﻿/* tslint:disable */
/* eslint-disable */
//----------------------
// <auto-generated>
//     Generated using the NSwag toolchain v13.0.6.0 (NJsonSchema v10.0.23.0 (Newtonsoft.Json v10.0.0.0)) (http://NSwag.org)
// </auto-generated>
//----------------------
// ReSharper disable InconsistentNaming

import { mergeMap as _observableMergeMap, catchError as _observableCatch } from 'rxjs/operators';
import { Observable, throwError as _observableThrow, of as _observableOf } from 'rxjs';
import { Injectable, Inject, Optional, InjectionToken } from '@angular/core';
import { HttpClient, HttpHeaders, HttpResponse, HttpResponseBase } from '@angular/common/http';

import * as moment from 'moment';

export const API_BASE_URL = new InjectionToken<string>('API_BASE_URL');

@Injectable()
export class AccountServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    isTenantAvailable(body: IsTenantAvailableInput | undefined): Observable<IsTenantAvailableOutput> {
        let url_ = this.baseUrl + "/api/services/app/Account/IsTenantAvailable";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIsTenantAvailable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIsTenantAvailable(<any>response_);
                } catch (e) {
                    return <Observable<IsTenantAvailableOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<IsTenantAvailableOutput>><any>_observableThrow(response_);
        }));
    }

    protected processIsTenantAvailable(response: HttpResponseBase): Observable<IsTenantAvailableOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = IsTenantAvailableOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<IsTenantAvailableOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    resolveTenantId(body: ResolveTenantIdInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Account/ResolveTenantId";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processResolveTenantId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processResolveTenantId(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processResolveTenantId(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    register(body: RegisterInput | undefined): Observable<RegisterOutput> {
        let url_ = this.baseUrl + "/api/services/app/Account/Register";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRegister(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRegister(<any>response_);
                } catch (e) {
                    return <Observable<RegisterOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<RegisterOutput>><any>_observableThrow(response_);
        }));
    }

    protected processRegister(response: HttpResponseBase): Observable<RegisterOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = RegisterOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RegisterOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    customerRegister(body: RegisterInput | undefined): Observable<RegisterOutput> {
        let url_ = this.baseUrl + "/api/services/app/Account/CustomerRegister";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCustomerRegister(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCustomerRegister(<any>response_);
                } catch (e) {
                    return <Observable<RegisterOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<RegisterOutput>><any>_observableThrow(response_);
        }));
    }

    protected processCustomerRegister(response: HttpResponseBase): Observable<RegisterOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = RegisterOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RegisterOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendPasswordResetCode(body: SendPasswordResetCodeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Account/SendPasswordResetCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendPasswordResetCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendPasswordResetCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendPasswordResetCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    resetPassword(body: ResetPasswordInput | undefined): Observable<ResetPasswordOutput> {
        let url_ = this.baseUrl + "/api/services/app/Account/ResetPassword";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processResetPassword(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processResetPassword(<any>response_);
                } catch (e) {
                    return <Observable<ResetPasswordOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<ResetPasswordOutput>><any>_observableThrow(response_);
        }));
    }

    protected processResetPassword(response: HttpResponseBase): Observable<ResetPasswordOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ResetPasswordOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ResetPasswordOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendEmailActivationLink(body: SendEmailActivationLinkInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Account/SendEmailActivationLink";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendEmailActivationLink(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendEmailActivationLink(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendEmailActivationLink(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    activateEmail(body: ActivateEmailInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Account/ActivateEmail";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processActivateEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processActivateEmail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processActivateEmail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    impersonate(body: ImpersonateInput | undefined): Observable<ImpersonateOutput> {
        let url_ = this.baseUrl + "/api/services/app/Account/Impersonate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processImpersonate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processImpersonate(<any>response_);
                } catch (e) {
                    return <Observable<ImpersonateOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<ImpersonateOutput>><any>_observableThrow(response_);
        }));
    }

    protected processImpersonate(response: HttpResponseBase): Observable<ImpersonateOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ImpersonateOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ImpersonateOutput>(<any>null);
    }

    /**
     * @return Success
     */
    backToImpersonator(): Observable<ImpersonateOutput> {
        let url_ = this.baseUrl + "/api/services/app/Account/BackToImpersonator";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBackToImpersonator(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBackToImpersonator(<any>response_);
                } catch (e) {
                    return <Observable<ImpersonateOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<ImpersonateOutput>><any>_observableThrow(response_);
        }));
    }

    protected processBackToImpersonator(response: HttpResponseBase): Observable<ImpersonateOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ImpersonateOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ImpersonateOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    switchToLinkedAccount(body: SwitchToLinkedAccountInput | undefined): Observable<SwitchToLinkedAccountOutput> {
        let url_ = this.baseUrl + "/api/services/app/Account/SwitchToLinkedAccount";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSwitchToLinkedAccount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSwitchToLinkedAccount(<any>response_);
                } catch (e) {
                    return <Observable<SwitchToLinkedAccountOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<SwitchToLinkedAccountOutput>><any>_observableThrow(response_);
        }));
    }

    protected processSwitchToLinkedAccount(response: HttpResponseBase): Observable<SwitchToLinkedAccountOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = SwitchToLinkedAccountOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SwitchToLinkedAccountOutput>(<any>null);
    }
}

@Injectable()
export class AddressServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param addressTypeId (optional) 
     * @param addressLine1 (optional) 
     * @param addressLine2 (optional) 
     * @param postalCodeId (optional) 
     * @param geocodeId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAddress(id: number | undefined, addressTypeId: number | undefined, addressLine1: string | undefined, addressLine2: string | undefined, postalCodeId: number | undefined, geocodeId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfAddressListDto> {
        let url_ = this.baseUrl + "/api/services/app/Address/GetAddress?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (addressTypeId === null)
            throw new Error("The parameter 'addressTypeId' cannot be null.");
        else if (addressTypeId !== undefined)
            url_ += "AddressTypeId=" + encodeURIComponent("" + addressTypeId) + "&"; 
        if (addressLine1 === null)
            throw new Error("The parameter 'addressLine1' cannot be null.");
        else if (addressLine1 !== undefined)
            url_ += "AddressLine1=" + encodeURIComponent("" + addressLine1) + "&"; 
        if (addressLine2 === null)
            throw new Error("The parameter 'addressLine2' cannot be null.");
        else if (addressLine2 !== undefined)
            url_ += "AddressLine2=" + encodeURIComponent("" + addressLine2) + "&"; 
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (geocodeId === null)
            throw new Error("The parameter 'geocodeId' cannot be null.");
        else if (geocodeId !== undefined)
            url_ += "GeocodeId=" + encodeURIComponent("" + geocodeId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddress(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfAddressListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfAddressListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddress(response: HttpResponseBase): Observable<PagedResultDtoOfAddressListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfAddressListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfAddressListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createAddress(body: CreateAddressInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Address/CreateAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateAddress(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateAddress(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteAddress(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Address/DeleteAddress?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteAddress(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteAddress(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateAddress(body: UpdateAddressInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Address/UpdateAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateAddress(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateAddress(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class AddressesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setOverridableAddressType(body: SetOverridableAddressTypeInput | undefined): Observable<SetOverridableAddressTypeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/SetOverridableAddressType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetOverridableAddressType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetOverridableAddressType(<any>response_);
                } catch (e) {
                    return <Observable<SetOverridableAddressTypeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<SetOverridableAddressTypeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processSetOverridableAddressType(response: HttpResponseBase): Observable<SetOverridableAddressTypeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(SetOverridableAddressTypeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SetOverridableAddressTypeDto[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param addressLine1Filter (optional) 
     * @param addressLine2Filter (optional) 
     * @param postalCodeValueFilter (optional) 
     * @param countryFilter (optional) 
     * @param stateFilter (optional) 
     * @param cityFilter (optional) 
     * @param geocodeLatitudeFilter (optional) 
     * @param geocodeLongitudeFilter (optional) 
     * @param addressTypeNameFilter (optional) 
     * @param notValidateAddress (optional) 
     * @param overridableAddressType (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, addressLine1Filter: string | undefined, addressLine2Filter: string | undefined, postalCodeValueFilter: string | undefined, countryFilter: string | undefined, stateFilter: string | undefined, cityFilter: string | undefined, geocodeLatitudeFilter: string | undefined, geocodeLongitudeFilter: string | undefined, addressTypeNameFilter: string | undefined, notValidateAddress: boolean | undefined, overridableAddressType: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetAddressForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (addressLine1Filter === null)
            throw new Error("The parameter 'addressLine1Filter' cannot be null.");
        else if (addressLine1Filter !== undefined)
            url_ += "AddressLine1Filter=" + encodeURIComponent("" + addressLine1Filter) + "&"; 
        if (addressLine2Filter === null)
            throw new Error("The parameter 'addressLine2Filter' cannot be null.");
        else if (addressLine2Filter !== undefined)
            url_ += "AddressLine2Filter=" + encodeURIComponent("" + addressLine2Filter) + "&"; 
        if (postalCodeValueFilter === null)
            throw new Error("The parameter 'postalCodeValueFilter' cannot be null.");
        else if (postalCodeValueFilter !== undefined)
            url_ += "PostalCodeValueFilter=" + encodeURIComponent("" + postalCodeValueFilter) + "&"; 
        if (countryFilter === null)
            throw new Error("The parameter 'countryFilter' cannot be null.");
        else if (countryFilter !== undefined)
            url_ += "CountryFilter=" + encodeURIComponent("" + countryFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        if (geocodeLatitudeFilter === null)
            throw new Error("The parameter 'geocodeLatitudeFilter' cannot be null.");
        else if (geocodeLatitudeFilter !== undefined)
            url_ += "GeocodeLatitudeFilter=" + encodeURIComponent("" + geocodeLatitudeFilter) + "&"; 
        if (geocodeLongitudeFilter === null)
            throw new Error("The parameter 'geocodeLongitudeFilter' cannot be null.");
        else if (geocodeLongitudeFilter !== undefined)
            url_ += "GeocodeLongitudeFilter=" + encodeURIComponent("" + geocodeLongitudeFilter) + "&"; 
        if (addressTypeNameFilter === null)
            throw new Error("The parameter 'addressTypeNameFilter' cannot be null.");
        else if (addressTypeNameFilter !== undefined)
            url_ += "AddressTypeNameFilter=" + encodeURIComponent("" + addressTypeNameFilter) + "&"; 
        if (notValidateAddress === null)
            throw new Error("The parameter 'notValidateAddress' cannot be null.");
        else if (notValidateAddress !== undefined)
            url_ += "NotValidateAddress=" + encodeURIComponent("" + notValidateAddress) + "&"; 
        if (overridableAddressType === null)
            throw new Error("The parameter 'overridableAddressType' cannot be null.");
        else if (overridableAddressType !== undefined)
            url_ += "OverridableAddressType=" + encodeURIComponent("" + overridableAddressType) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetAddressForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetAddressForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetAddressForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetAddressForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetAddressForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getAddressForView(id: number | undefined): Observable<GetAddressForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/GetAddressForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddressForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddressForView(<any>response_);
                } catch (e) {
                    return <Observable<GetAddressForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetAddressForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddressForView(response: HttpResponseBase): Observable<GetAddressForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetAddressForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetAddressForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getAddressForEdit(id: number | undefined): Observable<GetAddressForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/GetAddressForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddressForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddressForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetAddressForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetAddressForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddressForEdit(response: HttpResponseBase): Observable<GetAddressForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetAddressForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetAddressForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditAddressDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param addressLine1Filter (optional) 
     * @param addressLine2Filter (optional) 
     * @param postalCodeValueFilter (optional) 
     * @param geocodeLatitudeFilter (optional) 
     * @param addressTypeNameFilter (optional) 
     * @return Success
     */
    getAddressesToExcel(filter: string | undefined, addressLine1Filter: string | undefined, addressLine2Filter: string | undefined, postalCodeValueFilter: string | undefined, geocodeLatitudeFilter: string | undefined, addressTypeNameFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/GetAddressesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (addressLine1Filter === null)
            throw new Error("The parameter 'addressLine1Filter' cannot be null.");
        else if (addressLine1Filter !== undefined)
            url_ += "AddressLine1Filter=" + encodeURIComponent("" + addressLine1Filter) + "&"; 
        if (addressLine2Filter === null)
            throw new Error("The parameter 'addressLine2Filter' cannot be null.");
        else if (addressLine2Filter !== undefined)
            url_ += "AddressLine2Filter=" + encodeURIComponent("" + addressLine2Filter) + "&"; 
        if (postalCodeValueFilter === null)
            throw new Error("The parameter 'postalCodeValueFilter' cannot be null.");
        else if (postalCodeValueFilter !== undefined)
            url_ += "PostalCodeValueFilter=" + encodeURIComponent("" + postalCodeValueFilter) + "&"; 
        if (geocodeLatitudeFilter === null)
            throw new Error("The parameter 'geocodeLatitudeFilter' cannot be null.");
        else if (geocodeLatitudeFilter !== undefined)
            url_ += "GeocodeLatitudeFilter=" + encodeURIComponent("" + geocodeLatitudeFilter) + "&"; 
        if (addressTypeNameFilter === null)
            throw new Error("The parameter 'addressTypeNameFilter' cannot be null.");
        else if (addressTypeNameFilter !== undefined)
            url_ += "AddressTypeNameFilter=" + encodeURIComponent("" + addressTypeNameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddressesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddressesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddressesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllPostalCodeForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfAddressPostalCodeLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/GetAllPostalCodeForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllPostalCodeForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllPostalCodeForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfAddressPostalCodeLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfAddressPostalCodeLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllPostalCodeForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfAddressPostalCodeLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfAddressPostalCodeLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfAddressPostalCodeLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllGeocodeForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfAddressGeocodeLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/GetAllGeocodeForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllGeocodeForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllGeocodeForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfAddressGeocodeLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfAddressGeocodeLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllGeocodeForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfAddressGeocodeLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfAddressGeocodeLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfAddressGeocodeLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllAddressTypeForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfAddressAddressTypeLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/GetAllAddressTypeForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllAddressTypeForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllAddressTypeForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfAddressAddressTypeLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfAddressAddressTypeLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllAddressTypeForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfAddressAddressTypeLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfAddressAddressTypeLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfAddressAddressTypeLookupTableDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    validateAddress(body: EntityDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/ValidateAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processValidateAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processValidateAddress(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processValidateAddress(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderAddressContact(body: UpdateOrderAddressInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/UpdateOrderAddressContact";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderAddressContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderAddressContact(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderAddressContact(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param color (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAddressTypesForSelect(id: number | undefined, name: string | undefined, color: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Addresses/GetAddressTypesForSelect?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (color === null)
            throw new Error("The parameter 'color' cannot be null.");
        else if (color !== undefined)
            url_ += "Color=" + encodeURIComponent("" + color) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddressTypesForSelect(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddressTypesForSelect(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddressTypesForSelect(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class AddressTypeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param color (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAddressType(id: number | undefined, name: string | undefined, color: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfAddressTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/AddressType/GetAddressType?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (color === null)
            throw new Error("The parameter 'color' cannot be null.");
        else if (color !== undefined)
            url_ += "Color=" + encodeURIComponent("" + color) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddressType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddressType(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfAddressTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfAddressTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddressType(response: HttpResponseBase): Observable<PagedResultDtoOfAddressTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfAddressTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfAddressTypeListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createAddressType(body: CreateAddressTypeInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/AddressType/CreateAddressType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateAddressType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateAddressType(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateAddressType(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateAddressType(body: UpdateAddressTypeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AddressType/UpdateAddressType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateAddressType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateAddressType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateAddressType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteAddressType(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AddressType/DeleteAddressType?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteAddressType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteAddressType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteAddressType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class AddressTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetAddressTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/AddressTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetAddressTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetAddressTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetAddressTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetAddressTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetAddressTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getAddressTypeForView(id: number | undefined): Observable<GetAddressTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/AddressTypes/GetAddressTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddressTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddressTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetAddressTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetAddressTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddressTypeForView(response: HttpResponseBase): Observable<GetAddressTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetAddressTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetAddressTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getAddressTypeForEdit(id: number | undefined): Observable<GetAddressTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/AddressTypes/GetAddressTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddressTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddressTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetAddressTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetAddressTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddressTypeForEdit(response: HttpResponseBase): Observable<GetAddressTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetAddressTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetAddressTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditAddressTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AddressTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    create(body: CreateOrEditAddressTypeDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/AddressTypes/Create";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreate(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreate(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    update(body: CreateOrEditAddressTypeDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/AddressTypes/Update";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdate(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processUpdate(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AddressTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @return Success
     */
    getAddressTypesToExcel(filter: string | undefined, nameFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/AddressTypes/GetAddressTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddressTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddressTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddressTypesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllAddressTypes(): Observable<GetAllAddressTypesDto[]> {
        let url_ = this.baseUrl + "/api/services/app/AddressTypes/GetAllAddressTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllAddressTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllAddressTypes(<any>response_);
                } catch (e) {
                    return <Observable<GetAllAddressTypesDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetAllAddressTypesDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllAddressTypes(response: HttpResponseBase): Observable<GetAllAddressTypesDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetAllAddressTypesDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetAllAddressTypesDto[]>(<any>null);
    }
}

@Injectable()
export class ApiResponseStringManagerServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param tenantId (optional) 
     * @param userId (optional) 
     * @param resourceKey (optional) 
     * @return Success
     */
    getLocalized(tenantId: number | undefined, userId: number | undefined, resourceKey: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ApiResponseStringManager/GetLocalized?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "userId=" + encodeURIComponent("" + userId) + "&"; 
        if (resourceKey === null)
            throw new Error("The parameter 'resourceKey' cannot be null.");
        else if (resourceKey !== undefined)
            url_ += "resourceKey=" + encodeURIComponent("" + resourceKey) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocalized(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocalized(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocalized(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class AppBinaryToolsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getContentAsBase64(id: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/AppBinaryTools/GetContentAsBase64?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContentAsBase64(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContentAsBase64(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetContentAsBase64(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class AuditLogServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param userName (optional) 
     * @param serviceName (optional) 
     * @param methodName (optional) 
     * @param browserInfo (optional) 
     * @param hasException (optional) 
     * @param minExecutionDuration (optional) 
     * @param maxExecutionDuration (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAuditLogs(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, userName: string | undefined, serviceName: string | undefined, methodName: string | undefined, browserInfo: string | undefined, hasException: boolean | undefined, minExecutionDuration: number | undefined, maxExecutionDuration: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfAuditLogListDto> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/GetAuditLogs?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "UserName=" + encodeURIComponent("" + userName) + "&"; 
        if (serviceName === null)
            throw new Error("The parameter 'serviceName' cannot be null.");
        else if (serviceName !== undefined)
            url_ += "ServiceName=" + encodeURIComponent("" + serviceName) + "&"; 
        if (methodName === null)
            throw new Error("The parameter 'methodName' cannot be null.");
        else if (methodName !== undefined)
            url_ += "MethodName=" + encodeURIComponent("" + methodName) + "&"; 
        if (browserInfo === null)
            throw new Error("The parameter 'browserInfo' cannot be null.");
        else if (browserInfo !== undefined)
            url_ += "BrowserInfo=" + encodeURIComponent("" + browserInfo) + "&"; 
        if (hasException === null)
            throw new Error("The parameter 'hasException' cannot be null.");
        else if (hasException !== undefined)
            url_ += "HasException=" + encodeURIComponent("" + hasException) + "&"; 
        if (minExecutionDuration === null)
            throw new Error("The parameter 'minExecutionDuration' cannot be null.");
        else if (minExecutionDuration !== undefined)
            url_ += "MinExecutionDuration=" + encodeURIComponent("" + minExecutionDuration) + "&"; 
        if (maxExecutionDuration === null)
            throw new Error("The parameter 'maxExecutionDuration' cannot be null.");
        else if (maxExecutionDuration !== undefined)
            url_ += "MaxExecutionDuration=" + encodeURIComponent("" + maxExecutionDuration) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAuditLogs(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAuditLogs(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfAuditLogListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfAuditLogListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAuditLogs(response: HttpResponseBase): Observable<PagedResultDtoOfAuditLogListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfAuditLogListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfAuditLogListDto>(<any>null);
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param userName (optional) 
     * @param serviceName (optional) 
     * @param methodName (optional) 
     * @param browserInfo (optional) 
     * @param hasException (optional) 
     * @param minExecutionDuration (optional) 
     * @param maxExecutionDuration (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAuditLogsToExcel(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, userName: string | undefined, serviceName: string | undefined, methodName: string | undefined, browserInfo: string | undefined, hasException: boolean | undefined, minExecutionDuration: number | undefined, maxExecutionDuration: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/GetAuditLogsToExcel?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "UserName=" + encodeURIComponent("" + userName) + "&"; 
        if (serviceName === null)
            throw new Error("The parameter 'serviceName' cannot be null.");
        else if (serviceName !== undefined)
            url_ += "ServiceName=" + encodeURIComponent("" + serviceName) + "&"; 
        if (methodName === null)
            throw new Error("The parameter 'methodName' cannot be null.");
        else if (methodName !== undefined)
            url_ += "MethodName=" + encodeURIComponent("" + methodName) + "&"; 
        if (browserInfo === null)
            throw new Error("The parameter 'browserInfo' cannot be null.");
        else if (browserInfo !== undefined)
            url_ += "BrowserInfo=" + encodeURIComponent("" + browserInfo) + "&"; 
        if (hasException === null)
            throw new Error("The parameter 'hasException' cannot be null.");
        else if (hasException !== undefined)
            url_ += "HasException=" + encodeURIComponent("" + hasException) + "&"; 
        if (minExecutionDuration === null)
            throw new Error("The parameter 'minExecutionDuration' cannot be null.");
        else if (minExecutionDuration !== undefined)
            url_ += "MinExecutionDuration=" + encodeURIComponent("" + minExecutionDuration) + "&"; 
        if (maxExecutionDuration === null)
            throw new Error("The parameter 'maxExecutionDuration' cannot be null.");
        else if (maxExecutionDuration !== undefined)
            url_ += "MaxExecutionDuration=" + encodeURIComponent("" + maxExecutionDuration) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAuditLogsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAuditLogsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAuditLogsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getEntityHistoryObjectTypes(): Observable<NameValueDto[]> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/GetEntityHistoryObjectTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEntityHistoryObjectTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEntityHistoryObjectTypes(<any>response_);
                } catch (e) {
                    return <Observable<NameValueDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<NameValueDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetEntityHistoryObjectTypes(response: HttpResponseBase): Observable<NameValueDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(NameValueDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<NameValueDto[]>(<any>null);
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param userName (optional) 
     * @param entityTypeFullName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getEntityChanges(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, userName: string | undefined, entityTypeFullName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfEntityChangeListDto> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/GetEntityChanges?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "UserName=" + encodeURIComponent("" + userName) + "&"; 
        if (entityTypeFullName === null)
            throw new Error("The parameter 'entityTypeFullName' cannot be null.");
        else if (entityTypeFullName !== undefined)
            url_ += "EntityTypeFullName=" + encodeURIComponent("" + entityTypeFullName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEntityChanges(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEntityChanges(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfEntityChangeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfEntityChangeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEntityChanges(response: HttpResponseBase): Observable<PagedResultDtoOfEntityChangeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfEntityChangeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfEntityChangeListDto>(<any>null);
    }

    /**
     * @param entityTypeFullName (optional) 
     * @param entityId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getEntityTypeChanges(entityTypeFullName: string | undefined, entityId: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfEntityChangeListDto> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/GetEntityTypeChanges?";
        if (entityTypeFullName === null)
            throw new Error("The parameter 'entityTypeFullName' cannot be null.");
        else if (entityTypeFullName !== undefined)
            url_ += "EntityTypeFullName=" + encodeURIComponent("" + entityTypeFullName) + "&"; 
        if (entityId === null)
            throw new Error("The parameter 'entityId' cannot be null.");
        else if (entityId !== undefined)
            url_ += "EntityId=" + encodeURIComponent("" + entityId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEntityTypeChanges(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEntityTypeChanges(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfEntityChangeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfEntityChangeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEntityTypeChanges(response: HttpResponseBase): Observable<PagedResultDtoOfEntityChangeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfEntityChangeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfEntityChangeListDto>(<any>null);
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param userName (optional) 
     * @param entityTypeFullName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getEntityChangesToExcel(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, userName: string | undefined, entityTypeFullName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/GetEntityChangesToExcel?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "UserName=" + encodeURIComponent("" + userName) + "&"; 
        if (entityTypeFullName === null)
            throw new Error("The parameter 'entityTypeFullName' cannot be null.");
        else if (entityTypeFullName !== undefined)
            url_ += "EntityTypeFullName=" + encodeURIComponent("" + entityTypeFullName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEntityChangesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEntityChangesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEntityChangesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param entityChangeSetId (optional) 
     * @param entityFulltypeName (optional) 
     * @param entityChangeId (optional) 
     * @return Success
     */
    getEntityPropertyChanges(entityChangeSetId: number | undefined, entityFulltypeName: string | undefined, entityChangeId: number | undefined): Observable<EntityPropertyChangeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/GetEntityPropertyChanges?";
        if (entityChangeSetId === null)
            throw new Error("The parameter 'entityChangeSetId' cannot be null.");
        else if (entityChangeSetId !== undefined)
            url_ += "entityChangeSetId=" + encodeURIComponent("" + entityChangeSetId) + "&"; 
        if (entityFulltypeName === null)
            throw new Error("The parameter 'entityFulltypeName' cannot be null.");
        else if (entityFulltypeName !== undefined)
            url_ += "entityFulltypeName=" + encodeURIComponent("" + entityFulltypeName) + "&"; 
        if (entityChangeId === null)
            throw new Error("The parameter 'entityChangeId' cannot be null.");
        else if (entityChangeId !== undefined)
            url_ += "entityChangeId=" + encodeURIComponent("" + entityChangeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEntityPropertyChanges(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEntityPropertyChanges(<any>response_);
                } catch (e) {
                    return <Observable<EntityPropertyChangeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<EntityPropertyChangeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetEntityPropertyChanges(response: HttpResponseBase): Observable<EntityPropertyChangeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(EntityPropertyChangeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<EntityPropertyChangeDto[]>(<any>null);
    }

    /**
     * @param entityChangeId (optional) 
     * @param entityChangeSetId (optional) 
     * @return Success
     */
    getClinicScheduleHistory(entityChangeId: number | undefined, entityChangeSetId: number | undefined): Observable<EntityPropertyChangeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/GetClinicScheduleHistory?";
        if (entityChangeId === null)
            throw new Error("The parameter 'entityChangeId' cannot be null.");
        else if (entityChangeId !== undefined)
            url_ += "entityChangeId=" + encodeURIComponent("" + entityChangeId) + "&"; 
        if (entityChangeSetId === null)
            throw new Error("The parameter 'entityChangeSetId' cannot be null.");
        else if (entityChangeSetId !== undefined)
            url_ += "entityChangeSetId=" + encodeURIComponent("" + entityChangeSetId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicScheduleHistory(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicScheduleHistory(<any>response_);
                } catch (e) {
                    return <Observable<EntityPropertyChangeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<EntityPropertyChangeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicScheduleHistory(response: HttpResponseBase): Observable<EntityPropertyChangeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(EntityPropertyChangeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<EntityPropertyChangeDto[]>(<any>null);
    }

    /**
     * @param entityChangeSetId (optional) 
     * @param entityFulltypeName (optional) 
     * @param entityChangeId (optional) 
     * @param entityId (optional) 
     * @return Success
     */
    getRouteHistory(entityChangeSetId: number | undefined, entityFulltypeName: string | undefined, entityChangeId: number | undefined, entityId: string | undefined): Observable<EntityPropertyChangeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/GetRouteHistory?";
        if (entityChangeSetId === null)
            throw new Error("The parameter 'entityChangeSetId' cannot be null.");
        else if (entityChangeSetId !== undefined)
            url_ += "entityChangeSetId=" + encodeURIComponent("" + entityChangeSetId) + "&"; 
        if (entityFulltypeName === null)
            throw new Error("The parameter 'entityFulltypeName' cannot be null.");
        else if (entityFulltypeName !== undefined)
            url_ += "entityFulltypeName=" + encodeURIComponent("" + entityFulltypeName) + "&"; 
        if (entityChangeId === null)
            throw new Error("The parameter 'entityChangeId' cannot be null.");
        else if (entityChangeId !== undefined)
            url_ += "entityChangeId=" + encodeURIComponent("" + entityChangeId) + "&"; 
        if (entityId === null)
            throw new Error("The parameter 'entityId' cannot be null.");
        else if (entityId !== undefined)
            url_ += "entityId=" + encodeURIComponent("" + entityId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteHistory(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteHistory(<any>response_);
                } catch (e) {
                    return <Observable<EntityPropertyChangeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<EntityPropertyChangeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteHistory(response: HttpResponseBase): Observable<EntityPropertyChangeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(EntityPropertyChangeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<EntityPropertyChangeDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    deleteExpiredLogs(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AuditLog/DeleteExpiredLogs";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteExpiredLogs(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteExpiredLogs(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteExpiredLogs(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class AutomatedTestServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateTestAccount(body: CreateOrUpdateTestAccountInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/CreateOrUpdateTestAccount";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateTestAccount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateTestAccount(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateTestAccount(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param username (optional) 
     * @return Success
     */
    deleteTestAccount(tenantId: number | undefined, username: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/DeleteTestAccount?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (username === null)
            throw new Error("The parameter 'username' cannot be null.");
        else if (username !== undefined)
            url_ += "Username=" + encodeURIComponent("" + username) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteTestAccount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteTestAccount(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteTestAccount(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenancyName (optional) 
     * @param secretKey (optional) 
     * @return Success
     */
    getTestAccountForTenant(tenancyName: string | undefined, secretKey: string | undefined): Observable<GetTestAccountForTenantResultDto> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/GetTestAccountForTenant?";
        if (tenancyName === null)
            throw new Error("The parameter 'tenancyName' cannot be null.");
        else if (tenancyName !== undefined)
            url_ += "TenancyName=" + encodeURIComponent("" + tenancyName) + "&"; 
        if (secretKey === null)
            throw new Error("The parameter 'secretKey' cannot be null.");
        else if (secretKey !== undefined)
            url_ += "SecretKey=" + encodeURIComponent("" + secretKey) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTestAccountForTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTestAccountForTenant(<any>response_);
                } catch (e) {
                    return <Observable<GetTestAccountForTenantResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTestAccountForTenantResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTestAccountForTenant(response: HttpResponseBase): Observable<GetTestAccountForTenantResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTestAccountForTenantResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTestAccountForTenantResultDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    initializeTestData(body: InitializeTestDataInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/InitializeTestData";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processInitializeTestData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processInitializeTestData(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processInitializeTestData(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    isTestDataReady(body: IsTestDataReadyInputDto | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/IsTestDataReady";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIsTestDataReady(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIsTestDataReady(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processIsTestDataReady(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    clearTestData(body: ClearTestDataInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/ClearTestData";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processClearTestData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processClearTestData(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processClearTestData(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addDispatchCommandParameter(body: AddDispatchCommandParameterInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/AddDispatchCommandParameter";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddDispatchCommandParameter(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddDispatchCommandParameter(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddDispatchCommandParameter(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteDispatchCommandParameter(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/DeleteDispatchCommandParameter?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteDispatchCommandParameter(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteDispatchCommandParameter(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteDispatchCommandParameter(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendDispatchCommand(body: SendDispatchCommandInputDto | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/SendDispatchCommand";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendDispatchCommand(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendDispatchCommand(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processSendDispatchCommand(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param username (optional) 
     * @return Success
     */
    getDispatchCommandData(tenantId: number | undefined, username: string | undefined): Observable<GetDispatchCommandDataListItemDto[]> {
        let url_ = this.baseUrl + "/api/services/app/AutomatedTest/GetDispatchCommandData?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (username === null)
            throw new Error("The parameter 'username' cannot be null.");
        else if (username !== undefined)
            url_ += "Username=" + encodeURIComponent("" + username) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDispatchCommandData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDispatchCommandData(<any>response_);
                } catch (e) {
                    return <Observable<GetDispatchCommandDataListItemDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDispatchCommandDataListItemDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDispatchCommandData(response: HttpResponseBase): Observable<GetDispatchCommandDataListItemDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetDispatchCommandDataListItemDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDispatchCommandDataListItemDto[]>(<any>null);
    }
}

@Injectable()
export class BackgroundProcessesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param jobIdFilter (optional) 
     * @param jobClassFilter (optional) 
     * @param cronExpressionFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param maxLastStartTimeFilter (optional) 
     * @param minLastStartTimeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, jobIdFilter: string | undefined, jobClassFilter: string | undefined, cronExpressionFilter: string | undefined, isActiveFilter: number | undefined, descriptionFilter: string | undefined, maxLastStartTimeFilter: moment.Moment | undefined, minLastStartTimeFilter: moment.Moment | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetBackgroundProcessForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/BackgroundProcesses/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (jobIdFilter === null)
            throw new Error("The parameter 'jobIdFilter' cannot be null.");
        else if (jobIdFilter !== undefined)
            url_ += "JobIdFilter=" + encodeURIComponent("" + jobIdFilter) + "&"; 
        if (jobClassFilter === null)
            throw new Error("The parameter 'jobClassFilter' cannot be null.");
        else if (jobClassFilter !== undefined)
            url_ += "JobClassFilter=" + encodeURIComponent("" + jobClassFilter) + "&"; 
        if (cronExpressionFilter === null)
            throw new Error("The parameter 'cronExpressionFilter' cannot be null.");
        else if (cronExpressionFilter !== undefined)
            url_ += "CronExpressionFilter=" + encodeURIComponent("" + cronExpressionFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (maxLastStartTimeFilter === null)
            throw new Error("The parameter 'maxLastStartTimeFilter' cannot be null.");
        else if (maxLastStartTimeFilter !== undefined)
            url_ += "MaxLastStartTimeFilter=" + encodeURIComponent(maxLastStartTimeFilter ? "" + maxLastStartTimeFilter.toJSON() : "") + "&"; 
        if (minLastStartTimeFilter === null)
            throw new Error("The parameter 'minLastStartTimeFilter' cannot be null.");
        else if (minLastStartTimeFilter !== undefined)
            url_ += "MinLastStartTimeFilter=" + encodeURIComponent(minLastStartTimeFilter ? "" + minLastStartTimeFilter.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetBackgroundProcessForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetBackgroundProcessForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetBackgroundProcessForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetBackgroundProcessForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetBackgroundProcessForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getBackgroundProcessForView(id: number | undefined): Observable<GetBackgroundProcessForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/BackgroundProcesses/GetBackgroundProcessForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetBackgroundProcessForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetBackgroundProcessForView(<any>response_);
                } catch (e) {
                    return <Observable<GetBackgroundProcessForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetBackgroundProcessForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetBackgroundProcessForView(response: HttpResponseBase): Observable<GetBackgroundProcessForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetBackgroundProcessForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetBackgroundProcessForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getBackgroundProcessForEdit(id: number | undefined): Observable<GetBackgroundProcessForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/BackgroundProcesses/GetBackgroundProcessForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetBackgroundProcessForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetBackgroundProcessForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetBackgroundProcessForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetBackgroundProcessForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetBackgroundProcessForEdit(response: HttpResponseBase): Observable<GetBackgroundProcessForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetBackgroundProcessForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetBackgroundProcessForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditBackgroundProcessDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/BackgroundProcesses/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/BackgroundProcesses/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param jobIdFilter (optional) 
     * @param jobClassFilter (optional) 
     * @param cronExpressionFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param maxLastStartTimeFilter (optional) 
     * @param minLastStartTimeFilter (optional) 
     * @return Success
     */
    getBackgroundProcessesToExcel(filter: string | undefined, jobIdFilter: string | undefined, jobClassFilter: string | undefined, cronExpressionFilter: string | undefined, isActiveFilter: number | undefined, descriptionFilter: string | undefined, maxLastStartTimeFilter: moment.Moment | undefined, minLastStartTimeFilter: moment.Moment | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/BackgroundProcesses/GetBackgroundProcessesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (jobIdFilter === null)
            throw new Error("The parameter 'jobIdFilter' cannot be null.");
        else if (jobIdFilter !== undefined)
            url_ += "JobIdFilter=" + encodeURIComponent("" + jobIdFilter) + "&"; 
        if (jobClassFilter === null)
            throw new Error("The parameter 'jobClassFilter' cannot be null.");
        else if (jobClassFilter !== undefined)
            url_ += "JobClassFilter=" + encodeURIComponent("" + jobClassFilter) + "&"; 
        if (cronExpressionFilter === null)
            throw new Error("The parameter 'cronExpressionFilter' cannot be null.");
        else if (cronExpressionFilter !== undefined)
            url_ += "CronExpressionFilter=" + encodeURIComponent("" + cronExpressionFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (maxLastStartTimeFilter === null)
            throw new Error("The parameter 'maxLastStartTimeFilter' cannot be null.");
        else if (maxLastStartTimeFilter !== undefined)
            url_ += "MaxLastStartTimeFilter=" + encodeURIComponent(maxLastStartTimeFilter ? "" + maxLastStartTimeFilter.toJSON() : "") + "&"; 
        if (minLastStartTimeFilter === null)
            throw new Error("The parameter 'minLastStartTimeFilter' cannot be null.");
        else if (minLastStartTimeFilter !== undefined)
            url_ += "MinLastStartTimeFilter=" + encodeURIComponent(minLastStartTimeFilter ? "" + minLastStartTimeFilter.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetBackgroundProcessesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetBackgroundProcessesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetBackgroundProcessesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class BatchOrderStatusServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createBatchOrderStatus(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/BatchOrderStatus/CreateBatchOrderStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateBatchOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateBatchOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateBatchOrderStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param message (optional) 
     * @param body (optional) 
     * @return Success
     */
    logMessage(message: string | undefined, body: ConsoleTextColor | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/BatchOrderStatus/LogMessage?";
        if (message === null)
            throw new Error("The parameter 'message' cannot be null.");
        else if (message !== undefined)
            url_ += "message=" + encodeURIComponent("" + message) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLogMessage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLogMessage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLogMessage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class BlindCountServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateForRoute(body: GenerateForRouteInputDto | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/BlindCount/GenerateForRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateForRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateForRoute(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateForRoute(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    getBlindCountLimit(): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/BlindCount/GetBlindCountLimit";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetBlindCountLimit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetBlindCountLimit(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetBlindCountLimit(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setBlindCountLimit(body: SetBlindCountLimitInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/BlindCount/SetBlindCountLimit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetBlindCountLimit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetBlindCountLimit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetBlindCountLimit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    verifyCode(body: VerifyCodeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/BlindCount/VerifyCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processVerifyCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processVerifyCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processVerifyCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateForDestination(body: GenerateForDestinationInputDto | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/BlindCount/GenerateForDestination";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateForDestination(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateForDestination(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateForDestination(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    verifyCodeForDestination(body: VerifyCodeForDestinationInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/BlindCount/VerifyCodeForDestination";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processVerifyCodeForDestination(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processVerifyCodeForDestination(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processVerifyCodeForDestination(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class BusinessHoursServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getBusinessHours(): Observable<GetBusinessHoursDto[]> {
        let url_ = this.baseUrl + "/api/services/app/BusinessHours/GetBusinessHours";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetBusinessHours(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetBusinessHours(<any>response_);
                } catch (e) {
                    return <Observable<GetBusinessHoursDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetBusinessHoursDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetBusinessHours(response: HttpResponseBase): Observable<GetBusinessHoursDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetBusinessHoursDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetBusinessHoursDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEditBusinessHours(body: CreateOrEditBusinessHoursInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/BusinessHours/CreateOrEditBusinessHours";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEditBusinessHours(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEditBusinessHours(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEditBusinessHours(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getBusinessHourCode(): Observable<BusinessHoursCodeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/BusinessHours/GetBusinessHourCode";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetBusinessHourCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetBusinessHourCode(<any>response_);
                } catch (e) {
                    return <Observable<BusinessHoursCodeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<BusinessHoursCodeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetBusinessHourCode(response: HttpResponseBase): Observable<BusinessHoursCodeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(BusinessHoursCodeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<BusinessHoursCodeDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getDateOfTheWeek(): Observable<DAYOFTHEWEEKCODEDTO[]> {
        let url_ = this.baseUrl + "/api/services/app/BusinessHours/GetDateOfTheWeek";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDateOfTheWeek(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDateOfTheWeek(<any>response_);
                } catch (e) {
                    return <Observable<DAYOFTHEWEEKCODEDTO[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<DAYOFTHEWEEKCODEDTO[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDateOfTheWeek(response: HttpResponseBase): Observable<DAYOFTHEWEEKCODEDTO[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(DAYOFTHEWEEKCODEDTO.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DAYOFTHEWEEKCODEDTO[]>(<any>null);
    }

    /**
     * @param value (optional) 
     * @param dateTimeUTC (optional) 
     * @return Success
     */
    getUtcOffset(value: string | undefined, dateTimeUTC: moment.Moment | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/BusinessHours/GetUtcOffset?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "value=" + encodeURIComponent("" + value) + "&"; 
        if (dateTimeUTC === null)
            throw new Error("The parameter 'dateTimeUTC' cannot be null.");
        else if (dateTimeUTC !== undefined)
            url_ += "dateTimeUTC=" + encodeURIComponent(dateTimeUTC ? "" + dateTimeUTC.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUtcOffset(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUtcOffset(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetUtcOffset(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class CachedRequestSettingServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getCachedRequestPriorityTypes(): Observable<GetCachedRequestPriorityTypesDto> {
        let url_ = this.baseUrl + "/api/services/app/CachedRequestSetting/GetCachedRequestPriorityTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCachedRequestPriorityTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCachedRequestPriorityTypes(<any>response_);
                } catch (e) {
                    return <Observable<GetCachedRequestPriorityTypesDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetCachedRequestPriorityTypesDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCachedRequestPriorityTypes(response: HttpResponseBase): Observable<GetCachedRequestPriorityTypesDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetCachedRequestPriorityTypesDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetCachedRequestPriorityTypesDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllCachedRequestSettings(): Observable<ListResultDtoOfGetCachedRequestSettingListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/CachedRequestSetting/GetAllCachedRequestSettings";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllCachedRequestSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllCachedRequestSettings(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetCachedRequestSettingListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetCachedRequestSettingListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllCachedRequestSettings(response: HttpResponseBase): Observable<ListResultDtoOfGetCachedRequestSettingListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetCachedRequestSettingListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetCachedRequestSettingListItemDto>(<any>null);
    }

    /**
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getCachedRequestSettings(sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetCachedRequestSettingListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/CachedRequestSetting/GetCachedRequestSettings?";
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCachedRequestSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCachedRequestSettings(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetCachedRequestSettingListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetCachedRequestSettingListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCachedRequestSettings(response: HttpResponseBase): Observable<PagedResultDtoOfGetCachedRequestSettingListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetCachedRequestSettingListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetCachedRequestSettingListItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateCachedRequestSetting(body: CreateOrUpdateCachedRequestSettingInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/CachedRequestSetting/CreateOrUpdateCachedRequestSetting";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateCachedRequestSetting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateCachedRequestSetting(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateCachedRequestSetting(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param apiRequestCode (optional) 
     * @return Success
     */
    deleteCachedRequestSetting(apiRequestCode: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/CachedRequestSetting/DeleteCachedRequestSetting?";
        if (apiRequestCode === null)
            throw new Error("The parameter 'apiRequestCode' cannot be null.");
        else if (apiRequestCode !== undefined)
            url_ += "ApiRequestCode=" + encodeURIComponent("" + apiRequestCode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteCachedRequestSetting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteCachedRequestSetting(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteCachedRequestSetting(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class CachingServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getAllCaches(): Observable<ListResultDtoOfCacheDto> {
        let url_ = this.baseUrl + "/api/services/app/Caching/GetAllCaches";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllCaches(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllCaches(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfCacheDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfCacheDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllCaches(response: HttpResponseBase): Observable<ListResultDtoOfCacheDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfCacheDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfCacheDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    clearCache(body: EntityDtoOfString | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Caching/ClearCache";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processClearCache(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processClearCache(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processClearCache(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    clearAllCaches(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Caching/ClearAllCaches";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processClearAllCaches(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processClearAllCaches(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processClearAllCaches(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ChatServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getUserChatFriendsWithSettings(): Observable<GetUserChatFriendsWithSettingsOutput> {
        let url_ = this.baseUrl + "/api/services/app/Chat/GetUserChatFriendsWithSettings";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserChatFriendsWithSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserChatFriendsWithSettings(<any>response_);
                } catch (e) {
                    return <Observable<GetUserChatFriendsWithSettingsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserChatFriendsWithSettingsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserChatFriendsWithSettings(response: HttpResponseBase): Observable<GetUserChatFriendsWithSettingsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserChatFriendsWithSettingsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserChatFriendsWithSettingsOutput>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param userId (optional) 
     * @param minMessageId (optional) 
     * @return Success
     */
    getUserChatMessages(tenantId: number | undefined, userId: number | undefined, minMessageId: number | undefined): Observable<ListResultDtoOfChatMessageDto> {
        let url_ = this.baseUrl + "/api/services/app/Chat/GetUserChatMessages?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (minMessageId === null)
            throw new Error("The parameter 'minMessageId' cannot be null.");
        else if (minMessageId !== undefined)
            url_ += "MinMessageId=" + encodeURIComponent("" + minMessageId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserChatMessages(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserChatMessages(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfChatMessageDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfChatMessageDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserChatMessages(response: HttpResponseBase): Observable<ListResultDtoOfChatMessageDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfChatMessageDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfChatMessageDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    markAllUnreadMessagesOfUserAsRead(body: MarkAllUnreadMessagesOfUserAsReadInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Chat/MarkAllUnreadMessagesOfUserAsRead";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMarkAllUnreadMessagesOfUserAsRead(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMarkAllUnreadMessagesOfUserAsRead(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processMarkAllUnreadMessagesOfUserAsRead(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ClientAccountsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param accountNumberFilter (optional) 
     * @param orderSourceId (optional) 
     * @param connectionId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, accountNumberFilter: string | undefined, orderSourceId: number | undefined, connectionId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetClientAccountForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (accountNumberFilter === null)
            throw new Error("The parameter 'accountNumberFilter' cannot be null.");
        else if (accountNumberFilter !== undefined)
            url_ += "AccountNumberFilter=" + encodeURIComponent("" + accountNumberFilter) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (connectionId === null)
            throw new Error("The parameter 'connectionId' cannot be null.");
        else if (connectionId !== undefined)
            url_ += "ConnectionId=" + encodeURIComponent("" + connectionId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetClientAccountForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetClientAccountForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetClientAccountForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetClientAccountForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetClientAccountForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getClientAccountForView(id: number | undefined): Observable<GetClientAccountForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/GetClientAccountForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientAccountForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientAccountForView(<any>response_);
                } catch (e) {
                    return <Observable<GetClientAccountForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClientAccountForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientAccountForView(response: HttpResponseBase): Observable<GetClientAccountForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetClientAccountForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClientAccountForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getClientAccountForEdit(id: number | undefined): Observable<GetClientAccountForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/GetClientAccountForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientAccountForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientAccountForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetClientAccountForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClientAccountForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientAccountForEdit(response: HttpResponseBase): Observable<GetClientAccountForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetClientAccountForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClientAccountForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditClientAccountDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param accountNumberFilter (optional) 
     * @param orderSourceId (optional) 
     * @param connectionId (optional) 
     * @return Success
     */
    getClientConnectionsToExcel(filter: string | undefined, accountNumberFilter: string | undefined, orderSourceId: number | undefined, connectionId: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/GetClientConnectionsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (accountNumberFilter === null)
            throw new Error("The parameter 'accountNumberFilter' cannot be null.");
        else if (accountNumberFilter !== undefined)
            url_ += "AccountNumberFilter=" + encodeURIComponent("" + accountNumberFilter) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (connectionId === null)
            throw new Error("The parameter 'connectionId' cannot be null.");
        else if (connectionId !== undefined)
            url_ += "ConnectionId=" + encodeURIComponent("" + connectionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientConnectionsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientConnectionsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientConnectionsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param accountId (optional) 
     * @return Success
     */
    authenticateConnection(accountId: number | undefined): Observable<AuthenticationResult> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/AuthenticateConnection?";
        if (accountId === null)
            throw new Error("The parameter 'accountId' cannot be null.");
        else if (accountId !== undefined)
            url_ += "accountId=" + encodeURIComponent("" + accountId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAuthenticateConnection(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAuthenticateConnection(<any>response_);
                } catch (e) {
                    return <Observable<AuthenticationResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<AuthenticationResult>><any>_observableThrow(response_);
        }));
    }

    protected processAuthenticateConnection(response: HttpResponseBase): Observable<AuthenticationResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = AuthenticationResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<AuthenticationResult>(<any>null);
    }

    /**
     * @param accountId (optional) 
     * @return Success
     */
    downloadOpenOrders(accountId: number | undefined): Observable<CreateOrderApiResult[]> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/DownloadOpenOrders?";
        if (accountId === null)
            throw new Error("The parameter 'accountId' cannot be null.");
        else if (accountId !== undefined)
            url_ += "accountId=" + encodeURIComponent("" + accountId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDownloadOpenOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDownloadOpenOrders(<any>response_);
                } catch (e) {
                    return <Observable<CreateOrderApiResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateOrderApiResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processDownloadOpenOrders(response: HttpResponseBase): Observable<CreateOrderApiResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(CreateOrderApiResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateOrderApiResult[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getRouteTemplate(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/GetRouteTemplate?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplate(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplate(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createClientAccountHangfire(body: ClientAccount | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/CreateClientAccountHangfire";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateClientAccountHangfire(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateClientAccountHangfire(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateClientAccountHangfire(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    downloadOrders(body: DownloadOrdersInput | undefined): Observable<GenerateResultDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientAccounts/DownloadOrders";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDownloadOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDownloadOrders(<any>response_);
                } catch (e) {
                    return <Observable<GenerateResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GenerateResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processDownloadOrders(response: HttpResponseBase): Observable<GenerateResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GenerateResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GenerateResultDto>(<any>null);
    }
}

@Injectable()
export class ClientConnectionsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param usernameFilter (optional) 
     * @param passwordFilter (optional) 
     * @param url (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, usernameFilter: string | undefined, passwordFilter: string | undefined, url: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetClientConnectionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientConnections/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (usernameFilter === null)
            throw new Error("The parameter 'usernameFilter' cannot be null.");
        else if (usernameFilter !== undefined)
            url_ += "UsernameFilter=" + encodeURIComponent("" + usernameFilter) + "&"; 
        if (passwordFilter === null)
            throw new Error("The parameter 'passwordFilter' cannot be null.");
        else if (passwordFilter !== undefined)
            url_ += "PasswordFilter=" + encodeURIComponent("" + passwordFilter) + "&"; 
        if (url === null)
            throw new Error("The parameter 'url' cannot be null.");
        else if (url !== undefined)
            url_ += "Url=" + encodeURIComponent("" + url) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetClientConnectionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetClientConnectionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetClientConnectionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetClientConnectionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetClientConnectionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getClientConnectionForView(id: number | undefined): Observable<GetClientConnectionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientConnections/GetClientConnectionForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientConnectionForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientConnectionForView(<any>response_);
                } catch (e) {
                    return <Observable<GetClientConnectionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClientConnectionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientConnectionForView(response: HttpResponseBase): Observable<GetClientConnectionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetClientConnectionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClientConnectionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getClientConnectionForEdit(id: number | undefined): Observable<GetClientConnectionForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ClientConnections/GetClientConnectionForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientConnectionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientConnectionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetClientConnectionForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClientConnectionForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientConnectionForEdit(response: HttpResponseBase): Observable<GetClientConnectionForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetClientConnectionForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClientConnectionForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditClientConnectionDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ClientConnections/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ClientConnections/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param usernameFilter (optional) 
     * @param passwordFilter (optional) 
     * @return Success
     */
    getClientConnectionsToExcel(filter: string | undefined, usernameFilter: string | undefined, passwordFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientConnections/GetClientConnectionsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (usernameFilter === null)
            throw new Error("The parameter 'usernameFilter' cannot be null.");
        else if (usernameFilter !== undefined)
            url_ += "UsernameFilter=" + encodeURIComponent("" + usernameFilter) + "&"; 
        if (passwordFilter === null)
            throw new Error("The parameter 'passwordFilter' cannot be null.");
        else if (passwordFilter !== undefined)
            url_ += "PasswordFilter=" + encodeURIComponent("" + passwordFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientConnectionsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientConnectionsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientConnectionsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getConnections(): Observable<ClientConnectionDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ClientConnections/GetConnections";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetConnections(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetConnections(<any>response_);
                } catch (e) {
                    return <Observable<ClientConnectionDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ClientConnectionDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetConnections(response: HttpResponseBase): Observable<ClientConnectionDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ClientConnectionDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ClientConnectionDto[]>(<any>null);
    }
}

@Injectable()
export class ClientDriverServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param driverId (optional) 
     * @param firstName (optional) 
     * @param lastName (optional) 
     * @param accountId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getClientDriverToExcel(filter: string | undefined, driverId: string | undefined, firstName: string | undefined, lastName: string | undefined, accountId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientDriver/GetClientDriverToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (firstName === null)
            throw new Error("The parameter 'firstName' cannot be null.");
        else if (firstName !== undefined)
            url_ += "FirstName=" + encodeURIComponent("" + firstName) + "&"; 
        if (lastName === null)
            throw new Error("The parameter 'lastName' cannot be null.");
        else if (lastName !== undefined)
            url_ += "LastName=" + encodeURIComponent("" + lastName) + "&"; 
        if (accountId === null)
            throw new Error("The parameter 'accountId' cannot be null.");
        else if (accountId !== undefined)
            url_ += "AccountId=" + encodeURIComponent("" + accountId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientDriverToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientDriverToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientDriverToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param driverId (optional) 
     * @param firstName (optional) 
     * @param lastName (optional) 
     * @param accountId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllClientDrivers(filter: string | undefined, driverId: string | undefined, firstName: string | undefined, lastName: string | undefined, accountId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfClientDriversDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientDriver/GetAllClientDrivers?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (firstName === null)
            throw new Error("The parameter 'firstName' cannot be null.");
        else if (firstName !== undefined)
            url_ += "FirstName=" + encodeURIComponent("" + firstName) + "&"; 
        if (lastName === null)
            throw new Error("The parameter 'lastName' cannot be null.");
        else if (lastName !== undefined)
            url_ += "LastName=" + encodeURIComponent("" + lastName) + "&"; 
        if (accountId === null)
            throw new Error("The parameter 'accountId' cannot be null.");
        else if (accountId !== undefined)
            url_ += "AccountId=" + encodeURIComponent("" + accountId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllClientDrivers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllClientDrivers(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfClientDriversDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfClientDriversDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllClientDrivers(response: HttpResponseBase): Observable<PagedResultDtoOfClientDriversDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfClientDriversDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfClientDriversDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    create(body: CreateClientDriverInput | undefined): Observable<CreateClientDriverResult> {
        let url_ = this.baseUrl + "/api/services/app/ClientDriver/Create";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreate(<any>response_);
                } catch (e) {
                    return <Observable<CreateClientDriverResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateClientDriverResult>><any>_observableThrow(response_);
        }));
    }

    protected processCreate(response: HttpResponseBase): Observable<CreateClientDriverResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateClientDriverResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateClientDriverResult>(<any>null);
    }
}

@Injectable()
export class ClientLogsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createClientOrderLog(body: CreateClientOrderLogDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ClientLogs/CreateClientOrderLog";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateClientOrderLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateClientOrderLog(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateClientOrderLog(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteClientOrderLog(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ClientLogs/DeleteClientOrderLog?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteClientOrderLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteClientOrderLog(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteClientOrderLog(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderSourceName(id: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ClientLogs/GetOrderSourceName?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderSourceName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderSourceName(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderSourceName(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param accountId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getClientOrderLog(filter: string | undefined, accountId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfClientOrderLogDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientLogs/GetClientOrderLog?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (accountId === null)
            throw new Error("The parameter 'accountId' cannot be null.");
        else if (accountId !== undefined)
            url_ += "AccountId=" + encodeURIComponent("" + accountId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientOrderLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientOrderLog(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfClientOrderLogDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfClientOrderLogDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientOrderLog(response: HttpResponseBase): Observable<PagedResultDtoOfClientOrderLogDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfClientOrderLogDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfClientOrderLogDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param accountId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getClientOrderLogsToExcel(filter: string | undefined, accountId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientLogs/GetClientOrderLogsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (accountId === null)
            throw new Error("The parameter 'accountId' cannot be null.");
        else if (accountId !== undefined)
            url_ += "AccountId=" + encodeURIComponent("" + accountId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientOrderLogsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientOrderLogsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientOrderLogsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getClientAccountList(): Observable<NameValueDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ClientLogs/GetClientAccountList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientAccountList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientAccountList(<any>response_);
                } catch (e) {
                    return <Observable<NameValueDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<NameValueDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientAccountList(response: HttpResponseBase): Observable<NameValueDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(NameValueDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<NameValueDto[]>(<any>null);
    }
}

@Injectable()
export class ClientPreferencesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param valueFilter (optional) 
     * @param preferenceId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, valueFilter: string | undefined, preferenceId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetClientPreferenceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientPreferences/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        if (preferenceId === null)
            throw new Error("The parameter 'preferenceId' cannot be null.");
        else if (preferenceId !== undefined)
            url_ += "PreferenceId=" + encodeURIComponent("" + preferenceId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetClientPreferenceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetClientPreferenceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetClientPreferenceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetClientPreferenceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetClientPreferenceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getClientPreferenceForView(id: number | undefined): Observable<GetClientPreferenceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientPreferences/GetClientPreferenceForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientPreferenceForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientPreferenceForView(<any>response_);
                } catch (e) {
                    return <Observable<GetClientPreferenceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClientPreferenceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientPreferenceForView(response: HttpResponseBase): Observable<GetClientPreferenceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetClientPreferenceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClientPreferenceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getClientPreferenceForEdit(id: number | undefined): Observable<GetClientPreferenceForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ClientPreferences/GetClientPreferenceForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientPreferenceForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientPreferenceForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetClientPreferenceForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClientPreferenceForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientPreferenceForEdit(response: HttpResponseBase): Observable<GetClientPreferenceForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetClientPreferenceForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClientPreferenceForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditClientPreferenceDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ClientPreferences/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ClientPreferences/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param valueFilter (optional) 
     * @param preferenceId (optional) 
     * @return Success
     */
    getClientPreferencesToExcel(filter: string | undefined, valueFilter: string | undefined, preferenceId: number | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/ClientPreferences/GetClientPreferencesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        if (preferenceId === null)
            throw new Error("The parameter 'preferenceId' cannot be null.");
        else if (preferenceId !== undefined)
            url_ += "PreferenceId=" + encodeURIComponent("" + preferenceId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClientPreferencesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClientPreferencesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClientPreferencesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }
}

@Injectable()
export class ClinicsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param contactGroupId (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param filter (optional) 
     * @return Success
     */
    getClinicList(contactGroupId: number | undefined, maxResultCount: number | undefined, skipCount: number | undefined, filter: string | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/GetClinicList?";
        if (contactGroupId === null)
            throw new Error("The parameter 'contactGroupId' cannot be null.");
        else if (contactGroupId !== undefined)
            url_ += "ContactGroupId=" + encodeURIComponent("" + contactGroupId) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param clinicNotesFilter (optional) 
     * @param billingNotesFilter (optional) 
     * @param inactive (optional) 
     * @param clinicAccountFilter (optional) 
     * @param clinicNameFilter (optional) 
     * @param clinicAddressFilter (optional) 
     * @param maxContactIdFilter (optional) 
     * @param minContactIdFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, clinicNotesFilter: string | undefined, billingNotesFilter: string | undefined, inactive: boolean | undefined, clinicAccountFilter: string | undefined, clinicNameFilter: string | undefined, clinicAddressFilter: string | undefined, maxContactIdFilter: number | undefined, minContactIdFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetClinicForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicNotesFilter === null)
            throw new Error("The parameter 'clinicNotesFilter' cannot be null.");
        else if (clinicNotesFilter !== undefined)
            url_ += "ClinicNotesFilter=" + encodeURIComponent("" + clinicNotesFilter) + "&"; 
        if (billingNotesFilter === null)
            throw new Error("The parameter 'billingNotesFilter' cannot be null.");
        else if (billingNotesFilter !== undefined)
            url_ += "BillingNotesFilter=" + encodeURIComponent("" + billingNotesFilter) + "&"; 
        if (inactive === null)
            throw new Error("The parameter 'inactive' cannot be null.");
        else if (inactive !== undefined)
            url_ += "Inactive=" + encodeURIComponent("" + inactive) + "&"; 
        if (clinicAccountFilter === null)
            throw new Error("The parameter 'clinicAccountFilter' cannot be null.");
        else if (clinicAccountFilter !== undefined)
            url_ += "ClinicAccountFilter=" + encodeURIComponent("" + clinicAccountFilter) + "&"; 
        if (clinicNameFilter === null)
            throw new Error("The parameter 'clinicNameFilter' cannot be null.");
        else if (clinicNameFilter !== undefined)
            url_ += "ClinicNameFilter=" + encodeURIComponent("" + clinicNameFilter) + "&"; 
        if (clinicAddressFilter === null)
            throw new Error("The parameter 'clinicAddressFilter' cannot be null.");
        else if (clinicAddressFilter !== undefined)
            url_ += "ClinicAddressFilter=" + encodeURIComponent("" + clinicAddressFilter) + "&"; 
        if (maxContactIdFilter === null)
            throw new Error("The parameter 'maxContactIdFilter' cannot be null.");
        else if (maxContactIdFilter !== undefined)
            url_ += "MaxContactIdFilter=" + encodeURIComponent("" + maxContactIdFilter) + "&"; 
        if (minContactIdFilter === null)
            throw new Error("The parameter 'minContactIdFilter' cannot be null.");
        else if (minContactIdFilter !== undefined)
            url_ += "MinContactIdFilter=" + encodeURIComponent("" + minContactIdFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetClinicForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetClinicForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetClinicForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetClinicForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetClinicForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getClinicForView(id: number | undefined): Observable<GetClinicForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/GetClinicForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicForView(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicForView(response: HttpResponseBase): Observable<GetClinicForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetClinicForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getClinicForEdit(id: number | undefined): Observable<GetClinicForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/GetClinicForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicForEdit(response: HttpResponseBase): Observable<GetClinicForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetClinicForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditClinicDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param clinicNotesFilter (optional) 
     * @param billingNotesFilter (optional) 
     * @param maxContactIdFilter (optional) 
     * @param minContactIdFilter (optional) 
     * @param clinicAccountFilter (optional) 
     * @param clinicNameFilter (optional) 
     * @param activeFilter (optional) 
     * @return Success
     */
    getClinicsToExcel(filter: string | undefined, clinicNotesFilter: string | undefined, billingNotesFilter: string | undefined, maxContactIdFilter: number | undefined, minContactIdFilter: number | undefined, clinicAccountFilter: string | undefined, clinicNameFilter: string | undefined, activeFilter: boolean | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/GetClinicsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicNotesFilter === null)
            throw new Error("The parameter 'clinicNotesFilter' cannot be null.");
        else if (clinicNotesFilter !== undefined)
            url_ += "ClinicNotesFilter=" + encodeURIComponent("" + clinicNotesFilter) + "&"; 
        if (billingNotesFilter === null)
            throw new Error("The parameter 'billingNotesFilter' cannot be null.");
        else if (billingNotesFilter !== undefined)
            url_ += "BillingNotesFilter=" + encodeURIComponent("" + billingNotesFilter) + "&"; 
        if (maxContactIdFilter === null)
            throw new Error("The parameter 'maxContactIdFilter' cannot be null.");
        else if (maxContactIdFilter !== undefined)
            url_ += "MaxContactIdFilter=" + encodeURIComponent("" + maxContactIdFilter) + "&"; 
        if (minContactIdFilter === null)
            throw new Error("The parameter 'minContactIdFilter' cannot be null.");
        else if (minContactIdFilter !== undefined)
            url_ += "MinContactIdFilter=" + encodeURIComponent("" + minContactIdFilter) + "&"; 
        if (clinicAccountFilter === null)
            throw new Error("The parameter 'clinicAccountFilter' cannot be null.");
        else if (clinicAccountFilter !== undefined)
            url_ += "ClinicAccountFilter=" + encodeURIComponent("" + clinicAccountFilter) + "&"; 
        if (clinicNameFilter === null)
            throw new Error("The parameter 'clinicNameFilter' cannot be null.");
        else if (clinicNameFilter !== undefined)
            url_ += "ClinicNameFilter=" + encodeURIComponent("" + clinicNameFilter) + "&"; 
        if (activeFilter === null)
            throw new Error("The parameter 'activeFilter' cannot be null.");
        else if (activeFilter !== undefined)
            url_ += "ActiveFilter=" + encodeURIComponent("" + activeFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getClinicSchedule(id: number | undefined): Observable<ListResultDtoOfGetClinicScheduleDto> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/GetClinicSchedule?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicSchedule(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetClinicScheduleDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetClinicScheduleDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicSchedule(response: HttpResponseBase): Observable<ListResultDtoOfGetClinicScheduleDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetClinicScheduleDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetClinicScheduleDto>(<any>null);
    }

    /**
     * @param contactId (optional) 
     * @return Success
     */
    deleteLabOpenOrders(contactId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/DeleteLabOpenOrders?";
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteLabOpenOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteLabOpenOrders(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteLabOpenOrders(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param contactId (optional) 
     * @return Success
     */
    cancelLabOpenOrders(contactId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Clinics/CancelLabOpenOrders?";
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCancelLabOpenOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCancelLabOpenOrders(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCancelLabOpenOrders(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ClosingRouteServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    closeRoute(body: ClosingRouteInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ClosingRoute/CloseRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCloseRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCloseRoute(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCloseRoute(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class CommonLookupServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param onlyFreeItems (optional) 
     * @return Success
     */
    getEditionsForCombobox(onlyFreeItems: boolean | undefined): Observable<ListResultDtoOfSubscribableEditionComboboxItemDto> {
        let url_ = this.baseUrl + "/api/services/app/CommonLookup/GetEditionsForCombobox?";
        if (onlyFreeItems === null)
            throw new Error("The parameter 'onlyFreeItems' cannot be null.");
        else if (onlyFreeItems !== undefined)
            url_ += "onlyFreeItems=" + encodeURIComponent("" + onlyFreeItems) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEditionsForCombobox(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEditionsForCombobox(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfSubscribableEditionComboboxItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfSubscribableEditionComboboxItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEditionsForCombobox(response: HttpResponseBase): Observable<ListResultDtoOfSubscribableEditionComboboxItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfSubscribableEditionComboboxItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfSubscribableEditionComboboxItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    findUsers(body: FindUsersInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/CommonLookup/FindUsers";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processFindUsers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processFindUsers(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processFindUsers(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getDefaultEditionName(): Observable<GetDefaultEditionNameOutput> {
        let url_ = this.baseUrl + "/api/services/app/CommonLookup/GetDefaultEditionName";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDefaultEditionName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDefaultEditionName(<any>response_);
                } catch (e) {
                    return <Observable<GetDefaultEditionNameOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDefaultEditionNameOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetDefaultEditionName(response: HttpResponseBase): Observable<GetDefaultEditionNameOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDefaultEditionNameOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDefaultEditionNameOutput>(<any>null);
    }
}

@Injectable()
export class CommonSettingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getEntityTypes(): Observable<ListResultDtoOfString> {
        let url_ = this.baseUrl + "/api/services/app/CommonSettings/GetEntityTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEntityTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEntityTypes(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfString>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfString>><any>_observableThrow(response_);
        }));
    }

    protected processGetEntityTypes(response: HttpResponseBase): Observable<ListResultDtoOfString> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfString.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfString>(<any>null);
    }

    /**
     * @param entityType (optional) 
     * @return Success
     */
    getCodesForEntityType(entityType: string | undefined): Observable<ListResultDtoOfString> {
        let url_ = this.baseUrl + "/api/services/app/CommonSettings/GetCodesForEntityType?";
        if (entityType === null)
            throw new Error("The parameter 'entityType' cannot be null.");
        else if (entityType !== undefined)
            url_ += "entityType=" + encodeURIComponent("" + entityType) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCodesForEntityType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCodesForEntityType(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfString>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfString>><any>_observableThrow(response_);
        }));
    }

    protected processGetCodesForEntityType(response: HttpResponseBase): Observable<ListResultDtoOfString> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfString.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfString>(<any>null);
    }

    /**
     * @return Success
     */
    getCodesForStopType(): Observable<ListResultDtoOfString> {
        let url_ = this.baseUrl + "/api/services/app/CommonSettings/GetCodesForStopType";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCodesForStopType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCodesForStopType(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfString>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfString>><any>_observableThrow(response_);
        }));
    }

    protected processGetCodesForStopType(response: HttpResponseBase): Observable<ListResultDtoOfString> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfString.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfString>(<any>null);
    }
}

@Injectable()
export class CompanyServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param name (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getCompanies(name: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetCompaniesListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/Company/GetCompanies?";
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCompanies(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCompanies(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetCompaniesListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetCompaniesListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCompanies(response: HttpResponseBase): Observable<PagedResultDtoOfGetCompaniesListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetCompaniesListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetCompaniesListItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createCompany(body: CreateCompanyInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Company/CreateCompany";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateCompany(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateCompany(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateCompany(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class ContactServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param surnameFilter (optional) 
     * @param addressLine1Filter (optional) 
     * @param addressLine2Filter (optional) 
     * @param postalCodeValueFilter (optional) 
     * @param countryFilter (optional) 
     * @param stateFilter (optional) 
     * @param cityFilter (optional) 
     * @return Success
     */
    getContactsToExcel(filter: string | undefined, nameFilter: string | undefined, surnameFilter: string | undefined, addressLine1Filter: string | undefined, addressLine2Filter: string | undefined, postalCodeValueFilter: string | undefined, countryFilter: string | undefined, stateFilter: string | undefined, cityFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Contact/GetContactsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (surnameFilter === null)
            throw new Error("The parameter 'surnameFilter' cannot be null.");
        else if (surnameFilter !== undefined)
            url_ += "SurnameFilter=" + encodeURIComponent("" + surnameFilter) + "&"; 
        if (addressLine1Filter === null)
            throw new Error("The parameter 'addressLine1Filter' cannot be null.");
        else if (addressLine1Filter !== undefined)
            url_ += "AddressLine1Filter=" + encodeURIComponent("" + addressLine1Filter) + "&"; 
        if (addressLine2Filter === null)
            throw new Error("The parameter 'addressLine2Filter' cannot be null.");
        else if (addressLine2Filter !== undefined)
            url_ += "AddressLine2Filter=" + encodeURIComponent("" + addressLine2Filter) + "&"; 
        if (postalCodeValueFilter === null)
            throw new Error("The parameter 'postalCodeValueFilter' cannot be null.");
        else if (postalCodeValueFilter !== undefined)
            url_ += "PostalCodeValueFilter=" + encodeURIComponent("" + postalCodeValueFilter) + "&"; 
        if (countryFilter === null)
            throw new Error("The parameter 'countryFilter' cannot be null.");
        else if (countryFilter !== undefined)
            url_ += "CountryFilter=" + encodeURIComponent("" + countryFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param addressId (optional) 
     * @param postalCodeId (optional) 
     * @param postalCodeValueFilter (optional) 
     * @param stateFilter (optional) 
     * @param cityFilter (optional) 
     * @param countryFilter (optional) 
     * @param addressLine1Filter (optional) 
     * @param addressLine2Filter (optional) 
     * @param nameFilter (optional) 
     * @param filter (optional) 
     * @param firstName (optional) 
     * @param lastName (optional) 
     * @param emailAddressFilter (optional) 
     * @param phoneNumberFilter (optional) 
     * @param addressType (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getContact(id: number | undefined, userId: number | undefined, addressId: number | undefined, postalCodeId: number | undefined, postalCodeValueFilter: string | undefined, stateFilter: string | undefined, cityFilter: string | undefined, countryFilter: string | undefined, addressLine1Filter: string | undefined, addressLine2Filter: string | undefined, nameFilter: string | undefined, filter: string | undefined, firstName: string | undefined, lastName: string | undefined, emailAddressFilter: string | undefined, phoneNumberFilter: string | undefined, addressType: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfContactListDto> {
        let url_ = this.baseUrl + "/api/services/app/Contact/GetContact?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (addressId === null)
            throw new Error("The parameter 'addressId' cannot be null.");
        else if (addressId !== undefined)
            url_ += "AddressId=" + encodeURIComponent("" + addressId) + "&"; 
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (postalCodeValueFilter === null)
            throw new Error("The parameter 'postalCodeValueFilter' cannot be null.");
        else if (postalCodeValueFilter !== undefined)
            url_ += "PostalCodeValueFilter=" + encodeURIComponent("" + postalCodeValueFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        if (countryFilter === null)
            throw new Error("The parameter 'countryFilter' cannot be null.");
        else if (countryFilter !== undefined)
            url_ += "CountryFilter=" + encodeURIComponent("" + countryFilter) + "&"; 
        if (addressLine1Filter === null)
            throw new Error("The parameter 'addressLine1Filter' cannot be null.");
        else if (addressLine1Filter !== undefined)
            url_ += "AddressLine1Filter=" + encodeURIComponent("" + addressLine1Filter) + "&"; 
        if (addressLine2Filter === null)
            throw new Error("The parameter 'addressLine2Filter' cannot be null.");
        else if (addressLine2Filter !== undefined)
            url_ += "AddressLine2Filter=" + encodeURIComponent("" + addressLine2Filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (firstName === null)
            throw new Error("The parameter 'firstName' cannot be null.");
        else if (firstName !== undefined)
            url_ += "FirstName=" + encodeURIComponent("" + firstName) + "&"; 
        if (lastName === null)
            throw new Error("The parameter 'lastName' cannot be null.");
        else if (lastName !== undefined)
            url_ += "LastName=" + encodeURIComponent("" + lastName) + "&"; 
        if (emailAddressFilter === null)
            throw new Error("The parameter 'emailAddressFilter' cannot be null.");
        else if (emailAddressFilter !== undefined)
            url_ += "EmailAddressFilter=" + encodeURIComponent("" + emailAddressFilter) + "&"; 
        if (phoneNumberFilter === null)
            throw new Error("The parameter 'phoneNumberFilter' cannot be null.");
        else if (phoneNumberFilter !== undefined)
            url_ += "PhoneNumberFilter=" + encodeURIComponent("" + phoneNumberFilter) + "&"; 
        if (addressType === null)
            throw new Error("The parameter 'addressType' cannot be null.");
        else if (addressType !== undefined)
            url_ += "AddressType=" + encodeURIComponent("" + addressType) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContact(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfContactListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfContactListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContact(response: HttpResponseBase): Observable<PagedResultDtoOfContactListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfContactListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfContactListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param addressId (optional) 
     * @param postalCodeId (optional) 
     * @param postalCodeValueFilter (optional) 
     * @param stateFilter (optional) 
     * @param cityFilter (optional) 
     * @param countryFilter (optional) 
     * @param addressLine1Filter (optional) 
     * @param addressLine2Filter (optional) 
     * @param nameFilter (optional) 
     * @param filter (optional) 
     * @param firstName (optional) 
     * @param lastName (optional) 
     * @param emailAddressFilter (optional) 
     * @param phoneNumberFilter (optional) 
     * @param addressType (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getContactDriverQPaged(id: number | undefined, userId: number | undefined, addressId: number | undefined, postalCodeId: number | undefined, postalCodeValueFilter: string | undefined, stateFilter: string | undefined, cityFilter: string | undefined, countryFilter: string | undefined, addressLine1Filter: string | undefined, addressLine2Filter: string | undefined, nameFilter: string | undefined, filter: string | undefined, firstName: string | undefined, lastName: string | undefined, emailAddressFilter: string | undefined, phoneNumberFilter: string | undefined, addressType: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfContactListDto> {
        let url_ = this.baseUrl + "/api/services/app/Contact/GetContactDriverQPaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (addressId === null)
            throw new Error("The parameter 'addressId' cannot be null.");
        else if (addressId !== undefined)
            url_ += "AddressId=" + encodeURIComponent("" + addressId) + "&"; 
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (postalCodeValueFilter === null)
            throw new Error("The parameter 'postalCodeValueFilter' cannot be null.");
        else if (postalCodeValueFilter !== undefined)
            url_ += "PostalCodeValueFilter=" + encodeURIComponent("" + postalCodeValueFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        if (countryFilter === null)
            throw new Error("The parameter 'countryFilter' cannot be null.");
        else if (countryFilter !== undefined)
            url_ += "CountryFilter=" + encodeURIComponent("" + countryFilter) + "&"; 
        if (addressLine1Filter === null)
            throw new Error("The parameter 'addressLine1Filter' cannot be null.");
        else if (addressLine1Filter !== undefined)
            url_ += "AddressLine1Filter=" + encodeURIComponent("" + addressLine1Filter) + "&"; 
        if (addressLine2Filter === null)
            throw new Error("The parameter 'addressLine2Filter' cannot be null.");
        else if (addressLine2Filter !== undefined)
            url_ += "AddressLine2Filter=" + encodeURIComponent("" + addressLine2Filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (firstName === null)
            throw new Error("The parameter 'firstName' cannot be null.");
        else if (firstName !== undefined)
            url_ += "FirstName=" + encodeURIComponent("" + firstName) + "&"; 
        if (lastName === null)
            throw new Error("The parameter 'lastName' cannot be null.");
        else if (lastName !== undefined)
            url_ += "LastName=" + encodeURIComponent("" + lastName) + "&"; 
        if (emailAddressFilter === null)
            throw new Error("The parameter 'emailAddressFilter' cannot be null.");
        else if (emailAddressFilter !== undefined)
            url_ += "EmailAddressFilter=" + encodeURIComponent("" + emailAddressFilter) + "&"; 
        if (phoneNumberFilter === null)
            throw new Error("The parameter 'phoneNumberFilter' cannot be null.");
        else if (phoneNumberFilter !== undefined)
            url_ += "PhoneNumberFilter=" + encodeURIComponent("" + phoneNumberFilter) + "&"; 
        if (addressType === null)
            throw new Error("The parameter 'addressType' cannot be null.");
        else if (addressType !== undefined)
            url_ += "AddressType=" + encodeURIComponent("" + addressType) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactDriverQPaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactDriverQPaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfContactListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfContactListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactDriverQPaged(response: HttpResponseBase): Observable<PagedResultDtoOfContactListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfContactListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfContactListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param addressId (optional) 
     * @param postalCodeId (optional) 
     * @param postalCodeValueFilter (optional) 
     * @param stateFilter (optional) 
     * @param cityFilter (optional) 
     * @param countryFilter (optional) 
     * @param addressLine1Filter (optional) 
     * @param addressLine2Filter (optional) 
     * @param nameFilter (optional) 
     * @param filter (optional) 
     * @param firstName (optional) 
     * @param lastName (optional) 
     * @param emailAddressFilter (optional) 
     * @param phoneNumberFilter (optional) 
     * @param addressType (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getContactVendorQPaged(id: number | undefined, userId: number | undefined, addressId: number | undefined, postalCodeId: number | undefined, postalCodeValueFilter: string | undefined, stateFilter: string | undefined, cityFilter: string | undefined, countryFilter: string | undefined, addressLine1Filter: string | undefined, addressLine2Filter: string | undefined, nameFilter: string | undefined, filter: string | undefined, firstName: string | undefined, lastName: string | undefined, emailAddressFilter: string | undefined, phoneNumberFilter: string | undefined, addressType: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfContactListDto> {
        let url_ = this.baseUrl + "/api/services/app/Contact/GetContactVendorQPaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (addressId === null)
            throw new Error("The parameter 'addressId' cannot be null.");
        else if (addressId !== undefined)
            url_ += "AddressId=" + encodeURIComponent("" + addressId) + "&"; 
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (postalCodeValueFilter === null)
            throw new Error("The parameter 'postalCodeValueFilter' cannot be null.");
        else if (postalCodeValueFilter !== undefined)
            url_ += "PostalCodeValueFilter=" + encodeURIComponent("" + postalCodeValueFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        if (countryFilter === null)
            throw new Error("The parameter 'countryFilter' cannot be null.");
        else if (countryFilter !== undefined)
            url_ += "CountryFilter=" + encodeURIComponent("" + countryFilter) + "&"; 
        if (addressLine1Filter === null)
            throw new Error("The parameter 'addressLine1Filter' cannot be null.");
        else if (addressLine1Filter !== undefined)
            url_ += "AddressLine1Filter=" + encodeURIComponent("" + addressLine1Filter) + "&"; 
        if (addressLine2Filter === null)
            throw new Error("The parameter 'addressLine2Filter' cannot be null.");
        else if (addressLine2Filter !== undefined)
            url_ += "AddressLine2Filter=" + encodeURIComponent("" + addressLine2Filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (firstName === null)
            throw new Error("The parameter 'firstName' cannot be null.");
        else if (firstName !== undefined)
            url_ += "FirstName=" + encodeURIComponent("" + firstName) + "&"; 
        if (lastName === null)
            throw new Error("The parameter 'lastName' cannot be null.");
        else if (lastName !== undefined)
            url_ += "LastName=" + encodeURIComponent("" + lastName) + "&"; 
        if (emailAddressFilter === null)
            throw new Error("The parameter 'emailAddressFilter' cannot be null.");
        else if (emailAddressFilter !== undefined)
            url_ += "EmailAddressFilter=" + encodeURIComponent("" + emailAddressFilter) + "&"; 
        if (phoneNumberFilter === null)
            throw new Error("The parameter 'phoneNumberFilter' cannot be null.");
        else if (phoneNumberFilter !== undefined)
            url_ += "PhoneNumberFilter=" + encodeURIComponent("" + phoneNumberFilter) + "&"; 
        if (addressType === null)
            throw new Error("The parameter 'addressType' cannot be null.");
        else if (addressType !== undefined)
            url_ += "AddressType=" + encodeURIComponent("" + addressType) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactVendorQPaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactVendorQPaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfContactListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfContactListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactVendorQPaged(response: HttpResponseBase): Observable<PagedResultDtoOfContactListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfContactListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfContactListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createContact(body: CreateContactInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Contact/CreateContact";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateContact(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateContact(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteContact(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Contact/DeleteContact?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteContact(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteContact(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateContact(body: UpdateContactInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Contact/UpdateContact";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateContact(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateContact(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createContactDriverAddress(body: CreateContactUserAddressInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Contact/CreateContactDriverAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateContactDriverAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateContactDriverAddress(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateContactDriverAddress(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createContactVendorAddress(body: CreateContactUserAddressInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Contact/CreateContactVendorAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateContactVendorAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateContactVendorAddress(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateContactVendorAddress(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createContactUserAddress(body: CreateContactUserAddressInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Contact/CreateContactUserAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateContactUserAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateContactUserAddress(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateContactUserAddress(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createContactAddress(body: CreateContactAddressInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Contact/CreateContactAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateContactAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateContactAddress(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateContactAddress(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param addressId (optional) 
     * @param postalCodeId (optional) 
     * @param nameFilter (optional) 
     * @param firstName (optional) 
     * @param lastName (optional) 
     * @return Success
     */
    getVendorToExcel(id: number | undefined, userId: number | undefined, addressId: number | undefined, postalCodeId: number | undefined, nameFilter: string | undefined, firstName: string | undefined, lastName: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Contact/GetVendorToExcel?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (addressId === null)
            throw new Error("The parameter 'addressId' cannot be null.");
        else if (addressId !== undefined)
            url_ += "AddressId=" + encodeURIComponent("" + addressId) + "&"; 
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (firstName === null)
            throw new Error("The parameter 'firstName' cannot be null.");
        else if (firstName !== undefined)
            url_ += "FirstName=" + encodeURIComponent("" + firstName) + "&"; 
        if (lastName === null)
            throw new Error("The parameter 'lastName' cannot be null.");
        else if (lastName !== undefined)
            url_ += "LastName=" + encodeURIComponent("" + lastName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVendorToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVendorToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVendorToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param addressId (optional) 
     * @param postalCodeId (optional) 
     * @param nameFilter (optional) 
     * @param firstName (optional) 
     * @param lastName (optional) 
     * @return Success
     */
    getVendorss(id: number | undefined, userId: number | undefined, addressId: number | undefined, postalCodeId: number | undefined, nameFilter: string | undefined, firstName: string | undefined, lastName: string | undefined): Observable<ListResultDtoOfGetVendorForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Contact/GetVendorss?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (addressId === null)
            throw new Error("The parameter 'addressId' cannot be null.");
        else if (addressId !== undefined)
            url_ += "AddressId=" + encodeURIComponent("" + addressId) + "&"; 
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (firstName === null)
            throw new Error("The parameter 'firstName' cannot be null.");
        else if (firstName !== undefined)
            url_ += "FirstName=" + encodeURIComponent("" + firstName) + "&"; 
        if (lastName === null)
            throw new Error("The parameter 'lastName' cannot be null.");
        else if (lastName !== undefined)
            url_ += "LastName=" + encodeURIComponent("" + lastName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVendorss(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVendorss(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetVendorForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetVendorForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVendorss(response: HttpResponseBase): Observable<ListResultDtoOfGetVendorForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetVendorForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetVendorForViewDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createVendor(body: CreateOrUpdateContactUserInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Contact/CreateVendor";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateVendor(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateVendor(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateVendor(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @return Success
     */
    getRolesDefault(): Observable<UserRoleDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Contact/GetRolesDefault";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRolesDefault(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRolesDefault(<any>response_);
                } catch (e) {
                    return <Observable<UserRoleDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<UserRoleDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRolesDefault(response: HttpResponseBase): Observable<UserRoleDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(UserRoleDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UserRoleDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createUserInContact(body: CreateOrUpdateUserInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Contact/CreateUserInContact";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateUserInContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateUserInContact(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateUserInContact(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateMultipleUserId(body: UpdateMultipleUserInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Contact/UpdateMultipleUserId";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateMultipleUserId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateMultipleUserId(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateMultipleUserId(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ContactGroupServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addContactForGroup(body: AddContactForGroupInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/AddContactForGroup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddContactForGroup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddContactForGroup(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddContactForGroup(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addMultipleContactForGroup(body: AddContactForGroupInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/AddMultipleContactForGroup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddMultipleContactForGroup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddMultipleContactForGroup(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddMultipleContactForGroup(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addContactToGroup(body: AddContactToGroupInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/AddContactToGroup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddContactToGroup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddContactToGroup(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddContactToGroup(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateContactGroup(body: CreateOrUpdateContactGroupInputDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/CreateOrUpdateContactGroup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateContactGroup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateContactGroup(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateContactGroup(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateContactGroupSetting(body: CreateOrUpdateContactGroupSettingInputDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/CreateOrUpdateContactGroupSetting";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateContactGroupSetting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateContactGroupSetting(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateContactGroupSetting(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateEtaLock(body: CreateOrUpdateContactGroupSettingInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/CreateOrUpdateEtaLock";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateEtaLock(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateEtaLock(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateEtaLock(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateProximityLock(body: CreateOrUpdateContactGroupSettingInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/CreateOrUpdateProximityLock";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateProximityLock(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateProximityLock(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateProximityLock(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateUsePurpleBag(body: CreateOrUpdateContactGroupSettingInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/CreateOrUpdateUsePurpleBag";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateUsePurpleBag(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateUsePurpleBag(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateUsePurpleBag(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    deletContactFromGroup(body: DeletContactFromGroupInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/DeletContactFromGroup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeletContactFromGroup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeletContactFromGroup(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeletContactFromGroup(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param code (optional) 
     * @param id (optional) 
     * @return Success
     */
    deleteContactGroup(code: string | undefined, id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/DeleteContactGroup?";
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteContactGroup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteContactGroup(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteContactGroup(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getContactGroups(sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetContactGroupsListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/GetContactGroups?";
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactGroups(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactGroups(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetContactGroupsListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetContactGroupsListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactGroups(response: HttpResponseBase): Observable<PagedResultDtoOfGetContactGroupsListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetContactGroupsListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetContactGroupsListItemDto>(<any>null);
    }

    /**
     * @return Success
     */
    getContactGroupSettingTypes(): Observable<GetContactGroupSettingTypesListItemDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/GetContactGroupSettingTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactGroupSettingTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactGroupSettingTypes(<any>response_);
                } catch (e) {
                    return <Observable<GetContactGroupSettingTypesListItemDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetContactGroupSettingTypesListItemDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactGroupSettingTypes(response: HttpResponseBase): Observable<GetContactGroupSettingTypesListItemDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetContactGroupSettingTypesListItemDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetContactGroupSettingTypesListItemDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getContactGroupLists(): Observable<ListResultDtoOfGetContactGroupsListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/GetContactGroupLists";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactGroupLists(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactGroupLists(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetContactGroupsListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetContactGroupsListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactGroupLists(response: HttpResponseBase): Observable<ListResultDtoOfGetContactGroupsListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetContactGroupsListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetContactGroupsListItemDto>(<any>null);
    }

    /**
     * @param groupId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getContactsForGroup(groupId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfContactListDto> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/GetContactsForGroup?";
        if (groupId === null)
            throw new Error("The parameter 'groupId' cannot be null.");
        else if (groupId !== undefined)
            url_ += "GroupId=" + encodeURIComponent("" + groupId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactsForGroup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactsForGroup(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfContactListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfContactListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactsForGroup(response: HttpResponseBase): Observable<PagedResultDtoOfContactListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfContactListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfContactListDto>(<any>null);
    }

    /**
     * @param contactGroupId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getSettingsForContactGroup(contactGroupId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetSettingsForContactGroupListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/GetSettingsForContactGroup?";
        if (contactGroupId === null)
            throw new Error("The parameter 'contactGroupId' cannot be null.");
        else if (contactGroupId !== undefined)
            url_ += "ContactGroupId=" + encodeURIComponent("" + contactGroupId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSettingsForContactGroup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSettingsForContactGroup(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetSettingsForContactGroupListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetSettingsForContactGroupListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSettingsForContactGroup(response: HttpResponseBase): Observable<PagedResultDtoOfGetSettingsForContactGroupListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetSettingsForContactGroupListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetSettingsForContactGroupListItemDto>(<any>null);
    }

    /**
     * @param jobId (optional) 
     * @return Success
     */
    getJobState(jobId: string | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/GetJobState?";
        if (jobId === null)
            throw new Error("The parameter 'jobId' cannot be null.");
        else if (jobId !== undefined)
            url_ += "jobId=" + encodeURIComponent("" + jobId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetJobState(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetJobState(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processGetJobState(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateContactGroupSettingForImport(body: ContactGroupImportInputDto | undefined): Observable<ContactGroupApiResult> {
        let url_ = this.baseUrl + "/api/services/app/ContactGroup/CreateOrUpdateContactGroupSettingForImport";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateContactGroupSettingForImport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateContactGroupSettingForImport(<any>response_);
                } catch (e) {
                    return <Observable<ContactGroupApiResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ContactGroupApiResult>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateContactGroupSettingForImport(response: HttpResponseBase): Observable<ContactGroupApiResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ContactGroupApiResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ContactGroupApiResult>(<any>null);
    }
}

@Injectable()
export class ContactPersonsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getContactPersons(): Observable<GetContactPersonsDto> {
        let url_ = this.baseUrl + "/api/services/app/ContactPersons/GetContactPersons";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactPersons(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactPersons(<any>response_);
                } catch (e) {
                    return <Observable<GetContactPersonsDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetContactPersonsDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactPersons(response: HttpResponseBase): Observable<GetContactPersonsDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetContactPersonsDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetContactPersonsDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEditContactPerson(body: CreateOrEditContactPersonInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactPersons/CreateOrEditContactPerson";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEditContactPerson(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEditContactPerson(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEditContactPerson(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getBusinessHourCode(): Observable<BusinessHoursCodeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ContactPersons/GetBusinessHourCode";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetBusinessHourCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetBusinessHourCode(<any>response_);
                } catch (e) {
                    return <Observable<BusinessHoursCodeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<BusinessHoursCodeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetBusinessHourCode(response: HttpResponseBase): Observable<BusinessHoursCodeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(BusinessHoursCodeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<BusinessHoursCodeDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getDateOfTheWeek(): Observable<DAYOFTHEWEEKCODEDTO[]> {
        let url_ = this.baseUrl + "/api/services/app/ContactPersons/GetDateOfTheWeek";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDateOfTheWeek(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDateOfTheWeek(<any>response_);
                } catch (e) {
                    return <Observable<DAYOFTHEWEEKCODEDTO[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<DAYOFTHEWEEKCODEDTO[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDateOfTheWeek(response: HttpResponseBase): Observable<DAYOFTHEWEEKCODEDTO[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(DAYOFTHEWEEKCODEDTO.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DAYOFTHEWEEKCODEDTO[]>(<any>null);
    }
}

@Injectable()
export class ContactSettingServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getContactSettingCodes(): Observable<GetContactSettingCodesDto> {
        let url_ = this.baseUrl + "/api/services/app/ContactSetting/GetContactSettingCodes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactSettingCodes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactSettingCodes(<any>response_);
                } catch (e) {
                    return <Observable<GetContactSettingCodesDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetContactSettingCodesDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactSettingCodes(response: HttpResponseBase): Observable<GetContactSettingCodesDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetContactSettingCodesDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetContactSettingCodesDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateForContact(body: CreateOrUpdateForContactInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactSetting/CreateOrUpdateForContact";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateForContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateForContact(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateForContact(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param contactId (optional) 
     * @param code (optional) 
     * @param value (optional) 
     * @return Success
     */
    deleteForContact(contactId: number | undefined, code: string | undefined, value: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ContactSetting/DeleteForContact?";
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteForContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteForContact(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteForContact(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param contactId (optional) 
     * @return Success
     */
    getForContact(contactId: number | undefined): Observable<ListResultDtoOfGetContactSettingsItemDto> {
        let url_ = this.baseUrl + "/api/services/app/ContactSetting/GetForContact?";
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetForContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetForContact(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetContactSettingsItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetContactSettingsItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetForContact(response: HttpResponseBase): Observable<ListResultDtoOfGetContactSettingsItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetContactSettingsItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetContactSettingsItemDto>(<any>null);
    }
}

@Injectable()
export class ContainersServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getAll(): Observable<ListResultDtoOfGetContainersItemListDto> {
        let url_ = this.baseUrl + "/api/services/app/Containers/GetAll";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetContainersItemListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetContainersItemListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<ListResultDtoOfGetContainersItemListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetContainersItemListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetContainersItemListDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param nameFilter (optional) 
     * @param inActiveFilter (optional) 
     * @param colorFilter (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPaged(filter: string | undefined, codeFilter: string | undefined, nameFilter: string | undefined, inActiveFilter: number | undefined, colorFilter: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetContainersItemListDto> {
        let url_ = this.baseUrl + "/api/services/app/Containers/GetPaged?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (inActiveFilter === null)
            throw new Error("The parameter 'inActiveFilter' cannot be null.");
        else if (inActiveFilter !== undefined)
            url_ += "InActiveFilter=" + encodeURIComponent("" + inActiveFilter) + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetContainersItemListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetContainersItemListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPaged(response: HttpResponseBase): Observable<PagedResultDtoOfGetContainersItemListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetContainersItemListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetContainersItemListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdate(body: CreateContainerInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Containers/CreateOrUpdate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    update(body: UpdateContainerInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Containers/Update";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Containers/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ControllerDriverListServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param locationId (optional) 
     * @param routeId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param userId (optional) 
     * @param driverName (optional) 
     * @param driverId (optional) 
     * @param appVersion (optional) 
     * @param completed (optional) 
     * @param routeIds (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getControllerDriverList(locationId: number | undefined, routeId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, userId: number | undefined, driverName: string | undefined, driverId: number | undefined, appVersion: string | undefined, completed: boolean | undefined, routeIds: number[] | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfControllerDriverListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerDriverList/GetControllerDriverList?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (appVersion === null)
            throw new Error("The parameter 'appVersion' cannot be null.");
        else if (appVersion !== undefined)
            url_ += "AppVersion=" + encodeURIComponent("" + appVersion) + "&"; 
        if (completed === null)
            throw new Error("The parameter 'completed' cannot be null.");
        else if (completed !== undefined)
            url_ += "Completed=" + encodeURIComponent("" + completed) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerDriverList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerDriverList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfControllerDriverListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfControllerDriverListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerDriverList(response: HttpResponseBase): Observable<PagedResultDtoOfControllerDriverListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfControllerDriverListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfControllerDriverListDto>(<any>null);
    }

    /**
     * @param driverIds (optional) 
     * @return Success
     */
    getControllerDriverRouteCount(driverIds: number[] | undefined): Observable<ControllerDriverRouteListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerDriverList/GetControllerDriverRouteCount?";
        if (driverIds === null)
            throw new Error("The parameter 'driverIds' cannot be null.");
        else if (driverIds !== undefined)
            driverIds && driverIds.forEach(item => { url_ += "DriverIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerDriverRouteCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerDriverRouteCount(<any>response_);
                } catch (e) {
                    return <Observable<ControllerDriverRouteListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerDriverRouteListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerDriverRouteCount(response: HttpResponseBase): Observable<ControllerDriverRouteListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerDriverRouteListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerDriverRouteListDto[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param routeId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param userId (optional) 
     * @param driverName (optional) 
     * @param driverId (optional) 
     * @param appVersion (optional) 
     * @param completed (optional) 
     * @param routeIds (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDriverEntity(locationId: number | undefined, routeId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, userId: number | undefined, driverName: string | undefined, driverId: number | undefined, appVersion: string | undefined, completed: boolean | undefined, routeIds: number[] | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<GetDriverForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerDriverList/GetDriverEntity?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (appVersion === null)
            throw new Error("The parameter 'appVersion' cannot be null.");
        else if (appVersion !== undefined)
            url_ += "AppVersion=" + encodeURIComponent("" + appVersion) + "&"; 
        if (completed === null)
            throw new Error("The parameter 'completed' cannot be null.");
        else if (completed !== undefined)
            url_ += "Completed=" + encodeURIComponent("" + completed) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverEntity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverEntity(<any>response_);
                } catch (e) {
                    return <Observable<GetDriverForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDriverForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverEntity(response: HttpResponseBase): Observable<GetDriverForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDriverForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDriverForViewDto>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param routeId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param userId (optional) 
     * @param driverName (optional) 
     * @param driverId (optional) 
     * @param appVersion (optional) 
     * @param completed (optional) 
     * @param routeIds (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDriverDetails(locationId: number | undefined, routeId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, userId: number | undefined, driverName: string | undefined, driverId: number | undefined, appVersion: string | undefined, completed: boolean | undefined, routeIds: number[] | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetDriverDetailsResult> {
        let url_ = this.baseUrl + "/api/services/app/ControllerDriverList/GetDriverDetails?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (appVersion === null)
            throw new Error("The parameter 'appVersion' cannot be null.");
        else if (appVersion !== undefined)
            url_ += "AppVersion=" + encodeURIComponent("" + appVersion) + "&"; 
        if (completed === null)
            throw new Error("The parameter 'completed' cannot be null.");
        else if (completed !== undefined)
            url_ += "Completed=" + encodeURIComponent("" + completed) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverDetails(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetDriverDetailsResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetDriverDetailsResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverDetails(response: HttpResponseBase): Observable<PagedResultDtoOfGetDriverDetailsResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetDriverDetailsResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetDriverDetailsResult>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @return Success
     */
    getStopCount(routeIds: number[] | undefined): Observable<GetStopCountResult[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerDriverList/GetStopCount?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetStopCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetStopCount(<any>response_);
                } catch (e) {
                    return <Observable<GetStopCountResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetStopCountResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetStopCount(response: HttpResponseBase): Observable<GetStopCountResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetStopCountResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetStopCountResult[]>(<any>null);
    }

    /**
     * @param meters (optional) 
     * @return Success
     */
    convertMetersToMiles(meters: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ControllerDriverList/ConvertMetersToMiles?";
        if (meters === null)
            throw new Error("The parameter 'meters' cannot be null.");
        else if (meters !== undefined)
            url_ += "meters=" + encodeURIComponent("" + meters) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertMetersToMiles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertMetersToMiles(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processConvertMetersToMiles(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class ControllerKpiCountServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param routeIds (optional) 
     * @param locationId (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param completed (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getControllerKpiCount(routeIds: number[] | undefined, locationId: number | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, completed: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerKpiCountListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetControllerKpiCount?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (completed === null)
            throw new Error("The parameter 'completed' cannot be null.");
        else if (completed !== undefined)
            url_ += "Completed=" + encodeURIComponent("" + completed) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerKpiCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerKpiCount(<any>response_);
                } catch (e) {
                    return <Observable<ControllerKpiCountListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerKpiCountListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerKpiCount(response: HttpResponseBase): Observable<ControllerKpiCountListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerKpiCountListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerKpiCountListDto[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @return Success
     */
    getRefreshTime(locationId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetRefreshTime?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRefreshTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRefreshTime(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetRefreshTime(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @param locationId (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param completed (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getKPICount(routeIds: number[] | undefined, locationId: number | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, completed: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerKpiCountListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetKPICount?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (completed === null)
            throw new Error("The parameter 'completed' cannot be null.");
        else if (completed !== undefined)
            url_ += "Completed=" + encodeURIComponent("" + completed) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetKPICount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetKPICount(<any>response_);
                } catch (e) {
                    return <Observable<ControllerKpiCountListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerKpiCountListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetKPICount(response: HttpResponseBase): Observable<ControllerKpiCountListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ControllerKpiCountListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerKpiCountListDto>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filterType (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getKPICountList(locationId: number | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filterType: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerKpiCountListDetailsDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetKPICountList?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filterType === null)
            throw new Error("The parameter 'filterType' cannot be null.");
        else if (filterType !== undefined)
            url_ += "FilterType=" + encodeURIComponent("" + filterType) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetKPICountList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetKPICountList(<any>response_);
                } catch (e) {
                    return <Observable<ControllerKpiCountListDetailsDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerKpiCountListDetailsDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetKPICountList(response: HttpResponseBase): Observable<ControllerKpiCountListDetailsDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerKpiCountListDetailsDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerKpiCountListDetailsDto[]>(<any>null);
    }

    /**
     * @param vehicleName (optional) 
     * @param vehicleId (optional) 
     * @param locationId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param completed (optional) 
     * @param routeIds (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getControllerVehicleCount(vehicleName: string | undefined, vehicleId: number | undefined, locationId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, completed: boolean | undefined, routeIds: number[] | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetControllerVehicleCount?";
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (completed === null)
            throw new Error("The parameter 'completed' cannot be null.");
        else if (completed !== undefined)
            url_ += "Completed=" + encodeURIComponent("" + completed) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerVehicleCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerVehicleCount(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerVehicleCount(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @param locationId (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param completed (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getUnassignedPackagesCount(routeIds: number[] | undefined, locationId: number | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, completed: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetUnassignedPackagesCount?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (completed === null)
            throw new Error("The parameter 'completed' cannot be null.");
        else if (completed !== undefined)
            url_ += "Completed=" + encodeURIComponent("" + completed) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUnassignedPackagesCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUnassignedPackagesCount(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetUnassignedPackagesCount(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param vehicleName (optional) 
     * @param routeName (optional) 
     * @param driverName (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filter (optional) 
     * @param oSName (optional) 
     * @param completion (optional) 
     * @param routeIds (optional) 
     * @param orderTypes (optional) 
     * @param editionName (optional) 
     * @param routeTypeIds (optional) 
     * @param managerIds (optional) 
     * @param viewTypes (optional) 
     * @param locationIds (optional) 
     * @param showEmptyRoute (optional) 
     * @param threshold (optional) 
     * @param loadDateString (optional) 
     * @param isLineHaul (optional) 
     * @param isShowAllLocation (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getKPIActiveRoutes(id: number | undefined, locationId: number | undefined, vehicleId: number | undefined, routeId: string | undefined, vehicleName: string | undefined, routeName: string | undefined, driverName: string | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filter: string | undefined, oSName: string | undefined, completion: boolean | undefined, routeIds: number[] | undefined, orderTypes: string[] | undefined, editionName: string | undefined, routeTypeIds: number[] | undefined, managerIds: number[] | undefined, viewTypes: string | undefined, locationIds: number[] | undefined, showEmptyRoute: boolean | undefined, threshold: number | undefined, loadDateString: string | undefined, isLineHaul: boolean | undefined, isShowAllLocation: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerKpiLaboratoryCountListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetKPIActiveRoutes?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (oSName === null)
            throw new Error("The parameter 'oSName' cannot be null.");
        else if (oSName !== undefined)
            url_ += "OSName=" + encodeURIComponent("" + oSName) + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent("" + completion) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (orderTypes === null)
            throw new Error("The parameter 'orderTypes' cannot be null.");
        else if (orderTypes !== undefined)
            orderTypes && orderTypes.forEach(item => { url_ += "OrderTypes=" + encodeURIComponent("" + item) + "&"; });
        if (editionName === null)
            throw new Error("The parameter 'editionName' cannot be null.");
        else if (editionName !== undefined)
            url_ += "EditionName=" + encodeURIComponent("" + editionName) + "&"; 
        if (routeTypeIds === null)
            throw new Error("The parameter 'routeTypeIds' cannot be null.");
        else if (routeTypeIds !== undefined)
            routeTypeIds && routeTypeIds.forEach(item => { url_ += "RouteTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (managerIds === null)
            throw new Error("The parameter 'managerIds' cannot be null.");
        else if (managerIds !== undefined)
            managerIds && managerIds.forEach(item => { url_ += "ManagerIds=" + encodeURIComponent("" + item) + "&"; });
        if (viewTypes === null)
            throw new Error("The parameter 'viewTypes' cannot be null.");
        else if (viewTypes !== undefined)
            url_ += "ViewTypes=" + encodeURIComponent("" + viewTypes) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (showEmptyRoute === null)
            throw new Error("The parameter 'showEmptyRoute' cannot be null.");
        else if (showEmptyRoute !== undefined)
            url_ += "ShowEmptyRoute=" + encodeURIComponent("" + showEmptyRoute) + "&"; 
        if (threshold === null)
            throw new Error("The parameter 'threshold' cannot be null.");
        else if (threshold !== undefined)
            url_ += "Threshold=" + encodeURIComponent("" + threshold) + "&"; 
        if (loadDateString === null)
            throw new Error("The parameter 'loadDateString' cannot be null.");
        else if (loadDateString !== undefined)
            url_ += "LoadDateString=" + encodeURIComponent("" + loadDateString) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (isShowAllLocation === null)
            throw new Error("The parameter 'isShowAllLocation' cannot be null.");
        else if (isShowAllLocation !== undefined)
            url_ += "IsShowAllLocation=" + encodeURIComponent("" + isShowAllLocation) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetKPIActiveRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetKPIActiveRoutes(<any>response_);
                } catch (e) {
                    return <Observable<ControllerKpiLaboratoryCountListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerKpiLaboratoryCountListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetKPIActiveRoutes(response: HttpResponseBase): Observable<ControllerKpiLaboratoryCountListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerKpiLaboratoryCountListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerKpiLaboratoryCountListDto[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param vehicleName (optional) 
     * @param routeName (optional) 
     * @param driverName (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filter (optional) 
     * @param oSName (optional) 
     * @param completion (optional) 
     * @param routeIds (optional) 
     * @param orderTypes (optional) 
     * @param editionName (optional) 
     * @param routeTypeIds (optional) 
     * @param managerIds (optional) 
     * @param viewTypes (optional) 
     * @param locationIds (optional) 
     * @param showEmptyRoute (optional) 
     * @param threshold (optional) 
     * @param loadDateString (optional) 
     * @param isLineHaul (optional) 
     * @param isShowAllLocation (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getKPICountLates(id: number | undefined, locationId: number | undefined, vehicleId: number | undefined, routeId: string | undefined, vehicleName: string | undefined, routeName: string | undefined, driverName: string | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filter: string | undefined, oSName: string | undefined, completion: boolean | undefined, routeIds: number[] | undefined, orderTypes: string[] | undefined, editionName: string | undefined, routeTypeIds: number[] | undefined, managerIds: number[] | undefined, viewTypes: string | undefined, locationIds: number[] | undefined, showEmptyRoute: boolean | undefined, threshold: number | undefined, loadDateString: string | undefined, isLineHaul: boolean | undefined, isShowAllLocation: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerKpiLaboratoryLateListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetKPICountLates?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (oSName === null)
            throw new Error("The parameter 'oSName' cannot be null.");
        else if (oSName !== undefined)
            url_ += "OSName=" + encodeURIComponent("" + oSName) + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent("" + completion) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (orderTypes === null)
            throw new Error("The parameter 'orderTypes' cannot be null.");
        else if (orderTypes !== undefined)
            orderTypes && orderTypes.forEach(item => { url_ += "OrderTypes=" + encodeURIComponent("" + item) + "&"; });
        if (editionName === null)
            throw new Error("The parameter 'editionName' cannot be null.");
        else if (editionName !== undefined)
            url_ += "EditionName=" + encodeURIComponent("" + editionName) + "&"; 
        if (routeTypeIds === null)
            throw new Error("The parameter 'routeTypeIds' cannot be null.");
        else if (routeTypeIds !== undefined)
            routeTypeIds && routeTypeIds.forEach(item => { url_ += "RouteTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (managerIds === null)
            throw new Error("The parameter 'managerIds' cannot be null.");
        else if (managerIds !== undefined)
            managerIds && managerIds.forEach(item => { url_ += "ManagerIds=" + encodeURIComponent("" + item) + "&"; });
        if (viewTypes === null)
            throw new Error("The parameter 'viewTypes' cannot be null.");
        else if (viewTypes !== undefined)
            url_ += "ViewTypes=" + encodeURIComponent("" + viewTypes) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (showEmptyRoute === null)
            throw new Error("The parameter 'showEmptyRoute' cannot be null.");
        else if (showEmptyRoute !== undefined)
            url_ += "ShowEmptyRoute=" + encodeURIComponent("" + showEmptyRoute) + "&"; 
        if (threshold === null)
            throw new Error("The parameter 'threshold' cannot be null.");
        else if (threshold !== undefined)
            url_ += "Threshold=" + encodeURIComponent("" + threshold) + "&"; 
        if (loadDateString === null)
            throw new Error("The parameter 'loadDateString' cannot be null.");
        else if (loadDateString !== undefined)
            url_ += "LoadDateString=" + encodeURIComponent("" + loadDateString) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (isShowAllLocation === null)
            throw new Error("The parameter 'isShowAllLocation' cannot be null.");
        else if (isShowAllLocation !== undefined)
            url_ += "IsShowAllLocation=" + encodeURIComponent("" + isShowAllLocation) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetKPICountLates(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetKPICountLates(<any>response_);
                } catch (e) {
                    return <Observable<ControllerKpiLaboratoryLateListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerKpiLaboratoryLateListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetKPICountLates(response: HttpResponseBase): Observable<ControllerKpiLaboratoryLateListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerKpiLaboratoryLateListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerKpiLaboratoryLateListDto[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param vehicleName (optional) 
     * @param routeName (optional) 
     * @param driverName (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filter (optional) 
     * @param oSName (optional) 
     * @param completion (optional) 
     * @param routeIds (optional) 
     * @param orderTypes (optional) 
     * @param editionName (optional) 
     * @param routeTypeIds (optional) 
     * @param managerIds (optional) 
     * @param viewTypes (optional) 
     * @param locationIds (optional) 
     * @param showEmptyRoute (optional) 
     * @param threshold (optional) 
     * @param loadDateString (optional) 
     * @param isLineHaul (optional) 
     * @param isShowAllLocation (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getKPILaboratory(id: number | undefined, locationId: number | undefined, vehicleId: number | undefined, routeId: string | undefined, vehicleName: string | undefined, routeName: string | undefined, driverName: string | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filter: string | undefined, oSName: string | undefined, completion: boolean | undefined, routeIds: number[] | undefined, orderTypes: string[] | undefined, editionName: string | undefined, routeTypeIds: number[] | undefined, managerIds: number[] | undefined, viewTypes: string | undefined, locationIds: number[] | undefined, showEmptyRoute: boolean | undefined, threshold: number | undefined, loadDateString: string | undefined, isLineHaul: boolean | undefined, isShowAllLocation: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerKpiLaboratoryCountListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetKPILaboratory?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (oSName === null)
            throw new Error("The parameter 'oSName' cannot be null.");
        else if (oSName !== undefined)
            url_ += "OSName=" + encodeURIComponent("" + oSName) + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent("" + completion) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (orderTypes === null)
            throw new Error("The parameter 'orderTypes' cannot be null.");
        else if (orderTypes !== undefined)
            orderTypes && orderTypes.forEach(item => { url_ += "OrderTypes=" + encodeURIComponent("" + item) + "&"; });
        if (editionName === null)
            throw new Error("The parameter 'editionName' cannot be null.");
        else if (editionName !== undefined)
            url_ += "EditionName=" + encodeURIComponent("" + editionName) + "&"; 
        if (routeTypeIds === null)
            throw new Error("The parameter 'routeTypeIds' cannot be null.");
        else if (routeTypeIds !== undefined)
            routeTypeIds && routeTypeIds.forEach(item => { url_ += "RouteTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (managerIds === null)
            throw new Error("The parameter 'managerIds' cannot be null.");
        else if (managerIds !== undefined)
            managerIds && managerIds.forEach(item => { url_ += "ManagerIds=" + encodeURIComponent("" + item) + "&"; });
        if (viewTypes === null)
            throw new Error("The parameter 'viewTypes' cannot be null.");
        else if (viewTypes !== undefined)
            url_ += "ViewTypes=" + encodeURIComponent("" + viewTypes) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (showEmptyRoute === null)
            throw new Error("The parameter 'showEmptyRoute' cannot be null.");
        else if (showEmptyRoute !== undefined)
            url_ += "ShowEmptyRoute=" + encodeURIComponent("" + showEmptyRoute) + "&"; 
        if (threshold === null)
            throw new Error("The parameter 'threshold' cannot be null.");
        else if (threshold !== undefined)
            url_ += "Threshold=" + encodeURIComponent("" + threshold) + "&"; 
        if (loadDateString === null)
            throw new Error("The parameter 'loadDateString' cannot be null.");
        else if (loadDateString !== undefined)
            url_ += "LoadDateString=" + encodeURIComponent("" + loadDateString) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (isShowAllLocation === null)
            throw new Error("The parameter 'isShowAllLocation' cannot be null.");
        else if (isShowAllLocation !== undefined)
            url_ += "IsShowAllLocation=" + encodeURIComponent("" + isShowAllLocation) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetKPILaboratory(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetKPILaboratory(<any>response_);
                } catch (e) {
                    return <Observable<ControllerKpiLaboratoryCountListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerKpiLaboratoryCountListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetKPILaboratory(response: HttpResponseBase): Observable<ControllerKpiLaboratoryCountListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ControllerKpiLaboratoryCountListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerKpiLaboratoryCountListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param vehicleName (optional) 
     * @param routeName (optional) 
     * @param driverName (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filter (optional) 
     * @param oSName (optional) 
     * @param completion (optional) 
     * @param routeIds (optional) 
     * @param orderTypes (optional) 
     * @param editionName (optional) 
     * @param routeTypeIds (optional) 
     * @param managerIds (optional) 
     * @param viewTypes (optional) 
     * @param locationIds (optional) 
     * @param showEmptyRoute (optional) 
     * @param threshold (optional) 
     * @param loadDateString (optional) 
     * @param isLineHaul (optional) 
     * @param isShowAllLocation (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getKPICountLaboratoryListing(id: number | undefined, locationId: number | undefined, vehicleId: number | undefined, routeId: string | undefined, vehicleName: string | undefined, routeName: string | undefined, driverName: string | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filter: string | undefined, oSName: string | undefined, completion: boolean | undefined, routeIds: number[] | undefined, orderTypes: string[] | undefined, editionName: string | undefined, routeTypeIds: number[] | undefined, managerIds: number[] | undefined, viewTypes: string | undefined, locationIds: number[] | undefined, showEmptyRoute: boolean | undefined, threshold: number | undefined, loadDateString: string | undefined, isLineHaul: boolean | undefined, isShowAllLocation: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerKpiLaboratoryCountListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetKPICountLaboratoryListing?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (oSName === null)
            throw new Error("The parameter 'oSName' cannot be null.");
        else if (oSName !== undefined)
            url_ += "OSName=" + encodeURIComponent("" + oSName) + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent("" + completion) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (orderTypes === null)
            throw new Error("The parameter 'orderTypes' cannot be null.");
        else if (orderTypes !== undefined)
            orderTypes && orderTypes.forEach(item => { url_ += "OrderTypes=" + encodeURIComponent("" + item) + "&"; });
        if (editionName === null)
            throw new Error("The parameter 'editionName' cannot be null.");
        else if (editionName !== undefined)
            url_ += "EditionName=" + encodeURIComponent("" + editionName) + "&"; 
        if (routeTypeIds === null)
            throw new Error("The parameter 'routeTypeIds' cannot be null.");
        else if (routeTypeIds !== undefined)
            routeTypeIds && routeTypeIds.forEach(item => { url_ += "RouteTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (managerIds === null)
            throw new Error("The parameter 'managerIds' cannot be null.");
        else if (managerIds !== undefined)
            managerIds && managerIds.forEach(item => { url_ += "ManagerIds=" + encodeURIComponent("" + item) + "&"; });
        if (viewTypes === null)
            throw new Error("The parameter 'viewTypes' cannot be null.");
        else if (viewTypes !== undefined)
            url_ += "ViewTypes=" + encodeURIComponent("" + viewTypes) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (showEmptyRoute === null)
            throw new Error("The parameter 'showEmptyRoute' cannot be null.");
        else if (showEmptyRoute !== undefined)
            url_ += "ShowEmptyRoute=" + encodeURIComponent("" + showEmptyRoute) + "&"; 
        if (threshold === null)
            throw new Error("The parameter 'threshold' cannot be null.");
        else if (threshold !== undefined)
            url_ += "Threshold=" + encodeURIComponent("" + threshold) + "&"; 
        if (loadDateString === null)
            throw new Error("The parameter 'loadDateString' cannot be null.");
        else if (loadDateString !== undefined)
            url_ += "LoadDateString=" + encodeURIComponent("" + loadDateString) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (isShowAllLocation === null)
            throw new Error("The parameter 'isShowAllLocation' cannot be null.");
        else if (isShowAllLocation !== undefined)
            url_ += "IsShowAllLocation=" + encodeURIComponent("" + isShowAllLocation) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetKPICountLaboratoryListing(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetKPICountLaboratoryListing(<any>response_);
                } catch (e) {
                    return <Observable<ControllerKpiLaboratoryCountListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerKpiLaboratoryCountListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetKPICountLaboratoryListing(response: HttpResponseBase): Observable<ControllerKpiLaboratoryCountListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerKpiLaboratoryCountListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerKpiLaboratoryCountListDto[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param vehicleName (optional) 
     * @param routeName (optional) 
     * @param driverName (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filter (optional) 
     * @param oSName (optional) 
     * @param completion (optional) 
     * @param routeIds (optional) 
     * @param orderTypes (optional) 
     * @param editionName (optional) 
     * @param routeTypeIds (optional) 
     * @param managerIds (optional) 
     * @param viewTypes (optional) 
     * @param locationIds (optional) 
     * @param showEmptyRoute (optional) 
     * @param threshold (optional) 
     * @param loadDateString (optional) 
     * @param isLineHaul (optional) 
     * @param isShowAllLocation (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getKPICountLab(id: number | undefined, locationId: number | undefined, vehicleId: number | undefined, routeId: string | undefined, vehicleName: string | undefined, routeName: string | undefined, driverName: string | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filter: string | undefined, oSName: string | undefined, completion: boolean | undefined, routeIds: number[] | undefined, orderTypes: string[] | undefined, editionName: string | undefined, routeTypeIds: number[] | undefined, managerIds: number[] | undefined, viewTypes: string | undefined, locationIds: number[] | undefined, showEmptyRoute: boolean | undefined, threshold: number | undefined, loadDateString: string | undefined, isLineHaul: boolean | undefined, isShowAllLocation: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerKpiLaboratoryCountListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetKPICountLab?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (oSName === null)
            throw new Error("The parameter 'oSName' cannot be null.");
        else if (oSName !== undefined)
            url_ += "OSName=" + encodeURIComponent("" + oSName) + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent("" + completion) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (orderTypes === null)
            throw new Error("The parameter 'orderTypes' cannot be null.");
        else if (orderTypes !== undefined)
            orderTypes && orderTypes.forEach(item => { url_ += "OrderTypes=" + encodeURIComponent("" + item) + "&"; });
        if (editionName === null)
            throw new Error("The parameter 'editionName' cannot be null.");
        else if (editionName !== undefined)
            url_ += "EditionName=" + encodeURIComponent("" + editionName) + "&"; 
        if (routeTypeIds === null)
            throw new Error("The parameter 'routeTypeIds' cannot be null.");
        else if (routeTypeIds !== undefined)
            routeTypeIds && routeTypeIds.forEach(item => { url_ += "RouteTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (managerIds === null)
            throw new Error("The parameter 'managerIds' cannot be null.");
        else if (managerIds !== undefined)
            managerIds && managerIds.forEach(item => { url_ += "ManagerIds=" + encodeURIComponent("" + item) + "&"; });
        if (viewTypes === null)
            throw new Error("The parameter 'viewTypes' cannot be null.");
        else if (viewTypes !== undefined)
            url_ += "ViewTypes=" + encodeURIComponent("" + viewTypes) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (showEmptyRoute === null)
            throw new Error("The parameter 'showEmptyRoute' cannot be null.");
        else if (showEmptyRoute !== undefined)
            url_ += "ShowEmptyRoute=" + encodeURIComponent("" + showEmptyRoute) + "&"; 
        if (threshold === null)
            throw new Error("The parameter 'threshold' cannot be null.");
        else if (threshold !== undefined)
            url_ += "Threshold=" + encodeURIComponent("" + threshold) + "&"; 
        if (loadDateString === null)
            throw new Error("The parameter 'loadDateString' cannot be null.");
        else if (loadDateString !== undefined)
            url_ += "LoadDateString=" + encodeURIComponent("" + loadDateString) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (isShowAllLocation === null)
            throw new Error("The parameter 'isShowAllLocation' cannot be null.");
        else if (isShowAllLocation !== undefined)
            url_ += "IsShowAllLocation=" + encodeURIComponent("" + isShowAllLocation) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetKPICountLab(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetKPICountLab(<any>response_);
                } catch (e) {
                    return <Observable<ControllerKpiLaboratoryCountListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerKpiLaboratoryCountListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetKPICountLab(response: HttpResponseBase): Observable<ControllerKpiLaboratoryCountListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ControllerKpiLaboratoryCountListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerKpiLaboratoryCountListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param vehicleName (optional) 
     * @param routeName (optional) 
     * @param driverName (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filter (optional) 
     * @param oSName (optional) 
     * @param completion (optional) 
     * @param routeIds (optional) 
     * @param orderTypes (optional) 
     * @param editionName (optional) 
     * @param routeTypeIds (optional) 
     * @param managerIds (optional) 
     * @param viewTypes (optional) 
     * @param locationIds (optional) 
     * @param showEmptyRoute (optional) 
     * @param threshold (optional) 
     * @param loadDateString (optional) 
     * @param isLineHaul (optional) 
     * @param isShowAllLocation (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getKPICountLaboratory(id: number | undefined, locationId: number | undefined, vehicleId: number | undefined, routeId: string | undefined, vehicleName: string | undefined, routeName: string | undefined, driverName: string | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filter: string | undefined, oSName: string | undefined, completion: boolean | undefined, routeIds: number[] | undefined, orderTypes: string[] | undefined, editionName: string | undefined, routeTypeIds: number[] | undefined, managerIds: number[] | undefined, viewTypes: string | undefined, locationIds: number[] | undefined, showEmptyRoute: boolean | undefined, threshold: number | undefined, loadDateString: string | undefined, isLineHaul: boolean | undefined, isShowAllLocation: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerKpiLaboratoryCountListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerKpiCount/GetKPICountLaboratory?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (oSName === null)
            throw new Error("The parameter 'oSName' cannot be null.");
        else if (oSName !== undefined)
            url_ += "OSName=" + encodeURIComponent("" + oSName) + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent("" + completion) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (orderTypes === null)
            throw new Error("The parameter 'orderTypes' cannot be null.");
        else if (orderTypes !== undefined)
            orderTypes && orderTypes.forEach(item => { url_ += "OrderTypes=" + encodeURIComponent("" + item) + "&"; });
        if (editionName === null)
            throw new Error("The parameter 'editionName' cannot be null.");
        else if (editionName !== undefined)
            url_ += "EditionName=" + encodeURIComponent("" + editionName) + "&"; 
        if (routeTypeIds === null)
            throw new Error("The parameter 'routeTypeIds' cannot be null.");
        else if (routeTypeIds !== undefined)
            routeTypeIds && routeTypeIds.forEach(item => { url_ += "RouteTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (managerIds === null)
            throw new Error("The parameter 'managerIds' cannot be null.");
        else if (managerIds !== undefined)
            managerIds && managerIds.forEach(item => { url_ += "ManagerIds=" + encodeURIComponent("" + item) + "&"; });
        if (viewTypes === null)
            throw new Error("The parameter 'viewTypes' cannot be null.");
        else if (viewTypes !== undefined)
            url_ += "ViewTypes=" + encodeURIComponent("" + viewTypes) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (showEmptyRoute === null)
            throw new Error("The parameter 'showEmptyRoute' cannot be null.");
        else if (showEmptyRoute !== undefined)
            url_ += "ShowEmptyRoute=" + encodeURIComponent("" + showEmptyRoute) + "&"; 
        if (threshold === null)
            throw new Error("The parameter 'threshold' cannot be null.");
        else if (threshold !== undefined)
            url_ += "Threshold=" + encodeURIComponent("" + threshold) + "&"; 
        if (loadDateString === null)
            throw new Error("The parameter 'loadDateString' cannot be null.");
        else if (loadDateString !== undefined)
            url_ += "LoadDateString=" + encodeURIComponent("" + loadDateString) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (isShowAllLocation === null)
            throw new Error("The parameter 'isShowAllLocation' cannot be null.");
        else if (isShowAllLocation !== undefined)
            url_ += "IsShowAllLocation=" + encodeURIComponent("" + isShowAllLocation) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetKPICountLaboratory(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetKPICountLaboratory(<any>response_);
                } catch (e) {
                    return <Observable<ControllerKpiLaboratoryCountListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerKpiLaboratoryCountListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetKPICountLaboratory(response: HttpResponseBase): Observable<ControllerKpiLaboratoryCountListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerKpiLaboratoryCountListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerKpiLaboratoryCountListDto[]>(<any>null);
    }
}

@Injectable()
export class ControllerOrderPackagesListServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param statusCode (optional) 
     * @param orderPackageId (optional) 
     * @param orderId (optional) 
     * @param orderIds (optional) 
     * @param locationId (optional) 
     * @param packageId (optional) 
     * @param orderStatusTypeId (optional) 
     * @param orderTag (optional) 
     * @param accountNumber (optional) 
     * @param loadDate (optional) 
     * @param loadDateEnd (optional) 
     * @param unassigned (optional) 
     * @param willCalls (optional) 
     * @param timeZoneInfo (optional) 
     * @param customer (optional) 
     * @param address (optional) 
     * @param statusType (optional) 
     * @param orderTypeId (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getControllerOrderPackagesGroupList(filter: string | undefined, statusCode: string | undefined, orderPackageId: number | undefined, orderId: number | undefined, orderIds: number[] | undefined, locationId: number | undefined, packageId: number | undefined, orderStatusTypeId: number | undefined, orderTag: string | undefined, accountNumber: number | undefined, loadDate: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, unassigned: boolean | undefined, willCalls: boolean | undefined, timeZoneInfo: string | undefined, customer: string | undefined, address: string | undefined, statusType: string | undefined, orderTypeId: number | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfgroupOrderPackagesTab> {
        let url_ = this.baseUrl + "/api/services/app/ControllerOrderPackagesList/GetControllerOrderPackagesGroupList?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (statusCode === null)
            throw new Error("The parameter 'statusCode' cannot be null.");
        else if (statusCode !== undefined)
            url_ += "StatusCode=" + encodeURIComponent("" + statusCode) + "&"; 
        if (orderPackageId === null)
            throw new Error("The parameter 'orderPackageId' cannot be null.");
        else if (orderPackageId !== undefined)
            url_ += "OrderPackageId=" + encodeURIComponent("" + orderPackageId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (orderIds === null)
            throw new Error("The parameter 'orderIds' cannot be null.");
        else if (orderIds !== undefined)
            orderIds && orderIds.forEach(item => { url_ += "OrderIds=" + encodeURIComponent("" + item) + "&"; });
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (packageId === null)
            throw new Error("The parameter 'packageId' cannot be null.");
        else if (packageId !== undefined)
            url_ += "PackageId=" + encodeURIComponent("" + packageId) + "&"; 
        if (orderStatusTypeId === null)
            throw new Error("The parameter 'orderStatusTypeId' cannot be null.");
        else if (orderStatusTypeId !== undefined)
            url_ += "OrderStatusTypeId=" + encodeURIComponent("" + orderStatusTypeId) + "&"; 
        if (orderTag === null)
            throw new Error("The parameter 'orderTag' cannot be null.");
        else if (orderTag !== undefined)
            url_ += "OrderTag=" + encodeURIComponent("" + orderTag) + "&"; 
        if (accountNumber === null)
            throw new Error("The parameter 'accountNumber' cannot be null.");
        else if (accountNumber !== undefined)
            url_ += "AccountNumber=" + encodeURIComponent("" + accountNumber) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (unassigned === null)
            throw new Error("The parameter 'unassigned' cannot be null.");
        else if (unassigned !== undefined)
            url_ += "Unassigned=" + encodeURIComponent("" + unassigned) + "&"; 
        if (willCalls === null)
            throw new Error("The parameter 'willCalls' cannot be null.");
        else if (willCalls !== undefined)
            url_ += "WillCalls=" + encodeURIComponent("" + willCalls) + "&"; 
        if (timeZoneInfo === null)
            throw new Error("The parameter 'timeZoneInfo' cannot be null.");
        else if (timeZoneInfo !== undefined)
            url_ += "TimeZoneInfo=" + encodeURIComponent("" + timeZoneInfo) + "&"; 
        if (customer === null)
            throw new Error("The parameter 'customer' cannot be null.");
        else if (customer !== undefined)
            url_ += "Customer=" + encodeURIComponent("" + customer) + "&"; 
        if (address === null)
            throw new Error("The parameter 'address' cannot be null.");
        else if (address !== undefined)
            url_ += "Address=" + encodeURIComponent("" + address) + "&"; 
        if (statusType === null)
            throw new Error("The parameter 'statusType' cannot be null.");
        else if (statusType !== undefined)
            url_ += "StatusType=" + encodeURIComponent("" + statusType) + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "orderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerOrderPackagesGroupList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerOrderPackagesGroupList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfgroupOrderPackagesTab>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfgroupOrderPackagesTab>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerOrderPackagesGroupList(response: HttpResponseBase): Observable<PagedResultDtoOfgroupOrderPackagesTab> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfgroupOrderPackagesTab.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfgroupOrderPackagesTab>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param statusCode (optional) 
     * @param orderPackageId (optional) 
     * @param orderId (optional) 
     * @param orderIds (optional) 
     * @param locationId (optional) 
     * @param packageId (optional) 
     * @param orderStatusTypeId (optional) 
     * @param orderTag (optional) 
     * @param accountNumber (optional) 
     * @param loadDate (optional) 
     * @param loadDateEnd (optional) 
     * @param unassigned (optional) 
     * @param willCalls (optional) 
     * @param timeZoneInfo (optional) 
     * @param customer (optional) 
     * @param address (optional) 
     * @param statusType (optional) 
     * @param orderTypeId (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getControllerOrderPackagesList(filter: string | undefined, statusCode: string | undefined, orderPackageId: number | undefined, orderId: number | undefined, orderIds: number[] | undefined, locationId: number | undefined, packageId: number | undefined, orderStatusTypeId: number | undefined, orderTag: string | undefined, accountNumber: number | undefined, loadDate: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, unassigned: boolean | undefined, willCalls: boolean | undefined, timeZoneInfo: string | undefined, customer: string | undefined, address: string | undefined, statusType: string | undefined, orderTypeId: number | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetControllerOrderPackagesListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerOrderPackagesList/GetControllerOrderPackagesList?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (statusCode === null)
            throw new Error("The parameter 'statusCode' cannot be null.");
        else if (statusCode !== undefined)
            url_ += "StatusCode=" + encodeURIComponent("" + statusCode) + "&"; 
        if (orderPackageId === null)
            throw new Error("The parameter 'orderPackageId' cannot be null.");
        else if (orderPackageId !== undefined)
            url_ += "OrderPackageId=" + encodeURIComponent("" + orderPackageId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (orderIds === null)
            throw new Error("The parameter 'orderIds' cannot be null.");
        else if (orderIds !== undefined)
            orderIds && orderIds.forEach(item => { url_ += "OrderIds=" + encodeURIComponent("" + item) + "&"; });
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (packageId === null)
            throw new Error("The parameter 'packageId' cannot be null.");
        else if (packageId !== undefined)
            url_ += "PackageId=" + encodeURIComponent("" + packageId) + "&"; 
        if (orderStatusTypeId === null)
            throw new Error("The parameter 'orderStatusTypeId' cannot be null.");
        else if (orderStatusTypeId !== undefined)
            url_ += "OrderStatusTypeId=" + encodeURIComponent("" + orderStatusTypeId) + "&"; 
        if (orderTag === null)
            throw new Error("The parameter 'orderTag' cannot be null.");
        else if (orderTag !== undefined)
            url_ += "OrderTag=" + encodeURIComponent("" + orderTag) + "&"; 
        if (accountNumber === null)
            throw new Error("The parameter 'accountNumber' cannot be null.");
        else if (accountNumber !== undefined)
            url_ += "AccountNumber=" + encodeURIComponent("" + accountNumber) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (unassigned === null)
            throw new Error("The parameter 'unassigned' cannot be null.");
        else if (unassigned !== undefined)
            url_ += "Unassigned=" + encodeURIComponent("" + unassigned) + "&"; 
        if (willCalls === null)
            throw new Error("The parameter 'willCalls' cannot be null.");
        else if (willCalls !== undefined)
            url_ += "WillCalls=" + encodeURIComponent("" + willCalls) + "&"; 
        if (timeZoneInfo === null)
            throw new Error("The parameter 'timeZoneInfo' cannot be null.");
        else if (timeZoneInfo !== undefined)
            url_ += "TimeZoneInfo=" + encodeURIComponent("" + timeZoneInfo) + "&"; 
        if (customer === null)
            throw new Error("The parameter 'customer' cannot be null.");
        else if (customer !== undefined)
            url_ += "Customer=" + encodeURIComponent("" + customer) + "&"; 
        if (address === null)
            throw new Error("The parameter 'address' cannot be null.");
        else if (address !== undefined)
            url_ += "Address=" + encodeURIComponent("" + address) + "&"; 
        if (statusType === null)
            throw new Error("The parameter 'statusType' cannot be null.");
        else if (statusType !== undefined)
            url_ += "StatusType=" + encodeURIComponent("" + statusType) + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "orderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerOrderPackagesList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerOrderPackagesList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetControllerOrderPackagesListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetControllerOrderPackagesListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerOrderPackagesList(response: HttpResponseBase): Observable<PagedResultDtoOfGetControllerOrderPackagesListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetControllerOrderPackagesListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetControllerOrderPackagesListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    showOrderPackagesList(body: GetControllerOrderPackagesListInput | undefined): Observable<PagedResultDtoOfGetControllerOrderPackagesListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerOrderPackagesList/ShowOrderPackagesList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processShowOrderPackagesList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processShowOrderPackagesList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetControllerOrderPackagesListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetControllerOrderPackagesListDto>><any>_observableThrow(response_);
        }));
    }

    protected processShowOrderPackagesList(response: HttpResponseBase): Observable<PagedResultDtoOfGetControllerOrderPackagesListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetControllerOrderPackagesListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetControllerOrderPackagesListDto>(<any>null);
    }

    /**
     * @param orderPackageId (optional) 
     * @param timeZoneInfo (optional) 
     * @return Success
     */
    getControllerOrderPackageDetails(orderPackageId: number | undefined, timeZoneInfo: string | undefined): Observable<GetControllerOrderPackagesListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerOrderPackagesList/GetControllerOrderPackageDetails?";
        if (orderPackageId === null)
            throw new Error("The parameter 'orderPackageId' cannot be null.");
        else if (orderPackageId !== undefined)
            url_ += "OrderPackageId=" + encodeURIComponent("" + orderPackageId) + "&"; 
        if (timeZoneInfo === null)
            throw new Error("The parameter 'timeZoneInfo' cannot be null.");
        else if (timeZoneInfo !== undefined)
            url_ += "TimeZoneInfo=" + encodeURIComponent("" + timeZoneInfo) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerOrderPackageDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerOrderPackageDetails(<any>response_);
                } catch (e) {
                    return <Observable<GetControllerOrderPackagesListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetControllerOrderPackagesListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerOrderPackageDetails(response: HttpResponseBase): Observable<GetControllerOrderPackagesListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetControllerOrderPackagesListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetControllerOrderPackagesListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderPackageOrderStatus(body: CreateOrderStatusInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerOrderPackagesList/CreateOrderPackageOrderStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderPackageOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderPackageOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderPackageOrderStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderStatusTypeList(): Observable<ListResultDtoOfOrderStatusTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerOrderPackagesList/GetOrderStatusTypeList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusTypeList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusTypeList(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfOrderStatusTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfOrderStatusTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusTypeList(response: HttpResponseBase): Observable<ListResultDtoOfOrderStatusTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfOrderStatusTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfOrderStatusTypeListDto>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderDescriptionList(): Observable<ListResultDtoOfOrderStatusDescriptionListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerOrderPackagesList/GetOrderDescriptionList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderDescriptionList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderDescriptionList(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfOrderStatusDescriptionListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfOrderStatusDescriptionListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderDescriptionList(response: HttpResponseBase): Observable<ListResultDtoOfOrderStatusDescriptionListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfOrderStatusDescriptionListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfOrderStatusDescriptionListDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getOrderStatusTotalCount(orderId: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ControllerOrderPackagesList/GetOrderStatusTotalCount?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusTotalCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusTotalCount(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusTotalCount(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createBatchOrderStatus(body: AddBatchOrderStatusInput | undefined): Observable<CreateBatchResultOutput> {
        let url_ = this.baseUrl + "/api/services/app/ControllerOrderPackagesList/CreateBatchOrderStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateBatchOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateBatchOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<CreateBatchResultOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateBatchResultOutput>><any>_observableThrow(response_);
        }));
    }

    protected processCreateBatchOrderStatus(response: HttpResponseBase): Observable<CreateBatchResultOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateBatchResultOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateBatchResultOutput>(<any>null);
    }
}

@Injectable()
export class ControllerPrintRouteSheetServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param locationId (optional) 
     * @param loadDate (optional) 
     * @param routeIds (optional) 
     * @return Success
     */
    getRouteSheetToExcel(locationId: number | undefined, loadDate: moment.Moment | undefined, routeIds: number[] | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerPrintRouteSheet/GetRouteSheetToExcel?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "locationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteSheetToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteSheetToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteSheetToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @return Success
     */
    getPrintRoute(routeIds: number[] | undefined): Observable<ControllerRoutePrintAllDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerPrintRouteSheet/GetPrintRoute?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPrintRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPrintRoute(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRoutePrintAllDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRoutePrintAllDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetPrintRoute(response: HttpResponseBase): Observable<ControllerRoutePrintAllDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRoutePrintAllDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRoutePrintAllDto[]>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @return Success
     */
    getPrintRouteSheet(routeIds: number[] | undefined): Observable<ControllerRouteSheetDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerPrintRouteSheet/GetPrintRouteSheet?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPrintRouteSheet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPrintRouteSheet(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteSheetDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteSheetDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetPrintRouteSheet(response: HttpResponseBase): Observable<ControllerRouteSheetDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRouteSheetDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteSheetDto[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param loadDate (optional) 
     * @param routeIds (optional) 
     * @return Success
     */
    getRouteSheetLab(locationId: number | undefined, loadDate: moment.Moment | undefined, routeIds: number[] | undefined): Observable<RouteSheetList[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerPrintRouteSheet/GetRouteSheetLab?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "locationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteSheetLab(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteSheetLab(<any>response_);
                } catch (e) {
                    return <Observable<RouteSheetList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteSheetList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteSheetLab(response: HttpResponseBase): Observable<RouteSheetList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteSheetList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteSheetList[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param loadDate (optional) 
     * @param routeIds (optional) 
     * @return Success
     */
    getRouteSheet(locationId: number | undefined, loadDate: moment.Moment | undefined, routeIds: number[] | undefined): Observable<RouteSheetList[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerPrintRouteSheet/GetRouteSheet?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "locationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteSheet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteSheet(<any>response_);
                } catch (e) {
                    return <Observable<RouteSheetList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteSheetList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteSheet(response: HttpResponseBase): Observable<RouteSheetList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteSheetList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteSheetList[]>(<any>null);
    }
}

@Injectable()
export class ControllerRemainingPickupServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param locationId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRemainingPickup(locationId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfControllerRemainingPickupListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRemainingPickup/GetRemainingPickup?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRemainingPickup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRemainingPickup(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfControllerRemainingPickupListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfControllerRemainingPickupListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRemainingPickup(response: HttpResponseBase): Observable<PagedResultDtoOfControllerRemainingPickupListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfControllerRemainingPickupListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfControllerRemainingPickupListDto>(<any>null);
    }
}

@Injectable()
export class ControllerRouteServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    mobileLogs(body: GetControllerMobileInput | undefined): Observable<ControllerMobileListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/MobileLogs";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMobileLogs(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMobileLogs(<any>response_);
                } catch (e) {
                    return <Observable<ControllerMobileListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerMobileListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processMobileLogs(response: HttpResponseBase): Observable<ControllerMobileListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerMobileListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerMobileListDto[]>(<any>null);
    }

    /**
     * @param freeze (optional) 
     * @param id (optional) 
     * @return Success
     */
    updateFreeze(freeze: boolean | undefined, id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/UpdateFreeze?";
        if (freeze === null)
            throw new Error("The parameter 'freeze' cannot be null.");
        else if (freeze !== undefined)
            url_ += "freeze=" + encodeURIComponent("" + freeze) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateFreeze(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateFreeze(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateFreeze(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getManagers(): Observable<GetManagerResult[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetManagers";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetManagers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetManagers(<any>response_);
                } catch (e) {
                    return <Observable<GetManagerResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetManagerResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetManagers(response: HttpResponseBase): Observable<GetManagerResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetManagerResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetManagerResult[]>(<any>null);
    }

    /**
     * @param route (optional) 
     * @return Success
     */
    getClinicEmail(route: string | undefined): Observable<string[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetClinicEmail?";
        if (route === null)
            throw new Error("The parameter 'route' cannot be null.");
        else if (route !== undefined)
            url_ += "route=" + encodeURIComponent("" + route) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicEmail(<any>response_);
                } catch (e) {
                    return <Observable<string[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<string[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicEmail(response: HttpResponseBase): Observable<string[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string[]>(<any>null);
    }

    /**
     * @param reason (optional) 
     * @param id (optional) 
     * @param route (optional) 
     * @param adj (optional) 
     * @return Success
     */
    unfreeze(reason: string | undefined, id: number | undefined, route: string | undefined, adj: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/Unfreeze?";
        if (reason === null)
            throw new Error("The parameter 'reason' cannot be null.");
        else if (reason !== undefined)
            url_ += "reason=" + encodeURIComponent("" + reason) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        if (route === null)
            throw new Error("The parameter 'route' cannot be null.");
        else if (route !== undefined)
            url_ += "route=" + encodeURIComponent("" + route) + "&"; 
        if (adj === null)
            throw new Error("The parameter 'adj' cannot be null.");
        else if (adj !== undefined)
            url_ += "adj=" + encodeURIComponent("" + adj) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnfreeze(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnfreeze(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnfreeze(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getUnFreezeReason(id: number | undefined): Observable<RouteFreezeListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetUnFreezeReason?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUnFreezeReason(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUnFreezeReason(<any>response_);
                } catch (e) {
                    return <Observable<RouteFreezeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteFreezeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUnFreezeReason(response: HttpResponseBase): Observable<RouteFreezeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = RouteFreezeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteFreezeListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    mobileLogs2(body: GetControllerMobileInput | undefined): Observable<ControllerMobileListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/MobileLogs2";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMobileLogs2(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMobileLogs2(<any>response_);
                } catch (e) {
                    return <Observable<ControllerMobileListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerMobileListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processMobileLogs2(response: HttpResponseBase): Observable<ControllerMobileListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerMobileListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerMobileListDto[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getBranchTime(id: number | undefined, locationId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetBranchTime?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetBranchTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetBranchTime(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetBranchTime(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param vehicleName (optional) 
     * @param routeName (optional) 
     * @param driverName (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filter (optional) 
     * @param oSName (optional) 
     * @param completion (optional) 
     * @param routeIds (optional) 
     * @param orderTypes (optional) 
     * @param editionName (optional) 
     * @param routeTypeIds (optional) 
     * @param managerIds (optional) 
     * @param viewTypes (optional) 
     * @param locationIds (optional) 
     * @param showEmptyRoute (optional) 
     * @param threshold (optional) 
     * @param loadDateString (optional) 
     * @param isLineHaul (optional) 
     * @param isShowAllLocation (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDispatchList(id: number | undefined, locationId: number | undefined, vehicleId: number | undefined, routeId: string | undefined, vehicleName: string | undefined, routeName: string | undefined, driverName: string | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filter: string | undefined, oSName: string | undefined, completion: boolean | undefined, routeIds: number[] | undefined, orderTypes: string[] | undefined, editionName: string | undefined, routeTypeIds: number[] | undefined, managerIds: number[] | undefined, viewTypes: string | undefined, locationIds: number[] | undefined, showEmptyRoute: boolean | undefined, threshold: number | undefined, loadDateString: string | undefined, isLineHaul: boolean | undefined, isShowAllLocation: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerRouteListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetDispatchList?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (oSName === null)
            throw new Error("The parameter 'oSName' cannot be null.");
        else if (oSName !== undefined)
            url_ += "OSName=" + encodeURIComponent("" + oSName) + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent("" + completion) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (orderTypes === null)
            throw new Error("The parameter 'orderTypes' cannot be null.");
        else if (orderTypes !== undefined)
            orderTypes && orderTypes.forEach(item => { url_ += "OrderTypes=" + encodeURIComponent("" + item) + "&"; });
        if (editionName === null)
            throw new Error("The parameter 'editionName' cannot be null.");
        else if (editionName !== undefined)
            url_ += "EditionName=" + encodeURIComponent("" + editionName) + "&"; 
        if (routeTypeIds === null)
            throw new Error("The parameter 'routeTypeIds' cannot be null.");
        else if (routeTypeIds !== undefined)
            routeTypeIds && routeTypeIds.forEach(item => { url_ += "RouteTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (managerIds === null)
            throw new Error("The parameter 'managerIds' cannot be null.");
        else if (managerIds !== undefined)
            managerIds && managerIds.forEach(item => { url_ += "ManagerIds=" + encodeURIComponent("" + item) + "&"; });
        if (viewTypes === null)
            throw new Error("The parameter 'viewTypes' cannot be null.");
        else if (viewTypes !== undefined)
            url_ += "ViewTypes=" + encodeURIComponent("" + viewTypes) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (showEmptyRoute === null)
            throw new Error("The parameter 'showEmptyRoute' cannot be null.");
        else if (showEmptyRoute !== undefined)
            url_ += "ShowEmptyRoute=" + encodeURIComponent("" + showEmptyRoute) + "&"; 
        if (threshold === null)
            throw new Error("The parameter 'threshold' cannot be null.");
        else if (threshold !== undefined)
            url_ += "Threshold=" + encodeURIComponent("" + threshold) + "&"; 
        if (loadDateString === null)
            throw new Error("The parameter 'loadDateString' cannot be null.");
        else if (loadDateString !== undefined)
            url_ += "LoadDateString=" + encodeURIComponent("" + loadDateString) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (isShowAllLocation === null)
            throw new Error("The parameter 'isShowAllLocation' cannot be null.");
        else if (isShowAllLocation !== undefined)
            url_ += "IsShowAllLocation=" + encodeURIComponent("" + isShowAllLocation) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDispatchList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDispatchList(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDispatchList(response: HttpResponseBase): Observable<ControllerRouteListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRouteListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    closedRoutes(body: CloseRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/ClosedRoutes";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processClosedRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processClosedRoutes(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processClosedRoutes(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    deleteRouteDestinations(routeId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/DeleteRouteDestinations?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRouteDestinations(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRouteDestinations(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRouteDestinations(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param vehicleName (optional) 
     * @param routeName (optional) 
     * @param driverName (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filter (optional) 
     * @param oSName (optional) 
     * @param completion (optional) 
     * @param routeIds (optional) 
     * @param orderTypes (optional) 
     * @param editionName (optional) 
     * @param routeTypeIds (optional) 
     * @param managerIds (optional) 
     * @param viewTypes (optional) 
     * @param locationIds (optional) 
     * @param showEmptyRoute (optional) 
     * @param threshold (optional) 
     * @param loadDateString (optional) 
     * @param isLineHaul (optional) 
     * @param isShowAllLocation (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDispatchGroupList(id: number | undefined, locationId: number | undefined, vehicleId: number | undefined, routeId: string | undefined, vehicleName: string | undefined, routeName: string | undefined, driverName: string | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filter: string | undefined, oSName: string | undefined, completion: boolean | undefined, routeIds: number[] | undefined, orderTypes: string[] | undefined, editionName: string | undefined, routeTypeIds: number[] | undefined, managerIds: number[] | undefined, viewTypes: string | undefined, locationIds: number[] | undefined, showEmptyRoute: boolean | undefined, threshold: number | undefined, loadDateString: string | undefined, isLineHaul: boolean | undefined, isShowAllLocation: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ControllerRouteTypeListGroupDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetDispatchGroupList?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (oSName === null)
            throw new Error("The parameter 'oSName' cannot be null.");
        else if (oSName !== undefined)
            url_ += "OSName=" + encodeURIComponent("" + oSName) + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent("" + completion) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (orderTypes === null)
            throw new Error("The parameter 'orderTypes' cannot be null.");
        else if (orderTypes !== undefined)
            orderTypes && orderTypes.forEach(item => { url_ += "OrderTypes=" + encodeURIComponent("" + item) + "&"; });
        if (editionName === null)
            throw new Error("The parameter 'editionName' cannot be null.");
        else if (editionName !== undefined)
            url_ += "EditionName=" + encodeURIComponent("" + editionName) + "&"; 
        if (routeTypeIds === null)
            throw new Error("The parameter 'routeTypeIds' cannot be null.");
        else if (routeTypeIds !== undefined)
            routeTypeIds && routeTypeIds.forEach(item => { url_ += "RouteTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (managerIds === null)
            throw new Error("The parameter 'managerIds' cannot be null.");
        else if (managerIds !== undefined)
            managerIds && managerIds.forEach(item => { url_ += "ManagerIds=" + encodeURIComponent("" + item) + "&"; });
        if (viewTypes === null)
            throw new Error("The parameter 'viewTypes' cannot be null.");
        else if (viewTypes !== undefined)
            url_ += "ViewTypes=" + encodeURIComponent("" + viewTypes) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (showEmptyRoute === null)
            throw new Error("The parameter 'showEmptyRoute' cannot be null.");
        else if (showEmptyRoute !== undefined)
            url_ += "ShowEmptyRoute=" + encodeURIComponent("" + showEmptyRoute) + "&"; 
        if (threshold === null)
            throw new Error("The parameter 'threshold' cannot be null.");
        else if (threshold !== undefined)
            url_ += "Threshold=" + encodeURIComponent("" + threshold) + "&"; 
        if (loadDateString === null)
            throw new Error("The parameter 'loadDateString' cannot be null.");
        else if (loadDateString !== undefined)
            url_ += "LoadDateString=" + encodeURIComponent("" + loadDateString) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (isShowAllLocation === null)
            throw new Error("The parameter 'isShowAllLocation' cannot be null.");
        else if (isShowAllLocation !== undefined)
            url_ += "IsShowAllLocation=" + encodeURIComponent("" + isShowAllLocation) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDispatchGroupList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDispatchGroupList(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteTypeListGroupDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteTypeListGroupDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDispatchGroupList(response: HttpResponseBase): Observable<ControllerRouteTypeListGroupDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRouteTypeListGroupDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteTypeListGroupDto[]>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @param editions (optional) 
     * @param filterTypes (optional) 
     * @return Success
     */
    getDetails(routeIds: number[] | undefined, editions: string | undefined, filterTypes: string | undefined): Observable<ControllerRouteStatusDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetDetails?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (editions === null)
            throw new Error("The parameter 'editions' cannot be null.");
        else if (editions !== undefined)
            url_ += "Editions=" + encodeURIComponent("" + editions) + "&"; 
        if (filterTypes === null)
            throw new Error("The parameter 'filterTypes' cannot be null.");
        else if (filterTypes !== undefined)
            url_ += "FilterTypes=" + encodeURIComponent("" + filterTypes) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDetails(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteStatusDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteStatusDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDetails(response: HttpResponseBase): Observable<ControllerRouteStatusDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRouteStatusDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteStatusDto[]>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @param editions (optional) 
     * @param filterTypes (optional) 
     * @return Success
     */
    getProximityCodes(routeIds: number[] | undefined, editions: string | undefined, filterTypes: string | undefined): Observable<ControllerProximity> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetProximityCodes?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (editions === null)
            throw new Error("The parameter 'editions' cannot be null.");
        else if (editions !== undefined)
            url_ += "Editions=" + encodeURIComponent("" + editions) + "&"; 
        if (filterTypes === null)
            throw new Error("The parameter 'filterTypes' cannot be null.");
        else if (filterTypes !== undefined)
            url_ += "FilterTypes=" + encodeURIComponent("" + filterTypes) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetProximityCodes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetProximityCodes(<any>response_);
                } catch (e) {
                    return <Observable<ControllerProximity>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerProximity>><any>_observableThrow(response_);
        }));
    }

    protected processGetProximityCodes(response: HttpResponseBase): Observable<ControllerProximity> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ControllerProximity.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerProximity>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @param editions (optional) 
     * @param filterTypes (optional) 
     * @return Success
     */
    getCountRouteDetails(routeIds: number[] | undefined, editions: string | undefined, filterTypes: string | undefined): Observable<ControllerRouteCountsLaboratoryEditionDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetCountRouteDetails?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (editions === null)
            throw new Error("The parameter 'editions' cannot be null.");
        else if (editions !== undefined)
            url_ += "Editions=" + encodeURIComponent("" + editions) + "&"; 
        if (filterTypes === null)
            throw new Error("The parameter 'filterTypes' cannot be null.");
        else if (filterTypes !== undefined)
            url_ += "FilterTypes=" + encodeURIComponent("" + filterTypes) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCountRouteDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCountRouteDetails(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteCountsLaboratoryEditionDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteCountsLaboratoryEditionDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetCountRouteDetails(response: HttpResponseBase): Observable<ControllerRouteCountsLaboratoryEditionDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRouteCountsLaboratoryEditionDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteCountsLaboratoryEditionDto[]>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @param editions (optional) 
     * @param filterTypes (optional) 
     * @return Success
     */
    getCountRouteDetailsOld(routeIds: number[] | undefined, editions: string | undefined, filterTypes: string | undefined): Observable<ControllerRouteCountsLaboratoryEditionDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetCountRouteDetailsOld?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (editions === null)
            throw new Error("The parameter 'editions' cannot be null.");
        else if (editions !== undefined)
            url_ += "Editions=" + encodeURIComponent("" + editions) + "&"; 
        if (filterTypes === null)
            throw new Error("The parameter 'filterTypes' cannot be null.");
        else if (filterTypes !== undefined)
            url_ += "FilterTypes=" + encodeURIComponent("" + filterTypes) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCountRouteDetailsOld(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCountRouteDetailsOld(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteCountsLaboratoryEditionDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteCountsLaboratoryEditionDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetCountRouteDetailsOld(response: HttpResponseBase): Observable<ControllerRouteCountsLaboratoryEditionDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRouteCountsLaboratoryEditionDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteCountsLaboratoryEditionDto[]>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @param editions (optional) 
     * @param filterTypes (optional) 
     * @return Success
     */
    getCountLineHaulRouteDetails(routeIds: number[] | undefined, editions: string | undefined, filterTypes: string | undefined): Observable<ControllerRouteCountsLineHaulLaboratoryEditionDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetCountLineHaulRouteDetails?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (editions === null)
            throw new Error("The parameter 'editions' cannot be null.");
        else if (editions !== undefined)
            url_ += "Editions=" + encodeURIComponent("" + editions) + "&"; 
        if (filterTypes === null)
            throw new Error("The parameter 'filterTypes' cannot be null.");
        else if (filterTypes !== undefined)
            url_ += "FilterTypes=" + encodeURIComponent("" + filterTypes) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCountLineHaulRouteDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCountLineHaulRouteDetails(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteCountsLineHaulLaboratoryEditionDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteCountsLineHaulLaboratoryEditionDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetCountLineHaulRouteDetails(response: HttpResponseBase): Observable<ControllerRouteCountsLineHaulLaboratoryEditionDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRouteCountsLineHaulLaboratoryEditionDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteCountsLineHaulLaboratoryEditionDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    callInsStats(body: GetControllerCallInInputDto | undefined): Observable<ControllerCallInListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/CallInsStats";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCallInsStats(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCallInsStats(<any>response_);
                } catch (e) {
                    return <Observable<ControllerCallInListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerCallInListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processCallInsStats(response: HttpResponseBase): Observable<ControllerCallInListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerCallInListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerCallInListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    orderStatusList(body: GetControllerCallInInputDto | undefined): Observable<ControlllerRouteListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/OrderStatusList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrderStatusList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrderStatusList(<any>response_);
                } catch (e) {
                    return <Observable<ControlllerRouteListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControlllerRouteListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processOrderStatusList(response: HttpResponseBase): Observable<ControlllerRouteListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControlllerRouteListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControlllerRouteListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    stopsStats(body: GetControllerRouteStatusInputDto | undefined): Observable<ControllerRouteStatusAntechEditionDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/StopsStats";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processStopsStats(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processStopsStats(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteStatusAntechEditionDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteStatusAntechEditionDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processStopsStats(response: HttpResponseBase): Observable<ControllerRouteStatusAntechEditionDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRouteStatusAntechEditionDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteStatusAntechEditionDto[]>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @param editions (optional) 
     * @param filterTypes (optional) 
     * @return Success
     */
    getDetailsLaboratoryEdition(routeIds: number[] | undefined, editions: string | undefined, filterTypes: string | undefined): Observable<ControllerRouteStatusAntechEditionDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetDetailsLaboratoryEdition?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (editions === null)
            throw new Error("The parameter 'editions' cannot be null.");
        else if (editions !== undefined)
            url_ += "Editions=" + encodeURIComponent("" + editions) + "&"; 
        if (filterTypes === null)
            throw new Error("The parameter 'filterTypes' cannot be null.");
        else if (filterTypes !== undefined)
            url_ += "FilterTypes=" + encodeURIComponent("" + filterTypes) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDetailsLaboratoryEdition(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDetailsLaboratoryEdition(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteStatusAntechEditionDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteStatusAntechEditionDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDetailsLaboratoryEdition(response: HttpResponseBase): Observable<ControllerRouteStatusAntechEditionDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerRouteStatusAntechEditionDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteStatusAntechEditionDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateCompletedRoute(body: UpdateCompleteRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/UpdateCompletedRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateCompletedRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateCompletedRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateCompletedRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDepartureRoute(body: UpdateDepartureRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/UpdateDepartureRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDepartureRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDepartureRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDepartureRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    showBlindcode(body: ShowBlindCountCodeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/showBlindcode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processShowBlindcode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processShowBlindcode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processShowBlindcode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateLockedRoute(body: UpdateLockedRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/UpdateLockedRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateLockedRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateLockedRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateLockedRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateRouteManual(body: GenerateInputDto | undefined): Observable<GenerateResultDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GenerateRouteManual";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateRouteManual(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateRouteManual(<any>response_);
                } catch (e) {
                    return <Observable<GenerateResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GenerateResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateRouteManual(response: HttpResponseBase): Observable<GenerateResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GenerateResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GenerateResultDto>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @return Success
     */
    getDeliveredPackages(routeIds: number[] | undefined): Observable<GetDeliveredPackagesList[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetDeliveredPackages?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDeliveredPackages(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDeliveredPackages(<any>response_);
                } catch (e) {
                    return <Observable<GetDeliveredPackagesList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDeliveredPackagesList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDeliveredPackages(response: HttpResponseBase): Observable<GetDeliveredPackagesList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetDeliveredPackagesList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDeliveredPackagesList[]>(<any>null);
    }

    /**
     * @return Success
     */
    getMobileVersionsFilter(): Observable<MobileVersionListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetMobileVersionsFilter";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileVersionsFilter(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileVersionsFilter(<any>response_);
                } catch (e) {
                    return <Observable<MobileVersionListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<MobileVersionListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileVersionsFilter(response: HttpResponseBase): Observable<MobileVersionListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(MobileVersionListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<MobileVersionListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateStorageAPI(body: UserLocalStorageInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/CreateOrUpdateStorageAPI";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateStorageAPI(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateStorageAPI(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateStorageAPI(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    pickRouteDefinitionListPaged(body: RouteDefinitionListInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/PickRouteDefinitionListPaged";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPickRouteDefinitionListPaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPickRouteDefinitionListPaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processPickRouteDefinitionListPaged(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    pickRouteDefinitionList(body: RouteDefinitionListInput | undefined): Observable<NameValueDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/PickRouteDefinitionList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPickRouteDefinitionList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPickRouteDefinitionList(<any>response_);
                } catch (e) {
                    return <Observable<NameValueDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<NameValueDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processPickRouteDefinitionList(response: HttpResponseBase): Observable<NameValueDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(NameValueDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<NameValueDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createNewRoute(body: CreateNewRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/CreateNewRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateNewRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateNewRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateNewRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param timeZone (optional) 
     * @param localDateTime (optional) 
     * @return Success
     */
    getUtcOffset(timeZone: string | undefined, localDateTime: moment.Moment | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetUtcOffset?";
        if (timeZone === null)
            throw new Error("The parameter 'timeZone' cannot be null.");
        else if (timeZone !== undefined)
            url_ += "timeZone=" + encodeURIComponent("" + timeZone) + "&"; 
        if (localDateTime === null)
            throw new Error("The parameter 'localDateTime' cannot be null.");
        else if (localDateTime !== undefined)
            url_ += "localDateTime=" + encodeURIComponent(localDateTime ? "" + localDateTime.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUtcOffset(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUtcOffset(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetUtcOffset(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param meters (optional) 
     * @return Success
     */
    convertMetersToMiles(meters: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/ConvertMetersToMiles?";
        if (meters === null)
            throw new Error("The parameter 'meters' cannot be null.");
        else if (meters !== undefined)
            url_ += "meters=" + encodeURIComponent("" + meters) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertMetersToMiles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertMetersToMiles(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processConvertMetersToMiles(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @return Success
     */
    getDriverInactiveThreshold(): Observable<DriverInactiveThresholdDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/GetDriverInactiveThreshold";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverInactiveThreshold(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverInactiveThreshold(<any>response_);
                } catch (e) {
                    return <Observable<DriverInactiveThresholdDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverInactiveThresholdDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverInactiveThreshold(response: HttpResponseBase): Observable<DriverInactiveThresholdDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(DriverInactiveThresholdDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverInactiveThresholdDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    cleanUpDuplicateOrders(body: CleanUpDuplicateOrderDto | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRoute/CleanUpDuplicateOrders";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCleanUpDuplicateOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCleanUpDuplicateOrders(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processCleanUpDuplicateOrders(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }
}

@Injectable()
export class ControllerRouteDetailServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param routeId (optional) 
     * @param filter (optional) 
     * @param addressTypeIdsFilter (optional) 
     * @param orderSourceId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getControllerRouteDetailList(routeId: number | undefined, filter: string | undefined, addressTypeIdsFilter: number[] | undefined, orderSourceId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<ListResultDtoOfControllerOrderDetailsDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetControllerRouteDetailList?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (addressTypeIdsFilter === null)
            throw new Error("The parameter 'addressTypeIdsFilter' cannot be null.");
        else if (addressTypeIdsFilter !== undefined)
            addressTypeIdsFilter && addressTypeIdsFilter.forEach(item => { url_ += "AddressTypeIdsFilter=" + encodeURIComponent("" + item) + "&"; });
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerRouteDetailList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerRouteDetailList(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfControllerOrderDetailsDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfControllerOrderDetailsDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerRouteDetailList(response: HttpResponseBase): Observable<ListResultDtoOfControllerOrderDetailsDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfControllerOrderDetailsDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfControllerOrderDetailsDto>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param filter (optional) 
     * @param addressTypeIdsFilter (optional) 
     * @param orderSourceId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getRouteOrderDetailList(routeId: number | undefined, filter: string | undefined, addressTypeIdsFilter: number[] | undefined, orderSourceId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<ControllerOrderDetailsDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetRouteOrderDetailList?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (addressTypeIdsFilter === null)
            throw new Error("The parameter 'addressTypeIdsFilter' cannot be null.");
        else if (addressTypeIdsFilter !== undefined)
            addressTypeIdsFilter && addressTypeIdsFilter.forEach(item => { url_ += "AddressTypeIdsFilter=" + encodeURIComponent("" + item) + "&"; });
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteOrderDetailList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteOrderDetailList(<any>response_);
                } catch (e) {
                    return <Observable<ControllerOrderDetailsDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerOrderDetailsDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteOrderDetailList(response: HttpResponseBase): Observable<ControllerOrderDetailsDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerOrderDetailsDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerOrderDetailsDto[]>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getControllerRouteDetailHeader(routeId: number | undefined): Observable<ControllerRouteDetailDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetControllerRouteDetailHeader?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerRouteDetailHeader(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerRouteDetailHeader(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteDetailDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteDetailDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerRouteDetailHeader(response: HttpResponseBase): Observable<ControllerRouteDetailDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ControllerRouteDetailDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteDetailDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteInfo(id: number | undefined): Observable<GetRouteInfo> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetRouteInfo?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteInfo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteInfo(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteInfo>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteInfo>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteInfo(response: HttpResponseBase): Observable<GetRouteInfo> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteInfo.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteInfo>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getControllerRouteDetail(routeId: number | undefined): Observable<ControllerRouteDetailDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetControllerRouteDetail?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerRouteDetail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerRouteDetail(<any>response_);
                } catch (e) {
                    return <Observable<ControllerRouteDetailDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerRouteDetailDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerRouteDetail(response: HttpResponseBase): Observable<ControllerRouteDetailDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ControllerRouteDetailDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerRouteDetailDto>(<any>null);
    }

    /**
     * @param value (optional) 
     * @param dateTimeUTC (optional) 
     * @return Success
     */
    getUtcOffset(value: string | undefined, dateTimeUTC: moment.Moment | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetUtcOffset?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "value=" + encodeURIComponent("" + value) + "&"; 
        if (dateTimeUTC === null)
            throw new Error("The parameter 'dateTimeUTC' cannot be null.");
        else if (dateTimeUTC !== undefined)
            url_ += "dateTimeUTC=" + encodeURIComponent(dateTimeUTC ? "" + dateTimeUTC.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUtcOffset(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUtcOffset(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetUtcOffset(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getEditCountDetails(routeId: number | undefined): Observable<GetEditCountDetails> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetEditCountDetails?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEditCountDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEditCountDetails(<any>response_);
                } catch (e) {
                    return <Observable<GetEditCountDetails>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetEditCountDetails>><any>_observableThrow(response_);
        }));
    }

    protected processGetEditCountDetails(response: HttpResponseBase): Observable<GetEditCountDetails> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetEditCountDetails.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetEditCountDetails>(<any>null);
    }

    /**
     * @param clinicId (optional) 
     * @param orderId (optional) 
     * @return Success
     */
    getClinicNotes(clinicId: number | undefined, orderId: number | undefined): Observable<CreateOrEditClinicDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetClinicNotes?";
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "clinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "orderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicNotes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicNotes(<any>response_);
                } catch (e) {
                    return <Observable<CreateOrEditClinicDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateOrEditClinicDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicNotes(response: HttpResponseBase): Observable<CreateOrEditClinicDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateOrEditClinicDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateOrEditClinicDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param clinicId (optional) 
     * @param visibleToDriver (optional) 
     * @param noteId (optional) 
     * @param content (optional) 
     * @return Success
     */
    getOrderNotes(orderId: number | undefined, clinicId: number | undefined, visibleToDriver: boolean | undefined, noteId: number | undefined, content: string | undefined): Observable<OrderListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetOrderNotes?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "ClinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        if (visibleToDriver === null)
            throw new Error("The parameter 'visibleToDriver' cannot be null.");
        else if (visibleToDriver !== undefined)
            url_ += "VisibleToDriver=" + encodeURIComponent("" + visibleToDriver) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderNotes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderNotes(<any>response_);
                } catch (e) {
                    return <Observable<OrderListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderNotes(response: HttpResponseBase): Observable<OrderListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateOrderNotes(body: ControllerGetOrderIdForNoteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/CreateOrUpdateOrderNotes";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateOrderNotes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateOrderNotes(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateOrderNotes(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param timeZoneValue (optional) 
     * @param operatingLocationId (optional) 
     * @param routeId (optional) 
     * @param orderId (optional) 
     * @return Success
     */
    getAvailableRoute(loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, timeZoneValue: string | undefined, operatingLocationId: number | undefined, routeId: number | undefined, orderId: number | undefined): Observable<ListResultDtoOfControllerGetAllAvailabelRouteDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetAvailableRoute?";
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (timeZoneValue === null)
            throw new Error("The parameter 'timeZoneValue' cannot be null.");
        else if (timeZoneValue !== undefined)
            url_ += "TimeZoneValue=" + encodeURIComponent("" + timeZoneValue) + "&"; 
        if (operatingLocationId === null)
            throw new Error("The parameter 'operatingLocationId' cannot be null.");
        else if (operatingLocationId !== undefined)
            url_ += "OperatingLocationId=" + encodeURIComponent("" + operatingLocationId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAvailableRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAvailableRoute(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfControllerGetAllAvailabelRouteDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfControllerGetAllAvailabelRouteDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAvailableRoute(response: HttpResponseBase): Observable<ListResultDtoOfControllerGetAllAvailabelRouteDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfControllerGetAllAvailabelRouteDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfControllerGetAllAvailabelRouteDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    assignAvailableRoute(body: GetControllerRouteLoadDateInputPage | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/AssignAvailableRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignAvailableRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignAvailableRoute(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processAssignAvailableRoute(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getDriverList(): Observable<ControllerGetDriverListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetDriverList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverList(<any>response_);
                } catch (e) {
                    return <Observable<ControllerGetDriverListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerGetDriverListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverList(response: HttpResponseBase): Observable<ControllerGetDriverListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerGetDriverListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerGetDriverListDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getVehicleList(): Observable<ControllerDetailVehicleDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetVehicleList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleList(<any>response_);
                } catch (e) {
                    return <Observable<ControllerDetailVehicleDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerDetailVehicleDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleList(response: HttpResponseBase): Observable<ControllerDetailVehicleDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerDetailVehicleDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerDetailVehicleDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    selectVehicle(body: SelectVehicleInput | undefined): Observable<UpdateDriverDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/SelectVehicle";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSelectVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSelectVehicle(<any>response_);
                } catch (e) {
                    return <Observable<UpdateDriverDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<UpdateDriverDto>><any>_observableThrow(response_);
        }));
    }

    protected processSelectVehicle(response: HttpResponseBase): Observable<UpdateDriverDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = UpdateDriverDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UpdateDriverDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateVehicleDriver(body: GetDriverVehicle | undefined): Observable<UpdateDriverDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/UpdateVehicleDriver";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateVehicleDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateVehicleDriver(<any>response_);
                } catch (e) {
                    return <Observable<UpdateDriverDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<UpdateDriverDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateVehicleDriver(response: HttpResponseBase): Observable<UpdateDriverDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(UpdateDriverDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UpdateDriverDto[]>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getRouteZone(routeId: number | undefined): Observable<ContollerRouteLocationZoneDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetRouteZone?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteZone(<any>response_);
                } catch (e) {
                    return <Observable<ContollerRouteLocationZoneDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ContollerRouteLocationZoneDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteZone(response: HttpResponseBase): Observable<ContollerRouteLocationZoneDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ContollerRouteLocationZoneDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ContollerRouteLocationZoneDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateClinicGeocode(body: AddressIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/UpdateClinicGeocode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateClinicGeocode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateClinicGeocode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateClinicGeocode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateClinicGeocodeByStatus(body: GeocodeIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/UpdateClinicGeocodeByStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateClinicGeocodeByStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateClinicGeocodeByStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateClinicGeocodeByStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderNotes(body: OrderNotesInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/UpdateOrderNotes";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderNotes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderNotes(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderNotes(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param timeZoneInfo (optional) 
     * @param loadDate (optional) 
     * @param routeId (optional) 
     * @param filter (optional) 
     * @param accountNoFilter (optional) 
     * @param clinicFilter (optional) 
     * @param proximityFilter (optional) 
     * @param isHandOffRoute (optional) 
     * @return Success
     */
    getRouteSchedDetailList(id: number | undefined, timeZoneInfo: string | undefined, loadDate: moment.Moment | undefined, routeId: number | undefined, filter: string | undefined, accountNoFilter: string | undefined, clinicFilter: string | undefined, proximityFilter: string | undefined, isHandOffRoute: boolean | undefined): Observable<ControllerScheduleDetailDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetRouteSchedDetailList?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (timeZoneInfo === null)
            throw new Error("The parameter 'timeZoneInfo' cannot be null.");
        else if (timeZoneInfo !== undefined)
            url_ += "TimeZoneInfo=" + encodeURIComponent("" + timeZoneInfo) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (accountNoFilter === null)
            throw new Error("The parameter 'accountNoFilter' cannot be null.");
        else if (accountNoFilter !== undefined)
            url_ += "AccountNoFilter=" + encodeURIComponent("" + accountNoFilter) + "&"; 
        if (clinicFilter === null)
            throw new Error("The parameter 'clinicFilter' cannot be null.");
        else if (clinicFilter !== undefined)
            url_ += "ClinicFilter=" + encodeURIComponent("" + clinicFilter) + "&"; 
        if (proximityFilter === null)
            throw new Error("The parameter 'proximityFilter' cannot be null.");
        else if (proximityFilter !== undefined)
            url_ += "ProximityFilter=" + encodeURIComponent("" + proximityFilter) + "&"; 
        if (isHandOffRoute === null)
            throw new Error("The parameter 'isHandOffRoute' cannot be null.");
        else if (isHandOffRoute !== undefined)
            url_ += "IsHandOffRoute=" + encodeURIComponent("" + isHandOffRoute) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteSchedDetailList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteSchedDetailList(<any>response_);
                } catch (e) {
                    return <Observable<ControllerScheduleDetailDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerScheduleDetailDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteSchedDetailList(response: HttpResponseBase): Observable<ControllerScheduleDetailDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerScheduleDetailDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerScheduleDetailDto[]>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getLastProximity(routeId: number | undefined): Observable<ProximityCodeListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetLastProximity?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLastProximity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLastProximity(<any>response_);
                } catch (e) {
                    return <Observable<ProximityCodeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ProximityCodeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLastProximity(response: HttpResponseBase): Observable<ProximityCodeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ProximityCodeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ProximityCodeListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param timeZoneInfo (optional) 
     * @param loadDate (optional) 
     * @param routeId (optional) 
     * @param filter (optional) 
     * @param accountNoFilter (optional) 
     * @param clinicFilter (optional) 
     * @param proximityFilter (optional) 
     * @param isHandOffRoute (optional) 
     * @return Success
     */
    getRouteSchedDetails(id: number | undefined, timeZoneInfo: string | undefined, loadDate: moment.Moment | undefined, routeId: number | undefined, filter: string | undefined, accountNoFilter: string | undefined, clinicFilter: string | undefined, proximityFilter: string | undefined, isHandOffRoute: boolean | undefined): Observable<ListResultDtoOfControllerScheduleDetailDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetRouteSchedDetails?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (timeZoneInfo === null)
            throw new Error("The parameter 'timeZoneInfo' cannot be null.");
        else if (timeZoneInfo !== undefined)
            url_ += "TimeZoneInfo=" + encodeURIComponent("" + timeZoneInfo) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (accountNoFilter === null)
            throw new Error("The parameter 'accountNoFilter' cannot be null.");
        else if (accountNoFilter !== undefined)
            url_ += "AccountNoFilter=" + encodeURIComponent("" + accountNoFilter) + "&"; 
        if (clinicFilter === null)
            throw new Error("The parameter 'clinicFilter' cannot be null.");
        else if (clinicFilter !== undefined)
            url_ += "ClinicFilter=" + encodeURIComponent("" + clinicFilter) + "&"; 
        if (proximityFilter === null)
            throw new Error("The parameter 'proximityFilter' cannot be null.");
        else if (proximityFilter !== undefined)
            url_ += "ProximityFilter=" + encodeURIComponent("" + proximityFilter) + "&"; 
        if (isHandOffRoute === null)
            throw new Error("The parameter 'isHandOffRoute' cannot be null.");
        else if (isHandOffRoute !== undefined)
            url_ += "IsHandOffRoute=" + encodeURIComponent("" + isHandOffRoute) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteSchedDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteSchedDetails(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfControllerScheduleDetailDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfControllerScheduleDetailDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteSchedDetails(response: HttpResponseBase): Observable<ListResultDtoOfControllerScheduleDetailDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfControllerScheduleDetailDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfControllerScheduleDetailDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    importData(body: CreateBatchOptimizeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/ImportData";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processImportData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processImportData(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processImportData(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    assignDriversList(body: DriverListInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/AssignDriversList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignDriversList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignDriversList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processAssignDriversList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    assignVehiclesList(body: DriverListInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/AssignVehiclesList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignVehiclesList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignVehiclesList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processAssignVehiclesList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteByVehicleId(body: VehicleInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/UpdateRouteByVehicleId";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteByVehicleId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteByVehicleId(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteByVehicleId(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @return Success
     */
    getRouteScheduleToExcel(locationId: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetRouteScheduleToExcel?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteScheduleToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteScheduleToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteScheduleToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param locationIds (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param filter (optional) 
     * @return Success
     */
    getAllStopsList(tenantId: number | undefined, locationIds: number[] | undefined, maxResultCount: number | undefined, skipCount: number | undefined, filter: string | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetAllStopsList?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllStopsList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllStopsList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllStopsList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    checkFreeze(routeId: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/CheckFreeze?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckFreeze(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckFreeze(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processCheckFreeze(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteByStop(body: UpdateRouteByStopInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/UpdateRouteByStop";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteByStop(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteByStop(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteByStop(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    checkDelivered(routeId: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/CheckDelivered?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckDelivered(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckDelivered(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processCheckDelivered(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getEtaCode(orderId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/GetEtaCode?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEtaCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEtaCode(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetEtaCode(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    vendorChecker(): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/VendorChecker";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processVendorChecker(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processVendorChecker(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processVendorChecker(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param checkString (optional) 
     * @param prevUrl (optional) 
     * @return Success
     */
    handOffRouteChecker(routeId: number | undefined, checkString: string | undefined, prevUrl: string | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/HandOffRouteChecker?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        if (checkString === null)
            throw new Error("The parameter 'checkString' cannot be null.");
        else if (checkString !== undefined)
            url_ += "checkString=" + encodeURIComponent("" + checkString) + "&"; 
        if (prevUrl === null)
            throw new Error("The parameter 'prevUrl' cannot be null.");
        else if (prevUrl !== undefined)
            url_ += "prevUrl=" + encodeURIComponent("" + prevUrl) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processHandOffRouteChecker(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processHandOffRouteChecker(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processHandOffRouteChecker(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @return Success
     */
    hidePickup(): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ControllerRouteDetail/hidePickup";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processHidePickup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processHidePickup(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processHidePickup(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }
}

@Injectable()
export class ControllerVehicleListServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param vehicleName (optional) 
     * @param vehicleId (optional) 
     * @param locationId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param completed (optional) 
     * @param routeIds (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getControllerVehicleList(vehicleName: string | undefined, vehicleId: number | undefined, locationId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, completed: boolean | undefined, routeIds: number[] | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfControllerVehicleListDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerVehicleList/GetControllerVehicleList?";
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (completed === null)
            throw new Error("The parameter 'completed' cannot be null.");
        else if (completed !== undefined)
            url_ += "Completed=" + encodeURIComponent("" + completed) + "&"; 
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetControllerVehicleList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetControllerVehicleList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfControllerVehicleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfControllerVehicleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetControllerVehicleList(response: HttpResponseBase): Observable<PagedResultDtoOfControllerVehicleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfControllerVehicleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfControllerVehicleListDto>(<any>null);
    }

    /**
     * @param vehicleIds (optional) 
     * @return Success
     */
    getVehicleNameAndActiveRoute(vehicleIds: number[] | undefined): Observable<ControllerVehicleListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ControllerVehicleList/GetVehicleNameAndActiveRoute?";
        if (vehicleIds === null)
            throw new Error("The parameter 'vehicleIds' cannot be null.");
        else if (vehicleIds !== undefined)
            vehicleIds && vehicleIds.forEach(item => { url_ += "vehicleIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleNameAndActiveRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleNameAndActiveRoute(<any>response_);
                } catch (e) {
                    return <Observable<ControllerVehicleListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ControllerVehicleListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleNameAndActiveRoute(response: HttpResponseBase): Observable<ControllerVehicleListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ControllerVehicleListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ControllerVehicleListDto[]>(<any>null);
    }

    /**
     * @param vehicleId (optional) 
     * @param locationId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getVehicleEntity(vehicleId: number | undefined, locationId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<GetVehicleForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ControllerVehicleList/GetVehicleEntity?";
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleEntity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleEntity(<any>response_);
                } catch (e) {
                    return <Observable<GetVehicleForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVehicleForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleEntity(response: HttpResponseBase): Observable<GetVehicleForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVehicleForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVehicleForViewDto>(<any>null);
    }

    /**
     * @param vehicleId (optional) 
     * @param locationId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getVehicleRoutes(vehicleId: number | undefined, locationId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetVehicleRoutesResult> {
        let url_ = this.baseUrl + "/api/services/app/ControllerVehicleList/GetVehicleRoutes?";
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleRoutes(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetVehicleRoutesResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetVehicleRoutesResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleRoutes(response: HttpResponseBase): Observable<PagedResultDtoOfGetVehicleRoutesResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetVehicleRoutesResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetVehicleRoutesResult>(<any>null);
    }
}

@Injectable()
export class CustomerServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param contactId (optional) 
     * @return Success
     */
    getContactInfo(contactId: number | undefined): Observable<ContactInfo> {
        let url_ = this.baseUrl + "/api/services/app/Customer/GetContactInfo?";
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "contactId=" + encodeURIComponent("" + contactId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactInfo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactInfo(<any>response_);
                } catch (e) {
                    return <Observable<ContactInfo>><any>_observableThrow(e);
                }
            } else
                return <Observable<ContactInfo>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactInfo(response: HttpResponseBase): Observable<ContactInfo> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ContactInfo.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ContactInfo>(<any>null);
    }

    /**
     * @return Success
     */
    getCustomerProfile(): Observable<GetCustomerProfileDto> {
        let url_ = this.baseUrl + "/api/services/app/Customer/GetCustomerProfile";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCustomerProfile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCustomerProfile(<any>response_);
                } catch (e) {
                    return <Observable<GetCustomerProfileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetCustomerProfileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCustomerProfile(response: HttpResponseBase): Observable<GetCustomerProfileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetCustomerProfileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetCustomerProfileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateCustomerProfile(body: UpdateCustomerProfileInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Customer/UpdateCustomerProfile";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateCustomerProfile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateCustomerProfile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateCustomerProfile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateContactProfile(body: UpdateCustomerProfileInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Customer/UpdateContactProfile";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateContactProfile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateContactProfile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateContactProfile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getCustomerAddressForEdit(id: number | undefined): Observable<GetCustomerAddressForEdit> {
        let url_ = this.baseUrl + "/api/services/app/Customer/GetCustomerAddressForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCustomerAddressForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCustomerAddressForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetCustomerAddressForEdit>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetCustomerAddressForEdit>><any>_observableThrow(response_);
        }));
    }

    protected processGetCustomerAddressForEdit(response: HttpResponseBase): Observable<GetCustomerAddressForEdit> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetCustomerAddressForEdit.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetCustomerAddressForEdit>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateCustomerAddress(body: UpdateCustomerAddressInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Customer/UpdateCustomerAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateCustomerAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateCustomerAddress(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateCustomerAddress(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createClinicAccount(body: CreateClinicAccountInput | undefined): Observable<RegisterOutput> {
        let url_ = this.baseUrl + "/api/services/app/Customer/CreateClinicAccount";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateClinicAccount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateClinicAccount(<any>response_);
                } catch (e) {
                    return <Observable<RegisterOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<RegisterOutput>><any>_observableThrow(response_);
        }));
    }

    protected processCreateClinicAccount(response: HttpResponseBase): Observable<RegisterOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = RegisterOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RegisterOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createContactPerson(body: UpdateCustomerProfileInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Customer/CreateContactPerson";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateContactPerson(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateContactPerson(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateContactPerson(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateContactPerson(body: UpdateCustomerProfileInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Customer/UpdateContactPerson";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateContactPerson(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateContactPerson(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateContactPerson(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllContactPerson(sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetContactPersonsList> {
        let url_ = this.baseUrl + "/api/services/app/Customer/GetAllContactPerson?";
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllContactPerson(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllContactPerson(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetContactPersonsList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetContactPersonsList>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllContactPerson(response: HttpResponseBase): Observable<PagedResultDtoOfGetContactPersonsList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetContactPersonsList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetContactPersonsList>(<any>null);
    }

    /**
     * @param input (optional) 
     * @return Success
     */
    getContactPersonForEdit(input: number | undefined): Observable<ContactInfo> {
        let url_ = this.baseUrl + "/api/services/app/Customer/GetContactPersonForEdit?";
        if (input === null)
            throw new Error("The parameter 'input' cannot be null.");
        else if (input !== undefined)
            url_ += "input=" + encodeURIComponent("" + input) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactPersonForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactPersonForEdit(<any>response_);
                } catch (e) {
                    return <Observable<ContactInfo>><any>_observableThrow(e);
                }
            } else
                return <Observable<ContactInfo>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactPersonForEdit(response: HttpResponseBase): Observable<ContactInfo> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ContactInfo.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ContactInfo>(<any>null);
    }

    /**
     * @param input (optional) 
     * @return Success
     */
    deleteContactPerson(input: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Customer/DeleteContactPerson?";
        if (input === null)
            throw new Error("The parameter 'input' cannot be null.");
        else if (input !== undefined)
            url_ += "input=" + encodeURIComponent("" + input) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteContactPerson(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteContactPerson(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteContactPerson(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param timezoneInfo (optional) 
     * @return Success
     */
    getPickupSchedule(timezoneInfo: string | undefined): Observable<ClinicOrders[]> {
        let url_ = this.baseUrl + "/api/services/app/Customer/GetPickupSchedule?";
        if (timezoneInfo === null)
            throw new Error("The parameter 'timezoneInfo' cannot be null.");
        else if (timezoneInfo !== undefined)
            url_ += "TimezoneInfo=" + encodeURIComponent("" + timezoneInfo) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPickupSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPickupSchedule(<any>response_);
                } catch (e) {
                    return <Observable<ClinicOrders[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ClinicOrders[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetPickupSchedule(response: HttpResponseBase): Observable<ClinicOrders[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ClinicOrders.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ClinicOrders[]>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getCurrentDriverLocation(orderId: number | undefined): Observable<GetCurrentDriverLocation> {
        let url_ = this.baseUrl + "/api/services/app/Customer/GetCurrentDriverLocation?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCurrentDriverLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCurrentDriverLocation(<any>response_);
                } catch (e) {
                    return <Observable<GetCurrentDriverLocation>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetCurrentDriverLocation>><any>_observableThrow(response_);
        }));
    }

    protected processGetCurrentDriverLocation(response: HttpResponseBase): Observable<GetCurrentDriverLocation> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetCurrentDriverLocation.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetCurrentDriverLocation>(<any>null);
    }

    /**
     * @param userId (optional) 
     * @return Success
     */
    checkIfCustomer(userId: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Customer/CheckIfCustomer?";
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "userId=" + encodeURIComponent("" + userId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckIfCustomer(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckIfCustomer(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processCheckIfCustomer(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getCustomerPermissionForEdit(id: number | undefined): Observable<GetUserPermissionsForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Customer/GetCustomerPermissionForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCustomerPermissionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCustomerPermissionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetUserPermissionsForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserPermissionsForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetCustomerPermissionForEdit(response: HttpResponseBase): Observable<GetUserPermissionsForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserPermissionsForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserPermissionsForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateContactPersonPermissions(body: UpdateUserPermissionsInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Customer/UpdateContactPersonPermissions";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateContactPersonPermissions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateContactPersonPermissions(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateContactPersonPermissions(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param userId (optional) 
     * @param role (optional) 
     * @return Success
     */
    getUserRolePermissions(userId: number | undefined, role: string | undefined): Observable<GetUserPermissionsForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Customer/GetUserRolePermissions?";
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (role === null)
            throw new Error("The parameter 'role' cannot be null.");
        else if (role !== undefined)
            url_ += "Role=" + encodeURIComponent("" + role) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserRolePermissions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserRolePermissions(<any>response_);
                } catch (e) {
                    return <Observable<GetUserPermissionsForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserPermissionsForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserRolePermissions(response: HttpResponseBase): Observable<GetUserPermissionsForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserPermissionsForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserPermissionsForEditOutput>(<any>null);
    }

    /**
     * @return Success
     */
    checkCustomerRole(): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Customer/CheckCustomerRole";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckCustomerRole(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckCustomerRole(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processCheckCustomerRole(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }
}

@Injectable()
export class DashboardServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Dashboard/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param createdFrom (optional) 
     * @param createdTo (optional) 
     * @param modifiedFrom (optional) 
     * @param modifiedTo (optional) 
     * @param createdByFilter (optional) 
     * @param modifiedByFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getDashboards(filter: string | undefined, nameFilter: string | undefined, createdFrom: moment.Moment | undefined, createdTo: moment.Moment | undefined, modifiedFrom: moment.Moment | undefined, modifiedTo: moment.Moment | undefined, createdByFilter: number | undefined, modifiedByFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfDashboardList> {
        let url_ = this.baseUrl + "/api/services/app/Dashboard/GetDashboards?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (createdFrom === null)
            throw new Error("The parameter 'createdFrom' cannot be null.");
        else if (createdFrom !== undefined)
            url_ += "CreatedFrom=" + encodeURIComponent(createdFrom ? "" + createdFrom.toJSON() : "") + "&"; 
        if (createdTo === null)
            throw new Error("The parameter 'createdTo' cannot be null.");
        else if (createdTo !== undefined)
            url_ += "CreatedTo=" + encodeURIComponent(createdTo ? "" + createdTo.toJSON() : "") + "&"; 
        if (modifiedFrom === null)
            throw new Error("The parameter 'modifiedFrom' cannot be null.");
        else if (modifiedFrom !== undefined)
            url_ += "ModifiedFrom=" + encodeURIComponent(modifiedFrom ? "" + modifiedFrom.toJSON() : "") + "&"; 
        if (modifiedTo === null)
            throw new Error("The parameter 'modifiedTo' cannot be null.");
        else if (modifiedTo !== undefined)
            url_ += "ModifiedTo=" + encodeURIComponent(modifiedTo ? "" + modifiedTo.toJSON() : "") + "&"; 
        if (createdByFilter === null)
            throw new Error("The parameter 'createdByFilter' cannot be null.");
        else if (createdByFilter !== undefined)
            url_ += "CreatedByFilter=" + encodeURIComponent("" + createdByFilter) + "&"; 
        if (modifiedByFilter === null)
            throw new Error("The parameter 'modifiedByFilter' cannot be null.");
        else if (modifiedByFilter !== undefined)
            url_ += "ModifiedByFilter=" + encodeURIComponent("" + modifiedByFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDashboards(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDashboards(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfDashboardList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfDashboardList>><any>_observableThrow(response_);
        }));
    }

    protected processGetDashboards(response: HttpResponseBase): Observable<PagedResultDtoOfDashboardList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfDashboardList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfDashboardList>(<any>null);
    }

    /**
     * @return Success
     */
    getUsersForDropDownDashboard(): Observable<ListResultDtoOfUserListDto> {
        let url_ = this.baseUrl + "/api/services/app/Dashboard/GetUsersForDropDownDashboard";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUsersForDropDownDashboard(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUsersForDropDownDashboard(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfUserListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfUserListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUsersForDropDownDashboard(response: HttpResponseBase): Observable<ListResultDtoOfUserListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfUserListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfUserListDto>(<any>null);
    }

    /**
     * @return Success
     */
    getData(): Observable<Dashboards[]> {
        let url_ = this.baseUrl + "/api/services/app/Dashboard/GetData";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetData(<any>response_);
                } catch (e) {
                    return <Observable<Dashboards[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<Dashboards[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetData(response: HttpResponseBase): Observable<Dashboards[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(Dashboards.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Dashboards[]>(<any>null);
    }

    /**
     * @return Success
     */
    getDashboardUserId(): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Dashboard/GetDashboardUserId";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDashboardUserId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDashboardUserId(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetDashboardUserId(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @return Success
     */
    getDashboardTenantId(): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Dashboard/GetDashboardTenantId";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDashboardTenantId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDashboardTenantId(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetDashboardTenantId(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class DashboardCustomizationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param dashboardName (optional) 
     * @param application (optional) 
     * @return Success
     */
    getUserDashboard(dashboardName: string | undefined, application: string | undefined): Observable<Dashboard> {
        let url_ = this.baseUrl + "/api/services/app/DashboardCustomization/GetUserDashboard?";
        if (dashboardName === null)
            throw new Error("The parameter 'dashboardName' cannot be null.");
        else if (dashboardName !== undefined)
            url_ += "DashboardName=" + encodeURIComponent("" + dashboardName) + "&"; 
        if (application === null)
            throw new Error("The parameter 'application' cannot be null.");
        else if (application !== undefined)
            url_ += "Application=" + encodeURIComponent("" + application) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserDashboard(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserDashboard(<any>response_);
                } catch (e) {
                    return <Observable<Dashboard>><any>_observableThrow(e);
                }
            } else
                return <Observable<Dashboard>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserDashboard(response: HttpResponseBase): Observable<Dashboard> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = Dashboard.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Dashboard>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    savePage(body: SavePageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DashboardCustomization/SavePage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSavePage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSavePage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSavePage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    renamePage(body: RenamePageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DashboardCustomization/RenamePage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRenamePage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRenamePage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRenamePage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addNewPage(body: AddNewPageInput | undefined): Observable<AddNewPageOutput> {
        let url_ = this.baseUrl + "/api/services/app/DashboardCustomization/AddNewPage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddNewPage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddNewPage(<any>response_);
                } catch (e) {
                    return <Observable<AddNewPageOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<AddNewPageOutput>><any>_observableThrow(response_);
        }));
    }

    protected processAddNewPage(response: HttpResponseBase): Observable<AddNewPageOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = AddNewPageOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<AddNewPageOutput>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param dashboardName (optional) 
     * @param application (optional) 
     * @return Success
     */
    deletePage(id: string | undefined, dashboardName: string | undefined, application: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DashboardCustomization/DeletePage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (dashboardName === null)
            throw new Error("The parameter 'dashboardName' cannot be null.");
        else if (dashboardName !== undefined)
            url_ += "DashboardName=" + encodeURIComponent("" + dashboardName) + "&"; 
        if (application === null)
            throw new Error("The parameter 'application' cannot be null.");
        else if (application !== undefined)
            url_ += "Application=" + encodeURIComponent("" + application) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeletePage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeletePage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeletePage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addWidget(body: AddWidgetInput | undefined): Observable<Widget> {
        let url_ = this.baseUrl + "/api/services/app/DashboardCustomization/AddWidget";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddWidget(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddWidget(<any>response_);
                } catch (e) {
                    return <Observable<Widget>><any>_observableThrow(e);
                }
            } else
                return <Observable<Widget>><any>_observableThrow(response_);
        }));
    }

    protected processAddWidget(response: HttpResponseBase): Observable<Widget> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = Widget.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Widget>(<any>null);
    }

    /**
     * @param dashboardName (optional) 
     * @param application (optional) 
     * @return Success
     */
    getDashboardDefinition(dashboardName: string | undefined, application: string | undefined): Observable<DashboardOutput> {
        let url_ = this.baseUrl + "/api/services/app/DashboardCustomization/GetDashboardDefinition?";
        if (dashboardName === null)
            throw new Error("The parameter 'dashboardName' cannot be null.");
        else if (dashboardName !== undefined)
            url_ += "DashboardName=" + encodeURIComponent("" + dashboardName) + "&"; 
        if (application === null)
            throw new Error("The parameter 'application' cannot be null.");
        else if (application !== undefined)
            url_ += "Application=" + encodeURIComponent("" + application) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDashboardDefinition(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDashboardDefinition(<any>response_);
                } catch (e) {
                    return <Observable<DashboardOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<DashboardOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetDashboardDefinition(response: HttpResponseBase): Observable<DashboardOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DashboardOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DashboardOutput>(<any>null);
    }

    /**
     * @param dashboardName (optional) 
     * @param application (optional) 
     * @return Success
     */
    getAllWidgetDefinitions(dashboardName: string | undefined, application: string | undefined): Observable<WidgetOutput[]> {
        let url_ = this.baseUrl + "/api/services/app/DashboardCustomization/GetAllWidgetDefinitions?";
        if (dashboardName === null)
            throw new Error("The parameter 'dashboardName' cannot be null.");
        else if (dashboardName !== undefined)
            url_ += "DashboardName=" + encodeURIComponent("" + dashboardName) + "&"; 
        if (application === null)
            throw new Error("The parameter 'application' cannot be null.");
        else if (application !== undefined)
            url_ += "Application=" + encodeURIComponent("" + application) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllWidgetDefinitions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllWidgetDefinitions(<any>response_);
                } catch (e) {
                    return <Observable<WidgetOutput[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<WidgetOutput[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllWidgetDefinitions(response: HttpResponseBase): Observable<WidgetOutput[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(WidgetOutput.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<WidgetOutput[]>(<any>null);
    }

    /**
     * @param application (optional) 
     * @return Success
     */
    getSettingName(application: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/DashboardCustomization/GetSettingName?";
        if (application === null)
            throw new Error("The parameter 'application' cannot be null.");
        else if (application !== undefined)
            url_ += "application=" + encodeURIComponent("" + application) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSettingName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSettingName(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetSettingName(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class DataRetentionsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param entityFilter (optional) 
     * @param frequencyFilter (optional) 
     * @param maxDurationFilter (optional) 
     * @param minDurationFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, entityFilter: number | undefined, frequencyFilter: number | undefined, maxDurationFilter: number | undefined, minDurationFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetDataRetentionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (entityFilter === null)
            throw new Error("The parameter 'entityFilter' cannot be null.");
        else if (entityFilter !== undefined)
            url_ += "EntityFilter=" + encodeURIComponent("" + entityFilter) + "&"; 
        if (frequencyFilter === null)
            throw new Error("The parameter 'frequencyFilter' cannot be null.");
        else if (frequencyFilter !== undefined)
            url_ += "FrequencyFilter=" + encodeURIComponent("" + frequencyFilter) + "&"; 
        if (maxDurationFilter === null)
            throw new Error("The parameter 'maxDurationFilter' cannot be null.");
        else if (maxDurationFilter !== undefined)
            url_ += "MaxDurationFilter=" + encodeURIComponent("" + maxDurationFilter) + "&"; 
        if (minDurationFilter === null)
            throw new Error("The parameter 'minDurationFilter' cannot be null.");
        else if (minDurationFilter !== undefined)
            url_ += "MinDurationFilter=" + encodeURIComponent("" + minDurationFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetDataRetentionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetDataRetentionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetDataRetentionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetDataRetentionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetDataRetentionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getDataRetentionForView(id: number | undefined): Observable<GetDataRetentionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/GetDataRetentionForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDataRetentionForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDataRetentionForView(<any>response_);
                } catch (e) {
                    return <Observable<GetDataRetentionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDataRetentionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDataRetentionForView(response: HttpResponseBase): Observable<GetDataRetentionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDataRetentionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDataRetentionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getDataRetentionForEdit(id: number | undefined): Observable<GetDataRetentionForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/GetDataRetentionForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDataRetentionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDataRetentionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetDataRetentionForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDataRetentionForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetDataRetentionForEdit(response: HttpResponseBase): Observable<GetDataRetentionForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDataRetentionForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDataRetentionForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditDataRetentionDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setUpJob(body: JobInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/SetUpJob";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetUpJob(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetUpJob(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetUpJob(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param duration (optional) 
     * @param isActive (optional) 
     * @param startTime (optional) 
     * @param jobDuration (optional) 
     * @param effectiveDate (optional) 
     * @param isDeleted (optional) 
     * @param deleterUserId (optional) 
     * @param deletionTime (optional) 
     * @param lastModificationTime (optional) 
     * @param lastModifierUserId (optional) 
     * @param creationTime (optional) 
     * @param creatorUserId (optional) 
     * @param id (optional) 
     * @return Success
     */
    removeEntityJob(tenantId: number | undefined, entity: EntityEnum, frequency: Frequency, duration: number | undefined, isActive: boolean | undefined, startTime: TimeSpan | undefined, jobDuration: number | undefined, effectiveDate: moment.Moment | undefined, isDeleted: boolean | undefined, deleterUserId: number | undefined, deletionTime: moment.Moment | undefined, lastModificationTime: moment.Moment | undefined, lastModifierUserId: number | undefined, creationTime: moment.Moment | undefined, creatorUserId: number | undefined, id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/RemoveEntityJob?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (entity === undefined || entity === null)
            throw new Error("The parameter 'entity' must be defined and cannot be null.");
        else
            url_ += "Entity=" + encodeURIComponent("" + entity) + "&"; 
        if (frequency === undefined || frequency === null)
            throw new Error("The parameter 'frequency' must be defined and cannot be null.");
        else
            url_ += "Frequency=" + encodeURIComponent("" + frequency) + "&"; 
        if (duration === null)
            throw new Error("The parameter 'duration' cannot be null.");
        else if (duration !== undefined)
            url_ += "Duration=" + encodeURIComponent("" + duration) + "&"; 
        if (isActive === null)
            throw new Error("The parameter 'isActive' cannot be null.");
        else if (isActive !== undefined)
            url_ += "IsActive=" + encodeURIComponent("" + isActive) + "&"; 
        if (startTime === null)
            throw new Error("The parameter 'startTime' cannot be null.");
        else if (startTime !== undefined)
            url_ += "StartTime=" + encodeURIComponent("" + startTime) + "&"; 
        if (jobDuration === null)
            throw new Error("The parameter 'jobDuration' cannot be null.");
        else if (jobDuration !== undefined)
            url_ += "JobDuration=" + encodeURIComponent("" + jobDuration) + "&"; 
        if (effectiveDate === null)
            throw new Error("The parameter 'effectiveDate' cannot be null.");
        else if (effectiveDate !== undefined)
            url_ += "EffectiveDate=" + encodeURIComponent(effectiveDate ? "" + effectiveDate.toJSON() : "") + "&"; 
        if (isDeleted === null)
            throw new Error("The parameter 'isDeleted' cannot be null.");
        else if (isDeleted !== undefined)
            url_ += "IsDeleted=" + encodeURIComponent("" + isDeleted) + "&"; 
        if (deleterUserId === null)
            throw new Error("The parameter 'deleterUserId' cannot be null.");
        else if (deleterUserId !== undefined)
            url_ += "DeleterUserId=" + encodeURIComponent("" + deleterUserId) + "&"; 
        if (deletionTime === null)
            throw new Error("The parameter 'deletionTime' cannot be null.");
        else if (deletionTime !== undefined)
            url_ += "DeletionTime=" + encodeURIComponent(deletionTime ? "" + deletionTime.toJSON() : "") + "&"; 
        if (lastModificationTime === null)
            throw new Error("The parameter 'lastModificationTime' cannot be null.");
        else if (lastModificationTime !== undefined)
            url_ += "LastModificationTime=" + encodeURIComponent(lastModificationTime ? "" + lastModificationTime.toJSON() : "") + "&"; 
        if (lastModifierUserId === null)
            throw new Error("The parameter 'lastModifierUserId' cannot be null.");
        else if (lastModifierUserId !== undefined)
            url_ += "LastModifierUserId=" + encodeURIComponent("" + lastModifierUserId) + "&"; 
        if (creationTime === null)
            throw new Error("The parameter 'creationTime' cannot be null.");
        else if (creationTime !== undefined)
            url_ += "CreationTime=" + encodeURIComponent(creationTime ? "" + creationTime.toJSON() : "") + "&"; 
        if (creatorUserId === null)
            throw new Error("The parameter 'creatorUserId' cannot be null.");
        else if (creatorUserId !== undefined)
            url_ += "CreatorUserId=" + encodeURIComponent("" + creatorUserId) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRemoveEntityJob(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRemoveEntityJob(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRemoveEntityJob(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param startTime (optional) 
     * @param effectiveDate (optional) 
     * @return Success
     */
    getCron(frequency: Frequency, startTime: TimeSpan | undefined, effectiveDate: moment.Moment | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/GetCron?";
        if (frequency === undefined || frequency === null)
            throw new Error("The parameter 'frequency' must be defined and cannot be null.");
        else
            url_ += "frequency=" + encodeURIComponent("" + frequency) + "&"; 
        if (startTime === null)
            throw new Error("The parameter 'startTime' cannot be null.");
        else if (startTime !== undefined)
            url_ += "startTime=" + encodeURIComponent("" + startTime) + "&"; 
        if (effectiveDate === null)
            throw new Error("The parameter 'effectiveDate' cannot be null.");
        else if (effectiveDate !== undefined)
            url_ += "effectiveDate=" + encodeURIComponent(effectiveDate ? "" + effectiveDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCron(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCron(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetCron(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createLog(body: CreateOrEditDataRetentionLogDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/CreateLog";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateLog(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateLog(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param dataRetentionLogId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getRetentionLogs(filter: string | undefined, dataRetentionLogId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetDataRetentionLogForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/GetRetentionLogs?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (dataRetentionLogId === null)
            throw new Error("The parameter 'dataRetentionLogId' cannot be null.");
        else if (dataRetentionLogId !== undefined)
            url_ += "DataRetentionLogId=" + encodeURIComponent("" + dataRetentionLogId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRetentionLogs(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRetentionLogs(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetDataRetentionLogForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetDataRetentionLogForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRetentionLogs(response: HttpResponseBase): Observable<PagedResultDtoOfGetDataRetentionLogForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetDataRetentionLogForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetDataRetentionLogForViewDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param dataRetentionId (optional) 
     * @return Success
     */
    getRetentionLogsToExcel(filter: string | undefined, dataRetentionId: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/GetRetentionLogsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (dataRetentionId === null)
            throw new Error("The parameter 'dataRetentionId' cannot be null.");
        else if (dataRetentionId !== undefined)
            url_ += "DataRetentionId=" + encodeURIComponent("" + dataRetentionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRetentionLogsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRetentionLogsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRetentionLogsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param entityFilter (optional) 
     * @param frequencyFilter (optional) 
     * @param maxDurationFilter (optional) 
     * @param minDurationFilter (optional) 
     * @return Success
     */
    getDataRetentionsToExcel(filter: string | undefined, entityFilter: number | undefined, frequencyFilter: number | undefined, maxDurationFilter: number | undefined, minDurationFilter: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/DataRetentions/GetDataRetentionsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (entityFilter === null)
            throw new Error("The parameter 'entityFilter' cannot be null.");
        else if (entityFilter !== undefined)
            url_ += "EntityFilter=" + encodeURIComponent("" + entityFilter) + "&"; 
        if (frequencyFilter === null)
            throw new Error("The parameter 'frequencyFilter' cannot be null.");
        else if (frequencyFilter !== undefined)
            url_ += "FrequencyFilter=" + encodeURIComponent("" + frequencyFilter) + "&"; 
        if (maxDurationFilter === null)
            throw new Error("The parameter 'maxDurationFilter' cannot be null.");
        else if (maxDurationFilter !== undefined)
            url_ += "MaxDurationFilter=" + encodeURIComponent("" + maxDurationFilter) + "&"; 
        if (minDurationFilter === null)
            throw new Error("The parameter 'minDurationFilter' cannot be null.");
        else if (minDurationFilter !== undefined)
            url_ += "MinDurationFilter=" + encodeURIComponent("" + minDurationFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDataRetentionsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDataRetentionsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDataRetentionsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class DataSourceServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDataSource(body: CreateDataSourceInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/DataSource/CreateDataSource";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDataSource(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDataSource(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDataSource(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param description (optional) 
     * @param code (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDataSource(id: number | undefined, description: string | undefined, code: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfDataSourceListDto> {
        let url_ = this.baseUrl + "/api/services/app/DataSource/GetDataSource?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (description === null)
            throw new Error("The parameter 'description' cannot be null.");
        else if (description !== undefined)
            url_ += "Description=" + encodeURIComponent("" + description) + "&"; 
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDataSource(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDataSource(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfDataSourceListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfDataSourceListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDataSource(response: HttpResponseBase): Observable<ListResultDtoOfDataSourceListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfDataSourceListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfDataSourceListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDataSource(body: UpdateDataSourceInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DataSource/UpdateDataSource";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDataSource(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDataSource(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDataSource(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteDataSource(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DataSource/DeleteDataSource?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteDataSource(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteDataSource(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteDataSource(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class DateTimeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param locationId (optional) 
     * @return Success
     */
    getLocationTimeZone(locationId: number | undefined): Observable<DisplayLocation> {
        let url_ = this.baseUrl + "/api/services/app/DateTime/GetLocationTimeZone?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationTimeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationTimeZone(<any>response_);
                } catch (e) {
                    return <Observable<DisplayLocation>><any>_observableThrow(e);
                }
            } else
                return <Observable<DisplayLocation>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationTimeZone(response: HttpResponseBase): Observable<DisplayLocation> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DisplayLocation.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DisplayLocation>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    convertToUtc(body: InputDateDto | undefined): Observable<DisplayDateDto> {
        let url_ = this.baseUrl + "/api/services/app/DateTime/ConvertToUtc";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertToUtc(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertToUtc(<any>response_);
                } catch (e) {
                    return <Observable<DisplayDateDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<DisplayDateDto>><any>_observableThrow(response_);
        }));
    }

    protected processConvertToUtc(response: HttpResponseBase): Observable<DisplayDateDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DisplayDateDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DisplayDateDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    convertRange(body: InputRangeDateDto | undefined): Observable<DisplayRangeDateDto> {
        let url_ = this.baseUrl + "/api/services/app/DateTime/ConvertRange";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertRange(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertRange(<any>response_);
                } catch (e) {
                    return <Observable<DisplayRangeDateDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<DisplayRangeDateDto>><any>_observableThrow(response_);
        }));
    }

    protected processConvertRange(response: HttpResponseBase): Observable<DisplayRangeDateDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DisplayRangeDateDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DisplayRangeDateDto>(<any>null);
    }
}

@Injectable()
export class DeliveryNoteServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDeliveryNote(body: CreateDeliveryNoteInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/DeliveryNote/CreateDeliveryNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDeliveryNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDeliveryNote(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDeliveryNote(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param noteId (optional) 
     * @param sortOrder (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDeliveryNotes(id: number | undefined, noteId: number | undefined, sortOrder: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfDeliveryNoteListDto> {
        let url_ = this.baseUrl + "/api/services/app/DeliveryNote/GetDeliveryNotes?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (sortOrder === null)
            throw new Error("The parameter 'sortOrder' cannot be null.");
        else if (sortOrder !== undefined)
            url_ += "SortOrder=" + encodeURIComponent("" + sortOrder) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDeliveryNotes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDeliveryNotes(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfDeliveryNoteListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfDeliveryNoteListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDeliveryNotes(response: HttpResponseBase): Observable<PagedResultDtoOfDeliveryNoteListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfDeliveryNoteListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfDeliveryNoteListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDeliveryNote(body: UpdateDeliveryNoteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DeliveryNote/UpdateDeliveryNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDeliveryNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDeliveryNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDeliveryNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteDeliveryNote(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DeliveryNote/DeleteDeliveryNote?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteDeliveryNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteDeliveryNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteDeliveryNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class DemoUiComponentsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param date (optional) 
     * @return Success
     */
    sendAndGetDate(date: moment.Moment | undefined): Observable<DateToStringOutput> {
        let url_ = this.baseUrl + "/api/services/app/DemoUiComponents/SendAndGetDate?";
        if (date === null)
            throw new Error("The parameter 'date' cannot be null.");
        else if (date !== undefined)
            url_ += "date=" + encodeURIComponent(date ? "" + date.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendAndGetDate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendAndGetDate(<any>response_);
                } catch (e) {
                    return <Observable<DateToStringOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<DateToStringOutput>><any>_observableThrow(response_);
        }));
    }

    protected processSendAndGetDate(response: HttpResponseBase): Observable<DateToStringOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DateToStringOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DateToStringOutput>(<any>null);
    }

    /**
     * @param date (optional) 
     * @return Success
     */
    sendAndGetDateTime(date: moment.Moment | undefined): Observable<DateToStringOutput> {
        let url_ = this.baseUrl + "/api/services/app/DemoUiComponents/SendAndGetDateTime?";
        if (date === null)
            throw new Error("The parameter 'date' cannot be null.");
        else if (date !== undefined)
            url_ += "date=" + encodeURIComponent(date ? "" + date.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendAndGetDateTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendAndGetDateTime(<any>response_);
                } catch (e) {
                    return <Observable<DateToStringOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<DateToStringOutput>><any>_observableThrow(response_);
        }));
    }

    protected processSendAndGetDateTime(response: HttpResponseBase): Observable<DateToStringOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DateToStringOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DateToStringOutput>(<any>null);
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @return Success
     */
    sendAndGetDateRange(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined): Observable<DateToStringOutput> {
        let url_ = this.baseUrl + "/api/services/app/DemoUiComponents/SendAndGetDateRange?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "startDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "endDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendAndGetDateRange(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendAndGetDateRange(<any>response_);
                } catch (e) {
                    return <Observable<DateToStringOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<DateToStringOutput>><any>_observableThrow(response_);
        }));
    }

    protected processSendAndGetDateRange(response: HttpResponseBase): Observable<DateToStringOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DateToStringOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DateToStringOutput>(<any>null);
    }

    /**
     * @param searchTerm (optional) 
     * @return Success
     */
    getCountries(searchTerm: string | undefined): Observable<NameValueOfString[]> {
        let url_ = this.baseUrl + "/api/services/app/DemoUiComponents/GetCountries?";
        if (searchTerm === null)
            throw new Error("The parameter 'searchTerm' cannot be null.");
        else if (searchTerm !== undefined)
            url_ += "searchTerm=" + encodeURIComponent("" + searchTerm) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCountries(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCountries(<any>response_);
                } catch (e) {
                    return <Observable<NameValueOfString[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<NameValueOfString[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetCountries(response: HttpResponseBase): Observable<NameValueOfString[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(NameValueOfString.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<NameValueOfString[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendAndGetSelectedCountries(body: NameValueOfString[] | undefined): Observable<NameValueOfString[]> {
        let url_ = this.baseUrl + "/api/services/app/DemoUiComponents/SendAndGetSelectedCountries";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendAndGetSelectedCountries(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendAndGetSelectedCountries(<any>response_);
                } catch (e) {
                    return <Observable<NameValueOfString[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<NameValueOfString[]>><any>_observableThrow(response_);
        }));
    }

    protected processSendAndGetSelectedCountries(response: HttpResponseBase): Observable<NameValueOfString[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(NameValueOfString.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<NameValueOfString[]>(<any>null);
    }

    /**
     * @param input (optional) 
     * @return Success
     */
    sendAndGetValue(input: string | undefined): Observable<StringOutput> {
        let url_ = this.baseUrl + "/api/services/app/DemoUiComponents/SendAndGetValue?";
        if (input === null)
            throw new Error("The parameter 'input' cannot be null.");
        else if (input !== undefined)
            url_ += "input=" + encodeURIComponent("" + input) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendAndGetValue(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendAndGetValue(<any>response_);
                } catch (e) {
                    return <Observable<StringOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<StringOutput>><any>_observableThrow(response_);
        }));
    }

    protected processSendAndGetValue(response: HttpResponseBase): Observable<StringOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = StringOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<StringOutput>(<any>null);
    }
}

@Injectable()
export class DestinationDetailServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param contactId (optional) 
     * @param etaStart (optional) 
     * @param etaEnd (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDestinationDetail(id: number | undefined, contactId: number | undefined, etaStart: moment.Moment | undefined, etaEnd: moment.Moment | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfDestinationDetailListDto> {
        let url_ = this.baseUrl + "/api/services/app/DestinationDetail/GetDestinationDetail?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        if (etaStart === null)
            throw new Error("The parameter 'etaStart' cannot be null.");
        else if (etaStart !== undefined)
            url_ += "EtaStart=" + encodeURIComponent(etaStart ? "" + etaStart.toJSON() : "") + "&"; 
        if (etaEnd === null)
            throw new Error("The parameter 'etaEnd' cannot be null.");
        else if (etaEnd !== undefined)
            url_ += "EtaEnd=" + encodeURIComponent(etaEnd ? "" + etaEnd.toJSON() : "") + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDestinationDetail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDestinationDetail(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfDestinationDetailListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfDestinationDetailListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDestinationDetail(response: HttpResponseBase): Observable<ListResultDtoOfDestinationDetailListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfDestinationDetailListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfDestinationDetailListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDestinationDetail(body: CreateDestinationDetailInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/DestinationDetail/CreateDestinationDetail";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDestinationDetail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDestinationDetail(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDestinationDetail(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDestinationDetail(body: UpdateDestinationDetailInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DestinationDetail/UpdateDestinationDetail";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDestinationDetail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDestinationDetail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDestinationDetail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateEtaEnd(body: UpdateEtaEnd | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DestinationDetail/UpdateEtaEnd";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateEtaEnd(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateEtaEnd(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateEtaEnd(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteDestinationDetail(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DestinationDetail/DeleteDestinationDetail?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteDestinationDetail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteDestinationDetail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteDestinationDetail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class DriverAppLegacyServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param user_name (optional) 
     * @return Success
     */
    checkUserNameVerification(user_name: string | undefined): Observable<CheckUserNameVerificationResult> {
        let url_ = this.baseUrl + "/api/services/app/DriverAppLegacy/CheckUserNameVerification?";
        if (user_name === null)
            throw new Error("The parameter 'user_name' cannot be null.");
        else if (user_name !== undefined)
            url_ += "user_name=" + encodeURIComponent("" + user_name) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckUserNameVerification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckUserNameVerification(<any>response_);
                } catch (e) {
                    return <Observable<CheckUserNameVerificationResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<CheckUserNameVerificationResult>><any>_observableThrow(response_);
        }));
    }

    protected processCheckUserNameVerification(response: HttpResponseBase): Observable<CheckUserNameVerificationResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CheckUserNameVerificationResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CheckUserNameVerificationResult>(<any>null);
    }

    /**
     * @param user_name (optional) 
     * @param mobileNumber (optional) 
     * @return Success
     */
    generateOtp(user_name: string | undefined, mobileNumber: string | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/DriverAppLegacy/GenerateOtp?";
        if (user_name === null)
            throw new Error("The parameter 'user_name' cannot be null.");
        else if (user_name !== undefined)
            url_ += "user_name=" + encodeURIComponent("" + user_name) + "&"; 
        if (mobileNumber === null)
            throw new Error("The parameter 'mobileNumber' cannot be null.");
        else if (mobileNumber !== undefined)
            url_ += "mobileNumber=" + encodeURIComponent("" + mobileNumber) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateOtp(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateOtp(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateOtp(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param user_name (optional) 
     * @param otp (optional) 
     * @return Success
     */
    validateOtp(user_name: string | undefined, otp: string | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/DriverAppLegacy/ValidateOtp?";
        if (user_name === null)
            throw new Error("The parameter 'user_name' cannot be null.");
        else if (user_name !== undefined)
            url_ += "user_name=" + encodeURIComponent("" + user_name) + "&"; 
        if (otp === null)
            throw new Error("The parameter 'otp' cannot be null.");
        else if (otp !== undefined)
            url_ += "otp=" + encodeURIComponent("" + otp) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processValidateOtp(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processValidateOtp(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processValidateOtp(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }
}

@Injectable()
export class DriverClientServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param content (optional) 
     * @param body (optional) 
     * @return Success
     */
    sendNotificationPublic(content: string | undefined, body: User | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/SendNotificationPublic?";
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "content=" + encodeURIComponent("" + content) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendNotificationPublic(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendNotificationPublic(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendNotificationPublic(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param userName (optional) 
     * @param content (optional) 
     * @return Success
     */
    sendSingleNotification(userName: string | undefined, content: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/SendSingleNotification?";
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "userName=" + encodeURIComponent("" + userName) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "content=" + encodeURIComponent("" + content) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendSingleNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendSingleNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendSingleNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getProfile(): Observable<DriverClientProfile> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/GetProfile";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetProfile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetProfile(<any>response_);
                } catch (e) {
                    return <Observable<DriverClientProfile>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverClientProfile>><any>_observableThrow(response_);
        }));
    }

    protected processGetProfile(response: HttpResponseBase): Observable<DriverClientProfile> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DriverClientProfile.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverClientProfile>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    loginUnlock(body: LoginUnlockInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/LoginUnlock";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLoginUnlock(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLoginUnlock(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLoginUnlock(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    loginUnlockById(body: LoginUnlockByIdInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/LoginUnlockById";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLoginUnlockById(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLoginUnlockById(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLoginUnlockById(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getMessages(routeId: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfGetMobileMessagesItemDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/GetMessages?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMessages(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMessages(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetMobileMessagesItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetMobileMessagesItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMessages(response: HttpResponseBase): Observable<ListResultDtoOfGetMobileMessagesItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetMobileMessagesItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetMobileMessagesItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setFirebaseToken(body: SetFirebaseTokenInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/SetFirebaseToken";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetFirebaseToken(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetFirebaseToken(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetFirebaseToken(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    forceLogOff(body: LoginUnlockInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/ForceLogOff";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processForceLogOff(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processForceLogOff(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processForceLogOff(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    forceLogOffById(body: LoginUnlockByIdInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/ForceLogOffById";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processForceLogOffById(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processForceLogOffById(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processForceLogOffById(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getActiveRequestsCount(): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/GetActiveRequestsCount";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetActiveRequestsCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetActiveRequestsCount(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetActiveRequestsCount(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param value (optional) 
     * @return Success
     */
    setMobileClientConnectionLimit(value: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/SetMobileClientConnectionLimit?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "value=" + encodeURIComponent("" + value) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetMobileClientConnectionLimit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetMobileClientConnectionLimit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetMobileClientConnectionLimit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendCacheData(body: SendCacheDataInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/SendCacheData";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendCacheData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendCacheData(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendCacheData(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getMobileClientWarnings(): Observable<MobileClientWarningItemDto[]> {
        let url_ = this.baseUrl + "/api/services/app/DriverClient/GetMobileClientWarnings";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileClientWarnings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileClientWarnings(<any>response_);
                } catch (e) {
                    return <Observable<MobileClientWarningItemDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<MobileClientWarningItemDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileClientWarnings(response: HttpResponseBase): Observable<MobileClientWarningItemDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(MobileClientWarningItemDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<MobileClientWarningItemDto[]>(<any>null);
    }
}

@Injectable()
export class DriverIncidentServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDriverIncident(body: CreateDriverIncidentInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncident/CreateDriverIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDriverIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDriverIncident(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDriverIncident(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param incidentId (optional) 
     * @param userId (optional) 
     * @param userName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDriverIncident(id: number | undefined, incidentId: number | undefined, userId: number | undefined, userName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfDriverIncidentListDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncident/GetDriverIncident?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (incidentId === null)
            throw new Error("The parameter 'incidentId' cannot be null.");
        else if (incidentId !== undefined)
            url_ += "IncidentId=" + encodeURIComponent("" + incidentId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "UserName=" + encodeURIComponent("" + userName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverIncident(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfDriverIncidentListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfDriverIncidentListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverIncident(response: HttpResponseBase): Observable<PagedResultDtoOfDriverIncidentListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfDriverIncidentListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfDriverIncidentListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDriverIncident(body: UpdateDriverIncidentInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncident/UpdateDriverIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDriverIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDriverIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDriverIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteDriverIncident(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncident/DeleteDriverIncident?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteDriverIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteDriverIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteDriverIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class DriverIncidentsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDriverIncident(body: CreateOrEditDriverIncidentsInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidents/CreateDriverIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDriverIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDriverIncident(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDriverIncident(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param content (optional) 
     * @param incidentTypeId (optional) 
     * @param userId (optional) 
     * @param driverName (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDriverIncident(id: number | undefined, filter: string | undefined, content: string | undefined, incidentTypeId: number | undefined, userId: number | undefined, driverName: string | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfDriverIncidentsListDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidents/GetDriverIncident?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (incidentTypeId === null)
            throw new Error("The parameter 'incidentTypeId' cannot be null.");
        else if (incidentTypeId !== undefined)
            url_ += "IncidentTypeId=" + encodeURIComponent("" + incidentTypeId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverIncident(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfDriverIncidentsListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfDriverIncidentsListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverIncident(response: HttpResponseBase): Observable<PagedResultDtoOfDriverIncidentsListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfDriverIncidentsListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfDriverIncidentsListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDriverIncident(body: CreateOrEditDriverIncidentsInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidents/UpdateDriverIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDriverIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDriverIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDriverIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getDriverIncidentForEdit(id: number | undefined): Observable<GetDriverIncidentForEditDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidents/GetDriverIncidentForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverIncidentForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverIncidentForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetDriverIncidentForEditDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDriverIncidentForEditDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverIncidentForEdit(response: HttpResponseBase): Observable<GetDriverIncidentForEditDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDriverIncidentForEditDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDriverIncidentForEditDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteDriverIncident(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidents/DeleteDriverIncident?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteDriverIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteDriverIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteDriverIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param content (optional) 
     * @param incidentTypeId (optional) 
     * @param userId (optional) 
     * @param driverName (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDriverIncidentsExcel(id: number | undefined, filter: string | undefined, content: string | undefined, incidentTypeId: number | undefined, userId: number | undefined, driverName: string | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidents/GetDriverIncidentsExcel?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (incidentTypeId === null)
            throw new Error("The parameter 'incidentTypeId' cannot be null.");
        else if (incidentTypeId !== undefined)
            url_ += "IncidentTypeId=" + encodeURIComponent("" + incidentTypeId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (driverName === null)
            throw new Error("The parameter 'driverName' cannot be null.");
        else if (driverName !== undefined)
            url_ += "DriverName=" + encodeURIComponent("" + driverName) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverIncidentsExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverIncidentsExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverIncidentsExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getDriverList(): Observable<GetDriverList[]> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidents/GetDriverList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverList(<any>response_);
                } catch (e) {
                    return <Observable<GetDriverList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDriverList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverList(response: HttpResponseBase): Observable<GetDriverList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetDriverList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDriverList[]>(<any>null);
    }

    /**
     * @return Success
     */
    getManagers(): Observable<GetManagerResult[]> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidents/GetManagers";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetManagers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetManagers(<any>response_);
                } catch (e) {
                    return <Observable<GetManagerResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetManagerResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetManagers(response: HttpResponseBase): Observable<GetManagerResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetManagerResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetManagerResult[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getAttachments(id: number | undefined): Observable<GetAttachmentListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidents/GetAttachments?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAttachments(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAttachments(<any>response_);
                } catch (e) {
                    return <Observable<GetAttachmentListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetAttachmentListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAttachments(response: HttpResponseBase): Observable<GetAttachmentListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetAttachmentListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetAttachmentListDto[]>(<any>null);
    }
}

@Injectable()
export class DriverIncidentTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param codeFilter (optional) 
     * @param maxSortOrderFilter (optional) 
     * @param minSortOrderFilter (optional) 
     * @param isStaticFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, codeFilter: string | undefined, maxSortOrderFilter: number | undefined, minSortOrderFilter: number | undefined, isStaticFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetDriverIncidentTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidentTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (maxSortOrderFilter === null)
            throw new Error("The parameter 'maxSortOrderFilter' cannot be null.");
        else if (maxSortOrderFilter !== undefined)
            url_ += "MaxSortOrderFilter=" + encodeURIComponent("" + maxSortOrderFilter) + "&"; 
        if (minSortOrderFilter === null)
            throw new Error("The parameter 'minSortOrderFilter' cannot be null.");
        else if (minSortOrderFilter !== undefined)
            url_ += "MinSortOrderFilter=" + encodeURIComponent("" + minSortOrderFilter) + "&"; 
        if (isStaticFilter === null)
            throw new Error("The parameter 'isStaticFilter' cannot be null.");
        else if (isStaticFilter !== undefined)
            url_ += "IsStaticFilter=" + encodeURIComponent("" + isStaticFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetDriverIncidentTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetDriverIncidentTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetDriverIncidentTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetDriverIncidentTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetDriverIncidentTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getDriverIncidentTypeForView(id: number | undefined): Observable<GetDriverIncidentTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidentTypes/GetDriverIncidentTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverIncidentTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverIncidentTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetDriverIncidentTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDriverIncidentTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverIncidentTypeForView(response: HttpResponseBase): Observable<GetDriverIncidentTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDriverIncidentTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDriverIncidentTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getDriverIncidentTypeForEdit(id: number | undefined): Observable<GetDriverIncidentTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidentTypes/GetDriverIncidentTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverIncidentTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverIncidentTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetDriverIncidentTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDriverIncidentTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverIncidentTypeForEdit(response: HttpResponseBase): Observable<GetDriverIncidentTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDriverIncidentTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDriverIncidentTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditDriverIncidentTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidentTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidentTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param codeFilter (optional) 
     * @param maxSortOrderFilter (optional) 
     * @param minSortOrderFilter (optional) 
     * @param isStaticFilter (optional) 
     * @return Success
     */
    getDriverIncidentTypesToExcel(filter: string | undefined, nameFilter: string | undefined, codeFilter: string | undefined, maxSortOrderFilter: number | undefined, minSortOrderFilter: number | undefined, isStaticFilter: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverIncidentTypes/GetDriverIncidentTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (maxSortOrderFilter === null)
            throw new Error("The parameter 'maxSortOrderFilter' cannot be null.");
        else if (maxSortOrderFilter !== undefined)
            url_ += "MaxSortOrderFilter=" + encodeURIComponent("" + maxSortOrderFilter) + "&"; 
        if (minSortOrderFilter === null)
            throw new Error("The parameter 'minSortOrderFilter' cannot be null.");
        else if (minSortOrderFilter !== undefined)
            url_ += "MinSortOrderFilter=" + encodeURIComponent("" + minSortOrderFilter) + "&"; 
        if (isStaticFilter === null)
            throw new Error("The parameter 'isStaticFilter' cannot be null.");
        else if (isStaticFilter !== undefined)
            url_ += "IsStaticFilter=" + encodeURIComponent("" + isStaticFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverIncidentTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverIncidentTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverIncidentTypesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class DriverLogoutServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    logout(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverLogout/Logout";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLogout(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLogout(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLogout(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class DriverProximityServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param orderId (optional) 
     * @param userId (optional) 
     * @param locationId (optional) 
     * @param vehicleName (optional) 
     * @param address (optional) 
     * @param proximityCode (optional) 
     * @param accepted (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param customer (optional) 
     * @param accountNumber (optional) 
     * @param clinicName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPeople(filter: string | undefined, vehicleId: number | undefined, routeId: number | undefined, orderId: number | undefined, userId: number | undefined, locationId: number | undefined, vehicleName: string | undefined, address: string | undefined, proximityCode: string | undefined, accepted: boolean | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, customer: string | undefined, accountNumber: string | undefined, clinicName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ListResultDtoOfRouteListDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverProximity/GetPeople?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (address === null)
            throw new Error("The parameter 'address' cannot be null.");
        else if (address !== undefined)
            url_ += "Address=" + encodeURIComponent("" + address) + "&"; 
        if (proximityCode === null)
            throw new Error("The parameter 'proximityCode' cannot be null.");
        else if (proximityCode !== undefined)
            url_ += "ProximityCode=" + encodeURIComponent("" + proximityCode) + "&"; 
        if (accepted === null)
            throw new Error("The parameter 'accepted' cannot be null.");
        else if (accepted !== undefined)
            url_ += "Accepted=" + encodeURIComponent("" + accepted) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (customer === null)
            throw new Error("The parameter 'customer' cannot be null.");
        else if (customer !== undefined)
            url_ += "Customer=" + encodeURIComponent("" + customer) + "&"; 
        if (accountNumber === null)
            throw new Error("The parameter 'accountNumber' cannot be null.");
        else if (accountNumber !== undefined)
            url_ += "AccountNumber=" + encodeURIComponent("" + accountNumber) + "&"; 
        if (clinicName === null)
            throw new Error("The parameter 'clinicName' cannot be null.");
        else if (clinicName !== undefined)
            url_ += "ClinicName=" + encodeURIComponent("" + clinicName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPeople(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPeople(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfRouteListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfRouteListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPeople(response: HttpResponseBase): Observable<ListResultDtoOfRouteListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfRouteListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfRouteListDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param vehicleId (optional) 
     * @param routeId (optional) 
     * @param orderId (optional) 
     * @param userId (optional) 
     * @param locationId (optional) 
     * @param vehicleName (optional) 
     * @param address (optional) 
     * @param proximityCode (optional) 
     * @param accepted (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param customer (optional) 
     * @param accountNumber (optional) 
     * @param clinicName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDriverProximity(filter: string | undefined, vehicleId: number | undefined, routeId: number | undefined, orderId: number | undefined, userId: number | undefined, locationId: number | undefined, vehicleName: string | undefined, address: string | undefined, proximityCode: string | undefined, accepted: boolean | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, customer: string | undefined, accountNumber: string | undefined, clinicName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<DriverProximityDto[]> {
        let url_ = this.baseUrl + "/api/services/app/DriverProximity/GetDriverProximity?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (address === null)
            throw new Error("The parameter 'address' cannot be null.");
        else if (address !== undefined)
            url_ += "Address=" + encodeURIComponent("" + address) + "&"; 
        if (proximityCode === null)
            throw new Error("The parameter 'proximityCode' cannot be null.");
        else if (proximityCode !== undefined)
            url_ += "ProximityCode=" + encodeURIComponent("" + proximityCode) + "&"; 
        if (accepted === null)
            throw new Error("The parameter 'accepted' cannot be null.");
        else if (accepted !== undefined)
            url_ += "Accepted=" + encodeURIComponent("" + accepted) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (customer === null)
            throw new Error("The parameter 'customer' cannot be null.");
        else if (customer !== undefined)
            url_ += "Customer=" + encodeURIComponent("" + customer) + "&"; 
        if (accountNumber === null)
            throw new Error("The parameter 'accountNumber' cannot be null.");
        else if (accountNumber !== undefined)
            url_ += "AccountNumber=" + encodeURIComponent("" + accountNumber) + "&"; 
        if (clinicName === null)
            throw new Error("The parameter 'clinicName' cannot be null.");
        else if (clinicName !== undefined)
            url_ += "ClinicName=" + encodeURIComponent("" + clinicName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverProximity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverProximity(<any>response_);
                } catch (e) {
                    return <Observable<DriverProximityDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverProximityDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverProximity(response: HttpResponseBase): Observable<DriverProximityDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(DriverProximityDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverProximityDto[]>(<any>null);
    }

    /**
     * @param meters (optional) 
     * @return Success
     */
    convertMetersToMiles(meters: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/DriverProximity/ConvertMetersToMiles?";
        if (meters === null)
            throw new Error("The parameter 'meters' cannot be null.");
        else if (meters !== undefined)
            url_ += "meters=" + encodeURIComponent("" + meters) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertMetersToMiles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertMetersToMiles(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processConvertMetersToMiles(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    acceptProximity(body: AcceptProximityInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/DriverProximity/AcceptProximity";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAcceptProximity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAcceptProximity(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAcceptProximity(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param locationId (optional) 
     * @param isDeliveryCode (optional) 
     * @return Success
     */
    getDriverProximityDetails(orderId: number | undefined, locationId: number | undefined, isDeliveryCode: boolean | undefined): Observable<DriverProximityDetails> {
        let url_ = this.baseUrl + "/api/services/app/DriverProximity/GetDriverProximityDetails?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (isDeliveryCode === null)
            throw new Error("The parameter 'isDeliveryCode' cannot be null.");
        else if (isDeliveryCode !== undefined)
            url_ += "isDeliveryCode=" + encodeURIComponent("" + isDeliveryCode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverProximityDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverProximityDetails(<any>response_);
                } catch (e) {
                    return <Observable<DriverProximityDetails>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverProximityDetails>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverProximityDetails(response: HttpResponseBase): Observable<DriverProximityDetails> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DriverProximityDetails.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverProximityDetails>(<any>null);
    }
}

@Injectable()
export class DriverRatingServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDriverRating(body: CreateDriverRatingInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/DriverRating/CreateDriverRating";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDriverRating(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDriverRating(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDriverRating(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param trackId (optional) 
     * @return Success
     */
    getDriverRating(trackId: string | undefined): Observable<DriverRatingDto> {
        let url_ = this.baseUrl + "/api/services/app/DriverRating/GetDriverRating?";
        if (trackId === null)
            throw new Error("The parameter 'trackId' cannot be null.");
        else if (trackId !== undefined)
            url_ += "TrackId=" + encodeURIComponent("" + trackId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverRating(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverRating(<any>response_);
                } catch (e) {
                    return <Observable<DriverRatingDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverRatingDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverRating(response: HttpResponseBase): Observable<DriverRatingDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DriverRatingDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverRatingDto>(<any>null);
    }
}

@Injectable()
export class DriverReportsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param locationId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @return Success
     */
    getDriverReportDetails(locationId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined): Observable<DriverReportDetailDto[]> {
        let url_ = this.baseUrl + "/api/services/app/DriverReports/GetDriverReportDetails?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverReportDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverReportDetails(<any>response_);
                } catch (e) {
                    return <Observable<DriverReportDetailDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverReportDetailDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverReportDetails(response: HttpResponseBase): Observable<DriverReportDetailDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(DriverReportDetailDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverReportDetailDto[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @return Success
     */
    getDriverReportSummary(locationId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined): Observable<DriverReportSummaryDto[]> {
        let url_ = this.baseUrl + "/api/services/app/DriverReports/GetDriverReportSummary?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverReportSummary(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverReportSummary(<any>response_);
                } catch (e) {
                    return <Observable<DriverReportSummaryDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverReportSummaryDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverReportSummary(response: HttpResponseBase): Observable<DriverReportSummaryDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(DriverReportSummaryDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverReportSummaryDto[]>(<any>null);
    }
}

@Injectable()
export class DriversServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param emailAddress (optional) 
     * @param name (optional) 
     * @param surname (optional) 
     * @param isEmailConfirmed (optional) 
     * @param isAppVersionUpdated (optional) 
     * @param onlyLockedUsers (optional) 
     * @param locationIds (optional) 
     * @param fleetIds (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDriversToExcel(filter: string | undefined, emailAddress: string | undefined, name: string | undefined, surname: string | undefined, isEmailConfirmed: boolean | undefined, isAppVersionUpdated: boolean | undefined, onlyLockedUsers: boolean | undefined, locationIds: number[] | undefined, fleetIds: number[] | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetDriversToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (emailAddress === null)
            throw new Error("The parameter 'emailAddress' cannot be null.");
        else if (emailAddress !== undefined)
            url_ += "EmailAddress=" + encodeURIComponent("" + emailAddress) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (surname === null)
            throw new Error("The parameter 'surname' cannot be null.");
        else if (surname !== undefined)
            url_ += "Surname=" + encodeURIComponent("" + surname) + "&"; 
        if (isEmailConfirmed === null)
            throw new Error("The parameter 'isEmailConfirmed' cannot be null.");
        else if (isEmailConfirmed !== undefined)
            url_ += "isEmailConfirmed=" + encodeURIComponent("" + isEmailConfirmed) + "&"; 
        if (isAppVersionUpdated === null)
            throw new Error("The parameter 'isAppVersionUpdated' cannot be null.");
        else if (isAppVersionUpdated !== undefined)
            url_ += "isAppVersionUpdated=" + encodeURIComponent("" + isAppVersionUpdated) + "&"; 
        if (onlyLockedUsers === null)
            throw new Error("The parameter 'onlyLockedUsers' cannot be null.");
        else if (onlyLockedUsers !== undefined)
            url_ += "OnlyLockedUsers=" + encodeURIComponent("" + onlyLockedUsers) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (fleetIds === null)
            throw new Error("The parameter 'fleetIds' cannot be null.");
        else if (fleetIds !== undefined)
            fleetIds && fleetIds.forEach(item => { url_ += "FleetIds=" + encodeURIComponent("" + item) + "&"; });
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriversToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriversToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriversToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param emailAddress (optional) 
     * @param name (optional) 
     * @param surname (optional) 
     * @param isEmailConfirmed (optional) 
     * @param isAppVersionUpdated (optional) 
     * @param onlyLockedUsers (optional) 
     * @param locationIds (optional) 
     * @param fleetIds (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getDrivers(filter: string | undefined, emailAddress: string | undefined, name: string | undefined, surname: string | undefined, isEmailConfirmed: boolean | undefined, isAppVersionUpdated: boolean | undefined, onlyLockedUsers: boolean | undefined, locationIds: number[] | undefined, fleetIds: number[] | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetDriverListDto> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetDrivers?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (emailAddress === null)
            throw new Error("The parameter 'emailAddress' cannot be null.");
        else if (emailAddress !== undefined)
            url_ += "EmailAddress=" + encodeURIComponent("" + emailAddress) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (surname === null)
            throw new Error("The parameter 'surname' cannot be null.");
        else if (surname !== undefined)
            url_ += "Surname=" + encodeURIComponent("" + surname) + "&"; 
        if (isEmailConfirmed === null)
            throw new Error("The parameter 'isEmailConfirmed' cannot be null.");
        else if (isEmailConfirmed !== undefined)
            url_ += "isEmailConfirmed=" + encodeURIComponent("" + isEmailConfirmed) + "&"; 
        if (isAppVersionUpdated === null)
            throw new Error("The parameter 'isAppVersionUpdated' cannot be null.");
        else if (isAppVersionUpdated !== undefined)
            url_ += "isAppVersionUpdated=" + encodeURIComponent("" + isAppVersionUpdated) + "&"; 
        if (onlyLockedUsers === null)
            throw new Error("The parameter 'onlyLockedUsers' cannot be null.");
        else if (onlyLockedUsers !== undefined)
            url_ += "OnlyLockedUsers=" + encodeURIComponent("" + onlyLockedUsers) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (fleetIds === null)
            throw new Error("The parameter 'fleetIds' cannot be null.");
        else if (fleetIds !== undefined)
            fleetIds && fleetIds.forEach(item => { url_ += "FleetIds=" + encodeURIComponent("" + item) + "&"; });
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDrivers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDrivers(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetDriverListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetDriverListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDrivers(response: HttpResponseBase): Observable<PagedResultDtoOfGetDriverListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetDriverListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetDriverListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getDriverForEdit(id: number | undefined): Observable<GetDriverForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetDriverForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetDriverForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDriverForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverForEdit(response: HttpResponseBase): Observable<GetDriverForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDriverForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDriverForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateDriver(body: CreateOrUpdateContactUserInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/CreateOrUpdateDriver";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateDriver(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateDriver(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteDriver(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/DeleteDriver?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteDriver(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteDriver(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    driverEmailConfirm(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/DriverEmailConfirm";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDriverEmailConfirm(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDriverEmailConfirm(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDriverEmailConfirm(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    unlockDriver(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/UnlockDriver";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnlockDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnlockDriver(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnlockDriver(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    lockDriver(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/LockDriver";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLockDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLockDriver(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLockDriver(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateResetUserPassword(body: GetUserIdInputForResetPassword | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/UpdateResetUserPassword";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateResetUserPassword(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateResetUserPassword(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateResetUserPassword(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateResetMultipleUserPassword(body: GetMultipleUserIdForResetPassword | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/UpdateResetMultipleUserPassword";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateResetMultipleUserPassword(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateResetMultipleUserPassword(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateResetMultipleUserPassword(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getDriverDetails(id: number | undefined): Observable<GetDriverDetailsDto> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetDriverDetails?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverDetails(<any>response_);
                } catch (e) {
                    return <Observable<GetDriverDetailsDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDriverDetailsDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverDetails(response: HttpResponseBase): Observable<GetDriverDetailsDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDriverDetailsDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDriverDetailsDto>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @return Success
     */
    getAvailableDriver(locationId: number | undefined): Observable<GetAvailableDriverDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetAvailableDriver?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAvailableDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAvailableDriver(<any>response_);
                } catch (e) {
                    return <Observable<GetAvailableDriverDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetAvailableDriverDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAvailableDriver(response: HttpResponseBase): Observable<GetAvailableDriverDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetAvailableDriverDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetAvailableDriverDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDriverInfo(body: CreateOrUpdateDriverInfoInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/CreateDriverInfo";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDriverInfo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDriverInfo(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDriverInfo(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param userId (optional) 
     * @return Success
     */
    getDriverProfile(userId: number | undefined): Observable<DriverProfileListDto> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetDriverProfile?";
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverProfile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverProfile(<any>response_);
                } catch (e) {
                    return <Observable<DriverProfileListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverProfileListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverProfile(response: HttpResponseBase): Observable<DriverProfileListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DriverProfileListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverProfileListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDriverInfo(body: CreateOrUpdateDriverInfoInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/UpdateDriverInfo";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDriverInfo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDriverInfo(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDriverInfo(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param licenseNumber (optional) 
     * @param userId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAvailableVehicle(id: number | undefined, name: string | undefined, licenseNumber: string | undefined, userId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<AvailableVehicleListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetAvailableVehicle?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (licenseNumber === null)
            throw new Error("The parameter 'licenseNumber' cannot be null.");
        else if (licenseNumber !== undefined)
            url_ += "LicenseNumber=" + encodeURIComponent("" + licenseNumber) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAvailableVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAvailableVehicle(<any>response_);
                } catch (e) {
                    return <Observable<AvailableVehicleListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<AvailableVehicleListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAvailableVehicle(response: HttpResponseBase): Observable<AvailableVehicleListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(AvailableVehicleListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<AvailableVehicleListDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getUnassignedDrivers(): Observable<GetUnassignedDrivers[]> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetUnassignedDrivers";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUnassignedDrivers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUnassignedDrivers(<any>response_);
                } catch (e) {
                    return <Observable<GetUnassignedDrivers[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUnassignedDrivers[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetUnassignedDrivers(response: HttpResponseBase): Observable<GetUnassignedDrivers[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetUnassignedDrivers.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUnassignedDrivers[]>(<any>null);
    }

    /**
     * @return Success
     */
    getDriverList(): Observable<GetDriverList[]> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetDriverList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverList(<any>response_);
                } catch (e) {
                    return <Observable<GetDriverList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDriverList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverList(response: HttpResponseBase): Observable<GetDriverList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetDriverList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDriverList[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateDriverAPI(body: CreateDriverInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/CreateOrUpdateDriverAPI";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateDriverAPI(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateDriverAPI(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateDriverAPI(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getPagedDriverList(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/GetPagedDriverList?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPagedDriverList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPagedDriverList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPagedDriverList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    allowDriverToSkip(body: AllowDisableDriverToSkipInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/AllowDriverToSkip";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAllowDriverToSkip(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAllowDriverToSkip(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAllowDriverToSkip(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    disableDriverToSkip(body: AllowDisableDriverToSkipInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Drivers/DisableDriverToSkip";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDisableDriverToSkip(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDisableDriverToSkip(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDisableDriverToSkip(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class EditionServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getEditions(): Observable<ListResultDtoOfEditionListDto> {
        let url_ = this.baseUrl + "/api/services/app/Edition/GetEditions";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEditions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEditions(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfEditionListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfEditionListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEditions(response: HttpResponseBase): Observable<ListResultDtoOfEditionListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfEditionListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfEditionListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getEditionForEdit(id: number | undefined): Observable<GetEditionEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Edition/GetEditionForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEditionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEditionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetEditionEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetEditionEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetEditionForEdit(response: HttpResponseBase): Observable<GetEditionEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetEditionEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetEditionEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createEdition(body: CreateEditionDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Edition/CreateEdition";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateEdition(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateEdition(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateEdition(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateEdition(body: UpdateEditionDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Edition/UpdateEdition";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateEdition(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateEdition(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateEdition(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteEdition(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Edition/DeleteEdition?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteEdition(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteEdition(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteEdition(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    moveTenantsToAnotherEdition(body: MoveTenantsToAnotherEditionDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Edition/MoveTenantsToAnotherEdition";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMoveTenantsToAnotherEdition(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMoveTenantsToAnotherEdition(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processMoveTenantsToAnotherEdition(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param selectedEditionId (optional) 
     * @param addAllItem (optional) 
     * @param onlyFreeItems (optional) 
     * @return Success
     */
    getEditionComboboxItems(selectedEditionId: number | undefined, addAllItem: boolean | undefined, onlyFreeItems: boolean | undefined): Observable<SubscribableEditionComboboxItemDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Edition/GetEditionComboboxItems?";
        if (selectedEditionId === null)
            throw new Error("The parameter 'selectedEditionId' cannot be null.");
        else if (selectedEditionId !== undefined)
            url_ += "selectedEditionId=" + encodeURIComponent("" + selectedEditionId) + "&"; 
        if (addAllItem === null)
            throw new Error("The parameter 'addAllItem' cannot be null.");
        else if (addAllItem !== undefined)
            url_ += "addAllItem=" + encodeURIComponent("" + addAllItem) + "&"; 
        if (onlyFreeItems === null)
            throw new Error("The parameter 'onlyFreeItems' cannot be null.");
        else if (onlyFreeItems !== undefined)
            url_ += "onlyFreeItems=" + encodeURIComponent("" + onlyFreeItems) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEditionComboboxItems(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEditionComboboxItems(<any>response_);
                } catch (e) {
                    return <Observable<SubscribableEditionComboboxItemDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<SubscribableEditionComboboxItemDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetEditionComboboxItems(response: HttpResponseBase): Observable<SubscribableEditionComboboxItemDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(SubscribableEditionComboboxItemDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SubscribableEditionComboboxItemDto[]>(<any>null);
    }

    /**
     * @param editionId (optional) 
     * @return Success
     */
    getTenantCount(editionId: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Edition/GetTenantCount?";
        if (editionId === null)
            throw new Error("The parameter 'editionId' cannot be null.");
        else if (editionId !== undefined)
            url_ += "editionId=" + encodeURIComponent("" + editionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantCount(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantCount(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class EmailServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createEmail(body: CreateEmailInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Email/CreateEmail";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateEmail(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateEmail(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteEmail(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Email/DeleteEmail?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteEmail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteEmail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param contactId (optional) 
     * @param value (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getEmailList(id: number | undefined, contactId: number | undefined, value: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfEmailListDto> {
        let url_ = this.baseUrl + "/api/services/app/Email/GetEmailList?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmailList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmailList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfEmailListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfEmailListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmailList(response: HttpResponseBase): Observable<PagedResultDtoOfEmailListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfEmailListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfEmailListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateEmail(body: UpdateEmailInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Email/UpdateEmail";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateEmail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateEmail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class EmployeeIncidentsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createEmployeeIncident(body: CreateOrEditEmployeeIncidentsInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidents/CreateEmployeeIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateEmployeeIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateEmployeeIncident(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateEmployeeIncident(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param content (optional) 
     * @param incidentTypeId (optional) 
     * @param userId (optional) 
     * @param employeeName (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getEmployeeIncident(id: number | undefined, filter: string | undefined, content: string | undefined, incidentTypeId: number | undefined, userId: number | undefined, employeeName: string | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfEmployeeIncidentsListDto> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidents/GetEmployeeIncident?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (incidentTypeId === null)
            throw new Error("The parameter 'incidentTypeId' cannot be null.");
        else if (incidentTypeId !== undefined)
            url_ += "IncidentTypeId=" + encodeURIComponent("" + incidentTypeId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (employeeName === null)
            throw new Error("The parameter 'employeeName' cannot be null.");
        else if (employeeName !== undefined)
            url_ += "EmployeeName=" + encodeURIComponent("" + employeeName) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeeIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeeIncident(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfEmployeeIncidentsListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfEmployeeIncidentsListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeeIncident(response: HttpResponseBase): Observable<PagedResultDtoOfEmployeeIncidentsListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfEmployeeIncidentsListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfEmployeeIncidentsListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateEmployeeIncident(body: CreateOrEditEmployeeIncidentsInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidents/UpdateEmployeeIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateEmployeeIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateEmployeeIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateEmployeeIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getEmployeeIncidentForEdit(id: number | undefined): Observable<GetEmployeeIncidentForEditDto> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidents/GetEmployeeIncidentForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeeIncidentForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeeIncidentForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetEmployeeIncidentForEditDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetEmployeeIncidentForEditDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeeIncidentForEdit(response: HttpResponseBase): Observable<GetEmployeeIncidentForEditDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetEmployeeIncidentForEditDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetEmployeeIncidentForEditDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteEmployeeIncident(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidents/DeleteEmployeeIncident?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteEmployeeIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteEmployeeIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteEmployeeIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param content (optional) 
     * @param incidentTypeId (optional) 
     * @param userId (optional) 
     * @param employeeName (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getEmployeeIncidentsExcel(id: number | undefined, filter: string | undefined, content: string | undefined, incidentTypeId: number | undefined, userId: number | undefined, employeeName: string | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidents/GetEmployeeIncidentsExcel?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (incidentTypeId === null)
            throw new Error("The parameter 'incidentTypeId' cannot be null.");
        else if (incidentTypeId !== undefined)
            url_ += "IncidentTypeId=" + encodeURIComponent("" + incidentTypeId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (employeeName === null)
            throw new Error("The parameter 'employeeName' cannot be null.");
        else if (employeeName !== undefined)
            url_ += "EmployeeName=" + encodeURIComponent("" + employeeName) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeeIncidentsExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeeIncidentsExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeeIncidentsExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getEmployeeList(): Observable<GetEmployeeList[]> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidents/GetEmployeeList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeeList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeeList(<any>response_);
                } catch (e) {
                    return <Observable<GetEmployeeList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetEmployeeList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeeList(response: HttpResponseBase): Observable<GetEmployeeList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetEmployeeList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetEmployeeList[]>(<any>null);
    }

    /**
     * @return Success
     */
    getManagers(): Observable<GetManagerResult[]> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidents/GetManagers";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetManagers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetManagers(<any>response_);
                } catch (e) {
                    return <Observable<GetManagerResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetManagerResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetManagers(response: HttpResponseBase): Observable<GetManagerResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetManagerResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetManagerResult[]>(<any>null);
    }
}

@Injectable()
export class EmployeeIncidentTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param codeFilter (optional) 
     * @param maxSortOrderFilter (optional) 
     * @param minSortOrderFilter (optional) 
     * @param isStaticFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, codeFilter: string | undefined, maxSortOrderFilter: number | undefined, minSortOrderFilter: number | undefined, isStaticFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetEmployeeIncidentTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidentTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (maxSortOrderFilter === null)
            throw new Error("The parameter 'maxSortOrderFilter' cannot be null.");
        else if (maxSortOrderFilter !== undefined)
            url_ += "MaxSortOrderFilter=" + encodeURIComponent("" + maxSortOrderFilter) + "&"; 
        if (minSortOrderFilter === null)
            throw new Error("The parameter 'minSortOrderFilter' cannot be null.");
        else if (minSortOrderFilter !== undefined)
            url_ += "MinSortOrderFilter=" + encodeURIComponent("" + minSortOrderFilter) + "&"; 
        if (isStaticFilter === null)
            throw new Error("The parameter 'isStaticFilter' cannot be null.");
        else if (isStaticFilter !== undefined)
            url_ += "IsStaticFilter=" + encodeURIComponent("" + isStaticFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetEmployeeIncidentTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetEmployeeIncidentTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetEmployeeIncidentTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetEmployeeIncidentTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetEmployeeIncidentTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getEmployeeIncidentTypeForView(id: number | undefined): Observable<GetEmployeeIncidentTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidentTypes/GetEmployeeIncidentTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeeIncidentTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeeIncidentTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetEmployeeIncidentTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetEmployeeIncidentTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeeIncidentTypeForView(response: HttpResponseBase): Observable<GetEmployeeIncidentTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetEmployeeIncidentTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetEmployeeIncidentTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getEmployeeIncidentTypeForEdit(id: number | undefined): Observable<GetEmployeeIncidentTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidentTypes/GetEmployeeIncidentTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeeIncidentTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeeIncidentTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetEmployeeIncidentTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetEmployeeIncidentTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeeIncidentTypeForEdit(response: HttpResponseBase): Observable<GetEmployeeIncidentTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetEmployeeIncidentTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetEmployeeIncidentTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditEmployeeIncidentTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidentTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidentTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param codeFilter (optional) 
     * @param maxSortOrderFilter (optional) 
     * @param minSortOrderFilter (optional) 
     * @param isStaticFilter (optional) 
     * @return Success
     */
    getEmployeeIncidentTypesToExcel(filter: string | undefined, nameFilter: string | undefined, codeFilter: string | undefined, maxSortOrderFilter: number | undefined, minSortOrderFilter: number | undefined, isStaticFilter: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeIncidentTypes/GetEmployeeIncidentTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (maxSortOrderFilter === null)
            throw new Error("The parameter 'maxSortOrderFilter' cannot be null.");
        else if (maxSortOrderFilter !== undefined)
            url_ += "MaxSortOrderFilter=" + encodeURIComponent("" + maxSortOrderFilter) + "&"; 
        if (minSortOrderFilter === null)
            throw new Error("The parameter 'minSortOrderFilter' cannot be null.");
        else if (minSortOrderFilter !== undefined)
            url_ += "MinSortOrderFilter=" + encodeURIComponent("" + minSortOrderFilter) + "&"; 
        if (isStaticFilter === null)
            throw new Error("The parameter 'isStaticFilter' cannot be null.");
        else if (isStaticFilter !== undefined)
            url_ += "IsStaticFilter=" + encodeURIComponent("" + isStaticFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeeIncidentTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeeIncidentTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeeIncidentTypesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class EmployeeReviewServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createEmployeeReview(body: CreateEmployeeReviewInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeReview/CreateEmployeeReview";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateEmployeeReview(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateEmployeeReview(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateEmployeeReview(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param reviewId (optional) 
     * @param userName (optional) 
     * @param employeeFilter (optional) 
     * @param reviewFilter (optional) 
     * @param ratingFilter (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getEmployeeReview(id: number | undefined, userId: number | undefined, reviewId: number | undefined, userName: string | undefined, employeeFilter: string | undefined, reviewFilter: string | undefined, ratingFilter: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfEmployeeReviewListDto> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeReview/GetEmployeeReview?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (reviewId === null)
            throw new Error("The parameter 'reviewId' cannot be null.");
        else if (reviewId !== undefined)
            url_ += "ReviewId=" + encodeURIComponent("" + reviewId) + "&"; 
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "UserName=" + encodeURIComponent("" + userName) + "&"; 
        if (employeeFilter === null)
            throw new Error("The parameter 'employeeFilter' cannot be null.");
        else if (employeeFilter !== undefined)
            url_ += "EmployeeFilter=" + encodeURIComponent("" + employeeFilter) + "&"; 
        if (reviewFilter === null)
            throw new Error("The parameter 'reviewFilter' cannot be null.");
        else if (reviewFilter !== undefined)
            url_ += "ReviewFilter=" + encodeURIComponent("" + reviewFilter) + "&"; 
        if (ratingFilter === null)
            throw new Error("The parameter 'ratingFilter' cannot be null.");
        else if (ratingFilter !== undefined)
            url_ += "RatingFilter=" + encodeURIComponent("" + ratingFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeeReview(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeeReview(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfEmployeeReviewListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfEmployeeReviewListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeeReview(response: HttpResponseBase): Observable<PagedResultDtoOfEmployeeReviewListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfEmployeeReviewListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfEmployeeReviewListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateEmployeeReview(body: UpdateEmployeeReviewInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeReview/UpdateEmployeeReview";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateEmployeeReview(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateEmployeeReview(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateEmployeeReview(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteEmployeeReview(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeReview/DeleteEmployeeReview?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteEmployeeReview(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteEmployeeReview(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteEmployeeReview(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class EmployeesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param emailAddress (optional) 
     * @param name (optional) 
     * @param surname (optional) 
     * @param isEmailConfirmed (optional) 
     * @param onlyLockedUsers (optional) 
     * @param locationIds (optional) 
     * @param idNumber (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getEmployeesToExcel(filter: string | undefined, emailAddress: string | undefined, name: string | undefined, surname: string | undefined, isEmailConfirmed: boolean | undefined, onlyLockedUsers: boolean | undefined, locationIds: number[] | undefined, idNumber: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Employees/GetEmployeesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (emailAddress === null)
            throw new Error("The parameter 'emailAddress' cannot be null.");
        else if (emailAddress !== undefined)
            url_ += "EmailAddress=" + encodeURIComponent("" + emailAddress) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (surname === null)
            throw new Error("The parameter 'surname' cannot be null.");
        else if (surname !== undefined)
            url_ += "Surname=" + encodeURIComponent("" + surname) + "&"; 
        if (isEmailConfirmed === null)
            throw new Error("The parameter 'isEmailConfirmed' cannot be null.");
        else if (isEmailConfirmed !== undefined)
            url_ += "isEmailConfirmed=" + encodeURIComponent("" + isEmailConfirmed) + "&"; 
        if (onlyLockedUsers === null)
            throw new Error("The parameter 'onlyLockedUsers' cannot be null.");
        else if (onlyLockedUsers !== undefined)
            url_ += "OnlyLockedUsers=" + encodeURIComponent("" + onlyLockedUsers) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (idNumber === null)
            throw new Error("The parameter 'idNumber' cannot be null.");
        else if (idNumber !== undefined)
            url_ += "IdNumber=" + encodeURIComponent("" + idNumber) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param emailAddress (optional) 
     * @param name (optional) 
     * @param surname (optional) 
     * @param isEmailConfirmed (optional) 
     * @param onlyLockedUsers (optional) 
     * @param locationIds (optional) 
     * @param idNumber (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getEmployees(filter: string | undefined, emailAddress: string | undefined, name: string | undefined, surname: string | undefined, isEmailConfirmed: boolean | undefined, onlyLockedUsers: boolean | undefined, locationIds: number[] | undefined, idNumber: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetEmployeeListDto> {
        let url_ = this.baseUrl + "/api/services/app/Employees/GetEmployees?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (emailAddress === null)
            throw new Error("The parameter 'emailAddress' cannot be null.");
        else if (emailAddress !== undefined)
            url_ += "EmailAddress=" + encodeURIComponent("" + emailAddress) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (surname === null)
            throw new Error("The parameter 'surname' cannot be null.");
        else if (surname !== undefined)
            url_ += "Surname=" + encodeURIComponent("" + surname) + "&"; 
        if (isEmailConfirmed === null)
            throw new Error("The parameter 'isEmailConfirmed' cannot be null.");
        else if (isEmailConfirmed !== undefined)
            url_ += "isEmailConfirmed=" + encodeURIComponent("" + isEmailConfirmed) + "&"; 
        if (onlyLockedUsers === null)
            throw new Error("The parameter 'onlyLockedUsers' cannot be null.");
        else if (onlyLockedUsers !== undefined)
            url_ += "OnlyLockedUsers=" + encodeURIComponent("" + onlyLockedUsers) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (idNumber === null)
            throw new Error("The parameter 'idNumber' cannot be null.");
        else if (idNumber !== undefined)
            url_ += "IdNumber=" + encodeURIComponent("" + idNumber) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployees(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployees(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetEmployeeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetEmployeeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployees(response: HttpResponseBase): Observable<PagedResultDtoOfGetEmployeeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetEmployeeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetEmployeeListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getEmployeeForEdit(id: number | undefined): Observable<GetEmployeeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Employees/GetEmployeeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEmployeeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEmployeeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetEmployeeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetEmployeeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetEmployeeForEdit(response: HttpResponseBase): Observable<GetEmployeeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetEmployeeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetEmployeeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateEmployee(body: CreateEmployeeInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Employees/CreateOrUpdateEmployee";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateEmployee(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateEmployee(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateEmployee(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteEmployee(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Employees/DeleteEmployee?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteEmployee(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteEmployee(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteEmployee(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    unlockEmployee(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Employees/UnlockEmployee";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnlockEmployee(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnlockEmployee(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnlockEmployee(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    lockEmployee(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Employees/LockEmployee";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLockEmployee(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLockEmployee(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLockEmployee(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateResetUserPassword(body: GetUserIdInputForResetPassword | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Employees/UpdateResetUserPassword";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateResetUserPassword(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateResetUserPassword(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateResetUserPassword(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    employeeEmailConfirm(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Employees/EmployeeEmailConfirm";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processEmployeeEmailConfirm(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processEmployeeEmailConfirm(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processEmployeeEmailConfirm(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class EmployeeTimeSheetServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    clockIn(body: TimeSheetInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeTimeSheet/ClockIn";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processClockIn(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processClockIn(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processClockIn(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    clockOut(body: TimeSheetInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeTimeSheet/ClockOut";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processClockOut(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processClockOut(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processClockOut(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getActive(): Observable<TimeSheetListDto> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeTimeSheet/GetActive";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetActive(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetActive(<any>response_);
                } catch (e) {
                    return <Observable<TimeSheetListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<TimeSheetListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetActive(response: HttpResponseBase): Observable<TimeSheetListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TimeSheetListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TimeSheetListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    forceLogOffAndClockOut(body: LogOffClockOutInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/EmployeeTimeSheet/ForceLogOffAndClockOut";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processForceLogOffAndClockOut(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processForceLogOffAndClockOut(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processForceLogOffAndClockOut(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ExceleratorServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param username (optional) 
     * @param password (optional) 
     * @param url (optional) 
     * @param orderSource (optional) 
     * @param body (optional) 
     * @return Success
     */
    authenticateConnection(username: string | undefined, password: string | undefined, url: string | undefined, orderSource: string | undefined, body: PerformContext | undefined): Observable<AuthenticationResult> {
        let url_ = this.baseUrl + "/api/services/app/Excelerator/AuthenticateConnection?";
        if (username === null)
            throw new Error("The parameter 'username' cannot be null.");
        else if (username !== undefined)
            url_ += "username=" + encodeURIComponent("" + username) + "&"; 
        if (password === null)
            throw new Error("The parameter 'password' cannot be null.");
        else if (password !== undefined)
            url_ += "password=" + encodeURIComponent("" + password) + "&"; 
        if (url === null)
            throw new Error("The parameter 'url' cannot be null.");
        else if (url !== undefined)
            url_ += "url=" + encodeURIComponent("" + url) + "&"; 
        if (orderSource === null)
            throw new Error("The parameter 'orderSource' cannot be null.");
        else if (orderSource !== undefined)
            url_ += "orderSource=" + encodeURIComponent("" + orderSource) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAuthenticateConnection(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAuthenticateConnection(<any>response_);
                } catch (e) {
                    return <Observable<AuthenticationResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<AuthenticationResult>><any>_observableThrow(response_);
        }));
    }

    protected processAuthenticateConnection(response: HttpResponseBase): Observable<AuthenticationResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = AuthenticationResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<AuthenticationResult>(<any>null);
    }

    /**
     * @param tenant (optional) 
     * @param body (optional) 
     * @return Success
     */
    downloadOrders(tenant: string | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Excelerator/DownloadOrders?";
        if (tenant === null)
            throw new Error("The parameter 'tenant' cannot be null.");
        else if (tenant !== undefined)
            url_ += "tenant=" + encodeURIComponent("" + tenant) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDownloadOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDownloadOrders(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDownloadOrders(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenant (optional) 
     * @param body (optional) 
     * @return Success
     */
    downloadOrdersPerDate(tenant: string | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Excelerator/DownloadOrdersPerDate?";
        if (tenant === null)
            throw new Error("The parameter 'tenant' cannot be null.");
        else if (tenant !== undefined)
            url_ += "tenant=" + encodeURIComponent("" + tenant) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDownloadOrdersPerDate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDownloadOrdersPerDate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDownloadOrdersPerDate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ExportMappingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param exportTypeFilter (optional) 
     * @param ignoreFilter (optional) 
     * @param columnFilter (optional) 
     * @param dataTypeFilter (optional) 
     * @param requiredFilter (optional) 
     * @param columnToMapFilter (optional) 
     * @param columnNoFilter (optional) 
     * @param orderSourceId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, exportTypeFilter: number | undefined, ignoreFilter: number | undefined, columnFilter: string | undefined, dataTypeFilter: number | undefined, requiredFilter: number | undefined, columnToMapFilter: string | undefined, columnNoFilter: number | undefined, orderSourceId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetExportMappingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (exportTypeFilter === null)
            throw new Error("The parameter 'exportTypeFilter' cannot be null.");
        else if (exportTypeFilter !== undefined)
            url_ += "ExportTypeFilter=" + encodeURIComponent("" + exportTypeFilter) + "&"; 
        if (ignoreFilter === null)
            throw new Error("The parameter 'ignoreFilter' cannot be null.");
        else if (ignoreFilter !== undefined)
            url_ += "IgnoreFilter=" + encodeURIComponent("" + ignoreFilter) + "&"; 
        if (columnFilter === null)
            throw new Error("The parameter 'columnFilter' cannot be null.");
        else if (columnFilter !== undefined)
            url_ += "ColumnFilter=" + encodeURIComponent("" + columnFilter) + "&"; 
        if (dataTypeFilter === null)
            throw new Error("The parameter 'dataTypeFilter' cannot be null.");
        else if (dataTypeFilter !== undefined)
            url_ += "DataTypeFilter=" + encodeURIComponent("" + dataTypeFilter) + "&"; 
        if (requiredFilter === null)
            throw new Error("The parameter 'requiredFilter' cannot be null.");
        else if (requiredFilter !== undefined)
            url_ += "RequiredFilter=" + encodeURIComponent("" + requiredFilter) + "&"; 
        if (columnToMapFilter === null)
            throw new Error("The parameter 'columnToMapFilter' cannot be null.");
        else if (columnToMapFilter !== undefined)
            url_ += "ColumnToMapFilter=" + encodeURIComponent("" + columnToMapFilter) + "&"; 
        if (columnNoFilter === null)
            throw new Error("The parameter 'columnNoFilter' cannot be null.");
        else if (columnNoFilter !== undefined)
            url_ += "ColumnNoFilter=" + encodeURIComponent("" + columnNoFilter) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetExportMappingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetExportMappingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetExportMappingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetExportMappingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetExportMappingForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getExportMappingForView(id: number | undefined): Observable<GetExportMappingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/GetExportMappingForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetExportMappingForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetExportMappingForView(<any>response_);
                } catch (e) {
                    return <Observable<GetExportMappingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetExportMappingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetExportMappingForView(response: HttpResponseBase): Observable<GetExportMappingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetExportMappingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetExportMappingForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getExportMappingForEdit(id: number | undefined): Observable<GetExportMappingForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/GetExportMappingForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetExportMappingForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetExportMappingForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetExportMappingForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetExportMappingForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetExportMappingForEdit(response: HttpResponseBase): Observable<GetExportMappingForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetExportMappingForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetExportMappingForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditExportMappingDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param exportTypeFilter (optional) 
     * @param ignoreFilter (optional) 
     * @param columnFilter (optional) 
     * @param dataTypeFilter (optional) 
     * @param requiredFilter (optional) 
     * @param columnToMapFilter (optional) 
     * @return Success
     */
    getExportMappingsToExcel(filter: string | undefined, nameFilter: string | undefined, exportTypeFilter: number | undefined, ignoreFilter: number | undefined, columnFilter: string | undefined, dataTypeFilter: number | undefined, requiredFilter: number | undefined, columnToMapFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/GetExportMappingsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (exportTypeFilter === null)
            throw new Error("The parameter 'exportTypeFilter' cannot be null.");
        else if (exportTypeFilter !== undefined)
            url_ += "ExportTypeFilter=" + encodeURIComponent("" + exportTypeFilter) + "&"; 
        if (ignoreFilter === null)
            throw new Error("The parameter 'ignoreFilter' cannot be null.");
        else if (ignoreFilter !== undefined)
            url_ += "IgnoreFilter=" + encodeURIComponent("" + ignoreFilter) + "&"; 
        if (columnFilter === null)
            throw new Error("The parameter 'columnFilter' cannot be null.");
        else if (columnFilter !== undefined)
            url_ += "ColumnFilter=" + encodeURIComponent("" + columnFilter) + "&"; 
        if (dataTypeFilter === null)
            throw new Error("The parameter 'dataTypeFilter' cannot be null.");
        else if (dataTypeFilter !== undefined)
            url_ += "DataTypeFilter=" + encodeURIComponent("" + dataTypeFilter) + "&"; 
        if (requiredFilter === null)
            throw new Error("The parameter 'requiredFilter' cannot be null.");
        else if (requiredFilter !== undefined)
            url_ += "RequiredFilter=" + encodeURIComponent("" + requiredFilter) + "&"; 
        if (columnToMapFilter === null)
            throw new Error("The parameter 'columnToMapFilter' cannot be null.");
        else if (columnToMapFilter !== undefined)
            url_ += "ColumnToMapFilter=" + encodeURIComponent("" + columnToMapFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetExportMappingsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetExportMappingsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetExportMappingsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    createMapping(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/CreateMapping?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateMapping(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateMapping(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateMapping(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param trackingIdentifier (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param locationId (optional) 
     * @param orderTypeId (optional) 
     * @return Success
     */
    getOrderExportFile(trackingIdentifier: string | undefined, startDate: string | undefined, endDate: string | undefined, locationId: number | undefined, orderTypeId: number | undefined): Observable<GetExportEDIResult> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/GetOrderExportFile?";
        if (trackingIdentifier === null)
            throw new Error("The parameter 'trackingIdentifier' cannot be null.");
        else if (trackingIdentifier !== undefined)
            url_ += "TrackingIdentifier=" + encodeURIComponent("" + trackingIdentifier) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent("" + startDate) + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent("" + endDate) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderExportFile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderExportFile(<any>response_);
                } catch (e) {
                    return <Observable<GetExportEDIResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetExportEDIResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderExportFile(response: HttpResponseBase): Observable<GetExportEDIResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetExportEDIResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetExportEDIResult>(<any>null);
    }

    /**
     * @param subject (optional) 
     * @param mailMessage (optional) 
     * @param body (optional) 
     * @return Success
     */
    sendGridEmailEdi(subject: string | undefined, mailMessage: string | undefined, body: string[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/SendGridEmailEdi?";
        if (subject === null)
            throw new Error("The parameter 'subject' cannot be null.");
        else if (subject !== undefined)
            url_ += "subject=" + encodeURIComponent("" + subject) + "&"; 
        if (mailMessage === null)
            throw new Error("The parameter 'mailMessage' cannot be null.");
        else if (mailMessage !== undefined)
            url_ += "mailMessage=" + encodeURIComponent("" + mailMessage) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendGridEmailEdi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendGridEmailEdi(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendGridEmailEdi(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param trackingIdentifier (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param locationId (optional) 
     * @param orderTypeId (optional) 
     * @return Success
     */
    getExportOrder(trackingIdentifier: string | undefined, startDate: string | undefined, endDate: string | undefined, locationId: number | undefined, orderTypeId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ExportMappings/GetExportOrder?";
        if (trackingIdentifier === null)
            throw new Error("The parameter 'trackingIdentifier' cannot be null.");
        else if (trackingIdentifier !== undefined)
            url_ += "TrackingIdentifier=" + encodeURIComponent("" + trackingIdentifier) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent("" + startDate) + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent("" + endDate) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetExportOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetExportOrder(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetExportOrder(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class FirebaseNotificationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    markRequestsSent(body: UpdateRequestsInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FirebaseNotification/MarkRequestsSent";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMarkRequestsSent(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMarkRequestsSent(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processMarkRequestsSent(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param requestIds (optional) 
     * @return Success
     */
    deleteRequests(requestIds: number[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FirebaseNotification/DeleteRequests?";
        if (requestIds === null)
            throw new Error("The parameter 'requestIds' cannot be null.");
        else if (requestIds !== undefined)
            requestIds && requestIds.forEach(item => { url_ += "RequestIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRequests(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRequests(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRequests(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param dateCreated (optional) 
     * @param limit (optional) 
     * @return Success
     */
    getPendingRequests(dateCreated: moment.Moment | undefined, limit: number | undefined): Observable<ListResultDtoOfGetPendingRequestResultItemDto> {
        let url_ = this.baseUrl + "/api/services/app/FirebaseNotification/GetPendingRequests?";
        if (dateCreated === null)
            throw new Error("The parameter 'dateCreated' cannot be null.");
        else if (dateCreated !== undefined)
            url_ += "DateCreated=" + encodeURIComponent(dateCreated ? "" + dateCreated.toJSON() : "") + "&"; 
        if (limit === null)
            throw new Error("The parameter 'limit' cannot be null.");
        else if (limit !== undefined)
            url_ += "Limit=" + encodeURIComponent("" + limit) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPendingRequests(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPendingRequests(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetPendingRequestResultItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetPendingRequestResultItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPendingRequests(response: HttpResponseBase): Observable<ListResultDtoOfGetPendingRequestResultItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetPendingRequestResultItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetPendingRequestResultItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendNotifications(body: SendNotificationsInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FirebaseNotification/SendNotifications";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendNotifications(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendNotifications(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendNotifications(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRequest(body: CreateRequestInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FirebaseNotification/CreateRequest";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRequest(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRequest(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRequest(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class FleetServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createFleet(body: CreateFleetInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Fleet/CreateFleet";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateFleet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateFleet(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateFleet(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getFleetPaged(id: number | undefined, name: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfFleetListDto> {
        let url_ = this.baseUrl + "/api/services/app/Fleet/GetFleetPaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetPaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetPaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfFleetListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfFleetListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetPaged(response: HttpResponseBase): Observable<PagedResultDtoOfFleetListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfFleetListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfFleetListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getFleetForEdit(id: number | undefined): Observable<FleetListDto> {
        let url_ = this.baseUrl + "/api/services/app/Fleet/GetFleetForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetForEdit(<any>response_);
                } catch (e) {
                    return <Observable<FleetListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FleetListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetForEdit(response: HttpResponseBase): Observable<FleetListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FleetListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FleetListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateFleet(body: UpdateFleetInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Fleet/UpdateFleet";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateFleet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateFleet(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateFleet(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteFleet(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Fleet/DeleteFleet?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteFleet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteFleet(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteFleet(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getFleets(): Observable<FleetListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Fleet/GetFleets";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleets(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleets(<any>response_);
                } catch (e) {
                    return <Observable<FleetListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<FleetListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleets(response: HttpResponseBase): Observable<FleetListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(FleetListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FleetListDto[]>(<any>null);
    }
}

@Injectable()
export class FleetRateServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createFleetRate(body: CreateFleetRateInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/FleetRate/CreateFleetRate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateFleetRate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateFleetRate(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateFleetRate(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRateToFleet(body: CreateRateToFleetInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FleetRate/CreateRateToFleet";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRateToFleet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRateToFleet(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRateToFleet(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteFleetRate(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FleetRate/DeleteFleetRate?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteFleetRate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteFleetRate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteFleetRate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param fleetId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getRateForFleet(filter: string | undefined, fleetId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRateListForFleetDto> {
        let url_ = this.baseUrl + "/api/services/app/FleetRate/GetRateForFleet?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (fleetId === null)
            throw new Error("The parameter 'fleetId' cannot be null.");
        else if (fleetId !== undefined)
            url_ += "fleetId=" + encodeURIComponent("" + fleetId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRateForFleet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRateForFleet(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRateListForFleetDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRateListForFleetDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRateForFleet(response: HttpResponseBase): Observable<PagedResultDtoOfRateListForFleetDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRateListForFleetDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRateListForFleetDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param fleetId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getFleetRate(id: number | undefined, fleetId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfFleetRateListDto> {
        let url_ = this.baseUrl + "/api/services/app/FleetRate/GetFleetRate?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (fleetId === null)
            throw new Error("The parameter 'fleetId' cannot be null.");
        else if (fleetId !== undefined)
            url_ += "FleetId=" + encodeURIComponent("" + fleetId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetRate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetRate(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfFleetRateListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfFleetRateListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetRate(response: HttpResponseBase): Observable<PagedResultDtoOfFleetRateListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfFleetRateListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfFleetRateListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateFleetRate(body: UpdateFleetRateInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FleetRate/UpdateFleetRate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateFleetRate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateFleetRate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateFleetRate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRateLocationName(id: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/FleetRate/GetRateLocationName?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRateLocationName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRateLocationName(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetRateLocationName(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRateOrderTypeName(id: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/FleetRate/GetRateOrderTypeName?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRateOrderTypeName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRateOrderTypeName(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetRateOrderTypeName(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class FleetsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetFleetForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Fleets/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetFleetForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetFleetForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetFleetForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetFleetForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetFleetForViewDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllFleets(filter: string | undefined, nameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<ListResultDtoOfFleetDto> {
        let url_ = this.baseUrl + "/api/services/app/Fleets/GetAllFleets?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllFleets(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllFleets(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfFleetDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfFleetDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllFleets(response: HttpResponseBase): Observable<ListResultDtoOfFleetDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfFleetDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfFleetDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getFleetForView(id: number | undefined): Observable<GetFleetForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Fleets/GetFleetForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetForView(<any>response_);
                } catch (e) {
                    return <Observable<GetFleetForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetFleetForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetForView(response: HttpResponseBase): Observable<GetFleetForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetFleetForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetFleetForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getFleetForEdit(id: number | undefined): Observable<GetFleetForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Fleets/GetFleetForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetFleetForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetFleetForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetForEdit(response: HttpResponseBase): Observable<GetFleetForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetFleetForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetFleetForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditFleetDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Fleets/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Fleets/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @return Success
     */
    getFleetsToExcel(filter: string | undefined, nameFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Fleets/GetFleetsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class FleetUserServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createFleetUser(body: CreateFleetUserInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/FleetUser/CreateFleetUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateFleetUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateFleetUser(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateFleetUser(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param fleetId (optional) 
     * @param fleetName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getFleetUserPaged(id: number | undefined, userId: number | undefined, fleetId: number | undefined, fleetName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfFleetUserListDto> {
        let url_ = this.baseUrl + "/api/services/app/FleetUser/GetFleetUserPaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (fleetId === null)
            throw new Error("The parameter 'fleetId' cannot be null.");
        else if (fleetId !== undefined)
            url_ += "FleetId=" + encodeURIComponent("" + fleetId) + "&"; 
        if (fleetName === null)
            throw new Error("The parameter 'fleetName' cannot be null.");
        else if (fleetName !== undefined)
            url_ += "FleetName=" + encodeURIComponent("" + fleetName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetUserPaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetUserPaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfFleetUserListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfFleetUserListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetUserPaged(response: HttpResponseBase): Observable<PagedResultDtoOfFleetUserListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfFleetUserListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfFleetUserListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getFleetUserForEdit(id: number | undefined): Observable<GetFleetUserForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/FleetUser/GetFleetUserForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetUserForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetUserForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetFleetUserForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetFleetUserForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetUserForEdit(response: HttpResponseBase): Observable<GetFleetUserForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetFleetUserForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetFleetUserForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateFleetUser(body: UpdateFleetUserInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FleetUser/UpdateFleetUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateFleetUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateFleetUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateFleetUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteFleetUser(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FleetUser/DeleteFleetUser?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteFleetUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteFleetUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteFleetUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param permissions (optional) 
     * @param role (optional) 
     * @param onlyLockedUsers (optional) 
     * @param userIds (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getUnassignedDrivers(filter: string | undefined, permissions: string[] | undefined, role: number | undefined, onlyLockedUsers: boolean | undefined, userIds: number[] | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfUserListDto> {
        let url_ = this.baseUrl + "/api/services/app/FleetUser/GetUnassignedDrivers?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (permissions === null)
            throw new Error("The parameter 'permissions' cannot be null.");
        else if (permissions !== undefined)
            permissions && permissions.forEach(item => { url_ += "Permissions=" + encodeURIComponent("" + item) + "&"; });
        if (role === null)
            throw new Error("The parameter 'role' cannot be null.");
        else if (role !== undefined)
            url_ += "Role=" + encodeURIComponent("" + role) + "&"; 
        if (onlyLockedUsers === null)
            throw new Error("The parameter 'onlyLockedUsers' cannot be null.");
        else if (onlyLockedUsers !== undefined)
            url_ += "OnlyLockedUsers=" + encodeURIComponent("" + onlyLockedUsers) + "&"; 
        if (userIds === null)
            throw new Error("The parameter 'userIds' cannot be null.");
        else if (userIds !== undefined)
            userIds && userIds.forEach(item => { url_ += "userIds=" + encodeURIComponent("" + item) + "&"; });
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUnassignedDrivers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUnassignedDrivers(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfUserListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfUserListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUnassignedDrivers(response: HttpResponseBase): Observable<PagedResultDtoOfUserListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfUserListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfUserListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDriverToFleet(body: CreateDriverToFleetInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FleetUser/CreateDriverToFleet";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDriverToFleet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDriverToFleet(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDriverToFleet(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class FleetVehicleServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createFleetVehicle(body: CreateFleetVehicleInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/FleetVehicle/CreateFleetVehicle";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateFleetVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateFleetVehicle(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateFleetVehicle(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param fleetId (optional) 
     * @param vehicleId (optional) 
     * @param fleetName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getFleetVehiclePaged(id: number | undefined, fleetId: number | undefined, vehicleId: number | undefined, fleetName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfFleetVehicleListDto> {
        let url_ = this.baseUrl + "/api/services/app/FleetVehicle/GetFleetVehiclePaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (fleetId === null)
            throw new Error("The parameter 'fleetId' cannot be null.");
        else if (fleetId !== undefined)
            url_ += "FleetId=" + encodeURIComponent("" + fleetId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (fleetName === null)
            throw new Error("The parameter 'fleetName' cannot be null.");
        else if (fleetName !== undefined)
            url_ += "FleetName=" + encodeURIComponent("" + fleetName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetVehiclePaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetVehiclePaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfFleetVehicleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfFleetVehicleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetVehiclePaged(response: HttpResponseBase): Observable<PagedResultDtoOfFleetVehicleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfFleetVehicleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfFleetVehicleListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getFleetVehicleForEdit(id: number | undefined): Observable<GetFleetVehicleForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/FleetVehicle/GetFleetVehicleForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFleetVehicleForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFleetVehicleForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetFleetVehicleForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetFleetVehicleForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetFleetVehicleForEdit(response: HttpResponseBase): Observable<GetFleetVehicleForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetFleetVehicleForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetFleetVehicleForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateFleetVehicle(body: UpdateFleetVehicleInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FleetVehicle/UpdateFleetVehicle";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateFleetVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateFleetVehicle(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateFleetVehicle(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param vehicleName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getUnassignedVehicle(vehicleName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetUnassignedVehicleListDto> {
        let url_ = this.baseUrl + "/api/services/app/FleetVehicle/GetUnassignedVehicle?";
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUnassignedVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUnassignedVehicle(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetUnassignedVehicleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetUnassignedVehicleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUnassignedVehicle(response: HttpResponseBase): Observable<PagedResultDtoOfGetUnassignedVehicleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetUnassignedVehicleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetUnassignedVehicleListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteFleetVehicle(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FleetVehicle/DeleteFleetVehicle?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteFleetVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteFleetVehicle(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteFleetVehicle(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createVehicleToFleet(body: CreateVehicleToFleetInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FleetVehicle/CreateVehicleToFleet";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateVehicleToFleet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateVehicleToFleet(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateVehicleToFleet(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class FriendshipServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createFriendshipRequest(body: CreateFriendshipRequestInput | undefined): Observable<FriendDto> {
        let url_ = this.baseUrl + "/api/services/app/Friendship/CreateFriendshipRequest";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateFriendshipRequest(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateFriendshipRequest(<any>response_);
                } catch (e) {
                    return <Observable<FriendDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FriendDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateFriendshipRequest(response: HttpResponseBase): Observable<FriendDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FriendDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FriendDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createFriendshipRequestByUserName(body: CreateFriendshipRequestByUserNameInput | undefined): Observable<FriendDto> {
        let url_ = this.baseUrl + "/api/services/app/Friendship/CreateFriendshipRequestByUserName";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateFriendshipRequestByUserName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateFriendshipRequestByUserName(<any>response_);
                } catch (e) {
                    return <Observable<FriendDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FriendDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateFriendshipRequestByUserName(response: HttpResponseBase): Observable<FriendDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FriendDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FriendDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    blockUser(body: BlockUserInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Friendship/BlockUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBlockUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBlockUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBlockUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    unblockUser(body: UnblockUserInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Friendship/UnblockUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnblockUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnblockUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnblockUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    acceptFriendshipRequest(body: AcceptFriendshipRequestInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Friendship/AcceptFriendshipRequest";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAcceptFriendshipRequest(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAcceptFriendshipRequest(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAcceptFriendshipRequest(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class FtpAccountsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param hostFilter (optional) 
     * @param maxPortFilter (optional) 
     * @param minPortFilter (optional) 
     * @param usernameFilter (optional) 
     * @param passwordFilter (optional) 
     * @param folderFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, hostFilter: string | undefined, maxPortFilter: number | undefined, minPortFilter: number | undefined, usernameFilter: string | undefined, passwordFilter: string | undefined, folderFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetFtpAccountForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/FtpAccounts/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (hostFilter === null)
            throw new Error("The parameter 'hostFilter' cannot be null.");
        else if (hostFilter !== undefined)
            url_ += "HostFilter=" + encodeURIComponent("" + hostFilter) + "&"; 
        if (maxPortFilter === null)
            throw new Error("The parameter 'maxPortFilter' cannot be null.");
        else if (maxPortFilter !== undefined)
            url_ += "MaxPortFilter=" + encodeURIComponent("" + maxPortFilter) + "&"; 
        if (minPortFilter === null)
            throw new Error("The parameter 'minPortFilter' cannot be null.");
        else if (minPortFilter !== undefined)
            url_ += "MinPortFilter=" + encodeURIComponent("" + minPortFilter) + "&"; 
        if (usernameFilter === null)
            throw new Error("The parameter 'usernameFilter' cannot be null.");
        else if (usernameFilter !== undefined)
            url_ += "UsernameFilter=" + encodeURIComponent("" + usernameFilter) + "&"; 
        if (passwordFilter === null)
            throw new Error("The parameter 'passwordFilter' cannot be null.");
        else if (passwordFilter !== undefined)
            url_ += "PasswordFilter=" + encodeURIComponent("" + passwordFilter) + "&"; 
        if (folderFilter === null)
            throw new Error("The parameter 'folderFilter' cannot be null.");
        else if (folderFilter !== undefined)
            url_ += "FolderFilter=" + encodeURIComponent("" + folderFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetFtpAccountForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetFtpAccountForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetFtpAccountForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetFtpAccountForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetFtpAccountForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getFtpAccountForView(id: number | undefined): Observable<GetFtpAccountForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/FtpAccounts/GetFtpAccountForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFtpAccountForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFtpAccountForView(<any>response_);
                } catch (e) {
                    return <Observable<GetFtpAccountForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetFtpAccountForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetFtpAccountForView(response: HttpResponseBase): Observable<GetFtpAccountForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetFtpAccountForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetFtpAccountForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getFtpAccountForEdit(id: number | undefined): Observable<GetFtpAccountForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/FtpAccounts/GetFtpAccountForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFtpAccountForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFtpAccountForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetFtpAccountForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetFtpAccountForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetFtpAccountForEdit(response: HttpResponseBase): Observable<GetFtpAccountForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetFtpAccountForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetFtpAccountForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditFtpAccountDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FtpAccounts/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/FtpAccounts/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class GenericImportToExcelJobServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    execute(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GenericImportToExcelJob/Execute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExecute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExecute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExecute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param message (optional) 
     * @param body (optional) 
     * @return Success
     */
    sendGenericNotification(message: string | undefined, body: ImportGenericFromExcellJobArgs | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GenericImportToExcelJob/SendGenericNotification?";
        if (message === null)
            throw new Error("The parameter 'message' cannot be null.");
        else if (message !== undefined)
            url_ += "message=" + encodeURIComponent("" + message) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendGenericNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendGenericNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendGenericNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class GeocodeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param latitude (optional) 
     * @param longitude (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getGeocode(id: number | undefined, latitude: number | undefined, longitude: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGeocodeListDto> {
        let url_ = this.baseUrl + "/api/services/app/Geocode/GetGeocode?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (latitude === null)
            throw new Error("The parameter 'latitude' cannot be null.");
        else if (latitude !== undefined)
            url_ += "Latitude=" + encodeURIComponent("" + latitude) + "&"; 
        if (longitude === null)
            throw new Error("The parameter 'longitude' cannot be null.");
        else if (longitude !== undefined)
            url_ += "Longitude=" + encodeURIComponent("" + longitude) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetGeocode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetGeocode(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGeocodeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGeocodeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetGeocode(response: HttpResponseBase): Observable<PagedResultDtoOfGeocodeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGeocodeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGeocodeListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createGeocode(body: CreateGeocodeInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Geocode/CreateGeocode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateGeocode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateGeocode(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateGeocode(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateGeocode(body: UpdateGeocodeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Geocode/UpdateGeocode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateGeocode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateGeocode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateGeocode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteGeocode(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Geocode/DeleteGeocode?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteGeocode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteGeocode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteGeocode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class GoogleApiServiceServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param source (optional) 
     * @param body (optional) 
     * @return Success
     */
    processGeocode(source: string | undefined, body: GoogleGeocodingInput | undefined): Observable<GoogleGeocodingResult> {
        let url_ = this.baseUrl + "/api/services/app/GoogleApiService/ProcessGeocode?";
        if (source === null)
            throw new Error("The parameter 'source' cannot be null.");
        else if (source !== undefined)
            url_ += "Source=" + encodeURIComponent("" + source) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessGeocode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessGeocode(<any>response_);
                } catch (e) {
                    return <Observable<GoogleGeocodingResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<GoogleGeocodingResult>><any>_observableThrow(response_);
        }));
    }

    protected processProcessGeocode(response: HttpResponseBase): Observable<GoogleGeocodingResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GoogleGeocodingResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GoogleGeocodingResult>(<any>null);
    }

    /**
     * @param source (optional) 
     * @param body (optional) 
     * @return Success
     */
    processDistanceMatrix(source: string | undefined, body: GoogleDistanceMatrixInput | undefined): Observable<GoogleDistanceMatrixResult> {
        let url_ = this.baseUrl + "/api/services/app/GoogleApiService/ProcessDistanceMatrix?";
        if (source === null)
            throw new Error("The parameter 'source' cannot be null.");
        else if (source !== undefined)
            url_ += "Source=" + encodeURIComponent("" + source) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessDistanceMatrix(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessDistanceMatrix(<any>response_);
                } catch (e) {
                    return <Observable<GoogleDistanceMatrixResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<GoogleDistanceMatrixResult>><any>_observableThrow(response_);
        }));
    }

    protected processProcessDistanceMatrix(response: HttpResponseBase): Observable<GoogleDistanceMatrixResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GoogleDistanceMatrixResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GoogleDistanceMatrixResult>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    processOrTools(body: OrToolsInput | undefined): Observable<OrToolResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/GoogleApiService/ProcessOrTools";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessOrTools(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessOrTools(<any>response_);
                } catch (e) {
                    return <Observable<OrToolResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrToolResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processProcessOrTools(response: HttpResponseBase): Observable<OrToolResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrToolResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrToolResultDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    processOrToolsPickDel(body: OrToolsInput | undefined): Observable<CoordinateList[]> {
        let url_ = this.baseUrl + "/api/services/app/GoogleApiService/ProcessOrToolsPickDel";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessOrToolsPickDel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessOrToolsPickDel(<any>response_);
                } catch (e) {
                    return <Observable<CoordinateList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<CoordinateList[]>><any>_observableThrow(response_);
        }));
    }

    protected processProcessOrToolsPickDel(response: HttpResponseBase): Observable<CoordinateList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(CoordinateList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CoordinateList[]>(<any>null);
    }

    /**
     * @param source (optional) 
     * @return Success
     */
    logGoogleMapDynamic(source: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleApiService/LogGoogleMapDynamic?";
        if (source === null)
            throw new Error("The parameter 'source' cannot be null.");
        else if (source !== undefined)
            url_ += "Source=" + encodeURIComponent("" + source) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLogGoogleMapDynamic(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLogGoogleMapDynamic(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLogGoogleMapDynamic(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param source (optional) 
     * @param api (optional) 
     * @param isSuccess (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllGoogleRequests(filter: string | undefined, source: string | undefined, api: string | undefined, isSuccess: boolean | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGoogleRequestLogsDto> {
        let url_ = this.baseUrl + "/api/services/app/GoogleApiService/GetAllGoogleRequests?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (source === null)
            throw new Error("The parameter 'source' cannot be null.");
        else if (source !== undefined)
            url_ += "Source=" + encodeURIComponent("" + source) + "&"; 
        if (api === null)
            throw new Error("The parameter 'api' cannot be null.");
        else if (api !== undefined)
            url_ += "Api=" + encodeURIComponent("" + api) + "&"; 
        if (isSuccess === null)
            throw new Error("The parameter 'isSuccess' cannot be null.");
        else if (isSuccess !== undefined)
            url_ += "IsSuccess=" + encodeURIComponent("" + isSuccess) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllGoogleRequests(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllGoogleRequests(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGoogleRequestLogsDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGoogleRequestLogsDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllGoogleRequests(response: HttpResponseBase): Observable<PagedResultDtoOfGoogleRequestLogsDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGoogleRequestLogsDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGoogleRequestLogsDto>(<any>null);
    }
}

@Injectable()
export class GoogleDirectionOptimizationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    optimizeByLocationId(body: OptimizeByLocationIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionOptimization/OptimizeByLocationId";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOptimizeByLocationId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOptimizeByLocationId(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processOptimizeByLocationId(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    optimizeByOrderType(body: OptimizeByRouteIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionOptimization/OptimizeByOrderType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOptimizeByOrderType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOptimizeByOrderType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processOptimizeByOrderType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    optimizeByOrderStatus(body: OptimizeByRouteIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionOptimization/OptimizeByOrderStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOptimizeByOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOptimizeByOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processOptimizeByOrderStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param ruleConstant (optional) 
     * @param tenantId (optional) 
     * @return Success
     */
    getUpdateStatusRule(locationId: number | undefined, ruleConstant: number | undefined, tenantId: number | undefined): Observable<GetRuleByLocationResult[]> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionOptimization/GetUpdateStatusRule?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (ruleConstant === null)
            throw new Error("The parameter 'ruleConstant' cannot be null.");
        else if (ruleConstant !== undefined)
            url_ += "RuleConstant=" + encodeURIComponent("" + ruleConstant) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUpdateStatusRule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUpdateStatusRule(<any>response_);
                } catch (e) {
                    return <Observable<GetRuleByLocationResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRuleByLocationResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetUpdateStatusRule(response: HttpResponseBase): Observable<GetRuleByLocationResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetRuleByLocationResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRuleByLocationResult[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param ruleConstant (optional) 
     * @param tenantId (optional) 
     * @return Success
     */
    getRuleByLocation(locationId: number | undefined, ruleConstant: number | undefined, tenantId: number | undefined): Observable<GetRuleByLocationResult[]> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionOptimization/GetRuleByLocation?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (ruleConstant === null)
            throw new Error("The parameter 'ruleConstant' cannot be null.");
        else if (ruleConstant !== undefined)
            url_ += "RuleConstant=" + encodeURIComponent("" + ruleConstant) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRuleByLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRuleByLocation(<any>response_);
                } catch (e) {
                    return <Observable<GetRuleByLocationResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRuleByLocationResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRuleByLocation(response: HttpResponseBase): Observable<GetRuleByLocationResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetRuleByLocationResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRuleByLocationResult[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    optimizerRuleByOrderPosition(body: OptimizeByRouteIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionOptimization/OptimizerRuleByOrderPosition";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOptimizerRuleByOrderPosition(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOptimizerRuleByOrderPosition(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processOptimizerRuleByOrderPosition(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    optimizeRuleByDriverMilage(body: OptimizeByRouteIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionOptimization/OptimizeRuleByDriverMilage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOptimizeRuleByDriverMilage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOptimizeRuleByDriverMilage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processOptimizeRuleByDriverMilage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    optimizeRuleByDriverTimeExecution(body: OptimizeByRouteIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionOptimization/OptimizeRuleByDriverTimeExecution";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOptimizeRuleByDriverTimeExecution(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOptimizeRuleByDriverTimeExecution(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processOptimizeRuleByDriverTimeExecution(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    processOptimize(body: ProcessOptimizeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionOptimization/ProcessOptimize";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessOptimize(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessOptimize(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processProcessOptimize(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class GoogleDirectionProcessServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param source (optional) 
     * @param body (optional) 
     * @return Success
     */
    processGoogleDirection(source: string | undefined, body: GoogleDirectionInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionProcess/ProcessGoogleDirection?";
        if (source === null)
            throw new Error("The parameter 'source' cannot be null.");
        else if (source !== undefined)
            url_ += "Source=" + encodeURIComponent("" + source) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessGoogleDirection(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessGoogleDirection(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processProcessGoogleDirection(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param optimizer (optional) 
     * @param source (optional) 
     * @param body (optional) 
     * @return Success
     */
    processGoogleDirectionWillCall(optimizer: boolean | undefined, source: string | undefined, body: GoogleDirectionInput | undefined): Observable<WillCallReturn> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionProcess/ProcessGoogleDirectionWillCall?";
        if (optimizer === null)
            throw new Error("The parameter 'optimizer' cannot be null.");
        else if (optimizer !== undefined)
            url_ += "optimizer=" + encodeURIComponent("" + optimizer) + "&"; 
        if (source === null)
            throw new Error("The parameter 'source' cannot be null.");
        else if (source !== undefined)
            url_ += "Source=" + encodeURIComponent("" + source) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessGoogleDirectionWillCall(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessGoogleDirectionWillCall(<any>response_);
                } catch (e) {
                    return <Observable<WillCallReturn>><any>_observableThrow(e);
                }
            } else
                return <Observable<WillCallReturn>><any>_observableThrow(response_);
        }));
    }

    protected processProcessGoogleDirectionWillCall(response: HttpResponseBase): Observable<WillCallReturn> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = WillCallReturn.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<WillCallReturn>(<any>null);
    }

    /**
     * @param source (optional) 
     * @param body (optional) 
     * @return Success
     */
    processGoogleDirectionNoWaypoint(source: string | undefined, body: GoogleDirectionInput | undefined): Observable<WillCallReturn> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionProcess/ProcessGoogleDirectionNoWaypoint?";
        if (source === null)
            throw new Error("The parameter 'source' cannot be null.");
        else if (source !== undefined)
            url_ += "Source=" + encodeURIComponent("" + source) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessGoogleDirectionNoWaypoint(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessGoogleDirectionNoWaypoint(<any>response_);
                } catch (e) {
                    return <Observable<WillCallReturn>><any>_observableThrow(e);
                }
            } else
                return <Observable<WillCallReturn>><any>_observableThrow(response_);
        }));
    }

    protected processProcessGoogleDirectionNoWaypoint(response: HttpResponseBase): Observable<WillCallReturn> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = WillCallReturn.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<WillCallReturn>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    processGenericOptimizer(body: GoogleDirectionInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionProcess/ProcessGenericOptimizer";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessGenericOptimizer(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessGenericOptimizer(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processProcessGenericOptimizer(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param startTime (optional) 
     * @param waypoints (optional) 
     * @param toll (optional) 
     * @param highway (optional) 
     * @param ferry (optional) 
     * @param indoor (optional) 
     * @param originLat (optional) 
     * @param originLong (optional) 
     * @param destinationLat (optional) 
     * @param destinationLong (optional) 
     * @param tenantId (optional) 
     * @param optimize (optional) 
     * @param traffic (optional) 
     * @return Success
     */
    getOnDemandEta(routeId: number | undefined, startTime: moment.Moment | undefined, waypoints: OrderCooordinate[] | undefined, toll: boolean | undefined, highway: boolean | undefined, ferry: boolean | undefined, indoor: boolean | undefined, originLat: number | undefined, originLong: number | undefined, destinationLat: number | undefined, destinationLong: number | undefined, tenantId: number | undefined, optimize: boolean | undefined, traffic: boolean | undefined): Observable<moment.Moment> {
        let url_ = this.baseUrl + "/api/services/app/GoogleDirectionProcess/GetOnDemandEta?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (startTime === null)
            throw new Error("The parameter 'startTime' cannot be null.");
        else if (startTime !== undefined)
            url_ += "StartTime=" + encodeURIComponent(startTime ? "" + startTime.toJSON() : "") + "&"; 
        if (waypoints === null)
            throw new Error("The parameter 'waypoints' cannot be null.");
        else if (waypoints !== undefined)
            waypoints && waypoints.forEach((item, index) => { 
                for (let attr in item)
        			if (item.hasOwnProperty(attr)) {
        				url_ += "Waypoints[" + index + "]." + attr + "=" + encodeURIComponent("" + (<any>item)[attr]) + "&";
        			}
            });
        if (toll === null)
            throw new Error("The parameter 'toll' cannot be null.");
        else if (toll !== undefined)
            url_ += "Toll=" + encodeURIComponent("" + toll) + "&"; 
        if (highway === null)
            throw new Error("The parameter 'highway' cannot be null.");
        else if (highway !== undefined)
            url_ += "Highway=" + encodeURIComponent("" + highway) + "&"; 
        if (ferry === null)
            throw new Error("The parameter 'ferry' cannot be null.");
        else if (ferry !== undefined)
            url_ += "Ferry=" + encodeURIComponent("" + ferry) + "&"; 
        if (indoor === null)
            throw new Error("The parameter 'indoor' cannot be null.");
        else if (indoor !== undefined)
            url_ += "Indoor=" + encodeURIComponent("" + indoor) + "&"; 
        if (originLat === null)
            throw new Error("The parameter 'originLat' cannot be null.");
        else if (originLat !== undefined)
            url_ += "OriginLat=" + encodeURIComponent("" + originLat) + "&"; 
        if (originLong === null)
            throw new Error("The parameter 'originLong' cannot be null.");
        else if (originLong !== undefined)
            url_ += "OriginLong=" + encodeURIComponent("" + originLong) + "&"; 
        if (destinationLat === null)
            throw new Error("The parameter 'destinationLat' cannot be null.");
        else if (destinationLat !== undefined)
            url_ += "DestinationLat=" + encodeURIComponent("" + destinationLat) + "&"; 
        if (destinationLong === null)
            throw new Error("The parameter 'destinationLong' cannot be null.");
        else if (destinationLong !== undefined)
            url_ += "DestinationLong=" + encodeURIComponent("" + destinationLong) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (optimize === null)
            throw new Error("The parameter 'optimize' cannot be null.");
        else if (optimize !== undefined)
            url_ += "Optimize=" + encodeURIComponent("" + optimize) + "&"; 
        if (traffic === null)
            throw new Error("The parameter 'traffic' cannot be null.");
        else if (traffic !== undefined)
            url_ += "Traffic=" + encodeURIComponent("" + traffic) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOnDemandEta(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOnDemandEta(<any>response_);
                } catch (e) {
                    return <Observable<moment.Moment>><any>_observableThrow(e);
                }
            } else
                return <Observable<moment.Moment>><any>_observableThrow(response_);
        }));
    }

    protected processGetOnDemandEta(response: HttpResponseBase): Observable<moment.Moment> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 ? moment(resultData200.toString()) : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<moment.Moment>(<any>null);
    }
}

@Injectable()
export class HolidaysServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param descriptionFilter (optional) 
     * @param maxIsActiveFilter (optional) 
     * @param minIsActiveFilter (optional) 
     * @param maxFromFilter (optional) 
     * @param minFromFilter (optional) 
     * @param maxToFilter (optional) 
     * @param minToFilter (optional) 
     * @param colorFilter (optional) 
     * @param codeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, descriptionFilter: string | undefined, maxIsActiveFilter: number | undefined, minIsActiveFilter: number | undefined, maxFromFilter: moment.Moment | undefined, minFromFilter: moment.Moment | undefined, maxToFilter: moment.Moment | undefined, minToFilter: moment.Moment | undefined, colorFilter: string | undefined, codeFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetHolidayForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Holidays/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (maxIsActiveFilter === null)
            throw new Error("The parameter 'maxIsActiveFilter' cannot be null.");
        else if (maxIsActiveFilter !== undefined)
            url_ += "MaxIsActiveFilter=" + encodeURIComponent("" + maxIsActiveFilter) + "&"; 
        if (minIsActiveFilter === null)
            throw new Error("The parameter 'minIsActiveFilter' cannot be null.");
        else if (minIsActiveFilter !== undefined)
            url_ += "MinIsActiveFilter=" + encodeURIComponent("" + minIsActiveFilter) + "&"; 
        if (maxFromFilter === null)
            throw new Error("The parameter 'maxFromFilter' cannot be null.");
        else if (maxFromFilter !== undefined)
            url_ += "MaxFromFilter=" + encodeURIComponent(maxFromFilter ? "" + maxFromFilter.toJSON() : "") + "&"; 
        if (minFromFilter === null)
            throw new Error("The parameter 'minFromFilter' cannot be null.");
        else if (minFromFilter !== undefined)
            url_ += "MinFromFilter=" + encodeURIComponent(minFromFilter ? "" + minFromFilter.toJSON() : "") + "&"; 
        if (maxToFilter === null)
            throw new Error("The parameter 'maxToFilter' cannot be null.");
        else if (maxToFilter !== undefined)
            url_ += "MaxToFilter=" + encodeURIComponent(maxToFilter ? "" + maxToFilter.toJSON() : "") + "&"; 
        if (minToFilter === null)
            throw new Error("The parameter 'minToFilter' cannot be null.");
        else if (minToFilter !== undefined)
            url_ += "MinToFilter=" + encodeURIComponent(minToFilter ? "" + minToFilter.toJSON() : "") + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetHolidayForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetHolidayForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetHolidayForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetHolidayForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetHolidayForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getHolidayForView(id: number | undefined): Observable<GetHolidayForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Holidays/GetHolidayForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetHolidayForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetHolidayForView(<any>response_);
                } catch (e) {
                    return <Observable<GetHolidayForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetHolidayForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetHolidayForView(response: HttpResponseBase): Observable<GetHolidayForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetHolidayForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetHolidayForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getHolidayForEdit(id: number | undefined): Observable<GetHolidayForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Holidays/GetHolidayForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetHolidayForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetHolidayForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetHolidayForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetHolidayForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetHolidayForEdit(response: HttpResponseBase): Observable<GetHolidayForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetHolidayForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetHolidayForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditHolidayDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Holidays/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Holidays/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param descriptionFilter (optional) 
     * @param maxIsActiveFilter (optional) 
     * @param minIsActiveFilter (optional) 
     * @param maxFromFilter (optional) 
     * @param minFromFilter (optional) 
     * @param maxToFilter (optional) 
     * @param minToFilter (optional) 
     * @param colorFilter (optional) 
     * @param codeFilter (optional) 
     * @return Success
     */
    getHolidaysToExcel(filter: string | undefined, descriptionFilter: string | undefined, maxIsActiveFilter: number | undefined, minIsActiveFilter: number | undefined, maxFromFilter: moment.Moment | undefined, minFromFilter: moment.Moment | undefined, maxToFilter: moment.Moment | undefined, minToFilter: moment.Moment | undefined, colorFilter: string | undefined, codeFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Holidays/GetHolidaysToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (maxIsActiveFilter === null)
            throw new Error("The parameter 'maxIsActiveFilter' cannot be null.");
        else if (maxIsActiveFilter !== undefined)
            url_ += "MaxIsActiveFilter=" + encodeURIComponent("" + maxIsActiveFilter) + "&"; 
        if (minIsActiveFilter === null)
            throw new Error("The parameter 'minIsActiveFilter' cannot be null.");
        else if (minIsActiveFilter !== undefined)
            url_ += "MinIsActiveFilter=" + encodeURIComponent("" + minIsActiveFilter) + "&"; 
        if (maxFromFilter === null)
            throw new Error("The parameter 'maxFromFilter' cannot be null.");
        else if (maxFromFilter !== undefined)
            url_ += "MaxFromFilter=" + encodeURIComponent(maxFromFilter ? "" + maxFromFilter.toJSON() : "") + "&"; 
        if (minFromFilter === null)
            throw new Error("The parameter 'minFromFilter' cannot be null.");
        else if (minFromFilter !== undefined)
            url_ += "MinFromFilter=" + encodeURIComponent(minFromFilter ? "" + minFromFilter.toJSON() : "") + "&"; 
        if (maxToFilter === null)
            throw new Error("The parameter 'maxToFilter' cannot be null.");
        else if (maxToFilter !== undefined)
            url_ += "MaxToFilter=" + encodeURIComponent(maxToFilter ? "" + maxToFilter.toJSON() : "") + "&"; 
        if (minToFilter === null)
            throw new Error("The parameter 'minToFilter' cannot be null.");
        else if (minToFilter !== undefined)
            url_ += "MinToFilter=" + encodeURIComponent(minToFilter ? "" + minToFilter.toJSON() : "") + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetHolidaysToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetHolidaysToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetHolidaysToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getActionType(): Observable<GetActionTypes[]> {
        let url_ = this.baseUrl + "/api/services/app/Holidays/GetActionType";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetActionType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetActionType(<any>response_);
                } catch (e) {
                    return <Observable<GetActionTypes[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetActionTypes[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetActionType(response: HttpResponseBase): Observable<GetActionTypes[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetActionTypes.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetActionTypes[]>(<any>null);
    }

    /**
     * @param holidayId (optional) 
     * @param locationIds (optional) 
     * @param routeIds (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param filter (optional) 
     * @return Success
     */
    getUnassignedRoutesInCalendarRoute(holidayId: number | undefined, locationIds: number[] | undefined, routeIds: number[] | undefined, maxResultCount: number | undefined, skipCount: number | undefined, filter: string | undefined): Observable<PagedResultDtoOfRoutesForCalendarDto> {
        let url_ = this.baseUrl + "/api/services/app/Holidays/GetUnassignedRoutesInCalendarRoute?";
        if (holidayId === null)
            throw new Error("The parameter 'holidayId' cannot be null.");
        else if (holidayId !== undefined)
            url_ += "HolidayId=" + encodeURIComponent("" + holidayId) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUnassignedRoutesInCalendarRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUnassignedRoutesInCalendarRoute(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRoutesForCalendarDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRoutesForCalendarDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUnassignedRoutesInCalendarRoute(response: HttpResponseBase): Observable<PagedResultDtoOfRoutesForCalendarDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRoutesForCalendarDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRoutesForCalendarDto>(<any>null);
    }
}

@Injectable()
export class HostDashboardServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @return Success
     */
    getTopStatsData(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined): Observable<TopStatsData> {
        let url_ = this.baseUrl + "/api/services/app/HostDashboard/GetTopStatsData?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTopStatsData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTopStatsData(<any>response_);
                } catch (e) {
                    return <Observable<TopStatsData>><any>_observableThrow(e);
                }
            } else
                return <Observable<TopStatsData>><any>_observableThrow(response_);
        }));
    }

    protected processGetTopStatsData(response: HttpResponseBase): Observable<TopStatsData> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TopStatsData.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TopStatsData>(<any>null);
    }

    /**
     * @return Success
     */
    getRecentTenantsData(): Observable<GetRecentTenantsOutput> {
        let url_ = this.baseUrl + "/api/services/app/HostDashboard/GetRecentTenantsData";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRecentTenantsData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRecentTenantsData(<any>response_);
                } catch (e) {
                    return <Observable<GetRecentTenantsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRecentTenantsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRecentTenantsData(response: HttpResponseBase): Observable<GetRecentTenantsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRecentTenantsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRecentTenantsOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getSubscriptionExpiringTenantsData(): Observable<GetExpiringTenantsOutput> {
        let url_ = this.baseUrl + "/api/services/app/HostDashboard/GetSubscriptionExpiringTenantsData";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSubscriptionExpiringTenantsData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSubscriptionExpiringTenantsData(<any>response_);
                } catch (e) {
                    return <Observable<GetExpiringTenantsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetExpiringTenantsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetSubscriptionExpiringTenantsData(response: HttpResponseBase): Observable<GetExpiringTenantsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetExpiringTenantsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetExpiringTenantsOutput>(<any>null);
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @return Success
     */
    getIncomeStatistics(incomeStatisticsDateInterval: ChartDateInterval, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined): Observable<GetIncomeStatisticsDataOutput> {
        let url_ = this.baseUrl + "/api/services/app/HostDashboard/GetIncomeStatistics?";
        if (incomeStatisticsDateInterval === undefined || incomeStatisticsDateInterval === null)
            throw new Error("The parameter 'incomeStatisticsDateInterval' must be defined and cannot be null.");
        else
            url_ += "IncomeStatisticsDateInterval=" + encodeURIComponent("" + incomeStatisticsDateInterval) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncomeStatistics(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncomeStatistics(<any>response_);
                } catch (e) {
                    return <Observable<GetIncomeStatisticsDataOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetIncomeStatisticsDataOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncomeStatistics(response: HttpResponseBase): Observable<GetIncomeStatisticsDataOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetIncomeStatisticsDataOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetIncomeStatisticsDataOutput>(<any>null);
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @return Success
     */
    getEditionTenantStatistics(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined): Observable<GetEditionTenantStatisticsOutput> {
        let url_ = this.baseUrl + "/api/services/app/HostDashboard/GetEditionTenantStatistics?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEditionTenantStatistics(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEditionTenantStatistics(<any>response_);
                } catch (e) {
                    return <Observable<GetEditionTenantStatisticsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetEditionTenantStatisticsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetEditionTenantStatistics(response: HttpResponseBase): Observable<GetEditionTenantStatisticsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetEditionTenantStatisticsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetEditionTenantStatisticsOutput>(<any>null);
    }
}

@Injectable()
export class HostSettingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getAllSettings(): Observable<HostSettingsEditDto> {
        let url_ = this.baseUrl + "/api/services/app/HostSettings/GetAllSettings";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSettings(<any>response_);
                } catch (e) {
                    return <Observable<HostSettingsEditDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<HostSettingsEditDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSettings(response: HttpResponseBase): Observable<HostSettingsEditDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = HostSettingsEditDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<HostSettingsEditDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateAllSettings(body: HostSettingsEditDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/HostSettings/UpdateAllSettings";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateAllSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateAllSettings(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateAllSettings(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendTestEmail(body: SendTestEmailInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/HostSettings/SendTestEmail";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendTestEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendTestEmail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendTestEmail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ImageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createImage(body: CreateImageInput | undefined): Observable<CreateImageDto> {
        let url_ = this.baseUrl + "/api/services/app/Image/CreateImage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateImage(<any>response_);
                } catch (e) {
                    return <Observable<CreateImageDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateImageDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateImage(response: HttpResponseBase): Observable<CreateImageDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateImageDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateImageDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filename (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getImage(id: number | undefined, filename: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfImageListDto> {
        let url_ = this.baseUrl + "/api/services/app/Image/GetImage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filename === null)
            throw new Error("The parameter 'filename' cannot be null.");
        else if (filename !== undefined)
            url_ += "Filename=" + encodeURIComponent("" + filename) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImage(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfImageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfImageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImage(response: HttpResponseBase): Observable<ListResultDtoOfImageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfImageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfImageListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateImage(body: UpdateImageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Image/UpdateImage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateImage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateImage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteImage(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Image/DeleteImage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteImage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteImage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ImageNoteServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createImageNote(body: CreateImageNoteInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ImageNote/CreateImageNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateImageNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateImageNote(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateImageNote(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param imageId (optional) 
     * @param noteId (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getImageNote(id: number | undefined, imageId: number | undefined, noteId: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfImageNoteListDto> {
        let url_ = this.baseUrl + "/api/services/app/ImageNote/GetImageNote?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (imageId === null)
            throw new Error("The parameter 'imageId' cannot be null.");
        else if (imageId !== undefined)
            url_ += "ImageId=" + encodeURIComponent("" + imageId) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImageNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImageNote(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfImageNoteListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfImageNoteListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImageNote(response: HttpResponseBase): Observable<ListResultDtoOfImageNoteListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfImageNoteListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfImageNoteListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateImageNote(body: UpdateImageNoteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImageNote/UpdateImageNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateImageNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateImageNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateImageNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteImageNote(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImageNote/DeleteImageNote?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteImageNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteImageNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteImageNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ImportFieldsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param fieldNameFilter (optional) 
     * @param fieldCodeFilter (optional) 
     * @param requiredFilter (optional) 
     * @param importTableTableNameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, fieldNameFilter: string | undefined, fieldCodeFilter: string | undefined, requiredFilter: number | undefined, importTableTableNameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetImportFieldForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportFields/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (fieldNameFilter === null)
            throw new Error("The parameter 'fieldNameFilter' cannot be null.");
        else if (fieldNameFilter !== undefined)
            url_ += "FieldNameFilter=" + encodeURIComponent("" + fieldNameFilter) + "&"; 
        if (fieldCodeFilter === null)
            throw new Error("The parameter 'fieldCodeFilter' cannot be null.");
        else if (fieldCodeFilter !== undefined)
            url_ += "FieldCodeFilter=" + encodeURIComponent("" + fieldCodeFilter) + "&"; 
        if (requiredFilter === null)
            throw new Error("The parameter 'requiredFilter' cannot be null.");
        else if (requiredFilter !== undefined)
            url_ += "RequiredFilter=" + encodeURIComponent("" + requiredFilter) + "&"; 
        if (importTableTableNameFilter === null)
            throw new Error("The parameter 'importTableTableNameFilter' cannot be null.");
        else if (importTableTableNameFilter !== undefined)
            url_ += "ImportTableTableNameFilter=" + encodeURIComponent("" + importTableTableNameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetImportFieldForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetImportFieldForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetImportFieldForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetImportFieldForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetImportFieldForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportFieldForView(id: number | undefined): Observable<GetImportFieldForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportFields/GetImportFieldForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportFieldForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportFieldForView(<any>response_);
                } catch (e) {
                    return <Observable<GetImportFieldForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportFieldForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportFieldForView(response: HttpResponseBase): Observable<GetImportFieldForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportFieldForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportFieldForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportFieldForEdit(id: number | undefined): Observable<GetImportFieldForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ImportFields/GetImportFieldForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportFieldForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportFieldForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetImportFieldForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportFieldForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportFieldForEdit(response: HttpResponseBase): Observable<GetImportFieldForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportFieldForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportFieldForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditImportFieldDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportFields/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportFields/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param fieldNameFilter (optional) 
     * @param fieldCodeFilter (optional) 
     * @param requiredFilter (optional) 
     * @param importTableTableNameFilter (optional) 
     * @return Success
     */
    getImportFieldsToExcel(filter: string | undefined, fieldNameFilter: string | undefined, fieldCodeFilter: string | undefined, requiredFilter: number | undefined, importTableTableNameFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportFields/GetImportFieldsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (fieldNameFilter === null)
            throw new Error("The parameter 'fieldNameFilter' cannot be null.");
        else if (fieldNameFilter !== undefined)
            url_ += "FieldNameFilter=" + encodeURIComponent("" + fieldNameFilter) + "&"; 
        if (fieldCodeFilter === null)
            throw new Error("The parameter 'fieldCodeFilter' cannot be null.");
        else if (fieldCodeFilter !== undefined)
            url_ += "FieldCodeFilter=" + encodeURIComponent("" + fieldCodeFilter) + "&"; 
        if (requiredFilter === null)
            throw new Error("The parameter 'requiredFilter' cannot be null.");
        else if (requiredFilter !== undefined)
            url_ += "RequiredFilter=" + encodeURIComponent("" + requiredFilter) + "&"; 
        if (importTableTableNameFilter === null)
            throw new Error("The parameter 'importTableTableNameFilter' cannot be null.");
        else if (importTableTableNameFilter !== undefined)
            url_ += "ImportTableTableNameFilter=" + encodeURIComponent("" + importTableTableNameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportFieldsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportFieldsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportFieldsToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllImportTableForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfImportFieldImportTableLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportFields/GetAllImportTableForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllImportTableForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllImportTableForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfImportFieldImportTableLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfImportFieldImportTableLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllImportTableForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfImportFieldImportTableLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfImportFieldImportTableLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfImportFieldImportTableLookupTableDto>(<any>null);
    }
}

@Injectable()
export class ImportLogMessagesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param importLogId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, importLogId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetImportLogMessageForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogMessages/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (importLogId === null)
            throw new Error("The parameter 'importLogId' cannot be null.");
        else if (importLogId !== undefined)
            url_ += "ImportLogId=" + encodeURIComponent("" + importLogId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetImportLogMessageForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetImportLogMessageForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetImportLogMessageForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetImportLogMessageForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetImportLogMessageForViewDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param importLogId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllMessageByImportLogId(filter: string | undefined, importLogId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetImportLogMessageForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogMessages/GetAllMessageByImportLogId?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (importLogId === null)
            throw new Error("The parameter 'importLogId' cannot be null.");
        else if (importLogId !== undefined)
            url_ += "ImportLogId=" + encodeURIComponent("" + importLogId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllMessageByImportLogId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllMessageByImportLogId(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetImportLogMessageForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetImportLogMessageForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllMessageByImportLogId(response: HttpResponseBase): Observable<PagedResultDtoOfGetImportLogMessageForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetImportLogMessageForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetImportLogMessageForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportLogMessageForEdit(id: number | undefined): Observable<GetImportLogMessageForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogMessages/GetImportLogMessageForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportLogMessageForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportLogMessageForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetImportLogMessageForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportLogMessageForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportLogMessageForEdit(response: HttpResponseBase): Observable<GetImportLogMessageForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportLogMessageForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportLogMessageForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditImportLogMessageDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogMessages/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogMessages/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ImportLogsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param importTypeFilter (optional) 
     * @param fileNameFilter (optional) 
     * @param maxSuccessFilter (optional) 
     * @param minSuccessFilter (optional) 
     * @param maxFailedFilter (optional) 
     * @param minFailedFilter (optional) 
     * @param messageFilter (optional) 
     * @param maxUserIdFilter (optional) 
     * @param minUserIdFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, importTypeFilter: number | undefined, fileNameFilter: string | undefined, maxSuccessFilter: number | undefined, minSuccessFilter: number | undefined, maxFailedFilter: number | undefined, minFailedFilter: number | undefined, messageFilter: string | undefined, maxUserIdFilter: number | undefined, minUserIdFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetImportLogForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogs/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (importTypeFilter === null)
            throw new Error("The parameter 'importTypeFilter' cannot be null.");
        else if (importTypeFilter !== undefined)
            url_ += "ImportTypeFilter=" + encodeURIComponent("" + importTypeFilter) + "&"; 
        if (fileNameFilter === null)
            throw new Error("The parameter 'fileNameFilter' cannot be null.");
        else if (fileNameFilter !== undefined)
            url_ += "FileNameFilter=" + encodeURIComponent("" + fileNameFilter) + "&"; 
        if (maxSuccessFilter === null)
            throw new Error("The parameter 'maxSuccessFilter' cannot be null.");
        else if (maxSuccessFilter !== undefined)
            url_ += "MaxSuccessFilter=" + encodeURIComponent("" + maxSuccessFilter) + "&"; 
        if (minSuccessFilter === null)
            throw new Error("The parameter 'minSuccessFilter' cannot be null.");
        else if (minSuccessFilter !== undefined)
            url_ += "MinSuccessFilter=" + encodeURIComponent("" + minSuccessFilter) + "&"; 
        if (maxFailedFilter === null)
            throw new Error("The parameter 'maxFailedFilter' cannot be null.");
        else if (maxFailedFilter !== undefined)
            url_ += "MaxFailedFilter=" + encodeURIComponent("" + maxFailedFilter) + "&"; 
        if (minFailedFilter === null)
            throw new Error("The parameter 'minFailedFilter' cannot be null.");
        else if (minFailedFilter !== undefined)
            url_ += "MinFailedFilter=" + encodeURIComponent("" + minFailedFilter) + "&"; 
        if (messageFilter === null)
            throw new Error("The parameter 'messageFilter' cannot be null.");
        else if (messageFilter !== undefined)
            url_ += "MessageFilter=" + encodeURIComponent("" + messageFilter) + "&"; 
        if (maxUserIdFilter === null)
            throw new Error("The parameter 'maxUserIdFilter' cannot be null.");
        else if (maxUserIdFilter !== undefined)
            url_ += "MaxUserIdFilter=" + encodeURIComponent("" + maxUserIdFilter) + "&"; 
        if (minUserIdFilter === null)
            throw new Error("The parameter 'minUserIdFilter' cannot be null.");
        else if (minUserIdFilter !== undefined)
            url_ += "MinUserIdFilter=" + encodeURIComponent("" + minUserIdFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetImportLogForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetImportLogForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetImportLogForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetImportLogForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetImportLogForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportLogForView(id: number | undefined): Observable<GetImportLogForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogs/GetImportLogForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportLogForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportLogForView(<any>response_);
                } catch (e) {
                    return <Observable<GetImportLogForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportLogForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportLogForView(response: HttpResponseBase): Observable<GetImportLogForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportLogForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportLogForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportLogForEdit(id: number | undefined): Observable<GetImportLogForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogs/GetImportLogForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportLogForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportLogForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetImportLogForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportLogForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportLogForEdit(response: HttpResponseBase): Observable<GetImportLogForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportLogForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportLogForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditImportLogDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogs/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogs/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param connectionId (optional) 
     * @param fileName (optional) 
     * @return Success
     */
    getFileToExcel(connectionId: number | undefined, fileName: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogs/GetFileToExcel?";
        if (connectionId === null)
            throw new Error("The parameter 'connectionId' cannot be null.");
        else if (connectionId !== undefined)
            url_ += "connectionId=" + encodeURIComponent("" + connectionId) + "&"; 
        if (fileName === null)
            throw new Error("The parameter 'fileName' cannot be null.");
        else if (fileName !== undefined)
            url_ += "fileName=" + encodeURIComponent("" + fileName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFileToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFileToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetFileToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    convertToSpreadsheet(body: Blob | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogs/ConvertToSpreadsheet";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = body;

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "multipart/form-data", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertToSpreadsheet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertToSpreadsheet(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processConvertToSpreadsheet(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param orderSourceFileId (optional) 
     * @return Success
     */
    downloadFile(orderSourceFileId: number | undefined): Observable<DownloadFileDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportLogs/DownloadFile?";
        if (orderSourceFileId === null)
            throw new Error("The parameter 'orderSourceFileId' cannot be null.");
        else if (orderSourceFileId !== undefined)
            url_ += "orderSourceFileId=" + encodeURIComponent("" + orderSourceFileId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDownloadFile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDownloadFile(<any>response_);
                } catch (e) {
                    return <Observable<DownloadFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<DownloadFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processDownloadFile(response: HttpResponseBase): Observable<DownloadFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DownloadFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DownloadFileDto>(<any>null);
    }
}

@Injectable()
export class ImportMappingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param importTypeFilter (optional) 
     * @param ignoreFilter (optional) 
     * @param columnFilter (optional) 
     * @param dataTypeFilter (optional) 
     * @param requiredFilter (optional) 
     * @param columnToMapFilter (optional) 
     * @param columnNoFilter (optional) 
     * @param orderSourceId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, importTypeFilter: number | undefined, ignoreFilter: number | undefined, columnFilter: string | undefined, dataTypeFilter: number | undefined, requiredFilter: number | undefined, columnToMapFilter: string | undefined, columnNoFilter: number | undefined, orderSourceId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetImportMappingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportMappings/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (importTypeFilter === null)
            throw new Error("The parameter 'importTypeFilter' cannot be null.");
        else if (importTypeFilter !== undefined)
            url_ += "ImportTypeFilter=" + encodeURIComponent("" + importTypeFilter) + "&"; 
        if (ignoreFilter === null)
            throw new Error("The parameter 'ignoreFilter' cannot be null.");
        else if (ignoreFilter !== undefined)
            url_ += "IgnoreFilter=" + encodeURIComponent("" + ignoreFilter) + "&"; 
        if (columnFilter === null)
            throw new Error("The parameter 'columnFilter' cannot be null.");
        else if (columnFilter !== undefined)
            url_ += "ColumnFilter=" + encodeURIComponent("" + columnFilter) + "&"; 
        if (dataTypeFilter === null)
            throw new Error("The parameter 'dataTypeFilter' cannot be null.");
        else if (dataTypeFilter !== undefined)
            url_ += "DataTypeFilter=" + encodeURIComponent("" + dataTypeFilter) + "&"; 
        if (requiredFilter === null)
            throw new Error("The parameter 'requiredFilter' cannot be null.");
        else if (requiredFilter !== undefined)
            url_ += "RequiredFilter=" + encodeURIComponent("" + requiredFilter) + "&"; 
        if (columnToMapFilter === null)
            throw new Error("The parameter 'columnToMapFilter' cannot be null.");
        else if (columnToMapFilter !== undefined)
            url_ += "ColumnToMapFilter=" + encodeURIComponent("" + columnToMapFilter) + "&"; 
        if (columnNoFilter === null)
            throw new Error("The parameter 'columnNoFilter' cannot be null.");
        else if (columnNoFilter !== undefined)
            url_ += "ColumnNoFilter=" + encodeURIComponent("" + columnNoFilter) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetImportMappingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetImportMappingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetImportMappingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetImportMappingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetImportMappingForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportMappingForView(id: number | undefined): Observable<GetImportMappingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportMappings/GetImportMappingForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportMappingForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportMappingForView(<any>response_);
                } catch (e) {
                    return <Observable<GetImportMappingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportMappingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportMappingForView(response: HttpResponseBase): Observable<GetImportMappingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportMappingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportMappingForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportMappingForEdit(id: number | undefined): Observable<GetImportMappingForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ImportMappings/GetImportMappingForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportMappingForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportMappingForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetImportMappingForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportMappingForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportMappingForEdit(response: HttpResponseBase): Observable<GetImportMappingForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportMappingForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportMappingForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditImportMappingDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportMappings/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportMappings/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param importTypeFilter (optional) 
     * @param ignoreFilter (optional) 
     * @param columnFilter (optional) 
     * @param dataTypeFilter (optional) 
     * @param requiredFilter (optional) 
     * @param columnToMapFilter (optional) 
     * @return Success
     */
    getImportMappingsToExcel(filter: string | undefined, nameFilter: string | undefined, importTypeFilter: number | undefined, ignoreFilter: number | undefined, columnFilter: string | undefined, dataTypeFilter: number | undefined, requiredFilter: number | undefined, columnToMapFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportMappings/GetImportMappingsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (importTypeFilter === null)
            throw new Error("The parameter 'importTypeFilter' cannot be null.");
        else if (importTypeFilter !== undefined)
            url_ += "ImportTypeFilter=" + encodeURIComponent("" + importTypeFilter) + "&"; 
        if (ignoreFilter === null)
            throw new Error("The parameter 'ignoreFilter' cannot be null.");
        else if (ignoreFilter !== undefined)
            url_ += "IgnoreFilter=" + encodeURIComponent("" + ignoreFilter) + "&"; 
        if (columnFilter === null)
            throw new Error("The parameter 'columnFilter' cannot be null.");
        else if (columnFilter !== undefined)
            url_ += "ColumnFilter=" + encodeURIComponent("" + columnFilter) + "&"; 
        if (dataTypeFilter === null)
            throw new Error("The parameter 'dataTypeFilter' cannot be null.");
        else if (dataTypeFilter !== undefined)
            url_ += "DataTypeFilter=" + encodeURIComponent("" + dataTypeFilter) + "&"; 
        if (requiredFilter === null)
            throw new Error("The parameter 'requiredFilter' cannot be null.");
        else if (requiredFilter !== undefined)
            url_ += "RequiredFilter=" + encodeURIComponent("" + requiredFilter) + "&"; 
        if (columnToMapFilter === null)
            throw new Error("The parameter 'columnToMapFilter' cannot be null.");
        else if (columnToMapFilter !== undefined)
            url_ += "ColumnToMapFilter=" + encodeURIComponent("" + columnToMapFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportMappingsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportMappingsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportMappingsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    createMapping(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportMappings/CreateMapping?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateMapping(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateMapping(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateMapping(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ImportMapsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param headerFilter (optional) 
     * @param importFieldFieldNameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, headerFilter: string | undefined, importFieldFieldNameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetImportMapForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportMaps/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (headerFilter === null)
            throw new Error("The parameter 'headerFilter' cannot be null.");
        else if (headerFilter !== undefined)
            url_ += "HeaderFilter=" + encodeURIComponent("" + headerFilter) + "&"; 
        if (importFieldFieldNameFilter === null)
            throw new Error("The parameter 'importFieldFieldNameFilter' cannot be null.");
        else if (importFieldFieldNameFilter !== undefined)
            url_ += "ImportFieldFieldNameFilter=" + encodeURIComponent("" + importFieldFieldNameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetImportMapForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetImportMapForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetImportMapForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetImportMapForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetImportMapForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportMapForView(id: number | undefined): Observable<GetImportMapForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportMaps/GetImportMapForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportMapForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportMapForView(<any>response_);
                } catch (e) {
                    return <Observable<GetImportMapForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportMapForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportMapForView(response: HttpResponseBase): Observable<GetImportMapForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportMapForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportMapForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportMapForEdit(id: number | undefined): Observable<GetImportMapForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ImportMaps/GetImportMapForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportMapForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportMapForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetImportMapForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportMapForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportMapForEdit(response: HttpResponseBase): Observable<GetImportMapForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportMapForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportMapForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditImportMapDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportMaps/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportMaps/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param headerFilter (optional) 
     * @param importFieldFieldNameFilter (optional) 
     * @return Success
     */
    getImportMapsToExcel(filter: string | undefined, headerFilter: string | undefined, importFieldFieldNameFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportMaps/GetImportMapsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (headerFilter === null)
            throw new Error("The parameter 'headerFilter' cannot be null.");
        else if (headerFilter !== undefined)
            url_ += "HeaderFilter=" + encodeURIComponent("" + headerFilter) + "&"; 
        if (importFieldFieldNameFilter === null)
            throw new Error("The parameter 'importFieldFieldNameFilter' cannot be null.");
        else if (importFieldFieldNameFilter !== undefined)
            url_ += "ImportFieldFieldNameFilter=" + encodeURIComponent("" + importFieldFieldNameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportMapsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportMapsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportMapsToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllImportFieldForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfImportMapImportFieldLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportMaps/GetAllImportFieldForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllImportFieldForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllImportFieldForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfImportMapImportFieldLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfImportMapImportFieldLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllImportFieldForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfImportMapImportFieldLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfImportMapImportFieldLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfImportMapImportFieldLookupTableDto>(<any>null);
    }
}

@Injectable()
export class ImportTablesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param tableNameFilter (optional) 
     * @param tableCodeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, tableNameFilter: string | undefined, tableCodeFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetImportTableForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportTables/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (tableNameFilter === null)
            throw new Error("The parameter 'tableNameFilter' cannot be null.");
        else if (tableNameFilter !== undefined)
            url_ += "TableNameFilter=" + encodeURIComponent("" + tableNameFilter) + "&"; 
        if (tableCodeFilter === null)
            throw new Error("The parameter 'tableCodeFilter' cannot be null.");
        else if (tableCodeFilter !== undefined)
            url_ += "TableCodeFilter=" + encodeURIComponent("" + tableCodeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetImportTableForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetImportTableForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetImportTableForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetImportTableForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetImportTableForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportTableForView(id: number | undefined): Observable<GetImportTableForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportTables/GetImportTableForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportTableForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportTableForView(<any>response_);
                } catch (e) {
                    return <Observable<GetImportTableForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportTableForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportTableForView(response: HttpResponseBase): Observable<GetImportTableForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportTableForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportTableForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getImportTableForEdit(id: number | undefined): Observable<GetImportTableForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/ImportTables/GetImportTableForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportTableForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportTableForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetImportTableForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetImportTableForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportTableForEdit(response: HttpResponseBase): Observable<GetImportTableForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetImportTableForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetImportTableForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditImportTableDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportTables/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ImportTables/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param tableNameFilter (optional) 
     * @param tableCodeFilter (optional) 
     * @return Success
     */
    getImportTablesToExcel(filter: string | undefined, tableNameFilter: string | undefined, tableCodeFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/ImportTables/GetImportTablesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (tableNameFilter === null)
            throw new Error("The parameter 'tableNameFilter' cannot be null.");
        else if (tableNameFilter !== undefined)
            url_ += "TableNameFilter=" + encodeURIComponent("" + tableNameFilter) + "&"; 
        if (tableCodeFilter === null)
            throw new Error("The parameter 'tableCodeFilter' cannot be null.");
        else if (tableCodeFilter !== undefined)
            url_ += "TableCodeFilter=" + encodeURIComponent("" + tableCodeFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImportTablesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImportTablesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImportTablesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }
}

@Injectable()
export class IncidentServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createIncident(body: CreateIncidentInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Incident/CreateIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateIncident(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateIncident(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param geocodeId (optional) 
     * @param content (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getIncident(id: number | undefined, geocodeId: number | undefined, content: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfIncidentListDto> {
        let url_ = this.baseUrl + "/api/services/app/Incident/GetIncident?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (geocodeId === null)
            throw new Error("The parameter 'geocodeId' cannot be null.");
        else if (geocodeId !== undefined)
            url_ += "GeocodeId=" + encodeURIComponent("" + geocodeId) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncident(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfIncidentListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfIncidentListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncident(response: HttpResponseBase): Observable<PagedResultDtoOfIncidentListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfIncidentListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfIncidentListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateIncident(body: UpdateIncidentInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Incident/UpdateIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteIncident(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Incident/DeleteIncident?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createReport(body: CreateReportInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Incident/CreateReport";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateReport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateReport(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateReport(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addAttachment(body: AddAttachmentInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Incident/AddAttachment";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddAttachment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddAttachment(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddAttachment(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param incidentType (optional) 
     * @param orderTypeId (optional) 
     * @param incidentStatus (optional) 
     * @param content (optional) 
     * @param orderNumber (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param creator (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPagedIncident(filter: string | undefined, id: number | undefined, incidentType: number | undefined, orderTypeId: number | undefined, incidentStatus: number | undefined, content: string | undefined, orderNumber: number | undefined, startDate: string | undefined, endDate: string | undefined, creator: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfPagedIncidentList> {
        let url_ = this.baseUrl + "/api/services/app/Incident/GetPagedIncident?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (incidentType === null)
            throw new Error("The parameter 'incidentType' cannot be null.");
        else if (incidentType !== undefined)
            url_ += "IncidentType=" + encodeURIComponent("" + incidentType) + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (incidentStatus === null)
            throw new Error("The parameter 'incidentStatus' cannot be null.");
        else if (incidentStatus !== undefined)
            url_ += "IncidentStatus=" + encodeURIComponent("" + incidentStatus) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (orderNumber === null)
            throw new Error("The parameter 'orderNumber' cannot be null.");
        else if (orderNumber !== undefined)
            url_ += "OrderNumber=" + encodeURIComponent("" + orderNumber) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent("" + startDate) + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent("" + endDate) + "&"; 
        if (creator === null)
            throw new Error("The parameter 'creator' cannot be null.");
        else if (creator !== undefined)
            url_ += "Creator=" + encodeURIComponent("" + creator) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPagedIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPagedIncident(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfPagedIncidentList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfPagedIncidentList>><any>_observableThrow(response_);
        }));
    }

    protected processGetPagedIncident(response: HttpResponseBase): Observable<PagedResultDtoOfPagedIncidentList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfPagedIncidentList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfPagedIncidentList>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param incidentType (optional) 
     * @param orderTypeId (optional) 
     * @param incidentStatus (optional) 
     * @param content (optional) 
     * @param orderNumber (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param creator (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderIncidentToExcel(filter: string | undefined, id: number | undefined, incidentType: number | undefined, orderTypeId: number | undefined, incidentStatus: number | undefined, content: string | undefined, orderNumber: number | undefined, startDate: string | undefined, endDate: string | undefined, creator: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Incident/GetOrderIncidentToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (incidentType === null)
            throw new Error("The parameter 'incidentType' cannot be null.");
        else if (incidentType !== undefined)
            url_ += "IncidentType=" + encodeURIComponent("" + incidentType) + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (incidentStatus === null)
            throw new Error("The parameter 'incidentStatus' cannot be null.");
        else if (incidentStatus !== undefined)
            url_ += "IncidentStatus=" + encodeURIComponent("" + incidentStatus) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (orderNumber === null)
            throw new Error("The parameter 'orderNumber' cannot be null.");
        else if (orderNumber !== undefined)
            url_ += "OrderNumber=" + encodeURIComponent("" + orderNumber) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent("" + startDate) + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent("" + endDate) + "&"; 
        if (creator === null)
            throw new Error("The parameter 'creator' cannot be null.");
        else if (creator !== undefined)
            url_ += "Creator=" + encodeURIComponent("" + creator) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderIncidentToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderIncidentToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderIncidentToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param geocodeId (optional) 
     * @param content (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderIncidentForUpdate(id: number | undefined, geocodeId: number | undefined, content: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<GetIncidentForUpdate> {
        let url_ = this.baseUrl + "/api/services/app/Incident/GetOrderIncidentForUpdate?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (geocodeId === null)
            throw new Error("The parameter 'geocodeId' cannot be null.");
        else if (geocodeId !== undefined)
            url_ += "GeocodeId=" + encodeURIComponent("" + geocodeId) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderIncidentForUpdate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderIncidentForUpdate(<any>response_);
                } catch (e) {
                    return <Observable<GetIncidentForUpdate>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetIncidentForUpdate>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderIncidentForUpdate(response: HttpResponseBase): Observable<GetIncidentForUpdate> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetIncidentForUpdate.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetIncidentForUpdate>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteAttachment(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Incident/DeleteAttachment?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteAttachment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteAttachment(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteAttachment(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createAttachement(body: CreateAttachmentIncidentInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Incident/CreateAttachement";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateAttachement(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateAttachement(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateAttachement(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createIncidentNote(body: CreateNoteIncidentInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Incident/CreateIncidentNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateIncidentNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateIncidentNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateIncidentNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderIncident(body: UpdateOrderIncidentInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Incident/UpdateOrderIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    downloadFile(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Incident/DownloadFile?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDownloadFile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDownloadFile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDownloadFile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class IncidentImageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createIncidentImage(body: CreateIncidentImageInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/IncidentImage/CreateIncidentImage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateIncidentImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateIncidentImage(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateIncidentImage(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param binaryObjectId (optional) 
     * @param incidentId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getIncidentImage(id: number | undefined, binaryObjectId: number | undefined, incidentId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfIncidentImageListDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentImage/GetIncidentImage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (binaryObjectId === null)
            throw new Error("The parameter 'binaryObjectId' cannot be null.");
        else if (binaryObjectId !== undefined)
            url_ += "BinaryObjectId=" + encodeURIComponent("" + binaryObjectId) + "&"; 
        if (incidentId === null)
            throw new Error("The parameter 'incidentId' cannot be null.");
        else if (incidentId !== undefined)
            url_ += "IncidentId=" + encodeURIComponent("" + incidentId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidentImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidentImage(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfIncidentImageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfIncidentImageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidentImage(response: HttpResponseBase): Observable<PagedResultDtoOfIncidentImageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfIncidentImageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfIncidentImageListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateIncidentImage(body: UpdateIncidentImageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/IncidentImage/UpdateIncidentImage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateIncidentImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateIncidentImage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateIncidentImage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteIncidentImage(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/IncidentImage/DeleteIncidentImage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteIncidentImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteIncidentImage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteIncidentImage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class IncidentSourcesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, isActiveFilter: number | undefined, descriptionFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetIncidentSourceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentSources/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetIncidentSourceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetIncidentSourceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetIncidentSourceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetIncidentSourceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetIncidentSourceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getIncidentSourceForView(id: number | undefined): Observable<GetIncidentSourceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentSources/GetIncidentSourceForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidentSourceForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidentSourceForView(<any>response_);
                } catch (e) {
                    return <Observable<GetIncidentSourceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetIncidentSourceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidentSourceForView(response: HttpResponseBase): Observable<GetIncidentSourceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetIncidentSourceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetIncidentSourceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getIncidentSourceForEdit(id: number | undefined): Observable<GetIncidentSourceForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/IncidentSources/GetIncidentSourceForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidentSourceForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidentSourceForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetIncidentSourceForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetIncidentSourceForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidentSourceForEdit(response: HttpResponseBase): Observable<GetIncidentSourceForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetIncidentSourceForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetIncidentSourceForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditIncidentSourceDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/IncidentSources/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/IncidentSources/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param descriptionFilter (optional) 
     * @return Success
     */
    getIncidentSourcesToExcel(filter: string | undefined, nameFilter: string | undefined, isActiveFilter: number | undefined, descriptionFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentSources/GetIncidentSourcesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidentSourcesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidentSourcesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidentSourcesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class IncidentStatusServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateIncidentStatus(body: CreateOrUpdateIncidentStatusInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/IncidentStatus/CreateOrUpdateIncidentStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateIncidentStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateIncidentStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateIncidentStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param input (optional) 
     * @return Success
     */
    deleteIncidentStatus(input: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/IncidentStatus/DeleteIncidentStatus?";
        if (input === null)
            throw new Error("The parameter 'input' cannot be null.");
        else if (input !== undefined)
            url_ += "input=" + encodeURIComponent("" + input) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteIncidentStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteIncidentStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteIncidentStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @return Success
     */
    getAllIncidentStatus(id: number | undefined, filter: string | undefined): Observable<IncidentStatusListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/IncidentStatus/GetAllIncidentStatus?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllIncidentStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllIncidentStatus(<any>response_);
                } catch (e) {
                    return <Observable<IncidentStatusListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<IncidentStatusListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllIncidentStatus(response: HttpResponseBase): Observable<IncidentStatusListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(IncidentStatusListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<IncidentStatusListDto[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @return Success
     */
    getIncidentStatus(id: number | undefined, filter: string | undefined): Observable<IncidentStatusListDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentStatus/GetIncidentStatus?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidentStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidentStatus(<any>response_);
                } catch (e) {
                    return <Observable<IncidentStatusListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<IncidentStatusListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidentStatus(response: HttpResponseBase): Observable<IncidentStatusListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = IncidentStatusListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<IncidentStatusListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getPagedIncidentStatus(id: number | undefined, filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfIncidentStatusListDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentStatus/GetPagedIncidentStatus?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPagedIncidentStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPagedIncidentStatus(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfIncidentStatusListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfIncidentStatusListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPagedIncidentStatus(response: HttpResponseBase): Observable<PagedResultDtoOfIncidentStatusListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfIncidentStatusListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfIncidentStatusListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    incidentStatusPagedList(body: PagedIncidentStatusInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentStatus/IncidentStatusPagedList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIncidentStatusPagedList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIncidentStatusPagedList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processIncidentStatusPagedList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class IncidentTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param incidentTypeFilter (optional) 
     * @param maxsortOrderFilter (optional) 
     * @param minsortOrderFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, incidentTypeFilter: string | undefined, maxsortOrderFilter: number | undefined, minsortOrderFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetIncidentTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (incidentTypeFilter === null)
            throw new Error("The parameter 'incidentTypeFilter' cannot be null.");
        else if (incidentTypeFilter !== undefined)
            url_ += "incidentTypeFilter=" + encodeURIComponent("" + incidentTypeFilter) + "&"; 
        if (maxsortOrderFilter === null)
            throw new Error("The parameter 'maxsortOrderFilter' cannot be null.");
        else if (maxsortOrderFilter !== undefined)
            url_ += "MaxsortOrderFilter=" + encodeURIComponent("" + maxsortOrderFilter) + "&"; 
        if (minsortOrderFilter === null)
            throw new Error("The parameter 'minsortOrderFilter' cannot be null.");
        else if (minsortOrderFilter !== undefined)
            url_ += "MinsortOrderFilter=" + encodeURIComponent("" + minsortOrderFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetIncidentTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetIncidentTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetIncidentTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetIncidentTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetIncidentTypeForViewDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllIncidentType(): Observable<ListResultDtoOfIncidentTypeDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentTypes/GetAllIncidentType";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllIncidentType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllIncidentType(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfIncidentTypeDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfIncidentTypeDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllIncidentType(response: HttpResponseBase): Observable<ListResultDtoOfIncidentTypeDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfIncidentTypeDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfIncidentTypeDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getIncidentTypeForView(id: number | undefined): Observable<GetIncidentTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentTypes/GetIncidentTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidentTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidentTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetIncidentTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetIncidentTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidentTypeForView(response: HttpResponseBase): Observable<GetIncidentTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetIncidentTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetIncidentTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getIncidentTypeForEdit(id: number | undefined): Observable<GetIncidentTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/IncidentTypes/GetIncidentTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidentTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidentTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetIncidentTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetIncidentTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidentTypeForEdit(response: HttpResponseBase): Observable<GetIncidentTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetIncidentTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetIncidentTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditIncidentTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/IncidentTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/IncidentTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    incidentTypePagedList(body: GetAllForLookupTableInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/IncidentTypes/IncidentTypePagedList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIncidentTypePagedList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIncidentTypePagedList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processIncidentTypePagedList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class InstallServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setup(body: InstallDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Install/Setup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetup(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetup(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getAppSettingsJson(): Observable<AppSettingsJsonDto> {
        let url_ = this.baseUrl + "/api/services/app/Install/GetAppSettingsJson";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAppSettingsJson(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAppSettingsJson(<any>response_);
                } catch (e) {
                    return <Observable<AppSettingsJsonDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<AppSettingsJsonDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAppSettingsJson(response: HttpResponseBase): Observable<AppSettingsJsonDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = AppSettingsJsonDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<AppSettingsJsonDto>(<any>null);
    }

    /**
     * @return Success
     */
    checkDatabase(): Observable<CheckDatabaseOutput> {
        let url_ = this.baseUrl + "/api/services/app/Install/CheckDatabase";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckDatabase(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckDatabase(<any>response_);
                } catch (e) {
                    return <Observable<CheckDatabaseOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<CheckDatabaseOutput>><any>_observableThrow(response_);
        }));
    }

    protected processCheckDatabase(response: HttpResponseBase): Observable<CheckDatabaseOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CheckDatabaseOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CheckDatabaseOutput>(<any>null);
    }
}

@Injectable()
export class InvoiceServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getInvoiceInfo(id: number | undefined): Observable<InvoiceDto> {
        let url_ = this.baseUrl + "/api/services/app/Invoice/GetInvoiceInfo?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetInvoiceInfo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetInvoiceInfo(<any>response_);
                } catch (e) {
                    return <Observable<InvoiceDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<InvoiceDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetInvoiceInfo(response: HttpResponseBase): Observable<InvoiceDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = InvoiceDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<InvoiceDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createInvoice(body: CreateInvoiceDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Invoice/CreateInvoice";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateInvoice(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateInvoice(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateInvoice(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class LaboratoryDeliveryServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createLaboratoryDelivery(body: LaboratoryDeliveryItems | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/LaboratoryDelivery/CreateLaboratoryDelivery";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateLaboratoryDelivery(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateLaboratoryDelivery(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateLaboratoryDelivery(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addDelivery(body: CreateLaboratoryDeliveryInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/LaboratoryDelivery/AddDelivery";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddDelivery(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddDelivery(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddDelivery(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class LaboratoryPickupServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createLaboratoryPickup(body: CreateLaboratoryPickupInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/LaboratoryPickup/CreateLaboratoryPickup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateLaboratoryPickup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateLaboratoryPickup(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateLaboratoryPickup(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class LanguageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getLanguages(): Observable<GetLanguagesOutput> {
        let url_ = this.baseUrl + "/api/services/app/Language/GetLanguages";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLanguages(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLanguages(<any>response_);
                } catch (e) {
                    return <Observable<GetLanguagesOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLanguagesOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetLanguages(response: HttpResponseBase): Observable<GetLanguagesOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLanguagesOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLanguagesOutput>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getLanguageForEdit(id: number | undefined): Observable<GetLanguageForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Language/GetLanguageForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLanguageForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLanguageForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetLanguageForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLanguageForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetLanguageForEdit(response: HttpResponseBase): Observable<GetLanguageForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLanguageForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLanguageForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateLanguage(body: CreateOrUpdateLanguageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Language/CreateOrUpdateLanguage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateLanguage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateLanguage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateLanguage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteLanguage(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Language/DeleteLanguage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteLanguage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteLanguage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteLanguage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setDefaultLanguage(body: SetDefaultLanguageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Language/SetDefaultLanguage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetDefaultLanguage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetDefaultLanguage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetDefaultLanguage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param sorting (optional) 
     * @param baseLanguageName (optional) 
     * @param targetValueFilter (optional) 
     * @param filterText (optional) 
     * @return Success
     */
    getLanguageTexts(maxResultCount: number | undefined, skipCount: number | undefined, sorting: string | undefined, sourceName: string, baseLanguageName: string | undefined, targetLanguageName: string, targetValueFilter: string | undefined, filterText: string | undefined): Observable<PagedResultDtoOfLanguageTextListDto> {
        let url_ = this.baseUrl + "/api/services/app/Language/GetLanguageTexts?";
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (sourceName === undefined || sourceName === null)
            throw new Error("The parameter 'sourceName' must be defined and cannot be null.");
        else
            url_ += "SourceName=" + encodeURIComponent("" + sourceName) + "&"; 
        if (baseLanguageName === null)
            throw new Error("The parameter 'baseLanguageName' cannot be null.");
        else if (baseLanguageName !== undefined)
            url_ += "BaseLanguageName=" + encodeURIComponent("" + baseLanguageName) + "&"; 
        if (targetLanguageName === undefined || targetLanguageName === null)
            throw new Error("The parameter 'targetLanguageName' must be defined and cannot be null.");
        else
            url_ += "TargetLanguageName=" + encodeURIComponent("" + targetLanguageName) + "&"; 
        if (targetValueFilter === null)
            throw new Error("The parameter 'targetValueFilter' cannot be null.");
        else if (targetValueFilter !== undefined)
            url_ += "TargetValueFilter=" + encodeURIComponent("" + targetValueFilter) + "&"; 
        if (filterText === null)
            throw new Error("The parameter 'filterText' cannot be null.");
        else if (filterText !== undefined)
            url_ += "FilterText=" + encodeURIComponent("" + filterText) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLanguageTexts(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLanguageTexts(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfLanguageTextListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfLanguageTextListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLanguageTexts(response: HttpResponseBase): Observable<PagedResultDtoOfLanguageTextListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfLanguageTextListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfLanguageTextListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateLanguageText(body: UpdateLanguageTextInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Language/UpdateLanguageText";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateLanguageText(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateLanguageText(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateLanguageText(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ApiServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    locationPost(body: Coordinates | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/Location";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "application/json"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLocationPost(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLocationPost(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processLocationPost(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    locationGet(): Observable<string[]> {
        let url_ = this.baseUrl + "/api/Location";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "application/json"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLocationGet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLocationGet(<any>response_);
                } catch (e) {
                    return <Observable<string[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<string[]>><any>_observableThrow(response_);
        }));
    }

    protected processLocationGet(response: HttpResponseBase): Observable<string[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string[]>(<any>null);
    }
}

@Injectable()
export class LocationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param timeZoneFilter (optional) 
     * @return Success
     */
    getLocationsToExcel(filter: string | undefined, nameFilter: string | undefined, timeZoneFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetLocationsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (timeZoneFilter === null)
            throw new Error("The parameter 'timeZoneFilter' cannot be null.");
        else if (timeZoneFilter !== undefined)
            url_ += "TimeZoneFilter=" + encodeURIComponent("" + timeZoneFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createLocationContact(body: CreateLocationContactInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Location/CreateLocationContact";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateLocationContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateLocationContact(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateLocationContact(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createLocation(body: CreateLocationInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Location/CreateLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateLocation(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateLocation(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @return Success
     */
    getTimezoneOfTenantMarkets(tenantId: number | undefined): Observable<MarketListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetTimezoneOfTenantMarkets?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimezoneOfTenantMarkets(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimezoneOfTenantMarkets(<any>response_);
                } catch (e) {
                    return <Observable<MarketListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<MarketListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimezoneOfTenantMarkets(response: HttpResponseBase): Observable<MarketListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(MarketListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<MarketListDto[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getLocationInActiveBoolean(id: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetLocationInActiveBoolean?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationInActiveBoolean(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationInActiveBoolean(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationInActiveBoolean(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param timeZoneFilter (optional) 
     * @param inActiveFilter (optional) 
     * @param loadLimit (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getLocation(id: number | undefined, filter: string | undefined, nameFilter: string | undefined, timeZoneFilter: string | undefined, inActiveFilter: boolean | undefined, loadLimit: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfLocationListDto> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetLocation?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (timeZoneFilter === null)
            throw new Error("The parameter 'timeZoneFilter' cannot be null.");
        else if (timeZoneFilter !== undefined)
            url_ += "TimeZoneFilter=" + encodeURIComponent("" + timeZoneFilter) + "&"; 
        if (inActiveFilter === null)
            throw new Error("The parameter 'inActiveFilter' cannot be null.");
        else if (inActiveFilter !== undefined)
            url_ += "InActiveFilter=" + encodeURIComponent("" + inActiveFilter) + "&"; 
        if (loadLimit === null)
            throw new Error("The parameter 'loadLimit' cannot be null.");
        else if (loadLimit !== undefined)
            url_ += "LoadLimit=" + encodeURIComponent("" + loadLimit) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocation(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfLocationListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfLocationListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocation(response: HttpResponseBase): Observable<PagedResultDtoOfLocationListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfLocationListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfLocationListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param timeZoneFilter (optional) 
     * @param inActiveFilter (optional) 
     * @param loadLimit (optional) 
     * @return Success
     */
    getLocationTableOnly(id: number | undefined, filter: string | undefined, nameFilter: string | undefined, timeZoneFilter: string | undefined, inActiveFilter: boolean | undefined, loadLimit: number | undefined): Observable<LocationTableListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetLocationTableOnly?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (timeZoneFilter === null)
            throw new Error("The parameter 'timeZoneFilter' cannot be null.");
        else if (timeZoneFilter !== undefined)
            url_ += "TimeZoneFilter=" + encodeURIComponent("" + timeZoneFilter) + "&"; 
        if (inActiveFilter === null)
            throw new Error("The parameter 'inActiveFilter' cannot be null.");
        else if (inActiveFilter !== undefined)
            url_ += "InActiveFilter=" + encodeURIComponent("" + inActiveFilter) + "&"; 
        if (loadLimit === null)
            throw new Error("The parameter 'loadLimit' cannot be null.");
        else if (loadLimit !== undefined)
            url_ += "LoadLimit=" + encodeURIComponent("" + loadLimit) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationTableOnly(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationTableOnly(<any>response_);
                } catch (e) {
                    return <Observable<LocationTableListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<LocationTableListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationTableOnly(response: HttpResponseBase): Observable<LocationTableListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(LocationTableListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<LocationTableListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateLocation(body: UpdateLocationInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Location/UpdateLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param timezoneValue (optional) 
     * @return Success
     */
    getLocationCurrentLoadDate(timezoneValue: string | undefined): Observable<moment.Moment> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetLocationCurrentLoadDate?";
        if (timezoneValue === null)
            throw new Error("The parameter 'timezoneValue' cannot be null.");
        else if (timezoneValue !== undefined)
            url_ += "timezoneValue=" + encodeURIComponent("" + timezoneValue) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationCurrentLoadDate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationCurrentLoadDate(<any>response_);
                } catch (e) {
                    return <Observable<moment.Moment>><any>_observableThrow(e);
                }
            } else
                return <Observable<moment.Moment>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationCurrentLoadDate(response: HttpResponseBase): Observable<moment.Moment> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 ? moment(resultData200.toString()) : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<moment.Moment>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteLocation(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Location/DeleteLocation?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param timeZoneFilter (optional) 
     * @param inActiveFilter (optional) 
     * @param loadLimit (optional) 
     * @return Success
     */
    getLocationNames(id: number | undefined, filter: string | undefined, nameFilter: string | undefined, timeZoneFilter: string | undefined, inActiveFilter: boolean | undefined, loadLimit: number | undefined): Observable<LocationNameDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetLocationNames?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (timeZoneFilter === null)
            throw new Error("The parameter 'timeZoneFilter' cannot be null.");
        else if (timeZoneFilter !== undefined)
            url_ += "TimeZoneFilter=" + encodeURIComponent("" + timeZoneFilter) + "&"; 
        if (inActiveFilter === null)
            throw new Error("The parameter 'inActiveFilter' cannot be null.");
        else if (inActiveFilter !== undefined)
            url_ += "InActiveFilter=" + encodeURIComponent("" + inActiveFilter) + "&"; 
        if (loadLimit === null)
            throw new Error("The parameter 'loadLimit' cannot be null.");
        else if (loadLimit !== undefined)
            url_ += "LoadLimit=" + encodeURIComponent("" + loadLimit) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationNames(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationNames(<any>response_);
                } catch (e) {
                    return <Observable<LocationNameDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<LocationNameDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationNames(response: HttpResponseBase): Observable<LocationNameDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(LocationNameDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<LocationNameDto[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getLocationNameList(id: number | undefined, filter: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetLocationNameList?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationNameList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationNameList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationNameList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    assignLocationList(body: GetLocationNamesInputPage | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Location/AssignLocationList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignLocationList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignLocationList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processAssignLocationList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getPostalCodeRegExList(): Observable<PostalCodeZoneRegexListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Location/getPostalCodeRegExList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPostalCodeRegExList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPostalCodeRegExList(<any>response_);
                } catch (e) {
                    return <Observable<PostalCodeZoneRegexListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<PostalCodeZoneRegexListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetPostalCodeRegExList(response: HttpResponseBase): Observable<PostalCodeZoneRegexListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(PostalCodeZoneRegexListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PostalCodeZoneRegexListDto[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @return Success
     */
    getClinicEmail(locationId: number | undefined): Observable<string[]> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetClinicEmail?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "locationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicEmail(<any>response_);
                } catch (e) {
                    return <Observable<string[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<string[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicEmail(response: HttpResponseBase): Observable<string[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string[]>(<any>null);
    }

    /**
     * @return Success
     */
    getManagers(): Observable<GetManagerResult[]> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetManagers";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetManagers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetManagers(<any>response_);
                } catch (e) {
                    return <Observable<GetManagerResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetManagerResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetManagers(response: HttpResponseBase): Observable<GetManagerResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetManagerResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetManagerResult[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filterStartDate (optional) 
     * @return Success
     */
    getLocationForLock(id: number | undefined, filterStartDate: moment.Moment | undefined): Observable<GetLocationLockDto> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetLocationForLock?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filterStartDate === null)
            throw new Error("The parameter 'filterStartDate' cannot be null.");
        else if (filterStartDate !== undefined)
            url_ += "filterStartDate=" + encodeURIComponent(filterStartDate ? "" + filterStartDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationForLock(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationForLock(<any>response_);
                } catch (e) {
                    return <Observable<GetLocationLockDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLocationLockDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationForLock(response: HttpResponseBase): Observable<GetLocationLockDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLocationLockDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLocationLockDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    unlockLocation(body: UnlockLocationInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Location/UnlockLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnlockLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnlockLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnlockLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    lockLocation(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Location/LockLocation?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLockLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLockLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLockLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @return Success
     */
    unlockLocationSetupJob(tenantId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Location/UnlockLocationSetupJob?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnlockLocationSetupJob(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnlockLocationSetupJob(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnlockLocationSetupJob(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param _date (optional) 
     * @param locationId (optional) 
     * @param cacheName (optional) 
     * @param tenantId (optional) 
     * @return Success
     */
    isHolidayOnLocation(_date: moment.Moment | undefined, locationId: number | undefined, cacheName: string | undefined, tenantId: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Location/IsHolidayOnLocation?";
        if (_date === null)
            throw new Error("The parameter '_date' cannot be null.");
        else if (_date !== undefined)
            url_ += "_date=" + encodeURIComponent(_date ? "" + _date.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "locationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (cacheName === null)
            throw new Error("The parameter 'cacheName' cannot be null.");
        else if (cacheName !== undefined)
            url_ += "cacheName=" + encodeURIComponent("" + cacheName) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIsHolidayOnLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIsHolidayOnLocation(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processIsHolidayOnLocation(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param tenantId (optional) 
     * @param body (optional) 
     * @return Success
     */
    willCallIsHolidayOnLocation(locationId: number | undefined, tenantId: number | undefined, body: WillCallHolidays[] | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Location/WillCallIsHolidayOnLocation?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "locationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processWillCallIsHolidayOnLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processWillCallIsHolidayOnLocation(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processWillCallIsHolidayOnLocation(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param holidayId (optional) 
     * @param locationIds (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param filter (optional) 
     * @return Success
     */
    getUnassignedLocationInHoliday(holidayId: number | undefined, locationIds: number[] | undefined, maxResultCount: number | undefined, skipCount: number | undefined, filter: string | undefined): Observable<PagedResultDtoOfLocationNameDto> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetUnassignedLocationInHoliday?";
        if (holidayId === null)
            throw new Error("The parameter 'holidayId' cannot be null.");
        else if (holidayId !== undefined)
            url_ += "HolidayId=" + encodeURIComponent("" + holidayId) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUnassignedLocationInHoliday(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUnassignedLocationInHoliday(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfLocationNameDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfLocationNameDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUnassignedLocationInHoliday(response: HttpResponseBase): Observable<PagedResultDtoOfLocationNameDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfLocationNameDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfLocationNameDto>(<any>null);
    }

    /**
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param filter (optional) 
     * @return Success
     */
    getPagedLocation(maxResultCount: number | undefined, skipCount: number | undefined, filter: string | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetPagedLocation?";
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPagedLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPagedLocation(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPagedLocation(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @return Success
     */
    getLocationGenerationType(filter: string | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Location/GetLocationGenerationType?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationGenerationType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationGenerationType(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationGenerationType(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param location (optional) 
     * @param timeZone (optional) 
     * @param timeZoneStartTime (optional) 
     * @param queue (optional) 
     * @param tenantId (optional) 
     * @param schedLimit (optional) 
     * @param type (optional) 
     * @return Success
     */
    setupJob(location: string | undefined, timeZone: string | undefined, timeZoneStartTime: string | undefined, queue: string | undefined, tenantId: number | undefined, schedLimit: number | undefined, type: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Location/SetupJob?";
        if (location === null)
            throw new Error("The parameter 'location' cannot be null.");
        else if (location !== undefined)
            url_ += "location=" + encodeURIComponent("" + location) + "&"; 
        if (timeZone === null)
            throw new Error("The parameter 'timeZone' cannot be null.");
        else if (timeZone !== undefined)
            url_ += "timeZone=" + encodeURIComponent("" + timeZone) + "&"; 
        if (timeZoneStartTime === null)
            throw new Error("The parameter 'timeZoneStartTime' cannot be null.");
        else if (timeZoneStartTime !== undefined)
            url_ += "timeZoneStartTime=" + encodeURIComponent("" + timeZoneStartTime) + "&"; 
        if (queue === null)
            throw new Error("The parameter 'queue' cannot be null.");
        else if (queue !== undefined)
            url_ += "queue=" + encodeURIComponent("" + queue) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (schedLimit === null)
            throw new Error("The parameter 'schedLimit' cannot be null.");
        else if (schedLimit !== undefined)
            url_ += "schedLimit=" + encodeURIComponent("" + schedLimit) + "&"; 
        if (type === null)
            throw new Error("The parameter 'type' cannot be null.");
        else if (type !== undefined)
            url_ += "type=" + encodeURIComponent("" + type) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetupJob(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetupJob(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetupJob(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param location (optional) 
     * @param loadDate (optional) 
     * @return Success
     */
    removeCacheRouteGenDispatch(tenantId: number | undefined, location: string | undefined, loadDate: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Location/RemoveCacheRouteGenDispatch?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (location === null)
            throw new Error("The parameter 'location' cannot be null.");
        else if (location !== undefined)
            url_ += "location=" + encodeURIComponent("" + location) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "loadDate=" + encodeURIComponent("" + loadDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRemoveCacheRouteGenDispatch(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRemoveCacheRouteGenDispatch(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRemoveCacheRouteGenDispatch(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param jobId (optional) 
     * @param runAt (optional) 
     * @param tenantName (optional) 
     * @param body (optional) 
     * @return Success
     */
    createOrEditJob(jobId: string | undefined, runAt: string | undefined, tenantName: string | undefined, body: GenerateDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Location/CreateOrEditJob?";
        if (jobId === null)
            throw new Error("The parameter 'jobId' cannot be null.");
        else if (jobId !== undefined)
            url_ += "jobId=" + encodeURIComponent("" + jobId) + "&"; 
        if (runAt === null)
            throw new Error("The parameter 'runAt' cannot be null.");
        else if (runAt !== undefined)
            url_ += "runAt=" + encodeURIComponent("" + runAt) + "&"; 
        if (tenantName === null)
            throw new Error("The parameter 'tenantName' cannot be null.");
        else if (tenantName !== undefined)
            url_ += "tenantName=" + encodeURIComponent("" + tenantName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEditJob(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEditJob(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEditJob(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class LocationHolidaysServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param locationNameFilter (optional) 
     * @param holidayDescriptionFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, locationNameFilter: string | undefined, holidayDescriptionFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetLocationHolidayForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/LocationHolidays/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationNameFilter === null)
            throw new Error("The parameter 'locationNameFilter' cannot be null.");
        else if (locationNameFilter !== undefined)
            url_ += "LocationNameFilter=" + encodeURIComponent("" + locationNameFilter) + "&"; 
        if (holidayDescriptionFilter === null)
            throw new Error("The parameter 'holidayDescriptionFilter' cannot be null.");
        else if (holidayDescriptionFilter !== undefined)
            url_ += "HolidayDescriptionFilter=" + encodeURIComponent("" + holidayDescriptionFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetLocationHolidayForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetLocationHolidayForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetLocationHolidayForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetLocationHolidayForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetLocationHolidayForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getLocationHolidayForView(id: number | undefined): Observable<GetLocationHolidayForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/LocationHolidays/GetLocationHolidayForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationHolidayForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationHolidayForView(<any>response_);
                } catch (e) {
                    return <Observable<GetLocationHolidayForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLocationHolidayForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationHolidayForView(response: HttpResponseBase): Observable<GetLocationHolidayForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLocationHolidayForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLocationHolidayForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getLocationHolidayForEdit(id: number | undefined): Observable<GetLocationHolidayForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/LocationHolidays/GetLocationHolidayForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationHolidayForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationHolidayForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetLocationHolidayForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLocationHolidayForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationHolidayForEdit(response: HttpResponseBase): Observable<GetLocationHolidayForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLocationHolidayForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLocationHolidayForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditLocationHolidayDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/LocationHolidays/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/LocationHolidays/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllLocationForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfLocationHolidayLocationLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/LocationHolidays/GetAllLocationForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllLocationForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllLocationForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfLocationHolidayLocationLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfLocationHolidayLocationLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllLocationForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfLocationHolidayLocationLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfLocationHolidayLocationLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfLocationHolidayLocationLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllHolidayForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfLocationHolidayHolidayLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/LocationHolidays/GetAllHolidayForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllHolidayForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllHolidayForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfLocationHolidayHolidayLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfLocationHolidayHolidayLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllHolidayForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfLocationHolidayHolidayLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfLocationHolidayHolidayLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfLocationHolidayHolidayLookupTableDto>(<any>null);
    }
}

@Injectable()
export class LocatorServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @param driverActive (optional) 
     * @param routeType (optional) 
     * @param routeIds (optional) 
     * @param isNoEmptyRoute (optional) 
     * @param idleParam (optional) 
     * @param active (optional) 
     * @return Success
     */
    getDriverFilter(routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined, driverActive: number[] | undefined, routeType: number[] | undefined, routeIds: number[] | undefined, isNoEmptyRoute: boolean | undefined, idleParam: number | undefined, active: boolean | undefined): Observable<ListResultDtoOfGetDriverFilterResult> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetDriverFilter?";
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (driverActive === null)
            throw new Error("The parameter 'driverActive' cannot be null.");
        else if (driverActive !== undefined)
            driverActive && driverActive.forEach(item => { url_ += "DriverActive=" + encodeURIComponent("" + item) + "&"; });
        if (routeType === null)
            throw new Error("The parameter 'routeType' cannot be null.");
        else if (routeType !== undefined)
            routeType && routeType.forEach(item => { url_ += "RouteType=" + encodeURIComponent("" + item) + "&"; });
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isNoEmptyRoute === null)
            throw new Error("The parameter 'isNoEmptyRoute' cannot be null.");
        else if (isNoEmptyRoute !== undefined)
            url_ += "IsNoEmptyRoute=" + encodeURIComponent("" + isNoEmptyRoute) + "&"; 
        if (idleParam === null)
            throw new Error("The parameter 'idleParam' cannot be null.");
        else if (idleParam !== undefined)
            url_ += "IdleParam=" + encodeURIComponent("" + idleParam) + "&"; 
        if (active === null)
            throw new Error("The parameter 'active' cannot be null.");
        else if (active !== undefined)
            url_ += "Active=" + encodeURIComponent("" + active) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverFilter(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverFilter(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetDriverFilterResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetDriverFilterResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverFilter(response: HttpResponseBase): Observable<ListResultDtoOfGetDriverFilterResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetDriverFilterResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetDriverFilterResult>(<any>null);
    }

    /**
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @param routeStatusId (optional) 
     * @param routeTypeId (optional) 
     * @param routeActive (optional) 
     * @return Success
     */
    getRouteFilter(routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined, routeStatusId: number | undefined, routeTypeId: number | undefined, routeActive: number[] | undefined): Observable<ListResultDtoOfGetRouteFilterResult> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetRouteFilter?";
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (routeStatusId === null)
            throw new Error("The parameter 'routeStatusId' cannot be null.");
        else if (routeStatusId !== undefined)
            url_ += "RouteStatusId=" + encodeURIComponent("" + routeStatusId) + "&"; 
        if (routeTypeId === null)
            throw new Error("The parameter 'routeTypeId' cannot be null.");
        else if (routeTypeId !== undefined)
            url_ += "RouteTypeId=" + encodeURIComponent("" + routeTypeId) + "&"; 
        if (routeActive === null)
            throw new Error("The parameter 'routeActive' cannot be null.");
        else if (routeActive !== undefined)
            routeActive && routeActive.forEach(item => { url_ += "RouteActive=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteFilter(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteFilter(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetRouteFilterResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetRouteFilterResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteFilter(response: HttpResponseBase): Observable<ListResultDtoOfGetRouteFilterResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetRouteFilterResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetRouteFilterResult>(<any>null);
    }

    /**
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @param driverActive (optional) 
     * @param routeType (optional) 
     * @param routeIds (optional) 
     * @param isNoEmptyRoute (optional) 
     * @param idleParam (optional) 
     * @param active (optional) 
     * @return Success
     */
    getVehicleDestinationPoints(routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined, driverActive: number[] | undefined, routeType: number[] | undefined, routeIds: number[] | undefined, isNoEmptyRoute: boolean | undefined, idleParam: number | undefined, active: boolean | undefined): Observable<ListResultDtoOfGetVehicleDestinationPointsResultDto> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetVehicleDestinationPoints?";
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (driverActive === null)
            throw new Error("The parameter 'driverActive' cannot be null.");
        else if (driverActive !== undefined)
            driverActive && driverActive.forEach(item => { url_ += "DriverActive=" + encodeURIComponent("" + item) + "&"; });
        if (routeType === null)
            throw new Error("The parameter 'routeType' cannot be null.");
        else if (routeType !== undefined)
            routeType && routeType.forEach(item => { url_ += "RouteType=" + encodeURIComponent("" + item) + "&"; });
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isNoEmptyRoute === null)
            throw new Error("The parameter 'isNoEmptyRoute' cannot be null.");
        else if (isNoEmptyRoute !== undefined)
            url_ += "IsNoEmptyRoute=" + encodeURIComponent("" + isNoEmptyRoute) + "&"; 
        if (idleParam === null)
            throw new Error("The parameter 'idleParam' cannot be null.");
        else if (idleParam !== undefined)
            url_ += "IdleParam=" + encodeURIComponent("" + idleParam) + "&"; 
        if (active === null)
            throw new Error("The parameter 'active' cannot be null.");
        else if (active !== undefined)
            url_ += "Active=" + encodeURIComponent("" + active) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleDestinationPoints(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleDestinationPoints(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetVehicleDestinationPointsResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetVehicleDestinationPointsResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleDestinationPoints(response: HttpResponseBase): Observable<ListResultDtoOfGetVehicleDestinationPointsResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetVehicleDestinationPointsResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetVehicleDestinationPointsResultDto>(<any>null);
    }

    /**
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @param driverActive (optional) 
     * @param routeType (optional) 
     * @param routeIds (optional) 
     * @param isNoEmptyRoute (optional) 
     * @param idleParam (optional) 
     * @param active (optional) 
     * @return Success
     */
    getVehicleLocationLog(routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined, driverActive: number[] | undefined, routeType: number[] | undefined, routeIds: number[] | undefined, isNoEmptyRoute: boolean | undefined, idleParam: number | undefined, active: boolean | undefined): Observable<ListResultDtoOfGetVehicleLocationLogResult> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetVehicleLocationLog?";
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (driverActive === null)
            throw new Error("The parameter 'driverActive' cannot be null.");
        else if (driverActive !== undefined)
            driverActive && driverActive.forEach(item => { url_ += "DriverActive=" + encodeURIComponent("" + item) + "&"; });
        if (routeType === null)
            throw new Error("The parameter 'routeType' cannot be null.");
        else if (routeType !== undefined)
            routeType && routeType.forEach(item => { url_ += "RouteType=" + encodeURIComponent("" + item) + "&"; });
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isNoEmptyRoute === null)
            throw new Error("The parameter 'isNoEmptyRoute' cannot be null.");
        else if (isNoEmptyRoute !== undefined)
            url_ += "IsNoEmptyRoute=" + encodeURIComponent("" + isNoEmptyRoute) + "&"; 
        if (idleParam === null)
            throw new Error("The parameter 'idleParam' cannot be null.");
        else if (idleParam !== undefined)
            url_ += "IdleParam=" + encodeURIComponent("" + idleParam) + "&"; 
        if (active === null)
            throw new Error("The parameter 'active' cannot be null.");
        else if (active !== undefined)
            url_ += "Active=" + encodeURIComponent("" + active) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleLocationLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleLocationLog(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetVehicleLocationLogResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetVehicleLocationLogResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleLocationLog(response: HttpResponseBase): Observable<ListResultDtoOfGetVehicleLocationLogResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetVehicleLocationLogResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetVehicleLocationLogResult>(<any>null);
    }

    /**
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @param driverActive (optional) 
     * @param routeType (optional) 
     * @param routeIds (optional) 
     * @param isNoEmptyRoute (optional) 
     * @param idleParam (optional) 
     * @param active (optional) 
     * @return Success
     */
    getVehicleLatestLocation(routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined, driverActive: number[] | undefined, routeType: number[] | undefined, routeIds: number[] | undefined, isNoEmptyRoute: boolean | undefined, idleParam: number | undefined, active: boolean | undefined): Observable<ListResultDtoOfGetVehicleLocationLogResult> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetVehicleLatestLocation?";
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (driverActive === null)
            throw new Error("The parameter 'driverActive' cannot be null.");
        else if (driverActive !== undefined)
            driverActive && driverActive.forEach(item => { url_ += "DriverActive=" + encodeURIComponent("" + item) + "&"; });
        if (routeType === null)
            throw new Error("The parameter 'routeType' cannot be null.");
        else if (routeType !== undefined)
            routeType && routeType.forEach(item => { url_ += "RouteType=" + encodeURIComponent("" + item) + "&"; });
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isNoEmptyRoute === null)
            throw new Error("The parameter 'isNoEmptyRoute' cannot be null.");
        else if (isNoEmptyRoute !== undefined)
            url_ += "IsNoEmptyRoute=" + encodeURIComponent("" + isNoEmptyRoute) + "&"; 
        if (idleParam === null)
            throw new Error("The parameter 'idleParam' cannot be null.");
        else if (idleParam !== undefined)
            url_ += "IdleParam=" + encodeURIComponent("" + idleParam) + "&"; 
        if (active === null)
            throw new Error("The parameter 'active' cannot be null.");
        else if (active !== undefined)
            url_ += "Active=" + encodeURIComponent("" + active) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleLatestLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleLatestLocation(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetVehicleLocationLogResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetVehicleLocationLogResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleLatestLocation(response: HttpResponseBase): Observable<ListResultDtoOfGetVehicleLocationLogResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetVehicleLocationLogResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetVehicleLocationLogResult>(<any>null);
    }

    /**
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @param routeStatusId (optional) 
     * @param routeTypeId (optional) 
     * @param routeActive (optional) 
     * @return Success
     */
    getVehicleLatestLocationByRoute(routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined, routeStatusId: number | undefined, routeTypeId: number | undefined, routeActive: number[] | undefined): Observable<ListResultDtoOfGetVehicleLocationLogResult> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetVehicleLatestLocationByRoute?";
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (routeStatusId === null)
            throw new Error("The parameter 'routeStatusId' cannot be null.");
        else if (routeStatusId !== undefined)
            url_ += "RouteStatusId=" + encodeURIComponent("" + routeStatusId) + "&"; 
        if (routeTypeId === null)
            throw new Error("The parameter 'routeTypeId' cannot be null.");
        else if (routeTypeId !== undefined)
            url_ += "RouteTypeId=" + encodeURIComponent("" + routeTypeId) + "&"; 
        if (routeActive === null)
            throw new Error("The parameter 'routeActive' cannot be null.");
        else if (routeActive !== undefined)
            routeActive && routeActive.forEach(item => { url_ += "RouteActive=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleLatestLocationByRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleLatestLocationByRoute(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetVehicleLocationLogResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetVehicleLocationLogResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleLatestLocationByRoute(response: HttpResponseBase): Observable<ListResultDtoOfGetVehicleLocationLogResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetVehicleLocationLogResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetVehicleLocationLogResult>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @return Success
     */
    getRouteListDetail(orderId: number | undefined, routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined): Observable<ListResultDtoOfMoveToRouteListDetail> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetRouteListDetail?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteListDetail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteListDetail(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfMoveToRouteListDetail>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfMoveToRouteListDetail>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteListDetail(response: HttpResponseBase): Observable<ListResultDtoOfMoveToRouteListDetail> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfMoveToRouteListDetail.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfMoveToRouteListDetail>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    moveOrder(body: MoveOrder | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Locator/MoveOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMoveOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMoveOrder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processMoveOrder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteType(): Observable<ListResultDtoOfRouteTypeList> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetRouteType";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteType(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfRouteTypeList>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfRouteTypeList>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteType(response: HttpResponseBase): Observable<ListResultDtoOfRouteTypeList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfRouteTypeList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfRouteTypeList>(<any>null);
    }

    /**
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @param driverActive (optional) 
     * @param routeType (optional) 
     * @param routeIds (optional) 
     * @param isNoEmptyRoute (optional) 
     * @param idleParam (optional) 
     * @param active (optional) 
     * @return Success
     */
    getLaboratoryDriverDestinationPoints(routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined, driverActive: number[] | undefined, routeType: number[] | undefined, routeIds: number[] | undefined, isNoEmptyRoute: boolean | undefined, idleParam: number | undefined, active: boolean | undefined): Observable<ListResultDtoOfGetVehicleDestinationPointsResultDto> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetLaboratoryDriverDestinationPoints?";
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (driverActive === null)
            throw new Error("The parameter 'driverActive' cannot be null.");
        else if (driverActive !== undefined)
            driverActive && driverActive.forEach(item => { url_ += "DriverActive=" + encodeURIComponent("" + item) + "&"; });
        if (routeType === null)
            throw new Error("The parameter 'routeType' cannot be null.");
        else if (routeType !== undefined)
            routeType && routeType.forEach(item => { url_ += "RouteType=" + encodeURIComponent("" + item) + "&"; });
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isNoEmptyRoute === null)
            throw new Error("The parameter 'isNoEmptyRoute' cannot be null.");
        else if (isNoEmptyRoute !== undefined)
            url_ += "IsNoEmptyRoute=" + encodeURIComponent("" + isNoEmptyRoute) + "&"; 
        if (idleParam === null)
            throw new Error("The parameter 'idleParam' cannot be null.");
        else if (idleParam !== undefined)
            url_ += "IdleParam=" + encodeURIComponent("" + idleParam) + "&"; 
        if (active === null)
            throw new Error("The parameter 'active' cannot be null.");
        else if (active !== undefined)
            url_ += "Active=" + encodeURIComponent("" + active) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLaboratoryDriverDestinationPoints(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLaboratoryDriverDestinationPoints(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetVehicleDestinationPointsResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetVehicleDestinationPointsResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLaboratoryDriverDestinationPoints(response: HttpResponseBase): Observable<ListResultDtoOfGetVehicleDestinationPointsResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetVehicleDestinationPointsResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetVehicleDestinationPointsResultDto>(<any>null);
    }

    /**
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @param driverActive (optional) 
     * @param routeType (optional) 
     * @param routeIds (optional) 
     * @param isNoEmptyRoute (optional) 
     * @param idleParam (optional) 
     * @param active (optional) 
     * @return Success
     */
    getLaboratoryDriverFilter(routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined, driverActive: number[] | undefined, routeType: number[] | undefined, routeIds: number[] | undefined, isNoEmptyRoute: boolean | undefined, idleParam: number | undefined, active: boolean | undefined): Observable<ListResultDtoOfGetDriverFilterResult> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetLaboratoryDriverFilter?";
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (driverActive === null)
            throw new Error("The parameter 'driverActive' cannot be null.");
        else if (driverActive !== undefined)
            driverActive && driverActive.forEach(item => { url_ += "DriverActive=" + encodeURIComponent("" + item) + "&"; });
        if (routeType === null)
            throw new Error("The parameter 'routeType' cannot be null.");
        else if (routeType !== undefined)
            routeType && routeType.forEach(item => { url_ += "RouteType=" + encodeURIComponent("" + item) + "&"; });
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isNoEmptyRoute === null)
            throw new Error("The parameter 'isNoEmptyRoute' cannot be null.");
        else if (isNoEmptyRoute !== undefined)
            url_ += "IsNoEmptyRoute=" + encodeURIComponent("" + isNoEmptyRoute) + "&"; 
        if (idleParam === null)
            throw new Error("The parameter 'idleParam' cannot be null.");
        else if (idleParam !== undefined)
            url_ += "IdleParam=" + encodeURIComponent("" + idleParam) + "&"; 
        if (active === null)
            throw new Error("The parameter 'active' cannot be null.");
        else if (active !== undefined)
            url_ += "Active=" + encodeURIComponent("" + active) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLaboratoryDriverFilter(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLaboratoryDriverFilter(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetDriverFilterResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetDriverFilterResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetLaboratoryDriverFilter(response: HttpResponseBase): Observable<ListResultDtoOfGetDriverFilterResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetDriverFilterResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetDriverFilterResult>(<any>null);
    }

    /**
     * @param loadDate (optional) 
     * @param locationId (optional) 
     * @return Success
     */
    getActiveRoutes(loadDate: moment.Moment | undefined, locationId: number | undefined): Observable<ListResultDtoOfGetActiveRouteResult> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetActiveRoutes?";
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetActiveRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetActiveRoutes(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetActiveRouteResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetActiveRouteResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetActiveRoutes(response: HttpResponseBase): Observable<ListResultDtoOfGetActiveRouteResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetActiveRouteResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetActiveRouteResult>(<any>null);
    }

    /**
     * @return Success
     */
    getMobileLogo(): Observable<MobileLogo> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetMobileLogo";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileLogo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileLogo(<any>response_);
                } catch (e) {
                    return <Observable<MobileLogo>><any>_observableThrow(e);
                }
            } else
                return <Observable<MobileLogo>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileLogo(response: HttpResponseBase): Observable<MobileLogo> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = MobileLogo.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<MobileLogo>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateLocatorGeocode(body: UpdateLocatorGeocodeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Locator/UpdateLocatorGeocode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateLocatorGeocode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateLocatorGeocode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateLocatorGeocode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeDateStart (optional) 
     * @param routeDateEnd (optional) 
     * @param locationId (optional) 
     * @param driverActive (optional) 
     * @param routeType (optional) 
     * @param routeIds (optional) 
     * @param isNoEmptyRoute (optional) 
     * @param idleParam (optional) 
     * @param active (optional) 
     * @return Success
     */
    getAllVehicleIdle(routeDateStart: moment.Moment | undefined, routeDateEnd: moment.Moment | undefined, locationId: number | undefined, driverActive: number[] | undefined, routeType: number[] | undefined, routeIds: number[] | undefined, isNoEmptyRoute: boolean | undefined, idleParam: number | undefined, active: boolean | undefined): Observable<ListResultDtoOfIdleResult> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetAllVehicleIdle?";
        if (routeDateStart === null)
            throw new Error("The parameter 'routeDateStart' cannot be null.");
        else if (routeDateStart !== undefined)
            url_ += "RouteDateStart=" + encodeURIComponent(routeDateStart ? "" + routeDateStart.toJSON() : "") + "&"; 
        if (routeDateEnd === null)
            throw new Error("The parameter 'routeDateEnd' cannot be null.");
        else if (routeDateEnd !== undefined)
            url_ += "RouteDateEnd=" + encodeURIComponent(routeDateEnd ? "" + routeDateEnd.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (driverActive === null)
            throw new Error("The parameter 'driverActive' cannot be null.");
        else if (driverActive !== undefined)
            driverActive && driverActive.forEach(item => { url_ += "DriverActive=" + encodeURIComponent("" + item) + "&"; });
        if (routeType === null)
            throw new Error("The parameter 'routeType' cannot be null.");
        else if (routeType !== undefined)
            routeType && routeType.forEach(item => { url_ += "RouteType=" + encodeURIComponent("" + item) + "&"; });
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "RouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (isNoEmptyRoute === null)
            throw new Error("The parameter 'isNoEmptyRoute' cannot be null.");
        else if (isNoEmptyRoute !== undefined)
            url_ += "IsNoEmptyRoute=" + encodeURIComponent("" + isNoEmptyRoute) + "&"; 
        if (idleParam === null)
            throw new Error("The parameter 'idleParam' cannot be null.");
        else if (idleParam !== undefined)
            url_ += "IdleParam=" + encodeURIComponent("" + idleParam) + "&"; 
        if (active === null)
            throw new Error("The parameter 'active' cannot be null.");
        else if (active !== undefined)
            url_ += "Active=" + encodeURIComponent("" + active) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllVehicleIdle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllVehicleIdle(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfIdleResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfIdleResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllVehicleIdle(response: HttpResponseBase): Observable<ListResultDtoOfIdleResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfIdleResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfIdleResult>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getRouteLocation(routeId: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Locator/GetRouteLocation?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteLocation(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteLocation(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class MigrationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param addressId (optional) 
     * @param postalCodeId (optional) 
     * @param postalCodeValueFilter (optional) 
     * @param stateFilter (optional) 
     * @param cityFilter (optional) 
     * @param countryFilter (optional) 
     * @param addressLine1Filter (optional) 
     * @param addressLine2Filter (optional) 
     * @param nameFilter (optional) 
     * @param filter (optional) 
     * @param firstName (optional) 
     * @param lastName (optional) 
     * @param emailAddressFilter (optional) 
     * @param phoneNumberFilter (optional) 
     * @param addressType (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getContactsJson(id: number | undefined, userId: number | undefined, addressId: number | undefined, postalCodeId: number | undefined, postalCodeValueFilter: string | undefined, stateFilter: string | undefined, cityFilter: string | undefined, countryFilter: string | undefined, addressLine1Filter: string | undefined, addressLine2Filter: string | undefined, nameFilter: string | undefined, filter: string | undefined, firstName: string | undefined, lastName: string | undefined, emailAddressFilter: string | undefined, phoneNumberFilter: string | undefined, addressType: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetContactJsonListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetContactsJson?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (addressId === null)
            throw new Error("The parameter 'addressId' cannot be null.");
        else if (addressId !== undefined)
            url_ += "AddressId=" + encodeURIComponent("" + addressId) + "&"; 
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (postalCodeValueFilter === null)
            throw new Error("The parameter 'postalCodeValueFilter' cannot be null.");
        else if (postalCodeValueFilter !== undefined)
            url_ += "PostalCodeValueFilter=" + encodeURIComponent("" + postalCodeValueFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        if (countryFilter === null)
            throw new Error("The parameter 'countryFilter' cannot be null.");
        else if (countryFilter !== undefined)
            url_ += "CountryFilter=" + encodeURIComponent("" + countryFilter) + "&"; 
        if (addressLine1Filter === null)
            throw new Error("The parameter 'addressLine1Filter' cannot be null.");
        else if (addressLine1Filter !== undefined)
            url_ += "AddressLine1Filter=" + encodeURIComponent("" + addressLine1Filter) + "&"; 
        if (addressLine2Filter === null)
            throw new Error("The parameter 'addressLine2Filter' cannot be null.");
        else if (addressLine2Filter !== undefined)
            url_ += "AddressLine2Filter=" + encodeURIComponent("" + addressLine2Filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (firstName === null)
            throw new Error("The parameter 'firstName' cannot be null.");
        else if (firstName !== undefined)
            url_ += "FirstName=" + encodeURIComponent("" + firstName) + "&"; 
        if (lastName === null)
            throw new Error("The parameter 'lastName' cannot be null.");
        else if (lastName !== undefined)
            url_ += "LastName=" + encodeURIComponent("" + lastName) + "&"; 
        if (emailAddressFilter === null)
            throw new Error("The parameter 'emailAddressFilter' cannot be null.");
        else if (emailAddressFilter !== undefined)
            url_ += "EmailAddressFilter=" + encodeURIComponent("" + emailAddressFilter) + "&"; 
        if (phoneNumberFilter === null)
            throw new Error("The parameter 'phoneNumberFilter' cannot be null.");
        else if (phoneNumberFilter !== undefined)
            url_ += "PhoneNumberFilter=" + encodeURIComponent("" + phoneNumberFilter) + "&"; 
        if (addressType === null)
            throw new Error("The parameter 'addressType' cannot be null.");
        else if (addressType !== undefined)
            url_ += "AddressType=" + encodeURIComponent("" + addressType) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetContactsJson(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetContactsJson(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetContactJsonListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetContactJsonListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetContactsJson(response: HttpResponseBase): Observable<PagedResultDtoOfGetContactJsonListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetContactJsonListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetContactJsonListItemDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getUsersJson(id: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<GetUserJsonListItemDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetUsersJson?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUsersJson(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUsersJson(<any>response_);
                } catch (e) {
                    return <Observable<GetUserJsonListItemDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserJsonListItemDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetUsersJson(response: HttpResponseBase): Observable<GetUserJsonListItemDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetUserJsonListItemDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserJsonListItemDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getLocationsJson(): Observable<GetLocationJsonListItemDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetLocationsJson";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationsJson(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationsJson(<any>response_);
                } catch (e) {
                    return <Observable<GetLocationJsonListItemDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLocationJsonListItemDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationsJson(response: HttpResponseBase): Observable<GetLocationJsonListItemDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetLocationJsonListItemDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLocationJsonListItemDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getPostalCodeZones(): Observable<GetPostalCodeZoneListItemDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetPostalCodeZones";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPostalCodeZones(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPostalCodeZones(<any>response_);
                } catch (e) {
                    return <Observable<GetPostalCodeZoneListItemDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetPostalCodeZoneListItemDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetPostalCodeZones(response: HttpResponseBase): Observable<GetPostalCodeZoneListItemDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetPostalCodeZoneListItemDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetPostalCodeZoneListItemDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getZoneLocations(): Observable<GetZoneLocationsJsonDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetZoneLocations";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetZoneLocations(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetZoneLocations(<any>response_);
                } catch (e) {
                    return <Observable<GetZoneLocationsJsonDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetZoneLocationsJsonDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetZoneLocations(response: HttpResponseBase): Observable<GetZoneLocationsJsonDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetZoneLocationsJsonDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetZoneLocationsJsonDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getVehicles(): Observable<VehicleJsonDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetVehicles";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicles(<any>response_);
                } catch (e) {
                    return <Observable<VehicleJsonDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<VehicleJsonDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicles(response: HttpResponseBase): Observable<VehicleJsonDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(VehicleJsonDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<VehicleJsonDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getVehicleLocations(): Observable<GetVehicleLocationJsonDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetVehicleLocations";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleLocations(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleLocations(<any>response_);
                } catch (e) {
                    return <Observable<GetVehicleLocationJsonDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVehicleLocationJsonDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleLocations(response: HttpResponseBase): Observable<GetVehicleLocationJsonDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetVehicleLocationJsonDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVehicleLocationJsonDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteTemplates(): Observable<RouteTemplateJsonDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetRouteTemplates";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplates(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplates(<any>response_);
                } catch (e) {
                    return <Observable<RouteTemplateJsonDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteTemplateJsonDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplates(response: HttpResponseBase): Observable<RouteTemplateJsonDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteTemplateJsonDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteTemplateJsonDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteTemplateZones(): Observable<RouteTemplateZoneJsonDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetRouteTemplateZones";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateZones(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateZones(<any>response_);
                } catch (e) {
                    return <Observable<RouteTemplateZoneJsonDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteTemplateZoneJsonDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateZones(response: HttpResponseBase): Observable<RouteTemplateZoneJsonDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteTemplateZoneJsonDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteTemplateZoneJsonDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteTemplateAddresses(): Observable<RouteTemplateAddressJsonDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetRouteTemplateAddresses";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateAddresses(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateAddresses(<any>response_);
                } catch (e) {
                    return <Observable<RouteTemplateAddressJsonDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteTemplateAddressJsonDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateAddresses(response: HttpResponseBase): Observable<RouteTemplateAddressJsonDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteTemplateAddressJsonDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteTemplateAddressJsonDto[]>(<any>null);
    }

    /**
     * @param tenancyName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getTenantThemes(tenancyName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<TenantThemeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Migration/GetTenantThemes?";
        if (tenancyName === null)
            throw new Error("The parameter 'tenancyName' cannot be null.");
        else if (tenancyName !== undefined)
            url_ += "TenancyName=" + encodeURIComponent("" + tenancyName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantThemes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantThemes(<any>response_);
                } catch (e) {
                    return <Observable<TenantThemeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<TenantThemeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantThemes(response: HttpResponseBase): Observable<TenantThemeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(TenantThemeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TenantThemeDto[]>(<any>null);
    }
}

@Injectable()
export class MileageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createMileage(body: CreateMileageInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Mileage/CreateMileage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateMileage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateMileage(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateMileage(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param value (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getMileagePaged(id: number | undefined, value: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfMileageListDto> {
        let url_ = this.baseUrl + "/api/services/app/Mileage/GetMileagePaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMileagePaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMileagePaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfMileageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfMileageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMileagePaged(response: HttpResponseBase): Observable<PagedResultDtoOfMileageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfMileageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfMileageListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getMileageForEdit(id: number | undefined): Observable<UpdateMileageInput> {
        let url_ = this.baseUrl + "/api/services/app/Mileage/GetMileageForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMileageForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMileageForEdit(<any>response_);
                } catch (e) {
                    return <Observable<UpdateMileageInput>><any>_observableThrow(e);
                }
            } else
                return <Observable<UpdateMileageInput>><any>_observableThrow(response_);
        }));
    }

    protected processGetMileageForEdit(response: HttpResponseBase): Observable<UpdateMileageInput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = UpdateMileageInput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UpdateMileageInput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateMileage(body: UpdateMileageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Mileage/UpdateMileage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateMileage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateMileage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateMileage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteMileage(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Mileage/DeleteMileage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteMileage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteMileage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteMileage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class MileageReimbursementServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param locationId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getMileageReimbursement(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, locationId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<MileageReimbursementListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/MileageReimbursement/GetMileageReimbursement?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMileageReimbursement(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMileageReimbursement(<any>response_);
                } catch (e) {
                    return <Observable<MileageReimbursementListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<MileageReimbursementListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetMileageReimbursement(response: HttpResponseBase): Observable<MileageReimbursementListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(MileageReimbursementListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<MileageReimbursementListDto[]>(<any>null);
    }

    /**
     * @param meters (optional) 
     * @return Success
     */
    convertMetersToMiles(meters: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/MileageReimbursement/ConvertMetersToMiles?";
        if (meters === null)
            throw new Error("The parameter 'meters' cannot be null.");
        else if (meters !== undefined)
            url_ += "meters=" + encodeURIComponent("" + meters) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertMetersToMiles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertMetersToMiles(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processConvertMetersToMiles(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param locationId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getMileageReimbursementToExcel(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, locationId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/MileageReimbursement/GetMileageReimbursementToExcel?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMileageReimbursementToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMileageReimbursementToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMileageReimbursementToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }
}

@Injectable()
export class MobileAppVersionServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getMobileOsTypes(): Observable<GetMobileOsTypesResultDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileAppVersion/GetMobileOsTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileOsTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileOsTypes(<any>response_);
                } catch (e) {
                    return <Observable<GetMobileOsTypesResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetMobileOsTypesResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileOsTypes(response: HttpResponseBase): Observable<GetMobileOsTypesResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetMobileOsTypesResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetMobileOsTypesResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getMobileClientCodes(): Observable<GetMobileClientCodesResultDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileAppVersion/GetMobileClientCodes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileClientCodes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileClientCodes(<any>response_);
                } catch (e) {
                    return <Observable<GetMobileClientCodesResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetMobileClientCodesResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileClientCodes(response: HttpResponseBase): Observable<GetMobileClientCodesResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetMobileClientCodesResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetMobileClientCodesResultDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateMobileVersion(body: CreateMobileVersionInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/MobileAppVersion/CreateOrUpdateMobileVersion";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateMobileVersion(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateMobileVersion(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateMobileVersion(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createMobileVersion(body: CreateMobileVersionInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/MobileAppVersion/CreateMobileVersion";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateMobileVersion(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateMobileVersion(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateMobileVersion(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getMobileVersions(sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfMobileVersionListDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileAppVersion/GetMobileVersions?";
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileVersions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileVersions(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfMobileVersionListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfMobileVersionListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileVersions(response: HttpResponseBase): Observable<PagedResultDtoOfMobileVersionListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfMobileVersionListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfMobileVersionListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateMobileVersion(body: UpdateMobileVersionInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileAppVersion/UpdateMobileVersion";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateMobileVersion(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateMobileVersion(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateMobileVersion(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteMobileVersion(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileAppVersion/DeleteMobileVersion?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteMobileVersion(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteMobileVersion(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteMobileVersion(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class MobileClientServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createMobileClient(body: CreateMobileClientInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/MobileClient/CreateMobileClient";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateMobileClient(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateMobileClient(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateMobileClient(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param oSName (optional) 
     * @param oSVersion (optional) 
     * @param deviceModel (optional) 
     * @param appVersion (optional) 
     * @param driverStatus (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getMobileClients(id: number | undefined, oSName: string | undefined, oSVersion: string | undefined, deviceModel: string | undefined, appVersion: number | undefined, driverStatus: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfMobileClientListDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileClient/GetMobileClients?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (oSName === null)
            throw new Error("The parameter 'oSName' cannot be null.");
        else if (oSName !== undefined)
            url_ += "OSName=" + encodeURIComponent("" + oSName) + "&"; 
        if (oSVersion === null)
            throw new Error("The parameter 'oSVersion' cannot be null.");
        else if (oSVersion !== undefined)
            url_ += "OSVersion=" + encodeURIComponent("" + oSVersion) + "&"; 
        if (deviceModel === null)
            throw new Error("The parameter 'deviceModel' cannot be null.");
        else if (deviceModel !== undefined)
            url_ += "DeviceModel=" + encodeURIComponent("" + deviceModel) + "&"; 
        if (appVersion === null)
            throw new Error("The parameter 'appVersion' cannot be null.");
        else if (appVersion !== undefined)
            url_ += "AppVersion=" + encodeURIComponent("" + appVersion) + "&"; 
        if (driverStatus === null)
            throw new Error("The parameter 'driverStatus' cannot be null.");
        else if (driverStatus !== undefined)
            url_ += "DriverStatus=" + encodeURIComponent("" + driverStatus) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileClients(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileClients(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfMobileClientListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfMobileClientListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileClients(response: HttpResponseBase): Observable<PagedResultDtoOfMobileClientListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfMobileClientListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfMobileClientListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateMobileClient(body: UpdateMobileClientInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileClient/UpdateMobileClient";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateMobileClient(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateMobileClient(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateMobileClient(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteMobileClient(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileClient/DeleteMobileClient?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteMobileClient(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteMobileClient(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteMobileClient(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param mobileClientCode (optional) 
     * @return Success
     */
    getMobileUserPreferenceCodes(mobileClientCode: string | undefined): Observable<GetMobileUserPreferenceCodesResultDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileClient/GetMobileUserPreferenceCodes?";
        if (mobileClientCode === null)
            throw new Error("The parameter 'mobileClientCode' cannot be null.");
        else if (mobileClientCode !== undefined)
            url_ += "mobileClientCode=" + encodeURIComponent("" + mobileClientCode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileUserPreferenceCodes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileUserPreferenceCodes(<any>response_);
                } catch (e) {
                    return <Observable<GetMobileUserPreferenceCodesResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetMobileUserPreferenceCodesResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileUserPreferenceCodes(response: HttpResponseBase): Observable<GetMobileUserPreferenceCodesResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetMobileUserPreferenceCodesResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetMobileUserPreferenceCodesResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getCurrentUserRoles(): Observable<ListResultDtoOfRoleEditDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileClient/GetCurrentUserRoles";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCurrentUserRoles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCurrentUserRoles(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfRoleEditDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfRoleEditDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCurrentUserRoles(response: HttpResponseBase): Observable<ListResultDtoOfRoleEditDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfRoleEditDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfRoleEditDto>(<any>null);
    }
}

@Injectable()
export class MobileClientLogInServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateLogInUnlockCode(body: CreateLogInUnlockCode | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/MobileClientLogIn/GenerateLogInUnlockCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateLogInUnlockCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateLogInUnlockCode(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateLogInUnlockCode(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    validateLogInUnlockCode(body: ValidateLogInUnlockCodeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileClientLogIn/ValidateLogInUnlockCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processValidateLogInUnlockCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processValidateLogInUnlockCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processValidateLogInUnlockCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class MobileClientMessageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createMobileClientMessage(body: CreateMobileClientMessageInputDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/MobileClientMessage/CreateMobileClientMessage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateMobileClientMessage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateMobileClientMessage(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateMobileClientMessage(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteMobileClientMessage(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileClientMessage/DeleteMobileClientMessage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteMobileClientMessage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteMobileClientMessage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteMobileClientMessage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param isRead (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getMobileClientMessages(id: number | undefined, isRead: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetMobileClientMessageResultDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileClientMessage/GetMobileClientMessages?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (isRead === null)
            throw new Error("The parameter 'isRead' cannot be null.");
        else if (isRead !== undefined)
            url_ += "IsRead=" + encodeURIComponent("" + isRead) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileClientMessages(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileClientMessages(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetMobileClientMessageResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetMobileClientMessageResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileClientMessages(response: HttpResponseBase): Observable<PagedResultDtoOfGetMobileClientMessageResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetMobileClientMessageResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetMobileClientMessageResultDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateMobileClientMessage(body: UpdateMobileClientMessageInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileClientMessage/UpdateMobileClientMessage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateMobileClientMessage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateMobileClientMessage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateMobileClientMessage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class MobilePushNotificationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    testSendMessage(body: TestSendMessageInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobilePushNotification/TestSendMessage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTestSendMessage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTestSendMessage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processTestSendMessage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class MobileTenantCodeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateForTenant(body: CreateOrUpdateForTenantInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileTenantCode/CreateOrUpdateForTenant";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateForTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateForTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateForTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenancyName (optional) 
     * @return Success
     */
    deleteForTenant(tenancyName: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileTenantCode/DeleteForTenant?";
        if (tenancyName === null)
            throw new Error("The parameter 'tenancyName' cannot be null.");
        else if (tenancyName !== undefined)
            url_ += "TenancyName=" + encodeURIComponent("" + tenancyName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteForTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteForTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteForTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param code (optional) 
     * @return Success
     */
    getTenantMobileTheme(code: string | undefined): Observable<GetMobileThemeTenantDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileTenantCode/GetTenantMobileTheme?";
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantMobileTheme(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantMobileTheme(<any>response_);
                } catch (e) {
                    return <Observable<GetMobileThemeTenantDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetMobileThemeTenantDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantMobileTheme(response: HttpResponseBase): Observable<GetMobileThemeTenantDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetMobileThemeTenantDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetMobileThemeTenantDto>(<any>null);
    }
}

@Injectable()
export class MobileThemeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createMobileTheme(body: CreateMobileThemeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/CreateMobileTheme";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateMobileTheme(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateMobileTheme(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateMobileTheme(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateMobileTheme(body: UpdateMobileThemeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/UpdateMobileTheme";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateMobileTheme(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateMobileTheme(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateMobileTheme(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenancyName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getMobileTenantThemes(tenancyName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetMobileThemeTenantDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/GetMobileTenantThemes?";
        if (tenancyName === null)
            throw new Error("The parameter 'tenancyName' cannot be null.");
        else if (tenancyName !== undefined)
            url_ += "TenancyName=" + encodeURIComponent("" + tenancyName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileTenantThemes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileTenantThemes(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetMobileThemeTenantDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetMobileThemeTenantDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileTenantThemes(response: HttpResponseBase): Observable<PagedResultDtoOfGetMobileThemeTenantDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetMobileThemeTenantDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetMobileThemeTenantDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteMobileTheme(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/DeleteMobileTheme?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteMobileTheme(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteMobileTheme(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteMobileTheme(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getMobileThemeAttributes(): Observable<GetMobileThemeAttributesDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/GetMobileThemeAttributes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileThemeAttributes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileThemeAttributes(<any>response_);
                } catch (e) {
                    return <Observable<GetMobileThemeAttributesDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetMobileThemeAttributesDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileThemeAttributes(response: HttpResponseBase): Observable<GetMobileThemeAttributesDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetMobileThemeAttributesDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetMobileThemeAttributesDto>(<any>null);
    }

    /**
     * @return Success
     */
    getMobileThemeAttributesForTenant(): Observable<GetMobileThemeAttributesDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/GetMobileThemeAttributesForTenant";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileThemeAttributesForTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileThemeAttributesForTenant(<any>response_);
                } catch (e) {
                    return <Observable<GetMobileThemeAttributesDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetMobileThemeAttributesDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileThemeAttributesForTenant(response: HttpResponseBase): Observable<GetMobileThemeAttributesDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetMobileThemeAttributesDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetMobileThemeAttributesDto>(<any>null);
    }

    /**
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getMobileThemesForTenant(sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetMobileThemeListDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/GetMobileThemesForTenant?";
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileThemesForTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileThemesForTenant(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetMobileThemeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetMobileThemeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileThemesForTenant(response: HttpResponseBase): Observable<PagedResultDtoOfGetMobileThemeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetMobileThemeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetMobileThemeListDto>(<any>null);
    }

    /**
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getMobileThemesForHost(sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetHostMobileThemeListDto> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/GetMobileThemesForHost?";
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileThemesForHost(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileThemesForHost(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetHostMobileThemeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetHostMobileThemeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileThemesForHost(response: HttpResponseBase): Observable<PagedResultDtoOfGetHostMobileThemeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetHostMobileThemeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetHostMobileThemeListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateThemeForTenant(body: CreateOrUpdateThemeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/CreateOrUpdateThemeForTenant";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateThemeForTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateThemeForTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateThemeForTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateThemeForHost(body: CreateOrUpdateHostThemeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/CreateOrUpdateThemeForHost";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateThemeForHost(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateThemeForHost(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateThemeForHost(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    deleteMobileThemeForTenant(type: MobileThemeType): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/DeleteMobileThemeForTenant?";
        if (type === undefined || type === null)
            throw new Error("The parameter 'type' must be defined and cannot be null.");
        else
            url_ += "type=" + encodeURIComponent("" + type) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteMobileThemeForTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteMobileThemeForTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteMobileThemeForTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getMobileThemeTenants(): Observable<ListResultDtoOfTenantListDropDown> {
        let url_ = this.baseUrl + "/api/services/app/MobileTheme/GetMobileThemeTenants";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMobileThemeTenants(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMobileThemeTenants(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfTenantListDropDown>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfTenantListDropDown>><any>_observableThrow(response_);
        }));
    }

    protected processGetMobileThemeTenants(response: HttpResponseBase): Observable<ListResultDtoOfTenantListDropDown> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfTenantListDropDown.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfTenantListDropDown>(<any>null);
    }
}

@Injectable()
export class NoteServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param content (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getNote(id: number | undefined, content: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfNoteListDto> {
        let url_ = this.baseUrl + "/api/services/app/Note/GetNote?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetNote(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNoteListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNoteListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetNote(response: HttpResponseBase): Observable<PagedResultDtoOfNoteListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNoteListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNoteListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getNoteForEdit(id: number | undefined): Observable<UpdateNoteInput> {
        let url_ = this.baseUrl + "/api/services/app/Note/GetNoteForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetNoteForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetNoteForEdit(<any>response_);
                } catch (e) {
                    return <Observable<UpdateNoteInput>><any>_observableThrow(e);
                }
            } else
                return <Observable<UpdateNoteInput>><any>_observableThrow(response_);
        }));
    }

    protected processGetNoteForEdit(response: HttpResponseBase): Observable<UpdateNoteInput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = UpdateNoteInput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UpdateNoteInput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createNote(body: CreateNoteInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Note/CreateNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateNote(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateNote(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateNote(body: UpdateNoteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Note/UpdateNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteNote(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Note/DeleteNote?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class NotificationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param state (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getUserNotifications(state: UserNotificationState | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<GetNotificationsOutput> {
        let url_ = this.baseUrl + "/api/services/app/Notification/GetUserNotifications?";
        if (state === null)
            throw new Error("The parameter 'state' cannot be null.");
        else if (state !== undefined)
            url_ += "State=" + encodeURIComponent("" + state) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserNotifications(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserNotifications(<any>response_);
                } catch (e) {
                    return <Observable<GetNotificationsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetNotificationsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserNotifications(response: HttpResponseBase): Observable<GetNotificationsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetNotificationsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetNotificationsOutput>(<any>null);
    }

    /**
     * @return Success
     */
    setAllNotificationsAsRead(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Notification/SetAllNotificationsAsRead";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetAllNotificationsAsRead(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetAllNotificationsAsRead(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetAllNotificationsAsRead(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setNotificationAsRead(body: EntityDtoOfGuid | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Notification/SetNotificationAsRead";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetNotificationAsRead(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetNotificationAsRead(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetNotificationAsRead(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getNotificationSettings(): Observable<GetNotificationSettingsOutput> {
        let url_ = this.baseUrl + "/api/services/app/Notification/GetNotificationSettings";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetNotificationSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetNotificationSettings(<any>response_);
                } catch (e) {
                    return <Observable<GetNotificationSettingsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetNotificationSettingsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetNotificationSettings(response: HttpResponseBase): Observable<GetNotificationSettingsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetNotificationSettingsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetNotificationSettingsOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateNotificationSettings(body: UpdateNotificationSettingsInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Notification/UpdateNotificationSettings";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateNotificationSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateNotificationSettings(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateNotificationSettings(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteNotification(id: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Notification/DeleteNotification?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param state (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @return Success
     */
    deleteAllUserNotifications(state: UserNotificationState | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Notification/DeleteAllUserNotifications?";
        if (state === null)
            throw new Error("The parameter 'state' cannot be null.");
        else if (state !== undefined)
            url_ += "State=" + encodeURIComponent("" + state) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteAllUserNotifications(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteAllUserNotifications(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteAllUserNotifications(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class OptimizerProcessServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param ruleType (optional) 
     * @param tenantId (optional) 
     * @param userId (optional) 
     * @param loadDate (optional) 
     * @param locationId (optional) 
     * @param isMoved (optional) 
     * @param body (optional) 
     * @return Success
     */
    execute(ruleType: number | undefined, tenantId: number | undefined, userId: number | undefined, loadDate: string | undefined, locationId: number | undefined, isMoved: boolean | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OptimizerProcess/Execute?";
        if (ruleType === null)
            throw new Error("The parameter 'ruleType' cannot be null.");
        else if (ruleType !== undefined)
            url_ += "RuleType=" + encodeURIComponent("" + ruleType) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent("" + loadDate) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (isMoved === null)
            throw new Error("The parameter 'isMoved' cannot be null.");
        else if (isMoved !== undefined)
            url_ += "IsMoved=" + encodeURIComponent("" + isMoved) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExecute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExecute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExecute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param ruleType (optional) 
     * @param tenantId (optional) 
     * @param userId (optional) 
     * @param loadDate (optional) 
     * @param locationId (optional) 
     * @param isMoved (optional) 
     * @param body (optional) 
     * @return Success
     */
    proceed(ruleType: number | undefined, tenantId: number | undefined, userId: number | undefined, loadDate: string | undefined, locationId: number | undefined, isMoved: boolean | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OptimizerProcess/Proceed?";
        if (ruleType === null)
            throw new Error("The parameter 'ruleType' cannot be null.");
        else if (ruleType !== undefined)
            url_ += "RuleType=" + encodeURIComponent("" + ruleType) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent("" + loadDate) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (isMoved === null)
            throw new Error("The parameter 'isMoved' cannot be null.");
        else if (isMoved !== undefined)
            url_ += "IsMoved=" + encodeURIComponent("" + isMoved) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProceed(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProceed(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processProceed(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class OrderServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    contactAddressChecker(body: ContactAddressCheckerInput | undefined): Observable<ContactAddressCheckerResult> {
        let url_ = this.baseUrl + "/api/services/app/Order/ContactAddressChecker";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processContactAddressChecker(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processContactAddressChecker(<any>response_);
                } catch (e) {
                    return <Observable<ContactAddressCheckerResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ContactAddressCheckerResult>><any>_observableThrow(response_);
        }));
    }

    protected processContactAddressChecker(response: HttpResponseBase): Observable<ContactAddressCheckerResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ContactAddressCheckerResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ContactAddressCheckerResult>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateEtaErrorCode(body: GenerateEtaErrorCodeInputDto | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/GenerateEtaErrorCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateEtaErrorCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateEtaErrorCode(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateEtaErrorCode(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    validateEtaErrorCode(body: ValidateEtaErrorCodeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/ValidateEtaErrorCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processValidateEtaErrorCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processValidateEtaErrorCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processValidateEtaErrorCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    userOrderTypeChecker(id: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Order/UserOrderTypeChecker?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUserOrderTypeChecker(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUserOrderTypeChecker(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processUserOrderTypeChecker(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderIdsForOrderPackage(): Observable<number[]> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrderIdsForOrderPackage";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderIdsForOrderPackage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderIdsForOrderPackage(<any>response_);
                } catch (e) {
                    return <Observable<number[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<number[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderIdsForOrderPackage(response: HttpResponseBase): Observable<number[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateHandoffValidationCode(body: GenerateHandoffValidationCodeInputDto | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/GenerateHandoffValidationCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateHandoffValidationCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateHandoffValidationCode(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateHandoffValidationCode(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    validateHandOffCode(body: ValidateHandOffValidationCodeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/ValidateHandOffCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processValidateHandOffCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processValidateHandOffCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processValidateHandOffCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param loadDate (optional) 
     * @return Success
     */
    getRandomTrackingId(loadDate: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetRandomTrackingId?";
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "loadDate=" + encodeURIComponent("" + loadDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRandomTrackingId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRandomTrackingId(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetRandomTrackingId(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param utcTime (optional) 
     * @return Success
     */
    markPickedUpAsInTransit(utcTime: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/MarkPickedUpAsInTransit?";
        if (utcTime === null)
            throw new Error("The parameter 'utcTime' cannot be null.");
        else if (utcTime !== undefined)
            url_ += "utcTime=" + encodeURIComponent("" + utcTime) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMarkPickedUpAsInTransit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMarkPickedUpAsInTransit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processMarkPickedUpAsInTransit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sMSUnsubscribeEndpoint(body: KeyValuePairOfStringString[] | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/SMSUnsubscribeEndpoint";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSMSUnsubscribeEndpoint(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSMSUnsubscribeEndpoint(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processSMSUnsubscribeEndpoint(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    notifyContact(body: NotifyContactInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/NotifyContact";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processNotifyContact(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processNotifyContact(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processNotifyContact(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderUsers(): Observable<GetCreatorUsers[]> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrderUsers";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderUsers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderUsers(<any>response_);
                } catch (e) {
                    return <Observable<GetCreatorUsers[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetCreatorUsers[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderUsers(response: HttpResponseBase): Observable<GetCreatorUsers[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetCreatorUsers.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetCreatorUsers[]>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteOptimizationType(): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetRouteOptimizationType";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteOptimizationType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteOptimizationType(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteOptimizationType(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param input (optional) 
     * @return Success
     */
    getRouteIdOfOrder(input: number[] | undefined): Observable<number[]> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetRouteIdOfOrder?";
        if (input === null)
            throw new Error("The parameter 'input' cannot be null.");
        else if (input !== undefined)
            input && input.forEach(item => { url_ += "input=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteIdOfOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteIdOfOrder(<any>response_);
                } catch (e) {
                    return <Observable<number[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<number[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteIdOfOrder(response: HttpResponseBase): Observable<number[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateZeroCountReportCode(body: GenerateHandoffValidationCodeInputDto | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/GenerateZeroCountReportCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateZeroCountReportCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateZeroCountReportCode(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateZeroCountReportCode(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    validateZeroCountReportCode(body: ValidateHandOffValidationCodeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/ValidateZeroCountReportCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processValidateZeroCountReportCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processValidateZeroCountReportCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processValidateZeroCountReportCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @return Success
     */
    getLocationsZones(locationId: number | undefined): Observable<IntStringDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetLocationsZones?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "locationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationsZones(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationsZones(<any>response_);
                } catch (e) {
                    return <Observable<IntStringDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<IntStringDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationsZones(response: HttpResponseBase): Observable<IntStringDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(IntStringDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<IntStringDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getDeliveryOrderStatusTypes(): Observable<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetDeliveryOrderStatusTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDeliveryOrderStatusTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDeliveryOrderStatusTypes(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDeliveryOrderStatusTypes(response: HttpResponseBase): Observable<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto>(<any>null);
    }

    /**
     * @return Success
     */
    getTenantName(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetTenantName";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantName(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantName(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    trackImport(body: TrackImportInput | undefined): Observable<TrackImportResult> {
        let url_ = this.baseUrl + "/api/services/app/Order/TrackImport";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTrackImport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTrackImport(<any>response_);
                } catch (e) {
                    return <Observable<TrackImportResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<TrackImportResult>><any>_observableThrow(response_);
        }));
    }

    protected processTrackImport(response: HttpResponseBase): Observable<TrackImportResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TrackImportResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TrackImportResult>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrder(body: UpdateOrderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/UpdateOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderSorting(body: UpdateOrderSortingInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/UpdateOrderSorting";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderSorting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderSorting(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderSorting(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    orderStatusListName(body: OrderStatusListName | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/OrderStatusListName";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrderStatusListName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrderStatusListName(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processOrderStatusListName(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    moveOrder(body: ControllerMoveOrderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/MoveOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMoveOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMoveOrder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processMoveOrder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteId(body: RemoveOrderList | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/UpdateRouteId";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteId(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteId(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateCount(body: UpdateCountList | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/UpdateCount";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateCount(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateCount(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getOrdersCount(orderId: number[] | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrdersCount?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            orderId && orderId.forEach(item => { url_ += "OrderId=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrdersCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrdersCount(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrdersCount(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteOrder(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/DeleteOrder?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    getOrders(body: GetOrderInput | undefined): Observable<PagedResultDtoOfGetOrderListDtoNew> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrders";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrders(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderListDtoNew>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderListDtoNew>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrders(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderListDtoNew> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderListDtoNew.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderListDtoNew>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    getOrdersForExcels(body: GetOrderInput | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrdersForExcels";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrdersForExcels(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrdersForExcels(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrdersForExcels(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param pickupDetailsId (optional) 
     * @param deliveryDetailsId (optional) 
     * @param locationId (optional) 
     * @param noteId (optional) 
     * @param creationTime (optional) 
     * @param deliveryEta (optional) 
     * @param sortOrder (optional) 
     * @param orderTypeId (optional) 
     * @param orderId (optional) 
     * @param customerOrderNumberFilter (optional) 
     * @param trackingIdFilter (optional) 
     * @param unassigned (optional) 
     * @param currentOrders (optional) 
     * @param routeDate (optional) 
     * @param creationTimeString (optional) 
     * @param creator (optional) 
     * @param fullNameFilter (optional) 
     * @param addressLine1Filter (optional) 
     * @param cityFilter (optional) 
     * @param stateFilter (optional) 
     * @param postalCodeFilter (optional) 
     * @param firstNameFilter (optional) 
     * @param lastNameFilter (optional) 
     * @param creatorUserIds (optional) 
     * @param excludedUserIds (optional) 
     * @param isIntegration (optional) 
     * @param zoneFilter (optional) 
     * @param recurringOrderScheduleIdFilter (optional) 
     * @param multipleZoneFilter (optional) 
     * @param multipleDriverFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getCustomerOrders(id: number | undefined, filter: string | undefined, pickupDetailsId: number | undefined, deliveryDetailsId: number | undefined, locationId: number | undefined, noteId: number | undefined, creationTime: moment.Moment | undefined, deliveryEta: string | undefined, sortOrder: number | undefined, orderTypeId: number | undefined, orderId: string | undefined, customerOrderNumberFilter: string | undefined, trackingIdFilter: string | undefined, unassigned: boolean | undefined, currentOrders: boolean | undefined, routeDate: string | undefined, creationTimeString: string | undefined, creator: number | undefined, fullNameFilter: string | undefined, addressLine1Filter: string | undefined, cityFilter: string | undefined, stateFilter: string | undefined, postalCodeFilter: string | undefined, firstNameFilter: string | undefined, lastNameFilter: string | undefined, creatorUserIds: number[] | undefined, excludedUserIds: number[] | undefined, isIntegration: boolean | undefined, zoneFilter: string | undefined, recurringOrderScheduleIdFilter: number | undefined, multipleZoneFilter: number[] | undefined, multipleDriverFilter: number[] | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderListDtoNew> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetCustomerOrders?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (pickupDetailsId === null)
            throw new Error("The parameter 'pickupDetailsId' cannot be null.");
        else if (pickupDetailsId !== undefined)
            url_ += "PickupDetailsId=" + encodeURIComponent("" + pickupDetailsId) + "&"; 
        if (deliveryDetailsId === null)
            throw new Error("The parameter 'deliveryDetailsId' cannot be null.");
        else if (deliveryDetailsId !== undefined)
            url_ += "DeliveryDetailsId=" + encodeURIComponent("" + deliveryDetailsId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (creationTime === null)
            throw new Error("The parameter 'creationTime' cannot be null.");
        else if (creationTime !== undefined)
            url_ += "CreationTime=" + encodeURIComponent(creationTime ? "" + creationTime.toJSON() : "") + "&"; 
        if (deliveryEta === null)
            throw new Error("The parameter 'deliveryEta' cannot be null.");
        else if (deliveryEta !== undefined)
            url_ += "DeliveryEta=" + encodeURIComponent("" + deliveryEta) + "&"; 
        if (sortOrder === null)
            throw new Error("The parameter 'sortOrder' cannot be null.");
        else if (sortOrder !== undefined)
            url_ += "SortOrder=" + encodeURIComponent("" + sortOrder) + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (customerOrderNumberFilter === null)
            throw new Error("The parameter 'customerOrderNumberFilter' cannot be null.");
        else if (customerOrderNumberFilter !== undefined)
            url_ += "CustomerOrderNumberFilter=" + encodeURIComponent("" + customerOrderNumberFilter) + "&"; 
        if (trackingIdFilter === null)
            throw new Error("The parameter 'trackingIdFilter' cannot be null.");
        else if (trackingIdFilter !== undefined)
            url_ += "TrackingIdFilter=" + encodeURIComponent("" + trackingIdFilter) + "&"; 
        if (unassigned === null)
            throw new Error("The parameter 'unassigned' cannot be null.");
        else if (unassigned !== undefined)
            url_ += "Unassigned=" + encodeURIComponent("" + unassigned) + "&"; 
        if (currentOrders === null)
            throw new Error("The parameter 'currentOrders' cannot be null.");
        else if (currentOrders !== undefined)
            url_ += "CurrentOrders=" + encodeURIComponent("" + currentOrders) + "&"; 
        if (routeDate === null)
            throw new Error("The parameter 'routeDate' cannot be null.");
        else if (routeDate !== undefined)
            url_ += "RouteDate=" + encodeURIComponent("" + routeDate) + "&"; 
        if (creationTimeString === null)
            throw new Error("The parameter 'creationTimeString' cannot be null.");
        else if (creationTimeString !== undefined)
            url_ += "CreationTimeString=" + encodeURIComponent("" + creationTimeString) + "&"; 
        if (creator === null)
            throw new Error("The parameter 'creator' cannot be null.");
        else if (creator !== undefined)
            url_ += "Creator=" + encodeURIComponent("" + creator) + "&"; 
        if (fullNameFilter === null)
            throw new Error("The parameter 'fullNameFilter' cannot be null.");
        else if (fullNameFilter !== undefined)
            url_ += "FullNameFilter=" + encodeURIComponent("" + fullNameFilter) + "&"; 
        if (addressLine1Filter === null)
            throw new Error("The parameter 'addressLine1Filter' cannot be null.");
        else if (addressLine1Filter !== undefined)
            url_ += "AddressLine1Filter=" + encodeURIComponent("" + addressLine1Filter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (postalCodeFilter === null)
            throw new Error("The parameter 'postalCodeFilter' cannot be null.");
        else if (postalCodeFilter !== undefined)
            url_ += "PostalCodeFilter=" + encodeURIComponent("" + postalCodeFilter) + "&"; 
        if (firstNameFilter === null)
            throw new Error("The parameter 'firstNameFilter' cannot be null.");
        else if (firstNameFilter !== undefined)
            url_ += "FirstNameFilter=" + encodeURIComponent("" + firstNameFilter) + "&"; 
        if (lastNameFilter === null)
            throw new Error("The parameter 'lastNameFilter' cannot be null.");
        else if (lastNameFilter !== undefined)
            url_ += "LastNameFilter=" + encodeURIComponent("" + lastNameFilter) + "&"; 
        if (creatorUserIds === null)
            throw new Error("The parameter 'creatorUserIds' cannot be null.");
        else if (creatorUserIds !== undefined)
            creatorUserIds && creatorUserIds.forEach(item => { url_ += "CreatorUserIds=" + encodeURIComponent("" + item) + "&"; });
        if (excludedUserIds === null)
            throw new Error("The parameter 'excludedUserIds' cannot be null.");
        else if (excludedUserIds !== undefined)
            excludedUserIds && excludedUserIds.forEach(item => { url_ += "ExcludedUserIds=" + encodeURIComponent("" + item) + "&"; });
        if (isIntegration === null)
            throw new Error("The parameter 'isIntegration' cannot be null.");
        else if (isIntegration !== undefined)
            url_ += "IsIntegration=" + encodeURIComponent("" + isIntegration) + "&"; 
        if (zoneFilter === null)
            throw new Error("The parameter 'zoneFilter' cannot be null.");
        else if (zoneFilter !== undefined)
            url_ += "ZoneFilter=" + encodeURIComponent("" + zoneFilter) + "&"; 
        if (recurringOrderScheduleIdFilter === null)
            throw new Error("The parameter 'recurringOrderScheduleIdFilter' cannot be null.");
        else if (recurringOrderScheduleIdFilter !== undefined)
            url_ += "RecurringOrderScheduleIdFilter=" + encodeURIComponent("" + recurringOrderScheduleIdFilter) + "&"; 
        if (multipleZoneFilter === null)
            throw new Error("The parameter 'multipleZoneFilter' cannot be null.");
        else if (multipleZoneFilter !== undefined)
            multipleZoneFilter && multipleZoneFilter.forEach(item => { url_ += "MultipleZoneFilter=" + encodeURIComponent("" + item) + "&"; });
        if (multipleDriverFilter === null)
            throw new Error("The parameter 'multipleDriverFilter' cannot be null.");
        else if (multipleDriverFilter !== undefined)
            multipleDriverFilter && multipleDriverFilter.forEach(item => { url_ += "MultipleDriverFilter=" + encodeURIComponent("" + item) + "&"; });
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCustomerOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCustomerOrders(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderListDtoNew>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderListDtoNew>><any>_observableThrow(response_);
        }));
    }

    protected processGetCustomerOrders(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderListDtoNew> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderListDtoNew.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderListDtoNew>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param pickupDetailsId (optional) 
     * @param deliveryDetailsId (optional) 
     * @param locationId (optional) 
     * @param noteId (optional) 
     * @param creationTime (optional) 
     * @param deliveryEta (optional) 
     * @param sortOrder (optional) 
     * @param orderTypeId (optional) 
     * @param orderId (optional) 
     * @param customerOrderNumberFilter (optional) 
     * @param trackingIdFilter (optional) 
     * @param unassigned (optional) 
     * @param currentOrders (optional) 
     * @param routeDate (optional) 
     * @param creationTimeString (optional) 
     * @param creator (optional) 
     * @param fullNameFilter (optional) 
     * @param addressLine1Filter (optional) 
     * @param cityFilter (optional) 
     * @param stateFilter (optional) 
     * @param postalCodeFilter (optional) 
     * @param firstNameFilter (optional) 
     * @param lastNameFilter (optional) 
     * @param creatorUserIds (optional) 
     * @param excludedUserIds (optional) 
     * @param isIntegration (optional) 
     * @param zoneFilter (optional) 
     * @param recurringOrderScheduleIdFilter (optional) 
     * @param multipleZoneFilter (optional) 
     * @param multipleDriverFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getCustomerOrdersToExcel(id: number | undefined, filter: string | undefined, pickupDetailsId: number | undefined, deliveryDetailsId: number | undefined, locationId: number | undefined, noteId: number | undefined, creationTime: moment.Moment | undefined, deliveryEta: string | undefined, sortOrder: number | undefined, orderTypeId: number | undefined, orderId: string | undefined, customerOrderNumberFilter: string | undefined, trackingIdFilter: string | undefined, unassigned: boolean | undefined, currentOrders: boolean | undefined, routeDate: string | undefined, creationTimeString: string | undefined, creator: number | undefined, fullNameFilter: string | undefined, addressLine1Filter: string | undefined, cityFilter: string | undefined, stateFilter: string | undefined, postalCodeFilter: string | undefined, firstNameFilter: string | undefined, lastNameFilter: string | undefined, creatorUserIds: number[] | undefined, excludedUserIds: number[] | undefined, isIntegration: boolean | undefined, zoneFilter: string | undefined, recurringOrderScheduleIdFilter: number | undefined, multipleZoneFilter: number[] | undefined, multipleDriverFilter: number[] | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetCustomerOrdersToExcel?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (pickupDetailsId === null)
            throw new Error("The parameter 'pickupDetailsId' cannot be null.");
        else if (pickupDetailsId !== undefined)
            url_ += "PickupDetailsId=" + encodeURIComponent("" + pickupDetailsId) + "&"; 
        if (deliveryDetailsId === null)
            throw new Error("The parameter 'deliveryDetailsId' cannot be null.");
        else if (deliveryDetailsId !== undefined)
            url_ += "DeliveryDetailsId=" + encodeURIComponent("" + deliveryDetailsId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (creationTime === null)
            throw new Error("The parameter 'creationTime' cannot be null.");
        else if (creationTime !== undefined)
            url_ += "CreationTime=" + encodeURIComponent(creationTime ? "" + creationTime.toJSON() : "") + "&"; 
        if (deliveryEta === null)
            throw new Error("The parameter 'deliveryEta' cannot be null.");
        else if (deliveryEta !== undefined)
            url_ += "DeliveryEta=" + encodeURIComponent("" + deliveryEta) + "&"; 
        if (sortOrder === null)
            throw new Error("The parameter 'sortOrder' cannot be null.");
        else if (sortOrder !== undefined)
            url_ += "SortOrder=" + encodeURIComponent("" + sortOrder) + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (customerOrderNumberFilter === null)
            throw new Error("The parameter 'customerOrderNumberFilter' cannot be null.");
        else if (customerOrderNumberFilter !== undefined)
            url_ += "CustomerOrderNumberFilter=" + encodeURIComponent("" + customerOrderNumberFilter) + "&"; 
        if (trackingIdFilter === null)
            throw new Error("The parameter 'trackingIdFilter' cannot be null.");
        else if (trackingIdFilter !== undefined)
            url_ += "TrackingIdFilter=" + encodeURIComponent("" + trackingIdFilter) + "&"; 
        if (unassigned === null)
            throw new Error("The parameter 'unassigned' cannot be null.");
        else if (unassigned !== undefined)
            url_ += "Unassigned=" + encodeURIComponent("" + unassigned) + "&"; 
        if (currentOrders === null)
            throw new Error("The parameter 'currentOrders' cannot be null.");
        else if (currentOrders !== undefined)
            url_ += "CurrentOrders=" + encodeURIComponent("" + currentOrders) + "&"; 
        if (routeDate === null)
            throw new Error("The parameter 'routeDate' cannot be null.");
        else if (routeDate !== undefined)
            url_ += "RouteDate=" + encodeURIComponent("" + routeDate) + "&"; 
        if (creationTimeString === null)
            throw new Error("The parameter 'creationTimeString' cannot be null.");
        else if (creationTimeString !== undefined)
            url_ += "CreationTimeString=" + encodeURIComponent("" + creationTimeString) + "&"; 
        if (creator === null)
            throw new Error("The parameter 'creator' cannot be null.");
        else if (creator !== undefined)
            url_ += "Creator=" + encodeURIComponent("" + creator) + "&"; 
        if (fullNameFilter === null)
            throw new Error("The parameter 'fullNameFilter' cannot be null.");
        else if (fullNameFilter !== undefined)
            url_ += "FullNameFilter=" + encodeURIComponent("" + fullNameFilter) + "&"; 
        if (addressLine1Filter === null)
            throw new Error("The parameter 'addressLine1Filter' cannot be null.");
        else if (addressLine1Filter !== undefined)
            url_ += "AddressLine1Filter=" + encodeURIComponent("" + addressLine1Filter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (postalCodeFilter === null)
            throw new Error("The parameter 'postalCodeFilter' cannot be null.");
        else if (postalCodeFilter !== undefined)
            url_ += "PostalCodeFilter=" + encodeURIComponent("" + postalCodeFilter) + "&"; 
        if (firstNameFilter === null)
            throw new Error("The parameter 'firstNameFilter' cannot be null.");
        else if (firstNameFilter !== undefined)
            url_ += "FirstNameFilter=" + encodeURIComponent("" + firstNameFilter) + "&"; 
        if (lastNameFilter === null)
            throw new Error("The parameter 'lastNameFilter' cannot be null.");
        else if (lastNameFilter !== undefined)
            url_ += "LastNameFilter=" + encodeURIComponent("" + lastNameFilter) + "&"; 
        if (creatorUserIds === null)
            throw new Error("The parameter 'creatorUserIds' cannot be null.");
        else if (creatorUserIds !== undefined)
            creatorUserIds && creatorUserIds.forEach(item => { url_ += "CreatorUserIds=" + encodeURIComponent("" + item) + "&"; });
        if (excludedUserIds === null)
            throw new Error("The parameter 'excludedUserIds' cannot be null.");
        else if (excludedUserIds !== undefined)
            excludedUserIds && excludedUserIds.forEach(item => { url_ += "ExcludedUserIds=" + encodeURIComponent("" + item) + "&"; });
        if (isIntegration === null)
            throw new Error("The parameter 'isIntegration' cannot be null.");
        else if (isIntegration !== undefined)
            url_ += "IsIntegration=" + encodeURIComponent("" + isIntegration) + "&"; 
        if (zoneFilter === null)
            throw new Error("The parameter 'zoneFilter' cannot be null.");
        else if (zoneFilter !== undefined)
            url_ += "ZoneFilter=" + encodeURIComponent("" + zoneFilter) + "&"; 
        if (recurringOrderScheduleIdFilter === null)
            throw new Error("The parameter 'recurringOrderScheduleIdFilter' cannot be null.");
        else if (recurringOrderScheduleIdFilter !== undefined)
            url_ += "RecurringOrderScheduleIdFilter=" + encodeURIComponent("" + recurringOrderScheduleIdFilter) + "&"; 
        if (multipleZoneFilter === null)
            throw new Error("The parameter 'multipleZoneFilter' cannot be null.");
        else if (multipleZoneFilter !== undefined)
            multipleZoneFilter && multipleZoneFilter.forEach(item => { url_ += "MultipleZoneFilter=" + encodeURIComponent("" + item) + "&"; });
        if (multipleDriverFilter === null)
            throw new Error("The parameter 'multipleDriverFilter' cannot be null.");
        else if (multipleDriverFilter !== undefined)
            multipleDriverFilter && multipleDriverFilter.forEach(item => { url_ += "MultipleDriverFilter=" + encodeURIComponent("" + item) + "&"; });
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCustomerOrdersToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCustomerOrdersToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCustomerOrdersToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getOrderDetail(orderId: number | undefined): Observable<OrderListDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrderDetail?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderDetail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderDetail(<any>response_);
                } catch (e) {
                    return <Observable<OrderListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderDetail(response: HttpResponseBase): Observable<OrderListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    groupOrdersTab(body: GetOrderListTimezoneInput | undefined): Observable<PagedResultDtoOfgroupOrdersTab> {
        let url_ = this.baseUrl + "/api/services/app/Order/GroupOrdersTab";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGroupOrdersTab(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGroupOrdersTab(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfgroupOrdersTab>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfgroupOrdersTab>><any>_observableThrow(response_);
        }));
    }

    protected processGroupOrdersTab(response: HttpResponseBase): Observable<PagedResultDtoOfgroupOrdersTab> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfgroupOrdersTab.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfgroupOrdersTab>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    ordersTab(body: GetOrderListTimezoneInput | undefined): Observable<PagedResultDtoOfGetControllerOrderListDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/OrdersTab";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrdersTab(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrdersTab(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetControllerOrderListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetControllerOrderListDto>><any>_observableThrow(response_);
        }));
    }

    protected processOrdersTab(response: HttpResponseBase): Observable<PagedResultDtoOfGetControllerOrderListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetControllerOrderListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetControllerOrderListDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getOrderForUpdate(orderId: number | undefined): Observable<OrderListDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrderForUpdate?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderForUpdate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderForUpdate(<any>response_);
                } catch (e) {
                    return <Observable<OrderListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderForUpdate(response: HttpResponseBase): Observable<OrderListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderRouteLocation(id: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrderRouteLocation?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderRouteLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderRouteLocation(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderRouteLocation(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param trackingIdentifier (optional) 
     * @param timeZoneInfo (optional) 
     * @param orderNumber (optional) 
     * @param deliveryDateFrom (optional) 
     * @param deliveryDateTo (optional) 
     * @param locationCode (optional) 
     * @param orderSourceCode (optional) 
     * @return Success
     */
    trackOrder(orderId: number | undefined, trackingIdentifier: string | undefined, timeZoneInfo: string | undefined, orderNumber: string | undefined, deliveryDateFrom: moment.Moment | undefined, deliveryDateTo: moment.Moment | undefined, locationCode: string[] | undefined, orderSourceCode: string | undefined): Observable<GetOrderDetailsView[]> {
        let url_ = this.baseUrl + "/api/services/app/Order/TrackOrder?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (trackingIdentifier === null)
            throw new Error("The parameter 'trackingIdentifier' cannot be null.");
        else if (trackingIdentifier !== undefined)
            url_ += "TrackingIdentifier=" + encodeURIComponent("" + trackingIdentifier) + "&"; 
        if (timeZoneInfo === null)
            throw new Error("The parameter 'timeZoneInfo' cannot be null.");
        else if (timeZoneInfo !== undefined)
            url_ += "TimeZoneInfo=" + encodeURIComponent("" + timeZoneInfo) + "&"; 
        if (orderNumber === null)
            throw new Error("The parameter 'orderNumber' cannot be null.");
        else if (orderNumber !== undefined)
            url_ += "OrderNumber=" + encodeURIComponent("" + orderNumber) + "&"; 
        if (deliveryDateFrom === null)
            throw new Error("The parameter 'deliveryDateFrom' cannot be null.");
        else if (deliveryDateFrom !== undefined)
            url_ += "DeliveryDateFrom=" + encodeURIComponent(deliveryDateFrom ? "" + deliveryDateFrom.toJSON() : "") + "&"; 
        if (deliveryDateTo === null)
            throw new Error("The parameter 'deliveryDateTo' cannot be null.");
        else if (deliveryDateTo !== undefined)
            url_ += "DeliveryDateTo=" + encodeURIComponent(deliveryDateTo ? "" + deliveryDateTo.toJSON() : "") + "&"; 
        if (locationCode === null)
            throw new Error("The parameter 'locationCode' cannot be null.");
        else if (locationCode !== undefined)
            locationCode && locationCode.forEach(item => { url_ += "LocationCode=" + encodeURIComponent("" + item) + "&"; });
        if (orderSourceCode === null)
            throw new Error("The parameter 'orderSourceCode' cannot be null.");
        else if (orderSourceCode !== undefined)
            url_ += "OrderSourceCode=" + encodeURIComponent("" + orderSourceCode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTrackOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTrackOrder(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderDetailsView[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderDetailsView[]>><any>_observableThrow(response_);
        }));
    }

    protected processTrackOrder(response: HttpResponseBase): Observable<GetOrderDetailsView[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetOrderDetailsView.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderDetailsView[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDeliveryNote(body: UpdateBatchDeliveryNotesInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/UpdateDeliveryNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDeliveryNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDeliveryNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDeliveryNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getOrderForViewTracking(orderId: number | undefined): Observable<OrderListDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrderForViewTracking?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderForViewTracking(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderForViewTracking(<any>response_);
                } catch (e) {
                    return <Observable<OrderListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderForViewTracking(response: HttpResponseBase): Observable<OrderListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderListDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getLastStatus(orderId: number | undefined): Observable<OrderStatusDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetLastStatus?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLastStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLastStatus(<any>response_);
                } catch (e) {
                    return <Observable<OrderStatusDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderStatusDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLastStatus(response: HttpResponseBase): Observable<OrderStatusDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderStatusDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderStatusDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getOrderDriver(orderId: number | undefined): Observable<OrderRouteListDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrderDriver?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderDriver(<any>response_);
                } catch (e) {
                    return <Observable<OrderRouteListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderRouteListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderDriver(response: HttpResponseBase): Observable<OrderRouteListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderRouteListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderRouteListDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getRouteCodeDriver(orderId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetRouteCodeDriver?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteCodeDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteCodeDriver(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteCodeDriver(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getAccountDetails(orderId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetAccountDetails?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAccountDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAccountDetails(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetAccountDetails(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderV2(body: UpdateOrderV2Input | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/UpdateOrderV2";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderV2(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderV2(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderV2(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateProximityCode(body: GenerateProximityCodeInput | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Order/GenerateProximityCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateProximityCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateProximityCode(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateProximityCode(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    validateProximityCode(body: ValidateProximityCodeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/ValidateProximityCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processValidateProximityCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processValidateProximityCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processValidateProximityCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setStatusForOrders(body: SetStatusInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/SetStatusForOrders";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetStatusForOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetStatusForOrders(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetStatusForOrders(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addSingleOrderStatusAttachment(body: SingleOrderStatusAttachmentInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/AddSingleOrderStatusAttachment";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddSingleOrderStatusAttachment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddSingleOrderStatusAttachment(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddSingleOrderStatusAttachment(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addMultipleOrderStatusAttachment(body: MultipleOrderStatusAttachmentInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/AddMultipleOrderStatusAttachment";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddMultipleOrderStatusAttachment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddMultipleOrderStatusAttachment(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddMultipleOrderStatusAttachment(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param city (optional) 
     * @param country (optional) 
     * @param state (optional) 
     * @param postalCode (optional) 
     * @param postalCodeId (optional) 
     * @param tenantId (optional) 
     * @param orderSourceCode (optional) 
     * @param driverFirstName (optional) 
     * @param driverLastName (optional) 
     * @param zipRegEx (optional) 
     * @param timezone (optional) 
     * @return Success
     */
    getLocationForDestination(city: string | undefined, country: string | undefined, state: string | undefined, postalCode: string | undefined, postalCodeId: number | undefined, tenantId: number | undefined, orderSourceCode: string | undefined, driverFirstName: string | undefined, driverLastName: string | undefined, zipRegEx: string | undefined, timezone: string | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetLocationForDestination?";
        if (city === null)
            throw new Error("The parameter 'city' cannot be null.");
        else if (city !== undefined)
            url_ += "City=" + encodeURIComponent("" + city) + "&"; 
        if (country === null)
            throw new Error("The parameter 'country' cannot be null.");
        else if (country !== undefined)
            url_ += "Country=" + encodeURIComponent("" + country) + "&"; 
        if (state === null)
            throw new Error("The parameter 'state' cannot be null.");
        else if (state !== undefined)
            url_ += "State=" + encodeURIComponent("" + state) + "&"; 
        if (postalCode === null)
            throw new Error("The parameter 'postalCode' cannot be null.");
        else if (postalCode !== undefined)
            url_ += "PostalCode=" + encodeURIComponent("" + postalCode) + "&"; 
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (orderSourceCode === null)
            throw new Error("The parameter 'orderSourceCode' cannot be null.");
        else if (orderSourceCode !== undefined)
            url_ += "OrderSourceCode=" + encodeURIComponent("" + orderSourceCode) + "&"; 
        if (driverFirstName === null)
            throw new Error("The parameter 'driverFirstName' cannot be null.");
        else if (driverFirstName !== undefined)
            url_ += "DriverFirstName=" + encodeURIComponent("" + driverFirstName) + "&"; 
        if (driverLastName === null)
            throw new Error("The parameter 'driverLastName' cannot be null.");
        else if (driverLastName !== undefined)
            url_ += "DriverLastName=" + encodeURIComponent("" + driverLastName) + "&"; 
        if (zipRegEx === null)
            throw new Error("The parameter 'zipRegEx' cannot be null.");
        else if (zipRegEx !== undefined)
            url_ += "ZipRegEx=" + encodeURIComponent("" + zipRegEx) + "&"; 
        if (timezone === null)
            throw new Error("The parameter 'timezone' cannot be null.");
        else if (timezone !== undefined)
            url_ += "timezone=" + encodeURIComponent("" + timezone) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationForDestination(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationForDestination(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationForDestination(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * Creates an order.
     * @param body (optional) 
     * @return Returns a newly created order with its corresponding packageId and trackingIdentifier.
     */
    createOrder(body: CreateOrderApiInput | undefined): Observable<CreateOrderApiResult> {
        let url_ = this.baseUrl + "/api/services/app/Order/CreateOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrder(<any>response_);
                } catch (e) {
                    return <Observable<CreateOrderApiResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateOrderApiResult>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrder(response: HttpResponseBase): Observable<CreateOrderApiResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateOrderApiResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateOrderApiResult>(<any>null);
    }

    /**
     * @param value (optional) 
     * @param dateTimeUTC (optional) 
     * @return Success
     */
    getUtcOffset(value: string | undefined, dateTimeUTC: moment.Moment | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetUtcOffset?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "value=" + encodeURIComponent("" + value) + "&"; 
        if (dateTimeUTC === null)
            throw new Error("The parameter 'dateTimeUTC' cannot be null.");
        else if (dateTimeUTC !== undefined)
            url_ += "dateTimeUTC=" + encodeURIComponent(dateTimeUTC ? "" + dateTimeUTC.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUtcOffset(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUtcOffset(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetUtcOffset(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderWebHooks(body: any | undefined): Observable<CreateOrderApiResult> {
        let url_ = this.baseUrl + "/api/services/app/Order/CreateOrderWebHooks";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderWebHooks(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderWebHooks(<any>response_);
                } catch (e) {
                    return <Observable<CreateOrderApiResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateOrderApiResult>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderWebHooks(response: HttpResponseBase): Observable<CreateOrderApiResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateOrderApiResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateOrderApiResult>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param tenantId (optional) 
     * @param userId (optional) 
     * @param tags (optional) 
     * @param trackingIdentifier (optional) 
     * @param note (optional) 
     * @param packages (optional) 
     * @param destinationEtaStart (optional) 
     * @param destinationEtaEnd (optional) 
     * @param destinationContactId (optional) 
     * @param destinationFirstName (optional) 
     * @param destinationLastName (optional) 
     * @param destinationEmail (optional) 
     * @param destinationPhone (optional) 
     * @param destinationAddressLine1 (optional) 
     * @param destinationAddressLine2 (optional) 
     * @param destinationPostalCodeId (optional) 
     * @param destinationPostalCode (optional) 
     * @param destinationCountry (optional) 
     * @param destinationCity (optional) 
     * @param destinationState (optional) 
     * @param destinationGeocodeId (optional) 
     * @param destinationLat (optional) 
     * @param destinationLng (optional) 
     * @param destinationAddressTypeId (optional) 
     * @param pickUpEtaStart (optional) 
     * @param pickUpEtaEnd (optional) 
     * @param pickUpContactId (optional) 
     * @param pickUpFirstName (optional) 
     * @param pickUpLastName (optional) 
     * @param pickUpEmail (optional) 
     * @param pickUpPhone (optional) 
     * @param pickUpAddressLine1 (optional) 
     * @param pickUpAddressLine2 (optional) 
     * @param pickUpPostalCodeId (optional) 
     * @param pickUpPostalCode (optional) 
     * @param pickUpCountry (optional) 
     * @param pickUpCity (optional) 
     * @param pickUpState (optional) 
     * @param pickUpGeocodeId (optional) 
     * @param pickUpLat (optional) 
     * @param pickUpLng (optional) 
     * @param pickUpAddressTypeId (optional) 
     * @param orderSourceId (optional) 
     * @param orderSourceCode (optional) 
     * @param isDownloadOrder (optional) 
     * @param isRecurring (optional) 
     * @param recurringScheduleCode (optional) 
     * @param orderStatusCode (optional) 
     * @param zipRegex (optional) 
     * @param driverFirstName (optional) 
     * @param driverLastName (optional) 
     * @param driverUserName (optional) 
     * @return Success
     */
    getLocationOfDelivery(locationId: number | undefined, tenantId: number | undefined, userId: number | undefined, tags: TagInputApi[] | undefined, trackingIdentifier: string | undefined, note: string | undefined, packages: PackageInputApi[] | undefined, destinationEtaStart: moment.Moment | undefined, destinationEtaEnd: moment.Moment | undefined, destinationContactId: number | undefined, destinationFirstName: string | undefined, destinationLastName: string | undefined, destinationEmail: string | undefined, destinationPhone: string | undefined, destinationAddressLine1: string | undefined, destinationAddressLine2: string | undefined, destinationPostalCodeId: number | undefined, destinationPostalCode: string | undefined, destinationCountry: string | undefined, destinationCity: string | undefined, destinationState: string | undefined, destinationGeocodeId: number | undefined, destinationLat: number | undefined, destinationLng: number | undefined, destinationAddressTypeId: number | undefined, pickUpEtaStart: moment.Moment | undefined, pickUpEtaEnd: moment.Moment | undefined, pickUpContactId: number | undefined, pickUpFirstName: string | undefined, pickUpLastName: string | undefined, pickUpEmail: string | undefined, pickUpPhone: string | undefined, pickUpAddressLine1: string | undefined, pickUpAddressLine2: string | undefined, pickUpPostalCodeId: number | undefined, pickUpPostalCode: string | undefined, pickUpCountry: string | undefined, pickUpCity: string | undefined, pickUpState: string | undefined, pickUpGeocodeId: number | undefined, pickUpLat: number | undefined, pickUpLng: number | undefined, pickUpAddressTypeId: number | undefined, orderSourceId: number | undefined, orderSourceCode: string | undefined, isDownloadOrder: boolean | undefined, isRecurring: boolean | undefined, recurringScheduleCode: string | undefined, orderStatusCode: string | undefined, zipRegex: string | undefined, driverFirstName: string | undefined, driverLastName: string | undefined, driverUserName: string | undefined): Observable<Location> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetLocationOfDelivery?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (tags === null)
            throw new Error("The parameter 'tags' cannot be null.");
        else if (tags !== undefined)
            tags && tags.forEach((item, index) => { 
                for (let attr in item)
        			if (item.hasOwnProperty(attr)) {
        				url_ += "Tags[" + index + "]." + attr + "=" + encodeURIComponent("" + (<any>item)[attr]) + "&";
        			}
            });
        if (trackingIdentifier === null)
            throw new Error("The parameter 'trackingIdentifier' cannot be null.");
        else if (trackingIdentifier !== undefined)
            url_ += "TrackingIdentifier=" + encodeURIComponent("" + trackingIdentifier) + "&"; 
        if (note === null)
            throw new Error("The parameter 'note' cannot be null.");
        else if (note !== undefined)
            url_ += "Note=" + encodeURIComponent("" + note) + "&"; 
        if (packages === null)
            throw new Error("The parameter 'packages' cannot be null.");
        else if (packages !== undefined)
            packages && packages.forEach((item, index) => { 
                for (let attr in item)
        			if (item.hasOwnProperty(attr)) {
        				url_ += "Packages[" + index + "]." + attr + "=" + encodeURIComponent("" + (<any>item)[attr]) + "&";
        			}
            });
        if (destinationEtaStart === null)
            throw new Error("The parameter 'destinationEtaStart' cannot be null.");
        else if (destinationEtaStart !== undefined)
            url_ += "DestinationEtaStart=" + encodeURIComponent(destinationEtaStart ? "" + destinationEtaStart.toJSON() : "") + "&"; 
        if (destinationEtaEnd === null)
            throw new Error("The parameter 'destinationEtaEnd' cannot be null.");
        else if (destinationEtaEnd !== undefined)
            url_ += "DestinationEtaEnd=" + encodeURIComponent(destinationEtaEnd ? "" + destinationEtaEnd.toJSON() : "") + "&"; 
        if (destinationContactId === null)
            throw new Error("The parameter 'destinationContactId' cannot be null.");
        else if (destinationContactId !== undefined)
            url_ += "DestinationContactId=" + encodeURIComponent("" + destinationContactId) + "&"; 
        if (destinationFirstName === null)
            throw new Error("The parameter 'destinationFirstName' cannot be null.");
        else if (destinationFirstName !== undefined)
            url_ += "DestinationFirstName=" + encodeURIComponent("" + destinationFirstName) + "&"; 
        if (destinationLastName === null)
            throw new Error("The parameter 'destinationLastName' cannot be null.");
        else if (destinationLastName !== undefined)
            url_ += "DestinationLastName=" + encodeURIComponent("" + destinationLastName) + "&"; 
        if (destinationEmail === null)
            throw new Error("The parameter 'destinationEmail' cannot be null.");
        else if (destinationEmail !== undefined)
            url_ += "DestinationEmail=" + encodeURIComponent("" + destinationEmail) + "&"; 
        if (destinationPhone === null)
            throw new Error("The parameter 'destinationPhone' cannot be null.");
        else if (destinationPhone !== undefined)
            url_ += "DestinationPhone=" + encodeURIComponent("" + destinationPhone) + "&"; 
        if (destinationAddressLine1 === null)
            throw new Error("The parameter 'destinationAddressLine1' cannot be null.");
        else if (destinationAddressLine1 !== undefined)
            url_ += "DestinationAddressLine1=" + encodeURIComponent("" + destinationAddressLine1) + "&"; 
        if (destinationAddressLine2 === null)
            throw new Error("The parameter 'destinationAddressLine2' cannot be null.");
        else if (destinationAddressLine2 !== undefined)
            url_ += "DestinationAddressLine2=" + encodeURIComponent("" + destinationAddressLine2) + "&"; 
        if (destinationPostalCodeId === null)
            throw new Error("The parameter 'destinationPostalCodeId' cannot be null.");
        else if (destinationPostalCodeId !== undefined)
            url_ += "DestinationPostalCodeId=" + encodeURIComponent("" + destinationPostalCodeId) + "&"; 
        if (destinationPostalCode === null)
            throw new Error("The parameter 'destinationPostalCode' cannot be null.");
        else if (destinationPostalCode !== undefined)
            url_ += "DestinationPostalCode=" + encodeURIComponent("" + destinationPostalCode) + "&"; 
        if (destinationCountry === null)
            throw new Error("The parameter 'destinationCountry' cannot be null.");
        else if (destinationCountry !== undefined)
            url_ += "DestinationCountry=" + encodeURIComponent("" + destinationCountry) + "&"; 
        if (destinationCity === null)
            throw new Error("The parameter 'destinationCity' cannot be null.");
        else if (destinationCity !== undefined)
            url_ += "DestinationCity=" + encodeURIComponent("" + destinationCity) + "&"; 
        if (destinationState === null)
            throw new Error("The parameter 'destinationState' cannot be null.");
        else if (destinationState !== undefined)
            url_ += "DestinationState=" + encodeURIComponent("" + destinationState) + "&"; 
        if (destinationGeocodeId === null)
            throw new Error("The parameter 'destinationGeocodeId' cannot be null.");
        else if (destinationGeocodeId !== undefined)
            url_ += "DestinationGeocodeId=" + encodeURIComponent("" + destinationGeocodeId) + "&"; 
        if (destinationLat === null)
            throw new Error("The parameter 'destinationLat' cannot be null.");
        else if (destinationLat !== undefined)
            url_ += "DestinationLat=" + encodeURIComponent("" + destinationLat) + "&"; 
        if (destinationLng === null)
            throw new Error("The parameter 'destinationLng' cannot be null.");
        else if (destinationLng !== undefined)
            url_ += "DestinationLng=" + encodeURIComponent("" + destinationLng) + "&"; 
        if (destinationAddressTypeId === null)
            throw new Error("The parameter 'destinationAddressTypeId' cannot be null.");
        else if (destinationAddressTypeId !== undefined)
            url_ += "DestinationAddressTypeId=" + encodeURIComponent("" + destinationAddressTypeId) + "&"; 
        if (pickUpEtaStart === null)
            throw new Error("The parameter 'pickUpEtaStart' cannot be null.");
        else if (pickUpEtaStart !== undefined)
            url_ += "PickUpEtaStart=" + encodeURIComponent(pickUpEtaStart ? "" + pickUpEtaStart.toJSON() : "") + "&"; 
        if (pickUpEtaEnd === null)
            throw new Error("The parameter 'pickUpEtaEnd' cannot be null.");
        else if (pickUpEtaEnd !== undefined)
            url_ += "PickUpEtaEnd=" + encodeURIComponent(pickUpEtaEnd ? "" + pickUpEtaEnd.toJSON() : "") + "&"; 
        if (pickUpContactId === null)
            throw new Error("The parameter 'pickUpContactId' cannot be null.");
        else if (pickUpContactId !== undefined)
            url_ += "PickUpContactId=" + encodeURIComponent("" + pickUpContactId) + "&"; 
        if (pickUpFirstName === null)
            throw new Error("The parameter 'pickUpFirstName' cannot be null.");
        else if (pickUpFirstName !== undefined)
            url_ += "PickUpFirstName=" + encodeURIComponent("" + pickUpFirstName) + "&"; 
        if (pickUpLastName === null)
            throw new Error("The parameter 'pickUpLastName' cannot be null.");
        else if (pickUpLastName !== undefined)
            url_ += "PickUpLastName=" + encodeURIComponent("" + pickUpLastName) + "&"; 
        if (pickUpEmail === null)
            throw new Error("The parameter 'pickUpEmail' cannot be null.");
        else if (pickUpEmail !== undefined)
            url_ += "PickUpEmail=" + encodeURIComponent("" + pickUpEmail) + "&"; 
        if (pickUpPhone === null)
            throw new Error("The parameter 'pickUpPhone' cannot be null.");
        else if (pickUpPhone !== undefined)
            url_ += "PickUpPhone=" + encodeURIComponent("" + pickUpPhone) + "&"; 
        if (pickUpAddressLine1 === null)
            throw new Error("The parameter 'pickUpAddressLine1' cannot be null.");
        else if (pickUpAddressLine1 !== undefined)
            url_ += "PickUpAddressLine1=" + encodeURIComponent("" + pickUpAddressLine1) + "&"; 
        if (pickUpAddressLine2 === null)
            throw new Error("The parameter 'pickUpAddressLine2' cannot be null.");
        else if (pickUpAddressLine2 !== undefined)
            url_ += "PickUpAddressLine2=" + encodeURIComponent("" + pickUpAddressLine2) + "&"; 
        if (pickUpPostalCodeId === null)
            throw new Error("The parameter 'pickUpPostalCodeId' cannot be null.");
        else if (pickUpPostalCodeId !== undefined)
            url_ += "PickUpPostalCodeId=" + encodeURIComponent("" + pickUpPostalCodeId) + "&"; 
        if (pickUpPostalCode === null)
            throw new Error("The parameter 'pickUpPostalCode' cannot be null.");
        else if (pickUpPostalCode !== undefined)
            url_ += "PickUpPostalCode=" + encodeURIComponent("" + pickUpPostalCode) + "&"; 
        if (pickUpCountry === null)
            throw new Error("The parameter 'pickUpCountry' cannot be null.");
        else if (pickUpCountry !== undefined)
            url_ += "PickUpCountry=" + encodeURIComponent("" + pickUpCountry) + "&"; 
        if (pickUpCity === null)
            throw new Error("The parameter 'pickUpCity' cannot be null.");
        else if (pickUpCity !== undefined)
            url_ += "PickUpCity=" + encodeURIComponent("" + pickUpCity) + "&"; 
        if (pickUpState === null)
            throw new Error("The parameter 'pickUpState' cannot be null.");
        else if (pickUpState !== undefined)
            url_ += "PickUpState=" + encodeURIComponent("" + pickUpState) + "&"; 
        if (pickUpGeocodeId === null)
            throw new Error("The parameter 'pickUpGeocodeId' cannot be null.");
        else if (pickUpGeocodeId !== undefined)
            url_ += "PickUpGeocodeId=" + encodeURIComponent("" + pickUpGeocodeId) + "&"; 
        if (pickUpLat === null)
            throw new Error("The parameter 'pickUpLat' cannot be null.");
        else if (pickUpLat !== undefined)
            url_ += "PickUpLat=" + encodeURIComponent("" + pickUpLat) + "&"; 
        if (pickUpLng === null)
            throw new Error("The parameter 'pickUpLng' cannot be null.");
        else if (pickUpLng !== undefined)
            url_ += "PickUpLng=" + encodeURIComponent("" + pickUpLng) + "&"; 
        if (pickUpAddressTypeId === null)
            throw new Error("The parameter 'pickUpAddressTypeId' cannot be null.");
        else if (pickUpAddressTypeId !== undefined)
            url_ += "PickUpAddressTypeId=" + encodeURIComponent("" + pickUpAddressTypeId) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (orderSourceCode === null)
            throw new Error("The parameter 'orderSourceCode' cannot be null.");
        else if (orderSourceCode !== undefined)
            url_ += "OrderSourceCode=" + encodeURIComponent("" + orderSourceCode) + "&"; 
        if (isDownloadOrder === null)
            throw new Error("The parameter 'isDownloadOrder' cannot be null.");
        else if (isDownloadOrder !== undefined)
            url_ += "IsDownloadOrder=" + encodeURIComponent("" + isDownloadOrder) + "&"; 
        if (isRecurring === null)
            throw new Error("The parameter 'isRecurring' cannot be null.");
        else if (isRecurring !== undefined)
            url_ += "IsRecurring=" + encodeURIComponent("" + isRecurring) + "&"; 
        if (recurringScheduleCode === null)
            throw new Error("The parameter 'recurringScheduleCode' cannot be null.");
        else if (recurringScheduleCode !== undefined)
            url_ += "RecurringScheduleCode=" + encodeURIComponent("" + recurringScheduleCode) + "&"; 
        if (orderStatusCode === null)
            throw new Error("The parameter 'orderStatusCode' cannot be null.");
        else if (orderStatusCode !== undefined)
            url_ += "OrderStatusCode=" + encodeURIComponent("" + orderStatusCode) + "&"; 
        if (zipRegex === null)
            throw new Error("The parameter 'zipRegex' cannot be null.");
        else if (zipRegex !== undefined)
            url_ += "ZipRegex=" + encodeURIComponent("" + zipRegex) + "&"; 
        if (driverFirstName === null)
            throw new Error("The parameter 'driverFirstName' cannot be null.");
        else if (driverFirstName !== undefined)
            url_ += "DriverFirstName=" + encodeURIComponent("" + driverFirstName) + "&"; 
        if (driverLastName === null)
            throw new Error("The parameter 'driverLastName' cannot be null.");
        else if (driverLastName !== undefined)
            url_ += "DriverLastName=" + encodeURIComponent("" + driverLastName) + "&"; 
        if (driverUserName === null)
            throw new Error("The parameter 'driverUserName' cannot be null.");
        else if (driverUserName !== undefined)
            url_ += "DriverUserName=" + encodeURIComponent("" + driverUserName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationOfDelivery(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationOfDelivery(<any>response_);
                } catch (e) {
                    return <Observable<Location>><any>_observableThrow(e);
                }
            } else
                return <Observable<Location>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationOfDelivery(response: HttpResponseBase): Observable<Location> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = Location.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Location>(<any>null);
    }

    /**
     * @param notes (optional) 
     * @param brandOrderId (optional) 
     * @param orderSourceCode (optional) 
     * @param customer_brandContactId (optional) 
     * @param customer_email (optional) 
     * @param customer_phone (optional) 
     * @param customer_name (optional) 
     * @param customer_address1 (optional) 
     * @param customer_address2 (optional) 
     * @param customer_zipcode (optional) 
     * @param customer_city (optional) 
     * @param customer_state (optional) 
     * @param customer_country (optional) 
     * @param customer_notes (optional) 
     * @param receiver_brandContactId (optional) 
     * @param receiver_email (optional) 
     * @param receiver_phone (optional) 
     * @param receiver_name (optional) 
     * @param receiver_address1 (optional) 
     * @param receiver_address2 (optional) 
     * @param receiver_zipcode (optional) 
     * @param receiver_city (optional) 
     * @param receiver_state (optional) 
     * @param receiver_country (optional) 
     * @param receiver_notes (optional) 
     * @param requestedDeliveryDate (optional) 
     * @param items (optional) 
     * @return Success
     */
    getLocationOfDeliveryWebhooks(notes: string | undefined, brandOrderId: string | undefined, orderSourceCode: string | undefined, customer_brandContactId: string | undefined, customer_email: string | undefined, customer_phone: string | undefined, customer_name: string | undefined, customer_address1: string | undefined, customer_address2: string | undefined, customer_zipcode: string | undefined, customer_city: string | undefined, customer_state: string | undefined, customer_country: string | undefined, customer_notes: string | undefined, receiver_brandContactId: string | undefined, receiver_email: string | undefined, receiver_phone: string | undefined, receiver_name: string | undefined, receiver_address1: string | undefined, receiver_address2: string | undefined, receiver_zipcode: string | undefined, receiver_city: string | undefined, receiver_state: string | undefined, receiver_country: string | undefined, receiver_notes: string | undefined, requestedDeliveryDate: moment.Moment | undefined, items: PackageInputApi[] | undefined): Observable<Location> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetLocationOfDeliveryWebhooks?";
        if (notes === null)
            throw new Error("The parameter 'notes' cannot be null.");
        else if (notes !== undefined)
            url_ += "Notes=" + encodeURIComponent("" + notes) + "&"; 
        if (brandOrderId === null)
            throw new Error("The parameter 'brandOrderId' cannot be null.");
        else if (brandOrderId !== undefined)
            url_ += "BrandOrderId=" + encodeURIComponent("" + brandOrderId) + "&"; 
        if (orderSourceCode === null)
            throw new Error("The parameter 'orderSourceCode' cannot be null.");
        else if (orderSourceCode !== undefined)
            url_ += "OrderSourceCode=" + encodeURIComponent("" + orderSourceCode) + "&"; 
        if (customer_brandContactId === null)
            throw new Error("The parameter 'customer_brandContactId' cannot be null.");
        else if (customer_brandContactId !== undefined)
            url_ += "Customer.brandContactId=" + encodeURIComponent("" + customer_brandContactId) + "&"; 
        if (customer_email === null)
            throw new Error("The parameter 'customer_email' cannot be null.");
        else if (customer_email !== undefined)
            url_ += "Customer.email=" + encodeURIComponent("" + customer_email) + "&"; 
        if (customer_phone === null)
            throw new Error("The parameter 'customer_phone' cannot be null.");
        else if (customer_phone !== undefined)
            url_ += "Customer.phone=" + encodeURIComponent("" + customer_phone) + "&"; 
        if (customer_name === null)
            throw new Error("The parameter 'customer_name' cannot be null.");
        else if (customer_name !== undefined)
            url_ += "Customer.name=" + encodeURIComponent("" + customer_name) + "&"; 
        if (customer_address1 === null)
            throw new Error("The parameter 'customer_address1' cannot be null.");
        else if (customer_address1 !== undefined)
            url_ += "Customer.address1=" + encodeURIComponent("" + customer_address1) + "&"; 
        if (customer_address2 === null)
            throw new Error("The parameter 'customer_address2' cannot be null.");
        else if (customer_address2 !== undefined)
            url_ += "Customer.address2=" + encodeURIComponent("" + customer_address2) + "&"; 
        if (customer_zipcode === null)
            throw new Error("The parameter 'customer_zipcode' cannot be null.");
        else if (customer_zipcode !== undefined)
            url_ += "Customer.zipcode=" + encodeURIComponent("" + customer_zipcode) + "&"; 
        if (customer_city === null)
            throw new Error("The parameter 'customer_city' cannot be null.");
        else if (customer_city !== undefined)
            url_ += "Customer.city=" + encodeURIComponent("" + customer_city) + "&"; 
        if (customer_state === null)
            throw new Error("The parameter 'customer_state' cannot be null.");
        else if (customer_state !== undefined)
            url_ += "Customer.state=" + encodeURIComponent("" + customer_state) + "&"; 
        if (customer_country === null)
            throw new Error("The parameter 'customer_country' cannot be null.");
        else if (customer_country !== undefined)
            url_ += "Customer.country=" + encodeURIComponent("" + customer_country) + "&"; 
        if (customer_notes === null)
            throw new Error("The parameter 'customer_notes' cannot be null.");
        else if (customer_notes !== undefined)
            url_ += "Customer.notes=" + encodeURIComponent("" + customer_notes) + "&"; 
        if (receiver_brandContactId === null)
            throw new Error("The parameter 'receiver_brandContactId' cannot be null.");
        else if (receiver_brandContactId !== undefined)
            url_ += "Receiver.brandContactId=" + encodeURIComponent("" + receiver_brandContactId) + "&"; 
        if (receiver_email === null)
            throw new Error("The parameter 'receiver_email' cannot be null.");
        else if (receiver_email !== undefined)
            url_ += "Receiver.email=" + encodeURIComponent("" + receiver_email) + "&"; 
        if (receiver_phone === null)
            throw new Error("The parameter 'receiver_phone' cannot be null.");
        else if (receiver_phone !== undefined)
            url_ += "Receiver.phone=" + encodeURIComponent("" + receiver_phone) + "&"; 
        if (receiver_name === null)
            throw new Error("The parameter 'receiver_name' cannot be null.");
        else if (receiver_name !== undefined)
            url_ += "Receiver.name=" + encodeURIComponent("" + receiver_name) + "&"; 
        if (receiver_address1 === null)
            throw new Error("The parameter 'receiver_address1' cannot be null.");
        else if (receiver_address1 !== undefined)
            url_ += "Receiver.address1=" + encodeURIComponent("" + receiver_address1) + "&"; 
        if (receiver_address2 === null)
            throw new Error("The parameter 'receiver_address2' cannot be null.");
        else if (receiver_address2 !== undefined)
            url_ += "Receiver.address2=" + encodeURIComponent("" + receiver_address2) + "&"; 
        if (receiver_zipcode === null)
            throw new Error("The parameter 'receiver_zipcode' cannot be null.");
        else if (receiver_zipcode !== undefined)
            url_ += "Receiver.zipcode=" + encodeURIComponent("" + receiver_zipcode) + "&"; 
        if (receiver_city === null)
            throw new Error("The parameter 'receiver_city' cannot be null.");
        else if (receiver_city !== undefined)
            url_ += "Receiver.city=" + encodeURIComponent("" + receiver_city) + "&"; 
        if (receiver_state === null)
            throw new Error("The parameter 'receiver_state' cannot be null.");
        else if (receiver_state !== undefined)
            url_ += "Receiver.state=" + encodeURIComponent("" + receiver_state) + "&"; 
        if (receiver_country === null)
            throw new Error("The parameter 'receiver_country' cannot be null.");
        else if (receiver_country !== undefined)
            url_ += "Receiver.country=" + encodeURIComponent("" + receiver_country) + "&"; 
        if (receiver_notes === null)
            throw new Error("The parameter 'receiver_notes' cannot be null.");
        else if (receiver_notes !== undefined)
            url_ += "Receiver.notes=" + encodeURIComponent("" + receiver_notes) + "&"; 
        if (requestedDeliveryDate === null)
            throw new Error("The parameter 'requestedDeliveryDate' cannot be null.");
        else if (requestedDeliveryDate !== undefined)
            url_ += "RequestedDeliveryDate=" + encodeURIComponent(requestedDeliveryDate ? "" + requestedDeliveryDate.toJSON() : "") + "&"; 
        if (items === null)
            throw new Error("The parameter 'items' cannot be null.");
        else if (items !== undefined)
            items && items.forEach((item, index) => { 
                for (let attr in item)
        			if (item.hasOwnProperty(attr)) {
        				url_ += "Items[" + index + "]." + attr + "=" + encodeURIComponent("" + (<any>item)[attr]) + "&";
        			}
            });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationOfDeliveryWebhooks(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationOfDeliveryWebhooks(<any>response_);
                } catch (e) {
                    return <Observable<Location>><any>_observableThrow(e);
                }
            } else
                return <Observable<Location>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationOfDeliveryWebhooks(response: HttpResponseBase): Observable<Location> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = Location.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Location>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderDefault(body: CreateOrderDefaultInput | undefined): Observable<CreateOrderApiResult> {
        let url_ = this.baseUrl + "/api/services/app/Order/CreateOrderDefault";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderDefault(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderDefault(<any>response_);
                } catch (e) {
                    return <Observable<CreateOrderApiResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateOrderApiResult>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderDefault(response: HttpResponseBase): Observable<CreateOrderApiResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateOrderApiResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateOrderApiResult>(<any>null);
    }

    /**
     * @param postalCodeId (optional) 
     * @param postalCode (optional) 
     * @return Success
     */
    getLocationIdByPostalCode(postalCodeId: number | undefined, postalCode: string | undefined): Observable<Location> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetLocationIdByPostalCode?";
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (postalCode === null)
            throw new Error("The parameter 'postalCode' cannot be null.");
        else if (postalCode !== undefined)
            url_ += "PostalCode=" + encodeURIComponent("" + postalCode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationIdByPostalCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationIdByPostalCode(<any>response_);
                } catch (e) {
                    return <Observable<Location>><any>_observableThrow(e);
                }
            } else
                return <Observable<Location>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationIdByPostalCode(response: HttpResponseBase): Observable<Location> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = Location.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Location>(<any>null);
    }

    /**
     * Creates the ZPL value for the label.
     * @param body (optional) A unique Tracking Number from the CreateOrder API.
     * @return Returns the ZPL value for the order label.
     */
    createLabel(body: GetLabelInput | undefined): Observable<ZplResult> {
        let url_ = this.baseUrl + "/api/services/app/Order/CreateLabel";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateLabel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateLabel(<any>response_);
                } catch (e) {
                    return <Observable<ZplResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<ZplResult>><any>_observableThrow(response_);
        }));
    }

    protected processCreateLabel(response: HttpResponseBase): Observable<ZplResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ZplResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 501) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ZplResult>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    printlabels(body: GetLabels | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/Printlabels";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPrintlabels(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPrintlabels(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processPrintlabels(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    printlabel(body: GetLabelInput | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/Printlabel";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPrintlabel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPrintlabel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processPrintlabel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param pickupDetailsId (optional) 
     * @param deliveryDetailsId (optional) 
     * @param locationId (optional) 
     * @param noteId (optional) 
     * @param creationTime (optional) 
     * @param sortOrder (optional) 
     * @param orderTypeId (optional) 
     * @param orderId (optional) 
     * @return Success
     */
    getOrdersForExcel(id: number | undefined, filter: string | undefined, pickupDetailsId: number | undefined, deliveryDetailsId: number | undefined, locationId: number | undefined, noteId: number | undefined, creationTime: moment.Moment | undefined, sortOrder: number | undefined, orderTypeId: number | undefined, orderId: string | undefined): Observable<ListResultDtoOfOrderListDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetOrdersForExcel?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (pickupDetailsId === null)
            throw new Error("The parameter 'pickupDetailsId' cannot be null.");
        else if (pickupDetailsId !== undefined)
            url_ += "PickupDetailsId=" + encodeURIComponent("" + pickupDetailsId) + "&"; 
        if (deliveryDetailsId === null)
            throw new Error("The parameter 'deliveryDetailsId' cannot be null.");
        else if (deliveryDetailsId !== undefined)
            url_ += "DeliveryDetailsId=" + encodeURIComponent("" + deliveryDetailsId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (creationTime === null)
            throw new Error("The parameter 'creationTime' cannot be null.");
        else if (creationTime !== undefined)
            url_ += "CreationTime=" + encodeURIComponent(creationTime ? "" + creationTime.toJSON() : "") + "&"; 
        if (sortOrder === null)
            throw new Error("The parameter 'sortOrder' cannot be null.");
        else if (sortOrder !== undefined)
            url_ += "SortOrder=" + encodeURIComponent("" + sortOrder) + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrdersForExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrdersForExcel(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfOrderListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfOrderListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrdersForExcel(response: HttpResponseBase): Observable<ListResultDtoOfOrderListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfOrderListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfOrderListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderV2(body: CreateOrderV2Input | undefined): Observable<OrderListDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/CreateOrderV2";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderV2(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderV2(<any>response_);
                } catch (e) {
                    return <Observable<OrderListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderListDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderV2(response: HttpResponseBase): Observable<OrderListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    handleEvent(body: IOrderStatusAddEventData | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/HandleEvent";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processHandleEvent(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processHandleEvent(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processHandleEvent(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setClinicNoteRead(body: CreateClinicNoteReadInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/SetClinicNoteRead";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetClinicNoteRead(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetClinicNoteRead(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetClinicNoteRead(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    lockedOrder(body: LockedOrderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/LockedOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLockedOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLockedOrder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLockedOrder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    editOrderContactDetail(body: EditOrdeContactDetail | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/EditOrderContactDetail";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processEditOrderContactDetail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processEditOrderContactDetail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processEditOrderContactDetail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tagName (optional) 
     * @return Success
     */
    getTrackingId(tagName: string | undefined): Observable<GetOrderTagOrderIdDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetTrackingId?";
        if (tagName === null)
            throw new Error("The parameter 'tagName' cannot be null.");
        else if (tagName !== undefined)
            url_ += "TagName=" + encodeURIComponent("" + tagName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTrackingId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTrackingId(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderTagOrderIdDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderTagOrderIdDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTrackingId(response: HttpResponseBase): Observable<GetOrderTagOrderIdDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderTagOrderIdDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderTagOrderIdDto>(<any>null);
    }

    /**
     * @param tagName (optional) 
     * @return Success
     */
    getCustomerTracking(tagName: string | undefined): Observable<GetOrderTagOrderIdDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetCustomerTracking?";
        if (tagName === null)
            throw new Error("The parameter 'tagName' cannot be null.");
        else if (tagName !== undefined)
            url_ += "TagName=" + encodeURIComponent("" + tagName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCustomerTracking(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCustomerTracking(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderTagOrderIdDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderTagOrderIdDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCustomerTracking(response: HttpResponseBase): Observable<GetOrderTagOrderIdDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderTagOrderIdDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderTagOrderIdDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    cancelOrder(body: CancelOrderInputDto | undefined): Observable<CancelOrderResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Order/CancelOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCancelOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCancelOrder(<any>response_);
                } catch (e) {
                    return <Observable<CancelOrderResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<CancelOrderResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processCancelOrder(response: HttpResponseBase): Observable<CancelOrderResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(CancelOrderResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CancelOrderResultDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendOrderDetailToCustomer(body: SendEmailToCustomerDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/SendOrderDetailToCustomer";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendOrderDetailToCustomer(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendOrderDetailToCustomer(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendOrderDetailToCustomer(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param note (optional) 
     * @return Success
     */
    updateOrderNote(orderId: number | undefined, note: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/UpdateOrderNote?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (note === null)
            throw new Error("The parameter 'note' cannot be null.");
        else if (note !== undefined)
            url_ += "note=" + encodeURIComponent("" + note) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getClinicSchedule(orderId: number | undefined): Observable<ClinicSchedDto> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetClinicSchedule?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicSchedule(<any>response_);
                } catch (e) {
                    return <Observable<ClinicSchedDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ClinicSchedDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicSchedule(response: HttpResponseBase): Observable<ClinicSchedDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ClinicSchedDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ClinicSchedDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOnDemandOrder(body: CreateOnDemandOrderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Order/UpdateOnDemandOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOnDemandOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOnDemandOrder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOnDemandOrder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOnDemandOrder(body: CreateOnDemandOrderInput | undefined): Observable<CreateOrderApiResult> {
        let url_ = this.baseUrl + "/api/services/app/Order/CreateOnDemandOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOnDemandOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOnDemandOrder(<any>response_);
                } catch (e) {
                    return <Observable<CreateOrderApiResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateOrderApiResult>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOnDemandOrder(response: HttpResponseBase): Observable<CreateOrderApiResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateOrderApiResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateOrderApiResult>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param locationId (optional) 
     * @param routeCode (optional) 
     * @param startLat (optional) 
     * @param startLong (optional) 
     * @param endLat (optional) 
     * @param endLong (optional) 
     * @param initialDateTime (optional) 
     * @return Success
     */
    getLiveEta(orderId: number | undefined, locationId: number | undefined, routeCode: string | undefined, startLat: number | undefined, startLong: number | undefined, endLat: number | undefined, endLong: number | undefined, initialDateTime: moment.Moment | undefined): Observable<GetLiveEtaResult> {
        let url_ = this.baseUrl + "/api/services/app/Order/GetLiveEta?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (routeCode === null)
            throw new Error("The parameter 'routeCode' cannot be null.");
        else if (routeCode !== undefined)
            url_ += "RouteCode=" + encodeURIComponent("" + routeCode) + "&"; 
        if (startLat === null)
            throw new Error("The parameter 'startLat' cannot be null.");
        else if (startLat !== undefined)
            url_ += "StartLat=" + encodeURIComponent("" + startLat) + "&"; 
        if (startLong === null)
            throw new Error("The parameter 'startLong' cannot be null.");
        else if (startLong !== undefined)
            url_ += "StartLong=" + encodeURIComponent("" + startLong) + "&"; 
        if (endLat === null)
            throw new Error("The parameter 'endLat' cannot be null.");
        else if (endLat !== undefined)
            url_ += "EndLat=" + encodeURIComponent("" + endLat) + "&"; 
        if (endLong === null)
            throw new Error("The parameter 'endLong' cannot be null.");
        else if (endLong !== undefined)
            url_ += "EndLong=" + encodeURIComponent("" + endLong) + "&"; 
        if (initialDateTime === null)
            throw new Error("The parameter 'initialDateTime' cannot be null.");
        else if (initialDateTime !== undefined)
            url_ += "InitialDateTime=" + encodeURIComponent(initialDateTime ? "" + initialDateTime.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLiveEta(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLiveEta(<any>response_);
                } catch (e) {
                    return <Observable<GetLiveEtaResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLiveEtaResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetLiveEta(response: HttpResponseBase): Observable<GetLiveEtaResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLiveEtaResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLiveEtaResult>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    checkOrCreateGeocode(body: GoogleGeocodingResult | undefined): Observable<Geocode> {
        let url_ = this.baseUrl + "/api/services/app/Order/CheckOrCreateGeocode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckOrCreateGeocode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckOrCreateGeocode(<any>response_);
                } catch (e) {
                    return <Observable<Geocode>><any>_observableThrow(e);
                }
            } else
                return <Observable<Geocode>><any>_observableThrow(response_);
        }));
    }

    protected processCheckOrCreateGeocode(response: HttpResponseBase): Observable<Geocode> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = Geocode.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Geocode>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    checkOrCreateAddress(body: AddressCheckerInput | undefined): Observable<Address> {
        let url_ = this.baseUrl + "/api/services/app/Order/CheckOrCreateAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckOrCreateAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckOrCreateAddress(<any>response_);
                } catch (e) {
                    return <Observable<Address>><any>_observableThrow(e);
                }
            } else
                return <Observable<Address>><any>_observableThrow(response_);
        }));
    }

    protected processCheckOrCreateAddress(response: HttpResponseBase): Observable<Address> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = Address.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Address>(<any>null);
    }
}

@Injectable()
export class OrderBulkServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param testMode (optional) 
     * @param body (optional) 
     * @return Success
     */
    createBulkOrders(testMode: boolean | undefined, body: CreateOrderApiInput[] | undefined): Observable<CreateOrderBulkResult[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderBulk/CreateBulkOrders?";
        if (testMode === null)
            throw new Error("The parameter 'testMode' cannot be null.");
        else if (testMode !== undefined)
            url_ += "TestMode=" + encodeURIComponent("" + testMode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateBulkOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateBulkOrders(<any>response_);
                } catch (e) {
                    return <Observable<CreateOrderBulkResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateOrderBulkResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processCreateBulkOrders(response: HttpResponseBase): Observable<CreateOrderBulkResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(CreateOrderBulkResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateOrderBulkResult[]>(<any>null);
    }
}

@Injectable()
export class OrderIncidentsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getOrderIncidentTotalCount(orderId: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetOrderIncidentTotalCount?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderIncidentTotalCount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderIncidentTotalCount(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderIncidentTotalCount(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param orderId (optional) 
     * @param locationId (optional) 
     * @param incidentDate (optional) 
     * @param orderTypeId (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllGroupByOrderType(filter: string | undefined, orderId: number | undefined, locationId: number | undefined, incidentDate: moment.Moment | undefined, orderTypeId: number | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfgroupOrderIncidentTab> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetAllGroupByOrderType?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (incidentDate === null)
            throw new Error("The parameter 'incidentDate' cannot be null.");
        else if (incidentDate !== undefined)
            url_ += "IncidentDate=" + encodeURIComponent(incidentDate ? "" + incidentDate.toJSON() : "") + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllGroupByOrderType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllGroupByOrderType(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfgroupOrderIncidentTab>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfgroupOrderIncidentTab>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllGroupByOrderType(response: HttpResponseBase): Observable<PagedResultDtoOfgroupOrderIncidentTab> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfgroupOrderIncidentTab.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfgroupOrderIncidentTab>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param orderId (optional) 
     * @param locationId (optional) 
     * @param incidentDate (optional) 
     * @param orderTypeId (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllIncidentTab(filter: string | undefined, orderId: number | undefined, locationId: number | undefined, incidentDate: moment.Moment | undefined, orderTypeId: number | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderIncidentListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetAllIncidentTab?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (incidentDate === null)
            throw new Error("The parameter 'incidentDate' cannot be null.");
        else if (incidentDate !== undefined)
            url_ += "IncidentDate=" + encodeURIComponent(incidentDate ? "" + incidentDate.toJSON() : "") + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllIncidentTab(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllIncidentTab(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderIncidentListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderIncidentListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllIncidentTab(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderIncidentListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderIncidentListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderIncidentListDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param orderId (optional) 
     * @param locationId (optional) 
     * @param incidentDate (optional) 
     * @param orderTypeId (optional) 
     * @param isLineHaul (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, orderId: number | undefined, locationId: number | undefined, incidentDate: moment.Moment | undefined, orderTypeId: number | undefined, isLineHaul: boolean | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderIncidentListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (incidentDate === null)
            throw new Error("The parameter 'incidentDate' cannot be null.");
        else if (incidentDate !== undefined)
            url_ += "IncidentDate=" + encodeURIComponent(incidentDate ? "" + incidentDate.toJSON() : "") + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (isLineHaul === null)
            throw new Error("The parameter 'isLineHaul' cannot be null.");
        else if (isLineHaul !== undefined)
            url_ += "IsLineHaul=" + encodeURIComponent("" + isLineHaul) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderIncidentListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderIncidentListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderIncidentListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderIncidentListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderIncidentListDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderIncidentsByOrderId(orderId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetOrderIncidentListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetOrderIncidentsByOrderId?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderIncidentsByOrderId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderIncidentsByOrderId(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderIncidentListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderIncidentListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderIncidentsByOrderId(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderIncidentListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderIncidentListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderIncidentListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderIncidentForView(id: number | undefined): Observable<GetOrderIncidentForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetOrderIncidentForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderIncidentForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderIncidentForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderIncidentForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderIncidentForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderIncidentForView(response: HttpResponseBase): Observable<GetOrderIncidentForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderIncidentForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderIncidentForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderIncidentForEdit(id: number | undefined): Observable<GetOrderIncidentForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetOrderIncidentForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderIncidentForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderIncidentForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderIncidentForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderIncidentForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderIncidentForEdit(response: HttpResponseBase): Observable<GetOrderIncidentForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderIncidentForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderIncidentForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderIncident(body: CreateOrderIncidentInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/CreateOrderIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderIncident(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderIncident(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    editOrderIncident(body: EditOrderIncidentDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/EditOrderIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processEditOrderIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processEditOrderIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processEditOrderIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addMultipleOrderIncident(body: AddMultipleOrderIncidentDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/AddMultipleOrderIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddMultipleOrderIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddMultipleOrderIncident(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddMultipleOrderIncident(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getIncidentSource(): Observable<IncidentSourceListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetIncidentSource";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidentSource(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidentSource(<any>response_);
                } catch (e) {
                    return <Observable<IncidentSourceListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<IncidentSourceListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidentSource(response: HttpResponseBase): Observable<IncidentSourceListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(IncidentSourceListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<IncidentSourceListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    incidentSourcePagedList(body: GetAllForLookupTableInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/IncidentSourcePagedList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIncidentSourcePagedList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIncidentSourcePagedList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processIncidentSourcePagedList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllOrderForLookupTable(filter: string | undefined, id: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrderIncidentOrderLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetAllOrderForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderIncidentOrderLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderIncidentOrderLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfOrderIncidentOrderLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderIncidentOrderLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderIncidentOrderLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllIncidentForLookupTable(filter: string | undefined, id: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrderIncidentIncidentLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetAllIncidentForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllIncidentForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllIncidentForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderIncidentIncidentLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderIncidentIncidentLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllIncidentForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfOrderIncidentIncidentLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderIncidentIncidentLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderIncidentIncidentLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllIncidentTypeForLookupTable(filter: string | undefined, id: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetAllIncidentTypeForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllIncidentTypeForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllIncidentTypeForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllIncidentTypeForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto>(<any>null);
    }

    /**
     * @return Success
     */
    getManagers(): Observable<GetManagerResult[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetManagers";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetManagers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetManagers(<any>response_);
                } catch (e) {
                    return <Observable<GetManagerResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetManagerResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetManagers(response: HttpResponseBase): Observable<GetManagerResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetManagerResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetManagerResult[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    managersPagedList(body: GetAllForLookupTableInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/ManagersPagedList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processManagersPagedList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processManagersPagedList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processManagersPagedList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getManagerByOrder(orderId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetManagerByOrder?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetManagerByOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetManagerByOrder(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetManagerByOrder(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getClinicId(orderId: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetClinicId?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicId(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicId(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDriverOrderIncident(body: CreateDriverOrderIncidentInputDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/CreateDriverOrderIncident";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDriverOrderIncident(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDriverOrderIncident(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDriverOrderIncident(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getPagedManagerList(filter: string | undefined, id: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/GetPagedManagerList?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPagedManagerList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPagedManagerList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPagedManagerList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createIncidentForCustomer(body: CreateIncidentForCustomerInputDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderIncidents/CreateIncidentForCustomer";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateIncidentForCustomer(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateIncidentForCustomer(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateIncidentForCustomer(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class OrderNotificationsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param orderNotificationTemplateDescriptionFilter (optional) 
     * @param orderTypeDescriptionFilter (optional) 
     * @param smsTemplateDescriptionFilter (optional) 
     * @param orderStatusTypeDescriptionFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, codeFilter: string | undefined, isActiveFilter: number | undefined, descriptionFilter: string | undefined, orderNotificationTemplateDescriptionFilter: string | undefined, orderTypeDescriptionFilter: string | undefined, smsTemplateDescriptionFilter: string | undefined, orderStatusTypeDescriptionFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderNotificationForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (orderNotificationTemplateDescriptionFilter === null)
            throw new Error("The parameter 'orderNotificationTemplateDescriptionFilter' cannot be null.");
        else if (orderNotificationTemplateDescriptionFilter !== undefined)
            url_ += "OrderNotificationTemplateDescriptionFilter=" + encodeURIComponent("" + orderNotificationTemplateDescriptionFilter) + "&"; 
        if (orderTypeDescriptionFilter === null)
            throw new Error("The parameter 'orderTypeDescriptionFilter' cannot be null.");
        else if (orderTypeDescriptionFilter !== undefined)
            url_ += "OrderTypeDescriptionFilter=" + encodeURIComponent("" + orderTypeDescriptionFilter) + "&"; 
        if (smsTemplateDescriptionFilter === null)
            throw new Error("The parameter 'smsTemplateDescriptionFilter' cannot be null.");
        else if (smsTemplateDescriptionFilter !== undefined)
            url_ += "SmsTemplateDescriptionFilter=" + encodeURIComponent("" + smsTemplateDescriptionFilter) + "&"; 
        if (orderStatusTypeDescriptionFilter === null)
            throw new Error("The parameter 'orderStatusTypeDescriptionFilter' cannot be null.");
        else if (orderStatusTypeDescriptionFilter !== undefined)
            url_ += "OrderStatusTypeDescriptionFilter=" + encodeURIComponent("" + orderStatusTypeDescriptionFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderNotificationForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderNotificationForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderNotificationForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderNotificationForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderNotificationForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderNotificationForView(id: number | undefined): Observable<GetOrderNotificationForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetOrderNotificationForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderNotificationForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderNotificationForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderNotificationForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderNotificationForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderNotificationForView(response: HttpResponseBase): Observable<GetOrderNotificationForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderNotificationForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderNotificationForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderNotificationForEdit(id: number | undefined): Observable<GetOrderNotificationForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetOrderNotificationForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderNotificationForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderNotificationForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderNotificationForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderNotificationForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderNotificationForEdit(response: HttpResponseBase): Observable<GetOrderNotificationForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderNotificationForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderNotificationForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrderNotificationDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param orderNotificationTemplateDescriptionFilter (optional) 
     * @param orderTypeDescriptionFilter (optional) 
     * @param smsTemplateDescriptionFilter (optional) 
     * @param orderStatusTypeDescriptionFilter (optional) 
     * @return Success
     */
    getOrderNotificationsToExcel(filter: string | undefined, codeFilter: string | undefined, isActiveFilter: number | undefined, descriptionFilter: string | undefined, orderNotificationTemplateDescriptionFilter: string | undefined, orderTypeDescriptionFilter: string | undefined, smsTemplateDescriptionFilter: string | undefined, orderStatusTypeDescriptionFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetOrderNotificationsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (orderNotificationTemplateDescriptionFilter === null)
            throw new Error("The parameter 'orderNotificationTemplateDescriptionFilter' cannot be null.");
        else if (orderNotificationTemplateDescriptionFilter !== undefined)
            url_ += "OrderNotificationTemplateDescriptionFilter=" + encodeURIComponent("" + orderNotificationTemplateDescriptionFilter) + "&"; 
        if (orderTypeDescriptionFilter === null)
            throw new Error("The parameter 'orderTypeDescriptionFilter' cannot be null.");
        else if (orderTypeDescriptionFilter !== undefined)
            url_ += "OrderTypeDescriptionFilter=" + encodeURIComponent("" + orderTypeDescriptionFilter) + "&"; 
        if (smsTemplateDescriptionFilter === null)
            throw new Error("The parameter 'smsTemplateDescriptionFilter' cannot be null.");
        else if (smsTemplateDescriptionFilter !== undefined)
            url_ += "SmsTemplateDescriptionFilter=" + encodeURIComponent("" + smsTemplateDescriptionFilter) + "&"; 
        if (orderStatusTypeDescriptionFilter === null)
            throw new Error("The parameter 'orderStatusTypeDescriptionFilter' cannot be null.");
        else if (orderStatusTypeDescriptionFilter !== undefined)
            url_ += "OrderStatusTypeDescriptionFilter=" + encodeURIComponent("" + orderStatusTypeDescriptionFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderNotificationsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderNotificationsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderNotificationsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrderNotificationTemplateForTableDropdown(): Observable<OrderNotificationOrderNotificationTemplateLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAllOrderNotificationTemplateForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderNotificationTemplateForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderNotificationTemplateForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<OrderNotificationOrderNotificationTemplateLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderNotificationOrderNotificationTemplateLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderNotificationTemplateForTableDropdown(response: HttpResponseBase): Observable<OrderNotificationOrderNotificationTemplateLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderNotificationOrderNotificationTemplateLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderNotificationOrderNotificationTemplateLookupTableDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllIncidentStatusForTableDropdown(): Observable<IncidentStatusListDropdown[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAllIncidentStatusForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllIncidentStatusForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllIncidentStatusForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<IncidentStatusListDropdown[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<IncidentStatusListDropdown[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllIncidentStatusForTableDropdown(response: HttpResponseBase): Observable<IncidentStatusListDropdown[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(IncidentStatusListDropdown.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<IncidentStatusListDropdown[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllDriverIncidentStatusForTableDropdown(): Observable<DriverIncidentDropDownList[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAllDriverIncidentStatusForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllDriverIncidentStatusForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllDriverIncidentStatusForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<DriverIncidentDropDownList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverIncidentDropDownList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllDriverIncidentStatusForTableDropdown(response: HttpResponseBase): Observable<DriverIncidentDropDownList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(DriverIncidentDropDownList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverIncidentDropDownList[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllEmployeeIncidentStatusForTableDropdown(): Observable<EmployeeIncidentDropDownList[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAllEmployeeIncidentStatusForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllEmployeeIncidentStatusForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllEmployeeIncidentStatusForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<EmployeeIncidentDropDownList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<EmployeeIncidentDropDownList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllEmployeeIncidentStatusForTableDropdown(response: HttpResponseBase): Observable<EmployeeIncidentDropDownList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(EmployeeIncidentDropDownList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<EmployeeIncidentDropDownList[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrderTypeForTableDropdown(): Observable<OrderNotificationOrderTypeLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAllOrderTypeForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderTypeForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderTypeForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<OrderNotificationOrderTypeLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderNotificationOrderTypeLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderTypeForTableDropdown(response: HttpResponseBase): Observable<OrderNotificationOrderTypeLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderNotificationOrderTypeLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderNotificationOrderTypeLookupTableDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllSmsTemplateForTableDropdown(): Observable<OrderNotificationSmsTemplateLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAllSmsTemplateForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSmsTemplateForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSmsTemplateForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<OrderNotificationSmsTemplateLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderNotificationSmsTemplateLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSmsTemplateForTableDropdown(response: HttpResponseBase): Observable<OrderNotificationSmsTemplateLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderNotificationSmsTemplateLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderNotificationSmsTemplateLookupTableDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrderStatusTypeForTableDropdown(): Observable<OrderNotificationOrderStatusTypeLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAllOrderStatusTypeForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderStatusTypeForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderStatusTypeForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<OrderNotificationOrderStatusTypeLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderNotificationOrderStatusTypeLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderStatusTypeForTableDropdown(response: HttpResponseBase): Observable<OrderNotificationOrderStatusTypeLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderNotificationOrderStatusTypeLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderNotificationOrderStatusTypeLookupTableDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllUserForTableDropdown(): Observable<UserListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAllUserForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllUserForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllUserForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<UserListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<UserListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllUserForTableDropdown(response: HttpResponseBase): Observable<UserListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(UserListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UserListDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrgUnitsForTableDropdown(): Observable<OrganizationUnitDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/GetAllOrgUnitsForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrgUnitsForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrgUnitsForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<OrganizationUnitDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrganizationUnitDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrgUnitsForTableDropdown(response: HttpResponseBase): Observable<OrganizationUnitDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrganizationUnitDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrganizationUnitDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendDriverIncidentNotification(body: EmployeeIncidentNotifInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/SendDriverIncidentNotification";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendDriverIncidentNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendDriverIncidentNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendDriverIncidentNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendEmployeeIncidentNotification(body: EmployeeIncidentNotifInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/SendEmployeeIncidentNotification";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendEmployeeIncidentNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendEmployeeIncidentNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendEmployeeIncidentNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendOrderIncidentNotification(body: OrderIncidentNotifInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/SendOrderIncidentNotification";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendOrderIncidentNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendOrderIncidentNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendOrderIncidentNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendOrderStatusNotification(body: OrgEmailInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/SendOrderStatusNotification";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendOrderStatusNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendOrderStatusNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendOrderStatusNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    notificationChecker(body: NotifCheckerInput | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/NotificationChecker";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processNotificationChecker(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processNotificationChecker(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processNotificationChecker(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    testNotification(body: TestNotificationInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/TestNotification";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTestNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTestNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processTestNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param routeId (optional) 
     * @param statusId (optional) 
     * @return Success
     */
    publishOrderStatusWebhooks(orderId: number | undefined, routeId: number | undefined, statusId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/PublishOrderStatusWebhooks?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "orderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        if (statusId === null)
            throw new Error("The parameter 'statusId' cannot be null.");
        else if (statusId !== undefined)
            url_ += "statusId=" + encodeURIComponent("" + statusId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPublishOrderStatusWebhooks(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPublishOrderStatusWebhooks(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processPublishOrderStatusWebhooks(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    orderInfo(orderId: number | undefined): Observable<OrderInfoDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/OrderInfo?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "orderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrderInfo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrderInfo(<any>response_);
                } catch (e) {
                    return <Observable<OrderInfoDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderInfoDto>><any>_observableThrow(response_);
        }));
    }

    protected processOrderInfo(response: HttpResponseBase): Observable<OrderInfoDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderInfoDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderInfoDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param statusId (optional) 
     * @return Success
     */
    urlStatusViaEndpoint(orderId: number | undefined, statusId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/UrlStatusViaEndpoint?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "orderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (statusId === null)
            throw new Error("The parameter 'statusId' cannot be null.");
        else if (statusId !== undefined)
            url_ += "statusId=" + encodeURIComponent("" + statusId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUrlStatusViaEndpoint(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUrlStatusViaEndpoint(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processUrlStatusViaEndpoint(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param trackingNumber (optional) 
     * @param brandPackageId (optional) 
     * @param brandorderId (optional) 
     * @return Success
     */
    updateTrackingViaEndpoint(trackingNumber: string | undefined, brandPackageId: string | undefined, brandorderId: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/UpdateTrackingViaEndpoint?";
        if (trackingNumber === null)
            throw new Error("The parameter 'trackingNumber' cannot be null.");
        else if (trackingNumber !== undefined)
            url_ += "trackingNumber=" + encodeURIComponent("" + trackingNumber) + "&"; 
        if (brandPackageId === null)
            throw new Error("The parameter 'brandPackageId' cannot be null.");
        else if (brandPackageId !== undefined)
            url_ += "brandPackageId=" + encodeURIComponent("" + brandPackageId) + "&"; 
        if (brandorderId === null)
            throw new Error("The parameter 'brandorderId' cannot be null.");
        else if (brandorderId !== undefined)
            url_ += "brandorderId=" + encodeURIComponent("" + brandorderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTrackingViaEndpoint(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTrackingViaEndpoint(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTrackingViaEndpoint(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setStatusViaWebhookForXcelerator(body: any | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/SetStatusViaWebhookForXcelerator";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetStatusViaWebhookForXcelerator(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetStatusViaWebhookForXcelerator(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processSetStatusViaWebhookForXcelerator(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param date (optional) 
     * @return Success
     */
    converToDateTime(date: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/ConverToDateTime?";
        if (date === null)
            throw new Error("The parameter 'date' cannot be null.");
        else if (date !== undefined)
            url_ += "date=" + encodeURIComponent("" + date) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConverToDateTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConverToDateTime(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processConverToDateTime(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setStatusViaWebhookForWithBond(body: any | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/SetStatusViaWebhookForWithBond";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetStatusViaWebhookForWithBond(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetStatusViaWebhookForWithBond(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processSetStatusViaWebhookForWithBond(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setTrackingViaWebhookForWithBond(body: any | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/SetTrackingViaWebhookForWithBond";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetTrackingViaWebhookForWithBond(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetTrackingViaWebhookForWithBond(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processSetTrackingViaWebhookForWithBond(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    routeInfo(routeId: number | undefined): Observable<LabInfo[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/RouteInfo?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRouteInfo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRouteInfo(<any>response_);
                } catch (e) {
                    return <Observable<LabInfo[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<LabInfo[]>><any>_observableThrow(response_);
        }));
    }

    protected processRouteInfo(response: HttpResponseBase): Observable<LabInfo[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(LabInfo.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<LabInfo[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    trackOrderWebHooks(body: GetOrderByIdAndTimeZoneInput | undefined): Observable<GetOrderDetailsView[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/TrackOrderWebHooks";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTrackOrderWebHooks(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTrackOrderWebHooks(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderDetailsView[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderDetailsView[]>><any>_observableThrow(response_);
        }));
    }

    protected processTrackOrderWebHooks(response: HttpResponseBase): Observable<GetOrderDetailsView[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetOrderDetailsView.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderDetailsView[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sMSUnsubscribeViaWebhooks(body: KeyValuePairOfStringString[] | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/SMSUnsubscribeViaWebhooks";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSMSUnsubscribeViaWebhooks(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSMSUnsubscribeViaWebhooks(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processSMSUnsubscribeViaWebhooks(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    resetLookupCache(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotifications/ResetLookupCache";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processResetLookupCache(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processResetLookupCache(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processResetLookupCache(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class OrderNotificationTemplatesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param isActiveFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param templateFilter (optional) 
     * @param codeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, isActiveFilter: number | undefined, descriptionFilter: string | undefined, templateFilter: string | undefined, codeFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderNotificationTemplateForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotificationTemplates/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (templateFilter === null)
            throw new Error("The parameter 'templateFilter' cannot be null.");
        else if (templateFilter !== undefined)
            url_ += "TemplateFilter=" + encodeURIComponent("" + templateFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderNotificationTemplateForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderNotificationTemplateForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderNotificationTemplateForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderNotificationTemplateForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderNotificationTemplateForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderNotificationTemplateForView(id: number | undefined): Observable<GetOrderNotificationTemplateForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotificationTemplates/GetOrderNotificationTemplateForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderNotificationTemplateForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderNotificationTemplateForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderNotificationTemplateForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderNotificationTemplateForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderNotificationTemplateForView(response: HttpResponseBase): Observable<GetOrderNotificationTemplateForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderNotificationTemplateForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderNotificationTemplateForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderNotificationTemplateForEdit(id: number | undefined): Observable<GetOrderNotificationTemplateForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotificationTemplates/GetOrderNotificationTemplateForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderNotificationTemplateForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderNotificationTemplateForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderNotificationTemplateForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderNotificationTemplateForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderNotificationTemplateForEdit(response: HttpResponseBase): Observable<GetOrderNotificationTemplateForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderNotificationTemplateForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderNotificationTemplateForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrderNotificationTemplateDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotificationTemplates/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotificationTemplates/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param isActiveFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param templateFilter (optional) 
     * @param codeFilter (optional) 
     * @return Success
     */
    getOrderNotificationTemplatesToExcel(filter: string | undefined, isActiveFilter: number | undefined, descriptionFilter: string | undefined, templateFilter: string | undefined, codeFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderNotificationTemplates/GetOrderNotificationTemplatesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (templateFilter === null)
            throw new Error("The parameter 'templateFilter' cannot be null.");
        else if (templateFilter !== undefined)
            url_ += "TemplateFilter=" + encodeURIComponent("" + templateFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderNotificationTemplatesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderNotificationTemplatesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderNotificationTemplatesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class OrderPackageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param orderId (optional) 
     * @param packageId (optional) 
     * @param quantity (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderPackage(id: number | undefined, orderId: number | undefined, packageId: number | undefined, quantity: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfOrderPackageListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackage/GetOrderPackage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (packageId === null)
            throw new Error("The parameter 'packageId' cannot be null.");
        else if (packageId !== undefined)
            url_ += "PackageId=" + encodeURIComponent("" + packageId) + "&"; 
        if (quantity === null)
            throw new Error("The parameter 'quantity' cannot be null.");
        else if (quantity !== undefined)
            url_ += "Quantity=" + encodeURIComponent("" + quantity) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderPackage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderPackage(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderPackageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderPackageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderPackage(response: HttpResponseBase): Observable<PagedResultDtoOfOrderPackageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderPackageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderPackageListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderPackage(body: CreateOrderPackageInput | undefined): Observable<OrderPackageListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackage/CreateOrderPackage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderPackage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderPackage(<any>response_);
                } catch (e) {
                    return <Observable<OrderPackageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderPackageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderPackage(response: HttpResponseBase): Observable<OrderPackageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderPackageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderPackageListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderPackage(body: UpdateOrderPackageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackage/UpdateOrderPackage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderPackage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderPackage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderPackage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteOrderPackage(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackage/DeleteOrderPackage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrderPackage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrderPackage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrderPackage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class OrderPackagesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param orderId (optional) 
     * @param packageId (optional) 
     * @param maxQuantityFilter (optional) 
     * @param minQuantityFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(id: number | undefined, filter: string | undefined, orderId: number | undefined, packageId: number | undefined, maxQuantityFilter: number | undefined, minQuantityFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrderPackageDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/GetAll?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (packageId === null)
            throw new Error("The parameter 'packageId' cannot be null.");
        else if (packageId !== undefined)
            url_ += "PackageId=" + encodeURIComponent("" + packageId) + "&"; 
        if (maxQuantityFilter === null)
            throw new Error("The parameter 'maxQuantityFilter' cannot be null.");
        else if (maxQuantityFilter !== undefined)
            url_ += "MaxQuantityFilter=" + encodeURIComponent("" + maxQuantityFilter) + "&"; 
        if (minQuantityFilter === null)
            throw new Error("The parameter 'minQuantityFilter' cannot be null.");
        else if (minQuantityFilter !== undefined)
            url_ += "MinQuantityFilter=" + encodeURIComponent("" + minQuantityFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderPackageDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderPackageDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfOrderPackageDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderPackageDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderPackageDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderPackageForView(id: number | undefined): Observable<GetOrderPackageForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/GetOrderPackageForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderPackageForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderPackageForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderPackageForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderPackageForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderPackageForView(response: HttpResponseBase): Observable<GetOrderPackageForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderPackageForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderPackageForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderPackageForEdit(id: number | undefined): Observable<GetOrderPackageForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/GetOrderPackageForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderPackageForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderPackageForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderPackageForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderPackageForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderPackageForEdit(response: HttpResponseBase): Observable<GetOrderPackageForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderPackageForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderPackageForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrderPackageDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param orderId (optional) 
     * @param packageId (optional) 
     * @param maxQuantityFilter (optional) 
     * @param minQuantityFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getOrderPackagesToExcel(id: number | undefined, filter: string | undefined, orderId: number | undefined, packageId: number | undefined, maxQuantityFilter: number | undefined, minQuantityFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/GetOrderPackagesToExcel?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (packageId === null)
            throw new Error("The parameter 'packageId' cannot be null.");
        else if (packageId !== undefined)
            url_ += "PackageId=" + encodeURIComponent("" + packageId) + "&"; 
        if (maxQuantityFilter === null)
            throw new Error("The parameter 'maxQuantityFilter' cannot be null.");
        else if (maxQuantityFilter !== undefined)
            url_ += "MaxQuantityFilter=" + encodeURIComponent("" + maxQuantityFilter) + "&"; 
        if (minQuantityFilter === null)
            throw new Error("The parameter 'minQuantityFilter' cannot be null.");
        else if (minQuantityFilter !== undefined)
            url_ += "MinQuantityFilter=" + encodeURIComponent("" + minQuantityFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderPackagesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderPackagesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderPackagesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param minutes (optional) 
     * @return Success
     */
    setOrderPackageBuildIntervalMinutes(minutes: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/SetOrderPackageBuildIntervalMinutes?";
        if (minutes === null)
            throw new Error("The parameter 'minutes' cannot be null.");
        else if (minutes !== undefined)
            url_ += "minutes=" + encodeURIComponent("" + minutes) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetOrderPackageBuildIntervalMinutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetOrderPackageBuildIntervalMinutes(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetOrderPackageBuildIntervalMinutes(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderPackageBuildIntervalMinutes(): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/GetOrderPackageBuildIntervalMinutes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderPackageBuildIntervalMinutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderPackageBuildIntervalMinutes(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderPackageBuildIntervalMinutes(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param size (optional) 
     * @return Success
     */
    setOrderPackageBuildChunk(size: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/SetOrderPackageBuildChunk?";
        if (size === null)
            throw new Error("The parameter 'size' cannot be null.");
        else if (size !== undefined)
            url_ += "size=" + encodeURIComponent("" + size) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetOrderPackageBuildChunk(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetOrderPackageBuildChunk(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetOrderPackageBuildChunk(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderPackageBuildChunk(): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/GetOrderPackageBuildChunk";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderPackageBuildChunk(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderPackageBuildChunk(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderPackageBuildChunk(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @return Success
     */
    startOrderPackageBuild(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderPackages/StartOrderPackageBuild";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processStartOrderPackageBuild(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processStartOrderPackageBuild(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processStartOrderPackageBuild(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class OrderSourceConnectionsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param orderSourceId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, orderSourceId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderSourceConnectionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceConnections/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderSourceConnectionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderSourceConnectionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderSourceConnectionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderSourceConnectionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderSourceConnectionForViewDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param orderSourceId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllConnections(filter: string | undefined, orderSourceId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderSourceConnectionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceConnections/GetAllConnections?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllConnections(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllConnections(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderSourceConnectionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderSourceConnectionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllConnections(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderSourceConnectionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderSourceConnectionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderSourceConnectionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderSourceConnectionForEdit(id: number | undefined): Observable<GetOrderSourceConnectionForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceConnections/GetOrderSourceConnectionForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderSourceConnectionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderSourceConnectionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderSourceConnectionForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderSourceConnectionForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderSourceConnectionForEdit(response: HttpResponseBase): Observable<GetOrderSourceConnectionForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderSourceConnectionForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderSourceConnectionForEditOutput>(<any>null);
    }

    /**
     * @param orderSourceId (optional) 
     * @param connectionId (optional) 
     * @return Success
     */
    getConnectionForEdit(orderSourceId: number | undefined, connectionId: number | undefined, connectionType: ConnectionType): Observable<GetOrderSourceConnectionForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceConnections/GetConnectionForEdit?";
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (connectionId === null)
            throw new Error("The parameter 'connectionId' cannot be null.");
        else if (connectionId !== undefined)
            url_ += "ConnectionId=" + encodeURIComponent("" + connectionId) + "&"; 
        if (connectionType === undefined || connectionType === null)
            throw new Error("The parameter 'connectionType' must be defined and cannot be null.");
        else
            url_ += "ConnectionType=" + encodeURIComponent("" + connectionType) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetConnectionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetConnectionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderSourceConnectionForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderSourceConnectionForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetConnectionForEdit(response: HttpResponseBase): Observable<GetOrderSourceConnectionForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderSourceConnectionForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderSourceConnectionForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrderSourceConnectionDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceConnections/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceConnections/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class OrderSourceManagerServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    processFromFtp(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceManager/ProcessFromFtp";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessFromFtp(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessFromFtp(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processProcessFromFtp(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateRoutesForTenant(body: Tenant | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceManager/GenerateRoutesForTenant";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateRoutesForTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateRoutesForTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateRoutesForTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param isHeaderFixed (optional) 
     * @param body (optional) 
     * @return Success
     */
    convertToSpreadsheet(isHeaderFixed: boolean | undefined, body: Blob | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceManager/ConvertToSpreadsheet?";
        if (isHeaderFixed === null)
            throw new Error("The parameter 'isHeaderFixed' cannot be null.");
        else if (isHeaderFixed !== undefined)
            url_ += "isHeaderFixed=" + encodeURIComponent("" + isHeaderFixed) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = body;

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "multipart/form-data", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertToSpreadsheet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertToSpreadsheet(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processConvertToSpreadsheet(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param code (optional) 
     * @param tenantdId (optional) 
     * @param fileName (optional) 
     * @param orderSourceId (optional) 
     * @param orderSourceFileId (optional) 
     * @param body (optional) 
     * @return Success
     */
    createOrderItems(code: string | undefined, tenantdId: number | undefined, fileName: string | undefined, orderSourceId: number | undefined, orderSourceFileId: number | undefined, body: OrderImportDto[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceManager/CreateOrderItems?";
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "code=" + encodeURIComponent("" + code) + "&"; 
        if (tenantdId === null)
            throw new Error("The parameter 'tenantdId' cannot be null.");
        else if (tenantdId !== undefined)
            url_ += "tenantdId=" + encodeURIComponent("" + tenantdId) + "&"; 
        if (fileName === null)
            throw new Error("The parameter 'fileName' cannot be null.");
        else if (fileName !== undefined)
            url_ += "fileName=" + encodeURIComponent("" + fileName) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "orderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (orderSourceFileId === null)
            throw new Error("The parameter 'orderSourceFileId' cannot be null.");
        else if (orderSourceFileId !== undefined)
            url_ += "orderSourceFileId=" + encodeURIComponent("" + orderSourceFileId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderItems(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderItems(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderItems(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    checkForFiles(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceManager/CheckForFiles";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckForFiles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckForFiles(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCheckForFiles(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param fileName (optional) 
     * @param body (optional) 
     * @return Success
     */
    sendNotif(fileName: string | undefined, body: LocationCountSuccess[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceManager/SendNotif?";
        if (fileName === null)
            throw new Error("The parameter 'fileName' cannot be null.");
        else if (fileName !== undefined)
            url_ += "fileName=" + encodeURIComponent("" + fileName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendNotif(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendNotif(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendNotif(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filename (optional) 
     * @return Success
     */
    getFileContent(filename: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderSourceManager/GetFileContent?";
        if (filename === null)
            throw new Error("The parameter 'filename' cannot be null.");
        else if (filename !== undefined)
            url_ += "filename=" + encodeURIComponent("" + filename) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFileContent(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFileContent(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetFileContent(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class OrderSourcesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param codeFilter (optional) 
     * @param maxIsActiveFilter (optional) 
     * @param minIsActiveFilter (optional) 
     * @param maxTenantIdFilter (optional) 
     * @param minTenantIdFilter (optional) 
     * @param orderTypeFilter (optional) 
     * @param zipRegEx (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, codeFilter: string | undefined, maxIsActiveFilter: number | undefined, minIsActiveFilter: number | undefined, maxTenantIdFilter: number | undefined, minTenantIdFilter: number | undefined, orderTypeFilter: number | undefined, zipRegEx: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderSourceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderSources/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (maxIsActiveFilter === null)
            throw new Error("The parameter 'maxIsActiveFilter' cannot be null.");
        else if (maxIsActiveFilter !== undefined)
            url_ += "MaxIsActiveFilter=" + encodeURIComponent("" + maxIsActiveFilter) + "&"; 
        if (minIsActiveFilter === null)
            throw new Error("The parameter 'minIsActiveFilter' cannot be null.");
        else if (minIsActiveFilter !== undefined)
            url_ += "MinIsActiveFilter=" + encodeURIComponent("" + minIsActiveFilter) + "&"; 
        if (maxTenantIdFilter === null)
            throw new Error("The parameter 'maxTenantIdFilter' cannot be null.");
        else if (maxTenantIdFilter !== undefined)
            url_ += "MaxTenantIdFilter=" + encodeURIComponent("" + maxTenantIdFilter) + "&"; 
        if (minTenantIdFilter === null)
            throw new Error("The parameter 'minTenantIdFilter' cannot be null.");
        else if (minTenantIdFilter !== undefined)
            url_ += "MinTenantIdFilter=" + encodeURIComponent("" + minTenantIdFilter) + "&"; 
        if (orderTypeFilter === null)
            throw new Error("The parameter 'orderTypeFilter' cannot be null.");
        else if (orderTypeFilter !== undefined)
            url_ += "OrderTypeFilter=" + encodeURIComponent("" + orderTypeFilter) + "&"; 
        if (zipRegEx === null)
            throw new Error("The parameter 'zipRegEx' cannot be null.");
        else if (zipRegEx !== undefined)
            url_ += "ZipRegEx=" + encodeURIComponent("" + zipRegEx) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderSourceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderSourceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderSourceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderSourceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderSourceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderSourceForView(id: number | undefined): Observable<GetOrderSourceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderSources/GetOrderSourceForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderSourceForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderSourceForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderSourceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderSourceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderSourceForView(response: HttpResponseBase): Observable<GetOrderSourceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderSourceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderSourceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderSourceForEdit(id: number | undefined): Observable<GetOrderSourceForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderSources/GetOrderSourceForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderSourceForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderSourceForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderSourceForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderSourceForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderSourceForEdit(response: HttpResponseBase): Observable<GetOrderSourceForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderSourceForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderSourceForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrderSourceDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderSources/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderSources/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param codeFilter (optional) 
     * @param maxIsActiveFilter (optional) 
     * @param minIsActiveFilter (optional) 
     * @param maxTenantIdFilter (optional) 
     * @param minTenantIdFilter (optional) 
     * @param orderTypeFilter (optional) 
     * @param zipRegEx (optional) 
     * @return Success
     */
    getOrderSourcesToExcel(filter: string | undefined, nameFilter: string | undefined, codeFilter: string | undefined, maxIsActiveFilter: number | undefined, minIsActiveFilter: number | undefined, maxTenantIdFilter: number | undefined, minTenantIdFilter: number | undefined, orderTypeFilter: number | undefined, zipRegEx: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderSources/GetOrderSourcesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (maxIsActiveFilter === null)
            throw new Error("The parameter 'maxIsActiveFilter' cannot be null.");
        else if (maxIsActiveFilter !== undefined)
            url_ += "MaxIsActiveFilter=" + encodeURIComponent("" + maxIsActiveFilter) + "&"; 
        if (minIsActiveFilter === null)
            throw new Error("The parameter 'minIsActiveFilter' cannot be null.");
        else if (minIsActiveFilter !== undefined)
            url_ += "MinIsActiveFilter=" + encodeURIComponent("" + minIsActiveFilter) + "&"; 
        if (maxTenantIdFilter === null)
            throw new Error("The parameter 'maxTenantIdFilter' cannot be null.");
        else if (maxTenantIdFilter !== undefined)
            url_ += "MaxTenantIdFilter=" + encodeURIComponent("" + maxTenantIdFilter) + "&"; 
        if (minTenantIdFilter === null)
            throw new Error("The parameter 'minTenantIdFilter' cannot be null.");
        else if (minTenantIdFilter !== undefined)
            url_ += "MinTenantIdFilter=" + encodeURIComponent("" + minTenantIdFilter) + "&"; 
        if (orderTypeFilter === null)
            throw new Error("The parameter 'orderTypeFilter' cannot be null.");
        else if (orderTypeFilter !== undefined)
            url_ += "OrderTypeFilter=" + encodeURIComponent("" + orderTypeFilter) + "&"; 
        if (zipRegEx === null)
            throw new Error("The parameter 'zipRegEx' cannot be null.");
        else if (zipRegEx !== undefined)
            url_ += "ZipRegEx=" + encodeURIComponent("" + zipRegEx) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderSourcesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderSourcesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderSourcesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param orderSourceId (optional) 
     * @return Success
     */
    orderSourceCode(orderSourceId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderSources/OrderSourceCode?";
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "orderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrderSourceCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrderSourceCode(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processOrderSourceCode(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderSources(): Observable<OrderSourceDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderSources/GetOrderSources";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderSources(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderSources(<any>response_);
                } catch (e) {
                    return <Observable<OrderSourceDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderSourceDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderSources(response: HttpResponseBase): Observable<OrderSourceDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderSourceDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderSourceDto[]>(<any>null);
    }
}

@Injectable()
export class OrderStatusServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param orderId (optional) 
     * @param geocodeId (optional) 
     * @param orderStatusTypeId (optional) 
     * @param noteId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderStatus(id: number | undefined, userId: number | undefined, orderId: number | undefined, geocodeId: number | undefined, orderStatusTypeId: number | undefined, noteId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfOrderStatusListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatus/GetOrderStatus?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (geocodeId === null)
            throw new Error("The parameter 'geocodeId' cannot be null.");
        else if (geocodeId !== undefined)
            url_ += "GeocodeId=" + encodeURIComponent("" + geocodeId) + "&"; 
        if (orderStatusTypeId === null)
            throw new Error("The parameter 'orderStatusTypeId' cannot be null.");
        else if (orderStatusTypeId !== undefined)
            url_ += "OrderStatusTypeId=" + encodeURIComponent("" + orderStatusTypeId) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderStatusListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderStatusListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatus(response: HttpResponseBase): Observable<PagedResultDtoOfOrderStatusListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderStatusListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderStatusListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param orderId (optional) 
     * @param geocodeId (optional) 
     * @param orderStatusDescriptionId (optional) 
     * @param noteId (optional) 
     * @param timeZoneInfo (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getGroupedOrderStatus(id: number | undefined, userId: number | undefined, orderId: number | undefined, geocodeId: number | undefined, orderStatusDescriptionId: number | undefined, noteId: number | undefined, timeZoneInfo: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrderStatusListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatus/GetGroupedOrderStatus?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (geocodeId === null)
            throw new Error("The parameter 'geocodeId' cannot be null.");
        else if (geocodeId !== undefined)
            url_ += "GeocodeId=" + encodeURIComponent("" + geocodeId) + "&"; 
        if (orderStatusDescriptionId === null)
            throw new Error("The parameter 'orderStatusDescriptionId' cannot be null.");
        else if (orderStatusDescriptionId !== undefined)
            url_ += "OrderStatusDescriptionId=" + encodeURIComponent("" + orderStatusDescriptionId) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (timeZoneInfo === null)
            throw new Error("The parameter 'timeZoneInfo' cannot be null.");
        else if (timeZoneInfo !== undefined)
            url_ += "TimeZoneInfo=" + encodeURIComponent("" + timeZoneInfo) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetGroupedOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetGroupedOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderStatusListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderStatusListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetGroupedOrderStatus(response: HttpResponseBase): Observable<PagedResultDtoOfOrderStatusListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderStatusListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderStatusListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderStatus(body: CreateOrderStatusInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatus/CreateOrderStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderStatus(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderStatus(body: UpdateOrderStatusInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatus/UpdateOrderStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteOrderStatus(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatus/DeleteOrderStatus?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrderStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param orderId (optional) 
     * @return Success
     */
    deleteOrderDetailStatus(id: number | undefined, orderId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatus/DeleteOrderDetailStatus?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrderDetailStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrderDetailStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrderDetailStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateCurrentOrderDetailStatus(body: UpdateStatusOrderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatus/UpdateCurrentOrderDetailStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateCurrentOrderDetailStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateCurrentOrderDetailStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateCurrentOrderDetailStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateCurrentOrderStatus(body: UpdateStatusOrderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatus/UpdateCurrentOrderStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateCurrentOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateCurrentOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateCurrentOrderStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param orderId (optional) 
     * @param geocodeId (optional) 
     * @param orderStatusDescriptionId (optional) 
     * @param noteId (optional) 
     * @param timeZoneInfo (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getGroupedOrderStatusTracking(id: number | undefined, userId: number | undefined, orderId: number | undefined, geocodeId: number | undefined, orderStatusDescriptionId: number | undefined, noteId: number | undefined, timeZoneInfo: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrderStatusListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatus/GetGroupedOrderStatusTracking?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (geocodeId === null)
            throw new Error("The parameter 'geocodeId' cannot be null.");
        else if (geocodeId !== undefined)
            url_ += "GeocodeId=" + encodeURIComponent("" + geocodeId) + "&"; 
        if (orderStatusDescriptionId === null)
            throw new Error("The parameter 'orderStatusDescriptionId' cannot be null.");
        else if (orderStatusDescriptionId !== undefined)
            url_ += "OrderStatusDescriptionId=" + encodeURIComponent("" + orderStatusDescriptionId) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (timeZoneInfo === null)
            throw new Error("The parameter 'timeZoneInfo' cannot be null.");
        else if (timeZoneInfo !== undefined)
            url_ += "TimeZoneInfo=" + encodeURIComponent("" + timeZoneInfo) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetGroupedOrderStatusTracking(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetGroupedOrderStatusTracking(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderStatusListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderStatusListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetGroupedOrderStatusTracking(response: HttpResponseBase): Observable<PagedResultDtoOfOrderStatusListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderStatusListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderStatusListDto>(<any>null);
    }
}

@Injectable()
export class OrderStatusAttachmentServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param orderId (optional) 
     * @param binaryObjectId (optional) 
     * @param fileName (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Returns the order status attachment.
     */
    getOrderStatusAttachment(id: number | undefined, orderId: number | undefined, binaryObjectId: string | undefined, fileName: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfOrderStatusAttachmentListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/GetOrderStatusAttachment?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (binaryObjectId === null)
            throw new Error("The parameter 'binaryObjectId' cannot be null.");
        else if (binaryObjectId !== undefined)
            url_ += "BinaryObjectId=" + encodeURIComponent("" + binaryObjectId) + "&"; 
        if (fileName === null)
            throw new Error("The parameter 'fileName' cannot be null.");
        else if (fileName !== undefined)
            url_ += "FileName=" + encodeURIComponent("" + fileName) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusAttachment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusAttachment(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfOrderStatusAttachmentListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfOrderStatusAttachmentListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusAttachment(response: HttpResponseBase): Observable<ListResultDtoOfOrderStatusAttachmentListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfOrderStatusAttachmentListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfOrderStatusAttachmentListDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param timeZone (optional) 
     * @return Returns the order status attachment.
     */
    getOrderStatusAttachmentList(orderId: number | undefined, timeZone: string | undefined): Observable<OrderStatusAttachmentListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/GetOrderStatusAttachmentList?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "orderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (timeZone === null)
            throw new Error("The parameter 'timeZone' cannot be null.");
        else if (timeZone !== undefined)
            url_ += "TimeZone=" + encodeURIComponent("" + timeZone) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusAttachmentList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusAttachmentList(<any>response_);
                } catch (e) {
                    return <Observable<OrderStatusAttachmentListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderStatusAttachmentListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusAttachmentList(response: HttpResponseBase): Observable<OrderStatusAttachmentListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderStatusAttachmentListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderStatusAttachmentListDto[]>(<any>null);
    }

    /**
     * @param pictureString (optional) 
     * @return Returns the order status attachment.
     */
    viewImageById(pictureString: string | undefined): Observable<OrderAttachmentImageDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/ViewImageById?";
        if (pictureString === null)
            throw new Error("The parameter 'pictureString' cannot be null.");
        else if (pictureString !== undefined)
            url_ += "pictureString=" + encodeURIComponent("" + pictureString) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processViewImageById(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processViewImageById(<any>response_);
                } catch (e) {
                    return <Observable<OrderAttachmentImageDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderAttachmentImageDto>><any>_observableThrow(response_);
        }));
    }

    protected processViewImageById(response: HttpResponseBase): Observable<OrderAttachmentImageDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderAttachmentImageDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderAttachmentImageDto>(<any>null);
    }

    /**
     * @param pictureString (optional) 
     * @return Returns the order status attachment.
     */
    getImageIdInternal(pictureString: string | undefined): Observable<OrderAttachmentImageDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/GetImageIdInternal?";
        if (pictureString === null)
            throw new Error("The parameter 'pictureString' cannot be null.");
        else if (pictureString !== undefined)
            url_ += "pictureString=" + encodeURIComponent("" + pictureString) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImageIdInternal(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImageIdInternal(<any>response_);
                } catch (e) {
                    return <Observable<OrderAttachmentImageDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderAttachmentImageDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImageIdInternal(response: HttpResponseBase): Observable<OrderAttachmentImageDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderAttachmentImageDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderAttachmentImageDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Returns the order status attachment.
     */
    createOrderStatusAttachment(body: CreateOrderStatusAttachmentInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/CreateOrderStatusAttachment";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderStatusAttachment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderStatusAttachment(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderStatusAttachment(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Returns the order status attachment.
     */
    updateOrderStatusAttachment(body: UpdateOrderStatusAttachmentInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/UpdateOrderStatusAttachment";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderStatusAttachment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderStatusAttachment(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderStatusAttachment(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Returns the order status attachment.
     */
    deleteOrderStatusAttachment(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/DeleteOrderStatusAttachment?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrderStatusAttachment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrderStatusAttachment(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrderStatusAttachment(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Returns the order status attachment.
     */
    getOrderStatusPhotos(orderId: number | undefined): Observable<ListResultDtoOfOrderStatusPhotoListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/GetOrderStatusPhotos?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusPhotos(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusPhotos(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfOrderStatusPhotoListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfOrderStatusPhotoListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusPhotos(response: HttpResponseBase): Observable<ListResultDtoOfOrderStatusPhotoListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfOrderStatusPhotoListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfOrderStatusPhotoListItemDto>(<any>null);
    }

    /**
     * @param orderStatusPhotoId (optional) 
     * @return Returns the order status attachment.
     */
    deleteOrderStatusPhoto(orderStatusPhotoId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/DeleteOrderStatusPhoto?";
        if (orderStatusPhotoId === null)
            throw new Error("The parameter 'orderStatusPhotoId' cannot be null.");
        else if (orderStatusPhotoId !== undefined)
            url_ += "OrderStatusPhotoId=" + encodeURIComponent("" + orderStatusPhotoId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrderStatusPhoto(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrderStatusPhoto(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrderStatusPhoto(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param photoContentId (optional) 
     * @return Returns the order status attachment.
     */
    getImageLink(photoContentId: number | undefined): Observable<ImageLinkItemDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusAttachment/GetImageLink?";
        if (photoContentId === null)
            throw new Error("The parameter 'photoContentId' cannot be null.");
        else if (photoContentId !== undefined)
            url_ += "PhotoContentId=" + encodeURIComponent("" + photoContentId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetImageLink(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetImageLink(<any>response_);
                } catch (e) {
                    return <Observable<ImageLinkItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ImageLinkItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetImageLink(response: HttpResponseBase): Observable<ImageLinkItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ImageLinkItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ImageLinkItemDto>(<any>null);
    }
}

@Injectable()
export class OrderStatusesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param userId (optional) 
     * @param orderId (optional) 
     * @param geocodeId (optional) 
     * @param orderStatusTypeId (optional) 
     * @param noteId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(id: number | undefined, filter: string | undefined, userId: number | undefined, orderId: number | undefined, geocodeId: number | undefined, orderStatusTypeId: number | undefined, noteId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrderStatusPagedListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatuses/GetAll?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (geocodeId === null)
            throw new Error("The parameter 'geocodeId' cannot be null.");
        else if (geocodeId !== undefined)
            url_ += "GeocodeId=" + encodeURIComponent("" + geocodeId) + "&"; 
        if (orderStatusTypeId === null)
            throw new Error("The parameter 'orderStatusTypeId' cannot be null.");
        else if (orderStatusTypeId !== undefined)
            url_ += "OrderStatusTypeId=" + encodeURIComponent("" + orderStatusTypeId) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderStatusPagedListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderStatusPagedListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfOrderStatusPagedListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderStatusPagedListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderStatusPagedListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderStatusForView(id: number | undefined): Observable<GetOrderStatusForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatuses/GetOrderStatusForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderStatusForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderStatusForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusForView(response: HttpResponseBase): Observable<GetOrderStatusForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderStatusForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderStatusForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderStatusForEdit(id: number | undefined): Observable<GetOrderStatusForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatuses/GetOrderStatusForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderStatusForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderStatusForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusForEdit(response: HttpResponseBase): Observable<GetOrderStatusForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderStatusForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderStatusForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrderStatusDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatuses/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatuses/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param userId (optional) 
     * @param orderId (optional) 
     * @param geocodeId (optional) 
     * @param orderStatusTypeId (optional) 
     * @param noteId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getOrderStatusesToExcel(id: number | undefined, filter: string | undefined, userId: number | undefined, orderId: number | undefined, geocodeId: number | undefined, orderStatusTypeId: number | undefined, noteId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatuses/GetOrderStatusesToExcel?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (geocodeId === null)
            throw new Error("The parameter 'geocodeId' cannot be null.");
        else if (geocodeId !== undefined)
            url_ += "GeocodeId=" + encodeURIComponent("" + geocodeId) + "&"; 
        if (orderStatusTypeId === null)
            throw new Error("The parameter 'orderStatusTypeId' cannot be null.");
        else if (orderStatusTypeId !== undefined)
            url_ += "OrderStatusTypeId=" + encodeURIComponent("" + orderStatusTypeId) + "&"; 
        if (noteId === null)
            throw new Error("The parameter 'noteId' cannot be null.");
        else if (noteId !== undefined)
            url_ += "NoteId=" + encodeURIComponent("" + noteId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class OrderStatusMappingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param orderSourceId (optional) 
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param orderStatusDescriptionNameFilter (optional) 
     * @param orderSourceNameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(orderSourceId: number | undefined, filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, orderStatusDescriptionNameFilter: string | undefined, orderSourceNameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderStatusMappingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusMappings/GetAll?";
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (orderStatusDescriptionNameFilter === null)
            throw new Error("The parameter 'orderStatusDescriptionNameFilter' cannot be null.");
        else if (orderStatusDescriptionNameFilter !== undefined)
            url_ += "OrderStatusDescriptionNameFilter=" + encodeURIComponent("" + orderStatusDescriptionNameFilter) + "&"; 
        if (orderSourceNameFilter === null)
            throw new Error("The parameter 'orderSourceNameFilter' cannot be null.");
        else if (orderSourceNameFilter !== undefined)
            url_ += "OrderSourceNameFilter=" + encodeURIComponent("" + orderSourceNameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderStatusMappingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderStatusMappingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderStatusMappingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderStatusMappingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderStatusMappingForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderStatusMappingForView(id: number | undefined): Observable<GetOrderStatusMappingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusMappings/GetOrderStatusMappingForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusMappingForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusMappingForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderStatusMappingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderStatusMappingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusMappingForView(response: HttpResponseBase): Observable<GetOrderStatusMappingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderStatusMappingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderStatusMappingForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderStatusMappingForEdit(id: number | undefined): Observable<GetOrderStatusMappingForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusMappings/GetOrderStatusMappingForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusMappingForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusMappingForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderStatusMappingForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderStatusMappingForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusMappingForEdit(response: HttpResponseBase): Observable<GetOrderStatusMappingForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderStatusMappingForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderStatusMappingForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrderStatusMappingDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusMappings/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusMappings/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param orderStatusDescriptionNameFilter (optional) 
     * @param orderSourceNameFilter (optional) 
     * @return Success
     */
    getOrderStatusMappingsToExcel(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, orderStatusDescriptionNameFilter: string | undefined, orderSourceNameFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusMappings/GetOrderStatusMappingsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (orderStatusDescriptionNameFilter === null)
            throw new Error("The parameter 'orderStatusDescriptionNameFilter' cannot be null.");
        else if (orderStatusDescriptionNameFilter !== undefined)
            url_ += "OrderStatusDescriptionNameFilter=" + encodeURIComponent("" + orderStatusDescriptionNameFilter) + "&"; 
        if (orderSourceNameFilter === null)
            throw new Error("The parameter 'orderSourceNameFilter' cannot be null.");
        else if (orderSourceNameFilter !== undefined)
            url_ += "OrderSourceNameFilter=" + encodeURIComponent("" + orderSourceNameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusMappingsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusMappingsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusMappingsToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrderStatusDescriptionForTableDropdown(): Observable<OrderStatusMappingOrderStatusDescriptionLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusMappings/GetAllOrderStatusDescriptionForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderStatusDescriptionForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderStatusDescriptionForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<OrderStatusMappingOrderStatusDescriptionLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderStatusMappingOrderStatusDescriptionLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderStatusDescriptionForTableDropdown(response: HttpResponseBase): Observable<OrderStatusMappingOrderStatusDescriptionLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderStatusMappingOrderStatusDescriptionLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderStatusMappingOrderStatusDescriptionLookupTableDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrderSourceForTableDropdown(): Observable<OrderStatusMappingOrderSourceLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusMappings/GetAllOrderSourceForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderSourceForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderSourceForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<OrderStatusMappingOrderSourceLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderStatusMappingOrderSourceLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderSourceForTableDropdown(response: HttpResponseBase): Observable<OrderStatusMappingOrderSourceLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderStatusMappingOrderSourceLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderStatusMappingOrderSourceLookupTableDto[]>(<any>null);
    }
}

@Injectable()
export class OrderStatusTypeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderStatusTypeChild(body: CreateOrderStatusTypeInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusType/CreateOrderStatusTypeChild";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderStatusTypeChild(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderStatusTypeChild(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderStatusTypeChild(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderStatusTypeParent(body: CreateOrderStatusTypeInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusType/CreateOrderStatusTypeParent";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderStatusTypeParent(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderStatusTypeParent(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderStatusTypeParent(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderStatusType(body: UpdateOrderStatusTypeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusType/UpdateOrderStatusType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderStatusType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderStatusType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderStatusType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteOrderStatusType(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusType/DeleteOrderStatusType?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrderStatusType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrderStatusType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrderStatusType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param code (optional) 
     * @param description (optional) 
     * @param sortOrder (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderStatusType(id: number | undefined, code: string | undefined, description: string | undefined, sortOrder: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfOrderStatusTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusType/GetOrderStatusType?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        if (description === null)
            throw new Error("The parameter 'description' cannot be null.");
        else if (description !== undefined)
            url_ += "Description=" + encodeURIComponent("" + description) + "&"; 
        if (sortOrder === null)
            throw new Error("The parameter 'sortOrder' cannot be null.");
        else if (sortOrder !== undefined)
            url_ += "SortOrder=" + encodeURIComponent("" + sortOrder) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusType(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderStatusTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderStatusTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusType(response: HttpResponseBase): Observable<PagedResultDtoOfOrderStatusTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderStatusTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderStatusTypeListDto>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderStatusTypeAll(): Observable<ListResultDtoOfOrderStatusTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusType/GetOrderStatusTypeAll";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusTypeAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusTypeAll(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfOrderStatusTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfOrderStatusTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusTypeAll(response: HttpResponseBase): Observable<ListResultDtoOfOrderStatusTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfOrderStatusTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfOrderStatusTypeListDto>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderStatusTypeChild(): Observable<ListResultDtoOfOrderStatusTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusType/GetOrderStatusTypeChild";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusTypeChild(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusTypeChild(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfOrderStatusTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfOrderStatusTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusTypeChild(response: HttpResponseBase): Observable<ListResultDtoOfOrderStatusTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfOrderStatusTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfOrderStatusTypeListDto>(<any>null);
    }

    /**
     * @param statusTypeId (optional) 
     * @return Success
     */
    statusTypeCode(statusTypeId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusType/StatusTypeCode?";
        if (statusTypeId === null)
            throw new Error("The parameter 'statusTypeId' cannot be null.");
        else if (statusTypeId !== undefined)
            url_ += "statusTypeId=" + encodeURIComponent("" + statusTypeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processStatusTypeCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processStatusTypeCode(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processStatusTypeCode(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class OrderStatusTypeDescriptionServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderStatusTypeDescription(body: CreateOrderStatusTypeDescriptionInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypeDescription/CreateOrderStatusTypeDescription";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderStatusTypeDescription(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderStatusTypeDescription(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderStatusTypeDescription(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderStatusTypeDescriptionChild(body: CreateOrderStatusTypeDescriptionInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypeDescription/CreateOrderStatusTypeDescriptionChild";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderStatusTypeDescriptionChild(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderStatusTypeDescriptionChild(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderStatusTypeDescriptionChild(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderStatusTypeDescription(body: UpdateOrderStatusTypeDescriptionInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypeDescription/UpdateOrderStatusTypeDescription";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderStatusTypeDescription(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderStatusTypeDescription(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderStatusTypeDescription(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sortOrderStatusDescription(body: SortOrderStatusDescription | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypeDescription/SortOrderStatusDescription";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSortOrderStatusDescription(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSortOrderStatusDescription(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSortOrderStatusDescription(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteOrderStatusTypeDescription(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypeDescription/DeleteOrderStatusTypeDescription?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrderStatusTypeDescription(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrderStatusTypeDescription(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrderStatusTypeDescription(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param orderStatusTypeId (optional) 
     * @param description (optional) 
     * @param name (optional) 
     * @param sortOrder (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderStatusTypeDescription(id: number | undefined, orderStatusTypeId: number | undefined, description: string | undefined, name: string | undefined, sortOrder: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfOrderStatusTypeDescriptionListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypeDescription/GetOrderStatusTypeDescription?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (orderStatusTypeId === null)
            throw new Error("The parameter 'orderStatusTypeId' cannot be null.");
        else if (orderStatusTypeId !== undefined)
            url_ += "OrderStatusTypeId=" + encodeURIComponent("" + orderStatusTypeId) + "&"; 
        if (description === null)
            throw new Error("The parameter 'description' cannot be null.");
        else if (description !== undefined)
            url_ += "Description=" + encodeURIComponent("" + description) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (sortOrder === null)
            throw new Error("The parameter 'sortOrder' cannot be null.");
        else if (sortOrder !== undefined)
            url_ += "SortOrder=" + encodeURIComponent("" + sortOrder) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusTypeDescription(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusTypeDescription(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderStatusTypeDescriptionListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderStatusTypeDescriptionListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusTypeDescription(response: HttpResponseBase): Observable<PagedResultDtoOfOrderStatusTypeDescriptionListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderStatusTypeDescriptionListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderStatusTypeDescriptionListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getParentStatus(id: number | undefined): Observable<OrderStatusTypeDescriptionListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypeDescription/GetParentStatus?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetParentStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetParentStatus(<any>response_);
                } catch (e) {
                    return <Observable<OrderStatusTypeDescriptionListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderStatusTypeDescriptionListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetParentStatus(response: HttpResponseBase): Observable<OrderStatusTypeDescriptionListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrderStatusTypeDescriptionListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderStatusTypeDescriptionListDto>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderStatusTypeDescriptions(): Observable<ListResultDtoOfOrderStatusTypeDescriptionListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypeDescription/GetOrderStatusTypeDescriptions";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusTypeDescriptions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusTypeDescriptions(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfOrderStatusTypeDescriptionListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfOrderStatusTypeDescriptionListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusTypeDescriptions(response: HttpResponseBase): Observable<ListResultDtoOfOrderStatusTypeDescriptionListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfOrderStatusTypeDescriptionListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfOrderStatusTypeDescriptionListDto>(<any>null);
    }
}

@Injectable()
export class OrderStatusTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param maxSortOrderFilter (optional) 
     * @param minSortOrderFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, maxSortOrderFilter: number | undefined, minSortOrderFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderStatusTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (maxSortOrderFilter === null)
            throw new Error("The parameter 'maxSortOrderFilter' cannot be null.");
        else if (maxSortOrderFilter !== undefined)
            url_ += "MaxSortOrderFilter=" + encodeURIComponent("" + maxSortOrderFilter) + "&"; 
        if (minSortOrderFilter === null)
            throw new Error("The parameter 'minSortOrderFilter' cannot be null.");
        else if (minSortOrderFilter !== undefined)
            url_ += "MinSortOrderFilter=" + encodeURIComponent("" + minSortOrderFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderStatusTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderStatusTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderStatusTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderStatusTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderStatusTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderStatusTypeForView(id: number | undefined): Observable<GetOrderStatusTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypes/GetOrderStatusTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderStatusTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderStatusTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusTypeForView(response: HttpResponseBase): Observable<GetOrderStatusTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderStatusTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderStatusTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderStatusTypeForEdit(id: number | undefined): Observable<GetOrderStatusTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypes/GetOrderStatusTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderStatusTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderStatusTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusTypeForEdit(response: HttpResponseBase): Observable<GetOrderStatusTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderStatusTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderStatusTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrderStatusTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param maxSortOrderFilter (optional) 
     * @param minSortOrderFilter (optional) 
     * @return Success
     */
    getOrderStatusTypesToExcel(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, maxSortOrderFilter: number | undefined, minSortOrderFilter: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderStatusTypes/GetOrderStatusTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (maxSortOrderFilter === null)
            throw new Error("The parameter 'maxSortOrderFilter' cannot be null.");
        else if (maxSortOrderFilter !== undefined)
            url_ += "MaxSortOrderFilter=" + encodeURIComponent("" + maxSortOrderFilter) + "&"; 
        if (minSortOrderFilter === null)
            throw new Error("The parameter 'minSortOrderFilter' cannot be null.");
        else if (minSortOrderFilter !== undefined)
            url_ += "MinSortOrderFilter=" + encodeURIComponent("" + minSortOrderFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusTypesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class OrderTagServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param tagId (optional) 
     * @param orderId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderTag(id: number | undefined, tagId: number | undefined, orderId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfOrderTagListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderTag/GetOrderTag?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (tagId === null)
            throw new Error("The parameter 'tagId' cannot be null.");
        else if (tagId !== undefined)
            url_ += "TagId=" + encodeURIComponent("" + tagId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderTag(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderTag(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrderTagListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrderTagListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderTag(response: HttpResponseBase): Observable<PagedResultDtoOfOrderTagListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrderTagListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrderTagListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrderTag(body: CreateOrderTagInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/OrderTag/CreateOrderTag";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderTag(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderTag(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderTag(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderTag(body: UpdateOrderTagInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderTag/UpdateOrderTag";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderTag(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderTag(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderTag(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteOrderTag(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderTag/DeleteOrderTag?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrderTag(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrderTag(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrderTag(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class OrderTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param colorFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, isActiveFilter: number | undefined, colorFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrderTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderTypeForView(id: number | undefined): Observable<GetOrderTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderTypes/GetOrderTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderTypeForView(response: HttpResponseBase): Observable<GetOrderTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrderTypeForEdit(id: number | undefined): Observable<GetOrderTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrderTypes/GetOrderTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderTypeForEdit(response: HttpResponseBase): Observable<GetOrderTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrderTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrderTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrderTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param colorFilter (optional) 
     * @return Success
     */
    getOrderTypesToExcel(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, isActiveFilter: number | undefined, colorFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/OrderTypes/GetOrderTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderTypesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrderTypeForTableDropdown(): Observable<GetOrderTypeForViewDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderTypes/GetAllOrderTypeForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderTypeForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderTypeForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderTypeForViewDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderTypeForViewDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderTypeForTableDropdown(response: HttpResponseBase): Observable<GetOrderTypeForViewDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetOrderTypeForViewDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderTypeForViewDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getOrderTypes(): Observable<GetOrderTypeForViewDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderTypes/GetOrderTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderTypes(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderTypeForViewDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderTypeForViewDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderTypes(response: HttpResponseBase): Observable<GetOrderTypeForViewDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetOrderTypeForViewDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderTypeForViewDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getXceleratorOrderTypes(): Observable<GetOrderTypeForViewDto[]> {
        let url_ = this.baseUrl + "/api/services/app/OrderTypes/GetXceleratorOrderTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetXceleratorOrderTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetXceleratorOrderTypes(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderTypeForViewDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderTypeForViewDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetXceleratorOrderTypes(response: HttpResponseBase): Observable<GetOrderTypeForViewDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetOrderTypeForViewDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderTypeForViewDto[]>(<any>null);
    }
}

@Injectable()
export class OrganizationUnitServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getOrganizationUnits(): Observable<ListResultDtoOfOrganizationUnitDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/GetOrganizationUnits";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrganizationUnits(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrganizationUnits(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfOrganizationUnitDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfOrganizationUnitDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrganizationUnits(response: HttpResponseBase): Observable<ListResultDtoOfOrganizationUnitDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfOrganizationUnitDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfOrganizationUnitDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrganizationUnitUsers(id: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfOrganizationUnitUserListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/GetOrganizationUnitUsers?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrganizationUnitUsers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrganizationUnitUsers(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrganizationUnitUserListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrganizationUnitUserListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrganizationUnitUsers(response: HttpResponseBase): Observable<PagedResultDtoOfOrganizationUnitUserListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrganizationUnitUserListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrganizationUnitUserListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrganizationUnitRoles(id: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfOrganizationUnitRoleListDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/GetOrganizationUnitRoles?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrganizationUnitRoles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrganizationUnitRoles(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrganizationUnitRoleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrganizationUnitRoleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrganizationUnitRoles(response: HttpResponseBase): Observable<PagedResultDtoOfOrganizationUnitRoleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrganizationUnitRoleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrganizationUnitRoleListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrganizationUnit(body: CreateOrganizationUnitInput | undefined): Observable<OrganizationUnitDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/CreateOrganizationUnit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrganizationUnit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrganizationUnit(<any>response_);
                } catch (e) {
                    return <Observable<OrganizationUnitDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrganizationUnitDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrganizationUnit(response: HttpResponseBase): Observable<OrganizationUnitDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrganizationUnitDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrganizationUnitDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrganizationUnit(body: UpdateOrganizationUnitInput | undefined): Observable<OrganizationUnitDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/UpdateOrganizationUnit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrganizationUnit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrganizationUnit(<any>response_);
                } catch (e) {
                    return <Observable<OrganizationUnitDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrganizationUnitDto>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrganizationUnit(response: HttpResponseBase): Observable<OrganizationUnitDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrganizationUnitDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrganizationUnitDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    moveOrganizationUnit(body: MoveOrganizationUnitInput | undefined): Observable<OrganizationUnitDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/MoveOrganizationUnit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMoveOrganizationUnit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMoveOrganizationUnit(<any>response_);
                } catch (e) {
                    return <Observable<OrganizationUnitDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrganizationUnitDto>><any>_observableThrow(response_);
        }));
    }

    protected processMoveOrganizationUnit(response: HttpResponseBase): Observable<OrganizationUnitDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = OrganizationUnitDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrganizationUnitDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteOrganizationUnit(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/DeleteOrganizationUnit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteOrganizationUnit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteOrganizationUnit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteOrganizationUnit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param userId (optional) 
     * @param organizationUnitId (optional) 
     * @return Success
     */
    removeUserFromOrganizationUnit(userId: number | undefined, organizationUnitId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/RemoveUserFromOrganizationUnit?";
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (organizationUnitId === null)
            throw new Error("The parameter 'organizationUnitId' cannot be null.");
        else if (organizationUnitId !== undefined)
            url_ += "OrganizationUnitId=" + encodeURIComponent("" + organizationUnitId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRemoveUserFromOrganizationUnit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRemoveUserFromOrganizationUnit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRemoveUserFromOrganizationUnit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param roleId (optional) 
     * @param organizationUnitId (optional) 
     * @return Success
     */
    removeRoleFromOrganizationUnit(roleId: number | undefined, organizationUnitId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/RemoveRoleFromOrganizationUnit?";
        if (roleId === null)
            throw new Error("The parameter 'roleId' cannot be null.");
        else if (roleId !== undefined)
            url_ += "RoleId=" + encodeURIComponent("" + roleId) + "&"; 
        if (organizationUnitId === null)
            throw new Error("The parameter 'organizationUnitId' cannot be null.");
        else if (organizationUnitId !== undefined)
            url_ += "OrganizationUnitId=" + encodeURIComponent("" + organizationUnitId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRemoveRoleFromOrganizationUnit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRemoveRoleFromOrganizationUnit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRemoveRoleFromOrganizationUnit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addUsersToOrganizationUnit(body: UsersToOrganizationUnitInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/AddUsersToOrganizationUnit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddUsersToOrganizationUnit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddUsersToOrganizationUnit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddUsersToOrganizationUnit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addRolesToOrganizationUnit(body: RolesToOrganizationUnitInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/AddRolesToOrganizationUnit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddRolesToOrganizationUnit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddRolesToOrganizationUnit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddRolesToOrganizationUnit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    findUsers(body: FindOrganizationUnitUsersInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/FindUsers";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processFindUsers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processFindUsers(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processFindUsers(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    findRoles(body: FindOrganizationUnitRolesInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnit/FindRoles";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processFindRoles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processFindRoles(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processFindRoles(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class OrganizationUnitOrderNotificationsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param isEmailFilter (optional) 
     * @param isSMSFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param emailAddressFilter (optional) 
     * @param phoneNumberFilter (optional) 
     * @param codeFilter (optional) 
     * @param organizationUnitDisplayNameFilter (optional) 
     * @param orderNotificationOrderNotificationTemplateIdFilter (optional) 
     * @param userNameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, isEmailFilter: number | undefined, isSMSFilter: number | undefined, isActiveFilter: number | undefined, emailAddressFilter: string | undefined, phoneNumberFilter: string | undefined, codeFilter: string | undefined, organizationUnitDisplayNameFilter: string | undefined, orderNotificationOrderNotificationTemplateIdFilter: string | undefined, userNameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnitOrderNotifications/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (isEmailFilter === null)
            throw new Error("The parameter 'isEmailFilter' cannot be null.");
        else if (isEmailFilter !== undefined)
            url_ += "IsEmailFilter=" + encodeURIComponent("" + isEmailFilter) + "&"; 
        if (isSMSFilter === null)
            throw new Error("The parameter 'isSMSFilter' cannot be null.");
        else if (isSMSFilter !== undefined)
            url_ += "IsSMSFilter=" + encodeURIComponent("" + isSMSFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (emailAddressFilter === null)
            throw new Error("The parameter 'emailAddressFilter' cannot be null.");
        else if (emailAddressFilter !== undefined)
            url_ += "EmailAddressFilter=" + encodeURIComponent("" + emailAddressFilter) + "&"; 
        if (phoneNumberFilter === null)
            throw new Error("The parameter 'phoneNumberFilter' cannot be null.");
        else if (phoneNumberFilter !== undefined)
            url_ += "PhoneNumberFilter=" + encodeURIComponent("" + phoneNumberFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (organizationUnitDisplayNameFilter === null)
            throw new Error("The parameter 'organizationUnitDisplayNameFilter' cannot be null.");
        else if (organizationUnitDisplayNameFilter !== undefined)
            url_ += "OrganizationUnitDisplayNameFilter=" + encodeURIComponent("" + organizationUnitDisplayNameFilter) + "&"; 
        if (orderNotificationOrderNotificationTemplateIdFilter === null)
            throw new Error("The parameter 'orderNotificationOrderNotificationTemplateIdFilter' cannot be null.");
        else if (orderNotificationOrderNotificationTemplateIdFilter !== undefined)
            url_ += "OrderNotificationOrderNotificationTemplateIdFilter=" + encodeURIComponent("" + orderNotificationOrderNotificationTemplateIdFilter) + "&"; 
        if (userNameFilter === null)
            throw new Error("The parameter 'userNameFilter' cannot be null.");
        else if (userNameFilter !== undefined)
            url_ += "UserNameFilter=" + encodeURIComponent("" + userNameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrganizationUnitOrderNotificationForView(id: number | undefined): Observable<GetOrganizationUnitOrderNotificationForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnitOrderNotifications/GetOrganizationUnitOrderNotificationForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrganizationUnitOrderNotificationForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrganizationUnitOrderNotificationForView(<any>response_);
                } catch (e) {
                    return <Observable<GetOrganizationUnitOrderNotificationForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrganizationUnitOrderNotificationForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrganizationUnitOrderNotificationForView(response: HttpResponseBase): Observable<GetOrganizationUnitOrderNotificationForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrganizationUnitOrderNotificationForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrganizationUnitOrderNotificationForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOrganizationUnitOrderNotificationForEdit(id: number | undefined): Observable<GetOrganizationUnitOrderNotificationForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnitOrderNotifications/GetOrganizationUnitOrderNotificationForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrganizationUnitOrderNotificationForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrganizationUnitOrderNotificationForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetOrganizationUnitOrderNotificationForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrganizationUnitOrderNotificationForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrganizationUnitOrderNotificationForEdit(response: HttpResponseBase): Observable<GetOrganizationUnitOrderNotificationForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetOrganizationUnitOrderNotificationForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrganizationUnitOrderNotificationForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditOrganizationUnitOrderNotificationDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnitOrderNotifications/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnitOrderNotifications/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllOrganizationUnitForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnitOrderNotifications/GetAllOrganizationUnitForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrganizationUnitForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrganizationUnitForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrganizationUnitForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllOrderNotificationForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnitOrderNotifications/GetAllOrderNotificationForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderNotificationForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderNotificationForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderNotificationForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllUserForLookupTable(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/OrganizationUnitOrderNotifications/GetAllUserForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllUserForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllUserForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllUserForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto>(<any>null);
    }
}

@Injectable()
export class PackageOptionsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param packageName (optional) 
     * @param code (optional) 
     * @param key (optional) 
     * @param value (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAllPackageOptions(id: number | undefined, filter: string | undefined, packageName: string | undefined, code: string | undefined, key: string | undefined, value: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfPackageOptionsListDto> {
        let url_ = this.baseUrl + "/api/services/app/PackageOptions/GetAllPackageOptions?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (packageName === null)
            throw new Error("The parameter 'packageName' cannot be null.");
        else if (packageName !== undefined)
            url_ += "PackageName=" + encodeURIComponent("" + packageName) + "&"; 
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        if (key === null)
            throw new Error("The parameter 'key' cannot be null.");
        else if (key !== undefined)
            url_ += "Key=" + encodeURIComponent("" + key) + "&"; 
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllPackageOptions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllPackageOptions(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfPackageOptionsListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfPackageOptionsListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllPackageOptions(response: HttpResponseBase): Observable<PagedResultDtoOfPackageOptionsListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfPackageOptionsListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfPackageOptionsListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deletePackageOption(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PackageOptions/DeletePackageOption?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeletePackageOption(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeletePackageOption(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeletePackageOption(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditPackageOptionsDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PackageOptions/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createPackageOptions(body: CreatePackageOptionsDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/PackageOptions/CreatePackageOptions";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreatePackageOptions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreatePackageOptions(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreatePackageOptions(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updatePackageOptions(body: CreateOrEditPackageOptionsDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PackageOptions/UpdatePackageOptions";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdatePackageOptions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdatePackageOptions(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdatePackageOptions(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param packageNameFilter (optional) 
     * @param codeFilter (optional) 
     * @param keyFilter (optional) 
     * @param valueFilter (optional) 
     * @return Success
     */
    getPackageOptionsToExcel(filter: string | undefined, packageNameFilter: string | undefined, codeFilter: string | undefined, keyFilter: string | undefined, valueFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/PackageOptions/GetPackageOptionsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (packageNameFilter === null)
            throw new Error("The parameter 'packageNameFilter' cannot be null.");
        else if (packageNameFilter !== undefined)
            url_ += "PackageNameFilter=" + encodeURIComponent("" + packageNameFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (keyFilter === null)
            throw new Error("The parameter 'keyFilter' cannot be null.");
        else if (keyFilter !== undefined)
            url_ += "KeyFilter=" + encodeURIComponent("" + keyFilter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPackageOptionsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPackageOptionsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPackageOptionsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class PackagesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param price (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, price: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetPackageForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Packages/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (price === null)
            throw new Error("The parameter 'price' cannot be null.");
        else if (price !== undefined)
            url_ += "Price=" + encodeURIComponent("" + price) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetPackageForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetPackageForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetPackageForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetPackageForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetPackageForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getPackageForView(id: number | undefined): Observable<GetPackageForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Packages/GetPackageForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPackageForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPackageForView(<any>response_);
                } catch (e) {
                    return <Observable<GetPackageForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetPackageForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPackageForView(response: HttpResponseBase): Observable<GetPackageForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetPackageForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetPackageForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getPackageForEdit(id: number | undefined): Observable<GetPackageForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Packages/GetPackageForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPackageForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPackageForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetPackageForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetPackageForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetPackageForEdit(response: HttpResponseBase): Observable<GetPackageForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetPackageForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetPackageForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditPackageDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Packages/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Packages/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param price (optional) 
     * @return Success
     */
    getPackagesToExcel(filter: string | undefined, nameFilter: string | undefined, price: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Packages/GetPackagesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (price === null)
            throw new Error("The parameter 'price' cannot be null.");
        else if (price !== undefined)
            url_ += "Price=" + encodeURIComponent("" + price) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPackagesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPackagesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPackagesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class PaymentServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param upgradeEditionId (optional) 
     * @return Success
     */
    getPaymentInfo(upgradeEditionId: number | undefined): Observable<PaymentInfoDto> {
        let url_ = this.baseUrl + "/api/services/app/Payment/GetPaymentInfo?";
        if (upgradeEditionId === null)
            throw new Error("The parameter 'upgradeEditionId' cannot be null.");
        else if (upgradeEditionId !== undefined)
            url_ += "UpgradeEditionId=" + encodeURIComponent("" + upgradeEditionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPaymentInfo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPaymentInfo(<any>response_);
                } catch (e) {
                    return <Observable<PaymentInfoDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PaymentInfoDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPaymentInfo(response: HttpResponseBase): Observable<PaymentInfoDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PaymentInfoDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PaymentInfoDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createPayment(body: CreatePaymentDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Payment/CreatePayment";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreatePayment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreatePayment(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreatePayment(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    cancelPayment(body: CancelPaymentDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Payment/CancelPayment";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCancelPayment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCancelPayment(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCancelPayment(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPaymentHistory(sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfSubscriptionPaymentListDto> {
        let url_ = this.baseUrl + "/api/services/app/Payment/GetPaymentHistory?";
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPaymentHistory(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPaymentHistory(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSubscriptionPaymentListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSubscriptionPaymentListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPaymentHistory(response: HttpResponseBase): Observable<PagedResultDtoOfSubscriptionPaymentListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSubscriptionPaymentListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSubscriptionPaymentListDto>(<any>null);
    }

    /**
     * @param recurringPaymentsEnabled (optional) 
     * @return Success
     */
    getActiveGateways(recurringPaymentsEnabled: boolean | undefined): Observable<PaymentGatewayModel[]> {
        let url_ = this.baseUrl + "/api/services/app/Payment/GetActiveGateways?";
        if (recurringPaymentsEnabled === null)
            throw new Error("The parameter 'recurringPaymentsEnabled' cannot be null.");
        else if (recurringPaymentsEnabled !== undefined)
            url_ += "RecurringPaymentsEnabled=" + encodeURIComponent("" + recurringPaymentsEnabled) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetActiveGateways(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetActiveGateways(<any>response_);
                } catch (e) {
                    return <Observable<PaymentGatewayModel[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<PaymentGatewayModel[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetActiveGateways(response: HttpResponseBase): Observable<PaymentGatewayModel[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(PaymentGatewayModel.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PaymentGatewayModel[]>(<any>null);
    }

    /**
     * @param paymentId (optional) 
     * @return Success
     */
    getPayment(paymentId: number | undefined): Observable<SubscriptionPaymentDto> {
        let url_ = this.baseUrl + "/api/services/app/Payment/GetPayment?";
        if (paymentId === null)
            throw new Error("The parameter 'paymentId' cannot be null.");
        else if (paymentId !== undefined)
            url_ += "paymentId=" + encodeURIComponent("" + paymentId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPayment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPayment(<any>response_);
                } catch (e) {
                    return <Observable<SubscriptionPaymentDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<SubscriptionPaymentDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPayment(response: HttpResponseBase): Observable<SubscriptionPaymentDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = SubscriptionPaymentDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SubscriptionPaymentDto>(<any>null);
    }

    /**
     * @return Success
     */
    getLastCompletedPayment(): Observable<SubscriptionPaymentDto> {
        let url_ = this.baseUrl + "/api/services/app/Payment/GetLastCompletedPayment";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLastCompletedPayment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLastCompletedPayment(<any>response_);
                } catch (e) {
                    return <Observable<SubscriptionPaymentDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<SubscriptionPaymentDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLastCompletedPayment(response: HttpResponseBase): Observable<SubscriptionPaymentDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = SubscriptionPaymentDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SubscriptionPaymentDto>(<any>null);
    }

    /**
     * @param paymentId (optional) 
     * @return Success
     */
    buyNowSucceed(paymentId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Payment/BuyNowSucceed?";
        if (paymentId === null)
            throw new Error("The parameter 'paymentId' cannot be null.");
        else if (paymentId !== undefined)
            url_ += "paymentId=" + encodeURIComponent("" + paymentId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuyNowSucceed(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuyNowSucceed(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuyNowSucceed(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param paymentId (optional) 
     * @return Success
     */
    newRegistrationSucceed(paymentId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Payment/NewRegistrationSucceed?";
        if (paymentId === null)
            throw new Error("The parameter 'paymentId' cannot be null.");
        else if (paymentId !== undefined)
            url_ += "paymentId=" + encodeURIComponent("" + paymentId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processNewRegistrationSucceed(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processNewRegistrationSucceed(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processNewRegistrationSucceed(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param paymentId (optional) 
     * @return Success
     */
    upgradeSucceed(paymentId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Payment/UpgradeSucceed?";
        if (paymentId === null)
            throw new Error("The parameter 'paymentId' cannot be null.");
        else if (paymentId !== undefined)
            url_ += "paymentId=" + encodeURIComponent("" + paymentId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpgradeSucceed(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpgradeSucceed(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpgradeSucceed(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param paymentId (optional) 
     * @return Success
     */
    extendSucceed(paymentId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Payment/ExtendSucceed?";
        if (paymentId === null)
            throw new Error("The parameter 'paymentId' cannot be null.");
        else if (paymentId !== undefined)
            url_ += "paymentId=" + encodeURIComponent("" + paymentId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExtendSucceed(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExtendSucceed(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExtendSucceed(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param paymentId (optional) 
     * @return Success
     */
    paymentFailed(paymentId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Payment/PaymentFailed?";
        if (paymentId === null)
            throw new Error("The parameter 'paymentId' cannot be null.");
        else if (paymentId !== undefined)
            url_ += "paymentId=" + encodeURIComponent("" + paymentId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPaymentFailed(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPaymentFailed(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processPaymentFailed(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param upgradeEditionId (optional) 
     * @return Success
     */
    switchBetweenFreeEditions(upgradeEditionId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Payment/SwitchBetweenFreeEditions?";
        if (upgradeEditionId === null)
            throw new Error("The parameter 'upgradeEditionId' cannot be null.");
        else if (upgradeEditionId !== undefined)
            url_ += "upgradeEditionId=" + encodeURIComponent("" + upgradeEditionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSwitchBetweenFreeEditions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSwitchBetweenFreeEditions(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSwitchBetweenFreeEditions(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param editionId (optional) 
     * @return Success
     */
    upgradeSubscriptionCostsLessThenMinAmount(editionId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Payment/UpgradeSubscriptionCostsLessThenMinAmount?";
        if (editionId === null)
            throw new Error("The parameter 'editionId' cannot be null.");
        else if (editionId !== undefined)
            url_ += "editionId=" + encodeURIComponent("" + editionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpgradeSubscriptionCostsLessThenMinAmount(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpgradeSubscriptionCostsLessThenMinAmount(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpgradeSubscriptionCostsLessThenMinAmount(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class PayPalPaymentServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param paymentId (optional) 
     * @param paypalOrderId (optional) 
     * @return Success
     */
    confirmPayment(paymentId: number | undefined, paypalOrderId: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PayPalPayment/ConfirmPayment?";
        if (paymentId === null)
            throw new Error("The parameter 'paymentId' cannot be null.");
        else if (paymentId !== undefined)
            url_ += "paymentId=" + encodeURIComponent("" + paymentId) + "&"; 
        if (paypalOrderId === null)
            throw new Error("The parameter 'paypalOrderId' cannot be null.");
        else if (paypalOrderId !== undefined)
            url_ += "paypalOrderId=" + encodeURIComponent("" + paypalOrderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConfirmPayment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConfirmPayment(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processConfirmPayment(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getConfiguration(): Observable<PayPalConfigurationDto> {
        let url_ = this.baseUrl + "/api/services/app/PayPalPayment/GetConfiguration";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetConfiguration(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetConfiguration(<any>response_);
                } catch (e) {
                    return <Observable<PayPalConfigurationDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PayPalConfigurationDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetConfiguration(response: HttpResponseBase): Observable<PayPalConfigurationDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PayPalConfigurationDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PayPalConfigurationDto>(<any>null);
    }
}

@Injectable()
export class PermissionServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getAllPermissions(): Observable<ListResultDtoOfFlatPermissionWithLevelDto> {
        let url_ = this.baseUrl + "/api/services/app/Permission/GetAllPermissions";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllPermissions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllPermissions(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfFlatPermissionWithLevelDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfFlatPermissionWithLevelDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllPermissions(response: HttpResponseBase): Observable<ListResultDtoOfFlatPermissionWithLevelDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfFlatPermissionWithLevelDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfFlatPermissionWithLevelDto>(<any>null);
    }
}

@Injectable()
export class PhoneServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param contactId (optional) 
     * @param value (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPhone(id: number | undefined, contactId: number | undefined, value: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfPhoneListDto> {
        let url_ = this.baseUrl + "/api/services/app/Phone/GetPhone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPhone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPhone(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfPhoneListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfPhoneListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPhone(response: HttpResponseBase): Observable<ListResultDtoOfPhoneListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfPhoneListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfPhoneListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createPhone(body: CreatePhoneInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Phone/CreatePhone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreatePhone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreatePhone(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreatePhone(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updatePhone(body: UpdatePhoneInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Phone/UpdatePhone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdatePhone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdatePhone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdatePhone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deletePhone(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Phone/DeletePhone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeletePhone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeletePhone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeletePhone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class PickupItemTypeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPickupItemType(id: number | undefined, name: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfShippingPackageListDto> {
        let url_ = this.baseUrl + "/api/services/app/PickupItemType/GetPickupItemType?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPickupItemType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPickupItemType(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfShippingPackageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfShippingPackageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPickupItemType(response: HttpResponseBase): Observable<ListResultDtoOfShippingPackageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfShippingPackageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfShippingPackageListDto>(<any>null);
    }
}

@Injectable()
export class PostalCodeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param value (optional) 
     * @param country (optional) 
     * @param state (optional) 
     * @param city (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPostalCode(id: number | undefined, value: string | undefined, country: string | undefined, state: string | undefined, city: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfPostalCodeListDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/GetPostalCode?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (country === null)
            throw new Error("The parameter 'country' cannot be null.");
        else if (country !== undefined)
            url_ += "Country=" + encodeURIComponent("" + country) + "&"; 
        if (state === null)
            throw new Error("The parameter 'state' cannot be null.");
        else if (state !== undefined)
            url_ += "State=" + encodeURIComponent("" + state) + "&"; 
        if (city === null)
            throw new Error("The parameter 'city' cannot be null.");
        else if (city !== undefined)
            url_ += "City=" + encodeURIComponent("" + city) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPostalCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPostalCode(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfPostalCodeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfPostalCodeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPostalCode(response: HttpResponseBase): Observable<PagedResultDtoOfPostalCodeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfPostalCodeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfPostalCodeListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createPostalCode(body: CreatePostalCodeInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/CreatePostalCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreatePostalCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreatePostalCode(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreatePostalCode(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getPostalCodeEdit(id: number | undefined): Observable<PostalCodeListDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/GetPostalCodeEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPostalCodeEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPostalCodeEdit(<any>response_);
                } catch (e) {
                    return <Observable<PostalCodeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PostalCodeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPostalCodeEdit(response: HttpResponseBase): Observable<PostalCodeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PostalCodeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PostalCodeListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updatePostalCode(body: UpdatePostalCodeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/UpdatePostalCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdatePostalCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdatePostalCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdatePostalCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deletePostalCode(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/DeletePostalCode?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeletePostalCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeletePostalCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeletePostalCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param value (optional) 
     * @return Success
     */
    getDistinctPostalCode(value: string | undefined): Observable<ListResultDtoOfPostalCodeDropDownList> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/GetDistinctPostalCode?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDistinctPostalCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDistinctPostalCode(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfPostalCodeDropDownList>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfPostalCodeDropDownList>><any>_observableThrow(response_);
        }));
    }

    protected processGetDistinctPostalCode(response: HttpResponseBase): Observable<ListResultDtoOfPostalCodeDropDownList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfPostalCodeDropDownList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfPostalCodeDropDownList>(<any>null);
    }

    /**
     * @return Success
     */
    getAllPostalCode(): Observable<ListResultDtoOfGetPostalCodeListOnlyDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/GetAllPostalCode";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllPostalCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllPostalCode(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetPostalCodeListOnlyDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetPostalCodeListOnlyDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllPostalCode(response: HttpResponseBase): Observable<ListResultDtoOfGetPostalCodeListOnlyDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetPostalCodeListOnlyDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetPostalCodeListOnlyDto>(<any>null);
    }

    /**
     * @param value (optional) 
     * @param id (optional) 
     * @return Success
     */
    getAllPostalCodeAutoComplete(value: string | undefined, id: number | undefined): Observable<ListResultDtoOfGetPostalCodeListOnlyDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/GetAllPostalCodeAutoComplete?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllPostalCodeAutoComplete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllPostalCodeAutoComplete(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetPostalCodeListOnlyDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetPostalCodeListOnlyDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllPostalCodeAutoComplete(response: HttpResponseBase): Observable<ListResultDtoOfGetPostalCodeListOnlyDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetPostalCodeListOnlyDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetPostalCodeListOnlyDto>(<any>null);
    }

    /**
     * @param value (optional) 
     * @param country (optional) 
     * @return Success
     */
    getDistinctCountry(value: string | undefined, country: string | undefined): Observable<ListResultDtoOfGetCountryListOnlyDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/GetDistinctCountry?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (country === null)
            throw new Error("The parameter 'country' cannot be null.");
        else if (country !== undefined)
            url_ += "Country=" + encodeURIComponent("" + country) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDistinctCountry(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDistinctCountry(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetCountryListOnlyDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetCountryListOnlyDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDistinctCountry(response: HttpResponseBase): Observable<ListResultDtoOfGetCountryListOnlyDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetCountryListOnlyDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetCountryListOnlyDto>(<any>null);
    }

    /**
     * @param value (optional) 
     * @param state (optional) 
     * @return Success
     */
    getDistinctState(value: string | undefined, state: string | undefined): Observable<ListResultDtoOfGetStateListOnlyDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/GetDistinctState?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (state === null)
            throw new Error("The parameter 'state' cannot be null.");
        else if (state !== undefined)
            url_ += "State=" + encodeURIComponent("" + state) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDistinctState(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDistinctState(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetStateListOnlyDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetStateListOnlyDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDistinctState(response: HttpResponseBase): Observable<ListResultDtoOfGetStateListOnlyDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetStateListOnlyDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetStateListOnlyDto>(<any>null);
    }

    /**
     * @param value (optional) 
     * @param city (optional) 
     * @return Success
     */
    getDistinctCity(value: string | undefined, city: string | undefined): Observable<ListResultDtoOfGetCityListOnlyDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCode/GetDistinctCity?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (city === null)
            throw new Error("The parameter 'city' cannot be null.");
        else if (city !== undefined)
            url_ += "City=" + encodeURIComponent("" + city) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDistinctCity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDistinctCity(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetCityListOnlyDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetCityListOnlyDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDistinctCity(response: HttpResponseBase): Observable<ListResultDtoOfGetCityListOnlyDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetCityListOnlyDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetCityListOnlyDto>(<any>null);
    }
}

@Injectable()
export class PostalCodesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param countryFilter (optional) 
     * @param cityFilter (optional) 
     * @param stateFilter (optional) 
     * @param valueFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, countryFilter: string | undefined, cityFilter: string | undefined, stateFilter: string | undefined, valueFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetPostalCodeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (countryFilter === null)
            throw new Error("The parameter 'countryFilter' cannot be null.");
        else if (countryFilter !== undefined)
            url_ += "CountryFilter=" + encodeURIComponent("" + countryFilter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetPostalCodeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetPostalCodeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetPostalCodeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetPostalCodeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetPostalCodeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getPostalCodeForView(id: number | undefined): Observable<GetPostalCodeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodes/GetPostalCodeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPostalCodeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPostalCodeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetPostalCodeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetPostalCodeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPostalCodeForView(response: HttpResponseBase): Observable<GetPostalCodeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetPostalCodeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetPostalCodeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getPostalCodeForEdit(id: number | undefined): Observable<GetPostalCodeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodes/GetPostalCodeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPostalCodeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPostalCodeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetPostalCodeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetPostalCodeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetPostalCodeForEdit(response: HttpResponseBase): Observable<GetPostalCodeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetPostalCodeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetPostalCodeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditPostalCodeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param countryFilter (optional) 
     * @param cityFilter (optional) 
     * @param stateFilter (optional) 
     * @param valueFilter (optional) 
     * @return Success
     */
    getPostalCodesToExcel(filter: string | undefined, countryFilter: string | undefined, cityFilter: string | undefined, stateFilter: string | undefined, valueFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodes/GetPostalCodesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (countryFilter === null)
            throw new Error("The parameter 'countryFilter' cannot be null.");
        else if (countryFilter !== undefined)
            url_ += "CountryFilter=" + encodeURIComponent("" + countryFilter) + "&"; 
        if (cityFilter === null)
            throw new Error("The parameter 'cityFilter' cannot be null.");
        else if (cityFilter !== undefined)
            url_ += "CityFilter=" + encodeURIComponent("" + cityFilter) + "&"; 
        if (stateFilter === null)
            throw new Error("The parameter 'stateFilter' cannot be null.");
        else if (stateFilter !== undefined)
            url_ += "StateFilter=" + encodeURIComponent("" + stateFilter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPostalCodesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPostalCodesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPostalCodesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }
}

@Injectable()
export class PostalCodeZoneServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param postalCodeId (optional) 
     * @param zoneId (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPostalCodeZone(id: number | undefined, postalCodeId: number | undefined, zoneId: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfPostalCodeZoneListDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/GetPostalCodeZone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (postalCodeId === null)
            throw new Error("The parameter 'postalCodeId' cannot be null.");
        else if (postalCodeId !== undefined)
            url_ += "PostalCodeId=" + encodeURIComponent("" + postalCodeId) + "&"; 
        if (zoneId === null)
            throw new Error("The parameter 'zoneId' cannot be null.");
        else if (zoneId !== undefined)
            url_ += "ZoneId=" + encodeURIComponent("" + zoneId) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPostalCodeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPostalCodeZone(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfPostalCodeZoneListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfPostalCodeZoneListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPostalCodeZone(response: HttpResponseBase): Observable<ListResultDtoOfPostalCodeZoneListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfPostalCodeZoneListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfPostalCodeZoneListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getPostalCodeZoneList(id: number | undefined): Observable<ListResultDtoOfPostalCodeZoneListDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/GetPostalCodeZoneList?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPostalCodeZoneList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPostalCodeZoneList(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfPostalCodeZoneListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfPostalCodeZoneListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPostalCodeZoneList(response: HttpResponseBase): Observable<ListResultDtoOfPostalCodeZoneListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfPostalCodeZoneListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfPostalCodeZoneListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getGroupedPostalCodeZoneList(id: number | undefined): Observable<GroupedPostalCodeZoneListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/GetGroupedPostalCodeZoneList?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetGroupedPostalCodeZoneList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetGroupedPostalCodeZoneList(<any>response_);
                } catch (e) {
                    return <Observable<GroupedPostalCodeZoneListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GroupedPostalCodeZoneListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetGroupedPostalCodeZoneList(response: HttpResponseBase): Observable<GroupedPostalCodeZoneListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GroupedPostalCodeZoneListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GroupedPostalCodeZoneListDto[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param filter (optional) 
     * @param postalCode (optional) 
     * @param zoneName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPagedGroupedPostalCodeZone(locationId: number | undefined, filter: string | undefined, postalCode: string | undefined, zoneName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGroupedPostalCodeZoneListDto> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/GetPagedGroupedPostalCodeZone?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (postalCode === null)
            throw new Error("The parameter 'postalCode' cannot be null.");
        else if (postalCode !== undefined)
            url_ += "PostalCode=" + encodeURIComponent("" + postalCode) + "&"; 
        if (zoneName === null)
            throw new Error("The parameter 'zoneName' cannot be null.");
        else if (zoneName !== undefined)
            url_ += "ZoneName=" + encodeURIComponent("" + zoneName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPagedGroupedPostalCodeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPagedGroupedPostalCodeZone(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGroupedPostalCodeZoneListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGroupedPostalCodeZoneListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPagedGroupedPostalCodeZone(response: HttpResponseBase): Observable<PagedResultDtoOfGroupedPostalCodeZoneListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGroupedPostalCodeZoneListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGroupedPostalCodeZoneListDto>(<any>null);
    }

    /**
     * @param zid (optional) 
     * @return Success
     */
    getGroupedPostalCodeZoneListByZoneId(zid: number | undefined): Observable<GroupedPostalCodeZoneListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/GetGroupedPostalCodeZoneListByZoneId?";
        if (zid === null)
            throw new Error("The parameter 'zid' cannot be null.");
        else if (zid !== undefined)
            url_ += "zid=" + encodeURIComponent("" + zid) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetGroupedPostalCodeZoneListByZoneId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetGroupedPostalCodeZoneListByZoneId(<any>response_);
                } catch (e) {
                    return <Observable<GroupedPostalCodeZoneListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GroupedPostalCodeZoneListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetGroupedPostalCodeZoneListByZoneId(response: HttpResponseBase): Observable<GroupedPostalCodeZoneListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GroupedPostalCodeZoneListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GroupedPostalCodeZoneListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createPostalCodeZone(body: CreatePostalCodeZoneInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/CreatePostalCodeZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreatePostalCodeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreatePostalCodeZone(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreatePostalCodeZone(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updatePostalCodeZone(body: UpdatePostalCodeZoneInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/UpdatePostalCodeZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdatePostalCodeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdatePostalCodeZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdatePostalCodeZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deletePostalCodeZone(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/DeletePostalCodeZone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeletePostalCodeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeletePostalCodeZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeletePostalCodeZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDeletePostalCodeZoneChips(body: UpdatePostalCodeZonesInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/CreateDeletePostalCodeZoneChips";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDeletePostalCodeZoneChips(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDeletePostalCodeZoneChips(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDeletePostalCodeZoneChips(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param zid (optional) 
     * @return Success
     */
    deleteZonesZonesLocationPostalCodeZones(zid: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/DeleteZonesZonesLocationPostalCodeZones?";
        if (zid === null)
            throw new Error("The parameter 'zid' cannot be null.");
        else if (zid !== undefined)
            url_ += "zid=" + encodeURIComponent("" + zid) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteZonesZonesLocationPostalCodeZones(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteZonesZonesLocationPostalCodeZones(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteZonesZonesLocationPostalCodeZones(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEditPostalCodeZone(body: CreateOrEditPostalCodeZoneDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/PostalCodeZone/CreateOrEditPostalCodeZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEditPostalCodeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEditPostalCodeZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEditPostalCodeZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class PreferencesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetPreferenceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Preferences/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetPreferenceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetPreferenceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetPreferenceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetPreferenceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetPreferenceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getPreferenceForView(id: number | undefined): Observable<GetPreferenceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Preferences/GetPreferenceForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPreferenceForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPreferenceForView(<any>response_);
                } catch (e) {
                    return <Observable<GetPreferenceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetPreferenceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPreferenceForView(response: HttpResponseBase): Observable<GetPreferenceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetPreferenceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetPreferenceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getPreferenceForEdit(id: number | undefined): Observable<GetPreferenceForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Preferences/GetPreferenceForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPreferenceForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPreferenceForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetPreferenceForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetPreferenceForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetPreferenceForEdit(response: HttpResponseBase): Observable<GetPreferenceForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetPreferenceForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetPreferenceForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditPreferenceDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Preferences/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Preferences/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @return Success
     */
    getPreferencesToExcel(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/Preferences/GetPreferencesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPreferencesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPreferencesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPreferencesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param code (optional) 
     * @return Success
     */
    isPreferenceEnabled(code: string | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Preferences/IsPreferenceEnabled?";
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "code=" + encodeURIComponent("" + code) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIsPreferenceEnabled(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIsPreferenceEnabled(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processIsPreferenceEnabled(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }
}

@Injectable()
export class ProcessOrderSourcesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param testMode (optional) 
     * @param body (optional) 
     * @return Success
     */
    execute(testMode: boolean | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/Execute?";
        if (testMode === null)
            throw new Error("The parameter 'testMode' cannot be null.");
        else if (testMode !== undefined)
            url_ += "TestMode=" + encodeURIComponent("" + testMode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExecute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExecute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExecute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    checkProcessingFiles(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/CheckProcessingFiles";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckProcessingFiles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckProcessingFiles(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCheckProcessingFiles(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenant (optional) 
     * @param tenantName (optional) 
     * @param body (optional) 
     * @return Success
     */
    executePerTenant(tenant: number | undefined, tenantName: string | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/ExecutePerTenant?";
        if (tenant === null)
            throw new Error("The parameter 'tenant' cannot be null.");
        else if (tenant !== undefined)
            url_ += "tenant=" + encodeURIComponent("" + tenant) + "&"; 
        if (tenantName === null)
            throw new Error("The parameter 'tenantName' cannot be null.");
        else if (tenantName !== undefined)
            url_ += "tenantName=" + encodeURIComponent("" + tenantName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExecutePerTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExecutePerTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExecutePerTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    processFromFtp(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/ProcessFromFtp";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processProcessFromFtp(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processProcessFromFtp(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processProcessFromFtp(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateRoutesForTenant(body: Tenant | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/GenerateRoutesForTenant";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateRoutesForTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateRoutesForTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateRoutesForTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param isHeaderFixed (optional) 
     * @param body (optional) 
     * @return Success
     */
    convertToSpreadsheet(isHeaderFixed: boolean | undefined, body: Blob | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/ConvertToSpreadsheet?";
        if (isHeaderFixed === null)
            throw new Error("The parameter 'isHeaderFixed' cannot be null.");
        else if (isHeaderFixed !== undefined)
            url_ += "isHeaderFixed=" + encodeURIComponent("" + isHeaderFixed) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = body;

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "multipart/form-data", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertToSpreadsheet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertToSpreadsheet(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processConvertToSpreadsheet(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param code (optional) 
     * @param tenantdId (optional) 
     * @param fileName (optional) 
     * @param orderSourceId (optional) 
     * @param orderSourceFileId (optional) 
     * @param body (optional) 
     * @return Success
     */
    createOrderItems(code: string | undefined, tenantdId: number | undefined, fileName: string | undefined, orderSourceId: number | undefined, orderSourceFileId: number | undefined, body: OrderImportDto[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/CreateOrderItems?";
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "code=" + encodeURIComponent("" + code) + "&"; 
        if (tenantdId === null)
            throw new Error("The parameter 'tenantdId' cannot be null.");
        else if (tenantdId !== undefined)
            url_ += "tenantdId=" + encodeURIComponent("" + tenantdId) + "&"; 
        if (fileName === null)
            throw new Error("The parameter 'fileName' cannot be null.");
        else if (fileName !== undefined)
            url_ += "fileName=" + encodeURIComponent("" + fileName) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "orderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (orderSourceFileId === null)
            throw new Error("The parameter 'orderSourceFileId' cannot be null.");
        else if (orderSourceFileId !== undefined)
            url_ += "orderSourceFileId=" + encodeURIComponent("" + orderSourceFileId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrderItems(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrderItems(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrderItems(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    checkForFiles(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/CheckForFiles";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckForFiles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckForFiles(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCheckForFiles(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param fileName (optional) 
     * @param body (optional) 
     * @return Success
     */
    sendNotif(fileName: string | undefined, body: LocationCountSuccess[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/SendNotif?";
        if (fileName === null)
            throw new Error("The parameter 'fileName' cannot be null.");
        else if (fileName !== undefined)
            url_ += "fileName=" + encodeURIComponent("" + fileName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendNotif(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendNotif(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendNotif(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filename (optional) 
     * @return Success
     */
    getFileContent(filename: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ProcessOrderSources/GetFileContent?";
        if (filename === null)
            throw new Error("The parameter 'filename' cannot be null.");
        else if (filename !== undefined)
            url_ += "filename=" + encodeURIComponent("" + filename) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFileContent(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFileContent(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetFileContent(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class ProfileServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getCurrentUserProfileForEdit(): Observable<CurrentUserProfileEditDto> {
        let url_ = this.baseUrl + "/api/services/app/Profile/GetCurrentUserProfileForEdit";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCurrentUserProfileForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCurrentUserProfileForEdit(<any>response_);
                } catch (e) {
                    return <Observable<CurrentUserProfileEditDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<CurrentUserProfileEditDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCurrentUserProfileForEdit(response: HttpResponseBase): Observable<CurrentUserProfileEditDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CurrentUserProfileEditDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CurrentUserProfileEditDto>(<any>null);
    }

    /**
     * @return Success
     */
    disableGoogleAuthenticator(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/DisableGoogleAuthenticator";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDisableGoogleAuthenticator(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDisableGoogleAuthenticator(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDisableGoogleAuthenticator(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    updateGoogleAuthenticatorKey(): Observable<UpdateGoogleAuthenticatorKeyOutput> {
        let url_ = this.baseUrl + "/api/services/app/Profile/UpdateGoogleAuthenticatorKey";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateGoogleAuthenticatorKey(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateGoogleAuthenticatorKey(<any>response_);
                } catch (e) {
                    return <Observable<UpdateGoogleAuthenticatorKeyOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<UpdateGoogleAuthenticatorKeyOutput>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateGoogleAuthenticatorKey(response: HttpResponseBase): Observable<UpdateGoogleAuthenticatorKeyOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = UpdateGoogleAuthenticatorKeyOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UpdateGoogleAuthenticatorKeyOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendVerificationSms(body: SendVerificationSmsInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/SendVerificationSms";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendVerificationSms(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendVerificationSms(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendVerificationSms(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    verifySmsCode(body: VerifySmsCodeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/VerifySmsCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processVerifySmsCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processVerifySmsCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processVerifySmsCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    prepareCollectedData(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/PrepareCollectedData";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPrepareCollectedData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPrepareCollectedData(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processPrepareCollectedData(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateCurrentUserProfile(body: CurrentUserProfileEditDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/UpdateCurrentUserProfile";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateCurrentUserProfile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateCurrentUserProfile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateCurrentUserProfile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    changePassword(body: ChangePasswordInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/ChangePassword";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processChangePassword(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processChangePassword(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processChangePassword(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateProfilePicture(body: UpdateProfilePictureInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/UpdateProfilePicture";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateProfilePicture(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateProfilePicture(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateProfilePicture(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getPasswordComplexitySetting(): Observable<GetPasswordComplexitySettingOutput> {
        let url_ = this.baseUrl + "/api/services/app/Profile/GetPasswordComplexitySetting";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPasswordComplexitySetting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPasswordComplexitySetting(<any>response_);
                } catch (e) {
                    return <Observable<GetPasswordComplexitySettingOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetPasswordComplexitySettingOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetPasswordComplexitySetting(response: HttpResponseBase): Observable<GetPasswordComplexitySettingOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetPasswordComplexitySettingOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetPasswordComplexitySettingOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getProfilePicture(): Observable<GetProfilePictureOutput> {
        let url_ = this.baseUrl + "/api/services/app/Profile/GetProfilePicture";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetProfilePicture(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetProfilePicture(<any>response_);
                } catch (e) {
                    return <Observable<GetProfilePictureOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetProfilePictureOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetProfilePicture(response: HttpResponseBase): Observable<GetProfilePictureOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetProfilePictureOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetProfilePictureOutput>(<any>null);
    }

    /**
     * @param profilePictureId (optional) 
     * @param userId (optional) 
     * @param tenantId (optional) 
     * @return Success
     */
    getFriendProfilePictureById(profilePictureId: string | undefined, userId: number | undefined, tenantId: number | undefined): Observable<GetProfilePictureOutput> {
        let url_ = this.baseUrl + "/api/services/app/Profile/GetFriendProfilePictureById?";
        if (profilePictureId === null)
            throw new Error("The parameter 'profilePictureId' cannot be null.");
        else if (profilePictureId !== undefined)
            url_ += "ProfilePictureId=" + encodeURIComponent("" + profilePictureId) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFriendProfilePictureById(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFriendProfilePictureById(<any>response_);
                } catch (e) {
                    return <Observable<GetProfilePictureOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetProfilePictureOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetFriendProfilePictureById(response: HttpResponseBase): Observable<GetProfilePictureOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetProfilePictureOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetProfilePictureOutput>(<any>null);
    }

    /**
     * @param profilePictureId (optional) 
     * @return Success
     */
    getProfilePictureById(profilePictureId: string | undefined): Observable<GetProfilePictureOutput> {
        let url_ = this.baseUrl + "/api/services/app/Profile/GetProfilePictureById?";
        if (profilePictureId === null)
            throw new Error("The parameter 'profilePictureId' cannot be null.");
        else if (profilePictureId !== undefined)
            url_ += "profilePictureId=" + encodeURIComponent("" + profilePictureId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetProfilePictureById(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetProfilePictureById(<any>response_);
                } catch (e) {
                    return <Observable<GetProfilePictureOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetProfilePictureOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetProfilePictureById(response: HttpResponseBase): Observable<GetProfilePictureOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetProfilePictureOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetProfilePictureOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    changeLanguage(body: ChangeUserLanguageDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/ChangeLanguage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processChangeLanguage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processChangeLanguage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processChangeLanguage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    uploadMobilePhoto(body: UploadMobilePhotoInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/UploadMobilePhoto";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUploadMobilePhoto(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUploadMobilePhoto(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUploadMobilePhoto(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    editMobileProfile(body: EditMobileProfileInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/EditMobileProfile";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processEditMobileProfile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processEditMobileProfile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processEditMobileProfile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    editMobilePassword(body: EditMobilePasswordInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Profile/EditMobilePassword";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processEditMobilePassword(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processEditMobilePassword(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processEditMobilePassword(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ProximityServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filters (optional) 
     * @param proximityRangeFilter (optional) 
     * @param locationsFilter (optional) 
     * @param addressTypesFilter (optional) 
     * @return Success
     */
    getProximitiesToExcel(filters: string | undefined, proximityRangeFilter: string | undefined, locationsFilter: string | undefined, addressTypesFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/Proximity/GetProximitiesToExcel?";
        if (filters === null)
            throw new Error("The parameter 'filters' cannot be null.");
        else if (filters !== undefined)
            url_ += "Filters=" + encodeURIComponent("" + filters) + "&"; 
        if (proximityRangeFilter === null)
            throw new Error("The parameter 'proximityRangeFilter' cannot be null.");
        else if (proximityRangeFilter !== undefined)
            url_ += "ProximityRangeFilter=" + encodeURIComponent("" + proximityRangeFilter) + "&"; 
        if (locationsFilter === null)
            throw new Error("The parameter 'locationsFilter' cannot be null.");
        else if (locationsFilter !== undefined)
            url_ += "LocationsFilter=" + encodeURIComponent("" + locationsFilter) + "&"; 
        if (addressTypesFilter === null)
            throw new Error("The parameter 'addressTypesFilter' cannot be null.");
        else if (addressTypesFilter !== undefined)
            url_ += "AddressTypesFilter=" + encodeURIComponent("" + addressTypesFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetProximitiesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetProximitiesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetProximitiesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createProximity(body: CreateProximityInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Proximity/CreateProximity";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateProximity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateProximity(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateProximity(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param addressTypeId (optional) 
     * @param value (optional) 
     * @param filter (optional) 
     * @param locationFilter (optional) 
     * @param addressTypeFilter (optional) 
     * @param valueFilter (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getProximity(id: number | undefined, locationId: number | undefined, addressTypeId: number | undefined, value: number | undefined, filter: string | undefined, locationFilter: string | undefined, addressTypeFilter: string | undefined, valueFilter: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfProximityListDto> {
        let url_ = this.baseUrl + "/api/services/app/Proximity/GetProximity?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (addressTypeId === null)
            throw new Error("The parameter 'addressTypeId' cannot be null.");
        else if (addressTypeId !== undefined)
            url_ += "AddressTypeId=" + encodeURIComponent("" + addressTypeId) + "&"; 
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationFilter === null)
            throw new Error("The parameter 'locationFilter' cannot be null.");
        else if (locationFilter !== undefined)
            url_ += "LocationFilter=" + encodeURIComponent("" + locationFilter) + "&"; 
        if (addressTypeFilter === null)
            throw new Error("The parameter 'addressTypeFilter' cannot be null.");
        else if (addressTypeFilter !== undefined)
            url_ += "AddressTypeFilter=" + encodeURIComponent("" + addressTypeFilter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetProximity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetProximity(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfProximityListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfProximityListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetProximity(response: HttpResponseBase): Observable<PagedResultDtoOfProximityListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfProximityListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfProximityListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateProximity(body: UpdateProximityInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Proximity/UpdateProximity";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateProximity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateProximity(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateProximity(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteProximity(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Proximity/DeleteProximity?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteProximity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteProximity(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteProximity(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RateServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getOrderSourceRate(): Observable<OrderSourceRate[]> {
        let url_ = this.baseUrl + "/api/services/app/Rate/GetOrderSourceRate";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderSourceRate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderSourceRate(<any>response_);
                } catch (e) {
                    return <Observable<OrderSourceRate[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderSourceRate[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderSourceRate(response: HttpResponseBase): Observable<OrderSourceRate[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderSourceRate.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderSourceRate[]>(<any>null);
    }

    /**
     * @return Success
     */
    getRateTypeList(): Observable<RateTypeList[]> {
        let url_ = this.baseUrl + "/api/services/app/Rate/GetRateTypeList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRateTypeList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRateTypeList(<any>response_);
                } catch (e) {
                    return <Observable<RateTypeList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RateTypeList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRateTypeList(response: HttpResponseBase): Observable<RateTypeList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RateTypeList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RateTypeList[]>(<any>null);
    }

    /**
     * @return Success
     */
    getRuleList(): Observable<RuleList[]> {
        let url_ = this.baseUrl + "/api/services/app/Rate/GetRuleList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRuleList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRuleList(<any>response_);
                } catch (e) {
                    return <Observable<RuleList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RuleList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRuleList(response: HttpResponseBase): Observable<RuleList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RuleList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RuleList[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRateForEdit(id: number | undefined): Observable<GetRateForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Rate/GetRateForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRateForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRateForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRateForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRateForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRateForEdit(response: HttpResponseBase): Observable<GetRateForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRateForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRateForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRate(body: CreateOrEditRateInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Rate/CreateRate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Rate/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param locationId (optional) 
     * @param orderSourceId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getRate(filter: string | undefined, locationId: number | undefined, orderSourceId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRateDto> {
        let url_ = this.baseUrl + "/api/services/app/Rate/GetRate?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (orderSourceId === null)
            throw new Error("The parameter 'orderSourceId' cannot be null.");
        else if (orderSourceId !== undefined)
            url_ += "OrderSourceId=" + encodeURIComponent("" + orderSourceId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRate(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRateDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRateDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRate(response: HttpResponseBase): Observable<PagedResultDtoOfRateDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRateDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRateDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRate(body: CreateOrEditRateInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Rate/UpdateRate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param locationId (optional) 
     * @param fleetId (optional) 
     * @param date (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getDriverRate(filter: string | undefined, locationId: number | undefined, fleetId: number | undefined, date: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfDriverRateDto> {
        let url_ = this.baseUrl + "/api/services/app/Rate/GetDriverRate?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (fleetId === null)
            throw new Error("The parameter 'fleetId' cannot be null.");
        else if (fleetId !== undefined)
            url_ += "FleetId=" + encodeURIComponent("" + fleetId) + "&"; 
        if (date === null)
            throw new Error("The parameter 'date' cannot be null.");
        else if (date !== undefined)
            url_ += "Date=" + encodeURIComponent("" + date) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriverRate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriverRate(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfDriverRateDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfDriverRateDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriverRate(response: HttpResponseBase): Observable<PagedResultDtoOfDriverRateDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfDriverRateDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfDriverRateDto>(<any>null);
    }
}

@Injectable()
export class RealTimeEtaServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param routeIdsToLab (optional) 
     * @param routeIdsToClinics (optional) 
     * @return Success
     */
    getRouteRealTimeEtaLab(routeIdsToLab: number[] | undefined, routeIdsToClinics: number[] | undefined): Observable<GetRealTimeEtaDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RealTimeEta/GetRouteRealTimeEtaLab?";
        if (routeIdsToLab === null)
            throw new Error("The parameter 'routeIdsToLab' cannot be null.");
        else if (routeIdsToLab !== undefined)
            routeIdsToLab && routeIdsToLab.forEach(item => { url_ += "RouteIdsToLab=" + encodeURIComponent("" + item) + "&"; });
        if (routeIdsToClinics === null)
            throw new Error("The parameter 'routeIdsToClinics' cannot be null.");
        else if (routeIdsToClinics !== undefined)
            routeIdsToClinics && routeIdsToClinics.forEach(item => { url_ += "RouteIdsToClinics=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteRealTimeEtaLab(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteRealTimeEtaLab(<any>response_);
                } catch (e) {
                    return <Observable<GetRealTimeEtaDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRealTimeEtaDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteRealTimeEtaLab(response: HttpResponseBase): Observable<GetRealTimeEtaDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetRealTimeEtaDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRealTimeEtaDto[]>(<any>null);
    }

    /**
     * @param routeIdsToLab (optional) 
     * @param routeIdsToClinics (optional) 
     * @return Success
     */
    getRealTimeEtaClinics(routeIdsToLab: number[] | undefined, routeIdsToClinics: number[] | undefined): Observable<GetRealTimeEtaDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RealTimeEta/GetRealTimeEtaClinics?";
        if (routeIdsToLab === null)
            throw new Error("The parameter 'routeIdsToLab' cannot be null.");
        else if (routeIdsToLab !== undefined)
            routeIdsToLab && routeIdsToLab.forEach(item => { url_ += "RouteIdsToLab=" + encodeURIComponent("" + item) + "&"; });
        if (routeIdsToClinics === null)
            throw new Error("The parameter 'routeIdsToClinics' cannot be null.");
        else if (routeIdsToClinics !== undefined)
            routeIdsToClinics && routeIdsToClinics.forEach(item => { url_ += "RouteIdsToClinics=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRealTimeEtaClinics(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRealTimeEtaClinics(<any>response_);
                } catch (e) {
                    return <Observable<GetRealTimeEtaDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRealTimeEtaDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRealTimeEtaClinics(response: HttpResponseBase): Observable<GetRealTimeEtaDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetRealTimeEtaDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRealTimeEtaDto[]>(<any>null);
    }
}

@Injectable()
export class RecurringOrderScheduleServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param tenantId (optional) 
     * @return Success
     */
    getTimezoneOfTenantMarkets(tenantId: number | undefined): Observable<MarketListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedule/GetTimezoneOfTenantMarkets?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimezoneOfTenantMarkets(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimezoneOfTenantMarkets(<any>response_);
                } catch (e) {
                    return <Observable<MarketListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<MarketListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimezoneOfTenantMarkets(response: HttpResponseBase): Observable<MarketListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(MarketListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<MarketListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRecurringOrder(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedule/CreateRecurringOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRecurringOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRecurringOrder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRecurringOrder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRecurringOrderExecute(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedule/CreateRecurringOrderExecute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRecurringOrderExecute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRecurringOrderExecute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRecurringOrderExecute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param message (optional) 
     * @return Success
     */
    log(message: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedule/Log?";
        if (message === null)
            throw new Error("The parameter 'message' cannot be null.");
        else if (message !== undefined)
            url_ += "message=" + encodeURIComponent("" + message) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLog(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLog(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param dateToday (optional) 
     * @param body (optional) 
     * @return Success
     */
    recurringOrderScheduleCron(dateToday: moment.Moment | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedule/RecurringOrderScheduleCron?";
        if (dateToday === null)
            throw new Error("The parameter 'dateToday' cannot be null.");
        else if (dateToday !== undefined)
            url_ += "dateToday=" + encodeURIComponent(dateToday ? "" + dateToday.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRecurringOrderScheduleCron(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRecurringOrderScheduleCron(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRecurringOrderScheduleCron(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RecurringOrderSchedulesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param timezoneFilter (optional) 
     * @param maxStartDateFilter (optional) 
     * @param minStartDateFilter (optional) 
     * @param repeatFilter (optional) 
     * @param maxEndDateFilter (optional) 
     * @param minEndDateFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, timezoneFilter: string | undefined, maxStartDateFilter: moment.Moment | undefined, minStartDateFilter: moment.Moment | undefined, repeatFilter: string | undefined, maxEndDateFilter: moment.Moment | undefined, minEndDateFilter: moment.Moment | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRecurringOrderScheduleForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (timezoneFilter === null)
            throw new Error("The parameter 'timezoneFilter' cannot be null.");
        else if (timezoneFilter !== undefined)
            url_ += "TimezoneFilter=" + encodeURIComponent("" + timezoneFilter) + "&"; 
        if (maxStartDateFilter === null)
            throw new Error("The parameter 'maxStartDateFilter' cannot be null.");
        else if (maxStartDateFilter !== undefined)
            url_ += "MaxStartDateFilter=" + encodeURIComponent(maxStartDateFilter ? "" + maxStartDateFilter.toJSON() : "") + "&"; 
        if (minStartDateFilter === null)
            throw new Error("The parameter 'minStartDateFilter' cannot be null.");
        else if (minStartDateFilter !== undefined)
            url_ += "MinStartDateFilter=" + encodeURIComponent(minStartDateFilter ? "" + minStartDateFilter.toJSON() : "") + "&"; 
        if (repeatFilter === null)
            throw new Error("The parameter 'repeatFilter' cannot be null.");
        else if (repeatFilter !== undefined)
            url_ += "RepeatFilter=" + encodeURIComponent("" + repeatFilter) + "&"; 
        if (maxEndDateFilter === null)
            throw new Error("The parameter 'maxEndDateFilter' cannot be null.");
        else if (maxEndDateFilter !== undefined)
            url_ += "MaxEndDateFilter=" + encodeURIComponent(maxEndDateFilter ? "" + maxEndDateFilter.toJSON() : "") + "&"; 
        if (minEndDateFilter === null)
            throw new Error("The parameter 'minEndDateFilter' cannot be null.");
        else if (minEndDateFilter !== undefined)
            url_ += "MinEndDateFilter=" + encodeURIComponent(minEndDateFilter ? "" + minEndDateFilter.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRecurringOrderScheduleForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRecurringOrderScheduleForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRecurringOrderScheduleForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRecurringOrderScheduleForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRecurringOrderScheduleForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRecurringOrderScheduleForView(id: number | undefined): Observable<GetRecurringOrderScheduleForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/GetRecurringOrderScheduleForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRecurringOrderScheduleForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRecurringOrderScheduleForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRecurringOrderScheduleForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRecurringOrderScheduleForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRecurringOrderScheduleForView(response: HttpResponseBase): Observable<GetRecurringOrderScheduleForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRecurringOrderScheduleForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRecurringOrderScheduleForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRecurringOrderScheduleForEdit(id: number | undefined): Observable<GetRecurringOrderScheduleForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/GetRecurringOrderScheduleForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRecurringOrderScheduleForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRecurringOrderScheduleForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRecurringOrderScheduleForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRecurringOrderScheduleForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRecurringOrderScheduleForEdit(response: HttpResponseBase): Observable<GetRecurringOrderScheduleForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRecurringOrderScheduleForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRecurringOrderScheduleForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRecurringOrderScheduleDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param timezoneFilter (optional) 
     * @param maxStartDateFilter (optional) 
     * @param minStartDateFilter (optional) 
     * @param repeatFilter (optional) 
     * @param maxEndDateFilter (optional) 
     * @param minEndDateFilter (optional) 
     * @return Success
     */
    getRecurringOrderSchedulesToExcel(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, timezoneFilter: string | undefined, maxStartDateFilter: moment.Moment | undefined, minStartDateFilter: moment.Moment | undefined, repeatFilter: string | undefined, maxEndDateFilter: moment.Moment | undefined, minEndDateFilter: moment.Moment | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/GetRecurringOrderSchedulesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (timezoneFilter === null)
            throw new Error("The parameter 'timezoneFilter' cannot be null.");
        else if (timezoneFilter !== undefined)
            url_ += "TimezoneFilter=" + encodeURIComponent("" + timezoneFilter) + "&"; 
        if (maxStartDateFilter === null)
            throw new Error("The parameter 'maxStartDateFilter' cannot be null.");
        else if (maxStartDateFilter !== undefined)
            url_ += "MaxStartDateFilter=" + encodeURIComponent(maxStartDateFilter ? "" + maxStartDateFilter.toJSON() : "") + "&"; 
        if (minStartDateFilter === null)
            throw new Error("The parameter 'minStartDateFilter' cannot be null.");
        else if (minStartDateFilter !== undefined)
            url_ += "MinStartDateFilter=" + encodeURIComponent(minStartDateFilter ? "" + minStartDateFilter.toJSON() : "") + "&"; 
        if (repeatFilter === null)
            throw new Error("The parameter 'repeatFilter' cannot be null.");
        else if (repeatFilter !== undefined)
            url_ += "RepeatFilter=" + encodeURIComponent("" + repeatFilter) + "&"; 
        if (maxEndDateFilter === null)
            throw new Error("The parameter 'maxEndDateFilter' cannot be null.");
        else if (maxEndDateFilter !== undefined)
            url_ += "MaxEndDateFilter=" + encodeURIComponent(maxEndDateFilter ? "" + maxEndDateFilter.toJSON() : "") + "&"; 
        if (minEndDateFilter === null)
            throw new Error("The parameter 'minEndDateFilter' cannot be null.");
        else if (minEndDateFilter !== undefined)
            url_ += "MinEndDateFilter=" + encodeURIComponent(minEndDateFilter ? "" + minEndDateFilter.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRecurringOrderSchedulesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRecurringOrderSchedulesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRecurringOrderSchedulesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param timezoneFilter (optional) 
     * @param maxStartDateFilter (optional) 
     * @param minStartDateFilter (optional) 
     * @param repeatFilter (optional) 
     * @param maxEndDateFilter (optional) 
     * @param minEndDateFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllForModal(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, timezoneFilter: string | undefined, maxStartDateFilter: moment.Moment | undefined, minStartDateFilter: moment.Moment | undefined, repeatFilter: string | undefined, maxEndDateFilter: moment.Moment | undefined, minEndDateFilter: moment.Moment | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/GetAllForModal?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (timezoneFilter === null)
            throw new Error("The parameter 'timezoneFilter' cannot be null.");
        else if (timezoneFilter !== undefined)
            url_ += "TimezoneFilter=" + encodeURIComponent("" + timezoneFilter) + "&"; 
        if (maxStartDateFilter === null)
            throw new Error("The parameter 'maxStartDateFilter' cannot be null.");
        else if (maxStartDateFilter !== undefined)
            url_ += "MaxStartDateFilter=" + encodeURIComponent(maxStartDateFilter ? "" + maxStartDateFilter.toJSON() : "") + "&"; 
        if (minStartDateFilter === null)
            throw new Error("The parameter 'minStartDateFilter' cannot be null.");
        else if (minStartDateFilter !== undefined)
            url_ += "MinStartDateFilter=" + encodeURIComponent(minStartDateFilter ? "" + minStartDateFilter.toJSON() : "") + "&"; 
        if (repeatFilter === null)
            throw new Error("The parameter 'repeatFilter' cannot be null.");
        else if (repeatFilter !== undefined)
            url_ += "RepeatFilter=" + encodeURIComponent("" + repeatFilter) + "&"; 
        if (maxEndDateFilter === null)
            throw new Error("The parameter 'maxEndDateFilter' cannot be null.");
        else if (maxEndDateFilter !== undefined)
            url_ += "MaxEndDateFilter=" + encodeURIComponent(maxEndDateFilter ? "" + maxEndDateFilter.toJSON() : "") + "&"; 
        if (minEndDateFilter === null)
            throw new Error("The parameter 'minEndDateFilter' cannot be null.");
        else if (minEndDateFilter !== undefined)
            url_ += "MinEndDateFilter=" + encodeURIComponent(minEndDateFilter ? "" + minEndDateFilter.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllForModal(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllForModal(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllForModal(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRecurringId(body: UpdateRecurringScheduleIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/UpdateRecurringId";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRecurringId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRecurringId(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRecurringId(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param input (optional) 
     * @return Success
     */
    removeRecurringId(input: number[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/RemoveRecurringId?";
        if (input === null)
            throw new Error("The parameter 'input' cannot be null.");
        else if (input !== undefined)
            input && input.forEach(item => { url_ += "input=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRemoveRecurringId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRemoveRecurringId(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRemoveRecurringId(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRecurringScheduleHangfire(body: RecurringOrderSchedule | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/CreateRecurringScheduleHangfire";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRecurringScheduleHangfire(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRecurringScheduleHangfire(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRecurringScheduleHangfire(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    runRecurringHangFire(body: RecurringOrderSchedule | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/RunRecurringHangFire";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRunRecurringHangFire(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRunRecurringHangFire(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRunRecurringHangFire(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getDistinctRepeatCreated(): Observable<string[]> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/GetDistinctRepeatCreated";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDistinctRepeatCreated(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDistinctRepeatCreated(<any>response_);
                } catch (e) {
                    return <Observable<string[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<string[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDistinctRepeatCreated(response: HttpResponseBase): Observable<string[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string[]>(<any>null);
    }

    /**
     * @return Success
     */
    getUserDefaultTimezone(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/GetUserDefaultTimezone";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserDefaultTimezone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserDefaultTimezone(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserDefaultTimezone(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param timeZone (optional) 
     * @param recurringOrderScheduleId (optional) 
     * @return Success
     */
    recurringOrderSetupJob(tenantId: number | undefined, timeZone: string | undefined, recurringOrderScheduleId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RecurringOrderSchedules/RecurringOrderSetupJob?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (timeZone === null)
            throw new Error("The parameter 'timeZone' cannot be null.");
        else if (timeZone !== undefined)
            url_ += "timeZone=" + encodeURIComponent("" + timeZone) + "&"; 
        if (recurringOrderScheduleId === null)
            throw new Error("The parameter 'recurringOrderScheduleId' cannot be null.");
        else if (recurringOrderScheduleId !== undefined)
            url_ += "recurringOrderScheduleId=" + encodeURIComponent("" + recurringOrderScheduleId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRecurringOrderSetupJob(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRecurringOrderSetupJob(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRecurringOrderSetupJob(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ReportServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getTenants(): Observable<TenantIdList[]> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetTenants";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenants(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenants(<any>response_);
                } catch (e) {
                    return <Observable<TenantIdList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<TenantIdList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenants(response: HttpResponseBase): Observable<TenantIdList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(TenantIdList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TenantIdList[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param createdFrom (optional) 
     * @param createdTo (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getReportLogs(filter: string | undefined, nameFilter: string | undefined, createdFrom: moment.Moment | undefined, createdTo: moment.Moment | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfReportLogList> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetReportLogs?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (createdFrom === null)
            throw new Error("The parameter 'createdFrom' cannot be null.");
        else if (createdFrom !== undefined)
            url_ += "CreatedFrom=" + encodeURIComponent(createdFrom ? "" + createdFrom.toJSON() : "") + "&"; 
        if (createdTo === null)
            throw new Error("The parameter 'createdTo' cannot be null.");
        else if (createdTo !== undefined)
            url_ += "CreatedTo=" + encodeURIComponent(createdTo ? "" + createdTo.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportLogs(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportLogs(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfReportLogList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfReportLogList>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportLogs(response: HttpResponseBase): Observable<PagedResultDtoOfReportLogList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfReportLogList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfReportLogList>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createReportLog(body: CreateReportLogDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Report/CreateReportLog";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateReportLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateReportLog(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateReportLog(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param subject (optional) 
     * @param mailMessage (optional) 
     * @param body (optional) 
     * @return Success
     */
    sendReportEmailNotif(subject: string | undefined, mailMessage: string | undefined, body: string[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Report/SendReportEmailNotif?";
        if (subject === null)
            throw new Error("The parameter 'subject' cannot be null.");
        else if (subject !== undefined)
            url_ += "subject=" + encodeURIComponent("" + subject) + "&"; 
        if (mailMessage === null)
            throw new Error("The parameter 'mailMessage' cannot be null.");
        else if (mailMessage !== undefined)
            url_ += "mailMessage=" + encodeURIComponent("" + mailMessage) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendReportEmailNotif(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendReportEmailNotif(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendReportEmailNotif(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param reportId (optional) 
     * @return Success
     */
    triggerEmail(reportId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Report/TriggerEmail?";
        if (reportId === null)
            throw new Error("The parameter 'reportId' cannot be null.");
        else if (reportId !== undefined)
            url_ += "reportId=" + encodeURIComponent("" + reportId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTriggerEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTriggerEmail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processTriggerEmail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    uploadReport(body: UploadReport | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Report/UploadReport";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUploadReport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUploadReport(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUploadReport(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    downloadReport(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Report/DownloadReport?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDownloadReport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDownloadReport(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDownloadReport(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Report/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param createdFrom (optional) 
     * @param createdTo (optional) 
     * @param modifiedFrom (optional) 
     * @param modifiedTo (optional) 
     * @param createdByFilter (optional) 
     * @param modifiedByFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getReports(filter: string | undefined, nameFilter: string | undefined, createdFrom: moment.Moment | undefined, createdTo: moment.Moment | undefined, modifiedFrom: moment.Moment | undefined, modifiedTo: moment.Moment | undefined, createdByFilter: number | undefined, modifiedByFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfReportList> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetReports?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (createdFrom === null)
            throw new Error("The parameter 'createdFrom' cannot be null.");
        else if (createdFrom !== undefined)
            url_ += "CreatedFrom=" + encodeURIComponent(createdFrom ? "" + createdFrom.toJSON() : "") + "&"; 
        if (createdTo === null)
            throw new Error("The parameter 'createdTo' cannot be null.");
        else if (createdTo !== undefined)
            url_ += "CreatedTo=" + encodeURIComponent(createdTo ? "" + createdTo.toJSON() : "") + "&"; 
        if (modifiedFrom === null)
            throw new Error("The parameter 'modifiedFrom' cannot be null.");
        else if (modifiedFrom !== undefined)
            url_ += "ModifiedFrom=" + encodeURIComponent(modifiedFrom ? "" + modifiedFrom.toJSON() : "") + "&"; 
        if (modifiedTo === null)
            throw new Error("The parameter 'modifiedTo' cannot be null.");
        else if (modifiedTo !== undefined)
            url_ += "ModifiedTo=" + encodeURIComponent(modifiedTo ? "" + modifiedTo.toJSON() : "") + "&"; 
        if (createdByFilter === null)
            throw new Error("The parameter 'createdByFilter' cannot be null.");
        else if (createdByFilter !== undefined)
            url_ += "CreatedByFilter=" + encodeURIComponent("" + createdByFilter) + "&"; 
        if (modifiedByFilter === null)
            throw new Error("The parameter 'modifiedByFilter' cannot be null.");
        else if (modifiedByFilter !== undefined)
            url_ += "ModifiedByFilter=" + encodeURIComponent("" + modifiedByFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReports(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReports(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfReportList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfReportList>><any>_observableThrow(response_);
        }));
    }

    protected processGetReports(response: HttpResponseBase): Observable<PagedResultDtoOfReportList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfReportList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfReportList>(<any>null);
    }

    /**
     * @return Success
     */
    getUsersForDropDownReport(): Observable<UserListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetUsersForDropDownReport";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUsersForDropDownReport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUsersForDropDownReport(<any>response_);
                } catch (e) {
                    return <Observable<UserListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<UserListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetUsersForDropDownReport(response: HttpResponseBase): Observable<UserListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(UserListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UserListDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getData(): Observable<Reports[]> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetData";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetData(<any>response_);
                } catch (e) {
                    return <Observable<Reports[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<Reports[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetData(response: HttpResponseBase): Observable<Reports[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(Reports.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Reports[]>(<any>null);
    }

    /**
     * @return Success
     */
    getReportUser(): Observable<CurrentReportUser> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetReportUser";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportUser(<any>response_);
                } catch (e) {
                    return <Observable<CurrentReportUser>><any>_observableThrow(e);
                }
            } else
                return <Observable<CurrentReportUser>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportUser(response: HttpResponseBase): Observable<CurrentReportUser> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CurrentReportUser.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CurrentReportUser>(<any>null);
    }

    /**
     * @param reportName (optional) 
     * @param queryName (optional) 
     * @param body (optional) 
     * @return Success
     */
    setNewData(reportName: string | undefined, queryName: string | undefined, body: string[] | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Report/SetNewData?";
        if (reportName === null)
            throw new Error("The parameter 'reportName' cannot be null.");
        else if (reportName !== undefined)
            url_ += "reportName=" + encodeURIComponent("" + reportName) + "&"; 
        if (queryName === null)
            throw new Error("The parameter 'queryName' cannot be null.");
        else if (queryName !== undefined)
            url_ += "queryName=" + encodeURIComponent("" + queryName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetNewData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetNewData(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processSetNewData(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @return Success
     */
    getReportDataSource(): Observable<SqlQuery[]> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetReportDataSource";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportDataSource(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportDataSource(<any>response_);
                } catch (e) {
                    return <Observable<SqlQuery[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<SqlQuery[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportDataSource(response: HttpResponseBase): Observable<SqlQuery[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(SqlQuery.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SqlQuery[]>(<any>null);
    }

    /**
     * @param name (optional) 
     * @return Success
     */
    getDataField(name: string | undefined): Observable<IColumn[]> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetDataField?";
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "name=" + encodeURIComponent("" + name) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDataField(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDataField(<any>response_);
                } catch (e) {
                    return <Observable<IColumn[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<IColumn[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDataField(response: HttpResponseBase): Observable<IColumn[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(IColumn.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<IColumn[]>(<any>null);
    }

    /**
     * @return Success
     */
    getTenantConnectionString(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetTenantConnectionString";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantConnectionString(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantConnectionString(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantConnectionString(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    getStandardEditionForReport(): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetStandardEditionForReport";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetStandardEditionForReport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetStandardEditionForReport(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processGetStandardEditionForReport(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @return Success
     */
    getUserOrderTypesForReport(): Observable<OrderTypeIdList[]> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetUserOrderTypesForReport";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserOrderTypesForReport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserOrderTypesForReport(<any>response_);
                } catch (e) {
                    return <Observable<OrderTypeIdList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrderTypeIdList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserOrderTypesForReport(response: HttpResponseBase): Observable<OrderTypeIdList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrderTypeIdList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrderTypeIdList[]>(<any>null);
    }

    /**
     * @return Success
     */
    getUserLocationsForReport(): Observable<LocationIdList[]> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetUserLocationsForReport";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserLocationsForReport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserLocationsForReport(<any>response_);
                } catch (e) {
                    return <Observable<LocationIdList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<LocationIdList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserLocationsForReport(response: HttpResponseBase): Observable<LocationIdList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(LocationIdList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<LocationIdList[]>(<any>null);
    }

    /**
     * @return Success
     */
    getReportUrl(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Report/GetReportUrl";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportUrl(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportUrl(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportUrl(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class ReportPackageByZipCodeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param locationId (optional) 
     * @return Success
     */
    getReportPackageWithZipCode(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, locationId: number | undefined): Observable<ReportPackageByZipCodeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ReportPackageByZipCode/GetReportPackageWithZipCode?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportPackageWithZipCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportPackageWithZipCode(<any>response_);
                } catch (e) {
                    return <Observable<ReportPackageByZipCodeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ReportPackageByZipCodeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportPackageWithZipCode(response: HttpResponseBase): Observable<ReportPackageByZipCodeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ReportPackageByZipCodeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ReportPackageByZipCodeDto[]>(<any>null);
    }

    /**
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param locationId (optional) 
     * @return Success
     */
    getReportPackagePerZipCodeToExcel(startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, locationId: number | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/ReportPackageByZipCode/GetReportPackagePerZipCodeToExcel?";
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportPackagePerZipCodeToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportPackagePerZipCodeToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportPackagePerZipCodeToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param from (optional) 
     * @param thru (optional) 
     * @return Success
     */
    eachDay(from: moment.Moment | undefined, thru: moment.Moment | undefined): Observable<moment.Moment[]> {
        let url_ = this.baseUrl + "/api/services/app/ReportPackageByZipCode/EachDay?";
        if (from === null)
            throw new Error("The parameter 'from' cannot be null.");
        else if (from !== undefined)
            url_ += "from=" + encodeURIComponent(from ? "" + from.toJSON() : "") + "&"; 
        if (thru === null)
            throw new Error("The parameter 'thru' cannot be null.");
        else if (thru !== undefined)
            url_ += "thru=" + encodeURIComponent(thru ? "" + thru.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processEachDay(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processEachDay(<any>response_);
                } catch (e) {
                    return <Observable<moment.Moment[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<moment.Moment[]>><any>_observableThrow(response_);
        }));
    }

    protected processEachDay(response: HttpResponseBase): Observable<moment.Moment[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(moment(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<moment.Moment[]>(<any>null);
    }
}

@Injectable()
export class ReportScheduleServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param reportId (optional) 
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getReportSchedules(reportId: number | undefined, filter: string | undefined, nameFilter: string | undefined, descriptionFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfViewReportSchedulesDto> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/GetReportSchedules?";
        if (reportId === null)
            throw new Error("The parameter 'reportId' cannot be null.");
        else if (reportId !== undefined)
            url_ += "ReportId=" + encodeURIComponent("" + reportId) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportSchedules(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportSchedules(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfViewReportSchedulesDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfViewReportSchedulesDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportSchedules(response: HttpResponseBase): Observable<PagedResultDtoOfViewReportSchedulesDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfViewReportSchedulesDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfViewReportSchedulesDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createReportSchedule(body: CreateOrEditReportScheduleDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/CreateReportSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateReportSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateReportSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateReportSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param repeat (optional) 
     * @param startDay (optional) 
     * @param interval (optional) 
     * @param startDate (optional) 
     * @param dateGenerated (optional) 
     * @return Success
     */
    cronExpressionCreator(repeat: number | undefined, startDay: number | undefined, interval: number | undefined, startDate: moment.Moment | undefined, dateGenerated: moment.Moment | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/CronExpressionCreator?";
        if (repeat === null)
            throw new Error("The parameter 'repeat' cannot be null.");
        else if (repeat !== undefined)
            url_ += "repeat=" + encodeURIComponent("" + repeat) + "&"; 
        if (startDay === null)
            throw new Error("The parameter 'startDay' cannot be null.");
        else if (startDay !== undefined)
            url_ += "startDay=" + encodeURIComponent("" + startDay) + "&"; 
        if (interval === null)
            throw new Error("The parameter 'interval' cannot be null.");
        else if (interval !== undefined)
            url_ += "interval=" + encodeURIComponent("" + interval) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "startDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (dateGenerated === null)
            throw new Error("The parameter 'dateGenerated' cannot be null.");
        else if (dateGenerated !== undefined)
            url_ += "dateGenerated=" + encodeURIComponent(dateGenerated ? "" + dateGenerated.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCronExpressionCreator(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCronExpressionCreator(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processCronExpressionCreator(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createHangfireReportSchedule(body: ReportSchedules | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/CreateHangfireReportSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateHangfireReportSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateHangfireReportSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateHangfireReportSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getReportScheduleIfExisting(id: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/GetReportScheduleIfExisting?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportScheduleIfExisting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportScheduleIfExisting(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportScheduleIfExisting(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateReportSchedule(body: CreateOrEditReportScheduleDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/UpdateReportSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateReportSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateReportSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateReportSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param encodedData (optional) 
     * @return Success
     */
    decodeFrom64(encodedData: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/DecodeFrom64?";
        if (encodedData === null)
            throw new Error("The parameter 'encodedData' cannot be null.");
        else if (encodedData !== undefined)
            url_ += "encodedData=" + encodeURIComponent("" + encodedData) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDecodeFrom64(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDecodeFrom64(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processDecodeFrom64(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param reportScheduleId (optional) 
     * @return Success
     */
    getReportScheduleForEdit(reportScheduleId: number | undefined): Observable<GetReportScheduleForEdit> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/GetReportScheduleForEdit?";
        if (reportScheduleId === null)
            throw new Error("The parameter 'reportScheduleId' cannot be null.");
        else if (reportScheduleId !== undefined)
            url_ += "ReportScheduleId=" + encodeURIComponent("" + reportScheduleId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportScheduleForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportScheduleForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetReportScheduleForEdit>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetReportScheduleForEdit>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportScheduleForEdit(response: HttpResponseBase): Observable<GetReportScheduleForEdit> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetReportScheduleForEdit.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetReportScheduleForEdit>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteReportSchedules(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/DeleteReportSchedules?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteReportSchedules(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteReportSchedules(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteReportSchedules(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteReportScheduleRecipient(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/DeleteReportScheduleRecipient?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteReportScheduleRecipient(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteReportScheduleRecipient(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteReportScheduleRecipient(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addReportScheduleParameters(body: CreateReportScheduleParametersDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/AddReportScheduleParameters";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddReportScheduleParameters(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddReportScheduleParameters(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddReportScheduleParameters(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateReportScheduleParameters(body: CreateReportScheduleParametersDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/UpdateReportScheduleParameters";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateReportScheduleParameters(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateReportScheduleParameters(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateReportScheduleParameters(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param reportId (optional) 
     * @param parameterName (optional) 
     * @param filter (optional) 
     * @param isEdit (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getReportDefaultParameterValues(reportId: number | undefined, parameterName: string | undefined, filter: string | undefined, isEdit: boolean | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueReportDto> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/GetReportDefaultParameterValues?";
        if (reportId === null)
            throw new Error("The parameter 'reportId' cannot be null.");
        else if (reportId !== undefined)
            url_ += "ReportId=" + encodeURIComponent("" + reportId) + "&"; 
        if (parameterName === null)
            throw new Error("The parameter 'parameterName' cannot be null.");
        else if (parameterName !== undefined)
            url_ += "ParameterName=" + encodeURIComponent("" + parameterName) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (isEdit === null)
            throw new Error("The parameter 'isEdit' cannot be null.");
        else if (isEdit !== undefined)
            url_ += "IsEdit=" + encodeURIComponent("" + isEdit) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportDefaultParameterValues(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportDefaultParameterValues(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueReportDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueReportDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportDefaultParameterValues(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueReportDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueReportDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueReportDto>(<any>null);
    }

    /**
     * @param reportId (optional) 
     * @return Success
     */
    getReportParameters(reportId: number | undefined): Observable<GetReportParametersDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/GetReportParameters?";
        if (reportId === null)
            throw new Error("The parameter 'reportId' cannot be null.");
        else if (reportId !== undefined)
            url_ += "reportId=" + encodeURIComponent("" + reportId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportParameters(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportParameters(<any>response_);
                } catch (e) {
                    return <Observable<GetReportParametersDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetReportParametersDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportParameters(response: HttpResponseBase): Observable<GetReportParametersDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetReportParametersDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetReportParametersDto[]>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @return Success
     */
    getTenantConn(tenantId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/GetTenantConn?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantConn(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantConn(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantConn(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    connectionString(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/ConnectionString";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConnectionString(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConnectionString(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processConnectionString(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getReportName(id: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/GetReportName?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReportName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReportName(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetReportName(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    reportScheduleParameterChecker(body: ReportScheduleParameterCheckerInput | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/ReportScheduleParameterChecker";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processReportScheduleParameterChecker(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processReportScheduleParameterChecker(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processReportScheduleParameterChecker(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param lastModifierUserId (optional) 
     * @param timeZone (optional) 
     * @param dateGenerated (optional) 
     * @param timeInterval (optional) 
     * @param isDeleted (optional) 
     * @param deleterUserId (optional) 
     * @param deletionTime (optional) 
     * @param lastModificationTime (optional) 
     * @param creationTime (optional) 
     * @param creatorUserId (optional) 
     * @param id (optional) 
     * @return Success
     */
    getCronExpression(tenantId: number | undefined, lastModifierUserId: number | undefined, reportId: number, description: string, startDate: moment.Moment, startDay: number, repeat: number, isActive: boolean, exportType: string, ftpIsActive: boolean, timeZone: string | undefined, dateGenerated: moment.Moment | undefined, timeInterval: number | undefined, isDeleted: boolean | undefined, deleterUserId: number | undefined, deletionTime: moment.Moment | undefined, lastModificationTime: moment.Moment | undefined, creationTime: moment.Moment | undefined, creatorUserId: number | undefined, id: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/GetCronExpression?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (lastModifierUserId === null)
            throw new Error("The parameter 'lastModifierUserId' cannot be null.");
        else if (lastModifierUserId !== undefined)
            url_ += "LastModifierUserId=" + encodeURIComponent("" + lastModifierUserId) + "&"; 
        if (reportId === undefined || reportId === null)
            throw new Error("The parameter 'reportId' must be defined and cannot be null.");
        else
            url_ += "ReportId=" + encodeURIComponent("" + reportId) + "&"; 
        if (description === undefined || description === null)
            throw new Error("The parameter 'description' must be defined and cannot be null.");
        else
            url_ += "Description=" + encodeURIComponent("" + description) + "&"; 
        if (startDate === undefined || startDate === null)
            throw new Error("The parameter 'startDate' must be defined and cannot be null.");
        else
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (startDay === undefined || startDay === null)
            throw new Error("The parameter 'startDay' must be defined and cannot be null.");
        else
            url_ += "StartDay=" + encodeURIComponent("" + startDay) + "&"; 
        if (repeat === undefined || repeat === null)
            throw new Error("The parameter 'repeat' must be defined and cannot be null.");
        else
            url_ += "Repeat=" + encodeURIComponent("" + repeat) + "&"; 
        if (isActive === undefined || isActive === null)
            throw new Error("The parameter 'isActive' must be defined and cannot be null.");
        else
            url_ += "IsActive=" + encodeURIComponent("" + isActive) + "&"; 
        if (exportType === undefined || exportType === null)
            throw new Error("The parameter 'exportType' must be defined and cannot be null.");
        else
            url_ += "ExportType=" + encodeURIComponent("" + exportType) + "&"; 
        if (ftpIsActive === undefined || ftpIsActive === null)
            throw new Error("The parameter 'ftpIsActive' must be defined and cannot be null.");
        else
            url_ += "FtpIsActive=" + encodeURIComponent("" + ftpIsActive) + "&"; 
        if (timeZone === null)
            throw new Error("The parameter 'timeZone' cannot be null.");
        else if (timeZone !== undefined)
            url_ += "TimeZone=" + encodeURIComponent("" + timeZone) + "&"; 
        if (dateGenerated === null)
            throw new Error("The parameter 'dateGenerated' cannot be null.");
        else if (dateGenerated !== undefined)
            url_ += "DateGenerated=" + encodeURIComponent(dateGenerated ? "" + dateGenerated.toJSON() : "") + "&"; 
        if (timeInterval === null)
            throw new Error("The parameter 'timeInterval' cannot be null.");
        else if (timeInterval !== undefined)
            url_ += "TimeInterval=" + encodeURIComponent("" + timeInterval) + "&"; 
        if (isDeleted === null)
            throw new Error("The parameter 'isDeleted' cannot be null.");
        else if (isDeleted !== undefined)
            url_ += "IsDeleted=" + encodeURIComponent("" + isDeleted) + "&"; 
        if (deleterUserId === null)
            throw new Error("The parameter 'deleterUserId' cannot be null.");
        else if (deleterUserId !== undefined)
            url_ += "DeleterUserId=" + encodeURIComponent("" + deleterUserId) + "&"; 
        if (deletionTime === null)
            throw new Error("The parameter 'deletionTime' cannot be null.");
        else if (deletionTime !== undefined)
            url_ += "DeletionTime=" + encodeURIComponent(deletionTime ? "" + deletionTime.toJSON() : "") + "&"; 
        if (lastModificationTime === null)
            throw new Error("The parameter 'lastModificationTime' cannot be null.");
        else if (lastModificationTime !== undefined)
            url_ += "LastModificationTime=" + encodeURIComponent(lastModificationTime ? "" + lastModificationTime.toJSON() : "") + "&"; 
        if (creationTime === null)
            throw new Error("The parameter 'creationTime' cannot be null.");
        else if (creationTime !== undefined)
            url_ += "CreationTime=" + encodeURIComponent(creationTime ? "" + creationTime.toJSON() : "") + "&"; 
        if (creatorUserId === null)
            throw new Error("The parameter 'creatorUserId' cannot be null.");
        else if (creatorUserId !== undefined)
            url_ += "CreatorUserId=" + encodeURIComponent("" + creatorUserId) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCronExpression(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCronExpression(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetCronExpression(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    getUserLocationsOfReport(): Observable<LocationIdList[]> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/GetUserLocationsOfReport";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserLocationsOfReport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserLocationsOfReport(<any>response_);
                } catch (e) {
                    return <Observable<LocationIdList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<LocationIdList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserLocationsOfReport(response: HttpResponseBase): Observable<LocationIdList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(LocationIdList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<LocationIdList[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    testFtpConnection(body: CreateReportSchedulerFtpServersDto | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/TestFtpConnection";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTestFtpConnection(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTestFtpConnection(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processTestFtpConnection(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param timeZone (optional) 
     * @return Success
     */
    reportSchedulesSetupJob(tenantId: number | undefined, timeZone: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportSchedule/ReportSchedulesSetupJob?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (timeZone === null)
            throw new Error("The parameter 'timeZone' cannot be null.");
        else if (timeZone !== undefined)
            url_ += "timeZone=" + encodeURIComponent("" + timeZone) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processReportSchedulesSetupJob(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processReportSchedulesSetupJob(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processReportSchedulesSetupJob(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ReportSchedulerServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param tenantId (optional) 
     * @return Success
     */
    getTimezoneOfTenantMarkets(tenantId: number | undefined): Observable<MarketListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/GetTimezoneOfTenantMarkets?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimezoneOfTenantMarkets(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimezoneOfTenantMarkets(<any>response_);
                } catch (e) {
                    return <Observable<MarketListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<MarketListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimezoneOfTenantMarkets(response: HttpResponseBase): Observable<MarketListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(MarketListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<MarketListDto[]>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param scheduleStartDate (optional) 
     * @param scheduleEndDate (optional) 
     * @param scheduleId (optional) 
     * @param cronExpression (optional) 
     * @param body (optional) 
     * @return Success
     */
    exportToEmail(tenantId: number | undefined, scheduleStartDate: moment.Moment | undefined, scheduleEndDate: moment.Moment | undefined, scheduleId: number | undefined, cronExpression: string | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/ExportToEmail?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (scheduleStartDate === null)
            throw new Error("The parameter 'scheduleStartDate' cannot be null.");
        else if (scheduleStartDate !== undefined)
            url_ += "scheduleStartDate=" + encodeURIComponent(scheduleStartDate ? "" + scheduleStartDate.toJSON() : "") + "&"; 
        if (scheduleEndDate === null)
            throw new Error("The parameter 'scheduleEndDate' cannot be null.");
        else if (scheduleEndDate !== undefined)
            url_ += "scheduleEndDate=" + encodeURIComponent(scheduleEndDate ? "" + scheduleEndDate.toJSON() : "") + "&"; 
        if (scheduleId === null)
            throw new Error("The parameter 'scheduleId' cannot be null.");
        else if (scheduleId !== undefined)
            url_ += "scheduleId=" + encodeURIComponent("" + scheduleId) + "&"; 
        if (cronExpression === null)
            throw new Error("The parameter 'cronExpression' cannot be null.");
        else if (cronExpression !== undefined)
            url_ += "cronExpression=" + encodeURIComponent("" + cronExpression) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExportToEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExportToEmail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExportToEmail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param dateToday (optional) 
     * @param body (optional) 
     * @return Success
     */
    scheduleCron(dateToday: moment.Moment | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/ScheduleCron?";
        if (dateToday === null)
            throw new Error("The parameter 'dateToday' cannot be null.");
        else if (dateToday !== undefined)
            url_ += "dateToday=" + encodeURIComponent(dateToday ? "" + dateToday.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processScheduleCron(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processScheduleCron(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processScheduleCron(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    deleteFile(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/DeleteFile";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteFile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteFile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteFile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    decryptData(body: string | undefined): Observable<XDocument> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/DecryptData";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDecryptData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDecryptData(<any>response_);
                } catch (e) {
                    return <Observable<XDocument>><any>_observableThrow(e);
                }
            } else
                return <Observable<XDocument>><any>_observableThrow(response_);
        }));
    }

    protected processDecryptData(response: HttpResponseBase): Observable<XDocument> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = XDocument.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<XDocument>(<any>null);
    }

    /**
     * @param message (optional) 
     * @param body (optional) 
     * @return Success
     */
    logMessage(message: string | undefined, body: ConsoleTextColor | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/LogMessage?";
        if (message === null)
            throw new Error("The parameter 'message' cannot be null.");
        else if (message !== undefined)
            url_ += "message=" + encodeURIComponent("" + message) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLogMessage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLogMessage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLogMessage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param name (optional) 
     * @return Success
     */
    exportFile(name: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/ExportFile?";
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "name=" + encodeURIComponent("" + name) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExportFile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExportFile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExportFile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param name (optional) 
     * @return Success
     */
    pDFExport(name: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/PDFExport?";
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "name=" + encodeURIComponent("" + name) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPDFExport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPDFExport(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processPDFExport(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @return Success
     */
    getTenantConn(tenantId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/GetTenantConn?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantConn(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantConn(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantConn(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    connectionString(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/ConnectionString";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConnectionString(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConnectionString(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processConnectionString(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    uploadFile(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/UploadFile";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUploadFile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUploadFile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUploadFile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param subject (optional) 
     * @param mailMessage (optional) 
     * @param tenantId (optional) 
     * @param lab (optional) 
     * @param body (optional) 
     * @return Success
     */
    sendGridEmailReports(subject: string | undefined, mailMessage: string | undefined, tenantId: number | undefined, lab: boolean | undefined, body: string[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReportScheduler/SendGridEmailReports?";
        if (subject === null)
            throw new Error("The parameter 'subject' cannot be null.");
        else if (subject !== undefined)
            url_ += "subject=" + encodeURIComponent("" + subject) + "&"; 
        if (mailMessage === null)
            throw new Error("The parameter 'mailMessage' cannot be null.");
        else if (mailMessage !== undefined)
            url_ += "mailMessage=" + encodeURIComponent("" + mailMessage) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (lab === null)
            throw new Error("The parameter 'lab' cannot be null.");
        else if (lab !== undefined)
            url_ += "lab=" + encodeURIComponent("" + lab) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendGridEmailReports(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendGridEmailReports(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendGridEmailReports(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ReviewServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createReview(body: CreateReviewInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Review/CreateReview";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateReview(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateReview(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateReview(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param content (optional) 
     * @param rating (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getReview(id: number | undefined, content: string | undefined, rating: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfReviewListDto> {
        let url_ = this.baseUrl + "/api/services/app/Review/GetReview?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (content === null)
            throw new Error("The parameter 'content' cannot be null.");
        else if (content !== undefined)
            url_ += "Content=" + encodeURIComponent("" + content) + "&"; 
        if (rating === null)
            throw new Error("The parameter 'rating' cannot be null.");
        else if (rating !== undefined)
            url_ += "Rating=" + encodeURIComponent("" + rating) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReview(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReview(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfReviewListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfReviewListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetReview(response: HttpResponseBase): Observable<ListResultDtoOfReviewListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfReviewListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfReviewListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateReview(body: UpdateReviewInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Review/UpdateReview";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateReview(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateReview(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateReview(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteReview(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Review/DeleteReview?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteReview(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteReview(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteReview(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ReviewImageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createReviewImage(body: CreateReviewImageInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ReviewImage/CreateReviewImage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateReviewImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateReviewImage(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateReviewImage(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param reviewId (optional) 
     * @param imageId (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getReviewImage(id: number | undefined, reviewId: number | undefined, imageId: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfReviewImageListDto> {
        let url_ = this.baseUrl + "/api/services/app/ReviewImage/GetReviewImage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (reviewId === null)
            throw new Error("The parameter 'reviewId' cannot be null.");
        else if (reviewId !== undefined)
            url_ += "ReviewId=" + encodeURIComponent("" + reviewId) + "&"; 
        if (imageId === null)
            throw new Error("The parameter 'imageId' cannot be null.");
        else if (imageId !== undefined)
            url_ += "ImageId=" + encodeURIComponent("" + imageId) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetReviewImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetReviewImage(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfReviewImageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfReviewImageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetReviewImage(response: HttpResponseBase): Observable<ListResultDtoOfReviewImageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfReviewImageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfReviewImageListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateReviewImage(body: UpdateReviewImageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReviewImage/UpdateReviewImage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateReviewImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateReviewImage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateReviewImage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteReviewImage(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ReviewImage/DeleteReviewImage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteReviewImage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteReviewImage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteReviewImage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RoleServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param permissions (optional) 
     * @return Success
     */
    getRoles(permissions: string[] | undefined): Observable<ListResultDtoOfRoleListDto> {
        let url_ = this.baseUrl + "/api/services/app/Role/GetRoles?";
        if (permissions === null)
            throw new Error("The parameter 'permissions' cannot be null.");
        else if (permissions !== undefined)
            permissions && permissions.forEach(item => { url_ += "Permissions=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoles(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfRoleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfRoleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoles(response: HttpResponseBase): Observable<ListResultDtoOfRoleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfRoleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfRoleListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRoleForEdit(id: number | undefined): Observable<GetRoleForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Role/GetRoleForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoleForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoleForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRoleForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRoleForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoleForEdit(response: HttpResponseBase): Observable<GetRoleForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRoleForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRoleForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateRole(body: CreateOrUpdateRoleInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Role/CreateOrUpdateRole";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateRole(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateRole(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateRole(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteRole(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Role/DeleteRole?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRole(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRole(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRole(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generate(body: GenerateInputDto | undefined): Observable<GenerateResultDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/Generate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerate(<any>response_);
                } catch (e) {
                    return <Observable<GenerateResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GenerateResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGenerate(response: HttpResponseBase): Observable<GenerateResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GenerateResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GenerateResultDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    findOrCreateRouteTemplateByDriver(body: GetRouteTemplateByDriverInput | undefined): Observable<GetRouteTemplateByDriverDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/FindOrCreateRouteTemplateByDriver";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processFindOrCreateRouteTemplateByDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processFindOrCreateRouteTemplateByDriver(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteTemplateByDriverDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteTemplateByDriverDto>><any>_observableThrow(response_);
        }));
    }

    protected processFindOrCreateRouteTemplateByDriver(response: HttpResponseBase): Observable<GetRouteTemplateByDriverDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteTemplateByDriverDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteTemplateByDriverDto>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param contactId (optional) 
     * @param tenantId (optional) 
     * @return Success
     */
    getStartOrEndStopId(locationId: number | undefined, contactId: number | undefined, tenantId: number | undefined, type: StopTypes): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetStartOrEndStopId?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (type === undefined || type === null)
            throw new Error("The parameter 'type' must be defined and cannot be null.");
        else
            url_ += "Type=" + encodeURIComponent("" + type) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetStartOrEndStopId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetStartOrEndStopId(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetStartOrEndStopId(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param loadDate (optional) 
     * @return Success
     */
    getDuplicateRoutes(tenantId: number | undefined, loadDate: string | undefined): Observable<ValidateRouteDuplicationResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetDuplicateRoutes?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent("" + loadDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDuplicateRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDuplicateRoutes(<any>response_);
                } catch (e) {
                    return <Observable<ValidateRouteDuplicationResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ValidateRouteDuplicationResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetDuplicateRoutes(response: HttpResponseBase): Observable<ValidateRouteDuplicationResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ValidateRouteDuplicationResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ValidateRouteDuplicationResultDto[]>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param loadDate (optional) 
     * @param locationId (optional) 
     * @return Success
     */
    getLocWithUnMatchDestinations(tenantId: number | undefined, loadDate: string | undefined, locationId: number | undefined): Observable<ValidateOrderDestinationsResultDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetLocWithUnMatchDestinations?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "TenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent("" + loadDate) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocWithUnMatchDestinations(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocWithUnMatchDestinations(<any>response_);
                } catch (e) {
                    return <Observable<ValidateOrderDestinationsResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ValidateOrderDestinationsResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocWithUnMatchDestinations(response: HttpResponseBase): Observable<ValidateOrderDestinationsResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ValidateOrderDestinationsResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ValidateOrderDestinationsResultDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeTemplateId (optional) 
     * @param loadDate (optional) 
     * @param completion (optional) 
     * @param departure (optional) 
     * @param locked (optional) 
     * @param vehicle (optional) 
     * @param routeName (optional) 
     * @param location (optional) 
     * @param orderId (optional) 
     * @param driverId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getRoute(id: number | undefined, filter: string | undefined, locationId: number | undefined, vehicleId: number | undefined, routeTemplateId: number | undefined, loadDate: moment.Moment | undefined, completion: moment.Moment | undefined, departure: moment.Moment | undefined, locked: boolean | undefined, vehicle: string | undefined, routeName: string | undefined, location: string | undefined, orderId: number | undefined, driverId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRouteListDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetRoute?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent(completion ? "" + completion.toJSON() : "") + "&"; 
        if (departure === null)
            throw new Error("The parameter 'departure' cannot be null.");
        else if (departure !== undefined)
            url_ += "Departure=" + encodeURIComponent(departure ? "" + departure.toJSON() : "") + "&"; 
        if (locked === null)
            throw new Error("The parameter 'locked' cannot be null.");
        else if (locked !== undefined)
            url_ += "Locked=" + encodeURIComponent("" + locked) + "&"; 
        if (vehicle === null)
            throw new Error("The parameter 'vehicle' cannot be null.");
        else if (vehicle !== undefined)
            url_ += "Vehicle=" + encodeURIComponent("" + vehicle) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (location === null)
            throw new Error("The parameter 'location' cannot be null.");
        else if (location !== undefined)
            url_ += "Location=" + encodeURIComponent("" + location) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoute(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoute(response: HttpResponseBase): Observable<PagedResultDtoOfRouteListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param locationId (optional) 
     * @param vehicleId (optional) 
     * @param routeTemplateId (optional) 
     * @param loadDate (optional) 
     * @param completion (optional) 
     * @param departure (optional) 
     * @param locked (optional) 
     * @param vehicle (optional) 
     * @param routeName (optional) 
     * @param location (optional) 
     * @param orderId (optional) 
     * @param driverId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getRoutePaged(id: number | undefined, filter: string | undefined, locationId: number | undefined, vehicleId: number | undefined, routeTemplateId: number | undefined, loadDate: moment.Moment | undefined, completion: moment.Moment | undefined, departure: moment.Moment | undefined, locked: boolean | undefined, vehicle: string | undefined, routeName: string | undefined, location: string | undefined, orderId: number | undefined, driverId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRouteListDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetRoutePaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (completion === null)
            throw new Error("The parameter 'completion' cannot be null.");
        else if (completion !== undefined)
            url_ += "Completion=" + encodeURIComponent(completion ? "" + completion.toJSON() : "") + "&"; 
        if (departure === null)
            throw new Error("The parameter 'departure' cannot be null.");
        else if (departure !== undefined)
            url_ += "Departure=" + encodeURIComponent(departure ? "" + departure.toJSON() : "") + "&"; 
        if (locked === null)
            throw new Error("The parameter 'locked' cannot be null.");
        else if (locked !== undefined)
            url_ += "Locked=" + encodeURIComponent("" + locked) + "&"; 
        if (vehicle === null)
            throw new Error("The parameter 'vehicle' cannot be null.");
        else if (vehicle !== undefined)
            url_ += "Vehicle=" + encodeURIComponent("" + vehicle) + "&"; 
        if (routeName === null)
            throw new Error("The parameter 'routeName' cannot be null.");
        else if (routeName !== undefined)
            url_ += "RouteName=" + encodeURIComponent("" + routeName) + "&"; 
        if (location === null)
            throw new Error("The parameter 'location' cannot be null.");
        else if (location !== undefined)
            url_ += "Location=" + encodeURIComponent("" + location) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoutePaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoutePaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoutePaged(response: HttpResponseBase): Observable<PagedResultDtoOfRouteListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRoute(body: CreateRouteInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Route/CreateRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRoute(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRoute(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRoute(body: UpdateRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/UpdateRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param value (optional) 
     * @param dateTimeUTC (optional) 
     * @return Success
     */
    getUtcOffset(value: string | undefined, dateTimeUTC: moment.Moment | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetUtcOffset?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "value=" + encodeURIComponent("" + value) + "&"; 
        if (dateTimeUTC === null)
            throw new Error("The parameter 'dateTimeUTC' cannot be null.");
        else if (dateTimeUTC !== undefined)
            url_ += "dateTimeUTC=" + encodeURIComponent(dateTimeUTC ? "" + dateTimeUTC.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUtcOffset(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUtcOffset(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetUtcOffset(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateControllerRoute(body: UpdateRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/UpdateControllerRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateControllerRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateControllerRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateControllerRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteRoute(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/DeleteRoute?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAvailable(sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetAvailableRouteItemDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetAvailable?";
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAvailable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAvailable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetAvailableRouteItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetAvailableRouteItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAvailable(response: HttpResponseBase): Observable<PagedResultDtoOfGetAvailableRouteItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetAvailableRouteItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetAvailableRouteItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setActive(body: SetActiveRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/SetActive";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetActive(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetActive(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetActive(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getStops(): Observable<GetActiveRouteStopDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetStops";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetStops(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetStops(<any>response_);
                } catch (e) {
                    return <Observable<GetActiveRouteStopDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetActiveRouteStopDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetStops(response: HttpResponseBase): Observable<GetActiveRouteStopDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetActiveRouteStopDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetActiveRouteStopDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    changeSortOrder(body: ChangeSortOrderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/ChangeSortOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processChangeSortOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processChangeSortOrder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processChangeSortOrder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param routeOrderId (optional) 
     * @return Success
     */
    removeStop(routeId: number | undefined, routeOrderId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/RemoveStop?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (routeOrderId === null)
            throw new Error("The parameter 'routeOrderId' cannot be null.");
        else if (routeOrderId !== undefined)
            url_ += "RouteOrderId=" + encodeURIComponent("" + routeOrderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRemoveStop(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRemoveStop(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRemoveStop(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param mobileClientMessageId (optional) 
     * @param routeId (optional) 
     * @return Success
     */
    getOrdersForConfirmation(mobileClientMessageId: number | undefined, routeId: number | undefined): Observable<GetActiveRouteOrderDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetOrdersForConfirmation?";
        if (mobileClientMessageId === null)
            throw new Error("The parameter 'mobileClientMessageId' cannot be null.");
        else if (mobileClientMessageId !== undefined)
            url_ += "MobileClientMessageId=" + encodeURIComponent("" + mobileClientMessageId) + "&"; 
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrdersForConfirmation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrdersForConfirmation(<any>response_);
                } catch (e) {
                    return <Observable<GetActiveRouteOrderDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetActiveRouteOrderDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrdersForConfirmation(response: HttpResponseBase): Observable<GetActiveRouteOrderDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetActiveRouteOrderDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetActiveRouteOrderDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setStartTime(body: SetStartTimeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/SetStartTime";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetStartTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetStartTime(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetStartTime(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    arriveAtDestination(body: ArriveAtDestinationInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/ArriveAtDestination";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processArriveAtDestination(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processArriveAtDestination(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processArriveAtDestination(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    markDestinationComplete(body: ArriveAtDestinationInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/MarkDestinationComplete";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMarkDestinationComplete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMarkDestinationComplete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processMarkDestinationComplete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateDestinationsForRoute(body: Tenant | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/GenerateDestinationsForRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateDestinationsForRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateDestinationsForRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateDestinationsForRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    generateDestinations(routeId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/GenerateDestinations?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateDestinations(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateDestinations(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateDestinations(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param locationName (optional) 
     * @param inputDate (optional) 
     * @return Success
     */
    generateDestinationsForLocation(locationName: string | undefined, inputDate: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/GenerateDestinationsForLocation?";
        if (locationName === null)
            throw new Error("The parameter 'locationName' cannot be null.");
        else if (locationName !== undefined)
            url_ += "locationName=" + encodeURIComponent("" + locationName) + "&"; 
        if (inputDate === null)
            throw new Error("The parameter 'inputDate' cannot be null.");
        else if (inputDate !== undefined)
            url_ += "inputDate=" + encodeURIComponent("" + inputDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateDestinationsForLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateDestinationsForLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateDestinationsForLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    sortDestinationsByEta(routeId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/SortDestinationsByEta?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSortDestinationsByEta(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSortDestinationsByEta(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSortDestinationsByEta(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    checkForCompletion(routeId: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Route/CheckForCompletion?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckForCompletion(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckForCompletion(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processCheckForCompletion(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    markCompletedStandard(body: UpdateRouteId | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/MarkCompletedStandard";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processMarkCompletedStandard(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processMarkCompletedStandard(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processMarkCompletedStandard(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param locationName (optional) 
     * @param operationDate (optional) 
     * @return Success
     */
    generateMileageForLocation(locationName: string | undefined, operationDate: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/GenerateMileageForLocation?";
        if (locationName === null)
            throw new Error("The parameter 'locationName' cannot be null.");
        else if (locationName !== undefined)
            url_ += "locationName=" + encodeURIComponent("" + locationName) + "&"; 
        if (operationDate === null)
            throw new Error("The parameter 'operationDate' cannot be null.");
        else if (operationDate !== undefined)
            url_ += "operationDate=" + encodeURIComponent("" + operationDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateMileageForLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateMileageForLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateMileageForLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    generateMileage(routeId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/GenerateMileage?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateMileage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateMileage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateMileage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param destinationId (optional) 
     * @return Success
     */
    getLinehaulRouteForDestination(routeId: number | undefined, destinationId: number | undefined): Observable<GetLinehaulRouteForDestinationResponseDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetLinehaulRouteForDestination?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (destinationId === null)
            throw new Error("The parameter 'destinationId' cannot be null.");
        else if (destinationId !== undefined)
            url_ += "DestinationId=" + encodeURIComponent("" + destinationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLinehaulRouteForDestination(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLinehaulRouteForDestination(<any>response_);
                } catch (e) {
                    return <Observable<GetLinehaulRouteForDestinationResponseDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLinehaulRouteForDestinationResponseDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLinehaulRouteForDestination(response: HttpResponseBase): Observable<GetLinehaulRouteForDestinationResponseDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLinehaulRouteForDestinationResponseDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLinehaulRouteForDestinationResponseDto>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param destinationType (optional) 
     * @return Success
     */
    getDestinationsForRoute(routeId: number | undefined, destinationType: string | undefined): Observable<GetDestinationsForRouteResponseDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetDestinationsForRoute?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (destinationType === null)
            throw new Error("The parameter 'destinationType' cannot be null.");
        else if (destinationType !== undefined)
            url_ += "DestinationType=" + encodeURIComponent("" + destinationType) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDestinationsForRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDestinationsForRoute(<any>response_);
                } catch (e) {
                    return <Observable<GetDestinationsForRouteResponseDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDestinationsForRouteResponseDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDestinationsForRoute(response: HttpResponseBase): Observable<GetDestinationsForRouteResponseDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDestinationsForRouteResponseDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDestinationsForRouteResponseDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateDestinationForRoute(body: CreateOrUpdateDestinationForRouteInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/CreateOrUpdateDestinationForRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateDestinationForRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateDestinationForRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateDestinationForRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param destinationId (optional) 
     * @return Success
     */
    deleteDestinationForRoute(routeId: number | undefined, destinationId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/DeleteDestinationForRoute?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (destinationId === null)
            throw new Error("The parameter 'destinationId' cannot be null.");
        else if (destinationId !== undefined)
            url_ += "DestinationId=" + encodeURIComponent("" + destinationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteDestinationForRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteDestinationForRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteDestinationForRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setContainersForDestination(body: SetContainersForDestinationInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/SetContainersForDestination";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetContainersForDestination(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetContainersForDestination(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetContainersForDestination(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    refreshDeliveryContainers(routeId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/RefreshDeliveryContainers?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRefreshDeliveryContainers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRefreshDeliveryContainers(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRefreshDeliveryContainers(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    isDelivered(routeId: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/Route/IsDelivered?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIsDelivered(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIsDelivered(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processIsDelivered(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    cleanupOrderStatus(body: number[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/CleanupOrderStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCleanupOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCleanupOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCleanupOrderStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param operationDate (optional) 
     * @return Success
     */
    syncEstimatedStartTime(operationDate: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/SyncEstimatedStartTime?";
        if (operationDate === null)
            throw new Error("The parameter 'operationDate' cannot be null.");
        else if (operationDate !== undefined)
            url_ += "operationDate=" + encodeURIComponent("" + operationDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSyncEstimatedStartTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSyncEstimatedStartTime(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSyncEstimatedStartTime(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param operationDate (optional) 
     * @return Success
     */
    removeDuplicatePackages(operationDate: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/RemoveDuplicatePackages?";
        if (operationDate === null)
            throw new Error("The parameter 'operationDate' cannot be null.");
        else if (operationDate !== undefined)
            url_ += "operationDate=" + encodeURIComponent("" + operationDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRemoveDuplicatePackages(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRemoveDuplicatePackages(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRemoveDuplicatePackages(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    startRecursiveOrderPackageCleanup(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/StartRecursiveOrderPackageCleanup";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processStartRecursiveOrderPackageCleanup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processStartRecursiveOrderPackageCleanup(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processStartRecursiveOrderPackageCleanup(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getRecursiveOrderPackageCleanupDate(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetRecursiveOrderPackageCleanupDate";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRecursiveOrderPackageCleanupDate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRecursiveOrderPackageCleanupDate(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetRecursiveOrderPackageCleanupDate(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param operationDate (optional) 
     * @return Success
     */
    setRecursiveOrderPackageCleanupDate(operationDate: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/SetRecursiveOrderPackageCleanupDate?";
        if (operationDate === null)
            throw new Error("The parameter 'operationDate' cannot be null.");
        else if (operationDate !== undefined)
            url_ += "operationDate=" + encodeURIComponent("" + operationDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetRecursiveOrderPackageCleanupDate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetRecursiveOrderPackageCleanupDate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetRecursiveOrderPackageCleanupDate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getRouteDetailKpi(routeId: number | undefined): Observable<RouteDetailsKpi[]> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetRouteDetailKpi?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteDetailKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteDetailKpi(<any>response_);
                } catch (e) {
                    return <Observable<RouteDetailsKpi[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteDetailsKpi[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteDetailKpi(response: HttpResponseBase): Observable<RouteDetailsKpi[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteDetailsKpi.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteDetailsKpi[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRouteLocationKpi(locationId: number | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<RouteDetailsKpi[]> {
        let url_ = this.baseUrl + "/api/services/app/Route/GetRouteLocationKpi?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteLocationKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteLocationKpi(<any>response_);
                } catch (e) {
                    return <Observable<RouteDetailsKpi[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteDetailsKpi[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteLocationKpi(response: HttpResponseBase): Observable<RouteDetailsKpi[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteDetailsKpi.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteDetailsKpi[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateEstimatedStartTime(body: UpdateEstimatedStartTimeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/UpdateEstimatedStartTime";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateEstimatedStartTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateEstimatedStartTime(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateEstimatedStartTime(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    checkActiveRouteDetails(routeId: number | undefined): Observable<GetActiveRouteStopDto> {
        let url_ = this.baseUrl + "/api/services/app/Route/CheckActiveRouteDetails?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckActiveRouteDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckActiveRouteDetails(<any>response_);
                } catch (e) {
                    return <Observable<GetActiveRouteStopDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetActiveRouteStopDto>><any>_observableThrow(response_);
        }));
    }

    protected processCheckActiveRouteDetails(response: HttpResponseBase): Observable<GetActiveRouteStopDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetActiveRouteStopDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetActiveRouteStopDto>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    buildRouteDestinationsForLab(routeId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/BuildRouteDestinationsForLab?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteDestinationsForLab(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteDestinationsForLab(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteDestinationsForLab(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    buildRouteDestinationsForStandard(routeId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route/BuildRouteDestinationsForStandard?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "routeId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteDestinationsForStandard(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteDestinationsForStandard(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteDestinationsForStandard(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class Route4MeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    optimize(body: CreateOptimizeInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route4Me/Optimize";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOptimize(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOptimize(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processOptimize(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class Route4MeSettingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param valueFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, codeFilter: string | undefined, valueFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRoute4MeSettingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Route4MeSettings/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRoute4MeSettingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRoute4MeSettingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRoute4MeSettingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRoute4MeSettingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRoute4MeSettingForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRoute4MeSettingForView(id: number | undefined): Observable<GetRoute4MeSettingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Route4MeSettings/GetRoute4MeSettingForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoute4MeSettingForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoute4MeSettingForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRoute4MeSettingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRoute4MeSettingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoute4MeSettingForView(response: HttpResponseBase): Observable<GetRoute4MeSettingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRoute4MeSettingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRoute4MeSettingForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRoute4MeSettingForEdit(id: number | undefined): Observable<GetRoute4MeSettingForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Route4MeSettings/GetRoute4MeSettingForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoute4MeSettingForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoute4MeSettingForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRoute4MeSettingForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRoute4MeSettingForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoute4MeSettingForEdit(response: HttpResponseBase): Observable<GetRoute4MeSettingForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRoute4MeSettingForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRoute4MeSettingForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRoute4MeSettingDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route4MeSettings/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Route4MeSettings/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param valueFilter (optional) 
     * @return Success
     */
    getRoute4MeSettingsToExcel(filter: string | undefined, codeFilter: string | undefined, valueFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/Route4MeSettings/GetRoute4MeSettingsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoute4MeSettingsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoute4MeSettingsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoute4MeSettingsToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }
}

@Injectable()
export class RouteAnalyzerServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param locationId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param routeCode (optional) 
     * @param filter (optional) 
     * @param clinicNameFilter (optional) 
     * @param clinicAccountFilter (optional) 
     * @param dayFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getOrdersByLocation(locationId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, routeCode: string | undefined, filter: string | undefined, clinicNameFilter: string | undefined, clinicAccountFilter: string | undefined, dayFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<RouteAnalyzerOrderDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteAnalyzer/GetOrdersByLocation?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (routeCode === null)
            throw new Error("The parameter 'routeCode' cannot be null.");
        else if (routeCode !== undefined)
            url_ += "RouteCode=" + encodeURIComponent("" + routeCode) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicNameFilter === null)
            throw new Error("The parameter 'clinicNameFilter' cannot be null.");
        else if (clinicNameFilter !== undefined)
            url_ += "ClinicNameFilter=" + encodeURIComponent("" + clinicNameFilter) + "&"; 
        if (clinicAccountFilter === null)
            throw new Error("The parameter 'clinicAccountFilter' cannot be null.");
        else if (clinicAccountFilter !== undefined)
            url_ += "ClinicAccountFilter=" + encodeURIComponent("" + clinicAccountFilter) + "&"; 
        if (dayFilter === null)
            throw new Error("The parameter 'dayFilter' cannot be null.");
        else if (dayFilter !== undefined)
            url_ += "DayFilter=" + encodeURIComponent("" + dayFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrdersByLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrdersByLocation(<any>response_);
                } catch (e) {
                    return <Observable<RouteAnalyzerOrderDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteAnalyzerOrderDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrdersByLocation(response: HttpResponseBase): Observable<RouteAnalyzerOrderDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteAnalyzerOrderDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteAnalyzerOrderDto[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param routeCode (optional) 
     * @param filter (optional) 
     * @param clinicNameFilter (optional) 
     * @param clinicAccountFilter (optional) 
     * @param dayFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getStopsByLocation(locationId: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, routeCode: string | undefined, filter: string | undefined, clinicNameFilter: string | undefined, clinicAccountFilter: string | undefined, dayFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<RouteAnalyzerStopsDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteAnalyzer/GetStopsByLocation?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (routeCode === null)
            throw new Error("The parameter 'routeCode' cannot be null.");
        else if (routeCode !== undefined)
            url_ += "RouteCode=" + encodeURIComponent("" + routeCode) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicNameFilter === null)
            throw new Error("The parameter 'clinicNameFilter' cannot be null.");
        else if (clinicNameFilter !== undefined)
            url_ += "ClinicNameFilter=" + encodeURIComponent("" + clinicNameFilter) + "&"; 
        if (clinicAccountFilter === null)
            throw new Error("The parameter 'clinicAccountFilter' cannot be null.");
        else if (clinicAccountFilter !== undefined)
            url_ += "ClinicAccountFilter=" + encodeURIComponent("" + clinicAccountFilter) + "&"; 
        if (dayFilter === null)
            throw new Error("The parameter 'dayFilter' cannot be null.");
        else if (dayFilter !== undefined)
            url_ += "DayFilter=" + encodeURIComponent("" + dayFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetStopsByLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetStopsByLocation(<any>response_);
                } catch (e) {
                    return <Observable<RouteAnalyzerStopsDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteAnalyzerStopsDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetStopsByLocation(response: HttpResponseBase): Observable<RouteAnalyzerStopsDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteAnalyzerStopsDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteAnalyzerStopsDto[]>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param startDate (optional) 
     * @param routeCode (optional) 
     * @param dayFilter (optional) 
     * @return Success
     */
    getAnalyedDataToExcel(locationId: number | undefined, startDate: moment.Moment | undefined, routeCode: string | undefined, dayFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteAnalyzer/GetAnalyedDataToExcel?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (routeCode === null)
            throw new Error("The parameter 'routeCode' cannot be null.");
        else if (routeCode !== undefined)
            url_ += "RouteCode=" + encodeURIComponent("" + routeCode) + "&"; 
        if (dayFilter === null)
            throw new Error("The parameter 'dayFilter' cannot be null.");
        else if (dayFilter !== undefined)
            url_ += "DayFilter=" + encodeURIComponent("" + dayFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAnalyedDataToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAnalyedDataToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAnalyedDataToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateSchedule(body: UpdateScheduleInput[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteAnalyzer/UpdateSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteTemplate(body: UpdateRoutetemplateInput[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteAnalyzer/UpdateRouteTemplate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteTemplate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteTemplate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteTemplate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    routeCodeList(body: RouteCodeListInput | undefined): Observable<string[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteAnalyzer/RouteCodeList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRouteCodeList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRouteCodeList(<any>response_);
                } catch (e) {
                    return <Observable<string[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<string[]>><any>_observableThrow(response_);
        }));
    }

    protected processRouteCodeList(response: HttpResponseBase): Observable<string[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    routeCodesList(body: RouteCodeListInputFilter | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteAnalyzer/RouteCodesList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRouteCodesList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRouteCodesList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processRouteCodesList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getTenantConnectionString(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/RouteAnalyzer/GetTenantConnectionString";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantConnectionString(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantConnectionString(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantConnectionString(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class RouteBuilderServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    saveSortingRouteBuilder(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/SaveSortingRouteBuilder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSaveSortingRouteBuilder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSaveSortingRouteBuilder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSaveSortingRouteBuilder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    saveSortingRouteBuilderLocal(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/SaveSortingRouteBuilderLocal";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSaveSortingRouteBuilderLocal(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSaveSortingRouteBuilderLocal(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSaveSortingRouteBuilderLocal(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRoute(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRoute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRoute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteLocal(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteLocal";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteLocal(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteLocal(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteLocal(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteReverse(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteReverse";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteReverse(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteReverse(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteReverse(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteLocalReverse(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteLocalReverse";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteLocalReverse(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteLocalReverse(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteLocalReverse(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteNearToFar(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteNearToFar";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteNearToFar(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteNearToFar(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteNearToFar(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteLocalNearToFar(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteLocalNearToFar";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteLocalNearToFar(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteLocalNearToFar(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteLocalNearToFar(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteHybrid(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteHybrid";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteHybrid(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteHybrid(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteHybrid(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteLocalHybrid(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteLocalHybrid";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteLocalHybrid(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteLocalHybrid(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteLocalHybrid(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteReverseHybrid(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteReverseHybrid";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteReverseHybrid(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteReverseHybrid(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteReverseHybrid(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteLocalReverseHybrid(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteLocalReverseHybrid";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteLocalReverseHybrid(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteLocalReverseHybrid(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteLocalReverseHybrid(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteNearToFarHybrid(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteNearToFarHybrid";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteNearToFarHybrid(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteNearToFarHybrid(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteNearToFarHybrid(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    buildRouteLocalNearToFarHybrid(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/BuildRouteLocalNearToFarHybrid";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBuildRouteLocalNearToFarHybrid(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBuildRouteLocalNearToFarHybrid(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBuildRouteLocalNearToFarHybrid(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param addressId (optional) 
     * @return Success
     */
    getAddressById(addressId: number | undefined): Observable<CreateAddressInput> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/GetAddressById?";
        if (addressId === null)
            throw new Error("The parameter 'addressId' cannot be null.");
        else if (addressId !== undefined)
            url_ += "AddressId=" + encodeURIComponent("" + addressId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAddressById(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAddressById(<any>response_);
                } catch (e) {
                    return <Observable<CreateAddressInput>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateAddressInput>><any>_observableThrow(response_);
        }));
    }

    protected processGetAddressById(response: HttpResponseBase): Observable<CreateAddressInput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateAddressInput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateAddressInput>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param orderType (optional) 
     * @param defaultEtas (optional) 
     * @param generateRouteDest (optional) 
     * @return Success
     */
    getRouteForRouteBuilder(routeId: number | undefined, orderType: number[] | undefined, defaultEtas: OrderDefaultEtas[] | undefined, generateRouteDest: boolean | undefined): Observable<RouteBuilderRouteIdOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/GetRouteForRouteBuilder?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (orderType === null)
            throw new Error("The parameter 'orderType' cannot be null.");
        else if (orderType !== undefined)
            orderType && orderType.forEach(item => { url_ += "OrderType=" + encodeURIComponent("" + item) + "&"; });
        if (defaultEtas === null)
            throw new Error("The parameter 'defaultEtas' cannot be null.");
        else if (defaultEtas !== undefined)
            defaultEtas && defaultEtas.forEach((item, index) => { 
                for (let attr in item)
        			if (item.hasOwnProperty(attr)) {
        				url_ += "DefaultEtas[" + index + "]." + attr + "=" + encodeURIComponent("" + (<any>item)[attr]) + "&";
        			}
            });
        if (generateRouteDest === null)
            throw new Error("The parameter 'generateRouteDest' cannot be null.");
        else if (generateRouteDest !== undefined)
            url_ += "GenerateRouteDest=" + encodeURIComponent("" + generateRouteDest) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteForRouteBuilder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteForRouteBuilder(<any>response_);
                } catch (e) {
                    return <Observable<RouteBuilderRouteIdOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteBuilderRouteIdOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteForRouteBuilder(response: HttpResponseBase): Observable<RouteBuilderRouteIdOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = RouteBuilderRouteIdOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteBuilderRouteIdOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDestinationEta(body: UpdateDestinationEtaInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/UpdateDestinationEta";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDestinationEta(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDestinationEta(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDestinationEta(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    optimizeRouteGen(body: OptimizeByRouteIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/OptimizeRouteGen";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOptimizeRouteGen(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOptimizeRouteGen(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processOptimizeRouteGen(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    removeDestinationDetail(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/RemoveDestinationDetail?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRemoveDestinationDetail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRemoveDestinationDetail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRemoveDestinationDetail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param opt (optional) 
     * @param body (optional) 
     * @return Success
     */
    generalOptimizeBuilder(opt: number | undefined, body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/GeneralOptimizeBuilder?";
        if (opt === null)
            throw new Error("The parameter 'opt' cannot be null.");
        else if (opt !== undefined)
            url_ += "opt=" + encodeURIComponent("" + opt) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGeneralOptimizeBuilder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGeneralOptimizeBuilder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGeneralOptimizeBuilder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    eTAUpdateRealTime(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/ETAUpdateRealTime";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processETAUpdateRealTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processETAUpdateRealTime(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processETAUpdateRealTime(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    eTAUpdateRealTimeLocal(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteBuilder/ETAUpdateRealTimeLocal";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processETAUpdateRealTimeLocal(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processETAUpdateRealTimeLocal(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processETAUpdateRealTimeLocal(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteDefinitionsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param routeTypeRouteTypeCodeFilter (optional) 
     * @param routeTemplateNameFilter (optional) 
     * @param routeTypeId (optional) 
     * @param driverId (optional) 
     * @param locationId (optional) 
     * @param managerId (optional) 
     * @param assignedById (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param routeTemplateId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, routeTypeRouteTypeCodeFilter: string | undefined, routeTemplateNameFilter: string | undefined, routeTypeId: number | undefined, driverId: number | undefined, locationId: number | undefined, managerId: number | undefined, assignedById: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, routeTemplateId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteDefinitionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (routeTypeRouteTypeCodeFilter === null)
            throw new Error("The parameter 'routeTypeRouteTypeCodeFilter' cannot be null.");
        else if (routeTypeRouteTypeCodeFilter !== undefined)
            url_ += "RouteTypeRouteTypeCodeFilter=" + encodeURIComponent("" + routeTypeRouteTypeCodeFilter) + "&"; 
        if (routeTemplateNameFilter === null)
            throw new Error("The parameter 'routeTemplateNameFilter' cannot be null.");
        else if (routeTemplateNameFilter !== undefined)
            url_ += "RouteTemplateNameFilter=" + encodeURIComponent("" + routeTemplateNameFilter) + "&"; 
        if (routeTypeId === null)
            throw new Error("The parameter 'routeTypeId' cannot be null.");
        else if (routeTypeId !== undefined)
            url_ += "RouteTypeId=" + encodeURIComponent("" + routeTypeId) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (managerId === null)
            throw new Error("The parameter 'managerId' cannot be null.");
        else if (managerId !== undefined)
            url_ += "ManagerId=" + encodeURIComponent("" + managerId) + "&"; 
        if (assignedById === null)
            throw new Error("The parameter 'assignedById' cannot be null.");
        else if (assignedById !== undefined)
            url_ += "AssignedById=" + encodeURIComponent("" + assignedById) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteDefinitionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteDefinitionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteDefinitionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteDefinitionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteDefinitionForViewDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    showPagedRouteDefinitionForSearch(body: GetAllRouteDefinitionsInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/ShowPagedRouteDefinitionForSearch";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processShowPagedRouteDefinitionForSearch(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processShowPagedRouteDefinitionForSearch(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processShowPagedRouteDefinitionForSearch(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteDefinitionForView(id: number | undefined): Observable<GetRouteDefinitionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/GetRouteDefinitionForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteDefinitionForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteDefinitionForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteDefinitionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteDefinitionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteDefinitionForView(response: HttpResponseBase): Observable<GetRouteDefinitionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteDefinitionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteDefinitionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteDefinitionForEdit(id: number | undefined): Observable<GetRouteDefinitionForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/GetRouteDefinitionForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteDefinitionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteDefinitionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteDefinitionForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteDefinitionForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteDefinitionForEdit(response: HttpResponseBase): Observable<GetRouteDefinitionForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteDefinitionForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteDefinitionForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteDefinitionDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    checkActiveRoute(body: CheckActiveRouteInputDto | undefined): Observable<Route> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/CheckActiveRoute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckActiveRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckActiveRoute(<any>response_);
                } catch (e) {
                    return <Observable<Route>><any>_observableThrow(e);
                }
            } else
                return <Observable<Route>><any>_observableThrow(response_);
        }));
    }

    protected processCheckActiveRoute(response: HttpResponseBase): Observable<Route> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = Route.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<Route>(<any>null);
    }

    /**
     * @param zoneIdInput (optional) 
     * @param body (optional) 
     * @return Success
     */
    saveRouteTemplateZone(zoneIdInput: number | undefined, body: RouteDefinition | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/SaveRouteTemplateZone?";
        if (zoneIdInput === null)
            throw new Error("The parameter 'zoneIdInput' cannot be null.");
        else if (zoneIdInput !== undefined)
            url_ += "zoneIdInput=" + encodeURIComponent("" + zoneIdInput) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSaveRouteTemplateZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSaveRouteTemplateZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSaveRouteTemplateZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteSupervisor(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/DeleteSupervisor?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteSupervisor(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteSupervisor(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteSupervisor(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param tenantId (optional) 
     * @return Success
     */
    routeGenRemoveCache(locationId: number | undefined, tenantId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/RouteGenRemoveCache?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "locationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRouteGenRemoveCache(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRouteGenRemoveCache(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRouteGenRemoveCache(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param maxThresholdFilter (optional) 
     * @param minThresholdFilter (optional) 
     * @param routeTypeRouteTypeCodeFilter (optional) 
     * @param routeTemplateNameFilter (optional) 
     * @return Success
     */
    getRouteDefinitionsToExcel(filter: string | undefined, maxThresholdFilter: number | undefined, minThresholdFilter: number | undefined, routeTypeRouteTypeCodeFilter: string | undefined, routeTemplateNameFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/GetRouteDefinitionsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (maxThresholdFilter === null)
            throw new Error("The parameter 'maxThresholdFilter' cannot be null.");
        else if (maxThresholdFilter !== undefined)
            url_ += "MaxThresholdFilter=" + encodeURIComponent("" + maxThresholdFilter) + "&"; 
        if (minThresholdFilter === null)
            throw new Error("The parameter 'minThresholdFilter' cannot be null.");
        else if (minThresholdFilter !== undefined)
            url_ += "MinThresholdFilter=" + encodeURIComponent("" + minThresholdFilter) + "&"; 
        if (routeTypeRouteTypeCodeFilter === null)
            throw new Error("The parameter 'routeTypeRouteTypeCodeFilter' cannot be null.");
        else if (routeTypeRouteTypeCodeFilter !== undefined)
            url_ += "RouteTypeRouteTypeCodeFilter=" + encodeURIComponent("" + routeTypeRouteTypeCodeFilter) + "&"; 
        if (routeTemplateNameFilter === null)
            throw new Error("The parameter 'routeTemplateNameFilter' cannot be null.");
        else if (routeTemplateNameFilter !== undefined)
            url_ += "RouteTemplateNameFilter=" + encodeURIComponent("" + routeTemplateNameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteDefinitionsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteDefinitionsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteDefinitionsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param typeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllRouteTypeForLookupTable(filter: string | undefined, typeFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/GetAllRouteTypeForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllRouteTypeForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllRouteTypeForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllRouteTypeForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllRouteTypes(): Observable<RouteTypeTemp[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/GetAllRouteTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllRouteTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllRouteTypes(<any>response_);
                } catch (e) {
                    return <Observable<RouteTypeTemp[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteTypeTemp[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllRouteTypes(response: HttpResponseBase): Observable<RouteTypeTemp[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteTypeTemp.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteTypeTemp[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param typeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllRouteTemplateForLookupTable(filter: string | undefined, typeFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/GetAllRouteTemplateForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllRouteTemplateForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllRouteTemplateForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllRouteTemplateForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto>(<any>null);
    }

    /**
     * @return Success
     */
    getManagerList(): Observable<GetManagerListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/GetManagerList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetManagerList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetManagerList(<any>response_);
                } catch (e) {
                    return <Observable<GetManagerListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetManagerListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetManagerList(response: HttpResponseBase): Observable<GetManagerListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetManagerListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetManagerListDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAdminList(): Observable<GetManagerListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/GetAdminList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAdminList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAdminList(<any>response_);
                } catch (e) {
                    return <Observable<GetManagerListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetManagerListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAdminList(response: HttpResponseBase): Observable<GetManagerListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetManagerListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetManagerListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    assignRoutesToManager(body: AssignRoutesToManagerInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/AssignRoutesToManager";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignRoutesToManager(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignRoutesToManager(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAssignRoutesToManager(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    assignManagerByLocation(body: AssignManagerByLocationInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteDefinitions/AssignManagerByLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignManagerByLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignManagerByLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAssignManagerByLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteGenerationSettingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param isFutureFilter (optional) 
     * @param maxNoOfDaysFilter (optional) 
     * @param minNoOfDaysFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, isFutureFilter: number | undefined, maxNoOfDaysFilter: number | undefined, minNoOfDaysFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteGenerationSettingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteGenerationSettings/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (isFutureFilter === null)
            throw new Error("The parameter 'isFutureFilter' cannot be null.");
        else if (isFutureFilter !== undefined)
            url_ += "IsFutureFilter=" + encodeURIComponent("" + isFutureFilter) + "&"; 
        if (maxNoOfDaysFilter === null)
            throw new Error("The parameter 'maxNoOfDaysFilter' cannot be null.");
        else if (maxNoOfDaysFilter !== undefined)
            url_ += "MaxNoOfDaysFilter=" + encodeURIComponent("" + maxNoOfDaysFilter) + "&"; 
        if (minNoOfDaysFilter === null)
            throw new Error("The parameter 'minNoOfDaysFilter' cannot be null.");
        else if (minNoOfDaysFilter !== undefined)
            url_ += "MinNoOfDaysFilter=" + encodeURIComponent("" + minNoOfDaysFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteGenerationSettingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteGenerationSettingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteGenerationSettingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteGenerationSettingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteGenerationSettingForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteGenerationSettingForView(id: number | undefined): Observable<GetRouteGenerationSettingForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteGenerationSettings/GetRouteGenerationSettingForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteGenerationSettingForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteGenerationSettingForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteGenerationSettingForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteGenerationSettingForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteGenerationSettingForView(response: HttpResponseBase): Observable<GetRouteGenerationSettingForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteGenerationSettingForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteGenerationSettingForViewDto>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteGenerationSettingForEdit(): Observable<GetRouteGenerationSettingForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteGenerationSettings/GetRouteGenerationSettingForEdit";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteGenerationSettingForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteGenerationSettingForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteGenerationSettingForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteGenerationSettingForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteGenerationSettingForEdit(response: HttpResponseBase): Observable<GetRouteGenerationSettingForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteGenerationSettingForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteGenerationSettingForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteGenerationSettingDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteGenerationSettings/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteGeneratorDashboardServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    executeRecurring(body: DashboardDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorDashboard/ExecuteRecurring";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExecuteRecurring(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExecuteRecurring(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExecuteRecurring(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param loadDate (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getHeaderData(filter: string | undefined, loadDate: moment.Moment | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<HeaderRouteGenerationDashboardDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorDashboard/GetHeaderData?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetHeaderData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetHeaderData(<any>response_);
                } catch (e) {
                    return <Observable<HeaderRouteGenerationDashboardDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<HeaderRouteGenerationDashboardDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetHeaderData(response: HttpResponseBase): Observable<HeaderRouteGenerationDashboardDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = HeaderRouteGenerationDashboardDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<HeaderRouteGenerationDashboardDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param loadDate (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getRecurring(filter: string | undefined, loadDate: moment.Moment | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetDashboardViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorDashboard/GetRecurring?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "LoadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRecurring(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRecurring(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetDashboardViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetDashboardViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRecurring(response: HttpResponseBase): Observable<PagedResultDtoOfGetDashboardViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetDashboardViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetDashboardViewDto>(<any>null);
    }
}

@Injectable()
export class RouteGeneratorLogsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param parametersFilter (optional) 
     * @param maxStatusFilter (optional) 
     * @param minStatusFilter (optional) 
     * @param maxAttemptsFilter (optional) 
     * @param minAttemptsFilter (optional) 
     * @param resultFilter (optional) 
     * @param emailSentFilter (optional) 
     * @param maxLoadDateFilter (optional) 
     * @param minLoadDateFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, parametersFilter: string | undefined, maxStatusFilter: number | undefined, minStatusFilter: number | undefined, maxAttemptsFilter: number | undefined, minAttemptsFilter: number | undefined, resultFilter: string | undefined, emailSentFilter: number | undefined, maxLoadDateFilter: moment.Moment | undefined, minLoadDateFilter: moment.Moment | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteGeneratorLogForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorLogs/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (parametersFilter === null)
            throw new Error("The parameter 'parametersFilter' cannot be null.");
        else if (parametersFilter !== undefined)
            url_ += "ParametersFilter=" + encodeURIComponent("" + parametersFilter) + "&"; 
        if (maxStatusFilter === null)
            throw new Error("The parameter 'maxStatusFilter' cannot be null.");
        else if (maxStatusFilter !== undefined)
            url_ += "MaxStatusFilter=" + encodeURIComponent("" + maxStatusFilter) + "&"; 
        if (minStatusFilter === null)
            throw new Error("The parameter 'minStatusFilter' cannot be null.");
        else if (minStatusFilter !== undefined)
            url_ += "MinStatusFilter=" + encodeURIComponent("" + minStatusFilter) + "&"; 
        if (maxAttemptsFilter === null)
            throw new Error("The parameter 'maxAttemptsFilter' cannot be null.");
        else if (maxAttemptsFilter !== undefined)
            url_ += "MaxAttemptsFilter=" + encodeURIComponent("" + maxAttemptsFilter) + "&"; 
        if (minAttemptsFilter === null)
            throw new Error("The parameter 'minAttemptsFilter' cannot be null.");
        else if (minAttemptsFilter !== undefined)
            url_ += "MinAttemptsFilter=" + encodeURIComponent("" + minAttemptsFilter) + "&"; 
        if (resultFilter === null)
            throw new Error("The parameter 'resultFilter' cannot be null.");
        else if (resultFilter !== undefined)
            url_ += "ResultFilter=" + encodeURIComponent("" + resultFilter) + "&"; 
        if (emailSentFilter === null)
            throw new Error("The parameter 'emailSentFilter' cannot be null.");
        else if (emailSentFilter !== undefined)
            url_ += "EmailSentFilter=" + encodeURIComponent("" + emailSentFilter) + "&"; 
        if (maxLoadDateFilter === null)
            throw new Error("The parameter 'maxLoadDateFilter' cannot be null.");
        else if (maxLoadDateFilter !== undefined)
            url_ += "MaxLoadDateFilter=" + encodeURIComponent(maxLoadDateFilter ? "" + maxLoadDateFilter.toJSON() : "") + "&"; 
        if (minLoadDateFilter === null)
            throw new Error("The parameter 'minLoadDateFilter' cannot be null.");
        else if (minLoadDateFilter !== undefined)
            url_ += "MinLoadDateFilter=" + encodeURIComponent(minLoadDateFilter ? "" + minLoadDateFilter.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteGeneratorLogForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteGeneratorLogForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteGeneratorLogForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteGeneratorLogForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteGeneratorLogForViewDto>(<any>null);
    }

    /**
     * @param jobId (optional) 
     * @param loadDate (optional) 
     * @param tenantId (optional) 
     * @return Success
     */
    getProcessing(jobId: string | undefined, loadDate: moment.Moment | undefined, tenantId: number | undefined): Observable<RouteGeneratorLog> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorLogs/GetProcessing?";
        if (jobId === null)
            throw new Error("The parameter 'jobId' cannot be null.");
        else if (jobId !== undefined)
            url_ += "jobId=" + encodeURIComponent("" + jobId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "loadDate=" + encodeURIComponent(loadDate ? "" + loadDate.toJSON() : "") + "&"; 
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetProcessing(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetProcessing(<any>response_);
                } catch (e) {
                    return <Observable<RouteGeneratorLog>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteGeneratorLog>><any>_observableThrow(response_);
        }));
    }

    protected processGetProcessing(response: HttpResponseBase): Observable<RouteGeneratorLog> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = RouteGeneratorLog.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteGeneratorLog>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteGeneratorLogForView(id: number | undefined): Observable<GetRouteGeneratorLogForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorLogs/GetRouteGeneratorLogForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteGeneratorLogForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteGeneratorLogForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteGeneratorLogForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteGeneratorLogForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteGeneratorLogForView(response: HttpResponseBase): Observable<GetRouteGeneratorLogForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteGeneratorLogForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteGeneratorLogForViewDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    log(body: CreateOrEditRouteGeneratorLogDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorLogs/Log";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLog(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLog(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendEmail(body: SendEmailDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorLogs/SendEmail";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendEmail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendEmail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendSMS(body: SendEmailDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorLogs/SendSMS";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendSMS(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendSMS(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendSMS(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteGeneratorLogs/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteHandOffDefinitionsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param routeTemplateNameFilter (optional) 
     * @param routeTypeRouteTypeCodeFilter (optional) 
     * @param routeTypeId (optional) 
     * @param driverId (optional) 
     * @param locationId (optional) 
     * @param managerId (optional) 
     * @param assignedById (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param routeTemplateId (optional) 
     * @param inActive (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, routeTemplateNameFilter: string | undefined, routeTypeRouteTypeCodeFilter: string | undefined, routeTypeId: number | undefined, driverId: number | undefined, locationId: number | undefined, managerId: number | undefined, assignedById: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, routeTemplateId: number | undefined, inActive: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteHandOffDefinitionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (routeTemplateNameFilter === null)
            throw new Error("The parameter 'routeTemplateNameFilter' cannot be null.");
        else if (routeTemplateNameFilter !== undefined)
            url_ += "RouteTemplateNameFilter=" + encodeURIComponent("" + routeTemplateNameFilter) + "&"; 
        if (routeTypeRouteTypeCodeFilter === null)
            throw new Error("The parameter 'routeTypeRouteTypeCodeFilter' cannot be null.");
        else if (routeTypeRouteTypeCodeFilter !== undefined)
            url_ += "RouteTypeRouteTypeCodeFilter=" + encodeURIComponent("" + routeTypeRouteTypeCodeFilter) + "&"; 
        if (routeTypeId === null)
            throw new Error("The parameter 'routeTypeId' cannot be null.");
        else if (routeTypeId !== undefined)
            url_ += "RouteTypeId=" + encodeURIComponent("" + routeTypeId) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (managerId === null)
            throw new Error("The parameter 'managerId' cannot be null.");
        else if (managerId !== undefined)
            url_ += "ManagerId=" + encodeURIComponent("" + managerId) + "&"; 
        if (assignedById === null)
            throw new Error("The parameter 'assignedById' cannot be null.");
        else if (assignedById !== undefined)
            url_ += "AssignedById=" + encodeURIComponent("" + assignedById) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        if (inActive === null)
            throw new Error("The parameter 'inActive' cannot be null.");
        else if (inActive !== undefined)
            url_ += "InActive=" + encodeURIComponent("" + inActive) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteHandOffDefinitionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteHandOffDefinitionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteHandOffDefinitionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteHandOffDefinitionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteHandOffDefinitionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteHandOffDefinitionForView(id: number | undefined): Observable<GetRouteHandOffDefinitionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/GetRouteHandOffDefinitionForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteHandOffDefinitionForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteHandOffDefinitionForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteHandOffDefinitionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteHandOffDefinitionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteHandOffDefinitionForView(response: HttpResponseBase): Observable<GetRouteHandOffDefinitionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteHandOffDefinitionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteHandOffDefinitionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteHandOffDefinitionForEdit(id: number | undefined): Observable<GetRouteHandOffDefinitionForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/GetRouteHandOffDefinitionForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteHandOffDefinitionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteHandOffDefinitionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteHandOffDefinitionForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteHandOffDefinitionForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteHandOffDefinitionForEdit(response: HttpResponseBase): Observable<GetRouteHandOffDefinitionForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteHandOffDefinitionForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteHandOffDefinitionForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteHandOffDefinitionDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeHandOffDefinitionId (optional) 
     * @return Success
     */
    checkLineHaulChildRoutes(routeHandOffDefinitionId: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/CheckLineHaulChildRoutes?";
        if (routeHandOffDefinitionId === null)
            throw new Error("The parameter 'routeHandOffDefinitionId' cannot be null.");
        else if (routeHandOffDefinitionId !== undefined)
            url_ += "routeHandOffDefinitionId=" + encodeURIComponent("" + routeHandOffDefinitionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckLineHaulChildRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckLineHaulChildRoutes(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCheckLineHaulChildRoutes(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param routeTemplateNameFilter (optional) 
     * @param routeTypeRouteTypeCodeFilter (optional) 
     * @param routeTypeId (optional) 
     * @param driverId (optional) 
     * @param locationId (optional) 
     * @param managerId (optional) 
     * @param assignedById (optional) 
     * @param startDate (optional) 
     * @param endDate (optional) 
     * @param routeTemplateId (optional) 
     * @param inActive (optional) 
     * @return Success
     */
    getRouteHandOffDefinitionsToExcel(filter: string | undefined, routeTemplateNameFilter: string | undefined, routeTypeRouteTypeCodeFilter: string | undefined, routeTypeId: number | undefined, driverId: number | undefined, locationId: number | undefined, managerId: number | undefined, assignedById: number | undefined, startDate: moment.Moment | undefined, endDate: moment.Moment | undefined, routeTemplateId: number | undefined, inActive: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/GetRouteHandOffDefinitionsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (routeTemplateNameFilter === null)
            throw new Error("The parameter 'routeTemplateNameFilter' cannot be null.");
        else if (routeTemplateNameFilter !== undefined)
            url_ += "RouteTemplateNameFilter=" + encodeURIComponent("" + routeTemplateNameFilter) + "&"; 
        if (routeTypeRouteTypeCodeFilter === null)
            throw new Error("The parameter 'routeTypeRouteTypeCodeFilter' cannot be null.");
        else if (routeTypeRouteTypeCodeFilter !== undefined)
            url_ += "RouteTypeRouteTypeCodeFilter=" + encodeURIComponent("" + routeTypeRouteTypeCodeFilter) + "&"; 
        if (routeTypeId === null)
            throw new Error("The parameter 'routeTypeId' cannot be null.");
        else if (routeTypeId !== undefined)
            url_ += "RouteTypeId=" + encodeURIComponent("" + routeTypeId) + "&"; 
        if (driverId === null)
            throw new Error("The parameter 'driverId' cannot be null.");
        else if (driverId !== undefined)
            url_ += "DriverId=" + encodeURIComponent("" + driverId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (managerId === null)
            throw new Error("The parameter 'managerId' cannot be null.");
        else if (managerId !== undefined)
            url_ += "ManagerId=" + encodeURIComponent("" + managerId) + "&"; 
        if (assignedById === null)
            throw new Error("The parameter 'assignedById' cannot be null.");
        else if (assignedById !== undefined)
            url_ += "AssignedById=" + encodeURIComponent("" + assignedById) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (endDate === null)
            throw new Error("The parameter 'endDate' cannot be null.");
        else if (endDate !== undefined)
            url_ += "EndDate=" + encodeURIComponent(endDate ? "" + endDate.toJSON() : "") + "&"; 
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        if (inActive === null)
            throw new Error("The parameter 'inActive' cannot be null.");
        else if (inActive !== undefined)
            url_ += "InActive=" + encodeURIComponent("" + inActive) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteHandOffDefinitionsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteHandOffDefinitionsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteHandOffDefinitionsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param typeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllRouteTemplateForLookupTable(filter: string | undefined, typeFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/GetAllRouteTemplateForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllRouteTemplateForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllRouteTemplateForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllRouteTemplateForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param typeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllRouteTypeForLookupTable(filter: string | undefined, typeFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/GetAllRouteTypeForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllRouteTypeForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllRouteTypeForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllRouteTypeForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto>(<any>null);
    }

    /**
     * @return Success
     */
    getManagersList(): Observable<GetManagerListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/GetManagersList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetManagersList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetManagersList(<any>response_);
                } catch (e) {
                    return <Observable<GetManagerListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetManagerListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetManagersList(response: HttpResponseBase): Observable<GetManagerListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetManagerListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetManagerListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    assignRoutesToManager(body: AssignRoutesToManagerInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/AssignRoutesToManager";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignRoutesToManager(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignRoutesToManager(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAssignRoutesToManager(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    assignManagerByLocation(body: AssignManagerByLocationInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/AssignManagerByLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignManagerByLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignManagerByLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAssignManagerByLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteSupervisor(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/DeleteSupervisor?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteSupervisor(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteSupervisor(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteSupervisor(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeHandOffDefinitionId (optional) 
     * @param active (optional) 
     * @param onDemand (optional) 
     * @return Success
     */
    setActiveLineHaul(routeHandOffDefinitionId: number | undefined, active: boolean | undefined, onDemand: boolean | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/SetActiveLineHaul?";
        if (routeHandOffDefinitionId === null)
            throw new Error("The parameter 'routeHandOffDefinitionId' cannot be null.");
        else if (routeHandOffDefinitionId !== undefined)
            url_ += "routeHandOffDefinitionId=" + encodeURIComponent("" + routeHandOffDefinitionId) + "&"; 
        if (active === null)
            throw new Error("The parameter 'active' cannot be null.");
        else if (active !== undefined)
            url_ += "active=" + encodeURIComponent("" + active) + "&"; 
        if (onDemand === null)
            throw new Error("The parameter 'onDemand' cannot be null.");
        else if (onDemand !== undefined)
            url_ += "onDemand=" + encodeURIComponent("" + onDemand) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetActiveLineHaul(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetActiveLineHaul(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetActiveLineHaul(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeHandOffDefinitionIds (optional) 
     * @return Success
     */
    getHandOffIds(routeHandOffDefinitionIds: number[] | undefined): Observable<number[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffDefinitions/GetHandOffIds?";
        if (routeHandOffDefinitionIds === null)
            throw new Error("The parameter 'routeHandOffDefinitionIds' cannot be null.");
        else if (routeHandOffDefinitionIds !== undefined)
            routeHandOffDefinitionIds && routeHandOffDefinitionIds.forEach(item => { url_ += "routeHandOffDefinitionIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetHandOffIds(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetHandOffIds(<any>response_);
                } catch (e) {
                    return <Observable<number[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<number[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetHandOffIds(response: HttpResponseBase): Observable<number[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number[]>(<any>null);
    }
}

@Injectable()
export class RouteHandOffScheduleDetailsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param routeCodeFilter (optional) 
     * @param maxEstimatedTimeOfArrivalFilter (optional) 
     * @param minEstimatedTimeOfArrivalFilter (optional) 
     * @param maxCutOffFilter (optional) 
     * @param minCutOffFilter (optional) 
     * @param automaticFilter (optional) 
     * @param willCallFilter (optional) 
     * @param maxOorRateFilter (optional) 
     * @param minOorRateFilter (optional) 
     * @param maxEffectivityDateFilter (optional) 
     * @param minEffectivityDateFilter (optional) 
     * @param maxRouteScheduleIdFilter (optional) 
     * @param minRouteScheduleIdFilter (optional) 
     * @param maxRouteTypeIdFilter (optional) 
     * @param minRouteTypeIdFilter (optional) 
     * @param routeScheduleClinicFkFilter (optional) 
     * @param routeTemplateTypeNameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, routeCodeFilter: string | undefined, maxEstimatedTimeOfArrivalFilter: moment.Moment | undefined, minEstimatedTimeOfArrivalFilter: moment.Moment | undefined, maxCutOffFilter: moment.Moment | undefined, minCutOffFilter: moment.Moment | undefined, automaticFilter: number | undefined, willCallFilter: number | undefined, maxOorRateFilter: number | undefined, minOorRateFilter: number | undefined, maxEffectivityDateFilter: moment.Moment | undefined, minEffectivityDateFilter: moment.Moment | undefined, maxRouteScheduleIdFilter: number | undefined, minRouteScheduleIdFilter: number | undefined, maxRouteTypeIdFilter: number | undefined, minRouteTypeIdFilter: number | undefined, routeScheduleClinicFkFilter: string | undefined, routeTemplateTypeNameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleDetails/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (routeCodeFilter === null)
            throw new Error("The parameter 'routeCodeFilter' cannot be null.");
        else if (routeCodeFilter !== undefined)
            url_ += "RouteCodeFilter=" + encodeURIComponent("" + routeCodeFilter) + "&"; 
        if (maxEstimatedTimeOfArrivalFilter === null)
            throw new Error("The parameter 'maxEstimatedTimeOfArrivalFilter' cannot be null.");
        else if (maxEstimatedTimeOfArrivalFilter !== undefined)
            url_ += "MaxEstimatedTimeOfArrivalFilter=" + encodeURIComponent(maxEstimatedTimeOfArrivalFilter ? "" + maxEstimatedTimeOfArrivalFilter.toJSON() : "") + "&"; 
        if (minEstimatedTimeOfArrivalFilter === null)
            throw new Error("The parameter 'minEstimatedTimeOfArrivalFilter' cannot be null.");
        else if (minEstimatedTimeOfArrivalFilter !== undefined)
            url_ += "MinEstimatedTimeOfArrivalFilter=" + encodeURIComponent(minEstimatedTimeOfArrivalFilter ? "" + minEstimatedTimeOfArrivalFilter.toJSON() : "") + "&"; 
        if (maxCutOffFilter === null)
            throw new Error("The parameter 'maxCutOffFilter' cannot be null.");
        else if (maxCutOffFilter !== undefined)
            url_ += "MaxCutOffFilter=" + encodeURIComponent(maxCutOffFilter ? "" + maxCutOffFilter.toJSON() : "") + "&"; 
        if (minCutOffFilter === null)
            throw new Error("The parameter 'minCutOffFilter' cannot be null.");
        else if (minCutOffFilter !== undefined)
            url_ += "MinCutOffFilter=" + encodeURIComponent(minCutOffFilter ? "" + minCutOffFilter.toJSON() : "") + "&"; 
        if (automaticFilter === null)
            throw new Error("The parameter 'automaticFilter' cannot be null.");
        else if (automaticFilter !== undefined)
            url_ += "AutomaticFilter=" + encodeURIComponent("" + automaticFilter) + "&"; 
        if (willCallFilter === null)
            throw new Error("The parameter 'willCallFilter' cannot be null.");
        else if (willCallFilter !== undefined)
            url_ += "WillCallFilter=" + encodeURIComponent("" + willCallFilter) + "&"; 
        if (maxOorRateFilter === null)
            throw new Error("The parameter 'maxOorRateFilter' cannot be null.");
        else if (maxOorRateFilter !== undefined)
            url_ += "MaxOorRateFilter=" + encodeURIComponent("" + maxOorRateFilter) + "&"; 
        if (minOorRateFilter === null)
            throw new Error("The parameter 'minOorRateFilter' cannot be null.");
        else if (minOorRateFilter !== undefined)
            url_ += "MinOorRateFilter=" + encodeURIComponent("" + minOorRateFilter) + "&"; 
        if (maxEffectivityDateFilter === null)
            throw new Error("The parameter 'maxEffectivityDateFilter' cannot be null.");
        else if (maxEffectivityDateFilter !== undefined)
            url_ += "MaxEffectivityDateFilter=" + encodeURIComponent(maxEffectivityDateFilter ? "" + maxEffectivityDateFilter.toJSON() : "") + "&"; 
        if (minEffectivityDateFilter === null)
            throw new Error("The parameter 'minEffectivityDateFilter' cannot be null.");
        else if (minEffectivityDateFilter !== undefined)
            url_ += "MinEffectivityDateFilter=" + encodeURIComponent(minEffectivityDateFilter ? "" + minEffectivityDateFilter.toJSON() : "") + "&"; 
        if (maxRouteScheduleIdFilter === null)
            throw new Error("The parameter 'maxRouteScheduleIdFilter' cannot be null.");
        else if (maxRouteScheduleIdFilter !== undefined)
            url_ += "MaxRouteScheduleIdFilter=" + encodeURIComponent("" + maxRouteScheduleIdFilter) + "&"; 
        if (minRouteScheduleIdFilter === null)
            throw new Error("The parameter 'minRouteScheduleIdFilter' cannot be null.");
        else if (minRouteScheduleIdFilter !== undefined)
            url_ += "MinRouteScheduleIdFilter=" + encodeURIComponent("" + minRouteScheduleIdFilter) + "&"; 
        if (maxRouteTypeIdFilter === null)
            throw new Error("The parameter 'maxRouteTypeIdFilter' cannot be null.");
        else if (maxRouteTypeIdFilter !== undefined)
            url_ += "MaxRouteTypeIdFilter=" + encodeURIComponent("" + maxRouteTypeIdFilter) + "&"; 
        if (minRouteTypeIdFilter === null)
            throw new Error("The parameter 'minRouteTypeIdFilter' cannot be null.");
        else if (minRouteTypeIdFilter !== undefined)
            url_ += "MinRouteTypeIdFilter=" + encodeURIComponent("" + minRouteTypeIdFilter) + "&"; 
        if (routeScheduleClinicFkFilter === null)
            throw new Error("The parameter 'routeScheduleClinicFkFilter' cannot be null.");
        else if (routeScheduleClinicFkFilter !== undefined)
            url_ += "RouteScheduleClinicFkFilter=" + encodeURIComponent("" + routeScheduleClinicFkFilter) + "&"; 
        if (routeTemplateTypeNameFilter === null)
            throw new Error("The parameter 'routeTemplateTypeNameFilter' cannot be null.");
        else if (routeTemplateTypeNameFilter !== undefined)
            url_ += "RouteTemplateTypeNameFilter=" + encodeURIComponent("" + routeTemplateTypeNameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteHandOffScheduleDetailForView(id: number | undefined): Observable<GetRouteHandOffScheduleDetailForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleDetails/GetRouteHandOffScheduleDetailForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteHandOffScheduleDetailForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteHandOffScheduleDetailForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteHandOffScheduleDetailForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteHandOffScheduleDetailForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteHandOffScheduleDetailForView(response: HttpResponseBase): Observable<GetRouteHandOffScheduleDetailForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteHandOffScheduleDetailForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteHandOffScheduleDetailForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteHandOffScheduleDetailForEdit(id: number | undefined): Observable<GetRouteHandOffScheduleDetailForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleDetails/GetRouteHandOffScheduleDetailForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteHandOffScheduleDetailForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteHandOffScheduleDetailForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteHandOffScheduleDetailForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteHandOffScheduleDetailForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteHandOffScheduleDetailForEdit(response: HttpResponseBase): Observable<GetRouteHandOffScheduleDetailForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteHandOffScheduleDetailForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteHandOffScheduleDetailForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteHandOffScheduleDetailDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleDetails/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeHandOffScheduleDetailId (optional) 
     * @return Success
     */
    checkLineHaulParentRoutes(routeHandOffScheduleDetailId: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleDetails/CheckLineHaulParentRoutes?";
        if (routeHandOffScheduleDetailId === null)
            throw new Error("The parameter 'routeHandOffScheduleDetailId' cannot be null.");
        else if (routeHandOffScheduleDetailId !== undefined)
            url_ += "routeHandOffScheduleDetailId=" + encodeURIComponent("" + routeHandOffScheduleDetailId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckLineHaulParentRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckLineHaulParentRoutes(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCheckLineHaulParentRoutes(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleDetails/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param typeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllRouteTemplateForLookupTable(filter: string | undefined, typeFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleDetails/GetAllRouteTemplateForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllRouteTemplateForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllRouteTemplateForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllRouteTemplateForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getLineHaulRouteSchedule(id: number | undefined): Observable<ListResultDtoOfGetLineHaulRouteScheduleDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleDetails/GetLineHaulRouteSchedule?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLineHaulRouteSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLineHaulRouteSchedule(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetLineHaulRouteScheduleDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetLineHaulRouteScheduleDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLineHaulRouteSchedule(response: HttpResponseBase): Observable<ListResultDtoOfGetLineHaulRouteScheduleDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetLineHaulRouteScheduleDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetLineHaulRouteScheduleDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    lockedEtaSchedule(body: LockedEtaScheduleInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleDetails/LockedEtaSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLockedEtaSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLockedEtaSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLockedEtaSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteHandOffScheduleSettingServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param routeHandOffScheduleId (optional) 
     * @return Success
     */
    getForRouteHandOffSchedule(routeHandOffScheduleId: number | undefined): Observable<ListResultDtoOfGetRouteScheduleSettingsItemDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleSetting/GetForRouteHandOffSchedule?";
        if (routeHandOffScheduleId === null)
            throw new Error("The parameter 'routeHandOffScheduleId' cannot be null.");
        else if (routeHandOffScheduleId !== undefined)
            url_ += "RouteHandOffScheduleId=" + encodeURIComponent("" + routeHandOffScheduleId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetForRouteHandOffSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetForRouteHandOffSchedule(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetRouteScheduleSettingsItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetRouteScheduleSettingsItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetForRouteHandOffSchedule(response: HttpResponseBase): Observable<ListResultDtoOfGetRouteScheduleSettingsItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetRouteScheduleSettingsItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetRouteScheduleSettingsItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateForRouteHandOffSchedule(body: CreateForRouteHandOffScheduleInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleSetting/CreateOrUpdateForRouteHandOffSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateForRouteHandOffSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateForRouteHandOffSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateForRouteHandOffSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeHandOffScheduleId (optional) 
     * @param code (optional) 
     * @return Success
     */
    deleteForRouteHandOffSchedule(routeHandOffScheduleId: number | undefined, code: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteHandOffScheduleSetting/DeleteForRouteHandOffSchedule?";
        if (routeHandOffScheduleId === null)
            throw new Error("The parameter 'routeHandOffScheduleId' cannot be null.");
        else if (routeHandOffScheduleId !== undefined)
            url_ += "RouteHandOffScheduleId=" + encodeURIComponent("" + routeHandOffScheduleId) + "&"; 
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteForRouteHandOffSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteForRouteHandOffSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteForRouteHandOffSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteOptimizationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderList(body: Order[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/UpdateOrderList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderList(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderList(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    standardOptimization(body: OptimizeByRouteIdInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/StandardOptimization";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processStandardOptimization(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processStandardOptimization(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processStandardOptimization(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param startTime (optional) 
     * @param distance (optional) 
     * @param body (optional) 
     * @return Success
     */
    manualComputationEta(startTime: moment.Moment | undefined, distance: number | undefined, body: LocationParameter | undefined): Observable<moment.Moment> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/ManualComputationEta?";
        if (startTime === null)
            throw new Error("The parameter 'startTime' cannot be null.");
        else if (startTime !== undefined)
            url_ += "StartTime=" + encodeURIComponent(startTime ? "" + startTime.toJSON() : "") + "&"; 
        if (distance === null)
            throw new Error("The parameter 'distance' cannot be null.");
        else if (distance !== undefined)
            url_ += "distance=" + encodeURIComponent("" + distance) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processManualComputationEta(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processManualComputationEta(<any>response_);
                } catch (e) {
                    return <Observable<moment.Moment>><any>_observableThrow(e);
                }
            } else
                return <Observable<moment.Moment>><any>_observableThrow(response_);
        }));
    }

    protected processManualComputationEta(response: HttpResponseBase): Observable<moment.Moment> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 ? moment(resultData200.toString()) : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<moment.Moment>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    reSortByEtaLab(body: OptimizeRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/ReSortByEtaLab";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processReSortByEtaLab(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processReSortByEtaLab(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processReSortByEtaLab(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    willCallOptimization(body: OptimizeWillCallInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/WillCallOptimization";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processWillCallOptimization(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processWillCallOptimization(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processWillCallOptimization(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    etaComputation(body: EtaComputationInput | undefined): Observable<EtaComputationReturn[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/EtaComputation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processEtaComputation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processEtaComputation(<any>response_);
                } catch (e) {
                    return <Observable<EtaComputationReturn[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<EtaComputationReturn[]>><any>_observableThrow(response_);
        }));
    }

    protected processEtaComputation(response: HttpResponseBase): Observable<EtaComputationReturn[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(EtaComputationReturn.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<EtaComputationReturn[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sortByEta(body: EtaComputationInput | undefined): Observable<EtaComputationReturn[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/SortByEta";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSortByEta(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSortByEta(<any>response_);
                } catch (e) {
                    return <Observable<EtaComputationReturn[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<EtaComputationReturn[]>><any>_observableThrow(response_);
        }));
    }

    protected processSortByEta(response: HttpResponseBase): Observable<EtaComputationReturn[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(EtaComputationReturn.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<EtaComputationReturn[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    reSortByEtaStandard(body: OptimizeRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/ReSortByEtaStandard";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processReSortByEtaStandard(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processReSortByEtaStandard(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processReSortByEtaStandard(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    calculateLiveEta(body: LiveEtaInput | undefined): Observable<LiveEtaResult> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/CalculateLiveEta";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCalculateLiveEta(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCalculateLiveEta(<any>response_);
                } catch (e) {
                    return <Observable<LiveEtaResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<LiveEtaResult>><any>_observableThrow(response_);
        }));
    }

    protected processCalculateLiveEta(response: HttpResponseBase): Observable<LiveEtaResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = LiveEtaResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<LiveEtaResult>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param routeCode (optional) 
     * @param startLang (optional) 
     * @param startLong (optional) 
     * @param endLang (optional) 
     * @param endLong (optional) 
     * @param initialDateTime (optional) 
     * @return Success
     */
    getLiveEta(orderId: number | undefined, routeCode: string | undefined, startLang: number | undefined, startLong: number | undefined, endLang: number | undefined, endLong: number | undefined, initialDateTime: moment.Moment | undefined): Observable<GetLiveEtaResult> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/GetLiveEta?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (routeCode === null)
            throw new Error("The parameter 'routeCode' cannot be null.");
        else if (routeCode !== undefined)
            url_ += "RouteCode=" + encodeURIComponent("" + routeCode) + "&"; 
        if (startLang === null)
            throw new Error("The parameter 'startLang' cannot be null.");
        else if (startLang !== undefined)
            url_ += "StartLang=" + encodeURIComponent("" + startLang) + "&"; 
        if (startLong === null)
            throw new Error("The parameter 'startLong' cannot be null.");
        else if (startLong !== undefined)
            url_ += "StartLong=" + encodeURIComponent("" + startLong) + "&"; 
        if (endLang === null)
            throw new Error("The parameter 'endLang' cannot be null.");
        else if (endLang !== undefined)
            url_ += "EndLang=" + encodeURIComponent("" + endLang) + "&"; 
        if (endLong === null)
            throw new Error("The parameter 'endLong' cannot be null.");
        else if (endLong !== undefined)
            url_ += "EndLong=" + encodeURIComponent("" + endLong) + "&"; 
        if (initialDateTime === null)
            throw new Error("The parameter 'initialDateTime' cannot be null.");
        else if (initialDateTime !== undefined)
            url_ += "InitialDateTime=" + encodeURIComponent(initialDateTime ? "" + initialDateTime.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLiveEta(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLiveEta(<any>response_);
                } catch (e) {
                    return <Observable<GetLiveEtaResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLiveEtaResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetLiveEta(response: HttpResponseBase): Observable<GetLiveEtaResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLiveEtaResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLiveEtaResult>(<any>null);
    }

    /**
     * @param optimize (optional) 
     * @param body (optional) 
     * @return Success
     */
    optimizerWillCall(optimize: boolean | undefined, body: LiveEtaInput | undefined): Observable<LiveEtaResult> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/OptimizerWillCall?";
        if (optimize === null)
            throw new Error("The parameter 'optimize' cannot be null.");
        else if (optimize !== undefined)
            url_ += "optimize=" + encodeURIComponent("" + optimize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOptimizerWillCall(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOptimizerWillCall(<any>response_);
                } catch (e) {
                    return <Observable<LiveEtaResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<LiveEtaResult>><any>_observableThrow(response_);
        }));
    }

    protected processOptimizerWillCall(response: HttpResponseBase): Observable<LiveEtaResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = LiveEtaResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<LiveEtaResult>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateEta(body: UpdateEtaInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/UpdateEta";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateEta(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateEta(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateEta(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    genericOptimize(body: OptimizeRouteInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/GenericOptimize";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenericOptimize(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenericOptimize(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenericOptimize(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param body (optional) 
     * @return Success
     */
    changeSort(routeId: number | undefined, body: OrderCooordinate[] | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/ChangeSort?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processChangeSort(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processChangeSort(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processChangeSort(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    eTAUpdateRealTime(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/ETAUpdateRealTime";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processETAUpdateRealTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processETAUpdateRealTime(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processETAUpdateRealTime(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    eTAUpdateRealTimeLocal(body: UpdateRouteByBuilderInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimization/ETAUpdateRealTimeLocal";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processETAUpdateRealTimeLocal(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processETAUpdateRealTimeLocal(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processETAUpdateRealTimeLocal(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteOptimizerRulesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param maxTimeForExecutionFilter (optional) 
     * @param minTimeForExecutionFilter (optional) 
     * @param orderTypeId (optional) 
     * @param maxDistanceFilter (optional) 
     * @param minDistanceFilter (optional) 
     * @param maxOrderPositionFilter (optional) 
     * @param minOrderPositionFilter (optional) 
     * @param useGoogle (optional) 
     * @param routeOptimizerNameFilter (optional) 
     * @param orderStatusTypeDescriptionFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, maxTimeForExecutionFilter: moment.Moment | undefined, minTimeForExecutionFilter: moment.Moment | undefined, orderTypeId: number | undefined, maxDistanceFilter: number | undefined, minDistanceFilter: number | undefined, maxOrderPositionFilter: number | undefined, minOrderPositionFilter: number | undefined, useGoogle: boolean | undefined, routeOptimizerNameFilter: string | undefined, orderStatusTypeDescriptionFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteOptimizerRuleForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizerRules/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (maxTimeForExecutionFilter === null)
            throw new Error("The parameter 'maxTimeForExecutionFilter' cannot be null.");
        else if (maxTimeForExecutionFilter !== undefined)
            url_ += "MaxTimeForExecutionFilter=" + encodeURIComponent(maxTimeForExecutionFilter ? "" + maxTimeForExecutionFilter.toJSON() : "") + "&"; 
        if (minTimeForExecutionFilter === null)
            throw new Error("The parameter 'minTimeForExecutionFilter' cannot be null.");
        else if (minTimeForExecutionFilter !== undefined)
            url_ += "MinTimeForExecutionFilter=" + encodeURIComponent(minTimeForExecutionFilter ? "" + minTimeForExecutionFilter.toJSON() : "") + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (maxDistanceFilter === null)
            throw new Error("The parameter 'maxDistanceFilter' cannot be null.");
        else if (maxDistanceFilter !== undefined)
            url_ += "MaxDistanceFilter=" + encodeURIComponent("" + maxDistanceFilter) + "&"; 
        if (minDistanceFilter === null)
            throw new Error("The parameter 'minDistanceFilter' cannot be null.");
        else if (minDistanceFilter !== undefined)
            url_ += "MinDistanceFilter=" + encodeURIComponent("" + minDistanceFilter) + "&"; 
        if (maxOrderPositionFilter === null)
            throw new Error("The parameter 'maxOrderPositionFilter' cannot be null.");
        else if (maxOrderPositionFilter !== undefined)
            url_ += "MaxOrderPositionFilter=" + encodeURIComponent("" + maxOrderPositionFilter) + "&"; 
        if (minOrderPositionFilter === null)
            throw new Error("The parameter 'minOrderPositionFilter' cannot be null.");
        else if (minOrderPositionFilter !== undefined)
            url_ += "MinOrderPositionFilter=" + encodeURIComponent("" + minOrderPositionFilter) + "&"; 
        if (useGoogle === null)
            throw new Error("The parameter 'useGoogle' cannot be null.");
        else if (useGoogle !== undefined)
            url_ += "UseGoogle=" + encodeURIComponent("" + useGoogle) + "&"; 
        if (routeOptimizerNameFilter === null)
            throw new Error("The parameter 'routeOptimizerNameFilter' cannot be null.");
        else if (routeOptimizerNameFilter !== undefined)
            url_ += "RouteOptimizerNameFilter=" + encodeURIComponent("" + routeOptimizerNameFilter) + "&"; 
        if (orderStatusTypeDescriptionFilter === null)
            throw new Error("The parameter 'orderStatusTypeDescriptionFilter' cannot be null.");
        else if (orderStatusTypeDescriptionFilter !== undefined)
            url_ += "OrderStatusTypeDescriptionFilter=" + encodeURIComponent("" + orderStatusTypeDescriptionFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteOptimizerRuleForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteOptimizerRuleForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteOptimizerRuleForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteOptimizerRuleForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteOptimizerRuleForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteOptimizerRuleForView(id: number | undefined): Observable<GetRouteOptimizerRuleForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizerRules/GetRouteOptimizerRuleForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteOptimizerRuleForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteOptimizerRuleForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteOptimizerRuleForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteOptimizerRuleForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteOptimizerRuleForView(response: HttpResponseBase): Observable<GetRouteOptimizerRuleForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteOptimizerRuleForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteOptimizerRuleForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteOptimizerRuleForEdit(id: number | undefined): Observable<GetRouteOptimizerRuleForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizerRules/GetRouteOptimizerRuleForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteOptimizerRuleForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteOptimizerRuleForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteOptimizerRuleForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteOptimizerRuleForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteOptimizerRuleForEdit(response: HttpResponseBase): Observable<GetRouteOptimizerRuleForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteOptimizerRuleForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteOptimizerRuleForEditOutput>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getOptimizerRuleForEdit(id: number | undefined): Observable<CreateOrEditRouteOptimizerRuleDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizerRules/GetOptimizerRuleForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOptimizerRuleForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOptimizerRuleForEdit(<any>response_);
                } catch (e) {
                    return <Observable<CreateOrEditRouteOptimizerRuleDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateOrEditRouteOptimizerRuleDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOptimizerRuleForEdit(response: HttpResponseBase): Observable<CreateOrEditRouteOptimizerRuleDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateOrEditRouteOptimizerRuleDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateOrEditRouteOptimizerRuleDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteOptimizerRuleDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizerRules/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizerRules/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param maxTimeForExecutionFilter (optional) 
     * @param minTimeForExecutionFilter (optional) 
     * @param orderTypeId (optional) 
     * @param maxDistanceFilter (optional) 
     * @param minDistanceFilter (optional) 
     * @param maxOrderPositionFilter (optional) 
     * @param minOrderPositionFilter (optional) 
     * @param routeOptimizerNameFilter (optional) 
     * @param orderStatusTypeDescriptionFilter (optional) 
     * @return Success
     */
    getRouteOptimizerRulesToExcel(filter: string | undefined, maxTimeForExecutionFilter: moment.Moment | undefined, minTimeForExecutionFilter: moment.Moment | undefined, orderTypeId: number | undefined, maxDistanceFilter: number | undefined, minDistanceFilter: number | undefined, maxOrderPositionFilter: number | undefined, minOrderPositionFilter: number | undefined, routeOptimizerNameFilter: string | undefined, orderStatusTypeDescriptionFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizerRules/GetRouteOptimizerRulesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (maxTimeForExecutionFilter === null)
            throw new Error("The parameter 'maxTimeForExecutionFilter' cannot be null.");
        else if (maxTimeForExecutionFilter !== undefined)
            url_ += "MaxTimeForExecutionFilter=" + encodeURIComponent(maxTimeForExecutionFilter ? "" + maxTimeForExecutionFilter.toJSON() : "") + "&"; 
        if (minTimeForExecutionFilter === null)
            throw new Error("The parameter 'minTimeForExecutionFilter' cannot be null.");
        else if (minTimeForExecutionFilter !== undefined)
            url_ += "MinTimeForExecutionFilter=" + encodeURIComponent(minTimeForExecutionFilter ? "" + minTimeForExecutionFilter.toJSON() : "") + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (maxDistanceFilter === null)
            throw new Error("The parameter 'maxDistanceFilter' cannot be null.");
        else if (maxDistanceFilter !== undefined)
            url_ += "MaxDistanceFilter=" + encodeURIComponent("" + maxDistanceFilter) + "&"; 
        if (minDistanceFilter === null)
            throw new Error("The parameter 'minDistanceFilter' cannot be null.");
        else if (minDistanceFilter !== undefined)
            url_ += "MinDistanceFilter=" + encodeURIComponent("" + minDistanceFilter) + "&"; 
        if (maxOrderPositionFilter === null)
            throw new Error("The parameter 'maxOrderPositionFilter' cannot be null.");
        else if (maxOrderPositionFilter !== undefined)
            url_ += "MaxOrderPositionFilter=" + encodeURIComponent("" + maxOrderPositionFilter) + "&"; 
        if (minOrderPositionFilter === null)
            throw new Error("The parameter 'minOrderPositionFilter' cannot be null.");
        else if (minOrderPositionFilter !== undefined)
            url_ += "MinOrderPositionFilter=" + encodeURIComponent("" + minOrderPositionFilter) + "&"; 
        if (routeOptimizerNameFilter === null)
            throw new Error("The parameter 'routeOptimizerNameFilter' cannot be null.");
        else if (routeOptimizerNameFilter !== undefined)
            url_ += "RouteOptimizerNameFilter=" + encodeURIComponent("" + routeOptimizerNameFilter) + "&"; 
        if (orderStatusTypeDescriptionFilter === null)
            throw new Error("The parameter 'orderStatusTypeDescriptionFilter' cannot be null.");
        else if (orderStatusTypeDescriptionFilter !== undefined)
            url_ += "OrderStatusTypeDescriptionFilter=" + encodeURIComponent("" + orderStatusTypeDescriptionFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteOptimizerRulesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteOptimizerRulesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteOptimizerRulesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllRouteOptimizerForTableDropdown(): Observable<RouteOptimizerRuleRouteOptimizerLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizerRules/GetAllRouteOptimizerForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllRouteOptimizerForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllRouteOptimizerForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<RouteOptimizerRuleRouteOptimizerLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteOptimizerRuleRouteOptimizerLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllRouteOptimizerForTableDropdown(response: HttpResponseBase): Observable<RouteOptimizerRuleRouteOptimizerLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteOptimizerRuleRouteOptimizerLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteOptimizerRuleRouteOptimizerLookupTableDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrderStatusTypeForTableDropdown(): Observable<RouteOptimizerRuleOrderStatusTypeLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizerRules/GetAllOrderStatusTypeForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderStatusTypeForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderStatusTypeForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<RouteOptimizerRuleOrderStatusTypeLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteOptimizerRuleOrderStatusTypeLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderStatusTypeForTableDropdown(response: HttpResponseBase): Observable<RouteOptimizerRuleOrderStatusTypeLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteOptimizerRuleOrderStatusTypeLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteOptimizerRuleOrderStatusTypeLookupTableDto[]>(<any>null);
    }
}

@Injectable()
export class RouteOptimizersServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param toll (optional) 
     * @param highwaysFilter (optional) 
     * @param ferriesFilter (optional) 
     * @param indoorFilter (optional) 
     * @param activeFilter (optional) 
     * @param maxStartPeriodFilter (optional) 
     * @param minStartPeriodFilter (optional) 
     * @param maxEndPeriodFilter (optional) 
     * @param minEndPeriodFilter (optional) 
     * @param locationNameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, toll: number | undefined, highwaysFilter: number | undefined, ferriesFilter: number | undefined, indoorFilter: number | undefined, activeFilter: number | undefined, maxStartPeriodFilter: moment.Moment | undefined, minStartPeriodFilter: moment.Moment | undefined, maxEndPeriodFilter: moment.Moment | undefined, minEndPeriodFilter: moment.Moment | undefined, locationNameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteOptimizerForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizers/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (toll === null)
            throw new Error("The parameter 'toll' cannot be null.");
        else if (toll !== undefined)
            url_ += "Toll=" + encodeURIComponent("" + toll) + "&"; 
        if (highwaysFilter === null)
            throw new Error("The parameter 'highwaysFilter' cannot be null.");
        else if (highwaysFilter !== undefined)
            url_ += "HighwaysFilter=" + encodeURIComponent("" + highwaysFilter) + "&"; 
        if (ferriesFilter === null)
            throw new Error("The parameter 'ferriesFilter' cannot be null.");
        else if (ferriesFilter !== undefined)
            url_ += "FerriesFilter=" + encodeURIComponent("" + ferriesFilter) + "&"; 
        if (indoorFilter === null)
            throw new Error("The parameter 'indoorFilter' cannot be null.");
        else if (indoorFilter !== undefined)
            url_ += "IndoorFilter=" + encodeURIComponent("" + indoorFilter) + "&"; 
        if (activeFilter === null)
            throw new Error("The parameter 'activeFilter' cannot be null.");
        else if (activeFilter !== undefined)
            url_ += "ActiveFilter=" + encodeURIComponent("" + activeFilter) + "&"; 
        if (maxStartPeriodFilter === null)
            throw new Error("The parameter 'maxStartPeriodFilter' cannot be null.");
        else if (maxStartPeriodFilter !== undefined)
            url_ += "MaxStartPeriodFilter=" + encodeURIComponent(maxStartPeriodFilter ? "" + maxStartPeriodFilter.toJSON() : "") + "&"; 
        if (minStartPeriodFilter === null)
            throw new Error("The parameter 'minStartPeriodFilter' cannot be null.");
        else if (minStartPeriodFilter !== undefined)
            url_ += "MinStartPeriodFilter=" + encodeURIComponent(minStartPeriodFilter ? "" + minStartPeriodFilter.toJSON() : "") + "&"; 
        if (maxEndPeriodFilter === null)
            throw new Error("The parameter 'maxEndPeriodFilter' cannot be null.");
        else if (maxEndPeriodFilter !== undefined)
            url_ += "MaxEndPeriodFilter=" + encodeURIComponent(maxEndPeriodFilter ? "" + maxEndPeriodFilter.toJSON() : "") + "&"; 
        if (minEndPeriodFilter === null)
            throw new Error("The parameter 'minEndPeriodFilter' cannot be null.");
        else if (minEndPeriodFilter !== undefined)
            url_ += "MinEndPeriodFilter=" + encodeURIComponent(minEndPeriodFilter ? "" + minEndPeriodFilter.toJSON() : "") + "&"; 
        if (locationNameFilter === null)
            throw new Error("The parameter 'locationNameFilter' cannot be null.");
        else if (locationNameFilter !== undefined)
            url_ += "LocationNameFilter=" + encodeURIComponent("" + locationNameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteOptimizerForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteOptimizerForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteOptimizerForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteOptimizerForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteOptimizerForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteOptimizerForView(id: number | undefined): Observable<GetRouteOptimizerForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizers/GetRouteOptimizerForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteOptimizerForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteOptimizerForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteOptimizerForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteOptimizerForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteOptimizerForView(response: HttpResponseBase): Observable<GetRouteOptimizerForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteOptimizerForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteOptimizerForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteOptimizerForEdit(id: number | undefined): Observable<CreateOrEditRouteOptimizerDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizers/GetRouteOptimizerForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteOptimizerForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteOptimizerForEdit(<any>response_);
                } catch (e) {
                    return <Observable<CreateOrEditRouteOptimizerDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateOrEditRouteOptimizerDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteOptimizerForEdit(response: HttpResponseBase): Observable<CreateOrEditRouteOptimizerDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateOrEditRouteOptimizerDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateOrEditRouteOptimizerDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteOptimizerDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizers/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizers/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param trafficFilter (optional) 
     * @param highwaysFilter (optional) 
     * @param ferriesFilter (optional) 
     * @param indoorFilter (optional) 
     * @param activeFilter (optional) 
     * @param maxStartPeriodFilter (optional) 
     * @param minStartPeriodFilter (optional) 
     * @param maxEndPeriodFilter (optional) 
     * @param minEndPeriodFilter (optional) 
     * @param locationNameFilter (optional) 
     * @return Success
     */
    getRouteOptimizersToExcel(filter: string | undefined, nameFilter: string | undefined, trafficFilter: number | undefined, highwaysFilter: number | undefined, ferriesFilter: number | undefined, indoorFilter: number | undefined, activeFilter: number | undefined, maxStartPeriodFilter: moment.Moment | undefined, minStartPeriodFilter: moment.Moment | undefined, maxEndPeriodFilter: moment.Moment | undefined, minEndPeriodFilter: moment.Moment | undefined, locationNameFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizers/GetRouteOptimizersToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (trafficFilter === null)
            throw new Error("The parameter 'trafficFilter' cannot be null.");
        else if (trafficFilter !== undefined)
            url_ += "TrafficFilter=" + encodeURIComponent("" + trafficFilter) + "&"; 
        if (highwaysFilter === null)
            throw new Error("The parameter 'highwaysFilter' cannot be null.");
        else if (highwaysFilter !== undefined)
            url_ += "HighwaysFilter=" + encodeURIComponent("" + highwaysFilter) + "&"; 
        if (ferriesFilter === null)
            throw new Error("The parameter 'ferriesFilter' cannot be null.");
        else if (ferriesFilter !== undefined)
            url_ += "FerriesFilter=" + encodeURIComponent("" + ferriesFilter) + "&"; 
        if (indoorFilter === null)
            throw new Error("The parameter 'indoorFilter' cannot be null.");
        else if (indoorFilter !== undefined)
            url_ += "IndoorFilter=" + encodeURIComponent("" + indoorFilter) + "&"; 
        if (activeFilter === null)
            throw new Error("The parameter 'activeFilter' cannot be null.");
        else if (activeFilter !== undefined)
            url_ += "ActiveFilter=" + encodeURIComponent("" + activeFilter) + "&"; 
        if (maxStartPeriodFilter === null)
            throw new Error("The parameter 'maxStartPeriodFilter' cannot be null.");
        else if (maxStartPeriodFilter !== undefined)
            url_ += "MaxStartPeriodFilter=" + encodeURIComponent(maxStartPeriodFilter ? "" + maxStartPeriodFilter.toJSON() : "") + "&"; 
        if (minStartPeriodFilter === null)
            throw new Error("The parameter 'minStartPeriodFilter' cannot be null.");
        else if (minStartPeriodFilter !== undefined)
            url_ += "MinStartPeriodFilter=" + encodeURIComponent(minStartPeriodFilter ? "" + minStartPeriodFilter.toJSON() : "") + "&"; 
        if (maxEndPeriodFilter === null)
            throw new Error("The parameter 'maxEndPeriodFilter' cannot be null.");
        else if (maxEndPeriodFilter !== undefined)
            url_ += "MaxEndPeriodFilter=" + encodeURIComponent(maxEndPeriodFilter ? "" + maxEndPeriodFilter.toJSON() : "") + "&"; 
        if (minEndPeriodFilter === null)
            throw new Error("The parameter 'minEndPeriodFilter' cannot be null.");
        else if (minEndPeriodFilter !== undefined)
            url_ += "MinEndPeriodFilter=" + encodeURIComponent(minEndPeriodFilter ? "" + minEndPeriodFilter.toJSON() : "") + "&"; 
        if (locationNameFilter === null)
            throw new Error("The parameter 'locationNameFilter' cannot be null.");
        else if (locationNameFilter !== undefined)
            url_ += "LocationNameFilter=" + encodeURIComponent("" + locationNameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteOptimizersToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteOptimizersToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteOptimizersToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllLocationForTableDropdown(): Observable<RouteOptimizerLocationLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/RouteOptimizers/GetAllLocationForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllLocationForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllLocationForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<RouteOptimizerLocationLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<RouteOptimizerLocationLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllLocationForTableDropdown(response: HttpResponseBase): Observable<RouteOptimizerLocationLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(RouteOptimizerLocationLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RouteOptimizerLocationLookupTableDto[]>(<any>null);
    }
}

@Injectable()
export class RouteScheduleDetailsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param routeCodeFilter (optional) 
     * @param maxEstimatedTimeOfArrivalFilter (optional) 
     * @param minEstimatedTimeOfArrivalFilter (optional) 
     * @param maxCutOffFilter (optional) 
     * @param minCutOffFilter (optional) 
     * @param automaticFilter (optional) 
     * @param willCallFilter (optional) 
     * @param maxOorRateFilter (optional) 
     * @param minOorRateFilter (optional) 
     * @param maxEffectivityDateFilter (optional) 
     * @param minEffectivityDateFilter (optional) 
     * @param maxRouteScheduleIdFilter (optional) 
     * @param minRouteScheduleIdFilter (optional) 
     * @param maxRouteTypeIdFilter (optional) 
     * @param minRouteTypeIdFilter (optional) 
     * @param routeScheduleClinicFkFilter (optional) 
     * @param routeTemplateTypeNameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, routeCodeFilter: string | undefined, maxEstimatedTimeOfArrivalFilter: moment.Moment | undefined, minEstimatedTimeOfArrivalFilter: moment.Moment | undefined, maxCutOffFilter: moment.Moment | undefined, minCutOffFilter: moment.Moment | undefined, automaticFilter: number | undefined, willCallFilter: number | undefined, maxOorRateFilter: number | undefined, minOorRateFilter: number | undefined, maxEffectivityDateFilter: moment.Moment | undefined, minEffectivityDateFilter: moment.Moment | undefined, maxRouteScheduleIdFilter: number | undefined, minRouteScheduleIdFilter: number | undefined, maxRouteTypeIdFilter: number | undefined, minRouteTypeIdFilter: number | undefined, routeScheduleClinicFkFilter: string | undefined, routeTemplateTypeNameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteScheduleDetailForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (routeCodeFilter === null)
            throw new Error("The parameter 'routeCodeFilter' cannot be null.");
        else if (routeCodeFilter !== undefined)
            url_ += "RouteCodeFilter=" + encodeURIComponent("" + routeCodeFilter) + "&"; 
        if (maxEstimatedTimeOfArrivalFilter === null)
            throw new Error("The parameter 'maxEstimatedTimeOfArrivalFilter' cannot be null.");
        else if (maxEstimatedTimeOfArrivalFilter !== undefined)
            url_ += "MaxEstimatedTimeOfArrivalFilter=" + encodeURIComponent(maxEstimatedTimeOfArrivalFilter ? "" + maxEstimatedTimeOfArrivalFilter.toJSON() : "") + "&"; 
        if (minEstimatedTimeOfArrivalFilter === null)
            throw new Error("The parameter 'minEstimatedTimeOfArrivalFilter' cannot be null.");
        else if (minEstimatedTimeOfArrivalFilter !== undefined)
            url_ += "MinEstimatedTimeOfArrivalFilter=" + encodeURIComponent(minEstimatedTimeOfArrivalFilter ? "" + minEstimatedTimeOfArrivalFilter.toJSON() : "") + "&"; 
        if (maxCutOffFilter === null)
            throw new Error("The parameter 'maxCutOffFilter' cannot be null.");
        else if (maxCutOffFilter !== undefined)
            url_ += "MaxCutOffFilter=" + encodeURIComponent(maxCutOffFilter ? "" + maxCutOffFilter.toJSON() : "") + "&"; 
        if (minCutOffFilter === null)
            throw new Error("The parameter 'minCutOffFilter' cannot be null.");
        else if (minCutOffFilter !== undefined)
            url_ += "MinCutOffFilter=" + encodeURIComponent(minCutOffFilter ? "" + minCutOffFilter.toJSON() : "") + "&"; 
        if (automaticFilter === null)
            throw new Error("The parameter 'automaticFilter' cannot be null.");
        else if (automaticFilter !== undefined)
            url_ += "AutomaticFilter=" + encodeURIComponent("" + automaticFilter) + "&"; 
        if (willCallFilter === null)
            throw new Error("The parameter 'willCallFilter' cannot be null.");
        else if (willCallFilter !== undefined)
            url_ += "WillCallFilter=" + encodeURIComponent("" + willCallFilter) + "&"; 
        if (maxOorRateFilter === null)
            throw new Error("The parameter 'maxOorRateFilter' cannot be null.");
        else if (maxOorRateFilter !== undefined)
            url_ += "MaxOorRateFilter=" + encodeURIComponent("" + maxOorRateFilter) + "&"; 
        if (minOorRateFilter === null)
            throw new Error("The parameter 'minOorRateFilter' cannot be null.");
        else if (minOorRateFilter !== undefined)
            url_ += "MinOorRateFilter=" + encodeURIComponent("" + minOorRateFilter) + "&"; 
        if (maxEffectivityDateFilter === null)
            throw new Error("The parameter 'maxEffectivityDateFilter' cannot be null.");
        else if (maxEffectivityDateFilter !== undefined)
            url_ += "MaxEffectivityDateFilter=" + encodeURIComponent(maxEffectivityDateFilter ? "" + maxEffectivityDateFilter.toJSON() : "") + "&"; 
        if (minEffectivityDateFilter === null)
            throw new Error("The parameter 'minEffectivityDateFilter' cannot be null.");
        else if (minEffectivityDateFilter !== undefined)
            url_ += "MinEffectivityDateFilter=" + encodeURIComponent(minEffectivityDateFilter ? "" + minEffectivityDateFilter.toJSON() : "") + "&"; 
        if (maxRouteScheduleIdFilter === null)
            throw new Error("The parameter 'maxRouteScheduleIdFilter' cannot be null.");
        else if (maxRouteScheduleIdFilter !== undefined)
            url_ += "MaxRouteScheduleIdFilter=" + encodeURIComponent("" + maxRouteScheduleIdFilter) + "&"; 
        if (minRouteScheduleIdFilter === null)
            throw new Error("The parameter 'minRouteScheduleIdFilter' cannot be null.");
        else if (minRouteScheduleIdFilter !== undefined)
            url_ += "MinRouteScheduleIdFilter=" + encodeURIComponent("" + minRouteScheduleIdFilter) + "&"; 
        if (maxRouteTypeIdFilter === null)
            throw new Error("The parameter 'maxRouteTypeIdFilter' cannot be null.");
        else if (maxRouteTypeIdFilter !== undefined)
            url_ += "MaxRouteTypeIdFilter=" + encodeURIComponent("" + maxRouteTypeIdFilter) + "&"; 
        if (minRouteTypeIdFilter === null)
            throw new Error("The parameter 'minRouteTypeIdFilter' cannot be null.");
        else if (minRouteTypeIdFilter !== undefined)
            url_ += "MinRouteTypeIdFilter=" + encodeURIComponent("" + minRouteTypeIdFilter) + "&"; 
        if (routeScheduleClinicFkFilter === null)
            throw new Error("The parameter 'routeScheduleClinicFkFilter' cannot be null.");
        else if (routeScheduleClinicFkFilter !== undefined)
            url_ += "RouteScheduleClinicFkFilter=" + encodeURIComponent("" + routeScheduleClinicFkFilter) + "&"; 
        if (routeTemplateTypeNameFilter === null)
            throw new Error("The parameter 'routeTemplateTypeNameFilter' cannot be null.");
        else if (routeTemplateTypeNameFilter !== undefined)
            url_ += "RouteTemplateTypeNameFilter=" + encodeURIComponent("" + routeTemplateTypeNameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteScheduleDetailForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteScheduleDetailForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteScheduleDetailForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteScheduleDetailForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteScheduleDetailForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteScheduleDetailForView(id: number | undefined): Observable<GetRouteScheduleDetailForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/GetRouteScheduleDetailForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteScheduleDetailForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteScheduleDetailForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteScheduleDetailForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteScheduleDetailForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteScheduleDetailForView(response: HttpResponseBase): Observable<GetRouteScheduleDetailForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteScheduleDetailForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteScheduleDetailForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteScheduleDetailForEdit(id: number | undefined): Observable<GetRouteScheduleDetailForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/GetRouteScheduleDetailForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteScheduleDetailForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteScheduleDetailForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteScheduleDetailForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteScheduleDetailForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteScheduleDetailForEdit(response: HttpResponseBase): Observable<GetRouteScheduleDetailForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteScheduleDetailForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteScheduleDetailForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteScheduleDetailDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param day (optional) 
     * @param body (optional) 
     * @return Success
     */
    dayIsLTA(day: string | undefined, body: CreateOrEditRouteScheduleDetailDto | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/DayIsLTA?";
        if (day === null)
            throw new Error("The parameter 'day' cannot be null.");
        else if (day !== undefined)
            url_ += "day=" + encodeURIComponent("" + day) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDayIsLTA(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDayIsLTA(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processDayIsLTA(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    lockedEtaSchedule(body: LockedEtaScheduleInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/LockedEtaSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLockedEtaSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLockedEtaSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLockedEtaSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    routeGenRemoveCache(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/RouteGenRemoveCache";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRouteGenRemoveCache(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRouteGenRemoveCache(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRouteGenRemoveCache(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param routeCodeFilter (optional) 
     * @param maxEstimatedTimeOfArrivalFilter (optional) 
     * @param minEstimatedTimeOfArrivalFilter (optional) 
     * @param maxCutOffFilter (optional) 
     * @param minCutOffFilter (optional) 
     * @param automaticFilter (optional) 
     * @param willCallFilter (optional) 
     * @param maxOorRateFilter (optional) 
     * @param minOorRateFilter (optional) 
     * @param maxEffectivityDateFilter (optional) 
     * @param minEffectivityDateFilter (optional) 
     * @param maxRouteScheduleIdFilter (optional) 
     * @param minRouteScheduleIdFilter (optional) 
     * @param maxRouteTypeIdFilter (optional) 
     * @param minRouteTypeIdFilter (optional) 
     * @param routeScheduleClinicFkFilter (optional) 
     * @return Success
     */
    getRouteScheduleDetailsToExcel(filter: string | undefined, routeCodeFilter: string | undefined, maxEstimatedTimeOfArrivalFilter: moment.Moment | undefined, minEstimatedTimeOfArrivalFilter: moment.Moment | undefined, maxCutOffFilter: moment.Moment | undefined, minCutOffFilter: moment.Moment | undefined, automaticFilter: number | undefined, willCallFilter: number | undefined, maxOorRateFilter: number | undefined, minOorRateFilter: number | undefined, maxEffectivityDateFilter: moment.Moment | undefined, minEffectivityDateFilter: moment.Moment | undefined, maxRouteScheduleIdFilter: number | undefined, minRouteScheduleIdFilter: number | undefined, maxRouteTypeIdFilter: number | undefined, minRouteTypeIdFilter: number | undefined, routeScheduleClinicFkFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/GetRouteScheduleDetailsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (routeCodeFilter === null)
            throw new Error("The parameter 'routeCodeFilter' cannot be null.");
        else if (routeCodeFilter !== undefined)
            url_ += "RouteCodeFilter=" + encodeURIComponent("" + routeCodeFilter) + "&"; 
        if (maxEstimatedTimeOfArrivalFilter === null)
            throw new Error("The parameter 'maxEstimatedTimeOfArrivalFilter' cannot be null.");
        else if (maxEstimatedTimeOfArrivalFilter !== undefined)
            url_ += "MaxEstimatedTimeOfArrivalFilter=" + encodeURIComponent(maxEstimatedTimeOfArrivalFilter ? "" + maxEstimatedTimeOfArrivalFilter.toJSON() : "") + "&"; 
        if (minEstimatedTimeOfArrivalFilter === null)
            throw new Error("The parameter 'minEstimatedTimeOfArrivalFilter' cannot be null.");
        else if (minEstimatedTimeOfArrivalFilter !== undefined)
            url_ += "MinEstimatedTimeOfArrivalFilter=" + encodeURIComponent(minEstimatedTimeOfArrivalFilter ? "" + minEstimatedTimeOfArrivalFilter.toJSON() : "") + "&"; 
        if (maxCutOffFilter === null)
            throw new Error("The parameter 'maxCutOffFilter' cannot be null.");
        else if (maxCutOffFilter !== undefined)
            url_ += "MaxCutOffFilter=" + encodeURIComponent(maxCutOffFilter ? "" + maxCutOffFilter.toJSON() : "") + "&"; 
        if (minCutOffFilter === null)
            throw new Error("The parameter 'minCutOffFilter' cannot be null.");
        else if (minCutOffFilter !== undefined)
            url_ += "MinCutOffFilter=" + encodeURIComponent(minCutOffFilter ? "" + minCutOffFilter.toJSON() : "") + "&"; 
        if (automaticFilter === null)
            throw new Error("The parameter 'automaticFilter' cannot be null.");
        else if (automaticFilter !== undefined)
            url_ += "AutomaticFilter=" + encodeURIComponent("" + automaticFilter) + "&"; 
        if (willCallFilter === null)
            throw new Error("The parameter 'willCallFilter' cannot be null.");
        else if (willCallFilter !== undefined)
            url_ += "WillCallFilter=" + encodeURIComponent("" + willCallFilter) + "&"; 
        if (maxOorRateFilter === null)
            throw new Error("The parameter 'maxOorRateFilter' cannot be null.");
        else if (maxOorRateFilter !== undefined)
            url_ += "MaxOorRateFilter=" + encodeURIComponent("" + maxOorRateFilter) + "&"; 
        if (minOorRateFilter === null)
            throw new Error("The parameter 'minOorRateFilter' cannot be null.");
        else if (minOorRateFilter !== undefined)
            url_ += "MinOorRateFilter=" + encodeURIComponent("" + minOorRateFilter) + "&"; 
        if (maxEffectivityDateFilter === null)
            throw new Error("The parameter 'maxEffectivityDateFilter' cannot be null.");
        else if (maxEffectivityDateFilter !== undefined)
            url_ += "MaxEffectivityDateFilter=" + encodeURIComponent(maxEffectivityDateFilter ? "" + maxEffectivityDateFilter.toJSON() : "") + "&"; 
        if (minEffectivityDateFilter === null)
            throw new Error("The parameter 'minEffectivityDateFilter' cannot be null.");
        else if (minEffectivityDateFilter !== undefined)
            url_ += "MinEffectivityDateFilter=" + encodeURIComponent(minEffectivityDateFilter ? "" + minEffectivityDateFilter.toJSON() : "") + "&"; 
        if (maxRouteScheduleIdFilter === null)
            throw new Error("The parameter 'maxRouteScheduleIdFilter' cannot be null.");
        else if (maxRouteScheduleIdFilter !== undefined)
            url_ += "MaxRouteScheduleIdFilter=" + encodeURIComponent("" + maxRouteScheduleIdFilter) + "&"; 
        if (minRouteScheduleIdFilter === null)
            throw new Error("The parameter 'minRouteScheduleIdFilter' cannot be null.");
        else if (minRouteScheduleIdFilter !== undefined)
            url_ += "MinRouteScheduleIdFilter=" + encodeURIComponent("" + minRouteScheduleIdFilter) + "&"; 
        if (maxRouteTypeIdFilter === null)
            throw new Error("The parameter 'maxRouteTypeIdFilter' cannot be null.");
        else if (maxRouteTypeIdFilter !== undefined)
            url_ += "MaxRouteTypeIdFilter=" + encodeURIComponent("" + maxRouteTypeIdFilter) + "&"; 
        if (minRouteTypeIdFilter === null)
            throw new Error("The parameter 'minRouteTypeIdFilter' cannot be null.");
        else if (minRouteTypeIdFilter !== undefined)
            url_ += "MinRouteTypeIdFilter=" + encodeURIComponent("" + minRouteTypeIdFilter) + "&"; 
        if (routeScheduleClinicFkFilter === null)
            throw new Error("The parameter 'routeScheduleClinicFkFilter' cannot be null.");
        else if (routeScheduleClinicFkFilter !== undefined)
            url_ += "RouteScheduleClinicFkFilter=" + encodeURIComponent("" + routeScheduleClinicFkFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteScheduleDetailsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteScheduleDetailsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteScheduleDetailsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEditClinicSchedule(body: CreateOrEditClinicScheduleDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleDetails/CreateOrEditClinicSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEditClinicSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEditClinicSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEditClinicSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteSchedulesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param maxClinicIdFilter (optional) 
     * @param minClinicIdFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: number | undefined, maxClinicIdFilter: number | undefined, minClinicIdFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteScheduleForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteSchedules/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (maxClinicIdFilter === null)
            throw new Error("The parameter 'maxClinicIdFilter' cannot be null.");
        else if (maxClinicIdFilter !== undefined)
            url_ += "MaxClinicIdFilter=" + encodeURIComponent("" + maxClinicIdFilter) + "&"; 
        if (minClinicIdFilter === null)
            throw new Error("The parameter 'minClinicIdFilter' cannot be null.");
        else if (minClinicIdFilter !== undefined)
            url_ += "MinClinicIdFilter=" + encodeURIComponent("" + minClinicIdFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteScheduleForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteScheduleForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteScheduleForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteScheduleForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteScheduleForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteScheduleForView(id: number | undefined): Observable<GetRouteScheduleForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteSchedules/GetRouteScheduleForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteScheduleForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteScheduleForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteScheduleForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteScheduleForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteScheduleForView(response: HttpResponseBase): Observable<GetRouteScheduleForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteScheduleForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteScheduleForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteScheduleForEdit(id: number | undefined): Observable<GetRouteScheduleForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteSchedules/GetRouteScheduleForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteScheduleForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteScheduleForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteScheduleForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteScheduleForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteScheduleForEdit(response: HttpResponseBase): Observable<GetRouteScheduleForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteScheduleForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteScheduleForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteScheduleDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteSchedules/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteSchedules/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param maxClinicIdFilter (optional) 
     * @param minClinicIdFilter (optional) 
     * @return Success
     */
    getRouteSchedulesToExcel(filter: string | undefined, maxClinicIdFilter: number | undefined, minClinicIdFilter: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteSchedules/GetRouteSchedulesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (maxClinicIdFilter === null)
            throw new Error("The parameter 'maxClinicIdFilter' cannot be null.");
        else if (maxClinicIdFilter !== undefined)
            url_ += "MaxClinicIdFilter=" + encodeURIComponent("" + maxClinicIdFilter) + "&"; 
        if (minClinicIdFilter === null)
            throw new Error("The parameter 'minClinicIdFilter' cannot be null.");
        else if (minClinicIdFilter !== undefined)
            url_ += "MinClinicIdFilter=" + encodeURIComponent("" + minClinicIdFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteSchedulesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteSchedulesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteSchedulesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class RouteScheduleSettingServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param routeScheduleDetailId (optional) 
     * @return Success
     */
    getForRouteSchedule(routeScheduleDetailId: number | undefined): Observable<ListResultDtoOfGetRouteScheduleSettingsItemDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleSetting/GetForRouteSchedule?";
        if (routeScheduleDetailId === null)
            throw new Error("The parameter 'routeScheduleDetailId' cannot be null.");
        else if (routeScheduleDetailId !== undefined)
            url_ += "RouteScheduleDetailId=" + encodeURIComponent("" + routeScheduleDetailId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetForRouteSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetForRouteSchedule(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetRouteScheduleSettingsItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetRouteScheduleSettingsItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetForRouteSchedule(response: HttpResponseBase): Observable<ListResultDtoOfGetRouteScheduleSettingsItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetRouteScheduleSettingsItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetRouteScheduleSettingsItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateForRouteSchedule(body: CreateForRouteScheduleInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleSetting/CreateOrUpdateForRouteSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateForRouteSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateForRouteSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateForRouteSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param routeScheduleId (optional) 
     * @param code (optional) 
     * @return Success
     */
    deleteForRouteSchedule(routeScheduleId: number | undefined, code: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteScheduleSetting/DeleteForRouteSchedule?";
        if (routeScheduleId === null)
            throw new Error("The parameter 'routeScheduleId' cannot be null.");
        else if (routeScheduleId !== undefined)
            url_ += "RouteScheduleId=" + encodeURIComponent("" + routeScheduleId) + "&"; 
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteForRouteSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteForRouteSchedule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteForRouteSchedule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RoutesGeneratorServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param message (optional) 
     * @param body (optional) 
     * @return Success
     */
    logMessage(message: string | undefined, body: ConsoleTextColor | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/LogMessage?";
        if (message === null)
            throw new Error("The parameter 'message' cannot be null.");
        else if (message !== undefined)
            url_ += "message=" + encodeURIComponent("" + message) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLogMessage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLogMessage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLogMessage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    setCurrentUser(body: User | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/SetCurrentUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetCurrentUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetCurrentUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetCurrentUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantName (optional) 
     * @param body (optional) 
     * @return Success
     */
    generate(tenantName: string | undefined, body: GenerateDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/Generate?";
        if (tenantName === null)
            throw new Error("The parameter 'tenantName' cannot be null.");
        else if (tenantName !== undefined)
            url_ += "tenantName=" + encodeURIComponent("" + tenantName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantName (optional) 
     * @return Success
     */
    setCacheName(tenantName: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/SetCacheName?";
        if (tenantName === null)
            throw new Error("The parameter 'tenantName' cannot be null.");
        else if (tenantName !== undefined)
            url_ += "tenantName=" + encodeURIComponent("" + tenantName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetCacheName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetCacheName(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetCacheName(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    log(body: LogDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/Log";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLog(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLog(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantName (optional) 
     * @param body (optional) 
     * @return Success
     */
    execute(tenantName: string | undefined, body: GenerateDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/Execute?";
        if (tenantName === null)
            throw new Error("The parameter 'tenantName' cannot be null.");
        else if (tenantName !== undefined)
            url_ += "tenantName=" + encodeURIComponent("" + tenantName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExecute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExecute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExecute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param generateDto_TenantId (optional) 
     * @param generateDto_TenantName (optional) 
     * @param generateDto_RouteType (optional) 
     * @param generateDto_LocationId (optional) 
     * @param generateDto_ForDate (optional) 
     * @param generateDto_BaseDate (optional) 
     * @param generateDto_Timezone (optional) 
     * @param generateDto_UserId (optional) 
     * @param generateDto_SchedLimit (optional) 
     * @param generateDto_RunAttempt (optional) 
     * @param generateDto_SetupType (optional) 
     * @param generateDto_IsAuto (optional) 
     * @param generateDto_RunEstimatedStartTime (optional) 
     * @param generateDto_DriverUserId (optional) 
     * @param generateDto_VisibleToDriver (optional) 
     * @param generateDto_SourceRouteIds (optional) 
     * @param generateDto_TargetRouteId (optional) 
     * @param generateDto_OrderIds (optional) 
     * @param generateDto_DriverAndOrderMapping (optional) 
     * @return Success
     */
    getToOptimizeRouteIds(generateDto_TenantId: number | undefined, generateDto_TenantName: string | undefined, generateDto_RouteType: string | undefined, generateDto_LocationId: number | undefined, generateDto_ForDate: string | undefined, generateDto_BaseDate: string | undefined, generateDto_Timezone: string | undefined, generateDto_UserId: number | undefined, generateDto_SchedLimit: number | undefined, generateDto_RunAttempt: number | undefined, generateDto_SetupType: LocationGenerationTypeEnum | undefined, generateDto_IsAuto: boolean | undefined, generateDto_RunEstimatedStartTime: boolean | undefined, generateDto_DriverUserId: number | undefined, generateDto_VisibleToDriver: boolean | undefined, generateDto_SourceRouteIds: number[] | undefined, generateDto_TargetRouteId: number | undefined, generateDto_OrderIds: number[] | undefined, generateDto_DriverAndOrderMapping: DriverAndOrderMappingDto[] | undefined): Observable<number[]> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/GetToOptimizeRouteIds?";
        if (generateDto_TenantId === null)
            throw new Error("The parameter 'generateDto_TenantId' cannot be null.");
        else if (generateDto_TenantId !== undefined)
            url_ += "GenerateDto.TenantId=" + encodeURIComponent("" + generateDto_TenantId) + "&"; 
        if (generateDto_TenantName === null)
            throw new Error("The parameter 'generateDto_TenantName' cannot be null.");
        else if (generateDto_TenantName !== undefined)
            url_ += "GenerateDto.TenantName=" + encodeURIComponent("" + generateDto_TenantName) + "&"; 
        if (generateDto_RouteType === null)
            throw new Error("The parameter 'generateDto_RouteType' cannot be null.");
        else if (generateDto_RouteType !== undefined)
            url_ += "GenerateDto.RouteType=" + encodeURIComponent("" + generateDto_RouteType) + "&"; 
        if (generateDto_LocationId === null)
            throw new Error("The parameter 'generateDto_LocationId' cannot be null.");
        else if (generateDto_LocationId !== undefined)
            url_ += "GenerateDto.LocationId=" + encodeURIComponent("" + generateDto_LocationId) + "&"; 
        if (generateDto_ForDate === null)
            throw new Error("The parameter 'generateDto_ForDate' cannot be null.");
        else if (generateDto_ForDate !== undefined)
            url_ += "GenerateDto.ForDate=" + encodeURIComponent("" + generateDto_ForDate) + "&"; 
        if (generateDto_BaseDate === null)
            throw new Error("The parameter 'generateDto_BaseDate' cannot be null.");
        else if (generateDto_BaseDate !== undefined)
            url_ += "GenerateDto.BaseDate=" + encodeURIComponent("" + generateDto_BaseDate) + "&"; 
        if (generateDto_Timezone === null)
            throw new Error("The parameter 'generateDto_Timezone' cannot be null.");
        else if (generateDto_Timezone !== undefined)
            url_ += "GenerateDto.Timezone=" + encodeURIComponent("" + generateDto_Timezone) + "&"; 
        if (generateDto_UserId === null)
            throw new Error("The parameter 'generateDto_UserId' cannot be null.");
        else if (generateDto_UserId !== undefined)
            url_ += "GenerateDto.UserId=" + encodeURIComponent("" + generateDto_UserId) + "&"; 
        if (generateDto_SchedLimit === null)
            throw new Error("The parameter 'generateDto_SchedLimit' cannot be null.");
        else if (generateDto_SchedLimit !== undefined)
            url_ += "GenerateDto.SchedLimit=" + encodeURIComponent("" + generateDto_SchedLimit) + "&"; 
        if (generateDto_RunAttempt === null)
            throw new Error("The parameter 'generateDto_RunAttempt' cannot be null.");
        else if (generateDto_RunAttempt !== undefined)
            url_ += "GenerateDto.RunAttempt=" + encodeURIComponent("" + generateDto_RunAttempt) + "&"; 
        if (generateDto_SetupType === null)
            throw new Error("The parameter 'generateDto_SetupType' cannot be null.");
        else if (generateDto_SetupType !== undefined)
            url_ += "GenerateDto.SetupType=" + encodeURIComponent("" + generateDto_SetupType) + "&"; 
        if (generateDto_IsAuto === null)
            throw new Error("The parameter 'generateDto_IsAuto' cannot be null.");
        else if (generateDto_IsAuto !== undefined)
            url_ += "GenerateDto.IsAuto=" + encodeURIComponent("" + generateDto_IsAuto) + "&"; 
        if (generateDto_RunEstimatedStartTime === null)
            throw new Error("The parameter 'generateDto_RunEstimatedStartTime' cannot be null.");
        else if (generateDto_RunEstimatedStartTime !== undefined)
            url_ += "GenerateDto.RunEstimatedStartTime=" + encodeURIComponent("" + generateDto_RunEstimatedStartTime) + "&"; 
        if (generateDto_DriverUserId === null)
            throw new Error("The parameter 'generateDto_DriverUserId' cannot be null.");
        else if (generateDto_DriverUserId !== undefined)
            url_ += "GenerateDto.DriverUserId=" + encodeURIComponent("" + generateDto_DriverUserId) + "&"; 
        if (generateDto_VisibleToDriver === null)
            throw new Error("The parameter 'generateDto_VisibleToDriver' cannot be null.");
        else if (generateDto_VisibleToDriver !== undefined)
            url_ += "GenerateDto.VisibleToDriver=" + encodeURIComponent("" + generateDto_VisibleToDriver) + "&"; 
        if (generateDto_SourceRouteIds === null)
            throw new Error("The parameter 'generateDto_SourceRouteIds' cannot be null.");
        else if (generateDto_SourceRouteIds !== undefined)
            generateDto_SourceRouteIds && generateDto_SourceRouteIds.forEach(item => { url_ += "GenerateDto.SourceRouteIds=" + encodeURIComponent("" + item) + "&"; });
        if (generateDto_TargetRouteId === null)
            throw new Error("The parameter 'generateDto_TargetRouteId' cannot be null.");
        else if (generateDto_TargetRouteId !== undefined)
            url_ += "GenerateDto.TargetRouteId=" + encodeURIComponent("" + generateDto_TargetRouteId) + "&"; 
        if (generateDto_OrderIds === null)
            throw new Error("The parameter 'generateDto_OrderIds' cannot be null.");
        else if (generateDto_OrderIds !== undefined)
            generateDto_OrderIds && generateDto_OrderIds.forEach(item => { url_ += "GenerateDto.OrderIds=" + encodeURIComponent("" + item) + "&"; });
        if (generateDto_DriverAndOrderMapping === null)
            throw new Error("The parameter 'generateDto_DriverAndOrderMapping' cannot be null.");
        else if (generateDto_DriverAndOrderMapping !== undefined)
            generateDto_DriverAndOrderMapping && generateDto_DriverAndOrderMapping.forEach((item, index) => { 
                for (let attr in item)
        			if (item.hasOwnProperty(attr)) {
        				url_ += "GenerateDto.DriverAndOrderMapping[" + index + "]." + attr + "=" + encodeURIComponent("" + (<any>item)[attr]) + "&";
        			}
            });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetToOptimizeRouteIds(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetToOptimizeRouteIds(<any>response_);
                } catch (e) {
                    return <Observable<number[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<number[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetToOptimizeRouteIds(response: HttpResponseBase): Observable<number[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    generateRemaining(body: GenerateRemainingDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/GenerateRemaining";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateRemaining(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateRemaining(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateRemaining(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    runOptimizer(body: RunOptimizerDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/RunOptimizer";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRunOptimizer(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRunOptimizer(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRunOptimizer(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param loadDate (optional) 
     * @return Success
     */
    validateRoutesAndOrders(tenantId: number | undefined, loadDate: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/ValidateRoutesAndOrders?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (loadDate === null)
            throw new Error("The parameter 'loadDate' cannot be null.");
        else if (loadDate !== undefined)
            url_ += "loadDate=" + encodeURIComponent("" + loadDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processValidateRoutesAndOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processValidateRoutesAndOrders(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processValidateRoutesAndOrders(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param tenantId (optional) 
     * @param tenantName (optional) 
     * @param body (optional) 
     * @return Success
     */
    generateFutureRoutes(tenantId: number | undefined, tenantName: string | undefined, body: GenerateDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/GenerateFutureRoutes?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        if (tenantName === null)
            throw new Error("The parameter 'tenantName' cannot be null.");
        else if (tenantName !== undefined)
            url_ += "tenantName=" + encodeURIComponent("" + tenantName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGenerateFutureRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGenerateFutureRoutes(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processGenerateFutureRoutes(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getTenant(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/RoutesGenerator/GetTenant";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenant(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenant(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class RouteStopsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param locationNameFilter (optional) 
     * @param contactAddressFilter (optional) 
     * @param stopType (optional) 
     * @param isLinehaulSetup (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, locationNameFilter: string | undefined, contactAddressFilter: string | undefined, stopType: StopTypeCode | undefined, isLinehaulSetup: boolean | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteStopForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationNameFilter === null)
            throw new Error("The parameter 'locationNameFilter' cannot be null.");
        else if (locationNameFilter !== undefined)
            url_ += "LocationNameFilter=" + encodeURIComponent("" + locationNameFilter) + "&"; 
        if (contactAddressFilter === null)
            throw new Error("The parameter 'contactAddressFilter' cannot be null.");
        else if (contactAddressFilter !== undefined)
            url_ += "ContactAddressFilter=" + encodeURIComponent("" + contactAddressFilter) + "&"; 
        if (stopType === null)
            throw new Error("The parameter 'stopType' cannot be null.");
        else if (stopType !== undefined)
            url_ += "StopType=" + encodeURIComponent("" + stopType) + "&"; 
        if (isLinehaulSetup === null)
            throw new Error("The parameter 'isLinehaulSetup' cannot be null.");
        else if (isLinehaulSetup !== undefined)
            url_ += "IsLinehaulSetup=" + encodeURIComponent("" + isLinehaulSetup) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteStopForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteStopForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteStopForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteStopForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteStopForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteStopForView(id: number | undefined): Observable<GetRouteStopForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/GetRouteStopForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteStopForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteStopForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteStopForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteStopForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteStopForView(response: HttpResponseBase): Observable<GetRouteStopForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteStopForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteStopForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteStopForEdit(id: number | undefined): Observable<GetRouteStopForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/GetRouteStopForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteStopForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteStopForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteStopForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteStopForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteStopForEdit(response: HttpResponseBase): Observable<GetRouteStopForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteStopForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteStopForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteStopDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    create(body: CreateOrEditRouteStopDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/Create";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreate(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreate(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    update(body: CreateOrEditRouteStopDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/Update";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdate(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processUpdate(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param locationNameFilter (optional) 
     * @param contactAddressFilter (optional) 
     * @param isStartStop (optional) 
     * @return Success
     */
    getRouteStopsToExcel(filter: string | undefined, locationNameFilter: string | undefined, contactAddressFilter: string | undefined, isStartStop: boolean | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/GetRouteStopsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationNameFilter === null)
            throw new Error("The parameter 'locationNameFilter' cannot be null.");
        else if (locationNameFilter !== undefined)
            url_ += "LocationNameFilter=" + encodeURIComponent("" + locationNameFilter) + "&"; 
        if (contactAddressFilter === null)
            throw new Error("The parameter 'contactAddressFilter' cannot be null.");
        else if (contactAddressFilter !== undefined)
            url_ += "ContactAddressFilter=" + encodeURIComponent("" + contactAddressFilter) + "&"; 
        if (isStartStop === null)
            throw new Error("The parameter 'isStartStop' cannot be null.");
        else if (isStartStop !== undefined)
            url_ += "isStartStop=" + encodeURIComponent("" + isStartStop) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteStopsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteStopsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteStopsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param typeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllContactForLookupTable(filter: string | undefined, typeFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRouteStopContactLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/GetAllContactForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllContactForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllContactForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteStopContactLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteStopContactLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllContactForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfRouteStopContactLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteStopContactLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteStopContactLookupTableDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    showPagedRouteStop(body: GetAllRouteStopsInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/ShowPagedRouteStop";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processShowPagedRouteStop(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processShowPagedRouteStop(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processShowPagedRouteStop(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteStop(id: number | undefined): Observable<GetRouteStopForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/GetRouteStop?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteStop(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteStop(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteStopForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteStopForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteStop(response: HttpResponseBase): Observable<GetRouteStopForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteStopForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteStopForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteStopById(id: number | undefined): Observable<GetRouteStopForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/GetRouteStopById?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteStopById(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteStopById(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteStopForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteStopForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteStopById(response: HttpResponseBase): Observable<GetRouteStopForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteStopForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteStopForViewDto>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteStopForDropDownByLocation(): Observable<ListResultDtoOfGetRouteStopForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/GetRouteStopForDropDownByLocation";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteStopForDropDownByLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteStopForDropDownByLocation(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetRouteStopForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetRouteStopForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteStopForDropDownByLocation(response: HttpResponseBase): Observable<ListResultDtoOfGetRouteStopForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetRouteStopForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetRouteStopForViewDto>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteStopForDropDown(): Observable<ListResultDtoOfGetRouteStopForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteStops/GetRouteStopForDropDown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteStopForDropDown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteStopForDropDown(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetRouteStopForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetRouteStopForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteStopForDropDown(response: HttpResponseBase): Observable<ListResultDtoOfGetRouteStopForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetRouteStopForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetRouteStopForViewDto>(<any>null);
    }
}

@Injectable()
export class RouteTemplateServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param locationId (optional) 
     * @param routeTemplateTypeId (optional) 
     * @param name (optional) 
     * @param startTime (optional) 
     * @param endTime (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getRouteTemplates(filter: string | undefined, locationId: number | undefined, routeTemplateTypeId: number | undefined, name: string | undefined, startTime: TimeSpan | undefined, endTime: TimeSpan | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfRouteTemplateListDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplate/GetRouteTemplates?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (routeTemplateTypeId === null)
            throw new Error("The parameter 'routeTemplateTypeId' cannot be null.");
        else if (routeTemplateTypeId !== undefined)
            url_ += "RouteTemplateTypeId=" + encodeURIComponent("" + routeTemplateTypeId) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (startTime === null)
            throw new Error("The parameter 'startTime' cannot be null.");
        else if (startTime !== undefined)
            url_ += "StartTime=" + encodeURIComponent("" + startTime) + "&"; 
        if (endTime === null)
            throw new Error("The parameter 'endTime' cannot be null.");
        else if (endTime !== undefined)
            url_ += "EndTime=" + encodeURIComponent("" + endTime) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplates(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplates(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteTemplateListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteTemplateListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplates(response: HttpResponseBase): Observable<PagedResultDtoOfRouteTemplateListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteTemplateListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteTemplateListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param routeTemplateTypeId (optional) 
     * @param name (optional) 
     * @param startTime (optional) 
     * @param endTime (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRouteTemplate(id: number | undefined, locationId: number | undefined, routeTemplateTypeId: number | undefined, name: string | undefined, startTime: TimeSpan | undefined, endTime: TimeSpan | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfRouteTemplateListDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplate/GetRouteTemplate?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (routeTemplateTypeId === null)
            throw new Error("The parameter 'routeTemplateTypeId' cannot be null.");
        else if (routeTemplateTypeId !== undefined)
            url_ += "RouteTemplateTypeId=" + encodeURIComponent("" + routeTemplateTypeId) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (startTime === null)
            throw new Error("The parameter 'startTime' cannot be null.");
        else if (startTime !== undefined)
            url_ += "StartTime=" + encodeURIComponent("" + startTime) + "&"; 
        if (endTime === null)
            throw new Error("The parameter 'endTime' cannot be null.");
        else if (endTime !== undefined)
            url_ += "EndTime=" + encodeURIComponent("" + endTime) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplate(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteTemplateListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteTemplateListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplate(response: HttpResponseBase): Observable<PagedResultDtoOfRouteTemplateListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteTemplateListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteTemplateListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param locationId (optional) 
     * @param routeTemplateTypeId (optional) 
     * @param name (optional) 
     * @param startTime (optional) 
     * @param endTime (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRouteTemplatePaged(id: number | undefined, locationId: number | undefined, routeTemplateTypeId: number | undefined, name: string | undefined, startTime: TimeSpan | undefined, endTime: TimeSpan | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfRouteTemplateListDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplate/GetRouteTemplatePaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (routeTemplateTypeId === null)
            throw new Error("The parameter 'routeTemplateTypeId' cannot be null.");
        else if (routeTemplateTypeId !== undefined)
            url_ += "RouteTemplateTypeId=" + encodeURIComponent("" + routeTemplateTypeId) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (startTime === null)
            throw new Error("The parameter 'startTime' cannot be null.");
        else if (startTime !== undefined)
            url_ += "StartTime=" + encodeURIComponent("" + startTime) + "&"; 
        if (endTime === null)
            throw new Error("The parameter 'endTime' cannot be null.");
        else if (endTime !== undefined)
            url_ += "EndTime=" + encodeURIComponent("" + endTime) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplatePaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplatePaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteTemplateListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteTemplateListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplatePaged(response: HttpResponseBase): Observable<PagedResultDtoOfRouteTemplateListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteTemplateListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteTemplateListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRouteTemplate(body: CreateRouteTemplateInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplate/CreateRouteTemplate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRouteTemplate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRouteTemplate(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRouteTemplate(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteTemplate(body: UpdateRouteTemplateInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplate/UpdateRouteTemplate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteTemplate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteTemplate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteTemplate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteRouteTemplate(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplate/DeleteRouteTemplate?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRouteTemplate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRouteTemplate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRouteTemplate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteTemplateById(id: number | undefined): Observable<GetRouteTemplateForView> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplate/GetRouteTemplateById?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateById(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateById(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteTemplateForView>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteTemplateForView>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateById(response: HttpResponseBase): Observable<GetRouteTemplateForView> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteTemplateForView.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteTemplateForView>(<any>null);
    }
}

@Injectable()
export class RouteTemplateAddressServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param routeTemplateId (optional) 
     * @param addressId (optional) 
     * @param sortOrder (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRouteTemplateAddress(id: number | undefined, routeTemplateId: number | undefined, addressId: number | undefined, sortOrder: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfRouteTemplateAddressListDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateAddress/GetRouteTemplateAddress?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        if (addressId === null)
            throw new Error("The parameter 'addressId' cannot be null.");
        else if (addressId !== undefined)
            url_ += "AddressId=" + encodeURIComponent("" + addressId) + "&"; 
        if (sortOrder === null)
            throw new Error("The parameter 'sortOrder' cannot be null.");
        else if (sortOrder !== undefined)
            url_ += "SortOrder=" + encodeURIComponent("" + sortOrder) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateAddress(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfRouteTemplateAddressListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfRouteTemplateAddressListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateAddress(response: HttpResponseBase): Observable<ListResultDtoOfRouteTemplateAddressListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfRouteTemplateAddressListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfRouteTemplateAddressListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRouteTemplateAddress(body: CreateRouteTemplateAddressInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateAddress/CreateRouteTemplateAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRouteTemplateAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRouteTemplateAddress(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRouteTemplateAddress(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteTemplateAddress(body: UpdateRouteTemplateAddressInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateAddress/UpdateRouteTemplateAddress";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteTemplateAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteTemplateAddress(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteTemplateAddress(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteRouteTemplateAddress(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateAddress/DeleteRouteTemplateAddress?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRouteTemplateAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRouteTemplateAddress(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRouteTemplateAddress(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteTemplateOrderExtrasServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param orderExtraKeyFilter (optional) 
     * @param orderExtraValueFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, orderExtraKeyFilter: string | undefined, orderExtraValueFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateOrderExtras/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (orderExtraKeyFilter === null)
            throw new Error("The parameter 'orderExtraKeyFilter' cannot be null.");
        else if (orderExtraKeyFilter !== undefined)
            url_ += "OrderExtraKeyFilter=" + encodeURIComponent("" + orderExtraKeyFilter) + "&"; 
        if (orderExtraValueFilter === null)
            throw new Error("The parameter 'orderExtraValueFilter' cannot be null.");
        else if (orderExtraValueFilter !== undefined)
            url_ += "OrderExtraValueFilter=" + encodeURIComponent("" + orderExtraValueFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteTemplateOrderExtrasForView(id: number | undefined): Observable<GetRouteTemplateOrderExtrasForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateOrderExtras/GetRouteTemplateOrderExtrasForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateOrderExtrasForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateOrderExtrasForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteTemplateOrderExtrasForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteTemplateOrderExtrasForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateOrderExtrasForView(response: HttpResponseBase): Observable<GetRouteTemplateOrderExtrasForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteTemplateOrderExtrasForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteTemplateOrderExtrasForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteTemplateOrderExtrasForEdit(id: number | undefined): Observable<GetRouteTemplateOrderExtrasForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateOrderExtras/GetRouteTemplateOrderExtrasForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateOrderExtrasForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateOrderExtrasForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteTemplateOrderExtrasForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteTemplateOrderExtrasForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateOrderExtrasForEdit(response: HttpResponseBase): Observable<GetRouteTemplateOrderExtrasForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteTemplateOrderExtrasForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteTemplateOrderExtrasForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteTemplateOrderExtrasDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateOrderExtras/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateOrderExtras/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteTemplateSortingRuleServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param routeTemplateId (optional) 
     * @param sortingRuleId (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRouteTemplateSortingRule(id: number | undefined, routeTemplateId: number | undefined, sortingRuleId: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfRouteTemplateSortingRuleListDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateSortingRule/GetRouteTemplateSortingRule?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        if (sortingRuleId === null)
            throw new Error("The parameter 'sortingRuleId' cannot be null.");
        else if (sortingRuleId !== undefined)
            url_ += "SortingRuleId=" + encodeURIComponent("" + sortingRuleId) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateSortingRule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateSortingRule(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfRouteTemplateSortingRuleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfRouteTemplateSortingRuleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateSortingRule(response: HttpResponseBase): Observable<ListResultDtoOfRouteTemplateSortingRuleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfRouteTemplateSortingRuleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfRouteTemplateSortingRuleListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRouteTemplateSortingRule(body: CreateRouteTemplateSortingRuleInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateSortingRule/CreateRouteTemplateSortingRule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRouteTemplateSortingRule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRouteTemplateSortingRule(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRouteTemplateSortingRule(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteTemplateSortingRule(body: UpdateRouteTemplateSortingRuleInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateSortingRule/UpdateRouteTemplateSortingRule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteTemplateSortingRule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteTemplateSortingRule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteTemplateSortingRule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteRouteTemplateSortingRule(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateSortingRule/DeleteRouteTemplateSortingRule?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRouteTemplateSortingRule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRouteTemplateSortingRule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRouteTemplateSortingRule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteTemplateTypeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRouteTemplateType(id: number | undefined, name: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfRouteTemplateTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateType/GetRouteTemplateType?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateType(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteTemplateTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteTemplateTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateType(response: HttpResponseBase): Observable<PagedResultDtoOfRouteTemplateTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteTemplateTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteTemplateTypeListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRouteTemplateTypePaged(id: number | undefined, name: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfRouteTemplateTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateType/GetRouteTemplateTypePaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateTypePaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateTypePaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfRouteTemplateTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfRouteTemplateTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateTypePaged(response: HttpResponseBase): Observable<PagedResultDtoOfRouteTemplateTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfRouteTemplateTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfRouteTemplateTypeListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRouteTemplateType(body: CreateRouteTemplateTypeInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateType/CreateRouteTemplateType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRouteTemplateType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRouteTemplateType(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRouteTemplateType(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteTemplateType(body: UpdateRouteTemplateTypeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateType/UpdateRouteTemplateType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteTemplateType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteTemplateType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteTemplateType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteRouteTemplateType(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateType/DeleteRouteTemplateType?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRouteTemplateType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRouteTemplateType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRouteTemplateType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteTemplateWaypointServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param geocodeId (optional) 
     * @param routeTemplateId (optional) 
     * @param sortOrder (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRouteTemplateWaypoint(id: number | undefined, geocodeId: number | undefined, routeTemplateId: number | undefined, sortOrder: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfRouteTemplateWaypointListDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateWaypoint/GetRouteTemplateWaypoint?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (geocodeId === null)
            throw new Error("The parameter 'geocodeId' cannot be null.");
        else if (geocodeId !== undefined)
            url_ += "GeocodeId=" + encodeURIComponent("" + geocodeId) + "&"; 
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        if (sortOrder === null)
            throw new Error("The parameter 'sortOrder' cannot be null.");
        else if (sortOrder !== undefined)
            url_ += "SortOrder=" + encodeURIComponent("" + sortOrder) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateWaypoint(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateWaypoint(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfRouteTemplateWaypointListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfRouteTemplateWaypointListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateWaypoint(response: HttpResponseBase): Observable<ListResultDtoOfRouteTemplateWaypointListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfRouteTemplateWaypointListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfRouteTemplateWaypointListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRouteTemplateWaypoint(body: CreateRouteTemplateWaypointInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateWaypoint/CreateRouteTemplateWaypoint";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRouteTemplateWaypoint(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRouteTemplateWaypoint(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRouteTemplateWaypoint(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteTemplateWaypoint(body: UpdateRouteTemplateWaypointInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateWaypoint/UpdateRouteTemplateWaypoint";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteTemplateWaypoint(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteTemplateWaypoint(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteTemplateWaypoint(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteRouteTemplateWaypoint(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateWaypoint/DeleteRouteTemplateWaypoint?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRouteTemplateWaypoint(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRouteTemplateWaypoint(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRouteTemplateWaypoint(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteTemplateZoneServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param zoneId (optional) 
     * @param routeTemplateId (optional) 
     * @param sortOrder (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getRouteTemplateZone(id: number | undefined, zoneId: number | undefined, routeTemplateId: number | undefined, sortOrder: number | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfRouteTemplateZoneListDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateZone/GetRouteTemplateZone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (zoneId === null)
            throw new Error("The parameter 'zoneId' cannot be null.");
        else if (zoneId !== undefined)
            url_ += "ZoneId=" + encodeURIComponent("" + zoneId) + "&"; 
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        if (sortOrder === null)
            throw new Error("The parameter 'sortOrder' cannot be null.");
        else if (sortOrder !== undefined)
            url_ += "SortOrder=" + encodeURIComponent("" + sortOrder) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateZone(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfRouteTemplateZoneListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfRouteTemplateZoneListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateZone(response: HttpResponseBase): Observable<ListResultDtoOfRouteTemplateZoneListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfRouteTemplateZoneListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfRouteTemplateZoneListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createRouteTemplateZone(body: CreateRouteTemplateZoneInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateZone/CreateRouteTemplateZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateRouteTemplateZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateRouteTemplateZone(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateRouteTemplateZone(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEditRouteTemplateZone(body: CreateOrEditRouteTemplateZoneDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateZone/CreateOrEditRouteTemplateZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEditRouteTemplateZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEditRouteTemplateZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEditRouteTemplateZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateRouteTemplateZone(body: UpdateRouteTemplateZoneInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateZone/UpdateRouteTemplateZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateRouteTemplateZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateRouteTemplateZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateRouteTemplateZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteRouteTemplateZone(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTemplateZone/DeleteRouteTemplateZone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteRouteTemplateZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteRouteTemplateZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteRouteTemplateZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class RouteTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param routeTypeCodeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param displayColorFilter (optional) 
     * @param typeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, routeTypeCodeFilter: string | undefined, descriptionFilter: string | undefined, displayColorFilter: string | undefined, typeFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetRouteTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (routeTypeCodeFilter === null)
            throw new Error("The parameter 'routeTypeCodeFilter' cannot be null.");
        else if (routeTypeCodeFilter !== undefined)
            url_ += "RouteTypeCodeFilter=" + encodeURIComponent("" + routeTypeCodeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (displayColorFilter === null)
            throw new Error("The parameter 'displayColorFilter' cannot be null.");
        else if (displayColorFilter !== undefined)
            url_ += "DisplayColorFilter=" + encodeURIComponent("" + displayColorFilter) + "&"; 
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetRouteTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetRouteTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetRouteTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetRouteTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetRouteTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteTypeForView(id: number | undefined): Observable<GetRouteTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTypes/GetRouteTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTypeForView(response: HttpResponseBase): Observable<GetRouteTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getRouteTypeForEdit(id: number | undefined): Observable<GetRouteTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/RouteTypes/GetRouteTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTypeForEdit(response: HttpResponseBase): Observable<GetRouteTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateMultipleRouteType(body: UpdateMultipleRouteType | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTypes/UpdateMultipleRouteType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateMultipleRouteType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateMultipleRouteType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateMultipleRouteType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditRouteTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    routeGenRemoveCache(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTypes/RouteGenRemoveCache";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRouteGenRemoveCache(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRouteGenRemoveCache(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processRouteGenRemoveCache(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RouteTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param routeTypeCodeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param displayColorFilter (optional) 
     * @param typeFilter (optional) 
     * @return Success
     */
    getRouteTypesToExcel(filter: string | undefined, routeTypeCodeFilter: string | undefined, descriptionFilter: string | undefined, displayColorFilter: string | undefined, typeFilter: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/RouteTypes/GetRouteTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (routeTypeCodeFilter === null)
            throw new Error("The parameter 'routeTypeCodeFilter' cannot be null.");
        else if (routeTypeCodeFilter !== undefined)
            url_ += "RouteTypeCodeFilter=" + encodeURIComponent("" + routeTypeCodeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (displayColorFilter === null)
            throw new Error("The parameter 'displayColorFilter' cannot be null.");
        else if (displayColorFilter !== undefined)
            url_ += "DisplayColorFilter=" + encodeURIComponent("" + displayColorFilter) + "&"; 
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTypesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class RunningRouteCheckerServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    execute(body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RunningRouteChecker/Execute";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExecute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExecute(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processExecute(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param message (optional) 
     * @param body (optional) 
     * @return Success
     */
    logMessage(message: string | undefined, body: ConsoleTextColor | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/RunningRouteChecker/LogMessage?";
        if (message === null)
            throw new Error("The parameter 'message' cannot be null.");
        else if (message !== undefined)
            url_ += "message=" + encodeURIComponent("" + message) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLogMessage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLogMessage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLogMessage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class SecondaryConnectionServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createSecondaryConnection(body: CreateSecondaryConnectionInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/CreateSecondaryConnection";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateSecondaryConnection(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateSecondaryConnection(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateSecondaryConnection(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getSecondaryConnection(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfSecondaryConnectionDto> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/GetSecondaryConnection?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSecondaryConnection(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSecondaryConnection(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSecondaryConnectionDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSecondaryConnectionDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSecondaryConnection(response: HttpResponseBase): Observable<PagedResultDtoOfSecondaryConnectionDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSecondaryConnectionDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSecondaryConnectionDto>(<any>null);
    }

    /**
     * @return Success
     */
    secondaryConnectionList(): Observable<SecondaryConnectionDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/SecondaryConnectionList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSecondaryConnectionList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSecondaryConnectionList(<any>response_);
                } catch (e) {
                    return <Observable<SecondaryConnectionDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<SecondaryConnectionDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processSecondaryConnectionList(response: HttpResponseBase): Observable<SecondaryConnectionDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(SecondaryConnectionDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SecondaryConnectionDto[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSecondaryConnectionForEdit(id: number | undefined): Observable<GetSecondaryConnectionForEdit> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/GetSecondaryConnectionForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSecondaryConnectionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSecondaryConnectionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetSecondaryConnectionForEdit>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSecondaryConnectionForEdit>><any>_observableThrow(response_);
        }));
    }

    protected processGetSecondaryConnectionForEdit(response: HttpResponseBase): Observable<GetSecondaryConnectionForEdit> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSecondaryConnectionForEdit.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSecondaryConnectionForEdit>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateSecondaryConnection(body: UpdateSecondaryConnectionDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/UpdateSecondaryConnection";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateSecondaryConnection(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateSecondaryConnection(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateSecondaryConnection(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getTenants(): Observable<TenantList[]> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/GetTenants";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenants(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenants(<any>response_);
                } catch (e) {
                    return <Observable<TenantList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<TenantList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenants(response: HttpResponseBase): Observable<TenantList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(TenantList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TenantList[]>(<any>null);
    }

    /**
     * @return Success
     */
    getSecondaryContext(): Observable<SprintTekDbContext> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/GetSecondaryContext";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSecondaryContext(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSecondaryContext(<any>response_);
                } catch (e) {
                    return <Observable<SprintTekDbContext>><any>_observableThrow(e);
                }
            } else
                return <Observable<SprintTekDbContext>><any>_observableThrow(response_);
        }));
    }

    protected processGetSecondaryContext(response: HttpResponseBase): Observable<SprintTekDbContext> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = SprintTekDbContext.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SprintTekDbContext>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    connectToTenant(id: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/ConnectToTenant?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConnectToTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConnectToTenant(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processConnectToTenant(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @return Success
     */
    getSecondaryConnectioForReport(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/SecondaryConnection/GetSecondaryConnectioForReport";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSecondaryConnectioForReport(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSecondaryConnectioForReport(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetSecondaryConnectioForReport(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class SessionServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getCurrentLoginInformations(): Observable<GetCurrentLoginInformationsOutput> {
        let url_ = this.baseUrl + "/api/services/app/Session/GetCurrentLoginInformations";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCurrentLoginInformations(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCurrentLoginInformations(<any>response_);
                } catch (e) {
                    return <Observable<GetCurrentLoginInformationsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetCurrentLoginInformationsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetCurrentLoginInformations(response: HttpResponseBase): Observable<GetCurrentLoginInformationsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetCurrentLoginInformationsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetCurrentLoginInformationsOutput>(<any>null);
    }

    /**
     * @return Success
     */
    updateUserSignInToken(): Observable<UpdateUserSignInTokenOutput> {
        let url_ = this.baseUrl + "/api/services/app/Session/UpdateUserSignInToken";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateUserSignInToken(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateUserSignInToken(<any>response_);
                } catch (e) {
                    return <Observable<UpdateUserSignInTokenOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<UpdateUserSignInTokenOutput>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateUserSignInToken(response: HttpResponseBase): Observable<UpdateUserSignInTokenOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = UpdateUserSignInTokenOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UpdateUserSignInTokenOutput>(<any>null);
    }
}

@Injectable()
export class ShippingPackageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getShippingPackage(id: number | undefined, name: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfShippingPackageListDto> {
        let url_ = this.baseUrl + "/api/services/app/ShippingPackage/GetShippingPackage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetShippingPackage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetShippingPackage(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfShippingPackageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfShippingPackageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetShippingPackage(response: HttpResponseBase): Observable<PagedResultDtoOfShippingPackageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfShippingPackageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfShippingPackageListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getShippingPackageListOptionsStandard(id: number | undefined, name: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ShippingPackageListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ShippingPackage/GetShippingPackageListOptionsStandard?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetShippingPackageListOptionsStandard(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetShippingPackageListOptionsStandard(<any>response_);
                } catch (e) {
                    return <Observable<ShippingPackageListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ShippingPackageListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetShippingPackageListOptionsStandard(response: HttpResponseBase): Observable<ShippingPackageListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ShippingPackageListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ShippingPackageListDto[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getShippingPackageListOptions(id: number | undefined, name: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ShippingPackageListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/ShippingPackage/GetShippingPackageListOptions?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetShippingPackageListOptions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetShippingPackageListOptions(<any>response_);
                } catch (e) {
                    return <Observable<ShippingPackageListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ShippingPackageListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetShippingPackageListOptions(response: HttpResponseBase): Observable<ShippingPackageListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ShippingPackageListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ShippingPackageListDto[]>(<any>null);
    }

    /**
     * Gets the package types available for creating orders.
     * @param id (optional) 
     * @param name (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Returns the package types.
     */
    getPackageTypes(id: number | undefined, name: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfShippingPackageListDto> {
        let url_ = this.baseUrl + "/api/services/app/ShippingPackage/GetPackageTypes?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPackageTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPackageTypes(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfShippingPackageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfShippingPackageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPackageTypes(response: HttpResponseBase): Observable<PagedResultDtoOfShippingPackageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfShippingPackageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfShippingPackageListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createShippingPackage(body: CreateShippingPackageInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/ShippingPackage/CreateShippingPackage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateShippingPackage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateShippingPackage(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateShippingPackage(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteShippingPackage(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ShippingPackage/DeleteShippingPackage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteShippingPackage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteShippingPackage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteShippingPackage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateShippingPackage(body: UpdateShippingPackageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ShippingPackage/UpdateShippingPackage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateShippingPackage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateShippingPackage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateShippingPackage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class ShippingRoleActionServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateStatusForAction(body: CreateOrUpdateStatusForActionInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ShippingRoleAction/CreateOrUpdateStatusForAction";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateStatusForAction(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateStatusForAction(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateStatusForAction(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param roleId (optional) 
     * @param actionType (optional) 
     * @param orderStatusTypeId (optional) 
     * @return Success
     */
    deleteStatusForAction(roleId: number | undefined, actionType: string | undefined, orderStatusTypeId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/ShippingRoleAction/DeleteStatusForAction?";
        if (roleId === null)
            throw new Error("The parameter 'roleId' cannot be null.");
        else if (roleId !== undefined)
            url_ += "RoleId=" + encodeURIComponent("" + roleId) + "&"; 
        if (actionType === null)
            throw new Error("The parameter 'actionType' cannot be null.");
        else if (actionType !== undefined)
            url_ += "ActionType=" + encodeURIComponent("" + actionType) + "&"; 
        if (orderStatusTypeId === null)
            throw new Error("The parameter 'orderStatusTypeId' cannot be null.");
        else if (orderStatusTypeId !== undefined)
            url_ += "OrderStatusTypeId=" + encodeURIComponent("" + orderStatusTypeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteStatusForAction(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteStatusForAction(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteStatusForAction(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param roleId (optional) 
     * @param actionType (optional) 
     * @param includeChildStatus (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderStatusForActions(roleId: number | undefined, actionType: string | undefined, includeChildStatus: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetOrderStatusForActionsListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/ShippingRoleAction/GetOrderStatusForActions?";
        if (roleId === null)
            throw new Error("The parameter 'roleId' cannot be null.");
        else if (roleId !== undefined)
            url_ += "RoleId=" + encodeURIComponent("" + roleId) + "&"; 
        if (actionType === null)
            throw new Error("The parameter 'actionType' cannot be null.");
        else if (actionType !== undefined)
            url_ += "ActionType=" + encodeURIComponent("" + actionType) + "&"; 
        if (includeChildStatus === null)
            throw new Error("The parameter 'includeChildStatus' cannot be null.");
        else if (includeChildStatus !== undefined)
            url_ += "IncludeChildStatus=" + encodeURIComponent("" + includeChildStatus) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusForActions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusForActions(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderStatusForActionsListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderStatusForActionsListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusForActions(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderStatusForActionsListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderStatusForActionsListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderStatusForActionsListItemDto>(<any>null);
    }

    /**
     * @param roleId (optional) 
     * @param actionType (optional) 
     * @param includeChildStatus (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getOrderStatusListForRole(roleId: number | undefined, actionType: string | undefined, includeChildStatus: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetOrderStatusListForRoleListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/ShippingRoleAction/GetOrderStatusListForRole?";
        if (roleId === null)
            throw new Error("The parameter 'roleId' cannot be null.");
        else if (roleId !== undefined)
            url_ += "RoleId=" + encodeURIComponent("" + roleId) + "&"; 
        if (actionType === null)
            throw new Error("The parameter 'actionType' cannot be null.");
        else if (actionType !== undefined)
            url_ += "ActionType=" + encodeURIComponent("" + actionType) + "&"; 
        if (includeChildStatus === null)
            throw new Error("The parameter 'includeChildStatus' cannot be null.");
        else if (includeChildStatus !== undefined)
            url_ += "IncludeChildStatus=" + encodeURIComponent("" + includeChildStatus) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatusListForRole(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatusListForRole(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetOrderStatusListForRoleListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetOrderStatusListForRoleListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatusListForRole(response: HttpResponseBase): Observable<PagedResultDtoOfGetOrderStatusListForRoleListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetOrderStatusListForRoleListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetOrderStatusListForRoleListItemDto>(<any>null);
    }

    /**
     * @return Success
     */
    getMaintenancePermission(): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ShippingRoleAction/GetMaintenancePermission";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMaintenancePermission(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMaintenancePermission(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processGetMaintenancePermission(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param featureName (optional) 
     * @return Success
     */
    isMaintenancePageAvailable(featureName: string | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/ShippingRoleAction/IsMaintenancePageAvailable?";
        if (featureName === null)
            throw new Error("The parameter 'featureName' cannot be null.");
        else if (featureName !== undefined)
            url_ += "featureName=" + encodeURIComponent("" + featureName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIsMaintenancePageAvailable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIsMaintenancePageAvailable(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processIsMaintenancePageAvailable(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }
}

@Injectable()
export class SimulationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createClinicRoutes(body: CreateClinicRoutesInput | undefined): Observable<number[]> {
        let url_ = this.baseUrl + "/api/services/app/Simulation/CreateClinicRoutes";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateClinicRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateClinicRoutes(<any>response_);
                } catch (e) {
                    return <Observable<number[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<number[]>><any>_observableThrow(response_);
        }));
    }

    protected processCreateClinicRoutes(response: HttpResponseBase): Observable<number[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(item);
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createPickup(body: CreatePickupInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Simulation/CreatePickup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreatePickup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreatePickup(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreatePickup(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createDelivery(body: CreateDeliveryInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Simulation/CreateDelivery";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateDelivery(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateDelivery(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateDelivery(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }
}

@Injectable()
export class SmsAccountsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param activeFilter (optional) 
     * @param accountFilter (optional) 
     * @param accountSidFilter (optional) 
     * @param authTokenFilter (optional) 
     * @param senderNumberFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, activeFilter: number | undefined, accountFilter: string | undefined, accountSidFilter: string | undefined, authTokenFilter: string | undefined, senderNumberFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetSmsAccountForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SmsAccounts/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (activeFilter === null)
            throw new Error("The parameter 'activeFilter' cannot be null.");
        else if (activeFilter !== undefined)
            url_ += "ActiveFilter=" + encodeURIComponent("" + activeFilter) + "&"; 
        if (accountFilter === null)
            throw new Error("The parameter 'accountFilter' cannot be null.");
        else if (accountFilter !== undefined)
            url_ += "AccountFilter=" + encodeURIComponent("" + accountFilter) + "&"; 
        if (accountSidFilter === null)
            throw new Error("The parameter 'accountSidFilter' cannot be null.");
        else if (accountSidFilter !== undefined)
            url_ += "AccountSidFilter=" + encodeURIComponent("" + accountSidFilter) + "&"; 
        if (authTokenFilter === null)
            throw new Error("The parameter 'authTokenFilter' cannot be null.");
        else if (authTokenFilter !== undefined)
            url_ += "AuthTokenFilter=" + encodeURIComponent("" + authTokenFilter) + "&"; 
        if (senderNumberFilter === null)
            throw new Error("The parameter 'senderNumberFilter' cannot be null.");
        else if (senderNumberFilter !== undefined)
            url_ += "SenderNumberFilter=" + encodeURIComponent("" + senderNumberFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetSmsAccountForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetSmsAccountForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetSmsAccountForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetSmsAccountForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetSmsAccountForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSmsAccountForView(id: number | undefined): Observable<GetSmsAccountForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SmsAccounts/GetSmsAccountForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSmsAccountForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSmsAccountForView(<any>response_);
                } catch (e) {
                    return <Observable<GetSmsAccountForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSmsAccountForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSmsAccountForView(response: HttpResponseBase): Observable<GetSmsAccountForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSmsAccountForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSmsAccountForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSmsAccountForEdit(id: number | undefined): Observable<GetSmsAccountForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/SmsAccounts/GetSmsAccountForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSmsAccountForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSmsAccountForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetSmsAccountForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSmsAccountForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetSmsAccountForEdit(response: HttpResponseBase): Observable<GetSmsAccountForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSmsAccountForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSmsAccountForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditSmsAccountDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SmsAccounts/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SmsAccounts/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param activeFilter (optional) 
     * @param accountFilter (optional) 
     * @param accountSidFilter (optional) 
     * @param authTokenFilter (optional) 
     * @param senderNumberFilter (optional) 
     * @return Success
     */
    getSmsAccountsToExcel(filter: string | undefined, activeFilter: number | undefined, accountFilter: string | undefined, accountSidFilter: string | undefined, authTokenFilter: string | undefined, senderNumberFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/SmsAccounts/GetSmsAccountsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (activeFilter === null)
            throw new Error("The parameter 'activeFilter' cannot be null.");
        else if (activeFilter !== undefined)
            url_ += "ActiveFilter=" + encodeURIComponent("" + activeFilter) + "&"; 
        if (accountFilter === null)
            throw new Error("The parameter 'accountFilter' cannot be null.");
        else if (accountFilter !== undefined)
            url_ += "AccountFilter=" + encodeURIComponent("" + accountFilter) + "&"; 
        if (accountSidFilter === null)
            throw new Error("The parameter 'accountSidFilter' cannot be null.");
        else if (accountSidFilter !== undefined)
            url_ += "AccountSidFilter=" + encodeURIComponent("" + accountSidFilter) + "&"; 
        if (authTokenFilter === null)
            throw new Error("The parameter 'authTokenFilter' cannot be null.");
        else if (authTokenFilter !== undefined)
            url_ += "AuthTokenFilter=" + encodeURIComponent("" + authTokenFilter) + "&"; 
        if (senderNumberFilter === null)
            throw new Error("The parameter 'senderNumberFilter' cannot be null.");
        else if (senderNumberFilter !== undefined)
            url_ += "SenderNumberFilter=" + encodeURIComponent("" + senderNumberFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSmsAccountsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSmsAccountsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSmsAccountsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class SmsTemplatesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param descriptionFilter (optional) 
     * @param templateFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param codeFilter (optional) 
     * @param smsAccountAccountFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, descriptionFilter: string | undefined, templateFilter: string | undefined, isActiveFilter: number | undefined, codeFilter: string | undefined, smsAccountAccountFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetSmsTemplateForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SmsTemplates/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (templateFilter === null)
            throw new Error("The parameter 'templateFilter' cannot be null.");
        else if (templateFilter !== undefined)
            url_ += "TemplateFilter=" + encodeURIComponent("" + templateFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (smsAccountAccountFilter === null)
            throw new Error("The parameter 'smsAccountAccountFilter' cannot be null.");
        else if (smsAccountAccountFilter !== undefined)
            url_ += "SmsAccountAccountFilter=" + encodeURIComponent("" + smsAccountAccountFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetSmsTemplateForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetSmsTemplateForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetSmsTemplateForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetSmsTemplateForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetSmsTemplateForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSmsTemplateForView(id: number | undefined): Observable<GetSmsTemplateForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SmsTemplates/GetSmsTemplateForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSmsTemplateForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSmsTemplateForView(<any>response_);
                } catch (e) {
                    return <Observable<GetSmsTemplateForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSmsTemplateForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSmsTemplateForView(response: HttpResponseBase): Observable<GetSmsTemplateForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSmsTemplateForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSmsTemplateForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSmsTemplateForEdit(id: number | undefined): Observable<GetSmsTemplateForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/SmsTemplates/GetSmsTemplateForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSmsTemplateForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSmsTemplateForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetSmsTemplateForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSmsTemplateForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetSmsTemplateForEdit(response: HttpResponseBase): Observable<GetSmsTemplateForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSmsTemplateForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSmsTemplateForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditSmsTemplateDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SmsTemplates/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SmsTemplates/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param descriptionFilter (optional) 
     * @param templateFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param codeFilter (optional) 
     * @param smsAccountAccountFilter (optional) 
     * @return Success
     */
    getSmsTemplatesToExcel(filter: string | undefined, descriptionFilter: string | undefined, templateFilter: string | undefined, isActiveFilter: number | undefined, codeFilter: string | undefined, smsAccountAccountFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/SmsTemplates/GetSmsTemplatesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (templateFilter === null)
            throw new Error("The parameter 'templateFilter' cannot be null.");
        else if (templateFilter !== undefined)
            url_ += "TemplateFilter=" + encodeURIComponent("" + templateFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (smsAccountAccountFilter === null)
            throw new Error("The parameter 'smsAccountAccountFilter' cannot be null.");
        else if (smsAccountAccountFilter !== undefined)
            url_ += "SmsAccountAccountFilter=" + encodeURIComponent("" + smsAccountAccountFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSmsTemplatesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSmsTemplatesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSmsTemplatesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllSmsAccountForTableDropdown(): Observable<SmsTemplateSmsAccountLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SmsTemplates/GetAllSmsAccountForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSmsAccountForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSmsAccountForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<SmsTemplateSmsAccountLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<SmsTemplateSmsAccountLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSmsAccountForTableDropdown(response: HttpResponseBase): Observable<SmsTemplateSmsAccountLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(SmsTemplateSmsAccountLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SmsTemplateSmsAccountLookupTableDto[]>(<any>null);
    }
}

@Injectable()
export class SortingRuleServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getSortingRule(id: number | undefined, name: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfSortingRuleListDto> {
        let url_ = this.baseUrl + "/api/services/app/SortingRule/GetSortingRule?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSortingRule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSortingRule(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfSortingRuleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfSortingRuleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSortingRule(response: HttpResponseBase): Observable<ListResultDtoOfSortingRuleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfSortingRuleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfSortingRuleListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createSortingRule(body: CreateSortingRuleInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/SortingRule/CreateSortingRule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateSortingRule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateSortingRule(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateSortingRule(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateSortingRule(body: UpdateSortingRuleInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SortingRule/UpdateSortingRule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateSortingRule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateSortingRule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateSortingRule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteSortingRule(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SortingRule/DeleteSortingRule?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteSortingRule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteSortingRule(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteSortingRule(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class SprintTekDbLoggingServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getIsEnabled(): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/SprintTekDbLogging/GetIsEnabled";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIsEnabled(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIsEnabled(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processGetIsEnabled(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param value (optional) 
     * @return Success
     */
    setEnabled(value: boolean | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SprintTekDbLogging/SetEnabled?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "value=" + encodeURIComponent("" + value) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSetEnabled(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSetEnabled(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSetEnabled(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class SprintVisorServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getRoutesKpi(): Observable<GetStatResultDto> {
        let url_ = this.baseUrl + "/api/services/app/SprintVisor/GetRoutesKpi";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoutesKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoutesKpi(<any>response_);
                } catch (e) {
                    return <Observable<GetStatResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetStatResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoutesKpi(response: HttpResponseBase): Observable<GetStatResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetStatResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetStatResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getPickupsKpi(): Observable<GetStatResultDto> {
        let url_ = this.baseUrl + "/api/services/app/SprintVisor/GetPickupsKpi";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPickupsKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPickupsKpi(<any>response_);
                } catch (e) {
                    return <Observable<GetStatResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetStatResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPickupsKpi(response: HttpResponseBase): Observable<GetStatResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetStatResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetStatResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getDeliveriesKpi(): Observable<GetStatResultDto> {
        let url_ = this.baseUrl + "/api/services/app/SprintVisor/GetDeliveriesKpi";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDeliveriesKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDeliveriesKpi(<any>response_);
                } catch (e) {
                    return <Observable<GetStatResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetStatResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDeliveriesKpi(response: HttpResponseBase): Observable<GetStatResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetStatResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetStatResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getCustomersKpi(): Observable<GetStatResultDto> {
        let url_ = this.baseUrl + "/api/services/app/SprintVisor/GetCustomersKpi";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCustomersKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCustomersKpi(<any>response_);
                } catch (e) {
                    return <Observable<GetStatResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetStatResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCustomersKpi(response: HttpResponseBase): Observable<GetStatResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetStatResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetStatResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getIncidentsKpi(): Observable<GetStatResultDto> {
        let url_ = this.baseUrl + "/api/services/app/SprintVisor/GetIncidentsKpi";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidentsKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidentsKpi(<any>response_);
                } catch (e) {
                    return <Observable<GetStatResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetStatResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidentsKpi(response: HttpResponseBase): Observable<GetStatResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetStatResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetStatResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getDriversKpi(): Observable<GetStatResultDto> {
        let url_ = this.baseUrl + "/api/services/app/SprintVisor/GetDriversKpi";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDriversKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDriversKpi(<any>response_);
                } catch (e) {
                    return <Observable<GetStatResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetStatResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDriversKpi(response: HttpResponseBase): Observable<GetStatResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetStatResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetStatResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getDevicesKpi(): Observable<GetStatResultDto> {
        let url_ = this.baseUrl + "/api/services/app/SprintVisor/GetDevicesKpi";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDevicesKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDevicesKpi(<any>response_);
                } catch (e) {
                    return <Observable<GetStatResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetStatResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetDevicesKpi(response: HttpResponseBase): Observable<GetStatResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetStatResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetStatResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getOsKpi(): Observable<GetStatResultDto> {
        let url_ = this.baseUrl + "/api/services/app/SprintVisor/GetOsKpi";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOsKpi(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOsKpi(<any>response_);
                } catch (e) {
                    return <Observable<GetStatResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetStatResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOsKpi(response: HttpResponseBase): Observable<GetStatResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetStatResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetStatResultDto>(<any>null);
    }
}

@Injectable()
export class StatisticsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalPackagesSetForDelivery(body: SLAInput | undefined): Observable<TotalPackagesSetForDelivery> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalPackagesSetForDelivery";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalPackagesSetForDelivery(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalPackagesSetForDelivery(<any>response_);
                } catch (e) {
                    return <Observable<TotalPackagesSetForDelivery>><any>_observableThrow(e);
                }
            } else
                return <Observable<TotalPackagesSetForDelivery>><any>_observableThrow(response_);
        }));
    }

    protected processTotalPackagesSetForDelivery(response: HttpResponseBase): Observable<TotalPackagesSetForDelivery> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TotalPackagesSetForDelivery.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TotalPackagesSetForDelivery>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalPackagesNotPickedUp(body: SLAInput | undefined): Observable<TotalPackagesNotPickedUp> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalPackagesNotPickedUp";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalPackagesNotPickedUp(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalPackagesNotPickedUp(<any>response_);
                } catch (e) {
                    return <Observable<TotalPackagesNotPickedUp>><any>_observableThrow(e);
                }
            } else
                return <Observable<TotalPackagesNotPickedUp>><any>_observableThrow(response_);
        }));
    }

    protected processTotalPackagesNotPickedUp(response: HttpResponseBase): Observable<TotalPackagesNotPickedUp> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TotalPackagesNotPickedUp.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TotalPackagesNotPickedUp>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalPackagesIntransit(body: SLAInput | undefined): Observable<TotalPackagesIntransit> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalPackagesIntransit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalPackagesIntransit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalPackagesIntransit(<any>response_);
                } catch (e) {
                    return <Observable<TotalPackagesIntransit>><any>_observableThrow(e);
                }
            } else
                return <Observable<TotalPackagesIntransit>><any>_observableThrow(response_);
        }));
    }

    protected processTotalPackagesIntransit(response: HttpResponseBase): Observable<TotalPackagesIntransit> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TotalPackagesIntransit.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TotalPackagesIntransit>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalPackagesDelivered(body: SLAInput | undefined): Observable<TotalPackagesDelivered> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalPackagesDelivered";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalPackagesDelivered(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalPackagesDelivered(<any>response_);
                } catch (e) {
                    return <Observable<TotalPackagesDelivered>><any>_observableThrow(e);
                }
            } else
                return <Observable<TotalPackagesDelivered>><any>_observableThrow(response_);
        }));
    }

    protected processTotalPackagesDelivered(response: HttpResponseBase): Observable<TotalPackagesDelivered> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TotalPackagesDelivered.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TotalPackagesDelivered>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalPackagesDeliveredOnTime(body: SLAInput | undefined): Observable<TotalPackagesDeliveredOnTime> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalPackagesDeliveredOnTime";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalPackagesDeliveredOnTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalPackagesDeliveredOnTime(<any>response_);
                } catch (e) {
                    return <Observable<TotalPackagesDeliveredOnTime>><any>_observableThrow(e);
                }
            } else
                return <Observable<TotalPackagesDeliveredOnTime>><any>_observableThrow(response_);
        }));
    }

    protected processTotalPackagesDeliveredOnTime(response: HttpResponseBase): Observable<TotalPackagesDeliveredOnTime> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TotalPackagesDeliveredOnTime.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TotalPackagesDeliveredOnTime>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalPackagesDeliveredLate(body: SLAInput | undefined): Observable<TotalPackagesDeliveredLate> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalPackagesDeliveredLate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalPackagesDeliveredLate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalPackagesDeliveredLate(<any>response_);
                } catch (e) {
                    return <Observable<TotalPackagesDeliveredLate>><any>_observableThrow(e);
                }
            } else
                return <Observable<TotalPackagesDeliveredLate>><any>_observableThrow(response_);
        }));
    }

    protected processTotalPackagesDeliveredLate(response: HttpResponseBase): Observable<TotalPackagesDeliveredLate> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TotalPackagesDeliveredLate.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TotalPackagesDeliveredLate>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalPackagesTendered(body: SLAInput | undefined): Observable<TotalPackagesTendered> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalPackagesTendered";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalPackagesTendered(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalPackagesTendered(<any>response_);
                } catch (e) {
                    return <Observable<TotalPackagesTendered>><any>_observableThrow(e);
                }
            } else
                return <Observable<TotalPackagesTendered>><any>_observableThrow(response_);
        }));
    }

    protected processTotalPackagesTendered(response: HttpResponseBase): Observable<TotalPackagesTendered> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TotalPackagesTendered.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TotalPackagesTendered>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    latestDeliveryTime(body: SLAInput | undefined): Observable<LatestDeliveryTime> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/LatestDeliveryTime";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLatestDeliveryTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLatestDeliveryTime(<any>response_);
                } catch (e) {
                    return <Observable<LatestDeliveryTime>><any>_observableThrow(e);
                }
            } else
                return <Observable<LatestDeliveryTime>><any>_observableThrow(response_);
        }));
    }

    protected processLatestDeliveryTime(response: HttpResponseBase): Observable<LatestDeliveryTime> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = LatestDeliveryTime.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<LatestDeliveryTime>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    packagesNotDelivered(body: SLAInput | undefined): Observable<PackagesNotDelivered> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/PackagesNotDelivered";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPackagesNotDelivered(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPackagesNotDelivered(<any>response_);
                } catch (e) {
                    return <Observable<PackagesNotDelivered>><any>_observableThrow(e);
                }
            } else
                return <Observable<PackagesNotDelivered>><any>_observableThrow(response_);
        }));
    }

    protected processPackagesNotDelivered(response: HttpResponseBase): Observable<PackagesNotDelivered> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PackagesNotDelivered.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PackagesNotDelivered>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    packagesWDeliveryIssue(body: SLAInput | undefined): Observable<PackagesWDeliveryIssue> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/PackagesWDeliveryIssue";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPackagesWDeliveryIssue(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPackagesWDeliveryIssue(<any>response_);
                } catch (e) {
                    return <Observable<PackagesWDeliveryIssue>><any>_observableThrow(e);
                }
            } else
                return <Observable<PackagesWDeliveryIssue>><any>_observableThrow(response_);
        }));
    }

    protected processPackagesWDeliveryIssue(response: HttpResponseBase): Observable<PackagesWDeliveryIssue> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PackagesWDeliveryIssue.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PackagesWDeliveryIssue>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    packagesSetForRedelivery(body: SLAInput | undefined): Observable<PackagesSetForRedelivery> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/PackagesSetForRedelivery";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPackagesSetForRedelivery(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPackagesSetForRedelivery(<any>response_);
                } catch (e) {
                    return <Observable<PackagesSetForRedelivery>><any>_observableThrow(e);
                }
            } else
                return <Observable<PackagesSetForRedelivery>><any>_observableThrow(response_);
        }));
    }

    protected processPackagesSetForRedelivery(response: HttpResponseBase): Observable<PackagesSetForRedelivery> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PackagesSetForRedelivery.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PackagesSetForRedelivery>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    percentageOnTime(body: SLAInput | undefined): Observable<PercentageOnTime> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/PercentageOnTime";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPercentageOnTime(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPercentageOnTime(<any>response_);
                } catch (e) {
                    return <Observable<PercentageOnTime>><any>_observableThrow(e);
                }
            } else
                return <Observable<PercentageOnTime>><any>_observableThrow(response_);
        }));
    }

    protected processPercentageOnTime(response: HttpResponseBase): Observable<PercentageOnTime> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PercentageOnTime.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PercentageOnTime>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalOrdersNotPickedUp(body: SLAOrdersInput | undefined): Observable<PagedResultDtoOfSLAOrdersDto> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalOrdersNotPickedUp";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalOrdersNotPickedUp(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalOrdersNotPickedUp(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(response_);
        }));
    }

    protected processTotalOrdersNotPickedUp(response: HttpResponseBase): Observable<PagedResultDtoOfSLAOrdersDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSLAOrdersDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSLAOrdersDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    ordersNotPickedUp(body: SLAOrdersInput | undefined): Observable<PagedResultDtoOfSLAOrdersDto> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/OrdersNotPickedUp";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrdersNotPickedUp(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrdersNotPickedUp(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(response_);
        }));
    }

    protected processOrdersNotPickedUp(response: HttpResponseBase): Observable<PagedResultDtoOfSLAOrdersDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSLAOrdersDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSLAOrdersDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    ordersIntransit(body: SLAOrdersInput | undefined): Observable<PagedResultDtoOfSLAOrdersDto> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/OrdersIntransit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrdersIntransit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrdersIntransit(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(response_);
        }));
    }

    protected processOrdersIntransit(response: HttpResponseBase): Observable<PagedResultDtoOfSLAOrdersDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSLAOrdersDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSLAOrdersDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalOrdersIntransit(body: SLAOrdersInput | undefined): Observable<PagedResultDtoOfSLAOrdersDto> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalOrdersIntransit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalOrdersIntransit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalOrdersIntransit(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(response_);
        }));
    }

    protected processTotalOrdersIntransit(response: HttpResponseBase): Observable<PagedResultDtoOfSLAOrdersDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSLAOrdersDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSLAOrdersDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    ordersLate(body: SLAOrdersInput | undefined): Observable<PagedResultDtoOfSLAOrdersDto> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/OrdersLate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrdersLate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrdersLate(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(response_);
        }));
    }

    protected processOrdersLate(response: HttpResponseBase): Observable<PagedResultDtoOfSLAOrdersDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSLAOrdersDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSLAOrdersDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalOrdersLate(body: SLAOrdersInput | undefined): Observable<PagedResultDtoOfSLAOrdersDto> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalOrdersLate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalOrdersLate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalOrdersLate(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(response_);
        }));
    }

    protected processTotalOrdersLate(response: HttpResponseBase): Observable<PagedResultDtoOfSLAOrdersDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSLAOrdersDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSLAOrdersDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    ordersNotDelivered(body: SLAOrdersInput | undefined): Observable<PagedResultDtoOfSLAOrdersDto> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/OrdersNotDelivered";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrdersNotDelivered(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrdersNotDelivered(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(response_);
        }));
    }

    protected processOrdersNotDelivered(response: HttpResponseBase): Observable<PagedResultDtoOfSLAOrdersDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSLAOrdersDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSLAOrdersDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    totalOrdersNotDelivered(body: SLAOrdersInput | undefined): Observable<PagedResultDtoOfSLAOrdersDto> {
        let url_ = this.baseUrl + "/api/services/app/Statistics/TotalOrdersNotDelivered";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTotalOrdersNotDelivered(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTotalOrdersNotDelivered(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSLAOrdersDto>><any>_observableThrow(response_);
        }));
    }

    protected processTotalOrdersNotDelivered(response: HttpResponseBase): Observable<PagedResultDtoOfSLAOrdersDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSLAOrdersDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSLAOrdersDto>(<any>null);
    }
}

@Injectable()
export class StatusServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * Gets the most updated order status.
     * @param tagName (optional) 
     * @return Returns the latest order status.
     */
    getOrderStatus(tagName: string | undefined): Observable<SprintStatusListDto> {
        let url_ = this.baseUrl + "/api/services/app/Status/GetOrderStatus?";
        if (tagName === null)
            throw new Error("The parameter 'tagName' cannot be null.");
        else if (tagName !== undefined)
            url_ += "TagName=" + encodeURIComponent("" + tagName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetOrderStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetOrderStatus(<any>response_);
                } catch (e) {
                    return <Observable<SprintStatusListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<SprintStatusListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetOrderStatus(response: HttpResponseBase): Observable<SprintStatusListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = SprintStatusListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SprintStatusListDto>(<any>null);
    }
}

@Injectable()
export class StripePaymentServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getConfiguration(): Observable<StripeConfigurationDto> {
        let url_ = this.baseUrl + "/api/services/app/StripePayment/GetConfiguration";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetConfiguration(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetConfiguration(<any>response_);
                } catch (e) {
                    return <Observable<StripeConfigurationDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<StripeConfigurationDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetConfiguration(response: HttpResponseBase): Observable<StripeConfigurationDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = StripeConfigurationDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<StripeConfigurationDto>(<any>null);
    }

    /**
     * @param stripeSessionId (optional) 
     * @return Success
     */
    getPayment(stripeSessionId: string | undefined): Observable<SubscriptionPaymentDto> {
        let url_ = this.baseUrl + "/api/services/app/StripePayment/GetPayment?";
        if (stripeSessionId === null)
            throw new Error("The parameter 'stripeSessionId' cannot be null.");
        else if (stripeSessionId !== undefined)
            url_ += "StripeSessionId=" + encodeURIComponent("" + stripeSessionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPayment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPayment(<any>response_);
                } catch (e) {
                    return <Observable<SubscriptionPaymentDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<SubscriptionPaymentDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPayment(response: HttpResponseBase): Observable<SubscriptionPaymentDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = SubscriptionPaymentDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SubscriptionPaymentDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createPaymentSession(body: StripeCreatePaymentSessionInput | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/StripePayment/CreatePaymentSession";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreatePaymentSession(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreatePaymentSession(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processCreatePaymentSession(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @param paymentId (optional) 
     * @return Success
     */
    getPaymentResult(paymentId: number | undefined): Observable<StripePaymentResultOutput> {
        let url_ = this.baseUrl + "/api/services/app/StripePayment/GetPaymentResult?";
        if (paymentId === null)
            throw new Error("The parameter 'paymentId' cannot be null.");
        else if (paymentId !== undefined)
            url_ += "PaymentId=" + encodeURIComponent("" + paymentId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPaymentResult(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPaymentResult(<any>response_);
                } catch (e) {
                    return <Observable<StripePaymentResultOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<StripePaymentResultOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetPaymentResult(response: HttpResponseBase): Observable<StripePaymentResultOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = StripePaymentResultOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<StripePaymentResultOutput>(<any>null);
    }
}

@Injectable()
export class SubscriptionServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    disableRecurringPayments(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Subscription/DisableRecurringPayments";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDisableRecurringPayments(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDisableRecurringPayments(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDisableRecurringPayments(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    enableRecurringPayments(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Subscription/EnableRecurringPayments";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processEnableRecurringPayments(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processEnableRecurringPayments(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processEnableRecurringPayments(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class SupportCategoryTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param colorFilter (optional) 
     * @param iconFilter (optional) 
     * @param inactiveFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, colorFilter: string | undefined, iconFilter: string | undefined, inactiveFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetSupportCategoryTypesForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportCategoryTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        if (iconFilter === null)
            throw new Error("The parameter 'iconFilter' cannot be null.");
        else if (iconFilter !== undefined)
            url_ += "IconFilter=" + encodeURIComponent("" + iconFilter) + "&"; 
        if (inactiveFilter === null)
            throw new Error("The parameter 'inactiveFilter' cannot be null.");
        else if (inactiveFilter !== undefined)
            url_ += "InactiveFilter=" + encodeURIComponent("" + inactiveFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetSupportCategoryTypesForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetSupportCategoryTypesForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetSupportCategoryTypesForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetSupportCategoryTypesForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetSupportCategoryTypesForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSupportCategoryTypesForView(id: number | undefined): Observable<GetSupportCategoryTypesForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportCategoryTypes/GetSupportCategoryTypesForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportCategoryTypesForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportCategoryTypesForView(<any>response_);
                } catch (e) {
                    return <Observable<GetSupportCategoryTypesForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSupportCategoryTypesForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportCategoryTypesForView(response: HttpResponseBase): Observable<GetSupportCategoryTypesForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSupportCategoryTypesForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSupportCategoryTypesForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSupportCategoryTypesForEdit(id: number | undefined): Observable<GetSupportCategoryTypesForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/SupportCategoryTypes/GetSupportCategoryTypesForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportCategoryTypesForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportCategoryTypesForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetSupportCategoryTypesForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSupportCategoryTypesForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportCategoryTypesForEdit(response: HttpResponseBase): Observable<GetSupportCategoryTypesForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSupportCategoryTypesForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSupportCategoryTypesForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditSupportCategoryTypesDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportCategoryTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportCategoryTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param colorFilter (optional) 
     * @param iconFilter (optional) 
     * @param inactiveFilter (optional) 
     * @return Success
     */
    getSupportCategoryTypesToExcel(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, colorFilter: string | undefined, iconFilter: string | undefined, inactiveFilter: number | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportCategoryTypes/GetSupportCategoryTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        if (iconFilter === null)
            throw new Error("The parameter 'iconFilter' cannot be null.");
        else if (iconFilter !== undefined)
            url_ += "IconFilter=" + encodeURIComponent("" + iconFilter) + "&"; 
        if (inactiveFilter === null)
            throw new Error("The parameter 'inactiveFilter' cannot be null.");
        else if (inactiveFilter !== undefined)
            url_ += "InactiveFilter=" + encodeURIComponent("" + inactiveFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportCategoryTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportCategoryTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportCategoryTypesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param colorFilter (optional) 
     * @param iconFilter (optional) 
     * @param inactiveFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getCategoryTypesPagedList(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, colorFilter: string | undefined, iconFilter: string | undefined, inactiveFilter: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportCategoryTypes/GetCategoryTypesPagedList?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        if (iconFilter === null)
            throw new Error("The parameter 'iconFilter' cannot be null.");
        else if (iconFilter !== undefined)
            url_ += "IconFilter=" + encodeURIComponent("" + iconFilter) + "&"; 
        if (inactiveFilter === null)
            throw new Error("The parameter 'inactiveFilter' cannot be null.");
        else if (inactiveFilter !== undefined)
            url_ += "InactiveFilter=" + encodeURIComponent("" + inactiveFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCategoryTypesPagedList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCategoryTypesPagedList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCategoryTypesPagedList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class SupportTicketServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getTicketForEdit(id: number | undefined): Observable<GetTicketForEdit> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetTicketForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTicketForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTicketForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetTicketForEdit>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTicketForEdit>><any>_observableThrow(response_);
        }));
    }

    protected processGetTicketForEdit(response: HttpResponseBase): Observable<GetTicketForEdit> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTicketForEdit.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTicketForEdit>(<any>null);
    }

    /**
     * @return Success
     */
    getTicketForKPI(): Observable<TicketKPI> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetTicketForKPI";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTicketForKPI(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTicketForKPI(<any>response_);
                } catch (e) {
                    return <Observable<TicketKPI>><any>_observableThrow(e);
                }
            } else
                return <Observable<TicketKPI>><any>_observableThrow(response_);
        }));
    }

    protected processGetTicketForKPI(response: HttpResponseBase): Observable<TicketKPI> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TicketKPI.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TicketKPI>(<any>null);
    }

    /**
     * @param ticketId (optional) 
     * @return Success
     */
    getFiles(ticketId: number | undefined): Observable<ListResultDtoOfAttachmentList> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetFiles?";
        if (ticketId === null)
            throw new Error("The parameter 'ticketId' cannot be null.");
        else if (ticketId !== undefined)
            url_ += "ticketId=" + encodeURIComponent("" + ticketId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetFiles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetFiles(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfAttachmentList>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfAttachmentList>><any>_observableThrow(response_);
        }));
    }

    protected processGetFiles(response: HttpResponseBase): Observable<ListResultDtoOfAttachmentList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfAttachmentList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfAttachmentList>(<any>null);
    }

    /**
     * @param ticketId (optional) 
     * @return Success
     */
    getNotes(ticketId: number | undefined): Observable<ListResultDtoOfNoteList> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetNotes?";
        if (ticketId === null)
            throw new Error("The parameter 'ticketId' cannot be null.");
        else if (ticketId !== undefined)
            url_ += "ticketId=" + encodeURIComponent("" + ticketId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetNotes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetNotes(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfNoteList>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfNoteList>><any>_observableThrow(response_);
        }));
    }

    protected processGetNotes(response: HttpResponseBase): Observable<ListResultDtoOfNoteList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfNoteList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfNoteList>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    downloadFile(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/DownloadFile?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDownloadFile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDownloadFile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDownloadFile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getUsersForDropDown(): Observable<ListResultDtoOfUserListDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetUsersForDropDown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUsersForDropDown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUsersForDropDown(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfUserListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfUserListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUsersForDropDown(response: HttpResponseBase): Observable<ListResultDtoOfUserListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfUserListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfUserListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    usersList(body: GetSupportTicketUsersInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/UsersList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUsersList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUsersList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processUsersList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    organizationalUnitsList(body: GetSupportTicketUsersInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/OrganizationalUnitsList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processOrganizationalUnitsList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processOrganizationalUnitsList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processOrganizationalUnitsList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    ticketsList(body: GetSupportTicketUsersInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/TicketsList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTicketsList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTicketsList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processTicketsList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getTenantForDropDown(): Observable<ListResultDtoOfTenantListDropDown> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetTenantForDropDown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantForDropDown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantForDropDown(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfTenantListDropDown>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfTenantListDropDown>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantForDropDown(response: HttpResponseBase): Observable<ListResultDtoOfTenantListDropDown> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfTenantListDropDown.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfTenantListDropDown>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    replaceTenant(body: GetTicketInput | undefined): Observable<PagedResultDtoOfTicketList> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/ReplaceTenant";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processReplaceTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processReplaceTenant(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTicketList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTicketList>><any>_observableThrow(response_);
        }));
    }

    protected processReplaceTenant(response: HttpResponseBase): Observable<PagedResultDtoOfTicketList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTicketList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTicketList>(<any>null);
    }

    /**
     * @return Success
     */
    getTenantTicket(): Observable<TenantList[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetTenantTicket";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantTicket(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantTicket(<any>response_);
                } catch (e) {
                    return <Observable<TenantList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<TenantList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantTicket(response: HttpResponseBase): Observable<TenantList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(TenantList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TenantList[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTenantTicket(body: UpdateTicketTenant | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/UpdateTenantTicket";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTenantTicket(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTenantTicket(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTenantTicket(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param assignedToFilter (optional) 
     * @param tester (optional) 
     * @param statusFilter (optional) 
     * @param statusFilterCode (optional) 
     * @param typeFilter (optional) 
     * @param typeFilterCode (optional) 
     * @param createdFrom (optional) 
     * @param createdTo (optional) 
     * @param createdBy (optional) 
     * @param priority (optional) 
     * @param tenantId (optional) 
     * @param parentStatusTypeId (optional) 
     * @param parentStatusTypeIds (optional) 
     * @param categoryTypeId (optional) 
     * @param organizationUnitId (optional) 
     * @param todayFilter (optional) 
     * @param myTicketsFilter (optional) 
     * @param openTicketFilter (optional) 
     * @param startDate (optional) 
     * @param dueDate (optional) 
     * @param effortHour (optional) 
     * @param versionId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getTicket(filter: string | undefined, assignedToFilter: string | undefined, tester: string | undefined, statusFilter: string | undefined, statusFilterCode: string[] | undefined, typeFilter: string | undefined, typeFilterCode: string[] | undefined, createdFrom: string | undefined, createdTo: string | undefined, createdBy: string | undefined, priority: number[] | undefined, tenantId: number[] | undefined, parentStatusTypeId: number | undefined, parentStatusTypeIds: number[] | undefined, categoryTypeId: number[] | undefined, organizationUnitId: number | undefined, todayFilter: string | undefined, myTicketsFilter: string | undefined, openTicketFilter: string | undefined, startDate: moment.Moment | undefined, dueDate: moment.Moment | undefined, effortHour: number | undefined, versionId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfTicketList> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetTicket?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (assignedToFilter === null)
            throw new Error("The parameter 'assignedToFilter' cannot be null.");
        else if (assignedToFilter !== undefined)
            url_ += "AssignedToFilter=" + encodeURIComponent("" + assignedToFilter) + "&"; 
        if (tester === null)
            throw new Error("The parameter 'tester' cannot be null.");
        else if (tester !== undefined)
            url_ += "Tester=" + encodeURIComponent("" + tester) + "&"; 
        if (statusFilter === null)
            throw new Error("The parameter 'statusFilter' cannot be null.");
        else if (statusFilter !== undefined)
            url_ += "StatusFilter=" + encodeURIComponent("" + statusFilter) + "&"; 
        if (statusFilterCode === null)
            throw new Error("The parameter 'statusFilterCode' cannot be null.");
        else if (statusFilterCode !== undefined)
            statusFilterCode && statusFilterCode.forEach(item => { url_ += "StatusFilterCode=" + encodeURIComponent("" + item) + "&"; });
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        if (typeFilterCode === null)
            throw new Error("The parameter 'typeFilterCode' cannot be null.");
        else if (typeFilterCode !== undefined)
            typeFilterCode && typeFilterCode.forEach(item => { url_ += "TypeFilterCode=" + encodeURIComponent("" + item) + "&"; });
        if (createdFrom === null)
            throw new Error("The parameter 'createdFrom' cannot be null.");
        else if (createdFrom !== undefined)
            url_ += "CreatedFrom=" + encodeURIComponent("" + createdFrom) + "&"; 
        if (createdTo === null)
            throw new Error("The parameter 'createdTo' cannot be null.");
        else if (createdTo !== undefined)
            url_ += "CreatedTo=" + encodeURIComponent("" + createdTo) + "&"; 
        if (createdBy === null)
            throw new Error("The parameter 'createdBy' cannot be null.");
        else if (createdBy !== undefined)
            url_ += "CreatedBy=" + encodeURIComponent("" + createdBy) + "&"; 
        if (priority === null)
            throw new Error("The parameter 'priority' cannot be null.");
        else if (priority !== undefined)
            priority && priority.forEach(item => { url_ += "Priority=" + encodeURIComponent("" + item) + "&"; });
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            tenantId && tenantId.forEach(item => { url_ += "TenantId=" + encodeURIComponent("" + item) + "&"; });
        if (parentStatusTypeId === null)
            throw new Error("The parameter 'parentStatusTypeId' cannot be null.");
        else if (parentStatusTypeId !== undefined)
            url_ += "ParentStatusTypeId=" + encodeURIComponent("" + parentStatusTypeId) + "&"; 
        if (parentStatusTypeIds === null)
            throw new Error("The parameter 'parentStatusTypeIds' cannot be null.");
        else if (parentStatusTypeIds !== undefined)
            parentStatusTypeIds && parentStatusTypeIds.forEach(item => { url_ += "ParentStatusTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (categoryTypeId === null)
            throw new Error("The parameter 'categoryTypeId' cannot be null.");
        else if (categoryTypeId !== undefined)
            categoryTypeId && categoryTypeId.forEach(item => { url_ += "CategoryTypeId=" + encodeURIComponent("" + item) + "&"; });
        if (organizationUnitId === null)
            throw new Error("The parameter 'organizationUnitId' cannot be null.");
        else if (organizationUnitId !== undefined)
            url_ += "OrganizationUnitId=" + encodeURIComponent("" + organizationUnitId) + "&"; 
        if (todayFilter === null)
            throw new Error("The parameter 'todayFilter' cannot be null.");
        else if (todayFilter !== undefined)
            url_ += "TodayFilter=" + encodeURIComponent("" + todayFilter) + "&"; 
        if (myTicketsFilter === null)
            throw new Error("The parameter 'myTicketsFilter' cannot be null.");
        else if (myTicketsFilter !== undefined)
            url_ += "MyTicketsFilter=" + encodeURIComponent("" + myTicketsFilter) + "&"; 
        if (openTicketFilter === null)
            throw new Error("The parameter 'openTicketFilter' cannot be null.");
        else if (openTicketFilter !== undefined)
            url_ += "OpenTicketFilter=" + encodeURIComponent("" + openTicketFilter) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (dueDate === null)
            throw new Error("The parameter 'dueDate' cannot be null.");
        else if (dueDate !== undefined)
            url_ += "DueDate=" + encodeURIComponent(dueDate ? "" + dueDate.toJSON() : "") + "&"; 
        if (effortHour === null)
            throw new Error("The parameter 'effortHour' cannot be null.");
        else if (effortHour !== undefined)
            url_ += "EffortHour=" + encodeURIComponent("" + effortHour) + "&"; 
        if (versionId === null)
            throw new Error("The parameter 'versionId' cannot be null.");
        else if (versionId !== undefined)
            url_ += "VersionId=" + encodeURIComponent("" + versionId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTicket(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTicket(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTicketList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTicketList>><any>_observableThrow(response_);
        }));
    }

    protected processGetTicket(response: HttpResponseBase): Observable<PagedResultDtoOfTicketList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTicketList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTicketList>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteNote(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/DeleteNote?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteAttachment(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/DeleteAttachment?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteAttachment(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteAttachment(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteAttachment(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createFile(body: CreateAttachments | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/CreateFile";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateFile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateFile(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateFile(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createNote(body: CreateNotes | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/CreateNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateNote(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateNote(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param statusId (optional) 
     * @return Success
     */
    closeTicket(id: number | undefined, statusId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/CloseTicket?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (statusId === null)
            throw new Error("The parameter 'statusId' cannot be null.");
        else if (statusId !== undefined)
            url_ += "StatusId=" + encodeURIComponent("" + statusId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCloseTicket(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCloseTicket(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCloseTicket(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param userName (optional) 
     * @return Success
     */
    assignedUser(id: number | undefined, userId: number | undefined, userName: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/AssignedUser?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "userId=" + encodeURIComponent("" + userId) + "&"; 
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "userName=" + encodeURIComponent("" + userName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignedUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignedUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAssignedUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTicket(body: UpdateTicketDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/UpdateTicket";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTicket(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTicket(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTicket(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createTicket(body: CreateTicketDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/CreateTicket";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateTicket(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateTicket(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateTicket(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param statusCode (optional) 
     * @return Success
     */
    getStatusIdByCode(statusCode: string | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetStatusIdByCode?";
        if (statusCode === null)
            throw new Error("The parameter 'statusCode' cannot be null.");
        else if (statusCode !== undefined)
            url_ += "statusCode=" + encodeURIComponent("" + statusCode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetStatusIdByCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetStatusIdByCode(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetStatusIdByCode(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param assignedToFilter (optional) 
     * @param tester (optional) 
     * @param statusFilter (optional) 
     * @param statusFilterCode (optional) 
     * @param typeFilter (optional) 
     * @param typeFilterCode (optional) 
     * @param createdFrom (optional) 
     * @param createdTo (optional) 
     * @param createdBy (optional) 
     * @param priority (optional) 
     * @param tenantId (optional) 
     * @param parentStatusTypeId (optional) 
     * @param parentStatusTypeIds (optional) 
     * @param categoryTypeId (optional) 
     * @param organizationUnitId (optional) 
     * @param todayFilter (optional) 
     * @param myTicketsFilter (optional) 
     * @param openTicketFilter (optional) 
     * @param startDate (optional) 
     * @param dueDate (optional) 
     * @param effortHour (optional) 
     * @param versionId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getTicketToExcel(filter: string | undefined, assignedToFilter: string | undefined, tester: string | undefined, statusFilter: string | undefined, statusFilterCode: string[] | undefined, typeFilter: string | undefined, typeFilterCode: string[] | undefined, createdFrom: string | undefined, createdTo: string | undefined, createdBy: string | undefined, priority: number[] | undefined, tenantId: number[] | undefined, parentStatusTypeId: number | undefined, parentStatusTypeIds: number[] | undefined, categoryTypeId: number[] | undefined, organizationUnitId: number | undefined, todayFilter: string | undefined, myTicketsFilter: string | undefined, openTicketFilter: string | undefined, startDate: moment.Moment | undefined, dueDate: moment.Moment | undefined, effortHour: number | undefined, versionId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetTicketToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (assignedToFilter === null)
            throw new Error("The parameter 'assignedToFilter' cannot be null.");
        else if (assignedToFilter !== undefined)
            url_ += "AssignedToFilter=" + encodeURIComponent("" + assignedToFilter) + "&"; 
        if (tester === null)
            throw new Error("The parameter 'tester' cannot be null.");
        else if (tester !== undefined)
            url_ += "Tester=" + encodeURIComponent("" + tester) + "&"; 
        if (statusFilter === null)
            throw new Error("The parameter 'statusFilter' cannot be null.");
        else if (statusFilter !== undefined)
            url_ += "StatusFilter=" + encodeURIComponent("" + statusFilter) + "&"; 
        if (statusFilterCode === null)
            throw new Error("The parameter 'statusFilterCode' cannot be null.");
        else if (statusFilterCode !== undefined)
            statusFilterCode && statusFilterCode.forEach(item => { url_ += "StatusFilterCode=" + encodeURIComponent("" + item) + "&"; });
        if (typeFilter === null)
            throw new Error("The parameter 'typeFilter' cannot be null.");
        else if (typeFilter !== undefined)
            url_ += "TypeFilter=" + encodeURIComponent("" + typeFilter) + "&"; 
        if (typeFilterCode === null)
            throw new Error("The parameter 'typeFilterCode' cannot be null.");
        else if (typeFilterCode !== undefined)
            typeFilterCode && typeFilterCode.forEach(item => { url_ += "TypeFilterCode=" + encodeURIComponent("" + item) + "&"; });
        if (createdFrom === null)
            throw new Error("The parameter 'createdFrom' cannot be null.");
        else if (createdFrom !== undefined)
            url_ += "CreatedFrom=" + encodeURIComponent("" + createdFrom) + "&"; 
        if (createdTo === null)
            throw new Error("The parameter 'createdTo' cannot be null.");
        else if (createdTo !== undefined)
            url_ += "CreatedTo=" + encodeURIComponent("" + createdTo) + "&"; 
        if (createdBy === null)
            throw new Error("The parameter 'createdBy' cannot be null.");
        else if (createdBy !== undefined)
            url_ += "CreatedBy=" + encodeURIComponent("" + createdBy) + "&"; 
        if (priority === null)
            throw new Error("The parameter 'priority' cannot be null.");
        else if (priority !== undefined)
            priority && priority.forEach(item => { url_ += "Priority=" + encodeURIComponent("" + item) + "&"; });
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            tenantId && tenantId.forEach(item => { url_ += "TenantId=" + encodeURIComponent("" + item) + "&"; });
        if (parentStatusTypeId === null)
            throw new Error("The parameter 'parentStatusTypeId' cannot be null.");
        else if (parentStatusTypeId !== undefined)
            url_ += "ParentStatusTypeId=" + encodeURIComponent("" + parentStatusTypeId) + "&"; 
        if (parentStatusTypeIds === null)
            throw new Error("The parameter 'parentStatusTypeIds' cannot be null.");
        else if (parentStatusTypeIds !== undefined)
            parentStatusTypeIds && parentStatusTypeIds.forEach(item => { url_ += "ParentStatusTypeIds=" + encodeURIComponent("" + item) + "&"; });
        if (categoryTypeId === null)
            throw new Error("The parameter 'categoryTypeId' cannot be null.");
        else if (categoryTypeId !== undefined)
            categoryTypeId && categoryTypeId.forEach(item => { url_ += "CategoryTypeId=" + encodeURIComponent("" + item) + "&"; });
        if (organizationUnitId === null)
            throw new Error("The parameter 'organizationUnitId' cannot be null.");
        else if (organizationUnitId !== undefined)
            url_ += "OrganizationUnitId=" + encodeURIComponent("" + organizationUnitId) + "&"; 
        if (todayFilter === null)
            throw new Error("The parameter 'todayFilter' cannot be null.");
        else if (todayFilter !== undefined)
            url_ += "TodayFilter=" + encodeURIComponent("" + todayFilter) + "&"; 
        if (myTicketsFilter === null)
            throw new Error("The parameter 'myTicketsFilter' cannot be null.");
        else if (myTicketsFilter !== undefined)
            url_ += "MyTicketsFilter=" + encodeURIComponent("" + myTicketsFilter) + "&"; 
        if (openTicketFilter === null)
            throw new Error("The parameter 'openTicketFilter' cannot be null.");
        else if (openTicketFilter !== undefined)
            url_ += "OpenTicketFilter=" + encodeURIComponent("" + openTicketFilter) + "&"; 
        if (startDate === null)
            throw new Error("The parameter 'startDate' cannot be null.");
        else if (startDate !== undefined)
            url_ += "StartDate=" + encodeURIComponent(startDate ? "" + startDate.toJSON() : "") + "&"; 
        if (dueDate === null)
            throw new Error("The parameter 'dueDate' cannot be null.");
        else if (dueDate !== undefined)
            url_ += "DueDate=" + encodeURIComponent(dueDate ? "" + dueDate.toJSON() : "") + "&"; 
        if (effortHour === null)
            throw new Error("The parameter 'effortHour' cannot be null.");
        else if (effortHour !== undefined)
            url_ += "EffortHour=" + encodeURIComponent("" + effortHour) + "&"; 
        if (versionId === null)
            throw new Error("The parameter 'versionId' cannot be null.");
        else if (versionId !== undefined)
            url_ += "VersionId=" + encodeURIComponent("" + versionId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTicketToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTicketToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTicketToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getEnvironmentTypeList(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetEnvironmentTypeList?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEnvironmentTypeList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEnvironmentTypeList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEnvironmentTypeList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getPriorityTypeList(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicket/GetPriorityTypeList?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPriorityTypeList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPriorityTypeList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPriorityTypeList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class SupportTicketNotificationRecipientsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param isEmailFilter (optional) 
     * @param isSMSFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param emailAddressFilter (optional) 
     * @param codeFilter (optional) 
     * @param organizationUnitDisplayNameFilter (optional) 
     * @param userNameFilter (optional) 
     * @param supportTicketNotificationDescriptionFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, isEmailFilter: number | undefined, isSMSFilter: number | undefined, isActiveFilter: number | undefined, emailAddressFilter: string | undefined, codeFilter: string | undefined, organizationUnitDisplayNameFilter: string | undefined, userNameFilter: string | undefined, supportTicketNotificationDescriptionFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (isEmailFilter === null)
            throw new Error("The parameter 'isEmailFilter' cannot be null.");
        else if (isEmailFilter !== undefined)
            url_ += "IsEmailFilter=" + encodeURIComponent("" + isEmailFilter) + "&"; 
        if (isSMSFilter === null)
            throw new Error("The parameter 'isSMSFilter' cannot be null.");
        else if (isSMSFilter !== undefined)
            url_ += "IsSMSFilter=" + encodeURIComponent("" + isSMSFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (emailAddressFilter === null)
            throw new Error("The parameter 'emailAddressFilter' cannot be null.");
        else if (emailAddressFilter !== undefined)
            url_ += "EmailAddressFilter=" + encodeURIComponent("" + emailAddressFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (organizationUnitDisplayNameFilter === null)
            throw new Error("The parameter 'organizationUnitDisplayNameFilter' cannot be null.");
        else if (organizationUnitDisplayNameFilter !== undefined)
            url_ += "OrganizationUnitDisplayNameFilter=" + encodeURIComponent("" + organizationUnitDisplayNameFilter) + "&"; 
        if (userNameFilter === null)
            throw new Error("The parameter 'userNameFilter' cannot be null.");
        else if (userNameFilter !== undefined)
            url_ += "UserNameFilter=" + encodeURIComponent("" + userNameFilter) + "&"; 
        if (supportTicketNotificationDescriptionFilter === null)
            throw new Error("The parameter 'supportTicketNotificationDescriptionFilter' cannot be null.");
        else if (supportTicketNotificationDescriptionFilter !== undefined)
            url_ += "SupportTicketNotificationDescriptionFilter=" + encodeURIComponent("" + supportTicketNotificationDescriptionFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSupportTicketNotificationRecipientsForView(id: number | undefined): Observable<GetSupportTicketNotificationRecipientsForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/GetSupportTicketNotificationRecipientsForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportTicketNotificationRecipientsForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportTicketNotificationRecipientsForView(<any>response_);
                } catch (e) {
                    return <Observable<GetSupportTicketNotificationRecipientsForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSupportTicketNotificationRecipientsForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportTicketNotificationRecipientsForView(response: HttpResponseBase): Observable<GetSupportTicketNotificationRecipientsForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSupportTicketNotificationRecipientsForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSupportTicketNotificationRecipientsForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSupportTicketNotificationRecipientsForEdit(id: number | undefined): Observable<GetSupportTicketNotificationRecipientsForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/GetSupportTicketNotificationRecipientsForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportTicketNotificationRecipientsForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportTicketNotificationRecipientsForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetSupportTicketNotificationRecipientsForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSupportTicketNotificationRecipientsForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportTicketNotificationRecipientsForEdit(response: HttpResponseBase): Observable<GetSupportTicketNotificationRecipientsForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSupportTicketNotificationRecipientsForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSupportTicketNotificationRecipientsForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditSupportTicketNotificationRecipientsDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    create(body: CreateOrEditSupportTicketNotificationRecipientsDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/Create";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    update(body: CreateOrEditSupportTicketNotificationRecipientsDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/Update";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param isEmailFilter (optional) 
     * @param isSMSFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param emailAddressFilter (optional) 
     * @param codeFilter (optional) 
     * @param organizationUnitDisplayNameFilter (optional) 
     * @param userNameFilter (optional) 
     * @param supportTicketNotificationDescriptionFilter (optional) 
     * @return Success
     */
    getSupportTicketNotificationRecipientsesToExcel(filter: string | undefined, isEmailFilter: number | undefined, isSMSFilter: number | undefined, isActiveFilter: number | undefined, emailAddressFilter: string | undefined, codeFilter: string | undefined, organizationUnitDisplayNameFilter: string | undefined, userNameFilter: string | undefined, supportTicketNotificationDescriptionFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/GetSupportTicketNotificationRecipientsesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (isEmailFilter === null)
            throw new Error("The parameter 'isEmailFilter' cannot be null.");
        else if (isEmailFilter !== undefined)
            url_ += "IsEmailFilter=" + encodeURIComponent("" + isEmailFilter) + "&"; 
        if (isSMSFilter === null)
            throw new Error("The parameter 'isSMSFilter' cannot be null.");
        else if (isSMSFilter !== undefined)
            url_ += "IsSMSFilter=" + encodeURIComponent("" + isSMSFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (emailAddressFilter === null)
            throw new Error("The parameter 'emailAddressFilter' cannot be null.");
        else if (emailAddressFilter !== undefined)
            url_ += "EmailAddressFilter=" + encodeURIComponent("" + emailAddressFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (organizationUnitDisplayNameFilter === null)
            throw new Error("The parameter 'organizationUnitDisplayNameFilter' cannot be null.");
        else if (organizationUnitDisplayNameFilter !== undefined)
            url_ += "OrganizationUnitDisplayNameFilter=" + encodeURIComponent("" + organizationUnitDisplayNameFilter) + "&"; 
        if (userNameFilter === null)
            throw new Error("The parameter 'userNameFilter' cannot be null.");
        else if (userNameFilter !== undefined)
            url_ += "UserNameFilter=" + encodeURIComponent("" + userNameFilter) + "&"; 
        if (supportTicketNotificationDescriptionFilter === null)
            throw new Error("The parameter 'supportTicketNotificationDescriptionFilter' cannot be null.");
        else if (supportTicketNotificationDescriptionFilter !== undefined)
            url_ += "SupportTicketNotificationDescriptionFilter=" + encodeURIComponent("" + supportTicketNotificationDescriptionFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportTicketNotificationRecipientsesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportTicketNotificationRecipientsesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportTicketNotificationRecipientsesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllOrganizationUnitForLookupTable(filter: string | undefined, id: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/GetAllOrganizationUnitForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrganizationUnitForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrganizationUnitForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrganizationUnitForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllUserForLookupTable(filter: string | undefined, id: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/GetAllUserForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllUserForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllUserForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllUserForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllSupportTicketNotificationForLookupTable(filter: string | undefined, id: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotificationRecipients/GetAllSupportTicketNotificationForLookupTable?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSupportTicketNotificationForLookupTable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSupportTicketNotificationForLookupTable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSupportTicketNotificationForLookupTable(response: HttpResponseBase): Observable<PagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto>(<any>null);
    }
}

@Injectable()
export class SupportTicketNotificationsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param descriptionFilter (optional) 
     * @param codeFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param orderNotificationTemplateDescriptionFilter (optional) 
     * @param supportTicketStatusDescriptionFilter (optional) 
     * @param smsTemplateDescriptionFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, descriptionFilter: string | undefined, codeFilter: string | undefined, isActiveFilter: number | undefined, orderNotificationTemplateDescriptionFilter: string | undefined, supportTicketStatusDescriptionFilter: string | undefined, smsTemplateDescriptionFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetSupportTicketNotificationForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (orderNotificationTemplateDescriptionFilter === null)
            throw new Error("The parameter 'orderNotificationTemplateDescriptionFilter' cannot be null.");
        else if (orderNotificationTemplateDescriptionFilter !== undefined)
            url_ += "OrderNotificationTemplateDescriptionFilter=" + encodeURIComponent("" + orderNotificationTemplateDescriptionFilter) + "&"; 
        if (supportTicketStatusDescriptionFilter === null)
            throw new Error("The parameter 'supportTicketStatusDescriptionFilter' cannot be null.");
        else if (supportTicketStatusDescriptionFilter !== undefined)
            url_ += "SupportTicketStatusDescriptionFilter=" + encodeURIComponent("" + supportTicketStatusDescriptionFilter) + "&"; 
        if (smsTemplateDescriptionFilter === null)
            throw new Error("The parameter 'smsTemplateDescriptionFilter' cannot be null.");
        else if (smsTemplateDescriptionFilter !== undefined)
            url_ += "SmsTemplateDescriptionFilter=" + encodeURIComponent("" + smsTemplateDescriptionFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetSupportTicketNotificationForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetSupportTicketNotificationForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetSupportTicketNotificationForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetSupportTicketNotificationForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetSupportTicketNotificationForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSupportTicketNotificationForView(id: number | undefined): Observable<GetSupportTicketNotificationForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetSupportTicketNotificationForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportTicketNotificationForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportTicketNotificationForView(<any>response_);
                } catch (e) {
                    return <Observable<GetSupportTicketNotificationForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSupportTicketNotificationForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportTicketNotificationForView(response: HttpResponseBase): Observable<GetSupportTicketNotificationForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSupportTicketNotificationForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSupportTicketNotificationForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getSupportTicketNotificationForEdit(id: number | undefined): Observable<GetSupportTicketNotificationForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetSupportTicketNotificationForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportTicketNotificationForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportTicketNotificationForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetSupportTicketNotificationForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSupportTicketNotificationForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportTicketNotificationForEdit(response: HttpResponseBase): Observable<GetSupportTicketNotificationForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSupportTicketNotificationForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSupportTicketNotificationForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditSupportTicketNotificationDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param descriptionFilter (optional) 
     * @param codeFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param orderNotificationTemplateDescriptionFilter (optional) 
     * @param supportTicketStatusDescriptionFilter (optional) 
     * @param smsTemplateDescriptionFilter (optional) 
     * @return Success
     */
    getSupportTicketNotificationsToExcel(filter: string | undefined, descriptionFilter: string | undefined, codeFilter: string | undefined, isActiveFilter: number | undefined, orderNotificationTemplateDescriptionFilter: string | undefined, supportTicketStatusDescriptionFilter: string | undefined, smsTemplateDescriptionFilter: string | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetSupportTicketNotificationsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (orderNotificationTemplateDescriptionFilter === null)
            throw new Error("The parameter 'orderNotificationTemplateDescriptionFilter' cannot be null.");
        else if (orderNotificationTemplateDescriptionFilter !== undefined)
            url_ += "OrderNotificationTemplateDescriptionFilter=" + encodeURIComponent("" + orderNotificationTemplateDescriptionFilter) + "&"; 
        if (supportTicketStatusDescriptionFilter === null)
            throw new Error("The parameter 'supportTicketStatusDescriptionFilter' cannot be null.");
        else if (supportTicketStatusDescriptionFilter !== undefined)
            url_ += "SupportTicketStatusDescriptionFilter=" + encodeURIComponent("" + supportTicketStatusDescriptionFilter) + "&"; 
        if (smsTemplateDescriptionFilter === null)
            throw new Error("The parameter 'smsTemplateDescriptionFilter' cannot be null.");
        else if (smsTemplateDescriptionFilter !== undefined)
            url_ += "SmsTemplateDescriptionFilter=" + encodeURIComponent("" + smsTemplateDescriptionFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportTicketNotificationsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportTicketNotificationsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportTicketNotificationsToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrderNotificationTemplateForTableDropdown(): Observable<SupportTicketNotificationOrderNotificationTemplateLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetAllOrderNotificationTemplateForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderNotificationTemplateForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderNotificationTemplateForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<SupportTicketNotificationOrderNotificationTemplateLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<SupportTicketNotificationOrderNotificationTemplateLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderNotificationTemplateForTableDropdown(response: HttpResponseBase): Observable<SupportTicketNotificationOrderNotificationTemplateLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(SupportTicketNotificationOrderNotificationTemplateLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SupportTicketNotificationOrderNotificationTemplateLookupTableDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllSupportTicketStatusForTableDropdown(): Observable<SupportTicketNotificationSupportTicketStatusLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetAllSupportTicketStatusForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSupportTicketStatusForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSupportTicketStatusForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<SupportTicketNotificationSupportTicketStatusLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<SupportTicketNotificationSupportTicketStatusLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSupportTicketStatusForTableDropdown(response: HttpResponseBase): Observable<SupportTicketNotificationSupportTicketStatusLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(SupportTicketNotificationSupportTicketStatusLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SupportTicketNotificationSupportTicketStatusLookupTableDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllSmsTemplateForTableDropdown(): Observable<SupportTicketNotificationSmsTemplateLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetAllSmsTemplateForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSmsTemplateForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSmsTemplateForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<SupportTicketNotificationSmsTemplateLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<SupportTicketNotificationSmsTemplateLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSmsTemplateForTableDropdown(response: HttpResponseBase): Observable<SupportTicketNotificationSmsTemplateLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(SupportTicketNotificationSmsTemplateLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SupportTicketNotificationSmsTemplateLookupTableDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllUserForTableDropdown(): Observable<UserListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetAllUserForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllUserForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllUserForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<UserListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<UserListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllUserForTableDropdown(response: HttpResponseBase): Observable<UserListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(UserListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UserListDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrgUnitsForTableDropdown(): Observable<OrganizationUnitDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetAllOrgUnitsForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrgUnitsForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrgUnitsForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<OrganizationUnitDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<OrganizationUnitDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrgUnitsForTableDropdown(response: HttpResponseBase): Observable<OrganizationUnitDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(OrganizationUnitDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<OrganizationUnitDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getAllTenantsForTableDropdown(): Observable<TenantListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/GetAllTenantsForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllTenantsForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllTenantsForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<TenantListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<TenantListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllTenantsForTableDropdown(response: HttpResponseBase): Observable<TenantListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(TenantListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TenantListDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    supportNotification(body: SupportTicketNotificationInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketNotifications/SupportNotification";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSupportNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSupportNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSupportNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class SupportTicketSettingServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getSupportTicketSetting(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfSupportTicketSettingList> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketSetting/GetSupportTicketSetting?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSupportTicketSetting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSupportTicketSetting(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfSupportTicketSettingList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfSupportTicketSettingList>><any>_observableThrow(response_);
        }));
    }

    protected processGetSupportTicketSetting(response: HttpResponseBase): Observable<PagedResultDtoOfSupportTicketSettingList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfSupportTicketSettingList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfSupportTicketSettingList>(<any>null);
    }

    /**
     * @return Success
     */
    getSettingsForDisplay(): Observable<SupportTicketSettingList[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketSetting/GetSettingsForDisplay";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSettingsForDisplay(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSettingsForDisplay(<any>response_);
                } catch (e) {
                    return <Observable<SupportTicketSettingList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<SupportTicketSettingList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetSettingsForDisplay(response: HttpResponseBase): Observable<SupportTicketSettingList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(SupportTicketSettingList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SupportTicketSettingList[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketSetting/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    checkSupportSetting(): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketSetting/CheckSupportSetting";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckSupportSetting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckSupportSetting(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processCheckSupportSetting(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createSupportTicketSetting(body: CreateSupportTicketSettingDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketSetting/CreateSupportTicketSetting";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateSupportTicketSetting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateSupportTicketSetting(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateSupportTicketSetting(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateSupportTicketSetting(body: UpdateSupportTicketSettingDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketSetting/UpdateSupportTicketSetting";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateSupportTicketSetting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateSupportTicketSetting(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateSupportTicketSetting(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class SupportTicketStatusServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getTicketStatusList(): Observable<ListResultDtoOfTicketStatusList> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/GetTicketStatusList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTicketStatusList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTicketStatusList(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfTicketStatusList>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfTicketStatusList>><any>_observableThrow(response_);
        }));
    }

    protected processGetTicketStatusList(response: HttpResponseBase): Observable<ListResultDtoOfTicketStatusList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfTicketStatusList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfTicketStatusList>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param id (optional) 
     * @param isPublicFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getTicketStatus(filter: string | undefined, id: number | undefined, isPublicFilter: boolean | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfTicketStatusList> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/GetTicketStatus?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (isPublicFilter === null)
            throw new Error("The parameter 'isPublicFilter' cannot be null.");
        else if (isPublicFilter !== undefined)
            url_ += "IsPublicFilter=" + encodeURIComponent("" + isPublicFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTicketStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTicketStatus(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTicketStatusList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTicketStatusList>><any>_observableThrow(response_);
        }));
    }

    protected processGetTicketStatus(response: HttpResponseBase): Observable<PagedResultDtoOfTicketStatusList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTicketStatusList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTicketStatusList>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    ticketStatusPagedList(body: GetTicketStatusInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/TicketStatusPagedList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTicketStatusPagedList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTicketStatusPagedList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processTicketStatusPagedList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createTicketStatus(body: CreateTicketStatusDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/CreateTicketStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateTicketStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateTicketStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateTicketStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTicketStatus(body: UpdateTicketStatusDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/UpdateTicketStatus";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTicketStatus(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTicketStatus(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTicketStatus(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getParentTicketStatusType(): Observable<TicketStatusCodeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/GetParentTicketStatusType";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetParentTicketStatusType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetParentTicketStatusType(<any>response_);
                } catch (e) {
                    return <Observable<TicketStatusCodeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<TicketStatusCodeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetParentTicketStatusType(response: HttpResponseBase): Observable<TicketStatusCodeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(TicketStatusCodeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TicketStatusCodeDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getPriority(): Observable<PriorityCodeDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/GetPriority";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPriority(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPriority(<any>response_);
                } catch (e) {
                    return <Observable<PriorityCodeDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<PriorityCodeDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetPriority(response: HttpResponseBase): Observable<PriorityCodeDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(PriorityCodeDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PriorityCodeDto[]>(<any>null);
    }

    /**
     * @return Success
     */
    getEffortHours(): Observable<TicketEffortHoursDto[]> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/GetEffortHours";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEffortHours(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEffortHours(<any>response_);
                } catch (e) {
                    return <Observable<TicketEffortHoursDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<TicketEffortHoursDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetEffortHours(response: HttpResponseBase): Observable<TicketEffortHoursDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(TicketEffortHoursDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TicketEffortHoursDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    effortHoursList(body: GetTicketStatusInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketStatus/EffortHoursList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processEffortHoursList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processEffortHoursList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processEffortHoursList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class SupportTicketTypeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getTicketTypeList(): Observable<ListResultDtoOfTicketTypeList> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketType/GetTicketTypeList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTicketTypeList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTicketTypeList(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfTicketTypeList>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfTicketTypeList>><any>_observableThrow(response_);
        }));
    }

    protected processGetTicketTypeList(response: HttpResponseBase): Observable<ListResultDtoOfTicketTypeList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfTicketTypeList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfTicketTypeList>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getTicketTypePagedList(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketType/GetTicketTypePagedList?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTicketTypePagedList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTicketTypePagedList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTicketTypePagedList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getTicketType(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfTicketTypeList> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketType/GetTicketType?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTicketType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTicketType(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTicketTypeList>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTicketTypeList>><any>_observableThrow(response_);
        }));
    }

    protected processGetTicketType(response: HttpResponseBase): Observable<PagedResultDtoOfTicketTypeList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTicketTypeList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTicketTypeList>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketType/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createTicketType(body: CreateTicketTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketType/CreateTicketType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateTicketType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateTicketType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateTicketType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTicketType(body: UpdateTicketTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/SupportTicketType/UpdateTicketType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTicketType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTicketType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTicketType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class TagServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createTag(body: CreateTagInput | undefined): Observable<TagListDto> {
        let url_ = this.baseUrl + "/api/services/app/Tag/CreateTag";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateTag(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateTag(<any>response_);
                } catch (e) {
                    return <Observable<TagListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<TagListDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateTag(response: HttpResponseBase): Observable<TagListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TagListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TagListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTag(body: UpdateTagInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tag/UpdateTag";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTag(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTag(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTag(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteTag(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tag/DeleteTag?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteTag(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteTag(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteTag(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param tagTypeId (optional) 
     * @param name (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getTag(id: number | undefined, tagTypeId: number | undefined, name: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfTagListDto> {
        let url_ = this.baseUrl + "/api/services/app/Tag/GetTag?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (tagTypeId === null)
            throw new Error("The parameter 'tagTypeId' cannot be null.");
        else if (tagTypeId !== undefined)
            url_ += "TagTypeId=" + encodeURIComponent("" + tagTypeId) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTag(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTag(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTagListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTagListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTag(response: HttpResponseBase): Observable<PagedResultDtoOfTagListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTagListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTagListDto>(<any>null);
    }
}

@Injectable()
export class TagsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param tagTypeIdFilter (optional) 
     * @param nameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(id: number | undefined, filter: string | undefined, tagTypeIdFilter: number | undefined, nameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetTagForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Tags/GetAll?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (tagTypeIdFilter === null)
            throw new Error("The parameter 'tagTypeIdFilter' cannot be null.");
        else if (tagTypeIdFilter !== undefined)
            url_ += "TagTypeIdFilter=" + encodeURIComponent("" + tagTypeIdFilter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetTagForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetTagForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetTagForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetTagForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetTagForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getTagForView(id: number | undefined): Observable<GetTagForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Tags/GetTagForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTagForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTagForView(<any>response_);
                } catch (e) {
                    return <Observable<GetTagForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTagForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTagForView(response: HttpResponseBase): Observable<GetTagForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTagForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTagForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getTagForEdit(id: number | undefined): Observable<GetTagForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Tags/GetTagForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTagForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTagForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetTagForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTagForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetTagForEdit(response: HttpResponseBase): Observable<GetTagForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTagForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTagForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditTagDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tags/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tags/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param tagTypeIdFilter (optional) 
     * @param nameFilter (optional) 
     * @return Success
     */
    getTagsToExcel(filter: string | undefined, tagTypeIdFilter: number | undefined, nameFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Tags/GetTagsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (tagTypeIdFilter === null)
            throw new Error("The parameter 'tagTypeIdFilter' cannot be null.");
        else if (tagTypeIdFilter !== undefined)
            url_ += "TagTypeIdFilter=" + encodeURIComponent("" + tagTypeIdFilter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTagsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTagsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTagsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class TagTypeServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createTagType(body: CreateTagTypeInput | undefined): Observable<TagTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/TagType/CreateTagType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateTagType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateTagType(<any>response_);
                } catch (e) {
                    return <Observable<TagTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<TagTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateTagType(response: HttpResponseBase): Observable<TagTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TagTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TagTypeListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTagType(body: UpdateTagTypeInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TagType/UpdateTagType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTagType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTagType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTagType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteTagType(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TagType/DeleteTagType?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteTagType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteTagType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteTagType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getTagType(id: number | undefined, name: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfTagTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/TagType/GetTagType?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTagType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTagType(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTagTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTagTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTagType(response: HttpResponseBase): Observable<PagedResultDtoOfTagTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTagTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTagTypeListDto>(<any>null);
    }

    /**
     * Gets tag types.
     * @param id (optional) 
     * @param name (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Returns the tag types.
     */
    getTagTypes(id: number | undefined, name: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfTagTypeListDto> {
        let url_ = this.baseUrl + "/api/services/app/TagType/GetTagTypes?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTagTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTagTypes(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTagTypeListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTagTypeListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTagTypes(response: HttpResponseBase): Observable<PagedResultDtoOfTagTypeListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTagTypeListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status === 400) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("If query has a bad format or has unknown fields.", status, _responseText, _headers);
            }));
        } else if (status === 500) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("Something wrong occurs with this operation.", status, _responseText, _headers);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTagTypeListDto>(<any>null);
    }
}

@Injectable()
export class TagTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, nameFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetTagTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/TagTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetTagTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetTagTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetTagTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetTagTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetTagTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getTagTypeForView(id: number | undefined): Observable<GetTagTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/TagTypes/GetTagTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTagTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTagTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetTagTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTagTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTagTypeForView(response: HttpResponseBase): Observable<GetTagTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTagTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTagTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getTagTypeForEdit(id: number | undefined): Observable<GetTagTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/TagTypes/GetTagTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTagTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTagTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetTagTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTagTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetTagTypeForEdit(response: HttpResponseBase): Observable<GetTagTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTagTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTagTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditTagTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TagTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TagTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @return Success
     */
    getTagTypesToExcel(filter: string | undefined, nameFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/TagTypes/GetTagTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTagTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTagTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTagTypesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class TenantServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param subscriptionEndDateStart (optional) 
     * @param subscriptionEndDateEnd (optional) 
     * @param creationDateStart (optional) 
     * @param creationDateEnd (optional) 
     * @param editionId (optional) 
     * @param editionIdSpecified (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getTenants(filter: string | undefined, subscriptionEndDateStart: moment.Moment | undefined, subscriptionEndDateEnd: moment.Moment | undefined, creationDateStart: moment.Moment | undefined, creationDateEnd: moment.Moment | undefined, editionId: number | undefined, editionIdSpecified: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfTenantListDto> {
        let url_ = this.baseUrl + "/api/services/app/Tenant/GetTenants?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (subscriptionEndDateStart === null)
            throw new Error("The parameter 'subscriptionEndDateStart' cannot be null.");
        else if (subscriptionEndDateStart !== undefined)
            url_ += "SubscriptionEndDateStart=" + encodeURIComponent(subscriptionEndDateStart ? "" + subscriptionEndDateStart.toJSON() : "") + "&"; 
        if (subscriptionEndDateEnd === null)
            throw new Error("The parameter 'subscriptionEndDateEnd' cannot be null.");
        else if (subscriptionEndDateEnd !== undefined)
            url_ += "SubscriptionEndDateEnd=" + encodeURIComponent(subscriptionEndDateEnd ? "" + subscriptionEndDateEnd.toJSON() : "") + "&"; 
        if (creationDateStart === null)
            throw new Error("The parameter 'creationDateStart' cannot be null.");
        else if (creationDateStart !== undefined)
            url_ += "CreationDateStart=" + encodeURIComponent(creationDateStart ? "" + creationDateStart.toJSON() : "") + "&"; 
        if (creationDateEnd === null)
            throw new Error("The parameter 'creationDateEnd' cannot be null.");
        else if (creationDateEnd !== undefined)
            url_ += "CreationDateEnd=" + encodeURIComponent(creationDateEnd ? "" + creationDateEnd.toJSON() : "") + "&"; 
        if (editionId === null)
            throw new Error("The parameter 'editionId' cannot be null.");
        else if (editionId !== undefined)
            url_ += "EditionId=" + encodeURIComponent("" + editionId) + "&"; 
        if (editionIdSpecified === null)
            throw new Error("The parameter 'editionIdSpecified' cannot be null.");
        else if (editionIdSpecified !== undefined)
            url_ += "EditionIdSpecified=" + encodeURIComponent("" + editionIdSpecified) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenants(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenants(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTenantListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTenantListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenants(response: HttpResponseBase): Observable<PagedResultDtoOfTenantListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTenantListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTenantListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createTenant(body: CreateTenantInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tenant/CreateTenant";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getTenantForEdit(id: number | undefined): Observable<TenantEditDto> {
        let url_ = this.baseUrl + "/api/services/app/Tenant/GetTenantForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantForEdit(<any>response_);
                } catch (e) {
                    return <Observable<TenantEditDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<TenantEditDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantForEdit(response: HttpResponseBase): Observable<TenantEditDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TenantEditDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TenantEditDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTenant(body: TenantEditDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tenant/UpdateTenant";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteTenant(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tenant/DeleteTenant?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteTenant(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteTenant(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getTenantFeaturesForEdit(id: number | undefined): Observable<GetTenantFeaturesEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Tenant/GetTenantFeaturesForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantFeaturesForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantFeaturesForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetTenantFeaturesEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTenantFeaturesEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantFeaturesForEdit(response: HttpResponseBase): Observable<GetTenantFeaturesEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTenantFeaturesEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTenantFeaturesEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTenantFeatures(body: UpdateTenantFeaturesInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tenant/UpdateTenantFeatures";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTenantFeatures(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTenantFeatures(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTenantFeatures(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    resetTenantSpecificFeatures(body: EntityDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tenant/ResetTenantSpecificFeatures";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processResetTenantSpecificFeatures(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processResetTenantSpecificFeatures(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processResetTenantSpecificFeatures(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    unlockTenantAdmin(body: EntityDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Tenant/UnlockTenantAdmin";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnlockTenantAdmin(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnlockTenantAdmin(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnlockTenantAdmin(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class TenantDashboardServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getMemberActivity(): Observable<GetMemberActivityOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetMemberActivity";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetMemberActivity(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetMemberActivity(<any>response_);
                } catch (e) {
                    return <Observable<GetMemberActivityOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetMemberActivityOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetMemberActivity(response: HttpResponseBase): Observable<GetMemberActivityOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetMemberActivityOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetMemberActivityOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getDashboardData(salesSummaryDatePeriod: SalesSummaryDatePeriod): Observable<GetDashboardDataOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetDashboardData?";
        if (salesSummaryDatePeriod === undefined || salesSummaryDatePeriod === null)
            throw new Error("The parameter 'salesSummaryDatePeriod' must be defined and cannot be null.");
        else
            url_ += "SalesSummaryDatePeriod=" + encodeURIComponent("" + salesSummaryDatePeriod) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDashboardData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDashboardData(<any>response_);
                } catch (e) {
                    return <Observable<GetDashboardDataOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDashboardDataOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetDashboardData(response: HttpResponseBase): Observable<GetDashboardDataOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDashboardDataOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDashboardDataOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getTopStats(): Observable<GetTopStatsOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetTopStats";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTopStats(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTopStats(<any>response_);
                } catch (e) {
                    return <Observable<GetTopStatsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTopStatsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetTopStats(response: HttpResponseBase): Observable<GetTopStatsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTopStatsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTopStatsOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getProfitShare(): Observable<GetProfitShareOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetProfitShare";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetProfitShare(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetProfitShare(<any>response_);
                } catch (e) {
                    return <Observable<GetProfitShareOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetProfitShareOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetProfitShare(response: HttpResponseBase): Observable<GetProfitShareOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetProfitShareOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetProfitShareOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getDailySales(): Observable<GetDailySalesOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetDailySales";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetDailySales(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetDailySales(<any>response_);
                } catch (e) {
                    return <Observable<GetDailySalesOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetDailySalesOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetDailySales(response: HttpResponseBase): Observable<GetDailySalesOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetDailySalesOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetDailySalesOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getSalesSummary(salesSummaryDatePeriod: SalesSummaryDatePeriod): Observable<GetSalesSummaryOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetSalesSummary?";
        if (salesSummaryDatePeriod === undefined || salesSummaryDatePeriod === null)
            throw new Error("The parameter 'salesSummaryDatePeriod' must be defined and cannot be null.");
        else
            url_ += "SalesSummaryDatePeriod=" + encodeURIComponent("" + salesSummaryDatePeriod) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSalesSummary(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSalesSummary(<any>response_);
                } catch (e) {
                    return <Observable<GetSalesSummaryOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetSalesSummaryOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetSalesSummary(response: HttpResponseBase): Observable<GetSalesSummaryOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetSalesSummaryOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetSalesSummaryOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getRegionalStats(): Observable<GetRegionalStatsOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetRegionalStats";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRegionalStats(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRegionalStats(<any>response_);
                } catch (e) {
                    return <Observable<GetRegionalStatsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRegionalStatsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetRegionalStats(response: HttpResponseBase): Observable<GetRegionalStatsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRegionalStatsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRegionalStatsOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getGeneralStats(): Observable<GetGeneralStatsOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetGeneralStats";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetGeneralStats(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetGeneralStats(<any>response_);
                } catch (e) {
                    return <Observable<GetGeneralStatsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetGeneralStatsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetGeneralStats(response: HttpResponseBase): Observable<GetGeneralStatsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetGeneralStatsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetGeneralStatsOutput>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getNextArrival(routeId: number | undefined): Observable<moment.Moment> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetNextArrival?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetNextArrival(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetNextArrival(<any>response_);
                } catch (e) {
                    return <Observable<moment.Moment>><any>_observableThrow(e);
                }
            } else
                return <Observable<moment.Moment>><any>_observableThrow(response_);
        }));
    }

    protected processGetNextArrival(response: HttpResponseBase): Observable<moment.Moment> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 ? moment(resultData200.toString()) : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<moment.Moment>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getNextArrivalPackages(routeId: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetNextArrivalPackages?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetNextArrivalPackages(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetNextArrivalPackages(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetNextArrivalPackages(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @param locationId (optional) 
     * @return Success
     */
    getNextArrivalData(routeIds: number[] | undefined, locationId: number | undefined): Observable<GetNextArrivalData> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetNextArrivalData?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "routeIds=" + encodeURIComponent("" + item) + "&"; });
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "locationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetNextArrivalData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetNextArrivalData(<any>response_);
                } catch (e) {
                    return <Observable<GetNextArrivalData>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetNextArrivalData>><any>_observableThrow(response_);
        }));
    }

    protected processGetNextArrivalData(response: HttpResponseBase): Observable<GetNextArrivalData> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetNextArrivalData.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetNextArrivalData>(<any>null);
    }

    /**
     * @param routeIds (optional) 
     * @return Success
     */
    getPickupProgress(routeIds: number[] | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetPickupProgress?";
        if (routeIds === null)
            throw new Error("The parameter 'routeIds' cannot be null.");
        else if (routeIds !== undefined)
            routeIds && routeIds.forEach(item => { url_ += "routeIds=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPickupProgress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPickupProgress(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetPickupProgress(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param routeTypeId (optional) 
     * @param date (optional) 
     * @param contactId (optional) 
     * @param actionId (optional) 
     * @return Success
     */
    getLocationData(id: number | undefined, routeTypeId: number[] | undefined, date: string | undefined, contactId: number | undefined, actionId: number | undefined): Observable<GetLocationDataOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetLocationData?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (routeTypeId === null)
            throw new Error("The parameter 'routeTypeId' cannot be null.");
        else if (routeTypeId !== undefined)
            routeTypeId && routeTypeId.forEach(item => { url_ += "RouteTypeId=" + encodeURIComponent("" + item) + "&"; });
        if (date === null)
            throw new Error("The parameter 'date' cannot be null.");
        else if (date !== undefined)
            url_ += "Date=" + encodeURIComponent("" + date) + "&"; 
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        if (actionId === null)
            throw new Error("The parameter 'actionId' cannot be null.");
        else if (actionId !== undefined)
            url_ += "ActionId=" + encodeURIComponent("" + actionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationData(<any>response_);
                } catch (e) {
                    return <Observable<GetLocationDataOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLocationDataOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationData(response: HttpResponseBase): Observable<GetLocationDataOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLocationDataOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLocationDataOutput>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param routeTypeId (optional) 
     * @param date (optional) 
     * @param contactId (optional) 
     * @param actionId (optional) 
     * @param runningRouteId (optional) 
     * @return Success
     */
    getLocationRouteData(id: number | undefined, routeTypeId: number[] | undefined, date: string | undefined, contactId: number | undefined, actionId: number | undefined, runningRouteId: number | undefined): Observable<GetLocationRouteDataOutput[]> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetLocationRouteData?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (routeTypeId === null)
            throw new Error("The parameter 'routeTypeId' cannot be null.");
        else if (routeTypeId !== undefined)
            routeTypeId && routeTypeId.forEach(item => { url_ += "RouteTypeId=" + encodeURIComponent("" + item) + "&"; });
        if (date === null)
            throw new Error("The parameter 'date' cannot be null.");
        else if (date !== undefined)
            url_ += "Date=" + encodeURIComponent("" + date) + "&"; 
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        if (actionId === null)
            throw new Error("The parameter 'actionId' cannot be null.");
        else if (actionId !== undefined)
            url_ += "ActionId=" + encodeURIComponent("" + actionId) + "&"; 
        if (runningRouteId === null)
            throw new Error("The parameter 'runningRouteId' cannot be null.");
        else if (runningRouteId !== undefined)
            url_ += "runningRouteId=" + encodeURIComponent("" + runningRouteId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationRouteData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationRouteData(<any>response_);
                } catch (e) {
                    return <Observable<GetLocationRouteDataOutput[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLocationRouteDataOutput[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationRouteData(response: HttpResponseBase): Observable<GetLocationRouteDataOutput[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetLocationRouteDataOutput.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLocationRouteDataOutput[]>(<any>null);
    }

    /**
     * @param routeTemplateId (optional) 
     * @return Success
     */
    isLinehaul(routeTemplateId: number | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/IsLinehaul?";
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIsLinehaul(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIsLinehaul(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processIsLinehaul(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param routeTemplateId (optional) 
     * @return Success
     */
    getLineHaulList(routeTemplateId: number | undefined): Observable<LineHaulList[]> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetLineHaulList?";
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLineHaulList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLineHaulList(<any>response_);
                } catch (e) {
                    return <Observable<LineHaulList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<LineHaulList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetLineHaulList(response: HttpResponseBase): Observable<LineHaulList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(LineHaulList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<LineHaulList[]>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param routeTypeId (optional) 
     * @param date (optional) 
     * @param contactId (optional) 
     * @param actionId (optional) 
     * @param runningRouteId (optional) 
     * @return Success
     */
    getLocationRouteDataCompleted(id: number | undefined, routeTypeId: number[] | undefined, date: string | undefined, contactId: number | undefined, actionId: number | undefined, runningRouteId: number | undefined): Observable<GetLocationRouteDataCompletedOutput[]> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetLocationRouteDataCompleted?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (routeTypeId === null)
            throw new Error("The parameter 'routeTypeId' cannot be null.");
        else if (routeTypeId !== undefined)
            routeTypeId && routeTypeId.forEach(item => { url_ += "RouteTypeId=" + encodeURIComponent("" + item) + "&"; });
        if (date === null)
            throw new Error("The parameter 'date' cannot be null.");
        else if (date !== undefined)
            url_ += "Date=" + encodeURIComponent("" + date) + "&"; 
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        if (actionId === null)
            throw new Error("The parameter 'actionId' cannot be null.");
        else if (actionId !== undefined)
            url_ += "ActionId=" + encodeURIComponent("" + actionId) + "&"; 
        if (runningRouteId === null)
            throw new Error("The parameter 'runningRouteId' cannot be null.");
        else if (runningRouteId !== undefined)
            url_ += "runningRouteId=" + encodeURIComponent("" + runningRouteId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLocationRouteDataCompleted(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLocationRouteDataCompleted(<any>response_);
                } catch (e) {
                    return <Observable<GetLocationRouteDataCompletedOutput[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLocationRouteDataCompletedOutput[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetLocationRouteDataCompleted(response: HttpResponseBase): Observable<GetLocationRouteDataCompletedOutput[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetLocationRouteDataCompletedOutput.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLocationRouteDataCompletedOutput[]>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteTypeData(): Observable<GetRouteTypeDataOutput[]> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetRouteTypeData";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTypeData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTypeData(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteTypeDataOutput[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteTypeDataOutput[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTypeData(response: HttpResponseBase): Observable<GetRouteTypeDataOutput[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetRouteTypeDataOutput.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteTypeDataOutput[]>(<any>null);
    }

    /**
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param filter (optional) 
     * @return Success
     */
    getPagedRouteTypeData(maxResultCount: number | undefined, skipCount: number | undefined, filter: string | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetPagedRouteTypeData?";
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPagedRouteTypeData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPagedRouteTypeData(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPagedRouteTypeData(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @return Success
     */
    getLaboratoryData(locationId: number | undefined): Observable<GetLaboratoryDataOutput[]> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetLaboratoryData?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLaboratoryData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLaboratoryData(<any>response_);
                } catch (e) {
                    return <Observable<GetLaboratoryDataOutput[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLaboratoryDataOutput[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetLaboratoryData(response: HttpResponseBase): Observable<GetLaboratoryDataOutput[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetLaboratoryDataOutput.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLaboratoryDataOutput[]>(<any>null);
    }

    /**
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param filter (optional) 
     * @param locationId (optional) 
     * @return Success
     */
    getPagedLaboratoryData(maxResultCount: number | undefined, skipCount: number | undefined, filter: string | undefined, locationId: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetPagedLaboratoryData?";
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPagedLaboratoryData(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPagedLaboratoryData(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPagedLaboratoryData(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getRouteType(): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetRouteType";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteType(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteType(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAutoRefreshMins(): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetAutoRefreshMins";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAutoRefreshMins(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAutoRefreshMins(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAutoRefreshMins(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getCompletedRoute(): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetCompletedRoute";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCompletedRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCompletedRoute(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCompletedRoute(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getRunningRoute(): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetRunningRoute";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRunningRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRunningRoute(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRunningRoute(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getTenantConnectionString(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/TenantDashboard/GetTenantConnectionString";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTenantConnectionString(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTenantConnectionString(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetTenantConnectionString(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class TenantRegistrationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    registerTenant(body: RegisterTenantInput | undefined): Observable<RegisterTenantOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantRegistration/RegisterTenant";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRegisterTenant(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRegisterTenant(<any>response_);
                } catch (e) {
                    return <Observable<RegisterTenantOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<RegisterTenantOutput>><any>_observableThrow(response_);
        }));
    }

    protected processRegisterTenant(response: HttpResponseBase): Observable<RegisterTenantOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = RegisterTenantOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RegisterTenantOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getEditionsForSelect(): Observable<EditionsSelectOutput> {
        let url_ = this.baseUrl + "/api/services/app/TenantRegistration/GetEditionsForSelect";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEditionsForSelect(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEditionsForSelect(<any>response_);
                } catch (e) {
                    return <Observable<EditionsSelectOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<EditionsSelectOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetEditionsForSelect(response: HttpResponseBase): Observable<EditionsSelectOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = EditionsSelectOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<EditionsSelectOutput>(<any>null);
    }

    /**
     * @param editionId (optional) 
     * @return Success
     */
    getEdition(editionId: number | undefined): Observable<EditionSelectDto> {
        let url_ = this.baseUrl + "/api/services/app/TenantRegistration/GetEdition?";
        if (editionId === null)
            throw new Error("The parameter 'editionId' cannot be null.");
        else if (editionId !== undefined)
            url_ += "editionId=" + encodeURIComponent("" + editionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetEdition(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetEdition(<any>response_);
                } catch (e) {
                    return <Observable<EditionSelectDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<EditionSelectDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetEdition(response: HttpResponseBase): Observable<EditionSelectDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = EditionSelectDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<EditionSelectDto>(<any>null);
    }
}

@Injectable()
export class TenantSettingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getAllSettings(): Observable<TenantSettingsEditDto> {
        let url_ = this.baseUrl + "/api/services/app/TenantSettings/GetAllSettings";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSettings(<any>response_);
                } catch (e) {
                    return <Observable<TenantSettingsEditDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<TenantSettingsEditDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSettings(response: HttpResponseBase): Observable<TenantSettingsEditDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TenantSettingsEditDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TenantSettingsEditDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateOrderNumberDisplayType(body: OrderNumberDisplayTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TenantSettings/UpdateOrderNumberDisplayType";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateOrderNumberDisplayType(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateOrderNumberDisplayType(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateOrderNumberDisplayType(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateAllSettings(body: TenantSettingsEditDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TenantSettings/UpdateAllSettings";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateAllSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateAllSettings(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateAllSettings(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateCustomSetting(body: CustomSettingsEditDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TenantSettings/UpdateCustomSetting";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateCustomSetting(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateCustomSetting(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateCustomSetting(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    clearLogo(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TenantSettings/ClearLogo";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processClearLogo(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processClearLogo(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processClearLogo(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    clearCustomCss(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TenantSettings/ClearCustomCss";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processClearCustomCss(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processClearCustomCss(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processClearCustomCss(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendTestEmail(body: SendTestEmailInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TenantSettings/SendTestEmail";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendTestEmail(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendTestEmail(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendTestEmail(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class TextToSpeechSettingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdate(body: CreateOrUpdateTextToSpeechSettingInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TextToSpeechSettings/CreateOrUpdate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param code (optional) 
     * @return Success
     */
    delete(code: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TextToSpeechSettings/Delete?";
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getAll(): Observable<ListResultDtoOfGetTextToSpeechSettingListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/TextToSpeechSettings/GetAll";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetTextToSpeechSettingListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetTextToSpeechSettingListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<ListResultDtoOfGetTextToSpeechSettingListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetTextToSpeechSettingListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetTextToSpeechSettingListItemDto>(<any>null);
    }

    /**
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getPaged(sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetTextToSpeechSettingListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/TextToSpeechSettings/GetPaged?";
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetTextToSpeechSettingListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetTextToSpeechSettingListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPaged(response: HttpResponseBase): Observable<PagedResultDtoOfGetTextToSpeechSettingListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetTextToSpeechSettingListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetTextToSpeechSettingListItemDto>(<any>null);
    }
}

@Injectable()
export class TimeSheetServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createTimeSheet(body: CreateTimeSheetInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/TimeSheet/CreateTimeSheet";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateTimeSheet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateTimeSheet(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateTimeSheet(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param loginTime (optional) 
     * @param logoutTime (optional) 
     * @param userName (optional) 
     * @param employeeFilter (optional) 
     * @param clockInDate (optional) 
     * @param clockOutDate (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getTimeSheet(id: number | undefined, userId: number | undefined, loginTime: moment.Moment | undefined, logoutTime: moment.Moment | undefined, userName: string | undefined, employeeFilter: string | undefined, clockInDate: string | undefined, clockOutDate: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfTimeSheetListDto> {
        let url_ = this.baseUrl + "/api/services/app/TimeSheet/GetTimeSheet?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (loginTime === null)
            throw new Error("The parameter 'loginTime' cannot be null.");
        else if (loginTime !== undefined)
            url_ += "LoginTime=" + encodeURIComponent(loginTime ? "" + loginTime.toJSON() : "") + "&"; 
        if (logoutTime === null)
            throw new Error("The parameter 'logoutTime' cannot be null.");
        else if (logoutTime !== undefined)
            url_ += "LogoutTime=" + encodeURIComponent(logoutTime ? "" + logoutTime.toJSON() : "") + "&"; 
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "UserName=" + encodeURIComponent("" + userName) + "&"; 
        if (employeeFilter === null)
            throw new Error("The parameter 'employeeFilter' cannot be null.");
        else if (employeeFilter !== undefined)
            url_ += "EmployeeFilter=" + encodeURIComponent("" + employeeFilter) + "&"; 
        if (clockInDate === null)
            throw new Error("The parameter 'clockInDate' cannot be null.");
        else if (clockInDate !== undefined)
            url_ += "ClockInDate=" + encodeURIComponent("" + clockInDate) + "&"; 
        if (clockOutDate === null)
            throw new Error("The parameter 'clockOutDate' cannot be null.");
        else if (clockOutDate !== undefined)
            url_ += "ClockOutDate=" + encodeURIComponent("" + clockOutDate) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimeSheet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimeSheet(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTimeSheetListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTimeSheetListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimeSheet(response: HttpResponseBase): Observable<PagedResultDtoOfTimeSheetListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTimeSheetListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTimeSheetListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTimeSheet(body: UpdateTimeSheetInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TimeSheet/UpdateTimeSheet";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTimeSheet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTimeSheet(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTimeSheet(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteTimeSheet(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TimeSheet/DeleteTimeSheet?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteTimeSheet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteTimeSheet(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteTimeSheet(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class TimeZoneServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createTimeZone(body: CreateTimeZoneInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/TimeZone/CreateTimeZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateTimeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateTimeZone(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateTimeZone(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @return Success
     */
    getTimeZoneForDropDown(): Observable<ListResultDtoOfTimeZoneListDto> {
        let url_ = this.baseUrl + "/api/services/app/TimeZone/GetTimeZoneForDropDown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimeZoneForDropDown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimeZoneForDropDown(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfTimeZoneListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfTimeZoneListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimeZoneForDropDown(response: HttpResponseBase): Observable<ListResultDtoOfTimeZoneListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfTimeZoneListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfTimeZoneListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param value (optional) 
     * @param offset (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getTimeZone(id: number | undefined, value: string | undefined, offset: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfTimeZoneListDto> {
        let url_ = this.baseUrl + "/api/services/app/TimeZone/GetTimeZone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (offset === null)
            throw new Error("The parameter 'offset' cannot be null.");
        else if (offset !== undefined)
            url_ += "Offset=" + encodeURIComponent("" + offset) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimeZone(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfTimeZoneListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfTimeZoneListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimeZone(response: HttpResponseBase): Observable<PagedResultDtoOfTimeZoneListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfTimeZoneListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfTimeZoneListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateTimeZone(body: UpdateTimeZoneInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TimeZone/UpdateTimeZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateTimeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateTimeZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateTimeZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TimeZone/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteTimeZone(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TimeZone/DeleteTimeZone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteTimeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteTimeZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteTimeZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createMultipleTimeZone(body: AddMultipleTimeZone | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TimeZone/CreateMultipleTimeZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateMultipleTimeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateMultipleTimeZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateMultipleTimeZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class TimezoneCheckServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param ianaTimeZone (optional) 
     * @return Success
     */
    getWinTimeZone(ianaTimeZone: string | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/TimezoneCheck/GetWinTimeZone?";
        if (ianaTimeZone === null)
            throw new Error("The parameter 'ianaTimeZone' cannot be null.");
        else if (ianaTimeZone !== undefined)
            url_ += "ianaTimeZone=" + encodeURIComponent("" + ianaTimeZone) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetWinTimeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetWinTimeZone(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetWinTimeZone(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }
}

@Injectable()
export class TimeZonesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param valueFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, valueFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetTimeZoneForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/TimeZones/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetTimeZoneForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetTimeZoneForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetTimeZoneForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetTimeZoneForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetTimeZoneForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getTimeZoneForView(id: number | undefined): Observable<GetTimeZoneForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/TimeZones/GetTimeZoneForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimeZoneForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimeZoneForView(<any>response_);
                } catch (e) {
                    return <Observable<GetTimeZoneForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTimeZoneForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimeZoneForView(response: HttpResponseBase): Observable<GetTimeZoneForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTimeZoneForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTimeZoneForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getTimeZoneForEdit(id: number | undefined): Observable<GetTimeZoneForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/TimeZones/GetTimeZoneForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimeZoneForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimeZoneForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetTimeZoneForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTimeZoneForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimeZoneForEdit(response: HttpResponseBase): Observable<GetTimeZoneForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetTimeZoneForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTimeZoneForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditTimeZoneDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TimeZones/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/TimeZones/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param valueFilter (optional) 
     * @return Success
     */
    getTimeZonesToExcel(filter: string | undefined, valueFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/TimeZones/GetTimeZonesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimeZonesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimeZonesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimeZonesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class TimingServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getTimezones(defaultTimezoneScope: SettingScopes): Observable<ListResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Timing/GetTimezones?";
        if (defaultTimezoneScope === undefined || defaultTimezoneScope === null)
            throw new Error("The parameter 'defaultTimezoneScope' must be defined and cannot be null.");
        else
            url_ += "DefaultTimezoneScope=" + encodeURIComponent("" + defaultTimezoneScope) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimezones(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimezones(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimezones(response: HttpResponseBase): Observable<ListResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param selectedTimezoneId (optional) 
     * @return Success
     */
    getTimezoneComboboxItems(selectedTimezoneId: string | undefined): Observable<ComboboxItemDto[]> {
        let url_ = this.baseUrl + "/api/services/app/Timing/GetTimezoneComboboxItems?";
        if (selectedTimezoneId === null)
            throw new Error("The parameter 'selectedTimezoneId' cannot be null.");
        else if (selectedTimezoneId !== undefined)
            url_ += "SelectedTimezoneId=" + encodeURIComponent("" + selectedTimezoneId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTimezoneComboboxItems(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTimezoneComboboxItems(<any>response_);
                } catch (e) {
                    return <Observable<ComboboxItemDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ComboboxItemDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTimezoneComboboxItems(response: HttpResponseBase): Observable<ComboboxItemDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ComboboxItemDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ComboboxItemDto[]>(<any>null);
    }

    /**
     * @param utcDateTime (optional) 
     * @param locationTimeZone (optional) 
     * @return Success
     */
    convertToTimezone(utcDateTime: moment.Moment | undefined, locationTimeZone: string | undefined): Observable<moment.Moment> {
        let url_ = this.baseUrl + "/api/services/app/Timing/ConvertToTimezone?";
        if (utcDateTime === null)
            throw new Error("The parameter 'utcDateTime' cannot be null.");
        else if (utcDateTime !== undefined)
            url_ += "utcDateTime=" + encodeURIComponent(utcDateTime ? "" + utcDateTime.toJSON() : "") + "&"; 
        if (locationTimeZone === null)
            throw new Error("The parameter 'locationTimeZone' cannot be null.");
        else if (locationTimeZone !== undefined)
            url_ += "locationTimeZone=" + encodeURIComponent("" + locationTimeZone) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertToTimezone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertToTimezone(<any>response_);
                } catch (e) {
                    return <Observable<moment.Moment>><any>_observableThrow(e);
                }
            } else
                return <Observable<moment.Moment>><any>_observableThrow(response_);
        }));
    }

    protected processConvertToTimezone(response: HttpResponseBase): Observable<moment.Moment> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 ? moment(resultData200.toString()) : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<moment.Moment>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param baseUtcOffset (optional) 
     * @param displayName (optional) 
     * @param standardDisplayName (optional) 
     * @return Success
     */
    customTimeZone(id: string | undefined, baseUtcOffset: TimeSpan | undefined, displayName: string | undefined, standardDisplayName: string | undefined): Observable<TimeZoneInfo> {
        let url_ = this.baseUrl + "/api/services/app/Timing/CustomTimeZone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        if (baseUtcOffset === null)
            throw new Error("The parameter 'baseUtcOffset' cannot be null.");
        else if (baseUtcOffset !== undefined)
            url_ += "baseUtcOffset=" + encodeURIComponent("" + baseUtcOffset) + "&"; 
        if (displayName === null)
            throw new Error("The parameter 'displayName' cannot be null.");
        else if (displayName !== undefined)
            url_ += "displayName=" + encodeURIComponent("" + displayName) + "&"; 
        if (standardDisplayName === null)
            throw new Error("The parameter 'standardDisplayName' cannot be null.");
        else if (standardDisplayName !== undefined)
            url_ += "standardDisplayName=" + encodeURIComponent("" + standardDisplayName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCustomTimeZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCustomTimeZone(<any>response_);
                } catch (e) {
                    return <Observable<TimeZoneInfo>><any>_observableThrow(e);
                }
            } else
                return <Observable<TimeZoneInfo>><any>_observableThrow(response_);
        }));
    }

    protected processCustomTimeZone(response: HttpResponseBase): Observable<TimeZoneInfo> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = TimeZoneInfo.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<TimeZoneInfo>(<any>null);
    }
}

@Injectable()
export class TokenAuthServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    authenticate(body: AuthenticateModel | undefined): Observable<AuthenticateResultModel> {
        let url_ = this.baseUrl + "/api/TokenAuth/Authenticate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAuthenticate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAuthenticate(<any>response_);
                } catch (e) {
                    return <Observable<AuthenticateResultModel>><any>_observableThrow(e);
                }
            } else
                return <Observable<AuthenticateResultModel>><any>_observableThrow(response_);
        }));
    }

    protected processAuthenticate(response: HttpResponseBase): Observable<AuthenticateResultModel> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = AuthenticateResultModel.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<AuthenticateResultModel>(<any>null);
    }

    /**
     * @param refreshToken (optional) 
     * @return Success
     */
    refreshToken(refreshToken: string | undefined): Observable<RefreshTokenResult> {
        let url_ = this.baseUrl + "/api/TokenAuth/RefreshToken?";
        if (refreshToken === null)
            throw new Error("The parameter 'refreshToken' cannot be null.");
        else if (refreshToken !== undefined)
            url_ += "refreshToken=" + encodeURIComponent("" + refreshToken) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRefreshToken(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRefreshToken(<any>response_);
                } catch (e) {
                    return <Observable<RefreshTokenResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<RefreshTokenResult>><any>_observableThrow(response_);
        }));
    }

    protected processRefreshToken(response: HttpResponseBase): Observable<RefreshTokenResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = RefreshTokenResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RefreshTokenResult>(<any>null);
    }

    /**
     * @param refreshToken (optional) 
     * @return Success
     */
    refreshMobileToken(refreshToken: string | undefined): Observable<RefreshTokenResult> {
        let url_ = this.baseUrl + "/api/TokenAuth/RefreshMobileToken?";
        if (refreshToken === null)
            throw new Error("The parameter 'refreshToken' cannot be null.");
        else if (refreshToken !== undefined)
            url_ += "refreshToken=" + encodeURIComponent("" + refreshToken) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processRefreshMobileToken(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processRefreshMobileToken(<any>response_);
                } catch (e) {
                    return <Observable<RefreshTokenResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<RefreshTokenResult>><any>_observableThrow(response_);
        }));
    }

    protected processRefreshMobileToken(response: HttpResponseBase): Observable<RefreshTokenResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = RefreshTokenResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<RefreshTokenResult>(<any>null);
    }

    /**
     * @return Success
     */
    logOut(): Observable<void> {
        let url_ = this.baseUrl + "/api/TokenAuth/LogOut";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLogOut(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLogOut(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLogOut(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    sendTwoFactorAuthCode(body: SendTwoFactorAuthCodeModel | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/TokenAuth/SendTwoFactorAuthCode";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSendTwoFactorAuthCode(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSendTwoFactorAuthCode(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSendTwoFactorAuthCode(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param impersonationToken (optional) 
     * @return Success
     */
    impersonatedAuthenticate(impersonationToken: string | undefined): Observable<ImpersonatedAuthenticateResultModel> {
        let url_ = this.baseUrl + "/api/TokenAuth/ImpersonatedAuthenticate?";
        if (impersonationToken === null)
            throw new Error("The parameter 'impersonationToken' cannot be null.");
        else if (impersonationToken !== undefined)
            url_ += "impersonationToken=" + encodeURIComponent("" + impersonationToken) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processImpersonatedAuthenticate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processImpersonatedAuthenticate(<any>response_);
                } catch (e) {
                    return <Observable<ImpersonatedAuthenticateResultModel>><any>_observableThrow(e);
                }
            } else
                return <Observable<ImpersonatedAuthenticateResultModel>><any>_observableThrow(response_);
        }));
    }

    protected processImpersonatedAuthenticate(response: HttpResponseBase): Observable<ImpersonatedAuthenticateResultModel> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ImpersonatedAuthenticateResultModel.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ImpersonatedAuthenticateResultModel>(<any>null);
    }

    /**
     * @param switchAccountToken (optional) 
     * @return Success
     */
    linkedAccountAuthenticate(switchAccountToken: string | undefined): Observable<SwitchedAccountAuthenticateResultModel> {
        let url_ = this.baseUrl + "/api/TokenAuth/LinkedAccountAuthenticate?";
        if (switchAccountToken === null)
            throw new Error("The parameter 'switchAccountToken' cannot be null.");
        else if (switchAccountToken !== undefined)
            url_ += "switchAccountToken=" + encodeURIComponent("" + switchAccountToken) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLinkedAccountAuthenticate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLinkedAccountAuthenticate(<any>response_);
                } catch (e) {
                    return <Observable<SwitchedAccountAuthenticateResultModel>><any>_observableThrow(e);
                }
            } else
                return <Observable<SwitchedAccountAuthenticateResultModel>><any>_observableThrow(response_);
        }));
    }

    protected processLinkedAccountAuthenticate(response: HttpResponseBase): Observable<SwitchedAccountAuthenticateResultModel> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = SwitchedAccountAuthenticateResultModel.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SwitchedAccountAuthenticateResultModel>(<any>null);
    }

    /**
     * @return Success
     */
    getExternalAuthenticationProviders(): Observable<ExternalLoginProviderInfoModel[]> {
        let url_ = this.baseUrl + "/api/TokenAuth/GetExternalAuthenticationProviders";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetExternalAuthenticationProviders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetExternalAuthenticationProviders(<any>response_);
                } catch (e) {
                    return <Observable<ExternalLoginProviderInfoModel[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExternalLoginProviderInfoModel[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetExternalAuthenticationProviders(response: HttpResponseBase): Observable<ExternalLoginProviderInfoModel[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ExternalLoginProviderInfoModel.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExternalLoginProviderInfoModel[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    externalAuthenticate(body: ExternalAuthenticateModel | undefined): Observable<ExternalAuthenticateResultModel> {
        let url_ = this.baseUrl + "/api/TokenAuth/ExternalAuthenticate";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processExternalAuthenticate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processExternalAuthenticate(<any>response_);
                } catch (e) {
                    return <Observable<ExternalAuthenticateResultModel>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExternalAuthenticateResultModel>><any>_observableThrow(response_);
        }));
    }

    protected processExternalAuthenticate(response: HttpResponseBase): Observable<ExternalAuthenticateResultModel> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExternalAuthenticateResultModel.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExternalAuthenticateResultModel>(<any>null);
    }

    /**
     * @param message (optional) 
     * @param severity (optional) 
     * @return Success
     */
    testNotification(message: string | undefined, severity: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/TokenAuth/TestNotification?";
        if (message === null)
            throw new Error("The parameter 'message' cannot be null.");
        else if (message !== undefined)
            url_ += "message=" + encodeURIComponent("" + message) + "&"; 
        if (severity === null)
            throw new Error("The parameter 'severity' cannot be null.");
        else if (severity !== undefined)
            url_ += "severity=" + encodeURIComponent("" + severity) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processTestNotification(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processTestNotification(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processTestNotification(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    authenticateDriver(body: AuthenticateModel | undefined): Observable<DriverAuthResultModel> {
        let url_ = this.baseUrl + "/api/TokenAuth/AuthenticateDriver";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAuthenticateDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAuthenticateDriver(<any>response_);
                } catch (e) {
                    return <Observable<DriverAuthResultModel>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverAuthResultModel>><any>_observableThrow(response_);
        }));
    }

    protected processAuthenticateDriver(response: HttpResponseBase): Observable<DriverAuthResultModel> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DriverAuthResultModel.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverAuthResultModel>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    authenticateMobile(body: AuthenticateModel | undefined): Observable<DriverAuthResultModel> {
        let url_ = this.baseUrl + "/api/TokenAuth/AuthenticateMobile";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAuthenticateMobile(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAuthenticateMobile(<any>response_);
                } catch (e) {
                    return <Observable<DriverAuthResultModel>><any>_observableThrow(e);
                }
            } else
                return <Observable<DriverAuthResultModel>><any>_observableThrow(response_);
        }));
    }

    protected processAuthenticateMobile(response: HttpResponseBase): Observable<DriverAuthResultModel> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = DriverAuthResultModel.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<DriverAuthResultModel>(<any>null);
    }
}

@Injectable()
export class UiCustomizationSettingsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getUiManagementSettings(): Observable<ThemeSettingsDto[]> {
        let url_ = this.baseUrl + "/api/services/app/UiCustomizationSettings/GetUiManagementSettings";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUiManagementSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUiManagementSettings(<any>response_);
                } catch (e) {
                    return <Observable<ThemeSettingsDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ThemeSettingsDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetUiManagementSettings(response: HttpResponseBase): Observable<ThemeSettingsDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ThemeSettingsDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ThemeSettingsDto[]>(<any>null);
    }

    /**
     * @param themeName (optional) 
     * @return Success
     */
    changeThemeWithDefaultValues(themeName: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UiCustomizationSettings/ChangeThemeWithDefaultValues?";
        if (themeName === null)
            throw new Error("The parameter 'themeName' cannot be null.");
        else if (themeName !== undefined)
            url_ += "themeName=" + encodeURIComponent("" + themeName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processChangeThemeWithDefaultValues(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processChangeThemeWithDefaultValues(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processChangeThemeWithDefaultValues(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateUiManagementSettings(body: ThemeSettingsDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UiCustomizationSettings/UpdateUiManagementSettings";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateUiManagementSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateUiManagementSettings(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateUiManagementSettings(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateDefaultUiManagementSettings(body: ThemeSettingsDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UiCustomizationSettings/UpdateDefaultUiManagementSettings";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateDefaultUiManagementSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateDefaultUiManagementSettings(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateDefaultUiManagementSettings(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    useSystemDefaultSettings(): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UiCustomizationSettings/UseSystemDefaultSettings";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUseSystemDefaultSettings(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUseSystemDefaultSettings(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUseSystemDefaultSettings(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class UnassignedPackageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param locationId (optional) 
     * @param loadDateStart (optional) 
     * @param loadDateEnd (optional) 
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getUnassignedRoutes(locationId: number | undefined, loadDateStart: moment.Moment | undefined, loadDateEnd: moment.Moment | undefined, filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetUnassignedRouteListDto> {
        let url_ = this.baseUrl + "/api/services/app/UnassignedPackage/GetUnassignedRoutes?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (loadDateStart === null)
            throw new Error("The parameter 'loadDateStart' cannot be null.");
        else if (loadDateStart !== undefined)
            url_ += "LoadDateStart=" + encodeURIComponent(loadDateStart ? "" + loadDateStart.toJSON() : "") + "&"; 
        if (loadDateEnd === null)
            throw new Error("The parameter 'loadDateEnd' cannot be null.");
        else if (loadDateEnd !== undefined)
            url_ += "LoadDateEnd=" + encodeURIComponent(loadDateEnd ? "" + loadDateEnd.toJSON() : "") + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUnassignedRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUnassignedRoutes(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetUnassignedRouteListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetUnassignedRouteListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUnassignedRoutes(response: HttpResponseBase): Observable<PagedResultDtoOfGetUnassignedRouteListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetUnassignedRouteListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetUnassignedRouteListDto>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @param filterTxt (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getUnassignedOrders(routeId: number | undefined, filterTxt: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetUnassignedOrderListDto> {
        let url_ = this.baseUrl + "/api/services/app/UnassignedPackage/GetUnassignedOrders?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        if (filterTxt === null)
            throw new Error("The parameter 'filterTxt' cannot be null.");
        else if (filterTxt !== undefined)
            url_ += "FilterTxt=" + encodeURIComponent("" + filterTxt) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUnassignedOrders(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUnassignedOrders(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetUnassignedOrderListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetUnassignedOrderListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUnassignedOrders(response: HttpResponseBase): Observable<PagedResultDtoOfGetUnassignedOrderListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetUnassignedOrderListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetUnassignedOrderListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    assignRouteToDriverAndVehicle(body: AssignRouteToDriverAndVehicleDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UnassignedPackage/AssignRouteToDriverAndVehicle";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAssignRouteToDriverAndVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAssignRouteToDriverAndVehicle(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAssignRouteToDriverAndVehicle(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class UnlockLocationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param tenantId (optional) 
     * @param body (optional) 
     * @return Success
     */
    unlockLocationJob(tenantId: number | undefined, body: PerformContext | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UnlockLocation/UnlockLocationJob?";
        if (tenantId === null)
            throw new Error("The parameter 'tenantId' cannot be null.");
        else if (tenantId !== undefined)
            url_ += "tenantId=" + encodeURIComponent("" + tenantId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnlockLocationJob(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnlockLocationJob(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnlockLocationJob(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param message (optional) 
     * @param body (optional) 
     * @return Success
     */
    logMessage(message: string | undefined, body: ConsoleTextColor | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UnlockLocation/LogMessage?";
        if (message === null)
            throw new Error("The parameter 'message' cannot be null.");
        else if (message !== undefined)
            url_ += "message=" + encodeURIComponent("" + message) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLogMessage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLogMessage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLogMessage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class UserServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param permissions (optional) 
     * @param role (optional) 
     * @param onlyLockedUsers (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getUsers(filter: string | undefined, permissions: string[] | undefined, role: number | undefined, onlyLockedUsers: boolean | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfUserListDto> {
        let url_ = this.baseUrl + "/api/services/app/User/GetUsers?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (permissions === null)
            throw new Error("The parameter 'permissions' cannot be null.");
        else if (permissions !== undefined)
            permissions && permissions.forEach(item => { url_ += "Permissions=" + encodeURIComponent("" + item) + "&"; });
        if (role === null)
            throw new Error("The parameter 'role' cannot be null.");
        else if (role !== undefined)
            url_ += "Role=" + encodeURIComponent("" + role) + "&"; 
        if (onlyLockedUsers === null)
            throw new Error("The parameter 'onlyLockedUsers' cannot be null.");
        else if (onlyLockedUsers !== undefined)
            url_ += "OnlyLockedUsers=" + encodeURIComponent("" + onlyLockedUsers) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUsers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUsers(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfUserListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfUserListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUsers(response: HttpResponseBase): Observable<PagedResultDtoOfUserListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfUserListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfUserListDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param permissions (optional) 
     * @param role (optional) 
     * @param onlyLockedUsers (optional) 
     * @param sorting (optional) 
     * @return Success
     */
    getUsersToExcel(filter: string | undefined, permissions: string[] | undefined, role: number | undefined, onlyLockedUsers: boolean | undefined, sorting: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/User/GetUsersToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (permissions === null)
            throw new Error("The parameter 'permissions' cannot be null.");
        else if (permissions !== undefined)
            permissions && permissions.forEach(item => { url_ += "Permissions=" + encodeURIComponent("" + item) + "&"; });
        if (role === null)
            throw new Error("The parameter 'role' cannot be null.");
        else if (role !== undefined)
            url_ += "Role=" + encodeURIComponent("" + role) + "&"; 
        if (onlyLockedUsers === null)
            throw new Error("The parameter 'onlyLockedUsers' cannot be null.");
        else if (onlyLockedUsers !== undefined)
            url_ += "OnlyLockedUsers=" + encodeURIComponent("" + onlyLockedUsers) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUsersToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUsersToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUsersToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateResetUserPassword(body: GetUserIdInputForResetPassword | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/User/UpdateResetUserPassword";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateResetUserPassword(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateResetUserPassword(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateResetUserPassword(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getUserForEdit(id: number | undefined): Observable<GetUserForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/User/GetUserForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetUserForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserForEdit(response: HttpResponseBase): Observable<GetUserForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserForEditOutput>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getUserPermissionsForEdit(id: number | undefined): Observable<GetUserPermissionsForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/User/GetUserPermissionsForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserPermissionsForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserPermissionsForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetUserPermissionsForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserPermissionsForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserPermissionsForEdit(response: HttpResponseBase): Observable<GetUserPermissionsForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserPermissionsForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserPermissionsForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    resetUserSpecificPermissions(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/User/ResetUserSpecificPermissions";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processResetUserSpecificPermissions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processResetUserSpecificPermissions(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processResetUserSpecificPermissions(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateUserPermissions(body: UpdateUserPermissionsInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/User/UpdateUserPermissions";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateUserPermissions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateUserPermissions(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateUserPermissions(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateUser(body: CreateOrUpdateUserInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/User/CreateOrUpdateUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteUser(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/User/DeleteUser?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    unlockUser(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/User/UnlockUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnlockUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnlockUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnlockUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    lockUser(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/User/LockUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLockUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLockUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLockUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    userEmailConfirm(body: EntityDtoOfInt64 | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/User/UserEmailConfirm";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUserEmailConfirm(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUserEmailConfirm(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUserEmailConfirm(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class UserEventServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param userName (optional) 
     * @param startTime (optional) 
     * @param endTime (optional) 
     * @param code (optional) 
     * @param value (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    get(userName: string | undefined, startTime: moment.Moment | undefined, endTime: moment.Moment | undefined, code: string | undefined, value: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetUserEventResultListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/UserEvent/Get?";
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "UserName=" + encodeURIComponent("" + userName) + "&"; 
        if (startTime === null)
            throw new Error("The parameter 'startTime' cannot be null.");
        else if (startTime !== undefined)
            url_ += "StartTime=" + encodeURIComponent(startTime ? "" + startTime.toJSON() : "") + "&"; 
        if (endTime === null)
            throw new Error("The parameter 'endTime' cannot be null.");
        else if (endTime !== undefined)
            url_ += "EndTime=" + encodeURIComponent(endTime ? "" + endTime.toJSON() : "") + "&"; 
        if (code === null)
            throw new Error("The parameter 'code' cannot be null.");
        else if (code !== undefined)
            url_ += "Code=" + encodeURIComponent("" + code) + "&"; 
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "Value=" + encodeURIComponent("" + value) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGet(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetUserEventResultListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetUserEventResultListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGet(response: HttpResponseBase): Observable<PagedResultDtoOfGetUserEventResultListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetUserEventResultListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetUserEventResultListItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    create(body: CreateUserEventInputDto | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/UserEvent/Create";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreate(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreate(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserEvent/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class UserLinkServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    linkToUser(body: LinkToUserInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserLink/LinkToUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processLinkToUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processLinkToUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processLinkToUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param sorting (optional) 
     * @return Success
     */
    getLinkedUsers(maxResultCount: number | undefined, skipCount: number | undefined, sorting: string | undefined): Observable<PagedResultDtoOfLinkedUserDto> {
        let url_ = this.baseUrl + "/api/services/app/UserLink/GetLinkedUsers?";
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLinkedUsers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLinkedUsers(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfLinkedUserDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfLinkedUserDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetLinkedUsers(response: HttpResponseBase): Observable<PagedResultDtoOfLinkedUserDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfLinkedUserDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfLinkedUserDto>(<any>null);
    }

    /**
     * @return Success
     */
    getRecentlyUsedLinkedUsers(): Observable<ListResultDtoOfLinkedUserDto> {
        let url_ = this.baseUrl + "/api/services/app/UserLink/GetRecentlyUsedLinkedUsers";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRecentlyUsedLinkedUsers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRecentlyUsedLinkedUsers(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfLinkedUserDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfLinkedUserDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRecentlyUsedLinkedUsers(response: HttpResponseBase): Observable<ListResultDtoOfLinkedUserDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfLinkedUserDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfLinkedUserDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    unlinkUser(body: UnlinkUserInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserLink/UnlinkUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUnlinkUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUnlinkUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUnlinkUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class UserLocationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param user (optional) 
     * @param locationId (optional) 
     * @param filter (optional) 
     * @param userFilter (optional) 
     * @param locationFilter (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getUserLocationsToExcel(id: number | undefined, userId: number | undefined, user: string | undefined, locationId: number | undefined, filter: string | undefined, userFilter: string | undefined, locationFilter: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/UserLocation/GetUserLocationsToExcel?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (user === null)
            throw new Error("The parameter 'user' cannot be null.");
        else if (user !== undefined)
            url_ += "User=" + encodeURIComponent("" + user) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (userFilter === null)
            throw new Error("The parameter 'userFilter' cannot be null.");
        else if (userFilter !== undefined)
            url_ += "UserFilter=" + encodeURIComponent("" + userFilter) + "&"; 
        if (locationFilter === null)
            throw new Error("The parameter 'locationFilter' cannot be null.");
        else if (locationFilter !== undefined)
            url_ += "LocationFilter=" + encodeURIComponent("" + locationFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserLocationsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserLocationsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserLocationsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createUserLocation(body: CreateUserLocationInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserLocation/CreateUserLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateUserLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateUserLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateUserLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param user (optional) 
     * @param locationId (optional) 
     * @param filter (optional) 
     * @param userFilter (optional) 
     * @param locationFilter (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getUserLocation(id: number | undefined, userId: number | undefined, user: string | undefined, locationId: number | undefined, filter: string | undefined, userFilter: string | undefined, locationFilter: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfUserLocationListDto> {
        let url_ = this.baseUrl + "/api/services/app/UserLocation/GetUserLocation?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (user === null)
            throw new Error("The parameter 'user' cannot be null.");
        else if (user !== undefined)
            url_ += "User=" + encodeURIComponent("" + user) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (userFilter === null)
            throw new Error("The parameter 'userFilter' cannot be null.");
        else if (userFilter !== undefined)
            url_ += "UserFilter=" + encodeURIComponent("" + userFilter) + "&"; 
        if (locationFilter === null)
            throw new Error("The parameter 'locationFilter' cannot be null.");
        else if (locationFilter !== undefined)
            url_ += "LocationFilter=" + encodeURIComponent("" + locationFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserLocation(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfUserLocationListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfUserLocationListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserLocation(response: HttpResponseBase): Observable<PagedResultDtoOfUserLocationListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfUserLocationListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfUserLocationListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateUserLocation(body: UpdateUserLocationInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserLocation/UpdateUserLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateUserLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateUserLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateUserLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserLocation/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param userId (optional) 
     * @return Success
     */
    deleteUserLocation(userId: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserLocation/DeleteUserLocation?";
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteUserLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteUserLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteUserLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    pickUserList(body: GetUserListInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/UserLocation/PickUserList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPickUserList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPickUserList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processPickUserList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class UserLoginServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getRecentUserLoginAttempts(): Observable<ListResultDtoOfUserLoginAttemptDto> {
        let url_ = this.baseUrl + "/api/services/app/UserLogin/GetRecentUserLoginAttempts";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRecentUserLoginAttempts(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRecentUserLoginAttempts(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfUserLoginAttemptDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfUserLoginAttemptDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRecentUserLoginAttempts(response: HttpResponseBase): Observable<ListResultDtoOfUserLoginAttemptDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfUserLoginAttemptDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfUserLoginAttemptDto>(<any>null);
    }
}

@Injectable()
export class UserOrderTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param userNameFilter (optional) 
     * @param orderTypeCodeFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, userNameFilter: string | undefined, orderTypeCodeFilter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetUserOrderTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/UserOrderTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (userNameFilter === null)
            throw new Error("The parameter 'userNameFilter' cannot be null.");
        else if (userNameFilter !== undefined)
            url_ += "UserNameFilter=" + encodeURIComponent("" + userNameFilter) + "&"; 
        if (orderTypeCodeFilter === null)
            throw new Error("The parameter 'orderTypeCodeFilter' cannot be null.");
        else if (orderTypeCodeFilter !== undefined)
            url_ += "OrderTypeCodeFilter=" + encodeURIComponent("" + orderTypeCodeFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetUserOrderTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetUserOrderTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetUserOrderTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetUserOrderTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetUserOrderTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getUserOrderTypeForView(id: number | undefined): Observable<GetUserOrderTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/UserOrderTypes/GetUserOrderTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserOrderTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserOrderTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetUserOrderTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserOrderTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserOrderTypeForView(response: HttpResponseBase): Observable<GetUserOrderTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserOrderTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserOrderTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getUserOrderTypeForEdit(id: number | undefined): Observable<GetUserOrderTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/UserOrderTypes/GetUserOrderTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserOrderTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserOrderTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetUserOrderTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserOrderTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserOrderTypeForEdit(response: HttpResponseBase): Observable<GetUserOrderTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserOrderTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserOrderTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditUserOrderTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserOrderTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserOrderTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param userNameFilter (optional) 
     * @param orderTypeCodeFilter (optional) 
     * @return Success
     */
    getUserOrderTypesToExcel(filter: string | undefined, userNameFilter: string | undefined, orderTypeCodeFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/UserOrderTypes/GetUserOrderTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (userNameFilter === null)
            throw new Error("The parameter 'userNameFilter' cannot be null.");
        else if (userNameFilter !== undefined)
            url_ += "UserNameFilter=" + encodeURIComponent("" + userNameFilter) + "&"; 
        if (orderTypeCodeFilter === null)
            throw new Error("The parameter 'orderTypeCodeFilter' cannot be null.");
        else if (orderTypeCodeFilter !== undefined)
            url_ += "OrderTypeCodeFilter=" + encodeURIComponent("" + orderTypeCodeFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserOrderTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserOrderTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserOrderTypesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllUserForTableDropdown(): Observable<UserOrderTypeUserLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/UserOrderTypes/GetAllUserForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllUserForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllUserForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<UserOrderTypeUserLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<UserOrderTypeUserLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllUserForTableDropdown(response: HttpResponseBase): Observable<UserOrderTypeUserLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(UserOrderTypeUserLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UserOrderTypeUserLookupTableDto[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAllUserPaged(filter: string | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/UserOrderTypes/GetAllUserPaged?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllUserPaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllUserPaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllUserPaged(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @return Success
     */
    getAllOrderTypeForTableDropdown(): Observable<UserOrderTypeOrderTypeLookupTableDto[]> {
        let url_ = this.baseUrl + "/api/services/app/UserOrderTypes/GetAllOrderTypeForTableDropdown";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllOrderTypeForTableDropdown(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllOrderTypeForTableDropdown(<any>response_);
                } catch (e) {
                    return <Observable<UserOrderTypeOrderTypeLookupTableDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<UserOrderTypeOrderTypeLookupTableDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllOrderTypeForTableDropdown(response: HttpResponseBase): Observable<UserOrderTypeOrderTypeLookupTableDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(UserOrderTypeOrderTypeLookupTableDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<UserOrderTypeOrderTypeLookupTableDto[]>(<any>null);
    }
}

@Injectable()
export class UserPreferencesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param userId (optional) 
     * @param valueFilter (optional) 
     * @param preferenceId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, userId: number | undefined, valueFilter: string | undefined, preferenceId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetUserPreferenceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        if (preferenceId === null)
            throw new Error("The parameter 'preferenceId' cannot be null.");
        else if (preferenceId !== undefined)
            url_ += "PreferenceId=" + encodeURIComponent("" + preferenceId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetUserPreferenceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetUserPreferenceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetUserPreferenceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetUserPreferenceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetUserPreferenceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getUserPreferenceForView(id: number | undefined): Observable<GetUserPreferenceForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/GetUserPreferenceForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserPreferenceForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserPreferenceForView(<any>response_);
                } catch (e) {
                    return <Observable<GetUserPreferenceForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserPreferenceForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserPreferenceForView(response: HttpResponseBase): Observable<GetUserPreferenceForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserPreferenceForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserPreferenceForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getUserPreferenceForEdit(id: number | undefined): Observable<GetUserPreferenceForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/GetUserPreferenceForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserPreferenceForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserPreferenceForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetUserPreferenceForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserPreferenceForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserPreferenceForEdit(response: HttpResponseBase): Observable<GetUserPreferenceForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserPreferenceForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserPreferenceForEditOutput>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param preferenceId (optional) 
     * @return Success
     */
    getUserPreferenceForSession(id: number | undefined, preferenceId: number | undefined): Observable<GetUserPreferenceForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/GetUserPreferenceForSession?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (preferenceId === null)
            throw new Error("The parameter 'preferenceId' cannot be null.");
        else if (preferenceId !== undefined)
            url_ += "PreferenceId=" + encodeURIComponent("" + preferenceId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserPreferenceForSession(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserPreferenceForSession(<any>response_);
                } catch (e) {
                    return <Observable<GetUserPreferenceForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserPreferenceForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserPreferenceForSession(response: HttpResponseBase): Observable<GetUserPreferenceForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetUserPreferenceForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserPreferenceForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditUserPreferenceDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param maxUserIdFilter (optional) 
     * @param minUserIdFilter (optional) 
     * @param valueFilter (optional) 
     * @param maxPreferenceIdFilter (optional) 
     * @param minPreferenceIdFilter (optional) 
     * @return Success
     */
    getUserPreferencesToExcel(filter: string | undefined, maxUserIdFilter: number | undefined, minUserIdFilter: number | undefined, valueFilter: string | undefined, maxPreferenceIdFilter: number | undefined, minPreferenceIdFilter: number | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/GetUserPreferencesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (maxUserIdFilter === null)
            throw new Error("The parameter 'maxUserIdFilter' cannot be null.");
        else if (maxUserIdFilter !== undefined)
            url_ += "MaxUserIdFilter=" + encodeURIComponent("" + maxUserIdFilter) + "&"; 
        if (minUserIdFilter === null)
            throw new Error("The parameter 'minUserIdFilter' cannot be null.");
        else if (minUserIdFilter !== undefined)
            url_ += "MinUserIdFilter=" + encodeURIComponent("" + minUserIdFilter) + "&"; 
        if (valueFilter === null)
            throw new Error("The parameter 'valueFilter' cannot be null.");
        else if (valueFilter !== undefined)
            url_ += "ValueFilter=" + encodeURIComponent("" + valueFilter) + "&"; 
        if (maxPreferenceIdFilter === null)
            throw new Error("The parameter 'maxPreferenceIdFilter' cannot be null.");
        else if (maxPreferenceIdFilter !== undefined)
            url_ += "MaxPreferenceIdFilter=" + encodeURIComponent("" + maxPreferenceIdFilter) + "&"; 
        if (minPreferenceIdFilter === null)
            throw new Error("The parameter 'minPreferenceIdFilter' cannot be null.");
        else if (minPreferenceIdFilter !== undefined)
            url_ += "MinPreferenceIdFilter=" + encodeURIComponent("" + minPreferenceIdFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUserPreferencesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUserPreferencesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetUserPreferencesToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @return Success
     */
    getCurrentuserPreference(): Observable<GetUserPreferenceForViewDto[]> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/GetCurrentuserPreference";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCurrentuserPreference(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCurrentuserPreference(<any>response_);
                } catch (e) {
                    return <Observable<GetUserPreferenceForViewDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetUserPreferenceForViewDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetCurrentuserPreference(response: HttpResponseBase): Observable<GetUserPreferenceForViewDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetUserPreferenceForViewDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetUserPreferenceForViewDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEditUserPreference(body: UserPreferenceInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/CreateOrEditUserPreference";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEditUserPreference(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEditUserPreference(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEditUserPreference(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateForMobileClientUser(body: CreateOrUpdateForMobileClientUserInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/CreateOrUpdateForMobileClientUser";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateForMobileClientUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateForMobileClientUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateForMobileClientUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param userId (optional) 
     * @param preferenceCode (optional) 
     * @return Success
     */
    deleteForMobileClientUser(userId: number | undefined, preferenceCode: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/DeleteForMobileClientUser?";
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (preferenceCode === null)
            throw new Error("The parameter 'preferenceCode' cannot be null.");
        else if (preferenceCode !== undefined)
            url_ += "PreferenceCode=" + encodeURIComponent("" + preferenceCode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteForMobileClientUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteForMobileClientUser(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteForMobileClientUser(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param userId (optional) 
     * @return Success
     */
    getForMobileClientUser(userId: number | undefined): Observable<GetForMobileClientUserResultDto> {
        let url_ = this.baseUrl + "/api/services/app/UserPreferences/GetForMobileClientUser?";
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetForMobileClientUser(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetForMobileClientUser(<any>response_);
                } catch (e) {
                    return <Observable<GetForMobileClientUserResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetForMobileClientUserResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetForMobileClientUser(response: HttpResponseBase): Observable<GetForMobileClientUserResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetForMobileClientUserResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetForMobileClientUserResultDto>(<any>null);
    }
}

@Injectable()
export class VehicleServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createVehicle(body: CreateVehicleInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/CreateVehicle";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateVehicle(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateVehicle(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param nameFilter (optional) 
     * @param licenseNumberFilter (optional) 
     * @param driverFilter (optional) 
     * @return Success
     */
    getVehiclesToExcel(filter: string | undefined, nameFilter: string | undefined, licenseNumberFilter: string | undefined, driverFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/GetVehiclesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (nameFilter === null)
            throw new Error("The parameter 'nameFilter' cannot be null.");
        else if (nameFilter !== undefined)
            url_ += "NameFilter=" + encodeURIComponent("" + nameFilter) + "&"; 
        if (licenseNumberFilter === null)
            throw new Error("The parameter 'licenseNumberFilter' cannot be null.");
        else if (licenseNumberFilter !== undefined)
            url_ += "LicenseNumberFilter=" + encodeURIComponent("" + licenseNumberFilter) + "&"; 
        if (driverFilter === null)
            throw new Error("The parameter 'driverFilter' cannot be null.");
        else if (driverFilter !== undefined)
            url_ += "DriverFilter=" + encodeURIComponent("" + driverFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehiclesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehiclesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehiclesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param licenseNumber (optional) 
     * @param filter (optional) 
     * @param color (optional) 
     * @param userId (optional) 
     * @param userName (optional) 
     * @param userSurname (optional) 
     * @param mileageMultiplier (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getVehiclePaged(id: number | undefined, name: string | undefined, licenseNumber: string | undefined, filter: string | undefined, color: string | undefined, userId: number | undefined, userName: string | undefined, userSurname: string | undefined, mileageMultiplier: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfVehicleListDto> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/GetVehiclePaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (licenseNumber === null)
            throw new Error("The parameter 'licenseNumber' cannot be null.");
        else if (licenseNumber !== undefined)
            url_ += "LicenseNumber=" + encodeURIComponent("" + licenseNumber) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (color === null)
            throw new Error("The parameter 'color' cannot be null.");
        else if (color !== undefined)
            url_ += "Color=" + encodeURIComponent("" + color) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (userName === null)
            throw new Error("The parameter 'userName' cannot be null.");
        else if (userName !== undefined)
            url_ += "UserName=" + encodeURIComponent("" + userName) + "&"; 
        if (userSurname === null)
            throw new Error("The parameter 'userSurname' cannot be null.");
        else if (userSurname !== undefined)
            url_ += "UserSurname=" + encodeURIComponent("" + userSurname) + "&"; 
        if (mileageMultiplier === null)
            throw new Error("The parameter 'mileageMultiplier' cannot be null.");
        else if (mileageMultiplier !== undefined)
            url_ += "MileageMultiplier=" + encodeURIComponent("" + mileageMultiplier) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehiclePaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehiclePaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfVehicleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfVehicleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehiclePaged(response: HttpResponseBase): Observable<PagedResultDtoOfVehicleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfVehicleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfVehicleListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @return Success
     */
    getVehicleForEdit(id: number | undefined, userId: number | undefined): Observable<GetVehicleForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/GetVehicleForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetVehicleForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVehicleForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleForEdit(response: HttpResponseBase): Observable<GetVehicleForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVehicleForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVehicleForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateVehicle(body: UpdateVehicleInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/UpdateVehicle";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateVehicle(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateVehicle(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteVehicle(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/DeleteVehicle?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteVehicle(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteVehicle(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteVehicle(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    checkOut(body: VehicleCheckOutInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/CheckOut";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckOut(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckOut(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCheckOut(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    checkIn(body: VehicleCheckInInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/CheckIn";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckIn(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckIn(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCheckIn(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param licenseNumber (optional) 
     * @param userId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAvailable(id: number | undefined, name: string | undefined, licenseNumber: string | undefined, userId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfAvailableVehicleListDto> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/GetAvailable?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (licenseNumber === null)
            throw new Error("The parameter 'licenseNumber' cannot be null.");
        else if (licenseNumber !== undefined)
            url_ += "LicenseNumber=" + encodeURIComponent("" + licenseNumber) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAvailable(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAvailable(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfAvailableVehicleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfAvailableVehicleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAvailable(response: HttpResponseBase): Observable<PagedResultDtoOfAvailableVehicleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfAvailableVehicleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfAvailableVehicleListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param userId (optional) 
     * @param name (optional) 
     * @param licenseNumber (optional) 
     * @param lastModificationTime (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getCheckedOut(id: number | undefined, userId: number | undefined, name: string | undefined, licenseNumber: string | undefined, lastModificationTime: moment.Moment | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetCheckedOutVehicleListDto> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/GetCheckedOut?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (userId === null)
            throw new Error("The parameter 'userId' cannot be null.");
        else if (userId !== undefined)
            url_ += "UserId=" + encodeURIComponent("" + userId) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (licenseNumber === null)
            throw new Error("The parameter 'licenseNumber' cannot be null.");
        else if (licenseNumber !== undefined)
            url_ += "LicenseNumber=" + encodeURIComponent("" + licenseNumber) + "&"; 
        if (lastModificationTime === null)
            throw new Error("The parameter 'lastModificationTime' cannot be null.");
        else if (lastModificationTime !== undefined)
            url_ += "LastModificationTime=" + encodeURIComponent(lastModificationTime ? "" + lastModificationTime.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetCheckedOut(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetCheckedOut(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetCheckedOutVehicleListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetCheckedOutVehicleListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetCheckedOut(response: HttpResponseBase): Observable<PagedResultDtoOfGetCheckedOutVehicleListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetCheckedOutVehicleListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetCheckedOutVehicleListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addLog(body: AddLogInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/AddLog";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddLog(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddLog(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processAddLog(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    checkOrCreateVehicleByDriver(body: CheckOrCreateVehicleByDriverInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/CheckOrCreateVehicleByDriver";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCheckOrCreateVehicleByDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCheckOrCreateVehicleByDriver(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCheckOrCreateVehicleByDriver(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getChecklist(): Observable<ListResultDtoOfGetChecklistListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/GetChecklist";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetChecklist(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetChecklist(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetChecklistListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetChecklistListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetChecklist(response: HttpResponseBase): Observable<ListResultDtoOfGetChecklistListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetChecklistListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetChecklistListItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    saveChecklist(body: SaveChecklistInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/SaveChecklist";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSaveChecklist(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSaveChecklist(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processSaveChecklist(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @param filter (optional) 
     * @return Success
     */
    getPagedVehicleLookup(maxResultCount: number | undefined, skipCount: number | undefined, filter: string | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Vehicle/GetPagedVehicleLookup?";
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPagedVehicleLookup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPagedVehicleLookup(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPagedVehicleLookup(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class VehicleChecklistsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param colorFilter (optional) 
     * @param iconFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param isRequiredFilter (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, colorFilter: string | undefined, iconFilter: string | undefined, isActiveFilter: boolean | undefined, isRequiredFilter: boolean | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetVehicleChecklistForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleChecklists/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        if (iconFilter === null)
            throw new Error("The parameter 'iconFilter' cannot be null.");
        else if (iconFilter !== undefined)
            url_ += "iconFilter=" + encodeURIComponent("" + iconFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (isRequiredFilter === null)
            throw new Error("The parameter 'isRequiredFilter' cannot be null.");
        else if (isRequiredFilter !== undefined)
            url_ += "IsRequiredFilter=" + encodeURIComponent("" + isRequiredFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetVehicleChecklistForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetVehicleChecklistForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetVehicleChecklistForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetVehicleChecklistForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetVehicleChecklistForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getVehicleChecklistForView(id: number | undefined): Observable<GetVehicleChecklistForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleChecklists/GetVehicleChecklistForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleChecklistForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleChecklistForView(<any>response_);
                } catch (e) {
                    return <Observable<GetVehicleChecklistForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVehicleChecklistForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleChecklistForView(response: HttpResponseBase): Observable<GetVehicleChecklistForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVehicleChecklistForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVehicleChecklistForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getVehicleChecklistForEdit(id: number | undefined): Observable<GetVehicleChecklistForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/VehicleChecklists/GetVehicleChecklistForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleChecklistForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleChecklistForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetVehicleChecklistForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVehicleChecklistForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleChecklistForEdit(response: HttpResponseBase): Observable<GetVehicleChecklistForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVehicleChecklistForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVehicleChecklistForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditVehicleChecklistDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleChecklists/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleChecklists/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param codeFilter (optional) 
     * @param descriptionFilter (optional) 
     * @param colorFilter (optional) 
     * @param iconFilter (optional) 
     * @param isActiveFilter (optional) 
     * @param isRequiredFilter (optional) 
     * @return Success
     */
    getVehicleChecklistsToExcel(filter: string | undefined, codeFilter: string | undefined, descriptionFilter: string | undefined, colorFilter: string | undefined, iconFilter: string | undefined, isActiveFilter: boolean | undefined, isRequiredFilter: boolean | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleChecklists/GetVehicleChecklistsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (colorFilter === null)
            throw new Error("The parameter 'colorFilter' cannot be null.");
        else if (colorFilter !== undefined)
            url_ += "ColorFilter=" + encodeURIComponent("" + colorFilter) + "&"; 
        if (iconFilter === null)
            throw new Error("The parameter 'iconFilter' cannot be null.");
        else if (iconFilter !== undefined)
            url_ += "iconFilter=" + encodeURIComponent("" + iconFilter) + "&"; 
        if (isActiveFilter === null)
            throw new Error("The parameter 'isActiveFilter' cannot be null.");
        else if (isActiveFilter !== undefined)
            url_ += "IsActiveFilter=" + encodeURIComponent("" + isActiveFilter) + "&"; 
        if (isRequiredFilter === null)
            throw new Error("The parameter 'isRequiredFilter' cannot be null.");
        else if (isRequiredFilter !== undefined)
            url_ += "IsRequiredFilter=" + encodeURIComponent("" + isRequiredFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleChecklistsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleChecklistsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleChecklistsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class VehicleLocationServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createVehicleLocation(body: CreateVehicleLocationInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLocation/CreateVehicleLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateVehicleLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateVehicleLocation(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateVehicleLocation(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param filter (optional) 
     * @param vehicle (optional) 
     * @param locationFilter (optional) 
     * @param locationId (optional) 
     * @return Success
     */
    getVehicleLocationsToExcel(id: number | undefined, filter: string | undefined, vehicle: string | undefined, locationFilter: string | undefined, locationId: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLocation/GetVehicleLocationsToExcel?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (vehicle === null)
            throw new Error("The parameter 'vehicle' cannot be null.");
        else if (vehicle !== undefined)
            url_ += "Vehicle=" + encodeURIComponent("" + vehicle) + "&"; 
        if (locationFilter === null)
            throw new Error("The parameter 'locationFilter' cannot be null.");
        else if (locationFilter !== undefined)
            url_ += "LocationFilter=" + encodeURIComponent("" + locationFilter) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleLocationsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleLocationsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleLocationsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param vehicleId (optional) 
     * @param locationId (optional) 
     * @param vehicle (optional) 
     * @param filter (optional) 
     * @param vehicleFilter (optional) 
     * @param locationFilter (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getVehicleLocation(id: number | undefined, vehicleId: number | undefined, locationId: number | undefined, vehicle: string | undefined, filter: string | undefined, vehicleFilter: string | undefined, locationFilter: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfVehicleLocationListDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLocation/GetVehicleLocation?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (vehicle === null)
            throw new Error("The parameter 'vehicle' cannot be null.");
        else if (vehicle !== undefined)
            url_ += "Vehicle=" + encodeURIComponent("" + vehicle) + "&"; 
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (vehicleFilter === null)
            throw new Error("The parameter 'vehicleFilter' cannot be null.");
        else if (vehicleFilter !== undefined)
            url_ += "VehicleFilter=" + encodeURIComponent("" + vehicleFilter) + "&"; 
        if (locationFilter === null)
            throw new Error("The parameter 'locationFilter' cannot be null.");
        else if (locationFilter !== undefined)
            url_ += "LocationFilter=" + encodeURIComponent("" + locationFilter) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleLocation(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfVehicleLocationListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfVehicleLocationListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleLocation(response: HttpResponseBase): Observable<PagedResultDtoOfVehicleLocationListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfVehicleLocationListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfVehicleLocationListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateVehicleLocation(body: UpdateVehicleLocationInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLocation/UpdateVehicleLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateVehicleLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateVehicleLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateVehicleLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteVehicleLocation(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLocation/DeleteVehicleLocation?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteVehicleLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteVehicleLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteVehicleLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class VehicleLogServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createVehicleLocation(body: CreateVehicleLogInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLog/CreateVehicleLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateVehicleLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateVehicleLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateVehicleLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    batchCreateVehicleLocation(body: BatchCreateVehicleLocationInputDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLog/BatchCreateVehicleLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processBatchCreateVehicleLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processBatchCreateVehicleLocation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processBatchCreateVehicleLocation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param meters (optional) 
     * @return Success
     */
    convertMetersToMiles(meters: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLog/ConvertMetersToMiles?";
        if (meters === null)
            throw new Error("The parameter 'meters' cannot be null.");
        else if (meters !== undefined)
            url_ += "meters=" + encodeURIComponent("" + meters) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processConvertMetersToMiles(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processConvertMetersToMiles(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processConvertMetersToMiles(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getTotalMileageWithMultipleRoutes(routeId: number[] | undefined): Observable<GetTotalMileageDto[]> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLog/GetTotalMileageWithMultipleRoutes?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            routeId && routeId.forEach(item => { url_ += "RouteId=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTotalMileageWithMultipleRoutes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTotalMileageWithMultipleRoutes(<any>response_);
                } catch (e) {
                    return <Observable<GetTotalMileageDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTotalMileageDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTotalMileageWithMultipleRoutes(response: HttpResponseBase): Observable<GetTotalMileageDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetTotalMileageDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTotalMileageDto[]>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getTotalMileage(routeId: number[] | undefined): Observable<GetTotalMileageDto[]> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLog/GetTotalMileage?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            routeId && routeId.forEach(item => { url_ += "RouteId=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTotalMileage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTotalMileage(<any>response_);
                } catch (e) {
                    return <Observable<GetTotalMileageDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetTotalMileageDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetTotalMileage(response: HttpResponseBase): Observable<GetTotalMileageDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetTotalMileageDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetTotalMileageDto[]>(<any>null);
    }

    /**
     * @param routeId (optional) 
     * @return Success
     */
    getTotalMileagePerRoute(routeId: number | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLog/GetTotalMileagePerRoute?";
        if (routeId === null)
            throw new Error("The parameter 'routeId' cannot be null.");
        else if (routeId !== undefined)
            url_ += "RouteId=" + encodeURIComponent("" + routeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetTotalMileagePerRoute(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetTotalMileagePerRoute(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetTotalMileagePerRoute(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param operationDate (optional) 
     * @return Success
     */
    compressLogsForOperationDate(operationDate: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleLog/CompressLogsForOperationDate?";
        if (operationDate === null)
            throw new Error("The parameter 'operationDate' cannot be null.");
        else if (operationDate !== undefined)
            url_ += "operationDate=" + encodeURIComponent("" + operationDate) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCompressLogsForOperationDate(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCompressLogsForOperationDate(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCompressLogsForOperationDate(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class VehicleMileageServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createVehicleInVehicleMileage(body: CreateVehicleMileageInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/VehicleMileage/CreateVehicleInVehicleMileage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateVehicleInVehicleMileage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateVehicleInVehicleMileage(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateVehicleInVehicleMileage(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createVehicleMileage(body: CreateVehicleMileageInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/VehicleMileage/CreateVehicleMileage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateVehicleMileage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateVehicleMileage(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateVehicleMileage(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param vehicleId (optional) 
     * @param mileage (optional) 
     * @param vehicleName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getVehicleMileagePaged(id: number | undefined, vehicleId: number | undefined, mileage: number | undefined, vehicleName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfVehicleMileageListDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleMileage/GetVehicleMileagePaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (mileage === null)
            throw new Error("The parameter 'mileage' cannot be null.");
        else if (mileage !== undefined)
            url_ += "Mileage=" + encodeURIComponent("" + mileage) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleMileagePaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleMileagePaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfVehicleMileageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfVehicleMileageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleMileagePaged(response: HttpResponseBase): Observable<PagedResultDtoOfVehicleMileageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfVehicleMileageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfVehicleMileageListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param vehicleId (optional) 
     * @param mileage (optional) 
     * @param vehicleName (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getVehicleMileageQPaged(id: number | undefined, vehicleId: number | undefined, mileage: number | undefined, vehicleName: string | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfVehicleMileageListDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleMileage/GetVehicleMileageQPaged?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (vehicleId === null)
            throw new Error("The parameter 'vehicleId' cannot be null.");
        else if (vehicleId !== undefined)
            url_ += "VehicleId=" + encodeURIComponent("" + vehicleId) + "&"; 
        if (mileage === null)
            throw new Error("The parameter 'mileage' cannot be null.");
        else if (mileage !== undefined)
            url_ += "Mileage=" + encodeURIComponent("" + mileage) + "&"; 
        if (vehicleName === null)
            throw new Error("The parameter 'vehicleName' cannot be null.");
        else if (vehicleName !== undefined)
            url_ += "VehicleName=" + encodeURIComponent("" + vehicleName) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleMileageQPaged(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleMileageQPaged(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfVehicleMileageListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfVehicleMileageListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleMileageQPaged(response: HttpResponseBase): Observable<PagedResultDtoOfVehicleMileageListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfVehicleMileageListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfVehicleMileageListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getVehicleMileageForEdit(id: number | undefined): Observable<GetVehicleMileageForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/VehicleMileage/GetVehicleMileageForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleMileageForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleMileageForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetVehicleMileageForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVehicleMileageForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleMileageForEdit(response: HttpResponseBase): Observable<GetVehicleMileageForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVehicleMileageForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVehicleMileageForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateVehicleMileage(body: UpdateVehicleMileageInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleMileage/UpdateVehicleMileage";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateVehicleMileage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateVehicleMileage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateVehicleMileage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteVehicleMileage(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleMileage/DeleteVehicleMileage?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteVehicleMileage(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteVehicleMileage(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteVehicleMileage(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class VehicleTypesServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param descriptionFilter (optional) 
     * @param codeFilter (optional) 
     * @param mileageMultiplier (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, descriptionFilter: string | undefined, codeFilter: string | undefined, mileageMultiplier: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetVehicleTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleTypes/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        if (mileageMultiplier === null)
            throw new Error("The parameter 'mileageMultiplier' cannot be null.");
        else if (mileageMultiplier !== undefined)
            url_ += "MileageMultiplier=" + encodeURIComponent("" + mileageMultiplier) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetVehicleTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetVehicleTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetVehicleTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetVehicleTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetVehicleTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getVehicleTypeForView(id: number | undefined): Observable<GetVehicleTypeForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleTypes/GetVehicleTypeForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleTypeForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleTypeForView(<any>response_);
                } catch (e) {
                    return <Observable<GetVehicleTypeForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVehicleTypeForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleTypeForView(response: HttpResponseBase): Observable<GetVehicleTypeForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVehicleTypeForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVehicleTypeForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getVehicleTypeForEdit(id: number | undefined): Observable<GetVehicleTypeForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/VehicleTypes/GetVehicleTypeForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleTypeForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleTypeForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetVehicleTypeForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVehicleTypeForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleTypeForEdit(response: HttpResponseBase): Observable<GetVehicleTypeForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVehicleTypeForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVehicleTypeForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditVehicleTypeDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleTypes/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/VehicleTypes/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param descriptionFilter (optional) 
     * @param codeFilter (optional) 
     * @return Success
     */
    getVehicleTypesToExcel(filter: string | undefined, descriptionFilter: string | undefined, codeFilter: string | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/VehicleTypes/GetVehicleTypesToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (descriptionFilter === null)
            throw new Error("The parameter 'descriptionFilter' cannot be null.");
        else if (descriptionFilter !== undefined)
            url_ += "DescriptionFilter=" + encodeURIComponent("" + descriptionFilter) + "&"; 
        if (codeFilter === null)
            throw new Error("The parameter 'codeFilter' cannot be null.");
        else if (codeFilter !== undefined)
            url_ += "CodeFilter=" + encodeURIComponent("" + codeFilter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVehicleTypesToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVehicleTypesToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVehicleTypesToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }
}

@Injectable()
export class VendorsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param emailAddress (optional) 
     * @param name (optional) 
     * @param surname (optional) 
     * @param isEmailConfirmed (optional) 
     * @param onlyLockedUsers (optional) 
     * @param locationIds (optional) 
     * @param fleetId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getVendorsToExcel(filter: string | undefined, emailAddress: string | undefined, name: string | undefined, surname: string | undefined, isEmailConfirmed: boolean | undefined, onlyLockedUsers: boolean | undefined, locationIds: number[] | undefined, fleetId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/Vendors/GetVendorsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (emailAddress === null)
            throw new Error("The parameter 'emailAddress' cannot be null.");
        else if (emailAddress !== undefined)
            url_ += "EmailAddress=" + encodeURIComponent("" + emailAddress) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (surname === null)
            throw new Error("The parameter 'surname' cannot be null.");
        else if (surname !== undefined)
            url_ += "Surname=" + encodeURIComponent("" + surname) + "&"; 
        if (isEmailConfirmed === null)
            throw new Error("The parameter 'isEmailConfirmed' cannot be null.");
        else if (isEmailConfirmed !== undefined)
            url_ += "isEmailConfirmed=" + encodeURIComponent("" + isEmailConfirmed) + "&"; 
        if (onlyLockedUsers === null)
            throw new Error("The parameter 'onlyLockedUsers' cannot be null.");
        else if (onlyLockedUsers !== undefined)
            url_ += "OnlyLockedUsers=" + encodeURIComponent("" + onlyLockedUsers) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (fleetId === null)
            throw new Error("The parameter 'fleetId' cannot be null.");
        else if (fleetId !== undefined)
            url_ += "FleetId=" + encodeURIComponent("" + fleetId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVendorsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVendorsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVendorsToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param emailAddress (optional) 
     * @param name (optional) 
     * @param surname (optional) 
     * @param isEmailConfirmed (optional) 
     * @param onlyLockedUsers (optional) 
     * @param locationIds (optional) 
     * @param fleetId (optional) 
     * @param sorting (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getVendors(filter: string | undefined, emailAddress: string | undefined, name: string | undefined, surname: string | undefined, isEmailConfirmed: boolean | undefined, onlyLockedUsers: boolean | undefined, locationIds: number[] | undefined, fleetId: number | undefined, sorting: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetVendorListDto> {
        let url_ = this.baseUrl + "/api/services/app/Vendors/GetVendors?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (emailAddress === null)
            throw new Error("The parameter 'emailAddress' cannot be null.");
        else if (emailAddress !== undefined)
            url_ += "EmailAddress=" + encodeURIComponent("" + emailAddress) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (surname === null)
            throw new Error("The parameter 'surname' cannot be null.");
        else if (surname !== undefined)
            url_ += "Surname=" + encodeURIComponent("" + surname) + "&"; 
        if (isEmailConfirmed === null)
            throw new Error("The parameter 'isEmailConfirmed' cannot be null.");
        else if (isEmailConfirmed !== undefined)
            url_ += "isEmailConfirmed=" + encodeURIComponent("" + isEmailConfirmed) + "&"; 
        if (onlyLockedUsers === null)
            throw new Error("The parameter 'onlyLockedUsers' cannot be null.");
        else if (onlyLockedUsers !== undefined)
            url_ += "OnlyLockedUsers=" + encodeURIComponent("" + onlyLockedUsers) + "&"; 
        if (locationIds === null)
            throw new Error("The parameter 'locationIds' cannot be null.");
        else if (locationIds !== undefined)
            locationIds && locationIds.forEach(item => { url_ += "LocationIds=" + encodeURIComponent("" + item) + "&"; });
        if (fleetId === null)
            throw new Error("The parameter 'fleetId' cannot be null.");
        else if (fleetId !== undefined)
            url_ += "FleetId=" + encodeURIComponent("" + fleetId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVendors(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVendors(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetVendorListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetVendorListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVendors(response: HttpResponseBase): Observable<PagedResultDtoOfGetVendorListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetVendorListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetVendorListDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getVendorForEdit(id: number | undefined): Observable<GetVendorForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Vendors/GetVendorForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVendorForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVendorForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetVendorForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVendorForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetVendorForEdit(response: HttpResponseBase): Observable<GetVendorForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVendorForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVendorForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrUpdateVendor(body: CreateOrEditVendorInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Vendors/CreateOrUpdateVendor";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrUpdateVendor(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrUpdateVendor(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrUpdateVendor(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteDriver(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Vendors/DeleteDriver?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteDriver(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteDriver(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteVendor(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Vendors/DeleteVendor?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteVendor(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteVendor(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteVendor(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getVendorDetails(id: number | undefined): Observable<GetVendorDetailsDto> {
        let url_ = this.baseUrl + "/api/services/app/Vendors/GetVendorDetails?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVendorDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVendorDetails(<any>response_);
                } catch (e) {
                    return <Observable<GetVendorDetailsDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVendorDetailsDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVendorDetails(response: HttpResponseBase): Observable<GetVendorDetailsDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVendorDetailsDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVendorDetailsDto>(<any>null);
    }

    /**
     * @param usernames (optional) 
     * @return Success
     */
    getVendorsByUsernames(usernames: string[] | undefined): Observable<GetVendorList[]> {
        let url_ = this.baseUrl + "/api/services/app/Vendors/GetVendorsByUsernames?";
        if (usernames === null)
            throw new Error("The parameter 'usernames' cannot be null.");
        else if (usernames !== undefined)
            usernames && usernames.forEach(item => { url_ += "usernames=" + encodeURIComponent("" + item) + "&"; });
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVendorsByUsernames(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVendorsByUsernames(<any>response_);
                } catch (e) {
                    return <Observable<GetVendorList[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVendorList[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetVendorsByUsernames(response: HttpResponseBase): Observable<GetVendorList[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetVendorList.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVendorList[]>(<any>null);
    }
}

@Injectable()
export class VersionsServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param versionNumberFilter (optional) 
     * @param maxReleasedDateFilter (optional) 
     * @param minReleasedDateFilter (optional) 
     * @param id (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getAll(filter: string | undefined, versionNumberFilter: string | undefined, maxReleasedDateFilter: moment.Moment | undefined, minReleasedDateFilter: moment.Moment | undefined, id: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetVersionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Versions/GetAll?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (versionNumberFilter === null)
            throw new Error("The parameter 'versionNumberFilter' cannot be null.");
        else if (versionNumberFilter !== undefined)
            url_ += "VersionNumberFilter=" + encodeURIComponent("" + versionNumberFilter) + "&"; 
        if (maxReleasedDateFilter === null)
            throw new Error("The parameter 'maxReleasedDateFilter' cannot be null.");
        else if (maxReleasedDateFilter !== undefined)
            url_ += "MaxReleasedDateFilter=" + encodeURIComponent(maxReleasedDateFilter ? "" + maxReleasedDateFilter.toJSON() : "") + "&"; 
        if (minReleasedDateFilter === null)
            throw new Error("The parameter 'minReleasedDateFilter' cannot be null.");
        else if (minReleasedDateFilter !== undefined)
            url_ += "MinReleasedDateFilter=" + encodeURIComponent(minReleasedDateFilter ? "" + minReleasedDateFilter.toJSON() : "") + "&"; 
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAll(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAll(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetVersionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetVersionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAll(response: HttpResponseBase): Observable<PagedResultDtoOfGetVersionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetVersionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetVersionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getVersionForView(id: number | undefined): Observable<GetVersionForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Versions/GetVersionForView?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVersionForView(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVersionForView(<any>response_);
                } catch (e) {
                    return <Observable<GetVersionForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVersionForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVersionForView(response: HttpResponseBase): Observable<GetVersionForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVersionForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVersionForViewDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getVersionForEdit(id: number | undefined): Observable<GetVersionForEditOutput> {
        let url_ = this.baseUrl + "/api/services/app/Versions/GetVersionForEdit?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVersionForEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVersionForEdit(<any>response_);
                } catch (e) {
                    return <Observable<GetVersionForEditOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetVersionForEditOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetVersionForEdit(response: HttpResponseBase): Observable<GetVersionForEditOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetVersionForEditOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetVersionForEditOutput>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrEdit(body: CreateOrEditVersionDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Versions/CreateOrEdit";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrEdit(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrEdit(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrEdit(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    delete(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Versions/Delete?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDelete(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDelete(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDelete(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param versionNumberFilter (optional) 
     * @param maxReleasedDateFilter (optional) 
     * @param minReleasedDateFilter (optional) 
     * @return Success
     */
    getVersionsToExcel(filter: string | undefined, versionNumberFilter: string | undefined, maxReleasedDateFilter: moment.Moment | undefined, minReleasedDateFilter: moment.Moment | undefined): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/Versions/GetVersionsToExcel?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (versionNumberFilter === null)
            throw new Error("The parameter 'versionNumberFilter' cannot be null.");
        else if (versionNumberFilter !== undefined)
            url_ += "VersionNumberFilter=" + encodeURIComponent("" + versionNumberFilter) + "&"; 
        if (maxReleasedDateFilter === null)
            throw new Error("The parameter 'maxReleasedDateFilter' cannot be null.");
        else if (maxReleasedDateFilter !== undefined)
            url_ += "MaxReleasedDateFilter=" + encodeURIComponent(maxReleasedDateFilter ? "" + maxReleasedDateFilter.toJSON() : "") + "&"; 
        if (minReleasedDateFilter === null)
            throw new Error("The parameter 'minReleasedDateFilter' cannot be null.");
        else if (minReleasedDateFilter !== undefined)
            url_ += "MinReleasedDateFilter=" + encodeURIComponent(minReleasedDateFilter ? "" + minReleasedDateFilter.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetVersionsToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetVersionsToExcel(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetVersionsToExcel(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    versionPagedList(body: GetAllVersionsInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Versions/VersionPagedList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processVersionPagedList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processVersionPagedList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processVersionPagedList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }
}

@Injectable()
export class WarehouseServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    pickup(body: WarehousePickupInput | undefined): Observable<WarehousePickupResultDto> {
        let url_ = this.baseUrl + "/api/services/app/Warehouse/Pickup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPickup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPickup(<any>response_);
                } catch (e) {
                    return <Observable<WarehousePickupResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<WarehousePickupResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processPickup(response: HttpResponseBase): Observable<WarehousePickupResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = WarehousePickupResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<WarehousePickupResultDto>(<any>null);
    }

    /**
     * @return Success
     */
    getPickupOrderStatusTypes(): Observable<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto> {
        let url_ = this.baseUrl + "/api/services/app/Warehouse/GetPickupOrderStatusTypes";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPickupOrderStatusTypes(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPickupOrderStatusTypes(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetPickupOrderStatusTypes(response: HttpResponseBase): Observable<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    customPickup(body: WarehouseCustomPickupInput | undefined): Observable<WarehousePickupResultDto> {
        let url_ = this.baseUrl + "/api/services/app/Warehouse/CustomPickup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCustomPickup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCustomPickup(<any>response_);
                } catch (e) {
                    return <Observable<WarehousePickupResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<WarehousePickupResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processCustomPickup(response: HttpResponseBase): Observable<WarehousePickupResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = WarehousePickupResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<WarehousePickupResultDto>(<any>null);
    }
}

@Injectable()
export class WebhookEventServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    get(id: string | undefined): Observable<WebhookEvent> {
        let url_ = this.baseUrl + "/api/services/app/WebhookEvent/Get?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGet(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGet(<any>response_);
                } catch (e) {
                    return <Observable<WebhookEvent>><any>_observableThrow(e);
                }
            } else
                return <Observable<WebhookEvent>><any>_observableThrow(response_);
        }));
    }

    protected processGet(response: HttpResponseBase): Observable<WebhookEvent> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = WebhookEvent.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<WebhookEvent>(<any>null);
    }
}

@Injectable()
export class WebhookSendAttemptServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param subscriptionId (optional) 
     * @param maxResultCount (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getAllSendAttempts(subscriptionId: string | undefined, maxResultCount: number | undefined, skipCount: number | undefined): Observable<PagedResultDtoOfGetAllSendAttemptsOutput> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSendAttempt/GetAllSendAttempts?";
        if (subscriptionId === null)
            throw new Error("The parameter 'subscriptionId' cannot be null.");
        else if (subscriptionId !== undefined)
            url_ += "SubscriptionId=" + encodeURIComponent("" + subscriptionId) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSendAttempts(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSendAttempts(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetAllSendAttemptsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetAllSendAttemptsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSendAttempts(response: HttpResponseBase): Observable<PagedResultDtoOfGetAllSendAttemptsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetAllSendAttemptsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetAllSendAttemptsOutput>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    getAllSendAttemptsOfWebhookEvent(id: string | undefined): Observable<ListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSendAttempt/GetAllSendAttemptsOfWebhookEvent?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSendAttemptsOfWebhookEvent(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSendAttemptsOfWebhookEvent(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSendAttemptsOfWebhookEvent(response: HttpResponseBase): Observable<ListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput>(<any>null);
    }

    /**
     * @param sendAttemptId (optional) 
     * @return Success
     */
    resend(sendAttemptId: string | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSendAttempt/Resend?";
        if (sendAttemptId === null)
            throw new Error("The parameter 'sendAttemptId' cannot be null.");
        else if (sendAttemptId !== undefined)
            url_ += "sendAttemptId=" + encodeURIComponent("" + sendAttemptId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processResend(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processResend(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processResend(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

@Injectable()
export class WebhookSubscriptionServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    publishTestWebhook(): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSubscription/PublishTestWebhook";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processPublishTestWebhook(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processPublishTestWebhook(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processPublishTestWebhook(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    getAllSubscriptions(): Observable<ListResultDtoOfGetAllSubscriptionsOutput> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSubscription/GetAllSubscriptions";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSubscriptions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSubscriptions(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetAllSubscriptionsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetAllSubscriptionsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSubscriptions(response: HttpResponseBase): Observable<ListResultDtoOfGetAllSubscriptionsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetAllSubscriptionsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetAllSubscriptionsOutput>(<any>null);
    }

    /**
     * @param subscriptionId (optional) 
     * @return Success
     */
    getSubscription(subscriptionId: string | undefined): Observable<WebhookSubscription> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSubscription/GetSubscription?";
        if (subscriptionId === null)
            throw new Error("The parameter 'subscriptionId' cannot be null.");
        else if (subscriptionId !== undefined)
            url_ += "subscriptionId=" + encodeURIComponent("" + subscriptionId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetSubscription(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetSubscription(<any>response_);
                } catch (e) {
                    return <Observable<WebhookSubscription>><any>_observableThrow(e);
                }
            } else
                return <Observable<WebhookSubscription>><any>_observableThrow(response_);
        }));
    }

    protected processGetSubscription(response: HttpResponseBase): Observable<WebhookSubscription> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = WebhookSubscription.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<WebhookSubscription>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    addSubscription(body: WebhookSubscription | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSubscription/AddSubscription";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processAddSubscription(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processAddSubscription(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processAddSubscription(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateSubscription(body: WebhookSubscription | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSubscription/UpdateSubscription";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateSubscription(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateSubscription(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateSubscription(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    activateWebhookSubscription(body: ActivateWebhookSubscriptionInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSubscription/ActivateWebhookSubscription";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processActivateWebhookSubscription(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processActivateWebhookSubscription(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processActivateWebhookSubscription(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param webhookName (optional) 
     * @return Success
     */
    isSubscribed(webhookName: string | undefined): Observable<boolean> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSubscription/IsSubscribed?";
        if (webhookName === null)
            throw new Error("The parameter 'webhookName' cannot be null.");
        else if (webhookName !== undefined)
            url_ += "webhookName=" + encodeURIComponent("" + webhookName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processIsSubscribed(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processIsSubscribed(<any>response_);
                } catch (e) {
                    return <Observable<boolean>><any>_observableThrow(e);
                }
            } else
                return <Observable<boolean>><any>_observableThrow(response_);
        }));
    }

    protected processIsSubscribed(response: HttpResponseBase): Observable<boolean> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<boolean>(<any>null);
    }

    /**
     * @param webhookName (optional) 
     * @return Success
     */
    getAllSubscriptionsIfFeaturesGranted(webhookName: string | undefined): Observable<ListResultDtoOfGetAllSubscriptionsOutput> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSubscription/GetAllSubscriptionsIfFeaturesGranted?";
        if (webhookName === null)
            throw new Error("The parameter 'webhookName' cannot be null.");
        else if (webhookName !== undefined)
            url_ += "webhookName=" + encodeURIComponent("" + webhookName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllSubscriptionsIfFeaturesGranted(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllSubscriptionsIfFeaturesGranted(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetAllSubscriptionsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetAllSubscriptionsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllSubscriptionsIfFeaturesGranted(response: HttpResponseBase): Observable<ListResultDtoOfGetAllSubscriptionsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetAllSubscriptionsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetAllSubscriptionsOutput>(<any>null);
    }

    /**
     * @return Success
     */
    getAllAvailableWebhooks(): Observable<ListResultDtoOfGetAllAvailableWebhooksOutput> {
        let url_ = this.baseUrl + "/api/services/app/WebhookSubscription/GetAllAvailableWebhooks";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllAvailableWebhooks(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllAvailableWebhooks(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfGetAllAvailableWebhooksOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfGetAllAvailableWebhooksOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllAvailableWebhooks(response: HttpResponseBase): Observable<ListResultDtoOfGetAllAvailableWebhooksOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfGetAllAvailableWebhooksOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfGetAllAvailableWebhooksOutput>(<any>null);
    }
}

@Injectable()
export class WebLogServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @return Success
     */
    getLatestWebLogs(): Observable<GetLatestWebLogsOutput> {
        let url_ = this.baseUrl + "/api/services/app/WebLog/GetLatestWebLogs";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetLatestWebLogs(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetLatestWebLogs(<any>response_);
                } catch (e) {
                    return <Observable<GetLatestWebLogsOutput>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetLatestWebLogsOutput>><any>_observableThrow(response_);
        }));
    }

    protected processGetLatestWebLogs(response: HttpResponseBase): Observable<GetLatestWebLogsOutput> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetLatestWebLogsOutput.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetLatestWebLogsOutput>(<any>null);
    }

    /**
     * @return Success
     */
    downloadWebLogs(): Observable<FileDto> {
        let url_ = this.baseUrl + "/api/services/app/WebLog/DownloadWebLogs";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDownloadWebLogs(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDownloadWebLogs(<any>response_);
                } catch (e) {
                    return <Observable<FileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<FileDto>><any>_observableThrow(response_);
        }));
    }

    protected processDownloadWebLogs(response: HttpResponseBase): Observable<FileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = FileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<FileDto>(<any>null);
    }
}

@Injectable()
export class WillCallServiceServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param filter (optional) 
     * @param clinicId (optional) 
     * @return Success
     */
    getClinicForCallback(filter: string | undefined, clinicId: number | undefined): Observable<GetClinicResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetClinicForCallback?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "clinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicForCallback(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicForCallback(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicForCallback(response: HttpResponseBase): Observable<GetClinicResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetClinicResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicResultDto[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param clinicId (optional) 
     * @return Success
     */
    getClinicByAccountNumber(filter: string | undefined, clinicId: number | undefined): Observable<GetClinicResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetClinicByAccountNumber?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "clinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicByAccountNumber(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicByAccountNumber(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicByAccountNumber(response: HttpResponseBase): Observable<GetClinicResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetClinicResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicResultDto[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param clinicId (optional) 
     * @return Success
     */
    getClinicByClinicName(filter: string | undefined, clinicId: number | undefined): Observable<GetClinicResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetClinicByClinicName?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "clinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicByClinicName(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicByClinicName(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicByClinicName(response: HttpResponseBase): Observable<GetClinicResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetClinicResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicResultDto[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param clinicId (optional) 
     * @return Success
     */
    getClinicByClinicAddress(filter: string | undefined, clinicId: number | undefined): Observable<GetClinicResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetClinicByClinicAddress?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "clinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicByClinicAddress(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicByClinicAddress(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicByClinicAddress(response: HttpResponseBase): Observable<GetClinicResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetClinicResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicResultDto[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param clinicId (optional) 
     * @return Success
     */
    getClinicByOrderId(filter: string | undefined, clinicId: number | undefined): Observable<GetOrderResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetClinicByOrderId?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "clinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicByOrderId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicByOrderId(<any>response_);
                } catch (e) {
                    return <Observable<GetOrderResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetOrderResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicByOrderId(response: HttpResponseBase): Observable<GetOrderResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetOrderResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetOrderResultDto[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param clinicId (optional) 
     * @return Success
     */
    getClinicDetails(filter: string | undefined, clinicId: number | undefined): Observable<GetClinicResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetClinicDetails?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "clinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicDetails(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicDetails(response: HttpResponseBase): Observable<GetClinicResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetClinicResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicResultDto[]>(<any>null);
    }

    /**
     * @param clinicId (optional) 
     * @param filterText (optional) 
     * @param user (optional) 
     * @param status (optional) 
     * @param dateFrom (optional) 
     * @param dateTo (optional) 
     * @param orderTypeId (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getHistory(clinicId: number | undefined, filterText: string | undefined, user: string | undefined, status: number | undefined, dateFrom: moment.Moment | undefined, dateTo: moment.Moment | undefined, orderTypeId: number | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<GetHistoryResultDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetHistory?";
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "ClinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        if (filterText === null)
            throw new Error("The parameter 'filterText' cannot be null.");
        else if (filterText !== undefined)
            url_ += "FilterText=" + encodeURIComponent("" + filterText) + "&"; 
        if (user === null)
            throw new Error("The parameter 'user' cannot be null.");
        else if (user !== undefined)
            url_ += "User=" + encodeURIComponent("" + user) + "&"; 
        if (status === null)
            throw new Error("The parameter 'status' cannot be null.");
        else if (status !== undefined)
            url_ += "Status=" + encodeURIComponent("" + status) + "&"; 
        if (dateFrom === null)
            throw new Error("The parameter 'dateFrom' cannot be null.");
        else if (dateFrom !== undefined)
            url_ += "DateFrom=" + encodeURIComponent(dateFrom ? "" + dateFrom.toJSON() : "") + "&"; 
        if (dateTo === null)
            throw new Error("The parameter 'dateTo' cannot be null.");
        else if (dateTo !== undefined)
            url_ += "DateTo=" + encodeURIComponent(dateTo ? "" + dateTo.toJSON() : "") + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetHistory(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetHistory(<any>response_);
                } catch (e) {
                    return <Observable<GetHistoryResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetHistoryResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetHistory(response: HttpResponseBase): Observable<GetHistoryResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetHistoryResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetHistoryResultDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @return Success
     */
    getRouteCodeDriver(orderId: number | undefined): Observable<string> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetRouteCodeDriver?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteCodeDriver(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteCodeDriver(<any>response_);
                } catch (e) {
                    return <Observable<string>><any>_observableThrow(e);
                }
            } else
                return <Observable<string>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteCodeDriver(response: HttpResponseBase): Observable<string> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<string>(<any>null);
    }

    /**
     * @return Success
     */
    getPackageListOptions(): Observable<ShippingPackageListDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetPackageListOptions";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetPackageListOptions(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetPackageListOptions(<any>response_);
                } catch (e) {
                    return <Observable<ShippingPackageListDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<ShippingPackageListDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetPackageListOptions(response: HttpResponseBase): Observable<ShippingPackageListDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(ShippingPackageListDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ShippingPackageListDto[]>(<any>null);
    }

    /**
     * @param filter (optional) 
     * @param clinicId (optional) 
     * @return Success
     */
    getClinicForCallBackWithId(filter: string | undefined, clinicId: number | undefined): Observable<GetClinicResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetClinicForCallBackWithId?";
        if (filter === null)
            throw new Error("The parameter 'filter' cannot be null.");
        else if (filter !== undefined)
            url_ += "Filter=" + encodeURIComponent("" + filter) + "&"; 
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "clinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicForCallBackWithId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicForCallBackWithId(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicForCallBackWithId(response: HttpResponseBase): Observable<GetClinicResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetClinicResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicResultDto[]>(<any>null);
    }

    /**
     * @param clinicId (optional) 
     * @param routeDate (optional) 
     * @return Success
     */
    getRouteByClinic(clinicId: number | undefined, routeDate: moment.Moment | undefined): Observable<GetRouteByClinicResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetRouteByClinic?";
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "ClinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        if (routeDate === null)
            throw new Error("The parameter 'routeDate' cannot be null.");
        else if (routeDate !== undefined)
            url_ += "RouteDate=" + encodeURIComponent(routeDate ? "" + routeDate.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteByClinic(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteByClinic(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteByClinicResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteByClinicResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteByClinic(response: HttpResponseBase): Observable<GetRouteByClinicResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetRouteByClinicResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteByClinicResultDto[]>(<any>null);
    }

    /**
     * @param clinicId (optional) 
     * @param routeDate (optional) 
     * @param routeCode (optional) 
     * @param locationId (optional) 
     * @return Success
     */
    getRouteCutOffValidation(clinicId: number | undefined, routeDate: moment.Moment | undefined, routeCode: string | undefined, locationId: number | undefined): Observable<GetCallBackRouteDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetRouteCutOffValidation?";
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "ClinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        if (routeDate === null)
            throw new Error("The parameter 'routeDate' cannot be null.");
        else if (routeDate !== undefined)
            url_ += "RouteDate=" + encodeURIComponent(routeDate ? "" + routeDate.toJSON() : "") + "&"; 
        if (routeCode === null)
            throw new Error("The parameter 'routeCode' cannot be null.");
        else if (routeCode !== undefined)
            url_ += "RouteCode=" + encodeURIComponent("" + routeCode) + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteCutOffValidation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteCutOffValidation(<any>response_);
                } catch (e) {
                    return <Observable<GetCallBackRouteDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetCallBackRouteDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteCutOffValidation(response: HttpResponseBase): Observable<GetCallBackRouteDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetCallBackRouteDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetCallBackRouteDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createCallback(body: CreateCallbackInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/CreateCallback";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateCallback(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateCallback(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateCallback(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param accountNumber (optional) 
     * @param testMode (optional) 
     * @return Success
     */
    getClinicSchedule(accountNumber: string | undefined, testMode: boolean | undefined): Observable<GetClinicScheduleResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetClinicSchedule?";
        if (accountNumber === null)
            throw new Error("The parameter 'accountNumber' cannot be null.");
        else if (accountNumber !== undefined)
            url_ += "AccountNumber=" + encodeURIComponent("" + accountNumber) + "&"; 
        if (testMode === null)
            throw new Error("The parameter 'testMode' cannot be null.");
        else if (testMode !== undefined)
            url_ += "TestMode=" + encodeURIComponent("" + testMode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicSchedule(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicScheduleResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicScheduleResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicSchedule(response: HttpResponseBase): Observable<GetClinicScheduleResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetClinicScheduleResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicScheduleResultDto[]>(<any>null);
    }

    /**
     * @param clinicId (optional) 
     * @param accountNumber (optional) 
     * @param routeDate (optional) 
     * @param locationId (optional) 
     * @param designation (optional) 
     * @param isCancel (optional) 
     * @param testMode (optional) 
     * @return Success
     */
    getRoutesAutoSchedule(clinicId: number | undefined, accountNumber: string | undefined, routeDate: moment.Moment | undefined, locationId: number | undefined, designation: boolean | undefined, isCancel: boolean | undefined, testMode: boolean | undefined): Observable<GetClinicSchedResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetRoutesAutoSchedule?";
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "ClinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        if (accountNumber === null)
            throw new Error("The parameter 'accountNumber' cannot be null.");
        else if (accountNumber !== undefined)
            url_ += "AccountNumber=" + encodeURIComponent("" + accountNumber) + "&"; 
        if (routeDate === null)
            throw new Error("The parameter 'routeDate' cannot be null.");
        else if (routeDate !== undefined)
            url_ += "RouteDate=" + encodeURIComponent(routeDate ? "" + routeDate.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (designation === null)
            throw new Error("The parameter 'designation' cannot be null.");
        else if (designation !== undefined)
            url_ += "Designation=" + encodeURIComponent("" + designation) + "&"; 
        if (isCancel === null)
            throw new Error("The parameter 'isCancel' cannot be null.");
        else if (isCancel !== undefined)
            url_ += "IsCancel=" + encodeURIComponent("" + isCancel) + "&"; 
        if (testMode === null)
            throw new Error("The parameter 'testMode' cannot be null.");
        else if (testMode !== undefined)
            url_ += "TestMode=" + encodeURIComponent("" + testMode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoutesAutoSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoutesAutoSchedule(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicSchedResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicSchedResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoutesAutoSchedule(response: HttpResponseBase): Observable<GetClinicSchedResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetClinicSchedResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicSchedResultDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    saveNote(body: SaveNotesInput | undefined): Observable<SaveNoteResultDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/SaveNote";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processSaveNote(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processSaveNote(<any>response_);
                } catch (e) {
                    return <Observable<SaveNoteResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<SaveNoteResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processSaveNote(response: HttpResponseBase): Observable<SaveNoteResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = SaveNoteResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<SaveNoteResultDto>(<any>null);
    }

    /**
     * @param value (optional) 
     * @param dateTimeUTC (optional) 
     * @return Success
     */
    getUtcOffset(value: string | undefined, dateTimeUTC: moment.Moment | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetUtcOffset?";
        if (value === null)
            throw new Error("The parameter 'value' cannot be null.");
        else if (value !== undefined)
            url_ += "value=" + encodeURIComponent("" + value) + "&"; 
        if (dateTimeUTC === null)
            throw new Error("The parameter 'dateTimeUTC' cannot be null.");
        else if (dateTimeUTC !== undefined)
            url_ += "dateTimeUTC=" + encodeURIComponent(dateTimeUTC ? "" + dateTimeUTC.toJSON() : "") + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetUtcOffset(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetUtcOffset(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processGetUtcOffset(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param clinicId (optional) 
     * @param accountNumber (optional) 
     * @param routeDate (optional) 
     * @param locationId (optional) 
     * @param designation (optional) 
     * @param isCancel (optional) 
     * @param testMode (optional) 
     * @return Success
     */
    getRoutesSchedule(clinicId: number | undefined, accountNumber: string | undefined, routeDate: moment.Moment | undefined, locationId: number | undefined, designation: boolean | undefined, isCancel: boolean | undefined, testMode: boolean | undefined): Observable<GetClinicSchedResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetRoutesSchedule?";
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "ClinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        if (accountNumber === null)
            throw new Error("The parameter 'accountNumber' cannot be null.");
        else if (accountNumber !== undefined)
            url_ += "AccountNumber=" + encodeURIComponent("" + accountNumber) + "&"; 
        if (routeDate === null)
            throw new Error("The parameter 'routeDate' cannot be null.");
        else if (routeDate !== undefined)
            url_ += "RouteDate=" + encodeURIComponent(routeDate ? "" + routeDate.toJSON() : "") + "&"; 
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (designation === null)
            throw new Error("The parameter 'designation' cannot be null.");
        else if (designation !== undefined)
            url_ += "Designation=" + encodeURIComponent("" + designation) + "&"; 
        if (isCancel === null)
            throw new Error("The parameter 'isCancel' cannot be null.");
        else if (isCancel !== undefined)
            url_ += "IsCancel=" + encodeURIComponent("" + isCancel) + "&"; 
        if (testMode === null)
            throw new Error("The parameter 'testMode' cannot be null.");
        else if (testMode !== undefined)
            url_ += "TestMode=" + encodeURIComponent("" + testMode) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRoutesSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRoutesSchedule(<any>response_);
                } catch (e) {
                    return <Observable<GetClinicSchedResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetClinicSchedResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetRoutesSchedule(response: HttpResponseBase): Observable<GetClinicSchedResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetClinicSchedResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetClinicSchedResultDto[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createClinicSchedule(body: CreateClinicScheduleInput | undefined): Observable<CreateClinicScheduleResultDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/CreateClinicSchedule";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateClinicSchedule(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateClinicSchedule(<any>response_);
                } catch (e) {
                    return <Observable<CreateClinicScheduleResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateClinicScheduleResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateClinicSchedule(response: HttpResponseBase): Observable<CreateClinicScheduleResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateClinicScheduleResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateClinicScheduleResultDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createOrder(body: CreateCallinInput | undefined): Observable<CreateCallInResultDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/CreateOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateOrder(<any>response_);
                } catch (e) {
                    return <Observable<CreateCallInResultDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<CreateCallInResultDto>><any>_observableThrow(response_);
        }));
    }

    protected processCreateOrder(response: HttpResponseBase): Observable<CreateCallInResultDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = CreateCallInResultDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<CreateCallInResultDto>(<any>null);
    }

    /**
     * @param clinicId (optional) 
     * @param filterText (optional) 
     * @param user (optional) 
     * @param status (optional) 
     * @param dateFrom (optional) 
     * @param dateTo (optional) 
     * @param orderTypeId (optional) 
     * @return Success
     */
    getClinicHistoryToExcel(clinicId: number | undefined, filterText: string | undefined, user: string | undefined, status: number | undefined, dateFrom: moment.Moment | undefined, dateTo: moment.Moment | undefined, orderTypeId: number | undefined): Observable<ExportFileDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetClinicHistoryToExcel?";
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "ClinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        if (filterText === null)
            throw new Error("The parameter 'filterText' cannot be null.");
        else if (filterText !== undefined)
            url_ += "FilterText=" + encodeURIComponent("" + filterText) + "&"; 
        if (user === null)
            throw new Error("The parameter 'user' cannot be null.");
        else if (user !== undefined)
            url_ += "User=" + encodeURIComponent("" + user) + "&"; 
        if (status === null)
            throw new Error("The parameter 'status' cannot be null.");
        else if (status !== undefined)
            url_ += "Status=" + encodeURIComponent("" + status) + "&"; 
        if (dateFrom === null)
            throw new Error("The parameter 'dateFrom' cannot be null.");
        else if (dateFrom !== undefined)
            url_ += "DateFrom=" + encodeURIComponent(dateFrom ? "" + dateFrom.toJSON() : "") + "&"; 
        if (dateTo === null)
            throw new Error("The parameter 'dateTo' cannot be null.");
        else if (dateTo !== undefined)
            url_ += "DateTo=" + encodeURIComponent(dateTo ? "" + dateTo.toJSON() : "") + "&"; 
        if (orderTypeId === null)
            throw new Error("The parameter 'orderTypeId' cannot be null.");
        else if (orderTypeId !== undefined)
            url_ += "OrderTypeId=" + encodeURIComponent("" + orderTypeId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetClinicHistoryToExcel(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetClinicHistoryToExcel(<any>response_);
                } catch (e) {
                    return <Observable<ExportFileDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ExportFileDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetClinicHistoryToExcel(response: HttpResponseBase): Observable<ExportFileDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ExportFileDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ExportFileDto>(<any>null);
    }

    /**
     * @param orderId (optional) 
     * @param contactId (optional) 
     * @return Success
     */
    getModalMissedPickUp(orderId: number | undefined, contactId: number | undefined): Observable<GetModalMissedPickUpResult> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetModalMissedPickUp?";
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        if (contactId === null)
            throw new Error("The parameter 'contactId' cannot be null.");
        else if (contactId !== undefined)
            url_ += "ContactId=" + encodeURIComponent("" + contactId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetModalMissedPickUp(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetModalMissedPickUp(<any>response_);
                } catch (e) {
                    return <Observable<GetModalMissedPickUpResult>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetModalMissedPickUpResult>><any>_observableThrow(response_);
        }));
    }

    protected processGetModalMissedPickUp(response: HttpResponseBase): Observable<GetModalMissedPickUpResult> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetModalMissedPickUpResult.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetModalMissedPickUpResult>(<any>null);
    }

    /**
     * @return Success
     */
    getManagers(): Observable<GetManagerResult[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetManagers";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetManagers(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetManagers(<any>response_);
                } catch (e) {
                    return <Observable<GetManagerResult[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetManagerResult[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetManagers(response: HttpResponseBase): Observable<GetManagerResult[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetManagerResult.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetManagerResult[]>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createMissedPickup(body: CreateOrderIncidentDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/CreateMissedPickup";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateMissedPickup(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateMissedPickup(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateMissedPickup(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createEmailConfirmation(body: GetEmailConfirmationDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/CreateEmailConfirmation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateEmailConfirmation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateEmailConfirmation(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateEmailConfirmation(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param clinicId (optional) 
     * @param orderId (optional) 
     * @return Success
     */
    getGoBackDetails(clinicId: number | undefined, orderId: number | undefined): Observable<GoBackDetails> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetGoBackDetails?";
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "ClinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        if (orderId === null)
            throw new Error("The parameter 'orderId' cannot be null.");
        else if (orderId !== undefined)
            url_ += "OrderId=" + encodeURIComponent("" + orderId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetGoBackDetails(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetGoBackDetails(<any>response_);
                } catch (e) {
                    return <Observable<GoBackDetails>><any>_observableThrow(e);
                }
            } else
                return <Observable<GoBackDetails>><any>_observableThrow(response_);
        }));
    }

    protected processGetGoBackDetails(response: HttpResponseBase): Observable<GoBackDetails> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GoBackDetails.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GoBackDetails>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createGoBackOrder(body: CreateGoBackOrder | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/CreateGoBackOrder";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateGoBackOrder(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateGoBackOrder(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processCreateGoBackOrder(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param dateFrom (optional) 
     * @param dateTo (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @param maxResultCount (optional) 
     * @return Success
     */
    getIncidents(dateFrom: moment.Moment | undefined, dateTo: moment.Moment | undefined, sorting: string | undefined, skipCount: number | undefined, maxResultCount: number | undefined): Observable<PagedResultDtoOfGetIncidentsResultsDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetIncidents?";
        if (dateFrom === null)
            throw new Error("The parameter 'dateFrom' cannot be null.");
        else if (dateFrom !== undefined)
            url_ += "DateFrom=" + encodeURIComponent(dateFrom ? "" + dateFrom.toJSON() : "") + "&"; 
        if (dateTo === null)
            throw new Error("The parameter 'dateTo' cannot be null.");
        else if (dateTo !== undefined)
            url_ += "DateTo=" + encodeURIComponent(dateTo ? "" + dateTo.toJSON() : "") + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetIncidents(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetIncidents(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfGetIncidentsResultsDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfGetIncidentsResultsDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetIncidents(response: HttpResponseBase): Observable<PagedResultDtoOfGetIncidentsResultsDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfGetIncidentsResultsDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfGetIncidentsResultsDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    showClinicsListByAccountNumber(body: GetClinicInputForWillCall | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/showClinicsListByAccountNumber";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processShowClinicsListByAccountNumber(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processShowClinicsListByAccountNumber(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processShowClinicsListByAccountNumber(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    showClinicsListByOrderId(body: GetClinicInputForWillCall | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/ShowClinicsListByOrderId";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processShowClinicsListByOrderId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processShowClinicsListByOrderId(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processShowClinicsListByOrderId(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    showClinicsList(body: GetClinicInputForWillCall | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/ShowClinicsList";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processShowClinicsList(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processShowClinicsList(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processShowClinicsList(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param clinicId (optional) 
     * @return Success
     */
    getAutomaticSchedules(clinicId: number | undefined): Observable<GetAutomaticSchedulesResultDto[]> {
        let url_ = this.baseUrl + "/api/services/app/WillCallService/GetAutomaticSchedules?";
        if (clinicId === null)
            throw new Error("The parameter 'clinicId' cannot be null.");
        else if (clinicId !== undefined)
            url_ += "ClinicId=" + encodeURIComponent("" + clinicId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAutomaticSchedules(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAutomaticSchedules(<any>response_);
                } catch (e) {
                    return <Observable<GetAutomaticSchedulesResultDto[]>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetAutomaticSchedulesResultDto[]>><any>_observableThrow(response_);
        }));
    }

    protected processGetAutomaticSchedules(response: HttpResponseBase): Observable<GetAutomaticSchedulesResultDto[]> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            if (Array.isArray(resultData200)) {
                result200 = [] as any;
                for (let item of resultData200)
                    result200!.push(GetAutomaticSchedulesResultDto.fromJS(item));
            }
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetAutomaticSchedulesResultDto[]>(<any>null);
    }
}

@Injectable()
export class ZoneServiceProxy {
    private http: HttpClient;
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(@Inject(HttpClient) http: HttpClient, @Optional() @Inject(API_BASE_URL) baseUrl?: string) {
        this.http = http;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    /**
     * @param routeTemplateId (optional) 
     * @return Success
     */
    getRouteTemplateZone(routeTemplateId: number | undefined): Observable<GetRouteTemplateZoneForViewDto> {
        let url_ = this.baseUrl + "/api/services/app/Zone/GetRouteTemplateZone?";
        if (routeTemplateId === null)
            throw new Error("The parameter 'routeTemplateId' cannot be null.");
        else if (routeTemplateId !== undefined)
            url_ += "RouteTemplateId=" + encodeURIComponent("" + routeTemplateId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetRouteTemplateZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetRouteTemplateZone(<any>response_);
                } catch (e) {
                    return <Observable<GetRouteTemplateZoneForViewDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<GetRouteTemplateZoneForViewDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetRouteTemplateZone(response: HttpResponseBase): Observable<GetRouteTemplateZoneForViewDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = GetRouteTemplateZoneForViewDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<GetRouteTemplateZoneForViewDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    showPagedZones(body: GetAllZoneInput | undefined): Observable<PagedResultDtoOfNameValueDto> {
        let url_ = this.baseUrl + "/api/services/app/Zone/showPagedZones";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processShowPagedZones(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processShowPagedZones(<any>response_);
                } catch (e) {
                    return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<PagedResultDtoOfNameValueDto>><any>_observableThrow(response_);
        }));
    }

    protected processShowPagedZones(response: HttpResponseBase): Observable<PagedResultDtoOfNameValueDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = PagedResultDtoOfNameValueDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<PagedResultDtoOfNameValueDto>(<any>null);
    }

    /**
     * @param id (optional) 
     * @param name (optional) 
     * @param currentPage (optional) 
     * @param maxResultCount (optional) 
     * @param sorting (optional) 
     * @param skipCount (optional) 
     * @return Success
     */
    getZone(id: number | undefined, name: string | undefined, currentPage: number | undefined, maxResultCount: number | undefined, sorting: string | undefined, skipCount: number | undefined): Observable<ListResultDtoOfZoneListDto> {
        let url_ = this.baseUrl + "/api/services/app/Zone/GetZone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        if (name === null)
            throw new Error("The parameter 'name' cannot be null.");
        else if (name !== undefined)
            url_ += "Name=" + encodeURIComponent("" + name) + "&"; 
        if (currentPage === null)
            throw new Error("The parameter 'currentPage' cannot be null.");
        else if (currentPage !== undefined)
            url_ += "CurrentPage=" + encodeURIComponent("" + currentPage) + "&"; 
        if (maxResultCount === null)
            throw new Error("The parameter 'maxResultCount' cannot be null.");
        else if (maxResultCount !== undefined)
            url_ += "MaxResultCount=" + encodeURIComponent("" + maxResultCount) + "&"; 
        if (sorting === null)
            throw new Error("The parameter 'sorting' cannot be null.");
        else if (sorting !== undefined)
            url_ += "Sorting=" + encodeURIComponent("" + sorting) + "&"; 
        if (skipCount === null)
            throw new Error("The parameter 'skipCount' cannot be null.");
        else if (skipCount !== undefined)
            url_ += "SkipCount=" + encodeURIComponent("" + skipCount) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetZone(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfZoneListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfZoneListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetZone(response: HttpResponseBase): Observable<ListResultDtoOfZoneListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfZoneListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfZoneListDto>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createZone(body: CreateZoneInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Zone/CreateZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateZone(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateZone(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createZoneLocation(body: CreateZoneLocationInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Zone/CreateZoneLocation";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateZoneLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateZoneLocation(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateZoneLocation(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    createZoneLocationReturnZoneId(body: CreateZoneLocationInput | undefined): Observable<number> {
        let url_ = this.baseUrl + "/api/services/app/Zone/CreateZoneLocationReturnZoneId";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
                "Accept": "text/plain"
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processCreateZoneLocationReturnZoneId(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processCreateZoneLocationReturnZoneId(<any>response_);
                } catch (e) {
                    return <Observable<number>><any>_observableThrow(e);
                }
            } else
                return <Observable<number>><any>_observableThrow(response_);
        }));
    }

    protected processCreateZoneLocationReturnZoneId(response: HttpResponseBase): Observable<number> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = resultData200 !== undefined ? resultData200 : <any>null;
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<number>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    updateZone(body: UpdateZoneInput | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Zone/UpdateZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("put", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processUpdateZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processUpdateZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processUpdateZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @param id (optional) 
     * @return Success
     */
    deleteZone(id: number | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Zone/DeleteZone?";
        if (id === null)
            throw new Error("The parameter 'id' cannot be null.");
        else if (id !== undefined)
            url_ += "Id=" + encodeURIComponent("" + id) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
            })
        };

        return this.http.request("delete", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processDeleteZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processDeleteZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processDeleteZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }

    /**
     * @return Success
     */
    getAllZone(): Observable<ListResultDtoOfZoneListDto> {
        let url_ = this.baseUrl + "/api/services/app/Zone/GetAllZone";
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllZone(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfZoneListDto>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfZoneListDto>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllZone(response: HttpResponseBase): Observable<ListResultDtoOfZoneListDto> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfZoneListDto.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfZoneListDto>(<any>null);
    }

    /**
     * @param locationId (optional) 
     * @param zoneName (optional) 
     * @return Success
     */
    getAllZonesByLocation(locationId: number | undefined, zoneName: string | undefined): Observable<ListResultDtoOfZoneLocationZoneList> {
        let url_ = this.baseUrl + "/api/services/app/Zone/GetAllZonesByLocation?";
        if (locationId === null)
            throw new Error("The parameter 'locationId' cannot be null.");
        else if (locationId !== undefined)
            url_ += "LocationId=" + encodeURIComponent("" + locationId) + "&"; 
        if (zoneName === null)
            throw new Error("The parameter 'zoneName' cannot be null.");
        else if (zoneName !== undefined)
            url_ += "ZoneName=" + encodeURIComponent("" + zoneName) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ : any = {
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Accept": "text/plain"
            })
        };

        return this.http.request("get", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processGetAllZonesByLocation(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processGetAllZonesByLocation(<any>response_);
                } catch (e) {
                    return <Observable<ListResultDtoOfZoneLocationZoneList>><any>_observableThrow(e);
                }
            } else
                return <Observable<ListResultDtoOfZoneLocationZoneList>><any>_observableThrow(response_);
        }));
    }

    protected processGetAllZonesByLocation(response: HttpResponseBase): Observable<ListResultDtoOfZoneLocationZoneList> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            let result200: any = null;
            let resultData200 = _responseText === "" ? null : JSON.parse(_responseText, this.jsonParseReviver);
            result200 = ListResultDtoOfZoneLocationZoneList.fromJS(resultData200);
            return _observableOf(result200);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<ListResultDtoOfZoneLocationZoneList>(<any>null);
    }

    /**
     * @param body (optional) 
     * @return Success
     */
    importLocationZone(body: ZoneLocationImportDto | undefined): Observable<void> {
        let url_ = this.baseUrl + "/api/services/app/Zone/ImportLocationZone";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(body);

        let options_ : any = {
            body: content_,
            observe: "response",
            responseType: "blob",
            headers: new HttpHeaders({
                "Content-Type": "application/json-patch+json", 
            })
        };

        return this.http.request("post", url_, options_).pipe(_observableMergeMap((response_ : any) => {
            return this.processImportLocationZone(response_);
        })).pipe(_observableCatch((response_: any) => {
            if (response_ instanceof HttpResponseBase) {
                try {
                    return this.processImportLocationZone(<any>response_);
                } catch (e) {
                    return <Observable<void>><any>_observableThrow(e);
                }
            } else
                return <Observable<void>><any>_observableThrow(response_);
        }));
    }

    protected processImportLocationZone(response: HttpResponseBase): Observable<void> {
        const status = response.status;
        const responseBlob = 
            response instanceof HttpResponse ? response.body : 
            (<any>response).error instanceof Blob ? (<any>response).error : undefined;

        let _headers: any = {}; if (response.headers) { for (let key of response.headers.keys()) { _headers[key] = response.headers.get(key); }};
        if (status === 200) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return _observableOf<void>(<any>null);
            }));
        } else if (status !== 200 && status !== 204) {
            return blobToText(responseBlob).pipe(_observableMergeMap(_responseText => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            }));
        }
        return _observableOf<void>(<any>null);
    }
}

export class IsTenantAvailableInput implements IIsTenantAvailableInput {
    tenancyName!: string;

    constructor(data?: IIsTenantAvailableInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
        }
    }

    static fromJS(data: any): IsTenantAvailableInput {
        data = typeof data === 'object' ? data : {};
        let result = new IsTenantAvailableInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        return data; 
    }
}

export interface IIsTenantAvailableInput {
    tenancyName: string;
}

export enum TenantAvailabilityState {
    Available = 1,
    InActive = 2,
    NotFound = 3,
}

export class IsTenantAvailableOutput implements IIsTenantAvailableOutput {
    state!: TenantAvailabilityState;
    tenantId!: number | undefined;
    serverRootAddress!: string | undefined;
    reportServer!: string | undefined;

    constructor(data?: IIsTenantAvailableOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.state = data["state"];
            this.tenantId = data["tenantId"];
            this.serverRootAddress = data["serverRootAddress"];
            this.reportServer = data["reportServer"];
        }
    }

    static fromJS(data: any): IsTenantAvailableOutput {
        data = typeof data === 'object' ? data : {};
        let result = new IsTenantAvailableOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["state"] = this.state;
        data["tenantId"] = this.tenantId;
        data["serverRootAddress"] = this.serverRootAddress;
        data["reportServer"] = this.reportServer;
        return data; 
    }
}

export interface IIsTenantAvailableOutput {
    state: TenantAvailabilityState;
    tenantId: number | undefined;
    serverRootAddress: string | undefined;
    reportServer: string | undefined;
}

export class ResolveTenantIdInput implements IResolveTenantIdInput {
    c!: string | undefined;

    constructor(data?: IResolveTenantIdInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.c = data["c"];
        }
    }

    static fromJS(data: any): ResolveTenantIdInput {
        data = typeof data === 'object' ? data : {};
        let result = new ResolveTenantIdInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["c"] = this.c;
        return data; 
    }
}

export interface IResolveTenantIdInput {
    c: string | undefined;
}

export class RegisterInput implements IRegisterInput {
    name!: string;
    surname!: string;
    userName!: string;
    emailAddress!: string;
    password!: string;
    captchaResponse!: string | undefined;

    constructor(data?: IRegisterInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.surname = data["surname"];
            this.userName = data["userName"];
            this.emailAddress = data["emailAddress"];
            this.password = data["password"];
            this.captchaResponse = data["captchaResponse"];
        }
    }

    static fromJS(data: any): RegisterInput {
        data = typeof data === 'object' ? data : {};
        let result = new RegisterInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["userName"] = this.userName;
        data["emailAddress"] = this.emailAddress;
        data["password"] = this.password;
        data["captchaResponse"] = this.captchaResponse;
        return data; 
    }
}

export interface IRegisterInput {
    name: string;
    surname: string;
    userName: string;
    emailAddress: string;
    password: string;
    captchaResponse: string | undefined;
}

export class RegisterOutput implements IRegisterOutput {
    canLogin!: boolean;
    userId!: number;

    constructor(data?: IRegisterOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.canLogin = data["canLogin"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): RegisterOutput {
        data = typeof data === 'object' ? data : {};
        let result = new RegisterOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["canLogin"] = this.canLogin;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IRegisterOutput {
    canLogin: boolean;
    userId: number;
}

export class SendPasswordResetCodeInput implements ISendPasswordResetCodeInput {
    emailAddress!: string;

    constructor(data?: ISendPasswordResetCodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.emailAddress = data["emailAddress"];
        }
    }

    static fromJS(data: any): SendPasswordResetCodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new SendPasswordResetCodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["emailAddress"] = this.emailAddress;
        return data; 
    }
}

export interface ISendPasswordResetCodeInput {
    emailAddress: string;
}

export class ResetPasswordInput implements IResetPasswordInput {
    userId!: number;
    resetCode!: string | undefined;
    password!: string | undefined;
    returnUrl!: string | undefined;
    singleSignIn!: string | undefined;
    c!: string | undefined;

    constructor(data?: IResetPasswordInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.resetCode = data["resetCode"];
            this.password = data["password"];
            this.returnUrl = data["returnUrl"];
            this.singleSignIn = data["singleSignIn"];
            this.c = data["c"];
        }
    }

    static fromJS(data: any): ResetPasswordInput {
        data = typeof data === 'object' ? data : {};
        let result = new ResetPasswordInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["resetCode"] = this.resetCode;
        data["password"] = this.password;
        data["returnUrl"] = this.returnUrl;
        data["singleSignIn"] = this.singleSignIn;
        data["c"] = this.c;
        return data; 
    }
}

export interface IResetPasswordInput {
    userId: number;
    resetCode: string | undefined;
    password: string | undefined;
    returnUrl: string | undefined;
    singleSignIn: string | undefined;
    c: string | undefined;
}

export class ResetPasswordOutput implements IResetPasswordOutput {
    canLogin!: boolean;
    userName!: string | undefined;

    constructor(data?: IResetPasswordOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.canLogin = data["canLogin"];
            this.userName = data["userName"];
        }
    }

    static fromJS(data: any): ResetPasswordOutput {
        data = typeof data === 'object' ? data : {};
        let result = new ResetPasswordOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["canLogin"] = this.canLogin;
        data["userName"] = this.userName;
        return data; 
    }
}

export interface IResetPasswordOutput {
    canLogin: boolean;
    userName: string | undefined;
}

export class SendEmailActivationLinkInput implements ISendEmailActivationLinkInput {
    emailAddress!: string;

    constructor(data?: ISendEmailActivationLinkInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.emailAddress = data["emailAddress"];
        }
    }

    static fromJS(data: any): SendEmailActivationLinkInput {
        data = typeof data === 'object' ? data : {};
        let result = new SendEmailActivationLinkInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["emailAddress"] = this.emailAddress;
        return data; 
    }
}

export interface ISendEmailActivationLinkInput {
    emailAddress: string;
}

export class ActivateEmailInput implements IActivateEmailInput {
    userId!: number;
    confirmationCode!: string | undefined;
    c!: string | undefined;

    constructor(data?: IActivateEmailInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.confirmationCode = data["confirmationCode"];
            this.c = data["c"];
        }
    }

    static fromJS(data: any): ActivateEmailInput {
        data = typeof data === 'object' ? data : {};
        let result = new ActivateEmailInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["confirmationCode"] = this.confirmationCode;
        data["c"] = this.c;
        return data; 
    }
}

export interface IActivateEmailInput {
    userId: number;
    confirmationCode: string | undefined;
    c: string | undefined;
}

export class ImpersonateInput implements IImpersonateInput {
    tenantId!: number | undefined;
    userId!: number;

    constructor(data?: IImpersonateInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): ImpersonateInput {
        data = typeof data === 'object' ? data : {};
        let result = new ImpersonateInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IImpersonateInput {
    tenantId: number | undefined;
    userId: number;
}

export class ImpersonateOutput implements IImpersonateOutput {
    impersonationToken!: string | undefined;
    tenancyName!: string | undefined;

    constructor(data?: IImpersonateOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.impersonationToken = data["impersonationToken"];
            this.tenancyName = data["tenancyName"];
        }
    }

    static fromJS(data: any): ImpersonateOutput {
        data = typeof data === 'object' ? data : {};
        let result = new ImpersonateOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["impersonationToken"] = this.impersonationToken;
        data["tenancyName"] = this.tenancyName;
        return data; 
    }
}

export interface IImpersonateOutput {
    impersonationToken: string | undefined;
    tenancyName: string | undefined;
}

export class SwitchToLinkedAccountInput implements ISwitchToLinkedAccountInput {
    targetTenantId!: number | undefined;
    targetUserId!: number;

    constructor(data?: ISwitchToLinkedAccountInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.targetTenantId = data["targetTenantId"];
            this.targetUserId = data["targetUserId"];
        }
    }

    static fromJS(data: any): SwitchToLinkedAccountInput {
        data = typeof data === 'object' ? data : {};
        let result = new SwitchToLinkedAccountInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["targetTenantId"] = this.targetTenantId;
        data["targetUserId"] = this.targetUserId;
        return data; 
    }
}

export interface ISwitchToLinkedAccountInput {
    targetTenantId: number | undefined;
    targetUserId: number;
}

export class SwitchToLinkedAccountOutput implements ISwitchToLinkedAccountOutput {
    switchAccountToken!: string | undefined;
    tenancyName!: string | undefined;

    constructor(data?: ISwitchToLinkedAccountOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.switchAccountToken = data["switchAccountToken"];
            this.tenancyName = data["tenancyName"];
        }
    }

    static fromJS(data: any): SwitchToLinkedAccountOutput {
        data = typeof data === 'object' ? data : {};
        let result = new SwitchToLinkedAccountOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["switchAccountToken"] = this.switchAccountToken;
        data["tenancyName"] = this.tenancyName;
        return data; 
    }
}

export interface ISwitchToLinkedAccountOutput {
    switchAccountToken: string | undefined;
    tenancyName: string | undefined;
}

export class AddressTypeInAddressListDto implements IAddressTypeInAddressListDto {
    id!: number;
    name!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;

    constructor(data?: IAddressTypeInAddressListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
        }
    }

    static fromJS(data: any): AddressTypeInAddressListDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddressTypeInAddressListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        return data; 
    }
}

export interface IAddressTypeInAddressListDto {
    id: number;
    name: string | undefined;
    color: string | undefined;
    icon: string | undefined;
}

export class PostalCodeInAddressListDto implements IPostalCodeInAddressListDto {
    id!: number;
    country!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    value!: string | undefined;

    constructor(data?: IPostalCodeInAddressListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.country = data["country"];
            this.city = data["city"];
            this.state = data["state"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): PostalCodeInAddressListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PostalCodeInAddressListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["country"] = this.country;
        data["city"] = this.city;
        data["state"] = this.state;
        data["value"] = this.value;
        return data; 
    }
}

export interface IPostalCodeInAddressListDto {
    id: number;
    country: string | undefined;
    city: string | undefined;
    state: string | undefined;
    value: string | undefined;
}

export class GeocodeInAddressListDto implements IGeocodeInAddressListDto {
    id!: number;
    latitude!: number;
    longitude!: number;

    constructor(data?: IGeocodeInAddressListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): GeocodeInAddressListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GeocodeInAddressListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface IGeocodeInAddressListDto {
    id: number;
    latitude: number;
    longitude: number;
}

export class AddressListDto implements IAddressListDto {
    id!: number;
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    addressType!: AddressTypeInAddressListDto | undefined;
    postalCode!: PostalCodeInAddressListDto | undefined;
    geocode!: GeocodeInAddressListDto | undefined;
    formattedAddress!: string | undefined;

    constructor(data?: IAddressListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.addressType = data["addressType"] ? AddressTypeInAddressListDto.fromJS(data["addressType"]) : <any>undefined;
            this.postalCode = data["postalCode"] ? PostalCodeInAddressListDto.fromJS(data["postalCode"]) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeInAddressListDto.fromJS(data["geocode"]) : <any>undefined;
            this.formattedAddress = data["formattedAddress"];
        }
    }

    static fromJS(data: any): AddressListDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddressListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["addressType"] = this.addressType ? this.addressType.toJSON() : <any>undefined;
        data["postalCode"] = this.postalCode ? this.postalCode.toJSON() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["formattedAddress"] = this.formattedAddress;
        return data; 
    }
}

export interface IAddressListDto {
    id: number;
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    addressType: AddressTypeInAddressListDto | undefined;
    postalCode: PostalCodeInAddressListDto | undefined;
    geocode: GeocodeInAddressListDto | undefined;
    formattedAddress: string | undefined;
}

export class PagedResultDtoOfAddressListDto implements IPagedResultDtoOfAddressListDto {
    totalCount!: number;
    items!: AddressListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfAddressListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(AddressListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfAddressListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfAddressListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfAddressListDto {
    totalCount: number;
    items: AddressListDto[] | undefined;
}

export class CreateAddressInput implements ICreateAddressInput {
    id!: number;
    addressLine1!: string;
    addressLine2!: string | undefined;
    postalCodeId!: number;
    geocodeId!: number | undefined;
    addressTypeId!: number | undefined;
    formattedAddress!: string | undefined;

    constructor(data?: ICreateAddressInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.postalCodeId = data["postalCodeId"];
            this.geocodeId = data["geocodeId"];
            this.addressTypeId = data["addressTypeId"];
            this.formattedAddress = data["formattedAddress"];
        }
    }

    static fromJS(data: any): CreateAddressInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateAddressInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["postalCodeId"] = this.postalCodeId;
        data["geocodeId"] = this.geocodeId;
        data["addressTypeId"] = this.addressTypeId;
        data["formattedAddress"] = this.formattedAddress;
        return data; 
    }
}

export interface ICreateAddressInput {
    id: number;
    addressLine1: string;
    addressLine2: string | undefined;
    postalCodeId: number;
    geocodeId: number | undefined;
    addressTypeId: number | undefined;
    formattedAddress: string | undefined;
}

export class UpdateAddressInput implements IUpdateAddressInput {
    id!: number;
    addressLine1!: string;
    addressLine2!: string | undefined;
    postalCodeId!: number;
    geocodeId!: number | undefined;
    addressTypeId!: number | undefined;
    longitude!: number;
    latitude!: number;
    formattedAddress!: string | undefined;
    overridableAddressType!: boolean;

    constructor(data?: IUpdateAddressInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.postalCodeId = data["postalCodeId"];
            this.geocodeId = data["geocodeId"];
            this.addressTypeId = data["addressTypeId"];
            this.longitude = data["longitude"];
            this.latitude = data["latitude"];
            this.formattedAddress = data["formattedAddress"];
            this.overridableAddressType = data["overridableAddressType"];
        }
    }

    static fromJS(data: any): UpdateAddressInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateAddressInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["postalCodeId"] = this.postalCodeId;
        data["geocodeId"] = this.geocodeId;
        data["addressTypeId"] = this.addressTypeId;
        data["longitude"] = this.longitude;
        data["latitude"] = this.latitude;
        data["formattedAddress"] = this.formattedAddress;
        data["overridableAddressType"] = this.overridableAddressType;
        return data; 
    }
}

export interface IUpdateAddressInput {
    id: number;
    addressLine1: string;
    addressLine2: string | undefined;
    postalCodeId: number;
    geocodeId: number | undefined;
    addressTypeId: number | undefined;
    longitude: number;
    latitude: number;
    formattedAddress: string | undefined;
    overridableAddressType: boolean;
}

export class SetOverridableAddressTypeInput implements ISetOverridableAddressTypeInput {
    addressIds!: number[] | undefined;
    value!: boolean;
    addressTypeId!: number | undefined;

    constructor(data?: ISetOverridableAddressTypeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["addressIds"])) {
                this.addressIds = [] as any;
                for (let item of data["addressIds"])
                    this.addressIds!.push(item);
            }
            this.value = data["value"];
            this.addressTypeId = data["addressTypeId"];
        }
    }

    static fromJS(data: any): SetOverridableAddressTypeInput {
        data = typeof data === 'object' ? data : {};
        let result = new SetOverridableAddressTypeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.addressIds)) {
            data["addressIds"] = [];
            for (let item of this.addressIds)
                data["addressIds"].push(item);
        }
        data["value"] = this.value;
        data["addressTypeId"] = this.addressTypeId;
        return data; 
    }
}

export interface ISetOverridableAddressTypeInput {
    addressIds: number[] | undefined;
    value: boolean;
    addressTypeId: number | undefined;
}

export class SetOverridableAddressTypeDto implements ISetOverridableAddressTypeDto {
    addressId!: number | undefined;

    constructor(data?: ISetOverridableAddressTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressId = data["addressId"];
        }
    }

    static fromJS(data: any): SetOverridableAddressTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new SetOverridableAddressTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressId"] = this.addressId;
        return data; 
    }
}

export interface ISetOverridableAddressTypeDto {
    addressId: number | undefined;
}

export class AddressDto implements IAddressDto {
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    formattedAddress!: string | undefined;
    partialMatch!: boolean;
    postalCodeId!: number;
    geocodeId!: number | undefined;
    addressTypeId!: number | undefined;
    overridableAddressType!: boolean;
    id!: number;

    constructor(data?: IAddressDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.formattedAddress = data["formattedAddress"];
            this.partialMatch = data["partialMatch"];
            this.postalCodeId = data["postalCodeId"];
            this.geocodeId = data["geocodeId"];
            this.addressTypeId = data["addressTypeId"];
            this.overridableAddressType = data["overridableAddressType"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AddressDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddressDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["formattedAddress"] = this.formattedAddress;
        data["partialMatch"] = this.partialMatch;
        data["postalCodeId"] = this.postalCodeId;
        data["geocodeId"] = this.geocodeId;
        data["addressTypeId"] = this.addressTypeId;
        data["overridableAddressType"] = this.overridableAddressType;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAddressDto {
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    formattedAddress: string | undefined;
    partialMatch: boolean;
    postalCodeId: number;
    geocodeId: number | undefined;
    addressTypeId: number | undefined;
    overridableAddressType: boolean;
    id: number;
}

export class GetAddressForViewDto implements IGetAddressForViewDto {
    address!: AddressDto | undefined;
    postalCodeValue!: string | undefined;
    postalCodeCountry!: string | undefined;
    postalCodeState!: string | undefined;
    postalCodeCity!: string | undefined;
    geocodeLatitude!: string | undefined;
    geocodeLongitude!: string | undefined;
    addressTypeName!: string | undefined;

    constructor(data?: IGetAddressForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.address = data["address"] ? AddressDto.fromJS(data["address"]) : <any>undefined;
            this.postalCodeValue = data["postalCodeValue"];
            this.postalCodeCountry = data["postalCodeCountry"];
            this.postalCodeState = data["postalCodeState"];
            this.postalCodeCity = data["postalCodeCity"];
            this.geocodeLatitude = data["geocodeLatitude"];
            this.geocodeLongitude = data["geocodeLongitude"];
            this.addressTypeName = data["addressTypeName"];
        }
    }

    static fromJS(data: any): GetAddressForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetAddressForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["postalCodeValue"] = this.postalCodeValue;
        data["postalCodeCountry"] = this.postalCodeCountry;
        data["postalCodeState"] = this.postalCodeState;
        data["postalCodeCity"] = this.postalCodeCity;
        data["geocodeLatitude"] = this.geocodeLatitude;
        data["geocodeLongitude"] = this.geocodeLongitude;
        data["addressTypeName"] = this.addressTypeName;
        return data; 
    }
}

export interface IGetAddressForViewDto {
    address: AddressDto | undefined;
    postalCodeValue: string | undefined;
    postalCodeCountry: string | undefined;
    postalCodeState: string | undefined;
    postalCodeCity: string | undefined;
    geocodeLatitude: string | undefined;
    geocodeLongitude: string | undefined;
    addressTypeName: string | undefined;
}

export class PagedResultDtoOfGetAddressForViewDto implements IPagedResultDtoOfGetAddressForViewDto {
    totalCount!: number;
    items!: GetAddressForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetAddressForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetAddressForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetAddressForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetAddressForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetAddressForViewDto {
    totalCount: number;
    items: GetAddressForViewDto[] | undefined;
}

export class CreateOrEditAddressDto implements ICreateOrEditAddressDto {
    addressLine1!: string;
    addressLine2!: string | undefined;
    formattedAddress!: string | undefined;
    postalCodeId!: number;
    geocodeId!: number | undefined;
    latitude!: number;
    longitude!: number;
    addressTypeId!: number | undefined;
    overridableAddressType!: boolean;
    id!: number | undefined;

    constructor(data?: ICreateOrEditAddressDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.formattedAddress = data["formattedAddress"];
            this.postalCodeId = data["postalCodeId"];
            this.geocodeId = data["geocodeId"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.addressTypeId = data["addressTypeId"];
            this.overridableAddressType = data["overridableAddressType"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditAddressDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditAddressDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["formattedAddress"] = this.formattedAddress;
        data["postalCodeId"] = this.postalCodeId;
        data["geocodeId"] = this.geocodeId;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["addressTypeId"] = this.addressTypeId;
        data["overridableAddressType"] = this.overridableAddressType;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditAddressDto {
    addressLine1: string;
    addressLine2: string | undefined;
    formattedAddress: string | undefined;
    postalCodeId: number;
    geocodeId: number | undefined;
    latitude: number;
    longitude: number;
    addressTypeId: number | undefined;
    overridableAddressType: boolean;
    id: number | undefined;
}

export class GetAddressForEditOutput implements IGetAddressForEditOutput {
    address!: CreateOrEditAddressDto | undefined;
    postalCodeValue!: string | undefined;
    geocodeId!: number;
    geocodeLatitude!: number;
    geocodeLongitude!: number;
    addressTypeName!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    country!: string | undefined;

    constructor(data?: IGetAddressForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.address = data["address"] ? CreateOrEditAddressDto.fromJS(data["address"]) : <any>undefined;
            this.postalCodeValue = data["postalCodeValue"];
            this.geocodeId = data["geocodeId"];
            this.geocodeLatitude = data["geocodeLatitude"];
            this.geocodeLongitude = data["geocodeLongitude"];
            this.addressTypeName = data["addressTypeName"];
            this.city = data["city"];
            this.state = data["state"];
            this.country = data["country"];
        }
    }

    static fromJS(data: any): GetAddressForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAddressForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["postalCodeValue"] = this.postalCodeValue;
        data["geocodeId"] = this.geocodeId;
        data["geocodeLatitude"] = this.geocodeLatitude;
        data["geocodeLongitude"] = this.geocodeLongitude;
        data["addressTypeName"] = this.addressTypeName;
        data["city"] = this.city;
        data["state"] = this.state;
        data["country"] = this.country;
        return data; 
    }
}

export interface IGetAddressForEditOutput {
    address: CreateOrEditAddressDto | undefined;
    postalCodeValue: string | undefined;
    geocodeId: number;
    geocodeLatitude: number;
    geocodeLongitude: number;
    addressTypeName: string | undefined;
    city: string | undefined;
    state: string | undefined;
    country: string | undefined;
}

export class FileDto implements IFileDto {
    fileName!: string;
    fileType!: string | undefined;
    fileToken!: string;

    constructor(data?: IFileDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.fileType = data["fileType"];
            this.fileToken = data["fileToken"];
        }
    }

    static fromJS(data: any): FileDto {
        data = typeof data === 'object' ? data : {};
        let result = new FileDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["fileType"] = this.fileType;
        data["fileToken"] = this.fileToken;
        return data; 
    }
}

export interface IFileDto {
    fileName: string;
    fileType: string | undefined;
    fileToken: string;
}

export class AddressPostalCodeLookupTableDto implements IAddressPostalCodeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IAddressPostalCodeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): AddressPostalCodeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddressPostalCodeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IAddressPostalCodeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfAddressPostalCodeLookupTableDto implements IPagedResultDtoOfAddressPostalCodeLookupTableDto {
    totalCount!: number;
    items!: AddressPostalCodeLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfAddressPostalCodeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(AddressPostalCodeLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfAddressPostalCodeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfAddressPostalCodeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfAddressPostalCodeLookupTableDto {
    totalCount: number;
    items: AddressPostalCodeLookupTableDto[] | undefined;
}

export class AddressGeocodeLookupTableDto implements IAddressGeocodeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IAddressGeocodeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): AddressGeocodeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddressGeocodeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IAddressGeocodeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfAddressGeocodeLookupTableDto implements IPagedResultDtoOfAddressGeocodeLookupTableDto {
    totalCount!: number;
    items!: AddressGeocodeLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfAddressGeocodeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(AddressGeocodeLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfAddressGeocodeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfAddressGeocodeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfAddressGeocodeLookupTableDto {
    totalCount: number;
    items: AddressGeocodeLookupTableDto[] | undefined;
}

export class AddressAddressTypeLookupTableDto implements IAddressAddressTypeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IAddressAddressTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): AddressAddressTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddressAddressTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IAddressAddressTypeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfAddressAddressTypeLookupTableDto implements IPagedResultDtoOfAddressAddressTypeLookupTableDto {
    totalCount!: number;
    items!: AddressAddressTypeLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfAddressAddressTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(AddressAddressTypeLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfAddressAddressTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfAddressAddressTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfAddressAddressTypeLookupTableDto {
    totalCount: number;
    items: AddressAddressTypeLookupTableDto[] | undefined;
}

export class EntityDto implements IEntityDto {
    id!: number;

    constructor(data?: IEntityDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EntityDto {
        data = typeof data === 'object' ? data : {};
        let result = new EntityDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        return data; 
    }
}

export interface IEntityDto {
    id: number;
}

export class UpdateOrderAddressInput implements IUpdateOrderAddressInput {
    addressId!: number;
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    formattedAddress!: string | undefined;
    postalCodeValue!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    country!: string | undefined;
    latitude!: number;
    longitude!: number;
    locationId!: number;
    addressTypeName!: string | undefined;
    addressTypeId!: number | undefined;
    contactId!: number;

    constructor(data?: IUpdateOrderAddressInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressId = data["addressId"];
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.formattedAddress = data["formattedAddress"];
            this.postalCodeValue = data["postalCodeValue"];
            this.city = data["city"];
            this.state = data["state"];
            this.country = data["country"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.locationId = data["locationId"];
            this.addressTypeName = data["addressTypeName"];
            this.addressTypeId = data["addressTypeId"];
            this.contactId = data["contactId"];
        }
    }

    static fromJS(data: any): UpdateOrderAddressInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderAddressInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressId"] = this.addressId;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["formattedAddress"] = this.formattedAddress;
        data["postalCodeValue"] = this.postalCodeValue;
        data["city"] = this.city;
        data["state"] = this.state;
        data["country"] = this.country;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["locationId"] = this.locationId;
        data["addressTypeName"] = this.addressTypeName;
        data["addressTypeId"] = this.addressTypeId;
        data["contactId"] = this.contactId;
        return data; 
    }
}

export interface IUpdateOrderAddressInput {
    addressId: number;
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    formattedAddress: string | undefined;
    postalCodeValue: string | undefined;
    city: string | undefined;
    state: string | undefined;
    country: string | undefined;
    latitude: number;
    longitude: number;
    locationId: number;
    addressTypeName: string | undefined;
    addressTypeId: number | undefined;
    contactId: number;
}

export class NameValueDto implements INameValueDto {
    name!: string | undefined;
    value!: string | undefined;

    constructor(data?: INameValueDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): NameValueDto {
        data = typeof data === 'object' ? data : {};
        let result = new NameValueDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["value"] = this.value;
        return data; 
    }
}

export interface INameValueDto {
    name: string | undefined;
    value: string | undefined;
}

export class PagedResultDtoOfNameValueDto implements IPagedResultDtoOfNameValueDto {
    totalCount!: number;
    items!: NameValueDto[] | undefined;

    constructor(data?: IPagedResultDtoOfNameValueDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(NameValueDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfNameValueDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfNameValueDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfNameValueDto {
    totalCount: number;
    items: NameValueDto[] | undefined;
}

export class AddressTypeListDto implements IAddressTypeListDto {
    name!: string | undefined;
    color!: string | undefined;
    proximityValue!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IAddressTypeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.color = data["color"];
            this.proximityValue = data["proximityValue"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AddressTypeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddressTypeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["color"] = this.color;
        data["proximityValue"] = this.proximityValue;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAddressTypeListDto {
    name: string | undefined;
    color: string | undefined;
    proximityValue: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class PagedResultDtoOfAddressTypeListDto implements IPagedResultDtoOfAddressTypeListDto {
    totalCount!: number;
    items!: AddressTypeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfAddressTypeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(AddressTypeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfAddressTypeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfAddressTypeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfAddressTypeListDto {
    totalCount: number;
    items: AddressTypeListDto[] | undefined;
}

export class CreateAddressTypeInput implements ICreateAddressTypeInput {
    name!: string;

    constructor(data?: ICreateAddressTypeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CreateAddressTypeInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateAddressTypeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface ICreateAddressTypeInput {
    name: string;
}

export class UpdateAddressTypeInput implements IUpdateAddressTypeInput {
    id!: number;
    name!: string;

    constructor(data?: IUpdateAddressTypeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): UpdateAddressTypeInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateAddressTypeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IUpdateAddressTypeInput {
    id: number;
    name: string;
}

export class AddressTypeDto implements IAddressTypeDto {
    name!: string | undefined;
    color!: string | undefined;
    proximityValue!: number;
    icon!: string | undefined;
    id!: number;

    constructor(data?: IAddressTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.color = data["color"];
            this.proximityValue = data["proximityValue"];
            this.icon = data["icon"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AddressTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddressTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["color"] = this.color;
        data["proximityValue"] = this.proximityValue;
        data["icon"] = this.icon;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAddressTypeDto {
    name: string | undefined;
    color: string | undefined;
    proximityValue: number;
    icon: string | undefined;
    id: number;
}

export class GetAddressTypeForViewDto implements IGetAddressTypeForViewDto {
    addressType!: AddressTypeDto | undefined;

    constructor(data?: IGetAddressTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressType = data["addressType"] ? AddressTypeDto.fromJS(data["addressType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetAddressTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetAddressTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressType"] = this.addressType ? this.addressType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetAddressTypeForViewDto {
    addressType: AddressTypeDto | undefined;
}

export class PagedResultDtoOfGetAddressTypeForViewDto implements IPagedResultDtoOfGetAddressTypeForViewDto {
    totalCount!: number;
    items!: GetAddressTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetAddressTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetAddressTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetAddressTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetAddressTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetAddressTypeForViewDto {
    totalCount: number;
    items: GetAddressTypeForViewDto[] | undefined;
}

export class CreateOrEditAddressTypeDto implements ICreateOrEditAddressTypeDto {
    name!: string;
    color!: string;
    icon!: string | undefined;
    proximityValue!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditAddressTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.proximityValue = data["proximityValue"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditAddressTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditAddressTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["proximityValue"] = this.proximityValue;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditAddressTypeDto {
    name: string;
    color: string;
    icon: string | undefined;
    proximityValue: number;
    id: number | undefined;
}

export class GetAddressTypeForEditOutput implements IGetAddressTypeForEditOutput {
    addressType!: CreateOrEditAddressTypeDto | undefined;

    constructor(data?: IGetAddressTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressType = data["addressType"] ? CreateOrEditAddressTypeDto.fromJS(data["addressType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetAddressTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAddressTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressType"] = this.addressType ? this.addressType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetAddressTypeForEditOutput {
    addressType: CreateOrEditAddressTypeDto | undefined;
}

export class ExportFileDto implements IExportFileDto {
    fileDto!: FileDto | undefined;
    fileUrl!: string | undefined;

    constructor(data?: IExportFileDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileDto = data["fileDto"] ? FileDto.fromJS(data["fileDto"]) : <any>undefined;
            this.fileUrl = data["fileUrl"];
        }
    }

    static fromJS(data: any): ExportFileDto {
        data = typeof data === 'object' ? data : {};
        let result = new ExportFileDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileDto"] = this.fileDto ? this.fileDto.toJSON() : <any>undefined;
        data["fileUrl"] = this.fileUrl;
        return data; 
    }
}

export interface IExportFileDto {
    fileDto: FileDto | undefined;
    fileUrl: string | undefined;
}

export class GetAllAddressTypesDto implements IGetAllAddressTypesDto {
    id!: number;
    name!: string | undefined;

    constructor(data?: IGetAllAddressTypesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetAllAddressTypesDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllAddressTypesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetAllAddressTypesDto {
    id: number;
    name: string | undefined;
}

export class AuditLogListDto implements IAuditLogListDto {
    userId!: number | undefined;
    userName!: string | undefined;
    impersonatorTenantId!: number | undefined;
    impersonatorUserId!: number | undefined;
    serviceName!: string | undefined;
    methodName!: string | undefined;
    parameters!: string | undefined;
    executionTime!: moment.Moment;
    executionDuration!: number;
    clientIpAddress!: string | undefined;
    clientName!: string | undefined;
    browserInfo!: string | undefined;
    exception!: string | undefined;
    customData!: string | undefined;
    id!: number;

    constructor(data?: IAuditLogListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.userName = data["userName"];
            this.impersonatorTenantId = data["impersonatorTenantId"];
            this.impersonatorUserId = data["impersonatorUserId"];
            this.serviceName = data["serviceName"];
            this.methodName = data["methodName"];
            this.parameters = data["parameters"];
            this.executionTime = data["executionTime"] ? moment(data["executionTime"].toString()) : <any>undefined;
            this.executionDuration = data["executionDuration"];
            this.clientIpAddress = data["clientIpAddress"];
            this.clientName = data["clientName"];
            this.browserInfo = data["browserInfo"];
            this.exception = data["exception"];
            this.customData = data["customData"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AuditLogListDto {
        data = typeof data === 'object' ? data : {};
        let result = new AuditLogListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["userName"] = this.userName;
        data["impersonatorTenantId"] = this.impersonatorTenantId;
        data["impersonatorUserId"] = this.impersonatorUserId;
        data["serviceName"] = this.serviceName;
        data["methodName"] = this.methodName;
        data["parameters"] = this.parameters;
        data["executionTime"] = this.executionTime ? this.executionTime.toISOString() : <any>undefined;
        data["executionDuration"] = this.executionDuration;
        data["clientIpAddress"] = this.clientIpAddress;
        data["clientName"] = this.clientName;
        data["browserInfo"] = this.browserInfo;
        data["exception"] = this.exception;
        data["customData"] = this.customData;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAuditLogListDto {
    userId: number | undefined;
    userName: string | undefined;
    impersonatorTenantId: number | undefined;
    impersonatorUserId: number | undefined;
    serviceName: string | undefined;
    methodName: string | undefined;
    parameters: string | undefined;
    executionTime: moment.Moment;
    executionDuration: number;
    clientIpAddress: string | undefined;
    clientName: string | undefined;
    browserInfo: string | undefined;
    exception: string | undefined;
    customData: string | undefined;
    id: number;
}

export class PagedResultDtoOfAuditLogListDto implements IPagedResultDtoOfAuditLogListDto {
    totalCount!: number;
    items!: AuditLogListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfAuditLogListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(AuditLogListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfAuditLogListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfAuditLogListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfAuditLogListDto {
    totalCount: number;
    items: AuditLogListDto[] | undefined;
}

export enum EntityChangeType {
    Created = 0,
    Updated = 1,
    Deleted = 2,
}

export class EntityChangeListDto implements IEntityChangeListDto {
    userId!: number | undefined;
    userName!: string | undefined;
    changeTime!: moment.Moment;
    entityTypeFullName!: string | undefined;
    changeType!: EntityChangeType;
    readonly changeTypeName!: string | undefined;
    entityChangeSetId!: number;
    changeTimeString!: string | undefined;
    entityId!: string | undefined;
    id!: number;

    constructor(data?: IEntityChangeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.userName = data["userName"];
            this.changeTime = data["changeTime"] ? moment(data["changeTime"].toString()) : <any>undefined;
            this.entityTypeFullName = data["entityTypeFullName"];
            this.changeType = data["changeType"];
            (<any>this).changeTypeName = data["changeTypeName"];
            this.entityChangeSetId = data["entityChangeSetId"];
            this.changeTimeString = data["changeTimeString"];
            this.entityId = data["entityId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EntityChangeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new EntityChangeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["userName"] = this.userName;
        data["changeTime"] = this.changeTime ? this.changeTime.toISOString() : <any>undefined;
        data["entityTypeFullName"] = this.entityTypeFullName;
        data["changeType"] = this.changeType;
        data["changeTypeName"] = this.changeTypeName;
        data["entityChangeSetId"] = this.entityChangeSetId;
        data["changeTimeString"] = this.changeTimeString;
        data["entityId"] = this.entityId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEntityChangeListDto {
    userId: number | undefined;
    userName: string | undefined;
    changeTime: moment.Moment;
    entityTypeFullName: string | undefined;
    changeType: EntityChangeType;
    changeTypeName: string | undefined;
    entityChangeSetId: number;
    changeTimeString: string | undefined;
    entityId: string | undefined;
    id: number;
}

export class PagedResultDtoOfEntityChangeListDto implements IPagedResultDtoOfEntityChangeListDto {
    totalCount!: number;
    items!: EntityChangeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfEntityChangeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(EntityChangeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfEntityChangeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfEntityChangeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfEntityChangeListDto {
    totalCount: number;
    items: EntityChangeListDto[] | undefined;
}

export class EntityPropertyChangeDto implements IEntityPropertyChangeDto {
    entityChangeId!: number;
    newValue!: string | undefined;
    originalValue!: string | undefined;
    propertyName!: string | undefined;
    propertyTypeFullName!: string | undefined;
    tenantId!: number | undefined;
    id!: number;

    constructor(data?: IEntityPropertyChangeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.entityChangeId = data["entityChangeId"];
            this.newValue = data["newValue"];
            this.originalValue = data["originalValue"];
            this.propertyName = data["propertyName"];
            this.propertyTypeFullName = data["propertyTypeFullName"];
            this.tenantId = data["tenantId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EntityPropertyChangeDto {
        data = typeof data === 'object' ? data : {};
        let result = new EntityPropertyChangeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["entityChangeId"] = this.entityChangeId;
        data["newValue"] = this.newValue;
        data["originalValue"] = this.originalValue;
        data["propertyName"] = this.propertyName;
        data["propertyTypeFullName"] = this.propertyTypeFullName;
        data["tenantId"] = this.tenantId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEntityPropertyChangeDto {
    entityChangeId: number;
    newValue: string | undefined;
    originalValue: string | undefined;
    propertyName: string | undefined;
    propertyTypeFullName: string | undefined;
    tenantId: number | undefined;
    id: number;
}

export class CreateOrUpdateTestAccountInputDto implements ICreateOrUpdateTestAccountInputDto {
    tenantId!: number | undefined;
    username!: string | undefined;
    password!: string | undefined;
    vehicleId!: number;

    constructor(data?: ICreateOrUpdateTestAccountInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.username = data["username"];
            this.password = data["password"];
            this.vehicleId = data["vehicleId"];
        }
    }

    static fromJS(data: any): CreateOrUpdateTestAccountInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateTestAccountInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["username"] = this.username;
        data["password"] = this.password;
        data["vehicleId"] = this.vehicleId;
        return data; 
    }
}

export interface ICreateOrUpdateTestAccountInputDto {
    tenantId: number | undefined;
    username: string | undefined;
    password: string | undefined;
    vehicleId: number;
}

export class GetTestAccountForTenantResultDto implements IGetTestAccountForTenantResultDto {
    tenantId!: number | undefined;
    username!: string | undefined;
    password!: string | undefined;
    vehicleId!: number;

    constructor(data?: IGetTestAccountForTenantResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.username = data["username"];
            this.password = data["password"];
            this.vehicleId = data["vehicleId"];
        }
    }

    static fromJS(data: any): GetTestAccountForTenantResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetTestAccountForTenantResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["username"] = this.username;
        data["password"] = this.password;
        data["vehicleId"] = this.vehicleId;
        return data; 
    }
}

export interface IGetTestAccountForTenantResultDto {
    tenantId: number | undefined;
    username: string | undefined;
    password: string | undefined;
    vehicleId: number;
}

export class InitializeTestDataInputDto implements IInitializeTestDataInputDto {
    tenantId!: number | undefined;
    username!: string | undefined;

    constructor(data?: IInitializeTestDataInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.username = data["username"];
        }
    }

    static fromJS(data: any): InitializeTestDataInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new InitializeTestDataInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["username"] = this.username;
        return data; 
    }
}

export interface IInitializeTestDataInputDto {
    tenantId: number | undefined;
    username: string | undefined;
}

export class IsTestDataReadyInputDto implements IIsTestDataReadyInputDto {
    tenantId!: number | undefined;
    username!: string | undefined;

    constructor(data?: IIsTestDataReadyInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.username = data["username"];
        }
    }

    static fromJS(data: any): IsTestDataReadyInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new IsTestDataReadyInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["username"] = this.username;
        return data; 
    }
}

export interface IIsTestDataReadyInputDto {
    tenantId: number | undefined;
    username: string | undefined;
}

export class ClearTestDataInputDto implements IClearTestDataInputDto {
    tenantId!: number | undefined;
    username!: string | undefined;

    constructor(data?: IClearTestDataInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.username = data["username"];
        }
    }

    static fromJS(data: any): ClearTestDataInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new ClearTestDataInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["username"] = this.username;
        return data; 
    }
}

export interface IClearTestDataInputDto {
    tenantId: number | undefined;
    username: string | undefined;
}

export class AddDispatchCommandParameterInputDto implements IAddDispatchCommandParameterInputDto {
    tenantId!: number | undefined;
    username!: string | undefined;
    commandCode!: string | undefined;
    parameter!: string | undefined;

    constructor(data?: IAddDispatchCommandParameterInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.username = data["username"];
            this.commandCode = data["commandCode"];
            this.parameter = data["parameter"];
        }
    }

    static fromJS(data: any): AddDispatchCommandParameterInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddDispatchCommandParameterInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["username"] = this.username;
        data["commandCode"] = this.commandCode;
        data["parameter"] = this.parameter;
        return data; 
    }
}

export interface IAddDispatchCommandParameterInputDto {
    tenantId: number | undefined;
    username: string | undefined;
    commandCode: string | undefined;
    parameter: string | undefined;
}

export class SendDispatchCommandInputDto implements ISendDispatchCommandInputDto {
    tenantId!: number | undefined;
    username!: string | undefined;
    commandCode!: string | undefined;
    parameter!: string | undefined;

    constructor(data?: ISendDispatchCommandInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.username = data["username"];
            this.commandCode = data["commandCode"];
            this.parameter = data["parameter"];
        }
    }

    static fromJS(data: any): SendDispatchCommandInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new SendDispatchCommandInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["username"] = this.username;
        data["commandCode"] = this.commandCode;
        data["parameter"] = this.parameter;
        return data; 
    }
}

export interface ISendDispatchCommandInputDto {
    tenantId: number | undefined;
    username: string | undefined;
    commandCode: string | undefined;
    parameter: string | undefined;
}

export class GetDispatchCommandDataListItemDto implements IGetDispatchCommandDataListItemDto {
    id!: number;
    commandCode!: string | undefined;
    parameter!: string | undefined;

    constructor(data?: IGetDispatchCommandDataListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.commandCode = data["commandCode"];
            this.parameter = data["parameter"];
        }
    }

    static fromJS(data: any): GetDispatchCommandDataListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDispatchCommandDataListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["commandCode"] = this.commandCode;
        data["parameter"] = this.parameter;
        return data; 
    }
}

export interface IGetDispatchCommandDataListItemDto {
    id: number;
    commandCode: string | undefined;
    parameter: string | undefined;
}

export class BackgroundProcessDto implements IBackgroundProcessDto {
    jobId!: string | undefined;
    jobClass!: string | undefined;
    cronExpression!: string | undefined;
    isActive!: boolean;
    description!: string | undefined;
    lastStartTime!: moment.Moment;
    id!: number;

    constructor(data?: IBackgroundProcessDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.jobId = data["jobId"];
            this.jobClass = data["jobClass"];
            this.cronExpression = data["cronExpression"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.lastStartTime = data["lastStartTime"] ? moment(data["lastStartTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): BackgroundProcessDto {
        data = typeof data === 'object' ? data : {};
        let result = new BackgroundProcessDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["jobId"] = this.jobId;
        data["jobClass"] = this.jobClass;
        data["cronExpression"] = this.cronExpression;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["lastStartTime"] = this.lastStartTime ? this.lastStartTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IBackgroundProcessDto {
    jobId: string | undefined;
    jobClass: string | undefined;
    cronExpression: string | undefined;
    isActive: boolean;
    description: string | undefined;
    lastStartTime: moment.Moment;
    id: number;
}

export class GetBackgroundProcessForViewDto implements IGetBackgroundProcessForViewDto {
    backgroundProcess!: BackgroundProcessDto | undefined;

    constructor(data?: IGetBackgroundProcessForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.backgroundProcess = data["backgroundProcess"] ? BackgroundProcessDto.fromJS(data["backgroundProcess"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetBackgroundProcessForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetBackgroundProcessForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["backgroundProcess"] = this.backgroundProcess ? this.backgroundProcess.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetBackgroundProcessForViewDto {
    backgroundProcess: BackgroundProcessDto | undefined;
}

export class PagedResultDtoOfGetBackgroundProcessForViewDto implements IPagedResultDtoOfGetBackgroundProcessForViewDto {
    totalCount!: number;
    items!: GetBackgroundProcessForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetBackgroundProcessForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetBackgroundProcessForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetBackgroundProcessForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetBackgroundProcessForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetBackgroundProcessForViewDto {
    totalCount: number;
    items: GetBackgroundProcessForViewDto[] | undefined;
}

export class CreateOrEditBackgroundProcessDto implements ICreateOrEditBackgroundProcessDto {
    jobId!: string | undefined;
    jobClass!: string | undefined;
    cronExpression!: string | undefined;
    isActive!: boolean;
    description!: string | undefined;
    lastStartTime!: moment.Moment;
    id!: number | undefined;

    constructor(data?: ICreateOrEditBackgroundProcessDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.jobId = data["jobId"];
            this.jobClass = data["jobClass"];
            this.cronExpression = data["cronExpression"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.lastStartTime = data["lastStartTime"] ? moment(data["lastStartTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditBackgroundProcessDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditBackgroundProcessDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["jobId"] = this.jobId;
        data["jobClass"] = this.jobClass;
        data["cronExpression"] = this.cronExpression;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["lastStartTime"] = this.lastStartTime ? this.lastStartTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditBackgroundProcessDto {
    jobId: string | undefined;
    jobClass: string | undefined;
    cronExpression: string | undefined;
    isActive: boolean;
    description: string | undefined;
    lastStartTime: moment.Moment;
    id: number | undefined;
}

export class GetBackgroundProcessForEditOutput implements IGetBackgroundProcessForEditOutput {
    backgroundProcess!: CreateOrEditBackgroundProcessDto | undefined;

    constructor(data?: IGetBackgroundProcessForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.backgroundProcess = data["backgroundProcess"] ? CreateOrEditBackgroundProcessDto.fromJS(data["backgroundProcess"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetBackgroundProcessForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetBackgroundProcessForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["backgroundProcess"] = this.backgroundProcess ? this.backgroundProcess.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetBackgroundProcessForEditOutput {
    backgroundProcess: CreateOrEditBackgroundProcessDto | undefined;
}

export class TimeSpan implements ITimeSpan {
    readonly ticks!: number;
    readonly days!: number;
    readonly hours!: number;
    readonly milliseconds!: number;
    readonly minutes!: number;
    readonly seconds!: number;
    readonly totalDays!: number;
    readonly totalHours!: number;
    readonly totalMilliseconds!: number;
    readonly totalMinutes!: number;
    readonly totalSeconds!: number;

    constructor(data?: ITimeSpan) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).ticks = data["ticks"];
            (<any>this).days = data["days"];
            (<any>this).hours = data["hours"];
            (<any>this).milliseconds = data["milliseconds"];
            (<any>this).minutes = data["minutes"];
            (<any>this).seconds = data["seconds"];
            (<any>this).totalDays = data["totalDays"];
            (<any>this).totalHours = data["totalHours"];
            (<any>this).totalMilliseconds = data["totalMilliseconds"];
            (<any>this).totalMinutes = data["totalMinutes"];
            (<any>this).totalSeconds = data["totalSeconds"];
        }
    }

    static fromJS(data: any): TimeSpan {
        data = typeof data === 'object' ? data : {};
        let result = new TimeSpan();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["ticks"] = this.ticks;
        data["days"] = this.days;
        data["hours"] = this.hours;
        data["milliseconds"] = this.milliseconds;
        data["minutes"] = this.minutes;
        data["seconds"] = this.seconds;
        data["totalDays"] = this.totalDays;
        data["totalHours"] = this.totalHours;
        data["totalMilliseconds"] = this.totalMilliseconds;
        data["totalMinutes"] = this.totalMinutes;
        data["totalSeconds"] = this.totalSeconds;
        return data; 
    }
}

export interface ITimeSpan {
    ticks: number;
    days: number;
    hours: number;
    milliseconds: number;
    minutes: number;
    seconds: number;
    totalDays: number;
    totalHours: number;
    totalMilliseconds: number;
    totalMinutes: number;
    totalSeconds: number;
}

export class JobStorage implements IJobStorage {
    jobExpirationTimeout!: TimeSpan;
    readonly linearizableReads!: boolean;

    constructor(data?: IJobStorage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.jobExpirationTimeout = data["jobExpirationTimeout"] ? TimeSpan.fromJS(data["jobExpirationTimeout"]) : <any>undefined;
            (<any>this).linearizableReads = data["linearizableReads"];
        }
    }

    static fromJS(data: any): JobStorage {
        data = typeof data === 'object' ? data : {};
        let result = new JobStorage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["jobExpirationTimeout"] = this.jobExpirationTimeout ? this.jobExpirationTimeout.toJSON() : <any>undefined;
        data["linearizableReads"] = this.linearizableReads;
        return data; 
    }
}

export interface IJobStorage {
    jobExpirationTimeout: TimeSpan;
    linearizableReads: boolean;
}

export enum MemberTypes {
    Constructor = 1,
    Event = 2,
    Field = 4,
    Method = 8,
    Property = 16,
    TypeInfo = 32,
    Custom = 64,
    NestedType = 128,
    All = 191,
}

export enum MethodAttributes {
    ReuseSlot = 0,
    PrivateScope = 0,
    Private = 1,
    FamANDAssem = 2,
    Assembly = 3,
    Family = 4,
    FamORAssem = 5,
    Public = 6,
    MemberAccessMask = 7,
    UnmanagedExport = 8,
    Static = 16,
    Final = 32,
    Virtual = 64,
    HideBySig = 128,
    NewSlot = 256,
    VtableLayoutMask = 256,
    CheckAccessOnOverride = 512,
    Abstract = 1024,
    SpecialName = 2048,
    RTSpecialName = 4096,
    PinvokeImpl = 8192,
    HasSecurity = 16384,
    RequireSecObject = 32768,
    ReservedMask = 53248,
}

export enum MethodImplAttributes {
    IL = 0,
    Managed = 0,
    Native = 1,
    OPTIL = 2,
    Runtime = 3,
    CodeTypeMask = 3,
    Unmanaged = 4,
    ManagedMask = 4,
    NoInlining = 8,
    ForwardRef = 16,
    Synchronized = 32,
    NoOptimization = 64,
    PreserveSig = 128,
    AggressiveInlining = 256,
    AggressiveOptimization = 512,
    InternalCall = 4096,
    MaxMethodImplVal = 65535,
}

export enum CallingConventions {
    Standard = 1,
    VarArgs = 2,
    Any = 3,
    HasThis = 32,
    ExplicitThis = 64,
}

export class IntPtr implements IIntPtr {

    constructor(data?: IIntPtr) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): IntPtr {
        data = typeof data === 'object' ? data : {};
        let result = new IntPtr();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IIntPtr {
}

export class RuntimeMethodHandle implements IRuntimeMethodHandle {
    readonly value!: IntPtr;

    constructor(data?: IRuntimeMethodHandle) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).value = data["value"] ? IntPtr.fromJS(data["value"]) : <any>undefined;
        }
    }

    static fromJS(data: any): RuntimeMethodHandle {
        data = typeof data === 'object' ? data : {};
        let result = new RuntimeMethodHandle();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value ? this.value.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IRuntimeMethodHandle {
    value: IntPtr;
}

export class ModuleHandle implements IModuleHandle {
    readonly mdStreamVersion!: number;

    constructor(data?: IModuleHandle) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).mdStreamVersion = data["mdStreamVersion"];
        }
    }

    static fromJS(data: any): ModuleHandle {
        data = typeof data === 'object' ? data : {};
        let result = new ModuleHandle();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["mdStreamVersion"] = this.mdStreamVersion;
        return data; 
    }
}

export interface IModuleHandle {
    mdStreamVersion: number;
}

export class CustomAttributeTypedArgument implements ICustomAttributeTypedArgument {
    readonly argumentType!: Type | undefined;
    readonly value!: any | undefined;

    constructor(data?: ICustomAttributeTypedArgument) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).argumentType = data["argumentType"] ? Type.fromJS(data["argumentType"]) : <any>undefined;
            (<any>this).value = data["value"];
        }
    }

    static fromJS(data: any): CustomAttributeTypedArgument {
        data = typeof data === 'object' ? data : {};
        let result = new CustomAttributeTypedArgument();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["argumentType"] = this.argumentType ? this.argumentType.toJSON() : <any>undefined;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICustomAttributeTypedArgument {
    argumentType: Type | undefined;
    value: any | undefined;
}

export class MemberInfo implements IMemberInfo {
    readonly memberType!: MemberTypes;
    readonly name!: string | undefined;
    readonly declaringType!: Type | undefined;
    readonly reflectedType!: Type | undefined;
    readonly module!: Module | undefined;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly isCollectible!: boolean;
    readonly metadataToken!: number;

    constructor(data?: IMemberInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).memberType = data["memberType"];
            (<any>this).name = data["name"];
            (<any>this).declaringType = data["declaringType"] ? Type.fromJS(data["declaringType"]) : <any>undefined;
            (<any>this).reflectedType = data["reflectedType"] ? Type.fromJS(data["reflectedType"]) : <any>undefined;
            (<any>this).module = data["module"] ? Module.fromJS(data["module"]) : <any>undefined;
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): MemberInfo {
        data = typeof data === 'object' ? data : {};
        let result = new MemberInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["memberType"] = this.memberType;
        data["name"] = this.name;
        data["declaringType"] = this.declaringType ? this.declaringType.toJSON() : <any>undefined;
        data["reflectedType"] = this.reflectedType ? this.reflectedType.toJSON() : <any>undefined;
        data["module"] = this.module ? this.module.toJSON() : <any>undefined;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["isCollectible"] = this.isCollectible;
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IMemberInfo {
    memberType: MemberTypes;
    name: string | undefined;
    declaringType: Type | undefined;
    reflectedType: Type | undefined;
    module: Module | undefined;
    customAttributes: CustomAttributeData[] | undefined;
    isCollectible: boolean;
    metadataToken: number;
}

export class CustomAttributeNamedArgument implements ICustomAttributeNamedArgument {
    readonly memberInfo!: MemberInfo | undefined;
    readonly typedValue!: CustomAttributeTypedArgument;
    readonly memberName!: string | undefined;
    readonly isField!: boolean;

    constructor(data?: ICustomAttributeNamedArgument) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).memberInfo = data["memberInfo"] ? MemberInfo.fromJS(data["memberInfo"]) : <any>undefined;
            (<any>this).typedValue = data["typedValue"] ? CustomAttributeTypedArgument.fromJS(data["typedValue"]) : <any>undefined;
            (<any>this).memberName = data["memberName"];
            (<any>this).isField = data["isField"];
        }
    }

    static fromJS(data: any): CustomAttributeNamedArgument {
        data = typeof data === 'object' ? data : {};
        let result = new CustomAttributeNamedArgument();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["memberInfo"] = this.memberInfo ? this.memberInfo.toJSON() : <any>undefined;
        data["typedValue"] = this.typedValue ? this.typedValue.toJSON() : <any>undefined;
        data["memberName"] = this.memberName;
        data["isField"] = this.isField;
        return data; 
    }
}

export interface ICustomAttributeNamedArgument {
    memberInfo: MemberInfo | undefined;
    typedValue: CustomAttributeTypedArgument;
    memberName: string | undefined;
    isField: boolean;
}

export class CustomAttributeData implements ICustomAttributeData {
    readonly attributeType!: Type | undefined;
    readonly constructor_!: ConstructorInfo | undefined;
    readonly constructorArguments!: CustomAttributeTypedArgument[] | undefined;
    readonly namedArguments!: CustomAttributeNamedArgument[] | undefined;

    constructor(data?: ICustomAttributeData) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).attributeType = data["attributeType"] ? Type.fromJS(data["attributeType"]) : <any>undefined;
            (<any>this).constructor_ = data["constructor"] ? ConstructorInfo.fromJS(data["constructor"]) : <any>undefined;
            if (Array.isArray(data["constructorArguments"])) {
                (<any>this).constructorArguments = [] as any;
                for (let item of data["constructorArguments"])
                    (<any>this).constructorArguments!.push(CustomAttributeTypedArgument.fromJS(item));
            }
            if (Array.isArray(data["namedArguments"])) {
                (<any>this).namedArguments = [] as any;
                for (let item of data["namedArguments"])
                    (<any>this).namedArguments!.push(CustomAttributeNamedArgument.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CustomAttributeData {
        data = typeof data === 'object' ? data : {};
        let result = new CustomAttributeData();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["attributeType"] = this.attributeType ? this.attributeType.toJSON() : <any>undefined;
        data["constructor"] = this.constructor_ ? this.constructor_.toJSON() : <any>undefined;
        if (Array.isArray(this.constructorArguments)) {
            data["constructorArguments"] = [];
            for (let item of this.constructorArguments)
                data["constructorArguments"].push(item.toJSON());
        }
        if (Array.isArray(this.namedArguments)) {
            data["namedArguments"] = [];
            for (let item of this.namedArguments)
                data["namedArguments"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICustomAttributeData {
    attributeType: Type | undefined;
    constructor_: ConstructorInfo | undefined;
    constructorArguments: CustomAttributeTypedArgument[] | undefined;
    namedArguments: CustomAttributeNamedArgument[] | undefined;
}

export class Module implements IModule {
    readonly assembly!: Assembly | undefined;
    readonly fullyQualifiedName!: string | undefined;
    readonly name!: string | undefined;
    readonly mdStreamVersion!: number;
    readonly moduleVersionId!: string;
    readonly scopeName!: string | undefined;
    readonly moduleHandle!: ModuleHandle;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly metadataToken!: number;

    constructor(data?: IModule) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).assembly = data["assembly"] ? Assembly.fromJS(data["assembly"]) : <any>undefined;
            (<any>this).fullyQualifiedName = data["fullyQualifiedName"];
            (<any>this).name = data["name"];
            (<any>this).mdStreamVersion = data["mdStreamVersion"];
            (<any>this).moduleVersionId = data["moduleVersionId"];
            (<any>this).scopeName = data["scopeName"];
            (<any>this).moduleHandle = data["moduleHandle"] ? ModuleHandle.fromJS(data["moduleHandle"]) : <any>undefined;
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): Module {
        data = typeof data === 'object' ? data : {};
        let result = new Module();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["assembly"] = this.assembly ? this.assembly.toJSON() : <any>undefined;
        data["fullyQualifiedName"] = this.fullyQualifiedName;
        data["name"] = this.name;
        data["mdStreamVersion"] = this.mdStreamVersion;
        data["moduleVersionId"] = this.moduleVersionId;
        data["scopeName"] = this.scopeName;
        data["moduleHandle"] = this.moduleHandle ? this.moduleHandle.toJSON() : <any>undefined;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IModule {
    assembly: Assembly | undefined;
    fullyQualifiedName: string | undefined;
    name: string | undefined;
    mdStreamVersion: number;
    moduleVersionId: string;
    scopeName: string | undefined;
    moduleHandle: ModuleHandle;
    customAttributes: CustomAttributeData[] | undefined;
    metadataToken: number;
}

export class ConstructorInfo implements IConstructorInfo {
    readonly memberType!: MemberTypes;
    readonly attributes!: MethodAttributes;
    readonly methodImplementationFlags!: MethodImplAttributes;
    readonly callingConvention!: CallingConventions;
    readonly isAbstract!: boolean;
    readonly isConstructor!: boolean;
    readonly isFinal!: boolean;
    readonly isHideBySig!: boolean;
    readonly isSpecialName!: boolean;
    readonly isStatic!: boolean;
    readonly isVirtual!: boolean;
    readonly isAssembly!: boolean;
    readonly isFamily!: boolean;
    readonly isFamilyAndAssembly!: boolean;
    readonly isFamilyOrAssembly!: boolean;
    readonly isPrivate!: boolean;
    readonly isPublic!: boolean;
    readonly isConstructedGenericMethod!: boolean;
    readonly isGenericMethod!: boolean;
    readonly isGenericMethodDefinition!: boolean;
    readonly containsGenericParameters!: boolean;
    readonly methodHandle!: RuntimeMethodHandle;
    readonly isSecurityCritical!: boolean;
    readonly isSecuritySafeCritical!: boolean;
    readonly isSecurityTransparent!: boolean;
    readonly name!: string | undefined;
    readonly declaringType!: Type | undefined;
    readonly reflectedType!: Type | undefined;
    readonly module!: Module | undefined;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly isCollectible!: boolean;
    readonly metadataToken!: number;

    constructor(data?: IConstructorInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).memberType = data["memberType"];
            (<any>this).attributes = data["attributes"];
            (<any>this).methodImplementationFlags = data["methodImplementationFlags"];
            (<any>this).callingConvention = data["callingConvention"];
            (<any>this).isAbstract = data["isAbstract"];
            (<any>this).isConstructor = data["isConstructor"];
            (<any>this).isFinal = data["isFinal"];
            (<any>this).isHideBySig = data["isHideBySig"];
            (<any>this).isSpecialName = data["isSpecialName"];
            (<any>this).isStatic = data["isStatic"];
            (<any>this).isVirtual = data["isVirtual"];
            (<any>this).isAssembly = data["isAssembly"];
            (<any>this).isFamily = data["isFamily"];
            (<any>this).isFamilyAndAssembly = data["isFamilyAndAssembly"];
            (<any>this).isFamilyOrAssembly = data["isFamilyOrAssembly"];
            (<any>this).isPrivate = data["isPrivate"];
            (<any>this).isPublic = data["isPublic"];
            (<any>this).isConstructedGenericMethod = data["isConstructedGenericMethod"];
            (<any>this).isGenericMethod = data["isGenericMethod"];
            (<any>this).isGenericMethodDefinition = data["isGenericMethodDefinition"];
            (<any>this).containsGenericParameters = data["containsGenericParameters"];
            (<any>this).methodHandle = data["methodHandle"] ? RuntimeMethodHandle.fromJS(data["methodHandle"]) : <any>undefined;
            (<any>this).isSecurityCritical = data["isSecurityCritical"];
            (<any>this).isSecuritySafeCritical = data["isSecuritySafeCritical"];
            (<any>this).isSecurityTransparent = data["isSecurityTransparent"];
            (<any>this).name = data["name"];
            (<any>this).declaringType = data["declaringType"] ? Type.fromJS(data["declaringType"]) : <any>undefined;
            (<any>this).reflectedType = data["reflectedType"] ? Type.fromJS(data["reflectedType"]) : <any>undefined;
            (<any>this).module = data["module"] ? Module.fromJS(data["module"]) : <any>undefined;
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): ConstructorInfo {
        data = typeof data === 'object' ? data : {};
        let result = new ConstructorInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["memberType"] = this.memberType;
        data["attributes"] = this.attributes;
        data["methodImplementationFlags"] = this.methodImplementationFlags;
        data["callingConvention"] = this.callingConvention;
        data["isAbstract"] = this.isAbstract;
        data["isConstructor"] = this.isConstructor;
        data["isFinal"] = this.isFinal;
        data["isHideBySig"] = this.isHideBySig;
        data["isSpecialName"] = this.isSpecialName;
        data["isStatic"] = this.isStatic;
        data["isVirtual"] = this.isVirtual;
        data["isAssembly"] = this.isAssembly;
        data["isFamily"] = this.isFamily;
        data["isFamilyAndAssembly"] = this.isFamilyAndAssembly;
        data["isFamilyOrAssembly"] = this.isFamilyOrAssembly;
        data["isPrivate"] = this.isPrivate;
        data["isPublic"] = this.isPublic;
        data["isConstructedGenericMethod"] = this.isConstructedGenericMethod;
        data["isGenericMethod"] = this.isGenericMethod;
        data["isGenericMethodDefinition"] = this.isGenericMethodDefinition;
        data["containsGenericParameters"] = this.containsGenericParameters;
        data["methodHandle"] = this.methodHandle ? this.methodHandle.toJSON() : <any>undefined;
        data["isSecurityCritical"] = this.isSecurityCritical;
        data["isSecuritySafeCritical"] = this.isSecuritySafeCritical;
        data["isSecurityTransparent"] = this.isSecurityTransparent;
        data["name"] = this.name;
        data["declaringType"] = this.declaringType ? this.declaringType.toJSON() : <any>undefined;
        data["reflectedType"] = this.reflectedType ? this.reflectedType.toJSON() : <any>undefined;
        data["module"] = this.module ? this.module.toJSON() : <any>undefined;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["isCollectible"] = this.isCollectible;
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IConstructorInfo {
    memberType: MemberTypes;
    attributes: MethodAttributes;
    methodImplementationFlags: MethodImplAttributes;
    callingConvention: CallingConventions;
    isAbstract: boolean;
    isConstructor: boolean;
    isFinal: boolean;
    isHideBySig: boolean;
    isSpecialName: boolean;
    isStatic: boolean;
    isVirtual: boolean;
    isAssembly: boolean;
    isFamily: boolean;
    isFamilyAndAssembly: boolean;
    isFamilyOrAssembly: boolean;
    isPrivate: boolean;
    isPublic: boolean;
    isConstructedGenericMethod: boolean;
    isGenericMethod: boolean;
    isGenericMethodDefinition: boolean;
    containsGenericParameters: boolean;
    methodHandle: RuntimeMethodHandle;
    isSecurityCritical: boolean;
    isSecuritySafeCritical: boolean;
    isSecurityTransparent: boolean;
    name: string | undefined;
    declaringType: Type | undefined;
    reflectedType: Type | undefined;
    module: Module | undefined;
    customAttributes: CustomAttributeData[] | undefined;
    isCollectible: boolean;
    metadataToken: number;
}

export enum EventAttributes {
    None = 0,
    SpecialName = 512,
    RTSpecialName = 1024,
    ReservedMask = 1024,
}

export enum ParameterAttributes {
    None = 0,
    In = 1,
    Out = 2,
    Lcid = 4,
    Retval = 8,
    Optional = 16,
    HasDefault = 4096,
    HasFieldMarshal = 8192,
    Reserved3 = 16384,
    Reserved4 = 32768,
    ReservedMask = 61440,
}

export class ParameterInfo implements IParameterInfo {
    readonly attributes!: ParameterAttributes;
    readonly member!: MemberInfo | undefined;
    readonly name!: string | undefined;
    readonly parameterType!: Type | undefined;
    readonly position!: number;
    readonly isIn!: boolean;
    readonly isLcid!: boolean;
    readonly isOptional!: boolean;
    readonly isOut!: boolean;
    readonly isRetval!: boolean;
    readonly defaultValue!: any | undefined;
    readonly rawDefaultValue!: any | undefined;
    readonly hasDefaultValue!: boolean;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly metadataToken!: number;

    constructor(data?: IParameterInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).attributes = data["attributes"];
            (<any>this).member = data["member"] ? MemberInfo.fromJS(data["member"]) : <any>undefined;
            (<any>this).name = data["name"];
            (<any>this).parameterType = data["parameterType"] ? Type.fromJS(data["parameterType"]) : <any>undefined;
            (<any>this).position = data["position"];
            (<any>this).isIn = data["isIn"];
            (<any>this).isLcid = data["isLcid"];
            (<any>this).isOptional = data["isOptional"];
            (<any>this).isOut = data["isOut"];
            (<any>this).isRetval = data["isRetval"];
            (<any>this).defaultValue = data["defaultValue"];
            (<any>this).rawDefaultValue = data["rawDefaultValue"];
            (<any>this).hasDefaultValue = data["hasDefaultValue"];
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): ParameterInfo {
        data = typeof data === 'object' ? data : {};
        let result = new ParameterInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["attributes"] = this.attributes;
        data["member"] = this.member ? this.member.toJSON() : <any>undefined;
        data["name"] = this.name;
        data["parameterType"] = this.parameterType ? this.parameterType.toJSON() : <any>undefined;
        data["position"] = this.position;
        data["isIn"] = this.isIn;
        data["isLcid"] = this.isLcid;
        data["isOptional"] = this.isOptional;
        data["isOut"] = this.isOut;
        data["isRetval"] = this.isRetval;
        data["defaultValue"] = this.defaultValue;
        data["rawDefaultValue"] = this.rawDefaultValue;
        data["hasDefaultValue"] = this.hasDefaultValue;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IParameterInfo {
    attributes: ParameterAttributes;
    member: MemberInfo | undefined;
    name: string | undefined;
    parameterType: Type | undefined;
    position: number;
    isIn: boolean;
    isLcid: boolean;
    isOptional: boolean;
    isOut: boolean;
    isRetval: boolean;
    defaultValue: any | undefined;
    rawDefaultValue: any | undefined;
    hasDefaultValue: boolean;
    customAttributes: CustomAttributeData[] | undefined;
    metadataToken: number;
}

export class ICustomAttributeProvider implements IICustomAttributeProvider {

    constructor(data?: IICustomAttributeProvider) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): ICustomAttributeProvider {
        data = typeof data === 'object' ? data : {};
        let result = new ICustomAttributeProvider();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IICustomAttributeProvider {
}

export class MethodInfo implements IMethodInfo {
    readonly memberType!: MemberTypes;
    readonly returnParameter!: ParameterInfo | undefined;
    readonly returnType!: Type | undefined;
    readonly returnTypeCustomAttributes!: ICustomAttributeProvider | undefined;
    readonly attributes!: MethodAttributes;
    readonly methodImplementationFlags!: MethodImplAttributes;
    readonly callingConvention!: CallingConventions;
    readonly isAbstract!: boolean;
    readonly isConstructor!: boolean;
    readonly isFinal!: boolean;
    readonly isHideBySig!: boolean;
    readonly isSpecialName!: boolean;
    readonly isStatic!: boolean;
    readonly isVirtual!: boolean;
    readonly isAssembly!: boolean;
    readonly isFamily!: boolean;
    readonly isFamilyAndAssembly!: boolean;
    readonly isFamilyOrAssembly!: boolean;
    readonly isPrivate!: boolean;
    readonly isPublic!: boolean;
    readonly isConstructedGenericMethod!: boolean;
    readonly isGenericMethod!: boolean;
    readonly isGenericMethodDefinition!: boolean;
    readonly containsGenericParameters!: boolean;
    readonly methodHandle!: RuntimeMethodHandle;
    readonly isSecurityCritical!: boolean;
    readonly isSecuritySafeCritical!: boolean;
    readonly isSecurityTransparent!: boolean;
    readonly name!: string | undefined;
    readonly declaringType!: Type | undefined;
    readonly reflectedType!: Type | undefined;
    readonly module!: Module | undefined;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly isCollectible!: boolean;
    readonly metadataToken!: number;

    constructor(data?: IMethodInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).memberType = data["memberType"];
            (<any>this).returnParameter = data["returnParameter"] ? ParameterInfo.fromJS(data["returnParameter"]) : <any>undefined;
            (<any>this).returnType = data["returnType"] ? Type.fromJS(data["returnType"]) : <any>undefined;
            (<any>this).returnTypeCustomAttributes = data["returnTypeCustomAttributes"] ? ICustomAttributeProvider.fromJS(data["returnTypeCustomAttributes"]) : <any>undefined;
            (<any>this).attributes = data["attributes"];
            (<any>this).methodImplementationFlags = data["methodImplementationFlags"];
            (<any>this).callingConvention = data["callingConvention"];
            (<any>this).isAbstract = data["isAbstract"];
            (<any>this).isConstructor = data["isConstructor"];
            (<any>this).isFinal = data["isFinal"];
            (<any>this).isHideBySig = data["isHideBySig"];
            (<any>this).isSpecialName = data["isSpecialName"];
            (<any>this).isStatic = data["isStatic"];
            (<any>this).isVirtual = data["isVirtual"];
            (<any>this).isAssembly = data["isAssembly"];
            (<any>this).isFamily = data["isFamily"];
            (<any>this).isFamilyAndAssembly = data["isFamilyAndAssembly"];
            (<any>this).isFamilyOrAssembly = data["isFamilyOrAssembly"];
            (<any>this).isPrivate = data["isPrivate"];
            (<any>this).isPublic = data["isPublic"];
            (<any>this).isConstructedGenericMethod = data["isConstructedGenericMethod"];
            (<any>this).isGenericMethod = data["isGenericMethod"];
            (<any>this).isGenericMethodDefinition = data["isGenericMethodDefinition"];
            (<any>this).containsGenericParameters = data["containsGenericParameters"];
            (<any>this).methodHandle = data["methodHandle"] ? RuntimeMethodHandle.fromJS(data["methodHandle"]) : <any>undefined;
            (<any>this).isSecurityCritical = data["isSecurityCritical"];
            (<any>this).isSecuritySafeCritical = data["isSecuritySafeCritical"];
            (<any>this).isSecurityTransparent = data["isSecurityTransparent"];
            (<any>this).name = data["name"];
            (<any>this).declaringType = data["declaringType"] ? Type.fromJS(data["declaringType"]) : <any>undefined;
            (<any>this).reflectedType = data["reflectedType"] ? Type.fromJS(data["reflectedType"]) : <any>undefined;
            (<any>this).module = data["module"] ? Module.fromJS(data["module"]) : <any>undefined;
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): MethodInfo {
        data = typeof data === 'object' ? data : {};
        let result = new MethodInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["memberType"] = this.memberType;
        data["returnParameter"] = this.returnParameter ? this.returnParameter.toJSON() : <any>undefined;
        data["returnType"] = this.returnType ? this.returnType.toJSON() : <any>undefined;
        data["returnTypeCustomAttributes"] = this.returnTypeCustomAttributes ? this.returnTypeCustomAttributes.toJSON() : <any>undefined;
        data["attributes"] = this.attributes;
        data["methodImplementationFlags"] = this.methodImplementationFlags;
        data["callingConvention"] = this.callingConvention;
        data["isAbstract"] = this.isAbstract;
        data["isConstructor"] = this.isConstructor;
        data["isFinal"] = this.isFinal;
        data["isHideBySig"] = this.isHideBySig;
        data["isSpecialName"] = this.isSpecialName;
        data["isStatic"] = this.isStatic;
        data["isVirtual"] = this.isVirtual;
        data["isAssembly"] = this.isAssembly;
        data["isFamily"] = this.isFamily;
        data["isFamilyAndAssembly"] = this.isFamilyAndAssembly;
        data["isFamilyOrAssembly"] = this.isFamilyOrAssembly;
        data["isPrivate"] = this.isPrivate;
        data["isPublic"] = this.isPublic;
        data["isConstructedGenericMethod"] = this.isConstructedGenericMethod;
        data["isGenericMethod"] = this.isGenericMethod;
        data["isGenericMethodDefinition"] = this.isGenericMethodDefinition;
        data["containsGenericParameters"] = this.containsGenericParameters;
        data["methodHandle"] = this.methodHandle ? this.methodHandle.toJSON() : <any>undefined;
        data["isSecurityCritical"] = this.isSecurityCritical;
        data["isSecuritySafeCritical"] = this.isSecuritySafeCritical;
        data["isSecurityTransparent"] = this.isSecurityTransparent;
        data["name"] = this.name;
        data["declaringType"] = this.declaringType ? this.declaringType.toJSON() : <any>undefined;
        data["reflectedType"] = this.reflectedType ? this.reflectedType.toJSON() : <any>undefined;
        data["module"] = this.module ? this.module.toJSON() : <any>undefined;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["isCollectible"] = this.isCollectible;
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IMethodInfo {
    memberType: MemberTypes;
    returnParameter: ParameterInfo | undefined;
    returnType: Type | undefined;
    returnTypeCustomAttributes: ICustomAttributeProvider | undefined;
    attributes: MethodAttributes;
    methodImplementationFlags: MethodImplAttributes;
    callingConvention: CallingConventions;
    isAbstract: boolean;
    isConstructor: boolean;
    isFinal: boolean;
    isHideBySig: boolean;
    isSpecialName: boolean;
    isStatic: boolean;
    isVirtual: boolean;
    isAssembly: boolean;
    isFamily: boolean;
    isFamilyAndAssembly: boolean;
    isFamilyOrAssembly: boolean;
    isPrivate: boolean;
    isPublic: boolean;
    isConstructedGenericMethod: boolean;
    isGenericMethod: boolean;
    isGenericMethodDefinition: boolean;
    containsGenericParameters: boolean;
    methodHandle: RuntimeMethodHandle;
    isSecurityCritical: boolean;
    isSecuritySafeCritical: boolean;
    isSecurityTransparent: boolean;
    name: string | undefined;
    declaringType: Type | undefined;
    reflectedType: Type | undefined;
    module: Module | undefined;
    customAttributes: CustomAttributeData[] | undefined;
    isCollectible: boolean;
    metadataToken: number;
}

export class EventInfo implements IEventInfo {
    readonly memberType!: MemberTypes;
    readonly attributes!: EventAttributes;
    readonly isSpecialName!: boolean;
    readonly addMethod!: MethodInfo | undefined;
    readonly removeMethod!: MethodInfo | undefined;
    readonly raiseMethod!: MethodInfo | undefined;
    readonly isMulticast!: boolean;
    readonly eventHandlerType!: Type | undefined;
    readonly name!: string | undefined;
    readonly declaringType!: Type | undefined;
    readonly reflectedType!: Type | undefined;
    readonly module!: Module | undefined;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly isCollectible!: boolean;
    readonly metadataToken!: number;

    constructor(data?: IEventInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).memberType = data["memberType"];
            (<any>this).attributes = data["attributes"];
            (<any>this).isSpecialName = data["isSpecialName"];
            (<any>this).addMethod = data["addMethod"] ? MethodInfo.fromJS(data["addMethod"]) : <any>undefined;
            (<any>this).removeMethod = data["removeMethod"] ? MethodInfo.fromJS(data["removeMethod"]) : <any>undefined;
            (<any>this).raiseMethod = data["raiseMethod"] ? MethodInfo.fromJS(data["raiseMethod"]) : <any>undefined;
            (<any>this).isMulticast = data["isMulticast"];
            (<any>this).eventHandlerType = data["eventHandlerType"] ? Type.fromJS(data["eventHandlerType"]) : <any>undefined;
            (<any>this).name = data["name"];
            (<any>this).declaringType = data["declaringType"] ? Type.fromJS(data["declaringType"]) : <any>undefined;
            (<any>this).reflectedType = data["reflectedType"] ? Type.fromJS(data["reflectedType"]) : <any>undefined;
            (<any>this).module = data["module"] ? Module.fromJS(data["module"]) : <any>undefined;
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): EventInfo {
        data = typeof data === 'object' ? data : {};
        let result = new EventInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["memberType"] = this.memberType;
        data["attributes"] = this.attributes;
        data["isSpecialName"] = this.isSpecialName;
        data["addMethod"] = this.addMethod ? this.addMethod.toJSON() : <any>undefined;
        data["removeMethod"] = this.removeMethod ? this.removeMethod.toJSON() : <any>undefined;
        data["raiseMethod"] = this.raiseMethod ? this.raiseMethod.toJSON() : <any>undefined;
        data["isMulticast"] = this.isMulticast;
        data["eventHandlerType"] = this.eventHandlerType ? this.eventHandlerType.toJSON() : <any>undefined;
        data["name"] = this.name;
        data["declaringType"] = this.declaringType ? this.declaringType.toJSON() : <any>undefined;
        data["reflectedType"] = this.reflectedType ? this.reflectedType.toJSON() : <any>undefined;
        data["module"] = this.module ? this.module.toJSON() : <any>undefined;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["isCollectible"] = this.isCollectible;
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IEventInfo {
    memberType: MemberTypes;
    attributes: EventAttributes;
    isSpecialName: boolean;
    addMethod: MethodInfo | undefined;
    removeMethod: MethodInfo | undefined;
    raiseMethod: MethodInfo | undefined;
    isMulticast: boolean;
    eventHandlerType: Type | undefined;
    name: string | undefined;
    declaringType: Type | undefined;
    reflectedType: Type | undefined;
    module: Module | undefined;
    customAttributes: CustomAttributeData[] | undefined;
    isCollectible: boolean;
    metadataToken: number;
}

export enum FieldAttributes {
    PrivateScope = 0,
    Private = 1,
    FamANDAssem = 2,
    Assembly = 3,
    Family = 4,
    FamORAssem = 5,
    Public = 6,
    FieldAccessMask = 7,
    Static = 16,
    InitOnly = 32,
    Literal = 64,
    NotSerialized = 128,
    HasFieldRVA = 256,
    SpecialName = 512,
    RTSpecialName = 1024,
    HasFieldMarshal = 4096,
    PinvokeImpl = 8192,
    HasDefault = 32768,
    ReservedMask = 38144,
}

export class RuntimeFieldHandle implements IRuntimeFieldHandle {
    readonly value!: IntPtr;

    constructor(data?: IRuntimeFieldHandle) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).value = data["value"] ? IntPtr.fromJS(data["value"]) : <any>undefined;
        }
    }

    static fromJS(data: any): RuntimeFieldHandle {
        data = typeof data === 'object' ? data : {};
        let result = new RuntimeFieldHandle();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value ? this.value.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IRuntimeFieldHandle {
    value: IntPtr;
}

export class FieldInfo implements IFieldInfo {
    readonly memberType!: MemberTypes;
    readonly attributes!: FieldAttributes;
    readonly fieldType!: Type | undefined;
    readonly isInitOnly!: boolean;
    readonly isLiteral!: boolean;
    readonly isNotSerialized!: boolean;
    readonly isPinvokeImpl!: boolean;
    readonly isSpecialName!: boolean;
    readonly isStatic!: boolean;
    readonly isAssembly!: boolean;
    readonly isFamily!: boolean;
    readonly isFamilyAndAssembly!: boolean;
    readonly isFamilyOrAssembly!: boolean;
    readonly isPrivate!: boolean;
    readonly isPublic!: boolean;
    readonly isSecurityCritical!: boolean;
    readonly isSecuritySafeCritical!: boolean;
    readonly isSecurityTransparent!: boolean;
    readonly fieldHandle!: RuntimeFieldHandle;
    readonly name!: string | undefined;
    readonly declaringType!: Type | undefined;
    readonly reflectedType!: Type | undefined;
    readonly module!: Module | undefined;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly isCollectible!: boolean;
    readonly metadataToken!: number;

    constructor(data?: IFieldInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).memberType = data["memberType"];
            (<any>this).attributes = data["attributes"];
            (<any>this).fieldType = data["fieldType"] ? Type.fromJS(data["fieldType"]) : <any>undefined;
            (<any>this).isInitOnly = data["isInitOnly"];
            (<any>this).isLiteral = data["isLiteral"];
            (<any>this).isNotSerialized = data["isNotSerialized"];
            (<any>this).isPinvokeImpl = data["isPinvokeImpl"];
            (<any>this).isSpecialName = data["isSpecialName"];
            (<any>this).isStatic = data["isStatic"];
            (<any>this).isAssembly = data["isAssembly"];
            (<any>this).isFamily = data["isFamily"];
            (<any>this).isFamilyAndAssembly = data["isFamilyAndAssembly"];
            (<any>this).isFamilyOrAssembly = data["isFamilyOrAssembly"];
            (<any>this).isPrivate = data["isPrivate"];
            (<any>this).isPublic = data["isPublic"];
            (<any>this).isSecurityCritical = data["isSecurityCritical"];
            (<any>this).isSecuritySafeCritical = data["isSecuritySafeCritical"];
            (<any>this).isSecurityTransparent = data["isSecurityTransparent"];
            (<any>this).fieldHandle = data["fieldHandle"] ? RuntimeFieldHandle.fromJS(data["fieldHandle"]) : <any>undefined;
            (<any>this).name = data["name"];
            (<any>this).declaringType = data["declaringType"] ? Type.fromJS(data["declaringType"]) : <any>undefined;
            (<any>this).reflectedType = data["reflectedType"] ? Type.fromJS(data["reflectedType"]) : <any>undefined;
            (<any>this).module = data["module"] ? Module.fromJS(data["module"]) : <any>undefined;
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): FieldInfo {
        data = typeof data === 'object' ? data : {};
        let result = new FieldInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["memberType"] = this.memberType;
        data["attributes"] = this.attributes;
        data["fieldType"] = this.fieldType ? this.fieldType.toJSON() : <any>undefined;
        data["isInitOnly"] = this.isInitOnly;
        data["isLiteral"] = this.isLiteral;
        data["isNotSerialized"] = this.isNotSerialized;
        data["isPinvokeImpl"] = this.isPinvokeImpl;
        data["isSpecialName"] = this.isSpecialName;
        data["isStatic"] = this.isStatic;
        data["isAssembly"] = this.isAssembly;
        data["isFamily"] = this.isFamily;
        data["isFamilyAndAssembly"] = this.isFamilyAndAssembly;
        data["isFamilyOrAssembly"] = this.isFamilyOrAssembly;
        data["isPrivate"] = this.isPrivate;
        data["isPublic"] = this.isPublic;
        data["isSecurityCritical"] = this.isSecurityCritical;
        data["isSecuritySafeCritical"] = this.isSecuritySafeCritical;
        data["isSecurityTransparent"] = this.isSecurityTransparent;
        data["fieldHandle"] = this.fieldHandle ? this.fieldHandle.toJSON() : <any>undefined;
        data["name"] = this.name;
        data["declaringType"] = this.declaringType ? this.declaringType.toJSON() : <any>undefined;
        data["reflectedType"] = this.reflectedType ? this.reflectedType.toJSON() : <any>undefined;
        data["module"] = this.module ? this.module.toJSON() : <any>undefined;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["isCollectible"] = this.isCollectible;
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IFieldInfo {
    memberType: MemberTypes;
    attributes: FieldAttributes;
    fieldType: Type | undefined;
    isInitOnly: boolean;
    isLiteral: boolean;
    isNotSerialized: boolean;
    isPinvokeImpl: boolean;
    isSpecialName: boolean;
    isStatic: boolean;
    isAssembly: boolean;
    isFamily: boolean;
    isFamilyAndAssembly: boolean;
    isFamilyOrAssembly: boolean;
    isPrivate: boolean;
    isPublic: boolean;
    isSecurityCritical: boolean;
    isSecuritySafeCritical: boolean;
    isSecurityTransparent: boolean;
    fieldHandle: RuntimeFieldHandle;
    name: string | undefined;
    declaringType: Type | undefined;
    reflectedType: Type | undefined;
    module: Module | undefined;
    customAttributes: CustomAttributeData[] | undefined;
    isCollectible: boolean;
    metadataToken: number;
}

export enum PropertyAttributes {
    None = 0,
    SpecialName = 512,
    RTSpecialName = 1024,
    HasDefault = 4096,
    Reserved2 = 8192,
    Reserved3 = 16384,
    Reserved4 = 32768,
    ReservedMask = 62464,
}

export class PropertyInfo implements IPropertyInfo {
    readonly memberType!: MemberTypes;
    readonly propertyType!: Type | undefined;
    readonly attributes!: PropertyAttributes;
    readonly isSpecialName!: boolean;
    readonly canRead!: boolean;
    readonly canWrite!: boolean;
    readonly getMethod!: MethodInfo | undefined;
    readonly setMethod!: MethodInfo | undefined;
    readonly name!: string | undefined;
    readonly declaringType!: Type | undefined;
    readonly reflectedType!: Type | undefined;
    readonly module!: Module | undefined;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly isCollectible!: boolean;
    readonly metadataToken!: number;

    constructor(data?: IPropertyInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).memberType = data["memberType"];
            (<any>this).propertyType = data["propertyType"] ? Type.fromJS(data["propertyType"]) : <any>undefined;
            (<any>this).attributes = data["attributes"];
            (<any>this).isSpecialName = data["isSpecialName"];
            (<any>this).canRead = data["canRead"];
            (<any>this).canWrite = data["canWrite"];
            (<any>this).getMethod = data["getMethod"] ? MethodInfo.fromJS(data["getMethod"]) : <any>undefined;
            (<any>this).setMethod = data["setMethod"] ? MethodInfo.fromJS(data["setMethod"]) : <any>undefined;
            (<any>this).name = data["name"];
            (<any>this).declaringType = data["declaringType"] ? Type.fromJS(data["declaringType"]) : <any>undefined;
            (<any>this).reflectedType = data["reflectedType"] ? Type.fromJS(data["reflectedType"]) : <any>undefined;
            (<any>this).module = data["module"] ? Module.fromJS(data["module"]) : <any>undefined;
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): PropertyInfo {
        data = typeof data === 'object' ? data : {};
        let result = new PropertyInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["memberType"] = this.memberType;
        data["propertyType"] = this.propertyType ? this.propertyType.toJSON() : <any>undefined;
        data["attributes"] = this.attributes;
        data["isSpecialName"] = this.isSpecialName;
        data["canRead"] = this.canRead;
        data["canWrite"] = this.canWrite;
        data["getMethod"] = this.getMethod ? this.getMethod.toJSON() : <any>undefined;
        data["setMethod"] = this.setMethod ? this.setMethod.toJSON() : <any>undefined;
        data["name"] = this.name;
        data["declaringType"] = this.declaringType ? this.declaringType.toJSON() : <any>undefined;
        data["reflectedType"] = this.reflectedType ? this.reflectedType.toJSON() : <any>undefined;
        data["module"] = this.module ? this.module.toJSON() : <any>undefined;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["isCollectible"] = this.isCollectible;
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IPropertyInfo {
    memberType: MemberTypes;
    propertyType: Type | undefined;
    attributes: PropertyAttributes;
    isSpecialName: boolean;
    canRead: boolean;
    canWrite: boolean;
    getMethod: MethodInfo | undefined;
    setMethod: MethodInfo | undefined;
    name: string | undefined;
    declaringType: Type | undefined;
    reflectedType: Type | undefined;
    module: Module | undefined;
    customAttributes: CustomAttributeData[] | undefined;
    isCollectible: boolean;
    metadataToken: number;
}

export class MethodBase implements IMethodBase {
    readonly attributes!: MethodAttributes;
    readonly methodImplementationFlags!: MethodImplAttributes;
    readonly callingConvention!: CallingConventions;
    readonly isAbstract!: boolean;
    readonly isConstructor!: boolean;
    readonly isFinal!: boolean;
    readonly isHideBySig!: boolean;
    readonly isSpecialName!: boolean;
    readonly isStatic!: boolean;
    readonly isVirtual!: boolean;
    readonly isAssembly!: boolean;
    readonly isFamily!: boolean;
    readonly isFamilyAndAssembly!: boolean;
    readonly isFamilyOrAssembly!: boolean;
    readonly isPrivate!: boolean;
    readonly isPublic!: boolean;
    readonly isConstructedGenericMethod!: boolean;
    readonly isGenericMethod!: boolean;
    readonly isGenericMethodDefinition!: boolean;
    readonly containsGenericParameters!: boolean;
    readonly methodHandle!: RuntimeMethodHandle;
    readonly isSecurityCritical!: boolean;
    readonly isSecuritySafeCritical!: boolean;
    readonly isSecurityTransparent!: boolean;
    readonly memberType!: MemberTypes;
    readonly name!: string | undefined;
    readonly declaringType!: Type | undefined;
    readonly reflectedType!: Type | undefined;
    readonly module!: Module | undefined;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly isCollectible!: boolean;
    readonly metadataToken!: number;

    constructor(data?: IMethodBase) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).attributes = data["attributes"];
            (<any>this).methodImplementationFlags = data["methodImplementationFlags"];
            (<any>this).callingConvention = data["callingConvention"];
            (<any>this).isAbstract = data["isAbstract"];
            (<any>this).isConstructor = data["isConstructor"];
            (<any>this).isFinal = data["isFinal"];
            (<any>this).isHideBySig = data["isHideBySig"];
            (<any>this).isSpecialName = data["isSpecialName"];
            (<any>this).isStatic = data["isStatic"];
            (<any>this).isVirtual = data["isVirtual"];
            (<any>this).isAssembly = data["isAssembly"];
            (<any>this).isFamily = data["isFamily"];
            (<any>this).isFamilyAndAssembly = data["isFamilyAndAssembly"];
            (<any>this).isFamilyOrAssembly = data["isFamilyOrAssembly"];
            (<any>this).isPrivate = data["isPrivate"];
            (<any>this).isPublic = data["isPublic"];
            (<any>this).isConstructedGenericMethod = data["isConstructedGenericMethod"];
            (<any>this).isGenericMethod = data["isGenericMethod"];
            (<any>this).isGenericMethodDefinition = data["isGenericMethodDefinition"];
            (<any>this).containsGenericParameters = data["containsGenericParameters"];
            (<any>this).methodHandle = data["methodHandle"] ? RuntimeMethodHandle.fromJS(data["methodHandle"]) : <any>undefined;
            (<any>this).isSecurityCritical = data["isSecurityCritical"];
            (<any>this).isSecuritySafeCritical = data["isSecuritySafeCritical"];
            (<any>this).isSecurityTransparent = data["isSecurityTransparent"];
            (<any>this).memberType = data["memberType"];
            (<any>this).name = data["name"];
            (<any>this).declaringType = data["declaringType"] ? Type.fromJS(data["declaringType"]) : <any>undefined;
            (<any>this).reflectedType = data["reflectedType"] ? Type.fromJS(data["reflectedType"]) : <any>undefined;
            (<any>this).module = data["module"] ? Module.fromJS(data["module"]) : <any>undefined;
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): MethodBase {
        data = typeof data === 'object' ? data : {};
        let result = new MethodBase();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["attributes"] = this.attributes;
        data["methodImplementationFlags"] = this.methodImplementationFlags;
        data["callingConvention"] = this.callingConvention;
        data["isAbstract"] = this.isAbstract;
        data["isConstructor"] = this.isConstructor;
        data["isFinal"] = this.isFinal;
        data["isHideBySig"] = this.isHideBySig;
        data["isSpecialName"] = this.isSpecialName;
        data["isStatic"] = this.isStatic;
        data["isVirtual"] = this.isVirtual;
        data["isAssembly"] = this.isAssembly;
        data["isFamily"] = this.isFamily;
        data["isFamilyAndAssembly"] = this.isFamilyAndAssembly;
        data["isFamilyOrAssembly"] = this.isFamilyOrAssembly;
        data["isPrivate"] = this.isPrivate;
        data["isPublic"] = this.isPublic;
        data["isConstructedGenericMethod"] = this.isConstructedGenericMethod;
        data["isGenericMethod"] = this.isGenericMethod;
        data["isGenericMethodDefinition"] = this.isGenericMethodDefinition;
        data["containsGenericParameters"] = this.containsGenericParameters;
        data["methodHandle"] = this.methodHandle ? this.methodHandle.toJSON() : <any>undefined;
        data["isSecurityCritical"] = this.isSecurityCritical;
        data["isSecuritySafeCritical"] = this.isSecuritySafeCritical;
        data["isSecurityTransparent"] = this.isSecurityTransparent;
        data["memberType"] = this.memberType;
        data["name"] = this.name;
        data["declaringType"] = this.declaringType ? this.declaringType.toJSON() : <any>undefined;
        data["reflectedType"] = this.reflectedType ? this.reflectedType.toJSON() : <any>undefined;
        data["module"] = this.module ? this.module.toJSON() : <any>undefined;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["isCollectible"] = this.isCollectible;
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IMethodBase {
    attributes: MethodAttributes;
    methodImplementationFlags: MethodImplAttributes;
    callingConvention: CallingConventions;
    isAbstract: boolean;
    isConstructor: boolean;
    isFinal: boolean;
    isHideBySig: boolean;
    isSpecialName: boolean;
    isStatic: boolean;
    isVirtual: boolean;
    isAssembly: boolean;
    isFamily: boolean;
    isFamilyAndAssembly: boolean;
    isFamilyOrAssembly: boolean;
    isPrivate: boolean;
    isPublic: boolean;
    isConstructedGenericMethod: boolean;
    isGenericMethod: boolean;
    isGenericMethodDefinition: boolean;
    containsGenericParameters: boolean;
    methodHandle: RuntimeMethodHandle;
    isSecurityCritical: boolean;
    isSecuritySafeCritical: boolean;
    isSecurityTransparent: boolean;
    memberType: MemberTypes;
    name: string | undefined;
    declaringType: Type | undefined;
    reflectedType: Type | undefined;
    module: Module | undefined;
    customAttributes: CustomAttributeData[] | undefined;
    isCollectible: boolean;
    metadataToken: number;
}

export enum GenericParameterAttributes {
    None = 0,
    Covariant = 1,
    Contravariant = 2,
    VarianceMask = 3,
    ReferenceTypeConstraint = 4,
    NotNullableValueTypeConstraint = 8,
    DefaultConstructorConstraint = 16,
    SpecialConstraintMask = 28,
}

export enum TypeAttributes {
    NotPublic = 0,
    AutoLayout = 0,
    AnsiClass = 0,
    Class = 0,
    Public = 1,
    NestedPublic = 2,
    NestedPrivate = 3,
    NestedFamily = 4,
    NestedAssembly = 5,
    NestedFamANDAssem = 6,
    NestedFamORAssem = 7,
    VisibilityMask = 7,
    SequentialLayout = 8,
    ExplicitLayout = 16,
    LayoutMask = 24,
    Interface = 32,
    ClassSemanticsMask = 32,
    Abstract = 128,
    Sealed = 256,
    SpecialName = 1024,
    RTSpecialName = 2048,
    Import = 4096,
    Serializable = 8192,
    WindowsRuntime = 16384,
    UnicodeClass = 65536,
    AutoClass = 131072,
    CustomFormatClass = 196608,
    StringFormatMask = 196608,
    HasSecurity = 262144,
    ReservedMask = 264192,
    BeforeFieldInit = 1048576,
    CustomFormatMask = 12582912,
}

export enum LayoutKind {
    Sequential = 0,
    Explicit = 2,
    Auto = 3,
}

export class StructLayoutAttribute implements IStructLayoutAttribute {
    readonly value!: LayoutKind;
    readonly typeId!: any | undefined;

    constructor(data?: IStructLayoutAttribute) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).value = data["value"];
            (<any>this).typeId = data["typeId"];
        }
    }

    static fromJS(data: any): StructLayoutAttribute {
        data = typeof data === 'object' ? data : {};
        let result = new StructLayoutAttribute();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["typeId"] = this.typeId;
        return data; 
    }
}

export interface IStructLayoutAttribute {
    value: LayoutKind;
    typeId: any | undefined;
}

export class RuntimeTypeHandle implements IRuntimeTypeHandle {
    readonly value!: IntPtr;

    constructor(data?: IRuntimeTypeHandle) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).value = data["value"] ? IntPtr.fromJS(data["value"]) : <any>undefined;
        }
    }

    static fromJS(data: any): RuntimeTypeHandle {
        data = typeof data === 'object' ? data : {};
        let result = new RuntimeTypeHandle();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value ? this.value.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IRuntimeTypeHandle {
    value: IntPtr;
}

export class TypeInfo implements ITypeInfo {
    readonly genericTypeParameters!: Type[] | undefined;
    readonly declaredConstructors!: ConstructorInfo[] | undefined;
    readonly declaredEvents!: EventInfo[] | undefined;
    readonly declaredFields!: FieldInfo[] | undefined;
    readonly declaredMembers!: MemberInfo[] | undefined;
    readonly declaredMethods!: MethodInfo[] | undefined;
    readonly declaredNestedTypes!: TypeInfo[] | undefined;
    readonly declaredProperties!: PropertyInfo[] | undefined;
    readonly implementedInterfaces!: Type[] | undefined;
    readonly isInterface!: boolean;
    readonly memberType!: MemberTypes;
    readonly namespace!: string | undefined;
    readonly assemblyQualifiedName!: string | undefined;
    readonly fullName!: string | undefined;
    readonly assembly!: Assembly | undefined;
    readonly module!: Module | undefined;
    readonly isNested!: boolean;
    readonly declaringType!: Type | undefined;
    readonly declaringMethod!: MethodBase | undefined;
    readonly reflectedType!: Type | undefined;
    readonly underlyingSystemType!: Type | undefined;
    readonly isTypeDefinition!: boolean;
    readonly isArray!: boolean;
    readonly isByRef!: boolean;
    readonly isPointer!: boolean;
    readonly isConstructedGenericType!: boolean;
    readonly isGenericParameter!: boolean;
    readonly isGenericTypeParameter!: boolean;
    readonly isGenericMethodParameter!: boolean;
    readonly isGenericType!: boolean;
    readonly isGenericTypeDefinition!: boolean;
    readonly isSZArray!: boolean;
    readonly isVariableBoundArray!: boolean;
    readonly isByRefLike!: boolean;
    readonly hasElementType!: boolean;
    readonly genericTypeArguments!: Type[] | undefined;
    readonly genericParameterPosition!: number;
    readonly genericParameterAttributes!: GenericParameterAttributes;
    readonly attributes!: TypeAttributes;
    readonly isAbstract!: boolean;
    readonly isImport!: boolean;
    readonly isSealed!: boolean;
    readonly isSpecialName!: boolean;
    readonly isClass!: boolean;
    readonly isNestedAssembly!: boolean;
    readonly isNestedFamANDAssem!: boolean;
    readonly isNestedFamily!: boolean;
    readonly isNestedFamORAssem!: boolean;
    readonly isNestedPrivate!: boolean;
    readonly isNestedPublic!: boolean;
    readonly isNotPublic!: boolean;
    readonly isPublic!: boolean;
    readonly isAutoLayout!: boolean;
    readonly isExplicitLayout!: boolean;
    readonly isLayoutSequential!: boolean;
    readonly isAnsiClass!: boolean;
    readonly isAutoClass!: boolean;
    readonly isUnicodeClass!: boolean;
    readonly isCOMObject!: boolean;
    readonly isContextful!: boolean;
    readonly isEnum!: boolean;
    readonly isMarshalByRef!: boolean;
    readonly isPrimitive!: boolean;
    readonly isValueType!: boolean;
    readonly isSignatureType!: boolean;
    readonly isSecurityCritical!: boolean;
    readonly isSecuritySafeCritical!: boolean;
    readonly isSecurityTransparent!: boolean;
    readonly structLayoutAttribute!: StructLayoutAttribute | undefined;
    readonly typeInitializer!: ConstructorInfo | undefined;
    readonly typeHandle!: RuntimeTypeHandle;
    readonly guid!: string;
    readonly baseType!: Type | undefined;
    readonly isSerializable!: boolean;
    readonly containsGenericParameters!: boolean;
    readonly isVisible!: boolean;
    readonly name!: string | undefined;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly isCollectible!: boolean;
    readonly metadataToken!: number;

    constructor(data?: ITypeInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["genericTypeParameters"])) {
                (<any>this).genericTypeParameters = [] as any;
                for (let item of data["genericTypeParameters"])
                    (<any>this).genericTypeParameters!.push(Type.fromJS(item));
            }
            if (Array.isArray(data["declaredConstructors"])) {
                (<any>this).declaredConstructors = [] as any;
                for (let item of data["declaredConstructors"])
                    (<any>this).declaredConstructors!.push(ConstructorInfo.fromJS(item));
            }
            if (Array.isArray(data["declaredEvents"])) {
                (<any>this).declaredEvents = [] as any;
                for (let item of data["declaredEvents"])
                    (<any>this).declaredEvents!.push(EventInfo.fromJS(item));
            }
            if (Array.isArray(data["declaredFields"])) {
                (<any>this).declaredFields = [] as any;
                for (let item of data["declaredFields"])
                    (<any>this).declaredFields!.push(FieldInfo.fromJS(item));
            }
            if (Array.isArray(data["declaredMembers"])) {
                (<any>this).declaredMembers = [] as any;
                for (let item of data["declaredMembers"])
                    (<any>this).declaredMembers!.push(MemberInfo.fromJS(item));
            }
            if (Array.isArray(data["declaredMethods"])) {
                (<any>this).declaredMethods = [] as any;
                for (let item of data["declaredMethods"])
                    (<any>this).declaredMethods!.push(MethodInfo.fromJS(item));
            }
            if (Array.isArray(data["declaredNestedTypes"])) {
                (<any>this).declaredNestedTypes = [] as any;
                for (let item of data["declaredNestedTypes"])
                    (<any>this).declaredNestedTypes!.push(TypeInfo.fromJS(item));
            }
            if (Array.isArray(data["declaredProperties"])) {
                (<any>this).declaredProperties = [] as any;
                for (let item of data["declaredProperties"])
                    (<any>this).declaredProperties!.push(PropertyInfo.fromJS(item));
            }
            if (Array.isArray(data["implementedInterfaces"])) {
                (<any>this).implementedInterfaces = [] as any;
                for (let item of data["implementedInterfaces"])
                    (<any>this).implementedInterfaces!.push(Type.fromJS(item));
            }
            (<any>this).isInterface = data["isInterface"];
            (<any>this).memberType = data["memberType"];
            (<any>this).namespace = data["namespace"];
            (<any>this).assemblyQualifiedName = data["assemblyQualifiedName"];
            (<any>this).fullName = data["fullName"];
            (<any>this).assembly = data["assembly"] ? Assembly.fromJS(data["assembly"]) : <any>undefined;
            (<any>this).module = data["module"] ? Module.fromJS(data["module"]) : <any>undefined;
            (<any>this).isNested = data["isNested"];
            (<any>this).declaringType = data["declaringType"] ? Type.fromJS(data["declaringType"]) : <any>undefined;
            (<any>this).declaringMethod = data["declaringMethod"] ? MethodBase.fromJS(data["declaringMethod"]) : <any>undefined;
            (<any>this).reflectedType = data["reflectedType"] ? Type.fromJS(data["reflectedType"]) : <any>undefined;
            (<any>this).underlyingSystemType = data["underlyingSystemType"] ? Type.fromJS(data["underlyingSystemType"]) : <any>undefined;
            (<any>this).isTypeDefinition = data["isTypeDefinition"];
            (<any>this).isArray = data["isArray"];
            (<any>this).isByRef = data["isByRef"];
            (<any>this).isPointer = data["isPointer"];
            (<any>this).isConstructedGenericType = data["isConstructedGenericType"];
            (<any>this).isGenericParameter = data["isGenericParameter"];
            (<any>this).isGenericTypeParameter = data["isGenericTypeParameter"];
            (<any>this).isGenericMethodParameter = data["isGenericMethodParameter"];
            (<any>this).isGenericType = data["isGenericType"];
            (<any>this).isGenericTypeDefinition = data["isGenericTypeDefinition"];
            (<any>this).isSZArray = data["isSZArray"];
            (<any>this).isVariableBoundArray = data["isVariableBoundArray"];
            (<any>this).isByRefLike = data["isByRefLike"];
            (<any>this).hasElementType = data["hasElementType"];
            if (Array.isArray(data["genericTypeArguments"])) {
                (<any>this).genericTypeArguments = [] as any;
                for (let item of data["genericTypeArguments"])
                    (<any>this).genericTypeArguments!.push(Type.fromJS(item));
            }
            (<any>this).genericParameterPosition = data["genericParameterPosition"];
            (<any>this).genericParameterAttributes = data["genericParameterAttributes"];
            (<any>this).attributes = data["attributes"];
            (<any>this).isAbstract = data["isAbstract"];
            (<any>this).isImport = data["isImport"];
            (<any>this).isSealed = data["isSealed"];
            (<any>this).isSpecialName = data["isSpecialName"];
            (<any>this).isClass = data["isClass"];
            (<any>this).isNestedAssembly = data["isNestedAssembly"];
            (<any>this).isNestedFamANDAssem = data["isNestedFamANDAssem"];
            (<any>this).isNestedFamily = data["isNestedFamily"];
            (<any>this).isNestedFamORAssem = data["isNestedFamORAssem"];
            (<any>this).isNestedPrivate = data["isNestedPrivate"];
            (<any>this).isNestedPublic = data["isNestedPublic"];
            (<any>this).isNotPublic = data["isNotPublic"];
            (<any>this).isPublic = data["isPublic"];
            (<any>this).isAutoLayout = data["isAutoLayout"];
            (<any>this).isExplicitLayout = data["isExplicitLayout"];
            (<any>this).isLayoutSequential = data["isLayoutSequential"];
            (<any>this).isAnsiClass = data["isAnsiClass"];
            (<any>this).isAutoClass = data["isAutoClass"];
            (<any>this).isUnicodeClass = data["isUnicodeClass"];
            (<any>this).isCOMObject = data["isCOMObject"];
            (<any>this).isContextful = data["isContextful"];
            (<any>this).isEnum = data["isEnum"];
            (<any>this).isMarshalByRef = data["isMarshalByRef"];
            (<any>this).isPrimitive = data["isPrimitive"];
            (<any>this).isValueType = data["isValueType"];
            (<any>this).isSignatureType = data["isSignatureType"];
            (<any>this).isSecurityCritical = data["isSecurityCritical"];
            (<any>this).isSecuritySafeCritical = data["isSecuritySafeCritical"];
            (<any>this).isSecurityTransparent = data["isSecurityTransparent"];
            (<any>this).structLayoutAttribute = data["structLayoutAttribute"] ? StructLayoutAttribute.fromJS(data["structLayoutAttribute"]) : <any>undefined;
            (<any>this).typeInitializer = data["typeInitializer"] ? ConstructorInfo.fromJS(data["typeInitializer"]) : <any>undefined;
            (<any>this).typeHandle = data["typeHandle"] ? RuntimeTypeHandle.fromJS(data["typeHandle"]) : <any>undefined;
            (<any>this).guid = data["guid"];
            (<any>this).baseType = data["baseType"] ? Type.fromJS(data["baseType"]) : <any>undefined;
            (<any>this).isSerializable = data["isSerializable"];
            (<any>this).containsGenericParameters = data["containsGenericParameters"];
            (<any>this).isVisible = data["isVisible"];
            (<any>this).name = data["name"];
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): TypeInfo {
        data = typeof data === 'object' ? data : {};
        let result = new TypeInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.genericTypeParameters)) {
            data["genericTypeParameters"] = [];
            for (let item of this.genericTypeParameters)
                data["genericTypeParameters"].push(item.toJSON());
        }
        if (Array.isArray(this.declaredConstructors)) {
            data["declaredConstructors"] = [];
            for (let item of this.declaredConstructors)
                data["declaredConstructors"].push(item.toJSON());
        }
        if (Array.isArray(this.declaredEvents)) {
            data["declaredEvents"] = [];
            for (let item of this.declaredEvents)
                data["declaredEvents"].push(item.toJSON());
        }
        if (Array.isArray(this.declaredFields)) {
            data["declaredFields"] = [];
            for (let item of this.declaredFields)
                data["declaredFields"].push(item.toJSON());
        }
        if (Array.isArray(this.declaredMembers)) {
            data["declaredMembers"] = [];
            for (let item of this.declaredMembers)
                data["declaredMembers"].push(item.toJSON());
        }
        if (Array.isArray(this.declaredMethods)) {
            data["declaredMethods"] = [];
            for (let item of this.declaredMethods)
                data["declaredMethods"].push(item.toJSON());
        }
        if (Array.isArray(this.declaredNestedTypes)) {
            data["declaredNestedTypes"] = [];
            for (let item of this.declaredNestedTypes)
                data["declaredNestedTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.declaredProperties)) {
            data["declaredProperties"] = [];
            for (let item of this.declaredProperties)
                data["declaredProperties"].push(item.toJSON());
        }
        if (Array.isArray(this.implementedInterfaces)) {
            data["implementedInterfaces"] = [];
            for (let item of this.implementedInterfaces)
                data["implementedInterfaces"].push(item.toJSON());
        }
        data["isInterface"] = this.isInterface;
        data["memberType"] = this.memberType;
        data["namespace"] = this.namespace;
        data["assemblyQualifiedName"] = this.assemblyQualifiedName;
        data["fullName"] = this.fullName;
        data["assembly"] = this.assembly ? this.assembly.toJSON() : <any>undefined;
        data["module"] = this.module ? this.module.toJSON() : <any>undefined;
        data["isNested"] = this.isNested;
        data["declaringType"] = this.declaringType ? this.declaringType.toJSON() : <any>undefined;
        data["declaringMethod"] = this.declaringMethod ? this.declaringMethod.toJSON() : <any>undefined;
        data["reflectedType"] = this.reflectedType ? this.reflectedType.toJSON() : <any>undefined;
        data["underlyingSystemType"] = this.underlyingSystemType ? this.underlyingSystemType.toJSON() : <any>undefined;
        data["isTypeDefinition"] = this.isTypeDefinition;
        data["isArray"] = this.isArray;
        data["isByRef"] = this.isByRef;
        data["isPointer"] = this.isPointer;
        data["isConstructedGenericType"] = this.isConstructedGenericType;
        data["isGenericParameter"] = this.isGenericParameter;
        data["isGenericTypeParameter"] = this.isGenericTypeParameter;
        data["isGenericMethodParameter"] = this.isGenericMethodParameter;
        data["isGenericType"] = this.isGenericType;
        data["isGenericTypeDefinition"] = this.isGenericTypeDefinition;
        data["isSZArray"] = this.isSZArray;
        data["isVariableBoundArray"] = this.isVariableBoundArray;
        data["isByRefLike"] = this.isByRefLike;
        data["hasElementType"] = this.hasElementType;
        if (Array.isArray(this.genericTypeArguments)) {
            data["genericTypeArguments"] = [];
            for (let item of this.genericTypeArguments)
                data["genericTypeArguments"].push(item.toJSON());
        }
        data["genericParameterPosition"] = this.genericParameterPosition;
        data["genericParameterAttributes"] = this.genericParameterAttributes;
        data["attributes"] = this.attributes;
        data["isAbstract"] = this.isAbstract;
        data["isImport"] = this.isImport;
        data["isSealed"] = this.isSealed;
        data["isSpecialName"] = this.isSpecialName;
        data["isClass"] = this.isClass;
        data["isNestedAssembly"] = this.isNestedAssembly;
        data["isNestedFamANDAssem"] = this.isNestedFamANDAssem;
        data["isNestedFamily"] = this.isNestedFamily;
        data["isNestedFamORAssem"] = this.isNestedFamORAssem;
        data["isNestedPrivate"] = this.isNestedPrivate;
        data["isNestedPublic"] = this.isNestedPublic;
        data["isNotPublic"] = this.isNotPublic;
        data["isPublic"] = this.isPublic;
        data["isAutoLayout"] = this.isAutoLayout;
        data["isExplicitLayout"] = this.isExplicitLayout;
        data["isLayoutSequential"] = this.isLayoutSequential;
        data["isAnsiClass"] = this.isAnsiClass;
        data["isAutoClass"] = this.isAutoClass;
        data["isUnicodeClass"] = this.isUnicodeClass;
        data["isCOMObject"] = this.isCOMObject;
        data["isContextful"] = this.isContextful;
        data["isEnum"] = this.isEnum;
        data["isMarshalByRef"] = this.isMarshalByRef;
        data["isPrimitive"] = this.isPrimitive;
        data["isValueType"] = this.isValueType;
        data["isSignatureType"] = this.isSignatureType;
        data["isSecurityCritical"] = this.isSecurityCritical;
        data["isSecuritySafeCritical"] = this.isSecuritySafeCritical;
        data["isSecurityTransparent"] = this.isSecurityTransparent;
        data["structLayoutAttribute"] = this.structLayoutAttribute ? this.structLayoutAttribute.toJSON() : <any>undefined;
        data["typeInitializer"] = this.typeInitializer ? this.typeInitializer.toJSON() : <any>undefined;
        data["typeHandle"] = this.typeHandle ? this.typeHandle.toJSON() : <any>undefined;
        data["guid"] = this.guid;
        data["baseType"] = this.baseType ? this.baseType.toJSON() : <any>undefined;
        data["isSerializable"] = this.isSerializable;
        data["containsGenericParameters"] = this.containsGenericParameters;
        data["isVisible"] = this.isVisible;
        data["name"] = this.name;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["isCollectible"] = this.isCollectible;
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface ITypeInfo {
    genericTypeParameters: Type[] | undefined;
    declaredConstructors: ConstructorInfo[] | undefined;
    declaredEvents: EventInfo[] | undefined;
    declaredFields: FieldInfo[] | undefined;
    declaredMembers: MemberInfo[] | undefined;
    declaredMethods: MethodInfo[] | undefined;
    declaredNestedTypes: TypeInfo[] | undefined;
    declaredProperties: PropertyInfo[] | undefined;
    implementedInterfaces: Type[] | undefined;
    isInterface: boolean;
    memberType: MemberTypes;
    namespace: string | undefined;
    assemblyQualifiedName: string | undefined;
    fullName: string | undefined;
    assembly: Assembly | undefined;
    module: Module | undefined;
    isNested: boolean;
    declaringType: Type | undefined;
    declaringMethod: MethodBase | undefined;
    reflectedType: Type | undefined;
    underlyingSystemType: Type | undefined;
    isTypeDefinition: boolean;
    isArray: boolean;
    isByRef: boolean;
    isPointer: boolean;
    isConstructedGenericType: boolean;
    isGenericParameter: boolean;
    isGenericTypeParameter: boolean;
    isGenericMethodParameter: boolean;
    isGenericType: boolean;
    isGenericTypeDefinition: boolean;
    isSZArray: boolean;
    isVariableBoundArray: boolean;
    isByRefLike: boolean;
    hasElementType: boolean;
    genericTypeArguments: Type[] | undefined;
    genericParameterPosition: number;
    genericParameterAttributes: GenericParameterAttributes;
    attributes: TypeAttributes;
    isAbstract: boolean;
    isImport: boolean;
    isSealed: boolean;
    isSpecialName: boolean;
    isClass: boolean;
    isNestedAssembly: boolean;
    isNestedFamANDAssem: boolean;
    isNestedFamily: boolean;
    isNestedFamORAssem: boolean;
    isNestedPrivate: boolean;
    isNestedPublic: boolean;
    isNotPublic: boolean;
    isPublic: boolean;
    isAutoLayout: boolean;
    isExplicitLayout: boolean;
    isLayoutSequential: boolean;
    isAnsiClass: boolean;
    isAutoClass: boolean;
    isUnicodeClass: boolean;
    isCOMObject: boolean;
    isContextful: boolean;
    isEnum: boolean;
    isMarshalByRef: boolean;
    isPrimitive: boolean;
    isValueType: boolean;
    isSignatureType: boolean;
    isSecurityCritical: boolean;
    isSecuritySafeCritical: boolean;
    isSecurityTransparent: boolean;
    structLayoutAttribute: StructLayoutAttribute | undefined;
    typeInitializer: ConstructorInfo | undefined;
    typeHandle: RuntimeTypeHandle;
    guid: string;
    baseType: Type | undefined;
    isSerializable: boolean;
    containsGenericParameters: boolean;
    isVisible: boolean;
    name: string | undefined;
    customAttributes: CustomAttributeData[] | undefined;
    isCollectible: boolean;
    metadataToken: number;
}

export enum SecurityRuleSet {
    None = 0,
    Level1 = 1,
    Level2 = 2,
}

export class Assembly implements IAssembly {
    readonly definedTypes!: TypeInfo[] | undefined;
    readonly exportedTypes!: Type[] | undefined;
    readonly codeBase!: string | undefined;
    readonly entryPoint!: MethodInfo | undefined;
    readonly fullName!: string | undefined;
    readonly imageRuntimeVersion!: string | undefined;
    readonly isDynamic!: boolean;
    readonly location!: string | undefined;
    readonly reflectionOnly!: boolean;
    readonly isCollectible!: boolean;
    readonly isFullyTrusted!: boolean;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly escapedCodeBase!: string | undefined;
    readonly manifestModule!: Module | undefined;
    readonly modules!: Module[] | undefined;
    readonly globalAssemblyCache!: boolean;
    readonly hostContext!: number;
    readonly securityRuleSet!: SecurityRuleSet;

    constructor(data?: IAssembly) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["definedTypes"])) {
                (<any>this).definedTypes = [] as any;
                for (let item of data["definedTypes"])
                    (<any>this).definedTypes!.push(TypeInfo.fromJS(item));
            }
            if (Array.isArray(data["exportedTypes"])) {
                (<any>this).exportedTypes = [] as any;
                for (let item of data["exportedTypes"])
                    (<any>this).exportedTypes!.push(Type.fromJS(item));
            }
            (<any>this).codeBase = data["codeBase"];
            (<any>this).entryPoint = data["entryPoint"] ? MethodInfo.fromJS(data["entryPoint"]) : <any>undefined;
            (<any>this).fullName = data["fullName"];
            (<any>this).imageRuntimeVersion = data["imageRuntimeVersion"];
            (<any>this).isDynamic = data["isDynamic"];
            (<any>this).location = data["location"];
            (<any>this).reflectionOnly = data["reflectionOnly"];
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).isFullyTrusted = data["isFullyTrusted"];
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).escapedCodeBase = data["escapedCodeBase"];
            (<any>this).manifestModule = data["manifestModule"] ? Module.fromJS(data["manifestModule"]) : <any>undefined;
            if (Array.isArray(data["modules"])) {
                (<any>this).modules = [] as any;
                for (let item of data["modules"])
                    (<any>this).modules!.push(Module.fromJS(item));
            }
            (<any>this).globalAssemblyCache = data["globalAssemblyCache"];
            (<any>this).hostContext = data["hostContext"];
            (<any>this).securityRuleSet = data["securityRuleSet"];
        }
    }

    static fromJS(data: any): Assembly {
        data = typeof data === 'object' ? data : {};
        let result = new Assembly();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.definedTypes)) {
            data["definedTypes"] = [];
            for (let item of this.definedTypes)
                data["definedTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.exportedTypes)) {
            data["exportedTypes"] = [];
            for (let item of this.exportedTypes)
                data["exportedTypes"].push(item.toJSON());
        }
        data["codeBase"] = this.codeBase;
        data["entryPoint"] = this.entryPoint ? this.entryPoint.toJSON() : <any>undefined;
        data["fullName"] = this.fullName;
        data["imageRuntimeVersion"] = this.imageRuntimeVersion;
        data["isDynamic"] = this.isDynamic;
        data["location"] = this.location;
        data["reflectionOnly"] = this.reflectionOnly;
        data["isCollectible"] = this.isCollectible;
        data["isFullyTrusted"] = this.isFullyTrusted;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["escapedCodeBase"] = this.escapedCodeBase;
        data["manifestModule"] = this.manifestModule ? this.manifestModule.toJSON() : <any>undefined;
        if (Array.isArray(this.modules)) {
            data["modules"] = [];
            for (let item of this.modules)
                data["modules"].push(item.toJSON());
        }
        data["globalAssemblyCache"] = this.globalAssemblyCache;
        data["hostContext"] = this.hostContext;
        data["securityRuleSet"] = this.securityRuleSet;
        return data; 
    }
}

export interface IAssembly {
    definedTypes: TypeInfo[] | undefined;
    exportedTypes: Type[] | undefined;
    codeBase: string | undefined;
    entryPoint: MethodInfo | undefined;
    fullName: string | undefined;
    imageRuntimeVersion: string | undefined;
    isDynamic: boolean;
    location: string | undefined;
    reflectionOnly: boolean;
    isCollectible: boolean;
    isFullyTrusted: boolean;
    customAttributes: CustomAttributeData[] | undefined;
    escapedCodeBase: string | undefined;
    manifestModule: Module | undefined;
    modules: Module[] | undefined;
    globalAssemblyCache: boolean;
    hostContext: number;
    securityRuleSet: SecurityRuleSet;
}

export class Type implements IType {
    readonly isInterface!: boolean;
    readonly memberType!: MemberTypes;
    readonly namespace!: string | undefined;
    readonly assemblyQualifiedName!: string | undefined;
    readonly fullName!: string | undefined;
    readonly assembly!: Assembly | undefined;
    readonly module!: Module | undefined;
    readonly isNested!: boolean;
    readonly declaringType!: Type | undefined;
    readonly declaringMethod!: MethodBase | undefined;
    readonly reflectedType!: Type | undefined;
    readonly underlyingSystemType!: Type | undefined;
    readonly isTypeDefinition!: boolean;
    readonly isArray!: boolean;
    readonly isByRef!: boolean;
    readonly isPointer!: boolean;
    readonly isConstructedGenericType!: boolean;
    readonly isGenericParameter!: boolean;
    readonly isGenericTypeParameter!: boolean;
    readonly isGenericMethodParameter!: boolean;
    readonly isGenericType!: boolean;
    readonly isGenericTypeDefinition!: boolean;
    readonly isSZArray!: boolean;
    readonly isVariableBoundArray!: boolean;
    readonly isByRefLike!: boolean;
    readonly hasElementType!: boolean;
    readonly genericTypeArguments!: Type[] | undefined;
    readonly genericParameterPosition!: number;
    readonly genericParameterAttributes!: GenericParameterAttributes;
    readonly attributes!: TypeAttributes;
    readonly isAbstract!: boolean;
    readonly isImport!: boolean;
    readonly isSealed!: boolean;
    readonly isSpecialName!: boolean;
    readonly isClass!: boolean;
    readonly isNestedAssembly!: boolean;
    readonly isNestedFamANDAssem!: boolean;
    readonly isNestedFamily!: boolean;
    readonly isNestedFamORAssem!: boolean;
    readonly isNestedPrivate!: boolean;
    readonly isNestedPublic!: boolean;
    readonly isNotPublic!: boolean;
    readonly isPublic!: boolean;
    readonly isAutoLayout!: boolean;
    readonly isExplicitLayout!: boolean;
    readonly isLayoutSequential!: boolean;
    readonly isAnsiClass!: boolean;
    readonly isAutoClass!: boolean;
    readonly isUnicodeClass!: boolean;
    readonly isCOMObject!: boolean;
    readonly isContextful!: boolean;
    readonly isEnum!: boolean;
    readonly isMarshalByRef!: boolean;
    readonly isPrimitive!: boolean;
    readonly isValueType!: boolean;
    readonly isSignatureType!: boolean;
    readonly isSecurityCritical!: boolean;
    readonly isSecuritySafeCritical!: boolean;
    readonly isSecurityTransparent!: boolean;
    readonly structLayoutAttribute!: StructLayoutAttribute | undefined;
    readonly typeInitializer!: ConstructorInfo | undefined;
    readonly typeHandle!: RuntimeTypeHandle;
    readonly guid!: string;
    readonly baseType!: Type | undefined;
    readonly isSerializable!: boolean;
    readonly containsGenericParameters!: boolean;
    readonly isVisible!: boolean;
    readonly name!: string | undefined;
    readonly customAttributes!: CustomAttributeData[] | undefined;
    readonly isCollectible!: boolean;
    readonly metadataToken!: number;

    constructor(data?: IType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).isInterface = data["isInterface"];
            (<any>this).memberType = data["memberType"];
            (<any>this).namespace = data["namespace"];
            (<any>this).assemblyQualifiedName = data["assemblyQualifiedName"];
            (<any>this).fullName = data["fullName"];
            (<any>this).assembly = data["assembly"] ? Assembly.fromJS(data["assembly"]) : <any>undefined;
            (<any>this).module = data["module"] ? Module.fromJS(data["module"]) : <any>undefined;
            (<any>this).isNested = data["isNested"];
            (<any>this).declaringType = data["declaringType"] ? Type.fromJS(data["declaringType"]) : <any>undefined;
            (<any>this).declaringMethod = data["declaringMethod"] ? MethodBase.fromJS(data["declaringMethod"]) : <any>undefined;
            (<any>this).reflectedType = data["reflectedType"] ? Type.fromJS(data["reflectedType"]) : <any>undefined;
            (<any>this).underlyingSystemType = data["underlyingSystemType"] ? Type.fromJS(data["underlyingSystemType"]) : <any>undefined;
            (<any>this).isTypeDefinition = data["isTypeDefinition"];
            (<any>this).isArray = data["isArray"];
            (<any>this).isByRef = data["isByRef"];
            (<any>this).isPointer = data["isPointer"];
            (<any>this).isConstructedGenericType = data["isConstructedGenericType"];
            (<any>this).isGenericParameter = data["isGenericParameter"];
            (<any>this).isGenericTypeParameter = data["isGenericTypeParameter"];
            (<any>this).isGenericMethodParameter = data["isGenericMethodParameter"];
            (<any>this).isGenericType = data["isGenericType"];
            (<any>this).isGenericTypeDefinition = data["isGenericTypeDefinition"];
            (<any>this).isSZArray = data["isSZArray"];
            (<any>this).isVariableBoundArray = data["isVariableBoundArray"];
            (<any>this).isByRefLike = data["isByRefLike"];
            (<any>this).hasElementType = data["hasElementType"];
            if (Array.isArray(data["genericTypeArguments"])) {
                (<any>this).genericTypeArguments = [] as any;
                for (let item of data["genericTypeArguments"])
                    (<any>this).genericTypeArguments!.push(Type.fromJS(item));
            }
            (<any>this).genericParameterPosition = data["genericParameterPosition"];
            (<any>this).genericParameterAttributes = data["genericParameterAttributes"];
            (<any>this).attributes = data["attributes"];
            (<any>this).isAbstract = data["isAbstract"];
            (<any>this).isImport = data["isImport"];
            (<any>this).isSealed = data["isSealed"];
            (<any>this).isSpecialName = data["isSpecialName"];
            (<any>this).isClass = data["isClass"];
            (<any>this).isNestedAssembly = data["isNestedAssembly"];
            (<any>this).isNestedFamANDAssem = data["isNestedFamANDAssem"];
            (<any>this).isNestedFamily = data["isNestedFamily"];
            (<any>this).isNestedFamORAssem = data["isNestedFamORAssem"];
            (<any>this).isNestedPrivate = data["isNestedPrivate"];
            (<any>this).isNestedPublic = data["isNestedPublic"];
            (<any>this).isNotPublic = data["isNotPublic"];
            (<any>this).isPublic = data["isPublic"];
            (<any>this).isAutoLayout = data["isAutoLayout"];
            (<any>this).isExplicitLayout = data["isExplicitLayout"];
            (<any>this).isLayoutSequential = data["isLayoutSequential"];
            (<any>this).isAnsiClass = data["isAnsiClass"];
            (<any>this).isAutoClass = data["isAutoClass"];
            (<any>this).isUnicodeClass = data["isUnicodeClass"];
            (<any>this).isCOMObject = data["isCOMObject"];
            (<any>this).isContextful = data["isContextful"];
            (<any>this).isEnum = data["isEnum"];
            (<any>this).isMarshalByRef = data["isMarshalByRef"];
            (<any>this).isPrimitive = data["isPrimitive"];
            (<any>this).isValueType = data["isValueType"];
            (<any>this).isSignatureType = data["isSignatureType"];
            (<any>this).isSecurityCritical = data["isSecurityCritical"];
            (<any>this).isSecuritySafeCritical = data["isSecuritySafeCritical"];
            (<any>this).isSecurityTransparent = data["isSecurityTransparent"];
            (<any>this).structLayoutAttribute = data["structLayoutAttribute"] ? StructLayoutAttribute.fromJS(data["structLayoutAttribute"]) : <any>undefined;
            (<any>this).typeInitializer = data["typeInitializer"] ? ConstructorInfo.fromJS(data["typeInitializer"]) : <any>undefined;
            (<any>this).typeHandle = data["typeHandle"] ? RuntimeTypeHandle.fromJS(data["typeHandle"]) : <any>undefined;
            (<any>this).guid = data["guid"];
            (<any>this).baseType = data["baseType"] ? Type.fromJS(data["baseType"]) : <any>undefined;
            (<any>this).isSerializable = data["isSerializable"];
            (<any>this).containsGenericParameters = data["containsGenericParameters"];
            (<any>this).isVisible = data["isVisible"];
            (<any>this).name = data["name"];
            if (Array.isArray(data["customAttributes"])) {
                (<any>this).customAttributes = [] as any;
                for (let item of data["customAttributes"])
                    (<any>this).customAttributes!.push(CustomAttributeData.fromJS(item));
            }
            (<any>this).isCollectible = data["isCollectible"];
            (<any>this).metadataToken = data["metadataToken"];
        }
    }

    static fromJS(data: any): Type {
        data = typeof data === 'object' ? data : {};
        let result = new Type();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isInterface"] = this.isInterface;
        data["memberType"] = this.memberType;
        data["namespace"] = this.namespace;
        data["assemblyQualifiedName"] = this.assemblyQualifiedName;
        data["fullName"] = this.fullName;
        data["assembly"] = this.assembly ? this.assembly.toJSON() : <any>undefined;
        data["module"] = this.module ? this.module.toJSON() : <any>undefined;
        data["isNested"] = this.isNested;
        data["declaringType"] = this.declaringType ? this.declaringType.toJSON() : <any>undefined;
        data["declaringMethod"] = this.declaringMethod ? this.declaringMethod.toJSON() : <any>undefined;
        data["reflectedType"] = this.reflectedType ? this.reflectedType.toJSON() : <any>undefined;
        data["underlyingSystemType"] = this.underlyingSystemType ? this.underlyingSystemType.toJSON() : <any>undefined;
        data["isTypeDefinition"] = this.isTypeDefinition;
        data["isArray"] = this.isArray;
        data["isByRef"] = this.isByRef;
        data["isPointer"] = this.isPointer;
        data["isConstructedGenericType"] = this.isConstructedGenericType;
        data["isGenericParameter"] = this.isGenericParameter;
        data["isGenericTypeParameter"] = this.isGenericTypeParameter;
        data["isGenericMethodParameter"] = this.isGenericMethodParameter;
        data["isGenericType"] = this.isGenericType;
        data["isGenericTypeDefinition"] = this.isGenericTypeDefinition;
        data["isSZArray"] = this.isSZArray;
        data["isVariableBoundArray"] = this.isVariableBoundArray;
        data["isByRefLike"] = this.isByRefLike;
        data["hasElementType"] = this.hasElementType;
        if (Array.isArray(this.genericTypeArguments)) {
            data["genericTypeArguments"] = [];
            for (let item of this.genericTypeArguments)
                data["genericTypeArguments"].push(item.toJSON());
        }
        data["genericParameterPosition"] = this.genericParameterPosition;
        data["genericParameterAttributes"] = this.genericParameterAttributes;
        data["attributes"] = this.attributes;
        data["isAbstract"] = this.isAbstract;
        data["isImport"] = this.isImport;
        data["isSealed"] = this.isSealed;
        data["isSpecialName"] = this.isSpecialName;
        data["isClass"] = this.isClass;
        data["isNestedAssembly"] = this.isNestedAssembly;
        data["isNestedFamANDAssem"] = this.isNestedFamANDAssem;
        data["isNestedFamily"] = this.isNestedFamily;
        data["isNestedFamORAssem"] = this.isNestedFamORAssem;
        data["isNestedPrivate"] = this.isNestedPrivate;
        data["isNestedPublic"] = this.isNestedPublic;
        data["isNotPublic"] = this.isNotPublic;
        data["isPublic"] = this.isPublic;
        data["isAutoLayout"] = this.isAutoLayout;
        data["isExplicitLayout"] = this.isExplicitLayout;
        data["isLayoutSequential"] = this.isLayoutSequential;
        data["isAnsiClass"] = this.isAnsiClass;
        data["isAutoClass"] = this.isAutoClass;
        data["isUnicodeClass"] = this.isUnicodeClass;
        data["isCOMObject"] = this.isCOMObject;
        data["isContextful"] = this.isContextful;
        data["isEnum"] = this.isEnum;
        data["isMarshalByRef"] = this.isMarshalByRef;
        data["isPrimitive"] = this.isPrimitive;
        data["isValueType"] = this.isValueType;
        data["isSignatureType"] = this.isSignatureType;
        data["isSecurityCritical"] = this.isSecurityCritical;
        data["isSecuritySafeCritical"] = this.isSecuritySafeCritical;
        data["isSecurityTransparent"] = this.isSecurityTransparent;
        data["structLayoutAttribute"] = this.structLayoutAttribute ? this.structLayoutAttribute.toJSON() : <any>undefined;
        data["typeInitializer"] = this.typeInitializer ? this.typeInitializer.toJSON() : <any>undefined;
        data["typeHandle"] = this.typeHandle ? this.typeHandle.toJSON() : <any>undefined;
        data["guid"] = this.guid;
        data["baseType"] = this.baseType ? this.baseType.toJSON() : <any>undefined;
        data["isSerializable"] = this.isSerializable;
        data["containsGenericParameters"] = this.containsGenericParameters;
        data["isVisible"] = this.isVisible;
        data["name"] = this.name;
        if (Array.isArray(this.customAttributes)) {
            data["customAttributes"] = [];
            for (let item of this.customAttributes)
                data["customAttributes"].push(item.toJSON());
        }
        data["isCollectible"] = this.isCollectible;
        data["metadataToken"] = this.metadataToken;
        return data; 
    }
}

export interface IType {
    isInterface: boolean;
    memberType: MemberTypes;
    namespace: string | undefined;
    assemblyQualifiedName: string | undefined;
    fullName: string | undefined;
    assembly: Assembly | undefined;
    module: Module | undefined;
    isNested: boolean;
    declaringType: Type | undefined;
    declaringMethod: MethodBase | undefined;
    reflectedType: Type | undefined;
    underlyingSystemType: Type | undefined;
    isTypeDefinition: boolean;
    isArray: boolean;
    isByRef: boolean;
    isPointer: boolean;
    isConstructedGenericType: boolean;
    isGenericParameter: boolean;
    isGenericTypeParameter: boolean;
    isGenericMethodParameter: boolean;
    isGenericType: boolean;
    isGenericTypeDefinition: boolean;
    isSZArray: boolean;
    isVariableBoundArray: boolean;
    isByRefLike: boolean;
    hasElementType: boolean;
    genericTypeArguments: Type[] | undefined;
    genericParameterPosition: number;
    genericParameterAttributes: GenericParameterAttributes;
    attributes: TypeAttributes;
    isAbstract: boolean;
    isImport: boolean;
    isSealed: boolean;
    isSpecialName: boolean;
    isClass: boolean;
    isNestedAssembly: boolean;
    isNestedFamANDAssem: boolean;
    isNestedFamily: boolean;
    isNestedFamORAssem: boolean;
    isNestedPrivate: boolean;
    isNestedPublic: boolean;
    isNotPublic: boolean;
    isPublic: boolean;
    isAutoLayout: boolean;
    isExplicitLayout: boolean;
    isLayoutSequential: boolean;
    isAnsiClass: boolean;
    isAutoClass: boolean;
    isUnicodeClass: boolean;
    isCOMObject: boolean;
    isContextful: boolean;
    isEnum: boolean;
    isMarshalByRef: boolean;
    isPrimitive: boolean;
    isValueType: boolean;
    isSignatureType: boolean;
    isSecurityCritical: boolean;
    isSecuritySafeCritical: boolean;
    isSecurityTransparent: boolean;
    structLayoutAttribute: StructLayoutAttribute | undefined;
    typeInitializer: ConstructorInfo | undefined;
    typeHandle: RuntimeTypeHandle;
    guid: string;
    baseType: Type | undefined;
    isSerializable: boolean;
    containsGenericParameters: boolean;
    isVisible: boolean;
    name: string | undefined;
    customAttributes: CustomAttributeData[] | undefined;
    isCollectible: boolean;
    metadataToken: number;
}

export class Job implements IJob {
    readonly type!: Type | undefined;
    readonly method!: MethodInfo | undefined;
    readonly args!: any[] | undefined;
    readonly arguments!: string[] | undefined;

    constructor(data?: IJob) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).type = data["type"] ? Type.fromJS(data["type"]) : <any>undefined;
            (<any>this).method = data["method"] ? MethodInfo.fromJS(data["method"]) : <any>undefined;
            if (Array.isArray(data["args"])) {
                (<any>this).args = [] as any;
                for (let item of data["args"])
                    (<any>this).args!.push(item);
            }
            if (Array.isArray(data["arguments"])) {
                (<any>this).arguments = [] as any;
                for (let item of data["arguments"])
                    (<any>this).arguments!.push(item);
            }
        }
    }

    static fromJS(data: any): Job {
        data = typeof data === 'object' ? data : {};
        let result = new Job();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["type"] = this.type ? this.type.toJSON() : <any>undefined;
        data["method"] = this.method ? this.method.toJSON() : <any>undefined;
        if (Array.isArray(this.args)) {
            data["args"] = [];
            for (let item of this.args)
                data["args"].push(item);
        }
        if (Array.isArray(this.arguments)) {
            data["arguments"] = [];
            for (let item of this.arguments)
                data["arguments"].push(item);
        }
        return data; 
    }
}

export interface IJob {
    type: Type | undefined;
    method: MethodInfo | undefined;
    args: any[] | undefined;
    arguments: string[] | undefined;
}

export class BackgroundJob implements IBackgroundJob {
    readonly id!: string | undefined;
    readonly job!: Job | undefined;
    readonly createdAt!: moment.Moment;

    constructor(data?: IBackgroundJob) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).id = data["id"];
            (<any>this).job = data["job"] ? Job.fromJS(data["job"]) : <any>undefined;
            (<any>this).createdAt = data["createdAt"] ? moment(data["createdAt"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): BackgroundJob {
        data = typeof data === 'object' ? data : {};
        let result = new BackgroundJob();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["job"] = this.job ? this.job.toJSON() : <any>undefined;
        data["createdAt"] = this.createdAt ? this.createdAt.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IBackgroundJob {
    id: string | undefined;
    job: Job | undefined;
    createdAt: moment.Moment;
}

export class SafeWaitHandle implements ISafeWaitHandle {
    readonly isInvalid!: boolean;
    readonly isClosed!: boolean;

    constructor(data?: ISafeWaitHandle) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).isInvalid = data["isInvalid"];
            (<any>this).isClosed = data["isClosed"];
        }
    }

    static fromJS(data: any): SafeWaitHandle {
        data = typeof data === 'object' ? data : {};
        let result = new SafeWaitHandle();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isInvalid"] = this.isInvalid;
        data["isClosed"] = this.isClosed;
        return data; 
    }
}

export interface ISafeWaitHandle {
    isInvalid: boolean;
    isClosed: boolean;
}

export class WaitHandle implements IWaitHandle {
    handle!: IntPtr;
    safeWaitHandle!: SafeWaitHandle | undefined;

    constructor(data?: IWaitHandle) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.handle = data["handle"] ? IntPtr.fromJS(data["handle"]) : <any>undefined;
            this.safeWaitHandle = data["safeWaitHandle"] ? SafeWaitHandle.fromJS(data["safeWaitHandle"]) : <any>undefined;
        }
    }

    static fromJS(data: any): WaitHandle {
        data = typeof data === 'object' ? data : {};
        let result = new WaitHandle();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["handle"] = this.handle ? this.handle.toJSON() : <any>undefined;
        data["safeWaitHandle"] = this.safeWaitHandle ? this.safeWaitHandle.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IWaitHandle {
    handle: IntPtr;
    safeWaitHandle: SafeWaitHandle | undefined;
}

export class CancellationToken implements ICancellationToken {
    readonly isCancellationRequested!: boolean;
    readonly canBeCanceled!: boolean;
    readonly waitHandle!: WaitHandle | undefined;

    constructor(data?: ICancellationToken) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).isCancellationRequested = data["isCancellationRequested"];
            (<any>this).canBeCanceled = data["canBeCanceled"];
            (<any>this).waitHandle = data["waitHandle"] ? WaitHandle.fromJS(data["waitHandle"]) : <any>undefined;
        }
    }

    static fromJS(data: any): CancellationToken {
        data = typeof data === 'object' ? data : {};
        let result = new CancellationToken();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isCancellationRequested"] = this.isCancellationRequested;
        data["canBeCanceled"] = this.canBeCanceled;
        data["waitHandle"] = this.waitHandle ? this.waitHandle.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ICancellationToken {
    isCancellationRequested: boolean;
    canBeCanceled: boolean;
    waitHandle: WaitHandle | undefined;
}

export class IJobCancellationToken implements IIJobCancellationToken {
    readonly shutdownToken!: CancellationToken;

    constructor(data?: IIJobCancellationToken) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).shutdownToken = data["shutdownToken"] ? CancellationToken.fromJS(data["shutdownToken"]) : <any>undefined;
        }
    }

    static fromJS(data: any): IJobCancellationToken {
        data = typeof data === 'object' ? data : {};
        let result = new IJobCancellationToken();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["shutdownToken"] = this.shutdownToken ? this.shutdownToken.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IIJobCancellationToken {
    shutdownToken: CancellationToken;
}

export class IStorageConnection implements IIStorageConnection {

    constructor(data?: IIStorageConnection) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): IStorageConnection {
        data = typeof data === 'object' ? data : {};
        let result = new IStorageConnection();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IIStorageConnection {
}

export class PerformContext implements IPerformContext {
    readonly storage!: JobStorage | undefined;
    readonly items!: { [key: string]: any; } | undefined;
    readonly backgroundJob!: BackgroundJob | undefined;
    readonly jobId!: string | undefined;
    readonly job!: Job | undefined;
    readonly createdAt!: moment.Moment;
    readonly cancellationToken!: IJobCancellationToken | undefined;
    readonly connection!: IStorageConnection | undefined;

    constructor(data?: IPerformContext) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).storage = data["storage"] ? JobStorage.fromJS(data["storage"]) : <any>undefined;
            if (data["items"]) {
                (<any>this).items = {} as any;
                for (let key in data["items"]) {
                    if (data["items"].hasOwnProperty(key))
                        (<any>this).items![key] = data["items"][key];
                }
            }
            (<any>this).backgroundJob = data["backgroundJob"] ? BackgroundJob.fromJS(data["backgroundJob"]) : <any>undefined;
            (<any>this).jobId = data["jobId"];
            (<any>this).job = data["job"] ? Job.fromJS(data["job"]) : <any>undefined;
            (<any>this).createdAt = data["createdAt"] ? moment(data["createdAt"].toString()) : <any>undefined;
            (<any>this).cancellationToken = data["cancellationToken"] ? IJobCancellationToken.fromJS(data["cancellationToken"]) : <any>undefined;
            (<any>this).connection = data["connection"] ? IStorageConnection.fromJS(data["connection"]) : <any>undefined;
        }
    }

    static fromJS(data: any): PerformContext {
        data = typeof data === 'object' ? data : {};
        let result = new PerformContext();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["storage"] = this.storage ? this.storage.toJSON() : <any>undefined;
        if (this.items) {
            data["items"] = {};
            for (let key in this.items) {
                if (this.items.hasOwnProperty(key))
                    data["items"][key] = this.items[key];
            }
        }
        data["backgroundJob"] = this.backgroundJob ? this.backgroundJob.toJSON() : <any>undefined;
        data["jobId"] = this.jobId;
        data["job"] = this.job ? this.job.toJSON() : <any>undefined;
        data["createdAt"] = this.createdAt ? this.createdAt.toISOString() : <any>undefined;
        data["cancellationToken"] = this.cancellationToken ? this.cancellationToken.toJSON() : <any>undefined;
        data["connection"] = this.connection ? this.connection.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IPerformContext {
    storage: JobStorage | undefined;
    items: { [key: string]: any; } | undefined;
    backgroundJob: BackgroundJob | undefined;
    jobId: string | undefined;
    job: Job | undefined;
    createdAt: moment.Moment;
    cancellationToken: IJobCancellationToken | undefined;
    connection: IStorageConnection | undefined;
}

export class ConsoleTextColor implements IConsoleTextColor {

    constructor(data?: IConsoleTextColor) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): ConsoleTextColor {
        data = typeof data === 'object' ? data : {};
        let result = new ConsoleTextColor();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IConsoleTextColor {
}

export class BlindCountPackageItemDto implements IBlindCountPackageItemDto {
    packageId!: number;
    quantity!: number;

    constructor(data?: IBlindCountPackageItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.packageId = data["packageId"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): BlindCountPackageItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new BlindCountPackageItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["packageId"] = this.packageId;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface IBlindCountPackageItemDto {
    packageId: number;
    quantity: number;
}

export class GenerateForRouteInputDto implements IGenerateForRouteInputDto {
    routeId!: number;
    packages!: BlindCountPackageItemDto[] | undefined;

    constructor(data?: IGenerateForRouteInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            if (Array.isArray(data["packages"])) {
                this.packages = [] as any;
                for (let item of data["packages"])
                    this.packages!.push(BlindCountPackageItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GenerateForRouteInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new GenerateForRouteInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        if (Array.isArray(this.packages)) {
            data["packages"] = [];
            for (let item of this.packages)
                data["packages"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGenerateForRouteInputDto {
    routeId: number;
    packages: BlindCountPackageItemDto[] | undefined;
}

export class SetBlindCountLimitInputDto implements ISetBlindCountLimitInputDto {
    value!: number;

    constructor(data?: ISetBlindCountLimitInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
        }
    }

    static fromJS(data: any): SetBlindCountLimitInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new SetBlindCountLimitInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        return data; 
    }
}

export interface ISetBlindCountLimitInputDto {
    value: number;
}

export class VerifyCodeInputDto implements IVerifyCodeInputDto {
    routeId!: number;
    username!: string | undefined;
    code!: string | undefined;
    verifierNote!: string | undefined;

    constructor(data?: IVerifyCodeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.username = data["username"];
            this.code = data["code"];
            this.verifierNote = data["verifierNote"];
        }
    }

    static fromJS(data: any): VerifyCodeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new VerifyCodeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["username"] = this.username;
        data["code"] = this.code;
        data["verifierNote"] = this.verifierNote;
        return data; 
    }
}

export interface IVerifyCodeInputDto {
    routeId: number;
    username: string | undefined;
    code: string | undefined;
    verifierNote: string | undefined;
}

export class BlindCountContainerItemDto implements IBlindCountContainerItemDto {
    containerId!: number;
    quantity!: number;

    constructor(data?: IBlindCountContainerItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.containerId = data["containerId"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): BlindCountContainerItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new BlindCountContainerItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["containerId"] = this.containerId;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface IBlindCountContainerItemDto {
    containerId: number;
    quantity: number;
}

export class GenerateForDestinationInputDto implements IGenerateForDestinationInputDto {
    routeId!: number;
    destinationId!: number;
    orderStatusTypeId!: number;
    containers!: BlindCountContainerItemDto[] | undefined;

    constructor(data?: IGenerateForDestinationInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.destinationId = data["destinationId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            if (Array.isArray(data["containers"])) {
                this.containers = [] as any;
                for (let item of data["containers"])
                    this.containers!.push(BlindCountContainerItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GenerateForDestinationInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new GenerateForDestinationInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["destinationId"] = this.destinationId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        if (Array.isArray(this.containers)) {
            data["containers"] = [];
            for (let item of this.containers)
                data["containers"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGenerateForDestinationInputDto {
    routeId: number;
    destinationId: number;
    orderStatusTypeId: number;
    containers: BlindCountContainerItemDto[] | undefined;
}

export class VerifyCodeForDestinationInputDto implements IVerifyCodeForDestinationInputDto {
    routeId!: number;
    destinationId!: number;
    orderStatusTypeId!: number;
    code!: string | undefined;

    constructor(data?: IVerifyCodeForDestinationInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.destinationId = data["destinationId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): VerifyCodeForDestinationInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new VerifyCodeForDestinationInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["destinationId"] = this.destinationId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["code"] = this.code;
        return data; 
    }
}

export interface IVerifyCodeForDestinationInputDto {
    routeId: number;
    destinationId: number;
    orderStatusTypeId: number;
    code: string | undefined;
}

export class GetBusinessHoursDto implements IGetBusinessHoursDto {
    id!: number;
    code!: string | undefined;
    contactId!: number;
    openingTime!: TimeSpan;
    closingTime!: TimeSpan;
    openingTimeDate!: moment.Moment;
    closingTimeDate!: moment.Moment;
    openingTimeString!: string | undefined;
    closingTimeString!: string | undefined;
    openingTimeS!: string | undefined;
    closingTimeS!: string | undefined;
    date!: moment.Moment | undefined;
    dateString!: string | undefined;
    day!: string | undefined;
    isClosed!: boolean;

    constructor(data?: IGetBusinessHoursDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.contactId = data["contactId"];
            this.openingTime = data["openingTime"] ? TimeSpan.fromJS(data["openingTime"]) : <any>undefined;
            this.closingTime = data["closingTime"] ? TimeSpan.fromJS(data["closingTime"]) : <any>undefined;
            this.openingTimeDate = data["openingTimeDate"] ? moment(data["openingTimeDate"].toString()) : <any>undefined;
            this.closingTimeDate = data["closingTimeDate"] ? moment(data["closingTimeDate"].toString()) : <any>undefined;
            this.openingTimeString = data["openingTimeString"];
            this.closingTimeString = data["closingTimeString"];
            this.openingTimeS = data["openingTimeS"];
            this.closingTimeS = data["closingTimeS"];
            this.date = data["date"] ? moment(data["date"].toString()) : <any>undefined;
            this.dateString = data["dateString"];
            this.day = data["day"];
            this.isClosed = data["isClosed"];
        }
    }

    static fromJS(data: any): GetBusinessHoursDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetBusinessHoursDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["contactId"] = this.contactId;
        data["openingTime"] = this.openingTime ? this.openingTime.toJSON() : <any>undefined;
        data["closingTime"] = this.closingTime ? this.closingTime.toJSON() : <any>undefined;
        data["openingTimeDate"] = this.openingTimeDate ? this.openingTimeDate.toISOString() : <any>undefined;
        data["closingTimeDate"] = this.closingTimeDate ? this.closingTimeDate.toISOString() : <any>undefined;
        data["openingTimeString"] = this.openingTimeString;
        data["closingTimeString"] = this.closingTimeString;
        data["openingTimeS"] = this.openingTimeS;
        data["closingTimeS"] = this.closingTimeS;
        data["date"] = this.date ? this.date.toISOString() : <any>undefined;
        data["dateString"] = this.dateString;
        data["day"] = this.day;
        data["isClosed"] = this.isClosed;
        return data; 
    }
}

export interface IGetBusinessHoursDto {
    id: number;
    code: string | undefined;
    contactId: number;
    openingTime: TimeSpan;
    closingTime: TimeSpan;
    openingTimeDate: moment.Moment;
    closingTimeDate: moment.Moment;
    openingTimeString: string | undefined;
    closingTimeString: string | undefined;
    openingTimeS: string | undefined;
    closingTimeS: string | undefined;
    date: moment.Moment | undefined;
    dateString: string | undefined;
    day: string | undefined;
    isClosed: boolean;
}

export class BusinessHoursEditDto implements IBusinessHoursEditDto {
    id!: number | undefined;
    code!: string | undefined;
    contactId!: number;
    openingTime!: TimeSpan;
    closingTime!: TimeSpan;
    date!: moment.Moment | undefined;
    day!: string | undefined;
    isClosed!: boolean;
    openingTimeString!: string | undefined;
    closingTimeString!: string | undefined;

    constructor(data?: IBusinessHoursEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.contactId = data["contactId"];
            this.openingTime = data["openingTime"] ? TimeSpan.fromJS(data["openingTime"]) : <any>undefined;
            this.closingTime = data["closingTime"] ? TimeSpan.fromJS(data["closingTime"]) : <any>undefined;
            this.date = data["date"] ? moment(data["date"].toString()) : <any>undefined;
            this.day = data["day"];
            this.isClosed = data["isClosed"];
            this.openingTimeString = data["openingTimeString"];
            this.closingTimeString = data["closingTimeString"];
        }
    }

    static fromJS(data: any): BusinessHoursEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new BusinessHoursEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["contactId"] = this.contactId;
        data["openingTime"] = this.openingTime ? this.openingTime.toJSON() : <any>undefined;
        data["closingTime"] = this.closingTime ? this.closingTime.toJSON() : <any>undefined;
        data["date"] = this.date ? this.date.toISOString() : <any>undefined;
        data["day"] = this.day;
        data["isClosed"] = this.isClosed;
        data["openingTimeString"] = this.openingTimeString;
        data["closingTimeString"] = this.closingTimeString;
        return data; 
    }
}

export interface IBusinessHoursEditDto {
    id: number | undefined;
    code: string | undefined;
    contactId: number;
    openingTime: TimeSpan;
    closingTime: TimeSpan;
    date: moment.Moment | undefined;
    day: string | undefined;
    isClosed: boolean;
    openingTimeString: string | undefined;
    closingTimeString: string | undefined;
}

export class CreateOrEditBusinessHoursInput implements ICreateOrEditBusinessHoursInput {
    contactId!: number;
    createOrEditBusinessHours!: BusinessHoursEditDto[] | undefined;

    constructor(data?: ICreateOrEditBusinessHoursInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            if (Array.isArray(data["createOrEditBusinessHours"])) {
                this.createOrEditBusinessHours = [] as any;
                for (let item of data["createOrEditBusinessHours"])
                    this.createOrEditBusinessHours!.push(BusinessHoursEditDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateOrEditBusinessHoursInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditBusinessHoursInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        if (Array.isArray(this.createOrEditBusinessHours)) {
            data["createOrEditBusinessHours"] = [];
            for (let item of this.createOrEditBusinessHours)
                data["createOrEditBusinessHours"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateOrEditBusinessHoursInput {
    contactId: number;
    createOrEditBusinessHours: BusinessHoursEditDto[] | undefined;
}

export class BusinessHoursCodeDto implements IBusinessHoursCodeDto {
    code!: string | undefined;

    constructor(data?: IBusinessHoursCodeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
        }
    }

    static fromJS(data: any): BusinessHoursCodeDto {
        data = typeof data === 'object' ? data : {};
        let result = new BusinessHoursCodeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        return data; 
    }
}

export interface IBusinessHoursCodeDto {
    code: string | undefined;
}

export class DAYOFTHEWEEKCODEDTO implements IDAYOFTHEWEEKCODEDTO {
    code!: string | undefined;

    constructor(data?: IDAYOFTHEWEEKCODEDTO) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
        }
    }

    static fromJS(data: any): DAYOFTHEWEEKCODEDTO {
        data = typeof data === 'object' ? data : {};
        let result = new DAYOFTHEWEEKCODEDTO();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        return data; 
    }
}

export interface IDAYOFTHEWEEKCODEDTO {
    code: string | undefined;
}

export enum CachedRequestPriority {
    CRITICAL = 0,
    IMPORTANT = 5,
    OPTIONAL = 10,
}

export class CachedRequestPriorityTypeDto implements ICachedRequestPriorityTypeDto {
    type!: CachedRequestPriority;
    name!: string | undefined;

    constructor(data?: ICachedRequestPriorityTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.type = data["type"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CachedRequestPriorityTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CachedRequestPriorityTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["type"] = this.type;
        data["name"] = this.name;
        return data; 
    }
}

export interface ICachedRequestPriorityTypeDto {
    type: CachedRequestPriority;
    name: string | undefined;
}

export class GetCachedRequestPriorityTypesDto implements IGetCachedRequestPriorityTypesDto {
    items!: CachedRequestPriorityTypeDto[] | undefined;

    constructor(data?: IGetCachedRequestPriorityTypesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(CachedRequestPriorityTypeDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetCachedRequestPriorityTypesDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetCachedRequestPriorityTypesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetCachedRequestPriorityTypesDto {
    items: CachedRequestPriorityTypeDto[] | undefined;
}

export class GetCachedRequestSettingListItemDto implements IGetCachedRequestSettingListItemDto {
    apiRequestCode!: string | undefined;
    type!: string | undefined;
    priority!: number;

    constructor(data?: IGetCachedRequestSettingListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.apiRequestCode = data["apiRequestCode"];
            this.type = data["type"];
            this.priority = data["priority"];
        }
    }

    static fromJS(data: any): GetCachedRequestSettingListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetCachedRequestSettingListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["apiRequestCode"] = this.apiRequestCode;
        data["type"] = this.type;
        data["priority"] = this.priority;
        return data; 
    }
}

export interface IGetCachedRequestSettingListItemDto {
    apiRequestCode: string | undefined;
    type: string | undefined;
    priority: number;
}

export class ListResultDtoOfGetCachedRequestSettingListItemDto implements IListResultDtoOfGetCachedRequestSettingListItemDto {
    items!: GetCachedRequestSettingListItemDto[] | undefined;

    constructor(data?: IListResultDtoOfGetCachedRequestSettingListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetCachedRequestSettingListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetCachedRequestSettingListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetCachedRequestSettingListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetCachedRequestSettingListItemDto {
    items: GetCachedRequestSettingListItemDto[] | undefined;
}

export class PagedResultDtoOfGetCachedRequestSettingListItemDto implements IPagedResultDtoOfGetCachedRequestSettingListItemDto {
    totalCount!: number;
    items!: GetCachedRequestSettingListItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetCachedRequestSettingListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetCachedRequestSettingListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetCachedRequestSettingListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetCachedRequestSettingListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetCachedRequestSettingListItemDto {
    totalCount: number;
    items: GetCachedRequestSettingListItemDto[] | undefined;
}

export class CreateOrUpdateCachedRequestSettingInputDto implements ICreateOrUpdateCachedRequestSettingInputDto {
    apiRequestCode!: string | undefined;
    type!: CachedRequestPriority;

    constructor(data?: ICreateOrUpdateCachedRequestSettingInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.apiRequestCode = data["apiRequestCode"];
            this.type = data["type"];
        }
    }

    static fromJS(data: any): CreateOrUpdateCachedRequestSettingInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateCachedRequestSettingInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["apiRequestCode"] = this.apiRequestCode;
        data["type"] = this.type;
        return data; 
    }
}

export interface ICreateOrUpdateCachedRequestSettingInputDto {
    apiRequestCode: string | undefined;
    type: CachedRequestPriority;
}

export class CacheDto implements ICacheDto {
    name!: string | undefined;

    constructor(data?: ICacheDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CacheDto {
        data = typeof data === 'object' ? data : {};
        let result = new CacheDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface ICacheDto {
    name: string | undefined;
}

export class ListResultDtoOfCacheDto implements IListResultDtoOfCacheDto {
    items!: CacheDto[] | undefined;

    constructor(data?: IListResultDtoOfCacheDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(CacheDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfCacheDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfCacheDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfCacheDto {
    items: CacheDto[] | undefined;
}

export class EntityDtoOfString implements IEntityDtoOfString {
    id!: string | undefined;

    constructor(data?: IEntityDtoOfString) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EntityDtoOfString {
        data = typeof data === 'object' ? data : {};
        let result = new EntityDtoOfString();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        return data; 
    }
}

export interface IEntityDtoOfString {
    id: string | undefined;
}

export enum FriendshipState {
    Accepted = 1,
    Blocked = 2,
}

export class FriendDto implements IFriendDto {
    friendUserId!: number;
    friendTenantId!: number | undefined;
    friendUserName!: string | undefined;
    friendTenancyName!: string | undefined;
    friendProfilePictureId!: string | undefined;
    unreadMessageCount!: number;
    isOnline!: boolean;
    state!: FriendshipState;

    constructor(data?: IFriendDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.friendUserId = data["friendUserId"];
            this.friendTenantId = data["friendTenantId"];
            this.friendUserName = data["friendUserName"];
            this.friendTenancyName = data["friendTenancyName"];
            this.friendProfilePictureId = data["friendProfilePictureId"];
            this.unreadMessageCount = data["unreadMessageCount"];
            this.isOnline = data["isOnline"];
            this.state = data["state"];
        }
    }

    static fromJS(data: any): FriendDto {
        data = typeof data === 'object' ? data : {};
        let result = new FriendDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["friendUserId"] = this.friendUserId;
        data["friendTenantId"] = this.friendTenantId;
        data["friendUserName"] = this.friendUserName;
        data["friendTenancyName"] = this.friendTenancyName;
        data["friendProfilePictureId"] = this.friendProfilePictureId;
        data["unreadMessageCount"] = this.unreadMessageCount;
        data["isOnline"] = this.isOnline;
        data["state"] = this.state;
        return data; 
    }
}

export interface IFriendDto {
    friendUserId: number;
    friendTenantId: number | undefined;
    friendUserName: string | undefined;
    friendTenancyName: string | undefined;
    friendProfilePictureId: string | undefined;
    unreadMessageCount: number;
    isOnline: boolean;
    state: FriendshipState;
}

export class GetUserChatFriendsWithSettingsOutput implements IGetUserChatFriendsWithSettingsOutput {
    serverTime!: moment.Moment;
    friends!: FriendDto[] | undefined;

    constructor(data?: IGetUserChatFriendsWithSettingsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.serverTime = data["serverTime"] ? moment(data["serverTime"].toString()) : <any>undefined;
            if (Array.isArray(data["friends"])) {
                this.friends = [] as any;
                for (let item of data["friends"])
                    this.friends!.push(FriendDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetUserChatFriendsWithSettingsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserChatFriendsWithSettingsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["serverTime"] = this.serverTime ? this.serverTime.toISOString() : <any>undefined;
        if (Array.isArray(this.friends)) {
            data["friends"] = [];
            for (let item of this.friends)
                data["friends"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetUserChatFriendsWithSettingsOutput {
    serverTime: moment.Moment;
    friends: FriendDto[] | undefined;
}

export enum ChatSide {
    Sender = 1,
    Receiver = 2,
}

export enum ChatMessageReadState {
    Unread = 1,
    Read = 2,
}

export class ChatMessageDto implements IChatMessageDto {
    userId!: number;
    tenantId!: number | undefined;
    targetUserId!: number;
    targetTenantId!: number | undefined;
    side!: ChatSide;
    readState!: ChatMessageReadState;
    receiverReadState!: ChatMessageReadState;
    message!: string | undefined;
    creationTime!: moment.Moment;
    sharedMessageId!: string | undefined;
    id!: number;

    constructor(data?: IChatMessageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
            this.targetUserId = data["targetUserId"];
            this.targetTenantId = data["targetTenantId"];
            this.side = data["side"];
            this.readState = data["readState"];
            this.receiverReadState = data["receiverReadState"];
            this.message = data["message"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.sharedMessageId = data["sharedMessageId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ChatMessageDto {
        data = typeof data === 'object' ? data : {};
        let result = new ChatMessageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        data["targetUserId"] = this.targetUserId;
        data["targetTenantId"] = this.targetTenantId;
        data["side"] = this.side;
        data["readState"] = this.readState;
        data["receiverReadState"] = this.receiverReadState;
        data["message"] = this.message;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["sharedMessageId"] = this.sharedMessageId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IChatMessageDto {
    userId: number;
    tenantId: number | undefined;
    targetUserId: number;
    targetTenantId: number | undefined;
    side: ChatSide;
    readState: ChatMessageReadState;
    receiverReadState: ChatMessageReadState;
    message: string | undefined;
    creationTime: moment.Moment;
    sharedMessageId: string | undefined;
    id: number;
}

export class ListResultDtoOfChatMessageDto implements IListResultDtoOfChatMessageDto {
    items!: ChatMessageDto[] | undefined;

    constructor(data?: IListResultDtoOfChatMessageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ChatMessageDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfChatMessageDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfChatMessageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfChatMessageDto {
    items: ChatMessageDto[] | undefined;
}

export class MarkAllUnreadMessagesOfUserAsReadInput implements IMarkAllUnreadMessagesOfUserAsReadInput {
    tenantId!: number | undefined;
    userId!: number;

    constructor(data?: IMarkAllUnreadMessagesOfUserAsReadInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): MarkAllUnreadMessagesOfUserAsReadInput {
        data = typeof data === 'object' ? data : {};
        let result = new MarkAllUnreadMessagesOfUserAsReadInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IMarkAllUnreadMessagesOfUserAsReadInput {
    tenantId: number | undefined;
    userId: number;
}

export class OrderSourceDto implements IOrderSourceDto {
    name!: string | undefined;
    code!: string | undefined;
    isActive!: number;
    tenantId!: number | undefined;
    orderTypeId!: number;
    orderType!: string | undefined;
    isHeaderFixed!: boolean;
    zipRegEx!: string | undefined;
    id!: number;

    constructor(data?: IOrderSourceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.isActive = data["isActive"];
            this.tenantId = data["tenantId"];
            this.orderTypeId = data["orderTypeId"];
            this.orderType = data["orderType"];
            this.isHeaderFixed = data["isHeaderFixed"];
            this.zipRegEx = data["zipRegEx"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderSourceDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderSourceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["isActive"] = this.isActive;
        data["tenantId"] = this.tenantId;
        data["orderTypeId"] = this.orderTypeId;
        data["orderType"] = this.orderType;
        data["isHeaderFixed"] = this.isHeaderFixed;
        data["zipRegEx"] = this.zipRegEx;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderSourceDto {
    name: string | undefined;
    code: string | undefined;
    isActive: number;
    tenantId: number | undefined;
    orderTypeId: number;
    orderType: string | undefined;
    isHeaderFixed: boolean;
    zipRegEx: string | undefined;
    id: number;
}

export class ClientConnectionDto implements IClientConnectionDto {
    username!: string | undefined;
    password!: string | undefined;
    url!: string | undefined;
    id!: number;

    constructor(data?: IClientConnectionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.username = data["username"];
            this.password = data["password"];
            this.url = data["url"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ClientConnectionDto {
        data = typeof data === 'object' ? data : {};
        let result = new ClientConnectionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["username"] = this.username;
        data["password"] = this.password;
        data["url"] = this.url;
        data["id"] = this.id;
        return data; 
    }
}

export interface IClientConnectionDto {
    username: string | undefined;
    password: string | undefined;
    url: string | undefined;
    id: number;
}

export class ClientRouteTemplate implements IClientRouteTemplate {
    id!: number;
    name!: string | undefined;

    constructor(data?: IClientRouteTemplate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): ClientRouteTemplate {
        data = typeof data === 'object' ? data : {};
        let result = new ClientRouteTemplate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IClientRouteTemplate {
    id: number;
    name: string | undefined;
}

export class ClientAccountDto implements IClientAccountDto {
    accountNumber!: string | undefined;
    orderSourceId!: number;
    connectionId!: number;
    routeTemplateId!: number;
    orderSource!: OrderSourceDto | undefined;
    connections!: ClientConnectionDto | undefined;
    routeTemplate!: ClientRouteTemplate | undefined;
    downloadRange!: number;
    downloadFrequency!: number;
    isAutoAssign!: boolean;
    inActive!: boolean;
    isUpdateOrders!: boolean;
    id!: number;

    constructor(data?: IClientAccountDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accountNumber = data["accountNumber"];
            this.orderSourceId = data["orderSourceId"];
            this.connectionId = data["connectionId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.orderSource = data["orderSource"] ? OrderSourceDto.fromJS(data["orderSource"]) : <any>undefined;
            this.connections = data["connections"] ? ClientConnectionDto.fromJS(data["connections"]) : <any>undefined;
            this.routeTemplate = data["routeTemplate"] ? ClientRouteTemplate.fromJS(data["routeTemplate"]) : <any>undefined;
            this.downloadRange = data["downloadRange"];
            this.downloadFrequency = data["downloadFrequency"];
            this.isAutoAssign = data["isAutoAssign"];
            this.inActive = data["inActive"];
            this.isUpdateOrders = data["isUpdateOrders"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ClientAccountDto {
        data = typeof data === 'object' ? data : {};
        let result = new ClientAccountDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accountNumber"] = this.accountNumber;
        data["orderSourceId"] = this.orderSourceId;
        data["connectionId"] = this.connectionId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["orderSource"] = this.orderSource ? this.orderSource.toJSON() : <any>undefined;
        data["connections"] = this.connections ? this.connections.toJSON() : <any>undefined;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["downloadRange"] = this.downloadRange;
        data["downloadFrequency"] = this.downloadFrequency;
        data["isAutoAssign"] = this.isAutoAssign;
        data["inActive"] = this.inActive;
        data["isUpdateOrders"] = this.isUpdateOrders;
        data["id"] = this.id;
        return data; 
    }
}

export interface IClientAccountDto {
    accountNumber: string | undefined;
    orderSourceId: number;
    connectionId: number;
    routeTemplateId: number;
    orderSource: OrderSourceDto | undefined;
    connections: ClientConnectionDto | undefined;
    routeTemplate: ClientRouteTemplate | undefined;
    downloadRange: number;
    downloadFrequency: number;
    isAutoAssign: boolean;
    inActive: boolean;
    isUpdateOrders: boolean;
    id: number;
}

export class GetClientAccountForViewDto implements IGetClientAccountForViewDto {
    clientAccount!: ClientAccountDto | undefined;

    constructor(data?: IGetClientAccountForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientAccount = data["clientAccount"] ? ClientAccountDto.fromJS(data["clientAccount"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetClientAccountForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetClientAccountForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientAccount"] = this.clientAccount ? this.clientAccount.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetClientAccountForViewDto {
    clientAccount: ClientAccountDto | undefined;
}

export class PagedResultDtoOfGetClientAccountForViewDto implements IPagedResultDtoOfGetClientAccountForViewDto {
    totalCount!: number;
    items!: GetClientAccountForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetClientAccountForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetClientAccountForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetClientAccountForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetClientAccountForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetClientAccountForViewDto {
    totalCount: number;
    items: GetClientAccountForViewDto[] | undefined;
}

export class CreateOrEditClientAccountDto implements ICreateOrEditClientAccountDto {
    accountNumber!: string | undefined;
    orderSource!: OrderSourceDto | undefined;
    connections!: ClientConnectionDto | undefined;
    orderSourceId!: number;
    connectionId!: number;
    downloadFrequency!: number;
    downloadRange!: number;
    tenantId!: number | undefined;
    isAutoAssign!: boolean;
    inActive!: boolean;
    isUpdateOrders!: boolean;
    id!: number | undefined;

    constructor(data?: ICreateOrEditClientAccountDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accountNumber = data["accountNumber"];
            this.orderSource = data["orderSource"] ? OrderSourceDto.fromJS(data["orderSource"]) : <any>undefined;
            this.connections = data["connections"] ? ClientConnectionDto.fromJS(data["connections"]) : <any>undefined;
            this.orderSourceId = data["orderSourceId"];
            this.connectionId = data["connectionId"];
            this.downloadFrequency = data["downloadFrequency"];
            this.downloadRange = data["downloadRange"];
            this.tenantId = data["tenantId"];
            this.isAutoAssign = data["isAutoAssign"];
            this.inActive = data["inActive"];
            this.isUpdateOrders = data["isUpdateOrders"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditClientAccountDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditClientAccountDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accountNumber"] = this.accountNumber;
        data["orderSource"] = this.orderSource ? this.orderSource.toJSON() : <any>undefined;
        data["connections"] = this.connections ? this.connections.toJSON() : <any>undefined;
        data["orderSourceId"] = this.orderSourceId;
        data["connectionId"] = this.connectionId;
        data["downloadFrequency"] = this.downloadFrequency;
        data["downloadRange"] = this.downloadRange;
        data["tenantId"] = this.tenantId;
        data["isAutoAssign"] = this.isAutoAssign;
        data["inActive"] = this.inActive;
        data["isUpdateOrders"] = this.isUpdateOrders;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditClientAccountDto {
    accountNumber: string | undefined;
    orderSource: OrderSourceDto | undefined;
    connections: ClientConnectionDto | undefined;
    orderSourceId: number;
    connectionId: number;
    downloadFrequency: number;
    downloadRange: number;
    tenantId: number | undefined;
    isAutoAssign: boolean;
    inActive: boolean;
    isUpdateOrders: boolean;
    id: number | undefined;
}

export class GetClientAccountForEditOutput implements IGetClientAccountForEditOutput {
    clientAccount!: CreateOrEditClientAccountDto | undefined;

    constructor(data?: IGetClientAccountForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientAccount = data["clientAccount"] ? CreateOrEditClientAccountDto.fromJS(data["clientAccount"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetClientAccountForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetClientAccountForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientAccount"] = this.clientAccount ? this.clientAccount.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetClientAccountForEditOutput {
    clientAccount: CreateOrEditClientAccountDto | undefined;
}

export class AuthenticationResult implements IAuthenticationResult {
    access_token!: string | undefined;
    token_type!: string | undefined;
    expires_in!: number;
    username!: string | undefined;
    caller_id!: number;
    issued!: moment.Moment;
    expires!: moment.Moment;

    constructor(data?: IAuthenticationResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.access_token = data["access_token"];
            this.token_type = data["token_type"];
            this.expires_in = data["expires_in"];
            this.username = data["username"];
            this.caller_id = data["caller_id"];
            this.issued = data["issued"] ? moment(data["issued"].toString()) : <any>undefined;
            this.expires = data["expires"] ? moment(data["expires"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): AuthenticationResult {
        data = typeof data === 'object' ? data : {};
        let result = new AuthenticationResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["access_token"] = this.access_token;
        data["token_type"] = this.token_type;
        data["expires_in"] = this.expires_in;
        data["username"] = this.username;
        data["caller_id"] = this.caller_id;
        data["issued"] = this.issued ? this.issued.toISOString() : <any>undefined;
        data["expires"] = this.expires ? this.expires.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IAuthenticationResult {
    access_token: string | undefined;
    token_type: string | undefined;
    expires_in: number;
    username: string | undefined;
    caller_id: number;
    issued: moment.Moment;
    expires: moment.Moment;
}

export class CreateOrderApiResult implements ICreateOrderApiResult {
    packageIds!: number[] | undefined;
    trackingIdentifier!: string | undefined;
    orderId!: number;
    message!: string | undefined;
    isSuccess!: boolean;
    isUpdate!: boolean;
    locationId!: number | undefined;
    deliveryDate!: moment.Moment | undefined;
    routeStartContactId!: number | undefined;

    constructor(data?: ICreateOrderApiResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["packageIds"])) {
                this.packageIds = [] as any;
                for (let item of data["packageIds"])
                    this.packageIds!.push(item);
            }
            this.trackingIdentifier = data["trackingIdentifier"];
            this.orderId = data["orderId"];
            this.message = data["message"];
            this.isSuccess = data["isSuccess"];
            this.isUpdate = data["isUpdate"];
            this.locationId = data["locationId"];
            this.deliveryDate = data["deliveryDate"] ? moment(data["deliveryDate"].toString()) : <any>undefined;
            this.routeStartContactId = data["routeStartContactId"];
        }
    }

    static fromJS(data: any): CreateOrderApiResult {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderApiResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.packageIds)) {
            data["packageIds"] = [];
            for (let item of this.packageIds)
                data["packageIds"].push(item);
        }
        data["trackingIdentifier"] = this.trackingIdentifier;
        data["orderId"] = this.orderId;
        data["message"] = this.message;
        data["isSuccess"] = this.isSuccess;
        data["isUpdate"] = this.isUpdate;
        data["locationId"] = this.locationId;
        data["deliveryDate"] = this.deliveryDate ? this.deliveryDate.toISOString() : <any>undefined;
        data["routeStartContactId"] = this.routeStartContactId;
        return data; 
    }
}

export interface ICreateOrderApiResult {
    packageIds: number[] | undefined;
    trackingIdentifier: string | undefined;
    orderId: number;
    message: string | undefined;
    isSuccess: boolean;
    isUpdate: boolean;
    locationId: number | undefined;
    deliveryDate: moment.Moment | undefined;
    routeStartContactId: number | undefined;
}

export class OrderType implements IOrderType {
    tenantId!: number | undefined;
    code!: string;
    description!: string | undefined;
    isActive!: boolean;
    color!: string | undefined;
    textColor!: string | undefined;
    sortOrder!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.description = data["description"];
            this.isActive = data["isActive"];
            this.color = data["color"];
            this.textColor = data["textColor"];
            this.sortOrder = data["sortOrder"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderType {
        data = typeof data === 'object' ? data : {};
        let result = new OrderType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["description"] = this.description;
        data["isActive"] = this.isActive;
        data["color"] = this.color;
        data["textColor"] = this.textColor;
        data["sortOrder"] = this.sortOrder;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderType {
    tenantId: number | undefined;
    code: string;
    description: string | undefined;
    isActive: boolean;
    color: string | undefined;
    textColor: string | undefined;
    sortOrder: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderSource implements IOrderSource {
    tenantId!: number | undefined;
    name!: string;
    code!: string;
    isActive!: number;
    orderType!: OrderType | undefined;
    orderTypeId!: number;
    isHeaderFixed!: boolean;
    zipRegEx!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderSource) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.code = data["code"];
            this.isActive = data["isActive"];
            this.orderType = data["orderType"] ? OrderType.fromJS(data["orderType"]) : <any>undefined;
            this.orderTypeId = data["orderTypeId"];
            this.isHeaderFixed = data["isHeaderFixed"];
            this.zipRegEx = data["zipRegEx"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderSource {
        data = typeof data === 'object' ? data : {};
        let result = new OrderSource();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["isActive"] = this.isActive;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["orderTypeId"] = this.orderTypeId;
        data["isHeaderFixed"] = this.isHeaderFixed;
        data["zipRegEx"] = this.zipRegEx;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderSource {
    tenantId: number | undefined;
    name: string;
    code: string;
    isActive: number;
    orderType: OrderType | undefined;
    orderTypeId: number;
    isHeaderFixed: boolean;
    zipRegEx: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ClientConnection implements IClientConnection {
    tenantId!: number | undefined;
    username!: string;
    password!: string;
    url!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IClientConnection) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.username = data["username"];
            this.password = data["password"];
            this.url = data["url"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ClientConnection {
        data = typeof data === 'object' ? data : {};
        let result = new ClientConnection();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["username"] = this.username;
        data["password"] = this.password;
        data["url"] = this.url;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IClientConnection {
    tenantId: number | undefined;
    username: string;
    password: string;
    url: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ClientAccount implements IClientAccount {
    tenantId!: number | undefined;
    accountNumber!: string;
    orderSource!: OrderSource;
    orderSourceId!: number;
    clientConnection!: ClientConnection;
    connectionId!: number;
    downloadRange!: number;
    downloadFrequency!: number;
    isRunning!: boolean;
    isAutoAssign!: boolean;
    inActive!: boolean;
    isUpdateOrders!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IClientAccount) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.orderSource = new OrderSource();
            this.clientConnection = new ClientConnection();
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.accountNumber = data["accountNumber"];
            this.orderSource = data["orderSource"] ? OrderSource.fromJS(data["orderSource"]) : new OrderSource();
            this.orderSourceId = data["orderSourceId"];
            this.clientConnection = data["clientConnection"] ? ClientConnection.fromJS(data["clientConnection"]) : new ClientConnection();
            this.connectionId = data["connectionId"];
            this.downloadRange = data["downloadRange"];
            this.downloadFrequency = data["downloadFrequency"];
            this.isRunning = data["isRunning"];
            this.isAutoAssign = data["isAutoAssign"];
            this.inActive = data["inActive"];
            this.isUpdateOrders = data["isUpdateOrders"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ClientAccount {
        data = typeof data === 'object' ? data : {};
        let result = new ClientAccount();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["accountNumber"] = this.accountNumber;
        data["orderSource"] = this.orderSource ? this.orderSource.toJSON() : <any>undefined;
        data["orderSourceId"] = this.orderSourceId;
        data["clientConnection"] = this.clientConnection ? this.clientConnection.toJSON() : <any>undefined;
        data["connectionId"] = this.connectionId;
        data["downloadRange"] = this.downloadRange;
        data["downloadFrequency"] = this.downloadFrequency;
        data["isRunning"] = this.isRunning;
        data["isAutoAssign"] = this.isAutoAssign;
        data["inActive"] = this.inActive;
        data["isUpdateOrders"] = this.isUpdateOrders;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IClientAccount {
    tenantId: number | undefined;
    accountNumber: string;
    orderSource: OrderSource;
    orderSourceId: number;
    clientConnection: ClientConnection;
    connectionId: number;
    downloadRange: number;
    downloadFrequency: number;
    isRunning: boolean;
    isAutoAssign: boolean;
    inActive: boolean;
    isUpdateOrders: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DownloadOrdersInput implements IDownloadOrdersInput {
    startDate!: moment.Moment;
    endDate!: moment.Moment;
    recordPerPage!: number;
    accountId!: number;
    tenantId!: number | undefined;

    constructor(data?: IDownloadOrdersInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.endDate = data["endDate"] ? moment(data["endDate"].toString()) : <any>undefined;
            this.recordPerPage = data["recordPerPage"];
            this.accountId = data["accountId"];
            this.tenantId = data["tenantId"];
        }
    }

    static fromJS(data: any): DownloadOrdersInput {
        data = typeof data === 'object' ? data : {};
        let result = new DownloadOrdersInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["endDate"] = this.endDate ? this.endDate.toISOString() : <any>undefined;
        data["recordPerPage"] = this.recordPerPage;
        data["accountId"] = this.accountId;
        data["tenantId"] = this.tenantId;
        return data; 
    }
}

export interface IDownloadOrdersInput {
    startDate: moment.Moment;
    endDate: moment.Moment;
    recordPerPage: number;
    accountId: number;
    tenantId: number | undefined;
}

export class GenerateResultDto implements IGenerateResultDto {
    success!: boolean;
    jobId!: string | undefined;
    result!: string | undefined;

    constructor(data?: IGenerateResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.success = data["success"];
            this.jobId = data["jobId"];
            this.result = data["result"];
        }
    }

    static fromJS(data: any): GenerateResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GenerateResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["success"] = this.success;
        data["jobId"] = this.jobId;
        data["result"] = this.result;
        return data; 
    }
}

export interface IGenerateResultDto {
    success: boolean;
    jobId: string | undefined;
    result: string | undefined;
}

export class GetClientConnectionForViewDto implements IGetClientConnectionForViewDto {
    clientConnection!: ClientConnectionDto | undefined;

    constructor(data?: IGetClientConnectionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientConnection = data["clientConnection"] ? ClientConnectionDto.fromJS(data["clientConnection"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetClientConnectionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetClientConnectionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientConnection"] = this.clientConnection ? this.clientConnection.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetClientConnectionForViewDto {
    clientConnection: ClientConnectionDto | undefined;
}

export class PagedResultDtoOfGetClientConnectionForViewDto implements IPagedResultDtoOfGetClientConnectionForViewDto {
    totalCount!: number;
    items!: GetClientConnectionForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetClientConnectionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetClientConnectionForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetClientConnectionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetClientConnectionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetClientConnectionForViewDto {
    totalCount: number;
    items: GetClientConnectionForViewDto[] | undefined;
}

export class CreateOrEditClientConnectionDto implements ICreateOrEditClientConnectionDto {
    username!: string;
    password!: string | undefined;
    url!: string;
    id!: number | undefined;

    constructor(data?: ICreateOrEditClientConnectionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.username = data["username"];
            this.password = data["password"];
            this.url = data["url"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditClientConnectionDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditClientConnectionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["username"] = this.username;
        data["password"] = this.password;
        data["url"] = this.url;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditClientConnectionDto {
    username: string;
    password: string | undefined;
    url: string;
    id: number | undefined;
}

export class GetClientConnectionForEditOutput implements IGetClientConnectionForEditOutput {
    clientConnection!: CreateOrEditClientConnectionDto | undefined;

    constructor(data?: IGetClientConnectionForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientConnection = data["clientConnection"] ? CreateOrEditClientConnectionDto.fromJS(data["clientConnection"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetClientConnectionForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetClientConnectionForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientConnection"] = this.clientConnection ? this.clientConnection.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetClientConnectionForEditOutput {
    clientConnection: CreateOrEditClientConnectionDto | undefined;
}

export class ClientDriversDto implements IClientDriversDto {
    id!: number;
    driverId!: string | undefined;
    firstName!: string | undefined;
    lastName!: string | undefined;
    userName!: string | undefined;
    isActive!: boolean;
    clientAccountId!: number;
    clientAccount!: string | undefined;

    constructor(data?: IClientDriversDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.driverId = data["driverId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.userName = data["userName"];
            this.isActive = data["isActive"];
            this.clientAccountId = data["clientAccountId"];
            this.clientAccount = data["clientAccount"];
        }
    }

    static fromJS(data: any): ClientDriversDto {
        data = typeof data === 'object' ? data : {};
        let result = new ClientDriversDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["driverId"] = this.driverId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["userName"] = this.userName;
        data["isActive"] = this.isActive;
        data["clientAccountId"] = this.clientAccountId;
        data["clientAccount"] = this.clientAccount;
        return data; 
    }
}

export interface IClientDriversDto {
    id: number;
    driverId: string | undefined;
    firstName: string | undefined;
    lastName: string | undefined;
    userName: string | undefined;
    isActive: boolean;
    clientAccountId: number;
    clientAccount: string | undefined;
}

export class PagedResultDtoOfClientDriversDto implements IPagedResultDtoOfClientDriversDto {
    totalCount!: number;
    items!: ClientDriversDto[] | undefined;

    constructor(data?: IPagedResultDtoOfClientDriversDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ClientDriversDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfClientDriversDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfClientDriversDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfClientDriversDto {
    totalCount: number;
    items: ClientDriversDto[] | undefined;
}

export class CreateClientDriverInput implements ICreateClientDriverInput {
    tenantId!: number | undefined;
    driverId!: string | undefined;
    firstName!: string | undefined;
    lastName!: string | undefined;
    accountId!: number;
    locationId!: number;

    constructor(data?: ICreateClientDriverInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.driverId = data["driverId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.accountId = data["accountId"];
            this.locationId = data["locationId"];
        }
    }

    static fromJS(data: any): CreateClientDriverInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateClientDriverInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["driverId"] = this.driverId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["accountId"] = this.accountId;
        data["locationId"] = this.locationId;
        return data; 
    }
}

export interface ICreateClientDriverInput {
    tenantId: number | undefined;
    driverId: string | undefined;
    firstName: string | undefined;
    lastName: string | undefined;
    accountId: number;
    locationId: number;
}

export class CreateClientDriverResult implements ICreateClientDriverResult {
    driverId!: string | undefined;
    vehicleId!: number;
    userId!: number;
    clientAccountId!: number;
    firstName!: string | undefined;
    lastName!: string | undefined;
    message!: string | undefined;
    exception!: string | undefined;

    constructor(data?: ICreateClientDriverResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverId = data["driverId"];
            this.vehicleId = data["vehicleId"];
            this.userId = data["userId"];
            this.clientAccountId = data["clientAccountId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.message = data["message"];
            this.exception = data["exception"];
        }
    }

    static fromJS(data: any): CreateClientDriverResult {
        data = typeof data === 'object' ? data : {};
        let result = new CreateClientDriverResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverId"] = this.driverId;
        data["vehicleId"] = this.vehicleId;
        data["userId"] = this.userId;
        data["clientAccountId"] = this.clientAccountId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["message"] = this.message;
        data["exception"] = this.exception;
        return data; 
    }
}

export interface ICreateClientDriverResult {
    driverId: string | undefined;
    vehicleId: number;
    userId: number;
    clientAccountId: number;
    firstName: string | undefined;
    lastName: string | undefined;
    message: string | undefined;
    exception: string | undefined;
}

export class CreateClientOrderLogDto implements ICreateClientOrderLogDto {
    clientAccountId!: number;
    response!: string | undefined;
    success!: number;
    failed!: number;
    total!: number;

    constructor(data?: ICreateClientOrderLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientAccountId = data["clientAccountId"];
            this.response = data["response"];
            this.success = data["success"];
            this.failed = data["failed"];
            this.total = data["total"];
        }
    }

    static fromJS(data: any): CreateClientOrderLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateClientOrderLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientAccountId"] = this.clientAccountId;
        data["response"] = this.response;
        data["success"] = this.success;
        data["failed"] = this.failed;
        data["total"] = this.total;
        return data; 
    }
}

export interface ICreateClientOrderLogDto {
    clientAccountId: number;
    response: string | undefined;
    success: number;
    failed: number;
    total: number;
}

export class ClientOrderLogDto implements IClientOrderLogDto {
    id!: number;
    clientAccountId!: number;
    clientName!: string | undefined;
    response!: string | undefined;
    responseShort!: string | undefined;
    success!: number;
    failed!: number;
    total!: number;
    creationTime!: string | undefined;
    duration!: number;
    durationString!: string | undefined;

    constructor(data?: IClientOrderLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.clientAccountId = data["clientAccountId"];
            this.clientName = data["clientName"];
            this.response = data["response"];
            this.responseShort = data["responseShort"];
            this.success = data["success"];
            this.failed = data["failed"];
            this.total = data["total"];
            this.creationTime = data["creationTime"];
            this.duration = data["duration"];
            this.durationString = data["durationString"];
        }
    }

    static fromJS(data: any): ClientOrderLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new ClientOrderLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["clientAccountId"] = this.clientAccountId;
        data["clientName"] = this.clientName;
        data["response"] = this.response;
        data["responseShort"] = this.responseShort;
        data["success"] = this.success;
        data["failed"] = this.failed;
        data["total"] = this.total;
        data["creationTime"] = this.creationTime;
        data["duration"] = this.duration;
        data["durationString"] = this.durationString;
        return data; 
    }
}

export interface IClientOrderLogDto {
    id: number;
    clientAccountId: number;
    clientName: string | undefined;
    response: string | undefined;
    responseShort: string | undefined;
    success: number;
    failed: number;
    total: number;
    creationTime: string | undefined;
    duration: number;
    durationString: string | undefined;
}

export class PagedResultDtoOfClientOrderLogDto implements IPagedResultDtoOfClientOrderLogDto {
    totalCount!: number;
    items!: ClientOrderLogDto[] | undefined;

    constructor(data?: IPagedResultDtoOfClientOrderLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ClientOrderLogDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfClientOrderLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfClientOrderLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfClientOrderLogDto {
    totalCount: number;
    items: ClientOrderLogDto[] | undefined;
}

export class PreferenceDtos implements IPreferenceDtos {
    code!: string | undefined;
    description!: string | undefined;
    value!: number;
    id!: number;

    constructor(data?: IPreferenceDtos) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PreferenceDtos {
        data = typeof data === 'object' ? data : {};
        let result = new PreferenceDtos();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPreferenceDtos {
    code: string | undefined;
    description: string | undefined;
    value: number;
    id: number;
}

export class ClientPreferenceDto implements IClientPreferenceDto {
    value!: string | undefined;
    preferences!: PreferenceDtos | undefined;
    preferenceId!: number;
    id!: number;

    constructor(data?: IClientPreferenceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.preferences = data["preferences"] ? PreferenceDtos.fromJS(data["preferences"]) : <any>undefined;
            this.preferenceId = data["preferenceId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ClientPreferenceDto {
        data = typeof data === 'object' ? data : {};
        let result = new ClientPreferenceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["preferences"] = this.preferences ? this.preferences.toJSON() : <any>undefined;
        data["preferenceId"] = this.preferenceId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IClientPreferenceDto {
    value: string | undefined;
    preferences: PreferenceDtos | undefined;
    preferenceId: number;
    id: number;
}

export class GetClientPreferenceForViewDto implements IGetClientPreferenceForViewDto {
    clientPreference!: ClientPreferenceDto | undefined;

    constructor(data?: IGetClientPreferenceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientPreference = data["clientPreference"] ? ClientPreferenceDto.fromJS(data["clientPreference"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetClientPreferenceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetClientPreferenceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientPreference"] = this.clientPreference ? this.clientPreference.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetClientPreferenceForViewDto {
    clientPreference: ClientPreferenceDto | undefined;
}

export class PagedResultDtoOfGetClientPreferenceForViewDto implements IPagedResultDtoOfGetClientPreferenceForViewDto {
    totalCount!: number;
    items!: GetClientPreferenceForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetClientPreferenceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetClientPreferenceForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetClientPreferenceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetClientPreferenceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetClientPreferenceForViewDto {
    totalCount: number;
    items: GetClientPreferenceForViewDto[] | undefined;
}

export class CreateOrEditClientPreferenceDto implements ICreateOrEditClientPreferenceDto {
    value!: string | undefined;
    preferenceId!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditClientPreferenceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.preferenceId = data["preferenceId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditClientPreferenceDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditClientPreferenceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["preferenceId"] = this.preferenceId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditClientPreferenceDto {
    value: string | undefined;
    preferenceId: number;
    id: number | undefined;
}

export class GetClientPreferenceForEditOutput implements IGetClientPreferenceForEditOutput {
    clientPreference!: CreateOrEditClientPreferenceDto | undefined;

    constructor(data?: IGetClientPreferenceForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientPreference = data["clientPreference"] ? CreateOrEditClientPreferenceDto.fromJS(data["clientPreference"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetClientPreferenceForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetClientPreferenceForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientPreference"] = this.clientPreference ? this.clientPreference.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetClientPreferenceForEditOutput {
    clientPreference: CreateOrEditClientPreferenceDto | undefined;
}

export class ClinicDto implements IClinicDto {
    id!: number;
    clinicNotes!: string | undefined;
    billingNotes!: string | undefined;
    contactId!: number;
    clinicName!: string | undefined;
    clinicAccountNumber!: string | undefined;
    clinicVisibleToDriver!: boolean;
    active!: boolean;
    email!: string | undefined;
    clinicAddress!: string | undefined;
    city!: string | undefined;
    postalCode!: string | undefined;
    country!: string | undefined;
    state!: string | undefined;
    creationTime!: moment.Moment;
    creator!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUser!: string | undefined;
    modifiedAccountNo!: string | undefined;

    constructor(data?: IClinicDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.clinicNotes = data["clinicNotes"];
            this.billingNotes = data["billingNotes"];
            this.contactId = data["contactId"];
            this.clinicName = data["clinicName"];
            this.clinicAccountNumber = data["clinicAccountNumber"];
            this.clinicVisibleToDriver = data["clinicVisibleToDriver"];
            this.active = data["active"];
            this.email = data["email"];
            this.clinicAddress = data["clinicAddress"];
            this.city = data["city"];
            this.postalCode = data["postalCode"];
            this.country = data["country"];
            this.state = data["state"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creator = data["creator"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUser = data["lastModifierUser"];
            this.modifiedAccountNo = data["modifiedAccountNo"];
        }
    }

    static fromJS(data: any): ClinicDto {
        data = typeof data === 'object' ? data : {};
        let result = new ClinicDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["clinicNotes"] = this.clinicNotes;
        data["billingNotes"] = this.billingNotes;
        data["contactId"] = this.contactId;
        data["clinicName"] = this.clinicName;
        data["clinicAccountNumber"] = this.clinicAccountNumber;
        data["clinicVisibleToDriver"] = this.clinicVisibleToDriver;
        data["active"] = this.active;
        data["email"] = this.email;
        data["clinicAddress"] = this.clinicAddress;
        data["city"] = this.city;
        data["postalCode"] = this.postalCode;
        data["country"] = this.country;
        data["state"] = this.state;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creator"] = this.creator;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUser"] = this.lastModifierUser;
        data["modifiedAccountNo"] = this.modifiedAccountNo;
        return data; 
    }
}

export interface IClinicDto {
    id: number;
    clinicNotes: string | undefined;
    billingNotes: string | undefined;
    contactId: number;
    clinicName: string | undefined;
    clinicAccountNumber: string | undefined;
    clinicVisibleToDriver: boolean;
    active: boolean;
    email: string | undefined;
    clinicAddress: string | undefined;
    city: string | undefined;
    postalCode: string | undefined;
    country: string | undefined;
    state: string | undefined;
    creationTime: moment.Moment;
    creator: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUser: string | undefined;
    modifiedAccountNo: string | undefined;
}

export class GetClinicForViewDto implements IGetClinicForViewDto {
    clinic!: ClinicDto | undefined;

    constructor(data?: IGetClinicForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinic = data["clinic"] ? ClinicDto.fromJS(data["clinic"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetClinicForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetClinicForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinic"] = this.clinic ? this.clinic.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetClinicForViewDto {
    clinic: ClinicDto | undefined;
}

export class PagedResultDtoOfGetClinicForViewDto implements IPagedResultDtoOfGetClinicForViewDto {
    totalCount!: number;
    items!: GetClinicForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetClinicForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetClinicForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetClinicForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetClinicForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetClinicForViewDto {
    totalCount: number;
    items: GetClinicForViewDto[] | undefined;
}

export class GetContactSettingsItemDto implements IGetContactSettingsItemDto {
    code!: string | undefined;
    value!: string | undefined;

    constructor(data?: IGetContactSettingsItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): GetContactSettingsItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactSettingsItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["value"] = this.value;
        return data; 
    }
}

export interface IGetContactSettingsItemDto {
    code: string | undefined;
    value: string | undefined;
}

export class ContactGroupSettingsItemDto implements IContactGroupSettingsItemDto {
    code!: string | undefined;

    constructor(data?: IContactGroupSettingsItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
        }
    }

    static fromJS(data: any): ContactGroupSettingsItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ContactGroupSettingsItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        return data; 
    }
}

export interface IContactGroupSettingsItemDto {
    code: string | undefined;
}

export class CreateOrEditClinicDto implements ICreateOrEditClinicDto {
    clinicNotes!: string | undefined;
    clinicNotesVisibleToDriver!: boolean;
    active!: boolean;
    billingNotes!: string | undefined;
    contactId!: number;
    address!: CreateAddressInput | undefined;
    companyName!: string | undefined;
    accountNumber!: string | undefined;
    email!: string | undefined;
    mondayClinicNotes!: string | undefined;
    tuesdayClinicNotes!: string | undefined;
    wednesdayClinicNotes!: string | undefined;
    thursdayClinicNotes!: string | undefined;
    fridayClinicNotes!: string | undefined;
    saturdayClinicNotes!: string | undefined;
    sundayClinicNotes!: string | undefined;
    clinicLatitude!: number;
    clinicLongitude!: number;
    addressIdFromAntrim!: number | undefined;
    clinicPhoneNumber!: string | undefined;
    contactSetting!: GetContactSettingsItemDto[] | undefined;
    contactGroupSetting!: ContactGroupSettingsItemDto[] | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditClinicDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicNotes = data["clinicNotes"];
            this.clinicNotesVisibleToDriver = data["clinicNotesVisibleToDriver"];
            this.active = data["active"];
            this.billingNotes = data["billingNotes"];
            this.contactId = data["contactId"];
            this.address = data["address"] ? CreateAddressInput.fromJS(data["address"]) : <any>undefined;
            this.companyName = data["companyName"];
            this.accountNumber = data["accountNumber"];
            this.email = data["email"];
            this.mondayClinicNotes = data["mondayClinicNotes"];
            this.tuesdayClinicNotes = data["tuesdayClinicNotes"];
            this.wednesdayClinicNotes = data["wednesdayClinicNotes"];
            this.thursdayClinicNotes = data["thursdayClinicNotes"];
            this.fridayClinicNotes = data["fridayClinicNotes"];
            this.saturdayClinicNotes = data["saturdayClinicNotes"];
            this.sundayClinicNotes = data["sundayClinicNotes"];
            this.clinicLatitude = data["clinicLatitude"];
            this.clinicLongitude = data["clinicLongitude"];
            this.addressIdFromAntrim = data["addressIdFromAntrim"];
            this.clinicPhoneNumber = data["clinicPhoneNumber"];
            if (Array.isArray(data["contactSetting"])) {
                this.contactSetting = [] as any;
                for (let item of data["contactSetting"])
                    this.contactSetting!.push(GetContactSettingsItemDto.fromJS(item));
            }
            if (Array.isArray(data["contactGroupSetting"])) {
                this.contactGroupSetting = [] as any;
                for (let item of data["contactGroupSetting"])
                    this.contactGroupSetting!.push(ContactGroupSettingsItemDto.fromJS(item));
            }
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditClinicDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditClinicDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicNotes"] = this.clinicNotes;
        data["clinicNotesVisibleToDriver"] = this.clinicNotesVisibleToDriver;
        data["active"] = this.active;
        data["billingNotes"] = this.billingNotes;
        data["contactId"] = this.contactId;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["companyName"] = this.companyName;
        data["accountNumber"] = this.accountNumber;
        data["email"] = this.email;
        data["mondayClinicNotes"] = this.mondayClinicNotes;
        data["tuesdayClinicNotes"] = this.tuesdayClinicNotes;
        data["wednesdayClinicNotes"] = this.wednesdayClinicNotes;
        data["thursdayClinicNotes"] = this.thursdayClinicNotes;
        data["fridayClinicNotes"] = this.fridayClinicNotes;
        data["saturdayClinicNotes"] = this.saturdayClinicNotes;
        data["sundayClinicNotes"] = this.sundayClinicNotes;
        data["clinicLatitude"] = this.clinicLatitude;
        data["clinicLongitude"] = this.clinicLongitude;
        data["addressIdFromAntrim"] = this.addressIdFromAntrim;
        data["clinicPhoneNumber"] = this.clinicPhoneNumber;
        if (Array.isArray(this.contactSetting)) {
            data["contactSetting"] = [];
            for (let item of this.contactSetting)
                data["contactSetting"].push(item.toJSON());
        }
        if (Array.isArray(this.contactGroupSetting)) {
            data["contactGroupSetting"] = [];
            for (let item of this.contactGroupSetting)
                data["contactGroupSetting"].push(item.toJSON());
        }
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditClinicDto {
    clinicNotes: string | undefined;
    clinicNotesVisibleToDriver: boolean;
    active: boolean;
    billingNotes: string | undefined;
    contactId: number;
    address: CreateAddressInput | undefined;
    companyName: string | undefined;
    accountNumber: string | undefined;
    email: string | undefined;
    mondayClinicNotes: string | undefined;
    tuesdayClinicNotes: string | undefined;
    wednesdayClinicNotes: string | undefined;
    thursdayClinicNotes: string | undefined;
    fridayClinicNotes: string | undefined;
    saturdayClinicNotes: string | undefined;
    sundayClinicNotes: string | undefined;
    clinicLatitude: number;
    clinicLongitude: number;
    addressIdFromAntrim: number | undefined;
    clinicPhoneNumber: string | undefined;
    contactSetting: GetContactSettingsItemDto[] | undefined;
    contactGroupSetting: ContactGroupSettingsItemDto[] | undefined;
    id: number | undefined;
}

export class GetClinicForEditOutput implements IGetClinicForEditOutput {
    clinic!: CreateOrEditClinicDto | undefined;

    constructor(data?: IGetClinicForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinic = data["clinic"] ? CreateOrEditClinicDto.fromJS(data["clinic"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetClinicForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetClinicForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinic"] = this.clinic ? this.clinic.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetClinicForEditOutput {
    clinic: CreateOrEditClinicDto | undefined;
}

export class GetRouteScheduleSettingsItemDto implements IGetRouteScheduleSettingsItemDto {
    code!: string | undefined;
    value!: string | undefined;

    constructor(data?: IGetRouteScheduleSettingsItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): GetRouteScheduleSettingsItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteScheduleSettingsItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["value"] = this.value;
        return data; 
    }
}

export interface IGetRouteScheduleSettingsItemDto {
    code: string | undefined;
    value: string | undefined;
}

export class GetClinicScheduleDto implements IGetClinicScheduleDto {
    id!: number;
    routeCode!: string | undefined;
    estimatedTimeOfArrival!: string | undefined;
    mondayETATime!: string | undefined;
    tuesdayETATime!: string | undefined;
    wednesdayETATime!: string | undefined;
    thursdayETATime!: string | undefined;
    fridayETATime!: string | undefined;
    saturdayETATime!: string | undefined;
    sundayETATime!: string | undefined;
    displayMondayETATime!: string | undefined;
    displayTuesdayETATime!: string | undefined;
    displayWednesdayETATime!: string | undefined;
    displayThursdayETATime!: string | undefined;
    displayFridayETATime!: string | undefined;
    displaySaturdayETATime!: string | undefined;
    displaySundayETATime!: string | undefined;
    cutOff!: string | undefined;
    mondayCutOffTime!: string | undefined;
    tuesdayCutOffTime!: string | undefined;
    wednesdayCutOffTime!: string | undefined;
    thursdayCutOffTime!: string | undefined;
    fridayCutOffTime!: string | undefined;
    saturdayCutOffTime!: string | undefined;
    sundayCutOffTime!: string | undefined;
    displayMondayCutOffTime!: string | undefined;
    displayTuesdayCutOffTime!: string | undefined;
    displayWednesdayCutOffTime!: string | undefined;
    displayThursdayCutOffTime!: string | undefined;
    displayFridayCutOffTime!: string | undefined;
    displaySaturdayCutOffTime!: string | undefined;
    displaySundayCutOffTime!: string | undefined;
    displayMondayLTA!: string | undefined;
    displayTuesdayLTA!: string | undefined;
    displayWednesdayLTA!: string | undefined;
    displayThursdayLTA!: string | undefined;
    displayFridayLTA!: string | undefined;
    displaySaturdayLTA!: string | undefined;
    displaySundayLTA!: string | undefined;
    mondayLTA!: string | undefined;
    tuesdayLTA!: string | undefined;
    wednesdayLTA!: string | undefined;
    thursdayLTA!: string | undefined;
    fridayLTA!: string | undefined;
    saturdayLTA!: string | undefined;
    sundayLTA!: string | undefined;
    monIsLTA!: boolean;
    tueIsLTA!: boolean;
    wedIsLTA!: boolean;
    thuIsLTA!: boolean;
    friIsLTA!: boolean;
    satIsLTA!: boolean;
    sunIsLTA!: boolean;
    mondayIsAuto!: number | undefined;
    tuesdayIsAuto!: number | undefined;
    wednesdayIsAuto!: number | undefined;
    thursdayIsAuto!: number | undefined;
    fridayIsAuto!: number | undefined;
    saturdayIsAuto!: number | undefined;
    sundayIsAuto!: number | undefined;
    etaTime!: string | undefined;
    cutOffTime!: string | undefined;
    today!: moment.Moment;
    displayEta!: moment.Moment;
    displayCutOff!: moment.Moment;
    serviceTime!: number;
    timeWindowEnd!: number | undefined;
    timeWindowStart!: number;
    automatic!: boolean;
    willCall!: boolean;
    oorRate!: number | undefined;
    effectivityDate!: moment.Moment | undefined;
    routeTypeId!: number;
    routeTypeName!: string | undefined;
    isActive!: boolean;
    etaLocked!: boolean;
    etaLockedByUserId!: number | undefined;
    etaLockedByUser!: string | undefined;
    locationId!: number | undefined;
    routeTemplateId!: number | undefined;
    location!: string | undefined;
    dateEtaLocked!: moment.Moment | undefined;
    dateEtaLockedString!: string | undefined;
    creationTime!: moment.Moment;
    creationTimeString!: string | undefined;
    creator!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModificationTimeString!: string | undefined;
    lastModifierUser!: string | undefined;
    clinicId!: number | undefined;
    scheduleSetting!: GetRouteScheduleSettingsItemDto[] | undefined;
    lastModifierUserId!: number | undefined;
    creatorUserId!: number | undefined;

    constructor(data?: IGetClinicScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeCode = data["routeCode"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"];
            this.mondayETATime = data["mondayETATime"];
            this.tuesdayETATime = data["tuesdayETATime"];
            this.wednesdayETATime = data["wednesdayETATime"];
            this.thursdayETATime = data["thursdayETATime"];
            this.fridayETATime = data["fridayETATime"];
            this.saturdayETATime = data["saturdayETATime"];
            this.sundayETATime = data["sundayETATime"];
            this.displayMondayETATime = data["displayMondayETATime"];
            this.displayTuesdayETATime = data["displayTuesdayETATime"];
            this.displayWednesdayETATime = data["displayWednesdayETATime"];
            this.displayThursdayETATime = data["displayThursdayETATime"];
            this.displayFridayETATime = data["displayFridayETATime"];
            this.displaySaturdayETATime = data["displaySaturdayETATime"];
            this.displaySundayETATime = data["displaySundayETATime"];
            this.cutOff = data["cutOff"];
            this.mondayCutOffTime = data["mondayCutOffTime"];
            this.tuesdayCutOffTime = data["tuesdayCutOffTime"];
            this.wednesdayCutOffTime = data["wednesdayCutOffTime"];
            this.thursdayCutOffTime = data["thursdayCutOffTime"];
            this.fridayCutOffTime = data["fridayCutOffTime"];
            this.saturdayCutOffTime = data["saturdayCutOffTime"];
            this.sundayCutOffTime = data["sundayCutOffTime"];
            this.displayMondayCutOffTime = data["displayMondayCutOffTime"];
            this.displayTuesdayCutOffTime = data["displayTuesdayCutOffTime"];
            this.displayWednesdayCutOffTime = data["displayWednesdayCutOffTime"];
            this.displayThursdayCutOffTime = data["displayThursdayCutOffTime"];
            this.displayFridayCutOffTime = data["displayFridayCutOffTime"];
            this.displaySaturdayCutOffTime = data["displaySaturdayCutOffTime"];
            this.displaySundayCutOffTime = data["displaySundayCutOffTime"];
            this.displayMondayLTA = data["displayMondayLTA"];
            this.displayTuesdayLTA = data["displayTuesdayLTA"];
            this.displayWednesdayLTA = data["displayWednesdayLTA"];
            this.displayThursdayLTA = data["displayThursdayLTA"];
            this.displayFridayLTA = data["displayFridayLTA"];
            this.displaySaturdayLTA = data["displaySaturdayLTA"];
            this.displaySundayLTA = data["displaySundayLTA"];
            this.mondayLTA = data["mondayLTA"];
            this.tuesdayLTA = data["tuesdayLTA"];
            this.wednesdayLTA = data["wednesdayLTA"];
            this.thursdayLTA = data["thursdayLTA"];
            this.fridayLTA = data["fridayLTA"];
            this.saturdayLTA = data["saturdayLTA"];
            this.sundayLTA = data["sundayLTA"];
            this.monIsLTA = data["monIsLTA"];
            this.tueIsLTA = data["tueIsLTA"];
            this.wedIsLTA = data["wedIsLTA"];
            this.thuIsLTA = data["thuIsLTA"];
            this.friIsLTA = data["friIsLTA"];
            this.satIsLTA = data["satIsLTA"];
            this.sunIsLTA = data["sunIsLTA"];
            this.mondayIsAuto = data["mondayIsAuto"];
            this.tuesdayIsAuto = data["tuesdayIsAuto"];
            this.wednesdayIsAuto = data["wednesdayIsAuto"];
            this.thursdayIsAuto = data["thursdayIsAuto"];
            this.fridayIsAuto = data["fridayIsAuto"];
            this.saturdayIsAuto = data["saturdayIsAuto"];
            this.sundayIsAuto = data["sundayIsAuto"];
            this.etaTime = data["etaTime"];
            this.cutOffTime = data["cutOffTime"];
            this.today = data["today"] ? moment(data["today"].toString()) : <any>undefined;
            this.displayEta = data["displayEta"] ? moment(data["displayEta"].toString()) : <any>undefined;
            this.displayCutOff = data["displayCutOff"] ? moment(data["displayCutOff"].toString()) : <any>undefined;
            this.serviceTime = data["serviceTime"];
            this.timeWindowEnd = data["timeWindowEnd"];
            this.timeWindowStart = data["timeWindowStart"];
            this.automatic = data["automatic"];
            this.willCall = data["willCall"];
            this.oorRate = data["oorRate"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.routeTypeId = data["routeTypeId"];
            this.routeTypeName = data["routeTypeName"];
            this.isActive = data["isActive"];
            this.etaLocked = data["etaLocked"];
            this.etaLockedByUserId = data["etaLockedByUserId"];
            this.etaLockedByUser = data["etaLockedByUser"];
            this.locationId = data["locationId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.location = data["location"];
            this.dateEtaLocked = data["dateEtaLocked"] ? moment(data["dateEtaLocked"].toString()) : <any>undefined;
            this.dateEtaLockedString = data["dateEtaLockedString"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creationTimeString = data["creationTimeString"];
            this.creator = data["creator"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModificationTimeString = data["lastModificationTimeString"];
            this.lastModifierUser = data["lastModifierUser"];
            this.clinicId = data["clinicId"];
            if (Array.isArray(data["scheduleSetting"])) {
                this.scheduleSetting = [] as any;
                for (let item of data["scheduleSetting"])
                    this.scheduleSetting!.push(GetRouteScheduleSettingsItemDto.fromJS(item));
            }
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creatorUserId = data["creatorUserId"];
        }
    }

    static fromJS(data: any): GetClinicScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetClinicScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeCode"] = this.routeCode;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival;
        data["mondayETATime"] = this.mondayETATime;
        data["tuesdayETATime"] = this.tuesdayETATime;
        data["wednesdayETATime"] = this.wednesdayETATime;
        data["thursdayETATime"] = this.thursdayETATime;
        data["fridayETATime"] = this.fridayETATime;
        data["saturdayETATime"] = this.saturdayETATime;
        data["sundayETATime"] = this.sundayETATime;
        data["displayMondayETATime"] = this.displayMondayETATime;
        data["displayTuesdayETATime"] = this.displayTuesdayETATime;
        data["displayWednesdayETATime"] = this.displayWednesdayETATime;
        data["displayThursdayETATime"] = this.displayThursdayETATime;
        data["displayFridayETATime"] = this.displayFridayETATime;
        data["displaySaturdayETATime"] = this.displaySaturdayETATime;
        data["displaySundayETATime"] = this.displaySundayETATime;
        data["cutOff"] = this.cutOff;
        data["mondayCutOffTime"] = this.mondayCutOffTime;
        data["tuesdayCutOffTime"] = this.tuesdayCutOffTime;
        data["wednesdayCutOffTime"] = this.wednesdayCutOffTime;
        data["thursdayCutOffTime"] = this.thursdayCutOffTime;
        data["fridayCutOffTime"] = this.fridayCutOffTime;
        data["saturdayCutOffTime"] = this.saturdayCutOffTime;
        data["sundayCutOffTime"] = this.sundayCutOffTime;
        data["displayMondayCutOffTime"] = this.displayMondayCutOffTime;
        data["displayTuesdayCutOffTime"] = this.displayTuesdayCutOffTime;
        data["displayWednesdayCutOffTime"] = this.displayWednesdayCutOffTime;
        data["displayThursdayCutOffTime"] = this.displayThursdayCutOffTime;
        data["displayFridayCutOffTime"] = this.displayFridayCutOffTime;
        data["displaySaturdayCutOffTime"] = this.displaySaturdayCutOffTime;
        data["displaySundayCutOffTime"] = this.displaySundayCutOffTime;
        data["displayMondayLTA"] = this.displayMondayLTA;
        data["displayTuesdayLTA"] = this.displayTuesdayLTA;
        data["displayWednesdayLTA"] = this.displayWednesdayLTA;
        data["displayThursdayLTA"] = this.displayThursdayLTA;
        data["displayFridayLTA"] = this.displayFridayLTA;
        data["displaySaturdayLTA"] = this.displaySaturdayLTA;
        data["displaySundayLTA"] = this.displaySundayLTA;
        data["mondayLTA"] = this.mondayLTA;
        data["tuesdayLTA"] = this.tuesdayLTA;
        data["wednesdayLTA"] = this.wednesdayLTA;
        data["thursdayLTA"] = this.thursdayLTA;
        data["fridayLTA"] = this.fridayLTA;
        data["saturdayLTA"] = this.saturdayLTA;
        data["sundayLTA"] = this.sundayLTA;
        data["monIsLTA"] = this.monIsLTA;
        data["tueIsLTA"] = this.tueIsLTA;
        data["wedIsLTA"] = this.wedIsLTA;
        data["thuIsLTA"] = this.thuIsLTA;
        data["friIsLTA"] = this.friIsLTA;
        data["satIsLTA"] = this.satIsLTA;
        data["sunIsLTA"] = this.sunIsLTA;
        data["mondayIsAuto"] = this.mondayIsAuto;
        data["tuesdayIsAuto"] = this.tuesdayIsAuto;
        data["wednesdayIsAuto"] = this.wednesdayIsAuto;
        data["thursdayIsAuto"] = this.thursdayIsAuto;
        data["fridayIsAuto"] = this.fridayIsAuto;
        data["saturdayIsAuto"] = this.saturdayIsAuto;
        data["sundayIsAuto"] = this.sundayIsAuto;
        data["etaTime"] = this.etaTime;
        data["cutOffTime"] = this.cutOffTime;
        data["today"] = this.today ? this.today.toISOString() : <any>undefined;
        data["displayEta"] = this.displayEta ? this.displayEta.toISOString() : <any>undefined;
        data["displayCutOff"] = this.displayCutOff ? this.displayCutOff.toISOString() : <any>undefined;
        data["serviceTime"] = this.serviceTime;
        data["timeWindowEnd"] = this.timeWindowEnd;
        data["timeWindowStart"] = this.timeWindowStart;
        data["automatic"] = this.automatic;
        data["willCall"] = this.willCall;
        data["oorRate"] = this.oorRate;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["routeTypeId"] = this.routeTypeId;
        data["routeTypeName"] = this.routeTypeName;
        data["isActive"] = this.isActive;
        data["etaLocked"] = this.etaLocked;
        data["etaLockedByUserId"] = this.etaLockedByUserId;
        data["etaLockedByUser"] = this.etaLockedByUser;
        data["locationId"] = this.locationId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["location"] = this.location;
        data["dateEtaLocked"] = this.dateEtaLocked ? this.dateEtaLocked.toISOString() : <any>undefined;
        data["dateEtaLockedString"] = this.dateEtaLockedString;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creationTimeString"] = this.creationTimeString;
        data["creator"] = this.creator;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModificationTimeString"] = this.lastModificationTimeString;
        data["lastModifierUser"] = this.lastModifierUser;
        data["clinicId"] = this.clinicId;
        if (Array.isArray(this.scheduleSetting)) {
            data["scheduleSetting"] = [];
            for (let item of this.scheduleSetting)
                data["scheduleSetting"].push(item.toJSON());
        }
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creatorUserId"] = this.creatorUserId;
        return data; 
    }
}

export interface IGetClinicScheduleDto {
    id: number;
    routeCode: string | undefined;
    estimatedTimeOfArrival: string | undefined;
    mondayETATime: string | undefined;
    tuesdayETATime: string | undefined;
    wednesdayETATime: string | undefined;
    thursdayETATime: string | undefined;
    fridayETATime: string | undefined;
    saturdayETATime: string | undefined;
    sundayETATime: string | undefined;
    displayMondayETATime: string | undefined;
    displayTuesdayETATime: string | undefined;
    displayWednesdayETATime: string | undefined;
    displayThursdayETATime: string | undefined;
    displayFridayETATime: string | undefined;
    displaySaturdayETATime: string | undefined;
    displaySundayETATime: string | undefined;
    cutOff: string | undefined;
    mondayCutOffTime: string | undefined;
    tuesdayCutOffTime: string | undefined;
    wednesdayCutOffTime: string | undefined;
    thursdayCutOffTime: string | undefined;
    fridayCutOffTime: string | undefined;
    saturdayCutOffTime: string | undefined;
    sundayCutOffTime: string | undefined;
    displayMondayCutOffTime: string | undefined;
    displayTuesdayCutOffTime: string | undefined;
    displayWednesdayCutOffTime: string | undefined;
    displayThursdayCutOffTime: string | undefined;
    displayFridayCutOffTime: string | undefined;
    displaySaturdayCutOffTime: string | undefined;
    displaySundayCutOffTime: string | undefined;
    displayMondayLTA: string | undefined;
    displayTuesdayLTA: string | undefined;
    displayWednesdayLTA: string | undefined;
    displayThursdayLTA: string | undefined;
    displayFridayLTA: string | undefined;
    displaySaturdayLTA: string | undefined;
    displaySundayLTA: string | undefined;
    mondayLTA: string | undefined;
    tuesdayLTA: string | undefined;
    wednesdayLTA: string | undefined;
    thursdayLTA: string | undefined;
    fridayLTA: string | undefined;
    saturdayLTA: string | undefined;
    sundayLTA: string | undefined;
    monIsLTA: boolean;
    tueIsLTA: boolean;
    wedIsLTA: boolean;
    thuIsLTA: boolean;
    friIsLTA: boolean;
    satIsLTA: boolean;
    sunIsLTA: boolean;
    mondayIsAuto: number | undefined;
    tuesdayIsAuto: number | undefined;
    wednesdayIsAuto: number | undefined;
    thursdayIsAuto: number | undefined;
    fridayIsAuto: number | undefined;
    saturdayIsAuto: number | undefined;
    sundayIsAuto: number | undefined;
    etaTime: string | undefined;
    cutOffTime: string | undefined;
    today: moment.Moment;
    displayEta: moment.Moment;
    displayCutOff: moment.Moment;
    serviceTime: number;
    timeWindowEnd: number | undefined;
    timeWindowStart: number;
    automatic: boolean;
    willCall: boolean;
    oorRate: number | undefined;
    effectivityDate: moment.Moment | undefined;
    routeTypeId: number;
    routeTypeName: string | undefined;
    isActive: boolean;
    etaLocked: boolean;
    etaLockedByUserId: number | undefined;
    etaLockedByUser: string | undefined;
    locationId: number | undefined;
    routeTemplateId: number | undefined;
    location: string | undefined;
    dateEtaLocked: moment.Moment | undefined;
    dateEtaLockedString: string | undefined;
    creationTime: moment.Moment;
    creationTimeString: string | undefined;
    creator: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModificationTimeString: string | undefined;
    lastModifierUser: string | undefined;
    clinicId: number | undefined;
    scheduleSetting: GetRouteScheduleSettingsItemDto[] | undefined;
    lastModifierUserId: number | undefined;
    creatorUserId: number | undefined;
}

export class ListResultDtoOfGetClinicScheduleDto implements IListResultDtoOfGetClinicScheduleDto {
    items!: GetClinicScheduleDto[] | undefined;

    constructor(data?: IListResultDtoOfGetClinicScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetClinicScheduleDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetClinicScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetClinicScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetClinicScheduleDto {
    items: GetClinicScheduleDto[] | undefined;
}

export class ClosingRouteInput implements IClosingRouteInput {
    isManual!: boolean;
    routeDate!: moment.Moment | undefined;
    locationId!: number | undefined;
    tenantId!: number;
    routeIds!: number[] | undefined;

    constructor(data?: IClosingRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isManual = data["isManual"];
            this.routeDate = data["routeDate"] ? moment(data["routeDate"].toString()) : <any>undefined;
            this.locationId = data["locationId"];
            this.tenantId = data["tenantId"];
            if (Array.isArray(data["routeIds"])) {
                this.routeIds = [] as any;
                for (let item of data["routeIds"])
                    this.routeIds!.push(item);
            }
        }
    }

    static fromJS(data: any): ClosingRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new ClosingRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isManual"] = this.isManual;
        data["routeDate"] = this.routeDate ? this.routeDate.toISOString() : <any>undefined;
        data["locationId"] = this.locationId;
        data["tenantId"] = this.tenantId;
        if (Array.isArray(this.routeIds)) {
            data["routeIds"] = [];
            for (let item of this.routeIds)
                data["routeIds"].push(item);
        }
        return data; 
    }
}

export interface IClosingRouteInput {
    isManual: boolean;
    routeDate: moment.Moment | undefined;
    locationId: number | undefined;
    tenantId: number;
    routeIds: number[] | undefined;
}

export class SubscribableEditionComboboxItemDto implements ISubscribableEditionComboboxItemDto {
    isFree!: boolean | undefined;
    value!: string | undefined;
    displayText!: string | undefined;
    isSelected!: boolean;

    constructor(data?: ISubscribableEditionComboboxItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isFree = data["isFree"];
            this.value = data["value"];
            this.displayText = data["displayText"];
            this.isSelected = data["isSelected"];
        }
    }

    static fromJS(data: any): SubscribableEditionComboboxItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new SubscribableEditionComboboxItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isFree"] = this.isFree;
        data["value"] = this.value;
        data["displayText"] = this.displayText;
        data["isSelected"] = this.isSelected;
        return data; 
    }
}

export interface ISubscribableEditionComboboxItemDto {
    isFree: boolean | undefined;
    value: string | undefined;
    displayText: string | undefined;
    isSelected: boolean;
}

export class ListResultDtoOfSubscribableEditionComboboxItemDto implements IListResultDtoOfSubscribableEditionComboboxItemDto {
    items!: SubscribableEditionComboboxItemDto[] | undefined;

    constructor(data?: IListResultDtoOfSubscribableEditionComboboxItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SubscribableEditionComboboxItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfSubscribableEditionComboboxItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfSubscribableEditionComboboxItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfSubscribableEditionComboboxItemDto {
    items: SubscribableEditionComboboxItemDto[] | undefined;
}

export class FindUsersInput implements IFindUsersInput {
    tenantId!: number | undefined;
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: IFindUsersInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): FindUsersInput {
        data = typeof data === 'object' ? data : {};
        let result = new FindUsersInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface IFindUsersInput {
    tenantId: number | undefined;
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class GetDefaultEditionNameOutput implements IGetDefaultEditionNameOutput {
    name!: string | undefined;

    constructor(data?: IGetDefaultEditionNameOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetDefaultEditionNameOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetDefaultEditionNameOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetDefaultEditionNameOutput {
    name: string | undefined;
}

export class ListResultDtoOfString implements IListResultDtoOfString {
    items!: string[] | undefined;

    constructor(data?: IListResultDtoOfString) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(item);
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfString {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfString();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item);
        }
        return data; 
    }
}

export interface IListResultDtoOfString {
    items: string[] | undefined;
}

export class DriverClientProfilePostalCodeDto implements IDriverClientProfilePostalCodeDto {
    country!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    value!: string | undefined;

    constructor(data?: IDriverClientProfilePostalCodeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.country = data["country"];
            this.city = data["city"];
            this.state = data["state"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): DriverClientProfilePostalCodeDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverClientProfilePostalCodeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["country"] = this.country;
        data["city"] = this.city;
        data["state"] = this.state;
        data["value"] = this.value;
        return data; 
    }
}

export interface IDriverClientProfilePostalCodeDto {
    country: string | undefined;
    city: string | undefined;
    state: string | undefined;
    value: string | undefined;
}

export class GeocodeListDto implements IGeocodeListDto {
    id!: number;
    latitude!: number;
    longitude!: number;

    constructor(data?: IGeocodeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): GeocodeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GeocodeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface IGeocodeListDto {
    id: number;
    latitude: number;
    longitude: number;
}

export class DriverClientProfileAddressDto implements IDriverClientProfileAddressDto {
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    postalCode!: DriverClientProfilePostalCodeDto | undefined;
    geocode!: GeocodeListDto | undefined;

    constructor(data?: IDriverClientProfileAddressDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.postalCode = data["postalCode"] ? DriverClientProfilePostalCodeDto.fromJS(data["postalCode"]) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
        }
    }

    static fromJS(data: any): DriverClientProfileAddressDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverClientProfileAddressDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["postalCode"] = this.postalCode ? this.postalCode.toJSON() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IDriverClientProfileAddressDto {
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    postalCode: DriverClientProfilePostalCodeDto | undefined;
    geocode: GeocodeListDto | undefined;
}

export class GetCompaniesListItemContactDto implements IGetCompaniesListItemContactDto {
    firstName!: string | undefined;
    lastName!: string | undefined;
    address!: DriverClientProfileAddressDto | undefined;

    constructor(data?: IGetCompaniesListItemContactDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.address = data["address"] ? DriverClientProfileAddressDto.fromJS(data["address"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetCompaniesListItemContactDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetCompaniesListItemContactDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetCompaniesListItemContactDto {
    firstName: string | undefined;
    lastName: string | undefined;
    address: DriverClientProfileAddressDto | undefined;
}

export class GetCompaniesListItemDto implements IGetCompaniesListItemDto {
    name!: string | undefined;
    contact!: GetCompaniesListItemContactDto | undefined;
    accountNo!: string | undefined;

    constructor(data?: IGetCompaniesListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.contact = data["contact"] ? GetCompaniesListItemContactDto.fromJS(data["contact"]) : <any>undefined;
            this.accountNo = data["accountNo"];
        }
    }

    static fromJS(data: any): GetCompaniesListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetCompaniesListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["accountNo"] = this.accountNo;
        return data; 
    }
}

export interface IGetCompaniesListItemDto {
    name: string | undefined;
    contact: GetCompaniesListItemContactDto | undefined;
    accountNo: string | undefined;
}

export class PagedResultDtoOfGetCompaniesListItemDto implements IPagedResultDtoOfGetCompaniesListItemDto {
    totalCount!: number;
    items!: GetCompaniesListItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetCompaniesListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetCompaniesListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetCompaniesListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetCompaniesListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetCompaniesListItemDto {
    totalCount: number;
    items: GetCompaniesListItemDto[] | undefined;
}

export class CreateCompanyInput implements ICreateCompanyInput {
    name!: string;
    accountNo!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateCompanyInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.accountNo = data["accountNo"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateCompanyInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateCompanyInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["accountNo"] = this.accountNo;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateCompanyInput {
    name: string;
    accountNo: string | undefined;
    id: number | undefined;
}

export class ContactDto implements IContactDto {
    firstName!: string | undefined;
    lastName!: string | undefined;
    address!: AddressListDto | undefined;
    id!: number;

    constructor(data?: IContactDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.address = data["address"] ? AddressListDto.fromJS(data["address"]) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ContactDto {
        data = typeof data === 'object' ? data : {};
        let result = new ContactDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IContactDto {
    firstName: string | undefined;
    lastName: string | undefined;
    address: AddressListDto | undefined;
    id: number;
}

export class UserInContactListDto implements IUserInContactListDto {
    id!: number;
    name!: string | undefined;
    surname!: string | undefined;
    emailAddress!: string | undefined;
    phoneNumber!: string | undefined;
    userName!: string | undefined;
    isEmailConfirmed!: boolean;
    isActive!: boolean;

    constructor(data?: IUserInContactListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
            this.userName = data["userName"];
            this.isEmailConfirmed = data["isEmailConfirmed"];
            this.isActive = data["isActive"];
        }
    }

    static fromJS(data: any): UserInContactListDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserInContactListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        data["userName"] = this.userName;
        data["isEmailConfirmed"] = this.isEmailConfirmed;
        data["isActive"] = this.isActive;
        return data; 
    }
}

export interface IUserInContactListDto {
    id: number;
    name: string | undefined;
    surname: string | undefined;
    emailAddress: string | undefined;
    phoneNumber: string | undefined;
    userName: string | undefined;
    isEmailConfirmed: boolean;
    isActive: boolean;
}

export class ContactListCompanyDto implements IContactListCompanyDto {
    id!: number;
    name!: string | undefined;
    accountNo!: string | undefined;

    constructor(data?: IContactListCompanyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.accountNo = data["accountNo"];
        }
    }

    static fromJS(data: any): ContactListCompanyDto {
        data = typeof data === 'object' ? data : {};
        let result = new ContactListCompanyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["accountNo"] = this.accountNo;
        return data; 
    }
}

export interface IContactListCompanyDto {
    id: number;
    name: string | undefined;
    accountNo: string | undefined;
}

export class EmailListDto implements IEmailListDto {
    id!: number;
    contactId!: number;
    value!: string | undefined;

    constructor(data?: IEmailListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contactId = data["contactId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): EmailListDto {
        data = typeof data === 'object' ? data : {};
        let result = new EmailListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contactId"] = this.contactId;
        data["value"] = this.value;
        return data; 
    }
}

export interface IEmailListDto {
    id: number;
    contactId: number;
    value: string | undefined;
}

export class PhoneListDto implements IPhoneListDto {
    id!: number;
    contactId!: number;
    value!: string | undefined;

    constructor(data?: IPhoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contactId = data["contactId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): PhoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PhoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contactId"] = this.contactId;
        data["value"] = this.value;
        return data; 
    }
}

export interface IPhoneListDto {
    id: number;
    contactId: number;
    value: string | undefined;
}

export class ContactListDto implements IContactListDto {
    contact!: ContactDto | undefined;
    contactId!: number;
    id!: number;
    tenantId!: number;
    user!: UserInContactListDto | undefined;
    address!: AddressListDto | undefined;
    firstName!: string | undefined;
    lastName!: string | undefined;
    company!: ContactListCompanyDto | undefined;
    emails!: EmailListDto | undefined;
    phones!: PhoneListDto | undefined;
    companies!: GetCompaniesListItemDto | undefined;

    constructor(data?: IContactListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contact = data["contact"] ? ContactDto.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? UserInContactListDto.fromJS(data["user"]) : <any>undefined;
            this.address = data["address"] ? AddressListDto.fromJS(data["address"]) : <any>undefined;
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.company = data["company"] ? ContactListCompanyDto.fromJS(data["company"]) : <any>undefined;
            this.emails = data["emails"] ? EmailListDto.fromJS(data["emails"]) : <any>undefined;
            this.phones = data["phones"] ? PhoneListDto.fromJS(data["phones"]) : <any>undefined;
            this.companies = data["companies"] ? GetCompaniesListItemDto.fromJS(data["companies"]) : <any>undefined;
        }
    }

    static fromJS(data: any): ContactListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ContactListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["company"] = this.company ? this.company.toJSON() : <any>undefined;
        data["emails"] = this.emails ? this.emails.toJSON() : <any>undefined;
        data["phones"] = this.phones ? this.phones.toJSON() : <any>undefined;
        data["companies"] = this.companies ? this.companies.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IContactListDto {
    contact: ContactDto | undefined;
    contactId: number;
    id: number;
    tenantId: number;
    user: UserInContactListDto | undefined;
    address: AddressListDto | undefined;
    firstName: string | undefined;
    lastName: string | undefined;
    company: ContactListCompanyDto | undefined;
    emails: EmailListDto | undefined;
    phones: PhoneListDto | undefined;
    companies: GetCompaniesListItemDto | undefined;
}

export class PagedResultDtoOfContactListDto implements IPagedResultDtoOfContactListDto {
    totalCount!: number;
    items!: ContactListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfContactListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ContactListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfContactListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfContactListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfContactListDto {
    totalCount: number;
    items: ContactListDto[] | undefined;
}

export class CreateContactInput implements ICreateContactInput {
    userId!: number | undefined;
    tenantId!: number | undefined;
    addressId!: number | undefined;
    firstName!: string;
    lastName!: string;
    companyId!: number | undefined;

    constructor(data?: ICreateContactInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
            this.addressId = data["addressId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.companyId = data["companyId"];
        }
    }

    static fromJS(data: any): CreateContactInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateContactInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        data["addressId"] = this.addressId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["companyId"] = this.companyId;
        return data; 
    }
}

export interface ICreateContactInput {
    userId: number | undefined;
    tenantId: number | undefined;
    addressId: number | undefined;
    firstName: string;
    lastName: string;
    companyId: number | undefined;
}

export class UpdateContactInput implements IUpdateContactInput {
    id!: number;
    userId!: number | undefined;
    addressId!: number | undefined;
    companyId!: number | undefined;
    firstName!: string | undefined;
    lastName!: string | undefined;

    constructor(data?: IUpdateContactInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.addressId = data["addressId"];
            this.companyId = data["companyId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
        }
    }

    static fromJS(data: any): UpdateContactInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateContactInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["addressId"] = this.addressId;
        data["companyId"] = this.companyId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        return data; 
    }
}

export interface IUpdateContactInput {
    id: number;
    userId: number | undefined;
    addressId: number | undefined;
    companyId: number | undefined;
    firstName: string | undefined;
    lastName: string | undefined;
}

export class UserEditDto implements IUserEditDto {
    id!: number | undefined;
    name!: string;
    surname!: string;
    userName!: string;
    emailAddress!: string;
    phoneNumber!: string | undefined;
    password!: string | undefined;
    isActive!: boolean;
    shouldChangePasswordOnNextLogin!: boolean;
    sendActivationEmail!: boolean;
    isTwoFactorEnabled!: boolean;
    isLockoutEnabled!: boolean;

    constructor(data?: IUserEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.userName = data["userName"];
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
            this.password = data["password"];
            this.isActive = data["isActive"];
            this.shouldChangePasswordOnNextLogin = data["shouldChangePasswordOnNextLogin"];
            this.sendActivationEmail = data["sendActivationEmail"];
            this.isTwoFactorEnabled = data["isTwoFactorEnabled"];
            this.isLockoutEnabled = data["isLockoutEnabled"];
        }
    }

    static fromJS(data: any): UserEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["userName"] = this.userName;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        data["password"] = this.password;
        data["isActive"] = this.isActive;
        data["shouldChangePasswordOnNextLogin"] = this.shouldChangePasswordOnNextLogin;
        data["sendActivationEmail"] = this.sendActivationEmail;
        data["isTwoFactorEnabled"] = this.isTwoFactorEnabled;
        data["isLockoutEnabled"] = this.isLockoutEnabled;
        return data; 
    }
}

export interface IUserEditDto {
    id: number | undefined;
    name: string;
    surname: string;
    userName: string;
    emailAddress: string;
    phoneNumber: string | undefined;
    password: string | undefined;
    isActive: boolean;
    shouldChangePasswordOnNextLogin: boolean;
    sendActivationEmail: boolean;
    isTwoFactorEnabled: boolean;
    isLockoutEnabled: boolean;
}

export class CreateOrUpdateContactUserInput implements ICreateOrUpdateContactUserInput {
    user!: UserEditDto;
    assignedRoleNames!: string[];
    sendActivationEmail!: boolean;
    setRandomPassword!: boolean;
    shouldChangePasswordOnLogin!: boolean;
    location!: number[] | undefined;

    constructor(data?: ICreateOrUpdateContactUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new UserEditDto();
            this.assignedRoleNames = [];
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserEditDto.fromJS(data["user"]) : new UserEditDto();
            if (Array.isArray(data["assignedRoleNames"])) {
                this.assignedRoleNames = [] as any;
                for (let item of data["assignedRoleNames"])
                    this.assignedRoleNames!.push(item);
            }
            this.sendActivationEmail = data["sendActivationEmail"];
            this.setRandomPassword = data["setRandomPassword"];
            this.shouldChangePasswordOnLogin = data["shouldChangePasswordOnLogin"];
            if (Array.isArray(data["location"])) {
                this.location = [] as any;
                for (let item of data["location"])
                    this.location!.push(item);
            }
        }
    }

    static fromJS(data: any): CreateOrUpdateContactUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateContactUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        if (Array.isArray(this.assignedRoleNames)) {
            data["assignedRoleNames"] = [];
            for (let item of this.assignedRoleNames)
                data["assignedRoleNames"].push(item);
        }
        data["sendActivationEmail"] = this.sendActivationEmail;
        data["setRandomPassword"] = this.setRandomPassword;
        data["shouldChangePasswordOnLogin"] = this.shouldChangePasswordOnLogin;
        if (Array.isArray(this.location)) {
            data["location"] = [];
            for (let item of this.location)
                data["location"].push(item);
        }
        return data; 
    }
}

export interface ICreateOrUpdateContactUserInput {
    user: UserEditDto;
    assignedRoleNames: string[];
    sendActivationEmail: boolean;
    setRandomPassword: boolean;
    shouldChangePasswordOnLogin: boolean;
    location: number[] | undefined;
}

export class CreateContactUserAddressInput implements ICreateContactUserAddressInput {
    userId!: number | undefined;
    tenantId!: number;
    address!: CreateAddressInput | undefined;
    firstName!: string;
    lastName!: string;
    contactUser!: CreateOrUpdateContactUserInput | undefined;

    constructor(data?: ICreateContactUserAddressInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
            this.address = data["address"] ? CreateAddressInput.fromJS(data["address"]) : <any>undefined;
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.contactUser = data["contactUser"] ? CreateOrUpdateContactUserInput.fromJS(data["contactUser"]) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateContactUserAddressInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateContactUserAddressInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["contactUser"] = this.contactUser ? this.contactUser.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ICreateContactUserAddressInput {
    userId: number | undefined;
    tenantId: number;
    address: CreateAddressInput | undefined;
    firstName: string;
    lastName: string;
    contactUser: CreateOrUpdateContactUserInput | undefined;
}

export class CreateContactAddressInput implements ICreateContactAddressInput {
    userId!: number | undefined;
    tenantId!: number;
    address!: CreateAddressInput | undefined;
    firstName!: string;
    lastName!: string;

    constructor(data?: ICreateContactAddressInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
            this.address = data["address"] ? CreateAddressInput.fromJS(data["address"]) : <any>undefined;
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
        }
    }

    static fromJS(data: any): CreateContactAddressInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateContactAddressInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        return data; 
    }
}

export interface ICreateContactAddressInput {
    userId: number | undefined;
    tenantId: number;
    address: CreateAddressInput | undefined;
    firstName: string;
    lastName: string;
}

export class GetVendorForViewDto implements IGetVendorForViewDto {
    contact!: ContactListDto | undefined;

    constructor(data?: IGetVendorForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contact = data["contact"] ? ContactListDto.fromJS(data["contact"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVendorForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetVendorForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVendorForViewDto {
    contact: ContactListDto | undefined;
}

export class ListResultDtoOfGetVendorForViewDto implements IListResultDtoOfGetVendorForViewDto {
    items!: GetVendorForViewDto[] | undefined;

    constructor(data?: IListResultDtoOfGetVendorForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetVendorForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetVendorForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetVendorForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetVendorForViewDto {
    items: GetVendorForViewDto[] | undefined;
}

export class UserRoleDto implements IUserRoleDto {
    roleId!: number;
    roleName!: string | undefined;
    roleDisplayName!: string | undefined;
    isAssigned!: boolean;
    inheritedFromOrganizationUnit!: boolean;

    constructor(data?: IUserRoleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.roleId = data["roleId"];
            this.roleName = data["roleName"];
            this.roleDisplayName = data["roleDisplayName"];
            this.isAssigned = data["isAssigned"];
            this.inheritedFromOrganizationUnit = data["inheritedFromOrganizationUnit"];
        }
    }

    static fromJS(data: any): UserRoleDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserRoleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["roleId"] = this.roleId;
        data["roleName"] = this.roleName;
        data["roleDisplayName"] = this.roleDisplayName;
        data["isAssigned"] = this.isAssigned;
        data["inheritedFromOrganizationUnit"] = this.inheritedFromOrganizationUnit;
        return data; 
    }
}

export interface IUserRoleDto {
    roleId: number;
    roleName: string | undefined;
    roleDisplayName: string | undefined;
    isAssigned: boolean;
    inheritedFromOrganizationUnit: boolean;
}

export class CreateOrUpdateUserInput implements ICreateOrUpdateUserInput {
    user!: UserEditDto;
    assignedRoleNames!: string[];
    sendActivationEmail!: boolean;
    setRandomPassword!: boolean;
    organizationUnits!: number[] | undefined;

    constructor(data?: ICreateOrUpdateUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new UserEditDto();
            this.assignedRoleNames = [];
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserEditDto.fromJS(data["user"]) : new UserEditDto();
            if (Array.isArray(data["assignedRoleNames"])) {
                this.assignedRoleNames = [] as any;
                for (let item of data["assignedRoleNames"])
                    this.assignedRoleNames!.push(item);
            }
            this.sendActivationEmail = data["sendActivationEmail"];
            this.setRandomPassword = data["setRandomPassword"];
            if (Array.isArray(data["organizationUnits"])) {
                this.organizationUnits = [] as any;
                for (let item of data["organizationUnits"])
                    this.organizationUnits!.push(item);
            }
        }
    }

    static fromJS(data: any): CreateOrUpdateUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        if (Array.isArray(this.assignedRoleNames)) {
            data["assignedRoleNames"] = [];
            for (let item of this.assignedRoleNames)
                data["assignedRoleNames"].push(item);
        }
        data["sendActivationEmail"] = this.sendActivationEmail;
        data["setRandomPassword"] = this.setRandomPassword;
        if (Array.isArray(this.organizationUnits)) {
            data["organizationUnits"] = [];
            for (let item of this.organizationUnits)
                data["organizationUnits"].push(item);
        }
        return data; 
    }
}

export interface ICreateOrUpdateUserInput {
    user: UserEditDto;
    assignedRoleNames: string[];
    sendActivationEmail: boolean;
    setRandomPassword: boolean;
    organizationUnits: number[] | undefined;
}

export class UpdateUserInput implements IUpdateUserInput {
    id!: number;
    userId!: number;

    constructor(data?: IUpdateUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): UpdateUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IUpdateUserInput {
    id: number;
    userId: number;
}

export class UpdateMultipleUserInput implements IUpdateMultipleUserInput {
    updateMultipleUserId!: UpdateUserInput[] | undefined;

    constructor(data?: IUpdateMultipleUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["updateMultipleUserId"])) {
                this.updateMultipleUserId = [] as any;
                for (let item of data["updateMultipleUserId"])
                    this.updateMultipleUserId!.push(UpdateUserInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UpdateMultipleUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateMultipleUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.updateMultipleUserId)) {
            data["updateMultipleUserId"] = [];
            for (let item of this.updateMultipleUserId)
                data["updateMultipleUserId"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUpdateMultipleUserInput {
    updateMultipleUserId: UpdateUserInput[] | undefined;
}

export class AddContactForGroupInputDto implements IAddContactForGroupInputDto {
    groupId!: number;
    contactId!: number;
    contactIds!: number[] | undefined;

    constructor(data?: IAddContactForGroupInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.groupId = data["groupId"];
            this.contactId = data["contactId"];
            if (Array.isArray(data["contactIds"])) {
                this.contactIds = [] as any;
                for (let item of data["contactIds"])
                    this.contactIds!.push(item);
            }
        }
    }

    static fromJS(data: any): AddContactForGroupInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddContactForGroupInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["groupId"] = this.groupId;
        data["contactId"] = this.contactId;
        if (Array.isArray(this.contactIds)) {
            data["contactIds"] = [];
            for (let item of this.contactIds)
                data["contactIds"].push(item);
        }
        return data; 
    }
}

export interface IAddContactForGroupInputDto {
    groupId: number;
    contactId: number;
    contactIds: number[] | undefined;
}

export class AddContactToGroupInput implements IAddContactToGroupInput {
    contactIds!: number[] | undefined;
    contactId!: number;
    contactGroupId!: number;

    constructor(data?: IAddContactToGroupInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["contactIds"])) {
                this.contactIds = [] as any;
                for (let item of data["contactIds"])
                    this.contactIds!.push(item);
            }
            this.contactId = data["contactId"];
            this.contactGroupId = data["contactGroupId"];
        }
    }

    static fromJS(data: any): AddContactToGroupInput {
        data = typeof data === 'object' ? data : {};
        let result = new AddContactToGroupInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.contactIds)) {
            data["contactIds"] = [];
            for (let item of this.contactIds)
                data["contactIds"].push(item);
        }
        data["contactId"] = this.contactId;
        data["contactGroupId"] = this.contactGroupId;
        return data; 
    }
}

export interface IAddContactToGroupInput {
    contactIds: number[] | undefined;
    contactId: number;
    contactGroupId: number;
}

export class CreateOrUpdateContactGroupInputDto implements ICreateOrUpdateContactGroupInputDto {
    id!: number | undefined;
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    isActive!: boolean;

    constructor(data?: ICreateOrUpdateContactGroupInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.isActive = data["isActive"];
        }
    }

    static fromJS(data: any): CreateOrUpdateContactGroupInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateContactGroupInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["isActive"] = this.isActive;
        return data; 
    }
}

export interface ICreateOrUpdateContactGroupInputDto {
    id: number | undefined;
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    isActive: boolean;
}

export class CreateOrUpdateContactGroupSettingInputDto implements ICreateOrUpdateContactGroupSettingInputDto {
    tenantId!: number | undefined;
    groupId!: number;
    code!: string | undefined;
    value!: string | undefined;

    constructor(data?: ICreateOrUpdateContactGroupSettingInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.groupId = data["groupId"];
            this.code = data["code"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreateOrUpdateContactGroupSettingInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateContactGroupSettingInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["groupId"] = this.groupId;
        data["code"] = this.code;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreateOrUpdateContactGroupSettingInputDto {
    tenantId: number | undefined;
    groupId: number;
    code: string | undefined;
    value: string | undefined;
}

export class DeletContactFromGroupInputDto implements IDeletContactFromGroupInputDto {
    groupId!: number;
    contactId!: number;

    constructor(data?: IDeletContactFromGroupInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.groupId = data["groupId"];
            this.contactId = data["contactId"];
        }
    }

    static fromJS(data: any): DeletContactFromGroupInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new DeletContactFromGroupInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["groupId"] = this.groupId;
        data["contactId"] = this.contactId;
        return data; 
    }
}

export interface IDeletContactFromGroupInputDto {
    groupId: number;
    contactId: number;
}

export class GetContactGroupsListItemDto implements IGetContactGroupsListItemDto {
    id!: number;
    parentId!: number | undefined;
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    isActive!: boolean;
    totalContacts!: number;

    constructor(data?: IGetContactGroupsListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.parentId = data["parentId"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.isActive = data["isActive"];
            this.totalContacts = data["totalContacts"];
        }
    }

    static fromJS(data: any): GetContactGroupsListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactGroupsListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["parentId"] = this.parentId;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["isActive"] = this.isActive;
        data["totalContacts"] = this.totalContacts;
        return data; 
    }
}

export interface IGetContactGroupsListItemDto {
    id: number;
    parentId: number | undefined;
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    isActive: boolean;
    totalContacts: number;
}

export class PagedResultDtoOfGetContactGroupsListItemDto implements IPagedResultDtoOfGetContactGroupsListItemDto {
    totalCount!: number;
    items!: GetContactGroupsListItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetContactGroupsListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetContactGroupsListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetContactGroupsListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetContactGroupsListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetContactGroupsListItemDto {
    totalCount: number;
    items: GetContactGroupsListItemDto[] | undefined;
}

export class CommonSettingProperties implements ICommonSettingProperties {
    hintText!: string | undefined;
    type!: string | undefined;
    attributes!: { [key: string]: string; } | undefined;

    constructor(data?: ICommonSettingProperties) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.hintText = data["hintText"];
            this.type = data["type"];
            if (data["attributes"]) {
                this.attributes = {} as any;
                for (let key in data["attributes"]) {
                    if (data["attributes"].hasOwnProperty(key))
                        this.attributes![key] = data["attributes"][key];
                }
            }
        }
    }

    static fromJS(data: any): CommonSettingProperties {
        data = typeof data === 'object' ? data : {};
        let result = new CommonSettingProperties();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["hintText"] = this.hintText;
        data["type"] = this.type;
        if (this.attributes) {
            data["attributes"] = {};
            for (let key in this.attributes) {
                if (this.attributes.hasOwnProperty(key))
                    data["attributes"][key] = this.attributes[key];
            }
        }
        return data; 
    }
}

export interface ICommonSettingProperties {
    hintText: string | undefined;
    type: string | undefined;
    attributes: { [key: string]: string; } | undefined;
}

export class GetContactGroupSettingTypesListItemDto implements IGetContactGroupSettingTypesListItemDto {
    code!: string | undefined;
    properties!: CommonSettingProperties | undefined;

    constructor(data?: IGetContactGroupSettingTypesListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.properties = data["properties"] ? CommonSettingProperties.fromJS(data["properties"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetContactGroupSettingTypesListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactGroupSettingTypesListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["properties"] = this.properties ? this.properties.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetContactGroupSettingTypesListItemDto {
    code: string | undefined;
    properties: CommonSettingProperties | undefined;
}

export class ListResultDtoOfGetContactGroupsListItemDto implements IListResultDtoOfGetContactGroupsListItemDto {
    items!: GetContactGroupsListItemDto[] | undefined;

    constructor(data?: IListResultDtoOfGetContactGroupsListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetContactGroupsListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetContactGroupsListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetContactGroupsListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetContactGroupsListItemDto {
    items: GetContactGroupsListItemDto[] | undefined;
}

export class GetSettingsForContactGroupListItemDto implements IGetSettingsForContactGroupListItemDto {
    id!: number;
    code!: string | undefined;
    value!: string | undefined;
    properties!: CommonSettingProperties | undefined;

    constructor(data?: IGetSettingsForContactGroupListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.value = data["value"];
            this.properties = data["properties"] ? CommonSettingProperties.fromJS(data["properties"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetSettingsForContactGroupListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetSettingsForContactGroupListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["value"] = this.value;
        data["properties"] = this.properties ? this.properties.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetSettingsForContactGroupListItemDto {
    id: number;
    code: string | undefined;
    value: string | undefined;
    properties: CommonSettingProperties | undefined;
}

export class PagedResultDtoOfGetSettingsForContactGroupListItemDto implements IPagedResultDtoOfGetSettingsForContactGroupListItemDto {
    totalCount!: number;
    items!: GetSettingsForContactGroupListItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetSettingsForContactGroupListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetSettingsForContactGroupListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetSettingsForContactGroupListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetSettingsForContactGroupListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetSettingsForContactGroupListItemDto {
    totalCount: number;
    items: GetSettingsForContactGroupListItemDto[] | undefined;
}

export class ContactGroupSettingsInputDto implements IContactGroupSettingsInputDto {
    code!: string | undefined;
    value!: string | undefined;

    constructor(data?: IContactGroupSettingsInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): ContactGroupSettingsInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new ContactGroupSettingsInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["value"] = this.value;
        return data; 
    }
}

export interface IContactGroupSettingsInputDto {
    code: string | undefined;
    value: string | undefined;
}

export class ContactGroupImportInputDto implements IContactGroupImportInputDto {
    id!: number | undefined;
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    isActive!: boolean;
    settings!: ContactGroupSettingsInputDto[] | undefined;

    constructor(data?: IContactGroupImportInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.isActive = data["isActive"];
            if (Array.isArray(data["settings"])) {
                this.settings = [] as any;
                for (let item of data["settings"])
                    this.settings!.push(ContactGroupSettingsInputDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ContactGroupImportInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new ContactGroupImportInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["isActive"] = this.isActive;
        if (Array.isArray(this.settings)) {
            data["settings"] = [];
            for (let item of this.settings)
                data["settings"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IContactGroupImportInputDto {
    id: number | undefined;
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    isActive: boolean;
    settings: ContactGroupSettingsInputDto[] | undefined;
}

export class ContactGroupApiResult implements IContactGroupApiResult {
    code!: string | undefined;
    description!: string | undefined;
    message!: string | undefined;
    contactGroupSettingId!: number | undefined;
    contactGroupId!: number | undefined;
    isSuccess!: boolean;

    constructor(data?: IContactGroupApiResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.message = data["message"];
            this.contactGroupSettingId = data["contactGroupSettingId"];
            this.contactGroupId = data["contactGroupId"];
            this.isSuccess = data["isSuccess"];
        }
    }

    static fromJS(data: any): ContactGroupApiResult {
        data = typeof data === 'object' ? data : {};
        let result = new ContactGroupApiResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["message"] = this.message;
        data["contactGroupSettingId"] = this.contactGroupSettingId;
        data["contactGroupId"] = this.contactGroupId;
        data["isSuccess"] = this.isSuccess;
        return data; 
    }
}

export interface IContactGroupApiResult {
    code: string | undefined;
    description: string | undefined;
    message: string | undefined;
    contactGroupSettingId: number | undefined;
    contactGroupId: number | undefined;
    isSuccess: boolean;
}

export class GetContactPersons implements IGetContactPersons {
    id!: number;
    contactId!: number;
    firstName!: string | undefined;
    lastName!: string | undefined;
    phone!: string | undefined;
    email!: string | undefined;

    constructor(data?: IGetContactPersons) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contactId = data["contactId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.phone = data["phone"];
            this.email = data["email"];
        }
    }

    static fromJS(data: any): GetContactPersons {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactPersons();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contactId"] = this.contactId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["phone"] = this.phone;
        data["email"] = this.email;
        return data; 
    }
}

export interface IGetContactPersons {
    id: number;
    contactId: number;
    firstName: string | undefined;
    lastName: string | undefined;
    phone: string | undefined;
    email: string | undefined;
}

export class GetContactPersonsDto implements IGetContactPersonsDto {
    parentContactId!: number;
    getContactPersons!: GetContactPersons[] | undefined;

    constructor(data?: IGetContactPersonsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parentContactId = data["parentContactId"];
            if (Array.isArray(data["getContactPersons"])) {
                this.getContactPersons = [] as any;
                for (let item of data["getContactPersons"])
                    this.getContactPersons!.push(GetContactPersons.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetContactPersonsDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactPersonsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parentContactId"] = this.parentContactId;
        if (Array.isArray(this.getContactPersons)) {
            data["getContactPersons"] = [];
            for (let item of this.getContactPersons)
                data["getContactPersons"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetContactPersonsDto {
    parentContactId: number;
    getContactPersons: GetContactPersons[] | undefined;
}

export class ContactPersonsEditDto implements IContactPersonsEditDto {
    id!: number | undefined;
    contactId!: number;
    firstName!: string | undefined;
    lastName!: string | undefined;
    phone!: string | undefined;
    email!: string | undefined;

    constructor(data?: IContactPersonsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contactId = data["contactId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.phone = data["phone"];
            this.email = data["email"];
        }
    }

    static fromJS(data: any): ContactPersonsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new ContactPersonsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contactId"] = this.contactId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["phone"] = this.phone;
        data["email"] = this.email;
        return data; 
    }
}

export interface IContactPersonsEditDto {
    id: number | undefined;
    contactId: number;
    firstName: string | undefined;
    lastName: string | undefined;
    phone: string | undefined;
    email: string | undefined;
}

export class CreateOrEditContactPersonInput implements ICreateOrEditContactPersonInput {
    parentContactId!: number;
    createOrEditContactPerson!: ContactPersonsEditDto[] | undefined;

    constructor(data?: ICreateOrEditContactPersonInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parentContactId = data["parentContactId"];
            if (Array.isArray(data["createOrEditContactPerson"])) {
                this.createOrEditContactPerson = [] as any;
                for (let item of data["createOrEditContactPerson"])
                    this.createOrEditContactPerson!.push(ContactPersonsEditDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateOrEditContactPersonInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditContactPersonInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parentContactId"] = this.parentContactId;
        if (Array.isArray(this.createOrEditContactPerson)) {
            data["createOrEditContactPerson"] = [];
            for (let item of this.createOrEditContactPerson)
                data["createOrEditContactPerson"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateOrEditContactPersonInput {
    parentContactId: number;
    createOrEditContactPerson: ContactPersonsEditDto[] | undefined;
}

export enum ContactSettingCode {
    PerformBlindCount = 0,
    EtaLock = 1,
    StopType = 2,
    Alert = 3,
    RequireBag = 4,
    BagColor = 5,
    WillCallMessage = 6,
    PhotoRequired = 7,
    AttachmentsNote = 8,
    ReportZeroCount = 9,
    RequireDeliveryPhoto = 10,
    DeliveryPhotoNote = 11,
}

export class GetContactSettingCodesItemDto implements IGetContactSettingCodesItemDto {
    type!: ContactSettingCode;
    name!: string | undefined;

    constructor(data?: IGetContactSettingCodesItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.type = data["type"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetContactSettingCodesItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactSettingCodesItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["type"] = this.type;
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetContactSettingCodesItemDto {
    type: ContactSettingCode;
    name: string | undefined;
}

export class GetContactSettingCodesDto implements IGetContactSettingCodesDto {
    items!: GetContactSettingCodesItemDto[] | undefined;

    constructor(data?: IGetContactSettingCodesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetContactSettingCodesItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetContactSettingCodesDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactSettingCodesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetContactSettingCodesDto {
    items: GetContactSettingCodesItemDto[] | undefined;
}

export class CreateOrUpdateForContactInputDto implements ICreateOrUpdateForContactInputDto {
    contactId!: number;
    code!: string | undefined;
    value!: string | undefined;
    tenantId!: number | undefined;

    constructor(data?: ICreateOrUpdateForContactInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.code = data["code"];
            this.value = data["value"];
            this.tenantId = data["tenantId"];
        }
    }

    static fromJS(data: any): CreateOrUpdateForContactInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateForContactInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["code"] = this.code;
        data["value"] = this.value;
        data["tenantId"] = this.tenantId;
        return data; 
    }
}

export interface ICreateOrUpdateForContactInputDto {
    contactId: number;
    code: string | undefined;
    value: string | undefined;
    tenantId: number | undefined;
}

export class ListResultDtoOfGetContactSettingsItemDto implements IListResultDtoOfGetContactSettingsItemDto {
    items!: GetContactSettingsItemDto[] | undefined;

    constructor(data?: IListResultDtoOfGetContactSettingsItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetContactSettingsItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetContactSettingsItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetContactSettingsItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetContactSettingsItemDto {
    items: GetContactSettingsItemDto[] | undefined;
}

export class GetContainersItemListDto implements IGetContainersItemListDto {
    id!: number;
    tenantId!: number | undefined;
    name!: string | undefined;
    code!: string | undefined;
    price!: number;
    color!: string | undefined;
    inActive!: boolean;
    sortOrder!: number;
    size!: number;
    total!: number;

    constructor(data?: IGetContainersItemListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.code = data["code"];
            this.price = data["price"];
            this.color = data["color"];
            this.inActive = data["inActive"];
            this.sortOrder = data["sortOrder"];
            this.size = data["size"];
            this.total = data["total"];
        }
    }

    static fromJS(data: any): GetContainersItemListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContainersItemListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["price"] = this.price;
        data["color"] = this.color;
        data["inActive"] = this.inActive;
        data["sortOrder"] = this.sortOrder;
        data["size"] = this.size;
        data["total"] = this.total;
        return data; 
    }
}

export interface IGetContainersItemListDto {
    id: number;
    tenantId: number | undefined;
    name: string | undefined;
    code: string | undefined;
    price: number;
    color: string | undefined;
    inActive: boolean;
    sortOrder: number;
    size: number;
    total: number;
}

export class ListResultDtoOfGetContainersItemListDto implements IListResultDtoOfGetContainersItemListDto {
    items!: GetContainersItemListDto[] | undefined;

    constructor(data?: IListResultDtoOfGetContainersItemListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetContainersItemListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetContainersItemListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetContainersItemListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetContainersItemListDto {
    items: GetContainersItemListDto[] | undefined;
}

export class PagedResultDtoOfGetContainersItemListDto implements IPagedResultDtoOfGetContainersItemListDto {
    totalCount!: number;
    items!: GetContainersItemListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetContainersItemListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetContainersItemListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetContainersItemListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetContainersItemListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetContainersItemListDto {
    totalCount: number;
    items: GetContainersItemListDto[] | undefined;
}

export class CreateContainerInputDto implements ICreateContainerInputDto {
    name!: string | undefined;
    code!: string | undefined;
    price!: number;
    color!: string | undefined;
    inActive!: boolean;
    sortOrder!: number;
    size!: number;

    constructor(data?: ICreateContainerInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.price = data["price"];
            this.color = data["color"];
            this.inActive = data["inActive"];
            this.sortOrder = data["sortOrder"];
            this.size = data["size"];
        }
    }

    static fromJS(data: any): CreateContainerInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateContainerInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["price"] = this.price;
        data["color"] = this.color;
        data["inActive"] = this.inActive;
        data["sortOrder"] = this.sortOrder;
        data["size"] = this.size;
        return data; 
    }
}

export interface ICreateContainerInputDto {
    name: string | undefined;
    code: string | undefined;
    price: number;
    color: string | undefined;
    inActive: boolean;
    sortOrder: number;
    size: number;
}

export class UpdateContainerInputDto implements IUpdateContainerInputDto {
    id!: number;
    name!: string | undefined;
    code!: string | undefined;
    price!: number | undefined;
    color!: string | undefined;
    inActive!: boolean | undefined;
    sortOrder!: number | undefined;
    size!: number | undefined;

    constructor(data?: IUpdateContainerInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.code = data["code"];
            this.price = data["price"];
            this.color = data["color"];
            this.inActive = data["inActive"];
            this.sortOrder = data["sortOrder"];
            this.size = data["size"];
        }
    }

    static fromJS(data: any): UpdateContainerInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateContainerInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["code"] = this.code;
        data["price"] = this.price;
        data["color"] = this.color;
        data["inActive"] = this.inActive;
        data["sortOrder"] = this.sortOrder;
        data["size"] = this.size;
        return data; 
    }
}

export interface IUpdateContainerInputDto {
    id: number;
    name: string | undefined;
    code: string | undefined;
    price: number | undefined;
    color: string | undefined;
    inActive: boolean | undefined;
    sortOrder: number | undefined;
    size: number | undefined;
}

export class ControllerDriverListDto implements IControllerDriverListDto {
    userId!: number | undefined;
    fullName!: string | undefined;
    dateStarted!: moment.Moment;
    appVersion!: string | undefined;
    deviceOs!: string | undefined;
    currentVersion!: number;
    currentVersionName!: string | undefined;

    constructor(data?: IControllerDriverListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.fullName = data["fullName"];
            this.dateStarted = data["dateStarted"] ? moment(data["dateStarted"].toString()) : <any>undefined;
            this.appVersion = data["appVersion"];
            this.deviceOs = data["deviceOs"];
            this.currentVersion = data["currentVersion"];
            this.currentVersionName = data["currentVersionName"];
        }
    }

    static fromJS(data: any): ControllerDriverListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerDriverListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["fullName"] = this.fullName;
        data["dateStarted"] = this.dateStarted ? this.dateStarted.toISOString() : <any>undefined;
        data["appVersion"] = this.appVersion;
        data["deviceOs"] = this.deviceOs;
        data["currentVersion"] = this.currentVersion;
        data["currentVersionName"] = this.currentVersionName;
        return data; 
    }
}

export interface IControllerDriverListDto {
    userId: number | undefined;
    fullName: string | undefined;
    dateStarted: moment.Moment;
    appVersion: string | undefined;
    deviceOs: string | undefined;
    currentVersion: number;
    currentVersionName: string | undefined;
}

export class PagedResultDtoOfControllerDriverListDto implements IPagedResultDtoOfControllerDriverListDto {
    totalCount!: number;
    items!: ControllerDriverListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfControllerDriverListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ControllerDriverListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfControllerDriverListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfControllerDriverListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfControllerDriverListDto {
    totalCount: number;
    items: ControllerDriverListDto[] | undefined;
}

export class ControllerDriverRouteListDto implements IControllerDriverRouteListDto {
    driverId!: number;
    routeCount!: number;

    constructor(data?: IControllerDriverRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverId = data["driverId"];
            this.routeCount = data["routeCount"];
        }
    }

    static fromJS(data: any): ControllerDriverRouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerDriverRouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverId"] = this.driverId;
        data["routeCount"] = this.routeCount;
        return data; 
    }
}

export interface IControllerDriverRouteListDto {
    driverId: number;
    routeCount: number;
}

export class GetDriverForViewDto implements IGetDriverForViewDto {
    fullName!: string | undefined;

    constructor(data?: IGetDriverForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fullName = data["fullName"];
        }
    }

    static fromJS(data: any): GetDriverForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fullName"] = this.fullName;
        return data; 
    }
}

export interface IGetDriverForViewDto {
    fullName: string | undefined;
}

export class GetDriverDetailsResult implements IGetDriverDetailsResult {
    routeId!: number | undefined;
    loadDate!: moment.Moment;
    vehicleName!: string | undefined;
    totalTime!: string | undefined;
    stopCount!: number;
    miles!: number;
    stopsPerHour!: number;
    milesPerHour!: number;
    userId!: number;
    hour!: number;
    min!: number;

    constructor(data?: IGetDriverDetailsResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.vehicleName = data["vehicleName"];
            this.totalTime = data["totalTime"];
            this.stopCount = data["stopCount"];
            this.miles = data["miles"];
            this.stopsPerHour = data["stopsPerHour"];
            this.milesPerHour = data["milesPerHour"];
            this.userId = data["userId"];
            this.hour = data["hour"];
            this.min = data["min"];
        }
    }

    static fromJS(data: any): GetDriverDetailsResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverDetailsResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["vehicleName"] = this.vehicleName;
        data["totalTime"] = this.totalTime;
        data["stopCount"] = this.stopCount;
        data["miles"] = this.miles;
        data["stopsPerHour"] = this.stopsPerHour;
        data["milesPerHour"] = this.milesPerHour;
        data["userId"] = this.userId;
        data["hour"] = this.hour;
        data["min"] = this.min;
        return data; 
    }
}

export interface IGetDriverDetailsResult {
    routeId: number | undefined;
    loadDate: moment.Moment;
    vehicleName: string | undefined;
    totalTime: string | undefined;
    stopCount: number;
    miles: number;
    stopsPerHour: number;
    milesPerHour: number;
    userId: number;
    hour: number;
    min: number;
}

export class PagedResultDtoOfGetDriverDetailsResult implements IPagedResultDtoOfGetDriverDetailsResult {
    totalCount!: number;
    items!: GetDriverDetailsResult[] | undefined;

    constructor(data?: IPagedResultDtoOfGetDriverDetailsResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetDriverDetailsResult.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetDriverDetailsResult {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetDriverDetailsResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetDriverDetailsResult {
    totalCount: number;
    items: GetDriverDetailsResult[] | undefined;
}

export class GetStopCountResult implements IGetStopCountResult {
    stops!: number;
    routeId!: number | undefined;

    constructor(data?: IGetStopCountResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.stops = data["stops"];
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): GetStopCountResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetStopCountResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["stops"] = this.stops;
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface IGetStopCountResult {
    stops: number;
    routeId: number | undefined;
}

export class GetTargetTime implements IGetTargetTime {
    routeId!: number;
    eta!: string | undefined;
    timezone!: string | undefined;

    constructor(data?: IGetTargetTime) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.eta = data["eta"];
            this.timezone = data["timezone"];
        }
    }

    static fromJS(data: any): GetTargetTime {
        data = typeof data === 'object' ? data : {};
        let result = new GetTargetTime();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["eta"] = this.eta;
        data["timezone"] = this.timezone;
        return data; 
    }
}

export interface IGetTargetTime {
    routeId: number;
    eta: string | undefined;
    timezone: string | undefined;
}

export class ZoneList implements IZoneList {
    routeId!: number;
    zone!: string[] | undefined;

    constructor(data?: IZoneList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            if (Array.isArray(data["zone"])) {
                this.zone = [] as any;
                for (let item of data["zone"])
                    this.zone!.push(item);
            }
        }
    }

    static fromJS(data: any): ZoneList {
        data = typeof data === 'object' ? data : {};
        let result = new ZoneList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        if (Array.isArray(this.zone)) {
            data["zone"] = [];
            for (let item of this.zone)
                data["zone"].push(item);
        }
        return data; 
    }
}

export interface IZoneList {
    routeId: number;
    zone: string[] | undefined;
}

export class ControllerKpiCountListDto implements IControllerKpiCountListDto {
    totalVehicle!: number;
    totalVehicleIds!: number[] | undefined;
    totalStops!: number;
    totalStopsIds!: number[] | undefined;
    unassignedStops!: number;
    unassignedStopsIds!: number[] | undefined;
    remainingPickup!: number;
    remainingPickupIds!: number[] | undefined;
    remainingDeliveries!: number;
    remainingDeliveriesIds!: number[] | undefined;
    orderIncidents!: number;
    orderIncidentsIds!: number[] | undefined;
    pickedUp!: number;
    pickedUpIds!: number[] | undefined;
    delivered!: number;
    deliveredIds!: number[] | undefined;
    lateRoutes!: number;
    lateRouteIds!: number[] | undefined;
    competionRate!: string | undefined;
    routeDestination!: GetTargetTime[] | undefined;
    zoneList!: ZoneList[] | undefined;

    constructor(data?: IControllerKpiCountListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalVehicle = data["totalVehicle"];
            if (Array.isArray(data["totalVehicleIds"])) {
                this.totalVehicleIds = [] as any;
                for (let item of data["totalVehicleIds"])
                    this.totalVehicleIds!.push(item);
            }
            this.totalStops = data["totalStops"];
            if (Array.isArray(data["totalStopsIds"])) {
                this.totalStopsIds = [] as any;
                for (let item of data["totalStopsIds"])
                    this.totalStopsIds!.push(item);
            }
            this.unassignedStops = data["unassignedStops"];
            if (Array.isArray(data["unassignedStopsIds"])) {
                this.unassignedStopsIds = [] as any;
                for (let item of data["unassignedStopsIds"])
                    this.unassignedStopsIds!.push(item);
            }
            this.remainingPickup = data["remainingPickup"];
            if (Array.isArray(data["remainingPickupIds"])) {
                this.remainingPickupIds = [] as any;
                for (let item of data["remainingPickupIds"])
                    this.remainingPickupIds!.push(item);
            }
            this.remainingDeliveries = data["remainingDeliveries"];
            if (Array.isArray(data["remainingDeliveriesIds"])) {
                this.remainingDeliveriesIds = [] as any;
                for (let item of data["remainingDeliveriesIds"])
                    this.remainingDeliveriesIds!.push(item);
            }
            this.orderIncidents = data["orderIncidents"];
            if (Array.isArray(data["orderIncidentsIds"])) {
                this.orderIncidentsIds = [] as any;
                for (let item of data["orderIncidentsIds"])
                    this.orderIncidentsIds!.push(item);
            }
            this.pickedUp = data["pickedUp"];
            if (Array.isArray(data["pickedUpIds"])) {
                this.pickedUpIds = [] as any;
                for (let item of data["pickedUpIds"])
                    this.pickedUpIds!.push(item);
            }
            this.delivered = data["delivered"];
            if (Array.isArray(data["deliveredIds"])) {
                this.deliveredIds = [] as any;
                for (let item of data["deliveredIds"])
                    this.deliveredIds!.push(item);
            }
            this.lateRoutes = data["lateRoutes"];
            if (Array.isArray(data["lateRouteIds"])) {
                this.lateRouteIds = [] as any;
                for (let item of data["lateRouteIds"])
                    this.lateRouteIds!.push(item);
            }
            this.competionRate = data["competionRate"];
            if (Array.isArray(data["routeDestination"])) {
                this.routeDestination = [] as any;
                for (let item of data["routeDestination"])
                    this.routeDestination!.push(GetTargetTime.fromJS(item));
            }
            if (Array.isArray(data["zoneList"])) {
                this.zoneList = [] as any;
                for (let item of data["zoneList"])
                    this.zoneList!.push(ZoneList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ControllerKpiCountListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerKpiCountListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalVehicle"] = this.totalVehicle;
        if (Array.isArray(this.totalVehicleIds)) {
            data["totalVehicleIds"] = [];
            for (let item of this.totalVehicleIds)
                data["totalVehicleIds"].push(item);
        }
        data["totalStops"] = this.totalStops;
        if (Array.isArray(this.totalStopsIds)) {
            data["totalStopsIds"] = [];
            for (let item of this.totalStopsIds)
                data["totalStopsIds"].push(item);
        }
        data["unassignedStops"] = this.unassignedStops;
        if (Array.isArray(this.unassignedStopsIds)) {
            data["unassignedStopsIds"] = [];
            for (let item of this.unassignedStopsIds)
                data["unassignedStopsIds"].push(item);
        }
        data["remainingPickup"] = this.remainingPickup;
        if (Array.isArray(this.remainingPickupIds)) {
            data["remainingPickupIds"] = [];
            for (let item of this.remainingPickupIds)
                data["remainingPickupIds"].push(item);
        }
        data["remainingDeliveries"] = this.remainingDeliveries;
        if (Array.isArray(this.remainingDeliveriesIds)) {
            data["remainingDeliveriesIds"] = [];
            for (let item of this.remainingDeliveriesIds)
                data["remainingDeliveriesIds"].push(item);
        }
        data["orderIncidents"] = this.orderIncidents;
        if (Array.isArray(this.orderIncidentsIds)) {
            data["orderIncidentsIds"] = [];
            for (let item of this.orderIncidentsIds)
                data["orderIncidentsIds"].push(item);
        }
        data["pickedUp"] = this.pickedUp;
        if (Array.isArray(this.pickedUpIds)) {
            data["pickedUpIds"] = [];
            for (let item of this.pickedUpIds)
                data["pickedUpIds"].push(item);
        }
        data["delivered"] = this.delivered;
        if (Array.isArray(this.deliveredIds)) {
            data["deliveredIds"] = [];
            for (let item of this.deliveredIds)
                data["deliveredIds"].push(item);
        }
        data["lateRoutes"] = this.lateRoutes;
        if (Array.isArray(this.lateRouteIds)) {
            data["lateRouteIds"] = [];
            for (let item of this.lateRouteIds)
                data["lateRouteIds"].push(item);
        }
        data["competionRate"] = this.competionRate;
        if (Array.isArray(this.routeDestination)) {
            data["routeDestination"] = [];
            for (let item of this.routeDestination)
                data["routeDestination"].push(item.toJSON());
        }
        if (Array.isArray(this.zoneList)) {
            data["zoneList"] = [];
            for (let item of this.zoneList)
                data["zoneList"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IControllerKpiCountListDto {
    totalVehicle: number;
    totalVehicleIds: number[] | undefined;
    totalStops: number;
    totalStopsIds: number[] | undefined;
    unassignedStops: number;
    unassignedStopsIds: number[] | undefined;
    remainingPickup: number;
    remainingPickupIds: number[] | undefined;
    remainingDeliveries: number;
    remainingDeliveriesIds: number[] | undefined;
    orderIncidents: number;
    orderIncidentsIds: number[] | undefined;
    pickedUp: number;
    pickedUpIds: number[] | undefined;
    delivered: number;
    deliveredIds: number[] | undefined;
    lateRoutes: number;
    lateRouteIds: number[] | undefined;
    competionRate: string | undefined;
    routeDestination: GetTargetTime[] | undefined;
    zoneList: ZoneList[] | undefined;
}

export class ControllerKpiCountListDetailsDto implements IControllerKpiCountListDetailsDto {
    routeIds!: number;

    constructor(data?: IControllerKpiCountListDetailsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeIds = data["routeIds"];
        }
    }

    static fromJS(data: any): ControllerKpiCountListDetailsDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerKpiCountListDetailsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeIds"] = this.routeIds;
        return data; 
    }
}

export interface IControllerKpiCountListDetailsDto {
    routeIds: number;
}

export class ControllerKpiLaboratoryLateListDto implements IControllerKpiLaboratoryLateListDto {
    total20Minutes!: number;
    total30Minutes!: number;
    total20MinutesList!: number[] | undefined;
    total30MinutesList!: number[] | undefined;

    constructor(data?: IControllerKpiLaboratoryLateListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.total20Minutes = data["total20Minutes"];
            this.total30Minutes = data["total30Minutes"];
            if (Array.isArray(data["total20MinutesList"])) {
                this.total20MinutesList = [] as any;
                for (let item of data["total20MinutesList"])
                    this.total20MinutesList!.push(item);
            }
            if (Array.isArray(data["total30MinutesList"])) {
                this.total30MinutesList = [] as any;
                for (let item of data["total30MinutesList"])
                    this.total30MinutesList!.push(item);
            }
        }
    }

    static fromJS(data: any): ControllerKpiLaboratoryLateListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerKpiLaboratoryLateListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["total20Minutes"] = this.total20Minutes;
        data["total30Minutes"] = this.total30Minutes;
        if (Array.isArray(this.total20MinutesList)) {
            data["total20MinutesList"] = [];
            for (let item of this.total20MinutesList)
                data["total20MinutesList"].push(item);
        }
        if (Array.isArray(this.total30MinutesList)) {
            data["total30MinutesList"] = [];
            for (let item of this.total30MinutesList)
                data["total30MinutesList"].push(item);
        }
        return data; 
    }
}

export interface IControllerKpiLaboratoryLateListDto {
    total20Minutes: number;
    total30Minutes: number;
    total20MinutesList: number[] | undefined;
    total30MinutesList: number[] | undefined;
}

export class ControllerKpiLaboratoryCountListDto implements IControllerKpiLaboratoryCountListDto {
    routeId!: number;
    routeIds!: number[] | undefined;
    unassignedRoutesIds!: number[] | undefined;
    notCheckedInRouteIds!: number[] | undefined;
    completedRouteIds!: number[] | undefined;
    unassignedWillCallIds!: number[] | undefined;
    completedWillCallIds!: number[] | undefined;
    completedStopsIds!: number[] | undefined;
    incidentIds!: number[] | undefined;
    lockPickedUpIds!: number[] | undefined;
    missedWindowIds!: number[] | undefined;
    totalUnassignedRoutes!: number;
    totalUnassignedStops!: number;
    totalRoutes!: number;
    totalCompletedRoutes!: number;
    totalStops!: number;
    totalWillCalls!: number;
    totalCompletedStops!: number;
    totalCompletedWillCalls!: number;
    totalNotCheckedIn!: number;
    totalUnassignedWillCalls!: number;
    totalIncidents!: number;
    totalLockPickedUp!: number;
    totalLockClinics!: number;
    totalMissedWindow!: number;
    currentDateTime!: string | undefined;
    kpiCountLates!: ControllerKpiLaboratoryLateListDto[] | undefined;
    routeDestination!: GetTargetTime[] | undefined;

    constructor(data?: IControllerKpiLaboratoryCountListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            if (Array.isArray(data["routeIds"])) {
                this.routeIds = [] as any;
                for (let item of data["routeIds"])
                    this.routeIds!.push(item);
            }
            if (Array.isArray(data["unassignedRoutesIds"])) {
                this.unassignedRoutesIds = [] as any;
                for (let item of data["unassignedRoutesIds"])
                    this.unassignedRoutesIds!.push(item);
            }
            if (Array.isArray(data["notCheckedInRouteIds"])) {
                this.notCheckedInRouteIds = [] as any;
                for (let item of data["notCheckedInRouteIds"])
                    this.notCheckedInRouteIds!.push(item);
            }
            if (Array.isArray(data["completedRouteIds"])) {
                this.completedRouteIds = [] as any;
                for (let item of data["completedRouteIds"])
                    this.completedRouteIds!.push(item);
            }
            if (Array.isArray(data["unassignedWillCallIds"])) {
                this.unassignedWillCallIds = [] as any;
                for (let item of data["unassignedWillCallIds"])
                    this.unassignedWillCallIds!.push(item);
            }
            if (Array.isArray(data["completedWillCallIds"])) {
                this.completedWillCallIds = [] as any;
                for (let item of data["completedWillCallIds"])
                    this.completedWillCallIds!.push(item);
            }
            if (Array.isArray(data["completedStopsIds"])) {
                this.completedStopsIds = [] as any;
                for (let item of data["completedStopsIds"])
                    this.completedStopsIds!.push(item);
            }
            if (Array.isArray(data["incidentIds"])) {
                this.incidentIds = [] as any;
                for (let item of data["incidentIds"])
                    this.incidentIds!.push(item);
            }
            if (Array.isArray(data["lockPickedUpIds"])) {
                this.lockPickedUpIds = [] as any;
                for (let item of data["lockPickedUpIds"])
                    this.lockPickedUpIds!.push(item);
            }
            if (Array.isArray(data["missedWindowIds"])) {
                this.missedWindowIds = [] as any;
                for (let item of data["missedWindowIds"])
                    this.missedWindowIds!.push(item);
            }
            this.totalUnassignedRoutes = data["totalUnassignedRoutes"];
            this.totalUnassignedStops = data["totalUnassignedStops"];
            this.totalRoutes = data["totalRoutes"];
            this.totalCompletedRoutes = data["totalCompletedRoutes"];
            this.totalStops = data["totalStops"];
            this.totalWillCalls = data["totalWillCalls"];
            this.totalCompletedStops = data["totalCompletedStops"];
            this.totalCompletedWillCalls = data["totalCompletedWillCalls"];
            this.totalNotCheckedIn = data["totalNotCheckedIn"];
            this.totalUnassignedWillCalls = data["totalUnassignedWillCalls"];
            this.totalIncidents = data["totalIncidents"];
            this.totalLockPickedUp = data["totalLockPickedUp"];
            this.totalLockClinics = data["totalLockClinics"];
            this.totalMissedWindow = data["totalMissedWindow"];
            this.currentDateTime = data["currentDateTime"];
            if (Array.isArray(data["kpiCountLates"])) {
                this.kpiCountLates = [] as any;
                for (let item of data["kpiCountLates"])
                    this.kpiCountLates!.push(ControllerKpiLaboratoryLateListDto.fromJS(item));
            }
            if (Array.isArray(data["routeDestination"])) {
                this.routeDestination = [] as any;
                for (let item of data["routeDestination"])
                    this.routeDestination!.push(GetTargetTime.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ControllerKpiLaboratoryCountListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerKpiLaboratoryCountListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        if (Array.isArray(this.routeIds)) {
            data["routeIds"] = [];
            for (let item of this.routeIds)
                data["routeIds"].push(item);
        }
        if (Array.isArray(this.unassignedRoutesIds)) {
            data["unassignedRoutesIds"] = [];
            for (let item of this.unassignedRoutesIds)
                data["unassignedRoutesIds"].push(item);
        }
        if (Array.isArray(this.notCheckedInRouteIds)) {
            data["notCheckedInRouteIds"] = [];
            for (let item of this.notCheckedInRouteIds)
                data["notCheckedInRouteIds"].push(item);
        }
        if (Array.isArray(this.completedRouteIds)) {
            data["completedRouteIds"] = [];
            for (let item of this.completedRouteIds)
                data["completedRouteIds"].push(item);
        }
        if (Array.isArray(this.unassignedWillCallIds)) {
            data["unassignedWillCallIds"] = [];
            for (let item of this.unassignedWillCallIds)
                data["unassignedWillCallIds"].push(item);
        }
        if (Array.isArray(this.completedWillCallIds)) {
            data["completedWillCallIds"] = [];
            for (let item of this.completedWillCallIds)
                data["completedWillCallIds"].push(item);
        }
        if (Array.isArray(this.completedStopsIds)) {
            data["completedStopsIds"] = [];
            for (let item of this.completedStopsIds)
                data["completedStopsIds"].push(item);
        }
        if (Array.isArray(this.incidentIds)) {
            data["incidentIds"] = [];
            for (let item of this.incidentIds)
                data["incidentIds"].push(item);
        }
        if (Array.isArray(this.lockPickedUpIds)) {
            data["lockPickedUpIds"] = [];
            for (let item of this.lockPickedUpIds)
                data["lockPickedUpIds"].push(item);
        }
        if (Array.isArray(this.missedWindowIds)) {
            data["missedWindowIds"] = [];
            for (let item of this.missedWindowIds)
                data["missedWindowIds"].push(item);
        }
        data["totalUnassignedRoutes"] = this.totalUnassignedRoutes;
        data["totalUnassignedStops"] = this.totalUnassignedStops;
        data["totalRoutes"] = this.totalRoutes;
        data["totalCompletedRoutes"] = this.totalCompletedRoutes;
        data["totalStops"] = this.totalStops;
        data["totalWillCalls"] = this.totalWillCalls;
        data["totalCompletedStops"] = this.totalCompletedStops;
        data["totalCompletedWillCalls"] = this.totalCompletedWillCalls;
        data["totalNotCheckedIn"] = this.totalNotCheckedIn;
        data["totalUnassignedWillCalls"] = this.totalUnassignedWillCalls;
        data["totalIncidents"] = this.totalIncidents;
        data["totalLockPickedUp"] = this.totalLockPickedUp;
        data["totalLockClinics"] = this.totalLockClinics;
        data["totalMissedWindow"] = this.totalMissedWindow;
        data["currentDateTime"] = this.currentDateTime;
        if (Array.isArray(this.kpiCountLates)) {
            data["kpiCountLates"] = [];
            for (let item of this.kpiCountLates)
                data["kpiCountLates"].push(item.toJSON());
        }
        if (Array.isArray(this.routeDestination)) {
            data["routeDestination"] = [];
            for (let item of this.routeDestination)
                data["routeDestination"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IControllerKpiLaboratoryCountListDto {
    routeId: number;
    routeIds: number[] | undefined;
    unassignedRoutesIds: number[] | undefined;
    notCheckedInRouteIds: number[] | undefined;
    completedRouteIds: number[] | undefined;
    unassignedWillCallIds: number[] | undefined;
    completedWillCallIds: number[] | undefined;
    completedStopsIds: number[] | undefined;
    incidentIds: number[] | undefined;
    lockPickedUpIds: number[] | undefined;
    missedWindowIds: number[] | undefined;
    totalUnassignedRoutes: number;
    totalUnassignedStops: number;
    totalRoutes: number;
    totalCompletedRoutes: number;
    totalStops: number;
    totalWillCalls: number;
    totalCompletedStops: number;
    totalCompletedWillCalls: number;
    totalNotCheckedIn: number;
    totalUnassignedWillCalls: number;
    totalIncidents: number;
    totalLockPickedUp: number;
    totalLockClinics: number;
    totalMissedWindow: number;
    currentDateTime: string | undefined;
    kpiCountLates: ControllerKpiLaboratoryLateListDto[] | undefined;
    routeDestination: GetTargetTime[] | undefined;
}

export class TagTypeListDto implements ITagTypeListDto {
    id!: number;
    name!: string | undefined;
    code!: string | undefined;

    constructor(data?: ITagTypeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): TagTypeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new TagTypeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["code"] = this.code;
        return data; 
    }
}

export interface ITagTypeListDto {
    id: number;
    name: string | undefined;
    code: string | undefined;
}

export class TagListDto implements ITagListDto {
    tenantId!: number;
    tagType!: TagTypeListDto | undefined;
    tagTypeList!: TagTypeListDto[] | undefined;
    name!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ITagListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tagType = data["tagType"] ? TagTypeListDto.fromJS(data["tagType"]) : <any>undefined;
            if (Array.isArray(data["tagTypeList"])) {
                this.tagTypeList = [] as any;
                for (let item of data["tagTypeList"])
                    this.tagTypeList!.push(TagTypeListDto.fromJS(item));
            }
            this.name = data["name"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TagListDto {
        data = typeof data === 'object' ? data : {};
        let result = new TagListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tagType"] = this.tagType ? this.tagType.toJSON() : <any>undefined;
        if (Array.isArray(this.tagTypeList)) {
            data["tagTypeList"] = [];
            for (let item of this.tagTypeList)
                data["tagTypeList"].push(item.toJSON());
        }
        data["name"] = this.name;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITagListDto {
    tenantId: number;
    tagType: TagTypeListDto | undefined;
    tagTypeList: TagTypeListDto[] | undefined;
    name: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderTagListDto implements IOrderTagListDto {
    tag!: TagListDto | undefined;
    tagList!: TagListDto[] | undefined;
    tagId!: number;
    orderId!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderTagListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tag = data["tag"] ? TagListDto.fromJS(data["tag"]) : <any>undefined;
            if (Array.isArray(data["tagList"])) {
                this.tagList = [] as any;
                for (let item of data["tagList"])
                    this.tagList!.push(TagListDto.fromJS(item));
            }
            this.tagId = data["tagId"];
            this.orderId = data["orderId"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderTagListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderTagListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tag"] = this.tag ? this.tag.toJSON() : <any>undefined;
        if (Array.isArray(this.tagList)) {
            data["tagList"] = [];
            for (let item of this.tagList)
                data["tagList"].push(item.toJSON());
        }
        data["tagId"] = this.tagId;
        data["orderId"] = this.orderId;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderTagListDto {
    tag: TagListDto | undefined;
    tagList: TagListDto[] | undefined;
    tagId: number;
    orderId: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class GetControllerOrderPackagesListDto implements IGetControllerOrderPackagesListDto {
    id!: number;
    orderId!: number;
    pickUpEtaStart!: moment.Moment;
    pickUpEtaStartString!: string | undefined;
    pickUpEtaEnd!: moment.Moment;
    pickUpEtaEndString!: string | undefined;
    pickUpFirstName!: string | undefined;
    pickUpLastName!: string | undefined;
    pickUpAddressLine1!: string | undefined;
    pickUpAddressLine2!: string | undefined;
    pickUpCountry!: string | undefined;
    pickUpCity!: string | undefined;
    pickUpState!: string | undefined;
    pickUpPostalCode!: string | undefined;
    pickUpCompanyName!: string | undefined;
    pickUpAccountNo!: string | undefined;
    deliveryEtaStart!: moment.Moment;
    deliveryEtaStartString!: string | undefined;
    deliveryEtaEnd!: moment.Moment;
    deliveryEtaEndString!: string | undefined;
    deliveryFirstName!: string | undefined;
    deliveryLastName!: string | undefined;
    deliveryAddressLine1!: string | undefined;
    deliveryAddressLine2!: string | undefined;
    deliveryCountry!: string | undefined;
    deliveryCity!: string | undefined;
    deliveryState!: string | undefined;
    deliveryPostalCode!: string | undefined;
    deliveryName!: string | undefined;
    loadDate!: moment.Moment;
    lastLog!: moment.Moment;
    lastLogString!: string | undefined;
    status!: string | undefined;
    color!: string | undefined;
    code!: string | undefined;
    icon!: string | undefined;
    orderStatusTypeId!: number | undefined;
    orderTags!: OrderTagListDto[] | undefined;
    orderTypeId!: number;
    orderTypeDescription!: string | undefined;
    orderTypeColor!: string | undefined;
    pickupDate!: string | undefined;
    deliveryDate!: string | undefined;
    customer!: string | undefined;
    accountNo!: string | undefined;
    address!: string | undefined;
    routeName!: string | undefined;
    tagName!: string | undefined;

    constructor(data?: IGetControllerOrderPackagesListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.orderId = data["orderId"];
            this.pickUpEtaStart = data["pickUpEtaStart"] ? moment(data["pickUpEtaStart"].toString()) : <any>undefined;
            this.pickUpEtaStartString = data["pickUpEtaStartString"];
            this.pickUpEtaEnd = data["pickUpEtaEnd"] ? moment(data["pickUpEtaEnd"].toString()) : <any>undefined;
            this.pickUpEtaEndString = data["pickUpEtaEndString"];
            this.pickUpFirstName = data["pickUpFirstName"];
            this.pickUpLastName = data["pickUpLastName"];
            this.pickUpAddressLine1 = data["pickUpAddressLine1"];
            this.pickUpAddressLine2 = data["pickUpAddressLine2"];
            this.pickUpCountry = data["pickUpCountry"];
            this.pickUpCity = data["pickUpCity"];
            this.pickUpState = data["pickUpState"];
            this.pickUpPostalCode = data["pickUpPostalCode"];
            this.pickUpCompanyName = data["pickUpCompanyName"];
            this.pickUpAccountNo = data["pickUpAccountNo"];
            this.deliveryEtaStart = data["deliveryEtaStart"] ? moment(data["deliveryEtaStart"].toString()) : <any>undefined;
            this.deliveryEtaStartString = data["deliveryEtaStartString"];
            this.deliveryEtaEnd = data["deliveryEtaEnd"] ? moment(data["deliveryEtaEnd"].toString()) : <any>undefined;
            this.deliveryEtaEndString = data["deliveryEtaEndString"];
            this.deliveryFirstName = data["deliveryFirstName"];
            this.deliveryLastName = data["deliveryLastName"];
            this.deliveryAddressLine1 = data["deliveryAddressLine1"];
            this.deliveryAddressLine2 = data["deliveryAddressLine2"];
            this.deliveryCountry = data["deliveryCountry"];
            this.deliveryCity = data["deliveryCity"];
            this.deliveryState = data["deliveryState"];
            this.deliveryPostalCode = data["deliveryPostalCode"];
            this.deliveryName = data["deliveryName"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.lastLog = data["lastLog"] ? moment(data["lastLog"].toString()) : <any>undefined;
            this.lastLogString = data["lastLogString"];
            this.status = data["status"];
            this.color = data["color"];
            this.code = data["code"];
            this.icon = data["icon"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(OrderTagListDto.fromJS(item));
            }
            this.orderTypeId = data["orderTypeId"];
            this.orderTypeDescription = data["orderTypeDescription"];
            this.orderTypeColor = data["orderTypeColor"];
            this.pickupDate = data["pickupDate"];
            this.deliveryDate = data["deliveryDate"];
            this.customer = data["customer"];
            this.accountNo = data["accountNo"];
            this.address = data["address"];
            this.routeName = data["routeName"];
            this.tagName = data["tagName"];
        }
    }

    static fromJS(data: any): GetControllerOrderPackagesListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetControllerOrderPackagesListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["orderId"] = this.orderId;
        data["pickUpEtaStart"] = this.pickUpEtaStart ? this.pickUpEtaStart.toISOString() : <any>undefined;
        data["pickUpEtaStartString"] = this.pickUpEtaStartString;
        data["pickUpEtaEnd"] = this.pickUpEtaEnd ? this.pickUpEtaEnd.toISOString() : <any>undefined;
        data["pickUpEtaEndString"] = this.pickUpEtaEndString;
        data["pickUpFirstName"] = this.pickUpFirstName;
        data["pickUpLastName"] = this.pickUpLastName;
        data["pickUpAddressLine1"] = this.pickUpAddressLine1;
        data["pickUpAddressLine2"] = this.pickUpAddressLine2;
        data["pickUpCountry"] = this.pickUpCountry;
        data["pickUpCity"] = this.pickUpCity;
        data["pickUpState"] = this.pickUpState;
        data["pickUpPostalCode"] = this.pickUpPostalCode;
        data["pickUpCompanyName"] = this.pickUpCompanyName;
        data["pickUpAccountNo"] = this.pickUpAccountNo;
        data["deliveryEtaStart"] = this.deliveryEtaStart ? this.deliveryEtaStart.toISOString() : <any>undefined;
        data["deliveryEtaStartString"] = this.deliveryEtaStartString;
        data["deliveryEtaEnd"] = this.deliveryEtaEnd ? this.deliveryEtaEnd.toISOString() : <any>undefined;
        data["deliveryEtaEndString"] = this.deliveryEtaEndString;
        data["deliveryFirstName"] = this.deliveryFirstName;
        data["deliveryLastName"] = this.deliveryLastName;
        data["deliveryAddressLine1"] = this.deliveryAddressLine1;
        data["deliveryAddressLine2"] = this.deliveryAddressLine2;
        data["deliveryCountry"] = this.deliveryCountry;
        data["deliveryCity"] = this.deliveryCity;
        data["deliveryState"] = this.deliveryState;
        data["deliveryPostalCode"] = this.deliveryPostalCode;
        data["deliveryName"] = this.deliveryName;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["lastLog"] = this.lastLog ? this.lastLog.toISOString() : <any>undefined;
        data["lastLogString"] = this.lastLogString;
        data["status"] = this.status;
        data["color"] = this.color;
        data["code"] = this.code;
        data["icon"] = this.icon;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        data["orderTypeId"] = this.orderTypeId;
        data["orderTypeDescription"] = this.orderTypeDescription;
        data["orderTypeColor"] = this.orderTypeColor;
        data["pickupDate"] = this.pickupDate;
        data["deliveryDate"] = this.deliveryDate;
        data["customer"] = this.customer;
        data["accountNo"] = this.accountNo;
        data["address"] = this.address;
        data["routeName"] = this.routeName;
        data["tagName"] = this.tagName;
        return data; 
    }
}

export interface IGetControllerOrderPackagesListDto {
    id: number;
    orderId: number;
    pickUpEtaStart: moment.Moment;
    pickUpEtaStartString: string | undefined;
    pickUpEtaEnd: moment.Moment;
    pickUpEtaEndString: string | undefined;
    pickUpFirstName: string | undefined;
    pickUpLastName: string | undefined;
    pickUpAddressLine1: string | undefined;
    pickUpAddressLine2: string | undefined;
    pickUpCountry: string | undefined;
    pickUpCity: string | undefined;
    pickUpState: string | undefined;
    pickUpPostalCode: string | undefined;
    pickUpCompanyName: string | undefined;
    pickUpAccountNo: string | undefined;
    deliveryEtaStart: moment.Moment;
    deliveryEtaStartString: string | undefined;
    deliveryEtaEnd: moment.Moment;
    deliveryEtaEndString: string | undefined;
    deliveryFirstName: string | undefined;
    deliveryLastName: string | undefined;
    deliveryAddressLine1: string | undefined;
    deliveryAddressLine2: string | undefined;
    deliveryCountry: string | undefined;
    deliveryCity: string | undefined;
    deliveryState: string | undefined;
    deliveryPostalCode: string | undefined;
    deliveryName: string | undefined;
    loadDate: moment.Moment;
    lastLog: moment.Moment;
    lastLogString: string | undefined;
    status: string | undefined;
    color: string | undefined;
    code: string | undefined;
    icon: string | undefined;
    orderStatusTypeId: number | undefined;
    orderTags: OrderTagListDto[] | undefined;
    orderTypeId: number;
    orderTypeDescription: string | undefined;
    orderTypeColor: string | undefined;
    pickupDate: string | undefined;
    deliveryDate: string | undefined;
    customer: string | undefined;
    accountNo: string | undefined;
    address: string | undefined;
    routeName: string | undefined;
    tagName: string | undefined;
}

export class GroupOrderPackagesTab implements IGroupOrderPackagesTab {
    orderTypeDescription!: string | undefined;
    orderTypeId!: number;
    orderTypeColor!: string | undefined;
    groupOrders!: GetControllerOrderPackagesListDto[] | undefined;

    constructor(data?: IGroupOrderPackagesTab) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderTypeDescription = data["orderTypeDescription"];
            this.orderTypeId = data["orderTypeId"];
            this.orderTypeColor = data["orderTypeColor"];
            if (Array.isArray(data["groupOrders"])) {
                this.groupOrders = [] as any;
                for (let item of data["groupOrders"])
                    this.groupOrders!.push(GetControllerOrderPackagesListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GroupOrderPackagesTab {
        data = typeof data === 'object' ? data : {};
        let result = new GroupOrderPackagesTab();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderTypeDescription"] = this.orderTypeDescription;
        data["orderTypeId"] = this.orderTypeId;
        data["orderTypeColor"] = this.orderTypeColor;
        if (Array.isArray(this.groupOrders)) {
            data["groupOrders"] = [];
            for (let item of this.groupOrders)
                data["groupOrders"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGroupOrderPackagesTab {
    orderTypeDescription: string | undefined;
    orderTypeId: number;
    orderTypeColor: string | undefined;
    groupOrders: GetControllerOrderPackagesListDto[] | undefined;
}

export class PagedResultDtoOfgroupOrderPackagesTab implements IPagedResultDtoOfgroupOrderPackagesTab {
    totalCount!: number;
    items!: GroupOrderPackagesTab[] | undefined;

    constructor(data?: IPagedResultDtoOfgroupOrderPackagesTab) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GroupOrderPackagesTab.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfgroupOrderPackagesTab {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfgroupOrderPackagesTab();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfgroupOrderPackagesTab {
    totalCount: number;
    items: GroupOrderPackagesTab[] | undefined;
}

export class PagedResultDtoOfGetControllerOrderPackagesListDto implements IPagedResultDtoOfGetControllerOrderPackagesListDto {
    totalCount!: number;
    items!: GetControllerOrderPackagesListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetControllerOrderPackagesListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetControllerOrderPackagesListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetControllerOrderPackagesListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetControllerOrderPackagesListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetControllerOrderPackagesListDto {
    totalCount: number;
    items: GetControllerOrderPackagesListDto[] | undefined;
}

export class GetControllerOrderPackagesListInput implements IGetControllerOrderPackagesListInput {
    filter!: string | undefined;
    statusCode!: string | undefined;
    orderPackageId!: number | undefined;
    orderId!: number | undefined;
    orderIds!: number[] | undefined;
    locationId!: number | undefined;
    packageId!: number | undefined;
    orderStatusTypeId!: number | undefined;
    orderTag!: string | undefined;
    accountNumber!: number | undefined;
    loadDate!: moment.Moment;
    loadDateEnd!: moment.Moment;
    unassigned!: boolean | undefined;
    willCalls!: boolean | undefined;
    sorting!: string | undefined;
    maxResultCount!: number;
    skipCount!: number;

    constructor(data?: IGetControllerOrderPackagesListInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.filter = data["filter"];
            this.statusCode = data["statusCode"];
            this.orderPackageId = data["orderPackageId"];
            this.orderId = data["orderId"];
            if (Array.isArray(data["orderIds"])) {
                this.orderIds = [] as any;
                for (let item of data["orderIds"])
                    this.orderIds!.push(item);
            }
            this.locationId = data["locationId"];
            this.packageId = data["packageId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderTag = data["orderTag"];
            this.accountNumber = data["accountNumber"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.loadDateEnd = data["loadDateEnd"] ? moment(data["loadDateEnd"].toString()) : <any>undefined;
            this.unassigned = data["unassigned"];
            this.willCalls = data["willCalls"];
            this.sorting = data["sorting"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
        }
    }

    static fromJS(data: any): GetControllerOrderPackagesListInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetControllerOrderPackagesListInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["filter"] = this.filter;
        data["statusCode"] = this.statusCode;
        data["orderPackageId"] = this.orderPackageId;
        data["orderId"] = this.orderId;
        if (Array.isArray(this.orderIds)) {
            data["orderIds"] = [];
            for (let item of this.orderIds)
                data["orderIds"].push(item);
        }
        data["locationId"] = this.locationId;
        data["packageId"] = this.packageId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderTag"] = this.orderTag;
        data["accountNumber"] = this.accountNumber;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["loadDateEnd"] = this.loadDateEnd ? this.loadDateEnd.toISOString() : <any>undefined;
        data["unassigned"] = this.unassigned;
        data["willCalls"] = this.willCalls;
        data["sorting"] = this.sorting;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        return data; 
    }
}

export interface IGetControllerOrderPackagesListInput {
    filter: string | undefined;
    statusCode: string | undefined;
    orderPackageId: number | undefined;
    orderId: number | undefined;
    orderIds: number[] | undefined;
    locationId: number | undefined;
    packageId: number | undefined;
    orderStatusTypeId: number | undefined;
    orderTag: string | undefined;
    accountNumber: number | undefined;
    loadDate: moment.Moment;
    loadDateEnd: moment.Moment;
    unassigned: boolean | undefined;
    willCalls: boolean | undefined;
    sorting: string | undefined;
    maxResultCount: number;
    skipCount: number;
}

export class CreateOrderStatusInput implements ICreateOrderStatusInput {
    userId!: number;
    orderId!: number;
    geocodeId!: number | undefined;
    orderStatusTypeId!: number;
    orderStatusDescriptionId!: number;
    note!: string | undefined;
    latitude!: number;
    longitude!: number;
    noteId!: number | undefined;
    time!: moment.Moment;
    bgColor!: string | undefined;

    constructor(data?: ICreateOrderStatusInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.orderId = data["orderId"];
            this.geocodeId = data["geocodeId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderStatusDescriptionId = data["orderStatusDescriptionId"];
            this.note = data["note"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.noteId = data["noteId"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.bgColor = data["bgColor"];
        }
    }

    static fromJS(data: any): CreateOrderStatusInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderStatusInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["orderId"] = this.orderId;
        data["geocodeId"] = this.geocodeId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderStatusDescriptionId"] = this.orderStatusDescriptionId;
        data["note"] = this.note;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["noteId"] = this.noteId;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["bgColor"] = this.bgColor;
        return data; 
    }
}

export interface ICreateOrderStatusInput {
    userId: number;
    orderId: number;
    geocodeId: number | undefined;
    orderStatusTypeId: number;
    orderStatusDescriptionId: number;
    note: string | undefined;
    latitude: number;
    longitude: number;
    noteId: number | undefined;
    time: moment.Moment;
    bgColor: string | undefined;
}

export class OrderStatusTypeListDto implements IOrderStatusTypeListDto {
    id!: number;
    tenantId!: number;
    code!: string;
    description!: string;
    name!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    visible!: boolean;
    parentId!: number | undefined;
    sortOrder!: number;

    constructor(data?: IOrderStatusTypeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.description = data["description"];
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.visible = data["visible"];
            this.parentId = data["parentId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): OrderStatusTypeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusTypeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["description"] = this.description;
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["visible"] = this.visible;
        data["parentId"] = this.parentId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IOrderStatusTypeListDto {
    id: number;
    tenantId: number;
    code: string;
    description: string;
    name: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    visible: boolean;
    parentId: number | undefined;
    sortOrder: number;
}

export class ListResultDtoOfOrderStatusTypeListDto implements IListResultDtoOfOrderStatusTypeListDto {
    items!: OrderStatusTypeListDto[] | undefined;

    constructor(data?: IListResultDtoOfOrderStatusTypeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusTypeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfOrderStatusTypeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfOrderStatusTypeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfOrderStatusTypeListDto {
    items: OrderStatusTypeListDto[] | undefined;
}

export class OrderStatusDescriptionListDto implements IOrderStatusDescriptionListDto {
    id!: number;
    tenantId!: number;
    description!: string;
    code!: string | undefined;
    name!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    visible!: boolean;
    parentId!: number | undefined;
    sortOrder!: number;
    orderStatusTypeId!: number;
    parent!: OrderStatusDescriptionListDto | undefined;

    constructor(data?: IOrderStatusDescriptionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.description = data["description"];
            this.code = data["code"];
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.visible = data["visible"];
            this.parentId = data["parentId"];
            this.sortOrder = data["sortOrder"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.parent = data["parent"] ? OrderStatusDescriptionListDto.fromJS(data["parent"]) : <any>undefined;
        }
    }

    static fromJS(data: any): OrderStatusDescriptionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusDescriptionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["description"] = this.description;
        data["code"] = this.code;
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["visible"] = this.visible;
        data["parentId"] = this.parentId;
        data["sortOrder"] = this.sortOrder;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["parent"] = this.parent ? this.parent.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IOrderStatusDescriptionListDto {
    id: number;
    tenantId: number;
    description: string;
    code: string | undefined;
    name: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    visible: boolean;
    parentId: number | undefined;
    sortOrder: number;
    orderStatusTypeId: number;
    parent: OrderStatusDescriptionListDto | undefined;
}

export class ListResultDtoOfOrderStatusDescriptionListDto implements IListResultDtoOfOrderStatusDescriptionListDto {
    items!: OrderStatusDescriptionListDto[] | undefined;

    constructor(data?: IListResultDtoOfOrderStatusDescriptionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusDescriptionListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfOrderStatusDescriptionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfOrderStatusDescriptionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfOrderStatusDescriptionListDto {
    items: OrderStatusDescriptionListDto[] | undefined;
}

export class AddBatchOrderStatusInput implements IAddBatchOrderStatusInput {
    userId!: number;
    orderId!: number[] | undefined;
    geocodeId!: number | undefined;
    orderStatusTypeId!: number;
    orderStatusDescriptionId!: number;
    note!: string | undefined;
    latitude!: number;
    longitude!: number;
    noteId!: number | undefined;
    time!: moment.Moment;
    bgColor!: string | undefined;
    action!: string | undefined;
    jobId!: string | undefined;

    constructor(data?: IAddBatchOrderStatusInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            if (Array.isArray(data["orderId"])) {
                this.orderId = [] as any;
                for (let item of data["orderId"])
                    this.orderId!.push(item);
            }
            this.geocodeId = data["geocodeId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderStatusDescriptionId = data["orderStatusDescriptionId"];
            this.note = data["note"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.noteId = data["noteId"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.bgColor = data["bgColor"];
            this.action = data["action"];
            this.jobId = data["jobId"];
        }
    }

    static fromJS(data: any): AddBatchOrderStatusInput {
        data = typeof data === 'object' ? data : {};
        let result = new AddBatchOrderStatusInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        if (Array.isArray(this.orderId)) {
            data["orderId"] = [];
            for (let item of this.orderId)
                data["orderId"].push(item);
        }
        data["geocodeId"] = this.geocodeId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderStatusDescriptionId"] = this.orderStatusDescriptionId;
        data["note"] = this.note;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["noteId"] = this.noteId;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["bgColor"] = this.bgColor;
        data["action"] = this.action;
        data["jobId"] = this.jobId;
        return data; 
    }
}

export interface IAddBatchOrderStatusInput {
    userId: number;
    orderId: number[] | undefined;
    geocodeId: number | undefined;
    orderStatusTypeId: number;
    orderStatusDescriptionId: number;
    note: string | undefined;
    latitude: number;
    longitude: number;
    noteId: number | undefined;
    time: moment.Moment;
    bgColor: string | undefined;
    action: string | undefined;
    jobId: string | undefined;
}

export class CreateBatchResultOutput implements ICreateBatchResultOutput {
    jobId!: string | undefined;
    result!: string | undefined;
    isLast!: boolean;

    constructor(data?: ICreateBatchResultOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.jobId = data["jobId"];
            this.result = data["result"];
            this.isLast = data["isLast"];
        }
    }

    static fromJS(data: any): CreateBatchResultOutput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateBatchResultOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["jobId"] = this.jobId;
        data["result"] = this.result;
        data["isLast"] = this.isLast;
        return data; 
    }
}

export interface ICreateBatchResultOutput {
    jobId: string | undefined;
    result: string | undefined;
    isLast: boolean;
}

export class ShippingPackageListDto implements IShippingPackageListDto {
    id!: number;
    name!: string | undefined;
    price!: number;
    code!: string | undefined;
    color!: string | undefined;
    isHiddenPackages!: string | undefined;
    sortOrder!: number;
    total!: number;
    sku!: string | undefined;
    description!: string | undefined;

    constructor(data?: IShippingPackageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.price = data["price"];
            this.code = data["code"];
            this.color = data["color"];
            this.isHiddenPackages = data["isHiddenPackages"];
            this.sortOrder = data["sortOrder"];
            this.total = data["total"];
            this.sku = data["sku"];
            this.description = data["description"];
        }
    }

    static fromJS(data: any): ShippingPackageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ShippingPackageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["price"] = this.price;
        data["code"] = this.code;
        data["color"] = this.color;
        data["isHiddenPackages"] = this.isHiddenPackages;
        data["sortOrder"] = this.sortOrder;
        data["total"] = this.total;
        data["sku"] = this.sku;
        data["description"] = this.description;
        return data; 
    }
}

export interface IShippingPackageListDto {
    id: number;
    name: string | undefined;
    price: number;
    code: string | undefined;
    color: string | undefined;
    isHiddenPackages: string | undefined;
    sortOrder: number;
    total: number;
    sku: string | undefined;
    description: string | undefined;
}

export class OrderPackageListDto implements IOrderPackageListDto {
    orderId!: number;
    packageId!: number;
    package!: ShippingPackageListDto | undefined;
    listedPackage!: ShippingPackageListDto[] | undefined;
    quantity!: number;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderPackageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.packageId = data["packageId"];
            this.package = data["package"] ? ShippingPackageListDto.fromJS(data["package"]) : <any>undefined;
            if (Array.isArray(data["listedPackage"])) {
                this.listedPackage = [] as any;
                for (let item of data["listedPackage"])
                    this.listedPackage!.push(ShippingPackageListDto.fromJS(item));
            }
            this.quantity = data["quantity"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderPackageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderPackageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["packageId"] = this.packageId;
        data["package"] = this.package ? this.package.toJSON() : <any>undefined;
        if (Array.isArray(this.listedPackage)) {
            data["listedPackage"] = [];
            for (let item of this.listedPackage)
                data["listedPackage"].push(item.toJSON());
        }
        data["quantity"] = this.quantity;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderPackageListDto {
    orderId: number;
    packageId: number;
    package: ShippingPackageListDto | undefined;
    listedPackage: ShippingPackageListDto[] | undefined;
    quantity: number;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ControllerRoutePrintDto implements IControllerRoutePrintDto {
    routeId!: number | undefined;
    routeCode!: string | undefined;
    loadDate!: moment.Moment;
    driverName!: string | undefined;
    customer!: string | undefined;
    deliveryAddressLine1!: string | undefined;
    deliveryAddressLine2!: string | undefined;
    postalCode!: string | undefined;
    country!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    pickupName!: string | undefined;
    pickupAddressLine1!: string | undefined;
    pickupAddressLine2!: string | undefined;
    pickupPostalCode!: string | undefined;
    pickupCountry!: string | undefined;
    pickupCity!: string | undefined;
    pickupState!: string | undefined;
    orderNumber!: number | undefined;
    sortOrder!: number | undefined;
    orderTags!: OrderTagListDto[] | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;
    eta!: TimeSpan;
    displayRouteId!: boolean | undefined;

    constructor(data?: IControllerRoutePrintDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.routeCode = data["routeCode"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.driverName = data["driverName"];
            this.customer = data["customer"];
            this.deliveryAddressLine1 = data["deliveryAddressLine1"];
            this.deliveryAddressLine2 = data["deliveryAddressLine2"];
            this.postalCode = data["postalCode"];
            this.country = data["country"];
            this.city = data["city"];
            this.state = data["state"];
            this.pickupName = data["pickupName"];
            this.pickupAddressLine1 = data["pickupAddressLine1"];
            this.pickupAddressLine2 = data["pickupAddressLine2"];
            this.pickupPostalCode = data["pickupPostalCode"];
            this.pickupCountry = data["pickupCountry"];
            this.pickupCity = data["pickupCity"];
            this.pickupState = data["pickupState"];
            this.orderNumber = data["orderNumber"];
            this.sortOrder = data["sortOrder"];
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(OrderTagListDto.fromJS(item));
            }
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
            this.eta = data["eta"] ? TimeSpan.fromJS(data["eta"]) : <any>undefined;
            this.displayRouteId = data["displayRouteId"];
        }
    }

    static fromJS(data: any): ControllerRoutePrintDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRoutePrintDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["routeCode"] = this.routeCode;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["driverName"] = this.driverName;
        data["customer"] = this.customer;
        data["deliveryAddressLine1"] = this.deliveryAddressLine1;
        data["deliveryAddressLine2"] = this.deliveryAddressLine2;
        data["postalCode"] = this.postalCode;
        data["country"] = this.country;
        data["city"] = this.city;
        data["state"] = this.state;
        data["pickupName"] = this.pickupName;
        data["pickupAddressLine1"] = this.pickupAddressLine1;
        data["pickupAddressLine2"] = this.pickupAddressLine2;
        data["pickupPostalCode"] = this.pickupPostalCode;
        data["pickupCountry"] = this.pickupCountry;
        data["pickupCity"] = this.pickupCity;
        data["pickupState"] = this.pickupState;
        data["orderNumber"] = this.orderNumber;
        data["sortOrder"] = this.sortOrder;
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        data["eta"] = this.eta ? this.eta.toJSON() : <any>undefined;
        data["displayRouteId"] = this.displayRouteId;
        return data; 
    }
}

export interface IControllerRoutePrintDto {
    routeId: number | undefined;
    routeCode: string | undefined;
    loadDate: moment.Moment;
    driverName: string | undefined;
    customer: string | undefined;
    deliveryAddressLine1: string | undefined;
    deliveryAddressLine2: string | undefined;
    postalCode: string | undefined;
    country: string | undefined;
    city: string | undefined;
    state: string | undefined;
    pickupName: string | undefined;
    pickupAddressLine1: string | undefined;
    pickupAddressLine2: string | undefined;
    pickupPostalCode: string | undefined;
    pickupCountry: string | undefined;
    pickupCity: string | undefined;
    pickupState: string | undefined;
    orderNumber: number | undefined;
    sortOrder: number | undefined;
    orderTags: OrderTagListDto[] | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
    eta: TimeSpan;
    displayRouteId: boolean | undefined;
}

export class ControllerRoutePrintAllDto implements IControllerRoutePrintAllDto {
    routeId!: number | undefined;
    routeList!: ControllerRoutePrintDto[] | undefined;

    constructor(data?: IControllerRoutePrintAllDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            if (Array.isArray(data["routeList"])) {
                this.routeList = [] as any;
                for (let item of data["routeList"])
                    this.routeList!.push(ControllerRoutePrintDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ControllerRoutePrintAllDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRoutePrintAllDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        if (Array.isArray(this.routeList)) {
            data["routeList"] = [];
            for (let item of this.routeList)
                data["routeList"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IControllerRoutePrintAllDto {
    routeId: number | undefined;
    routeList: ControllerRoutePrintDto[] | undefined;
}

export class ControllerOrderExtraListDto implements IControllerOrderExtraListDto {
    orderId!: number;
    type!: string | undefined;
    value!: string | undefined;
    description!: string | undefined;

    constructor(data?: IControllerOrderExtraListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.type = data["type"];
            this.value = data["value"];
            this.description = data["description"];
        }
    }

    static fromJS(data: any): ControllerOrderExtraListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerOrderExtraListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["type"] = this.type;
        data["value"] = this.value;
        data["description"] = this.description;
        return data; 
    }
}

export interface IControllerOrderExtraListDto {
    orderId: number;
    type: string | undefined;
    value: string | undefined;
    description: string | undefined;
}

export class ControllerRouteSheetOrderListDto implements IControllerRouteSheetOrderListDto {
    orderId!: number;
    company!: string | undefined;
    acctNo!: string | undefined;
    orderType!: string | undefined;
    after!: moment.Moment;
    time!: moment.Moment | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;
    orderExtras!: ControllerOrderExtraListDto[] | undefined;
    lastStatus!: string | undefined;
    note!: string | undefined;
    clinicNote!: string | undefined;
    eta!: string | undefined;
    arriveTime!: string | undefined;
    pickUp!: boolean;
    sortOrder!: number | undefined;

    constructor(data?: IControllerRouteSheetOrderListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.company = data["company"];
            this.acctNo = data["acctNo"];
            this.orderType = data["orderType"];
            this.after = data["after"] ? moment(data["after"].toString()) : <any>undefined;
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
            if (Array.isArray(data["orderExtras"])) {
                this.orderExtras = [] as any;
                for (let item of data["orderExtras"])
                    this.orderExtras!.push(ControllerOrderExtraListDto.fromJS(item));
            }
            this.lastStatus = data["lastStatus"];
            this.note = data["note"];
            this.clinicNote = data["clinicNote"];
            this.eta = data["eta"];
            this.arriveTime = data["arriveTime"];
            this.pickUp = data["pickUp"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): ControllerRouteSheetOrderListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteSheetOrderListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["company"] = this.company;
        data["acctNo"] = this.acctNo;
        data["orderType"] = this.orderType;
        data["after"] = this.after ? this.after.toISOString() : <any>undefined;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.orderExtras)) {
            data["orderExtras"] = [];
            for (let item of this.orderExtras)
                data["orderExtras"].push(item.toJSON());
        }
        data["lastStatus"] = this.lastStatus;
        data["note"] = this.note;
        data["clinicNote"] = this.clinicNote;
        data["eta"] = this.eta;
        data["arriveTime"] = this.arriveTime;
        data["pickUp"] = this.pickUp;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IControllerRouteSheetOrderListDto {
    orderId: number;
    company: string | undefined;
    acctNo: string | undefined;
    orderType: string | undefined;
    after: moment.Moment;
    time: moment.Moment | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
    orderExtras: ControllerOrderExtraListDto[] | undefined;
    lastStatus: string | undefined;
    note: string | undefined;
    clinicNote: string | undefined;
    eta: string | undefined;
    arriveTime: string | undefined;
    pickUp: boolean;
    sortOrder: number | undefined;
}

export class GetControllerWillCallRouteSheetDto implements IGetControllerWillCallRouteSheetDto {
    clinicName!: string | undefined;
    clinicAcctNo!: string | undefined;
    after!: string | undefined;
    eta!: string | undefined;
    clinicNotes!: string | undefined;

    constructor(data?: IGetControllerWillCallRouteSheetDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicName = data["clinicName"];
            this.clinicAcctNo = data["clinicAcctNo"];
            this.after = data["after"];
            this.eta = data["eta"];
            this.clinicNotes = data["clinicNotes"];
        }
    }

    static fromJS(data: any): GetControllerWillCallRouteSheetDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetControllerWillCallRouteSheetDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicName"] = this.clinicName;
        data["clinicAcctNo"] = this.clinicAcctNo;
        data["after"] = this.after;
        data["eta"] = this.eta;
        data["clinicNotes"] = this.clinicNotes;
        return data; 
    }
}

export interface IGetControllerWillCallRouteSheetDto {
    clinicName: string | undefined;
    clinicAcctNo: string | undefined;
    after: string | undefined;
    eta: string | undefined;
    clinicNotes: string | undefined;
}

export class ControllerRouteSheetDto implements IControllerRouteSheetDto {
    routeId!: number | undefined;
    routeCode!: string | undefined;
    driverName!: string | undefined;
    loadDate!: string | undefined;
    orderList!: ControllerRouteSheetOrderListDto[] | undefined;
    willCallList!: GetControllerWillCallRouteSheetDto[] | undefined;

    constructor(data?: IControllerRouteSheetDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.routeCode = data["routeCode"];
            this.driverName = data["driverName"];
            this.loadDate = data["loadDate"];
            if (Array.isArray(data["orderList"])) {
                this.orderList = [] as any;
                for (let item of data["orderList"])
                    this.orderList!.push(ControllerRouteSheetOrderListDto.fromJS(item));
            }
            if (Array.isArray(data["willCallList"])) {
                this.willCallList = [] as any;
                for (let item of data["willCallList"])
                    this.willCallList!.push(GetControllerWillCallRouteSheetDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ControllerRouteSheetDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteSheetDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["routeCode"] = this.routeCode;
        data["driverName"] = this.driverName;
        data["loadDate"] = this.loadDate;
        if (Array.isArray(this.orderList)) {
            data["orderList"] = [];
            for (let item of this.orderList)
                data["orderList"].push(item.toJSON());
        }
        if (Array.isArray(this.willCallList)) {
            data["willCallList"] = [];
            for (let item of this.willCallList)
                data["willCallList"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IControllerRouteSheetDto {
    routeId: number | undefined;
    routeCode: string | undefined;
    driverName: string | undefined;
    loadDate: string | undefined;
    orderList: ControllerRouteSheetOrderListDto[] | undefined;
    willCallList: GetControllerWillCallRouteSheetDto[] | undefined;
}

export class RouteSchedAutosList implements IRouteSchedAutosList {
    accountNumber!: string | undefined;
    customerName!: string | undefined;
    phoneNumber!: string | undefined;
    addresses!: string | undefined;
    eta!: string | undefined;
    etAs!: TimeSpan | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;
    sortOrder!: number;

    constructor(data?: IRouteSchedAutosList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accountNumber = data["accountNumber"];
            this.customerName = data["customerName"];
            this.phoneNumber = data["phoneNumber"];
            this.addresses = data["addresses"];
            this.eta = data["eta"];
            this.etAs = data["etAs"] ? TimeSpan.fromJS(data["etAs"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): RouteSchedAutosList {
        data = typeof data === 'object' ? data : {};
        let result = new RouteSchedAutosList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accountNumber"] = this.accountNumber;
        data["customerName"] = this.customerName;
        data["phoneNumber"] = this.phoneNumber;
        data["addresses"] = this.addresses;
        data["eta"] = this.eta;
        data["etAs"] = this.etAs ? this.etAs.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IRouteSchedAutosList {
    accountNumber: string | undefined;
    customerName: string | undefined;
    phoneNumber: string | undefined;
    addresses: string | undefined;
    eta: string | undefined;
    etAs: TimeSpan | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
    sortOrder: number;
}

export class RouteSchedWillCallList implements IRouteSchedWillCallList {
    accountNumber!: string | undefined;
    customerName!: string | undefined;
    phoneNumber!: string | undefined;
    addresses!: string | undefined;
    eta!: string | undefined;
    etAs!: TimeSpan | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;

    constructor(data?: IRouteSchedWillCallList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accountNumber = data["accountNumber"];
            this.customerName = data["customerName"];
            this.phoneNumber = data["phoneNumber"];
            this.addresses = data["addresses"];
            this.eta = data["eta"];
            this.etAs = data["etAs"] ? TimeSpan.fromJS(data["etAs"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): RouteSchedWillCallList {
        data = typeof data === 'object' ? data : {};
        let result = new RouteSchedWillCallList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accountNumber"] = this.accountNumber;
        data["customerName"] = this.customerName;
        data["phoneNumber"] = this.phoneNumber;
        data["addresses"] = this.addresses;
        data["eta"] = this.eta;
        data["etAs"] = this.etAs ? this.etAs.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IRouteSchedWillCallList {
    accountNumber: string | undefined;
    customerName: string | undefined;
    phoneNumber: string | undefined;
    addresses: string | undefined;
    eta: string | undefined;
    etAs: TimeSpan | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
}

export class HandOffContainers implements IHandOffContainers {
    name!: string | undefined;
    quantity!: number;

    constructor(data?: IHandOffContainers) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): HandOffContainers {
        data = typeof data === 'object' ? data : {};
        let result = new HandOffContainers();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface IHandOffContainers {
    name: string | undefined;
    quantity: number;
}

export class RouteSchedLineHaulList implements IRouteSchedLineHaulList {
    accountNumber!: string | undefined;
    customerName!: string | undefined;
    phoneNumber!: string | undefined;
    addresses!: string | undefined;
    eta!: string | undefined;
    etAs!: TimeSpan | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;
    container!: HandOffContainers[] | undefined;
    sortOrder!: number;

    constructor(data?: IRouteSchedLineHaulList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accountNumber = data["accountNumber"];
            this.customerName = data["customerName"];
            this.phoneNumber = data["phoneNumber"];
            this.addresses = data["addresses"];
            this.eta = data["eta"];
            this.etAs = data["etAs"] ? TimeSpan.fromJS(data["etAs"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
            if (Array.isArray(data["container"])) {
                this.container = [] as any;
                for (let item of data["container"])
                    this.container!.push(HandOffContainers.fromJS(item));
            }
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): RouteSchedLineHaulList {
        data = typeof data === 'object' ? data : {};
        let result = new RouteSchedLineHaulList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accountNumber"] = this.accountNumber;
        data["customerName"] = this.customerName;
        data["phoneNumber"] = this.phoneNumber;
        data["addresses"] = this.addresses;
        data["eta"] = this.eta;
        data["etAs"] = this.etAs ? this.etAs.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.container)) {
            data["container"] = [];
            for (let item of this.container)
                data["container"].push(item.toJSON());
        }
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IRouteSchedLineHaulList {
    accountNumber: string | undefined;
    customerName: string | undefined;
    phoneNumber: string | undefined;
    addresses: string | undefined;
    eta: string | undefined;
    etAs: TimeSpan | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
    container: HandOffContainers[] | undefined;
    sortOrder: number;
}

export class HandOffList implements IHandOffList {
    routeCode!: string | undefined;
    routeSchedLineHaulList!: RouteSchedLineHaulList[] | undefined;

    constructor(data?: IHandOffList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeCode = data["routeCode"];
            if (Array.isArray(data["routeSchedLineHaulList"])) {
                this.routeSchedLineHaulList = [] as any;
                for (let item of data["routeSchedLineHaulList"])
                    this.routeSchedLineHaulList!.push(RouteSchedLineHaulList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): HandOffList {
        data = typeof data === 'object' ? data : {};
        let result = new HandOffList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeCode"] = this.routeCode;
        if (Array.isArray(this.routeSchedLineHaulList)) {
            data["routeSchedLineHaulList"] = [];
            for (let item of this.routeSchedLineHaulList)
                data["routeSchedLineHaulList"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IHandOffList {
    routeCode: string | undefined;
    routeSchedLineHaulList: RouteSchedLineHaulList[] | undefined;
}

export class RouteSheetList implements IRouteSheetList {
    routeCode!: string | undefined;
    routeSchedAutosList!: RouteSchedAutosList[] | undefined;
    routeSchedWillCallList!: RouteSchedWillCallList[] | undefined;
    handOffList!: HandOffList[] | undefined;
    loadDate!: string | undefined;
    location!: string | undefined;

    constructor(data?: IRouteSheetList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeCode = data["routeCode"];
            if (Array.isArray(data["routeSchedAutosList"])) {
                this.routeSchedAutosList = [] as any;
                for (let item of data["routeSchedAutosList"])
                    this.routeSchedAutosList!.push(RouteSchedAutosList.fromJS(item));
            }
            if (Array.isArray(data["routeSchedWillCallList"])) {
                this.routeSchedWillCallList = [] as any;
                for (let item of data["routeSchedWillCallList"])
                    this.routeSchedWillCallList!.push(RouteSchedWillCallList.fromJS(item));
            }
            if (Array.isArray(data["handOffList"])) {
                this.handOffList = [] as any;
                for (let item of data["handOffList"])
                    this.handOffList!.push(HandOffList.fromJS(item));
            }
            this.loadDate = data["loadDate"];
            this.location = data["location"];
        }
    }

    static fromJS(data: any): RouteSheetList {
        data = typeof data === 'object' ? data : {};
        let result = new RouteSheetList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeCode"] = this.routeCode;
        if (Array.isArray(this.routeSchedAutosList)) {
            data["routeSchedAutosList"] = [];
            for (let item of this.routeSchedAutosList)
                data["routeSchedAutosList"].push(item.toJSON());
        }
        if (Array.isArray(this.routeSchedWillCallList)) {
            data["routeSchedWillCallList"] = [];
            for (let item of this.routeSchedWillCallList)
                data["routeSchedWillCallList"].push(item.toJSON());
        }
        if (Array.isArray(this.handOffList)) {
            data["handOffList"] = [];
            for (let item of this.handOffList)
                data["handOffList"].push(item.toJSON());
        }
        data["loadDate"] = this.loadDate;
        data["location"] = this.location;
        return data; 
    }
}

export interface IRouteSheetList {
    routeCode: string | undefined;
    routeSchedAutosList: RouteSchedAutosList[] | undefined;
    routeSchedWillCallList: RouteSchedWillCallList[] | undefined;
    handOffList: HandOffList[] | undefined;
    loadDate: string | undefined;
    location: string | undefined;
}

export class ControllerRemainingPickupListDto implements IControllerRemainingPickupListDto {
    routeId!: number | undefined;
    orderPackageId!: number;
    recipientName!: string | undefined;
    recipientAddress1!: string | undefined;
    recipientAddress2!: string | undefined;
    recipientCountry!: string | undefined;
    recipientCity!: string | undefined;
    recipientState!: string | undefined;
    recipientZip!: string | undefined;
    senderName!: string | undefined;
    orderStatus!: string | undefined;
    orderId!: number;

    constructor(data?: IControllerRemainingPickupListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.orderPackageId = data["orderPackageId"];
            this.recipientName = data["recipientName"];
            this.recipientAddress1 = data["recipientAddress1"];
            this.recipientAddress2 = data["recipientAddress2"];
            this.recipientCountry = data["recipientCountry"];
            this.recipientCity = data["recipientCity"];
            this.recipientState = data["recipientState"];
            this.recipientZip = data["recipientZip"];
            this.senderName = data["senderName"];
            this.orderStatus = data["orderStatus"];
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): ControllerRemainingPickupListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRemainingPickupListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["orderPackageId"] = this.orderPackageId;
        data["recipientName"] = this.recipientName;
        data["recipientAddress1"] = this.recipientAddress1;
        data["recipientAddress2"] = this.recipientAddress2;
        data["recipientCountry"] = this.recipientCountry;
        data["recipientCity"] = this.recipientCity;
        data["recipientState"] = this.recipientState;
        data["recipientZip"] = this.recipientZip;
        data["senderName"] = this.senderName;
        data["orderStatus"] = this.orderStatus;
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface IControllerRemainingPickupListDto {
    routeId: number | undefined;
    orderPackageId: number;
    recipientName: string | undefined;
    recipientAddress1: string | undefined;
    recipientAddress2: string | undefined;
    recipientCountry: string | undefined;
    recipientCity: string | undefined;
    recipientState: string | undefined;
    recipientZip: string | undefined;
    senderName: string | undefined;
    orderStatus: string | undefined;
    orderId: number;
}

export class PagedResultDtoOfControllerRemainingPickupListDto implements IPagedResultDtoOfControllerRemainingPickupListDto {
    totalCount!: number;
    items!: ControllerRemainingPickupListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfControllerRemainingPickupListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ControllerRemainingPickupListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfControllerRemainingPickupListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfControllerRemainingPickupListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfControllerRemainingPickupListDto {
    totalCount: number;
    items: ControllerRemainingPickupListDto[] | undefined;
}

export class GetControllerMobileInput implements IGetControllerMobileInput {
    userIds!: number[] | undefined;
    startTime!: moment.Moment;
    endTime!: moment.Moment;
    endTime2!: moment.Moment;

    constructor(data?: IGetControllerMobileInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["userIds"])) {
                this.userIds = [] as any;
                for (let item of data["userIds"])
                    this.userIds!.push(item);
            }
            this.startTime = data["startTime"] ? moment(data["startTime"].toString()) : <any>undefined;
            this.endTime = data["endTime"] ? moment(data["endTime"].toString()) : <any>undefined;
            this.endTime2 = data["endTime2"] ? moment(data["endTime2"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetControllerMobileInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetControllerMobileInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.userIds)) {
            data["userIds"] = [];
            for (let item of this.userIds)
                data["userIds"].push(item);
        }
        data["startTime"] = this.startTime ? this.startTime.toISOString() : <any>undefined;
        data["endTime"] = this.endTime ? this.endTime.toISOString() : <any>undefined;
        data["endTime2"] = this.endTime2 ? this.endTime2.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetControllerMobileInput {
    userIds: number[] | undefined;
    startTime: moment.Moment;
    endTime: moment.Moment;
    endTime2: moment.Moment;
}

export class ControllerMobileListDto implements IControllerMobileListDto {
    devicesId!: number;
    creatorUserId!: number | undefined;
    creatorTime!: moment.Moment;
    osName!: string | undefined;
    osVersion!: string | undefined;
    deviceModel!: string | undefined;
    appVersion!: number;
    driverStatus!: string | undefined;
    minimumVersion!: number;

    constructor(data?: IControllerMobileListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.devicesId = data["devicesId"];
            this.creatorUserId = data["creatorUserId"];
            this.creatorTime = data["creatorTime"] ? moment(data["creatorTime"].toString()) : <any>undefined;
            this.osName = data["osName"];
            this.osVersion = data["osVersion"];
            this.deviceModel = data["deviceModel"];
            this.appVersion = data["appVersion"];
            this.driverStatus = data["driverStatus"];
            this.minimumVersion = data["minimumVersion"];
        }
    }

    static fromJS(data: any): ControllerMobileListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerMobileListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["devicesId"] = this.devicesId;
        data["creatorUserId"] = this.creatorUserId;
        data["creatorTime"] = this.creatorTime ? this.creatorTime.toISOString() : <any>undefined;
        data["osName"] = this.osName;
        data["osVersion"] = this.osVersion;
        data["deviceModel"] = this.deviceModel;
        data["appVersion"] = this.appVersion;
        data["driverStatus"] = this.driverStatus;
        data["minimumVersion"] = this.minimumVersion;
        return data; 
    }
}

export interface IControllerMobileListDto {
    devicesId: number;
    creatorUserId: number | undefined;
    creatorTime: moment.Moment;
    osName: string | undefined;
    osVersion: string | undefined;
    deviceModel: string | undefined;
    appVersion: number;
    driverStatus: string | undefined;
    minimumVersion: number;
}

export class GetManagerResult implements IGetManagerResult {
    managerId!: number | undefined;
    managerFullName!: string | undefined;
    email!: string | undefined;

    constructor(data?: IGetManagerResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.managerId = data["managerId"];
            this.managerFullName = data["managerFullName"];
            this.email = data["email"];
        }
    }

    static fromJS(data: any): GetManagerResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetManagerResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["managerId"] = this.managerId;
        data["managerFullName"] = this.managerFullName;
        data["email"] = this.email;
        return data; 
    }
}

export interface IGetManagerResult {
    managerId: number | undefined;
    managerFullName: string | undefined;
    email: string | undefined;
}

export class RouteFreezeListDto implements IRouteFreezeListDto {
    userID!: number | undefined;
    user!: string | undefined;
    reason!: string | undefined;
    cutoffAdjustments!: number | undefined;

    constructor(data?: IRouteFreezeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userID = data["userID"];
            this.user = data["user"];
            this.reason = data["reason"];
            this.cutoffAdjustments = data["cutoffAdjustments"];
        }
    }

    static fromJS(data: any): RouteFreezeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteFreezeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userID"] = this.userID;
        data["user"] = this.user;
        data["reason"] = this.reason;
        data["cutoffAdjustments"] = this.cutoffAdjustments;
        return data; 
    }
}

export interface IRouteFreezeListDto {
    userID: number | undefined;
    user: string | undefined;
    reason: string | undefined;
    cutoffAdjustments: number | undefined;
}

export class ControllerRouteCountsLaboratoryEditionDto implements IControllerRouteCountsLaboratoryEditionDto {
    packageId!: number;
    routeId!: number | undefined;
    packageDescription!: string | undefined;
    totalPackages!: number;

    constructor(data?: IControllerRouteCountsLaboratoryEditionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.packageId = data["packageId"];
            this.routeId = data["routeId"];
            this.packageDescription = data["packageDescription"];
            this.totalPackages = data["totalPackages"];
        }
    }

    static fromJS(data: any): ControllerRouteCountsLaboratoryEditionDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteCountsLaboratoryEditionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["packageId"] = this.packageId;
        data["routeId"] = this.routeId;
        data["packageDescription"] = this.packageDescription;
        data["totalPackages"] = this.totalPackages;
        return data; 
    }
}

export interface IControllerRouteCountsLaboratoryEditionDto {
    packageId: number;
    routeId: number | undefined;
    packageDescription: string | undefined;
    totalPackages: number;
}

export class ParentRouteListDto implements IParentRouteListDto {
    routeId!: number | undefined;
    routeCode!: string | undefined;
    sortOrder!: number;
    location!: string | undefined;
    locationId!: number;

    constructor(data?: IParentRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.routeCode = data["routeCode"];
            this.sortOrder = data["sortOrder"];
            this.location = data["location"];
            this.locationId = data["locationId"];
        }
    }

    static fromJS(data: any): ParentRouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ParentRouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["routeCode"] = this.routeCode;
        data["sortOrder"] = this.sortOrder;
        data["location"] = this.location;
        data["locationId"] = this.locationId;
        return data; 
    }
}

export interface IParentRouteListDto {
    routeId: number | undefined;
    routeCode: string | undefined;
    sortOrder: number;
    location: string | undefined;
    locationId: number;
}

export class LHStop implements ILHStop {
    locationId!: number | undefined;
    name!: string | undefined;

    constructor(data?: ILHStop) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): LHStop {
        data = typeof data === 'object' ? data : {};
        let result = new LHStop();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["name"] = this.name;
        return data; 
    }
}

export interface ILHStop {
    locationId: number | undefined;
    name: string | undefined;
}

export class ControllerRouteListDto implements IControllerRouteListDto {
    routeId!: number | undefined;
    userId!: number | undefined;
    loadDate!: moment.Moment;
    locked!: boolean;
    completion!: moment.Moment | undefined;
    departure!: moment.Moment | undefined;
    blindCode!: string | undefined;
    handOffBlindCode!: string | undefined;
    lastModifierUserId!: number | undefined;
    freeze!: boolean;
    cutoffAdjustment!: number | undefined;
    driverId!: number | undefined;
    vehicleId!: number | undefined;
    vehicleName!: string | undefined;
    licenseNumber!: string | undefined;
    fullName!: string | undefined;
    deviceVersion!: string | undefined;
    deviceType!: string | undefined;
    driverStatus!: string | undefined;
    currentVersion!: string | undefined;
    locationName!: string | undefined;
    locationId!: number;
    routeTemplateName!: string | undefined;
    eta!: string | undefined;
    targetTimeString!: string | undefined;
    targetTimezoneString!: string | undefined;
    selectedRoute!: boolean;
    completionString!: string | undefined;
    departureString!: string | undefined;
    orderTypes!: string[] | undefined;
    sortOrder!: number | undefined;
    currentDateTime!: string | undefined;
    loadLimit!: number | undefined;
    routeTypeId!: number | undefined;
    routeTypeDescription!: string | undefined;
    displayColor!: string | undefined;
    bcVerifierId!: number | undefined;
    totalMileage!: number;
    totalDeliveredPackages!: string | undefined;
    routeNull!: boolean;
    proximity!: string | undefined;
    zeroCountCode!: string | undefined;
    totalCountPackages!: string | undefined;
    totalLineHaulWaitingPickupContainers!: string | undefined;
    totalLineHaulPickedupContainers!: string | undefined;
    totalLineHaulDeliveredContainers!: string | undefined;
    countPerPackage!: ControllerRouteCountsLaboratoryEditionDto[] | undefined;
    statusDescription!: string | undefined;
    statusIcon!: string | undefined;
    statusColor!: string | undefined;
    totalStops!: number;
    totalPickedUp!: number;
    totalCallIn!: number;
    totalCallInPickedUp!: number;
    parentRoute!: ParentRouteListDto | undefined;
    zone!: string | undefined;
    zoneList!: string[] | undefined;
    completePercentage!: string | undefined;
    handOffCode!: string | undefined;
    color!: string | undefined;
    layer!: number | undefined;
    inactiveDriver!: boolean;
    loginEarly!: boolean;
    endPointLocation!: LHStop | undefined;
    isBoxLimit!: boolean;
    displayRouteId!: boolean;

    constructor(data?: IControllerRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.userId = data["userId"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.locked = data["locked"];
            this.completion = data["completion"] ? moment(data["completion"].toString()) : <any>undefined;
            this.departure = data["departure"] ? moment(data["departure"].toString()) : <any>undefined;
            this.blindCode = data["blindCode"];
            this.handOffBlindCode = data["handOffBlindCode"];
            this.lastModifierUserId = data["lastModifierUserId"];
            this.freeze = data["freeze"];
            this.cutoffAdjustment = data["cutoffAdjustment"];
            this.driverId = data["driverId"];
            this.vehicleId = data["vehicleId"];
            this.vehicleName = data["vehicleName"];
            this.licenseNumber = data["licenseNumber"];
            this.fullName = data["fullName"];
            this.deviceVersion = data["deviceVersion"];
            this.deviceType = data["deviceType"];
            this.driverStatus = data["driverStatus"];
            this.currentVersion = data["currentVersion"];
            this.locationName = data["locationName"];
            this.locationId = data["locationId"];
            this.routeTemplateName = data["routeTemplateName"];
            this.eta = data["eta"];
            this.targetTimeString = data["targetTimeString"];
            this.targetTimezoneString = data["targetTimezoneString"];
            this.selectedRoute = data["selectedRoute"];
            this.completionString = data["completionString"];
            this.departureString = data["departureString"];
            if (Array.isArray(data["orderTypes"])) {
                this.orderTypes = [] as any;
                for (let item of data["orderTypes"])
                    this.orderTypes!.push(item);
            }
            this.sortOrder = data["sortOrder"];
            this.currentDateTime = data["currentDateTime"];
            this.loadLimit = data["loadLimit"];
            this.routeTypeId = data["routeTypeId"];
            this.routeTypeDescription = data["routeTypeDescription"];
            this.displayColor = data["displayColor"];
            this.bcVerifierId = data["bcVerifierId"];
            this.totalMileage = data["totalMileage"];
            this.totalDeliveredPackages = data["totalDeliveredPackages"];
            this.routeNull = data["routeNull"];
            this.proximity = data["proximity"];
            this.zeroCountCode = data["zeroCountCode"];
            this.totalCountPackages = data["totalCountPackages"];
            this.totalLineHaulWaitingPickupContainers = data["totalLineHaulWaitingPickupContainers"];
            this.totalLineHaulPickedupContainers = data["totalLineHaulPickedupContainers"];
            this.totalLineHaulDeliveredContainers = data["totalLineHaulDeliveredContainers"];
            if (Array.isArray(data["countPerPackage"])) {
                this.countPerPackage = [] as any;
                for (let item of data["countPerPackage"])
                    this.countPerPackage!.push(ControllerRouteCountsLaboratoryEditionDto.fromJS(item));
            }
            this.statusDescription = data["statusDescription"];
            this.statusIcon = data["statusIcon"];
            this.statusColor = data["statusColor"];
            this.totalStops = data["totalStops"];
            this.totalPickedUp = data["totalPickedUp"];
            this.totalCallIn = data["totalCallIn"];
            this.totalCallInPickedUp = data["totalCallInPickedUp"];
            this.parentRoute = data["parentRoute"] ? ParentRouteListDto.fromJS(data["parentRoute"]) : <any>undefined;
            this.zone = data["zone"];
            if (Array.isArray(data["zoneList"])) {
                this.zoneList = [] as any;
                for (let item of data["zoneList"])
                    this.zoneList!.push(item);
            }
            this.completePercentage = data["completePercentage"];
            this.handOffCode = data["handOffCode"];
            this.color = data["color"];
            this.layer = data["layer"];
            this.inactiveDriver = data["inactiveDriver"];
            this.loginEarly = data["loginEarly"];
            this.endPointLocation = data["endPointLocation"] ? LHStop.fromJS(data["endPointLocation"]) : <any>undefined;
            this.isBoxLimit = data["isBoxLimit"];
            this.displayRouteId = data["displayRouteId"];
        }
    }

    static fromJS(data: any): ControllerRouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["userId"] = this.userId;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["locked"] = this.locked;
        data["completion"] = this.completion ? this.completion.toISOString() : <any>undefined;
        data["departure"] = this.departure ? this.departure.toISOString() : <any>undefined;
        data["blindCode"] = this.blindCode;
        data["handOffBlindCode"] = this.handOffBlindCode;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["freeze"] = this.freeze;
        data["cutoffAdjustment"] = this.cutoffAdjustment;
        data["driverId"] = this.driverId;
        data["vehicleId"] = this.vehicleId;
        data["vehicleName"] = this.vehicleName;
        data["licenseNumber"] = this.licenseNumber;
        data["fullName"] = this.fullName;
        data["deviceVersion"] = this.deviceVersion;
        data["deviceType"] = this.deviceType;
        data["driverStatus"] = this.driverStatus;
        data["currentVersion"] = this.currentVersion;
        data["locationName"] = this.locationName;
        data["locationId"] = this.locationId;
        data["routeTemplateName"] = this.routeTemplateName;
        data["eta"] = this.eta;
        data["targetTimeString"] = this.targetTimeString;
        data["targetTimezoneString"] = this.targetTimezoneString;
        data["selectedRoute"] = this.selectedRoute;
        data["completionString"] = this.completionString;
        data["departureString"] = this.departureString;
        if (Array.isArray(this.orderTypes)) {
            data["orderTypes"] = [];
            for (let item of this.orderTypes)
                data["orderTypes"].push(item);
        }
        data["sortOrder"] = this.sortOrder;
        data["currentDateTime"] = this.currentDateTime;
        data["loadLimit"] = this.loadLimit;
        data["routeTypeId"] = this.routeTypeId;
        data["routeTypeDescription"] = this.routeTypeDescription;
        data["displayColor"] = this.displayColor;
        data["bcVerifierId"] = this.bcVerifierId;
        data["totalMileage"] = this.totalMileage;
        data["totalDeliveredPackages"] = this.totalDeliveredPackages;
        data["routeNull"] = this.routeNull;
        data["proximity"] = this.proximity;
        data["zeroCountCode"] = this.zeroCountCode;
        data["totalCountPackages"] = this.totalCountPackages;
        data["totalLineHaulWaitingPickupContainers"] = this.totalLineHaulWaitingPickupContainers;
        data["totalLineHaulPickedupContainers"] = this.totalLineHaulPickedupContainers;
        data["totalLineHaulDeliveredContainers"] = this.totalLineHaulDeliveredContainers;
        if (Array.isArray(this.countPerPackage)) {
            data["countPerPackage"] = [];
            for (let item of this.countPerPackage)
                data["countPerPackage"].push(item.toJSON());
        }
        data["statusDescription"] = this.statusDescription;
        data["statusIcon"] = this.statusIcon;
        data["statusColor"] = this.statusColor;
        data["totalStops"] = this.totalStops;
        data["totalPickedUp"] = this.totalPickedUp;
        data["totalCallIn"] = this.totalCallIn;
        data["totalCallInPickedUp"] = this.totalCallInPickedUp;
        data["parentRoute"] = this.parentRoute ? this.parentRoute.toJSON() : <any>undefined;
        data["zone"] = this.zone;
        if (Array.isArray(this.zoneList)) {
            data["zoneList"] = [];
            for (let item of this.zoneList)
                data["zoneList"].push(item);
        }
        data["completePercentage"] = this.completePercentage;
        data["handOffCode"] = this.handOffCode;
        data["color"] = this.color;
        data["layer"] = this.layer;
        data["inactiveDriver"] = this.inactiveDriver;
        data["loginEarly"] = this.loginEarly;
        data["endPointLocation"] = this.endPointLocation ? this.endPointLocation.toJSON() : <any>undefined;
        data["isBoxLimit"] = this.isBoxLimit;
        data["displayRouteId"] = this.displayRouteId;
        return data; 
    }
}

export interface IControllerRouteListDto {
    routeId: number | undefined;
    userId: number | undefined;
    loadDate: moment.Moment;
    locked: boolean;
    completion: moment.Moment | undefined;
    departure: moment.Moment | undefined;
    blindCode: string | undefined;
    handOffBlindCode: string | undefined;
    lastModifierUserId: number | undefined;
    freeze: boolean;
    cutoffAdjustment: number | undefined;
    driverId: number | undefined;
    vehicleId: number | undefined;
    vehicleName: string | undefined;
    licenseNumber: string | undefined;
    fullName: string | undefined;
    deviceVersion: string | undefined;
    deviceType: string | undefined;
    driverStatus: string | undefined;
    currentVersion: string | undefined;
    locationName: string | undefined;
    locationId: number;
    routeTemplateName: string | undefined;
    eta: string | undefined;
    targetTimeString: string | undefined;
    targetTimezoneString: string | undefined;
    selectedRoute: boolean;
    completionString: string | undefined;
    departureString: string | undefined;
    orderTypes: string[] | undefined;
    sortOrder: number | undefined;
    currentDateTime: string | undefined;
    loadLimit: number | undefined;
    routeTypeId: number | undefined;
    routeTypeDescription: string | undefined;
    displayColor: string | undefined;
    bcVerifierId: number | undefined;
    totalMileage: number;
    totalDeliveredPackages: string | undefined;
    routeNull: boolean;
    proximity: string | undefined;
    zeroCountCode: string | undefined;
    totalCountPackages: string | undefined;
    totalLineHaulWaitingPickupContainers: string | undefined;
    totalLineHaulPickedupContainers: string | undefined;
    totalLineHaulDeliveredContainers: string | undefined;
    countPerPackage: ControllerRouteCountsLaboratoryEditionDto[] | undefined;
    statusDescription: string | undefined;
    statusIcon: string | undefined;
    statusColor: string | undefined;
    totalStops: number;
    totalPickedUp: number;
    totalCallIn: number;
    totalCallInPickedUp: number;
    parentRoute: ParentRouteListDto | undefined;
    zone: string | undefined;
    zoneList: string[] | undefined;
    completePercentage: string | undefined;
    handOffCode: string | undefined;
    color: string | undefined;
    layer: number | undefined;
    inactiveDriver: boolean;
    loginEarly: boolean;
    endPointLocation: LHStop | undefined;
    isBoxLimit: boolean;
    displayRouteId: boolean;
}

export class CloseRouteInput implements ICloseRouteInput {
    routeId!: number;

    constructor(data?: ICloseRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): CloseRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new CloseRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface ICloseRouteInput {
    routeId: number;
}

export class ControllerRouteTypeListGroupDto implements IControllerRouteTypeListGroupDto {
    routeTypeId!: number | undefined;
    locationId!: number | undefined;
    routeType!: string | undefined;
    routeTypeColor!: string | undefined;
    routeTypeSort!: number | undefined;
    routeListDetails!: ControllerRouteListDto[] | undefined;

    constructor(data?: IControllerRouteTypeListGroupDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTypeId = data["routeTypeId"];
            this.locationId = data["locationId"];
            this.routeType = data["routeType"];
            this.routeTypeColor = data["routeTypeColor"];
            this.routeTypeSort = data["routeTypeSort"];
            if (Array.isArray(data["routeListDetails"])) {
                this.routeListDetails = [] as any;
                for (let item of data["routeListDetails"])
                    this.routeListDetails!.push(ControllerRouteListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ControllerRouteTypeListGroupDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteTypeListGroupDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTypeId"] = this.routeTypeId;
        data["locationId"] = this.locationId;
        data["routeType"] = this.routeType;
        data["routeTypeColor"] = this.routeTypeColor;
        data["routeTypeSort"] = this.routeTypeSort;
        if (Array.isArray(this.routeListDetails)) {
            data["routeListDetails"] = [];
            for (let item of this.routeListDetails)
                data["routeListDetails"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IControllerRouteTypeListGroupDto {
    routeTypeId: number | undefined;
    locationId: number | undefined;
    routeType: string | undefined;
    routeTypeColor: string | undefined;
    routeTypeSort: number | undefined;
    routeListDetails: ControllerRouteListDto[] | undefined;
}

export class GetControllerPostalCodeZoneListListDto implements IGetControllerPostalCodeZoneListListDto {
    zoneId!: number;
    routeId!: number | undefined;

    constructor(data?: IGetControllerPostalCodeZoneListListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.zoneId = data["zoneId"];
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): GetControllerPostalCodeZoneListListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetControllerPostalCodeZoneListListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["zoneId"] = this.zoneId;
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface IGetControllerPostalCodeZoneListListDto {
    zoneId: number;
    routeId: number | undefined;
}

export class ControllerRouteStatusDto implements IControllerRouteStatusDto {
    totalPackages!: number;
    routeId!: number | undefined;
    statusCode!: string | undefined;
    orderStatusId!: number;
    orderId!: number;
    orderStatusTypeId!: number;
    totalDelivered!: number;
    zoneIds!: GetControllerPostalCodeZoneListListDto[] | undefined;

    constructor(data?: IControllerRouteStatusDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            this.routeId = data["routeId"];
            this.statusCode = data["statusCode"];
            this.orderStatusId = data["orderStatusId"];
            this.orderId = data["orderId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.totalDelivered = data["totalDelivered"];
            if (Array.isArray(data["zoneIds"])) {
                this.zoneIds = [] as any;
                for (let item of data["zoneIds"])
                    this.zoneIds!.push(GetControllerPostalCodeZoneListListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ControllerRouteStatusDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteStatusDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        data["routeId"] = this.routeId;
        data["statusCode"] = this.statusCode;
        data["orderStatusId"] = this.orderStatusId;
        data["orderId"] = this.orderId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["totalDelivered"] = this.totalDelivered;
        if (Array.isArray(this.zoneIds)) {
            data["zoneIds"] = [];
            for (let item of this.zoneIds)
                data["zoneIds"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IControllerRouteStatusDto {
    totalPackages: number;
    routeId: number | undefined;
    statusCode: string | undefined;
    orderStatusId: number;
    orderId: number;
    orderStatusTypeId: number;
    totalDelivered: number;
    zoneIds: GetControllerPostalCodeZoneListListDto[] | undefined;
}

export class ControllerProximityList implements IControllerProximityList {
    orderId!: number;
    routeId!: number | undefined;
    proximityCode!: string | undefined;
    proximityCodeId!: number;

    constructor(data?: IControllerProximityList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.routeId = data["routeId"];
            this.proximityCode = data["proximityCode"];
            this.proximityCodeId = data["proximityCodeId"];
        }
    }

    static fromJS(data: any): ControllerProximityList {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerProximityList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["routeId"] = this.routeId;
        data["proximityCode"] = this.proximityCode;
        data["proximityCodeId"] = this.proximityCodeId;
        return data; 
    }
}

export interface IControllerProximityList {
    orderId: number;
    routeId: number | undefined;
    proximityCode: string | undefined;
    proximityCodeId: number;
}

export class ControllerZeroCountCode implements IControllerZeroCountCode {
    orderId!: number;
    routeId!: number | undefined;
    zeroCountCode!: string | undefined;

    constructor(data?: IControllerZeroCountCode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.routeId = data["routeId"];
            this.zeroCountCode = data["zeroCountCode"];
        }
    }

    static fromJS(data: any): ControllerZeroCountCode {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerZeroCountCode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["routeId"] = this.routeId;
        data["zeroCountCode"] = this.zeroCountCode;
        return data; 
    }
}

export interface IControllerZeroCountCode {
    orderId: number;
    routeId: number | undefined;
    zeroCountCode: string | undefined;
}

export class ControllerProximity implements IControllerProximity {
    proximity!: ControllerProximityList[] | undefined;
    zeroCountCode!: ControllerZeroCountCode[] | undefined;

    constructor(data?: IControllerProximity) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["proximity"])) {
                this.proximity = [] as any;
                for (let item of data["proximity"])
                    this.proximity!.push(ControllerProximityList.fromJS(item));
            }
            if (Array.isArray(data["zeroCountCode"])) {
                this.zeroCountCode = [] as any;
                for (let item of data["zeroCountCode"])
                    this.zeroCountCode!.push(ControllerZeroCountCode.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ControllerProximity {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerProximity();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.proximity)) {
            data["proximity"] = [];
            for (let item of this.proximity)
                data["proximity"].push(item.toJSON());
        }
        if (Array.isArray(this.zeroCountCode)) {
            data["zeroCountCode"] = [];
            for (let item of this.zeroCountCode)
                data["zeroCountCode"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IControllerProximity {
    proximity: ControllerProximityList[] | undefined;
    zeroCountCode: ControllerZeroCountCode[] | undefined;
}

export class ControllerRouteCountsLineHaulLaboratoryEditionDto implements IControllerRouteCountsLineHaulLaboratoryEditionDto {
    packageId!: number;
    routeId!: number | undefined;
    packageDescription!: string | undefined;
    quantity!: number;

    constructor(data?: IControllerRouteCountsLineHaulLaboratoryEditionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.packageId = data["packageId"];
            this.routeId = data["routeId"];
            this.packageDescription = data["packageDescription"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): ControllerRouteCountsLineHaulLaboratoryEditionDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteCountsLineHaulLaboratoryEditionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["packageId"] = this.packageId;
        data["routeId"] = this.routeId;
        data["packageDescription"] = this.packageDescription;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface IControllerRouteCountsLineHaulLaboratoryEditionDto {
    packageId: number;
    routeId: number | undefined;
    packageDescription: string | undefined;
    quantity: number;
}

export class ControllerRouteOrderList implements IControllerRouteOrderList {
    routeId!: number | undefined;
    orderId!: number;

    constructor(data?: IControllerRouteOrderList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): ControllerRouteOrderList {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteOrderList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface IControllerRouteOrderList {
    routeId: number | undefined;
    orderId: number;
}

export class GetControllerCallInInputDto implements IGetControllerCallInInputDto {
    orderIds!: number[] | undefined;
    orderTypeIds!: number[] | undefined;
    editions!: string | undefined;
    routeOrders!: ControllerRouteOrderList[] | undefined;
    filterTypes!: string | undefined;

    constructor(data?: IGetControllerCallInInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["orderIds"])) {
                this.orderIds = [] as any;
                for (let item of data["orderIds"])
                    this.orderIds!.push(item);
            }
            if (Array.isArray(data["orderTypeIds"])) {
                this.orderTypeIds = [] as any;
                for (let item of data["orderTypeIds"])
                    this.orderTypeIds!.push(item);
            }
            this.editions = data["editions"];
            if (Array.isArray(data["routeOrders"])) {
                this.routeOrders = [] as any;
                for (let item of data["routeOrders"])
                    this.routeOrders!.push(ControllerRouteOrderList.fromJS(item));
            }
            this.filterTypes = data["filterTypes"];
        }
    }

    static fromJS(data: any): GetControllerCallInInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetControllerCallInInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.orderIds)) {
            data["orderIds"] = [];
            for (let item of this.orderIds)
                data["orderIds"].push(item);
        }
        if (Array.isArray(this.orderTypeIds)) {
            data["orderTypeIds"] = [];
            for (let item of this.orderTypeIds)
                data["orderTypeIds"].push(item);
        }
        data["editions"] = this.editions;
        if (Array.isArray(this.routeOrders)) {
            data["routeOrders"] = [];
            for (let item of this.routeOrders)
                data["routeOrders"].push(item.toJSON());
        }
        data["filterTypes"] = this.filterTypes;
        return data; 
    }
}

export interface IGetControllerCallInInputDto {
    orderIds: number[] | undefined;
    orderTypeIds: number[] | undefined;
    editions: string | undefined;
    routeOrders: ControllerRouteOrderList[] | undefined;
    filterTypes: string | undefined;
}

export class ControllerCallInListDto implements IControllerCallInListDto {
    routeId!: number | undefined;
    callInOrderIds!: number[] | undefined;
    totalCallIn!: number;
    totalPickUpCallIn!: number;
    totalDeliveredCallIn!: number;
    totalUnassignedWillCall!: number;

    constructor(data?: IControllerCallInListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            if (Array.isArray(data["callInOrderIds"])) {
                this.callInOrderIds = [] as any;
                for (let item of data["callInOrderIds"])
                    this.callInOrderIds!.push(item);
            }
            this.totalCallIn = data["totalCallIn"];
            this.totalPickUpCallIn = data["totalPickUpCallIn"];
            this.totalDeliveredCallIn = data["totalDeliveredCallIn"];
            this.totalUnassignedWillCall = data["totalUnassignedWillCall"];
        }
    }

    static fromJS(data: any): ControllerCallInListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerCallInListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        if (Array.isArray(this.callInOrderIds)) {
            data["callInOrderIds"] = [];
            for (let item of this.callInOrderIds)
                data["callInOrderIds"].push(item);
        }
        data["totalCallIn"] = this.totalCallIn;
        data["totalPickUpCallIn"] = this.totalPickUpCallIn;
        data["totalDeliveredCallIn"] = this.totalDeliveredCallIn;
        data["totalUnassignedWillCall"] = this.totalUnassignedWillCall;
        return data; 
    }
}

export interface IControllerCallInListDto {
    routeId: number | undefined;
    callInOrderIds: number[] | undefined;
    totalCallIn: number;
    totalPickUpCallIn: number;
    totalDeliveredCallIn: number;
    totalUnassignedWillCall: number;
}

export class ControlllerRouteListDto implements IControlllerRouteListDto {
    routeId!: number | undefined;
    statusId!: number;
    activeOrderId!: number;
    activeOrderEtaEnd!: string | undefined;
    activeTime!: moment.Moment;
    totalOrders!: number;
    totalPickup!: number;
    status!: string | undefined;
    statusDescription!: string | undefined;
    icon!: string | undefined;
    color!: string | undefined;
    pickupOrderIds!: number[] | undefined;

    constructor(data?: IControlllerRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.statusId = data["statusId"];
            this.activeOrderId = data["activeOrderId"];
            this.activeOrderEtaEnd = data["activeOrderEtaEnd"];
            this.activeTime = data["activeTime"] ? moment(data["activeTime"].toString()) : <any>undefined;
            this.totalOrders = data["totalOrders"];
            this.totalPickup = data["totalPickup"];
            this.status = data["status"];
            this.statusDescription = data["statusDescription"];
            this.icon = data["icon"];
            this.color = data["color"];
            if (Array.isArray(data["pickupOrderIds"])) {
                this.pickupOrderIds = [] as any;
                for (let item of data["pickupOrderIds"])
                    this.pickupOrderIds!.push(item);
            }
        }
    }

    static fromJS(data: any): ControlllerRouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControlllerRouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["statusId"] = this.statusId;
        data["activeOrderId"] = this.activeOrderId;
        data["activeOrderEtaEnd"] = this.activeOrderEtaEnd;
        data["activeTime"] = this.activeTime ? this.activeTime.toISOString() : <any>undefined;
        data["totalOrders"] = this.totalOrders;
        data["totalPickup"] = this.totalPickup;
        data["status"] = this.status;
        data["statusDescription"] = this.statusDescription;
        data["icon"] = this.icon;
        data["color"] = this.color;
        if (Array.isArray(this.pickupOrderIds)) {
            data["pickupOrderIds"] = [];
            for (let item of this.pickupOrderIds)
                data["pickupOrderIds"].push(item);
        }
        return data; 
    }
}

export interface IControlllerRouteListDto {
    routeId: number | undefined;
    statusId: number;
    activeOrderId: number;
    activeOrderEtaEnd: string | undefined;
    activeTime: moment.Moment;
    totalOrders: number;
    totalPickup: number;
    status: string | undefined;
    statusDescription: string | undefined;
    icon: string | undefined;
    color: string | undefined;
    pickupOrderIds: number[] | undefined;
}

export class GetControllerRouteStatusInputDto implements IGetControllerRouteStatusInputDto {
    routeIds!: number[] | undefined;
    editions!: string | undefined;
    filterTypes!: string | undefined;

    constructor(data?: IGetControllerRouteStatusInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["routeIds"])) {
                this.routeIds = [] as any;
                for (let item of data["routeIds"])
                    this.routeIds!.push(item);
            }
            this.editions = data["editions"];
            this.filterTypes = data["filterTypes"];
        }
    }

    static fromJS(data: any): GetControllerRouteStatusInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetControllerRouteStatusInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.routeIds)) {
            data["routeIds"] = [];
            for (let item of this.routeIds)
                data["routeIds"].push(item);
        }
        data["editions"] = this.editions;
        data["filterTypes"] = this.filterTypes;
        return data; 
    }
}

export interface IGetControllerRouteStatusInputDto {
    routeIds: number[] | undefined;
    editions: string | undefined;
    filterTypes: string | undefined;
}

export class ControllerRouteStatusAntechEditionDto implements IControllerRouteStatusAntechEditionDto {
    totalPackages!: number;
    routeId!: number | undefined;
    statusId!: number;
    statusCode!: string | undefined;
    statusDescription!: string | undefined;
    orderStatusId!: number;
    orderId!: number;
    orderStatusTypeId!: number;
    totalPickedUp!: number;
    totalDelivered!: number;
    totalPending!: number;
    totalCallIn!: number;
    routeName!: string | undefined;
    totalWillCall!: number;
    totalCallInPickedUp!: number;
    icon!: string | undefined;
    color!: string | undefined;
    activeTime!: moment.Moment;
    pickupOrderIds!: number[] | undefined;
    callInOrderIds!: number[] | undefined;
    totalUnassignedWillCall!: number;
    eta!: string | undefined;
    completeRate!: string | undefined;

    constructor(data?: IControllerRouteStatusAntechEditionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            this.routeId = data["routeId"];
            this.statusId = data["statusId"];
            this.statusCode = data["statusCode"];
            this.statusDescription = data["statusDescription"];
            this.orderStatusId = data["orderStatusId"];
            this.orderId = data["orderId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.totalPickedUp = data["totalPickedUp"];
            this.totalDelivered = data["totalDelivered"];
            this.totalPending = data["totalPending"];
            this.totalCallIn = data["totalCallIn"];
            this.routeName = data["routeName"];
            this.totalWillCall = data["totalWillCall"];
            this.totalCallInPickedUp = data["totalCallInPickedUp"];
            this.icon = data["icon"];
            this.color = data["color"];
            this.activeTime = data["activeTime"] ? moment(data["activeTime"].toString()) : <any>undefined;
            if (Array.isArray(data["pickupOrderIds"])) {
                this.pickupOrderIds = [] as any;
                for (let item of data["pickupOrderIds"])
                    this.pickupOrderIds!.push(item);
            }
            if (Array.isArray(data["callInOrderIds"])) {
                this.callInOrderIds = [] as any;
                for (let item of data["callInOrderIds"])
                    this.callInOrderIds!.push(item);
            }
            this.totalUnassignedWillCall = data["totalUnassignedWillCall"];
            this.eta = data["eta"];
            this.completeRate = data["completeRate"];
        }
    }

    static fromJS(data: any): ControllerRouteStatusAntechEditionDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteStatusAntechEditionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        data["routeId"] = this.routeId;
        data["statusId"] = this.statusId;
        data["statusCode"] = this.statusCode;
        data["statusDescription"] = this.statusDescription;
        data["orderStatusId"] = this.orderStatusId;
        data["orderId"] = this.orderId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["totalPickedUp"] = this.totalPickedUp;
        data["totalDelivered"] = this.totalDelivered;
        data["totalPending"] = this.totalPending;
        data["totalCallIn"] = this.totalCallIn;
        data["routeName"] = this.routeName;
        data["totalWillCall"] = this.totalWillCall;
        data["totalCallInPickedUp"] = this.totalCallInPickedUp;
        data["icon"] = this.icon;
        data["color"] = this.color;
        data["activeTime"] = this.activeTime ? this.activeTime.toISOString() : <any>undefined;
        if (Array.isArray(this.pickupOrderIds)) {
            data["pickupOrderIds"] = [];
            for (let item of this.pickupOrderIds)
                data["pickupOrderIds"].push(item);
        }
        if (Array.isArray(this.callInOrderIds)) {
            data["callInOrderIds"] = [];
            for (let item of this.callInOrderIds)
                data["callInOrderIds"].push(item);
        }
        data["totalUnassignedWillCall"] = this.totalUnassignedWillCall;
        data["eta"] = this.eta;
        data["completeRate"] = this.completeRate;
        return data; 
    }
}

export interface IControllerRouteStatusAntechEditionDto {
    totalPackages: number;
    routeId: number | undefined;
    statusId: number;
    statusCode: string | undefined;
    statusDescription: string | undefined;
    orderStatusId: number;
    orderId: number;
    orderStatusTypeId: number;
    totalPickedUp: number;
    totalDelivered: number;
    totalPending: number;
    totalCallIn: number;
    routeName: string | undefined;
    totalWillCall: number;
    totalCallInPickedUp: number;
    icon: string | undefined;
    color: string | undefined;
    activeTime: moment.Moment;
    pickupOrderIds: number[] | undefined;
    callInOrderIds: number[] | undefined;
    totalUnassignedWillCall: number;
    eta: string | undefined;
    completeRate: string | undefined;
}

export class UpdateCompleteRouteInput implements IUpdateCompleteRouteInput {
    id!: number;
    completion!: boolean;

    constructor(data?: IUpdateCompleteRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.completion = data["completion"];
        }
    }

    static fromJS(data: any): UpdateCompleteRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateCompleteRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["completion"] = this.completion;
        return data; 
    }
}

export interface IUpdateCompleteRouteInput {
    id: number;
    completion: boolean;
}

export class UpdateDepartureRouteInput implements IUpdateDepartureRouteInput {
    id!: number;
    departure!: boolean;

    constructor(data?: IUpdateDepartureRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.departure = data["departure"];
        }
    }

    static fromJS(data: any): UpdateDepartureRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateDepartureRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["departure"] = this.departure;
        return data; 
    }
}

export interface IUpdateDepartureRouteInput {
    id: number;
    departure: boolean;
}

export class ShowBlindCountCodeInput implements IShowBlindCountCodeInput {
    routeId!: number;

    constructor(data?: IShowBlindCountCodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): ShowBlindCountCodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new ShowBlindCountCodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface IShowBlindCountCodeInput {
    routeId: number;
}

export class UpdateLockedRouteInput implements IUpdateLockedRouteInput {
    routeId!: number;
    locked!: boolean;

    constructor(data?: IUpdateLockedRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.locked = data["locked"];
        }
    }

    static fromJS(data: any): UpdateLockedRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateLockedRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["locked"] = this.locked;
        return data; 
    }
}

export interface IUpdateLockedRouteInput {
    routeId: number;
    locked: boolean;
}

export class DriverAndOrderMappingDto implements IDriverAndOrderMappingDto {
    driverUserId!: number | undefined;
    orderIds!: number[] | undefined;

    constructor(data?: IDriverAndOrderMappingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverUserId = data["driverUserId"];
            if (Array.isArray(data["orderIds"])) {
                this.orderIds = [] as any;
                for (let item of data["orderIds"])
                    this.orderIds!.push(item);
            }
        }
    }

    static fromJS(data: any): DriverAndOrderMappingDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverAndOrderMappingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverUserId"] = this.driverUserId;
        if (Array.isArray(this.orderIds)) {
            data["orderIds"] = [];
            for (let item of this.orderIds)
                data["orderIds"].push(item);
        }
        return data; 
    }
}

export interface IDriverAndOrderMappingDto {
    driverUserId: number | undefined;
    orderIds: number[] | undefined;
}

export class GenerateInputDto implements IGenerateInputDto {
    locationId!: number | undefined;
    loadDateStart!: moment.Moment;
    loadDateEnd!: moment.Moment;
    timezone!: string | undefined;
    isAuto!: boolean;
    limit!: number;
    action!: string | undefined;
    jobId!: string | undefined;
    runEstimatedStartTime!: boolean;
    sourceRouteIds!: number[] | undefined;
    targetRouteId!: number | undefined;
    orderIds!: number[] | undefined;
    driverUserId!: number | undefined;
    visibleToDriver!: boolean | undefined;
    isDownloadOrder!: boolean;
    tenantId!: number | undefined;
    driverAndOrderMapping!: DriverAndOrderMappingDto[] | undefined;

    constructor(data?: IGenerateInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.loadDateStart = data["loadDateStart"] ? moment(data["loadDateStart"].toString()) : <any>undefined;
            this.loadDateEnd = data["loadDateEnd"] ? moment(data["loadDateEnd"].toString()) : <any>undefined;
            this.timezone = data["timezone"];
            this.isAuto = data["isAuto"];
            this.limit = data["limit"];
            this.action = data["action"];
            this.jobId = data["jobId"];
            this.runEstimatedStartTime = data["runEstimatedStartTime"];
            if (Array.isArray(data["sourceRouteIds"])) {
                this.sourceRouteIds = [] as any;
                for (let item of data["sourceRouteIds"])
                    this.sourceRouteIds!.push(item);
            }
            this.targetRouteId = data["targetRouteId"];
            if (Array.isArray(data["orderIds"])) {
                this.orderIds = [] as any;
                for (let item of data["orderIds"])
                    this.orderIds!.push(item);
            }
            this.driverUserId = data["driverUserId"];
            this.visibleToDriver = data["visibleToDriver"];
            this.isDownloadOrder = data["isDownloadOrder"];
            this.tenantId = data["tenantId"];
            if (Array.isArray(data["driverAndOrderMapping"])) {
                this.driverAndOrderMapping = [] as any;
                for (let item of data["driverAndOrderMapping"])
                    this.driverAndOrderMapping!.push(DriverAndOrderMappingDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GenerateInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new GenerateInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["loadDateStart"] = this.loadDateStart ? this.loadDateStart.toISOString() : <any>undefined;
        data["loadDateEnd"] = this.loadDateEnd ? this.loadDateEnd.toISOString() : <any>undefined;
        data["timezone"] = this.timezone;
        data["isAuto"] = this.isAuto;
        data["limit"] = this.limit;
        data["action"] = this.action;
        data["jobId"] = this.jobId;
        data["runEstimatedStartTime"] = this.runEstimatedStartTime;
        if (Array.isArray(this.sourceRouteIds)) {
            data["sourceRouteIds"] = [];
            for (let item of this.sourceRouteIds)
                data["sourceRouteIds"].push(item);
        }
        data["targetRouteId"] = this.targetRouteId;
        if (Array.isArray(this.orderIds)) {
            data["orderIds"] = [];
            for (let item of this.orderIds)
                data["orderIds"].push(item);
        }
        data["driverUserId"] = this.driverUserId;
        data["visibleToDriver"] = this.visibleToDriver;
        data["isDownloadOrder"] = this.isDownloadOrder;
        data["tenantId"] = this.tenantId;
        if (Array.isArray(this.driverAndOrderMapping)) {
            data["driverAndOrderMapping"] = [];
            for (let item of this.driverAndOrderMapping)
                data["driverAndOrderMapping"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGenerateInputDto {
    locationId: number | undefined;
    loadDateStart: moment.Moment;
    loadDateEnd: moment.Moment;
    timezone: string | undefined;
    isAuto: boolean;
    limit: number;
    action: string | undefined;
    jobId: string | undefined;
    runEstimatedStartTime: boolean;
    sourceRouteIds: number[] | undefined;
    targetRouteId: number | undefined;
    orderIds: number[] | undefined;
    driverUserId: number | undefined;
    visibleToDriver: boolean | undefined;
    isDownloadOrder: boolean;
    tenantId: number | undefined;
    driverAndOrderMapping: DriverAndOrderMappingDto[] | undefined;
}

export class GetDeliveredPackagesList implements IGetDeliveredPackagesList {
    routeId!: number | undefined;
    totalPackages!: number;
    totalDelivered!: number;

    constructor(data?: IGetDeliveredPackagesList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.totalPackages = data["totalPackages"];
            this.totalDelivered = data["totalDelivered"];
        }
    }

    static fromJS(data: any): GetDeliveredPackagesList {
        data = typeof data === 'object' ? data : {};
        let result = new GetDeliveredPackagesList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["totalPackages"] = this.totalPackages;
        data["totalDelivered"] = this.totalDelivered;
        return data; 
    }
}

export interface IGetDeliveredPackagesList {
    routeId: number | undefined;
    totalPackages: number;
    totalDelivered: number;
}

export class MobileVersionListDto implements IMobileVersionListDto {
    id!: number;
    clientCode!: string | undefined;
    osName!: string | undefined;
    minimumVersion!: number;
    versionName!: string | undefined;

    constructor(data?: IMobileVersionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.clientCode = data["clientCode"];
            this.osName = data["osName"];
            this.minimumVersion = data["minimumVersion"];
            this.versionName = data["versionName"];
        }
    }

    static fromJS(data: any): MobileVersionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new MobileVersionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["clientCode"] = this.clientCode;
        data["osName"] = this.osName;
        data["minimumVersion"] = this.minimumVersion;
        data["versionName"] = this.versionName;
        return data; 
    }
}

export interface IMobileVersionListDto {
    id: number;
    clientCode: string | undefined;
    osName: string | undefined;
    minimumVersion: number;
    versionName: string | undefined;
}

export class UserLocalStorageInput implements IUserLocalStorageInput {
    userId!: number;
    userKey!: string | undefined;
    description!: string | undefined;

    constructor(data?: IUserLocalStorageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.userKey = data["userKey"];
            this.description = data["description"];
        }
    }

    static fromJS(data: any): UserLocalStorageInput {
        data = typeof data === 'object' ? data : {};
        let result = new UserLocalStorageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["userKey"] = this.userKey;
        data["description"] = this.description;
        return data; 
    }
}

export interface IUserLocalStorageInput {
    userId: number;
    userKey: string | undefined;
    description: string | undefined;
}

export class RouteDefinitionListInput implements IRouteDefinitionListInput {
    tenantId!: number | undefined;
    name!: string | undefined;
    locationId!: number;
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: IRouteDefinitionListInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.locationId = data["locationId"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): RouteDefinitionListInput {
        data = typeof data === 'object' ? data : {};
        let result = new RouteDefinitionListInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["locationId"] = this.locationId;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface IRouteDefinitionListInput {
    tenantId: number | undefined;
    name: string | undefined;
    locationId: number;
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class CreateNewRouteInput implements ICreateNewRouteInput {
    locationId!: number;
    vehicleId!: number | undefined;
    routeDefinitionId!: number;
    loadDate!: moment.Moment;
    name!: string | undefined;
    zone!: string | undefined;

    constructor(data?: ICreateNewRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.vehicleId = data["vehicleId"];
            this.routeDefinitionId = data["routeDefinitionId"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.name = data["name"];
            this.zone = data["zone"];
        }
    }

    static fromJS(data: any): CreateNewRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateNewRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["vehicleId"] = this.vehicleId;
        data["routeDefinitionId"] = this.routeDefinitionId;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["name"] = this.name;
        data["zone"] = this.zone;
        return data; 
    }
}

export interface ICreateNewRouteInput {
    locationId: number;
    vehicleId: number | undefined;
    routeDefinitionId: number;
    loadDate: moment.Moment;
    name: string | undefined;
    zone: string | undefined;
}

export class DriverInactiveThresholdDto implements IDriverInactiveThresholdDto {
    mins!: number;

    constructor(data?: IDriverInactiveThresholdDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.mins = data["mins"];
        }
    }

    static fromJS(data: any): DriverInactiveThresholdDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverInactiveThresholdDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["mins"] = this.mins;
        return data; 
    }
}

export interface IDriverInactiveThresholdDto {
    mins: number;
}

export class CleanUpDuplicateOrderDto implements ICleanUpDuplicateOrderDto {
    routeId!: number[] | undefined;
    tenantId!: number | undefined;
    isLab!: boolean;

    constructor(data?: ICleanUpDuplicateOrderDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["routeId"])) {
                this.routeId = [] as any;
                for (let item of data["routeId"])
                    this.routeId!.push(item);
            }
            this.tenantId = data["tenantId"];
            this.isLab = data["isLab"];
        }
    }

    static fromJS(data: any): CleanUpDuplicateOrderDto {
        data = typeof data === 'object' ? data : {};
        let result = new CleanUpDuplicateOrderDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.routeId)) {
            data["routeId"] = [];
            for (let item of this.routeId)
                data["routeId"].push(item);
        }
        data["tenantId"] = this.tenantId;
        data["isLab"] = this.isLab;
        return data; 
    }
}

export interface ICleanUpDuplicateOrderDto {
    routeId: number[] | undefined;
    tenantId: number | undefined;
    isLab: boolean;
}

export class DestinationDetailListDto implements IDestinationDetailListDto {
    id!: number;
    contact!: ContactListDto | undefined;
    etaStart!: moment.Moment;
    etaEnd!: moment.Moment;
    stopType!: string | undefined;

    constructor(data?: IDestinationDetailListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contact = data["contact"] ? ContactListDto.fromJS(data["contact"]) : <any>undefined;
            this.etaStart = data["etaStart"] ? moment(data["etaStart"].toString()) : <any>undefined;
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
            this.stopType = data["stopType"];
        }
    }

    static fromJS(data: any): DestinationDetailListDto {
        data = typeof data === 'object' ? data : {};
        let result = new DestinationDetailListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["etaStart"] = this.etaStart ? this.etaStart.toISOString() : <any>undefined;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        data["stopType"] = this.stopType;
        return data; 
    }
}

export interface IDestinationDetailListDto {
    id: number;
    contact: ContactListDto | undefined;
    etaStart: moment.Moment;
    etaEnd: moment.Moment;
    stopType: string | undefined;
}

export class ControllerOrderStatusListDto implements IControllerOrderStatusListDto {
    geocode!: GeocodeListDto | undefined;
    time!: moment.Moment | undefined;
    orderStatusType!: OrderStatusTypeListDto | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IControllerOrderStatusListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.orderStatusType = data["orderStatusType"] ? OrderStatusTypeListDto.fromJS(data["orderStatusType"]) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ControllerOrderStatusListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerOrderStatusListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IControllerOrderStatusListDto {
    geocode: GeocodeListDto | undefined;
    time: moment.Moment | undefined;
    orderStatusType: OrderStatusTypeListDto | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderStatusTypeDescriptionListDto implements IOrderStatusTypeDescriptionListDto {
    id!: number;
    tenantId!: number;
    orderStatusTypeId!: number;
    description!: string;
    orderStatusTypeCode!: string | undefined;
    orderStatusType!: OrderStatusTypeListDto | undefined;
    name!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    visible!: boolean;
    parentId!: number | undefined;
    sortOrder!: number;
    code!: string | undefined;

    constructor(data?: IOrderStatusTypeDescriptionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.description = data["description"];
            this.orderStatusTypeCode = data["orderStatusTypeCode"];
            this.orderStatusType = data["orderStatusType"] ? OrderStatusTypeListDto.fromJS(data["orderStatusType"]) : <any>undefined;
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.visible = data["visible"];
            this.parentId = data["parentId"];
            this.sortOrder = data["sortOrder"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): OrderStatusTypeDescriptionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusTypeDescriptionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["description"] = this.description;
        data["orderStatusTypeCode"] = this.orderStatusTypeCode;
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["visible"] = this.visible;
        data["parentId"] = this.parentId;
        data["sortOrder"] = this.sortOrder;
        data["code"] = this.code;
        return data; 
    }
}

export interface IOrderStatusTypeDescriptionListDto {
    id: number;
    tenantId: number;
    orderStatusTypeId: number;
    description: string;
    orderStatusTypeCode: string | undefined;
    orderStatusType: OrderStatusTypeListDto | undefined;
    name: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    visible: boolean;
    parentId: number | undefined;
    sortOrder: number;
    code: string | undefined;
}

export class UserListRoleDto implements IUserListRoleDto {
    roleId!: number;
    roleName!: string | undefined;

    constructor(data?: IUserListRoleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.roleId = data["roleId"];
            this.roleName = data["roleName"];
        }
    }

    static fromJS(data: any): UserListRoleDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserListRoleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["roleId"] = this.roleId;
        data["roleName"] = this.roleName;
        return data; 
    }
}

export interface IUserListRoleDto {
    roleId: number;
    roleName: string | undefined;
}

export class UserListDto implements IUserListDto {
    name!: string | undefined;
    surname!: string | undefined;
    userName!: string | undefined;
    emailAddress!: string | undefined;
    phoneNumber!: string | undefined;
    lockOutEndDateUtc!: moment.Moment | undefined;
    profilePictureId!: string | undefined;
    isEmailConfirmed!: boolean;
    roles!: UserListRoleDto[] | undefined;
    isActive!: boolean;
    creationTime!: moment.Moment;
    preferences!: string | undefined;
    hasBackgroundImage!: boolean;
    id!: number;

    constructor(data?: IUserListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.surname = data["surname"];
            this.userName = data["userName"];
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
            this.lockOutEndDateUtc = data["lockOutEndDateUtc"] ? moment(data["lockOutEndDateUtc"].toString()) : <any>undefined;
            this.profilePictureId = data["profilePictureId"];
            this.isEmailConfirmed = data["isEmailConfirmed"];
            if (Array.isArray(data["roles"])) {
                this.roles = [] as any;
                for (let item of data["roles"])
                    this.roles!.push(UserListRoleDto.fromJS(item));
            }
            this.isActive = data["isActive"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.preferences = data["preferences"];
            this.hasBackgroundImage = data["hasBackgroundImage"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserListDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["userName"] = this.userName;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        data["lockOutEndDateUtc"] = this.lockOutEndDateUtc ? this.lockOutEndDateUtc.toISOString() : <any>undefined;
        data["profilePictureId"] = this.profilePictureId;
        data["isEmailConfirmed"] = this.isEmailConfirmed;
        if (Array.isArray(this.roles)) {
            data["roles"] = [];
            for (let item of this.roles)
                data["roles"].push(item.toJSON());
        }
        data["isActive"] = this.isActive;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["preferences"] = this.preferences;
        data["hasBackgroundImage"] = this.hasBackgroundImage;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserListDto {
    name: string | undefined;
    surname: string | undefined;
    userName: string | undefined;
    emailAddress: string | undefined;
    phoneNumber: string | undefined;
    lockOutEndDateUtc: moment.Moment | undefined;
    profilePictureId: string | undefined;
    isEmailConfirmed: boolean;
    roles: UserListRoleDto[] | undefined;
    isActive: boolean;
    creationTime: moment.Moment;
    preferences: string | undefined;
    hasBackgroundImage: boolean;
    id: number;
}

export class TimeZoneListDto implements ITimeZoneListDto {
    id!: number;
    value!: string | undefined;
    offset!: string | undefined;

    constructor(data?: ITimeZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.value = data["value"];
            this.offset = data["offset"];
        }
    }

    static fromJS(data: any): TimeZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new TimeZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["value"] = this.value;
        data["offset"] = this.offset;
        return data; 
    }
}

export interface ITimeZoneListDto {
    id: number;
    value: string | undefined;
    offset: string | undefined;
}

export class DistanceInputApi implements IDistanceInputApi {
    maxDistance!: number;
    multiplier!: number;

    constructor(data?: IDistanceInputApi) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.maxDistance = data["maxDistance"];
            this.multiplier = data["multiplier"];
        }
    }

    static fromJS(data: any): DistanceInputApi {
        data = typeof data === 'object' ? data : {};
        let result = new DistanceInputApi();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["maxDistance"] = this.maxDistance;
        data["multiplier"] = this.multiplier;
        return data; 
    }
}

export interface IDistanceInputApi {
    maxDistance: number;
    multiplier: number;
}

export class TrafficInputApi implements ITrafficInputApi {
    trafficStartTime!: string | undefined;
    trafficEndTime!: string | undefined;
    multiplier!: number;

    constructor(data?: ITrafficInputApi) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.trafficStartTime = data["trafficStartTime"];
            this.trafficEndTime = data["trafficEndTime"];
            this.multiplier = data["multiplier"];
        }
    }

    static fromJS(data: any): TrafficInputApi {
        data = typeof data === 'object' ? data : {};
        let result = new TrafficInputApi();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["trafficStartTime"] = this.trafficStartTime;
        data["trafficEndTime"] = this.trafficEndTime;
        data["multiplier"] = this.multiplier;
        return data; 
    }
}

export interface ITrafficInputApi {
    trafficStartTime: string | undefined;
    trafficEndTime: string | undefined;
    multiplier: number;
}

export enum LocationGenerationTypeEnum {
    Later = 0,
    Prior = 1,
}

export class LocationListDto implements ILocationListDto {
    id!: number;
    tenantId!: number;
    contactId!: number;
    contact!: ContactListDto | undefined;
    timeZoneId!: number;
    timeZone!: TimeZoneListDto | undefined;
    userId!: number;
    name!: string | undefined;
    minutesPerMile!: number;
    leadTime!: number | undefined;
    etaRoundUp!: number | undefined;
    goBackTimeWindow!: number | undefined;
    minutesPerStop!: number;
    loadLimit!: number | undefined;
    distanceAdjustment!: DistanceInputApi[] | undefined;
    trafficAdjustment!: TrafficInputApi[] | undefined;
    inActive!: boolean;
    postalCodeRegEx!: string | undefined;
    driverInactiveThreshold!: number | undefined;
    code!: string | undefined;
    generationType!: LocationGenerationTypeEnum | undefined;
    generationTime!: string | undefined;

    constructor(data?: ILocationListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.contactId = data["contactId"];
            this.contact = data["contact"] ? ContactListDto.fromJS(data["contact"]) : <any>undefined;
            this.timeZoneId = data["timeZoneId"];
            this.timeZone = data["timeZone"] ? TimeZoneListDto.fromJS(data["timeZone"]) : <any>undefined;
            this.userId = data["userId"];
            this.name = data["name"];
            this.minutesPerMile = data["minutesPerMile"];
            this.leadTime = data["leadTime"];
            this.etaRoundUp = data["etaRoundUp"];
            this.goBackTimeWindow = data["goBackTimeWindow"];
            this.minutesPerStop = data["minutesPerStop"];
            this.loadLimit = data["loadLimit"];
            if (Array.isArray(data["distanceAdjustment"])) {
                this.distanceAdjustment = [] as any;
                for (let item of data["distanceAdjustment"])
                    this.distanceAdjustment!.push(DistanceInputApi.fromJS(item));
            }
            if (Array.isArray(data["trafficAdjustment"])) {
                this.trafficAdjustment = [] as any;
                for (let item of data["trafficAdjustment"])
                    this.trafficAdjustment!.push(TrafficInputApi.fromJS(item));
            }
            this.inActive = data["inActive"];
            this.postalCodeRegEx = data["postalCodeRegEx"];
            this.driverInactiveThreshold = data["driverInactiveThreshold"];
            this.code = data["code"];
            this.generationType = data["generationType"];
            this.generationTime = data["generationTime"];
        }
    }

    static fromJS(data: any): LocationListDto {
        data = typeof data === 'object' ? data : {};
        let result = new LocationListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["contactId"] = this.contactId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["timeZoneId"] = this.timeZoneId;
        data["timeZone"] = this.timeZone ? this.timeZone.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["name"] = this.name;
        data["minutesPerMile"] = this.minutesPerMile;
        data["leadTime"] = this.leadTime;
        data["etaRoundUp"] = this.etaRoundUp;
        data["goBackTimeWindow"] = this.goBackTimeWindow;
        data["minutesPerStop"] = this.minutesPerStop;
        data["loadLimit"] = this.loadLimit;
        if (Array.isArray(this.distanceAdjustment)) {
            data["distanceAdjustment"] = [];
            for (let item of this.distanceAdjustment)
                data["distanceAdjustment"].push(item.toJSON());
        }
        if (Array.isArray(this.trafficAdjustment)) {
            data["trafficAdjustment"] = [];
            for (let item of this.trafficAdjustment)
                data["trafficAdjustment"].push(item.toJSON());
        }
        data["inActive"] = this.inActive;
        data["postalCodeRegEx"] = this.postalCodeRegEx;
        data["driverInactiveThreshold"] = this.driverInactiveThreshold;
        data["code"] = this.code;
        data["generationType"] = this.generationType;
        data["generationTime"] = this.generationTime;
        return data; 
    }
}

export interface ILocationListDto {
    id: number;
    tenantId: number;
    contactId: number;
    contact: ContactListDto | undefined;
    timeZoneId: number;
    timeZone: TimeZoneListDto | undefined;
    userId: number;
    name: string | undefined;
    minutesPerMile: number;
    leadTime: number | undefined;
    etaRoundUp: number | undefined;
    goBackTimeWindow: number | undefined;
    minutesPerStop: number;
    loadLimit: number | undefined;
    distanceAdjustment: DistanceInputApi[] | undefined;
    trafficAdjustment: TrafficInputApi[] | undefined;
    inActive: boolean;
    postalCodeRegEx: string | undefined;
    driverInactiveThreshold: number | undefined;
    code: string | undefined;
    generationType: LocationGenerationTypeEnum | undefined;
    generationTime: string | undefined;
}

export class ControllerGetDriverListDto implements IControllerGetDriverListDto {
    userId!: number;
    fullName!: string | undefined;

    constructor(data?: IControllerGetDriverListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.fullName = data["fullName"];
        }
    }

    static fromJS(data: any): ControllerGetDriverListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerGetDriverListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["fullName"] = this.fullName;
        return data; 
    }
}

export interface IControllerGetDriverListDto {
    userId: number;
    fullName: string | undefined;
}

export class RouteVehicleListDto implements IRouteVehicleListDto {
    id!: number;
    name!: string | undefined;
    licenseNumber!: string | undefined;
    tenantId!: number;
    userId!: number;
    user!: UserListDto | undefined;
    users!: ControllerGetDriverListDto | undefined;

    constructor(data?: IRouteVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.user = data["user"] ? UserListDto.fromJS(data["user"]) : <any>undefined;
            this.users = data["users"] ? ControllerGetDriverListDto.fromJS(data["users"]) : <any>undefined;
        }
    }

    static fromJS(data: any): RouteVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["users"] = this.users ? this.users.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IRouteVehicleListDto {
    id: number;
    name: string | undefined;
    licenseNumber: string | undefined;
    tenantId: number;
    userId: number;
    user: UserListDto | undefined;
    users: ControllerGetDriverListDto | undefined;
}

export class RouteLocationListDto implements IRouteLocationListDto {
    id!: number;
    name!: string | undefined;
    contactId!: number;
    minutesPerMile!: number;
    minutesPerStop!: number;
    tenantId!: number;
    timeZoneId!: number;
    userId!: number;

    constructor(data?: IRouteLocationListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.contactId = data["contactId"];
            this.minutesPerMile = data["minutesPerMile"];
            this.minutesPerStop = data["minutesPerStop"];
            this.tenantId = data["tenantId"];
            this.timeZoneId = data["timeZoneId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): RouteLocationListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteLocationListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["contactId"] = this.contactId;
        data["minutesPerMile"] = this.minutesPerMile;
        data["minutesPerStop"] = this.minutesPerStop;
        data["tenantId"] = this.tenantId;
        data["timeZoneId"] = this.timeZoneId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IRouteLocationListDto {
    id: number;
    name: string | undefined;
    contactId: number;
    minutesPerMile: number;
    minutesPerStop: number;
    tenantId: number;
    timeZoneId: number;
    userId: number;
}

export class RouteTemplateLocationListDto implements IRouteTemplateLocationListDto {
    id!: number;
    name!: string | undefined;
    contactId!: number;
    minutesPerMile!: number;
    minutesPerStop!: number;
    tenantId!: number;
    timeZoneId!: number;
    userId!: number;

    constructor(data?: IRouteTemplateLocationListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.contactId = data["contactId"];
            this.minutesPerMile = data["minutesPerMile"];
            this.minutesPerStop = data["minutesPerStop"];
            this.tenantId = data["tenantId"];
            this.timeZoneId = data["timeZoneId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): RouteTemplateLocationListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateLocationListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["contactId"] = this.contactId;
        data["minutesPerMile"] = this.minutesPerMile;
        data["minutesPerStop"] = this.minutesPerStop;
        data["tenantId"] = this.tenantId;
        data["timeZoneId"] = this.timeZoneId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IRouteTemplateLocationListDto {
    id: number;
    name: string | undefined;
    contactId: number;
    minutesPerMile: number;
    minutesPerStop: number;
    tenantId: number;
    timeZoneId: number;
    userId: number;
}

export class RouteTemplateListDto implements IRouteTemplateListDto {
    tenantId!: number;
    locationId!: number;
    routeTemplateTypeId!: number;
    name!: string | undefined;
    startTime!: string | undefined;
    endTime!: string | undefined;
    defaultUserId!: number | undefined;
    location!: RouteTemplateLocationListDto | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.locationId = data["locationId"];
            this.routeTemplateTypeId = data["routeTemplateTypeId"];
            this.name = data["name"];
            this.startTime = data["startTime"];
            this.endTime = data["endTime"];
            this.defaultUserId = data["defaultUserId"];
            this.location = data["location"] ? RouteTemplateLocationListDto.fromJS(data["location"]) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["locationId"] = this.locationId;
        data["routeTemplateTypeId"] = this.routeTemplateTypeId;
        data["name"] = this.name;
        data["startTime"] = this.startTime;
        data["endTime"] = this.endTime;
        data["defaultUserId"] = this.defaultUserId;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateListDto {
    tenantId: number;
    locationId: number;
    routeTemplateTypeId: number;
    name: string | undefined;
    startTime: string | undefined;
    endTime: string | undefined;
    defaultUserId: number | undefined;
    location: RouteTemplateLocationListDto | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteListDto implements IRouteListDto {
    tenantId!: number;
    vehicleId!: number | undefined;
    locationId!: number;
    locationName!: string | undefined;
    routeTemplateId!: number;
    routeTemplateName!: string | undefined;
    driverName!: string | undefined;
    vehicle!: RouteVehicleListDto | undefined;
    location!: RouteLocationListDto | undefined;
    routeTemplate!: RouteTemplateListDto | undefined;
    loadDate!: moment.Moment;
    completion!: moment.Moment | undefined;
    departure!: moment.Moment | undefined;
    estimatedStartTime!: moment.Moment | undefined;
    locked!: boolean;
    orders!: OrderListDto[] | undefined;
    vehicleName!: string | undefined;
    utcOffset!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.vehicleId = data["vehicleId"];
            this.locationId = data["locationId"];
            this.locationName = data["locationName"];
            this.routeTemplateId = data["routeTemplateId"];
            this.routeTemplateName = data["routeTemplateName"];
            this.driverName = data["driverName"];
            this.vehicle = data["vehicle"] ? RouteVehicleListDto.fromJS(data["vehicle"]) : <any>undefined;
            this.location = data["location"] ? RouteLocationListDto.fromJS(data["location"]) : <any>undefined;
            this.routeTemplate = data["routeTemplate"] ? RouteTemplateListDto.fromJS(data["routeTemplate"]) : <any>undefined;
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.completion = data["completion"] ? moment(data["completion"].toString()) : <any>undefined;
            this.departure = data["departure"] ? moment(data["departure"].toString()) : <any>undefined;
            this.estimatedStartTime = data["estimatedStartTime"] ? moment(data["estimatedStartTime"].toString()) : <any>undefined;
            this.locked = data["locked"];
            if (Array.isArray(data["orders"])) {
                this.orders = [] as any;
                for (let item of data["orders"])
                    this.orders!.push(OrderListDto.fromJS(item));
            }
            this.vehicleName = data["vehicleName"];
            this.utcOffset = data["utcOffset"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["vehicleId"] = this.vehicleId;
        data["locationId"] = this.locationId;
        data["locationName"] = this.locationName;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeTemplateName"] = this.routeTemplateName;
        data["driverName"] = this.driverName;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["completion"] = this.completion ? this.completion.toISOString() : <any>undefined;
        data["departure"] = this.departure ? this.departure.toISOString() : <any>undefined;
        data["estimatedStartTime"] = this.estimatedStartTime ? this.estimatedStartTime.toISOString() : <any>undefined;
        data["locked"] = this.locked;
        if (Array.isArray(this.orders)) {
            data["orders"] = [];
            for (let item of this.orders)
                data["orders"].push(item.toJSON());
        }
        data["vehicleName"] = this.vehicleName;
        data["utcOffset"] = this.utcOffset;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteListDto {
    tenantId: number;
    vehicleId: number | undefined;
    locationId: number;
    locationName: string | undefined;
    routeTemplateId: number;
    routeTemplateName: string | undefined;
    driverName: string | undefined;
    vehicle: RouteVehicleListDto | undefined;
    location: RouteLocationListDto | undefined;
    routeTemplate: RouteTemplateListDto | undefined;
    loadDate: moment.Moment;
    completion: moment.Moment | undefined;
    departure: moment.Moment | undefined;
    estimatedStartTime: moment.Moment | undefined;
    locked: boolean;
    orders: OrderListDto[] | undefined;
    vehicleName: string | undefined;
    utcOffset: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class NoteListDto implements INoteListDto {
    id!: number | undefined;
    content!: string | undefined;

    constructor(data?: INoteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.content = data["content"];
        }
    }

    static fromJS(data: any): NoteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new NoteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["content"] = this.content;
        return data; 
    }
}

export interface INoteListDto {
    id: number | undefined;
    content: string | undefined;
}

export class OrderStatusListDto implements IOrderStatusListDto {
    time!: moment.Moment;
    user!: UserListDto | undefined;
    order!: OrderListDto | undefined;
    geocode!: GeocodeListDto | undefined;
    orderStatusType!: OrderStatusTypeListDto | undefined;
    orderStatusDescription!: OrderStatusDescriptionListDto | undefined;
    note!: NoteListDto | undefined;
    stringTime!: string | undefined;
    orderType!: string | undefined;
    etaString!: string | undefined;
    eta!: moment.Moment;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderStatusListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.user = data["user"] ? UserListDto.fromJS(data["user"]) : <any>undefined;
            this.order = data["order"] ? OrderListDto.fromJS(data["order"]) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.orderStatusType = data["orderStatusType"] ? OrderStatusTypeListDto.fromJS(data["orderStatusType"]) : <any>undefined;
            this.orderStatusDescription = data["orderStatusDescription"] ? OrderStatusDescriptionListDto.fromJS(data["orderStatusDescription"]) : <any>undefined;
            this.note = data["note"] ? NoteListDto.fromJS(data["note"]) : <any>undefined;
            this.stringTime = data["stringTime"];
            this.orderType = data["orderType"];
            this.etaString = data["etaString"];
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatusListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        data["orderStatusDescription"] = this.orderStatusDescription ? this.orderStatusDescription.toJSON() : <any>undefined;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["stringTime"] = this.stringTime;
        data["orderType"] = this.orderType;
        data["etaString"] = this.etaString;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatusListDto {
    time: moment.Moment;
    user: UserListDto | undefined;
    order: OrderListDto | undefined;
    geocode: GeocodeListDto | undefined;
    orderStatusType: OrderStatusTypeListDto | undefined;
    orderStatusDescription: OrderStatusDescriptionListDto | undefined;
    note: NoteListDto | undefined;
    stringTime: string | undefined;
    orderType: string | undefined;
    etaString: string | undefined;
    eta: moment.Moment;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteScheduleDetailDto implements IRouteScheduleDetailDto {
    routeCode!: string | undefined;
    estimatedTimeOfArrival!: moment.Moment;
    cutOff!: moment.Moment;
    automatic!: boolean;
    willCall!: boolean;
    isActive!: boolean;
    oorRate!: number | undefined;
    effectivityDate!: moment.Moment | undefined;
    routeScheduleId!: number;
    routeTypeId!: number;
    routeTemplateTypeId!: any | undefined;
    orders!: OrderListDto[] | undefined;
    id!: number;

    constructor(data?: IRouteScheduleDetailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeCode = data["routeCode"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"] ? moment(data["estimatedTimeOfArrival"].toString()) : <any>undefined;
            this.cutOff = data["cutOff"] ? moment(data["cutOff"].toString()) : <any>undefined;
            this.automatic = data["automatic"];
            this.willCall = data["willCall"];
            this.isActive = data["isActive"];
            this.oorRate = data["oorRate"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.routeScheduleId = data["routeScheduleId"];
            this.routeTypeId = data["routeTypeId"];
            this.routeTemplateTypeId = data["routeTemplateTypeId"];
            if (Array.isArray(data["orders"])) {
                this.orders = [] as any;
                for (let item of data["orders"])
                    this.orders!.push(OrderListDto.fromJS(item));
            }
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteScheduleDetailDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteScheduleDetailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeCode"] = this.routeCode;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival ? this.estimatedTimeOfArrival.toISOString() : <any>undefined;
        data["cutOff"] = this.cutOff ? this.cutOff.toISOString() : <any>undefined;
        data["automatic"] = this.automatic;
        data["willCall"] = this.willCall;
        data["isActive"] = this.isActive;
        data["oorRate"] = this.oorRate;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["routeScheduleId"] = this.routeScheduleId;
        data["routeTypeId"] = this.routeTypeId;
        data["routeTemplateTypeId"] = this.routeTemplateTypeId;
        if (Array.isArray(this.orders)) {
            data["orders"] = [];
            for (let item of this.orders)
                data["orders"].push(item.toJSON());
        }
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteScheduleDetailDto {
    routeCode: string | undefined;
    estimatedTimeOfArrival: moment.Moment;
    cutOff: moment.Moment;
    automatic: boolean;
    willCall: boolean;
    isActive: boolean;
    oorRate: number | undefined;
    effectivityDate: moment.Moment | undefined;
    routeScheduleId: number;
    routeTypeId: number;
    routeTemplateTypeId: any | undefined;
    orders: OrderListDto[] | undefined;
    id: number;
}

export class OrderTypeDto implements IOrderTypeDto {
    code!: string | undefined;
    description!: string | undefined;
    isActive!: boolean;
    color!: string | undefined;
    textColor!: string | undefined;
    sortOrder!: number;
    id!: number;

    constructor(data?: IOrderTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.isActive = data["isActive"];
            this.color = data["color"];
            this.textColor = data["textColor"];
            this.sortOrder = data["sortOrder"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["isActive"] = this.isActive;
        data["color"] = this.color;
        data["textColor"] = this.textColor;
        data["sortOrder"] = this.sortOrder;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderTypeDto {
    code: string | undefined;
    description: string | undefined;
    isActive: boolean;
    color: string | undefined;
    textColor: string | undefined;
    sortOrder: number;
    id: number;
}

export class OrderListDto implements IOrderListDto {
    id!: number;
    tenantId!: number;
    user!: UserListDto | undefined;
    pickupDetail!: DestinationDetailListDto | undefined;
    deliveryDetail!: DestinationDetailListDto | undefined;
    location!: LocationListDto | undefined;
    route!: RouteListDto | undefined;
    note!: NoteListDto | undefined;
    orderStatus!: OrderStatusListDto | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;
    orderTags!: OrderTagListDto[] | undefined;
    orderStatusCollection!: OrderStatusListDto[] | undefined;
    proximityCode!: ProximityCodeListDto | undefined;
    creationTime!: moment.Moment;
    routeScheduleDetail!: RouteScheduleDetailDto | undefined;
    orderType!: OrderTypeDto | undefined;
    pickupEtaStart!: moment.Moment;
    deliveryEtaEnd!: moment.Moment;

    constructor(data?: IOrderListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? UserListDto.fromJS(data["user"]) : <any>undefined;
            this.pickupDetail = data["pickupDetail"] ? DestinationDetailListDto.fromJS(data["pickupDetail"]) : <any>undefined;
            this.deliveryDetail = data["deliveryDetail"] ? DestinationDetailListDto.fromJS(data["deliveryDetail"]) : <any>undefined;
            this.location = data["location"] ? LocationListDto.fromJS(data["location"]) : <any>undefined;
            this.route = data["route"] ? RouteListDto.fromJS(data["route"]) : <any>undefined;
            this.note = data["note"] ? NoteListDto.fromJS(data["note"]) : <any>undefined;
            this.orderStatus = data["orderStatus"] ? OrderStatusListDto.fromJS(data["orderStatus"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(OrderTagListDto.fromJS(item));
            }
            if (Array.isArray(data["orderStatusCollection"])) {
                this.orderStatusCollection = [] as any;
                for (let item of data["orderStatusCollection"])
                    this.orderStatusCollection!.push(OrderStatusListDto.fromJS(item));
            }
            this.proximityCode = data["proximityCode"] ? ProximityCodeListDto.fromJS(data["proximityCode"]) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.routeScheduleDetail = data["routeScheduleDetail"] ? RouteScheduleDetailDto.fromJS(data["routeScheduleDetail"]) : <any>undefined;
            this.orderType = data["orderType"] ? OrderTypeDto.fromJS(data["orderType"]) : <any>undefined;
            this.pickupEtaStart = data["pickupEtaStart"] ? moment(data["pickupEtaStart"].toString()) : <any>undefined;
            this.deliveryEtaEnd = data["deliveryEtaEnd"] ? moment(data["deliveryEtaEnd"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): OrderListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["pickupDetail"] = this.pickupDetail ? this.pickupDetail.toJSON() : <any>undefined;
        data["deliveryDetail"] = this.deliveryDetail ? this.deliveryDetail.toJSON() : <any>undefined;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["orderStatus"] = this.orderStatus ? this.orderStatus.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatusCollection)) {
            data["orderStatusCollection"] = [];
            for (let item of this.orderStatusCollection)
                data["orderStatusCollection"].push(item.toJSON());
        }
        data["proximityCode"] = this.proximityCode ? this.proximityCode.toJSON() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["routeScheduleDetail"] = this.routeScheduleDetail ? this.routeScheduleDetail.toJSON() : <any>undefined;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["pickupEtaStart"] = this.pickupEtaStart ? this.pickupEtaStart.toISOString() : <any>undefined;
        data["deliveryEtaEnd"] = this.deliveryEtaEnd ? this.deliveryEtaEnd.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IOrderListDto {
    id: number;
    tenantId: number;
    user: UserListDto | undefined;
    pickupDetail: DestinationDetailListDto | undefined;
    deliveryDetail: DestinationDetailListDto | undefined;
    location: LocationListDto | undefined;
    route: RouteListDto | undefined;
    note: NoteListDto | undefined;
    orderStatus: OrderStatusListDto | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
    orderTags: OrderTagListDto[] | undefined;
    orderStatusCollection: OrderStatusListDto[] | undefined;
    proximityCode: ProximityCodeListDto | undefined;
    creationTime: moment.Moment;
    routeScheduleDetail: RouteScheduleDetailDto | undefined;
    orderType: OrderTypeDto | undefined;
    pickupEtaStart: moment.Moment;
    deliveryEtaEnd: moment.Moment;
}

export class ProximityCodeListDto implements IProximityCodeListDto {
    id!: number;
    orderId!: number | undefined;
    order!: OrderListDto | undefined;
    geocode!: GeocodeListDto | undefined;
    geoCodeId!: number | undefined;
    value!: string | undefined;
    creationTime!: moment.Moment;
    lastModificationTime!: moment.Moment | undefined;
    modifiedByName!: string | undefined;
    modifiedBySurname!: string | undefined;
    isAccepted!: boolean;
    isDeliveryCode!: boolean;
    pickupCode!: string | undefined;
    deliveryCode!: string | undefined;

    constructor(data?: IProximityCodeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.orderId = data["orderId"];
            this.order = data["order"] ? OrderListDto.fromJS(data["order"]) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.geoCodeId = data["geoCodeId"];
            this.value = data["value"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.modifiedByName = data["modifiedByName"];
            this.modifiedBySurname = data["modifiedBySurname"];
            this.isAccepted = data["isAccepted"];
            this.isDeliveryCode = data["isDeliveryCode"];
            this.pickupCode = data["pickupCode"];
            this.deliveryCode = data["deliveryCode"];
        }
    }

    static fromJS(data: any): ProximityCodeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ProximityCodeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["orderId"] = this.orderId;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["geoCodeId"] = this.geoCodeId;
        data["value"] = this.value;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["modifiedByName"] = this.modifiedByName;
        data["modifiedBySurname"] = this.modifiedBySurname;
        data["isAccepted"] = this.isAccepted;
        data["isDeliveryCode"] = this.isDeliveryCode;
        data["pickupCode"] = this.pickupCode;
        data["deliveryCode"] = this.deliveryCode;
        return data; 
    }
}

export interface IProximityCodeListDto {
    id: number;
    orderId: number | undefined;
    order: OrderListDto | undefined;
    geocode: GeocodeListDto | undefined;
    geoCodeId: number | undefined;
    value: string | undefined;
    creationTime: moment.Moment;
    lastModificationTime: moment.Moment | undefined;
    modifiedByName: string | undefined;
    modifiedBySurname: string | undefined;
    isAccepted: boolean;
    isDeliveryCode: boolean;
    pickupCode: string | undefined;
    deliveryCode: string | undefined;
}

export class ZoneListDto implements IZoneListDto {
    tenantId!: number;
    name!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IZoneListDto {
    tenantId: number;
    name: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ControllerPostalCodeZoneDto implements IControllerPostalCodeZoneDto {
    zone!: ZoneListDto | undefined;

    constructor(data?: IControllerPostalCodeZoneDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.zone = data["zone"] ? ZoneListDto.fromJS(data["zone"]) : <any>undefined;
        }
    }

    static fromJS(data: any): ControllerPostalCodeZoneDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerPostalCodeZoneDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["zone"] = this.zone ? this.zone.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IControllerPostalCodeZoneDto {
    zone: ZoneListDto | undefined;
}

export class ControllerOrderDetailsDto implements IControllerOrderDetailsDto {
    id!: number;
    tenantId!: number;
    pickupDetail!: DestinationDetailListDto | undefined;
    deliveryDetail!: DestinationDetailListDto | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;
    packageCount!: number | undefined;
    orderStatus!: ControllerOrderStatusListDto | undefined;
    orderStatusDescription!: OrderStatusTypeDescriptionListDto | undefined;
    orderTags!: OrderTagListDto[] | undefined;
    proximityCode!: ProximityCodeListDto | undefined;
    notes!: string | undefined;
    notesVisibleToDriver!: boolean;
    postalCodeZone!: ControllerPostalCodeZoneDto | undefined;
    sortOrder!: number | undefined;
    action!: string | undefined;
    estimatedTimeOfArrival!: moment.Moment;
    pickUp!: boolean;
    delivered!: boolean;
    completed!: boolean;
    locked!: boolean;
    deliveryTime!: string | undefined;
    arriveTime!: string | undefined;
    attachmentCount!: number | undefined;
    markedAsDelivered!: boolean;
    orderType!: OrderTypeDto | undefined;
    ordertag!: string | undefined;
    orderPackageCount!: number;
    deliveryAddress!: string | undefined;
    pickupAddress!: string | undefined;
    lastStatusDateTime!: moment.Moment | undefined;
    orderExtras!: ControllerOrderExtraListDto[] | undefined;

    constructor(data?: IControllerOrderDetailsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.pickupDetail = data["pickupDetail"] ? DestinationDetailListDto.fromJS(data["pickupDetail"]) : <any>undefined;
            this.deliveryDetail = data["deliveryDetail"] ? DestinationDetailListDto.fromJS(data["deliveryDetail"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
            this.packageCount = data["packageCount"];
            this.orderStatus = data["orderStatus"] ? ControllerOrderStatusListDto.fromJS(data["orderStatus"]) : <any>undefined;
            this.orderStatusDescription = data["orderStatusDescription"] ? OrderStatusTypeDescriptionListDto.fromJS(data["orderStatusDescription"]) : <any>undefined;
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(OrderTagListDto.fromJS(item));
            }
            this.proximityCode = data["proximityCode"] ? ProximityCodeListDto.fromJS(data["proximityCode"]) : <any>undefined;
            this.notes = data["notes"];
            this.notesVisibleToDriver = data["notesVisibleToDriver"];
            this.postalCodeZone = data["postalCodeZone"] ? ControllerPostalCodeZoneDto.fromJS(data["postalCodeZone"]) : <any>undefined;
            this.sortOrder = data["sortOrder"];
            this.action = data["action"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"] ? moment(data["estimatedTimeOfArrival"].toString()) : <any>undefined;
            this.pickUp = data["pickUp"];
            this.delivered = data["delivered"];
            this.completed = data["completed"];
            this.locked = data["locked"];
            this.deliveryTime = data["deliveryTime"];
            this.arriveTime = data["arriveTime"];
            this.attachmentCount = data["attachmentCount"];
            this.markedAsDelivered = data["markedAsDelivered"];
            this.orderType = data["orderType"] ? OrderTypeDto.fromJS(data["orderType"]) : <any>undefined;
            this.ordertag = data["ordertag"];
            this.orderPackageCount = data["orderPackageCount"];
            this.deliveryAddress = data["deliveryAddress"];
            this.pickupAddress = data["pickupAddress"];
            this.lastStatusDateTime = data["lastStatusDateTime"] ? moment(data["lastStatusDateTime"].toString()) : <any>undefined;
            if (Array.isArray(data["orderExtras"])) {
                this.orderExtras = [] as any;
                for (let item of data["orderExtras"])
                    this.orderExtras!.push(ControllerOrderExtraListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ControllerOrderDetailsDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerOrderDetailsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["pickupDetail"] = this.pickupDetail ? this.pickupDetail.toJSON() : <any>undefined;
        data["deliveryDetail"] = this.deliveryDetail ? this.deliveryDetail.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        data["packageCount"] = this.packageCount;
        data["orderStatus"] = this.orderStatus ? this.orderStatus.toJSON() : <any>undefined;
        data["orderStatusDescription"] = this.orderStatusDescription ? this.orderStatusDescription.toJSON() : <any>undefined;
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        data["proximityCode"] = this.proximityCode ? this.proximityCode.toJSON() : <any>undefined;
        data["notes"] = this.notes;
        data["notesVisibleToDriver"] = this.notesVisibleToDriver;
        data["postalCodeZone"] = this.postalCodeZone ? this.postalCodeZone.toJSON() : <any>undefined;
        data["sortOrder"] = this.sortOrder;
        data["action"] = this.action;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival ? this.estimatedTimeOfArrival.toISOString() : <any>undefined;
        data["pickUp"] = this.pickUp;
        data["delivered"] = this.delivered;
        data["completed"] = this.completed;
        data["locked"] = this.locked;
        data["deliveryTime"] = this.deliveryTime;
        data["arriveTime"] = this.arriveTime;
        data["attachmentCount"] = this.attachmentCount;
        data["markedAsDelivered"] = this.markedAsDelivered;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["ordertag"] = this.ordertag;
        data["orderPackageCount"] = this.orderPackageCount;
        data["deliveryAddress"] = this.deliveryAddress;
        data["pickupAddress"] = this.pickupAddress;
        data["lastStatusDateTime"] = this.lastStatusDateTime ? this.lastStatusDateTime.toISOString() : <any>undefined;
        if (Array.isArray(this.orderExtras)) {
            data["orderExtras"] = [];
            for (let item of this.orderExtras)
                data["orderExtras"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IControllerOrderDetailsDto {
    id: number;
    tenantId: number;
    pickupDetail: DestinationDetailListDto | undefined;
    deliveryDetail: DestinationDetailListDto | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
    packageCount: number | undefined;
    orderStatus: ControllerOrderStatusListDto | undefined;
    orderStatusDescription: OrderStatusTypeDescriptionListDto | undefined;
    orderTags: OrderTagListDto[] | undefined;
    proximityCode: ProximityCodeListDto | undefined;
    notes: string | undefined;
    notesVisibleToDriver: boolean;
    postalCodeZone: ControllerPostalCodeZoneDto | undefined;
    sortOrder: number | undefined;
    action: string | undefined;
    estimatedTimeOfArrival: moment.Moment;
    pickUp: boolean;
    delivered: boolean;
    completed: boolean;
    locked: boolean;
    deliveryTime: string | undefined;
    arriveTime: string | undefined;
    attachmentCount: number | undefined;
    markedAsDelivered: boolean;
    orderType: OrderTypeDto | undefined;
    ordertag: string | undefined;
    orderPackageCount: number;
    deliveryAddress: string | undefined;
    pickupAddress: string | undefined;
    lastStatusDateTime: moment.Moment | undefined;
    orderExtras: ControllerOrderExtraListDto[] | undefined;
}

export class ListResultDtoOfControllerOrderDetailsDto implements IListResultDtoOfControllerOrderDetailsDto {
    items!: ControllerOrderDetailsDto[] | undefined;

    constructor(data?: IListResultDtoOfControllerOrderDetailsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ControllerOrderDetailsDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfControllerOrderDetailsDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfControllerOrderDetailsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfControllerOrderDetailsDto {
    items: ControllerOrderDetailsDto[] | undefined;
}

export class ControllerRouteDetailDto implements IControllerRouteDetailDto {
    tenantId!: number;
    vehicleId!: number | undefined;
    locationId!: number;
    routeTemplateId!: number;
    vehicle!: RouteVehicleListDto | undefined;
    location!: RouteLocationListDto | undefined;
    routeTemplate!: RouteTemplateListDto | undefined;
    loadDate!: moment.Moment;
    loadDateString!: string | undefined;
    completion!: moment.Moment | undefined;
    departure!: moment.Moment | undefined;
    estimatedStartTime!: moment.Moment | undefined;
    locked!: boolean;
    isVisibleToDriver!: boolean;
    driver!: string | undefined;
    notes!: string | undefined;
    parentRouteList!: ParentRouteListDto[] | undefined;
    utcOffset!: number;
    displayRouteId!: boolean;

    constructor(data?: IControllerRouteDetailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.vehicleId = data["vehicleId"];
            this.locationId = data["locationId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.vehicle = data["vehicle"] ? RouteVehicleListDto.fromJS(data["vehicle"]) : <any>undefined;
            this.location = data["location"] ? RouteLocationListDto.fromJS(data["location"]) : <any>undefined;
            this.routeTemplate = data["routeTemplate"] ? RouteTemplateListDto.fromJS(data["routeTemplate"]) : <any>undefined;
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.loadDateString = data["loadDateString"];
            this.completion = data["completion"] ? moment(data["completion"].toString()) : <any>undefined;
            this.departure = data["departure"] ? moment(data["departure"].toString()) : <any>undefined;
            this.estimatedStartTime = data["estimatedStartTime"] ? moment(data["estimatedStartTime"].toString()) : <any>undefined;
            this.locked = data["locked"];
            this.isVisibleToDriver = data["isVisibleToDriver"];
            this.driver = data["driver"];
            this.notes = data["notes"];
            if (Array.isArray(data["parentRouteList"])) {
                this.parentRouteList = [] as any;
                for (let item of data["parentRouteList"])
                    this.parentRouteList!.push(ParentRouteListDto.fromJS(item));
            }
            this.utcOffset = data["utcOffset"];
            this.displayRouteId = data["displayRouteId"];
        }
    }

    static fromJS(data: any): ControllerRouteDetailDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteDetailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["vehicleId"] = this.vehicleId;
        data["locationId"] = this.locationId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["loadDateString"] = this.loadDateString;
        data["completion"] = this.completion ? this.completion.toISOString() : <any>undefined;
        data["departure"] = this.departure ? this.departure.toISOString() : <any>undefined;
        data["estimatedStartTime"] = this.estimatedStartTime ? this.estimatedStartTime.toISOString() : <any>undefined;
        data["locked"] = this.locked;
        data["isVisibleToDriver"] = this.isVisibleToDriver;
        data["driver"] = this.driver;
        data["notes"] = this.notes;
        if (Array.isArray(this.parentRouteList)) {
            data["parentRouteList"] = [];
            for (let item of this.parentRouteList)
                data["parentRouteList"].push(item.toJSON());
        }
        data["utcOffset"] = this.utcOffset;
        data["displayRouteId"] = this.displayRouteId;
        return data; 
    }
}

export interface IControllerRouteDetailDto {
    tenantId: number;
    vehicleId: number | undefined;
    locationId: number;
    routeTemplateId: number;
    vehicle: RouteVehicleListDto | undefined;
    location: RouteLocationListDto | undefined;
    routeTemplate: RouteTemplateListDto | undefined;
    loadDate: moment.Moment;
    loadDateString: string | undefined;
    completion: moment.Moment | undefined;
    departure: moment.Moment | undefined;
    estimatedStartTime: moment.Moment | undefined;
    locked: boolean;
    isVisibleToDriver: boolean;
    driver: string | undefined;
    notes: string | undefined;
    parentRouteList: ParentRouteListDto[] | undefined;
    utcOffset: number;
    displayRouteId: boolean;
}

export class GetRouteInfo implements IGetRouteInfo {
    routeId!: number;
    driver!: string | undefined;
    userId!: number | undefined;

    constructor(data?: IGetRouteInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.driver = data["driver"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): GetRouteInfo {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["driver"] = this.driver;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IGetRouteInfo {
    routeId: number;
    driver: string | undefined;
    userId: number | undefined;
}

export class GetEditCountDetails implements IGetEditCountDetails {
    editCountBy!: string | undefined;
    notes!: string | undefined;
    editCountDate!: string | undefined;

    constructor(data?: IGetEditCountDetails) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.editCountBy = data["editCountBy"];
            this.notes = data["notes"];
            this.editCountDate = data["editCountDate"];
        }
    }

    static fromJS(data: any): GetEditCountDetails {
        data = typeof data === 'object' ? data : {};
        let result = new GetEditCountDetails();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["editCountBy"] = this.editCountBy;
        data["notes"] = this.notes;
        data["editCountDate"] = this.editCountDate;
        return data; 
    }
}

export interface IGetEditCountDetails {
    editCountBy: string | undefined;
    notes: string | undefined;
    editCountDate: string | undefined;
}

export class ControllerGetOrderIdForNoteInput implements IControllerGetOrderIdForNoteInput {
    orderId!: number;
    clinicId!: number;
    visibleToDriver!: boolean;
    noteId!: number | undefined;
    content!: string | undefined;

    constructor(data?: IControllerGetOrderIdForNoteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.clinicId = data["clinicId"];
            this.visibleToDriver = data["visibleToDriver"];
            this.noteId = data["noteId"];
            this.content = data["content"];
        }
    }

    static fromJS(data: any): ControllerGetOrderIdForNoteInput {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerGetOrderIdForNoteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["clinicId"] = this.clinicId;
        data["visibleToDriver"] = this.visibleToDriver;
        data["noteId"] = this.noteId;
        data["content"] = this.content;
        return data; 
    }
}

export interface IControllerGetOrderIdForNoteInput {
    orderId: number;
    clinicId: number;
    visibleToDriver: boolean;
    noteId: number | undefined;
    content: string | undefined;
}

export class ControllerVehicleListDto implements IControllerVehicleListDto {
    vehicleId!: number | undefined;
    name!: string | undefined;
    vehicleName!: string | undefined;
    surName!: string | undefined;
    firstName!: string | undefined;
    fullName!: string | undefined;
    activeRouteName!: string | undefined;
    activeRouteId!: number | undefined;
    routeId!: number | undefined;
    userId!: number | undefined;
    version!: number;

    constructor(data?: IControllerVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleId = data["vehicleId"];
            this.name = data["name"];
            this.vehicleName = data["vehicleName"];
            this.surName = data["surName"];
            this.firstName = data["firstName"];
            this.fullName = data["fullName"];
            this.activeRouteName = data["activeRouteName"];
            this.activeRouteId = data["activeRouteId"];
            this.routeId = data["routeId"];
            this.userId = data["userId"];
            this.version = data["version"];
        }
    }

    static fromJS(data: any): ControllerVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleId"] = this.vehicleId;
        data["name"] = this.name;
        data["vehicleName"] = this.vehicleName;
        data["surName"] = this.surName;
        data["firstName"] = this.firstName;
        data["fullName"] = this.fullName;
        data["activeRouteName"] = this.activeRouteName;
        data["activeRouteId"] = this.activeRouteId;
        data["routeId"] = this.routeId;
        data["userId"] = this.userId;
        data["version"] = this.version;
        return data; 
    }
}

export interface IControllerVehicleListDto {
    vehicleId: number | undefined;
    name: string | undefined;
    vehicleName: string | undefined;
    surName: string | undefined;
    firstName: string | undefined;
    fullName: string | undefined;
    activeRouteName: string | undefined;
    activeRouteId: number | undefined;
    routeId: number | undefined;
    userId: number | undefined;
    version: number;
}

export class ControllerGetAllAvailabelRouteDto implements IControllerGetAllAvailabelRouteDto {
    loadDate!: moment.Moment;
    vehicle!: ControllerVehicleListDto | undefined;
    routeId!: number;
    routeCode!: string | undefined;
    loadDateString!: string | undefined;

    constructor(data?: IControllerGetAllAvailabelRouteDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.vehicle = data["vehicle"] ? ControllerVehicleListDto.fromJS(data["vehicle"]) : <any>undefined;
            this.routeId = data["routeId"];
            this.routeCode = data["routeCode"];
            this.loadDateString = data["loadDateString"];
        }
    }

    static fromJS(data: any): ControllerGetAllAvailabelRouteDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerGetAllAvailabelRouteDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["routeId"] = this.routeId;
        data["routeCode"] = this.routeCode;
        data["loadDateString"] = this.loadDateString;
        return data; 
    }
}

export interface IControllerGetAllAvailabelRouteDto {
    loadDate: moment.Moment;
    vehicle: ControllerVehicleListDto | undefined;
    routeId: number;
    routeCode: string | undefined;
    loadDateString: string | undefined;
}

export class ListResultDtoOfControllerGetAllAvailabelRouteDto implements IListResultDtoOfControllerGetAllAvailabelRouteDto {
    items!: ControllerGetAllAvailabelRouteDto[] | undefined;

    constructor(data?: IListResultDtoOfControllerGetAllAvailabelRouteDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ControllerGetAllAvailabelRouteDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfControllerGetAllAvailabelRouteDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfControllerGetAllAvailabelRouteDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfControllerGetAllAvailabelRouteDto {
    items: ControllerGetAllAvailabelRouteDto[] | undefined;
}

export class GetControllerRouteLoadDateInputPage implements IGetControllerRouteLoadDateInputPage {
    loadDateStart!: moment.Moment;
    loadDateEnd!: moment.Moment;
    timeZoneValue!: string | undefined;
    operatingLocationId!: number | undefined;
    routeId!: number | undefined;
    orderId!: number | undefined;
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: IGetControllerRouteLoadDateInputPage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.loadDateStart = data["loadDateStart"] ? moment(data["loadDateStart"].toString()) : <any>undefined;
            this.loadDateEnd = data["loadDateEnd"] ? moment(data["loadDateEnd"].toString()) : <any>undefined;
            this.timeZoneValue = data["timeZoneValue"];
            this.operatingLocationId = data["operatingLocationId"];
            this.routeId = data["routeId"];
            this.orderId = data["orderId"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): GetControllerRouteLoadDateInputPage {
        data = typeof data === 'object' ? data : {};
        let result = new GetControllerRouteLoadDateInputPage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["loadDateStart"] = this.loadDateStart ? this.loadDateStart.toISOString() : <any>undefined;
        data["loadDateEnd"] = this.loadDateEnd ? this.loadDateEnd.toISOString() : <any>undefined;
        data["timeZoneValue"] = this.timeZoneValue;
        data["operatingLocationId"] = this.operatingLocationId;
        data["routeId"] = this.routeId;
        data["orderId"] = this.orderId;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface IGetControllerRouteLoadDateInputPage {
    loadDateStart: moment.Moment;
    loadDateEnd: moment.Moment;
    timeZoneValue: string | undefined;
    operatingLocationId: number | undefined;
    routeId: number | undefined;
    orderId: number | undefined;
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class ControllerDetailVehicleDto implements IControllerDetailVehicleDto {
    vehicleId!: number | undefined;
    name!: string | undefined;

    constructor(data?: IControllerDetailVehicleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleId = data["vehicleId"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): ControllerDetailVehicleDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerDetailVehicleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleId"] = this.vehicleId;
        data["name"] = this.name;
        return data; 
    }
}

export interface IControllerDetailVehicleDto {
    vehicleId: number | undefined;
    name: string | undefined;
}

export class SelectVehicleInput implements ISelectVehicleInput {
    vehicleId!: number;

    constructor(data?: ISelectVehicleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleId = data["vehicleId"];
        }
    }

    static fromJS(data: any): SelectVehicleInput {
        data = typeof data === 'object' ? data : {};
        let result = new SelectVehicleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleId"] = this.vehicleId;
        return data; 
    }
}

export interface ISelectVehicleInput {
    vehicleId: number;
}

export class UpdateDriverDto implements IUpdateDriverDto {
    vehicleId!: number | undefined;
    driverId!: number | undefined;
    routeId!: number;
    vehicleName!: string | undefined;
    driverName!: string | undefined;

    constructor(data?: IUpdateDriverDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleId = data["vehicleId"];
            this.driverId = data["driverId"];
            this.routeId = data["routeId"];
            this.vehicleName = data["vehicleName"];
            this.driverName = data["driverName"];
        }
    }

    static fromJS(data: any): UpdateDriverDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateDriverDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleId"] = this.vehicleId;
        data["driverId"] = this.driverId;
        data["routeId"] = this.routeId;
        data["vehicleName"] = this.vehicleName;
        data["driverName"] = this.driverName;
        return data; 
    }
}

export interface IUpdateDriverDto {
    vehicleId: number | undefined;
    driverId: number | undefined;
    routeId: number;
    vehicleName: string | undefined;
    driverName: string | undefined;
}

export class GetDriverVehicle implements IGetDriverVehicle {
    searchType!: string | undefined;
    filterId!: number;
    routeId!: number;
    previousDriverVehicleId!: number | undefined;

    constructor(data?: IGetDriverVehicle) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.searchType = data["searchType"];
            this.filterId = data["filterId"];
            this.routeId = data["routeId"];
            this.previousDriverVehicleId = data["previousDriverVehicleId"];
        }
    }

    static fromJS(data: any): GetDriverVehicle {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverVehicle();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["searchType"] = this.searchType;
        data["filterId"] = this.filterId;
        data["routeId"] = this.routeId;
        data["previousDriverVehicleId"] = this.previousDriverVehicleId;
        return data; 
    }
}

export interface IGetDriverVehicle {
    searchType: string | undefined;
    filterId: number;
    routeId: number;
    previousDriverVehicleId: number | undefined;
}

export class ContollerRouteLocationZoneDto implements IContollerRouteLocationZoneDto {
    name!: string | undefined;
    locationId!: number;
    zoneId!: number;

    constructor(data?: IContollerRouteLocationZoneDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.locationId = data["locationId"];
            this.zoneId = data["zoneId"];
        }
    }

    static fromJS(data: any): ContollerRouteLocationZoneDto {
        data = typeof data === 'object' ? data : {};
        let result = new ContollerRouteLocationZoneDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["locationId"] = this.locationId;
        data["zoneId"] = this.zoneId;
        return data; 
    }
}

export interface IContollerRouteLocationZoneDto {
    name: string | undefined;
    locationId: number;
    zoneId: number;
}

export class AddressIdInput implements IAddressIdInput {
    id!: number;
    geocodeId!: number;
    orderId!: number;
    value!: string | undefined;

    constructor(data?: IAddressIdInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.geocodeId = data["geocodeId"];
            this.orderId = data["orderId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): AddressIdInput {
        data = typeof data === 'object' ? data : {};
        let result = new AddressIdInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["geocodeId"] = this.geocodeId;
        data["orderId"] = this.orderId;
        data["value"] = this.value;
        return data; 
    }
}

export interface IAddressIdInput {
    id: number;
    geocodeId: number;
    orderId: number;
    value: string | undefined;
}

export class GeocodeIdInput implements IGeocodeIdInput {
    geocodeId!: number;
    addressId!: number;

    constructor(data?: IGeocodeIdInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.geocodeId = data["geocodeId"];
            this.addressId = data["addressId"];
        }
    }

    static fromJS(data: any): GeocodeIdInput {
        data = typeof data === 'object' ? data : {};
        let result = new GeocodeIdInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["geocodeId"] = this.geocodeId;
        data["addressId"] = this.addressId;
        return data; 
    }
}

export interface IGeocodeIdInput {
    geocodeId: number;
    addressId: number;
}

export class OrderNotesInput implements IOrderNotesInput {
    notes!: string | undefined;
    clinicNotesVisibleToDriver!: boolean;
    notesVisibleToDriver!: boolean;
    orderId!: number;

    constructor(data?: IOrderNotesInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.notes = data["notes"];
            this.clinicNotesVisibleToDriver = data["clinicNotesVisibleToDriver"];
            this.notesVisibleToDriver = data["notesVisibleToDriver"];
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): OrderNotesInput {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNotesInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["notes"] = this.notes;
        data["clinicNotesVisibleToDriver"] = this.clinicNotesVisibleToDriver;
        data["notesVisibleToDriver"] = this.notesVisibleToDriver;
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface IOrderNotesInput {
    notes: string | undefined;
    clinicNotesVisibleToDriver: boolean;
    notesVisibleToDriver: boolean;
    orderId: number;
}

export class DestinationContainerListItemDto implements IDestinationContainerListItemDto {
    tenantId!: number | undefined;
    routeId!: number;
    destinationId!: number;
    containerId!: number;
    container!: GetContainersItemListDto | undefined;
    quantity!: number;
    orderStatusTypeId!: number;
    time!: moment.Moment;
    geocodeId!: number | undefined;
    orderId!: number;

    constructor(data?: IDestinationContainerListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeId = data["routeId"];
            this.destinationId = data["destinationId"];
            this.containerId = data["containerId"];
            this.container = data["container"] ? GetContainersItemListDto.fromJS(data["container"]) : <any>undefined;
            this.quantity = data["quantity"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): DestinationContainerListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new DestinationContainerListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeId"] = this.routeId;
        data["destinationId"] = this.destinationId;
        data["containerId"] = this.containerId;
        data["container"] = this.container ? this.container.toJSON() : <any>undefined;
        data["quantity"] = this.quantity;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface IDestinationContainerListItemDto {
    tenantId: number | undefined;
    routeId: number;
    destinationId: number;
    containerId: number;
    container: GetContainersItemListDto | undefined;
    quantity: number;
    orderStatusTypeId: number;
    time: moment.Moment;
    geocodeId: number | undefined;
    orderId: number;
}

export class ControllerRouteClinicDto implements IControllerRouteClinicDto {
    id!: number;
    accountNo!: string | undefined;
    clinicNotesVisibleToDriver!: boolean;
    clinicNotes!: string | undefined;

    constructor(data?: IControllerRouteClinicDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.accountNo = data["accountNo"];
            this.clinicNotesVisibleToDriver = data["clinicNotesVisibleToDriver"];
            this.clinicNotes = data["clinicNotes"];
        }
    }

    static fromJS(data: any): ControllerRouteClinicDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerRouteClinicDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["accountNo"] = this.accountNo;
        data["clinicNotesVisibleToDriver"] = this.clinicNotesVisibleToDriver;
        data["clinicNotes"] = this.clinicNotes;
        return data; 
    }
}

export interface IControllerRouteClinicDto {
    id: number;
    accountNo: string | undefined;
    clinicNotesVisibleToDriver: boolean;
    clinicNotes: string | undefined;
}

export class RouteScheduleDto implements IRouteScheduleDto {
    clinicId!: number;
    id!: number;

    constructor(data?: IRouteScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteScheduleDto {
    clinicId: number;
    id: number;
}

export class DriverProximityDetails implements IDriverProximityDetails {
    orderId!: number;
    proximityCode!: string | undefined;
    deliveryAddress!: string | undefined;
    deliveryDate!: string | undefined;
    deliveryName!: string | undefined;
    pickupAddress!: string | undefined;
    pickupDate!: string | undefined;
    timeCreated!: string | undefined;
    lastModifierUser!: string | undefined;
    lastModificationTime!: string | undefined;
    isAccepted!: boolean;
    customer!: string | undefined;
    clinicName!: string | undefined;
    acctNo!: string | undefined;
    geocode!: GeocodeListDto | undefined;
    geocodeDel!: GeocodeListDto | undefined;
    geocodeStatus!: GeocodeListDto | undefined;
    lastStatus!: string | undefined;
    arrivalTime!: string | undefined;
    orderType!: string | undefined;
    eta!: string | undefined;
    addressId!: number | undefined;
    proximityId!: number;
    sortOrder!: number | undefined;

    constructor(data?: IDriverProximityDetails) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.proximityCode = data["proximityCode"];
            this.deliveryAddress = data["deliveryAddress"];
            this.deliveryDate = data["deliveryDate"];
            this.deliveryName = data["deliveryName"];
            this.pickupAddress = data["pickupAddress"];
            this.pickupDate = data["pickupDate"];
            this.timeCreated = data["timeCreated"];
            this.lastModifierUser = data["lastModifierUser"];
            this.lastModificationTime = data["lastModificationTime"];
            this.isAccepted = data["isAccepted"];
            this.customer = data["customer"];
            this.clinicName = data["clinicName"];
            this.acctNo = data["acctNo"];
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.geocodeDel = data["geocodeDel"] ? GeocodeListDto.fromJS(data["geocodeDel"]) : <any>undefined;
            this.geocodeStatus = data["geocodeStatus"] ? GeocodeListDto.fromJS(data["geocodeStatus"]) : <any>undefined;
            this.lastStatus = data["lastStatus"];
            this.arrivalTime = data["arrivalTime"];
            this.orderType = data["orderType"];
            this.eta = data["eta"];
            this.addressId = data["addressId"];
            this.proximityId = data["proximityId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): DriverProximityDetails {
        data = typeof data === 'object' ? data : {};
        let result = new DriverProximityDetails();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["proximityCode"] = this.proximityCode;
        data["deliveryAddress"] = this.deliveryAddress;
        data["deliveryDate"] = this.deliveryDate;
        data["deliveryName"] = this.deliveryName;
        data["pickupAddress"] = this.pickupAddress;
        data["pickupDate"] = this.pickupDate;
        data["timeCreated"] = this.timeCreated;
        data["lastModifierUser"] = this.lastModifierUser;
        data["lastModificationTime"] = this.lastModificationTime;
        data["isAccepted"] = this.isAccepted;
        data["customer"] = this.customer;
        data["clinicName"] = this.clinicName;
        data["acctNo"] = this.acctNo;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["geocodeDel"] = this.geocodeDel ? this.geocodeDel.toJSON() : <any>undefined;
        data["geocodeStatus"] = this.geocodeStatus ? this.geocodeStatus.toJSON() : <any>undefined;
        data["lastStatus"] = this.lastStatus;
        data["arrivalTime"] = this.arrivalTime;
        data["orderType"] = this.orderType;
        data["eta"] = this.eta;
        data["addressId"] = this.addressId;
        data["proximityId"] = this.proximityId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IDriverProximityDetails {
    orderId: number;
    proximityCode: string | undefined;
    deliveryAddress: string | undefined;
    deliveryDate: string | undefined;
    deliveryName: string | undefined;
    pickupAddress: string | undefined;
    pickupDate: string | undefined;
    timeCreated: string | undefined;
    lastModifierUser: string | undefined;
    lastModificationTime: string | undefined;
    isAccepted: boolean;
    customer: string | undefined;
    clinicName: string | undefined;
    acctNo: string | undefined;
    geocode: GeocodeListDto | undefined;
    geocodeDel: GeocodeListDto | undefined;
    geocodeStatus: GeocodeListDto | undefined;
    lastStatus: string | undefined;
    arrivalTime: string | undefined;
    orderType: string | undefined;
    eta: string | undefined;
    addressId: number | undefined;
    proximityId: number;
    sortOrder: number | undefined;
}

export class HandOffRouteDto implements IHandOffRouteDto {
    routeId!: number | undefined;
    name!: string | undefined;
    location!: string | undefined;
    timeZone!: string | undefined;
    timezoneAbbr!: string | undefined;
    routeTemplateId!: number;

    constructor(data?: IHandOffRouteDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.name = data["name"];
            this.location = data["location"];
            this.timeZone = data["timeZone"];
            this.timezoneAbbr = data["timezoneAbbr"];
            this.routeTemplateId = data["routeTemplateId"];
        }
    }

    static fromJS(data: any): HandOffRouteDto {
        data = typeof data === 'object' ? data : {};
        let result = new HandOffRouteDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["name"] = this.name;
        data["location"] = this.location;
        data["timeZone"] = this.timeZone;
        data["timezoneAbbr"] = this.timezoneAbbr;
        data["routeTemplateId"] = this.routeTemplateId;
        return data; 
    }
}

export interface IHandOffRouteDto {
    routeId: number | undefined;
    name: string | undefined;
    location: string | undefined;
    timeZone: string | undefined;
    timezoneAbbr: string | undefined;
    routeTemplateId: number;
}

export class ControllerScheduleDetailDto implements IControllerScheduleDetailDto {
    id!: number;
    pickupDetail!: DestinationDetailListDto | undefined;
    deliveryDetail!: DestinationDetailListDto | undefined;
    orderStatus!: ControllerOrderStatusListDto | undefined;
    orderStatusDescription!: OrderStatusTypeDescriptionListDto | undefined;
    proximityCode!: ProximityCodeListDto | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;
    orderContainers!: DestinationContainerListItemDto[] | undefined;
    routeCode!: string | undefined;
    estimatedTimeOfArrival!: moment.Moment;
    lta!: string | undefined;
    clinic!: ControllerRouteClinicDto | undefined;
    company!: GetCompaniesListItemDto | undefined;
    packageCount!: number;
    lineHaulCount!: number;
    action!: string | undefined;
    orderExtras!: ControllerOrderExtraListDto[] | undefined;
    routeSchedule!: RouteScheduleDto | undefined;
    completion!: moment.Moment | undefined;
    sortOrder!: number | undefined;
    notes!: string | undefined;
    pickUp!: boolean;
    delivered!: boolean;
    completed!: boolean;
    locked!: boolean;
    orderType!: OrderTypeDto | undefined;
    eta!: string | undefined;
    deliveryTime!: string | undefined;
    arriveTime!: string | undefined;
    completionString!: string | undefined;
    driverName!: string | undefined;
    proximityCodeLastModificationTime!: string | undefined;
    loadDate!: moment.Moment | undefined;
    attachmentCount!: number | undefined;
    routeScheduleId!: number | undefined;
    createdBy!: string | undefined;
    modifiedBy!: string | undefined;
    clinicNotesVisibleToDriver!: boolean;
    arrivalTime!: moment.Moment | undefined;
    deliveredTime!: moment.Moment | undefined;
    driverProximityDetails!: DriverProximityDetails | undefined;
    empty!: boolean | undefined;
    stopTime!: string | undefined;
    routeEndTime!: moment.Moment;
    routeId!: number | undefined;
    handOffRoute!: HandOffRouteDto | undefined;
    meetPointRoute!: HandOffRouteDto | undefined;
    endPointRoute!: HandOffRouteDto | undefined;
    clinicIsActive!: boolean;
    markedAsDelivered!: boolean;
    routeScheduleDetailId!: number | undefined;
    etaCode!: string | undefined;

    constructor(data?: IControllerScheduleDetailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.pickupDetail = data["pickupDetail"] ? DestinationDetailListDto.fromJS(data["pickupDetail"]) : <any>undefined;
            this.deliveryDetail = data["deliveryDetail"] ? DestinationDetailListDto.fromJS(data["deliveryDetail"]) : <any>undefined;
            this.orderStatus = data["orderStatus"] ? ControllerOrderStatusListDto.fromJS(data["orderStatus"]) : <any>undefined;
            this.orderStatusDescription = data["orderStatusDescription"] ? OrderStatusTypeDescriptionListDto.fromJS(data["orderStatusDescription"]) : <any>undefined;
            this.proximityCode = data["proximityCode"] ? ProximityCodeListDto.fromJS(data["proximityCode"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
            if (Array.isArray(data["orderContainers"])) {
                this.orderContainers = [] as any;
                for (let item of data["orderContainers"])
                    this.orderContainers!.push(DestinationContainerListItemDto.fromJS(item));
            }
            this.routeCode = data["routeCode"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"] ? moment(data["estimatedTimeOfArrival"].toString()) : <any>undefined;
            this.lta = data["lta"];
            this.clinic = data["clinic"] ? ControllerRouteClinicDto.fromJS(data["clinic"]) : <any>undefined;
            this.company = data["company"] ? GetCompaniesListItemDto.fromJS(data["company"]) : <any>undefined;
            this.packageCount = data["packageCount"];
            this.lineHaulCount = data["lineHaulCount"];
            this.action = data["action"];
            if (Array.isArray(data["orderExtras"])) {
                this.orderExtras = [] as any;
                for (let item of data["orderExtras"])
                    this.orderExtras!.push(ControllerOrderExtraListDto.fromJS(item));
            }
            this.routeSchedule = data["routeSchedule"] ? RouteScheduleDto.fromJS(data["routeSchedule"]) : <any>undefined;
            this.completion = data["completion"] ? moment(data["completion"].toString()) : <any>undefined;
            this.sortOrder = data["sortOrder"];
            this.notes = data["notes"];
            this.pickUp = data["pickUp"];
            this.delivered = data["delivered"];
            this.completed = data["completed"];
            this.locked = data["locked"];
            this.orderType = data["orderType"] ? OrderTypeDto.fromJS(data["orderType"]) : <any>undefined;
            this.eta = data["eta"];
            this.deliveryTime = data["deliveryTime"];
            this.arriveTime = data["arriveTime"];
            this.completionString = data["completionString"];
            this.driverName = data["driverName"];
            this.proximityCodeLastModificationTime = data["proximityCodeLastModificationTime"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.attachmentCount = data["attachmentCount"];
            this.routeScheduleId = data["routeScheduleId"];
            this.createdBy = data["createdBy"];
            this.modifiedBy = data["modifiedBy"];
            this.clinicNotesVisibleToDriver = data["clinicNotesVisibleToDriver"];
            this.arrivalTime = data["arrivalTime"] ? moment(data["arrivalTime"].toString()) : <any>undefined;
            this.deliveredTime = data["deliveredTime"] ? moment(data["deliveredTime"].toString()) : <any>undefined;
            this.driverProximityDetails = data["driverProximityDetails"] ? DriverProximityDetails.fromJS(data["driverProximityDetails"]) : <any>undefined;
            this.empty = data["empty"];
            this.stopTime = data["stopTime"];
            this.routeEndTime = data["routeEndTime"] ? moment(data["routeEndTime"].toString()) : <any>undefined;
            this.routeId = data["routeId"];
            this.handOffRoute = data["handOffRoute"] ? HandOffRouteDto.fromJS(data["handOffRoute"]) : <any>undefined;
            this.meetPointRoute = data["meetPointRoute"] ? HandOffRouteDto.fromJS(data["meetPointRoute"]) : <any>undefined;
            this.endPointRoute = data["endPointRoute"] ? HandOffRouteDto.fromJS(data["endPointRoute"]) : <any>undefined;
            this.clinicIsActive = data["clinicIsActive"];
            this.markedAsDelivered = data["markedAsDelivered"];
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.etaCode = data["etaCode"];
        }
    }

    static fromJS(data: any): ControllerScheduleDetailDto {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerScheduleDetailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["pickupDetail"] = this.pickupDetail ? this.pickupDetail.toJSON() : <any>undefined;
        data["deliveryDetail"] = this.deliveryDetail ? this.deliveryDetail.toJSON() : <any>undefined;
        data["orderStatus"] = this.orderStatus ? this.orderStatus.toJSON() : <any>undefined;
        data["orderStatusDescription"] = this.orderStatusDescription ? this.orderStatusDescription.toJSON() : <any>undefined;
        data["proximityCode"] = this.proximityCode ? this.proximityCode.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.orderContainers)) {
            data["orderContainers"] = [];
            for (let item of this.orderContainers)
                data["orderContainers"].push(item.toJSON());
        }
        data["routeCode"] = this.routeCode;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival ? this.estimatedTimeOfArrival.toISOString() : <any>undefined;
        data["lta"] = this.lta;
        data["clinic"] = this.clinic ? this.clinic.toJSON() : <any>undefined;
        data["company"] = this.company ? this.company.toJSON() : <any>undefined;
        data["packageCount"] = this.packageCount;
        data["lineHaulCount"] = this.lineHaulCount;
        data["action"] = this.action;
        if (Array.isArray(this.orderExtras)) {
            data["orderExtras"] = [];
            for (let item of this.orderExtras)
                data["orderExtras"].push(item.toJSON());
        }
        data["routeSchedule"] = this.routeSchedule ? this.routeSchedule.toJSON() : <any>undefined;
        data["completion"] = this.completion ? this.completion.toISOString() : <any>undefined;
        data["sortOrder"] = this.sortOrder;
        data["notes"] = this.notes;
        data["pickUp"] = this.pickUp;
        data["delivered"] = this.delivered;
        data["completed"] = this.completed;
        data["locked"] = this.locked;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["eta"] = this.eta;
        data["deliveryTime"] = this.deliveryTime;
        data["arriveTime"] = this.arriveTime;
        data["completionString"] = this.completionString;
        data["driverName"] = this.driverName;
        data["proximityCodeLastModificationTime"] = this.proximityCodeLastModificationTime;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["attachmentCount"] = this.attachmentCount;
        data["routeScheduleId"] = this.routeScheduleId;
        data["createdBy"] = this.createdBy;
        data["modifiedBy"] = this.modifiedBy;
        data["clinicNotesVisibleToDriver"] = this.clinicNotesVisibleToDriver;
        data["arrivalTime"] = this.arrivalTime ? this.arrivalTime.toISOString() : <any>undefined;
        data["deliveredTime"] = this.deliveredTime ? this.deliveredTime.toISOString() : <any>undefined;
        data["driverProximityDetails"] = this.driverProximityDetails ? this.driverProximityDetails.toJSON() : <any>undefined;
        data["empty"] = this.empty;
        data["stopTime"] = this.stopTime;
        data["routeEndTime"] = this.routeEndTime ? this.routeEndTime.toISOString() : <any>undefined;
        data["routeId"] = this.routeId;
        data["handOffRoute"] = this.handOffRoute ? this.handOffRoute.toJSON() : <any>undefined;
        data["meetPointRoute"] = this.meetPointRoute ? this.meetPointRoute.toJSON() : <any>undefined;
        data["endPointRoute"] = this.endPointRoute ? this.endPointRoute.toJSON() : <any>undefined;
        data["clinicIsActive"] = this.clinicIsActive;
        data["markedAsDelivered"] = this.markedAsDelivered;
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["etaCode"] = this.etaCode;
        return data; 
    }
}

export interface IControllerScheduleDetailDto {
    id: number;
    pickupDetail: DestinationDetailListDto | undefined;
    deliveryDetail: DestinationDetailListDto | undefined;
    orderStatus: ControllerOrderStatusListDto | undefined;
    orderStatusDescription: OrderStatusTypeDescriptionListDto | undefined;
    proximityCode: ProximityCodeListDto | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
    orderContainers: DestinationContainerListItemDto[] | undefined;
    routeCode: string | undefined;
    estimatedTimeOfArrival: moment.Moment;
    lta: string | undefined;
    clinic: ControllerRouteClinicDto | undefined;
    company: GetCompaniesListItemDto | undefined;
    packageCount: number;
    lineHaulCount: number;
    action: string | undefined;
    orderExtras: ControllerOrderExtraListDto[] | undefined;
    routeSchedule: RouteScheduleDto | undefined;
    completion: moment.Moment | undefined;
    sortOrder: number | undefined;
    notes: string | undefined;
    pickUp: boolean;
    delivered: boolean;
    completed: boolean;
    locked: boolean;
    orderType: OrderTypeDto | undefined;
    eta: string | undefined;
    deliveryTime: string | undefined;
    arriveTime: string | undefined;
    completionString: string | undefined;
    driverName: string | undefined;
    proximityCodeLastModificationTime: string | undefined;
    loadDate: moment.Moment | undefined;
    attachmentCount: number | undefined;
    routeScheduleId: number | undefined;
    createdBy: string | undefined;
    modifiedBy: string | undefined;
    clinicNotesVisibleToDriver: boolean;
    arrivalTime: moment.Moment | undefined;
    deliveredTime: moment.Moment | undefined;
    driverProximityDetails: DriverProximityDetails | undefined;
    empty: boolean | undefined;
    stopTime: string | undefined;
    routeEndTime: moment.Moment;
    routeId: number | undefined;
    handOffRoute: HandOffRouteDto | undefined;
    meetPointRoute: HandOffRouteDto | undefined;
    endPointRoute: HandOffRouteDto | undefined;
    clinicIsActive: boolean;
    markedAsDelivered: boolean;
    routeScheduleDetailId: number | undefined;
    etaCode: string | undefined;
}

export class ListResultDtoOfControllerScheduleDetailDto implements IListResultDtoOfControllerScheduleDetailDto {
    items!: ControllerScheduleDetailDto[] | undefined;

    constructor(data?: IListResultDtoOfControllerScheduleDetailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ControllerScheduleDetailDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfControllerScheduleDetailDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfControllerScheduleDetailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfControllerScheduleDetailDto {
    items: ControllerScheduleDetailDto[] | undefined;
}

export class CreateBatchOptimizeInputDto implements ICreateBatchOptimizeInputDto {
    routeCode!: string | undefined;
    version!: string | undefined;

    constructor(data?: ICreateBatchOptimizeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeCode = data["routeCode"];
            this.version = data["version"];
        }
    }

    static fromJS(data: any): CreateBatchOptimizeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateBatchOptimizeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeCode"] = this.routeCode;
        data["version"] = this.version;
        return data; 
    }
}

export interface ICreateBatchOptimizeInputDto {
    routeCode: string | undefined;
    version: string | undefined;
}

export class DriverListInput implements IDriverListInput {
    tenantId!: number | undefined;
    locationId!: number;
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: IDriverListInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.locationId = data["locationId"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): DriverListInput {
        data = typeof data === 'object' ? data : {};
        let result = new DriverListInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["locationId"] = this.locationId;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface IDriverListInput {
    tenantId: number | undefined;
    locationId: number;
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class VehicleInput implements IVehicleInput {
    driverId!: number;
    routeId!: number;

    constructor(data?: IVehicleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverId = data["driverId"];
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): VehicleInput {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverId"] = this.driverId;
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface IVehicleInput {
    driverId: number;
    routeId: number;
}

export class UpdateRouteByStopInput implements IUpdateRouteByStopInput {
    contactId!: number;
    routeId!: number;
    loadDate!: moment.Moment;
    routeComplete!: boolean;

    constructor(data?: IUpdateRouteByStopInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.routeId = data["routeId"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.routeComplete = data["routeComplete"];
        }
    }

    static fromJS(data: any): UpdateRouteByStopInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteByStopInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["routeId"] = this.routeId;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["routeComplete"] = this.routeComplete;
        return data; 
    }
}

export interface IUpdateRouteByStopInput {
    contactId: number;
    routeId: number;
    loadDate: moment.Moment;
    routeComplete: boolean;
}

export class PagedResultDtoOfControllerVehicleListDto implements IPagedResultDtoOfControllerVehicleListDto {
    totalCount!: number;
    items!: ControllerVehicleListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfControllerVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ControllerVehicleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfControllerVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfControllerVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfControllerVehicleListDto {
    totalCount: number;
    items: ControllerVehicleListDto[] | undefined;
}

export class GetVehicleForViewDto implements IGetVehicleForViewDto {
    name!: string | undefined;
    licenseNumber!: string | undefined;
    userId!: number | undefined;

    constructor(data?: IGetVehicleForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): GetVehicleForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IGetVehicleForViewDto {
    name: string | undefined;
    licenseNumber: string | undefined;
    userId: number | undefined;
}

export class GetVehicleRoutesResult implements IGetVehicleRoutesResult {
    routeId!: number;
    routeDate!: moment.Moment;
    driverName!: string | undefined;
    stops!: number;
    miles!: number;
    userId!: number | undefined;

    constructor(data?: IGetVehicleRoutesResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.routeDate = data["routeDate"] ? moment(data["routeDate"].toString()) : <any>undefined;
            this.driverName = data["driverName"];
            this.stops = data["stops"];
            this.miles = data["miles"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): GetVehicleRoutesResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleRoutesResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["routeDate"] = this.routeDate ? this.routeDate.toISOString() : <any>undefined;
        data["driverName"] = this.driverName;
        data["stops"] = this.stops;
        data["miles"] = this.miles;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IGetVehicleRoutesResult {
    routeId: number;
    routeDate: moment.Moment;
    driverName: string | undefined;
    stops: number;
    miles: number;
    userId: number | undefined;
}

export class PagedResultDtoOfGetVehicleRoutesResult implements IPagedResultDtoOfGetVehicleRoutesResult {
    totalCount!: number;
    items!: GetVehicleRoutesResult[] | undefined;

    constructor(data?: IPagedResultDtoOfGetVehicleRoutesResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetVehicleRoutesResult.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetVehicleRoutesResult {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetVehicleRoutesResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetVehicleRoutesResult {
    totalCount: number;
    items: GetVehicleRoutesResult[] | undefined;
}

export class ContactInfo implements IContactInfo {
    phone!: string | undefined;
    name!: string | undefined;
    surname!: string | undefined;
    email!: string | undefined;
    username!: string | undefined;
    password!: string | undefined;
    userId!: number | undefined;
    contactId!: number;
    addressId!: number | undefined;
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    postalCode!: string | undefined;
    country!: string | undefined;
    latitude!: number;
    longitude!: number;
    addressTypeName!: string | undefined;
    addressTypeId!: number | undefined;
    profilePicture!: string | undefined;
    isUserActive!: boolean;

    constructor(data?: IContactInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.phone = data["phone"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.email = data["email"];
            this.username = data["username"];
            this.password = data["password"];
            this.userId = data["userId"];
            this.contactId = data["contactId"];
            this.addressId = data["addressId"];
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.city = data["city"];
            this.state = data["state"];
            this.postalCode = data["postalCode"];
            this.country = data["country"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.addressTypeName = data["addressTypeName"];
            this.addressTypeId = data["addressTypeId"];
            this.profilePicture = data["profilePicture"];
            this.isUserActive = data["isUserActive"];
        }
    }

    static fromJS(data: any): ContactInfo {
        data = typeof data === 'object' ? data : {};
        let result = new ContactInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["phone"] = this.phone;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["email"] = this.email;
        data["username"] = this.username;
        data["password"] = this.password;
        data["userId"] = this.userId;
        data["contactId"] = this.contactId;
        data["addressId"] = this.addressId;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["city"] = this.city;
        data["state"] = this.state;
        data["postalCode"] = this.postalCode;
        data["country"] = this.country;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["addressTypeName"] = this.addressTypeName;
        data["addressTypeId"] = this.addressTypeId;
        data["profilePicture"] = this.profilePicture;
        data["isUserActive"] = this.isUserActive;
        return data; 
    }
}

export interface IContactInfo {
    phone: string | undefined;
    name: string | undefined;
    surname: string | undefined;
    email: string | undefined;
    username: string | undefined;
    password: string | undefined;
    userId: number | undefined;
    contactId: number;
    addressId: number | undefined;
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    city: string | undefined;
    state: string | undefined;
    postalCode: string | undefined;
    country: string | undefined;
    latitude: number;
    longitude: number;
    addressTypeName: string | undefined;
    addressTypeId: number | undefined;
    profilePicture: string | undefined;
    isUserActive: boolean;
}

export class GetCustomerProfileDto implements IGetCustomerProfileDto {
    customerInfo!: ContactInfo | undefined;
    contactPersonInfo!: ContactInfo | undefined;
    clinicName!: string | undefined;
    accountNo!: string | undefined;
    clinicId!: number;
    isActive!: boolean;
    mondayNote!: string | undefined;
    tuesdayNote!: string | undefined;
    wednesdayNote!: string | undefined;
    thursdayNote!: string | undefined;
    fridayNote!: string | undefined;
    saturdayNote!: string | undefined;
    sundayNote!: string | undefined;
    aarrivalString!: string | undefined;
    profilePicture!: string | undefined;

    constructor(data?: IGetCustomerProfileDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.customerInfo = data["customerInfo"] ? ContactInfo.fromJS(data["customerInfo"]) : <any>undefined;
            this.contactPersonInfo = data["contactPersonInfo"] ? ContactInfo.fromJS(data["contactPersonInfo"]) : <any>undefined;
            this.clinicName = data["clinicName"];
            this.accountNo = data["accountNo"];
            this.clinicId = data["clinicId"];
            this.isActive = data["isActive"];
            this.mondayNote = data["mondayNote"];
            this.tuesdayNote = data["tuesdayNote"];
            this.wednesdayNote = data["wednesdayNote"];
            this.thursdayNote = data["thursdayNote"];
            this.fridayNote = data["fridayNote"];
            this.saturdayNote = data["saturdayNote"];
            this.sundayNote = data["sundayNote"];
            this.aarrivalString = data["aarrivalString"];
            this.profilePicture = data["profilePicture"];
        }
    }

    static fromJS(data: any): GetCustomerProfileDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetCustomerProfileDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["customerInfo"] = this.customerInfo ? this.customerInfo.toJSON() : <any>undefined;
        data["contactPersonInfo"] = this.contactPersonInfo ? this.contactPersonInfo.toJSON() : <any>undefined;
        data["clinicName"] = this.clinicName;
        data["accountNo"] = this.accountNo;
        data["clinicId"] = this.clinicId;
        data["isActive"] = this.isActive;
        data["mondayNote"] = this.mondayNote;
        data["tuesdayNote"] = this.tuesdayNote;
        data["wednesdayNote"] = this.wednesdayNote;
        data["thursdayNote"] = this.thursdayNote;
        data["fridayNote"] = this.fridayNote;
        data["saturdayNote"] = this.saturdayNote;
        data["sundayNote"] = this.sundayNote;
        data["aarrivalString"] = this.aarrivalString;
        data["profilePicture"] = this.profilePicture;
        return data; 
    }
}

export interface IGetCustomerProfileDto {
    customerInfo: ContactInfo | undefined;
    contactPersonInfo: ContactInfo | undefined;
    clinicName: string | undefined;
    accountNo: string | undefined;
    clinicId: number;
    isActive: boolean;
    mondayNote: string | undefined;
    tuesdayNote: string | undefined;
    wednesdayNote: string | undefined;
    thursdayNote: string | undefined;
    fridayNote: string | undefined;
    saturdayNote: string | undefined;
    sundayNote: string | undefined;
    aarrivalString: string | undefined;
    profilePicture: string | undefined;
}

export class UpdateCustomerProfileInput implements IUpdateCustomerProfileInput {
    clinicName!: string | undefined;
    accountNo!: string | undefined;
    phone!: string | undefined;
    name!: string | undefined;
    surname!: string | undefined;
    password!: string | undefined;
    email!: string | undefined;
    username!: string | undefined;
    isActive!: boolean;
    isUserActive!: boolean;
    contactId!: number | undefined;
    userId!: number;
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    formattedAddress!: string | undefined;
    postalCodeValue!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    country!: string | undefined;
    latitude!: number;
    longitude!: number;
    addressTypeName!: string | undefined;
    mondayNote!: string | undefined;
    tuesdayNote!: string | undefined;
    wednesdayNote!: string | undefined;
    thursdayNote!: string | undefined;
    fridayNote!: string | undefined;
    saturdayNote!: string | undefined;
    sundayNote!: string | undefined;
    arrivalAlert!: string | undefined;
    grantedPermissionNames!: string[] | undefined;
    assignedRoleNames!: string[] | undefined;

    constructor(data?: IUpdateCustomerProfileInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicName = data["clinicName"];
            this.accountNo = data["accountNo"];
            this.phone = data["phone"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.password = data["password"];
            this.email = data["email"];
            this.username = data["username"];
            this.isActive = data["isActive"];
            this.isUserActive = data["isUserActive"];
            this.contactId = data["contactId"];
            this.userId = data["userId"];
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.formattedAddress = data["formattedAddress"];
            this.postalCodeValue = data["postalCodeValue"];
            this.city = data["city"];
            this.state = data["state"];
            this.country = data["country"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.addressTypeName = data["addressTypeName"];
            this.mondayNote = data["mondayNote"];
            this.tuesdayNote = data["tuesdayNote"];
            this.wednesdayNote = data["wednesdayNote"];
            this.thursdayNote = data["thursdayNote"];
            this.fridayNote = data["fridayNote"];
            this.saturdayNote = data["saturdayNote"];
            this.sundayNote = data["sundayNote"];
            this.arrivalAlert = data["arrivalAlert"];
            if (Array.isArray(data["grantedPermissionNames"])) {
                this.grantedPermissionNames = [] as any;
                for (let item of data["grantedPermissionNames"])
                    this.grantedPermissionNames!.push(item);
            }
            if (Array.isArray(data["assignedRoleNames"])) {
                this.assignedRoleNames = [] as any;
                for (let item of data["assignedRoleNames"])
                    this.assignedRoleNames!.push(item);
            }
        }
    }

    static fromJS(data: any): UpdateCustomerProfileInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateCustomerProfileInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicName"] = this.clinicName;
        data["accountNo"] = this.accountNo;
        data["phone"] = this.phone;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["password"] = this.password;
        data["email"] = this.email;
        data["username"] = this.username;
        data["isActive"] = this.isActive;
        data["isUserActive"] = this.isUserActive;
        data["contactId"] = this.contactId;
        data["userId"] = this.userId;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["formattedAddress"] = this.formattedAddress;
        data["postalCodeValue"] = this.postalCodeValue;
        data["city"] = this.city;
        data["state"] = this.state;
        data["country"] = this.country;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["addressTypeName"] = this.addressTypeName;
        data["mondayNote"] = this.mondayNote;
        data["tuesdayNote"] = this.tuesdayNote;
        data["wednesdayNote"] = this.wednesdayNote;
        data["thursdayNote"] = this.thursdayNote;
        data["fridayNote"] = this.fridayNote;
        data["saturdayNote"] = this.saturdayNote;
        data["sundayNote"] = this.sundayNote;
        data["arrivalAlert"] = this.arrivalAlert;
        if (Array.isArray(this.grantedPermissionNames)) {
            data["grantedPermissionNames"] = [];
            for (let item of this.grantedPermissionNames)
                data["grantedPermissionNames"].push(item);
        }
        if (Array.isArray(this.assignedRoleNames)) {
            data["assignedRoleNames"] = [];
            for (let item of this.assignedRoleNames)
                data["assignedRoleNames"].push(item);
        }
        return data; 
    }
}

export interface IUpdateCustomerProfileInput {
    clinicName: string | undefined;
    accountNo: string | undefined;
    phone: string | undefined;
    name: string | undefined;
    surname: string | undefined;
    password: string | undefined;
    email: string | undefined;
    username: string | undefined;
    isActive: boolean;
    isUserActive: boolean;
    contactId: number | undefined;
    userId: number;
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    formattedAddress: string | undefined;
    postalCodeValue: string | undefined;
    city: string | undefined;
    state: string | undefined;
    country: string | undefined;
    latitude: number;
    longitude: number;
    addressTypeName: string | undefined;
    mondayNote: string | undefined;
    tuesdayNote: string | undefined;
    wednesdayNote: string | undefined;
    thursdayNote: string | undefined;
    fridayNote: string | undefined;
    saturdayNote: string | undefined;
    sundayNote: string | undefined;
    arrivalAlert: string | undefined;
    grantedPermissionNames: string[] | undefined;
    assignedRoleNames: string[] | undefined;
}

export class GetCustomerAddressForEdit implements IGetCustomerAddressForEdit {
    contactId!: number | undefined;
    address!: GetAddressForEditOutput | undefined;

    constructor(data?: IGetCustomerAddressForEdit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.address = data["address"] ? GetAddressForEditOutput.fromJS(data["address"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetCustomerAddressForEdit {
        data = typeof data === 'object' ? data : {};
        let result = new GetCustomerAddressForEdit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetCustomerAddressForEdit {
    contactId: number | undefined;
    address: GetAddressForEditOutput | undefined;
}

export class UpdateCustomerAddressInput implements IUpdateCustomerAddressInput {
    addressId!: number;
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    formattedAddress!: string | undefined;
    postalCodeValue!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    country!: string | undefined;
    latitude!: number;
    longitude!: number;
    addressTypeName!: string | undefined;
    contactId!: number;
    addressTypeId!: number | undefined;

    constructor(data?: IUpdateCustomerAddressInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressId = data["addressId"];
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.formattedAddress = data["formattedAddress"];
            this.postalCodeValue = data["postalCodeValue"];
            this.city = data["city"];
            this.state = data["state"];
            this.country = data["country"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.addressTypeName = data["addressTypeName"];
            this.contactId = data["contactId"];
            this.addressTypeId = data["addressTypeId"];
        }
    }

    static fromJS(data: any): UpdateCustomerAddressInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateCustomerAddressInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressId"] = this.addressId;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["formattedAddress"] = this.formattedAddress;
        data["postalCodeValue"] = this.postalCodeValue;
        data["city"] = this.city;
        data["state"] = this.state;
        data["country"] = this.country;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["addressTypeName"] = this.addressTypeName;
        data["contactId"] = this.contactId;
        data["addressTypeId"] = this.addressTypeId;
        return data; 
    }
}

export interface IUpdateCustomerAddressInput {
    addressId: number;
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    formattedAddress: string | undefined;
    postalCodeValue: string | undefined;
    city: string | undefined;
    state: string | undefined;
    country: string | undefined;
    latitude: number;
    longitude: number;
    addressTypeName: string | undefined;
    contactId: number;
    addressTypeId: number | undefined;
}

export class CreateClinicAccountInput implements ICreateClinicAccountInput {
    clinicName!: string | undefined;
    accountNo!: string | undefined;
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    formattedAddress!: string | undefined;
    postalCodeValue!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    country!: string | undefined;
    latitude!: number;
    longitude!: number;
    addressTypeName!: string | undefined;
    phone!: string | undefined;
    arrivalAlert!: string | undefined;
    userInput!: RegisterInput | undefined;

    constructor(data?: ICreateClinicAccountInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicName = data["clinicName"];
            this.accountNo = data["accountNo"];
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.formattedAddress = data["formattedAddress"];
            this.postalCodeValue = data["postalCodeValue"];
            this.city = data["city"];
            this.state = data["state"];
            this.country = data["country"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.addressTypeName = data["addressTypeName"];
            this.phone = data["phone"];
            this.arrivalAlert = data["arrivalAlert"];
            this.userInput = data["userInput"] ? RegisterInput.fromJS(data["userInput"]) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateClinicAccountInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateClinicAccountInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicName"] = this.clinicName;
        data["accountNo"] = this.accountNo;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["formattedAddress"] = this.formattedAddress;
        data["postalCodeValue"] = this.postalCodeValue;
        data["city"] = this.city;
        data["state"] = this.state;
        data["country"] = this.country;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["addressTypeName"] = this.addressTypeName;
        data["phone"] = this.phone;
        data["arrivalAlert"] = this.arrivalAlert;
        data["userInput"] = this.userInput ? this.userInput.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ICreateClinicAccountInput {
    clinicName: string | undefined;
    accountNo: string | undefined;
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    formattedAddress: string | undefined;
    postalCodeValue: string | undefined;
    city: string | undefined;
    state: string | undefined;
    country: string | undefined;
    latitude: number;
    longitude: number;
    addressTypeName: string | undefined;
    phone: string | undefined;
    arrivalAlert: string | undefined;
    userInput: RegisterInput | undefined;
}

export class GetContactPersonsList implements IGetContactPersonsList {
    userId!: number;
    name!: string | undefined;
    username!: string | undefined;

    constructor(data?: IGetContactPersonsList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.name = data["name"];
            this.username = data["username"];
        }
    }

    static fromJS(data: any): GetContactPersonsList {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactPersonsList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["name"] = this.name;
        data["username"] = this.username;
        return data; 
    }
}

export interface IGetContactPersonsList {
    userId: number;
    name: string | undefined;
    username: string | undefined;
}

export class PagedResultDtoOfGetContactPersonsList implements IPagedResultDtoOfGetContactPersonsList {
    totalCount!: number;
    items!: GetContactPersonsList[] | undefined;

    constructor(data?: IPagedResultDtoOfGetContactPersonsList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetContactPersonsList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetContactPersonsList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetContactPersonsList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetContactPersonsList {
    totalCount: number;
    items: GetContactPersonsList[] | undefined;
}

export class ClinicOrders implements IClinicOrders {
    routeId!: number;
    orderId!: number;
    tracking!: string | undefined;
    pickupDate!: string | undefined;
    pickupDateTime!: moment.Moment | undefined;
    pickupTime!: string | undefined;
    etaDate!: moment.Moment;
    eta!: string | undefined;
    status!: string | undefined;
    statusColor!: string | undefined;
    statusIcon!: string | undefined;
    arrival!: string | undefined;
    alert!: boolean;
    isLate!: boolean;
    sortOrder!: number;
    timezoneInfo!: string | undefined;
    isWillCall!: boolean;
    latitude!: number | undefined;
    longitude!: number | undefined;

    constructor(data?: IClinicOrders) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.orderId = data["orderId"];
            this.tracking = data["tracking"];
            this.pickupDate = data["pickupDate"];
            this.pickupDateTime = data["pickupDateTime"] ? moment(data["pickupDateTime"].toString()) : <any>undefined;
            this.pickupTime = data["pickupTime"];
            this.etaDate = data["etaDate"] ? moment(data["etaDate"].toString()) : <any>undefined;
            this.eta = data["eta"];
            this.status = data["status"];
            this.statusColor = data["statusColor"];
            this.statusIcon = data["statusIcon"];
            this.arrival = data["arrival"];
            this.alert = data["alert"];
            this.isLate = data["isLate"];
            this.sortOrder = data["sortOrder"];
            this.timezoneInfo = data["timezoneInfo"];
            this.isWillCall = data["isWillCall"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): ClinicOrders {
        data = typeof data === 'object' ? data : {};
        let result = new ClinicOrders();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["orderId"] = this.orderId;
        data["tracking"] = this.tracking;
        data["pickupDate"] = this.pickupDate;
        data["pickupDateTime"] = this.pickupDateTime ? this.pickupDateTime.toISOString() : <any>undefined;
        data["pickupTime"] = this.pickupTime;
        data["etaDate"] = this.etaDate ? this.etaDate.toISOString() : <any>undefined;
        data["eta"] = this.eta;
        data["status"] = this.status;
        data["statusColor"] = this.statusColor;
        data["statusIcon"] = this.statusIcon;
        data["arrival"] = this.arrival;
        data["alert"] = this.alert;
        data["isLate"] = this.isLate;
        data["sortOrder"] = this.sortOrder;
        data["timezoneInfo"] = this.timezoneInfo;
        data["isWillCall"] = this.isWillCall;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface IClinicOrders {
    routeId: number;
    orderId: number;
    tracking: string | undefined;
    pickupDate: string | undefined;
    pickupDateTime: moment.Moment | undefined;
    pickupTime: string | undefined;
    etaDate: moment.Moment;
    eta: string | undefined;
    status: string | undefined;
    statusColor: string | undefined;
    statusIcon: string | undefined;
    arrival: string | undefined;
    alert: boolean;
    isLate: boolean;
    sortOrder: number;
    timezoneInfo: string | undefined;
    isWillCall: boolean;
    latitude: number | undefined;
    longitude: number | undefined;
}

export class GetCurrentDriverLocation implements IGetCurrentDriverLocation {
    driverLat!: number;
    driverLong!: number;
    driverName!: string | undefined;
    driverVehicle!: string | undefined;
    clinicLat!: number;
    clinicLong!: number;
    eta!: string | undefined;

    constructor(data?: IGetCurrentDriverLocation) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverLat = data["driverLat"];
            this.driverLong = data["driverLong"];
            this.driverName = data["driverName"];
            this.driverVehicle = data["driverVehicle"];
            this.clinicLat = data["clinicLat"];
            this.clinicLong = data["clinicLong"];
            this.eta = data["eta"];
        }
    }

    static fromJS(data: any): GetCurrentDriverLocation {
        data = typeof data === 'object' ? data : {};
        let result = new GetCurrentDriverLocation();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverLat"] = this.driverLat;
        data["driverLong"] = this.driverLong;
        data["driverName"] = this.driverName;
        data["driverVehicle"] = this.driverVehicle;
        data["clinicLat"] = this.clinicLat;
        data["clinicLong"] = this.clinicLong;
        data["eta"] = this.eta;
        return data; 
    }
}

export interface IGetCurrentDriverLocation {
    driverLat: number;
    driverLong: number;
    driverName: string | undefined;
    driverVehicle: string | undefined;
    clinicLat: number;
    clinicLong: number;
    eta: string | undefined;
}

export class FlatPermissionDto implements IFlatPermissionDto {
    parentName!: string | undefined;
    name!: string | undefined;
    displayName!: string | undefined;
    description!: string | undefined;
    isGrantedByDefault!: boolean;

    constructor(data?: IFlatPermissionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parentName = data["parentName"];
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.description = data["description"];
            this.isGrantedByDefault = data["isGrantedByDefault"];
        }
    }

    static fromJS(data: any): FlatPermissionDto {
        data = typeof data === 'object' ? data : {};
        let result = new FlatPermissionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parentName"] = this.parentName;
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["description"] = this.description;
        data["isGrantedByDefault"] = this.isGrantedByDefault;
        return data; 
    }
}

export interface IFlatPermissionDto {
    parentName: string | undefined;
    name: string | undefined;
    displayName: string | undefined;
    description: string | undefined;
    isGrantedByDefault: boolean;
}

export class GetUserPermissionsForEditOutput implements IGetUserPermissionsForEditOutput {
    permissions!: FlatPermissionDto[] | undefined;
    grantedPermissionNames!: string[] | undefined;

    constructor(data?: IGetUserPermissionsForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["permissions"])) {
                this.permissions = [] as any;
                for (let item of data["permissions"])
                    this.permissions!.push(FlatPermissionDto.fromJS(item));
            }
            if (Array.isArray(data["grantedPermissionNames"])) {
                this.grantedPermissionNames = [] as any;
                for (let item of data["grantedPermissionNames"])
                    this.grantedPermissionNames!.push(item);
            }
        }
    }

    static fromJS(data: any): GetUserPermissionsForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserPermissionsForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.permissions)) {
            data["permissions"] = [];
            for (let item of this.permissions)
                data["permissions"].push(item.toJSON());
        }
        if (Array.isArray(this.grantedPermissionNames)) {
            data["grantedPermissionNames"] = [];
            for (let item of this.grantedPermissionNames)
                data["grantedPermissionNames"].push(item);
        }
        return data; 
    }
}

export interface IGetUserPermissionsForEditOutput {
    permissions: FlatPermissionDto[] | undefined;
    grantedPermissionNames: string[] | undefined;
}

export class UpdateUserPermissionsInput implements IUpdateUserPermissionsInput {
    id!: number;
    grantedPermissionNames!: string[];

    constructor(data?: IUpdateUserPermissionsInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.grantedPermissionNames = [];
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            if (Array.isArray(data["grantedPermissionNames"])) {
                this.grantedPermissionNames = [] as any;
                for (let item of data["grantedPermissionNames"])
                    this.grantedPermissionNames!.push(item);
            }
        }
    }

    static fromJS(data: any): UpdateUserPermissionsInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateUserPermissionsInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        if (Array.isArray(this.grantedPermissionNames)) {
            data["grantedPermissionNames"] = [];
            for (let item of this.grantedPermissionNames)
                data["grantedPermissionNames"].push(item);
        }
        return data; 
    }
}

export interface IUpdateUserPermissionsInput {
    id: number;
    grantedPermissionNames: string[];
}

export class DashboardList implements IDashboardList {
    id!: number | undefined;
    name!: string | undefined;
    code!: string | undefined;
    createdBy!: string | undefined;
    createdWhen!: string | undefined;
    modifiedWhen!: string | undefined;
    modifiedBy!: string | undefined;
    tenantId!: number | undefined;
    inactive!: boolean;

    constructor(data?: IDashboardList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.code = data["code"];
            this.createdBy = data["createdBy"];
            this.createdWhen = data["createdWhen"];
            this.modifiedWhen = data["modifiedWhen"];
            this.modifiedBy = data["modifiedBy"];
            this.tenantId = data["tenantId"];
            this.inactive = data["inactive"];
        }
    }

    static fromJS(data: any): DashboardList {
        data = typeof data === 'object' ? data : {};
        let result = new DashboardList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["code"] = this.code;
        data["createdBy"] = this.createdBy;
        data["createdWhen"] = this.createdWhen;
        data["modifiedWhen"] = this.modifiedWhen;
        data["modifiedBy"] = this.modifiedBy;
        data["tenantId"] = this.tenantId;
        data["inactive"] = this.inactive;
        return data; 
    }
}

export interface IDashboardList {
    id: number | undefined;
    name: string | undefined;
    code: string | undefined;
    createdBy: string | undefined;
    createdWhen: string | undefined;
    modifiedWhen: string | undefined;
    modifiedBy: string | undefined;
    tenantId: number | undefined;
    inactive: boolean;
}

export class PagedResultDtoOfDashboardList implements IPagedResultDtoOfDashboardList {
    totalCount!: number;
    items!: DashboardList[] | undefined;

    constructor(data?: IPagedResultDtoOfDashboardList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(DashboardList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfDashboardList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfDashboardList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfDashboardList {
    totalCount: number;
    items: DashboardList[] | undefined;
}

export class ListResultDtoOfUserListDto implements IListResultDtoOfUserListDto {
    items!: UserListDto[] | undefined;

    constructor(data?: IListResultDtoOfUserListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(UserListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfUserListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfUserListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfUserListDto {
    items: UserListDto[] | undefined;
}

export class Dashboards implements IDashboards {
    tenantId!: number | undefined;
    lastModifierUserId!: number | undefined;
    name!: string;
    code!: string;
    inactive!: boolean;
    data!: string;
    base64EncodedData!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDashboards) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.lastModifierUserId = data["lastModifierUserId"];
            this.name = data["name"];
            this.code = data["code"];
            this.inactive = data["inactive"];
            this.data = data["data"];
            this.base64EncodedData = data["base64EncodedData"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Dashboards {
        data = typeof data === 'object' ? data : {};
        let result = new Dashboards();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["inactive"] = this.inactive;
        data["data"] = this.data;
        data["base64EncodedData"] = this.base64EncodedData;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDashboards {
    tenantId: number | undefined;
    lastModifierUserId: number | undefined;
    name: string;
    code: string;
    inactive: boolean;
    data: string;
    base64EncodedData: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Widget implements IWidget {
    widgetId!: string | undefined;
    height!: number;
    width!: number;
    positionX!: number;
    positionY!: number;

    constructor(data?: IWidget) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.widgetId = data["widgetId"];
            this.height = data["height"];
            this.width = data["width"];
            this.positionX = data["positionX"];
            this.positionY = data["positionY"];
        }
    }

    static fromJS(data: any): Widget {
        data = typeof data === 'object' ? data : {};
        let result = new Widget();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["widgetId"] = this.widgetId;
        data["height"] = this.height;
        data["width"] = this.width;
        data["positionX"] = this.positionX;
        data["positionY"] = this.positionY;
        return data; 
    }
}

export interface IWidget {
    widgetId: string | undefined;
    height: number;
    width: number;
    positionX: number;
    positionY: number;
}

export class Page implements IPage {
    id!: string | undefined;
    name!: string | undefined;
    widgets!: Widget[] | undefined;

    constructor(data?: IPage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            if (Array.isArray(data["widgets"])) {
                this.widgets = [] as any;
                for (let item of data["widgets"])
                    this.widgets!.push(Widget.fromJS(item));
            }
        }
    }

    static fromJS(data: any): Page {
        data = typeof data === 'object' ? data : {};
        let result = new Page();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        if (Array.isArray(this.widgets)) {
            data["widgets"] = [];
            for (let item of this.widgets)
                data["widgets"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPage {
    id: string | undefined;
    name: string | undefined;
    widgets: Widget[] | undefined;
}

export class Dashboard implements IDashboard {
    dashboardName!: string | undefined;
    pages!: Page[] | undefined;

    constructor(data?: IDashboard) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dashboardName = data["dashboardName"];
            if (Array.isArray(data["pages"])) {
                this.pages = [] as any;
                for (let item of data["pages"])
                    this.pages!.push(Page.fromJS(item));
            }
        }
    }

    static fromJS(data: any): Dashboard {
        data = typeof data === 'object' ? data : {};
        let result = new Dashboard();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dashboardName"] = this.dashboardName;
        if (Array.isArray(this.pages)) {
            data["pages"] = [];
            for (let item of this.pages)
                data["pages"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IDashboard {
    dashboardName: string | undefined;
    pages: Page[] | undefined;
}

export class SavePageInput implements ISavePageInput {
    dashboardName!: string | undefined;
    application!: string | undefined;
    pages!: Page[] | undefined;

    constructor(data?: ISavePageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dashboardName = data["dashboardName"];
            this.application = data["application"];
            if (Array.isArray(data["pages"])) {
                this.pages = [] as any;
                for (let item of data["pages"])
                    this.pages!.push(Page.fromJS(item));
            }
        }
    }

    static fromJS(data: any): SavePageInput {
        data = typeof data === 'object' ? data : {};
        let result = new SavePageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dashboardName"] = this.dashboardName;
        data["application"] = this.application;
        if (Array.isArray(this.pages)) {
            data["pages"] = [];
            for (let item of this.pages)
                data["pages"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ISavePageInput {
    dashboardName: string | undefined;
    application: string | undefined;
    pages: Page[] | undefined;
}

export class RenamePageInput implements IRenamePageInput {
    dashboardName!: string | undefined;
    id!: string | undefined;
    name!: string | undefined;
    application!: string | undefined;

    constructor(data?: IRenamePageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dashboardName = data["dashboardName"];
            this.id = data["id"];
            this.name = data["name"];
            this.application = data["application"];
        }
    }

    static fromJS(data: any): RenamePageInput {
        data = typeof data === 'object' ? data : {};
        let result = new RenamePageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dashboardName"] = this.dashboardName;
        data["id"] = this.id;
        data["name"] = this.name;
        data["application"] = this.application;
        return data; 
    }
}

export interface IRenamePageInput {
    dashboardName: string | undefined;
    id: string | undefined;
    name: string | undefined;
    application: string | undefined;
}

export class AddNewPageInput implements IAddNewPageInput {
    dashboardName!: string | undefined;
    name!: string | undefined;
    application!: string | undefined;

    constructor(data?: IAddNewPageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dashboardName = data["dashboardName"];
            this.name = data["name"];
            this.application = data["application"];
        }
    }

    static fromJS(data: any): AddNewPageInput {
        data = typeof data === 'object' ? data : {};
        let result = new AddNewPageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dashboardName"] = this.dashboardName;
        data["name"] = this.name;
        data["application"] = this.application;
        return data; 
    }
}

export interface IAddNewPageInput {
    dashboardName: string | undefined;
    name: string | undefined;
    application: string | undefined;
}

export class AddNewPageOutput implements IAddNewPageOutput {
    pageId!: string | undefined;

    constructor(data?: IAddNewPageOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.pageId = data["pageId"];
        }
    }

    static fromJS(data: any): AddNewPageOutput {
        data = typeof data === 'object' ? data : {};
        let result = new AddNewPageOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["pageId"] = this.pageId;
        return data; 
    }
}

export interface IAddNewPageOutput {
    pageId: string | undefined;
}

export class AddWidgetInput implements IAddWidgetInput {
    widgetId!: string | undefined;
    pageId!: string | undefined;
    dashboardName!: string | undefined;
    width!: number;
    height!: number;
    application!: string | undefined;

    constructor(data?: IAddWidgetInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.widgetId = data["widgetId"];
            this.pageId = data["pageId"];
            this.dashboardName = data["dashboardName"];
            this.width = data["width"];
            this.height = data["height"];
            this.application = data["application"];
        }
    }

    static fromJS(data: any): AddWidgetInput {
        data = typeof data === 'object' ? data : {};
        let result = new AddWidgetInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["widgetId"] = this.widgetId;
        data["pageId"] = this.pageId;
        data["dashboardName"] = this.dashboardName;
        data["width"] = this.width;
        data["height"] = this.height;
        data["application"] = this.application;
        return data; 
    }
}

export interface IAddWidgetInput {
    widgetId: string | undefined;
    pageId: string | undefined;
    dashboardName: string | undefined;
    width: number;
    height: number;
    application: string | undefined;
}

export class WidgetFilterOutput implements IWidgetFilterOutput {
    readonly id!: string | undefined;
    readonly name!: string | undefined;

    constructor(data?: IWidgetFilterOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).id = data["id"];
            (<any>this).name = data["name"];
        }
    }

    static fromJS(data: any): WidgetFilterOutput {
        data = typeof data === 'object' ? data : {};
        let result = new WidgetFilterOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IWidgetFilterOutput {
    id: string | undefined;
    name: string | undefined;
}

export class WidgetOutput implements IWidgetOutput {
    readonly id!: string | undefined;
    readonly name!: string | undefined;
    readonly description!: string | undefined;
    filters!: WidgetFilterOutput[] | undefined;

    constructor(data?: IWidgetOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).id = data["id"];
            (<any>this).name = data["name"];
            (<any>this).description = data["description"];
            if (Array.isArray(data["filters"])) {
                this.filters = [] as any;
                for (let item of data["filters"])
                    this.filters!.push(WidgetFilterOutput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): WidgetOutput {
        data = typeof data === 'object' ? data : {};
        let result = new WidgetOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["description"] = this.description;
        if (Array.isArray(this.filters)) {
            data["filters"] = [];
            for (let item of this.filters)
                data["filters"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IWidgetOutput {
    id: string | undefined;
    name: string | undefined;
    description: string | undefined;
    filters: WidgetFilterOutput[] | undefined;
}

/** This class stores filtered dashboard information by user */
export class DashboardOutput implements IDashboardOutput {
    name!: string | undefined;
    widgets!: WidgetOutput[] | undefined;

    constructor(data?: IDashboardOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            if (Array.isArray(data["widgets"])) {
                this.widgets = [] as any;
                for (let item of data["widgets"])
                    this.widgets!.push(WidgetOutput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): DashboardOutput {
        data = typeof data === 'object' ? data : {};
        let result = new DashboardOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        if (Array.isArray(this.widgets)) {
            data["widgets"] = [];
            for (let item of this.widgets)
                data["widgets"].push(item.toJSON());
        }
        return data; 
    }
}

/** This class stores filtered dashboard information by user */
export interface IDashboardOutput {
    name: string | undefined;
    widgets: WidgetOutput[] | undefined;
}

export enum Frequency {
    Weekly = 0,
    Monthly = 1,
    Yearly = 2,
    Daily = 3,
}

export class DataRetentionDto implements IDataRetentionDto {
    entity!: string | undefined;
    frequency!: Frequency;
    duration!: number;
    lastExecutionTime!: moment.Moment | undefined;
    nextExecutionTime!: moment.Moment | undefined;
    isActive!: boolean;
    startTime!: string | undefined;
    jobDuration!: number;
    effectiveDate!: moment.Moment | undefined;
    id!: number;

    constructor(data?: IDataRetentionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.entity = data["entity"];
            this.frequency = data["frequency"];
            this.duration = data["duration"];
            this.lastExecutionTime = data["lastExecutionTime"] ? moment(data["lastExecutionTime"].toString()) : <any>undefined;
            this.nextExecutionTime = data["nextExecutionTime"] ? moment(data["nextExecutionTime"].toString()) : <any>undefined;
            this.isActive = data["isActive"];
            this.startTime = data["startTime"];
            this.jobDuration = data["jobDuration"];
            this.effectiveDate = data["effectiveDate"] ? moment(data["effectiveDate"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DataRetentionDto {
        data = typeof data === 'object' ? data : {};
        let result = new DataRetentionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["entity"] = this.entity;
        data["frequency"] = this.frequency;
        data["duration"] = this.duration;
        data["lastExecutionTime"] = this.lastExecutionTime ? this.lastExecutionTime.toISOString() : <any>undefined;
        data["nextExecutionTime"] = this.nextExecutionTime ? this.nextExecutionTime.toISOString() : <any>undefined;
        data["isActive"] = this.isActive;
        data["startTime"] = this.startTime;
        data["jobDuration"] = this.jobDuration;
        data["effectiveDate"] = this.effectiveDate ? this.effectiveDate.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDataRetentionDto {
    entity: string | undefined;
    frequency: Frequency;
    duration: number;
    lastExecutionTime: moment.Moment | undefined;
    nextExecutionTime: moment.Moment | undefined;
    isActive: boolean;
    startTime: string | undefined;
    jobDuration: number;
    effectiveDate: moment.Moment | undefined;
    id: number;
}

export class GetDataRetentionForViewDto implements IGetDataRetentionForViewDto {
    dataRetention!: DataRetentionDto | undefined;

    constructor(data?: IGetDataRetentionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dataRetention = data["dataRetention"] ? DataRetentionDto.fromJS(data["dataRetention"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetDataRetentionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDataRetentionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dataRetention"] = this.dataRetention ? this.dataRetention.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetDataRetentionForViewDto {
    dataRetention: DataRetentionDto | undefined;
}

export class PagedResultDtoOfGetDataRetentionForViewDto implements IPagedResultDtoOfGetDataRetentionForViewDto {
    totalCount!: number;
    items!: GetDataRetentionForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetDataRetentionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetDataRetentionForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetDataRetentionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetDataRetentionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetDataRetentionForViewDto {
    totalCount: number;
    items: GetDataRetentionForViewDto[] | undefined;
}

export enum EntityEnum {
    Order = 0,
    Route = 1,
    ProofOfDelivery = 2,
    AbpEntityChanges = 3,
    AbpAuditLogs = 4,
    GoogleApiRequestsLogs = 5,
    Geocodes = 6,
    ReportLogs = 7,
    ClientOrderLogs = 8,
}

export class CreateOrEditDataRetentionDto implements ICreateOrEditDataRetentionDto {
    entity!: EntityEnum;
    frequency!: Frequency;
    duration!: number;
    isActive!: boolean;
    startTime!: string | undefined;
    jobDuration!: number;
    effectiveDate!: moment.Moment | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditDataRetentionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.entity = data["entity"];
            this.frequency = data["frequency"];
            this.duration = data["duration"];
            this.isActive = data["isActive"];
            this.startTime = data["startTime"];
            this.jobDuration = data["jobDuration"];
            this.effectiveDate = data["effectiveDate"] ? moment(data["effectiveDate"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditDataRetentionDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditDataRetentionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["entity"] = this.entity;
        data["frequency"] = this.frequency;
        data["duration"] = this.duration;
        data["isActive"] = this.isActive;
        data["startTime"] = this.startTime;
        data["jobDuration"] = this.jobDuration;
        data["effectiveDate"] = this.effectiveDate ? this.effectiveDate.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditDataRetentionDto {
    entity: EntityEnum;
    frequency: Frequency;
    duration: number;
    isActive: boolean;
    startTime: string | undefined;
    jobDuration: number;
    effectiveDate: moment.Moment | undefined;
    id: number | undefined;
}

export class GetDataRetentionForEditOutput implements IGetDataRetentionForEditOutput {
    dataRetention!: CreateOrEditDataRetentionDto | undefined;

    constructor(data?: IGetDataRetentionForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dataRetention = data["dataRetention"] ? CreateOrEditDataRetentionDto.fromJS(data["dataRetention"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetDataRetentionForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetDataRetentionForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dataRetention"] = this.dataRetention ? this.dataRetention.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetDataRetentionForEditOutput {
    dataRetention: CreateOrEditDataRetentionDto | undefined;
}

export class DataRetention implements IDataRetention {
    tenantId!: number | undefined;
    entity!: EntityEnum;
    frequency!: Frequency;
    duration!: number;
    isActive!: boolean;
    startTime!: TimeSpan;
    jobDuration!: number;
    effectiveDate!: moment.Moment | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDataRetention) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.entity = data["entity"];
            this.frequency = data["frequency"];
            this.duration = data["duration"];
            this.isActive = data["isActive"];
            this.startTime = data["startTime"] ? TimeSpan.fromJS(data["startTime"]) : <any>undefined;
            this.jobDuration = data["jobDuration"];
            this.effectiveDate = data["effectiveDate"] ? moment(data["effectiveDate"].toString()) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DataRetention {
        data = typeof data === 'object' ? data : {};
        let result = new DataRetention();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["entity"] = this.entity;
        data["frequency"] = this.frequency;
        data["duration"] = this.duration;
        data["isActive"] = this.isActive;
        data["startTime"] = this.startTime ? this.startTime.toJSON() : <any>undefined;
        data["jobDuration"] = this.jobDuration;
        data["effectiveDate"] = this.effectiveDate ? this.effectiveDate.toISOString() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDataRetention {
    tenantId: number | undefined;
    entity: EntityEnum;
    frequency: Frequency;
    duration: number;
    isActive: boolean;
    startTime: TimeSpan;
    jobDuration: number;
    effectiveDate: moment.Moment | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class JobInputDto implements IJobInputDto {
    retention!: DataRetention | undefined;

    constructor(data?: IJobInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.retention = data["retention"] ? DataRetention.fromJS(data["retention"]) : <any>undefined;
        }
    }

    static fromJS(data: any): JobInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new JobInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["retention"] = this.retention ? this.retention.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IJobInputDto {
    retention: DataRetention | undefined;
}

export enum LogStatus {
    FAILED = 0,
    SUCCEEDED = 1,
}

export class CreateOrEditDataRetentionLogDto implements ICreateOrEditDataRetentionLogDto {
    tenantId!: number | undefined;
    dataRetentionId!: number;
    status!: LogStatus;
    message!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditDataRetentionLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.dataRetentionId = data["dataRetentionId"];
            this.status = data["status"];
            this.message = data["message"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditDataRetentionLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditDataRetentionLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["dataRetentionId"] = this.dataRetentionId;
        data["status"] = this.status;
        data["message"] = this.message;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditDataRetentionLogDto {
    tenantId: number | undefined;
    dataRetentionId: number;
    status: LogStatus;
    message: string | undefined;
    id: number | undefined;
}

export class DataRetentionLogDto implements IDataRetentionLogDto {
    dataRetentionId!: number;
    status!: LogStatus;
    message!: string | undefined;
    creationTime!: moment.Moment;
    id!: number;

    constructor(data?: IDataRetentionLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dataRetentionId = data["dataRetentionId"];
            this.status = data["status"];
            this.message = data["message"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DataRetentionLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new DataRetentionLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dataRetentionId"] = this.dataRetentionId;
        data["status"] = this.status;
        data["message"] = this.message;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDataRetentionLogDto {
    dataRetentionId: number;
    status: LogStatus;
    message: string | undefined;
    creationTime: moment.Moment;
    id: number;
}

export class GetDataRetentionLogForViewDto implements IGetDataRetentionLogForViewDto {
    dataRetentionLog!: DataRetentionLogDto | undefined;

    constructor(data?: IGetDataRetentionLogForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dataRetentionLog = data["dataRetentionLog"] ? DataRetentionLogDto.fromJS(data["dataRetentionLog"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetDataRetentionLogForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDataRetentionLogForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dataRetentionLog"] = this.dataRetentionLog ? this.dataRetentionLog.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetDataRetentionLogForViewDto {
    dataRetentionLog: DataRetentionLogDto | undefined;
}

export class PagedResultDtoOfGetDataRetentionLogForViewDto implements IPagedResultDtoOfGetDataRetentionLogForViewDto {
    totalCount!: number;
    items!: GetDataRetentionLogForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetDataRetentionLogForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetDataRetentionLogForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetDataRetentionLogForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetDataRetentionLogForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetDataRetentionLogForViewDto {
    totalCount: number;
    items: GetDataRetentionLogForViewDto[] | undefined;
}

export class CreateDataSourceInput implements ICreateDataSourceInput {
    description!: string;
    configuration!: string;
    code!: number;

    constructor(data?: ICreateDataSourceInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.configuration = data["configuration"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): CreateDataSourceInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDataSourceInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["configuration"] = this.configuration;
        data["code"] = this.code;
        return data; 
    }
}

export interface ICreateDataSourceInput {
    description: string;
    configuration: string;
    code: number;
}

export class DataSourceListDto implements IDataSourceListDto {
    id!: number;
    description!: string | undefined;
    configuration!: string | undefined;
    code!: number;

    constructor(data?: IDataSourceListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.description = data["description"];
            this.configuration = data["configuration"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): DataSourceListDto {
        data = typeof data === 'object' ? data : {};
        let result = new DataSourceListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["description"] = this.description;
        data["configuration"] = this.configuration;
        data["code"] = this.code;
        return data; 
    }
}

export interface IDataSourceListDto {
    id: number;
    description: string | undefined;
    configuration: string | undefined;
    code: number;
}

export class ListResultDtoOfDataSourceListDto implements IListResultDtoOfDataSourceListDto {
    items!: DataSourceListDto[] | undefined;

    constructor(data?: IListResultDtoOfDataSourceListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(DataSourceListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfDataSourceListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfDataSourceListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfDataSourceListDto {
    items: DataSourceListDto[] | undefined;
}

export class UpdateDataSourceInput implements IUpdateDataSourceInput {
    id!: number;
    description!: string | undefined;
    configuration!: string | undefined;
    code!: number;

    constructor(data?: IUpdateDataSourceInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.description = data["description"];
            this.configuration = data["configuration"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): UpdateDataSourceInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateDataSourceInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["description"] = this.description;
        data["configuration"] = this.configuration;
        data["code"] = this.code;
        return data; 
    }
}

export interface IUpdateDataSourceInput {
    id: number;
    description: string | undefined;
    configuration: string | undefined;
    code: number;
}

export class DisplayLocation implements IDisplayLocation {
    location!: string | undefined;
    loadLimit!: number | undefined;
    driverInactiveThreshold!: number | undefined;

    constructor(data?: IDisplayLocation) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.location = data["location"];
            this.loadLimit = data["loadLimit"];
            this.driverInactiveThreshold = data["driverInactiveThreshold"];
        }
    }

    static fromJS(data: any): DisplayLocation {
        data = typeof data === 'object' ? data : {};
        let result = new DisplayLocation();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["location"] = this.location;
        data["loadLimit"] = this.loadLimit;
        data["driverInactiveThreshold"] = this.driverInactiveThreshold;
        return data; 
    }
}

export interface IDisplayLocation {
    location: string | undefined;
    loadLimit: number | undefined;
    driverInactiveThreshold: number | undefined;
}

export class InputDateDto implements IInputDateDto {
    dateTimeValue!: moment.Moment;
    locationId!: number | undefined;
    timeZoneValue!: string | undefined;

    constructor(data?: IInputDateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dateTimeValue = data["dateTimeValue"] ? moment(data["dateTimeValue"].toString()) : <any>undefined;
            this.locationId = data["locationId"];
            this.timeZoneValue = data["timeZoneValue"];
        }
    }

    static fromJS(data: any): InputDateDto {
        data = typeof data === 'object' ? data : {};
        let result = new InputDateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dateTimeValue"] = this.dateTimeValue ? this.dateTimeValue.toISOString() : <any>undefined;
        data["locationId"] = this.locationId;
        data["timeZoneValue"] = this.timeZoneValue;
        return data; 
    }
}

export interface IInputDateDto {
    dateTimeValue: moment.Moment;
    locationId: number | undefined;
    timeZoneValue: string | undefined;
}

export class DisplayDateDto implements IDisplayDateDto {
    currentDateTimeUTC!: moment.Moment;
    convertedDateTime!: moment.Moment;
    convertionDescription!: string | undefined;

    constructor(data?: IDisplayDateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.currentDateTimeUTC = data["currentDateTimeUTC"] ? moment(data["currentDateTimeUTC"].toString()) : <any>undefined;
            this.convertedDateTime = data["convertedDateTime"] ? moment(data["convertedDateTime"].toString()) : <any>undefined;
            this.convertionDescription = data["convertionDescription"];
        }
    }

    static fromJS(data: any): DisplayDateDto {
        data = typeof data === 'object' ? data : {};
        let result = new DisplayDateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["currentDateTimeUTC"] = this.currentDateTimeUTC ? this.currentDateTimeUTC.toISOString() : <any>undefined;
        data["convertedDateTime"] = this.convertedDateTime ? this.convertedDateTime.toISOString() : <any>undefined;
        data["convertionDescription"] = this.convertionDescription;
        return data; 
    }
}

export interface IDisplayDateDto {
    currentDateTimeUTC: moment.Moment;
    convertedDateTime: moment.Moment;
    convertionDescription: string | undefined;
}

export class InputRangeDateDto implements IInputRangeDateDto {
    startDateTime!: moment.Moment;
    endDateTime!: moment.Moment;
    timeZoneValue!: string | undefined;

    constructor(data?: IInputRangeDateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.startDateTime = data["startDateTime"] ? moment(data["startDateTime"].toString()) : <any>undefined;
            this.endDateTime = data["endDateTime"] ? moment(data["endDateTime"].toString()) : <any>undefined;
            this.timeZoneValue = data["timeZoneValue"];
        }
    }

    static fromJS(data: any): InputRangeDateDto {
        data = typeof data === 'object' ? data : {};
        let result = new InputRangeDateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["startDateTime"] = this.startDateTime ? this.startDateTime.toISOString() : <any>undefined;
        data["endDateTime"] = this.endDateTime ? this.endDateTime.toISOString() : <any>undefined;
        data["timeZoneValue"] = this.timeZoneValue;
        return data; 
    }
}

export interface IInputRangeDateDto {
    startDateTime: moment.Moment;
    endDateTime: moment.Moment;
    timeZoneValue: string | undefined;
}

export class DisplayRangeDateDto implements IDisplayRangeDateDto {
    startTime!: moment.Moment;
    endTime!: moment.Moment;

    constructor(data?: IDisplayRangeDateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.startTime = data["startTime"] ? moment(data["startTime"].toString()) : <any>undefined;
            this.endTime = data["endTime"] ? moment(data["endTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): DisplayRangeDateDto {
        data = typeof data === 'object' ? data : {};
        let result = new DisplayRangeDateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["startTime"] = this.startTime ? this.startTime.toISOString() : <any>undefined;
        data["endTime"] = this.endTime ? this.endTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IDisplayRangeDateDto {
    startTime: moment.Moment;
    endTime: moment.Moment;
}

export class CreateNoteInput implements ICreateNoteInput {
    content!: string;

    constructor(data?: ICreateNoteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.content = data["content"];
        }
    }

    static fromJS(data: any): CreateNoteInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateNoteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["content"] = this.content;
        return data; 
    }
}

export interface ICreateNoteInput {
    content: string;
}

export class CreateDeliveryNoteInput implements ICreateDeliveryNoteInput {
    note!: CreateNoteInput | undefined;
    sortOrder!: number;

    constructor(data?: ICreateDeliveryNoteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.note = data["note"] ? CreateNoteInput.fromJS(data["note"]) : <any>undefined;
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): CreateDeliveryNoteInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDeliveryNoteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface ICreateDeliveryNoteInput {
    note: CreateNoteInput | undefined;
    sortOrder: number;
}

export class DeliveryNoteListDto implements IDeliveryNoteListDto {
    id!: number;
    note!: NoteListDto | undefined;
    sortorder!: number;

    constructor(data?: IDeliveryNoteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.note = data["note"] ? NoteListDto.fromJS(data["note"]) : <any>undefined;
            this.sortorder = data["sortorder"];
        }
    }

    static fromJS(data: any): DeliveryNoteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new DeliveryNoteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["sortorder"] = this.sortorder;
        return data; 
    }
}

export interface IDeliveryNoteListDto {
    id: number;
    note: NoteListDto | undefined;
    sortorder: number;
}

export class PagedResultDtoOfDeliveryNoteListDto implements IPagedResultDtoOfDeliveryNoteListDto {
    totalCount!: number;
    items!: DeliveryNoteListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfDeliveryNoteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(DeliveryNoteListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfDeliveryNoteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfDeliveryNoteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfDeliveryNoteListDto {
    totalCount: number;
    items: DeliveryNoteListDto[] | undefined;
}

export class UpdateNoteInput implements IUpdateNoteInput {
    id!: number;
    content!: string | undefined;

    constructor(data?: IUpdateNoteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.content = data["content"];
        }
    }

    static fromJS(data: any): UpdateNoteInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateNoteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["content"] = this.content;
        return data; 
    }
}

export interface IUpdateNoteInput {
    id: number;
    content: string | undefined;
}

export class UpdateDeliveryNoteInput implements IUpdateDeliveryNoteInput {
    id!: number;
    note!: UpdateNoteInput | undefined;
    sortOrder!: number;

    constructor(data?: IUpdateDeliveryNoteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.note = data["note"] ? UpdateNoteInput.fromJS(data["note"]) : <any>undefined;
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): UpdateDeliveryNoteInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateDeliveryNoteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IUpdateDeliveryNoteInput {
    id: number;
    note: UpdateNoteInput | undefined;
    sortOrder: number;
}

export class DateToStringOutput implements IDateToStringOutput {
    dateString!: string | undefined;

    constructor(data?: IDateToStringOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.dateString = data["dateString"];
        }
    }

    static fromJS(data: any): DateToStringOutput {
        data = typeof data === 'object' ? data : {};
        let result = new DateToStringOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["dateString"] = this.dateString;
        return data; 
    }
}

export interface IDateToStringOutput {
    dateString: string | undefined;
}

export class NameValueOfString implements INameValueOfString {
    name!: string | undefined;
    value!: string | undefined;

    constructor(data?: INameValueOfString) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): NameValueOfString {
        data = typeof data === 'object' ? data : {};
        let result = new NameValueOfString();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["value"] = this.value;
        return data; 
    }
}

export interface INameValueOfString {
    name: string | undefined;
    value: string | undefined;
}

export class StringOutput implements IStringOutput {
    output!: string | undefined;

    constructor(data?: IStringOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.output = data["output"];
        }
    }

    static fromJS(data: any): StringOutput {
        data = typeof data === 'object' ? data : {};
        let result = new StringOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["output"] = this.output;
        return data; 
    }
}

export interface IStringOutput {
    output: string | undefined;
}

export class ListResultDtoOfDestinationDetailListDto implements IListResultDtoOfDestinationDetailListDto {
    items!: DestinationDetailListDto[] | undefined;

    constructor(data?: IListResultDtoOfDestinationDetailListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(DestinationDetailListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfDestinationDetailListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfDestinationDetailListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfDestinationDetailListDto {
    items: DestinationDetailListDto[] | undefined;
}

export class CreateDestinationDetailInput implements ICreateDestinationDetailInput {
    contactId!: number;
    etaStart!: moment.Moment;
    etaEnd!: moment.Moment;

    constructor(data?: ICreateDestinationDetailInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.etaStart = data["etaStart"] ? moment(data["etaStart"].toString()) : <any>undefined;
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateDestinationDetailInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDestinationDetailInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["etaStart"] = this.etaStart ? this.etaStart.toISOString() : <any>undefined;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ICreateDestinationDetailInput {
    contactId: number;
    etaStart: moment.Moment;
    etaEnd: moment.Moment;
}

export class UpdateDestinationDetailInput implements IUpdateDestinationDetailInput {
    id!: number;
    contactId!: number;
    etaStart!: moment.Moment;
    etaEnd!: moment.Moment;

    constructor(data?: IUpdateDestinationDetailInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contactId = data["contactId"];
            this.etaStart = data["etaStart"] ? moment(data["etaStart"].toString()) : <any>undefined;
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): UpdateDestinationDetailInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateDestinationDetailInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contactId"] = this.contactId;
        data["etaStart"] = this.etaStart ? this.etaStart.toISOString() : <any>undefined;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IUpdateDestinationDetailInput {
    id: number;
    contactId: number;
    etaStart: moment.Moment;
    etaEnd: moment.Moment;
}

export class UpdateEtaEnd implements IUpdateEtaEnd {
    id!: number;
    eta!: string | undefined;
    locationId!: number;
    scheduleId!: number;
    day!: number;

    constructor(data?: IUpdateEtaEnd) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.eta = data["eta"];
            this.locationId = data["locationId"];
            this.scheduleId = data["scheduleId"];
            this.day = data["day"];
        }
    }

    static fromJS(data: any): UpdateEtaEnd {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateEtaEnd();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["eta"] = this.eta;
        data["locationId"] = this.locationId;
        data["scheduleId"] = this.scheduleId;
        data["day"] = this.day;
        return data; 
    }
}

export interface IUpdateEtaEnd {
    id: number;
    eta: string | undefined;
    locationId: number;
    scheduleId: number;
    day: number;
}

export class CheckUserNameVerificationResult implements ICheckUserNameVerificationResult {
    isExempted!: boolean;
    isOtpGenerated!: boolean;

    constructor(data?: ICheckUserNameVerificationResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isExempted = data["isExempted"];
            this.isOtpGenerated = data["isOtpGenerated"];
        }
    }

    static fromJS(data: any): CheckUserNameVerificationResult {
        data = typeof data === 'object' ? data : {};
        let result = new CheckUserNameVerificationResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isExempted"] = this.isExempted;
        data["isOtpGenerated"] = this.isOtpGenerated;
        return data; 
    }
}

export interface ICheckUserNameVerificationResult {
    isExempted: boolean;
    isOtpGenerated: boolean;
}

export class UserOrganizationUnit implements IUserOrganizationUnit {
    tenantId!: number | undefined;
    userId!: number;
    organizationUnitId!: number;
    isDeleted!: boolean;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUserOrganizationUnit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.organizationUnitId = data["organizationUnitId"];
            this.isDeleted = data["isDeleted"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserOrganizationUnit {
        data = typeof data === 'object' ? data : {};
        let result = new UserOrganizationUnit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["organizationUnitId"] = this.organizationUnitId;
        data["isDeleted"] = this.isDeleted;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserOrganizationUnit {
    tenantId: number | undefined;
    userId: number;
    organizationUnitId: number;
    isDeleted: boolean;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class UserToken implements IUserToken {
    tenantId!: number | undefined;
    userId!: number;
    loginProvider!: string | undefined;
    name!: string | undefined;
    value!: string | undefined;
    expireDate!: moment.Moment | undefined;
    id!: number;

    constructor(data?: IUserToken) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.loginProvider = data["loginProvider"];
            this.name = data["name"];
            this.value = data["value"];
            this.expireDate = data["expireDate"] ? moment(data["expireDate"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserToken {
        data = typeof data === 'object' ? data : {};
        let result = new UserToken();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["loginProvider"] = this.loginProvider;
        data["name"] = this.name;
        data["value"] = this.value;
        data["expireDate"] = this.expireDate ? this.expireDate.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserToken {
    tenantId: number | undefined;
    userId: number;
    loginProvider: string | undefined;
    name: string | undefined;
    value: string | undefined;
    expireDate: moment.Moment | undefined;
    id: number;
}

export class UserLogin implements IUserLogin {
    tenantId!: number | undefined;
    userId!: number;
    loginProvider!: string;
    providerKey!: string;
    id!: number;

    constructor(data?: IUserLogin) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.loginProvider = data["loginProvider"];
            this.providerKey = data["providerKey"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserLogin {
        data = typeof data === 'object' ? data : {};
        let result = new UserLogin();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["loginProvider"] = this.loginProvider;
        data["providerKey"] = this.providerKey;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserLogin {
    tenantId: number | undefined;
    userId: number;
    loginProvider: string;
    providerKey: string;
    id: number;
}

export class UserRole implements IUserRole {
    tenantId!: number | undefined;
    userId!: number;
    roleId!: number;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUserRole) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.roleId = data["roleId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserRole {
        data = typeof data === 'object' ? data : {};
        let result = new UserRole();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["roleId"] = this.roleId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserRole {
    tenantId: number | undefined;
    userId: number;
    roleId: number;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class UserClaim implements IUserClaim {
    tenantId!: number | undefined;
    userId!: number;
    claimType!: string | undefined;
    claimValue!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUserClaim) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.claimType = data["claimType"];
            this.claimValue = data["claimValue"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserClaim {
        data = typeof data === 'object' ? data : {};
        let result = new UserClaim();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["claimType"] = this.claimType;
        data["claimValue"] = this.claimValue;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserClaim {
    tenantId: number | undefined;
    userId: number;
    claimType: string | undefined;
    claimValue: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class UserPermissionSetting implements IUserPermissionSetting {
    userId!: number;
    tenantId!: number | undefined;
    name!: string;
    isGranted!: boolean;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUserPermissionSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.isGranted = data["isGranted"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserPermissionSetting {
        data = typeof data === 'object' ? data : {};
        let result = new UserPermissionSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["isGranted"] = this.isGranted;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserPermissionSetting {
    userId: number;
    tenantId: number | undefined;
    name: string;
    isGranted: boolean;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Setting implements ISetting {
    tenantId!: number | undefined;
    userId!: number | undefined;
    name!: string;
    value!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.name = data["name"];
            this.value = data["value"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Setting {
        data = typeof data === 'object' ? data : {};
        let result = new Setting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["name"] = this.name;
        data["value"] = this.value;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISetting {
    tenantId: number | undefined;
    userId: number | undefined;
    name: string;
    value: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class User implements IUser {
    profilePictureId!: string | undefined;
    shouldChangePasswordOnNextLogin!: boolean;
    signInTokenExpireTimeUtc!: moment.Moment | undefined;
    signInToken!: string | undefined;
    googleAuthenticatorKey!: string | undefined;
    organizationUnits!: UserOrganizationUnit[] | undefined;
    hasBackgroundImage!: boolean;
    normalizedUserName!: string;
    normalizedEmailAddress!: string;
    concurrencyStamp!: string | undefined;
    tokens!: UserToken[] | undefined;
    deleterUser!: User | undefined;
    creatorUser!: User | undefined;
    lastModifierUser!: User | undefined;
    authenticationSource!: string | undefined;
    userName!: string;
    tenantId!: number | undefined;
    emailAddress!: string;
    name!: string;
    surname!: string;
    readonly fullName!: string | undefined;
    password!: string;
    emailConfirmationCode!: string | undefined;
    passwordResetCode!: string | undefined;
    lockoutEndDateUtc!: moment.Moment | undefined;
    accessFailedCount!: number;
    isLockoutEnabled!: boolean;
    phoneNumber!: string | undefined;
    isPhoneNumberConfirmed!: boolean;
    securityStamp!: string | undefined;
    isTwoFactorEnabled!: boolean;
    logins!: UserLogin[] | undefined;
    roles!: UserRole[] | undefined;
    claims!: UserClaim[] | undefined;
    permissions!: UserPermissionSetting[] | undefined;
    settings!: Setting[] | undefined;
    isEmailConfirmed!: boolean;
    isActive!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUser) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.profilePictureId = data["profilePictureId"];
            this.shouldChangePasswordOnNextLogin = data["shouldChangePasswordOnNextLogin"];
            this.signInTokenExpireTimeUtc = data["signInTokenExpireTimeUtc"] ? moment(data["signInTokenExpireTimeUtc"].toString()) : <any>undefined;
            this.signInToken = data["signInToken"];
            this.googleAuthenticatorKey = data["googleAuthenticatorKey"];
            if (Array.isArray(data["organizationUnits"])) {
                this.organizationUnits = [] as any;
                for (let item of data["organizationUnits"])
                    this.organizationUnits!.push(UserOrganizationUnit.fromJS(item));
            }
            this.hasBackgroundImage = data["hasBackgroundImage"];
            this.normalizedUserName = data["normalizedUserName"];
            this.normalizedEmailAddress = data["normalizedEmailAddress"];
            this.concurrencyStamp = data["concurrencyStamp"];
            if (Array.isArray(data["tokens"])) {
                this.tokens = [] as any;
                for (let item of data["tokens"])
                    this.tokens!.push(UserToken.fromJS(item));
            }
            this.deleterUser = data["deleterUser"] ? User.fromJS(data["deleterUser"]) : <any>undefined;
            this.creatorUser = data["creatorUser"] ? User.fromJS(data["creatorUser"]) : <any>undefined;
            this.lastModifierUser = data["lastModifierUser"] ? User.fromJS(data["lastModifierUser"]) : <any>undefined;
            this.authenticationSource = data["authenticationSource"];
            this.userName = data["userName"];
            this.tenantId = data["tenantId"];
            this.emailAddress = data["emailAddress"];
            this.name = data["name"];
            this.surname = data["surname"];
            (<any>this).fullName = data["fullName"];
            this.password = data["password"];
            this.emailConfirmationCode = data["emailConfirmationCode"];
            this.passwordResetCode = data["passwordResetCode"];
            this.lockoutEndDateUtc = data["lockoutEndDateUtc"] ? moment(data["lockoutEndDateUtc"].toString()) : <any>undefined;
            this.accessFailedCount = data["accessFailedCount"];
            this.isLockoutEnabled = data["isLockoutEnabled"];
            this.phoneNumber = data["phoneNumber"];
            this.isPhoneNumberConfirmed = data["isPhoneNumberConfirmed"];
            this.securityStamp = data["securityStamp"];
            this.isTwoFactorEnabled = data["isTwoFactorEnabled"];
            if (Array.isArray(data["logins"])) {
                this.logins = [] as any;
                for (let item of data["logins"])
                    this.logins!.push(UserLogin.fromJS(item));
            }
            if (Array.isArray(data["roles"])) {
                this.roles = [] as any;
                for (let item of data["roles"])
                    this.roles!.push(UserRole.fromJS(item));
            }
            if (Array.isArray(data["claims"])) {
                this.claims = [] as any;
                for (let item of data["claims"])
                    this.claims!.push(UserClaim.fromJS(item));
            }
            if (Array.isArray(data["permissions"])) {
                this.permissions = [] as any;
                for (let item of data["permissions"])
                    this.permissions!.push(UserPermissionSetting.fromJS(item));
            }
            if (Array.isArray(data["settings"])) {
                this.settings = [] as any;
                for (let item of data["settings"])
                    this.settings!.push(Setting.fromJS(item));
            }
            this.isEmailConfirmed = data["isEmailConfirmed"];
            this.isActive = data["isActive"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): User {
        data = typeof data === 'object' ? data : {};
        let result = new User();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["profilePictureId"] = this.profilePictureId;
        data["shouldChangePasswordOnNextLogin"] = this.shouldChangePasswordOnNextLogin;
        data["signInTokenExpireTimeUtc"] = this.signInTokenExpireTimeUtc ? this.signInTokenExpireTimeUtc.toISOString() : <any>undefined;
        data["signInToken"] = this.signInToken;
        data["googleAuthenticatorKey"] = this.googleAuthenticatorKey;
        if (Array.isArray(this.organizationUnits)) {
            data["organizationUnits"] = [];
            for (let item of this.organizationUnits)
                data["organizationUnits"].push(item.toJSON());
        }
        data["hasBackgroundImage"] = this.hasBackgroundImage;
        data["normalizedUserName"] = this.normalizedUserName;
        data["normalizedEmailAddress"] = this.normalizedEmailAddress;
        data["concurrencyStamp"] = this.concurrencyStamp;
        if (Array.isArray(this.tokens)) {
            data["tokens"] = [];
            for (let item of this.tokens)
                data["tokens"].push(item.toJSON());
        }
        data["deleterUser"] = this.deleterUser ? this.deleterUser.toJSON() : <any>undefined;
        data["creatorUser"] = this.creatorUser ? this.creatorUser.toJSON() : <any>undefined;
        data["lastModifierUser"] = this.lastModifierUser ? this.lastModifierUser.toJSON() : <any>undefined;
        data["authenticationSource"] = this.authenticationSource;
        data["userName"] = this.userName;
        data["tenantId"] = this.tenantId;
        data["emailAddress"] = this.emailAddress;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["fullName"] = this.fullName;
        data["password"] = this.password;
        data["emailConfirmationCode"] = this.emailConfirmationCode;
        data["passwordResetCode"] = this.passwordResetCode;
        data["lockoutEndDateUtc"] = this.lockoutEndDateUtc ? this.lockoutEndDateUtc.toISOString() : <any>undefined;
        data["accessFailedCount"] = this.accessFailedCount;
        data["isLockoutEnabled"] = this.isLockoutEnabled;
        data["phoneNumber"] = this.phoneNumber;
        data["isPhoneNumberConfirmed"] = this.isPhoneNumberConfirmed;
        data["securityStamp"] = this.securityStamp;
        data["isTwoFactorEnabled"] = this.isTwoFactorEnabled;
        if (Array.isArray(this.logins)) {
            data["logins"] = [];
            for (let item of this.logins)
                data["logins"].push(item.toJSON());
        }
        if (Array.isArray(this.roles)) {
            data["roles"] = [];
            for (let item of this.roles)
                data["roles"].push(item.toJSON());
        }
        if (Array.isArray(this.claims)) {
            data["claims"] = [];
            for (let item of this.claims)
                data["claims"].push(item.toJSON());
        }
        if (Array.isArray(this.permissions)) {
            data["permissions"] = [];
            for (let item of this.permissions)
                data["permissions"].push(item.toJSON());
        }
        if (Array.isArray(this.settings)) {
            data["settings"] = [];
            for (let item of this.settings)
                data["settings"].push(item.toJSON());
        }
        data["isEmailConfirmed"] = this.isEmailConfirmed;
        data["isActive"] = this.isActive;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUser {
    profilePictureId: string | undefined;
    shouldChangePasswordOnNextLogin: boolean;
    signInTokenExpireTimeUtc: moment.Moment | undefined;
    signInToken: string | undefined;
    googleAuthenticatorKey: string | undefined;
    organizationUnits: UserOrganizationUnit[] | undefined;
    hasBackgroundImage: boolean;
    normalizedUserName: string;
    normalizedEmailAddress: string;
    concurrencyStamp: string | undefined;
    tokens: UserToken[] | undefined;
    deleterUser: User | undefined;
    creatorUser: User | undefined;
    lastModifierUser: User | undefined;
    authenticationSource: string | undefined;
    userName: string;
    tenantId: number | undefined;
    emailAddress: string;
    name: string;
    surname: string;
    fullName: string | undefined;
    password: string;
    emailConfirmationCode: string | undefined;
    passwordResetCode: string | undefined;
    lockoutEndDateUtc: moment.Moment | undefined;
    accessFailedCount: number;
    isLockoutEnabled: boolean;
    phoneNumber: string | undefined;
    isPhoneNumberConfirmed: boolean;
    securityStamp: string | undefined;
    isTwoFactorEnabled: boolean;
    logins: UserLogin[] | undefined;
    roles: UserRole[] | undefined;
    claims: UserClaim[] | undefined;
    permissions: UserPermissionSetting[] | undefined;
    settings: Setting[] | undefined;
    isEmailConfirmed: boolean;
    isActive: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DriverClientUserProfileDto implements IDriverClientUserProfileDto {
    id!: number;
    userName!: string | undefined;
    name!: string | undefined;
    surname!: string | undefined;
    emailAddress!: string | undefined;
    phoneNumber!: string | undefined;

    constructor(data?: IDriverClientUserProfileDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userName = data["userName"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
        }
    }

    static fromJS(data: any): DriverClientUserProfileDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverClientUserProfileDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userName"] = this.userName;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        return data; 
    }
}

export interface IDriverClientUserProfileDto {
    id: number;
    userName: string | undefined;
    name: string | undefined;
    surname: string | undefined;
    emailAddress: string | undefined;
    phoneNumber: string | undefined;
}

export class DriverClientProfileTimesheetDto implements IDriverClientProfileTimesheetDto {
    id!: number;
    loginTime!: moment.Moment | undefined;
    logoutTime!: moment.Moment | undefined;

    constructor(data?: IDriverClientProfileTimesheetDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.loginTime = data["loginTime"] ? moment(data["loginTime"].toString()) : <any>undefined;
            this.logoutTime = data["logoutTime"] ? moment(data["logoutTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): DriverClientProfileTimesheetDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverClientProfileTimesheetDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["loginTime"] = this.loginTime ? this.loginTime.toISOString() : <any>undefined;
        data["logoutTime"] = this.logoutTime ? this.logoutTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IDriverClientProfileTimesheetDto {
    id: number;
    loginTime: moment.Moment | undefined;
    logoutTime: moment.Moment | undefined;
}

export class VehicleProfileDto implements IVehicleProfileDto {
    id!: number;
    userId!: number | undefined;
    name!: string | undefined;
    licenseNumber!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    mileage!: number | undefined;
    activeRouteId!: number | undefined;

    constructor(data?: IVehicleProfileDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.mileage = data["mileage"];
            this.activeRouteId = data["activeRouteId"];
        }
    }

    static fromJS(data: any): VehicleProfileDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleProfileDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["mileage"] = this.mileage;
        data["activeRouteId"] = this.activeRouteId;
        return data; 
    }
}

export interface IVehicleProfileDto {
    id: number;
    userId: number | undefined;
    name: string | undefined;
    licenseNumber: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    mileage: number | undefined;
    activeRouteId: number | undefined;
}

export class DriverClientProfileContactDto implements IDriverClientProfileContactDto {
    id!: number;
    companyId!: number | undefined;
    firstName!: string | undefined;
    lastName!: string | undefined;
    address!: DriverClientProfileAddressDto | undefined;

    constructor(data?: IDriverClientProfileContactDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.companyId = data["companyId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.address = data["address"] ? DriverClientProfileAddressDto.fromJS(data["address"]) : <any>undefined;
        }
    }

    static fromJS(data: any): DriverClientProfileContactDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverClientProfileContactDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["companyId"] = this.companyId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IDriverClientProfileContactDto {
    id: number;
    companyId: number | undefined;
    firstName: string | undefined;
    lastName: string | undefined;
    address: DriverClientProfileAddressDto | undefined;
}

export class GetProfileCompanyItemDto implements IGetProfileCompanyItemDto {
    id!: number;
    name!: string | undefined;
    accountNumber!: string | undefined;
    clinicId!: number | undefined;

    constructor(data?: IGetProfileCompanyItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.accountNumber = data["accountNumber"];
            this.clinicId = data["clinicId"];
        }
    }

    static fromJS(data: any): GetProfileCompanyItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetProfileCompanyItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["accountNumber"] = this.accountNumber;
        data["clinicId"] = this.clinicId;
        return data; 
    }
}

export interface IGetProfileCompanyItemDto {
    id: number;
    name: string | undefined;
    accountNumber: string | undefined;
    clinicId: number | undefined;
}

export class OrderStatusTypeProfileDto implements IOrderStatusTypeProfileDto {
    id!: number;
    code!: string | undefined;

    constructor(data?: IOrderStatusTypeProfileDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): OrderStatusTypeProfileDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusTypeProfileDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        return data; 
    }
}

export interface IOrderStatusTypeProfileDto {
    id: number;
    code: string | undefined;
}

export class ListResultDtoOfOrderStatusTypeProfileDto implements IListResultDtoOfOrderStatusTypeProfileDto {
    items!: OrderStatusTypeProfileDto[] | undefined;

    constructor(data?: IListResultDtoOfOrderStatusTypeProfileDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusTypeProfileDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfOrderStatusTypeProfileDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfOrderStatusTypeProfileDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfOrderStatusTypeProfileDto {
    items: OrderStatusTypeProfileDto[] | undefined;
}

export class DriverClientProfileProximityDto implements IDriverClientProfileProximityDto {
    addressType!: string | undefined;
    value!: number;

    constructor(data?: IDriverClientProfileProximityDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressType = data["addressType"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): DriverClientProfileProximityDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverClientProfileProximityDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressType"] = this.addressType;
        data["value"] = this.value;
        return data; 
    }
}

export interface IDriverClientProfileProximityDto {
    addressType: string | undefined;
    value: number;
}

export class MobileMessageActionTypeDto implements IMobileMessageActionTypeDto {
    id!: number;
    code!: string | undefined;

    constructor(data?: IMobileMessageActionTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): MobileMessageActionTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new MobileMessageActionTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        return data; 
    }
}

export interface IMobileMessageActionTypeDto {
    id: number;
    code: string | undefined;
}

export class ListResultDtoOfMobileVersionListDto implements IListResultDtoOfMobileVersionListDto {
    items!: MobileVersionListDto[] | undefined;

    constructor(data?: IListResultDtoOfMobileVersionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(MobileVersionListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfMobileVersionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfMobileVersionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfMobileVersionListDto {
    items: MobileVersionListDto[] | undefined;
}

export class DriverClientProfileOrderTypeDto implements IDriverClientProfileOrderTypeDto {
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;

    constructor(data?: IDriverClientProfileOrderTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
        }
    }

    static fromJS(data: any): DriverClientProfileOrderTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverClientProfileOrderTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        return data; 
    }
}

export interface IDriverClientProfileOrderTypeDto {
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
}

export class ListResultDtoOfDriverClientProfileOrderTypeDto implements IListResultDtoOfDriverClientProfileOrderTypeDto {
    items!: DriverClientProfileOrderTypeDto[] | undefined;

    constructor(data?: IListResultDtoOfDriverClientProfileOrderTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(DriverClientProfileOrderTypeDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfDriverClientProfileOrderTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfDriverClientProfileOrderTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfDriverClientProfileOrderTypeDto {
    items: DriverClientProfileOrderTypeDto[] | undefined;
}

export class GetMobileThemeListDto implements IGetMobileThemeListDto {
    id!: number;
    attribute!: string | undefined;
    value!: string | undefined;

    constructor(data?: IGetMobileThemeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.attribute = data["attribute"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): GetMobileThemeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileThemeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["attribute"] = this.attribute;
        data["value"] = this.value;
        return data; 
    }
}

export interface IGetMobileThemeListDto {
    id: number;
    attribute: string | undefined;
    value: string | undefined;
}

export class ListResultDtoOfGetMobileThemeListDto implements IListResultDtoOfGetMobileThemeListDto {
    items!: GetMobileThemeListDto[] | undefined;

    constructor(data?: IListResultDtoOfGetMobileThemeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetMobileThemeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetMobileThemeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetMobileThemeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetMobileThemeListDto {
    items: GetMobileThemeListDto[] | undefined;
}

export class DriverClientProfileUserPreferenceListItemDto implements IDriverClientProfileUserPreferenceListItemDto {
    code!: string | undefined;
    value!: string | undefined;

    constructor(data?: IDriverClientProfileUserPreferenceListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): DriverClientProfileUserPreferenceListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverClientProfileUserPreferenceListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["value"] = this.value;
        return data; 
    }
}

export interface IDriverClientProfileUserPreferenceListItemDto {
    code: string | undefined;
    value: string | undefined;
}

export class ListResultDtoOfDriverClientProfileUserPreferenceListItemDto implements IListResultDtoOfDriverClientProfileUserPreferenceListItemDto {
    items!: DriverClientProfileUserPreferenceListItemDto[] | undefined;

    constructor(data?: IListResultDtoOfDriverClientProfileUserPreferenceListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(DriverClientProfileUserPreferenceListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfDriverClientProfileUserPreferenceListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfDriverClientProfileUserPreferenceListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfDriverClientProfileUserPreferenceListItemDto {
    items: DriverClientProfileUserPreferenceListItemDto[] | undefined;
}

export class DriverClientProfile implements IDriverClientProfile {
    edition!: string | undefined;
    blindCountLimit!: number | undefined;
    user!: DriverClientUserProfileDto | undefined;
    timeSheet!: DriverClientProfileTimesheetDto | undefined;
    vehicle!: VehicleProfileDto | undefined;
    contact!: DriverClientProfileContactDto | undefined;
    clinicIds!: number[] | undefined;
    companies!: GetProfileCompanyItemDto[] | undefined;
    orderStatusType!: ListResultDtoOfOrderStatusTypeProfileDto | undefined;
    addressTypes!: DriverClientProfileProximityDto[] | undefined;
    messageActions!: MobileMessageActionTypeDto[] | undefined;
    mobileAppVersions!: ListResultDtoOfMobileVersionListDto | undefined;
    orderTypes!: ListResultDtoOfDriverClientProfileOrderTypeDto | undefined;
    appSettings!: ListResultDtoOfGetMobileThemeListDto | undefined;
    containers!: ListResultDtoOfGetContainersItemListDto | undefined;
    userPreferences!: ListResultDtoOfDriverClientProfileUserPreferenceListItemDto | undefined;

    constructor(data?: IDriverClientProfile) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.edition = data["edition"];
            this.blindCountLimit = data["blindCountLimit"];
            this.user = data["user"] ? DriverClientUserProfileDto.fromJS(data["user"]) : <any>undefined;
            this.timeSheet = data["timeSheet"] ? DriverClientProfileTimesheetDto.fromJS(data["timeSheet"]) : <any>undefined;
            this.vehicle = data["vehicle"] ? VehicleProfileDto.fromJS(data["vehicle"]) : <any>undefined;
            this.contact = data["contact"] ? DriverClientProfileContactDto.fromJS(data["contact"]) : <any>undefined;
            if (Array.isArray(data["clinicIds"])) {
                this.clinicIds = [] as any;
                for (let item of data["clinicIds"])
                    this.clinicIds!.push(item);
            }
            if (Array.isArray(data["companies"])) {
                this.companies = [] as any;
                for (let item of data["companies"])
                    this.companies!.push(GetProfileCompanyItemDto.fromJS(item));
            }
            this.orderStatusType = data["orderStatusType"] ? ListResultDtoOfOrderStatusTypeProfileDto.fromJS(data["orderStatusType"]) : <any>undefined;
            if (Array.isArray(data["addressTypes"])) {
                this.addressTypes = [] as any;
                for (let item of data["addressTypes"])
                    this.addressTypes!.push(DriverClientProfileProximityDto.fromJS(item));
            }
            if (Array.isArray(data["messageActions"])) {
                this.messageActions = [] as any;
                for (let item of data["messageActions"])
                    this.messageActions!.push(MobileMessageActionTypeDto.fromJS(item));
            }
            this.mobileAppVersions = data["mobileAppVersions"] ? ListResultDtoOfMobileVersionListDto.fromJS(data["mobileAppVersions"]) : <any>undefined;
            this.orderTypes = data["orderTypes"] ? ListResultDtoOfDriverClientProfileOrderTypeDto.fromJS(data["orderTypes"]) : <any>undefined;
            this.appSettings = data["appSettings"] ? ListResultDtoOfGetMobileThemeListDto.fromJS(data["appSettings"]) : <any>undefined;
            this.containers = data["containers"] ? ListResultDtoOfGetContainersItemListDto.fromJS(data["containers"]) : <any>undefined;
            this.userPreferences = data["userPreferences"] ? ListResultDtoOfDriverClientProfileUserPreferenceListItemDto.fromJS(data["userPreferences"]) : <any>undefined;
        }
    }

    static fromJS(data: any): DriverClientProfile {
        data = typeof data === 'object' ? data : {};
        let result = new DriverClientProfile();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["edition"] = this.edition;
        data["blindCountLimit"] = this.blindCountLimit;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["timeSheet"] = this.timeSheet ? this.timeSheet.toJSON() : <any>undefined;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        if (Array.isArray(this.clinicIds)) {
            data["clinicIds"] = [];
            for (let item of this.clinicIds)
                data["clinicIds"].push(item);
        }
        if (Array.isArray(this.companies)) {
            data["companies"] = [];
            for (let item of this.companies)
                data["companies"].push(item.toJSON());
        }
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        if (Array.isArray(this.addressTypes)) {
            data["addressTypes"] = [];
            for (let item of this.addressTypes)
                data["addressTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.messageActions)) {
            data["messageActions"] = [];
            for (let item of this.messageActions)
                data["messageActions"].push(item.toJSON());
        }
        data["mobileAppVersions"] = this.mobileAppVersions ? this.mobileAppVersions.toJSON() : <any>undefined;
        data["orderTypes"] = this.orderTypes ? this.orderTypes.toJSON() : <any>undefined;
        data["appSettings"] = this.appSettings ? this.appSettings.toJSON() : <any>undefined;
        data["containers"] = this.containers ? this.containers.toJSON() : <any>undefined;
        data["userPreferences"] = this.userPreferences ? this.userPreferences.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IDriverClientProfile {
    edition: string | undefined;
    blindCountLimit: number | undefined;
    user: DriverClientUserProfileDto | undefined;
    timeSheet: DriverClientProfileTimesheetDto | undefined;
    vehicle: VehicleProfileDto | undefined;
    contact: DriverClientProfileContactDto | undefined;
    clinicIds: number[] | undefined;
    companies: GetProfileCompanyItemDto[] | undefined;
    orderStatusType: ListResultDtoOfOrderStatusTypeProfileDto | undefined;
    addressTypes: DriverClientProfileProximityDto[] | undefined;
    messageActions: MobileMessageActionTypeDto[] | undefined;
    mobileAppVersions: ListResultDtoOfMobileVersionListDto | undefined;
    orderTypes: ListResultDtoOfDriverClientProfileOrderTypeDto | undefined;
    appSettings: ListResultDtoOfGetMobileThemeListDto | undefined;
    containers: ListResultDtoOfGetContainersItemListDto | undefined;
    userPreferences: ListResultDtoOfDriverClientProfileUserPreferenceListItemDto | undefined;
}

export class LoginUnlockInputDto implements ILoginUnlockInputDto {
    userName!: string | undefined;

    constructor(data?: ILoginUnlockInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userName = data["userName"];
        }
    }

    static fromJS(data: any): LoginUnlockInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new LoginUnlockInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userName"] = this.userName;
        return data; 
    }
}

export interface ILoginUnlockInputDto {
    userName: string | undefined;
}

export class LoginUnlockByIdInputDto implements ILoginUnlockByIdInputDto {
    userId!: number;

    constructor(data?: ILoginUnlockByIdInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): LoginUnlockByIdInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new LoginUnlockByIdInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        return data; 
    }
}

export interface ILoginUnlockByIdInputDto {
    userId: number;
}

export enum MobileClientMessageAction {
    CONFIRM_NOTE = 1,
    ACCEPT_DECLINE_ORDER = 2,
}

export class GetMobileMessagesItemDto implements IGetMobileMessagesItemDto {
    id!: number;
    action!: MobileClientMessageAction;
    content!: string | undefined;
    dateCreated!: moment.Moment;

    constructor(data?: IGetMobileMessagesItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.action = data["action"];
            this.content = data["content"];
            this.dateCreated = data["dateCreated"] ? moment(data["dateCreated"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetMobileMessagesItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileMessagesItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["action"] = this.action;
        data["content"] = this.content;
        data["dateCreated"] = this.dateCreated ? this.dateCreated.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetMobileMessagesItemDto {
    id: number;
    action: MobileClientMessageAction;
    content: string | undefined;
    dateCreated: moment.Moment;
}

export class ListResultDtoOfGetMobileMessagesItemDto implements IListResultDtoOfGetMobileMessagesItemDto {
    items!: GetMobileMessagesItemDto[] | undefined;

    constructor(data?: IListResultDtoOfGetMobileMessagesItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetMobileMessagesItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetMobileMessagesItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetMobileMessagesItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetMobileMessagesItemDto {
    items: GetMobileMessagesItemDto[] | undefined;
}

export class SetFirebaseTokenInputDto implements ISetFirebaseTokenInputDto {
    token!: string | undefined;

    constructor(data?: ISetFirebaseTokenInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.token = data["token"];
        }
    }

    static fromJS(data: any): SetFirebaseTokenInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new SetFirebaseTokenInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["token"] = this.token;
        return data; 
    }
}

export interface ISetFirebaseTokenInputDto {
    token: string | undefined;
}

export class SendCacheDataInputDto implements ISendCacheDataInputDto {
    base64EncodedData!: string | undefined;

    constructor(data?: ISendCacheDataInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.base64EncodedData = data["base64EncodedData"];
        }
    }

    static fromJS(data: any): SendCacheDataInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new SendCacheDataInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["base64EncodedData"] = this.base64EncodedData;
        return data; 
    }
}

export interface ISendCacheDataInputDto {
    base64EncodedData: string | undefined;
}

export class MobileClientWarningItemDto implements IMobileClientWarningItemDto {
    code!: string | undefined;
    count!: number;
    limit!: number | undefined;

    constructor(data?: IMobileClientWarningItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.count = data["count"];
            this.limit = data["limit"];
        }
    }

    static fromJS(data: any): MobileClientWarningItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new MobileClientWarningItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["count"] = this.count;
        data["limit"] = this.limit;
        return data; 
    }
}

export interface IMobileClientWarningItemDto {
    code: string | undefined;
    count: number;
    limit: number | undefined;
}

export class CreateDriverIncidentInput implements ICreateDriverIncidentInput {
    incidentId!: number;
    userId!: number;

    constructor(data?: ICreateDriverIncidentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentId = data["incidentId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): CreateDriverIncidentInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDriverIncidentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentId"] = this.incidentId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface ICreateDriverIncidentInput {
    incidentId: number;
    userId: number;
}

export class IncidentListDto implements IIncidentListDto {
    id!: number;
    tenantId!: number;
    geocodeId!: number;
    geocode!: GeocodeListDto | undefined;
    content!: string | undefined;
    incidentDate!: moment.Moment;

    constructor(data?: IIncidentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.geocodeId = data["geocodeId"];
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.content = data["content"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): IncidentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["geocodeId"] = this.geocodeId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["content"] = this.content;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IIncidentListDto {
    id: number;
    tenantId: number;
    geocodeId: number;
    geocode: GeocodeListDto | undefined;
    content: string | undefined;
    incidentDate: moment.Moment;
}

export class DriverIncidentListDto implements IDriverIncidentListDto {
    id!: number;
    tenantId!: number;
    incident!: IncidentListDto | undefined;
    user!: UserListDto | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;

    constructor(data?: IDriverIncidentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.incident = data["incident"] ? IncidentListDto.fromJS(data["incident"]) : <any>undefined;
            this.user = data["user"] ? UserListDto.fromJS(data["user"]) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
        }
    }

    static fromJS(data: any): DriverIncidentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncidentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["incident"] = this.incident ? this.incident.toJSON() : <any>undefined;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        return data; 
    }
}

export interface IDriverIncidentListDto {
    id: number;
    tenantId: number;
    incident: IncidentListDto | undefined;
    user: UserListDto | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
}

export class PagedResultDtoOfDriverIncidentListDto implements IPagedResultDtoOfDriverIncidentListDto {
    totalCount!: number;
    items!: DriverIncidentListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfDriverIncidentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(DriverIncidentListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfDriverIncidentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfDriverIncidentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfDriverIncidentListDto {
    totalCount: number;
    items: DriverIncidentListDto[] | undefined;
}

export class UpdateDriverIncidentInput implements IUpdateDriverIncidentInput {
    id!: number;
    incidentId!: number;
    userId!: number;

    constructor(data?: IUpdateDriverIncidentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.incidentId = data["incidentId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): UpdateDriverIncidentInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateDriverIncidentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["incidentId"] = this.incidentId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IUpdateDriverIncidentInput {
    id: number;
    incidentId: number;
    userId: number;
}

export class DriverIncidentAttachment implements IDriverIncidentAttachment {
    fileName!: string | undefined;
    base64EncodedData!: string | undefined;
    incidentId!: number;

    constructor(data?: IDriverIncidentAttachment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.base64EncodedData = data["base64EncodedData"];
            this.incidentId = data["incidentId"];
        }
    }

    static fromJS(data: any): DriverIncidentAttachment {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncidentAttachment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["base64EncodedData"] = this.base64EncodedData;
        data["incidentId"] = this.incidentId;
        return data; 
    }
}

export interface IDriverIncidentAttachment {
    fileName: string | undefined;
    base64EncodedData: string | undefined;
    incidentId: number;
}

export class DriverIncidentNotes implements IDriverIncidentNotes {
    incidentId!: number;
    notes!: string | undefined;

    constructor(data?: IDriverIncidentNotes) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentId = data["incidentId"];
            this.notes = data["notes"];
        }
    }

    static fromJS(data: any): DriverIncidentNotes {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncidentNotes();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentId"] = this.incidentId;
        data["notes"] = this.notes;
        return data; 
    }
}

export interface IDriverIncidentNotes {
    incidentId: number;
    notes: string | undefined;
}

export class CreateOrEditDriverIncidentsInput implements ICreateOrEditDriverIncidentsInput {
    id!: number | undefined;
    userId!: number;
    incidentContent!: string | undefined;
    incidentDate!: moment.Moment;
    driverIncidentTypeId!: number | undefined;
    incidentTypeId!: number | undefined;
    geocodeId!: number | undefined;
    incidentStatusId!: number | undefined;
    managerId!: number | undefined;
    email!: string | undefined;
    createAttachments!: DriverIncidentAttachment[] | undefined;
    createNotes!: DriverIncidentNotes[] | undefined;

    constructor(data?: ICreateOrEditDriverIncidentsInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.incidentContent = data["incidentContent"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.driverIncidentTypeId = data["driverIncidentTypeId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.geocodeId = data["geocodeId"];
            this.incidentStatusId = data["incidentStatusId"];
            this.managerId = data["managerId"];
            this.email = data["email"];
            if (Array.isArray(data["createAttachments"])) {
                this.createAttachments = [] as any;
                for (let item of data["createAttachments"])
                    this.createAttachments!.push(DriverIncidentAttachment.fromJS(item));
            }
            if (Array.isArray(data["createNotes"])) {
                this.createNotes = [] as any;
                for (let item of data["createNotes"])
                    this.createNotes!.push(DriverIncidentNotes.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateOrEditDriverIncidentsInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditDriverIncidentsInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["incidentContent"] = this.incidentContent;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["driverIncidentTypeId"] = this.driverIncidentTypeId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["geocodeId"] = this.geocodeId;
        data["incidentStatusId"] = this.incidentStatusId;
        data["managerId"] = this.managerId;
        data["email"] = this.email;
        if (Array.isArray(this.createAttachments)) {
            data["createAttachments"] = [];
            for (let item of this.createAttachments)
                data["createAttachments"].push(item.toJSON());
        }
        if (Array.isArray(this.createNotes)) {
            data["createNotes"] = [];
            for (let item of this.createNotes)
                data["createNotes"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateOrEditDriverIncidentsInput {
    id: number | undefined;
    userId: number;
    incidentContent: string | undefined;
    incidentDate: moment.Moment;
    driverIncidentTypeId: number | undefined;
    incidentTypeId: number | undefined;
    geocodeId: number | undefined;
    incidentStatusId: number | undefined;
    managerId: number | undefined;
    email: string | undefined;
    createAttachments: DriverIncidentAttachment[] | undefined;
    createNotes: DriverIncidentNotes[] | undefined;
}

export class DriverIncidentsListDto implements IDriverIncidentsListDto {
    tenantId!: number;
    creator!: string | undefined;
    incidentId!: number;
    incidentContent!: string | undefined;
    incidentDate!: moment.Moment;
    driverIncidentTypeId!: number | undefined;
    driverIncidentType!: string | undefined;
    driverIncidentStatus!: string | undefined;
    driverName!: string | undefined;
    managerName!: string | undefined;
    userId!: number;
    geocodeId!: number | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDriverIncidentsListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.creator = data["creator"];
            this.incidentId = data["incidentId"];
            this.incidentContent = data["incidentContent"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.driverIncidentTypeId = data["driverIncidentTypeId"];
            this.driverIncidentType = data["driverIncidentType"];
            this.driverIncidentStatus = data["driverIncidentStatus"];
            this.driverName = data["driverName"];
            this.managerName = data["managerName"];
            this.userId = data["userId"];
            this.geocodeId = data["geocodeId"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DriverIncidentsListDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncidentsListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["creator"] = this.creator;
        data["incidentId"] = this.incidentId;
        data["incidentContent"] = this.incidentContent;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["driverIncidentTypeId"] = this.driverIncidentTypeId;
        data["driverIncidentType"] = this.driverIncidentType;
        data["driverIncidentStatus"] = this.driverIncidentStatus;
        data["driverName"] = this.driverName;
        data["managerName"] = this.managerName;
        data["userId"] = this.userId;
        data["geocodeId"] = this.geocodeId;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDriverIncidentsListDto {
    tenantId: number;
    creator: string | undefined;
    incidentId: number;
    incidentContent: string | undefined;
    incidentDate: moment.Moment;
    driverIncidentTypeId: number | undefined;
    driverIncidentType: string | undefined;
    driverIncidentStatus: string | undefined;
    driverName: string | undefined;
    managerName: string | undefined;
    userId: number;
    geocodeId: number | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class PagedResultDtoOfDriverIncidentsListDto implements IPagedResultDtoOfDriverIncidentsListDto {
    totalCount!: number;
    items!: DriverIncidentsListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfDriverIncidentsListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(DriverIncidentsListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfDriverIncidentsListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfDriverIncidentsListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfDriverIncidentsListDto {
    totalCount: number;
    items: DriverIncidentsListDto[] | undefined;
}

export class DriverIncidentAttachmentForUpdate implements IDriverIncidentAttachmentForUpdate {
    fileName!: string | undefined;
    data!: string | undefined;
    incidentId!: number;
    id!: number;

    constructor(data?: IDriverIncidentAttachmentForUpdate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.data = data["data"];
            this.incidentId = data["incidentId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DriverIncidentAttachmentForUpdate {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncidentAttachmentForUpdate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["data"] = this.data;
        data["incidentId"] = this.incidentId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDriverIncidentAttachmentForUpdate {
    fileName: string | undefined;
    data: string | undefined;
    incidentId: number;
    id: number;
}

export class DriverIncidentNotesForUpdate implements IDriverIncidentNotesForUpdate {
    incidentId!: number;
    notes!: string | undefined;
    creator!: string | undefined;
    dateCreated!: moment.Moment;
    id!: number;

    constructor(data?: IDriverIncidentNotesForUpdate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentId = data["incidentId"];
            this.notes = data["notes"];
            this.creator = data["creator"];
            this.dateCreated = data["dateCreated"] ? moment(data["dateCreated"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DriverIncidentNotesForUpdate {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncidentNotesForUpdate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentId"] = this.incidentId;
        data["notes"] = this.notes;
        data["creator"] = this.creator;
        data["dateCreated"] = this.dateCreated ? this.dateCreated.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDriverIncidentNotesForUpdate {
    incidentId: number;
    notes: string | undefined;
    creator: string | undefined;
    dateCreated: moment.Moment;
    id: number;
}

export class GetDriverIncidentForEditDto implements IGetDriverIncidentForEditDto {
    id!: number;
    userId!: number;
    incidentDate!: moment.Moment;
    incidentContent!: string | undefined;
    statusId!: number | undefined;
    managerId!: number | undefined;
    email!: string | undefined;
    driverIncidentTypeId!: number | undefined;
    incidentId!: number;
    driverName!: string | undefined;
    incidentTypeName!: string | undefined;
    incidenStatusName!: string | undefined;
    managerName!: string | undefined;
    attachments!: DriverIncidentAttachmentForUpdate[] | undefined;
    notes!: DriverIncidentNotesForUpdate[] | undefined;

    constructor(data?: IGetDriverIncidentForEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.incidentContent = data["incidentContent"];
            this.statusId = data["statusId"];
            this.managerId = data["managerId"];
            this.email = data["email"];
            this.driverIncidentTypeId = data["driverIncidentTypeId"];
            this.incidentId = data["incidentId"];
            this.driverName = data["driverName"];
            this.incidentTypeName = data["incidentTypeName"];
            this.incidenStatusName = data["incidenStatusName"];
            this.managerName = data["managerName"];
            if (Array.isArray(data["attachments"])) {
                this.attachments = [] as any;
                for (let item of data["attachments"])
                    this.attachments!.push(DriverIncidentAttachmentForUpdate.fromJS(item));
            }
            if (Array.isArray(data["notes"])) {
                this.notes = [] as any;
                for (let item of data["notes"])
                    this.notes!.push(DriverIncidentNotesForUpdate.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetDriverIncidentForEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverIncidentForEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["incidentContent"] = this.incidentContent;
        data["statusId"] = this.statusId;
        data["managerId"] = this.managerId;
        data["email"] = this.email;
        data["driverIncidentTypeId"] = this.driverIncidentTypeId;
        data["incidentId"] = this.incidentId;
        data["driverName"] = this.driverName;
        data["incidentTypeName"] = this.incidentTypeName;
        data["incidenStatusName"] = this.incidenStatusName;
        data["managerName"] = this.managerName;
        if (Array.isArray(this.attachments)) {
            data["attachments"] = [];
            for (let item of this.attachments)
                data["attachments"].push(item.toJSON());
        }
        if (Array.isArray(this.notes)) {
            data["notes"] = [];
            for (let item of this.notes)
                data["notes"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetDriverIncidentForEditDto {
    id: number;
    userId: number;
    incidentDate: moment.Moment;
    incidentContent: string | undefined;
    statusId: number | undefined;
    managerId: number | undefined;
    email: string | undefined;
    driverIncidentTypeId: number | undefined;
    incidentId: number;
    driverName: string | undefined;
    incidentTypeName: string | undefined;
    incidenStatusName: string | undefined;
    managerName: string | undefined;
    attachments: DriverIncidentAttachmentForUpdate[] | undefined;
    notes: DriverIncidentNotesForUpdate[] | undefined;
}

export class GetDriverList implements IGetDriverList {
    id!: number | undefined;
    fullName!: string | undefined;
    email!: string | undefined;
    userName!: string | undefined;

    constructor(data?: IGetDriverList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.fullName = data["fullName"];
            this.email = data["email"];
            this.userName = data["userName"];
        }
    }

    static fromJS(data: any): GetDriverList {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["fullName"] = this.fullName;
        data["email"] = this.email;
        data["userName"] = this.userName;
        return data; 
    }
}

export interface IGetDriverList {
    id: number | undefined;
    fullName: string | undefined;
    email: string | undefined;
    userName: string | undefined;
}

export class GetAttachmentListDto implements IGetAttachmentListDto {
    fileName!: string | undefined;
    data!: string | undefined;
    incidentId!: number;
    id!: number;
    extensionName!: string | undefined;

    constructor(data?: IGetAttachmentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.data = data["data"];
            this.incidentId = data["incidentId"];
            this.id = data["id"];
            this.extensionName = data["extensionName"];
        }
    }

    static fromJS(data: any): GetAttachmentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetAttachmentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["data"] = this.data;
        data["incidentId"] = this.incidentId;
        data["id"] = this.id;
        data["extensionName"] = this.extensionName;
        return data; 
    }
}

export interface IGetAttachmentListDto {
    fileName: string | undefined;
    data: string | undefined;
    incidentId: number;
    id: number;
    extensionName: string | undefined;
}

export class DriverIncidentTypeDto implements IDriverIncidentTypeDto {
    name!: string | undefined;
    code!: string | undefined;
    sortOrder!: number;
    isStatic!: boolean;
    id!: number;

    constructor(data?: IDriverIncidentTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.sortOrder = data["sortOrder"];
            this.isStatic = data["isStatic"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DriverIncidentTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncidentTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["sortOrder"] = this.sortOrder;
        data["isStatic"] = this.isStatic;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDriverIncidentTypeDto {
    name: string | undefined;
    code: string | undefined;
    sortOrder: number;
    isStatic: boolean;
    id: number;
}

export class GetDriverIncidentTypeForViewDto implements IGetDriverIncidentTypeForViewDto {
    driverIncidentType!: DriverIncidentTypeDto | undefined;

    constructor(data?: IGetDriverIncidentTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverIncidentType = data["driverIncidentType"] ? DriverIncidentTypeDto.fromJS(data["driverIncidentType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetDriverIncidentTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverIncidentTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverIncidentType"] = this.driverIncidentType ? this.driverIncidentType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetDriverIncidentTypeForViewDto {
    driverIncidentType: DriverIncidentTypeDto | undefined;
}

export class PagedResultDtoOfGetDriverIncidentTypeForViewDto implements IPagedResultDtoOfGetDriverIncidentTypeForViewDto {
    totalCount!: number;
    items!: GetDriverIncidentTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetDriverIncidentTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetDriverIncidentTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetDriverIncidentTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetDriverIncidentTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetDriverIncidentTypeForViewDto {
    totalCount: number;
    items: GetDriverIncidentTypeForViewDto[] | undefined;
}

export class CreateOrEditDriverIncidentTypeDto implements ICreateOrEditDriverIncidentTypeDto {
    name!: string;
    code!: string;
    sortOrder!: number;
    isStatic!: boolean;
    id!: number | undefined;

    constructor(data?: ICreateOrEditDriverIncidentTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.sortOrder = data["sortOrder"];
            this.isStatic = data["isStatic"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditDriverIncidentTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditDriverIncidentTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["sortOrder"] = this.sortOrder;
        data["isStatic"] = this.isStatic;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditDriverIncidentTypeDto {
    name: string;
    code: string;
    sortOrder: number;
    isStatic: boolean;
    id: number | undefined;
}

export class GetDriverIncidentTypeForEditOutput implements IGetDriverIncidentTypeForEditOutput {
    driverIncidentType!: CreateOrEditDriverIncidentTypeDto | undefined;

    constructor(data?: IGetDriverIncidentTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverIncidentType = data["driverIncidentType"] ? CreateOrEditDriverIncidentTypeDto.fromJS(data["driverIncidentType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetDriverIncidentTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverIncidentTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverIncidentType"] = this.driverIncidentType ? this.driverIncidentType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetDriverIncidentTypeForEditOutput {
    driverIncidentType: CreateOrEditDriverIncidentTypeDto | undefined;
}

export class ListResultDtoOfRouteListDto implements IListResultDtoOfRouteListDto {
    items!: RouteListDto[] | undefined;

    constructor(data?: IListResultDtoOfRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfRouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfRouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfRouteListDto {
    items: RouteListDto[] | undefined;
}

export class DriverProximityDto implements IDriverProximityDto {
    routeId!: number | undefined;
    driverName!: string | undefined;
    vehicleName!: string | undefined;
    routeCode!: string | undefined;
    proximityDetails!: DriverProximityDetails[] | undefined;

    constructor(data?: IDriverProximityDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.driverName = data["driverName"];
            this.vehicleName = data["vehicleName"];
            this.routeCode = data["routeCode"];
            if (Array.isArray(data["proximityDetails"])) {
                this.proximityDetails = [] as any;
                for (let item of data["proximityDetails"])
                    this.proximityDetails!.push(DriverProximityDetails.fromJS(item));
            }
        }
    }

    static fromJS(data: any): DriverProximityDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverProximityDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["driverName"] = this.driverName;
        data["vehicleName"] = this.vehicleName;
        data["routeCode"] = this.routeCode;
        if (Array.isArray(this.proximityDetails)) {
            data["proximityDetails"] = [];
            for (let item of this.proximityDetails)
                data["proximityDetails"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IDriverProximityDto {
    routeId: number | undefined;
    driverName: string | undefined;
    vehicleName: string | undefined;
    routeCode: string | undefined;
    proximityDetails: DriverProximityDetails[] | undefined;
}

export class AcceptProximityInput implements IAcceptProximityInput {
    orderId!: number;

    constructor(data?: IAcceptProximityInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): AcceptProximityInput {
        data = typeof data === 'object' ? data : {};
        let result = new AcceptProximityInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface IAcceptProximityInput {
    orderId: number;
}

export class CreateDriverRatingInput implements ICreateDriverRatingInput {
    trackId!: string | undefined;
    starRating!: number;
    subject!: string | undefined;
    details!: string | undefined;

    constructor(data?: ICreateDriverRatingInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.trackId = data["trackId"];
            this.starRating = data["starRating"];
            this.subject = data["subject"];
            this.details = data["details"];
        }
    }

    static fromJS(data: any): CreateDriverRatingInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDriverRatingInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["trackId"] = this.trackId;
        data["starRating"] = this.starRating;
        data["subject"] = this.subject;
        data["details"] = this.details;
        return data; 
    }
}

export interface ICreateDriverRatingInput {
    trackId: string | undefined;
    starRating: number;
    subject: string | undefined;
    details: string | undefined;
}

export class DriverRatingDto implements IDriverRatingDto {
    starRating!: number;
    orderId!: number;
    driverId!: number;
    subject!: string | undefined;
    details!: string | undefined;
    id!: number;

    constructor(data?: IDriverRatingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.starRating = data["starRating"];
            this.orderId = data["orderId"];
            this.driverId = data["driverId"];
            this.subject = data["subject"];
            this.details = data["details"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DriverRatingDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverRatingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["starRating"] = this.starRating;
        data["orderId"] = this.orderId;
        data["driverId"] = this.driverId;
        data["subject"] = this.subject;
        data["details"] = this.details;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDriverRatingDto {
    starRating: number;
    orderId: number;
    driverId: number;
    subject: string | undefined;
    details: string | undefined;
    id: number;
}

export class DriverRouteHistory implements IDriverRouteHistory {
    routeId!: number | undefined;
    routeDate!: moment.Moment;
    routeDay!: string | undefined;
    vehicleName!: string | undefined;
    totalOrders!: number;
    totalPrice!: number;
    userId!: number | undefined;
    totalHours!: string | undefined;
    sph!: string | undefined;

    constructor(data?: IDriverRouteHistory) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.routeDate = data["routeDate"] ? moment(data["routeDate"].toString()) : <any>undefined;
            this.routeDay = data["routeDay"];
            this.vehicleName = data["vehicleName"];
            this.totalOrders = data["totalOrders"];
            this.totalPrice = data["totalPrice"];
            this.userId = data["userId"];
            this.totalHours = data["totalHours"];
            this.sph = data["sph"];
        }
    }

    static fromJS(data: any): DriverRouteHistory {
        data = typeof data === 'object' ? data : {};
        let result = new DriverRouteHistory();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["routeDate"] = this.routeDate ? this.routeDate.toISOString() : <any>undefined;
        data["routeDay"] = this.routeDay;
        data["vehicleName"] = this.vehicleName;
        data["totalOrders"] = this.totalOrders;
        data["totalPrice"] = this.totalPrice;
        data["userId"] = this.userId;
        data["totalHours"] = this.totalHours;
        data["sph"] = this.sph;
        return data; 
    }
}

export interface IDriverRouteHistory {
    routeId: number | undefined;
    routeDate: moment.Moment;
    routeDay: string | undefined;
    vehicleName: string | undefined;
    totalOrders: number;
    totalPrice: number;
    userId: number | undefined;
    totalHours: string | undefined;
    sph: string | undefined;
}

export class DriverReportDetailDto implements IDriverReportDetailDto {
    driverName!: string | undefined;
    driverRouteHistory!: DriverRouteHistory[] | undefined;

    constructor(data?: IDriverReportDetailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverName = data["driverName"];
            if (Array.isArray(data["driverRouteHistory"])) {
                this.driverRouteHistory = [] as any;
                for (let item of data["driverRouteHistory"])
                    this.driverRouteHistory!.push(DriverRouteHistory.fromJS(item));
            }
        }
    }

    static fromJS(data: any): DriverReportDetailDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverReportDetailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverName"] = this.driverName;
        if (Array.isArray(this.driverRouteHistory)) {
            data["driverRouteHistory"] = [];
            for (let item of this.driverRouteHistory)
                data["driverRouteHistory"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IDriverReportDetailDto {
    driverName: string | undefined;
    driverRouteHistory: DriverRouteHistory[] | undefined;
}

export class DriverReportSummaryDto implements IDriverReportSummaryDto {
    driverName!: string | undefined;
    driverUserId!: number | undefined;
    totalLoadLists!: number;
    totalHours!: string | undefined;
    totalPackages!: number;
    packagesPerHour!: string | undefined;

    constructor(data?: IDriverReportSummaryDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverName = data["driverName"];
            this.driverUserId = data["driverUserId"];
            this.totalLoadLists = data["totalLoadLists"];
            this.totalHours = data["totalHours"];
            this.totalPackages = data["totalPackages"];
            this.packagesPerHour = data["packagesPerHour"];
        }
    }

    static fromJS(data: any): DriverReportSummaryDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverReportSummaryDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverName"] = this.driverName;
        data["driverUserId"] = this.driverUserId;
        data["totalLoadLists"] = this.totalLoadLists;
        data["totalHours"] = this.totalHours;
        data["totalPackages"] = this.totalPackages;
        data["packagesPerHour"] = this.packagesPerHour;
        return data; 
    }
}

export interface IDriverReportSummaryDto {
    driverName: string | undefined;
    driverUserId: number | undefined;
    totalLoadLists: number;
    totalHours: string | undefined;
    totalPackages: number;
    packagesPerHour: string | undefined;
}

export class GetDriverListDto implements IGetDriverListDto {
    id!: number;
    name!: string | undefined;
    surname!: string | undefined;
    phoneNumber!: string | undefined;
    emailAddress!: string | undefined;
    isEmailConfirmed!: boolean;
    lockOutEndDateUtc!: moment.Moment | undefined;
    currentVersion!: string | undefined;
    minimumVersion!: string | undefined;
    osName!: string | undefined;
    isVersionBehind!: boolean;
    driverId!: number;
    fleetName!: string | undefined;
    fleetId!: number | undefined;
    allowToSkip!: boolean;

    constructor(data?: IGetDriverListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.phoneNumber = data["phoneNumber"];
            this.emailAddress = data["emailAddress"];
            this.isEmailConfirmed = data["isEmailConfirmed"];
            this.lockOutEndDateUtc = data["lockOutEndDateUtc"] ? moment(data["lockOutEndDateUtc"].toString()) : <any>undefined;
            this.currentVersion = data["currentVersion"];
            this.minimumVersion = data["minimumVersion"];
            this.osName = data["osName"];
            this.isVersionBehind = data["isVersionBehind"];
            this.driverId = data["driverId"];
            this.fleetName = data["fleetName"];
            this.fleetId = data["fleetId"];
            this.allowToSkip = data["allowToSkip"];
        }
    }

    static fromJS(data: any): GetDriverListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["phoneNumber"] = this.phoneNumber;
        data["emailAddress"] = this.emailAddress;
        data["isEmailConfirmed"] = this.isEmailConfirmed;
        data["lockOutEndDateUtc"] = this.lockOutEndDateUtc ? this.lockOutEndDateUtc.toISOString() : <any>undefined;
        data["currentVersion"] = this.currentVersion;
        data["minimumVersion"] = this.minimumVersion;
        data["osName"] = this.osName;
        data["isVersionBehind"] = this.isVersionBehind;
        data["driverId"] = this.driverId;
        data["fleetName"] = this.fleetName;
        data["fleetId"] = this.fleetId;
        data["allowToSkip"] = this.allowToSkip;
        return data; 
    }
}

export interface IGetDriverListDto {
    id: number;
    name: string | undefined;
    surname: string | undefined;
    phoneNumber: string | undefined;
    emailAddress: string | undefined;
    isEmailConfirmed: boolean;
    lockOutEndDateUtc: moment.Moment | undefined;
    currentVersion: string | undefined;
    minimumVersion: string | undefined;
    osName: string | undefined;
    isVersionBehind: boolean;
    driverId: number;
    fleetName: string | undefined;
    fleetId: number | undefined;
    allowToSkip: boolean;
}

export class PagedResultDtoOfGetDriverListDto implements IPagedResultDtoOfGetDriverListDto {
    totalCount!: number;
    items!: GetDriverListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetDriverListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetDriverListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetDriverListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetDriverListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetDriverListDto {
    totalCount: number;
    items: GetDriverListDto[] | undefined;
}

export class DriverProfileListDto implements IDriverProfileListDto {
    id!: number;
    userId!: number;
    contactId!: number;
    vehicleId!: number | undefined;
    startDate!: moment.Moment | undefined;
    endDate!: moment.Moment | undefined;
    driverLicenseNumber!: string | undefined;
    driverLicenseState!: string | undefined;
    driverLicenseExpirationDate!: moment.Moment | undefined;
    hourlyRate!: number | undefined;
    dailyRate!: number | undefined;
    perSprintRate!: number | undefined;
    onDemand!: boolean;
    ownVehicle!: boolean;
    isActive!: boolean;
    skipOrders!: boolean;
    skipDeliveryScanOrder!: boolean;

    constructor(data?: IDriverProfileListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.contactId = data["contactId"];
            this.vehicleId = data["vehicleId"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.endDate = data["endDate"] ? moment(data["endDate"].toString()) : <any>undefined;
            this.driverLicenseNumber = data["driverLicenseNumber"];
            this.driverLicenseState = data["driverLicenseState"];
            this.driverLicenseExpirationDate = data["driverLicenseExpirationDate"] ? moment(data["driverLicenseExpirationDate"].toString()) : <any>undefined;
            this.hourlyRate = data["hourlyRate"];
            this.dailyRate = data["dailyRate"];
            this.perSprintRate = data["perSprintRate"];
            this.onDemand = data["onDemand"];
            this.ownVehicle = data["ownVehicle"];
            this.isActive = data["isActive"];
            this.skipOrders = data["skipOrders"];
            this.skipDeliveryScanOrder = data["skipDeliveryScanOrder"];
        }
    }

    static fromJS(data: any): DriverProfileListDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverProfileListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["contactId"] = this.contactId;
        data["vehicleId"] = this.vehicleId;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["endDate"] = this.endDate ? this.endDate.toISOString() : <any>undefined;
        data["driverLicenseNumber"] = this.driverLicenseNumber;
        data["driverLicenseState"] = this.driverLicenseState;
        data["driverLicenseExpirationDate"] = this.driverLicenseExpirationDate ? this.driverLicenseExpirationDate.toISOString() : <any>undefined;
        data["hourlyRate"] = this.hourlyRate;
        data["dailyRate"] = this.dailyRate;
        data["perSprintRate"] = this.perSprintRate;
        data["onDemand"] = this.onDemand;
        data["ownVehicle"] = this.ownVehicle;
        data["isActive"] = this.isActive;
        data["skipOrders"] = this.skipOrders;
        data["skipDeliveryScanOrder"] = this.skipDeliveryScanOrder;
        return data; 
    }
}

export interface IDriverProfileListDto {
    id: number;
    userId: number;
    contactId: number;
    vehicleId: number | undefined;
    startDate: moment.Moment | undefined;
    endDate: moment.Moment | undefined;
    driverLicenseNumber: string | undefined;
    driverLicenseState: string | undefined;
    driverLicenseExpirationDate: moment.Moment | undefined;
    hourlyRate: number | undefined;
    dailyRate: number | undefined;
    perSprintRate: number | undefined;
    onDemand: boolean;
    ownVehicle: boolean;
    isActive: boolean;
    skipOrders: boolean;
    skipDeliveryScanOrder: boolean;
}

export class GetDriverForEditOutput implements IGetDriverForEditOutput {
    user!: UserEditDto | undefined;
    locationId!: number[] | undefined;
    contact!: ContactListDto | undefined;
    driverProfile!: DriverProfileListDto | undefined;

    constructor(data?: IGetDriverForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserEditDto.fromJS(data["user"]) : <any>undefined;
            if (Array.isArray(data["locationId"])) {
                this.locationId = [] as any;
                for (let item of data["locationId"])
                    this.locationId!.push(item);
            }
            this.contact = data["contact"] ? ContactListDto.fromJS(data["contact"]) : <any>undefined;
            this.driverProfile = data["driverProfile"] ? DriverProfileListDto.fromJS(data["driverProfile"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetDriverForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        if (Array.isArray(this.locationId)) {
            data["locationId"] = [];
            for (let item of this.locationId)
                data["locationId"].push(item);
        }
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["driverProfile"] = this.driverProfile ? this.driverProfile.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetDriverForEditOutput {
    user: UserEditDto | undefined;
    locationId: number[] | undefined;
    contact: ContactListDto | undefined;
    driverProfile: DriverProfileListDto | undefined;
}

export class EntityDtoOfInt64 implements IEntityDtoOfInt64 {
    id!: number;

    constructor(data?: IEntityDtoOfInt64) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EntityDtoOfInt64 {
        data = typeof data === 'object' ? data : {};
        let result = new EntityDtoOfInt64();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        return data; 
    }
}

export interface IEntityDtoOfInt64 {
    id: number;
}

export class GetUserIdInputForResetPassword implements IGetUserIdInputForResetPassword {
    userId!: number;

    constructor(data?: IGetUserIdInputForResetPassword) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): GetUserIdInputForResetPassword {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserIdInputForResetPassword();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IGetUserIdInputForResetPassword {
    userId: number;
}

export class GetMultipleUserIdForResetPassword implements IGetMultipleUserIdForResetPassword {
    userIds!: number[] | undefined;

    constructor(data?: IGetMultipleUserIdForResetPassword) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["userIds"])) {
                this.userIds = [] as any;
                for (let item of data["userIds"])
                    this.userIds!.push(item);
            }
        }
    }

    static fromJS(data: any): GetMultipleUserIdForResetPassword {
        data = typeof data === 'object' ? data : {};
        let result = new GetMultipleUserIdForResetPassword();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.userIds)) {
            data["userIds"] = [];
            for (let item of this.userIds)
                data["userIds"].push(item);
        }
        return data; 
    }
}

export interface IGetMultipleUserIdForResetPassword {
    userIds: number[] | undefined;
}

export class GetDriverDetailsDto implements IGetDriverDetailsDto {
    user!: UserInContactListDto | undefined;
    address!: AddressListDto | undefined;
    driverProfile!: DriverProfileListDto | undefined;
    driverIncident!: DriverIncidentListDto[] | undefined;

    constructor(data?: IGetDriverDetailsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserInContactListDto.fromJS(data["user"]) : <any>undefined;
            this.address = data["address"] ? AddressListDto.fromJS(data["address"]) : <any>undefined;
            this.driverProfile = data["driverProfile"] ? DriverProfileListDto.fromJS(data["driverProfile"]) : <any>undefined;
            if (Array.isArray(data["driverIncident"])) {
                this.driverIncident = [] as any;
                for (let item of data["driverIncident"])
                    this.driverIncident!.push(DriverIncidentListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetDriverDetailsDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverDetailsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["driverProfile"] = this.driverProfile ? this.driverProfile.toJSON() : <any>undefined;
        if (Array.isArray(this.driverIncident)) {
            data["driverIncident"] = [];
            for (let item of this.driverIncident)
                data["driverIncident"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetDriverDetailsDto {
    user: UserInContactListDto | undefined;
    address: AddressListDto | undefined;
    driverProfile: DriverProfileListDto | undefined;
    driverIncident: DriverIncidentListDto[] | undefined;
}

export class GetAvailableDriverDto implements IGetAvailableDriverDto {
    driverId!: number;
    driverName!: string | undefined;

    constructor(data?: IGetAvailableDriverDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverId = data["driverId"];
            this.driverName = data["driverName"];
        }
    }

    static fromJS(data: any): GetAvailableDriverDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetAvailableDriverDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverId"] = this.driverId;
        data["driverName"] = this.driverName;
        return data; 
    }
}

export interface IGetAvailableDriverDto {
    driverId: number;
    driverName: string | undefined;
}

export class CreateOrUpdateDriverInfoInput implements ICreateOrUpdateDriverInfoInput {
    userId!: number;
    contactId!: number;
    vehicleId!: number | undefined;
    startDate!: moment.Moment | undefined;
    endDate!: moment.Moment | undefined;
    driverLicenseNumber!: string | undefined;
    driverLicenseState!: string | undefined;
    driverLicenseExpirationDate!: moment.Moment | undefined;
    hourlyRate!: number;
    dailyRate!: number;
    perSprintRate!: number;
    onDemand!: boolean;
    ownVehicle!: boolean;
    isActive!: boolean;

    constructor(data?: ICreateOrUpdateDriverInfoInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.contactId = data["contactId"];
            this.vehicleId = data["vehicleId"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.endDate = data["endDate"] ? moment(data["endDate"].toString()) : <any>undefined;
            this.driverLicenseNumber = data["driverLicenseNumber"];
            this.driverLicenseState = data["driverLicenseState"];
            this.driverLicenseExpirationDate = data["driverLicenseExpirationDate"] ? moment(data["driverLicenseExpirationDate"].toString()) : <any>undefined;
            this.hourlyRate = data["hourlyRate"];
            this.dailyRate = data["dailyRate"];
            this.perSprintRate = data["perSprintRate"];
            this.onDemand = data["onDemand"];
            this.ownVehicle = data["ownVehicle"];
            this.isActive = data["isActive"];
        }
    }

    static fromJS(data: any): CreateOrUpdateDriverInfoInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateDriverInfoInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["contactId"] = this.contactId;
        data["vehicleId"] = this.vehicleId;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["endDate"] = this.endDate ? this.endDate.toISOString() : <any>undefined;
        data["driverLicenseNumber"] = this.driverLicenseNumber;
        data["driverLicenseState"] = this.driverLicenseState;
        data["driverLicenseExpirationDate"] = this.driverLicenseExpirationDate ? this.driverLicenseExpirationDate.toISOString() : <any>undefined;
        data["hourlyRate"] = this.hourlyRate;
        data["dailyRate"] = this.dailyRate;
        data["perSprintRate"] = this.perSprintRate;
        data["onDemand"] = this.onDemand;
        data["ownVehicle"] = this.ownVehicle;
        data["isActive"] = this.isActive;
        return data; 
    }
}

export interface ICreateOrUpdateDriverInfoInput {
    userId: number;
    contactId: number;
    vehicleId: number | undefined;
    startDate: moment.Moment | undefined;
    endDate: moment.Moment | undefined;
    driverLicenseNumber: string | undefined;
    driverLicenseState: string | undefined;
    driverLicenseExpirationDate: moment.Moment | undefined;
    hourlyRate: number;
    dailyRate: number;
    perSprintRate: number;
    onDemand: boolean;
    ownVehicle: boolean;
    isActive: boolean;
}

export class UserInVehicleListDto implements IUserInVehicleListDto {
    id!: number;
    name!: string | undefined;
    surname!: string | undefined;
    roles!: UserListRoleDto[] | undefined;

    constructor(data?: IUserInVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.surname = data["surname"];
            if (Array.isArray(data["roles"])) {
                this.roles = [] as any;
                for (let item of data["roles"])
                    this.roles!.push(UserListRoleDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UserInVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserInVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["surname"] = this.surname;
        if (Array.isArray(this.roles)) {
            data["roles"] = [];
            for (let item of this.roles)
                data["roles"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUserInVehicleListDto {
    id: number;
    name: string | undefined;
    surname: string | undefined;
    roles: UserListRoleDto[] | undefined;
}

export class AvailableVehicleListDto implements IAvailableVehicleListDto {
    tenantId!: number;
    name!: string | undefined;
    licenseNumber!: string | undefined;
    user!: UserInVehicleListDto | undefined;
    userId!: number;
    id!: number;
    mileage!: number;

    constructor(data?: IAvailableVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.user = data["user"] ? UserInVehicleListDto.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.id = data["id"];
            this.mileage = data["mileage"];
        }
    }

    static fromJS(data: any): AvailableVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new AvailableVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["id"] = this.id;
        data["mileage"] = this.mileage;
        return data; 
    }
}

export interface IAvailableVehicleListDto {
    tenantId: number;
    name: string | undefined;
    licenseNumber: string | undefined;
    user: UserInVehicleListDto | undefined;
    userId: number;
    id: number;
    mileage: number;
}

export class GetUnassignedDrivers implements IGetUnassignedDrivers {
    userId!: number;
    fullName!: string | undefined;

    constructor(data?: IGetUnassignedDrivers) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.fullName = data["fullName"];
        }
    }

    static fromJS(data: any): GetUnassignedDrivers {
        data = typeof data === 'object' ? data : {};
        let result = new GetUnassignedDrivers();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["fullName"] = this.fullName;
        return data; 
    }
}

export interface IGetUnassignedDrivers {
    userId: number;
    fullName: string | undefined;
}

export class CreatePostalCodeInput implements ICreatePostalCodeInput {
    country!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    value!: string | undefined;

    constructor(data?: ICreatePostalCodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.country = data["country"];
            this.city = data["city"];
            this.state = data["state"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreatePostalCodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreatePostalCodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["country"] = this.country;
        data["city"] = this.city;
        data["state"] = this.state;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreatePostalCodeInput {
    country: string | undefined;
    city: string | undefined;
    state: string | undefined;
    value: string | undefined;
}

export class CreateDriverInput implements ICreateDriverInput {
    user!: UserEditDto;
    sendActivationEmail!: boolean;
    setRandomPassword!: boolean;
    location!: number[] | undefined;
    address!: CreateAddressInput | undefined;
    contact!: CreateContactInput | undefined;
    contactId!: number | undefined;
    driverInfo!: CreateOrUpdateDriverInfoInput | undefined;
    postalCodeId!: number;
    postalCode!: CreatePostalCodeInput | undefined;
    longitude!: number;
    latitude!: number;
    skipOrders!: boolean;
    skipDeliveryScanOrder!: boolean;

    constructor(data?: ICreateDriverInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new UserEditDto();
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserEditDto.fromJS(data["user"]) : new UserEditDto();
            this.sendActivationEmail = data["sendActivationEmail"];
            this.setRandomPassword = data["setRandomPassword"];
            if (Array.isArray(data["location"])) {
                this.location = [] as any;
                for (let item of data["location"])
                    this.location!.push(item);
            }
            this.address = data["address"] ? CreateAddressInput.fromJS(data["address"]) : <any>undefined;
            this.contact = data["contact"] ? CreateContactInput.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.driverInfo = data["driverInfo"] ? CreateOrUpdateDriverInfoInput.fromJS(data["driverInfo"]) : <any>undefined;
            this.postalCodeId = data["postalCodeId"];
            this.postalCode = data["postalCode"] ? CreatePostalCodeInput.fromJS(data["postalCode"]) : <any>undefined;
            this.longitude = data["longitude"];
            this.latitude = data["latitude"];
            this.skipOrders = data["skipOrders"];
            this.skipDeliveryScanOrder = data["skipDeliveryScanOrder"];
        }
    }

    static fromJS(data: any): CreateDriverInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDriverInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["sendActivationEmail"] = this.sendActivationEmail;
        data["setRandomPassword"] = this.setRandomPassword;
        if (Array.isArray(this.location)) {
            data["location"] = [];
            for (let item of this.location)
                data["location"].push(item);
        }
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["driverInfo"] = this.driverInfo ? this.driverInfo.toJSON() : <any>undefined;
        data["postalCodeId"] = this.postalCodeId;
        data["postalCode"] = this.postalCode ? this.postalCode.toJSON() : <any>undefined;
        data["longitude"] = this.longitude;
        data["latitude"] = this.latitude;
        data["skipOrders"] = this.skipOrders;
        data["skipDeliveryScanOrder"] = this.skipDeliveryScanOrder;
        return data; 
    }
}

export interface ICreateDriverInput {
    user: UserEditDto;
    sendActivationEmail: boolean;
    setRandomPassword: boolean;
    location: number[] | undefined;
    address: CreateAddressInput | undefined;
    contact: CreateContactInput | undefined;
    contactId: number | undefined;
    driverInfo: CreateOrUpdateDriverInfoInput | undefined;
    postalCodeId: number;
    postalCode: CreatePostalCodeInput | undefined;
    longitude: number;
    latitude: number;
    skipOrders: boolean;
    skipDeliveryScanOrder: boolean;
}

export class AllowDisableDriverToSkipInput implements IAllowDisableDriverToSkipInput {
    userIds!: number[] | undefined;

    constructor(data?: IAllowDisableDriverToSkipInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["userIds"])) {
                this.userIds = [] as any;
                for (let item of data["userIds"])
                    this.userIds!.push(item);
            }
        }
    }

    static fromJS(data: any): AllowDisableDriverToSkipInput {
        data = typeof data === 'object' ? data : {};
        let result = new AllowDisableDriverToSkipInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.userIds)) {
            data["userIds"] = [];
            for (let item of this.userIds)
                data["userIds"].push(item);
        }
        return data; 
    }
}

export interface IAllowDisableDriverToSkipInput {
    userIds: number[] | undefined;
}

export class EditionListDto implements IEditionListDto {
    name!: string | undefined;
    displayName!: string | undefined;
    dailyPrice!: number | undefined;
    weeklyPrice!: number | undefined;
    monthlyPrice!: number | undefined;
    annualPrice!: number | undefined;
    waitingDayAfterExpire!: number | undefined;
    trialDayCount!: number | undefined;
    expiringEditionDisplayName!: string | undefined;
    id!: number;

    constructor(data?: IEditionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.dailyPrice = data["dailyPrice"];
            this.weeklyPrice = data["weeklyPrice"];
            this.monthlyPrice = data["monthlyPrice"];
            this.annualPrice = data["annualPrice"];
            this.waitingDayAfterExpire = data["waitingDayAfterExpire"];
            this.trialDayCount = data["trialDayCount"];
            this.expiringEditionDisplayName = data["expiringEditionDisplayName"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EditionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new EditionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["dailyPrice"] = this.dailyPrice;
        data["weeklyPrice"] = this.weeklyPrice;
        data["monthlyPrice"] = this.monthlyPrice;
        data["annualPrice"] = this.annualPrice;
        data["waitingDayAfterExpire"] = this.waitingDayAfterExpire;
        data["trialDayCount"] = this.trialDayCount;
        data["expiringEditionDisplayName"] = this.expiringEditionDisplayName;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEditionListDto {
    name: string | undefined;
    displayName: string | undefined;
    dailyPrice: number | undefined;
    weeklyPrice: number | undefined;
    monthlyPrice: number | undefined;
    annualPrice: number | undefined;
    waitingDayAfterExpire: number | undefined;
    trialDayCount: number | undefined;
    expiringEditionDisplayName: string | undefined;
    id: number;
}

export class ListResultDtoOfEditionListDto implements IListResultDtoOfEditionListDto {
    items!: EditionListDto[] | undefined;

    constructor(data?: IListResultDtoOfEditionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(EditionListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfEditionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfEditionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfEditionListDto {
    items: EditionListDto[] | undefined;
}

export class EditionEditDto implements IEditionEditDto {
    id!: number | undefined;
    displayName!: string;
    expiringEditionId!: number | undefined;

    constructor(data?: IEditionEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
            this.expiringEditionId = data["expiringEditionId"];
        }
    }

    static fromJS(data: any): EditionEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new EditionEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        data["expiringEditionId"] = this.expiringEditionId;
        return data; 
    }
}

export interface IEditionEditDto {
    id: number | undefined;
    displayName: string;
    expiringEditionId: number | undefined;
}

export class IValueValidator implements IIValueValidator {
    readonly name!: string | undefined;
    readonly attributes!: { [key: string]: any; } | undefined;

    constructor(data?: IIValueValidator) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).name = data["name"];
            if (data["attributes"]) {
                (<any>this).attributes = {} as any;
                for (let key in data["attributes"]) {
                    if (data["attributes"].hasOwnProperty(key))
                        (<any>this).attributes![key] = data["attributes"][key];
                }
            }
        }
    }

    static fromJS(data: any): IValueValidator {
        data = typeof data === 'object' ? data : {};
        let result = new IValueValidator();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        if (this.attributes) {
            data["attributes"] = {};
            for (let key in this.attributes) {
                if (this.attributes.hasOwnProperty(key))
                    data["attributes"][key] = this.attributes[key];
            }
        }
        return data; 
    }
}

export interface IIValueValidator {
    name: string | undefined;
    attributes: { [key: string]: any; } | undefined;
}

export class LocalizableComboboxItemDto implements ILocalizableComboboxItemDto {
    value!: string | undefined;
    displayText!: string | undefined;

    constructor(data?: ILocalizableComboboxItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.displayText = data["displayText"];
        }
    }

    static fromJS(data: any): LocalizableComboboxItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new LocalizableComboboxItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["displayText"] = this.displayText;
        return data; 
    }
}

export interface ILocalizableComboboxItemDto {
    value: string | undefined;
    displayText: string | undefined;
}

export class LocalizableComboboxItemSourceDto implements ILocalizableComboboxItemSourceDto {
    items!: LocalizableComboboxItemDto[] | undefined;

    constructor(data?: ILocalizableComboboxItemSourceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(LocalizableComboboxItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): LocalizableComboboxItemSourceDto {
        data = typeof data === 'object' ? data : {};
        let result = new LocalizableComboboxItemSourceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ILocalizableComboboxItemSourceDto {
    items: LocalizableComboboxItemDto[] | undefined;
}

export class FeatureInputTypeDto implements IFeatureInputTypeDto {
    name!: string | undefined;
    attributes!: { [key: string]: any; } | undefined;
    validator!: IValueValidator | undefined;
    itemSource!: LocalizableComboboxItemSourceDto | undefined;

    constructor(data?: IFeatureInputTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            if (data["attributes"]) {
                this.attributes = {} as any;
                for (let key in data["attributes"]) {
                    if (data["attributes"].hasOwnProperty(key))
                        this.attributes![key] = data["attributes"][key];
                }
            }
            this.validator = data["validator"] ? IValueValidator.fromJS(data["validator"]) : <any>undefined;
            this.itemSource = data["itemSource"] ? LocalizableComboboxItemSourceDto.fromJS(data["itemSource"]) : <any>undefined;
        }
    }

    static fromJS(data: any): FeatureInputTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new FeatureInputTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        if (this.attributes) {
            data["attributes"] = {};
            for (let key in this.attributes) {
                if (this.attributes.hasOwnProperty(key))
                    data["attributes"][key] = this.attributes[key];
            }
        }
        data["validator"] = this.validator ? this.validator.toJSON() : <any>undefined;
        data["itemSource"] = this.itemSource ? this.itemSource.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IFeatureInputTypeDto {
    name: string | undefined;
    attributes: { [key: string]: any; } | undefined;
    validator: IValueValidator | undefined;
    itemSource: LocalizableComboboxItemSourceDto | undefined;
}

export class FlatFeatureDto implements IFlatFeatureDto {
    parentName!: string | undefined;
    name!: string | undefined;
    displayName!: string | undefined;
    description!: string | undefined;
    defaultValue!: string | undefined;
    inputType!: FeatureInputTypeDto | undefined;

    constructor(data?: IFlatFeatureDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parentName = data["parentName"];
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.description = data["description"];
            this.defaultValue = data["defaultValue"];
            this.inputType = data["inputType"] ? FeatureInputTypeDto.fromJS(data["inputType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): FlatFeatureDto {
        data = typeof data === 'object' ? data : {};
        let result = new FlatFeatureDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parentName"] = this.parentName;
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["description"] = this.description;
        data["defaultValue"] = this.defaultValue;
        data["inputType"] = this.inputType ? this.inputType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IFlatFeatureDto {
    parentName: string | undefined;
    name: string | undefined;
    displayName: string | undefined;
    description: string | undefined;
    defaultValue: string | undefined;
    inputType: FeatureInputTypeDto | undefined;
}

export class GetEditionEditOutput implements IGetEditionEditOutput {
    edition!: EditionEditDto | undefined;
    featureValues!: NameValueDto[] | undefined;
    features!: FlatFeatureDto[] | undefined;

    constructor(data?: IGetEditionEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.edition = data["edition"] ? EditionEditDto.fromJS(data["edition"]) : <any>undefined;
            if (Array.isArray(data["featureValues"])) {
                this.featureValues = [] as any;
                for (let item of data["featureValues"])
                    this.featureValues!.push(NameValueDto.fromJS(item));
            }
            if (Array.isArray(data["features"])) {
                this.features = [] as any;
                for (let item of data["features"])
                    this.features!.push(FlatFeatureDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetEditionEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetEditionEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["edition"] = this.edition ? this.edition.toJSON() : <any>undefined;
        if (Array.isArray(this.featureValues)) {
            data["featureValues"] = [];
            for (let item of this.featureValues)
                data["featureValues"].push(item.toJSON());
        }
        if (Array.isArray(this.features)) {
            data["features"] = [];
            for (let item of this.features)
                data["features"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetEditionEditOutput {
    edition: EditionEditDto | undefined;
    featureValues: NameValueDto[] | undefined;
    features: FlatFeatureDto[] | undefined;
}

export class EditionCreateDto implements IEditionCreateDto {
    id!: number | undefined;
    displayName!: string;
    dailyPrice!: number | undefined;
    weeklyPrice!: number | undefined;
    monthlyPrice!: number | undefined;
    annualPrice!: number | undefined;
    trialDayCount!: number | undefined;
    waitingDayAfterExpire!: number | undefined;
    expiringEditionId!: number | undefined;

    constructor(data?: IEditionCreateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
            this.dailyPrice = data["dailyPrice"];
            this.weeklyPrice = data["weeklyPrice"];
            this.monthlyPrice = data["monthlyPrice"];
            this.annualPrice = data["annualPrice"];
            this.trialDayCount = data["trialDayCount"];
            this.waitingDayAfterExpire = data["waitingDayAfterExpire"];
            this.expiringEditionId = data["expiringEditionId"];
        }
    }

    static fromJS(data: any): EditionCreateDto {
        data = typeof data === 'object' ? data : {};
        let result = new EditionCreateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        data["dailyPrice"] = this.dailyPrice;
        data["weeklyPrice"] = this.weeklyPrice;
        data["monthlyPrice"] = this.monthlyPrice;
        data["annualPrice"] = this.annualPrice;
        data["trialDayCount"] = this.trialDayCount;
        data["waitingDayAfterExpire"] = this.waitingDayAfterExpire;
        data["expiringEditionId"] = this.expiringEditionId;
        return data; 
    }
}

export interface IEditionCreateDto {
    id: number | undefined;
    displayName: string;
    dailyPrice: number | undefined;
    weeklyPrice: number | undefined;
    monthlyPrice: number | undefined;
    annualPrice: number | undefined;
    trialDayCount: number | undefined;
    waitingDayAfterExpire: number | undefined;
    expiringEditionId: number | undefined;
}

export class CreateEditionDto implements ICreateEditionDto {
    edition!: EditionCreateDto;
    featureValues!: NameValueDto[];

    constructor(data?: ICreateEditionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.edition = new EditionCreateDto();
            this.featureValues = [];
        }
    }

    init(data?: any) {
        if (data) {
            this.edition = data["edition"] ? EditionCreateDto.fromJS(data["edition"]) : new EditionCreateDto();
            if (Array.isArray(data["featureValues"])) {
                this.featureValues = [] as any;
                for (let item of data["featureValues"])
                    this.featureValues!.push(NameValueDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateEditionDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateEditionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["edition"] = this.edition ? this.edition.toJSON() : <any>undefined;
        if (Array.isArray(this.featureValues)) {
            data["featureValues"] = [];
            for (let item of this.featureValues)
                data["featureValues"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateEditionDto {
    edition: EditionCreateDto;
    featureValues: NameValueDto[];
}

export class UpdateEditionDto implements IUpdateEditionDto {
    edition!: EditionEditDto;
    featureValues!: NameValueDto[];

    constructor(data?: IUpdateEditionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.edition = new EditionEditDto();
            this.featureValues = [];
        }
    }

    init(data?: any) {
        if (data) {
            this.edition = data["edition"] ? EditionEditDto.fromJS(data["edition"]) : new EditionEditDto();
            if (Array.isArray(data["featureValues"])) {
                this.featureValues = [] as any;
                for (let item of data["featureValues"])
                    this.featureValues!.push(NameValueDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UpdateEditionDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateEditionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["edition"] = this.edition ? this.edition.toJSON() : <any>undefined;
        if (Array.isArray(this.featureValues)) {
            data["featureValues"] = [];
            for (let item of this.featureValues)
                data["featureValues"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUpdateEditionDto {
    edition: EditionEditDto;
    featureValues: NameValueDto[];
}

export class MoveTenantsToAnotherEditionDto implements IMoveTenantsToAnotherEditionDto {
    sourceEditionId!: number;
    targetEditionId!: number;

    constructor(data?: IMoveTenantsToAnotherEditionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.sourceEditionId = data["sourceEditionId"];
            this.targetEditionId = data["targetEditionId"];
        }
    }

    static fromJS(data: any): MoveTenantsToAnotherEditionDto {
        data = typeof data === 'object' ? data : {};
        let result = new MoveTenantsToAnotherEditionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["sourceEditionId"] = this.sourceEditionId;
        data["targetEditionId"] = this.targetEditionId;
        return data; 
    }
}

export interface IMoveTenantsToAnotherEditionDto {
    sourceEditionId: number;
    targetEditionId: number;
}

export class CreateEmailInput implements ICreateEmailInput {
    contactId!: number;
    value!: string;

    constructor(data?: ICreateEmailInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreateEmailInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateEmailInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreateEmailInput {
    contactId: number;
    value: string;
}

export class PagedResultDtoOfEmailListDto implements IPagedResultDtoOfEmailListDto {
    totalCount!: number;
    items!: EmailListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfEmailListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(EmailListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfEmailListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfEmailListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfEmailListDto {
    totalCount: number;
    items: EmailListDto[] | undefined;
}

export class UpdateEmailInput implements IUpdateEmailInput {
    id!: number;
    contactId!: number;
    value!: string;

    constructor(data?: IUpdateEmailInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contactId = data["contactId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): UpdateEmailInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateEmailInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contactId"] = this.contactId;
        data["value"] = this.value;
        return data; 
    }
}

export interface IUpdateEmailInput {
    id: number;
    contactId: number;
    value: string;
}

export class EmployeeIncidentAttachment implements IEmployeeIncidentAttachment {
    fileName!: string | undefined;
    base64EncodedData!: string | undefined;
    incidentId!: number;

    constructor(data?: IEmployeeIncidentAttachment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.base64EncodedData = data["base64EncodedData"];
            this.incidentId = data["incidentId"];
        }
    }

    static fromJS(data: any): EmployeeIncidentAttachment {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncidentAttachment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["base64EncodedData"] = this.base64EncodedData;
        data["incidentId"] = this.incidentId;
        return data; 
    }
}

export interface IEmployeeIncidentAttachment {
    fileName: string | undefined;
    base64EncodedData: string | undefined;
    incidentId: number;
}

export class EmployeeIncidentNotes implements IEmployeeIncidentNotes {
    incidentId!: number;
    notes!: string | undefined;

    constructor(data?: IEmployeeIncidentNotes) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentId = data["incidentId"];
            this.notes = data["notes"];
        }
    }

    static fromJS(data: any): EmployeeIncidentNotes {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncidentNotes();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentId"] = this.incidentId;
        data["notes"] = this.notes;
        return data; 
    }
}

export interface IEmployeeIncidentNotes {
    incidentId: number;
    notes: string | undefined;
}

export class CreateOrEditEmployeeIncidentsInput implements ICreateOrEditEmployeeIncidentsInput {
    id!: number | undefined;
    userId!: number;
    incidentContent!: string | undefined;
    incidentDate!: moment.Moment;
    employeeIncidentTypeId!: number | undefined;
    incidentTypeId!: number | undefined;
    geocodeId!: number | undefined;
    incidentStatusId!: number | undefined;
    managerId!: number | undefined;
    email!: string | undefined;
    createAttachments!: EmployeeIncidentAttachment[] | undefined;
    createNotes!: EmployeeIncidentNotes[] | undefined;

    constructor(data?: ICreateOrEditEmployeeIncidentsInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.incidentContent = data["incidentContent"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.employeeIncidentTypeId = data["employeeIncidentTypeId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.geocodeId = data["geocodeId"];
            this.incidentStatusId = data["incidentStatusId"];
            this.managerId = data["managerId"];
            this.email = data["email"];
            if (Array.isArray(data["createAttachments"])) {
                this.createAttachments = [] as any;
                for (let item of data["createAttachments"])
                    this.createAttachments!.push(EmployeeIncidentAttachment.fromJS(item));
            }
            if (Array.isArray(data["createNotes"])) {
                this.createNotes = [] as any;
                for (let item of data["createNotes"])
                    this.createNotes!.push(EmployeeIncidentNotes.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateOrEditEmployeeIncidentsInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditEmployeeIncidentsInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["incidentContent"] = this.incidentContent;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["employeeIncidentTypeId"] = this.employeeIncidentTypeId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["geocodeId"] = this.geocodeId;
        data["incidentStatusId"] = this.incidentStatusId;
        data["managerId"] = this.managerId;
        data["email"] = this.email;
        if (Array.isArray(this.createAttachments)) {
            data["createAttachments"] = [];
            for (let item of this.createAttachments)
                data["createAttachments"].push(item.toJSON());
        }
        if (Array.isArray(this.createNotes)) {
            data["createNotes"] = [];
            for (let item of this.createNotes)
                data["createNotes"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateOrEditEmployeeIncidentsInput {
    id: number | undefined;
    userId: number;
    incidentContent: string | undefined;
    incidentDate: moment.Moment;
    employeeIncidentTypeId: number | undefined;
    incidentTypeId: number | undefined;
    geocodeId: number | undefined;
    incidentStatusId: number | undefined;
    managerId: number | undefined;
    email: string | undefined;
    createAttachments: EmployeeIncidentAttachment[] | undefined;
    createNotes: EmployeeIncidentNotes[] | undefined;
}

export class EmployeeIncidentsListDto implements IEmployeeIncidentsListDto {
    tenantId!: number;
    creator!: string | undefined;
    incidentContent!: string | undefined;
    incidentDate!: moment.Moment;
    employeeIncidentTypeId!: number | undefined;
    incidentId!: number;
    employeeIncidentType!: string | undefined;
    employeeIncidentStatus!: string | undefined;
    employeeName!: string | undefined;
    managerName!: string | undefined;
    userId!: number;
    geocodeId!: number | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IEmployeeIncidentsListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.creator = data["creator"];
            this.incidentContent = data["incidentContent"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.employeeIncidentTypeId = data["employeeIncidentTypeId"];
            this.incidentId = data["incidentId"];
            this.employeeIncidentType = data["employeeIncidentType"];
            this.employeeIncidentStatus = data["employeeIncidentStatus"];
            this.employeeName = data["employeeName"];
            this.managerName = data["managerName"];
            this.userId = data["userId"];
            this.geocodeId = data["geocodeId"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EmployeeIncidentsListDto {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncidentsListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["creator"] = this.creator;
        data["incidentContent"] = this.incidentContent;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["employeeIncidentTypeId"] = this.employeeIncidentTypeId;
        data["incidentId"] = this.incidentId;
        data["employeeIncidentType"] = this.employeeIncidentType;
        data["employeeIncidentStatus"] = this.employeeIncidentStatus;
        data["employeeName"] = this.employeeName;
        data["managerName"] = this.managerName;
        data["userId"] = this.userId;
        data["geocodeId"] = this.geocodeId;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEmployeeIncidentsListDto {
    tenantId: number;
    creator: string | undefined;
    incidentContent: string | undefined;
    incidentDate: moment.Moment;
    employeeIncidentTypeId: number | undefined;
    incidentId: number;
    employeeIncidentType: string | undefined;
    employeeIncidentStatus: string | undefined;
    employeeName: string | undefined;
    managerName: string | undefined;
    userId: number;
    geocodeId: number | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class PagedResultDtoOfEmployeeIncidentsListDto implements IPagedResultDtoOfEmployeeIncidentsListDto {
    totalCount!: number;
    items!: EmployeeIncidentsListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfEmployeeIncidentsListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(EmployeeIncidentsListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfEmployeeIncidentsListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfEmployeeIncidentsListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfEmployeeIncidentsListDto {
    totalCount: number;
    items: EmployeeIncidentsListDto[] | undefined;
}

export class EmployeeIncidentAttachmentForUpdate implements IEmployeeIncidentAttachmentForUpdate {
    fileName!: string | undefined;
    data!: string | undefined;
    incidentId!: number;
    id!: number;

    constructor(data?: IEmployeeIncidentAttachmentForUpdate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.data = data["data"];
            this.incidentId = data["incidentId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EmployeeIncidentAttachmentForUpdate {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncidentAttachmentForUpdate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["data"] = this.data;
        data["incidentId"] = this.incidentId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEmployeeIncidentAttachmentForUpdate {
    fileName: string | undefined;
    data: string | undefined;
    incidentId: number;
    id: number;
}

export class EmployeeIncidentNotesForUpdate implements IEmployeeIncidentNotesForUpdate {
    incidentId!: number;
    notes!: string | undefined;
    creator!: string | undefined;
    dateCreated!: moment.Moment;
    id!: number;

    constructor(data?: IEmployeeIncidentNotesForUpdate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentId = data["incidentId"];
            this.notes = data["notes"];
            this.creator = data["creator"];
            this.dateCreated = data["dateCreated"] ? moment(data["dateCreated"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EmployeeIncidentNotesForUpdate {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncidentNotesForUpdate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentId"] = this.incidentId;
        data["notes"] = this.notes;
        data["creator"] = this.creator;
        data["dateCreated"] = this.dateCreated ? this.dateCreated.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEmployeeIncidentNotesForUpdate {
    incidentId: number;
    notes: string | undefined;
    creator: string | undefined;
    dateCreated: moment.Moment;
    id: number;
}

export class GetEmployeeIncidentForEditDto implements IGetEmployeeIncidentForEditDto {
    id!: number;
    userId!: number;
    incidentDate!: moment.Moment;
    incidentContent!: string | undefined;
    statusId!: number | undefined;
    managerId!: number | undefined;
    email!: string | undefined;
    employeeIncidentTypeId!: number | undefined;
    incidentId!: number;
    employeeName!: string | undefined;
    incidentTypeName!: string | undefined;
    incidenStatusName!: string | undefined;
    managerName!: string | undefined;
    attachments!: EmployeeIncidentAttachmentForUpdate[] | undefined;
    notes!: EmployeeIncidentNotesForUpdate[] | undefined;

    constructor(data?: IGetEmployeeIncidentForEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.incidentContent = data["incidentContent"];
            this.statusId = data["statusId"];
            this.managerId = data["managerId"];
            this.email = data["email"];
            this.employeeIncidentTypeId = data["employeeIncidentTypeId"];
            this.incidentId = data["incidentId"];
            this.employeeName = data["employeeName"];
            this.incidentTypeName = data["incidentTypeName"];
            this.incidenStatusName = data["incidenStatusName"];
            this.managerName = data["managerName"];
            if (Array.isArray(data["attachments"])) {
                this.attachments = [] as any;
                for (let item of data["attachments"])
                    this.attachments!.push(EmployeeIncidentAttachmentForUpdate.fromJS(item));
            }
            if (Array.isArray(data["notes"])) {
                this.notes = [] as any;
                for (let item of data["notes"])
                    this.notes!.push(EmployeeIncidentNotesForUpdate.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetEmployeeIncidentForEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetEmployeeIncidentForEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["incidentContent"] = this.incidentContent;
        data["statusId"] = this.statusId;
        data["managerId"] = this.managerId;
        data["email"] = this.email;
        data["employeeIncidentTypeId"] = this.employeeIncidentTypeId;
        data["incidentId"] = this.incidentId;
        data["employeeName"] = this.employeeName;
        data["incidentTypeName"] = this.incidentTypeName;
        data["incidenStatusName"] = this.incidenStatusName;
        data["managerName"] = this.managerName;
        if (Array.isArray(this.attachments)) {
            data["attachments"] = [];
            for (let item of this.attachments)
                data["attachments"].push(item.toJSON());
        }
        if (Array.isArray(this.notes)) {
            data["notes"] = [];
            for (let item of this.notes)
                data["notes"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetEmployeeIncidentForEditDto {
    id: number;
    userId: number;
    incidentDate: moment.Moment;
    incidentContent: string | undefined;
    statusId: number | undefined;
    managerId: number | undefined;
    email: string | undefined;
    employeeIncidentTypeId: number | undefined;
    incidentId: number;
    employeeName: string | undefined;
    incidentTypeName: string | undefined;
    incidenStatusName: string | undefined;
    managerName: string | undefined;
    attachments: EmployeeIncidentAttachmentForUpdate[] | undefined;
    notes: EmployeeIncidentNotesForUpdate[] | undefined;
}

export class GetEmployeeList implements IGetEmployeeList {
    id!: number | undefined;
    fullName!: string | undefined;
    email!: string | undefined;

    constructor(data?: IGetEmployeeList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.fullName = data["fullName"];
            this.email = data["email"];
        }
    }

    static fromJS(data: any): GetEmployeeList {
        data = typeof data === 'object' ? data : {};
        let result = new GetEmployeeList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["fullName"] = this.fullName;
        data["email"] = this.email;
        return data; 
    }
}

export interface IGetEmployeeList {
    id: number | undefined;
    fullName: string | undefined;
    email: string | undefined;
}

export class EmployeeIncidentTypeDto implements IEmployeeIncidentTypeDto {
    name!: string | undefined;
    code!: string | undefined;
    sortOrder!: number;
    isStatic!: boolean;
    id!: number;

    constructor(data?: IEmployeeIncidentTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.sortOrder = data["sortOrder"];
            this.isStatic = data["isStatic"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EmployeeIncidentTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncidentTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["sortOrder"] = this.sortOrder;
        data["isStatic"] = this.isStatic;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEmployeeIncidentTypeDto {
    name: string | undefined;
    code: string | undefined;
    sortOrder: number;
    isStatic: boolean;
    id: number;
}

export class GetEmployeeIncidentTypeForViewDto implements IGetEmployeeIncidentTypeForViewDto {
    employeeIncidentType!: EmployeeIncidentTypeDto | undefined;

    constructor(data?: IGetEmployeeIncidentTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.employeeIncidentType = data["employeeIncidentType"] ? EmployeeIncidentTypeDto.fromJS(data["employeeIncidentType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetEmployeeIncidentTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetEmployeeIncidentTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["employeeIncidentType"] = this.employeeIncidentType ? this.employeeIncidentType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetEmployeeIncidentTypeForViewDto {
    employeeIncidentType: EmployeeIncidentTypeDto | undefined;
}

export class PagedResultDtoOfGetEmployeeIncidentTypeForViewDto implements IPagedResultDtoOfGetEmployeeIncidentTypeForViewDto {
    totalCount!: number;
    items!: GetEmployeeIncidentTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetEmployeeIncidentTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetEmployeeIncidentTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetEmployeeIncidentTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetEmployeeIncidentTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetEmployeeIncidentTypeForViewDto {
    totalCount: number;
    items: GetEmployeeIncidentTypeForViewDto[] | undefined;
}

export class CreateOrEditEmployeeIncidentTypeDto implements ICreateOrEditEmployeeIncidentTypeDto {
    name!: string;
    code!: string;
    sortOrder!: number;
    isStatic!: boolean;
    id!: number | undefined;

    constructor(data?: ICreateOrEditEmployeeIncidentTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.sortOrder = data["sortOrder"];
            this.isStatic = data["isStatic"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditEmployeeIncidentTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditEmployeeIncidentTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["sortOrder"] = this.sortOrder;
        data["isStatic"] = this.isStatic;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditEmployeeIncidentTypeDto {
    name: string;
    code: string;
    sortOrder: number;
    isStatic: boolean;
    id: number | undefined;
}

export class GetEmployeeIncidentTypeForEditOutput implements IGetEmployeeIncidentTypeForEditOutput {
    employeeIncidentType!: CreateOrEditEmployeeIncidentTypeDto | undefined;

    constructor(data?: IGetEmployeeIncidentTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.employeeIncidentType = data["employeeIncidentType"] ? CreateOrEditEmployeeIncidentTypeDto.fromJS(data["employeeIncidentType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetEmployeeIncidentTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetEmployeeIncidentTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["employeeIncidentType"] = this.employeeIncidentType ? this.employeeIncidentType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetEmployeeIncidentTypeForEditOutput {
    employeeIncidentType: CreateOrEditEmployeeIncidentTypeDto | undefined;
}

export class CreateEmployeeReviewInput implements ICreateEmployeeReviewInput {
    userId!: number | undefined;
    reviewId!: number | undefined;

    constructor(data?: ICreateEmployeeReviewInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.reviewId = data["reviewId"];
        }
    }

    static fromJS(data: any): CreateEmployeeReviewInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateEmployeeReviewInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["reviewId"] = this.reviewId;
        return data; 
    }
}

export interface ICreateEmployeeReviewInput {
    userId: number | undefined;
    reviewId: number | undefined;
}

export class ReviewListDto implements IReviewListDto {
    id!: number;
    content!: string | undefined;
    rating!: number;

    constructor(data?: IReviewListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.content = data["content"];
            this.rating = data["rating"];
        }
    }

    static fromJS(data: any): ReviewListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ReviewListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["content"] = this.content;
        data["rating"] = this.rating;
        return data; 
    }
}

export interface IReviewListDto {
    id: number;
    content: string | undefined;
    rating: number;
}

export class EmployeeReviewListDto implements IEmployeeReviewListDto {
    id!: number;
    tenantId!: number;
    userId!: number;
    user!: UserListDto | undefined;
    reviewId!: number;
    review!: ReviewListDto | undefined;

    constructor(data?: IEmployeeReviewListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.user = data["user"] ? UserListDto.fromJS(data["user"]) : <any>undefined;
            this.reviewId = data["reviewId"];
            this.review = data["review"] ? ReviewListDto.fromJS(data["review"]) : <any>undefined;
        }
    }

    static fromJS(data: any): EmployeeReviewListDto {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeReviewListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["reviewId"] = this.reviewId;
        data["review"] = this.review ? this.review.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IEmployeeReviewListDto {
    id: number;
    tenantId: number;
    userId: number;
    user: UserListDto | undefined;
    reviewId: number;
    review: ReviewListDto | undefined;
}

export class PagedResultDtoOfEmployeeReviewListDto implements IPagedResultDtoOfEmployeeReviewListDto {
    totalCount!: number;
    items!: EmployeeReviewListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfEmployeeReviewListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(EmployeeReviewListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfEmployeeReviewListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfEmployeeReviewListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfEmployeeReviewListDto {
    totalCount: number;
    items: EmployeeReviewListDto[] | undefined;
}

export class UpdateEmployeeReviewInput implements IUpdateEmployeeReviewInput {
    id!: number;
    userId!: number;
    reviewId!: number;

    constructor(data?: IUpdateEmployeeReviewInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.reviewId = data["reviewId"];
        }
    }

    static fromJS(data: any): UpdateEmployeeReviewInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateEmployeeReviewInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["reviewId"] = this.reviewId;
        return data; 
    }
}

export interface IUpdateEmployeeReviewInput {
    id: number;
    userId: number;
    reviewId: number;
}

export class GetEmployeeListDto implements IGetEmployeeListDto {
    id!: number;
    name!: string | undefined;
    surname!: string | undefined;
    phoneNumber!: string | undefined;
    emailAddress!: string | undefined;
    isEmailConfirmed!: boolean;
    lockOutEndDateUtc!: moment.Moment | undefined;
    locations!: string[] | undefined;
    idNumber!: string | undefined;

    constructor(data?: IGetEmployeeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.phoneNumber = data["phoneNumber"];
            this.emailAddress = data["emailAddress"];
            this.isEmailConfirmed = data["isEmailConfirmed"];
            this.lockOutEndDateUtc = data["lockOutEndDateUtc"] ? moment(data["lockOutEndDateUtc"].toString()) : <any>undefined;
            if (Array.isArray(data["locations"])) {
                this.locations = [] as any;
                for (let item of data["locations"])
                    this.locations!.push(item);
            }
            this.idNumber = data["idNumber"];
        }
    }

    static fromJS(data: any): GetEmployeeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetEmployeeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["phoneNumber"] = this.phoneNumber;
        data["emailAddress"] = this.emailAddress;
        data["isEmailConfirmed"] = this.isEmailConfirmed;
        data["lockOutEndDateUtc"] = this.lockOutEndDateUtc ? this.lockOutEndDateUtc.toISOString() : <any>undefined;
        if (Array.isArray(this.locations)) {
            data["locations"] = [];
            for (let item of this.locations)
                data["locations"].push(item);
        }
        data["idNumber"] = this.idNumber;
        return data; 
    }
}

export interface IGetEmployeeListDto {
    id: number;
    name: string | undefined;
    surname: string | undefined;
    phoneNumber: string | undefined;
    emailAddress: string | undefined;
    isEmailConfirmed: boolean;
    lockOutEndDateUtc: moment.Moment | undefined;
    locations: string[] | undefined;
    idNumber: string | undefined;
}

export class PagedResultDtoOfGetEmployeeListDto implements IPagedResultDtoOfGetEmployeeListDto {
    totalCount!: number;
    items!: GetEmployeeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetEmployeeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetEmployeeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetEmployeeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetEmployeeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetEmployeeListDto {
    totalCount: number;
    items: GetEmployeeListDto[] | undefined;
}

export class EmployeeInfo implements IEmployeeInfo {
    startDate!: moment.Moment | undefined;
    hourlyRate!: number | undefined;
    dailyRate!: number | undefined;
    idNumber!: string | undefined;

    constructor(data?: IEmployeeInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.hourlyRate = data["hourlyRate"];
            this.dailyRate = data["dailyRate"];
            this.idNumber = data["idNumber"];
        }
    }

    static fromJS(data: any): EmployeeInfo {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["hourlyRate"] = this.hourlyRate;
        data["dailyRate"] = this.dailyRate;
        data["idNumber"] = this.idNumber;
        return data; 
    }
}

export interface IEmployeeInfo {
    startDate: moment.Moment | undefined;
    hourlyRate: number | undefined;
    dailyRate: number | undefined;
    idNumber: string | undefined;
}

export class GetEmployeeForEditOutput implements IGetEmployeeForEditOutput {
    user!: UserEditDto | undefined;
    locationId!: number[] | undefined;
    contact!: ContactListDto | undefined;
    employee!: EmployeeInfo | undefined;

    constructor(data?: IGetEmployeeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserEditDto.fromJS(data["user"]) : <any>undefined;
            if (Array.isArray(data["locationId"])) {
                this.locationId = [] as any;
                for (let item of data["locationId"])
                    this.locationId!.push(item);
            }
            this.contact = data["contact"] ? ContactListDto.fromJS(data["contact"]) : <any>undefined;
            this.employee = data["employee"] ? EmployeeInfo.fromJS(data["employee"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetEmployeeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetEmployeeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        if (Array.isArray(this.locationId)) {
            data["locationId"] = [];
            for (let item of this.locationId)
                data["locationId"].push(item);
        }
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["employee"] = this.employee ? this.employee.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetEmployeeForEditOutput {
    user: UserEditDto | undefined;
    locationId: number[] | undefined;
    contact: ContactListDto | undefined;
    employee: EmployeeInfo | undefined;
}

export class CreateEmployeeInput implements ICreateEmployeeInput {
    user!: UserEditDto;
    sendActivationEmail!: boolean;
    setRandomPassword!: boolean;
    location!: number[] | undefined;
    address!: CreateAddressInput | undefined;
    contact!: CreateContactInput | undefined;
    contactId!: number | undefined;
    startDate!: moment.Moment | undefined;
    hourlyRate!: number | undefined;
    dailyRate!: number | undefined;
    idNumber!: string | undefined;
    longitude!: number;
    latitude!: number;
    isImported!: boolean;

    constructor(data?: ICreateEmployeeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new UserEditDto();
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserEditDto.fromJS(data["user"]) : new UserEditDto();
            this.sendActivationEmail = data["sendActivationEmail"];
            this.setRandomPassword = data["setRandomPassword"];
            if (Array.isArray(data["location"])) {
                this.location = [] as any;
                for (let item of data["location"])
                    this.location!.push(item);
            }
            this.address = data["address"] ? CreateAddressInput.fromJS(data["address"]) : <any>undefined;
            this.contact = data["contact"] ? CreateContactInput.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.hourlyRate = data["hourlyRate"];
            this.dailyRate = data["dailyRate"];
            this.idNumber = data["idNumber"];
            this.longitude = data["longitude"];
            this.latitude = data["latitude"];
            this.isImported = data["isImported"];
        }
    }

    static fromJS(data: any): CreateEmployeeInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateEmployeeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["sendActivationEmail"] = this.sendActivationEmail;
        data["setRandomPassword"] = this.setRandomPassword;
        if (Array.isArray(this.location)) {
            data["location"] = [];
            for (let item of this.location)
                data["location"].push(item);
        }
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["hourlyRate"] = this.hourlyRate;
        data["dailyRate"] = this.dailyRate;
        data["idNumber"] = this.idNumber;
        data["longitude"] = this.longitude;
        data["latitude"] = this.latitude;
        data["isImported"] = this.isImported;
        return data; 
    }
}

export interface ICreateEmployeeInput {
    user: UserEditDto;
    sendActivationEmail: boolean;
    setRandomPassword: boolean;
    location: number[] | undefined;
    address: CreateAddressInput | undefined;
    contact: CreateContactInput | undefined;
    contactId: number | undefined;
    startDate: moment.Moment | undefined;
    hourlyRate: number | undefined;
    dailyRate: number | undefined;
    idNumber: string | undefined;
    longitude: number;
    latitude: number;
    isImported: boolean;
}

export class TimeSheetInput implements ITimeSheetInput {
    time!: moment.Moment;
    ianA_Timezone!: string | undefined;

    constructor(data?: ITimeSheetInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.ianA_Timezone = data["ianA_Timezone"];
        }
    }

    static fromJS(data: any): TimeSheetInput {
        data = typeof data === 'object' ? data : {};
        let result = new TimeSheetInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["ianA_Timezone"] = this.ianA_Timezone;
        return data; 
    }
}

export interface ITimeSheetInput {
    time: moment.Moment;
    ianA_Timezone: string | undefined;
}

export class TimeSheetListDto implements ITimeSheetListDto {
    loginTime!: moment.Moment | undefined;
    login_Timezone!: string | undefined;
    logoutTime!: moment.Moment | undefined;
    logout_Timezone!: string | undefined;
    userId!: number;
    user!: UserListDto | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ITimeSheetListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.loginTime = data["loginTime"] ? moment(data["loginTime"].toString()) : <any>undefined;
            this.login_Timezone = data["login_Timezone"];
            this.logoutTime = data["logoutTime"] ? moment(data["logoutTime"].toString()) : <any>undefined;
            this.logout_Timezone = data["logout_Timezone"];
            this.userId = data["userId"];
            this.user = data["user"] ? UserListDto.fromJS(data["user"]) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TimeSheetListDto {
        data = typeof data === 'object' ? data : {};
        let result = new TimeSheetListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["loginTime"] = this.loginTime ? this.loginTime.toISOString() : <any>undefined;
        data["login_Timezone"] = this.login_Timezone;
        data["logoutTime"] = this.logoutTime ? this.logoutTime.toISOString() : <any>undefined;
        data["logout_Timezone"] = this.logout_Timezone;
        data["userId"] = this.userId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITimeSheetListDto {
    loginTime: moment.Moment | undefined;
    login_Timezone: string | undefined;
    logoutTime: moment.Moment | undefined;
    logout_Timezone: string | undefined;
    userId: number;
    user: UserListDto | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class LogOffClockOutInput implements ILogOffClockOutInput {
    timezone!: string | undefined;
    userId!: number;

    constructor(data?: ILogOffClockOutInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.timezone = data["timezone"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): LogOffClockOutInput {
        data = typeof data === 'object' ? data : {};
        let result = new LogOffClockOutInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["timezone"] = this.timezone;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface ILogOffClockOutInput {
    timezone: string | undefined;
    userId: number;
}

export enum ExportType {
    Orders = 0,
    CallIns = 1,
    RouteSchedules = 2,
    Drivers = 3,
    Vehicles = 4,
    Clinics = 5,
    Addresses = 6,
    Fleets = 7,
    ZoneLocation = 8,
    RouteDefinition = 9,
}

export enum DataType {
    String = 0,
    Number = 1,
    Date = 2,
    Boolean = 3,
    Decimal = 4,
    Time = 5,
}

export class ExportMappingDto implements IExportMappingDto {
    name!: string | undefined;
    exportType!: ExportType;
    ignore!: boolean;
    column!: string | undefined;
    dataType!: DataType;
    required!: boolean;
    columnToMap!: string | undefined;
    defaultValue!: string | undefined;
    columnNo!: number;
    id!: number;

    constructor(data?: IExportMappingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.exportType = data["exportType"];
            this.ignore = data["ignore"];
            this.column = data["column"];
            this.dataType = data["dataType"];
            this.required = data["required"];
            this.columnToMap = data["columnToMap"];
            this.defaultValue = data["defaultValue"];
            this.columnNo = data["columnNo"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ExportMappingDto {
        data = typeof data === 'object' ? data : {};
        let result = new ExportMappingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["exportType"] = this.exportType;
        data["ignore"] = this.ignore;
        data["column"] = this.column;
        data["dataType"] = this.dataType;
        data["required"] = this.required;
        data["columnToMap"] = this.columnToMap;
        data["defaultValue"] = this.defaultValue;
        data["columnNo"] = this.columnNo;
        data["id"] = this.id;
        return data; 
    }
}

export interface IExportMappingDto {
    name: string | undefined;
    exportType: ExportType;
    ignore: boolean;
    column: string | undefined;
    dataType: DataType;
    required: boolean;
    columnToMap: string | undefined;
    defaultValue: string | undefined;
    columnNo: number;
    id: number;
}

export class GetExportMappingForViewDto implements IGetExportMappingForViewDto {
    exportMapping!: ExportMappingDto | undefined;

    constructor(data?: IGetExportMappingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.exportMapping = data["exportMapping"] ? ExportMappingDto.fromJS(data["exportMapping"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetExportMappingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetExportMappingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["exportMapping"] = this.exportMapping ? this.exportMapping.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetExportMappingForViewDto {
    exportMapping: ExportMappingDto | undefined;
}

export class PagedResultDtoOfGetExportMappingForViewDto implements IPagedResultDtoOfGetExportMappingForViewDto {
    totalCount!: number;
    items!: GetExportMappingForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetExportMappingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetExportMappingForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetExportMappingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetExportMappingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetExportMappingForViewDto {
    totalCount: number;
    items: GetExportMappingForViewDto[] | undefined;
}

export class CreateOrEditExportMappingDto implements ICreateOrEditExportMappingDto {
    name!: string;
    exportType!: ExportType;
    ignore!: boolean;
    column!: string;
    dataType!: DataType;
    required!: boolean;
    columnToMap!: string;
    defaultValue!: string | undefined;
    columnNo!: number | undefined;
    orderSourceId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditExportMappingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.exportType = data["exportType"];
            this.ignore = data["ignore"];
            this.column = data["column"];
            this.dataType = data["dataType"];
            this.required = data["required"];
            this.columnToMap = data["columnToMap"];
            this.defaultValue = data["defaultValue"];
            this.columnNo = data["columnNo"];
            this.orderSourceId = data["orderSourceId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditExportMappingDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditExportMappingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["exportType"] = this.exportType;
        data["ignore"] = this.ignore;
        data["column"] = this.column;
        data["dataType"] = this.dataType;
        data["required"] = this.required;
        data["columnToMap"] = this.columnToMap;
        data["defaultValue"] = this.defaultValue;
        data["columnNo"] = this.columnNo;
        data["orderSourceId"] = this.orderSourceId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditExportMappingDto {
    name: string;
    exportType: ExportType;
    ignore: boolean;
    column: string;
    dataType: DataType;
    required: boolean;
    columnToMap: string;
    defaultValue: string | undefined;
    columnNo: number | undefined;
    orderSourceId: number | undefined;
    id: number | undefined;
}

export class GetExportMappingForEditOutput implements IGetExportMappingForEditOutput {
    exportMapping!: CreateOrEditExportMappingDto | undefined;

    constructor(data?: IGetExportMappingForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.exportMapping = data["exportMapping"] ? CreateOrEditExportMappingDto.fromJS(data["exportMapping"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetExportMappingForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetExportMappingForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["exportMapping"] = this.exportMapping ? this.exportMapping.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetExportMappingForEditOutput {
    exportMapping: CreateOrEditExportMappingDto | undefined;
}

export class GetExportEDIResult implements IGetExportEDIResult {
    message!: string | undefined;
    blobUrl!: string | undefined;

    constructor(data?: IGetExportEDIResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.message = data["message"];
            this.blobUrl = data["blobUrl"];
        }
    }

    static fromJS(data: any): GetExportEDIResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetExportEDIResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["message"] = this.message;
        data["blobUrl"] = this.blobUrl;
        return data; 
    }
}

export interface IGetExportEDIResult {
    message: string | undefined;
    blobUrl: string | undefined;
}

export class UpdateRequestsInputDto implements IUpdateRequestsInputDto {
    requestIds!: number[] | undefined;

    constructor(data?: IUpdateRequestsInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["requestIds"])) {
                this.requestIds = [] as any;
                for (let item of data["requestIds"])
                    this.requestIds!.push(item);
            }
        }
    }

    static fromJS(data: any): UpdateRequestsInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRequestsInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.requestIds)) {
            data["requestIds"] = [];
            for (let item of this.requestIds)
                data["requestIds"].push(item);
        }
        return data; 
    }
}

export interface IUpdateRequestsInputDto {
    requestIds: number[] | undefined;
}

export class GetPendingRequestResultItemDto implements IGetPendingRequestResultItemDto {
    id!: number;
    token!: string | undefined;
    content!: string | undefined;
    isSent!: boolean;

    constructor(data?: IGetPendingRequestResultItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.token = data["token"];
            this.content = data["content"];
            this.isSent = data["isSent"];
        }
    }

    static fromJS(data: any): GetPendingRequestResultItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetPendingRequestResultItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["token"] = this.token;
        data["content"] = this.content;
        data["isSent"] = this.isSent;
        return data; 
    }
}

export interface IGetPendingRequestResultItemDto {
    id: number;
    token: string | undefined;
    content: string | undefined;
    isSent: boolean;
}

export class ListResultDtoOfGetPendingRequestResultItemDto implements IListResultDtoOfGetPendingRequestResultItemDto {
    items!: GetPendingRequestResultItemDto[] | undefined;

    constructor(data?: IListResultDtoOfGetPendingRequestResultItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetPendingRequestResultItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetPendingRequestResultItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetPendingRequestResultItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetPendingRequestResultItemDto {
    items: GetPendingRequestResultItemDto[] | undefined;
}

export class SendNotificationsRecipientListItemDto implements ISendNotificationsRecipientListItemDto {
    requestId!: number;
    token!: string | undefined;

    constructor(data?: ISendNotificationsRecipientListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.requestId = data["requestId"];
            this.token = data["token"];
        }
    }

    static fromJS(data: any): SendNotificationsRecipientListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new SendNotificationsRecipientListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["requestId"] = this.requestId;
        data["token"] = this.token;
        return data; 
    }
}

export interface ISendNotificationsRecipientListItemDto {
    requestId: number;
    token: string | undefined;
}

export class SendNotificationsInputDto implements ISendNotificationsInputDto {
    recipients!: SendNotificationsRecipientListItemDto[] | undefined;
    content!: string | undefined;

    constructor(data?: ISendNotificationsInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["recipients"])) {
                this.recipients = [] as any;
                for (let item of data["recipients"])
                    this.recipients!.push(SendNotificationsRecipientListItemDto.fromJS(item));
            }
            this.content = data["content"];
        }
    }

    static fromJS(data: any): SendNotificationsInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new SendNotificationsInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.recipients)) {
            data["recipients"] = [];
            for (let item of this.recipients)
                data["recipients"].push(item.toJSON());
        }
        data["content"] = this.content;
        return data; 
    }
}

export interface ISendNotificationsInputDto {
    recipients: SendNotificationsRecipientListItemDto[] | undefined;
    content: string | undefined;
}

export class CreateRequestInputDto implements ICreateRequestInputDto {
    token!: string | undefined;
    content!: string | undefined;

    constructor(data?: ICreateRequestInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.token = data["token"];
            this.content = data["content"];
        }
    }

    static fromJS(data: any): CreateRequestInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRequestInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["token"] = this.token;
        data["content"] = this.content;
        return data; 
    }
}

export interface ICreateRequestInputDto {
    token: string | undefined;
    content: string | undefined;
}

export class CreateFleetInput implements ICreateFleetInput {
    name!: string | undefined;

    constructor(data?: ICreateFleetInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CreateFleetInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateFleetInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface ICreateFleetInput {
    name: string | undefined;
}

export class FleetListDto implements IFleetListDto {
    tenantId!: number;
    id!: number;
    name!: string | undefined;
    mileageMultiplier!: number | undefined;

    constructor(data?: IFleetListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.id = data["id"];
            this.name = data["name"];
            this.mileageMultiplier = data["mileageMultiplier"];
        }
    }

    static fromJS(data: any): FleetListDto {
        data = typeof data === 'object' ? data : {};
        let result = new FleetListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["id"] = this.id;
        data["name"] = this.name;
        data["mileageMultiplier"] = this.mileageMultiplier;
        return data; 
    }
}

export interface IFleetListDto {
    tenantId: number;
    id: number;
    name: string | undefined;
    mileageMultiplier: number | undefined;
}

export class PagedResultDtoOfFleetListDto implements IPagedResultDtoOfFleetListDto {
    totalCount!: number;
    items!: FleetListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfFleetListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(FleetListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfFleetListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfFleetListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfFleetListDto {
    totalCount: number;
    items: FleetListDto[] | undefined;
}

export class UpdateFleetInput implements IUpdateFleetInput {
    id!: number;
    name!: string | undefined;
    mileageMultiplier!: number | undefined;

    constructor(data?: IUpdateFleetInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.mileageMultiplier = data["mileageMultiplier"];
        }
    }

    static fromJS(data: any): UpdateFleetInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateFleetInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["mileageMultiplier"] = this.mileageMultiplier;
        return data; 
    }
}

export interface IUpdateFleetInput {
    id: number;
    name: string | undefined;
    mileageMultiplier: number | undefined;
}

export class CreateFleetRateInput implements ICreateFleetRateInput {
    fleetId!: number;
    rateId!: number;

    constructor(data?: ICreateFleetRateInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fleetId = data["fleetId"];
            this.rateId = data["rateId"];
        }
    }

    static fromJS(data: any): CreateFleetRateInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateFleetRateInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fleetId"] = this.fleetId;
        data["rateId"] = this.rateId;
        return data; 
    }
}

export interface ICreateFleetRateInput {
    fleetId: number;
    rateId: number;
}

export class CreateRateToFleetInput implements ICreateRateToFleetInput {
    rateIds!: number[] | undefined;
    rateId!: number;
    fleetId!: number;

    constructor(data?: ICreateRateToFleetInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["rateIds"])) {
                this.rateIds = [] as any;
                for (let item of data["rateIds"])
                    this.rateIds!.push(item);
            }
            this.rateId = data["rateId"];
            this.fleetId = data["fleetId"];
        }
    }

    static fromJS(data: any): CreateRateToFleetInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRateToFleetInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.rateIds)) {
            data["rateIds"] = [];
            for (let item of this.rateIds)
                data["rateIds"].push(item);
        }
        data["rateId"] = this.rateId;
        data["fleetId"] = this.fleetId;
        return data; 
    }
}

export interface ICreateRateToFleetInput {
    rateIds: number[] | undefined;
    rateId: number;
    fleetId: number;
}

export class RateListForFleetDto implements IRateListForFleetDto {
    id!: number | undefined;
    tenantId!: number | undefined;
    locationId!: number | undefined;
    locationName!: string | undefined;
    orderSourceId!: number | undefined;
    orderSourceName!: string | undefined;
    description!: string | undefined;

    constructor(data?: IRateListForFleetDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.locationId = data["locationId"];
            this.locationName = data["locationName"];
            this.orderSourceId = data["orderSourceId"];
            this.orderSourceName = data["orderSourceName"];
            this.description = data["description"];
        }
    }

    static fromJS(data: any): RateListForFleetDto {
        data = typeof data === 'object' ? data : {};
        let result = new RateListForFleetDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["locationId"] = this.locationId;
        data["locationName"] = this.locationName;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSourceName"] = this.orderSourceName;
        data["description"] = this.description;
        return data; 
    }
}

export interface IRateListForFleetDto {
    id: number | undefined;
    tenantId: number | undefined;
    locationId: number | undefined;
    locationName: string | undefined;
    orderSourceId: number | undefined;
    orderSourceName: string | undefined;
    description: string | undefined;
}

export class PagedResultDtoOfRateListForFleetDto implements IPagedResultDtoOfRateListForFleetDto {
    totalCount!: number;
    items!: RateListForFleetDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRateListForFleetDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RateListForFleetDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRateListForFleetDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRateListForFleetDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRateListForFleetDto {
    totalCount: number;
    items: RateListForFleetDto[] | undefined;
}

export class FleetInFleetRateListDto implements IFleetInFleetRateListDto {
    id!: number;
    name!: string | undefined;

    constructor(data?: IFleetInFleetRateListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): FleetInFleetRateListDto {
        data = typeof data === 'object' ? data : {};
        let result = new FleetInFleetRateListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IFleetInFleetRateListDto {
    id: number;
    name: string | undefined;
}

export class RateInFleetRateListDto implements IRateInFleetRateListDto {
    id!: number | undefined;
    tenantId!: number | undefined;
    locationId!: number | undefined;
    locationName!: string | undefined;
    orderSourceId!: number | undefined;
    orderSourceName!: string | undefined;
    description!: string | undefined;
    inActive!: boolean;

    constructor(data?: IRateInFleetRateListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.locationId = data["locationId"];
            this.locationName = data["locationName"];
            this.orderSourceId = data["orderSourceId"];
            this.orderSourceName = data["orderSourceName"];
            this.description = data["description"];
            this.inActive = data["inActive"];
        }
    }

    static fromJS(data: any): RateInFleetRateListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RateInFleetRateListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["locationId"] = this.locationId;
        data["locationName"] = this.locationName;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSourceName"] = this.orderSourceName;
        data["description"] = this.description;
        data["inActive"] = this.inActive;
        return data; 
    }
}

export interface IRateInFleetRateListDto {
    id: number | undefined;
    tenantId: number | undefined;
    locationId: number | undefined;
    locationName: string | undefined;
    orderSourceId: number | undefined;
    orderSourceName: string | undefined;
    description: string | undefined;
    inActive: boolean;
}

export class FleetRateListDto implements IFleetRateListDto {
    id!: number;
    fleet!: FleetInFleetRateListDto | undefined;
    fleetId!: number;
    rate!: RateInFleetRateListDto | undefined;
    rateId!: number;

    constructor(data?: IFleetRateListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.fleet = data["fleet"] ? FleetInFleetRateListDto.fromJS(data["fleet"]) : <any>undefined;
            this.fleetId = data["fleetId"];
            this.rate = data["rate"] ? RateInFleetRateListDto.fromJS(data["rate"]) : <any>undefined;
            this.rateId = data["rateId"];
        }
    }

    static fromJS(data: any): FleetRateListDto {
        data = typeof data === 'object' ? data : {};
        let result = new FleetRateListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        data["fleetId"] = this.fleetId;
        data["rate"] = this.rate ? this.rate.toJSON() : <any>undefined;
        data["rateId"] = this.rateId;
        return data; 
    }
}

export interface IFleetRateListDto {
    id: number;
    fleet: FleetInFleetRateListDto | undefined;
    fleetId: number;
    rate: RateInFleetRateListDto | undefined;
    rateId: number;
}

export class PagedResultDtoOfFleetRateListDto implements IPagedResultDtoOfFleetRateListDto {
    totalCount!: number;
    items!: FleetRateListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfFleetRateListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(FleetRateListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfFleetRateListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfFleetRateListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfFleetRateListDto {
    totalCount: number;
    items: FleetRateListDto[] | undefined;
}

export class UpdateFleetRateInput implements IUpdateFleetRateInput {
    id!: number;
    fleetId!: number;
    rateId!: number;

    constructor(data?: IUpdateFleetRateInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.fleetId = data["fleetId"];
            this.rateId = data["rateId"];
        }
    }

    static fromJS(data: any): UpdateFleetRateInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateFleetRateInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["fleetId"] = this.fleetId;
        data["rateId"] = this.rateId;
        return data; 
    }
}

export interface IUpdateFleetRateInput {
    id: number;
    fleetId: number;
    rateId: number;
}

export class FleetDto implements IFleetDto {
    name!: string | undefined;
    parentId!: number | undefined;
    driverCount!: number;
    vehicleCount!: number;
    rateCount!: number;
    mileageMultiplier!: number | undefined;
    id!: number;

    constructor(data?: IFleetDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.parentId = data["parentId"];
            this.driverCount = data["driverCount"];
            this.vehicleCount = data["vehicleCount"];
            this.rateCount = data["rateCount"];
            this.mileageMultiplier = data["mileageMultiplier"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): FleetDto {
        data = typeof data === 'object' ? data : {};
        let result = new FleetDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["parentId"] = this.parentId;
        data["driverCount"] = this.driverCount;
        data["vehicleCount"] = this.vehicleCount;
        data["rateCount"] = this.rateCount;
        data["mileageMultiplier"] = this.mileageMultiplier;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFleetDto {
    name: string | undefined;
    parentId: number | undefined;
    driverCount: number;
    vehicleCount: number;
    rateCount: number;
    mileageMultiplier: number | undefined;
    id: number;
}

export class GetFleetForViewDto implements IGetFleetForViewDto {
    fleet!: FleetDto | undefined;

    constructor(data?: IGetFleetForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fleet = data["fleet"] ? FleetDto.fromJS(data["fleet"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetFleetForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetFleetForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetFleetForViewDto {
    fleet: FleetDto | undefined;
}

export class PagedResultDtoOfGetFleetForViewDto implements IPagedResultDtoOfGetFleetForViewDto {
    totalCount!: number;
    items!: GetFleetForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetFleetForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetFleetForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetFleetForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetFleetForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetFleetForViewDto {
    totalCount: number;
    items: GetFleetForViewDto[] | undefined;
}

export class ListResultDtoOfFleetDto implements IListResultDtoOfFleetDto {
    items!: FleetDto[] | undefined;

    constructor(data?: IListResultDtoOfFleetDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(FleetDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfFleetDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfFleetDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfFleetDto {
    items: FleetDto[] | undefined;
}

export class CreateOrEditFleetDto implements ICreateOrEditFleetDto {
    name!: string | undefined;
    mileageMultiplier!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditFleetDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.mileageMultiplier = data["mileageMultiplier"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditFleetDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditFleetDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["mileageMultiplier"] = this.mileageMultiplier;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditFleetDto {
    name: string | undefined;
    mileageMultiplier: number | undefined;
    id: number | undefined;
}

export class GetFleetForEditOutput implements IGetFleetForEditOutput {
    fleet!: CreateOrEditFleetDto | undefined;

    constructor(data?: IGetFleetForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fleet = data["fleet"] ? CreateOrEditFleetDto.fromJS(data["fleet"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetFleetForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetFleetForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetFleetForEditOutput {
    fleet: CreateOrEditFleetDto | undefined;
}

export class CreateFleetUserInput implements ICreateFleetUserInput {
    userId!: number;
    fleetId!: number;

    constructor(data?: ICreateFleetUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.fleetId = data["fleetId"];
        }
    }

    static fromJS(data: any): CreateFleetUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateFleetUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["fleetId"] = this.fleetId;
        return data; 
    }
}

export interface ICreateFleetUserInput {
    userId: number;
    fleetId: number;
}

export class UserInFleetUserListDto implements IUserInFleetUserListDto {
    id!: number;
    name!: string | undefined;
    surname!: string | undefined;
    phoneNumber!: string | undefined;
    emailAddress!: string | undefined;
    roles!: UserListRoleDto[] | undefined;

    constructor(data?: IUserInFleetUserListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.phoneNumber = data["phoneNumber"];
            this.emailAddress = data["emailAddress"];
            if (Array.isArray(data["roles"])) {
                this.roles = [] as any;
                for (let item of data["roles"])
                    this.roles!.push(UserListRoleDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UserInFleetUserListDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserInFleetUserListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["phoneNumber"] = this.phoneNumber;
        data["emailAddress"] = this.emailAddress;
        if (Array.isArray(this.roles)) {
            data["roles"] = [];
            for (let item of this.roles)
                data["roles"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUserInFleetUserListDto {
    id: number;
    name: string | undefined;
    surname: string | undefined;
    phoneNumber: string | undefined;
    emailAddress: string | undefined;
    roles: UserListRoleDto[] | undefined;
}

export class FleetInFleetUserListDto implements IFleetInFleetUserListDto {
    id!: number;
    name!: string | undefined;

    constructor(data?: IFleetInFleetUserListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): FleetInFleetUserListDto {
        data = typeof data === 'object' ? data : {};
        let result = new FleetInFleetUserListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IFleetInFleetUserListDto {
    id: number;
    name: string | undefined;
}

export class FleetUserListDto implements IFleetUserListDto {
    id!: number;
    userId!: number;
    user!: UserInFleetUserListDto | undefined;
    fleet!: FleetInFleetUserListDto | undefined;
    fleetId!: number;

    constructor(data?: IFleetUserListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.user = data["user"] ? UserInFleetUserListDto.fromJS(data["user"]) : <any>undefined;
            this.fleet = data["fleet"] ? FleetInFleetUserListDto.fromJS(data["fleet"]) : <any>undefined;
            this.fleetId = data["fleetId"];
        }
    }

    static fromJS(data: any): FleetUserListDto {
        data = typeof data === 'object' ? data : {};
        let result = new FleetUserListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        data["fleetId"] = this.fleetId;
        return data; 
    }
}

export interface IFleetUserListDto {
    id: number;
    userId: number;
    user: UserInFleetUserListDto | undefined;
    fleet: FleetInFleetUserListDto | undefined;
    fleetId: number;
}

export class PagedResultDtoOfFleetUserListDto implements IPagedResultDtoOfFleetUserListDto {
    totalCount!: number;
    items!: FleetUserListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfFleetUserListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(FleetUserListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfFleetUserListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfFleetUserListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfFleetUserListDto {
    totalCount: number;
    items: FleetUserListDto[] | undefined;
}

export class GetFleetUserForEditOutput implements IGetFleetUserForEditOutput {
    fleetUser!: FleetUserListDto | undefined;

    constructor(data?: IGetFleetUserForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fleetUser = data["fleetUser"] ? FleetUserListDto.fromJS(data["fleetUser"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetFleetUserForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetFleetUserForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fleetUser"] = this.fleetUser ? this.fleetUser.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetFleetUserForEditOutput {
    fleetUser: FleetUserListDto | undefined;
}

export class UpdateFleetUserInput implements IUpdateFleetUserInput {
    id!: number;
    userId!: number;
    fleetId!: number;

    constructor(data?: IUpdateFleetUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.fleetId = data["fleetId"];
        }
    }

    static fromJS(data: any): UpdateFleetUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateFleetUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["fleetId"] = this.fleetId;
        return data; 
    }
}

export interface IUpdateFleetUserInput {
    id: number;
    userId: number;
    fleetId: number;
}

export class PagedResultDtoOfUserListDto implements IPagedResultDtoOfUserListDto {
    totalCount!: number;
    items!: UserListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfUserListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(UserListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfUserListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfUserListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfUserListDto {
    totalCount: number;
    items: UserListDto[] | undefined;
}

export class CreateDriverToFleetInput implements ICreateDriverToFleetInput {
    userIds!: number[] | undefined;
    userId!: number;
    fleetId!: number;

    constructor(data?: ICreateDriverToFleetInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["userIds"])) {
                this.userIds = [] as any;
                for (let item of data["userIds"])
                    this.userIds!.push(item);
            }
            this.userId = data["userId"];
            this.fleetId = data["fleetId"];
        }
    }

    static fromJS(data: any): CreateDriverToFleetInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDriverToFleetInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.userIds)) {
            data["userIds"] = [];
            for (let item of this.userIds)
                data["userIds"].push(item);
        }
        data["userId"] = this.userId;
        data["fleetId"] = this.fleetId;
        return data; 
    }
}

export interface ICreateDriverToFleetInput {
    userIds: number[] | undefined;
    userId: number;
    fleetId: number;
}

export class CreateFleetVehicleInput implements ICreateFleetVehicleInput {
    fleetId!: number;
    vehicleId!: number;

    constructor(data?: ICreateFleetVehicleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fleetId = data["fleetId"];
            this.vehicleId = data["vehicleId"];
        }
    }

    static fromJS(data: any): CreateFleetVehicleInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateFleetVehicleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fleetId"] = this.fleetId;
        data["vehicleId"] = this.vehicleId;
        return data; 
    }
}

export interface ICreateFleetVehicleInput {
    fleetId: number;
    vehicleId: number;
}

export class FleetInFleetVehicleListDto implements IFleetInFleetVehicleListDto {
    id!: number;
    name!: string | undefined;

    constructor(data?: IFleetInFleetVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): FleetInFleetVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new FleetInFleetVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IFleetInFleetVehicleListDto {
    id: number;
    name: string | undefined;
}

export class VehicleInFleetVehicleListDto implements IVehicleInFleetVehicleListDto {
    id!: number;
    name!: string | undefined;
    licenseNumber!: string | undefined;

    constructor(data?: IVehicleInFleetVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
        }
    }

    static fromJS(data: any): VehicleInFleetVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleInFleetVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        return data; 
    }
}

export interface IVehicleInFleetVehicleListDto {
    id: number;
    name: string | undefined;
    licenseNumber: string | undefined;
}

export class FleetVehicleListDto implements IFleetVehicleListDto {
    id!: number;
    fleet!: FleetInFleetVehicleListDto | undefined;
    fleetId!: number;
    vehicle!: VehicleInFleetVehicleListDto | undefined;
    vehicleId!: number;

    constructor(data?: IFleetVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.fleet = data["fleet"] ? FleetInFleetVehicleListDto.fromJS(data["fleet"]) : <any>undefined;
            this.fleetId = data["fleetId"];
            this.vehicle = data["vehicle"] ? VehicleInFleetVehicleListDto.fromJS(data["vehicle"]) : <any>undefined;
            this.vehicleId = data["vehicleId"];
        }
    }

    static fromJS(data: any): FleetVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new FleetVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        data["fleetId"] = this.fleetId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        return data; 
    }
}

export interface IFleetVehicleListDto {
    id: number;
    fleet: FleetInFleetVehicleListDto | undefined;
    fleetId: number;
    vehicle: VehicleInFleetVehicleListDto | undefined;
    vehicleId: number;
}

export class PagedResultDtoOfFleetVehicleListDto implements IPagedResultDtoOfFleetVehicleListDto {
    totalCount!: number;
    items!: FleetVehicleListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfFleetVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(FleetVehicleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfFleetVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfFleetVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfFleetVehicleListDto {
    totalCount: number;
    items: FleetVehicleListDto[] | undefined;
}

export class GetFleetVehicleForEditOutput implements IGetFleetVehicleForEditOutput {
    fleetVehicle!: FleetVehicleListDto | undefined;

    constructor(data?: IGetFleetVehicleForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fleetVehicle = data["fleetVehicle"] ? FleetVehicleListDto.fromJS(data["fleetVehicle"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetFleetVehicleForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetFleetVehicleForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fleetVehicle"] = this.fleetVehicle ? this.fleetVehicle.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetFleetVehicleForEditOutput {
    fleetVehicle: FleetVehicleListDto | undefined;
}

export class UpdateFleetVehicleInput implements IUpdateFleetVehicleInput {
    id!: number;
    fleetId!: number;
    vehicleId!: number;

    constructor(data?: IUpdateFleetVehicleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.fleetId = data["fleetId"];
            this.vehicleId = data["vehicleId"];
        }
    }

    static fromJS(data: any): UpdateFleetVehicleInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateFleetVehicleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["fleetId"] = this.fleetId;
        data["vehicleId"] = this.vehicleId;
        return data; 
    }
}

export interface IUpdateFleetVehicleInput {
    id: number;
    fleetId: number;
    vehicleId: number;
}

export class GetUnassignedVehicleListDto implements IGetUnassignedVehicleListDto {
    id!: number;
    name!: string | undefined;

    constructor(data?: IGetUnassignedVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetUnassignedVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetUnassignedVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetUnassignedVehicleListDto {
    id: number;
    name: string | undefined;
}

export class PagedResultDtoOfGetUnassignedVehicleListDto implements IPagedResultDtoOfGetUnassignedVehicleListDto {
    totalCount!: number;
    items!: GetUnassignedVehicleListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetUnassignedVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetUnassignedVehicleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetUnassignedVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetUnassignedVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetUnassignedVehicleListDto {
    totalCount: number;
    items: GetUnassignedVehicleListDto[] | undefined;
}

export class CreateVehicleToFleetInput implements ICreateVehicleToFleetInput {
    vehicleIds!: number[] | undefined;
    vehicleId!: number;
    fleetId!: number;

    constructor(data?: ICreateVehicleToFleetInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["vehicleIds"])) {
                this.vehicleIds = [] as any;
                for (let item of data["vehicleIds"])
                    this.vehicleIds!.push(item);
            }
            this.vehicleId = data["vehicleId"];
            this.fleetId = data["fleetId"];
        }
    }

    static fromJS(data: any): CreateVehicleToFleetInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateVehicleToFleetInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.vehicleIds)) {
            data["vehicleIds"] = [];
            for (let item of this.vehicleIds)
                data["vehicleIds"].push(item);
        }
        data["vehicleId"] = this.vehicleId;
        data["fleetId"] = this.fleetId;
        return data; 
    }
}

export interface ICreateVehicleToFleetInput {
    vehicleIds: number[] | undefined;
    vehicleId: number;
    fleetId: number;
}

export class CreateFriendshipRequestInput implements ICreateFriendshipRequestInput {
    userId!: number;
    tenantId!: number | undefined;

    constructor(data?: ICreateFriendshipRequestInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
        }
    }

    static fromJS(data: any): CreateFriendshipRequestInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateFriendshipRequestInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        return data; 
    }
}

export interface ICreateFriendshipRequestInput {
    userId: number;
    tenantId: number | undefined;
}

export class CreateFriendshipRequestByUserNameInput implements ICreateFriendshipRequestByUserNameInput {
    tenancyName!: string;
    userName!: string | undefined;

    constructor(data?: ICreateFriendshipRequestByUserNameInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.userName = data["userName"];
        }
    }

    static fromJS(data: any): CreateFriendshipRequestByUserNameInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateFriendshipRequestByUserNameInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["userName"] = this.userName;
        return data; 
    }
}

export interface ICreateFriendshipRequestByUserNameInput {
    tenancyName: string;
    userName: string | undefined;
}

export class BlockUserInput implements IBlockUserInput {
    userId!: number;
    tenantId!: number | undefined;

    constructor(data?: IBlockUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
        }
    }

    static fromJS(data: any): BlockUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new BlockUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        return data; 
    }
}

export interface IBlockUserInput {
    userId: number;
    tenantId: number | undefined;
}

export class UnblockUserInput implements IUnblockUserInput {
    userId!: number;
    tenantId!: number | undefined;

    constructor(data?: IUnblockUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
        }
    }

    static fromJS(data: any): UnblockUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new UnblockUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        return data; 
    }
}

export interface IUnblockUserInput {
    userId: number;
    tenantId: number | undefined;
}

export class AcceptFriendshipRequestInput implements IAcceptFriendshipRequestInput {
    userId!: number;
    tenantId!: number | undefined;

    constructor(data?: IAcceptFriendshipRequestInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
        }
    }

    static fromJS(data: any): AcceptFriendshipRequestInput {
        data = typeof data === 'object' ? data : {};
        let result = new AcceptFriendshipRequestInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        return data; 
    }
}

export interface IAcceptFriendshipRequestInput {
    userId: number;
    tenantId: number | undefined;
}

export class FtpAccountDto implements IFtpAccountDto {
    name!: string | undefined;
    host!: string | undefined;
    port!: number;
    username!: string | undefined;
    password!: string | undefined;
    folder!: string | undefined;
    isActive!: boolean;
    id!: number;

    constructor(data?: IFtpAccountDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.host = data["host"];
            this.port = data["port"];
            this.username = data["username"];
            this.password = data["password"];
            this.folder = data["folder"];
            this.isActive = data["isActive"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): FtpAccountDto {
        data = typeof data === 'object' ? data : {};
        let result = new FtpAccountDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["host"] = this.host;
        data["port"] = this.port;
        data["username"] = this.username;
        data["password"] = this.password;
        data["folder"] = this.folder;
        data["isActive"] = this.isActive;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFtpAccountDto {
    name: string | undefined;
    host: string | undefined;
    port: number;
    username: string | undefined;
    password: string | undefined;
    folder: string | undefined;
    isActive: boolean;
    id: number;
}

export class GetFtpAccountForViewDto implements IGetFtpAccountForViewDto {
    ftpAccount!: FtpAccountDto | undefined;

    constructor(data?: IGetFtpAccountForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.ftpAccount = data["ftpAccount"] ? FtpAccountDto.fromJS(data["ftpAccount"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetFtpAccountForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetFtpAccountForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["ftpAccount"] = this.ftpAccount ? this.ftpAccount.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetFtpAccountForViewDto {
    ftpAccount: FtpAccountDto | undefined;
}

export class PagedResultDtoOfGetFtpAccountForViewDto implements IPagedResultDtoOfGetFtpAccountForViewDto {
    totalCount!: number;
    items!: GetFtpAccountForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetFtpAccountForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetFtpAccountForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetFtpAccountForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetFtpAccountForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetFtpAccountForViewDto {
    totalCount: number;
    items: GetFtpAccountForViewDto[] | undefined;
}

export class CreateOrEditFtpAccountDto implements ICreateOrEditFtpAccountDto {
    name!: string;
    host!: string;
    port!: number;
    username!: string;
    password!: string;
    folder!: string;
    isActive!: boolean;
    id!: number | undefined;

    constructor(data?: ICreateOrEditFtpAccountDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.host = data["host"];
            this.port = data["port"];
            this.username = data["username"];
            this.password = data["password"];
            this.folder = data["folder"];
            this.isActive = data["isActive"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditFtpAccountDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditFtpAccountDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["host"] = this.host;
        data["port"] = this.port;
        data["username"] = this.username;
        data["password"] = this.password;
        data["folder"] = this.folder;
        data["isActive"] = this.isActive;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditFtpAccountDto {
    name: string;
    host: string;
    port: number;
    username: string;
    password: string;
    folder: string;
    isActive: boolean;
    id: number | undefined;
}

export class GetFtpAccountForEditOutput implements IGetFtpAccountForEditOutput {
    ftpAccount!: CreateOrEditFtpAccountDto | undefined;

    constructor(data?: IGetFtpAccountForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.ftpAccount = data["ftpAccount"] ? CreateOrEditFtpAccountDto.fromJS(data["ftpAccount"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetFtpAccountForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetFtpAccountForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["ftpAccount"] = this.ftpAccount ? this.ftpAccount.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetFtpAccountForEditOutput {
    ftpAccount: CreateOrEditFtpAccountDto | undefined;
}

export class UserIdentifier implements IUserIdentifier {
    readonly tenantId!: number | undefined;
    readonly userId!: number;

    constructor(data?: IUserIdentifier) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).tenantId = data["tenantId"];
            (<any>this).userId = data["userId"];
        }
    }

    static fromJS(data: any): UserIdentifier {
        data = typeof data === 'object' ? data : {};
        let result = new UserIdentifier();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IUserIdentifier {
    tenantId: number | undefined;
    userId: number;
}

export class ImportGenericFromExcellJobArgs implements IImportGenericFromExcellJobArgs {
    tenantId!: number | undefined;
    binaryObjectId!: string;
    user!: UserIdentifier | undefined;
    key!: string | undefined;
    locale!: string | undefined;
    loadDate!: string | undefined;
    fileName!: string | undefined;
    orderSourceId!: number | undefined;
    orderSourceCode!: string | undefined;
    locationId!: number | undefined;
    isHeaderFixed!: boolean;

    constructor(data?: IImportGenericFromExcellJobArgs) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.binaryObjectId = data["binaryObjectId"];
            this.user = data["user"] ? UserIdentifier.fromJS(data["user"]) : <any>undefined;
            this.key = data["key"];
            this.locale = data["locale"];
            this.loadDate = data["loadDate"];
            this.fileName = data["fileName"];
            this.orderSourceId = data["orderSourceId"];
            this.orderSourceCode = data["orderSourceCode"];
            this.locationId = data["locationId"];
            this.isHeaderFixed = data["isHeaderFixed"];
        }
    }

    static fromJS(data: any): ImportGenericFromExcellJobArgs {
        data = typeof data === 'object' ? data : {};
        let result = new ImportGenericFromExcellJobArgs();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["binaryObjectId"] = this.binaryObjectId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["key"] = this.key;
        data["locale"] = this.locale;
        data["loadDate"] = this.loadDate;
        data["fileName"] = this.fileName;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSourceCode"] = this.orderSourceCode;
        data["locationId"] = this.locationId;
        data["isHeaderFixed"] = this.isHeaderFixed;
        return data; 
    }
}

export interface IImportGenericFromExcellJobArgs {
    tenantId: number | undefined;
    binaryObjectId: string;
    user: UserIdentifier | undefined;
    key: string | undefined;
    locale: string | undefined;
    loadDate: string | undefined;
    fileName: string | undefined;
    orderSourceId: number | undefined;
    orderSourceCode: string | undefined;
    locationId: number | undefined;
    isHeaderFixed: boolean;
}

export class PagedResultDtoOfGeocodeListDto implements IPagedResultDtoOfGeocodeListDto {
    totalCount!: number;
    items!: GeocodeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGeocodeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GeocodeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGeocodeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGeocodeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGeocodeListDto {
    totalCount: number;
    items: GeocodeListDto[] | undefined;
}

export class CreateGeocodeInput implements ICreateGeocodeInput {
    latitude!: number;
    longitude!: number;

    constructor(data?: ICreateGeocodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): CreateGeocodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateGeocodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface ICreateGeocodeInput {
    latitude: number;
    longitude: number;
}

export class UpdateGeocodeInput implements IUpdateGeocodeInput {
    id!: number;
    latitude!: number;
    longitude!: number;

    constructor(data?: IUpdateGeocodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): UpdateGeocodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateGeocodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface IUpdateGeocodeInput {
    id: number;
    latitude: number;
    longitude: number;
}

export class GoogleGeocodingInput implements IGoogleGeocodingInput {
    addressToGeocode!: string | undefined;
    country!: string | undefined;
    paramPostal!: string | undefined;

    constructor(data?: IGoogleGeocodingInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressToGeocode = data["addressToGeocode"];
            this.country = data["country"];
            this.paramPostal = data["paramPostal"];
        }
    }

    static fromJS(data: any): GoogleGeocodingInput {
        data = typeof data === 'object' ? data : {};
        let result = new GoogleGeocodingInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressToGeocode"] = this.addressToGeocode;
        data["country"] = this.country;
        data["paramPostal"] = this.paramPostal;
        return data; 
    }
}

export interface IGoogleGeocodingInput {
    addressToGeocode: string | undefined;
    country: string | undefined;
    paramPostal: string | undefined;
}

export class GoogleGeocodingResult implements IGoogleGeocodingResult {
    latitude!: number;
    longitude!: number;
    result!: string | undefined;
    formattedAddress!: string | undefined;
    partialMatch!: boolean;
    addressType!: string | undefined;
    postalCode!: string | undefined;
    postalCodeId!: number | undefined;

    constructor(data?: IGoogleGeocodingResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.result = data["result"];
            this.formattedAddress = data["formattedAddress"];
            this.partialMatch = data["partialMatch"];
            this.addressType = data["addressType"];
            this.postalCode = data["postalCode"];
            this.postalCodeId = data["postalCodeId"];
        }
    }

    static fromJS(data: any): GoogleGeocodingResult {
        data = typeof data === 'object' ? data : {};
        let result = new GoogleGeocodingResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["result"] = this.result;
        data["formattedAddress"] = this.formattedAddress;
        data["partialMatch"] = this.partialMatch;
        data["addressType"] = this.addressType;
        data["postalCode"] = this.postalCode;
        data["postalCodeId"] = this.postalCodeId;
        return data; 
    }
}

export interface IGoogleGeocodingResult {
    latitude: number;
    longitude: number;
    result: string | undefined;
    formattedAddress: string | undefined;
    partialMatch: boolean;
    addressType: string | undefined;
    postalCode: string | undefined;
    postalCodeId: number | undefined;
}

export class GoogleDistanceMatrixCoordinates implements IGoogleDistanceMatrixCoordinates {
    latitude!: number;
    longitude!: number;
    serviceTime!: number | undefined;
    time!: moment.Moment;

    constructor(data?: IGoogleDistanceMatrixCoordinates) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.serviceTime = data["serviceTime"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GoogleDistanceMatrixCoordinates {
        data = typeof data === 'object' ? data : {};
        let result = new GoogleDistanceMatrixCoordinates();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["serviceTime"] = this.serviceTime;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGoogleDistanceMatrixCoordinates {
    latitude: number;
    longitude: number;
    serviceTime: number | undefined;
    time: moment.Moment;
}

export class GoogleDistanceMatrixInput implements IGoogleDistanceMatrixInput {
    startTime!: moment.Moment | undefined;
    origins!: GoogleDistanceMatrixCoordinates[] | undefined;
    destinations!: GoogleDistanceMatrixCoordinates[] | undefined;
    toll!: boolean;
    highway!: boolean;
    ferry!: boolean;
    indoor!: boolean;
    tenantId!: number | undefined;

    constructor(data?: IGoogleDistanceMatrixInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.startTime = data["startTime"] ? moment(data["startTime"].toString()) : <any>undefined;
            if (Array.isArray(data["origins"])) {
                this.origins = [] as any;
                for (let item of data["origins"])
                    this.origins!.push(GoogleDistanceMatrixCoordinates.fromJS(item));
            }
            if (Array.isArray(data["destinations"])) {
                this.destinations = [] as any;
                for (let item of data["destinations"])
                    this.destinations!.push(GoogleDistanceMatrixCoordinates.fromJS(item));
            }
            this.toll = data["toll"];
            this.highway = data["highway"];
            this.ferry = data["ferry"];
            this.indoor = data["indoor"];
            this.tenantId = data["tenantId"];
        }
    }

    static fromJS(data: any): GoogleDistanceMatrixInput {
        data = typeof data === 'object' ? data : {};
        let result = new GoogleDistanceMatrixInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["startTime"] = this.startTime ? this.startTime.toISOString() : <any>undefined;
        if (Array.isArray(this.origins)) {
            data["origins"] = [];
            for (let item of this.origins)
                data["origins"].push(item.toJSON());
        }
        if (Array.isArray(this.destinations)) {
            data["destinations"] = [];
            for (let item of this.destinations)
                data["destinations"].push(item.toJSON());
        }
        data["toll"] = this.toll;
        data["highway"] = this.highway;
        data["ferry"] = this.ferry;
        data["indoor"] = this.indoor;
        data["tenantId"] = this.tenantId;
        return data; 
    }
}

export interface IGoogleDistanceMatrixInput {
    startTime: moment.Moment | undefined;
    origins: GoogleDistanceMatrixCoordinates[] | undefined;
    destinations: GoogleDistanceMatrixCoordinates[] | undefined;
    toll: boolean;
    highway: boolean;
    ferry: boolean;
    indoor: boolean;
    tenantId: number | undefined;
}

export class GoogleDistanceMatrixResult implements IGoogleDistanceMatrixResult {
    destinationAddresses!: string | undefined;
    originAddresses!: string | undefined;
    status!: string | undefined;
    distanceText!: string | undefined;
    distanceValue!: number;
    durationText!: string | undefined;
    durationValue!: number;
    index!: number;
    eta!: moment.Moment | undefined;

    constructor(data?: IGoogleDistanceMatrixResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.destinationAddresses = data["destinationAddresses"];
            this.originAddresses = data["originAddresses"];
            this.status = data["status"];
            this.distanceText = data["distanceText"];
            this.distanceValue = data["distanceValue"];
            this.durationText = data["durationText"];
            this.durationValue = data["durationValue"];
            this.index = data["index"];
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GoogleDistanceMatrixResult {
        data = typeof data === 'object' ? data : {};
        let result = new GoogleDistanceMatrixResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["destinationAddresses"] = this.destinationAddresses;
        data["originAddresses"] = this.originAddresses;
        data["status"] = this.status;
        data["distanceText"] = this.distanceText;
        data["distanceValue"] = this.distanceValue;
        data["durationText"] = this.durationText;
        data["durationValue"] = this.durationValue;
        data["index"] = this.index;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGoogleDistanceMatrixResult {
    destinationAddresses: string | undefined;
    originAddresses: string | undefined;
    status: string | undefined;
    distanceText: string | undefined;
    distanceValue: number;
    durationText: string | undefined;
    durationValue: number;
    index: number;
    eta: moment.Moment | undefined;
}

export class CoordinateList implements ICoordinateList {
    latitude!: number;
    longitude!: number;
    distance!: number | undefined;
    showEta!: boolean | undefined;
    orderIds!: number[] | undefined;
    pickUp!: boolean;
    deliver!: boolean;
    orderId!: number;
    destinationId!: number | undefined;

    constructor(data?: ICoordinateList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.distance = data["distance"];
            this.showEta = data["showEta"];
            if (Array.isArray(data["orderIds"])) {
                this.orderIds = [] as any;
                for (let item of data["orderIds"])
                    this.orderIds!.push(item);
            }
            this.pickUp = data["pickUp"];
            this.deliver = data["deliver"];
            this.orderId = data["orderId"];
            this.destinationId = data["destinationId"];
        }
    }

    static fromJS(data: any): CoordinateList {
        data = typeof data === 'object' ? data : {};
        let result = new CoordinateList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["distance"] = this.distance;
        data["showEta"] = this.showEta;
        if (Array.isArray(this.orderIds)) {
            data["orderIds"] = [];
            for (let item of this.orderIds)
                data["orderIds"].push(item);
        }
        data["pickUp"] = this.pickUp;
        data["deliver"] = this.deliver;
        data["orderId"] = this.orderId;
        data["destinationId"] = this.destinationId;
        return data; 
    }
}

export interface ICoordinateList {
    latitude: number;
    longitude: number;
    distance: number | undefined;
    showEta: boolean | undefined;
    orderIds: number[] | undefined;
    pickUp: boolean;
    deliver: boolean;
    orderId: number;
    destinationId: number | undefined;
}

export class OrToolsInput implements IOrToolsInput {
    coordinateLists!: CoordinateList[] | undefined;
    useGoogleDistanceMatrix!: boolean;
    startTime!: moment.Moment;

    constructor(data?: IOrToolsInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["coordinateLists"])) {
                this.coordinateLists = [] as any;
                for (let item of data["coordinateLists"])
                    this.coordinateLists!.push(CoordinateList.fromJS(item));
            }
            this.useGoogleDistanceMatrix = data["useGoogleDistanceMatrix"];
            this.startTime = data["startTime"] ? moment(data["startTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): OrToolsInput {
        data = typeof data === 'object' ? data : {};
        let result = new OrToolsInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.coordinateLists)) {
            data["coordinateLists"] = [];
            for (let item of this.coordinateLists)
                data["coordinateLists"].push(item.toJSON());
        }
        data["useGoogleDistanceMatrix"] = this.useGoogleDistanceMatrix;
        data["startTime"] = this.startTime ? this.startTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IOrToolsInput {
    coordinateLists: CoordinateList[] | undefined;
    useGoogleDistanceMatrix: boolean;
    startTime: moment.Moment;
}

export class OrToolResultDto implements IOrToolResultDto {
    distance!: number | undefined;
    arrayKey!: number | undefined;
    previosArrayKey!: number | undefined;

    constructor(data?: IOrToolResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.distance = data["distance"];
            this.arrayKey = data["arrayKey"];
            this.previosArrayKey = data["previosArrayKey"];
        }
    }

    static fromJS(data: any): OrToolResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrToolResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["distance"] = this.distance;
        data["arrayKey"] = this.arrayKey;
        data["previosArrayKey"] = this.previosArrayKey;
        return data; 
    }
}

export interface IOrToolResultDto {
    distance: number | undefined;
    arrayKey: number | undefined;
    previosArrayKey: number | undefined;
}

export class GoogleRequestLogsDto implements IGoogleRequestLogsDto {
    id!: number;
    source!: string | undefined;
    api!: string | undefined;
    isSuccess!: boolean;
    startDate!: moment.Moment | undefined;
    endDate!: moment.Moment | undefined;
    userId!: number;
    fullName!: string | undefined;
    creationTime!: moment.Moment;

    constructor(data?: IGoogleRequestLogsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.source = data["source"];
            this.api = data["api"];
            this.isSuccess = data["isSuccess"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.endDate = data["endDate"] ? moment(data["endDate"].toString()) : <any>undefined;
            this.userId = data["userId"];
            this.fullName = data["fullName"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GoogleRequestLogsDto {
        data = typeof data === 'object' ? data : {};
        let result = new GoogleRequestLogsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["source"] = this.source;
        data["api"] = this.api;
        data["isSuccess"] = this.isSuccess;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["endDate"] = this.endDate ? this.endDate.toISOString() : <any>undefined;
        data["userId"] = this.userId;
        data["fullName"] = this.fullName;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGoogleRequestLogsDto {
    id: number;
    source: string | undefined;
    api: string | undefined;
    isSuccess: boolean;
    startDate: moment.Moment | undefined;
    endDate: moment.Moment | undefined;
    userId: number;
    fullName: string | undefined;
    creationTime: moment.Moment;
}

export class PagedResultDtoOfGoogleRequestLogsDto implements IPagedResultDtoOfGoogleRequestLogsDto {
    totalCount!: number;
    items!: GoogleRequestLogsDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGoogleRequestLogsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GoogleRequestLogsDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGoogleRequestLogsDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGoogleRequestLogsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGoogleRequestLogsDto {
    totalCount: number;
    items: GoogleRequestLogsDto[] | undefined;
}

export class OptimizeByLocationIdInput implements IOptimizeByLocationIdInput {
    locationId!: number;
    departureTime!: moment.Moment;
    toll!: boolean;
    highway!: boolean;
    ferry!: boolean;
    indoor!: boolean;

    constructor(data?: IOptimizeByLocationIdInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.departureTime = data["departureTime"] ? moment(data["departureTime"].toString()) : <any>undefined;
            this.toll = data["toll"];
            this.highway = data["highway"];
            this.ferry = data["ferry"];
            this.indoor = data["indoor"];
        }
    }

    static fromJS(data: any): OptimizeByLocationIdInput {
        data = typeof data === 'object' ? data : {};
        let result = new OptimizeByLocationIdInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["departureTime"] = this.departureTime ? this.departureTime.toISOString() : <any>undefined;
        data["toll"] = this.toll;
        data["highway"] = this.highway;
        data["ferry"] = this.ferry;
        data["indoor"] = this.indoor;
        return data; 
    }
}

export interface IOptimizeByLocationIdInput {
    locationId: number;
    departureTime: moment.Moment;
    toll: boolean;
    highway: boolean;
    ferry: boolean;
    indoor: boolean;
}

export class GetRuleByLocationResult implements IGetRuleByLocationResult {
    highways!: boolean;
    tolls!: boolean;
    indoor!: boolean;
    ferries!: boolean;
    statusId!: number | undefined;
    orderType!: number | undefined;
    orderPosition!: number | undefined;
    timeExecution!: TimeSpan | undefined;
    distance!: number | undefined;
    ruleType!: number;
    trafficFlag!: boolean | undefined;
    useGoogle!: boolean | undefined;

    constructor(data?: IGetRuleByLocationResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.highways = data["highways"];
            this.tolls = data["tolls"];
            this.indoor = data["indoor"];
            this.ferries = data["ferries"];
            this.statusId = data["statusId"];
            this.orderType = data["orderType"];
            this.orderPosition = data["orderPosition"];
            this.timeExecution = data["timeExecution"] ? TimeSpan.fromJS(data["timeExecution"]) : <any>undefined;
            this.distance = data["distance"];
            this.ruleType = data["ruleType"];
            this.trafficFlag = data["trafficFlag"];
            this.useGoogle = data["useGoogle"];
        }
    }

    static fromJS(data: any): GetRuleByLocationResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetRuleByLocationResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["highways"] = this.highways;
        data["tolls"] = this.tolls;
        data["indoor"] = this.indoor;
        data["ferries"] = this.ferries;
        data["statusId"] = this.statusId;
        data["orderType"] = this.orderType;
        data["orderPosition"] = this.orderPosition;
        data["timeExecution"] = this.timeExecution ? this.timeExecution.toJSON() : <any>undefined;
        data["distance"] = this.distance;
        data["ruleType"] = this.ruleType;
        data["trafficFlag"] = this.trafficFlag;
        data["useGoogle"] = this.useGoogle;
        return data; 
    }
}

export interface IGetRuleByLocationResult {
    highways: boolean;
    tolls: boolean;
    indoor: boolean;
    ferries: boolean;
    statusId: number | undefined;
    orderType: number | undefined;
    orderPosition: number | undefined;
    timeExecution: TimeSpan | undefined;
    distance: number | undefined;
    ruleType: number;
    trafficFlag: boolean | undefined;
    useGoogle: boolean | undefined;
}

export class OrderDefaultEtas implements IOrderDefaultEtas {
    orderId!: number | undefined;
    defaultEta!: moment.Moment | undefined;

    constructor(data?: IOrderDefaultEtas) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.defaultEta = data["defaultEta"] ? moment(data["defaultEta"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): OrderDefaultEtas {
        data = typeof data === 'object' ? data : {};
        let result = new OrderDefaultEtas();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["defaultEta"] = this.defaultEta ? this.defaultEta.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IOrderDefaultEtas {
    orderId: number | undefined;
    defaultEta: moment.Moment | undefined;
}

export class OptimizeByRouteIdInput implements IOptimizeByRouteIdInput {
    routeId!: number;
    departureTime!: moment.Moment | undefined;
    tenantId!: number | undefined;
    ruleType!: number | undefined;
    orderId!: number | undefined;
    statusId!: number | undefined;
    optimizerRules!: GetRuleByLocationResult[] | undefined;
    defaultEtas!: OrderDefaultEtas[] | undefined;

    constructor(data?: IOptimizeByRouteIdInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.departureTime = data["departureTime"] ? moment(data["departureTime"].toString()) : <any>undefined;
            this.tenantId = data["tenantId"];
            this.ruleType = data["ruleType"];
            this.orderId = data["orderId"];
            this.statusId = data["statusId"];
            if (Array.isArray(data["optimizerRules"])) {
                this.optimizerRules = [] as any;
                for (let item of data["optimizerRules"])
                    this.optimizerRules!.push(GetRuleByLocationResult.fromJS(item));
            }
            if (Array.isArray(data["defaultEtas"])) {
                this.defaultEtas = [] as any;
                for (let item of data["defaultEtas"])
                    this.defaultEtas!.push(OrderDefaultEtas.fromJS(item));
            }
        }
    }

    static fromJS(data: any): OptimizeByRouteIdInput {
        data = typeof data === 'object' ? data : {};
        let result = new OptimizeByRouteIdInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["departureTime"] = this.departureTime ? this.departureTime.toISOString() : <any>undefined;
        data["tenantId"] = this.tenantId;
        data["ruleType"] = this.ruleType;
        data["orderId"] = this.orderId;
        data["statusId"] = this.statusId;
        if (Array.isArray(this.optimizerRules)) {
            data["optimizerRules"] = [];
            for (let item of this.optimizerRules)
                data["optimizerRules"].push(item.toJSON());
        }
        if (Array.isArray(this.defaultEtas)) {
            data["defaultEtas"] = [];
            for (let item of this.defaultEtas)
                data["defaultEtas"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IOptimizeByRouteIdInput {
    routeId: number;
    departureTime: moment.Moment | undefined;
    tenantId: number | undefined;
    ruleType: number | undefined;
    orderId: number | undefined;
    statusId: number | undefined;
    optimizerRules: GetRuleByLocationResult[] | undefined;
    defaultEtas: OrderDefaultEtas[] | undefined;
}

export class ProcessOptimizeInput implements IProcessOptimizeInput {
    routeId!: number;
    locationId!: number | undefined;
    rule!: number | undefined;
    orderStatus!: number | undefined;
    distance!: number | undefined;
    tenantId!: number | undefined;
    defaultEtas!: OrderDefaultEtas[] | undefined;
    iMoved!: boolean | undefined;

    constructor(data?: IProcessOptimizeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.locationId = data["locationId"];
            this.rule = data["rule"];
            this.orderStatus = data["orderStatus"];
            this.distance = data["distance"];
            this.tenantId = data["tenantId"];
            if (Array.isArray(data["defaultEtas"])) {
                this.defaultEtas = [] as any;
                for (let item of data["defaultEtas"])
                    this.defaultEtas!.push(OrderDefaultEtas.fromJS(item));
            }
            this.iMoved = data["iMoved"];
        }
    }

    static fromJS(data: any): ProcessOptimizeInput {
        data = typeof data === 'object' ? data : {};
        let result = new ProcessOptimizeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["locationId"] = this.locationId;
        data["rule"] = this.rule;
        data["orderStatus"] = this.orderStatus;
        data["distance"] = this.distance;
        data["tenantId"] = this.tenantId;
        if (Array.isArray(this.defaultEtas)) {
            data["defaultEtas"] = [];
            for (let item of this.defaultEtas)
                data["defaultEtas"].push(item.toJSON());
        }
        data["iMoved"] = this.iMoved;
        return data; 
    }
}

export interface IProcessOptimizeInput {
    routeId: number;
    locationId: number | undefined;
    rule: number | undefined;
    orderStatus: number | undefined;
    distance: number | undefined;
    tenantId: number | undefined;
    defaultEtas: OrderDefaultEtas[] | undefined;
    iMoved: boolean | undefined;
}

export class OrderCooordinate implements IOrderCooordinate {
    orderId!: number;
    initialDestinationDetailsId!: number;
    latitude!: number;
    longitude!: number;
    lastDestinationDetailsId!: number;
    serviceTime!: number | undefined;
    time!: moment.Moment | undefined;
    update!: boolean | undefined;
    lta!: moment.Moment | undefined;
    distanceFromStart!: number | undefined;
    sort!: number | undefined;
    ondemand!: boolean | undefined;
    pickedUp!: boolean | undefined;
    pickUp!: boolean | undefined;
    delivery!: boolean | undefined;

    constructor(data?: IOrderCooordinate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.initialDestinationDetailsId = data["initialDestinationDetailsId"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.lastDestinationDetailsId = data["lastDestinationDetailsId"];
            this.serviceTime = data["serviceTime"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.update = data["update"];
            this.lta = data["lta"] ? moment(data["lta"].toString()) : <any>undefined;
            this.distanceFromStart = data["distanceFromStart"];
            this.sort = data["sort"];
            this.ondemand = data["ondemand"];
            this.pickedUp = data["pickedUp"];
            this.pickUp = data["pickUp"];
            this.delivery = data["delivery"];
        }
    }

    static fromJS(data: any): OrderCooordinate {
        data = typeof data === 'object' ? data : {};
        let result = new OrderCooordinate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["initialDestinationDetailsId"] = this.initialDestinationDetailsId;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["lastDestinationDetailsId"] = this.lastDestinationDetailsId;
        data["serviceTime"] = this.serviceTime;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["update"] = this.update;
        data["lta"] = this.lta ? this.lta.toISOString() : <any>undefined;
        data["distanceFromStart"] = this.distanceFromStart;
        data["sort"] = this.sort;
        data["ondemand"] = this.ondemand;
        data["pickedUp"] = this.pickedUp;
        data["pickUp"] = this.pickUp;
        data["delivery"] = this.delivery;
        return data; 
    }
}

export interface IOrderCooordinate {
    orderId: number;
    initialDestinationDetailsId: number;
    latitude: number;
    longitude: number;
    lastDestinationDetailsId: number;
    serviceTime: number | undefined;
    time: moment.Moment | undefined;
    update: boolean | undefined;
    lta: moment.Moment | undefined;
    distanceFromStart: number | undefined;
    sort: number | undefined;
    ondemand: boolean | undefined;
    pickedUp: boolean | undefined;
    pickUp: boolean | undefined;
    delivery: boolean | undefined;
}

export class GoogleDirectionInput implements IGoogleDirectionInput {
    routeId!: number;
    startTime!: moment.Moment;
    waypoints!: OrderCooordinate[] | undefined;
    toll!: boolean;
    highway!: boolean;
    ferry!: boolean;
    indoor!: boolean;
    originLat!: number;
    originLong!: number;
    destinationLat!: number;
    destinationLong!: number;
    tenantId!: number | undefined;
    optimize!: boolean | undefined;
    traffic!: boolean | undefined;

    constructor(data?: IGoogleDirectionInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.startTime = data["startTime"] ? moment(data["startTime"].toString()) : <any>undefined;
            if (Array.isArray(data["waypoints"])) {
                this.waypoints = [] as any;
                for (let item of data["waypoints"])
                    this.waypoints!.push(OrderCooordinate.fromJS(item));
            }
            this.toll = data["toll"];
            this.highway = data["highway"];
            this.ferry = data["ferry"];
            this.indoor = data["indoor"];
            this.originLat = data["originLat"];
            this.originLong = data["originLong"];
            this.destinationLat = data["destinationLat"];
            this.destinationLong = data["destinationLong"];
            this.tenantId = data["tenantId"];
            this.optimize = data["optimize"];
            this.traffic = data["traffic"];
        }
    }

    static fromJS(data: any): GoogleDirectionInput {
        data = typeof data === 'object' ? data : {};
        let result = new GoogleDirectionInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["startTime"] = this.startTime ? this.startTime.toISOString() : <any>undefined;
        if (Array.isArray(this.waypoints)) {
            data["waypoints"] = [];
            for (let item of this.waypoints)
                data["waypoints"].push(item.toJSON());
        }
        data["toll"] = this.toll;
        data["highway"] = this.highway;
        data["ferry"] = this.ferry;
        data["indoor"] = this.indoor;
        data["originLat"] = this.originLat;
        data["originLong"] = this.originLong;
        data["destinationLat"] = this.destinationLat;
        data["destinationLong"] = this.destinationLong;
        data["tenantId"] = this.tenantId;
        data["optimize"] = this.optimize;
        data["traffic"] = this.traffic;
        return data; 
    }
}

export interface IGoogleDirectionInput {
    routeId: number;
    startTime: moment.Moment;
    waypoints: OrderCooordinate[] | undefined;
    toll: boolean;
    highway: boolean;
    ferry: boolean;
    indoor: boolean;
    originLat: number;
    originLong: number;
    destinationLat: number;
    destinationLong: number;
    tenantId: number | undefined;
    optimize: boolean | undefined;
    traffic: boolean | undefined;
}

export class WillCallReturn implements IWillCallReturn {
    eta!: moment.Moment;
    totalSecond!: number;

    constructor(data?: IWillCallReturn) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
            this.totalSecond = data["totalSecond"];
        }
    }

    static fromJS(data: any): WillCallReturn {
        data = typeof data === 'object' ? data : {};
        let result = new WillCallReturn();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        data["totalSecond"] = this.totalSecond;
        return data; 
    }
}

export interface IWillCallReturn {
    eta: moment.Moment;
    totalSecond: number;
}

export enum SelectionType {
    ALL = 0,
    ALL_EXCEPT = 1,
    ONLY = 2,
}

export class LocationNameDto implements ILocationNameDto {
    id!: number;
    name!: string | undefined;
    code!: string | undefined;
    timezone!: string | undefined;

    constructor(data?: ILocationNameDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.code = data["code"];
            this.timezone = data["timezone"];
        }
    }

    static fromJS(data: any): LocationNameDto {
        data = typeof data === 'object' ? data : {};
        let result = new LocationNameDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["code"] = this.code;
        data["timezone"] = this.timezone;
        return data; 
    }
}

export interface ILocationNameDto {
    id: number;
    name: string | undefined;
    code: string | undefined;
    timezone: string | undefined;
}

export enum ActionType {
    HOLIDAY = 0,
    UNLOCK_LOCATION = 1,
    UNFREEZE_ROUTE = 2,
}

export class RoutesForCalendarDto implements IRoutesForCalendarDto {
    id!: number;
    locationId!: number;
    locationName!: string | undefined;
    routeCode!: string | undefined;

    constructor(data?: IRoutesForCalendarDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.locationId = data["locationId"];
            this.locationName = data["locationName"];
            this.routeCode = data["routeCode"];
        }
    }

    static fromJS(data: any): RoutesForCalendarDto {
        data = typeof data === 'object' ? data : {};
        let result = new RoutesForCalendarDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["locationId"] = this.locationId;
        data["locationName"] = this.locationName;
        data["routeCode"] = this.routeCode;
        return data; 
    }
}

export interface IRoutesForCalendarDto {
    id: number;
    locationId: number;
    locationName: string | undefined;
    routeCode: string | undefined;
}

export class HolidayDto implements IHolidayDto {
    description!: string | undefined;
    isActive!: number;
    from!: moment.Moment;
    to!: moment.Moment;
    color!: string | undefined;
    code!: string | undefined;
    selectionType!: SelectionType;
    locations!: LocationNameDto[] | undefined;
    actionType!: ActionType;
    routes!: RoutesForCalendarDto[] | undefined;
    cutOffAdjustment!: number | undefined;
    id!: number;

    constructor(data?: IHolidayDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.isActive = data["isActive"];
            this.from = data["from"] ? moment(data["from"].toString()) : <any>undefined;
            this.to = data["to"] ? moment(data["to"].toString()) : <any>undefined;
            this.color = data["color"];
            this.code = data["code"];
            this.selectionType = data["selectionType"];
            if (Array.isArray(data["locations"])) {
                this.locations = [] as any;
                for (let item of data["locations"])
                    this.locations!.push(LocationNameDto.fromJS(item));
            }
            this.actionType = data["actionType"];
            if (Array.isArray(data["routes"])) {
                this.routes = [] as any;
                for (let item of data["routes"])
                    this.routes!.push(RoutesForCalendarDto.fromJS(item));
            }
            this.cutOffAdjustment = data["cutOffAdjustment"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): HolidayDto {
        data = typeof data === 'object' ? data : {};
        let result = new HolidayDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["isActive"] = this.isActive;
        data["from"] = this.from ? this.from.toISOString() : <any>undefined;
        data["to"] = this.to ? this.to.toISOString() : <any>undefined;
        data["color"] = this.color;
        data["code"] = this.code;
        data["selectionType"] = this.selectionType;
        if (Array.isArray(this.locations)) {
            data["locations"] = [];
            for (let item of this.locations)
                data["locations"].push(item.toJSON());
        }
        data["actionType"] = this.actionType;
        if (Array.isArray(this.routes)) {
            data["routes"] = [];
            for (let item of this.routes)
                data["routes"].push(item.toJSON());
        }
        data["cutOffAdjustment"] = this.cutOffAdjustment;
        data["id"] = this.id;
        return data; 
    }
}

export interface IHolidayDto {
    description: string | undefined;
    isActive: number;
    from: moment.Moment;
    to: moment.Moment;
    color: string | undefined;
    code: string | undefined;
    selectionType: SelectionType;
    locations: LocationNameDto[] | undefined;
    actionType: ActionType;
    routes: RoutesForCalendarDto[] | undefined;
    cutOffAdjustment: number | undefined;
    id: number;
}

export class GetHolidayForViewDto implements IGetHolidayForViewDto {
    holiday!: HolidayDto | undefined;

    constructor(data?: IGetHolidayForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.holiday = data["holiday"] ? HolidayDto.fromJS(data["holiday"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetHolidayForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetHolidayForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["holiday"] = this.holiday ? this.holiday.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetHolidayForViewDto {
    holiday: HolidayDto | undefined;
}

export class PagedResultDtoOfGetHolidayForViewDto implements IPagedResultDtoOfGetHolidayForViewDto {
    totalCount!: number;
    items!: GetHolidayForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetHolidayForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetHolidayForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetHolidayForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetHolidayForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetHolidayForViewDto {
    totalCount: number;
    items: GetHolidayForViewDto[] | undefined;
}

export class LocationTableListDto implements ILocationTableListDto {
    id!: number;
    name!: string | undefined;
    inActive!: boolean;
    contactId!: number | undefined;
    timeZoneId!: number | undefined;
    timeZone!: TimeZoneListDto | undefined;
    loadLimit!: number | undefined;

    constructor(data?: ILocationTableListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.inActive = data["inActive"];
            this.contactId = data["contactId"];
            this.timeZoneId = data["timeZoneId"];
            this.timeZone = data["timeZone"] ? TimeZoneListDto.fromJS(data["timeZone"]) : <any>undefined;
            this.loadLimit = data["loadLimit"];
        }
    }

    static fromJS(data: any): LocationTableListDto {
        data = typeof data === 'object' ? data : {};
        let result = new LocationTableListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["inActive"] = this.inActive;
        data["contactId"] = this.contactId;
        data["timeZoneId"] = this.timeZoneId;
        data["timeZone"] = this.timeZone ? this.timeZone.toJSON() : <any>undefined;
        data["loadLimit"] = this.loadLimit;
        return data; 
    }
}

export interface ILocationTableListDto {
    id: number;
    name: string | undefined;
    inActive: boolean;
    contactId: number | undefined;
    timeZoneId: number | undefined;
    timeZone: TimeZoneListDto | undefined;
    loadLimit: number | undefined;
}

export class CreateOrEditHolidayDto implements ICreateOrEditHolidayDto {
    description!: string;
    isActive!: number;
    from!: moment.Moment;
    to!: moment.Moment;
    color!: string;
    code!: string;
    selectionType!: SelectionType;
    actionType!: ActionType;
    cutOffAdjustment!: number | undefined;
    locationList!: LocationTableListDto[] | undefined;
    locationIds!: number[] | undefined;
    routeList!: RoutesForCalendarDto[] | undefined;
    routeIds!: number[] | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditHolidayDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.isActive = data["isActive"];
            this.from = data["from"] ? moment(data["from"].toString()) : <any>undefined;
            this.to = data["to"] ? moment(data["to"].toString()) : <any>undefined;
            this.color = data["color"];
            this.code = data["code"];
            this.selectionType = data["selectionType"];
            this.actionType = data["actionType"];
            this.cutOffAdjustment = data["cutOffAdjustment"];
            if (Array.isArray(data["locationList"])) {
                this.locationList = [] as any;
                for (let item of data["locationList"])
                    this.locationList!.push(LocationTableListDto.fromJS(item));
            }
            if (Array.isArray(data["locationIds"])) {
                this.locationIds = [] as any;
                for (let item of data["locationIds"])
                    this.locationIds!.push(item);
            }
            if (Array.isArray(data["routeList"])) {
                this.routeList = [] as any;
                for (let item of data["routeList"])
                    this.routeList!.push(RoutesForCalendarDto.fromJS(item));
            }
            if (Array.isArray(data["routeIds"])) {
                this.routeIds = [] as any;
                for (let item of data["routeIds"])
                    this.routeIds!.push(item);
            }
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditHolidayDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditHolidayDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["isActive"] = this.isActive;
        data["from"] = this.from ? this.from.toISOString() : <any>undefined;
        data["to"] = this.to ? this.to.toISOString() : <any>undefined;
        data["color"] = this.color;
        data["code"] = this.code;
        data["selectionType"] = this.selectionType;
        data["actionType"] = this.actionType;
        data["cutOffAdjustment"] = this.cutOffAdjustment;
        if (Array.isArray(this.locationList)) {
            data["locationList"] = [];
            for (let item of this.locationList)
                data["locationList"].push(item.toJSON());
        }
        if (Array.isArray(this.locationIds)) {
            data["locationIds"] = [];
            for (let item of this.locationIds)
                data["locationIds"].push(item);
        }
        if (Array.isArray(this.routeList)) {
            data["routeList"] = [];
            for (let item of this.routeList)
                data["routeList"].push(item.toJSON());
        }
        if (Array.isArray(this.routeIds)) {
            data["routeIds"] = [];
            for (let item of this.routeIds)
                data["routeIds"].push(item);
        }
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditHolidayDto {
    description: string;
    isActive: number;
    from: moment.Moment;
    to: moment.Moment;
    color: string;
    code: string;
    selectionType: SelectionType;
    actionType: ActionType;
    cutOffAdjustment: number | undefined;
    locationList: LocationTableListDto[] | undefined;
    locationIds: number[] | undefined;
    routeList: RoutesForCalendarDto[] | undefined;
    routeIds: number[] | undefined;
    id: number | undefined;
}

export class GetHolidayForEditOutput implements IGetHolidayForEditOutput {
    holiday!: CreateOrEditHolidayDto | undefined;

    constructor(data?: IGetHolidayForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.holiday = data["holiday"] ? CreateOrEditHolidayDto.fromJS(data["holiday"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetHolidayForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetHolidayForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["holiday"] = this.holiday ? this.holiday.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetHolidayForEditOutput {
    holiday: CreateOrEditHolidayDto | undefined;
}

export class GetActionTypes implements IGetActionTypes {
    id!: ActionType;
    code!: string | undefined;

    constructor(data?: IGetActionTypes) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): GetActionTypes {
        data = typeof data === 'object' ? data : {};
        let result = new GetActionTypes();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        return data; 
    }
}

export interface IGetActionTypes {
    id: ActionType;
    code: string | undefined;
}

export class PagedResultDtoOfRoutesForCalendarDto implements IPagedResultDtoOfRoutesForCalendarDto {
    totalCount!: number;
    items!: RoutesForCalendarDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRoutesForCalendarDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RoutesForCalendarDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRoutesForCalendarDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRoutesForCalendarDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRoutesForCalendarDto {
    totalCount: number;
    items: RoutesForCalendarDto[] | undefined;
}

export class TopStatsData implements ITopStatsData {
    newTenantsCount!: number;
    newSubscriptionAmount!: number;
    dashboardPlaceholder1!: number;
    dashboardPlaceholder2!: number;

    constructor(data?: ITopStatsData) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.newTenantsCount = data["newTenantsCount"];
            this.newSubscriptionAmount = data["newSubscriptionAmount"];
            this.dashboardPlaceholder1 = data["dashboardPlaceholder1"];
            this.dashboardPlaceholder2 = data["dashboardPlaceholder2"];
        }
    }

    static fromJS(data: any): TopStatsData {
        data = typeof data === 'object' ? data : {};
        let result = new TopStatsData();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["newTenantsCount"] = this.newTenantsCount;
        data["newSubscriptionAmount"] = this.newSubscriptionAmount;
        data["dashboardPlaceholder1"] = this.dashboardPlaceholder1;
        data["dashboardPlaceholder2"] = this.dashboardPlaceholder2;
        return data; 
    }
}

export interface ITopStatsData {
    newTenantsCount: number;
    newSubscriptionAmount: number;
    dashboardPlaceholder1: number;
    dashboardPlaceholder2: number;
}

export class RecentTenant implements IRecentTenant {
    id!: number;
    name!: string | undefined;
    creationTime!: moment.Moment;

    constructor(data?: IRecentTenant) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): RecentTenant {
        data = typeof data === 'object' ? data : {};
        let result = new RecentTenant();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IRecentTenant {
    id: number;
    name: string | undefined;
    creationTime: moment.Moment;
}

export class GetRecentTenantsOutput implements IGetRecentTenantsOutput {
    recentTenantsDayCount!: number;
    maxRecentTenantsShownCount!: number;
    tenantCreationStartDate!: moment.Moment;
    recentTenants!: RecentTenant[] | undefined;

    constructor(data?: IGetRecentTenantsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.recentTenantsDayCount = data["recentTenantsDayCount"];
            this.maxRecentTenantsShownCount = data["maxRecentTenantsShownCount"];
            this.tenantCreationStartDate = data["tenantCreationStartDate"] ? moment(data["tenantCreationStartDate"].toString()) : <any>undefined;
            if (Array.isArray(data["recentTenants"])) {
                this.recentTenants = [] as any;
                for (let item of data["recentTenants"])
                    this.recentTenants!.push(RecentTenant.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetRecentTenantsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRecentTenantsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["recentTenantsDayCount"] = this.recentTenantsDayCount;
        data["maxRecentTenantsShownCount"] = this.maxRecentTenantsShownCount;
        data["tenantCreationStartDate"] = this.tenantCreationStartDate ? this.tenantCreationStartDate.toISOString() : <any>undefined;
        if (Array.isArray(this.recentTenants)) {
            data["recentTenants"] = [];
            for (let item of this.recentTenants)
                data["recentTenants"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetRecentTenantsOutput {
    recentTenantsDayCount: number;
    maxRecentTenantsShownCount: number;
    tenantCreationStartDate: moment.Moment;
    recentTenants: RecentTenant[] | undefined;
}

export class ExpiringTenant implements IExpiringTenant {
    tenantName!: string | undefined;
    remainingDayCount!: number;

    constructor(data?: IExpiringTenant) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantName = data["tenantName"];
            this.remainingDayCount = data["remainingDayCount"];
        }
    }

    static fromJS(data: any): ExpiringTenant {
        data = typeof data === 'object' ? data : {};
        let result = new ExpiringTenant();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantName"] = this.tenantName;
        data["remainingDayCount"] = this.remainingDayCount;
        return data; 
    }
}

export interface IExpiringTenant {
    tenantName: string | undefined;
    remainingDayCount: number;
}

export class GetExpiringTenantsOutput implements IGetExpiringTenantsOutput {
    expiringTenants!: ExpiringTenant[] | undefined;
    subscriptionEndAlertDayCount!: number;
    maxExpiringTenantsShownCount!: number;
    subscriptionEndDateStart!: moment.Moment;
    subscriptionEndDateEnd!: moment.Moment;

    constructor(data?: IGetExpiringTenantsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["expiringTenants"])) {
                this.expiringTenants = [] as any;
                for (let item of data["expiringTenants"])
                    this.expiringTenants!.push(ExpiringTenant.fromJS(item));
            }
            this.subscriptionEndAlertDayCount = data["subscriptionEndAlertDayCount"];
            this.maxExpiringTenantsShownCount = data["maxExpiringTenantsShownCount"];
            this.subscriptionEndDateStart = data["subscriptionEndDateStart"] ? moment(data["subscriptionEndDateStart"].toString()) : <any>undefined;
            this.subscriptionEndDateEnd = data["subscriptionEndDateEnd"] ? moment(data["subscriptionEndDateEnd"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetExpiringTenantsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetExpiringTenantsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.expiringTenants)) {
            data["expiringTenants"] = [];
            for (let item of this.expiringTenants)
                data["expiringTenants"].push(item.toJSON());
        }
        data["subscriptionEndAlertDayCount"] = this.subscriptionEndAlertDayCount;
        data["maxExpiringTenantsShownCount"] = this.maxExpiringTenantsShownCount;
        data["subscriptionEndDateStart"] = this.subscriptionEndDateStart ? this.subscriptionEndDateStart.toISOString() : <any>undefined;
        data["subscriptionEndDateEnd"] = this.subscriptionEndDateEnd ? this.subscriptionEndDateEnd.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetExpiringTenantsOutput {
    expiringTenants: ExpiringTenant[] | undefined;
    subscriptionEndAlertDayCount: number;
    maxExpiringTenantsShownCount: number;
    subscriptionEndDateStart: moment.Moment;
    subscriptionEndDateEnd: moment.Moment;
}

export enum ChartDateInterval {
    Daily = 1,
    Weekly = 2,
    Monthly = 3,
}

export class IncomeStastistic implements IIncomeStastistic {
    label!: string | undefined;
    date!: moment.Moment;
    amount!: number;

    constructor(data?: IIncomeStastistic) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.label = data["label"];
            this.date = data["date"] ? moment(data["date"].toString()) : <any>undefined;
            this.amount = data["amount"];
        }
    }

    static fromJS(data: any): IncomeStastistic {
        data = typeof data === 'object' ? data : {};
        let result = new IncomeStastistic();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["label"] = this.label;
        data["date"] = this.date ? this.date.toISOString() : <any>undefined;
        data["amount"] = this.amount;
        return data; 
    }
}

export interface IIncomeStastistic {
    label: string | undefined;
    date: moment.Moment;
    amount: number;
}

export class GetIncomeStatisticsDataOutput implements IGetIncomeStatisticsDataOutput {
    incomeStatistics!: IncomeStastistic[] | undefined;

    constructor(data?: IGetIncomeStatisticsDataOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["incomeStatistics"])) {
                this.incomeStatistics = [] as any;
                for (let item of data["incomeStatistics"])
                    this.incomeStatistics!.push(IncomeStastistic.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetIncomeStatisticsDataOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetIncomeStatisticsDataOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.incomeStatistics)) {
            data["incomeStatistics"] = [];
            for (let item of this.incomeStatistics)
                data["incomeStatistics"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetIncomeStatisticsDataOutput {
    incomeStatistics: IncomeStastistic[] | undefined;
}

export class TenantEdition implements ITenantEdition {
    label!: string | undefined;
    value!: number;

    constructor(data?: ITenantEdition) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.label = data["label"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): TenantEdition {
        data = typeof data === 'object' ? data : {};
        let result = new TenantEdition();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["label"] = this.label;
        data["value"] = this.value;
        return data; 
    }
}

export interface ITenantEdition {
    label: string | undefined;
    value: number;
}

export class GetEditionTenantStatisticsOutput implements IGetEditionTenantStatisticsOutput {
    editionStatistics!: TenantEdition[] | undefined;

    constructor(data?: IGetEditionTenantStatisticsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["editionStatistics"])) {
                this.editionStatistics = [] as any;
                for (let item of data["editionStatistics"])
                    this.editionStatistics!.push(TenantEdition.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetEditionTenantStatisticsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetEditionTenantStatisticsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.editionStatistics)) {
            data["editionStatistics"] = [];
            for (let item of this.editionStatistics)
                data["editionStatistics"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetEditionTenantStatisticsOutput {
    editionStatistics: TenantEdition[] | undefined;
}

export class GeneralSettingsEditDto implements IGeneralSettingsEditDto {
    timezone!: string | undefined;
    timezoneForComparison!: string | undefined;

    constructor(data?: IGeneralSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.timezone = data["timezone"];
            this.timezoneForComparison = data["timezoneForComparison"];
        }
    }

    static fromJS(data: any): GeneralSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new GeneralSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["timezone"] = this.timezone;
        data["timezoneForComparison"] = this.timezoneForComparison;
        return data; 
    }
}

export interface IGeneralSettingsEditDto {
    timezone: string | undefined;
    timezoneForComparison: string | undefined;
}

export class SessionTimeOutSettingsEditDto implements ISessionTimeOutSettingsEditDto {
    isEnabled!: boolean;
    timeOutSecond!: number;
    showTimeOutNotificationSecond!: number;
    showLockScreenWhenTimedOut!: boolean;

    constructor(data?: ISessionTimeOutSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEnabled = data["isEnabled"];
            this.timeOutSecond = data["timeOutSecond"];
            this.showTimeOutNotificationSecond = data["showTimeOutNotificationSecond"];
            this.showLockScreenWhenTimedOut = data["showLockScreenWhenTimedOut"];
        }
    }

    static fromJS(data: any): SessionTimeOutSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new SessionTimeOutSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEnabled"] = this.isEnabled;
        data["timeOutSecond"] = this.timeOutSecond;
        data["showTimeOutNotificationSecond"] = this.showTimeOutNotificationSecond;
        data["showLockScreenWhenTimedOut"] = this.showLockScreenWhenTimedOut;
        return data; 
    }
}

export interface ISessionTimeOutSettingsEditDto {
    isEnabled: boolean;
    timeOutSecond: number;
    showTimeOutNotificationSecond: number;
    showLockScreenWhenTimedOut: boolean;
}

export class HostUserManagementSettingsEditDto implements IHostUserManagementSettingsEditDto {
    isEmailConfirmationRequiredForLogin!: boolean;
    smsVerificationEnabled!: boolean;
    isCookieConsentEnabled!: boolean;
    isQuickThemeSelectEnabled!: boolean;
    useCaptchaOnLogin!: boolean;
    sessionTimeOutSettings!: SessionTimeOutSettingsEditDto | undefined;

    constructor(data?: IHostUserManagementSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEmailConfirmationRequiredForLogin = data["isEmailConfirmationRequiredForLogin"];
            this.smsVerificationEnabled = data["smsVerificationEnabled"];
            this.isCookieConsentEnabled = data["isCookieConsentEnabled"];
            this.isQuickThemeSelectEnabled = data["isQuickThemeSelectEnabled"];
            this.useCaptchaOnLogin = data["useCaptchaOnLogin"];
            this.sessionTimeOutSettings = data["sessionTimeOutSettings"] ? SessionTimeOutSettingsEditDto.fromJS(data["sessionTimeOutSettings"]) : <any>undefined;
        }
    }

    static fromJS(data: any): HostUserManagementSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new HostUserManagementSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEmailConfirmationRequiredForLogin"] = this.isEmailConfirmationRequiredForLogin;
        data["smsVerificationEnabled"] = this.smsVerificationEnabled;
        data["isCookieConsentEnabled"] = this.isCookieConsentEnabled;
        data["isQuickThemeSelectEnabled"] = this.isQuickThemeSelectEnabled;
        data["useCaptchaOnLogin"] = this.useCaptchaOnLogin;
        data["sessionTimeOutSettings"] = this.sessionTimeOutSettings ? this.sessionTimeOutSettings.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IHostUserManagementSettingsEditDto {
    isEmailConfirmationRequiredForLogin: boolean;
    smsVerificationEnabled: boolean;
    isCookieConsentEnabled: boolean;
    isQuickThemeSelectEnabled: boolean;
    useCaptchaOnLogin: boolean;
    sessionTimeOutSettings: SessionTimeOutSettingsEditDto | undefined;
}

export class EmailSettingsEditDto implements IEmailSettingsEditDto {
    defaultFromAddress!: string | undefined;
    defaultFromDisplayName!: string | undefined;
    smtpHost!: string | undefined;
    smtpPort!: number;
    smtpUserName!: string | undefined;
    smtpPassword!: string | undefined;
    smtpDomain!: string | undefined;
    smtpEnableSsl!: boolean;
    smtpUseDefaultCredentials!: boolean;

    constructor(data?: IEmailSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.defaultFromAddress = data["defaultFromAddress"];
            this.defaultFromDisplayName = data["defaultFromDisplayName"];
            this.smtpHost = data["smtpHost"];
            this.smtpPort = data["smtpPort"];
            this.smtpUserName = data["smtpUserName"];
            this.smtpPassword = data["smtpPassword"];
            this.smtpDomain = data["smtpDomain"];
            this.smtpEnableSsl = data["smtpEnableSsl"];
            this.smtpUseDefaultCredentials = data["smtpUseDefaultCredentials"];
        }
    }

    static fromJS(data: any): EmailSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new EmailSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["defaultFromAddress"] = this.defaultFromAddress;
        data["defaultFromDisplayName"] = this.defaultFromDisplayName;
        data["smtpHost"] = this.smtpHost;
        data["smtpPort"] = this.smtpPort;
        data["smtpUserName"] = this.smtpUserName;
        data["smtpPassword"] = this.smtpPassword;
        data["smtpDomain"] = this.smtpDomain;
        data["smtpEnableSsl"] = this.smtpEnableSsl;
        data["smtpUseDefaultCredentials"] = this.smtpUseDefaultCredentials;
        return data; 
    }
}

export interface IEmailSettingsEditDto {
    defaultFromAddress: string | undefined;
    defaultFromDisplayName: string | undefined;
    smtpHost: string | undefined;
    smtpPort: number;
    smtpUserName: string | undefined;
    smtpPassword: string | undefined;
    smtpDomain: string | undefined;
    smtpEnableSsl: boolean;
    smtpUseDefaultCredentials: boolean;
}

export class TenantManagementSettingsEditDto implements ITenantManagementSettingsEditDto {
    allowSelfRegistration!: boolean;
    isNewRegisteredTenantActiveByDefault!: boolean;
    useCaptchaOnRegistration!: boolean;
    defaultEditionId!: number | undefined;

    constructor(data?: ITenantManagementSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.allowSelfRegistration = data["allowSelfRegistration"];
            this.isNewRegisteredTenantActiveByDefault = data["isNewRegisteredTenantActiveByDefault"];
            this.useCaptchaOnRegistration = data["useCaptchaOnRegistration"];
            this.defaultEditionId = data["defaultEditionId"];
        }
    }

    static fromJS(data: any): TenantManagementSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantManagementSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["allowSelfRegistration"] = this.allowSelfRegistration;
        data["isNewRegisteredTenantActiveByDefault"] = this.isNewRegisteredTenantActiveByDefault;
        data["useCaptchaOnRegistration"] = this.useCaptchaOnRegistration;
        data["defaultEditionId"] = this.defaultEditionId;
        return data; 
    }
}

export interface ITenantManagementSettingsEditDto {
    allowSelfRegistration: boolean;
    isNewRegisteredTenantActiveByDefault: boolean;
    useCaptchaOnRegistration: boolean;
    defaultEditionId: number | undefined;
}

export class PasswordComplexitySetting implements IPasswordComplexitySetting {
    requireDigit!: boolean;
    requireLowercase!: boolean;
    requireNonAlphanumeric!: boolean;
    requireUppercase!: boolean;
    requiredLength!: number;

    constructor(data?: IPasswordComplexitySetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.requireDigit = data["requireDigit"];
            this.requireLowercase = data["requireLowercase"];
            this.requireNonAlphanumeric = data["requireNonAlphanumeric"];
            this.requireUppercase = data["requireUppercase"];
            this.requiredLength = data["requiredLength"];
        }
    }

    static fromJS(data: any): PasswordComplexitySetting {
        data = typeof data === 'object' ? data : {};
        let result = new PasswordComplexitySetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["requireDigit"] = this.requireDigit;
        data["requireLowercase"] = this.requireLowercase;
        data["requireNonAlphanumeric"] = this.requireNonAlphanumeric;
        data["requireUppercase"] = this.requireUppercase;
        data["requiredLength"] = this.requiredLength;
        return data; 
    }
}

export interface IPasswordComplexitySetting {
    requireDigit: boolean;
    requireLowercase: boolean;
    requireNonAlphanumeric: boolean;
    requireUppercase: boolean;
    requiredLength: number;
}

export class UserLockOutSettingsEditDto implements IUserLockOutSettingsEditDto {
    isEnabled!: boolean;
    maxFailedAccessAttemptsBeforeLockout!: number;
    defaultAccountLockoutSeconds!: number;

    constructor(data?: IUserLockOutSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEnabled = data["isEnabled"];
            this.maxFailedAccessAttemptsBeforeLockout = data["maxFailedAccessAttemptsBeforeLockout"];
            this.defaultAccountLockoutSeconds = data["defaultAccountLockoutSeconds"];
        }
    }

    static fromJS(data: any): UserLockOutSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserLockOutSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEnabled"] = this.isEnabled;
        data["maxFailedAccessAttemptsBeforeLockout"] = this.maxFailedAccessAttemptsBeforeLockout;
        data["defaultAccountLockoutSeconds"] = this.defaultAccountLockoutSeconds;
        return data; 
    }
}

export interface IUserLockOutSettingsEditDto {
    isEnabled: boolean;
    maxFailedAccessAttemptsBeforeLockout: number;
    defaultAccountLockoutSeconds: number;
}

export class TwoFactorLoginSettingsEditDto implements ITwoFactorLoginSettingsEditDto {
    isEnabledForApplication!: boolean;
    isEnabled!: boolean;
    isEmailProviderEnabled!: boolean;
    isSmsProviderEnabled!: boolean;
    isRememberBrowserEnabled!: boolean;
    isGoogleAuthenticatorEnabled!: boolean;

    constructor(data?: ITwoFactorLoginSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEnabledForApplication = data["isEnabledForApplication"];
            this.isEnabled = data["isEnabled"];
            this.isEmailProviderEnabled = data["isEmailProviderEnabled"];
            this.isSmsProviderEnabled = data["isSmsProviderEnabled"];
            this.isRememberBrowserEnabled = data["isRememberBrowserEnabled"];
            this.isGoogleAuthenticatorEnabled = data["isGoogleAuthenticatorEnabled"];
        }
    }

    static fromJS(data: any): TwoFactorLoginSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new TwoFactorLoginSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEnabledForApplication"] = this.isEnabledForApplication;
        data["isEnabled"] = this.isEnabled;
        data["isEmailProviderEnabled"] = this.isEmailProviderEnabled;
        data["isSmsProviderEnabled"] = this.isSmsProviderEnabled;
        data["isRememberBrowserEnabled"] = this.isRememberBrowserEnabled;
        data["isGoogleAuthenticatorEnabled"] = this.isGoogleAuthenticatorEnabled;
        return data; 
    }
}

export interface ITwoFactorLoginSettingsEditDto {
    isEnabledForApplication: boolean;
    isEnabled: boolean;
    isEmailProviderEnabled: boolean;
    isSmsProviderEnabled: boolean;
    isRememberBrowserEnabled: boolean;
    isGoogleAuthenticatorEnabled: boolean;
}

export class SecuritySettingsEditDto implements ISecuritySettingsEditDto {
    allowOneConcurrentLoginPerUser!: boolean;
    useDefaultPasswordComplexitySettings!: boolean;
    passwordComplexity!: PasswordComplexitySetting | undefined;
    defaultPasswordComplexity!: PasswordComplexitySetting | undefined;
    userLockOut!: UserLockOutSettingsEditDto | undefined;
    twoFactorLogin!: TwoFactorLoginSettingsEditDto | undefined;

    constructor(data?: ISecuritySettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.allowOneConcurrentLoginPerUser = data["allowOneConcurrentLoginPerUser"];
            this.useDefaultPasswordComplexitySettings = data["useDefaultPasswordComplexitySettings"];
            this.passwordComplexity = data["passwordComplexity"] ? PasswordComplexitySetting.fromJS(data["passwordComplexity"]) : <any>undefined;
            this.defaultPasswordComplexity = data["defaultPasswordComplexity"] ? PasswordComplexitySetting.fromJS(data["defaultPasswordComplexity"]) : <any>undefined;
            this.userLockOut = data["userLockOut"] ? UserLockOutSettingsEditDto.fromJS(data["userLockOut"]) : <any>undefined;
            this.twoFactorLogin = data["twoFactorLogin"] ? TwoFactorLoginSettingsEditDto.fromJS(data["twoFactorLogin"]) : <any>undefined;
        }
    }

    static fromJS(data: any): SecuritySettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new SecuritySettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["allowOneConcurrentLoginPerUser"] = this.allowOneConcurrentLoginPerUser;
        data["useDefaultPasswordComplexitySettings"] = this.useDefaultPasswordComplexitySettings;
        data["passwordComplexity"] = this.passwordComplexity ? this.passwordComplexity.toJSON() : <any>undefined;
        data["defaultPasswordComplexity"] = this.defaultPasswordComplexity ? this.defaultPasswordComplexity.toJSON() : <any>undefined;
        data["userLockOut"] = this.userLockOut ? this.userLockOut.toJSON() : <any>undefined;
        data["twoFactorLogin"] = this.twoFactorLogin ? this.twoFactorLogin.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ISecuritySettingsEditDto {
    allowOneConcurrentLoginPerUser: boolean;
    useDefaultPasswordComplexitySettings: boolean;
    passwordComplexity: PasswordComplexitySetting | undefined;
    defaultPasswordComplexity: PasswordComplexitySetting | undefined;
    userLockOut: UserLockOutSettingsEditDto | undefined;
    twoFactorLogin: TwoFactorLoginSettingsEditDto | undefined;
}

export class HostBillingSettingsEditDto implements IHostBillingSettingsEditDto {
    legalName!: string | undefined;
    address!: string | undefined;

    constructor(data?: IHostBillingSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.legalName = data["legalName"];
            this.address = data["address"];
        }
    }

    static fromJS(data: any): HostBillingSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new HostBillingSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["legalName"] = this.legalName;
        data["address"] = this.address;
        return data; 
    }
}

export interface IHostBillingSettingsEditDto {
    legalName: string | undefined;
    address: string | undefined;
}

export class OtherSettingsEditDto implements IOtherSettingsEditDto {
    isQuickThemeSelectEnabled!: boolean;

    constructor(data?: IOtherSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isQuickThemeSelectEnabled = data["isQuickThemeSelectEnabled"];
        }
    }

    static fromJS(data: any): OtherSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new OtherSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isQuickThemeSelectEnabled"] = this.isQuickThemeSelectEnabled;
        return data; 
    }
}

export interface IOtherSettingsEditDto {
    isQuickThemeSelectEnabled: boolean;
}

export class HostSettingsEditDto implements IHostSettingsEditDto {
    general!: GeneralSettingsEditDto;
    userManagement!: HostUserManagementSettingsEditDto;
    email!: EmailSettingsEditDto;
    tenantManagement!: TenantManagementSettingsEditDto;
    security!: SecuritySettingsEditDto;
    billing!: HostBillingSettingsEditDto | undefined;
    otherSettings!: OtherSettingsEditDto | undefined;

    constructor(data?: IHostSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.general = new GeneralSettingsEditDto();
            this.userManagement = new HostUserManagementSettingsEditDto();
            this.email = new EmailSettingsEditDto();
            this.tenantManagement = new TenantManagementSettingsEditDto();
            this.security = new SecuritySettingsEditDto();
        }
    }

    init(data?: any) {
        if (data) {
            this.general = data["general"] ? GeneralSettingsEditDto.fromJS(data["general"]) : new GeneralSettingsEditDto();
            this.userManagement = data["userManagement"] ? HostUserManagementSettingsEditDto.fromJS(data["userManagement"]) : new HostUserManagementSettingsEditDto();
            this.email = data["email"] ? EmailSettingsEditDto.fromJS(data["email"]) : new EmailSettingsEditDto();
            this.tenantManagement = data["tenantManagement"] ? TenantManagementSettingsEditDto.fromJS(data["tenantManagement"]) : new TenantManagementSettingsEditDto();
            this.security = data["security"] ? SecuritySettingsEditDto.fromJS(data["security"]) : new SecuritySettingsEditDto();
            this.billing = data["billing"] ? HostBillingSettingsEditDto.fromJS(data["billing"]) : <any>undefined;
            this.otherSettings = data["otherSettings"] ? OtherSettingsEditDto.fromJS(data["otherSettings"]) : <any>undefined;
        }
    }

    static fromJS(data: any): HostSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new HostSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["general"] = this.general ? this.general.toJSON() : <any>undefined;
        data["userManagement"] = this.userManagement ? this.userManagement.toJSON() : <any>undefined;
        data["email"] = this.email ? this.email.toJSON() : <any>undefined;
        data["tenantManagement"] = this.tenantManagement ? this.tenantManagement.toJSON() : <any>undefined;
        data["security"] = this.security ? this.security.toJSON() : <any>undefined;
        data["billing"] = this.billing ? this.billing.toJSON() : <any>undefined;
        data["otherSettings"] = this.otherSettings ? this.otherSettings.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IHostSettingsEditDto {
    general: GeneralSettingsEditDto;
    userManagement: HostUserManagementSettingsEditDto;
    email: EmailSettingsEditDto;
    tenantManagement: TenantManagementSettingsEditDto;
    security: SecuritySettingsEditDto;
    billing: HostBillingSettingsEditDto | undefined;
    otherSettings: OtherSettingsEditDto | undefined;
}

export class SendTestEmailInput implements ISendTestEmailInput {
    emailAddress!: string;

    constructor(data?: ISendTestEmailInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.emailAddress = data["emailAddress"];
        }
    }

    static fromJS(data: any): SendTestEmailInput {
        data = typeof data === 'object' ? data : {};
        let result = new SendTestEmailInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["emailAddress"] = this.emailAddress;
        return data; 
    }
}

export interface ISendTestEmailInput {
    emailAddress: string;
}

export class CreateImageInput implements ICreateImageInput {
    fileName!: string | undefined;
    base64EncodedData!: string | undefined;

    constructor(data?: ICreateImageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.base64EncodedData = data["base64EncodedData"];
        }
    }

    static fromJS(data: any): CreateImageInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateImageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["base64EncodedData"] = this.base64EncodedData;
        return data; 
    }
}

export interface ICreateImageInput {
    fileName: string | undefined;
    base64EncodedData: string | undefined;
}

export class CreateImageDto implements ICreateImageDto {
    binaryObjectId!: string | undefined;

    constructor(data?: ICreateImageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.binaryObjectId = data["binaryObjectId"];
        }
    }

    static fromJS(data: any): CreateImageDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateImageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["binaryObjectId"] = this.binaryObjectId;
        return data; 
    }
}

export interface ICreateImageDto {
    binaryObjectId: string | undefined;
}

export class ImageListDto implements IImageListDto {
    id!: number;
    filename!: string | undefined;
    data!: string | undefined;

    constructor(data?: IImageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.filename = data["filename"];
            this.data = data["data"];
        }
    }

    static fromJS(data: any): ImageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["filename"] = this.filename;
        data["data"] = this.data;
        return data; 
    }
}

export interface IImageListDto {
    id: number;
    filename: string | undefined;
    data: string | undefined;
}

export class ListResultDtoOfImageListDto implements IListResultDtoOfImageListDto {
    items!: ImageListDto[] | undefined;

    constructor(data?: IListResultDtoOfImageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ImageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfImageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfImageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfImageListDto {
    items: ImageListDto[] | undefined;
}

export class UpdateImageInput implements IUpdateImageInput {
    id!: number;
    filename!: string | undefined;
    base64EncodedData!: string | undefined;

    constructor(data?: IUpdateImageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.filename = data["filename"];
            this.base64EncodedData = data["base64EncodedData"];
        }
    }

    static fromJS(data: any): UpdateImageInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateImageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["filename"] = this.filename;
        data["base64EncodedData"] = this.base64EncodedData;
        return data; 
    }
}

export interface IUpdateImageInput {
    id: number;
    filename: string | undefined;
    base64EncodedData: string | undefined;
}

export class CreateImageNoteInput implements ICreateImageNoteInput {
    imageId!: number;
    noteId!: number;

    constructor(data?: ICreateImageNoteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.imageId = data["imageId"];
            this.noteId = data["noteId"];
        }
    }

    static fromJS(data: any): CreateImageNoteInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateImageNoteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["imageId"] = this.imageId;
        data["noteId"] = this.noteId;
        return data; 
    }
}

export interface ICreateImageNoteInput {
    imageId: number;
    noteId: number;
}

export class ImageNoteListDto implements IImageNoteListDto {
    id!: number;
    tenantId!: number;
    image!: ImageListDto | undefined;
    note!: NoteListDto | undefined;

    constructor(data?: IImageNoteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.image = data["image"] ? ImageListDto.fromJS(data["image"]) : <any>undefined;
            this.note = data["note"] ? NoteListDto.fromJS(data["note"]) : <any>undefined;
        }
    }

    static fromJS(data: any): ImageNoteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImageNoteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["image"] = this.image ? this.image.toJSON() : <any>undefined;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IImageNoteListDto {
    id: number;
    tenantId: number;
    image: ImageListDto | undefined;
    note: NoteListDto | undefined;
}

export class ListResultDtoOfImageNoteListDto implements IListResultDtoOfImageNoteListDto {
    items!: ImageNoteListDto[] | undefined;

    constructor(data?: IListResultDtoOfImageNoteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ImageNoteListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfImageNoteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfImageNoteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfImageNoteListDto {
    items: ImageNoteListDto[] | undefined;
}

export class UpdateImageNoteInput implements IUpdateImageNoteInput {
    id!: number;
    imageId!: number;
    noteId!: number;

    constructor(data?: IUpdateImageNoteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.imageId = data["imageId"];
            this.noteId = data["noteId"];
        }
    }

    static fromJS(data: any): UpdateImageNoteInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateImageNoteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["imageId"] = this.imageId;
        data["noteId"] = this.noteId;
        return data; 
    }
}

export interface IUpdateImageNoteInput {
    id: number;
    imageId: number;
    noteId: number;
}

export class ImportFieldDto implements IImportFieldDto {
    fieldName!: string | undefined;
    fieldCode!: string | undefined;
    required!: boolean;
    importTableId!: number;
    id!: number;

    constructor(data?: IImportFieldDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fieldName = data["fieldName"];
            this.fieldCode = data["fieldCode"];
            this.required = data["required"];
            this.importTableId = data["importTableId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportFieldDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImportFieldDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fieldName"] = this.fieldName;
        data["fieldCode"] = this.fieldCode;
        data["required"] = this.required;
        data["importTableId"] = this.importTableId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportFieldDto {
    fieldName: string | undefined;
    fieldCode: string | undefined;
    required: boolean;
    importTableId: number;
    id: number;
}

export class GetImportFieldForViewDto implements IGetImportFieldForViewDto {
    importField!: ImportFieldDto | undefined;
    importTableTableName!: string | undefined;

    constructor(data?: IGetImportFieldForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importField = data["importField"] ? ImportFieldDto.fromJS(data["importField"]) : <any>undefined;
            this.importTableTableName = data["importTableTableName"];
        }
    }

    static fromJS(data: any): GetImportFieldForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportFieldForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importField"] = this.importField ? this.importField.toJSON() : <any>undefined;
        data["importTableTableName"] = this.importTableTableName;
        return data; 
    }
}

export interface IGetImportFieldForViewDto {
    importField: ImportFieldDto | undefined;
    importTableTableName: string | undefined;
}

export class PagedResultDtoOfGetImportFieldForViewDto implements IPagedResultDtoOfGetImportFieldForViewDto {
    totalCount!: number;
    items!: GetImportFieldForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetImportFieldForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetImportFieldForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetImportFieldForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetImportFieldForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetImportFieldForViewDto {
    totalCount: number;
    items: GetImportFieldForViewDto[] | undefined;
}

export class CreateOrEditImportFieldDto implements ICreateOrEditImportFieldDto {
    fieldName!: string;
    fieldCode!: string | undefined;
    required!: boolean;
    importTableId!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditImportFieldDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fieldName = data["fieldName"];
            this.fieldCode = data["fieldCode"];
            this.required = data["required"];
            this.importTableId = data["importTableId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditImportFieldDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditImportFieldDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fieldName"] = this.fieldName;
        data["fieldCode"] = this.fieldCode;
        data["required"] = this.required;
        data["importTableId"] = this.importTableId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditImportFieldDto {
    fieldName: string;
    fieldCode: string | undefined;
    required: boolean;
    importTableId: number;
    id: number | undefined;
}

export class GetImportFieldForEditOutput implements IGetImportFieldForEditOutput {
    importField!: CreateOrEditImportFieldDto | undefined;
    importTableTableName!: string | undefined;

    constructor(data?: IGetImportFieldForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importField = data["importField"] ? CreateOrEditImportFieldDto.fromJS(data["importField"]) : <any>undefined;
            this.importTableTableName = data["importTableTableName"];
        }
    }

    static fromJS(data: any): GetImportFieldForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportFieldForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importField"] = this.importField ? this.importField.toJSON() : <any>undefined;
        data["importTableTableName"] = this.importTableTableName;
        return data; 
    }
}

export interface IGetImportFieldForEditOutput {
    importField: CreateOrEditImportFieldDto | undefined;
    importTableTableName: string | undefined;
}

export class ImportFieldImportTableLookupTableDto implements IImportFieldImportTableLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IImportFieldImportTableLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): ImportFieldImportTableLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImportFieldImportTableLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IImportFieldImportTableLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfImportFieldImportTableLookupTableDto implements IPagedResultDtoOfImportFieldImportTableLookupTableDto {
    totalCount!: number;
    items!: ImportFieldImportTableLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfImportFieldImportTableLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ImportFieldImportTableLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfImportFieldImportTableLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfImportFieldImportTableLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfImportFieldImportTableLookupTableDto {
    totalCount: number;
    items: ImportFieldImportTableLookupTableDto[] | undefined;
}

export class ImportLogMessageDto implements IImportLogMessageDto {
    importLogId!: number;
    message!: string | undefined;
    uniqueIdentifier!: string | undefined;
    id!: number;

    constructor(data?: IImportLogMessageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importLogId = data["importLogId"];
            this.message = data["message"];
            this.uniqueIdentifier = data["uniqueIdentifier"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportLogMessageDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImportLogMessageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importLogId"] = this.importLogId;
        data["message"] = this.message;
        data["uniqueIdentifier"] = this.uniqueIdentifier;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportLogMessageDto {
    importLogId: number;
    message: string | undefined;
    uniqueIdentifier: string | undefined;
    id: number;
}

export class GetImportLogMessageForViewDto implements IGetImportLogMessageForViewDto {
    importLogMessage!: ImportLogMessageDto | undefined;

    constructor(data?: IGetImportLogMessageForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importLogMessage = data["importLogMessage"] ? ImportLogMessageDto.fromJS(data["importLogMessage"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetImportLogMessageForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportLogMessageForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importLogMessage"] = this.importLogMessage ? this.importLogMessage.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetImportLogMessageForViewDto {
    importLogMessage: ImportLogMessageDto | undefined;
}

export class PagedResultDtoOfGetImportLogMessageForViewDto implements IPagedResultDtoOfGetImportLogMessageForViewDto {
    totalCount!: number;
    items!: GetImportLogMessageForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetImportLogMessageForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetImportLogMessageForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetImportLogMessageForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetImportLogMessageForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetImportLogMessageForViewDto {
    totalCount: number;
    items: GetImportLogMessageForViewDto[] | undefined;
}

export class CreateOrEditImportLogMessageDto implements ICreateOrEditImportLogMessageDto {
    id!: number | undefined;

    constructor(data?: ICreateOrEditImportLogMessageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditImportLogMessageDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditImportLogMessageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditImportLogMessageDto {
    id: number | undefined;
}

export class GetImportLogMessageForEditOutput implements IGetImportLogMessageForEditOutput {
    importLogMessage!: CreateOrEditImportLogMessageDto | undefined;

    constructor(data?: IGetImportLogMessageForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importLogMessage = data["importLogMessage"] ? CreateOrEditImportLogMessageDto.fromJS(data["importLogMessage"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetImportLogMessageForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportLogMessageForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importLogMessage"] = this.importLogMessage ? this.importLogMessage.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetImportLogMessageForEditOutput {
    importLogMessage: CreateOrEditImportLogMessageDto | undefined;
}

export enum ImportType {
    Orders = 0,
    CallIns = 1,
    RouteSchedules = 2,
    Drivers = 3,
    Vehicles = 4,
    Clinics = 5,
    Addresses = 6,
    Fleets = 7,
    ZoneLocation = 8,
    RouteDefinition = 9,
    CustomerGroup = 10,
}

export class ImportLogDto implements IImportLogDto {
    importType!: ImportType;
    fileName!: string | undefined;
    success!: number | undefined;
    failed!: number | undefined;
    userId!: number | undefined;
    importedBy!: string | undefined;
    connectionId!: number | undefined;
    importedAt!: moment.Moment;
    orderSourceFileId!: number | undefined;
    id!: number;

    constructor(data?: IImportLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importType = data["importType"];
            this.fileName = data["fileName"];
            this.success = data["success"];
            this.failed = data["failed"];
            this.userId = data["userId"];
            this.importedBy = data["importedBy"];
            this.connectionId = data["connectionId"];
            this.importedAt = data["importedAt"] ? moment(data["importedAt"].toString()) : <any>undefined;
            this.orderSourceFileId = data["orderSourceFileId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImportLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importType"] = this.importType;
        data["fileName"] = this.fileName;
        data["success"] = this.success;
        data["failed"] = this.failed;
        data["userId"] = this.userId;
        data["importedBy"] = this.importedBy;
        data["connectionId"] = this.connectionId;
        data["importedAt"] = this.importedAt ? this.importedAt.toISOString() : <any>undefined;
        data["orderSourceFileId"] = this.orderSourceFileId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportLogDto {
    importType: ImportType;
    fileName: string | undefined;
    success: number | undefined;
    failed: number | undefined;
    userId: number | undefined;
    importedBy: string | undefined;
    connectionId: number | undefined;
    importedAt: moment.Moment;
    orderSourceFileId: number | undefined;
    id: number;
}

export class GetImportLogForViewDto implements IGetImportLogForViewDto {
    importLog!: ImportLogDto | undefined;
    messages!: string[] | undefined;

    constructor(data?: IGetImportLogForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importLog = data["importLog"] ? ImportLogDto.fromJS(data["importLog"]) : <any>undefined;
            if (Array.isArray(data["messages"])) {
                this.messages = [] as any;
                for (let item of data["messages"])
                    this.messages!.push(item);
            }
        }
    }

    static fromJS(data: any): GetImportLogForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportLogForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importLog"] = this.importLog ? this.importLog.toJSON() : <any>undefined;
        if (Array.isArray(this.messages)) {
            data["messages"] = [];
            for (let item of this.messages)
                data["messages"].push(item);
        }
        return data; 
    }
}

export interface IGetImportLogForViewDto {
    importLog: ImportLogDto | undefined;
    messages: string[] | undefined;
}

export class PagedResultDtoOfGetImportLogForViewDto implements IPagedResultDtoOfGetImportLogForViewDto {
    totalCount!: number;
    items!: GetImportLogForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetImportLogForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetImportLogForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetImportLogForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetImportLogForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetImportLogForViewDto {
    totalCount: number;
    items: GetImportLogForViewDto[] | undefined;
}

export class CreateOrEditImportLogDto implements ICreateOrEditImportLogDto {
    importType!: ImportType;
    fileName!: string;
    success!: number | undefined;
    failed!: number | undefined;
    orderSourceId!: number | undefined;
    result!: string | undefined;
    orderSourceFileId!: number | undefined;
    tenantId!: number | undefined;
    message!: ImportLogMessageDto[] | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditImportLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importType = data["importType"];
            this.fileName = data["fileName"];
            this.success = data["success"];
            this.failed = data["failed"];
            this.orderSourceId = data["orderSourceId"];
            this.result = data["result"];
            this.orderSourceFileId = data["orderSourceFileId"];
            this.tenantId = data["tenantId"];
            if (Array.isArray(data["message"])) {
                this.message = [] as any;
                for (let item of data["message"])
                    this.message!.push(ImportLogMessageDto.fromJS(item));
            }
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditImportLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditImportLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importType"] = this.importType;
        data["fileName"] = this.fileName;
        data["success"] = this.success;
        data["failed"] = this.failed;
        data["orderSourceId"] = this.orderSourceId;
        data["result"] = this.result;
        data["orderSourceFileId"] = this.orderSourceFileId;
        data["tenantId"] = this.tenantId;
        if (Array.isArray(this.message)) {
            data["message"] = [];
            for (let item of this.message)
                data["message"].push(item.toJSON());
        }
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditImportLogDto {
    importType: ImportType;
    fileName: string;
    success: number | undefined;
    failed: number | undefined;
    orderSourceId: number | undefined;
    result: string | undefined;
    orderSourceFileId: number | undefined;
    tenantId: number | undefined;
    message: ImportLogMessageDto[] | undefined;
    id: number | undefined;
}

export class GetImportLogForEditOutput implements IGetImportLogForEditOutput {
    importLog!: CreateOrEditImportLogDto | undefined;

    constructor(data?: IGetImportLogForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importLog = data["importLog"] ? CreateOrEditImportLogDto.fromJS(data["importLog"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetImportLogForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportLogForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importLog"] = this.importLog ? this.importLog.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetImportLogForEditOutput {
    importLog: CreateOrEditImportLogDto | undefined;
}

export class DownloadFileDto implements IDownloadFileDto {
    fileName!: string | undefined;
    content!: string | undefined;

    constructor(data?: IDownloadFileDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.content = data["content"];
        }
    }

    static fromJS(data: any): DownloadFileDto {
        data = typeof data === 'object' ? data : {};
        let result = new DownloadFileDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["content"] = this.content;
        return data; 
    }
}

export interface IDownloadFileDto {
    fileName: string | undefined;
    content: string | undefined;
}

export class ImportMappingDto implements IImportMappingDto {
    name!: string | undefined;
    importType!: ImportType;
    ignore!: boolean;
    column!: string | undefined;
    dataType!: DataType;
    required!: boolean;
    columnToMap!: string | undefined;
    defaultValue!: string | undefined;
    columnNo!: number;
    useCurrentDate!: boolean;
    noOfDays!: number | undefined;
    id!: number;

    constructor(data?: IImportMappingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.importType = data["importType"];
            this.ignore = data["ignore"];
            this.column = data["column"];
            this.dataType = data["dataType"];
            this.required = data["required"];
            this.columnToMap = data["columnToMap"];
            this.defaultValue = data["defaultValue"];
            this.columnNo = data["columnNo"];
            this.useCurrentDate = data["useCurrentDate"];
            this.noOfDays = data["noOfDays"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportMappingDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImportMappingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["importType"] = this.importType;
        data["ignore"] = this.ignore;
        data["column"] = this.column;
        data["dataType"] = this.dataType;
        data["required"] = this.required;
        data["columnToMap"] = this.columnToMap;
        data["defaultValue"] = this.defaultValue;
        data["columnNo"] = this.columnNo;
        data["useCurrentDate"] = this.useCurrentDate;
        data["noOfDays"] = this.noOfDays;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportMappingDto {
    name: string | undefined;
    importType: ImportType;
    ignore: boolean;
    column: string | undefined;
    dataType: DataType;
    required: boolean;
    columnToMap: string | undefined;
    defaultValue: string | undefined;
    columnNo: number;
    useCurrentDate: boolean;
    noOfDays: number | undefined;
    id: number;
}

export class GetImportMappingForViewDto implements IGetImportMappingForViewDto {
    importMapping!: ImportMappingDto | undefined;

    constructor(data?: IGetImportMappingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importMapping = data["importMapping"] ? ImportMappingDto.fromJS(data["importMapping"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetImportMappingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportMappingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importMapping"] = this.importMapping ? this.importMapping.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetImportMappingForViewDto {
    importMapping: ImportMappingDto | undefined;
}

export class PagedResultDtoOfGetImportMappingForViewDto implements IPagedResultDtoOfGetImportMappingForViewDto {
    totalCount!: number;
    items!: GetImportMappingForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetImportMappingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetImportMappingForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetImportMappingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetImportMappingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetImportMappingForViewDto {
    totalCount: number;
    items: GetImportMappingForViewDto[] | undefined;
}

export class CreateOrEditImportMappingDto implements ICreateOrEditImportMappingDto {
    name!: string;
    importType!: ImportType;
    ignore!: boolean;
    column!: string;
    dataType!: DataType;
    required!: boolean;
    columnToMap!: string;
    defaultValue!: string | undefined;
    columnNo!: number;
    useCurrentDate!: boolean;
    noOfDays!: number;
    orderSourceId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditImportMappingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.importType = data["importType"];
            this.ignore = data["ignore"];
            this.column = data["column"];
            this.dataType = data["dataType"];
            this.required = data["required"];
            this.columnToMap = data["columnToMap"];
            this.defaultValue = data["defaultValue"];
            this.columnNo = data["columnNo"];
            this.useCurrentDate = data["useCurrentDate"];
            this.noOfDays = data["noOfDays"];
            this.orderSourceId = data["orderSourceId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditImportMappingDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditImportMappingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["importType"] = this.importType;
        data["ignore"] = this.ignore;
        data["column"] = this.column;
        data["dataType"] = this.dataType;
        data["required"] = this.required;
        data["columnToMap"] = this.columnToMap;
        data["defaultValue"] = this.defaultValue;
        data["columnNo"] = this.columnNo;
        data["useCurrentDate"] = this.useCurrentDate;
        data["noOfDays"] = this.noOfDays;
        data["orderSourceId"] = this.orderSourceId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditImportMappingDto {
    name: string;
    importType: ImportType;
    ignore: boolean;
    column: string;
    dataType: DataType;
    required: boolean;
    columnToMap: string;
    defaultValue: string | undefined;
    columnNo: number;
    useCurrentDate: boolean;
    noOfDays: number;
    orderSourceId: number | undefined;
    id: number | undefined;
}

export class GetImportMappingForEditOutput implements IGetImportMappingForEditOutput {
    importMapping!: CreateOrEditImportMappingDto | undefined;

    constructor(data?: IGetImportMappingForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importMapping = data["importMapping"] ? CreateOrEditImportMappingDto.fromJS(data["importMapping"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetImportMappingForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportMappingForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importMapping"] = this.importMapping ? this.importMapping.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetImportMappingForEditOutput {
    importMapping: CreateOrEditImportMappingDto | undefined;
}

export class ImportMapDto implements IImportMapDto {
    header!: string | undefined;
    importFieldId!: number;
    id!: number;

    constructor(data?: IImportMapDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.header = data["header"];
            this.importFieldId = data["importFieldId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportMapDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImportMapDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["header"] = this.header;
        data["importFieldId"] = this.importFieldId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportMapDto {
    header: string | undefined;
    importFieldId: number;
    id: number;
}

export class GetImportMapForViewDto implements IGetImportMapForViewDto {
    importMap!: ImportMapDto | undefined;
    importFieldFieldName!: string | undefined;

    constructor(data?: IGetImportMapForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importMap = data["importMap"] ? ImportMapDto.fromJS(data["importMap"]) : <any>undefined;
            this.importFieldFieldName = data["importFieldFieldName"];
        }
    }

    static fromJS(data: any): GetImportMapForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportMapForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importMap"] = this.importMap ? this.importMap.toJSON() : <any>undefined;
        data["importFieldFieldName"] = this.importFieldFieldName;
        return data; 
    }
}

export interface IGetImportMapForViewDto {
    importMap: ImportMapDto | undefined;
    importFieldFieldName: string | undefined;
}

export class PagedResultDtoOfGetImportMapForViewDto implements IPagedResultDtoOfGetImportMapForViewDto {
    totalCount!: number;
    items!: GetImportMapForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetImportMapForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetImportMapForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetImportMapForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetImportMapForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetImportMapForViewDto {
    totalCount: number;
    items: GetImportMapForViewDto[] | undefined;
}

export class CreateOrEditImportMapDto implements ICreateOrEditImportMapDto {
    header!: string;
    importFieldId!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditImportMapDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.header = data["header"];
            this.importFieldId = data["importFieldId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditImportMapDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditImportMapDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["header"] = this.header;
        data["importFieldId"] = this.importFieldId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditImportMapDto {
    header: string;
    importFieldId: number;
    id: number | undefined;
}

export class GetImportMapForEditOutput implements IGetImportMapForEditOutput {
    importMap!: CreateOrEditImportMapDto | undefined;
    importFieldFieldName!: string | undefined;

    constructor(data?: IGetImportMapForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importMap = data["importMap"] ? CreateOrEditImportMapDto.fromJS(data["importMap"]) : <any>undefined;
            this.importFieldFieldName = data["importFieldFieldName"];
        }
    }

    static fromJS(data: any): GetImportMapForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportMapForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importMap"] = this.importMap ? this.importMap.toJSON() : <any>undefined;
        data["importFieldFieldName"] = this.importFieldFieldName;
        return data; 
    }
}

export interface IGetImportMapForEditOutput {
    importMap: CreateOrEditImportMapDto | undefined;
    importFieldFieldName: string | undefined;
}

export class ImportMapImportFieldLookupTableDto implements IImportMapImportFieldLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IImportMapImportFieldLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): ImportMapImportFieldLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImportMapImportFieldLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IImportMapImportFieldLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfImportMapImportFieldLookupTableDto implements IPagedResultDtoOfImportMapImportFieldLookupTableDto {
    totalCount!: number;
    items!: ImportMapImportFieldLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfImportMapImportFieldLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ImportMapImportFieldLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfImportMapImportFieldLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfImportMapImportFieldLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfImportMapImportFieldLookupTableDto {
    totalCount: number;
    items: ImportMapImportFieldLookupTableDto[] | undefined;
}

export class ImportTableDto implements IImportTableDto {
    tableName!: string | undefined;
    tableCode!: string | undefined;
    id!: number;

    constructor(data?: IImportTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tableName = data["tableName"];
            this.tableCode = data["tableCode"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImportTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tableName"] = this.tableName;
        data["tableCode"] = this.tableCode;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportTableDto {
    tableName: string | undefined;
    tableCode: string | undefined;
    id: number;
}

export class GetImportTableForViewDto implements IGetImportTableForViewDto {
    importTable!: ImportTableDto | undefined;

    constructor(data?: IGetImportTableForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importTable = data["importTable"] ? ImportTableDto.fromJS(data["importTable"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetImportTableForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportTableForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importTable"] = this.importTable ? this.importTable.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetImportTableForViewDto {
    importTable: ImportTableDto | undefined;
}

export class PagedResultDtoOfGetImportTableForViewDto implements IPagedResultDtoOfGetImportTableForViewDto {
    totalCount!: number;
    items!: GetImportTableForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetImportTableForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetImportTableForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetImportTableForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetImportTableForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetImportTableForViewDto {
    totalCount: number;
    items: GetImportTableForViewDto[] | undefined;
}

export class CreateOrEditImportTableDto implements ICreateOrEditImportTableDto {
    tableName!: string;
    tableCode!: string;
    id!: number | undefined;

    constructor(data?: ICreateOrEditImportTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tableName = data["tableName"];
            this.tableCode = data["tableCode"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditImportTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditImportTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tableName"] = this.tableName;
        data["tableCode"] = this.tableCode;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditImportTableDto {
    tableName: string;
    tableCode: string;
    id: number | undefined;
}

export class GetImportTableForEditOutput implements IGetImportTableForEditOutput {
    importTable!: CreateOrEditImportTableDto | undefined;

    constructor(data?: IGetImportTableForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.importTable = data["importTable"] ? CreateOrEditImportTableDto.fromJS(data["importTable"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetImportTableForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetImportTableForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["importTable"] = this.importTable ? this.importTable.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetImportTableForEditOutput {
    importTable: CreateOrEditImportTableDto | undefined;
}

export class CreateIncidentInput implements ICreateIncidentInput {
    geocodeId!: number | undefined;
    content!: string | undefined;
    incidentDate!: moment.Moment;
    managerId!: number | undefined;
    email!: string | undefined;

    constructor(data?: ICreateIncidentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.geocodeId = data["geocodeId"];
            this.content = data["content"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.managerId = data["managerId"];
            this.email = data["email"];
        }
    }

    static fromJS(data: any): CreateIncidentInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateIncidentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["geocodeId"] = this.geocodeId;
        data["content"] = this.content;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["managerId"] = this.managerId;
        data["email"] = this.email;
        return data; 
    }
}

export interface ICreateIncidentInput {
    geocodeId: number | undefined;
    content: string | undefined;
    incidentDate: moment.Moment;
    managerId: number | undefined;
    email: string | undefined;
}

export class PagedResultDtoOfIncidentListDto implements IPagedResultDtoOfIncidentListDto {
    totalCount!: number;
    items!: IncidentListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfIncidentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(IncidentListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfIncidentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfIncidentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfIncidentListDto {
    totalCount: number;
    items: IncidentListDto[] | undefined;
}

export class UpdateIncidentInput implements IUpdateIncidentInput {
    id!: number;
    geocodeId!: number | undefined;
    content!: string | undefined;
    incidentDate!: moment.Moment;

    constructor(data?: IUpdateIncidentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.geocodeId = data["geocodeId"];
            this.content = data["content"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): UpdateIncidentInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateIncidentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["geocodeId"] = this.geocodeId;
        data["content"] = this.content;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IUpdateIncidentInput {
    id: number;
    geocodeId: number | undefined;
    content: string | undefined;
    incidentDate: moment.Moment;
}

export class CreateReportInput implements ICreateReportInput {
    content!: string | undefined;
    time!: moment.Moment;
    geocode!: GeocodeListDto | undefined;

    constructor(data?: ICreateReportInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.content = data["content"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateReportInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateReportInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["content"] = this.content;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ICreateReportInput {
    content: string | undefined;
    time: moment.Moment;
    geocode: GeocodeListDto | undefined;
}

export class AddAttachmentInput implements IAddAttachmentInput {
    incidentId!: number;
    attachment!: CreateImageInput | undefined;

    constructor(data?: IAddAttachmentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentId = data["incidentId"];
            this.attachment = data["attachment"] ? CreateImageInput.fromJS(data["attachment"]) : <any>undefined;
        }
    }

    static fromJS(data: any): AddAttachmentInput {
        data = typeof data === 'object' ? data : {};
        let result = new AddAttachmentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentId"] = this.incidentId;
        data["attachment"] = this.attachment ? this.attachment.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IAddAttachmentInput {
    incidentId: number;
    attachment: CreateImageInput | undefined;
}

export class PagedIncidentList implements IPagedIncidentList {
    id!: number;
    orderNumber!: number | undefined;
    content!: string | undefined;
    incidentDate!: moment.Moment;
    lastModifiedIncidentDate!: moment.Moment | undefined;
    creationDate!: moment.Moment | undefined;
    creator!: string | undefined;
    createdDateString!: string | undefined;
    lastModifiedUser!: string | undefined;
    lastModifiedTimeString!: string | undefined;
    incidentType!: string | undefined;
    incidentStatus!: string | undefined;
    incidentTypeId!: number | undefined;
    incidentStatusId!: number | undefined;
    manager!: string | undefined;
    managerId!: number | undefined;
    incidentDateStr!: string | undefined;
    isDeleted!: boolean;
    orderType!: string | undefined;
    orderTypeColor!: string | undefined;
    incidentStatusColor!: string | undefined;

    constructor(data?: IPagedIncidentList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.orderNumber = data["orderNumber"];
            this.content = data["content"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.lastModifiedIncidentDate = data["lastModifiedIncidentDate"] ? moment(data["lastModifiedIncidentDate"].toString()) : <any>undefined;
            this.creationDate = data["creationDate"] ? moment(data["creationDate"].toString()) : <any>undefined;
            this.creator = data["creator"];
            this.createdDateString = data["createdDateString"];
            this.lastModifiedUser = data["lastModifiedUser"];
            this.lastModifiedTimeString = data["lastModifiedTimeString"];
            this.incidentType = data["incidentType"];
            this.incidentStatus = data["incidentStatus"];
            this.incidentTypeId = data["incidentTypeId"];
            this.incidentStatusId = data["incidentStatusId"];
            this.manager = data["manager"];
            this.managerId = data["managerId"];
            this.incidentDateStr = data["incidentDateStr"];
            this.isDeleted = data["isDeleted"];
            this.orderType = data["orderType"];
            this.orderTypeColor = data["orderTypeColor"];
            this.incidentStatusColor = data["incidentStatusColor"];
        }
    }

    static fromJS(data: any): PagedIncidentList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedIncidentList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["orderNumber"] = this.orderNumber;
        data["content"] = this.content;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["lastModifiedIncidentDate"] = this.lastModifiedIncidentDate ? this.lastModifiedIncidentDate.toISOString() : <any>undefined;
        data["creationDate"] = this.creationDate ? this.creationDate.toISOString() : <any>undefined;
        data["creator"] = this.creator;
        data["createdDateString"] = this.createdDateString;
        data["lastModifiedUser"] = this.lastModifiedUser;
        data["lastModifiedTimeString"] = this.lastModifiedTimeString;
        data["incidentType"] = this.incidentType;
        data["incidentStatus"] = this.incidentStatus;
        data["incidentTypeId"] = this.incidentTypeId;
        data["incidentStatusId"] = this.incidentStatusId;
        data["manager"] = this.manager;
        data["managerId"] = this.managerId;
        data["incidentDateStr"] = this.incidentDateStr;
        data["isDeleted"] = this.isDeleted;
        data["orderType"] = this.orderType;
        data["orderTypeColor"] = this.orderTypeColor;
        data["incidentStatusColor"] = this.incidentStatusColor;
        return data; 
    }
}

export interface IPagedIncidentList {
    id: number;
    orderNumber: number | undefined;
    content: string | undefined;
    incidentDate: moment.Moment;
    lastModifiedIncidentDate: moment.Moment | undefined;
    creationDate: moment.Moment | undefined;
    creator: string | undefined;
    createdDateString: string | undefined;
    lastModifiedUser: string | undefined;
    lastModifiedTimeString: string | undefined;
    incidentType: string | undefined;
    incidentStatus: string | undefined;
    incidentTypeId: number | undefined;
    incidentStatusId: number | undefined;
    manager: string | undefined;
    managerId: number | undefined;
    incidentDateStr: string | undefined;
    isDeleted: boolean;
    orderType: string | undefined;
    orderTypeColor: string | undefined;
    incidentStatusColor: string | undefined;
}

export class PagedResultDtoOfPagedIncidentList implements IPagedResultDtoOfPagedIncidentList {
    totalCount!: number;
    items!: PagedIncidentList[] | undefined;

    constructor(data?: IPagedResultDtoOfPagedIncidentList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(PagedIncidentList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfPagedIncidentList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfPagedIncidentList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfPagedIncidentList {
    totalCount: number;
    items: PagedIncidentList[] | undefined;
}

export class OrderIncidentAttachmentForUpdate implements IOrderIncidentAttachmentForUpdate {
    fileName!: string | undefined;
    data!: string | undefined;
    incidentId!: number;
    id!: number;

    constructor(data?: IOrderIncidentAttachmentForUpdate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.data = data["data"];
            this.incidentId = data["incidentId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderIncidentAttachmentForUpdate {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncidentAttachmentForUpdate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["data"] = this.data;
        data["incidentId"] = this.incidentId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderIncidentAttachmentForUpdate {
    fileName: string | undefined;
    data: string | undefined;
    incidentId: number;
    id: number;
}

export class OrderIncidentNotesForUpdate implements IOrderIncidentNotesForUpdate {
    incidentId!: number;
    notes!: string | undefined;
    creator!: string | undefined;
    dateCreated!: moment.Moment;
    id!: number;

    constructor(data?: IOrderIncidentNotesForUpdate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentId = data["incidentId"];
            this.notes = data["notes"];
            this.creator = data["creator"];
            this.dateCreated = data["dateCreated"] ? moment(data["dateCreated"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderIncidentNotesForUpdate {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncidentNotesForUpdate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentId"] = this.incidentId;
        data["notes"] = this.notes;
        data["creator"] = this.creator;
        data["dateCreated"] = this.dateCreated ? this.dateCreated.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderIncidentNotesForUpdate {
    incidentId: number;
    notes: string | undefined;
    creator: string | undefined;
    dateCreated: moment.Moment;
    id: number;
}

export class GetIncidentForUpdate implements IGetIncidentForUpdate {
    typeId!: number | undefined;
    statusId!: number | undefined;
    incidentDate!: moment.Moment;
    routeDriverString!: string | undefined;
    orderId!: number | undefined;
    managerId!: number;
    content!: string | undefined;
    orderIncidentId!: number;
    incidentId!: number;
    email!: string | undefined;
    phone!: string | undefined;
    complaint!: string | undefined;
    investigation!: string | undefined;
    resolution!: string | undefined;
    incidentSourceId!: number | undefined;
    attachments!: OrderIncidentAttachmentForUpdate[] | undefined;
    notes!: OrderIncidentNotesForUpdate[] | undefined;
    isDeleted!: boolean;

    constructor(data?: IGetIncidentForUpdate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.typeId = data["typeId"];
            this.statusId = data["statusId"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.routeDriverString = data["routeDriverString"];
            this.orderId = data["orderId"];
            this.managerId = data["managerId"];
            this.content = data["content"];
            this.orderIncidentId = data["orderIncidentId"];
            this.incidentId = data["incidentId"];
            this.email = data["email"];
            this.phone = data["phone"];
            this.complaint = data["complaint"];
            this.investigation = data["investigation"];
            this.resolution = data["resolution"];
            this.incidentSourceId = data["incidentSourceId"];
            if (Array.isArray(data["attachments"])) {
                this.attachments = [] as any;
                for (let item of data["attachments"])
                    this.attachments!.push(OrderIncidentAttachmentForUpdate.fromJS(item));
            }
            if (Array.isArray(data["notes"])) {
                this.notes = [] as any;
                for (let item of data["notes"])
                    this.notes!.push(OrderIncidentNotesForUpdate.fromJS(item));
            }
            this.isDeleted = data["isDeleted"];
        }
    }

    static fromJS(data: any): GetIncidentForUpdate {
        data = typeof data === 'object' ? data : {};
        let result = new GetIncidentForUpdate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["typeId"] = this.typeId;
        data["statusId"] = this.statusId;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["routeDriverString"] = this.routeDriverString;
        data["orderId"] = this.orderId;
        data["managerId"] = this.managerId;
        data["content"] = this.content;
        data["orderIncidentId"] = this.orderIncidentId;
        data["incidentId"] = this.incidentId;
        data["email"] = this.email;
        data["phone"] = this.phone;
        data["complaint"] = this.complaint;
        data["investigation"] = this.investigation;
        data["resolution"] = this.resolution;
        data["incidentSourceId"] = this.incidentSourceId;
        if (Array.isArray(this.attachments)) {
            data["attachments"] = [];
            for (let item of this.attachments)
                data["attachments"].push(item.toJSON());
        }
        if (Array.isArray(this.notes)) {
            data["notes"] = [];
            for (let item of this.notes)
                data["notes"].push(item.toJSON());
        }
        data["isDeleted"] = this.isDeleted;
        return data; 
    }
}

export interface IGetIncidentForUpdate {
    typeId: number | undefined;
    statusId: number | undefined;
    incidentDate: moment.Moment;
    routeDriverString: string | undefined;
    orderId: number | undefined;
    managerId: number;
    content: string | undefined;
    orderIncidentId: number;
    incidentId: number;
    email: string | undefined;
    phone: string | undefined;
    complaint: string | undefined;
    investigation: string | undefined;
    resolution: string | undefined;
    incidentSourceId: number | undefined;
    attachments: OrderIncidentAttachmentForUpdate[] | undefined;
    notes: OrderIncidentNotesForUpdate[] | undefined;
    isDeleted: boolean;
}

export class CreateAttachmentIncidentInput implements ICreateAttachmentIncidentInput {
    fileName!: string | undefined;
    base64EncodedData!: string | undefined;
    incidentId!: number;

    constructor(data?: ICreateAttachmentIncidentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.base64EncodedData = data["base64EncodedData"];
            this.incidentId = data["incidentId"];
        }
    }

    static fromJS(data: any): CreateAttachmentIncidentInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateAttachmentIncidentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["base64EncodedData"] = this.base64EncodedData;
        data["incidentId"] = this.incidentId;
        return data; 
    }
}

export interface ICreateAttachmentIncidentInput {
    fileName: string | undefined;
    base64EncodedData: string | undefined;
    incidentId: number;
}

export class CreateNoteIncidentInput implements ICreateNoteIncidentInput {
    content!: string | undefined;
    incidentId!: number;

    constructor(data?: ICreateNoteIncidentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.content = data["content"];
            this.incidentId = data["incidentId"];
        }
    }

    static fromJS(data: any): CreateNoteIncidentInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateNoteIncidentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["content"] = this.content;
        data["incidentId"] = this.incidentId;
        return data; 
    }
}

export interface ICreateNoteIncidentInput {
    content: string | undefined;
    incidentId: number;
}

export class UpdateOrderIncidentInput implements IUpdateOrderIncidentInput {
    incidentId!: number;
    managerId!: number | undefined;
    statusId!: number | undefined;
    typeId!: number | undefined;
    content!: string | undefined;
    email!: string | undefined;
    complaint!: string | undefined;
    investigation!: string | undefined;
    resolution!: string | undefined;
    incidentSourceId!: number | undefined;
    date!: moment.Moment;
    phone!: string | undefined;

    constructor(data?: IUpdateOrderIncidentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentId = data["incidentId"];
            this.managerId = data["managerId"];
            this.statusId = data["statusId"];
            this.typeId = data["typeId"];
            this.content = data["content"];
            this.email = data["email"];
            this.complaint = data["complaint"];
            this.investigation = data["investigation"];
            this.resolution = data["resolution"];
            this.incidentSourceId = data["incidentSourceId"];
            this.date = data["date"] ? moment(data["date"].toString()) : <any>undefined;
            this.phone = data["phone"];
        }
    }

    static fromJS(data: any): UpdateOrderIncidentInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderIncidentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentId"] = this.incidentId;
        data["managerId"] = this.managerId;
        data["statusId"] = this.statusId;
        data["typeId"] = this.typeId;
        data["content"] = this.content;
        data["email"] = this.email;
        data["complaint"] = this.complaint;
        data["investigation"] = this.investigation;
        data["resolution"] = this.resolution;
        data["incidentSourceId"] = this.incidentSourceId;
        data["date"] = this.date ? this.date.toISOString() : <any>undefined;
        data["phone"] = this.phone;
        return data; 
    }
}

export interface IUpdateOrderIncidentInput {
    incidentId: number;
    managerId: number | undefined;
    statusId: number | undefined;
    typeId: number | undefined;
    content: string | undefined;
    email: string | undefined;
    complaint: string | undefined;
    investigation: string | undefined;
    resolution: string | undefined;
    incidentSourceId: number | undefined;
    date: moment.Moment;
    phone: string | undefined;
}

export class CreateIncidentImageInput implements ICreateIncidentImageInput {
    binaryObjectId!: string;
    incidentId!: number;

    constructor(data?: ICreateIncidentImageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.binaryObjectId = data["binaryObjectId"];
            this.incidentId = data["incidentId"];
        }
    }

    static fromJS(data: any): CreateIncidentImageInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateIncidentImageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["binaryObjectId"] = this.binaryObjectId;
        data["incidentId"] = this.incidentId;
        return data; 
    }
}

export interface ICreateIncidentImageInput {
    binaryObjectId: string;
    incidentId: number;
}

export class IncidentImageListDto implements IIncidentImageListDto {
    id!: number;
    incidentId!: number;
    binaryObjectId!: string;

    constructor(data?: IIncidentImageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.incidentId = data["incidentId"];
            this.binaryObjectId = data["binaryObjectId"];
        }
    }

    static fromJS(data: any): IncidentImageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentImageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["incidentId"] = this.incidentId;
        data["binaryObjectId"] = this.binaryObjectId;
        return data; 
    }
}

export interface IIncidentImageListDto {
    id: number;
    incidentId: number;
    binaryObjectId: string;
}

export class PagedResultDtoOfIncidentImageListDto implements IPagedResultDtoOfIncidentImageListDto {
    totalCount!: number;
    items!: IncidentImageListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfIncidentImageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(IncidentImageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfIncidentImageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfIncidentImageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfIncidentImageListDto {
    totalCount: number;
    items: IncidentImageListDto[] | undefined;
}

export class UpdateIncidentImageInput implements IUpdateIncidentImageInput {
    id!: number;
    binaryObjectId!: string;
    incidentId!: number;

    constructor(data?: IUpdateIncidentImageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.binaryObjectId = data["binaryObjectId"];
            this.incidentId = data["incidentId"];
        }
    }

    static fromJS(data: any): UpdateIncidentImageInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateIncidentImageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["binaryObjectId"] = this.binaryObjectId;
        data["incidentId"] = this.incidentId;
        return data; 
    }
}

export interface IUpdateIncidentImageInput {
    id: number;
    binaryObjectId: string;
    incidentId: number;
}

export class IncidentSourceDto implements IIncidentSourceDto {
    name!: string | undefined;
    isActive!: boolean;
    description!: string | undefined;
    id!: number;

    constructor(data?: IIncidentSourceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentSourceDto {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentSourceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentSourceDto {
    name: string | undefined;
    isActive: boolean;
    description: string | undefined;
    id: number;
}

export class GetIncidentSourceForViewDto implements IGetIncidentSourceForViewDto {
    incidentSource!: IncidentSourceDto | undefined;

    constructor(data?: IGetIncidentSourceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentSource = data["incidentSource"] ? IncidentSourceDto.fromJS(data["incidentSource"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetIncidentSourceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetIncidentSourceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentSource"] = this.incidentSource ? this.incidentSource.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetIncidentSourceForViewDto {
    incidentSource: IncidentSourceDto | undefined;
}

export class PagedResultDtoOfGetIncidentSourceForViewDto implements IPagedResultDtoOfGetIncidentSourceForViewDto {
    totalCount!: number;
    items!: GetIncidentSourceForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetIncidentSourceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetIncidentSourceForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetIncidentSourceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetIncidentSourceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetIncidentSourceForViewDto {
    totalCount: number;
    items: GetIncidentSourceForViewDto[] | undefined;
}

export class CreateOrEditIncidentSourceDto implements ICreateOrEditIncidentSourceDto {
    name!: string | undefined;
    isActive!: boolean;
    description!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditIncidentSourceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditIncidentSourceDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditIncidentSourceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditIncidentSourceDto {
    name: string | undefined;
    isActive: boolean;
    description: string | undefined;
    id: number | undefined;
}

export class GetIncidentSourceForEditOutput implements IGetIncidentSourceForEditOutput {
    incidentSource!: CreateOrEditIncidentSourceDto | undefined;

    constructor(data?: IGetIncidentSourceForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentSource = data["incidentSource"] ? CreateOrEditIncidentSourceDto.fromJS(data["incidentSource"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetIncidentSourceForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetIncidentSourceForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentSource"] = this.incidentSource ? this.incidentSource.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetIncidentSourceForEditOutput {
    incidentSource: CreateOrEditIncidentSourceDto | undefined;
}

export class CreateOrUpdateIncidentStatusInput implements ICreateOrUpdateIncidentStatusInput {
    id!: number | undefined;
    name!: string | undefined;
    code!: string | undefined;
    static!: boolean;
    color!: string | undefined;

    constructor(data?: ICreateOrUpdateIncidentStatusInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.code = data["code"];
            this.static = data["static"];
            this.color = data["color"];
        }
    }

    static fromJS(data: any): CreateOrUpdateIncidentStatusInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateIncidentStatusInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["code"] = this.code;
        data["static"] = this.static;
        data["color"] = this.color;
        return data; 
    }
}

export interface ICreateOrUpdateIncidentStatusInput {
    id: number | undefined;
    name: string | undefined;
    code: string | undefined;
    static: boolean;
    color: string | undefined;
}

export class IncidentStatusListDto implements IIncidentStatusListDto {
    name!: string | undefined;
    code!: string | undefined;
    static!: boolean;
    color!: string | undefined;
    id!: number;

    constructor(data?: IIncidentStatusListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.static = data["static"];
            this.color = data["color"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentStatusListDto {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentStatusListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["static"] = this.static;
        data["color"] = this.color;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentStatusListDto {
    name: string | undefined;
    code: string | undefined;
    static: boolean;
    color: string | undefined;
    id: number;
}

export class PagedResultDtoOfIncidentStatusListDto implements IPagedResultDtoOfIncidentStatusListDto {
    totalCount!: number;
    items!: IncidentStatusListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfIncidentStatusListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(IncidentStatusListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfIncidentStatusListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfIncidentStatusListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfIncidentStatusListDto {
    totalCount: number;
    items: IncidentStatusListDto[] | undefined;
}

export class PagedIncidentStatusInput implements IPagedIncidentStatusInput {
    id!: number | undefined;
    filter!: string | undefined;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IPagedIncidentStatusInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.filter = data["filter"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): PagedIncidentStatusInput {
        data = typeof data === 'object' ? data : {};
        let result = new PagedIncidentStatusInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["filter"] = this.filter;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IPagedIncidentStatusInput {
    id: number | undefined;
    filter: string | undefined;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class IncidentTypeDto implements IIncidentTypeDto {
    incidentType!: string | undefined;
    sortOrder!: number;
    code!: string | undefined;
    id!: number;

    constructor(data?: IIncidentTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentType = data["incidentType"];
            this.sortOrder = data["sortOrder"];
            this.code = data["code"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentType"] = this.incidentType;
        data["sortOrder"] = this.sortOrder;
        data["code"] = this.code;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentTypeDto {
    incidentType: string | undefined;
    sortOrder: number;
    code: string | undefined;
    id: number;
}

export class GetIncidentTypeForViewDto implements IGetIncidentTypeForViewDto {
    incidentType!: IncidentTypeDto | undefined;

    constructor(data?: IGetIncidentTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentType = data["incidentType"] ? IncidentTypeDto.fromJS(data["incidentType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetIncidentTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetIncidentTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentType"] = this.incidentType ? this.incidentType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetIncidentTypeForViewDto {
    incidentType: IncidentTypeDto | undefined;
}

export class PagedResultDtoOfGetIncidentTypeForViewDto implements IPagedResultDtoOfGetIncidentTypeForViewDto {
    totalCount!: number;
    items!: GetIncidentTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetIncidentTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetIncidentTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetIncidentTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetIncidentTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetIncidentTypeForViewDto {
    totalCount: number;
    items: GetIncidentTypeForViewDto[] | undefined;
}

export class ListResultDtoOfIncidentTypeDto implements IListResultDtoOfIncidentTypeDto {
    items!: IncidentTypeDto[] | undefined;

    constructor(data?: IListResultDtoOfIncidentTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(IncidentTypeDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfIncidentTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfIncidentTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfIncidentTypeDto {
    items: IncidentTypeDto[] | undefined;
}

export class CreateOrEditIncidentTypeDto implements ICreateOrEditIncidentTypeDto {
    incidentType!: string | undefined;
    code!: string | undefined;
    sortOrder!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditIncidentTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentType = data["incidentType"];
            this.code = data["code"];
            this.sortOrder = data["sortOrder"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditIncidentTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditIncidentTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentType"] = this.incidentType;
        data["code"] = this.code;
        data["sortOrder"] = this.sortOrder;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditIncidentTypeDto {
    incidentType: string | undefined;
    code: string | undefined;
    sortOrder: number;
    id: number | undefined;
}

export class GetIncidentTypeForEditOutput implements IGetIncidentTypeForEditOutput {
    incidentType!: CreateOrEditIncidentTypeDto | undefined;

    constructor(data?: IGetIncidentTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentType = data["incidentType"] ? CreateOrEditIncidentTypeDto.fromJS(data["incidentType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetIncidentTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetIncidentTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentType"] = this.incidentType ? this.incidentType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetIncidentTypeForEditOutput {
    incidentType: CreateOrEditIncidentTypeDto | undefined;
}

export class GetAllForLookupTableInput implements IGetAllForLookupTableInput {
    filter!: string | undefined;
    id!: number | undefined;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetAllForLookupTableInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.filter = data["filter"];
            this.id = data["id"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetAllForLookupTableInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllForLookupTableInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["filter"] = this.filter;
        data["id"] = this.id;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetAllForLookupTableInput {
    filter: string | undefined;
    id: number | undefined;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class InstallDto implements IInstallDto {
    connectionString!: string;
    adminPassword!: string;
    webSiteUrl!: string;
    serverUrl!: string | undefined;
    defaultLanguage!: string;
    smtpSettings!: EmailSettingsEditDto | undefined;
    billInfo!: HostBillingSettingsEditDto | undefined;

    constructor(data?: IInstallDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.connectionString = data["connectionString"];
            this.adminPassword = data["adminPassword"];
            this.webSiteUrl = data["webSiteUrl"];
            this.serverUrl = data["serverUrl"];
            this.defaultLanguage = data["defaultLanguage"];
            this.smtpSettings = data["smtpSettings"] ? EmailSettingsEditDto.fromJS(data["smtpSettings"]) : <any>undefined;
            this.billInfo = data["billInfo"] ? HostBillingSettingsEditDto.fromJS(data["billInfo"]) : <any>undefined;
        }
    }

    static fromJS(data: any): InstallDto {
        data = typeof data === 'object' ? data : {};
        let result = new InstallDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["connectionString"] = this.connectionString;
        data["adminPassword"] = this.adminPassword;
        data["webSiteUrl"] = this.webSiteUrl;
        data["serverUrl"] = this.serverUrl;
        data["defaultLanguage"] = this.defaultLanguage;
        data["smtpSettings"] = this.smtpSettings ? this.smtpSettings.toJSON() : <any>undefined;
        data["billInfo"] = this.billInfo ? this.billInfo.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IInstallDto {
    connectionString: string;
    adminPassword: string;
    webSiteUrl: string;
    serverUrl: string | undefined;
    defaultLanguage: string;
    smtpSettings: EmailSettingsEditDto | undefined;
    billInfo: HostBillingSettingsEditDto | undefined;
}

export class NameValue implements INameValue {
    name!: string | undefined;
    value!: string | undefined;

    constructor(data?: INameValue) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): NameValue {
        data = typeof data === 'object' ? data : {};
        let result = new NameValue();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["value"] = this.value;
        return data; 
    }
}

export interface INameValue {
    name: string | undefined;
    value: string | undefined;
}

export class AppSettingsJsonDto implements IAppSettingsJsonDto {
    webSiteUrl!: string | undefined;
    serverSiteUrl!: string | undefined;
    languages!: NameValue[] | undefined;

    constructor(data?: IAppSettingsJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.webSiteUrl = data["webSiteUrl"];
            this.serverSiteUrl = data["serverSiteUrl"];
            if (Array.isArray(data["languages"])) {
                this.languages = [] as any;
                for (let item of data["languages"])
                    this.languages!.push(NameValue.fromJS(item));
            }
        }
    }

    static fromJS(data: any): AppSettingsJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new AppSettingsJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["webSiteUrl"] = this.webSiteUrl;
        data["serverSiteUrl"] = this.serverSiteUrl;
        if (Array.isArray(this.languages)) {
            data["languages"] = [];
            for (let item of this.languages)
                data["languages"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IAppSettingsJsonDto {
    webSiteUrl: string | undefined;
    serverSiteUrl: string | undefined;
    languages: NameValue[] | undefined;
}

export class CheckDatabaseOutput implements ICheckDatabaseOutput {
    isDatabaseExist!: boolean;

    constructor(data?: ICheckDatabaseOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isDatabaseExist = data["isDatabaseExist"];
        }
    }

    static fromJS(data: any): CheckDatabaseOutput {
        data = typeof data === 'object' ? data : {};
        let result = new CheckDatabaseOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isDatabaseExist"] = this.isDatabaseExist;
        return data; 
    }
}

export interface ICheckDatabaseOutput {
    isDatabaseExist: boolean;
}

export class InvoiceDto implements IInvoiceDto {
    amount!: number;
    editionDisplayName!: string | undefined;
    invoiceNo!: string | undefined;
    invoiceDate!: moment.Moment;
    tenantLegalName!: string | undefined;
    tenantAddress!: string[] | undefined;
    tenantTaxNo!: string | undefined;
    hostLegalName!: string | undefined;
    hostAddress!: string[] | undefined;

    constructor(data?: IInvoiceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.amount = data["amount"];
            this.editionDisplayName = data["editionDisplayName"];
            this.invoiceNo = data["invoiceNo"];
            this.invoiceDate = data["invoiceDate"] ? moment(data["invoiceDate"].toString()) : <any>undefined;
            this.tenantLegalName = data["tenantLegalName"];
            if (Array.isArray(data["tenantAddress"])) {
                this.tenantAddress = [] as any;
                for (let item of data["tenantAddress"])
                    this.tenantAddress!.push(item);
            }
            this.tenantTaxNo = data["tenantTaxNo"];
            this.hostLegalName = data["hostLegalName"];
            if (Array.isArray(data["hostAddress"])) {
                this.hostAddress = [] as any;
                for (let item of data["hostAddress"])
                    this.hostAddress!.push(item);
            }
        }
    }

    static fromJS(data: any): InvoiceDto {
        data = typeof data === 'object' ? data : {};
        let result = new InvoiceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["amount"] = this.amount;
        data["editionDisplayName"] = this.editionDisplayName;
        data["invoiceNo"] = this.invoiceNo;
        data["invoiceDate"] = this.invoiceDate ? this.invoiceDate.toISOString() : <any>undefined;
        data["tenantLegalName"] = this.tenantLegalName;
        if (Array.isArray(this.tenantAddress)) {
            data["tenantAddress"] = [];
            for (let item of this.tenantAddress)
                data["tenantAddress"].push(item);
        }
        data["tenantTaxNo"] = this.tenantTaxNo;
        data["hostLegalName"] = this.hostLegalName;
        if (Array.isArray(this.hostAddress)) {
            data["hostAddress"] = [];
            for (let item of this.hostAddress)
                data["hostAddress"].push(item);
        }
        return data; 
    }
}

export interface IInvoiceDto {
    amount: number;
    editionDisplayName: string | undefined;
    invoiceNo: string | undefined;
    invoiceDate: moment.Moment;
    tenantLegalName: string | undefined;
    tenantAddress: string[] | undefined;
    tenantTaxNo: string | undefined;
    hostLegalName: string | undefined;
    hostAddress: string[] | undefined;
}

export class CreateInvoiceDto implements ICreateInvoiceDto {
    subscriptionPaymentId!: number;

    constructor(data?: ICreateInvoiceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.subscriptionPaymentId = data["subscriptionPaymentId"];
        }
    }

    static fromJS(data: any): CreateInvoiceDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateInvoiceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["subscriptionPaymentId"] = this.subscriptionPaymentId;
        return data; 
    }
}

export interface ICreateInvoiceDto {
    subscriptionPaymentId: number;
}

export class SetOrderPackageInputItem implements ISetOrderPackageInputItem {
    type!: number;
    quantity!: number;

    constructor(data?: ISetOrderPackageInputItem) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.type = data["type"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): SetOrderPackageInputItem {
        data = typeof data === 'object' ? data : {};
        let result = new SetOrderPackageInputItem();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["type"] = this.type;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface ISetOrderPackageInputItem {
    type: number;
    quantity: number;
}

export class SetOrderExtraInputItem implements ISetOrderExtraInputItem {
    type!: string | undefined;
    value!: string | undefined;

    constructor(data?: ISetOrderExtraInputItem) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.type = data["type"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): SetOrderExtraInputItem {
        data = typeof data === 'object' ? data : {};
        let result = new SetOrderExtraInputItem();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["type"] = this.type;
        data["value"] = this.value;
        return data; 
    }
}

export interface ISetOrderExtraInputItem {
    type: string | undefined;
    value: string | undefined;
}

export class CreateLaboratoryDeliveryInput implements ICreateLaboratoryDeliveryInput {
    orderId!: number;
    packages!: SetOrderPackageInputItem[] | undefined;
    extras!: SetOrderExtraInputItem[] | undefined;
    geocode!: CreateGeocodeInput | undefined;
    time!: moment.Moment;
    note!: string | undefined;

    constructor(data?: ICreateLaboratoryDeliveryInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            if (Array.isArray(data["packages"])) {
                this.packages = [] as any;
                for (let item of data["packages"])
                    this.packages!.push(SetOrderPackageInputItem.fromJS(item));
            }
            if (Array.isArray(data["extras"])) {
                this.extras = [] as any;
                for (let item of data["extras"])
                    this.extras!.push(SetOrderExtraInputItem.fromJS(item));
            }
            this.geocode = data["geocode"] ? CreateGeocodeInput.fromJS(data["geocode"]) : <any>undefined;
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.note = data["note"];
        }
    }

    static fromJS(data: any): CreateLaboratoryDeliveryInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateLaboratoryDeliveryInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        if (Array.isArray(this.packages)) {
            data["packages"] = [];
            for (let item of this.packages)
                data["packages"].push(item.toJSON());
        }
        if (Array.isArray(this.extras)) {
            data["extras"] = [];
            for (let item of this.extras)
                data["extras"].push(item.toJSON());
        }
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["note"] = this.note;
        return data; 
    }
}

export interface ICreateLaboratoryDeliveryInput {
    orderId: number;
    packages: SetOrderPackageInputItem[] | undefined;
    extras: SetOrderExtraInputItem[] | undefined;
    geocode: CreateGeocodeInput | undefined;
    time: moment.Moment;
    note: string | undefined;
}

export class LaboratoryDeliveryItems implements ILaboratoryDeliveryItems {
    items!: CreateLaboratoryDeliveryInput[] | undefined;

    constructor(data?: ILaboratoryDeliveryItems) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(CreateLaboratoryDeliveryInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): LaboratoryDeliveryItems {
        data = typeof data === 'object' ? data : {};
        let result = new LaboratoryDeliveryItems();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ILaboratoryDeliveryItems {
    items: CreateLaboratoryDeliveryInput[] | undefined;
}

export class CreateLaboratoryPickupInput implements ICreateLaboratoryPickupInput {
    orderId!: number;
    items!: SetOrderPackageInputItem[] | undefined;
    extras!: SetOrderExtraInputItem[] | undefined;
    geocode!: CreateGeocodeInput | undefined;
    time!: moment.Moment;
    note!: string | undefined;

    constructor(data?: ICreateLaboratoryPickupInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SetOrderPackageInputItem.fromJS(item));
            }
            if (Array.isArray(data["extras"])) {
                this.extras = [] as any;
                for (let item of data["extras"])
                    this.extras!.push(SetOrderExtraInputItem.fromJS(item));
            }
            this.geocode = data["geocode"] ? CreateGeocodeInput.fromJS(data["geocode"]) : <any>undefined;
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.note = data["note"];
        }
    }

    static fromJS(data: any): CreateLaboratoryPickupInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateLaboratoryPickupInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        if (Array.isArray(this.extras)) {
            data["extras"] = [];
            for (let item of this.extras)
                data["extras"].push(item.toJSON());
        }
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["note"] = this.note;
        return data; 
    }
}

export interface ICreateLaboratoryPickupInput {
    orderId: number;
    items: SetOrderPackageInputItem[] | undefined;
    extras: SetOrderExtraInputItem[] | undefined;
    geocode: CreateGeocodeInput | undefined;
    time: moment.Moment;
    note: string | undefined;
}

export class ApplicationLanguageListDto implements IApplicationLanguageListDto {
    tenantId!: number | undefined;
    name!: string | undefined;
    displayName!: string | undefined;
    icon!: string | undefined;
    isDisabled!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IApplicationLanguageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.icon = data["icon"];
            this.isDisabled = data["isDisabled"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ApplicationLanguageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ApplicationLanguageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["icon"] = this.icon;
        data["isDisabled"] = this.isDisabled;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IApplicationLanguageListDto {
    tenantId: number | undefined;
    name: string | undefined;
    displayName: string | undefined;
    icon: string | undefined;
    isDisabled: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class GetLanguagesOutput implements IGetLanguagesOutput {
    defaultLanguageName!: string | undefined;
    items!: ApplicationLanguageListDto[] | undefined;

    constructor(data?: IGetLanguagesOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.defaultLanguageName = data["defaultLanguageName"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ApplicationLanguageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetLanguagesOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetLanguagesOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["defaultLanguageName"] = this.defaultLanguageName;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetLanguagesOutput {
    defaultLanguageName: string | undefined;
    items: ApplicationLanguageListDto[] | undefined;
}

export class ApplicationLanguageEditDto implements IApplicationLanguageEditDto {
    id!: number | undefined;
    name!: string;
    icon!: string | undefined;
    isEnabled!: boolean;

    constructor(data?: IApplicationLanguageEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.icon = data["icon"];
            this.isEnabled = data["isEnabled"];
        }
    }

    static fromJS(data: any): ApplicationLanguageEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new ApplicationLanguageEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["icon"] = this.icon;
        data["isEnabled"] = this.isEnabled;
        return data; 
    }
}

export interface IApplicationLanguageEditDto {
    id: number | undefined;
    name: string;
    icon: string | undefined;
    isEnabled: boolean;
}

export class ComboboxItemDto implements IComboboxItemDto {
    value!: string | undefined;
    displayText!: string | undefined;
    isSelected!: boolean;

    constructor(data?: IComboboxItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.displayText = data["displayText"];
            this.isSelected = data["isSelected"];
        }
    }

    static fromJS(data: any): ComboboxItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ComboboxItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["displayText"] = this.displayText;
        data["isSelected"] = this.isSelected;
        return data; 
    }
}

export interface IComboboxItemDto {
    value: string | undefined;
    displayText: string | undefined;
    isSelected: boolean;
}

export class GetLanguageForEditOutput implements IGetLanguageForEditOutput {
    language!: ApplicationLanguageEditDto | undefined;
    languageNames!: ComboboxItemDto[] | undefined;
    flags!: ComboboxItemDto[] | undefined;

    constructor(data?: IGetLanguageForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.language = data["language"] ? ApplicationLanguageEditDto.fromJS(data["language"]) : <any>undefined;
            if (Array.isArray(data["languageNames"])) {
                this.languageNames = [] as any;
                for (let item of data["languageNames"])
                    this.languageNames!.push(ComboboxItemDto.fromJS(item));
            }
            if (Array.isArray(data["flags"])) {
                this.flags = [] as any;
                for (let item of data["flags"])
                    this.flags!.push(ComboboxItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetLanguageForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetLanguageForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["language"] = this.language ? this.language.toJSON() : <any>undefined;
        if (Array.isArray(this.languageNames)) {
            data["languageNames"] = [];
            for (let item of this.languageNames)
                data["languageNames"].push(item.toJSON());
        }
        if (Array.isArray(this.flags)) {
            data["flags"] = [];
            for (let item of this.flags)
                data["flags"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetLanguageForEditOutput {
    language: ApplicationLanguageEditDto | undefined;
    languageNames: ComboboxItemDto[] | undefined;
    flags: ComboboxItemDto[] | undefined;
}

export class CreateOrUpdateLanguageInput implements ICreateOrUpdateLanguageInput {
    language!: ApplicationLanguageEditDto;

    constructor(data?: ICreateOrUpdateLanguageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.language = new ApplicationLanguageEditDto();
        }
    }

    init(data?: any) {
        if (data) {
            this.language = data["language"] ? ApplicationLanguageEditDto.fromJS(data["language"]) : new ApplicationLanguageEditDto();
        }
    }

    static fromJS(data: any): CreateOrUpdateLanguageInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateLanguageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["language"] = this.language ? this.language.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ICreateOrUpdateLanguageInput {
    language: ApplicationLanguageEditDto;
}

export class SetDefaultLanguageInput implements ISetDefaultLanguageInput {
    name!: string;

    constructor(data?: ISetDefaultLanguageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): SetDefaultLanguageInput {
        data = typeof data === 'object' ? data : {};
        let result = new SetDefaultLanguageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface ISetDefaultLanguageInput {
    name: string;
}

export class LanguageTextListDto implements ILanguageTextListDto {
    key!: string | undefined;
    baseValue!: string | undefined;
    targetValue!: string | undefined;

    constructor(data?: ILanguageTextListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.key = data["key"];
            this.baseValue = data["baseValue"];
            this.targetValue = data["targetValue"];
        }
    }

    static fromJS(data: any): LanguageTextListDto {
        data = typeof data === 'object' ? data : {};
        let result = new LanguageTextListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["key"] = this.key;
        data["baseValue"] = this.baseValue;
        data["targetValue"] = this.targetValue;
        return data; 
    }
}

export interface ILanguageTextListDto {
    key: string | undefined;
    baseValue: string | undefined;
    targetValue: string | undefined;
}

export class PagedResultDtoOfLanguageTextListDto implements IPagedResultDtoOfLanguageTextListDto {
    totalCount!: number;
    items!: LanguageTextListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfLanguageTextListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(LanguageTextListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfLanguageTextListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfLanguageTextListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfLanguageTextListDto {
    totalCount: number;
    items: LanguageTextListDto[] | undefined;
}

export class UpdateLanguageTextInput implements IUpdateLanguageTextInput {
    languageName!: string;
    sourceName!: string;
    key!: string;
    value!: string;

    constructor(data?: IUpdateLanguageTextInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.languageName = data["languageName"];
            this.sourceName = data["sourceName"];
            this.key = data["key"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): UpdateLanguageTextInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateLanguageTextInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["languageName"] = this.languageName;
        data["sourceName"] = this.sourceName;
        data["key"] = this.key;
        data["value"] = this.value;
        return data; 
    }
}

export interface IUpdateLanguageTextInput {
    languageName: string;
    sourceName: string;
    key: string;
    value: string;
}

export class Coordinates implements ICoordinates {
    latitude!: string | undefined;
    longitude!: string | undefined;

    constructor(data?: ICoordinates) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): Coordinates {
        data = typeof data === 'object' ? data : {};
        let result = new Coordinates();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface ICoordinates {
    latitude: string | undefined;
    longitude: string | undefined;
}

export class CreateLocationContactInput implements ICreateLocationContactInput {
    contact!: CreateContactAddressInput | undefined;
    timeZoneId!: number;
    userId!: number | undefined;
    name!: string | undefined;
    code!: string | undefined;
    minutesPerMile!: number;
    minutesPerStop!: number;
    goBackTimeWindow!: number | undefined;
    leadTime!: number | undefined;
    etaRoundUp!: number | undefined;
    loadLimit!: number | undefined;
    distanceAdjustment!: DistanceInputApi[] | undefined;
    trafficAdjustment!: TrafficInputApi[] | undefined;
    inActive!: boolean;
    postalCodeRegEx!: string | undefined;
    driverInActiveThreshold!: number | undefined;
    generationType!: LocationGenerationTypeEnum | undefined;
    generationTime!: string | undefined;

    constructor(data?: ICreateLocationContactInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contact = data["contact"] ? CreateContactAddressInput.fromJS(data["contact"]) : <any>undefined;
            this.timeZoneId = data["timeZoneId"];
            this.userId = data["userId"];
            this.name = data["name"];
            this.code = data["code"];
            this.minutesPerMile = data["minutesPerMile"];
            this.minutesPerStop = data["minutesPerStop"];
            this.goBackTimeWindow = data["goBackTimeWindow"];
            this.leadTime = data["leadTime"];
            this.etaRoundUp = data["etaRoundUp"];
            this.loadLimit = data["loadLimit"];
            if (Array.isArray(data["distanceAdjustment"])) {
                this.distanceAdjustment = [] as any;
                for (let item of data["distanceAdjustment"])
                    this.distanceAdjustment!.push(DistanceInputApi.fromJS(item));
            }
            if (Array.isArray(data["trafficAdjustment"])) {
                this.trafficAdjustment = [] as any;
                for (let item of data["trafficAdjustment"])
                    this.trafficAdjustment!.push(TrafficInputApi.fromJS(item));
            }
            this.inActive = data["inActive"];
            this.postalCodeRegEx = data["postalCodeRegEx"];
            this.driverInActiveThreshold = data["driverInActiveThreshold"];
            this.generationType = data["generationType"];
            this.generationTime = data["generationTime"];
        }
    }

    static fromJS(data: any): CreateLocationContactInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateLocationContactInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["timeZoneId"] = this.timeZoneId;
        data["userId"] = this.userId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["minutesPerMile"] = this.minutesPerMile;
        data["minutesPerStop"] = this.minutesPerStop;
        data["goBackTimeWindow"] = this.goBackTimeWindow;
        data["leadTime"] = this.leadTime;
        data["etaRoundUp"] = this.etaRoundUp;
        data["loadLimit"] = this.loadLimit;
        if (Array.isArray(this.distanceAdjustment)) {
            data["distanceAdjustment"] = [];
            for (let item of this.distanceAdjustment)
                data["distanceAdjustment"].push(item.toJSON());
        }
        if (Array.isArray(this.trafficAdjustment)) {
            data["trafficAdjustment"] = [];
            for (let item of this.trafficAdjustment)
                data["trafficAdjustment"].push(item.toJSON());
        }
        data["inActive"] = this.inActive;
        data["postalCodeRegEx"] = this.postalCodeRegEx;
        data["driverInActiveThreshold"] = this.driverInActiveThreshold;
        data["generationType"] = this.generationType;
        data["generationTime"] = this.generationTime;
        return data; 
    }
}

export interface ICreateLocationContactInput {
    contact: CreateContactAddressInput | undefined;
    timeZoneId: number;
    userId: number | undefined;
    name: string | undefined;
    code: string | undefined;
    minutesPerMile: number;
    minutesPerStop: number;
    goBackTimeWindow: number | undefined;
    leadTime: number | undefined;
    etaRoundUp: number | undefined;
    loadLimit: number | undefined;
    distanceAdjustment: DistanceInputApi[] | undefined;
    trafficAdjustment: TrafficInputApi[] | undefined;
    inActive: boolean;
    postalCodeRegEx: string | undefined;
    driverInActiveThreshold: number | undefined;
    generationType: LocationGenerationTypeEnum | undefined;
    generationTime: string | undefined;
}

export class CreateLocationInput implements ICreateLocationInput {
    contactId!: number | undefined;
    timeZoneId!: number | undefined;
    userId!: number | undefined;
    name!: string | undefined;
    code!: string | undefined;
    minutesPerMile!: number;
    minutesPerStop!: number;
    loadLimit!: number | undefined;
    leadTime!: number | undefined;
    etaRoundUp!: number | undefined;
    goBackTimeWindow!: number | undefined;
    inActive!: boolean;
    postalCodeRegEx!: string | undefined;
    driverInActiveThreshold!: number | undefined;
    generationTime!: TimeSpan;
    generationType!: LocationGenerationTypeEnum | undefined;

    constructor(data?: ICreateLocationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.timeZoneId = data["timeZoneId"];
            this.userId = data["userId"];
            this.name = data["name"];
            this.code = data["code"];
            this.minutesPerMile = data["minutesPerMile"];
            this.minutesPerStop = data["minutesPerStop"];
            this.loadLimit = data["loadLimit"];
            this.leadTime = data["leadTime"];
            this.etaRoundUp = data["etaRoundUp"];
            this.goBackTimeWindow = data["goBackTimeWindow"];
            this.inActive = data["inActive"];
            this.postalCodeRegEx = data["postalCodeRegEx"];
            this.driverInActiveThreshold = data["driverInActiveThreshold"];
            this.generationTime = data["generationTime"] ? TimeSpan.fromJS(data["generationTime"]) : <any>undefined;
            this.generationType = data["generationType"];
        }
    }

    static fromJS(data: any): CreateLocationInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateLocationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["timeZoneId"] = this.timeZoneId;
        data["userId"] = this.userId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["minutesPerMile"] = this.minutesPerMile;
        data["minutesPerStop"] = this.minutesPerStop;
        data["loadLimit"] = this.loadLimit;
        data["leadTime"] = this.leadTime;
        data["etaRoundUp"] = this.etaRoundUp;
        data["goBackTimeWindow"] = this.goBackTimeWindow;
        data["inActive"] = this.inActive;
        data["postalCodeRegEx"] = this.postalCodeRegEx;
        data["driverInActiveThreshold"] = this.driverInActiveThreshold;
        data["generationTime"] = this.generationTime ? this.generationTime.toJSON() : <any>undefined;
        data["generationType"] = this.generationType;
        return data; 
    }
}

export interface ICreateLocationInput {
    contactId: number | undefined;
    timeZoneId: number | undefined;
    userId: number | undefined;
    name: string | undefined;
    code: string | undefined;
    minutesPerMile: number;
    minutesPerStop: number;
    loadLimit: number | undefined;
    leadTime: number | undefined;
    etaRoundUp: number | undefined;
    goBackTimeWindow: number | undefined;
    inActive: boolean;
    postalCodeRegEx: string | undefined;
    driverInActiveThreshold: number | undefined;
    generationTime: TimeSpan;
    generationType: LocationGenerationTypeEnum | undefined;
}

export class MarketListDto implements IMarketListDto {
    timezone!: string | undefined;
    timezoonId!: number;
    offset!: string | undefined;
    locationInActive!: boolean;

    constructor(data?: IMarketListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.timezone = data["timezone"];
            this.timezoonId = data["timezoonId"];
            this.offset = data["offset"];
            this.locationInActive = data["locationInActive"];
        }
    }

    static fromJS(data: any): MarketListDto {
        data = typeof data === 'object' ? data : {};
        let result = new MarketListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["timezone"] = this.timezone;
        data["timezoonId"] = this.timezoonId;
        data["offset"] = this.offset;
        data["locationInActive"] = this.locationInActive;
        return data; 
    }
}

export interface IMarketListDto {
    timezone: string | undefined;
    timezoonId: number;
    offset: string | undefined;
    locationInActive: boolean;
}

export class PagedResultDtoOfLocationListDto implements IPagedResultDtoOfLocationListDto {
    totalCount!: number;
    items!: LocationListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfLocationListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(LocationListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfLocationListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfLocationListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfLocationListDto {
    totalCount: number;
    items: LocationListDto[] | undefined;
}

export class UpdateLocationInput implements IUpdateLocationInput {
    id!: number;
    contactId!: number | undefined;
    timeZoneId!: number | undefined;
    userId!: number | undefined;
    name!: string | undefined;
    minutesPerMile!: number;
    minutesPerStop!: number;
    loadLimit!: number | undefined;
    leadTime!: number | undefined;
    etaRoundUp!: number | undefined;
    goBackTimeWindow!: number | undefined;
    distanceAdjustment!: DistanceInputApi[] | undefined;
    trafficAdjustment!: TrafficInputApi[] | undefined;
    inActive!: boolean;
    generationTime!: string | undefined;
    generationType!: LocationGenerationTypeEnum | undefined;
    postalCodeRegEx!: string | undefined;
    driverInActiveThreshold!: number | undefined;
    code!: string | undefined;

    constructor(data?: IUpdateLocationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contactId = data["contactId"];
            this.timeZoneId = data["timeZoneId"];
            this.userId = data["userId"];
            this.name = data["name"];
            this.minutesPerMile = data["minutesPerMile"];
            this.minutesPerStop = data["minutesPerStop"];
            this.loadLimit = data["loadLimit"];
            this.leadTime = data["leadTime"];
            this.etaRoundUp = data["etaRoundUp"];
            this.goBackTimeWindow = data["goBackTimeWindow"];
            if (Array.isArray(data["distanceAdjustment"])) {
                this.distanceAdjustment = [] as any;
                for (let item of data["distanceAdjustment"])
                    this.distanceAdjustment!.push(DistanceInputApi.fromJS(item));
            }
            if (Array.isArray(data["trafficAdjustment"])) {
                this.trafficAdjustment = [] as any;
                for (let item of data["trafficAdjustment"])
                    this.trafficAdjustment!.push(TrafficInputApi.fromJS(item));
            }
            this.inActive = data["inActive"];
            this.generationTime = data["generationTime"];
            this.generationType = data["generationType"];
            this.postalCodeRegEx = data["postalCodeRegEx"];
            this.driverInActiveThreshold = data["driverInActiveThreshold"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): UpdateLocationInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateLocationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contactId"] = this.contactId;
        data["timeZoneId"] = this.timeZoneId;
        data["userId"] = this.userId;
        data["name"] = this.name;
        data["minutesPerMile"] = this.minutesPerMile;
        data["minutesPerStop"] = this.minutesPerStop;
        data["loadLimit"] = this.loadLimit;
        data["leadTime"] = this.leadTime;
        data["etaRoundUp"] = this.etaRoundUp;
        data["goBackTimeWindow"] = this.goBackTimeWindow;
        if (Array.isArray(this.distanceAdjustment)) {
            data["distanceAdjustment"] = [];
            for (let item of this.distanceAdjustment)
                data["distanceAdjustment"].push(item.toJSON());
        }
        if (Array.isArray(this.trafficAdjustment)) {
            data["trafficAdjustment"] = [];
            for (let item of this.trafficAdjustment)
                data["trafficAdjustment"].push(item.toJSON());
        }
        data["inActive"] = this.inActive;
        data["generationTime"] = this.generationTime;
        data["generationType"] = this.generationType;
        data["postalCodeRegEx"] = this.postalCodeRegEx;
        data["driverInActiveThreshold"] = this.driverInActiveThreshold;
        data["code"] = this.code;
        return data; 
    }
}

export interface IUpdateLocationInput {
    id: number;
    contactId: number | undefined;
    timeZoneId: number | undefined;
    userId: number | undefined;
    name: string | undefined;
    minutesPerMile: number;
    minutesPerStop: number;
    loadLimit: number | undefined;
    leadTime: number | undefined;
    etaRoundUp: number | undefined;
    goBackTimeWindow: number | undefined;
    distanceAdjustment: DistanceInputApi[] | undefined;
    trafficAdjustment: TrafficInputApi[] | undefined;
    inActive: boolean;
    generationTime: string | undefined;
    generationType: LocationGenerationTypeEnum | undefined;
    postalCodeRegEx: string | undefined;
    driverInActiveThreshold: number | undefined;
    code: string | undefined;
}

export class GetLocationNamesInputPage implements IGetLocationNamesInputPage {
    id!: number | undefined;
    filter!: string | undefined;
    nameFilter!: string | undefined;
    timeZoneFilter!: string | undefined;
    inActiveFilter!: boolean;
    loadLimit!: number | undefined;
    maxResultCount!: number;
    skipCount!: number;

    constructor(data?: IGetLocationNamesInputPage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.filter = data["filter"];
            this.nameFilter = data["nameFilter"];
            this.timeZoneFilter = data["timeZoneFilter"];
            this.inActiveFilter = data["inActiveFilter"];
            this.loadLimit = data["loadLimit"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
        }
    }

    static fromJS(data: any): GetLocationNamesInputPage {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationNamesInputPage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["filter"] = this.filter;
        data["nameFilter"] = this.nameFilter;
        data["timeZoneFilter"] = this.timeZoneFilter;
        data["inActiveFilter"] = this.inActiveFilter;
        data["loadLimit"] = this.loadLimit;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        return data; 
    }
}

export interface IGetLocationNamesInputPage {
    id: number | undefined;
    filter: string | undefined;
    nameFilter: string | undefined;
    timeZoneFilter: string | undefined;
    inActiveFilter: boolean;
    loadLimit: number | undefined;
    maxResultCount: number;
    skipCount: number;
}

export class PostalCodeZoneRegexListDto implements IPostalCodeZoneRegexListDto {
    name!: string | undefined;

    constructor(data?: IPostalCodeZoneRegexListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): PostalCodeZoneRegexListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PostalCodeZoneRegexListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface IPostalCodeZoneRegexListDto {
    name: string | undefined;
}

export class GetLocationLockDto implements IGetLocationLockDto {
    id!: number;
    lock!: boolean;
    name!: string | undefined;
    unlockBy!: string | undefined;
    unlockReason!: string | undefined;
    unlockDate!: moment.Moment | undefined;
    unlockFrom!: string | undefined;
    unlockTo!: string | undefined;
    dateUnlock!: string | undefined;
    cuttOffAddMinutes!: number | undefined;
    cuttOffAddHours!: number | undefined;
    isShowToday!: boolean;

    constructor(data?: IGetLocationLockDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.lock = data["lock"];
            this.name = data["name"];
            this.unlockBy = data["unlockBy"];
            this.unlockReason = data["unlockReason"];
            this.unlockDate = data["unlockDate"] ? moment(data["unlockDate"].toString()) : <any>undefined;
            this.unlockFrom = data["unlockFrom"];
            this.unlockTo = data["unlockTo"];
            this.dateUnlock = data["dateUnlock"];
            this.cuttOffAddMinutes = data["cuttOffAddMinutes"];
            this.cuttOffAddHours = data["cuttOffAddHours"];
            this.isShowToday = data["isShowToday"];
        }
    }

    static fromJS(data: any): GetLocationLockDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationLockDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["lock"] = this.lock;
        data["name"] = this.name;
        data["unlockBy"] = this.unlockBy;
        data["unlockReason"] = this.unlockReason;
        data["unlockDate"] = this.unlockDate ? this.unlockDate.toISOString() : <any>undefined;
        data["unlockFrom"] = this.unlockFrom;
        data["unlockTo"] = this.unlockTo;
        data["dateUnlock"] = this.dateUnlock;
        data["cuttOffAddMinutes"] = this.cuttOffAddMinutes;
        data["cuttOffAddHours"] = this.cuttOffAddHours;
        data["isShowToday"] = this.isShowToday;
        return data; 
    }
}

export interface IGetLocationLockDto {
    id: number;
    lock: boolean;
    name: string | undefined;
    unlockBy: string | undefined;
    unlockReason: string | undefined;
    unlockDate: moment.Moment | undefined;
    unlockFrom: string | undefined;
    unlockTo: string | undefined;
    dateUnlock: string | undefined;
    cuttOffAddMinutes: number | undefined;
    cuttOffAddHours: number | undefined;
    isShowToday: boolean;
}

export class UnlockLocationInput implements IUnlockLocationInput {
    id!: number;
    unlockReason!: string | undefined;
    unlock!: boolean;
    unlockFrom!: string | undefined;
    unlockTo!: string | undefined;
    time!: string | undefined;
    cuttOffAddMinutes!: number | undefined;

    constructor(data?: IUnlockLocationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.unlockReason = data["unlockReason"];
            this.unlock = data["unlock"];
            this.unlockFrom = data["unlockFrom"];
            this.unlockTo = data["unlockTo"];
            this.time = data["time"];
            this.cuttOffAddMinutes = data["cuttOffAddMinutes"];
        }
    }

    static fromJS(data: any): UnlockLocationInput {
        data = typeof data === 'object' ? data : {};
        let result = new UnlockLocationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["unlockReason"] = this.unlockReason;
        data["unlock"] = this.unlock;
        data["unlockFrom"] = this.unlockFrom;
        data["unlockTo"] = this.unlockTo;
        data["time"] = this.time;
        data["cuttOffAddMinutes"] = this.cuttOffAddMinutes;
        return data; 
    }
}

export interface IUnlockLocationInput {
    id: number;
    unlockReason: string | undefined;
    unlock: boolean;
    unlockFrom: string | undefined;
    unlockTo: string | undefined;
    time: string | undefined;
    cuttOffAddMinutes: number | undefined;
}

export class WillCallHolidays implements IWillCallHolidays {
    id!: number;
    selectionType!: SelectionType;
    from!: moment.Moment;
    to!: moment.Moment;

    constructor(data?: IWillCallHolidays) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.selectionType = data["selectionType"];
            this.from = data["from"] ? moment(data["from"].toString()) : <any>undefined;
            this.to = data["to"] ? moment(data["to"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): WillCallHolidays {
        data = typeof data === 'object' ? data : {};
        let result = new WillCallHolidays();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["selectionType"] = this.selectionType;
        data["from"] = this.from ? this.from.toISOString() : <any>undefined;
        data["to"] = this.to ? this.to.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IWillCallHolidays {
    id: number;
    selectionType: SelectionType;
    from: moment.Moment;
    to: moment.Moment;
}

export class PagedResultDtoOfLocationNameDto implements IPagedResultDtoOfLocationNameDto {
    totalCount!: number;
    items!: LocationNameDto[] | undefined;

    constructor(data?: IPagedResultDtoOfLocationNameDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(LocationNameDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfLocationNameDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfLocationNameDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfLocationNameDto {
    totalCount: number;
    items: LocationNameDto[] | undefined;
}

export class GenerateDto implements IGenerateDto {
    tenantId!: number;
    tenantName!: string | undefined;
    routeType!: string | undefined;
    locationId!: number;
    forDate!: string | undefined;
    baseDate!: string | undefined;
    timezone!: string | undefined;
    userId!: number;
    schedLimit!: number | undefined;
    runAttempt!: number;
    setupType!: LocationGenerationTypeEnum | undefined;
    isAuto!: boolean | undefined;
    runEstimatedStartTime!: boolean | undefined;
    driverUserId!: number | undefined;
    visibleToDriver!: boolean | undefined;
    sourceRouteIds!: number[] | undefined;
    targetRouteId!: number;
    orderIds!: number[] | undefined;
    driverAndOrderMapping!: DriverAndOrderMappingDto[] | undefined;

    constructor(data?: IGenerateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenantName = data["tenantName"];
            this.routeType = data["routeType"];
            this.locationId = data["locationId"];
            this.forDate = data["forDate"];
            this.baseDate = data["baseDate"];
            this.timezone = data["timezone"];
            this.userId = data["userId"];
            this.schedLimit = data["schedLimit"];
            this.runAttempt = data["runAttempt"];
            this.setupType = data["setupType"];
            this.isAuto = data["isAuto"];
            this.runEstimatedStartTime = data["runEstimatedStartTime"];
            this.driverUserId = data["driverUserId"];
            this.visibleToDriver = data["visibleToDriver"];
            if (Array.isArray(data["sourceRouteIds"])) {
                this.sourceRouteIds = [] as any;
                for (let item of data["sourceRouteIds"])
                    this.sourceRouteIds!.push(item);
            }
            this.targetRouteId = data["targetRouteId"];
            if (Array.isArray(data["orderIds"])) {
                this.orderIds = [] as any;
                for (let item of data["orderIds"])
                    this.orderIds!.push(item);
            }
            if (Array.isArray(data["driverAndOrderMapping"])) {
                this.driverAndOrderMapping = [] as any;
                for (let item of data["driverAndOrderMapping"])
                    this.driverAndOrderMapping!.push(DriverAndOrderMappingDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GenerateDto {
        data = typeof data === 'object' ? data : {};
        let result = new GenerateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenantName"] = this.tenantName;
        data["routeType"] = this.routeType;
        data["locationId"] = this.locationId;
        data["forDate"] = this.forDate;
        data["baseDate"] = this.baseDate;
        data["timezone"] = this.timezone;
        data["userId"] = this.userId;
        data["schedLimit"] = this.schedLimit;
        data["runAttempt"] = this.runAttempt;
        data["setupType"] = this.setupType;
        data["isAuto"] = this.isAuto;
        data["runEstimatedStartTime"] = this.runEstimatedStartTime;
        data["driverUserId"] = this.driverUserId;
        data["visibleToDriver"] = this.visibleToDriver;
        if (Array.isArray(this.sourceRouteIds)) {
            data["sourceRouteIds"] = [];
            for (let item of this.sourceRouteIds)
                data["sourceRouteIds"].push(item);
        }
        data["targetRouteId"] = this.targetRouteId;
        if (Array.isArray(this.orderIds)) {
            data["orderIds"] = [];
            for (let item of this.orderIds)
                data["orderIds"].push(item);
        }
        if (Array.isArray(this.driverAndOrderMapping)) {
            data["driverAndOrderMapping"] = [];
            for (let item of this.driverAndOrderMapping)
                data["driverAndOrderMapping"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGenerateDto {
    tenantId: number;
    tenantName: string | undefined;
    routeType: string | undefined;
    locationId: number;
    forDate: string | undefined;
    baseDate: string | undefined;
    timezone: string | undefined;
    userId: number;
    schedLimit: number | undefined;
    runAttempt: number;
    setupType: LocationGenerationTypeEnum | undefined;
    isAuto: boolean | undefined;
    runEstimatedStartTime: boolean | undefined;
    driverUserId: number | undefined;
    visibleToDriver: boolean | undefined;
    sourceRouteIds: number[] | undefined;
    targetRouteId: number;
    orderIds: number[] | undefined;
    driverAndOrderMapping: DriverAndOrderMappingDto[] | undefined;
}

export class LocationHolidayDto implements ILocationHolidayDto {
    locationId!: number | undefined;
    holidayId!: number | undefined;
    id!: number;

    constructor(data?: ILocationHolidayDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.holidayId = data["holidayId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): LocationHolidayDto {
        data = typeof data === 'object' ? data : {};
        let result = new LocationHolidayDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["holidayId"] = this.holidayId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ILocationHolidayDto {
    locationId: number | undefined;
    holidayId: number | undefined;
    id: number;
}

export class GetLocationHolidayForViewDto implements IGetLocationHolidayForViewDto {
    locationHoliday!: LocationHolidayDto | undefined;
    locationName!: string | undefined;
    holidayDescription!: string | undefined;

    constructor(data?: IGetLocationHolidayForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationHoliday = data["locationHoliday"] ? LocationHolidayDto.fromJS(data["locationHoliday"]) : <any>undefined;
            this.locationName = data["locationName"];
            this.holidayDescription = data["holidayDescription"];
        }
    }

    static fromJS(data: any): GetLocationHolidayForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationHolidayForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationHoliday"] = this.locationHoliday ? this.locationHoliday.toJSON() : <any>undefined;
        data["locationName"] = this.locationName;
        data["holidayDescription"] = this.holidayDescription;
        return data; 
    }
}

export interface IGetLocationHolidayForViewDto {
    locationHoliday: LocationHolidayDto | undefined;
    locationName: string | undefined;
    holidayDescription: string | undefined;
}

export class PagedResultDtoOfGetLocationHolidayForViewDto implements IPagedResultDtoOfGetLocationHolidayForViewDto {
    totalCount!: number;
    items!: GetLocationHolidayForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetLocationHolidayForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetLocationHolidayForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetLocationHolidayForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetLocationHolidayForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetLocationHolidayForViewDto {
    totalCount: number;
    items: GetLocationHolidayForViewDto[] | undefined;
}

export class CreateOrEditLocationHolidayDto implements ICreateOrEditLocationHolidayDto {
    locationId!: number | undefined;
    holidayId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditLocationHolidayDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.holidayId = data["holidayId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditLocationHolidayDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditLocationHolidayDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["holidayId"] = this.holidayId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditLocationHolidayDto {
    locationId: number | undefined;
    holidayId: number | undefined;
    id: number | undefined;
}

export class GetLocationHolidayForEditOutput implements IGetLocationHolidayForEditOutput {
    locationHoliday!: CreateOrEditLocationHolidayDto | undefined;
    locationName!: string | undefined;
    holidayDescription!: string | undefined;

    constructor(data?: IGetLocationHolidayForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationHoliday = data["locationHoliday"] ? CreateOrEditLocationHolidayDto.fromJS(data["locationHoliday"]) : <any>undefined;
            this.locationName = data["locationName"];
            this.holidayDescription = data["holidayDescription"];
        }
    }

    static fromJS(data: any): GetLocationHolidayForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationHolidayForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationHoliday"] = this.locationHoliday ? this.locationHoliday.toJSON() : <any>undefined;
        data["locationName"] = this.locationName;
        data["holidayDescription"] = this.holidayDescription;
        return data; 
    }
}

export interface IGetLocationHolidayForEditOutput {
    locationHoliday: CreateOrEditLocationHolidayDto | undefined;
    locationName: string | undefined;
    holidayDescription: string | undefined;
}

export class LocationHolidayLocationLookupTableDto implements ILocationHolidayLocationLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: ILocationHolidayLocationLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): LocationHolidayLocationLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new LocationHolidayLocationLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ILocationHolidayLocationLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfLocationHolidayLocationLookupTableDto implements IPagedResultDtoOfLocationHolidayLocationLookupTableDto {
    totalCount!: number;
    items!: LocationHolidayLocationLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfLocationHolidayLocationLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(LocationHolidayLocationLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfLocationHolidayLocationLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfLocationHolidayLocationLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfLocationHolidayLocationLookupTableDto {
    totalCount: number;
    items: LocationHolidayLocationLookupTableDto[] | undefined;
}

export class LocationHolidayHolidayLookupTableDto implements ILocationHolidayHolidayLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: ILocationHolidayHolidayLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): LocationHolidayHolidayLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new LocationHolidayHolidayLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ILocationHolidayHolidayLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfLocationHolidayHolidayLookupTableDto implements IPagedResultDtoOfLocationHolidayHolidayLookupTableDto {
    totalCount!: number;
    items!: LocationHolidayHolidayLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfLocationHolidayHolidayLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(LocationHolidayHolidayLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfLocationHolidayHolidayLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfLocationHolidayHolidayLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfLocationHolidayHolidayLookupTableDto {
    totalCount: number;
    items: LocationHolidayHolidayLookupTableDto[] | undefined;
}

export class GetDriverFilterResult implements IGetDriverFilterResult {
    name!: string | undefined;
    userId!: number | undefined;
    color!: string | undefined;
    routeCode!: string | undefined;
    searchTerm!: string | undefined;
    routeId!: number | undefined;

    constructor(data?: IGetDriverFilterResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.userId = data["userId"];
            this.color = data["color"];
            this.routeCode = data["routeCode"];
            this.searchTerm = data["searchTerm"];
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): GetDriverFilterResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetDriverFilterResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["userId"] = this.userId;
        data["color"] = this.color;
        data["routeCode"] = this.routeCode;
        data["searchTerm"] = this.searchTerm;
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface IGetDriverFilterResult {
    name: string | undefined;
    userId: number | undefined;
    color: string | undefined;
    routeCode: string | undefined;
    searchTerm: string | undefined;
    routeId: number | undefined;
}

export class ListResultDtoOfGetDriverFilterResult implements IListResultDtoOfGetDriverFilterResult {
    items!: GetDriverFilterResult[] | undefined;

    constructor(data?: IListResultDtoOfGetDriverFilterResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetDriverFilterResult.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetDriverFilterResult {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetDriverFilterResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetDriverFilterResult {
    items: GetDriverFilterResult[] | undefined;
}

export class GetRouteFilterResult implements IGetRouteFilterResult {
    routeId!: number;
    total!: number;
    color!: string | undefined;
    userId!: number | undefined;
    zone!: string | undefined;

    constructor(data?: IGetRouteFilterResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.total = data["total"];
            this.color = data["color"];
            this.userId = data["userId"];
            this.zone = data["zone"];
        }
    }

    static fromJS(data: any): GetRouteFilterResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteFilterResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["total"] = this.total;
        data["color"] = this.color;
        data["userId"] = this.userId;
        data["zone"] = this.zone;
        return data; 
    }
}

export interface IGetRouteFilterResult {
    routeId: number;
    total: number;
    color: string | undefined;
    userId: number | undefined;
    zone: string | undefined;
}

export class ListResultDtoOfGetRouteFilterResult implements IListResultDtoOfGetRouteFilterResult {
    items!: GetRouteFilterResult[] | undefined;

    constructor(data?: IListResultDtoOfGetRouteFilterResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteFilterResult.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetRouteFilterResult {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetRouteFilterResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetRouteFilterResult {
    items: GetRouteFilterResult[] | undefined;
}

export class GetVehicleDestinationPointsResultDto implements IGetVehicleDestinationPointsResultDto {
    orderId!: number;
    routeId!: number;
    driverName!: string | undefined;
    pickUpLatitude!: number;
    pickUpLongtitude!: number;
    pickUpGeoCodeId!: number;
    deliveryLatitude!: number;
    deliveryLongtitude!: number;
    deliveryGeoCodeId!: number;
    eta!: string | undefined;
    color!: string | undefined;
    destinationAddress!: string | undefined;
    destinationCountry!: string | undefined;
    destinationCity!: string | undefined;
    destinationState!: string | undefined;
    destinationPostal!: string | undefined;
    pickUpAddress!: string | undefined;
    pickUpCountry!: string | undefined;
    pickUpCity!: string | undefined;
    pickUpState!: string | undefined;
    pickUpPostal!: string | undefined;
    routeCode!: string | undefined;
    pickUpCompanyName!: string | undefined;
    deliveryCompanyName!: string | undefined;
    orderNumber!: number | undefined;
    vehicleColor!: string | undefined;
    statusCode!: string | undefined;
    statusDescription!: string | undefined;
    statusTime!: string | undefined;
    pickUpTime!: string | undefined;
    account!: string | undefined;
    orderType!: string | undefined;
    deliveryTime!: string | undefined;
    completionTime!: string | undefined;
    startFromWarehouse!: boolean;

    constructor(data?: IGetVehicleDestinationPointsResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.routeId = data["routeId"];
            this.driverName = data["driverName"];
            this.pickUpLatitude = data["pickUpLatitude"];
            this.pickUpLongtitude = data["pickUpLongtitude"];
            this.pickUpGeoCodeId = data["pickUpGeoCodeId"];
            this.deliveryLatitude = data["deliveryLatitude"];
            this.deliveryLongtitude = data["deliveryLongtitude"];
            this.deliveryGeoCodeId = data["deliveryGeoCodeId"];
            this.eta = data["eta"];
            this.color = data["color"];
            this.destinationAddress = data["destinationAddress"];
            this.destinationCountry = data["destinationCountry"];
            this.destinationCity = data["destinationCity"];
            this.destinationState = data["destinationState"];
            this.destinationPostal = data["destinationPostal"];
            this.pickUpAddress = data["pickUpAddress"];
            this.pickUpCountry = data["pickUpCountry"];
            this.pickUpCity = data["pickUpCity"];
            this.pickUpState = data["pickUpState"];
            this.pickUpPostal = data["pickUpPostal"];
            this.routeCode = data["routeCode"];
            this.pickUpCompanyName = data["pickUpCompanyName"];
            this.deliveryCompanyName = data["deliveryCompanyName"];
            this.orderNumber = data["orderNumber"];
            this.vehicleColor = data["vehicleColor"];
            this.statusCode = data["statusCode"];
            this.statusDescription = data["statusDescription"];
            this.statusTime = data["statusTime"];
            this.pickUpTime = data["pickUpTime"];
            this.account = data["account"];
            this.orderType = data["orderType"];
            this.deliveryTime = data["deliveryTime"];
            this.completionTime = data["completionTime"];
            this.startFromWarehouse = data["startFromWarehouse"];
        }
    }

    static fromJS(data: any): GetVehicleDestinationPointsResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleDestinationPointsResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["routeId"] = this.routeId;
        data["driverName"] = this.driverName;
        data["pickUpLatitude"] = this.pickUpLatitude;
        data["pickUpLongtitude"] = this.pickUpLongtitude;
        data["pickUpGeoCodeId"] = this.pickUpGeoCodeId;
        data["deliveryLatitude"] = this.deliveryLatitude;
        data["deliveryLongtitude"] = this.deliveryLongtitude;
        data["deliveryGeoCodeId"] = this.deliveryGeoCodeId;
        data["eta"] = this.eta;
        data["color"] = this.color;
        data["destinationAddress"] = this.destinationAddress;
        data["destinationCountry"] = this.destinationCountry;
        data["destinationCity"] = this.destinationCity;
        data["destinationState"] = this.destinationState;
        data["destinationPostal"] = this.destinationPostal;
        data["pickUpAddress"] = this.pickUpAddress;
        data["pickUpCountry"] = this.pickUpCountry;
        data["pickUpCity"] = this.pickUpCity;
        data["pickUpState"] = this.pickUpState;
        data["pickUpPostal"] = this.pickUpPostal;
        data["routeCode"] = this.routeCode;
        data["pickUpCompanyName"] = this.pickUpCompanyName;
        data["deliveryCompanyName"] = this.deliveryCompanyName;
        data["orderNumber"] = this.orderNumber;
        data["vehicleColor"] = this.vehicleColor;
        data["statusCode"] = this.statusCode;
        data["statusDescription"] = this.statusDescription;
        data["statusTime"] = this.statusTime;
        data["pickUpTime"] = this.pickUpTime;
        data["account"] = this.account;
        data["orderType"] = this.orderType;
        data["deliveryTime"] = this.deliveryTime;
        data["completionTime"] = this.completionTime;
        data["startFromWarehouse"] = this.startFromWarehouse;
        return data; 
    }
}

export interface IGetVehicleDestinationPointsResultDto {
    orderId: number;
    routeId: number;
    driverName: string | undefined;
    pickUpLatitude: number;
    pickUpLongtitude: number;
    pickUpGeoCodeId: number;
    deliveryLatitude: number;
    deliveryLongtitude: number;
    deliveryGeoCodeId: number;
    eta: string | undefined;
    color: string | undefined;
    destinationAddress: string | undefined;
    destinationCountry: string | undefined;
    destinationCity: string | undefined;
    destinationState: string | undefined;
    destinationPostal: string | undefined;
    pickUpAddress: string | undefined;
    pickUpCountry: string | undefined;
    pickUpCity: string | undefined;
    pickUpState: string | undefined;
    pickUpPostal: string | undefined;
    routeCode: string | undefined;
    pickUpCompanyName: string | undefined;
    deliveryCompanyName: string | undefined;
    orderNumber: number | undefined;
    vehicleColor: string | undefined;
    statusCode: string | undefined;
    statusDescription: string | undefined;
    statusTime: string | undefined;
    pickUpTime: string | undefined;
    account: string | undefined;
    orderType: string | undefined;
    deliveryTime: string | undefined;
    completionTime: string | undefined;
    startFromWarehouse: boolean;
}

export class ListResultDtoOfGetVehicleDestinationPointsResultDto implements IListResultDtoOfGetVehicleDestinationPointsResultDto {
    items!: GetVehicleDestinationPointsResultDto[] | undefined;

    constructor(data?: IListResultDtoOfGetVehicleDestinationPointsResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetVehicleDestinationPointsResultDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetVehicleDestinationPointsResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetVehicleDestinationPointsResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetVehicleDestinationPointsResultDto {
    items: GetVehicleDestinationPointsResultDto[] | undefined;
}

export class GetVehicleLocationLogResult implements IGetVehicleLocationLogResult {
    latitude!: number;
    longtitude!: number;
    timeStamp!: string | undefined;
    userId!: number | undefined;
    color!: string | undefined;
    order!: number;
    driverName!: string | undefined;

    constructor(data?: IGetVehicleLocationLogResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longtitude = data["longtitude"];
            this.timeStamp = data["timeStamp"];
            this.userId = data["userId"];
            this.color = data["color"];
            this.order = data["order"];
            this.driverName = data["driverName"];
        }
    }

    static fromJS(data: any): GetVehicleLocationLogResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleLocationLogResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longtitude"] = this.longtitude;
        data["timeStamp"] = this.timeStamp;
        data["userId"] = this.userId;
        data["color"] = this.color;
        data["order"] = this.order;
        data["driverName"] = this.driverName;
        return data; 
    }
}

export interface IGetVehicleLocationLogResult {
    latitude: number;
    longtitude: number;
    timeStamp: string | undefined;
    userId: number | undefined;
    color: string | undefined;
    order: number;
    driverName: string | undefined;
}

export class ListResultDtoOfGetVehicleLocationLogResult implements IListResultDtoOfGetVehicleLocationLogResult {
    items!: GetVehicleLocationLogResult[] | undefined;

    constructor(data?: IListResultDtoOfGetVehicleLocationLogResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetVehicleLocationLogResult.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetVehicleLocationLogResult {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetVehicleLocationLogResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetVehicleLocationLogResult {
    items: GetVehicleLocationLogResult[] | undefined;
}

export class MoveToRouteListDetail implements IMoveToRouteListDetail {
    routeId!: number;
    driverName!: string | undefined;
    zone!: string | undefined;
    routeDate!: moment.Moment;

    constructor(data?: IMoveToRouteListDetail) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.driverName = data["driverName"];
            this.zone = data["zone"];
            this.routeDate = data["routeDate"] ? moment(data["routeDate"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): MoveToRouteListDetail {
        data = typeof data === 'object' ? data : {};
        let result = new MoveToRouteListDetail();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["driverName"] = this.driverName;
        data["zone"] = this.zone;
        data["routeDate"] = this.routeDate ? this.routeDate.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IMoveToRouteListDetail {
    routeId: number;
    driverName: string | undefined;
    zone: string | undefined;
    routeDate: moment.Moment;
}

export class ListResultDtoOfMoveToRouteListDetail implements IListResultDtoOfMoveToRouteListDetail {
    items!: MoveToRouteListDetail[] | undefined;

    constructor(data?: IListResultDtoOfMoveToRouteListDetail) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(MoveToRouteListDetail.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfMoveToRouteListDetail {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfMoveToRouteListDetail();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfMoveToRouteListDetail {
    items: MoveToRouteListDetail[] | undefined;
}

export class MoveOrder implements IMoveOrder {
    orderId!: number;
    routeId!: number;

    constructor(data?: IMoveOrder) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): MoveOrder {
        data = typeof data === 'object' ? data : {};
        let result = new MoveOrder();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface IMoveOrder {
    orderId: number;
    routeId: number;
}

export class RouteTypeList implements IRouteTypeList {
    routeTypeCode!: string | undefined;
    description!: string | undefined;
    displayColor!: string | undefined;
    id!: number;

    constructor(data?: IRouteTypeList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTypeCode = data["routeTypeCode"];
            this.description = data["description"];
            this.displayColor = data["displayColor"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTypeList {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTypeList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTypeCode"] = this.routeTypeCode;
        data["description"] = this.description;
        data["displayColor"] = this.displayColor;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTypeList {
    routeTypeCode: string | undefined;
    description: string | undefined;
    displayColor: string | undefined;
    id: number;
}

export class ListResultDtoOfRouteTypeList implements IListResultDtoOfRouteTypeList {
    items!: RouteTypeList[] | undefined;

    constructor(data?: IListResultDtoOfRouteTypeList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteTypeList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfRouteTypeList {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfRouteTypeList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfRouteTypeList {
    items: RouteTypeList[] | undefined;
}

export class GetActiveRouteResult implements IGetActiveRouteResult {
    routeId!: number;
    userId!: number;

    constructor(data?: IGetActiveRouteResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): GetActiveRouteResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IGetActiveRouteResult {
    routeId: number;
    userId: number;
}

export class ListResultDtoOfGetActiveRouteResult implements IListResultDtoOfGetActiveRouteResult {
    items!: GetActiveRouteResult[] | undefined;

    constructor(data?: IListResultDtoOfGetActiveRouteResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetActiveRouteResult.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetActiveRouteResult {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetActiveRouteResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetActiveRouteResult {
    items: GetActiveRouteResult[] | undefined;
}

export class MobileLogo implements IMobileLogo {
    data!: string | undefined;

    constructor(data?: IMobileLogo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.data = data["data"];
        }
    }

    static fromJS(data: any): MobileLogo {
        data = typeof data === 'object' ? data : {};
        let result = new MobileLogo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["data"] = this.data;
        return data; 
    }
}

export interface IMobileLogo {
    data: string | undefined;
}

export class UpdateLocatorGeocodeInput implements IUpdateLocatorGeocodeInput {
    geocodeId!: number;
    latitude!: number;
    longtitude!: number;

    constructor(data?: IUpdateLocatorGeocodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.geocodeId = data["geocodeId"];
            this.latitude = data["latitude"];
            this.longtitude = data["longtitude"];
        }
    }

    static fromJS(data: any): UpdateLocatorGeocodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateLocatorGeocodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["geocodeId"] = this.geocodeId;
        data["latitude"] = this.latitude;
        data["longtitude"] = this.longtitude;
        return data; 
    }
}

export interface IUpdateLocatorGeocodeInput {
    geocodeId: number;
    latitude: number;
    longtitude: number;
}

export class IdleResult implements IIdleResult {
    latitude!: number;
    longtitude!: number;
    timeStamp!: string | undefined;
    userId!: number | undefined;
    color!: string | undefined;
    order!: number;
    driverName!: string | undefined;
    idleMinutes!: number;
    routeCode!: string | undefined;

    constructor(data?: IIdleResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longtitude = data["longtitude"];
            this.timeStamp = data["timeStamp"];
            this.userId = data["userId"];
            this.color = data["color"];
            this.order = data["order"];
            this.driverName = data["driverName"];
            this.idleMinutes = data["idleMinutes"];
            this.routeCode = data["routeCode"];
        }
    }

    static fromJS(data: any): IdleResult {
        data = typeof data === 'object' ? data : {};
        let result = new IdleResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longtitude"] = this.longtitude;
        data["timeStamp"] = this.timeStamp;
        data["userId"] = this.userId;
        data["color"] = this.color;
        data["order"] = this.order;
        data["driverName"] = this.driverName;
        data["idleMinutes"] = this.idleMinutes;
        data["routeCode"] = this.routeCode;
        return data; 
    }
}

export interface IIdleResult {
    latitude: number;
    longtitude: number;
    timeStamp: string | undefined;
    userId: number | undefined;
    color: string | undefined;
    order: number;
    driverName: string | undefined;
    idleMinutes: number;
    routeCode: string | undefined;
}

export class ListResultDtoOfIdleResult implements IListResultDtoOfIdleResult {
    items!: IdleResult[] | undefined;

    constructor(data?: IListResultDtoOfIdleResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(IdleResult.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfIdleResult {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfIdleResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfIdleResult {
    items: IdleResult[] | undefined;
}

export class GetContactJsonListItemTenantDto implements IGetContactJsonListItemTenantDto {
    tenancyName!: string | undefined;

    constructor(data?: IGetContactJsonListItemTenantDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
        }
    }

    static fromJS(data: any): GetContactJsonListItemTenantDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactJsonListItemTenantDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        return data; 
    }
}

export interface IGetContactJsonListItemTenantDto {
    tenancyName: string | undefined;
}

export class GetContactJsonListItemUserDto implements IGetContactJsonListItemUserDto {
    userName!: string | undefined;

    constructor(data?: IGetContactJsonListItemUserDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userName = data["userName"];
        }
    }

    static fromJS(data: any): GetContactJsonListItemUserDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactJsonListItemUserDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userName"] = this.userName;
        return data; 
    }
}

export interface IGetContactJsonListItemUserDto {
    userName: string | undefined;
}

export class GetContactJsonListItemDto implements IGetContactJsonListItemDto {
    tenant!: GetContactJsonListItemTenantDto | undefined;
    user!: GetContactJsonListItemUserDto | undefined;
    firstName!: string | undefined;
    lastName!: string | undefined;
    address!: DriverClientProfileAddressDto | undefined;
    company!: ContactListCompanyDto | undefined;

    constructor(data?: IGetContactJsonListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"] ? GetContactJsonListItemTenantDto.fromJS(data["tenant"]) : <any>undefined;
            this.user = data["user"] ? GetContactJsonListItemUserDto.fromJS(data["user"]) : <any>undefined;
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.address = data["address"] ? DriverClientProfileAddressDto.fromJS(data["address"]) : <any>undefined;
            this.company = data["company"] ? ContactListCompanyDto.fromJS(data["company"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetContactJsonListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetContactJsonListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["company"] = this.company ? this.company.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetContactJsonListItemDto {
    tenant: GetContactJsonListItemTenantDto | undefined;
    user: GetContactJsonListItemUserDto | undefined;
    firstName: string | undefined;
    lastName: string | undefined;
    address: DriverClientProfileAddressDto | undefined;
    company: ContactListCompanyDto | undefined;
}

export class PagedResultDtoOfGetContactJsonListItemDto implements IPagedResultDtoOfGetContactJsonListItemDto {
    totalCount!: number;
    items!: GetContactJsonListItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetContactJsonListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetContactJsonListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetContactJsonListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetContactJsonListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetContactJsonListItemDto {
    totalCount: number;
    items: GetContactJsonListItemDto[] | undefined;
}

export class GetUserJsonListItemDto implements IGetUserJsonListItemDto {
    userName!: string | undefined;
    name!: string | undefined;
    surname!: string | undefined;
    emailAddress!: string | undefined;

    constructor(data?: IGetUserJsonListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userName = data["userName"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.emailAddress = data["emailAddress"];
        }
    }

    static fromJS(data: any): GetUserJsonListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserJsonListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userName"] = this.userName;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["emailAddress"] = this.emailAddress;
        return data; 
    }
}

export interface IGetUserJsonListItemDto {
    userName: string | undefined;
    name: string | undefined;
    surname: string | undefined;
    emailAddress: string | undefined;
}

export class TenantJsonDto implements ITenantJsonDto {
    tenancyName!: string | undefined;

    constructor(data?: ITenantJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
        }
    }

    static fromJS(data: any): TenantJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        return data; 
    }
}

export interface ITenantJsonDto {
    tenancyName: string | undefined;
}

export class GetLocationJsonUserDto implements IGetLocationJsonUserDto {
    userName!: string | undefined;

    constructor(data?: IGetLocationJsonUserDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userName = data["userName"];
        }
    }

    static fromJS(data: any): GetLocationJsonUserDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationJsonUserDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userName"] = this.userName;
        return data; 
    }
}

export interface IGetLocationJsonUserDto {
    userName: string | undefined;
}

export class GetLocationJsonTimezoneDto implements IGetLocationJsonTimezoneDto {
    value!: string | undefined;

    constructor(data?: IGetLocationJsonTimezoneDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
        }
    }

    static fromJS(data: any): GetLocationJsonTimezoneDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationJsonTimezoneDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        return data; 
    }
}

export interface IGetLocationJsonTimezoneDto {
    value: string | undefined;
}

export class GetLocationJsonListItemDto implements IGetLocationJsonListItemDto {
    tenant!: TenantJsonDto | undefined;
    user!: GetLocationJsonUserDto | undefined;
    timeZone!: GetLocationJsonTimezoneDto | undefined;
    name!: string | undefined;

    constructor(data?: IGetLocationJsonListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"] ? TenantJsonDto.fromJS(data["tenant"]) : <any>undefined;
            this.user = data["user"] ? GetLocationJsonUserDto.fromJS(data["user"]) : <any>undefined;
            this.timeZone = data["timeZone"] ? GetLocationJsonTimezoneDto.fromJS(data["timeZone"]) : <any>undefined;
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetLocationJsonListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationJsonListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["timeZone"] = this.timeZone ? this.timeZone.toJSON() : <any>undefined;
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetLocationJsonListItemDto {
    tenant: TenantJsonDto | undefined;
    user: GetLocationJsonUserDto | undefined;
    timeZone: GetLocationJsonTimezoneDto | undefined;
    name: string | undefined;
}

export class ZoneJsonDto implements IZoneJsonDto {
    tenant!: TenantJsonDto | undefined;
    name!: string | undefined;

    constructor(data?: IZoneJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"] ? TenantJsonDto.fromJS(data["tenant"]) : <any>undefined;
            this.name = data["name"];
        }
    }

    static fromJS(data: any): ZoneJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new ZoneJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["name"] = this.name;
        return data; 
    }
}

export interface IZoneJsonDto {
    tenant: TenantJsonDto | undefined;
    name: string | undefined;
}

export class PostalCodeJsonDto implements IPostalCodeJsonDto {
    country!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    value!: string | undefined;

    constructor(data?: IPostalCodeJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.country = data["country"];
            this.city = data["city"];
            this.state = data["state"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): PostalCodeJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new PostalCodeJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["country"] = this.country;
        data["city"] = this.city;
        data["state"] = this.state;
        data["value"] = this.value;
        return data; 
    }
}

export interface IPostalCodeJsonDto {
    country: string | undefined;
    city: string | undefined;
    state: string | undefined;
    value: string | undefined;
}

export class GetPostalCodeZoneListItemDto implements IGetPostalCodeZoneListItemDto {
    tenant!: TenantJsonDto | undefined;
    zone!: ZoneJsonDto | undefined;
    postalCode!: PostalCodeJsonDto | undefined;

    constructor(data?: IGetPostalCodeZoneListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"] ? TenantJsonDto.fromJS(data["tenant"]) : <any>undefined;
            this.zone = data["zone"] ? ZoneJsonDto.fromJS(data["zone"]) : <any>undefined;
            this.postalCode = data["postalCode"] ? PostalCodeJsonDto.fromJS(data["postalCode"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetPostalCodeZoneListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetPostalCodeZoneListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["zone"] = this.zone ? this.zone.toJSON() : <any>undefined;
        data["postalCode"] = this.postalCode ? this.postalCode.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetPostalCodeZoneListItemDto {
    tenant: TenantJsonDto | undefined;
    zone: ZoneJsonDto | undefined;
    postalCode: PostalCodeJsonDto | undefined;
}

export class GetZoneLocationsJsonDto implements IGetZoneLocationsJsonDto {
    tenant!: TenantJsonDto | undefined;
    zone!: ZoneJsonDto | undefined;
    location!: GetLocationJsonListItemDto | undefined;

    constructor(data?: IGetZoneLocationsJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"] ? TenantJsonDto.fromJS(data["tenant"]) : <any>undefined;
            this.zone = data["zone"] ? ZoneJsonDto.fromJS(data["zone"]) : <any>undefined;
            this.location = data["location"] ? GetLocationJsonListItemDto.fromJS(data["location"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetZoneLocationsJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetZoneLocationsJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["zone"] = this.zone ? this.zone.toJSON() : <any>undefined;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetZoneLocationsJsonDto {
    tenant: TenantJsonDto | undefined;
    zone: ZoneJsonDto | undefined;
    location: GetLocationJsonListItemDto | undefined;
}

export class VehicleJsonDto implements IVehicleJsonDto {
    tenant!: TenantJsonDto | undefined;
    user!: GetContactJsonListItemUserDto | undefined;
    licenseNumber!: string | undefined;
    name!: string | undefined;
    color!: string | undefined;

    constructor(data?: IVehicleJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"] ? TenantJsonDto.fromJS(data["tenant"]) : <any>undefined;
            this.user = data["user"] ? GetContactJsonListItemUserDto.fromJS(data["user"]) : <any>undefined;
            this.licenseNumber = data["licenseNumber"];
            this.name = data["name"];
            this.color = data["color"];
        }
    }

    static fromJS(data: any): VehicleJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["licenseNumber"] = this.licenseNumber;
        data["name"] = this.name;
        data["color"] = this.color;
        return data; 
    }
}

export interface IVehicleJsonDto {
    tenant: TenantJsonDto | undefined;
    user: GetContactJsonListItemUserDto | undefined;
    licenseNumber: string | undefined;
    name: string | undefined;
    color: string | undefined;
}

export class GetVehicleLocationJsonDto implements IGetVehicleLocationJsonDto {
    location!: GetLocationJsonListItemDto | undefined;
    tenant!: TenantJsonDto | undefined;
    vehicle!: VehicleJsonDto | undefined;

    constructor(data?: IGetVehicleLocationJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.location = data["location"] ? GetLocationJsonListItemDto.fromJS(data["location"]) : <any>undefined;
            this.tenant = data["tenant"] ? TenantJsonDto.fromJS(data["tenant"]) : <any>undefined;
            this.vehicle = data["vehicle"] ? VehicleJsonDto.fromJS(data["vehicle"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVehicleLocationJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleLocationJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVehicleLocationJsonDto {
    location: GetLocationJsonListItemDto | undefined;
    tenant: TenantJsonDto | undefined;
    vehicle: VehicleJsonDto | undefined;
}

export class RouteTemplateLocationJsonDto implements IRouteTemplateLocationJsonDto {
    name!: string | undefined;

    constructor(data?: IRouteTemplateLocationJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): RouteTemplateLocationJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateLocationJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface IRouteTemplateLocationJsonDto {
    name: string | undefined;
}

export class RouteTemplateTypeJsonDto implements IRouteTemplateTypeJsonDto {
    name!: string | undefined;

    constructor(data?: IRouteTemplateTypeJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): RouteTemplateTypeJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateTypeJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface IRouteTemplateTypeJsonDto {
    name: string | undefined;
}

export class RouteTemplateJsonDto implements IRouteTemplateJsonDto {
    tenant!: TenantJsonDto | undefined;
    name!: string | undefined;
    startTime!: TimeSpan;
    endTime!: TimeSpan;
    location!: RouteTemplateLocationJsonDto | undefined;
    routeTemplateType!: RouteTemplateTypeJsonDto | undefined;
    defaultContact!: GetContactJsonListItemDto | undefined;
    defaultUser!: GetContactJsonListItemUserDto | undefined;

    constructor(data?: IRouteTemplateJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"] ? TenantJsonDto.fromJS(data["tenant"]) : <any>undefined;
            this.name = data["name"];
            this.startTime = data["startTime"] ? TimeSpan.fromJS(data["startTime"]) : <any>undefined;
            this.endTime = data["endTime"] ? TimeSpan.fromJS(data["endTime"]) : <any>undefined;
            this.location = data["location"] ? RouteTemplateLocationJsonDto.fromJS(data["location"]) : <any>undefined;
            this.routeTemplateType = data["routeTemplateType"] ? RouteTemplateTypeJsonDto.fromJS(data["routeTemplateType"]) : <any>undefined;
            this.defaultContact = data["defaultContact"] ? GetContactJsonListItemDto.fromJS(data["defaultContact"]) : <any>undefined;
            this.defaultUser = data["defaultUser"] ? GetContactJsonListItemUserDto.fromJS(data["defaultUser"]) : <any>undefined;
        }
    }

    static fromJS(data: any): RouteTemplateJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["name"] = this.name;
        data["startTime"] = this.startTime ? this.startTime.toJSON() : <any>undefined;
        data["endTime"] = this.endTime ? this.endTime.toJSON() : <any>undefined;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["routeTemplateType"] = this.routeTemplateType ? this.routeTemplateType.toJSON() : <any>undefined;
        data["defaultContact"] = this.defaultContact ? this.defaultContact.toJSON() : <any>undefined;
        data["defaultUser"] = this.defaultUser ? this.defaultUser.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IRouteTemplateJsonDto {
    tenant: TenantJsonDto | undefined;
    name: string | undefined;
    startTime: TimeSpan;
    endTime: TimeSpan;
    location: RouteTemplateLocationJsonDto | undefined;
    routeTemplateType: RouteTemplateTypeJsonDto | undefined;
    defaultContact: GetContactJsonListItemDto | undefined;
    defaultUser: GetContactJsonListItemUserDto | undefined;
}

export class RouteTemplateZoneJsonDto implements IRouteTemplateZoneJsonDto {
    zone!: ZoneJsonDto | undefined;
    routeTemplate!: RouteTemplateJsonDto | undefined;
    tenant!: TenantJsonDto | undefined;
    sortOrder!: number;

    constructor(data?: IRouteTemplateZoneJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.zone = data["zone"] ? ZoneJsonDto.fromJS(data["zone"]) : <any>undefined;
            this.routeTemplate = data["routeTemplate"] ? RouteTemplateJsonDto.fromJS(data["routeTemplate"]) : <any>undefined;
            this.tenant = data["tenant"] ? TenantJsonDto.fromJS(data["tenant"]) : <any>undefined;
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): RouteTemplateZoneJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateZoneJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["zone"] = this.zone ? this.zone.toJSON() : <any>undefined;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IRouteTemplateZoneJsonDto {
    zone: ZoneJsonDto | undefined;
    routeTemplate: RouteTemplateJsonDto | undefined;
    tenant: TenantJsonDto | undefined;
    sortOrder: number;
}

export class RouteTemplateAddressJsonDto implements IRouteTemplateAddressJsonDto {
    tenant!: TenantJsonDto | undefined;
    routeTemplate!: RouteTemplateJsonDto | undefined;
    address!: DriverClientProfileAddressDto | undefined;
    sortOrder!: number;

    constructor(data?: IRouteTemplateAddressJsonDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"] ? TenantJsonDto.fromJS(data["tenant"]) : <any>undefined;
            this.routeTemplate = data["routeTemplate"] ? RouteTemplateJsonDto.fromJS(data["routeTemplate"]) : <any>undefined;
            this.address = data["address"] ? DriverClientProfileAddressDto.fromJS(data["address"]) : <any>undefined;
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): RouteTemplateAddressJsonDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateAddressJsonDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IRouteTemplateAddressJsonDto {
    tenant: TenantJsonDto | undefined;
    routeTemplate: RouteTemplateJsonDto | undefined;
    address: DriverClientProfileAddressDto | undefined;
    sortOrder: number;
}

export class TenantThemeDto implements ITenantThemeDto {
    tenancyName!: string | undefined;
    customCss!: string | undefined;
    logo!: string | undefined;

    constructor(data?: ITenantThemeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.customCss = data["customCss"];
            this.logo = data["logo"];
        }
    }

    static fromJS(data: any): TenantThemeDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantThemeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["customCss"] = this.customCss;
        data["logo"] = this.logo;
        return data; 
    }
}

export interface ITenantThemeDto {
    tenancyName: string | undefined;
    customCss: string | undefined;
    logo: string | undefined;
}

export class CreateMileageInput implements ICreateMileageInput {
    tenantId!: number | undefined;
    value!: number;

    constructor(data?: ICreateMileageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreateMileageInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateMileageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreateMileageInput {
    tenantId: number | undefined;
    value: number;
}

export class MileageListDto implements IMileageListDto {
    tenantId!: number;
    value!: number;
    id!: number;

    constructor(data?: IMileageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MileageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new MileageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMileageListDto {
    tenantId: number;
    value: number;
    id: number;
}

export class PagedResultDtoOfMileageListDto implements IPagedResultDtoOfMileageListDto {
    totalCount!: number;
    items!: MileageListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfMileageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(MileageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfMileageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfMileageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfMileageListDto {
    totalCount: number;
    items: MileageListDto[] | undefined;
}

export class UpdateMileageInput implements IUpdateMileageInput {
    id!: number;
    value!: number;

    constructor(data?: IUpdateMileageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): UpdateMileageInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateMileageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["value"] = this.value;
        return data; 
    }
}

export interface IUpdateMileageInput {
    id: number;
    value: number;
}

export class MileageReimbursementListDto implements IMileageReimbursementListDto {
    driverName!: string | undefined;
    lastName!: string | undefined;
    firstName!: string | undefined;
    startDate!: string | undefined;
    endDate!: string | undefined;
    totalMileage!: number | undefined;
    totalMileageString!: string | undefined;
    mileageReimbursement!: number | undefined;
    mileageReimbursementString!: string | undefined;
    address!: string | undefined;

    constructor(data?: IMileageReimbursementListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverName = data["driverName"];
            this.lastName = data["lastName"];
            this.firstName = data["firstName"];
            this.startDate = data["startDate"];
            this.endDate = data["endDate"];
            this.totalMileage = data["totalMileage"];
            this.totalMileageString = data["totalMileageString"];
            this.mileageReimbursement = data["mileageReimbursement"];
            this.mileageReimbursementString = data["mileageReimbursementString"];
            this.address = data["address"];
        }
    }

    static fromJS(data: any): MileageReimbursementListDto {
        data = typeof data === 'object' ? data : {};
        let result = new MileageReimbursementListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverName"] = this.driverName;
        data["lastName"] = this.lastName;
        data["firstName"] = this.firstName;
        data["startDate"] = this.startDate;
        data["endDate"] = this.endDate;
        data["totalMileage"] = this.totalMileage;
        data["totalMileageString"] = this.totalMileageString;
        data["mileageReimbursement"] = this.mileageReimbursement;
        data["mileageReimbursementString"] = this.mileageReimbursementString;
        data["address"] = this.address;
        return data; 
    }
}

export interface IMileageReimbursementListDto {
    driverName: string | undefined;
    lastName: string | undefined;
    firstName: string | undefined;
    startDate: string | undefined;
    endDate: string | undefined;
    totalMileage: number | undefined;
    totalMileageString: string | undefined;
    mileageReimbursement: number | undefined;
    mileageReimbursementString: string | undefined;
    address: string | undefined;
}

export class GetMobileOsTypeListItemDto implements IGetMobileOsTypeListItemDto {
    osName!: string | undefined;

    constructor(data?: IGetMobileOsTypeListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.osName = data["osName"];
        }
    }

    static fromJS(data: any): GetMobileOsTypeListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileOsTypeListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["osName"] = this.osName;
        return data; 
    }
}

export interface IGetMobileOsTypeListItemDto {
    osName: string | undefined;
}

export class GetMobileOsTypesResultDto implements IGetMobileOsTypesResultDto {
    items!: GetMobileOsTypeListItemDto[] | undefined;

    constructor(data?: IGetMobileOsTypesResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetMobileOsTypeListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetMobileOsTypesResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileOsTypesResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetMobileOsTypesResultDto {
    items: GetMobileOsTypeListItemDto[] | undefined;
}

export class GetMobileClientCodesListItemDto implements IGetMobileClientCodesListItemDto {
    clientCode!: string | undefined;

    constructor(data?: IGetMobileClientCodesListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientCode = data["clientCode"];
        }
    }

    static fromJS(data: any): GetMobileClientCodesListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileClientCodesListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientCode"] = this.clientCode;
        return data; 
    }
}

export interface IGetMobileClientCodesListItemDto {
    clientCode: string | undefined;
}

export class GetMobileClientCodesResultDto implements IGetMobileClientCodesResultDto {
    items!: GetMobileClientCodesListItemDto[] | undefined;

    constructor(data?: IGetMobileClientCodesResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetMobileClientCodesListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetMobileClientCodesResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileClientCodesResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetMobileClientCodesResultDto {
    items: GetMobileClientCodesListItemDto[] | undefined;
}

export class CreateMobileVersionInput implements ICreateMobileVersionInput {
    clientCode!: string | undefined;
    osName!: string | undefined;
    minimumVersion!: number;
    versionName!: string | undefined;

    constructor(data?: ICreateMobileVersionInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientCode = data["clientCode"];
            this.osName = data["osName"];
            this.minimumVersion = data["minimumVersion"];
            this.versionName = data["versionName"];
        }
    }

    static fromJS(data: any): CreateMobileVersionInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateMobileVersionInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientCode"] = this.clientCode;
        data["osName"] = this.osName;
        data["minimumVersion"] = this.minimumVersion;
        data["versionName"] = this.versionName;
        return data; 
    }
}

export interface ICreateMobileVersionInput {
    clientCode: string | undefined;
    osName: string | undefined;
    minimumVersion: number;
    versionName: string | undefined;
}

export class PagedResultDtoOfMobileVersionListDto implements IPagedResultDtoOfMobileVersionListDto {
    totalCount!: number;
    items!: MobileVersionListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfMobileVersionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(MobileVersionListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfMobileVersionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfMobileVersionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfMobileVersionListDto {
    totalCount: number;
    items: MobileVersionListDto[] | undefined;
}

export class UpdateMobileVersionInput implements IUpdateMobileVersionInput {
    id!: number;
    clientCode!: string | undefined;
    osName!: string | undefined;
    minimumVersion!: number;
    versionName!: string | undefined;

    constructor(data?: IUpdateMobileVersionInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.clientCode = data["clientCode"];
            this.osName = data["osName"];
            this.minimumVersion = data["minimumVersion"];
            this.versionName = data["versionName"];
        }
    }

    static fromJS(data: any): UpdateMobileVersionInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateMobileVersionInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["clientCode"] = this.clientCode;
        data["osName"] = this.osName;
        data["minimumVersion"] = this.minimumVersion;
        data["versionName"] = this.versionName;
        return data; 
    }
}

export interface IUpdateMobileVersionInput {
    id: number;
    clientCode: string | undefined;
    osName: string | undefined;
    minimumVersion: number;
    versionName: string | undefined;
}

export class CreateMobileClientInput implements ICreateMobileClientInput {
    osName!: string | undefined;
    osVersion!: string | undefined;
    deviceModel!: string | undefined;
    appCode!: string | undefined;
    appVersion!: number;
    language!: string | undefined;
    driverStatus!: string | undefined;

    constructor(data?: ICreateMobileClientInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.osName = data["osName"];
            this.osVersion = data["osVersion"];
            this.deviceModel = data["deviceModel"];
            this.appCode = data["appCode"];
            this.appVersion = data["appVersion"];
            this.language = data["language"];
            this.driverStatus = data["driverStatus"];
        }
    }

    static fromJS(data: any): CreateMobileClientInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateMobileClientInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["osName"] = this.osName;
        data["osVersion"] = this.osVersion;
        data["deviceModel"] = this.deviceModel;
        data["appCode"] = this.appCode;
        data["appVersion"] = this.appVersion;
        data["language"] = this.language;
        data["driverStatus"] = this.driverStatus;
        return data; 
    }
}

export interface ICreateMobileClientInput {
    osName: string | undefined;
    osVersion: string | undefined;
    deviceModel: string | undefined;
    appCode: string | undefined;
    appVersion: number;
    language: string | undefined;
    driverStatus: string | undefined;
}

export enum DriverStatus {
    Logged_in = 0,
    Logged_off = 1,
    Clocked_in = 2,
    Clocked_out = 3,
}

export class MobileClientListDto implements IMobileClientListDto {
    id!: number;
    osName!: string | undefined;
    osVersion!: string | undefined;
    deviceModel!: string | undefined;
    appVersion!: number;
    driverStatus!: DriverStatus;

    constructor(data?: IMobileClientListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.osName = data["osName"];
            this.osVersion = data["osVersion"];
            this.deviceModel = data["deviceModel"];
            this.appVersion = data["appVersion"];
            this.driverStatus = data["driverStatus"];
        }
    }

    static fromJS(data: any): MobileClientListDto {
        data = typeof data === 'object' ? data : {};
        let result = new MobileClientListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["osName"] = this.osName;
        data["osVersion"] = this.osVersion;
        data["deviceModel"] = this.deviceModel;
        data["appVersion"] = this.appVersion;
        data["driverStatus"] = this.driverStatus;
        return data; 
    }
}

export interface IMobileClientListDto {
    id: number;
    osName: string | undefined;
    osVersion: string | undefined;
    deviceModel: string | undefined;
    appVersion: number;
    driverStatus: DriverStatus;
}

export class PagedResultDtoOfMobileClientListDto implements IPagedResultDtoOfMobileClientListDto {
    totalCount!: number;
    items!: MobileClientListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfMobileClientListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(MobileClientListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfMobileClientListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfMobileClientListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfMobileClientListDto {
    totalCount: number;
    items: MobileClientListDto[] | undefined;
}

export class UpdateMobileClientInput implements IUpdateMobileClientInput {
    id!: number;
    osName!: string | undefined;
    osVersion!: string | undefined;
    deviceModel!: string | undefined;
    appVersion!: number;
    driverStatus!: DriverStatus;

    constructor(data?: IUpdateMobileClientInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.osName = data["osName"];
            this.osVersion = data["osVersion"];
            this.deviceModel = data["deviceModel"];
            this.appVersion = data["appVersion"];
            this.driverStatus = data["driverStatus"];
        }
    }

    static fromJS(data: any): UpdateMobileClientInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateMobileClientInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["osName"] = this.osName;
        data["osVersion"] = this.osVersion;
        data["deviceModel"] = this.deviceModel;
        data["appVersion"] = this.appVersion;
        data["driverStatus"] = this.driverStatus;
        return data; 
    }
}

export interface IUpdateMobileClientInput {
    id: number;
    osName: string | undefined;
    osVersion: string | undefined;
    deviceModel: string | undefined;
    appVersion: number;
    driverStatus: DriverStatus;
}

export class GetMobileUserPreferenceCodesListItemDto implements IGetMobileUserPreferenceCodesListItemDto {
    userPreferenceCode!: string | undefined;

    constructor(data?: IGetMobileUserPreferenceCodesListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userPreferenceCode = data["userPreferenceCode"];
        }
    }

    static fromJS(data: any): GetMobileUserPreferenceCodesListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileUserPreferenceCodesListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userPreferenceCode"] = this.userPreferenceCode;
        return data; 
    }
}

export interface IGetMobileUserPreferenceCodesListItemDto {
    userPreferenceCode: string | undefined;
}

export class GetMobileUserPreferenceCodesResultDto implements IGetMobileUserPreferenceCodesResultDto {
    items!: GetMobileUserPreferenceCodesListItemDto[] | undefined;

    constructor(data?: IGetMobileUserPreferenceCodesResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetMobileUserPreferenceCodesListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetMobileUserPreferenceCodesResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileUserPreferenceCodesResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetMobileUserPreferenceCodesResultDto {
    items: GetMobileUserPreferenceCodesListItemDto[] | undefined;
}

export class RoleEditDto implements IRoleEditDto {
    id!: number | undefined;
    displayName!: string;
    isDefault!: boolean;

    constructor(data?: IRoleEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
            this.isDefault = data["isDefault"];
        }
    }

    static fromJS(data: any): RoleEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new RoleEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        data["isDefault"] = this.isDefault;
        return data; 
    }
}

export interface IRoleEditDto {
    id: number | undefined;
    displayName: string;
    isDefault: boolean;
}

export class ListResultDtoOfRoleEditDto implements IListResultDtoOfRoleEditDto {
    items!: RoleEditDto[] | undefined;

    constructor(data?: IListResultDtoOfRoleEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RoleEditDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfRoleEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfRoleEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfRoleEditDto {
    items: RoleEditDto[] | undefined;
}

export class CreateLogInUnlockCode implements ICreateLogInUnlockCode {
    userName!: string | undefined;

    constructor(data?: ICreateLogInUnlockCode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userName = data["userName"];
        }
    }

    static fromJS(data: any): CreateLogInUnlockCode {
        data = typeof data === 'object' ? data : {};
        let result = new CreateLogInUnlockCode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userName"] = this.userName;
        return data; 
    }
}

export interface ICreateLogInUnlockCode {
    userName: string | undefined;
}

export class ValidateLogInUnlockCodeInput implements IValidateLogInUnlockCodeInput {
    code!: string | undefined;

    constructor(data?: IValidateLogInUnlockCodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
        }
    }

    static fromJS(data: any): ValidateLogInUnlockCodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new ValidateLogInUnlockCodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        return data; 
    }
}

export interface IValidateLogInUnlockCodeInput {
    code: string | undefined;
}

export class CreateMobileClientMessageInputDto implements ICreateMobileClientMessageInputDto {
    action!: MobileClientMessageAction;
    content!: string | undefined;
    userId!: number;

    constructor(data?: ICreateMobileClientMessageInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.action = data["action"];
            this.content = data["content"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): CreateMobileClientMessageInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateMobileClientMessageInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["action"] = this.action;
        data["content"] = this.content;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface ICreateMobileClientMessageInputDto {
    action: MobileClientMessageAction;
    content: string | undefined;
    userId: number;
}

export class GetMobileClientMessageResultDto implements IGetMobileClientMessageResultDto {
    id!: number;
    action!: MobileClientMessageAction;
    content!: string | undefined;
    isRead!: boolean;
    dateCreated!: moment.Moment;

    constructor(data?: IGetMobileClientMessageResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.action = data["action"];
            this.content = data["content"];
            this.isRead = data["isRead"];
            this.dateCreated = data["dateCreated"] ? moment(data["dateCreated"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetMobileClientMessageResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileClientMessageResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["action"] = this.action;
        data["content"] = this.content;
        data["isRead"] = this.isRead;
        data["dateCreated"] = this.dateCreated ? this.dateCreated.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetMobileClientMessageResultDto {
    id: number;
    action: MobileClientMessageAction;
    content: string | undefined;
    isRead: boolean;
    dateCreated: moment.Moment;
}

export class PagedResultDtoOfGetMobileClientMessageResultDto implements IPagedResultDtoOfGetMobileClientMessageResultDto {
    totalCount!: number;
    items!: GetMobileClientMessageResultDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetMobileClientMessageResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetMobileClientMessageResultDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetMobileClientMessageResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetMobileClientMessageResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetMobileClientMessageResultDto {
    totalCount: number;
    items: GetMobileClientMessageResultDto[] | undefined;
}

export class UpdateMobileClientMessageInputDto implements IUpdateMobileClientMessageInputDto {
    id!: number;
    tenantId!: number | undefined;
    userId!: number | undefined;
    action!: MobileClientMessageAction | undefined;
    isRead!: boolean | undefined;
    content!: string | undefined;

    constructor(data?: IUpdateMobileClientMessageInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.action = data["action"];
            this.isRead = data["isRead"];
            this.content = data["content"];
        }
    }

    static fromJS(data: any): UpdateMobileClientMessageInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateMobileClientMessageInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["action"] = this.action;
        data["isRead"] = this.isRead;
        data["content"] = this.content;
        return data; 
    }
}

export interface IUpdateMobileClientMessageInputDto {
    id: number;
    tenantId: number | undefined;
    userId: number | undefined;
    action: MobileClientMessageAction | undefined;
    isRead: boolean | undefined;
    content: string | undefined;
}

export class TestSendMessageInputDto implements ITestSendMessageInputDto {
    userName!: string | undefined;
    message!: string | undefined;

    constructor(data?: ITestSendMessageInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userName = data["userName"];
            this.message = data["message"];
        }
    }

    static fromJS(data: any): TestSendMessageInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new TestSendMessageInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userName"] = this.userName;
        data["message"] = this.message;
        return data; 
    }
}

export interface ITestSendMessageInputDto {
    userName: string | undefined;
    message: string | undefined;
}

export class CreateOrUpdateForTenantInputDto implements ICreateOrUpdateForTenantInputDto {
    tenancyName!: string | undefined;
    code!: string | undefined;

    constructor(data?: ICreateOrUpdateForTenantInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): CreateOrUpdateForTenantInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateForTenantInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["code"] = this.code;
        return data; 
    }
}

export interface ICreateOrUpdateForTenantInputDto {
    tenancyName: string | undefined;
    code: string | undefined;
}

export class GetMobileThemeTenantDto implements IGetMobileThemeTenantDto {
    id!: number;
    name!: string | undefined;
    tenancyName!: string | undefined;
    mobileTheme!: GetMobileThemeListDto[] | undefined;

    constructor(data?: IGetMobileThemeTenantDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.tenancyName = data["tenancyName"];
            if (Array.isArray(data["mobileTheme"])) {
                this.mobileTheme = [] as any;
                for (let item of data["mobileTheme"])
                    this.mobileTheme!.push(GetMobileThemeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetMobileThemeTenantDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileThemeTenantDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["tenancyName"] = this.tenancyName;
        if (Array.isArray(this.mobileTheme)) {
            data["mobileTheme"] = [];
            for (let item of this.mobileTheme)
                data["mobileTheme"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetMobileThemeTenantDto {
    id: number;
    name: string | undefined;
    tenancyName: string | undefined;
    mobileTheme: GetMobileThemeListDto[] | undefined;
}

export class CreateMobileThemeInput implements ICreateMobileThemeInput {
    tenantId!: number;
    attribute!: string | undefined;
    base64Value!: string | undefined;

    constructor(data?: ICreateMobileThemeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.attribute = data["attribute"];
            this.base64Value = data["base64Value"];
        }
    }

    static fromJS(data: any): CreateMobileThemeInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateMobileThemeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["attribute"] = this.attribute;
        data["base64Value"] = this.base64Value;
        return data; 
    }
}

export interface ICreateMobileThemeInput {
    tenantId: number;
    attribute: string | undefined;
    base64Value: string | undefined;
}

export class UpdateMobileThemeInput implements IUpdateMobileThemeInput {
    id!: number;
    tenantId!: number;
    attribute!: string | undefined;
    base64Value!: string | undefined;

    constructor(data?: IUpdateMobileThemeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.attribute = data["attribute"];
            this.base64Value = data["base64Value"];
        }
    }

    static fromJS(data: any): UpdateMobileThemeInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateMobileThemeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["attribute"] = this.attribute;
        data["base64Value"] = this.base64Value;
        return data; 
    }
}

export interface IUpdateMobileThemeInput {
    id: number;
    tenantId: number;
    attribute: string | undefined;
    base64Value: string | undefined;
}

export class PagedResultDtoOfGetMobileThemeTenantDto implements IPagedResultDtoOfGetMobileThemeTenantDto {
    totalCount!: number;
    items!: GetMobileThemeTenantDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetMobileThemeTenantDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetMobileThemeTenantDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetMobileThemeTenantDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetMobileThemeTenantDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetMobileThemeTenantDto {
    totalCount: number;
    items: GetMobileThemeTenantDto[] | undefined;
}

export enum MobileThemeType {
    Logo = 0,
    Primary = 1,
    PrimaryDark = 2,
    Accent = 3,
    BaseUrl = 4,
    ProximityLock = 5,
    BlindCountLimit = 6,
    ShowOrderIncident = 7,
    PodSizeLimit = 8,
    ShowPickedUpQty = 9,
    PodWidth = 10,
    ProximityLock_SendPickup = 11,
    AutoLogOffDelay = 12,
    LocationServiceUpdateInterval = 13,
    LocationServiceUpdateDistance = 14,
    TokenRefresh = 15,
    PickupStartRoute = 16,
    DroidLocServiceUpdateDistance = 17,
    AcceptAllWillCall = 18,
    BatchRequestEnabled = 19,
    RouteRefreshInterval = 20,
    EnableEtaLock = 21,
    EnableEtaLockValidation = 22,
    ShowCallButton = 23,
    LockTransactionLocation = 24,
    RouteOrderLock = 25,
    CacheDataValidity = 26,
    SendCacheDataEnabled = 27,
    LhBlindCountLimit = 28,
    SkipKnockAndTag = 29,
    SkipLockBox = 30,
    WarehousePickupCode = 31,
    ObsoleteClientLimit = 32,
    NoFleetLimit = 33,
    HideExpressPickup = 34,
    RouteMenuTitle = 35,
    ShowExpressDelivery = 36,
    RouteScreenSearch = 37,
    RequireNotes = 38,
    RequireAttachments = 39,
    ShowExpressPickupRoute = 40,
    RouteCompletionCheckInterval = 41,
    LocationMinimumUpdateInterval = 42,
    SkipDeliveryScanOrder = 43,
    OptionalSignatureInputField = 44,
    AddInTransitAfterStartRoute = 45,
    AddInTransitBeforeArrival = 46,
}

export class GetMobileThemeAttributesListItemDto implements IGetMobileThemeAttributesListItemDto {
    typeId!: MobileThemeType;
    name!: string | undefined;
    hintText!: string | undefined;
    data!: { [key: string]: string; } | undefined;

    constructor(data?: IGetMobileThemeAttributesListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.typeId = data["typeId"];
            this.name = data["name"];
            this.hintText = data["hintText"];
            if (data["data"]) {
                this.data = {} as any;
                for (let key in data["data"]) {
                    if (data["data"].hasOwnProperty(key))
                        this.data![key] = data["data"][key];
                }
            }
        }
    }

    static fromJS(data: any): GetMobileThemeAttributesListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileThemeAttributesListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["typeId"] = this.typeId;
        data["name"] = this.name;
        data["hintText"] = this.hintText;
        if (this.data) {
            data["data"] = {};
            for (let key in this.data) {
                if (this.data.hasOwnProperty(key))
                    data["data"][key] = this.data[key];
            }
        }
        return data; 
    }
}

export interface IGetMobileThemeAttributesListItemDto {
    typeId: MobileThemeType;
    name: string | undefined;
    hintText: string | undefined;
    data: { [key: string]: string; } | undefined;
}

export class GetMobileThemeAttributesDto implements IGetMobileThemeAttributesDto {
    items!: GetMobileThemeAttributesListItemDto[] | undefined;

    constructor(data?: IGetMobileThemeAttributesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetMobileThemeAttributesListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetMobileThemeAttributesDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetMobileThemeAttributesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetMobileThemeAttributesDto {
    items: GetMobileThemeAttributesListItemDto[] | undefined;
}

export class PagedResultDtoOfGetMobileThemeListDto implements IPagedResultDtoOfGetMobileThemeListDto {
    totalCount!: number;
    items!: GetMobileThemeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetMobileThemeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetMobileThemeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetMobileThemeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetMobileThemeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetMobileThemeListDto {
    totalCount: number;
    items: GetMobileThemeListDto[] | undefined;
}

export class GetHostMobileThemeListDto implements IGetHostMobileThemeListDto {
    id!: number;
    tenantId!: number;
    attribute!: string | undefined;
    value!: string | undefined;
    tenantName!: string | undefined;

    constructor(data?: IGetHostMobileThemeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.attribute = data["attribute"];
            this.value = data["value"];
            this.tenantName = data["tenantName"];
        }
    }

    static fromJS(data: any): GetHostMobileThemeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetHostMobileThemeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["attribute"] = this.attribute;
        data["value"] = this.value;
        data["tenantName"] = this.tenantName;
        return data; 
    }
}

export interface IGetHostMobileThemeListDto {
    id: number;
    tenantId: number;
    attribute: string | undefined;
    value: string | undefined;
    tenantName: string | undefined;
}

export class PagedResultDtoOfGetHostMobileThemeListDto implements IPagedResultDtoOfGetHostMobileThemeListDto {
    totalCount!: number;
    items!: GetHostMobileThemeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetHostMobileThemeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetHostMobileThemeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetHostMobileThemeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetHostMobileThemeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetHostMobileThemeListDto {
    totalCount: number;
    items: GetHostMobileThemeListDto[] | undefined;
}

export class CreateOrUpdateThemeInputDto implements ICreateOrUpdateThemeInputDto {
    type!: MobileThemeType;
    base64Value!: string | undefined;

    constructor(data?: ICreateOrUpdateThemeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.type = data["type"];
            this.base64Value = data["base64Value"];
        }
    }

    static fromJS(data: any): CreateOrUpdateThemeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateThemeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["type"] = this.type;
        data["base64Value"] = this.base64Value;
        return data; 
    }
}

export interface ICreateOrUpdateThemeInputDto {
    type: MobileThemeType;
    base64Value: string | undefined;
}

export class CreateOrUpdateHostThemeInputDto implements ICreateOrUpdateHostThemeInputDto {
    tenantId!: number;
    type!: MobileThemeType;
    base64Value!: string | undefined;

    constructor(data?: ICreateOrUpdateHostThemeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.type = data["type"];
            this.base64Value = data["base64Value"];
        }
    }

    static fromJS(data: any): CreateOrUpdateHostThemeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateHostThemeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["type"] = this.type;
        data["base64Value"] = this.base64Value;
        return data; 
    }
}

export interface ICreateOrUpdateHostThemeInputDto {
    tenantId: number;
    type: MobileThemeType;
    base64Value: string | undefined;
}

export class TenantListDropDown implements ITenantListDropDown {
    id!: number;
    name!: string | undefined;

    constructor(data?: ITenantListDropDown) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): TenantListDropDown {
        data = typeof data === 'object' ? data : {};
        let result = new TenantListDropDown();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface ITenantListDropDown {
    id: number;
    name: string | undefined;
}

export class ListResultDtoOfTenantListDropDown implements IListResultDtoOfTenantListDropDown {
    items!: TenantListDropDown[] | undefined;

    constructor(data?: IListResultDtoOfTenantListDropDown) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TenantListDropDown.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfTenantListDropDown {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfTenantListDropDown();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfTenantListDropDown {
    items: TenantListDropDown[] | undefined;
}

export class PagedResultDtoOfNoteListDto implements IPagedResultDtoOfNoteListDto {
    totalCount!: number;
    items!: NoteListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfNoteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(NoteListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfNoteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfNoteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfNoteListDto {
    totalCount: number;
    items: NoteListDto[] | undefined;
}

export enum UserNotificationState {
    Unread = 0,
    Read = 1,
}

export class NotificationData implements INotificationData {
    readonly type!: string | undefined;
    properties!: { [key: string]: any; } | undefined;

    constructor(data?: INotificationData) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).type = data["type"];
            if (data["properties"]) {
                this.properties = {} as any;
                for (let key in data["properties"]) {
                    if (data["properties"].hasOwnProperty(key))
                        this.properties![key] = data["properties"][key];
                }
            }
        }
    }

    static fromJS(data: any): NotificationData {
        data = typeof data === 'object' ? data : {};
        let result = new NotificationData();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["type"] = this.type;
        if (this.properties) {
            data["properties"] = {};
            for (let key in this.properties) {
                if (this.properties.hasOwnProperty(key))
                    data["properties"][key] = this.properties[key];
            }
        }
        return data; 
    }
}

export interface INotificationData {
    type: string | undefined;
    properties: { [key: string]: any; } | undefined;
}

export enum NotificationSeverity {
    Info = 0,
    Success = 1,
    Warn = 2,
    Error = 3,
    Fatal = 4,
}

export class TenantNotification implements ITenantNotification {
    tenantId!: number | undefined;
    notificationName!: string | undefined;
    data!: NotificationData | undefined;
    entityType!: Type | undefined;
    entityTypeName!: string | undefined;
    entityId!: any | undefined;
    severity!: NotificationSeverity;
    creationTime!: moment.Moment;
    id!: string;

    constructor(data?: ITenantNotification) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.notificationName = data["notificationName"];
            this.data = data["data"] ? NotificationData.fromJS(data["data"]) : <any>undefined;
            this.entityType = data["entityType"] ? Type.fromJS(data["entityType"]) : <any>undefined;
            this.entityTypeName = data["entityTypeName"];
            this.entityId = data["entityId"];
            this.severity = data["severity"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TenantNotification {
        data = typeof data === 'object' ? data : {};
        let result = new TenantNotification();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["notificationName"] = this.notificationName;
        data["data"] = this.data ? this.data.toJSON() : <any>undefined;
        data["entityType"] = this.entityType ? this.entityType.toJSON() : <any>undefined;
        data["entityTypeName"] = this.entityTypeName;
        data["entityId"] = this.entityId;
        data["severity"] = this.severity;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITenantNotification {
    tenantId: number | undefined;
    notificationName: string | undefined;
    data: NotificationData | undefined;
    entityType: Type | undefined;
    entityTypeName: string | undefined;
    entityId: any | undefined;
    severity: NotificationSeverity;
    creationTime: moment.Moment;
    id: string;
}

export class UserNotification implements IUserNotification {
    tenantId!: number | undefined;
    userId!: number;
    state!: UserNotificationState;
    notification!: TenantNotification | undefined;
    id!: string;

    constructor(data?: IUserNotification) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.state = data["state"];
            this.notification = data["notification"] ? TenantNotification.fromJS(data["notification"]) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserNotification {
        data = typeof data === 'object' ? data : {};
        let result = new UserNotification();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["state"] = this.state;
        data["notification"] = this.notification ? this.notification.toJSON() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserNotification {
    tenantId: number | undefined;
    userId: number;
    state: UserNotificationState;
    notification: TenantNotification | undefined;
    id: string;
}

export class GetNotificationsOutput implements IGetNotificationsOutput {
    unreadCount!: number;
    totalCount!: number;
    items!: UserNotification[] | undefined;

    constructor(data?: IGetNotificationsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.unreadCount = data["unreadCount"];
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(UserNotification.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetNotificationsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetNotificationsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["unreadCount"] = this.unreadCount;
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetNotificationsOutput {
    unreadCount: number;
    totalCount: number;
    items: UserNotification[] | undefined;
}

export class EntityDtoOfGuid implements IEntityDtoOfGuid {
    id!: string;

    constructor(data?: IEntityDtoOfGuid) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EntityDtoOfGuid {
        data = typeof data === 'object' ? data : {};
        let result = new EntityDtoOfGuid();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        return data; 
    }
}

export interface IEntityDtoOfGuid {
    id: string;
}

export class NotificationSubscriptionWithDisplayNameDto implements INotificationSubscriptionWithDisplayNameDto {
    displayName!: string | undefined;
    description!: string | undefined;
    name!: string;
    isSubscribed!: boolean;

    constructor(data?: INotificationSubscriptionWithDisplayNameDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.displayName = data["displayName"];
            this.description = data["description"];
            this.name = data["name"];
            this.isSubscribed = data["isSubscribed"];
        }
    }

    static fromJS(data: any): NotificationSubscriptionWithDisplayNameDto {
        data = typeof data === 'object' ? data : {};
        let result = new NotificationSubscriptionWithDisplayNameDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["displayName"] = this.displayName;
        data["description"] = this.description;
        data["name"] = this.name;
        data["isSubscribed"] = this.isSubscribed;
        return data; 
    }
}

export interface INotificationSubscriptionWithDisplayNameDto {
    displayName: string | undefined;
    description: string | undefined;
    name: string;
    isSubscribed: boolean;
}

export class GetNotificationSettingsOutput implements IGetNotificationSettingsOutput {
    receiveNotifications!: boolean;
    notifications!: NotificationSubscriptionWithDisplayNameDto[] | undefined;

    constructor(data?: IGetNotificationSettingsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.receiveNotifications = data["receiveNotifications"];
            if (Array.isArray(data["notifications"])) {
                this.notifications = [] as any;
                for (let item of data["notifications"])
                    this.notifications!.push(NotificationSubscriptionWithDisplayNameDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetNotificationSettingsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetNotificationSettingsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["receiveNotifications"] = this.receiveNotifications;
        if (Array.isArray(this.notifications)) {
            data["notifications"] = [];
            for (let item of this.notifications)
                data["notifications"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetNotificationSettingsOutput {
    receiveNotifications: boolean;
    notifications: NotificationSubscriptionWithDisplayNameDto[] | undefined;
}

export class NotificationSubscriptionDto implements INotificationSubscriptionDto {
    name!: string;
    isSubscribed!: boolean;

    constructor(data?: INotificationSubscriptionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.isSubscribed = data["isSubscribed"];
        }
    }

    static fromJS(data: any): NotificationSubscriptionDto {
        data = typeof data === 'object' ? data : {};
        let result = new NotificationSubscriptionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["isSubscribed"] = this.isSubscribed;
        return data; 
    }
}

export interface INotificationSubscriptionDto {
    name: string;
    isSubscribed: boolean;
}

export class UpdateNotificationSettingsInput implements IUpdateNotificationSettingsInput {
    receiveNotifications!: boolean;
    notifications!: NotificationSubscriptionDto[] | undefined;

    constructor(data?: IUpdateNotificationSettingsInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.receiveNotifications = data["receiveNotifications"];
            if (Array.isArray(data["notifications"])) {
                this.notifications = [] as any;
                for (let item of data["notifications"])
                    this.notifications!.push(NotificationSubscriptionDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UpdateNotificationSettingsInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateNotificationSettingsInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["receiveNotifications"] = this.receiveNotifications;
        if (Array.isArray(this.notifications)) {
            data["notifications"] = [];
            for (let item of this.notifications)
                data["notifications"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUpdateNotificationSettingsInput {
    receiveNotifications: boolean;
    notifications: NotificationSubscriptionDto[] | undefined;
}

export class ContactAddressCheckerInput implements IContactAddressCheckerInput {
    addressLine1!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    country!: string | undefined;
    postalCode!: string | undefined;
    formattedAddress!: string | undefined;
    latitude!: number;
    longitude!: number;

    constructor(data?: IContactAddressCheckerInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressLine1 = data["addressLine1"];
            this.city = data["city"];
            this.state = data["state"];
            this.country = data["country"];
            this.postalCode = data["postalCode"];
            this.formattedAddress = data["formattedAddress"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): ContactAddressCheckerInput {
        data = typeof data === 'object' ? data : {};
        let result = new ContactAddressCheckerInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressLine1"] = this.addressLine1;
        data["city"] = this.city;
        data["state"] = this.state;
        data["country"] = this.country;
        data["postalCode"] = this.postalCode;
        data["formattedAddress"] = this.formattedAddress;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface IContactAddressCheckerInput {
    addressLine1: string | undefined;
    city: string | undefined;
    state: string | undefined;
    country: string | undefined;
    postalCode: string | undefined;
    formattedAddress: string | undefined;
    latitude: number;
    longitude: number;
}

export class ContactAddressCheckerResult implements IContactAddressCheckerResult {
    firstName!: string | undefined;
    lastName!: string | undefined;
    email!: string | undefined;
    phone!: string | undefined;
    contactId!: number;
    postalCodeId!: number;
    geocodeId!: number | undefined;

    constructor(data?: IContactAddressCheckerResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.email = data["email"];
            this.phone = data["phone"];
            this.contactId = data["contactId"];
            this.postalCodeId = data["postalCodeId"];
            this.geocodeId = data["geocodeId"];
        }
    }

    static fromJS(data: any): ContactAddressCheckerResult {
        data = typeof data === 'object' ? data : {};
        let result = new ContactAddressCheckerResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["email"] = this.email;
        data["phone"] = this.phone;
        data["contactId"] = this.contactId;
        data["postalCodeId"] = this.postalCodeId;
        data["geocodeId"] = this.geocodeId;
        return data; 
    }
}

export interface IContactAddressCheckerResult {
    firstName: string | undefined;
    lastName: string | undefined;
    email: string | undefined;
    phone: string | undefined;
    contactId: number;
    postalCodeId: number;
    geocodeId: number | undefined;
}

export class GenerateEtaErrorCodeInputDto implements IGenerateEtaErrorCodeInputDto {
    orderId!: number;
    statusId!: number;
    latitude!: number;
    longitude!: number;
    time!: moment.Moment;

    constructor(data?: IGenerateEtaErrorCodeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.statusId = data["statusId"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GenerateEtaErrorCodeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new GenerateEtaErrorCodeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["statusId"] = this.statusId;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGenerateEtaErrorCodeInputDto {
    orderId: number;
    statusId: number;
    latitude: number;
    longitude: number;
    time: moment.Moment;
}

export class ValidateEtaErrorCodeInputDto implements IValidateEtaErrorCodeInputDto {
    orderId!: number;
    statusId!: number;
    code!: string | undefined;

    constructor(data?: IValidateEtaErrorCodeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.statusId = data["statusId"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): ValidateEtaErrorCodeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new ValidateEtaErrorCodeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["statusId"] = this.statusId;
        data["code"] = this.code;
        return data; 
    }
}

export interface IValidateEtaErrorCodeInputDto {
    orderId: number;
    statusId: number;
    code: string | undefined;
}

export class GenerateHandoffValidationCodeInputDto implements IGenerateHandoffValidationCodeInputDto {
    orderId!: number;
    latitude!: number;
    longitude!: number;

    constructor(data?: IGenerateHandoffValidationCodeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): GenerateHandoffValidationCodeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new GenerateHandoffValidationCodeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface IGenerateHandoffValidationCodeInputDto {
    orderId: number;
    latitude: number;
    longitude: number;
}

export class ValidateHandOffValidationCodeInputDto implements IValidateHandOffValidationCodeInputDto {
    orderId!: number;
    code!: string | undefined;

    constructor(data?: IValidateHandOffValidationCodeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): ValidateHandOffValidationCodeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new ValidateHandOffValidationCodeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["code"] = this.code;
        return data; 
    }
}

export interface IValidateHandOffValidationCodeInputDto {
    orderId: number;
    code: string | undefined;
}

export class KeyValuePairOfStringString implements IKeyValuePairOfStringString {
    readonly key!: string | undefined;
    readonly value!: string | undefined;

    constructor(data?: IKeyValuePairOfStringString) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).key = data["key"];
            (<any>this).value = data["value"];
        }
    }

    static fromJS(data: any): KeyValuePairOfStringString {
        data = typeof data === 'object' ? data : {};
        let result = new KeyValuePairOfStringString();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["key"] = this.key;
        data["value"] = this.value;
        return data; 
    }
}

export interface IKeyValuePairOfStringString {
    key: string | undefined;
    value: string | undefined;
}

export class NotifyContactInputDto implements INotifyContactInputDto {
    orderId!: number;
    value!: string | undefined;
    latitude!: number | undefined;
    longitude!: number | undefined;

    constructor(data?: INotifyContactInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.value = data["value"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): NotifyContactInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new NotifyContactInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["value"] = this.value;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface INotifyContactInputDto {
    orderId: number;
    value: string | undefined;
    latitude: number | undefined;
    longitude: number | undefined;
}

export class GetCreatorUsers implements IGetCreatorUsers {
    name!: string | undefined;
    userId!: number;

    constructor(data?: IGetCreatorUsers) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): GetCreatorUsers {
        data = typeof data === 'object' ? data : {};
        let result = new GetCreatorUsers();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IGetCreatorUsers {
    name: string | undefined;
    userId: number;
}

export class IntStringDto implements IIntStringDto {
    id!: number;
    name!: string | undefined;

    constructor(data?: IIntStringDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): IntStringDto {
        data = typeof data === 'object' ? data : {};
        let result = new IntStringDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IIntStringDto {
    id: number;
    name: string | undefined;
}

export class WarehousePickupOrderStatusTypeListItemDto implements IWarehousePickupOrderStatusTypeListItemDto {
    id!: number;
    code!: string | undefined;
    description!: string | undefined;

    constructor(data?: IWarehousePickupOrderStatusTypeListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
        }
    }

    static fromJS(data: any): WarehousePickupOrderStatusTypeListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new WarehousePickupOrderStatusTypeListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        return data; 
    }
}

export interface IWarehousePickupOrderStatusTypeListItemDto {
    id: number;
    code: string | undefined;
    description: string | undefined;
}

export class ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto implements IListResultDtoOfWarehousePickupOrderStatusTypeListItemDto {
    items!: WarehousePickupOrderStatusTypeListItemDto[] | undefined;

    constructor(data?: IListResultDtoOfWarehousePickupOrderStatusTypeListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(WarehousePickupOrderStatusTypeListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfWarehousePickupOrderStatusTypeListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfWarehousePickupOrderStatusTypeListItemDto {
    items: WarehousePickupOrderStatusTypeListItemDto[] | undefined;
}

export class TrackImportInput implements ITrackImportInput {
    jobId!: string | undefined;

    constructor(data?: ITrackImportInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.jobId = data["jobId"];
        }
    }

    static fromJS(data: any): TrackImportInput {
        data = typeof data === 'object' ? data : {};
        let result = new TrackImportInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["jobId"] = this.jobId;
        return data; 
    }
}

export interface ITrackImportInput {
    jobId: string | undefined;
}

export class TrackImportResult implements ITrackImportResult {
    success!: boolean;
    result!: string | undefined;

    constructor(data?: ITrackImportResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.success = data["success"];
            this.result = data["result"];
        }
    }

    static fromJS(data: any): TrackImportResult {
        data = typeof data === 'object' ? data : {};
        let result = new TrackImportResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["success"] = this.success;
        data["result"] = this.result;
        return data; 
    }
}

export interface ITrackImportResult {
    success: boolean;
    result: string | undefined;
}

export class UpdateOrderInput implements IUpdateOrderInput {
    id!: number;
    userId!: number;
    pickupDetailsId!: number;
    deliveryDetailsId!: number;
    locationId!: number;
    noteId!: number | undefined;

    constructor(data?: IUpdateOrderInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.pickupDetailsId = data["pickupDetailsId"];
            this.deliveryDetailsId = data["deliveryDetailsId"];
            this.locationId = data["locationId"];
            this.noteId = data["noteId"];
        }
    }

    static fromJS(data: any): UpdateOrderInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["pickupDetailsId"] = this.pickupDetailsId;
        data["deliveryDetailsId"] = this.deliveryDetailsId;
        data["locationId"] = this.locationId;
        data["noteId"] = this.noteId;
        return data; 
    }
}

export interface IUpdateOrderInput {
    id: number;
    userId: number;
    pickupDetailsId: number;
    deliveryDetailsId: number;
    locationId: number;
    noteId: number | undefined;
}

export class UpdateOrderSorting implements IUpdateOrderSorting {
    id!: number;
    sortOrder!: number;

    constructor(data?: IUpdateOrderSorting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): UpdateOrderSorting {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderSorting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IUpdateOrderSorting {
    id: number;
    sortOrder: number;
}

export class UpdateRouteTemplateAddressSorting implements IUpdateRouteTemplateAddressSorting {
    addressId!: number;
    routeTemplateId!: number;
    sortOrder!: number;

    constructor(data?: IUpdateRouteTemplateAddressSorting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressId = data["addressId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): UpdateRouteTemplateAddressSorting {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteTemplateAddressSorting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressId"] = this.addressId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IUpdateRouteTemplateAddressSorting {
    addressId: number;
    routeTemplateId: number;
    sortOrder: number;
}

export class UpdateRouteScheduleDetailSorting implements IUpdateRouteScheduleDetailSorting {
    id!: number;
    sortOrder!: number;

    constructor(data?: IUpdateRouteScheduleDetailSorting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): UpdateRouteScheduleDetailSorting {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteScheduleDetailSorting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IUpdateRouteScheduleDetailSorting {
    id: number;
    sortOrder: number;
}

export class UpdateOrderSortingInput implements IUpdateOrderSortingInput {
    sortingOrderInput!: UpdateOrderSorting[] | undefined;
    sortingRouteTemplateAddressInput!: UpdateRouteTemplateAddressSorting[] | undefined;
    sortingRouteScheduleDetailInput!: UpdateRouteScheduleDetailSorting[] | undefined;

    constructor(data?: IUpdateOrderSortingInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["sortingOrderInput"])) {
                this.sortingOrderInput = [] as any;
                for (let item of data["sortingOrderInput"])
                    this.sortingOrderInput!.push(UpdateOrderSorting.fromJS(item));
            }
            if (Array.isArray(data["sortingRouteTemplateAddressInput"])) {
                this.sortingRouteTemplateAddressInput = [] as any;
                for (let item of data["sortingRouteTemplateAddressInput"])
                    this.sortingRouteTemplateAddressInput!.push(UpdateRouteTemplateAddressSorting.fromJS(item));
            }
            if (Array.isArray(data["sortingRouteScheduleDetailInput"])) {
                this.sortingRouteScheduleDetailInput = [] as any;
                for (let item of data["sortingRouteScheduleDetailInput"])
                    this.sortingRouteScheduleDetailInput!.push(UpdateRouteScheduleDetailSorting.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UpdateOrderSortingInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderSortingInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.sortingOrderInput)) {
            data["sortingOrderInput"] = [];
            for (let item of this.sortingOrderInput)
                data["sortingOrderInput"].push(item.toJSON());
        }
        if (Array.isArray(this.sortingRouteTemplateAddressInput)) {
            data["sortingRouteTemplateAddressInput"] = [];
            for (let item of this.sortingRouteTemplateAddressInput)
                data["sortingRouteTemplateAddressInput"].push(item.toJSON());
        }
        if (Array.isArray(this.sortingRouteScheduleDetailInput)) {
            data["sortingRouteScheduleDetailInput"] = [];
            for (let item of this.sortingRouteScheduleDetailInput)
                data["sortingRouteScheduleDetailInput"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUpdateOrderSortingInput {
    sortingOrderInput: UpdateOrderSorting[] | undefined;
    sortingRouteTemplateAddressInput: UpdateRouteTemplateAddressSorting[] | undefined;
    sortingRouteScheduleDetailInput: UpdateRouteScheduleDetailSorting[] | undefined;
}

export class OrderStatusListName implements IOrderStatusListName {
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: IOrderStatusListName) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): OrderStatusListName {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusListName();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface IOrderStatusListName {
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class ControllerMoveOrderInput implements IControllerMoveOrderInput {
    selectedRouteId!: number | undefined;
    originRouteId!: number | undefined;
    id!: number[] | undefined;
    locationId!: number | undefined;
    date!: moment.Moment;
    routeOptimizationType!: string | undefined;
    userId!: number | undefined;
    statusId!: number | undefined;
    tenantId!: number | undefined;

    constructor(data?: IControllerMoveOrderInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.selectedRouteId = data["selectedRouteId"];
            this.originRouteId = data["originRouteId"];
            if (Array.isArray(data["id"])) {
                this.id = [] as any;
                for (let item of data["id"])
                    this.id!.push(item);
            }
            this.locationId = data["locationId"];
            this.date = data["date"] ? moment(data["date"].toString()) : <any>undefined;
            this.routeOptimizationType = data["routeOptimizationType"];
            this.userId = data["userId"];
            this.statusId = data["statusId"];
            this.tenantId = data["tenantId"];
        }
    }

    static fromJS(data: any): ControllerMoveOrderInput {
        data = typeof data === 'object' ? data : {};
        let result = new ControllerMoveOrderInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["selectedRouteId"] = this.selectedRouteId;
        data["originRouteId"] = this.originRouteId;
        if (Array.isArray(this.id)) {
            data["id"] = [];
            for (let item of this.id)
                data["id"].push(item);
        }
        data["locationId"] = this.locationId;
        data["date"] = this.date ? this.date.toISOString() : <any>undefined;
        data["routeOptimizationType"] = this.routeOptimizationType;
        data["userId"] = this.userId;
        data["statusId"] = this.statusId;
        data["tenantId"] = this.tenantId;
        return data; 
    }
}

export interface IControllerMoveOrderInput {
    selectedRouteId: number | undefined;
    originRouteId: number | undefined;
    id: number[] | undefined;
    locationId: number | undefined;
    date: moment.Moment;
    routeOptimizationType: string | undefined;
    userId: number | undefined;
    statusId: number | undefined;
    tenantId: number | undefined;
}

export class RemoveOrderInput implements IRemoveOrderInput {
    id!: number;
    routeId!: number;

    constructor(data?: IRemoveOrderInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): RemoveOrderInput {
        data = typeof data === 'object' ? data : {};
        let result = new RemoveOrderInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface IRemoveOrderInput {
    id: number;
    routeId: number;
}

export class RemoveOrderList implements IRemoveOrderList {
    removeOrderInput!: RemoveOrderInput[] | undefined;

    constructor(data?: IRemoveOrderList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["removeOrderInput"])) {
                this.removeOrderInput = [] as any;
                for (let item of data["removeOrderInput"])
                    this.removeOrderInput!.push(RemoveOrderInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): RemoveOrderList {
        data = typeof data === 'object' ? data : {};
        let result = new RemoveOrderList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.removeOrderInput)) {
            data["removeOrderInput"] = [];
            for (let item of this.removeOrderInput)
                data["removeOrderInput"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IRemoveOrderList {
    removeOrderInput: RemoveOrderInput[] | undefined;
}

export class UpdateCountInput implements IUpdateCountInput {
    orderId!: number;
    orderPackageId!: number;
    packageId!: number;
    quantity!: number;

    constructor(data?: IUpdateCountInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.orderPackageId = data["orderPackageId"];
            this.packageId = data["packageId"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): UpdateCountInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateCountInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["orderPackageId"] = this.orderPackageId;
        data["packageId"] = this.packageId;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface IUpdateCountInput {
    orderId: number;
    orderPackageId: number;
    packageId: number;
    quantity: number;
}

export class UpdateCountLHInput implements IUpdateCountLHInput {
    orderId!: number;
    containerId!: number;
    containerQuantity!: number;

    constructor(data?: IUpdateCountLHInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.containerId = data["containerId"];
            this.containerQuantity = data["containerQuantity"];
        }
    }

    static fromJS(data: any): UpdateCountLHInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateCountLHInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["containerId"] = this.containerId;
        data["containerQuantity"] = this.containerQuantity;
        return data; 
    }
}

export interface IUpdateCountLHInput {
    orderId: number;
    containerId: number;
    containerQuantity: number;
}

export class UpdateCountList implements IUpdateCountList {
    routeId!: number;
    notes!: string | undefined;
    updateCountInput!: UpdateCountInput[] | undefined;
    updateCountLHInput!: UpdateCountLHInput[] | undefined;

    constructor(data?: IUpdateCountList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.notes = data["notes"];
            if (Array.isArray(data["updateCountInput"])) {
                this.updateCountInput = [] as any;
                for (let item of data["updateCountInput"])
                    this.updateCountInput!.push(UpdateCountInput.fromJS(item));
            }
            if (Array.isArray(data["updateCountLHInput"])) {
                this.updateCountLHInput = [] as any;
                for (let item of data["updateCountLHInput"])
                    this.updateCountLHInput!.push(UpdateCountLHInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UpdateCountList {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateCountList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["notes"] = this.notes;
        if (Array.isArray(this.updateCountInput)) {
            data["updateCountInput"] = [];
            for (let item of this.updateCountInput)
                data["updateCountInput"].push(item.toJSON());
        }
        if (Array.isArray(this.updateCountLHInput)) {
            data["updateCountLHInput"] = [];
            for (let item of this.updateCountLHInput)
                data["updateCountLHInput"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUpdateCountList {
    routeId: number;
    notes: string | undefined;
    updateCountInput: UpdateCountInput[] | undefined;
    updateCountLHInput: UpdateCountLHInput[] | undefined;
}

export class GetOrderInput implements IGetOrderInput {
    id!: number | undefined;
    filter!: string | undefined;
    pickupDetailsId!: number | undefined;
    deliveryDetailsId!: number | undefined;
    locationId!: number | undefined;
    noteId!: number | undefined;
    creationTime!: moment.Moment | undefined;
    deliveryEta!: string | undefined;
    sortOrder!: number | undefined;
    orderTypeId!: number | undefined;
    orderId!: string | undefined;
    customerOrderNumberFilter!: string | undefined;
    trackingIdFilter!: string | undefined;
    unassigned!: boolean;
    currentOrders!: boolean;
    routeDate!: string | undefined;
    creationTimeString!: string | undefined;
    creator!: number | undefined;
    fullNameFilter!: string | undefined;
    addressLine1Filter!: string | undefined;
    cityFilter!: string | undefined;
    stateFilter!: string | undefined;
    postalCodeFilter!: string | undefined;
    firstNameFilter!: string | undefined;
    lastNameFilter!: string | undefined;
    creatorUserIds!: number[] | undefined;
    excludedUserIds!: number[] | undefined;
    isIntegration!: boolean;
    zoneFilter!: string | undefined;
    recurringOrderScheduleIdFilter!: number | undefined;
    multipleZoneFilter!: number[] | undefined;
    multipleDriverFilter!: number[] | undefined;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetOrderInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.filter = data["filter"];
            this.pickupDetailsId = data["pickupDetailsId"];
            this.deliveryDetailsId = data["deliveryDetailsId"];
            this.locationId = data["locationId"];
            this.noteId = data["noteId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.deliveryEta = data["deliveryEta"];
            this.sortOrder = data["sortOrder"];
            this.orderTypeId = data["orderTypeId"];
            this.orderId = data["orderId"];
            this.customerOrderNumberFilter = data["customerOrderNumberFilter"];
            this.trackingIdFilter = data["trackingIdFilter"];
            this.unassigned = data["unassigned"];
            this.currentOrders = data["currentOrders"];
            this.routeDate = data["routeDate"];
            this.creationTimeString = data["creationTimeString"];
            this.creator = data["creator"];
            this.fullNameFilter = data["fullNameFilter"];
            this.addressLine1Filter = data["addressLine1Filter"];
            this.cityFilter = data["cityFilter"];
            this.stateFilter = data["stateFilter"];
            this.postalCodeFilter = data["postalCodeFilter"];
            this.firstNameFilter = data["firstNameFilter"];
            this.lastNameFilter = data["lastNameFilter"];
            if (Array.isArray(data["creatorUserIds"])) {
                this.creatorUserIds = [] as any;
                for (let item of data["creatorUserIds"])
                    this.creatorUserIds!.push(item);
            }
            if (Array.isArray(data["excludedUserIds"])) {
                this.excludedUserIds = [] as any;
                for (let item of data["excludedUserIds"])
                    this.excludedUserIds!.push(item);
            }
            this.isIntegration = data["isIntegration"];
            this.zoneFilter = data["zoneFilter"];
            this.recurringOrderScheduleIdFilter = data["recurringOrderScheduleIdFilter"];
            if (Array.isArray(data["multipleZoneFilter"])) {
                this.multipleZoneFilter = [] as any;
                for (let item of data["multipleZoneFilter"])
                    this.multipleZoneFilter!.push(item);
            }
            if (Array.isArray(data["multipleDriverFilter"])) {
                this.multipleDriverFilter = [] as any;
                for (let item of data["multipleDriverFilter"])
                    this.multipleDriverFilter!.push(item);
            }
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetOrderInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["filter"] = this.filter;
        data["pickupDetailsId"] = this.pickupDetailsId;
        data["deliveryDetailsId"] = this.deliveryDetailsId;
        data["locationId"] = this.locationId;
        data["noteId"] = this.noteId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["deliveryEta"] = this.deliveryEta;
        data["sortOrder"] = this.sortOrder;
        data["orderTypeId"] = this.orderTypeId;
        data["orderId"] = this.orderId;
        data["customerOrderNumberFilter"] = this.customerOrderNumberFilter;
        data["trackingIdFilter"] = this.trackingIdFilter;
        data["unassigned"] = this.unassigned;
        data["currentOrders"] = this.currentOrders;
        data["routeDate"] = this.routeDate;
        data["creationTimeString"] = this.creationTimeString;
        data["creator"] = this.creator;
        data["fullNameFilter"] = this.fullNameFilter;
        data["addressLine1Filter"] = this.addressLine1Filter;
        data["cityFilter"] = this.cityFilter;
        data["stateFilter"] = this.stateFilter;
        data["postalCodeFilter"] = this.postalCodeFilter;
        data["firstNameFilter"] = this.firstNameFilter;
        data["lastNameFilter"] = this.lastNameFilter;
        if (Array.isArray(this.creatorUserIds)) {
            data["creatorUserIds"] = [];
            for (let item of this.creatorUserIds)
                data["creatorUserIds"].push(item);
        }
        if (Array.isArray(this.excludedUserIds)) {
            data["excludedUserIds"] = [];
            for (let item of this.excludedUserIds)
                data["excludedUserIds"].push(item);
        }
        data["isIntegration"] = this.isIntegration;
        data["zoneFilter"] = this.zoneFilter;
        data["recurringOrderScheduleIdFilter"] = this.recurringOrderScheduleIdFilter;
        if (Array.isArray(this.multipleZoneFilter)) {
            data["multipleZoneFilter"] = [];
            for (let item of this.multipleZoneFilter)
                data["multipleZoneFilter"].push(item);
        }
        if (Array.isArray(this.multipleDriverFilter)) {
            data["multipleDriverFilter"] = [];
            for (let item of this.multipleDriverFilter)
                data["multipleDriverFilter"].push(item);
        }
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetOrderInput {
    id: number | undefined;
    filter: string | undefined;
    pickupDetailsId: number | undefined;
    deliveryDetailsId: number | undefined;
    locationId: number | undefined;
    noteId: number | undefined;
    creationTime: moment.Moment | undefined;
    deliveryEta: string | undefined;
    sortOrder: number | undefined;
    orderTypeId: number | undefined;
    orderId: string | undefined;
    customerOrderNumberFilter: string | undefined;
    trackingIdFilter: string | undefined;
    unassigned: boolean;
    currentOrders: boolean;
    routeDate: string | undefined;
    creationTimeString: string | undefined;
    creator: number | undefined;
    fullNameFilter: string | undefined;
    addressLine1Filter: string | undefined;
    cityFilter: string | undefined;
    stateFilter: string | undefined;
    postalCodeFilter: string | undefined;
    firstNameFilter: string | undefined;
    lastNameFilter: string | undefined;
    creatorUserIds: number[] | undefined;
    excludedUserIds: number[] | undefined;
    isIntegration: boolean;
    zoneFilter: string | undefined;
    recurringOrderScheduleIdFilter: number | undefined;
    multipleZoneFilter: number[] | undefined;
    multipleDriverFilter: number[] | undefined;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class GetOrderListDtoNew implements IGetOrderListDtoNew {
    id!: number;
    tenantId!: number | undefined;
    customer!: string | undefined;
    pickUpFirstName!: string | undefined;
    pickUpLastName!: string | undefined;
    pickUpFullName!: string | undefined;
    location!: string | undefined;
    numberOfPackagesInOrder!: number;
    lastLog!: moment.Moment;
    status!: string | undefined;
    orderNumber!: string | undefined;
    trackingId!: string | undefined;
    orderTypeCode!: string | undefined;
    createdString!: string | undefined;
    lastModifiedString!: string | undefined;
    createDate!: moment.Moment;
    lastModifiedTime!: moment.Moment | undefined;
    routeDates!: moment.Moment | undefined;
    creator!: string | undefined;
    lastModifiedUser!: string | undefined;
    lastModifiedUserId!: number | undefined;
    driverId!: number | undefined;
    statusColor!: string | undefined;
    statusIcon!: string | undefined;
    statusName!: string | undefined;
    orderTypeColor!: string | undefined;
    orderTypeDescription!: string | undefined;
    deliveryFirstName!: string | undefined;
    deliveryLastName!: string | undefined;
    deliveryFullName!: string | undefined;
    driver!: string | undefined;
    route!: string | undefined;
    routeDate!: string | undefined;
    userId!: number | undefined;
    creatorUserId!: number | undefined;
    statusId!: number | undefined;
    timeZone!: string | undefined;
    locationId!: number;
    orderTypeId!: number | undefined;
    routeId!: number | undefined;
    incidentId!: number | undefined;
    orderTag!: string | undefined;
    zone!: string | undefined;
    recurringOrderScheduleDescription!: string | undefined;
    recurringOrderScheduleId!: number | undefined;
    deliveryAddress!: string | undefined;
    displayRouteId!: boolean | undefined;
    notes!: string | undefined;

    constructor(data?: IGetOrderListDtoNew) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.customer = data["customer"];
            this.pickUpFirstName = data["pickUpFirstName"];
            this.pickUpLastName = data["pickUpLastName"];
            this.pickUpFullName = data["pickUpFullName"];
            this.location = data["location"];
            this.numberOfPackagesInOrder = data["numberOfPackagesInOrder"];
            this.lastLog = data["lastLog"] ? moment(data["lastLog"].toString()) : <any>undefined;
            this.status = data["status"];
            this.orderNumber = data["orderNumber"];
            this.trackingId = data["trackingId"];
            this.orderTypeCode = data["orderTypeCode"];
            this.createdString = data["createdString"];
            this.lastModifiedString = data["lastModifiedString"];
            this.createDate = data["createDate"] ? moment(data["createDate"].toString()) : <any>undefined;
            this.lastModifiedTime = data["lastModifiedTime"] ? moment(data["lastModifiedTime"].toString()) : <any>undefined;
            this.routeDates = data["routeDates"] ? moment(data["routeDates"].toString()) : <any>undefined;
            this.creator = data["creator"];
            this.lastModifiedUser = data["lastModifiedUser"];
            this.lastModifiedUserId = data["lastModifiedUserId"];
            this.driverId = data["driverId"];
            this.statusColor = data["statusColor"];
            this.statusIcon = data["statusIcon"];
            this.statusName = data["statusName"];
            this.orderTypeColor = data["orderTypeColor"];
            this.orderTypeDescription = data["orderTypeDescription"];
            this.deliveryFirstName = data["deliveryFirstName"];
            this.deliveryLastName = data["deliveryLastName"];
            this.deliveryFullName = data["deliveryFullName"];
            this.driver = data["driver"];
            this.route = data["route"];
            this.routeDate = data["routeDate"];
            this.userId = data["userId"];
            this.creatorUserId = data["creatorUserId"];
            this.statusId = data["statusId"];
            this.timeZone = data["timeZone"];
            this.locationId = data["locationId"];
            this.orderTypeId = data["orderTypeId"];
            this.routeId = data["routeId"];
            this.incidentId = data["incidentId"];
            this.orderTag = data["orderTag"];
            this.zone = data["zone"];
            this.recurringOrderScheduleDescription = data["recurringOrderScheduleDescription"];
            this.recurringOrderScheduleId = data["recurringOrderScheduleId"];
            this.deliveryAddress = data["deliveryAddress"];
            this.displayRouteId = data["displayRouteId"];
            this.notes = data["notes"];
        }
    }

    static fromJS(data: any): GetOrderListDtoNew {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderListDtoNew();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["customer"] = this.customer;
        data["pickUpFirstName"] = this.pickUpFirstName;
        data["pickUpLastName"] = this.pickUpLastName;
        data["pickUpFullName"] = this.pickUpFullName;
        data["location"] = this.location;
        data["numberOfPackagesInOrder"] = this.numberOfPackagesInOrder;
        data["lastLog"] = this.lastLog ? this.lastLog.toISOString() : <any>undefined;
        data["status"] = this.status;
        data["orderNumber"] = this.orderNumber;
        data["trackingId"] = this.trackingId;
        data["orderTypeCode"] = this.orderTypeCode;
        data["createdString"] = this.createdString;
        data["lastModifiedString"] = this.lastModifiedString;
        data["createDate"] = this.createDate ? this.createDate.toISOString() : <any>undefined;
        data["lastModifiedTime"] = this.lastModifiedTime ? this.lastModifiedTime.toISOString() : <any>undefined;
        data["routeDates"] = this.routeDates ? this.routeDates.toISOString() : <any>undefined;
        data["creator"] = this.creator;
        data["lastModifiedUser"] = this.lastModifiedUser;
        data["lastModifiedUserId"] = this.lastModifiedUserId;
        data["driverId"] = this.driverId;
        data["statusColor"] = this.statusColor;
        data["statusIcon"] = this.statusIcon;
        data["statusName"] = this.statusName;
        data["orderTypeColor"] = this.orderTypeColor;
        data["orderTypeDescription"] = this.orderTypeDescription;
        data["deliveryFirstName"] = this.deliveryFirstName;
        data["deliveryLastName"] = this.deliveryLastName;
        data["deliveryFullName"] = this.deliveryFullName;
        data["driver"] = this.driver;
        data["route"] = this.route;
        data["routeDate"] = this.routeDate;
        data["userId"] = this.userId;
        data["creatorUserId"] = this.creatorUserId;
        data["statusId"] = this.statusId;
        data["timeZone"] = this.timeZone;
        data["locationId"] = this.locationId;
        data["orderTypeId"] = this.orderTypeId;
        data["routeId"] = this.routeId;
        data["incidentId"] = this.incidentId;
        data["orderTag"] = this.orderTag;
        data["zone"] = this.zone;
        data["recurringOrderScheduleDescription"] = this.recurringOrderScheduleDescription;
        data["recurringOrderScheduleId"] = this.recurringOrderScheduleId;
        data["deliveryAddress"] = this.deliveryAddress;
        data["displayRouteId"] = this.displayRouteId;
        data["notes"] = this.notes;
        return data; 
    }
}

export interface IGetOrderListDtoNew {
    id: number;
    tenantId: number | undefined;
    customer: string | undefined;
    pickUpFirstName: string | undefined;
    pickUpLastName: string | undefined;
    pickUpFullName: string | undefined;
    location: string | undefined;
    numberOfPackagesInOrder: number;
    lastLog: moment.Moment;
    status: string | undefined;
    orderNumber: string | undefined;
    trackingId: string | undefined;
    orderTypeCode: string | undefined;
    createdString: string | undefined;
    lastModifiedString: string | undefined;
    createDate: moment.Moment;
    lastModifiedTime: moment.Moment | undefined;
    routeDates: moment.Moment | undefined;
    creator: string | undefined;
    lastModifiedUser: string | undefined;
    lastModifiedUserId: number | undefined;
    driverId: number | undefined;
    statusColor: string | undefined;
    statusIcon: string | undefined;
    statusName: string | undefined;
    orderTypeColor: string | undefined;
    orderTypeDescription: string | undefined;
    deliveryFirstName: string | undefined;
    deliveryLastName: string | undefined;
    deliveryFullName: string | undefined;
    driver: string | undefined;
    route: string | undefined;
    routeDate: string | undefined;
    userId: number | undefined;
    creatorUserId: number | undefined;
    statusId: number | undefined;
    timeZone: string | undefined;
    locationId: number;
    orderTypeId: number | undefined;
    routeId: number | undefined;
    incidentId: number | undefined;
    orderTag: string | undefined;
    zone: string | undefined;
    recurringOrderScheduleDescription: string | undefined;
    recurringOrderScheduleId: number | undefined;
    deliveryAddress: string | undefined;
    displayRouteId: boolean | undefined;
    notes: string | undefined;
}

export class PagedResultDtoOfGetOrderListDtoNew implements IPagedResultDtoOfGetOrderListDtoNew {
    totalCount!: number;
    items!: GetOrderListDtoNew[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderListDtoNew) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderListDtoNew.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderListDtoNew {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderListDtoNew();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderListDtoNew {
    totalCount: number;
    items: GetOrderListDtoNew[] | undefined;
}

export class GetOrderListTimezoneInput implements IGetOrderListTimezoneInput {
    id!: number | undefined;
    filter!: string | undefined;
    routeCode!: string | undefined;
    locationId!: number | undefined;
    routeId!: string | undefined;
    orderTag!: string | undefined;
    accountNumber!: string | undefined;
    etaEnd!: moment.Moment;
    customer!: string | undefined;
    address!: string | undefined;
    unassigned!: boolean;
    willCalls!: boolean;
    statusCode!: string | undefined;
    timeZoneInfo!: string | undefined;
    statusType!: string | undefined;
    orderIds!: number[] | undefined;
    orderTypeId!: number | undefined;
    isLineHaul!: boolean;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetOrderListTimezoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.filter = data["filter"];
            this.routeCode = data["routeCode"];
            this.locationId = data["locationId"];
            this.routeId = data["routeId"];
            this.orderTag = data["orderTag"];
            this.accountNumber = data["accountNumber"];
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
            this.customer = data["customer"];
            this.address = data["address"];
            this.unassigned = data["unassigned"];
            this.willCalls = data["willCalls"];
            this.statusCode = data["statusCode"];
            this.timeZoneInfo = data["timeZoneInfo"];
            this.statusType = data["statusType"];
            if (Array.isArray(data["orderIds"])) {
                this.orderIds = [] as any;
                for (let item of data["orderIds"])
                    this.orderIds!.push(item);
            }
            this.orderTypeId = data["orderTypeId"];
            this.isLineHaul = data["isLineHaul"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetOrderListTimezoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderListTimezoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["filter"] = this.filter;
        data["routeCode"] = this.routeCode;
        data["locationId"] = this.locationId;
        data["routeId"] = this.routeId;
        data["orderTag"] = this.orderTag;
        data["accountNumber"] = this.accountNumber;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        data["customer"] = this.customer;
        data["address"] = this.address;
        data["unassigned"] = this.unassigned;
        data["willCalls"] = this.willCalls;
        data["statusCode"] = this.statusCode;
        data["timeZoneInfo"] = this.timeZoneInfo;
        data["statusType"] = this.statusType;
        if (Array.isArray(this.orderIds)) {
            data["orderIds"] = [];
            for (let item of this.orderIds)
                data["orderIds"].push(item);
        }
        data["orderTypeId"] = this.orderTypeId;
        data["isLineHaul"] = this.isLineHaul;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetOrderListTimezoneInput {
    id: number | undefined;
    filter: string | undefined;
    routeCode: string | undefined;
    locationId: number | undefined;
    routeId: string | undefined;
    orderTag: string | undefined;
    accountNumber: string | undefined;
    etaEnd: moment.Moment;
    customer: string | undefined;
    address: string | undefined;
    unassigned: boolean;
    willCalls: boolean;
    statusCode: string | undefined;
    timeZoneInfo: string | undefined;
    statusType: string | undefined;
    orderIds: number[] | undefined;
    orderTypeId: number | undefined;
    isLineHaul: boolean;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class GetControllerOrderListDto implements IGetControllerOrderListDto {
    id!: number;
    tenantId!: number;
    pickUpEtaStart!: moment.Moment;
    pickUpEtaEnd!: moment.Moment;
    pickUpFirstName!: string | undefined;
    pickUpLastName!: string | undefined;
    pickUpAddressLine1!: string | undefined;
    pickUpCountry!: string | undefined;
    pickUpCity!: string | undefined;
    pickUpState!: string | undefined;
    pickUpPostalCode!: string | undefined;
    pickUpCompanyName!: string | undefined;
    pickUpAccountNo!: string | undefined;
    deliveryEtaStart!: moment.Moment;
    deliveryEtaEnd!: moment.Moment;
    deliveryFirstName!: string | undefined;
    deliveryLastName!: string | undefined;
    deliveryAddressLine1!: string | undefined;
    deliveryCountry!: string | undefined;
    deliveryCity!: string | undefined;
    deliveryState!: string | undefined;
    deliveryPostalCode!: string | undefined;
    deliveryName!: string | undefined;
    loadDate!: moment.Moment;
    routeId!: number | undefined;
    routeName!: string | undefined;
    lastLog!: string | undefined;
    status!: string | undefined;
    color!: string | undefined;
    code!: string | undefined;
    icon!: string | undefined;
    orderTypeId!: number;
    orderTypeDescription!: string | undefined;
    orderTypeColor!: string | undefined;
    pickupDateString!: string | undefined;
    deliveryDateString!: string | undefined;
    orderTag!: string | undefined;

    constructor(data?: IGetControllerOrderListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.pickUpEtaStart = data["pickUpEtaStart"] ? moment(data["pickUpEtaStart"].toString()) : <any>undefined;
            this.pickUpEtaEnd = data["pickUpEtaEnd"] ? moment(data["pickUpEtaEnd"].toString()) : <any>undefined;
            this.pickUpFirstName = data["pickUpFirstName"];
            this.pickUpLastName = data["pickUpLastName"];
            this.pickUpAddressLine1 = data["pickUpAddressLine1"];
            this.pickUpCountry = data["pickUpCountry"];
            this.pickUpCity = data["pickUpCity"];
            this.pickUpState = data["pickUpState"];
            this.pickUpPostalCode = data["pickUpPostalCode"];
            this.pickUpCompanyName = data["pickUpCompanyName"];
            this.pickUpAccountNo = data["pickUpAccountNo"];
            this.deliveryEtaStart = data["deliveryEtaStart"] ? moment(data["deliveryEtaStart"].toString()) : <any>undefined;
            this.deliveryEtaEnd = data["deliveryEtaEnd"] ? moment(data["deliveryEtaEnd"].toString()) : <any>undefined;
            this.deliveryFirstName = data["deliveryFirstName"];
            this.deliveryLastName = data["deliveryLastName"];
            this.deliveryAddressLine1 = data["deliveryAddressLine1"];
            this.deliveryCountry = data["deliveryCountry"];
            this.deliveryCity = data["deliveryCity"];
            this.deliveryState = data["deliveryState"];
            this.deliveryPostalCode = data["deliveryPostalCode"];
            this.deliveryName = data["deliveryName"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.routeId = data["routeId"];
            this.routeName = data["routeName"];
            this.lastLog = data["lastLog"];
            this.status = data["status"];
            this.color = data["color"];
            this.code = data["code"];
            this.icon = data["icon"];
            this.orderTypeId = data["orderTypeId"];
            this.orderTypeDescription = data["orderTypeDescription"];
            this.orderTypeColor = data["orderTypeColor"];
            this.pickupDateString = data["pickupDateString"];
            this.deliveryDateString = data["deliveryDateString"];
            this.orderTag = data["orderTag"];
        }
    }

    static fromJS(data: any): GetControllerOrderListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetControllerOrderListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["pickUpEtaStart"] = this.pickUpEtaStart ? this.pickUpEtaStart.toISOString() : <any>undefined;
        data["pickUpEtaEnd"] = this.pickUpEtaEnd ? this.pickUpEtaEnd.toISOString() : <any>undefined;
        data["pickUpFirstName"] = this.pickUpFirstName;
        data["pickUpLastName"] = this.pickUpLastName;
        data["pickUpAddressLine1"] = this.pickUpAddressLine1;
        data["pickUpCountry"] = this.pickUpCountry;
        data["pickUpCity"] = this.pickUpCity;
        data["pickUpState"] = this.pickUpState;
        data["pickUpPostalCode"] = this.pickUpPostalCode;
        data["pickUpCompanyName"] = this.pickUpCompanyName;
        data["pickUpAccountNo"] = this.pickUpAccountNo;
        data["deliveryEtaStart"] = this.deliveryEtaStart ? this.deliveryEtaStart.toISOString() : <any>undefined;
        data["deliveryEtaEnd"] = this.deliveryEtaEnd ? this.deliveryEtaEnd.toISOString() : <any>undefined;
        data["deliveryFirstName"] = this.deliveryFirstName;
        data["deliveryLastName"] = this.deliveryLastName;
        data["deliveryAddressLine1"] = this.deliveryAddressLine1;
        data["deliveryCountry"] = this.deliveryCountry;
        data["deliveryCity"] = this.deliveryCity;
        data["deliveryState"] = this.deliveryState;
        data["deliveryPostalCode"] = this.deliveryPostalCode;
        data["deliveryName"] = this.deliveryName;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["routeId"] = this.routeId;
        data["routeName"] = this.routeName;
        data["lastLog"] = this.lastLog;
        data["status"] = this.status;
        data["color"] = this.color;
        data["code"] = this.code;
        data["icon"] = this.icon;
        data["orderTypeId"] = this.orderTypeId;
        data["orderTypeDescription"] = this.orderTypeDescription;
        data["orderTypeColor"] = this.orderTypeColor;
        data["pickupDateString"] = this.pickupDateString;
        data["deliveryDateString"] = this.deliveryDateString;
        data["orderTag"] = this.orderTag;
        return data; 
    }
}

export interface IGetControllerOrderListDto {
    id: number;
    tenantId: number;
    pickUpEtaStart: moment.Moment;
    pickUpEtaEnd: moment.Moment;
    pickUpFirstName: string | undefined;
    pickUpLastName: string | undefined;
    pickUpAddressLine1: string | undefined;
    pickUpCountry: string | undefined;
    pickUpCity: string | undefined;
    pickUpState: string | undefined;
    pickUpPostalCode: string | undefined;
    pickUpCompanyName: string | undefined;
    pickUpAccountNo: string | undefined;
    deliveryEtaStart: moment.Moment;
    deliveryEtaEnd: moment.Moment;
    deliveryFirstName: string | undefined;
    deliveryLastName: string | undefined;
    deliveryAddressLine1: string | undefined;
    deliveryCountry: string | undefined;
    deliveryCity: string | undefined;
    deliveryState: string | undefined;
    deliveryPostalCode: string | undefined;
    deliveryName: string | undefined;
    loadDate: moment.Moment;
    routeId: number | undefined;
    routeName: string | undefined;
    lastLog: string | undefined;
    status: string | undefined;
    color: string | undefined;
    code: string | undefined;
    icon: string | undefined;
    orderTypeId: number;
    orderTypeDescription: string | undefined;
    orderTypeColor: string | undefined;
    pickupDateString: string | undefined;
    deliveryDateString: string | undefined;
    orderTag: string | undefined;
}

export class GroupOrdersTab implements IGroupOrdersTab {
    orderTypeDescription!: string | undefined;
    orderTypeId!: number;
    orderTypeColor!: string | undefined;
    groupOrders!: GetControllerOrderListDto[] | undefined;

    constructor(data?: IGroupOrdersTab) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderTypeDescription = data["orderTypeDescription"];
            this.orderTypeId = data["orderTypeId"];
            this.orderTypeColor = data["orderTypeColor"];
            if (Array.isArray(data["groupOrders"])) {
                this.groupOrders = [] as any;
                for (let item of data["groupOrders"])
                    this.groupOrders!.push(GetControllerOrderListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GroupOrdersTab {
        data = typeof data === 'object' ? data : {};
        let result = new GroupOrdersTab();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderTypeDescription"] = this.orderTypeDescription;
        data["orderTypeId"] = this.orderTypeId;
        data["orderTypeColor"] = this.orderTypeColor;
        if (Array.isArray(this.groupOrders)) {
            data["groupOrders"] = [];
            for (let item of this.groupOrders)
                data["groupOrders"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGroupOrdersTab {
    orderTypeDescription: string | undefined;
    orderTypeId: number;
    orderTypeColor: string | undefined;
    groupOrders: GetControllerOrderListDto[] | undefined;
}

export class PagedResultDtoOfgroupOrdersTab implements IPagedResultDtoOfgroupOrdersTab {
    totalCount!: number;
    items!: GroupOrdersTab[] | undefined;

    constructor(data?: IPagedResultDtoOfgroupOrdersTab) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GroupOrdersTab.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfgroupOrdersTab {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfgroupOrdersTab();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfgroupOrdersTab {
    totalCount: number;
    items: GroupOrdersTab[] | undefined;
}

export class PagedResultDtoOfGetControllerOrderListDto implements IPagedResultDtoOfGetControllerOrderListDto {
    totalCount!: number;
    items!: GetControllerOrderListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetControllerOrderListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetControllerOrderListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetControllerOrderListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetControllerOrderListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetControllerOrderListDto {
    totalCount: number;
    items: GetControllerOrderListDto[] | undefined;
}

export class SharedOrderProximityCodeJson implements ISharedOrderProximityCodeJson {
    pickup!: string | undefined;
    pickupAccepted!: string | undefined;
    delivery!: string | undefined;
    deliveryAccepted!: string | undefined;
    pickupValidationDate!: moment.Moment | undefined;
    deliveryValidationDate!: moment.Moment | undefined;
    pickupGeocode!: CreateGeocodeInput | undefined;
    deliveryGeocode!: CreateGeocodeInput | undefined;
    pickupDriverId!: number | undefined;
    deliveryDriverId!: number | undefined;

    constructor(data?: ISharedOrderProximityCodeJson) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.pickup = data["pickup"];
            this.pickupAccepted = data["pickupAccepted"];
            this.delivery = data["delivery"];
            this.deliveryAccepted = data["deliveryAccepted"];
            this.pickupValidationDate = data["pickupValidationDate"] ? moment(data["pickupValidationDate"].toString()) : <any>undefined;
            this.deliveryValidationDate = data["deliveryValidationDate"] ? moment(data["deliveryValidationDate"].toString()) : <any>undefined;
            this.pickupGeocode = data["pickupGeocode"] ? CreateGeocodeInput.fromJS(data["pickupGeocode"]) : <any>undefined;
            this.deliveryGeocode = data["deliveryGeocode"] ? CreateGeocodeInput.fromJS(data["deliveryGeocode"]) : <any>undefined;
            this.pickupDriverId = data["pickupDriverId"];
            this.deliveryDriverId = data["deliveryDriverId"];
        }
    }

    static fromJS(data: any): SharedOrderProximityCodeJson {
        data = typeof data === 'object' ? data : {};
        let result = new SharedOrderProximityCodeJson();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["pickup"] = this.pickup;
        data["pickupAccepted"] = this.pickupAccepted;
        data["delivery"] = this.delivery;
        data["deliveryAccepted"] = this.deliveryAccepted;
        data["pickupValidationDate"] = this.pickupValidationDate ? this.pickupValidationDate.toISOString() : <any>undefined;
        data["deliveryValidationDate"] = this.deliveryValidationDate ? this.deliveryValidationDate.toISOString() : <any>undefined;
        data["pickupGeocode"] = this.pickupGeocode ? this.pickupGeocode.toJSON() : <any>undefined;
        data["deliveryGeocode"] = this.deliveryGeocode ? this.deliveryGeocode.toJSON() : <any>undefined;
        data["pickupDriverId"] = this.pickupDriverId;
        data["deliveryDriverId"] = this.deliveryDriverId;
        return data; 
    }
}

export interface ISharedOrderProximityCodeJson {
    pickup: string | undefined;
    pickupAccepted: string | undefined;
    delivery: string | undefined;
    deliveryAccepted: string | undefined;
    pickupValidationDate: moment.Moment | undefined;
    deliveryValidationDate: moment.Moment | undefined;
    pickupGeocode: CreateGeocodeInput | undefined;
    deliveryGeocode: CreateGeocodeInput | undefined;
    pickupDriverId: number | undefined;
    deliveryDriverId: number | undefined;
}

export class OrderStatusRes implements IOrderStatusRes {
    status!: string | undefined;
    time!: string | undefined;
    creator!: string | undefined;
    sortOrder!: number;
    orderStatusTypeId!: number;
    color!: string | undefined;

    constructor(data?: IOrderStatusRes) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.status = data["status"];
            this.time = data["time"];
            this.creator = data["creator"];
            this.sortOrder = data["sortOrder"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.color = data["color"];
        }
    }

    static fromJS(data: any): OrderStatusRes {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusRes();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["status"] = this.status;
        data["time"] = this.time;
        data["creator"] = this.creator;
        data["sortOrder"] = this.sortOrder;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["color"] = this.color;
        return data; 
    }
}

export interface IOrderStatusRes {
    status: string | undefined;
    time: string | undefined;
    creator: string | undefined;
    sortOrder: number;
    orderStatusTypeId: number;
    color: string | undefined;
}

export class GetOrderDetailsView implements IGetOrderDetailsView {
    id!: number;
    note!: string | undefined;
    createdDate!: moment.Moment | undefined;
    modifiedDate!: moment.Moment | undefined;
    createdBy!: string | undefined;
    modifiedBy!: string | undefined;
    proximityValue!: string | undefined;
    proximityLong!: number | undefined;
    proximityLat!: number | undefined;
    proximityGeocodeId!: number;
    proximity!: ProximityCodeListDto | undefined;
    proximityJson!: SharedOrderProximityCodeJson | undefined;
    proximityModifiedBy!: string | undefined;
    pickUpId!: number;
    pickupAddressId!: number | undefined;
    pickupContactId!: number;
    pickupPostalCodeId!: number;
    pickupFirstName!: string | undefined;
    pickupLastName!: string | undefined;
    pickupTime!: moment.Moment;
    pickupAddressLine1!: string | undefined;
    pickupAddressLine2!: string | undefined;
    pickupCountry!: string | undefined;
    pickupCity!: string | undefined;
    pickupState!: string | undefined;
    pickupPostal!: string | undefined;
    pickupLat!: number;
    pickupLong!: number;
    pickUpCompanyName!: string | undefined;
    pickUpEmail!: string | undefined;
    pickUpPhone!: string | undefined;
    pickupAddressType!: string | undefined;
    deliveryId!: number;
    deliveryAddressId!: number | undefined;
    deliveryContactId!: number;
    deliveryPostalCodeId!: number;
    deliveryCompanyName!: string | undefined;
    deliveryFirstName!: string | undefined;
    deliveryLastName!: string | undefined;
    deliveryTime!: moment.Moment | undefined;
    delivered!: boolean;
    deliveryAddressLine1!: string | undefined;
    deliveryAddressLine2!: string | undefined;
    deliveryCountry!: string | undefined;
    deliveryCity!: string | undefined;
    deliveryState!: string | undefined;
    deliveryPostal!: string | undefined;
    deliveryLat!: number | undefined;
    deliveryLong!: number | undefined;
    accountNo!: string | undefined;
    proximityAcceptedBy!: string | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;
    orderTags!: OrderTagListDto[] | undefined;
    routeId!: number | undefined;
    routeName!: string | undefined;
    driverName!: string | undefined;
    driverPhone!: string | undefined;
    vehicleName!: string | undefined;
    location!: string | undefined;
    locationId!: number;
    locationCode!: string | undefined;
    orderTypeId!: number | undefined;
    orderType!: string | undefined;
    pickupFormatAddress!: string | undefined;
    deliverFormatAddress!: string | undefined;
    deliveryEmail!: string | undefined;
    deliveryPhone!: string | undefined;
    pickupDetailsId!: number;
    deliveryDetailsId!: number;
    deliverAddressType!: string | undefined;
    statusId!: number | undefined;
    statusDescription!: string | undefined;
    orderStatuses!: OrderStatusRes[] | undefined;
    sourceChecker!: boolean;
    sourceCheckerMF!: boolean;
    sourceCheckerFFF!: boolean;
    orderExtras!: ControllerOrderExtraListDto[] | undefined;
    callerName!: string | undefined;
    url!: string | undefined;
    isSignatoryEnabled!: boolean;

    constructor(data?: IGetOrderDetailsView) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.note = data["note"];
            this.createdDate = data["createdDate"] ? moment(data["createdDate"].toString()) : <any>undefined;
            this.modifiedDate = data["modifiedDate"] ? moment(data["modifiedDate"].toString()) : <any>undefined;
            this.createdBy = data["createdBy"];
            this.modifiedBy = data["modifiedBy"];
            this.proximityValue = data["proximityValue"];
            this.proximityLong = data["proximityLong"];
            this.proximityLat = data["proximityLat"];
            this.proximityGeocodeId = data["proximityGeocodeId"];
            this.proximity = data["proximity"] ? ProximityCodeListDto.fromJS(data["proximity"]) : <any>undefined;
            this.proximityJson = data["proximityJson"] ? SharedOrderProximityCodeJson.fromJS(data["proximityJson"]) : <any>undefined;
            this.proximityModifiedBy = data["proximityModifiedBy"];
            this.pickUpId = data["pickUpId"];
            this.pickupAddressId = data["pickupAddressId"];
            this.pickupContactId = data["pickupContactId"];
            this.pickupPostalCodeId = data["pickupPostalCodeId"];
            this.pickupFirstName = data["pickupFirstName"];
            this.pickupLastName = data["pickupLastName"];
            this.pickupTime = data["pickupTime"] ? moment(data["pickupTime"].toString()) : <any>undefined;
            this.pickupAddressLine1 = data["pickupAddressLine1"];
            this.pickupAddressLine2 = data["pickupAddressLine2"];
            this.pickupCountry = data["pickupCountry"];
            this.pickupCity = data["pickupCity"];
            this.pickupState = data["pickupState"];
            this.pickupPostal = data["pickupPostal"];
            this.pickupLat = data["pickupLat"];
            this.pickupLong = data["pickupLong"];
            this.pickUpCompanyName = data["pickUpCompanyName"];
            this.pickUpEmail = data["pickUpEmail"];
            this.pickUpPhone = data["pickUpPhone"];
            this.pickupAddressType = data["pickupAddressType"];
            this.deliveryId = data["deliveryId"];
            this.deliveryAddressId = data["deliveryAddressId"];
            this.deliveryContactId = data["deliveryContactId"];
            this.deliveryPostalCodeId = data["deliveryPostalCodeId"];
            this.deliveryCompanyName = data["deliveryCompanyName"];
            this.deliveryFirstName = data["deliveryFirstName"];
            this.deliveryLastName = data["deliveryLastName"];
            this.deliveryTime = data["deliveryTime"] ? moment(data["deliveryTime"].toString()) : <any>undefined;
            this.delivered = data["delivered"];
            this.deliveryAddressLine1 = data["deliveryAddressLine1"];
            this.deliveryAddressLine2 = data["deliveryAddressLine2"];
            this.deliveryCountry = data["deliveryCountry"];
            this.deliveryCity = data["deliveryCity"];
            this.deliveryState = data["deliveryState"];
            this.deliveryPostal = data["deliveryPostal"];
            this.deliveryLat = data["deliveryLat"];
            this.deliveryLong = data["deliveryLong"];
            this.accountNo = data["accountNo"];
            this.proximityAcceptedBy = data["proximityAcceptedBy"];
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(OrderTagListDto.fromJS(item));
            }
            this.routeId = data["routeId"];
            this.routeName = data["routeName"];
            this.driverName = data["driverName"];
            this.driverPhone = data["driverPhone"];
            this.vehicleName = data["vehicleName"];
            this.location = data["location"];
            this.locationId = data["locationId"];
            this.locationCode = data["locationCode"];
            this.orderTypeId = data["orderTypeId"];
            this.orderType = data["orderType"];
            this.pickupFormatAddress = data["pickupFormatAddress"];
            this.deliverFormatAddress = data["deliverFormatAddress"];
            this.deliveryEmail = data["deliveryEmail"];
            this.deliveryPhone = data["deliveryPhone"];
            this.pickupDetailsId = data["pickupDetailsId"];
            this.deliveryDetailsId = data["deliveryDetailsId"];
            this.deliverAddressType = data["deliverAddressType"];
            this.statusId = data["statusId"];
            this.statusDescription = data["statusDescription"];
            if (Array.isArray(data["orderStatuses"])) {
                this.orderStatuses = [] as any;
                for (let item of data["orderStatuses"])
                    this.orderStatuses!.push(OrderStatusRes.fromJS(item));
            }
            this.sourceChecker = data["sourceChecker"];
            this.sourceCheckerMF = data["sourceCheckerMF"];
            this.sourceCheckerFFF = data["sourceCheckerFFF"];
            if (Array.isArray(data["orderExtras"])) {
                this.orderExtras = [] as any;
                for (let item of data["orderExtras"])
                    this.orderExtras!.push(ControllerOrderExtraListDto.fromJS(item));
            }
            this.callerName = data["callerName"];
            this.url = data["url"];
            this.isSignatoryEnabled = data["isSignatoryEnabled"];
        }
    }

    static fromJS(data: any): GetOrderDetailsView {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderDetailsView();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["note"] = this.note;
        data["createdDate"] = this.createdDate ? this.createdDate.toISOString() : <any>undefined;
        data["modifiedDate"] = this.modifiedDate ? this.modifiedDate.toISOString() : <any>undefined;
        data["createdBy"] = this.createdBy;
        data["modifiedBy"] = this.modifiedBy;
        data["proximityValue"] = this.proximityValue;
        data["proximityLong"] = this.proximityLong;
        data["proximityLat"] = this.proximityLat;
        data["proximityGeocodeId"] = this.proximityGeocodeId;
        data["proximity"] = this.proximity ? this.proximity.toJSON() : <any>undefined;
        data["proximityJson"] = this.proximityJson ? this.proximityJson.toJSON() : <any>undefined;
        data["proximityModifiedBy"] = this.proximityModifiedBy;
        data["pickUpId"] = this.pickUpId;
        data["pickupAddressId"] = this.pickupAddressId;
        data["pickupContactId"] = this.pickupContactId;
        data["pickupPostalCodeId"] = this.pickupPostalCodeId;
        data["pickupFirstName"] = this.pickupFirstName;
        data["pickupLastName"] = this.pickupLastName;
        data["pickupTime"] = this.pickupTime ? this.pickupTime.toISOString() : <any>undefined;
        data["pickupAddressLine1"] = this.pickupAddressLine1;
        data["pickupAddressLine2"] = this.pickupAddressLine2;
        data["pickupCountry"] = this.pickupCountry;
        data["pickupCity"] = this.pickupCity;
        data["pickupState"] = this.pickupState;
        data["pickupPostal"] = this.pickupPostal;
        data["pickupLat"] = this.pickupLat;
        data["pickupLong"] = this.pickupLong;
        data["pickUpCompanyName"] = this.pickUpCompanyName;
        data["pickUpEmail"] = this.pickUpEmail;
        data["pickUpPhone"] = this.pickUpPhone;
        data["pickupAddressType"] = this.pickupAddressType;
        data["deliveryId"] = this.deliveryId;
        data["deliveryAddressId"] = this.deliveryAddressId;
        data["deliveryContactId"] = this.deliveryContactId;
        data["deliveryPostalCodeId"] = this.deliveryPostalCodeId;
        data["deliveryCompanyName"] = this.deliveryCompanyName;
        data["deliveryFirstName"] = this.deliveryFirstName;
        data["deliveryLastName"] = this.deliveryLastName;
        data["deliveryTime"] = this.deliveryTime ? this.deliveryTime.toISOString() : <any>undefined;
        data["delivered"] = this.delivered;
        data["deliveryAddressLine1"] = this.deliveryAddressLine1;
        data["deliveryAddressLine2"] = this.deliveryAddressLine2;
        data["deliveryCountry"] = this.deliveryCountry;
        data["deliveryCity"] = this.deliveryCity;
        data["deliveryState"] = this.deliveryState;
        data["deliveryPostal"] = this.deliveryPostal;
        data["deliveryLat"] = this.deliveryLat;
        data["deliveryLong"] = this.deliveryLong;
        data["accountNo"] = this.accountNo;
        data["proximityAcceptedBy"] = this.proximityAcceptedBy;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        data["routeId"] = this.routeId;
        data["routeName"] = this.routeName;
        data["driverName"] = this.driverName;
        data["driverPhone"] = this.driverPhone;
        data["vehicleName"] = this.vehicleName;
        data["location"] = this.location;
        data["locationId"] = this.locationId;
        data["locationCode"] = this.locationCode;
        data["orderTypeId"] = this.orderTypeId;
        data["orderType"] = this.orderType;
        data["pickupFormatAddress"] = this.pickupFormatAddress;
        data["deliverFormatAddress"] = this.deliverFormatAddress;
        data["deliveryEmail"] = this.deliveryEmail;
        data["deliveryPhone"] = this.deliveryPhone;
        data["pickupDetailsId"] = this.pickupDetailsId;
        data["deliveryDetailsId"] = this.deliveryDetailsId;
        data["deliverAddressType"] = this.deliverAddressType;
        data["statusId"] = this.statusId;
        data["statusDescription"] = this.statusDescription;
        if (Array.isArray(this.orderStatuses)) {
            data["orderStatuses"] = [];
            for (let item of this.orderStatuses)
                data["orderStatuses"].push(item.toJSON());
        }
        data["sourceChecker"] = this.sourceChecker;
        data["sourceCheckerMF"] = this.sourceCheckerMF;
        data["sourceCheckerFFF"] = this.sourceCheckerFFF;
        if (Array.isArray(this.orderExtras)) {
            data["orderExtras"] = [];
            for (let item of this.orderExtras)
                data["orderExtras"].push(item.toJSON());
        }
        data["callerName"] = this.callerName;
        data["url"] = this.url;
        data["isSignatoryEnabled"] = this.isSignatoryEnabled;
        return data; 
    }
}

export interface IGetOrderDetailsView {
    id: number;
    note: string | undefined;
    createdDate: moment.Moment | undefined;
    modifiedDate: moment.Moment | undefined;
    createdBy: string | undefined;
    modifiedBy: string | undefined;
    proximityValue: string | undefined;
    proximityLong: number | undefined;
    proximityLat: number | undefined;
    proximityGeocodeId: number;
    proximity: ProximityCodeListDto | undefined;
    proximityJson: SharedOrderProximityCodeJson | undefined;
    proximityModifiedBy: string | undefined;
    pickUpId: number;
    pickupAddressId: number | undefined;
    pickupContactId: number;
    pickupPostalCodeId: number;
    pickupFirstName: string | undefined;
    pickupLastName: string | undefined;
    pickupTime: moment.Moment;
    pickupAddressLine1: string | undefined;
    pickupAddressLine2: string | undefined;
    pickupCountry: string | undefined;
    pickupCity: string | undefined;
    pickupState: string | undefined;
    pickupPostal: string | undefined;
    pickupLat: number;
    pickupLong: number;
    pickUpCompanyName: string | undefined;
    pickUpEmail: string | undefined;
    pickUpPhone: string | undefined;
    pickupAddressType: string | undefined;
    deliveryId: number;
    deliveryAddressId: number | undefined;
    deliveryContactId: number;
    deliveryPostalCodeId: number;
    deliveryCompanyName: string | undefined;
    deliveryFirstName: string | undefined;
    deliveryLastName: string | undefined;
    deliveryTime: moment.Moment | undefined;
    delivered: boolean;
    deliveryAddressLine1: string | undefined;
    deliveryAddressLine2: string | undefined;
    deliveryCountry: string | undefined;
    deliveryCity: string | undefined;
    deliveryState: string | undefined;
    deliveryPostal: string | undefined;
    deliveryLat: number | undefined;
    deliveryLong: number | undefined;
    accountNo: string | undefined;
    proximityAcceptedBy: string | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
    orderTags: OrderTagListDto[] | undefined;
    routeId: number | undefined;
    routeName: string | undefined;
    driverName: string | undefined;
    driverPhone: string | undefined;
    vehicleName: string | undefined;
    location: string | undefined;
    locationId: number;
    locationCode: string | undefined;
    orderTypeId: number | undefined;
    orderType: string | undefined;
    pickupFormatAddress: string | undefined;
    deliverFormatAddress: string | undefined;
    deliveryEmail: string | undefined;
    deliveryPhone: string | undefined;
    pickupDetailsId: number;
    deliveryDetailsId: number;
    deliverAddressType: string | undefined;
    statusId: number | undefined;
    statusDescription: string | undefined;
    orderStatuses: OrderStatusRes[] | undefined;
    sourceChecker: boolean;
    sourceCheckerMF: boolean;
    sourceCheckerFFF: boolean;
    orderExtras: ControllerOrderExtraListDto[] | undefined;
    callerName: string | undefined;
    url: string | undefined;
    isSignatoryEnabled: boolean;
}

export class UpdateBatchDeliveryNotesInput implements IUpdateBatchDeliveryNotesInput {
    ids!: number[] | undefined;
    notes!: string | undefined;

    constructor(data?: IUpdateBatchDeliveryNotesInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["ids"])) {
                this.ids = [] as any;
                for (let item of data["ids"])
                    this.ids!.push(item);
            }
            this.notes = data["notes"];
        }
    }

    static fromJS(data: any): UpdateBatchDeliveryNotesInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateBatchDeliveryNotesInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.ids)) {
            data["ids"] = [];
            for (let item of this.ids)
                data["ids"].push(item);
        }
        data["notes"] = this.notes;
        return data; 
    }
}

export interface IUpdateBatchDeliveryNotesInput {
    ids: number[] | undefined;
    notes: string | undefined;
}

export class OrderStatusDto implements IOrderStatusDto {
    user!: UserListDto | undefined;
    order!: OrderListDto | undefined;
    geocode!: GeocodeListDto | undefined;
    orderStatusType!: OrderStatusTypeListDto | undefined;
    note!: NoteListDto | undefined;
    time!: moment.Moment;
    id!: number;

    constructor(data?: IOrderStatusDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserListDto.fromJS(data["user"]) : <any>undefined;
            this.order = data["order"] ? OrderListDto.fromJS(data["order"]) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.orderStatusType = data["orderStatusType"] ? OrderStatusTypeListDto.fromJS(data["orderStatusType"]) : <any>undefined;
            this.note = data["note"] ? NoteListDto.fromJS(data["note"]) : <any>undefined;
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatusDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatusDto {
    user: UserListDto | undefined;
    order: OrderListDto | undefined;
    geocode: GeocodeListDto | undefined;
    orderStatusType: OrderStatusTypeListDto | undefined;
    note: NoteListDto | undefined;
    time: moment.Moment;
    id: number;
}

export class RouteDriverListDto implements IRouteDriverListDto {
    tenantId!: number;
    vehicleId!: number | undefined;
    locationId!: number;
    routeTemplateId!: number;
    vehicle!: RouteVehicleListDto | undefined;
    location!: RouteLocationListDto | undefined;
    routeTemplate!: RouteTemplateListDto | undefined;
    loadDate!: moment.Moment;
    completion!: moment.Moment;
    departure!: moment.Moment;

    constructor(data?: IRouteDriverListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.vehicleId = data["vehicleId"];
            this.locationId = data["locationId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.vehicle = data["vehicle"] ? RouteVehicleListDto.fromJS(data["vehicle"]) : <any>undefined;
            this.location = data["location"] ? RouteLocationListDto.fromJS(data["location"]) : <any>undefined;
            this.routeTemplate = data["routeTemplate"] ? RouteTemplateListDto.fromJS(data["routeTemplate"]) : <any>undefined;
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.completion = data["completion"] ? moment(data["completion"].toString()) : <any>undefined;
            this.departure = data["departure"] ? moment(data["departure"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): RouteDriverListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteDriverListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["vehicleId"] = this.vehicleId;
        data["locationId"] = this.locationId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["completion"] = this.completion ? this.completion.toISOString() : <any>undefined;
        data["departure"] = this.departure ? this.departure.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IRouteDriverListDto {
    tenantId: number;
    vehicleId: number | undefined;
    locationId: number;
    routeTemplateId: number;
    vehicle: RouteVehicleListDto | undefined;
    location: RouteLocationListDto | undefined;
    routeTemplate: RouteTemplateListDto | undefined;
    loadDate: moment.Moment;
    completion: moment.Moment;
    departure: moment.Moment;
}

export class OrderRouteListDto implements IOrderRouteListDto {
    id!: number;
    route!: RouteDriverListDto | undefined;
    deliveryDetail!: DestinationDetailListDto | undefined;

    constructor(data?: IOrderRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.route = data["route"] ? RouteDriverListDto.fromJS(data["route"]) : <any>undefined;
            this.deliveryDetail = data["deliveryDetail"] ? DestinationDetailListDto.fromJS(data["deliveryDetail"]) : <any>undefined;
        }
    }

    static fromJS(data: any): OrderRouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderRouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["deliveryDetail"] = this.deliveryDetail ? this.deliveryDetail.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IOrderRouteListDto {
    id: number;
    route: RouteDriverListDto | undefined;
    deliveryDetail: DestinationDetailListDto | undefined;
}

export class UpdateOrderV2Input implements IUpdateOrderV2Input {
    id!: number;
    pickupDetails!: DestinationDetailListDto | undefined;
    deliveryDetails!: DestinationDetailListDto | undefined;
    tag!: TagListDto | undefined;
    note!: NoteListDto | undefined;
    orderPackages!: OrderPackageListDto[] | undefined;
    location!: LocationListDto | undefined;
    userId!: number;

    constructor(data?: IUpdateOrderV2Input) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.pickupDetails = data["pickupDetails"] ? DestinationDetailListDto.fromJS(data["pickupDetails"]) : <any>undefined;
            this.deliveryDetails = data["deliveryDetails"] ? DestinationDetailListDto.fromJS(data["deliveryDetails"]) : <any>undefined;
            this.tag = data["tag"] ? TagListDto.fromJS(data["tag"]) : <any>undefined;
            this.note = data["note"] ? NoteListDto.fromJS(data["note"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackageListDto.fromJS(item));
            }
            this.location = data["location"] ? LocationListDto.fromJS(data["location"]) : <any>undefined;
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): UpdateOrderV2Input {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderV2Input();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["pickupDetails"] = this.pickupDetails ? this.pickupDetails.toJSON() : <any>undefined;
        data["deliveryDetails"] = this.deliveryDetails ? this.deliveryDetails.toJSON() : <any>undefined;
        data["tag"] = this.tag ? this.tag.toJSON() : <any>undefined;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IUpdateOrderV2Input {
    id: number;
    pickupDetails: DestinationDetailListDto | undefined;
    deliveryDetails: DestinationDetailListDto | undefined;
    tag: TagListDto | undefined;
    note: NoteListDto | undefined;
    orderPackages: OrderPackageListDto[] | undefined;
    location: LocationListDto | undefined;
    userId: number;
}

export class GenerateProximityCodeInput implements IGenerateProximityCodeInput {
    orderId!: number;
    geocode!: CreateGeocodeInput | undefined;
    dateCreated!: moment.Moment | undefined;

    constructor(data?: IGenerateProximityCodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.geocode = data["geocode"] ? CreateGeocodeInput.fromJS(data["geocode"]) : <any>undefined;
            this.dateCreated = data["dateCreated"] ? moment(data["dateCreated"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GenerateProximityCodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new GenerateProximityCodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["dateCreated"] = this.dateCreated ? this.dateCreated.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGenerateProximityCodeInput {
    orderId: number;
    geocode: CreateGeocodeInput | undefined;
    dateCreated: moment.Moment | undefined;
}

export class ValidateProximityCodeInput implements IValidateProximityCodeInput {
    orderId!: number;
    code!: string | undefined;

    constructor(data?: IValidateProximityCodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.code = data["code"];
        }
    }

    static fromJS(data: any): ValidateProximityCodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new ValidateProximityCodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["code"] = this.code;
        return data; 
    }
}

export interface IValidateProximityCodeInput {
    orderId: number;
    code: string | undefined;
}

export class SetOrderStatusInputItem implements ISetOrderStatusInputItem {
    orderId!: number;
    orderStatusTypeId!: number;
    extras!: SetOrderExtraInputItem[] | undefined;
    geocode!: GeocodeListDto | undefined;
    note!: string | undefined;
    time!: moment.Moment;

    constructor(data?: ISetOrderStatusInputItem) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            if (Array.isArray(data["extras"])) {
                this.extras = [] as any;
                for (let item of data["extras"])
                    this.extras!.push(SetOrderExtraInputItem.fromJS(item));
            }
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.note = data["note"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): SetOrderStatusInputItem {
        data = typeof data === 'object' ? data : {};
        let result = new SetOrderStatusInputItem();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        if (Array.isArray(this.extras)) {
            data["extras"] = [];
            for (let item of this.extras)
                data["extras"].push(item.toJSON());
        }
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["note"] = this.note;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ISetOrderStatusInputItem {
    orderId: number;
    orderStatusTypeId: number;
    extras: SetOrderExtraInputItem[] | undefined;
    geocode: GeocodeListDto | undefined;
    note: string | undefined;
    time: moment.Moment;
}

export class SetStatusInput implements ISetStatusInput {
    items!: SetOrderStatusInputItem[] | undefined;

    constructor(data?: ISetStatusInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SetOrderStatusInputItem.fromJS(item));
            }
        }
    }

    static fromJS(data: any): SetStatusInput {
        data = typeof data === 'object' ? data : {};
        let result = new SetStatusInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ISetStatusInput {
    items: SetOrderStatusInputItem[] | undefined;
}

export class SingleOrderStatusAttachmentInput implements ISingleOrderStatusAttachmentInput {
    orderId!: number;
    attachment!: CreateImageInput | undefined;
    dateTime!: moment.Moment;

    constructor(data?: ISingleOrderStatusAttachmentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.attachment = data["attachment"] ? CreateImageInput.fromJS(data["attachment"]) : <any>undefined;
            this.dateTime = data["dateTime"] ? moment(data["dateTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): SingleOrderStatusAttachmentInput {
        data = typeof data === 'object' ? data : {};
        let result = new SingleOrderStatusAttachmentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["attachment"] = this.attachment ? this.attachment.toJSON() : <any>undefined;
        data["dateTime"] = this.dateTime ? this.dateTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ISingleOrderStatusAttachmentInput {
    orderId: number;
    attachment: CreateImageInput | undefined;
    dateTime: moment.Moment;
}

export class MultipleOrderStatusAttachmentInput implements IMultipleOrderStatusAttachmentInput {
    orderId!: number[] | undefined;
    attachment!: CreateImageInput | undefined;
    dateTime!: moment.Moment;

    constructor(data?: IMultipleOrderStatusAttachmentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["orderId"])) {
                this.orderId = [] as any;
                for (let item of data["orderId"])
                    this.orderId!.push(item);
            }
            this.attachment = data["attachment"] ? CreateImageInput.fromJS(data["attachment"]) : <any>undefined;
            this.dateTime = data["dateTime"] ? moment(data["dateTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): MultipleOrderStatusAttachmentInput {
        data = typeof data === 'object' ? data : {};
        let result = new MultipleOrderStatusAttachmentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.orderId)) {
            data["orderId"] = [];
            for (let item of this.orderId)
                data["orderId"].push(item);
        }
        data["attachment"] = this.attachment ? this.attachment.toJSON() : <any>undefined;
        data["dateTime"] = this.dateTime ? this.dateTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IMultipleOrderStatusAttachmentInput {
    orderId: number[] | undefined;
    attachment: CreateImageInput | undefined;
    dateTime: moment.Moment;
}

export class TagInputApi implements ITagInputApi {
    tagCode!: string | undefined;
    value!: string | undefined;

    constructor(data?: ITagInputApi) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tagCode = data["tagCode"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): TagInputApi {
        data = typeof data === 'object' ? data : {};
        let result = new TagInputApi();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tagCode"] = this.tagCode;
        data["value"] = this.value;
        return data; 
    }
}

export interface ITagInputApi {
    tagCode: string | undefined;
    value: string | undefined;
}

export class PackageInputApi implements IPackageInputApi {
    packageCode!: string | undefined;
    quantity!: number | undefined;
    packageName!: string | undefined;
    description!: string | undefined;
    sku!: string | undefined;
    price!: number | undefined;

    constructor(data?: IPackageInputApi) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.packageCode = data["packageCode"];
            this.quantity = data["quantity"];
            this.packageName = data["packageName"];
            this.description = data["description"];
            this.sku = data["sku"];
            this.price = data["price"];
        }
    }

    static fromJS(data: any): PackageInputApi {
        data = typeof data === 'object' ? data : {};
        let result = new PackageInputApi();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["packageCode"] = this.packageCode;
        data["quantity"] = this.quantity;
        data["packageName"] = this.packageName;
        data["description"] = this.description;
        data["sku"] = this.sku;
        data["price"] = this.price;
        return data; 
    }
}

export interface IPackageInputApi {
    packageCode: string | undefined;
    quantity: number | undefined;
    packageName: string | undefined;
    description: string | undefined;
    sku: string | undefined;
    price: number | undefined;
}

export class CreateOrderApiInput implements ICreateOrderApiInput {
    locationId!: number | undefined;
    tenantId!: number | undefined;
    userId!: number | undefined;
    tags!: TagInputApi[] | undefined;
    trackingIdentifier!: string | undefined;
    note!: string | undefined;
    packages!: PackageInputApi[] | undefined;
    destinationEtaStart!: moment.Moment;
    destinationEtaEnd!: moment.Moment;
    destinationContactId!: number | undefined;
    destinationFirstName!: string | undefined;
    destinationLastName!: string | undefined;
    destinationEmail!: string | undefined;
    destinationPhone!: string | undefined;
    destinationAddressLine1!: string | undefined;
    destinationAddressLine2!: string | undefined;
    destinationPostalCodeId!: number | undefined;
    destinationPostalCode!: string | undefined;
    destinationCountry!: string | undefined;
    destinationCity!: string | undefined;
    destinationState!: string | undefined;
    destinationGeocodeId!: number | undefined;
    destinationLat!: number | undefined;
    destinationLng!: number | undefined;
    destinationAddressTypeId!: number | undefined;
    pickUpEtaStart!: moment.Moment;
    pickUpEtaEnd!: moment.Moment;
    pickUpContactId!: number | undefined;
    pickUpFirstName!: string | undefined;
    pickUpLastName!: string | undefined;
    pickUpEmail!: string | undefined;
    pickUpPhone!: string | undefined;
    pickUpAddressLine1!: string | undefined;
    pickUpAddressLine2!: string | undefined;
    pickUpPostalCodeId!: number | undefined;
    pickUpPostalCode!: string | undefined;
    pickUpCountry!: string | undefined;
    pickUpCity!: string | undefined;
    pickUpState!: string | undefined;
    pickUpGeocodeId!: number | undefined;
    pickUpLat!: number | undefined;
    pickUpLng!: number | undefined;
    pickUpAddressTypeId!: number | undefined;
    orderSourceId!: number | undefined;
    orderSourceCode!: string | undefined;
    isDownloadOrder!: boolean;
    isRecurring!: boolean;
    recurringScheduleCode!: string | undefined;
    orderStatusCode!: string | undefined;
    zipRegex!: string | undefined;
    driverFirstName!: string | undefined;
    driverLastName!: string | undefined;
    driverUserName!: string | undefined;

    constructor(data?: ICreateOrderApiInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            if (Array.isArray(data["tags"])) {
                this.tags = [] as any;
                for (let item of data["tags"])
                    this.tags!.push(TagInputApi.fromJS(item));
            }
            this.trackingIdentifier = data["trackingIdentifier"];
            this.note = data["note"];
            if (Array.isArray(data["packages"])) {
                this.packages = [] as any;
                for (let item of data["packages"])
                    this.packages!.push(PackageInputApi.fromJS(item));
            }
            this.destinationEtaStart = data["destinationEtaStart"] ? moment(data["destinationEtaStart"].toString()) : <any>undefined;
            this.destinationEtaEnd = data["destinationEtaEnd"] ? moment(data["destinationEtaEnd"].toString()) : <any>undefined;
            this.destinationContactId = data["destinationContactId"];
            this.destinationFirstName = data["destinationFirstName"];
            this.destinationLastName = data["destinationLastName"];
            this.destinationEmail = data["destinationEmail"];
            this.destinationPhone = data["destinationPhone"];
            this.destinationAddressLine1 = data["destinationAddressLine1"];
            this.destinationAddressLine2 = data["destinationAddressLine2"];
            this.destinationPostalCodeId = data["destinationPostalCodeId"];
            this.destinationPostalCode = data["destinationPostalCode"];
            this.destinationCountry = data["destinationCountry"];
            this.destinationCity = data["destinationCity"];
            this.destinationState = data["destinationState"];
            this.destinationGeocodeId = data["destinationGeocodeId"];
            this.destinationLat = data["destinationLat"];
            this.destinationLng = data["destinationLng"];
            this.destinationAddressTypeId = data["destinationAddressTypeId"];
            this.pickUpEtaStart = data["pickUpEtaStart"] ? moment(data["pickUpEtaStart"].toString()) : <any>undefined;
            this.pickUpEtaEnd = data["pickUpEtaEnd"] ? moment(data["pickUpEtaEnd"].toString()) : <any>undefined;
            this.pickUpContactId = data["pickUpContactId"];
            this.pickUpFirstName = data["pickUpFirstName"];
            this.pickUpLastName = data["pickUpLastName"];
            this.pickUpEmail = data["pickUpEmail"];
            this.pickUpPhone = data["pickUpPhone"];
            this.pickUpAddressLine1 = data["pickUpAddressLine1"];
            this.pickUpAddressLine2 = data["pickUpAddressLine2"];
            this.pickUpPostalCodeId = data["pickUpPostalCodeId"];
            this.pickUpPostalCode = data["pickUpPostalCode"];
            this.pickUpCountry = data["pickUpCountry"];
            this.pickUpCity = data["pickUpCity"];
            this.pickUpState = data["pickUpState"];
            this.pickUpGeocodeId = data["pickUpGeocodeId"];
            this.pickUpLat = data["pickUpLat"];
            this.pickUpLng = data["pickUpLng"];
            this.pickUpAddressTypeId = data["pickUpAddressTypeId"];
            this.orderSourceId = data["orderSourceId"];
            this.orderSourceCode = data["orderSourceCode"];
            this.isDownloadOrder = data["isDownloadOrder"];
            this.isRecurring = data["isRecurring"];
            this.recurringScheduleCode = data["recurringScheduleCode"];
            this.orderStatusCode = data["orderStatusCode"];
            this.zipRegex = data["zipRegex"];
            this.driverFirstName = data["driverFirstName"];
            this.driverLastName = data["driverLastName"];
            this.driverUserName = data["driverUserName"];
        }
    }

    static fromJS(data: any): CreateOrderApiInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderApiInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        if (Array.isArray(this.tags)) {
            data["tags"] = [];
            for (let item of this.tags)
                data["tags"].push(item.toJSON());
        }
        data["trackingIdentifier"] = this.trackingIdentifier;
        data["note"] = this.note;
        if (Array.isArray(this.packages)) {
            data["packages"] = [];
            for (let item of this.packages)
                data["packages"].push(item.toJSON());
        }
        data["destinationEtaStart"] = this.destinationEtaStart ? this.destinationEtaStart.toISOString() : <any>undefined;
        data["destinationEtaEnd"] = this.destinationEtaEnd ? this.destinationEtaEnd.toISOString() : <any>undefined;
        data["destinationContactId"] = this.destinationContactId;
        data["destinationFirstName"] = this.destinationFirstName;
        data["destinationLastName"] = this.destinationLastName;
        data["destinationEmail"] = this.destinationEmail;
        data["destinationPhone"] = this.destinationPhone;
        data["destinationAddressLine1"] = this.destinationAddressLine1;
        data["destinationAddressLine2"] = this.destinationAddressLine2;
        data["destinationPostalCodeId"] = this.destinationPostalCodeId;
        data["destinationPostalCode"] = this.destinationPostalCode;
        data["destinationCountry"] = this.destinationCountry;
        data["destinationCity"] = this.destinationCity;
        data["destinationState"] = this.destinationState;
        data["destinationGeocodeId"] = this.destinationGeocodeId;
        data["destinationLat"] = this.destinationLat;
        data["destinationLng"] = this.destinationLng;
        data["destinationAddressTypeId"] = this.destinationAddressTypeId;
        data["pickUpEtaStart"] = this.pickUpEtaStart ? this.pickUpEtaStart.toISOString() : <any>undefined;
        data["pickUpEtaEnd"] = this.pickUpEtaEnd ? this.pickUpEtaEnd.toISOString() : <any>undefined;
        data["pickUpContactId"] = this.pickUpContactId;
        data["pickUpFirstName"] = this.pickUpFirstName;
        data["pickUpLastName"] = this.pickUpLastName;
        data["pickUpEmail"] = this.pickUpEmail;
        data["pickUpPhone"] = this.pickUpPhone;
        data["pickUpAddressLine1"] = this.pickUpAddressLine1;
        data["pickUpAddressLine2"] = this.pickUpAddressLine2;
        data["pickUpPostalCodeId"] = this.pickUpPostalCodeId;
        data["pickUpPostalCode"] = this.pickUpPostalCode;
        data["pickUpCountry"] = this.pickUpCountry;
        data["pickUpCity"] = this.pickUpCity;
        data["pickUpState"] = this.pickUpState;
        data["pickUpGeocodeId"] = this.pickUpGeocodeId;
        data["pickUpLat"] = this.pickUpLat;
        data["pickUpLng"] = this.pickUpLng;
        data["pickUpAddressTypeId"] = this.pickUpAddressTypeId;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSourceCode"] = this.orderSourceCode;
        data["isDownloadOrder"] = this.isDownloadOrder;
        data["isRecurring"] = this.isRecurring;
        data["recurringScheduleCode"] = this.recurringScheduleCode;
        data["orderStatusCode"] = this.orderStatusCode;
        data["zipRegex"] = this.zipRegex;
        data["driverFirstName"] = this.driverFirstName;
        data["driverLastName"] = this.driverLastName;
        data["driverUserName"] = this.driverUserName;
        return data; 
    }
}

export interface ICreateOrderApiInput {
    locationId: number | undefined;
    tenantId: number | undefined;
    userId: number | undefined;
    tags: TagInputApi[] | undefined;
    trackingIdentifier: string | undefined;
    note: string | undefined;
    packages: PackageInputApi[] | undefined;
    destinationEtaStart: moment.Moment;
    destinationEtaEnd: moment.Moment;
    destinationContactId: number | undefined;
    destinationFirstName: string | undefined;
    destinationLastName: string | undefined;
    destinationEmail: string | undefined;
    destinationPhone: string | undefined;
    destinationAddressLine1: string | undefined;
    destinationAddressLine2: string | undefined;
    destinationPostalCodeId: number | undefined;
    destinationPostalCode: string | undefined;
    destinationCountry: string | undefined;
    destinationCity: string | undefined;
    destinationState: string | undefined;
    destinationGeocodeId: number | undefined;
    destinationLat: number | undefined;
    destinationLng: number | undefined;
    destinationAddressTypeId: number | undefined;
    pickUpEtaStart: moment.Moment;
    pickUpEtaEnd: moment.Moment;
    pickUpContactId: number | undefined;
    pickUpFirstName: string | undefined;
    pickUpLastName: string | undefined;
    pickUpEmail: string | undefined;
    pickUpPhone: string | undefined;
    pickUpAddressLine1: string | undefined;
    pickUpAddressLine2: string | undefined;
    pickUpPostalCodeId: number | undefined;
    pickUpPostalCode: string | undefined;
    pickUpCountry: string | undefined;
    pickUpCity: string | undefined;
    pickUpState: string | undefined;
    pickUpGeocodeId: number | undefined;
    pickUpLat: number | undefined;
    pickUpLng: number | undefined;
    pickUpAddressTypeId: number | undefined;
    orderSourceId: number | undefined;
    orderSourceCode: string | undefined;
    isDownloadOrder: boolean;
    isRecurring: boolean;
    recurringScheduleCode: string | undefined;
    orderStatusCode: string | undefined;
    zipRegex: string | undefined;
    driverFirstName: string | undefined;
    driverLastName: string | undefined;
    driverUserName: string | undefined;
}

export class PostalCode implements IPostalCode {
    country!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    value!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IPostalCode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.country = data["country"];
            this.city = data["city"];
            this.state = data["state"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PostalCode {
        data = typeof data === 'object' ? data : {};
        let result = new PostalCode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["country"] = this.country;
        data["city"] = this.city;
        data["state"] = this.state;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPostalCode {
    country: string | undefined;
    city: string | undefined;
    state: string | undefined;
    value: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Geocode implements IGeocode {
    latitude!: number;
    longitude!: number;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IGeocode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Geocode {
        data = typeof data === 'object' ? data : {};
        let result = new Geocode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IGeocode {
    latitude: number;
    longitude: number;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class AddressType implements IAddressType {
    name!: string;
    color!: string | undefined;
    icon!: string | undefined;
    proximityValue!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IAddressType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.proximityValue = data["proximityValue"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AddressType {
        data = typeof data === 'object' ? data : {};
        let result = new AddressType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["proximityValue"] = this.proximityValue;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAddressType {
    name: string;
    color: string | undefined;
    icon: string | undefined;
    proximityValue: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Address implements IAddress {
    addressLine1!: string;
    addressLine2!: string | undefined;
    postalCodeId!: number;
    postalCode!: PostalCode | undefined;
    geocodeId!: number | undefined;
    geocode!: Geocode | undefined;
    addressTypeId!: number | undefined;
    addressType!: AddressType | undefined;
    maxDistance!: number;
    formattedAddress!: string | undefined;
    partialMatch!: boolean;
    overridableAddressType!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IAddress) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.postalCodeId = data["postalCodeId"];
            this.postalCode = data["postalCode"] ? PostalCode.fromJS(data["postalCode"]) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.addressTypeId = data["addressTypeId"];
            this.addressType = data["addressType"] ? AddressType.fromJS(data["addressType"]) : <any>undefined;
            this.maxDistance = data["maxDistance"];
            this.formattedAddress = data["formattedAddress"];
            this.partialMatch = data["partialMatch"];
            this.overridableAddressType = data["overridableAddressType"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Address {
        data = typeof data === 'object' ? data : {};
        let result = new Address();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["postalCodeId"] = this.postalCodeId;
        data["postalCode"] = this.postalCode ? this.postalCode.toJSON() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["addressTypeId"] = this.addressTypeId;
        data["addressType"] = this.addressType ? this.addressType.toJSON() : <any>undefined;
        data["maxDistance"] = this.maxDistance;
        data["formattedAddress"] = this.formattedAddress;
        data["partialMatch"] = this.partialMatch;
        data["overridableAddressType"] = this.overridableAddressType;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAddress {
    addressLine1: string;
    addressLine2: string | undefined;
    postalCodeId: number;
    postalCode: PostalCode | undefined;
    geocodeId: number | undefined;
    geocode: Geocode | undefined;
    addressTypeId: number | undefined;
    addressType: AddressType | undefined;
    maxDistance: number;
    formattedAddress: string | undefined;
    partialMatch: boolean;
    overridableAddressType: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Company implements ICompany {
    tenantId!: number | undefined;
    name!: string | undefined;
    accountNo!: string | undefined;
    contact!: Contact | undefined;
    contactId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ICompany) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.accountNo = data["accountNo"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Company {
        data = typeof data === 'object' ? data : {};
        let result = new Company();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["accountNo"] = this.accountNo;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICompany {
    tenantId: number | undefined;
    name: string | undefined;
    accountNo: string | undefined;
    contact: Contact | undefined;
    contactId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Email implements IEmail {
    contact!: Contact | undefined;
    contactId!: number;
    value!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IEmail) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Email {
        data = typeof data === 'object' ? data : {};
        let result = new Email();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEmail {
    contact: Contact | undefined;
    contactId: number;
    value: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Phone implements IPhone {
    contact!: Contact | undefined;
    contactId!: number;
    value!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IPhone) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Phone {
        data = typeof data === 'object' ? data : {};
        let result = new Phone();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPhone {
    contact: Contact | undefined;
    contactId: number;
    value: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export enum SubscriptionPaymentType {
    Manual = 0,
    RecurringAutomatic = 1,
    RecurringManual = 2,
}

export class MobileTheme implements IMobileTheme {
    tenantId!: number;
    tenant!: Tenant | undefined;
    attribute!: string | undefined;
    value!: string | undefined;
    base64Value!: string | undefined;
    tenantName!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IMobileTheme) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.attribute = data["attribute"];
            this.value = data["value"];
            this.base64Value = data["base64Value"];
            this.tenantName = data["tenantName"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileTheme {
        data = typeof data === 'object' ? data : {};
        let result = new MobileTheme();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["attribute"] = this.attribute;
        data["value"] = this.value;
        data["base64Value"] = this.base64Value;
        data["tenantName"] = this.tenantName;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileTheme {
    tenantId: number;
    tenant: Tenant | undefined;
    attribute: string | undefined;
    value: string | undefined;
    base64Value: string | undefined;
    tenantName: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Edition implements IEdition {
    name!: string;
    displayName!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IEdition) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Edition {
        data = typeof data === 'object' ? data : {};
        let result = new Edition();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEdition {
    name: string;
    displayName: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Tenant implements ITenant {
    subscriptionEndDateUtc!: moment.Moment | undefined;
    isInTrialPeriod!: boolean;
    customCssId!: string | undefined;
    logoId!: string | undefined;
    logoFileType!: string | undefined;
    subscriptionPaymentType!: SubscriptionPaymentType;
    mobileTheme!: MobileTheme[] | undefined;
    edition!: Edition | undefined;
    editionId!: number | undefined;
    creatorUser!: User | undefined;
    lastModifierUser!: User | undefined;
    deleterUser!: User | undefined;
    tenancyName!: string;
    name!: string;
    connectionString!: string | undefined;
    isActive!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ITenant) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.subscriptionEndDateUtc = data["subscriptionEndDateUtc"] ? moment(data["subscriptionEndDateUtc"].toString()) : <any>undefined;
            this.isInTrialPeriod = data["isInTrialPeriod"];
            this.customCssId = data["customCssId"];
            this.logoId = data["logoId"];
            this.logoFileType = data["logoFileType"];
            this.subscriptionPaymentType = data["subscriptionPaymentType"];
            if (Array.isArray(data["mobileTheme"])) {
                this.mobileTheme = [] as any;
                for (let item of data["mobileTheme"])
                    this.mobileTheme!.push(MobileTheme.fromJS(item));
            }
            this.edition = data["edition"] ? Edition.fromJS(data["edition"]) : <any>undefined;
            this.editionId = data["editionId"];
            this.creatorUser = data["creatorUser"] ? User.fromJS(data["creatorUser"]) : <any>undefined;
            this.lastModifierUser = data["lastModifierUser"] ? User.fromJS(data["lastModifierUser"]) : <any>undefined;
            this.deleterUser = data["deleterUser"] ? User.fromJS(data["deleterUser"]) : <any>undefined;
            this.tenancyName = data["tenancyName"];
            this.name = data["name"];
            this.connectionString = data["connectionString"];
            this.isActive = data["isActive"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Tenant {
        data = typeof data === 'object' ? data : {};
        let result = new Tenant();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["subscriptionEndDateUtc"] = this.subscriptionEndDateUtc ? this.subscriptionEndDateUtc.toISOString() : <any>undefined;
        data["isInTrialPeriod"] = this.isInTrialPeriod;
        data["customCssId"] = this.customCssId;
        data["logoId"] = this.logoId;
        data["logoFileType"] = this.logoFileType;
        data["subscriptionPaymentType"] = this.subscriptionPaymentType;
        if (Array.isArray(this.mobileTheme)) {
            data["mobileTheme"] = [];
            for (let item of this.mobileTheme)
                data["mobileTheme"].push(item.toJSON());
        }
        data["edition"] = this.edition ? this.edition.toJSON() : <any>undefined;
        data["editionId"] = this.editionId;
        data["creatorUser"] = this.creatorUser ? this.creatorUser.toJSON() : <any>undefined;
        data["lastModifierUser"] = this.lastModifierUser ? this.lastModifierUser.toJSON() : <any>undefined;
        data["deleterUser"] = this.deleterUser ? this.deleterUser.toJSON() : <any>undefined;
        data["tenancyName"] = this.tenancyName;
        data["name"] = this.name;
        data["connectionString"] = this.connectionString;
        data["isActive"] = this.isActive;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITenant {
    subscriptionEndDateUtc: moment.Moment | undefined;
    isInTrialPeriod: boolean;
    customCssId: string | undefined;
    logoId: string | undefined;
    logoFileType: string | undefined;
    subscriptionPaymentType: SubscriptionPaymentType;
    mobileTheme: MobileTheme[] | undefined;
    edition: Edition | undefined;
    editionId: number | undefined;
    creatorUser: User | undefined;
    lastModifierUser: User | undefined;
    deleterUser: User | undefined;
    tenancyName: string;
    name: string;
    connectionString: string | undefined;
    isActive: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ContactSetting implements IContactSetting {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    contactId!: number;
    contact!: Contact | undefined;
    code!: string | undefined;
    value!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IContactSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.code = data["code"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ContactSetting {
        data = typeof data === 'object' ? data : {};
        let result = new ContactSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IContactSetting {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    contactId: number;
    contact: Contact | undefined;
    code: string | undefined;
    value: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Contact implements IContact {
    tenantId!: number | undefined;
    user!: User | undefined;
    userId!: number | undefined;
    address!: Address | undefined;
    addressId!: number | undefined;
    firstName!: string;
    lastName!: string;
    company!: Company | undefined;
    companyId!: number | undefined;
    emailId!: number | undefined;
    emails!: Email | undefined;
    phoneId!: number | undefined;
    phones!: Phone | undefined;
    locationId!: number | undefined;
    locations!: Location | undefined;
    phoneNumbers!: string[] | undefined;
    settings!: ContactSetting[] | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IContact) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.address = data["address"] ? Address.fromJS(data["address"]) : <any>undefined;
            this.addressId = data["addressId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.company = data["company"] ? Company.fromJS(data["company"]) : <any>undefined;
            this.companyId = data["companyId"];
            this.emailId = data["emailId"];
            this.emails = data["emails"] ? Email.fromJS(data["emails"]) : <any>undefined;
            this.phoneId = data["phoneId"];
            this.phones = data["phones"] ? Phone.fromJS(data["phones"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.locations = data["locations"] ? Location.fromJS(data["locations"]) : <any>undefined;
            if (Array.isArray(data["phoneNumbers"])) {
                this.phoneNumbers = [] as any;
                for (let item of data["phoneNumbers"])
                    this.phoneNumbers!.push(item);
            }
            if (Array.isArray(data["settings"])) {
                this.settings = [] as any;
                for (let item of data["settings"])
                    this.settings!.push(ContactSetting.fromJS(item));
            }
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Contact {
        data = typeof data === 'object' ? data : {};
        let result = new Contact();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["addressId"] = this.addressId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["company"] = this.company ? this.company.toJSON() : <any>undefined;
        data["companyId"] = this.companyId;
        data["emailId"] = this.emailId;
        data["emails"] = this.emails ? this.emails.toJSON() : <any>undefined;
        data["phoneId"] = this.phoneId;
        data["phones"] = this.phones ? this.phones.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["locations"] = this.locations ? this.locations.toJSON() : <any>undefined;
        if (Array.isArray(this.phoneNumbers)) {
            data["phoneNumbers"] = [];
            for (let item of this.phoneNumbers)
                data["phoneNumbers"].push(item);
        }
        if (Array.isArray(this.settings)) {
            data["settings"] = [];
            for (let item of this.settings)
                data["settings"].push(item.toJSON());
        }
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IContact {
    tenantId: number | undefined;
    user: User | undefined;
    userId: number | undefined;
    address: Address | undefined;
    addressId: number | undefined;
    firstName: string;
    lastName: string;
    company: Company | undefined;
    companyId: number | undefined;
    emailId: number | undefined;
    emails: Email | undefined;
    phoneId: number | undefined;
    phones: Phone | undefined;
    locationId: number | undefined;
    locations: Location | undefined;
    phoneNumbers: string[] | undefined;
    settings: ContactSetting[] | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class TimeZone implements ITimeZone {
    value!: string;
    offset!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ITimeZone) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.offset = data["offset"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TimeZone {
        data = typeof data === 'object' ? data : {};
        let result = new TimeZone();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["offset"] = this.offset;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITimeZone {
    value: string;
    offset: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Location implements ILocation {
    tenantId!: number | undefined;
    contact!: Contact | undefined;
    contactId!: number | undefined;
    timeZone!: TimeZone | undefined;
    timeZoneId!: number | undefined;
    user!: User | undefined;
    userId!: number | undefined;
    name!: string;
    minutesPerMile!: number | undefined;
    minutesPerStop!: number | undefined;
    loadLimit!: number | undefined;
    leadTime!: number | undefined;
    etaRoundUp!: number | undefined;
    goBackTimeWindow!: number | undefined;
    inActive!: boolean;
    postalCodeRegEx!: string | undefined;
    locked!: boolean;
    unLockByUser!: User | undefined;
    unLockByUserId!: number | undefined;
    unLockDate!: moment.Moment | undefined;
    unLockReason!: string | undefined;
    unlockFrom!: moment.Moment | undefined;
    unlockTo!: moment.Moment | undefined;
    cutOffAddMinutes!: number | undefined;
    driverInactiveThreshold!: number | undefined;
    code!: string | undefined;
    generationType!: LocationGenerationTypeEnum | undefined;
    generationTime!: TimeSpan;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ILocation) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.locked = true;
            this.cutOffAddMinutes = 0;
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.timeZone = data["timeZone"] ? TimeZone.fromJS(data["timeZone"]) : <any>undefined;
            this.timeZoneId = data["timeZoneId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.name = data["name"];
            this.minutesPerMile = data["minutesPerMile"];
            this.minutesPerStop = data["minutesPerStop"];
            this.loadLimit = data["loadLimit"];
            this.leadTime = data["leadTime"];
            this.etaRoundUp = data["etaRoundUp"];
            this.goBackTimeWindow = data["goBackTimeWindow"];
            this.inActive = data["inActive"];
            this.postalCodeRegEx = data["postalCodeRegEx"];
            this.locked = data["locked"] !== undefined ? data["locked"] : true;
            this.unLockByUser = data["unLockByUser"] ? User.fromJS(data["unLockByUser"]) : <any>undefined;
            this.unLockByUserId = data["unLockByUserId"];
            this.unLockDate = data["unLockDate"] ? moment(data["unLockDate"].toString()) : <any>undefined;
            this.unLockReason = data["unLockReason"];
            this.unlockFrom = data["unlockFrom"] ? moment(data["unlockFrom"].toString()) : <any>undefined;
            this.unlockTo = data["unlockTo"] ? moment(data["unlockTo"].toString()) : <any>undefined;
            this.cutOffAddMinutes = data["cutOffAddMinutes"] !== undefined ? data["cutOffAddMinutes"] : 0;
            this.driverInactiveThreshold = data["driverInactiveThreshold"];
            this.code = data["code"];
            this.generationType = data["generationType"];
            this.generationTime = data["generationTime"] ? TimeSpan.fromJS(data["generationTime"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Location {
        data = typeof data === 'object' ? data : {};
        let result = new Location();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["timeZone"] = this.timeZone ? this.timeZone.toJSON() : <any>undefined;
        data["timeZoneId"] = this.timeZoneId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["name"] = this.name;
        data["minutesPerMile"] = this.minutesPerMile;
        data["minutesPerStop"] = this.minutesPerStop;
        data["loadLimit"] = this.loadLimit;
        data["leadTime"] = this.leadTime;
        data["etaRoundUp"] = this.etaRoundUp;
        data["goBackTimeWindow"] = this.goBackTimeWindow;
        data["inActive"] = this.inActive;
        data["postalCodeRegEx"] = this.postalCodeRegEx;
        data["locked"] = this.locked;
        data["unLockByUser"] = this.unLockByUser ? this.unLockByUser.toJSON() : <any>undefined;
        data["unLockByUserId"] = this.unLockByUserId;
        data["unLockDate"] = this.unLockDate ? this.unLockDate.toISOString() : <any>undefined;
        data["unLockReason"] = this.unLockReason;
        data["unlockFrom"] = this.unlockFrom ? this.unlockFrom.toISOString() : <any>undefined;
        data["unlockTo"] = this.unlockTo ? this.unlockTo.toISOString() : <any>undefined;
        data["cutOffAddMinutes"] = this.cutOffAddMinutes;
        data["driverInactiveThreshold"] = this.driverInactiveThreshold;
        data["code"] = this.code;
        data["generationType"] = this.generationType;
        data["generationTime"] = this.generationTime ? this.generationTime.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ILocation {
    tenantId: number | undefined;
    contact: Contact | undefined;
    contactId: number | undefined;
    timeZone: TimeZone | undefined;
    timeZoneId: number | undefined;
    user: User | undefined;
    userId: number | undefined;
    name: string;
    minutesPerMile: number | undefined;
    minutesPerStop: number | undefined;
    loadLimit: number | undefined;
    leadTime: number | undefined;
    etaRoundUp: number | undefined;
    goBackTimeWindow: number | undefined;
    inActive: boolean;
    postalCodeRegEx: string | undefined;
    locked: boolean;
    unLockByUser: User | undefined;
    unLockByUserId: number | undefined;
    unLockDate: moment.Moment | undefined;
    unLockReason: string | undefined;
    unlockFrom: moment.Moment | undefined;
    unlockTo: moment.Moment | undefined;
    cutOffAddMinutes: number | undefined;
    driverInactiveThreshold: number | undefined;
    code: string | undefined;
    generationType: LocationGenerationTypeEnum | undefined;
    generationTime: TimeSpan;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class TagInput implements ITagInput {
    tagTypeId!: number;
    tagTypeName!: string | undefined;
    value!: string | undefined;

    constructor(data?: ITagInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tagTypeId = data["tagTypeId"];
            this.tagTypeName = data["tagTypeName"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): TagInput {
        data = typeof data === 'object' ? data : {};
        let result = new TagInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tagTypeId"] = this.tagTypeId;
        data["tagTypeName"] = this.tagTypeName;
        data["value"] = this.value;
        return data; 
    }
}

export interface ITagInput {
    tagTypeId: number;
    tagTypeName: string | undefined;
    value: string | undefined;
}

export class PackageInput implements IPackageInput {
    packageId!: number;
    quantity!: number;
    packageName!: string | undefined;
    price!: number;

    constructor(data?: IPackageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.packageId = data["packageId"];
            this.quantity = data["quantity"];
            this.packageName = data["packageName"];
            this.price = data["price"];
        }
    }

    static fromJS(data: any): PackageInput {
        data = typeof data === 'object' ? data : {};
        let result = new PackageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["packageId"] = this.packageId;
        data["quantity"] = this.quantity;
        data["packageName"] = this.packageName;
        data["price"] = this.price;
        return data; 
    }
}

export interface IPackageInput {
    packageId: number;
    quantity: number;
    packageName: string | undefined;
    price: number;
}

export class CreateOrderDefaultInput implements ICreateOrderDefaultInput {
    locationId!: number | undefined;
    tagName!: string | undefined;
    tagInput!: TagInput[] | undefined;
    noteInput!: string | undefined;
    packageInput!: PackageInput[] | undefined;
    destinationEtaStart!: moment.Moment;
    destinationEtaEnd!: moment.Moment;
    destinationContactId!: number | undefined;
    destinationFirstName!: string | undefined;
    destinationLastName!: string | undefined;
    destinationEmail!: string | undefined;
    destinationPhone!: string | undefined;
    destinationAddressLine1!: string | undefined;
    destinationAddressLine2!: string | undefined;
    destinationPostalCodeId!: number | undefined;
    destinationPostalCode!: string | undefined;
    destinationCountry!: string | undefined;
    destinationCity!: string | undefined;
    destinationState!: string | undefined;
    destinationGeocodeId!: number | undefined;
    destinationAddressTypeId!: number | undefined;
    pickUpEtaStart!: moment.Moment;
    pickUpEtaEnd!: moment.Moment;
    pickUpContactId!: number | undefined;
    pickUpFirstName!: string | undefined;
    pickUpLastName!: string | undefined;
    pickUpEmail!: string | undefined;
    pickUpPhone!: string | undefined;
    pickUpAddressLine1!: string | undefined;
    pickUpAddressLine2!: string | undefined;
    pickUpPostalCodeId!: number | undefined;
    pickUpPostalCode!: string | undefined;
    pickUpCountry!: string | undefined;
    pickUpCity!: string | undefined;
    pickUpState!: string | undefined;
    pickUpGeocodeId!: number | undefined;
    pickUpAddressTypeId!: number | undefined;

    constructor(data?: ICreateOrderDefaultInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.tagName = data["tagName"];
            if (Array.isArray(data["tagInput"])) {
                this.tagInput = [] as any;
                for (let item of data["tagInput"])
                    this.tagInput!.push(TagInput.fromJS(item));
            }
            this.noteInput = data["noteInput"];
            if (Array.isArray(data["packageInput"])) {
                this.packageInput = [] as any;
                for (let item of data["packageInput"])
                    this.packageInput!.push(PackageInput.fromJS(item));
            }
            this.destinationEtaStart = data["destinationEtaStart"] ? moment(data["destinationEtaStart"].toString()) : <any>undefined;
            this.destinationEtaEnd = data["destinationEtaEnd"] ? moment(data["destinationEtaEnd"].toString()) : <any>undefined;
            this.destinationContactId = data["destinationContactId"];
            this.destinationFirstName = data["destinationFirstName"];
            this.destinationLastName = data["destinationLastName"];
            this.destinationEmail = data["destinationEmail"];
            this.destinationPhone = data["destinationPhone"];
            this.destinationAddressLine1 = data["destinationAddressLine1"];
            this.destinationAddressLine2 = data["destinationAddressLine2"];
            this.destinationPostalCodeId = data["destinationPostalCodeId"];
            this.destinationPostalCode = data["destinationPostalCode"];
            this.destinationCountry = data["destinationCountry"];
            this.destinationCity = data["destinationCity"];
            this.destinationState = data["destinationState"];
            this.destinationGeocodeId = data["destinationGeocodeId"];
            this.destinationAddressTypeId = data["destinationAddressTypeId"];
            this.pickUpEtaStart = data["pickUpEtaStart"] ? moment(data["pickUpEtaStart"].toString()) : <any>undefined;
            this.pickUpEtaEnd = data["pickUpEtaEnd"] ? moment(data["pickUpEtaEnd"].toString()) : <any>undefined;
            this.pickUpContactId = data["pickUpContactId"];
            this.pickUpFirstName = data["pickUpFirstName"];
            this.pickUpLastName = data["pickUpLastName"];
            this.pickUpEmail = data["pickUpEmail"];
            this.pickUpPhone = data["pickUpPhone"];
            this.pickUpAddressLine1 = data["pickUpAddressLine1"];
            this.pickUpAddressLine2 = data["pickUpAddressLine2"];
            this.pickUpPostalCodeId = data["pickUpPostalCodeId"];
            this.pickUpPostalCode = data["pickUpPostalCode"];
            this.pickUpCountry = data["pickUpCountry"];
            this.pickUpCity = data["pickUpCity"];
            this.pickUpState = data["pickUpState"];
            this.pickUpGeocodeId = data["pickUpGeocodeId"];
            this.pickUpAddressTypeId = data["pickUpAddressTypeId"];
        }
    }

    static fromJS(data: any): CreateOrderDefaultInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderDefaultInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["tagName"] = this.tagName;
        if (Array.isArray(this.tagInput)) {
            data["tagInput"] = [];
            for (let item of this.tagInput)
                data["tagInput"].push(item.toJSON());
        }
        data["noteInput"] = this.noteInput;
        if (Array.isArray(this.packageInput)) {
            data["packageInput"] = [];
            for (let item of this.packageInput)
                data["packageInput"].push(item.toJSON());
        }
        data["destinationEtaStart"] = this.destinationEtaStart ? this.destinationEtaStart.toISOString() : <any>undefined;
        data["destinationEtaEnd"] = this.destinationEtaEnd ? this.destinationEtaEnd.toISOString() : <any>undefined;
        data["destinationContactId"] = this.destinationContactId;
        data["destinationFirstName"] = this.destinationFirstName;
        data["destinationLastName"] = this.destinationLastName;
        data["destinationEmail"] = this.destinationEmail;
        data["destinationPhone"] = this.destinationPhone;
        data["destinationAddressLine1"] = this.destinationAddressLine1;
        data["destinationAddressLine2"] = this.destinationAddressLine2;
        data["destinationPostalCodeId"] = this.destinationPostalCodeId;
        data["destinationPostalCode"] = this.destinationPostalCode;
        data["destinationCountry"] = this.destinationCountry;
        data["destinationCity"] = this.destinationCity;
        data["destinationState"] = this.destinationState;
        data["destinationGeocodeId"] = this.destinationGeocodeId;
        data["destinationAddressTypeId"] = this.destinationAddressTypeId;
        data["pickUpEtaStart"] = this.pickUpEtaStart ? this.pickUpEtaStart.toISOString() : <any>undefined;
        data["pickUpEtaEnd"] = this.pickUpEtaEnd ? this.pickUpEtaEnd.toISOString() : <any>undefined;
        data["pickUpContactId"] = this.pickUpContactId;
        data["pickUpFirstName"] = this.pickUpFirstName;
        data["pickUpLastName"] = this.pickUpLastName;
        data["pickUpEmail"] = this.pickUpEmail;
        data["pickUpPhone"] = this.pickUpPhone;
        data["pickUpAddressLine1"] = this.pickUpAddressLine1;
        data["pickUpAddressLine2"] = this.pickUpAddressLine2;
        data["pickUpPostalCodeId"] = this.pickUpPostalCodeId;
        data["pickUpPostalCode"] = this.pickUpPostalCode;
        data["pickUpCountry"] = this.pickUpCountry;
        data["pickUpCity"] = this.pickUpCity;
        data["pickUpState"] = this.pickUpState;
        data["pickUpGeocodeId"] = this.pickUpGeocodeId;
        data["pickUpAddressTypeId"] = this.pickUpAddressTypeId;
        return data; 
    }
}

export interface ICreateOrderDefaultInput {
    locationId: number | undefined;
    tagName: string | undefined;
    tagInput: TagInput[] | undefined;
    noteInput: string | undefined;
    packageInput: PackageInput[] | undefined;
    destinationEtaStart: moment.Moment;
    destinationEtaEnd: moment.Moment;
    destinationContactId: number | undefined;
    destinationFirstName: string | undefined;
    destinationLastName: string | undefined;
    destinationEmail: string | undefined;
    destinationPhone: string | undefined;
    destinationAddressLine1: string | undefined;
    destinationAddressLine2: string | undefined;
    destinationPostalCodeId: number | undefined;
    destinationPostalCode: string | undefined;
    destinationCountry: string | undefined;
    destinationCity: string | undefined;
    destinationState: string | undefined;
    destinationGeocodeId: number | undefined;
    destinationAddressTypeId: number | undefined;
    pickUpEtaStart: moment.Moment;
    pickUpEtaEnd: moment.Moment;
    pickUpContactId: number | undefined;
    pickUpFirstName: string | undefined;
    pickUpLastName: string | undefined;
    pickUpEmail: string | undefined;
    pickUpPhone: string | undefined;
    pickUpAddressLine1: string | undefined;
    pickUpAddressLine2: string | undefined;
    pickUpPostalCodeId: number | undefined;
    pickUpPostalCode: string | undefined;
    pickUpCountry: string | undefined;
    pickUpCity: string | undefined;
    pickUpState: string | undefined;
    pickUpGeocodeId: number | undefined;
    pickUpAddressTypeId: number | undefined;
}

export class GetLabelInput implements IGetLabelInput {
    trackingIdentifier!: string | undefined;

    constructor(data?: IGetLabelInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.trackingIdentifier = data["trackingIdentifier"];
        }
    }

    static fromJS(data: any): GetLabelInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetLabelInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["trackingIdentifier"] = this.trackingIdentifier;
        return data; 
    }
}

export interface IGetLabelInput {
    trackingIdentifier: string | undefined;
}

export class ZplResult implements IZplResult {
    zpl!: string | undefined;

    constructor(data?: IZplResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.zpl = data["zpl"];
        }
    }

    static fromJS(data: any): ZplResult {
        data = typeof data === 'object' ? data : {};
        let result = new ZplResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["zpl"] = this.zpl;
        return data; 
    }
}

export interface IZplResult {
    zpl: string | undefined;
}

export class GetLabels implements IGetLabels {
    labels!: string[] | undefined;

    constructor(data?: IGetLabels) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["labels"])) {
                this.labels = [] as any;
                for (let item of data["labels"])
                    this.labels!.push(item);
            }
        }
    }

    static fromJS(data: any): GetLabels {
        data = typeof data === 'object' ? data : {};
        let result = new GetLabels();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.labels)) {
            data["labels"] = [];
            for (let item of this.labels)
                data["labels"].push(item);
        }
        return data; 
    }
}

export interface IGetLabels {
    labels: string[] | undefined;
}

export class ListResultDtoOfOrderListDto implements IListResultDtoOfOrderListDto {
    items!: OrderListDto[] | undefined;

    constructor(data?: IListResultDtoOfOrderListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfOrderListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfOrderListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfOrderListDto {
    items: OrderListDto[] | undefined;
}

export class AddressInput implements IAddressInput {
    addressLine1!: string;
    addressLine2!: string | undefined;
    cityId!: number;
    stateId!: number;
    countryId!: number;
    postalCodeId!: number;
    geocodeId!: number | undefined;
    addressTypeId!: number | undefined;

    constructor(data?: IAddressInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.cityId = data["cityId"];
            this.stateId = data["stateId"];
            this.countryId = data["countryId"];
            this.postalCodeId = data["postalCodeId"];
            this.geocodeId = data["geocodeId"];
            this.addressTypeId = data["addressTypeId"];
        }
    }

    static fromJS(data: any): AddressInput {
        data = typeof data === 'object' ? data : {};
        let result = new AddressInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["cityId"] = this.cityId;
        data["stateId"] = this.stateId;
        data["countryId"] = this.countryId;
        data["postalCodeId"] = this.postalCodeId;
        data["geocodeId"] = this.geocodeId;
        data["addressTypeId"] = this.addressTypeId;
        return data; 
    }
}

export interface IAddressInput {
    addressLine1: string;
    addressLine2: string | undefined;
    cityId: number;
    stateId: number;
    countryId: number;
    postalCodeId: number;
    geocodeId: number | undefined;
    addressTypeId: number | undefined;
}

export class ContactInput implements IContactInput {
    addressId!: number | undefined;
    addressInput!: AddressInput | undefined;
    firstName!: string;
    lastName!: string;

    constructor(data?: IContactInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressId = data["addressId"];
            this.addressInput = data["addressInput"] ? AddressInput.fromJS(data["addressInput"]) : <any>undefined;
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
        }
    }

    static fromJS(data: any): ContactInput {
        data = typeof data === 'object' ? data : {};
        let result = new ContactInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressId"] = this.addressId;
        data["addressInput"] = this.addressInput ? this.addressInput.toJSON() : <any>undefined;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        return data; 
    }
}

export interface IContactInput {
    addressId: number | undefined;
    addressInput: AddressInput | undefined;
    firstName: string;
    lastName: string;
}

export class CreatePhoneInput implements ICreatePhoneInput {
    contactId!: number;
    value!: string | undefined;

    constructor(data?: ICreatePhoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreatePhoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreatePhoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreatePhoneInput {
    contactId: number;
    value: string | undefined;
}

export class DestinationDetailInput implements IDestinationDetailInput {
    contactId!: number | undefined;
    contactInput!: ContactInput | undefined;
    etaStart!: moment.Moment;
    etaEnd!: moment.Moment;
    email!: CreateEmailInput | undefined;
    phone!: CreatePhoneInput | undefined;

    constructor(data?: IDestinationDetailInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.contactInput = data["contactInput"] ? ContactInput.fromJS(data["contactInput"]) : <any>undefined;
            this.etaStart = data["etaStart"] ? moment(data["etaStart"].toString()) : <any>undefined;
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
            this.email = data["email"] ? CreateEmailInput.fromJS(data["email"]) : <any>undefined;
            this.phone = data["phone"] ? CreatePhoneInput.fromJS(data["phone"]) : <any>undefined;
        }
    }

    static fromJS(data: any): DestinationDetailInput {
        data = typeof data === 'object' ? data : {};
        let result = new DestinationDetailInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["contactInput"] = this.contactInput ? this.contactInput.toJSON() : <any>undefined;
        data["etaStart"] = this.etaStart ? this.etaStart.toISOString() : <any>undefined;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        data["email"] = this.email ? this.email.toJSON() : <any>undefined;
        data["phone"] = this.phone ? this.phone.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IDestinationDetailInput {
    contactId: number | undefined;
    contactInput: ContactInput | undefined;
    etaStart: moment.Moment;
    etaEnd: moment.Moment;
    email: CreateEmailInput | undefined;
    phone: CreatePhoneInput | undefined;
}

export class PickupDetailInput implements IPickupDetailInput {
    contactId!: number | undefined;
    contactInput!: ContactInput | undefined;
    etaStart!: moment.Moment;
    etaEnd!: moment.Moment;
    email!: CreateEmailInput | undefined;
    phone!: CreatePhoneInput | undefined;

    constructor(data?: IPickupDetailInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.contactInput = data["contactInput"] ? ContactInput.fromJS(data["contactInput"]) : <any>undefined;
            this.etaStart = data["etaStart"] ? moment(data["etaStart"].toString()) : <any>undefined;
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
            this.email = data["email"] ? CreateEmailInput.fromJS(data["email"]) : <any>undefined;
            this.phone = data["phone"] ? CreatePhoneInput.fromJS(data["phone"]) : <any>undefined;
        }
    }

    static fromJS(data: any): PickupDetailInput {
        data = typeof data === 'object' ? data : {};
        let result = new PickupDetailInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["contactInput"] = this.contactInput ? this.contactInput.toJSON() : <any>undefined;
        data["etaStart"] = this.etaStart ? this.etaStart.toISOString() : <any>undefined;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        data["email"] = this.email ? this.email.toJSON() : <any>undefined;
        data["phone"] = this.phone ? this.phone.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IPickupDetailInput {
    contactId: number | undefined;
    contactInput: ContactInput | undefined;
    etaStart: moment.Moment;
    etaEnd: moment.Moment;
    email: CreateEmailInput | undefined;
    phone: CreatePhoneInput | undefined;
}

export class CreateOrderV2Input implements ICreateOrderV2Input {
    locationId!: number;
    noteInput!: CreateNoteInput | undefined;
    packageInput!: PackageInput[] | undefined;
    destinationDetailInput!: DestinationDetailInput | undefined;
    pickupDetailInput!: PickupDetailInput | undefined;
    tag!: string | undefined;
    userId!: number;
    tagType!: TagTypeListDto | undefined;

    constructor(data?: ICreateOrderV2Input) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.noteInput = data["noteInput"] ? CreateNoteInput.fromJS(data["noteInput"]) : <any>undefined;
            if (Array.isArray(data["packageInput"])) {
                this.packageInput = [] as any;
                for (let item of data["packageInput"])
                    this.packageInput!.push(PackageInput.fromJS(item));
            }
            this.destinationDetailInput = data["destinationDetailInput"] ? DestinationDetailInput.fromJS(data["destinationDetailInput"]) : <any>undefined;
            this.pickupDetailInput = data["pickupDetailInput"] ? PickupDetailInput.fromJS(data["pickupDetailInput"]) : <any>undefined;
            this.tag = data["tag"];
            this.userId = data["userId"];
            this.tagType = data["tagType"] ? TagTypeListDto.fromJS(data["tagType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateOrderV2Input {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderV2Input();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["noteInput"] = this.noteInput ? this.noteInput.toJSON() : <any>undefined;
        if (Array.isArray(this.packageInput)) {
            data["packageInput"] = [];
            for (let item of this.packageInput)
                data["packageInput"].push(item.toJSON());
        }
        data["destinationDetailInput"] = this.destinationDetailInput ? this.destinationDetailInput.toJSON() : <any>undefined;
        data["pickupDetailInput"] = this.pickupDetailInput ? this.pickupDetailInput.toJSON() : <any>undefined;
        data["tag"] = this.tag;
        data["userId"] = this.userId;
        data["tagType"] = this.tagType ? this.tagType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ICreateOrderV2Input {
    locationId: number;
    noteInput: CreateNoteInput | undefined;
    packageInput: PackageInput[] | undefined;
    destinationDetailInput: DestinationDetailInput | undefined;
    pickupDetailInput: PickupDetailInput | undefined;
    tag: string | undefined;
    userId: number;
    tagType: TagTypeListDto | undefined;
}

export class IOrderStatusAddEventData implements IIOrderStatusAddEventData {

    constructor(data?: IIOrderStatusAddEventData) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): IOrderStatusAddEventData {
        data = typeof data === 'object' ? data : {};
        let result = new IOrderStatusAddEventData();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IIOrderStatusAddEventData {
}

export class ClinicReadNoteList implements IClinicReadNoteList {
    id!: number;
    isRead!: boolean;

    constructor(data?: IClinicReadNoteList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.isRead = data["isRead"];
        }
    }

    static fromJS(data: any): ClinicReadNoteList {
        data = typeof data === 'object' ? data : {};
        let result = new ClinicReadNoteList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["isRead"] = this.isRead;
        return data; 
    }
}

export interface IClinicReadNoteList {
    id: number;
    isRead: boolean;
}

export class CreateClinicNoteReadInput implements ICreateClinicNoteReadInput {
    orders!: ClinicReadNoteList[] | undefined;

    constructor(data?: ICreateClinicNoteReadInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["orders"])) {
                this.orders = [] as any;
                for (let item of data["orders"])
                    this.orders!.push(ClinicReadNoteList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateClinicNoteReadInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateClinicNoteReadInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.orders)) {
            data["orders"] = [];
            for (let item of this.orders)
                data["orders"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateClinicNoteReadInput {
    orders: ClinicReadNoteList[] | undefined;
}

export class LockedOrderInput implements ILockedOrderInput {
    id!: number;
    routeScheduleId!: number;
    locked!: boolean;

    constructor(data?: ILockedOrderInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeScheduleId = data["routeScheduleId"];
            this.locked = data["locked"];
        }
    }

    static fromJS(data: any): LockedOrderInput {
        data = typeof data === 'object' ? data : {};
        let result = new LockedOrderInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeScheduleId"] = this.routeScheduleId;
        data["locked"] = this.locked;
        return data; 
    }
}

export interface ILockedOrderInput {
    id: number;
    routeScheduleId: number;
    locked: boolean;
}

export class EditOrdeContactDetail implements IEditOrdeContactDetail {
    id!: number;
    phoneId!: number | undefined;
    emailId!: number | undefined;
    firstName!: string | undefined;
    lastName!: string | undefined;
    phone!: string | undefined;
    email!: string | undefined;

    constructor(data?: IEditOrdeContactDetail) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.phoneId = data["phoneId"];
            this.emailId = data["emailId"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.phone = data["phone"];
            this.email = data["email"];
        }
    }

    static fromJS(data: any): EditOrdeContactDetail {
        data = typeof data === 'object' ? data : {};
        let result = new EditOrdeContactDetail();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["phoneId"] = this.phoneId;
        data["emailId"] = this.emailId;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["phone"] = this.phone;
        data["email"] = this.email;
        return data; 
    }
}

export interface IEditOrdeContactDetail {
    id: number;
    phoneId: number | undefined;
    emailId: number | undefined;
    firstName: string | undefined;
    lastName: string | undefined;
    phone: string | undefined;
    email: string | undefined;
}

export class GetOrderTagOrderIdDto implements IGetOrderTagOrderIdDto {
    orderId!: number;
    tagName!: string | undefined;

    constructor(data?: IGetOrderTagOrderIdDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.tagName = data["tagName"];
        }
    }

    static fromJS(data: any): GetOrderTagOrderIdDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderTagOrderIdDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["tagName"] = this.tagName;
        return data; 
    }
}

export interface IGetOrderTagOrderIdDto {
    orderId: number;
    tagName: string | undefined;
}

export class CancelOrderInputDto implements ICancelOrderInputDto {
    confirmationNumber!: string[] | undefined;
    specialInstructions!: string | undefined;

    constructor(data?: ICancelOrderInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["confirmationNumber"])) {
                this.confirmationNumber = [] as any;
                for (let item of data["confirmationNumber"])
                    this.confirmationNumber!.push(item);
            }
            this.specialInstructions = data["specialInstructions"];
        }
    }

    static fromJS(data: any): CancelOrderInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CancelOrderInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.confirmationNumber)) {
            data["confirmationNumber"] = [];
            for (let item of this.confirmationNumber)
                data["confirmationNumber"].push(item);
        }
        data["specialInstructions"] = this.specialInstructions;
        return data; 
    }
}

export interface ICancelOrderInputDto {
    confirmationNumber: string[] | undefined;
    specialInstructions: string | undefined;
}

export class CancelOrderResultDto implements ICancelOrderResultDto {
    orderId!: number | undefined;
    message!: string | undefined;

    constructor(data?: ICancelOrderResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.message = data["message"];
        }
    }

    static fromJS(data: any): CancelOrderResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new CancelOrderResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["message"] = this.message;
        return data; 
    }
}

export interface ICancelOrderResultDto {
    orderId: number | undefined;
    message: string | undefined;
}

export class SendEmailToCustomerDto implements ISendEmailToCustomerDto {
    orderId!: number;
    emailFrom!: string | undefined;
    emailTo!: string | undefined;
    emailCc!: string | undefined;

    constructor(data?: ISendEmailToCustomerDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.emailFrom = data["emailFrom"];
            this.emailTo = data["emailTo"];
            this.emailCc = data["emailCc"];
        }
    }

    static fromJS(data: any): SendEmailToCustomerDto {
        data = typeof data === 'object' ? data : {};
        let result = new SendEmailToCustomerDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["emailFrom"] = this.emailFrom;
        data["emailTo"] = this.emailTo;
        data["emailCc"] = this.emailCc;
        return data; 
    }
}

export interface ISendEmailToCustomerDto {
    orderId: number;
    emailFrom: string | undefined;
    emailTo: string | undefined;
    emailCc: string | undefined;
}

export class ClinicSchedDto implements IClinicSchedDto {
    clinicId!: number | undefined;

    constructor(data?: IClinicSchedDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
        }
    }

    static fromJS(data: any): ClinicSchedDto {
        data = typeof data === 'object' ? data : {};
        let result = new ClinicSchedDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        return data; 
    }
}

export interface IClinicSchedDto {
    clinicId: number | undefined;
}

export class CreateOnDemandOrderInput implements ICreateOnDemandOrderInput {
    routeId!: number | undefined;
    orderId!: number | undefined;
    pickupDetailsId!: number | undefined;
    deliveryDetailsId!: number | undefined;
    orderTypeId!: number | undefined;
    startDate!: moment.Moment | undefined;
    firstName_pickup!: string | undefined;
    lastName_pickup!: string | undefined;
    email_pickup!: string | undefined;
    phone_pickup!: string | undefined;
    addressLine1_pickup!: string | undefined;
    city_pickup!: string | undefined;
    state_pickup!: string | undefined;
    country_pickup!: string | undefined;
    postalcode_pickup!: string | undefined;
    formattedAddress_pickup!: string | undefined;
    latitude_pickup!: number;
    longitude_pickup!: number;
    addressType_pickup!: string | undefined;
    addressLine2_pickup!: string | undefined;
    pickupAddressTypeId!: number | undefined;
    firstName_deliver!: string | undefined;
    lastName_deliver!: string | undefined;
    email_deliver!: string | undefined;
    phone_deliver!: string | undefined;
    addressLine1_deliver!: string | undefined;
    city_deliver!: string | undefined;
    state_deliver!: string | undefined;
    country_deliver!: string | undefined;
    postalcode_deliver!: string | undefined;
    latitude_deliver!: number;
    longitude_deliver!: number;
    formattedAddress_deliver!: string | undefined;
    noteInput!: string | undefined;
    packageInput!: PackageInput[] | undefined;
    addressType_deliver!: string | undefined;
    deliverAddressTypeId!: number | undefined;
    addressLine2_deliver!: string | undefined;
    locationId!: number | undefined;

    constructor(data?: ICreateOnDemandOrderInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.orderId = data["orderId"];
            this.pickupDetailsId = data["pickupDetailsId"];
            this.deliveryDetailsId = data["deliveryDetailsId"];
            this.orderTypeId = data["orderTypeId"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.firstName_pickup = data["firstName_pickup"];
            this.lastName_pickup = data["lastName_pickup"];
            this.email_pickup = data["email_pickup"];
            this.phone_pickup = data["phone_pickup"];
            this.addressLine1_pickup = data["addressLine1_pickup"];
            this.city_pickup = data["city_pickup"];
            this.state_pickup = data["state_pickup"];
            this.country_pickup = data["country_pickup"];
            this.postalcode_pickup = data["postalcode_pickup"];
            this.formattedAddress_pickup = data["formattedAddress_pickup"];
            this.latitude_pickup = data["latitude_pickup"];
            this.longitude_pickup = data["longitude_pickup"];
            this.addressType_pickup = data["addressType_pickup"];
            this.addressLine2_pickup = data["addressLine2_pickup"];
            this.pickupAddressTypeId = data["pickupAddressTypeId"];
            this.firstName_deliver = data["firstName_deliver"];
            this.lastName_deliver = data["lastName_deliver"];
            this.email_deliver = data["email_deliver"];
            this.phone_deliver = data["phone_deliver"];
            this.addressLine1_deliver = data["addressLine1_deliver"];
            this.city_deliver = data["city_deliver"];
            this.state_deliver = data["state_deliver"];
            this.country_deliver = data["country_deliver"];
            this.postalcode_deliver = data["postalcode_deliver"];
            this.latitude_deliver = data["latitude_deliver"];
            this.longitude_deliver = data["longitude_deliver"];
            this.formattedAddress_deliver = data["formattedAddress_deliver"];
            this.noteInput = data["noteInput"];
            if (Array.isArray(data["packageInput"])) {
                this.packageInput = [] as any;
                for (let item of data["packageInput"])
                    this.packageInput!.push(PackageInput.fromJS(item));
            }
            this.addressType_deliver = data["addressType_deliver"];
            this.deliverAddressTypeId = data["deliverAddressTypeId"];
            this.addressLine2_deliver = data["addressLine2_deliver"];
            this.locationId = data["locationId"];
        }
    }

    static fromJS(data: any): CreateOnDemandOrderInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOnDemandOrderInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["orderId"] = this.orderId;
        data["pickupDetailsId"] = this.pickupDetailsId;
        data["deliveryDetailsId"] = this.deliveryDetailsId;
        data["orderTypeId"] = this.orderTypeId;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["firstName_pickup"] = this.firstName_pickup;
        data["lastName_pickup"] = this.lastName_pickup;
        data["email_pickup"] = this.email_pickup;
        data["phone_pickup"] = this.phone_pickup;
        data["addressLine1_pickup"] = this.addressLine1_pickup;
        data["city_pickup"] = this.city_pickup;
        data["state_pickup"] = this.state_pickup;
        data["country_pickup"] = this.country_pickup;
        data["postalcode_pickup"] = this.postalcode_pickup;
        data["formattedAddress_pickup"] = this.formattedAddress_pickup;
        data["latitude_pickup"] = this.latitude_pickup;
        data["longitude_pickup"] = this.longitude_pickup;
        data["addressType_pickup"] = this.addressType_pickup;
        data["addressLine2_pickup"] = this.addressLine2_pickup;
        data["pickupAddressTypeId"] = this.pickupAddressTypeId;
        data["firstName_deliver"] = this.firstName_deliver;
        data["lastName_deliver"] = this.lastName_deliver;
        data["email_deliver"] = this.email_deliver;
        data["phone_deliver"] = this.phone_deliver;
        data["addressLine1_deliver"] = this.addressLine1_deliver;
        data["city_deliver"] = this.city_deliver;
        data["state_deliver"] = this.state_deliver;
        data["country_deliver"] = this.country_deliver;
        data["postalcode_deliver"] = this.postalcode_deliver;
        data["latitude_deliver"] = this.latitude_deliver;
        data["longitude_deliver"] = this.longitude_deliver;
        data["formattedAddress_deliver"] = this.formattedAddress_deliver;
        data["noteInput"] = this.noteInput;
        if (Array.isArray(this.packageInput)) {
            data["packageInput"] = [];
            for (let item of this.packageInput)
                data["packageInput"].push(item.toJSON());
        }
        data["addressType_deliver"] = this.addressType_deliver;
        data["deliverAddressTypeId"] = this.deliverAddressTypeId;
        data["addressLine2_deliver"] = this.addressLine2_deliver;
        data["locationId"] = this.locationId;
        return data; 
    }
}

export interface ICreateOnDemandOrderInput {
    routeId: number | undefined;
    orderId: number | undefined;
    pickupDetailsId: number | undefined;
    deliveryDetailsId: number | undefined;
    orderTypeId: number | undefined;
    startDate: moment.Moment | undefined;
    firstName_pickup: string | undefined;
    lastName_pickup: string | undefined;
    email_pickup: string | undefined;
    phone_pickup: string | undefined;
    addressLine1_pickup: string | undefined;
    city_pickup: string | undefined;
    state_pickup: string | undefined;
    country_pickup: string | undefined;
    postalcode_pickup: string | undefined;
    formattedAddress_pickup: string | undefined;
    latitude_pickup: number;
    longitude_pickup: number;
    addressType_pickup: string | undefined;
    addressLine2_pickup: string | undefined;
    pickupAddressTypeId: number | undefined;
    firstName_deliver: string | undefined;
    lastName_deliver: string | undefined;
    email_deliver: string | undefined;
    phone_deliver: string | undefined;
    addressLine1_deliver: string | undefined;
    city_deliver: string | undefined;
    state_deliver: string | undefined;
    country_deliver: string | undefined;
    postalcode_deliver: string | undefined;
    latitude_deliver: number;
    longitude_deliver: number;
    formattedAddress_deliver: string | undefined;
    noteInput: string | undefined;
    packageInput: PackageInput[] | undefined;
    addressType_deliver: string | undefined;
    deliverAddressTypeId: number | undefined;
    addressLine2_deliver: string | undefined;
    locationId: number | undefined;
}

export class GetLiveEtaResult implements IGetLiveEtaResult {
    liveEta!: moment.Moment;

    constructor(data?: IGetLiveEtaResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.liveEta = data["liveEta"] ? moment(data["liveEta"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetLiveEtaResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetLiveEtaResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["liveEta"] = this.liveEta ? this.liveEta.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetLiveEtaResult {
    liveEta: moment.Moment;
}

export class AddressCheckerInput implements IAddressCheckerInput {
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    postalCodeId!: number;
    geocodes!: Geocode | undefined;
    geocodeId!: number | undefined;
    formattedAddress!: string | undefined;
    addressTypes!: string | undefined;
    addressTypeId!: number | undefined;
    locationId!: number;

    constructor(data?: IAddressCheckerInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.postalCodeId = data["postalCodeId"];
            this.geocodes = data["geocodes"] ? Geocode.fromJS(data["geocodes"]) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.formattedAddress = data["formattedAddress"];
            this.addressTypes = data["addressTypes"];
            this.addressTypeId = data["addressTypeId"];
            this.locationId = data["locationId"];
        }
    }

    static fromJS(data: any): AddressCheckerInput {
        data = typeof data === 'object' ? data : {};
        let result = new AddressCheckerInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["postalCodeId"] = this.postalCodeId;
        data["geocodes"] = this.geocodes ? this.geocodes.toJSON() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["formattedAddress"] = this.formattedAddress;
        data["addressTypes"] = this.addressTypes;
        data["addressTypeId"] = this.addressTypeId;
        data["locationId"] = this.locationId;
        return data; 
    }
}

export interface IAddressCheckerInput {
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    postalCodeId: number;
    geocodes: Geocode | undefined;
    geocodeId: number | undefined;
    formattedAddress: string | undefined;
    addressTypes: string | undefined;
    addressTypeId: number | undefined;
    locationId: number;
}

export class CreateOrderBulkResult implements ICreateOrderBulkResult {
    packageIds!: number[] | undefined;
    trackingIdentifier!: string | undefined;
    message!: string | undefined;
    isSuccess!: boolean;
    isUpdate!: boolean;
    locationId!: number | undefined;
    pickUpDate!: moment.Moment | undefined;
    deliveryDate!: moment.Moment | undefined;

    constructor(data?: ICreateOrderBulkResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["packageIds"])) {
                this.packageIds = [] as any;
                for (let item of data["packageIds"])
                    this.packageIds!.push(item);
            }
            this.trackingIdentifier = data["trackingIdentifier"];
            this.message = data["message"];
            this.isSuccess = data["isSuccess"];
            this.isUpdate = data["isUpdate"];
            this.locationId = data["locationId"];
            this.pickUpDate = data["pickUpDate"] ? moment(data["pickUpDate"].toString()) : <any>undefined;
            this.deliveryDate = data["deliveryDate"] ? moment(data["deliveryDate"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateOrderBulkResult {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderBulkResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.packageIds)) {
            data["packageIds"] = [];
            for (let item of this.packageIds)
                data["packageIds"].push(item);
        }
        data["trackingIdentifier"] = this.trackingIdentifier;
        data["message"] = this.message;
        data["isSuccess"] = this.isSuccess;
        data["isUpdate"] = this.isUpdate;
        data["locationId"] = this.locationId;
        data["pickUpDate"] = this.pickUpDate ? this.pickUpDate.toISOString() : <any>undefined;
        data["deliveryDate"] = this.deliveryDate ? this.deliveryDate.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ICreateOrderBulkResult {
    packageIds: number[] | undefined;
    trackingIdentifier: string | undefined;
    message: string | undefined;
    isSuccess: boolean;
    isUpdate: boolean;
    locationId: number | undefined;
    pickUpDate: moment.Moment | undefined;
    deliveryDate: moment.Moment | undefined;
}

export class GetOrderIncidentListDto implements IGetOrderIncidentListDto {
    id!: number;
    orderId!: number;
    incidentTypeId!: number;
    incidentId!: number;
    orderUserId!: string | undefined;
    incidentCreatorUser!: string | undefined;
    incidentTypeName!: string | undefined;
    customer!: string | undefined;
    accountNo!: string | undefined;
    location!: string | undefined;
    locationId!: number;
    incidentContent!: string | undefined;
    customerPickup!: string | undefined;
    incidentDate!: moment.Moment;
    incidentDateTime!: string | undefined;
    orderTypeId!: number;
    orderTypeDescription!: string | undefined;
    orderTypeColor!: string | undefined;

    constructor(data?: IGetOrderIncidentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.orderId = data["orderId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.incidentId = data["incidentId"];
            this.orderUserId = data["orderUserId"];
            this.incidentCreatorUser = data["incidentCreatorUser"];
            this.incidentTypeName = data["incidentTypeName"];
            this.customer = data["customer"];
            this.accountNo = data["accountNo"];
            this.location = data["location"];
            this.locationId = data["locationId"];
            this.incidentContent = data["incidentContent"];
            this.customerPickup = data["customerPickup"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.incidentDateTime = data["incidentDateTime"];
            this.orderTypeId = data["orderTypeId"];
            this.orderTypeDescription = data["orderTypeDescription"];
            this.orderTypeColor = data["orderTypeColor"];
        }
    }

    static fromJS(data: any): GetOrderIncidentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderIncidentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["orderId"] = this.orderId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["incidentId"] = this.incidentId;
        data["orderUserId"] = this.orderUserId;
        data["incidentCreatorUser"] = this.incidentCreatorUser;
        data["incidentTypeName"] = this.incidentTypeName;
        data["customer"] = this.customer;
        data["accountNo"] = this.accountNo;
        data["location"] = this.location;
        data["locationId"] = this.locationId;
        data["incidentContent"] = this.incidentContent;
        data["customerPickup"] = this.customerPickup;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["incidentDateTime"] = this.incidentDateTime;
        data["orderTypeId"] = this.orderTypeId;
        data["orderTypeDescription"] = this.orderTypeDescription;
        data["orderTypeColor"] = this.orderTypeColor;
        return data; 
    }
}

export interface IGetOrderIncidentListDto {
    id: number;
    orderId: number;
    incidentTypeId: number;
    incidentId: number;
    orderUserId: string | undefined;
    incidentCreatorUser: string | undefined;
    incidentTypeName: string | undefined;
    customer: string | undefined;
    accountNo: string | undefined;
    location: string | undefined;
    locationId: number;
    incidentContent: string | undefined;
    customerPickup: string | undefined;
    incidentDate: moment.Moment;
    incidentDateTime: string | undefined;
    orderTypeId: number;
    orderTypeDescription: string | undefined;
    orderTypeColor: string | undefined;
}

export class GroupOrderIncidentTab implements IGroupOrderIncidentTab {
    orderTypeDescription!: string | undefined;
    orderTypeId!: number;
    orderTypeColor!: string | undefined;
    groupOrders!: GetOrderIncidentListDto[] | undefined;

    constructor(data?: IGroupOrderIncidentTab) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderTypeDescription = data["orderTypeDescription"];
            this.orderTypeId = data["orderTypeId"];
            this.orderTypeColor = data["orderTypeColor"];
            if (Array.isArray(data["groupOrders"])) {
                this.groupOrders = [] as any;
                for (let item of data["groupOrders"])
                    this.groupOrders!.push(GetOrderIncidentListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GroupOrderIncidentTab {
        data = typeof data === 'object' ? data : {};
        let result = new GroupOrderIncidentTab();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderTypeDescription"] = this.orderTypeDescription;
        data["orderTypeId"] = this.orderTypeId;
        data["orderTypeColor"] = this.orderTypeColor;
        if (Array.isArray(this.groupOrders)) {
            data["groupOrders"] = [];
            for (let item of this.groupOrders)
                data["groupOrders"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGroupOrderIncidentTab {
    orderTypeDescription: string | undefined;
    orderTypeId: number;
    orderTypeColor: string | undefined;
    groupOrders: GetOrderIncidentListDto[] | undefined;
}

export class PagedResultDtoOfgroupOrderIncidentTab implements IPagedResultDtoOfgroupOrderIncidentTab {
    totalCount!: number;
    items!: GroupOrderIncidentTab[] | undefined;

    constructor(data?: IPagedResultDtoOfgroupOrderIncidentTab) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GroupOrderIncidentTab.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfgroupOrderIncidentTab {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfgroupOrderIncidentTab();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfgroupOrderIncidentTab {
    totalCount: number;
    items: GroupOrderIncidentTab[] | undefined;
}

export class PagedResultDtoOfGetOrderIncidentListDto implements IPagedResultDtoOfGetOrderIncidentListDto {
    totalCount!: number;
    items!: GetOrderIncidentListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderIncidentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderIncidentListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderIncidentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderIncidentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderIncidentListDto {
    totalCount: number;
    items: GetOrderIncidentListDto[] | undefined;
}

export class OrderIncidentDto implements IOrderIncidentDto {
    orderId!: number;
    incidentId!: number;
    incidentTypeId!: number;
    id!: number;

    constructor(data?: IOrderIncidentDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.incidentId = data["incidentId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderIncidentDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncidentDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["incidentId"] = this.incidentId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderIncidentDto {
    orderId: number;
    incidentId: number;
    incidentTypeId: number;
    id: number;
}

export class GetOrderIncidentForViewDto implements IGetOrderIncidentForViewDto {
    orderIncident!: OrderIncidentDto | undefined;
    orderUserId!: string | undefined;
    incidentCreatorUser!: string | undefined;
    incidentTypeName!: string | undefined;
    customer!: string | undefined;
    location!: string | undefined;
    locationId!: number;
    incidentContent!: string | undefined;
    incidentDate!: moment.Moment;

    constructor(data?: IGetOrderIncidentForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderIncident = data["orderIncident"] ? OrderIncidentDto.fromJS(data["orderIncident"]) : <any>undefined;
            this.orderUserId = data["orderUserId"];
            this.incidentCreatorUser = data["incidentCreatorUser"];
            this.incidentTypeName = data["incidentTypeName"];
            this.customer = data["customer"];
            this.location = data["location"];
            this.locationId = data["locationId"];
            this.incidentContent = data["incidentContent"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderIncidentForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderIncidentForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderIncident"] = this.orderIncident ? this.orderIncident.toJSON() : <any>undefined;
        data["orderUserId"] = this.orderUserId;
        data["incidentCreatorUser"] = this.incidentCreatorUser;
        data["incidentTypeName"] = this.incidentTypeName;
        data["customer"] = this.customer;
        data["location"] = this.location;
        data["locationId"] = this.locationId;
        data["incidentContent"] = this.incidentContent;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderIncidentForViewDto {
    orderIncident: OrderIncidentDto | undefined;
    orderUserId: string | undefined;
    incidentCreatorUser: string | undefined;
    incidentTypeName: string | undefined;
    customer: string | undefined;
    location: string | undefined;
    locationId: number;
    incidentContent: string | undefined;
    incidentDate: moment.Moment;
}

export class EditOrderIncidentDto implements IEditOrderIncidentDto {
    orderId!: number;
    incidentTypeId!: number;
    geocodeId!: number | undefined;
    content!: string | undefined;
    incidentDate!: moment.Moment;
    id!: number | undefined;

    constructor(data?: IEditOrderIncidentDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.geocodeId = data["geocodeId"];
            this.content = data["content"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EditOrderIncidentDto {
        data = typeof data === 'object' ? data : {};
        let result = new EditOrderIncidentDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["geocodeId"] = this.geocodeId;
        data["content"] = this.content;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEditOrderIncidentDto {
    orderId: number;
    incidentTypeId: number;
    geocodeId: number | undefined;
    content: string | undefined;
    incidentDate: moment.Moment;
    id: number | undefined;
}

export class GetOrderIncidentForEditOutput implements IGetOrderIncidentForEditOutput {
    orderIncident!: EditOrderIncidentDto | undefined;
    orderUserId!: string | undefined;
    orderId!: number;
    incidentCreatorUser!: string | undefined;
    incidentTypeName!: string | undefined;
    user!: string | undefined;
    location!: string | undefined;
    locationId!: number;
    incidentContent!: string | undefined;
    incidentId!: number;

    constructor(data?: IGetOrderIncidentForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderIncident = data["orderIncident"] ? EditOrderIncidentDto.fromJS(data["orderIncident"]) : <any>undefined;
            this.orderUserId = data["orderUserId"];
            this.orderId = data["orderId"];
            this.incidentCreatorUser = data["incidentCreatorUser"];
            this.incidentTypeName = data["incidentTypeName"];
            this.user = data["user"];
            this.location = data["location"];
            this.locationId = data["locationId"];
            this.incidentContent = data["incidentContent"];
            this.incidentId = data["incidentId"];
        }
    }

    static fromJS(data: any): GetOrderIncidentForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderIncidentForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderIncident"] = this.orderIncident ? this.orderIncident.toJSON() : <any>undefined;
        data["orderUserId"] = this.orderUserId;
        data["orderId"] = this.orderId;
        data["incidentCreatorUser"] = this.incidentCreatorUser;
        data["incidentTypeName"] = this.incidentTypeName;
        data["user"] = this.user;
        data["location"] = this.location;
        data["locationId"] = this.locationId;
        data["incidentContent"] = this.incidentContent;
        data["incidentId"] = this.incidentId;
        return data; 
    }
}

export interface IGetOrderIncidentForEditOutput {
    orderIncident: EditOrderIncidentDto | undefined;
    orderUserId: string | undefined;
    orderId: number;
    incidentCreatorUser: string | undefined;
    incidentTypeName: string | undefined;
    user: string | undefined;
    location: string | undefined;
    locationId: number;
    incidentContent: string | undefined;
    incidentId: number;
}

export class OrderIncidentAttachment implements IOrderIncidentAttachment {
    fileName!: string | undefined;
    base64EncodedData!: string | undefined;
    incidentId!: number;

    constructor(data?: IOrderIncidentAttachment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.base64EncodedData = data["base64EncodedData"];
            this.incidentId = data["incidentId"];
        }
    }

    static fromJS(data: any): OrderIncidentAttachment {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncidentAttachment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["base64EncodedData"] = this.base64EncodedData;
        data["incidentId"] = this.incidentId;
        return data; 
    }
}

export interface IOrderIncidentAttachment {
    fileName: string | undefined;
    base64EncodedData: string | undefined;
    incidentId: number;
}

export class OrderIncidentNotes implements IOrderIncidentNotes {
    incidentId!: number;
    notes!: string | undefined;

    constructor(data?: IOrderIncidentNotes) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentId = data["incidentId"];
            this.notes = data["notes"];
        }
    }

    static fromJS(data: any): OrderIncidentNotes {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncidentNotes();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentId"] = this.incidentId;
        data["notes"] = this.notes;
        return data; 
    }
}

export interface IOrderIncidentNotes {
    incidentId: number;
    notes: string | undefined;
}

export class CreateOrderIncidentInput implements ICreateOrderIncidentInput {
    orderId!: number | undefined;
    incidentTypeId!: number | undefined;
    geocodeId!: number | undefined;
    incidentStatusId!: number | undefined;
    content!: string | undefined;
    complaint!: string | undefined;
    investigation!: string | undefined;
    resolution!: string | undefined;
    incidentDate!: moment.Moment;
    managerId!: number | undefined;
    incidentSourceId!: number | undefined;
    email!: string | undefined;
    phone!: string | undefined;
    createAttachments!: OrderIncidentAttachment[] | undefined;
    createNotes!: OrderIncidentNotes[] | undefined;

    constructor(data?: ICreateOrderIncidentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.geocodeId = data["geocodeId"];
            this.incidentStatusId = data["incidentStatusId"];
            this.content = data["content"];
            this.complaint = data["complaint"];
            this.investigation = data["investigation"];
            this.resolution = data["resolution"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.managerId = data["managerId"];
            this.incidentSourceId = data["incidentSourceId"];
            this.email = data["email"];
            this.phone = data["phone"];
            if (Array.isArray(data["createAttachments"])) {
                this.createAttachments = [] as any;
                for (let item of data["createAttachments"])
                    this.createAttachments!.push(OrderIncidentAttachment.fromJS(item));
            }
            if (Array.isArray(data["createNotes"])) {
                this.createNotes = [] as any;
                for (let item of data["createNotes"])
                    this.createNotes!.push(OrderIncidentNotes.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateOrderIncidentInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderIncidentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["geocodeId"] = this.geocodeId;
        data["incidentStatusId"] = this.incidentStatusId;
        data["content"] = this.content;
        data["complaint"] = this.complaint;
        data["investigation"] = this.investigation;
        data["resolution"] = this.resolution;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["managerId"] = this.managerId;
        data["incidentSourceId"] = this.incidentSourceId;
        data["email"] = this.email;
        data["phone"] = this.phone;
        if (Array.isArray(this.createAttachments)) {
            data["createAttachments"] = [];
            for (let item of this.createAttachments)
                data["createAttachments"].push(item.toJSON());
        }
        if (Array.isArray(this.createNotes)) {
            data["createNotes"] = [];
            for (let item of this.createNotes)
                data["createNotes"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateOrderIncidentInput {
    orderId: number | undefined;
    incidentTypeId: number | undefined;
    geocodeId: number | undefined;
    incidentStatusId: number | undefined;
    content: string | undefined;
    complaint: string | undefined;
    investigation: string | undefined;
    resolution: string | undefined;
    incidentDate: moment.Moment;
    managerId: number | undefined;
    incidentSourceId: number | undefined;
    email: string | undefined;
    phone: string | undefined;
    createAttachments: OrderIncidentAttachment[] | undefined;
    createNotes: OrderIncidentNotes[] | undefined;
}

export class AddMultipleOrderIncidentDto implements IAddMultipleOrderIncidentDto {
    createOrderIncidentDto!: CreateOrderIncidentInput[] | undefined;

    constructor(data?: IAddMultipleOrderIncidentDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["createOrderIncidentDto"])) {
                this.createOrderIncidentDto = [] as any;
                for (let item of data["createOrderIncidentDto"])
                    this.createOrderIncidentDto!.push(CreateOrderIncidentInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): AddMultipleOrderIncidentDto {
        data = typeof data === 'object' ? data : {};
        let result = new AddMultipleOrderIncidentDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.createOrderIncidentDto)) {
            data["createOrderIncidentDto"] = [];
            for (let item of this.createOrderIncidentDto)
                data["createOrderIncidentDto"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IAddMultipleOrderIncidentDto {
    createOrderIncidentDto: CreateOrderIncidentInput[] | undefined;
}

export class IncidentSourceListDto implements IIncidentSourceListDto {
    id!: number;
    name!: string | undefined;
    isActive!: boolean;
    description!: string | undefined;

    constructor(data?: IIncidentSourceListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.isActive = data["isActive"];
            this.description = data["description"];
        }
    }

    static fromJS(data: any): IncidentSourceListDto {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentSourceListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        return data; 
    }
}

export interface IIncidentSourceListDto {
    id: number;
    name: string | undefined;
    isActive: boolean;
    description: string | undefined;
}

export class OrderIncidentOrderLookupTableDto implements IOrderIncidentOrderLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrderIncidentOrderLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrderIncidentOrderLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncidentOrderLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrderIncidentOrderLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfOrderIncidentOrderLookupTableDto implements IPagedResultDtoOfOrderIncidentOrderLookupTableDto {
    totalCount!: number;
    items!: OrderIncidentOrderLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderIncidentOrderLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderIncidentOrderLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderIncidentOrderLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderIncidentOrderLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderIncidentOrderLookupTableDto {
    totalCount: number;
    items: OrderIncidentOrderLookupTableDto[] | undefined;
}

export class OrderIncidentIncidentLookupTableDto implements IOrderIncidentIncidentLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrderIncidentIncidentLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrderIncidentIncidentLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncidentIncidentLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrderIncidentIncidentLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfOrderIncidentIncidentLookupTableDto implements IPagedResultDtoOfOrderIncidentIncidentLookupTableDto {
    totalCount!: number;
    items!: OrderIncidentIncidentLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderIncidentIncidentLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderIncidentIncidentLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderIncidentIncidentLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderIncidentIncidentLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderIncidentIncidentLookupTableDto {
    totalCount: number;
    items: OrderIncidentIncidentLookupTableDto[] | undefined;
}

export class OrderIncidentIncidentTypeLookupTableDto implements IOrderIncidentIncidentTypeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrderIncidentIncidentTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrderIncidentIncidentTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncidentIncidentTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrderIncidentIncidentTypeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto implements IPagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto {
    totalCount!: number;
    items!: OrderIncidentIncidentTypeLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderIncidentIncidentTypeLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderIncidentIncidentTypeLookupTableDto {
    totalCount: number;
    items: OrderIncidentIncidentTypeLookupTableDto[] | undefined;
}

export class CreateDriverOrderIncidentGeocode implements ICreateDriverOrderIncidentGeocode {
    latitude!: number;
    longitude!: number;

    constructor(data?: ICreateDriverOrderIncidentGeocode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): CreateDriverOrderIncidentGeocode {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDriverOrderIncidentGeocode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface ICreateDriverOrderIncidentGeocode {
    latitude: number;
    longitude: number;
}

export class CreateDriverOrderIncidentAttachment implements ICreateDriverOrderIncidentAttachment {
    fileName!: string | undefined;
    base64EncodedData!: string | undefined;

    constructor(data?: ICreateDriverOrderIncidentAttachment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.base64EncodedData = data["base64EncodedData"];
        }
    }

    static fromJS(data: any): CreateDriverOrderIncidentAttachment {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDriverOrderIncidentAttachment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["base64EncodedData"] = this.base64EncodedData;
        return data; 
    }
}

export interface ICreateDriverOrderIncidentAttachment {
    fileName: string | undefined;
    base64EncodedData: string | undefined;
}

export class CreateDriverOrderIncidentInputDto implements ICreateDriverOrderIncidentInputDto {
    orderId!: number;
    incidentTypeId!: number;
    content!: string | undefined;
    geocode!: CreateDriverOrderIncidentGeocode | undefined;
    incidentDate!: moment.Moment;
    attachments!: CreateDriverOrderIncidentAttachment[] | undefined;

    constructor(data?: ICreateDriverOrderIncidentInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.content = data["content"];
            this.geocode = data["geocode"] ? CreateDriverOrderIncidentGeocode.fromJS(data["geocode"]) : <any>undefined;
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            if (Array.isArray(data["attachments"])) {
                this.attachments = [] as any;
                for (let item of data["attachments"])
                    this.attachments!.push(CreateDriverOrderIncidentAttachment.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateDriverOrderIncidentInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDriverOrderIncidentInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["content"] = this.content;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        if (Array.isArray(this.attachments)) {
            data["attachments"] = [];
            for (let item of this.attachments)
                data["attachments"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateDriverOrderIncidentInputDto {
    orderId: number;
    incidentTypeId: number;
    content: string | undefined;
    geocode: CreateDriverOrderIncidentGeocode | undefined;
    incidentDate: moment.Moment;
    attachments: CreateDriverOrderIncidentAttachment[] | undefined;
}

export class CustomerIncidentAttachment implements ICustomerIncidentAttachment {
    fileName!: string | undefined;
    base64EncodedData!: string | undefined;

    constructor(data?: ICustomerIncidentAttachment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.base64EncodedData = data["base64EncodedData"];
        }
    }

    static fromJS(data: any): CustomerIncidentAttachment {
        data = typeof data === 'object' ? data : {};
        let result = new CustomerIncidentAttachment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["base64EncodedData"] = this.base64EncodedData;
        return data; 
    }
}

export interface ICustomerIncidentAttachment {
    fileName: string | undefined;
    base64EncodedData: string | undefined;
}

export class CreateIncidentForCustomerInputDto implements ICreateIncidentForCustomerInputDto {
    orderId!: number;
    content!: string | undefined;
    attachments!: CustomerIncidentAttachment[] | undefined;

    constructor(data?: ICreateIncidentForCustomerInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.content = data["content"];
            if (Array.isArray(data["attachments"])) {
                this.attachments = [] as any;
                for (let item of data["attachments"])
                    this.attachments!.push(CustomerIncidentAttachment.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateIncidentForCustomerInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateIncidentForCustomerInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["content"] = this.content;
        if (Array.isArray(this.attachments)) {
            data["attachments"] = [];
            for (let item of this.attachments)
                data["attachments"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateIncidentForCustomerInputDto {
    orderId: number;
    content: string | undefined;
    attachments: CustomerIncidentAttachment[] | undefined;
}

export class OrderNotificationDto implements IOrderNotificationDto {
    code!: string | undefined;
    isActive!: boolean;
    description!: string | undefined;
    orderNotificationTemplateId!: number | undefined;
    orderTypeId!: number | undefined;
    smsTemplateId!: number | undefined;
    orderStatusTypeId!: number | undefined;
    development!: boolean;
    orderTargetType!: number;
    id!: number;

    constructor(data?: IOrderNotificationDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.orderNotificationTemplateId = data["orderNotificationTemplateId"];
            this.orderTypeId = data["orderTypeId"];
            this.smsTemplateId = data["smsTemplateId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.development = data["development"];
            this.orderTargetType = data["orderTargetType"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderNotificationDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNotificationDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["orderNotificationTemplateId"] = this.orderNotificationTemplateId;
        data["orderTypeId"] = this.orderTypeId;
        data["smsTemplateId"] = this.smsTemplateId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["development"] = this.development;
        data["orderTargetType"] = this.orderTargetType;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderNotificationDto {
    code: string | undefined;
    isActive: boolean;
    description: string | undefined;
    orderNotificationTemplateId: number | undefined;
    orderTypeId: number | undefined;
    smsTemplateId: number | undefined;
    orderStatusTypeId: number | undefined;
    development: boolean;
    orderTargetType: number;
    id: number;
}

export class GetOrderNotificationForViewDto implements IGetOrderNotificationForViewDto {
    orderNotification!: OrderNotificationDto | undefined;
    orderNotificationTemplateDescription!: string | undefined;
    orderTypeDescription!: string | undefined;
    smsTemplateDescription!: string | undefined;
    orderStatusTypeDescription!: string | undefined;

    constructor(data?: IGetOrderNotificationForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderNotification = data["orderNotification"] ? OrderNotificationDto.fromJS(data["orderNotification"]) : <any>undefined;
            this.orderNotificationTemplateDescription = data["orderNotificationTemplateDescription"];
            this.orderTypeDescription = data["orderTypeDescription"];
            this.smsTemplateDescription = data["smsTemplateDescription"];
            this.orderStatusTypeDescription = data["orderStatusTypeDescription"];
        }
    }

    static fromJS(data: any): GetOrderNotificationForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderNotificationForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderNotification"] = this.orderNotification ? this.orderNotification.toJSON() : <any>undefined;
        data["orderNotificationTemplateDescription"] = this.orderNotificationTemplateDescription;
        data["orderTypeDescription"] = this.orderTypeDescription;
        data["smsTemplateDescription"] = this.smsTemplateDescription;
        data["orderStatusTypeDescription"] = this.orderStatusTypeDescription;
        return data; 
    }
}

export interface IGetOrderNotificationForViewDto {
    orderNotification: OrderNotificationDto | undefined;
    orderNotificationTemplateDescription: string | undefined;
    orderTypeDescription: string | undefined;
    smsTemplateDescription: string | undefined;
    orderStatusTypeDescription: string | undefined;
}

export class PagedResultDtoOfGetOrderNotificationForViewDto implements IPagedResultDtoOfGetOrderNotificationForViewDto {
    totalCount!: number;
    items!: GetOrderNotificationForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderNotificationForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderNotificationForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderNotificationForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderNotificationForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderNotificationForViewDto {
    totalCount: number;
    items: GetOrderNotificationForViewDto[] | undefined;
}

export class OrganizationUnitOrderNotificationDto implements IOrganizationUnitOrderNotificationDto {
    isEmail!: boolean;
    isSMS!: boolean;
    isActive!: boolean;
    emailAddress!: string | undefined;
    phoneNumber!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    orderNotificationId!: number | undefined;
    userId!: number | undefined;
    id!: number;

    constructor(data?: IOrganizationUnitOrderNotificationDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEmail = data["isEmail"];
            this.isSMS = data["isSMS"];
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.orderNotificationId = data["orderNotificationId"];
            this.userId = data["userId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrganizationUnitOrderNotificationDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnitOrderNotificationDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEmail"] = this.isEmail;
        data["isSMS"] = this.isSMS;
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["orderNotificationId"] = this.orderNotificationId;
        data["userId"] = this.userId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrganizationUnitOrderNotificationDto {
    isEmail: boolean;
    isSMS: boolean;
    isActive: boolean;
    emailAddress: string | undefined;
    phoneNumber: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    orderNotificationId: number | undefined;
    userId: number | undefined;
    id: number;
}

export class CreateOrEditOrderNotificationDto implements ICreateOrEditOrderNotificationDto {
    code!: string;
    isActive!: boolean;
    description!: string | undefined;
    organizationUnitOrderNotification!: OrganizationUnitOrderNotificationDto[] | undefined;
    orderNotificationTemplateId!: number | undefined;
    orderTypeId!: number | undefined;
    smsTemplateId!: number | undefined;
    orderStatusTypeId!: number | undefined;
    incidentTypeId!: number | undefined;
    driverIncidentTypeId!: number | undefined;
    employeeIncidentTypeId!: number | undefined;
    development!: boolean;
    targetType!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrderNotificationDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            if (Array.isArray(data["organizationUnitOrderNotification"])) {
                this.organizationUnitOrderNotification = [] as any;
                for (let item of data["organizationUnitOrderNotification"])
                    this.organizationUnitOrderNotification!.push(OrganizationUnitOrderNotificationDto.fromJS(item));
            }
            this.orderNotificationTemplateId = data["orderNotificationTemplateId"];
            this.orderTypeId = data["orderTypeId"];
            this.smsTemplateId = data["smsTemplateId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.driverIncidentTypeId = data["driverIncidentTypeId"];
            this.employeeIncidentTypeId = data["employeeIncidentTypeId"];
            this.development = data["development"];
            this.targetType = data["targetType"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrderNotificationDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrderNotificationDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        if (Array.isArray(this.organizationUnitOrderNotification)) {
            data["organizationUnitOrderNotification"] = [];
            for (let item of this.organizationUnitOrderNotification)
                data["organizationUnitOrderNotification"].push(item.toJSON());
        }
        data["orderNotificationTemplateId"] = this.orderNotificationTemplateId;
        data["orderTypeId"] = this.orderTypeId;
        data["smsTemplateId"] = this.smsTemplateId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["driverIncidentTypeId"] = this.driverIncidentTypeId;
        data["employeeIncidentTypeId"] = this.employeeIncidentTypeId;
        data["development"] = this.development;
        data["targetType"] = this.targetType;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrderNotificationDto {
    code: string;
    isActive: boolean;
    description: string | undefined;
    organizationUnitOrderNotification: OrganizationUnitOrderNotificationDto[] | undefined;
    orderNotificationTemplateId: number | undefined;
    orderTypeId: number | undefined;
    smsTemplateId: number | undefined;
    orderStatusTypeId: number | undefined;
    incidentTypeId: number | undefined;
    driverIncidentTypeId: number | undefined;
    employeeIncidentTypeId: number | undefined;
    development: boolean;
    targetType: number | undefined;
    id: number | undefined;
}

export class GetOrderNotificationForEditOutput implements IGetOrderNotificationForEditOutput {
    orderNotification!: CreateOrEditOrderNotificationDto | undefined;
    orderNotificationTemplateDescription!: string | undefined;
    orderTypeDescription!: string | undefined;
    smsTemplateDescription!: string | undefined;
    orderStatusTypeDescription!: string | undefined;
    orderIncidentTypeDescription!: string | undefined;
    driverIncidentTypeDescription!: string | undefined;
    employeeIncidentTypeDescription!: string | undefined;

    constructor(data?: IGetOrderNotificationForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderNotification = data["orderNotification"] ? CreateOrEditOrderNotificationDto.fromJS(data["orderNotification"]) : <any>undefined;
            this.orderNotificationTemplateDescription = data["orderNotificationTemplateDescription"];
            this.orderTypeDescription = data["orderTypeDescription"];
            this.smsTemplateDescription = data["smsTemplateDescription"];
            this.orderStatusTypeDescription = data["orderStatusTypeDescription"];
            this.orderIncidentTypeDescription = data["orderIncidentTypeDescription"];
            this.driverIncidentTypeDescription = data["driverIncidentTypeDescription"];
            this.employeeIncidentTypeDescription = data["employeeIncidentTypeDescription"];
        }
    }

    static fromJS(data: any): GetOrderNotificationForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderNotificationForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderNotification"] = this.orderNotification ? this.orderNotification.toJSON() : <any>undefined;
        data["orderNotificationTemplateDescription"] = this.orderNotificationTemplateDescription;
        data["orderTypeDescription"] = this.orderTypeDescription;
        data["smsTemplateDescription"] = this.smsTemplateDescription;
        data["orderStatusTypeDescription"] = this.orderStatusTypeDescription;
        data["orderIncidentTypeDescription"] = this.orderIncidentTypeDescription;
        data["driverIncidentTypeDescription"] = this.driverIncidentTypeDescription;
        data["employeeIncidentTypeDescription"] = this.employeeIncidentTypeDescription;
        return data; 
    }
}

export interface IGetOrderNotificationForEditOutput {
    orderNotification: CreateOrEditOrderNotificationDto | undefined;
    orderNotificationTemplateDescription: string | undefined;
    orderTypeDescription: string | undefined;
    smsTemplateDescription: string | undefined;
    orderStatusTypeDescription: string | undefined;
    orderIncidentTypeDescription: string | undefined;
    driverIncidentTypeDescription: string | undefined;
    employeeIncidentTypeDescription: string | undefined;
}

export class OrderNotificationOrderNotificationTemplateLookupTableDto implements IOrderNotificationOrderNotificationTemplateLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrderNotificationOrderNotificationTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrderNotificationOrderNotificationTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNotificationOrderNotificationTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrderNotificationOrderNotificationTemplateLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class IncidentStatusListDropdown implements IIncidentStatusListDropdown {
    name!: string | undefined;
    id!: number;

    constructor(data?: IIncidentStatusListDropdown) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentStatusListDropdown {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentStatusListDropdown();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentStatusListDropdown {
    name: string | undefined;
    id: number;
}

export class DriverIncidentDropDownList implements IDriverIncidentDropDownList {
    id!: number;
    name!: string | undefined;

    constructor(data?: IDriverIncidentDropDownList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): DriverIncidentDropDownList {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncidentDropDownList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IDriverIncidentDropDownList {
    id: number;
    name: string | undefined;
}

export class EmployeeIncidentDropDownList implements IEmployeeIncidentDropDownList {
    id!: number;
    name!: string | undefined;

    constructor(data?: IEmployeeIncidentDropDownList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): EmployeeIncidentDropDownList {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncidentDropDownList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IEmployeeIncidentDropDownList {
    id: number;
    name: string | undefined;
}

export class OrderNotificationOrderTypeLookupTableDto implements IOrderNotificationOrderTypeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrderNotificationOrderTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrderNotificationOrderTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNotificationOrderTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrderNotificationOrderTypeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class OrderNotificationSmsTemplateLookupTableDto implements IOrderNotificationSmsTemplateLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrderNotificationSmsTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrderNotificationSmsTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNotificationSmsTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrderNotificationSmsTemplateLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class OrderNotificationOrderStatusTypeLookupTableDto implements IOrderNotificationOrderStatusTypeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrderNotificationOrderStatusTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrderNotificationOrderStatusTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNotificationOrderStatusTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrderNotificationOrderStatusTypeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class OrganizationUnitDto implements IOrganizationUnitDto {
    parentId!: number | undefined;
    code!: string | undefined;
    displayName!: string | undefined;
    memberCount!: number;
    roleCount!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrganizationUnitDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parentId = data["parentId"];
            this.code = data["code"];
            this.displayName = data["displayName"];
            this.memberCount = data["memberCount"];
            this.roleCount = data["roleCount"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrganizationUnitDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnitDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parentId"] = this.parentId;
        data["code"] = this.code;
        data["displayName"] = this.displayName;
        data["memberCount"] = this.memberCount;
        data["roleCount"] = this.roleCount;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrganizationUnitDto {
    parentId: number | undefined;
    code: string | undefined;
    displayName: string | undefined;
    memberCount: number;
    roleCount: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class EmployeeIncidentNotifInput implements IEmployeeIncidentNotifInput {
    incidentTypeId!: number;
    userId!: number;
    targetTypeId!: number;

    constructor(data?: IEmployeeIncidentNotifInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incidentTypeId = data["incidentTypeId"];
            this.userId = data["userId"];
            this.targetTypeId = data["targetTypeId"];
        }
    }

    static fromJS(data: any): EmployeeIncidentNotifInput {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncidentNotifInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incidentTypeId"] = this.incidentTypeId;
        data["userId"] = this.userId;
        data["targetTypeId"] = this.targetTypeId;
        return data; 
    }
}

export interface IEmployeeIncidentNotifInput {
    incidentTypeId: number;
    userId: number;
    targetTypeId: number;
}

export class OrderIncidentNotifInput implements IOrderIncidentNotifInput {
    orderIncidentId!: number;
    incidentTypeId!: number;
    orderId!: number;
    targetTypeId!: number;

    constructor(data?: IOrderIncidentNotifInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderIncidentId = data["orderIncidentId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.orderId = data["orderId"];
            this.targetTypeId = data["targetTypeId"];
        }
    }

    static fromJS(data: any): OrderIncidentNotifInput {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncidentNotifInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderIncidentId"] = this.orderIncidentId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["orderId"] = this.orderId;
        data["targetTypeId"] = this.targetTypeId;
        return data; 
    }
}

export interface IOrderIncidentNotifInput {
    orderIncidentId: number;
    incidentTypeId: number;
    orderId: number;
    targetTypeId: number;
}

export class OrgEmailInput implements IOrgEmailInput {
    orderStatusTypeId!: number;
    orderId!: number;
    targetTypeId!: number;
    orderTypeId!: number;
    notifName!: string | undefined;
    notifNumber!: string | undefined;
    time!: string | undefined;

    constructor(data?: IOrgEmailInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderId = data["orderId"];
            this.targetTypeId = data["targetTypeId"];
            this.orderTypeId = data["orderTypeId"];
            this.notifName = data["notifName"];
            this.notifNumber = data["notifNumber"];
            this.time = data["time"];
        }
    }

    static fromJS(data: any): OrgEmailInput {
        data = typeof data === 'object' ? data : {};
        let result = new OrgEmailInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderId"] = this.orderId;
        data["targetTypeId"] = this.targetTypeId;
        data["orderTypeId"] = this.orderTypeId;
        data["notifName"] = this.notifName;
        data["notifNumber"] = this.notifNumber;
        data["time"] = this.time;
        return data; 
    }
}

export interface IOrgEmailInput {
    orderStatusTypeId: number;
    orderId: number;
    targetTypeId: number;
    orderTypeId: number;
    notifName: string | undefined;
    notifNumber: string | undefined;
    time: string | undefined;
}

export class NotifCheckerInput implements INotifCheckerInput {
    orderStatusTypeId!: number;
    orderId!: number;

    constructor(data?: INotifCheckerInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): NotifCheckerInput {
        data = typeof data === 'object' ? data : {};
        let result = new NotifCheckerInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface INotifCheckerInput {
    orderStatusTypeId: number;
    orderId: number;
}

export class TestNotificationInput implements ITestNotificationInput {
    emailAddress!: string | undefined;
    phoneNumber!: string | undefined;

    constructor(data?: ITestNotificationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
        }
    }

    static fromJS(data: any): TestNotificationInput {
        data = typeof data === 'object' ? data : {};
        let result = new TestNotificationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        return data; 
    }
}

export interface ITestNotificationInput {
    emailAddress: string | undefined;
    phoneNumber: string | undefined;
}

export class OrderInfoDto implements IOrderInfoDto {
    statusId!: number | undefined;
    orderSourceId!: number | undefined;

    constructor(data?: IOrderInfoDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.statusId = data["statusId"];
            this.orderSourceId = data["orderSourceId"];
        }
    }

    static fromJS(data: any): OrderInfoDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderInfoDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["statusId"] = this.statusId;
        data["orderSourceId"] = this.orderSourceId;
        return data; 
    }
}

export interface IOrderInfoDto {
    statusId: number | undefined;
    orderSourceId: number | undefined;
}

export class ClinicPackages implements IClinicPackages {
    id!: number;
    name!: string | undefined;
    quantity!: number;

    constructor(data?: IClinicPackages) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): ClinicPackages {
        data = typeof data === 'object' ? data : {};
        let result = new ClinicPackages();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface IClinicPackages {
    id: number;
    name: string | undefined;
    quantity: number;
}

export class LabInfo implements ILabInfo {
    clinicCode!: string | undefined;
    clinicName!: string | undefined;
    packages!: ClinicPackages[] | undefined;

    constructor(data?: ILabInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicCode = data["clinicCode"];
            this.clinicName = data["clinicName"];
            if (Array.isArray(data["packages"])) {
                this.packages = [] as any;
                for (let item of data["packages"])
                    this.packages!.push(ClinicPackages.fromJS(item));
            }
        }
    }

    static fromJS(data: any): LabInfo {
        data = typeof data === 'object' ? data : {};
        let result = new LabInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicCode"] = this.clinicCode;
        data["clinicName"] = this.clinicName;
        if (Array.isArray(this.packages)) {
            data["packages"] = [];
            for (let item of this.packages)
                data["packages"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ILabInfo {
    clinicCode: string | undefined;
    clinicName: string | undefined;
    packages: ClinicPackages[] | undefined;
}

export class GetOrderByIdAndTimeZoneInput implements IGetOrderByIdAndTimeZoneInput {
    orderId!: number | undefined;
    trackingIdentifier!: string | undefined;
    timeZoneInfo!: string | undefined;
    orderNumber!: string | undefined;
    deliveryDateFrom!: moment.Moment | undefined;
    deliveryDateTo!: moment.Moment | undefined;
    locationCode!: string[] | undefined;
    orderSourceCode!: string | undefined;

    constructor(data?: IGetOrderByIdAndTimeZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.trackingIdentifier = data["trackingIdentifier"];
            this.timeZoneInfo = data["timeZoneInfo"];
            this.orderNumber = data["orderNumber"];
            this.deliveryDateFrom = data["deliveryDateFrom"] ? moment(data["deliveryDateFrom"].toString()) : <any>undefined;
            this.deliveryDateTo = data["deliveryDateTo"] ? moment(data["deliveryDateTo"].toString()) : <any>undefined;
            if (Array.isArray(data["locationCode"])) {
                this.locationCode = [] as any;
                for (let item of data["locationCode"])
                    this.locationCode!.push(item);
            }
            this.orderSourceCode = data["orderSourceCode"];
        }
    }

    static fromJS(data: any): GetOrderByIdAndTimeZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderByIdAndTimeZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["trackingIdentifier"] = this.trackingIdentifier;
        data["timeZoneInfo"] = this.timeZoneInfo;
        data["orderNumber"] = this.orderNumber;
        data["deliveryDateFrom"] = this.deliveryDateFrom ? this.deliveryDateFrom.toISOString() : <any>undefined;
        data["deliveryDateTo"] = this.deliveryDateTo ? this.deliveryDateTo.toISOString() : <any>undefined;
        if (Array.isArray(this.locationCode)) {
            data["locationCode"] = [];
            for (let item of this.locationCode)
                data["locationCode"].push(item);
        }
        data["orderSourceCode"] = this.orderSourceCode;
        return data; 
    }
}

export interface IGetOrderByIdAndTimeZoneInput {
    orderId: number | undefined;
    trackingIdentifier: string | undefined;
    timeZoneInfo: string | undefined;
    orderNumber: string | undefined;
    deliveryDateFrom: moment.Moment | undefined;
    deliveryDateTo: moment.Moment | undefined;
    locationCode: string[] | undefined;
    orderSourceCode: string | undefined;
}

export class OrderNotificationTemplateDto implements IOrderNotificationTemplateDto {
    isActive!: boolean;
    description!: string | undefined;
    template!: string | undefined;
    code!: string | undefined;
    id!: number;

    constructor(data?: IOrderNotificationTemplateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.template = data["template"];
            this.code = data["code"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderNotificationTemplateDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNotificationTemplateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["template"] = this.template;
        data["code"] = this.code;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderNotificationTemplateDto {
    isActive: boolean;
    description: string | undefined;
    template: string | undefined;
    code: string | undefined;
    id: number;
}

export class GetOrderNotificationTemplateForViewDto implements IGetOrderNotificationTemplateForViewDto {
    orderNotificationTemplate!: OrderNotificationTemplateDto | undefined;

    constructor(data?: IGetOrderNotificationTemplateForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderNotificationTemplate = data["orderNotificationTemplate"] ? OrderNotificationTemplateDto.fromJS(data["orderNotificationTemplate"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderNotificationTemplateForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderNotificationTemplateForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderNotificationTemplate"] = this.orderNotificationTemplate ? this.orderNotificationTemplate.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderNotificationTemplateForViewDto {
    orderNotificationTemplate: OrderNotificationTemplateDto | undefined;
}

export class PagedResultDtoOfGetOrderNotificationTemplateForViewDto implements IPagedResultDtoOfGetOrderNotificationTemplateForViewDto {
    totalCount!: number;
    items!: GetOrderNotificationTemplateForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderNotificationTemplateForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderNotificationTemplateForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderNotificationTemplateForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderNotificationTemplateForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderNotificationTemplateForViewDto {
    totalCount: number;
    items: GetOrderNotificationTemplateForViewDto[] | undefined;
}

export class CreateOrEditOrderNotificationTemplateDto implements ICreateOrEditOrderNotificationTemplateDto {
    isActive!: boolean;
    description!: string | undefined;
    template!: string | undefined;
    code!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrderNotificationTemplateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.template = data["template"];
            this.code = data["code"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrderNotificationTemplateDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrderNotificationTemplateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["template"] = this.template;
        data["code"] = this.code;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrderNotificationTemplateDto {
    isActive: boolean;
    description: string | undefined;
    template: string | undefined;
    code: string | undefined;
    id: number | undefined;
}

export class GetOrderNotificationTemplateForEditOutput implements IGetOrderNotificationTemplateForEditOutput {
    orderNotificationTemplate!: CreateOrEditOrderNotificationTemplateDto | undefined;

    constructor(data?: IGetOrderNotificationTemplateForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderNotificationTemplate = data["orderNotificationTemplate"] ? CreateOrEditOrderNotificationTemplateDto.fromJS(data["orderNotificationTemplate"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderNotificationTemplateForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderNotificationTemplateForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderNotificationTemplate"] = this.orderNotificationTemplate ? this.orderNotificationTemplate.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderNotificationTemplateForEditOutput {
    orderNotificationTemplate: CreateOrEditOrderNotificationTemplateDto | undefined;
}

export class PagedResultDtoOfOrderPackageListDto implements IPagedResultDtoOfOrderPackageListDto {
    totalCount!: number;
    items!: OrderPackageListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderPackageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderPackageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderPackageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderPackageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderPackageListDto {
    totalCount: number;
    items: OrderPackageListDto[] | undefined;
}

export class CreateOrderPackageInput implements ICreateOrderPackageInput {
    orderId!: number;
    packageId!: number;
    quantity!: number;

    constructor(data?: ICreateOrderPackageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.packageId = data["packageId"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): CreateOrderPackageInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderPackageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["packageId"] = this.packageId;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface ICreateOrderPackageInput {
    orderId: number;
    packageId: number;
    quantity: number;
}

export class UpdateOrderPackageInput implements IUpdateOrderPackageInput {
    id!: number;
    orderId!: number;
    packageId!: number;
    quantity!: number;

    constructor(data?: IUpdateOrderPackageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.orderId = data["orderId"];
            this.packageId = data["packageId"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): UpdateOrderPackageInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderPackageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["orderId"] = this.orderId;
        data["packageId"] = this.packageId;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface IUpdateOrderPackageInput {
    id: number;
    orderId: number;
    packageId: number;
    quantity: number;
}

export class PackageDto implements IPackageDto {
    name!: string | undefined;
    code!: string | undefined;
    price!: number;
    color!: string | undefined;
    sku!: string | undefined;
    description!: string | undefined;
    id!: number;

    constructor(data?: IPackageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.price = data["price"];
            this.color = data["color"];
            this.sku = data["sku"];
            this.description = data["description"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PackageDto {
        data = typeof data === 'object' ? data : {};
        let result = new PackageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["price"] = this.price;
        data["color"] = this.color;
        data["sku"] = this.sku;
        data["description"] = this.description;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPackageDto {
    name: string | undefined;
    code: string | undefined;
    price: number;
    color: string | undefined;
    sku: string | undefined;
    description: string | undefined;
    id: number;
}

export class OrderPackageDto implements IOrderPackageDto {
    orderId!: number;
    packageId!: number;
    package!: PackageDto | undefined;
    quantity!: number;
    createdDate!: moment.Moment;
    lastModifiedDate!: moment.Moment | undefined;
    creator!: string | undefined;
    lastModifiedUser!: string | undefined;
    id!: number;

    constructor(data?: IOrderPackageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.packageId = data["packageId"];
            this.package = data["package"] ? PackageDto.fromJS(data["package"]) : <any>undefined;
            this.quantity = data["quantity"];
            this.createdDate = data["createdDate"] ? moment(data["createdDate"].toString()) : <any>undefined;
            this.lastModifiedDate = data["lastModifiedDate"] ? moment(data["lastModifiedDate"].toString()) : <any>undefined;
            this.creator = data["creator"];
            this.lastModifiedUser = data["lastModifiedUser"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderPackageDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderPackageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["packageId"] = this.packageId;
        data["package"] = this.package ? this.package.toJSON() : <any>undefined;
        data["quantity"] = this.quantity;
        data["createdDate"] = this.createdDate ? this.createdDate.toISOString() : <any>undefined;
        data["lastModifiedDate"] = this.lastModifiedDate ? this.lastModifiedDate.toISOString() : <any>undefined;
        data["creator"] = this.creator;
        data["lastModifiedUser"] = this.lastModifiedUser;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderPackageDto {
    orderId: number;
    packageId: number;
    package: PackageDto | undefined;
    quantity: number;
    createdDate: moment.Moment;
    lastModifiedDate: moment.Moment | undefined;
    creator: string | undefined;
    lastModifiedUser: string | undefined;
    id: number;
}

export class PagedResultDtoOfOrderPackageDto implements IPagedResultDtoOfOrderPackageDto {
    totalCount!: number;
    items!: OrderPackageDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderPackageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderPackageDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderPackageDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderPackageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderPackageDto {
    totalCount: number;
    items: OrderPackageDto[] | undefined;
}

export class GetOrderPackageForViewDto implements IGetOrderPackageForViewDto {
    orderPackage!: OrderPackageDto | undefined;

    constructor(data?: IGetOrderPackageForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderPackage = data["orderPackage"] ? OrderPackageDto.fromJS(data["orderPackage"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderPackageForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderPackageForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderPackage"] = this.orderPackage ? this.orderPackage.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderPackageForViewDto {
    orderPackage: OrderPackageDto | undefined;
}

export class CreateOrEditOrderPackageDto implements ICreateOrEditOrderPackageDto {
    orderId!: number;
    packageId!: number;
    quantity!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrderPackageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.packageId = data["packageId"];
            this.quantity = data["quantity"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrderPackageDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrderPackageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["packageId"] = this.packageId;
        data["quantity"] = this.quantity;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrderPackageDto {
    orderId: number;
    packageId: number;
    quantity: number;
    id: number | undefined;
}

export class GetOrderPackageForEditOutput implements IGetOrderPackageForEditOutput {
    orderPackage!: CreateOrEditOrderPackageDto | undefined;

    constructor(data?: IGetOrderPackageForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderPackage = data["orderPackage"] ? CreateOrEditOrderPackageDto.fromJS(data["orderPackage"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderPackageForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderPackageForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderPackage"] = this.orderPackage ? this.orderPackage.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderPackageForEditOutput {
    orderPackage: CreateOrEditOrderPackageDto | undefined;
}

export enum ConnectionType {
    FTPS = 0,
    API = 1,
    FTP = 2,
}

export class ConnectionDto implements IConnectionDto {
    name!: string | undefined;
    username!: string | undefined;
    password!: string | undefined;
    isActive!: boolean;
    host!: string | undefined;
    port!: number | undefined;
    folder!: string | undefined;
    id!: number | undefined;

    constructor(data?: IConnectionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.username = data["username"];
            this.password = data["password"];
            this.isActive = data["isActive"];
            this.host = data["host"];
            this.port = data["port"];
            this.folder = data["folder"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ConnectionDto {
        data = typeof data === 'object' ? data : {};
        let result = new ConnectionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["username"] = this.username;
        data["password"] = this.password;
        data["isActive"] = this.isActive;
        data["host"] = this.host;
        data["port"] = this.port;
        data["folder"] = this.folder;
        data["id"] = this.id;
        return data; 
    }
}

export interface IConnectionDto {
    name: string | undefined;
    username: string | undefined;
    password: string | undefined;
    isActive: boolean;
    host: string | undefined;
    port: number | undefined;
    folder: string | undefined;
    id: number | undefined;
}

export class OrderSourceConnectionDto implements IOrderSourceConnectionDto {
    orderSourceId!: number | undefined;
    connectionType!: ConnectionType;
    connectionId!: number | undefined;
    connection!: ConnectionDto | undefined;
    id!: number;

    constructor(data?: IOrderSourceConnectionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderSourceId = data["orderSourceId"];
            this.connectionType = data["connectionType"];
            this.connectionId = data["connectionId"];
            this.connection = data["connection"] ? ConnectionDto.fromJS(data["connection"]) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderSourceConnectionDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderSourceConnectionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderSourceId"] = this.orderSourceId;
        data["connectionType"] = this.connectionType;
        data["connectionId"] = this.connectionId;
        data["connection"] = this.connection ? this.connection.toJSON() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderSourceConnectionDto {
    orderSourceId: number | undefined;
    connectionType: ConnectionType;
    connectionId: number | undefined;
    connection: ConnectionDto | undefined;
    id: number;
}

export class GetOrderSourceConnectionForViewDto implements IGetOrderSourceConnectionForViewDto {
    orderSourceConnection!: OrderSourceConnectionDto | undefined;

    constructor(data?: IGetOrderSourceConnectionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderSourceConnection = data["orderSourceConnection"] ? OrderSourceConnectionDto.fromJS(data["orderSourceConnection"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderSourceConnectionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderSourceConnectionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderSourceConnection"] = this.orderSourceConnection ? this.orderSourceConnection.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderSourceConnectionForViewDto {
    orderSourceConnection: OrderSourceConnectionDto | undefined;
}

export class PagedResultDtoOfGetOrderSourceConnectionForViewDto implements IPagedResultDtoOfGetOrderSourceConnectionForViewDto {
    totalCount!: number;
    items!: GetOrderSourceConnectionForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderSourceConnectionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderSourceConnectionForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderSourceConnectionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderSourceConnectionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderSourceConnectionForViewDto {
    totalCount: number;
    items: GetOrderSourceConnectionForViewDto[] | undefined;
}

export class CreateOrEditOrderSourceConnectionDto implements ICreateOrEditOrderSourceConnectionDto {
    orderSourceId!: number;
    connectionType!: ConnectionType;
    connection!: ConnectionDto | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrderSourceConnectionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderSourceId = data["orderSourceId"];
            this.connectionType = data["connectionType"];
            this.connection = data["connection"] ? ConnectionDto.fromJS(data["connection"]) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrderSourceConnectionDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrderSourceConnectionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderSourceId"] = this.orderSourceId;
        data["connectionType"] = this.connectionType;
        data["connection"] = this.connection ? this.connection.toJSON() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrderSourceConnectionDto {
    orderSourceId: number;
    connectionType: ConnectionType;
    connection: ConnectionDto | undefined;
    id: number | undefined;
}

export class GetOrderSourceConnectionForEditOutput implements IGetOrderSourceConnectionForEditOutput {
    orderSourceConnection!: CreateOrEditOrderSourceConnectionDto | undefined;

    constructor(data?: IGetOrderSourceConnectionForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderSourceConnection = data["orderSourceConnection"] ? CreateOrEditOrderSourceConnectionDto.fromJS(data["orderSourceConnection"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderSourceConnectionForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderSourceConnectionForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderSourceConnection"] = this.orderSourceConnection ? this.orderSourceConnection.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderSourceConnectionForEditOutput {
    orderSourceConnection: CreateOrEditOrderSourceConnectionDto | undefined;
}

export class OrderImportDto implements IOrderImportDto {
    quantity!: number | undefined;
    packageName!: string | undefined;
    price!: number | undefined;
    tagCode!: string | undefined;
    packageCode!: string | undefined;
    tagName!: string | undefined;
    exception!: string | undefined;
    locationId!: number | undefined;
    tenantId!: number | undefined;
    userId!: number | undefined;
    tags!: TagInputApi[] | undefined;
    trackingIdentifier!: string | undefined;
    note!: string | undefined;
    packages!: PackageInputApi[] | undefined;
    destinationEtaStart!: moment.Moment;
    destinationEtaEnd!: moment.Moment;
    destinationContactId!: number | undefined;
    destinationFirstName!: string | undefined;
    destinationLastName!: string | undefined;
    destinationEmail!: string | undefined;
    destinationPhone!: string | undefined;
    destinationAddressLine1!: string | undefined;
    destinationAddressLine2!: string | undefined;
    destinationPostalCodeId!: number | undefined;
    destinationPostalCode!: string | undefined;
    destinationCountry!: string | undefined;
    destinationCity!: string | undefined;
    destinationState!: string | undefined;
    destinationGeocodeId!: number | undefined;
    destinationLat!: number | undefined;
    destinationLng!: number | undefined;
    destinationAddressTypeId!: number | undefined;
    pickUpEtaStart!: moment.Moment;
    pickUpEtaEnd!: moment.Moment;
    pickUpContactId!: number | undefined;
    pickUpFirstName!: string | undefined;
    pickUpLastName!: string | undefined;
    pickUpEmail!: string | undefined;
    pickUpPhone!: string | undefined;
    pickUpAddressLine1!: string | undefined;
    pickUpAddressLine2!: string | undefined;
    pickUpPostalCodeId!: number | undefined;
    pickUpPostalCode!: string | undefined;
    pickUpCountry!: string | undefined;
    pickUpCity!: string | undefined;
    pickUpState!: string | undefined;
    pickUpGeocodeId!: number | undefined;
    pickUpLat!: number | undefined;
    pickUpLng!: number | undefined;
    pickUpAddressTypeId!: number | undefined;
    orderSourceId!: number | undefined;
    orderSourceCode!: string | undefined;
    isDownloadOrder!: boolean;
    isRecurring!: boolean;
    recurringScheduleCode!: string | undefined;
    orderStatusCode!: string | undefined;
    zipRegex!: string | undefined;
    driverFirstName!: string | undefined;
    driverLastName!: string | undefined;
    driverUserName!: string | undefined;

    constructor(data?: IOrderImportDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.quantity = data["quantity"];
            this.packageName = data["packageName"];
            this.price = data["price"];
            this.tagCode = data["tagCode"];
            this.packageCode = data["packageCode"];
            this.tagName = data["tagName"];
            this.exception = data["exception"];
            this.locationId = data["locationId"];
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            if (Array.isArray(data["tags"])) {
                this.tags = [] as any;
                for (let item of data["tags"])
                    this.tags!.push(TagInputApi.fromJS(item));
            }
            this.trackingIdentifier = data["trackingIdentifier"];
            this.note = data["note"];
            if (Array.isArray(data["packages"])) {
                this.packages = [] as any;
                for (let item of data["packages"])
                    this.packages!.push(PackageInputApi.fromJS(item));
            }
            this.destinationEtaStart = data["destinationEtaStart"] ? moment(data["destinationEtaStart"].toString()) : <any>undefined;
            this.destinationEtaEnd = data["destinationEtaEnd"] ? moment(data["destinationEtaEnd"].toString()) : <any>undefined;
            this.destinationContactId = data["destinationContactId"];
            this.destinationFirstName = data["destinationFirstName"];
            this.destinationLastName = data["destinationLastName"];
            this.destinationEmail = data["destinationEmail"];
            this.destinationPhone = data["destinationPhone"];
            this.destinationAddressLine1 = data["destinationAddressLine1"];
            this.destinationAddressLine2 = data["destinationAddressLine2"];
            this.destinationPostalCodeId = data["destinationPostalCodeId"];
            this.destinationPostalCode = data["destinationPostalCode"];
            this.destinationCountry = data["destinationCountry"];
            this.destinationCity = data["destinationCity"];
            this.destinationState = data["destinationState"];
            this.destinationGeocodeId = data["destinationGeocodeId"];
            this.destinationLat = data["destinationLat"];
            this.destinationLng = data["destinationLng"];
            this.destinationAddressTypeId = data["destinationAddressTypeId"];
            this.pickUpEtaStart = data["pickUpEtaStart"] ? moment(data["pickUpEtaStart"].toString()) : <any>undefined;
            this.pickUpEtaEnd = data["pickUpEtaEnd"] ? moment(data["pickUpEtaEnd"].toString()) : <any>undefined;
            this.pickUpContactId = data["pickUpContactId"];
            this.pickUpFirstName = data["pickUpFirstName"];
            this.pickUpLastName = data["pickUpLastName"];
            this.pickUpEmail = data["pickUpEmail"];
            this.pickUpPhone = data["pickUpPhone"];
            this.pickUpAddressLine1 = data["pickUpAddressLine1"];
            this.pickUpAddressLine2 = data["pickUpAddressLine2"];
            this.pickUpPostalCodeId = data["pickUpPostalCodeId"];
            this.pickUpPostalCode = data["pickUpPostalCode"];
            this.pickUpCountry = data["pickUpCountry"];
            this.pickUpCity = data["pickUpCity"];
            this.pickUpState = data["pickUpState"];
            this.pickUpGeocodeId = data["pickUpGeocodeId"];
            this.pickUpLat = data["pickUpLat"];
            this.pickUpLng = data["pickUpLng"];
            this.pickUpAddressTypeId = data["pickUpAddressTypeId"];
            this.orderSourceId = data["orderSourceId"];
            this.orderSourceCode = data["orderSourceCode"];
            this.isDownloadOrder = data["isDownloadOrder"];
            this.isRecurring = data["isRecurring"];
            this.recurringScheduleCode = data["recurringScheduleCode"];
            this.orderStatusCode = data["orderStatusCode"];
            this.zipRegex = data["zipRegex"];
            this.driverFirstName = data["driverFirstName"];
            this.driverLastName = data["driverLastName"];
            this.driverUserName = data["driverUserName"];
        }
    }

    static fromJS(data: any): OrderImportDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderImportDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["quantity"] = this.quantity;
        data["packageName"] = this.packageName;
        data["price"] = this.price;
        data["tagCode"] = this.tagCode;
        data["packageCode"] = this.packageCode;
        data["tagName"] = this.tagName;
        data["exception"] = this.exception;
        data["locationId"] = this.locationId;
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        if (Array.isArray(this.tags)) {
            data["tags"] = [];
            for (let item of this.tags)
                data["tags"].push(item.toJSON());
        }
        data["trackingIdentifier"] = this.trackingIdentifier;
        data["note"] = this.note;
        if (Array.isArray(this.packages)) {
            data["packages"] = [];
            for (let item of this.packages)
                data["packages"].push(item.toJSON());
        }
        data["destinationEtaStart"] = this.destinationEtaStart ? this.destinationEtaStart.toISOString() : <any>undefined;
        data["destinationEtaEnd"] = this.destinationEtaEnd ? this.destinationEtaEnd.toISOString() : <any>undefined;
        data["destinationContactId"] = this.destinationContactId;
        data["destinationFirstName"] = this.destinationFirstName;
        data["destinationLastName"] = this.destinationLastName;
        data["destinationEmail"] = this.destinationEmail;
        data["destinationPhone"] = this.destinationPhone;
        data["destinationAddressLine1"] = this.destinationAddressLine1;
        data["destinationAddressLine2"] = this.destinationAddressLine2;
        data["destinationPostalCodeId"] = this.destinationPostalCodeId;
        data["destinationPostalCode"] = this.destinationPostalCode;
        data["destinationCountry"] = this.destinationCountry;
        data["destinationCity"] = this.destinationCity;
        data["destinationState"] = this.destinationState;
        data["destinationGeocodeId"] = this.destinationGeocodeId;
        data["destinationLat"] = this.destinationLat;
        data["destinationLng"] = this.destinationLng;
        data["destinationAddressTypeId"] = this.destinationAddressTypeId;
        data["pickUpEtaStart"] = this.pickUpEtaStart ? this.pickUpEtaStart.toISOString() : <any>undefined;
        data["pickUpEtaEnd"] = this.pickUpEtaEnd ? this.pickUpEtaEnd.toISOString() : <any>undefined;
        data["pickUpContactId"] = this.pickUpContactId;
        data["pickUpFirstName"] = this.pickUpFirstName;
        data["pickUpLastName"] = this.pickUpLastName;
        data["pickUpEmail"] = this.pickUpEmail;
        data["pickUpPhone"] = this.pickUpPhone;
        data["pickUpAddressLine1"] = this.pickUpAddressLine1;
        data["pickUpAddressLine2"] = this.pickUpAddressLine2;
        data["pickUpPostalCodeId"] = this.pickUpPostalCodeId;
        data["pickUpPostalCode"] = this.pickUpPostalCode;
        data["pickUpCountry"] = this.pickUpCountry;
        data["pickUpCity"] = this.pickUpCity;
        data["pickUpState"] = this.pickUpState;
        data["pickUpGeocodeId"] = this.pickUpGeocodeId;
        data["pickUpLat"] = this.pickUpLat;
        data["pickUpLng"] = this.pickUpLng;
        data["pickUpAddressTypeId"] = this.pickUpAddressTypeId;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSourceCode"] = this.orderSourceCode;
        data["isDownloadOrder"] = this.isDownloadOrder;
        data["isRecurring"] = this.isRecurring;
        data["recurringScheduleCode"] = this.recurringScheduleCode;
        data["orderStatusCode"] = this.orderStatusCode;
        data["zipRegex"] = this.zipRegex;
        data["driverFirstName"] = this.driverFirstName;
        data["driverLastName"] = this.driverLastName;
        data["driverUserName"] = this.driverUserName;
        return data; 
    }
}

export interface IOrderImportDto {
    quantity: number | undefined;
    packageName: string | undefined;
    price: number | undefined;
    tagCode: string | undefined;
    packageCode: string | undefined;
    tagName: string | undefined;
    exception: string | undefined;
    locationId: number | undefined;
    tenantId: number | undefined;
    userId: number | undefined;
    tags: TagInputApi[] | undefined;
    trackingIdentifier: string | undefined;
    note: string | undefined;
    packages: PackageInputApi[] | undefined;
    destinationEtaStart: moment.Moment;
    destinationEtaEnd: moment.Moment;
    destinationContactId: number | undefined;
    destinationFirstName: string | undefined;
    destinationLastName: string | undefined;
    destinationEmail: string | undefined;
    destinationPhone: string | undefined;
    destinationAddressLine1: string | undefined;
    destinationAddressLine2: string | undefined;
    destinationPostalCodeId: number | undefined;
    destinationPostalCode: string | undefined;
    destinationCountry: string | undefined;
    destinationCity: string | undefined;
    destinationState: string | undefined;
    destinationGeocodeId: number | undefined;
    destinationLat: number | undefined;
    destinationLng: number | undefined;
    destinationAddressTypeId: number | undefined;
    pickUpEtaStart: moment.Moment;
    pickUpEtaEnd: moment.Moment;
    pickUpContactId: number | undefined;
    pickUpFirstName: string | undefined;
    pickUpLastName: string | undefined;
    pickUpEmail: string | undefined;
    pickUpPhone: string | undefined;
    pickUpAddressLine1: string | undefined;
    pickUpAddressLine2: string | undefined;
    pickUpPostalCodeId: number | undefined;
    pickUpPostalCode: string | undefined;
    pickUpCountry: string | undefined;
    pickUpCity: string | undefined;
    pickUpState: string | undefined;
    pickUpGeocodeId: number | undefined;
    pickUpLat: number | undefined;
    pickUpLng: number | undefined;
    pickUpAddressTypeId: number | undefined;
    orderSourceId: number | undefined;
    orderSourceCode: string | undefined;
    isDownloadOrder: boolean;
    isRecurring: boolean;
    recurringScheduleCode: string | undefined;
    orderStatusCode: string | undefined;
    zipRegex: string | undefined;
    driverFirstName: string | undefined;
    driverLastName: string | undefined;
    driverUserName: string | undefined;
}

export class LocationCountSuccess implements ILocationCountSuccess {
    locationId!: number;
    count!: number;
    tenantId!: number | undefined;
    name!: string | undefined;
    deliveryDates!: moment.Moment[] | undefined;
    pickUpDates!: moment.Moment[] | undefined;

    constructor(data?: ILocationCountSuccess) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.count = data["count"];
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            if (Array.isArray(data["deliveryDates"])) {
                this.deliveryDates = [] as any;
                for (let item of data["deliveryDates"])
                    this.deliveryDates!.push(moment(item));
            }
            if (Array.isArray(data["pickUpDates"])) {
                this.pickUpDates = [] as any;
                for (let item of data["pickUpDates"])
                    this.pickUpDates!.push(moment(item));
            }
        }
    }

    static fromJS(data: any): LocationCountSuccess {
        data = typeof data === 'object' ? data : {};
        let result = new LocationCountSuccess();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["count"] = this.count;
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        if (Array.isArray(this.deliveryDates)) {
            data["deliveryDates"] = [];
            for (let item of this.deliveryDates)
                data["deliveryDates"].push(item.toISOString());
        }
        if (Array.isArray(this.pickUpDates)) {
            data["pickUpDates"] = [];
            for (let item of this.pickUpDates)
                data["pickUpDates"].push(item.toISOString());
        }
        return data; 
    }
}

export interface ILocationCountSuccess {
    locationId: number;
    count: number;
    tenantId: number | undefined;
    name: string | undefined;
    deliveryDates: moment.Moment[] | undefined;
    pickUpDates: moment.Moment[] | undefined;
}

export class GetOrderSourceForViewDto implements IGetOrderSourceForViewDto {
    orderSource!: OrderSourceDto | undefined;

    constructor(data?: IGetOrderSourceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderSource = data["orderSource"] ? OrderSourceDto.fromJS(data["orderSource"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderSourceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderSourceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderSource"] = this.orderSource ? this.orderSource.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderSourceForViewDto {
    orderSource: OrderSourceDto | undefined;
}

export class PagedResultDtoOfGetOrderSourceForViewDto implements IPagedResultDtoOfGetOrderSourceForViewDto {
    totalCount!: number;
    items!: GetOrderSourceForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderSourceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderSourceForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderSourceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderSourceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderSourceForViewDto {
    totalCount: number;
    items: GetOrderSourceForViewDto[] | undefined;
}

export class CreateOrEditOrderSourceDto implements ICreateOrEditOrderSourceDto {
    name!: string;
    code!: string;
    isActive!: number;
    isHeaderFixed!: number;
    tenantId!: number;
    orderTypeId!: number;
    orderSourceConnectionId!: number | undefined;
    connectionType!: ConnectionType;
    connection!: ConnectionDto | undefined;
    zipRegEx!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrderSourceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.isActive = data["isActive"];
            this.isHeaderFixed = data["isHeaderFixed"];
            this.tenantId = data["tenantId"];
            this.orderTypeId = data["orderTypeId"];
            this.orderSourceConnectionId = data["orderSourceConnectionId"];
            this.connectionType = data["connectionType"];
            this.connection = data["connection"] ? ConnectionDto.fromJS(data["connection"]) : <any>undefined;
            this.zipRegEx = data["zipRegEx"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrderSourceDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrderSourceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["isActive"] = this.isActive;
        data["isHeaderFixed"] = this.isHeaderFixed;
        data["tenantId"] = this.tenantId;
        data["orderTypeId"] = this.orderTypeId;
        data["orderSourceConnectionId"] = this.orderSourceConnectionId;
        data["connectionType"] = this.connectionType;
        data["connection"] = this.connection ? this.connection.toJSON() : <any>undefined;
        data["zipRegEx"] = this.zipRegEx;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrderSourceDto {
    name: string;
    code: string;
    isActive: number;
    isHeaderFixed: number;
    tenantId: number;
    orderTypeId: number;
    orderSourceConnectionId: number | undefined;
    connectionType: ConnectionType;
    connection: ConnectionDto | undefined;
    zipRegEx: string | undefined;
    id: number | undefined;
}

export class GetOrderSourceForEditOutput implements IGetOrderSourceForEditOutput {
    orderSource!: CreateOrEditOrderSourceDto | undefined;

    constructor(data?: IGetOrderSourceForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderSource = data["orderSource"] ? CreateOrEditOrderSourceDto.fromJS(data["orderSource"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderSourceForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderSourceForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderSource"] = this.orderSource ? this.orderSource.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderSourceForEditOutput {
    orderSource: CreateOrEditOrderSourceDto | undefined;
}

export class PagedResultDtoOfOrderStatusListDto implements IPagedResultDtoOfOrderStatusListDto {
    totalCount!: number;
    items!: OrderStatusListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderStatusListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderStatusListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderStatusListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderStatusListDto {
    totalCount: number;
    items: OrderStatusListDto[] | undefined;
}

export class UpdateOrderStatusInput implements IUpdateOrderStatusInput {
    id!: number;
    userId!: number;
    orderId!: number;
    geocodeId!: number;
    orderStatusTypeId!: number;
    noteId!: number | undefined;

    constructor(data?: IUpdateOrderStatusInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.userId = data["userId"];
            this.orderId = data["orderId"];
            this.geocodeId = data["geocodeId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.noteId = data["noteId"];
        }
    }

    static fromJS(data: any): UpdateOrderStatusInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderStatusInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["userId"] = this.userId;
        data["orderId"] = this.orderId;
        data["geocodeId"] = this.geocodeId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["noteId"] = this.noteId;
        return data; 
    }
}

export interface IUpdateOrderStatusInput {
    id: number;
    userId: number;
    orderId: number;
    geocodeId: number;
    orderStatusTypeId: number;
    noteId: number | undefined;
}

export class UpdateStatusOrderInput implements IUpdateStatusOrderInput {
    orderId!: number;

    constructor(data?: IUpdateStatusOrderInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): UpdateStatusOrderInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateStatusOrderInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface IUpdateStatusOrderInput {
    orderId: number;
}

export class OrderAttachmentImageDto implements IOrderAttachmentImageDto {
    pictureString!: string | undefined;

    constructor(data?: IOrderAttachmentImageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.pictureString = data["pictureString"];
        }
    }

    static fromJS(data: any): OrderAttachmentImageDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderAttachmentImageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["pictureString"] = this.pictureString;
        return data; 
    }
}

export interface IOrderAttachmentImageDto {
    pictureString: string | undefined;
}

export class OrderStatusAttachmentListDto implements IOrderStatusAttachmentListDto {
    orderId!: number;
    binaryObjectId!: string;
    fileName!: string | undefined;
    orderAttachment!: OrderAttachmentImageDto | undefined;
    deviceTime!: moment.Moment;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderStatusAttachmentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.binaryObjectId = data["binaryObjectId"];
            this.fileName = data["fileName"];
            this.orderAttachment = data["orderAttachment"] ? OrderAttachmentImageDto.fromJS(data["orderAttachment"]) : <any>undefined;
            this.deviceTime = data["deviceTime"] ? moment(data["deviceTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatusAttachmentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusAttachmentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["binaryObjectId"] = this.binaryObjectId;
        data["fileName"] = this.fileName;
        data["orderAttachment"] = this.orderAttachment ? this.orderAttachment.toJSON() : <any>undefined;
        data["deviceTime"] = this.deviceTime ? this.deviceTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatusAttachmentListDto {
    orderId: number;
    binaryObjectId: string;
    fileName: string | undefined;
    orderAttachment: OrderAttachmentImageDto | undefined;
    deviceTime: moment.Moment;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ListResultDtoOfOrderStatusAttachmentListDto implements IListResultDtoOfOrderStatusAttachmentListDto {
    items!: OrderStatusAttachmentListDto[] | undefined;

    constructor(data?: IListResultDtoOfOrderStatusAttachmentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusAttachmentListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfOrderStatusAttachmentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfOrderStatusAttachmentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfOrderStatusAttachmentListDto {
    items: OrderStatusAttachmentListDto[] | undefined;
}

export class CreateOrderStatusAttachmentInput implements ICreateOrderStatusAttachmentInput {
    orderId!: number;
    binaryObjectId!: string;
    fileName!: string | undefined;

    constructor(data?: ICreateOrderStatusAttachmentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.binaryObjectId = data["binaryObjectId"];
            this.fileName = data["fileName"];
        }
    }

    static fromJS(data: any): CreateOrderStatusAttachmentInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderStatusAttachmentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["binaryObjectId"] = this.binaryObjectId;
        data["fileName"] = this.fileName;
        return data; 
    }
}

export interface ICreateOrderStatusAttachmentInput {
    orderId: number;
    binaryObjectId: string;
    fileName: string | undefined;
}

export class UpdateOrderStatusAttachmentInput implements IUpdateOrderStatusAttachmentInput {
    id!: number;
    orderId!: number;
    binaryObjectId!: string;
    fileName!: string | undefined;

    constructor(data?: IUpdateOrderStatusAttachmentInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.orderId = data["orderId"];
            this.binaryObjectId = data["binaryObjectId"];
            this.fileName = data["fileName"];
        }
    }

    static fromJS(data: any): UpdateOrderStatusAttachmentInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderStatusAttachmentInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["orderId"] = this.orderId;
        data["binaryObjectId"] = this.binaryObjectId;
        data["fileName"] = this.fileName;
        return data; 
    }
}

export interface IUpdateOrderStatusAttachmentInput {
    id: number;
    orderId: number;
    binaryObjectId: string;
    fileName: string | undefined;
}

export class OrderStatusPhotoListItemDto implements IOrderStatusPhotoListItemDto {
    id!: number;
    orderId!: number;
    fileName!: string | undefined;
    deviceTime!: moment.Moment;
    content!: string | undefined;

    constructor(data?: IOrderStatusPhotoListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.orderId = data["orderId"];
            this.fileName = data["fileName"];
            this.deviceTime = data["deviceTime"] ? moment(data["deviceTime"].toString()) : <any>undefined;
            this.content = data["content"];
        }
    }

    static fromJS(data: any): OrderStatusPhotoListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusPhotoListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["orderId"] = this.orderId;
        data["fileName"] = this.fileName;
        data["deviceTime"] = this.deviceTime ? this.deviceTime.toISOString() : <any>undefined;
        data["content"] = this.content;
        return data; 
    }
}

export interface IOrderStatusPhotoListItemDto {
    id: number;
    orderId: number;
    fileName: string | undefined;
    deviceTime: moment.Moment;
    content: string | undefined;
}

export class ListResultDtoOfOrderStatusPhotoListItemDto implements IListResultDtoOfOrderStatusPhotoListItemDto {
    items!: OrderStatusPhotoListItemDto[] | undefined;

    constructor(data?: IListResultDtoOfOrderStatusPhotoListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusPhotoListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfOrderStatusPhotoListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfOrderStatusPhotoListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfOrderStatusPhotoListItemDto {
    items: OrderStatusPhotoListItemDto[] | undefined;
}

export class ImageLinkItemDto implements IImageLinkItemDto {
    fileName!: string | undefined;
    content!: string | undefined;

    constructor(data?: IImageLinkItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.content = data["content"];
        }
    }

    static fromJS(data: any): ImageLinkItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ImageLinkItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["content"] = this.content;
        return data; 
    }
}

export interface IImageLinkItemDto {
    fileName: string | undefined;
    content: string | undefined;
}

export class OrderStatusPagedListDto implements IOrderStatusPagedListDto {
    id!: number;
    orderId!: number;
    statusCode!: string | undefined;
    creator!: string | undefined;
    lastModifiedUser!: string | undefined;
    createdDate!: moment.Moment;
    lastModifiedTime!: moment.Moment | undefined;

    constructor(data?: IOrderStatusPagedListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.orderId = data["orderId"];
            this.statusCode = data["statusCode"];
            this.creator = data["creator"];
            this.lastModifiedUser = data["lastModifiedUser"];
            this.createdDate = data["createdDate"] ? moment(data["createdDate"].toString()) : <any>undefined;
            this.lastModifiedTime = data["lastModifiedTime"] ? moment(data["lastModifiedTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): OrderStatusPagedListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusPagedListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["orderId"] = this.orderId;
        data["statusCode"] = this.statusCode;
        data["creator"] = this.creator;
        data["lastModifiedUser"] = this.lastModifiedUser;
        data["createdDate"] = this.createdDate ? this.createdDate.toISOString() : <any>undefined;
        data["lastModifiedTime"] = this.lastModifiedTime ? this.lastModifiedTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IOrderStatusPagedListDto {
    id: number;
    orderId: number;
    statusCode: string | undefined;
    creator: string | undefined;
    lastModifiedUser: string | undefined;
    createdDate: moment.Moment;
    lastModifiedTime: moment.Moment | undefined;
}

export class PagedResultDtoOfOrderStatusPagedListDto implements IPagedResultDtoOfOrderStatusPagedListDto {
    totalCount!: number;
    items!: OrderStatusPagedListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderStatusPagedListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusPagedListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderStatusPagedListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderStatusPagedListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderStatusPagedListDto {
    totalCount: number;
    items: OrderStatusPagedListDto[] | undefined;
}

export class GetOrderStatusForViewDto implements IGetOrderStatusForViewDto {
    orderStatus!: OrderStatusDto | undefined;

    constructor(data?: IGetOrderStatusForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatus = data["orderStatus"] ? OrderStatusDto.fromJS(data["orderStatus"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderStatusForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderStatusForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatus"] = this.orderStatus ? this.orderStatus.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderStatusForViewDto {
    orderStatus: OrderStatusDto | undefined;
}

export class CreateOrEditOrderStatusDto implements ICreateOrEditOrderStatusDto {
    userId!: number;
    orderId!: number;
    geocodeId!: number;
    orderStatusTypeId!: number;
    note!: string | undefined;
    noteId!: number | undefined;
    time!: moment.Moment;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrderStatusDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.orderId = data["orderId"];
            this.geocodeId = data["geocodeId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.note = data["note"];
            this.noteId = data["noteId"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrderStatusDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrderStatusDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["orderId"] = this.orderId;
        data["geocodeId"] = this.geocodeId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["note"] = this.note;
        data["noteId"] = this.noteId;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrderStatusDto {
    userId: number;
    orderId: number;
    geocodeId: number;
    orderStatusTypeId: number;
    note: string | undefined;
    noteId: number | undefined;
    time: moment.Moment;
    id: number | undefined;
}

export class GetOrderStatusForEditOutput implements IGetOrderStatusForEditOutput {
    orderStatus!: CreateOrEditOrderStatusDto | undefined;

    constructor(data?: IGetOrderStatusForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatus = data["orderStatus"] ? CreateOrEditOrderStatusDto.fromJS(data["orderStatus"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderStatusForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderStatusForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatus"] = this.orderStatus ? this.orderStatus.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderStatusForEditOutput {
    orderStatus: CreateOrEditOrderStatusDto | undefined;
}

export class OrderStatusMappingDto implements IOrderStatusMappingDto {
    code!: string | undefined;
    description!: string | undefined;
    orderStatusDescriptionId!: number;
    orderSourceId!: number;
    id!: number;

    constructor(data?: IOrderStatusMappingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.orderStatusDescriptionId = data["orderStatusDescriptionId"];
            this.orderSourceId = data["orderSourceId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatusMappingDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusMappingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["orderStatusDescriptionId"] = this.orderStatusDescriptionId;
        data["orderSourceId"] = this.orderSourceId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatusMappingDto {
    code: string | undefined;
    description: string | undefined;
    orderStatusDescriptionId: number;
    orderSourceId: number;
    id: number;
}

export class GetOrderStatusMappingForViewDto implements IGetOrderStatusMappingForViewDto {
    orderStatusMapping!: OrderStatusMappingDto | undefined;
    orderStatusDescriptionName!: string | undefined;
    orderSourceName!: string | undefined;

    constructor(data?: IGetOrderStatusMappingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatusMapping = data["orderStatusMapping"] ? OrderStatusMappingDto.fromJS(data["orderStatusMapping"]) : <any>undefined;
            this.orderStatusDescriptionName = data["orderStatusDescriptionName"];
            this.orderSourceName = data["orderSourceName"];
        }
    }

    static fromJS(data: any): GetOrderStatusMappingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderStatusMappingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatusMapping"] = this.orderStatusMapping ? this.orderStatusMapping.toJSON() : <any>undefined;
        data["orderStatusDescriptionName"] = this.orderStatusDescriptionName;
        data["orderSourceName"] = this.orderSourceName;
        return data; 
    }
}

export interface IGetOrderStatusMappingForViewDto {
    orderStatusMapping: OrderStatusMappingDto | undefined;
    orderStatusDescriptionName: string | undefined;
    orderSourceName: string | undefined;
}

export class PagedResultDtoOfGetOrderStatusMappingForViewDto implements IPagedResultDtoOfGetOrderStatusMappingForViewDto {
    totalCount!: number;
    items!: GetOrderStatusMappingForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderStatusMappingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderStatusMappingForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderStatusMappingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderStatusMappingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderStatusMappingForViewDto {
    totalCount: number;
    items: GetOrderStatusMappingForViewDto[] | undefined;
}

export class CreateOrEditOrderStatusMappingDto implements ICreateOrEditOrderStatusMappingDto {
    code!: string;
    description!: string;
    orderStatusDescriptionId!: number;
    orderSourceId!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrderStatusMappingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.orderStatusDescriptionId = data["orderStatusDescriptionId"];
            this.orderSourceId = data["orderSourceId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrderStatusMappingDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrderStatusMappingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["orderStatusDescriptionId"] = this.orderStatusDescriptionId;
        data["orderSourceId"] = this.orderSourceId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrderStatusMappingDto {
    code: string;
    description: string;
    orderStatusDescriptionId: number;
    orderSourceId: number;
    id: number | undefined;
}

export class GetOrderStatusMappingForEditOutput implements IGetOrderStatusMappingForEditOutput {
    orderStatusMapping!: CreateOrEditOrderStatusMappingDto | undefined;
    orderStatusDescriptionName!: string | undefined;
    orderSourceName!: string | undefined;

    constructor(data?: IGetOrderStatusMappingForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatusMapping = data["orderStatusMapping"] ? CreateOrEditOrderStatusMappingDto.fromJS(data["orderStatusMapping"]) : <any>undefined;
            this.orderStatusDescriptionName = data["orderStatusDescriptionName"];
            this.orderSourceName = data["orderSourceName"];
        }
    }

    static fromJS(data: any): GetOrderStatusMappingForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderStatusMappingForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatusMapping"] = this.orderStatusMapping ? this.orderStatusMapping.toJSON() : <any>undefined;
        data["orderStatusDescriptionName"] = this.orderStatusDescriptionName;
        data["orderSourceName"] = this.orderSourceName;
        return data; 
    }
}

export interface IGetOrderStatusMappingForEditOutput {
    orderStatusMapping: CreateOrEditOrderStatusMappingDto | undefined;
    orderStatusDescriptionName: string | undefined;
    orderSourceName: string | undefined;
}

export class OrderStatusMappingOrderStatusDescriptionLookupTableDto implements IOrderStatusMappingOrderStatusDescriptionLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrderStatusMappingOrderStatusDescriptionLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrderStatusMappingOrderStatusDescriptionLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusMappingOrderStatusDescriptionLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrderStatusMappingOrderStatusDescriptionLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class OrderStatusMappingOrderSourceLookupTableDto implements IOrderStatusMappingOrderSourceLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrderStatusMappingOrderSourceLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrderStatusMappingOrderSourceLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusMappingOrderSourceLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrderStatusMappingOrderSourceLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class CreateOrderStatusTypeInput implements ICreateOrderStatusTypeInput {
    code!: string;
    description!: string;
    name!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    visible!: boolean;
    parentId!: number | undefined;
    sortOrder!: number;

    constructor(data?: ICreateOrderStatusTypeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.visible = data["visible"];
            this.parentId = data["parentId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): CreateOrderStatusTypeInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderStatusTypeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["visible"] = this.visible;
        data["parentId"] = this.parentId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface ICreateOrderStatusTypeInput {
    code: string;
    description: string;
    name: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    visible: boolean;
    parentId: number | undefined;
    sortOrder: number;
}

export class UpdateOrderStatusTypeInput implements IUpdateOrderStatusTypeInput {
    id!: number;
    code!: string;
    description!: string;
    name!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    visible!: boolean;
    parentId!: number | undefined;
    sortOrder!: number;

    constructor(data?: IUpdateOrderStatusTypeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.visible = data["visible"];
            this.parentId = data["parentId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): UpdateOrderStatusTypeInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderStatusTypeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["visible"] = this.visible;
        data["parentId"] = this.parentId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IUpdateOrderStatusTypeInput {
    id: number;
    code: string;
    description: string;
    name: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    visible: boolean;
    parentId: number | undefined;
    sortOrder: number;
}

export class PagedResultDtoOfOrderStatusTypeListDto implements IPagedResultDtoOfOrderStatusTypeListDto {
    totalCount!: number;
    items!: OrderStatusTypeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderStatusTypeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusTypeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderStatusTypeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderStatusTypeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderStatusTypeListDto {
    totalCount: number;
    items: OrderStatusTypeListDto[] | undefined;
}

export class CreateOrderStatusTypeDescriptionInput implements ICreateOrderStatusTypeDescriptionInput {
    orderStatusTypeId!: number;
    description!: string;
    name!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    visible!: boolean;
    parentId!: number | undefined;
    sortOrder!: number;

    constructor(data?: ICreateOrderStatusTypeDescriptionInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.description = data["description"];
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.visible = data["visible"];
            this.parentId = data["parentId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): CreateOrderStatusTypeDescriptionInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderStatusTypeDescriptionInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["description"] = this.description;
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["visible"] = this.visible;
        data["parentId"] = this.parentId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface ICreateOrderStatusTypeDescriptionInput {
    orderStatusTypeId: number;
    description: string;
    name: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    visible: boolean;
    parentId: number | undefined;
    sortOrder: number;
}

export class UpdateOrderStatusTypeDescriptionInput implements IUpdateOrderStatusTypeDescriptionInput {
    id!: number;
    orderStatusTypeId!: number;
    description!: string | undefined;
    name!: string;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    visible!: boolean;
    parentId!: number | undefined;
    sortOrder!: number;

    constructor(data?: IUpdateOrderStatusTypeDescriptionInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.description = data["description"];
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.visible = data["visible"];
            this.parentId = data["parentId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): UpdateOrderStatusTypeDescriptionInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderStatusTypeDescriptionInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["description"] = this.description;
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["visible"] = this.visible;
        data["parentId"] = this.parentId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IUpdateOrderStatusTypeDescriptionInput {
    id: number;
    orderStatusTypeId: number;
    description: string | undefined;
    name: string;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    visible: boolean;
    parentId: number | undefined;
    sortOrder: number;
}

export class SortOrderStatusDescription implements ISortOrderStatusDescription {
    sortStatusTypeDescription!: UpdateOrderStatusTypeDescriptionInput[] | undefined;

    constructor(data?: ISortOrderStatusDescription) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["sortStatusTypeDescription"])) {
                this.sortStatusTypeDescription = [] as any;
                for (let item of data["sortStatusTypeDescription"])
                    this.sortStatusTypeDescription!.push(UpdateOrderStatusTypeDescriptionInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): SortOrderStatusDescription {
        data = typeof data === 'object' ? data : {};
        let result = new SortOrderStatusDescription();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.sortStatusTypeDescription)) {
            data["sortStatusTypeDescription"] = [];
            for (let item of this.sortStatusTypeDescription)
                data["sortStatusTypeDescription"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ISortOrderStatusDescription {
    sortStatusTypeDescription: UpdateOrderStatusTypeDescriptionInput[] | undefined;
}

export class PagedResultDtoOfOrderStatusTypeDescriptionListDto implements IPagedResultDtoOfOrderStatusTypeDescriptionListDto {
    totalCount!: number;
    items!: OrderStatusTypeDescriptionListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderStatusTypeDescriptionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusTypeDescriptionListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderStatusTypeDescriptionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderStatusTypeDescriptionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderStatusTypeDescriptionListDto {
    totalCount: number;
    items: OrderStatusTypeDescriptionListDto[] | undefined;
}

export class ListResultDtoOfOrderStatusTypeDescriptionListDto implements IListResultDtoOfOrderStatusTypeDescriptionListDto {
    items!: OrderStatusTypeDescriptionListDto[] | undefined;

    constructor(data?: IListResultDtoOfOrderStatusTypeDescriptionListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderStatusTypeDescriptionListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfOrderStatusTypeDescriptionListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfOrderStatusTypeDescriptionListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfOrderStatusTypeDescriptionListDto {
    items: OrderStatusTypeDescriptionListDto[] | undefined;
}

export class OrderStatusTypeDto implements IOrderStatusTypeDto {
    code!: string | undefined;
    description!: string | undefined;
    sortOrder!: number;
    id!: number;

    constructor(data?: IOrderStatusTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.sortOrder = data["sortOrder"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatusTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["sortOrder"] = this.sortOrder;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatusTypeDto {
    code: string | undefined;
    description: string | undefined;
    sortOrder: number;
    id: number;
}

export class GetOrderStatusTypeForViewDto implements IGetOrderStatusTypeForViewDto {
    orderStatusType!: OrderStatusTypeDto | undefined;

    constructor(data?: IGetOrderStatusTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatusType = data["orderStatusType"] ? OrderStatusTypeDto.fromJS(data["orderStatusType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderStatusTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderStatusTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderStatusTypeForViewDto {
    orderStatusType: OrderStatusTypeDto | undefined;
}

export class PagedResultDtoOfGetOrderStatusTypeForViewDto implements IPagedResultDtoOfGetOrderStatusTypeForViewDto {
    totalCount!: number;
    items!: GetOrderStatusTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderStatusTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderStatusTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderStatusTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderStatusTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderStatusTypeForViewDto {
    totalCount: number;
    items: GetOrderStatusTypeForViewDto[] | undefined;
}

export class CreateOrEditOrderStatusTypeDto implements ICreateOrEditOrderStatusTypeDto {
    code!: string | undefined;
    description!: string | undefined;
    sortOrder!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrderStatusTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.sortOrder = data["sortOrder"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrderStatusTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrderStatusTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["sortOrder"] = this.sortOrder;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrderStatusTypeDto {
    code: string | undefined;
    description: string | undefined;
    sortOrder: number;
    id: number | undefined;
}

export class GetOrderStatusTypeForEditOutput implements IGetOrderStatusTypeForEditOutput {
    orderStatusType!: CreateOrEditOrderStatusTypeDto | undefined;

    constructor(data?: IGetOrderStatusTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatusType = data["orderStatusType"] ? CreateOrEditOrderStatusTypeDto.fromJS(data["orderStatusType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderStatusTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderStatusTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderStatusTypeForEditOutput {
    orderStatusType: CreateOrEditOrderStatusTypeDto | undefined;
}

export class PagedResultDtoOfOrderTagListDto implements IPagedResultDtoOfOrderTagListDto {
    totalCount!: number;
    items!: OrderTagListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrderTagListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrderTagListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrderTagListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrderTagListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrderTagListDto {
    totalCount: number;
    items: OrderTagListDto[] | undefined;
}

export class CreateOrderTagInput implements ICreateOrderTagInput {
    tagId!: number;
    orderId!: number;

    constructor(data?: ICreateOrderTagInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tagId = data["tagId"];
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): CreateOrderTagInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderTagInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tagId"] = this.tagId;
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface ICreateOrderTagInput {
    tagId: number;
    orderId: number;
}

export class UpdateOrderTagInput implements IUpdateOrderTagInput {
    id!: number;
    tagId!: number;
    orderId!: number;

    constructor(data?: IUpdateOrderTagInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tagId = data["tagId"];
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): UpdateOrderTagInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrderTagInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tagId"] = this.tagId;
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface IUpdateOrderTagInput {
    id: number;
    tagId: number;
    orderId: number;
}

export class GetOrderTypeForViewDto implements IGetOrderTypeForViewDto {
    orderType!: OrderTypeDto | undefined;

    constructor(data?: IGetOrderTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderType = data["orderType"] ? OrderTypeDto.fromJS(data["orderType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderTypeForViewDto {
    orderType: OrderTypeDto | undefined;
}

export class PagedResultDtoOfGetOrderTypeForViewDto implements IPagedResultDtoOfGetOrderTypeForViewDto {
    totalCount!: number;
    items!: GetOrderTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderTypeForViewDto {
    totalCount: number;
    items: GetOrderTypeForViewDto[] | undefined;
}

export class CreateOrEditOrderTypeDto implements ICreateOrEditOrderTypeDto {
    code!: string;
    description!: string | undefined;
    isActive!: boolean;
    color!: string | undefined;
    textColor!: string | undefined;
    sortOrder!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrderTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.isActive = data["isActive"];
            this.color = data["color"];
            this.textColor = data["textColor"];
            this.sortOrder = data["sortOrder"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrderTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrderTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["isActive"] = this.isActive;
        data["color"] = this.color;
        data["textColor"] = this.textColor;
        data["sortOrder"] = this.sortOrder;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrderTypeDto {
    code: string;
    description: string | undefined;
    isActive: boolean;
    color: string | undefined;
    textColor: string | undefined;
    sortOrder: number;
    id: number | undefined;
}

export class GetOrderTypeForEditOutput implements IGetOrderTypeForEditOutput {
    orderType!: CreateOrEditOrderTypeDto | undefined;

    constructor(data?: IGetOrderTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderType = data["orderType"] ? CreateOrEditOrderTypeDto.fromJS(data["orderType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderTypeForEditOutput {
    orderType: CreateOrEditOrderTypeDto | undefined;
}

export class ListResultDtoOfOrganizationUnitDto implements IListResultDtoOfOrganizationUnitDto {
    items!: OrganizationUnitDto[] | undefined;

    constructor(data?: IListResultDtoOfOrganizationUnitDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrganizationUnitDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfOrganizationUnitDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfOrganizationUnitDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfOrganizationUnitDto {
    items: OrganizationUnitDto[] | undefined;
}

export class OrganizationUnitUserListDto implements IOrganizationUnitUserListDto {
    name!: string | undefined;
    surname!: string | undefined;
    userName!: string | undefined;
    emailAddress!: string | undefined;
    profilePictureId!: string | undefined;
    addedTime!: moment.Moment;
    id!: number;

    constructor(data?: IOrganizationUnitUserListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.surname = data["surname"];
            this.userName = data["userName"];
            this.emailAddress = data["emailAddress"];
            this.profilePictureId = data["profilePictureId"];
            this.addedTime = data["addedTime"] ? moment(data["addedTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrganizationUnitUserListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnitUserListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["userName"] = this.userName;
        data["emailAddress"] = this.emailAddress;
        data["profilePictureId"] = this.profilePictureId;
        data["addedTime"] = this.addedTime ? this.addedTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrganizationUnitUserListDto {
    name: string | undefined;
    surname: string | undefined;
    userName: string | undefined;
    emailAddress: string | undefined;
    profilePictureId: string | undefined;
    addedTime: moment.Moment;
    id: number;
}

export class PagedResultDtoOfOrganizationUnitUserListDto implements IPagedResultDtoOfOrganizationUnitUserListDto {
    totalCount!: number;
    items!: OrganizationUnitUserListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrganizationUnitUserListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrganizationUnitUserListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrganizationUnitUserListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrganizationUnitUserListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrganizationUnitUserListDto {
    totalCount: number;
    items: OrganizationUnitUserListDto[] | undefined;
}

export class OrganizationUnitRoleListDto implements IOrganizationUnitRoleListDto {
    displayName!: string | undefined;
    name!: string | undefined;
    addedTime!: moment.Moment;
    id!: number;

    constructor(data?: IOrganizationUnitRoleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.displayName = data["displayName"];
            this.name = data["name"];
            this.addedTime = data["addedTime"] ? moment(data["addedTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrganizationUnitRoleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnitRoleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["displayName"] = this.displayName;
        data["name"] = this.name;
        data["addedTime"] = this.addedTime ? this.addedTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrganizationUnitRoleListDto {
    displayName: string | undefined;
    name: string | undefined;
    addedTime: moment.Moment;
    id: number;
}

export class PagedResultDtoOfOrganizationUnitRoleListDto implements IPagedResultDtoOfOrganizationUnitRoleListDto {
    totalCount!: number;
    items!: OrganizationUnitRoleListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrganizationUnitRoleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrganizationUnitRoleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrganizationUnitRoleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrganizationUnitRoleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrganizationUnitRoleListDto {
    totalCount: number;
    items: OrganizationUnitRoleListDto[] | undefined;
}

export class CreateOrganizationUnitInput implements ICreateOrganizationUnitInput {
    parentId!: number | undefined;
    displayName!: string;

    constructor(data?: ICreateOrganizationUnitInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parentId = data["parentId"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): CreateOrganizationUnitInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrganizationUnitInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parentId"] = this.parentId;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ICreateOrganizationUnitInput {
    parentId: number | undefined;
    displayName: string;
}

export class UpdateOrganizationUnitInput implements IUpdateOrganizationUnitInput {
    id!: number;
    displayName!: string;

    constructor(data?: IUpdateOrganizationUnitInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): UpdateOrganizationUnitInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateOrganizationUnitInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IUpdateOrganizationUnitInput {
    id: number;
    displayName: string;
}

export class MoveOrganizationUnitInput implements IMoveOrganizationUnitInput {
    id!: number;
    newParentId!: number | undefined;

    constructor(data?: IMoveOrganizationUnitInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.newParentId = data["newParentId"];
        }
    }

    static fromJS(data: any): MoveOrganizationUnitInput {
        data = typeof data === 'object' ? data : {};
        let result = new MoveOrganizationUnitInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["newParentId"] = this.newParentId;
        return data; 
    }
}

export interface IMoveOrganizationUnitInput {
    id: number;
    newParentId: number | undefined;
}

export class UsersToOrganizationUnitInput implements IUsersToOrganizationUnitInput {
    userIds!: number[] | undefined;
    organizationUnitId!: number;

    constructor(data?: IUsersToOrganizationUnitInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["userIds"])) {
                this.userIds = [] as any;
                for (let item of data["userIds"])
                    this.userIds!.push(item);
            }
            this.organizationUnitId = data["organizationUnitId"];
        }
    }

    static fromJS(data: any): UsersToOrganizationUnitInput {
        data = typeof data === 'object' ? data : {};
        let result = new UsersToOrganizationUnitInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.userIds)) {
            data["userIds"] = [];
            for (let item of this.userIds)
                data["userIds"].push(item);
        }
        data["organizationUnitId"] = this.organizationUnitId;
        return data; 
    }
}

export interface IUsersToOrganizationUnitInput {
    userIds: number[] | undefined;
    organizationUnitId: number;
}

export class RolesToOrganizationUnitInput implements IRolesToOrganizationUnitInput {
    roleIds!: number[] | undefined;
    organizationUnitId!: number;

    constructor(data?: IRolesToOrganizationUnitInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["roleIds"])) {
                this.roleIds = [] as any;
                for (let item of data["roleIds"])
                    this.roleIds!.push(item);
            }
            this.organizationUnitId = data["organizationUnitId"];
        }
    }

    static fromJS(data: any): RolesToOrganizationUnitInput {
        data = typeof data === 'object' ? data : {};
        let result = new RolesToOrganizationUnitInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.roleIds)) {
            data["roleIds"] = [];
            for (let item of this.roleIds)
                data["roleIds"].push(item);
        }
        data["organizationUnitId"] = this.organizationUnitId;
        return data; 
    }
}

export interface IRolesToOrganizationUnitInput {
    roleIds: number[] | undefined;
    organizationUnitId: number;
}

export class FindOrganizationUnitUsersInput implements IFindOrganizationUnitUsersInput {
    organizationUnitId!: number;
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: IFindOrganizationUnitUsersInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.organizationUnitId = data["organizationUnitId"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): FindOrganizationUnitUsersInput {
        data = typeof data === 'object' ? data : {};
        let result = new FindOrganizationUnitUsersInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["organizationUnitId"] = this.organizationUnitId;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface IFindOrganizationUnitUsersInput {
    organizationUnitId: number;
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class FindOrganizationUnitRolesInput implements IFindOrganizationUnitRolesInput {
    organizationUnitId!: number;
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: IFindOrganizationUnitRolesInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.organizationUnitId = data["organizationUnitId"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): FindOrganizationUnitRolesInput {
        data = typeof data === 'object' ? data : {};
        let result = new FindOrganizationUnitRolesInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["organizationUnitId"] = this.organizationUnitId;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface IFindOrganizationUnitRolesInput {
    organizationUnitId: number;
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class GetOrganizationUnitOrderNotificationForViewDto implements IGetOrganizationUnitOrderNotificationForViewDto {
    organizationUnitOrderNotification!: OrganizationUnitOrderNotificationDto | undefined;
    organizationUnitDisplayName!: string | undefined;
    orderNotificationOrderNotificationTemplateId!: string | undefined;
    userName!: string | undefined;

    constructor(data?: IGetOrganizationUnitOrderNotificationForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.organizationUnitOrderNotification = data["organizationUnitOrderNotification"] ? OrganizationUnitOrderNotificationDto.fromJS(data["organizationUnitOrderNotification"]) : <any>undefined;
            this.organizationUnitDisplayName = data["organizationUnitDisplayName"];
            this.orderNotificationOrderNotificationTemplateId = data["orderNotificationOrderNotificationTemplateId"];
            this.userName = data["userName"];
        }
    }

    static fromJS(data: any): GetOrganizationUnitOrderNotificationForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrganizationUnitOrderNotificationForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["organizationUnitOrderNotification"] = this.organizationUnitOrderNotification ? this.organizationUnitOrderNotification.toJSON() : <any>undefined;
        data["organizationUnitDisplayName"] = this.organizationUnitDisplayName;
        data["orderNotificationOrderNotificationTemplateId"] = this.orderNotificationOrderNotificationTemplateId;
        data["userName"] = this.userName;
        return data; 
    }
}

export interface IGetOrganizationUnitOrderNotificationForViewDto {
    organizationUnitOrderNotification: OrganizationUnitOrderNotificationDto | undefined;
    organizationUnitDisplayName: string | undefined;
    orderNotificationOrderNotificationTemplateId: string | undefined;
    userName: string | undefined;
}

export class PagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto implements IPagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto {
    totalCount!: number;
    items!: GetOrganizationUnitOrderNotificationForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrganizationUnitOrderNotificationForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrganizationUnitOrderNotificationForViewDto {
    totalCount: number;
    items: GetOrganizationUnitOrderNotificationForViewDto[] | undefined;
}

export class CreateOrEditOrganizationUnitOrderNotificationDto implements ICreateOrEditOrganizationUnitOrderNotificationDto {
    isEmail!: boolean;
    isSMS!: boolean;
    isActive!: boolean;
    emailAddress!: string | undefined;
    phoneNumber!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    orderNotificationId!: number | undefined;
    userId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditOrganizationUnitOrderNotificationDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEmail = data["isEmail"];
            this.isSMS = data["isSMS"];
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.orderNotificationId = data["orderNotificationId"];
            this.userId = data["userId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditOrganizationUnitOrderNotificationDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditOrganizationUnitOrderNotificationDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEmail"] = this.isEmail;
        data["isSMS"] = this.isSMS;
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["orderNotificationId"] = this.orderNotificationId;
        data["userId"] = this.userId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditOrganizationUnitOrderNotificationDto {
    isEmail: boolean;
    isSMS: boolean;
    isActive: boolean;
    emailAddress: string | undefined;
    phoneNumber: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    orderNotificationId: number | undefined;
    userId: number | undefined;
    id: number | undefined;
}

export class GetOrganizationUnitOrderNotificationForEditOutput implements IGetOrganizationUnitOrderNotificationForEditOutput {
    organizationUnitOrderNotification!: CreateOrEditOrganizationUnitOrderNotificationDto | undefined;
    organizationUnitDisplayName!: string | undefined;
    orderNotificationOrderNotificationTemplateId!: string | undefined;
    userName!: string | undefined;

    constructor(data?: IGetOrganizationUnitOrderNotificationForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.organizationUnitOrderNotification = data["organizationUnitOrderNotification"] ? CreateOrEditOrganizationUnitOrderNotificationDto.fromJS(data["organizationUnitOrderNotification"]) : <any>undefined;
            this.organizationUnitDisplayName = data["organizationUnitDisplayName"];
            this.orderNotificationOrderNotificationTemplateId = data["orderNotificationOrderNotificationTemplateId"];
            this.userName = data["userName"];
        }
    }

    static fromJS(data: any): GetOrganizationUnitOrderNotificationForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrganizationUnitOrderNotificationForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["organizationUnitOrderNotification"] = this.organizationUnitOrderNotification ? this.organizationUnitOrderNotification.toJSON() : <any>undefined;
        data["organizationUnitDisplayName"] = this.organizationUnitDisplayName;
        data["orderNotificationOrderNotificationTemplateId"] = this.orderNotificationOrderNotificationTemplateId;
        data["userName"] = this.userName;
        return data; 
    }
}

export interface IGetOrganizationUnitOrderNotificationForEditOutput {
    organizationUnitOrderNotification: CreateOrEditOrganizationUnitOrderNotificationDto | undefined;
    organizationUnitDisplayName: string | undefined;
    orderNotificationOrderNotificationTemplateId: string | undefined;
    userName: string | undefined;
}

export class OrganizationUnitOrderNotificationOrganizationUnitLookupTableDto implements IOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrganizationUnitOrderNotificationOrganizationUnitLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnitOrderNotificationOrganizationUnitLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto implements IPagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto {
    totalCount!: number;
    items!: OrganizationUnitOrderNotificationOrganizationUnitLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrganizationUnitOrderNotificationOrganizationUnitLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrganizationUnitOrderNotificationOrganizationUnitLookupTableDto {
    totalCount: number;
    items: OrganizationUnitOrderNotificationOrganizationUnitLookupTableDto[] | undefined;
}

export class OrganizationUnitOrderNotificationOrderNotificationLookupTableDto implements IOrganizationUnitOrderNotificationOrderNotificationLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrganizationUnitOrderNotificationOrderNotificationLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrganizationUnitOrderNotificationOrderNotificationLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnitOrderNotificationOrderNotificationLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrganizationUnitOrderNotificationOrderNotificationLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto implements IPagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto {
    totalCount!: number;
    items!: OrganizationUnitOrderNotificationOrderNotificationLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrganizationUnitOrderNotificationOrderNotificationLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrganizationUnitOrderNotificationOrderNotificationLookupTableDto {
    totalCount: number;
    items: OrganizationUnitOrderNotificationOrderNotificationLookupTableDto[] | undefined;
}

export class OrganizationUnitOrderNotificationUserLookupTableDto implements IOrganizationUnitOrderNotificationUserLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IOrganizationUnitOrderNotificationUserLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): OrganizationUnitOrderNotificationUserLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnitOrderNotificationUserLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IOrganizationUnitOrderNotificationUserLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto implements IPagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto {
    totalCount!: number;
    items!: OrganizationUnitOrderNotificationUserLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(OrganizationUnitOrderNotificationUserLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfOrganizationUnitOrderNotificationUserLookupTableDto {
    totalCount: number;
    items: OrganizationUnitOrderNotificationUserLookupTableDto[] | undefined;
}

export class PackageOptionsListDto implements IPackageOptionsListDto {
    id!: number | undefined;
    packageId!: number;
    packageName!: string | undefined;
    code!: string | undefined;
    key!: string | undefined;
    value!: string | undefined;

    constructor(data?: IPackageOptionsListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.packageId = data["packageId"];
            this.packageName = data["packageName"];
            this.code = data["code"];
            this.key = data["key"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): PackageOptionsListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PackageOptionsListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["packageId"] = this.packageId;
        data["packageName"] = this.packageName;
        data["code"] = this.code;
        data["key"] = this.key;
        data["value"] = this.value;
        return data; 
    }
}

export interface IPackageOptionsListDto {
    id: number | undefined;
    packageId: number;
    packageName: string | undefined;
    code: string | undefined;
    key: string | undefined;
    value: string | undefined;
}

export class PagedResultDtoOfPackageOptionsListDto implements IPagedResultDtoOfPackageOptionsListDto {
    totalCount!: number;
    items!: PackageOptionsListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfPackageOptionsListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(PackageOptionsListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfPackageOptionsListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfPackageOptionsListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfPackageOptionsListDto {
    totalCount: number;
    items: PackageOptionsListDto[] | undefined;
}

export class CreateOrEditPackageOptionsDto implements ICreateOrEditPackageOptionsDto {
    id!: number;
    packageId!: number;
    code!: string | undefined;
    key!: string | undefined;
    value!: string | undefined;

    constructor(data?: ICreateOrEditPackageOptionsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.packageId = data["packageId"];
            this.code = data["code"];
            this.key = data["key"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreateOrEditPackageOptionsDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditPackageOptionsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["packageId"] = this.packageId;
        data["code"] = this.code;
        data["key"] = this.key;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreateOrEditPackageOptionsDto {
    id: number;
    packageId: number;
    code: string | undefined;
    key: string | undefined;
    value: string | undefined;
}

export class CreatePackageOptionsDto implements ICreatePackageOptionsDto {
    id!: number;
    packageId!: number;
    code!: string | undefined;
    key!: string | undefined;
    value!: string | undefined;

    constructor(data?: ICreatePackageOptionsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.packageId = data["packageId"];
            this.code = data["code"];
            this.key = data["key"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreatePackageOptionsDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreatePackageOptionsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["packageId"] = this.packageId;
        data["code"] = this.code;
        data["key"] = this.key;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreatePackageOptionsDto {
    id: number;
    packageId: number;
    code: string | undefined;
    key: string | undefined;
    value: string | undefined;
}

export class GetPackageForViewDto implements IGetPackageForViewDto {
    package!: PackageDto | undefined;

    constructor(data?: IGetPackageForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.package = data["package"] ? PackageDto.fromJS(data["package"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetPackageForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetPackageForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["package"] = this.package ? this.package.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetPackageForViewDto {
    package: PackageDto | undefined;
}

export class PagedResultDtoOfGetPackageForViewDto implements IPagedResultDtoOfGetPackageForViewDto {
    totalCount!: number;
    items!: GetPackageForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetPackageForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetPackageForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetPackageForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetPackageForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetPackageForViewDto {
    totalCount: number;
    items: GetPackageForViewDto[] | undefined;
}

export class CreateOrEditPackageDto implements ICreateOrEditPackageDto {
    name!: string;
    code!: string | undefined;
    price!: number;
    color!: string | undefined;
    sku!: string | undefined;
    description!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditPackageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.price = data["price"];
            this.color = data["color"];
            this.sku = data["sku"];
            this.description = data["description"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditPackageDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditPackageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["price"] = this.price;
        data["color"] = this.color;
        data["sku"] = this.sku;
        data["description"] = this.description;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditPackageDto {
    name: string;
    code: string | undefined;
    price: number;
    color: string | undefined;
    sku: string | undefined;
    description: string | undefined;
    id: number | undefined;
}

export class GetPackageForEditOutput implements IGetPackageForEditOutput {
    package!: CreateOrEditPackageDto | undefined;

    constructor(data?: IGetPackageForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.package = data["package"] ? CreateOrEditPackageDto.fromJS(data["package"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetPackageForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetPackageForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["package"] = this.package ? this.package.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetPackageForEditOutput {
    package: CreateOrEditPackageDto | undefined;
}

export class EditionSelectDto implements IEditionSelectDto {
    id!: number;
    name!: string | undefined;
    displayName!: string | undefined;
    expiringEditionId!: number | undefined;
    dailyPrice!: number | undefined;
    weeklyPrice!: number | undefined;
    monthlyPrice!: number | undefined;
    annualPrice!: number | undefined;
    trialDayCount!: number | undefined;
    waitingDayAfterExpire!: number | undefined;
    isFree!: boolean;
    additionalData!: AdditionalData | undefined;

    constructor(data?: IEditionSelectDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.expiringEditionId = data["expiringEditionId"];
            this.dailyPrice = data["dailyPrice"];
            this.weeklyPrice = data["weeklyPrice"];
            this.monthlyPrice = data["monthlyPrice"];
            this.annualPrice = data["annualPrice"];
            this.trialDayCount = data["trialDayCount"];
            this.waitingDayAfterExpire = data["waitingDayAfterExpire"];
            this.isFree = data["isFree"];
            this.additionalData = data["additionalData"] ? AdditionalData.fromJS(data["additionalData"]) : <any>undefined;
        }
    }

    static fromJS(data: any): EditionSelectDto {
        data = typeof data === 'object' ? data : {};
        let result = new EditionSelectDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["expiringEditionId"] = this.expiringEditionId;
        data["dailyPrice"] = this.dailyPrice;
        data["weeklyPrice"] = this.weeklyPrice;
        data["monthlyPrice"] = this.monthlyPrice;
        data["annualPrice"] = this.annualPrice;
        data["trialDayCount"] = this.trialDayCount;
        data["waitingDayAfterExpire"] = this.waitingDayAfterExpire;
        data["isFree"] = this.isFree;
        data["additionalData"] = this.additionalData ? this.additionalData.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IEditionSelectDto {
    id: number;
    name: string | undefined;
    displayName: string | undefined;
    expiringEditionId: number | undefined;
    dailyPrice: number | undefined;
    weeklyPrice: number | undefined;
    monthlyPrice: number | undefined;
    annualPrice: number | undefined;
    trialDayCount: number | undefined;
    waitingDayAfterExpire: number | undefined;
    isFree: boolean;
    additionalData: AdditionalData | undefined;
}

export class PaymentInfoDto implements IPaymentInfoDto {
    edition!: EditionSelectDto | undefined;
    additionalPrice!: number;

    constructor(data?: IPaymentInfoDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.edition = data["edition"] ? EditionSelectDto.fromJS(data["edition"]) : <any>undefined;
            this.additionalPrice = data["additionalPrice"];
        }
    }

    static fromJS(data: any): PaymentInfoDto {
        data = typeof data === 'object' ? data : {};
        let result = new PaymentInfoDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["edition"] = this.edition ? this.edition.toJSON() : <any>undefined;
        data["additionalPrice"] = this.additionalPrice;
        return data; 
    }
}

export interface IPaymentInfoDto {
    edition: EditionSelectDto | undefined;
    additionalPrice: number;
}

export enum EditionPaymentType {
    NewRegistration = 0,
    BuyNow = 1,
    Upgrade = 2,
    Extend = 3,
}

export enum PaymentPeriodType {
    Daily = 1,
    Weekly = 7,
    Monthly = 30,
    Annual = 365,
}

export enum SubscriptionPaymentGatewayType {
    Paypal = 1,
    Stripe = 2,
}

export class CreatePaymentDto implements ICreatePaymentDto {
    editionId!: number;
    editionPaymentType!: EditionPaymentType;
    paymentPeriodType!: PaymentPeriodType | undefined;
    subscriptionPaymentGatewayType!: SubscriptionPaymentGatewayType;
    recurringPaymentEnabled!: boolean;
    successUrl!: string | undefined;
    errorUrl!: string | undefined;

    constructor(data?: ICreatePaymentDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.editionId = data["editionId"];
            this.editionPaymentType = data["editionPaymentType"];
            this.paymentPeriodType = data["paymentPeriodType"];
            this.subscriptionPaymentGatewayType = data["subscriptionPaymentGatewayType"];
            this.recurringPaymentEnabled = data["recurringPaymentEnabled"];
            this.successUrl = data["successUrl"];
            this.errorUrl = data["errorUrl"];
        }
    }

    static fromJS(data: any): CreatePaymentDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreatePaymentDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["editionId"] = this.editionId;
        data["editionPaymentType"] = this.editionPaymentType;
        data["paymentPeriodType"] = this.paymentPeriodType;
        data["subscriptionPaymentGatewayType"] = this.subscriptionPaymentGatewayType;
        data["recurringPaymentEnabled"] = this.recurringPaymentEnabled;
        data["successUrl"] = this.successUrl;
        data["errorUrl"] = this.errorUrl;
        return data; 
    }
}

export interface ICreatePaymentDto {
    editionId: number;
    editionPaymentType: EditionPaymentType;
    paymentPeriodType: PaymentPeriodType | undefined;
    subscriptionPaymentGatewayType: SubscriptionPaymentGatewayType;
    recurringPaymentEnabled: boolean;
    successUrl: string | undefined;
    errorUrl: string | undefined;
}

export class CancelPaymentDto implements ICancelPaymentDto {
    paymentId!: string | undefined;
    gateway!: SubscriptionPaymentGatewayType;

    constructor(data?: ICancelPaymentDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.paymentId = data["paymentId"];
            this.gateway = data["gateway"];
        }
    }

    static fromJS(data: any): CancelPaymentDto {
        data = typeof data === 'object' ? data : {};
        let result = new CancelPaymentDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["paymentId"] = this.paymentId;
        data["gateway"] = this.gateway;
        return data; 
    }
}

export interface ICancelPaymentDto {
    paymentId: string | undefined;
    gateway: SubscriptionPaymentGatewayType;
}

export class SubscriptionPaymentListDto implements ISubscriptionPaymentListDto {
    gateway!: string | undefined;
    amount!: number;
    editionId!: number;
    dayCount!: number;
    paymentPeriodType!: string | undefined;
    externalPaymentId!: string | undefined;
    payerId!: string | undefined;
    status!: string | undefined;
    editionDisplayName!: string | undefined;
    tenantId!: number;
    invoiceNo!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISubscriptionPaymentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.gateway = data["gateway"];
            this.amount = data["amount"];
            this.editionId = data["editionId"];
            this.dayCount = data["dayCount"];
            this.paymentPeriodType = data["paymentPeriodType"];
            this.externalPaymentId = data["externalPaymentId"];
            this.payerId = data["payerId"];
            this.status = data["status"];
            this.editionDisplayName = data["editionDisplayName"];
            this.tenantId = data["tenantId"];
            this.invoiceNo = data["invoiceNo"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SubscriptionPaymentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new SubscriptionPaymentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["gateway"] = this.gateway;
        data["amount"] = this.amount;
        data["editionId"] = this.editionId;
        data["dayCount"] = this.dayCount;
        data["paymentPeriodType"] = this.paymentPeriodType;
        data["externalPaymentId"] = this.externalPaymentId;
        data["payerId"] = this.payerId;
        data["status"] = this.status;
        data["editionDisplayName"] = this.editionDisplayName;
        data["tenantId"] = this.tenantId;
        data["invoiceNo"] = this.invoiceNo;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISubscriptionPaymentListDto {
    gateway: string | undefined;
    amount: number;
    editionId: number;
    dayCount: number;
    paymentPeriodType: string | undefined;
    externalPaymentId: string | undefined;
    payerId: string | undefined;
    status: string | undefined;
    editionDisplayName: string | undefined;
    tenantId: number;
    invoiceNo: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class PagedResultDtoOfSubscriptionPaymentListDto implements IPagedResultDtoOfSubscriptionPaymentListDto {
    totalCount!: number;
    items!: SubscriptionPaymentListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfSubscriptionPaymentListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SubscriptionPaymentListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfSubscriptionPaymentListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfSubscriptionPaymentListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfSubscriptionPaymentListDto {
    totalCount: number;
    items: SubscriptionPaymentListDto[] | undefined;
}

export class PaymentGatewayModel implements IPaymentGatewayModel {
    gatewayType!: SubscriptionPaymentGatewayType;
    supportsRecurringPayments!: boolean;

    constructor(data?: IPaymentGatewayModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.gatewayType = data["gatewayType"];
            this.supportsRecurringPayments = data["supportsRecurringPayments"];
        }
    }

    static fromJS(data: any): PaymentGatewayModel {
        data = typeof data === 'object' ? data : {};
        let result = new PaymentGatewayModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["gatewayType"] = this.gatewayType;
        data["supportsRecurringPayments"] = this.supportsRecurringPayments;
        return data; 
    }
}

export interface IPaymentGatewayModel {
    gatewayType: SubscriptionPaymentGatewayType;
    supportsRecurringPayments: boolean;
}

export enum SubscriptionPaymentStatus {
    NotPaid = 1,
    Paid = 2,
    Failed = 3,
    Cancelled = 4,
    Completed = 5,
}

export class SubscriptionPaymentDto implements ISubscriptionPaymentDto {
    description!: string | undefined;
    gateway!: SubscriptionPaymentGatewayType;
    amount!: number;
    editionId!: number;
    tenantId!: number;
    dayCount!: number;
    paymentPeriodType!: PaymentPeriodType;
    paymentId!: string | undefined;
    payerId!: string | undefined;
    editionDisplayName!: string | undefined;
    invoiceNo!: number;
    status!: SubscriptionPaymentStatus;
    isRecurring!: boolean;
    externalPaymentId!: string | undefined;
    successUrl!: string | undefined;
    errorUrl!: string | undefined;
    editionPaymentType!: EditionPaymentType;
    id!: number;

    constructor(data?: ISubscriptionPaymentDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.gateway = data["gateway"];
            this.amount = data["amount"];
            this.editionId = data["editionId"];
            this.tenantId = data["tenantId"];
            this.dayCount = data["dayCount"];
            this.paymentPeriodType = data["paymentPeriodType"];
            this.paymentId = data["paymentId"];
            this.payerId = data["payerId"];
            this.editionDisplayName = data["editionDisplayName"];
            this.invoiceNo = data["invoiceNo"];
            this.status = data["status"];
            this.isRecurring = data["isRecurring"];
            this.externalPaymentId = data["externalPaymentId"];
            this.successUrl = data["successUrl"];
            this.errorUrl = data["errorUrl"];
            this.editionPaymentType = data["editionPaymentType"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SubscriptionPaymentDto {
        data = typeof data === 'object' ? data : {};
        let result = new SubscriptionPaymentDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["gateway"] = this.gateway;
        data["amount"] = this.amount;
        data["editionId"] = this.editionId;
        data["tenantId"] = this.tenantId;
        data["dayCount"] = this.dayCount;
        data["paymentPeriodType"] = this.paymentPeriodType;
        data["paymentId"] = this.paymentId;
        data["payerId"] = this.payerId;
        data["editionDisplayName"] = this.editionDisplayName;
        data["invoiceNo"] = this.invoiceNo;
        data["status"] = this.status;
        data["isRecurring"] = this.isRecurring;
        data["externalPaymentId"] = this.externalPaymentId;
        data["successUrl"] = this.successUrl;
        data["errorUrl"] = this.errorUrl;
        data["editionPaymentType"] = this.editionPaymentType;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISubscriptionPaymentDto {
    description: string | undefined;
    gateway: SubscriptionPaymentGatewayType;
    amount: number;
    editionId: number;
    tenantId: number;
    dayCount: number;
    paymentPeriodType: PaymentPeriodType;
    paymentId: string | undefined;
    payerId: string | undefined;
    editionDisplayName: string | undefined;
    invoiceNo: number;
    status: SubscriptionPaymentStatus;
    isRecurring: boolean;
    externalPaymentId: string | undefined;
    successUrl: string | undefined;
    errorUrl: string | undefined;
    editionPaymentType: EditionPaymentType;
    id: number;
}

export class PayPalConfigurationDto implements IPayPalConfigurationDto {
    clientId!: string | undefined;
    demoUsername!: string | undefined;
    demoPassword!: string | undefined;

    constructor(data?: IPayPalConfigurationDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clientId = data["clientId"];
            this.demoUsername = data["demoUsername"];
            this.demoPassword = data["demoPassword"];
        }
    }

    static fromJS(data: any): PayPalConfigurationDto {
        data = typeof data === 'object' ? data : {};
        let result = new PayPalConfigurationDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clientId"] = this.clientId;
        data["demoUsername"] = this.demoUsername;
        data["demoPassword"] = this.demoPassword;
        return data; 
    }
}

export interface IPayPalConfigurationDto {
    clientId: string | undefined;
    demoUsername: string | undefined;
    demoPassword: string | undefined;
}

export class FlatPermissionWithLevelDto implements IFlatPermissionWithLevelDto {
    level!: number;
    parentName!: string | undefined;
    name!: string | undefined;
    displayName!: string | undefined;
    description!: string | undefined;
    isGrantedByDefault!: boolean;

    constructor(data?: IFlatPermissionWithLevelDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.level = data["level"];
            this.parentName = data["parentName"];
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.description = data["description"];
            this.isGrantedByDefault = data["isGrantedByDefault"];
        }
    }

    static fromJS(data: any): FlatPermissionWithLevelDto {
        data = typeof data === 'object' ? data : {};
        let result = new FlatPermissionWithLevelDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["level"] = this.level;
        data["parentName"] = this.parentName;
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["description"] = this.description;
        data["isGrantedByDefault"] = this.isGrantedByDefault;
        return data; 
    }
}

export interface IFlatPermissionWithLevelDto {
    level: number;
    parentName: string | undefined;
    name: string | undefined;
    displayName: string | undefined;
    description: string | undefined;
    isGrantedByDefault: boolean;
}

export class ListResultDtoOfFlatPermissionWithLevelDto implements IListResultDtoOfFlatPermissionWithLevelDto {
    items!: FlatPermissionWithLevelDto[] | undefined;

    constructor(data?: IListResultDtoOfFlatPermissionWithLevelDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(FlatPermissionWithLevelDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfFlatPermissionWithLevelDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfFlatPermissionWithLevelDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfFlatPermissionWithLevelDto {
    items: FlatPermissionWithLevelDto[] | undefined;
}

export class ListResultDtoOfPhoneListDto implements IListResultDtoOfPhoneListDto {
    items!: PhoneListDto[] | undefined;

    constructor(data?: IListResultDtoOfPhoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(PhoneListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfPhoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfPhoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfPhoneListDto {
    items: PhoneListDto[] | undefined;
}

export class UpdatePhoneInput implements IUpdatePhoneInput {
    id!: number;
    contactId!: number;
    value!: string | undefined;

    constructor(data?: IUpdatePhoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contactId = data["contactId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): UpdatePhoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdatePhoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contactId"] = this.contactId;
        data["value"] = this.value;
        return data; 
    }
}

export interface IUpdatePhoneInput {
    id: number;
    contactId: number;
    value: string | undefined;
}

export class ListResultDtoOfShippingPackageListDto implements IListResultDtoOfShippingPackageListDto {
    items!: ShippingPackageListDto[] | undefined;

    constructor(data?: IListResultDtoOfShippingPackageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ShippingPackageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfShippingPackageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfShippingPackageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfShippingPackageListDto {
    items: ShippingPackageListDto[] | undefined;
}

export class PostalCodeListDto implements IPostalCodeListDto {
    country!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    value!: string | undefined;
    id!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;

    constructor(data?: IPostalCodeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.country = data["country"];
            this.city = data["city"];
            this.state = data["state"];
            this.value = data["value"];
            this.id = data["id"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
        }
    }

    static fromJS(data: any): PostalCodeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PostalCodeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["country"] = this.country;
        data["city"] = this.city;
        data["state"] = this.state;
        data["value"] = this.value;
        data["id"] = this.id;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        return data; 
    }
}

export interface IPostalCodeListDto {
    country: string | undefined;
    city: string | undefined;
    state: string | undefined;
    value: string | undefined;
    id: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
}

export class PagedResultDtoOfPostalCodeListDto implements IPagedResultDtoOfPostalCodeListDto {
    totalCount!: number;
    items!: PostalCodeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfPostalCodeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(PostalCodeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfPostalCodeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfPostalCodeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfPostalCodeListDto {
    totalCount: number;
    items: PostalCodeListDto[] | undefined;
}

export class UpdatePostalCodeInput implements IUpdatePostalCodeInput {
    id!: number;
    value!: string | undefined;
    country!: string | undefined;
    state!: string | undefined;
    city!: string | undefined;

    constructor(data?: IUpdatePostalCodeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.value = data["value"];
            this.country = data["country"];
            this.state = data["state"];
            this.city = data["city"];
        }
    }

    static fromJS(data: any): UpdatePostalCodeInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdatePostalCodeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["value"] = this.value;
        data["country"] = this.country;
        data["state"] = this.state;
        data["city"] = this.city;
        return data; 
    }
}

export interface IUpdatePostalCodeInput {
    id: number;
    value: string | undefined;
    country: string | undefined;
    state: string | undefined;
    city: string | undefined;
}

export class PostalCodeDropDownList implements IPostalCodeDropDownList {
    id!: number;
    value!: string | undefined;

    constructor(data?: IPostalCodeDropDownList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): PostalCodeDropDownList {
        data = typeof data === 'object' ? data : {};
        let result = new PostalCodeDropDownList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["value"] = this.value;
        return data; 
    }
}

export interface IPostalCodeDropDownList {
    id: number;
    value: string | undefined;
}

export class ListResultDtoOfPostalCodeDropDownList implements IListResultDtoOfPostalCodeDropDownList {
    items!: PostalCodeDropDownList[] | undefined;

    constructor(data?: IListResultDtoOfPostalCodeDropDownList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(PostalCodeDropDownList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfPostalCodeDropDownList {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfPostalCodeDropDownList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfPostalCodeDropDownList {
    items: PostalCodeDropDownList[] | undefined;
}

export class GetPostalCodeListOnlyDto implements IGetPostalCodeListOnlyDto {
    value!: string | undefined;
    locationValue!: string | undefined;
    country!: string | undefined;
    state!: string | undefined;
    city!: string | undefined;
    id!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;

    constructor(data?: IGetPostalCodeListOnlyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.locationValue = data["locationValue"];
            this.country = data["country"];
            this.state = data["state"];
            this.city = data["city"];
            this.id = data["id"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
        }
    }

    static fromJS(data: any): GetPostalCodeListOnlyDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetPostalCodeListOnlyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["locationValue"] = this.locationValue;
        data["country"] = this.country;
        data["state"] = this.state;
        data["city"] = this.city;
        data["id"] = this.id;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        return data; 
    }
}

export interface IGetPostalCodeListOnlyDto {
    value: string | undefined;
    locationValue: string | undefined;
    country: string | undefined;
    state: string | undefined;
    city: string | undefined;
    id: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
}

export class ListResultDtoOfGetPostalCodeListOnlyDto implements IListResultDtoOfGetPostalCodeListOnlyDto {
    items!: GetPostalCodeListOnlyDto[] | undefined;

    constructor(data?: IListResultDtoOfGetPostalCodeListOnlyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetPostalCodeListOnlyDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetPostalCodeListOnlyDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetPostalCodeListOnlyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetPostalCodeListOnlyDto {
    items: GetPostalCodeListOnlyDto[] | undefined;
}

export class GetCountryListOnlyDto implements IGetCountryListOnlyDto {
    id!: number;
    value!: string | undefined;
    country!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;

    constructor(data?: IGetCountryListOnlyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.value = data["value"];
            this.country = data["country"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
        }
    }

    static fromJS(data: any): GetCountryListOnlyDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetCountryListOnlyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["value"] = this.value;
        data["country"] = this.country;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        return data; 
    }
}

export interface IGetCountryListOnlyDto {
    id: number;
    value: string | undefined;
    country: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
}

export class ListResultDtoOfGetCountryListOnlyDto implements IListResultDtoOfGetCountryListOnlyDto {
    items!: GetCountryListOnlyDto[] | undefined;

    constructor(data?: IListResultDtoOfGetCountryListOnlyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetCountryListOnlyDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetCountryListOnlyDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetCountryListOnlyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetCountryListOnlyDto {
    items: GetCountryListOnlyDto[] | undefined;
}

export class GetStateListOnlyDto implements IGetStateListOnlyDto {
    value!: string | undefined;
    state!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IGetStateListOnlyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.state = data["state"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): GetStateListOnlyDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetStateListOnlyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["state"] = this.state;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IGetStateListOnlyDto {
    value: string | undefined;
    state: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ListResultDtoOfGetStateListOnlyDto implements IListResultDtoOfGetStateListOnlyDto {
    items!: GetStateListOnlyDto[] | undefined;

    constructor(data?: IListResultDtoOfGetStateListOnlyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetStateListOnlyDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetStateListOnlyDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetStateListOnlyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetStateListOnlyDto {
    items: GetStateListOnlyDto[] | undefined;
}

export class GetCityListOnlyDto implements IGetCityListOnlyDto {
    value!: string | undefined;
    city!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IGetCityListOnlyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.city = data["city"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): GetCityListOnlyDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetCityListOnlyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["city"] = this.city;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IGetCityListOnlyDto {
    value: string | undefined;
    city: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ListResultDtoOfGetCityListOnlyDto implements IListResultDtoOfGetCityListOnlyDto {
    items!: GetCityListOnlyDto[] | undefined;

    constructor(data?: IListResultDtoOfGetCityListOnlyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetCityListOnlyDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetCityListOnlyDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetCityListOnlyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetCityListOnlyDto {
    items: GetCityListOnlyDto[] | undefined;
}

export class PostalCodeDto implements IPostalCodeDto {
    country!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    value!: string | undefined;
    id!: number;

    constructor(data?: IPostalCodeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.country = data["country"];
            this.city = data["city"];
            this.state = data["state"];
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PostalCodeDto {
        data = typeof data === 'object' ? data : {};
        let result = new PostalCodeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["country"] = this.country;
        data["city"] = this.city;
        data["state"] = this.state;
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPostalCodeDto {
    country: string | undefined;
    city: string | undefined;
    state: string | undefined;
    value: string | undefined;
    id: number;
}

export class GetPostalCodeForViewDto implements IGetPostalCodeForViewDto {
    postalCode!: PostalCodeDto | undefined;

    constructor(data?: IGetPostalCodeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.postalCode = data["postalCode"] ? PostalCodeDto.fromJS(data["postalCode"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetPostalCodeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetPostalCodeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["postalCode"] = this.postalCode ? this.postalCode.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetPostalCodeForViewDto {
    postalCode: PostalCodeDto | undefined;
}

export class PagedResultDtoOfGetPostalCodeForViewDto implements IPagedResultDtoOfGetPostalCodeForViewDto {
    totalCount!: number;
    items!: GetPostalCodeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetPostalCodeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetPostalCodeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetPostalCodeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetPostalCodeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetPostalCodeForViewDto {
    totalCount: number;
    items: GetPostalCodeForViewDto[] | undefined;
}

export class CreateOrEditPostalCodeDto implements ICreateOrEditPostalCodeDto {
    country!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    value!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditPostalCodeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.country = data["country"];
            this.city = data["city"];
            this.state = data["state"];
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditPostalCodeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditPostalCodeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["country"] = this.country;
        data["city"] = this.city;
        data["state"] = this.state;
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditPostalCodeDto {
    country: string | undefined;
    city: string | undefined;
    state: string | undefined;
    value: string | undefined;
    id: number | undefined;
}

export class GetPostalCodeForEditOutput implements IGetPostalCodeForEditOutput {
    postalCode!: CreateOrEditPostalCodeDto | undefined;

    constructor(data?: IGetPostalCodeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.postalCode = data["postalCode"] ? CreateOrEditPostalCodeDto.fromJS(data["postalCode"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetPostalCodeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetPostalCodeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["postalCode"] = this.postalCode ? this.postalCode.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetPostalCodeForEditOutput {
    postalCode: CreateOrEditPostalCodeDto | undefined;
}

export class PostalCodeZoneListDto implements IPostalCodeZoneListDto {
    tenantId!: number;
    postalCodeId!: number;
    zoneId!: number;
    postalCodes!: PostalCodeListDto[] | undefined;
    zoneName!: string | undefined;
    postalCode!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    country!: string | undefined;
    zone!: ZoneListDto | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IPostalCodeZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.postalCodeId = data["postalCodeId"];
            this.zoneId = data["zoneId"];
            if (Array.isArray(data["postalCodes"])) {
                this.postalCodes = [] as any;
                for (let item of data["postalCodes"])
                    this.postalCodes!.push(PostalCodeListDto.fromJS(item));
            }
            this.zoneName = data["zoneName"];
            this.postalCode = data["postalCode"];
            this.city = data["city"];
            this.state = data["state"];
            this.country = data["country"];
            this.zone = data["zone"] ? ZoneListDto.fromJS(data["zone"]) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PostalCodeZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PostalCodeZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["postalCodeId"] = this.postalCodeId;
        data["zoneId"] = this.zoneId;
        if (Array.isArray(this.postalCodes)) {
            data["postalCodes"] = [];
            for (let item of this.postalCodes)
                data["postalCodes"].push(item.toJSON());
        }
        data["zoneName"] = this.zoneName;
        data["postalCode"] = this.postalCode;
        data["city"] = this.city;
        data["state"] = this.state;
        data["country"] = this.country;
        data["zone"] = this.zone ? this.zone.toJSON() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPostalCodeZoneListDto {
    tenantId: number;
    postalCodeId: number;
    zoneId: number;
    postalCodes: PostalCodeListDto[] | undefined;
    zoneName: string | undefined;
    postalCode: string | undefined;
    city: string | undefined;
    state: string | undefined;
    country: string | undefined;
    zone: ZoneListDto | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ListResultDtoOfPostalCodeZoneListDto implements IListResultDtoOfPostalCodeZoneListDto {
    items!: PostalCodeZoneListDto[] | undefined;

    constructor(data?: IListResultDtoOfPostalCodeZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(PostalCodeZoneListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfPostalCodeZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfPostalCodeZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfPostalCodeZoneListDto {
    items: PostalCodeZoneListDto[] | undefined;
}

export class GroupedPostalCodeZoneListDto implements IGroupedPostalCodeZoneListDto {
    id!: number;
    zoneId!: number;
    zoneName!: string | undefined;
    isPrimary!: boolean;
    postalCodes!: PostalCodeListDto[] | undefined;
    zones!: ZoneListDto[] | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;

    constructor(data?: IGroupedPostalCodeZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.zoneId = data["zoneId"];
            this.zoneName = data["zoneName"];
            this.isPrimary = data["isPrimary"];
            if (Array.isArray(data["postalCodes"])) {
                this.postalCodes = [] as any;
                for (let item of data["postalCodes"])
                    this.postalCodes!.push(PostalCodeListDto.fromJS(item));
            }
            if (Array.isArray(data["zones"])) {
                this.zones = [] as any;
                for (let item of data["zones"])
                    this.zones!.push(ZoneListDto.fromJS(item));
            }
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
        }
    }

    static fromJS(data: any): GroupedPostalCodeZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GroupedPostalCodeZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["zoneId"] = this.zoneId;
        data["zoneName"] = this.zoneName;
        data["isPrimary"] = this.isPrimary;
        if (Array.isArray(this.postalCodes)) {
            data["postalCodes"] = [];
            for (let item of this.postalCodes)
                data["postalCodes"].push(item.toJSON());
        }
        if (Array.isArray(this.zones)) {
            data["zones"] = [];
            for (let item of this.zones)
                data["zones"].push(item.toJSON());
        }
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        return data; 
    }
}

export interface IGroupedPostalCodeZoneListDto {
    id: number;
    zoneId: number;
    zoneName: string | undefined;
    isPrimary: boolean;
    postalCodes: PostalCodeListDto[] | undefined;
    zones: ZoneListDto[] | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
}

export class PagedResultDtoOfGroupedPostalCodeZoneListDto implements IPagedResultDtoOfGroupedPostalCodeZoneListDto {
    totalCount!: number;
    items!: GroupedPostalCodeZoneListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGroupedPostalCodeZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GroupedPostalCodeZoneListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGroupedPostalCodeZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGroupedPostalCodeZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGroupedPostalCodeZoneListDto {
    totalCount: number;
    items: GroupedPostalCodeZoneListDto[] | undefined;
}

export class CreatePostalCodeZoneInput implements ICreatePostalCodeZoneInput {
    postalCodeId!: number;
    zoneId!: number;

    constructor(data?: ICreatePostalCodeZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.postalCodeId = data["postalCodeId"];
            this.zoneId = data["zoneId"];
        }
    }

    static fromJS(data: any): CreatePostalCodeZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreatePostalCodeZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["postalCodeId"] = this.postalCodeId;
        data["zoneId"] = this.zoneId;
        return data; 
    }
}

export interface ICreatePostalCodeZoneInput {
    postalCodeId: number;
    zoneId: number;
}

export class UpdatePostalCodeZoneInput implements IUpdatePostalCodeZoneInput {
    id!: number;
    postalCodeId!: number;
    zoneId!: number;

    constructor(data?: IUpdatePostalCodeZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.postalCodeId = data["postalCodeId"];
            this.zoneId = data["zoneId"];
        }
    }

    static fromJS(data: any): UpdatePostalCodeZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdatePostalCodeZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["postalCodeId"] = this.postalCodeId;
        data["zoneId"] = this.zoneId;
        return data; 
    }
}

export interface IUpdatePostalCodeZoneInput {
    id: number;
    postalCodeId: number;
    zoneId: number;
}

export class ToBeDeletedPostalCodeZonesInput implements IToBeDeletedPostalCodeZonesInput {
    postalCodeId!: number;
    zoneId!: number;

    constructor(data?: IToBeDeletedPostalCodeZonesInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.postalCodeId = data["postalCodeId"];
            this.zoneId = data["zoneId"];
        }
    }

    static fromJS(data: any): ToBeDeletedPostalCodeZonesInput {
        data = typeof data === 'object' ? data : {};
        let result = new ToBeDeletedPostalCodeZonesInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["postalCodeId"] = this.postalCodeId;
        data["zoneId"] = this.zoneId;
        return data; 
    }
}

export interface IToBeDeletedPostalCodeZonesInput {
    postalCodeId: number;
    zoneId: number;
}

export class ToBeCreatedPostalCodeZonesInput implements IToBeCreatedPostalCodeZonesInput {
    postalCodeId!: number | undefined;
    zoneId!: number | undefined;

    constructor(data?: IToBeCreatedPostalCodeZonesInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.postalCodeId = data["postalCodeId"];
            this.zoneId = data["zoneId"];
        }
    }

    static fromJS(data: any): ToBeCreatedPostalCodeZonesInput {
        data = typeof data === 'object' ? data : {};
        let result = new ToBeCreatedPostalCodeZonesInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["postalCodeId"] = this.postalCodeId;
        data["zoneId"] = this.zoneId;
        return data; 
    }
}

export interface IToBeCreatedPostalCodeZonesInput {
    postalCodeId: number | undefined;
    zoneId: number | undefined;
}

export class UpdatePostalCodeZonesInput implements IUpdatePostalCodeZonesInput {
    unselectedValues!: ToBeDeletedPostalCodeZonesInput[] | undefined;
    selectedValues!: ToBeCreatedPostalCodeZonesInput[] | undefined;

    constructor(data?: IUpdatePostalCodeZonesInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["unselectedValues"])) {
                this.unselectedValues = [] as any;
                for (let item of data["unselectedValues"])
                    this.unselectedValues!.push(ToBeDeletedPostalCodeZonesInput.fromJS(item));
            }
            if (Array.isArray(data["selectedValues"])) {
                this.selectedValues = [] as any;
                for (let item of data["selectedValues"])
                    this.selectedValues!.push(ToBeCreatedPostalCodeZonesInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UpdatePostalCodeZonesInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdatePostalCodeZonesInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.unselectedValues)) {
            data["unselectedValues"] = [];
            for (let item of this.unselectedValues)
                data["unselectedValues"].push(item.toJSON());
        }
        if (Array.isArray(this.selectedValues)) {
            data["selectedValues"] = [];
            for (let item of this.selectedValues)
                data["selectedValues"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUpdatePostalCodeZonesInput {
    unselectedValues: ToBeDeletedPostalCodeZonesInput[] | undefined;
    selectedValues: ToBeCreatedPostalCodeZonesInput[] | undefined;
}

export class CreateZoneInput implements ICreateZoneInput {
    name!: string;
    locationId!: number;
    isPrimary!: boolean;

    constructor(data?: ICreateZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.locationId = data["locationId"];
            this.isPrimary = data["isPrimary"];
        }
    }

    static fromJS(data: any): CreateZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["locationId"] = this.locationId;
        data["isPrimary"] = this.isPrimary;
        return data; 
    }
}

export interface ICreateZoneInput {
    name: string;
    locationId: number;
    isPrimary: boolean;
}

export class CreateOrEditPostalCodeZoneDto implements ICreateOrEditPostalCodeZoneDto {
    newPostalCodeZone!: boolean | undefined;
    locationId!: number;
    createPostalCodeInput!: CreatePostalCodeInput[] | undefined;
    createZoneInput!: CreateZoneInput[] | undefined;

    constructor(data?: ICreateOrEditPostalCodeZoneDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.newPostalCodeZone = data["newPostalCodeZone"];
            this.locationId = data["locationId"];
            if (Array.isArray(data["createPostalCodeInput"])) {
                this.createPostalCodeInput = [] as any;
                for (let item of data["createPostalCodeInput"])
                    this.createPostalCodeInput!.push(CreatePostalCodeInput.fromJS(item));
            }
            if (Array.isArray(data["createZoneInput"])) {
                this.createZoneInput = [] as any;
                for (let item of data["createZoneInput"])
                    this.createZoneInput!.push(CreateZoneInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateOrEditPostalCodeZoneDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditPostalCodeZoneDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["newPostalCodeZone"] = this.newPostalCodeZone;
        data["locationId"] = this.locationId;
        if (Array.isArray(this.createPostalCodeInput)) {
            data["createPostalCodeInput"] = [];
            for (let item of this.createPostalCodeInput)
                data["createPostalCodeInput"].push(item.toJSON());
        }
        if (Array.isArray(this.createZoneInput)) {
            data["createZoneInput"] = [];
            for (let item of this.createZoneInput)
                data["createZoneInput"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateOrEditPostalCodeZoneDto {
    newPostalCodeZone: boolean | undefined;
    locationId: number;
    createPostalCodeInput: CreatePostalCodeInput[] | undefined;
    createZoneInput: CreateZoneInput[] | undefined;
}

export class GetPreferenceForViewDto implements IGetPreferenceForViewDto {
    preference!: PreferenceDtos | undefined;

    constructor(data?: IGetPreferenceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.preference = data["preference"] ? PreferenceDtos.fromJS(data["preference"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetPreferenceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetPreferenceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["preference"] = this.preference ? this.preference.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetPreferenceForViewDto {
    preference: PreferenceDtos | undefined;
}

export class PagedResultDtoOfGetPreferenceForViewDto implements IPagedResultDtoOfGetPreferenceForViewDto {
    totalCount!: number;
    items!: GetPreferenceForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetPreferenceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetPreferenceForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetPreferenceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetPreferenceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetPreferenceForViewDto {
    totalCount: number;
    items: GetPreferenceForViewDto[] | undefined;
}

export class CreateOrEditPreferenceDto implements ICreateOrEditPreferenceDto {
    code!: string | undefined;
    description!: string | undefined;
    value!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditPreferenceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditPreferenceDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditPreferenceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditPreferenceDto {
    code: string | undefined;
    description: string | undefined;
    value: number;
    id: number | undefined;
}

export class GetPreferenceForEditOutput implements IGetPreferenceForEditOutput {
    preference!: CreateOrEditPreferenceDto | undefined;

    constructor(data?: IGetPreferenceForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.preference = data["preference"] ? CreateOrEditPreferenceDto.fromJS(data["preference"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetPreferenceForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetPreferenceForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["preference"] = this.preference ? this.preference.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetPreferenceForEditOutput {
    preference: CreateOrEditPreferenceDto | undefined;
}

export class CurrentUserProfileEditDto implements ICurrentUserProfileEditDto {
    name!: string;
    surname!: string;
    userName!: string;
    emailAddress!: string;
    phoneNumber!: string | undefined;
    isPhoneNumberConfirmed!: boolean;
    timezone!: string | undefined;
    qrCodeSetupImageUrl!: string | undefined;
    isGoogleAuthenticatorEnabled!: boolean;
    hasBackgroundImage!: boolean;
    recordCountPerPage!: number | undefined;

    constructor(data?: ICurrentUserProfileEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.surname = data["surname"];
            this.userName = data["userName"];
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
            this.isPhoneNumberConfirmed = data["isPhoneNumberConfirmed"];
            this.timezone = data["timezone"];
            this.qrCodeSetupImageUrl = data["qrCodeSetupImageUrl"];
            this.isGoogleAuthenticatorEnabled = data["isGoogleAuthenticatorEnabled"];
            this.hasBackgroundImage = data["hasBackgroundImage"];
            this.recordCountPerPage = data["recordCountPerPage"];
        }
    }

    static fromJS(data: any): CurrentUserProfileEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new CurrentUserProfileEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["userName"] = this.userName;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        data["isPhoneNumberConfirmed"] = this.isPhoneNumberConfirmed;
        data["timezone"] = this.timezone;
        data["qrCodeSetupImageUrl"] = this.qrCodeSetupImageUrl;
        data["isGoogleAuthenticatorEnabled"] = this.isGoogleAuthenticatorEnabled;
        data["hasBackgroundImage"] = this.hasBackgroundImage;
        data["recordCountPerPage"] = this.recordCountPerPage;
        return data; 
    }
}

export interface ICurrentUserProfileEditDto {
    name: string;
    surname: string;
    userName: string;
    emailAddress: string;
    phoneNumber: string | undefined;
    isPhoneNumberConfirmed: boolean;
    timezone: string | undefined;
    qrCodeSetupImageUrl: string | undefined;
    isGoogleAuthenticatorEnabled: boolean;
    hasBackgroundImage: boolean;
    recordCountPerPage: number | undefined;
}

export class UpdateGoogleAuthenticatorKeyOutput implements IUpdateGoogleAuthenticatorKeyOutput {
    qrCodeSetupImageUrl!: string | undefined;

    constructor(data?: IUpdateGoogleAuthenticatorKeyOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.qrCodeSetupImageUrl = data["qrCodeSetupImageUrl"];
        }
    }

    static fromJS(data: any): UpdateGoogleAuthenticatorKeyOutput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateGoogleAuthenticatorKeyOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["qrCodeSetupImageUrl"] = this.qrCodeSetupImageUrl;
        return data; 
    }
}

export interface IUpdateGoogleAuthenticatorKeyOutput {
    qrCodeSetupImageUrl: string | undefined;
}

export class SendVerificationSmsInputDto implements ISendVerificationSmsInputDto {
    phoneNumber!: string | undefined;

    constructor(data?: ISendVerificationSmsInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.phoneNumber = data["phoneNumber"];
        }
    }

    static fromJS(data: any): SendVerificationSmsInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new SendVerificationSmsInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["phoneNumber"] = this.phoneNumber;
        return data; 
    }
}

export interface ISendVerificationSmsInputDto {
    phoneNumber: string | undefined;
}

export class VerifySmsCodeInputDto implements IVerifySmsCodeInputDto {
    code!: string | undefined;
    phoneNumber!: string | undefined;

    constructor(data?: IVerifySmsCodeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.phoneNumber = data["phoneNumber"];
        }
    }

    static fromJS(data: any): VerifySmsCodeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new VerifySmsCodeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["phoneNumber"] = this.phoneNumber;
        return data; 
    }
}

export interface IVerifySmsCodeInputDto {
    code: string | undefined;
    phoneNumber: string | undefined;
}

export class ChangePasswordInput implements IChangePasswordInput {
    currentPassword!: string;
    newPassword!: string;

    constructor(data?: IChangePasswordInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.currentPassword = data["currentPassword"];
            this.newPassword = data["newPassword"];
        }
    }

    static fromJS(data: any): ChangePasswordInput {
        data = typeof data === 'object' ? data : {};
        let result = new ChangePasswordInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["currentPassword"] = this.currentPassword;
        data["newPassword"] = this.newPassword;
        return data; 
    }
}

export interface IChangePasswordInput {
    currentPassword: string;
    newPassword: string;
}

export class UpdateProfilePictureInput implements IUpdateProfilePictureInput {
    fileToken!: string;
    x!: number;
    y!: number;
    width!: number;
    height!: number;

    constructor(data?: IUpdateProfilePictureInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileToken = data["fileToken"];
            this.x = data["x"];
            this.y = data["y"];
            this.width = data["width"];
            this.height = data["height"];
        }
    }

    static fromJS(data: any): UpdateProfilePictureInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateProfilePictureInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileToken"] = this.fileToken;
        data["x"] = this.x;
        data["y"] = this.y;
        data["width"] = this.width;
        data["height"] = this.height;
        return data; 
    }
}

export interface IUpdateProfilePictureInput {
    fileToken: string;
    x: number;
    y: number;
    width: number;
    height: number;
}

export class GetPasswordComplexitySettingOutput implements IGetPasswordComplexitySettingOutput {
    setting!: PasswordComplexitySetting | undefined;

    constructor(data?: IGetPasswordComplexitySettingOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.setting = data["setting"] ? PasswordComplexitySetting.fromJS(data["setting"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetPasswordComplexitySettingOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetPasswordComplexitySettingOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["setting"] = this.setting ? this.setting.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetPasswordComplexitySettingOutput {
    setting: PasswordComplexitySetting | undefined;
}

export class GetProfilePictureOutput implements IGetProfilePictureOutput {
    profilePicture!: string | undefined;

    constructor(data?: IGetProfilePictureOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.profilePicture = data["profilePicture"];
        }
    }

    static fromJS(data: any): GetProfilePictureOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetProfilePictureOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["profilePicture"] = this.profilePicture;
        return data; 
    }
}

export interface IGetProfilePictureOutput {
    profilePicture: string | undefined;
}

export class ChangeUserLanguageDto implements IChangeUserLanguageDto {
    languageName!: string;

    constructor(data?: IChangeUserLanguageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.languageName = data["languageName"];
        }
    }

    static fromJS(data: any): ChangeUserLanguageDto {
        data = typeof data === 'object' ? data : {};
        let result = new ChangeUserLanguageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["languageName"] = this.languageName;
        return data; 
    }
}

export interface IChangeUserLanguageDto {
    languageName: string;
}

export class UploadMobilePhotoInputDto implements IUploadMobilePhotoInputDto {
    data!: string | undefined;

    constructor(data?: IUploadMobilePhotoInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.data = data["data"];
        }
    }

    static fromJS(data: any): UploadMobilePhotoInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new UploadMobilePhotoInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["data"] = this.data;
        return data; 
    }
}

export interface IUploadMobilePhotoInputDto {
    data: string | undefined;
}

export class EditMobileProfileInputDto implements IEditMobileProfileInputDto {
    name!: string | undefined;
    surname!: string | undefined;
    emailAddress!: string | undefined;
    phoneNumber!: string | undefined;

    constructor(data?: IEditMobileProfileInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.surname = data["surname"];
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
        }
    }

    static fromJS(data: any): EditMobileProfileInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new EditMobileProfileInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        return data; 
    }
}

export interface IEditMobileProfileInputDto {
    name: string | undefined;
    surname: string | undefined;
    emailAddress: string | undefined;
    phoneNumber: string | undefined;
}

export class EditMobilePasswordInputDto implements IEditMobilePasswordInputDto {
    newPassword!: string | undefined;

    constructor(data?: IEditMobilePasswordInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.newPassword = data["newPassword"];
        }
    }

    static fromJS(data: any): EditMobilePasswordInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new EditMobilePasswordInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["newPassword"] = this.newPassword;
        return data; 
    }
}

export interface IEditMobilePasswordInputDto {
    newPassword: string | undefined;
}

export class CreateProximityInput implements ICreateProximityInput {
    addressTypeId!: number | undefined;
    locationId!: number | undefined;
    value!: number;

    constructor(data?: ICreateProximityInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressTypeId = data["addressTypeId"];
            this.locationId = data["locationId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreateProximityInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateProximityInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressTypeId"] = this.addressTypeId;
        data["locationId"] = this.locationId;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreateProximityInput {
    addressTypeId: number | undefined;
    locationId: number | undefined;
    value: number;
}

export class ProximityListDto implements IProximityListDto {
    id!: number;
    locationId!: number | undefined;
    location!: LocationListDto | undefined;
    addressTypeId!: number | undefined;
    addressType!: AddressTypeListDto | undefined;
    value!: number;

    constructor(data?: IProximityListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.locationId = data["locationId"];
            this.location = data["location"] ? LocationListDto.fromJS(data["location"]) : <any>undefined;
            this.addressTypeId = data["addressTypeId"];
            this.addressType = data["addressType"] ? AddressTypeListDto.fromJS(data["addressType"]) : <any>undefined;
            this.value = data["value"];
        }
    }

    static fromJS(data: any): ProximityListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ProximityListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["locationId"] = this.locationId;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["addressTypeId"] = this.addressTypeId;
        data["addressType"] = this.addressType ? this.addressType.toJSON() : <any>undefined;
        data["value"] = this.value;
        return data; 
    }
}

export interface IProximityListDto {
    id: number;
    locationId: number | undefined;
    location: LocationListDto | undefined;
    addressTypeId: number | undefined;
    addressType: AddressTypeListDto | undefined;
    value: number;
}

export class PagedResultDtoOfProximityListDto implements IPagedResultDtoOfProximityListDto {
    totalCount!: number;
    items!: ProximityListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfProximityListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ProximityListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfProximityListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfProximityListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfProximityListDto {
    totalCount: number;
    items: ProximityListDto[] | undefined;
}

export class UpdateProximityInput implements IUpdateProximityInput {
    id!: number;
    locationId!: number;
    addressTypeId!: number;
    value!: number;

    constructor(data?: IUpdateProximityInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.locationId = data["locationId"];
            this.addressTypeId = data["addressTypeId"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): UpdateProximityInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateProximityInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["locationId"] = this.locationId;
        data["addressTypeId"] = this.addressTypeId;
        data["value"] = this.value;
        return data; 
    }
}

export interface IUpdateProximityInput {
    id: number;
    locationId: number;
    addressTypeId: number;
    value: number;
}

export class OrderSourceRate implements IOrderSourceRate {
    id!: number;
    name!: string | undefined;

    constructor(data?: IOrderSourceRate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): OrderSourceRate {
        data = typeof data === 'object' ? data : {};
        let result = new OrderSourceRate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IOrderSourceRate {
    id: number;
    name: string | undefined;
}

export class RateTypeList implements IRateTypeList {
    id!: number;
    name!: string | undefined;

    constructor(data?: IRateTypeList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): RateTypeList {
        data = typeof data === 'object' ? data : {};
        let result = new RateTypeList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IRateTypeList {
    id: number;
    name: string | undefined;
}

export class RuleList implements IRuleList {
    id!: number;
    name!: string | undefined;

    constructor(data?: IRuleList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): RuleList {
        data = typeof data === 'object' ? data : {};
        let result = new RuleList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IRuleList {
    id: number;
    name: string | undefined;
}

export enum RateType {
    HOURLY = 0,
    DAILY = 1,
    WEEKLY = 2,
    MONTHLY = 3,
    MILEAGE = 4,
    PACKAGE_COUNT = 5,
    PACKAGE_WEIGHT = 6,
    PACKAGE_DIMENSION = 7,
    STOP = 8,
    ROUTE = 9,
    ROUTE_SCHEDULE = 10,
    MISCELLANEOUS = 11,
    EXCESS = 12,
}

export enum Rule {
    FIXED = 0,
    RANGE = 1,
    MULTIPLIER = 2,
}

export class RateRuleDto implements IRateRuleDto {
    id!: number | undefined;
    tenantId!: number | undefined;
    minAmount!: number | undefined;
    maxAmount!: number | undefined;
    amount!: number | undefined;
    rateAmount!: number | undefined;
    rateId!: number;
    rateTypeStr!: string | undefined;
    rateType!: RateType;
    rule!: Rule;
    ruleStr!: string | undefined;

    constructor(data?: IRateRuleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.minAmount = data["minAmount"];
            this.maxAmount = data["maxAmount"];
            this.amount = data["amount"];
            this.rateAmount = data["rateAmount"];
            this.rateId = data["rateId"];
            this.rateTypeStr = data["rateTypeStr"];
            this.rateType = data["rateType"];
            this.rule = data["rule"];
            this.ruleStr = data["ruleStr"];
        }
    }

    static fromJS(data: any): RateRuleDto {
        data = typeof data === 'object' ? data : {};
        let result = new RateRuleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["minAmount"] = this.minAmount;
        data["maxAmount"] = this.maxAmount;
        data["amount"] = this.amount;
        data["rateAmount"] = this.rateAmount;
        data["rateId"] = this.rateId;
        data["rateTypeStr"] = this.rateTypeStr;
        data["rateType"] = this.rateType;
        data["rule"] = this.rule;
        data["ruleStr"] = this.ruleStr;
        return data; 
    }
}

export interface IRateRuleDto {
    id: number | undefined;
    tenantId: number | undefined;
    minAmount: number | undefined;
    maxAmount: number | undefined;
    amount: number | undefined;
    rateAmount: number | undefined;
    rateId: number;
    rateTypeStr: string | undefined;
    rateType: RateType;
    rule: Rule;
    ruleStr: string | undefined;
}

export class CreateOrEditRateInput implements ICreateOrEditRateInput {
    id!: number | undefined;
    tenantId!: number | undefined;
    locationId!: number | undefined;
    locationName!: string | undefined;
    orderSourceId!: number | undefined;
    orderSourceName!: string | undefined;
    description!: string | undefined;
    inActive!: boolean;
    rateRules!: RateRuleDto[] | undefined;

    constructor(data?: ICreateOrEditRateInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.locationId = data["locationId"];
            this.locationName = data["locationName"];
            this.orderSourceId = data["orderSourceId"];
            this.orderSourceName = data["orderSourceName"];
            this.description = data["description"];
            this.inActive = data["inActive"];
            if (Array.isArray(data["rateRules"])) {
                this.rateRules = [] as any;
                for (let item of data["rateRules"])
                    this.rateRules!.push(RateRuleDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateOrEditRateInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRateInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["locationId"] = this.locationId;
        data["locationName"] = this.locationName;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSourceName"] = this.orderSourceName;
        data["description"] = this.description;
        data["inActive"] = this.inActive;
        if (Array.isArray(this.rateRules)) {
            data["rateRules"] = [];
            for (let item of this.rateRules)
                data["rateRules"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateOrEditRateInput {
    id: number | undefined;
    tenantId: number | undefined;
    locationId: number | undefined;
    locationName: string | undefined;
    orderSourceId: number | undefined;
    orderSourceName: string | undefined;
    description: string | undefined;
    inActive: boolean;
    rateRules: RateRuleDto[] | undefined;
}

export class GetRateForEditOutput implements IGetRateForEditOutput {
    rate!: CreateOrEditRateInput | undefined;

    constructor(data?: IGetRateForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.rate = data["rate"] ? CreateOrEditRateInput.fromJS(data["rate"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRateForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRateForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["rate"] = this.rate ? this.rate.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRateForEditOutput {
    rate: CreateOrEditRateInput | undefined;
}

export class RateDto implements IRateDto {
    id!: number | undefined;
    tenantId!: number | undefined;
    locationId!: number | undefined;
    locationName!: string | undefined;
    orderSourceId!: number | undefined;
    orderSourceName!: string | undefined;
    description!: string | undefined;
    inActive!: boolean;
    rateRules!: RateRuleDto[] | undefined;

    constructor(data?: IRateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.locationId = data["locationId"];
            this.locationName = data["locationName"];
            this.orderSourceId = data["orderSourceId"];
            this.orderSourceName = data["orderSourceName"];
            this.description = data["description"];
            this.inActive = data["inActive"];
            if (Array.isArray(data["rateRules"])) {
                this.rateRules = [] as any;
                for (let item of data["rateRules"])
                    this.rateRules!.push(RateRuleDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): RateDto {
        data = typeof data === 'object' ? data : {};
        let result = new RateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["locationId"] = this.locationId;
        data["locationName"] = this.locationName;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSourceName"] = this.orderSourceName;
        data["description"] = this.description;
        data["inActive"] = this.inActive;
        if (Array.isArray(this.rateRules)) {
            data["rateRules"] = [];
            for (let item of this.rateRules)
                data["rateRules"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IRateDto {
    id: number | undefined;
    tenantId: number | undefined;
    locationId: number | undefined;
    locationName: string | undefined;
    orderSourceId: number | undefined;
    orderSourceName: string | undefined;
    description: string | undefined;
    inActive: boolean;
    rateRules: RateRuleDto[] | undefined;
}

export class PagedResultDtoOfRateDto implements IPagedResultDtoOfRateDto {
    totalCount!: number;
    items!: RateDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RateDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRateDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRateDto {
    totalCount: number;
    items: RateDto[] | undefined;
}

export class DriverRateDto implements IDriverRateDto {
    id!: number | undefined;
    driverId!: number | undefined;
    driverName!: string | undefined;
    tenantId!: number | undefined;
    rate!: number | undefined;
    routeId!: number | undefined;
    routeTemplateId!: number | undefined;
    routeName!: string | undefined;
    loadLimit!: number | undefined;
    excessLoad!: number | undefined;
    stopChange!: number;
    changeRate!: number | undefined;
    changeAmount!: number | undefined;
    total!: number | undefined;
    orderSourceId!: number | undefined;
    orderSourceName!: string | undefined;
    fleetId!: number | undefined;
    fleetName!: string | undefined;
    locationId!: number | undefined;
    locationName!: string | undefined;

    constructor(data?: IDriverRateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.driverId = data["driverId"];
            this.driverName = data["driverName"];
            this.tenantId = data["tenantId"];
            this.rate = data["rate"];
            this.routeId = data["routeId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.routeName = data["routeName"];
            this.loadLimit = data["loadLimit"];
            this.excessLoad = data["excessLoad"];
            this.stopChange = data["stopChange"];
            this.changeRate = data["changeRate"];
            this.changeAmount = data["changeAmount"];
            this.total = data["total"];
            this.orderSourceId = data["orderSourceId"];
            this.orderSourceName = data["orderSourceName"];
            this.fleetId = data["fleetId"];
            this.fleetName = data["fleetName"];
            this.locationId = data["locationId"];
            this.locationName = data["locationName"];
        }
    }

    static fromJS(data: any): DriverRateDto {
        data = typeof data === 'object' ? data : {};
        let result = new DriverRateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["driverId"] = this.driverId;
        data["driverName"] = this.driverName;
        data["tenantId"] = this.tenantId;
        data["rate"] = this.rate;
        data["routeId"] = this.routeId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeName"] = this.routeName;
        data["loadLimit"] = this.loadLimit;
        data["excessLoad"] = this.excessLoad;
        data["stopChange"] = this.stopChange;
        data["changeRate"] = this.changeRate;
        data["changeAmount"] = this.changeAmount;
        data["total"] = this.total;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSourceName"] = this.orderSourceName;
        data["fleetId"] = this.fleetId;
        data["fleetName"] = this.fleetName;
        data["locationId"] = this.locationId;
        data["locationName"] = this.locationName;
        return data; 
    }
}

export interface IDriverRateDto {
    id: number | undefined;
    driverId: number | undefined;
    driverName: string | undefined;
    tenantId: number | undefined;
    rate: number | undefined;
    routeId: number | undefined;
    routeTemplateId: number | undefined;
    routeName: string | undefined;
    loadLimit: number | undefined;
    excessLoad: number | undefined;
    stopChange: number;
    changeRate: number | undefined;
    changeAmount: number | undefined;
    total: number | undefined;
    orderSourceId: number | undefined;
    orderSourceName: string | undefined;
    fleetId: number | undefined;
    fleetName: string | undefined;
    locationId: number | undefined;
    locationName: string | undefined;
}

export class PagedResultDtoOfDriverRateDto implements IPagedResultDtoOfDriverRateDto {
    totalCount!: number;
    items!: DriverRateDto[] | undefined;

    constructor(data?: IPagedResultDtoOfDriverRateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(DriverRateDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfDriverRateDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfDriverRateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfDriverRateDto {
    totalCount: number;
    items: DriverRateDto[] | undefined;
}

export class GetRealTimeEtaDto implements IGetRealTimeEtaDto {
    routeId!: number | undefined;
    realTimeETA!: number;

    constructor(data?: IGetRealTimeEtaDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.realTimeETA = data["realTimeETA"];
        }
    }

    static fromJS(data: any): GetRealTimeEtaDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRealTimeEtaDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["realTimeETA"] = this.realTimeETA;
        return data; 
    }
}

export interface IGetRealTimeEtaDto {
    routeId: number | undefined;
    realTimeETA: number;
}

export class RecurringOrderScheduleDto implements IRecurringOrderScheduleDto {
    code!: string | undefined;
    description!: string | undefined;
    timezone!: string | undefined;
    startDate!: moment.Moment;
    startDateString!: string | undefined;
    repeat!: string | undefined;
    endDate!: moment.Moment | undefined;
    endDateString!: string | undefined;
    id!: number;

    constructor(data?: IRecurringOrderScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.timezone = data["timezone"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.startDateString = data["startDateString"];
            this.repeat = data["repeat"];
            this.endDate = data["endDate"] ? moment(data["endDate"].toString()) : <any>undefined;
            this.endDateString = data["endDateString"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RecurringOrderScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new RecurringOrderScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["timezone"] = this.timezone;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["startDateString"] = this.startDateString;
        data["repeat"] = this.repeat;
        data["endDate"] = this.endDate ? this.endDate.toISOString() : <any>undefined;
        data["endDateString"] = this.endDateString;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRecurringOrderScheduleDto {
    code: string | undefined;
    description: string | undefined;
    timezone: string | undefined;
    startDate: moment.Moment;
    startDateString: string | undefined;
    repeat: string | undefined;
    endDate: moment.Moment | undefined;
    endDateString: string | undefined;
    id: number;
}

export class GetRecurringOrderScheduleForViewDto implements IGetRecurringOrderScheduleForViewDto {
    recurringOrderSchedule!: RecurringOrderScheduleDto | undefined;

    constructor(data?: IGetRecurringOrderScheduleForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.recurringOrderSchedule = data["recurringOrderSchedule"] ? RecurringOrderScheduleDto.fromJS(data["recurringOrderSchedule"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRecurringOrderScheduleForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRecurringOrderScheduleForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["recurringOrderSchedule"] = this.recurringOrderSchedule ? this.recurringOrderSchedule.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRecurringOrderScheduleForViewDto {
    recurringOrderSchedule: RecurringOrderScheduleDto | undefined;
}

export class PagedResultDtoOfGetRecurringOrderScheduleForViewDto implements IPagedResultDtoOfGetRecurringOrderScheduleForViewDto {
    totalCount!: number;
    items!: GetRecurringOrderScheduleForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRecurringOrderScheduleForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRecurringOrderScheduleForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRecurringOrderScheduleForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRecurringOrderScheduleForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRecurringOrderScheduleForViewDto {
    totalCount: number;
    items: GetRecurringOrderScheduleForViewDto[] | undefined;
}

export class CreateOrEditRecurringOrderScheduleDto implements ICreateOrEditRecurringOrderScheduleDto {
    id!: number | undefined;
    code!: string;
    description!: string;
    timezone!: string;
    startDate!: moment.Moment;
    startTime!: string | undefined;
    repeat!: string;
    endDate!: moment.Moment | undefined;
    endTime!: string | undefined;

    constructor(data?: ICreateOrEditRecurringOrderScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.timezone = data["timezone"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.startTime = data["startTime"];
            this.repeat = data["repeat"];
            this.endDate = data["endDate"] ? moment(data["endDate"].toString()) : <any>undefined;
            this.endTime = data["endTime"];
        }
    }

    static fromJS(data: any): CreateOrEditRecurringOrderScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRecurringOrderScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["timezone"] = this.timezone;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["startTime"] = this.startTime;
        data["repeat"] = this.repeat;
        data["endDate"] = this.endDate ? this.endDate.toISOString() : <any>undefined;
        data["endTime"] = this.endTime;
        return data; 
    }
}

export interface ICreateOrEditRecurringOrderScheduleDto {
    id: number | undefined;
    code: string;
    description: string;
    timezone: string;
    startDate: moment.Moment;
    startTime: string | undefined;
    repeat: string;
    endDate: moment.Moment | undefined;
    endTime: string | undefined;
}

export class GetRecurringOrderScheduleForEditOutput implements IGetRecurringOrderScheduleForEditOutput {
    recurringOrderSchedule!: CreateOrEditRecurringOrderScheduleDto | undefined;

    constructor(data?: IGetRecurringOrderScheduleForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.recurringOrderSchedule = data["recurringOrderSchedule"] ? CreateOrEditRecurringOrderScheduleDto.fromJS(data["recurringOrderSchedule"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRecurringOrderScheduleForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRecurringOrderScheduleForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["recurringOrderSchedule"] = this.recurringOrderSchedule ? this.recurringOrderSchedule.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRecurringOrderScheduleForEditOutput {
    recurringOrderSchedule: CreateOrEditRecurringOrderScheduleDto | undefined;
}

export class UpdateRecurringScheduleIdInput implements IUpdateRecurringScheduleIdInput {
    orderIds!: number[] | undefined;
    recurringOrderScheduleId!: number;

    constructor(data?: IUpdateRecurringScheduleIdInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["orderIds"])) {
                this.orderIds = [] as any;
                for (let item of data["orderIds"])
                    this.orderIds!.push(item);
            }
            this.recurringOrderScheduleId = data["recurringOrderScheduleId"];
        }
    }

    static fromJS(data: any): UpdateRecurringScheduleIdInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRecurringScheduleIdInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.orderIds)) {
            data["orderIds"] = [];
            for (let item of this.orderIds)
                data["orderIds"].push(item);
        }
        data["recurringOrderScheduleId"] = this.recurringOrderScheduleId;
        return data; 
    }
}

export interface IUpdateRecurringScheduleIdInput {
    orderIds: number[] | undefined;
    recurringOrderScheduleId: number;
}

export class RecurringOrderSchedule implements IRecurringOrderSchedule {
    tenantId!: number | undefined;
    code!: string;
    description!: string;
    timezone!: string;
    startDate!: moment.Moment;
    repeat!: string;
    endDate!: moment.Moment | undefined;
    lastRunDate!: moment.Moment | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRecurringOrderSchedule) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.description = data["description"];
            this.timezone = data["timezone"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.repeat = data["repeat"];
            this.endDate = data["endDate"] ? moment(data["endDate"].toString()) : <any>undefined;
            this.lastRunDate = data["lastRunDate"] ? moment(data["lastRunDate"].toString()) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RecurringOrderSchedule {
        data = typeof data === 'object' ? data : {};
        let result = new RecurringOrderSchedule();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["description"] = this.description;
        data["timezone"] = this.timezone;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["repeat"] = this.repeat;
        data["endDate"] = this.endDate ? this.endDate.toISOString() : <any>undefined;
        data["lastRunDate"] = this.lastRunDate ? this.lastRunDate.toISOString() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRecurringOrderSchedule {
    tenantId: number | undefined;
    code: string;
    description: string;
    timezone: string;
    startDate: moment.Moment;
    repeat: string;
    endDate: moment.Moment | undefined;
    lastRunDate: moment.Moment | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class TenantIdList implements ITenantIdList {
    id!: number | undefined;
    tenantName!: string | undefined;

    constructor(data?: ITenantIdList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantName = data["tenantName"];
        }
    }

    static fromJS(data: any): TenantIdList {
        data = typeof data === 'object' ? data : {};
        let result = new TenantIdList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantName"] = this.tenantName;
        return data; 
    }
}

export interface ITenantIdList {
    id: number | undefined;
    tenantName: string | undefined;
}

export class ReportLogList implements IReportLogList {
    id!: number | undefined;
    reportName!: string | undefined;
    createdBy!: string | undefined;
    createdWhen!: string | undefined;
    duration!: number;
    errorMessage!: string | undefined;

    constructor(data?: IReportLogList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.reportName = data["reportName"];
            this.createdBy = data["createdBy"];
            this.createdWhen = data["createdWhen"];
            this.duration = data["duration"];
            this.errorMessage = data["errorMessage"];
        }
    }

    static fromJS(data: any): ReportLogList {
        data = typeof data === 'object' ? data : {};
        let result = new ReportLogList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["reportName"] = this.reportName;
        data["createdBy"] = this.createdBy;
        data["createdWhen"] = this.createdWhen;
        data["duration"] = this.duration;
        data["errorMessage"] = this.errorMessage;
        return data; 
    }
}

export interface IReportLogList {
    id: number | undefined;
    reportName: string | undefined;
    createdBy: string | undefined;
    createdWhen: string | undefined;
    duration: number;
    errorMessage: string | undefined;
}

export class PagedResultDtoOfReportLogList implements IPagedResultDtoOfReportLogList {
    totalCount!: number;
    items!: ReportLogList[] | undefined;

    constructor(data?: IPagedResultDtoOfReportLogList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ReportLogList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfReportLogList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfReportLogList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfReportLogList {
    totalCount: number;
    items: ReportLogList[] | undefined;
}

export class CreateReportLogDto implements ICreateReportLogDto {
    reportId!: number;
    errorMessage!: string | undefined;
    duration!: number;

    constructor(data?: ICreateReportLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.reportId = data["reportId"];
            this.errorMessage = data["errorMessage"];
            this.duration = data["duration"];
        }
    }

    static fromJS(data: any): CreateReportLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateReportLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["reportId"] = this.reportId;
        data["errorMessage"] = this.errorMessage;
        data["duration"] = this.duration;
        return data; 
    }
}

export interface ICreateReportLogDto {
    reportId: number;
    errorMessage: string | undefined;
    duration: number;
}

export class UploadReport implements IUploadReport {
    name!: string | undefined;
    base64EncodedData!: string | undefined;

    constructor(data?: IUploadReport) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.base64EncodedData = data["base64EncodedData"];
        }
    }

    static fromJS(data: any): UploadReport {
        data = typeof data === 'object' ? data : {};
        let result = new UploadReport();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["base64EncodedData"] = this.base64EncodedData;
        return data; 
    }
}

export interface IUploadReport {
    name: string | undefined;
    base64EncodedData: string | undefined;
}

export class ReportList implements IReportList {
    id!: number | undefined;
    name!: string | undefined;
    createdBy!: string | undefined;
    createdWhen!: string | undefined;
    modifiedWhen!: string | undefined;
    modifiedBy!: string | undefined;
    inactive!: boolean;

    constructor(data?: IReportList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.createdBy = data["createdBy"];
            this.createdWhen = data["createdWhen"];
            this.modifiedWhen = data["modifiedWhen"];
            this.modifiedBy = data["modifiedBy"];
            this.inactive = data["inactive"];
        }
    }

    static fromJS(data: any): ReportList {
        data = typeof data === 'object' ? data : {};
        let result = new ReportList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["createdBy"] = this.createdBy;
        data["createdWhen"] = this.createdWhen;
        data["modifiedWhen"] = this.modifiedWhen;
        data["modifiedBy"] = this.modifiedBy;
        data["inactive"] = this.inactive;
        return data; 
    }
}

export interface IReportList {
    id: number | undefined;
    name: string | undefined;
    createdBy: string | undefined;
    createdWhen: string | undefined;
    modifiedWhen: string | undefined;
    modifiedBy: string | undefined;
    inactive: boolean;
}

export class PagedResultDtoOfReportList implements IPagedResultDtoOfReportList {
    totalCount!: number;
    items!: ReportList[] | undefined;

    constructor(data?: IPagedResultDtoOfReportList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ReportList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfReportList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfReportList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfReportList {
    totalCount: number;
    items: ReportList[] | undefined;
}

export class Reports implements IReports {
    tenantId!: number | undefined;
    lastModifierUserId!: number | undefined;
    name!: string;
    code!: string;
    inactive!: boolean;
    data!: string;
    base64EncodedData!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IReports) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.lastModifierUserId = data["lastModifierUserId"];
            this.name = data["name"];
            this.code = data["code"];
            this.inactive = data["inactive"];
            this.data = data["data"];
            this.base64EncodedData = data["base64EncodedData"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Reports {
        data = typeof data === 'object' ? data : {};
        let result = new Reports();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["inactive"] = this.inactive;
        data["data"] = this.data;
        data["base64EncodedData"] = this.base64EncodedData;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IReports {
    tenantId: number | undefined;
    lastModifierUserId: number | undefined;
    name: string;
    code: string;
    inactive: boolean;
    data: string;
    base64EncodedData: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class CurrentReportUser implements ICurrentReportUser {
    tenantId!: number | undefined;
    userId!: number | undefined;

    constructor(data?: ICurrentReportUser) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): CurrentReportUser {
        data = typeof data === 'object' ? data : {};
        let result = new CurrentReportUser();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface ICurrentReportUser {
    tenantId: number | undefined;
    userId: number | undefined;
}

export class QueryParameter implements IQueryParameter {
    name!: string | undefined;
    type!: Type | undefined;
    value!: any | undefined;
    valueInfo!: string | undefined;

    constructor(data?: IQueryParameter) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.type = data["type"] ? Type.fromJS(data["type"]) : <any>undefined;
            this.value = data["value"];
            this.valueInfo = data["valueInfo"];
        }
    }

    static fromJS(data: any): QueryParameter {
        data = typeof data === 'object' ? data : {};
        let result = new QueryParameter();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["type"] = this.type ? this.type.toJSON() : <any>undefined;
        data["value"] = this.value;
        data["valueInfo"] = this.valueInfo;
        return data; 
    }
}

export interface IQueryParameter {
    name: string | undefined;
    type: Type | undefined;
    value: any | undefined;
    valueInfo: string | undefined;
}

export class SqlQuery implements ISqlQuery {
    readonly parameters!: QueryParameter[] | undefined;
    name!: string | undefined;
    metaSerializable!: string | undefined;

    constructor(data?: ISqlQuery) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.name = "";
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["parameters"])) {
                (<any>this).parameters = [] as any;
                for (let item of data["parameters"])
                    (<any>this).parameters!.push(QueryParameter.fromJS(item));
            }
            this.name = data["name"] !== undefined ? data["name"] : "";
            this.metaSerializable = data["metaSerializable"];
        }
    }

    static fromJS(data: any): SqlQuery {
        data = typeof data === 'object' ? data : {};
        let result = new SqlQuery();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.parameters)) {
            data["parameters"] = [];
            for (let item of this.parameters)
                data["parameters"].push(item.toJSON());
        }
        data["name"] = this.name;
        data["metaSerializable"] = this.metaSerializable;
        return data; 
    }
}

export interface ISqlQuery {
    parameters: QueryParameter[] | undefined;
    name: string | undefined;
    metaSerializable: string | undefined;
}

export class IColumn implements IIColumn {
    readonly name!: string | undefined;
    readonly type!: Type | undefined;

    constructor(data?: IIColumn) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).name = data["name"];
            (<any>this).type = data["type"] ? Type.fromJS(data["type"]) : <any>undefined;
        }
    }

    static fromJS(data: any): IColumn {
        data = typeof data === 'object' ? data : {};
        let result = new IColumn();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["type"] = this.type ? this.type.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IIColumn {
    name: string | undefined;
    type: Type | undefined;
}

export class OrderTypeIdList implements IOrderTypeIdList {
    id!: number | undefined;
    name!: string | undefined;

    constructor(data?: IOrderTypeIdList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): OrderTypeIdList {
        data = typeof data === 'object' ? data : {};
        let result = new OrderTypeIdList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IOrderTypeIdList {
    id: number | undefined;
    name: string | undefined;
}

export class LocationIdList implements ILocationIdList {
    id!: number | undefined;
    name!: string | undefined;

    constructor(data?: ILocationIdList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): LocationIdList {
        data = typeof data === 'object' ? data : {};
        let result = new LocationIdList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface ILocationIdList {
    id: number | undefined;
    name: string | undefined;
}

export class DateWithTotalPackagesList implements IDateWithTotalPackagesList {
    deliveryDate!: moment.Moment;
    totalPackages!: number;
    deliveryDateString!: string | undefined;

    constructor(data?: IDateWithTotalPackagesList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.deliveryDate = data["deliveryDate"] ? moment(data["deliveryDate"].toString()) : <any>undefined;
            this.totalPackages = data["totalPackages"];
            this.deliveryDateString = data["deliveryDateString"];
        }
    }

    static fromJS(data: any): DateWithTotalPackagesList {
        data = typeof data === 'object' ? data : {};
        let result = new DateWithTotalPackagesList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["deliveryDate"] = this.deliveryDate ? this.deliveryDate.toISOString() : <any>undefined;
        data["totalPackages"] = this.totalPackages;
        data["deliveryDateString"] = this.deliveryDateString;
        return data; 
    }
}

export interface IDateWithTotalPackagesList {
    deliveryDate: moment.Moment;
    totalPackages: number;
    deliveryDateString: string | undefined;
}

export class ReportPackageByZipCodeDto implements IReportPackageByZipCodeDto {
    postalCodeId!: number;
    postalCode!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    packageList!: DateWithTotalPackagesList[] | undefined;

    constructor(data?: IReportPackageByZipCodeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.postalCodeId = data["postalCodeId"];
            this.postalCode = data["postalCode"];
            this.city = data["city"];
            this.state = data["state"];
            if (Array.isArray(data["packageList"])) {
                this.packageList = [] as any;
                for (let item of data["packageList"])
                    this.packageList!.push(DateWithTotalPackagesList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ReportPackageByZipCodeDto {
        data = typeof data === 'object' ? data : {};
        let result = new ReportPackageByZipCodeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["postalCodeId"] = this.postalCodeId;
        data["postalCode"] = this.postalCode;
        data["city"] = this.city;
        data["state"] = this.state;
        if (Array.isArray(this.packageList)) {
            data["packageList"] = [];
            for (let item of this.packageList)
                data["packageList"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IReportPackageByZipCodeDto {
    postalCodeId: number;
    postalCode: string | undefined;
    city: string | undefined;
    state: string | undefined;
    packageList: DateWithTotalPackagesList[] | undefined;
}

export class ViewReportSchedulesDto implements IViewReportSchedulesDto {
    id!: number;
    reportName!: string | undefined;
    description!: string | undefined;
    createdBy!: string | undefined;
    creationTime!: string | undefined;
    modificationTime!: string | undefined;
    modifiedBy!: string | undefined;
    isActive!: boolean;

    constructor(data?: IViewReportSchedulesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.reportName = data["reportName"];
            this.description = data["description"];
            this.createdBy = data["createdBy"];
            this.creationTime = data["creationTime"];
            this.modificationTime = data["modificationTime"];
            this.modifiedBy = data["modifiedBy"];
            this.isActive = data["isActive"];
        }
    }

    static fromJS(data: any): ViewReportSchedulesDto {
        data = typeof data === 'object' ? data : {};
        let result = new ViewReportSchedulesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["reportName"] = this.reportName;
        data["description"] = this.description;
        data["createdBy"] = this.createdBy;
        data["creationTime"] = this.creationTime;
        data["modificationTime"] = this.modificationTime;
        data["modifiedBy"] = this.modifiedBy;
        data["isActive"] = this.isActive;
        return data; 
    }
}

export interface IViewReportSchedulesDto {
    id: number;
    reportName: string | undefined;
    description: string | undefined;
    createdBy: string | undefined;
    creationTime: string | undefined;
    modificationTime: string | undefined;
    modifiedBy: string | undefined;
    isActive: boolean;
}

export class PagedResultDtoOfViewReportSchedulesDto implements IPagedResultDtoOfViewReportSchedulesDto {
    totalCount!: number;
    items!: ViewReportSchedulesDto[] | undefined;

    constructor(data?: IPagedResultDtoOfViewReportSchedulesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ViewReportSchedulesDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfViewReportSchedulesDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfViewReportSchedulesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfViewReportSchedulesDto {
    totalCount: number;
    items: ViewReportSchedulesDto[] | undefined;
}

export class CreateOrEditReportRecipientDto implements ICreateOrEditReportRecipientDto {
    isActive!: boolean;
    emailAddress!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    reportScheduleId!: number;
    userId!: number | undefined;
    id!: number;

    constructor(data?: ICreateOrEditReportRecipientDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.reportScheduleId = data["reportScheduleId"];
            this.userId = data["userId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditReportRecipientDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditReportRecipientDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["reportScheduleId"] = this.reportScheduleId;
        data["userId"] = this.userId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditReportRecipientDto {
    isActive: boolean;
    emailAddress: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    reportScheduleId: number;
    userId: number | undefined;
    id: number;
}

export class ParameterValueNameDto implements IParameterValueNameDto {
    parameterName!: string | undefined;
    parameterValue!: string | undefined;
    multiValue!: boolean;

    constructor(data?: IParameterValueNameDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parameterName = data["parameterName"];
            this.parameterValue = data["parameterValue"];
            this.multiValue = data["multiValue"];
        }
    }

    static fromJS(data: any): ParameterValueNameDto {
        data = typeof data === 'object' ? data : {};
        let result = new ParameterValueNameDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parameterName"] = this.parameterName;
        data["parameterValue"] = this.parameterValue;
        data["multiValue"] = this.multiValue;
        return data; 
    }
}

export interface IParameterValueNameDto {
    parameterName: string | undefined;
    parameterValue: string | undefined;
    multiValue: boolean;
}

export class CreateOrEditReportScheduleDto implements ICreateOrEditReportScheduleDto {
    reportScheduleId!: number;
    reportId!: number;
    description!: string | undefined;
    startDate!: moment.Moment;
    startTime!: string | undefined;
    repeat!: number;
    startDay!: number;
    exportType!: string | undefined;
    timeZone!: string | undefined;
    isActive!: boolean;
    recipients!: CreateOrEditReportRecipientDto[] | undefined;
    parameterNameValue!: ParameterValueNameDto[] | undefined;
    ftpIsActive!: boolean;
    ftpServerName!: string | undefined;
    ftpUserName!: string | undefined;
    ftpPassword!: string | undefined;
    ftpFolderName!: string | undefined;
    timeInterval!: number | undefined;
    ftpIsSftp!: boolean;

    constructor(data?: ICreateOrEditReportScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.reportScheduleId = data["reportScheduleId"];
            this.reportId = data["reportId"];
            this.description = data["description"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.startTime = data["startTime"];
            this.repeat = data["repeat"];
            this.startDay = data["startDay"];
            this.exportType = data["exportType"];
            this.timeZone = data["timeZone"];
            this.isActive = data["isActive"];
            if (Array.isArray(data["recipients"])) {
                this.recipients = [] as any;
                for (let item of data["recipients"])
                    this.recipients!.push(CreateOrEditReportRecipientDto.fromJS(item));
            }
            if (Array.isArray(data["parameterNameValue"])) {
                this.parameterNameValue = [] as any;
                for (let item of data["parameterNameValue"])
                    this.parameterNameValue!.push(ParameterValueNameDto.fromJS(item));
            }
            this.ftpIsActive = data["ftpIsActive"];
            this.ftpServerName = data["ftpServerName"];
            this.ftpUserName = data["ftpUserName"];
            this.ftpPassword = data["ftpPassword"];
            this.ftpFolderName = data["ftpFolderName"];
            this.timeInterval = data["timeInterval"];
            this.ftpIsSftp = data["ftpIsSftp"];
        }
    }

    static fromJS(data: any): CreateOrEditReportScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditReportScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["reportScheduleId"] = this.reportScheduleId;
        data["reportId"] = this.reportId;
        data["description"] = this.description;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["startTime"] = this.startTime;
        data["repeat"] = this.repeat;
        data["startDay"] = this.startDay;
        data["exportType"] = this.exportType;
        data["timeZone"] = this.timeZone;
        data["isActive"] = this.isActive;
        if (Array.isArray(this.recipients)) {
            data["recipients"] = [];
            for (let item of this.recipients)
                data["recipients"].push(item.toJSON());
        }
        if (Array.isArray(this.parameterNameValue)) {
            data["parameterNameValue"] = [];
            for (let item of this.parameterNameValue)
                data["parameterNameValue"].push(item.toJSON());
        }
        data["ftpIsActive"] = this.ftpIsActive;
        data["ftpServerName"] = this.ftpServerName;
        data["ftpUserName"] = this.ftpUserName;
        data["ftpPassword"] = this.ftpPassword;
        data["ftpFolderName"] = this.ftpFolderName;
        data["timeInterval"] = this.timeInterval;
        data["ftpIsSftp"] = this.ftpIsSftp;
        return data; 
    }
}

export interface ICreateOrEditReportScheduleDto {
    reportScheduleId: number;
    reportId: number;
    description: string | undefined;
    startDate: moment.Moment;
    startTime: string | undefined;
    repeat: number;
    startDay: number;
    exportType: string | undefined;
    timeZone: string | undefined;
    isActive: boolean;
    recipients: CreateOrEditReportRecipientDto[] | undefined;
    parameterNameValue: ParameterValueNameDto[] | undefined;
    ftpIsActive: boolean;
    ftpServerName: string | undefined;
    ftpUserName: string | undefined;
    ftpPassword: string | undefined;
    ftpFolderName: string | undefined;
    timeInterval: number | undefined;
    ftpIsSftp: boolean;
}

export class ReportSchedules implements IReportSchedules {
    tenantId!: number | undefined;
    lastModifierUserId!: number | undefined;
    reportId!: number;
    description!: string;
    startDate!: moment.Moment;
    startDay!: number;
    repeat!: number;
    isActive!: boolean;
    exportType!: string;
    ftpIsActive!: boolean;
    timeZone!: string | undefined;
    dateGenerated!: moment.Moment | undefined;
    timeInterval!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IReportSchedules) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.lastModifierUserId = data["lastModifierUserId"];
            this.reportId = data["reportId"];
            this.description = data["description"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.startDay = data["startDay"];
            this.repeat = data["repeat"];
            this.isActive = data["isActive"];
            this.exportType = data["exportType"];
            this.ftpIsActive = data["ftpIsActive"];
            this.timeZone = data["timeZone"];
            this.dateGenerated = data["dateGenerated"] ? moment(data["dateGenerated"].toString()) : <any>undefined;
            this.timeInterval = data["timeInterval"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ReportSchedules {
        data = typeof data === 'object' ? data : {};
        let result = new ReportSchedules();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["reportId"] = this.reportId;
        data["description"] = this.description;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["startDay"] = this.startDay;
        data["repeat"] = this.repeat;
        data["isActive"] = this.isActive;
        data["exportType"] = this.exportType;
        data["ftpIsActive"] = this.ftpIsActive;
        data["timeZone"] = this.timeZone;
        data["dateGenerated"] = this.dateGenerated ? this.dateGenerated.toISOString() : <any>undefined;
        data["timeInterval"] = this.timeInterval;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IReportSchedules {
    tenantId: number | undefined;
    lastModifierUserId: number | undefined;
    reportId: number;
    description: string;
    startDate: moment.Moment;
    startDay: number;
    repeat: number;
    isActive: boolean;
    exportType: string;
    ftpIsActive: boolean;
    timeZone: string | undefined;
    dateGenerated: moment.Moment | undefined;
    timeInterval: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class GetReportScheduleRecipientForEdit implements IGetReportScheduleRecipientForEdit {
    id!: number;
    isActive!: boolean;
    emailAddress!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    reportScheduleId!: number;
    userId!: number | undefined;

    constructor(data?: IGetReportScheduleRecipientForEdit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.reportScheduleId = data["reportScheduleId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): GetReportScheduleRecipientForEdit {
        data = typeof data === 'object' ? data : {};
        let result = new GetReportScheduleRecipientForEdit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["reportScheduleId"] = this.reportScheduleId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IGetReportScheduleRecipientForEdit {
    id: number;
    isActive: boolean;
    emailAddress: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    reportScheduleId: number;
    userId: number | undefined;
}

export class GetReportScheduleForEdit implements IGetReportScheduleForEdit {
    reportId!: number;
    description!: string | undefined;
    startDate!: moment.Moment;
    startDateString!: string | undefined;
    startTime!: string | undefined;
    repeat!: number;
    startDay!: number;
    exportType!: string | undefined;
    isActive!: boolean;
    timeZone!: string | undefined;
    recipients!: GetReportScheduleRecipientForEdit[] | undefined;
    parameterNameValue!: ParameterValueNameDto[] | undefined;
    ftpIsActive!: boolean;
    ftpServerName!: string | undefined;
    ftpUserName!: string | undefined;
    ftpPassword!: string | undefined;
    ftpFolderName!: string | undefined;
    ftpIsSftp!: boolean;
    timeInterval!: number | undefined;

    constructor(data?: IGetReportScheduleForEdit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.reportId = data["reportId"];
            this.description = data["description"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.startDateString = data["startDateString"];
            this.startTime = data["startTime"];
            this.repeat = data["repeat"];
            this.startDay = data["startDay"];
            this.exportType = data["exportType"];
            this.isActive = data["isActive"];
            this.timeZone = data["timeZone"];
            if (Array.isArray(data["recipients"])) {
                this.recipients = [] as any;
                for (let item of data["recipients"])
                    this.recipients!.push(GetReportScheduleRecipientForEdit.fromJS(item));
            }
            if (Array.isArray(data["parameterNameValue"])) {
                this.parameterNameValue = [] as any;
                for (let item of data["parameterNameValue"])
                    this.parameterNameValue!.push(ParameterValueNameDto.fromJS(item));
            }
            this.ftpIsActive = data["ftpIsActive"];
            this.ftpServerName = data["ftpServerName"];
            this.ftpUserName = data["ftpUserName"];
            this.ftpPassword = data["ftpPassword"];
            this.ftpFolderName = data["ftpFolderName"];
            this.ftpIsSftp = data["ftpIsSftp"];
            this.timeInterval = data["timeInterval"];
        }
    }

    static fromJS(data: any): GetReportScheduleForEdit {
        data = typeof data === 'object' ? data : {};
        let result = new GetReportScheduleForEdit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["reportId"] = this.reportId;
        data["description"] = this.description;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["startDateString"] = this.startDateString;
        data["startTime"] = this.startTime;
        data["repeat"] = this.repeat;
        data["startDay"] = this.startDay;
        data["exportType"] = this.exportType;
        data["isActive"] = this.isActive;
        data["timeZone"] = this.timeZone;
        if (Array.isArray(this.recipients)) {
            data["recipients"] = [];
            for (let item of this.recipients)
                data["recipients"].push(item.toJSON());
        }
        if (Array.isArray(this.parameterNameValue)) {
            data["parameterNameValue"] = [];
            for (let item of this.parameterNameValue)
                data["parameterNameValue"].push(item.toJSON());
        }
        data["ftpIsActive"] = this.ftpIsActive;
        data["ftpServerName"] = this.ftpServerName;
        data["ftpUserName"] = this.ftpUserName;
        data["ftpPassword"] = this.ftpPassword;
        data["ftpFolderName"] = this.ftpFolderName;
        data["ftpIsSftp"] = this.ftpIsSftp;
        data["timeInterval"] = this.timeInterval;
        return data; 
    }
}

export interface IGetReportScheduleForEdit {
    reportId: number;
    description: string | undefined;
    startDate: moment.Moment;
    startDateString: string | undefined;
    startTime: string | undefined;
    repeat: number;
    startDay: number;
    exportType: string | undefined;
    isActive: boolean;
    timeZone: string | undefined;
    recipients: GetReportScheduleRecipientForEdit[] | undefined;
    parameterNameValue: ParameterValueNameDto[] | undefined;
    ftpIsActive: boolean;
    ftpServerName: string | undefined;
    ftpUserName: string | undefined;
    ftpPassword: string | undefined;
    ftpFolderName: string | undefined;
    ftpIsSftp: boolean;
    timeInterval: number | undefined;
}

export class CreateReportScheduleParametersDto implements ICreateReportScheduleParametersDto {
    reportId!: number | undefined;
    reportScheduleId!: number | undefined;
    parameterName!: string | undefined;
    parameterValue!: string | undefined;
    multiValue!: boolean;

    constructor(data?: ICreateReportScheduleParametersDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.reportId = data["reportId"];
            this.reportScheduleId = data["reportScheduleId"];
            this.parameterName = data["parameterName"];
            this.parameterValue = data["parameterValue"];
            this.multiValue = data["multiValue"];
        }
    }

    static fromJS(data: any): CreateReportScheduleParametersDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateReportScheduleParametersDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["reportId"] = this.reportId;
        data["reportScheduleId"] = this.reportScheduleId;
        data["parameterName"] = this.parameterName;
        data["parameterValue"] = this.parameterValue;
        data["multiValue"] = this.multiValue;
        return data; 
    }
}

export interface ICreateReportScheduleParametersDto {
    reportId: number | undefined;
    reportScheduleId: number | undefined;
    parameterName: string | undefined;
    parameterValue: string | undefined;
    multiValue: boolean;
}

export class NameValueReportDto implements INameValueReportDto {
    name!: string | undefined;
    value!: string | undefined;
    paramName!: string | undefined;

    constructor(data?: INameValueReportDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.value = data["value"];
            this.paramName = data["paramName"];
        }
    }

    static fromJS(data: any): NameValueReportDto {
        data = typeof data === 'object' ? data : {};
        let result = new NameValueReportDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["value"] = this.value;
        data["paramName"] = this.paramName;
        return data; 
    }
}

export interface INameValueReportDto {
    name: string | undefined;
    value: string | undefined;
    paramName: string | undefined;
}

export class PagedResultDtoOfNameValueReportDto implements IPagedResultDtoOfNameValueReportDto {
    totalCount!: number;
    items!: NameValueReportDto[] | undefined;

    constructor(data?: IPagedResultDtoOfNameValueReportDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(NameValueReportDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfNameValueReportDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfNameValueReportDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfNameValueReportDto {
    totalCount: number;
    items: NameValueReportDto[] | undefined;
}

export class GetReportParameterValuesDto implements IGetReportParameterValuesDto {
    id!: number;
    name!: string | undefined;
    multiValue!: boolean;

    constructor(data?: IGetReportParameterValuesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.multiValue = data["multiValue"];
        }
    }

    static fromJS(data: any): GetReportParameterValuesDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetReportParameterValuesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["multiValue"] = this.multiValue;
        return data; 
    }
}

export interface IGetReportParameterValuesDto {
    id: number;
    name: string | undefined;
    multiValue: boolean;
}

export class GetReportParametersDto implements IGetReportParametersDto {
    name!: string | undefined;
    defaultValues!: GetReportParameterValuesDto[] | undefined;
    multiValue!: boolean;
    basicInput!: boolean;

    constructor(data?: IGetReportParametersDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            if (Array.isArray(data["defaultValues"])) {
                this.defaultValues = [] as any;
                for (let item of data["defaultValues"])
                    this.defaultValues!.push(GetReportParameterValuesDto.fromJS(item));
            }
            this.multiValue = data["multiValue"];
            this.basicInput = data["basicInput"];
        }
    }

    static fromJS(data: any): GetReportParametersDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetReportParametersDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        if (Array.isArray(this.defaultValues)) {
            data["defaultValues"] = [];
            for (let item of this.defaultValues)
                data["defaultValues"].push(item.toJSON());
        }
        data["multiValue"] = this.multiValue;
        data["basicInput"] = this.basicInput;
        return data; 
    }
}

export interface IGetReportParametersDto {
    name: string | undefined;
    defaultValues: GetReportParameterValuesDto[] | undefined;
    multiValue: boolean;
    basicInput: boolean;
}

export class ReportScheduleParameterCheckerInput implements IReportScheduleParameterCheckerInput {
    repeat!: number;
    reportId!: number;
    reportScheduleId!: number | undefined;
    parameterNameValue!: ParameterValueNameDto[] | undefined;
    recipients!: CreateOrEditReportRecipientDto[] | undefined;

    constructor(data?: IReportScheduleParameterCheckerInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.repeat = data["repeat"];
            this.reportId = data["reportId"];
            this.reportScheduleId = data["reportScheduleId"];
            if (Array.isArray(data["parameterNameValue"])) {
                this.parameterNameValue = [] as any;
                for (let item of data["parameterNameValue"])
                    this.parameterNameValue!.push(ParameterValueNameDto.fromJS(item));
            }
            if (Array.isArray(data["recipients"])) {
                this.recipients = [] as any;
                for (let item of data["recipients"])
                    this.recipients!.push(CreateOrEditReportRecipientDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ReportScheduleParameterCheckerInput {
        data = typeof data === 'object' ? data : {};
        let result = new ReportScheduleParameterCheckerInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["repeat"] = this.repeat;
        data["reportId"] = this.reportId;
        data["reportScheduleId"] = this.reportScheduleId;
        if (Array.isArray(this.parameterNameValue)) {
            data["parameterNameValue"] = [];
            for (let item of this.parameterNameValue)
                data["parameterNameValue"].push(item.toJSON());
        }
        if (Array.isArray(this.recipients)) {
            data["recipients"] = [];
            for (let item of this.recipients)
                data["recipients"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IReportScheduleParameterCheckerInput {
    repeat: number;
    reportId: number;
    reportScheduleId: number | undefined;
    parameterNameValue: ParameterValueNameDto[] | undefined;
    recipients: CreateOrEditReportRecipientDto[] | undefined;
}

export class CreateReportSchedulerFtpServersDto implements ICreateReportSchedulerFtpServersDto {
    scheduleId!: number | undefined;
    ftpServerName!: string | undefined;
    ftpUserName!: string | undefined;
    ftpPassword!: string | undefined;
    ftpIsSftp!: boolean;

    constructor(data?: ICreateReportSchedulerFtpServersDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.scheduleId = data["scheduleId"];
            this.ftpServerName = data["ftpServerName"];
            this.ftpUserName = data["ftpUserName"];
            this.ftpPassword = data["ftpPassword"];
            this.ftpIsSftp = data["ftpIsSftp"];
        }
    }

    static fromJS(data: any): CreateReportSchedulerFtpServersDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateReportSchedulerFtpServersDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["scheduleId"] = this.scheduleId;
        data["ftpServerName"] = this.ftpServerName;
        data["ftpUserName"] = this.ftpUserName;
        data["ftpPassword"] = this.ftpPassword;
        data["ftpIsSftp"] = this.ftpIsSftp;
        return data; 
    }
}

export interface ICreateReportSchedulerFtpServersDto {
    scheduleId: number | undefined;
    ftpServerName: string | undefined;
    ftpUserName: string | undefined;
    ftpPassword: string | undefined;
    ftpIsSftp: boolean;
}

export class XDeclaration implements IXDeclaration {
    encoding!: string | undefined;
    standalone!: string | undefined;
    version!: string | undefined;

    constructor(data?: IXDeclaration) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.encoding = data["encoding"];
            this.standalone = data["standalone"];
            this.version = data["version"];
        }
    }

    static fromJS(data: any): XDeclaration {
        data = typeof data === 'object' ? data : {};
        let result = new XDeclaration();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["encoding"] = this.encoding;
        data["standalone"] = this.standalone;
        data["version"] = this.version;
        return data; 
    }
}

export interface IXDeclaration {
    encoding: string | undefined;
    standalone: string | undefined;
    version: string | undefined;
}

export enum XmlNodeType {
    None = 0,
    Element = 1,
    Attribute = 2,
    Text = 3,
    CDATA = 4,
    EntityReference = 5,
    Entity = 6,
    ProcessingInstruction = 7,
    Comment = 8,
    Document = 9,
    DocumentType = 10,
    DocumentFragment = 11,
    Notation = 12,
    Whitespace = 13,
    SignificantWhitespace = 14,
    EndElement = 15,
    EndEntity = 16,
    XmlDeclaration = 17,
}

export class XNamespace implements IXNamespace {
    readonly namespaceName!: string | undefined;

    constructor(data?: IXNamespace) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).namespaceName = data["namespaceName"];
        }
    }

    static fromJS(data: any): XNamespace {
        data = typeof data === 'object' ? data : {};
        let result = new XNamespace();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["namespaceName"] = this.namespaceName;
        return data; 
    }
}

export interface IXNamespace {
    namespaceName: string | undefined;
}

export class XName implements IXName {
    readonly localName!: string | undefined;
    readonly namespace!: XNamespace | undefined;
    readonly namespaceName!: string | undefined;

    constructor(data?: IXName) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).localName = data["localName"];
            (<any>this).namespace = data["namespace"] ? XNamespace.fromJS(data["namespace"]) : <any>undefined;
            (<any>this).namespaceName = data["namespaceName"];
        }
    }

    static fromJS(data: any): XName {
        data = typeof data === 'object' ? data : {};
        let result = new XName();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["localName"] = this.localName;
        data["namespace"] = this.namespace ? this.namespace.toJSON() : <any>undefined;
        data["namespaceName"] = this.namespaceName;
        return data; 
    }
}

export interface IXName {
    localName: string | undefined;
    namespace: XNamespace | undefined;
    namespaceName: string | undefined;
}

export class XAttribute implements IXAttribute {
    readonly isNamespaceDeclaration!: boolean;
    readonly name!: XName | undefined;
    readonly nextAttribute!: XAttribute | undefined;
    readonly nodeType!: XmlNodeType;
    readonly previousAttribute!: XAttribute | undefined;
    value!: string | undefined;
    readonly baseUri!: string | undefined;
    readonly document!: XDocument | undefined;
    readonly parent!: XElement | undefined;

    constructor(data?: IXAttribute) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).isNamespaceDeclaration = data["isNamespaceDeclaration"];
            (<any>this).name = data["name"] ? XName.fromJS(data["name"]) : <any>undefined;
            (<any>this).nextAttribute = data["nextAttribute"] ? XAttribute.fromJS(data["nextAttribute"]) : <any>undefined;
            (<any>this).nodeType = data["nodeType"];
            (<any>this).previousAttribute = data["previousAttribute"] ? XAttribute.fromJS(data["previousAttribute"]) : <any>undefined;
            this.value = data["value"];
            (<any>this).baseUri = data["baseUri"];
            (<any>this).document = data["document"] ? XDocument.fromJS(data["document"]) : <any>undefined;
            (<any>this).parent = data["parent"] ? XElement.fromJS(data["parent"]) : <any>undefined;
        }
    }

    static fromJS(data: any): XAttribute {
        data = typeof data === 'object' ? data : {};
        let result = new XAttribute();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isNamespaceDeclaration"] = this.isNamespaceDeclaration;
        data["name"] = this.name ? this.name.toJSON() : <any>undefined;
        data["nextAttribute"] = this.nextAttribute ? this.nextAttribute.toJSON() : <any>undefined;
        data["nodeType"] = this.nodeType;
        data["previousAttribute"] = this.previousAttribute ? this.previousAttribute.toJSON() : <any>undefined;
        data["value"] = this.value;
        data["baseUri"] = this.baseUri;
        data["document"] = this.document ? this.document.toJSON() : <any>undefined;
        data["parent"] = this.parent ? this.parent.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IXAttribute {
    isNamespaceDeclaration: boolean;
    name: XName | undefined;
    nextAttribute: XAttribute | undefined;
    nodeType: XmlNodeType;
    previousAttribute: XAttribute | undefined;
    value: string | undefined;
    baseUri: string | undefined;
    document: XDocument | undefined;
    parent: XElement | undefined;
}

export class XElement implements IXElement {
    readonly firstAttribute!: XAttribute | undefined;
    readonly hasAttributes!: boolean;
    readonly hasElements!: boolean;
    readonly isEmpty!: boolean;
    readonly lastAttribute!: XAttribute | undefined;
    name!: XName | undefined;
    readonly nodeType!: XmlNodeType;
    value!: string | undefined;
    readonly firstNode!: XNode | undefined;
    readonly lastNode!: XNode | undefined;
    readonly nextNode!: XNode | undefined;
    readonly previousNode!: XNode | undefined;
    readonly baseUri!: string | undefined;
    readonly document!: XDocument | undefined;
    readonly parent!: XElement | undefined;

    constructor(data?: IXElement) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).firstAttribute = data["firstAttribute"] ? XAttribute.fromJS(data["firstAttribute"]) : <any>undefined;
            (<any>this).hasAttributes = data["hasAttributes"];
            (<any>this).hasElements = data["hasElements"];
            (<any>this).isEmpty = data["isEmpty"];
            (<any>this).lastAttribute = data["lastAttribute"] ? XAttribute.fromJS(data["lastAttribute"]) : <any>undefined;
            this.name = data["name"] ? XName.fromJS(data["name"]) : <any>undefined;
            (<any>this).nodeType = data["nodeType"];
            this.value = data["value"];
            (<any>this).firstNode = data["firstNode"] ? XNode.fromJS(data["firstNode"]) : <any>undefined;
            (<any>this).lastNode = data["lastNode"] ? XNode.fromJS(data["lastNode"]) : <any>undefined;
            (<any>this).nextNode = data["nextNode"] ? XNode.fromJS(data["nextNode"]) : <any>undefined;
            (<any>this).previousNode = data["previousNode"] ? XNode.fromJS(data["previousNode"]) : <any>undefined;
            (<any>this).baseUri = data["baseUri"];
            (<any>this).document = data["document"] ? XDocument.fromJS(data["document"]) : <any>undefined;
            (<any>this).parent = data["parent"] ? XElement.fromJS(data["parent"]) : <any>undefined;
        }
    }

    static fromJS(data: any): XElement {
        data = typeof data === 'object' ? data : {};
        let result = new XElement();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["firstAttribute"] = this.firstAttribute ? this.firstAttribute.toJSON() : <any>undefined;
        data["hasAttributes"] = this.hasAttributes;
        data["hasElements"] = this.hasElements;
        data["isEmpty"] = this.isEmpty;
        data["lastAttribute"] = this.lastAttribute ? this.lastAttribute.toJSON() : <any>undefined;
        data["name"] = this.name ? this.name.toJSON() : <any>undefined;
        data["nodeType"] = this.nodeType;
        data["value"] = this.value;
        data["firstNode"] = this.firstNode ? this.firstNode.toJSON() : <any>undefined;
        data["lastNode"] = this.lastNode ? this.lastNode.toJSON() : <any>undefined;
        data["nextNode"] = this.nextNode ? this.nextNode.toJSON() : <any>undefined;
        data["previousNode"] = this.previousNode ? this.previousNode.toJSON() : <any>undefined;
        data["baseUri"] = this.baseUri;
        data["document"] = this.document ? this.document.toJSON() : <any>undefined;
        data["parent"] = this.parent ? this.parent.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IXElement {
    firstAttribute: XAttribute | undefined;
    hasAttributes: boolean;
    hasElements: boolean;
    isEmpty: boolean;
    lastAttribute: XAttribute | undefined;
    name: XName | undefined;
    nodeType: XmlNodeType;
    value: string | undefined;
    firstNode: XNode | undefined;
    lastNode: XNode | undefined;
    nextNode: XNode | undefined;
    previousNode: XNode | undefined;
    baseUri: string | undefined;
    document: XDocument | undefined;
    parent: XElement | undefined;
}

export class XNode implements IXNode {
    readonly nextNode!: XNode | undefined;
    readonly previousNode!: XNode | undefined;
    readonly baseUri!: string | undefined;
    readonly document!: XDocument | undefined;
    readonly nodeType!: XmlNodeType;
    readonly parent!: XElement | undefined;

    constructor(data?: IXNode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).nextNode = data["nextNode"] ? XNode.fromJS(data["nextNode"]) : <any>undefined;
            (<any>this).previousNode = data["previousNode"] ? XNode.fromJS(data["previousNode"]) : <any>undefined;
            (<any>this).baseUri = data["baseUri"];
            (<any>this).document = data["document"] ? XDocument.fromJS(data["document"]) : <any>undefined;
            (<any>this).nodeType = data["nodeType"];
            (<any>this).parent = data["parent"] ? XElement.fromJS(data["parent"]) : <any>undefined;
        }
    }

    static fromJS(data: any): XNode {
        data = typeof data === 'object' ? data : {};
        let result = new XNode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["nextNode"] = this.nextNode ? this.nextNode.toJSON() : <any>undefined;
        data["previousNode"] = this.previousNode ? this.previousNode.toJSON() : <any>undefined;
        data["baseUri"] = this.baseUri;
        data["document"] = this.document ? this.document.toJSON() : <any>undefined;
        data["nodeType"] = this.nodeType;
        data["parent"] = this.parent ? this.parent.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IXNode {
    nextNode: XNode | undefined;
    previousNode: XNode | undefined;
    baseUri: string | undefined;
    document: XDocument | undefined;
    nodeType: XmlNodeType;
    parent: XElement | undefined;
}

export class XDocumentType implements IXDocumentType {
    internalSubset!: string | undefined;
    name!: string | undefined;
    readonly nodeType!: XmlNodeType;
    publicId!: string | undefined;
    systemId!: string | undefined;
    readonly nextNode!: XNode | undefined;
    readonly previousNode!: XNode | undefined;
    readonly baseUri!: string | undefined;
    readonly document!: XDocument | undefined;
    readonly parent!: XElement | undefined;

    constructor(data?: IXDocumentType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.internalSubset = data["internalSubset"];
            this.name = data["name"];
            (<any>this).nodeType = data["nodeType"];
            this.publicId = data["publicId"];
            this.systemId = data["systemId"];
            (<any>this).nextNode = data["nextNode"] ? XNode.fromJS(data["nextNode"]) : <any>undefined;
            (<any>this).previousNode = data["previousNode"] ? XNode.fromJS(data["previousNode"]) : <any>undefined;
            (<any>this).baseUri = data["baseUri"];
            (<any>this).document = data["document"] ? XDocument.fromJS(data["document"]) : <any>undefined;
            (<any>this).parent = data["parent"] ? XElement.fromJS(data["parent"]) : <any>undefined;
        }
    }

    static fromJS(data: any): XDocumentType {
        data = typeof data === 'object' ? data : {};
        let result = new XDocumentType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["internalSubset"] = this.internalSubset;
        data["name"] = this.name;
        data["nodeType"] = this.nodeType;
        data["publicId"] = this.publicId;
        data["systemId"] = this.systemId;
        data["nextNode"] = this.nextNode ? this.nextNode.toJSON() : <any>undefined;
        data["previousNode"] = this.previousNode ? this.previousNode.toJSON() : <any>undefined;
        data["baseUri"] = this.baseUri;
        data["document"] = this.document ? this.document.toJSON() : <any>undefined;
        data["parent"] = this.parent ? this.parent.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IXDocumentType {
    internalSubset: string | undefined;
    name: string | undefined;
    nodeType: XmlNodeType;
    publicId: string | undefined;
    systemId: string | undefined;
    nextNode: XNode | undefined;
    previousNode: XNode | undefined;
    baseUri: string | undefined;
    document: XDocument | undefined;
    parent: XElement | undefined;
}

export class XDocument implements IXDocument {
    declaration!: XDeclaration | undefined;
    readonly documentType!: XDocumentType | undefined;
    readonly nodeType!: XmlNodeType;
    readonly root!: XElement | undefined;
    readonly firstNode!: XNode | undefined;
    readonly lastNode!: XNode | undefined;
    readonly nextNode!: XNode | undefined;
    readonly previousNode!: XNode | undefined;
    readonly baseUri!: string | undefined;
    readonly document!: XDocument | undefined;
    readonly parent!: XElement | undefined;

    constructor(data?: IXDocument) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.declaration = data["declaration"] ? XDeclaration.fromJS(data["declaration"]) : <any>undefined;
            (<any>this).documentType = data["documentType"] ? XDocumentType.fromJS(data["documentType"]) : <any>undefined;
            (<any>this).nodeType = data["nodeType"];
            (<any>this).root = data["root"] ? XElement.fromJS(data["root"]) : <any>undefined;
            (<any>this).firstNode = data["firstNode"] ? XNode.fromJS(data["firstNode"]) : <any>undefined;
            (<any>this).lastNode = data["lastNode"] ? XNode.fromJS(data["lastNode"]) : <any>undefined;
            (<any>this).nextNode = data["nextNode"] ? XNode.fromJS(data["nextNode"]) : <any>undefined;
            (<any>this).previousNode = data["previousNode"] ? XNode.fromJS(data["previousNode"]) : <any>undefined;
            (<any>this).baseUri = data["baseUri"];
            (<any>this).document = data["document"] ? XDocument.fromJS(data["document"]) : <any>undefined;
            (<any>this).parent = data["parent"] ? XElement.fromJS(data["parent"]) : <any>undefined;
        }
    }

    static fromJS(data: any): XDocument {
        data = typeof data === 'object' ? data : {};
        let result = new XDocument();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["declaration"] = this.declaration ? this.declaration.toJSON() : <any>undefined;
        data["documentType"] = this.documentType ? this.documentType.toJSON() : <any>undefined;
        data["nodeType"] = this.nodeType;
        data["root"] = this.root ? this.root.toJSON() : <any>undefined;
        data["firstNode"] = this.firstNode ? this.firstNode.toJSON() : <any>undefined;
        data["lastNode"] = this.lastNode ? this.lastNode.toJSON() : <any>undefined;
        data["nextNode"] = this.nextNode ? this.nextNode.toJSON() : <any>undefined;
        data["previousNode"] = this.previousNode ? this.previousNode.toJSON() : <any>undefined;
        data["baseUri"] = this.baseUri;
        data["document"] = this.document ? this.document.toJSON() : <any>undefined;
        data["parent"] = this.parent ? this.parent.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IXDocument {
    declaration: XDeclaration | undefined;
    documentType: XDocumentType | undefined;
    nodeType: XmlNodeType;
    root: XElement | undefined;
    firstNode: XNode | undefined;
    lastNode: XNode | undefined;
    nextNode: XNode | undefined;
    previousNode: XNode | undefined;
    baseUri: string | undefined;
    document: XDocument | undefined;
    parent: XElement | undefined;
}

export class CreateReviewInput implements ICreateReviewInput {
    content!: string;
    rating!: number;

    constructor(data?: ICreateReviewInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.content = data["content"];
            this.rating = data["rating"];
        }
    }

    static fromJS(data: any): CreateReviewInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateReviewInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["content"] = this.content;
        data["rating"] = this.rating;
        return data; 
    }
}

export interface ICreateReviewInput {
    content: string;
    rating: number;
}

export class ListResultDtoOfReviewListDto implements IListResultDtoOfReviewListDto {
    items!: ReviewListDto[] | undefined;

    constructor(data?: IListResultDtoOfReviewListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ReviewListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfReviewListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfReviewListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfReviewListDto {
    items: ReviewListDto[] | undefined;
}

export class UpdateReviewInput implements IUpdateReviewInput {
    id!: number;
    content!: string | undefined;
    rating!: number;

    constructor(data?: IUpdateReviewInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.content = data["content"];
            this.rating = data["rating"];
        }
    }

    static fromJS(data: any): UpdateReviewInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateReviewInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["content"] = this.content;
        data["rating"] = this.rating;
        return data; 
    }
}

export interface IUpdateReviewInput {
    id: number;
    content: string | undefined;
    rating: number;
}

export class CreateReviewImageInput implements ICreateReviewImageInput {
    reviewId!: number | undefined;
    imageId!: number | undefined;

    constructor(data?: ICreateReviewImageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.reviewId = data["reviewId"];
            this.imageId = data["imageId"];
        }
    }

    static fromJS(data: any): CreateReviewImageInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateReviewImageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["reviewId"] = this.reviewId;
        data["imageId"] = this.imageId;
        return data; 
    }
}

export interface ICreateReviewImageInput {
    reviewId: number | undefined;
    imageId: number | undefined;
}

export class ReviewImageListDto implements IReviewImageListDto {
    id!: number;
    reviewId!: number;
    review!: ReviewListDto | undefined;
    imageId!: number;
    image!: ImageListDto | undefined;

    constructor(data?: IReviewImageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.reviewId = data["reviewId"];
            this.review = data["review"] ? ReviewListDto.fromJS(data["review"]) : <any>undefined;
            this.imageId = data["imageId"];
            this.image = data["image"] ? ImageListDto.fromJS(data["image"]) : <any>undefined;
        }
    }

    static fromJS(data: any): ReviewImageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ReviewImageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["reviewId"] = this.reviewId;
        data["review"] = this.review ? this.review.toJSON() : <any>undefined;
        data["imageId"] = this.imageId;
        data["image"] = this.image ? this.image.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IReviewImageListDto {
    id: number;
    reviewId: number;
    review: ReviewListDto | undefined;
    imageId: number;
    image: ImageListDto | undefined;
}

export class ListResultDtoOfReviewImageListDto implements IListResultDtoOfReviewImageListDto {
    items!: ReviewImageListDto[] | undefined;

    constructor(data?: IListResultDtoOfReviewImageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ReviewImageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfReviewImageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfReviewImageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfReviewImageListDto {
    items: ReviewImageListDto[] | undefined;
}

export class UpdateReviewImageInput implements IUpdateReviewImageInput {
    id!: number;
    reviewId!: number;
    imageId!: number;

    constructor(data?: IUpdateReviewImageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.reviewId = data["reviewId"];
            this.imageId = data["imageId"];
        }
    }

    static fromJS(data: any): UpdateReviewImageInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateReviewImageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["reviewId"] = this.reviewId;
        data["imageId"] = this.imageId;
        return data; 
    }
}

export interface IUpdateReviewImageInput {
    id: number;
    reviewId: number;
    imageId: number;
}

export class RoleListDto implements IRoleListDto {
    name!: string | undefined;
    displayName!: string | undefined;
    isStatic!: boolean;
    isDefault!: boolean;
    creationTime!: moment.Moment;
    id!: number;

    constructor(data?: IRoleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.isStatic = data["isStatic"];
            this.isDefault = data["isDefault"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RoleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RoleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["isStatic"] = this.isStatic;
        data["isDefault"] = this.isDefault;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRoleListDto {
    name: string | undefined;
    displayName: string | undefined;
    isStatic: boolean;
    isDefault: boolean;
    creationTime: moment.Moment;
    id: number;
}

export class ListResultDtoOfRoleListDto implements IListResultDtoOfRoleListDto {
    items!: RoleListDto[] | undefined;

    constructor(data?: IListResultDtoOfRoleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RoleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfRoleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfRoleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfRoleListDto {
    items: RoleListDto[] | undefined;
}

export class GetRoleForEditOutput implements IGetRoleForEditOutput {
    role!: RoleEditDto | undefined;
    permissions!: FlatPermissionDto[] | undefined;
    grantedPermissionNames!: string[] | undefined;

    constructor(data?: IGetRoleForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.role = data["role"] ? RoleEditDto.fromJS(data["role"]) : <any>undefined;
            if (Array.isArray(data["permissions"])) {
                this.permissions = [] as any;
                for (let item of data["permissions"])
                    this.permissions!.push(FlatPermissionDto.fromJS(item));
            }
            if (Array.isArray(data["grantedPermissionNames"])) {
                this.grantedPermissionNames = [] as any;
                for (let item of data["grantedPermissionNames"])
                    this.grantedPermissionNames!.push(item);
            }
        }
    }

    static fromJS(data: any): GetRoleForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRoleForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["role"] = this.role ? this.role.toJSON() : <any>undefined;
        if (Array.isArray(this.permissions)) {
            data["permissions"] = [];
            for (let item of this.permissions)
                data["permissions"].push(item.toJSON());
        }
        if (Array.isArray(this.grantedPermissionNames)) {
            data["grantedPermissionNames"] = [];
            for (let item of this.grantedPermissionNames)
                data["grantedPermissionNames"].push(item);
        }
        return data; 
    }
}

export interface IGetRoleForEditOutput {
    role: RoleEditDto | undefined;
    permissions: FlatPermissionDto[] | undefined;
    grantedPermissionNames: string[] | undefined;
}

export class CreateOrUpdateRoleInput implements ICreateOrUpdateRoleInput {
    role!: RoleEditDto;
    grantedPermissionNames!: string[];

    constructor(data?: ICreateOrUpdateRoleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.role = new RoleEditDto();
            this.grantedPermissionNames = [];
        }
    }

    init(data?: any) {
        if (data) {
            this.role = data["role"] ? RoleEditDto.fromJS(data["role"]) : new RoleEditDto();
            if (Array.isArray(data["grantedPermissionNames"])) {
                this.grantedPermissionNames = [] as any;
                for (let item of data["grantedPermissionNames"])
                    this.grantedPermissionNames!.push(item);
            }
        }
    }

    static fromJS(data: any): CreateOrUpdateRoleInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateRoleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["role"] = this.role ? this.role.toJSON() : <any>undefined;
        if (Array.isArray(this.grantedPermissionNames)) {
            data["grantedPermissionNames"] = [];
            for (let item of this.grantedPermissionNames)
                data["grantedPermissionNames"].push(item);
        }
        return data; 
    }
}

export interface ICreateOrUpdateRoleInput {
    role: RoleEditDto;
    grantedPermissionNames: string[];
}

export class GetRouteTemplateByDriverInput implements IGetRouteTemplateByDriverInput {
    driverUserId!: number;
    defaultContactId!: number | undefined;
    routeStartContactId!: number | undefined;
    tenantId!: number | undefined;
    loadDate!: string | undefined;

    constructor(data?: IGetRouteTemplateByDriverInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverUserId = data["driverUserId"];
            this.defaultContactId = data["defaultContactId"];
            this.routeStartContactId = data["routeStartContactId"];
            this.tenantId = data["tenantId"];
            this.loadDate = data["loadDate"];
        }
    }

    static fromJS(data: any): GetRouteTemplateByDriverInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteTemplateByDriverInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverUserId"] = this.driverUserId;
        data["defaultContactId"] = this.defaultContactId;
        data["routeStartContactId"] = this.routeStartContactId;
        data["tenantId"] = this.tenantId;
        data["loadDate"] = this.loadDate;
        return data; 
    }
}

export interface IGetRouteTemplateByDriverInput {
    driverUserId: number;
    defaultContactId: number | undefined;
    routeStartContactId: number | undefined;
    tenantId: number | undefined;
    loadDate: string | undefined;
}

export class GetRouteTemplateByDriverDto implements IGetRouteTemplateByDriverDto {
    routeTemplateId!: number;

    constructor(data?: IGetRouteTemplateByDriverDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateId = data["routeTemplateId"];
        }
    }

    static fromJS(data: any): GetRouteTemplateByDriverDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteTemplateByDriverDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateId"] = this.routeTemplateId;
        return data; 
    }
}

export interface IGetRouteTemplateByDriverDto {
    routeTemplateId: number;
}

export enum StopTypes {
    START = 0,
    MEET = 1,
    END = 2,
}

export class ValidateRouteDuplicationResultDto implements IValidateRouteDuplicationResultDto {
    routeId!: number;
    ordersCount!: number;
    routeName!: string | undefined;

    constructor(data?: IValidateRouteDuplicationResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.ordersCount = data["ordersCount"];
            this.routeName = data["routeName"];
        }
    }

    static fromJS(data: any): ValidateRouteDuplicationResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new ValidateRouteDuplicationResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["ordersCount"] = this.ordersCount;
        data["routeName"] = this.routeName;
        return data; 
    }
}

export interface IValidateRouteDuplicationResultDto {
    routeId: number;
    ordersCount: number;
    routeName: string | undefined;
}

export class ValidateOrderDestinationsResultDto implements IValidateOrderDestinationsResultDto {
    locationIds!: number[] | undefined;

    constructor(data?: IValidateOrderDestinationsResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["locationIds"])) {
                this.locationIds = [] as any;
                for (let item of data["locationIds"])
                    this.locationIds!.push(item);
            }
        }
    }

    static fromJS(data: any): ValidateOrderDestinationsResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new ValidateOrderDestinationsResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.locationIds)) {
            data["locationIds"] = [];
            for (let item of this.locationIds)
                data["locationIds"].push(item);
        }
        return data; 
    }
}

export interface IValidateOrderDestinationsResultDto {
    locationIds: number[] | undefined;
}

export class PagedResultDtoOfRouteListDto implements IPagedResultDtoOfRouteListDto {
    totalCount!: number;
    items!: RouteListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRouteListDto {
    totalCount: number;
    items: RouteListDto[] | undefined;
}

export class CreateRouteInput implements ICreateRouteInput {
    locationId!: number;
    vehicleId!: number | undefined;
    routeTemplateId!: number;
    loadDate!: moment.Moment;
    completion!: moment.Moment | undefined;
    departure!: moment.Moment | undefined;
    estimatedStartTime!: moment.Moment | undefined;
    locked!: boolean | undefined;

    constructor(data?: ICreateRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.vehicleId = data["vehicleId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.completion = data["completion"] ? moment(data["completion"].toString()) : <any>undefined;
            this.departure = data["departure"] ? moment(data["departure"].toString()) : <any>undefined;
            this.estimatedStartTime = data["estimatedStartTime"] ? moment(data["estimatedStartTime"].toString()) : <any>undefined;
            this.locked = data["locked"];
        }
    }

    static fromJS(data: any): CreateRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["vehicleId"] = this.vehicleId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["completion"] = this.completion ? this.completion.toISOString() : <any>undefined;
        data["departure"] = this.departure ? this.departure.toISOString() : <any>undefined;
        data["estimatedStartTime"] = this.estimatedStartTime ? this.estimatedStartTime.toISOString() : <any>undefined;
        data["locked"] = this.locked;
        return data; 
    }
}

export interface ICreateRouteInput {
    locationId: number;
    vehicleId: number | undefined;
    routeTemplateId: number;
    loadDate: moment.Moment;
    completion: moment.Moment | undefined;
    departure: moment.Moment | undefined;
    estimatedStartTime: moment.Moment | undefined;
    locked: boolean | undefined;
}

export class UpdateRouteInput implements IUpdateRouteInput {
    id!: number;
    locationId!: number;
    vehicleId!: number | undefined;
    driverId!: number | undefined;
    routeTemplateId!: number;
    loadDate!: moment.Moment;
    completion!: moment.Moment | undefined;
    departure!: moment.Moment | undefined;
    estimatedStartTime!: moment.Moment | undefined;
    locked!: boolean;
    isVisibleToDriver!: boolean;

    constructor(data?: IUpdateRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.locationId = data["locationId"];
            this.vehicleId = data["vehicleId"];
            this.driverId = data["driverId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.completion = data["completion"] ? moment(data["completion"].toString()) : <any>undefined;
            this.departure = data["departure"] ? moment(data["departure"].toString()) : <any>undefined;
            this.estimatedStartTime = data["estimatedStartTime"] ? moment(data["estimatedStartTime"].toString()) : <any>undefined;
            this.locked = data["locked"];
            this.isVisibleToDriver = data["isVisibleToDriver"];
        }
    }

    static fromJS(data: any): UpdateRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["locationId"] = this.locationId;
        data["vehicleId"] = this.vehicleId;
        data["driverId"] = this.driverId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["completion"] = this.completion ? this.completion.toISOString() : <any>undefined;
        data["departure"] = this.departure ? this.departure.toISOString() : <any>undefined;
        data["estimatedStartTime"] = this.estimatedStartTime ? this.estimatedStartTime.toISOString() : <any>undefined;
        data["locked"] = this.locked;
        data["isVisibleToDriver"] = this.isVisibleToDriver;
        return data; 
    }
}

export interface IUpdateRouteInput {
    id: number;
    locationId: number;
    vehicleId: number | undefined;
    driverId: number | undefined;
    routeTemplateId: number;
    loadDate: moment.Moment;
    completion: moment.Moment | undefined;
    departure: moment.Moment | undefined;
    estimatedStartTime: moment.Moment | undefined;
    locked: boolean;
    isVisibleToDriver: boolean;
}

export class GetAvailableRouteItemDto implements IGetAvailableRouteItemDto {
    id!: number;
    routeTemplateName!: string | undefined;
    timeZone!: string | undefined;
    loadDate!: moment.Moment;

    constructor(data?: IGetAvailableRouteItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeTemplateName = data["routeTemplateName"];
            this.timeZone = data["timeZone"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetAvailableRouteItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetAvailableRouteItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeTemplateName"] = this.routeTemplateName;
        data["timeZone"] = this.timeZone;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetAvailableRouteItemDto {
    id: number;
    routeTemplateName: string | undefined;
    timeZone: string | undefined;
    loadDate: moment.Moment;
}

export class PagedResultDtoOfGetAvailableRouteItemDto implements IPagedResultDtoOfGetAvailableRouteItemDto {
    totalCount!: number;
    items!: GetAvailableRouteItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetAvailableRouteItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetAvailableRouteItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetAvailableRouteItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetAvailableRouteItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetAvailableRouteItemDto {
    totalCount: number;
    items: GetAvailableRouteItemDto[] | undefined;
}

export class SetActiveRouteInput implements ISetActiveRouteInput {
    routeId!: number;

    constructor(data?: ISetActiveRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): SetActiveRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new SetActiveRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface ISetActiveRouteInput {
    routeId: number;
}

export class GetStopsRouteTypeDto implements IGetStopsRouteTypeDto {
    routeTypeCode!: string | undefined;
    description!: string | undefined;

    constructor(data?: IGetStopsRouteTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTypeCode = data["routeTypeCode"];
            this.description = data["description"];
        }
    }

    static fromJS(data: any): GetStopsRouteTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetStopsRouteTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTypeCode"] = this.routeTypeCode;
        data["description"] = this.description;
        return data; 
    }
}

export interface IGetStopsRouteTypeDto {
    routeTypeCode: string | undefined;
    description: string | undefined;
}

export class GetActiveRouteAddressTypeDto implements IGetActiveRouteAddressTypeDto {
    name!: string | undefined;

    constructor(data?: IGetActiveRouteAddressTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetActiveRouteAddressTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteAddressTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetActiveRouteAddressTypeDto {
    name: string | undefined;
}

export class GetActiveRouteAddressDto implements IGetActiveRouteAddressDto {
    addressType!: GetActiveRouteAddressTypeDto | undefined;
    addressLine1!: string | undefined;
    addressLine2!: string | undefined;
    postalCode!: DriverClientProfilePostalCodeDto | undefined;
    geocode!: GeocodeListDto | undefined;
    maxDistance!: number;

    constructor(data?: IGetActiveRouteAddressDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressType = data["addressType"] ? GetActiveRouteAddressTypeDto.fromJS(data["addressType"]) : <any>undefined;
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.postalCode = data["postalCode"] ? DriverClientProfilePostalCodeDto.fromJS(data["postalCode"]) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.maxDistance = data["maxDistance"];
        }
    }

    static fromJS(data: any): GetActiveRouteAddressDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteAddressDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressType"] = this.addressType ? this.addressType.toJSON() : <any>undefined;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["postalCode"] = this.postalCode ? this.postalCode.toJSON() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["maxDistance"] = this.maxDistance;
        return data; 
    }
}

export interface IGetActiveRouteAddressDto {
    addressType: GetActiveRouteAddressTypeDto | undefined;
    addressLine1: string | undefined;
    addressLine2: string | undefined;
    postalCode: DriverClientProfilePostalCodeDto | undefined;
    geocode: GeocodeListDto | undefined;
    maxDistance: number;
}

export class GetActiveRouteCompanyDto implements IGetActiveRouteCompanyDto {
    name!: string | undefined;

    constructor(data?: IGetActiveRouteCompanyDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetActiveRouteCompanyDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteCompanyDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetActiveRouteCompanyDto {
    name: string | undefined;
}

export class GetActiveRouteContactDto implements IGetActiveRouteContactDto {
    id!: number;
    firstName!: string | undefined;
    lastName!: string | undefined;
    address!: GetActiveRouteAddressDto | undefined;
    company!: GetActiveRouteCompanyDto | undefined;
    phoneNumbers!: string[] | undefined;
    settings!: GetContactSettingsItemDto[] | undefined;

    constructor(data?: IGetActiveRouteContactDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.address = data["address"] ? GetActiveRouteAddressDto.fromJS(data["address"]) : <any>undefined;
            this.company = data["company"] ? GetActiveRouteCompanyDto.fromJS(data["company"]) : <any>undefined;
            if (Array.isArray(data["phoneNumbers"])) {
                this.phoneNumbers = [] as any;
                for (let item of data["phoneNumbers"])
                    this.phoneNumbers!.push(item);
            }
            if (Array.isArray(data["settings"])) {
                this.settings = [] as any;
                for (let item of data["settings"])
                    this.settings!.push(GetContactSettingsItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetActiveRouteContactDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteContactDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["company"] = this.company ? this.company.toJSON() : <any>undefined;
        if (Array.isArray(this.phoneNumbers)) {
            data["phoneNumbers"] = [];
            for (let item of this.phoneNumbers)
                data["phoneNumbers"].push(item);
        }
        if (Array.isArray(this.settings)) {
            data["settings"] = [];
            for (let item of this.settings)
                data["settings"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetActiveRouteContactDto {
    id: number;
    firstName: string | undefined;
    lastName: string | undefined;
    address: GetActiveRouteAddressDto | undefined;
    company: GetActiveRouteCompanyDto | undefined;
    phoneNumbers: string[] | undefined;
    settings: GetContactSettingsItemDto[] | undefined;
}

export class GetActiveRouteNoteDto implements IGetActiveRouteNoteDto {
    content!: string | undefined;

    constructor(data?: IGetActiveRouteNoteDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.content = data["content"];
        }
    }

    static fromJS(data: any): GetActiveRouteNoteDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteNoteDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["content"] = this.content;
        return data; 
    }
}

export interface IGetActiveRouteNoteDto {
    content: string | undefined;
}

export class GetActiveRouteOrderStatusTypeDto implements IGetActiveRouteOrderStatusTypeDto {
    code!: string | undefined;

    constructor(data?: IGetActiveRouteOrderStatusTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
        }
    }

    static fromJS(data: any): GetActiveRouteOrderStatusTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteOrderStatusTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        return data; 
    }
}

export interface IGetActiveRouteOrderStatusTypeDto {
    code: string | undefined;
}

export class GetActiveRouteOrderPackageDto implements IGetActiveRouteOrderPackageDto {
    package!: ShippingPackageListDto | undefined;
    quantity!: number;

    constructor(data?: IGetActiveRouteOrderPackageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.package = data["package"] ? ShippingPackageListDto.fromJS(data["package"]) : <any>undefined;
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): GetActiveRouteOrderPackageDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteOrderPackageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["package"] = this.package ? this.package.toJSON() : <any>undefined;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface IGetActiveRouteOrderPackageDto {
    package: ShippingPackageListDto | undefined;
    quantity: number;
}

export class GetActiveRouteTag implements IGetActiveRouteTag {
    name!: string | undefined;

    constructor(data?: IGetActiveRouteTag) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetActiveRouteTag {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteTag();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetActiveRouteTag {
    name: string | undefined;
}

export class GetActiveRouteOrderTagDto implements IGetActiveRouteOrderTagDto {
    tag!: GetActiveRouteTag | undefined;

    constructor(data?: IGetActiveRouteOrderTagDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tag = data["tag"] ? GetActiveRouteTag.fromJS(data["tag"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetActiveRouteOrderTagDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteOrderTagDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tag"] = this.tag ? this.tag.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetActiveRouteOrderTagDto {
    tag: GetActiveRouteTag | undefined;
}

export class GetActiveRouteOrderStopOrderTypeDto implements IGetActiveRouteOrderStopOrderTypeDto {
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    textColor!: string | undefined;

    constructor(data?: IGetActiveRouteOrderStopOrderTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.textColor = data["textColor"];
        }
    }

    static fromJS(data: any): GetActiveRouteOrderStopOrderTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteOrderStopOrderTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["textColor"] = this.textColor;
        return data; 
    }
}

export interface IGetActiveRouteOrderStopOrderTypeDto {
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    textColor: string | undefined;
}

export class GetActiveRouteOrderStopListDto implements IGetActiveRouteOrderStopListDto {
    id!: number;
    contact!: GetActiveRouteContactDto | undefined;
    note!: GetActiveRouteNoteDto | undefined;
    status!: GetActiveRouteOrderStatusTypeDto | undefined;
    orderPackages!: GetActiveRouteOrderPackageDto[] | undefined;
    orderTags!: GetActiveRouteOrderTagDto[] | undefined;
    sortOrder!: number | undefined;
    hasReadNote!: boolean;
    clinicNotesVisibleToDriver!: boolean;
    notesVisibleToDriver!: boolean;
    orderType!: GetActiveRouteOrderStopOrderTypeDto | undefined;
    linehaulParentRouteId!: number | undefined;
    lineHaulParentRouteCode!: string | undefined;

    constructor(data?: IGetActiveRouteOrderStopListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.contact = data["contact"] ? GetActiveRouteContactDto.fromJS(data["contact"]) : <any>undefined;
            this.note = data["note"] ? GetActiveRouteNoteDto.fromJS(data["note"]) : <any>undefined;
            this.status = data["status"] ? GetActiveRouteOrderStatusTypeDto.fromJS(data["status"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(GetActiveRouteOrderPackageDto.fromJS(item));
            }
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(GetActiveRouteOrderTagDto.fromJS(item));
            }
            this.sortOrder = data["sortOrder"];
            this.hasReadNote = data["hasReadNote"];
            this.clinicNotesVisibleToDriver = data["clinicNotesVisibleToDriver"];
            this.notesVisibleToDriver = data["notesVisibleToDriver"];
            this.orderType = data["orderType"] ? GetActiveRouteOrderStopOrderTypeDto.fromJS(data["orderType"]) : <any>undefined;
            this.linehaulParentRouteId = data["linehaulParentRouteId"];
            this.lineHaulParentRouteCode = data["lineHaulParentRouteCode"];
        }
    }

    static fromJS(data: any): GetActiveRouteOrderStopListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteOrderStopListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["status"] = this.status ? this.status.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        data["sortOrder"] = this.sortOrder;
        data["hasReadNote"] = this.hasReadNote;
        data["clinicNotesVisibleToDriver"] = this.clinicNotesVisibleToDriver;
        data["notesVisibleToDriver"] = this.notesVisibleToDriver;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["linehaulParentRouteId"] = this.linehaulParentRouteId;
        data["lineHaulParentRouteCode"] = this.lineHaulParentRouteCode;
        return data; 
    }
}

export interface IGetActiveRouteOrderStopListDto {
    id: number;
    contact: GetActiveRouteContactDto | undefined;
    note: GetActiveRouteNoteDto | undefined;
    status: GetActiveRouteOrderStatusTypeDto | undefined;
    orderPackages: GetActiveRouteOrderPackageDto[] | undefined;
    orderTags: GetActiveRouteOrderTagDto[] | undefined;
    sortOrder: number | undefined;
    hasReadNote: boolean;
    clinicNotesVisibleToDriver: boolean;
    notesVisibleToDriver: boolean;
    orderType: GetActiveRouteOrderStopOrderTypeDto | undefined;
    linehaulParentRouteId: number | undefined;
    lineHaulParentRouteCode: string | undefined;
}

export class GetActiveRouteStopDestinationDetail implements IGetActiveRouteStopDestinationDetail {
    id!: number;
    note!: string | undefined;
    contact!: GetActiveRouteContactDto | undefined;
    etaStart!: moment.Moment;
    etaEnd!: moment.Moment;
    sortOrder!: number;
    orders!: GetActiveRouteOrderStopListDto[] | undefined;
    containers!: DestinationContainerListItemDto[] | undefined;
    notificationCodes!: string[] | undefined;

    constructor(data?: IGetActiveRouteStopDestinationDetail) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.note = data["note"];
            this.contact = data["contact"] ? GetActiveRouteContactDto.fromJS(data["contact"]) : <any>undefined;
            this.etaStart = data["etaStart"] ? moment(data["etaStart"].toString()) : <any>undefined;
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
            this.sortOrder = data["sortOrder"];
            if (Array.isArray(data["orders"])) {
                this.orders = [] as any;
                for (let item of data["orders"])
                    this.orders!.push(GetActiveRouteOrderStopListDto.fromJS(item));
            }
            if (Array.isArray(data["containers"])) {
                this.containers = [] as any;
                for (let item of data["containers"])
                    this.containers!.push(DestinationContainerListItemDto.fromJS(item));
            }
            if (Array.isArray(data["notificationCodes"])) {
                this.notificationCodes = [] as any;
                for (let item of data["notificationCodes"])
                    this.notificationCodes!.push(item);
            }
        }
    }

    static fromJS(data: any): GetActiveRouteStopDestinationDetail {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteStopDestinationDetail();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["note"] = this.note;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["etaStart"] = this.etaStart ? this.etaStart.toISOString() : <any>undefined;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        data["sortOrder"] = this.sortOrder;
        if (Array.isArray(this.orders)) {
            data["orders"] = [];
            for (let item of this.orders)
                data["orders"].push(item.toJSON());
        }
        if (Array.isArray(this.containers)) {
            data["containers"] = [];
            for (let item of this.containers)
                data["containers"].push(item.toJSON());
        }
        if (Array.isArray(this.notificationCodes)) {
            data["notificationCodes"] = [];
            for (let item of this.notificationCodes)
                data["notificationCodes"].push(item);
        }
        return data; 
    }
}

export interface IGetActiveRouteStopDestinationDetail {
    id: number;
    note: string | undefined;
    contact: GetActiveRouteContactDto | undefined;
    etaStart: moment.Moment;
    etaEnd: moment.Moment;
    sortOrder: number;
    orders: GetActiveRouteOrderStopListDto[] | undefined;
    containers: DestinationContainerListItemDto[] | undefined;
    notificationCodes: string[] | undefined;
}

export class GetActiveRouteStopDto implements IGetActiveRouteStopDto {
    id!: number;
    routeTemplateName!: string | undefined;
    loadDate!: moment.Moment;
    locationId!: number;
    vehicleId!: number;
    departure!: moment.Moment | undefined;
    timezone!: string | undefined;
    mobileTimezone!: string | undefined;
    routeType!: GetStopsRouteTypeDto | undefined;
    routeTypes!: GetStopsRouteTypeDto[] | undefined;
    destinations!: GetActiveRouteStopDestinationDetail[] | undefined;
    forConfirmation!: GetActiveRouteStopDestinationDetail[] | undefined;
    cancelled!: GetActiveRouteStopDestinationDetail[] | undefined;

    constructor(data?: IGetActiveRouteStopDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeTemplateName = data["routeTemplateName"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.locationId = data["locationId"];
            this.vehicleId = data["vehicleId"];
            this.departure = data["departure"] ? moment(data["departure"].toString()) : <any>undefined;
            this.timezone = data["timezone"];
            this.mobileTimezone = data["mobileTimezone"];
            this.routeType = data["routeType"] ? GetStopsRouteTypeDto.fromJS(data["routeType"]) : <any>undefined;
            if (Array.isArray(data["routeTypes"])) {
                this.routeTypes = [] as any;
                for (let item of data["routeTypes"])
                    this.routeTypes!.push(GetStopsRouteTypeDto.fromJS(item));
            }
            if (Array.isArray(data["destinations"])) {
                this.destinations = [] as any;
                for (let item of data["destinations"])
                    this.destinations!.push(GetActiveRouteStopDestinationDetail.fromJS(item));
            }
            if (Array.isArray(data["forConfirmation"])) {
                this.forConfirmation = [] as any;
                for (let item of data["forConfirmation"])
                    this.forConfirmation!.push(GetActiveRouteStopDestinationDetail.fromJS(item));
            }
            if (Array.isArray(data["cancelled"])) {
                this.cancelled = [] as any;
                for (let item of data["cancelled"])
                    this.cancelled!.push(GetActiveRouteStopDestinationDetail.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetActiveRouteStopDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteStopDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeTemplateName"] = this.routeTemplateName;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["locationId"] = this.locationId;
        data["vehicleId"] = this.vehicleId;
        data["departure"] = this.departure ? this.departure.toISOString() : <any>undefined;
        data["timezone"] = this.timezone;
        data["mobileTimezone"] = this.mobileTimezone;
        data["routeType"] = this.routeType ? this.routeType.toJSON() : <any>undefined;
        if (Array.isArray(this.routeTypes)) {
            data["routeTypes"] = [];
            for (let item of this.routeTypes)
                data["routeTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.destinations)) {
            data["destinations"] = [];
            for (let item of this.destinations)
                data["destinations"].push(item.toJSON());
        }
        if (Array.isArray(this.forConfirmation)) {
            data["forConfirmation"] = [];
            for (let item of this.forConfirmation)
                data["forConfirmation"].push(item.toJSON());
        }
        if (Array.isArray(this.cancelled)) {
            data["cancelled"] = [];
            for (let item of this.cancelled)
                data["cancelled"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetActiveRouteStopDto {
    id: number;
    routeTemplateName: string | undefined;
    loadDate: moment.Moment;
    locationId: number;
    vehicleId: number;
    departure: moment.Moment | undefined;
    timezone: string | undefined;
    mobileTimezone: string | undefined;
    routeType: GetStopsRouteTypeDto | undefined;
    routeTypes: GetStopsRouteTypeDto[] | undefined;
    destinations: GetActiveRouteStopDestinationDetail[] | undefined;
    forConfirmation: GetActiveRouteStopDestinationDetail[] | undefined;
    cancelled: GetActiveRouteStopDestinationDetail[] | undefined;
}

export class SortOrderInputItem implements ISortOrderInputItem {
    routeOrderId!: number;
    sortOrder!: number;

    constructor(data?: ISortOrderInputItem) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeOrderId = data["routeOrderId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): SortOrderInputItem {
        data = typeof data === 'object' ? data : {};
        let result = new SortOrderInputItem();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeOrderId"] = this.routeOrderId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface ISortOrderInputItem {
    routeOrderId: number;
    sortOrder: number;
}

export class ChangeSortOrderInput implements IChangeSortOrderInput {
    routeId!: number;
    items!: SortOrderInputItem[] | undefined;

    constructor(data?: IChangeSortOrderInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SortOrderInputItem.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ChangeSortOrderInput {
        data = typeof data === 'object' ? data : {};
        let result = new ChangeSortOrderInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IChangeSortOrderInput {
    routeId: number;
    items: SortOrderInputItem[] | undefined;
}

export class GetActiveRouteDestinationDetailDto implements IGetActiveRouteDestinationDetailDto {
    contact!: GetActiveRouteContactDto | undefined;
    etaStart!: moment.Moment;
    etaEnd!: moment.Moment;

    constructor(data?: IGetActiveRouteDestinationDetailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contact = data["contact"] ? GetActiveRouteContactDto.fromJS(data["contact"]) : <any>undefined;
            this.etaStart = data["etaStart"] ? moment(data["etaStart"].toString()) : <any>undefined;
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetActiveRouteDestinationDetailDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteDestinationDetailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["etaStart"] = this.etaStart ? this.etaStart.toISOString() : <any>undefined;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetActiveRouteDestinationDetailDto {
    contact: GetActiveRouteContactDto | undefined;
    etaStart: moment.Moment;
    etaEnd: moment.Moment;
}

export class GetActiveRouteOrderDto implements IGetActiveRouteOrderDto {
    id!: number;
    pickupDetail!: GetActiveRouteDestinationDetailDto | undefined;
    deliveryDetail!: GetActiveRouteDestinationDetailDto | undefined;
    note!: GetActiveRouteNoteDto | undefined;
    status!: GetActiveRouteOrderStatusTypeDto | undefined;
    orderPackages!: GetActiveRouteOrderPackageDto[] | undefined;
    orderTags!: GetActiveRouteOrderTagDto[] | undefined;
    sortOrder!: number;

    constructor(data?: IGetActiveRouteOrderDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.pickupDetail = data["pickupDetail"] ? GetActiveRouteDestinationDetailDto.fromJS(data["pickupDetail"]) : <any>undefined;
            this.deliveryDetail = data["deliveryDetail"] ? GetActiveRouteDestinationDetailDto.fromJS(data["deliveryDetail"]) : <any>undefined;
            this.note = data["note"] ? GetActiveRouteNoteDto.fromJS(data["note"]) : <any>undefined;
            this.status = data["status"] ? GetActiveRouteOrderStatusTypeDto.fromJS(data["status"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(GetActiveRouteOrderPackageDto.fromJS(item));
            }
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(GetActiveRouteOrderTagDto.fromJS(item));
            }
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): GetActiveRouteOrderDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetActiveRouteOrderDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["pickupDetail"] = this.pickupDetail ? this.pickupDetail.toJSON() : <any>undefined;
        data["deliveryDetail"] = this.deliveryDetail ? this.deliveryDetail.toJSON() : <any>undefined;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["status"] = this.status ? this.status.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IGetActiveRouteOrderDto {
    id: number;
    pickupDetail: GetActiveRouteDestinationDetailDto | undefined;
    deliveryDetail: GetActiveRouteDestinationDetailDto | undefined;
    note: GetActiveRouteNoteDto | undefined;
    status: GetActiveRouteOrderStatusTypeDto | undefined;
    orderPackages: GetActiveRouteOrderPackageDto[] | undefined;
    orderTags: GetActiveRouteOrderTagDto[] | undefined;
    sortOrder: number;
}

export class SetStartTimeInputDto implements ISetStartTimeInputDto {
    routeId!: number;
    vehicleId!: number;
    time!: moment.Moment;
    latitude!: number | undefined;
    longitude!: number | undefined;

    constructor(data?: ISetStartTimeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.vehicleId = data["vehicleId"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): SetStartTimeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new SetStartTimeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["vehicleId"] = this.vehicleId;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface ISetStartTimeInputDto {
    routeId: number;
    vehicleId: number;
    time: moment.Moment;
    latitude: number | undefined;
    longitude: number | undefined;
}

export class ArriveAtDestinationInputDto implements IArriveAtDestinationInputDto {
    routeId!: number;
    destinationId!: number;
    time!: moment.Moment;

    constructor(data?: IArriveAtDestinationInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.destinationId = data["destinationId"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): ArriveAtDestinationInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new ArriveAtDestinationInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["destinationId"] = this.destinationId;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IArriveAtDestinationInputDto {
    routeId: number;
    destinationId: number;
    time: moment.Moment;
}

export class UpdateRouteId implements IUpdateRouteId {
    id!: number;

    constructor(data?: IUpdateRouteId) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UpdateRouteId {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteId();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        return data; 
    }
}

export interface IUpdateRouteId {
    id: number;
}

export class GetLinehaulRouteForDestinationResponseDto implements IGetLinehaulRouteForDestinationResponseDto {
    routeId!: number;
    routeTemplateName!: string | undefined;
    loadDate!: moment.Moment;
    destination!: GetActiveRouteStopDestinationDetail | undefined;

    constructor(data?: IGetLinehaulRouteForDestinationResponseDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.routeTemplateName = data["routeTemplateName"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.destination = data["destination"] ? GetActiveRouteStopDestinationDetail.fromJS(data["destination"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetLinehaulRouteForDestinationResponseDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetLinehaulRouteForDestinationResponseDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["routeTemplateName"] = this.routeTemplateName;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["destination"] = this.destination ? this.destination.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetLinehaulRouteForDestinationResponseDto {
    routeId: number;
    routeTemplateName: string | undefined;
    loadDate: moment.Moment;
    destination: GetActiveRouteStopDestinationDetail | undefined;
}

export class GetDestinationsForRouteResponseDto implements IGetDestinationsForRouteResponseDto {
    destinations!: GetActiveRouteStopDestinationDetail[] | undefined;

    constructor(data?: IGetDestinationsForRouteResponseDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["destinations"])) {
                this.destinations = [] as any;
                for (let item of data["destinations"])
                    this.destinations!.push(GetActiveRouteStopDestinationDetail.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetDestinationsForRouteResponseDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDestinationsForRouteResponseDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.destinations)) {
            data["destinations"] = [];
            for (let item of this.destinations)
                data["destinations"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetDestinationsForRouteResponseDto {
    destinations: GetActiveRouteStopDestinationDetail[] | undefined;
}

export class CreateOrUpdateDestinationForRouteInputDto implements ICreateOrUpdateDestinationForRouteInputDto {
    routeId!: number;
    destinationId!: number;
    sortOrder!: number;

    constructor(data?: ICreateOrUpdateDestinationForRouteInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.destinationId = data["destinationId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): CreateOrUpdateDestinationForRouteInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateDestinationForRouteInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["destinationId"] = this.destinationId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface ICreateOrUpdateDestinationForRouteInputDto {
    routeId: number;
    destinationId: number;
    sortOrder: number;
}

export class DestinationContainerInputItemDto implements IDestinationContainerInputItemDto {
    containerId!: number;
    quantity!: number;

    constructor(data?: IDestinationContainerInputItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.containerId = data["containerId"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): DestinationContainerInputItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new DestinationContainerInputItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["containerId"] = this.containerId;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface IDestinationContainerInputItemDto {
    containerId: number;
    quantity: number;
}

export class SetContainersForDestinationInputDto implements ISetContainersForDestinationInputDto {
    routeId!: number;
    destinationId!: number;
    time!: moment.Moment;
    orderStatusTypeId!: number;
    geocode!: CreateGeocodeInput | undefined;
    containers!: DestinationContainerInputItemDto[] | undefined;

    constructor(data?: ISetContainersForDestinationInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.destinationId = data["destinationId"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.geocode = data["geocode"] ? CreateGeocodeInput.fromJS(data["geocode"]) : <any>undefined;
            if (Array.isArray(data["containers"])) {
                this.containers = [] as any;
                for (let item of data["containers"])
                    this.containers!.push(DestinationContainerInputItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): SetContainersForDestinationInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new SetContainersForDestinationInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["destinationId"] = this.destinationId;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        if (Array.isArray(this.containers)) {
            data["containers"] = [];
            for (let item of this.containers)
                data["containers"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ISetContainersForDestinationInputDto {
    routeId: number;
    destinationId: number;
    time: moment.Moment;
    orderStatusTypeId: number;
    geocode: CreateGeocodeInput | undefined;
    containers: DestinationContainerInputItemDto[] | undefined;
}

export class RouteDetailsKpi implements IRouteDetailsKpi {
    orderSourceId!: number;
    orderTypeName!: string | undefined;
    orderTotal!: number;
    orderDelivered!: number;
    color!: string | undefined;
    orderTypeId!: number | undefined;
    orderDeliverPercent!: number;

    constructor(data?: IRouteDetailsKpi) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderSourceId = data["orderSourceId"];
            this.orderTypeName = data["orderTypeName"];
            this.orderTotal = data["orderTotal"];
            this.orderDelivered = data["orderDelivered"];
            this.color = data["color"];
            this.orderTypeId = data["orderTypeId"];
            this.orderDeliverPercent = data["orderDeliverPercent"];
        }
    }

    static fromJS(data: any): RouteDetailsKpi {
        data = typeof data === 'object' ? data : {};
        let result = new RouteDetailsKpi();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderSourceId"] = this.orderSourceId;
        data["orderTypeName"] = this.orderTypeName;
        data["orderTotal"] = this.orderTotal;
        data["orderDelivered"] = this.orderDelivered;
        data["color"] = this.color;
        data["orderTypeId"] = this.orderTypeId;
        data["orderDeliverPercent"] = this.orderDeliverPercent;
        return data; 
    }
}

export interface IRouteDetailsKpi {
    orderSourceId: number;
    orderTypeName: string | undefined;
    orderTotal: number;
    orderDelivered: number;
    color: string | undefined;
    orderTypeId: number | undefined;
    orderDeliverPercent: number;
}

export class UpdateEstimatedStartTimeInput implements IUpdateEstimatedStartTimeInput {
    loadDate!: string | undefined;
    routeId!: number | undefined;
    locationId!: number | undefined;

    constructor(data?: IUpdateEstimatedStartTimeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.loadDate = data["loadDate"];
            this.routeId = data["routeId"];
            this.locationId = data["locationId"];
        }
    }

    static fromJS(data: any): UpdateEstimatedStartTimeInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateEstimatedStartTimeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["loadDate"] = this.loadDate;
        data["routeId"] = this.routeId;
        data["locationId"] = this.locationId;
        return data; 
    }
}

export interface IUpdateEstimatedStartTimeInput {
    loadDate: string | undefined;
    routeId: number | undefined;
    locationId: number | undefined;
}

export class CreateOptimizeInputDto implements ICreateOptimizeInputDto {
    routeId!: number;
    isReOptimize!: boolean | undefined;

    constructor(data?: ICreateOptimizeInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.isReOptimize = data["isReOptimize"];
        }
    }

    static fromJS(data: any): CreateOptimizeInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOptimizeInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["isReOptimize"] = this.isReOptimize;
        return data; 
    }
}

export interface ICreateOptimizeInputDto {
    routeId: number;
    isReOptimize: boolean | undefined;
}

export class Route4MeSettingDto implements IRoute4MeSettingDto {
    code!: string | undefined;
    value!: string | undefined;
    id!: number;

    constructor(data?: IRoute4MeSettingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Route4MeSettingDto {
        data = typeof data === 'object' ? data : {};
        let result = new Route4MeSettingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRoute4MeSettingDto {
    code: string | undefined;
    value: string | undefined;
    id: number;
}

export class GetRoute4MeSettingForViewDto implements IGetRoute4MeSettingForViewDto {
    route4MeSetting!: Route4MeSettingDto | undefined;

    constructor(data?: IGetRoute4MeSettingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.route4MeSetting = data["route4MeSetting"] ? Route4MeSettingDto.fromJS(data["route4MeSetting"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRoute4MeSettingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRoute4MeSettingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["route4MeSetting"] = this.route4MeSetting ? this.route4MeSetting.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRoute4MeSettingForViewDto {
    route4MeSetting: Route4MeSettingDto | undefined;
}

export class PagedResultDtoOfGetRoute4MeSettingForViewDto implements IPagedResultDtoOfGetRoute4MeSettingForViewDto {
    totalCount!: number;
    items!: GetRoute4MeSettingForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRoute4MeSettingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRoute4MeSettingForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRoute4MeSettingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRoute4MeSettingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRoute4MeSettingForViewDto {
    totalCount: number;
    items: GetRoute4MeSettingForViewDto[] | undefined;
}

export class CreateOrEditRoute4MeSettingDto implements ICreateOrEditRoute4MeSettingDto {
    code!: string;
    value!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRoute4MeSettingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRoute4MeSettingDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRoute4MeSettingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRoute4MeSettingDto {
    code: string;
    value: string | undefined;
    id: number | undefined;
}

export class GetRoute4MeSettingForEditOutput implements IGetRoute4MeSettingForEditOutput {
    route4MeSetting!: CreateOrEditRoute4MeSettingDto | undefined;

    constructor(data?: IGetRoute4MeSettingForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.route4MeSetting = data["route4MeSetting"] ? CreateOrEditRoute4MeSettingDto.fromJS(data["route4MeSetting"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRoute4MeSettingForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRoute4MeSettingForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["route4MeSetting"] = this.route4MeSetting ? this.route4MeSetting.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRoute4MeSettingForEditOutput {
    route4MeSetting: CreateOrEditRoute4MeSettingDto | undefined;
}

export class TimeDateList implements ITimeDateList {
    arrivalTime!: moment.Moment | undefined;
    loadDate!: string | undefined;
    arriveTime!: string | undefined;
    over!: boolean;
    day!: number;

    constructor(data?: ITimeDateList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.arrivalTime = data["arrivalTime"] ? moment(data["arrivalTime"].toString()) : <any>undefined;
            this.loadDate = data["loadDate"];
            this.arriveTime = data["arriveTime"];
            this.over = data["over"];
            this.day = data["day"];
        }
    }

    static fromJS(data: any): TimeDateList {
        data = typeof data === 'object' ? data : {};
        let result = new TimeDateList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["arrivalTime"] = this.arrivalTime ? this.arrivalTime.toISOString() : <any>undefined;
        data["loadDate"] = this.loadDate;
        data["arriveTime"] = this.arriveTime;
        data["over"] = this.over;
        data["day"] = this.day;
        return data; 
    }
}

export interface ITimeDateList {
    arrivalTime: moment.Moment | undefined;
    loadDate: string | undefined;
    arriveTime: string | undefined;
    over: boolean;
    day: number;
}

export class RouteAnalyzerOrderDto implements IRouteAnalyzerOrderDto {
    routeScheduleId!: number;
    routeScheduleDetailId!: number;
    accountNumber!: string | undefined;
    clinicName!: string | undefined;
    loadDate!: string | undefined;
    timeDateList!: TimeDateList[] | undefined;
    timeList!: TimeSpan[] | undefined;
    timeAverage!: TimeSpan | undefined;
    timeAverageWithExclusion!: string | undefined;
    timeSD!: TimeSpan | undefined;
    time1SD!: TimeSpan | undefined;
    time2SD!: TimeSpan | undefined;
    timeListWithExclusion!: TimeSpan[] | undefined;
    timeSDString!: string | undefined;
    time1SDString!: string | undefined;
    time2SDString!: string | undefined;
    timeAverageString!: string | undefined;
    timeAverageWithExclusionString!: string | undefined;
    startDate!: string | undefined;
    analyzedTime!: string | undefined;
    analyzedBy!: string | undefined;
    selected!: boolean;
    day!: number;

    constructor(data?: IRouteAnalyzerOrderDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeScheduleId = data["routeScheduleId"];
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.accountNumber = data["accountNumber"];
            this.clinicName = data["clinicName"];
            this.loadDate = data["loadDate"];
            if (Array.isArray(data["timeDateList"])) {
                this.timeDateList = [] as any;
                for (let item of data["timeDateList"])
                    this.timeDateList!.push(TimeDateList.fromJS(item));
            }
            if (Array.isArray(data["timeList"])) {
                this.timeList = [] as any;
                for (let item of data["timeList"])
                    this.timeList!.push(TimeSpan.fromJS(item));
            }
            this.timeAverage = data["timeAverage"] ? TimeSpan.fromJS(data["timeAverage"]) : <any>undefined;
            this.timeAverageWithExclusion = data["timeAverageWithExclusion"];
            this.timeSD = data["timeSD"] ? TimeSpan.fromJS(data["timeSD"]) : <any>undefined;
            this.time1SD = data["time1SD"] ? TimeSpan.fromJS(data["time1SD"]) : <any>undefined;
            this.time2SD = data["time2SD"] ? TimeSpan.fromJS(data["time2SD"]) : <any>undefined;
            if (Array.isArray(data["timeListWithExclusion"])) {
                this.timeListWithExclusion = [] as any;
                for (let item of data["timeListWithExclusion"])
                    this.timeListWithExclusion!.push(TimeSpan.fromJS(item));
            }
            this.timeSDString = data["timeSDString"];
            this.time1SDString = data["time1SDString"];
            this.time2SDString = data["time2SDString"];
            this.timeAverageString = data["timeAverageString"];
            this.timeAverageWithExclusionString = data["timeAverageWithExclusionString"];
            this.startDate = data["startDate"];
            this.analyzedTime = data["analyzedTime"];
            this.analyzedBy = data["analyzedBy"];
            this.selected = data["selected"];
            this.day = data["day"];
        }
    }

    static fromJS(data: any): RouteAnalyzerOrderDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteAnalyzerOrderDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeScheduleId"] = this.routeScheduleId;
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["accountNumber"] = this.accountNumber;
        data["clinicName"] = this.clinicName;
        data["loadDate"] = this.loadDate;
        if (Array.isArray(this.timeDateList)) {
            data["timeDateList"] = [];
            for (let item of this.timeDateList)
                data["timeDateList"].push(item.toJSON());
        }
        if (Array.isArray(this.timeList)) {
            data["timeList"] = [];
            for (let item of this.timeList)
                data["timeList"].push(item.toJSON());
        }
        data["timeAverage"] = this.timeAverage ? this.timeAverage.toJSON() : <any>undefined;
        data["timeAverageWithExclusion"] = this.timeAverageWithExclusion;
        data["timeSD"] = this.timeSD ? this.timeSD.toJSON() : <any>undefined;
        data["time1SD"] = this.time1SD ? this.time1SD.toJSON() : <any>undefined;
        data["time2SD"] = this.time2SD ? this.time2SD.toJSON() : <any>undefined;
        if (Array.isArray(this.timeListWithExclusion)) {
            data["timeListWithExclusion"] = [];
            for (let item of this.timeListWithExclusion)
                data["timeListWithExclusion"].push(item.toJSON());
        }
        data["timeSDString"] = this.timeSDString;
        data["time1SDString"] = this.time1SDString;
        data["time2SDString"] = this.time2SDString;
        data["timeAverageString"] = this.timeAverageString;
        data["timeAverageWithExclusionString"] = this.timeAverageWithExclusionString;
        data["startDate"] = this.startDate;
        data["analyzedTime"] = this.analyzedTime;
        data["analyzedBy"] = this.analyzedBy;
        data["selected"] = this.selected;
        data["day"] = this.day;
        return data; 
    }
}

export interface IRouteAnalyzerOrderDto {
    routeScheduleId: number;
    routeScheduleDetailId: number;
    accountNumber: string | undefined;
    clinicName: string | undefined;
    loadDate: string | undefined;
    timeDateList: TimeDateList[] | undefined;
    timeList: TimeSpan[] | undefined;
    timeAverage: TimeSpan | undefined;
    timeAverageWithExclusion: string | undefined;
    timeSD: TimeSpan | undefined;
    time1SD: TimeSpan | undefined;
    time2SD: TimeSpan | undefined;
    timeListWithExclusion: TimeSpan[] | undefined;
    timeSDString: string | undefined;
    time1SDString: string | undefined;
    time2SDString: string | undefined;
    timeAverageString: string | undefined;
    timeAverageWithExclusionString: string | undefined;
    startDate: string | undefined;
    analyzedTime: string | undefined;
    analyzedBy: string | undefined;
    selected: boolean;
    day: number;
}

export class RouteAnalyzerStopsDto implements IRouteAnalyzerStopsDto {
    routeTemplateId!: number;
    routeCode!: string | undefined;
    stopName!: string | undefined;
    address!: string | undefined;
    loadDate!: string | undefined;
    day!: number;
    timeDateList!: TimeDateList[] | undefined;
    timeList!: TimeSpan[] | undefined;
    timeListWithExclusion!: TimeSpan[] | undefined;
    timeAverage!: TimeSpan | undefined;
    timeAverageWithExclusion!: string | undefined;
    timeSD!: TimeSpan | undefined;
    time1SD!: TimeSpan | undefined;
    time2SD!: TimeSpan | undefined;
    timeSDString!: string | undefined;
    time1SDString!: string | undefined;
    time2SDString!: string | undefined;
    timeAverageString!: string | undefined;
    timeAverageWithExclusionString!: string | undefined;
    analyzedTime!: string | undefined;
    analyzedBy!: string | undefined;
    selected!: boolean;

    constructor(data?: IRouteAnalyzerStopsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateId = data["routeTemplateId"];
            this.routeCode = data["routeCode"];
            this.stopName = data["stopName"];
            this.address = data["address"];
            this.loadDate = data["loadDate"];
            this.day = data["day"];
            if (Array.isArray(data["timeDateList"])) {
                this.timeDateList = [] as any;
                for (let item of data["timeDateList"])
                    this.timeDateList!.push(TimeDateList.fromJS(item));
            }
            if (Array.isArray(data["timeList"])) {
                this.timeList = [] as any;
                for (let item of data["timeList"])
                    this.timeList!.push(TimeSpan.fromJS(item));
            }
            if (Array.isArray(data["timeListWithExclusion"])) {
                this.timeListWithExclusion = [] as any;
                for (let item of data["timeListWithExclusion"])
                    this.timeListWithExclusion!.push(TimeSpan.fromJS(item));
            }
            this.timeAverage = data["timeAverage"] ? TimeSpan.fromJS(data["timeAverage"]) : <any>undefined;
            this.timeAverageWithExclusion = data["timeAverageWithExclusion"];
            this.timeSD = data["timeSD"] ? TimeSpan.fromJS(data["timeSD"]) : <any>undefined;
            this.time1SD = data["time1SD"] ? TimeSpan.fromJS(data["time1SD"]) : <any>undefined;
            this.time2SD = data["time2SD"] ? TimeSpan.fromJS(data["time2SD"]) : <any>undefined;
            this.timeSDString = data["timeSDString"];
            this.time1SDString = data["time1SDString"];
            this.time2SDString = data["time2SDString"];
            this.timeAverageString = data["timeAverageString"];
            this.timeAverageWithExclusionString = data["timeAverageWithExclusionString"];
            this.analyzedTime = data["analyzedTime"];
            this.analyzedBy = data["analyzedBy"];
            this.selected = data["selected"];
        }
    }

    static fromJS(data: any): RouteAnalyzerStopsDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteAnalyzerStopsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeCode"] = this.routeCode;
        data["stopName"] = this.stopName;
        data["address"] = this.address;
        data["loadDate"] = this.loadDate;
        data["day"] = this.day;
        if (Array.isArray(this.timeDateList)) {
            data["timeDateList"] = [];
            for (let item of this.timeDateList)
                data["timeDateList"].push(item.toJSON());
        }
        if (Array.isArray(this.timeList)) {
            data["timeList"] = [];
            for (let item of this.timeList)
                data["timeList"].push(item.toJSON());
        }
        if (Array.isArray(this.timeListWithExclusion)) {
            data["timeListWithExclusion"] = [];
            for (let item of this.timeListWithExclusion)
                data["timeListWithExclusion"].push(item.toJSON());
        }
        data["timeAverage"] = this.timeAverage ? this.timeAverage.toJSON() : <any>undefined;
        data["timeAverageWithExclusion"] = this.timeAverageWithExclusion;
        data["timeSD"] = this.timeSD ? this.timeSD.toJSON() : <any>undefined;
        data["time1SD"] = this.time1SD ? this.time1SD.toJSON() : <any>undefined;
        data["time2SD"] = this.time2SD ? this.time2SD.toJSON() : <any>undefined;
        data["timeSDString"] = this.timeSDString;
        data["time1SDString"] = this.time1SDString;
        data["time2SDString"] = this.time2SDString;
        data["timeAverageString"] = this.timeAverageString;
        data["timeAverageWithExclusionString"] = this.timeAverageWithExclusionString;
        data["analyzedTime"] = this.analyzedTime;
        data["analyzedBy"] = this.analyzedBy;
        data["selected"] = this.selected;
        return data; 
    }
}

export interface IRouteAnalyzerStopsDto {
    routeTemplateId: number;
    routeCode: string | undefined;
    stopName: string | undefined;
    address: string | undefined;
    loadDate: string | undefined;
    day: number;
    timeDateList: TimeDateList[] | undefined;
    timeList: TimeSpan[] | undefined;
    timeListWithExclusion: TimeSpan[] | undefined;
    timeAverage: TimeSpan | undefined;
    timeAverageWithExclusion: string | undefined;
    timeSD: TimeSpan | undefined;
    time1SD: TimeSpan | undefined;
    time2SD: TimeSpan | undefined;
    timeSDString: string | undefined;
    time1SDString: string | undefined;
    time2SDString: string | undefined;
    timeAverageString: string | undefined;
    timeAverageWithExclusionString: string | undefined;
    analyzedTime: string | undefined;
    analyzedBy: string | undefined;
    selected: boolean;
}

export class UpdateScheduleInput implements IUpdateScheduleInput {
    routeScheduleId!: number;
    eta!: string | undefined;

    constructor(data?: IUpdateScheduleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeScheduleId = data["routeScheduleId"];
            this.eta = data["eta"];
        }
    }

    static fromJS(data: any): UpdateScheduleInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateScheduleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeScheduleId"] = this.routeScheduleId;
        data["eta"] = this.eta;
        return data; 
    }
}

export interface IUpdateScheduleInput {
    routeScheduleId: number;
    eta: string | undefined;
}

export class UpdateRoutetemplateInput implements IUpdateRoutetemplateInput {
    routeTemplateId!: number;
    endTime!: string | undefined;

    constructor(data?: IUpdateRoutetemplateInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateId = data["routeTemplateId"];
            this.endTime = data["endTime"];
        }
    }

    static fromJS(data: any): UpdateRoutetemplateInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRoutetemplateInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateId"] = this.routeTemplateId;
        data["endTime"] = this.endTime;
        return data; 
    }
}

export interface IUpdateRoutetemplateInput {
    routeTemplateId: number;
    endTime: string | undefined;
}

export class RouteCodeListInput implements IRouteCodeListInput {
    locationId!: number;

    constructor(data?: IRouteCodeListInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
        }
    }

    static fromJS(data: any): RouteCodeListInput {
        data = typeof data === 'object' ? data : {};
        let result = new RouteCodeListInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        return data; 
    }
}

export interface IRouteCodeListInput {
    locationId: number;
}

export class RouteCodeListInputFilter implements IRouteCodeListInputFilter {
    locationId!: number;
    filter!: string | undefined;
    maxResultCount!: number;
    skipCount!: number;

    constructor(data?: IRouteCodeListInputFilter) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.filter = data["filter"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
        }
    }

    static fromJS(data: any): RouteCodeListInputFilter {
        data = typeof data === 'object' ? data : {};
        let result = new RouteCodeListInputFilter();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["filter"] = this.filter;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        return data; 
    }
}

export interface IRouteCodeListInputFilter {
    locationId: number;
    filter: string | undefined;
    maxResultCount: number;
    skipCount: number;
}

export class RouteBuilderOrderList implements IRouteBuilderOrderList {
    id!: number;
    start!: boolean;
    end!: boolean;
    orderId!: number;
    routeId!: number;
    routeTemplateId!: number;
    latitude!: number;
    longitude!: number;
    address!: string | undefined;
    name!: string | undefined;
    sortOrder!: number;
    eta!: moment.Moment;
    etaString!: string | undefined;
    destinationDetailsId!: number;
    lockEta!: boolean;
    addressId!: number;
    pastDate!: boolean;
    statusId!: number;
    statusColor!: string | undefined;
    statusCode!: string | undefined;
    statusDescription!: string | undefined;
    delivered!: boolean;
    pickedUp!: boolean;
    statusIcon!: string | undefined;
    orderTypeId!: number | undefined;
    pickUpDestinationId!: number | undefined;
    deliveryDestinationId!: number | undefined;
    orderIds!: number[] | undefined;

    constructor(data?: IRouteBuilderOrderList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.start = data["start"];
            this.end = data["end"];
            this.orderId = data["orderId"];
            this.routeId = data["routeId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.address = data["address"];
            this.name = data["name"];
            this.sortOrder = data["sortOrder"];
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
            this.etaString = data["etaString"];
            this.destinationDetailsId = data["destinationDetailsId"];
            this.lockEta = data["lockEta"];
            this.addressId = data["addressId"];
            this.pastDate = data["pastDate"];
            this.statusId = data["statusId"];
            this.statusColor = data["statusColor"];
            this.statusCode = data["statusCode"];
            this.statusDescription = data["statusDescription"];
            this.delivered = data["delivered"];
            this.pickedUp = data["pickedUp"];
            this.statusIcon = data["statusIcon"];
            this.orderTypeId = data["orderTypeId"];
            this.pickUpDestinationId = data["pickUpDestinationId"];
            this.deliveryDestinationId = data["deliveryDestinationId"];
            if (Array.isArray(data["orderIds"])) {
                this.orderIds = [] as any;
                for (let item of data["orderIds"])
                    this.orderIds!.push(item);
            }
        }
    }

    static fromJS(data: any): RouteBuilderOrderList {
        data = typeof data === 'object' ? data : {};
        let result = new RouteBuilderOrderList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["start"] = this.start;
        data["end"] = this.end;
        data["orderId"] = this.orderId;
        data["routeId"] = this.routeId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["address"] = this.address;
        data["name"] = this.name;
        data["sortOrder"] = this.sortOrder;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        data["etaString"] = this.etaString;
        data["destinationDetailsId"] = this.destinationDetailsId;
        data["lockEta"] = this.lockEta;
        data["addressId"] = this.addressId;
        data["pastDate"] = this.pastDate;
        data["statusId"] = this.statusId;
        data["statusColor"] = this.statusColor;
        data["statusCode"] = this.statusCode;
        data["statusDescription"] = this.statusDescription;
        data["delivered"] = this.delivered;
        data["pickedUp"] = this.pickedUp;
        data["statusIcon"] = this.statusIcon;
        data["orderTypeId"] = this.orderTypeId;
        data["pickUpDestinationId"] = this.pickUpDestinationId;
        data["deliveryDestinationId"] = this.deliveryDestinationId;
        if (Array.isArray(this.orderIds)) {
            data["orderIds"] = [];
            for (let item of this.orderIds)
                data["orderIds"].push(item);
        }
        return data; 
    }
}

export interface IRouteBuilderOrderList {
    id: number;
    start: boolean;
    end: boolean;
    orderId: number;
    routeId: number;
    routeTemplateId: number;
    latitude: number;
    longitude: number;
    address: string | undefined;
    name: string | undefined;
    sortOrder: number;
    eta: moment.Moment;
    etaString: string | undefined;
    destinationDetailsId: number;
    lockEta: boolean;
    addressId: number;
    pastDate: boolean;
    statusId: number;
    statusColor: string | undefined;
    statusCode: string | undefined;
    statusDescription: string | undefined;
    delivered: boolean;
    pickedUp: boolean;
    statusIcon: string | undefined;
    orderTypeId: number | undefined;
    pickUpDestinationId: number | undefined;
    deliveryDestinationId: number | undefined;
    orderIds: number[] | undefined;
}

export class UpdateRouteByBuilderInput implements IUpdateRouteByBuilderInput {
    routeOrder!: RouteBuilderOrderList[] | undefined;
    traffic!: boolean;
    fromMove!: boolean | undefined;
    exludeCompleted!: boolean | undefined;
    routeStartInactive!: boolean | undefined;
    source!: string | undefined;

    constructor(data?: IUpdateRouteByBuilderInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["routeOrder"])) {
                this.routeOrder = [] as any;
                for (let item of data["routeOrder"])
                    this.routeOrder!.push(RouteBuilderOrderList.fromJS(item));
            }
            this.traffic = data["traffic"];
            this.fromMove = data["fromMove"];
            this.exludeCompleted = data["exludeCompleted"];
            this.routeStartInactive = data["routeStartInactive"];
            this.source = data["source"];
        }
    }

    static fromJS(data: any): UpdateRouteByBuilderInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteByBuilderInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.routeOrder)) {
            data["routeOrder"] = [];
            for (let item of this.routeOrder)
                data["routeOrder"].push(item.toJSON());
        }
        data["traffic"] = this.traffic;
        data["fromMove"] = this.fromMove;
        data["exludeCompleted"] = this.exludeCompleted;
        data["routeStartInactive"] = this.routeStartInactive;
        data["source"] = this.source;
        return data; 
    }
}

export interface IUpdateRouteByBuilderInput {
    routeOrder: RouteBuilderOrderList[] | undefined;
    traffic: boolean;
    fromMove: boolean | undefined;
    exludeCompleted: boolean | undefined;
    routeStartInactive: boolean | undefined;
    source: string | undefined;
}

export class RouteBuilderRouteIdOutput implements IRouteBuilderRouteIdOutput {
    routeOrder!: RouteBuilderOrderList[] | undefined;
    routeDate!: moment.Moment;
    routeId!: number;
    locationId!: number;
    route!: string | undefined;
    locationName!: string | undefined;
    routeStartInactive!: boolean | undefined;
    routeStopInactive!: boolean | undefined;
    displayRouteId!: boolean | undefined;

    constructor(data?: IRouteBuilderRouteIdOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["routeOrder"])) {
                this.routeOrder = [] as any;
                for (let item of data["routeOrder"])
                    this.routeOrder!.push(RouteBuilderOrderList.fromJS(item));
            }
            this.routeDate = data["routeDate"] ? moment(data["routeDate"].toString()) : <any>undefined;
            this.routeId = data["routeId"];
            this.locationId = data["locationId"];
            this.route = data["route"];
            this.locationName = data["locationName"];
            this.routeStartInactive = data["routeStartInactive"];
            this.routeStopInactive = data["routeStopInactive"];
            this.displayRouteId = data["displayRouteId"];
        }
    }

    static fromJS(data: any): RouteBuilderRouteIdOutput {
        data = typeof data === 'object' ? data : {};
        let result = new RouteBuilderRouteIdOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.routeOrder)) {
            data["routeOrder"] = [];
            for (let item of this.routeOrder)
                data["routeOrder"].push(item.toJSON());
        }
        data["routeDate"] = this.routeDate ? this.routeDate.toISOString() : <any>undefined;
        data["routeId"] = this.routeId;
        data["locationId"] = this.locationId;
        data["route"] = this.route;
        data["locationName"] = this.locationName;
        data["routeStartInactive"] = this.routeStartInactive;
        data["routeStopInactive"] = this.routeStopInactive;
        data["displayRouteId"] = this.displayRouteId;
        return data; 
    }
}

export interface IRouteBuilderRouteIdOutput {
    routeOrder: RouteBuilderOrderList[] | undefined;
    routeDate: moment.Moment;
    routeId: number;
    locationId: number;
    route: string | undefined;
    locationName: string | undefined;
    routeStartInactive: boolean | undefined;
    routeStopInactive: boolean | undefined;
    displayRouteId: boolean | undefined;
}

export class UpdateDestinationEtaInput implements IUpdateDestinationEtaInput {
    eta!: string | undefined;
    destinationDetail!: number;
    locationId!: number;
    address!: CreateAddressInput | undefined;
    latitude!: number;
    longitude!: number;

    constructor(data?: IUpdateDestinationEtaInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.eta = data["eta"];
            this.destinationDetail = data["destinationDetail"];
            this.locationId = data["locationId"];
            this.address = data["address"] ? CreateAddressInput.fromJS(data["address"]) : <any>undefined;
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): UpdateDestinationEtaInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateDestinationEtaInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["eta"] = this.eta;
        data["destinationDetail"] = this.destinationDetail;
        data["locationId"] = this.locationId;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface IUpdateDestinationEtaInput {
    eta: string | undefined;
    destinationDetail: number;
    locationId: number;
    address: CreateAddressInput | undefined;
    latitude: number;
    longitude: number;
}

export class RouteDefinitionDto implements IRouteDefinitionDto {
    threshold!: number;
    routeTypeId!: number | undefined;
    routeTemplateId!: number | undefined;
    inactive!: boolean;
    createdBy!: string | undefined;
    updatedBy!: string | undefined;
    createdTime!: moment.Moment | undefined;
    updatedTime!: moment.Moment | undefined;
    running!: boolean;
    id!: number;

    constructor(data?: IRouteDefinitionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.threshold = data["threshold"];
            this.routeTypeId = data["routeTypeId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.inactive = data["inactive"];
            this.createdBy = data["createdBy"];
            this.updatedBy = data["updatedBy"];
            this.createdTime = data["createdTime"] ? moment(data["createdTime"].toString()) : <any>undefined;
            this.updatedTime = data["updatedTime"] ? moment(data["updatedTime"].toString()) : <any>undefined;
            this.running = data["running"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteDefinitionDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteDefinitionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["threshold"] = this.threshold;
        data["routeTypeId"] = this.routeTypeId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["inactive"] = this.inactive;
        data["createdBy"] = this.createdBy;
        data["updatedBy"] = this.updatedBy;
        data["createdTime"] = this.createdTime ? this.createdTime.toISOString() : <any>undefined;
        data["updatedTime"] = this.updatedTime ? this.updatedTime.toISOString() : <any>undefined;
        data["running"] = this.running;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteDefinitionDto {
    threshold: number;
    routeTypeId: number | undefined;
    routeTemplateId: number | undefined;
    inactive: boolean;
    createdBy: string | undefined;
    updatedBy: string | undefined;
    createdTime: moment.Moment | undefined;
    updatedTime: moment.Moment | undefined;
    running: boolean;
    id: number;
}

export class GetRouteDefinitionForViewDto implements IGetRouteDefinitionForViewDto {
    routeDefinition!: RouteDefinitionDto | undefined;
    routeTypeRouteTypeCode!: string | undefined;
    routeTemplateName!: string | undefined;
    driver!: string | undefined;
    location!: string | undefined;
    routeStop!: string | undefined;
    routeStopLocation!: string | undefined;
    routeStart!: string | undefined;
    routeStartLocation!: string | undefined;
    routeStartAddress!: string | undefined;
    address!: string | undefined;
    manager!: string | undefined;
    assignedBy!: string | undefined;
    assignedDate!: moment.Moment | undefined;
    selectedRouteDefinition!: boolean;
    routeTemplateId!: number | undefined;
    routeStartInactive!: boolean;
    routeStopInactive!: boolean;
    isRunning!: boolean;

    constructor(data?: IGetRouteDefinitionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeDefinition = data["routeDefinition"] ? RouteDefinitionDto.fromJS(data["routeDefinition"]) : <any>undefined;
            this.routeTypeRouteTypeCode = data["routeTypeRouteTypeCode"];
            this.routeTemplateName = data["routeTemplateName"];
            this.driver = data["driver"];
            this.location = data["location"];
            this.routeStop = data["routeStop"];
            this.routeStopLocation = data["routeStopLocation"];
            this.routeStart = data["routeStart"];
            this.routeStartLocation = data["routeStartLocation"];
            this.routeStartAddress = data["routeStartAddress"];
            this.address = data["address"];
            this.manager = data["manager"];
            this.assignedBy = data["assignedBy"];
            this.assignedDate = data["assignedDate"] ? moment(data["assignedDate"].toString()) : <any>undefined;
            this.selectedRouteDefinition = data["selectedRouteDefinition"];
            this.routeTemplateId = data["routeTemplateId"];
            this.routeStartInactive = data["routeStartInactive"];
            this.routeStopInactive = data["routeStopInactive"];
            this.isRunning = data["isRunning"];
        }
    }

    static fromJS(data: any): GetRouteDefinitionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteDefinitionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeDefinition"] = this.routeDefinition ? this.routeDefinition.toJSON() : <any>undefined;
        data["routeTypeRouteTypeCode"] = this.routeTypeRouteTypeCode;
        data["routeTemplateName"] = this.routeTemplateName;
        data["driver"] = this.driver;
        data["location"] = this.location;
        data["routeStop"] = this.routeStop;
        data["routeStopLocation"] = this.routeStopLocation;
        data["routeStart"] = this.routeStart;
        data["routeStartLocation"] = this.routeStartLocation;
        data["routeStartAddress"] = this.routeStartAddress;
        data["address"] = this.address;
        data["manager"] = this.manager;
        data["assignedBy"] = this.assignedBy;
        data["assignedDate"] = this.assignedDate ? this.assignedDate.toISOString() : <any>undefined;
        data["selectedRouteDefinition"] = this.selectedRouteDefinition;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeStartInactive"] = this.routeStartInactive;
        data["routeStopInactive"] = this.routeStopInactive;
        data["isRunning"] = this.isRunning;
        return data; 
    }
}

export interface IGetRouteDefinitionForViewDto {
    routeDefinition: RouteDefinitionDto | undefined;
    routeTypeRouteTypeCode: string | undefined;
    routeTemplateName: string | undefined;
    driver: string | undefined;
    location: string | undefined;
    routeStop: string | undefined;
    routeStopLocation: string | undefined;
    routeStart: string | undefined;
    routeStartLocation: string | undefined;
    routeStartAddress: string | undefined;
    address: string | undefined;
    manager: string | undefined;
    assignedBy: string | undefined;
    assignedDate: moment.Moment | undefined;
    selectedRouteDefinition: boolean;
    routeTemplateId: number | undefined;
    routeStartInactive: boolean;
    routeStopInactive: boolean;
    isRunning: boolean;
}

export class PagedResultDtoOfGetRouteDefinitionForViewDto implements IPagedResultDtoOfGetRouteDefinitionForViewDto {
    totalCount!: number;
    items!: GetRouteDefinitionForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteDefinitionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteDefinitionForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteDefinitionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteDefinitionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteDefinitionForViewDto {
    totalCount: number;
    items: GetRouteDefinitionForViewDto[] | undefined;
}

export class GetAllRouteDefinitionsInput implements IGetAllRouteDefinitionsInput {
    filter!: string | undefined;
    routeTypeRouteTypeCodeFilter!: string | undefined;
    routeTemplateNameFilter!: string | undefined;
    routeTypeId!: number | undefined;
    driverId!: number | undefined;
    locationId!: number | undefined;
    managerId!: number | undefined;
    assignedById!: number | undefined;
    startDate!: moment.Moment | undefined;
    endDate!: moment.Moment | undefined;
    routeTemplateId!: number | undefined;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetAllRouteDefinitionsInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.filter = data["filter"];
            this.routeTypeRouteTypeCodeFilter = data["routeTypeRouteTypeCodeFilter"];
            this.routeTemplateNameFilter = data["routeTemplateNameFilter"];
            this.routeTypeId = data["routeTypeId"];
            this.driverId = data["driverId"];
            this.locationId = data["locationId"];
            this.managerId = data["managerId"];
            this.assignedById = data["assignedById"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.endDate = data["endDate"] ? moment(data["endDate"].toString()) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetAllRouteDefinitionsInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllRouteDefinitionsInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["filter"] = this.filter;
        data["routeTypeRouteTypeCodeFilter"] = this.routeTypeRouteTypeCodeFilter;
        data["routeTemplateNameFilter"] = this.routeTemplateNameFilter;
        data["routeTypeId"] = this.routeTypeId;
        data["driverId"] = this.driverId;
        data["locationId"] = this.locationId;
        data["managerId"] = this.managerId;
        data["assignedById"] = this.assignedById;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["endDate"] = this.endDate ? this.endDate.toISOString() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetAllRouteDefinitionsInput {
    filter: string | undefined;
    routeTypeRouteTypeCodeFilter: string | undefined;
    routeTemplateNameFilter: string | undefined;
    routeTypeId: number | undefined;
    driverId: number | undefined;
    locationId: number | undefined;
    managerId: number | undefined;
    assignedById: number | undefined;
    startDate: moment.Moment | undefined;
    endDate: moment.Moment | undefined;
    routeTemplateId: number | undefined;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class RouteNotificationRecipientDto implements IRouteNotificationRecipientDto {
    isEmail!: boolean;
    isSMS!: boolean;
    tenantId!: number | undefined;
    isActive!: boolean;
    emailAddress!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    userId!: number | undefined;
    routeTemplateId!: number | undefined;
    id!: number;

    constructor(data?: IRouteNotificationRecipientDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEmail = data["isEmail"];
            this.isSMS = data["isSMS"];
            this.tenantId = data["tenantId"];
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.userId = data["userId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteNotificationRecipientDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteNotificationRecipientDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEmail"] = this.isEmail;
        data["isSMS"] = this.isSMS;
        data["tenantId"] = this.tenantId;
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["userId"] = this.userId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteNotificationRecipientDto {
    isEmail: boolean;
    isSMS: boolean;
    tenantId: number | undefined;
    isActive: boolean;
    emailAddress: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    userId: number | undefined;
    routeTemplateId: number | undefined;
    id: number;
}

export class CreateOrEditRouteDefinitionDto implements ICreateOrEditRouteDefinitionDto {
    tenantId!: number | undefined;
    loadLimit!: number | undefined;
    threshold!: number;
    inactive!: boolean;
    running!: boolean;
    routeTypeId!: number | undefined;
    routeTemplateId!: number | undefined;
    locationId!: number | undefined;
    managerId!: number | undefined;
    assignedById!: number | undefined;
    assignedDate!: moment.Moment | undefined;
    isRunning!: boolean;
    defaultUserId!: number | undefined;
    mondayDriverId!: number | undefined;
    tuesdayDriverId!: number | undefined;
    wednesdayDriverId!: number | undefined;
    thursdayDriverId!: number | undefined;
    fridayDriverId!: number | undefined;
    saturdayDriverId!: number | undefined;
    sundayDriverId!: number | undefined;
    defaultContactId!: number | undefined;
    meetpointContactId!: number | undefined;
    routeStartContactId!: number | undefined;
    routeCode!: string | undefined;
    routeTemplateTypeId!: number | undefined;
    eta!: moment.Moment;
    cutOff!: moment.Moment;
    mondayManagerId!: number | undefined;
    tuesdayManagerId!: number | undefined;
    wednesdayManagerId!: number | undefined;
    thursdayManagerId!: number | undefined;
    fridayManagerId!: number | undefined;
    saturdayManagerId!: number | undefined;
    sundayManagerId!: number | undefined;
    routeStartInactive!: boolean;
    routeStopInactive!: boolean;
    routeNotificationRecipients!: RouteNotificationRecipientDto[] | undefined;
    startTimeType!: number;
    startTime!: string | undefined;
    startTimeMins!: number | undefined;
    endTimeType!: number;
    endTime!: string | undefined;
    endTimeMins!: number | undefined;
    mondaySupervisorId!: number | undefined;
    tuesdaySupervisorId!: number | undefined;
    wednesdaySupervisorId!: number | undefined;
    thursdaySupervisorId!: number | undefined;
    fridaySupervisorId!: number | undefined;
    saturdaySupervisorId!: number | undefined;
    sundaySupervisorId!: number | undefined;
    hasRouteStop!: boolean | undefined;
    routeStopId!: number | undefined;
    meetPointStopId!: number | undefined;
    routeStartId!: number | undefined;
    routeTemplateZoneId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteDefinitionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.loadLimit = data["loadLimit"];
            this.threshold = data["threshold"];
            this.inactive = data["inactive"];
            this.running = data["running"];
            this.routeTypeId = data["routeTypeId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.locationId = data["locationId"];
            this.managerId = data["managerId"];
            this.assignedById = data["assignedById"];
            this.assignedDate = data["assignedDate"] ? moment(data["assignedDate"].toString()) : <any>undefined;
            this.isRunning = data["isRunning"];
            this.defaultUserId = data["defaultUserId"];
            this.mondayDriverId = data["mondayDriverId"];
            this.tuesdayDriverId = data["tuesdayDriverId"];
            this.wednesdayDriverId = data["wednesdayDriverId"];
            this.thursdayDriverId = data["thursdayDriverId"];
            this.fridayDriverId = data["fridayDriverId"];
            this.saturdayDriverId = data["saturdayDriverId"];
            this.sundayDriverId = data["sundayDriverId"];
            this.defaultContactId = data["defaultContactId"];
            this.meetpointContactId = data["meetpointContactId"];
            this.routeStartContactId = data["routeStartContactId"];
            this.routeCode = data["routeCode"];
            this.routeTemplateTypeId = data["routeTemplateTypeId"];
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
            this.cutOff = data["cutOff"] ? moment(data["cutOff"].toString()) : <any>undefined;
            this.mondayManagerId = data["mondayManagerId"];
            this.tuesdayManagerId = data["tuesdayManagerId"];
            this.wednesdayManagerId = data["wednesdayManagerId"];
            this.thursdayManagerId = data["thursdayManagerId"];
            this.fridayManagerId = data["fridayManagerId"];
            this.saturdayManagerId = data["saturdayManagerId"];
            this.sundayManagerId = data["sundayManagerId"];
            this.routeStartInactive = data["routeStartInactive"];
            this.routeStopInactive = data["routeStopInactive"];
            if (Array.isArray(data["routeNotificationRecipients"])) {
                this.routeNotificationRecipients = [] as any;
                for (let item of data["routeNotificationRecipients"])
                    this.routeNotificationRecipients!.push(RouteNotificationRecipientDto.fromJS(item));
            }
            this.startTimeType = data["startTimeType"];
            this.startTime = data["startTime"];
            this.startTimeMins = data["startTimeMins"];
            this.endTimeType = data["endTimeType"];
            this.endTime = data["endTime"];
            this.endTimeMins = data["endTimeMins"];
            this.mondaySupervisorId = data["mondaySupervisorId"];
            this.tuesdaySupervisorId = data["tuesdaySupervisorId"];
            this.wednesdaySupervisorId = data["wednesdaySupervisorId"];
            this.thursdaySupervisorId = data["thursdaySupervisorId"];
            this.fridaySupervisorId = data["fridaySupervisorId"];
            this.saturdaySupervisorId = data["saturdaySupervisorId"];
            this.sundaySupervisorId = data["sundaySupervisorId"];
            this.hasRouteStop = data["hasRouteStop"];
            this.routeStopId = data["routeStopId"];
            this.meetPointStopId = data["meetPointStopId"];
            this.routeStartId = data["routeStartId"];
            this.routeTemplateZoneId = data["routeTemplateZoneId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteDefinitionDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteDefinitionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["loadLimit"] = this.loadLimit;
        data["threshold"] = this.threshold;
        data["inactive"] = this.inactive;
        data["running"] = this.running;
        data["routeTypeId"] = this.routeTypeId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["locationId"] = this.locationId;
        data["managerId"] = this.managerId;
        data["assignedById"] = this.assignedById;
        data["assignedDate"] = this.assignedDate ? this.assignedDate.toISOString() : <any>undefined;
        data["isRunning"] = this.isRunning;
        data["defaultUserId"] = this.defaultUserId;
        data["mondayDriverId"] = this.mondayDriverId;
        data["tuesdayDriverId"] = this.tuesdayDriverId;
        data["wednesdayDriverId"] = this.wednesdayDriverId;
        data["thursdayDriverId"] = this.thursdayDriverId;
        data["fridayDriverId"] = this.fridayDriverId;
        data["saturdayDriverId"] = this.saturdayDriverId;
        data["sundayDriverId"] = this.sundayDriverId;
        data["defaultContactId"] = this.defaultContactId;
        data["meetpointContactId"] = this.meetpointContactId;
        data["routeStartContactId"] = this.routeStartContactId;
        data["routeCode"] = this.routeCode;
        data["routeTemplateTypeId"] = this.routeTemplateTypeId;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        data["cutOff"] = this.cutOff ? this.cutOff.toISOString() : <any>undefined;
        data["mondayManagerId"] = this.mondayManagerId;
        data["tuesdayManagerId"] = this.tuesdayManagerId;
        data["wednesdayManagerId"] = this.wednesdayManagerId;
        data["thursdayManagerId"] = this.thursdayManagerId;
        data["fridayManagerId"] = this.fridayManagerId;
        data["saturdayManagerId"] = this.saturdayManagerId;
        data["sundayManagerId"] = this.sundayManagerId;
        data["routeStartInactive"] = this.routeStartInactive;
        data["routeStopInactive"] = this.routeStopInactive;
        if (Array.isArray(this.routeNotificationRecipients)) {
            data["routeNotificationRecipients"] = [];
            for (let item of this.routeNotificationRecipients)
                data["routeNotificationRecipients"].push(item.toJSON());
        }
        data["startTimeType"] = this.startTimeType;
        data["startTime"] = this.startTime;
        data["startTimeMins"] = this.startTimeMins;
        data["endTimeType"] = this.endTimeType;
        data["endTime"] = this.endTime;
        data["endTimeMins"] = this.endTimeMins;
        data["mondaySupervisorId"] = this.mondaySupervisorId;
        data["tuesdaySupervisorId"] = this.tuesdaySupervisorId;
        data["wednesdaySupervisorId"] = this.wednesdaySupervisorId;
        data["thursdaySupervisorId"] = this.thursdaySupervisorId;
        data["fridaySupervisorId"] = this.fridaySupervisorId;
        data["saturdaySupervisorId"] = this.saturdaySupervisorId;
        data["sundaySupervisorId"] = this.sundaySupervisorId;
        data["hasRouteStop"] = this.hasRouteStop;
        data["routeStopId"] = this.routeStopId;
        data["meetPointStopId"] = this.meetPointStopId;
        data["routeStartId"] = this.routeStartId;
        data["routeTemplateZoneId"] = this.routeTemplateZoneId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteDefinitionDto {
    tenantId: number | undefined;
    loadLimit: number | undefined;
    threshold: number;
    inactive: boolean;
    running: boolean;
    routeTypeId: number | undefined;
    routeTemplateId: number | undefined;
    locationId: number | undefined;
    managerId: number | undefined;
    assignedById: number | undefined;
    assignedDate: moment.Moment | undefined;
    isRunning: boolean;
    defaultUserId: number | undefined;
    mondayDriverId: number | undefined;
    tuesdayDriverId: number | undefined;
    wednesdayDriverId: number | undefined;
    thursdayDriverId: number | undefined;
    fridayDriverId: number | undefined;
    saturdayDriverId: number | undefined;
    sundayDriverId: number | undefined;
    defaultContactId: number | undefined;
    meetpointContactId: number | undefined;
    routeStartContactId: number | undefined;
    routeCode: string | undefined;
    routeTemplateTypeId: number | undefined;
    eta: moment.Moment;
    cutOff: moment.Moment;
    mondayManagerId: number | undefined;
    tuesdayManagerId: number | undefined;
    wednesdayManagerId: number | undefined;
    thursdayManagerId: number | undefined;
    fridayManagerId: number | undefined;
    saturdayManagerId: number | undefined;
    sundayManagerId: number | undefined;
    routeStartInactive: boolean;
    routeStopInactive: boolean;
    routeNotificationRecipients: RouteNotificationRecipientDto[] | undefined;
    startTimeType: number;
    startTime: string | undefined;
    startTimeMins: number | undefined;
    endTimeType: number;
    endTime: string | undefined;
    endTimeMins: number | undefined;
    mondaySupervisorId: number | undefined;
    tuesdaySupervisorId: number | undefined;
    wednesdaySupervisorId: number | undefined;
    thursdaySupervisorId: number | undefined;
    fridaySupervisorId: number | undefined;
    saturdaySupervisorId: number | undefined;
    sundaySupervisorId: number | undefined;
    hasRouteStop: boolean | undefined;
    routeStopId: number | undefined;
    meetPointStopId: number | undefined;
    routeStartId: number | undefined;
    routeTemplateZoneId: number | undefined;
    id: number | undefined;
}

export class GetRouteDefinitionForEditOutput implements IGetRouteDefinitionForEditOutput {
    routeDefinition!: CreateOrEditRouteDefinitionDto | undefined;
    routeTypeRouteTypeCode!: string | undefined;
    routeTemplateName!: string | undefined;

    constructor(data?: IGetRouteDefinitionForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeDefinition = data["routeDefinition"] ? CreateOrEditRouteDefinitionDto.fromJS(data["routeDefinition"]) : <any>undefined;
            this.routeTypeRouteTypeCode = data["routeTypeRouteTypeCode"];
            this.routeTemplateName = data["routeTemplateName"];
        }
    }

    static fromJS(data: any): GetRouteDefinitionForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteDefinitionForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeDefinition"] = this.routeDefinition ? this.routeDefinition.toJSON() : <any>undefined;
        data["routeTypeRouteTypeCode"] = this.routeTypeRouteTypeCode;
        data["routeTemplateName"] = this.routeTemplateName;
        return data; 
    }
}

export interface IGetRouteDefinitionForEditOutput {
    routeDefinition: CreateOrEditRouteDefinitionDto | undefined;
    routeTypeRouteTypeCode: string | undefined;
    routeTemplateName: string | undefined;
}

export class CheckActiveRouteInputDto implements ICheckActiveRouteInputDto {
    routeTemplateId!: number;
    locationId!: number;

    constructor(data?: ICheckActiveRouteInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateId = data["routeTemplateId"];
            this.locationId = data["locationId"];
        }
    }

    static fromJS(data: any): CheckActiveRouteInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CheckActiveRouteInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateId"] = this.routeTemplateId;
        data["locationId"] = this.locationId;
        return data; 
    }
}

export interface ICheckActiveRouteInputDto {
    routeTemplateId: number;
    locationId: number;
}

export class VehicleMileage implements IVehicleMileage {
    tenantId!: number | undefined;
    vehicle!: Vehicle;
    vehicleId!: number;
    mileage!: number | undefined;
    id!: number;

    constructor(data?: IVehicleMileage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.vehicle = new Vehicle();
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.vehicle = data["vehicle"] ? Vehicle.fromJS(data["vehicle"]) : new Vehicle();
            this.vehicleId = data["vehicleId"];
            this.mileage = data["mileage"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VehicleMileage {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleMileage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        data["mileage"] = this.mileage;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicleMileage {
    tenantId: number | undefined;
    vehicle: Vehicle;
    vehicleId: number;
    mileage: number | undefined;
    id: number;
}

export class VehicleTypes implements IVehicleTypes {
    tenantId!: number | undefined;
    description!: string;
    code!: string;
    mileageMultiplier!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IVehicleTypes) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.description = data["description"];
            this.code = data["code"];
            this.mileageMultiplier = data["mileageMultiplier"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VehicleTypes {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleTypes();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["description"] = this.description;
        data["code"] = this.code;
        data["mileageMultiplier"] = this.mileageMultiplier;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicleTypes {
    tenantId: number | undefined;
    description: string;
    code: string;
    mileageMultiplier: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Vehicle implements IVehicle {
    tenantId!: number | undefined;
    name!: string;
    licenseNumber!: string;
    user!: User | undefined;
    userId!: number | undefined;
    mileage!: number | undefined;
    vehicleMileage!: VehicleMileage | undefined;
    activeRoute!: Route | undefined;
    color!: string | undefined;
    activeRouteId!: number | undefined;
    vehicleId!: number;
    fullName!: string | undefined;
    appVersion!: string | undefined;
    deviceOs!: string | undefined;
    licenseState!: string;
    acquisitionDate!: moment.Moment | undefined;
    description!: string | undefined;
    temporaryVehicle!: boolean;
    vehicleType!: VehicleTypes | undefined;
    vehicleTypeId!: number | undefined;
    lastMileage!: number;
    speed!: number | undefined;
    latitude!: number | undefined;
    longitude!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IVehicle) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.mileage = data["mileage"];
            this.vehicleMileage = data["vehicleMileage"] ? VehicleMileage.fromJS(data["vehicleMileage"]) : <any>undefined;
            this.activeRoute = data["activeRoute"] ? Route.fromJS(data["activeRoute"]) : <any>undefined;
            this.color = data["color"];
            this.activeRouteId = data["activeRouteId"];
            this.vehicleId = data["vehicleId"];
            this.fullName = data["fullName"];
            this.appVersion = data["appVersion"];
            this.deviceOs = data["deviceOs"];
            this.licenseState = data["licenseState"];
            this.acquisitionDate = data["acquisitionDate"] ? moment(data["acquisitionDate"].toString()) : <any>undefined;
            this.description = data["description"];
            this.temporaryVehicle = data["temporaryVehicle"];
            this.vehicleType = data["vehicleType"] ? VehicleTypes.fromJS(data["vehicleType"]) : <any>undefined;
            this.vehicleTypeId = data["vehicleTypeId"];
            this.lastMileage = data["lastMileage"];
            this.speed = data["speed"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Vehicle {
        data = typeof data === 'object' ? data : {};
        let result = new Vehicle();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["mileage"] = this.mileage;
        data["vehicleMileage"] = this.vehicleMileage ? this.vehicleMileage.toJSON() : <any>undefined;
        data["activeRoute"] = this.activeRoute ? this.activeRoute.toJSON() : <any>undefined;
        data["color"] = this.color;
        data["activeRouteId"] = this.activeRouteId;
        data["vehicleId"] = this.vehicleId;
        data["fullName"] = this.fullName;
        data["appVersion"] = this.appVersion;
        data["deviceOs"] = this.deviceOs;
        data["licenseState"] = this.licenseState;
        data["acquisitionDate"] = this.acquisitionDate ? this.acquisitionDate.toISOString() : <any>undefined;
        data["description"] = this.description;
        data["temporaryVehicle"] = this.temporaryVehicle;
        data["vehicleType"] = this.vehicleType ? this.vehicleType.toJSON() : <any>undefined;
        data["vehicleTypeId"] = this.vehicleTypeId;
        data["lastMileage"] = this.lastMileage;
        data["speed"] = this.speed;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicle {
    tenantId: number | undefined;
    name: string;
    licenseNumber: string;
    user: User | undefined;
    userId: number | undefined;
    mileage: number | undefined;
    vehicleMileage: VehicleMileage | undefined;
    activeRoute: Route | undefined;
    color: string | undefined;
    activeRouteId: number | undefined;
    vehicleId: number;
    fullName: string | undefined;
    appVersion: string | undefined;
    deviceOs: string | undefined;
    licenseState: string;
    acquisitionDate: moment.Moment | undefined;
    description: string | undefined;
    temporaryVehicle: boolean;
    vehicleType: VehicleTypes | undefined;
    vehicleTypeId: number | undefined;
    lastMileage: number;
    speed: number | undefined;
    latitude: number | undefined;
    longitude: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteTemplateType implements IRouteTemplateType {
    name!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateType {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateType {
    name: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteStop implements IRouteStop {
    tenantId!: number | undefined;
    contactId!: number | undefined;
    contactFk!: Contact | undefined;
    locationId!: number | undefined;
    location!: Location | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteStop) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.contactId = data["contactId"];
            this.contactFk = data["contactFk"] ? Contact.fromJS(data["contactFk"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.location = data["location"] ? Location.fromJS(data["location"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteStop {
        data = typeof data === 'object' ? data : {};
        let result = new RouteStop();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["contactId"] = this.contactId;
        data["contactFk"] = this.contactFk ? this.contactFk.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteStop {
    tenantId: number | undefined;
    contactId: number | undefined;
    contactFk: Contact | undefined;
    locationId: number | undefined;
    location: Location | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteTemplate implements IRouteTemplate {
    tenantId!: number | undefined;
    location!: Location | undefined;
    locationId!: number;
    routeTemplateType!: RouteTemplateType | undefined;
    routeTemplateTypeId!: number;
    name!: string;
    startTimeType!: number;
    startTime!: TimeSpan;
    startTimeMins!: number | undefined;
    endTimeType!: number;
    endTime!: TimeSpan;
    endTimeMins!: number | undefined;
    isRunning!: boolean;
    defaultUser!: User | undefined;
    defaultUserId!: number | undefined;
    mondayDriverId!: number | undefined;
    tuesdayDriverId!: number | undefined;
    wednesdayDriverId!: number | undefined;
    thursdayDriverId!: number | undefined;
    fridayDriverId!: number | undefined;
    saturdayDriverId!: number | undefined;
    sundayDriverId!: number | undefined;
    mondayManagerId!: number | undefined;
    tuesdayManagerId!: number | undefined;
    wednesdayManagerId!: number | undefined;
    thursdayManagerId!: number | undefined;
    fridayManagerId!: number | undefined;
    saturdayManagerId!: number | undefined;
    sundayManagerId!: number | undefined;
    defaultContact!: Contact | undefined;
    defaultContactId!: number | undefined;
    routeStopInActive!: boolean;
    routeStartContact!: Contact | undefined;
    routeStartContactId!: number | undefined;
    routeStartInActive!: boolean;
    routeEndContact!: Contact | undefined;
    routeEndContactId!: number | undefined;
    mondaySupervisorId!: number | undefined;
    tuesdaySupervisorId!: number | undefined;
    wednesdaySupervisorId!: number | undefined;
    thursdaySupervisorId!: number | undefined;
    fridaySupervisorId!: number | undefined;
    saturdaySupervisorId!: number | undefined;
    sundaySupervisorId!: number | undefined;
    meetpointContact!: Contact | undefined;
    meetpointContactId!: number | undefined;
    meetPointStop!: RouteStop | undefined;
    meetPointStopId!: number | undefined;
    routeStart!: RouteStop | undefined;
    routeStartId!: number | undefined;
    routeStop!: RouteStop | undefined;
    routeStopId!: number | undefined;
    analyzedTime!: moment.Moment | undefined;
    analyzedByUserId!: number | undefined;
    loadLimit!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.location = data["location"] ? Location.fromJS(data["location"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.routeTemplateType = data["routeTemplateType"] ? RouteTemplateType.fromJS(data["routeTemplateType"]) : <any>undefined;
            this.routeTemplateTypeId = data["routeTemplateTypeId"];
            this.name = data["name"];
            this.startTimeType = data["startTimeType"];
            this.startTime = data["startTime"] ? TimeSpan.fromJS(data["startTime"]) : <any>undefined;
            this.startTimeMins = data["startTimeMins"];
            this.endTimeType = data["endTimeType"];
            this.endTime = data["endTime"] ? TimeSpan.fromJS(data["endTime"]) : <any>undefined;
            this.endTimeMins = data["endTimeMins"];
            this.isRunning = data["isRunning"];
            this.defaultUser = data["defaultUser"] ? User.fromJS(data["defaultUser"]) : <any>undefined;
            this.defaultUserId = data["defaultUserId"];
            this.mondayDriverId = data["mondayDriverId"];
            this.tuesdayDriverId = data["tuesdayDriverId"];
            this.wednesdayDriverId = data["wednesdayDriverId"];
            this.thursdayDriverId = data["thursdayDriverId"];
            this.fridayDriverId = data["fridayDriverId"];
            this.saturdayDriverId = data["saturdayDriverId"];
            this.sundayDriverId = data["sundayDriverId"];
            this.mondayManagerId = data["mondayManagerId"];
            this.tuesdayManagerId = data["tuesdayManagerId"];
            this.wednesdayManagerId = data["wednesdayManagerId"];
            this.thursdayManagerId = data["thursdayManagerId"];
            this.fridayManagerId = data["fridayManagerId"];
            this.saturdayManagerId = data["saturdayManagerId"];
            this.sundayManagerId = data["sundayManagerId"];
            this.defaultContact = data["defaultContact"] ? Contact.fromJS(data["defaultContact"]) : <any>undefined;
            this.defaultContactId = data["defaultContactId"];
            this.routeStopInActive = data["routeStopInActive"];
            this.routeStartContact = data["routeStartContact"] ? Contact.fromJS(data["routeStartContact"]) : <any>undefined;
            this.routeStartContactId = data["routeStartContactId"];
            this.routeStartInActive = data["routeStartInActive"];
            this.routeEndContact = data["routeEndContact"] ? Contact.fromJS(data["routeEndContact"]) : <any>undefined;
            this.routeEndContactId = data["routeEndContactId"];
            this.mondaySupervisorId = data["mondaySupervisorId"];
            this.tuesdaySupervisorId = data["tuesdaySupervisorId"];
            this.wednesdaySupervisorId = data["wednesdaySupervisorId"];
            this.thursdaySupervisorId = data["thursdaySupervisorId"];
            this.fridaySupervisorId = data["fridaySupervisorId"];
            this.saturdaySupervisorId = data["saturdaySupervisorId"];
            this.sundaySupervisorId = data["sundaySupervisorId"];
            this.meetpointContact = data["meetpointContact"] ? Contact.fromJS(data["meetpointContact"]) : <any>undefined;
            this.meetpointContactId = data["meetpointContactId"];
            this.meetPointStop = data["meetPointStop"] ? RouteStop.fromJS(data["meetPointStop"]) : <any>undefined;
            this.meetPointStopId = data["meetPointStopId"];
            this.routeStart = data["routeStart"] ? RouteStop.fromJS(data["routeStart"]) : <any>undefined;
            this.routeStartId = data["routeStartId"];
            this.routeStop = data["routeStop"] ? RouteStop.fromJS(data["routeStop"]) : <any>undefined;
            this.routeStopId = data["routeStopId"];
            this.analyzedTime = data["analyzedTime"] ? moment(data["analyzedTime"].toString()) : <any>undefined;
            this.analyzedByUserId = data["analyzedByUserId"];
            this.loadLimit = data["loadLimit"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplate {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["routeTemplateType"] = this.routeTemplateType ? this.routeTemplateType.toJSON() : <any>undefined;
        data["routeTemplateTypeId"] = this.routeTemplateTypeId;
        data["name"] = this.name;
        data["startTimeType"] = this.startTimeType;
        data["startTime"] = this.startTime ? this.startTime.toJSON() : <any>undefined;
        data["startTimeMins"] = this.startTimeMins;
        data["endTimeType"] = this.endTimeType;
        data["endTime"] = this.endTime ? this.endTime.toJSON() : <any>undefined;
        data["endTimeMins"] = this.endTimeMins;
        data["isRunning"] = this.isRunning;
        data["defaultUser"] = this.defaultUser ? this.defaultUser.toJSON() : <any>undefined;
        data["defaultUserId"] = this.defaultUserId;
        data["mondayDriverId"] = this.mondayDriverId;
        data["tuesdayDriverId"] = this.tuesdayDriverId;
        data["wednesdayDriverId"] = this.wednesdayDriverId;
        data["thursdayDriverId"] = this.thursdayDriverId;
        data["fridayDriverId"] = this.fridayDriverId;
        data["saturdayDriverId"] = this.saturdayDriverId;
        data["sundayDriverId"] = this.sundayDriverId;
        data["mondayManagerId"] = this.mondayManagerId;
        data["tuesdayManagerId"] = this.tuesdayManagerId;
        data["wednesdayManagerId"] = this.wednesdayManagerId;
        data["thursdayManagerId"] = this.thursdayManagerId;
        data["fridayManagerId"] = this.fridayManagerId;
        data["saturdayManagerId"] = this.saturdayManagerId;
        data["sundayManagerId"] = this.sundayManagerId;
        data["defaultContact"] = this.defaultContact ? this.defaultContact.toJSON() : <any>undefined;
        data["defaultContactId"] = this.defaultContactId;
        data["routeStopInActive"] = this.routeStopInActive;
        data["routeStartContact"] = this.routeStartContact ? this.routeStartContact.toJSON() : <any>undefined;
        data["routeStartContactId"] = this.routeStartContactId;
        data["routeStartInActive"] = this.routeStartInActive;
        data["routeEndContact"] = this.routeEndContact ? this.routeEndContact.toJSON() : <any>undefined;
        data["routeEndContactId"] = this.routeEndContactId;
        data["mondaySupervisorId"] = this.mondaySupervisorId;
        data["tuesdaySupervisorId"] = this.tuesdaySupervisorId;
        data["wednesdaySupervisorId"] = this.wednesdaySupervisorId;
        data["thursdaySupervisorId"] = this.thursdaySupervisorId;
        data["fridaySupervisorId"] = this.fridaySupervisorId;
        data["saturdaySupervisorId"] = this.saturdaySupervisorId;
        data["sundaySupervisorId"] = this.sundaySupervisorId;
        data["meetpointContact"] = this.meetpointContact ? this.meetpointContact.toJSON() : <any>undefined;
        data["meetpointContactId"] = this.meetpointContactId;
        data["meetPointStop"] = this.meetPointStop ? this.meetPointStop.toJSON() : <any>undefined;
        data["meetPointStopId"] = this.meetPointStopId;
        data["routeStart"] = this.routeStart ? this.routeStart.toJSON() : <any>undefined;
        data["routeStartId"] = this.routeStartId;
        data["routeStop"] = this.routeStop ? this.routeStop.toJSON() : <any>undefined;
        data["routeStopId"] = this.routeStopId;
        data["analyzedTime"] = this.analyzedTime ? this.analyzedTime.toISOString() : <any>undefined;
        data["analyzedByUserId"] = this.analyzedByUserId;
        data["loadLimit"] = this.loadLimit;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplate {
    tenantId: number | undefined;
    location: Location | undefined;
    locationId: number;
    routeTemplateType: RouteTemplateType | undefined;
    routeTemplateTypeId: number;
    name: string;
    startTimeType: number;
    startTime: TimeSpan;
    startTimeMins: number | undefined;
    endTimeType: number;
    endTime: TimeSpan;
    endTimeMins: number | undefined;
    isRunning: boolean;
    defaultUser: User | undefined;
    defaultUserId: number | undefined;
    mondayDriverId: number | undefined;
    tuesdayDriverId: number | undefined;
    wednesdayDriverId: number | undefined;
    thursdayDriverId: number | undefined;
    fridayDriverId: number | undefined;
    saturdayDriverId: number | undefined;
    sundayDriverId: number | undefined;
    mondayManagerId: number | undefined;
    tuesdayManagerId: number | undefined;
    wednesdayManagerId: number | undefined;
    thursdayManagerId: number | undefined;
    fridayManagerId: number | undefined;
    saturdayManagerId: number | undefined;
    sundayManagerId: number | undefined;
    defaultContact: Contact | undefined;
    defaultContactId: number | undefined;
    routeStopInActive: boolean;
    routeStartContact: Contact | undefined;
    routeStartContactId: number | undefined;
    routeStartInActive: boolean;
    routeEndContact: Contact | undefined;
    routeEndContactId: number | undefined;
    mondaySupervisorId: number | undefined;
    tuesdaySupervisorId: number | undefined;
    wednesdaySupervisorId: number | undefined;
    thursdaySupervisorId: number | undefined;
    fridaySupervisorId: number | undefined;
    saturdaySupervisorId: number | undefined;
    sundaySupervisorId: number | undefined;
    meetpointContact: Contact | undefined;
    meetpointContactId: number | undefined;
    meetPointStop: RouteStop | undefined;
    meetPointStopId: number | undefined;
    routeStart: RouteStop | undefined;
    routeStartId: number | undefined;
    routeStop: RouteStop | undefined;
    routeStopId: number | undefined;
    analyzedTime: moment.Moment | undefined;
    analyzedByUserId: number | undefined;
    loadLimit: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Note implements INote {
    content!: string;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: INote) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.content = data["content"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Note {
        data = typeof data === 'object' ? data : {};
        let result = new Note();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["content"] = this.content;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface INote {
    content: string;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderStatusType implements IOrderStatusType {
    tenantId!: number | undefined;
    code!: string | undefined;
    description!: string | undefined;
    sortOrder!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderStatusType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.description = data["description"];
            this.sortOrder = data["sortOrder"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatusType {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["description"] = this.description;
        data["sortOrder"] = this.sortOrder;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatusType {
    tenantId: number | undefined;
    code: string | undefined;
    description: string | undefined;
    sortOrder: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Package implements IPackage {
    tenantId!: number | undefined;
    name!: string;
    price!: number;
    code!: string | undefined;
    sku!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    inActive!: boolean;
    sortOrder!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IPackage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.price = data["price"];
            this.code = data["code"];
            this.sku = data["sku"];
            this.description = data["description"];
            this.color = data["color"];
            this.inActive = data["inActive"];
            this.sortOrder = data["sortOrder"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Package {
        data = typeof data === 'object' ? data : {};
        let result = new Package();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["price"] = this.price;
        data["code"] = this.code;
        data["sku"] = this.sku;
        data["description"] = this.description;
        data["color"] = this.color;
        data["inActive"] = this.inActive;
        data["sortOrder"] = this.sortOrder;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPackage {
    tenantId: number | undefined;
    name: string;
    price: number;
    code: string | undefined;
    sku: string | undefined;
    description: string | undefined;
    color: string | undefined;
    inActive: boolean;
    sortOrder: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderPackage implements IOrderPackage {
    order!: Order | undefined;
    orderId!: number;
    package!: Package | undefined;
    packageId!: number;
    quantity!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderPackage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.package = data["package"] ? Package.fromJS(data["package"]) : <any>undefined;
            this.packageId = data["packageId"];
            this.quantity = data["quantity"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderPackage {
        data = typeof data === 'object' ? data : {};
        let result = new OrderPackage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["package"] = this.package ? this.package.toJSON() : <any>undefined;
        data["packageId"] = this.packageId;
        data["quantity"] = this.quantity;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderPackage {
    order: Order | undefined;
    orderId: number;
    package: Package | undefined;
    packageId: number;
    quantity: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class TagType implements ITagType {
    tenantId!: number | undefined;
    name!: string | undefined;
    code!: string | undefined;
    isBarcode!: boolean;
    isQrcode!: boolean;
    isPrivate!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ITagType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.code = data["code"];
            this.isBarcode = data["isBarcode"];
            this.isQrcode = data["isQrcode"];
            this.isPrivate = data["isPrivate"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TagType {
        data = typeof data === 'object' ? data : {};
        let result = new TagType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["isBarcode"] = this.isBarcode;
        data["isQrcode"] = this.isQrcode;
        data["isPrivate"] = this.isPrivate;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITagType {
    tenantId: number | undefined;
    name: string | undefined;
    code: string | undefined;
    isBarcode: boolean;
    isQrcode: boolean;
    isPrivate: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Tag implements ITag {
    tenantId!: number | undefined;
    tagType!: TagType | undefined;
    tagTypeId!: number;
    name!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ITag) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tagType = data["tagType"] ? TagType.fromJS(data["tagType"]) : <any>undefined;
            this.tagTypeId = data["tagTypeId"];
            this.name = data["name"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Tag {
        data = typeof data === 'object' ? data : {};
        let result = new Tag();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tagType"] = this.tagType ? this.tagType.toJSON() : <any>undefined;
        data["tagTypeId"] = this.tagTypeId;
        data["name"] = this.name;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITag {
    tenantId: number | undefined;
    tagType: TagType | undefined;
    tagTypeId: number;
    name: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderTag implements IOrderTag {
    tag!: Tag | undefined;
    tagId!: number;
    order!: Order | undefined;
    orderId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderTag) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tag = data["tag"] ? Tag.fromJS(data["tag"]) : <any>undefined;
            this.tagId = data["tagId"];
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderTag {
        data = typeof data === 'object' ? data : {};
        let result = new OrderTag();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tag"] = this.tag ? this.tag.toJSON() : <any>undefined;
        data["tagId"] = this.tagId;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderTag {
    tag: Tag | undefined;
    tagId: number;
    order: Order | undefined;
    orderId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrdersInStop implements IOrdersInStop {
    id!: number;
    routeId!: number | undefined;
    route!: Route | undefined;
    contact!: Contact | undefined;
    note!: Note | undefined;
    status!: OrderStatusType | undefined;
    sortOrder!: number | undefined;
    orderPackages!: OrderPackage[] | undefined;
    orderTags!: OrderTag[] | undefined;
    destinationId!: number;
    destinationDetail!: DestinationDetail | undefined;
    spanMillis!: number;
    hasReadNote!: boolean;
    clinicNotesVisibleToDriver!: boolean;
    notesVisibleToDriver!: boolean;
    orderType!: OrderType | undefined;
    routeTemplate!: RouteTemplate | undefined;
    linehaulParentRouteId!: number | undefined;
    lineHaulParentRouteCode!: string | undefined;

    constructor(data?: IOrdersInStop) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeId = data["routeId"];
            this.route = data["route"] ? Route.fromJS(data["route"]) : <any>undefined;
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.note = data["note"] ? Note.fromJS(data["note"]) : <any>undefined;
            this.status = data["status"] ? OrderStatusType.fromJS(data["status"]) : <any>undefined;
            this.sortOrder = data["sortOrder"];
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackage.fromJS(item));
            }
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(OrderTag.fromJS(item));
            }
            this.destinationId = data["destinationId"];
            this.destinationDetail = data["destinationDetail"] ? DestinationDetail.fromJS(data["destinationDetail"]) : <any>undefined;
            this.spanMillis = data["spanMillis"];
            this.hasReadNote = data["hasReadNote"];
            this.clinicNotesVisibleToDriver = data["clinicNotesVisibleToDriver"];
            this.notesVisibleToDriver = data["notesVisibleToDriver"];
            this.orderType = data["orderType"] ? OrderType.fromJS(data["orderType"]) : <any>undefined;
            this.routeTemplate = data["routeTemplate"] ? RouteTemplate.fromJS(data["routeTemplate"]) : <any>undefined;
            this.linehaulParentRouteId = data["linehaulParentRouteId"];
            this.lineHaulParentRouteCode = data["lineHaulParentRouteCode"];
        }
    }

    static fromJS(data: any): OrdersInStop {
        data = typeof data === 'object' ? data : {};
        let result = new OrdersInStop();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeId"] = this.routeId;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["status"] = this.status ? this.status.toJSON() : <any>undefined;
        data["sortOrder"] = this.sortOrder;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        data["destinationId"] = this.destinationId;
        data["destinationDetail"] = this.destinationDetail ? this.destinationDetail.toJSON() : <any>undefined;
        data["spanMillis"] = this.spanMillis;
        data["hasReadNote"] = this.hasReadNote;
        data["clinicNotesVisibleToDriver"] = this.clinicNotesVisibleToDriver;
        data["notesVisibleToDriver"] = this.notesVisibleToDriver;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["linehaulParentRouteId"] = this.linehaulParentRouteId;
        data["lineHaulParentRouteCode"] = this.lineHaulParentRouteCode;
        return data; 
    }
}

export interface IOrdersInStop {
    id: number;
    routeId: number | undefined;
    route: Route | undefined;
    contact: Contact | undefined;
    note: Note | undefined;
    status: OrderStatusType | undefined;
    sortOrder: number | undefined;
    orderPackages: OrderPackage[] | undefined;
    orderTags: OrderTag[] | undefined;
    destinationId: number;
    destinationDetail: DestinationDetail | undefined;
    spanMillis: number;
    hasReadNote: boolean;
    clinicNotesVisibleToDriver: boolean;
    notesVisibleToDriver: boolean;
    orderType: OrderType | undefined;
    routeTemplate: RouteTemplate | undefined;
    linehaulParentRouteId: number | undefined;
    lineHaulParentRouteCode: string | undefined;
}

export class Container implements IContainer {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    name!: string;
    code!: string | undefined;
    price!: number;
    color!: string | undefined;
    inActive!: boolean;
    sortOrder!: number;
    size!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IContainer) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.name = data["name"];
            this.code = data["code"];
            this.price = data["price"];
            this.color = data["color"];
            this.inActive = data["inActive"];
            this.sortOrder = data["sortOrder"];
            this.size = data["size"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Container {
        data = typeof data === 'object' ? data : {};
        let result = new Container();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["name"] = this.name;
        data["code"] = this.code;
        data["price"] = this.price;
        data["color"] = this.color;
        data["inActive"] = this.inActive;
        data["sortOrder"] = this.sortOrder;
        data["size"] = this.size;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IContainer {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    name: string;
    code: string | undefined;
    price: number;
    color: string | undefined;
    inActive: boolean;
    sortOrder: number;
    size: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DestinationContainer implements IDestinationContainer {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    routeId!: number;
    route!: Route | undefined;
    destinationId!: number;
    destinationDetail!: DestinationDetail | undefined;
    containerId!: number;
    container!: Container | undefined;
    quantity!: number;
    time!: moment.Moment;
    orderStatusTypeId!: number;
    orderStatusType!: OrderStatusType | undefined;
    geocodeId!: number | undefined;
    geocode!: Geocode | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDestinationContainer) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.routeId = data["routeId"];
            this.route = data["route"] ? Route.fromJS(data["route"]) : <any>undefined;
            this.destinationId = data["destinationId"];
            this.destinationDetail = data["destinationDetail"] ? DestinationDetail.fromJS(data["destinationDetail"]) : <any>undefined;
            this.containerId = data["containerId"];
            this.container = data["container"] ? Container.fromJS(data["container"]) : <any>undefined;
            this.quantity = data["quantity"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderStatusType = data["orderStatusType"] ? OrderStatusType.fromJS(data["orderStatusType"]) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DestinationContainer {
        data = typeof data === 'object' ? data : {};
        let result = new DestinationContainer();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["routeId"] = this.routeId;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["destinationId"] = this.destinationId;
        data["destinationDetail"] = this.destinationDetail ? this.destinationDetail.toJSON() : <any>undefined;
        data["containerId"] = this.containerId;
        data["container"] = this.container ? this.container.toJSON() : <any>undefined;
        data["quantity"] = this.quantity;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDestinationContainer {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    routeId: number;
    route: Route | undefined;
    destinationId: number;
    destinationDetail: DestinationDetail | undefined;
    containerId: number;
    container: Container | undefined;
    quantity: number;
    time: moment.Moment;
    orderStatusTypeId: number;
    orderStatusType: OrderStatusType | undefined;
    geocodeId: number | undefined;
    geocode: Geocode | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DestinationDetail implements IDestinationDetail {
    contact!: Contact | undefined;
    contactId!: number;
    etaStart!: moment.Moment;
    etaEnd!: moment.Moment;
    orders!: OrdersInStop[] | undefined;
    sortOrder!: number;
    note!: string | undefined;
    containers!: DestinationContainer[] | undefined;
    notificationCodes!: string[] | undefined;
    eta!: moment.Moment;
    lta!: TimeSpan | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDestinationDetail) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.etaStart = data["etaStart"] ? moment(data["etaStart"].toString()) : <any>undefined;
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
            if (Array.isArray(data["orders"])) {
                this.orders = [] as any;
                for (let item of data["orders"])
                    this.orders!.push(OrdersInStop.fromJS(item));
            }
            this.sortOrder = data["sortOrder"];
            this.note = data["note"];
            if (Array.isArray(data["containers"])) {
                this.containers = [] as any;
                for (let item of data["containers"])
                    this.containers!.push(DestinationContainer.fromJS(item));
            }
            if (Array.isArray(data["notificationCodes"])) {
                this.notificationCodes = [] as any;
                for (let item of data["notificationCodes"])
                    this.notificationCodes!.push(item);
            }
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
            this.lta = data["lta"] ? TimeSpan.fromJS(data["lta"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DestinationDetail {
        data = typeof data === 'object' ? data : {};
        let result = new DestinationDetail();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["etaStart"] = this.etaStart ? this.etaStart.toISOString() : <any>undefined;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        if (Array.isArray(this.orders)) {
            data["orders"] = [];
            for (let item of this.orders)
                data["orders"].push(item.toJSON());
        }
        data["sortOrder"] = this.sortOrder;
        data["note"] = this.note;
        if (Array.isArray(this.containers)) {
            data["containers"] = [];
            for (let item of this.containers)
                data["containers"].push(item.toJSON());
        }
        if (Array.isArray(this.notificationCodes)) {
            data["notificationCodes"] = [];
            for (let item of this.notificationCodes)
                data["notificationCodes"].push(item);
        }
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        data["lta"] = this.lta ? this.lta.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDestinationDetail {
    contact: Contact | undefined;
    contactId: number;
    etaStart: moment.Moment;
    etaEnd: moment.Moment;
    orders: OrdersInStop[] | undefined;
    sortOrder: number;
    note: string | undefined;
    containers: DestinationContainer[] | undefined;
    notificationCodes: string[] | undefined;
    eta: moment.Moment;
    lta: TimeSpan | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ProximityCode implements IProximityCode {
    order!: Order | undefined;
    orderId!: number;
    geocode!: Geocode | undefined;
    geocodeId!: number;
    value!: string | undefined;
    isAccepted!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IProximityCode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.value = data["value"];
            this.isAccepted = data["isAccepted"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ProximityCode {
        data = typeof data === 'object' ? data : {};
        let result = new ProximityCode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["value"] = this.value;
        data["isAccepted"] = this.isAccepted;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IProximityCode {
    order: Order | undefined;
    orderId: number;
    geocode: Geocode | undefined;
    geocodeId: number;
    value: string | undefined;
    isAccepted: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderStatus implements IOrderStatus {
    user!: User | undefined;
    userId!: number | undefined;
    order!: Order | undefined;
    orderId!: number;
    geocodeId!: number | undefined;
    geocode!: Geocode | undefined;
    orderStatusType!: OrderStatusType | undefined;
    orderStatusTypeId!: number;
    note!: Note | undefined;
    noteId!: number | undefined;
    time!: moment.Moment;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderStatus) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.geocodeId = data["geocodeId"];
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.orderStatusType = data["orderStatusType"] ? OrderStatusType.fromJS(data["orderStatusType"]) : <any>undefined;
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.note = data["note"] ? Note.fromJS(data["note"]) : <any>undefined;
            this.noteId = data["noteId"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatus {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatus();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["geocodeId"] = this.geocodeId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["noteId"] = this.noteId;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatus {
    user: User | undefined;
    userId: number | undefined;
    order: Order | undefined;
    orderId: number;
    geocodeId: number | undefined;
    geocode: Geocode | undefined;
    orderStatusType: OrderStatusType | undefined;
    orderStatusTypeId: number;
    note: Note | undefined;
    noteId: number | undefined;
    time: moment.Moment;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export enum Types {
    Regular = 0,
    Linehaul = 1,
}

export class RouteType implements IRouteType {
    tenantId!: number | undefined;
    routeTypeCode!: string;
    description!: string;
    displayColor!: string;
    sortOrder!: number | undefined;
    type!: Types;
    startTime!: TimeSpan | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeTypeCode = data["routeTypeCode"];
            this.description = data["description"];
            this.displayColor = data["displayColor"];
            this.sortOrder = data["sortOrder"];
            this.type = data["type"];
            this.startTime = data["startTime"] ? TimeSpan.fromJS(data["startTime"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteType {
        data = typeof data === 'object' ? data : {};
        let result = new RouteType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeTypeCode"] = this.routeTypeCode;
        data["description"] = this.description;
        data["displayColor"] = this.displayColor;
        data["sortOrder"] = this.sortOrder;
        data["type"] = this.type;
        data["startTime"] = this.startTime ? this.startTime.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteType {
    tenantId: number | undefined;
    routeTypeCode: string;
    description: string;
    displayColor: string;
    sortOrder: number | undefined;
    type: Types;
    startTime: TimeSpan | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Clinic implements IClinic {
    tenantId!: number | undefined;
    clinicNotes!: string | undefined;
    mondayClinicNotes!: string | undefined;
    tuesdayClinicNotes!: string | undefined;
    wednesdayClinicNotes!: string | undefined;
    thursdayClinicNotes!: string | undefined;
    fridayClinicNotes!: string | undefined;
    saturdayClinicNotes!: string | undefined;
    sundayClinicNotes!: string | undefined;
    clinicNotesVisibleToDriver!: boolean;
    billingNotes!: string | undefined;
    contact!: Contact | undefined;
    contactId!: number;
    accountNo!: string | undefined;
    active!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IClinic) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.clinicNotes = data["clinicNotes"];
            this.mondayClinicNotes = data["mondayClinicNotes"];
            this.tuesdayClinicNotes = data["tuesdayClinicNotes"];
            this.wednesdayClinicNotes = data["wednesdayClinicNotes"];
            this.thursdayClinicNotes = data["thursdayClinicNotes"];
            this.fridayClinicNotes = data["fridayClinicNotes"];
            this.saturdayClinicNotes = data["saturdayClinicNotes"];
            this.sundayClinicNotes = data["sundayClinicNotes"];
            this.clinicNotesVisibleToDriver = data["clinicNotesVisibleToDriver"];
            this.billingNotes = data["billingNotes"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.accountNo = data["accountNo"];
            this.active = data["active"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Clinic {
        data = typeof data === 'object' ? data : {};
        let result = new Clinic();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["clinicNotes"] = this.clinicNotes;
        data["mondayClinicNotes"] = this.mondayClinicNotes;
        data["tuesdayClinicNotes"] = this.tuesdayClinicNotes;
        data["wednesdayClinicNotes"] = this.wednesdayClinicNotes;
        data["thursdayClinicNotes"] = this.thursdayClinicNotes;
        data["fridayClinicNotes"] = this.fridayClinicNotes;
        data["saturdayClinicNotes"] = this.saturdayClinicNotes;
        data["sundayClinicNotes"] = this.sundayClinicNotes;
        data["clinicNotesVisibleToDriver"] = this.clinicNotesVisibleToDriver;
        data["billingNotes"] = this.billingNotes;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["accountNo"] = this.accountNo;
        data["active"] = this.active;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IClinic {
    tenantId: number | undefined;
    clinicNotes: string | undefined;
    mondayClinicNotes: string | undefined;
    tuesdayClinicNotes: string | undefined;
    wednesdayClinicNotes: string | undefined;
    thursdayClinicNotes: string | undefined;
    fridayClinicNotes: string | undefined;
    saturdayClinicNotes: string | undefined;
    sundayClinicNotes: string | undefined;
    clinicNotesVisibleToDriver: boolean;
    billingNotes: string | undefined;
    contact: Contact | undefined;
    contactId: number;
    accountNo: string | undefined;
    active: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderStatusDescription implements IOrderStatusDescription {
    tenantId!: number | undefined;
    description!: string | undefined;
    orderStatusType!: OrderStatusType | undefined;
    orderStatusTypeId!: number;
    name!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    visible!: boolean;
    parentId!: number | undefined;
    sortOrder!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderStatusDescription) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.description = data["description"];
            this.orderStatusType = data["orderStatusType"] ? OrderStatusType.fromJS(data["orderStatusType"]) : <any>undefined;
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.name = data["name"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.visible = data["visible"];
            this.parentId = data["parentId"];
            this.sortOrder = data["sortOrder"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatusDescription {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusDescription();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["description"] = this.description;
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["name"] = this.name;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["visible"] = this.visible;
        data["parentId"] = this.parentId;
        data["sortOrder"] = this.sortOrder;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatusDescription {
    tenantId: number | undefined;
    description: string | undefined;
    orderStatusType: OrderStatusType | undefined;
    orderStatusTypeId: number;
    name: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    visible: boolean;
    parentId: number | undefined;
    sortOrder: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderExtra implements IOrderExtra {
    tenantId!: number | undefined;
    order!: Order | undefined;
    orderId!: number;
    type!: string | undefined;
    value!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderExtra) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.type = data["type"];
            this.value = data["value"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderExtra {
        data = typeof data === 'object' ? data : {};
        let result = new OrderExtra();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["type"] = this.type;
        data["value"] = this.value;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderExtra {
    tenantId: number | undefined;
    order: Order | undefined;
    orderId: number;
    type: string | undefined;
    value: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class BinaryObject implements IBinaryObject {
    tenantId!: number | undefined;
    bytes!: string;
    id!: string;

    constructor(data?: IBinaryObject) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.bytes = data["bytes"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): BinaryObject {
        data = typeof data === 'object' ? data : {};
        let result = new BinaryObject();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["bytes"] = this.bytes;
        data["id"] = this.id;
        return data; 
    }
}

export interface IBinaryObject {
    tenantId: number | undefined;
    bytes: string;
    id: string;
}

export class OrderStatusAttachment implements IOrderStatusAttachment {
    order!: Order | undefined;
    orderId!: number;
    binaryObject!: BinaryObject | undefined;
    binaryObjectId!: string;
    fileName!: string | undefined;
    deviceTime!: moment.Moment;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderStatusAttachment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.binaryObject = data["binaryObject"] ? BinaryObject.fromJS(data["binaryObject"]) : <any>undefined;
            this.binaryObjectId = data["binaryObjectId"];
            this.fileName = data["fileName"];
            this.deviceTime = data["deviceTime"] ? moment(data["deviceTime"].toString()) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatusAttachment {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusAttachment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["binaryObject"] = this.binaryObject ? this.binaryObject.toJSON() : <any>undefined;
        data["binaryObjectId"] = this.binaryObjectId;
        data["fileName"] = this.fileName;
        data["deviceTime"] = this.deviceTime ? this.deviceTime.toISOString() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatusAttachment {
    order: Order | undefined;
    orderId: number;
    binaryObject: BinaryObject | undefined;
    binaryObjectId: string;
    fileName: string | undefined;
    deviceTime: moment.Moment;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export enum DayOfWeek {
    Sunday = 0,
    Monday = 1,
    Tuesday = 2,
    Wednesday = 3,
    Thursday = 4,
    Friday = 5,
    Saturday = 6,
}

export enum TimeTypes {
    CUTOFF = 0,
    ETA = 1,
    LTA = 2,
}

export class RouteScheduleDetailEtas implements IRouteScheduleDetailEtas {
    routeScheduleDetail!: RouteScheduleDetail | undefined;
    routeScheduleDetailId!: number | undefined;
    time!: TimeSpan;
    day!: DayOfWeek;
    type!: TimeTypes;
    analyzedTime!: moment.Moment | undefined;
    analyzedByUserId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteScheduleDetailEtas) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeScheduleDetail = data["routeScheduleDetail"] ? RouteScheduleDetail.fromJS(data["routeScheduleDetail"]) : <any>undefined;
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.time = data["time"] ? TimeSpan.fromJS(data["time"]) : <any>undefined;
            this.day = data["day"];
            this.type = data["type"];
            this.analyzedTime = data["analyzedTime"] ? moment(data["analyzedTime"].toString()) : <any>undefined;
            this.analyzedByUserId = data["analyzedByUserId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteScheduleDetailEtas {
        data = typeof data === 'object' ? data : {};
        let result = new RouteScheduleDetailEtas();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeScheduleDetail"] = this.routeScheduleDetail ? this.routeScheduleDetail.toJSON() : <any>undefined;
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["time"] = this.time ? this.time.toJSON() : <any>undefined;
        data["day"] = this.day;
        data["type"] = this.type;
        data["analyzedTime"] = this.analyzedTime ? this.analyzedTime.toISOString() : <any>undefined;
        data["analyzedByUserId"] = this.analyzedByUserId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteScheduleDetailEtas {
    routeScheduleDetail: RouteScheduleDetail | undefined;
    routeScheduleDetailId: number | undefined;
    time: TimeSpan;
    day: DayOfWeek;
    type: TimeTypes;
    analyzedTime: moment.Moment | undefined;
    analyzedByUserId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteScheduleDetail implements IRouteScheduleDetail {
    tenantId!: number | undefined;
    routeCode!: string;
    estimatedTimeOfArrival!: moment.Moment;
    cutOff!: moment.Moment;
    etaTime!: TimeSpan;
    mondayETATime!: TimeSpan | undefined;
    tuesdayETATime!: TimeSpan | undefined;
    wednesdayETATime!: TimeSpan | undefined;
    thursdayETATime!: TimeSpan | undefined;
    fridayETATime!: TimeSpan | undefined;
    saturdayETATime!: TimeSpan | undefined;
    sundayETATime!: TimeSpan | undefined;
    cutOffTime!: TimeSpan;
    mondayCutOffTime!: TimeSpan | undefined;
    tuesdayCutOffTime!: TimeSpan | undefined;
    wednesdayCutOffTime!: TimeSpan | undefined;
    thursdayCutOffTime!: TimeSpan | undefined;
    fridayCutOffTime!: TimeSpan | undefined;
    saturdayCutOffTime!: TimeSpan | undefined;
    sundayCutOffTime!: TimeSpan | undefined;
    mondayIsAuto!: number | undefined;
    tuesdayIsAuto!: number | undefined;
    wednesdayIsAuto!: number | undefined;
    thursdayIsAuto!: number | undefined;
    fridayIsAuto!: number | undefined;
    saturdayIsAuto!: number | undefined;
    sundayIsAuto!: number | undefined;
    isActive!: boolean;
    oorRate!: number | undefined;
    rate!: number | undefined;
    effectivityDate!: moment.Moment;
    routeType!: RouteType | undefined;
    routeTypeId!: number | undefined;
    routeTemplateFk!: RouteTemplate | undefined;
    routeTemplateId!: number | undefined;
    clinic!: Clinic | undefined;
    contact!: Contact | undefined;
    contactId!: number | undefined;
    pickupDetail!: DestinationDetail | undefined;
    deliveryDetail!: DestinationDetail | undefined;
    note!: Note | undefined;
    orderStatus!: OrderStatus | undefined;
    orderStatusDescription!: OrderStatusDescription | undefined;
    orderPackages!: OrderPackage[] | undefined;
    orders!: Order | undefined;
    company!: Company | undefined;
    packageCount!: number;
    action!: string | undefined;
    orderExtras!: OrderExtra[] | undefined;
    orderStatusAttachment!: OrderStatusAttachment[] | undefined;
    sortOrder!: number | undefined;
    timeWindowStart!: number;
    timeWindowEnd!: number | undefined;
    serviceTime!: number;
    pickUp!: boolean;
    deliveryNote!: string | undefined;
    locked!: boolean;
    orderType!: OrderType | undefined;
    etaLocked!: boolean;
    etaLockedByUser!: User | undefined;
    etaLockedByUserId!: number | undefined;
    dateEtaLocked!: moment.Moment | undefined;
    driverName!: string | undefined;
    mondayLTA!: TimeSpan | undefined;
    tuesdayLTA!: TimeSpan | undefined;
    wednesdayLTA!: TimeSpan | undefined;
    thursdayLTA!: TimeSpan | undefined;
    fridayLTA!: TimeSpan | undefined;
    saturdayLTA!: TimeSpan | undefined;
    sundayLTA!: TimeSpan | undefined;
    etas!: RouteScheduleDetailEtas[] | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteScheduleDetail) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeCode = data["routeCode"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"] ? moment(data["estimatedTimeOfArrival"].toString()) : <any>undefined;
            this.cutOff = data["cutOff"] ? moment(data["cutOff"].toString()) : <any>undefined;
            this.etaTime = data["etaTime"] ? TimeSpan.fromJS(data["etaTime"]) : <any>undefined;
            this.mondayETATime = data["mondayETATime"] ? TimeSpan.fromJS(data["mondayETATime"]) : <any>undefined;
            this.tuesdayETATime = data["tuesdayETATime"] ? TimeSpan.fromJS(data["tuesdayETATime"]) : <any>undefined;
            this.wednesdayETATime = data["wednesdayETATime"] ? TimeSpan.fromJS(data["wednesdayETATime"]) : <any>undefined;
            this.thursdayETATime = data["thursdayETATime"] ? TimeSpan.fromJS(data["thursdayETATime"]) : <any>undefined;
            this.fridayETATime = data["fridayETATime"] ? TimeSpan.fromJS(data["fridayETATime"]) : <any>undefined;
            this.saturdayETATime = data["saturdayETATime"] ? TimeSpan.fromJS(data["saturdayETATime"]) : <any>undefined;
            this.sundayETATime = data["sundayETATime"] ? TimeSpan.fromJS(data["sundayETATime"]) : <any>undefined;
            this.cutOffTime = data["cutOffTime"] ? TimeSpan.fromJS(data["cutOffTime"]) : <any>undefined;
            this.mondayCutOffTime = data["mondayCutOffTime"] ? TimeSpan.fromJS(data["mondayCutOffTime"]) : <any>undefined;
            this.tuesdayCutOffTime = data["tuesdayCutOffTime"] ? TimeSpan.fromJS(data["tuesdayCutOffTime"]) : <any>undefined;
            this.wednesdayCutOffTime = data["wednesdayCutOffTime"] ? TimeSpan.fromJS(data["wednesdayCutOffTime"]) : <any>undefined;
            this.thursdayCutOffTime = data["thursdayCutOffTime"] ? TimeSpan.fromJS(data["thursdayCutOffTime"]) : <any>undefined;
            this.fridayCutOffTime = data["fridayCutOffTime"] ? TimeSpan.fromJS(data["fridayCutOffTime"]) : <any>undefined;
            this.saturdayCutOffTime = data["saturdayCutOffTime"] ? TimeSpan.fromJS(data["saturdayCutOffTime"]) : <any>undefined;
            this.sundayCutOffTime = data["sundayCutOffTime"] ? TimeSpan.fromJS(data["sundayCutOffTime"]) : <any>undefined;
            this.mondayIsAuto = data["mondayIsAuto"];
            this.tuesdayIsAuto = data["tuesdayIsAuto"];
            this.wednesdayIsAuto = data["wednesdayIsAuto"];
            this.thursdayIsAuto = data["thursdayIsAuto"];
            this.fridayIsAuto = data["fridayIsAuto"];
            this.saturdayIsAuto = data["saturdayIsAuto"];
            this.sundayIsAuto = data["sundayIsAuto"];
            this.isActive = data["isActive"];
            this.oorRate = data["oorRate"];
            this.rate = data["rate"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.routeType = data["routeType"] ? RouteType.fromJS(data["routeType"]) : <any>undefined;
            this.routeTypeId = data["routeTypeId"];
            this.routeTemplateFk = data["routeTemplateFk"] ? RouteTemplate.fromJS(data["routeTemplateFk"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.clinic = data["clinic"] ? Clinic.fromJS(data["clinic"]) : <any>undefined;
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.pickupDetail = data["pickupDetail"] ? DestinationDetail.fromJS(data["pickupDetail"]) : <any>undefined;
            this.deliveryDetail = data["deliveryDetail"] ? DestinationDetail.fromJS(data["deliveryDetail"]) : <any>undefined;
            this.note = data["note"] ? Note.fromJS(data["note"]) : <any>undefined;
            this.orderStatus = data["orderStatus"] ? OrderStatus.fromJS(data["orderStatus"]) : <any>undefined;
            this.orderStatusDescription = data["orderStatusDescription"] ? OrderStatusDescription.fromJS(data["orderStatusDescription"]) : <any>undefined;
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackage.fromJS(item));
            }
            this.orders = data["orders"] ? Order.fromJS(data["orders"]) : <any>undefined;
            this.company = data["company"] ? Company.fromJS(data["company"]) : <any>undefined;
            this.packageCount = data["packageCount"];
            this.action = data["action"];
            if (Array.isArray(data["orderExtras"])) {
                this.orderExtras = [] as any;
                for (let item of data["orderExtras"])
                    this.orderExtras!.push(OrderExtra.fromJS(item));
            }
            if (Array.isArray(data["orderStatusAttachment"])) {
                this.orderStatusAttachment = [] as any;
                for (let item of data["orderStatusAttachment"])
                    this.orderStatusAttachment!.push(OrderStatusAttachment.fromJS(item));
            }
            this.sortOrder = data["sortOrder"];
            this.timeWindowStart = data["timeWindowStart"];
            this.timeWindowEnd = data["timeWindowEnd"];
            this.serviceTime = data["serviceTime"];
            this.pickUp = data["pickUp"];
            this.deliveryNote = data["deliveryNote"];
            this.locked = data["locked"];
            this.orderType = data["orderType"] ? OrderType.fromJS(data["orderType"]) : <any>undefined;
            this.etaLocked = data["etaLocked"];
            this.etaLockedByUser = data["etaLockedByUser"] ? User.fromJS(data["etaLockedByUser"]) : <any>undefined;
            this.etaLockedByUserId = data["etaLockedByUserId"];
            this.dateEtaLocked = data["dateEtaLocked"] ? moment(data["dateEtaLocked"].toString()) : <any>undefined;
            this.driverName = data["driverName"];
            this.mondayLTA = data["mondayLTA"] ? TimeSpan.fromJS(data["mondayLTA"]) : <any>undefined;
            this.tuesdayLTA = data["tuesdayLTA"] ? TimeSpan.fromJS(data["tuesdayLTA"]) : <any>undefined;
            this.wednesdayLTA = data["wednesdayLTA"] ? TimeSpan.fromJS(data["wednesdayLTA"]) : <any>undefined;
            this.thursdayLTA = data["thursdayLTA"] ? TimeSpan.fromJS(data["thursdayLTA"]) : <any>undefined;
            this.fridayLTA = data["fridayLTA"] ? TimeSpan.fromJS(data["fridayLTA"]) : <any>undefined;
            this.saturdayLTA = data["saturdayLTA"] ? TimeSpan.fromJS(data["saturdayLTA"]) : <any>undefined;
            this.sundayLTA = data["sundayLTA"] ? TimeSpan.fromJS(data["sundayLTA"]) : <any>undefined;
            if (Array.isArray(data["etas"])) {
                this.etas = [] as any;
                for (let item of data["etas"])
                    this.etas!.push(RouteScheduleDetailEtas.fromJS(item));
            }
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteScheduleDetail {
        data = typeof data === 'object' ? data : {};
        let result = new RouteScheduleDetail();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeCode"] = this.routeCode;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival ? this.estimatedTimeOfArrival.toISOString() : <any>undefined;
        data["cutOff"] = this.cutOff ? this.cutOff.toISOString() : <any>undefined;
        data["etaTime"] = this.etaTime ? this.etaTime.toJSON() : <any>undefined;
        data["mondayETATime"] = this.mondayETATime ? this.mondayETATime.toJSON() : <any>undefined;
        data["tuesdayETATime"] = this.tuesdayETATime ? this.tuesdayETATime.toJSON() : <any>undefined;
        data["wednesdayETATime"] = this.wednesdayETATime ? this.wednesdayETATime.toJSON() : <any>undefined;
        data["thursdayETATime"] = this.thursdayETATime ? this.thursdayETATime.toJSON() : <any>undefined;
        data["fridayETATime"] = this.fridayETATime ? this.fridayETATime.toJSON() : <any>undefined;
        data["saturdayETATime"] = this.saturdayETATime ? this.saturdayETATime.toJSON() : <any>undefined;
        data["sundayETATime"] = this.sundayETATime ? this.sundayETATime.toJSON() : <any>undefined;
        data["cutOffTime"] = this.cutOffTime ? this.cutOffTime.toJSON() : <any>undefined;
        data["mondayCutOffTime"] = this.mondayCutOffTime ? this.mondayCutOffTime.toJSON() : <any>undefined;
        data["tuesdayCutOffTime"] = this.tuesdayCutOffTime ? this.tuesdayCutOffTime.toJSON() : <any>undefined;
        data["wednesdayCutOffTime"] = this.wednesdayCutOffTime ? this.wednesdayCutOffTime.toJSON() : <any>undefined;
        data["thursdayCutOffTime"] = this.thursdayCutOffTime ? this.thursdayCutOffTime.toJSON() : <any>undefined;
        data["fridayCutOffTime"] = this.fridayCutOffTime ? this.fridayCutOffTime.toJSON() : <any>undefined;
        data["saturdayCutOffTime"] = this.saturdayCutOffTime ? this.saturdayCutOffTime.toJSON() : <any>undefined;
        data["sundayCutOffTime"] = this.sundayCutOffTime ? this.sundayCutOffTime.toJSON() : <any>undefined;
        data["mondayIsAuto"] = this.mondayIsAuto;
        data["tuesdayIsAuto"] = this.tuesdayIsAuto;
        data["wednesdayIsAuto"] = this.wednesdayIsAuto;
        data["thursdayIsAuto"] = this.thursdayIsAuto;
        data["fridayIsAuto"] = this.fridayIsAuto;
        data["saturdayIsAuto"] = this.saturdayIsAuto;
        data["sundayIsAuto"] = this.sundayIsAuto;
        data["isActive"] = this.isActive;
        data["oorRate"] = this.oorRate;
        data["rate"] = this.rate;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["routeType"] = this.routeType ? this.routeType.toJSON() : <any>undefined;
        data["routeTypeId"] = this.routeTypeId;
        data["routeTemplateFk"] = this.routeTemplateFk ? this.routeTemplateFk.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["clinic"] = this.clinic ? this.clinic.toJSON() : <any>undefined;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["pickupDetail"] = this.pickupDetail ? this.pickupDetail.toJSON() : <any>undefined;
        data["deliveryDetail"] = this.deliveryDetail ? this.deliveryDetail.toJSON() : <any>undefined;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["orderStatus"] = this.orderStatus ? this.orderStatus.toJSON() : <any>undefined;
        data["orderStatusDescription"] = this.orderStatusDescription ? this.orderStatusDescription.toJSON() : <any>undefined;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        data["orders"] = this.orders ? this.orders.toJSON() : <any>undefined;
        data["company"] = this.company ? this.company.toJSON() : <any>undefined;
        data["packageCount"] = this.packageCount;
        data["action"] = this.action;
        if (Array.isArray(this.orderExtras)) {
            data["orderExtras"] = [];
            for (let item of this.orderExtras)
                data["orderExtras"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatusAttachment)) {
            data["orderStatusAttachment"] = [];
            for (let item of this.orderStatusAttachment)
                data["orderStatusAttachment"].push(item.toJSON());
        }
        data["sortOrder"] = this.sortOrder;
        data["timeWindowStart"] = this.timeWindowStart;
        data["timeWindowEnd"] = this.timeWindowEnd;
        data["serviceTime"] = this.serviceTime;
        data["pickUp"] = this.pickUp;
        data["deliveryNote"] = this.deliveryNote;
        data["locked"] = this.locked;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["etaLocked"] = this.etaLocked;
        data["etaLockedByUser"] = this.etaLockedByUser ? this.etaLockedByUser.toJSON() : <any>undefined;
        data["etaLockedByUserId"] = this.etaLockedByUserId;
        data["dateEtaLocked"] = this.dateEtaLocked ? this.dateEtaLocked.toISOString() : <any>undefined;
        data["driverName"] = this.driverName;
        data["mondayLTA"] = this.mondayLTA ? this.mondayLTA.toJSON() : <any>undefined;
        data["tuesdayLTA"] = this.tuesdayLTA ? this.tuesdayLTA.toJSON() : <any>undefined;
        data["wednesdayLTA"] = this.wednesdayLTA ? this.wednesdayLTA.toJSON() : <any>undefined;
        data["thursdayLTA"] = this.thursdayLTA ? this.thursdayLTA.toJSON() : <any>undefined;
        data["fridayLTA"] = this.fridayLTA ? this.fridayLTA.toJSON() : <any>undefined;
        data["saturdayLTA"] = this.saturdayLTA ? this.saturdayLTA.toJSON() : <any>undefined;
        data["sundayLTA"] = this.sundayLTA ? this.sundayLTA.toJSON() : <any>undefined;
        if (Array.isArray(this.etas)) {
            data["etas"] = [];
            for (let item of this.etas)
                data["etas"].push(item.toJSON());
        }
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteScheduleDetail {
    tenantId: number | undefined;
    routeCode: string;
    estimatedTimeOfArrival: moment.Moment;
    cutOff: moment.Moment;
    etaTime: TimeSpan;
    mondayETATime: TimeSpan | undefined;
    tuesdayETATime: TimeSpan | undefined;
    wednesdayETATime: TimeSpan | undefined;
    thursdayETATime: TimeSpan | undefined;
    fridayETATime: TimeSpan | undefined;
    saturdayETATime: TimeSpan | undefined;
    sundayETATime: TimeSpan | undefined;
    cutOffTime: TimeSpan;
    mondayCutOffTime: TimeSpan | undefined;
    tuesdayCutOffTime: TimeSpan | undefined;
    wednesdayCutOffTime: TimeSpan | undefined;
    thursdayCutOffTime: TimeSpan | undefined;
    fridayCutOffTime: TimeSpan | undefined;
    saturdayCutOffTime: TimeSpan | undefined;
    sundayCutOffTime: TimeSpan | undefined;
    mondayIsAuto: number | undefined;
    tuesdayIsAuto: number | undefined;
    wednesdayIsAuto: number | undefined;
    thursdayIsAuto: number | undefined;
    fridayIsAuto: number | undefined;
    saturdayIsAuto: number | undefined;
    sundayIsAuto: number | undefined;
    isActive: boolean;
    oorRate: number | undefined;
    rate: number | undefined;
    effectivityDate: moment.Moment;
    routeType: RouteType | undefined;
    routeTypeId: number | undefined;
    routeTemplateFk: RouteTemplate | undefined;
    routeTemplateId: number | undefined;
    clinic: Clinic | undefined;
    contact: Contact | undefined;
    contactId: number | undefined;
    pickupDetail: DestinationDetail | undefined;
    deliveryDetail: DestinationDetail | undefined;
    note: Note | undefined;
    orderStatus: OrderStatus | undefined;
    orderStatusDescription: OrderStatusDescription | undefined;
    orderPackages: OrderPackage[] | undefined;
    orders: Order | undefined;
    company: Company | undefined;
    packageCount: number;
    action: string | undefined;
    orderExtras: OrderExtra[] | undefined;
    orderStatusAttachment: OrderStatusAttachment[] | undefined;
    sortOrder: number | undefined;
    timeWindowStart: number;
    timeWindowEnd: number | undefined;
    serviceTime: number;
    pickUp: boolean;
    deliveryNote: string | undefined;
    locked: boolean;
    orderType: OrderType | undefined;
    etaLocked: boolean;
    etaLockedByUser: User | undefined;
    etaLockedByUserId: number | undefined;
    dateEtaLocked: moment.Moment | undefined;
    driverName: string | undefined;
    mondayLTA: TimeSpan | undefined;
    tuesdayLTA: TimeSpan | undefined;
    wednesdayLTA: TimeSpan | undefined;
    thursdayLTA: TimeSpan | undefined;
    fridayLTA: TimeSpan | undefined;
    saturdayLTA: TimeSpan | undefined;
    sundayLTA: TimeSpan | undefined;
    etas: RouteScheduleDetailEtas[] | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Zone implements IZone {
    tenantId!: number | undefined;
    name!: string;
    isPrimary!: boolean;
    postalCodeZone!: PostalCodeZone[] | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IZone) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.isPrimary = data["isPrimary"];
            if (Array.isArray(data["postalCodeZone"])) {
                this.postalCodeZone = [] as any;
                for (let item of data["postalCodeZone"])
                    this.postalCodeZone!.push(PostalCodeZone.fromJS(item));
            }
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Zone {
        data = typeof data === 'object' ? data : {};
        let result = new Zone();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["isPrimary"] = this.isPrimary;
        if (Array.isArray(this.postalCodeZone)) {
            data["postalCodeZone"] = [];
            for (let item of this.postalCodeZone)
                data["postalCodeZone"].push(item.toJSON());
        }
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IZone {
    tenantId: number | undefined;
    name: string;
    isPrimary: boolean;
    postalCodeZone: PostalCodeZone[] | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class PostalCodeZone implements IPostalCodeZone {
    tenantId!: number | undefined;
    postalCode!: PostalCode | undefined;
    postalCodeId!: number;
    zone!: Zone | undefined;
    zoneId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IPostalCodeZone) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.postalCode = data["postalCode"] ? PostalCode.fromJS(data["postalCode"]) : <any>undefined;
            this.postalCodeId = data["postalCodeId"];
            this.zone = data["zone"] ? Zone.fromJS(data["zone"]) : <any>undefined;
            this.zoneId = data["zoneId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PostalCodeZone {
        data = typeof data === 'object' ? data : {};
        let result = new PostalCodeZone();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["postalCode"] = this.postalCode ? this.postalCode.toJSON() : <any>undefined;
        data["postalCodeId"] = this.postalCodeId;
        data["zone"] = this.zone ? this.zone.toJSON() : <any>undefined;
        data["zoneId"] = this.zoneId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPostalCodeZone {
    tenantId: number | undefined;
    postalCode: PostalCode | undefined;
    postalCodeId: number;
    zone: Zone | undefined;
    zoneId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteHandOffDefinitionOrder implements IRouteHandOffDefinitionOrder {
    tenantId!: number | undefined;
    order!: Order | undefined;
    orderId!: number;
    routeHandOffDefinitionId!: number;
    routeTemplateId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteHandOffDefinitionOrder) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.routeHandOffDefinitionId = data["routeHandOffDefinitionId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteHandOffDefinitionOrder {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffDefinitionOrder();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["routeHandOffDefinitionId"] = this.routeHandOffDefinitionId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteHandOffDefinitionOrder {
    tenantId: number | undefined;
    order: Order | undefined;
    orderId: number;
    routeHandOffDefinitionId: number;
    routeTemplateId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class BigInteger implements IBigInteger {
    readonly isPowerOfTwo!: boolean;
    readonly isZero!: boolean;
    readonly isOne!: boolean;
    readonly isEven!: boolean;
    readonly sign!: number;

    constructor(data?: IBigInteger) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).isPowerOfTwo = data["isPowerOfTwo"];
            (<any>this).isZero = data["isZero"];
            (<any>this).isOne = data["isOne"];
            (<any>this).isEven = data["isEven"];
            (<any>this).sign = data["sign"];
        }
    }

    static fromJS(data: any): BigInteger {
        data = typeof data === 'object' ? data : {};
        let result = new BigInteger();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isPowerOfTwo"] = this.isPowerOfTwo;
        data["isZero"] = this.isZero;
        data["isOne"] = this.isOne;
        data["isEven"] = this.isEven;
        data["sign"] = this.sign;
        return data; 
    }
}

export interface IBigInteger {
    isPowerOfTwo: boolean;
    isZero: boolean;
    isOne: boolean;
    isEven: boolean;
    sign: number;
}

export class Order implements IOrder {
    tenantId!: number | undefined;
    user!: User | undefined;
    userId!: number | undefined;
    pickupDetail!: DestinationDetail | undefined;
    pickupDetailsId!: number;
    deliveryDetail!: DestinationDetail | undefined;
    deliveryDetailsId!: number;
    originalPickupDetail!: DestinationDetail | undefined;
    originalPickupDetailsId!: number | undefined;
    originalDeliveryDetail!: DestinationDetail | undefined;
    originalDeliveryDetailsId!: number | undefined;
    location!: Location | undefined;
    locationId!: number;
    note!: Note | undefined;
    noteId!: number | undefined;
    notes!: string | undefined;
    route!: Route | undefined;
    routeId!: number | undefined;
    orderType!: OrderType | undefined;
    orderTypeId!: number | undefined;
    orderPackages!: OrderPackage[] | undefined;
    sortOrder!: number | undefined;
    hasReadNote!: boolean;
    clinicNotesVisibleToDriver!: boolean;
    locked!: boolean;
    lockedByUser!: User | undefined;
    lockedByUserId!: number | undefined;
    orderSource!: OrderSource | undefined;
    orderSourceId!: number | undefined;
    dateLocked!: moment.Moment | undefined;
    requester!: string | undefined;
    pickupDate!: moment.Moment | undefined;
    deliveryDate!: moment.Moment | undefined;
    notesVisibleToDriver!: boolean;
    orderTagId!: number | undefined;
    orderTags!: OrderTag[] | undefined;
    tags!: Tag[] | undefined;
    orderStatusId!: number | undefined;
    proximityCode!: ProximityCode | undefined;
    orderStatus!: OrderStatus | undefined;
    clinicId!: number | undefined;
    routeScheduleDetail!: RouteScheduleDetail | undefined;
    orderPackage!: OrderPackage | undefined;
    orderPackageId!: number | undefined;
    recipientName!: string | undefined;
    recipientAddress1!: string | undefined;
    recipientAddress2!: string | undefined;
    recipientCountry!: string | undefined;
    recipientCity!: string | undefined;
    recipientState!: string | undefined;
    recipientZip!: string | undefined;
    senderName!: string | undefined;
    zone!: PostalCodeZone | undefined;
    contact!: Contact | undefined;
    orderExtras!: OrderExtra[] | undefined;
    orderStatuses!: OrderStatus[] | undefined;
    status!: OrderStatusType | undefined;
    statusId!: number | undefined;
    orderStatusDescription!: OrderStatusDescription | undefined;
    postalCodeZone!: PostalCodeZone | undefined;
    linehaulParentRouteId!: number | undefined;
    isMoved!: boolean;
    lineHaulParentRouteCode!: string | undefined;
    toAssignedRouteTemplate!: RouteTemplate | undefined;
    routeTemplateId!: number | undefined;
    scheduleId!: number | undefined;
    routeHandOffDefinitionId!: number | undefined;
    routeHandOffDefinitionOrders!: RouteHandOffDefinitionOrder[] | undefined;
    routeHandOffTemplateId!: number | undefined;
    bigIntGuid!: BigInteger;
    recurringOrderScheduleId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrder) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.pickupDetail = data["pickupDetail"] ? DestinationDetail.fromJS(data["pickupDetail"]) : <any>undefined;
            this.pickupDetailsId = data["pickupDetailsId"];
            this.deliveryDetail = data["deliveryDetail"] ? DestinationDetail.fromJS(data["deliveryDetail"]) : <any>undefined;
            this.deliveryDetailsId = data["deliveryDetailsId"];
            this.originalPickupDetail = data["originalPickupDetail"] ? DestinationDetail.fromJS(data["originalPickupDetail"]) : <any>undefined;
            this.originalPickupDetailsId = data["originalPickupDetailsId"];
            this.originalDeliveryDetail = data["originalDeliveryDetail"] ? DestinationDetail.fromJS(data["originalDeliveryDetail"]) : <any>undefined;
            this.originalDeliveryDetailsId = data["originalDeliveryDetailsId"];
            this.location = data["location"] ? Location.fromJS(data["location"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.note = data["note"] ? Note.fromJS(data["note"]) : <any>undefined;
            this.noteId = data["noteId"];
            this.notes = data["notes"];
            this.route = data["route"] ? Route.fromJS(data["route"]) : <any>undefined;
            this.routeId = data["routeId"];
            this.orderType = data["orderType"] ? OrderType.fromJS(data["orderType"]) : <any>undefined;
            this.orderTypeId = data["orderTypeId"];
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackage.fromJS(item));
            }
            this.sortOrder = data["sortOrder"];
            this.hasReadNote = data["hasReadNote"];
            this.clinicNotesVisibleToDriver = data["clinicNotesVisibleToDriver"];
            this.locked = data["locked"];
            this.lockedByUser = data["lockedByUser"] ? User.fromJS(data["lockedByUser"]) : <any>undefined;
            this.lockedByUserId = data["lockedByUserId"];
            this.orderSource = data["orderSource"] ? OrderSource.fromJS(data["orderSource"]) : <any>undefined;
            this.orderSourceId = data["orderSourceId"];
            this.dateLocked = data["dateLocked"] ? moment(data["dateLocked"].toString()) : <any>undefined;
            this.requester = data["requester"];
            this.pickupDate = data["pickupDate"] ? moment(data["pickupDate"].toString()) : <any>undefined;
            this.deliveryDate = data["deliveryDate"] ? moment(data["deliveryDate"].toString()) : <any>undefined;
            this.notesVisibleToDriver = data["notesVisibleToDriver"];
            this.orderTagId = data["orderTagId"];
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(OrderTag.fromJS(item));
            }
            if (Array.isArray(data["tags"])) {
                this.tags = [] as any;
                for (let item of data["tags"])
                    this.tags!.push(Tag.fromJS(item));
            }
            this.orderStatusId = data["orderStatusId"];
            this.proximityCode = data["proximityCode"] ? ProximityCode.fromJS(data["proximityCode"]) : <any>undefined;
            this.orderStatus = data["orderStatus"] ? OrderStatus.fromJS(data["orderStatus"]) : <any>undefined;
            this.clinicId = data["clinicId"];
            this.routeScheduleDetail = data["routeScheduleDetail"] ? RouteScheduleDetail.fromJS(data["routeScheduleDetail"]) : <any>undefined;
            this.orderPackage = data["orderPackage"] ? OrderPackage.fromJS(data["orderPackage"]) : <any>undefined;
            this.orderPackageId = data["orderPackageId"];
            this.recipientName = data["recipientName"];
            this.recipientAddress1 = data["recipientAddress1"];
            this.recipientAddress2 = data["recipientAddress2"];
            this.recipientCountry = data["recipientCountry"];
            this.recipientCity = data["recipientCity"];
            this.recipientState = data["recipientState"];
            this.recipientZip = data["recipientZip"];
            this.senderName = data["senderName"];
            this.zone = data["zone"] ? PostalCodeZone.fromJS(data["zone"]) : <any>undefined;
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            if (Array.isArray(data["orderExtras"])) {
                this.orderExtras = [] as any;
                for (let item of data["orderExtras"])
                    this.orderExtras!.push(OrderExtra.fromJS(item));
            }
            if (Array.isArray(data["orderStatuses"])) {
                this.orderStatuses = [] as any;
                for (let item of data["orderStatuses"])
                    this.orderStatuses!.push(OrderStatus.fromJS(item));
            }
            this.status = data["status"] ? OrderStatusType.fromJS(data["status"]) : <any>undefined;
            this.statusId = data["statusId"];
            this.orderStatusDescription = data["orderStatusDescription"] ? OrderStatusDescription.fromJS(data["orderStatusDescription"]) : <any>undefined;
            this.postalCodeZone = data["postalCodeZone"] ? PostalCodeZone.fromJS(data["postalCodeZone"]) : <any>undefined;
            this.linehaulParentRouteId = data["linehaulParentRouteId"];
            this.isMoved = data["isMoved"];
            this.lineHaulParentRouteCode = data["lineHaulParentRouteCode"];
            this.toAssignedRouteTemplate = data["toAssignedRouteTemplate"] ? RouteTemplate.fromJS(data["toAssignedRouteTemplate"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.scheduleId = data["scheduleId"];
            this.routeHandOffDefinitionId = data["routeHandOffDefinitionId"];
            if (Array.isArray(data["routeHandOffDefinitionOrders"])) {
                this.routeHandOffDefinitionOrders = [] as any;
                for (let item of data["routeHandOffDefinitionOrders"])
                    this.routeHandOffDefinitionOrders!.push(RouteHandOffDefinitionOrder.fromJS(item));
            }
            this.routeHandOffTemplateId = data["routeHandOffTemplateId"];
            this.bigIntGuid = data["bigIntGuid"] ? BigInteger.fromJS(data["bigIntGuid"]) : <any>undefined;
            this.recurringOrderScheduleId = data["recurringOrderScheduleId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Order {
        data = typeof data === 'object' ? data : {};
        let result = new Order();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["pickupDetail"] = this.pickupDetail ? this.pickupDetail.toJSON() : <any>undefined;
        data["pickupDetailsId"] = this.pickupDetailsId;
        data["deliveryDetail"] = this.deliveryDetail ? this.deliveryDetail.toJSON() : <any>undefined;
        data["deliveryDetailsId"] = this.deliveryDetailsId;
        data["originalPickupDetail"] = this.originalPickupDetail ? this.originalPickupDetail.toJSON() : <any>undefined;
        data["originalPickupDetailsId"] = this.originalPickupDetailsId;
        data["originalDeliveryDetail"] = this.originalDeliveryDetail ? this.originalDeliveryDetail.toJSON() : <any>undefined;
        data["originalDeliveryDetailsId"] = this.originalDeliveryDetailsId;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["noteId"] = this.noteId;
        data["notes"] = this.notes;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["routeId"] = this.routeId;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["orderTypeId"] = this.orderTypeId;
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        data["sortOrder"] = this.sortOrder;
        data["hasReadNote"] = this.hasReadNote;
        data["clinicNotesVisibleToDriver"] = this.clinicNotesVisibleToDriver;
        data["locked"] = this.locked;
        data["lockedByUser"] = this.lockedByUser ? this.lockedByUser.toJSON() : <any>undefined;
        data["lockedByUserId"] = this.lockedByUserId;
        data["orderSource"] = this.orderSource ? this.orderSource.toJSON() : <any>undefined;
        data["orderSourceId"] = this.orderSourceId;
        data["dateLocked"] = this.dateLocked ? this.dateLocked.toISOString() : <any>undefined;
        data["requester"] = this.requester;
        data["pickupDate"] = this.pickupDate ? this.pickupDate.toISOString() : <any>undefined;
        data["deliveryDate"] = this.deliveryDate ? this.deliveryDate.toISOString() : <any>undefined;
        data["notesVisibleToDriver"] = this.notesVisibleToDriver;
        data["orderTagId"] = this.orderTagId;
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        if (Array.isArray(this.tags)) {
            data["tags"] = [];
            for (let item of this.tags)
                data["tags"].push(item.toJSON());
        }
        data["orderStatusId"] = this.orderStatusId;
        data["proximityCode"] = this.proximityCode ? this.proximityCode.toJSON() : <any>undefined;
        data["orderStatus"] = this.orderStatus ? this.orderStatus.toJSON() : <any>undefined;
        data["clinicId"] = this.clinicId;
        data["routeScheduleDetail"] = this.routeScheduleDetail ? this.routeScheduleDetail.toJSON() : <any>undefined;
        data["orderPackage"] = this.orderPackage ? this.orderPackage.toJSON() : <any>undefined;
        data["orderPackageId"] = this.orderPackageId;
        data["recipientName"] = this.recipientName;
        data["recipientAddress1"] = this.recipientAddress1;
        data["recipientAddress2"] = this.recipientAddress2;
        data["recipientCountry"] = this.recipientCountry;
        data["recipientCity"] = this.recipientCity;
        data["recipientState"] = this.recipientState;
        data["recipientZip"] = this.recipientZip;
        data["senderName"] = this.senderName;
        data["zone"] = this.zone ? this.zone.toJSON() : <any>undefined;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        if (Array.isArray(this.orderExtras)) {
            data["orderExtras"] = [];
            for (let item of this.orderExtras)
                data["orderExtras"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatuses)) {
            data["orderStatuses"] = [];
            for (let item of this.orderStatuses)
                data["orderStatuses"].push(item.toJSON());
        }
        data["status"] = this.status ? this.status.toJSON() : <any>undefined;
        data["statusId"] = this.statusId;
        data["orderStatusDescription"] = this.orderStatusDescription ? this.orderStatusDescription.toJSON() : <any>undefined;
        data["postalCodeZone"] = this.postalCodeZone ? this.postalCodeZone.toJSON() : <any>undefined;
        data["linehaulParentRouteId"] = this.linehaulParentRouteId;
        data["isMoved"] = this.isMoved;
        data["lineHaulParentRouteCode"] = this.lineHaulParentRouteCode;
        data["toAssignedRouteTemplate"] = this.toAssignedRouteTemplate ? this.toAssignedRouteTemplate.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["scheduleId"] = this.scheduleId;
        data["routeHandOffDefinitionId"] = this.routeHandOffDefinitionId;
        if (Array.isArray(this.routeHandOffDefinitionOrders)) {
            data["routeHandOffDefinitionOrders"] = [];
            for (let item of this.routeHandOffDefinitionOrders)
                data["routeHandOffDefinitionOrders"].push(item.toJSON());
        }
        data["routeHandOffTemplateId"] = this.routeHandOffTemplateId;
        data["bigIntGuid"] = this.bigIntGuid ? this.bigIntGuid.toJSON() : <any>undefined;
        data["recurringOrderScheduleId"] = this.recurringOrderScheduleId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrder {
    tenantId: number | undefined;
    user: User | undefined;
    userId: number | undefined;
    pickupDetail: DestinationDetail | undefined;
    pickupDetailsId: number;
    deliveryDetail: DestinationDetail | undefined;
    deliveryDetailsId: number;
    originalPickupDetail: DestinationDetail | undefined;
    originalPickupDetailsId: number | undefined;
    originalDeliveryDetail: DestinationDetail | undefined;
    originalDeliveryDetailsId: number | undefined;
    location: Location | undefined;
    locationId: number;
    note: Note | undefined;
    noteId: number | undefined;
    notes: string | undefined;
    route: Route | undefined;
    routeId: number | undefined;
    orderType: OrderType | undefined;
    orderTypeId: number | undefined;
    orderPackages: OrderPackage[] | undefined;
    sortOrder: number | undefined;
    hasReadNote: boolean;
    clinicNotesVisibleToDriver: boolean;
    locked: boolean;
    lockedByUser: User | undefined;
    lockedByUserId: number | undefined;
    orderSource: OrderSource | undefined;
    orderSourceId: number | undefined;
    dateLocked: moment.Moment | undefined;
    requester: string | undefined;
    pickupDate: moment.Moment | undefined;
    deliveryDate: moment.Moment | undefined;
    notesVisibleToDriver: boolean;
    orderTagId: number | undefined;
    orderTags: OrderTag[] | undefined;
    tags: Tag[] | undefined;
    orderStatusId: number | undefined;
    proximityCode: ProximityCode | undefined;
    orderStatus: OrderStatus | undefined;
    clinicId: number | undefined;
    routeScheduleDetail: RouteScheduleDetail | undefined;
    orderPackage: OrderPackage | undefined;
    orderPackageId: number | undefined;
    recipientName: string | undefined;
    recipientAddress1: string | undefined;
    recipientAddress2: string | undefined;
    recipientCountry: string | undefined;
    recipientCity: string | undefined;
    recipientState: string | undefined;
    recipientZip: string | undefined;
    senderName: string | undefined;
    zone: PostalCodeZone | undefined;
    contact: Contact | undefined;
    orderExtras: OrderExtra[] | undefined;
    orderStatuses: OrderStatus[] | undefined;
    status: OrderStatusType | undefined;
    statusId: number | undefined;
    orderStatusDescription: OrderStatusDescription | undefined;
    postalCodeZone: PostalCodeZone | undefined;
    linehaulParentRouteId: number | undefined;
    isMoved: boolean;
    lineHaulParentRouteCode: string | undefined;
    toAssignedRouteTemplate: RouteTemplate | undefined;
    routeTemplateId: number | undefined;
    scheduleId: number | undefined;
    routeHandOffDefinitionId: number | undefined;
    routeHandOffDefinitionOrders: RouteHandOffDefinitionOrder[] | undefined;
    routeHandOffTemplateId: number | undefined;
    bigIntGuid: BigInteger;
    recurringOrderScheduleId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class MobileClient implements IMobileClient {
    tenantId!: number | undefined;
    osName!: string | undefined;
    osVersion!: string | undefined;
    deviceModel!: string | undefined;
    appCode!: string | undefined;
    appVersion!: number;
    driverStatus!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IMobileClient) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.osName = data["osName"];
            this.osVersion = data["osVersion"];
            this.deviceModel = data["deviceModel"];
            this.appCode = data["appCode"];
            this.appVersion = data["appVersion"];
            this.driverStatus = data["driverStatus"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileClient {
        data = typeof data === 'object' ? data : {};
        let result = new MobileClient();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["osName"] = this.osName;
        data["osVersion"] = this.osVersion;
        data["deviceModel"] = this.deviceModel;
        data["appCode"] = this.appCode;
        data["appVersion"] = this.appVersion;
        data["driverStatus"] = this.driverStatus;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileClient {
    tenantId: number | undefined;
    osName: string | undefined;
    osVersion: string | undefined;
    deviceModel: string | undefined;
    appCode: string | undefined;
    appVersion: number;
    driverStatus: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Route implements IRoute {
    tenantId!: number | undefined;
    location!: Location | undefined;
    locationId!: number;
    vehicle!: Vehicle | undefined;
    vehicleId!: number | undefined;
    routeTemplate!: RouteTemplate | undefined;
    routeTemplateId!: number;
    activeOrderId!: number | undefined;
    loadDate!: moment.Moment;
    completion!: moment.Moment | undefined;
    departure!: moment.Moment | undefined;
    locked!: boolean;
    orders!: Order[] | undefined;
    closeTime!: moment.Moment | undefined;
    estimated!: moment.Moment | undefined;
    closedByUser!: User | undefined;
    closedByUserId!: number | undefined;
    freeze!: boolean;
    unFreezeByUser!: User | undefined;
    unFreezeByUserId!: number | undefined;
    unFreezeDate!: moment.Moment | undefined;
    unFreezeReason!: string | undefined;
    editCountByUser!: User | undefined;
    editCountByUserId!: number | undefined;
    editCountDate!: moment.Moment | undefined;
    notes!: string | undefined;
    isRunning!: boolean;
    cutOffAddjustments!: number | undefined;
    markedDeliveredById!: number | undefined;
    zone!: string | undefined;
    estimatedStartTime!: moment.Moment | undefined;
    deviceVersion!: string | undefined;
    deviceType!: string | undefined;
    routeId!: number | undefined;
    driverName!: string | undefined;
    totalPackages!: number;
    stops!: Order[] | undefined;
    destinations!: DestinationDetail[] | undefined;
    fullName!: string | undefined;
    name!: string | undefined;
    routeTemplateName!: string | undefined;
    userId!: number | undefined;
    vehicleName!: string | undefined;
    totalTime!: number;
    totalStops!: number;
    miles!: number;
    stopsPerHour!: number;
    milesPerHour!: number;
    timeZone!: string | undefined;
    mobileTimezone!: string | undefined;
    eta!: string | undefined;
    totalOrders!: number;
    currentVersion!: string | undefined;
    blindCode!: string | undefined;
    referenceNumber!: string | undefined;
    orderTypes!: string[] | undefined;
    selectedRoute!: boolean;
    forConfirmation!: DestinationDetail[] | undefined;
    cancelled!: DestinationDetail[] | undefined;
    routeTypes!: RouteType[] | undefined;
    routeTypeId!: number | undefined;
    routeType!: RouteType | undefined;
    driverStatusId!: number | undefined;
    driverStatus!: MobileClient | undefined;
    mileage!: number;
    lastDriverUpdate!: moment.Moment | undefined;
    isVisibleToDriver!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRoute) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.freeze = true;
            this.cutOffAddjustments = 0;
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.location = data["location"] ? Location.fromJS(data["location"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.vehicle = data["vehicle"] ? Vehicle.fromJS(data["vehicle"]) : <any>undefined;
            this.vehicleId = data["vehicleId"];
            this.routeTemplate = data["routeTemplate"] ? RouteTemplate.fromJS(data["routeTemplate"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.activeOrderId = data["activeOrderId"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.completion = data["completion"] ? moment(data["completion"].toString()) : <any>undefined;
            this.departure = data["departure"] ? moment(data["departure"].toString()) : <any>undefined;
            this.locked = data["locked"];
            if (Array.isArray(data["orders"])) {
                this.orders = [] as any;
                for (let item of data["orders"])
                    this.orders!.push(Order.fromJS(item));
            }
            this.closeTime = data["closeTime"] ? moment(data["closeTime"].toString()) : <any>undefined;
            this.estimated = data["estimated"] ? moment(data["estimated"].toString()) : <any>undefined;
            this.closedByUser = data["closedByUser"] ? User.fromJS(data["closedByUser"]) : <any>undefined;
            this.closedByUserId = data["closedByUserId"];
            this.freeze = data["freeze"] !== undefined ? data["freeze"] : true;
            this.unFreezeByUser = data["unFreezeByUser"] ? User.fromJS(data["unFreezeByUser"]) : <any>undefined;
            this.unFreezeByUserId = data["unFreezeByUserId"];
            this.unFreezeDate = data["unFreezeDate"] ? moment(data["unFreezeDate"].toString()) : <any>undefined;
            this.unFreezeReason = data["unFreezeReason"];
            this.editCountByUser = data["editCountByUser"] ? User.fromJS(data["editCountByUser"]) : <any>undefined;
            this.editCountByUserId = data["editCountByUserId"];
            this.editCountDate = data["editCountDate"] ? moment(data["editCountDate"].toString()) : <any>undefined;
            this.notes = data["notes"];
            this.isRunning = data["isRunning"];
            this.cutOffAddjustments = data["cutOffAddjustments"] !== undefined ? data["cutOffAddjustments"] : 0;
            this.markedDeliveredById = data["markedDeliveredById"];
            this.zone = data["zone"];
            this.estimatedStartTime = data["estimatedStartTime"] ? moment(data["estimatedStartTime"].toString()) : <any>undefined;
            this.deviceVersion = data["deviceVersion"];
            this.deviceType = data["deviceType"];
            this.routeId = data["routeId"];
            this.driverName = data["driverName"];
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["stops"])) {
                this.stops = [] as any;
                for (let item of data["stops"])
                    this.stops!.push(Order.fromJS(item));
            }
            if (Array.isArray(data["destinations"])) {
                this.destinations = [] as any;
                for (let item of data["destinations"])
                    this.destinations!.push(DestinationDetail.fromJS(item));
            }
            this.fullName = data["fullName"];
            this.name = data["name"];
            this.routeTemplateName = data["routeTemplateName"];
            this.userId = data["userId"];
            this.vehicleName = data["vehicleName"];
            this.totalTime = data["totalTime"];
            this.totalStops = data["totalStops"];
            this.miles = data["miles"];
            this.stopsPerHour = data["stopsPerHour"];
            this.milesPerHour = data["milesPerHour"];
            this.timeZone = data["timeZone"];
            this.mobileTimezone = data["mobileTimezone"];
            this.eta = data["eta"];
            this.totalOrders = data["totalOrders"];
            this.currentVersion = data["currentVersion"];
            this.blindCode = data["blindCode"];
            this.referenceNumber = data["referenceNumber"];
            if (Array.isArray(data["orderTypes"])) {
                this.orderTypes = [] as any;
                for (let item of data["orderTypes"])
                    this.orderTypes!.push(item);
            }
            this.selectedRoute = data["selectedRoute"];
            if (Array.isArray(data["forConfirmation"])) {
                this.forConfirmation = [] as any;
                for (let item of data["forConfirmation"])
                    this.forConfirmation!.push(DestinationDetail.fromJS(item));
            }
            if (Array.isArray(data["cancelled"])) {
                this.cancelled = [] as any;
                for (let item of data["cancelled"])
                    this.cancelled!.push(DestinationDetail.fromJS(item));
            }
            if (Array.isArray(data["routeTypes"])) {
                this.routeTypes = [] as any;
                for (let item of data["routeTypes"])
                    this.routeTypes!.push(RouteType.fromJS(item));
            }
            this.routeTypeId = data["routeTypeId"];
            this.routeType = data["routeType"] ? RouteType.fromJS(data["routeType"]) : <any>undefined;
            this.driverStatusId = data["driverStatusId"];
            this.driverStatus = data["driverStatus"] ? MobileClient.fromJS(data["driverStatus"]) : <any>undefined;
            this.mileage = data["mileage"];
            this.lastDriverUpdate = data["lastDriverUpdate"] ? moment(data["lastDriverUpdate"].toString()) : <any>undefined;
            this.isVisibleToDriver = data["isVisibleToDriver"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Route {
        data = typeof data === 'object' ? data : {};
        let result = new Route();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["activeOrderId"] = this.activeOrderId;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["completion"] = this.completion ? this.completion.toISOString() : <any>undefined;
        data["departure"] = this.departure ? this.departure.toISOString() : <any>undefined;
        data["locked"] = this.locked;
        if (Array.isArray(this.orders)) {
            data["orders"] = [];
            for (let item of this.orders)
                data["orders"].push(item.toJSON());
        }
        data["closeTime"] = this.closeTime ? this.closeTime.toISOString() : <any>undefined;
        data["estimated"] = this.estimated ? this.estimated.toISOString() : <any>undefined;
        data["closedByUser"] = this.closedByUser ? this.closedByUser.toJSON() : <any>undefined;
        data["closedByUserId"] = this.closedByUserId;
        data["freeze"] = this.freeze;
        data["unFreezeByUser"] = this.unFreezeByUser ? this.unFreezeByUser.toJSON() : <any>undefined;
        data["unFreezeByUserId"] = this.unFreezeByUserId;
        data["unFreezeDate"] = this.unFreezeDate ? this.unFreezeDate.toISOString() : <any>undefined;
        data["unFreezeReason"] = this.unFreezeReason;
        data["editCountByUser"] = this.editCountByUser ? this.editCountByUser.toJSON() : <any>undefined;
        data["editCountByUserId"] = this.editCountByUserId;
        data["editCountDate"] = this.editCountDate ? this.editCountDate.toISOString() : <any>undefined;
        data["notes"] = this.notes;
        data["isRunning"] = this.isRunning;
        data["cutOffAddjustments"] = this.cutOffAddjustments;
        data["markedDeliveredById"] = this.markedDeliveredById;
        data["zone"] = this.zone;
        data["estimatedStartTime"] = this.estimatedStartTime ? this.estimatedStartTime.toISOString() : <any>undefined;
        data["deviceVersion"] = this.deviceVersion;
        data["deviceType"] = this.deviceType;
        data["routeId"] = this.routeId;
        data["driverName"] = this.driverName;
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.stops)) {
            data["stops"] = [];
            for (let item of this.stops)
                data["stops"].push(item.toJSON());
        }
        if (Array.isArray(this.destinations)) {
            data["destinations"] = [];
            for (let item of this.destinations)
                data["destinations"].push(item.toJSON());
        }
        data["fullName"] = this.fullName;
        data["name"] = this.name;
        data["routeTemplateName"] = this.routeTemplateName;
        data["userId"] = this.userId;
        data["vehicleName"] = this.vehicleName;
        data["totalTime"] = this.totalTime;
        data["totalStops"] = this.totalStops;
        data["miles"] = this.miles;
        data["stopsPerHour"] = this.stopsPerHour;
        data["milesPerHour"] = this.milesPerHour;
        data["timeZone"] = this.timeZone;
        data["mobileTimezone"] = this.mobileTimezone;
        data["eta"] = this.eta;
        data["totalOrders"] = this.totalOrders;
        data["currentVersion"] = this.currentVersion;
        data["blindCode"] = this.blindCode;
        data["referenceNumber"] = this.referenceNumber;
        if (Array.isArray(this.orderTypes)) {
            data["orderTypes"] = [];
            for (let item of this.orderTypes)
                data["orderTypes"].push(item);
        }
        data["selectedRoute"] = this.selectedRoute;
        if (Array.isArray(this.forConfirmation)) {
            data["forConfirmation"] = [];
            for (let item of this.forConfirmation)
                data["forConfirmation"].push(item.toJSON());
        }
        if (Array.isArray(this.cancelled)) {
            data["cancelled"] = [];
            for (let item of this.cancelled)
                data["cancelled"].push(item.toJSON());
        }
        if (Array.isArray(this.routeTypes)) {
            data["routeTypes"] = [];
            for (let item of this.routeTypes)
                data["routeTypes"].push(item.toJSON());
        }
        data["routeTypeId"] = this.routeTypeId;
        data["routeType"] = this.routeType ? this.routeType.toJSON() : <any>undefined;
        data["driverStatusId"] = this.driverStatusId;
        data["driverStatus"] = this.driverStatus ? this.driverStatus.toJSON() : <any>undefined;
        data["mileage"] = this.mileage;
        data["lastDriverUpdate"] = this.lastDriverUpdate ? this.lastDriverUpdate.toISOString() : <any>undefined;
        data["isVisibleToDriver"] = this.isVisibleToDriver;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRoute {
    tenantId: number | undefined;
    location: Location | undefined;
    locationId: number;
    vehicle: Vehicle | undefined;
    vehicleId: number | undefined;
    routeTemplate: RouteTemplate | undefined;
    routeTemplateId: number;
    activeOrderId: number | undefined;
    loadDate: moment.Moment;
    completion: moment.Moment | undefined;
    departure: moment.Moment | undefined;
    locked: boolean;
    orders: Order[] | undefined;
    closeTime: moment.Moment | undefined;
    estimated: moment.Moment | undefined;
    closedByUser: User | undefined;
    closedByUserId: number | undefined;
    freeze: boolean;
    unFreezeByUser: User | undefined;
    unFreezeByUserId: number | undefined;
    unFreezeDate: moment.Moment | undefined;
    unFreezeReason: string | undefined;
    editCountByUser: User | undefined;
    editCountByUserId: number | undefined;
    editCountDate: moment.Moment | undefined;
    notes: string | undefined;
    isRunning: boolean;
    cutOffAddjustments: number | undefined;
    markedDeliveredById: number | undefined;
    zone: string | undefined;
    estimatedStartTime: moment.Moment | undefined;
    deviceVersion: string | undefined;
    deviceType: string | undefined;
    routeId: number | undefined;
    driverName: string | undefined;
    totalPackages: number;
    stops: Order[] | undefined;
    destinations: DestinationDetail[] | undefined;
    fullName: string | undefined;
    name: string | undefined;
    routeTemplateName: string | undefined;
    userId: number | undefined;
    vehicleName: string | undefined;
    totalTime: number;
    totalStops: number;
    miles: number;
    stopsPerHour: number;
    milesPerHour: number;
    timeZone: string | undefined;
    mobileTimezone: string | undefined;
    eta: string | undefined;
    totalOrders: number;
    currentVersion: string | undefined;
    blindCode: string | undefined;
    referenceNumber: string | undefined;
    orderTypes: string[] | undefined;
    selectedRoute: boolean;
    forConfirmation: DestinationDetail[] | undefined;
    cancelled: DestinationDetail[] | undefined;
    routeTypes: RouteType[] | undefined;
    routeTypeId: number | undefined;
    routeType: RouteType | undefined;
    driverStatusId: number | undefined;
    driverStatus: MobileClient | undefined;
    mileage: number;
    lastDriverUpdate: moment.Moment | undefined;
    isVisibleToDriver: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteDefinition implements IRouteDefinition {
    tenantId!: number | undefined;
    threshold!: number;
    routeTypeId!: number | undefined;
    routeTypeFk!: RouteType | undefined;
    routeTemplateId!: number | undefined;
    routeTemplateFk!: RouteTemplate | undefined;
    inactive!: boolean;
    manager!: User | undefined;
    managerId!: number | undefined;
    assignedBy!: User | undefined;
    assignedById!: number | undefined;
    assignedDate!: moment.Moment | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteDefinition) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.threshold = data["threshold"];
            this.routeTypeId = data["routeTypeId"];
            this.routeTypeFk = data["routeTypeFk"] ? RouteType.fromJS(data["routeTypeFk"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.routeTemplateFk = data["routeTemplateFk"] ? RouteTemplate.fromJS(data["routeTemplateFk"]) : <any>undefined;
            this.inactive = data["inactive"];
            this.manager = data["manager"] ? User.fromJS(data["manager"]) : <any>undefined;
            this.managerId = data["managerId"];
            this.assignedBy = data["assignedBy"] ? User.fromJS(data["assignedBy"]) : <any>undefined;
            this.assignedById = data["assignedById"];
            this.assignedDate = data["assignedDate"] ? moment(data["assignedDate"].toString()) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteDefinition {
        data = typeof data === 'object' ? data : {};
        let result = new RouteDefinition();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["threshold"] = this.threshold;
        data["routeTypeId"] = this.routeTypeId;
        data["routeTypeFk"] = this.routeTypeFk ? this.routeTypeFk.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeTemplateFk"] = this.routeTemplateFk ? this.routeTemplateFk.toJSON() : <any>undefined;
        data["inactive"] = this.inactive;
        data["manager"] = this.manager ? this.manager.toJSON() : <any>undefined;
        data["managerId"] = this.managerId;
        data["assignedBy"] = this.assignedBy ? this.assignedBy.toJSON() : <any>undefined;
        data["assignedById"] = this.assignedById;
        data["assignedDate"] = this.assignedDate ? this.assignedDate.toISOString() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteDefinition {
    tenantId: number | undefined;
    threshold: number;
    routeTypeId: number | undefined;
    routeTypeFk: RouteType | undefined;
    routeTemplateId: number | undefined;
    routeTemplateFk: RouteTemplate | undefined;
    inactive: boolean;
    manager: User | undefined;
    managerId: number | undefined;
    assignedBy: User | undefined;
    assignedById: number | undefined;
    assignedDate: moment.Moment | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteDefinitionRouteTypeLookupTableDto implements IRouteDefinitionRouteTypeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IRouteDefinitionRouteTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): RouteDefinitionRouteTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteDefinitionRouteTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IRouteDefinitionRouteTypeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto implements IPagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto {
    totalCount!: number;
    items!: RouteDefinitionRouteTypeLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteDefinitionRouteTypeLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRouteDefinitionRouteTypeLookupTableDto {
    totalCount: number;
    items: RouteDefinitionRouteTypeLookupTableDto[] | undefined;
}

export class RouteTypeTemp implements IRouteTypeTemp {
    id!: number;
    description!: string | undefined;

    constructor(data?: IRouteTypeTemp) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.description = data["description"];
        }
    }

    static fromJS(data: any): RouteTypeTemp {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTypeTemp();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["description"] = this.description;
        return data; 
    }
}

export interface IRouteTypeTemp {
    id: number;
    description: string | undefined;
}

export class RouteDefinitionRouteTemplateLookupTableDto implements IRouteDefinitionRouteTemplateLookupTableDto {
    id!: number;
    displayName!: string | undefined;
    locationId!: number;
    location!: string | undefined;

    constructor(data?: IRouteDefinitionRouteTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
            this.locationId = data["locationId"];
            this.location = data["location"];
        }
    }

    static fromJS(data: any): RouteDefinitionRouteTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteDefinitionRouteTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        data["locationId"] = this.locationId;
        data["location"] = this.location;
        return data; 
    }
}

export interface IRouteDefinitionRouteTemplateLookupTableDto {
    id: number;
    displayName: string | undefined;
    locationId: number;
    location: string | undefined;
}

export class PagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto implements IPagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto {
    totalCount!: number;
    items!: RouteDefinitionRouteTemplateLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteDefinitionRouteTemplateLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRouteDefinitionRouteTemplateLookupTableDto {
    totalCount: number;
    items: RouteDefinitionRouteTemplateLookupTableDto[] | undefined;
}

export class GetManagerListDto implements IGetManagerListDto {
    fullName!: string | undefined;
    userId!: number;

    constructor(data?: IGetManagerListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fullName = data["fullName"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): GetManagerListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetManagerListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fullName"] = this.fullName;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IGetManagerListDto {
    fullName: string | undefined;
    userId: number;
}

export class AssignRoutesToManagerInput implements IAssignRoutesToManagerInput {
    managerId!: number | undefined;
    routeDefinitionIds!: number[] | undefined;

    constructor(data?: IAssignRoutesToManagerInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.managerId = data["managerId"];
            if (Array.isArray(data["routeDefinitionIds"])) {
                this.routeDefinitionIds = [] as any;
                for (let item of data["routeDefinitionIds"])
                    this.routeDefinitionIds!.push(item);
            }
        }
    }

    static fromJS(data: any): AssignRoutesToManagerInput {
        data = typeof data === 'object' ? data : {};
        let result = new AssignRoutesToManagerInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["managerId"] = this.managerId;
        if (Array.isArray(this.routeDefinitionIds)) {
            data["routeDefinitionIds"] = [];
            for (let item of this.routeDefinitionIds)
                data["routeDefinitionIds"].push(item);
        }
        return data; 
    }
}

export interface IAssignRoutesToManagerInput {
    managerId: number | undefined;
    routeDefinitionIds: number[] | undefined;
}

export class AssignManagerByLocationInput implements IAssignManagerByLocationInput {
    locationId!: number;
    managerId!: number | undefined;

    constructor(data?: IAssignManagerByLocationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.managerId = data["managerId"];
        }
    }

    static fromJS(data: any): AssignManagerByLocationInput {
        data = typeof data === 'object' ? data : {};
        let result = new AssignManagerByLocationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["managerId"] = this.managerId;
        return data; 
    }
}

export interface IAssignManagerByLocationInput {
    locationId: number;
    managerId: number | undefined;
}

export class RouteGenerationSettingDto implements IRouteGenerationSettingDto {
    isFuture!: boolean;
    noOfDays!: number;
    id!: number;

    constructor(data?: IRouteGenerationSettingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isFuture = data["isFuture"];
            this.noOfDays = data["noOfDays"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteGenerationSettingDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteGenerationSettingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isFuture"] = this.isFuture;
        data["noOfDays"] = this.noOfDays;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteGenerationSettingDto {
    isFuture: boolean;
    noOfDays: number;
    id: number;
}

export class GetRouteGenerationSettingForViewDto implements IGetRouteGenerationSettingForViewDto {
    routeGenerationSetting!: RouteGenerationSettingDto | undefined;

    constructor(data?: IGetRouteGenerationSettingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeGenerationSetting = data["routeGenerationSetting"] ? RouteGenerationSettingDto.fromJS(data["routeGenerationSetting"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteGenerationSettingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteGenerationSettingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeGenerationSetting"] = this.routeGenerationSetting ? this.routeGenerationSetting.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteGenerationSettingForViewDto {
    routeGenerationSetting: RouteGenerationSettingDto | undefined;
}

export class PagedResultDtoOfGetRouteGenerationSettingForViewDto implements IPagedResultDtoOfGetRouteGenerationSettingForViewDto {
    totalCount!: number;
    items!: GetRouteGenerationSettingForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteGenerationSettingForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteGenerationSettingForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteGenerationSettingForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteGenerationSettingForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteGenerationSettingForViewDto {
    totalCount: number;
    items: GetRouteGenerationSettingForViewDto[] | undefined;
}

export class CreateOrEditRouteGenerationSettingDto implements ICreateOrEditRouteGenerationSettingDto {
    isFuture!: boolean;
    noOfDays!: number;
    routeGenNoOfDays!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteGenerationSettingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isFuture = data["isFuture"];
            this.noOfDays = data["noOfDays"];
            this.routeGenNoOfDays = data["routeGenNoOfDays"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteGenerationSettingDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteGenerationSettingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isFuture"] = this.isFuture;
        data["noOfDays"] = this.noOfDays;
        data["routeGenNoOfDays"] = this.routeGenNoOfDays;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteGenerationSettingDto {
    isFuture: boolean;
    noOfDays: number;
    routeGenNoOfDays: number | undefined;
    id: number | undefined;
}

export class GetRouteGenerationSettingForEditOutput implements IGetRouteGenerationSettingForEditOutput {
    routeGenerationSetting!: CreateOrEditRouteGenerationSettingDto | undefined;

    constructor(data?: IGetRouteGenerationSettingForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeGenerationSetting = data["routeGenerationSetting"] ? CreateOrEditRouteGenerationSettingDto.fromJS(data["routeGenerationSetting"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteGenerationSettingForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteGenerationSettingForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeGenerationSetting"] = this.routeGenerationSetting ? this.routeGenerationSetting.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteGenerationSettingForEditOutput {
    routeGenerationSetting: CreateOrEditRouteGenerationSettingDto | undefined;
}

export class DashboardDto implements IDashboardDto {
    timeZoneId!: number;
    timeZoneName!: string | undefined;
    executionTime!: string | undefined;
    lastExecutionTime!: string | undefined;
    orderCountLastWeek!: number;
    orderCountToday!: number;
    progress!: number;
    loadDate!: moment.Moment;

    constructor(data?: IDashboardDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.timeZoneId = data["timeZoneId"];
            this.timeZoneName = data["timeZoneName"];
            this.executionTime = data["executionTime"];
            this.lastExecutionTime = data["lastExecutionTime"];
            this.orderCountLastWeek = data["orderCountLastWeek"];
            this.orderCountToday = data["orderCountToday"];
            this.progress = data["progress"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): DashboardDto {
        data = typeof data === 'object' ? data : {};
        let result = new DashboardDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["timeZoneId"] = this.timeZoneId;
        data["timeZoneName"] = this.timeZoneName;
        data["executionTime"] = this.executionTime;
        data["lastExecutionTime"] = this.lastExecutionTime;
        data["orderCountLastWeek"] = this.orderCountLastWeek;
        data["orderCountToday"] = this.orderCountToday;
        data["progress"] = this.progress;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IDashboardDto {
    timeZoneId: number;
    timeZoneName: string | undefined;
    executionTime: string | undefined;
    lastExecutionTime: string | undefined;
    orderCountLastWeek: number;
    orderCountToday: number;
    progress: number;
    loadDate: moment.Moment;
}

export class HeaderRouteGenerationDashboardDto implements IHeaderRouteGenerationDashboardDto {
    orderToday!: number;
    orderLastWeek!: number;
    difference!: number;
    percent!: number;

    constructor(data?: IHeaderRouteGenerationDashboardDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderToday = data["orderToday"];
            this.orderLastWeek = data["orderLastWeek"];
            this.difference = data["difference"];
            this.percent = data["percent"];
        }
    }

    static fromJS(data: any): HeaderRouteGenerationDashboardDto {
        data = typeof data === 'object' ? data : {};
        let result = new HeaderRouteGenerationDashboardDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderToday"] = this.orderToday;
        data["orderLastWeek"] = this.orderLastWeek;
        data["difference"] = this.difference;
        data["percent"] = this.percent;
        return data; 
    }
}

export interface IHeaderRouteGenerationDashboardDto {
    orderToday: number;
    orderLastWeek: number;
    difference: number;
    percent: number;
}

export class GetDashboardViewDto implements IGetDashboardViewDto {
    recurring!: DashboardDto | undefined;

    constructor(data?: IGetDashboardViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.recurring = data["recurring"] ? DashboardDto.fromJS(data["recurring"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetDashboardViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetDashboardViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["recurring"] = this.recurring ? this.recurring.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetDashboardViewDto {
    recurring: DashboardDto | undefined;
}

export class PagedResultDtoOfGetDashboardViewDto implements IPagedResultDtoOfGetDashboardViewDto {
    totalCount!: number;
    items!: GetDashboardViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetDashboardViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetDashboardViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetDashboardViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetDashboardViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetDashboardViewDto {
    totalCount: number;
    items: GetDashboardViewDto[] | undefined;
}

export enum Status {
    SUCCEEDED = 0,
    FAILED = 1,
    PROCESSING = 2,
}

export class StatusDto implements IStatusDto {
    routesToDate!: number;
    routesWeekAgo!: number;
    regularToDate!: number;
    regularWeekAgo!: number;
    regularDifference!: number;
    regularPercentage!: number;

    constructor(data?: IStatusDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routesToDate = data["routesToDate"];
            this.routesWeekAgo = data["routesWeekAgo"];
            this.regularToDate = data["regularToDate"];
            this.regularWeekAgo = data["regularWeekAgo"];
            this.regularDifference = data["regularDifference"];
            this.regularPercentage = data["regularPercentage"];
        }
    }

    static fromJS(data: any): StatusDto {
        data = typeof data === 'object' ? data : {};
        let result = new StatusDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routesToDate"] = this.routesToDate;
        data["routesWeekAgo"] = this.routesWeekAgo;
        data["regularToDate"] = this.regularToDate;
        data["regularWeekAgo"] = this.regularWeekAgo;
        data["regularDifference"] = this.regularDifference;
        data["regularPercentage"] = this.regularPercentage;
        return data; 
    }
}

export interface IStatusDto {
    routesToDate: number;
    routesWeekAgo: number;
    regularToDate: number;
    regularWeekAgo: number;
    regularDifference: number;
    regularPercentage: number;
}

export class RouteGeneratorLogDto implements IRouteGeneratorLogDto {
    status!: Status;
    duration!: TimeSpan;
    result!: string | undefined;
    parameters!: string | undefined;
    loadDate!: moment.Moment;
    jobId!: string | undefined;
    dailyUpdate!: StatusDto | undefined;
    hangfireJobId!: string | undefined;
    id!: number;

    constructor(data?: IRouteGeneratorLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.status = data["status"];
            this.duration = data["duration"] ? TimeSpan.fromJS(data["duration"]) : <any>undefined;
            this.result = data["result"];
            this.parameters = data["parameters"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.jobId = data["jobId"];
            this.dailyUpdate = data["dailyUpdate"] ? StatusDto.fromJS(data["dailyUpdate"]) : <any>undefined;
            this.hangfireJobId = data["hangfireJobId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteGeneratorLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteGeneratorLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["status"] = this.status;
        data["duration"] = this.duration ? this.duration.toJSON() : <any>undefined;
        data["result"] = this.result;
        data["parameters"] = this.parameters;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["jobId"] = this.jobId;
        data["dailyUpdate"] = this.dailyUpdate ? this.dailyUpdate.toJSON() : <any>undefined;
        data["hangfireJobId"] = this.hangfireJobId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteGeneratorLogDto {
    status: Status;
    duration: TimeSpan;
    result: string | undefined;
    parameters: string | undefined;
    loadDate: moment.Moment;
    jobId: string | undefined;
    dailyUpdate: StatusDto | undefined;
    hangfireJobId: string | undefined;
    id: number;
}

export class GetRouteGeneratorLogForViewDto implements IGetRouteGeneratorLogForViewDto {
    routeGeneratorLog!: RouteGeneratorLogDto | undefined;

    constructor(data?: IGetRouteGeneratorLogForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeGeneratorLog = data["routeGeneratorLog"] ? RouteGeneratorLogDto.fromJS(data["routeGeneratorLog"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteGeneratorLogForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteGeneratorLogForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeGeneratorLog"] = this.routeGeneratorLog ? this.routeGeneratorLog.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteGeneratorLogForViewDto {
    routeGeneratorLog: RouteGeneratorLogDto | undefined;
}

export class PagedResultDtoOfGetRouteGeneratorLogForViewDto implements IPagedResultDtoOfGetRouteGeneratorLogForViewDto {
    totalCount!: number;
    items!: GetRouteGeneratorLogForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteGeneratorLogForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteGeneratorLogForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteGeneratorLogForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteGeneratorLogForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteGeneratorLogForViewDto {
    totalCount: number;
    items: GetRouteGeneratorLogForViewDto[] | undefined;
}

export class RouteGeneratorLog implements IRouteGeneratorLog {
    tenantId!: number | undefined;
    parameters!: string;
    status!: Status;
    result!: string | undefined;
    loadDate!: moment.Moment;
    jobId!: string;
    hangfireJobId!: string | undefined;
    duration!: TimeSpan;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteGeneratorLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.parameters = data["parameters"];
            this.status = data["status"];
            this.result = data["result"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.jobId = data["jobId"];
            this.hangfireJobId = data["hangfireJobId"];
            this.duration = data["duration"] ? TimeSpan.fromJS(data["duration"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteGeneratorLog {
        data = typeof data === 'object' ? data : {};
        let result = new RouteGeneratorLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["parameters"] = this.parameters;
        data["status"] = this.status;
        data["result"] = this.result;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["jobId"] = this.jobId;
        data["hangfireJobId"] = this.hangfireJobId;
        data["duration"] = this.duration ? this.duration.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteGeneratorLog {
    tenantId: number | undefined;
    parameters: string;
    status: Status;
    result: string | undefined;
    loadDate: moment.Moment;
    jobId: string;
    hangfireJobId: string | undefined;
    duration: TimeSpan;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class CreateOrEditRouteGeneratorLogDto implements ICreateOrEditRouteGeneratorLogDto {
    parameters!: string;
    status!: Status;
    attempts!: number;
    result!: string;
    emailSent!: boolean;
    loadDate!: moment.Moment;
    jobId!: string | undefined;
    tenantId!: number;
    hangfireJobId!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteGeneratorLogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parameters = data["parameters"];
            this.status = data["status"];
            this.attempts = data["attempts"];
            this.result = data["result"];
            this.emailSent = data["emailSent"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.jobId = data["jobId"];
            this.tenantId = data["tenantId"];
            this.hangfireJobId = data["hangfireJobId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteGeneratorLogDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteGeneratorLogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parameters"] = this.parameters;
        data["status"] = this.status;
        data["attempts"] = this.attempts;
        data["result"] = this.result;
        data["emailSent"] = this.emailSent;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["jobId"] = this.jobId;
        data["tenantId"] = this.tenantId;
        data["hangfireJobId"] = this.hangfireJobId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteGeneratorLogDto {
    parameters: string;
    status: Status;
    attempts: number;
    result: string;
    emailSent: boolean;
    loadDate: moment.Moment;
    jobId: string | undefined;
    tenantId: number;
    hangfireJobId: string | undefined;
    id: number | undefined;
}

export class SendEmailDto implements ISendEmailDto {
    tenantId!: number;
    routeGeneratorLog!: RouteGeneratorLogDto | undefined;

    constructor(data?: ISendEmailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeGeneratorLog = data["routeGeneratorLog"] ? RouteGeneratorLogDto.fromJS(data["routeGeneratorLog"]) : <any>undefined;
        }
    }

    static fromJS(data: any): SendEmailDto {
        data = typeof data === 'object' ? data : {};
        let result = new SendEmailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeGeneratorLog"] = this.routeGeneratorLog ? this.routeGeneratorLog.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ISendEmailDto {
    tenantId: number;
    routeGeneratorLog: RouteGeneratorLogDto | undefined;
}

export class RouteHandOffDefinitionDto implements IRouteHandOffDefinitionDto {
    threshold!: number;
    inactive!: boolean;
    routeTemplateId!: number | undefined;
    routeTypeId!: number | undefined;
    createdBy!: string | undefined;
    updatedBy!: string | undefined;
    createdTime!: moment.Moment | undefined;
    updatedTime!: moment.Moment | undefined;
    id!: number;

    constructor(data?: IRouteHandOffDefinitionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.threshold = data["threshold"];
            this.inactive = data["inactive"];
            this.routeTemplateId = data["routeTemplateId"];
            this.routeTypeId = data["routeTypeId"];
            this.createdBy = data["createdBy"];
            this.updatedBy = data["updatedBy"];
            this.createdTime = data["createdTime"] ? moment(data["createdTime"].toString()) : <any>undefined;
            this.updatedTime = data["updatedTime"] ? moment(data["updatedTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteHandOffDefinitionDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffDefinitionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["threshold"] = this.threshold;
        data["inactive"] = this.inactive;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeTypeId"] = this.routeTypeId;
        data["createdBy"] = this.createdBy;
        data["updatedBy"] = this.updatedBy;
        data["createdTime"] = this.createdTime ? this.createdTime.toISOString() : <any>undefined;
        data["updatedTime"] = this.updatedTime ? this.updatedTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteHandOffDefinitionDto {
    threshold: number;
    inactive: boolean;
    routeTemplateId: number | undefined;
    routeTypeId: number | undefined;
    createdBy: string | undefined;
    updatedBy: string | undefined;
    createdTime: moment.Moment | undefined;
    updatedTime: moment.Moment | undefined;
    id: number;
}

export class GetRouteHandOffDefinitionForViewDto implements IGetRouteHandOffDefinitionForViewDto {
    routeHandOffDefinition!: RouteHandOffDefinitionDto | undefined;
    routeTypeRouteTypeCode!: string | undefined;
    routeTemplateName!: string | undefined;
    driver!: string | undefined;
    location!: string | undefined;
    routeStop!: string | undefined;
    routeStart!: string | undefined;
    routeStartAddress!: string | undefined;
    address!: string | undefined;
    manager!: string | undefined;
    assignedBy!: string | undefined;
    assignedDate!: moment.Moment | undefined;
    selectedRouteDefinition!: boolean;
    routeTemplateId!: number | undefined;
    routeStartInactive!: boolean;

    constructor(data?: IGetRouteHandOffDefinitionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeHandOffDefinition = data["routeHandOffDefinition"] ? RouteHandOffDefinitionDto.fromJS(data["routeHandOffDefinition"]) : <any>undefined;
            this.routeTypeRouteTypeCode = data["routeTypeRouteTypeCode"];
            this.routeTemplateName = data["routeTemplateName"];
            this.driver = data["driver"];
            this.location = data["location"];
            this.routeStop = data["routeStop"];
            this.routeStart = data["routeStart"];
            this.routeStartAddress = data["routeStartAddress"];
            this.address = data["address"];
            this.manager = data["manager"];
            this.assignedBy = data["assignedBy"];
            this.assignedDate = data["assignedDate"] ? moment(data["assignedDate"].toString()) : <any>undefined;
            this.selectedRouteDefinition = data["selectedRouteDefinition"];
            this.routeTemplateId = data["routeTemplateId"];
            this.routeStartInactive = data["routeStartInactive"];
        }
    }

    static fromJS(data: any): GetRouteHandOffDefinitionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteHandOffDefinitionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeHandOffDefinition"] = this.routeHandOffDefinition ? this.routeHandOffDefinition.toJSON() : <any>undefined;
        data["routeTypeRouteTypeCode"] = this.routeTypeRouteTypeCode;
        data["routeTemplateName"] = this.routeTemplateName;
        data["driver"] = this.driver;
        data["location"] = this.location;
        data["routeStop"] = this.routeStop;
        data["routeStart"] = this.routeStart;
        data["routeStartAddress"] = this.routeStartAddress;
        data["address"] = this.address;
        data["manager"] = this.manager;
        data["assignedBy"] = this.assignedBy;
        data["assignedDate"] = this.assignedDate ? this.assignedDate.toISOString() : <any>undefined;
        data["selectedRouteDefinition"] = this.selectedRouteDefinition;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeStartInactive"] = this.routeStartInactive;
        return data; 
    }
}

export interface IGetRouteHandOffDefinitionForViewDto {
    routeHandOffDefinition: RouteHandOffDefinitionDto | undefined;
    routeTypeRouteTypeCode: string | undefined;
    routeTemplateName: string | undefined;
    driver: string | undefined;
    location: string | undefined;
    routeStop: string | undefined;
    routeStart: string | undefined;
    routeStartAddress: string | undefined;
    address: string | undefined;
    manager: string | undefined;
    assignedBy: string | undefined;
    assignedDate: moment.Moment | undefined;
    selectedRouteDefinition: boolean;
    routeTemplateId: number | undefined;
    routeStartInactive: boolean;
}

export class PagedResultDtoOfGetRouteHandOffDefinitionForViewDto implements IPagedResultDtoOfGetRouteHandOffDefinitionForViewDto {
    totalCount!: number;
    items!: GetRouteHandOffDefinitionForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteHandOffDefinitionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteHandOffDefinitionForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteHandOffDefinitionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteHandOffDefinitionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteHandOffDefinitionForViewDto {
    totalCount: number;
    items: GetRouteHandOffDefinitionForViewDto[] | undefined;
}

export class CreateOrEditRouteHandOffDefinitionDto implements ICreateOrEditRouteHandOffDefinitionDto {
    threshold!: number;
    inactive!: boolean;
    isOnDemand!: boolean;
    managerId!: number | undefined;
    assignedById!: number | undefined;
    assignedDate!: moment.Moment | undefined;
    routeTemplateId!: number | undefined;
    routeTypeId!: number | undefined;
    locationId!: number | undefined;
    defaultUserId!: number | undefined;
    mondayDriverId!: number | undefined;
    tuesdayDriverId!: number | undefined;
    wednesdayDriverId!: number | undefined;
    thursdayDriverId!: number | undefined;
    fridayDriverId!: number | undefined;
    saturdayDriverId!: number | undefined;
    sundayDriverId!: number | undefined;
    defaultContactId!: number | undefined;
    routeStartContactId!: number | undefined;
    routeCode!: string | undefined;
    routeTemplateTypeId!: number | undefined;
    eta!: moment.Moment;
    cutOff!: moment.Moment;
    mondayManagerId!: number | undefined;
    tuesdayManagerId!: number | undefined;
    wednesdayManagerId!: number | undefined;
    thursdayManagerId!: number | undefined;
    fridayManagerId!: number | undefined;
    saturdayManagerId!: number | undefined;
    sundayManagerId!: number | undefined;
    routeStartInactive!: boolean;
    startTime!: string | undefined;
    endTime!: string | undefined;
    startTimeType!: number;
    startTimeMins!: number | undefined;
    endTimeType!: number;
    endTimeMins!: number | undefined;
    mondaySupervisorId!: number | undefined;
    tuesdaySupervisorId!: number | undefined;
    wednesdaySupervisorId!: number | undefined;
    thursdaySupervisorId!: number | undefined;
    fridaySupervisorId!: number | undefined;
    saturdaySupervisorId!: number | undefined;
    sundaySupervisorId!: number | undefined;
    routeNotificationRecipients!: RouteNotificationRecipientDto[] | undefined;
    routeStopId!: number | undefined;
    routeStartId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteHandOffDefinitionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.threshold = data["threshold"];
            this.inactive = data["inactive"];
            this.isOnDemand = data["isOnDemand"];
            this.managerId = data["managerId"];
            this.assignedById = data["assignedById"];
            this.assignedDate = data["assignedDate"] ? moment(data["assignedDate"].toString()) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.routeTypeId = data["routeTypeId"];
            this.locationId = data["locationId"];
            this.defaultUserId = data["defaultUserId"];
            this.mondayDriverId = data["mondayDriverId"];
            this.tuesdayDriverId = data["tuesdayDriverId"];
            this.wednesdayDriverId = data["wednesdayDriverId"];
            this.thursdayDriverId = data["thursdayDriverId"];
            this.fridayDriverId = data["fridayDriverId"];
            this.saturdayDriverId = data["saturdayDriverId"];
            this.sundayDriverId = data["sundayDriverId"];
            this.defaultContactId = data["defaultContactId"];
            this.routeStartContactId = data["routeStartContactId"];
            this.routeCode = data["routeCode"];
            this.routeTemplateTypeId = data["routeTemplateTypeId"];
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
            this.cutOff = data["cutOff"] ? moment(data["cutOff"].toString()) : <any>undefined;
            this.mondayManagerId = data["mondayManagerId"];
            this.tuesdayManagerId = data["tuesdayManagerId"];
            this.wednesdayManagerId = data["wednesdayManagerId"];
            this.thursdayManagerId = data["thursdayManagerId"];
            this.fridayManagerId = data["fridayManagerId"];
            this.saturdayManagerId = data["saturdayManagerId"];
            this.sundayManagerId = data["sundayManagerId"];
            this.routeStartInactive = data["routeStartInactive"];
            this.startTime = data["startTime"];
            this.endTime = data["endTime"];
            this.startTimeType = data["startTimeType"];
            this.startTimeMins = data["startTimeMins"];
            this.endTimeType = data["endTimeType"];
            this.endTimeMins = data["endTimeMins"];
            this.mondaySupervisorId = data["mondaySupervisorId"];
            this.tuesdaySupervisorId = data["tuesdaySupervisorId"];
            this.wednesdaySupervisorId = data["wednesdaySupervisorId"];
            this.thursdaySupervisorId = data["thursdaySupervisorId"];
            this.fridaySupervisorId = data["fridaySupervisorId"];
            this.saturdaySupervisorId = data["saturdaySupervisorId"];
            this.sundaySupervisorId = data["sundaySupervisorId"];
            if (Array.isArray(data["routeNotificationRecipients"])) {
                this.routeNotificationRecipients = [] as any;
                for (let item of data["routeNotificationRecipients"])
                    this.routeNotificationRecipients!.push(RouteNotificationRecipientDto.fromJS(item));
            }
            this.routeStopId = data["routeStopId"];
            this.routeStartId = data["routeStartId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteHandOffDefinitionDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteHandOffDefinitionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["threshold"] = this.threshold;
        data["inactive"] = this.inactive;
        data["isOnDemand"] = this.isOnDemand;
        data["managerId"] = this.managerId;
        data["assignedById"] = this.assignedById;
        data["assignedDate"] = this.assignedDate ? this.assignedDate.toISOString() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeTypeId"] = this.routeTypeId;
        data["locationId"] = this.locationId;
        data["defaultUserId"] = this.defaultUserId;
        data["mondayDriverId"] = this.mondayDriverId;
        data["tuesdayDriverId"] = this.tuesdayDriverId;
        data["wednesdayDriverId"] = this.wednesdayDriverId;
        data["thursdayDriverId"] = this.thursdayDriverId;
        data["fridayDriverId"] = this.fridayDriverId;
        data["saturdayDriverId"] = this.saturdayDriverId;
        data["sundayDriverId"] = this.sundayDriverId;
        data["defaultContactId"] = this.defaultContactId;
        data["routeStartContactId"] = this.routeStartContactId;
        data["routeCode"] = this.routeCode;
        data["routeTemplateTypeId"] = this.routeTemplateTypeId;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        data["cutOff"] = this.cutOff ? this.cutOff.toISOString() : <any>undefined;
        data["mondayManagerId"] = this.mondayManagerId;
        data["tuesdayManagerId"] = this.tuesdayManagerId;
        data["wednesdayManagerId"] = this.wednesdayManagerId;
        data["thursdayManagerId"] = this.thursdayManagerId;
        data["fridayManagerId"] = this.fridayManagerId;
        data["saturdayManagerId"] = this.saturdayManagerId;
        data["sundayManagerId"] = this.sundayManagerId;
        data["routeStartInactive"] = this.routeStartInactive;
        data["startTime"] = this.startTime;
        data["endTime"] = this.endTime;
        data["startTimeType"] = this.startTimeType;
        data["startTimeMins"] = this.startTimeMins;
        data["endTimeType"] = this.endTimeType;
        data["endTimeMins"] = this.endTimeMins;
        data["mondaySupervisorId"] = this.mondaySupervisorId;
        data["tuesdaySupervisorId"] = this.tuesdaySupervisorId;
        data["wednesdaySupervisorId"] = this.wednesdaySupervisorId;
        data["thursdaySupervisorId"] = this.thursdaySupervisorId;
        data["fridaySupervisorId"] = this.fridaySupervisorId;
        data["saturdaySupervisorId"] = this.saturdaySupervisorId;
        data["sundaySupervisorId"] = this.sundaySupervisorId;
        if (Array.isArray(this.routeNotificationRecipients)) {
            data["routeNotificationRecipients"] = [];
            for (let item of this.routeNotificationRecipients)
                data["routeNotificationRecipients"].push(item.toJSON());
        }
        data["routeStopId"] = this.routeStopId;
        data["routeStartId"] = this.routeStartId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteHandOffDefinitionDto {
    threshold: number;
    inactive: boolean;
    isOnDemand: boolean;
    managerId: number | undefined;
    assignedById: number | undefined;
    assignedDate: moment.Moment | undefined;
    routeTemplateId: number | undefined;
    routeTypeId: number | undefined;
    locationId: number | undefined;
    defaultUserId: number | undefined;
    mondayDriverId: number | undefined;
    tuesdayDriverId: number | undefined;
    wednesdayDriverId: number | undefined;
    thursdayDriverId: number | undefined;
    fridayDriverId: number | undefined;
    saturdayDriverId: number | undefined;
    sundayDriverId: number | undefined;
    defaultContactId: number | undefined;
    routeStartContactId: number | undefined;
    routeCode: string | undefined;
    routeTemplateTypeId: number | undefined;
    eta: moment.Moment;
    cutOff: moment.Moment;
    mondayManagerId: number | undefined;
    tuesdayManagerId: number | undefined;
    wednesdayManagerId: number | undefined;
    thursdayManagerId: number | undefined;
    fridayManagerId: number | undefined;
    saturdayManagerId: number | undefined;
    sundayManagerId: number | undefined;
    routeStartInactive: boolean;
    startTime: string | undefined;
    endTime: string | undefined;
    startTimeType: number;
    startTimeMins: number | undefined;
    endTimeType: number;
    endTimeMins: number | undefined;
    mondaySupervisorId: number | undefined;
    tuesdaySupervisorId: number | undefined;
    wednesdaySupervisorId: number | undefined;
    thursdaySupervisorId: number | undefined;
    fridaySupervisorId: number | undefined;
    saturdaySupervisorId: number | undefined;
    sundaySupervisorId: number | undefined;
    routeNotificationRecipients: RouteNotificationRecipientDto[] | undefined;
    routeStopId: number | undefined;
    routeStartId: number | undefined;
    id: number | undefined;
}

export class GetRouteHandOffDefinitionForEditOutput implements IGetRouteHandOffDefinitionForEditOutput {
    routeHandOffDefinition!: CreateOrEditRouteHandOffDefinitionDto | undefined;
    routeTemplateName!: string | undefined;
    routeTypeRouteTypeCode!: string | undefined;

    constructor(data?: IGetRouteHandOffDefinitionForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeHandOffDefinition = data["routeHandOffDefinition"] ? CreateOrEditRouteHandOffDefinitionDto.fromJS(data["routeHandOffDefinition"]) : <any>undefined;
            this.routeTemplateName = data["routeTemplateName"];
            this.routeTypeRouteTypeCode = data["routeTypeRouteTypeCode"];
        }
    }

    static fromJS(data: any): GetRouteHandOffDefinitionForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteHandOffDefinitionForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeHandOffDefinition"] = this.routeHandOffDefinition ? this.routeHandOffDefinition.toJSON() : <any>undefined;
        data["routeTemplateName"] = this.routeTemplateName;
        data["routeTypeRouteTypeCode"] = this.routeTypeRouteTypeCode;
        return data; 
    }
}

export interface IGetRouteHandOffDefinitionForEditOutput {
    routeHandOffDefinition: CreateOrEditRouteHandOffDefinitionDto | undefined;
    routeTemplateName: string | undefined;
    routeTypeRouteTypeCode: string | undefined;
}

export class RouteHandOffDefinitionRouteTemplateLookupTableDto implements IRouteHandOffDefinitionRouteTemplateLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IRouteHandOffDefinitionRouteTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): RouteHandOffDefinitionRouteTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffDefinitionRouteTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IRouteHandOffDefinitionRouteTemplateLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto implements IPagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto {
    totalCount!: number;
    items!: RouteHandOffDefinitionRouteTemplateLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteHandOffDefinitionRouteTemplateLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRouteHandOffDefinitionRouteTemplateLookupTableDto {
    totalCount: number;
    items: RouteHandOffDefinitionRouteTemplateLookupTableDto[] | undefined;
}

export class RouteHandOffDefinitionRouteTypeLookupTableDto implements IRouteHandOffDefinitionRouteTypeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IRouteHandOffDefinitionRouteTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): RouteHandOffDefinitionRouteTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffDefinitionRouteTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IRouteHandOffDefinitionRouteTypeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto implements IPagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto {
    totalCount!: number;
    items!: RouteHandOffDefinitionRouteTypeLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteHandOffDefinitionRouteTypeLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRouteHandOffDefinitionRouteTypeLookupTableDto {
    totalCount: number;
    items: RouteHandOffDefinitionRouteTypeLookupTableDto[] | undefined;
}

export class RouteHandOffScheduleDetailDto implements IRouteHandOffScheduleDetailDto {
    routeCode!: string | undefined;
    estimatedTimeOfArrival!: moment.Moment;
    cutOff!: moment.Moment;
    automatic!: boolean;
    willCall!: boolean;
    isActive!: boolean;
    oorRate!: number | undefined;
    effectivityDate!: moment.Moment | undefined;
    routeScheduleId!: number;
    routeTemplateTypeId!: any | undefined;
    routeTypeId!: number;
    routeHandOffDefinitionId!: number;
    contactId!: number;
    id!: number;

    constructor(data?: IRouteHandOffScheduleDetailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeCode = data["routeCode"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"] ? moment(data["estimatedTimeOfArrival"].toString()) : <any>undefined;
            this.cutOff = data["cutOff"] ? moment(data["cutOff"].toString()) : <any>undefined;
            this.automatic = data["automatic"];
            this.willCall = data["willCall"];
            this.isActive = data["isActive"];
            this.oorRate = data["oorRate"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.routeScheduleId = data["routeScheduleId"];
            this.routeTemplateTypeId = data["routeTemplateTypeId"];
            this.routeTypeId = data["routeTypeId"];
            this.routeHandOffDefinitionId = data["routeHandOffDefinitionId"];
            this.contactId = data["contactId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteHandOffScheduleDetailDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffScheduleDetailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeCode"] = this.routeCode;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival ? this.estimatedTimeOfArrival.toISOString() : <any>undefined;
        data["cutOff"] = this.cutOff ? this.cutOff.toISOString() : <any>undefined;
        data["automatic"] = this.automatic;
        data["willCall"] = this.willCall;
        data["isActive"] = this.isActive;
        data["oorRate"] = this.oorRate;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["routeScheduleId"] = this.routeScheduleId;
        data["routeTemplateTypeId"] = this.routeTemplateTypeId;
        data["routeTypeId"] = this.routeTypeId;
        data["routeHandOffDefinitionId"] = this.routeHandOffDefinitionId;
        data["contactId"] = this.contactId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteHandOffScheduleDetailDto {
    routeCode: string | undefined;
    estimatedTimeOfArrival: moment.Moment;
    cutOff: moment.Moment;
    automatic: boolean;
    willCall: boolean;
    isActive: boolean;
    oorRate: number | undefined;
    effectivityDate: moment.Moment | undefined;
    routeScheduleId: number;
    routeTemplateTypeId: any | undefined;
    routeTypeId: number;
    routeHandOffDefinitionId: number;
    contactId: number;
    id: number;
}

export class GetRouteHandOffScheduleDetailForViewDto implements IGetRouteHandOffScheduleDetailForViewDto {
    routeHandOffScheduleDetail!: RouteHandOffScheduleDetailDto | undefined;
    routeTemplateName!: string | undefined;
    routeTypeRouteTypeCode!: string | undefined;

    constructor(data?: IGetRouteHandOffScheduleDetailForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeHandOffScheduleDetail = data["routeHandOffScheduleDetail"] ? RouteHandOffScheduleDetailDto.fromJS(data["routeHandOffScheduleDetail"]) : <any>undefined;
            this.routeTemplateName = data["routeTemplateName"];
            this.routeTypeRouteTypeCode = data["routeTypeRouteTypeCode"];
        }
    }

    static fromJS(data: any): GetRouteHandOffScheduleDetailForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteHandOffScheduleDetailForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeHandOffScheduleDetail"] = this.routeHandOffScheduleDetail ? this.routeHandOffScheduleDetail.toJSON() : <any>undefined;
        data["routeTemplateName"] = this.routeTemplateName;
        data["routeTypeRouteTypeCode"] = this.routeTypeRouteTypeCode;
        return data; 
    }
}

export interface IGetRouteHandOffScheduleDetailForViewDto {
    routeHandOffScheduleDetail: RouteHandOffScheduleDetailDto | undefined;
    routeTemplateName: string | undefined;
    routeTypeRouteTypeCode: string | undefined;
}

export class PagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto implements IPagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto {
    totalCount!: number;
    items!: GetRouteHandOffScheduleDetailForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteHandOffScheduleDetailForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteHandOffScheduleDetailForViewDto {
    totalCount: number;
    items: GetRouteHandOffScheduleDetailForViewDto[] | undefined;
}

export class CreateOrEditRouteHandOffScheduleDetailDto implements ICreateOrEditRouteHandOffScheduleDetailDto {
    routeCode!: string | undefined;
    estimatedTimeOfArrival!: moment.Moment;
    oorRate!: number | undefined;
    rate!: number | undefined;
    effectivityDate!: moment.Moment;
    isActive!: boolean;
    oneTime!: boolean;
    etaTime!: string | undefined;
    serviceTime!: number;
    timeWindowStart!: number;
    timeWindowEnd!: number | undefined;
    sortOrder!: number | undefined;
    dateEtaLocked!: moment.Moment | undefined;
    etaLocked!: boolean;
    etaLockedByUserId!: number | undefined;
    mondayETATime!: string | undefined;
    tuesdayETATime!: string | undefined;
    wednesdayETATime!: string | undefined;
    thursdayETATime!: string | undefined;
    fridayETATime!: string | undefined;
    saturdayETATime!: string | undefined;
    sundayETATime!: string | undefined;
    routeHandOffDefinitionId!: number;
    routeTemplateId!: number;
    routeTypeId!: number;
    contactId!: number;
    latitude!: number;
    longitude!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteHandOffScheduleDetailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeCode = data["routeCode"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"] ? moment(data["estimatedTimeOfArrival"].toString()) : <any>undefined;
            this.oorRate = data["oorRate"];
            this.rate = data["rate"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.isActive = data["isActive"];
            this.oneTime = data["oneTime"];
            this.etaTime = data["etaTime"];
            this.serviceTime = data["serviceTime"];
            this.timeWindowStart = data["timeWindowStart"];
            this.timeWindowEnd = data["timeWindowEnd"];
            this.sortOrder = data["sortOrder"];
            this.dateEtaLocked = data["dateEtaLocked"] ? moment(data["dateEtaLocked"].toString()) : <any>undefined;
            this.etaLocked = data["etaLocked"];
            this.etaLockedByUserId = data["etaLockedByUserId"];
            this.mondayETATime = data["mondayETATime"];
            this.tuesdayETATime = data["tuesdayETATime"];
            this.wednesdayETATime = data["wednesdayETATime"];
            this.thursdayETATime = data["thursdayETATime"];
            this.fridayETATime = data["fridayETATime"];
            this.saturdayETATime = data["saturdayETATime"];
            this.sundayETATime = data["sundayETATime"];
            this.routeHandOffDefinitionId = data["routeHandOffDefinitionId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.routeTypeId = data["routeTypeId"];
            this.contactId = data["contactId"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteHandOffScheduleDetailDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteHandOffScheduleDetailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeCode"] = this.routeCode;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival ? this.estimatedTimeOfArrival.toISOString() : <any>undefined;
        data["oorRate"] = this.oorRate;
        data["rate"] = this.rate;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["isActive"] = this.isActive;
        data["oneTime"] = this.oneTime;
        data["etaTime"] = this.etaTime;
        data["serviceTime"] = this.serviceTime;
        data["timeWindowStart"] = this.timeWindowStart;
        data["timeWindowEnd"] = this.timeWindowEnd;
        data["sortOrder"] = this.sortOrder;
        data["dateEtaLocked"] = this.dateEtaLocked ? this.dateEtaLocked.toISOString() : <any>undefined;
        data["etaLocked"] = this.etaLocked;
        data["etaLockedByUserId"] = this.etaLockedByUserId;
        data["mondayETATime"] = this.mondayETATime;
        data["tuesdayETATime"] = this.tuesdayETATime;
        data["wednesdayETATime"] = this.wednesdayETATime;
        data["thursdayETATime"] = this.thursdayETATime;
        data["fridayETATime"] = this.fridayETATime;
        data["saturdayETATime"] = this.saturdayETATime;
        data["sundayETATime"] = this.sundayETATime;
        data["routeHandOffDefinitionId"] = this.routeHandOffDefinitionId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeTypeId"] = this.routeTypeId;
        data["contactId"] = this.contactId;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteHandOffScheduleDetailDto {
    routeCode: string | undefined;
    estimatedTimeOfArrival: moment.Moment;
    oorRate: number | undefined;
    rate: number | undefined;
    effectivityDate: moment.Moment;
    isActive: boolean;
    oneTime: boolean;
    etaTime: string | undefined;
    serviceTime: number;
    timeWindowStart: number;
    timeWindowEnd: number | undefined;
    sortOrder: number | undefined;
    dateEtaLocked: moment.Moment | undefined;
    etaLocked: boolean;
    etaLockedByUserId: number | undefined;
    mondayETATime: string | undefined;
    tuesdayETATime: string | undefined;
    wednesdayETATime: string | undefined;
    thursdayETATime: string | undefined;
    fridayETATime: string | undefined;
    saturdayETATime: string | undefined;
    sundayETATime: string | undefined;
    routeHandOffDefinitionId: number;
    routeTemplateId: number;
    routeTypeId: number;
    contactId: number;
    latitude: number;
    longitude: number;
    id: number | undefined;
}

export class GetRouteHandOffScheduleDetailForEditOutput implements IGetRouteHandOffScheduleDetailForEditOutput {
    routeHandOffScheduleDetail!: CreateOrEditRouteHandOffScheduleDetailDto | undefined;

    constructor(data?: IGetRouteHandOffScheduleDetailForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeHandOffScheduleDetail = data["routeHandOffScheduleDetail"] ? CreateOrEditRouteHandOffScheduleDetailDto.fromJS(data["routeHandOffScheduleDetail"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteHandOffScheduleDetailForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteHandOffScheduleDetailForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeHandOffScheduleDetail"] = this.routeHandOffScheduleDetail ? this.routeHandOffScheduleDetail.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteHandOffScheduleDetailForEditOutput {
    routeHandOffScheduleDetail: CreateOrEditRouteHandOffScheduleDetailDto | undefined;
}

export class RouteHandOffScheduleDetailRouteTemplateLookupTableDto implements IRouteHandOffScheduleDetailRouteTemplateLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IRouteHandOffScheduleDetailRouteTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): RouteHandOffScheduleDetailRouteTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffScheduleDetailRouteTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IRouteHandOffScheduleDetailRouteTemplateLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto implements IPagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto {
    totalCount!: number;
    items!: RouteHandOffScheduleDetailRouteTemplateLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteHandOffScheduleDetailRouteTemplateLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRouteHandOffScheduleDetailRouteTemplateLookupTableDto {
    totalCount: number;
    items: RouteHandOffScheduleDetailRouteTemplateLookupTableDto[] | undefined;
}

export class GetLineHaulRouteScheduleDto implements IGetLineHaulRouteScheduleDto {
    id!: number;
    routeCode!: string | undefined;
    estimatedTimeOfArrival!: string | undefined;
    mondayETATime!: string | undefined;
    tuesdayETATime!: string | undefined;
    wednesdayETATime!: string | undefined;
    thursdayETATime!: string | undefined;
    fridayETATime!: string | undefined;
    saturdayETATime!: string | undefined;
    sundayETATime!: string | undefined;
    etaTime!: string | undefined;
    today!: moment.Moment;
    displayEta!: moment.Moment;
    serviceTime!: number;
    timeWindowEnd!: number | undefined;
    timeWindowStart!: number;
    oorRate!: number | undefined;
    effectivityDate!: moment.Moment | undefined;
    routeScheduleId!: number;
    routeTypeId!: number;
    routeTypeName!: string | undefined;
    isActive!: boolean;
    oneTime!: boolean;
    etaLocked!: boolean;
    etaLockedByUserId!: number | undefined;
    etaLockedByUser!: string | undefined;
    locationId!: number | undefined;
    routeTemplateId!: number | undefined;
    location!: string | undefined;
    dateEtaLocked!: moment.Moment | undefined;
    creationTime!: moment.Moment;
    creator!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUser!: string | undefined;
    contact!: CreateContactInput | undefined;
    address!: CreateAddressInput | undefined;
    emailAddress!: string | undefined;
    phoneNumber!: string | undefined;
    contactId!: number;
    latitude!: number;
    longitude!: number;
    lastModifierUserId!: number | undefined;
    creatorUserId!: number | undefined;

    constructor(data?: IGetLineHaulRouteScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeCode = data["routeCode"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"];
            this.mondayETATime = data["mondayETATime"];
            this.tuesdayETATime = data["tuesdayETATime"];
            this.wednesdayETATime = data["wednesdayETATime"];
            this.thursdayETATime = data["thursdayETATime"];
            this.fridayETATime = data["fridayETATime"];
            this.saturdayETATime = data["saturdayETATime"];
            this.sundayETATime = data["sundayETATime"];
            this.etaTime = data["etaTime"];
            this.today = data["today"] ? moment(data["today"].toString()) : <any>undefined;
            this.displayEta = data["displayEta"] ? moment(data["displayEta"].toString()) : <any>undefined;
            this.serviceTime = data["serviceTime"];
            this.timeWindowEnd = data["timeWindowEnd"];
            this.timeWindowStart = data["timeWindowStart"];
            this.oorRate = data["oorRate"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.routeScheduleId = data["routeScheduleId"];
            this.routeTypeId = data["routeTypeId"];
            this.routeTypeName = data["routeTypeName"];
            this.isActive = data["isActive"];
            this.oneTime = data["oneTime"];
            this.etaLocked = data["etaLocked"];
            this.etaLockedByUserId = data["etaLockedByUserId"];
            this.etaLockedByUser = data["etaLockedByUser"];
            this.locationId = data["locationId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.location = data["location"];
            this.dateEtaLocked = data["dateEtaLocked"] ? moment(data["dateEtaLocked"].toString()) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creator = data["creator"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUser = data["lastModifierUser"];
            this.contact = data["contact"] ? CreateContactInput.fromJS(data["contact"]) : <any>undefined;
            this.address = data["address"] ? CreateAddressInput.fromJS(data["address"]) : <any>undefined;
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
            this.contactId = data["contactId"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creatorUserId = data["creatorUserId"];
        }
    }

    static fromJS(data: any): GetLineHaulRouteScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetLineHaulRouteScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeCode"] = this.routeCode;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival;
        data["mondayETATime"] = this.mondayETATime;
        data["tuesdayETATime"] = this.tuesdayETATime;
        data["wednesdayETATime"] = this.wednesdayETATime;
        data["thursdayETATime"] = this.thursdayETATime;
        data["fridayETATime"] = this.fridayETATime;
        data["saturdayETATime"] = this.saturdayETATime;
        data["sundayETATime"] = this.sundayETATime;
        data["etaTime"] = this.etaTime;
        data["today"] = this.today ? this.today.toISOString() : <any>undefined;
        data["displayEta"] = this.displayEta ? this.displayEta.toISOString() : <any>undefined;
        data["serviceTime"] = this.serviceTime;
        data["timeWindowEnd"] = this.timeWindowEnd;
        data["timeWindowStart"] = this.timeWindowStart;
        data["oorRate"] = this.oorRate;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["routeScheduleId"] = this.routeScheduleId;
        data["routeTypeId"] = this.routeTypeId;
        data["routeTypeName"] = this.routeTypeName;
        data["isActive"] = this.isActive;
        data["oneTime"] = this.oneTime;
        data["etaLocked"] = this.etaLocked;
        data["etaLockedByUserId"] = this.etaLockedByUserId;
        data["etaLockedByUser"] = this.etaLockedByUser;
        data["locationId"] = this.locationId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["location"] = this.location;
        data["dateEtaLocked"] = this.dateEtaLocked ? this.dateEtaLocked.toISOString() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creator"] = this.creator;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUser"] = this.lastModifierUser;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        data["contactId"] = this.contactId;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creatorUserId"] = this.creatorUserId;
        return data; 
    }
}

export interface IGetLineHaulRouteScheduleDto {
    id: number;
    routeCode: string | undefined;
    estimatedTimeOfArrival: string | undefined;
    mondayETATime: string | undefined;
    tuesdayETATime: string | undefined;
    wednesdayETATime: string | undefined;
    thursdayETATime: string | undefined;
    fridayETATime: string | undefined;
    saturdayETATime: string | undefined;
    sundayETATime: string | undefined;
    etaTime: string | undefined;
    today: moment.Moment;
    displayEta: moment.Moment;
    serviceTime: number;
    timeWindowEnd: number | undefined;
    timeWindowStart: number;
    oorRate: number | undefined;
    effectivityDate: moment.Moment | undefined;
    routeScheduleId: number;
    routeTypeId: number;
    routeTypeName: string | undefined;
    isActive: boolean;
    oneTime: boolean;
    etaLocked: boolean;
    etaLockedByUserId: number | undefined;
    etaLockedByUser: string | undefined;
    locationId: number | undefined;
    routeTemplateId: number | undefined;
    location: string | undefined;
    dateEtaLocked: moment.Moment | undefined;
    creationTime: moment.Moment;
    creator: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUser: string | undefined;
    contact: CreateContactInput | undefined;
    address: CreateAddressInput | undefined;
    emailAddress: string | undefined;
    phoneNumber: string | undefined;
    contactId: number;
    latitude: number;
    longitude: number;
    lastModifierUserId: number | undefined;
    creatorUserId: number | undefined;
}

export class ListResultDtoOfGetLineHaulRouteScheduleDto implements IListResultDtoOfGetLineHaulRouteScheduleDto {
    items!: GetLineHaulRouteScheduleDto[] | undefined;

    constructor(data?: IListResultDtoOfGetLineHaulRouteScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetLineHaulRouteScheduleDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetLineHaulRouteScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetLineHaulRouteScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetLineHaulRouteScheduleDto {
    items: GetLineHaulRouteScheduleDto[] | undefined;
}

export class LockedEtaScheduleInput implements ILockedEtaScheduleInput {
    id!: number;
    etaLocked!: boolean;

    constructor(data?: ILockedEtaScheduleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.etaLocked = data["etaLocked"];
        }
    }

    static fromJS(data: any): LockedEtaScheduleInput {
        data = typeof data === 'object' ? data : {};
        let result = new LockedEtaScheduleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["etaLocked"] = this.etaLocked;
        return data; 
    }
}

export interface ILockedEtaScheduleInput {
    id: number;
    etaLocked: boolean;
}

export class ListResultDtoOfGetRouteScheduleSettingsItemDto implements IListResultDtoOfGetRouteScheduleSettingsItemDto {
    items!: GetRouteScheduleSettingsItemDto[] | undefined;

    constructor(data?: IListResultDtoOfGetRouteScheduleSettingsItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteScheduleSettingsItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetRouteScheduleSettingsItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetRouteScheduleSettingsItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetRouteScheduleSettingsItemDto {
    items: GetRouteScheduleSettingsItemDto[] | undefined;
}

export class CreateForRouteHandOffScheduleInputDto implements ICreateForRouteHandOffScheduleInputDto {
    routeHandOffScheduleId!: number;
    code!: string | undefined;
    value!: string | undefined;

    constructor(data?: ICreateForRouteHandOffScheduleInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeHandOffScheduleId = data["routeHandOffScheduleId"];
            this.code = data["code"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreateForRouteHandOffScheduleInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateForRouteHandOffScheduleInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeHandOffScheduleId"] = this.routeHandOffScheduleId;
        data["code"] = this.code;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreateForRouteHandOffScheduleInputDto {
    routeHandOffScheduleId: number;
    code: string | undefined;
    value: string | undefined;
}

export class GeocodeDto implements IGeocodeDto {
    latitude!: number;
    longitude!: number;

    constructor(data?: IGeocodeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): GeocodeDto {
        data = typeof data === 'object' ? data : {};
        let result = new GeocodeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface IGeocodeDto {
    latitude: number;
    longitude: number;
}

export class LocationParameter implements ILocationParameter {
    id!: number;
    geocode!: GeocodeDto | undefined;
    value!: string | undefined;
    leadTime!: number | undefined;
    minutesPerMile!: number | undefined;
    minutesPerStop!: number | undefined;
    etaRoundUp!: number | undefined;

    constructor(data?: ILocationParameter) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.geocode = data["geocode"] ? GeocodeDto.fromJS(data["geocode"]) : <any>undefined;
            this.value = data["value"];
            this.leadTime = data["leadTime"];
            this.minutesPerMile = data["minutesPerMile"];
            this.minutesPerStop = data["minutesPerStop"];
            this.etaRoundUp = data["etaRoundUp"];
        }
    }

    static fromJS(data: any): LocationParameter {
        data = typeof data === 'object' ? data : {};
        let result = new LocationParameter();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["value"] = this.value;
        data["leadTime"] = this.leadTime;
        data["minutesPerMile"] = this.minutesPerMile;
        data["minutesPerStop"] = this.minutesPerStop;
        data["etaRoundUp"] = this.etaRoundUp;
        return data; 
    }
}

export interface ILocationParameter {
    id: number;
    geocode: GeocodeDto | undefined;
    value: string | undefined;
    leadTime: number | undefined;
    minutesPerMile: number | undefined;
    minutesPerStop: number | undefined;
    etaRoundUp: number | undefined;
}

export class OptimizeRouteInput implements IOptimizeRouteInput {
    routeId!: number;

    constructor(data?: IOptimizeRouteInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
        }
    }

    static fromJS(data: any): OptimizeRouteInput {
        data = typeof data === 'object' ? data : {};
        let result = new OptimizeRouteInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        return data; 
    }
}

export interface IOptimizeRouteInput {
    routeId: number;
}

export class OptimizeWillCallInput implements IOptimizeWillCallInput {
    routeId!: number;
    orderId!: number;

    constructor(data?: IOptimizeWillCallInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): OptimizeWillCallInput {
        data = typeof data === 'object' ? data : {};
        let result = new OptimizeWillCallInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface IOptimizeWillCallInput {
    routeId: number;
    orderId: number;
}

export class EtaComputationInput implements IEtaComputationInput {
    routeCode!: string | undefined;

    constructor(data?: IEtaComputationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeCode = data["routeCode"];
        }
    }

    static fromJS(data: any): EtaComputationInput {
        data = typeof data === 'object' ? data : {};
        let result = new EtaComputationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeCode"] = this.routeCode;
        return data; 
    }
}

export interface IEtaComputationInput {
    routeCode: string | undefined;
}

export class EtaComputationReturn implements IEtaComputationReturn {
    sequence!: number;
    routeCode!: string | undefined;
    eta!: TimeSpan;

    constructor(data?: IEtaComputationReturn) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.sequence = data["sequence"];
            this.routeCode = data["routeCode"];
            this.eta = data["eta"] ? TimeSpan.fromJS(data["eta"]) : <any>undefined;
        }
    }

    static fromJS(data: any): EtaComputationReturn {
        data = typeof data === 'object' ? data : {};
        let result = new EtaComputationReturn();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["sequence"] = this.sequence;
        data["routeCode"] = this.routeCode;
        data["eta"] = this.eta ? this.eta.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IEtaComputationReturn {
    sequence: number;
    routeCode: string | undefined;
    eta: TimeSpan;
}

export class RouteScheduleDetailETAs implements IRouteScheduleDetailETAs {
    routeScheduleDetailId!: number;
    time!: TimeSpan;
    day!: DayOfWeek;
    type!: TimeTypes;

    constructor(data?: IRouteScheduleDetailETAs) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.time = data["time"] ? TimeSpan.fromJS(data["time"]) : <any>undefined;
            this.day = data["day"];
            this.type = data["type"];
        }
    }

    static fromJS(data: any): RouteScheduleDetailETAs {
        data = typeof data === 'object' ? data : {};
        let result = new RouteScheduleDetailETAs();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["time"] = this.time ? this.time.toJSON() : <any>undefined;
        data["day"] = this.day;
        data["type"] = this.type;
        return data; 
    }
}

export interface IRouteScheduleDetailETAs {
    routeScheduleDetailId: number;
    time: TimeSpan;
    day: DayOfWeek;
    type: TimeTypes;
}

export class ContactBusinessHours implements IContactBusinessHours {
    code!: string | undefined;
    contactId!: number;
    openingTime!: TimeSpan;
    closingTime!: TimeSpan;
    date!: moment.Moment | undefined;
    day!: string | undefined;
    isClosed!: boolean;

    constructor(data?: IContactBusinessHours) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.contactId = data["contactId"];
            this.openingTime = data["openingTime"] ? TimeSpan.fromJS(data["openingTime"]) : <any>undefined;
            this.closingTime = data["closingTime"] ? TimeSpan.fromJS(data["closingTime"]) : <any>undefined;
            this.date = data["date"] ? moment(data["date"].toString()) : <any>undefined;
            this.day = data["day"];
            this.isClosed = data["isClosed"];
        }
    }

    static fromJS(data: any): ContactBusinessHours {
        data = typeof data === 'object' ? data : {};
        let result = new ContactBusinessHours();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["contactId"] = this.contactId;
        data["openingTime"] = this.openingTime ? this.openingTime.toJSON() : <any>undefined;
        data["closingTime"] = this.closingTime ? this.closingTime.toJSON() : <any>undefined;
        data["date"] = this.date ? this.date.toISOString() : <any>undefined;
        data["day"] = this.day;
        data["isClosed"] = this.isClosed;
        return data; 
    }
}

export interface IContactBusinessHours {
    code: string | undefined;
    contactId: number;
    openingTime: TimeSpan;
    closingTime: TimeSpan;
    date: moment.Moment | undefined;
    day: string | undefined;
    isClosed: boolean;
}

export class RouteScheduleDetailParam implements IRouteScheduleDetailParam {
    id!: number;
    routeCode!: string | undefined;
    routeScheduleId!: number;
    locationId!: number;
    routeTypeId!: number;
    tenantId!: number;
    effectivityDate!: moment.Moment;
    mondayIsActive!: number | undefined;
    mondayCutOffTime!: TimeSpan | undefined;
    tuesdayIsActive!: number | undefined;
    tuesdayCutOffTime!: TimeSpan | undefined;
    wednesdayIsActive!: number | undefined;
    wednesdayCutOffTime!: TimeSpan | undefined;
    thursdayIsActive!: number | undefined;
    thursdayCutOffTime!: TimeSpan | undefined;
    fridayIsActive!: number | undefined;
    fridayCutOffTime!: TimeSpan | undefined;
    saturdayIsActive!: number | undefined;
    saturdayCutOffTime!: TimeSpan | undefined;
    sundayIsActive!: number | undefined;
    sundayCutOffTime!: TimeSpan | undefined;
    serviceTime!: number;
    etaLocked!: boolean;
    sundayETATime!: TimeSpan | undefined;
    mondayETATime!: TimeSpan | undefined;
    tuesdayETATime!: TimeSpan | undefined;
    wednesdayETATime!: TimeSpan | undefined;
    thursdayETATime!: TimeSpan | undefined;
    fridayETATime!: TimeSpan | undefined;
    saturdayETATime!: TimeSpan | undefined;
    routeTemplateId!: number | undefined;
    mondayLTA!: TimeSpan | undefined;
    tuesdayLTA!: TimeSpan | undefined;
    wednesdayLTA!: TimeSpan | undefined;
    thursdayLTA!: TimeSpan | undefined;
    fridayLTA!: TimeSpan | undefined;
    saturdayLTA!: TimeSpan | undefined;
    sundayLTA!: TimeSpan | undefined;
    contactId!: number;
    timeWindowStart!: number;
    timeWindowEnd!: number | undefined;
    timeZoneId!: number | undefined;
    timeZoneValue!: string | undefined;
    locationName!: string | undefined;
    locked!: boolean;
    cutOffAddMinutes!: number | undefined;
    sortOrder!: number | undefined;
    routeTypeCode!: string | undefined;
    routeTypeStartTime!: TimeSpan | undefined;
    clinicLatitude!: number;
    clinicLongitude!: number;
    unlockFrom!: moment.Moment | undefined;
    unlockTo!: moment.Moment | undefined;
    startTime!: TimeSpan;
    endTime!: TimeSpan;
    startTimeType!: number;
    routeScheduleDetailETAs!: RouteScheduleDetailETAs[] | undefined;
    contactBusinessHours!: ContactBusinessHours[] | undefined;

    constructor(data?: IRouteScheduleDetailParam) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeCode = data["routeCode"];
            this.routeScheduleId = data["routeScheduleId"];
            this.locationId = data["locationId"];
            this.routeTypeId = data["routeTypeId"];
            this.tenantId = data["tenantId"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.mondayIsActive = data["mondayIsActive"];
            this.mondayCutOffTime = data["mondayCutOffTime"] ? TimeSpan.fromJS(data["mondayCutOffTime"]) : <any>undefined;
            this.tuesdayIsActive = data["tuesdayIsActive"];
            this.tuesdayCutOffTime = data["tuesdayCutOffTime"] ? TimeSpan.fromJS(data["tuesdayCutOffTime"]) : <any>undefined;
            this.wednesdayIsActive = data["wednesdayIsActive"];
            this.wednesdayCutOffTime = data["wednesdayCutOffTime"] ? TimeSpan.fromJS(data["wednesdayCutOffTime"]) : <any>undefined;
            this.thursdayIsActive = data["thursdayIsActive"];
            this.thursdayCutOffTime = data["thursdayCutOffTime"] ? TimeSpan.fromJS(data["thursdayCutOffTime"]) : <any>undefined;
            this.fridayIsActive = data["fridayIsActive"];
            this.fridayCutOffTime = data["fridayCutOffTime"] ? TimeSpan.fromJS(data["fridayCutOffTime"]) : <any>undefined;
            this.saturdayIsActive = data["saturdayIsActive"];
            this.saturdayCutOffTime = data["saturdayCutOffTime"] ? TimeSpan.fromJS(data["saturdayCutOffTime"]) : <any>undefined;
            this.sundayIsActive = data["sundayIsActive"];
            this.sundayCutOffTime = data["sundayCutOffTime"] ? TimeSpan.fromJS(data["sundayCutOffTime"]) : <any>undefined;
            this.serviceTime = data["serviceTime"];
            this.etaLocked = data["etaLocked"];
            this.sundayETATime = data["sundayETATime"] ? TimeSpan.fromJS(data["sundayETATime"]) : <any>undefined;
            this.mondayETATime = data["mondayETATime"] ? TimeSpan.fromJS(data["mondayETATime"]) : <any>undefined;
            this.tuesdayETATime = data["tuesdayETATime"] ? TimeSpan.fromJS(data["tuesdayETATime"]) : <any>undefined;
            this.wednesdayETATime = data["wednesdayETATime"] ? TimeSpan.fromJS(data["wednesdayETATime"]) : <any>undefined;
            this.thursdayETATime = data["thursdayETATime"] ? TimeSpan.fromJS(data["thursdayETATime"]) : <any>undefined;
            this.fridayETATime = data["fridayETATime"] ? TimeSpan.fromJS(data["fridayETATime"]) : <any>undefined;
            this.saturdayETATime = data["saturdayETATime"] ? TimeSpan.fromJS(data["saturdayETATime"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.mondayLTA = data["mondayLTA"] ? TimeSpan.fromJS(data["mondayLTA"]) : <any>undefined;
            this.tuesdayLTA = data["tuesdayLTA"] ? TimeSpan.fromJS(data["tuesdayLTA"]) : <any>undefined;
            this.wednesdayLTA = data["wednesdayLTA"] ? TimeSpan.fromJS(data["wednesdayLTA"]) : <any>undefined;
            this.thursdayLTA = data["thursdayLTA"] ? TimeSpan.fromJS(data["thursdayLTA"]) : <any>undefined;
            this.fridayLTA = data["fridayLTA"] ? TimeSpan.fromJS(data["fridayLTA"]) : <any>undefined;
            this.saturdayLTA = data["saturdayLTA"] ? TimeSpan.fromJS(data["saturdayLTA"]) : <any>undefined;
            this.sundayLTA = data["sundayLTA"] ? TimeSpan.fromJS(data["sundayLTA"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.timeWindowStart = data["timeWindowStart"];
            this.timeWindowEnd = data["timeWindowEnd"];
            this.timeZoneId = data["timeZoneId"];
            this.timeZoneValue = data["timeZoneValue"];
            this.locationName = data["locationName"];
            this.locked = data["locked"];
            this.cutOffAddMinutes = data["cutOffAddMinutes"];
            this.sortOrder = data["sortOrder"];
            this.routeTypeCode = data["routeTypeCode"];
            this.routeTypeStartTime = data["routeTypeStartTime"] ? TimeSpan.fromJS(data["routeTypeStartTime"]) : <any>undefined;
            this.clinicLatitude = data["clinicLatitude"];
            this.clinicLongitude = data["clinicLongitude"];
            this.unlockFrom = data["unlockFrom"] ? moment(data["unlockFrom"].toString()) : <any>undefined;
            this.unlockTo = data["unlockTo"] ? moment(data["unlockTo"].toString()) : <any>undefined;
            this.startTime = data["startTime"] ? TimeSpan.fromJS(data["startTime"]) : <any>undefined;
            this.endTime = data["endTime"] ? TimeSpan.fromJS(data["endTime"]) : <any>undefined;
            this.startTimeType = data["startTimeType"];
            if (Array.isArray(data["routeScheduleDetailETAs"])) {
                this.routeScheduleDetailETAs = [] as any;
                for (let item of data["routeScheduleDetailETAs"])
                    this.routeScheduleDetailETAs!.push(RouteScheduleDetailETAs.fromJS(item));
            }
            if (Array.isArray(data["contactBusinessHours"])) {
                this.contactBusinessHours = [] as any;
                for (let item of data["contactBusinessHours"])
                    this.contactBusinessHours!.push(ContactBusinessHours.fromJS(item));
            }
        }
    }

    static fromJS(data: any): RouteScheduleDetailParam {
        data = typeof data === 'object' ? data : {};
        let result = new RouteScheduleDetailParam();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeCode"] = this.routeCode;
        data["routeScheduleId"] = this.routeScheduleId;
        data["locationId"] = this.locationId;
        data["routeTypeId"] = this.routeTypeId;
        data["tenantId"] = this.tenantId;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["mondayIsActive"] = this.mondayIsActive;
        data["mondayCutOffTime"] = this.mondayCutOffTime ? this.mondayCutOffTime.toJSON() : <any>undefined;
        data["tuesdayIsActive"] = this.tuesdayIsActive;
        data["tuesdayCutOffTime"] = this.tuesdayCutOffTime ? this.tuesdayCutOffTime.toJSON() : <any>undefined;
        data["wednesdayIsActive"] = this.wednesdayIsActive;
        data["wednesdayCutOffTime"] = this.wednesdayCutOffTime ? this.wednesdayCutOffTime.toJSON() : <any>undefined;
        data["thursdayIsActive"] = this.thursdayIsActive;
        data["thursdayCutOffTime"] = this.thursdayCutOffTime ? this.thursdayCutOffTime.toJSON() : <any>undefined;
        data["fridayIsActive"] = this.fridayIsActive;
        data["fridayCutOffTime"] = this.fridayCutOffTime ? this.fridayCutOffTime.toJSON() : <any>undefined;
        data["saturdayIsActive"] = this.saturdayIsActive;
        data["saturdayCutOffTime"] = this.saturdayCutOffTime ? this.saturdayCutOffTime.toJSON() : <any>undefined;
        data["sundayIsActive"] = this.sundayIsActive;
        data["sundayCutOffTime"] = this.sundayCutOffTime ? this.sundayCutOffTime.toJSON() : <any>undefined;
        data["serviceTime"] = this.serviceTime;
        data["etaLocked"] = this.etaLocked;
        data["sundayETATime"] = this.sundayETATime ? this.sundayETATime.toJSON() : <any>undefined;
        data["mondayETATime"] = this.mondayETATime ? this.mondayETATime.toJSON() : <any>undefined;
        data["tuesdayETATime"] = this.tuesdayETATime ? this.tuesdayETATime.toJSON() : <any>undefined;
        data["wednesdayETATime"] = this.wednesdayETATime ? this.wednesdayETATime.toJSON() : <any>undefined;
        data["thursdayETATime"] = this.thursdayETATime ? this.thursdayETATime.toJSON() : <any>undefined;
        data["fridayETATime"] = this.fridayETATime ? this.fridayETATime.toJSON() : <any>undefined;
        data["saturdayETATime"] = this.saturdayETATime ? this.saturdayETATime.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["mondayLTA"] = this.mondayLTA ? this.mondayLTA.toJSON() : <any>undefined;
        data["tuesdayLTA"] = this.tuesdayLTA ? this.tuesdayLTA.toJSON() : <any>undefined;
        data["wednesdayLTA"] = this.wednesdayLTA ? this.wednesdayLTA.toJSON() : <any>undefined;
        data["thursdayLTA"] = this.thursdayLTA ? this.thursdayLTA.toJSON() : <any>undefined;
        data["fridayLTA"] = this.fridayLTA ? this.fridayLTA.toJSON() : <any>undefined;
        data["saturdayLTA"] = this.saturdayLTA ? this.saturdayLTA.toJSON() : <any>undefined;
        data["sundayLTA"] = this.sundayLTA ? this.sundayLTA.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["timeWindowStart"] = this.timeWindowStart;
        data["timeWindowEnd"] = this.timeWindowEnd;
        data["timeZoneId"] = this.timeZoneId;
        data["timeZoneValue"] = this.timeZoneValue;
        data["locationName"] = this.locationName;
        data["locked"] = this.locked;
        data["cutOffAddMinutes"] = this.cutOffAddMinutes;
        data["sortOrder"] = this.sortOrder;
        data["routeTypeCode"] = this.routeTypeCode;
        data["routeTypeStartTime"] = this.routeTypeStartTime ? this.routeTypeStartTime.toJSON() : <any>undefined;
        data["clinicLatitude"] = this.clinicLatitude;
        data["clinicLongitude"] = this.clinicLongitude;
        data["unlockFrom"] = this.unlockFrom ? this.unlockFrom.toISOString() : <any>undefined;
        data["unlockTo"] = this.unlockTo ? this.unlockTo.toISOString() : <any>undefined;
        data["startTime"] = this.startTime ? this.startTime.toJSON() : <any>undefined;
        data["endTime"] = this.endTime ? this.endTime.toJSON() : <any>undefined;
        data["startTimeType"] = this.startTimeType;
        if (Array.isArray(this.routeScheduleDetailETAs)) {
            data["routeScheduleDetailETAs"] = [];
            for (let item of this.routeScheduleDetailETAs)
                data["routeScheduleDetailETAs"].push(item.toJSON());
        }
        if (Array.isArray(this.contactBusinessHours)) {
            data["contactBusinessHours"] = [];
            for (let item of this.contactBusinessHours)
                data["contactBusinessHours"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IRouteScheduleDetailParam {
    id: number;
    routeCode: string | undefined;
    routeScheduleId: number;
    locationId: number;
    routeTypeId: number;
    tenantId: number;
    effectivityDate: moment.Moment;
    mondayIsActive: number | undefined;
    mondayCutOffTime: TimeSpan | undefined;
    tuesdayIsActive: number | undefined;
    tuesdayCutOffTime: TimeSpan | undefined;
    wednesdayIsActive: number | undefined;
    wednesdayCutOffTime: TimeSpan | undefined;
    thursdayIsActive: number | undefined;
    thursdayCutOffTime: TimeSpan | undefined;
    fridayIsActive: number | undefined;
    fridayCutOffTime: TimeSpan | undefined;
    saturdayIsActive: number | undefined;
    saturdayCutOffTime: TimeSpan | undefined;
    sundayIsActive: number | undefined;
    sundayCutOffTime: TimeSpan | undefined;
    serviceTime: number;
    etaLocked: boolean;
    sundayETATime: TimeSpan | undefined;
    mondayETATime: TimeSpan | undefined;
    tuesdayETATime: TimeSpan | undefined;
    wednesdayETATime: TimeSpan | undefined;
    thursdayETATime: TimeSpan | undefined;
    fridayETATime: TimeSpan | undefined;
    saturdayETATime: TimeSpan | undefined;
    routeTemplateId: number | undefined;
    mondayLTA: TimeSpan | undefined;
    tuesdayLTA: TimeSpan | undefined;
    wednesdayLTA: TimeSpan | undefined;
    thursdayLTA: TimeSpan | undefined;
    fridayLTA: TimeSpan | undefined;
    saturdayLTA: TimeSpan | undefined;
    sundayLTA: TimeSpan | undefined;
    contactId: number;
    timeWindowStart: number;
    timeWindowEnd: number | undefined;
    timeZoneId: number | undefined;
    timeZoneValue: string | undefined;
    locationName: string | undefined;
    locked: boolean;
    cutOffAddMinutes: number | undefined;
    sortOrder: number | undefined;
    routeTypeCode: string | undefined;
    routeTypeStartTime: TimeSpan | undefined;
    clinicLatitude: number;
    clinicLongitude: number;
    unlockFrom: moment.Moment | undefined;
    unlockTo: moment.Moment | undefined;
    startTime: TimeSpan;
    endTime: TimeSpan;
    startTimeType: number;
    routeScheduleDetailETAs: RouteScheduleDetailETAs[] | undefined;
    contactBusinessHours: ContactBusinessHours[] | undefined;
}

export class CreateRouteTemplateClinicInput implements ICreateRouteTemplateClinicInput {
    name!: string;
    locationId!: number;
    routeTemplateTypeId!: number;
    startTimeType!: number;
    startTimeMins!: number | undefined;
    startTime!: TimeSpan;
    endTimeType!: number;
    endTimeMins!: number | undefined;
    endTime!: TimeSpan;
    defaultUserId!: number | undefined;
    routeStartContactId!: number | undefined;
    isRunning!: boolean;
    mondayDriverId!: number | undefined;
    tuesdayDriverId!: number | undefined;
    wednesdayDriverId!: number | undefined;
    thursdayDriverId!: number | undefined;
    fridayDriverId!: number | undefined;
    saturdayDriverId!: number | undefined;
    sundayDriverId!: number | undefined;
    mondayManagerId!: number | undefined;
    tuesdayManagerId!: number | undefined;
    wednesdayManagerId!: number | undefined;
    thursdayManagerId!: number | undefined;
    fridayManagerId!: number | undefined;
    saturdayManagerId!: number | undefined;
    sundayManagerId!: number | undefined;
    defaultContactId!: number | undefined;
    meetpointContactId!: number | undefined;
    routeStartInactive!: boolean;
    routeStopInactive!: boolean;
    mondaySupervisorId!: number | undefined;
    tuesdaySupervisorId!: number | undefined;
    wednesdaySupervisorId!: number | undefined;
    thursdaySupervisorId!: number | undefined;
    fridaySupervisorId!: number | undefined;
    saturdaySupervisorId!: number | undefined;
    sundaySupervisorId!: number | undefined;
    routeStopId!: number | undefined;
    meetPointStopId!: number | undefined;
    routeStartId!: number | undefined;
    loadLimit!: number | undefined;

    constructor(data?: ICreateRouteTemplateClinicInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.locationId = data["locationId"];
            this.routeTemplateTypeId = data["routeTemplateTypeId"];
            this.startTimeType = data["startTimeType"];
            this.startTimeMins = data["startTimeMins"];
            this.startTime = data["startTime"] ? TimeSpan.fromJS(data["startTime"]) : <any>undefined;
            this.endTimeType = data["endTimeType"];
            this.endTimeMins = data["endTimeMins"];
            this.endTime = data["endTime"] ? TimeSpan.fromJS(data["endTime"]) : <any>undefined;
            this.defaultUserId = data["defaultUserId"];
            this.routeStartContactId = data["routeStartContactId"];
            this.isRunning = data["isRunning"];
            this.mondayDriverId = data["mondayDriverId"];
            this.tuesdayDriverId = data["tuesdayDriverId"];
            this.wednesdayDriverId = data["wednesdayDriverId"];
            this.thursdayDriverId = data["thursdayDriverId"];
            this.fridayDriverId = data["fridayDriverId"];
            this.saturdayDriverId = data["saturdayDriverId"];
            this.sundayDriverId = data["sundayDriverId"];
            this.mondayManagerId = data["mondayManagerId"];
            this.tuesdayManagerId = data["tuesdayManagerId"];
            this.wednesdayManagerId = data["wednesdayManagerId"];
            this.thursdayManagerId = data["thursdayManagerId"];
            this.fridayManagerId = data["fridayManagerId"];
            this.saturdayManagerId = data["saturdayManagerId"];
            this.sundayManagerId = data["sundayManagerId"];
            this.defaultContactId = data["defaultContactId"];
            this.meetpointContactId = data["meetpointContactId"];
            this.routeStartInactive = data["routeStartInactive"];
            this.routeStopInactive = data["routeStopInactive"];
            this.mondaySupervisorId = data["mondaySupervisorId"];
            this.tuesdaySupervisorId = data["tuesdaySupervisorId"];
            this.wednesdaySupervisorId = data["wednesdaySupervisorId"];
            this.thursdaySupervisorId = data["thursdaySupervisorId"];
            this.fridaySupervisorId = data["fridaySupervisorId"];
            this.saturdaySupervisorId = data["saturdaySupervisorId"];
            this.sundaySupervisorId = data["sundaySupervisorId"];
            this.routeStopId = data["routeStopId"];
            this.meetPointStopId = data["meetPointStopId"];
            this.routeStartId = data["routeStartId"];
            this.loadLimit = data["loadLimit"];
        }
    }

    static fromJS(data: any): CreateRouteTemplateClinicInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRouteTemplateClinicInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["locationId"] = this.locationId;
        data["routeTemplateTypeId"] = this.routeTemplateTypeId;
        data["startTimeType"] = this.startTimeType;
        data["startTimeMins"] = this.startTimeMins;
        data["startTime"] = this.startTime ? this.startTime.toJSON() : <any>undefined;
        data["endTimeType"] = this.endTimeType;
        data["endTimeMins"] = this.endTimeMins;
        data["endTime"] = this.endTime ? this.endTime.toJSON() : <any>undefined;
        data["defaultUserId"] = this.defaultUserId;
        data["routeStartContactId"] = this.routeStartContactId;
        data["isRunning"] = this.isRunning;
        data["mondayDriverId"] = this.mondayDriverId;
        data["tuesdayDriverId"] = this.tuesdayDriverId;
        data["wednesdayDriverId"] = this.wednesdayDriverId;
        data["thursdayDriverId"] = this.thursdayDriverId;
        data["fridayDriverId"] = this.fridayDriverId;
        data["saturdayDriverId"] = this.saturdayDriverId;
        data["sundayDriverId"] = this.sundayDriverId;
        data["mondayManagerId"] = this.mondayManagerId;
        data["tuesdayManagerId"] = this.tuesdayManagerId;
        data["wednesdayManagerId"] = this.wednesdayManagerId;
        data["thursdayManagerId"] = this.thursdayManagerId;
        data["fridayManagerId"] = this.fridayManagerId;
        data["saturdayManagerId"] = this.saturdayManagerId;
        data["sundayManagerId"] = this.sundayManagerId;
        data["defaultContactId"] = this.defaultContactId;
        data["meetpointContactId"] = this.meetpointContactId;
        data["routeStartInactive"] = this.routeStartInactive;
        data["routeStopInactive"] = this.routeStopInactive;
        data["mondaySupervisorId"] = this.mondaySupervisorId;
        data["tuesdaySupervisorId"] = this.tuesdaySupervisorId;
        data["wednesdaySupervisorId"] = this.wednesdaySupervisorId;
        data["thursdaySupervisorId"] = this.thursdaySupervisorId;
        data["fridaySupervisorId"] = this.fridaySupervisorId;
        data["saturdaySupervisorId"] = this.saturdaySupervisorId;
        data["sundaySupervisorId"] = this.sundaySupervisorId;
        data["routeStopId"] = this.routeStopId;
        data["meetPointStopId"] = this.meetPointStopId;
        data["routeStartId"] = this.routeStartId;
        data["loadLimit"] = this.loadLimit;
        return data; 
    }
}

export interface ICreateRouteTemplateClinicInput {
    name: string;
    locationId: number;
    routeTemplateTypeId: number;
    startTimeType: number;
    startTimeMins: number | undefined;
    startTime: TimeSpan;
    endTimeType: number;
    endTimeMins: number | undefined;
    endTime: TimeSpan;
    defaultUserId: number | undefined;
    routeStartContactId: number | undefined;
    isRunning: boolean;
    mondayDriverId: number | undefined;
    tuesdayDriverId: number | undefined;
    wednesdayDriverId: number | undefined;
    thursdayDriverId: number | undefined;
    fridayDriverId: number | undefined;
    saturdayDriverId: number | undefined;
    sundayDriverId: number | undefined;
    mondayManagerId: number | undefined;
    tuesdayManagerId: number | undefined;
    wednesdayManagerId: number | undefined;
    thursdayManagerId: number | undefined;
    fridayManagerId: number | undefined;
    saturdayManagerId: number | undefined;
    sundayManagerId: number | undefined;
    defaultContactId: number | undefined;
    meetpointContactId: number | undefined;
    routeStartInactive: boolean;
    routeStopInactive: boolean;
    mondaySupervisorId: number | undefined;
    tuesdaySupervisorId: number | undefined;
    wednesdaySupervisorId: number | undefined;
    thursdaySupervisorId: number | undefined;
    fridaySupervisorId: number | undefined;
    saturdaySupervisorId: number | undefined;
    sundaySupervisorId: number | undefined;
    routeStopId: number | undefined;
    meetPointStopId: number | undefined;
    routeStartId: number | undefined;
    loadLimit: number | undefined;
}

export class GetRoutesResultDto implements IGetRoutesResultDto {
    id!: number;
    freeze!: boolean;
    cutOffAddjustments!: number | undefined;
    loadDate!: moment.Moment;
    vehicleId!: number | undefined;
    departure!: moment.Moment | undefined;
    completion!: moment.Moment | undefined;

    constructor(data?: IGetRoutesResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.freeze = data["freeze"];
            this.cutOffAddjustments = data["cutOffAddjustments"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.vehicleId = data["vehicleId"];
            this.departure = data["departure"] ? moment(data["departure"].toString()) : <any>undefined;
            this.completion = data["completion"] ? moment(data["completion"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRoutesResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRoutesResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["freeze"] = this.freeze;
        data["cutOffAddjustments"] = this.cutOffAddjustments;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        data["departure"] = this.departure ? this.departure.toISOString() : <any>undefined;
        data["completion"] = this.completion ? this.completion.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetRoutesResultDto {
    id: number;
    freeze: boolean;
    cutOffAddjustments: number | undefined;
    loadDate: moment.Moment;
    vehicleId: number | undefined;
    departure: moment.Moment | undefined;
    completion: moment.Moment | undefined;
}

export class RouteTemplateResult implements IRouteTemplateResult {
    id!: number;
    name!: string | undefined;
    startTime!: TimeSpan;
    defaultContactId!: number | undefined;
    routeStartContactLat!: number;
    routeStartContactLong!: number;
    routeStartInActive!: boolean;
    defaultContactLat!: number;
    defaultContactLong!: number;
    routeStopInActive!: boolean;

    constructor(data?: IRouteTemplateResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.startTime = data["startTime"] ? TimeSpan.fromJS(data["startTime"]) : <any>undefined;
            this.defaultContactId = data["defaultContactId"];
            this.routeStartContactLat = data["routeStartContactLat"];
            this.routeStartContactLong = data["routeStartContactLong"];
            this.routeStartInActive = data["routeStartInActive"];
            this.defaultContactLat = data["defaultContactLat"];
            this.defaultContactLong = data["defaultContactLong"];
            this.routeStopInActive = data["routeStopInActive"];
        }
    }

    static fromJS(data: any): RouteTemplateResult {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["startTime"] = this.startTime ? this.startTime.toJSON() : <any>undefined;
        data["defaultContactId"] = this.defaultContactId;
        data["routeStartContactLat"] = this.routeStartContactLat;
        data["routeStartContactLong"] = this.routeStartContactLong;
        data["routeStartInActive"] = this.routeStartInActive;
        data["defaultContactLat"] = this.defaultContactLat;
        data["defaultContactLong"] = this.defaultContactLong;
        data["routeStopInActive"] = this.routeStopInActive;
        return data; 
    }
}

export interface IRouteTemplateResult {
    id: number;
    name: string | undefined;
    startTime: TimeSpan;
    defaultContactId: number | undefined;
    routeStartContactLat: number;
    routeStartContactLong: number;
    routeStartInActive: boolean;
    defaultContactLat: number;
    defaultContactLong: number;
    routeStopInActive: boolean;
}

export class AutoScheduleDetailResults implements IAutoScheduleDetailResults {
    id!: number;
    sortOrder!: number | undefined;
    serviceTime!: number;
    contactId!: number | undefined;
    routeTemplateId!: number | undefined;

    constructor(data?: IAutoScheduleDetailResults) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.sortOrder = data["sortOrder"];
            this.serviceTime = data["serviceTime"];
            this.contactId = data["contactId"];
            this.routeTemplateId = data["routeTemplateId"];
        }
    }

    static fromJS(data: any): AutoScheduleDetailResults {
        data = typeof data === 'object' ? data : {};
        let result = new AutoScheduleDetailResults();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["sortOrder"] = this.sortOrder;
        data["serviceTime"] = this.serviceTime;
        data["contactId"] = this.contactId;
        data["routeTemplateId"] = this.routeTemplateId;
        return data; 
    }
}

export interface IAutoScheduleDetailResults {
    id: number;
    sortOrder: number | undefined;
    serviceTime: number;
    contactId: number | undefined;
    routeTemplateId: number | undefined;
}

export class AutoSchedDetailETAs implements IAutoSchedDetailETAs {
    routeScheduleDetailId!: number | undefined;
    time!: TimeSpan;
    day!: DayOfWeek;

    constructor(data?: IAutoSchedDetailETAs) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.time = data["time"] ? TimeSpan.fromJS(data["time"]) : <any>undefined;
            this.day = data["day"];
        }
    }

    static fromJS(data: any): AutoSchedDetailETAs {
        data = typeof data === 'object' ? data : {};
        let result = new AutoSchedDetailETAs();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["time"] = this.time ? this.time.toJSON() : <any>undefined;
        data["day"] = this.day;
        return data; 
    }
}

export interface IAutoSchedDetailETAs {
    routeScheduleDetailId: number | undefined;
    time: TimeSpan;
    day: DayOfWeek;
}

export class ContactResults implements IContactResults {
    id!: number;
    addressId!: number | undefined;

    constructor(data?: IContactResults) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.addressId = data["addressId"];
        }
    }

    static fromJS(data: any): ContactResults {
        data = typeof data === 'object' ? data : {};
        let result = new ContactResults();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["addressId"] = this.addressId;
        return data; 
    }
}

export interface IContactResults {
    id: number;
    addressId: number | undefined;
}

export class AddressResults implements IAddressResults {
    id!: number;
    geocodeId!: number | undefined;

    constructor(data?: IAddressResults) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.geocodeId = data["geocodeId"];
        }
    }

    static fromJS(data: any): AddressResults {
        data = typeof data === 'object' ? data : {};
        let result = new AddressResults();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["geocodeId"] = this.geocodeId;
        return data; 
    }
}

export interface IAddressResults {
    id: number;
    geocodeId: number | undefined;
}

export class GeocodeResults implements IGeocodeResults {
    id!: number;
    latitude!: number;
    longitude!: number;

    constructor(data?: IGeocodeResults) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
        }
    }

    static fromJS(data: any): GeocodeResults {
        data = typeof data === 'object' ? data : {};
        let result = new GeocodeResults();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        return data; 
    }
}

export interface IGeocodeResults {
    id: number;
    latitude: number;
    longitude: number;
}

export class LiveEtaInput implements ILiveEtaInput {
    scheduleDetailId!: number;
    isLaboratory!: boolean;
    nextDay!: boolean;
    dateTime!: moment.Moment | undefined;
    routeScheduleDetailParam!: RouteScheduleDetailParam | undefined;
    routeTemplate!: CreateRouteTemplateClinicInput | undefined;
    orderStatusId!: number[] | undefined;
    routeList!: GetRoutesResultDto | undefined;
    orderTypeId!: number;
    routeTemplateResult!: RouteTemplateResult[] | undefined;
    testMode!: boolean | undefined;
    autoScheduleDetailResults!: AutoScheduleDetailResults[] | undefined;
    autoSchedDetailETAs!: AutoSchedDetailETAs[] | undefined;
    contactResults!: ContactResults[] | undefined;
    addressResults!: AddressResults[] | undefined;
    geocodeResults!: GeocodeResults[] | undefined;

    constructor(data?: ILiveEtaInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.scheduleDetailId = data["scheduleDetailId"];
            this.isLaboratory = data["isLaboratory"];
            this.nextDay = data["nextDay"];
            this.dateTime = data["dateTime"] ? moment(data["dateTime"].toString()) : <any>undefined;
            this.routeScheduleDetailParam = data["routeScheduleDetailParam"] ? RouteScheduleDetailParam.fromJS(data["routeScheduleDetailParam"]) : <any>undefined;
            this.routeTemplate = data["routeTemplate"] ? CreateRouteTemplateClinicInput.fromJS(data["routeTemplate"]) : <any>undefined;
            if (Array.isArray(data["orderStatusId"])) {
                this.orderStatusId = [] as any;
                for (let item of data["orderStatusId"])
                    this.orderStatusId!.push(item);
            }
            this.routeList = data["routeList"] ? GetRoutesResultDto.fromJS(data["routeList"]) : <any>undefined;
            this.orderTypeId = data["orderTypeId"];
            if (Array.isArray(data["routeTemplateResult"])) {
                this.routeTemplateResult = [] as any;
                for (let item of data["routeTemplateResult"])
                    this.routeTemplateResult!.push(RouteTemplateResult.fromJS(item));
            }
            this.testMode = data["testMode"];
            if (Array.isArray(data["autoScheduleDetailResults"])) {
                this.autoScheduleDetailResults = [] as any;
                for (let item of data["autoScheduleDetailResults"])
                    this.autoScheduleDetailResults!.push(AutoScheduleDetailResults.fromJS(item));
            }
            if (Array.isArray(data["autoSchedDetailETAs"])) {
                this.autoSchedDetailETAs = [] as any;
                for (let item of data["autoSchedDetailETAs"])
                    this.autoSchedDetailETAs!.push(AutoSchedDetailETAs.fromJS(item));
            }
            if (Array.isArray(data["contactResults"])) {
                this.contactResults = [] as any;
                for (let item of data["contactResults"])
                    this.contactResults!.push(ContactResults.fromJS(item));
            }
            if (Array.isArray(data["addressResults"])) {
                this.addressResults = [] as any;
                for (let item of data["addressResults"])
                    this.addressResults!.push(AddressResults.fromJS(item));
            }
            if (Array.isArray(data["geocodeResults"])) {
                this.geocodeResults = [] as any;
                for (let item of data["geocodeResults"])
                    this.geocodeResults!.push(GeocodeResults.fromJS(item));
            }
        }
    }

    static fromJS(data: any): LiveEtaInput {
        data = typeof data === 'object' ? data : {};
        let result = new LiveEtaInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["scheduleDetailId"] = this.scheduleDetailId;
        data["isLaboratory"] = this.isLaboratory;
        data["nextDay"] = this.nextDay;
        data["dateTime"] = this.dateTime ? this.dateTime.toISOString() : <any>undefined;
        data["routeScheduleDetailParam"] = this.routeScheduleDetailParam ? this.routeScheduleDetailParam.toJSON() : <any>undefined;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        if (Array.isArray(this.orderStatusId)) {
            data["orderStatusId"] = [];
            for (let item of this.orderStatusId)
                data["orderStatusId"].push(item);
        }
        data["routeList"] = this.routeList ? this.routeList.toJSON() : <any>undefined;
        data["orderTypeId"] = this.orderTypeId;
        if (Array.isArray(this.routeTemplateResult)) {
            data["routeTemplateResult"] = [];
            for (let item of this.routeTemplateResult)
                data["routeTemplateResult"].push(item.toJSON());
        }
        data["testMode"] = this.testMode;
        if (Array.isArray(this.autoScheduleDetailResults)) {
            data["autoScheduleDetailResults"] = [];
            for (let item of this.autoScheduleDetailResults)
                data["autoScheduleDetailResults"].push(item.toJSON());
        }
        if (Array.isArray(this.autoSchedDetailETAs)) {
            data["autoSchedDetailETAs"] = [];
            for (let item of this.autoSchedDetailETAs)
                data["autoSchedDetailETAs"].push(item.toJSON());
        }
        if (Array.isArray(this.contactResults)) {
            data["contactResults"] = [];
            for (let item of this.contactResults)
                data["contactResults"].push(item.toJSON());
        }
        if (Array.isArray(this.addressResults)) {
            data["addressResults"] = [];
            for (let item of this.addressResults)
                data["addressResults"].push(item.toJSON());
        }
        if (Array.isArray(this.geocodeResults)) {
            data["geocodeResults"] = [];
            for (let item of this.geocodeResults)
                data["geocodeResults"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ILiveEtaInput {
    scheduleDetailId: number;
    isLaboratory: boolean;
    nextDay: boolean;
    dateTime: moment.Moment | undefined;
    routeScheduleDetailParam: RouteScheduleDetailParam | undefined;
    routeTemplate: CreateRouteTemplateClinicInput | undefined;
    orderStatusId: number[] | undefined;
    routeList: GetRoutesResultDto | undefined;
    orderTypeId: number;
    routeTemplateResult: RouteTemplateResult[] | undefined;
    testMode: boolean | undefined;
    autoScheduleDetailResults: AutoScheduleDetailResults[] | undefined;
    autoSchedDetailETAs: AutoSchedDetailETAs[] | undefined;
    contactResults: ContactResults[] | undefined;
    addressResults: AddressResults[] | undefined;
    geocodeResults: GeocodeResults[] | undefined;
}

export class LiveEtaResult implements ILiveEtaResult {
    liveEta!: moment.Moment;
    liveGoBackEta!: moment.Moment;

    constructor(data?: ILiveEtaResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.liveEta = data["liveEta"] ? moment(data["liveEta"].toString()) : <any>undefined;
            this.liveGoBackEta = data["liveGoBackEta"] ? moment(data["liveGoBackEta"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): LiveEtaResult {
        data = typeof data === 'object' ? data : {};
        let result = new LiveEtaResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["liveEta"] = this.liveEta ? this.liveEta.toISOString() : <any>undefined;
        data["liveGoBackEta"] = this.liveGoBackEta ? this.liveGoBackEta.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ILiveEtaResult {
    liveEta: moment.Moment;
    liveGoBackEta: moment.Moment;
}

export class UpdateEtaInput implements IUpdateEtaInput {
    routeId!: number;
    locationId!: number;
    routeTemplateId!: number;

    constructor(data?: IUpdateEtaInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.locationId = data["locationId"];
            this.routeTemplateId = data["routeTemplateId"];
        }
    }

    static fromJS(data: any): UpdateEtaInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateEtaInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["locationId"] = this.locationId;
        data["routeTemplateId"] = this.routeTemplateId;
        return data; 
    }
}

export interface IUpdateEtaInput {
    routeId: number;
    locationId: number;
    routeTemplateId: number;
}

export class RouteOptimizerRuleDto implements IRouteOptimizerRuleDto {
    timeForExecution!: moment.Moment | undefined;
    orderTypeId!: number | undefined;
    distance!: number | undefined;
    orderPosition!: number | undefined;
    routeOptimizerId!: number | undefined;
    orderStatusTypeId!: number | undefined;
    ruleType!: number | undefined;
    useGoogle!: boolean | undefined;
    id!: number;

    constructor(data?: IRouteOptimizerRuleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.timeForExecution = data["timeForExecution"] ? moment(data["timeForExecution"].toString()) : <any>undefined;
            this.orderTypeId = data["orderTypeId"];
            this.distance = data["distance"];
            this.orderPosition = data["orderPosition"];
            this.routeOptimizerId = data["routeOptimizerId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.ruleType = data["ruleType"];
            this.useGoogle = data["useGoogle"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteOptimizerRuleDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteOptimizerRuleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["timeForExecution"] = this.timeForExecution ? this.timeForExecution.toISOString() : <any>undefined;
        data["orderTypeId"] = this.orderTypeId;
        data["distance"] = this.distance;
        data["orderPosition"] = this.orderPosition;
        data["routeOptimizerId"] = this.routeOptimizerId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["ruleType"] = this.ruleType;
        data["useGoogle"] = this.useGoogle;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteOptimizerRuleDto {
    timeForExecution: moment.Moment | undefined;
    orderTypeId: number | undefined;
    distance: number | undefined;
    orderPosition: number | undefined;
    routeOptimizerId: number | undefined;
    orderStatusTypeId: number | undefined;
    ruleType: number | undefined;
    useGoogle: boolean | undefined;
    id: number;
}

export class GetRouteOptimizerRuleForViewDto implements IGetRouteOptimizerRuleForViewDto {
    routeOptimizerRule!: RouteOptimizerRuleDto | undefined;
    routeOptimizerName!: string | undefined;
    orderStatusTypeDescription!: string | undefined;

    constructor(data?: IGetRouteOptimizerRuleForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeOptimizerRule = data["routeOptimizerRule"] ? RouteOptimizerRuleDto.fromJS(data["routeOptimizerRule"]) : <any>undefined;
            this.routeOptimizerName = data["routeOptimizerName"];
            this.orderStatusTypeDescription = data["orderStatusTypeDescription"];
        }
    }

    static fromJS(data: any): GetRouteOptimizerRuleForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteOptimizerRuleForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeOptimizerRule"] = this.routeOptimizerRule ? this.routeOptimizerRule.toJSON() : <any>undefined;
        data["routeOptimizerName"] = this.routeOptimizerName;
        data["orderStatusTypeDescription"] = this.orderStatusTypeDescription;
        return data; 
    }
}

export interface IGetRouteOptimizerRuleForViewDto {
    routeOptimizerRule: RouteOptimizerRuleDto | undefined;
    routeOptimizerName: string | undefined;
    orderStatusTypeDescription: string | undefined;
}

export class PagedResultDtoOfGetRouteOptimizerRuleForViewDto implements IPagedResultDtoOfGetRouteOptimizerRuleForViewDto {
    totalCount!: number;
    items!: GetRouteOptimizerRuleForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteOptimizerRuleForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteOptimizerRuleForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteOptimizerRuleForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteOptimizerRuleForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteOptimizerRuleForViewDto {
    totalCount: number;
    items: GetRouteOptimizerRuleForViewDto[] | undefined;
}

export class CreateOrEditRouteOptimizerRuleDto implements ICreateOrEditRouteOptimizerRuleDto {
    timeForExecution!: moment.Moment | undefined;
    orderTypeId!: number | undefined;
    distance!: number | undefined;
    orderPosition!: number | undefined;
    routeOptimizerId!: number | undefined;
    orderStatusTypeId!: number | undefined;
    ruleType!: number | undefined;
    useGoogle!: boolean | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteOptimizerRuleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.timeForExecution = data["timeForExecution"] ? moment(data["timeForExecution"].toString()) : <any>undefined;
            this.orderTypeId = data["orderTypeId"];
            this.distance = data["distance"];
            this.orderPosition = data["orderPosition"];
            this.routeOptimizerId = data["routeOptimizerId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.ruleType = data["ruleType"];
            this.useGoogle = data["useGoogle"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteOptimizerRuleDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteOptimizerRuleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["timeForExecution"] = this.timeForExecution ? this.timeForExecution.toISOString() : <any>undefined;
        data["orderTypeId"] = this.orderTypeId;
        data["distance"] = this.distance;
        data["orderPosition"] = this.orderPosition;
        data["routeOptimizerId"] = this.routeOptimizerId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["ruleType"] = this.ruleType;
        data["useGoogle"] = this.useGoogle;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteOptimizerRuleDto {
    timeForExecution: moment.Moment | undefined;
    orderTypeId: number | undefined;
    distance: number | undefined;
    orderPosition: number | undefined;
    routeOptimizerId: number | undefined;
    orderStatusTypeId: number | undefined;
    ruleType: number | undefined;
    useGoogle: boolean | undefined;
    id: number | undefined;
}

export class GetRouteOptimizerRuleForEditOutput implements IGetRouteOptimizerRuleForEditOutput {
    routeOptimizerRule!: CreateOrEditRouteOptimizerRuleDto | undefined;
    routeOptimizerName!: string | undefined;
    orderStatusTypeDescription!: string | undefined;

    constructor(data?: IGetRouteOptimizerRuleForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeOptimizerRule = data["routeOptimizerRule"] ? CreateOrEditRouteOptimizerRuleDto.fromJS(data["routeOptimizerRule"]) : <any>undefined;
            this.routeOptimizerName = data["routeOptimizerName"];
            this.orderStatusTypeDescription = data["orderStatusTypeDescription"];
        }
    }

    static fromJS(data: any): GetRouteOptimizerRuleForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteOptimizerRuleForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeOptimizerRule"] = this.routeOptimizerRule ? this.routeOptimizerRule.toJSON() : <any>undefined;
        data["routeOptimizerName"] = this.routeOptimizerName;
        data["orderStatusTypeDescription"] = this.orderStatusTypeDescription;
        return data; 
    }
}

export interface IGetRouteOptimizerRuleForEditOutput {
    routeOptimizerRule: CreateOrEditRouteOptimizerRuleDto | undefined;
    routeOptimizerName: string | undefined;
    orderStatusTypeDescription: string | undefined;
}

export class RouteOptimizerRuleRouteOptimizerLookupTableDto implements IRouteOptimizerRuleRouteOptimizerLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IRouteOptimizerRuleRouteOptimizerLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): RouteOptimizerRuleRouteOptimizerLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteOptimizerRuleRouteOptimizerLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IRouteOptimizerRuleRouteOptimizerLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class RouteOptimizerRuleOrderStatusTypeLookupTableDto implements IRouteOptimizerRuleOrderStatusTypeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IRouteOptimizerRuleOrderStatusTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): RouteOptimizerRuleOrderStatusTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteOptimizerRuleOrderStatusTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IRouteOptimizerRuleOrderStatusTypeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class RouteOptimizerDto implements IRouteOptimizerDto {
    name!: string | undefined;
    toll!: boolean;
    highways!: boolean;
    ferries!: boolean;
    indoor!: boolean;
    active!: boolean;
    withTraffic!: boolean;
    startPeriod!: moment.Moment;
    endPeriod!: moment.Moment;
    indefinite!: boolean;
    locationId!: number | undefined;
    id!: number;

    constructor(data?: IRouteOptimizerDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.toll = data["toll"];
            this.highways = data["highways"];
            this.ferries = data["ferries"];
            this.indoor = data["indoor"];
            this.active = data["active"];
            this.withTraffic = data["withTraffic"];
            this.startPeriod = data["startPeriod"] ? moment(data["startPeriod"].toString()) : <any>undefined;
            this.endPeriod = data["endPeriod"] ? moment(data["endPeriod"].toString()) : <any>undefined;
            this.indefinite = data["indefinite"];
            this.locationId = data["locationId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteOptimizerDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteOptimizerDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["toll"] = this.toll;
        data["highways"] = this.highways;
        data["ferries"] = this.ferries;
        data["indoor"] = this.indoor;
        data["active"] = this.active;
        data["withTraffic"] = this.withTraffic;
        data["startPeriod"] = this.startPeriod ? this.startPeriod.toISOString() : <any>undefined;
        data["endPeriod"] = this.endPeriod ? this.endPeriod.toISOString() : <any>undefined;
        data["indefinite"] = this.indefinite;
        data["locationId"] = this.locationId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteOptimizerDto {
    name: string | undefined;
    toll: boolean;
    highways: boolean;
    ferries: boolean;
    indoor: boolean;
    active: boolean;
    withTraffic: boolean;
    startPeriod: moment.Moment;
    endPeriod: moment.Moment;
    indefinite: boolean;
    locationId: number | undefined;
    id: number;
}

export class GetRouteOptimizerForViewDto implements IGetRouteOptimizerForViewDto {
    routeOptimizer!: RouteOptimizerDto | undefined;
    locationName!: string | undefined;

    constructor(data?: IGetRouteOptimizerForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeOptimizer = data["routeOptimizer"] ? RouteOptimizerDto.fromJS(data["routeOptimizer"]) : <any>undefined;
            this.locationName = data["locationName"];
        }
    }

    static fromJS(data: any): GetRouteOptimizerForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteOptimizerForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeOptimizer"] = this.routeOptimizer ? this.routeOptimizer.toJSON() : <any>undefined;
        data["locationName"] = this.locationName;
        return data; 
    }
}

export interface IGetRouteOptimizerForViewDto {
    routeOptimizer: RouteOptimizerDto | undefined;
    locationName: string | undefined;
}

export class PagedResultDtoOfGetRouteOptimizerForViewDto implements IPagedResultDtoOfGetRouteOptimizerForViewDto {
    totalCount!: number;
    items!: GetRouteOptimizerForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteOptimizerForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteOptimizerForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteOptimizerForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteOptimizerForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteOptimizerForViewDto {
    totalCount: number;
    items: GetRouteOptimizerForViewDto[] | undefined;
}

export class CreateOrEditRouteOptimizerDto implements ICreateOrEditRouteOptimizerDto {
    name!: string | undefined;
    toll!: boolean;
    highways!: boolean;
    ferries!: boolean;
    indoor!: boolean;
    withTraffic!: boolean;
    active!: boolean;
    indefinite!: boolean;
    startPeriod!: moment.Moment;
    endPeriod!: moment.Moment;
    locationId!: number | undefined;
    useGoogle!: boolean | undefined;
    optimizersRules!: CreateOrEditRouteOptimizerRuleDto[] | undefined;
    isDefault!: boolean;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteOptimizerDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.toll = data["toll"];
            this.highways = data["highways"];
            this.ferries = data["ferries"];
            this.indoor = data["indoor"];
            this.withTraffic = data["withTraffic"];
            this.active = data["active"];
            this.indefinite = data["indefinite"];
            this.startPeriod = data["startPeriod"] ? moment(data["startPeriod"].toString()) : <any>undefined;
            this.endPeriod = data["endPeriod"] ? moment(data["endPeriod"].toString()) : <any>undefined;
            this.locationId = data["locationId"];
            this.useGoogle = data["useGoogle"];
            if (Array.isArray(data["optimizersRules"])) {
                this.optimizersRules = [] as any;
                for (let item of data["optimizersRules"])
                    this.optimizersRules!.push(CreateOrEditRouteOptimizerRuleDto.fromJS(item));
            }
            this.isDefault = data["isDefault"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteOptimizerDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteOptimizerDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["toll"] = this.toll;
        data["highways"] = this.highways;
        data["ferries"] = this.ferries;
        data["indoor"] = this.indoor;
        data["withTraffic"] = this.withTraffic;
        data["active"] = this.active;
        data["indefinite"] = this.indefinite;
        data["startPeriod"] = this.startPeriod ? this.startPeriod.toISOString() : <any>undefined;
        data["endPeriod"] = this.endPeriod ? this.endPeriod.toISOString() : <any>undefined;
        data["locationId"] = this.locationId;
        data["useGoogle"] = this.useGoogle;
        if (Array.isArray(this.optimizersRules)) {
            data["optimizersRules"] = [];
            for (let item of this.optimizersRules)
                data["optimizersRules"].push(item.toJSON());
        }
        data["isDefault"] = this.isDefault;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteOptimizerDto {
    name: string | undefined;
    toll: boolean;
    highways: boolean;
    ferries: boolean;
    indoor: boolean;
    withTraffic: boolean;
    active: boolean;
    indefinite: boolean;
    startPeriod: moment.Moment;
    endPeriod: moment.Moment;
    locationId: number | undefined;
    useGoogle: boolean | undefined;
    optimizersRules: CreateOrEditRouteOptimizerRuleDto[] | undefined;
    isDefault: boolean;
    id: number | undefined;
}

export class RouteOptimizerLocationLookupTableDto implements IRouteOptimizerLocationLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IRouteOptimizerLocationLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): RouteOptimizerLocationLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteOptimizerLocationLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IRouteOptimizerLocationLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class GetRouteScheduleDetailForViewDto implements IGetRouteScheduleDetailForViewDto {
    routeScheduleDetail!: RouteScheduleDetailDto | undefined;
    routeScheduleClinicFk!: any | undefined;
    routeTemplateTypeName!: string | undefined;

    constructor(data?: IGetRouteScheduleDetailForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeScheduleDetail = data["routeScheduleDetail"] ? RouteScheduleDetailDto.fromJS(data["routeScheduleDetail"]) : <any>undefined;
            this.routeScheduleClinicFk = data["routeScheduleClinicFk"];
            this.routeTemplateTypeName = data["routeTemplateTypeName"];
        }
    }

    static fromJS(data: any): GetRouteScheduleDetailForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteScheduleDetailForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeScheduleDetail"] = this.routeScheduleDetail ? this.routeScheduleDetail.toJSON() : <any>undefined;
        data["routeScheduleClinicFk"] = this.routeScheduleClinicFk;
        data["routeTemplateTypeName"] = this.routeTemplateTypeName;
        return data; 
    }
}

export interface IGetRouteScheduleDetailForViewDto {
    routeScheduleDetail: RouteScheduleDetailDto | undefined;
    routeScheduleClinicFk: any | undefined;
    routeTemplateTypeName: string | undefined;
}

export class PagedResultDtoOfGetRouteScheduleDetailForViewDto implements IPagedResultDtoOfGetRouteScheduleDetailForViewDto {
    totalCount!: number;
    items!: GetRouteScheduleDetailForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteScheduleDetailForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteScheduleDetailForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteScheduleDetailForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteScheduleDetailForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteScheduleDetailForViewDto {
    totalCount: number;
    items: GetRouteScheduleDetailForViewDto[] | undefined;
}

export class CreateOrEditRouteScheduleDto implements ICreateOrEditRouteScheduleDto {
    clinicId!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteScheduleDto {
    clinicId: number;
    id: number | undefined;
}

export class CreateOrEditRouteScheduleDetailDto implements ICreateOrEditRouteScheduleDetailDto {
    routeCode!: string;
    estimatedTimeOfArrival!: moment.Moment | undefined;
    cutOff!: string | undefined;
    etaTime!: string | undefined;
    mondayETATime!: string | undefined;
    tuesdayETATime!: string | undefined;
    wednesdayETATime!: string | undefined;
    thursdayETATime!: string | undefined;
    fridayETATime!: string | undefined;
    saturdayETATime!: string | undefined;
    sundayETATime!: string | undefined;
    cutOffTime!: string | undefined;
    mondayCutOffTime!: string | undefined;
    tuesdayCutOffTime!: string | undefined;
    wednesdayCutOffTime!: string | undefined;
    thursdayCutOffTime!: string | undefined;
    fridayCutOffTime!: string | undefined;
    saturdayCutOffTime!: string | undefined;
    sundayCutOffTime!: string | undefined;
    monIsLTA!: boolean | undefined;
    tueIsLTA!: boolean | undefined;
    wedIsLTA!: boolean | undefined;
    thuIsLTA!: boolean | undefined;
    friIsLTA!: boolean | undefined;
    satIsLTA!: boolean | undefined;
    sunIsLTA!: boolean | undefined;
    mondayLTA!: string | undefined;
    tuesdayLTA!: string | undefined;
    wednesdayLTA!: string | undefined;
    thursdayLTA!: string | undefined;
    fridayLTA!: string | undefined;
    saturdayLTA!: string | undefined;
    sundayLTA!: string | undefined;
    mondayIsActive!: boolean | undefined;
    tuesdayIsActive!: boolean | undefined;
    wednesdayIsActive!: boolean | undefined;
    thursdayIsActive!: boolean | undefined;
    fridayIsActive!: boolean | undefined;
    saturdayIsActive!: boolean | undefined;
    sundayIsActive!: boolean | undefined;
    mondayIsAuto!: number | undefined;
    tuesdayIsAuto!: number | undefined;
    wednesdayIsAuto!: number | undefined;
    thursdayIsAuto!: number | undefined;
    fridayIsAuto!: number | undefined;
    saturdayIsAuto!: number | undefined;
    sundayIsAuto!: number | undefined;
    serviceTime!: number | undefined;
    timeWindowEnd!: number | undefined;
    timeWindowStart!: number | undefined;
    automatic!: boolean | undefined;
    willCall!: boolean | undefined;
    designation!: string | undefined;
    oorRate!: number | undefined;
    rate!: number | undefined;
    effectivityDate!: moment.Moment;
    isAntrimRequest!: boolean | undefined;
    routeTypeId!: number;
    isActive!: boolean;
    dateEtaLocked!: moment.Moment | undefined;
    locationId!: number | undefined;
    routeTemplateId!: number | undefined;
    clinicId!: number | undefined;
    createRouteSchedule!: CreateOrEditRouteScheduleDto | undefined;
    scheduleSetting!: GetRouteScheduleSettingsItemDto[] | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteScheduleDetailDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeCode = data["routeCode"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"] ? moment(data["estimatedTimeOfArrival"].toString()) : <any>undefined;
            this.cutOff = data["cutOff"];
            this.etaTime = data["etaTime"];
            this.mondayETATime = data["mondayETATime"];
            this.tuesdayETATime = data["tuesdayETATime"];
            this.wednesdayETATime = data["wednesdayETATime"];
            this.thursdayETATime = data["thursdayETATime"];
            this.fridayETATime = data["fridayETATime"];
            this.saturdayETATime = data["saturdayETATime"];
            this.sundayETATime = data["sundayETATime"];
            this.cutOffTime = data["cutOffTime"];
            this.mondayCutOffTime = data["mondayCutOffTime"];
            this.tuesdayCutOffTime = data["tuesdayCutOffTime"];
            this.wednesdayCutOffTime = data["wednesdayCutOffTime"];
            this.thursdayCutOffTime = data["thursdayCutOffTime"];
            this.fridayCutOffTime = data["fridayCutOffTime"];
            this.saturdayCutOffTime = data["saturdayCutOffTime"];
            this.sundayCutOffTime = data["sundayCutOffTime"];
            this.monIsLTA = data["monIsLTA"];
            this.tueIsLTA = data["tueIsLTA"];
            this.wedIsLTA = data["wedIsLTA"];
            this.thuIsLTA = data["thuIsLTA"];
            this.friIsLTA = data["friIsLTA"];
            this.satIsLTA = data["satIsLTA"];
            this.sunIsLTA = data["sunIsLTA"];
            this.mondayLTA = data["mondayLTA"];
            this.tuesdayLTA = data["tuesdayLTA"];
            this.wednesdayLTA = data["wednesdayLTA"];
            this.thursdayLTA = data["thursdayLTA"];
            this.fridayLTA = data["fridayLTA"];
            this.saturdayLTA = data["saturdayLTA"];
            this.sundayLTA = data["sundayLTA"];
            this.mondayIsActive = data["mondayIsActive"];
            this.tuesdayIsActive = data["tuesdayIsActive"];
            this.wednesdayIsActive = data["wednesdayIsActive"];
            this.thursdayIsActive = data["thursdayIsActive"];
            this.fridayIsActive = data["fridayIsActive"];
            this.saturdayIsActive = data["saturdayIsActive"];
            this.sundayIsActive = data["sundayIsActive"];
            this.mondayIsAuto = data["mondayIsAuto"];
            this.tuesdayIsAuto = data["tuesdayIsAuto"];
            this.wednesdayIsAuto = data["wednesdayIsAuto"];
            this.thursdayIsAuto = data["thursdayIsAuto"];
            this.fridayIsAuto = data["fridayIsAuto"];
            this.saturdayIsAuto = data["saturdayIsAuto"];
            this.sundayIsAuto = data["sundayIsAuto"];
            this.serviceTime = data["serviceTime"];
            this.timeWindowEnd = data["timeWindowEnd"];
            this.timeWindowStart = data["timeWindowStart"];
            this.automatic = data["automatic"];
            this.willCall = data["willCall"];
            this.designation = data["designation"];
            this.oorRate = data["oorRate"];
            this.rate = data["rate"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.isAntrimRequest = data["isAntrimRequest"];
            this.routeTypeId = data["routeTypeId"];
            this.isActive = data["isActive"];
            this.dateEtaLocked = data["dateEtaLocked"] ? moment(data["dateEtaLocked"].toString()) : <any>undefined;
            this.locationId = data["locationId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.clinicId = data["clinicId"];
            this.createRouteSchedule = data["createRouteSchedule"] ? CreateOrEditRouteScheduleDto.fromJS(data["createRouteSchedule"]) : <any>undefined;
            if (Array.isArray(data["scheduleSetting"])) {
                this.scheduleSetting = [] as any;
                for (let item of data["scheduleSetting"])
                    this.scheduleSetting!.push(GetRouteScheduleSettingsItemDto.fromJS(item));
            }
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteScheduleDetailDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteScheduleDetailDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeCode"] = this.routeCode;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival ? this.estimatedTimeOfArrival.toISOString() : <any>undefined;
        data["cutOff"] = this.cutOff;
        data["etaTime"] = this.etaTime;
        data["mondayETATime"] = this.mondayETATime;
        data["tuesdayETATime"] = this.tuesdayETATime;
        data["wednesdayETATime"] = this.wednesdayETATime;
        data["thursdayETATime"] = this.thursdayETATime;
        data["fridayETATime"] = this.fridayETATime;
        data["saturdayETATime"] = this.saturdayETATime;
        data["sundayETATime"] = this.sundayETATime;
        data["cutOffTime"] = this.cutOffTime;
        data["mondayCutOffTime"] = this.mondayCutOffTime;
        data["tuesdayCutOffTime"] = this.tuesdayCutOffTime;
        data["wednesdayCutOffTime"] = this.wednesdayCutOffTime;
        data["thursdayCutOffTime"] = this.thursdayCutOffTime;
        data["fridayCutOffTime"] = this.fridayCutOffTime;
        data["saturdayCutOffTime"] = this.saturdayCutOffTime;
        data["sundayCutOffTime"] = this.sundayCutOffTime;
        data["monIsLTA"] = this.monIsLTA;
        data["tueIsLTA"] = this.tueIsLTA;
        data["wedIsLTA"] = this.wedIsLTA;
        data["thuIsLTA"] = this.thuIsLTA;
        data["friIsLTA"] = this.friIsLTA;
        data["satIsLTA"] = this.satIsLTA;
        data["sunIsLTA"] = this.sunIsLTA;
        data["mondayLTA"] = this.mondayLTA;
        data["tuesdayLTA"] = this.tuesdayLTA;
        data["wednesdayLTA"] = this.wednesdayLTA;
        data["thursdayLTA"] = this.thursdayLTA;
        data["fridayLTA"] = this.fridayLTA;
        data["saturdayLTA"] = this.saturdayLTA;
        data["sundayLTA"] = this.sundayLTA;
        data["mondayIsActive"] = this.mondayIsActive;
        data["tuesdayIsActive"] = this.tuesdayIsActive;
        data["wednesdayIsActive"] = this.wednesdayIsActive;
        data["thursdayIsActive"] = this.thursdayIsActive;
        data["fridayIsActive"] = this.fridayIsActive;
        data["saturdayIsActive"] = this.saturdayIsActive;
        data["sundayIsActive"] = this.sundayIsActive;
        data["mondayIsAuto"] = this.mondayIsAuto;
        data["tuesdayIsAuto"] = this.tuesdayIsAuto;
        data["wednesdayIsAuto"] = this.wednesdayIsAuto;
        data["thursdayIsAuto"] = this.thursdayIsAuto;
        data["fridayIsAuto"] = this.fridayIsAuto;
        data["saturdayIsAuto"] = this.saturdayIsAuto;
        data["sundayIsAuto"] = this.sundayIsAuto;
        data["serviceTime"] = this.serviceTime;
        data["timeWindowEnd"] = this.timeWindowEnd;
        data["timeWindowStart"] = this.timeWindowStart;
        data["automatic"] = this.automatic;
        data["willCall"] = this.willCall;
        data["designation"] = this.designation;
        data["oorRate"] = this.oorRate;
        data["rate"] = this.rate;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["isAntrimRequest"] = this.isAntrimRequest;
        data["routeTypeId"] = this.routeTypeId;
        data["isActive"] = this.isActive;
        data["dateEtaLocked"] = this.dateEtaLocked ? this.dateEtaLocked.toISOString() : <any>undefined;
        data["locationId"] = this.locationId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["clinicId"] = this.clinicId;
        data["createRouteSchedule"] = this.createRouteSchedule ? this.createRouteSchedule.toJSON() : <any>undefined;
        if (Array.isArray(this.scheduleSetting)) {
            data["scheduleSetting"] = [];
            for (let item of this.scheduleSetting)
                data["scheduleSetting"].push(item.toJSON());
        }
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteScheduleDetailDto {
    routeCode: string;
    estimatedTimeOfArrival: moment.Moment | undefined;
    cutOff: string | undefined;
    etaTime: string | undefined;
    mondayETATime: string | undefined;
    tuesdayETATime: string | undefined;
    wednesdayETATime: string | undefined;
    thursdayETATime: string | undefined;
    fridayETATime: string | undefined;
    saturdayETATime: string | undefined;
    sundayETATime: string | undefined;
    cutOffTime: string | undefined;
    mondayCutOffTime: string | undefined;
    tuesdayCutOffTime: string | undefined;
    wednesdayCutOffTime: string | undefined;
    thursdayCutOffTime: string | undefined;
    fridayCutOffTime: string | undefined;
    saturdayCutOffTime: string | undefined;
    sundayCutOffTime: string | undefined;
    monIsLTA: boolean | undefined;
    tueIsLTA: boolean | undefined;
    wedIsLTA: boolean | undefined;
    thuIsLTA: boolean | undefined;
    friIsLTA: boolean | undefined;
    satIsLTA: boolean | undefined;
    sunIsLTA: boolean | undefined;
    mondayLTA: string | undefined;
    tuesdayLTA: string | undefined;
    wednesdayLTA: string | undefined;
    thursdayLTA: string | undefined;
    fridayLTA: string | undefined;
    saturdayLTA: string | undefined;
    sundayLTA: string | undefined;
    mondayIsActive: boolean | undefined;
    tuesdayIsActive: boolean | undefined;
    wednesdayIsActive: boolean | undefined;
    thursdayIsActive: boolean | undefined;
    fridayIsActive: boolean | undefined;
    saturdayIsActive: boolean | undefined;
    sundayIsActive: boolean | undefined;
    mondayIsAuto: number | undefined;
    tuesdayIsAuto: number | undefined;
    wednesdayIsAuto: number | undefined;
    thursdayIsAuto: number | undefined;
    fridayIsAuto: number | undefined;
    saturdayIsAuto: number | undefined;
    sundayIsAuto: number | undefined;
    serviceTime: number | undefined;
    timeWindowEnd: number | undefined;
    timeWindowStart: number | undefined;
    automatic: boolean | undefined;
    willCall: boolean | undefined;
    designation: string | undefined;
    oorRate: number | undefined;
    rate: number | undefined;
    effectivityDate: moment.Moment;
    isAntrimRequest: boolean | undefined;
    routeTypeId: number;
    isActive: boolean;
    dateEtaLocked: moment.Moment | undefined;
    locationId: number | undefined;
    routeTemplateId: number | undefined;
    clinicId: number | undefined;
    createRouteSchedule: CreateOrEditRouteScheduleDto | undefined;
    scheduleSetting: GetRouteScheduleSettingsItemDto[] | undefined;
    id: number | undefined;
}

export class GetRouteScheduleDetailForEditOutput implements IGetRouteScheduleDetailForEditOutput {
    routeScheduleDetail!: CreateOrEditRouteScheduleDetailDto | undefined;

    constructor(data?: IGetRouteScheduleDetailForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeScheduleDetail = data["routeScheduleDetail"] ? CreateOrEditRouteScheduleDetailDto.fromJS(data["routeScheduleDetail"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteScheduleDetailForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteScheduleDetailForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeScheduleDetail"] = this.routeScheduleDetail ? this.routeScheduleDetail.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteScheduleDetailForEditOutput {
    routeScheduleDetail: CreateOrEditRouteScheduleDetailDto | undefined;
}

export class CreateOrEditClinicScheduleDto implements ICreateOrEditClinicScheduleDto {
    scheduleInput!: CreateOrEditRouteScheduleDetailDto[] | undefined;
    newSchedule!: boolean | undefined;
    routeScheduleInput!: CreateOrEditRouteScheduleDto | undefined;
    updateScheduleInput!: CreateOrEditRouteScheduleDetailDto[] | undefined;
    updateClinicInput!: CreateOrEditClinicDto | undefined;

    constructor(data?: ICreateOrEditClinicScheduleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["scheduleInput"])) {
                this.scheduleInput = [] as any;
                for (let item of data["scheduleInput"])
                    this.scheduleInput!.push(CreateOrEditRouteScheduleDetailDto.fromJS(item));
            }
            this.newSchedule = data["newSchedule"];
            this.routeScheduleInput = data["routeScheduleInput"] ? CreateOrEditRouteScheduleDto.fromJS(data["routeScheduleInput"]) : <any>undefined;
            if (Array.isArray(data["updateScheduleInput"])) {
                this.updateScheduleInput = [] as any;
                for (let item of data["updateScheduleInput"])
                    this.updateScheduleInput!.push(CreateOrEditRouteScheduleDetailDto.fromJS(item));
            }
            this.updateClinicInput = data["updateClinicInput"] ? CreateOrEditClinicDto.fromJS(data["updateClinicInput"]) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateOrEditClinicScheduleDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditClinicScheduleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.scheduleInput)) {
            data["scheduleInput"] = [];
            for (let item of this.scheduleInput)
                data["scheduleInput"].push(item.toJSON());
        }
        data["newSchedule"] = this.newSchedule;
        data["routeScheduleInput"] = this.routeScheduleInput ? this.routeScheduleInput.toJSON() : <any>undefined;
        if (Array.isArray(this.updateScheduleInput)) {
            data["updateScheduleInput"] = [];
            for (let item of this.updateScheduleInput)
                data["updateScheduleInput"].push(item.toJSON());
        }
        data["updateClinicInput"] = this.updateClinicInput ? this.updateClinicInput.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ICreateOrEditClinicScheduleDto {
    scheduleInput: CreateOrEditRouteScheduleDetailDto[] | undefined;
    newSchedule: boolean | undefined;
    routeScheduleInput: CreateOrEditRouteScheduleDto | undefined;
    updateScheduleInput: CreateOrEditRouteScheduleDetailDto[] | undefined;
    updateClinicInput: CreateOrEditClinicDto | undefined;
}

export class GetRouteScheduleForViewDto implements IGetRouteScheduleForViewDto {
    routeSchedule!: RouteScheduleDto | undefined;

    constructor(data?: IGetRouteScheduleForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeSchedule = data["routeSchedule"] ? RouteScheduleDto.fromJS(data["routeSchedule"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteScheduleForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteScheduleForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeSchedule"] = this.routeSchedule ? this.routeSchedule.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteScheduleForViewDto {
    routeSchedule: RouteScheduleDto | undefined;
}

export class PagedResultDtoOfGetRouteScheduleForViewDto implements IPagedResultDtoOfGetRouteScheduleForViewDto {
    totalCount!: number;
    items!: GetRouteScheduleForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteScheduleForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteScheduleForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteScheduleForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteScheduleForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteScheduleForViewDto {
    totalCount: number;
    items: GetRouteScheduleForViewDto[] | undefined;
}

export class GetRouteScheduleForEditOutput implements IGetRouteScheduleForEditOutput {
    routeSchedule!: CreateOrEditRouteScheduleDto | undefined;

    constructor(data?: IGetRouteScheduleForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeSchedule = data["routeSchedule"] ? CreateOrEditRouteScheduleDto.fromJS(data["routeSchedule"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteScheduleForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteScheduleForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeSchedule"] = this.routeSchedule ? this.routeSchedule.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteScheduleForEditOutput {
    routeSchedule: CreateOrEditRouteScheduleDto | undefined;
}

export class CreateForRouteScheduleInputDto implements ICreateForRouteScheduleInputDto {
    routeScheduleDetailId!: number;
    code!: string | undefined;
    value!: string | undefined;

    constructor(data?: ICreateForRouteScheduleInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.code = data["code"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreateForRouteScheduleInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateForRouteScheduleInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["code"] = this.code;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreateForRouteScheduleInputDto {
    routeScheduleDetailId: number;
    code: string | undefined;
    value: string | undefined;
}

export class LogDto implements ILogDto {
    jobId!: string | undefined;
    status!: Status;
    loadDate!: moment.Moment;
    attempt!: number;
    parameters!: string | undefined;
    result!: string | undefined;
    tenantId!: number | undefined;
    end!: boolean;

    constructor(data?: ILogDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.jobId = data["jobId"];
            this.status = data["status"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.attempt = data["attempt"];
            this.parameters = data["parameters"];
            this.result = data["result"];
            this.tenantId = data["tenantId"];
            this.end = data["end"];
        }
    }

    static fromJS(data: any): LogDto {
        data = typeof data === 'object' ? data : {};
        let result = new LogDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["jobId"] = this.jobId;
        data["status"] = this.status;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["attempt"] = this.attempt;
        data["parameters"] = this.parameters;
        data["result"] = this.result;
        data["tenantId"] = this.tenantId;
        data["end"] = this.end;
        return data; 
    }
}

export interface ILogDto {
    jobId: string | undefined;
    status: Status;
    loadDate: moment.Moment;
    attempt: number;
    parameters: string | undefined;
    result: string | undefined;
    tenantId: number | undefined;
    end: boolean;
}

export class TimeZoneInfo implements ITimeZoneInfo {
    readonly id!: string | undefined;
    readonly displayName!: string | undefined;
    readonly standardName!: string | undefined;
    readonly daylightName!: string | undefined;
    readonly baseUtcOffset!: TimeSpan;
    readonly supportsDaylightSavingTime!: boolean;

    constructor(data?: ITimeZoneInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).id = data["id"];
            (<any>this).displayName = data["displayName"];
            (<any>this).standardName = data["standardName"];
            (<any>this).daylightName = data["daylightName"];
            (<any>this).baseUtcOffset = data["baseUtcOffset"] ? TimeSpan.fromJS(data["baseUtcOffset"]) : <any>undefined;
            (<any>this).supportsDaylightSavingTime = data["supportsDaylightSavingTime"];
        }
    }

    static fromJS(data: any): TimeZoneInfo {
        data = typeof data === 'object' ? data : {};
        let result = new TimeZoneInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        data["standardName"] = this.standardName;
        data["daylightName"] = this.daylightName;
        data["baseUtcOffset"] = this.baseUtcOffset ? this.baseUtcOffset.toJSON() : <any>undefined;
        data["supportsDaylightSavingTime"] = this.supportsDaylightSavingTime;
        return data; 
    }
}

export interface ITimeZoneInfo {
    id: string | undefined;
    displayName: string | undefined;
    standardName: string | undefined;
    daylightName: string | undefined;
    baseUtcOffset: TimeSpan;
    supportsDaylightSavingTime: boolean;
}

export class LoadDateDto implements ILoadDateDto {
    loadDate!: string | undefined;
    loadDateLocal!: string | undefined;
    locationTimezoneId!: TimeZoneInfo | undefined;

    constructor(data?: ILoadDateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.loadDate = data["loadDate"];
            this.loadDateLocal = data["loadDateLocal"];
            this.locationTimezoneId = data["locationTimezoneId"] ? TimeZoneInfo.fromJS(data["locationTimezoneId"]) : <any>undefined;
        }
    }

    static fromJS(data: any): LoadDateDto {
        data = typeof data === 'object' ? data : {};
        let result = new LoadDateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["loadDate"] = this.loadDate;
        data["loadDateLocal"] = this.loadDateLocal;
        data["locationTimezoneId"] = this.locationTimezoneId ? this.locationTimezoneId.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ILoadDateDto {
    loadDate: string | undefined;
    loadDateLocal: string | undefined;
    locationTimezoneId: TimeZoneInfo | undefined;
}

export class LocationManager implements ILocationManager {

    constructor(data?: ILocationManager) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): LocationManager {
        data = typeof data === 'object' ? data : {};
        let result = new LocationManager();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface ILocationManager {
}

export class GenerateRemainingDto implements IGenerateRemainingDto {
    job!: Type | undefined;
    jobIdStr!: string | undefined;
    edition!: any | undefined;
    generateDto!: GenerateDto | undefined;
    loadDateDto!: LoadDateDto | undefined;
    tenant!: Tenant | undefined;
    tenantName!: string | undefined;
    locManager!: LocationManager | undefined;
    currentUserId!: number;
    toOptimizeRouteIds!: number[] | undefined;

    constructor(data?: IGenerateRemainingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.job = data["job"] ? Type.fromJS(data["job"]) : <any>undefined;
            this.jobIdStr = data["jobIdStr"];
            this.edition = data["edition"];
            this.generateDto = data["generateDto"] ? GenerateDto.fromJS(data["generateDto"]) : <any>undefined;
            this.loadDateDto = data["loadDateDto"] ? LoadDateDto.fromJS(data["loadDateDto"]) : <any>undefined;
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.tenantName = data["tenantName"];
            this.locManager = data["locManager"] ? LocationManager.fromJS(data["locManager"]) : <any>undefined;
            this.currentUserId = data["currentUserId"];
            if (Array.isArray(data["toOptimizeRouteIds"])) {
                this.toOptimizeRouteIds = [] as any;
                for (let item of data["toOptimizeRouteIds"])
                    this.toOptimizeRouteIds!.push(item);
            }
        }
    }

    static fromJS(data: any): GenerateRemainingDto {
        data = typeof data === 'object' ? data : {};
        let result = new GenerateRemainingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["job"] = this.job ? this.job.toJSON() : <any>undefined;
        data["jobIdStr"] = this.jobIdStr;
        data["edition"] = this.edition;
        data["generateDto"] = this.generateDto ? this.generateDto.toJSON() : <any>undefined;
        data["loadDateDto"] = this.loadDateDto ? this.loadDateDto.toJSON() : <any>undefined;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["tenantName"] = this.tenantName;
        data["locManager"] = this.locManager ? this.locManager.toJSON() : <any>undefined;
        data["currentUserId"] = this.currentUserId;
        if (Array.isArray(this.toOptimizeRouteIds)) {
            data["toOptimizeRouteIds"] = [];
            for (let item of this.toOptimizeRouteIds)
                data["toOptimizeRouteIds"].push(item);
        }
        return data; 
    }
}

export interface IGenerateRemainingDto {
    job: Type | undefined;
    jobIdStr: string | undefined;
    edition: any | undefined;
    generateDto: GenerateDto | undefined;
    loadDateDto: LoadDateDto | undefined;
    tenant: Tenant | undefined;
    tenantName: string | undefined;
    locManager: LocationManager | undefined;
    currentUserId: number;
    toOptimizeRouteIds: number[] | undefined;
}

export class RunOptimizerDto implements IRunOptimizerDto {
    locationId!: number;
    tenantId!: number;
    currentUserId!: number;
    loadDateStr!: string | undefined;
    isMoved!: boolean | undefined;
    toOptimizeRouteIds!: number[] | undefined;

    constructor(data?: IRunOptimizerDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.tenantId = data["tenantId"];
            this.currentUserId = data["currentUserId"];
            this.loadDateStr = data["loadDateStr"];
            this.isMoved = data["isMoved"];
            if (Array.isArray(data["toOptimizeRouteIds"])) {
                this.toOptimizeRouteIds = [] as any;
                for (let item of data["toOptimizeRouteIds"])
                    this.toOptimizeRouteIds!.push(item);
            }
        }
    }

    static fromJS(data: any): RunOptimizerDto {
        data = typeof data === 'object' ? data : {};
        let result = new RunOptimizerDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["tenantId"] = this.tenantId;
        data["currentUserId"] = this.currentUserId;
        data["loadDateStr"] = this.loadDateStr;
        data["isMoved"] = this.isMoved;
        if (Array.isArray(this.toOptimizeRouteIds)) {
            data["toOptimizeRouteIds"] = [];
            for (let item of this.toOptimizeRouteIds)
                data["toOptimizeRouteIds"].push(item);
        }
        return data; 
    }
}

export interface IRunOptimizerDto {
    locationId: number;
    tenantId: number;
    currentUserId: number;
    loadDateStr: string | undefined;
    isMoved: boolean | undefined;
    toOptimizeRouteIds: number[] | undefined;
}

export enum StopTypeCode {
    StartPoint = 0,
    MeetPoint = 1,
    EndPoint = 2,
}

export class RouteStopDto implements IRouteStopDto {
    contactId!: number | undefined;
    company!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    postalCode!: string | undefined;
    latitude!: string | undefined;
    longitude!: string | undefined;
    location!: string | undefined;
    stopType!: string | undefined;
    locationId!: number | undefined;
    id!: number;

    constructor(data?: IRouteStopDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.company = data["company"];
            this.city = data["city"];
            this.state = data["state"];
            this.postalCode = data["postalCode"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.location = data["location"];
            this.stopType = data["stopType"];
            this.locationId = data["locationId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteStopDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteStopDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["company"] = this.company;
        data["city"] = this.city;
        data["state"] = this.state;
        data["postalCode"] = this.postalCode;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["location"] = this.location;
        data["stopType"] = this.stopType;
        data["locationId"] = this.locationId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteStopDto {
    contactId: number | undefined;
    company: string | undefined;
    city: string | undefined;
    state: string | undefined;
    postalCode: string | undefined;
    latitude: string | undefined;
    longitude: string | undefined;
    location: string | undefined;
    stopType: string | undefined;
    locationId: number | undefined;
    id: number;
}

export class GetRouteStopForViewDto implements IGetRouteStopForViewDto {
    routeStop!: RouteStopDto | undefined;
    contactAddress!: string | undefined;
    contactName!: string | undefined;
    lat!: number | undefined;
    long!: number | undefined;

    constructor(data?: IGetRouteStopForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeStop = data["routeStop"] ? RouteStopDto.fromJS(data["routeStop"]) : <any>undefined;
            this.contactAddress = data["contactAddress"];
            this.contactName = data["contactName"];
            this.lat = data["lat"];
            this.long = data["long"];
        }
    }

    static fromJS(data: any): GetRouteStopForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteStopForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeStop"] = this.routeStop ? this.routeStop.toJSON() : <any>undefined;
        data["contactAddress"] = this.contactAddress;
        data["contactName"] = this.contactName;
        data["lat"] = this.lat;
        data["long"] = this.long;
        return data; 
    }
}

export interface IGetRouteStopForViewDto {
    routeStop: RouteStopDto | undefined;
    contactAddress: string | undefined;
    contactName: string | undefined;
    lat: number | undefined;
    long: number | undefined;
}

export class PagedResultDtoOfGetRouteStopForViewDto implements IPagedResultDtoOfGetRouteStopForViewDto {
    totalCount!: number;
    items!: GetRouteStopForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteStopForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteStopForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteStopForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteStopForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteStopForViewDto {
    totalCount: number;
    items: GetRouteStopForViewDto[] | undefined;
}

export class CreateOrEditRouteStopDto implements ICreateOrEditRouteStopDto {
    contactId!: number | undefined;
    routeStop!: string | undefined;
    contactPerson!: string | undefined;
    address!: CreateAddressInput | undefined;
    email!: string | undefined;
    latitude!: number;
    longitude!: number;
    locationId!: number | undefined;
    contactSetting!: GetContactSettingsItemDto[] | undefined;
    tenantId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteStopDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.routeStop = data["routeStop"];
            this.contactPerson = data["contactPerson"];
            this.address = data["address"] ? CreateAddressInput.fromJS(data["address"]) : <any>undefined;
            this.email = data["email"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.locationId = data["locationId"];
            if (Array.isArray(data["contactSetting"])) {
                this.contactSetting = [] as any;
                for (let item of data["contactSetting"])
                    this.contactSetting!.push(GetContactSettingsItemDto.fromJS(item));
            }
            this.tenantId = data["tenantId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteStopDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteStopDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["routeStop"] = this.routeStop;
        data["contactPerson"] = this.contactPerson;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["email"] = this.email;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["locationId"] = this.locationId;
        if (Array.isArray(this.contactSetting)) {
            data["contactSetting"] = [];
            for (let item of this.contactSetting)
                data["contactSetting"].push(item.toJSON());
        }
        data["tenantId"] = this.tenantId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteStopDto {
    contactId: number | undefined;
    routeStop: string | undefined;
    contactPerson: string | undefined;
    address: CreateAddressInput | undefined;
    email: string | undefined;
    latitude: number;
    longitude: number;
    locationId: number | undefined;
    contactSetting: GetContactSettingsItemDto[] | undefined;
    tenantId: number | undefined;
    id: number | undefined;
}

export class GetRouteStopForEditOutput implements IGetRouteStopForEditOutput {
    routeStop!: CreateOrEditRouteStopDto | undefined;

    constructor(data?: IGetRouteStopForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeStop = data["routeStop"] ? CreateOrEditRouteStopDto.fromJS(data["routeStop"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteStopForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteStopForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeStop"] = this.routeStop ? this.routeStop.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteStopForEditOutput {
    routeStop: CreateOrEditRouteStopDto | undefined;
}

export class RouteStopContactLookupTableDto implements IRouteStopContactLookupTableDto {
    id!: number;
    displayName!: string | undefined;
    address!: string | undefined;

    constructor(data?: IRouteStopContactLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
            this.address = data["address"];
        }
    }

    static fromJS(data: any): RouteStopContactLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteStopContactLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        data["address"] = this.address;
        return data; 
    }
}

export interface IRouteStopContactLookupTableDto {
    id: number;
    displayName: string | undefined;
    address: string | undefined;
}

export class PagedResultDtoOfRouteStopContactLookupTableDto implements IPagedResultDtoOfRouteStopContactLookupTableDto {
    totalCount!: number;
    items!: RouteStopContactLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRouteStopContactLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteStopContactLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRouteStopContactLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRouteStopContactLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRouteStopContactLookupTableDto {
    totalCount: number;
    items: RouteStopContactLookupTableDto[] | undefined;
}

export class GetAllRouteStopsInput implements IGetAllRouteStopsInput {
    filter!: string | undefined;
    locationNameFilter!: string | undefined;
    contactAddressFilter!: string | undefined;
    stopType!: StopTypeCode | undefined;
    isLinehaulSetup!: boolean;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetAllRouteStopsInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.filter = data["filter"];
            this.locationNameFilter = data["locationNameFilter"];
            this.contactAddressFilter = data["contactAddressFilter"];
            this.stopType = data["stopType"];
            this.isLinehaulSetup = data["isLinehaulSetup"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetAllRouteStopsInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllRouteStopsInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["filter"] = this.filter;
        data["locationNameFilter"] = this.locationNameFilter;
        data["contactAddressFilter"] = this.contactAddressFilter;
        data["stopType"] = this.stopType;
        data["isLinehaulSetup"] = this.isLinehaulSetup;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetAllRouteStopsInput {
    filter: string | undefined;
    locationNameFilter: string | undefined;
    contactAddressFilter: string | undefined;
    stopType: StopTypeCode | undefined;
    isLinehaulSetup: boolean;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class ListResultDtoOfGetRouteStopForViewDto implements IListResultDtoOfGetRouteStopForViewDto {
    items!: GetRouteStopForViewDto[] | undefined;

    constructor(data?: IListResultDtoOfGetRouteStopForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteStopForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetRouteStopForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetRouteStopForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetRouteStopForViewDto {
    items: GetRouteStopForViewDto[] | undefined;
}

export class PagedResultDtoOfRouteTemplateListDto implements IPagedResultDtoOfRouteTemplateListDto {
    totalCount!: number;
    items!: RouteTemplateListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRouteTemplateListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteTemplateListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRouteTemplateListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRouteTemplateListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRouteTemplateListDto {
    totalCount: number;
    items: RouteTemplateListDto[] | undefined;
}

export class CreateRouteTemplateInput implements ICreateRouteTemplateInput {
    name!: string;
    locationId!: number;
    routeTemplateTypeId!: number;
    startTime!: string | undefined;
    endTime!: string | undefined;
    defaultUserId!: number | undefined;
    routeStartContactId!: number | undefined;
    mondayDriverId!: number | undefined;
    tuesdayDriverId!: number | undefined;
    wednesdayDriverId!: number | undefined;
    thursdayDriverId!: number | undefined;
    fridayDriverId!: number | undefined;
    saturdayDriverId!: number | undefined;
    sundayDriverId!: number | undefined;
    mondayManagerId!: number | undefined;
    tuesdayManagerId!: number | undefined;
    wednesdayManagerId!: number | undefined;
    thursdayManagerId!: number | undefined;
    fridayManagerId!: number | undefined;
    saturdayManagerId!: number | undefined;
    sundayManagerId!: number | undefined;
    mondaySupervisorId!: number | undefined;
    tuesdaySupervisorId!: number | undefined;
    wednesdaySupervisorId!: number | undefined;
    thursdaySupervisorId!: number | undefined;
    fridaySupervisorId!: number | undefined;
    saturdaySupervisorId!: number | undefined;
    sundaySupervisorId!: number | undefined;
    defaultContactId!: number | undefined;

    constructor(data?: ICreateRouteTemplateInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.locationId = data["locationId"];
            this.routeTemplateTypeId = data["routeTemplateTypeId"];
            this.startTime = data["startTime"];
            this.endTime = data["endTime"];
            this.defaultUserId = data["defaultUserId"];
            this.routeStartContactId = data["routeStartContactId"];
            this.mondayDriverId = data["mondayDriverId"];
            this.tuesdayDriverId = data["tuesdayDriverId"];
            this.wednesdayDriverId = data["wednesdayDriverId"];
            this.thursdayDriverId = data["thursdayDriverId"];
            this.fridayDriverId = data["fridayDriverId"];
            this.saturdayDriverId = data["saturdayDriverId"];
            this.sundayDriverId = data["sundayDriverId"];
            this.mondayManagerId = data["mondayManagerId"];
            this.tuesdayManagerId = data["tuesdayManagerId"];
            this.wednesdayManagerId = data["wednesdayManagerId"];
            this.thursdayManagerId = data["thursdayManagerId"];
            this.fridayManagerId = data["fridayManagerId"];
            this.saturdayManagerId = data["saturdayManagerId"];
            this.sundayManagerId = data["sundayManagerId"];
            this.mondaySupervisorId = data["mondaySupervisorId"];
            this.tuesdaySupervisorId = data["tuesdaySupervisorId"];
            this.wednesdaySupervisorId = data["wednesdaySupervisorId"];
            this.thursdaySupervisorId = data["thursdaySupervisorId"];
            this.fridaySupervisorId = data["fridaySupervisorId"];
            this.saturdaySupervisorId = data["saturdaySupervisorId"];
            this.sundaySupervisorId = data["sundaySupervisorId"];
            this.defaultContactId = data["defaultContactId"];
        }
    }

    static fromJS(data: any): CreateRouteTemplateInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRouteTemplateInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["locationId"] = this.locationId;
        data["routeTemplateTypeId"] = this.routeTemplateTypeId;
        data["startTime"] = this.startTime;
        data["endTime"] = this.endTime;
        data["defaultUserId"] = this.defaultUserId;
        data["routeStartContactId"] = this.routeStartContactId;
        data["mondayDriverId"] = this.mondayDriverId;
        data["tuesdayDriverId"] = this.tuesdayDriverId;
        data["wednesdayDriverId"] = this.wednesdayDriverId;
        data["thursdayDriverId"] = this.thursdayDriverId;
        data["fridayDriverId"] = this.fridayDriverId;
        data["saturdayDriverId"] = this.saturdayDriverId;
        data["sundayDriverId"] = this.sundayDriverId;
        data["mondayManagerId"] = this.mondayManagerId;
        data["tuesdayManagerId"] = this.tuesdayManagerId;
        data["wednesdayManagerId"] = this.wednesdayManagerId;
        data["thursdayManagerId"] = this.thursdayManagerId;
        data["fridayManagerId"] = this.fridayManagerId;
        data["saturdayManagerId"] = this.saturdayManagerId;
        data["sundayManagerId"] = this.sundayManagerId;
        data["mondaySupervisorId"] = this.mondaySupervisorId;
        data["tuesdaySupervisorId"] = this.tuesdaySupervisorId;
        data["wednesdaySupervisorId"] = this.wednesdaySupervisorId;
        data["thursdaySupervisorId"] = this.thursdaySupervisorId;
        data["fridaySupervisorId"] = this.fridaySupervisorId;
        data["saturdaySupervisorId"] = this.saturdaySupervisorId;
        data["sundaySupervisorId"] = this.sundaySupervisorId;
        data["defaultContactId"] = this.defaultContactId;
        return data; 
    }
}

export interface ICreateRouteTemplateInput {
    name: string;
    locationId: number;
    routeTemplateTypeId: number;
    startTime: string | undefined;
    endTime: string | undefined;
    defaultUserId: number | undefined;
    routeStartContactId: number | undefined;
    mondayDriverId: number | undefined;
    tuesdayDriverId: number | undefined;
    wednesdayDriverId: number | undefined;
    thursdayDriverId: number | undefined;
    fridayDriverId: number | undefined;
    saturdayDriverId: number | undefined;
    sundayDriverId: number | undefined;
    mondayManagerId: number | undefined;
    tuesdayManagerId: number | undefined;
    wednesdayManagerId: number | undefined;
    thursdayManagerId: number | undefined;
    fridayManagerId: number | undefined;
    saturdayManagerId: number | undefined;
    sundayManagerId: number | undefined;
    mondaySupervisorId: number | undefined;
    tuesdaySupervisorId: number | undefined;
    wednesdaySupervisorId: number | undefined;
    thursdaySupervisorId: number | undefined;
    fridaySupervisorId: number | undefined;
    saturdaySupervisorId: number | undefined;
    sundaySupervisorId: number | undefined;
    defaultContactId: number | undefined;
}

export class UpdateRouteTemplateInput implements IUpdateRouteTemplateInput {
    id!: number;
    name!: string;
    locationId!: number;
    routeTemplateTypeId!: number;
    startTime!: string | undefined;
    endTime!: string | undefined;
    defaultUserId!: number | undefined;

    constructor(data?: IUpdateRouteTemplateInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.locationId = data["locationId"];
            this.routeTemplateTypeId = data["routeTemplateTypeId"];
            this.startTime = data["startTime"];
            this.endTime = data["endTime"];
            this.defaultUserId = data["defaultUserId"];
        }
    }

    static fromJS(data: any): UpdateRouteTemplateInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteTemplateInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["locationId"] = this.locationId;
        data["routeTemplateTypeId"] = this.routeTemplateTypeId;
        data["startTime"] = this.startTime;
        data["endTime"] = this.endTime;
        data["defaultUserId"] = this.defaultUserId;
        return data; 
    }
}

export interface IUpdateRouteTemplateInput {
    id: number;
    name: string;
    locationId: number;
    routeTemplateTypeId: number;
    startTime: string | undefined;
    endTime: string | undefined;
    defaultUserId: number | undefined;
}

export class GetRouteTemplateForView implements IGetRouteTemplateForView {
    routeTemplateName!: string | undefined;
    location!: string | undefined;
    routeTemplateId!: number | undefined;
    routeStartInactive!: boolean;

    constructor(data?: IGetRouteTemplateForView) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateName = data["routeTemplateName"];
            this.location = data["location"];
            this.routeTemplateId = data["routeTemplateId"];
            this.routeStartInactive = data["routeStartInactive"];
        }
    }

    static fromJS(data: any): GetRouteTemplateForView {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteTemplateForView();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateName"] = this.routeTemplateName;
        data["location"] = this.location;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeStartInactive"] = this.routeStartInactive;
        return data; 
    }
}

export interface IGetRouteTemplateForView {
    routeTemplateName: string | undefined;
    location: string | undefined;
    routeTemplateId: number | undefined;
    routeStartInactive: boolean;
}

export class RouteTemplateAddressListDto implements IRouteTemplateAddressListDto {
    tenantId!: number;
    routeTemplateId!: number;
    addressId!: number;
    sortOrder!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateAddressListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.addressId = data["addressId"];
            this.sortOrder = data["sortOrder"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateAddressListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateAddressListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["addressId"] = this.addressId;
        data["sortOrder"] = this.sortOrder;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateAddressListDto {
    tenantId: number;
    routeTemplateId: number;
    addressId: number;
    sortOrder: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ListResultDtoOfRouteTemplateAddressListDto implements IListResultDtoOfRouteTemplateAddressListDto {
    items!: RouteTemplateAddressListDto[] | undefined;

    constructor(data?: IListResultDtoOfRouteTemplateAddressListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteTemplateAddressListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfRouteTemplateAddressListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfRouteTemplateAddressListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfRouteTemplateAddressListDto {
    items: RouteTemplateAddressListDto[] | undefined;
}

export class CreateRouteTemplateAddressInput implements ICreateRouteTemplateAddressInput {
    routeTemplateId!: number;
    addressId!: number;
    sortOrder!: number;

    constructor(data?: ICreateRouteTemplateAddressInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateId = data["routeTemplateId"];
            this.addressId = data["addressId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): CreateRouteTemplateAddressInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRouteTemplateAddressInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateId"] = this.routeTemplateId;
        data["addressId"] = this.addressId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface ICreateRouteTemplateAddressInput {
    routeTemplateId: number;
    addressId: number;
    sortOrder: number;
}

export class UpdateRouteTemplateAddressInput implements IUpdateRouteTemplateAddressInput {
    id!: number;
    routeTemplateId!: number;
    addressId!: number;
    sortOrder!: number;

    constructor(data?: IUpdateRouteTemplateAddressInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeTemplateId = data["routeTemplateId"];
            this.addressId = data["addressId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): UpdateRouteTemplateAddressInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteTemplateAddressInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeTemplateId"] = this.routeTemplateId;
        data["addressId"] = this.addressId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IUpdateRouteTemplateAddressInput {
    id: number;
    routeTemplateId: number;
    addressId: number;
    sortOrder: number;
}

export class RouteTemplateOrderExtrasDto implements IRouteTemplateOrderExtrasDto {
    orderExtraKey!: string | undefined;
    orderExtraValue!: string | undefined;
    id!: number;

    constructor(data?: IRouteTemplateOrderExtrasDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderExtraKey = data["orderExtraKey"];
            this.orderExtraValue = data["orderExtraValue"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateOrderExtrasDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateOrderExtrasDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderExtraKey"] = this.orderExtraKey;
        data["orderExtraValue"] = this.orderExtraValue;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateOrderExtrasDto {
    orderExtraKey: string | undefined;
    orderExtraValue: string | undefined;
    id: number;
}

export class GetRouteTemplateOrderExtrasForViewDto implements IGetRouteTemplateOrderExtrasForViewDto {
    routeTemplateOrderExtras!: RouteTemplateOrderExtrasDto | undefined;

    constructor(data?: IGetRouteTemplateOrderExtrasForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateOrderExtras = data["routeTemplateOrderExtras"] ? RouteTemplateOrderExtrasDto.fromJS(data["routeTemplateOrderExtras"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteTemplateOrderExtrasForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteTemplateOrderExtrasForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateOrderExtras"] = this.routeTemplateOrderExtras ? this.routeTemplateOrderExtras.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteTemplateOrderExtrasForViewDto {
    routeTemplateOrderExtras: RouteTemplateOrderExtrasDto | undefined;
}

export class PagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto implements IPagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto {
    totalCount!: number;
    items!: GetRouteTemplateOrderExtrasForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteTemplateOrderExtrasForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteTemplateOrderExtrasForViewDto {
    totalCount: number;
    items: GetRouteTemplateOrderExtrasForViewDto[] | undefined;
}

export class CreateOrEditRouteTemplateOrderExtrasDto implements ICreateOrEditRouteTemplateOrderExtrasDto {
    routeTemplateId!: number;
    orderExtraKey!: string;
    orderExtraValue!: string;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteTemplateOrderExtrasDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateId = data["routeTemplateId"];
            this.orderExtraKey = data["orderExtraKey"];
            this.orderExtraValue = data["orderExtraValue"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteTemplateOrderExtrasDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteTemplateOrderExtrasDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateId"] = this.routeTemplateId;
        data["orderExtraKey"] = this.orderExtraKey;
        data["orderExtraValue"] = this.orderExtraValue;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteTemplateOrderExtrasDto {
    routeTemplateId: number;
    orderExtraKey: string;
    orderExtraValue: string;
    id: number | undefined;
}

export class GetRouteTemplateOrderExtrasForEditOutput implements IGetRouteTemplateOrderExtrasForEditOutput {
    routeTemplateOrderExtras!: CreateOrEditRouteTemplateOrderExtrasDto | undefined;

    constructor(data?: IGetRouteTemplateOrderExtrasForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateOrderExtras = data["routeTemplateOrderExtras"] ? CreateOrEditRouteTemplateOrderExtrasDto.fromJS(data["routeTemplateOrderExtras"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteTemplateOrderExtrasForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteTemplateOrderExtrasForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateOrderExtras"] = this.routeTemplateOrderExtras ? this.routeTemplateOrderExtras.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteTemplateOrderExtrasForEditOutput {
    routeTemplateOrderExtras: CreateOrEditRouteTemplateOrderExtrasDto | undefined;
}

export class RouteTemplateSortingRuleListDto implements IRouteTemplateSortingRuleListDto {
    tenantId!: number;
    routeTemplateId!: number;
    sortingRuleId!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateSortingRuleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.sortingRuleId = data["sortingRuleId"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateSortingRuleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateSortingRuleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortingRuleId"] = this.sortingRuleId;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateSortingRuleListDto {
    tenantId: number;
    routeTemplateId: number;
    sortingRuleId: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ListResultDtoOfRouteTemplateSortingRuleListDto implements IListResultDtoOfRouteTemplateSortingRuleListDto {
    items!: RouteTemplateSortingRuleListDto[] | undefined;

    constructor(data?: IListResultDtoOfRouteTemplateSortingRuleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteTemplateSortingRuleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfRouteTemplateSortingRuleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfRouteTemplateSortingRuleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfRouteTemplateSortingRuleListDto {
    items: RouteTemplateSortingRuleListDto[] | undefined;
}

export class CreateRouteTemplateSortingRuleInput implements ICreateRouteTemplateSortingRuleInput {
    routeTemplateId!: number;
    sortingRuleId!: number;

    constructor(data?: ICreateRouteTemplateSortingRuleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateId = data["routeTemplateId"];
            this.sortingRuleId = data["sortingRuleId"];
        }
    }

    static fromJS(data: any): CreateRouteTemplateSortingRuleInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRouteTemplateSortingRuleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortingRuleId"] = this.sortingRuleId;
        return data; 
    }
}

export interface ICreateRouteTemplateSortingRuleInput {
    routeTemplateId: number;
    sortingRuleId: number;
}

export class UpdateRouteTemplateSortingRuleInput implements IUpdateRouteTemplateSortingRuleInput {
    id!: number;
    routeTemplateId!: number;
    sortingRuleId!: number;

    constructor(data?: IUpdateRouteTemplateSortingRuleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeTemplateId = data["routeTemplateId"];
            this.sortingRuleId = data["sortingRuleId"];
        }
    }

    static fromJS(data: any): UpdateRouteTemplateSortingRuleInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteTemplateSortingRuleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortingRuleId"] = this.sortingRuleId;
        return data; 
    }
}

export interface IUpdateRouteTemplateSortingRuleInput {
    id: number;
    routeTemplateId: number;
    sortingRuleId: number;
}

export class RouteTemplateTypeListDto implements IRouteTemplateTypeListDto {
    id!: number;
    tenantId!: number;
    name!: string | undefined;

    constructor(data?: IRouteTemplateTypeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): RouteTemplateTypeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateTypeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        return data; 
    }
}

export interface IRouteTemplateTypeListDto {
    id: number;
    tenantId: number;
    name: string | undefined;
}

export class PagedResultDtoOfRouteTemplateTypeListDto implements IPagedResultDtoOfRouteTemplateTypeListDto {
    totalCount!: number;
    items!: RouteTemplateTypeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfRouteTemplateTypeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteTemplateTypeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfRouteTemplateTypeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfRouteTemplateTypeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfRouteTemplateTypeListDto {
    totalCount: number;
    items: RouteTemplateTypeListDto[] | undefined;
}

export class CreateRouteTemplateTypeInput implements ICreateRouteTemplateTypeInput {
    name!: string;

    constructor(data?: ICreateRouteTemplateTypeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CreateRouteTemplateTypeInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRouteTemplateTypeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface ICreateRouteTemplateTypeInput {
    name: string;
}

export class UpdateRouteTemplateTypeInput implements IUpdateRouteTemplateTypeInput {
    id!: number;
    name!: string;

    constructor(data?: IUpdateRouteTemplateTypeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): UpdateRouteTemplateTypeInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteTemplateTypeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IUpdateRouteTemplateTypeInput {
    id: number;
    name: string;
}

export class RouteTemplateWaypointListDto implements IRouteTemplateWaypointListDto {
    tenantId!: number;
    geocodeId!: number;
    routeTemplateId!: number;
    sortOrder!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateWaypointListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.geocodeId = data["geocodeId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.sortOrder = data["sortOrder"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateWaypointListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateWaypointListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["geocodeId"] = this.geocodeId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortOrder"] = this.sortOrder;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateWaypointListDto {
    tenantId: number;
    geocodeId: number;
    routeTemplateId: number;
    sortOrder: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ListResultDtoOfRouteTemplateWaypointListDto implements IListResultDtoOfRouteTemplateWaypointListDto {
    items!: RouteTemplateWaypointListDto[] | undefined;

    constructor(data?: IListResultDtoOfRouteTemplateWaypointListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteTemplateWaypointListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfRouteTemplateWaypointListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfRouteTemplateWaypointListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfRouteTemplateWaypointListDto {
    items: RouteTemplateWaypointListDto[] | undefined;
}

export class CreateRouteTemplateWaypointInput implements ICreateRouteTemplateWaypointInput {
    geocodeId!: number;
    routeTemplateId!: number;
    sortOrder!: number;

    constructor(data?: ICreateRouteTemplateWaypointInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.geocodeId = data["geocodeId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): CreateRouteTemplateWaypointInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRouteTemplateWaypointInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["geocodeId"] = this.geocodeId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface ICreateRouteTemplateWaypointInput {
    geocodeId: number;
    routeTemplateId: number;
    sortOrder: number;
}

export class UpdateRouteTemplateWaypointInput implements IUpdateRouteTemplateWaypointInput {
    id!: number;
    geocodeId!: number;
    routeTemplateId!: number;
    sortOrder!: number;

    constructor(data?: IUpdateRouteTemplateWaypointInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.geocodeId = data["geocodeId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): UpdateRouteTemplateWaypointInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteTemplateWaypointInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["geocodeId"] = this.geocodeId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IUpdateRouteTemplateWaypointInput {
    id: number;
    geocodeId: number;
    routeTemplateId: number;
    sortOrder: number;
}

export class RouteTemplateZoneListDto implements IRouteTemplateZoneListDto {
    tenantId!: number;
    zoneId!: number;
    routeTemplateId!: number;
    sortOrder!: number;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.zoneId = data["zoneId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.sortOrder = data["sortOrder"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["zoneId"] = this.zoneId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortOrder"] = this.sortOrder;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateZoneListDto {
    tenantId: number;
    zoneId: number;
    routeTemplateId: number;
    sortOrder: number;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ListResultDtoOfRouteTemplateZoneListDto implements IListResultDtoOfRouteTemplateZoneListDto {
    items!: RouteTemplateZoneListDto[] | undefined;

    constructor(data?: IListResultDtoOfRouteTemplateZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(RouteTemplateZoneListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfRouteTemplateZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfRouteTemplateZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfRouteTemplateZoneListDto {
    items: RouteTemplateZoneListDto[] | undefined;
}

export class CreateRouteTemplateZoneInput implements ICreateRouteTemplateZoneInput {
    zoneId!: number;
    routeTemplateId!: number;
    sortOrder!: number;

    constructor(data?: ICreateRouteTemplateZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.zoneId = data["zoneId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): CreateRouteTemplateZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateRouteTemplateZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["zoneId"] = this.zoneId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface ICreateRouteTemplateZoneInput {
    zoneId: number;
    routeTemplateId: number;
    sortOrder: number;
}

export class CreateOrEditRouteTemplateZoneDto implements ICreateOrEditRouteTemplateZoneDto {
    newRouteTemplateZone!: boolean | undefined;
    createRouteTemplateZone!: CreateRouteTemplateZoneInput[] | undefined;
    templateId!: number | undefined;

    constructor(data?: ICreateOrEditRouteTemplateZoneDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.newRouteTemplateZone = data["newRouteTemplateZone"];
            if (Array.isArray(data["createRouteTemplateZone"])) {
                this.createRouteTemplateZone = [] as any;
                for (let item of data["createRouteTemplateZone"])
                    this.createRouteTemplateZone!.push(CreateRouteTemplateZoneInput.fromJS(item));
            }
            this.templateId = data["templateId"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteTemplateZoneDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteTemplateZoneDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["newRouteTemplateZone"] = this.newRouteTemplateZone;
        if (Array.isArray(this.createRouteTemplateZone)) {
            data["createRouteTemplateZone"] = [];
            for (let item of this.createRouteTemplateZone)
                data["createRouteTemplateZone"].push(item.toJSON());
        }
        data["templateId"] = this.templateId;
        return data; 
    }
}

export interface ICreateOrEditRouteTemplateZoneDto {
    newRouteTemplateZone: boolean | undefined;
    createRouteTemplateZone: CreateRouteTemplateZoneInput[] | undefined;
    templateId: number | undefined;
}

export class UpdateRouteTemplateZoneInput implements IUpdateRouteTemplateZoneInput {
    id!: number;
    zoneId!: number;
    routeTemplateId!: number;
    sortOrder!: number;

    constructor(data?: IUpdateRouteTemplateZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.zoneId = data["zoneId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.sortOrder = data["sortOrder"];
        }
    }

    static fromJS(data: any): UpdateRouteTemplateZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateRouteTemplateZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["zoneId"] = this.zoneId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortOrder"] = this.sortOrder;
        return data; 
    }
}

export interface IUpdateRouteTemplateZoneInput {
    id: number;
    zoneId: number;
    routeTemplateId: number;
    sortOrder: number;
}

export class RouteTypeDto implements IRouteTypeDto {
    routeTypeCode!: string | undefined;
    description!: string | undefined;
    displayColor!: string | undefined;
    monday!: boolean;
    tuesday!: boolean;
    wednesday!: boolean;
    thursday!: boolean;
    friday!: boolean;
    saturday!: boolean;
    sunday!: boolean;
    sortOrder!: number | undefined;
    type!: Types;
    id!: number;

    constructor(data?: IRouteTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTypeCode = data["routeTypeCode"];
            this.description = data["description"];
            this.displayColor = data["displayColor"];
            this.monday = data["monday"];
            this.tuesday = data["tuesday"];
            this.wednesday = data["wednesday"];
            this.thursday = data["thursday"];
            this.friday = data["friday"];
            this.saturday = data["saturday"];
            this.sunday = data["sunday"];
            this.sortOrder = data["sortOrder"];
            this.type = data["type"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTypeCode"] = this.routeTypeCode;
        data["description"] = this.description;
        data["displayColor"] = this.displayColor;
        data["monday"] = this.monday;
        data["tuesday"] = this.tuesday;
        data["wednesday"] = this.wednesday;
        data["thursday"] = this.thursday;
        data["friday"] = this.friday;
        data["saturday"] = this.saturday;
        data["sunday"] = this.sunday;
        data["sortOrder"] = this.sortOrder;
        data["type"] = this.type;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTypeDto {
    routeTypeCode: string | undefined;
    description: string | undefined;
    displayColor: string | undefined;
    monday: boolean;
    tuesday: boolean;
    wednesday: boolean;
    thursday: boolean;
    friday: boolean;
    saturday: boolean;
    sunday: boolean;
    sortOrder: number | undefined;
    type: Types;
    id: number;
}

export class GetRouteTypeForViewDto implements IGetRouteTypeForViewDto {
    routeType!: RouteTypeDto | undefined;

    constructor(data?: IGetRouteTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeType = data["routeType"] ? RouteTypeDto.fromJS(data["routeType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeType"] = this.routeType ? this.routeType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteTypeForViewDto {
    routeType: RouteTypeDto | undefined;
}

export class PagedResultDtoOfGetRouteTypeForViewDto implements IPagedResultDtoOfGetRouteTypeForViewDto {
    totalCount!: number;
    items!: GetRouteTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetRouteTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetRouteTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetRouteTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetRouteTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetRouteTypeForViewDto {
    totalCount: number;
    items: GetRouteTypeForViewDto[] | undefined;
}

export class CreateOrEditRouteTypeDto implements ICreateOrEditRouteTypeDto {
    routeTypeCode!: string;
    description!: string;
    displayColor!: string;
    sortOrder!: number | undefined;
    type!: Types;
    startTime!: string | undefined;
    monday!: boolean;
    tuesday!: boolean;
    wednesday!: boolean;
    thursday!: boolean;
    friday!: boolean;
    saturday!: boolean;
    sunday!: boolean;
    id!: number | undefined;

    constructor(data?: ICreateOrEditRouteTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTypeCode = data["routeTypeCode"];
            this.description = data["description"];
            this.displayColor = data["displayColor"];
            this.sortOrder = data["sortOrder"];
            this.type = data["type"];
            this.startTime = data["startTime"];
            this.monday = data["monday"];
            this.tuesday = data["tuesday"];
            this.wednesday = data["wednesday"];
            this.thursday = data["thursday"];
            this.friday = data["friday"];
            this.saturday = data["saturday"];
            this.sunday = data["sunday"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditRouteTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditRouteTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTypeCode"] = this.routeTypeCode;
        data["description"] = this.description;
        data["displayColor"] = this.displayColor;
        data["sortOrder"] = this.sortOrder;
        data["type"] = this.type;
        data["startTime"] = this.startTime;
        data["monday"] = this.monday;
        data["tuesday"] = this.tuesday;
        data["wednesday"] = this.wednesday;
        data["thursday"] = this.thursday;
        data["friday"] = this.friday;
        data["saturday"] = this.saturday;
        data["sunday"] = this.sunday;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditRouteTypeDto {
    routeTypeCode: string;
    description: string;
    displayColor: string;
    sortOrder: number | undefined;
    type: Types;
    startTime: string | undefined;
    monday: boolean;
    tuesday: boolean;
    wednesday: boolean;
    thursday: boolean;
    friday: boolean;
    saturday: boolean;
    sunday: boolean;
    id: number | undefined;
}

export class GetRouteTypeForEditOutput implements IGetRouteTypeForEditOutput {
    routeType!: CreateOrEditRouteTypeDto | undefined;

    constructor(data?: IGetRouteTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeType = data["routeType"] ? CreateOrEditRouteTypeDto.fromJS(data["routeType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetRouteTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeType"] = this.routeType ? this.routeType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetRouteTypeForEditOutput {
    routeType: CreateOrEditRouteTypeDto | undefined;
}

export class UpdateMultipleRouteType implements IUpdateMultipleRouteType {
    createOrEditRouteType!: CreateOrEditRouteTypeDto[] | undefined;

    constructor(data?: IUpdateMultipleRouteType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["createOrEditRouteType"])) {
                this.createOrEditRouteType = [] as any;
                for (let item of data["createOrEditRouteType"])
                    this.createOrEditRouteType!.push(CreateOrEditRouteTypeDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UpdateMultipleRouteType {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateMultipleRouteType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.createOrEditRouteType)) {
            data["createOrEditRouteType"] = [];
            for (let item of this.createOrEditRouteType)
                data["createOrEditRouteType"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUpdateMultipleRouteType {
    createOrEditRouteType: CreateOrEditRouteTypeDto[] | undefined;
}

export class CreateSecondaryConnectionInput implements ICreateSecondaryConnectionInput {
    tenantId!: number | undefined;
    connectionString!: string | undefined;

    constructor(data?: ICreateSecondaryConnectionInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.connectionString = data["connectionString"];
        }
    }

    static fromJS(data: any): CreateSecondaryConnectionInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateSecondaryConnectionInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["connectionString"] = this.connectionString;
        return data; 
    }
}

export interface ICreateSecondaryConnectionInput {
    tenantId: number | undefined;
    connectionString: string | undefined;
}

export class SecondaryConnectionDto implements ISecondaryConnectionDto {
    id!: number | undefined;
    tenantId!: number | undefined;
    tenantName!: string | undefined;
    connectionString!: string | undefined;
    modifiedBy!: string | undefined;
    createdBy!: string | undefined;

    constructor(data?: ISecondaryConnectionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.tenantName = data["tenantName"];
            this.connectionString = data["connectionString"];
            this.modifiedBy = data["modifiedBy"];
            this.createdBy = data["createdBy"];
        }
    }

    static fromJS(data: any): SecondaryConnectionDto {
        data = typeof data === 'object' ? data : {};
        let result = new SecondaryConnectionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["tenantName"] = this.tenantName;
        data["connectionString"] = this.connectionString;
        data["modifiedBy"] = this.modifiedBy;
        data["createdBy"] = this.createdBy;
        return data; 
    }
}

export interface ISecondaryConnectionDto {
    id: number | undefined;
    tenantId: number | undefined;
    tenantName: string | undefined;
    connectionString: string | undefined;
    modifiedBy: string | undefined;
    createdBy: string | undefined;
}

export class PagedResultDtoOfSecondaryConnectionDto implements IPagedResultDtoOfSecondaryConnectionDto {
    totalCount!: number;
    items!: SecondaryConnectionDto[] | undefined;

    constructor(data?: IPagedResultDtoOfSecondaryConnectionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SecondaryConnectionDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfSecondaryConnectionDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfSecondaryConnectionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfSecondaryConnectionDto {
    totalCount: number;
    items: SecondaryConnectionDto[] | undefined;
}

export class GetSecondaryConnectionForEdit implements IGetSecondaryConnectionForEdit {
    id!: number;
    tenantId!: number;
    connectionString!: string | undefined;

    constructor(data?: IGetSecondaryConnectionForEdit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.connectionString = data["connectionString"];
        }
    }

    static fromJS(data: any): GetSecondaryConnectionForEdit {
        data = typeof data === 'object' ? data : {};
        let result = new GetSecondaryConnectionForEdit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["connectionString"] = this.connectionString;
        return data; 
    }
}

export interface IGetSecondaryConnectionForEdit {
    id: number;
    tenantId: number;
    connectionString: string | undefined;
}

export class UpdateSecondaryConnectionDto implements IUpdateSecondaryConnectionDto {
    id!: number;
    connectionString!: string | undefined;

    constructor(data?: IUpdateSecondaryConnectionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.connectionString = data["connectionString"];
        }
    }

    static fromJS(data: any): UpdateSecondaryConnectionDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateSecondaryConnectionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["connectionString"] = this.connectionString;
        return data; 
    }
}

export interface IUpdateSecondaryConnectionDto {
    id: number;
    connectionString: string | undefined;
}

export class TenantList implements ITenantList {
    tenancyName!: string | undefined;
    name!: string | undefined;
    tenancyId!: number;

    constructor(data?: ITenantList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.name = data["name"];
            this.tenancyId = data["tenancyId"];
        }
    }

    static fromJS(data: any): TenantList {
        data = typeof data === 'object' ? data : {};
        let result = new TenantList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["name"] = this.name;
        data["tenancyId"] = this.tenancyId;
        return data; 
    }
}

export interface ITenantList {
    tenancyName: string | undefined;
    name: string | undefined;
    tenancyId: number;
}

export class RouteTemplateOrderExtra implements IRouteTemplateOrderExtra {
    tenantId!: number | undefined;
    routeTemplateId!: number;
    orderExtraKey!: string;
    orderExtraValue!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateOrderExtra) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeTemplateId = data["routeTemplateId"];
            this.orderExtraKey = data["orderExtraKey"];
            this.orderExtraValue = data["orderExtraValue"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateOrderExtra {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateOrderExtra();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeTemplateId"] = this.routeTemplateId;
        data["orderExtraKey"] = this.orderExtraKey;
        data["orderExtraValue"] = this.orderExtraValue;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateOrderExtra {
    tenantId: number | undefined;
    routeTemplateId: number;
    orderExtraKey: string;
    orderExtraValue: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderLog implements IOrderLog {
    orderNumber!: string | undefined;
    trackingId!: string | undefined;
    response!: string | undefined;
    orderType!: OrderType | undefined;
    orderTypeId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderNumber = data["orderNumber"];
            this.trackingId = data["trackingId"];
            this.response = data["response"];
            this.orderType = data["orderType"] ? OrderType.fromJS(data["orderType"]) : <any>undefined;
            this.orderTypeId = data["orderTypeId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderLog {
        data = typeof data === 'object' ? data : {};
        let result = new OrderLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderNumber"] = this.orderNumber;
        data["trackingId"] = this.trackingId;
        data["response"] = this.response;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["orderTypeId"] = this.orderTypeId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderLog {
    orderNumber: string | undefined;
    trackingId: string | undefined;
    response: string | undefined;
    orderType: OrderType | undefined;
    orderTypeId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ClientOrderLog implements IClientOrderLog {
    tenantId!: number | undefined;
    clientAccount!: ClientAccount;
    clientAccountId!: number;
    response!: string | undefined;
    success!: number;
    failed!: number;
    total!: number;
    duration!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IClientOrderLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.clientAccount = new ClientAccount();
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.clientAccount = data["clientAccount"] ? ClientAccount.fromJS(data["clientAccount"]) : new ClientAccount();
            this.clientAccountId = data["clientAccountId"];
            this.response = data["response"];
            this.success = data["success"];
            this.failed = data["failed"];
            this.total = data["total"];
            this.duration = data["duration"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ClientOrderLog {
        data = typeof data === 'object' ? data : {};
        let result = new ClientOrderLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["clientAccount"] = this.clientAccount ? this.clientAccount.toJSON() : <any>undefined;
        data["clientAccountId"] = this.clientAccountId;
        data["response"] = this.response;
        data["success"] = this.success;
        data["failed"] = this.failed;
        data["total"] = this.total;
        data["duration"] = this.duration;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IClientOrderLog {
    tenantId: number | undefined;
    clientAccount: ClientAccount;
    clientAccountId: number;
    response: string | undefined;
    success: number;
    failed: number;
    total: number;
    duration: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ClientDriver implements IClientDriver {
    tenantId!: number | undefined;
    driverId!: string;
    user!: User;
    userId!: number;
    clientAccount!: ClientAccount;
    clientAccountId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IClientDriver) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new User();
            this.clientAccount = new ClientAccount();
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.driverId = data["driverId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : new User();
            this.userId = data["userId"];
            this.clientAccount = data["clientAccount"] ? ClientAccount.fromJS(data["clientAccount"]) : new ClientAccount();
            this.clientAccountId = data["clientAccountId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ClientDriver {
        data = typeof data === 'object' ? data : {};
        let result = new ClientDriver();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["driverId"] = this.driverId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["clientAccount"] = this.clientAccount ? this.clientAccount.toJSON() : <any>undefined;
        data["clientAccountId"] = this.clientAccountId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IClientDriver {
    tenantId: number | undefined;
    driverId: string;
    user: User;
    userId: number;
    clientAccount: ClientAccount;
    clientAccountId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderStatusMapping implements IOrderStatusMapping {
    tenantId!: number | undefined;
    code!: string;
    description!: string;
    orderStatusDescriptionId!: number;
    orderStatusDescription!: OrderStatusDescription | undefined;
    orderSourceId!: number;
    orderSource!: OrderSource | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderStatusMapping) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.description = data["description"];
            this.orderStatusDescriptionId = data["orderStatusDescriptionId"];
            this.orderStatusDescription = data["orderStatusDescription"] ? OrderStatusDescription.fromJS(data["orderStatusDescription"]) : <any>undefined;
            this.orderSourceId = data["orderSourceId"];
            this.orderSource = data["orderSource"] ? OrderSource.fromJS(data["orderSource"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderStatusMapping {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusMapping();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["description"] = this.description;
        data["orderStatusDescriptionId"] = this.orderStatusDescriptionId;
        data["orderStatusDescription"] = this.orderStatusDescription ? this.orderStatusDescription.toJSON() : <any>undefined;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSource"] = this.orderSource ? this.orderSource.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderStatusMapping {
    tenantId: number | undefined;
    code: string;
    description: string;
    orderStatusDescriptionId: number;
    orderStatusDescription: OrderStatusDescription | undefined;
    orderSourceId: number;
    orderSource: OrderSource | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteGenerationSetting implements IRouteGenerationSetting {
    tenantId!: number | undefined;
    isFuture!: boolean;
    noOfDays!: number;
    id!: number;

    constructor(data?: IRouteGenerationSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.isFuture = data["isFuture"];
            this.noOfDays = data["noOfDays"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteGenerationSetting {
        data = typeof data === 'object' ? data : {};
        let result = new RouteGenerationSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["isFuture"] = this.isFuture;
        data["noOfDays"] = this.noOfDays;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteGenerationSetting {
    tenantId: number | undefined;
    isFuture: boolean;
    noOfDays: number;
    id: number;
}

export class RouteHandOffDefinition implements IRouteHandOffDefinition {
    tenantId!: number | undefined;
    threshold!: number;
    inactive!: boolean;
    manager!: User | undefined;
    managerId!: number | undefined;
    assignedBy!: User | undefined;
    assignedById!: number | undefined;
    assignedDate!: moment.Moment | undefined;
    routeTemplateId!: number | undefined;
    routeTemplateFk!: RouteTemplate | undefined;
    routeTypeId!: number | undefined;
    routeTypeFk!: RouteType | undefined;
    isOnDemand!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteHandOffDefinition) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.threshold = data["threshold"];
            this.inactive = data["inactive"];
            this.manager = data["manager"] ? User.fromJS(data["manager"]) : <any>undefined;
            this.managerId = data["managerId"];
            this.assignedBy = data["assignedBy"] ? User.fromJS(data["assignedBy"]) : <any>undefined;
            this.assignedById = data["assignedById"];
            this.assignedDate = data["assignedDate"] ? moment(data["assignedDate"].toString()) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.routeTemplateFk = data["routeTemplateFk"] ? RouteTemplate.fromJS(data["routeTemplateFk"]) : <any>undefined;
            this.routeTypeId = data["routeTypeId"];
            this.routeTypeFk = data["routeTypeFk"] ? RouteType.fromJS(data["routeTypeFk"]) : <any>undefined;
            this.isOnDemand = data["isOnDemand"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteHandOffDefinition {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffDefinition();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["threshold"] = this.threshold;
        data["inactive"] = this.inactive;
        data["manager"] = this.manager ? this.manager.toJSON() : <any>undefined;
        data["managerId"] = this.managerId;
        data["assignedBy"] = this.assignedBy ? this.assignedBy.toJSON() : <any>undefined;
        data["assignedById"] = this.assignedById;
        data["assignedDate"] = this.assignedDate ? this.assignedDate.toISOString() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeTemplateFk"] = this.routeTemplateFk ? this.routeTemplateFk.toJSON() : <any>undefined;
        data["routeTypeId"] = this.routeTypeId;
        data["routeTypeFk"] = this.routeTypeFk ? this.routeTypeFk.toJSON() : <any>undefined;
        data["isOnDemand"] = this.isOnDemand;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteHandOffDefinition {
    tenantId: number | undefined;
    threshold: number;
    inactive: boolean;
    manager: User | undefined;
    managerId: number | undefined;
    assignedBy: User | undefined;
    assignedById: number | undefined;
    assignedDate: moment.Moment | undefined;
    routeTemplateId: number | undefined;
    routeTemplateFk: RouteTemplate | undefined;
    routeTypeId: number | undefined;
    routeTypeFk: RouteType | undefined;
    isOnDemand: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteHandOffScheduleDetail implements IRouteHandOffScheduleDetail {
    tenantId!: number | undefined;
    routeCode!: string | undefined;
    estimatedTimeOfArrival!: moment.Moment;
    oorRate!: number | undefined;
    rate!: number | undefined;
    effectivityDate!: moment.Moment;
    isActive!: boolean;
    etaTime!: TimeSpan;
    serviceTime!: number;
    timeWindowStart!: number;
    timeWindowEnd!: number | undefined;
    sortOrder!: number | undefined;
    dateEtaLocked!: moment.Moment | undefined;
    etaLocked!: boolean;
    etaLockedByUser!: User | undefined;
    etaLockedByUserId!: number | undefined;
    mondayETATime!: TimeSpan | undefined;
    tuesdayETATime!: TimeSpan | undefined;
    wednesdayETATime!: TimeSpan | undefined;
    thursdayETATime!: TimeSpan | undefined;
    fridayETATime!: TimeSpan | undefined;
    saturdayETATime!: TimeSpan | undefined;
    sundayETATime!: TimeSpan | undefined;
    routeHandOffDefinitionFk!: RouteHandOffDefinition | undefined;
    routeHandOffDefinitionId!: number;
    routeTemplateFk!: RouteTemplate | undefined;
    routeTemplateId!: number | undefined;
    routeTypeFk!: RouteType | undefined;
    routeTypeId!: number | undefined;
    contact!: Contact | undefined;
    contactId!: number;
    etas!: RouteHandOffScheduleDetailEtas[] | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteHandOffScheduleDetail) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeCode = data["routeCode"];
            this.estimatedTimeOfArrival = data["estimatedTimeOfArrival"] ? moment(data["estimatedTimeOfArrival"].toString()) : <any>undefined;
            this.oorRate = data["oorRate"];
            this.rate = data["rate"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.isActive = data["isActive"];
            this.etaTime = data["etaTime"] ? TimeSpan.fromJS(data["etaTime"]) : <any>undefined;
            this.serviceTime = data["serviceTime"];
            this.timeWindowStart = data["timeWindowStart"];
            this.timeWindowEnd = data["timeWindowEnd"];
            this.sortOrder = data["sortOrder"];
            this.dateEtaLocked = data["dateEtaLocked"] ? moment(data["dateEtaLocked"].toString()) : <any>undefined;
            this.etaLocked = data["etaLocked"];
            this.etaLockedByUser = data["etaLockedByUser"] ? User.fromJS(data["etaLockedByUser"]) : <any>undefined;
            this.etaLockedByUserId = data["etaLockedByUserId"];
            this.mondayETATime = data["mondayETATime"] ? TimeSpan.fromJS(data["mondayETATime"]) : <any>undefined;
            this.tuesdayETATime = data["tuesdayETATime"] ? TimeSpan.fromJS(data["tuesdayETATime"]) : <any>undefined;
            this.wednesdayETATime = data["wednesdayETATime"] ? TimeSpan.fromJS(data["wednesdayETATime"]) : <any>undefined;
            this.thursdayETATime = data["thursdayETATime"] ? TimeSpan.fromJS(data["thursdayETATime"]) : <any>undefined;
            this.fridayETATime = data["fridayETATime"] ? TimeSpan.fromJS(data["fridayETATime"]) : <any>undefined;
            this.saturdayETATime = data["saturdayETATime"] ? TimeSpan.fromJS(data["saturdayETATime"]) : <any>undefined;
            this.sundayETATime = data["sundayETATime"] ? TimeSpan.fromJS(data["sundayETATime"]) : <any>undefined;
            this.routeHandOffDefinitionFk = data["routeHandOffDefinitionFk"] ? RouteHandOffDefinition.fromJS(data["routeHandOffDefinitionFk"]) : <any>undefined;
            this.routeHandOffDefinitionId = data["routeHandOffDefinitionId"];
            this.routeTemplateFk = data["routeTemplateFk"] ? RouteTemplate.fromJS(data["routeTemplateFk"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.routeTypeFk = data["routeTypeFk"] ? RouteType.fromJS(data["routeTypeFk"]) : <any>undefined;
            this.routeTypeId = data["routeTypeId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            if (Array.isArray(data["etas"])) {
                this.etas = [] as any;
                for (let item of data["etas"])
                    this.etas!.push(RouteHandOffScheduleDetailEtas.fromJS(item));
            }
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteHandOffScheduleDetail {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffScheduleDetail();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeCode"] = this.routeCode;
        data["estimatedTimeOfArrival"] = this.estimatedTimeOfArrival ? this.estimatedTimeOfArrival.toISOString() : <any>undefined;
        data["oorRate"] = this.oorRate;
        data["rate"] = this.rate;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["isActive"] = this.isActive;
        data["etaTime"] = this.etaTime ? this.etaTime.toJSON() : <any>undefined;
        data["serviceTime"] = this.serviceTime;
        data["timeWindowStart"] = this.timeWindowStart;
        data["timeWindowEnd"] = this.timeWindowEnd;
        data["sortOrder"] = this.sortOrder;
        data["dateEtaLocked"] = this.dateEtaLocked ? this.dateEtaLocked.toISOString() : <any>undefined;
        data["etaLocked"] = this.etaLocked;
        data["etaLockedByUser"] = this.etaLockedByUser ? this.etaLockedByUser.toJSON() : <any>undefined;
        data["etaLockedByUserId"] = this.etaLockedByUserId;
        data["mondayETATime"] = this.mondayETATime ? this.mondayETATime.toJSON() : <any>undefined;
        data["tuesdayETATime"] = this.tuesdayETATime ? this.tuesdayETATime.toJSON() : <any>undefined;
        data["wednesdayETATime"] = this.wednesdayETATime ? this.wednesdayETATime.toJSON() : <any>undefined;
        data["thursdayETATime"] = this.thursdayETATime ? this.thursdayETATime.toJSON() : <any>undefined;
        data["fridayETATime"] = this.fridayETATime ? this.fridayETATime.toJSON() : <any>undefined;
        data["saturdayETATime"] = this.saturdayETATime ? this.saturdayETATime.toJSON() : <any>undefined;
        data["sundayETATime"] = this.sundayETATime ? this.sundayETATime.toJSON() : <any>undefined;
        data["routeHandOffDefinitionFk"] = this.routeHandOffDefinitionFk ? this.routeHandOffDefinitionFk.toJSON() : <any>undefined;
        data["routeHandOffDefinitionId"] = this.routeHandOffDefinitionId;
        data["routeTemplateFk"] = this.routeTemplateFk ? this.routeTemplateFk.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeTypeFk"] = this.routeTypeFk ? this.routeTypeFk.toJSON() : <any>undefined;
        data["routeTypeId"] = this.routeTypeId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        if (Array.isArray(this.etas)) {
            data["etas"] = [];
            for (let item of this.etas)
                data["etas"].push(item.toJSON());
        }
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteHandOffScheduleDetail {
    tenantId: number | undefined;
    routeCode: string | undefined;
    estimatedTimeOfArrival: moment.Moment;
    oorRate: number | undefined;
    rate: number | undefined;
    effectivityDate: moment.Moment;
    isActive: boolean;
    etaTime: TimeSpan;
    serviceTime: number;
    timeWindowStart: number;
    timeWindowEnd: number | undefined;
    sortOrder: number | undefined;
    dateEtaLocked: moment.Moment | undefined;
    etaLocked: boolean;
    etaLockedByUser: User | undefined;
    etaLockedByUserId: number | undefined;
    mondayETATime: TimeSpan | undefined;
    tuesdayETATime: TimeSpan | undefined;
    wednesdayETATime: TimeSpan | undefined;
    thursdayETATime: TimeSpan | undefined;
    fridayETATime: TimeSpan | undefined;
    saturdayETATime: TimeSpan | undefined;
    sundayETATime: TimeSpan | undefined;
    routeHandOffDefinitionFk: RouteHandOffDefinition | undefined;
    routeHandOffDefinitionId: number;
    routeTemplateFk: RouteTemplate | undefined;
    routeTemplateId: number | undefined;
    routeTypeFk: RouteType | undefined;
    routeTypeId: number | undefined;
    contact: Contact | undefined;
    contactId: number;
    etas: RouteHandOffScheduleDetailEtas[] | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteHandOffScheduleDetailEtas implements IRouteHandOffScheduleDetailEtas {
    routeHandOffScheduleDetail!: RouteHandOffScheduleDetail | undefined;
    routeHandOffScheduleDetailId!: number | undefined;
    time!: TimeSpan;
    day!: DayOfWeek;
    type!: TimeTypes;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteHandOffScheduleDetailEtas) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeHandOffScheduleDetail = data["routeHandOffScheduleDetail"] ? RouteHandOffScheduleDetail.fromJS(data["routeHandOffScheduleDetail"]) : <any>undefined;
            this.routeHandOffScheduleDetailId = data["routeHandOffScheduleDetailId"];
            this.time = data["time"] ? TimeSpan.fromJS(data["time"]) : <any>undefined;
            this.day = data["day"];
            this.type = data["type"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteHandOffScheduleDetailEtas {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffScheduleDetailEtas();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeHandOffScheduleDetail"] = this.routeHandOffScheduleDetail ? this.routeHandOffScheduleDetail.toJSON() : <any>undefined;
        data["routeHandOffScheduleDetailId"] = this.routeHandOffScheduleDetailId;
        data["time"] = this.time ? this.time.toJSON() : <any>undefined;
        data["day"] = this.day;
        data["type"] = this.type;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteHandOffScheduleDetailEtas {
    routeHandOffScheduleDetail: RouteHandOffScheduleDetail | undefined;
    routeHandOffScheduleDetailId: number | undefined;
    time: TimeSpan;
    day: DayOfWeek;
    type: TimeTypes;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ContactPerson implements IContactPerson {
    tenantId!: number | undefined;
    parentContactId!: number;
    contact!: Contact | undefined;
    contactId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IContactPerson) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.parentContactId = data["parentContactId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ContactPerson {
        data = typeof data === 'object' ? data : {};
        let result = new ContactPerson();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["parentContactId"] = this.parentContactId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IContactPerson {
    tenantId: number | undefined;
    parentContactId: number;
    contact: Contact | undefined;
    contactId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ContactBusinessHour implements IContactBusinessHour {
    tenantId!: number | undefined;
    contact!: Contact;
    code!: string | undefined;
    contactId!: number;
    openingTime!: TimeSpan;
    closingTime!: TimeSpan;
    date!: moment.Moment | undefined;
    day!: string | undefined;
    isClosed!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IContactBusinessHour) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.contact = new Contact();
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : new Contact();
            this.code = data["code"];
            this.contactId = data["contactId"];
            this.openingTime = data["openingTime"] ? TimeSpan.fromJS(data["openingTime"]) : <any>undefined;
            this.closingTime = data["closingTime"] ? TimeSpan.fromJS(data["closingTime"]) : <any>undefined;
            this.date = data["date"] ? moment(data["date"].toString()) : <any>undefined;
            this.day = data["day"];
            this.isClosed = data["isClosed"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ContactBusinessHour {
        data = typeof data === 'object' ? data : {};
        let result = new ContactBusinessHour();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["contactId"] = this.contactId;
        data["openingTime"] = this.openingTime ? this.openingTime.toJSON() : <any>undefined;
        data["closingTime"] = this.closingTime ? this.closingTime.toJSON() : <any>undefined;
        data["date"] = this.date ? this.date.toISOString() : <any>undefined;
        data["day"] = this.day;
        data["isClosed"] = this.isClosed;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IContactBusinessHour {
    tenantId: number | undefined;
    contact: Contact;
    code: string | undefined;
    contactId: number;
    openingTime: TimeSpan;
    closingTime: TimeSpan;
    date: moment.Moment | undefined;
    day: string | undefined;
    isClosed: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DataRetentionLog implements IDataRetentionLog {
    tenantId!: number | undefined;
    dataRetentionId!: number;
    status!: LogStatus;
    message!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDataRetentionLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.dataRetentionId = data["dataRetentionId"];
            this.status = data["status"];
            this.message = data["message"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DataRetentionLog {
        data = typeof data === 'object' ? data : {};
        let result = new DataRetentionLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["dataRetentionId"] = this.dataRetentionId;
        data["status"] = this.status;
        data["message"] = this.message;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDataRetentionLog {
    tenantId: number | undefined;
    dataRetentionId: number;
    status: LogStatus;
    message: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Version implements IVersion {
    versionNumber!: string;
    releasedDate!: moment.Moment | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IVersion) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.versionNumber = data["versionNumber"];
            this.releasedDate = data["releasedDate"] ? moment(data["releasedDate"].toString()) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Version {
        data = typeof data === 'object' ? data : {};
        let result = new Version();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["versionNumber"] = this.versionNumber;
        data["releasedDate"] = this.releasedDate ? this.releasedDate.toISOString() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVersion {
    versionNumber: string;
    releasedDate: moment.Moment | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class FtpAccount implements IFtpAccount {
    tenantId!: number | undefined;
    name!: string;
    host!: string;
    port!: number;
    username!: string;
    password!: string;
    folder!: string;
    isActive!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IFtpAccount) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.host = data["host"];
            this.port = data["port"];
            this.username = data["username"];
            this.password = data["password"];
            this.folder = data["folder"];
            this.isActive = data["isActive"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): FtpAccount {
        data = typeof data === 'object' ? data : {};
        let result = new FtpAccount();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["host"] = this.host;
        data["port"] = this.port;
        data["username"] = this.username;
        data["password"] = this.password;
        data["folder"] = this.folder;
        data["isActive"] = this.isActive;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFtpAccount {
    tenantId: number | undefined;
    name: string;
    host: string;
    port: number;
    username: string;
    password: string;
    folder: string;
    isActive: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class UserOrderType implements IUserOrderType {
    tenantId!: number | undefined;
    userId!: number | undefined;
    userFk!: User | undefined;
    orderTypeId!: number | undefined;
    orderTypeFk!: OrderType | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUserOrderType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.userFk = data["userFk"] ? User.fromJS(data["userFk"]) : <any>undefined;
            this.orderTypeId = data["orderTypeId"];
            this.orderTypeFk = data["orderTypeFk"] ? OrderType.fromJS(data["orderTypeFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserOrderType {
        data = typeof data === 'object' ? data : {};
        let result = new UserOrderType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["userFk"] = this.userFk ? this.userFk.toJSON() : <any>undefined;
        data["orderTypeId"] = this.orderTypeId;
        data["orderTypeFk"] = this.orderTypeFk ? this.orderTypeFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserOrderType {
    tenantId: number | undefined;
    userId: number | undefined;
    userFk: User | undefined;
    orderTypeId: number | undefined;
    orderTypeFk: OrderType | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderSourceConnection implements IOrderSourceConnection {
    tenantId!: number | undefined;
    orderSource!: OrderSource | undefined;
    orderSourceId!: number;
    connectionId!: number;
    connectionType!: ConnectionType;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderSourceConnection) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.orderSource = data["orderSource"] ? OrderSource.fromJS(data["orderSource"]) : <any>undefined;
            this.orderSourceId = data["orderSourceId"];
            this.connectionId = data["connectionId"];
            this.connectionType = data["connectionType"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderSourceConnection {
        data = typeof data === 'object' ? data : {};
        let result = new OrderSourceConnection();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["orderSource"] = this.orderSource ? this.orderSource.toJSON() : <any>undefined;
        data["orderSourceId"] = this.orderSourceId;
        data["connectionId"] = this.connectionId;
        data["connectionType"] = this.connectionType;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderSourceConnection {
    tenantId: number | undefined;
    orderSource: OrderSource | undefined;
    orderSourceId: number;
    connectionId: number;
    connectionType: ConnectionType;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class FleetUser implements IFleetUser {
    user!: User | undefined;
    userId!: number;
    fleet!: Fleet | undefined;
    fleetId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IFleetUser) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.fleet = data["fleet"] ? Fleet.fromJS(data["fleet"]) : <any>undefined;
            this.fleetId = data["fleetId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): FleetUser {
        data = typeof data === 'object' ? data : {};
        let result = new FleetUser();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        data["fleetId"] = this.fleetId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFleetUser {
    user: User | undefined;
    userId: number;
    fleet: Fleet | undefined;
    fleetId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class FleetVehicle implements IFleetVehicle {
    fleet!: Fleet | undefined;
    fleetId!: number;
    vehicle!: Vehicle | undefined;
    vehicleId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IFleetVehicle) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fleet = data["fleet"] ? Fleet.fromJS(data["fleet"]) : <any>undefined;
            this.fleetId = data["fleetId"];
            this.vehicle = data["vehicle"] ? Vehicle.fromJS(data["vehicle"]) : <any>undefined;
            this.vehicleId = data["vehicleId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): FleetVehicle {
        data = typeof data === 'object' ? data : {};
        let result = new FleetVehicle();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        data["fleetId"] = this.fleetId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFleetVehicle {
    fleet: Fleet | undefined;
    fleetId: number;
    vehicle: Vehicle | undefined;
    vehicleId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Rates implements IRates {
    tenantId!: number | undefined;
    locationId!: number | undefined;
    locationFk!: Location | undefined;
    orderSourceId!: number | undefined;
    orderSourceFk!: OrderSource | undefined;
    inActive!: boolean;
    description!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRates) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.locationId = data["locationId"];
            this.locationFk = data["locationFk"] ? Location.fromJS(data["locationFk"]) : <any>undefined;
            this.orderSourceId = data["orderSourceId"];
            this.orderSourceFk = data["orderSourceFk"] ? OrderSource.fromJS(data["orderSourceFk"]) : <any>undefined;
            this.inActive = data["inActive"];
            this.description = data["description"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Rates {
        data = typeof data === 'object' ? data : {};
        let result = new Rates();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["locationId"] = this.locationId;
        data["locationFk"] = this.locationFk ? this.locationFk.toJSON() : <any>undefined;
        data["orderSourceId"] = this.orderSourceId;
        data["orderSourceFk"] = this.orderSourceFk ? this.orderSourceFk.toJSON() : <any>undefined;
        data["inActive"] = this.inActive;
        data["description"] = this.description;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRates {
    tenantId: number | undefined;
    locationId: number | undefined;
    locationFk: Location | undefined;
    orderSourceId: number | undefined;
    orderSourceFk: OrderSource | undefined;
    inActive: boolean;
    description: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class FleetRate implements IFleetRate {
    fleet!: Fleet | undefined;
    fleetId!: number;
    rate!: Rates | undefined;
    rateId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IFleetRate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fleet = data["fleet"] ? Fleet.fromJS(data["fleet"]) : <any>undefined;
            this.fleetId = data["fleetId"];
            this.rate = data["rate"] ? Rates.fromJS(data["rate"]) : <any>undefined;
            this.rateId = data["rateId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): FleetRate {
        data = typeof data === 'object' ? data : {};
        let result = new FleetRate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        data["fleetId"] = this.fleetId;
        data["rate"] = this.rate ? this.rate.toJSON() : <any>undefined;
        data["rateId"] = this.rateId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFleetRate {
    fleet: Fleet | undefined;
    fleetId: number;
    rate: Rates | undefined;
    rateId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Fleet implements IFleet {
    tenantId!: number | undefined;
    name!: string | undefined;
    fleetUsers!: FleetUser[] | undefined;
    fleetVehicle!: FleetVehicle[] | undefined;
    fleetRate!: FleetRate[] | undefined;
    mileageMultiplier!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IFleet) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            if (Array.isArray(data["fleetUsers"])) {
                this.fleetUsers = [] as any;
                for (let item of data["fleetUsers"])
                    this.fleetUsers!.push(FleetUser.fromJS(item));
            }
            if (Array.isArray(data["fleetVehicle"])) {
                this.fleetVehicle = [] as any;
                for (let item of data["fleetVehicle"])
                    this.fleetVehicle!.push(FleetVehicle.fromJS(item));
            }
            if (Array.isArray(data["fleetRate"])) {
                this.fleetRate = [] as any;
                for (let item of data["fleetRate"])
                    this.fleetRate!.push(FleetRate.fromJS(item));
            }
            this.mileageMultiplier = data["mileageMultiplier"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Fleet {
        data = typeof data === 'object' ? data : {};
        let result = new Fleet();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        if (Array.isArray(this.fleetUsers)) {
            data["fleetUsers"] = [];
            for (let item of this.fleetUsers)
                data["fleetUsers"].push(item.toJSON());
        }
        if (Array.isArray(this.fleetVehicle)) {
            data["fleetVehicle"] = [];
            for (let item of this.fleetVehicle)
                data["fleetVehicle"].push(item.toJSON());
        }
        if (Array.isArray(this.fleetRate)) {
            data["fleetRate"] = [];
            for (let item of this.fleetRate)
                data["fleetRate"].push(item.toJSON());
        }
        data["mileageMultiplier"] = this.mileageMultiplier;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFleet {
    tenantId: number | undefined;
    name: string | undefined;
    fleetUsers: FleetUser[] | undefined;
    fleetVehicle: FleetVehicle[] | undefined;
    fleetRate: FleetRate[] | undefined;
    mileageMultiplier: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Vendor implements IVendor {
    tenantId!: number | undefined;
    user!: User;
    userId!: number;
    contact!: Contact | undefined;
    contactId!: number | undefined;
    startDate!: moment.Moment | undefined;
    hourlyRate!: number | undefined;
    dailyRate!: number | undefined;
    idNumber!: string | undefined;
    fleet!: Fleet | undefined;
    fleetId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IVendor) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new User();
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : new User();
            this.userId = data["userId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.hourlyRate = data["hourlyRate"];
            this.dailyRate = data["dailyRate"];
            this.idNumber = data["idNumber"];
            this.fleet = data["fleet"] ? Fleet.fromJS(data["fleet"]) : <any>undefined;
            this.fleetId = data["fleetId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Vendor {
        data = typeof data === 'object' ? data : {};
        let result = new Vendor();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["hourlyRate"] = this.hourlyRate;
        data["dailyRate"] = this.dailyRate;
        data["idNumber"] = this.idNumber;
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        data["fleetId"] = this.fleetId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVendor {
    tenantId: number | undefined;
    user: User;
    userId: number;
    contact: Contact | undefined;
    contactId: number | undefined;
    startDate: moment.Moment | undefined;
    hourlyRate: number | undefined;
    dailyRate: number | undefined;
    idNumber: string | undefined;
    fleet: Fleet | undefined;
    fleetId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class IncidentSource implements IIncidentSource {
    tenantId!: number | undefined;
    name!: string | undefined;
    isActive!: boolean;
    description!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IIncidentSource) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentSource {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentSource();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentSource {
    tenantId: number | undefined;
    name: string | undefined;
    isActive: boolean;
    description: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderSourceFile implements IOrderSourceFile {
    tenantId!: number | undefined;
    ftpAccounts!: FtpAccount | undefined;
    ftpAccountId!: number | undefined;
    fileName!: string;
    binaryObject!: string | undefined;
    isDownloaded!: boolean;
    isImported!: boolean;
    noTries!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderSourceFile) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.ftpAccounts = data["ftpAccounts"] ? FtpAccount.fromJS(data["ftpAccounts"]) : <any>undefined;
            this.ftpAccountId = data["ftpAccountId"];
            this.fileName = data["fileName"];
            this.binaryObject = data["binaryObject"];
            this.isDownloaded = data["isDownloaded"];
            this.isImported = data["isImported"];
            this.noTries = data["noTries"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderSourceFile {
        data = typeof data === 'object' ? data : {};
        let result = new OrderSourceFile();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["ftpAccounts"] = this.ftpAccounts ? this.ftpAccounts.toJSON() : <any>undefined;
        data["ftpAccountId"] = this.ftpAccountId;
        data["fileName"] = this.fileName;
        data["binaryObject"] = this.binaryObject;
        data["isDownloaded"] = this.isDownloaded;
        data["isImported"] = this.isImported;
        data["noTries"] = this.noTries;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderSourceFile {
    tenantId: number | undefined;
    ftpAccounts: FtpAccount | undefined;
    ftpAccountId: number | undefined;
    fileName: string;
    binaryObject: string | undefined;
    isDownloaded: boolean;
    isImported: boolean;
    noTries: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ImportLog implements IImportLog {
    tenantId!: number | undefined;
    importType!: ImportType;
    fileName!: string;
    success!: number | undefined;
    failed!: number | undefined;
    connectionId!: number | undefined;
    result!: string | undefined;
    orderSourceFile!: OrderSourceFile | undefined;
    orderSourceFileId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IImportLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.importType = data["importType"];
            this.fileName = data["fileName"];
            this.success = data["success"];
            this.failed = data["failed"];
            this.connectionId = data["connectionId"];
            this.result = data["result"];
            this.orderSourceFile = data["orderSourceFile"] ? OrderSourceFile.fromJS(data["orderSourceFile"]) : <any>undefined;
            this.orderSourceFileId = data["orderSourceFileId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportLog {
        data = typeof data === 'object' ? data : {};
        let result = new ImportLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["importType"] = this.importType;
        data["fileName"] = this.fileName;
        data["success"] = this.success;
        data["failed"] = this.failed;
        data["connectionId"] = this.connectionId;
        data["result"] = this.result;
        data["orderSourceFile"] = this.orderSourceFile ? this.orderSourceFile.toJSON() : <any>undefined;
        data["orderSourceFileId"] = this.orderSourceFileId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportLog {
    tenantId: number | undefined;
    importType: ImportType;
    fileName: string;
    success: number | undefined;
    failed: number | undefined;
    connectionId: number | undefined;
    result: string | undefined;
    orderSourceFile: OrderSourceFile | undefined;
    orderSourceFileId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ImportLogMessage implements IImportLogMessage {
    tenantId!: number | undefined;
    message!: string;
    importLog!: ImportLog | undefined;
    importLogId!: number;
    uniqueIdentifier!: string | undefined;
    id!: number;

    constructor(data?: IImportLogMessage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.message = data["message"];
            this.importLog = data["importLog"] ? ImportLog.fromJS(data["importLog"]) : <any>undefined;
            this.importLogId = data["importLogId"];
            this.uniqueIdentifier = data["uniqueIdentifier"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportLogMessage {
        data = typeof data === 'object' ? data : {};
        let result = new ImportLogMessage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["message"] = this.message;
        data["importLog"] = this.importLog ? this.importLog.toJSON() : <any>undefined;
        data["importLogId"] = this.importLogId;
        data["uniqueIdentifier"] = this.uniqueIdentifier;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportLogMessage {
    tenantId: number | undefined;
    message: string;
    importLog: ImportLog | undefined;
    importLogId: number;
    uniqueIdentifier: string | undefined;
    id: number;
}

export class SupportCategoryTypes implements ISupportCategoryTypes {
    tenantId!: number | undefined;
    code!: string;
    description!: string;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportCategoryTypes) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportCategoryTypes {
        data = typeof data === 'object' ? data : {};
        let result = new SupportCategoryTypes();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportCategoryTypes {
    tenantId: number | undefined;
    code: string;
    description: string;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrganizationUnit implements IOrganizationUnit {
    tenantId!: number | undefined;
    parent!: OrganizationUnit | undefined;
    parentId!: number | undefined;
    code!: string;
    displayName!: string;
    children!: OrganizationUnit[] | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrganizationUnit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.parent = data["parent"] ? OrganizationUnit.fromJS(data["parent"]) : <any>undefined;
            this.parentId = data["parentId"];
            this.code = data["code"];
            this.displayName = data["displayName"];
            if (Array.isArray(data["children"])) {
                this.children = [] as any;
                for (let item of data["children"])
                    this.children!.push(OrganizationUnit.fromJS(item));
            }
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrganizationUnit {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["parent"] = this.parent ? this.parent.toJSON() : <any>undefined;
        data["parentId"] = this.parentId;
        data["code"] = this.code;
        data["displayName"] = this.displayName;
        if (Array.isArray(this.children)) {
            data["children"] = [];
            for (let item of this.children)
                data["children"].push(item.toJSON());
        }
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrganizationUnit {
    tenantId: number | undefined;
    parent: OrganizationUnit | undefined;
    parentId: number | undefined;
    code: string;
    displayName: string;
    children: OrganizationUnit[] | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SupportTicketType implements ISupportTicketType {
    code!: string | undefined;
    description!: string;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketType {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketType {
    code: string | undefined;
    description: string;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SupportTicketStatus implements ISupportTicketStatus {
    code!: string | undefined;
    description!: string;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    isPublic!: boolean;
    parentStatusTypeId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketStatus) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.isPublic = data["isPublic"];
            this.parentStatusTypeId = data["parentStatusTypeId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketStatus {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketStatus();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["isPublic"] = this.isPublic;
        data["parentStatusTypeId"] = this.parentStatusTypeId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketStatus {
    code: string | undefined;
    description: string;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    isPublic: boolean;
    parentStatusTypeId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SupportTicket implements ISupportTicket {
    tenantId!: number | undefined;
    parentId!: number | undefined;
    assignedTo!: User | undefined;
    assignedToId!: number | undefined;
    testerUser!: User | undefined;
    testerUserId!: number | undefined;
    managerUser!: User | undefined;
    managerId!: number | undefined;
    developerUser!: User | undefined;
    developerId!: number | undefined;
    technicalSupportUser!: User | undefined;
    technicalSupportId!: number | undefined;
    parentTicketId!: number | undefined;
    organizationUnit!: OrganizationUnit | undefined;
    organizationUnitId!: number | undefined;
    ticketType!: SupportTicketType | undefined;
    ticketTypeId!: number;
    ticketStatus!: SupportTicketStatus | undefined;
    ticketStatusId!: number;
    tester!: string | undefined;
    assigned!: string | undefined;
    creator!: string | undefined;
    manager!: string | undefined;
    developer!: string | undefined;
    technicalSupport!: string | undefined;
    organizationalUnit!: string | undefined;
    shortDescription!: string;
    description!: string;
    rootCause!: string;
    solution!: string;
    environment!: string;
    priority!: number;
    startDate!: moment.Moment;
    dueDate!: moment.Moment;
    effortHour!: number;
    supportTicketCategory!: SupportTicketCategory[] | undefined;
    version!: Version | undefined;
    versionId!: number | undefined;
    tenantModifier!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicket) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.parentId = data["parentId"];
            this.assignedTo = data["assignedTo"] ? User.fromJS(data["assignedTo"]) : <any>undefined;
            this.assignedToId = data["assignedToId"];
            this.testerUser = data["testerUser"] ? User.fromJS(data["testerUser"]) : <any>undefined;
            this.testerUserId = data["testerUserId"];
            this.managerUser = data["managerUser"] ? User.fromJS(data["managerUser"]) : <any>undefined;
            this.managerId = data["managerId"];
            this.developerUser = data["developerUser"] ? User.fromJS(data["developerUser"]) : <any>undefined;
            this.developerId = data["developerId"];
            this.technicalSupportUser = data["technicalSupportUser"] ? User.fromJS(data["technicalSupportUser"]) : <any>undefined;
            this.technicalSupportId = data["technicalSupportId"];
            this.parentTicketId = data["parentTicketId"];
            this.organizationUnit = data["organizationUnit"] ? OrganizationUnit.fromJS(data["organizationUnit"]) : <any>undefined;
            this.organizationUnitId = data["organizationUnitId"];
            this.ticketType = data["ticketType"] ? SupportTicketType.fromJS(data["ticketType"]) : <any>undefined;
            this.ticketTypeId = data["ticketTypeId"];
            this.ticketStatus = data["ticketStatus"] ? SupportTicketStatus.fromJS(data["ticketStatus"]) : <any>undefined;
            this.ticketStatusId = data["ticketStatusId"];
            this.tester = data["tester"];
            this.assigned = data["assigned"];
            this.creator = data["creator"];
            this.manager = data["manager"];
            this.developer = data["developer"];
            this.technicalSupport = data["technicalSupport"];
            this.organizationalUnit = data["organizationalUnit"];
            this.shortDescription = data["shortDescription"];
            this.description = data["description"];
            this.rootCause = data["rootCause"];
            this.solution = data["solution"];
            this.environment = data["environment"];
            this.priority = data["priority"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.dueDate = data["dueDate"] ? moment(data["dueDate"].toString()) : <any>undefined;
            this.effortHour = data["effortHour"];
            if (Array.isArray(data["supportTicketCategory"])) {
                this.supportTicketCategory = [] as any;
                for (let item of data["supportTicketCategory"])
                    this.supportTicketCategory!.push(SupportTicketCategory.fromJS(item));
            }
            this.version = data["version"] ? Version.fromJS(data["version"]) : <any>undefined;
            this.versionId = data["versionId"];
            this.tenantModifier = data["tenantModifier"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicket {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicket();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["parentId"] = this.parentId;
        data["assignedTo"] = this.assignedTo ? this.assignedTo.toJSON() : <any>undefined;
        data["assignedToId"] = this.assignedToId;
        data["testerUser"] = this.testerUser ? this.testerUser.toJSON() : <any>undefined;
        data["testerUserId"] = this.testerUserId;
        data["managerUser"] = this.managerUser ? this.managerUser.toJSON() : <any>undefined;
        data["managerId"] = this.managerId;
        data["developerUser"] = this.developerUser ? this.developerUser.toJSON() : <any>undefined;
        data["developerId"] = this.developerId;
        data["technicalSupportUser"] = this.technicalSupportUser ? this.technicalSupportUser.toJSON() : <any>undefined;
        data["technicalSupportId"] = this.technicalSupportId;
        data["parentTicketId"] = this.parentTicketId;
        data["organizationUnit"] = this.organizationUnit ? this.organizationUnit.toJSON() : <any>undefined;
        data["organizationUnitId"] = this.organizationUnitId;
        data["ticketType"] = this.ticketType ? this.ticketType.toJSON() : <any>undefined;
        data["ticketTypeId"] = this.ticketTypeId;
        data["ticketStatus"] = this.ticketStatus ? this.ticketStatus.toJSON() : <any>undefined;
        data["ticketStatusId"] = this.ticketStatusId;
        data["tester"] = this.tester;
        data["assigned"] = this.assigned;
        data["creator"] = this.creator;
        data["manager"] = this.manager;
        data["developer"] = this.developer;
        data["technicalSupport"] = this.technicalSupport;
        data["organizationalUnit"] = this.organizationalUnit;
        data["shortDescription"] = this.shortDescription;
        data["description"] = this.description;
        data["rootCause"] = this.rootCause;
        data["solution"] = this.solution;
        data["environment"] = this.environment;
        data["priority"] = this.priority;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["dueDate"] = this.dueDate ? this.dueDate.toISOString() : <any>undefined;
        data["effortHour"] = this.effortHour;
        if (Array.isArray(this.supportTicketCategory)) {
            data["supportTicketCategory"] = [];
            for (let item of this.supportTicketCategory)
                data["supportTicketCategory"].push(item.toJSON());
        }
        data["version"] = this.version ? this.version.toJSON() : <any>undefined;
        data["versionId"] = this.versionId;
        data["tenantModifier"] = this.tenantModifier;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicket {
    tenantId: number | undefined;
    parentId: number | undefined;
    assignedTo: User | undefined;
    assignedToId: number | undefined;
    testerUser: User | undefined;
    testerUserId: number | undefined;
    managerUser: User | undefined;
    managerId: number | undefined;
    developerUser: User | undefined;
    developerId: number | undefined;
    technicalSupportUser: User | undefined;
    technicalSupportId: number | undefined;
    parentTicketId: number | undefined;
    organizationUnit: OrganizationUnit | undefined;
    organizationUnitId: number | undefined;
    ticketType: SupportTicketType | undefined;
    ticketTypeId: number;
    ticketStatus: SupportTicketStatus | undefined;
    ticketStatusId: number;
    tester: string | undefined;
    assigned: string | undefined;
    creator: string | undefined;
    manager: string | undefined;
    developer: string | undefined;
    technicalSupport: string | undefined;
    organizationalUnit: string | undefined;
    shortDescription: string;
    description: string;
    rootCause: string;
    solution: string;
    environment: string;
    priority: number;
    startDate: moment.Moment;
    dueDate: moment.Moment;
    effortHour: number;
    supportTicketCategory: SupportTicketCategory[] | undefined;
    version: Version | undefined;
    versionId: number | undefined;
    tenantModifier: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SupportTicketCategory implements ISupportTicketCategory {
    tenantId!: number | undefined;
    supportTicket!: SupportTicket | undefined;
    supportTicketId!: number;
    supportCategoryType!: SupportCategoryTypes | undefined;
    supportCategoryTypeId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketCategory) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.supportTicket = data["supportTicket"] ? SupportTicket.fromJS(data["supportTicket"]) : <any>undefined;
            this.supportTicketId = data["supportTicketId"];
            this.supportCategoryType = data["supportCategoryType"] ? SupportCategoryTypes.fromJS(data["supportCategoryType"]) : <any>undefined;
            this.supportCategoryTypeId = data["supportCategoryTypeId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketCategory {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketCategory();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["supportTicket"] = this.supportTicket ? this.supportTicket.toJSON() : <any>undefined;
        data["supportTicketId"] = this.supportTicketId;
        data["supportCategoryType"] = this.supportCategoryType ? this.supportCategoryType.toJSON() : <any>undefined;
        data["supportCategoryTypeId"] = this.supportCategoryTypeId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketCategory {
    tenantId: number | undefined;
    supportTicket: SupportTicket | undefined;
    supportTicketId: number;
    supportCategoryType: SupportCategoryTypes | undefined;
    supportCategoryTypeId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteDestination implements IRouteDestination {
    tenantId!: number | undefined;
    routeId!: number;
    route!: Route | undefined;
    destinationId!: number;
    destinationDetail!: DestinationDetail | undefined;
    sortOrder!: number | undefined;
    arrivalTime!: moment.Moment | undefined;
    completionTime!: moment.Moment | undefined;
    scheduleId!: number;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteDestination) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeId = data["routeId"];
            this.route = data["route"] ? Route.fromJS(data["route"]) : <any>undefined;
            this.destinationId = data["destinationId"];
            this.destinationDetail = data["destinationDetail"] ? DestinationDetail.fromJS(data["destinationDetail"]) : <any>undefined;
            this.sortOrder = data["sortOrder"];
            this.arrivalTime = data["arrivalTime"] ? moment(data["arrivalTime"].toString()) : <any>undefined;
            this.completionTime = data["completionTime"] ? moment(data["completionTime"].toString()) : <any>undefined;
            this.scheduleId = data["scheduleId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteDestination {
        data = typeof data === 'object' ? data : {};
        let result = new RouteDestination();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeId"] = this.routeId;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["destinationId"] = this.destinationId;
        data["destinationDetail"] = this.destinationDetail ? this.destinationDetail.toJSON() : <any>undefined;
        data["sortOrder"] = this.sortOrder;
        data["arrivalTime"] = this.arrivalTime ? this.arrivalTime.toISOString() : <any>undefined;
        data["completionTime"] = this.completionTime ? this.completionTime.toISOString() : <any>undefined;
        data["scheduleId"] = this.scheduleId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteDestination {
    tenantId: number | undefined;
    routeId: number;
    route: Route | undefined;
    destinationId: number;
    destinationDetail: DestinationDetail | undefined;
    sortOrder: number | undefined;
    arrivalTime: moment.Moment | undefined;
    completionTime: moment.Moment | undefined;
    scheduleId: number;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Holiday implements IHoliday {
    tenantId!: number | undefined;
    description!: string;
    isActive!: number;
    from!: moment.Moment;
    to!: moment.Moment;
    color!: string;
    code!: string;
    selectionType!: SelectionType;
    cutOffAdjustment!: number | undefined;
    actionType!: ActionType;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IHoliday) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.description = data["description"];
            this.isActive = data["isActive"];
            this.from = data["from"] ? moment(data["from"].toString()) : <any>undefined;
            this.to = data["to"] ? moment(data["to"].toString()) : <any>undefined;
            this.color = data["color"];
            this.code = data["code"];
            this.selectionType = data["selectionType"];
            this.cutOffAdjustment = data["cutOffAdjustment"];
            this.actionType = data["actionType"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Holiday {
        data = typeof data === 'object' ? data : {};
        let result = new Holiday();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["description"] = this.description;
        data["isActive"] = this.isActive;
        data["from"] = this.from ? this.from.toISOString() : <any>undefined;
        data["to"] = this.to ? this.to.toISOString() : <any>undefined;
        data["color"] = this.color;
        data["code"] = this.code;
        data["selectionType"] = this.selectionType;
        data["cutOffAdjustment"] = this.cutOffAdjustment;
        data["actionType"] = this.actionType;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IHoliday {
    tenantId: number | undefined;
    description: string;
    isActive: number;
    from: moment.Moment;
    to: moment.Moment;
    color: string;
    code: string;
    selectionType: SelectionType;
    cutOffAdjustment: number | undefined;
    actionType: ActionType;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class LocationCalendarRoute implements ILocationCalendarRoute {
    tenantId!: number | undefined;
    locationId!: number | undefined;
    locationFk!: Location | undefined;
    holidayId!: number | undefined;
    holidayFk!: Holiday | undefined;
    routeTemplateId!: number | undefined;
    routeTemplateFk!: RouteTemplate | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ILocationCalendarRoute) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.locationId = data["locationId"];
            this.locationFk = data["locationFk"] ? Location.fromJS(data["locationFk"]) : <any>undefined;
            this.holidayId = data["holidayId"];
            this.holidayFk = data["holidayFk"] ? Holiday.fromJS(data["holidayFk"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.routeTemplateFk = data["routeTemplateFk"] ? RouteTemplate.fromJS(data["routeTemplateFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): LocationCalendarRoute {
        data = typeof data === 'object' ? data : {};
        let result = new LocationCalendarRoute();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["locationId"] = this.locationId;
        data["locationFk"] = this.locationFk ? this.locationFk.toJSON() : <any>undefined;
        data["holidayId"] = this.holidayId;
        data["holidayFk"] = this.holidayFk ? this.holidayFk.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeTemplateFk"] = this.routeTemplateFk ? this.routeTemplateFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ILocationCalendarRoute {
    tenantId: number | undefined;
    locationId: number | undefined;
    locationFk: Location | undefined;
    holidayId: number | undefined;
    holidayFk: Holiday | undefined;
    routeTemplateId: number | undefined;
    routeTemplateFk: RouteTemplate | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class LocationHoliday implements ILocationHoliday {
    tenantId!: number | undefined;
    locationId!: number | undefined;
    locationFk!: Location | undefined;
    holidayId!: number | undefined;
    holidayFk!: Holiday | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ILocationHoliday) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.locationId = data["locationId"];
            this.locationFk = data["locationFk"] ? Location.fromJS(data["locationFk"]) : <any>undefined;
            this.holidayId = data["holidayId"];
            this.holidayFk = data["holidayFk"] ? Holiday.fromJS(data["holidayFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): LocationHoliday {
        data = typeof data === 'object' ? data : {};
        let result = new LocationHoliday();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["locationId"] = this.locationId;
        data["locationFk"] = this.locationFk ? this.locationFk.toJSON() : <any>undefined;
        data["holidayId"] = this.holidayId;
        data["holidayFk"] = this.holidayFk ? this.holidayFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ILocationHoliday {
    tenantId: number | undefined;
    locationId: number | undefined;
    locationFk: Location | undefined;
    holidayId: number | undefined;
    holidayFk: Holiday | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DriverIncidentType implements IDriverIncidentType {
    tenantId!: number | undefined;
    name!: string;
    code!: string;
    sortOrder!: number;
    isStatic!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDriverIncidentType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.code = data["code"];
            this.sortOrder = data["sortOrder"];
            this.isStatic = data["isStatic"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DriverIncidentType {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncidentType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["sortOrder"] = this.sortOrder;
        data["isStatic"] = this.isStatic;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDriverIncidentType {
    tenantId: number | undefined;
    name: string;
    code: string;
    sortOrder: number;
    isStatic: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class IncidentStatuses implements IIncidentStatuses {
    tenantId!: number | undefined;
    name!: string | undefined;
    code!: string | undefined;
    static!: boolean;
    color!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IIncidentStatuses) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.code = data["code"];
            this.static = data["static"];
            this.color = data["color"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentStatuses {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentStatuses();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["static"] = this.static;
        data["color"] = this.color;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentStatuses {
    tenantId: number | undefined;
    name: string | undefined;
    code: string | undefined;
    static: boolean;
    color: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Incident implements IIncident {
    creatorUser!: User | undefined;
    lastModifiedUser!: User | undefined;
    deleterUser!: User | undefined;
    tenantId!: number | undefined;
    geocode!: Geocode | undefined;
    geocodeId!: number | undefined;
    content!: string;
    managerUserId!: number | undefined;
    email!: string | undefined;
    incidentDate!: moment.Moment;
    incidentStatusId!: number | undefined;
    incidentStatuses!: IncidentStatuses | undefined;
    incidentSourceId!: number | undefined;
    incidentSource!: IncidentSource | undefined;
    complaint!: string | undefined;
    investigation!: string | undefined;
    resolution!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IIncident) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.creatorUser = data["creatorUser"] ? User.fromJS(data["creatorUser"]) : <any>undefined;
            this.lastModifiedUser = data["lastModifiedUser"] ? User.fromJS(data["lastModifiedUser"]) : <any>undefined;
            this.deleterUser = data["deleterUser"] ? User.fromJS(data["deleterUser"]) : <any>undefined;
            this.tenantId = data["tenantId"];
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.content = data["content"];
            this.managerUserId = data["managerUserId"];
            this.email = data["email"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.incidentStatusId = data["incidentStatusId"];
            this.incidentStatuses = data["incidentStatuses"] ? IncidentStatuses.fromJS(data["incidentStatuses"]) : <any>undefined;
            this.incidentSourceId = data["incidentSourceId"];
            this.incidentSource = data["incidentSource"] ? IncidentSource.fromJS(data["incidentSource"]) : <any>undefined;
            this.complaint = data["complaint"];
            this.investigation = data["investigation"];
            this.resolution = data["resolution"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Incident {
        data = typeof data === 'object' ? data : {};
        let result = new Incident();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["creatorUser"] = this.creatorUser ? this.creatorUser.toJSON() : <any>undefined;
        data["lastModifiedUser"] = this.lastModifiedUser ? this.lastModifiedUser.toJSON() : <any>undefined;
        data["deleterUser"] = this.deleterUser ? this.deleterUser.toJSON() : <any>undefined;
        data["tenantId"] = this.tenantId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["content"] = this.content;
        data["managerUserId"] = this.managerUserId;
        data["email"] = this.email;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["incidentStatusId"] = this.incidentStatusId;
        data["incidentStatuses"] = this.incidentStatuses ? this.incidentStatuses.toJSON() : <any>undefined;
        data["incidentSourceId"] = this.incidentSourceId;
        data["incidentSource"] = this.incidentSource ? this.incidentSource.toJSON() : <any>undefined;
        data["complaint"] = this.complaint;
        data["investigation"] = this.investigation;
        data["resolution"] = this.resolution;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncident {
    creatorUser: User | undefined;
    lastModifiedUser: User | undefined;
    deleterUser: User | undefined;
    tenantId: number | undefined;
    geocode: Geocode | undefined;
    geocodeId: number | undefined;
    content: string;
    managerUserId: number | undefined;
    email: string | undefined;
    incidentDate: moment.Moment;
    incidentStatusId: number | undefined;
    incidentStatuses: IncidentStatuses | undefined;
    incidentSourceId: number | undefined;
    incidentSource: IncidentSource | undefined;
    complaint: string | undefined;
    investigation: string | undefined;
    resolution: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class EmployeeIncidentType implements IEmployeeIncidentType {
    tenantId!: number | undefined;
    name!: string;
    code!: string;
    sortOrder!: number;
    isStatic!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IEmployeeIncidentType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.code = data["code"];
            this.sortOrder = data["sortOrder"];
            this.isStatic = data["isStatic"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EmployeeIncidentType {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncidentType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["sortOrder"] = this.sortOrder;
        data["isStatic"] = this.isStatic;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEmployeeIncidentType {
    tenantId: number | undefined;
    name: string;
    code: string;
    sortOrder: number;
    isStatic: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class EmployeeIncident implements IEmployeeIncident {
    tenantId!: number | undefined;
    user!: User;
    userId!: number;
    incident!: Incident;
    incidentId!: number;
    employeeIncidentType!: EmployeeIncidentType | undefined;
    employeeIncidentTypeId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IEmployeeIncident) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new User();
            this.incident = new Incident();
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : new User();
            this.userId = data["userId"];
            this.incident = data["incident"] ? Incident.fromJS(data["incident"]) : new Incident();
            this.incidentId = data["incidentId"];
            this.employeeIncidentType = data["employeeIncidentType"] ? EmployeeIncidentType.fromJS(data["employeeIncidentType"]) : <any>undefined;
            this.employeeIncidentTypeId = data["employeeIncidentTypeId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EmployeeIncident {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeIncident();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["incident"] = this.incident ? this.incident.toJSON() : <any>undefined;
        data["incidentId"] = this.incidentId;
        data["employeeIncidentType"] = this.employeeIncidentType ? this.employeeIncidentType.toJSON() : <any>undefined;
        data["employeeIncidentTypeId"] = this.employeeIncidentTypeId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEmployeeIncident {
    tenantId: number | undefined;
    user: User;
    userId: number;
    incident: Incident;
    incidentId: number;
    employeeIncidentType: EmployeeIncidentType | undefined;
    employeeIncidentTypeId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Employee implements IEmployee {
    tenantId!: number | undefined;
    user!: User;
    userId!: number;
    contact!: Contact;
    contactId!: number | undefined;
    startDate!: moment.Moment | undefined;
    hourlyRate!: number | undefined;
    dailyRate!: number | undefined;
    idNumber!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IEmployee) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new User();
            this.contact = new Contact();
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : new User();
            this.userId = data["userId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : new Contact();
            this.contactId = data["contactId"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.hourlyRate = data["hourlyRate"];
            this.dailyRate = data["dailyRate"];
            this.idNumber = data["idNumber"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Employee {
        data = typeof data === 'object' ? data : {};
        let result = new Employee();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["hourlyRate"] = this.hourlyRate;
        data["dailyRate"] = this.dailyRate;
        data["idNumber"] = this.idNumber;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEmployee {
    tenantId: number | undefined;
    user: User;
    userId: number;
    contact: Contact;
    contactId: number | undefined;
    startDate: moment.Moment | undefined;
    hourlyRate: number | undefined;
    dailyRate: number | undefined;
    idNumber: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderNotificationTemplate implements IOrderNotificationTemplate {
    tenantId!: number | undefined;
    isActive!: boolean;
    description!: string | undefined;
    template!: string | undefined;
    code!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderNotificationTemplate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.template = data["template"];
            this.code = data["code"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderNotificationTemplate {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNotificationTemplate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["template"] = this.template;
        data["code"] = this.code;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderNotificationTemplate {
    tenantId: number | undefined;
    isActive: boolean;
    description: string | undefined;
    template: string | undefined;
    code: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SmsAccount implements ISmsAccount {
    tenantId!: number | undefined;
    active!: boolean;
    account!: string | undefined;
    accountSid!: string | undefined;
    authToken!: string | undefined;
    senderNumber!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISmsAccount) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.active = data["active"];
            this.account = data["account"];
            this.accountSid = data["accountSid"];
            this.authToken = data["authToken"];
            this.senderNumber = data["senderNumber"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SmsAccount {
        data = typeof data === 'object' ? data : {};
        let result = new SmsAccount();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["active"] = this.active;
        data["account"] = this.account;
        data["accountSid"] = this.accountSid;
        data["authToken"] = this.authToken;
        data["senderNumber"] = this.senderNumber;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISmsAccount {
    tenantId: number | undefined;
    active: boolean;
    account: string | undefined;
    accountSid: string | undefined;
    authToken: string | undefined;
    senderNumber: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SmsTemplate implements ISmsTemplate {
    tenantId!: number | undefined;
    description!: string | undefined;
    template!: string | undefined;
    isActive!: boolean;
    code!: string | undefined;
    smsAccountId!: number | undefined;
    smsAccountFk!: SmsAccount | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISmsTemplate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.description = data["description"];
            this.template = data["template"];
            this.isActive = data["isActive"];
            this.code = data["code"];
            this.smsAccountId = data["smsAccountId"];
            this.smsAccountFk = data["smsAccountFk"] ? SmsAccount.fromJS(data["smsAccountFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SmsTemplate {
        data = typeof data === 'object' ? data : {};
        let result = new SmsTemplate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["description"] = this.description;
        data["template"] = this.template;
        data["isActive"] = this.isActive;
        data["code"] = this.code;
        data["smsAccountId"] = this.smsAccountId;
        data["smsAccountFk"] = this.smsAccountFk ? this.smsAccountFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISmsTemplate {
    tenantId: number | undefined;
    description: string | undefined;
    template: string | undefined;
    isActive: boolean;
    code: string | undefined;
    smsAccountId: number | undefined;
    smsAccountFk: SmsAccount | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SupportTicketNotification implements ISupportTicketNotification {
    tenantId!: number | undefined;
    description!: string | undefined;
    code!: string | undefined;
    isActive!: boolean;
    supportTicketNotificationRecipients!: SupportTicketNotificationRecipients[] | undefined;
    orderNotificationTemplateId!: number | undefined;
    orderNotificationTemplateFk!: OrderNotificationTemplate | undefined;
    supportTicketStatusId!: number | undefined;
    supportTicketStatusFk!: SupportTicketStatus | undefined;
    smsTemplateId!: number | undefined;
    smsTemplateFk!: SmsTemplate | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketNotification) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.description = data["description"];
            this.code = data["code"];
            this.isActive = data["isActive"];
            if (Array.isArray(data["supportTicketNotificationRecipients"])) {
                this.supportTicketNotificationRecipients = [] as any;
                for (let item of data["supportTicketNotificationRecipients"])
                    this.supportTicketNotificationRecipients!.push(SupportTicketNotificationRecipients.fromJS(item));
            }
            this.orderNotificationTemplateId = data["orderNotificationTemplateId"];
            this.orderNotificationTemplateFk = data["orderNotificationTemplateFk"] ? OrderNotificationTemplate.fromJS(data["orderNotificationTemplateFk"]) : <any>undefined;
            this.supportTicketStatusId = data["supportTicketStatusId"];
            this.supportTicketStatusFk = data["supportTicketStatusFk"] ? SupportTicketStatus.fromJS(data["supportTicketStatusFk"]) : <any>undefined;
            this.smsTemplateId = data["smsTemplateId"];
            this.smsTemplateFk = data["smsTemplateFk"] ? SmsTemplate.fromJS(data["smsTemplateFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketNotification {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotification();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["description"] = this.description;
        data["code"] = this.code;
        data["isActive"] = this.isActive;
        if (Array.isArray(this.supportTicketNotificationRecipients)) {
            data["supportTicketNotificationRecipients"] = [];
            for (let item of this.supportTicketNotificationRecipients)
                data["supportTicketNotificationRecipients"].push(item.toJSON());
        }
        data["orderNotificationTemplateId"] = this.orderNotificationTemplateId;
        data["orderNotificationTemplateFk"] = this.orderNotificationTemplateFk ? this.orderNotificationTemplateFk.toJSON() : <any>undefined;
        data["supportTicketStatusId"] = this.supportTicketStatusId;
        data["supportTicketStatusFk"] = this.supportTicketStatusFk ? this.supportTicketStatusFk.toJSON() : <any>undefined;
        data["smsTemplateId"] = this.smsTemplateId;
        data["smsTemplateFk"] = this.smsTemplateFk ? this.smsTemplateFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketNotification {
    tenantId: number | undefined;
    description: string | undefined;
    code: string | undefined;
    isActive: boolean;
    supportTicketNotificationRecipients: SupportTicketNotificationRecipients[] | undefined;
    orderNotificationTemplateId: number | undefined;
    orderNotificationTemplateFk: OrderNotificationTemplate | undefined;
    supportTicketStatusId: number | undefined;
    supportTicketStatusFk: SupportTicketStatus | undefined;
    smsTemplateId: number | undefined;
    smsTemplateFk: SmsTemplate | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SupportTicketNotificationRecipients implements ISupportTicketNotificationRecipients {
    isEmail!: boolean;
    isSMS!: boolean;
    isActive!: boolean;
    emailAddress!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    organizationUnitFk!: OrganizationUnit | undefined;
    userId!: number | undefined;
    userFk!: User | undefined;
    supportTicketNotificationId!: number | undefined;
    supportTicketNotificationFk!: SupportTicketNotification | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketNotificationRecipients) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEmail = data["isEmail"];
            this.isSMS = data["isSMS"];
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.organizationUnitFk = data["organizationUnitFk"] ? OrganizationUnit.fromJS(data["organizationUnitFk"]) : <any>undefined;
            this.userId = data["userId"];
            this.userFk = data["userFk"] ? User.fromJS(data["userFk"]) : <any>undefined;
            this.supportTicketNotificationId = data["supportTicketNotificationId"];
            this.supportTicketNotificationFk = data["supportTicketNotificationFk"] ? SupportTicketNotification.fromJS(data["supportTicketNotificationFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationRecipients {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationRecipients();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEmail"] = this.isEmail;
        data["isSMS"] = this.isSMS;
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["organizationUnitFk"] = this.organizationUnitFk ? this.organizationUnitFk.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["userFk"] = this.userFk ? this.userFk.toJSON() : <any>undefined;
        data["supportTicketNotificationId"] = this.supportTicketNotificationId;
        data["supportTicketNotificationFk"] = this.supportTicketNotificationFk ? this.supportTicketNotificationFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketNotificationRecipients {
    isEmail: boolean;
    isSMS: boolean;
    isActive: boolean;
    emailAddress: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    organizationUnitFk: OrganizationUnit | undefined;
    userId: number | undefined;
    userFk: User | undefined;
    supportTicketNotificationId: number | undefined;
    supportTicketNotificationFk: SupportTicketNotification | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class IncidentType implements IIncidentType {
    tenantId!: number | undefined;
    name!: string | undefined;
    code!: string | undefined;
    sortOrder!: number;
    isStatic!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IIncidentType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.code = data["code"];
            this.sortOrder = data["sortOrder"];
            this.isStatic = data["isStatic"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentType {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["code"] = this.code;
        data["sortOrder"] = this.sortOrder;
        data["isStatic"] = this.isStatic;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentType {
    tenantId: number | undefined;
    name: string | undefined;
    code: string | undefined;
    sortOrder: number;
    isStatic: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderNotification implements IOrderNotification {
    tenantId!: number | undefined;
    code!: string;
    isActive!: boolean;
    description!: string | undefined;
    organizationUnitOrderNotification!: OrganizationUnitOrderNotification[] | undefined;
    orderNotificationTemplateId!: number | undefined;
    orderNotificationTemplateFk!: OrderNotificationTemplate | undefined;
    orderTypeId!: number | undefined;
    orderTypeFk!: OrderType | undefined;
    smsTemplateId!: number | undefined;
    smsTemplateFk!: SmsTemplate | undefined;
    orderStatusTypeId!: number | undefined;
    orderStatusTypeFk!: OrderStatusType | undefined;
    development!: boolean;
    orderTargetType!: number;
    incidentTypeId!: number | undefined;
    incidentType!: IncidentType | undefined;
    driverIncidentTypeId!: number | undefined;
    driverIncidentType!: DriverIncidentType | undefined;
    employeeIncidentTypeId!: number | undefined;
    employeeIncidentType!: EmployeeIncidentType | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderNotification) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            if (Array.isArray(data["organizationUnitOrderNotification"])) {
                this.organizationUnitOrderNotification = [] as any;
                for (let item of data["organizationUnitOrderNotification"])
                    this.organizationUnitOrderNotification!.push(OrganizationUnitOrderNotification.fromJS(item));
            }
            this.orderNotificationTemplateId = data["orderNotificationTemplateId"];
            this.orderNotificationTemplateFk = data["orderNotificationTemplateFk"] ? OrderNotificationTemplate.fromJS(data["orderNotificationTemplateFk"]) : <any>undefined;
            this.orderTypeId = data["orderTypeId"];
            this.orderTypeFk = data["orderTypeFk"] ? OrderType.fromJS(data["orderTypeFk"]) : <any>undefined;
            this.smsTemplateId = data["smsTemplateId"];
            this.smsTemplateFk = data["smsTemplateFk"] ? SmsTemplate.fromJS(data["smsTemplateFk"]) : <any>undefined;
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderStatusTypeFk = data["orderStatusTypeFk"] ? OrderStatusType.fromJS(data["orderStatusTypeFk"]) : <any>undefined;
            this.development = data["development"];
            this.orderTargetType = data["orderTargetType"];
            this.incidentTypeId = data["incidentTypeId"];
            this.incidentType = data["incidentType"] ? IncidentType.fromJS(data["incidentType"]) : <any>undefined;
            this.driverIncidentTypeId = data["driverIncidentTypeId"];
            this.driverIncidentType = data["driverIncidentType"] ? DriverIncidentType.fromJS(data["driverIncidentType"]) : <any>undefined;
            this.employeeIncidentTypeId = data["employeeIncidentTypeId"];
            this.employeeIncidentType = data["employeeIncidentType"] ? EmployeeIncidentType.fromJS(data["employeeIncidentType"]) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderNotification {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNotification();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        if (Array.isArray(this.organizationUnitOrderNotification)) {
            data["organizationUnitOrderNotification"] = [];
            for (let item of this.organizationUnitOrderNotification)
                data["organizationUnitOrderNotification"].push(item.toJSON());
        }
        data["orderNotificationTemplateId"] = this.orderNotificationTemplateId;
        data["orderNotificationTemplateFk"] = this.orderNotificationTemplateFk ? this.orderNotificationTemplateFk.toJSON() : <any>undefined;
        data["orderTypeId"] = this.orderTypeId;
        data["orderTypeFk"] = this.orderTypeFk ? this.orderTypeFk.toJSON() : <any>undefined;
        data["smsTemplateId"] = this.smsTemplateId;
        data["smsTemplateFk"] = this.smsTemplateFk ? this.smsTemplateFk.toJSON() : <any>undefined;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderStatusTypeFk"] = this.orderStatusTypeFk ? this.orderStatusTypeFk.toJSON() : <any>undefined;
        data["development"] = this.development;
        data["orderTargetType"] = this.orderTargetType;
        data["incidentTypeId"] = this.incidentTypeId;
        data["incidentType"] = this.incidentType ? this.incidentType.toJSON() : <any>undefined;
        data["driverIncidentTypeId"] = this.driverIncidentTypeId;
        data["driverIncidentType"] = this.driverIncidentType ? this.driverIncidentType.toJSON() : <any>undefined;
        data["employeeIncidentTypeId"] = this.employeeIncidentTypeId;
        data["employeeIncidentType"] = this.employeeIncidentType ? this.employeeIncidentType.toJSON() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderNotification {
    tenantId: number | undefined;
    code: string;
    isActive: boolean;
    description: string | undefined;
    organizationUnitOrderNotification: OrganizationUnitOrderNotification[] | undefined;
    orderNotificationTemplateId: number | undefined;
    orderNotificationTemplateFk: OrderNotificationTemplate | undefined;
    orderTypeId: number | undefined;
    orderTypeFk: OrderType | undefined;
    smsTemplateId: number | undefined;
    smsTemplateFk: SmsTemplate | undefined;
    orderStatusTypeId: number | undefined;
    orderStatusTypeFk: OrderStatusType | undefined;
    development: boolean;
    orderTargetType: number;
    incidentTypeId: number | undefined;
    incidentType: IncidentType | undefined;
    driverIncidentTypeId: number | undefined;
    driverIncidentType: DriverIncidentType | undefined;
    employeeIncidentTypeId: number | undefined;
    employeeIncidentType: EmployeeIncidentType | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrganizationUnitOrderNotification implements IOrganizationUnitOrderNotification {
    tenantId!: number | undefined;
    isEmail!: boolean;
    isSMS!: boolean;
    isActive!: boolean;
    emailAddress!: string | undefined;
    phoneNumber!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    organizationUnitFk!: OrganizationUnit | undefined;
    orderNotificationId!: number | undefined;
    orderNotificationFk!: OrderNotification | undefined;
    userId!: number | undefined;
    userFk!: User | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrganizationUnitOrderNotification) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.isEmail = data["isEmail"];
            this.isSMS = data["isSMS"];
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.phoneNumber = data["phoneNumber"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.organizationUnitFk = data["organizationUnitFk"] ? OrganizationUnit.fromJS(data["organizationUnitFk"]) : <any>undefined;
            this.orderNotificationId = data["orderNotificationId"];
            this.orderNotificationFk = data["orderNotificationFk"] ? OrderNotification.fromJS(data["orderNotificationFk"]) : <any>undefined;
            this.userId = data["userId"];
            this.userFk = data["userFk"] ? User.fromJS(data["userFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrganizationUnitOrderNotification {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnitOrderNotification();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["isEmail"] = this.isEmail;
        data["isSMS"] = this.isSMS;
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["phoneNumber"] = this.phoneNumber;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["organizationUnitFk"] = this.organizationUnitFk ? this.organizationUnitFk.toJSON() : <any>undefined;
        data["orderNotificationId"] = this.orderNotificationId;
        data["orderNotificationFk"] = this.orderNotificationFk ? this.orderNotificationFk.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["userFk"] = this.userFk ? this.userFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrganizationUnitOrderNotification {
    tenantId: number | undefined;
    isEmail: boolean;
    isSMS: boolean;
    isActive: boolean;
    emailAddress: string | undefined;
    phoneNumber: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    organizationUnitFk: OrganizationUnit | undefined;
    orderNotificationId: number | undefined;
    orderNotificationFk: OrderNotification | undefined;
    userId: number | undefined;
    userFk: User | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class VehicleChecklist implements IVehicleChecklist {
    tenantId!: number | undefined;
    code!: string;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    isActive!: boolean;
    isRequired!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IVehicleChecklist) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.isActive = data["isActive"];
            this.isRequired = data["isRequired"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VehicleChecklist {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleChecklist();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["isActive"] = this.isActive;
        data["isRequired"] = this.isRequired;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicleChecklist {
    tenantId: number | undefined;
    code: string;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    isActive: boolean;
    isRequired: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Route4MeSetting implements IRoute4MeSetting {
    tenantId!: number | undefined;
    code!: string;
    value!: string | undefined;
    id!: number;

    constructor(data?: IRoute4MeSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Route4MeSetting {
        data = typeof data === 'object' ? data : {};
        let result = new Route4MeSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRoute4MeSetting {
    tenantId: number | undefined;
    code: string;
    value: string | undefined;
    id: number;
}

export class Route4MeDataImport implements IRoute4MeDataImport {
    id!: number;
    addressId!: number | undefined;
    account!: string | undefined;
    addressLine1!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    postalCode!: string | undefined;
    latitude!: number | undefined;
    longitude!: number | undefined;
    routeCode!: string | undefined;
    routeType!: string | undefined;
    oldEta!: TimeSpan | undefined;
    newEta!: TimeSpan | undefined;
    startAddress!: string | undefined;
    startAddressId!: number | undefined;
    startAddressLine1!: string | undefined;
    startCity!: string | undefined;
    startState!: string | undefined;
    startPostalCode!: string | undefined;
    startLatitude!: number | undefined;
    startLongitude!: number | undefined;
    startTime!: TimeSpan | undefined;
    endAddress!: string | undefined;
    endAddressId!: number | undefined;
    endAddressLine1!: string | undefined;
    endCity!: string | undefined;
    endState!: string | undefined;
    endPostalCode!: string | undefined;
    endLatitude!: number | undefined;
    endLongitude!: number | undefined;
    clinicName!: string | undefined;
    sequence!: number | undefined;
    auto!: number;

    constructor(data?: IRoute4MeDataImport) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.addressId = data["addressId"];
            this.account = data["account"];
            this.addressLine1 = data["addressLine1"];
            this.city = data["city"];
            this.state = data["state"];
            this.postalCode = data["postalCode"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.routeCode = data["routeCode"];
            this.routeType = data["routeType"];
            this.oldEta = data["oldEta"] ? TimeSpan.fromJS(data["oldEta"]) : <any>undefined;
            this.newEta = data["newEta"] ? TimeSpan.fromJS(data["newEta"]) : <any>undefined;
            this.startAddress = data["startAddress"];
            this.startAddressId = data["startAddressId"];
            this.startAddressLine1 = data["startAddressLine1"];
            this.startCity = data["startCity"];
            this.startState = data["startState"];
            this.startPostalCode = data["startPostalCode"];
            this.startLatitude = data["startLatitude"];
            this.startLongitude = data["startLongitude"];
            this.startTime = data["startTime"] ? TimeSpan.fromJS(data["startTime"]) : <any>undefined;
            this.endAddress = data["endAddress"];
            this.endAddressId = data["endAddressId"];
            this.endAddressLine1 = data["endAddressLine1"];
            this.endCity = data["endCity"];
            this.endState = data["endState"];
            this.endPostalCode = data["endPostalCode"];
            this.endLatitude = data["endLatitude"];
            this.endLongitude = data["endLongitude"];
            this.clinicName = data["clinicName"];
            this.sequence = data["sequence"];
            this.auto = data["auto"];
        }
    }

    static fromJS(data: any): Route4MeDataImport {
        data = typeof data === 'object' ? data : {};
        let result = new Route4MeDataImport();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["addressId"] = this.addressId;
        data["account"] = this.account;
        data["addressLine1"] = this.addressLine1;
        data["city"] = this.city;
        data["state"] = this.state;
        data["postalCode"] = this.postalCode;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["routeCode"] = this.routeCode;
        data["routeType"] = this.routeType;
        data["oldEta"] = this.oldEta ? this.oldEta.toJSON() : <any>undefined;
        data["newEta"] = this.newEta ? this.newEta.toJSON() : <any>undefined;
        data["startAddress"] = this.startAddress;
        data["startAddressId"] = this.startAddressId;
        data["startAddressLine1"] = this.startAddressLine1;
        data["startCity"] = this.startCity;
        data["startState"] = this.startState;
        data["startPostalCode"] = this.startPostalCode;
        data["startLatitude"] = this.startLatitude;
        data["startLongitude"] = this.startLongitude;
        data["startTime"] = this.startTime ? this.startTime.toJSON() : <any>undefined;
        data["endAddress"] = this.endAddress;
        data["endAddressId"] = this.endAddressId;
        data["endAddressLine1"] = this.endAddressLine1;
        data["endCity"] = this.endCity;
        data["endState"] = this.endState;
        data["endPostalCode"] = this.endPostalCode;
        data["endLatitude"] = this.endLatitude;
        data["endLongitude"] = this.endLongitude;
        data["clinicName"] = this.clinicName;
        data["sequence"] = this.sequence;
        data["auto"] = this.auto;
        return data; 
    }
}

export interface IRoute4MeDataImport {
    id: number;
    addressId: number | undefined;
    account: string | undefined;
    addressLine1: string | undefined;
    city: string | undefined;
    state: string | undefined;
    postalCode: string | undefined;
    latitude: number | undefined;
    longitude: number | undefined;
    routeCode: string | undefined;
    routeType: string | undefined;
    oldEta: TimeSpan | undefined;
    newEta: TimeSpan | undefined;
    startAddress: string | undefined;
    startAddressId: number | undefined;
    startAddressLine1: string | undefined;
    startCity: string | undefined;
    startState: string | undefined;
    startPostalCode: string | undefined;
    startLatitude: number | undefined;
    startLongitude: number | undefined;
    startTime: TimeSpan | undefined;
    endAddress: string | undefined;
    endAddressId: number | undefined;
    endAddressLine1: string | undefined;
    endCity: string | undefined;
    endState: string | undefined;
    endPostalCode: string | undefined;
    endLatitude: number | undefined;
    endLongitude: number | undefined;
    clinicName: string | undefined;
    sequence: number | undefined;
    auto: number;
}

export class BackgroundProcess implements IBackgroundProcess {
    tenantId!: number | undefined;
    jobId!: string | undefined;
    jobClass!: string | undefined;
    cronExpression!: string | undefined;
    isActive!: boolean;
    description!: string | undefined;
    lastStartTime!: moment.Moment;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IBackgroundProcess) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.jobId = data["jobId"];
            this.jobClass = data["jobClass"];
            this.cronExpression = data["cronExpression"];
            this.isActive = data["isActive"];
            this.description = data["description"];
            this.lastStartTime = data["lastStartTime"] ? moment(data["lastStartTime"].toString()) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): BackgroundProcess {
        data = typeof data === 'object' ? data : {};
        let result = new BackgroundProcess();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["jobId"] = this.jobId;
        data["jobClass"] = this.jobClass;
        data["cronExpression"] = this.cronExpression;
        data["isActive"] = this.isActive;
        data["description"] = this.description;
        data["lastStartTime"] = this.lastStartTime ? this.lastStartTime.toISOString() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IBackgroundProcess {
    tenantId: number | undefined;
    jobId: string | undefined;
    jobClass: string | undefined;
    cronExpression: string | undefined;
    isActive: boolean;
    description: string | undefined;
    lastStartTime: moment.Moment;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderIncident implements IOrderIncident {
    tenantId!: number | undefined;
    orderId!: number | undefined;
    order!: Order | undefined;
    incidentId!: number;
    incident!: Incident | undefined;
    incidentTypeId!: number | undefined;
    incidentType!: IncidentType | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderIncident) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.orderId = data["orderId"];
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.incidentId = data["incidentId"];
            this.incident = data["incident"] ? Incident.fromJS(data["incident"]) : <any>undefined;
            this.incidentTypeId = data["incidentTypeId"];
            this.incidentType = data["incidentType"] ? IncidentType.fromJS(data["incidentType"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderIncident {
        data = typeof data === 'object' ? data : {};
        let result = new OrderIncident();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["orderId"] = this.orderId;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["incidentId"] = this.incidentId;
        data["incident"] = this.incident ? this.incident.toJSON() : <any>undefined;
        data["incidentTypeId"] = this.incidentTypeId;
        data["incidentType"] = this.incidentType ? this.incidentType.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderIncident {
    tenantId: number | undefined;
    orderId: number | undefined;
    order: Order | undefined;
    incidentId: number;
    incident: Incident | undefined;
    incidentTypeId: number | undefined;
    incidentType: IncidentType | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class IncidentNote implements IIncidentNote {
    tenantId!: number | undefined;
    incident!: Incident | undefined;
    incidentId!: number;
    note!: Note | undefined;
    noteId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IIncidentNote) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.incident = data["incident"] ? Incident.fromJS(data["incident"]) : <any>undefined;
            this.incidentId = data["incidentId"];
            this.note = data["note"] ? Note.fromJS(data["note"]) : <any>undefined;
            this.noteId = data["noteId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentNote {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentNote();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["incident"] = this.incident ? this.incident.toJSON() : <any>undefined;
        data["incidentId"] = this.incidentId;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["noteId"] = this.noteId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentNote {
    tenantId: number | undefined;
    incident: Incident | undefined;
    incidentId: number;
    note: Note | undefined;
    noteId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class IncidentAttachment implements IIncidentAttachment {
    incident!: Incident | undefined;
    incidentId!: number;
    filename!: string;
    data!: string | undefined;
    blobFile!: string | undefined;
    base64EncodedData!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IIncidentAttachment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incident = data["incident"] ? Incident.fromJS(data["incident"]) : <any>undefined;
            this.incidentId = data["incidentId"];
            this.filename = data["filename"];
            this.data = data["data"];
            this.blobFile = data["blobFile"];
            this.base64EncodedData = data["base64EncodedData"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentAttachment {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentAttachment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incident"] = this.incident ? this.incident.toJSON() : <any>undefined;
        data["incidentId"] = this.incidentId;
        data["filename"] = this.filename;
        data["data"] = this.data;
        data["blobFile"] = this.blobFile;
        data["base64EncodedData"] = this.base64EncodedData;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentAttachment {
    incident: Incident | undefined;
    incidentId: number;
    filename: string;
    data: string | undefined;
    blobFile: string | undefined;
    base64EncodedData: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ImportTable implements IImportTable {
    tableName!: string;
    tableCode!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IImportTable) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tableName = data["tableName"];
            this.tableCode = data["tableCode"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportTable {
        data = typeof data === 'object' ? data : {};
        let result = new ImportTable();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tableName"] = this.tableName;
        data["tableCode"] = this.tableCode;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportTable {
    tableName: string;
    tableCode: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ImportField implements IImportField {
    fieldName!: string;
    fieldCode!: string | undefined;
    required!: boolean;
    importTableId!: number;
    importTableFk!: ImportTable | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IImportField) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fieldName = data["fieldName"];
            this.fieldCode = data["fieldCode"];
            this.required = data["required"];
            this.importTableId = data["importTableId"];
            this.importTableFk = data["importTableFk"] ? ImportTable.fromJS(data["importTableFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportField {
        data = typeof data === 'object' ? data : {};
        let result = new ImportField();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fieldName"] = this.fieldName;
        data["fieldCode"] = this.fieldCode;
        data["required"] = this.required;
        data["importTableId"] = this.importTableId;
        data["importTableFk"] = this.importTableFk ? this.importTableFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportField {
    fieldName: string;
    fieldCode: string | undefined;
    required: boolean;
    importTableId: number;
    importTableFk: ImportTable | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ImportMap implements IImportMap {
    tenantId!: number;
    header!: string;
    importFieldId!: number;
    importFieldFk!: ImportField | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IImportMap) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.header = data["header"];
            this.importFieldId = data["importFieldId"];
            this.importFieldFk = data["importFieldFk"] ? ImportField.fromJS(data["importFieldFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportMap {
        data = typeof data === 'object' ? data : {};
        let result = new ImportMap();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["header"] = this.header;
        data["importFieldId"] = this.importFieldId;
        data["importFieldFk"] = this.importFieldFk ? this.importFieldFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportMap {
    tenantId: number;
    header: string;
    importFieldId: number;
    importFieldFk: ImportField | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ImportMapping implements IImportMapping {
    tenantId!: number | undefined;
    name!: string;
    importType!: ImportType;
    ignore!: boolean;
    column!: string;
    dataType!: DataType;
    required!: boolean;
    columnToMap!: string;
    defaultValue!: string | undefined;
    columnNo!: number;
    orderSourceId!: number | undefined;
    useCurrentDate!: boolean;
    noOfDays!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IImportMapping) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.importType = data["importType"];
            this.ignore = data["ignore"];
            this.column = data["column"];
            this.dataType = data["dataType"];
            this.required = data["required"];
            this.columnToMap = data["columnToMap"];
            this.defaultValue = data["defaultValue"];
            this.columnNo = data["columnNo"];
            this.orderSourceId = data["orderSourceId"];
            this.useCurrentDate = data["useCurrentDate"];
            this.noOfDays = data["noOfDays"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImportMapping {
        data = typeof data === 'object' ? data : {};
        let result = new ImportMapping();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["importType"] = this.importType;
        data["ignore"] = this.ignore;
        data["column"] = this.column;
        data["dataType"] = this.dataType;
        data["required"] = this.required;
        data["columnToMap"] = this.columnToMap;
        data["defaultValue"] = this.defaultValue;
        data["columnNo"] = this.columnNo;
        data["orderSourceId"] = this.orderSourceId;
        data["useCurrentDate"] = this.useCurrentDate;
        data["noOfDays"] = this.noOfDays;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImportMapping {
    tenantId: number | undefined;
    name: string;
    importType: ImportType;
    ignore: boolean;
    column: string;
    dataType: DataType;
    required: boolean;
    columnToMap: string;
    defaultValue: string | undefined;
    columnNo: number;
    orderSourceId: number | undefined;
    useCurrentDate: boolean;
    noOfDays: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ExportMapping implements IExportMapping {
    tenantId!: number | undefined;
    name!: string;
    exportType!: ExportType;
    ignore!: boolean;
    column!: string;
    dataType!: DataType;
    required!: boolean;
    columnToMap!: string;
    defaultValue!: string | undefined;
    columnNo!: number;
    orderSourceId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IExportMapping) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.exportType = data["exportType"];
            this.ignore = data["ignore"];
            this.column = data["column"];
            this.dataType = data["dataType"];
            this.required = data["required"];
            this.columnToMap = data["columnToMap"];
            this.defaultValue = data["defaultValue"];
            this.columnNo = data["columnNo"];
            this.orderSourceId = data["orderSourceId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ExportMapping {
        data = typeof data === 'object' ? data : {};
        let result = new ExportMapping();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["exportType"] = this.exportType;
        data["ignore"] = this.ignore;
        data["column"] = this.column;
        data["dataType"] = this.dataType;
        data["required"] = this.required;
        data["columnToMap"] = this.columnToMap;
        data["defaultValue"] = this.defaultValue;
        data["columnNo"] = this.columnNo;
        data["orderSourceId"] = this.orderSourceId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IExportMapping {
    tenantId: number | undefined;
    name: string;
    exportType: ExportType;
    ignore: boolean;
    column: string;
    dataType: DataType;
    required: boolean;
    columnToMap: string;
    defaultValue: string | undefined;
    columnNo: number;
    orderSourceId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class PackageOption implements IPackageOption {
    tenantId!: number | undefined;
    package!: Package | undefined;
    packageId!: number;
    code!: string | undefined;
    key!: string | undefined;
    value!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IPackageOption) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.package = data["package"] ? Package.fromJS(data["package"]) : <any>undefined;
            this.packageId = data["packageId"];
            this.code = data["code"];
            this.key = data["key"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PackageOption {
        data = typeof data === 'object' ? data : {};
        let result = new PackageOption();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["package"] = this.package ? this.package.toJSON() : <any>undefined;
        data["packageId"] = this.packageId;
        data["code"] = this.code;
        data["key"] = this.key;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPackageOption {
    tenantId: number | undefined;
    package: Package | undefined;
    packageId: number;
    code: string | undefined;
    key: string | undefined;
    value: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteScheduleEta implements IRouteScheduleEta {
    tenantId!: number | undefined;
    routeScheduleDetailId!: number | undefined;
    etaUtc!: moment.Moment | undefined;
    loadDate!: moment.Moment | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteScheduleEta) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.etaUtc = data["etaUtc"] ? moment(data["etaUtc"].toString()) : <any>undefined;
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteScheduleEta {
        data = typeof data === 'object' ? data : {};
        let result = new RouteScheduleEta();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["etaUtc"] = this.etaUtc ? this.etaUtc.toISOString() : <any>undefined;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteScheduleEta {
    tenantId: number | undefined;
    routeScheduleDetailId: number | undefined;
    etaUtc: moment.Moment | undefined;
    loadDate: moment.Moment | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteSchedule implements IRouteSchedule {
    tenantId!: number | undefined;
    clinic!: Clinic | undefined;
    clinicId!: number;
    contact!: Contact | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteSchedule) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.clinic = data["clinic"] ? Clinic.fromJS(data["clinic"]) : <any>undefined;
            this.clinicId = data["clinicId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteSchedule {
        data = typeof data === 'object' ? data : {};
        let result = new RouteSchedule();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["clinic"] = this.clinic ? this.clinic.toJSON() : <any>undefined;
        data["clinicId"] = this.clinicId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteSchedule {
    tenantId: number | undefined;
    clinic: Clinic | undefined;
    clinicId: number;
    contact: Contact | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Friendship implements IFriendship {
    userId!: number;
    tenantId!: number | undefined;
    friendUserId!: number;
    friendTenantId!: number | undefined;
    friendUserName!: string;
    friendTenancyName!: string | undefined;
    friendProfilePictureId!: string | undefined;
    state!: FriendshipState;
    creationTime!: moment.Moment;
    id!: number;

    constructor(data?: IFriendship) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
            this.friendUserId = data["friendUserId"];
            this.friendTenantId = data["friendTenantId"];
            this.friendUserName = data["friendUserName"];
            this.friendTenancyName = data["friendTenancyName"];
            this.friendProfilePictureId = data["friendProfilePictureId"];
            this.state = data["state"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Friendship {
        data = typeof data === 'object' ? data : {};
        let result = new Friendship();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        data["friendUserId"] = this.friendUserId;
        data["friendTenantId"] = this.friendTenantId;
        data["friendUserName"] = this.friendUserName;
        data["friendTenancyName"] = this.friendTenancyName;
        data["friendProfilePictureId"] = this.friendProfilePictureId;
        data["state"] = this.state;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFriendship {
    userId: number;
    tenantId: number | undefined;
    friendUserId: number;
    friendTenantId: number | undefined;
    friendUserName: string;
    friendTenancyName: string | undefined;
    friendProfilePictureId: string | undefined;
    state: FriendshipState;
    creationTime: moment.Moment;
    id: number;
}

export class ChatMessage implements IChatMessage {
    userId!: number;
    tenantId!: number | undefined;
    targetUserId!: number;
    targetTenantId!: number | undefined;
    message!: string;
    creationTime!: moment.Moment;
    side!: ChatSide;
    readonly readState!: ChatMessageReadState;
    readonly receiverReadState!: ChatMessageReadState;
    sharedMessageId!: string | undefined;
    id!: number;

    constructor(data?: IChatMessage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.tenantId = data["tenantId"];
            this.targetUserId = data["targetUserId"];
            this.targetTenantId = data["targetTenantId"];
            this.message = data["message"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.side = data["side"];
            (<any>this).readState = data["readState"];
            (<any>this).receiverReadState = data["receiverReadState"];
            this.sharedMessageId = data["sharedMessageId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ChatMessage {
        data = typeof data === 'object' ? data : {};
        let result = new ChatMessage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        data["targetUserId"] = this.targetUserId;
        data["targetTenantId"] = this.targetTenantId;
        data["message"] = this.message;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["side"] = this.side;
        data["readState"] = this.readState;
        data["receiverReadState"] = this.receiverReadState;
        data["sharedMessageId"] = this.sharedMessageId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IChatMessage {
    userId: number;
    tenantId: number | undefined;
    targetUserId: number;
    targetTenantId: number | undefined;
    message: string;
    creationTime: moment.Moment;
    side: ChatSide;
    readState: ChatMessageReadState;
    receiverReadState: ChatMessageReadState;
    sharedMessageId: string | undefined;
    id: number;
}

export class SubscribableEdition implements ISubscribableEdition {
    expiringEditionId!: number | undefined;
    dailyPrice!: number | undefined;
    weeklyPrice!: number | undefined;
    monthlyPrice!: number | undefined;
    annualPrice!: number | undefined;
    trialDayCount!: number | undefined;
    waitingDayAfterExpire!: number | undefined;
    readonly isFree!: boolean;
    name!: string;
    displayName!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISubscribableEdition) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.expiringEditionId = data["expiringEditionId"];
            this.dailyPrice = data["dailyPrice"];
            this.weeklyPrice = data["weeklyPrice"];
            this.monthlyPrice = data["monthlyPrice"];
            this.annualPrice = data["annualPrice"];
            this.trialDayCount = data["trialDayCount"];
            this.waitingDayAfterExpire = data["waitingDayAfterExpire"];
            (<any>this).isFree = data["isFree"];
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SubscribableEdition {
        data = typeof data === 'object' ? data : {};
        let result = new SubscribableEdition();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["expiringEditionId"] = this.expiringEditionId;
        data["dailyPrice"] = this.dailyPrice;
        data["weeklyPrice"] = this.weeklyPrice;
        data["monthlyPrice"] = this.monthlyPrice;
        data["annualPrice"] = this.annualPrice;
        data["trialDayCount"] = this.trialDayCount;
        data["waitingDayAfterExpire"] = this.waitingDayAfterExpire;
        data["isFree"] = this.isFree;
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISubscribableEdition {
    expiringEditionId: number | undefined;
    dailyPrice: number | undefined;
    weeklyPrice: number | undefined;
    monthlyPrice: number | undefined;
    annualPrice: number | undefined;
    trialDayCount: number | undefined;
    waitingDayAfterExpire: number | undefined;
    isFree: boolean;
    name: string;
    displayName: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SubscriptionPayment implements ISubscriptionPayment {
    description!: string | undefined;
    gateway!: SubscriptionPaymentGatewayType;
    amount!: number;
    readonly status!: SubscriptionPaymentStatus;
    editionId!: number;
    tenantId!: number;
    dayCount!: number;
    paymentPeriodType!: PaymentPeriodType | undefined;
    externalPaymentId!: string | undefined;
    edition!: Edition | undefined;
    invoiceNo!: string | undefined;
    isRecurring!: boolean;
    successUrl!: string | undefined;
    errorUrl!: string | undefined;
    editionPaymentType!: EditionPaymentType;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISubscriptionPayment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.gateway = data["gateway"];
            this.amount = data["amount"];
            (<any>this).status = data["status"];
            this.editionId = data["editionId"];
            this.tenantId = data["tenantId"];
            this.dayCount = data["dayCount"];
            this.paymentPeriodType = data["paymentPeriodType"];
            this.externalPaymentId = data["externalPaymentId"];
            this.edition = data["edition"] ? Edition.fromJS(data["edition"]) : <any>undefined;
            this.invoiceNo = data["invoiceNo"];
            this.isRecurring = data["isRecurring"];
            this.successUrl = data["successUrl"];
            this.errorUrl = data["errorUrl"];
            this.editionPaymentType = data["editionPaymentType"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SubscriptionPayment {
        data = typeof data === 'object' ? data : {};
        let result = new SubscriptionPayment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["gateway"] = this.gateway;
        data["amount"] = this.amount;
        data["status"] = this.status;
        data["editionId"] = this.editionId;
        data["tenantId"] = this.tenantId;
        data["dayCount"] = this.dayCount;
        data["paymentPeriodType"] = this.paymentPeriodType;
        data["externalPaymentId"] = this.externalPaymentId;
        data["edition"] = this.edition ? this.edition.toJSON() : <any>undefined;
        data["invoiceNo"] = this.invoiceNo;
        data["isRecurring"] = this.isRecurring;
        data["successUrl"] = this.successUrl;
        data["errorUrl"] = this.errorUrl;
        data["editionPaymentType"] = this.editionPaymentType;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISubscriptionPayment {
    description: string | undefined;
    gateway: SubscriptionPaymentGatewayType;
    amount: number;
    status: SubscriptionPaymentStatus;
    editionId: number;
    tenantId: number;
    dayCount: number;
    paymentPeriodType: PaymentPeriodType | undefined;
    externalPaymentId: string | undefined;
    edition: Edition | undefined;
    invoiceNo: string | undefined;
    isRecurring: boolean;
    successUrl: string | undefined;
    errorUrl: string | undefined;
    editionPaymentType: EditionPaymentType;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Invoice implements IInvoice {
    invoiceNo!: string | undefined;
    invoiceDate!: moment.Moment;
    tenantLegalName!: string | undefined;
    tenantAddress!: string | undefined;
    tenantTaxNo!: string | undefined;
    id!: number;

    constructor(data?: IInvoice) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.invoiceNo = data["invoiceNo"];
            this.invoiceDate = data["invoiceDate"] ? moment(data["invoiceDate"].toString()) : <any>undefined;
            this.tenantLegalName = data["tenantLegalName"];
            this.tenantAddress = data["tenantAddress"];
            this.tenantTaxNo = data["tenantTaxNo"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Invoice {
        data = typeof data === 'object' ? data : {};
        let result = new Invoice();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["invoiceNo"] = this.invoiceNo;
        data["invoiceDate"] = this.invoiceDate ? this.invoiceDate.toISOString() : <any>undefined;
        data["tenantLegalName"] = this.tenantLegalName;
        data["tenantAddress"] = this.tenantAddress;
        data["tenantTaxNo"] = this.tenantTaxNo;
        data["id"] = this.id;
        return data; 
    }
}

export interface IInvoice {
    invoiceNo: string | undefined;
    invoiceDate: moment.Moment;
    tenantLegalName: string | undefined;
    tenantAddress: string | undefined;
    tenantTaxNo: string | undefined;
    id: number;
}

export class PersistedGrantEntity implements IPersistedGrantEntity {
    type!: string | undefined;
    subjectId!: string | undefined;
    clientId!: string | undefined;
    creationTime!: moment.Moment;
    expiration!: moment.Moment | undefined;
    data!: string | undefined;
    id!: string | undefined;

    constructor(data?: IPersistedGrantEntity) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.type = data["type"];
            this.subjectId = data["subjectId"];
            this.clientId = data["clientId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.expiration = data["expiration"] ? moment(data["expiration"].toString()) : <any>undefined;
            this.data = data["data"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PersistedGrantEntity {
        data = typeof data === 'object' ? data : {};
        let result = new PersistedGrantEntity();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["type"] = this.type;
        data["subjectId"] = this.subjectId;
        data["clientId"] = this.clientId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["expiration"] = this.expiration ? this.expiration.toISOString() : <any>undefined;
        data["data"] = this.data;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPersistedGrantEntity {
    type: string | undefined;
    subjectId: string | undefined;
    clientId: string | undefined;
    creationTime: moment.Moment;
    expiration: moment.Moment | undefined;
    data: string | undefined;
    id: string | undefined;
}

export class Image implements IImage {
    tenantId!: number | undefined;
    filename!: string;
    data!: string;
    base64EncodedData!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IImage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.filename = data["filename"];
            this.data = data["data"];
            this.base64EncodedData = data["base64EncodedData"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Image {
        data = typeof data === 'object' ? data : {};
        let result = new Image();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["filename"] = this.filename;
        data["data"] = this.data;
        data["base64EncodedData"] = this.base64EncodedData;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImage {
    tenantId: number | undefined;
    filename: string;
    data: string;
    base64EncodedData: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ImageNote implements IImageNote {
    tenantId!: number | undefined;
    image!: Image | undefined;
    imageId!: number;
    note!: Note | undefined;
    noteId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IImageNote) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.image = data["image"] ? Image.fromJS(data["image"]) : <any>undefined;
            this.imageId = data["imageId"];
            this.note = data["note"] ? Note.fromJS(data["note"]) : <any>undefined;
            this.noteId = data["noteId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ImageNote {
        data = typeof data === 'object' ? data : {};
        let result = new ImageNote();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["image"] = this.image ? this.image.toJSON() : <any>undefined;
        data["imageId"] = this.imageId;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["noteId"] = this.noteId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IImageNote {
    tenantId: number | undefined;
    image: Image | undefined;
    imageId: number;
    note: Note | undefined;
    noteId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class TimeSheet implements ITimeSheet {
    tenantId!: number | undefined;
    user!: User | undefined;
    creatorUserId!: number | undefined;
    loginTime!: moment.Moment | undefined;
    login_Timezone!: string | undefined;
    logoutTime!: moment.Moment | undefined;
    logout_Timezone!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    id!: number;

    constructor(data?: ITimeSheet) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.loginTime = data["loginTime"] ? moment(data["loginTime"].toString()) : <any>undefined;
            this.login_Timezone = data["login_Timezone"];
            this.logoutTime = data["logoutTime"] ? moment(data["logoutTime"].toString()) : <any>undefined;
            this.logout_Timezone = data["logout_Timezone"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TimeSheet {
        data = typeof data === 'object' ? data : {};
        let result = new TimeSheet();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["loginTime"] = this.loginTime ? this.loginTime.toISOString() : <any>undefined;
        data["login_Timezone"] = this.login_Timezone;
        data["logoutTime"] = this.logoutTime ? this.logoutTime.toISOString() : <any>undefined;
        data["logout_Timezone"] = this.logout_Timezone;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITimeSheet {
    tenantId: number | undefined;
    user: User | undefined;
    creatorUserId: number | undefined;
    loginTime: moment.Moment | undefined;
    login_Timezone: string | undefined;
    logoutTime: moment.Moment | undefined;
    logout_Timezone: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    id: number;
}

export class Review implements IReview {
    content!: string;
    rating!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IReview) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.content = data["content"];
            this.rating = data["rating"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Review {
        data = typeof data === 'object' ? data : {};
        let result = new Review();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["content"] = this.content;
        data["rating"] = this.rating;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IReview {
    content: string;
    rating: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class EmployeeReview implements IEmployeeReview {
    tenantId!: number | undefined;
    user!: User | undefined;
    userId!: number | undefined;
    review!: Review | undefined;
    reviewId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IEmployeeReview) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.review = data["review"] ? Review.fromJS(data["review"]) : <any>undefined;
            this.reviewId = data["reviewId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EmployeeReview {
        data = typeof data === 'object' ? data : {};
        let result = new EmployeeReview();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["review"] = this.review ? this.review.toJSON() : <any>undefined;
        data["reviewId"] = this.reviewId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEmployeeReview {
    tenantId: number | undefined;
    user: User | undefined;
    userId: number | undefined;
    review: Review | undefined;
    reviewId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteTemplateAddress implements IRouteTemplateAddress {
    routeTemplate!: RouteTemplate | undefined;
    routeTemplateId!: number;
    address!: Address | undefined;
    addressId!: number;
    tenantId!: number | undefined;
    sortOrder!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateAddress) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplate = data["routeTemplate"] ? RouteTemplate.fromJS(data["routeTemplate"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.address = data["address"] ? Address.fromJS(data["address"]) : <any>undefined;
            this.addressId = data["addressId"];
            this.tenantId = data["tenantId"];
            this.sortOrder = data["sortOrder"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateAddress {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateAddress();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["addressId"] = this.addressId;
        data["tenantId"] = this.tenantId;
        data["sortOrder"] = this.sortOrder;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateAddress {
    routeTemplate: RouteTemplate | undefined;
    routeTemplateId: number;
    address: Address | undefined;
    addressId: number;
    tenantId: number | undefined;
    sortOrder: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SortingRule implements ISortingRule {
    tenantId!: number | undefined;
    name!: string;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISortingRule) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SortingRule {
        data = typeof data === 'object' ? data : {};
        let result = new SortingRule();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISortingRule {
    tenantId: number | undefined;
    name: string;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteTemplateSortingRule implements IRouteTemplateSortingRule {
    routeTemplate!: RouteTemplate | undefined;
    routeTemplateId!: number;
    sortingRule!: SortingRule | undefined;
    sortingRuleId!: number;
    tenantId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateSortingRule) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplate = data["routeTemplate"] ? RouteTemplate.fromJS(data["routeTemplate"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.sortingRule = data["sortingRule"] ? SortingRule.fromJS(data["sortingRule"]) : <any>undefined;
            this.sortingRuleId = data["sortingRuleId"];
            this.tenantId = data["tenantId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateSortingRule {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateSortingRule();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["sortingRule"] = this.sortingRule ? this.sortingRule.toJSON() : <any>undefined;
        data["sortingRuleId"] = this.sortingRuleId;
        data["tenantId"] = this.tenantId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateSortingRule {
    routeTemplate: RouteTemplate | undefined;
    routeTemplateId: number;
    sortingRule: SortingRule | undefined;
    sortingRuleId: number;
    tenantId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteTemplateWaypoint implements IRouteTemplateWaypoint {
    geocode!: Geocode | undefined;
    geocodeId!: number;
    routeTemplate!: RouteTemplate | undefined;
    routeTemplateId!: number;
    tenantId!: number | undefined;
    sortOrder!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateWaypoint) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.routeTemplate = data["routeTemplate"] ? RouteTemplate.fromJS(data["routeTemplate"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.tenantId = data["tenantId"];
            this.sortOrder = data["sortOrder"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateWaypoint {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateWaypoint();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["tenantId"] = this.tenantId;
        data["sortOrder"] = this.sortOrder;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateWaypoint {
    geocode: Geocode | undefined;
    geocodeId: number;
    routeTemplate: RouteTemplate | undefined;
    routeTemplateId: number;
    tenantId: number | undefined;
    sortOrder: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteTemplateZone implements IRouteTemplateZone {
    zone!: Zone | undefined;
    zoneId!: number;
    routeTemplate!: RouteTemplate | undefined;
    routeTemplateId!: number;
    tenantId!: number | undefined;
    sortOrder!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteTemplateZone) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.zone = data["zone"] ? Zone.fromJS(data["zone"]) : <any>undefined;
            this.zoneId = data["zoneId"];
            this.routeTemplate = data["routeTemplate"] ? RouteTemplate.fromJS(data["routeTemplate"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.tenantId = data["tenantId"];
            this.sortOrder = data["sortOrder"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteTemplateZone {
        data = typeof data === 'object' ? data : {};
        let result = new RouteTemplateZone();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["zone"] = this.zone ? this.zone.toJSON() : <any>undefined;
        data["zoneId"] = this.zoneId;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["tenantId"] = this.tenantId;
        data["sortOrder"] = this.sortOrder;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteTemplateZone {
    zone: Zone | undefined;
    zoneId: number;
    routeTemplate: RouteTemplate | undefined;
    routeTemplateId: number;
    tenantId: number | undefined;
    sortOrder: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Proximity implements IProximity {
    tenantId!: number | undefined;
    addressType!: AddressType | undefined;
    addressTypeId!: number;
    location!: Location | undefined;
    locationId!: number;
    value!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IProximity) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.addressType = data["addressType"] ? AddressType.fromJS(data["addressType"]) : <any>undefined;
            this.addressTypeId = data["addressTypeId"];
            this.location = data["location"] ? Location.fromJS(data["location"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Proximity {
        data = typeof data === 'object' ? data : {};
        let result = new Proximity();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["addressType"] = this.addressType ? this.addressType.toJSON() : <any>undefined;
        data["addressTypeId"] = this.addressTypeId;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IProximity {
    tenantId: number | undefined;
    addressType: AddressType | undefined;
    addressTypeId: number;
    location: Location | undefined;
    locationId: number;
    value: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class UserLocation implements IUserLocation {
    tenantId!: number | undefined;
    location!: Location | undefined;
    locationId!: number;
    user!: User | undefined;
    userId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUserLocation) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.location = data["location"] ? Location.fromJS(data["location"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserLocation {
        data = typeof data === 'object' ? data : {};
        let result = new UserLocation();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserLocation {
    tenantId: number | undefined;
    location: Location | undefined;
    locationId: number;
    user: User | undefined;
    userId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ZoneLocation implements IZoneLocation {
    tenantId!: number | undefined;
    zone!: Zone | undefined;
    zoneId!: number;
    location!: Location | undefined;
    locationId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IZoneLocation) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.zone = data["zone"] ? Zone.fromJS(data["zone"]) : <any>undefined;
            this.zoneId = data["zoneId"];
            this.location = data["location"] ? Location.fromJS(data["location"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ZoneLocation {
        data = typeof data === 'object' ? data : {};
        let result = new ZoneLocation();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["zone"] = this.zone ? this.zone.toJSON() : <any>undefined;
        data["zoneId"] = this.zoneId;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IZoneLocation {
    tenantId: number | undefined;
    zone: Zone | undefined;
    zoneId: number;
    location: Location | undefined;
    locationId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class VehicleLocation implements IVehicleLocation {
    location!: Location | undefined;
    locationId!: number | undefined;
    vehicle!: Vehicle | undefined;
    vehicleId!: number | undefined;
    tenantId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IVehicleLocation) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.location = data["location"] ? Location.fromJS(data["location"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.vehicle = data["vehicle"] ? Vehicle.fromJS(data["vehicle"]) : <any>undefined;
            this.vehicleId = data["vehicleId"];
            this.tenantId = data["tenantId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VehicleLocation {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleLocation();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        data["tenantId"] = this.tenantId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicleLocation {
    location: Location | undefined;
    locationId: number | undefined;
    vehicle: Vehicle | undefined;
    vehicleId: number | undefined;
    tenantId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Mileage implements IMileage {
    tenantId!: number | undefined;
    value!: number;
    id!: number;

    constructor(data?: IMileage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Mileage {
        data = typeof data === 'object' ? data : {};
        let result = new Mileage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMileage {
    tenantId: number | undefined;
    value: number;
    id: number;
}

export class DriverIncident implements IDriverIncident {
    tenantId!: number | undefined;
    incident!: Incident | undefined;
    incidentId!: number;
    user!: User | undefined;
    userId!: number;
    driverIncidentType!: DriverIncidentType | undefined;
    driverIncidentTypeId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDriverIncident) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.incident = data["incident"] ? Incident.fromJS(data["incident"]) : <any>undefined;
            this.incidentId = data["incidentId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.driverIncidentType = data["driverIncidentType"] ? DriverIncidentType.fromJS(data["driverIncidentType"]) : <any>undefined;
            this.driverIncidentTypeId = data["driverIncidentTypeId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DriverIncident {
        data = typeof data === 'object' ? data : {};
        let result = new DriverIncident();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["incident"] = this.incident ? this.incident.toJSON() : <any>undefined;
        data["incidentId"] = this.incidentId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["driverIncidentType"] = this.driverIncidentType ? this.driverIncidentType.toJSON() : <any>undefined;
        data["driverIncidentTypeId"] = this.driverIncidentTypeId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDriverIncident {
    tenantId: number | undefined;
    incident: Incident | undefined;
    incidentId: number;
    user: User | undefined;
    userId: number;
    driverIncidentType: DriverIncidentType | undefined;
    driverIncidentTypeId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class IncidentImage implements IIncidentImage {
    incident!: Incident | undefined;
    incidentId!: number;
    binaryObject!: BinaryObject | undefined;
    binaryObjectId!: string;
    fileName!: string | undefined;
    based64Data!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IIncidentImage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incident = data["incident"] ? Incident.fromJS(data["incident"]) : <any>undefined;
            this.incidentId = data["incidentId"];
            this.binaryObject = data["binaryObject"] ? BinaryObject.fromJS(data["binaryObject"]) : <any>undefined;
            this.binaryObjectId = data["binaryObjectId"];
            this.fileName = data["fileName"];
            this.based64Data = data["based64Data"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): IncidentImage {
        data = typeof data === 'object' ? data : {};
        let result = new IncidentImage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incident"] = this.incident ? this.incident.toJSON() : <any>undefined;
        data["incidentId"] = this.incidentId;
        data["binaryObject"] = this.binaryObject ? this.binaryObject.toJSON() : <any>undefined;
        data["binaryObjectId"] = this.binaryObjectId;
        data["fileName"] = this.fileName;
        data["based64Data"] = this.based64Data;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IIncidentImage {
    incident: Incident | undefined;
    incidentId: number;
    binaryObject: BinaryObject | undefined;
    binaryObjectId: string;
    fileName: string | undefined;
    based64Data: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ReviewImage implements IReviewImage {
    review!: Review | undefined;
    reviewId!: number | undefined;
    image!: Image | undefined;
    imageId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IReviewImage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.review = data["review"] ? Review.fromJS(data["review"]) : <any>undefined;
            this.reviewId = data["reviewId"];
            this.image = data["image"] ? Image.fromJS(data["image"]) : <any>undefined;
            this.imageId = data["imageId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ReviewImage {
        data = typeof data === 'object' ? data : {};
        let result = new ReviewImage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["review"] = this.review ? this.review.toJSON() : <any>undefined;
        data["reviewId"] = this.reviewId;
        data["image"] = this.image ? this.image.toJSON() : <any>undefined;
        data["imageId"] = this.imageId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IReviewImage {
    review: Review | undefined;
    reviewId: number | undefined;
    image: Image | undefined;
    imageId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class VehicleLog implements IVehicleLog {
    vehicle!: Vehicle | undefined;
    vehicleId!: number;
    speed!: number;
    time!: moment.Moment;
    geocode!: Geocode | undefined;
    geocodeId!: number;
    route!: Route | undefined;
    routeId!: number | undefined;
    distance!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IVehicleLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicle = data["vehicle"] ? Vehicle.fromJS(data["vehicle"]) : <any>undefined;
            this.vehicleId = data["vehicleId"];
            this.speed = data["speed"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.route = data["route"] ? Route.fromJS(data["route"]) : <any>undefined;
            this.routeId = data["routeId"];
            this.distance = data["distance"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VehicleLog {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        data["speed"] = this.speed;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["routeId"] = this.routeId;
        data["distance"] = this.distance;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicleLog {
    vehicle: Vehicle | undefined;
    vehicleId: number;
    speed: number;
    time: moment.Moment;
    geocode: Geocode | undefined;
    geocodeId: number;
    route: Route | undefined;
    routeId: number | undefined;
    distance: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DeliveryNote implements IDeliveryNote {
    tenantId!: number | undefined;
    note!: Note | undefined;
    noteId!: number;
    sortOrder!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDeliveryNote) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.note = data["note"] ? Note.fromJS(data["note"]) : <any>undefined;
            this.noteId = data["noteId"];
            this.sortOrder = data["sortOrder"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DeliveryNote {
        data = typeof data === 'object' ? data : {};
        let result = new DeliveryNote();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["note"] = this.note ? this.note.toJSON() : <any>undefined;
        data["noteId"] = this.noteId;
        data["sortOrder"] = this.sortOrder;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDeliveryNote {
    tenantId: number | undefined;
    note: Note | undefined;
    noteId: number;
    sortOrder: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class GeocodeRequestLog implements IGeocodeRequestLog {
    addressId!: number;
    provider!: string | undefined;
    success!: boolean;
    creationTime!: moment.Moment;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IGeocodeRequestLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.addressId = data["addressId"];
            this.provider = data["provider"];
            this.success = data["success"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): GeocodeRequestLog {
        data = typeof data === 'object' ? data : {};
        let result = new GeocodeRequestLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["addressId"] = this.addressId;
        data["provider"] = this.provider;
        data["success"] = this.success;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IGeocodeRequestLog {
    addressId: number;
    provider: string | undefined;
    success: boolean;
    creationTime: moment.Moment;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creatorUserId: number | undefined;
    id: number;
}

export class GoogleApiRequestsLog implements IGoogleApiRequestsLog {
    googleApi!: string | undefined;
    request!: string | undefined;
    source!: string | undefined;
    success!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IGoogleApiRequestsLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.googleApi = data["googleApi"];
            this.request = data["request"];
            this.source = data["source"];
            this.success = data["success"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): GoogleApiRequestsLog {
        data = typeof data === 'object' ? data : {};
        let result = new GoogleApiRequestsLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["googleApi"] = this.googleApi;
        data["request"] = this.request;
        data["source"] = this.source;
        data["success"] = this.success;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IGoogleApiRequestsLog {
    googleApi: string | undefined;
    request: string | undefined;
    source: string | undefined;
    success: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class MobileAppVersion implements IMobileAppVersion {
    osName!: string | undefined;
    minimumVersion!: number;
    versionName!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IMobileAppVersion) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.osName = data["osName"];
            this.minimumVersion = data["minimumVersion"];
            this.versionName = data["versionName"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileAppVersion {
        data = typeof data === 'object' ? data : {};
        let result = new MobileAppVersion();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["osName"] = this.osName;
        data["minimumVersion"] = this.minimumVersion;
        data["versionName"] = this.versionName;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileAppVersion {
    osName: string | undefined;
    minimumVersion: number;
    versionName: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class BlindCountLimit implements IBlindCountLimit {
    tenantId!: number;
    value!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IBlindCountLimit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): BlindCountLimit {
        data = typeof data === 'object' ? data : {};
        let result = new BlindCountLimit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IBlindCountLimit {
    tenantId: number;
    value: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class BlindCountError implements IBlindCountError {
    routeId!: number;
    driverId!: number;
    verifierId!: number | undefined;
    code!: string | undefined;
    verifierNoteId!: number | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IBlindCountError) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.driverId = data["driverId"];
            this.verifierId = data["verifierId"];
            this.code = data["code"];
            this.verifierNoteId = data["verifierNoteId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): BlindCountError {
        data = typeof data === 'object' ? data : {};
        let result = new BlindCountError();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["driverId"] = this.driverId;
        data["verifierId"] = this.verifierId;
        data["code"] = this.code;
        data["verifierNoteId"] = this.verifierNoteId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IBlindCountError {
    routeId: number;
    driverId: number;
    verifierId: number | undefined;
    code: string | undefined;
    verifierNoteId: number | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderPackageQuantityLog implements IOrderPackageQuantityLog {
    orderPackage!: OrderPackage | undefined;
    orderPackageId!: number;
    quantity!: number;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderPackageQuantityLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderPackage = data["orderPackage"] ? OrderPackage.fromJS(data["orderPackage"]) : <any>undefined;
            this.orderPackageId = data["orderPackageId"];
            this.quantity = data["quantity"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderPackageQuantityLog {
        data = typeof data === 'object' ? data : {};
        let result = new OrderPackageQuantityLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderPackage"] = this.orderPackage ? this.orderPackage.toJSON() : <any>undefined;
        data["orderPackageId"] = this.orderPackageId;
        data["quantity"] = this.quantity;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderPackageQuantityLog {
    orderPackage: OrderPackage | undefined;
    orderPackageId: number;
    quantity: number;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class MobileClientMessage implements IMobileClientMessage {
    tenantId!: number | undefined;
    user!: User | undefined;
    userId!: number;
    action!: MobileClientMessageAction;
    isRead!: boolean;
    content!: string | undefined;
    dateCreated!: moment.Moment;
    routeId!: number | undefined;
    route!: Route | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IMobileClientMessage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.action = data["action"];
            this.isRead = data["isRead"];
            this.content = data["content"];
            this.dateCreated = data["dateCreated"] ? moment(data["dateCreated"].toString()) : <any>undefined;
            this.routeId = data["routeId"];
            this.route = data["route"] ? Route.fromJS(data["route"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileClientMessage {
        data = typeof data === 'object' ? data : {};
        let result = new MobileClientMessage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["action"] = this.action;
        data["isRead"] = this.isRead;
        data["content"] = this.content;
        data["dateCreated"] = this.dateCreated ? this.dateCreated.toISOString() : <any>undefined;
        data["routeId"] = this.routeId;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileClientMessage {
    tenantId: number | undefined;
    user: User | undefined;
    userId: number;
    action: MobileClientMessageAction;
    isRead: boolean;
    content: string | undefined;
    dateCreated: moment.Moment;
    routeId: number | undefined;
    route: Route | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class MobileClientLogInCode implements IMobileClientLogInCode {
    mobileClient!: MobileClient | undefined;
    mobileClientId!: number;
    value!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IMobileClientLogInCode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.mobileClient = data["mobileClient"] ? MobileClient.fromJS(data["mobileClient"]) : <any>undefined;
            this.mobileClientId = data["mobileClientId"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileClientLogInCode {
        data = typeof data === 'object' ? data : {};
        let result = new MobileClientLogInCode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["mobileClient"] = this.mobileClient ? this.mobileClient.toJSON() : <any>undefined;
        data["mobileClientId"] = this.mobileClientId;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileClientLogInCode {
    mobileClient: MobileClient | undefined;
    mobileClientId: number;
    value: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SupportTicketAttachment implements ISupportTicketAttachment {
    ticket!: SupportTicket | undefined;
    ticketId!: number | undefined;
    filename!: string;
    data!: string | undefined;
    blobFile!: string | undefined;
    base64EncodedData!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketAttachment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.ticket = data["ticket"] ? SupportTicket.fromJS(data["ticket"]) : <any>undefined;
            this.ticketId = data["ticketId"];
            this.filename = data["filename"];
            this.data = data["data"];
            this.blobFile = data["blobFile"];
            this.base64EncodedData = data["base64EncodedData"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketAttachment {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketAttachment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["ticket"] = this.ticket ? this.ticket.toJSON() : <any>undefined;
        data["ticketId"] = this.ticketId;
        data["filename"] = this.filename;
        data["data"] = this.data;
        data["blobFile"] = this.blobFile;
        data["base64EncodedData"] = this.base64EncodedData;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketAttachment {
    ticket: SupportTicket | undefined;
    ticketId: number | undefined;
    filename: string;
    data: string | undefined;
    blobFile: string | undefined;
    base64EncodedData: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SupportTicketNote implements ISupportTicketNote {
    ticket!: SupportTicket | undefined;
    ticketId!: number | undefined;
    notes!: string;
    creator!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketNote) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.ticket = data["ticket"] ? SupportTicket.fromJS(data["ticket"]) : <any>undefined;
            this.ticketId = data["ticketId"];
            this.notes = data["notes"];
            this.creator = data["creator"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketNote {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNote();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["ticket"] = this.ticket ? this.ticket.toJSON() : <any>undefined;
        data["ticketId"] = this.ticketId;
        data["notes"] = this.notes;
        data["creator"] = this.creator;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketNote {
    ticket: SupportTicket | undefined;
    ticketId: number | undefined;
    notes: string;
    creator: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SupportTicketSetting implements ISupportTicketSetting {
    tenantId!: number | undefined;
    documentationUrl!: string | undefined;
    onBoardingGuideUrl!: string | undefined;
    trainingVideoUrl!: string | undefined;
    faqUrl!: string | undefined;
    isActive!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.documentationUrl = data["documentationUrl"];
            this.onBoardingGuideUrl = data["onBoardingGuideUrl"];
            this.trainingVideoUrl = data["trainingVideoUrl"];
            this.faqUrl = data["faqUrl"];
            this.isActive = data["isActive"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketSetting {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["documentationUrl"] = this.documentationUrl;
        data["onBoardingGuideUrl"] = this.onBoardingGuideUrl;
        data["trainingVideoUrl"] = this.trainingVideoUrl;
        data["faqUrl"] = this.faqUrl;
        data["isActive"] = this.isActive;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketSetting {
    tenantId: number | undefined;
    documentationUrl: string | undefined;
    onBoardingGuideUrl: string | undefined;
    trainingVideoUrl: string | undefined;
    faqUrl: string | undefined;
    isActive: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteVehicleCheck implements IRouteVehicleCheck {
    tenantId!: number;
    vehicleChecklist!: VehicleChecklist | undefined;
    vehicleChecklistId!: number;
    route!: Route | undefined;
    routeId!: number | undefined;
    vehicle!: Vehicle | undefined;
    vehicleId!: number;
    isDone!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteVehicleCheck) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.vehicleChecklist = data["vehicleChecklist"] ? VehicleChecklist.fromJS(data["vehicleChecklist"]) : <any>undefined;
            this.vehicleChecklistId = data["vehicleChecklistId"];
            this.route = data["route"] ? Route.fromJS(data["route"]) : <any>undefined;
            this.routeId = data["routeId"];
            this.vehicle = data["vehicle"] ? Vehicle.fromJS(data["vehicle"]) : <any>undefined;
            this.vehicleId = data["vehicleId"];
            this.isDone = data["isDone"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteVehicleCheck {
        data = typeof data === 'object' ? data : {};
        let result = new RouteVehicleCheck();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["vehicleChecklist"] = this.vehicleChecklist ? this.vehicleChecklist.toJSON() : <any>undefined;
        data["vehicleChecklistId"] = this.vehicleChecklistId;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["routeId"] = this.routeId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        data["isDone"] = this.isDone;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteVehicleCheck {
    tenantId: number;
    vehicleChecklist: VehicleChecklist | undefined;
    vehicleChecklistId: number;
    route: Route | undefined;
    routeId: number | undefined;
    vehicle: Vehicle | undefined;
    vehicleId: number;
    isDone: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ReportLogs implements IReportLogs {
    tenantId!: number | undefined;
    reports!: Reports | undefined;
    reportId!: number;
    errorMessage!: string | undefined;
    duration!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IReportLogs) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.reports = data["reports"] ? Reports.fromJS(data["reports"]) : <any>undefined;
            this.reportId = data["reportId"];
            this.errorMessage = data["errorMessage"];
            this.duration = data["duration"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ReportLogs {
        data = typeof data === 'object' ? data : {};
        let result = new ReportLogs();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["reports"] = this.reports ? this.reports.toJSON() : <any>undefined;
        data["reportId"] = this.reportId;
        data["errorMessage"] = this.errorMessage;
        data["duration"] = this.duration;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IReportLogs {
    tenantId: number | undefined;
    reports: Reports | undefined;
    reportId: number;
    errorMessage: string | undefined;
    duration: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class SecondaryConnections implements ISecondaryConnections {
    tenantId!: number | undefined;
    connectionString!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISecondaryConnections) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.connectionString = data["connectionString"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SecondaryConnections {
        data = typeof data === 'object' ? data : {};
        let result = new SecondaryConnections();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["connectionString"] = this.connectionString;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISecondaryConnections {
    tenantId: number | undefined;
    connectionString: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Preference implements IPreference {
    tenantId!: number | undefined;
    code!: string | undefined;
    description!: string | undefined;
    value!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IPreference) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.code = data["code"];
            this.description = data["description"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Preference {
        data = typeof data === 'object' ? data : {};
        let result = new Preference();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["code"] = this.code;
        data["description"] = this.description;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPreference {
    tenantId: number | undefined;
    code: string | undefined;
    description: string | undefined;
    value: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class UserPreference implements IUserPreference {
    tenantId!: number | undefined;
    user!: User | undefined;
    userId!: number;
    value!: string | undefined;
    preference!: Preference | undefined;
    preferenceId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUserPreference) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.value = data["value"];
            this.preference = data["preference"] ? Preference.fromJS(data["preference"]) : <any>undefined;
            this.preferenceId = data["preferenceId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserPreference {
        data = typeof data === 'object' ? data : {};
        let result = new UserPreference();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["value"] = this.value;
        data["preference"] = this.preference ? this.preference.toJSON() : <any>undefined;
        data["preferenceId"] = this.preferenceId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserPreference {
    tenantId: number | undefined;
    user: User | undefined;
    userId: number;
    value: string | undefined;
    preference: Preference | undefined;
    preferenceId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ClientPreference implements IClientPreference {
    tenantId!: number | undefined;
    value!: string | undefined;
    preference!: Preference | undefined;
    preferenceId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IClientPreference) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.value = data["value"];
            this.preference = data["preference"] ? Preference.fromJS(data["preference"]) : <any>undefined;
            this.preferenceId = data["preferenceId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ClientPreference {
        data = typeof data === 'object' ? data : {};
        let result = new ClientPreference();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["value"] = this.value;
        data["preference"] = this.preference ? this.preference.toJSON() : <any>undefined;
        data["preferenceId"] = this.preferenceId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IClientPreference {
    tenantId: number | undefined;
    value: string | undefined;
    preference: Preference | undefined;
    preferenceId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DataSource implements IDataSource {
    tenantId!: number | undefined;
    description!: string;
    configuration!: string;
    code!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDataSource) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.description = data["description"];
            this.configuration = data["configuration"];
            this.code = data["code"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DataSource {
        data = typeof data === 'object' ? data : {};
        let result = new DataSource();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["description"] = this.description;
        data["configuration"] = this.configuration;
        data["code"] = this.code;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDataSource {
    tenantId: number | undefined;
    description: string;
    configuration: string;
    code: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DataSourceFiles implements IDataSourceFiles {
    tenantId!: number | undefined;
    fileName!: string;
    fileType!: string;
    content!: string;
    dataSources!: DataSource | undefined;
    dataSourceId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDataSourceFiles) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.fileName = data["fileName"];
            this.fileType = data["fileType"];
            this.content = data["content"];
            this.dataSources = data["dataSources"] ? DataSource.fromJS(data["dataSources"]) : <any>undefined;
            this.dataSourceId = data["dataSourceId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DataSourceFiles {
        data = typeof data === 'object' ? data : {};
        let result = new DataSourceFiles();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["fileName"] = this.fileName;
        data["fileType"] = this.fileType;
        data["content"] = this.content;
        data["dataSources"] = this.dataSources ? this.dataSources.toJSON() : <any>undefined;
        data["dataSourceId"] = this.dataSourceId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDataSourceFiles {
    tenantId: number | undefined;
    fileName: string;
    fileType: string;
    content: string;
    dataSources: DataSource | undefined;
    dataSourceId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DataSourceFileOrders implements IDataSourceFileOrders {
    tenantId!: number | undefined;
    dataSourceFiles!: DataSourceFiles | undefined;
    dataSourceFileId!: number;
    orders!: Order | undefined;
    orderId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDataSourceFileOrders) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.dataSourceFiles = data["dataSourceFiles"] ? DataSourceFiles.fromJS(data["dataSourceFiles"]) : <any>undefined;
            this.dataSourceFileId = data["dataSourceFileId"];
            this.orders = data["orders"] ? Order.fromJS(data["orders"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DataSourceFileOrders {
        data = typeof data === 'object' ? data : {};
        let result = new DataSourceFileOrders();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["dataSourceFiles"] = this.dataSourceFiles ? this.dataSourceFiles.toJSON() : <any>undefined;
        data["dataSourceFileId"] = this.dataSourceFileId;
        data["orders"] = this.orders ? this.orders.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDataSourceFileOrders {
    tenantId: number | undefined;
    dataSourceFiles: DataSourceFiles | undefined;
    dataSourceFileId: number;
    orders: Order | undefined;
    orderId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Drivers implements IDrivers {
    tenantId!: number | undefined;
    user!: User;
    userId!: number;
    contact!: Contact;
    contactId!: number;
    vehicle!: Vehicle | undefined;
    vehicleId!: number | undefined;
    startDate!: moment.Moment | undefined;
    endDate!: moment.Moment | undefined;
    driverLicenseNumber!: string | undefined;
    driverLicenseState!: string | undefined;
    driverLicenseExpirationDate!: moment.Moment | undefined;
    hourlyRate!: number | undefined;
    dailyRate!: number | undefined;
    perSprintRate!: number | undefined;
    onDemand!: boolean;
    ownVehicle!: boolean;
    isActive!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDrivers) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new User();
            this.contact = new Contact();
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : new User();
            this.userId = data["userId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : new Contact();
            this.contactId = data["contactId"];
            this.vehicle = data["vehicle"] ? Vehicle.fromJS(data["vehicle"]) : <any>undefined;
            this.vehicleId = data["vehicleId"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.endDate = data["endDate"] ? moment(data["endDate"].toString()) : <any>undefined;
            this.driverLicenseNumber = data["driverLicenseNumber"];
            this.driverLicenseState = data["driverLicenseState"];
            this.driverLicenseExpirationDate = data["driverLicenseExpirationDate"] ? moment(data["driverLicenseExpirationDate"].toString()) : <any>undefined;
            this.hourlyRate = data["hourlyRate"];
            this.dailyRate = data["dailyRate"];
            this.perSprintRate = data["perSprintRate"];
            this.onDemand = data["onDemand"];
            this.ownVehicle = data["ownVehicle"];
            this.isActive = data["isActive"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Drivers {
        data = typeof data === 'object' ? data : {};
        let result = new Drivers();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["endDate"] = this.endDate ? this.endDate.toISOString() : <any>undefined;
        data["driverLicenseNumber"] = this.driverLicenseNumber;
        data["driverLicenseState"] = this.driverLicenseState;
        data["driverLicenseExpirationDate"] = this.driverLicenseExpirationDate ? this.driverLicenseExpirationDate.toISOString() : <any>undefined;
        data["hourlyRate"] = this.hourlyRate;
        data["dailyRate"] = this.dailyRate;
        data["perSprintRate"] = this.perSprintRate;
        data["onDemand"] = this.onDemand;
        data["ownVehicle"] = this.ownVehicle;
        data["isActive"] = this.isActive;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDrivers {
    tenantId: number | undefined;
    user: User;
    userId: number;
    contact: Contact;
    contactId: number;
    vehicle: Vehicle | undefined;
    vehicleId: number | undefined;
    startDate: moment.Moment | undefined;
    endDate: moment.Moment | undefined;
    driverLicenseNumber: string | undefined;
    driverLicenseState: string | undefined;
    driverLicenseExpirationDate: moment.Moment | undefined;
    hourlyRate: number | undefined;
    dailyRate: number | undefined;
    perSprintRate: number | undefined;
    onDemand: boolean;
    ownVehicle: boolean;
    isActive: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DriverRating implements IDriverRating {
    starRating!: number;
    order!: Order | undefined;
    orderId!: number;
    driverId!: number;
    details!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDriverRating) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.starRating = data["starRating"];
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.driverId = data["driverId"];
            this.details = data["details"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DriverRating {
        data = typeof data === 'object' ? data : {};
        let result = new DriverRating();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["starRating"] = this.starRating;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["driverId"] = this.driverId;
        data["details"] = this.details;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDriverRating {
    starRating: number;
    order: Order | undefined;
    orderId: number;
    driverId: number;
    details: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class AdjustmentType implements IAdjustmentType {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    name!: string | undefined;
    code!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IAdjustmentType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.name = data["name"];
            this.code = data["code"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AdjustmentType {
        data = typeof data === 'object' ? data : {};
        let result = new AdjustmentType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["name"] = this.name;
        data["code"] = this.code;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAdjustmentType {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    name: string | undefined;
    code: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class LocationAdjustment implements ILocationAdjustment {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    value!: number;
    location!: Location | undefined;
    locationId!: number;
    adjustmentType!: AdjustmentType | undefined;
    adjustmentTypeId!: number;
    distance!: number | undefined;
    timeStart!: TimeSpan | undefined;
    timeEnd!: TimeSpan | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ILocationAdjustment) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.value = data["value"];
            this.location = data["location"] ? Location.fromJS(data["location"]) : <any>undefined;
            this.locationId = data["locationId"];
            this.adjustmentType = data["adjustmentType"] ? AdjustmentType.fromJS(data["adjustmentType"]) : <any>undefined;
            this.adjustmentTypeId = data["adjustmentTypeId"];
            this.distance = data["distance"];
            this.timeStart = data["timeStart"] ? TimeSpan.fromJS(data["timeStart"]) : <any>undefined;
            this.timeEnd = data["timeEnd"] ? TimeSpan.fromJS(data["timeEnd"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): LocationAdjustment {
        data = typeof data === 'object' ? data : {};
        let result = new LocationAdjustment();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["value"] = this.value;
        data["location"] = this.location ? this.location.toJSON() : <any>undefined;
        data["locationId"] = this.locationId;
        data["adjustmentType"] = this.adjustmentType ? this.adjustmentType.toJSON() : <any>undefined;
        data["adjustmentTypeId"] = this.adjustmentTypeId;
        data["distance"] = this.distance;
        data["timeStart"] = this.timeStart ? this.timeStart.toJSON() : <any>undefined;
        data["timeEnd"] = this.timeEnd ? this.timeEnd.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ILocationAdjustment {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    value: number;
    location: Location | undefined;
    locationId: number;
    adjustmentType: AdjustmentType | undefined;
    adjustmentTypeId: number;
    distance: number | undefined;
    timeStart: TimeSpan | undefined;
    timeEnd: TimeSpan | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteOptimizer implements IRouteOptimizer {
    tenantId!: number | undefined;
    name!: string | undefined;
    toll!: boolean;
    highways!: boolean;
    ferries!: boolean;
    indoor!: boolean;
    active!: boolean;
    withTraffic!: boolean;
    startPeriod!: moment.Moment;
    endPeriod!: moment.Moment | undefined;
    indefinite!: boolean;
    locationId!: number | undefined;
    locationFk!: Location | undefined;
    isDefault!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteOptimizer) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.toll = data["toll"];
            this.highways = data["highways"];
            this.ferries = data["ferries"];
            this.indoor = data["indoor"];
            this.active = data["active"];
            this.withTraffic = data["withTraffic"];
            this.startPeriod = data["startPeriod"] ? moment(data["startPeriod"].toString()) : <any>undefined;
            this.endPeriod = data["endPeriod"] ? moment(data["endPeriod"].toString()) : <any>undefined;
            this.indefinite = data["indefinite"];
            this.locationId = data["locationId"];
            this.locationFk = data["locationFk"] ? Location.fromJS(data["locationFk"]) : <any>undefined;
            this.isDefault = data["isDefault"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteOptimizer {
        data = typeof data === 'object' ? data : {};
        let result = new RouteOptimizer();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["toll"] = this.toll;
        data["highways"] = this.highways;
        data["ferries"] = this.ferries;
        data["indoor"] = this.indoor;
        data["active"] = this.active;
        data["withTraffic"] = this.withTraffic;
        data["startPeriod"] = this.startPeriod ? this.startPeriod.toISOString() : <any>undefined;
        data["endPeriod"] = this.endPeriod ? this.endPeriod.toISOString() : <any>undefined;
        data["indefinite"] = this.indefinite;
        data["locationId"] = this.locationId;
        data["locationFk"] = this.locationFk ? this.locationFk.toJSON() : <any>undefined;
        data["isDefault"] = this.isDefault;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteOptimizer {
    tenantId: number | undefined;
    name: string | undefined;
    toll: boolean;
    highways: boolean;
    ferries: boolean;
    indoor: boolean;
    active: boolean;
    withTraffic: boolean;
    startPeriod: moment.Moment;
    endPeriod: moment.Moment | undefined;
    indefinite: boolean;
    locationId: number | undefined;
    locationFk: Location | undefined;
    isDefault: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteOptimizerRule implements IRouteOptimizerRule {
    tenantId!: number | undefined;
    timeForExecution!: moment.Moment | undefined;
    distance!: number | undefined;
    orderPosition!: number | undefined;
    routeOptimizerId!: number | undefined;
    orderTypeId!: number | undefined;
    orderType!: OrderType | undefined;
    routeOptimizerFk!: RouteOptimizer | undefined;
    orderStatusTypeId!: number | undefined;
    orderStatusTypeFk!: OrderStatusType | undefined;
    ruleType!: number;
    useGoogle!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteOptimizerRule) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.timeForExecution = data["timeForExecution"] ? moment(data["timeForExecution"].toString()) : <any>undefined;
            this.distance = data["distance"];
            this.orderPosition = data["orderPosition"];
            this.routeOptimizerId = data["routeOptimizerId"];
            this.orderTypeId = data["orderTypeId"];
            this.orderType = data["orderType"] ? OrderType.fromJS(data["orderType"]) : <any>undefined;
            this.routeOptimizerFk = data["routeOptimizerFk"] ? RouteOptimizer.fromJS(data["routeOptimizerFk"]) : <any>undefined;
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderStatusTypeFk = data["orderStatusTypeFk"] ? OrderStatusType.fromJS(data["orderStatusTypeFk"]) : <any>undefined;
            this.ruleType = data["ruleType"];
            this.useGoogle = data["useGoogle"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteOptimizerRule {
        data = typeof data === 'object' ? data : {};
        let result = new RouteOptimizerRule();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["timeForExecution"] = this.timeForExecution ? this.timeForExecution.toISOString() : <any>undefined;
        data["distance"] = this.distance;
        data["orderPosition"] = this.orderPosition;
        data["routeOptimizerId"] = this.routeOptimizerId;
        data["orderTypeId"] = this.orderTypeId;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["routeOptimizerFk"] = this.routeOptimizerFk ? this.routeOptimizerFk.toJSON() : <any>undefined;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderStatusTypeFk"] = this.orderStatusTypeFk ? this.orderStatusTypeFk.toJSON() : <any>undefined;
        data["ruleType"] = this.ruleType;
        data["useGoogle"] = this.useGoogle;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteOptimizerRule {
    tenantId: number | undefined;
    timeForExecution: moment.Moment | undefined;
    distance: number | undefined;
    orderPosition: number | undefined;
    routeOptimizerId: number | undefined;
    orderTypeId: number | undefined;
    orderType: OrderType | undefined;
    routeOptimizerFk: RouteOptimizer | undefined;
    orderStatusTypeId: number | undefined;
    orderStatusTypeFk: OrderStatusType | undefined;
    ruleType: number;
    useGoogle: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ReportSchedulesRecipients implements IReportSchedulesRecipients {
    tenantId!: number | undefined;
    lastModifierUserId!: number | undefined;
    reportSchedule!: ReportSchedules | undefined;
    reportScheduleId!: number;
    emailAddress!: string | undefined;
    organizationUnit!: OrganizationUnit | undefined;
    organizationUnitId!: number | undefined;
    user!: User | undefined;
    userId!: number | undefined;
    isActive!: boolean;
    code!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IReportSchedulesRecipients) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.lastModifierUserId = data["lastModifierUserId"];
            this.reportSchedule = data["reportSchedule"] ? ReportSchedules.fromJS(data["reportSchedule"]) : <any>undefined;
            this.reportScheduleId = data["reportScheduleId"];
            this.emailAddress = data["emailAddress"];
            this.organizationUnit = data["organizationUnit"] ? OrganizationUnit.fromJS(data["organizationUnit"]) : <any>undefined;
            this.organizationUnitId = data["organizationUnitId"];
            this.user = data["user"] ? User.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.isActive = data["isActive"];
            this.code = data["code"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ReportSchedulesRecipients {
        data = typeof data === 'object' ? data : {};
        let result = new ReportSchedulesRecipients();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["reportSchedule"] = this.reportSchedule ? this.reportSchedule.toJSON() : <any>undefined;
        data["reportScheduleId"] = this.reportScheduleId;
        data["emailAddress"] = this.emailAddress;
        data["organizationUnit"] = this.organizationUnit ? this.organizationUnit.toJSON() : <any>undefined;
        data["organizationUnitId"] = this.organizationUnitId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["isActive"] = this.isActive;
        data["code"] = this.code;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IReportSchedulesRecipients {
    tenantId: number | undefined;
    lastModifierUserId: number | undefined;
    reportSchedule: ReportSchedules | undefined;
    reportScheduleId: number;
    emailAddress: string | undefined;
    organizationUnit: OrganizationUnit | undefined;
    organizationUnitId: number | undefined;
    user: User | undefined;
    userId: number | undefined;
    isActive: boolean;
    code: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ReportScheduleParameters implements IReportScheduleParameters {
    tenantId!: number | undefined;
    report!: Reports | undefined;
    reportId!: number;
    reportSchedule!: ReportSchedules | undefined;
    reportScheduleId!: number;
    parameterName!: string | undefined;
    parameterValue!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IReportScheduleParameters) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.report = data["report"] ? Reports.fromJS(data["report"]) : <any>undefined;
            this.reportId = data["reportId"];
            this.reportSchedule = data["reportSchedule"] ? ReportSchedules.fromJS(data["reportSchedule"]) : <any>undefined;
            this.reportScheduleId = data["reportScheduleId"];
            this.parameterName = data["parameterName"];
            this.parameterValue = data["parameterValue"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ReportScheduleParameters {
        data = typeof data === 'object' ? data : {};
        let result = new ReportScheduleParameters();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["report"] = this.report ? this.report.toJSON() : <any>undefined;
        data["reportId"] = this.reportId;
        data["reportSchedule"] = this.reportSchedule ? this.reportSchedule.toJSON() : <any>undefined;
        data["reportScheduleId"] = this.reportScheduleId;
        data["parameterName"] = this.parameterName;
        data["parameterValue"] = this.parameterValue;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IReportScheduleParameters {
    tenantId: number | undefined;
    report: Reports | undefined;
    reportId: number;
    reportSchedule: ReportSchedules | undefined;
    reportScheduleId: number;
    parameterName: string | undefined;
    parameterValue: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ReportSchedulerFtpServers implements IReportSchedulerFtpServers {
    tenantId!: number | undefined;
    reportSchedule!: ReportSchedules | undefined;
    reportScheduleId!: number;
    serverName!: string | undefined;
    userName!: string | undefined;
    password!: string | undefined;
    folderName!: string | undefined;
    isSftp!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IReportSchedulerFtpServers) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.reportSchedule = data["reportSchedule"] ? ReportSchedules.fromJS(data["reportSchedule"]) : <any>undefined;
            this.reportScheduleId = data["reportScheduleId"];
            this.serverName = data["serverName"];
            this.userName = data["userName"];
            this.password = data["password"];
            this.folderName = data["folderName"];
            this.isSftp = data["isSftp"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ReportSchedulerFtpServers {
        data = typeof data === 'object' ? data : {};
        let result = new ReportSchedulerFtpServers();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["reportSchedule"] = this.reportSchedule ? this.reportSchedule.toJSON() : <any>undefined;
        data["reportScheduleId"] = this.reportScheduleId;
        data["serverName"] = this.serverName;
        data["userName"] = this.userName;
        data["password"] = this.password;
        data["folderName"] = this.folderName;
        data["isSftp"] = this.isSftp;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IReportSchedulerFtpServers {
    tenantId: number | undefined;
    reportSchedule: ReportSchedules | undefined;
    reportScheduleId: number;
    serverName: string | undefined;
    userName: string | undefined;
    password: string | undefined;
    folderName: string | undefined;
    isSftp: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class CachedRequestSetting implements ICachedRequestSetting {
    apiRequestCode!: string | undefined;
    type!: CachedRequestPriority;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ICachedRequestSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.apiRequestCode = data["apiRequestCode"];
            this.type = data["type"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CachedRequestSetting {
        data = typeof data === 'object' ? data : {};
        let result = new CachedRequestSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["apiRequestCode"] = this.apiRequestCode;
        data["type"] = this.type;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICachedRequestSetting {
    apiRequestCode: string | undefined;
    type: CachedRequestPriority;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class TextToSpeechSetting implements ITextToSpeechSetting {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    code!: string | undefined;
    description!: string | undefined;
    content!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ITextToSpeechSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.code = data["code"];
            this.description = data["description"];
            this.content = data["content"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TextToSpeechSetting {
        data = typeof data === 'object' ? data : {};
        let result = new TextToSpeechSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["description"] = this.description;
        data["content"] = this.content;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITextToSpeechSetting {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    code: string | undefined;
    description: string | undefined;
    content: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class UserEvent implements IUserEvent {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    time!: moment.Moment;
    geocodeId!: number | undefined;
    geocode!: Geocode | undefined;
    code!: string | undefined;
    value!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUserEvent) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.code = data["code"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserEvent {
        data = typeof data === 'object' ? data : {};
        let result = new UserEvent();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserEvent {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    time: moment.Moment;
    geocodeId: number | undefined;
    geocode: Geocode | undefined;
    code: string | undefined;
    value: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteNotificationRecipient implements IRouteNotificationRecipient {
    tenantId!: number | undefined;
    isEmail!: boolean;
    isSMS!: boolean;
    isActive!: boolean;
    emailAddress!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    organizationUnitFk!: OrganizationUnit | undefined;
    userId!: number | undefined;
    userFk!: User | undefined;
    routeTemplateId!: number | undefined;
    routeTemplateFk!: RouteTemplate | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteNotificationRecipient) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.isEmail = data["isEmail"];
            this.isSMS = data["isSMS"];
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.organizationUnitFk = data["organizationUnitFk"] ? OrganizationUnit.fromJS(data["organizationUnitFk"]) : <any>undefined;
            this.userId = data["userId"];
            this.userFk = data["userFk"] ? User.fromJS(data["userFk"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.routeTemplateFk = data["routeTemplateFk"] ? RouteTemplate.fromJS(data["routeTemplateFk"]) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteNotificationRecipient {
        data = typeof data === 'object' ? data : {};
        let result = new RouteNotificationRecipient();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["isEmail"] = this.isEmail;
        data["isSMS"] = this.isSMS;
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["organizationUnitFk"] = this.organizationUnitFk ? this.organizationUnitFk.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["userFk"] = this.userFk ? this.userFk.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["routeTemplateFk"] = this.routeTemplateFk ? this.routeTemplateFk.toJSON() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteNotificationRecipient {
    tenantId: number | undefined;
    isEmail: boolean;
    isSMS: boolean;
    isActive: boolean;
    emailAddress: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    organizationUnitFk: OrganizationUnit | undefined;
    userId: number | undefined;
    userFk: User | undefined;
    routeTemplateId: number | undefined;
    routeTemplateFk: RouteTemplate | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class PhotoContent implements IPhotoContent {
    fileName!: string | undefined;
    content!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IPhotoContent) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.content = data["content"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PhotoContent {
        data = typeof data === 'object' ? data : {};
        let result = new PhotoContent();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["content"] = this.content;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPhotoContent {
    fileName: string | undefined;
    content: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderStatusPhoto implements IOrderStatusPhoto {
    id!: number;
    order!: Order | undefined;
    orderId!: number;
    fileName!: string | undefined;
    deviceTime!: moment.Moment;
    photoContent!: PhotoContent | undefined;
    photoContentId!: number;
    content!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;

    constructor(data?: IOrderStatusPhoto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.fileName = data["fileName"];
            this.deviceTime = data["deviceTime"] ? moment(data["deviceTime"].toString()) : <any>undefined;
            this.photoContent = data["photoContent"] ? PhotoContent.fromJS(data["photoContent"]) : <any>undefined;
            this.photoContentId = data["photoContentId"];
            this.content = data["content"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
        }
    }

    static fromJS(data: any): OrderStatusPhoto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderStatusPhoto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["fileName"] = this.fileName;
        data["deviceTime"] = this.deviceTime ? this.deviceTime.toISOString() : <any>undefined;
        data["photoContent"] = this.photoContent ? this.photoContent.toJSON() : <any>undefined;
        data["photoContentId"] = this.photoContentId;
        data["content"] = this.content;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        return data; 
    }
}

export interface IOrderStatusPhoto {
    id: number;
    order: Order | undefined;
    orderId: number;
    fileName: string | undefined;
    deviceTime: moment.Moment;
    photoContent: PhotoContent | undefined;
    photoContentId: number;
    content: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
}

export class FirebaseToken implements IFirebaseToken {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    token!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IFirebaseToken) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.token = data["token"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): FirebaseToken {
        data = typeof data === 'object' ? data : {};
        let result = new FirebaseToken();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["token"] = this.token;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFirebaseToken {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    token: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class FirebaseNotificationRequest implements IFirebaseNotificationRequest {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    token!: string | undefined;
    driverId!: number;
    content!: string | undefined;
    isSent!: boolean;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IFirebaseNotificationRequest) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.token = data["token"];
            this.driverId = data["driverId"];
            this.content = data["content"];
            this.isSent = data["isSent"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): FirebaseNotificationRequest {
        data = typeof data === 'object' ? data : {};
        let result = new FirebaseNotificationRequest();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["token"] = this.token;
        data["driverId"] = this.driverId;
        data["content"] = this.content;
        data["isSent"] = this.isSent;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFirebaseNotificationRequest {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    token: string | undefined;
    driverId: number;
    content: string | undefined;
    isSent: boolean;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class BlindCountErrorPackage implements IBlindCountErrorPackage {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    blindCountErrorId!: number;
    blindCountError!: BlindCountError | undefined;
    packageId!: number;
    package!: Package | undefined;
    routeId!: number;
    route!: Route | undefined;
    quantity!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IBlindCountErrorPackage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.blindCountErrorId = data["blindCountErrorId"];
            this.blindCountError = data["blindCountError"] ? BlindCountError.fromJS(data["blindCountError"]) : <any>undefined;
            this.packageId = data["packageId"];
            this.package = data["package"] ? Package.fromJS(data["package"]) : <any>undefined;
            this.routeId = data["routeId"];
            this.route = data["route"] ? Route.fromJS(data["route"]) : <any>undefined;
            this.quantity = data["quantity"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): BlindCountErrorPackage {
        data = typeof data === 'object' ? data : {};
        let result = new BlindCountErrorPackage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["blindCountErrorId"] = this.blindCountErrorId;
        data["blindCountError"] = this.blindCountError ? this.blindCountError.toJSON() : <any>undefined;
        data["packageId"] = this.packageId;
        data["package"] = this.package ? this.package.toJSON() : <any>undefined;
        data["routeId"] = this.routeId;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["quantity"] = this.quantity;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IBlindCountErrorPackage {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    blindCountErrorId: number;
    blindCountError: BlindCountError | undefined;
    packageId: number;
    package: Package | undefined;
    routeId: number;
    route: Route | undefined;
    quantity: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class AutomatedTestAccount implements IAutomatedTestAccount {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    username!: string | undefined;
    password!: string | undefined;
    vehicleId!: number;
    isAvailable!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IAutomatedTestAccount) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.username = data["username"];
            this.password = data["password"];
            this.vehicleId = data["vehicleId"];
            this.isAvailable = data["isAvailable"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AutomatedTestAccount {
        data = typeof data === 'object' ? data : {};
        let result = new AutomatedTestAccount();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["username"] = this.username;
        data["password"] = this.password;
        data["vehicleId"] = this.vehicleId;
        data["isAvailable"] = this.isAvailable;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAutomatedTestAccount {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    username: string | undefined;
    password: string | undefined;
    vehicleId: number;
    isAvailable: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class AutomatedTestAccountDataState implements IAutomatedTestAccountDataState {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    testAccountId!: number;
    testAccount!: AutomatedTestAccount | undefined;
    status!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IAutomatedTestAccountDataState) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.testAccountId = data["testAccountId"];
            this.testAccount = data["testAccount"] ? AutomatedTestAccount.fromJS(data["testAccount"]) : <any>undefined;
            this.status = data["status"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AutomatedTestAccountDataState {
        data = typeof data === 'object' ? data : {};
        let result = new AutomatedTestAccountDataState();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["testAccountId"] = this.testAccountId;
        data["testAccount"] = this.testAccount ? this.testAccount.toJSON() : <any>undefined;
        data["status"] = this.status;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAutomatedTestAccountDataState {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    testAccountId: number;
    testAccount: AutomatedTestAccount | undefined;
    status: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class EtaErrorCode implements IEtaErrorCode {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    orderId!: number;
    order!: Order | undefined;
    statusId!: number;
    status!: OrderStatusType | undefined;
    geocodeId!: number;
    geocode!: Geocode | undefined;
    value!: string | undefined;
    time!: moment.Moment;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IEtaErrorCode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.statusId = data["statusId"];
            this.status = data["status"] ? OrderStatusType.fromJS(data["status"]) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.value = data["value"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EtaErrorCode {
        data = typeof data === 'object' ? data : {};
        let result = new EtaErrorCode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["statusId"] = this.statusId;
        data["status"] = this.status ? this.status.toJSON() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["value"] = this.value;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEtaErrorCode {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    orderId: number;
    order: Order | undefined;
    statusId: number;
    status: OrderStatusType | undefined;
    geocodeId: number;
    geocode: Geocode | undefined;
    value: string | undefined;
    time: moment.Moment;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteScheduleSetting implements IRouteScheduleSetting {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    routeScheduleDetailId!: number;
    routeScheduleDetail!: RouteScheduleDetail | undefined;
    code!: string | undefined;
    value!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteScheduleSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.routeScheduleDetail = data["routeScheduleDetail"] ? RouteScheduleDetail.fromJS(data["routeScheduleDetail"]) : <any>undefined;
            this.code = data["code"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteScheduleSetting {
        data = typeof data === 'object' ? data : {};
        let result = new RouteScheduleSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["routeScheduleDetail"] = this.routeScheduleDetail ? this.routeScheduleDetail.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteScheduleSetting {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    routeScheduleDetailId: number;
    routeScheduleDetail: RouteScheduleDetail | undefined;
    code: string | undefined;
    value: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteHandOffSchedule implements IRouteHandOffSchedule {
    tenantId!: number | undefined;
    contactFk!: Contact | undefined;
    contactId!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteHandOffSchedule) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.contactFk = data["contactFk"] ? Contact.fromJS(data["contactFk"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteHandOffSchedule {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffSchedule();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["contactFk"] = this.contactFk ? this.contactFk.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteHandOffSchedule {
    tenantId: number | undefined;
    contactFk: Contact | undefined;
    contactId: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RouteHandOffScheduleSetting implements IRouteHandOffScheduleSetting {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    routeHandOffScheduleId!: number;
    routeHandOffSchedule!: RouteHandOffSchedule | undefined;
    code!: string | undefined;
    value!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRouteHandOffScheduleSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.routeHandOffScheduleId = data["routeHandOffScheduleId"];
            this.routeHandOffSchedule = data["routeHandOffSchedule"] ? RouteHandOffSchedule.fromJS(data["routeHandOffSchedule"]) : <any>undefined;
            this.code = data["code"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RouteHandOffScheduleSetting {
        data = typeof data === 'object' ? data : {};
        let result = new RouteHandOffScheduleSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["routeHandOffScheduleId"] = this.routeHandOffScheduleId;
        data["routeHandOffSchedule"] = this.routeHandOffSchedule ? this.routeHandOffSchedule.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRouteHandOffScheduleSetting {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    routeHandOffScheduleId: number;
    routeHandOffSchedule: RouteHandOffSchedule | undefined;
    code: string | undefined;
    value: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderValidationCode implements IOrderValidationCode {
    order!: Order | undefined;
    orderId!: number;
    geocode!: Geocode | undefined;
    geocodeId!: number;
    type!: string | undefined;
    value!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderValidationCode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.order = data["order"] ? Order.fromJS(data["order"]) : <any>undefined;
            this.orderId = data["orderId"];
            this.geocode = data["geocode"] ? Geocode.fromJS(data["geocode"]) : <any>undefined;
            this.geocodeId = data["geocodeId"];
            this.type = data["type"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderValidationCode {
        data = typeof data === 'object' ? data : {};
        let result = new OrderValidationCode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["order"] = this.order ? this.order.toJSON() : <any>undefined;
        data["orderId"] = this.orderId;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["geocodeId"] = this.geocodeId;
        data["type"] = this.type;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderValidationCode {
    order: Order | undefined;
    orderId: number;
    geocode: Geocode | undefined;
    geocodeId: number;
    type: string | undefined;
    value: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class MobileTenantCode implements IMobileTenantCode {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    code!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IMobileTenantCode) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.code = data["code"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileTenantCode {
        data = typeof data === 'object' ? data : {};
        let result = new MobileTenantCode();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileTenantCode {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    code: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class AutomatedTestDispatchCommandParam implements IAutomatedTestDispatchCommandParam {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    testAccountId!: number;
    testAccount!: AutomatedTestAccount | undefined;
    commandCode!: string | undefined;
    parameter!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IAutomatedTestDispatchCommandParam) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.testAccountId = data["testAccountId"];
            this.testAccount = data["testAccount"] ? AutomatedTestAccount.fromJS(data["testAccount"]) : <any>undefined;
            this.commandCode = data["commandCode"];
            this.parameter = data["parameter"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AutomatedTestDispatchCommandParam {
        data = typeof data === 'object' ? data : {};
        let result = new AutomatedTestDispatchCommandParam();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["testAccountId"] = this.testAccountId;
        data["testAccount"] = this.testAccount ? this.testAccount.toJSON() : <any>undefined;
        data["commandCode"] = this.commandCode;
        data["parameter"] = this.parameter;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAutomatedTestDispatchCommandParam {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    testAccountId: number;
    testAccount: AutomatedTestAccount | undefined;
    commandCode: string | undefined;
    parameter: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class MobileClientCacheData implements IMobileClientCacheData {
    tenantId!: number | undefined;
    content!: string | undefined;
    isRead!: boolean;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IMobileClientCacheData) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.content = data["content"];
            this.isRead = data["isRead"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileClientCacheData {
        data = typeof data === 'object' ? data : {};
        let result = new MobileClientCacheData();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["content"] = this.content;
        data["isRead"] = this.isRead;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileClientCacheData {
    tenantId: number | undefined;
    content: string | undefined;
    isRead: boolean;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class MobileClientSentRequest implements IMobileClientSentRequest {
    tenantId!: number | undefined;
    driverId!: number | undefined;
    hash!: string | undefined;
    creationTime!: moment.Moment;
    id!: number;

    constructor(data?: IMobileClientSentRequest) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.driverId = data["driverId"];
            this.hash = data["hash"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileClientSentRequest {
        data = typeof data === 'object' ? data : {};
        let result = new MobileClientSentRequest();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["driverId"] = this.driverId;
        data["hash"] = this.hash;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileClientSentRequest {
    tenantId: number | undefined;
    driverId: number | undefined;
    hash: string | undefined;
    creationTime: moment.Moment;
    id: number;
}

export class DestinationBlindCountError implements IDestinationBlindCountError {
    tenantId!: number | undefined;
    routeId!: number;
    route!: Route | undefined;
    destinationId!: number;
    orderStatusTypeId!: number;
    verifierId!: number | undefined;
    code!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDestinationBlindCountError) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeId = data["routeId"];
            this.route = data["route"] ? Route.fromJS(data["route"]) : <any>undefined;
            this.destinationId = data["destinationId"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.verifierId = data["verifierId"];
            this.code = data["code"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DestinationBlindCountError {
        data = typeof data === 'object' ? data : {};
        let result = new DestinationBlindCountError();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeId"] = this.routeId;
        data["route"] = this.route ? this.route.toJSON() : <any>undefined;
        data["destinationId"] = this.destinationId;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["verifierId"] = this.verifierId;
        data["code"] = this.code;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDestinationBlindCountError {
    tenantId: number | undefined;
    routeId: number;
    route: Route | undefined;
    destinationId: number;
    orderStatusTypeId: number;
    verifierId: number | undefined;
    code: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class DestinationBlindCountErrorContainer implements IDestinationBlindCountErrorContainer {
    tenantId!: number | undefined;
    routeId!: number;
    destinationBlindCountErrorId!: number;
    destinationBlindCountError!: DestinationBlindCountError | undefined;
    containerId!: number;
    container!: Container | undefined;
    quantity!: number;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IDestinationBlindCountErrorContainer) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.routeId = data["routeId"];
            this.destinationBlindCountErrorId = data["destinationBlindCountErrorId"];
            this.destinationBlindCountError = data["destinationBlindCountError"] ? DestinationBlindCountError.fromJS(data["destinationBlindCountError"]) : <any>undefined;
            this.containerId = data["containerId"];
            this.container = data["container"] ? Container.fromJS(data["container"]) : <any>undefined;
            this.quantity = data["quantity"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): DestinationBlindCountErrorContainer {
        data = typeof data === 'object' ? data : {};
        let result = new DestinationBlindCountErrorContainer();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["routeId"] = this.routeId;
        data["destinationBlindCountErrorId"] = this.destinationBlindCountErrorId;
        data["destinationBlindCountError"] = this.destinationBlindCountError ? this.destinationBlindCountError.toJSON() : <any>undefined;
        data["containerId"] = this.containerId;
        data["container"] = this.container ? this.container.toJSON() : <any>undefined;
        data["quantity"] = this.quantity;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IDestinationBlindCountErrorContainer {
    tenantId: number | undefined;
    routeId: number;
    destinationBlindCountErrorId: number;
    destinationBlindCountError: DestinationBlindCountError | undefined;
    containerId: number;
    container: Container | undefined;
    quantity: number;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class MobileClientVersion implements IMobileClientVersion {
    tenantId!: number | undefined;
    clientCode!: string | undefined;
    osName!: string | undefined;
    minimumVersion!: number;
    versionName!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IMobileClientVersion) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.clientCode = data["clientCode"];
            this.osName = data["osName"];
            this.minimumVersion = data["minimumVersion"];
            this.versionName = data["versionName"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileClientVersion {
        data = typeof data === 'object' ? data : {};
        let result = new MobileClientVersion();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["clientCode"] = this.clientCode;
        data["osName"] = this.osName;
        data["minimumVersion"] = this.minimumVersion;
        data["versionName"] = this.versionName;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileClientVersion {
    tenantId: number | undefined;
    clientCode: string | undefined;
    osName: string | undefined;
    minimumVersion: number;
    versionName: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrderAttachmentCacheKey implements IOrderAttachmentCacheKey {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    key!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrderAttachmentCacheKey) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.key = data["key"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrderAttachmentCacheKey {
        data = typeof data === 'object' ? data : {};
        let result = new OrderAttachmentCacheKey();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["key"] = this.key;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrderAttachmentCacheKey {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    key: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RateRules implements IRateRules {
    tenantId!: number | undefined;
    minAmount!: number | undefined;
    maxAmount!: number | undefined;
    amount!: number | undefined;
    rateAmount!: number | undefined;
    rate!: Rates | undefined;
    rateId!: number;
    rateType!: RateType;
    rule!: Rule;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRateRules) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.minAmount = data["minAmount"];
            this.maxAmount = data["maxAmount"];
            this.amount = data["amount"];
            this.rateAmount = data["rateAmount"];
            this.rate = data["rate"] ? Rates.fromJS(data["rate"]) : <any>undefined;
            this.rateId = data["rateId"];
            this.rateType = data["rateType"];
            this.rule = data["rule"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RateRules {
        data = typeof data === 'object' ? data : {};
        let result = new RateRules();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["minAmount"] = this.minAmount;
        data["maxAmount"] = this.maxAmount;
        data["amount"] = this.amount;
        data["rateAmount"] = this.rateAmount;
        data["rate"] = this.rate ? this.rate.toJSON() : <any>undefined;
        data["rateId"] = this.rateId;
        data["rateType"] = this.rateType;
        data["rule"] = this.rule;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRateRules {
    tenantId: number | undefined;
    minAmount: number | undefined;
    maxAmount: number | undefined;
    amount: number | undefined;
    rateAmount: number | undefined;
    rate: Rates | undefined;
    rateId: number;
    rateType: RateType;
    rule: Rule;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RoleClaim implements IRoleClaim {
    tenantId!: number | undefined;
    roleId!: number;
    claimType!: string | undefined;
    claimValue!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRoleClaim) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.roleId = data["roleId"];
            this.claimType = data["claimType"];
            this.claimValue = data["claimValue"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RoleClaim {
        data = typeof data === 'object' ? data : {};
        let result = new RoleClaim();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["roleId"] = this.roleId;
        data["claimType"] = this.claimType;
        data["claimValue"] = this.claimValue;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRoleClaim {
    tenantId: number | undefined;
    roleId: number;
    claimType: string | undefined;
    claimValue: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class RolePermissionSetting implements IRolePermissionSetting {
    roleId!: number;
    tenantId!: number | undefined;
    name!: string;
    isGranted!: boolean;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRolePermissionSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.roleId = data["roleId"];
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.isGranted = data["isGranted"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): RolePermissionSetting {
        data = typeof data === 'object' ? data : {};
        let result = new RolePermissionSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["roleId"] = this.roleId;
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["isGranted"] = this.isGranted;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRolePermissionSetting {
    roleId: number;
    tenantId: number | undefined;
    name: string;
    isGranted: boolean;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class Role implements IRole {
    normalizedName!: string;
    claims!: RoleClaim[] | undefined;
    concurrencyStamp!: string | undefined;
    deleterUser!: User | undefined;
    creatorUser!: User | undefined;
    lastModifierUser!: User | undefined;
    tenantId!: number | undefined;
    name!: string;
    displayName!: string;
    isStatic!: boolean;
    isDefault!: boolean;
    permissions!: RolePermissionSetting[] | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IRole) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.normalizedName = data["normalizedName"];
            if (Array.isArray(data["claims"])) {
                this.claims = [] as any;
                for (let item of data["claims"])
                    this.claims!.push(RoleClaim.fromJS(item));
            }
            this.concurrencyStamp = data["concurrencyStamp"];
            this.deleterUser = data["deleterUser"] ? User.fromJS(data["deleterUser"]) : <any>undefined;
            this.creatorUser = data["creatorUser"] ? User.fromJS(data["creatorUser"]) : <any>undefined;
            this.lastModifierUser = data["lastModifierUser"] ? User.fromJS(data["lastModifierUser"]) : <any>undefined;
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.isStatic = data["isStatic"];
            this.isDefault = data["isDefault"];
            if (Array.isArray(data["permissions"])) {
                this.permissions = [] as any;
                for (let item of data["permissions"])
                    this.permissions!.push(RolePermissionSetting.fromJS(item));
            }
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): Role {
        data = typeof data === 'object' ? data : {};
        let result = new Role();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["normalizedName"] = this.normalizedName;
        if (Array.isArray(this.claims)) {
            data["claims"] = [];
            for (let item of this.claims)
                data["claims"].push(item.toJSON());
        }
        data["concurrencyStamp"] = this.concurrencyStamp;
        data["deleterUser"] = this.deleterUser ? this.deleterUser.toJSON() : <any>undefined;
        data["creatorUser"] = this.creatorUser ? this.creatorUser.toJSON() : <any>undefined;
        data["lastModifierUser"] = this.lastModifierUser ? this.lastModifierUser.toJSON() : <any>undefined;
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["isStatic"] = this.isStatic;
        data["isDefault"] = this.isDefault;
        if (Array.isArray(this.permissions)) {
            data["permissions"] = [];
            for (let item of this.permissions)
                data["permissions"].push(item.toJSON());
        }
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IRole {
    normalizedName: string;
    claims: RoleClaim[] | undefined;
    concurrencyStamp: string | undefined;
    deleterUser: User | undefined;
    creatorUser: User | undefined;
    lastModifierUser: User | undefined;
    tenantId: number | undefined;
    name: string;
    displayName: string;
    isStatic: boolean;
    isDefault: boolean;
    permissions: RolePermissionSetting[] | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export enum ShippingActionType {
    Pickup = 0,
    Delivery = 1,
}

export class ShippingRoleAction implements IShippingRoleAction {
    tenant!: Tenant | undefined;
    tenantId!: number | undefined;
    role!: Role | undefined;
    roleId!: number;
    actionType!: ShippingActionType;
    orderStatusType!: OrderStatusType | undefined;
    orderStatusTypeId!: number;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IShippingRoleAction) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.tenantId = data["tenantId"];
            this.role = data["role"] ? Role.fromJS(data["role"]) : <any>undefined;
            this.roleId = data["roleId"];
            this.actionType = data["actionType"];
            this.orderStatusType = data["orderStatusType"] ? OrderStatusType.fromJS(data["orderStatusType"]) : <any>undefined;
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ShippingRoleAction {
        data = typeof data === 'object' ? data : {};
        let result = new ShippingRoleAction();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["tenantId"] = this.tenantId;
        data["role"] = this.role ? this.role.toJSON() : <any>undefined;
        data["roleId"] = this.roleId;
        data["actionType"] = this.actionType;
        data["orderStatusType"] = this.orderStatusType ? this.orderStatusType.toJSON() : <any>undefined;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IShippingRoleAction {
    tenant: Tenant | undefined;
    tenantId: number | undefined;
    role: Role | undefined;
    roleId: number;
    actionType: ShippingActionType;
    orderStatusType: OrderStatusType | undefined;
    orderStatusTypeId: number;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class MobileClientWarning implements IMobileClientWarning {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    code!: string | undefined;
    count!: number;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IMobileClientWarning) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.code = data["code"];
            this.count = data["count"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): MobileClientWarning {
        data = typeof data === 'object' ? data : {};
        let result = new MobileClientWarning();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["count"] = this.count;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IMobileClientWarning {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    code: string | undefined;
    count: number;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ContactGroup implements IContactGroup {
    tenantId!: number | undefined;
    tenant!: Tenant | undefined;
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    isActive!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IContactGroup) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"] ? Tenant.fromJS(data["tenant"]) : <any>undefined;
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.isActive = data["isActive"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ContactGroup {
        data = typeof data === 'object' ? data : {};
        let result = new ContactGroup();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["isActive"] = this.isActive;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IContactGroup {
    tenantId: number | undefined;
    tenant: Tenant | undefined;
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    isActive: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ContactGroupMapping implements IContactGroupMapping {
    contactId!: number;
    contact!: Contact | undefined;
    contactGroupId!: number;
    contactGroup!: ContactGroup | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IContactGroupMapping) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.contact = data["contact"] ? Contact.fromJS(data["contact"]) : <any>undefined;
            this.contactGroupId = data["contactGroupId"];
            this.contactGroup = data["contactGroup"] ? ContactGroup.fromJS(data["contactGroup"]) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ContactGroupMapping {
        data = typeof data === 'object' ? data : {};
        let result = new ContactGroupMapping();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactGroupId"] = this.contactGroupId;
        data["contactGroup"] = this.contactGroup ? this.contactGroup.toJSON() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IContactGroupMapping {
    contactId: number;
    contact: Contact | undefined;
    contactGroupId: number;
    contactGroup: ContactGroup | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ContactGroupSetting implements IContactGroupSetting {
    contactGroupId!: number;
    contactGroup!: ContactGroup | undefined;
    code!: string | undefined;
    value!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IContactGroupSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactGroupId = data["contactGroupId"];
            this.contactGroup = data["contactGroup"] ? ContactGroup.fromJS(data["contactGroup"]) : <any>undefined;
            this.code = data["code"];
            this.value = data["value"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ContactGroupSetting {
        data = typeof data === 'object' ? data : {};
        let result = new ContactGroupSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactGroupId"] = this.contactGroupId;
        data["contactGroup"] = this.contactGroup ? this.contactGroup.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["value"] = this.value;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IContactGroupSetting {
    contactGroupId: number;
    contactGroup: ContactGroup | undefined;
    code: string | undefined;
    value: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class FeatureSetting implements IFeatureSetting {
    tenantId!: number | undefined;
    name!: string;
    value!: string;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IFeatureSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.value = data["value"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): FeatureSetting {
        data = typeof data === 'object' ? data : {};
        let result = new FeatureSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["value"] = this.value;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IFeatureSetting {
    tenantId: number | undefined;
    name: string;
    value: string;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class TenantFeatureSetting implements ITenantFeatureSetting {
    tenantId!: number | undefined;
    name!: string;
    value!: string;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ITenantFeatureSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.value = data["value"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TenantFeatureSetting {
        data = typeof data === 'object' ? data : {};
        let result = new TenantFeatureSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["value"] = this.value;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITenantFeatureSetting {
    tenantId: number | undefined;
    name: string;
    value: string;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class EditionFeatureSetting implements IEditionFeatureSetting {
    edition!: Edition | undefined;
    editionId!: number;
    tenantId!: number | undefined;
    name!: string;
    value!: string;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IEditionFeatureSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.edition = data["edition"] ? Edition.fromJS(data["edition"]) : <any>undefined;
            this.editionId = data["editionId"];
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.value = data["value"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EditionFeatureSetting {
        data = typeof data === 'object' ? data : {};
        let result = new EditionFeatureSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["edition"] = this.edition ? this.edition.toJSON() : <any>undefined;
        data["editionId"] = this.editionId;
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["value"] = this.value;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEditionFeatureSetting {
    edition: Edition | undefined;
    editionId: number;
    tenantId: number | undefined;
    name: string;
    value: string;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export enum BackgroundJobPriority {
    Low = 5,
    BelowNormal = 10,
    Normal = 15,
    AboveNormal = 20,
    High = 25,
}

export class BackgroundJobInfo implements IBackgroundJobInfo {
    jobType!: string;
    jobArgs!: string;
    tryCount!: number;
    nextTryTime!: moment.Moment;
    lastTryTime!: moment.Moment | undefined;
    isAbandoned!: boolean;
    priority!: BackgroundJobPriority;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IBackgroundJobInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.jobType = data["jobType"];
            this.jobArgs = data["jobArgs"];
            this.tryCount = data["tryCount"];
            this.nextTryTime = data["nextTryTime"] ? moment(data["nextTryTime"].toString()) : <any>undefined;
            this.lastTryTime = data["lastTryTime"] ? moment(data["lastTryTime"].toString()) : <any>undefined;
            this.isAbandoned = data["isAbandoned"];
            this.priority = data["priority"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): BackgroundJobInfo {
        data = typeof data === 'object' ? data : {};
        let result = new BackgroundJobInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["jobType"] = this.jobType;
        data["jobArgs"] = this.jobArgs;
        data["tryCount"] = this.tryCount;
        data["nextTryTime"] = this.nextTryTime ? this.nextTryTime.toISOString() : <any>undefined;
        data["lastTryTime"] = this.lastTryTime ? this.lastTryTime.toISOString() : <any>undefined;
        data["isAbandoned"] = this.isAbandoned;
        data["priority"] = this.priority;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IBackgroundJobInfo {
    jobType: string;
    jobArgs: string;
    tryCount: number;
    nextTryTime: moment.Moment;
    lastTryTime: moment.Moment | undefined;
    isAbandoned: boolean;
    priority: BackgroundJobPriority;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class UserAccount implements IUserAccount {
    tenantId!: number | undefined;
    userId!: number;
    userLinkId!: number | undefined;
    userName!: string | undefined;
    emailAddress!: string | undefined;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IUserAccount) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.userLinkId = data["userLinkId"];
            this.userName = data["userName"];
            this.emailAddress = data["emailAddress"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserAccount {
        data = typeof data === 'object' ? data : {};
        let result = new UserAccount();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["userLinkId"] = this.userLinkId;
        data["userName"] = this.userName;
        data["emailAddress"] = this.emailAddress;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserAccount {
    tenantId: number | undefined;
    userId: number;
    userLinkId: number | undefined;
    userName: string | undefined;
    emailAddress: string | undefined;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class NotificationInfo implements INotificationInfo {
    notificationName!: string;
    data!: string | undefined;
    dataTypeName!: string | undefined;
    entityTypeName!: string | undefined;
    entityTypeAssemblyQualifiedName!: string | undefined;
    entityId!: string | undefined;
    severity!: NotificationSeverity;
    userIds!: string | undefined;
    excludedUserIds!: string | undefined;
    tenantIds!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: string;

    constructor(data?: INotificationInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.notificationName = data["notificationName"];
            this.data = data["data"];
            this.dataTypeName = data["dataTypeName"];
            this.entityTypeName = data["entityTypeName"];
            this.entityTypeAssemblyQualifiedName = data["entityTypeAssemblyQualifiedName"];
            this.entityId = data["entityId"];
            this.severity = data["severity"];
            this.userIds = data["userIds"];
            this.excludedUserIds = data["excludedUserIds"];
            this.tenantIds = data["tenantIds"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): NotificationInfo {
        data = typeof data === 'object' ? data : {};
        let result = new NotificationInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["notificationName"] = this.notificationName;
        data["data"] = this.data;
        data["dataTypeName"] = this.dataTypeName;
        data["entityTypeName"] = this.entityTypeName;
        data["entityTypeAssemblyQualifiedName"] = this.entityTypeAssemblyQualifiedName;
        data["entityId"] = this.entityId;
        data["severity"] = this.severity;
        data["userIds"] = this.userIds;
        data["excludedUserIds"] = this.excludedUserIds;
        data["tenantIds"] = this.tenantIds;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface INotificationInfo {
    notificationName: string;
    data: string | undefined;
    dataTypeName: string | undefined;
    entityTypeName: string | undefined;
    entityTypeAssemblyQualifiedName: string | undefined;
    entityId: string | undefined;
    severity: NotificationSeverity;
    userIds: string | undefined;
    excludedUserIds: string | undefined;
    tenantIds: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: string;
}

export enum AbpLoginResultType {
    Success = 1,
    InvalidUserNameOrEmailAddress = 2,
    InvalidPassword = 3,
    UserIsNotActive = 4,
    InvalidTenancyName = 5,
    TenantIsNotActive = 6,
    UserEmailIsNotConfirmed = 7,
    UnknownExternalLogin = 8,
    LockedOut = 9,
    UserPhoneNumberIsNotConfirmed = 10,
}

export class UserLoginAttempt implements IUserLoginAttempt {
    tenantId!: number | undefined;
    tenancyName!: string | undefined;
    userId!: number | undefined;
    userNameOrEmailAddress!: string | undefined;
    clientIpAddress!: string | undefined;
    clientName!: string | undefined;
    browserInfo!: string | undefined;
    result!: AbpLoginResultType;
    creationTime!: moment.Moment;
    id!: number;

    constructor(data?: IUserLoginAttempt) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenancyName = data["tenancyName"];
            this.userId = data["userId"];
            this.userNameOrEmailAddress = data["userNameOrEmailAddress"];
            this.clientIpAddress = data["clientIpAddress"];
            this.clientName = data["clientName"];
            this.browserInfo = data["browserInfo"];
            this.result = data["result"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserLoginAttempt {
        data = typeof data === 'object' ? data : {};
        let result = new UserLoginAttempt();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenancyName"] = this.tenancyName;
        data["userId"] = this.userId;
        data["userNameOrEmailAddress"] = this.userNameOrEmailAddress;
        data["clientIpAddress"] = this.clientIpAddress;
        data["clientName"] = this.clientName;
        data["browserInfo"] = this.browserInfo;
        data["result"] = this.result;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserLoginAttempt {
    tenantId: number | undefined;
    tenancyName: string | undefined;
    userId: number | undefined;
    userNameOrEmailAddress: string | undefined;
    clientIpAddress: string | undefined;
    clientName: string | undefined;
    browserInfo: string | undefined;
    result: AbpLoginResultType;
    creationTime: moment.Moment;
    id: number;
}

export class PermissionSetting implements IPermissionSetting {
    tenantId!: number | undefined;
    name!: string;
    isGranted!: boolean;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IPermissionSetting) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.isGranted = data["isGranted"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PermissionSetting {
        data = typeof data === 'object' ? data : {};
        let result = new PermissionSetting();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["isGranted"] = this.isGranted;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPermissionSetting {
    tenantId: number | undefined;
    name: string;
    isGranted: boolean;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class AuditLog implements IAuditLog {
    tenantId!: number | undefined;
    userId!: number | undefined;
    serviceName!: string | undefined;
    methodName!: string | undefined;
    parameters!: string | undefined;
    returnValue!: string | undefined;
    executionTime!: moment.Moment;
    executionDuration!: number;
    clientIpAddress!: string | undefined;
    clientName!: string | undefined;
    browserInfo!: string | undefined;
    exception!: string | undefined;
    impersonatorUserId!: number | undefined;
    impersonatorTenantId!: number | undefined;
    customData!: string | undefined;
    id!: number;

    constructor(data?: IAuditLog) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.serviceName = data["serviceName"];
            this.methodName = data["methodName"];
            this.parameters = data["parameters"];
            this.returnValue = data["returnValue"];
            this.executionTime = data["executionTime"] ? moment(data["executionTime"].toString()) : <any>undefined;
            this.executionDuration = data["executionDuration"];
            this.clientIpAddress = data["clientIpAddress"];
            this.clientName = data["clientName"];
            this.browserInfo = data["browserInfo"];
            this.exception = data["exception"];
            this.impersonatorUserId = data["impersonatorUserId"];
            this.impersonatorTenantId = data["impersonatorTenantId"];
            this.customData = data["customData"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): AuditLog {
        data = typeof data === 'object' ? data : {};
        let result = new AuditLog();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["serviceName"] = this.serviceName;
        data["methodName"] = this.methodName;
        data["parameters"] = this.parameters;
        data["returnValue"] = this.returnValue;
        data["executionTime"] = this.executionTime ? this.executionTime.toISOString() : <any>undefined;
        data["executionDuration"] = this.executionDuration;
        data["clientIpAddress"] = this.clientIpAddress;
        data["clientName"] = this.clientName;
        data["browserInfo"] = this.browserInfo;
        data["exception"] = this.exception;
        data["impersonatorUserId"] = this.impersonatorUserId;
        data["impersonatorTenantId"] = this.impersonatorTenantId;
        data["customData"] = this.customData;
        data["id"] = this.id;
        return data; 
    }
}

export interface IAuditLog {
    tenantId: number | undefined;
    userId: number | undefined;
    serviceName: string | undefined;
    methodName: string | undefined;
    parameters: string | undefined;
    returnValue: string | undefined;
    executionTime: moment.Moment;
    executionDuration: number;
    clientIpAddress: string | undefined;
    clientName: string | undefined;
    browserInfo: string | undefined;
    exception: string | undefined;
    impersonatorUserId: number | undefined;
    impersonatorTenantId: number | undefined;
    customData: string | undefined;
    id: number;
}

export class ApplicationLanguage implements IApplicationLanguage {
    tenantId!: number | undefined;
    name!: string;
    displayName!: string;
    icon!: string | undefined;
    isDisabled!: boolean;
    isDeleted!: boolean;
    deleterUserId!: number | undefined;
    deletionTime!: moment.Moment | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IApplicationLanguage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.icon = data["icon"];
            this.isDisabled = data["isDisabled"];
            this.isDeleted = data["isDeleted"];
            this.deleterUserId = data["deleterUserId"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ApplicationLanguage {
        data = typeof data === 'object' ? data : {};
        let result = new ApplicationLanguage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["icon"] = this.icon;
        data["isDisabled"] = this.isDisabled;
        data["isDeleted"] = this.isDeleted;
        data["deleterUserId"] = this.deleterUserId;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IApplicationLanguage {
    tenantId: number | undefined;
    name: string;
    displayName: string;
    icon: string | undefined;
    isDisabled: boolean;
    isDeleted: boolean;
    deleterUserId: number | undefined;
    deletionTime: moment.Moment | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ApplicationLanguageText implements IApplicationLanguageText {
    tenantId!: number | undefined;
    languageName!: string;
    source!: string;
    key!: string;
    value!: string;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IApplicationLanguageText) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.languageName = data["languageName"];
            this.source = data["source"];
            this.key = data["key"];
            this.value = data["value"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): ApplicationLanguageText {
        data = typeof data === 'object' ? data : {};
        let result = new ApplicationLanguageText();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["languageName"] = this.languageName;
        data["source"] = this.source;
        data["key"] = this.key;
        data["value"] = this.value;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IApplicationLanguageText {
    tenantId: number | undefined;
    languageName: string;
    source: string;
    key: string;
    value: string;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class OrganizationUnitRole implements IOrganizationUnitRole {
    tenantId!: number | undefined;
    roleId!: number;
    organizationUnitId!: number;
    isDeleted!: boolean;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: IOrganizationUnitRole) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.roleId = data["roleId"];
            this.organizationUnitId = data["organizationUnitId"];
            this.isDeleted = data["isDeleted"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): OrganizationUnitRole {
        data = typeof data === 'object' ? data : {};
        let result = new OrganizationUnitRole();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["roleId"] = this.roleId;
        data["organizationUnitId"] = this.organizationUnitId;
        data["isDeleted"] = this.isDeleted;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IOrganizationUnitRole {
    tenantId: number | undefined;
    roleId: number;
    organizationUnitId: number;
    isDeleted: boolean;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class TenantNotificationInfo implements ITenantNotificationInfo {
    tenantId!: number | undefined;
    notificationName!: string;
    data!: string | undefined;
    dataTypeName!: string | undefined;
    entityTypeName!: string | undefined;
    entityTypeAssemblyQualifiedName!: string | undefined;
    entityId!: string | undefined;
    severity!: NotificationSeverity;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: string;

    constructor(data?: ITenantNotificationInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.notificationName = data["notificationName"];
            this.data = data["data"];
            this.dataTypeName = data["dataTypeName"];
            this.entityTypeName = data["entityTypeName"];
            this.entityTypeAssemblyQualifiedName = data["entityTypeAssemblyQualifiedName"];
            this.entityId = data["entityId"];
            this.severity = data["severity"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TenantNotificationInfo {
        data = typeof data === 'object' ? data : {};
        let result = new TenantNotificationInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["notificationName"] = this.notificationName;
        data["data"] = this.data;
        data["dataTypeName"] = this.dataTypeName;
        data["entityTypeName"] = this.entityTypeName;
        data["entityTypeAssemblyQualifiedName"] = this.entityTypeAssemblyQualifiedName;
        data["entityId"] = this.entityId;
        data["severity"] = this.severity;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITenantNotificationInfo {
    tenantId: number | undefined;
    notificationName: string;
    data: string | undefined;
    dataTypeName: string | undefined;
    entityTypeName: string | undefined;
    entityTypeAssemblyQualifiedName: string | undefined;
    entityId: string | undefined;
    severity: NotificationSeverity;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: string;
}

export class UserNotificationInfo implements IUserNotificationInfo {
    tenantId!: number | undefined;
    userId!: number;
    tenantNotificationId!: string;
    state!: UserNotificationState;
    creationTime!: moment.Moment;
    id!: string;

    constructor(data?: IUserNotificationInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.tenantNotificationId = data["tenantNotificationId"];
            this.state = data["state"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserNotificationInfo {
        data = typeof data === 'object' ? data : {};
        let result = new UserNotificationInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["tenantNotificationId"] = this.tenantNotificationId;
        data["state"] = this.state;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserNotificationInfo {
    tenantId: number | undefined;
    userId: number;
    tenantNotificationId: string;
    state: UserNotificationState;
    creationTime: moment.Moment;
    id: string;
}

export class NotificationSubscriptionInfo implements INotificationSubscriptionInfo {
    tenantId!: number | undefined;
    userId!: number;
    notificationName!: string | undefined;
    entityTypeName!: string | undefined;
    entityTypeAssemblyQualifiedName!: string | undefined;
    entityId!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: string;

    constructor(data?: INotificationSubscriptionInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            this.notificationName = data["notificationName"];
            this.entityTypeName = data["entityTypeName"];
            this.entityTypeAssemblyQualifiedName = data["entityTypeAssemblyQualifiedName"];
            this.entityId = data["entityId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): NotificationSubscriptionInfo {
        data = typeof data === 'object' ? data : {};
        let result = new NotificationSubscriptionInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        data["notificationName"] = this.notificationName;
        data["entityTypeName"] = this.entityTypeName;
        data["entityTypeAssemblyQualifiedName"] = this.entityTypeAssemblyQualifiedName;
        data["entityId"] = this.entityId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface INotificationSubscriptionInfo {
    tenantId: number | undefined;
    userId: number;
    notificationName: string | undefined;
    entityTypeName: string | undefined;
    entityTypeAssemblyQualifiedName: string | undefined;
    entityId: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: string;
}

export class EntityPropertyChange implements IEntityPropertyChange {
    entityChangeId!: number;
    newValue!: string | undefined;
    originalValue!: string | undefined;
    propertyName!: string | undefined;
    propertyTypeFullName!: string | undefined;
    tenantId!: number | undefined;
    id!: number;

    constructor(data?: IEntityPropertyChange) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.entityChangeId = data["entityChangeId"];
            this.newValue = data["newValue"];
            this.originalValue = data["originalValue"];
            this.propertyName = data["propertyName"];
            this.propertyTypeFullName = data["propertyTypeFullName"];
            this.tenantId = data["tenantId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EntityPropertyChange {
        data = typeof data === 'object' ? data : {};
        let result = new EntityPropertyChange();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["entityChangeId"] = this.entityChangeId;
        data["newValue"] = this.newValue;
        data["originalValue"] = this.originalValue;
        data["propertyName"] = this.propertyName;
        data["propertyTypeFullName"] = this.propertyTypeFullName;
        data["tenantId"] = this.tenantId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEntityPropertyChange {
    entityChangeId: number;
    newValue: string | undefined;
    originalValue: string | undefined;
    propertyName: string | undefined;
    propertyTypeFullName: string | undefined;
    tenantId: number | undefined;
    id: number;
}

export class EntityChange implements IEntityChange {
    changeTime!: moment.Moment;
    changeType!: EntityChangeType;
    entityChangeSetId!: number;
    entityId!: string | undefined;
    entityTypeFullName!: string | undefined;
    tenantId!: number | undefined;
    propertyChanges!: EntityPropertyChange[] | undefined;
    entityEntry!: any | undefined;
    id!: number;

    constructor(data?: IEntityChange) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.changeTime = data["changeTime"] ? moment(data["changeTime"].toString()) : <any>undefined;
            this.changeType = data["changeType"];
            this.entityChangeSetId = data["entityChangeSetId"];
            this.entityId = data["entityId"];
            this.entityTypeFullName = data["entityTypeFullName"];
            this.tenantId = data["tenantId"];
            if (Array.isArray(data["propertyChanges"])) {
                this.propertyChanges = [] as any;
                for (let item of data["propertyChanges"])
                    this.propertyChanges!.push(EntityPropertyChange.fromJS(item));
            }
            this.entityEntry = data["entityEntry"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EntityChange {
        data = typeof data === 'object' ? data : {};
        let result = new EntityChange();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["changeTime"] = this.changeTime ? this.changeTime.toISOString() : <any>undefined;
        data["changeType"] = this.changeType;
        data["entityChangeSetId"] = this.entityChangeSetId;
        data["entityId"] = this.entityId;
        data["entityTypeFullName"] = this.entityTypeFullName;
        data["tenantId"] = this.tenantId;
        if (Array.isArray(this.propertyChanges)) {
            data["propertyChanges"] = [];
            for (let item of this.propertyChanges)
                data["propertyChanges"].push(item.toJSON());
        }
        data["entityEntry"] = this.entityEntry;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEntityChange {
    changeTime: moment.Moment;
    changeType: EntityChangeType;
    entityChangeSetId: number;
    entityId: string | undefined;
    entityTypeFullName: string | undefined;
    tenantId: number | undefined;
    propertyChanges: EntityPropertyChange[] | undefined;
    entityEntry: any | undefined;
    id: number;
}

export class EntityChangeSet implements IEntityChangeSet {
    browserInfo!: string | undefined;
    clientIpAddress!: string | undefined;
    clientName!: string | undefined;
    creationTime!: moment.Moment;
    extensionData!: string | undefined;
    impersonatorTenantId!: number | undefined;
    impersonatorUserId!: number | undefined;
    reason!: string | undefined;
    tenantId!: number | undefined;
    userId!: number | undefined;
    entityChanges!: EntityChange[] | undefined;
    id!: number;

    constructor(data?: IEntityChangeSet) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.browserInfo = data["browserInfo"];
            this.clientIpAddress = data["clientIpAddress"];
            this.clientName = data["clientName"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.extensionData = data["extensionData"];
            this.impersonatorTenantId = data["impersonatorTenantId"];
            this.impersonatorUserId = data["impersonatorUserId"];
            this.reason = data["reason"];
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
            if (Array.isArray(data["entityChanges"])) {
                this.entityChanges = [] as any;
                for (let item of data["entityChanges"])
                    this.entityChanges!.push(EntityChange.fromJS(item));
            }
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EntityChangeSet {
        data = typeof data === 'object' ? data : {};
        let result = new EntityChangeSet();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["browserInfo"] = this.browserInfo;
        data["clientIpAddress"] = this.clientIpAddress;
        data["clientName"] = this.clientName;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["extensionData"] = this.extensionData;
        data["impersonatorTenantId"] = this.impersonatorTenantId;
        data["impersonatorUserId"] = this.impersonatorUserId;
        data["reason"] = this.reason;
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        if (Array.isArray(this.entityChanges)) {
            data["entityChanges"] = [];
            for (let item of this.entityChanges)
                data["entityChanges"].push(item.toJSON());
        }
        data["id"] = this.id;
        return data; 
    }
}

export interface IEntityChangeSet {
    browserInfo: string | undefined;
    clientIpAddress: string | undefined;
    clientName: string | undefined;
    creationTime: moment.Moment;
    extensionData: string | undefined;
    impersonatorTenantId: number | undefined;
    impersonatorUserId: number | undefined;
    reason: string | undefined;
    tenantId: number | undefined;
    userId: number | undefined;
    entityChanges: EntityChange[] | undefined;
    id: number;
}

export class WebhookEvent implements IWebhookEvent {
    webhookName!: string;
    data!: string | undefined;
    creationTime!: moment.Moment;
    tenantId!: number | undefined;
    isDeleted!: boolean;
    deletionTime!: moment.Moment | undefined;
    id!: string;

    constructor(data?: IWebhookEvent) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.webhookName = data["webhookName"];
            this.data = data["data"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.tenantId = data["tenantId"];
            this.isDeleted = data["isDeleted"];
            this.deletionTime = data["deletionTime"] ? moment(data["deletionTime"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): WebhookEvent {
        data = typeof data === 'object' ? data : {};
        let result = new WebhookEvent();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["webhookName"] = this.webhookName;
        data["data"] = this.data;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["tenantId"] = this.tenantId;
        data["isDeleted"] = this.isDeleted;
        data["deletionTime"] = this.deletionTime ? this.deletionTime.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IWebhookEvent {
    webhookName: string;
    data: string | undefined;
    creationTime: moment.Moment;
    tenantId: number | undefined;
    isDeleted: boolean;
    deletionTime: moment.Moment | undefined;
    id: string;
}

export class WebhookSubscriptionInfo implements IWebhookSubscriptionInfo {
    tenantId!: number | undefined;
    webhookUri!: string;
    secret!: string;
    isActive!: boolean;
    webhooks!: string | undefined;
    headers!: string | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: string;

    constructor(data?: IWebhookSubscriptionInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.webhookUri = data["webhookUri"];
            this.secret = data["secret"];
            this.isActive = data["isActive"];
            this.webhooks = data["webhooks"];
            this.headers = data["headers"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): WebhookSubscriptionInfo {
        data = typeof data === 'object' ? data : {};
        let result = new WebhookSubscriptionInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["webhookUri"] = this.webhookUri;
        data["secret"] = this.secret;
        data["isActive"] = this.isActive;
        data["webhooks"] = this.webhooks;
        data["headers"] = this.headers;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IWebhookSubscriptionInfo {
    tenantId: number | undefined;
    webhookUri: string;
    secret: string;
    isActive: boolean;
    webhooks: string | undefined;
    headers: string | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: string;
}

export enum HttpStatusCode {
    Continue = 100,
    SwitchingProtocols = 101,
    Processing = 102,
    EarlyHints = 103,
    OK = 200,
    Created = 201,
    Accepted = 202,
    NonAuthoritativeInformation = 203,
    NoContent = 204,
    ResetContent = 205,
    PartialContent = 206,
    MultiStatus = 207,
    AlreadyReported = 208,
    IMUsed = 226,
    MultipleChoices = 300,
    Ambiguous = 300,
    MovedPermanently = 301,
    Moved = 301,
    Found = 302,
    Redirect = 302,
    SeeOther = 303,
    RedirectMethod = 303,
    NotModified = 304,
    UseProxy = 305,
    Unused = 306,
    TemporaryRedirect = 307,
    RedirectKeepVerb = 307,
    PermanentRedirect = 308,
    BadRequest = 400,
    Unauthorized = 401,
    PaymentRequired = 402,
    Forbidden = 403,
    NotFound = 404,
    MethodNotAllowed = 405,
    NotAcceptable = 406,
    ProxyAuthenticationRequired = 407,
    RequestTimeout = 408,
    Conflict = 409,
    Gone = 410,
    LengthRequired = 411,
    PreconditionFailed = 412,
    RequestEntityTooLarge = 413,
    RequestUriTooLong = 414,
    UnsupportedMediaType = 415,
    RequestedRangeNotSatisfiable = 416,
    ExpectationFailed = 417,
    MisdirectedRequest = 421,
    UnprocessableEntity = 422,
    Locked = 423,
    FailedDependency = 424,
    UpgradeRequired = 426,
    PreconditionRequired = 428,
    TooManyRequests = 429,
    RequestHeaderFieldsTooLarge = 431,
    UnavailableForLegalReasons = 451,
    InternalServerError = 500,
    NotImplemented = 501,
    BadGateway = 502,
    ServiceUnavailable = 503,
    GatewayTimeout = 504,
    HttpVersionNotSupported = 505,
    VariantAlsoNegotiates = 506,
    InsufficientStorage = 507,
    LoopDetected = 508,
    NotExtended = 510,
    NetworkAuthenticationRequired = 511,
}

export class WebhookSendAttempt implements IWebhookSendAttempt {
    webhookEventId!: string;
    webhookSubscriptionId!: string;
    response!: string | undefined;
    responseStatusCode!: HttpStatusCode | undefined;
    creationTime!: moment.Moment;
    lastModificationTime!: moment.Moment | undefined;
    tenantId!: number | undefined;
    webhookEvent!: WebhookEvent | undefined;
    id!: string;

    constructor(data?: IWebhookSendAttempt) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.webhookEventId = data["webhookEventId"];
            this.webhookSubscriptionId = data["webhookSubscriptionId"];
            this.response = data["response"];
            this.responseStatusCode = data["responseStatusCode"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.tenantId = data["tenantId"];
            this.webhookEvent = data["webhookEvent"] ? WebhookEvent.fromJS(data["webhookEvent"]) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): WebhookSendAttempt {
        data = typeof data === 'object' ? data : {};
        let result = new WebhookSendAttempt();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["webhookEventId"] = this.webhookEventId;
        data["webhookSubscriptionId"] = this.webhookSubscriptionId;
        data["response"] = this.response;
        data["responseStatusCode"] = this.responseStatusCode;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["tenantId"] = this.tenantId;
        data["webhookEvent"] = this.webhookEvent ? this.webhookEvent.toJSON() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IWebhookSendAttempt {
    webhookEventId: string;
    webhookSubscriptionId: string;
    response: string | undefined;
    responseStatusCode: HttpStatusCode | undefined;
    creationTime: moment.Moment;
    lastModificationTime: moment.Moment | undefined;
    tenantId: number | undefined;
    webhookEvent: WebhookEvent | undefined;
    id: string;
}

export class IEntityHistoryHelper implements IIEntityHistoryHelper {

    constructor(data?: IIEntityHistoryHelper) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): IEntityHistoryHelper {
        data = typeof data === 'object' ? data : {};
        let result = new IEntityHistoryHelper();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IIEntityHistoryHelper {
}

export enum MultiTenancySides {
    Tenant = 1,
    Host = 2,
}

export class IAbpSession implements IIAbpSession {
    readonly userId!: number | undefined;
    readonly tenantId!: number | undefined;
    readonly multiTenancySide!: MultiTenancySides;
    readonly impersonatorUserId!: number | undefined;
    readonly impersonatorTenantId!: number | undefined;

    constructor(data?: IIAbpSession) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).userId = data["userId"];
            (<any>this).tenantId = data["tenantId"];
            (<any>this).multiTenancySide = data["multiTenancySide"];
            (<any>this).impersonatorUserId = data["impersonatorUserId"];
            (<any>this).impersonatorTenantId = data["impersonatorTenantId"];
        }
    }

    static fromJS(data: any): IAbpSession {
        data = typeof data === 'object' ? data : {};
        let result = new IAbpSession();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["tenantId"] = this.tenantId;
        data["multiTenancySide"] = this.multiTenancySide;
        data["impersonatorUserId"] = this.impersonatorUserId;
        data["impersonatorTenantId"] = this.impersonatorTenantId;
        return data; 
    }
}

export interface IIAbpSession {
    userId: number | undefined;
    tenantId: number | undefined;
    multiTenancySide: MultiTenancySides;
    impersonatorUserId: number | undefined;
    impersonatorTenantId: number | undefined;
}

export class IEntityChangeEventHelper implements IIEntityChangeEventHelper {

    constructor(data?: IIEntityChangeEventHelper) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): IEntityChangeEventHelper {
        data = typeof data === 'object' ? data : {};
        let result = new IEntityChangeEventHelper();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IIEntityChangeEventHelper {
}

export class ILogger implements IILogger {
    readonly isTraceEnabled!: boolean;
    readonly isDebugEnabled!: boolean;
    readonly isErrorEnabled!: boolean;
    readonly isFatalEnabled!: boolean;
    readonly isInfoEnabled!: boolean;
    readonly isWarnEnabled!: boolean;

    constructor(data?: IILogger) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).isTraceEnabled = data["isTraceEnabled"];
            (<any>this).isDebugEnabled = data["isDebugEnabled"];
            (<any>this).isErrorEnabled = data["isErrorEnabled"];
            (<any>this).isFatalEnabled = data["isFatalEnabled"];
            (<any>this).isInfoEnabled = data["isInfoEnabled"];
            (<any>this).isWarnEnabled = data["isWarnEnabled"];
        }
    }

    static fromJS(data: any): ILogger {
        data = typeof data === 'object' ? data : {};
        let result = new ILogger();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isTraceEnabled"] = this.isTraceEnabled;
        data["isDebugEnabled"] = this.isDebugEnabled;
        data["isErrorEnabled"] = this.isErrorEnabled;
        data["isFatalEnabled"] = this.isFatalEnabled;
        data["isInfoEnabled"] = this.isInfoEnabled;
        data["isWarnEnabled"] = this.isWarnEnabled;
        return data; 
    }
}

export interface IILogger {
    isTraceEnabled: boolean;
    isDebugEnabled: boolean;
    isErrorEnabled: boolean;
    isFatalEnabled: boolean;
    isInfoEnabled: boolean;
    isWarnEnabled: boolean;
}

export class IEventBus implements IIEventBus {

    constructor(data?: IIEventBus) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): IEventBus {
        data = typeof data === 'object' ? data : {};
        let result = new IEventBus();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IIEventBus {
}

export class IGuidGenerator implements IIGuidGenerator {

    constructor(data?: IIGuidGenerator) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): IGuidGenerator {
        data = typeof data === 'object' ? data : {};
        let result = new IGuidGenerator();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IIGuidGenerator {
}

export class IUnitOfWork implements IIUnitOfWork {
    readonly id!: string | undefined;
    outer!: IUnitOfWork | undefined;

    constructor(data?: IIUnitOfWork) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).id = data["id"];
            this.outer = data["outer"] ? IUnitOfWork.fromJS(data["outer"]) : <any>undefined;
        }
    }

    static fromJS(data: any): IUnitOfWork {
        data = typeof data === 'object' ? data : {};
        let result = new IUnitOfWork();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["outer"] = this.outer ? this.outer.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IIUnitOfWork {
    id: string | undefined;
    outer: IUnitOfWork | undefined;
}

export class ICurrentUnitOfWorkProvider implements IICurrentUnitOfWorkProvider {
    current!: IUnitOfWork | undefined;

    constructor(data?: IICurrentUnitOfWorkProvider) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.current = data["current"] ? IUnitOfWork.fromJS(data["current"]) : <any>undefined;
        }
    }

    static fromJS(data: any): ICurrentUnitOfWorkProvider {
        data = typeof data === 'object' ? data : {};
        let result = new ICurrentUnitOfWorkProvider();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["current"] = this.current ? this.current.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IICurrentUnitOfWorkProvider {
    current: IUnitOfWork | undefined;
}

export class IMultiTenancyConfig implements IIMultiTenancyConfig {
    isEnabled!: boolean;
    ignoreFeatureCheckForHostUsers!: boolean;
    readonly resolvers!: Type[] | undefined;
    tenantIdResolveKey!: string | undefined;

    constructor(data?: IIMultiTenancyConfig) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEnabled = data["isEnabled"];
            this.ignoreFeatureCheckForHostUsers = data["ignoreFeatureCheckForHostUsers"];
            if (Array.isArray(data["resolvers"])) {
                (<any>this).resolvers = [] as any;
                for (let item of data["resolvers"])
                    (<any>this).resolvers!.push(Type.fromJS(item));
            }
            this.tenantIdResolveKey = data["tenantIdResolveKey"];
        }
    }

    static fromJS(data: any): IMultiTenancyConfig {
        data = typeof data === 'object' ? data : {};
        let result = new IMultiTenancyConfig();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEnabled"] = this.isEnabled;
        data["ignoreFeatureCheckForHostUsers"] = this.ignoreFeatureCheckForHostUsers;
        if (Array.isArray(this.resolvers)) {
            data["resolvers"] = [];
            for (let item of this.resolvers)
                data["resolvers"].push(item.toJSON());
        }
        data["tenantIdResolveKey"] = this.tenantIdResolveKey;
        return data; 
    }
}

export interface IIMultiTenancyConfig {
    isEnabled: boolean;
    ignoreFeatureCheckForHostUsers: boolean;
    resolvers: Type[] | undefined;
    tenantIdResolveKey: string | undefined;
}

export class IDbContextTransaction implements IIDbContextTransaction {
    readonly transactionId!: string;

    constructor(data?: IIDbContextTransaction) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).transactionId = data["transactionId"];
        }
    }

    static fromJS(data: any): IDbContextTransaction {
        data = typeof data === 'object' ? data : {};
        let result = new IDbContextTransaction();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["transactionId"] = this.transactionId;
        return data; 
    }
}

export interface IIDbContextTransaction {
    transactionId: string;
}

export class DatabaseFacade implements IDatabaseFacade {
    readonly currentTransaction!: IDbContextTransaction | undefined;
    autoTransactionsEnabled!: boolean;
    readonly providerName!: string | undefined;

    constructor(data?: IDatabaseFacade) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).currentTransaction = data["currentTransaction"] ? IDbContextTransaction.fromJS(data["currentTransaction"]) : <any>undefined;
            this.autoTransactionsEnabled = data["autoTransactionsEnabled"];
            (<any>this).providerName = data["providerName"];
        }
    }

    static fromJS(data: any): DatabaseFacade {
        data = typeof data === 'object' ? data : {};
        let result = new DatabaseFacade();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["currentTransaction"] = this.currentTransaction ? this.currentTransaction.toJSON() : <any>undefined;
        data["autoTransactionsEnabled"] = this.autoTransactionsEnabled;
        data["providerName"] = this.providerName;
        return data; 
    }
}

export interface IDatabaseFacade {
    currentTransaction: IDbContextTransaction | undefined;
    autoTransactionsEnabled: boolean;
    providerName: string | undefined;
}

export enum QueryTrackingBehavior {
    TrackAll = 0,
    NoTracking = 1,
}

export enum CascadeTiming {
    Immediate = 0,
    OnSaveChanges = 1,
    Never = 2,
}

export class IModel implements IIModel {

    constructor(data?: IIModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
    }

    static fromJS(data: any): IModel {
        data = typeof data === 'object' ? data : {};
        let result = new IModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        return data; 
    }
}

export interface IIModel {
}

export class DbContextId implements IDbContextId {
    readonly instanceId!: string;
    readonly lease!: number;

    constructor(data?: IDbContextId) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).instanceId = data["instanceId"];
            (<any>this).lease = data["lease"];
        }
    }

    static fromJS(data: any): DbContextId {
        data = typeof data === 'object' ? data : {};
        let result = new DbContextId();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["instanceId"] = this.instanceId;
        data["lease"] = this.lease;
        return data; 
    }
}

export interface IDbContextId {
    instanceId: string;
    lease: number;
}

export class DbContext implements IDbContext {
    readonly database!: DatabaseFacade | undefined;
    readonly changeTracker!: ChangeTracker | undefined;
    readonly model!: IModel | undefined;
    readonly contextId!: DbContextId;

    constructor(data?: IDbContext) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).database = data["database"] ? DatabaseFacade.fromJS(data["database"]) : <any>undefined;
            (<any>this).changeTracker = data["changeTracker"] ? ChangeTracker.fromJS(data["changeTracker"]) : <any>undefined;
            (<any>this).model = data["model"] ? IModel.fromJS(data["model"]) : <any>undefined;
            (<any>this).contextId = data["contextId"] ? DbContextId.fromJS(data["contextId"]) : <any>undefined;
        }
    }

    static fromJS(data: any): DbContext {
        data = typeof data === 'object' ? data : {};
        let result = new DbContext();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["database"] = this.database ? this.database.toJSON() : <any>undefined;
        data["changeTracker"] = this.changeTracker ? this.changeTracker.toJSON() : <any>undefined;
        data["model"] = this.model ? this.model.toJSON() : <any>undefined;
        data["contextId"] = this.contextId ? this.contextId.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IDbContext {
    database: DatabaseFacade | undefined;
    changeTracker: ChangeTracker | undefined;
    model: IModel | undefined;
    contextId: DbContextId;
}

export class ChangeTracker implements IChangeTracker {
    autoDetectChangesEnabled!: boolean;
    lazyLoadingEnabled!: boolean;
    queryTrackingBehavior!: QueryTrackingBehavior;
    deleteOrphansTiming!: CascadeTiming;
    cascadeDeleteTiming!: CascadeTiming;
    readonly context!: DbContext | undefined;

    constructor(data?: IChangeTracker) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.autoDetectChangesEnabled = data["autoDetectChangesEnabled"];
            this.lazyLoadingEnabled = data["lazyLoadingEnabled"];
            this.queryTrackingBehavior = data["queryTrackingBehavior"];
            this.deleteOrphansTiming = data["deleteOrphansTiming"];
            this.cascadeDeleteTiming = data["cascadeDeleteTiming"];
            (<any>this).context = data["context"] ? DbContext.fromJS(data["context"]) : <any>undefined;
        }
    }

    static fromJS(data: any): ChangeTracker {
        data = typeof data === 'object' ? data : {};
        let result = new ChangeTracker();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["autoDetectChangesEnabled"] = this.autoDetectChangesEnabled;
        data["lazyLoadingEnabled"] = this.lazyLoadingEnabled;
        data["queryTrackingBehavior"] = this.queryTrackingBehavior;
        data["deleteOrphansTiming"] = this.deleteOrphansTiming;
        data["cascadeDeleteTiming"] = this.cascadeDeleteTiming;
        data["context"] = this.context ? this.context.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IChangeTracker {
    autoDetectChangesEnabled: boolean;
    lazyLoadingEnabled: boolean;
    queryTrackingBehavior: QueryTrackingBehavior;
    deleteOrphansTiming: CascadeTiming;
    cascadeDeleteTiming: CascadeTiming;
    context: DbContext | undefined;
}

export class SprintTekDbContext implements ISprintTekDbContext {
    routeTemplateOrderExtras!: RouteTemplateOrderExtra[] | undefined;
    recurringOrderSchedules!: RecurringOrderSchedule[] | undefined;
    orderLogs!: OrderLog[] | undefined;
    clientOrderLogs!: ClientOrderLog[] | undefined;
    clientConnections!: ClientConnection[] | undefined;
    clientDrivers!: ClientDriver[] | undefined;
    clientAccounts!: ClientAccount[] | undefined;
    orderStatusMappings!: OrderStatusMapping[] | undefined;
    routeGenerationSettings!: RouteGenerationSetting[] | undefined;
    routeHandOffScheduleDetailEtas!: RouteHandOffScheduleDetailEtas[] | undefined;
    contactPersons!: ContactPerson[] | undefined;
    contactBusinessHours!: ContactBusinessHour[] | undefined;
    routeHandOffDefinitionOrders!: RouteHandOffDefinitionOrder[] | undefined;
    dataRetentionLogs!: DataRetentionLog[] | undefined;
    dataRetentions!: DataRetention[] | undefined;
    routeGeneratorLogs!: RouteGeneratorLog[] | undefined;
    versions!: Version[] | undefined;
    ftpAccounts!: FtpAccount[] | undefined;
    userOrderTypes!: UserOrderType[] | undefined;
    orderSourceConnections!: OrderSourceConnection[] | undefined;
    orderSources!: OrderSource[] | undefined;
    vendors!: Vendor[] | undefined;
    incidentSources!: IncidentSource[] | undefined;
    importLogMessages!: ImportLogMessage[] | undefined;
    importLogs!: ImportLog[] | undefined;
    routeHandOffScheduleDetails!: RouteHandOffScheduleDetail[] | undefined;
    routeHandOffDefinitions!: RouteHandOffDefinition[] | undefined;
    supportCategoryTypes!: SupportCategoryTypes[] | undefined;
    supportTicketCategories!: SupportTicketCategory[] | undefined;
    routeDestinations!: RouteDestination[] | undefined;
    locationCalendarRoutes!: LocationCalendarRoute[] | undefined;
    locationHolidays!: LocationHoliday[] | undefined;
    holidays!: Holiday[] | undefined;
    driverIncidentTypes!: DriverIncidentType[] | undefined;
    employeeIncidents!: EmployeeIncident[] | undefined;
    employeeIncidentTypes!: EmployeeIncidentType[] | undefined;
    employees!: Employee[] | undefined;
    supportTicketNotificationRecipientses!: SupportTicketNotificationRecipients[] | undefined;
    supportTicketNotifications!: SupportTicketNotification[] | undefined;
    smsTemplates!: SmsTemplate[] | undefined;
    smsAccounts!: SmsAccount[] | undefined;
    organizationUnitOrderNotifications!: OrganizationUnitOrderNotification[] | undefined;
    orderNotifications!: OrderNotification[] | undefined;
    orderNotificationTemplates!: OrderNotificationTemplate[] | undefined;
    vehicleChecklists!: VehicleChecklist[] | undefined;
    vehicleTypes!: VehicleTypes[] | undefined;
    route4MeSettings!: Route4MeSetting[] | undefined;
    route4MeDataImporting!: Route4MeDataImport[] | undefined;
    backgroundProcesses!: BackgroundProcess[] | undefined;
    orderTypes!: OrderType[] | undefined;
    orderIncidents!: OrderIncident[] | undefined;
    incidentTypes!: IncidentType[] | undefined;
    incidentStatuses!: IncidentStatuses[] | undefined;
    incidentNote!: IncidentNote[] | undefined;
    incidentAttachment!: IncidentAttachment[] | undefined;
    importMaps!: ImportMap[] | undefined;
    importFields!: ImportField[] | undefined;
    importTables!: ImportTable[] | undefined;
    importMappings!: ImportMapping[] | undefined;
    exportMappings!: ExportMapping[] | undefined;
    packageOptions!: PackageOption[] | undefined;
    routeDefinitions!: RouteDefinition[] | undefined;
    orderStatuses!: OrderStatus[] | undefined;
    routeTypes!: RouteType[] | undefined;
    routeScheduleDetails!: RouteScheduleDetail[] | undefined;
    routeScheduleDetailEtas!: RouteScheduleDetailEtas[] | undefined;
    routeScheduleEtas!: RouteScheduleEta[] | undefined;
    routeSchedules!: RouteSchedule[] | undefined;
    routeStops!: RouteStop[] | undefined;
    clinics!: Clinic[] | undefined;
    binaryObjects!: BinaryObject[] | undefined;
    friendships!: Friendship[] | undefined;
    chatMessages!: ChatMessage[] | undefined;
    subscribableEditions!: SubscribableEdition[] | undefined;
    subscriptionPayments!: SubscriptionPayment[] | undefined;
    invoices!: Invoice[] | undefined;
    persistedGrants!: PersistedGrantEntity[] | undefined;
    notes!: Note[] | undefined;
    imageNotes!: ImageNote[] | undefined;
    images!: Image[] | undefined;
    timeSheets!: TimeSheet[] | undefined;
    reviews!: Review[] | undefined;
    employeeReviews!: EmployeeReview[] | undefined;
    postalCodeZones!: PostalCodeZone[] | undefined;
    routes!: Route[] | undefined;
    routeTemplates!: RouteTemplate[] | undefined;
    routeTemplateAddresses!: RouteTemplateAddress[] | undefined;
    routeTemplateSortingRules!: RouteTemplateSortingRule[] | undefined;
    routeTemplateTypes!: RouteTemplateType[] | undefined;
    routeTemplateWaypoints!: RouteTemplateWaypoint[] | undefined;
    routeTemplateZones!: RouteTemplateZone[] | undefined;
    sortingRules!: SortingRule[] | undefined;
    zones!: Zone[] | undefined;
    locations!: Location[] | undefined;
    proximities!: Proximity[] | undefined;
    timeZones!: TimeZone[] | undefined;
    userLocations!: UserLocation[] | undefined;
    zoneLocations!: ZoneLocation[] | undefined;
    vehicleLocations!: VehicleLocation[] | undefined;
    destinationDetails!: DestinationDetail[] | undefined;
    orders!: Order[] | undefined;
    orderPackages!: OrderPackage[] | undefined;
    orderStatus!: OrderStatus[] | undefined;
    orderStatusAttachments!: OrderStatusAttachment[] | undefined;
    orderStatusTypes!: OrderStatusType[] | undefined;
    orderTags!: OrderTag[] | undefined;
    tags!: Tag[] | undefined;
    tagTypes!: TagType[] | undefined;
    vehicles!: Vehicle[] | undefined;
    mileages!: Mileage[] | undefined;
    vehicleMileages!: VehicleMileage[] | undefined;
    fleets!: Fleet[] | undefined;
    fleetVehicles!: FleetVehicle[] | undefined;
    fleetUsers!: FleetUser[] | undefined;
    fleetRates!: FleetRate[] | undefined;
    incidents!: Incident[] | undefined;
    driverIncidents!: DriverIncident[] | undefined;
    incidentImages!: IncidentImage[] | undefined;
    reviewImages!: ReviewImage[] | undefined;
    packages!: Package[] | undefined;
    addresses!: Address[] | undefined;
    contacts!: Contact[] | undefined;
    phones!: Phone[] | undefined;
    addressTypes!: AddressType[] | undefined;
    emails!: Email[] | undefined;
    postalCodes!: PostalCode[] | undefined;
    geocodes!: Geocode[] | undefined;
    proximityCodes!: ProximityCode[] | undefined;
    vehicleLogs!: VehicleLog[] | undefined;
    mobileThemes!: MobileTheme[] | undefined;
    deliveryNotes!: DeliveryNote[] | undefined;
    companies!: Company[] | undefined;
    mobileClients!: MobileClient[] | undefined;
    orderExtras!: OrderExtra[] | undefined;
    geocodeRequestLogs!: GeocodeRequestLog[] | undefined;
    googleApiRequestsLogs!: GoogleApiRequestsLog[] | undefined;
    mobileAppVersions!: MobileAppVersion[] | undefined;
    orderStatusDescriptions!: OrderStatusDescription[] | undefined;
    blindCountLimits!: BlindCountLimit[] | undefined;
    blindCountErrors!: BlindCountError[] | undefined;
    orderPackageQuantityLogs!: OrderPackageQuantityLog[] | undefined;
    mobileClientMessages!: MobileClientMessage[] | undefined;
    mobileClientLogInCodes!: MobileClientLogInCode[] | undefined;
    supportTickets!: SupportTicket[] | undefined;
    supportTicketTypes!: SupportTicketType[] | undefined;
    supportTicketStatuses!: SupportTicketStatus[] | undefined;
    supportTicketAttachments!: SupportTicketAttachment[] | undefined;
    supportTicketNotes!: SupportTicketNote[] | undefined;
    supportTicketSettings!: SupportTicketSetting[] | undefined;
    routeVehicleChecks!: RouteVehicleCheck[] | undefined;
    reports!: Reports[] | undefined;
    reportLogs!: ReportLogs[] | undefined;
    dashboards!: Dashboards[] | undefined;
    secondaryConnections!: SecondaryConnections[] | undefined;
    preferences!: Preference[] | undefined;
    userPreferences!: UserPreference[] | undefined;
    clientPreferences!: ClientPreference[] | undefined;
    dataSources!: DataSource[] | undefined;
    dataSourceFiles!: DataSourceFiles[] | undefined;
    dataSourceFileOrders!: DataSourceFileOrders[] | undefined;
    drivers!: Drivers[] | undefined;
    driverRatings!: DriverRating[] | undefined;
    adjustmentTypes!: AdjustmentType[] | undefined;
    locationAdjustments!: LocationAdjustment[] | undefined;
    routeOptimizerRules!: RouteOptimizerRule[] | undefined;
    routeOptimizers!: RouteOptimizer[] | undefined;
    reportSchedules!: ReportSchedules[] | undefined;
    reportSchedulesRecipients!: ReportSchedulesRecipients[] | undefined;
    reportScheduleParameters!: ReportScheduleParameters[] | undefined;
    reportSchedulerFtpServers!: ReportSchedulerFtpServers[] | undefined;
    cachedRequestSettings!: CachedRequestSetting[] | undefined;
    textToSpeechSettings!: TextToSpeechSetting[] | undefined;
    userEvents!: UserEvent[] | undefined;
    routeNotificationRecipients!: RouteNotificationRecipient[] | undefined;
    orderStatusPhotos!: OrderStatusPhoto[] | undefined;
    photoContents!: PhotoContent[] | undefined;
    firebaseTokens!: FirebaseToken[] | undefined;
    firebaseNotificationRequests!: FirebaseNotificationRequest[] | undefined;
    containers!: Container[] | undefined;
    destinationContainers!: DestinationContainer[] | undefined;
    blindCountErrorPackages!: BlindCountErrorPackage[] | undefined;
    automatedTestAccounts!: AutomatedTestAccount[] | undefined;
    automatedTestAccountDataStates!: AutomatedTestAccountDataState[] | undefined;
    contactSettings!: ContactSetting[] | undefined;
    etaErrorCodes!: EtaErrorCode[] | undefined;
    orderSourceFiles!: OrderSourceFile[] | undefined;
    routeScheduleSettings!: RouteScheduleSetting[] | undefined;
    routeHandOffScheduleSettings!: RouteHandOffScheduleSetting[] | undefined;
    orderValidationCodes!: OrderValidationCode[] | undefined;
    mobileTenantCodes!: MobileTenantCode[] | undefined;
    automatedTestDispatchCommandParams!: AutomatedTestDispatchCommandParam[] | undefined;
    mobileClientCacheDatas!: MobileClientCacheData[] | undefined;
    mobileClientSentRequests!: MobileClientSentRequest[] | undefined;
    destinationBlindCountErrors!: DestinationBlindCountError[] | undefined;
    destinationBlindCountErrorContainers!: DestinationBlindCountErrorContainer[] | undefined;
    rotueScheduleDetailEtas!: RouteScheduleDetailEtas[] | undefined;
    mobileClientVersions!: MobileClientVersion[] | undefined;
    orderAttachmentCacheKeys!: OrderAttachmentCacheKey[] | undefined;
    rates!: Rates[] | undefined;
    rateRules!: RateRules[] | undefined;
    shippingRoleActions!: ShippingRoleAction[] | undefined;
    mobileClientWarnings!: MobileClientWarning[] | undefined;
    contactGroups!: ContactGroup[] | undefined;
    contactGroupMappings!: ContactGroupMapping[] | undefined;
    contactGroupSettings!: ContactGroupSetting[] | undefined;
    tenants!: Tenant[] | undefined;
    editions!: Edition[] | undefined;
    featureSettings!: FeatureSetting[] | undefined;
    tenantFeatureSettings!: TenantFeatureSetting[] | undefined;
    editionFeatureSettings!: EditionFeatureSetting[] | undefined;
    backgroundJobs!: BackgroundJobInfo[] | undefined;
    userAccounts!: UserAccount[] | undefined;
    notifications!: NotificationInfo[] | undefined;
    roles!: Role[] | undefined;
    users!: User[] | undefined;
    userLogins!: UserLogin[] | undefined;
    userLoginAttempts!: UserLoginAttempt[] | undefined;
    userRoles!: UserRole[] | undefined;
    userClaims!: UserClaim[] | undefined;
    userTokens!: UserToken[] | undefined;
    roleClaims!: RoleClaim[] | undefined;
    permissions!: PermissionSetting[] | undefined;
    rolePermissions!: RolePermissionSetting[] | undefined;
    userPermissions!: UserPermissionSetting[] | undefined;
    settings!: Setting[] | undefined;
    auditLogs!: AuditLog[] | undefined;
    languages!: ApplicationLanguage[] | undefined;
    languageTexts!: ApplicationLanguageText[] | undefined;
    organizationUnits!: OrganizationUnit[] | undefined;
    userOrganizationUnits!: UserOrganizationUnit[] | undefined;
    organizationUnitRoles!: OrganizationUnitRole[] | undefined;
    tenantNotifications!: TenantNotificationInfo[] | undefined;
    userNotifications!: UserNotificationInfo[] | undefined;
    notificationSubscriptions!: NotificationSubscriptionInfo[] | undefined;
    entityChanges!: EntityChange[] | undefined;
    entityChangeSets!: EntityChangeSet[] | undefined;
    entityPropertyChanges!: EntityPropertyChange[] | undefined;
    webhookEvents!: WebhookEvent[] | undefined;
    webhookSubscriptions!: WebhookSubscriptionInfo[] | undefined;
    webhookSendAttempts!: WebhookSendAttempt[] | undefined;
    entityHistoryHelper!: IEntityHistoryHelper | undefined;
    abpSession!: IAbpSession | undefined;
    entityChangeEventHelper!: IEntityChangeEventHelper | undefined;
    logger!: ILogger | undefined;
    eventBus!: IEventBus | undefined;
    guidGenerator!: IGuidGenerator | undefined;
    currentUnitOfWorkProvider!: ICurrentUnitOfWorkProvider | undefined;
    multiTenancyConfig!: IMultiTenancyConfig | undefined;
    suppressAutoSetTenantId!: boolean;
    readonly database!: DatabaseFacade | undefined;
    readonly changeTracker!: ChangeTracker | undefined;
    readonly model!: IModel | undefined;
    readonly contextId!: DbContextId;

    constructor(data?: ISprintTekDbContext) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["routeTemplateOrderExtras"])) {
                this.routeTemplateOrderExtras = [] as any;
                for (let item of data["routeTemplateOrderExtras"])
                    this.routeTemplateOrderExtras!.push(RouteTemplateOrderExtra.fromJS(item));
            }
            if (Array.isArray(data["recurringOrderSchedules"])) {
                this.recurringOrderSchedules = [] as any;
                for (let item of data["recurringOrderSchedules"])
                    this.recurringOrderSchedules!.push(RecurringOrderSchedule.fromJS(item));
            }
            if (Array.isArray(data["orderLogs"])) {
                this.orderLogs = [] as any;
                for (let item of data["orderLogs"])
                    this.orderLogs!.push(OrderLog.fromJS(item));
            }
            if (Array.isArray(data["clientOrderLogs"])) {
                this.clientOrderLogs = [] as any;
                for (let item of data["clientOrderLogs"])
                    this.clientOrderLogs!.push(ClientOrderLog.fromJS(item));
            }
            if (Array.isArray(data["clientConnections"])) {
                this.clientConnections = [] as any;
                for (let item of data["clientConnections"])
                    this.clientConnections!.push(ClientConnection.fromJS(item));
            }
            if (Array.isArray(data["clientDrivers"])) {
                this.clientDrivers = [] as any;
                for (let item of data["clientDrivers"])
                    this.clientDrivers!.push(ClientDriver.fromJS(item));
            }
            if (Array.isArray(data["clientAccounts"])) {
                this.clientAccounts = [] as any;
                for (let item of data["clientAccounts"])
                    this.clientAccounts!.push(ClientAccount.fromJS(item));
            }
            if (Array.isArray(data["orderStatusMappings"])) {
                this.orderStatusMappings = [] as any;
                for (let item of data["orderStatusMappings"])
                    this.orderStatusMappings!.push(OrderStatusMapping.fromJS(item));
            }
            if (Array.isArray(data["routeGenerationSettings"])) {
                this.routeGenerationSettings = [] as any;
                for (let item of data["routeGenerationSettings"])
                    this.routeGenerationSettings!.push(RouteGenerationSetting.fromJS(item));
            }
            if (Array.isArray(data["routeHandOffScheduleDetailEtas"])) {
                this.routeHandOffScheduleDetailEtas = [] as any;
                for (let item of data["routeHandOffScheduleDetailEtas"])
                    this.routeHandOffScheduleDetailEtas!.push(RouteHandOffScheduleDetailEtas.fromJS(item));
            }
            if (Array.isArray(data["contactPersons"])) {
                this.contactPersons = [] as any;
                for (let item of data["contactPersons"])
                    this.contactPersons!.push(ContactPerson.fromJS(item));
            }
            if (Array.isArray(data["contactBusinessHours"])) {
                this.contactBusinessHours = [] as any;
                for (let item of data["contactBusinessHours"])
                    this.contactBusinessHours!.push(ContactBusinessHour.fromJS(item));
            }
            if (Array.isArray(data["routeHandOffDefinitionOrders"])) {
                this.routeHandOffDefinitionOrders = [] as any;
                for (let item of data["routeHandOffDefinitionOrders"])
                    this.routeHandOffDefinitionOrders!.push(RouteHandOffDefinitionOrder.fromJS(item));
            }
            if (Array.isArray(data["dataRetentionLogs"])) {
                this.dataRetentionLogs = [] as any;
                for (let item of data["dataRetentionLogs"])
                    this.dataRetentionLogs!.push(DataRetentionLog.fromJS(item));
            }
            if (Array.isArray(data["dataRetentions"])) {
                this.dataRetentions = [] as any;
                for (let item of data["dataRetentions"])
                    this.dataRetentions!.push(DataRetention.fromJS(item));
            }
            if (Array.isArray(data["routeGeneratorLogs"])) {
                this.routeGeneratorLogs = [] as any;
                for (let item of data["routeGeneratorLogs"])
                    this.routeGeneratorLogs!.push(RouteGeneratorLog.fromJS(item));
            }
            if (Array.isArray(data["versions"])) {
                this.versions = [] as any;
                for (let item of data["versions"])
                    this.versions!.push(Version.fromJS(item));
            }
            if (Array.isArray(data["ftpAccounts"])) {
                this.ftpAccounts = [] as any;
                for (let item of data["ftpAccounts"])
                    this.ftpAccounts!.push(FtpAccount.fromJS(item));
            }
            if (Array.isArray(data["userOrderTypes"])) {
                this.userOrderTypes = [] as any;
                for (let item of data["userOrderTypes"])
                    this.userOrderTypes!.push(UserOrderType.fromJS(item));
            }
            if (Array.isArray(data["orderSourceConnections"])) {
                this.orderSourceConnections = [] as any;
                for (let item of data["orderSourceConnections"])
                    this.orderSourceConnections!.push(OrderSourceConnection.fromJS(item));
            }
            if (Array.isArray(data["orderSources"])) {
                this.orderSources = [] as any;
                for (let item of data["orderSources"])
                    this.orderSources!.push(OrderSource.fromJS(item));
            }
            if (Array.isArray(data["vendors"])) {
                this.vendors = [] as any;
                for (let item of data["vendors"])
                    this.vendors!.push(Vendor.fromJS(item));
            }
            if (Array.isArray(data["incidentSources"])) {
                this.incidentSources = [] as any;
                for (let item of data["incidentSources"])
                    this.incidentSources!.push(IncidentSource.fromJS(item));
            }
            if (Array.isArray(data["importLogMessages"])) {
                this.importLogMessages = [] as any;
                for (let item of data["importLogMessages"])
                    this.importLogMessages!.push(ImportLogMessage.fromJS(item));
            }
            if (Array.isArray(data["importLogs"])) {
                this.importLogs = [] as any;
                for (let item of data["importLogs"])
                    this.importLogs!.push(ImportLog.fromJS(item));
            }
            if (Array.isArray(data["routeHandOffScheduleDetails"])) {
                this.routeHandOffScheduleDetails = [] as any;
                for (let item of data["routeHandOffScheduleDetails"])
                    this.routeHandOffScheduleDetails!.push(RouteHandOffScheduleDetail.fromJS(item));
            }
            if (Array.isArray(data["routeHandOffDefinitions"])) {
                this.routeHandOffDefinitions = [] as any;
                for (let item of data["routeHandOffDefinitions"])
                    this.routeHandOffDefinitions!.push(RouteHandOffDefinition.fromJS(item));
            }
            if (Array.isArray(data["supportCategoryTypes"])) {
                this.supportCategoryTypes = [] as any;
                for (let item of data["supportCategoryTypes"])
                    this.supportCategoryTypes!.push(SupportCategoryTypes.fromJS(item));
            }
            if (Array.isArray(data["supportTicketCategories"])) {
                this.supportTicketCategories = [] as any;
                for (let item of data["supportTicketCategories"])
                    this.supportTicketCategories!.push(SupportTicketCategory.fromJS(item));
            }
            if (Array.isArray(data["routeDestinations"])) {
                this.routeDestinations = [] as any;
                for (let item of data["routeDestinations"])
                    this.routeDestinations!.push(RouteDestination.fromJS(item));
            }
            if (Array.isArray(data["locationCalendarRoutes"])) {
                this.locationCalendarRoutes = [] as any;
                for (let item of data["locationCalendarRoutes"])
                    this.locationCalendarRoutes!.push(LocationCalendarRoute.fromJS(item));
            }
            if (Array.isArray(data["locationHolidays"])) {
                this.locationHolidays = [] as any;
                for (let item of data["locationHolidays"])
                    this.locationHolidays!.push(LocationHoliday.fromJS(item));
            }
            if (Array.isArray(data["holidays"])) {
                this.holidays = [] as any;
                for (let item of data["holidays"])
                    this.holidays!.push(Holiday.fromJS(item));
            }
            if (Array.isArray(data["driverIncidentTypes"])) {
                this.driverIncidentTypes = [] as any;
                for (let item of data["driverIncidentTypes"])
                    this.driverIncidentTypes!.push(DriverIncidentType.fromJS(item));
            }
            if (Array.isArray(data["employeeIncidents"])) {
                this.employeeIncidents = [] as any;
                for (let item of data["employeeIncidents"])
                    this.employeeIncidents!.push(EmployeeIncident.fromJS(item));
            }
            if (Array.isArray(data["employeeIncidentTypes"])) {
                this.employeeIncidentTypes = [] as any;
                for (let item of data["employeeIncidentTypes"])
                    this.employeeIncidentTypes!.push(EmployeeIncidentType.fromJS(item));
            }
            if (Array.isArray(data["employees"])) {
                this.employees = [] as any;
                for (let item of data["employees"])
                    this.employees!.push(Employee.fromJS(item));
            }
            if (Array.isArray(data["supportTicketNotificationRecipientses"])) {
                this.supportTicketNotificationRecipientses = [] as any;
                for (let item of data["supportTicketNotificationRecipientses"])
                    this.supportTicketNotificationRecipientses!.push(SupportTicketNotificationRecipients.fromJS(item));
            }
            if (Array.isArray(data["supportTicketNotifications"])) {
                this.supportTicketNotifications = [] as any;
                for (let item of data["supportTicketNotifications"])
                    this.supportTicketNotifications!.push(SupportTicketNotification.fromJS(item));
            }
            if (Array.isArray(data["smsTemplates"])) {
                this.smsTemplates = [] as any;
                for (let item of data["smsTemplates"])
                    this.smsTemplates!.push(SmsTemplate.fromJS(item));
            }
            if (Array.isArray(data["smsAccounts"])) {
                this.smsAccounts = [] as any;
                for (let item of data["smsAccounts"])
                    this.smsAccounts!.push(SmsAccount.fromJS(item));
            }
            if (Array.isArray(data["organizationUnitOrderNotifications"])) {
                this.organizationUnitOrderNotifications = [] as any;
                for (let item of data["organizationUnitOrderNotifications"])
                    this.organizationUnitOrderNotifications!.push(OrganizationUnitOrderNotification.fromJS(item));
            }
            if (Array.isArray(data["orderNotifications"])) {
                this.orderNotifications = [] as any;
                for (let item of data["orderNotifications"])
                    this.orderNotifications!.push(OrderNotification.fromJS(item));
            }
            if (Array.isArray(data["orderNotificationTemplates"])) {
                this.orderNotificationTemplates = [] as any;
                for (let item of data["orderNotificationTemplates"])
                    this.orderNotificationTemplates!.push(OrderNotificationTemplate.fromJS(item));
            }
            if (Array.isArray(data["vehicleChecklists"])) {
                this.vehicleChecklists = [] as any;
                for (let item of data["vehicleChecklists"])
                    this.vehicleChecklists!.push(VehicleChecklist.fromJS(item));
            }
            if (Array.isArray(data["vehicleTypes"])) {
                this.vehicleTypes = [] as any;
                for (let item of data["vehicleTypes"])
                    this.vehicleTypes!.push(VehicleTypes.fromJS(item));
            }
            if (Array.isArray(data["route4MeSettings"])) {
                this.route4MeSettings = [] as any;
                for (let item of data["route4MeSettings"])
                    this.route4MeSettings!.push(Route4MeSetting.fromJS(item));
            }
            if (Array.isArray(data["route4MeDataImporting"])) {
                this.route4MeDataImporting = [] as any;
                for (let item of data["route4MeDataImporting"])
                    this.route4MeDataImporting!.push(Route4MeDataImport.fromJS(item));
            }
            if (Array.isArray(data["backgroundProcesses"])) {
                this.backgroundProcesses = [] as any;
                for (let item of data["backgroundProcesses"])
                    this.backgroundProcesses!.push(BackgroundProcess.fromJS(item));
            }
            if (Array.isArray(data["orderTypes"])) {
                this.orderTypes = [] as any;
                for (let item of data["orderTypes"])
                    this.orderTypes!.push(OrderType.fromJS(item));
            }
            if (Array.isArray(data["orderIncidents"])) {
                this.orderIncidents = [] as any;
                for (let item of data["orderIncidents"])
                    this.orderIncidents!.push(OrderIncident.fromJS(item));
            }
            if (Array.isArray(data["incidentTypes"])) {
                this.incidentTypes = [] as any;
                for (let item of data["incidentTypes"])
                    this.incidentTypes!.push(IncidentType.fromJS(item));
            }
            if (Array.isArray(data["incidentStatuses"])) {
                this.incidentStatuses = [] as any;
                for (let item of data["incidentStatuses"])
                    this.incidentStatuses!.push(IncidentStatuses.fromJS(item));
            }
            if (Array.isArray(data["incidentNote"])) {
                this.incidentNote = [] as any;
                for (let item of data["incidentNote"])
                    this.incidentNote!.push(IncidentNote.fromJS(item));
            }
            if (Array.isArray(data["incidentAttachment"])) {
                this.incidentAttachment = [] as any;
                for (let item of data["incidentAttachment"])
                    this.incidentAttachment!.push(IncidentAttachment.fromJS(item));
            }
            if (Array.isArray(data["importMaps"])) {
                this.importMaps = [] as any;
                for (let item of data["importMaps"])
                    this.importMaps!.push(ImportMap.fromJS(item));
            }
            if (Array.isArray(data["importFields"])) {
                this.importFields = [] as any;
                for (let item of data["importFields"])
                    this.importFields!.push(ImportField.fromJS(item));
            }
            if (Array.isArray(data["importTables"])) {
                this.importTables = [] as any;
                for (let item of data["importTables"])
                    this.importTables!.push(ImportTable.fromJS(item));
            }
            if (Array.isArray(data["importMappings"])) {
                this.importMappings = [] as any;
                for (let item of data["importMappings"])
                    this.importMappings!.push(ImportMapping.fromJS(item));
            }
            if (Array.isArray(data["exportMappings"])) {
                this.exportMappings = [] as any;
                for (let item of data["exportMappings"])
                    this.exportMappings!.push(ExportMapping.fromJS(item));
            }
            if (Array.isArray(data["packageOptions"])) {
                this.packageOptions = [] as any;
                for (let item of data["packageOptions"])
                    this.packageOptions!.push(PackageOption.fromJS(item));
            }
            if (Array.isArray(data["routeDefinitions"])) {
                this.routeDefinitions = [] as any;
                for (let item of data["routeDefinitions"])
                    this.routeDefinitions!.push(RouteDefinition.fromJS(item));
            }
            if (Array.isArray(data["orderStatuses"])) {
                this.orderStatuses = [] as any;
                for (let item of data["orderStatuses"])
                    this.orderStatuses!.push(OrderStatus.fromJS(item));
            }
            if (Array.isArray(data["routeTypes"])) {
                this.routeTypes = [] as any;
                for (let item of data["routeTypes"])
                    this.routeTypes!.push(RouteType.fromJS(item));
            }
            if (Array.isArray(data["routeScheduleDetails"])) {
                this.routeScheduleDetails = [] as any;
                for (let item of data["routeScheduleDetails"])
                    this.routeScheduleDetails!.push(RouteScheduleDetail.fromJS(item));
            }
            if (Array.isArray(data["routeScheduleDetailEtas"])) {
                this.routeScheduleDetailEtas = [] as any;
                for (let item of data["routeScheduleDetailEtas"])
                    this.routeScheduleDetailEtas!.push(RouteScheduleDetailEtas.fromJS(item));
            }
            if (Array.isArray(data["routeScheduleEtas"])) {
                this.routeScheduleEtas = [] as any;
                for (let item of data["routeScheduleEtas"])
                    this.routeScheduleEtas!.push(RouteScheduleEta.fromJS(item));
            }
            if (Array.isArray(data["routeSchedules"])) {
                this.routeSchedules = [] as any;
                for (let item of data["routeSchedules"])
                    this.routeSchedules!.push(RouteSchedule.fromJS(item));
            }
            if (Array.isArray(data["routeStops"])) {
                this.routeStops = [] as any;
                for (let item of data["routeStops"])
                    this.routeStops!.push(RouteStop.fromJS(item));
            }
            if (Array.isArray(data["clinics"])) {
                this.clinics = [] as any;
                for (let item of data["clinics"])
                    this.clinics!.push(Clinic.fromJS(item));
            }
            if (Array.isArray(data["binaryObjects"])) {
                this.binaryObjects = [] as any;
                for (let item of data["binaryObjects"])
                    this.binaryObjects!.push(BinaryObject.fromJS(item));
            }
            if (Array.isArray(data["friendships"])) {
                this.friendships = [] as any;
                for (let item of data["friendships"])
                    this.friendships!.push(Friendship.fromJS(item));
            }
            if (Array.isArray(data["chatMessages"])) {
                this.chatMessages = [] as any;
                for (let item of data["chatMessages"])
                    this.chatMessages!.push(ChatMessage.fromJS(item));
            }
            if (Array.isArray(data["subscribableEditions"])) {
                this.subscribableEditions = [] as any;
                for (let item of data["subscribableEditions"])
                    this.subscribableEditions!.push(SubscribableEdition.fromJS(item));
            }
            if (Array.isArray(data["subscriptionPayments"])) {
                this.subscriptionPayments = [] as any;
                for (let item of data["subscriptionPayments"])
                    this.subscriptionPayments!.push(SubscriptionPayment.fromJS(item));
            }
            if (Array.isArray(data["invoices"])) {
                this.invoices = [] as any;
                for (let item of data["invoices"])
                    this.invoices!.push(Invoice.fromJS(item));
            }
            if (Array.isArray(data["persistedGrants"])) {
                this.persistedGrants = [] as any;
                for (let item of data["persistedGrants"])
                    this.persistedGrants!.push(PersistedGrantEntity.fromJS(item));
            }
            if (Array.isArray(data["notes"])) {
                this.notes = [] as any;
                for (let item of data["notes"])
                    this.notes!.push(Note.fromJS(item));
            }
            if (Array.isArray(data["imageNotes"])) {
                this.imageNotes = [] as any;
                for (let item of data["imageNotes"])
                    this.imageNotes!.push(ImageNote.fromJS(item));
            }
            if (Array.isArray(data["images"])) {
                this.images = [] as any;
                for (let item of data["images"])
                    this.images!.push(Image.fromJS(item));
            }
            if (Array.isArray(data["timeSheets"])) {
                this.timeSheets = [] as any;
                for (let item of data["timeSheets"])
                    this.timeSheets!.push(TimeSheet.fromJS(item));
            }
            if (Array.isArray(data["reviews"])) {
                this.reviews = [] as any;
                for (let item of data["reviews"])
                    this.reviews!.push(Review.fromJS(item));
            }
            if (Array.isArray(data["employeeReviews"])) {
                this.employeeReviews = [] as any;
                for (let item of data["employeeReviews"])
                    this.employeeReviews!.push(EmployeeReview.fromJS(item));
            }
            if (Array.isArray(data["postalCodeZones"])) {
                this.postalCodeZones = [] as any;
                for (let item of data["postalCodeZones"])
                    this.postalCodeZones!.push(PostalCodeZone.fromJS(item));
            }
            if (Array.isArray(data["routes"])) {
                this.routes = [] as any;
                for (let item of data["routes"])
                    this.routes!.push(Route.fromJS(item));
            }
            if (Array.isArray(data["routeTemplates"])) {
                this.routeTemplates = [] as any;
                for (let item of data["routeTemplates"])
                    this.routeTemplates!.push(RouteTemplate.fromJS(item));
            }
            if (Array.isArray(data["routeTemplateAddresses"])) {
                this.routeTemplateAddresses = [] as any;
                for (let item of data["routeTemplateAddresses"])
                    this.routeTemplateAddresses!.push(RouteTemplateAddress.fromJS(item));
            }
            if (Array.isArray(data["routeTemplateSortingRules"])) {
                this.routeTemplateSortingRules = [] as any;
                for (let item of data["routeTemplateSortingRules"])
                    this.routeTemplateSortingRules!.push(RouteTemplateSortingRule.fromJS(item));
            }
            if (Array.isArray(data["routeTemplateTypes"])) {
                this.routeTemplateTypes = [] as any;
                for (let item of data["routeTemplateTypes"])
                    this.routeTemplateTypes!.push(RouteTemplateType.fromJS(item));
            }
            if (Array.isArray(data["routeTemplateWaypoints"])) {
                this.routeTemplateWaypoints = [] as any;
                for (let item of data["routeTemplateWaypoints"])
                    this.routeTemplateWaypoints!.push(RouteTemplateWaypoint.fromJS(item));
            }
            if (Array.isArray(data["routeTemplateZones"])) {
                this.routeTemplateZones = [] as any;
                for (let item of data["routeTemplateZones"])
                    this.routeTemplateZones!.push(RouteTemplateZone.fromJS(item));
            }
            if (Array.isArray(data["sortingRules"])) {
                this.sortingRules = [] as any;
                for (let item of data["sortingRules"])
                    this.sortingRules!.push(SortingRule.fromJS(item));
            }
            if (Array.isArray(data["zones"])) {
                this.zones = [] as any;
                for (let item of data["zones"])
                    this.zones!.push(Zone.fromJS(item));
            }
            if (Array.isArray(data["locations"])) {
                this.locations = [] as any;
                for (let item of data["locations"])
                    this.locations!.push(Location.fromJS(item));
            }
            if (Array.isArray(data["proximities"])) {
                this.proximities = [] as any;
                for (let item of data["proximities"])
                    this.proximities!.push(Proximity.fromJS(item));
            }
            if (Array.isArray(data["timeZones"])) {
                this.timeZones = [] as any;
                for (let item of data["timeZones"])
                    this.timeZones!.push(TimeZone.fromJS(item));
            }
            if (Array.isArray(data["userLocations"])) {
                this.userLocations = [] as any;
                for (let item of data["userLocations"])
                    this.userLocations!.push(UserLocation.fromJS(item));
            }
            if (Array.isArray(data["zoneLocations"])) {
                this.zoneLocations = [] as any;
                for (let item of data["zoneLocations"])
                    this.zoneLocations!.push(ZoneLocation.fromJS(item));
            }
            if (Array.isArray(data["vehicleLocations"])) {
                this.vehicleLocations = [] as any;
                for (let item of data["vehicleLocations"])
                    this.vehicleLocations!.push(VehicleLocation.fromJS(item));
            }
            if (Array.isArray(data["destinationDetails"])) {
                this.destinationDetails = [] as any;
                for (let item of data["destinationDetails"])
                    this.destinationDetails!.push(DestinationDetail.fromJS(item));
            }
            if (Array.isArray(data["orders"])) {
                this.orders = [] as any;
                for (let item of data["orders"])
                    this.orders!.push(Order.fromJS(item));
            }
            if (Array.isArray(data["orderPackages"])) {
                this.orderPackages = [] as any;
                for (let item of data["orderPackages"])
                    this.orderPackages!.push(OrderPackage.fromJS(item));
            }
            if (Array.isArray(data["orderStatus"])) {
                this.orderStatus = [] as any;
                for (let item of data["orderStatus"])
                    this.orderStatus!.push(OrderStatus.fromJS(item));
            }
            if (Array.isArray(data["orderStatusAttachments"])) {
                this.orderStatusAttachments = [] as any;
                for (let item of data["orderStatusAttachments"])
                    this.orderStatusAttachments!.push(OrderStatusAttachment.fromJS(item));
            }
            if (Array.isArray(data["orderStatusTypes"])) {
                this.orderStatusTypes = [] as any;
                for (let item of data["orderStatusTypes"])
                    this.orderStatusTypes!.push(OrderStatusType.fromJS(item));
            }
            if (Array.isArray(data["orderTags"])) {
                this.orderTags = [] as any;
                for (let item of data["orderTags"])
                    this.orderTags!.push(OrderTag.fromJS(item));
            }
            if (Array.isArray(data["tags"])) {
                this.tags = [] as any;
                for (let item of data["tags"])
                    this.tags!.push(Tag.fromJS(item));
            }
            if (Array.isArray(data["tagTypes"])) {
                this.tagTypes = [] as any;
                for (let item of data["tagTypes"])
                    this.tagTypes!.push(TagType.fromJS(item));
            }
            if (Array.isArray(data["vehicles"])) {
                this.vehicles = [] as any;
                for (let item of data["vehicles"])
                    this.vehicles!.push(Vehicle.fromJS(item));
            }
            if (Array.isArray(data["mileages"])) {
                this.mileages = [] as any;
                for (let item of data["mileages"])
                    this.mileages!.push(Mileage.fromJS(item));
            }
            if (Array.isArray(data["vehicleMileages"])) {
                this.vehicleMileages = [] as any;
                for (let item of data["vehicleMileages"])
                    this.vehicleMileages!.push(VehicleMileage.fromJS(item));
            }
            if (Array.isArray(data["fleets"])) {
                this.fleets = [] as any;
                for (let item of data["fleets"])
                    this.fleets!.push(Fleet.fromJS(item));
            }
            if (Array.isArray(data["fleetVehicles"])) {
                this.fleetVehicles = [] as any;
                for (let item of data["fleetVehicles"])
                    this.fleetVehicles!.push(FleetVehicle.fromJS(item));
            }
            if (Array.isArray(data["fleetUsers"])) {
                this.fleetUsers = [] as any;
                for (let item of data["fleetUsers"])
                    this.fleetUsers!.push(FleetUser.fromJS(item));
            }
            if (Array.isArray(data["fleetRates"])) {
                this.fleetRates = [] as any;
                for (let item of data["fleetRates"])
                    this.fleetRates!.push(FleetRate.fromJS(item));
            }
            if (Array.isArray(data["incidents"])) {
                this.incidents = [] as any;
                for (let item of data["incidents"])
                    this.incidents!.push(Incident.fromJS(item));
            }
            if (Array.isArray(data["driverIncidents"])) {
                this.driverIncidents = [] as any;
                for (let item of data["driverIncidents"])
                    this.driverIncidents!.push(DriverIncident.fromJS(item));
            }
            if (Array.isArray(data["incidentImages"])) {
                this.incidentImages = [] as any;
                for (let item of data["incidentImages"])
                    this.incidentImages!.push(IncidentImage.fromJS(item));
            }
            if (Array.isArray(data["reviewImages"])) {
                this.reviewImages = [] as any;
                for (let item of data["reviewImages"])
                    this.reviewImages!.push(ReviewImage.fromJS(item));
            }
            if (Array.isArray(data["packages"])) {
                this.packages = [] as any;
                for (let item of data["packages"])
                    this.packages!.push(Package.fromJS(item));
            }
            if (Array.isArray(data["addresses"])) {
                this.addresses = [] as any;
                for (let item of data["addresses"])
                    this.addresses!.push(Address.fromJS(item));
            }
            if (Array.isArray(data["contacts"])) {
                this.contacts = [] as any;
                for (let item of data["contacts"])
                    this.contacts!.push(Contact.fromJS(item));
            }
            if (Array.isArray(data["phones"])) {
                this.phones = [] as any;
                for (let item of data["phones"])
                    this.phones!.push(Phone.fromJS(item));
            }
            if (Array.isArray(data["addressTypes"])) {
                this.addressTypes = [] as any;
                for (let item of data["addressTypes"])
                    this.addressTypes!.push(AddressType.fromJS(item));
            }
            if (Array.isArray(data["emails"])) {
                this.emails = [] as any;
                for (let item of data["emails"])
                    this.emails!.push(Email.fromJS(item));
            }
            if (Array.isArray(data["postalCodes"])) {
                this.postalCodes = [] as any;
                for (let item of data["postalCodes"])
                    this.postalCodes!.push(PostalCode.fromJS(item));
            }
            if (Array.isArray(data["geocodes"])) {
                this.geocodes = [] as any;
                for (let item of data["geocodes"])
                    this.geocodes!.push(Geocode.fromJS(item));
            }
            if (Array.isArray(data["proximityCodes"])) {
                this.proximityCodes = [] as any;
                for (let item of data["proximityCodes"])
                    this.proximityCodes!.push(ProximityCode.fromJS(item));
            }
            if (Array.isArray(data["vehicleLogs"])) {
                this.vehicleLogs = [] as any;
                for (let item of data["vehicleLogs"])
                    this.vehicleLogs!.push(VehicleLog.fromJS(item));
            }
            if (Array.isArray(data["mobileThemes"])) {
                this.mobileThemes = [] as any;
                for (let item of data["mobileThemes"])
                    this.mobileThemes!.push(MobileTheme.fromJS(item));
            }
            if (Array.isArray(data["deliveryNotes"])) {
                this.deliveryNotes = [] as any;
                for (let item of data["deliveryNotes"])
                    this.deliveryNotes!.push(DeliveryNote.fromJS(item));
            }
            if (Array.isArray(data["companies"])) {
                this.companies = [] as any;
                for (let item of data["companies"])
                    this.companies!.push(Company.fromJS(item));
            }
            if (Array.isArray(data["mobileClients"])) {
                this.mobileClients = [] as any;
                for (let item of data["mobileClients"])
                    this.mobileClients!.push(MobileClient.fromJS(item));
            }
            if (Array.isArray(data["orderExtras"])) {
                this.orderExtras = [] as any;
                for (let item of data["orderExtras"])
                    this.orderExtras!.push(OrderExtra.fromJS(item));
            }
            if (Array.isArray(data["geocodeRequestLogs"])) {
                this.geocodeRequestLogs = [] as any;
                for (let item of data["geocodeRequestLogs"])
                    this.geocodeRequestLogs!.push(GeocodeRequestLog.fromJS(item));
            }
            if (Array.isArray(data["googleApiRequestsLogs"])) {
                this.googleApiRequestsLogs = [] as any;
                for (let item of data["googleApiRequestsLogs"])
                    this.googleApiRequestsLogs!.push(GoogleApiRequestsLog.fromJS(item));
            }
            if (Array.isArray(data["mobileAppVersions"])) {
                this.mobileAppVersions = [] as any;
                for (let item of data["mobileAppVersions"])
                    this.mobileAppVersions!.push(MobileAppVersion.fromJS(item));
            }
            if (Array.isArray(data["orderStatusDescriptions"])) {
                this.orderStatusDescriptions = [] as any;
                for (let item of data["orderStatusDescriptions"])
                    this.orderStatusDescriptions!.push(OrderStatusDescription.fromJS(item));
            }
            if (Array.isArray(data["blindCountLimits"])) {
                this.blindCountLimits = [] as any;
                for (let item of data["blindCountLimits"])
                    this.blindCountLimits!.push(BlindCountLimit.fromJS(item));
            }
            if (Array.isArray(data["blindCountErrors"])) {
                this.blindCountErrors = [] as any;
                for (let item of data["blindCountErrors"])
                    this.blindCountErrors!.push(BlindCountError.fromJS(item));
            }
            if (Array.isArray(data["orderPackageQuantityLogs"])) {
                this.orderPackageQuantityLogs = [] as any;
                for (let item of data["orderPackageQuantityLogs"])
                    this.orderPackageQuantityLogs!.push(OrderPackageQuantityLog.fromJS(item));
            }
            if (Array.isArray(data["mobileClientMessages"])) {
                this.mobileClientMessages = [] as any;
                for (let item of data["mobileClientMessages"])
                    this.mobileClientMessages!.push(MobileClientMessage.fromJS(item));
            }
            if (Array.isArray(data["mobileClientLogInCodes"])) {
                this.mobileClientLogInCodes = [] as any;
                for (let item of data["mobileClientLogInCodes"])
                    this.mobileClientLogInCodes!.push(MobileClientLogInCode.fromJS(item));
            }
            if (Array.isArray(data["supportTickets"])) {
                this.supportTickets = [] as any;
                for (let item of data["supportTickets"])
                    this.supportTickets!.push(SupportTicket.fromJS(item));
            }
            if (Array.isArray(data["supportTicketTypes"])) {
                this.supportTicketTypes = [] as any;
                for (let item of data["supportTicketTypes"])
                    this.supportTicketTypes!.push(SupportTicketType.fromJS(item));
            }
            if (Array.isArray(data["supportTicketStatuses"])) {
                this.supportTicketStatuses = [] as any;
                for (let item of data["supportTicketStatuses"])
                    this.supportTicketStatuses!.push(SupportTicketStatus.fromJS(item));
            }
            if (Array.isArray(data["supportTicketAttachments"])) {
                this.supportTicketAttachments = [] as any;
                for (let item of data["supportTicketAttachments"])
                    this.supportTicketAttachments!.push(SupportTicketAttachment.fromJS(item));
            }
            if (Array.isArray(data["supportTicketNotes"])) {
                this.supportTicketNotes = [] as any;
                for (let item of data["supportTicketNotes"])
                    this.supportTicketNotes!.push(SupportTicketNote.fromJS(item));
            }
            if (Array.isArray(data["supportTicketSettings"])) {
                this.supportTicketSettings = [] as any;
                for (let item of data["supportTicketSettings"])
                    this.supportTicketSettings!.push(SupportTicketSetting.fromJS(item));
            }
            if (Array.isArray(data["routeVehicleChecks"])) {
                this.routeVehicleChecks = [] as any;
                for (let item of data["routeVehicleChecks"])
                    this.routeVehicleChecks!.push(RouteVehicleCheck.fromJS(item));
            }
            if (Array.isArray(data["reports"])) {
                this.reports = [] as any;
                for (let item of data["reports"])
                    this.reports!.push(Reports.fromJS(item));
            }
            if (Array.isArray(data["reportLogs"])) {
                this.reportLogs = [] as any;
                for (let item of data["reportLogs"])
                    this.reportLogs!.push(ReportLogs.fromJS(item));
            }
            if (Array.isArray(data["dashboards"])) {
                this.dashboards = [] as any;
                for (let item of data["dashboards"])
                    this.dashboards!.push(Dashboards.fromJS(item));
            }
            if (Array.isArray(data["secondaryConnections"])) {
                this.secondaryConnections = [] as any;
                for (let item of data["secondaryConnections"])
                    this.secondaryConnections!.push(SecondaryConnections.fromJS(item));
            }
            if (Array.isArray(data["preferences"])) {
                this.preferences = [] as any;
                for (let item of data["preferences"])
                    this.preferences!.push(Preference.fromJS(item));
            }
            if (Array.isArray(data["userPreferences"])) {
                this.userPreferences = [] as any;
                for (let item of data["userPreferences"])
                    this.userPreferences!.push(UserPreference.fromJS(item));
            }
            if (Array.isArray(data["clientPreferences"])) {
                this.clientPreferences = [] as any;
                for (let item of data["clientPreferences"])
                    this.clientPreferences!.push(ClientPreference.fromJS(item));
            }
            if (Array.isArray(data["dataSources"])) {
                this.dataSources = [] as any;
                for (let item of data["dataSources"])
                    this.dataSources!.push(DataSource.fromJS(item));
            }
            if (Array.isArray(data["dataSourceFiles"])) {
                this.dataSourceFiles = [] as any;
                for (let item of data["dataSourceFiles"])
                    this.dataSourceFiles!.push(DataSourceFiles.fromJS(item));
            }
            if (Array.isArray(data["dataSourceFileOrders"])) {
                this.dataSourceFileOrders = [] as any;
                for (let item of data["dataSourceFileOrders"])
                    this.dataSourceFileOrders!.push(DataSourceFileOrders.fromJS(item));
            }
            if (Array.isArray(data["drivers"])) {
                this.drivers = [] as any;
                for (let item of data["drivers"])
                    this.drivers!.push(Drivers.fromJS(item));
            }
            if (Array.isArray(data["driverRatings"])) {
                this.driverRatings = [] as any;
                for (let item of data["driverRatings"])
                    this.driverRatings!.push(DriverRating.fromJS(item));
            }
            if (Array.isArray(data["adjustmentTypes"])) {
                this.adjustmentTypes = [] as any;
                for (let item of data["adjustmentTypes"])
                    this.adjustmentTypes!.push(AdjustmentType.fromJS(item));
            }
            if (Array.isArray(data["locationAdjustments"])) {
                this.locationAdjustments = [] as any;
                for (let item of data["locationAdjustments"])
                    this.locationAdjustments!.push(LocationAdjustment.fromJS(item));
            }
            if (Array.isArray(data["routeOptimizerRules"])) {
                this.routeOptimizerRules = [] as any;
                for (let item of data["routeOptimizerRules"])
                    this.routeOptimizerRules!.push(RouteOptimizerRule.fromJS(item));
            }
            if (Array.isArray(data["routeOptimizers"])) {
                this.routeOptimizers = [] as any;
                for (let item of data["routeOptimizers"])
                    this.routeOptimizers!.push(RouteOptimizer.fromJS(item));
            }
            if (Array.isArray(data["reportSchedules"])) {
                this.reportSchedules = [] as any;
                for (let item of data["reportSchedules"])
                    this.reportSchedules!.push(ReportSchedules.fromJS(item));
            }
            if (Array.isArray(data["reportSchedulesRecipients"])) {
                this.reportSchedulesRecipients = [] as any;
                for (let item of data["reportSchedulesRecipients"])
                    this.reportSchedulesRecipients!.push(ReportSchedulesRecipients.fromJS(item));
            }
            if (Array.isArray(data["reportScheduleParameters"])) {
                this.reportScheduleParameters = [] as any;
                for (let item of data["reportScheduleParameters"])
                    this.reportScheduleParameters!.push(ReportScheduleParameters.fromJS(item));
            }
            if (Array.isArray(data["reportSchedulerFtpServers"])) {
                this.reportSchedulerFtpServers = [] as any;
                for (let item of data["reportSchedulerFtpServers"])
                    this.reportSchedulerFtpServers!.push(ReportSchedulerFtpServers.fromJS(item));
            }
            if (Array.isArray(data["cachedRequestSettings"])) {
                this.cachedRequestSettings = [] as any;
                for (let item of data["cachedRequestSettings"])
                    this.cachedRequestSettings!.push(CachedRequestSetting.fromJS(item));
            }
            if (Array.isArray(data["textToSpeechSettings"])) {
                this.textToSpeechSettings = [] as any;
                for (let item of data["textToSpeechSettings"])
                    this.textToSpeechSettings!.push(TextToSpeechSetting.fromJS(item));
            }
            if (Array.isArray(data["userEvents"])) {
                this.userEvents = [] as any;
                for (let item of data["userEvents"])
                    this.userEvents!.push(UserEvent.fromJS(item));
            }
            if (Array.isArray(data["routeNotificationRecipients"])) {
                this.routeNotificationRecipients = [] as any;
                for (let item of data["routeNotificationRecipients"])
                    this.routeNotificationRecipients!.push(RouteNotificationRecipient.fromJS(item));
            }
            if (Array.isArray(data["orderStatusPhotos"])) {
                this.orderStatusPhotos = [] as any;
                for (let item of data["orderStatusPhotos"])
                    this.orderStatusPhotos!.push(OrderStatusPhoto.fromJS(item));
            }
            if (Array.isArray(data["photoContents"])) {
                this.photoContents = [] as any;
                for (let item of data["photoContents"])
                    this.photoContents!.push(PhotoContent.fromJS(item));
            }
            if (Array.isArray(data["firebaseTokens"])) {
                this.firebaseTokens = [] as any;
                for (let item of data["firebaseTokens"])
                    this.firebaseTokens!.push(FirebaseToken.fromJS(item));
            }
            if (Array.isArray(data["firebaseNotificationRequests"])) {
                this.firebaseNotificationRequests = [] as any;
                for (let item of data["firebaseNotificationRequests"])
                    this.firebaseNotificationRequests!.push(FirebaseNotificationRequest.fromJS(item));
            }
            if (Array.isArray(data["containers"])) {
                this.containers = [] as any;
                for (let item of data["containers"])
                    this.containers!.push(Container.fromJS(item));
            }
            if (Array.isArray(data["destinationContainers"])) {
                this.destinationContainers = [] as any;
                for (let item of data["destinationContainers"])
                    this.destinationContainers!.push(DestinationContainer.fromJS(item));
            }
            if (Array.isArray(data["blindCountErrorPackages"])) {
                this.blindCountErrorPackages = [] as any;
                for (let item of data["blindCountErrorPackages"])
                    this.blindCountErrorPackages!.push(BlindCountErrorPackage.fromJS(item));
            }
            if (Array.isArray(data["automatedTestAccounts"])) {
                this.automatedTestAccounts = [] as any;
                for (let item of data["automatedTestAccounts"])
                    this.automatedTestAccounts!.push(AutomatedTestAccount.fromJS(item));
            }
            if (Array.isArray(data["automatedTestAccountDataStates"])) {
                this.automatedTestAccountDataStates = [] as any;
                for (let item of data["automatedTestAccountDataStates"])
                    this.automatedTestAccountDataStates!.push(AutomatedTestAccountDataState.fromJS(item));
            }
            if (Array.isArray(data["contactSettings"])) {
                this.contactSettings = [] as any;
                for (let item of data["contactSettings"])
                    this.contactSettings!.push(ContactSetting.fromJS(item));
            }
            if (Array.isArray(data["etaErrorCodes"])) {
                this.etaErrorCodes = [] as any;
                for (let item of data["etaErrorCodes"])
                    this.etaErrorCodes!.push(EtaErrorCode.fromJS(item));
            }
            if (Array.isArray(data["orderSourceFiles"])) {
                this.orderSourceFiles = [] as any;
                for (let item of data["orderSourceFiles"])
                    this.orderSourceFiles!.push(OrderSourceFile.fromJS(item));
            }
            if (Array.isArray(data["routeScheduleSettings"])) {
                this.routeScheduleSettings = [] as any;
                for (let item of data["routeScheduleSettings"])
                    this.routeScheduleSettings!.push(RouteScheduleSetting.fromJS(item));
            }
            if (Array.isArray(data["routeHandOffScheduleSettings"])) {
                this.routeHandOffScheduleSettings = [] as any;
                for (let item of data["routeHandOffScheduleSettings"])
                    this.routeHandOffScheduleSettings!.push(RouteHandOffScheduleSetting.fromJS(item));
            }
            if (Array.isArray(data["orderValidationCodes"])) {
                this.orderValidationCodes = [] as any;
                for (let item of data["orderValidationCodes"])
                    this.orderValidationCodes!.push(OrderValidationCode.fromJS(item));
            }
            if (Array.isArray(data["mobileTenantCodes"])) {
                this.mobileTenantCodes = [] as any;
                for (let item of data["mobileTenantCodes"])
                    this.mobileTenantCodes!.push(MobileTenantCode.fromJS(item));
            }
            if (Array.isArray(data["automatedTestDispatchCommandParams"])) {
                this.automatedTestDispatchCommandParams = [] as any;
                for (let item of data["automatedTestDispatchCommandParams"])
                    this.automatedTestDispatchCommandParams!.push(AutomatedTestDispatchCommandParam.fromJS(item));
            }
            if (Array.isArray(data["mobileClientCacheDatas"])) {
                this.mobileClientCacheDatas = [] as any;
                for (let item of data["mobileClientCacheDatas"])
                    this.mobileClientCacheDatas!.push(MobileClientCacheData.fromJS(item));
            }
            if (Array.isArray(data["mobileClientSentRequests"])) {
                this.mobileClientSentRequests = [] as any;
                for (let item of data["mobileClientSentRequests"])
                    this.mobileClientSentRequests!.push(MobileClientSentRequest.fromJS(item));
            }
            if (Array.isArray(data["destinationBlindCountErrors"])) {
                this.destinationBlindCountErrors = [] as any;
                for (let item of data["destinationBlindCountErrors"])
                    this.destinationBlindCountErrors!.push(DestinationBlindCountError.fromJS(item));
            }
            if (Array.isArray(data["destinationBlindCountErrorContainers"])) {
                this.destinationBlindCountErrorContainers = [] as any;
                for (let item of data["destinationBlindCountErrorContainers"])
                    this.destinationBlindCountErrorContainers!.push(DestinationBlindCountErrorContainer.fromJS(item));
            }
            if (Array.isArray(data["rotueScheduleDetailEtas"])) {
                this.rotueScheduleDetailEtas = [] as any;
                for (let item of data["rotueScheduleDetailEtas"])
                    this.rotueScheduleDetailEtas!.push(RouteScheduleDetailEtas.fromJS(item));
            }
            if (Array.isArray(data["mobileClientVersions"])) {
                this.mobileClientVersions = [] as any;
                for (let item of data["mobileClientVersions"])
                    this.mobileClientVersions!.push(MobileClientVersion.fromJS(item));
            }
            if (Array.isArray(data["orderAttachmentCacheKeys"])) {
                this.orderAttachmentCacheKeys = [] as any;
                for (let item of data["orderAttachmentCacheKeys"])
                    this.orderAttachmentCacheKeys!.push(OrderAttachmentCacheKey.fromJS(item));
            }
            if (Array.isArray(data["rates"])) {
                this.rates = [] as any;
                for (let item of data["rates"])
                    this.rates!.push(Rates.fromJS(item));
            }
            if (Array.isArray(data["rateRules"])) {
                this.rateRules = [] as any;
                for (let item of data["rateRules"])
                    this.rateRules!.push(RateRules.fromJS(item));
            }
            if (Array.isArray(data["shippingRoleActions"])) {
                this.shippingRoleActions = [] as any;
                for (let item of data["shippingRoleActions"])
                    this.shippingRoleActions!.push(ShippingRoleAction.fromJS(item));
            }
            if (Array.isArray(data["mobileClientWarnings"])) {
                this.mobileClientWarnings = [] as any;
                for (let item of data["mobileClientWarnings"])
                    this.mobileClientWarnings!.push(MobileClientWarning.fromJS(item));
            }
            if (Array.isArray(data["contactGroups"])) {
                this.contactGroups = [] as any;
                for (let item of data["contactGroups"])
                    this.contactGroups!.push(ContactGroup.fromJS(item));
            }
            if (Array.isArray(data["contactGroupMappings"])) {
                this.contactGroupMappings = [] as any;
                for (let item of data["contactGroupMappings"])
                    this.contactGroupMappings!.push(ContactGroupMapping.fromJS(item));
            }
            if (Array.isArray(data["contactGroupSettings"])) {
                this.contactGroupSettings = [] as any;
                for (let item of data["contactGroupSettings"])
                    this.contactGroupSettings!.push(ContactGroupSetting.fromJS(item));
            }
            if (Array.isArray(data["tenants"])) {
                this.tenants = [] as any;
                for (let item of data["tenants"])
                    this.tenants!.push(Tenant.fromJS(item));
            }
            if (Array.isArray(data["editions"])) {
                this.editions = [] as any;
                for (let item of data["editions"])
                    this.editions!.push(Edition.fromJS(item));
            }
            if (Array.isArray(data["featureSettings"])) {
                this.featureSettings = [] as any;
                for (let item of data["featureSettings"])
                    this.featureSettings!.push(FeatureSetting.fromJS(item));
            }
            if (Array.isArray(data["tenantFeatureSettings"])) {
                this.tenantFeatureSettings = [] as any;
                for (let item of data["tenantFeatureSettings"])
                    this.tenantFeatureSettings!.push(TenantFeatureSetting.fromJS(item));
            }
            if (Array.isArray(data["editionFeatureSettings"])) {
                this.editionFeatureSettings = [] as any;
                for (let item of data["editionFeatureSettings"])
                    this.editionFeatureSettings!.push(EditionFeatureSetting.fromJS(item));
            }
            if (Array.isArray(data["backgroundJobs"])) {
                this.backgroundJobs = [] as any;
                for (let item of data["backgroundJobs"])
                    this.backgroundJobs!.push(BackgroundJobInfo.fromJS(item));
            }
            if (Array.isArray(data["userAccounts"])) {
                this.userAccounts = [] as any;
                for (let item of data["userAccounts"])
                    this.userAccounts!.push(UserAccount.fromJS(item));
            }
            if (Array.isArray(data["notifications"])) {
                this.notifications = [] as any;
                for (let item of data["notifications"])
                    this.notifications!.push(NotificationInfo.fromJS(item));
            }
            if (Array.isArray(data["roles"])) {
                this.roles = [] as any;
                for (let item of data["roles"])
                    this.roles!.push(Role.fromJS(item));
            }
            if (Array.isArray(data["users"])) {
                this.users = [] as any;
                for (let item of data["users"])
                    this.users!.push(User.fromJS(item));
            }
            if (Array.isArray(data["userLogins"])) {
                this.userLogins = [] as any;
                for (let item of data["userLogins"])
                    this.userLogins!.push(UserLogin.fromJS(item));
            }
            if (Array.isArray(data["userLoginAttempts"])) {
                this.userLoginAttempts = [] as any;
                for (let item of data["userLoginAttempts"])
                    this.userLoginAttempts!.push(UserLoginAttempt.fromJS(item));
            }
            if (Array.isArray(data["userRoles"])) {
                this.userRoles = [] as any;
                for (let item of data["userRoles"])
                    this.userRoles!.push(UserRole.fromJS(item));
            }
            if (Array.isArray(data["userClaims"])) {
                this.userClaims = [] as any;
                for (let item of data["userClaims"])
                    this.userClaims!.push(UserClaim.fromJS(item));
            }
            if (Array.isArray(data["userTokens"])) {
                this.userTokens = [] as any;
                for (let item of data["userTokens"])
                    this.userTokens!.push(UserToken.fromJS(item));
            }
            if (Array.isArray(data["roleClaims"])) {
                this.roleClaims = [] as any;
                for (let item of data["roleClaims"])
                    this.roleClaims!.push(RoleClaim.fromJS(item));
            }
            if (Array.isArray(data["permissions"])) {
                this.permissions = [] as any;
                for (let item of data["permissions"])
                    this.permissions!.push(PermissionSetting.fromJS(item));
            }
            if (Array.isArray(data["rolePermissions"])) {
                this.rolePermissions = [] as any;
                for (let item of data["rolePermissions"])
                    this.rolePermissions!.push(RolePermissionSetting.fromJS(item));
            }
            if (Array.isArray(data["userPermissions"])) {
                this.userPermissions = [] as any;
                for (let item of data["userPermissions"])
                    this.userPermissions!.push(UserPermissionSetting.fromJS(item));
            }
            if (Array.isArray(data["settings"])) {
                this.settings = [] as any;
                for (let item of data["settings"])
                    this.settings!.push(Setting.fromJS(item));
            }
            if (Array.isArray(data["auditLogs"])) {
                this.auditLogs = [] as any;
                for (let item of data["auditLogs"])
                    this.auditLogs!.push(AuditLog.fromJS(item));
            }
            if (Array.isArray(data["languages"])) {
                this.languages = [] as any;
                for (let item of data["languages"])
                    this.languages!.push(ApplicationLanguage.fromJS(item));
            }
            if (Array.isArray(data["languageTexts"])) {
                this.languageTexts = [] as any;
                for (let item of data["languageTexts"])
                    this.languageTexts!.push(ApplicationLanguageText.fromJS(item));
            }
            if (Array.isArray(data["organizationUnits"])) {
                this.organizationUnits = [] as any;
                for (let item of data["organizationUnits"])
                    this.organizationUnits!.push(OrganizationUnit.fromJS(item));
            }
            if (Array.isArray(data["userOrganizationUnits"])) {
                this.userOrganizationUnits = [] as any;
                for (let item of data["userOrganizationUnits"])
                    this.userOrganizationUnits!.push(UserOrganizationUnit.fromJS(item));
            }
            if (Array.isArray(data["organizationUnitRoles"])) {
                this.organizationUnitRoles = [] as any;
                for (let item of data["organizationUnitRoles"])
                    this.organizationUnitRoles!.push(OrganizationUnitRole.fromJS(item));
            }
            if (Array.isArray(data["tenantNotifications"])) {
                this.tenantNotifications = [] as any;
                for (let item of data["tenantNotifications"])
                    this.tenantNotifications!.push(TenantNotificationInfo.fromJS(item));
            }
            if (Array.isArray(data["userNotifications"])) {
                this.userNotifications = [] as any;
                for (let item of data["userNotifications"])
                    this.userNotifications!.push(UserNotificationInfo.fromJS(item));
            }
            if (Array.isArray(data["notificationSubscriptions"])) {
                this.notificationSubscriptions = [] as any;
                for (let item of data["notificationSubscriptions"])
                    this.notificationSubscriptions!.push(NotificationSubscriptionInfo.fromJS(item));
            }
            if (Array.isArray(data["entityChanges"])) {
                this.entityChanges = [] as any;
                for (let item of data["entityChanges"])
                    this.entityChanges!.push(EntityChange.fromJS(item));
            }
            if (Array.isArray(data["entityChangeSets"])) {
                this.entityChangeSets = [] as any;
                for (let item of data["entityChangeSets"])
                    this.entityChangeSets!.push(EntityChangeSet.fromJS(item));
            }
            if (Array.isArray(data["entityPropertyChanges"])) {
                this.entityPropertyChanges = [] as any;
                for (let item of data["entityPropertyChanges"])
                    this.entityPropertyChanges!.push(EntityPropertyChange.fromJS(item));
            }
            if (Array.isArray(data["webhookEvents"])) {
                this.webhookEvents = [] as any;
                for (let item of data["webhookEvents"])
                    this.webhookEvents!.push(WebhookEvent.fromJS(item));
            }
            if (Array.isArray(data["webhookSubscriptions"])) {
                this.webhookSubscriptions = [] as any;
                for (let item of data["webhookSubscriptions"])
                    this.webhookSubscriptions!.push(WebhookSubscriptionInfo.fromJS(item));
            }
            if (Array.isArray(data["webhookSendAttempts"])) {
                this.webhookSendAttempts = [] as any;
                for (let item of data["webhookSendAttempts"])
                    this.webhookSendAttempts!.push(WebhookSendAttempt.fromJS(item));
            }
            this.entityHistoryHelper = data["entityHistoryHelper"] ? IEntityHistoryHelper.fromJS(data["entityHistoryHelper"]) : <any>undefined;
            this.abpSession = data["abpSession"] ? IAbpSession.fromJS(data["abpSession"]) : <any>undefined;
            this.entityChangeEventHelper = data["entityChangeEventHelper"] ? IEntityChangeEventHelper.fromJS(data["entityChangeEventHelper"]) : <any>undefined;
            this.logger = data["logger"] ? ILogger.fromJS(data["logger"]) : <any>undefined;
            this.eventBus = data["eventBus"] ? IEventBus.fromJS(data["eventBus"]) : <any>undefined;
            this.guidGenerator = data["guidGenerator"] ? IGuidGenerator.fromJS(data["guidGenerator"]) : <any>undefined;
            this.currentUnitOfWorkProvider = data["currentUnitOfWorkProvider"] ? ICurrentUnitOfWorkProvider.fromJS(data["currentUnitOfWorkProvider"]) : <any>undefined;
            this.multiTenancyConfig = data["multiTenancyConfig"] ? IMultiTenancyConfig.fromJS(data["multiTenancyConfig"]) : <any>undefined;
            this.suppressAutoSetTenantId = data["suppressAutoSetTenantId"];
            (<any>this).database = data["database"] ? DatabaseFacade.fromJS(data["database"]) : <any>undefined;
            (<any>this).changeTracker = data["changeTracker"] ? ChangeTracker.fromJS(data["changeTracker"]) : <any>undefined;
            (<any>this).model = data["model"] ? IModel.fromJS(data["model"]) : <any>undefined;
            (<any>this).contextId = data["contextId"] ? DbContextId.fromJS(data["contextId"]) : <any>undefined;
        }
    }

    static fromJS(data: any): SprintTekDbContext {
        data = typeof data === 'object' ? data : {};
        let result = new SprintTekDbContext();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.routeTemplateOrderExtras)) {
            data["routeTemplateOrderExtras"] = [];
            for (let item of this.routeTemplateOrderExtras)
                data["routeTemplateOrderExtras"].push(item.toJSON());
        }
        if (Array.isArray(this.recurringOrderSchedules)) {
            data["recurringOrderSchedules"] = [];
            for (let item of this.recurringOrderSchedules)
                data["recurringOrderSchedules"].push(item.toJSON());
        }
        if (Array.isArray(this.orderLogs)) {
            data["orderLogs"] = [];
            for (let item of this.orderLogs)
                data["orderLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.clientOrderLogs)) {
            data["clientOrderLogs"] = [];
            for (let item of this.clientOrderLogs)
                data["clientOrderLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.clientConnections)) {
            data["clientConnections"] = [];
            for (let item of this.clientConnections)
                data["clientConnections"].push(item.toJSON());
        }
        if (Array.isArray(this.clientDrivers)) {
            data["clientDrivers"] = [];
            for (let item of this.clientDrivers)
                data["clientDrivers"].push(item.toJSON());
        }
        if (Array.isArray(this.clientAccounts)) {
            data["clientAccounts"] = [];
            for (let item of this.clientAccounts)
                data["clientAccounts"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatusMappings)) {
            data["orderStatusMappings"] = [];
            for (let item of this.orderStatusMappings)
                data["orderStatusMappings"].push(item.toJSON());
        }
        if (Array.isArray(this.routeGenerationSettings)) {
            data["routeGenerationSettings"] = [];
            for (let item of this.routeGenerationSettings)
                data["routeGenerationSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.routeHandOffScheduleDetailEtas)) {
            data["routeHandOffScheduleDetailEtas"] = [];
            for (let item of this.routeHandOffScheduleDetailEtas)
                data["routeHandOffScheduleDetailEtas"].push(item.toJSON());
        }
        if (Array.isArray(this.contactPersons)) {
            data["contactPersons"] = [];
            for (let item of this.contactPersons)
                data["contactPersons"].push(item.toJSON());
        }
        if (Array.isArray(this.contactBusinessHours)) {
            data["contactBusinessHours"] = [];
            for (let item of this.contactBusinessHours)
                data["contactBusinessHours"].push(item.toJSON());
        }
        if (Array.isArray(this.routeHandOffDefinitionOrders)) {
            data["routeHandOffDefinitionOrders"] = [];
            for (let item of this.routeHandOffDefinitionOrders)
                data["routeHandOffDefinitionOrders"].push(item.toJSON());
        }
        if (Array.isArray(this.dataRetentionLogs)) {
            data["dataRetentionLogs"] = [];
            for (let item of this.dataRetentionLogs)
                data["dataRetentionLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.dataRetentions)) {
            data["dataRetentions"] = [];
            for (let item of this.dataRetentions)
                data["dataRetentions"].push(item.toJSON());
        }
        if (Array.isArray(this.routeGeneratorLogs)) {
            data["routeGeneratorLogs"] = [];
            for (let item of this.routeGeneratorLogs)
                data["routeGeneratorLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.versions)) {
            data["versions"] = [];
            for (let item of this.versions)
                data["versions"].push(item.toJSON());
        }
        if (Array.isArray(this.ftpAccounts)) {
            data["ftpAccounts"] = [];
            for (let item of this.ftpAccounts)
                data["ftpAccounts"].push(item.toJSON());
        }
        if (Array.isArray(this.userOrderTypes)) {
            data["userOrderTypes"] = [];
            for (let item of this.userOrderTypes)
                data["userOrderTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.orderSourceConnections)) {
            data["orderSourceConnections"] = [];
            for (let item of this.orderSourceConnections)
                data["orderSourceConnections"].push(item.toJSON());
        }
        if (Array.isArray(this.orderSources)) {
            data["orderSources"] = [];
            for (let item of this.orderSources)
                data["orderSources"].push(item.toJSON());
        }
        if (Array.isArray(this.vendors)) {
            data["vendors"] = [];
            for (let item of this.vendors)
                data["vendors"].push(item.toJSON());
        }
        if (Array.isArray(this.incidentSources)) {
            data["incidentSources"] = [];
            for (let item of this.incidentSources)
                data["incidentSources"].push(item.toJSON());
        }
        if (Array.isArray(this.importLogMessages)) {
            data["importLogMessages"] = [];
            for (let item of this.importLogMessages)
                data["importLogMessages"].push(item.toJSON());
        }
        if (Array.isArray(this.importLogs)) {
            data["importLogs"] = [];
            for (let item of this.importLogs)
                data["importLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.routeHandOffScheduleDetails)) {
            data["routeHandOffScheduleDetails"] = [];
            for (let item of this.routeHandOffScheduleDetails)
                data["routeHandOffScheduleDetails"].push(item.toJSON());
        }
        if (Array.isArray(this.routeHandOffDefinitions)) {
            data["routeHandOffDefinitions"] = [];
            for (let item of this.routeHandOffDefinitions)
                data["routeHandOffDefinitions"].push(item.toJSON());
        }
        if (Array.isArray(this.supportCategoryTypes)) {
            data["supportCategoryTypes"] = [];
            for (let item of this.supportCategoryTypes)
                data["supportCategoryTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.supportTicketCategories)) {
            data["supportTicketCategories"] = [];
            for (let item of this.supportTicketCategories)
                data["supportTicketCategories"].push(item.toJSON());
        }
        if (Array.isArray(this.routeDestinations)) {
            data["routeDestinations"] = [];
            for (let item of this.routeDestinations)
                data["routeDestinations"].push(item.toJSON());
        }
        if (Array.isArray(this.locationCalendarRoutes)) {
            data["locationCalendarRoutes"] = [];
            for (let item of this.locationCalendarRoutes)
                data["locationCalendarRoutes"].push(item.toJSON());
        }
        if (Array.isArray(this.locationHolidays)) {
            data["locationHolidays"] = [];
            for (let item of this.locationHolidays)
                data["locationHolidays"].push(item.toJSON());
        }
        if (Array.isArray(this.holidays)) {
            data["holidays"] = [];
            for (let item of this.holidays)
                data["holidays"].push(item.toJSON());
        }
        if (Array.isArray(this.driverIncidentTypes)) {
            data["driverIncidentTypes"] = [];
            for (let item of this.driverIncidentTypes)
                data["driverIncidentTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.employeeIncidents)) {
            data["employeeIncidents"] = [];
            for (let item of this.employeeIncidents)
                data["employeeIncidents"].push(item.toJSON());
        }
        if (Array.isArray(this.employeeIncidentTypes)) {
            data["employeeIncidentTypes"] = [];
            for (let item of this.employeeIncidentTypes)
                data["employeeIncidentTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.employees)) {
            data["employees"] = [];
            for (let item of this.employees)
                data["employees"].push(item.toJSON());
        }
        if (Array.isArray(this.supportTicketNotificationRecipientses)) {
            data["supportTicketNotificationRecipientses"] = [];
            for (let item of this.supportTicketNotificationRecipientses)
                data["supportTicketNotificationRecipientses"].push(item.toJSON());
        }
        if (Array.isArray(this.supportTicketNotifications)) {
            data["supportTicketNotifications"] = [];
            for (let item of this.supportTicketNotifications)
                data["supportTicketNotifications"].push(item.toJSON());
        }
        if (Array.isArray(this.smsTemplates)) {
            data["smsTemplates"] = [];
            for (let item of this.smsTemplates)
                data["smsTemplates"].push(item.toJSON());
        }
        if (Array.isArray(this.smsAccounts)) {
            data["smsAccounts"] = [];
            for (let item of this.smsAccounts)
                data["smsAccounts"].push(item.toJSON());
        }
        if (Array.isArray(this.organizationUnitOrderNotifications)) {
            data["organizationUnitOrderNotifications"] = [];
            for (let item of this.organizationUnitOrderNotifications)
                data["organizationUnitOrderNotifications"].push(item.toJSON());
        }
        if (Array.isArray(this.orderNotifications)) {
            data["orderNotifications"] = [];
            for (let item of this.orderNotifications)
                data["orderNotifications"].push(item.toJSON());
        }
        if (Array.isArray(this.orderNotificationTemplates)) {
            data["orderNotificationTemplates"] = [];
            for (let item of this.orderNotificationTemplates)
                data["orderNotificationTemplates"].push(item.toJSON());
        }
        if (Array.isArray(this.vehicleChecklists)) {
            data["vehicleChecklists"] = [];
            for (let item of this.vehicleChecklists)
                data["vehicleChecklists"].push(item.toJSON());
        }
        if (Array.isArray(this.vehicleTypes)) {
            data["vehicleTypes"] = [];
            for (let item of this.vehicleTypes)
                data["vehicleTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.route4MeSettings)) {
            data["route4MeSettings"] = [];
            for (let item of this.route4MeSettings)
                data["route4MeSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.route4MeDataImporting)) {
            data["route4MeDataImporting"] = [];
            for (let item of this.route4MeDataImporting)
                data["route4MeDataImporting"].push(item.toJSON());
        }
        if (Array.isArray(this.backgroundProcesses)) {
            data["backgroundProcesses"] = [];
            for (let item of this.backgroundProcesses)
                data["backgroundProcesses"].push(item.toJSON());
        }
        if (Array.isArray(this.orderTypes)) {
            data["orderTypes"] = [];
            for (let item of this.orderTypes)
                data["orderTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.orderIncidents)) {
            data["orderIncidents"] = [];
            for (let item of this.orderIncidents)
                data["orderIncidents"].push(item.toJSON());
        }
        if (Array.isArray(this.incidentTypes)) {
            data["incidentTypes"] = [];
            for (let item of this.incidentTypes)
                data["incidentTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.incidentStatuses)) {
            data["incidentStatuses"] = [];
            for (let item of this.incidentStatuses)
                data["incidentStatuses"].push(item.toJSON());
        }
        if (Array.isArray(this.incidentNote)) {
            data["incidentNote"] = [];
            for (let item of this.incidentNote)
                data["incidentNote"].push(item.toJSON());
        }
        if (Array.isArray(this.incidentAttachment)) {
            data["incidentAttachment"] = [];
            for (let item of this.incidentAttachment)
                data["incidentAttachment"].push(item.toJSON());
        }
        if (Array.isArray(this.importMaps)) {
            data["importMaps"] = [];
            for (let item of this.importMaps)
                data["importMaps"].push(item.toJSON());
        }
        if (Array.isArray(this.importFields)) {
            data["importFields"] = [];
            for (let item of this.importFields)
                data["importFields"].push(item.toJSON());
        }
        if (Array.isArray(this.importTables)) {
            data["importTables"] = [];
            for (let item of this.importTables)
                data["importTables"].push(item.toJSON());
        }
        if (Array.isArray(this.importMappings)) {
            data["importMappings"] = [];
            for (let item of this.importMappings)
                data["importMappings"].push(item.toJSON());
        }
        if (Array.isArray(this.exportMappings)) {
            data["exportMappings"] = [];
            for (let item of this.exportMappings)
                data["exportMappings"].push(item.toJSON());
        }
        if (Array.isArray(this.packageOptions)) {
            data["packageOptions"] = [];
            for (let item of this.packageOptions)
                data["packageOptions"].push(item.toJSON());
        }
        if (Array.isArray(this.routeDefinitions)) {
            data["routeDefinitions"] = [];
            for (let item of this.routeDefinitions)
                data["routeDefinitions"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatuses)) {
            data["orderStatuses"] = [];
            for (let item of this.orderStatuses)
                data["orderStatuses"].push(item.toJSON());
        }
        if (Array.isArray(this.routeTypes)) {
            data["routeTypes"] = [];
            for (let item of this.routeTypes)
                data["routeTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.routeScheduleDetails)) {
            data["routeScheduleDetails"] = [];
            for (let item of this.routeScheduleDetails)
                data["routeScheduleDetails"].push(item.toJSON());
        }
        if (Array.isArray(this.routeScheduleDetailEtas)) {
            data["routeScheduleDetailEtas"] = [];
            for (let item of this.routeScheduleDetailEtas)
                data["routeScheduleDetailEtas"].push(item.toJSON());
        }
        if (Array.isArray(this.routeScheduleEtas)) {
            data["routeScheduleEtas"] = [];
            for (let item of this.routeScheduleEtas)
                data["routeScheduleEtas"].push(item.toJSON());
        }
        if (Array.isArray(this.routeSchedules)) {
            data["routeSchedules"] = [];
            for (let item of this.routeSchedules)
                data["routeSchedules"].push(item.toJSON());
        }
        if (Array.isArray(this.routeStops)) {
            data["routeStops"] = [];
            for (let item of this.routeStops)
                data["routeStops"].push(item.toJSON());
        }
        if (Array.isArray(this.clinics)) {
            data["clinics"] = [];
            for (let item of this.clinics)
                data["clinics"].push(item.toJSON());
        }
        if (Array.isArray(this.binaryObjects)) {
            data["binaryObjects"] = [];
            for (let item of this.binaryObjects)
                data["binaryObjects"].push(item.toJSON());
        }
        if (Array.isArray(this.friendships)) {
            data["friendships"] = [];
            for (let item of this.friendships)
                data["friendships"].push(item.toJSON());
        }
        if (Array.isArray(this.chatMessages)) {
            data["chatMessages"] = [];
            for (let item of this.chatMessages)
                data["chatMessages"].push(item.toJSON());
        }
        if (Array.isArray(this.subscribableEditions)) {
            data["subscribableEditions"] = [];
            for (let item of this.subscribableEditions)
                data["subscribableEditions"].push(item.toJSON());
        }
        if (Array.isArray(this.subscriptionPayments)) {
            data["subscriptionPayments"] = [];
            for (let item of this.subscriptionPayments)
                data["subscriptionPayments"].push(item.toJSON());
        }
        if (Array.isArray(this.invoices)) {
            data["invoices"] = [];
            for (let item of this.invoices)
                data["invoices"].push(item.toJSON());
        }
        if (Array.isArray(this.persistedGrants)) {
            data["persistedGrants"] = [];
            for (let item of this.persistedGrants)
                data["persistedGrants"].push(item.toJSON());
        }
        if (Array.isArray(this.notes)) {
            data["notes"] = [];
            for (let item of this.notes)
                data["notes"].push(item.toJSON());
        }
        if (Array.isArray(this.imageNotes)) {
            data["imageNotes"] = [];
            for (let item of this.imageNotes)
                data["imageNotes"].push(item.toJSON());
        }
        if (Array.isArray(this.images)) {
            data["images"] = [];
            for (let item of this.images)
                data["images"].push(item.toJSON());
        }
        if (Array.isArray(this.timeSheets)) {
            data["timeSheets"] = [];
            for (let item of this.timeSheets)
                data["timeSheets"].push(item.toJSON());
        }
        if (Array.isArray(this.reviews)) {
            data["reviews"] = [];
            for (let item of this.reviews)
                data["reviews"].push(item.toJSON());
        }
        if (Array.isArray(this.employeeReviews)) {
            data["employeeReviews"] = [];
            for (let item of this.employeeReviews)
                data["employeeReviews"].push(item.toJSON());
        }
        if (Array.isArray(this.postalCodeZones)) {
            data["postalCodeZones"] = [];
            for (let item of this.postalCodeZones)
                data["postalCodeZones"].push(item.toJSON());
        }
        if (Array.isArray(this.routes)) {
            data["routes"] = [];
            for (let item of this.routes)
                data["routes"].push(item.toJSON());
        }
        if (Array.isArray(this.routeTemplates)) {
            data["routeTemplates"] = [];
            for (let item of this.routeTemplates)
                data["routeTemplates"].push(item.toJSON());
        }
        if (Array.isArray(this.routeTemplateAddresses)) {
            data["routeTemplateAddresses"] = [];
            for (let item of this.routeTemplateAddresses)
                data["routeTemplateAddresses"].push(item.toJSON());
        }
        if (Array.isArray(this.routeTemplateSortingRules)) {
            data["routeTemplateSortingRules"] = [];
            for (let item of this.routeTemplateSortingRules)
                data["routeTemplateSortingRules"].push(item.toJSON());
        }
        if (Array.isArray(this.routeTemplateTypes)) {
            data["routeTemplateTypes"] = [];
            for (let item of this.routeTemplateTypes)
                data["routeTemplateTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.routeTemplateWaypoints)) {
            data["routeTemplateWaypoints"] = [];
            for (let item of this.routeTemplateWaypoints)
                data["routeTemplateWaypoints"].push(item.toJSON());
        }
        if (Array.isArray(this.routeTemplateZones)) {
            data["routeTemplateZones"] = [];
            for (let item of this.routeTemplateZones)
                data["routeTemplateZones"].push(item.toJSON());
        }
        if (Array.isArray(this.sortingRules)) {
            data["sortingRules"] = [];
            for (let item of this.sortingRules)
                data["sortingRules"].push(item.toJSON());
        }
        if (Array.isArray(this.zones)) {
            data["zones"] = [];
            for (let item of this.zones)
                data["zones"].push(item.toJSON());
        }
        if (Array.isArray(this.locations)) {
            data["locations"] = [];
            for (let item of this.locations)
                data["locations"].push(item.toJSON());
        }
        if (Array.isArray(this.proximities)) {
            data["proximities"] = [];
            for (let item of this.proximities)
                data["proximities"].push(item.toJSON());
        }
        if (Array.isArray(this.timeZones)) {
            data["timeZones"] = [];
            for (let item of this.timeZones)
                data["timeZones"].push(item.toJSON());
        }
        if (Array.isArray(this.userLocations)) {
            data["userLocations"] = [];
            for (let item of this.userLocations)
                data["userLocations"].push(item.toJSON());
        }
        if (Array.isArray(this.zoneLocations)) {
            data["zoneLocations"] = [];
            for (let item of this.zoneLocations)
                data["zoneLocations"].push(item.toJSON());
        }
        if (Array.isArray(this.vehicleLocations)) {
            data["vehicleLocations"] = [];
            for (let item of this.vehicleLocations)
                data["vehicleLocations"].push(item.toJSON());
        }
        if (Array.isArray(this.destinationDetails)) {
            data["destinationDetails"] = [];
            for (let item of this.destinationDetails)
                data["destinationDetails"].push(item.toJSON());
        }
        if (Array.isArray(this.orders)) {
            data["orders"] = [];
            for (let item of this.orders)
                data["orders"].push(item.toJSON());
        }
        if (Array.isArray(this.orderPackages)) {
            data["orderPackages"] = [];
            for (let item of this.orderPackages)
                data["orderPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatus)) {
            data["orderStatus"] = [];
            for (let item of this.orderStatus)
                data["orderStatus"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatusAttachments)) {
            data["orderStatusAttachments"] = [];
            for (let item of this.orderStatusAttachments)
                data["orderStatusAttachments"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatusTypes)) {
            data["orderStatusTypes"] = [];
            for (let item of this.orderStatusTypes)
                data["orderStatusTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.orderTags)) {
            data["orderTags"] = [];
            for (let item of this.orderTags)
                data["orderTags"].push(item.toJSON());
        }
        if (Array.isArray(this.tags)) {
            data["tags"] = [];
            for (let item of this.tags)
                data["tags"].push(item.toJSON());
        }
        if (Array.isArray(this.tagTypes)) {
            data["tagTypes"] = [];
            for (let item of this.tagTypes)
                data["tagTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.vehicles)) {
            data["vehicles"] = [];
            for (let item of this.vehicles)
                data["vehicles"].push(item.toJSON());
        }
        if (Array.isArray(this.mileages)) {
            data["mileages"] = [];
            for (let item of this.mileages)
                data["mileages"].push(item.toJSON());
        }
        if (Array.isArray(this.vehicleMileages)) {
            data["vehicleMileages"] = [];
            for (let item of this.vehicleMileages)
                data["vehicleMileages"].push(item.toJSON());
        }
        if (Array.isArray(this.fleets)) {
            data["fleets"] = [];
            for (let item of this.fleets)
                data["fleets"].push(item.toJSON());
        }
        if (Array.isArray(this.fleetVehicles)) {
            data["fleetVehicles"] = [];
            for (let item of this.fleetVehicles)
                data["fleetVehicles"].push(item.toJSON());
        }
        if (Array.isArray(this.fleetUsers)) {
            data["fleetUsers"] = [];
            for (let item of this.fleetUsers)
                data["fleetUsers"].push(item.toJSON());
        }
        if (Array.isArray(this.fleetRates)) {
            data["fleetRates"] = [];
            for (let item of this.fleetRates)
                data["fleetRates"].push(item.toJSON());
        }
        if (Array.isArray(this.incidents)) {
            data["incidents"] = [];
            for (let item of this.incidents)
                data["incidents"].push(item.toJSON());
        }
        if (Array.isArray(this.driverIncidents)) {
            data["driverIncidents"] = [];
            for (let item of this.driverIncidents)
                data["driverIncidents"].push(item.toJSON());
        }
        if (Array.isArray(this.incidentImages)) {
            data["incidentImages"] = [];
            for (let item of this.incidentImages)
                data["incidentImages"].push(item.toJSON());
        }
        if (Array.isArray(this.reviewImages)) {
            data["reviewImages"] = [];
            for (let item of this.reviewImages)
                data["reviewImages"].push(item.toJSON());
        }
        if (Array.isArray(this.packages)) {
            data["packages"] = [];
            for (let item of this.packages)
                data["packages"].push(item.toJSON());
        }
        if (Array.isArray(this.addresses)) {
            data["addresses"] = [];
            for (let item of this.addresses)
                data["addresses"].push(item.toJSON());
        }
        if (Array.isArray(this.contacts)) {
            data["contacts"] = [];
            for (let item of this.contacts)
                data["contacts"].push(item.toJSON());
        }
        if (Array.isArray(this.phones)) {
            data["phones"] = [];
            for (let item of this.phones)
                data["phones"].push(item.toJSON());
        }
        if (Array.isArray(this.addressTypes)) {
            data["addressTypes"] = [];
            for (let item of this.addressTypes)
                data["addressTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.emails)) {
            data["emails"] = [];
            for (let item of this.emails)
                data["emails"].push(item.toJSON());
        }
        if (Array.isArray(this.postalCodes)) {
            data["postalCodes"] = [];
            for (let item of this.postalCodes)
                data["postalCodes"].push(item.toJSON());
        }
        if (Array.isArray(this.geocodes)) {
            data["geocodes"] = [];
            for (let item of this.geocodes)
                data["geocodes"].push(item.toJSON());
        }
        if (Array.isArray(this.proximityCodes)) {
            data["proximityCodes"] = [];
            for (let item of this.proximityCodes)
                data["proximityCodes"].push(item.toJSON());
        }
        if (Array.isArray(this.vehicleLogs)) {
            data["vehicleLogs"] = [];
            for (let item of this.vehicleLogs)
                data["vehicleLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileThemes)) {
            data["mobileThemes"] = [];
            for (let item of this.mobileThemes)
                data["mobileThemes"].push(item.toJSON());
        }
        if (Array.isArray(this.deliveryNotes)) {
            data["deliveryNotes"] = [];
            for (let item of this.deliveryNotes)
                data["deliveryNotes"].push(item.toJSON());
        }
        if (Array.isArray(this.companies)) {
            data["companies"] = [];
            for (let item of this.companies)
                data["companies"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileClients)) {
            data["mobileClients"] = [];
            for (let item of this.mobileClients)
                data["mobileClients"].push(item.toJSON());
        }
        if (Array.isArray(this.orderExtras)) {
            data["orderExtras"] = [];
            for (let item of this.orderExtras)
                data["orderExtras"].push(item.toJSON());
        }
        if (Array.isArray(this.geocodeRequestLogs)) {
            data["geocodeRequestLogs"] = [];
            for (let item of this.geocodeRequestLogs)
                data["geocodeRequestLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.googleApiRequestsLogs)) {
            data["googleApiRequestsLogs"] = [];
            for (let item of this.googleApiRequestsLogs)
                data["googleApiRequestsLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileAppVersions)) {
            data["mobileAppVersions"] = [];
            for (let item of this.mobileAppVersions)
                data["mobileAppVersions"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatusDescriptions)) {
            data["orderStatusDescriptions"] = [];
            for (let item of this.orderStatusDescriptions)
                data["orderStatusDescriptions"].push(item.toJSON());
        }
        if (Array.isArray(this.blindCountLimits)) {
            data["blindCountLimits"] = [];
            for (let item of this.blindCountLimits)
                data["blindCountLimits"].push(item.toJSON());
        }
        if (Array.isArray(this.blindCountErrors)) {
            data["blindCountErrors"] = [];
            for (let item of this.blindCountErrors)
                data["blindCountErrors"].push(item.toJSON());
        }
        if (Array.isArray(this.orderPackageQuantityLogs)) {
            data["orderPackageQuantityLogs"] = [];
            for (let item of this.orderPackageQuantityLogs)
                data["orderPackageQuantityLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileClientMessages)) {
            data["mobileClientMessages"] = [];
            for (let item of this.mobileClientMessages)
                data["mobileClientMessages"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileClientLogInCodes)) {
            data["mobileClientLogInCodes"] = [];
            for (let item of this.mobileClientLogInCodes)
                data["mobileClientLogInCodes"].push(item.toJSON());
        }
        if (Array.isArray(this.supportTickets)) {
            data["supportTickets"] = [];
            for (let item of this.supportTickets)
                data["supportTickets"].push(item.toJSON());
        }
        if (Array.isArray(this.supportTicketTypes)) {
            data["supportTicketTypes"] = [];
            for (let item of this.supportTicketTypes)
                data["supportTicketTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.supportTicketStatuses)) {
            data["supportTicketStatuses"] = [];
            for (let item of this.supportTicketStatuses)
                data["supportTicketStatuses"].push(item.toJSON());
        }
        if (Array.isArray(this.supportTicketAttachments)) {
            data["supportTicketAttachments"] = [];
            for (let item of this.supportTicketAttachments)
                data["supportTicketAttachments"].push(item.toJSON());
        }
        if (Array.isArray(this.supportTicketNotes)) {
            data["supportTicketNotes"] = [];
            for (let item of this.supportTicketNotes)
                data["supportTicketNotes"].push(item.toJSON());
        }
        if (Array.isArray(this.supportTicketSettings)) {
            data["supportTicketSettings"] = [];
            for (let item of this.supportTicketSettings)
                data["supportTicketSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.routeVehicleChecks)) {
            data["routeVehicleChecks"] = [];
            for (let item of this.routeVehicleChecks)
                data["routeVehicleChecks"].push(item.toJSON());
        }
        if (Array.isArray(this.reports)) {
            data["reports"] = [];
            for (let item of this.reports)
                data["reports"].push(item.toJSON());
        }
        if (Array.isArray(this.reportLogs)) {
            data["reportLogs"] = [];
            for (let item of this.reportLogs)
                data["reportLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.dashboards)) {
            data["dashboards"] = [];
            for (let item of this.dashboards)
                data["dashboards"].push(item.toJSON());
        }
        if (Array.isArray(this.secondaryConnections)) {
            data["secondaryConnections"] = [];
            for (let item of this.secondaryConnections)
                data["secondaryConnections"].push(item.toJSON());
        }
        if (Array.isArray(this.preferences)) {
            data["preferences"] = [];
            for (let item of this.preferences)
                data["preferences"].push(item.toJSON());
        }
        if (Array.isArray(this.userPreferences)) {
            data["userPreferences"] = [];
            for (let item of this.userPreferences)
                data["userPreferences"].push(item.toJSON());
        }
        if (Array.isArray(this.clientPreferences)) {
            data["clientPreferences"] = [];
            for (let item of this.clientPreferences)
                data["clientPreferences"].push(item.toJSON());
        }
        if (Array.isArray(this.dataSources)) {
            data["dataSources"] = [];
            for (let item of this.dataSources)
                data["dataSources"].push(item.toJSON());
        }
        if (Array.isArray(this.dataSourceFiles)) {
            data["dataSourceFiles"] = [];
            for (let item of this.dataSourceFiles)
                data["dataSourceFiles"].push(item.toJSON());
        }
        if (Array.isArray(this.dataSourceFileOrders)) {
            data["dataSourceFileOrders"] = [];
            for (let item of this.dataSourceFileOrders)
                data["dataSourceFileOrders"].push(item.toJSON());
        }
        if (Array.isArray(this.drivers)) {
            data["drivers"] = [];
            for (let item of this.drivers)
                data["drivers"].push(item.toJSON());
        }
        if (Array.isArray(this.driverRatings)) {
            data["driverRatings"] = [];
            for (let item of this.driverRatings)
                data["driverRatings"].push(item.toJSON());
        }
        if (Array.isArray(this.adjustmentTypes)) {
            data["adjustmentTypes"] = [];
            for (let item of this.adjustmentTypes)
                data["adjustmentTypes"].push(item.toJSON());
        }
        if (Array.isArray(this.locationAdjustments)) {
            data["locationAdjustments"] = [];
            for (let item of this.locationAdjustments)
                data["locationAdjustments"].push(item.toJSON());
        }
        if (Array.isArray(this.routeOptimizerRules)) {
            data["routeOptimizerRules"] = [];
            for (let item of this.routeOptimizerRules)
                data["routeOptimizerRules"].push(item.toJSON());
        }
        if (Array.isArray(this.routeOptimizers)) {
            data["routeOptimizers"] = [];
            for (let item of this.routeOptimizers)
                data["routeOptimizers"].push(item.toJSON());
        }
        if (Array.isArray(this.reportSchedules)) {
            data["reportSchedules"] = [];
            for (let item of this.reportSchedules)
                data["reportSchedules"].push(item.toJSON());
        }
        if (Array.isArray(this.reportSchedulesRecipients)) {
            data["reportSchedulesRecipients"] = [];
            for (let item of this.reportSchedulesRecipients)
                data["reportSchedulesRecipients"].push(item.toJSON());
        }
        if (Array.isArray(this.reportScheduleParameters)) {
            data["reportScheduleParameters"] = [];
            for (let item of this.reportScheduleParameters)
                data["reportScheduleParameters"].push(item.toJSON());
        }
        if (Array.isArray(this.reportSchedulerFtpServers)) {
            data["reportSchedulerFtpServers"] = [];
            for (let item of this.reportSchedulerFtpServers)
                data["reportSchedulerFtpServers"].push(item.toJSON());
        }
        if (Array.isArray(this.cachedRequestSettings)) {
            data["cachedRequestSettings"] = [];
            for (let item of this.cachedRequestSettings)
                data["cachedRequestSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.textToSpeechSettings)) {
            data["textToSpeechSettings"] = [];
            for (let item of this.textToSpeechSettings)
                data["textToSpeechSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.userEvents)) {
            data["userEvents"] = [];
            for (let item of this.userEvents)
                data["userEvents"].push(item.toJSON());
        }
        if (Array.isArray(this.routeNotificationRecipients)) {
            data["routeNotificationRecipients"] = [];
            for (let item of this.routeNotificationRecipients)
                data["routeNotificationRecipients"].push(item.toJSON());
        }
        if (Array.isArray(this.orderStatusPhotos)) {
            data["orderStatusPhotos"] = [];
            for (let item of this.orderStatusPhotos)
                data["orderStatusPhotos"].push(item.toJSON());
        }
        if (Array.isArray(this.photoContents)) {
            data["photoContents"] = [];
            for (let item of this.photoContents)
                data["photoContents"].push(item.toJSON());
        }
        if (Array.isArray(this.firebaseTokens)) {
            data["firebaseTokens"] = [];
            for (let item of this.firebaseTokens)
                data["firebaseTokens"].push(item.toJSON());
        }
        if (Array.isArray(this.firebaseNotificationRequests)) {
            data["firebaseNotificationRequests"] = [];
            for (let item of this.firebaseNotificationRequests)
                data["firebaseNotificationRequests"].push(item.toJSON());
        }
        if (Array.isArray(this.containers)) {
            data["containers"] = [];
            for (let item of this.containers)
                data["containers"].push(item.toJSON());
        }
        if (Array.isArray(this.destinationContainers)) {
            data["destinationContainers"] = [];
            for (let item of this.destinationContainers)
                data["destinationContainers"].push(item.toJSON());
        }
        if (Array.isArray(this.blindCountErrorPackages)) {
            data["blindCountErrorPackages"] = [];
            for (let item of this.blindCountErrorPackages)
                data["blindCountErrorPackages"].push(item.toJSON());
        }
        if (Array.isArray(this.automatedTestAccounts)) {
            data["automatedTestAccounts"] = [];
            for (let item of this.automatedTestAccounts)
                data["automatedTestAccounts"].push(item.toJSON());
        }
        if (Array.isArray(this.automatedTestAccountDataStates)) {
            data["automatedTestAccountDataStates"] = [];
            for (let item of this.automatedTestAccountDataStates)
                data["automatedTestAccountDataStates"].push(item.toJSON());
        }
        if (Array.isArray(this.contactSettings)) {
            data["contactSettings"] = [];
            for (let item of this.contactSettings)
                data["contactSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.etaErrorCodes)) {
            data["etaErrorCodes"] = [];
            for (let item of this.etaErrorCodes)
                data["etaErrorCodes"].push(item.toJSON());
        }
        if (Array.isArray(this.orderSourceFiles)) {
            data["orderSourceFiles"] = [];
            for (let item of this.orderSourceFiles)
                data["orderSourceFiles"].push(item.toJSON());
        }
        if (Array.isArray(this.routeScheduleSettings)) {
            data["routeScheduleSettings"] = [];
            for (let item of this.routeScheduleSettings)
                data["routeScheduleSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.routeHandOffScheduleSettings)) {
            data["routeHandOffScheduleSettings"] = [];
            for (let item of this.routeHandOffScheduleSettings)
                data["routeHandOffScheduleSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.orderValidationCodes)) {
            data["orderValidationCodes"] = [];
            for (let item of this.orderValidationCodes)
                data["orderValidationCodes"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileTenantCodes)) {
            data["mobileTenantCodes"] = [];
            for (let item of this.mobileTenantCodes)
                data["mobileTenantCodes"].push(item.toJSON());
        }
        if (Array.isArray(this.automatedTestDispatchCommandParams)) {
            data["automatedTestDispatchCommandParams"] = [];
            for (let item of this.automatedTestDispatchCommandParams)
                data["automatedTestDispatchCommandParams"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileClientCacheDatas)) {
            data["mobileClientCacheDatas"] = [];
            for (let item of this.mobileClientCacheDatas)
                data["mobileClientCacheDatas"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileClientSentRequests)) {
            data["mobileClientSentRequests"] = [];
            for (let item of this.mobileClientSentRequests)
                data["mobileClientSentRequests"].push(item.toJSON());
        }
        if (Array.isArray(this.destinationBlindCountErrors)) {
            data["destinationBlindCountErrors"] = [];
            for (let item of this.destinationBlindCountErrors)
                data["destinationBlindCountErrors"].push(item.toJSON());
        }
        if (Array.isArray(this.destinationBlindCountErrorContainers)) {
            data["destinationBlindCountErrorContainers"] = [];
            for (let item of this.destinationBlindCountErrorContainers)
                data["destinationBlindCountErrorContainers"].push(item.toJSON());
        }
        if (Array.isArray(this.rotueScheduleDetailEtas)) {
            data["rotueScheduleDetailEtas"] = [];
            for (let item of this.rotueScheduleDetailEtas)
                data["rotueScheduleDetailEtas"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileClientVersions)) {
            data["mobileClientVersions"] = [];
            for (let item of this.mobileClientVersions)
                data["mobileClientVersions"].push(item.toJSON());
        }
        if (Array.isArray(this.orderAttachmentCacheKeys)) {
            data["orderAttachmentCacheKeys"] = [];
            for (let item of this.orderAttachmentCacheKeys)
                data["orderAttachmentCacheKeys"].push(item.toJSON());
        }
        if (Array.isArray(this.rates)) {
            data["rates"] = [];
            for (let item of this.rates)
                data["rates"].push(item.toJSON());
        }
        if (Array.isArray(this.rateRules)) {
            data["rateRules"] = [];
            for (let item of this.rateRules)
                data["rateRules"].push(item.toJSON());
        }
        if (Array.isArray(this.shippingRoleActions)) {
            data["shippingRoleActions"] = [];
            for (let item of this.shippingRoleActions)
                data["shippingRoleActions"].push(item.toJSON());
        }
        if (Array.isArray(this.mobileClientWarnings)) {
            data["mobileClientWarnings"] = [];
            for (let item of this.mobileClientWarnings)
                data["mobileClientWarnings"].push(item.toJSON());
        }
        if (Array.isArray(this.contactGroups)) {
            data["contactGroups"] = [];
            for (let item of this.contactGroups)
                data["contactGroups"].push(item.toJSON());
        }
        if (Array.isArray(this.contactGroupMappings)) {
            data["contactGroupMappings"] = [];
            for (let item of this.contactGroupMappings)
                data["contactGroupMappings"].push(item.toJSON());
        }
        if (Array.isArray(this.contactGroupSettings)) {
            data["contactGroupSettings"] = [];
            for (let item of this.contactGroupSettings)
                data["contactGroupSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.tenants)) {
            data["tenants"] = [];
            for (let item of this.tenants)
                data["tenants"].push(item.toJSON());
        }
        if (Array.isArray(this.editions)) {
            data["editions"] = [];
            for (let item of this.editions)
                data["editions"].push(item.toJSON());
        }
        if (Array.isArray(this.featureSettings)) {
            data["featureSettings"] = [];
            for (let item of this.featureSettings)
                data["featureSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.tenantFeatureSettings)) {
            data["tenantFeatureSettings"] = [];
            for (let item of this.tenantFeatureSettings)
                data["tenantFeatureSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.editionFeatureSettings)) {
            data["editionFeatureSettings"] = [];
            for (let item of this.editionFeatureSettings)
                data["editionFeatureSettings"].push(item.toJSON());
        }
        if (Array.isArray(this.backgroundJobs)) {
            data["backgroundJobs"] = [];
            for (let item of this.backgroundJobs)
                data["backgroundJobs"].push(item.toJSON());
        }
        if (Array.isArray(this.userAccounts)) {
            data["userAccounts"] = [];
            for (let item of this.userAccounts)
                data["userAccounts"].push(item.toJSON());
        }
        if (Array.isArray(this.notifications)) {
            data["notifications"] = [];
            for (let item of this.notifications)
                data["notifications"].push(item.toJSON());
        }
        if (Array.isArray(this.roles)) {
            data["roles"] = [];
            for (let item of this.roles)
                data["roles"].push(item.toJSON());
        }
        if (Array.isArray(this.users)) {
            data["users"] = [];
            for (let item of this.users)
                data["users"].push(item.toJSON());
        }
        if (Array.isArray(this.userLogins)) {
            data["userLogins"] = [];
            for (let item of this.userLogins)
                data["userLogins"].push(item.toJSON());
        }
        if (Array.isArray(this.userLoginAttempts)) {
            data["userLoginAttempts"] = [];
            for (let item of this.userLoginAttempts)
                data["userLoginAttempts"].push(item.toJSON());
        }
        if (Array.isArray(this.userRoles)) {
            data["userRoles"] = [];
            for (let item of this.userRoles)
                data["userRoles"].push(item.toJSON());
        }
        if (Array.isArray(this.userClaims)) {
            data["userClaims"] = [];
            for (let item of this.userClaims)
                data["userClaims"].push(item.toJSON());
        }
        if (Array.isArray(this.userTokens)) {
            data["userTokens"] = [];
            for (let item of this.userTokens)
                data["userTokens"].push(item.toJSON());
        }
        if (Array.isArray(this.roleClaims)) {
            data["roleClaims"] = [];
            for (let item of this.roleClaims)
                data["roleClaims"].push(item.toJSON());
        }
        if (Array.isArray(this.permissions)) {
            data["permissions"] = [];
            for (let item of this.permissions)
                data["permissions"].push(item.toJSON());
        }
        if (Array.isArray(this.rolePermissions)) {
            data["rolePermissions"] = [];
            for (let item of this.rolePermissions)
                data["rolePermissions"].push(item.toJSON());
        }
        if (Array.isArray(this.userPermissions)) {
            data["userPermissions"] = [];
            for (let item of this.userPermissions)
                data["userPermissions"].push(item.toJSON());
        }
        if (Array.isArray(this.settings)) {
            data["settings"] = [];
            for (let item of this.settings)
                data["settings"].push(item.toJSON());
        }
        if (Array.isArray(this.auditLogs)) {
            data["auditLogs"] = [];
            for (let item of this.auditLogs)
                data["auditLogs"].push(item.toJSON());
        }
        if (Array.isArray(this.languages)) {
            data["languages"] = [];
            for (let item of this.languages)
                data["languages"].push(item.toJSON());
        }
        if (Array.isArray(this.languageTexts)) {
            data["languageTexts"] = [];
            for (let item of this.languageTexts)
                data["languageTexts"].push(item.toJSON());
        }
        if (Array.isArray(this.organizationUnits)) {
            data["organizationUnits"] = [];
            for (let item of this.organizationUnits)
                data["organizationUnits"].push(item.toJSON());
        }
        if (Array.isArray(this.userOrganizationUnits)) {
            data["userOrganizationUnits"] = [];
            for (let item of this.userOrganizationUnits)
                data["userOrganizationUnits"].push(item.toJSON());
        }
        if (Array.isArray(this.organizationUnitRoles)) {
            data["organizationUnitRoles"] = [];
            for (let item of this.organizationUnitRoles)
                data["organizationUnitRoles"].push(item.toJSON());
        }
        if (Array.isArray(this.tenantNotifications)) {
            data["tenantNotifications"] = [];
            for (let item of this.tenantNotifications)
                data["tenantNotifications"].push(item.toJSON());
        }
        if (Array.isArray(this.userNotifications)) {
            data["userNotifications"] = [];
            for (let item of this.userNotifications)
                data["userNotifications"].push(item.toJSON());
        }
        if (Array.isArray(this.notificationSubscriptions)) {
            data["notificationSubscriptions"] = [];
            for (let item of this.notificationSubscriptions)
                data["notificationSubscriptions"].push(item.toJSON());
        }
        if (Array.isArray(this.entityChanges)) {
            data["entityChanges"] = [];
            for (let item of this.entityChanges)
                data["entityChanges"].push(item.toJSON());
        }
        if (Array.isArray(this.entityChangeSets)) {
            data["entityChangeSets"] = [];
            for (let item of this.entityChangeSets)
                data["entityChangeSets"].push(item.toJSON());
        }
        if (Array.isArray(this.entityPropertyChanges)) {
            data["entityPropertyChanges"] = [];
            for (let item of this.entityPropertyChanges)
                data["entityPropertyChanges"].push(item.toJSON());
        }
        if (Array.isArray(this.webhookEvents)) {
            data["webhookEvents"] = [];
            for (let item of this.webhookEvents)
                data["webhookEvents"].push(item.toJSON());
        }
        if (Array.isArray(this.webhookSubscriptions)) {
            data["webhookSubscriptions"] = [];
            for (let item of this.webhookSubscriptions)
                data["webhookSubscriptions"].push(item.toJSON());
        }
        if (Array.isArray(this.webhookSendAttempts)) {
            data["webhookSendAttempts"] = [];
            for (let item of this.webhookSendAttempts)
                data["webhookSendAttempts"].push(item.toJSON());
        }
        data["entityHistoryHelper"] = this.entityHistoryHelper ? this.entityHistoryHelper.toJSON() : <any>undefined;
        data["abpSession"] = this.abpSession ? this.abpSession.toJSON() : <any>undefined;
        data["entityChangeEventHelper"] = this.entityChangeEventHelper ? this.entityChangeEventHelper.toJSON() : <any>undefined;
        data["logger"] = this.logger ? this.logger.toJSON() : <any>undefined;
        data["eventBus"] = this.eventBus ? this.eventBus.toJSON() : <any>undefined;
        data["guidGenerator"] = this.guidGenerator ? this.guidGenerator.toJSON() : <any>undefined;
        data["currentUnitOfWorkProvider"] = this.currentUnitOfWorkProvider ? this.currentUnitOfWorkProvider.toJSON() : <any>undefined;
        data["multiTenancyConfig"] = this.multiTenancyConfig ? this.multiTenancyConfig.toJSON() : <any>undefined;
        data["suppressAutoSetTenantId"] = this.suppressAutoSetTenantId;
        data["database"] = this.database ? this.database.toJSON() : <any>undefined;
        data["changeTracker"] = this.changeTracker ? this.changeTracker.toJSON() : <any>undefined;
        data["model"] = this.model ? this.model.toJSON() : <any>undefined;
        data["contextId"] = this.contextId ? this.contextId.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ISprintTekDbContext {
    routeTemplateOrderExtras: RouteTemplateOrderExtra[] | undefined;
    recurringOrderSchedules: RecurringOrderSchedule[] | undefined;
    orderLogs: OrderLog[] | undefined;
    clientOrderLogs: ClientOrderLog[] | undefined;
    clientConnections: ClientConnection[] | undefined;
    clientDrivers: ClientDriver[] | undefined;
    clientAccounts: ClientAccount[] | undefined;
    orderStatusMappings: OrderStatusMapping[] | undefined;
    routeGenerationSettings: RouteGenerationSetting[] | undefined;
    routeHandOffScheduleDetailEtas: RouteHandOffScheduleDetailEtas[] | undefined;
    contactPersons: ContactPerson[] | undefined;
    contactBusinessHours: ContactBusinessHour[] | undefined;
    routeHandOffDefinitionOrders: RouteHandOffDefinitionOrder[] | undefined;
    dataRetentionLogs: DataRetentionLog[] | undefined;
    dataRetentions: DataRetention[] | undefined;
    routeGeneratorLogs: RouteGeneratorLog[] | undefined;
    versions: Version[] | undefined;
    ftpAccounts: FtpAccount[] | undefined;
    userOrderTypes: UserOrderType[] | undefined;
    orderSourceConnections: OrderSourceConnection[] | undefined;
    orderSources: OrderSource[] | undefined;
    vendors: Vendor[] | undefined;
    incidentSources: IncidentSource[] | undefined;
    importLogMessages: ImportLogMessage[] | undefined;
    importLogs: ImportLog[] | undefined;
    routeHandOffScheduleDetails: RouteHandOffScheduleDetail[] | undefined;
    routeHandOffDefinitions: RouteHandOffDefinition[] | undefined;
    supportCategoryTypes: SupportCategoryTypes[] | undefined;
    supportTicketCategories: SupportTicketCategory[] | undefined;
    routeDestinations: RouteDestination[] | undefined;
    locationCalendarRoutes: LocationCalendarRoute[] | undefined;
    locationHolidays: LocationHoliday[] | undefined;
    holidays: Holiday[] | undefined;
    driverIncidentTypes: DriverIncidentType[] | undefined;
    employeeIncidents: EmployeeIncident[] | undefined;
    employeeIncidentTypes: EmployeeIncidentType[] | undefined;
    employees: Employee[] | undefined;
    supportTicketNotificationRecipientses: SupportTicketNotificationRecipients[] | undefined;
    supportTicketNotifications: SupportTicketNotification[] | undefined;
    smsTemplates: SmsTemplate[] | undefined;
    smsAccounts: SmsAccount[] | undefined;
    organizationUnitOrderNotifications: OrganizationUnitOrderNotification[] | undefined;
    orderNotifications: OrderNotification[] | undefined;
    orderNotificationTemplates: OrderNotificationTemplate[] | undefined;
    vehicleChecklists: VehicleChecklist[] | undefined;
    vehicleTypes: VehicleTypes[] | undefined;
    route4MeSettings: Route4MeSetting[] | undefined;
    route4MeDataImporting: Route4MeDataImport[] | undefined;
    backgroundProcesses: BackgroundProcess[] | undefined;
    orderTypes: OrderType[] | undefined;
    orderIncidents: OrderIncident[] | undefined;
    incidentTypes: IncidentType[] | undefined;
    incidentStatuses: IncidentStatuses[] | undefined;
    incidentNote: IncidentNote[] | undefined;
    incidentAttachment: IncidentAttachment[] | undefined;
    importMaps: ImportMap[] | undefined;
    importFields: ImportField[] | undefined;
    importTables: ImportTable[] | undefined;
    importMappings: ImportMapping[] | undefined;
    exportMappings: ExportMapping[] | undefined;
    packageOptions: PackageOption[] | undefined;
    routeDefinitions: RouteDefinition[] | undefined;
    orderStatuses: OrderStatus[] | undefined;
    routeTypes: RouteType[] | undefined;
    routeScheduleDetails: RouteScheduleDetail[] | undefined;
    routeScheduleDetailEtas: RouteScheduleDetailEtas[] | undefined;
    routeScheduleEtas: RouteScheduleEta[] | undefined;
    routeSchedules: RouteSchedule[] | undefined;
    routeStops: RouteStop[] | undefined;
    clinics: Clinic[] | undefined;
    binaryObjects: BinaryObject[] | undefined;
    friendships: Friendship[] | undefined;
    chatMessages: ChatMessage[] | undefined;
    subscribableEditions: SubscribableEdition[] | undefined;
    subscriptionPayments: SubscriptionPayment[] | undefined;
    invoices: Invoice[] | undefined;
    persistedGrants: PersistedGrantEntity[] | undefined;
    notes: Note[] | undefined;
    imageNotes: ImageNote[] | undefined;
    images: Image[] | undefined;
    timeSheets: TimeSheet[] | undefined;
    reviews: Review[] | undefined;
    employeeReviews: EmployeeReview[] | undefined;
    postalCodeZones: PostalCodeZone[] | undefined;
    routes: Route[] | undefined;
    routeTemplates: RouteTemplate[] | undefined;
    routeTemplateAddresses: RouteTemplateAddress[] | undefined;
    routeTemplateSortingRules: RouteTemplateSortingRule[] | undefined;
    routeTemplateTypes: RouteTemplateType[] | undefined;
    routeTemplateWaypoints: RouteTemplateWaypoint[] | undefined;
    routeTemplateZones: RouteTemplateZone[] | undefined;
    sortingRules: SortingRule[] | undefined;
    zones: Zone[] | undefined;
    locations: Location[] | undefined;
    proximities: Proximity[] | undefined;
    timeZones: TimeZone[] | undefined;
    userLocations: UserLocation[] | undefined;
    zoneLocations: ZoneLocation[] | undefined;
    vehicleLocations: VehicleLocation[] | undefined;
    destinationDetails: DestinationDetail[] | undefined;
    orders: Order[] | undefined;
    orderPackages: OrderPackage[] | undefined;
    orderStatus: OrderStatus[] | undefined;
    orderStatusAttachments: OrderStatusAttachment[] | undefined;
    orderStatusTypes: OrderStatusType[] | undefined;
    orderTags: OrderTag[] | undefined;
    tags: Tag[] | undefined;
    tagTypes: TagType[] | undefined;
    vehicles: Vehicle[] | undefined;
    mileages: Mileage[] | undefined;
    vehicleMileages: VehicleMileage[] | undefined;
    fleets: Fleet[] | undefined;
    fleetVehicles: FleetVehicle[] | undefined;
    fleetUsers: FleetUser[] | undefined;
    fleetRates: FleetRate[] | undefined;
    incidents: Incident[] | undefined;
    driverIncidents: DriverIncident[] | undefined;
    incidentImages: IncidentImage[] | undefined;
    reviewImages: ReviewImage[] | undefined;
    packages: Package[] | undefined;
    addresses: Address[] | undefined;
    contacts: Contact[] | undefined;
    phones: Phone[] | undefined;
    addressTypes: AddressType[] | undefined;
    emails: Email[] | undefined;
    postalCodes: PostalCode[] | undefined;
    geocodes: Geocode[] | undefined;
    proximityCodes: ProximityCode[] | undefined;
    vehicleLogs: VehicleLog[] | undefined;
    mobileThemes: MobileTheme[] | undefined;
    deliveryNotes: DeliveryNote[] | undefined;
    companies: Company[] | undefined;
    mobileClients: MobileClient[] | undefined;
    orderExtras: OrderExtra[] | undefined;
    geocodeRequestLogs: GeocodeRequestLog[] | undefined;
    googleApiRequestsLogs: GoogleApiRequestsLog[] | undefined;
    mobileAppVersions: MobileAppVersion[] | undefined;
    orderStatusDescriptions: OrderStatusDescription[] | undefined;
    blindCountLimits: BlindCountLimit[] | undefined;
    blindCountErrors: BlindCountError[] | undefined;
    orderPackageQuantityLogs: OrderPackageQuantityLog[] | undefined;
    mobileClientMessages: MobileClientMessage[] | undefined;
    mobileClientLogInCodes: MobileClientLogInCode[] | undefined;
    supportTickets: SupportTicket[] | undefined;
    supportTicketTypes: SupportTicketType[] | undefined;
    supportTicketStatuses: SupportTicketStatus[] | undefined;
    supportTicketAttachments: SupportTicketAttachment[] | undefined;
    supportTicketNotes: SupportTicketNote[] | undefined;
    supportTicketSettings: SupportTicketSetting[] | undefined;
    routeVehicleChecks: RouteVehicleCheck[] | undefined;
    reports: Reports[] | undefined;
    reportLogs: ReportLogs[] | undefined;
    dashboards: Dashboards[] | undefined;
    secondaryConnections: SecondaryConnections[] | undefined;
    preferences: Preference[] | undefined;
    userPreferences: UserPreference[] | undefined;
    clientPreferences: ClientPreference[] | undefined;
    dataSources: DataSource[] | undefined;
    dataSourceFiles: DataSourceFiles[] | undefined;
    dataSourceFileOrders: DataSourceFileOrders[] | undefined;
    drivers: Drivers[] | undefined;
    driverRatings: DriverRating[] | undefined;
    adjustmentTypes: AdjustmentType[] | undefined;
    locationAdjustments: LocationAdjustment[] | undefined;
    routeOptimizerRules: RouteOptimizerRule[] | undefined;
    routeOptimizers: RouteOptimizer[] | undefined;
    reportSchedules: ReportSchedules[] | undefined;
    reportSchedulesRecipients: ReportSchedulesRecipients[] | undefined;
    reportScheduleParameters: ReportScheduleParameters[] | undefined;
    reportSchedulerFtpServers: ReportSchedulerFtpServers[] | undefined;
    cachedRequestSettings: CachedRequestSetting[] | undefined;
    textToSpeechSettings: TextToSpeechSetting[] | undefined;
    userEvents: UserEvent[] | undefined;
    routeNotificationRecipients: RouteNotificationRecipient[] | undefined;
    orderStatusPhotos: OrderStatusPhoto[] | undefined;
    photoContents: PhotoContent[] | undefined;
    firebaseTokens: FirebaseToken[] | undefined;
    firebaseNotificationRequests: FirebaseNotificationRequest[] | undefined;
    containers: Container[] | undefined;
    destinationContainers: DestinationContainer[] | undefined;
    blindCountErrorPackages: BlindCountErrorPackage[] | undefined;
    automatedTestAccounts: AutomatedTestAccount[] | undefined;
    automatedTestAccountDataStates: AutomatedTestAccountDataState[] | undefined;
    contactSettings: ContactSetting[] | undefined;
    etaErrorCodes: EtaErrorCode[] | undefined;
    orderSourceFiles: OrderSourceFile[] | undefined;
    routeScheduleSettings: RouteScheduleSetting[] | undefined;
    routeHandOffScheduleSettings: RouteHandOffScheduleSetting[] | undefined;
    orderValidationCodes: OrderValidationCode[] | undefined;
    mobileTenantCodes: MobileTenantCode[] | undefined;
    automatedTestDispatchCommandParams: AutomatedTestDispatchCommandParam[] | undefined;
    mobileClientCacheDatas: MobileClientCacheData[] | undefined;
    mobileClientSentRequests: MobileClientSentRequest[] | undefined;
    destinationBlindCountErrors: DestinationBlindCountError[] | undefined;
    destinationBlindCountErrorContainers: DestinationBlindCountErrorContainer[] | undefined;
    rotueScheduleDetailEtas: RouteScheduleDetailEtas[] | undefined;
    mobileClientVersions: MobileClientVersion[] | undefined;
    orderAttachmentCacheKeys: OrderAttachmentCacheKey[] | undefined;
    rates: Rates[] | undefined;
    rateRules: RateRules[] | undefined;
    shippingRoleActions: ShippingRoleAction[] | undefined;
    mobileClientWarnings: MobileClientWarning[] | undefined;
    contactGroups: ContactGroup[] | undefined;
    contactGroupMappings: ContactGroupMapping[] | undefined;
    contactGroupSettings: ContactGroupSetting[] | undefined;
    tenants: Tenant[] | undefined;
    editions: Edition[] | undefined;
    featureSettings: FeatureSetting[] | undefined;
    tenantFeatureSettings: TenantFeatureSetting[] | undefined;
    editionFeatureSettings: EditionFeatureSetting[] | undefined;
    backgroundJobs: BackgroundJobInfo[] | undefined;
    userAccounts: UserAccount[] | undefined;
    notifications: NotificationInfo[] | undefined;
    roles: Role[] | undefined;
    users: User[] | undefined;
    userLogins: UserLogin[] | undefined;
    userLoginAttempts: UserLoginAttempt[] | undefined;
    userRoles: UserRole[] | undefined;
    userClaims: UserClaim[] | undefined;
    userTokens: UserToken[] | undefined;
    roleClaims: RoleClaim[] | undefined;
    permissions: PermissionSetting[] | undefined;
    rolePermissions: RolePermissionSetting[] | undefined;
    userPermissions: UserPermissionSetting[] | undefined;
    settings: Setting[] | undefined;
    auditLogs: AuditLog[] | undefined;
    languages: ApplicationLanguage[] | undefined;
    languageTexts: ApplicationLanguageText[] | undefined;
    organizationUnits: OrganizationUnit[] | undefined;
    userOrganizationUnits: UserOrganizationUnit[] | undefined;
    organizationUnitRoles: OrganizationUnitRole[] | undefined;
    tenantNotifications: TenantNotificationInfo[] | undefined;
    userNotifications: UserNotificationInfo[] | undefined;
    notificationSubscriptions: NotificationSubscriptionInfo[] | undefined;
    entityChanges: EntityChange[] | undefined;
    entityChangeSets: EntityChangeSet[] | undefined;
    entityPropertyChanges: EntityPropertyChange[] | undefined;
    webhookEvents: WebhookEvent[] | undefined;
    webhookSubscriptions: WebhookSubscriptionInfo[] | undefined;
    webhookSendAttempts: WebhookSendAttempt[] | undefined;
    entityHistoryHelper: IEntityHistoryHelper | undefined;
    abpSession: IAbpSession | undefined;
    entityChangeEventHelper: IEntityChangeEventHelper | undefined;
    logger: ILogger | undefined;
    eventBus: IEventBus | undefined;
    guidGenerator: IGuidGenerator | undefined;
    currentUnitOfWorkProvider: ICurrentUnitOfWorkProvider | undefined;
    multiTenancyConfig: IMultiTenancyConfig | undefined;
    suppressAutoSetTenantId: boolean;
    database: DatabaseFacade | undefined;
    changeTracker: ChangeTracker | undefined;
    model: IModel | undefined;
    contextId: DbContextId;
}

export class UserLoginInfoDto implements IUserLoginInfoDto {
    name!: string | undefined;
    surname!: string | undefined;
    userName!: string | undefined;
    emailAddress!: string | undefined;
    profilePictureId!: string | undefined;
    hasBackgroundImage!: boolean;
    recordCountPerPage!: number;
    id!: number;

    constructor(data?: IUserLoginInfoDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.surname = data["surname"];
            this.userName = data["userName"];
            this.emailAddress = data["emailAddress"];
            this.profilePictureId = data["profilePictureId"];
            this.hasBackgroundImage = data["hasBackgroundImage"];
            this.recordCountPerPage = data["recordCountPerPage"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserLoginInfoDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserLoginInfoDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["userName"] = this.userName;
        data["emailAddress"] = this.emailAddress;
        data["profilePictureId"] = this.profilePictureId;
        data["hasBackgroundImage"] = this.hasBackgroundImage;
        data["recordCountPerPage"] = this.recordCountPerPage;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserLoginInfoDto {
    name: string | undefined;
    surname: string | undefined;
    userName: string | undefined;
    emailAddress: string | undefined;
    profilePictureId: string | undefined;
    hasBackgroundImage: boolean;
    recordCountPerPage: number;
    id: number;
}

export class EditionInfoDto implements IEditionInfoDto {
    displayName!: string | undefined;
    trialDayCount!: number | undefined;
    monthlyPrice!: number | undefined;
    annualPrice!: number | undefined;
    isHighestEdition!: boolean;
    isFree!: boolean;
    id!: number;

    constructor(data?: IEditionInfoDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.displayName = data["displayName"];
            this.trialDayCount = data["trialDayCount"];
            this.monthlyPrice = data["monthlyPrice"];
            this.annualPrice = data["annualPrice"];
            this.isHighestEdition = data["isHighestEdition"];
            this.isFree = data["isFree"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): EditionInfoDto {
        data = typeof data === 'object' ? data : {};
        let result = new EditionInfoDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["displayName"] = this.displayName;
        data["trialDayCount"] = this.trialDayCount;
        data["monthlyPrice"] = this.monthlyPrice;
        data["annualPrice"] = this.annualPrice;
        data["isHighestEdition"] = this.isHighestEdition;
        data["isFree"] = this.isFree;
        data["id"] = this.id;
        return data; 
    }
}

export interface IEditionInfoDto {
    displayName: string | undefined;
    trialDayCount: number | undefined;
    monthlyPrice: number | undefined;
    annualPrice: number | undefined;
    isHighestEdition: boolean;
    isFree: boolean;
    id: number;
}

export class TenantLoginInfoDto implements ITenantLoginInfoDto {
    tenancyName!: string | undefined;
    name!: string | undefined;
    logoId!: string | undefined;
    logoFileType!: string | undefined;
    customCssId!: string | undefined;
    subscriptionEndDateUtc!: moment.Moment | undefined;
    isInTrialPeriod!: boolean;
    subscriptionPaymentType!: SubscriptionPaymentType;
    edition!: EditionInfoDto | undefined;
    creationTime!: moment.Moment;
    paymentPeriodType!: PaymentPeriodType;
    subscriptionDateString!: string | undefined;
    creationTimeString!: string | undefined;
    id!: number;

    constructor(data?: ITenantLoginInfoDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.name = data["name"];
            this.logoId = data["logoId"];
            this.logoFileType = data["logoFileType"];
            this.customCssId = data["customCssId"];
            this.subscriptionEndDateUtc = data["subscriptionEndDateUtc"] ? moment(data["subscriptionEndDateUtc"].toString()) : <any>undefined;
            this.isInTrialPeriod = data["isInTrialPeriod"];
            this.subscriptionPaymentType = data["subscriptionPaymentType"];
            this.edition = data["edition"] ? EditionInfoDto.fromJS(data["edition"]) : <any>undefined;
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.paymentPeriodType = data["paymentPeriodType"];
            this.subscriptionDateString = data["subscriptionDateString"];
            this.creationTimeString = data["creationTimeString"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TenantLoginInfoDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantLoginInfoDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["name"] = this.name;
        data["logoId"] = this.logoId;
        data["logoFileType"] = this.logoFileType;
        data["customCssId"] = this.customCssId;
        data["subscriptionEndDateUtc"] = this.subscriptionEndDateUtc ? this.subscriptionEndDateUtc.toISOString() : <any>undefined;
        data["isInTrialPeriod"] = this.isInTrialPeriod;
        data["subscriptionPaymentType"] = this.subscriptionPaymentType;
        data["edition"] = this.edition ? this.edition.toJSON() : <any>undefined;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["paymentPeriodType"] = this.paymentPeriodType;
        data["subscriptionDateString"] = this.subscriptionDateString;
        data["creationTimeString"] = this.creationTimeString;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITenantLoginInfoDto {
    tenancyName: string | undefined;
    name: string | undefined;
    logoId: string | undefined;
    logoFileType: string | undefined;
    customCssId: string | undefined;
    subscriptionEndDateUtc: moment.Moment | undefined;
    isInTrialPeriod: boolean;
    subscriptionPaymentType: SubscriptionPaymentType;
    edition: EditionInfoDto | undefined;
    creationTime: moment.Moment;
    paymentPeriodType: PaymentPeriodType;
    subscriptionDateString: string | undefined;
    creationTimeString: string | undefined;
    id: number;
}

export class ApplicationInfoDto implements IApplicationInfoDto {
    version!: string | undefined;
    releaseDate!: moment.Moment;
    currency!: string | undefined;
    currencySign!: string | undefined;
    allowTenantsToChangeEmailSettings!: boolean;
    features!: { [key: string]: boolean; } | undefined;

    constructor(data?: IApplicationInfoDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.version = data["version"];
            this.releaseDate = data["releaseDate"] ? moment(data["releaseDate"].toString()) : <any>undefined;
            this.currency = data["currency"];
            this.currencySign = data["currencySign"];
            this.allowTenantsToChangeEmailSettings = data["allowTenantsToChangeEmailSettings"];
            if (data["features"]) {
                this.features = {} as any;
                for (let key in data["features"]) {
                    if (data["features"].hasOwnProperty(key))
                        this.features![key] = data["features"][key];
                }
            }
        }
    }

    static fromJS(data: any): ApplicationInfoDto {
        data = typeof data === 'object' ? data : {};
        let result = new ApplicationInfoDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["version"] = this.version;
        data["releaseDate"] = this.releaseDate ? this.releaseDate.toISOString() : <any>undefined;
        data["currency"] = this.currency;
        data["currencySign"] = this.currencySign;
        data["allowTenantsToChangeEmailSettings"] = this.allowTenantsToChangeEmailSettings;
        if (this.features) {
            data["features"] = {};
            for (let key in this.features) {
                if (this.features.hasOwnProperty(key))
                    data["features"][key] = this.features[key];
            }
        }
        return data; 
    }
}

export interface IApplicationInfoDto {
    version: string | undefined;
    releaseDate: moment.Moment;
    currency: string | undefined;
    currencySign: string | undefined;
    allowTenantsToChangeEmailSettings: boolean;
    features: { [key: string]: boolean; } | undefined;
}

export class ThemeLayoutSettingsDto implements IThemeLayoutSettingsDto {
    layoutType!: string | undefined;

    constructor(data?: IThemeLayoutSettingsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.layoutType = data["layoutType"];
        }
    }

    static fromJS(data: any): ThemeLayoutSettingsDto {
        data = typeof data === 'object' ? data : {};
        let result = new ThemeLayoutSettingsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["layoutType"] = this.layoutType;
        return data; 
    }
}

export interface IThemeLayoutSettingsDto {
    layoutType: string | undefined;
}

export class ThemeHeaderSettingsDto implements IThemeHeaderSettingsDto {
    desktopFixedHeader!: boolean;
    mobileFixedHeader!: boolean;
    headerSkin!: string | undefined;
    minimizeDesktopHeaderType!: string | undefined;
    headerMenuArrows!: boolean;

    constructor(data?: IThemeHeaderSettingsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.desktopFixedHeader = data["desktopFixedHeader"];
            this.mobileFixedHeader = data["mobileFixedHeader"];
            this.headerSkin = data["headerSkin"];
            this.minimizeDesktopHeaderType = data["minimizeDesktopHeaderType"];
            this.headerMenuArrows = data["headerMenuArrows"];
        }
    }

    static fromJS(data: any): ThemeHeaderSettingsDto {
        data = typeof data === 'object' ? data : {};
        let result = new ThemeHeaderSettingsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["desktopFixedHeader"] = this.desktopFixedHeader;
        data["mobileFixedHeader"] = this.mobileFixedHeader;
        data["headerSkin"] = this.headerSkin;
        data["minimizeDesktopHeaderType"] = this.minimizeDesktopHeaderType;
        data["headerMenuArrows"] = this.headerMenuArrows;
        return data; 
    }
}

export interface IThemeHeaderSettingsDto {
    desktopFixedHeader: boolean;
    mobileFixedHeader: boolean;
    headerSkin: string | undefined;
    minimizeDesktopHeaderType: string | undefined;
    headerMenuArrows: boolean;
}

export class ThemeSubHeaderSettingsDto implements IThemeSubHeaderSettingsDto {
    fixedSubHeader!: boolean;
    subheaderStyle!: string | undefined;

    constructor(data?: IThemeSubHeaderSettingsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fixedSubHeader = data["fixedSubHeader"];
            this.subheaderStyle = data["subheaderStyle"];
        }
    }

    static fromJS(data: any): ThemeSubHeaderSettingsDto {
        data = typeof data === 'object' ? data : {};
        let result = new ThemeSubHeaderSettingsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fixedSubHeader"] = this.fixedSubHeader;
        data["subheaderStyle"] = this.subheaderStyle;
        return data; 
    }
}

export interface IThemeSubHeaderSettingsDto {
    fixedSubHeader: boolean;
    subheaderStyle: string | undefined;
}

export class ThemeMenuSettingsDto implements IThemeMenuSettingsDto {
    position!: string | undefined;
    asideSkin!: string | undefined;
    fixedAside!: boolean;
    allowAsideMinimizing!: boolean;
    defaultMinimizedAside!: boolean;
    submenuToggle!: string | undefined;
    searchActive!: boolean;

    constructor(data?: IThemeMenuSettingsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.position = data["position"];
            this.asideSkin = data["asideSkin"];
            this.fixedAside = data["fixedAside"];
            this.allowAsideMinimizing = data["allowAsideMinimizing"];
            this.defaultMinimizedAside = data["defaultMinimizedAside"];
            this.submenuToggle = data["submenuToggle"];
            this.searchActive = data["searchActive"];
        }
    }

    static fromJS(data: any): ThemeMenuSettingsDto {
        data = typeof data === 'object' ? data : {};
        let result = new ThemeMenuSettingsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["position"] = this.position;
        data["asideSkin"] = this.asideSkin;
        data["fixedAside"] = this.fixedAside;
        data["allowAsideMinimizing"] = this.allowAsideMinimizing;
        data["defaultMinimizedAside"] = this.defaultMinimizedAside;
        data["submenuToggle"] = this.submenuToggle;
        data["searchActive"] = this.searchActive;
        return data; 
    }
}

export interface IThemeMenuSettingsDto {
    position: string | undefined;
    asideSkin: string | undefined;
    fixedAside: boolean;
    allowAsideMinimizing: boolean;
    defaultMinimizedAside: boolean;
    submenuToggle: string | undefined;
    searchActive: boolean;
}

export class ThemeFooterSettingsDto implements IThemeFooterSettingsDto {
    fixedFooter!: boolean;

    constructor(data?: IThemeFooterSettingsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fixedFooter = data["fixedFooter"];
        }
    }

    static fromJS(data: any): ThemeFooterSettingsDto {
        data = typeof data === 'object' ? data : {};
        let result = new ThemeFooterSettingsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fixedFooter"] = this.fixedFooter;
        return data; 
    }
}

export interface IThemeFooterSettingsDto {
    fixedFooter: boolean;
}

export class ThemeSettingsDto implements IThemeSettingsDto {
    theme!: string | undefined;
    layout!: ThemeLayoutSettingsDto | undefined;
    header!: ThemeHeaderSettingsDto | undefined;
    subHeader!: ThemeSubHeaderSettingsDto | undefined;
    menu!: ThemeMenuSettingsDto | undefined;
    footer!: ThemeFooterSettingsDto | undefined;

    constructor(data?: IThemeSettingsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.theme = data["theme"];
            this.layout = data["layout"] ? ThemeLayoutSettingsDto.fromJS(data["layout"]) : <any>undefined;
            this.header = data["header"] ? ThemeHeaderSettingsDto.fromJS(data["header"]) : <any>undefined;
            this.subHeader = data["subHeader"] ? ThemeSubHeaderSettingsDto.fromJS(data["subHeader"]) : <any>undefined;
            this.menu = data["menu"] ? ThemeMenuSettingsDto.fromJS(data["menu"]) : <any>undefined;
            this.footer = data["footer"] ? ThemeFooterSettingsDto.fromJS(data["footer"]) : <any>undefined;
        }
    }

    static fromJS(data: any): ThemeSettingsDto {
        data = typeof data === 'object' ? data : {};
        let result = new ThemeSettingsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["theme"] = this.theme;
        data["layout"] = this.layout ? this.layout.toJSON() : <any>undefined;
        data["header"] = this.header ? this.header.toJSON() : <any>undefined;
        data["subHeader"] = this.subHeader ? this.subHeader.toJSON() : <any>undefined;
        data["menu"] = this.menu ? this.menu.toJSON() : <any>undefined;
        data["footer"] = this.footer ? this.footer.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IThemeSettingsDto {
    theme: string | undefined;
    layout: ThemeLayoutSettingsDto | undefined;
    header: ThemeHeaderSettingsDto | undefined;
    subHeader: ThemeSubHeaderSettingsDto | undefined;
    menu: ThemeMenuSettingsDto | undefined;
    footer: ThemeFooterSettingsDto | undefined;
}

export class UiCustomizationSettingsDto implements IUiCustomizationSettingsDto {
    baseSettings!: ThemeSettingsDto | undefined;
    isLeftMenuUsed!: boolean;
    isTopMenuUsed!: boolean;
    isTabMenuUsed!: boolean;
    allowMenuScroll!: boolean;

    constructor(data?: IUiCustomizationSettingsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.baseSettings = data["baseSettings"] ? ThemeSettingsDto.fromJS(data["baseSettings"]) : <any>undefined;
            this.isLeftMenuUsed = data["isLeftMenuUsed"];
            this.isTopMenuUsed = data["isTopMenuUsed"];
            this.isTabMenuUsed = data["isTabMenuUsed"];
            this.allowMenuScroll = data["allowMenuScroll"];
        }
    }

    static fromJS(data: any): UiCustomizationSettingsDto {
        data = typeof data === 'object' ? data : {};
        let result = new UiCustomizationSettingsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["baseSettings"] = this.baseSettings ? this.baseSettings.toJSON() : <any>undefined;
        data["isLeftMenuUsed"] = this.isLeftMenuUsed;
        data["isTopMenuUsed"] = this.isTopMenuUsed;
        data["isTabMenuUsed"] = this.isTabMenuUsed;
        data["allowMenuScroll"] = this.allowMenuScroll;
        return data; 
    }
}

export interface IUiCustomizationSettingsDto {
    baseSettings: ThemeSettingsDto | undefined;
    isLeftMenuUsed: boolean;
    isTopMenuUsed: boolean;
    isTabMenuUsed: boolean;
    allowMenuScroll: boolean;
}

export class GetCurrentLoginInformationsOutput implements IGetCurrentLoginInformationsOutput {
    user!: UserLoginInfoDto | undefined;
    tenant!: TenantLoginInfoDto | undefined;
    application!: ApplicationInfoDto | undefined;
    theme!: UiCustomizationSettingsDto | undefined;

    constructor(data?: IGetCurrentLoginInformationsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserLoginInfoDto.fromJS(data["user"]) : <any>undefined;
            this.tenant = data["tenant"] ? TenantLoginInfoDto.fromJS(data["tenant"]) : <any>undefined;
            this.application = data["application"] ? ApplicationInfoDto.fromJS(data["application"]) : <any>undefined;
            this.theme = data["theme"] ? UiCustomizationSettingsDto.fromJS(data["theme"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetCurrentLoginInformationsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetCurrentLoginInformationsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["tenant"] = this.tenant ? this.tenant.toJSON() : <any>undefined;
        data["application"] = this.application ? this.application.toJSON() : <any>undefined;
        data["theme"] = this.theme ? this.theme.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetCurrentLoginInformationsOutput {
    user: UserLoginInfoDto | undefined;
    tenant: TenantLoginInfoDto | undefined;
    application: ApplicationInfoDto | undefined;
    theme: UiCustomizationSettingsDto | undefined;
}

export class UpdateUserSignInTokenOutput implements IUpdateUserSignInTokenOutput {
    signInToken!: string | undefined;
    encodedUserId!: string | undefined;
    encodedTenantId!: string | undefined;

    constructor(data?: IUpdateUserSignInTokenOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.signInToken = data["signInToken"];
            this.encodedUserId = data["encodedUserId"];
            this.encodedTenantId = data["encodedTenantId"];
        }
    }

    static fromJS(data: any): UpdateUserSignInTokenOutput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateUserSignInTokenOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["signInToken"] = this.signInToken;
        data["encodedUserId"] = this.encodedUserId;
        data["encodedTenantId"] = this.encodedTenantId;
        return data; 
    }
}

export interface IUpdateUserSignInTokenOutput {
    signInToken: string | undefined;
    encodedUserId: string | undefined;
    encodedTenantId: string | undefined;
}

export class PagedResultDtoOfShippingPackageListDto implements IPagedResultDtoOfShippingPackageListDto {
    totalCount!: number;
    items!: ShippingPackageListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfShippingPackageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ShippingPackageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfShippingPackageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfShippingPackageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfShippingPackageListDto {
    totalCount: number;
    items: ShippingPackageListDto[] | undefined;
}

export class CreateShippingPackageInput implements ICreateShippingPackageInput {
    name!: string;

    constructor(data?: ICreateShippingPackageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CreateShippingPackageInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateShippingPackageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface ICreateShippingPackageInput {
    name: string;
}

export class UpdateShippingPackageInput implements IUpdateShippingPackageInput {
    id!: number;
    name!: string | undefined;

    constructor(data?: IUpdateShippingPackageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): UpdateShippingPackageInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateShippingPackageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IUpdateShippingPackageInput {
    id: number;
    name: string | undefined;
}

export class CreateOrUpdateStatusForActionInputDto implements ICreateOrUpdateStatusForActionInputDto {
    roleId!: number;
    actionType!: string | undefined;
    orderStatusTypeId!: number;

    constructor(data?: ICreateOrUpdateStatusForActionInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.roleId = data["roleId"];
            this.actionType = data["actionType"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
        }
    }

    static fromJS(data: any): CreateOrUpdateStatusForActionInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateStatusForActionInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["roleId"] = this.roleId;
        data["actionType"] = this.actionType;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        return data; 
    }
}

export interface ICreateOrUpdateStatusForActionInputDto {
    roleId: number;
    actionType: string | undefined;
    orderStatusTypeId: number;
}

export class GetOrderStatusForActionsListItemDto implements IGetOrderStatusForActionsListItemDto {
    action!: string | undefined;
    orderStatusTypeId!: number;
    orderStatusType!: string | undefined;

    constructor(data?: IGetOrderStatusForActionsListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.action = data["action"];
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderStatusType = data["orderStatusType"];
        }
    }

    static fromJS(data: any): GetOrderStatusForActionsListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderStatusForActionsListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["action"] = this.action;
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderStatusType"] = this.orderStatusType;
        return data; 
    }
}

export interface IGetOrderStatusForActionsListItemDto {
    action: string | undefined;
    orderStatusTypeId: number;
    orderStatusType: string | undefined;
}

export class PagedResultDtoOfGetOrderStatusForActionsListItemDto implements IPagedResultDtoOfGetOrderStatusForActionsListItemDto {
    totalCount!: number;
    items!: GetOrderStatusForActionsListItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderStatusForActionsListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderStatusForActionsListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderStatusForActionsListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderStatusForActionsListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderStatusForActionsListItemDto {
    totalCount: number;
    items: GetOrderStatusForActionsListItemDto[] | undefined;
}

export class GetOrderStatusListForRoleListItemDto implements IGetOrderStatusListForRoleListItemDto {
    orderStatusTypeId!: number;
    orderStatusType!: string | undefined;
    isChecked!: boolean;

    constructor(data?: IGetOrderStatusListForRoleListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.orderStatusType = data["orderStatusType"];
            this.isChecked = data["isChecked"];
        }
    }

    static fromJS(data: any): GetOrderStatusListForRoleListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderStatusListForRoleListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["orderStatusType"] = this.orderStatusType;
        data["isChecked"] = this.isChecked;
        return data; 
    }
}

export interface IGetOrderStatusListForRoleListItemDto {
    orderStatusTypeId: number;
    orderStatusType: string | undefined;
    isChecked: boolean;
}

export class PagedResultDtoOfGetOrderStatusListForRoleListItemDto implements IPagedResultDtoOfGetOrderStatusListForRoleListItemDto {
    totalCount!: number;
    items!: GetOrderStatusListForRoleListItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetOrderStatusListForRoleListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetOrderStatusListForRoleListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetOrderStatusListForRoleListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetOrderStatusListForRoleListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetOrderStatusListForRoleListItemDto {
    totalCount: number;
    items: GetOrderStatusListForRoleListItemDto[] | undefined;
}

export class CreateClinicRoutesInput implements ICreateClinicRoutesInput {
    etaStart!: moment.Moment;
    etaEnd!: moment.Moment;

    constructor(data?: ICreateClinicRoutesInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.etaStart = data["etaStart"] ? moment(data["etaStart"].toString()) : <any>undefined;
            this.etaEnd = data["etaEnd"] ? moment(data["etaEnd"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateClinicRoutesInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateClinicRoutesInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["etaStart"] = this.etaStart ? this.etaStart.toISOString() : <any>undefined;
        data["etaEnd"] = this.etaEnd ? this.etaEnd.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ICreateClinicRoutesInput {
    etaStart: moment.Moment;
    etaEnd: moment.Moment;
}

export class CreatePickupInput implements ICreatePickupInput {
    firstName!: string | undefined;
    lastName!: string | undefined;
    address1!: string | undefined;
    address2!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    postalCode!: string | undefined;
    country!: string | undefined;
    pickupDate!: moment.Moment;

    constructor(data?: ICreatePickupInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.address1 = data["address1"];
            this.address2 = data["address2"];
            this.city = data["city"];
            this.state = data["state"];
            this.postalCode = data["postalCode"];
            this.country = data["country"];
            this.pickupDate = data["pickupDate"] ? moment(data["pickupDate"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): CreatePickupInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreatePickupInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["address1"] = this.address1;
        data["address2"] = this.address2;
        data["city"] = this.city;
        data["state"] = this.state;
        data["postalCode"] = this.postalCode;
        data["country"] = this.country;
        data["pickupDate"] = this.pickupDate ? this.pickupDate.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ICreatePickupInput {
    firstName: string | undefined;
    lastName: string | undefined;
    address1: string | undefined;
    address2: string | undefined;
    city: string | undefined;
    state: string | undefined;
    postalCode: string | undefined;
    country: string | undefined;
    pickupDate: moment.Moment;
}

export class CreateOrderPackageInputDto implements ICreateOrderPackageInputDto {
    packageId!: number;
    quantity!: number;

    constructor(data?: ICreateOrderPackageInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.packageId = data["packageId"];
            this.quantity = data["quantity"];
        }
    }

    static fromJS(data: any): CreateOrderPackageInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderPackageInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["packageId"] = this.packageId;
        data["quantity"] = this.quantity;
        return data; 
    }
}

export interface ICreateOrderPackageInputDto {
    packageId: number;
    quantity: number;
}

export class CreateOrderLabelInputDto implements ICreateOrderLabelInputDto {
    tagTypeId!: number;
    name!: string | undefined;

    constructor(data?: ICreateOrderLabelInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tagTypeId = data["tagTypeId"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CreateOrderLabelInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderLabelInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tagTypeId"] = this.tagTypeId;
        data["name"] = this.name;
        return data; 
    }
}

export interface ICreateOrderLabelInputDto {
    tagTypeId: number;
    name: string | undefined;
}

export class CreateDeliveryInput implements ICreateDeliveryInput {
    firstName!: string | undefined;
    lastName!: string | undefined;
    address1!: string | undefined;
    address2!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    postalCode!: string | undefined;
    country!: string | undefined;
    deliveryDate!: moment.Moment;
    packages!: CreateOrderPackageInputDto[] | undefined;
    labels!: CreateOrderLabelInputDto[] | undefined;

    constructor(data?: ICreateDeliveryInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.firstName = data["firstName"];
            this.lastName = data["lastName"];
            this.address1 = data["address1"];
            this.address2 = data["address2"];
            this.city = data["city"];
            this.state = data["state"];
            this.postalCode = data["postalCode"];
            this.country = data["country"];
            this.deliveryDate = data["deliveryDate"] ? moment(data["deliveryDate"].toString()) : <any>undefined;
            if (Array.isArray(data["packages"])) {
                this.packages = [] as any;
                for (let item of data["packages"])
                    this.packages!.push(CreateOrderPackageInputDto.fromJS(item));
            }
            if (Array.isArray(data["labels"])) {
                this.labels = [] as any;
                for (let item of data["labels"])
                    this.labels!.push(CreateOrderLabelInputDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateDeliveryInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateDeliveryInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["firstName"] = this.firstName;
        data["lastName"] = this.lastName;
        data["address1"] = this.address1;
        data["address2"] = this.address2;
        data["city"] = this.city;
        data["state"] = this.state;
        data["postalCode"] = this.postalCode;
        data["country"] = this.country;
        data["deliveryDate"] = this.deliveryDate ? this.deliveryDate.toISOString() : <any>undefined;
        if (Array.isArray(this.packages)) {
            data["packages"] = [];
            for (let item of this.packages)
                data["packages"].push(item.toJSON());
        }
        if (Array.isArray(this.labels)) {
            data["labels"] = [];
            for (let item of this.labels)
                data["labels"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateDeliveryInput {
    firstName: string | undefined;
    lastName: string | undefined;
    address1: string | undefined;
    address2: string | undefined;
    city: string | undefined;
    state: string | undefined;
    postalCode: string | undefined;
    country: string | undefined;
    deliveryDate: moment.Moment;
    packages: CreateOrderPackageInputDto[] | undefined;
    labels: CreateOrderLabelInputDto[] | undefined;
}

export class SmsAccountDto implements ISmsAccountDto {
    active!: boolean;
    account!: string | undefined;
    accountSid!: string | undefined;
    authToken!: string | undefined;
    senderNumber!: string | undefined;
    id!: number;

    constructor(data?: ISmsAccountDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.active = data["active"];
            this.account = data["account"];
            this.accountSid = data["accountSid"];
            this.authToken = data["authToken"];
            this.senderNumber = data["senderNumber"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SmsAccountDto {
        data = typeof data === 'object' ? data : {};
        let result = new SmsAccountDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["active"] = this.active;
        data["account"] = this.account;
        data["accountSid"] = this.accountSid;
        data["authToken"] = this.authToken;
        data["senderNumber"] = this.senderNumber;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISmsAccountDto {
    active: boolean;
    account: string | undefined;
    accountSid: string | undefined;
    authToken: string | undefined;
    senderNumber: string | undefined;
    id: number;
}

export class GetSmsAccountForViewDto implements IGetSmsAccountForViewDto {
    smsAccount!: SmsAccountDto | undefined;

    constructor(data?: IGetSmsAccountForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.smsAccount = data["smsAccount"] ? SmsAccountDto.fromJS(data["smsAccount"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetSmsAccountForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetSmsAccountForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["smsAccount"] = this.smsAccount ? this.smsAccount.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetSmsAccountForViewDto {
    smsAccount: SmsAccountDto | undefined;
}

export class PagedResultDtoOfGetSmsAccountForViewDto implements IPagedResultDtoOfGetSmsAccountForViewDto {
    totalCount!: number;
    items!: GetSmsAccountForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetSmsAccountForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetSmsAccountForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetSmsAccountForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetSmsAccountForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetSmsAccountForViewDto {
    totalCount: number;
    items: GetSmsAccountForViewDto[] | undefined;
}

export class CreateOrEditSmsAccountDto implements ICreateOrEditSmsAccountDto {
    active!: boolean;
    account!: string | undefined;
    accountSid!: string | undefined;
    authToken!: string | undefined;
    senderNumber!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditSmsAccountDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.active = data["active"];
            this.account = data["account"];
            this.accountSid = data["accountSid"];
            this.authToken = data["authToken"];
            this.senderNumber = data["senderNumber"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditSmsAccountDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditSmsAccountDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["active"] = this.active;
        data["account"] = this.account;
        data["accountSid"] = this.accountSid;
        data["authToken"] = this.authToken;
        data["senderNumber"] = this.senderNumber;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditSmsAccountDto {
    active: boolean;
    account: string | undefined;
    accountSid: string | undefined;
    authToken: string | undefined;
    senderNumber: string | undefined;
    id: number | undefined;
}

export class GetSmsAccountForEditOutput implements IGetSmsAccountForEditOutput {
    smsAccount!: CreateOrEditSmsAccountDto | undefined;

    constructor(data?: IGetSmsAccountForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.smsAccount = data["smsAccount"] ? CreateOrEditSmsAccountDto.fromJS(data["smsAccount"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetSmsAccountForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetSmsAccountForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["smsAccount"] = this.smsAccount ? this.smsAccount.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetSmsAccountForEditOutput {
    smsAccount: CreateOrEditSmsAccountDto | undefined;
}

export class SmsTemplateDto implements ISmsTemplateDto {
    description!: string | undefined;
    template!: string | undefined;
    isActive!: boolean;
    code!: string | undefined;
    smsAccountId!: number | undefined;
    id!: number;

    constructor(data?: ISmsTemplateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.template = data["template"];
            this.isActive = data["isActive"];
            this.code = data["code"];
            this.smsAccountId = data["smsAccountId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SmsTemplateDto {
        data = typeof data === 'object' ? data : {};
        let result = new SmsTemplateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["template"] = this.template;
        data["isActive"] = this.isActive;
        data["code"] = this.code;
        data["smsAccountId"] = this.smsAccountId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISmsTemplateDto {
    description: string | undefined;
    template: string | undefined;
    isActive: boolean;
    code: string | undefined;
    smsAccountId: number | undefined;
    id: number;
}

export class GetSmsTemplateForViewDto implements IGetSmsTemplateForViewDto {
    smsTemplate!: SmsTemplateDto | undefined;
    smsAccountAccount!: string | undefined;

    constructor(data?: IGetSmsTemplateForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.smsTemplate = data["smsTemplate"] ? SmsTemplateDto.fromJS(data["smsTemplate"]) : <any>undefined;
            this.smsAccountAccount = data["smsAccountAccount"];
        }
    }

    static fromJS(data: any): GetSmsTemplateForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetSmsTemplateForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["smsTemplate"] = this.smsTemplate ? this.smsTemplate.toJSON() : <any>undefined;
        data["smsAccountAccount"] = this.smsAccountAccount;
        return data; 
    }
}

export interface IGetSmsTemplateForViewDto {
    smsTemplate: SmsTemplateDto | undefined;
    smsAccountAccount: string | undefined;
}

export class PagedResultDtoOfGetSmsTemplateForViewDto implements IPagedResultDtoOfGetSmsTemplateForViewDto {
    totalCount!: number;
    items!: GetSmsTemplateForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetSmsTemplateForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetSmsTemplateForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetSmsTemplateForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetSmsTemplateForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetSmsTemplateForViewDto {
    totalCount: number;
    items: GetSmsTemplateForViewDto[] | undefined;
}

export class CreateOrEditSmsTemplateDto implements ICreateOrEditSmsTemplateDto {
    description!: string | undefined;
    template!: string | undefined;
    isActive!: boolean;
    code!: string | undefined;
    smsAccountId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditSmsTemplateDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.template = data["template"];
            this.isActive = data["isActive"];
            this.code = data["code"];
            this.smsAccountId = data["smsAccountId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditSmsTemplateDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditSmsTemplateDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["template"] = this.template;
        data["isActive"] = this.isActive;
        data["code"] = this.code;
        data["smsAccountId"] = this.smsAccountId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditSmsTemplateDto {
    description: string | undefined;
    template: string | undefined;
    isActive: boolean;
    code: string | undefined;
    smsAccountId: number | undefined;
    id: number | undefined;
}

export class GetSmsTemplateForEditOutput implements IGetSmsTemplateForEditOutput {
    smsTemplate!: CreateOrEditSmsTemplateDto | undefined;
    smsAccountAccount!: string | undefined;

    constructor(data?: IGetSmsTemplateForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.smsTemplate = data["smsTemplate"] ? CreateOrEditSmsTemplateDto.fromJS(data["smsTemplate"]) : <any>undefined;
            this.smsAccountAccount = data["smsAccountAccount"];
        }
    }

    static fromJS(data: any): GetSmsTemplateForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetSmsTemplateForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["smsTemplate"] = this.smsTemplate ? this.smsTemplate.toJSON() : <any>undefined;
        data["smsAccountAccount"] = this.smsAccountAccount;
        return data; 
    }
}

export interface IGetSmsTemplateForEditOutput {
    smsTemplate: CreateOrEditSmsTemplateDto | undefined;
    smsAccountAccount: string | undefined;
}

export class SmsTemplateSmsAccountLookupTableDto implements ISmsTemplateSmsAccountLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: ISmsTemplateSmsAccountLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): SmsTemplateSmsAccountLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new SmsTemplateSmsAccountLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ISmsTemplateSmsAccountLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class SortingRuleListDto implements ISortingRuleListDto {
    tenantId!: number;
    name!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    lastModifierUserId!: number | undefined;
    creationTime!: moment.Moment;
    creatorUserId!: number | undefined;
    id!: number;

    constructor(data?: ISortingRuleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.lastModifierUserId = data["lastModifierUserId"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.creatorUserId = data["creatorUserId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SortingRuleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new SortingRuleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["lastModifierUserId"] = this.lastModifierUserId;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["creatorUserId"] = this.creatorUserId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISortingRuleListDto {
    tenantId: number;
    name: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    lastModifierUserId: number | undefined;
    creationTime: moment.Moment;
    creatorUserId: number | undefined;
    id: number;
}

export class ListResultDtoOfSortingRuleListDto implements IListResultDtoOfSortingRuleListDto {
    items!: SortingRuleListDto[] | undefined;

    constructor(data?: IListResultDtoOfSortingRuleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SortingRuleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfSortingRuleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfSortingRuleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfSortingRuleListDto {
    items: SortingRuleListDto[] | undefined;
}

export class CreateSortingRuleInput implements ICreateSortingRuleInput {
    name!: string;

    constructor(data?: ICreateSortingRuleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CreateSortingRuleInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateSortingRuleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface ICreateSortingRuleInput {
    name: string;
}

export class UpdateSortingRuleInput implements IUpdateSortingRuleInput {
    id!: number;
    name!: string;

    constructor(data?: IUpdateSortingRuleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): UpdateSortingRuleInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateSortingRuleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IUpdateSortingRuleInput {
    id: number;
    name: string;
}

export class GetStatResultListItemDto implements IGetStatResultListItemDto {
    label!: string | undefined;
    value!: number;
    sortOrder!: number;
    color!: string | undefined;

    constructor(data?: IGetStatResultListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.label = data["label"];
            this.value = data["value"];
            this.sortOrder = data["sortOrder"];
            this.color = data["color"];
        }
    }

    static fromJS(data: any): GetStatResultListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetStatResultListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["label"] = this.label;
        data["value"] = this.value;
        data["sortOrder"] = this.sortOrder;
        data["color"] = this.color;
        return data; 
    }
}

export interface IGetStatResultListItemDto {
    label: string | undefined;
    value: number;
    sortOrder: number;
    color: string | undefined;
}

export class GetStatResultDto implements IGetStatResultDto {
    total!: number;
    items!: GetStatResultListItemDto[] | undefined;

    constructor(data?: IGetStatResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.total = data["total"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetStatResultListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetStatResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetStatResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["total"] = this.total;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetStatResultDto {
    total: number;
    items: GetStatResultListItemDto[] | undefined;
}

export class SLAInput implements ISLAInput {
    allLocation!: boolean;
    startDate!: moment.Moment;
    locationId!: number;

    constructor(data?: ISLAInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.allLocation = data["allLocation"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.locationId = data["locationId"];
        }
    }

    static fromJS(data: any): SLAInput {
        data = typeof data === 'object' ? data : {};
        let result = new SLAInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["allLocation"] = this.allLocation;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["locationId"] = this.locationId;
        return data; 
    }
}

export interface ISLAInput {
    allLocation: boolean;
    startDate: moment.Moment;
    locationId: number;
}

export class SLADto implements ISLADto {
    loadDate!: string | undefined;
    day!: number;
    packageCount!: number;

    constructor(data?: ISLADto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.loadDate = data["loadDate"];
            this.day = data["day"];
            this.packageCount = data["packageCount"];
        }
    }

    static fromJS(data: any): SLADto {
        data = typeof data === 'object' ? data : {};
        let result = new SLADto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["loadDate"] = this.loadDate;
        data["day"] = this.day;
        data["packageCount"] = this.packageCount;
        return data; 
    }
}

export interface ISLADto {
    loadDate: string | undefined;
    day: number;
    packageCount: number;
}

export class TotalPackagesSetForDelivery implements ITotalPackagesSetForDelivery {
    totalPackages!: string | undefined;
    setForDelivery!: SLADto[] | undefined;

    constructor(data?: ITotalPackagesSetForDelivery) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["setForDelivery"])) {
                this.setForDelivery = [] as any;
                for (let item of data["setForDelivery"])
                    this.setForDelivery!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): TotalPackagesSetForDelivery {
        data = typeof data === 'object' ? data : {};
        let result = new TotalPackagesSetForDelivery();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.setForDelivery)) {
            data["setForDelivery"] = [];
            for (let item of this.setForDelivery)
                data["setForDelivery"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ITotalPackagesSetForDelivery {
    totalPackages: string | undefined;
    setForDelivery: SLADto[] | undefined;
}

export class TotalPackagesNotPickedUp implements ITotalPackagesNotPickedUp {
    totalPackages!: string | undefined;
    notPickedUp!: SLADto[] | undefined;

    constructor(data?: ITotalPackagesNotPickedUp) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["notPickedUp"])) {
                this.notPickedUp = [] as any;
                for (let item of data["notPickedUp"])
                    this.notPickedUp!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): TotalPackagesNotPickedUp {
        data = typeof data === 'object' ? data : {};
        let result = new TotalPackagesNotPickedUp();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.notPickedUp)) {
            data["notPickedUp"] = [];
            for (let item of this.notPickedUp)
                data["notPickedUp"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ITotalPackagesNotPickedUp {
    totalPackages: string | undefined;
    notPickedUp: SLADto[] | undefined;
}

export class TotalPackagesIntransit implements ITotalPackagesIntransit {
    totalPackages!: string | undefined;
    setForIntransit!: SLADto[] | undefined;

    constructor(data?: ITotalPackagesIntransit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["setForIntransit"])) {
                this.setForIntransit = [] as any;
                for (let item of data["setForIntransit"])
                    this.setForIntransit!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): TotalPackagesIntransit {
        data = typeof data === 'object' ? data : {};
        let result = new TotalPackagesIntransit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.setForIntransit)) {
            data["setForIntransit"] = [];
            for (let item of this.setForIntransit)
                data["setForIntransit"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ITotalPackagesIntransit {
    totalPackages: string | undefined;
    setForIntransit: SLADto[] | undefined;
}

export class TotalPackagesDelivered implements ITotalPackagesDelivered {
    totalPackages!: string | undefined;
    delivered!: SLADto[] | undefined;

    constructor(data?: ITotalPackagesDelivered) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["delivered"])) {
                this.delivered = [] as any;
                for (let item of data["delivered"])
                    this.delivered!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): TotalPackagesDelivered {
        data = typeof data === 'object' ? data : {};
        let result = new TotalPackagesDelivered();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.delivered)) {
            data["delivered"] = [];
            for (let item of this.delivered)
                data["delivered"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ITotalPackagesDelivered {
    totalPackages: string | undefined;
    delivered: SLADto[] | undefined;
}

export class TotalPackagesDeliveredOnTime implements ITotalPackagesDeliveredOnTime {
    totalPackages!: string | undefined;
    deliveredOnTime!: SLADto[] | undefined;

    constructor(data?: ITotalPackagesDeliveredOnTime) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["deliveredOnTime"])) {
                this.deliveredOnTime = [] as any;
                for (let item of data["deliveredOnTime"])
                    this.deliveredOnTime!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): TotalPackagesDeliveredOnTime {
        data = typeof data === 'object' ? data : {};
        let result = new TotalPackagesDeliveredOnTime();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.deliveredOnTime)) {
            data["deliveredOnTime"] = [];
            for (let item of this.deliveredOnTime)
                data["deliveredOnTime"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ITotalPackagesDeliveredOnTime {
    totalPackages: string | undefined;
    deliveredOnTime: SLADto[] | undefined;
}

export class TotalPackagesDeliveredLate implements ITotalPackagesDeliveredLate {
    totalPackages!: string | undefined;
    deliveredLate!: SLADto[] | undefined;

    constructor(data?: ITotalPackagesDeliveredLate) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["deliveredLate"])) {
                this.deliveredLate = [] as any;
                for (let item of data["deliveredLate"])
                    this.deliveredLate!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): TotalPackagesDeliveredLate {
        data = typeof data === 'object' ? data : {};
        let result = new TotalPackagesDeliveredLate();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.deliveredLate)) {
            data["deliveredLate"] = [];
            for (let item of this.deliveredLate)
                data["deliveredLate"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ITotalPackagesDeliveredLate {
    totalPackages: string | undefined;
    deliveredLate: SLADto[] | undefined;
}

export class TotalPackagesTendered implements ITotalPackagesTendered {
    totalPackages!: string | undefined;
    packagesTendered!: SLADto[] | undefined;

    constructor(data?: ITotalPackagesTendered) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["packagesTendered"])) {
                this.packagesTendered = [] as any;
                for (let item of data["packagesTendered"])
                    this.packagesTendered!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): TotalPackagesTendered {
        data = typeof data === 'object' ? data : {};
        let result = new TotalPackagesTendered();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.packagesTendered)) {
            data["packagesTendered"] = [];
            for (let item of this.packagesTendered)
                data["packagesTendered"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ITotalPackagesTendered {
    totalPackages: string | undefined;
    packagesTendered: SLADto[] | undefined;
}

export class LatestDeliveryTimeDto implements ILatestDeliveryTimeDto {
    loadDate!: string | undefined;
    day!: number;
    latestDelivery!: string | undefined;

    constructor(data?: ILatestDeliveryTimeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.loadDate = data["loadDate"];
            this.day = data["day"];
            this.latestDelivery = data["latestDelivery"];
        }
    }

    static fromJS(data: any): LatestDeliveryTimeDto {
        data = typeof data === 'object' ? data : {};
        let result = new LatestDeliveryTimeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["loadDate"] = this.loadDate;
        data["day"] = this.day;
        data["latestDelivery"] = this.latestDelivery;
        return data; 
    }
}

export interface ILatestDeliveryTimeDto {
    loadDate: string | undefined;
    day: number;
    latestDelivery: string | undefined;
}

export class LatestDeliveryTime implements ILatestDeliveryTime {
    deliveryTime!: LatestDeliveryTimeDto[] | undefined;

    constructor(data?: ILatestDeliveryTime) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["deliveryTime"])) {
                this.deliveryTime = [] as any;
                for (let item of data["deliveryTime"])
                    this.deliveryTime!.push(LatestDeliveryTimeDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): LatestDeliveryTime {
        data = typeof data === 'object' ? data : {};
        let result = new LatestDeliveryTime();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.deliveryTime)) {
            data["deliveryTime"] = [];
            for (let item of this.deliveryTime)
                data["deliveryTime"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ILatestDeliveryTime {
    deliveryTime: LatestDeliveryTimeDto[] | undefined;
}

export class PackagesNotDelivered implements IPackagesNotDelivered {
    totalPackages!: string | undefined;
    notDelivered!: SLADto[] | undefined;

    constructor(data?: IPackagesNotDelivered) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["notDelivered"])) {
                this.notDelivered = [] as any;
                for (let item of data["notDelivered"])
                    this.notDelivered!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PackagesNotDelivered {
        data = typeof data === 'object' ? data : {};
        let result = new PackagesNotDelivered();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.notDelivered)) {
            data["notDelivered"] = [];
            for (let item of this.notDelivered)
                data["notDelivered"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPackagesNotDelivered {
    totalPackages: string | undefined;
    notDelivered: SLADto[] | undefined;
}

export class PackagesWDeliveryIssue implements IPackagesWDeliveryIssue {
    totalPackages!: string | undefined;
    deliveredIssues!: SLADto[] | undefined;

    constructor(data?: IPackagesWDeliveryIssue) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["deliveredIssues"])) {
                this.deliveredIssues = [] as any;
                for (let item of data["deliveredIssues"])
                    this.deliveredIssues!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PackagesWDeliveryIssue {
        data = typeof data === 'object' ? data : {};
        let result = new PackagesWDeliveryIssue();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.deliveredIssues)) {
            data["deliveredIssues"] = [];
            for (let item of this.deliveredIssues)
                data["deliveredIssues"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPackagesWDeliveryIssue {
    totalPackages: string | undefined;
    deliveredIssues: SLADto[] | undefined;
}

export class PackagesSetForRedelivery implements IPackagesSetForRedelivery {
    totalPackages!: string | undefined;
    setForRedelivery!: SLADto[] | undefined;

    constructor(data?: IPackagesSetForRedelivery) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalPackages = data["totalPackages"];
            if (Array.isArray(data["setForRedelivery"])) {
                this.setForRedelivery = [] as any;
                for (let item of data["setForRedelivery"])
                    this.setForRedelivery!.push(SLADto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PackagesSetForRedelivery {
        data = typeof data === 'object' ? data : {};
        let result = new PackagesSetForRedelivery();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalPackages"] = this.totalPackages;
        if (Array.isArray(this.setForRedelivery)) {
            data["setForRedelivery"] = [];
            for (let item of this.setForRedelivery)
                data["setForRedelivery"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPackagesSetForRedelivery {
    totalPackages: string | undefined;
    setForRedelivery: SLADto[] | undefined;
}

export class PercentageOnTimeDto implements IPercentageOnTimeDto {
    loadDate!: string | undefined;
    day!: number;
    percentage!: number;
    packageCount!: number;

    constructor(data?: IPercentageOnTimeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.loadDate = data["loadDate"];
            this.day = data["day"];
            this.percentage = data["percentage"];
            this.packageCount = data["packageCount"];
        }
    }

    static fromJS(data: any): PercentageOnTimeDto {
        data = typeof data === 'object' ? data : {};
        let result = new PercentageOnTimeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["loadDate"] = this.loadDate;
        data["day"] = this.day;
        data["percentage"] = this.percentage;
        data["packageCount"] = this.packageCount;
        return data; 
    }
}

export interface IPercentageOnTimeDto {
    loadDate: string | undefined;
    day: number;
    percentage: number;
    packageCount: number;
}

export class PercentageOnTime implements IPercentageOnTime {
    percentageData!: PercentageOnTimeDto[] | undefined;

    constructor(data?: IPercentageOnTime) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["percentageData"])) {
                this.percentageData = [] as any;
                for (let item of data["percentageData"])
                    this.percentageData!.push(PercentageOnTimeDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PercentageOnTime {
        data = typeof data === 'object' ? data : {};
        let result = new PercentageOnTime();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.percentageData)) {
            data["percentageData"] = [];
            for (let item of this.percentageData)
                data["percentageData"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPercentageOnTime {
    percentageData: PercentageOnTimeDto[] | undefined;
}

export class SLAOrdersInput implements ISLAOrdersInput {
    allLocation!: boolean;
    locationId!: number;
    loadDate!: moment.Moment;
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: ISLAOrdersInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.allLocation = data["allLocation"];
            this.locationId = data["locationId"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): SLAOrdersInput {
        data = typeof data === 'object' ? data : {};
        let result = new SLAOrdersInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["allLocation"] = this.allLocation;
        data["locationId"] = this.locationId;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface ISLAOrdersInput {
    allLocation: boolean;
    locationId: number;
    loadDate: moment.Moment;
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class SLAOrdersDto implements ISLAOrdersDto {
    id!: number;
    customerOrderNumber!: string | undefined;
    address!: string | undefined;
    customerName!: string | undefined;

    constructor(data?: ISLAOrdersDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.customerOrderNumber = data["customerOrderNumber"];
            this.address = data["address"];
            this.customerName = data["customerName"];
        }
    }

    static fromJS(data: any): SLAOrdersDto {
        data = typeof data === 'object' ? data : {};
        let result = new SLAOrdersDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["customerOrderNumber"] = this.customerOrderNumber;
        data["address"] = this.address;
        data["customerName"] = this.customerName;
        return data; 
    }
}

export interface ISLAOrdersDto {
    id: number;
    customerOrderNumber: string | undefined;
    address: string | undefined;
    customerName: string | undefined;
}

export class PagedResultDtoOfSLAOrdersDto implements IPagedResultDtoOfSLAOrdersDto {
    totalCount!: number;
    items!: SLAOrdersDto[] | undefined;

    constructor(data?: IPagedResultDtoOfSLAOrdersDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SLAOrdersDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfSLAOrdersDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfSLAOrdersDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfSLAOrdersDto {
    totalCount: number;
    items: SLAOrdersDto[] | undefined;
}

export class SprintStatusOrderStatusDto implements ISprintStatusOrderStatusDto {
    statusCode!: string | undefined;
    statusDescription!: string | undefined;
    time!: moment.Moment;
    geocode!: GeocodeListDto | undefined;
    note!: string | undefined;

    constructor(data?: ISprintStatusOrderStatusDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.statusCode = data["statusCode"];
            this.statusDescription = data["statusDescription"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.note = data["note"];
        }
    }

    static fromJS(data: any): SprintStatusOrderStatusDto {
        data = typeof data === 'object' ? data : {};
        let result = new SprintStatusOrderStatusDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["statusCode"] = this.statusCode;
        data["statusDescription"] = this.statusDescription;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["note"] = this.note;
        return data; 
    }
}

export interface ISprintStatusOrderStatusDto {
    statusCode: string | undefined;
    statusDescription: string | undefined;
    time: moment.Moment;
    geocode: GeocodeListDto | undefined;
    note: string | undefined;
}

export class SprintStatusListDto implements ISprintStatusListDto {
    orderId!: number;
    tagName!: string | undefined;
    orderStatus!: SprintStatusOrderStatusDto | undefined;
    eta!: moment.Moment | undefined;

    constructor(data?: ISprintStatusListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.tagName = data["tagName"];
            this.orderStatus = data["orderStatus"] ? SprintStatusOrderStatusDto.fromJS(data["orderStatus"]) : <any>undefined;
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): SprintStatusListDto {
        data = typeof data === 'object' ? data : {};
        let result = new SprintStatusListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["tagName"] = this.tagName;
        data["orderStatus"] = this.orderStatus ? this.orderStatus.toJSON() : <any>undefined;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ISprintStatusListDto {
    orderId: number;
    tagName: string | undefined;
    orderStatus: SprintStatusOrderStatusDto | undefined;
    eta: moment.Moment | undefined;
}

export class StripeConfigurationDto implements IStripeConfigurationDto {
    publishableKey!: string | undefined;

    constructor(data?: IStripeConfigurationDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.publishableKey = data["publishableKey"];
        }
    }

    static fromJS(data: any): StripeConfigurationDto {
        data = typeof data === 'object' ? data : {};
        let result = new StripeConfigurationDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["publishableKey"] = this.publishableKey;
        return data; 
    }
}

export interface IStripeConfigurationDto {
    publishableKey: string | undefined;
}

export class StripeCreatePaymentSessionInput implements IStripeCreatePaymentSessionInput {
    paymentId!: number;
    successUrl!: string | undefined;
    cancelUrl!: string | undefined;

    constructor(data?: IStripeCreatePaymentSessionInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.paymentId = data["paymentId"];
            this.successUrl = data["successUrl"];
            this.cancelUrl = data["cancelUrl"];
        }
    }

    static fromJS(data: any): StripeCreatePaymentSessionInput {
        data = typeof data === 'object' ? data : {};
        let result = new StripeCreatePaymentSessionInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["paymentId"] = this.paymentId;
        data["successUrl"] = this.successUrl;
        data["cancelUrl"] = this.cancelUrl;
        return data; 
    }
}

export interface IStripeCreatePaymentSessionInput {
    paymentId: number;
    successUrl: string | undefined;
    cancelUrl: string | undefined;
}

export class StripePaymentResultOutput implements IStripePaymentResultOutput {
    paymentDone!: boolean;

    constructor(data?: IStripePaymentResultOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.paymentDone = data["paymentDone"];
        }
    }

    static fromJS(data: any): StripePaymentResultOutput {
        data = typeof data === 'object' ? data : {};
        let result = new StripePaymentResultOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["paymentDone"] = this.paymentDone;
        return data; 
    }
}

export interface IStripePaymentResultOutput {
    paymentDone: boolean;
}

export class SupportCategoryTypesDto implements ISupportCategoryTypesDto {
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    id!: number;

    constructor(data?: ISupportCategoryTypesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportCategoryTypesDto {
        data = typeof data === 'object' ? data : {};
        let result = new SupportCategoryTypesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportCategoryTypesDto {
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    id: number;
}

export class GetSupportCategoryTypesForViewDto implements IGetSupportCategoryTypesForViewDto {
    supportCategoryTypes!: SupportCategoryTypesDto | undefined;
    mainTenant!: number | undefined;
    tenantId!: number | undefined;
    tenant!: string | undefined;

    constructor(data?: IGetSupportCategoryTypesForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.supportCategoryTypes = data["supportCategoryTypes"] ? SupportCategoryTypesDto.fromJS(data["supportCategoryTypes"]) : <any>undefined;
            this.mainTenant = data["mainTenant"];
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"];
        }
    }

    static fromJS(data: any): GetSupportCategoryTypesForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetSupportCategoryTypesForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["supportCategoryTypes"] = this.supportCategoryTypes ? this.supportCategoryTypes.toJSON() : <any>undefined;
        data["mainTenant"] = this.mainTenant;
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant;
        return data; 
    }
}

export interface IGetSupportCategoryTypesForViewDto {
    supportCategoryTypes: SupportCategoryTypesDto | undefined;
    mainTenant: number | undefined;
    tenantId: number | undefined;
    tenant: string | undefined;
}

export class PagedResultDtoOfGetSupportCategoryTypesForViewDto implements IPagedResultDtoOfGetSupportCategoryTypesForViewDto {
    totalCount!: number;
    items!: GetSupportCategoryTypesForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetSupportCategoryTypesForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetSupportCategoryTypesForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetSupportCategoryTypesForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetSupportCategoryTypesForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetSupportCategoryTypesForViewDto {
    totalCount: number;
    items: GetSupportCategoryTypesForViewDto[] | undefined;
}

export class CreateOrEditSupportCategoryTypesDto implements ICreateOrEditSupportCategoryTypesDto {
    code!: string;
    description!: string;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    id!: number | undefined;

    constructor(data?: ICreateOrEditSupportCategoryTypesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditSupportCategoryTypesDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditSupportCategoryTypesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditSupportCategoryTypesDto {
    code: string;
    description: string;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    id: number | undefined;
}

export class GetSupportCategoryTypesForEditOutput implements IGetSupportCategoryTypesForEditOutput {
    supportCategoryTypes!: CreateOrEditSupportCategoryTypesDto | undefined;

    constructor(data?: IGetSupportCategoryTypesForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.supportCategoryTypes = data["supportCategoryTypes"] ? CreateOrEditSupportCategoryTypesDto.fromJS(data["supportCategoryTypes"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetSupportCategoryTypesForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetSupportCategoryTypesForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["supportCategoryTypes"] = this.supportCategoryTypes ? this.supportCategoryTypes.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetSupportCategoryTypesForEditOutput {
    supportCategoryTypes: CreateOrEditSupportCategoryTypesDto | undefined;
}

export class GetTicketForEdit implements IGetTicketForEdit {
    parentId!: number | undefined;
    assignedToId!: number | undefined;
    testerUserId!: number | undefined;
    tester!: string | undefined;
    ticketTypeId!: number | undefined;
    ticketTypeCode!: string | undefined;
    ticketStatusId!: number | undefined;
    ticketStatus!: string | undefined;
    ticketType!: string | undefined;
    ticketStatusCode!: string | undefined;
    ticketStatusPublic!: boolean;
    shortDescription!: string | undefined;
    assigned!: string | undefined;
    description!: string | undefined;
    rootCause!: string | undefined;
    solution!: string | undefined;
    environment!: string | undefined;
    priority!: number | undefined;
    startDate!: moment.Moment;
    dueDate!: moment.Moment;
    effortHour!: number;
    categoryId!: number[] | undefined;
    createdDateTimeString!: string | undefined;
    creatorName!: string | undefined;
    versionId!: number | undefined;
    versionString!: string | undefined;
    versionDate!: moment.Moment | undefined;
    managerId!: number | undefined;
    developerId!: number | undefined;
    technicalSupportId!: number | undefined;
    parentTicketId!: number | undefined;
    organizationalUnitId!: number | undefined;
    manager!: string | undefined;
    developer!: string | undefined;
    technicalSupport!: string | undefined;
    organizationalUnit!: string | undefined;
    lastNote!: string | undefined;

    constructor(data?: IGetTicketForEdit) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parentId = data["parentId"];
            this.assignedToId = data["assignedToId"];
            this.testerUserId = data["testerUserId"];
            this.tester = data["tester"];
            this.ticketTypeId = data["ticketTypeId"];
            this.ticketTypeCode = data["ticketTypeCode"];
            this.ticketStatusId = data["ticketStatusId"];
            this.ticketStatus = data["ticketStatus"];
            this.ticketType = data["ticketType"];
            this.ticketStatusCode = data["ticketStatusCode"];
            this.ticketStatusPublic = data["ticketStatusPublic"];
            this.shortDescription = data["shortDescription"];
            this.assigned = data["assigned"];
            this.description = data["description"];
            this.rootCause = data["rootCause"];
            this.solution = data["solution"];
            this.environment = data["environment"];
            this.priority = data["priority"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.dueDate = data["dueDate"] ? moment(data["dueDate"].toString()) : <any>undefined;
            this.effortHour = data["effortHour"];
            if (Array.isArray(data["categoryId"])) {
                this.categoryId = [] as any;
                for (let item of data["categoryId"])
                    this.categoryId!.push(item);
            }
            this.createdDateTimeString = data["createdDateTimeString"];
            this.creatorName = data["creatorName"];
            this.versionId = data["versionId"];
            this.versionString = data["versionString"];
            this.versionDate = data["versionDate"] ? moment(data["versionDate"].toString()) : <any>undefined;
            this.managerId = data["managerId"];
            this.developerId = data["developerId"];
            this.technicalSupportId = data["technicalSupportId"];
            this.parentTicketId = data["parentTicketId"];
            this.organizationalUnitId = data["organizationalUnitId"];
            this.manager = data["manager"];
            this.developer = data["developer"];
            this.technicalSupport = data["technicalSupport"];
            this.organizationalUnit = data["organizationalUnit"];
            this.lastNote = data["lastNote"];
        }
    }

    static fromJS(data: any): GetTicketForEdit {
        data = typeof data === 'object' ? data : {};
        let result = new GetTicketForEdit();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parentId"] = this.parentId;
        data["assignedToId"] = this.assignedToId;
        data["testerUserId"] = this.testerUserId;
        data["tester"] = this.tester;
        data["ticketTypeId"] = this.ticketTypeId;
        data["ticketTypeCode"] = this.ticketTypeCode;
        data["ticketStatusId"] = this.ticketStatusId;
        data["ticketStatus"] = this.ticketStatus;
        data["ticketType"] = this.ticketType;
        data["ticketStatusCode"] = this.ticketStatusCode;
        data["ticketStatusPublic"] = this.ticketStatusPublic;
        data["shortDescription"] = this.shortDescription;
        data["assigned"] = this.assigned;
        data["description"] = this.description;
        data["rootCause"] = this.rootCause;
        data["solution"] = this.solution;
        data["environment"] = this.environment;
        data["priority"] = this.priority;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["dueDate"] = this.dueDate ? this.dueDate.toISOString() : <any>undefined;
        data["effortHour"] = this.effortHour;
        if (Array.isArray(this.categoryId)) {
            data["categoryId"] = [];
            for (let item of this.categoryId)
                data["categoryId"].push(item);
        }
        data["createdDateTimeString"] = this.createdDateTimeString;
        data["creatorName"] = this.creatorName;
        data["versionId"] = this.versionId;
        data["versionString"] = this.versionString;
        data["versionDate"] = this.versionDate ? this.versionDate.toISOString() : <any>undefined;
        data["managerId"] = this.managerId;
        data["developerId"] = this.developerId;
        data["technicalSupportId"] = this.technicalSupportId;
        data["parentTicketId"] = this.parentTicketId;
        data["organizationalUnitId"] = this.organizationalUnitId;
        data["manager"] = this.manager;
        data["developer"] = this.developer;
        data["technicalSupport"] = this.technicalSupport;
        data["organizationalUnit"] = this.organizationalUnit;
        data["lastNote"] = this.lastNote;
        return data; 
    }
}

export interface IGetTicketForEdit {
    parentId: number | undefined;
    assignedToId: number | undefined;
    testerUserId: number | undefined;
    tester: string | undefined;
    ticketTypeId: number | undefined;
    ticketTypeCode: string | undefined;
    ticketStatusId: number | undefined;
    ticketStatus: string | undefined;
    ticketType: string | undefined;
    ticketStatusCode: string | undefined;
    ticketStatusPublic: boolean;
    shortDescription: string | undefined;
    assigned: string | undefined;
    description: string | undefined;
    rootCause: string | undefined;
    solution: string | undefined;
    environment: string | undefined;
    priority: number | undefined;
    startDate: moment.Moment;
    dueDate: moment.Moment;
    effortHour: number;
    categoryId: number[] | undefined;
    createdDateTimeString: string | undefined;
    creatorName: string | undefined;
    versionId: number | undefined;
    versionString: string | undefined;
    versionDate: moment.Moment | undefined;
    managerId: number | undefined;
    developerId: number | undefined;
    technicalSupportId: number | undefined;
    parentTicketId: number | undefined;
    organizationalUnitId: number | undefined;
    manager: string | undefined;
    developer: string | undefined;
    technicalSupport: string | undefined;
    organizationalUnit: string | undefined;
    lastNote: string | undefined;
}

export class TicketKPI implements ITicketKPI {
    totalTicket!: number;
    totalAllTicket!: number;
    totalNewTicket!: number;
    totalAssignedTicket!: number;
    totalUnAssignedTicket!: number;
    totalCloseTicket!: number;
    totalCloseTicketToday!: number;
    totalFeatureChangeTicket!: number;
    totalRequestTicket!: number;
    totalIssueOrBugTicket!: number;
    totalNewFeatureTicket!: number;
    totalMyTicket!: number;
    totalMyCreateTicket!: number;
    totalUrgentTicket!: number;

    constructor(data?: ITicketKPI) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalTicket = data["totalTicket"];
            this.totalAllTicket = data["totalAllTicket"];
            this.totalNewTicket = data["totalNewTicket"];
            this.totalAssignedTicket = data["totalAssignedTicket"];
            this.totalUnAssignedTicket = data["totalUnAssignedTicket"];
            this.totalCloseTicket = data["totalCloseTicket"];
            this.totalCloseTicketToday = data["totalCloseTicketToday"];
            this.totalFeatureChangeTicket = data["totalFeatureChangeTicket"];
            this.totalRequestTicket = data["totalRequestTicket"];
            this.totalIssueOrBugTicket = data["totalIssueOrBugTicket"];
            this.totalNewFeatureTicket = data["totalNewFeatureTicket"];
            this.totalMyTicket = data["totalMyTicket"];
            this.totalMyCreateTicket = data["totalMyCreateTicket"];
            this.totalUrgentTicket = data["totalUrgentTicket"];
        }
    }

    static fromJS(data: any): TicketKPI {
        data = typeof data === 'object' ? data : {};
        let result = new TicketKPI();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalTicket"] = this.totalTicket;
        data["totalAllTicket"] = this.totalAllTicket;
        data["totalNewTicket"] = this.totalNewTicket;
        data["totalAssignedTicket"] = this.totalAssignedTicket;
        data["totalUnAssignedTicket"] = this.totalUnAssignedTicket;
        data["totalCloseTicket"] = this.totalCloseTicket;
        data["totalCloseTicketToday"] = this.totalCloseTicketToday;
        data["totalFeatureChangeTicket"] = this.totalFeatureChangeTicket;
        data["totalRequestTicket"] = this.totalRequestTicket;
        data["totalIssueOrBugTicket"] = this.totalIssueOrBugTicket;
        data["totalNewFeatureTicket"] = this.totalNewFeatureTicket;
        data["totalMyTicket"] = this.totalMyTicket;
        data["totalMyCreateTicket"] = this.totalMyCreateTicket;
        data["totalUrgentTicket"] = this.totalUrgentTicket;
        return data; 
    }
}

export interface ITicketKPI {
    totalTicket: number;
    totalAllTicket: number;
    totalNewTicket: number;
    totalAssignedTicket: number;
    totalUnAssignedTicket: number;
    totalCloseTicket: number;
    totalCloseTicketToday: number;
    totalFeatureChangeTicket: number;
    totalRequestTicket: number;
    totalIssueOrBugTicket: number;
    totalNewFeatureTicket: number;
    totalMyTicket: number;
    totalMyCreateTicket: number;
    totalUrgentTicket: number;
}

export class AttachmentList implements IAttachmentList {
    id!: number;
    ticketId!: number;
    data!: string | undefined;
    fileName!: string | undefined;

    constructor(data?: IAttachmentList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.ticketId = data["ticketId"];
            this.data = data["data"];
            this.fileName = data["fileName"];
        }
    }

    static fromJS(data: any): AttachmentList {
        data = typeof data === 'object' ? data : {};
        let result = new AttachmentList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["ticketId"] = this.ticketId;
        data["data"] = this.data;
        data["fileName"] = this.fileName;
        return data; 
    }
}

export interface IAttachmentList {
    id: number;
    ticketId: number;
    data: string | undefined;
    fileName: string | undefined;
}

export class ListResultDtoOfAttachmentList implements IListResultDtoOfAttachmentList {
    items!: AttachmentList[] | undefined;

    constructor(data?: IListResultDtoOfAttachmentList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(AttachmentList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfAttachmentList {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfAttachmentList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfAttachmentList {
    items: AttachmentList[] | undefined;
}

export class NoteList implements INoteList {
    id!: number;
    creatorUserId!: number | undefined;
    creator!: string | undefined;
    ticketId!: number | undefined;
    notes!: string | undefined;
    creationTime!: moment.Moment;

    constructor(data?: INoteList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.creatorUserId = data["creatorUserId"];
            this.creator = data["creator"];
            this.ticketId = data["ticketId"];
            this.notes = data["notes"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): NoteList {
        data = typeof data === 'object' ? data : {};
        let result = new NoteList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["creatorUserId"] = this.creatorUserId;
        data["creator"] = this.creator;
        data["ticketId"] = this.ticketId;
        data["notes"] = this.notes;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface INoteList {
    id: number;
    creatorUserId: number | undefined;
    creator: string | undefined;
    ticketId: number | undefined;
    notes: string | undefined;
    creationTime: moment.Moment;
}

export class ListResultDtoOfNoteList implements IListResultDtoOfNoteList {
    items!: NoteList[] | undefined;

    constructor(data?: IListResultDtoOfNoteList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(NoteList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfNoteList {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfNoteList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfNoteList {
    items: NoteList[] | undefined;
}

export class GetSupportTicketUsersInput implements IGetSupportTicketUsersInput {
    filter!: string | undefined;
    id!: number | undefined;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetSupportTicketUsersInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.filter = data["filter"];
            this.id = data["id"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetSupportTicketUsersInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetSupportTicketUsersInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["filter"] = this.filter;
        data["id"] = this.id;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetSupportTicketUsersInput {
    filter: string | undefined;
    id: number | undefined;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class GetTicketInput implements IGetTicketInput {
    filter!: string | undefined;
    assignedToFilter!: string | undefined;
    tester!: string | undefined;
    statusFilter!: string | undefined;
    statusFilterCode!: string[] | undefined;
    typeFilter!: string | undefined;
    typeFilterCode!: string[] | undefined;
    createdFrom!: string | undefined;
    createdTo!: string | undefined;
    createdBy!: string | undefined;
    priority!: number[] | undefined;
    tenantId!: number[] | undefined;
    parentStatusTypeId!: number;
    parentStatusTypeIds!: number[] | undefined;
    categoryTypeId!: number[] | undefined;
    organizationUnitId!: number | undefined;
    todayFilter!: string | undefined;
    myTicketsFilter!: string | undefined;
    openTicketFilter!: string | undefined;
    startDate!: moment.Moment;
    dueDate!: moment.Moment;
    effortHour!: number;
    versionId!: number | undefined;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetTicketInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.filter = data["filter"];
            this.assignedToFilter = data["assignedToFilter"];
            this.tester = data["tester"];
            this.statusFilter = data["statusFilter"];
            if (Array.isArray(data["statusFilterCode"])) {
                this.statusFilterCode = [] as any;
                for (let item of data["statusFilterCode"])
                    this.statusFilterCode!.push(item);
            }
            this.typeFilter = data["typeFilter"];
            if (Array.isArray(data["typeFilterCode"])) {
                this.typeFilterCode = [] as any;
                for (let item of data["typeFilterCode"])
                    this.typeFilterCode!.push(item);
            }
            this.createdFrom = data["createdFrom"];
            this.createdTo = data["createdTo"];
            this.createdBy = data["createdBy"];
            if (Array.isArray(data["priority"])) {
                this.priority = [] as any;
                for (let item of data["priority"])
                    this.priority!.push(item);
            }
            if (Array.isArray(data["tenantId"])) {
                this.tenantId = [] as any;
                for (let item of data["tenantId"])
                    this.tenantId!.push(item);
            }
            this.parentStatusTypeId = data["parentStatusTypeId"];
            if (Array.isArray(data["parentStatusTypeIds"])) {
                this.parentStatusTypeIds = [] as any;
                for (let item of data["parentStatusTypeIds"])
                    this.parentStatusTypeIds!.push(item);
            }
            if (Array.isArray(data["categoryTypeId"])) {
                this.categoryTypeId = [] as any;
                for (let item of data["categoryTypeId"])
                    this.categoryTypeId!.push(item);
            }
            this.organizationUnitId = data["organizationUnitId"];
            this.todayFilter = data["todayFilter"];
            this.myTicketsFilter = data["myTicketsFilter"];
            this.openTicketFilter = data["openTicketFilter"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.dueDate = data["dueDate"] ? moment(data["dueDate"].toString()) : <any>undefined;
            this.effortHour = data["effortHour"];
            this.versionId = data["versionId"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetTicketInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetTicketInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["filter"] = this.filter;
        data["assignedToFilter"] = this.assignedToFilter;
        data["tester"] = this.tester;
        data["statusFilter"] = this.statusFilter;
        if (Array.isArray(this.statusFilterCode)) {
            data["statusFilterCode"] = [];
            for (let item of this.statusFilterCode)
                data["statusFilterCode"].push(item);
        }
        data["typeFilter"] = this.typeFilter;
        if (Array.isArray(this.typeFilterCode)) {
            data["typeFilterCode"] = [];
            for (let item of this.typeFilterCode)
                data["typeFilterCode"].push(item);
        }
        data["createdFrom"] = this.createdFrom;
        data["createdTo"] = this.createdTo;
        data["createdBy"] = this.createdBy;
        if (Array.isArray(this.priority)) {
            data["priority"] = [];
            for (let item of this.priority)
                data["priority"].push(item);
        }
        if (Array.isArray(this.tenantId)) {
            data["tenantId"] = [];
            for (let item of this.tenantId)
                data["tenantId"].push(item);
        }
        data["parentStatusTypeId"] = this.parentStatusTypeId;
        if (Array.isArray(this.parentStatusTypeIds)) {
            data["parentStatusTypeIds"] = [];
            for (let item of this.parentStatusTypeIds)
                data["parentStatusTypeIds"].push(item);
        }
        if (Array.isArray(this.categoryTypeId)) {
            data["categoryTypeId"] = [];
            for (let item of this.categoryTypeId)
                data["categoryTypeId"].push(item);
        }
        data["organizationUnitId"] = this.organizationUnitId;
        data["todayFilter"] = this.todayFilter;
        data["myTicketsFilter"] = this.myTicketsFilter;
        data["openTicketFilter"] = this.openTicketFilter;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["dueDate"] = this.dueDate ? this.dueDate.toISOString() : <any>undefined;
        data["effortHour"] = this.effortHour;
        data["versionId"] = this.versionId;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetTicketInput {
    filter: string | undefined;
    assignedToFilter: string | undefined;
    tester: string | undefined;
    statusFilter: string | undefined;
    statusFilterCode: string[] | undefined;
    typeFilter: string | undefined;
    typeFilterCode: string[] | undefined;
    createdFrom: string | undefined;
    createdTo: string | undefined;
    createdBy: string | undefined;
    priority: number[] | undefined;
    tenantId: number[] | undefined;
    parentStatusTypeId: number;
    parentStatusTypeIds: number[] | undefined;
    categoryTypeId: number[] | undefined;
    organizationUnitId: number | undefined;
    todayFilter: string | undefined;
    myTicketsFilter: string | undefined;
    openTicketFilter: string | undefined;
    startDate: moment.Moment;
    dueDate: moment.Moment;
    effortHour: number;
    versionId: number | undefined;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class CategoryTypes implements ICategoryTypes {
    id!: number | undefined;
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;

    constructor(data?: ICategoryTypes) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
        }
    }

    static fromJS(data: any): CategoryTypes {
        data = typeof data === 'object' ? data : {};
        let result = new CategoryTypes();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        return data; 
    }
}

export interface ICategoryTypes {
    id: number | undefined;
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
}

export class TicketList implements ITicketList {
    id!: number | undefined;
    description!: string | undefined;
    shortDescription!: string | undefined;
    tenantId!: number | undefined;
    tenant!: string | undefined;
    assignedToId!: number | undefined;
    testerUserId!: number | undefined;
    tester!: string | undefined;
    ticketTypeId!: number | undefined;
    ticketStatusId!: number | undefined;
    assignedTo!: string | undefined;
    ticketType!: string | undefined;
    ticketTypeCode!: string | undefined;
    ticketTypeColor!: string | undefined;
    ticketTypeIcon!: string | undefined;
    ticketStatus!: string | undefined;
    ticketStatusCode!: string | undefined;
    ticketStatusColor!: string | undefined;
    ticketStatusIcon!: string | undefined;
    createdBy!: string | undefined;
    dateCreated!: moment.Moment;
    dateCreatedDisplay!: string | undefined;
    environment!: string | undefined;
    lastModificationTime!: moment.Moment | undefined;
    modifiedBy!: string | undefined;
    mainTenant!: number | undefined;
    parentStatusTypeId!: number;
    priority!: string | undefined;
    categoryTypes!: CategoryTypes[] | undefined;
    rootCause!: string | undefined;
    solution!: string | undefined;
    parentStatus!: string | undefined;
    lastModificationTimeString!: string | undefined;
    categories!: string | undefined;
    startDate!: moment.Moment;
    startDateDisplay!: string | undefined;
    dueDate!: moment.Moment;
    dueDateDisplay!: string | undefined;
    effortHour!: number;
    version!: string | undefined;
    releasedDate!: moment.Moment | undefined;
    releasedDateDisplay!: string | undefined;
    manager!: string | undefined;
    developer!: string | undefined;
    technicalSupport!: string | undefined;
    organizationalUnit!: string | undefined;
    parentTicketId!: number | undefined;
    completionRate!: string | undefined;
    progress!: number | undefined;

    constructor(data?: ITicketList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.description = data["description"];
            this.shortDescription = data["shortDescription"];
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"];
            this.assignedToId = data["assignedToId"];
            this.testerUserId = data["testerUserId"];
            this.tester = data["tester"];
            this.ticketTypeId = data["ticketTypeId"];
            this.ticketStatusId = data["ticketStatusId"];
            this.assignedTo = data["assignedTo"];
            this.ticketType = data["ticketType"];
            this.ticketTypeCode = data["ticketTypeCode"];
            this.ticketTypeColor = data["ticketTypeColor"];
            this.ticketTypeIcon = data["ticketTypeIcon"];
            this.ticketStatus = data["ticketStatus"];
            this.ticketStatusCode = data["ticketStatusCode"];
            this.ticketStatusColor = data["ticketStatusColor"];
            this.ticketStatusIcon = data["ticketStatusIcon"];
            this.createdBy = data["createdBy"];
            this.dateCreated = data["dateCreated"] ? moment(data["dateCreated"].toString()) : <any>undefined;
            this.dateCreatedDisplay = data["dateCreatedDisplay"];
            this.environment = data["environment"];
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
            this.modifiedBy = data["modifiedBy"];
            this.mainTenant = data["mainTenant"];
            this.parentStatusTypeId = data["parentStatusTypeId"];
            this.priority = data["priority"];
            if (Array.isArray(data["categoryTypes"])) {
                this.categoryTypes = [] as any;
                for (let item of data["categoryTypes"])
                    this.categoryTypes!.push(CategoryTypes.fromJS(item));
            }
            this.rootCause = data["rootCause"];
            this.solution = data["solution"];
            this.parentStatus = data["parentStatus"];
            this.lastModificationTimeString = data["lastModificationTimeString"];
            this.categories = data["categories"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.startDateDisplay = data["startDateDisplay"];
            this.dueDate = data["dueDate"] ? moment(data["dueDate"].toString()) : <any>undefined;
            this.dueDateDisplay = data["dueDateDisplay"];
            this.effortHour = data["effortHour"];
            this.version = data["version"];
            this.releasedDate = data["releasedDate"] ? moment(data["releasedDate"].toString()) : <any>undefined;
            this.releasedDateDisplay = data["releasedDateDisplay"];
            this.manager = data["manager"];
            this.developer = data["developer"];
            this.technicalSupport = data["technicalSupport"];
            this.organizationalUnit = data["organizationalUnit"];
            this.parentTicketId = data["parentTicketId"];
            this.completionRate = data["completionRate"];
            this.progress = data["progress"];
        }
    }

    static fromJS(data: any): TicketList {
        data = typeof data === 'object' ? data : {};
        let result = new TicketList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["description"] = this.description;
        data["shortDescription"] = this.shortDescription;
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant;
        data["assignedToId"] = this.assignedToId;
        data["testerUserId"] = this.testerUserId;
        data["tester"] = this.tester;
        data["ticketTypeId"] = this.ticketTypeId;
        data["ticketStatusId"] = this.ticketStatusId;
        data["assignedTo"] = this.assignedTo;
        data["ticketType"] = this.ticketType;
        data["ticketTypeCode"] = this.ticketTypeCode;
        data["ticketTypeColor"] = this.ticketTypeColor;
        data["ticketTypeIcon"] = this.ticketTypeIcon;
        data["ticketStatus"] = this.ticketStatus;
        data["ticketStatusCode"] = this.ticketStatusCode;
        data["ticketStatusColor"] = this.ticketStatusColor;
        data["ticketStatusIcon"] = this.ticketStatusIcon;
        data["createdBy"] = this.createdBy;
        data["dateCreated"] = this.dateCreated ? this.dateCreated.toISOString() : <any>undefined;
        data["dateCreatedDisplay"] = this.dateCreatedDisplay;
        data["environment"] = this.environment;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        data["modifiedBy"] = this.modifiedBy;
        data["mainTenant"] = this.mainTenant;
        data["parentStatusTypeId"] = this.parentStatusTypeId;
        data["priority"] = this.priority;
        if (Array.isArray(this.categoryTypes)) {
            data["categoryTypes"] = [];
            for (let item of this.categoryTypes)
                data["categoryTypes"].push(item.toJSON());
        }
        data["rootCause"] = this.rootCause;
        data["solution"] = this.solution;
        data["parentStatus"] = this.parentStatus;
        data["lastModificationTimeString"] = this.lastModificationTimeString;
        data["categories"] = this.categories;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["startDateDisplay"] = this.startDateDisplay;
        data["dueDate"] = this.dueDate ? this.dueDate.toISOString() : <any>undefined;
        data["dueDateDisplay"] = this.dueDateDisplay;
        data["effortHour"] = this.effortHour;
        data["version"] = this.version;
        data["releasedDate"] = this.releasedDate ? this.releasedDate.toISOString() : <any>undefined;
        data["releasedDateDisplay"] = this.releasedDateDisplay;
        data["manager"] = this.manager;
        data["developer"] = this.developer;
        data["technicalSupport"] = this.technicalSupport;
        data["organizationalUnit"] = this.organizationalUnit;
        data["parentTicketId"] = this.parentTicketId;
        data["completionRate"] = this.completionRate;
        data["progress"] = this.progress;
        return data; 
    }
}

export interface ITicketList {
    id: number | undefined;
    description: string | undefined;
    shortDescription: string | undefined;
    tenantId: number | undefined;
    tenant: string | undefined;
    assignedToId: number | undefined;
    testerUserId: number | undefined;
    tester: string | undefined;
    ticketTypeId: number | undefined;
    ticketStatusId: number | undefined;
    assignedTo: string | undefined;
    ticketType: string | undefined;
    ticketTypeCode: string | undefined;
    ticketTypeColor: string | undefined;
    ticketTypeIcon: string | undefined;
    ticketStatus: string | undefined;
    ticketStatusCode: string | undefined;
    ticketStatusColor: string | undefined;
    ticketStatusIcon: string | undefined;
    createdBy: string | undefined;
    dateCreated: moment.Moment;
    dateCreatedDisplay: string | undefined;
    environment: string | undefined;
    lastModificationTime: moment.Moment | undefined;
    modifiedBy: string | undefined;
    mainTenant: number | undefined;
    parentStatusTypeId: number;
    priority: string | undefined;
    categoryTypes: CategoryTypes[] | undefined;
    rootCause: string | undefined;
    solution: string | undefined;
    parentStatus: string | undefined;
    lastModificationTimeString: string | undefined;
    categories: string | undefined;
    startDate: moment.Moment;
    startDateDisplay: string | undefined;
    dueDate: moment.Moment;
    dueDateDisplay: string | undefined;
    effortHour: number;
    version: string | undefined;
    releasedDate: moment.Moment | undefined;
    releasedDateDisplay: string | undefined;
    manager: string | undefined;
    developer: string | undefined;
    technicalSupport: string | undefined;
    organizationalUnit: string | undefined;
    parentTicketId: number | undefined;
    completionRate: string | undefined;
    progress: number | undefined;
}

export class PagedResultDtoOfTicketList implements IPagedResultDtoOfTicketList {
    totalCount!: number;
    items!: TicketList[] | undefined;

    constructor(data?: IPagedResultDtoOfTicketList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TicketList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfTicketList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfTicketList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfTicketList {
    totalCount: number;
    items: TicketList[] | undefined;
}

export class UpdateTicketTenant implements IUpdateTicketTenant {
    tenantId!: number;
    ticketId!: number;

    constructor(data?: IUpdateTicketTenant) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.ticketId = data["ticketId"];
        }
    }

    static fromJS(data: any): UpdateTicketTenant {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateTicketTenant();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["ticketId"] = this.ticketId;
        return data; 
    }
}

export interface IUpdateTicketTenant {
    tenantId: number;
    ticketId: number;
}

export class CreateAttachments implements ICreateAttachments {
    fileName!: string | undefined;
    base64EncodedData!: string | undefined;
    ticketId!: number | undefined;

    constructor(data?: ICreateAttachments) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.fileName = data["fileName"];
            this.base64EncodedData = data["base64EncodedData"];
            this.ticketId = data["ticketId"];
        }
    }

    static fromJS(data: any): CreateAttachments {
        data = typeof data === 'object' ? data : {};
        let result = new CreateAttachments();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["fileName"] = this.fileName;
        data["base64EncodedData"] = this.base64EncodedData;
        data["ticketId"] = this.ticketId;
        return data; 
    }
}

export interface ICreateAttachments {
    fileName: string | undefined;
    base64EncodedData: string | undefined;
    ticketId: number | undefined;
}

export class CreateNotes implements ICreateNotes {
    ticketId!: number | undefined;
    notes!: string | undefined;
    creator!: string | undefined;
    creationTime!: moment.Moment;

    constructor(data?: ICreateNotes) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.ticketId = data["ticketId"];
            this.notes = data["notes"];
            this.creator = data["creator"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateNotes {
        data = typeof data === 'object' ? data : {};
        let result = new CreateNotes();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["ticketId"] = this.ticketId;
        data["notes"] = this.notes;
        data["creator"] = this.creator;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ICreateNotes {
    ticketId: number | undefined;
    notes: string | undefined;
    creator: string | undefined;
    creationTime: moment.Moment;
}

export class UpdateTicketDto implements IUpdateTicketDto {
    id!: number;
    assignedToId!: number | undefined;
    testerUserId!: number | undefined;
    tester!: string | undefined;
    ticketTypeId!: number;
    ticketStatusId!: number;
    shortDescription!: string | undefined;
    assigned!: string | undefined;
    description!: string | undefined;
    rootCause!: string | undefined;
    solution!: string | undefined;
    environment!: string | undefined;
    priority!: number;
    createAttachments!: CreateAttachments[] | undefined;
    categoryTypeId!: number[] | undefined;
    startDate!: moment.Moment;
    dueDate!: moment.Moment;
    effortHour!: number;
    versionId!: number | undefined;
    managerId!: number | undefined;
    developerId!: number | undefined;
    technicalSupportId!: number | undefined;
    parentTicketId!: number | undefined;
    organizationalUnitId!: number | undefined;
    manager!: string | undefined;
    developer!: string | undefined;
    technicalSupport!: string | undefined;
    organizationalUnit!: string | undefined;

    constructor(data?: IUpdateTicketDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.assignedToId = data["assignedToId"];
            this.testerUserId = data["testerUserId"];
            this.tester = data["tester"];
            this.ticketTypeId = data["ticketTypeId"];
            this.ticketStatusId = data["ticketStatusId"];
            this.shortDescription = data["shortDescription"];
            this.assigned = data["assigned"];
            this.description = data["description"];
            this.rootCause = data["rootCause"];
            this.solution = data["solution"];
            this.environment = data["environment"];
            this.priority = data["priority"];
            if (Array.isArray(data["createAttachments"])) {
                this.createAttachments = [] as any;
                for (let item of data["createAttachments"])
                    this.createAttachments!.push(CreateAttachments.fromJS(item));
            }
            if (Array.isArray(data["categoryTypeId"])) {
                this.categoryTypeId = [] as any;
                for (let item of data["categoryTypeId"])
                    this.categoryTypeId!.push(item);
            }
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.dueDate = data["dueDate"] ? moment(data["dueDate"].toString()) : <any>undefined;
            this.effortHour = data["effortHour"];
            this.versionId = data["versionId"];
            this.managerId = data["managerId"];
            this.developerId = data["developerId"];
            this.technicalSupportId = data["technicalSupportId"];
            this.parentTicketId = data["parentTicketId"];
            this.organizationalUnitId = data["organizationalUnitId"];
            this.manager = data["manager"];
            this.developer = data["developer"];
            this.technicalSupport = data["technicalSupport"];
            this.organizationalUnit = data["organizationalUnit"];
        }
    }

    static fromJS(data: any): UpdateTicketDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateTicketDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["assignedToId"] = this.assignedToId;
        data["testerUserId"] = this.testerUserId;
        data["tester"] = this.tester;
        data["ticketTypeId"] = this.ticketTypeId;
        data["ticketStatusId"] = this.ticketStatusId;
        data["shortDescription"] = this.shortDescription;
        data["assigned"] = this.assigned;
        data["description"] = this.description;
        data["rootCause"] = this.rootCause;
        data["solution"] = this.solution;
        data["environment"] = this.environment;
        data["priority"] = this.priority;
        if (Array.isArray(this.createAttachments)) {
            data["createAttachments"] = [];
            for (let item of this.createAttachments)
                data["createAttachments"].push(item.toJSON());
        }
        if (Array.isArray(this.categoryTypeId)) {
            data["categoryTypeId"] = [];
            for (let item of this.categoryTypeId)
                data["categoryTypeId"].push(item);
        }
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["dueDate"] = this.dueDate ? this.dueDate.toISOString() : <any>undefined;
        data["effortHour"] = this.effortHour;
        data["versionId"] = this.versionId;
        data["managerId"] = this.managerId;
        data["developerId"] = this.developerId;
        data["technicalSupportId"] = this.technicalSupportId;
        data["parentTicketId"] = this.parentTicketId;
        data["organizationalUnitId"] = this.organizationalUnitId;
        data["manager"] = this.manager;
        data["developer"] = this.developer;
        data["technicalSupport"] = this.technicalSupport;
        data["organizationalUnit"] = this.organizationalUnit;
        return data; 
    }
}

export interface IUpdateTicketDto {
    id: number;
    assignedToId: number | undefined;
    testerUserId: number | undefined;
    tester: string | undefined;
    ticketTypeId: number;
    ticketStatusId: number;
    shortDescription: string | undefined;
    assigned: string | undefined;
    description: string | undefined;
    rootCause: string | undefined;
    solution: string | undefined;
    environment: string | undefined;
    priority: number;
    createAttachments: CreateAttachments[] | undefined;
    categoryTypeId: number[] | undefined;
    startDate: moment.Moment;
    dueDate: moment.Moment;
    effortHour: number;
    versionId: number | undefined;
    managerId: number | undefined;
    developerId: number | undefined;
    technicalSupportId: number | undefined;
    parentTicketId: number | undefined;
    organizationalUnitId: number | undefined;
    manager: string | undefined;
    developer: string | undefined;
    technicalSupport: string | undefined;
    organizationalUnit: string | undefined;
}

export class CreateTicketDto implements ICreateTicketDto {
    tenantId!: number | undefined;
    parentId!: number | undefined;
    assignedToId!: number | undefined;
    testerUserId!: number | undefined;
    tester!: string | undefined;
    managerId!: number | undefined;
    developerId!: number | undefined;
    technicalSupportId!: number | undefined;
    parentTicketId!: number | undefined;
    organizationalUnitId!: number | undefined;
    manager!: string | undefined;
    developer!: string | undefined;
    technicalSupport!: string | undefined;
    organizationalUnit!: string | undefined;
    ticketTypeId!: number;
    ticketStatusId!: number;
    shortDescription!: string | undefined;
    assigned!: string | undefined;
    creator!: string | undefined;
    description!: string | undefined;
    rootCause!: string | undefined;
    solution!: string | undefined;
    environment!: string | undefined;
    priority!: number;
    createAttachments!: CreateAttachments[] | undefined;
    createNotes!: CreateNotes[] | undefined;
    categoryTypeId!: number[] | undefined;
    startDate!: moment.Moment;
    dueDate!: moment.Moment;
    effortHour!: number;
    versionId!: number | undefined;

    constructor(data?: ICreateTicketDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.parentId = data["parentId"];
            this.assignedToId = data["assignedToId"];
            this.testerUserId = data["testerUserId"];
            this.tester = data["tester"];
            this.managerId = data["managerId"];
            this.developerId = data["developerId"];
            this.technicalSupportId = data["technicalSupportId"];
            this.parentTicketId = data["parentTicketId"];
            this.organizationalUnitId = data["organizationalUnitId"];
            this.manager = data["manager"];
            this.developer = data["developer"];
            this.technicalSupport = data["technicalSupport"];
            this.organizationalUnit = data["organizationalUnit"];
            this.ticketTypeId = data["ticketTypeId"];
            this.ticketStatusId = data["ticketStatusId"];
            this.shortDescription = data["shortDescription"];
            this.assigned = data["assigned"];
            this.creator = data["creator"];
            this.description = data["description"];
            this.rootCause = data["rootCause"];
            this.solution = data["solution"];
            this.environment = data["environment"];
            this.priority = data["priority"];
            if (Array.isArray(data["createAttachments"])) {
                this.createAttachments = [] as any;
                for (let item of data["createAttachments"])
                    this.createAttachments!.push(CreateAttachments.fromJS(item));
            }
            if (Array.isArray(data["createNotes"])) {
                this.createNotes = [] as any;
                for (let item of data["createNotes"])
                    this.createNotes!.push(CreateNotes.fromJS(item));
            }
            if (Array.isArray(data["categoryTypeId"])) {
                this.categoryTypeId = [] as any;
                for (let item of data["categoryTypeId"])
                    this.categoryTypeId!.push(item);
            }
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.dueDate = data["dueDate"] ? moment(data["dueDate"].toString()) : <any>undefined;
            this.effortHour = data["effortHour"];
            this.versionId = data["versionId"];
        }
    }

    static fromJS(data: any): CreateTicketDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateTicketDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["parentId"] = this.parentId;
        data["assignedToId"] = this.assignedToId;
        data["testerUserId"] = this.testerUserId;
        data["tester"] = this.tester;
        data["managerId"] = this.managerId;
        data["developerId"] = this.developerId;
        data["technicalSupportId"] = this.technicalSupportId;
        data["parentTicketId"] = this.parentTicketId;
        data["organizationalUnitId"] = this.organizationalUnitId;
        data["manager"] = this.manager;
        data["developer"] = this.developer;
        data["technicalSupport"] = this.technicalSupport;
        data["organizationalUnit"] = this.organizationalUnit;
        data["ticketTypeId"] = this.ticketTypeId;
        data["ticketStatusId"] = this.ticketStatusId;
        data["shortDescription"] = this.shortDescription;
        data["assigned"] = this.assigned;
        data["creator"] = this.creator;
        data["description"] = this.description;
        data["rootCause"] = this.rootCause;
        data["solution"] = this.solution;
        data["environment"] = this.environment;
        data["priority"] = this.priority;
        if (Array.isArray(this.createAttachments)) {
            data["createAttachments"] = [];
            for (let item of this.createAttachments)
                data["createAttachments"].push(item.toJSON());
        }
        if (Array.isArray(this.createNotes)) {
            data["createNotes"] = [];
            for (let item of this.createNotes)
                data["createNotes"].push(item.toJSON());
        }
        if (Array.isArray(this.categoryTypeId)) {
            data["categoryTypeId"] = [];
            for (let item of this.categoryTypeId)
                data["categoryTypeId"].push(item);
        }
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["dueDate"] = this.dueDate ? this.dueDate.toISOString() : <any>undefined;
        data["effortHour"] = this.effortHour;
        data["versionId"] = this.versionId;
        return data; 
    }
}

export interface ICreateTicketDto {
    tenantId: number | undefined;
    parentId: number | undefined;
    assignedToId: number | undefined;
    testerUserId: number | undefined;
    tester: string | undefined;
    managerId: number | undefined;
    developerId: number | undefined;
    technicalSupportId: number | undefined;
    parentTicketId: number | undefined;
    organizationalUnitId: number | undefined;
    manager: string | undefined;
    developer: string | undefined;
    technicalSupport: string | undefined;
    organizationalUnit: string | undefined;
    ticketTypeId: number;
    ticketStatusId: number;
    shortDescription: string | undefined;
    assigned: string | undefined;
    creator: string | undefined;
    description: string | undefined;
    rootCause: string | undefined;
    solution: string | undefined;
    environment: string | undefined;
    priority: number;
    createAttachments: CreateAttachments[] | undefined;
    createNotes: CreateNotes[] | undefined;
    categoryTypeId: number[] | undefined;
    startDate: moment.Moment;
    dueDate: moment.Moment;
    effortHour: number;
    versionId: number | undefined;
}

export class SupportTicketNotificationRecipientsDto implements ISupportTicketNotificationRecipientsDto {
    isEmail!: boolean;
    isSMS!: boolean;
    isActive!: boolean;
    emailAddress!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    userId!: number | undefined;
    supportTicketNotificationId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketNotificationRecipientsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEmail = data["isEmail"];
            this.isSMS = data["isSMS"];
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.userId = data["userId"];
            this.supportTicketNotificationId = data["supportTicketNotificationId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationRecipientsDto {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationRecipientsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEmail"] = this.isEmail;
        data["isSMS"] = this.isSMS;
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["userId"] = this.userId;
        data["supportTicketNotificationId"] = this.supportTicketNotificationId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketNotificationRecipientsDto {
    isEmail: boolean;
    isSMS: boolean;
    isActive: boolean;
    emailAddress: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    userId: number | undefined;
    supportTicketNotificationId: number | undefined;
    id: number;
}

export class GetSupportTicketNotificationRecipientsForViewDto implements IGetSupportTicketNotificationRecipientsForViewDto {
    supportTicketNotificationRecipients!: SupportTicketNotificationRecipientsDto | undefined;
    organizationUnitDisplayName!: string | undefined;
    userName!: string | undefined;
    supportTicketNotificationDescription!: string | undefined;

    constructor(data?: IGetSupportTicketNotificationRecipientsForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.supportTicketNotificationRecipients = data["supportTicketNotificationRecipients"] ? SupportTicketNotificationRecipientsDto.fromJS(data["supportTicketNotificationRecipients"]) : <any>undefined;
            this.organizationUnitDisplayName = data["organizationUnitDisplayName"];
            this.userName = data["userName"];
            this.supportTicketNotificationDescription = data["supportTicketNotificationDescription"];
        }
    }

    static fromJS(data: any): GetSupportTicketNotificationRecipientsForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetSupportTicketNotificationRecipientsForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["supportTicketNotificationRecipients"] = this.supportTicketNotificationRecipients ? this.supportTicketNotificationRecipients.toJSON() : <any>undefined;
        data["organizationUnitDisplayName"] = this.organizationUnitDisplayName;
        data["userName"] = this.userName;
        data["supportTicketNotificationDescription"] = this.supportTicketNotificationDescription;
        return data; 
    }
}

export interface IGetSupportTicketNotificationRecipientsForViewDto {
    supportTicketNotificationRecipients: SupportTicketNotificationRecipientsDto | undefined;
    organizationUnitDisplayName: string | undefined;
    userName: string | undefined;
    supportTicketNotificationDescription: string | undefined;
}

export class PagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto implements IPagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto {
    totalCount!: number;
    items!: GetSupportTicketNotificationRecipientsForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetSupportTicketNotificationRecipientsForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetSupportTicketNotificationRecipientsForViewDto {
    totalCount: number;
    items: GetSupportTicketNotificationRecipientsForViewDto[] | undefined;
}

export class CreateOrEditSupportTicketNotificationRecipientsDto implements ICreateOrEditSupportTicketNotificationRecipientsDto {
    isEmail!: boolean;
    isSMS!: boolean;
    isActive!: boolean;
    emailAddress!: string | undefined;
    code!: string | undefined;
    organizationUnitId!: number | undefined;
    userId!: number | undefined;
    supportTicketNotificationId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditSupportTicketNotificationRecipientsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isEmail = data["isEmail"];
            this.isSMS = data["isSMS"];
            this.isActive = data["isActive"];
            this.emailAddress = data["emailAddress"];
            this.code = data["code"];
            this.organizationUnitId = data["organizationUnitId"];
            this.userId = data["userId"];
            this.supportTicketNotificationId = data["supportTicketNotificationId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditSupportTicketNotificationRecipientsDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditSupportTicketNotificationRecipientsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isEmail"] = this.isEmail;
        data["isSMS"] = this.isSMS;
        data["isActive"] = this.isActive;
        data["emailAddress"] = this.emailAddress;
        data["code"] = this.code;
        data["organizationUnitId"] = this.organizationUnitId;
        data["userId"] = this.userId;
        data["supportTicketNotificationId"] = this.supportTicketNotificationId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditSupportTicketNotificationRecipientsDto {
    isEmail: boolean;
    isSMS: boolean;
    isActive: boolean;
    emailAddress: string | undefined;
    code: string | undefined;
    organizationUnitId: number | undefined;
    userId: number | undefined;
    supportTicketNotificationId: number | undefined;
    id: number | undefined;
}

export class GetSupportTicketNotificationRecipientsForEditOutput implements IGetSupportTicketNotificationRecipientsForEditOutput {
    supportTicketNotificationRecipients!: CreateOrEditSupportTicketNotificationRecipientsDto | undefined;
    organizationUnitDisplayName!: string | undefined;
    userName!: string | undefined;
    supportTicketNotificationDescription!: string | undefined;

    constructor(data?: IGetSupportTicketNotificationRecipientsForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.supportTicketNotificationRecipients = data["supportTicketNotificationRecipients"] ? CreateOrEditSupportTicketNotificationRecipientsDto.fromJS(data["supportTicketNotificationRecipients"]) : <any>undefined;
            this.organizationUnitDisplayName = data["organizationUnitDisplayName"];
            this.userName = data["userName"];
            this.supportTicketNotificationDescription = data["supportTicketNotificationDescription"];
        }
    }

    static fromJS(data: any): GetSupportTicketNotificationRecipientsForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetSupportTicketNotificationRecipientsForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["supportTicketNotificationRecipients"] = this.supportTicketNotificationRecipients ? this.supportTicketNotificationRecipients.toJSON() : <any>undefined;
        data["organizationUnitDisplayName"] = this.organizationUnitDisplayName;
        data["userName"] = this.userName;
        data["supportTicketNotificationDescription"] = this.supportTicketNotificationDescription;
        return data; 
    }
}

export interface IGetSupportTicketNotificationRecipientsForEditOutput {
    supportTicketNotificationRecipients: CreateOrEditSupportTicketNotificationRecipientsDto | undefined;
    organizationUnitDisplayName: string | undefined;
    userName: string | undefined;
    supportTicketNotificationDescription: string | undefined;
}

export class SupportTicketNotificationRecipientsOrganizationUnitLookupTableDto implements ISupportTicketNotificationRecipientsOrganizationUnitLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: ISupportTicketNotificationRecipientsOrganizationUnitLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationRecipientsOrganizationUnitLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationRecipientsOrganizationUnitLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ISupportTicketNotificationRecipientsOrganizationUnitLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto implements IPagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto {
    totalCount!: number;
    items!: SupportTicketNotificationRecipientsOrganizationUnitLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SupportTicketNotificationRecipientsOrganizationUnitLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfSupportTicketNotificationRecipientsOrganizationUnitLookupTableDto {
    totalCount: number;
    items: SupportTicketNotificationRecipientsOrganizationUnitLookupTableDto[] | undefined;
}

export class SupportTicketNotificationRecipientsUserLookupTableDto implements ISupportTicketNotificationRecipientsUserLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: ISupportTicketNotificationRecipientsUserLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationRecipientsUserLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationRecipientsUserLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ISupportTicketNotificationRecipientsUserLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto implements IPagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto {
    totalCount!: number;
    items!: SupportTicketNotificationRecipientsUserLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SupportTicketNotificationRecipientsUserLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfSupportTicketNotificationRecipientsUserLookupTableDto {
    totalCount: number;
    items: SupportTicketNotificationRecipientsUserLookupTableDto[] | undefined;
}

export class SupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto implements ISupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: ISupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ISupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class PagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto implements IPagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto {
    totalCount!: number;
    items!: SupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto[] | undefined;

    constructor(data?: IPagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfSupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto {
    totalCount: number;
    items: SupportTicketNotificationRecipientsSupportTicketNotificationLookupTableDto[] | undefined;
}

export class SupportTicketNotificationDto implements ISupportTicketNotificationDto {
    description!: string | undefined;
    code!: string | undefined;
    isActive!: boolean;
    orderNotificationTemplateId!: number | undefined;
    supportTicketStatusId!: number | undefined;
    smsTemplateId!: number | undefined;
    tenantId!: number | undefined;
    id!: number;

    constructor(data?: ISupportTicketNotificationDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.code = data["code"];
            this.isActive = data["isActive"];
            this.orderNotificationTemplateId = data["orderNotificationTemplateId"];
            this.supportTicketStatusId = data["supportTicketStatusId"];
            this.smsTemplateId = data["smsTemplateId"];
            this.tenantId = data["tenantId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationDto {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["code"] = this.code;
        data["isActive"] = this.isActive;
        data["orderNotificationTemplateId"] = this.orderNotificationTemplateId;
        data["supportTicketStatusId"] = this.supportTicketStatusId;
        data["smsTemplateId"] = this.smsTemplateId;
        data["tenantId"] = this.tenantId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ISupportTicketNotificationDto {
    description: string | undefined;
    code: string | undefined;
    isActive: boolean;
    orderNotificationTemplateId: number | undefined;
    supportTicketStatusId: number | undefined;
    smsTemplateId: number | undefined;
    tenantId: number | undefined;
    id: number;
}

export class GetSupportTicketNotificationForViewDto implements IGetSupportTicketNotificationForViewDto {
    supportTicketNotification!: SupportTicketNotificationDto | undefined;
    orderNotificationTemplateDescription!: string | undefined;
    supportTicketStatusDescription!: string | undefined;
    smsTemplateDescription!: string | undefined;
    tenantName!: string | undefined;

    constructor(data?: IGetSupportTicketNotificationForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.supportTicketNotification = data["supportTicketNotification"] ? SupportTicketNotificationDto.fromJS(data["supportTicketNotification"]) : <any>undefined;
            this.orderNotificationTemplateDescription = data["orderNotificationTemplateDescription"];
            this.supportTicketStatusDescription = data["supportTicketStatusDescription"];
            this.smsTemplateDescription = data["smsTemplateDescription"];
            this.tenantName = data["tenantName"];
        }
    }

    static fromJS(data: any): GetSupportTicketNotificationForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetSupportTicketNotificationForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["supportTicketNotification"] = this.supportTicketNotification ? this.supportTicketNotification.toJSON() : <any>undefined;
        data["orderNotificationTemplateDescription"] = this.orderNotificationTemplateDescription;
        data["supportTicketStatusDescription"] = this.supportTicketStatusDescription;
        data["smsTemplateDescription"] = this.smsTemplateDescription;
        data["tenantName"] = this.tenantName;
        return data; 
    }
}

export interface IGetSupportTicketNotificationForViewDto {
    supportTicketNotification: SupportTicketNotificationDto | undefined;
    orderNotificationTemplateDescription: string | undefined;
    supportTicketStatusDescription: string | undefined;
    smsTemplateDescription: string | undefined;
    tenantName: string | undefined;
}

export class PagedResultDtoOfGetSupportTicketNotificationForViewDto implements IPagedResultDtoOfGetSupportTicketNotificationForViewDto {
    totalCount!: number;
    items!: GetSupportTicketNotificationForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetSupportTicketNotificationForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetSupportTicketNotificationForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetSupportTicketNotificationForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetSupportTicketNotificationForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetSupportTicketNotificationForViewDto {
    totalCount: number;
    items: GetSupportTicketNotificationForViewDto[] | undefined;
}

export class CreateOrEditSupportTicketNotificationDto implements ICreateOrEditSupportTicketNotificationDto {
    description!: string | undefined;
    code!: string | undefined;
    isActive!: boolean;
    supportTicketNotificationRecipients!: SupportTicketNotificationRecipientsDto[] | undefined;
    orderNotificationTemplateId!: number | undefined;
    supportTicketStatusId!: number | undefined;
    smsTemplateId!: number | undefined;
    tenantId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditSupportTicketNotificationDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.code = data["code"];
            this.isActive = data["isActive"];
            if (Array.isArray(data["supportTicketNotificationRecipients"])) {
                this.supportTicketNotificationRecipients = [] as any;
                for (let item of data["supportTicketNotificationRecipients"])
                    this.supportTicketNotificationRecipients!.push(SupportTicketNotificationRecipientsDto.fromJS(item));
            }
            this.orderNotificationTemplateId = data["orderNotificationTemplateId"];
            this.supportTicketStatusId = data["supportTicketStatusId"];
            this.smsTemplateId = data["smsTemplateId"];
            this.tenantId = data["tenantId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditSupportTicketNotificationDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditSupportTicketNotificationDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["code"] = this.code;
        data["isActive"] = this.isActive;
        if (Array.isArray(this.supportTicketNotificationRecipients)) {
            data["supportTicketNotificationRecipients"] = [];
            for (let item of this.supportTicketNotificationRecipients)
                data["supportTicketNotificationRecipients"].push(item.toJSON());
        }
        data["orderNotificationTemplateId"] = this.orderNotificationTemplateId;
        data["supportTicketStatusId"] = this.supportTicketStatusId;
        data["smsTemplateId"] = this.smsTemplateId;
        data["tenantId"] = this.tenantId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditSupportTicketNotificationDto {
    description: string | undefined;
    code: string | undefined;
    isActive: boolean;
    supportTicketNotificationRecipients: SupportTicketNotificationRecipientsDto[] | undefined;
    orderNotificationTemplateId: number | undefined;
    supportTicketStatusId: number | undefined;
    smsTemplateId: number | undefined;
    tenantId: number | undefined;
    id: number | undefined;
}

export class GetSupportTicketNotificationForEditOutput implements IGetSupportTicketNotificationForEditOutput {
    supportTicketNotification!: CreateOrEditSupportTicketNotificationDto | undefined;
    orderNotificationTemplateDescription!: string | undefined;
    supportTicketStatusDescription!: string | undefined;
    smsTemplateDescription!: string | undefined;
    tenantName!: string | undefined;

    constructor(data?: IGetSupportTicketNotificationForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.supportTicketNotification = data["supportTicketNotification"] ? CreateOrEditSupportTicketNotificationDto.fromJS(data["supportTicketNotification"]) : <any>undefined;
            this.orderNotificationTemplateDescription = data["orderNotificationTemplateDescription"];
            this.supportTicketStatusDescription = data["supportTicketStatusDescription"];
            this.smsTemplateDescription = data["smsTemplateDescription"];
            this.tenantName = data["tenantName"];
        }
    }

    static fromJS(data: any): GetSupportTicketNotificationForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetSupportTicketNotificationForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["supportTicketNotification"] = this.supportTicketNotification ? this.supportTicketNotification.toJSON() : <any>undefined;
        data["orderNotificationTemplateDescription"] = this.orderNotificationTemplateDescription;
        data["supportTicketStatusDescription"] = this.supportTicketStatusDescription;
        data["smsTemplateDescription"] = this.smsTemplateDescription;
        data["tenantName"] = this.tenantName;
        return data; 
    }
}

export interface IGetSupportTicketNotificationForEditOutput {
    supportTicketNotification: CreateOrEditSupportTicketNotificationDto | undefined;
    orderNotificationTemplateDescription: string | undefined;
    supportTicketStatusDescription: string | undefined;
    smsTemplateDescription: string | undefined;
    tenantName: string | undefined;
}

export class SupportTicketNotificationOrderNotificationTemplateLookupTableDto implements ISupportTicketNotificationOrderNotificationTemplateLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: ISupportTicketNotificationOrderNotificationTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationOrderNotificationTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationOrderNotificationTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ISupportTicketNotificationOrderNotificationTemplateLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class SupportTicketNotificationSupportTicketStatusLookupTableDto implements ISupportTicketNotificationSupportTicketStatusLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: ISupportTicketNotificationSupportTicketStatusLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationSupportTicketStatusLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationSupportTicketStatusLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ISupportTicketNotificationSupportTicketStatusLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class SupportTicketNotificationSmsTemplateLookupTableDto implements ISupportTicketNotificationSmsTemplateLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: ISupportTicketNotificationSmsTemplateLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationSmsTemplateLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationSmsTemplateLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface ISupportTicketNotificationSmsTemplateLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class TenantListDto implements ITenantListDto {
    tenancyName!: string | undefined;
    name!: string | undefined;
    editionDisplayName!: string | undefined;
    connectionString!: string | undefined;
    isActive!: boolean;
    creationTime!: moment.Moment;
    subscriptionEndDateUtc!: moment.Moment | undefined;
    editionId!: number | undefined;
    isInTrialPeriod!: boolean;
    id!: number;

    constructor(data?: ITenantListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.name = data["name"];
            this.editionDisplayName = data["editionDisplayName"];
            this.connectionString = data["connectionString"];
            this.isActive = data["isActive"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.subscriptionEndDateUtc = data["subscriptionEndDateUtc"] ? moment(data["subscriptionEndDateUtc"].toString()) : <any>undefined;
            this.editionId = data["editionId"];
            this.isInTrialPeriod = data["isInTrialPeriod"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TenantListDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["name"] = this.name;
        data["editionDisplayName"] = this.editionDisplayName;
        data["connectionString"] = this.connectionString;
        data["isActive"] = this.isActive;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["subscriptionEndDateUtc"] = this.subscriptionEndDateUtc ? this.subscriptionEndDateUtc.toISOString() : <any>undefined;
        data["editionId"] = this.editionId;
        data["isInTrialPeriod"] = this.isInTrialPeriod;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITenantListDto {
    tenancyName: string | undefined;
    name: string | undefined;
    editionDisplayName: string | undefined;
    connectionString: string | undefined;
    isActive: boolean;
    creationTime: moment.Moment;
    subscriptionEndDateUtc: moment.Moment | undefined;
    editionId: number | undefined;
    isInTrialPeriod: boolean;
    id: number;
}

export class SupportTicketNotificationInput implements ISupportTicketNotificationInput {
    id!: number | undefined;
    tenantId!: number | undefined;
    supportTicketStatusId!: number | undefined;
    supportTicketId!: number | undefined;
    assignedTo!: number | undefined;
    updated!: boolean;

    constructor(data?: ISupportTicketNotificationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.supportTicketStatusId = data["supportTicketStatusId"];
            this.supportTicketId = data["supportTicketId"];
            this.assignedTo = data["assignedTo"];
            this.updated = data["updated"];
        }
    }

    static fromJS(data: any): SupportTicketNotificationInput {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketNotificationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["supportTicketStatusId"] = this.supportTicketStatusId;
        data["supportTicketId"] = this.supportTicketId;
        data["assignedTo"] = this.assignedTo;
        data["updated"] = this.updated;
        return data; 
    }
}

export interface ISupportTicketNotificationInput {
    id: number | undefined;
    tenantId: number | undefined;
    supportTicketStatusId: number | undefined;
    supportTicketId: number | undefined;
    assignedTo: number | undefined;
    updated: boolean;
}

export class SupportTicketSettingList implements ISupportTicketSettingList {
    id!: number | undefined;
    tenantId!: number | undefined;
    tenant!: string | undefined;
    documentationUrl!: string | undefined;
    trainingVideoUrl!: string | undefined;
    onBoardingGuideUrl!: string | undefined;
    faqUrl!: string | undefined;
    isActive!: boolean;

    constructor(data?: ISupportTicketSettingList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.tenant = data["tenant"];
            this.documentationUrl = data["documentationUrl"];
            this.trainingVideoUrl = data["trainingVideoUrl"];
            this.onBoardingGuideUrl = data["onBoardingGuideUrl"];
            this.faqUrl = data["faqUrl"];
            this.isActive = data["isActive"];
        }
    }

    static fromJS(data: any): SupportTicketSettingList {
        data = typeof data === 'object' ? data : {};
        let result = new SupportTicketSettingList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["tenant"] = this.tenant;
        data["documentationUrl"] = this.documentationUrl;
        data["trainingVideoUrl"] = this.trainingVideoUrl;
        data["onBoardingGuideUrl"] = this.onBoardingGuideUrl;
        data["faqUrl"] = this.faqUrl;
        data["isActive"] = this.isActive;
        return data; 
    }
}

export interface ISupportTicketSettingList {
    id: number | undefined;
    tenantId: number | undefined;
    tenant: string | undefined;
    documentationUrl: string | undefined;
    trainingVideoUrl: string | undefined;
    onBoardingGuideUrl: string | undefined;
    faqUrl: string | undefined;
    isActive: boolean;
}

export class PagedResultDtoOfSupportTicketSettingList implements IPagedResultDtoOfSupportTicketSettingList {
    totalCount!: number;
    items!: SupportTicketSettingList[] | undefined;

    constructor(data?: IPagedResultDtoOfSupportTicketSettingList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SupportTicketSettingList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfSupportTicketSettingList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfSupportTicketSettingList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfSupportTicketSettingList {
    totalCount: number;
    items: SupportTicketSettingList[] | undefined;
}

export class CreateSupportTicketSettingDto implements ICreateSupportTicketSettingDto {
    id!: number | undefined;
    tenantId!: number | undefined;
    documentationUrl!: string | undefined;
    trainingVideoUrl!: string | undefined;
    onBoardingGuideUrl!: string | undefined;
    faqUrl!: string | undefined;
    isActive!: boolean;

    constructor(data?: ICreateSupportTicketSettingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.documentationUrl = data["documentationUrl"];
            this.trainingVideoUrl = data["trainingVideoUrl"];
            this.onBoardingGuideUrl = data["onBoardingGuideUrl"];
            this.faqUrl = data["faqUrl"];
            this.isActive = data["isActive"];
        }
    }

    static fromJS(data: any): CreateSupportTicketSettingDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateSupportTicketSettingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["documentationUrl"] = this.documentationUrl;
        data["trainingVideoUrl"] = this.trainingVideoUrl;
        data["onBoardingGuideUrl"] = this.onBoardingGuideUrl;
        data["faqUrl"] = this.faqUrl;
        data["isActive"] = this.isActive;
        return data; 
    }
}

export interface ICreateSupportTicketSettingDto {
    id: number | undefined;
    tenantId: number | undefined;
    documentationUrl: string | undefined;
    trainingVideoUrl: string | undefined;
    onBoardingGuideUrl: string | undefined;
    faqUrl: string | undefined;
    isActive: boolean;
}

export class UpdateSupportTicketSettingDto implements IUpdateSupportTicketSettingDto {
    id!: number;
    tenantId!: number | undefined;
    documentationUrl!: string | undefined;
    trainingVideoUrl!: string | undefined;
    onBoardingGuideUrl!: string | undefined;
    faqUrl!: string | undefined;
    isActive!: boolean;

    constructor(data?: IUpdateSupportTicketSettingDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.documentationUrl = data["documentationUrl"];
            this.trainingVideoUrl = data["trainingVideoUrl"];
            this.onBoardingGuideUrl = data["onBoardingGuideUrl"];
            this.faqUrl = data["faqUrl"];
            this.isActive = data["isActive"];
        }
    }

    static fromJS(data: any): UpdateSupportTicketSettingDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateSupportTicketSettingDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["documentationUrl"] = this.documentationUrl;
        data["trainingVideoUrl"] = this.trainingVideoUrl;
        data["onBoardingGuideUrl"] = this.onBoardingGuideUrl;
        data["faqUrl"] = this.faqUrl;
        data["isActive"] = this.isActive;
        return data; 
    }
}

export interface IUpdateSupportTicketSettingDto {
    id: number;
    tenantId: number | undefined;
    documentationUrl: string | undefined;
    trainingVideoUrl: string | undefined;
    onBoardingGuideUrl: string | undefined;
    faqUrl: string | undefined;
    isActive: boolean;
}

export class TicketStatusList implements ITicketStatusList {
    id!: number | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    code!: string | undefined;
    inactive!: boolean;
    parentStatusTypeId!: number;
    parentStatusType!: string | undefined;
    isPublic!: boolean;

    constructor(data?: ITicketStatusList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.code = data["code"];
            this.inactive = data["inactive"];
            this.parentStatusTypeId = data["parentStatusTypeId"];
            this.parentStatusType = data["parentStatusType"];
            this.isPublic = data["isPublic"];
        }
    }

    static fromJS(data: any): TicketStatusList {
        data = typeof data === 'object' ? data : {};
        let result = new TicketStatusList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["code"] = this.code;
        data["inactive"] = this.inactive;
        data["parentStatusTypeId"] = this.parentStatusTypeId;
        data["parentStatusType"] = this.parentStatusType;
        data["isPublic"] = this.isPublic;
        return data; 
    }
}

export interface ITicketStatusList {
    id: number | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    code: string | undefined;
    inactive: boolean;
    parentStatusTypeId: number;
    parentStatusType: string | undefined;
    isPublic: boolean;
}

export class ListResultDtoOfTicketStatusList implements IListResultDtoOfTicketStatusList {
    items!: TicketStatusList[] | undefined;

    constructor(data?: IListResultDtoOfTicketStatusList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TicketStatusList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfTicketStatusList {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfTicketStatusList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfTicketStatusList {
    items: TicketStatusList[] | undefined;
}

export class PagedResultDtoOfTicketStatusList implements IPagedResultDtoOfTicketStatusList {
    totalCount!: number;
    items!: TicketStatusList[] | undefined;

    constructor(data?: IPagedResultDtoOfTicketStatusList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TicketStatusList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfTicketStatusList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfTicketStatusList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfTicketStatusList {
    totalCount: number;
    items: TicketStatusList[] | undefined;
}

export class GetTicketStatusInput implements IGetTicketStatusInput {
    filter!: string | undefined;
    id!: number | undefined;
    isPublicFilter!: boolean | undefined;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetTicketStatusInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.filter = data["filter"];
            this.id = data["id"];
            this.isPublicFilter = data["isPublicFilter"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetTicketStatusInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetTicketStatusInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["filter"] = this.filter;
        data["id"] = this.id;
        data["isPublicFilter"] = this.isPublicFilter;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetTicketStatusInput {
    filter: string | undefined;
    id: number | undefined;
    isPublicFilter: boolean | undefined;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class CreateTicketStatusDto implements ICreateTicketStatusDto {
    id!: number | undefined;
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    parentStatusTypeId!: number;
    isPublic!: boolean;

    constructor(data?: ICreateTicketStatusDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.parentStatusTypeId = data["parentStatusTypeId"];
            this.isPublic = data["isPublic"];
        }
    }

    static fromJS(data: any): CreateTicketStatusDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateTicketStatusDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["parentStatusTypeId"] = this.parentStatusTypeId;
        data["isPublic"] = this.isPublic;
        return data; 
    }
}

export interface ICreateTicketStatusDto {
    id: number | undefined;
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    parentStatusTypeId: number;
    isPublic: boolean;
}

export class UpdateTicketStatusDto implements IUpdateTicketStatusDto {
    id!: number;
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;
    parentStatusTypeId!: number;
    isPublic!: boolean;

    constructor(data?: IUpdateTicketStatusDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
            this.parentStatusTypeId = data["parentStatusTypeId"];
            this.isPublic = data["isPublic"];
        }
    }

    static fromJS(data: any): UpdateTicketStatusDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateTicketStatusDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        data["parentStatusTypeId"] = this.parentStatusTypeId;
        data["isPublic"] = this.isPublic;
        return data; 
    }
}

export interface IUpdateTicketStatusDto {
    id: number;
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
    parentStatusTypeId: number;
    isPublic: boolean;
}

export class TicketStatusCodeDto implements ITicketStatusCodeDto {
    code!: string | undefined;
    id!: number;

    constructor(data?: ITicketStatusCodeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TicketStatusCodeDto {
        data = typeof data === 'object' ? data : {};
        let result = new TicketStatusCodeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITicketStatusCodeDto {
    code: string | undefined;
    id: number;
}

export class PriorityCodeDto implements IPriorityCodeDto {
    code!: string | undefined;
    id!: number;

    constructor(data?: IPriorityCodeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): PriorityCodeDto {
        data = typeof data === 'object' ? data : {};
        let result = new PriorityCodeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["id"] = this.id;
        return data; 
    }
}

export interface IPriorityCodeDto {
    code: string | undefined;
    id: number;
}

export class TicketEffortHoursDto implements ITicketEffortHoursDto {
    hours!: number;

    constructor(data?: ITicketEffortHoursDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.hours = data["hours"];
        }
    }

    static fromJS(data: any): TicketEffortHoursDto {
        data = typeof data === 'object' ? data : {};
        let result = new TicketEffortHoursDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["hours"] = this.hours;
        return data; 
    }
}

export interface ITicketEffortHoursDto {
    hours: number;
}

export class TicketTypeList implements ITicketTypeList {
    id!: number | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    code!: string | undefined;
    inactive!: boolean;

    constructor(data?: ITicketTypeList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.code = data["code"];
            this.inactive = data["inactive"];
        }
    }

    static fromJS(data: any): TicketTypeList {
        data = typeof data === 'object' ? data : {};
        let result = new TicketTypeList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["code"] = this.code;
        data["inactive"] = this.inactive;
        return data; 
    }
}

export interface ITicketTypeList {
    id: number | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    code: string | undefined;
    inactive: boolean;
}

export class ListResultDtoOfTicketTypeList implements IListResultDtoOfTicketTypeList {
    items!: TicketTypeList[] | undefined;

    constructor(data?: IListResultDtoOfTicketTypeList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TicketTypeList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfTicketTypeList {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfTicketTypeList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfTicketTypeList {
    items: TicketTypeList[] | undefined;
}

export class PagedResultDtoOfTicketTypeList implements IPagedResultDtoOfTicketTypeList {
    totalCount!: number;
    items!: TicketTypeList[] | undefined;

    constructor(data?: IPagedResultDtoOfTicketTypeList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TicketTypeList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfTicketTypeList {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfTicketTypeList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfTicketTypeList {
    totalCount: number;
    items: TicketTypeList[] | undefined;
}

export class CreateTicketTypeDto implements ICreateTicketTypeDto {
    id!: number | undefined;
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;

    constructor(data?: ICreateTicketTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
        }
    }

    static fromJS(data: any): CreateTicketTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateTicketTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        return data; 
    }
}

export interface ICreateTicketTypeDto {
    id: number | undefined;
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
}

export class UpdateTicketTypeDto implements IUpdateTicketTypeDto {
    id!: number;
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    inactive!: boolean;

    constructor(data?: IUpdateTicketTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.inactive = data["inactive"];
        }
    }

    static fromJS(data: any): UpdateTicketTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateTicketTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["inactive"] = this.inactive;
        return data; 
    }
}

export interface IUpdateTicketTypeDto {
    id: number;
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    inactive: boolean;
}

export class CreateTagInput implements ICreateTagInput {
    tagTypeId!: number;
    name!: string;

    constructor(data?: ICreateTagInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tagTypeId = data["tagTypeId"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CreateTagInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateTagInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tagTypeId"] = this.tagTypeId;
        data["name"] = this.name;
        return data; 
    }
}

export interface ICreateTagInput {
    tagTypeId: number;
    name: string;
}

export class UpdateTagInput implements IUpdateTagInput {
    id!: number;
    tagTypeId!: number;
    name!: string;

    constructor(data?: IUpdateTagInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tagTypeId = data["tagTypeId"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): UpdateTagInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateTagInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tagTypeId"] = this.tagTypeId;
        data["name"] = this.name;
        return data; 
    }
}

export interface IUpdateTagInput {
    id: number;
    tagTypeId: number;
    name: string;
}

export class PagedResultDtoOfTagListDto implements IPagedResultDtoOfTagListDto {
    totalCount!: number;
    items!: TagListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfTagListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TagListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfTagListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfTagListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfTagListDto {
    totalCount: number;
    items: TagListDto[] | undefined;
}

export class TagDto implements ITagDto {
    tenantId!: number;
    tagTypes!: TagTypeListDto | undefined;
    name!: string | undefined;
    id!: number;

    constructor(data?: ITagDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tagTypes = data["tagTypes"] ? TagTypeListDto.fromJS(data["tagTypes"]) : <any>undefined;
            this.name = data["name"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TagDto {
        data = typeof data === 'object' ? data : {};
        let result = new TagDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tagTypes"] = this.tagTypes ? this.tagTypes.toJSON() : <any>undefined;
        data["name"] = this.name;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITagDto {
    tenantId: number;
    tagTypes: TagTypeListDto | undefined;
    name: string | undefined;
    id: number;
}

export class GetTagForViewDto implements IGetTagForViewDto {
    tag!: TagDto | undefined;

    constructor(data?: IGetTagForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tag = data["tag"] ? TagDto.fromJS(data["tag"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetTagForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetTagForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tag"] = this.tag ? this.tag.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetTagForViewDto {
    tag: TagDto | undefined;
}

export class PagedResultDtoOfGetTagForViewDto implements IPagedResultDtoOfGetTagForViewDto {
    totalCount!: number;
    items!: GetTagForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetTagForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetTagForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetTagForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetTagForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetTagForViewDto {
    totalCount: number;
    items: GetTagForViewDto[] | undefined;
}

export class CreateOrEditTagDto implements ICreateOrEditTagDto {
    tagTypeId!: number;
    name!: string;
    id!: number | undefined;

    constructor(data?: ICreateOrEditTagDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tagTypeId = data["tagTypeId"];
            this.name = data["name"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditTagDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditTagDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tagTypeId"] = this.tagTypeId;
        data["name"] = this.name;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditTagDto {
    tagTypeId: number;
    name: string;
    id: number | undefined;
}

export class GetTagForEditOutput implements IGetTagForEditOutput {
    tag!: CreateOrEditTagDto | undefined;

    constructor(data?: IGetTagForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tag = data["tag"] ? CreateOrEditTagDto.fromJS(data["tag"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetTagForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetTagForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tag"] = this.tag ? this.tag.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetTagForEditOutput {
    tag: CreateOrEditTagDto | undefined;
}

export class CreateTagTypeInput implements ICreateTagTypeInput {
    name!: string | undefined;

    constructor(data?: ICreateTagTypeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
        }
    }

    static fromJS(data: any): CreateTagTypeInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateTagTypeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        return data; 
    }
}

export interface ICreateTagTypeInput {
    name: string | undefined;
}

export class UpdateTagTypeInput implements IUpdateTagTypeInput {
    id!: number;
    tenantId!: number;
    name!: string | undefined;

    constructor(data?: IUpdateTagTypeInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.tenantId = data["tenantId"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): UpdateTagTypeInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateTagTypeInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        return data; 
    }
}

export interface IUpdateTagTypeInput {
    id: number;
    tenantId: number;
    name: string | undefined;
}

export class PagedResultDtoOfTagTypeListDto implements IPagedResultDtoOfTagTypeListDto {
    totalCount!: number;
    items!: TagTypeListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfTagTypeListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TagTypeListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfTagTypeListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfTagTypeListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfTagTypeListDto {
    totalCount: number;
    items: TagTypeListDto[] | undefined;
}

export class TagTypeDto implements ITagTypeDto {
    name!: string | undefined;
    code!: string | undefined;
    id!: number;

    constructor(data?: ITagTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TagTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new TagTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITagTypeDto {
    name: string | undefined;
    code: string | undefined;
    id: number;
}

export class GetTagTypeForViewDto implements IGetTagTypeForViewDto {
    tagType!: TagTypeDto | undefined;

    constructor(data?: IGetTagTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tagType = data["tagType"] ? TagTypeDto.fromJS(data["tagType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetTagTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetTagTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tagType"] = this.tagType ? this.tagType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetTagTypeForViewDto {
    tagType: TagTypeDto | undefined;
}

export class PagedResultDtoOfGetTagTypeForViewDto implements IPagedResultDtoOfGetTagTypeForViewDto {
    totalCount!: number;
    items!: GetTagTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetTagTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetTagTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetTagTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetTagTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetTagTypeForViewDto {
    totalCount: number;
    items: GetTagTypeForViewDto[] | undefined;
}

export class CreateOrEditTagTypeDto implements ICreateOrEditTagTypeDto {
    name!: string | undefined;
    code!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditTagTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.code = data["code"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditTagTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditTagTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["code"] = this.code;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditTagTypeDto {
    name: string | undefined;
    code: string | undefined;
    id: number | undefined;
}

export class GetTagTypeForEditOutput implements IGetTagTypeForEditOutput {
    tagType!: CreateOrEditTagTypeDto | undefined;

    constructor(data?: IGetTagTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tagType = data["tagType"] ? CreateOrEditTagTypeDto.fromJS(data["tagType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetTagTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetTagTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tagType"] = this.tagType ? this.tagType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetTagTypeForEditOutput {
    tagType: CreateOrEditTagTypeDto | undefined;
}

export class PagedResultDtoOfTenantListDto implements IPagedResultDtoOfTenantListDto {
    totalCount!: number;
    items!: TenantListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfTenantListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TenantListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfTenantListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfTenantListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfTenantListDto {
    totalCount: number;
    items: TenantListDto[] | undefined;
}

export class CreateTenantInput implements ICreateTenantInput {
    tenancyName!: string;
    name!: string;
    adminEmailAddress!: string;
    adminPassword!: string | undefined;
    connectionString!: string | undefined;
    shouldChangePasswordOnNextLogin!: boolean;
    sendActivationEmail!: boolean;
    editionId!: number | undefined;
    isActive!: boolean;
    subscriptionEndDateUtc!: moment.Moment | undefined;
    isInTrialPeriod!: boolean;

    constructor(data?: ICreateTenantInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.name = data["name"];
            this.adminEmailAddress = data["adminEmailAddress"];
            this.adminPassword = data["adminPassword"];
            this.connectionString = data["connectionString"];
            this.shouldChangePasswordOnNextLogin = data["shouldChangePasswordOnNextLogin"];
            this.sendActivationEmail = data["sendActivationEmail"];
            this.editionId = data["editionId"];
            this.isActive = data["isActive"];
            this.subscriptionEndDateUtc = data["subscriptionEndDateUtc"] ? moment(data["subscriptionEndDateUtc"].toString()) : <any>undefined;
            this.isInTrialPeriod = data["isInTrialPeriod"];
        }
    }

    static fromJS(data: any): CreateTenantInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateTenantInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["name"] = this.name;
        data["adminEmailAddress"] = this.adminEmailAddress;
        data["adminPassword"] = this.adminPassword;
        data["connectionString"] = this.connectionString;
        data["shouldChangePasswordOnNextLogin"] = this.shouldChangePasswordOnNextLogin;
        data["sendActivationEmail"] = this.sendActivationEmail;
        data["editionId"] = this.editionId;
        data["isActive"] = this.isActive;
        data["subscriptionEndDateUtc"] = this.subscriptionEndDateUtc ? this.subscriptionEndDateUtc.toISOString() : <any>undefined;
        data["isInTrialPeriod"] = this.isInTrialPeriod;
        return data; 
    }
}

export interface ICreateTenantInput {
    tenancyName: string;
    name: string;
    adminEmailAddress: string;
    adminPassword: string | undefined;
    connectionString: string | undefined;
    shouldChangePasswordOnNextLogin: boolean;
    sendActivationEmail: boolean;
    editionId: number | undefined;
    isActive: boolean;
    subscriptionEndDateUtc: moment.Moment | undefined;
    isInTrialPeriod: boolean;
}

export class TenantEditDto implements ITenantEditDto {
    tenancyName!: string;
    name!: string;
    connectionString!: string | undefined;
    editionId!: number | undefined;
    isActive!: boolean;
    subscriptionEndDateUtc!: moment.Moment | undefined;
    isInTrialPeriod!: boolean;
    id!: number;

    constructor(data?: ITenantEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.name = data["name"];
            this.connectionString = data["connectionString"];
            this.editionId = data["editionId"];
            this.isActive = data["isActive"];
            this.subscriptionEndDateUtc = data["subscriptionEndDateUtc"] ? moment(data["subscriptionEndDateUtc"].toString()) : <any>undefined;
            this.isInTrialPeriod = data["isInTrialPeriod"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TenantEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["name"] = this.name;
        data["connectionString"] = this.connectionString;
        data["editionId"] = this.editionId;
        data["isActive"] = this.isActive;
        data["subscriptionEndDateUtc"] = this.subscriptionEndDateUtc ? this.subscriptionEndDateUtc.toISOString() : <any>undefined;
        data["isInTrialPeriod"] = this.isInTrialPeriod;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITenantEditDto {
    tenancyName: string;
    name: string;
    connectionString: string | undefined;
    editionId: number | undefined;
    isActive: boolean;
    subscriptionEndDateUtc: moment.Moment | undefined;
    isInTrialPeriod: boolean;
    id: number;
}

export class GetTenantFeaturesEditOutput implements IGetTenantFeaturesEditOutput {
    featureValues!: NameValueDto[] | undefined;
    features!: FlatFeatureDto[] | undefined;

    constructor(data?: IGetTenantFeaturesEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["featureValues"])) {
                this.featureValues = [] as any;
                for (let item of data["featureValues"])
                    this.featureValues!.push(NameValueDto.fromJS(item));
            }
            if (Array.isArray(data["features"])) {
                this.features = [] as any;
                for (let item of data["features"])
                    this.features!.push(FlatFeatureDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetTenantFeaturesEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetTenantFeaturesEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.featureValues)) {
            data["featureValues"] = [];
            for (let item of this.featureValues)
                data["featureValues"].push(item.toJSON());
        }
        if (Array.isArray(this.features)) {
            data["features"] = [];
            for (let item of this.features)
                data["features"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetTenantFeaturesEditOutput {
    featureValues: NameValueDto[] | undefined;
    features: FlatFeatureDto[] | undefined;
}

export class UpdateTenantFeaturesInput implements IUpdateTenantFeaturesInput {
    id!: number;
    featureValues!: NameValueDto[];

    constructor(data?: IUpdateTenantFeaturesInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.featureValues = [];
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            if (Array.isArray(data["featureValues"])) {
                this.featureValues = [] as any;
                for (let item of data["featureValues"])
                    this.featureValues!.push(NameValueDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): UpdateTenantFeaturesInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateTenantFeaturesInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        if (Array.isArray(this.featureValues)) {
            data["featureValues"] = [];
            for (let item of this.featureValues)
                data["featureValues"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IUpdateTenantFeaturesInput {
    id: number;
    featureValues: NameValueDto[];
}

export class MemberActivity implements IMemberActivity {
    name!: string | undefined;
    earnings!: string | undefined;
    cases!: number;
    closed!: number;
    rate!: string | undefined;

    constructor(data?: IMemberActivity) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.earnings = data["earnings"];
            this.cases = data["cases"];
            this.closed = data["closed"];
            this.rate = data["rate"];
        }
    }

    static fromJS(data: any): MemberActivity {
        data = typeof data === 'object' ? data : {};
        let result = new MemberActivity();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["earnings"] = this.earnings;
        data["cases"] = this.cases;
        data["closed"] = this.closed;
        data["rate"] = this.rate;
        return data; 
    }
}

export interface IMemberActivity {
    name: string | undefined;
    earnings: string | undefined;
    cases: number;
    closed: number;
    rate: string | undefined;
}

export class GetMemberActivityOutput implements IGetMemberActivityOutput {
    memberActivities!: MemberActivity[] | undefined;

    constructor(data?: IGetMemberActivityOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["memberActivities"])) {
                this.memberActivities = [] as any;
                for (let item of data["memberActivities"])
                    this.memberActivities!.push(MemberActivity.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetMemberActivityOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetMemberActivityOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.memberActivities)) {
            data["memberActivities"] = [];
            for (let item of this.memberActivities)
                data["memberActivities"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetMemberActivityOutput {
    memberActivities: MemberActivity[] | undefined;
}

export enum SalesSummaryDatePeriod {
    Daily = 1,
    Weekly = 2,
    Monthly = 3,
}

export class SalesSummaryData implements ISalesSummaryData {
    period!: string | undefined;
    sales!: number;
    profit!: number;

    constructor(data?: ISalesSummaryData) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.period = data["period"];
            this.sales = data["sales"];
            this.profit = data["profit"];
        }
    }

    static fromJS(data: any): SalesSummaryData {
        data = typeof data === 'object' ? data : {};
        let result = new SalesSummaryData();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["period"] = this.period;
        data["sales"] = this.sales;
        data["profit"] = this.profit;
        return data; 
    }
}

export interface ISalesSummaryData {
    period: string | undefined;
    sales: number;
    profit: number;
}

export class GetDashboardDataOutput implements IGetDashboardDataOutput {
    totalProfit!: number;
    newFeedbacks!: number;
    newOrders!: number;
    newUsers!: number;
    salesSummary!: SalesSummaryData[] | undefined;
    totalSales!: number;
    revenue!: number;
    expenses!: number;
    growth!: number;
    transactionPercent!: number;
    newVisitPercent!: number;
    bouncePercent!: number;
    dailySales!: number[] | undefined;
    profitShares!: number[] | undefined;

    constructor(data?: IGetDashboardDataOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalProfit = data["totalProfit"];
            this.newFeedbacks = data["newFeedbacks"];
            this.newOrders = data["newOrders"];
            this.newUsers = data["newUsers"];
            if (Array.isArray(data["salesSummary"])) {
                this.salesSummary = [] as any;
                for (let item of data["salesSummary"])
                    this.salesSummary!.push(SalesSummaryData.fromJS(item));
            }
            this.totalSales = data["totalSales"];
            this.revenue = data["revenue"];
            this.expenses = data["expenses"];
            this.growth = data["growth"];
            this.transactionPercent = data["transactionPercent"];
            this.newVisitPercent = data["newVisitPercent"];
            this.bouncePercent = data["bouncePercent"];
            if (Array.isArray(data["dailySales"])) {
                this.dailySales = [] as any;
                for (let item of data["dailySales"])
                    this.dailySales!.push(item);
            }
            if (Array.isArray(data["profitShares"])) {
                this.profitShares = [] as any;
                for (let item of data["profitShares"])
                    this.profitShares!.push(item);
            }
        }
    }

    static fromJS(data: any): GetDashboardDataOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetDashboardDataOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalProfit"] = this.totalProfit;
        data["newFeedbacks"] = this.newFeedbacks;
        data["newOrders"] = this.newOrders;
        data["newUsers"] = this.newUsers;
        if (Array.isArray(this.salesSummary)) {
            data["salesSummary"] = [];
            for (let item of this.salesSummary)
                data["salesSummary"].push(item.toJSON());
        }
        data["totalSales"] = this.totalSales;
        data["revenue"] = this.revenue;
        data["expenses"] = this.expenses;
        data["growth"] = this.growth;
        data["transactionPercent"] = this.transactionPercent;
        data["newVisitPercent"] = this.newVisitPercent;
        data["bouncePercent"] = this.bouncePercent;
        if (Array.isArray(this.dailySales)) {
            data["dailySales"] = [];
            for (let item of this.dailySales)
                data["dailySales"].push(item);
        }
        if (Array.isArray(this.profitShares)) {
            data["profitShares"] = [];
            for (let item of this.profitShares)
                data["profitShares"].push(item);
        }
        return data; 
    }
}

export interface IGetDashboardDataOutput {
    totalProfit: number;
    newFeedbacks: number;
    newOrders: number;
    newUsers: number;
    salesSummary: SalesSummaryData[] | undefined;
    totalSales: number;
    revenue: number;
    expenses: number;
    growth: number;
    transactionPercent: number;
    newVisitPercent: number;
    bouncePercent: number;
    dailySales: number[] | undefined;
    profitShares: number[] | undefined;
}

export class GetTopStatsOutput implements IGetTopStatsOutput {
    totalProfit!: number;
    newFeedbacks!: number;
    newOrders!: number;
    newUsers!: number;

    constructor(data?: IGetTopStatsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalProfit = data["totalProfit"];
            this.newFeedbacks = data["newFeedbacks"];
            this.newOrders = data["newOrders"];
            this.newUsers = data["newUsers"];
        }
    }

    static fromJS(data: any): GetTopStatsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetTopStatsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalProfit"] = this.totalProfit;
        data["newFeedbacks"] = this.newFeedbacks;
        data["newOrders"] = this.newOrders;
        data["newUsers"] = this.newUsers;
        return data; 
    }
}

export interface IGetTopStatsOutput {
    totalProfit: number;
    newFeedbacks: number;
    newOrders: number;
    newUsers: number;
}

export class GetProfitShareOutput implements IGetProfitShareOutput {
    profitShares!: number[] | undefined;

    constructor(data?: IGetProfitShareOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["profitShares"])) {
                this.profitShares = [] as any;
                for (let item of data["profitShares"])
                    this.profitShares!.push(item);
            }
        }
    }

    static fromJS(data: any): GetProfitShareOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetProfitShareOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.profitShares)) {
            data["profitShares"] = [];
            for (let item of this.profitShares)
                data["profitShares"].push(item);
        }
        return data; 
    }
}

export interface IGetProfitShareOutput {
    profitShares: number[] | undefined;
}

export class GetDailySalesOutput implements IGetDailySalesOutput {
    dailySales!: number[] | undefined;

    constructor(data?: IGetDailySalesOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["dailySales"])) {
                this.dailySales = [] as any;
                for (let item of data["dailySales"])
                    this.dailySales!.push(item);
            }
        }
    }

    static fromJS(data: any): GetDailySalesOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetDailySalesOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.dailySales)) {
            data["dailySales"] = [];
            for (let item of this.dailySales)
                data["dailySales"].push(item);
        }
        return data; 
    }
}

export interface IGetDailySalesOutput {
    dailySales: number[] | undefined;
}

export class GetSalesSummaryOutput implements IGetSalesSummaryOutput {
    totalSales!: number;
    revenue!: number;
    expenses!: number;
    growth!: number;
    salesSummary!: SalesSummaryData[] | undefined;

    constructor(data?: IGetSalesSummaryOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalSales = data["totalSales"];
            this.revenue = data["revenue"];
            this.expenses = data["expenses"];
            this.growth = data["growth"];
            if (Array.isArray(data["salesSummary"])) {
                this.salesSummary = [] as any;
                for (let item of data["salesSummary"])
                    this.salesSummary!.push(SalesSummaryData.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetSalesSummaryOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetSalesSummaryOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalSales"] = this.totalSales;
        data["revenue"] = this.revenue;
        data["expenses"] = this.expenses;
        data["growth"] = this.growth;
        if (Array.isArray(this.salesSummary)) {
            data["salesSummary"] = [];
            for (let item of this.salesSummary)
                data["salesSummary"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetSalesSummaryOutput {
    totalSales: number;
    revenue: number;
    expenses: number;
    growth: number;
    salesSummary: SalesSummaryData[] | undefined;
}

export class RegionalStatCountry implements IRegionalStatCountry {
    countryName!: string | undefined;
    sales!: number;
    change!: number[] | undefined;
    averagePrice!: number;
    totalPrice!: number;

    constructor(data?: IRegionalStatCountry) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.countryName = data["countryName"];
            this.sales = data["sales"];
            if (Array.isArray(data["change"])) {
                this.change = [] as any;
                for (let item of data["change"])
                    this.change!.push(item);
            }
            this.averagePrice = data["averagePrice"];
            this.totalPrice = data["totalPrice"];
        }
    }

    static fromJS(data: any): RegionalStatCountry {
        data = typeof data === 'object' ? data : {};
        let result = new RegionalStatCountry();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["countryName"] = this.countryName;
        data["sales"] = this.sales;
        if (Array.isArray(this.change)) {
            data["change"] = [];
            for (let item of this.change)
                data["change"].push(item);
        }
        data["averagePrice"] = this.averagePrice;
        data["totalPrice"] = this.totalPrice;
        return data; 
    }
}

export interface IRegionalStatCountry {
    countryName: string | undefined;
    sales: number;
    change: number[] | undefined;
    averagePrice: number;
    totalPrice: number;
}

export class GetRegionalStatsOutput implements IGetRegionalStatsOutput {
    stats!: RegionalStatCountry[] | undefined;

    constructor(data?: IGetRegionalStatsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["stats"])) {
                this.stats = [] as any;
                for (let item of data["stats"])
                    this.stats!.push(RegionalStatCountry.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetRegionalStatsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRegionalStatsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.stats)) {
            data["stats"] = [];
            for (let item of this.stats)
                data["stats"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetRegionalStatsOutput {
    stats: RegionalStatCountry[] | undefined;
}

export class GetGeneralStatsOutput implements IGetGeneralStatsOutput {
    transactionPercent!: number;
    newVisitPercent!: number;
    bouncePercent!: number;

    constructor(data?: IGetGeneralStatsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.transactionPercent = data["transactionPercent"];
            this.newVisitPercent = data["newVisitPercent"];
            this.bouncePercent = data["bouncePercent"];
        }
    }

    static fromJS(data: any): GetGeneralStatsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetGeneralStatsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["transactionPercent"] = this.transactionPercent;
        data["newVisitPercent"] = this.newVisitPercent;
        data["bouncePercent"] = this.bouncePercent;
        return data; 
    }
}

export interface IGetGeneralStatsOutput {
    transactionPercent: number;
    newVisitPercent: number;
    bouncePercent: number;
}

export class GetNextArrivalData implements IGetNextArrivalData {
    routeId!: number;
    routeName!: string | undefined;
    nextArrival!: number;
    nextArrivalTime!: moment.Moment;

    constructor(data?: IGetNextArrivalData) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.routeName = data["routeName"];
            this.nextArrival = data["nextArrival"];
            this.nextArrivalTime = data["nextArrivalTime"] ? moment(data["nextArrivalTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetNextArrivalData {
        data = typeof data === 'object' ? data : {};
        let result = new GetNextArrivalData();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["routeName"] = this.routeName;
        data["nextArrival"] = this.nextArrival;
        data["nextArrivalTime"] = this.nextArrivalTime ? this.nextArrivalTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetNextArrivalData {
    routeId: number;
    routeName: string | undefined;
    nextArrival: number;
    nextArrivalTime: moment.Moment;
}

export class GetLocationDataOutput implements IGetLocationDataOutput {
    locationName!: string | undefined;
    dateFilter!: string | undefined;
    locationCurrentTime!: string | undefined;
    inboundTotal!: number;
    nextArrival!: number;
    nextArrivalTime!: string | undefined;
    nextArrivalRoute!: string | undefined;
    totalInHouse!: number;
    grandTotal!: number;
    pickupProgress!: number;

    constructor(data?: IGetLocationDataOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationName = data["locationName"];
            this.dateFilter = data["dateFilter"];
            this.locationCurrentTime = data["locationCurrentTime"];
            this.inboundTotal = data["inboundTotal"];
            this.nextArrival = data["nextArrival"];
            this.nextArrivalTime = data["nextArrivalTime"];
            this.nextArrivalRoute = data["nextArrivalRoute"];
            this.totalInHouse = data["totalInHouse"];
            this.grandTotal = data["grandTotal"];
            this.pickupProgress = data["pickupProgress"];
        }
    }

    static fromJS(data: any): GetLocationDataOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationDataOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationName"] = this.locationName;
        data["dateFilter"] = this.dateFilter;
        data["locationCurrentTime"] = this.locationCurrentTime;
        data["inboundTotal"] = this.inboundTotal;
        data["nextArrival"] = this.nextArrival;
        data["nextArrivalTime"] = this.nextArrivalTime;
        data["nextArrivalRoute"] = this.nextArrivalRoute;
        data["totalInHouse"] = this.totalInHouse;
        data["grandTotal"] = this.grandTotal;
        data["pickupProgress"] = this.pickupProgress;
        return data; 
    }
}

export interface IGetLocationDataOutput {
    locationName: string | undefined;
    dateFilter: string | undefined;
    locationCurrentTime: string | undefined;
    inboundTotal: number;
    nextArrival: number;
    nextArrivalTime: string | undefined;
    nextArrivalRoute: string | undefined;
    totalInHouse: number;
    grandTotal: number;
    pickupProgress: number;
}

export class LineHaulList implements ILineHaulList {
    name!: string | undefined;
    routeTemplateId!: number;

    constructor(data?: ILineHaulList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.routeTemplateId = data["routeTemplateId"];
        }
    }

    static fromJS(data: any): LineHaulList {
        data = typeof data === 'object' ? data : {};
        let result = new LineHaulList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["routeTemplateId"] = this.routeTemplateId;
        return data; 
    }
}

export interface ILineHaulList {
    name: string | undefined;
    routeTemplateId: number;
}

export class GetLocationRouteDataOutput implements IGetLocationRouteDataOutput {
    routeTemplateId!: number;
    route!: string | undefined;
    samples!: number;
    target!: string | undefined;
    lastSched!: string | undefined;
    lastSchedSamples!: number;
    targetMinutes!: number | undefined;
    tommorow!: boolean;
    arrival!: string | undefined;
    liveEta!: string | undefined;
    liveEtaTime!: moment.Moment;
    etaMinutes!: number | undefined;
    completionMinutes!: number | undefined;
    liveEtaMinutes!: number | undefined;
    currentTimeMinutes!: number | undefined;
    gridFillColor!: string | undefined;
    sampleTextColor!: string | undefined;
    gridTextColor!: string | undefined;
    samplesPickedUp!: number;
    parentLHLists!: LineHaulList[] | undefined;
    isLinehaul!: boolean;

    constructor(data?: IGetLocationRouteDataOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateId = data["routeTemplateId"];
            this.route = data["route"];
            this.samples = data["samples"];
            this.target = data["target"];
            this.lastSched = data["lastSched"];
            this.lastSchedSamples = data["lastSchedSamples"];
            this.targetMinutes = data["targetMinutes"];
            this.tommorow = data["tommorow"];
            this.arrival = data["arrival"];
            this.liveEta = data["liveEta"];
            this.liveEtaTime = data["liveEtaTime"] ? moment(data["liveEtaTime"].toString()) : <any>undefined;
            this.etaMinutes = data["etaMinutes"];
            this.completionMinutes = data["completionMinutes"];
            this.liveEtaMinutes = data["liveEtaMinutes"];
            this.currentTimeMinutes = data["currentTimeMinutes"];
            this.gridFillColor = data["gridFillColor"];
            this.sampleTextColor = data["sampleTextColor"];
            this.gridTextColor = data["gridTextColor"];
            this.samplesPickedUp = data["samplesPickedUp"];
            if (Array.isArray(data["parentLHLists"])) {
                this.parentLHLists = [] as any;
                for (let item of data["parentLHLists"])
                    this.parentLHLists!.push(LineHaulList.fromJS(item));
            }
            this.isLinehaul = data["isLinehaul"];
        }
    }

    static fromJS(data: any): GetLocationRouteDataOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationRouteDataOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateId"] = this.routeTemplateId;
        data["route"] = this.route;
        data["samples"] = this.samples;
        data["target"] = this.target;
        data["lastSched"] = this.lastSched;
        data["lastSchedSamples"] = this.lastSchedSamples;
        data["targetMinutes"] = this.targetMinutes;
        data["tommorow"] = this.tommorow;
        data["arrival"] = this.arrival;
        data["liveEta"] = this.liveEta;
        data["liveEtaTime"] = this.liveEtaTime ? this.liveEtaTime.toISOString() : <any>undefined;
        data["etaMinutes"] = this.etaMinutes;
        data["completionMinutes"] = this.completionMinutes;
        data["liveEtaMinutes"] = this.liveEtaMinutes;
        data["currentTimeMinutes"] = this.currentTimeMinutes;
        data["gridFillColor"] = this.gridFillColor;
        data["sampleTextColor"] = this.sampleTextColor;
        data["gridTextColor"] = this.gridTextColor;
        data["samplesPickedUp"] = this.samplesPickedUp;
        if (Array.isArray(this.parentLHLists)) {
            data["parentLHLists"] = [];
            for (let item of this.parentLHLists)
                data["parentLHLists"].push(item.toJSON());
        }
        data["isLinehaul"] = this.isLinehaul;
        return data; 
    }
}

export interface IGetLocationRouteDataOutput {
    routeTemplateId: number;
    route: string | undefined;
    samples: number;
    target: string | undefined;
    lastSched: string | undefined;
    lastSchedSamples: number;
    targetMinutes: number | undefined;
    tommorow: boolean;
    arrival: string | undefined;
    liveEta: string | undefined;
    liveEtaTime: moment.Moment;
    etaMinutes: number | undefined;
    completionMinutes: number | undefined;
    liveEtaMinutes: number | undefined;
    currentTimeMinutes: number | undefined;
    gridFillColor: string | undefined;
    sampleTextColor: string | undefined;
    gridTextColor: string | undefined;
    samplesPickedUp: number;
    parentLHLists: LineHaulList[] | undefined;
    isLinehaul: boolean;
}

export class GetLocationRouteDataCompletedOutput implements IGetLocationRouteDataCompletedOutput {
    routeId!: number;
    locationId!: number;
    loadDate!: string | undefined;
    targetTime!: TimeSpan;
    routeTemplateId!: number;
    route!: string | undefined;
    samples!: number;
    target!: string | undefined;
    targetMinutes!: number | undefined;
    tommorow!: boolean;
    arrival!: string | undefined;
    liveEta!: string | undefined;
    liveEtaTime!: moment.Moment;
    etaMinutes!: number | undefined;
    completionMinutes!: number | undefined;
    liveEtaMinutes!: number | undefined;
    currentTimeMinutes!: number | undefined;
    gridFillColor!: string | undefined;
    sampleTextColor!: string | undefined;
    gridTextColor!: string | undefined;
    samplesPickedUp!: number;
    targetDate!: moment.Moment;
    parentLHLists!: LineHaulList[] | undefined;
    isLinehaul!: boolean;

    constructor(data?: IGetLocationRouteDataCompletedOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.locationId = data["locationId"];
            this.loadDate = data["loadDate"];
            this.targetTime = data["targetTime"] ? TimeSpan.fromJS(data["targetTime"]) : <any>undefined;
            this.routeTemplateId = data["routeTemplateId"];
            this.route = data["route"];
            this.samples = data["samples"];
            this.target = data["target"];
            this.targetMinutes = data["targetMinutes"];
            this.tommorow = data["tommorow"];
            this.arrival = data["arrival"];
            this.liveEta = data["liveEta"];
            this.liveEtaTime = data["liveEtaTime"] ? moment(data["liveEtaTime"].toString()) : <any>undefined;
            this.etaMinutes = data["etaMinutes"];
            this.completionMinutes = data["completionMinutes"];
            this.liveEtaMinutes = data["liveEtaMinutes"];
            this.currentTimeMinutes = data["currentTimeMinutes"];
            this.gridFillColor = data["gridFillColor"];
            this.sampleTextColor = data["sampleTextColor"];
            this.gridTextColor = data["gridTextColor"];
            this.samplesPickedUp = data["samplesPickedUp"];
            this.targetDate = data["targetDate"] ? moment(data["targetDate"].toString()) : <any>undefined;
            if (Array.isArray(data["parentLHLists"])) {
                this.parentLHLists = [] as any;
                for (let item of data["parentLHLists"])
                    this.parentLHLists!.push(LineHaulList.fromJS(item));
            }
            this.isLinehaul = data["isLinehaul"];
        }
    }

    static fromJS(data: any): GetLocationRouteDataCompletedOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetLocationRouteDataCompletedOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["locationId"] = this.locationId;
        data["loadDate"] = this.loadDate;
        data["targetTime"] = this.targetTime ? this.targetTime.toJSON() : <any>undefined;
        data["routeTemplateId"] = this.routeTemplateId;
        data["route"] = this.route;
        data["samples"] = this.samples;
        data["target"] = this.target;
        data["targetMinutes"] = this.targetMinutes;
        data["tommorow"] = this.tommorow;
        data["arrival"] = this.arrival;
        data["liveEta"] = this.liveEta;
        data["liveEtaTime"] = this.liveEtaTime ? this.liveEtaTime.toISOString() : <any>undefined;
        data["etaMinutes"] = this.etaMinutes;
        data["completionMinutes"] = this.completionMinutes;
        data["liveEtaMinutes"] = this.liveEtaMinutes;
        data["currentTimeMinutes"] = this.currentTimeMinutes;
        data["gridFillColor"] = this.gridFillColor;
        data["sampleTextColor"] = this.sampleTextColor;
        data["gridTextColor"] = this.gridTextColor;
        data["samplesPickedUp"] = this.samplesPickedUp;
        data["targetDate"] = this.targetDate ? this.targetDate.toISOString() : <any>undefined;
        if (Array.isArray(this.parentLHLists)) {
            data["parentLHLists"] = [];
            for (let item of this.parentLHLists)
                data["parentLHLists"].push(item.toJSON());
        }
        data["isLinehaul"] = this.isLinehaul;
        return data; 
    }
}

export interface IGetLocationRouteDataCompletedOutput {
    routeId: number;
    locationId: number;
    loadDate: string | undefined;
    targetTime: TimeSpan;
    routeTemplateId: number;
    route: string | undefined;
    samples: number;
    target: string | undefined;
    targetMinutes: number | undefined;
    tommorow: boolean;
    arrival: string | undefined;
    liveEta: string | undefined;
    liveEtaTime: moment.Moment;
    etaMinutes: number | undefined;
    completionMinutes: number | undefined;
    liveEtaMinutes: number | undefined;
    currentTimeMinutes: number | undefined;
    gridFillColor: string | undefined;
    sampleTextColor: string | undefined;
    gridTextColor: string | undefined;
    samplesPickedUp: number;
    targetDate: moment.Moment;
    parentLHLists: LineHaulList[] | undefined;
    isLinehaul: boolean;
}

export class GetRouteTypeDataOutput implements IGetRouteTypeDataOutput {
    id!: number;
    name!: string | undefined;

    constructor(data?: IGetRouteTypeDataOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetRouteTypeDataOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteTypeDataOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetRouteTypeDataOutput {
    id: number;
    name: string | undefined;
}

export class GetLaboratoryDataOutput implements IGetLaboratoryDataOutput {
    contactId!: number;
    name!: string | undefined;
    address!: string | undefined;

    constructor(data?: IGetLaboratoryDataOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.contactId = data["contactId"];
            this.name = data["name"];
            this.address = data["address"];
        }
    }

    static fromJS(data: any): GetLaboratoryDataOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetLaboratoryDataOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["contactId"] = this.contactId;
        data["name"] = this.name;
        data["address"] = this.address;
        return data; 
    }
}

export interface IGetLaboratoryDataOutput {
    contactId: number;
    name: string | undefined;
    address: string | undefined;
}

export enum SubscriptionStartType {
    Free = 1,
    Trial = 2,
    Paid = 3,
}

export class RegisterTenantInput implements IRegisterTenantInput {
    tenancyName!: string;
    name!: string;
    adminEmailAddress!: string;
    adminPassword!: string | undefined;
    captchaResponse!: string | undefined;
    subscriptionStartType!: SubscriptionStartType;
    editionId!: number | undefined;

    constructor(data?: IRegisterTenantInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.name = data["name"];
            this.adminEmailAddress = data["adminEmailAddress"];
            this.adminPassword = data["adminPassword"];
            this.captchaResponse = data["captchaResponse"];
            this.subscriptionStartType = data["subscriptionStartType"];
            this.editionId = data["editionId"];
        }
    }

    static fromJS(data: any): RegisterTenantInput {
        data = typeof data === 'object' ? data : {};
        let result = new RegisterTenantInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["name"] = this.name;
        data["adminEmailAddress"] = this.adminEmailAddress;
        data["adminPassword"] = this.adminPassword;
        data["captchaResponse"] = this.captchaResponse;
        data["subscriptionStartType"] = this.subscriptionStartType;
        data["editionId"] = this.editionId;
        return data; 
    }
}

export interface IRegisterTenantInput {
    tenancyName: string;
    name: string;
    adminEmailAddress: string;
    adminPassword: string | undefined;
    captchaResponse: string | undefined;
    subscriptionStartType: SubscriptionStartType;
    editionId: number | undefined;
}

export class RegisterTenantOutput implements IRegisterTenantOutput {
    tenantId!: number;
    tenancyName!: string | undefined;
    name!: string | undefined;
    userName!: string | undefined;
    emailAddress!: string | undefined;
    isTenantActive!: boolean;
    isActive!: boolean;
    isEmailConfirmationRequired!: boolean;

    constructor(data?: IRegisterTenantOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenancyName = data["tenancyName"];
            this.name = data["name"];
            this.userName = data["userName"];
            this.emailAddress = data["emailAddress"];
            this.isTenantActive = data["isTenantActive"];
            this.isActive = data["isActive"];
            this.isEmailConfirmationRequired = data["isEmailConfirmationRequired"];
        }
    }

    static fromJS(data: any): RegisterTenantOutput {
        data = typeof data === 'object' ? data : {};
        let result = new RegisterTenantOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenancyName"] = this.tenancyName;
        data["name"] = this.name;
        data["userName"] = this.userName;
        data["emailAddress"] = this.emailAddress;
        data["isTenantActive"] = this.isTenantActive;
        data["isActive"] = this.isActive;
        data["isEmailConfirmationRequired"] = this.isEmailConfirmationRequired;
        return data; 
    }
}

export interface IRegisterTenantOutput {
    tenantId: number;
    tenancyName: string | undefined;
    name: string | undefined;
    userName: string | undefined;
    emailAddress: string | undefined;
    isTenantActive: boolean;
    isActive: boolean;
    isEmailConfirmationRequired: boolean;
}

export class IInputType implements IIInputType {
    readonly name!: string | undefined;
    readonly attributes!: { [key: string]: any; } | undefined;
    validator!: IValueValidator | undefined;

    constructor(data?: IIInputType) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            (<any>this).name = data["name"];
            if (data["attributes"]) {
                (<any>this).attributes = {} as any;
                for (let key in data["attributes"]) {
                    if (data["attributes"].hasOwnProperty(key))
                        (<any>this).attributes![key] = data["attributes"][key];
                }
            }
            this.validator = data["validator"] ? IValueValidator.fromJS(data["validator"]) : <any>undefined;
        }
    }

    static fromJS(data: any): IInputType {
        data = typeof data === 'object' ? data : {};
        let result = new IInputType();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        if (this.attributes) {
            data["attributes"] = {};
            for (let key in this.attributes) {
                if (this.attributes.hasOwnProperty(key))
                    data["attributes"][key] = this.attributes[key];
            }
        }
        data["validator"] = this.validator ? this.validator.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IIInputType {
    name: string | undefined;
    attributes: { [key: string]: any; } | undefined;
    validator: IValueValidator | undefined;
}

export class FlatFeatureSelectDto implements IFlatFeatureSelectDto {
    parentName!: string | undefined;
    name!: string | undefined;
    displayName!: string | undefined;
    description!: string | undefined;
    defaultValue!: string | undefined;
    inputType!: IInputType | undefined;
    textHtmlColor!: string | undefined;

    constructor(data?: IFlatFeatureSelectDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.parentName = data["parentName"];
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.description = data["description"];
            this.defaultValue = data["defaultValue"];
            this.inputType = data["inputType"] ? IInputType.fromJS(data["inputType"]) : <any>undefined;
            this.textHtmlColor = data["textHtmlColor"];
        }
    }

    static fromJS(data: any): FlatFeatureSelectDto {
        data = typeof data === 'object' ? data : {};
        let result = new FlatFeatureSelectDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["parentName"] = this.parentName;
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["description"] = this.description;
        data["defaultValue"] = this.defaultValue;
        data["inputType"] = this.inputType ? this.inputType.toJSON() : <any>undefined;
        data["textHtmlColor"] = this.textHtmlColor;
        return data; 
    }
}

export interface IFlatFeatureSelectDto {
    parentName: string | undefined;
    name: string | undefined;
    displayName: string | undefined;
    description: string | undefined;
    defaultValue: string | undefined;
    inputType: IInputType | undefined;
    textHtmlColor: string | undefined;
}

export class EditionWithFeaturesDto implements IEditionWithFeaturesDto {
    edition!: EditionSelectDto | undefined;
    featureValues!: NameValueDto[] | undefined;

    constructor(data?: IEditionWithFeaturesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.edition = data["edition"] ? EditionSelectDto.fromJS(data["edition"]) : <any>undefined;
            if (Array.isArray(data["featureValues"])) {
                this.featureValues = [] as any;
                for (let item of data["featureValues"])
                    this.featureValues!.push(NameValueDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): EditionWithFeaturesDto {
        data = typeof data === 'object' ? data : {};
        let result = new EditionWithFeaturesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["edition"] = this.edition ? this.edition.toJSON() : <any>undefined;
        if (Array.isArray(this.featureValues)) {
            data["featureValues"] = [];
            for (let item of this.featureValues)
                data["featureValues"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IEditionWithFeaturesDto {
    edition: EditionSelectDto | undefined;
    featureValues: NameValueDto[] | undefined;
}

export class EditionsSelectOutput implements IEditionsSelectOutput {
    allFeatures!: FlatFeatureSelectDto[] | undefined;
    editionsWithFeatures!: EditionWithFeaturesDto[] | undefined;

    constructor(data?: IEditionsSelectOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["allFeatures"])) {
                this.allFeatures = [] as any;
                for (let item of data["allFeatures"])
                    this.allFeatures!.push(FlatFeatureSelectDto.fromJS(item));
            }
            if (Array.isArray(data["editionsWithFeatures"])) {
                this.editionsWithFeatures = [] as any;
                for (let item of data["editionsWithFeatures"])
                    this.editionsWithFeatures!.push(EditionWithFeaturesDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): EditionsSelectOutput {
        data = typeof data === 'object' ? data : {};
        let result = new EditionsSelectOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.allFeatures)) {
            data["allFeatures"] = [];
            for (let item of this.allFeatures)
                data["allFeatures"].push(item.toJSON());
        }
        if (Array.isArray(this.editionsWithFeatures)) {
            data["editionsWithFeatures"] = [];
            for (let item of this.editionsWithFeatures)
                data["editionsWithFeatures"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IEditionsSelectOutput {
    allFeatures: FlatFeatureSelectDto[] | undefined;
    editionsWithFeatures: EditionWithFeaturesDto[] | undefined;
}

export class TenantUserManagementSettingsEditDto implements ITenantUserManagementSettingsEditDto {
    allowSelfRegistration!: boolean;
    isNewRegisteredUserActiveByDefault!: boolean;
    isEmailConfirmationRequiredForLogin!: boolean;
    useCaptchaOnRegistration!: boolean;
    useCaptchaOnLogin!: boolean;
    isCookieConsentEnabled!: boolean;
    isQuickThemeSelectEnabled!: boolean;
    sessionTimeOutSettings!: SessionTimeOutSettingsEditDto | undefined;

    constructor(data?: ITenantUserManagementSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.allowSelfRegistration = data["allowSelfRegistration"];
            this.isNewRegisteredUserActiveByDefault = data["isNewRegisteredUserActiveByDefault"];
            this.isEmailConfirmationRequiredForLogin = data["isEmailConfirmationRequiredForLogin"];
            this.useCaptchaOnRegistration = data["useCaptchaOnRegistration"];
            this.useCaptchaOnLogin = data["useCaptchaOnLogin"];
            this.isCookieConsentEnabled = data["isCookieConsentEnabled"];
            this.isQuickThemeSelectEnabled = data["isQuickThemeSelectEnabled"];
            this.sessionTimeOutSettings = data["sessionTimeOutSettings"] ? SessionTimeOutSettingsEditDto.fromJS(data["sessionTimeOutSettings"]) : <any>undefined;
        }
    }

    static fromJS(data: any): TenantUserManagementSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantUserManagementSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["allowSelfRegistration"] = this.allowSelfRegistration;
        data["isNewRegisteredUserActiveByDefault"] = this.isNewRegisteredUserActiveByDefault;
        data["isEmailConfirmationRequiredForLogin"] = this.isEmailConfirmationRequiredForLogin;
        data["useCaptchaOnRegistration"] = this.useCaptchaOnRegistration;
        data["useCaptchaOnLogin"] = this.useCaptchaOnLogin;
        data["isCookieConsentEnabled"] = this.isCookieConsentEnabled;
        data["isQuickThemeSelectEnabled"] = this.isQuickThemeSelectEnabled;
        data["sessionTimeOutSettings"] = this.sessionTimeOutSettings ? this.sessionTimeOutSettings.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ITenantUserManagementSettingsEditDto {
    allowSelfRegistration: boolean;
    isNewRegisteredUserActiveByDefault: boolean;
    isEmailConfirmationRequiredForLogin: boolean;
    useCaptchaOnRegistration: boolean;
    useCaptchaOnLogin: boolean;
    isCookieConsentEnabled: boolean;
    isQuickThemeSelectEnabled: boolean;
    sessionTimeOutSettings: SessionTimeOutSettingsEditDto | undefined;
}

export class TenantEmailSettingsEditDto implements ITenantEmailSettingsEditDto {
    useHostDefaultEmailSettings!: boolean;
    defaultFromAddress!: string | undefined;
    defaultFromDisplayName!: string | undefined;
    smtpHost!: string | undefined;
    smtpPort!: number;
    smtpUserName!: string | undefined;
    smtpPassword!: string | undefined;
    smtpDomain!: string | undefined;
    smtpEnableSsl!: boolean;
    smtpUseDefaultCredentials!: boolean;

    constructor(data?: ITenantEmailSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.useHostDefaultEmailSettings = data["useHostDefaultEmailSettings"];
            this.defaultFromAddress = data["defaultFromAddress"];
            this.defaultFromDisplayName = data["defaultFromDisplayName"];
            this.smtpHost = data["smtpHost"];
            this.smtpPort = data["smtpPort"];
            this.smtpUserName = data["smtpUserName"];
            this.smtpPassword = data["smtpPassword"];
            this.smtpDomain = data["smtpDomain"];
            this.smtpEnableSsl = data["smtpEnableSsl"];
            this.smtpUseDefaultCredentials = data["smtpUseDefaultCredentials"];
        }
    }

    static fromJS(data: any): TenantEmailSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantEmailSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["useHostDefaultEmailSettings"] = this.useHostDefaultEmailSettings;
        data["defaultFromAddress"] = this.defaultFromAddress;
        data["defaultFromDisplayName"] = this.defaultFromDisplayName;
        data["smtpHost"] = this.smtpHost;
        data["smtpPort"] = this.smtpPort;
        data["smtpUserName"] = this.smtpUserName;
        data["smtpPassword"] = this.smtpPassword;
        data["smtpDomain"] = this.smtpDomain;
        data["smtpEnableSsl"] = this.smtpEnableSsl;
        data["smtpUseDefaultCredentials"] = this.smtpUseDefaultCredentials;
        return data; 
    }
}

export interface ITenantEmailSettingsEditDto {
    useHostDefaultEmailSettings: boolean;
    defaultFromAddress: string | undefined;
    defaultFromDisplayName: string | undefined;
    smtpHost: string | undefined;
    smtpPort: number;
    smtpUserName: string | undefined;
    smtpPassword: string | undefined;
    smtpDomain: string | undefined;
    smtpEnableSsl: boolean;
    smtpUseDefaultCredentials: boolean;
}

export class LdapSettingsEditDto implements ILdapSettingsEditDto {
    isModuleEnabled!: boolean;
    isEnabled!: boolean;
    domain!: string | undefined;
    userName!: string | undefined;
    password!: string | undefined;

    constructor(data?: ILdapSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isModuleEnabled = data["isModuleEnabled"];
            this.isEnabled = data["isEnabled"];
            this.domain = data["domain"];
            this.userName = data["userName"];
            this.password = data["password"];
        }
    }

    static fromJS(data: any): LdapSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new LdapSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isModuleEnabled"] = this.isModuleEnabled;
        data["isEnabled"] = this.isEnabled;
        data["domain"] = this.domain;
        data["userName"] = this.userName;
        data["password"] = this.password;
        return data; 
    }
}

export interface ILdapSettingsEditDto {
    isModuleEnabled: boolean;
    isEnabled: boolean;
    domain: string | undefined;
    userName: string | undefined;
    password: string | undefined;
}

export class TenantBillingSettingsEditDto implements ITenantBillingSettingsEditDto {
    legalName!: string | undefined;
    address!: string | undefined;
    taxVatNo!: string | undefined;

    constructor(data?: ITenantBillingSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.legalName = data["legalName"];
            this.address = data["address"];
            this.taxVatNo = data["taxVatNo"];
        }
    }

    static fromJS(data: any): TenantBillingSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantBillingSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["legalName"] = this.legalName;
        data["address"] = this.address;
        data["taxVatNo"] = this.taxVatNo;
        return data; 
    }
}

export interface ITenantBillingSettingsEditDto {
    legalName: string | undefined;
    address: string | undefined;
    taxVatNo: string | undefined;
}

export class TenantOtherSettingsEditDto implements ITenantOtherSettingsEditDto {
    isQuickThemeSelectEnabled!: boolean;

    constructor(data?: ITenantOtherSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.isQuickThemeSelectEnabled = data["isQuickThemeSelectEnabled"];
        }
    }

    static fromJS(data: any): TenantOtherSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantOtherSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["isQuickThemeSelectEnabled"] = this.isQuickThemeSelectEnabled;
        return data; 
    }
}

export interface ITenantOtherSettingsEditDto {
    isQuickThemeSelectEnabled: boolean;
}

export class CustomSettingsEditDto implements ICustomSettingsEditDto {
    defaultAddressType!: string | undefined;
    googleTestMode!: boolean;
    postalCodeChecker!: string | undefined;

    constructor(data?: ICustomSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.defaultAddressType = data["defaultAddressType"];
            this.googleTestMode = data["googleTestMode"];
            this.postalCodeChecker = data["postalCodeChecker"];
        }
    }

    static fromJS(data: any): CustomSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new CustomSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["defaultAddressType"] = this.defaultAddressType;
        data["googleTestMode"] = this.googleTestMode;
        data["postalCodeChecker"] = this.postalCodeChecker;
        return data; 
    }
}

export interface ICustomSettingsEditDto {
    defaultAddressType: string | undefined;
    googleTestMode: boolean;
    postalCodeChecker: string | undefined;
}

export class OrderNumberDisplayTypeDto implements IOrderNumberDisplayTypeDto {
    orderNumberDisplayType!: string | undefined;

    constructor(data?: IOrderNumberDisplayTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderNumberDisplayType = data["orderNumberDisplayType"];
        }
    }

    static fromJS(data: any): OrderNumberDisplayTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new OrderNumberDisplayTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderNumberDisplayType"] = this.orderNumberDisplayType;
        return data; 
    }
}

export interface IOrderNumberDisplayTypeDto {
    orderNumberDisplayType: string | undefined;
}

export class TenantSettingsEditDto implements ITenantSettingsEditDto {
    general!: GeneralSettingsEditDto | undefined;
    blindCountLimit!: SetBlindCountLimitInputDto | undefined;
    userManagement!: TenantUserManagementSettingsEditDto;
    email!: TenantEmailSettingsEditDto | undefined;
    ldap!: LdapSettingsEditDto | undefined;
    security!: SecuritySettingsEditDto;
    billing!: TenantBillingSettingsEditDto | undefined;
    otherSettings!: TenantOtherSettingsEditDto | undefined;
    customSettings!: CustomSettingsEditDto | undefined;
    orderNumberDisplay!: OrderNumberDisplayTypeDto | undefined;

    constructor(data?: ITenantSettingsEditDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.userManagement = new TenantUserManagementSettingsEditDto();
            this.security = new SecuritySettingsEditDto();
        }
    }

    init(data?: any) {
        if (data) {
            this.general = data["general"] ? GeneralSettingsEditDto.fromJS(data["general"]) : <any>undefined;
            this.blindCountLimit = data["blindCountLimit"] ? SetBlindCountLimitInputDto.fromJS(data["blindCountLimit"]) : <any>undefined;
            this.userManagement = data["userManagement"] ? TenantUserManagementSettingsEditDto.fromJS(data["userManagement"]) : new TenantUserManagementSettingsEditDto();
            this.email = data["email"] ? TenantEmailSettingsEditDto.fromJS(data["email"]) : <any>undefined;
            this.ldap = data["ldap"] ? LdapSettingsEditDto.fromJS(data["ldap"]) : <any>undefined;
            this.security = data["security"] ? SecuritySettingsEditDto.fromJS(data["security"]) : new SecuritySettingsEditDto();
            this.billing = data["billing"] ? TenantBillingSettingsEditDto.fromJS(data["billing"]) : <any>undefined;
            this.otherSettings = data["otherSettings"] ? TenantOtherSettingsEditDto.fromJS(data["otherSettings"]) : <any>undefined;
            this.customSettings = data["customSettings"] ? CustomSettingsEditDto.fromJS(data["customSettings"]) : <any>undefined;
            this.orderNumberDisplay = data["orderNumberDisplay"] ? OrderNumberDisplayTypeDto.fromJS(data["orderNumberDisplay"]) : <any>undefined;
        }
    }

    static fromJS(data: any): TenantSettingsEditDto {
        data = typeof data === 'object' ? data : {};
        let result = new TenantSettingsEditDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["general"] = this.general ? this.general.toJSON() : <any>undefined;
        data["blindCountLimit"] = this.blindCountLimit ? this.blindCountLimit.toJSON() : <any>undefined;
        data["userManagement"] = this.userManagement ? this.userManagement.toJSON() : <any>undefined;
        data["email"] = this.email ? this.email.toJSON() : <any>undefined;
        data["ldap"] = this.ldap ? this.ldap.toJSON() : <any>undefined;
        data["security"] = this.security ? this.security.toJSON() : <any>undefined;
        data["billing"] = this.billing ? this.billing.toJSON() : <any>undefined;
        data["otherSettings"] = this.otherSettings ? this.otherSettings.toJSON() : <any>undefined;
        data["customSettings"] = this.customSettings ? this.customSettings.toJSON() : <any>undefined;
        data["orderNumberDisplay"] = this.orderNumberDisplay ? this.orderNumberDisplay.toJSON() : <any>undefined;
        return data; 
    }
}

export interface ITenantSettingsEditDto {
    general: GeneralSettingsEditDto | undefined;
    blindCountLimit: SetBlindCountLimitInputDto | undefined;
    userManagement: TenantUserManagementSettingsEditDto;
    email: TenantEmailSettingsEditDto | undefined;
    ldap: LdapSettingsEditDto | undefined;
    security: SecuritySettingsEditDto;
    billing: TenantBillingSettingsEditDto | undefined;
    otherSettings: TenantOtherSettingsEditDto | undefined;
    customSettings: CustomSettingsEditDto | undefined;
    orderNumberDisplay: OrderNumberDisplayTypeDto | undefined;
}

export class CreateOrUpdateTextToSpeechSettingInputDto implements ICreateOrUpdateTextToSpeechSettingInputDto {
    code!: string | undefined;
    description!: string | undefined;
    content!: string | undefined;

    constructor(data?: ICreateOrUpdateTextToSpeechSettingInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.content = data["content"];
        }
    }

    static fromJS(data: any): CreateOrUpdateTextToSpeechSettingInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateTextToSpeechSettingInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["content"] = this.content;
        return data; 
    }
}

export interface ICreateOrUpdateTextToSpeechSettingInputDto {
    code: string | undefined;
    description: string | undefined;
    content: string | undefined;
}

export class GetTextToSpeechSettingListItemDto implements IGetTextToSpeechSettingListItemDto {
    code!: string | undefined;
    description!: string | undefined;
    content!: string | undefined;

    constructor(data?: IGetTextToSpeechSettingListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.content = data["content"];
        }
    }

    static fromJS(data: any): GetTextToSpeechSettingListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetTextToSpeechSettingListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["content"] = this.content;
        return data; 
    }
}

export interface IGetTextToSpeechSettingListItemDto {
    code: string | undefined;
    description: string | undefined;
    content: string | undefined;
}

export class ListResultDtoOfGetTextToSpeechSettingListItemDto implements IListResultDtoOfGetTextToSpeechSettingListItemDto {
    items!: GetTextToSpeechSettingListItemDto[] | undefined;

    constructor(data?: IListResultDtoOfGetTextToSpeechSettingListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetTextToSpeechSettingListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetTextToSpeechSettingListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetTextToSpeechSettingListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetTextToSpeechSettingListItemDto {
    items: GetTextToSpeechSettingListItemDto[] | undefined;
}

export class PagedResultDtoOfGetTextToSpeechSettingListItemDto implements IPagedResultDtoOfGetTextToSpeechSettingListItemDto {
    totalCount!: number;
    items!: GetTextToSpeechSettingListItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetTextToSpeechSettingListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetTextToSpeechSettingListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetTextToSpeechSettingListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetTextToSpeechSettingListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetTextToSpeechSettingListItemDto {
    totalCount: number;
    items: GetTextToSpeechSettingListItemDto[] | undefined;
}

export class CreateTimeSheetInput implements ICreateTimeSheetInput {
    creatorUserId!: number;
    loginTime!: moment.Moment;
    logoutTime!: moment.Moment | undefined;

    constructor(data?: ICreateTimeSheetInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.creatorUserId = data["creatorUserId"];
            this.loginTime = data["loginTime"] ? moment(data["loginTime"].toString()) : <any>undefined;
            this.logoutTime = data["logoutTime"] ? moment(data["logoutTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateTimeSheetInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateTimeSheetInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["creatorUserId"] = this.creatorUserId;
        data["loginTime"] = this.loginTime ? this.loginTime.toISOString() : <any>undefined;
        data["logoutTime"] = this.logoutTime ? this.logoutTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ICreateTimeSheetInput {
    creatorUserId: number;
    loginTime: moment.Moment;
    logoutTime: moment.Moment | undefined;
}

export class PagedResultDtoOfTimeSheetListDto implements IPagedResultDtoOfTimeSheetListDto {
    totalCount!: number;
    items!: TimeSheetListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfTimeSheetListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TimeSheetListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfTimeSheetListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfTimeSheetListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfTimeSheetListDto {
    totalCount: number;
    items: TimeSheetListDto[] | undefined;
}

export class UpdateTimeSheetInput implements IUpdateTimeSheetInput {
    id!: number;
    creatorUserId!: number;
    loginTime!: moment.Moment;
    logoutTime!: moment.Moment;

    constructor(data?: IUpdateTimeSheetInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.creatorUserId = data["creatorUserId"];
            this.loginTime = data["loginTime"] ? moment(data["loginTime"].toString()) : <any>undefined;
            this.logoutTime = data["logoutTime"] ? moment(data["logoutTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): UpdateTimeSheetInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateTimeSheetInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["creatorUserId"] = this.creatorUserId;
        data["loginTime"] = this.loginTime ? this.loginTime.toISOString() : <any>undefined;
        data["logoutTime"] = this.logoutTime ? this.logoutTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IUpdateTimeSheetInput {
    id: number;
    creatorUserId: number;
    loginTime: moment.Moment;
    logoutTime: moment.Moment;
}

export class CreateTimeZoneInput implements ICreateTimeZoneInput {
    value!: string | undefined;

    constructor(data?: ICreateTimeZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreateTimeZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateTimeZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreateTimeZoneInput {
    value: string | undefined;
}

export class ListResultDtoOfTimeZoneListDto implements IListResultDtoOfTimeZoneListDto {
    items!: TimeZoneListDto[] | undefined;

    constructor(data?: IListResultDtoOfTimeZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TimeZoneListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfTimeZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfTimeZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfTimeZoneListDto {
    items: TimeZoneListDto[] | undefined;
}

export class PagedResultDtoOfTimeZoneListDto implements IPagedResultDtoOfTimeZoneListDto {
    totalCount!: number;
    items!: TimeZoneListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfTimeZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(TimeZoneListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfTimeZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfTimeZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfTimeZoneListDto {
    totalCount: number;
    items: TimeZoneListDto[] | undefined;
}

export class UpdateTimeZoneInput implements IUpdateTimeZoneInput {
    value!: string | undefined;
    id!: number;

    constructor(data?: IUpdateTimeZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UpdateTimeZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateTimeZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUpdateTimeZoneInput {
    value: string | undefined;
    id: number;
}

export class CreateMultipleTimeZoneInput implements ICreateMultipleTimeZoneInput {
    value!: string | undefined;
    offset!: string | undefined;

    constructor(data?: ICreateMultipleTimeZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.offset = data["offset"];
        }
    }

    static fromJS(data: any): CreateMultipleTimeZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateMultipleTimeZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["offset"] = this.offset;
        return data; 
    }
}

export interface ICreateMultipleTimeZoneInput {
    value: string | undefined;
    offset: string | undefined;
}

export class AddMultipleTimeZone implements IAddMultipleTimeZone {
    multipleTimeZone!: CreateMultipleTimeZoneInput[] | undefined;

    constructor(data?: IAddMultipleTimeZone) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["multipleTimeZone"])) {
                this.multipleTimeZone = [] as any;
                for (let item of data["multipleTimeZone"])
                    this.multipleTimeZone!.push(CreateMultipleTimeZoneInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): AddMultipleTimeZone {
        data = typeof data === 'object' ? data : {};
        let result = new AddMultipleTimeZone();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.multipleTimeZone)) {
            data["multipleTimeZone"] = [];
            for (let item of this.multipleTimeZone)
                data["multipleTimeZone"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IAddMultipleTimeZone {
    multipleTimeZone: CreateMultipleTimeZoneInput[] | undefined;
}

export class TimeZoneDto implements ITimeZoneDto {
    value!: string | undefined;
    offSet!: string | undefined;
    id!: number;

    constructor(data?: ITimeZoneDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.offSet = data["offSet"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): TimeZoneDto {
        data = typeof data === 'object' ? data : {};
        let result = new TimeZoneDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["offSet"] = this.offSet;
        data["id"] = this.id;
        return data; 
    }
}

export interface ITimeZoneDto {
    value: string | undefined;
    offSet: string | undefined;
    id: number;
}

export class GetTimeZoneForViewDto implements IGetTimeZoneForViewDto {
    timeZone!: TimeZoneDto | undefined;

    constructor(data?: IGetTimeZoneForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.timeZone = data["timeZone"] ? TimeZoneDto.fromJS(data["timeZone"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetTimeZoneForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetTimeZoneForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["timeZone"] = this.timeZone ? this.timeZone.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetTimeZoneForViewDto {
    timeZone: TimeZoneDto | undefined;
}

export class PagedResultDtoOfGetTimeZoneForViewDto implements IPagedResultDtoOfGetTimeZoneForViewDto {
    totalCount!: number;
    items!: GetTimeZoneForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetTimeZoneForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetTimeZoneForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetTimeZoneForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetTimeZoneForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetTimeZoneForViewDto {
    totalCount: number;
    items: GetTimeZoneForViewDto[] | undefined;
}

export class CreateOrEditTimeZoneDto implements ICreateOrEditTimeZoneDto {
    value!: string;
    id!: number | undefined;

    constructor(data?: ICreateOrEditTimeZoneDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.value = data["value"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditTimeZoneDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditTimeZoneDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["value"] = this.value;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditTimeZoneDto {
    value: string;
    id: number | undefined;
}

export class GetTimeZoneForEditOutput implements IGetTimeZoneForEditOutput {
    timeZone!: CreateOrEditTimeZoneDto | undefined;

    constructor(data?: IGetTimeZoneForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.timeZone = data["timeZone"] ? CreateOrEditTimeZoneDto.fromJS(data["timeZone"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetTimeZoneForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetTimeZoneForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["timeZone"] = this.timeZone ? this.timeZone.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetTimeZoneForEditOutput {
    timeZone: CreateOrEditTimeZoneDto | undefined;
}

export enum SettingScopes {
    Application = 1,
    Tenant = 2,
    User = 4,
    All = 7,
}

export class ListResultDtoOfNameValueDto implements IListResultDtoOfNameValueDto {
    items!: NameValueDto[] | undefined;

    constructor(data?: IListResultDtoOfNameValueDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(NameValueDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfNameValueDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfNameValueDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfNameValueDto {
    items: NameValueDto[] | undefined;
}

export class ExternalClient implements IExternalClient {
    tenant!: string | undefined;
    mobileClient!: CreateMobileClientInput | undefined;

    constructor(data?: IExternalClient) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenant = data["tenant"];
            this.mobileClient = data["mobileClient"] ? CreateMobileClientInput.fromJS(data["mobileClient"]) : <any>undefined;
        }
    }

    static fromJS(data: any): ExternalClient {
        data = typeof data === 'object' ? data : {};
        let result = new ExternalClient();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenant"] = this.tenant;
        data["mobileClient"] = this.mobileClient ? this.mobileClient.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IExternalClient {
    tenant: string | undefined;
    mobileClient: CreateMobileClientInput | undefined;
}

export class AuthenticateModel implements IAuthenticateModel {
    userNameOrEmailAddress!: string;
    password!: string;
    twoFactorVerificationCode!: string | undefined;
    rememberClient!: boolean;
    twoFactorRememberClientToken!: string | undefined;
    singleSignIn!: boolean | undefined;
    returnUrl!: string | undefined;
    captchaResponse!: string | undefined;
    external!: ExternalClient | undefined;

    constructor(data?: IAuthenticateModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userNameOrEmailAddress = data["userNameOrEmailAddress"];
            this.password = data["password"];
            this.twoFactorVerificationCode = data["twoFactorVerificationCode"];
            this.rememberClient = data["rememberClient"];
            this.twoFactorRememberClientToken = data["twoFactorRememberClientToken"];
            this.singleSignIn = data["singleSignIn"];
            this.returnUrl = data["returnUrl"];
            this.captchaResponse = data["captchaResponse"];
            this.external = data["external"] ? ExternalClient.fromJS(data["external"]) : <any>undefined;
        }
    }

    static fromJS(data: any): AuthenticateModel {
        data = typeof data === 'object' ? data : {};
        let result = new AuthenticateModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userNameOrEmailAddress"] = this.userNameOrEmailAddress;
        data["password"] = this.password;
        data["twoFactorVerificationCode"] = this.twoFactorVerificationCode;
        data["rememberClient"] = this.rememberClient;
        data["twoFactorRememberClientToken"] = this.twoFactorRememberClientToken;
        data["singleSignIn"] = this.singleSignIn;
        data["returnUrl"] = this.returnUrl;
        data["captchaResponse"] = this.captchaResponse;
        data["external"] = this.external ? this.external.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IAuthenticateModel {
    userNameOrEmailAddress: string;
    password: string;
    twoFactorVerificationCode: string | undefined;
    rememberClient: boolean;
    twoFactorRememberClientToken: string | undefined;
    singleSignIn: boolean | undefined;
    returnUrl: string | undefined;
    captchaResponse: string | undefined;
    external: ExternalClient | undefined;
}

export class AuthenticateResultModel implements IAuthenticateResultModel {
    accessToken!: string | undefined;
    encryptedAccessToken!: string | undefined;
    expireInSeconds!: number;
    shouldResetPassword!: boolean;
    passwordResetCode!: string | undefined;
    userId!: number;
    requiresTwoFactorVerification!: boolean;
    twoFactorAuthProviders!: string[] | undefined;
    twoFactorRememberClientToken!: string | undefined;
    returnUrl!: string | undefined;
    refreshToken!: string | undefined;
    refreshTokenExpireInSeconds!: number;

    constructor(data?: IAuthenticateResultModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accessToken = data["accessToken"];
            this.encryptedAccessToken = data["encryptedAccessToken"];
            this.expireInSeconds = data["expireInSeconds"];
            this.shouldResetPassword = data["shouldResetPassword"];
            this.passwordResetCode = data["passwordResetCode"];
            this.userId = data["userId"];
            this.requiresTwoFactorVerification = data["requiresTwoFactorVerification"];
            if (Array.isArray(data["twoFactorAuthProviders"])) {
                this.twoFactorAuthProviders = [] as any;
                for (let item of data["twoFactorAuthProviders"])
                    this.twoFactorAuthProviders!.push(item);
            }
            this.twoFactorRememberClientToken = data["twoFactorRememberClientToken"];
            this.returnUrl = data["returnUrl"];
            this.refreshToken = data["refreshToken"];
            this.refreshTokenExpireInSeconds = data["refreshTokenExpireInSeconds"];
        }
    }

    static fromJS(data: any): AuthenticateResultModel {
        data = typeof data === 'object' ? data : {};
        let result = new AuthenticateResultModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accessToken"] = this.accessToken;
        data["encryptedAccessToken"] = this.encryptedAccessToken;
        data["expireInSeconds"] = this.expireInSeconds;
        data["shouldResetPassword"] = this.shouldResetPassword;
        data["passwordResetCode"] = this.passwordResetCode;
        data["userId"] = this.userId;
        data["requiresTwoFactorVerification"] = this.requiresTwoFactorVerification;
        if (Array.isArray(this.twoFactorAuthProviders)) {
            data["twoFactorAuthProviders"] = [];
            for (let item of this.twoFactorAuthProviders)
                data["twoFactorAuthProviders"].push(item);
        }
        data["twoFactorRememberClientToken"] = this.twoFactorRememberClientToken;
        data["returnUrl"] = this.returnUrl;
        data["refreshToken"] = this.refreshToken;
        data["refreshTokenExpireInSeconds"] = this.refreshTokenExpireInSeconds;
        return data; 
    }
}

export interface IAuthenticateResultModel {
    accessToken: string | undefined;
    encryptedAccessToken: string | undefined;
    expireInSeconds: number;
    shouldResetPassword: boolean;
    passwordResetCode: string | undefined;
    userId: number;
    requiresTwoFactorVerification: boolean;
    twoFactorAuthProviders: string[] | undefined;
    twoFactorRememberClientToken: string | undefined;
    returnUrl: string | undefined;
    refreshToken: string | undefined;
    refreshTokenExpireInSeconds: number;
}

export class RefreshTokenResult implements IRefreshTokenResult {
    accessToken!: string | undefined;
    encryptedAccessToken!: string | undefined;
    expireInSeconds!: number;

    constructor(data?: IRefreshTokenResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accessToken = data["accessToken"];
            this.encryptedAccessToken = data["encryptedAccessToken"];
            this.expireInSeconds = data["expireInSeconds"];
        }
    }

    static fromJS(data: any): RefreshTokenResult {
        data = typeof data === 'object' ? data : {};
        let result = new RefreshTokenResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accessToken"] = this.accessToken;
        data["encryptedAccessToken"] = this.encryptedAccessToken;
        data["expireInSeconds"] = this.expireInSeconds;
        return data; 
    }
}

export interface IRefreshTokenResult {
    accessToken: string | undefined;
    encryptedAccessToken: string | undefined;
    expireInSeconds: number;
}

export class SendTwoFactorAuthCodeModel implements ISendTwoFactorAuthCodeModel {
    userId!: number;
    provider!: string;

    constructor(data?: ISendTwoFactorAuthCodeModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.provider = data["provider"];
        }
    }

    static fromJS(data: any): SendTwoFactorAuthCodeModel {
        data = typeof data === 'object' ? data : {};
        let result = new SendTwoFactorAuthCodeModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["provider"] = this.provider;
        return data; 
    }
}

export interface ISendTwoFactorAuthCodeModel {
    userId: number;
    provider: string;
}

export class ImpersonatedAuthenticateResultModel implements IImpersonatedAuthenticateResultModel {
    accessToken!: string | undefined;
    encryptedAccessToken!: string | undefined;
    expireInSeconds!: number;

    constructor(data?: IImpersonatedAuthenticateResultModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accessToken = data["accessToken"];
            this.encryptedAccessToken = data["encryptedAccessToken"];
            this.expireInSeconds = data["expireInSeconds"];
        }
    }

    static fromJS(data: any): ImpersonatedAuthenticateResultModel {
        data = typeof data === 'object' ? data : {};
        let result = new ImpersonatedAuthenticateResultModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accessToken"] = this.accessToken;
        data["encryptedAccessToken"] = this.encryptedAccessToken;
        data["expireInSeconds"] = this.expireInSeconds;
        return data; 
    }
}

export interface IImpersonatedAuthenticateResultModel {
    accessToken: string | undefined;
    encryptedAccessToken: string | undefined;
    expireInSeconds: number;
}

export class SwitchedAccountAuthenticateResultModel implements ISwitchedAccountAuthenticateResultModel {
    accessToken!: string | undefined;
    encryptedAccessToken!: string | undefined;
    expireInSeconds!: number;

    constructor(data?: ISwitchedAccountAuthenticateResultModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accessToken = data["accessToken"];
            this.encryptedAccessToken = data["encryptedAccessToken"];
            this.expireInSeconds = data["expireInSeconds"];
        }
    }

    static fromJS(data: any): SwitchedAccountAuthenticateResultModel {
        data = typeof data === 'object' ? data : {};
        let result = new SwitchedAccountAuthenticateResultModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accessToken"] = this.accessToken;
        data["encryptedAccessToken"] = this.encryptedAccessToken;
        data["expireInSeconds"] = this.expireInSeconds;
        return data; 
    }
}

export interface ISwitchedAccountAuthenticateResultModel {
    accessToken: string | undefined;
    encryptedAccessToken: string | undefined;
    expireInSeconds: number;
}

export class ExternalLoginProviderInfoModel implements IExternalLoginProviderInfoModel {
    name!: string | undefined;
    clientId!: string | undefined;
    additionalParams!: { [key: string]: string; } | undefined;

    constructor(data?: IExternalLoginProviderInfoModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.clientId = data["clientId"];
            if (data["additionalParams"]) {
                this.additionalParams = {} as any;
                for (let key in data["additionalParams"]) {
                    if (data["additionalParams"].hasOwnProperty(key))
                        this.additionalParams![key] = data["additionalParams"][key];
                }
            }
        }
    }

    static fromJS(data: any): ExternalLoginProviderInfoModel {
        data = typeof data === 'object' ? data : {};
        let result = new ExternalLoginProviderInfoModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["clientId"] = this.clientId;
        if (this.additionalParams) {
            data["additionalParams"] = {};
            for (let key in this.additionalParams) {
                if (this.additionalParams.hasOwnProperty(key))
                    data["additionalParams"][key] = this.additionalParams[key];
            }
        }
        return data; 
    }
}

export interface IExternalLoginProviderInfoModel {
    name: string | undefined;
    clientId: string | undefined;
    additionalParams: { [key: string]: string; } | undefined;
}

export class ExternalAuthenticateModel implements IExternalAuthenticateModel {
    authProvider!: string;
    providerKey!: string;
    providerAccessCode!: string;
    returnUrl!: string | undefined;
    singleSignIn!: boolean | undefined;

    constructor(data?: IExternalAuthenticateModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.authProvider = data["authProvider"];
            this.providerKey = data["providerKey"];
            this.providerAccessCode = data["providerAccessCode"];
            this.returnUrl = data["returnUrl"];
            this.singleSignIn = data["singleSignIn"];
        }
    }

    static fromJS(data: any): ExternalAuthenticateModel {
        data = typeof data === 'object' ? data : {};
        let result = new ExternalAuthenticateModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["authProvider"] = this.authProvider;
        data["providerKey"] = this.providerKey;
        data["providerAccessCode"] = this.providerAccessCode;
        data["returnUrl"] = this.returnUrl;
        data["singleSignIn"] = this.singleSignIn;
        return data; 
    }
}

export interface IExternalAuthenticateModel {
    authProvider: string;
    providerKey: string;
    providerAccessCode: string;
    returnUrl: string | undefined;
    singleSignIn: boolean | undefined;
}

export class ExternalAuthenticateResultModel implements IExternalAuthenticateResultModel {
    accessToken!: string | undefined;
    encryptedAccessToken!: string | undefined;
    expireInSeconds!: number;
    waitingForActivation!: boolean;
    returnUrl!: string | undefined;
    refreshToken!: string | undefined;
    refreshTokenExpireInSeconds!: number;

    constructor(data?: IExternalAuthenticateResultModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.accessToken = data["accessToken"];
            this.encryptedAccessToken = data["encryptedAccessToken"];
            this.expireInSeconds = data["expireInSeconds"];
            this.waitingForActivation = data["waitingForActivation"];
            this.returnUrl = data["returnUrl"];
            this.refreshToken = data["refreshToken"];
            this.refreshTokenExpireInSeconds = data["refreshTokenExpireInSeconds"];
        }
    }

    static fromJS(data: any): ExternalAuthenticateResultModel {
        data = typeof data === 'object' ? data : {};
        let result = new ExternalAuthenticateResultModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["accessToken"] = this.accessToken;
        data["encryptedAccessToken"] = this.encryptedAccessToken;
        data["expireInSeconds"] = this.expireInSeconds;
        data["waitingForActivation"] = this.waitingForActivation;
        data["returnUrl"] = this.returnUrl;
        data["refreshToken"] = this.refreshToken;
        data["refreshTokenExpireInSeconds"] = this.refreshTokenExpireInSeconds;
        return data; 
    }
}

export interface IExternalAuthenticateResultModel {
    accessToken: string | undefined;
    encryptedAccessToken: string | undefined;
    expireInSeconds: number;
    waitingForActivation: boolean;
    returnUrl: string | undefined;
    refreshToken: string | undefined;
    refreshTokenExpireInSeconds: number;
}

export class DriverAuthResultModel implements IDriverAuthResultModel {
    session!: AuthenticateResultModel | undefined;
    profile!: DriverClientProfile | undefined;

    constructor(data?: IDriverAuthResultModel) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.session = data["session"] ? AuthenticateResultModel.fromJS(data["session"]) : <any>undefined;
            this.profile = data["profile"] ? DriverClientProfile.fromJS(data["profile"]) : <any>undefined;
        }
    }

    static fromJS(data: any): DriverAuthResultModel {
        data = typeof data === 'object' ? data : {};
        let result = new DriverAuthResultModel();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["session"] = this.session ? this.session.toJSON() : <any>undefined;
        data["profile"] = this.profile ? this.profile.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IDriverAuthResultModel {
    session: AuthenticateResultModel | undefined;
    profile: DriverClientProfile | undefined;
}

export class GetUnassignedRouteListDto implements IGetUnassignedRouteListDto {
    routeId!: number;
    routeName!: string | undefined;
    loadDate!: moment.Moment;
    totalOrders!: number;

    constructor(data?: IGetUnassignedRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.routeName = data["routeName"];
            this.loadDate = data["loadDate"] ? moment(data["loadDate"].toString()) : <any>undefined;
            this.totalOrders = data["totalOrders"];
        }
    }

    static fromJS(data: any): GetUnassignedRouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetUnassignedRouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["routeName"] = this.routeName;
        data["loadDate"] = this.loadDate ? this.loadDate.toISOString() : <any>undefined;
        data["totalOrders"] = this.totalOrders;
        return data; 
    }
}

export interface IGetUnassignedRouteListDto {
    routeId: number;
    routeName: string | undefined;
    loadDate: moment.Moment;
    totalOrders: number;
}

export class PagedResultDtoOfGetUnassignedRouteListDto implements IPagedResultDtoOfGetUnassignedRouteListDto {
    totalCount!: number;
    items!: GetUnassignedRouteListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetUnassignedRouteListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetUnassignedRouteListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetUnassignedRouteListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetUnassignedRouteListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetUnassignedRouteListDto {
    totalCount: number;
    items: GetUnassignedRouteListDto[] | undefined;
}

export class GetUnassignedOrderListDto implements IGetUnassignedOrderListDto {
    routeId!: number | undefined;
    orderId!: number;
    zone!: string | undefined;
    recipientName!: string | undefined;
    recipientAddress1!: string | undefined;
    recipientCity!: string | undefined;
    recipientState!: string | undefined;
    recipientCountry!: string | undefined;
    recipientPostCode!: string | undefined;
    senderName!: string | undefined;
    routeCode!: string | undefined;
    orderTag!: string | undefined;
    senderAddress1!: string | undefined;
    senderCity!: string | undefined;
    senderState!: string | undefined;
    senderCountry!: string | undefined;
    senderPostCode!: string | undefined;

    constructor(data?: IGetUnassignedOrderListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.orderId = data["orderId"];
            this.zone = data["zone"];
            this.recipientName = data["recipientName"];
            this.recipientAddress1 = data["recipientAddress1"];
            this.recipientCity = data["recipientCity"];
            this.recipientState = data["recipientState"];
            this.recipientCountry = data["recipientCountry"];
            this.recipientPostCode = data["recipientPostCode"];
            this.senderName = data["senderName"];
            this.routeCode = data["routeCode"];
            this.orderTag = data["orderTag"];
            this.senderAddress1 = data["senderAddress1"];
            this.senderCity = data["senderCity"];
            this.senderState = data["senderState"];
            this.senderCountry = data["senderCountry"];
            this.senderPostCode = data["senderPostCode"];
        }
    }

    static fromJS(data: any): GetUnassignedOrderListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetUnassignedOrderListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["orderId"] = this.orderId;
        data["zone"] = this.zone;
        data["recipientName"] = this.recipientName;
        data["recipientAddress1"] = this.recipientAddress1;
        data["recipientCity"] = this.recipientCity;
        data["recipientState"] = this.recipientState;
        data["recipientCountry"] = this.recipientCountry;
        data["recipientPostCode"] = this.recipientPostCode;
        data["senderName"] = this.senderName;
        data["routeCode"] = this.routeCode;
        data["orderTag"] = this.orderTag;
        data["senderAddress1"] = this.senderAddress1;
        data["senderCity"] = this.senderCity;
        data["senderState"] = this.senderState;
        data["senderCountry"] = this.senderCountry;
        data["senderPostCode"] = this.senderPostCode;
        return data; 
    }
}

export interface IGetUnassignedOrderListDto {
    routeId: number | undefined;
    orderId: number;
    zone: string | undefined;
    recipientName: string | undefined;
    recipientAddress1: string | undefined;
    recipientCity: string | undefined;
    recipientState: string | undefined;
    recipientCountry: string | undefined;
    recipientPostCode: string | undefined;
    senderName: string | undefined;
    routeCode: string | undefined;
    orderTag: string | undefined;
    senderAddress1: string | undefined;
    senderCity: string | undefined;
    senderState: string | undefined;
    senderCountry: string | undefined;
    senderPostCode: string | undefined;
}

export class PagedResultDtoOfGetUnassignedOrderListDto implements IPagedResultDtoOfGetUnassignedOrderListDto {
    totalCount!: number;
    items!: GetUnassignedOrderListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetUnassignedOrderListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetUnassignedOrderListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetUnassignedOrderListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetUnassignedOrderListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetUnassignedOrderListDto {
    totalCount: number;
    items: GetUnassignedOrderListDto[] | undefined;
}

export class AssignRouteToDriverAndVehicleDto implements IAssignRouteToDriverAndVehicleDto {
    routeId!: number;
    vehicleId!: number;
    driverId!: number;

    constructor(data?: IAssignRouteToDriverAndVehicleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.vehicleId = data["vehicleId"];
            this.driverId = data["driverId"];
        }
    }

    static fromJS(data: any): AssignRouteToDriverAndVehicleDto {
        data = typeof data === 'object' ? data : {};
        let result = new AssignRouteToDriverAndVehicleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["vehicleId"] = this.vehicleId;
        data["driverId"] = this.driverId;
        return data; 
    }
}

export interface IAssignRouteToDriverAndVehicleDto {
    routeId: number;
    vehicleId: number;
    driverId: number;
}

export class GetUserForEditOutput implements IGetUserForEditOutput {
    profilePictureId!: string | undefined;
    user!: UserEditDto | undefined;
    roles!: UserRoleDto[] | undefined;
    allOrganizationUnits!: OrganizationUnitDto[] | undefined;
    memberedOrganizationUnits!: string[] | undefined;

    constructor(data?: IGetUserForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.profilePictureId = data["profilePictureId"];
            this.user = data["user"] ? UserEditDto.fromJS(data["user"]) : <any>undefined;
            if (Array.isArray(data["roles"])) {
                this.roles = [] as any;
                for (let item of data["roles"])
                    this.roles!.push(UserRoleDto.fromJS(item));
            }
            if (Array.isArray(data["allOrganizationUnits"])) {
                this.allOrganizationUnits = [] as any;
                for (let item of data["allOrganizationUnits"])
                    this.allOrganizationUnits!.push(OrganizationUnitDto.fromJS(item));
            }
            if (Array.isArray(data["memberedOrganizationUnits"])) {
                this.memberedOrganizationUnits = [] as any;
                for (let item of data["memberedOrganizationUnits"])
                    this.memberedOrganizationUnits!.push(item);
            }
        }
    }

    static fromJS(data: any): GetUserForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["profilePictureId"] = this.profilePictureId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        if (Array.isArray(this.roles)) {
            data["roles"] = [];
            for (let item of this.roles)
                data["roles"].push(item.toJSON());
        }
        if (Array.isArray(this.allOrganizationUnits)) {
            data["allOrganizationUnits"] = [];
            for (let item of this.allOrganizationUnits)
                data["allOrganizationUnits"].push(item.toJSON());
        }
        if (Array.isArray(this.memberedOrganizationUnits)) {
            data["memberedOrganizationUnits"] = [];
            for (let item of this.memberedOrganizationUnits)
                data["memberedOrganizationUnits"].push(item);
        }
        return data; 
    }
}

export interface IGetUserForEditOutput {
    profilePictureId: string | undefined;
    user: UserEditDto | undefined;
    roles: UserRoleDto[] | undefined;
    allOrganizationUnits: OrganizationUnitDto[] | undefined;
    memberedOrganizationUnits: string[] | undefined;
}

export class GetUserEventResultListItemDto implements IGetUserEventResultListItemDto {
    tenantId!: number | undefined;
    time!: moment.Moment;
    geocode!: GeocodeListDto | undefined;
    code!: string | undefined;
    value!: string | undefined;

    constructor(data?: IGetUserEventResultListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.code = data["code"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): GetUserEventResultListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserEventResultListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["code"] = this.code;
        data["value"] = this.value;
        return data; 
    }
}

export interface IGetUserEventResultListItemDto {
    tenantId: number | undefined;
    time: moment.Moment;
    geocode: GeocodeListDto | undefined;
    code: string | undefined;
    value: string | undefined;
}

export class PagedResultDtoOfGetUserEventResultListItemDto implements IPagedResultDtoOfGetUserEventResultListItemDto {
    totalCount!: number;
    items!: GetUserEventResultListItemDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetUserEventResultListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetUserEventResultListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetUserEventResultListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetUserEventResultListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetUserEventResultListItemDto {
    totalCount: number;
    items: GetUserEventResultListItemDto[] | undefined;
}

export class CreateUserEventInputDto implements ICreateUserEventInputDto {
    code!: string | undefined;
    value!: string | undefined;
    latitude!: number | undefined;
    longitude!: number | undefined;
    time!: moment.Moment;

    constructor(data?: ICreateUserEventInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.value = data["value"];
            this.latitude = data["latitude"];
            this.longitude = data["longitude"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateUserEventInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateUserEventInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["value"] = this.value;
        data["latitude"] = this.latitude;
        data["longitude"] = this.longitude;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ICreateUserEventInputDto {
    code: string | undefined;
    value: string | undefined;
    latitude: number | undefined;
    longitude: number | undefined;
    time: moment.Moment;
}

export class LinkToUserInput implements ILinkToUserInput {
    tenancyName!: string | undefined;
    usernameOrEmailAddress!: string;
    password!: string;

    constructor(data?: ILinkToUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.usernameOrEmailAddress = data["usernameOrEmailAddress"];
            this.password = data["password"];
        }
    }

    static fromJS(data: any): LinkToUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new LinkToUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["usernameOrEmailAddress"] = this.usernameOrEmailAddress;
        data["password"] = this.password;
        return data; 
    }
}

export interface ILinkToUserInput {
    tenancyName: string | undefined;
    usernameOrEmailAddress: string;
    password: string;
}

export class LinkedUserDto implements ILinkedUserDto {
    tenantId!: number | undefined;
    tenancyName!: string | undefined;
    username!: string | undefined;
    id!: number;

    constructor(data?: ILinkedUserDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tenancyName = data["tenancyName"];
            this.username = data["username"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): LinkedUserDto {
        data = typeof data === 'object' ? data : {};
        let result = new LinkedUserDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tenancyName"] = this.tenancyName;
        data["username"] = this.username;
        data["id"] = this.id;
        return data; 
    }
}

export interface ILinkedUserDto {
    tenantId: number | undefined;
    tenancyName: string | undefined;
    username: string | undefined;
    id: number;
}

export class PagedResultDtoOfLinkedUserDto implements IPagedResultDtoOfLinkedUserDto {
    totalCount!: number;
    items!: LinkedUserDto[] | undefined;

    constructor(data?: IPagedResultDtoOfLinkedUserDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(LinkedUserDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfLinkedUserDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfLinkedUserDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfLinkedUserDto {
    totalCount: number;
    items: LinkedUserDto[] | undefined;
}

export class ListResultDtoOfLinkedUserDto implements IListResultDtoOfLinkedUserDto {
    items!: LinkedUserDto[] | undefined;

    constructor(data?: IListResultDtoOfLinkedUserDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(LinkedUserDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfLinkedUserDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfLinkedUserDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfLinkedUserDto {
    items: LinkedUserDto[] | undefined;
}

export class UnlinkUserInput implements IUnlinkUserInput {
    tenantId!: number | undefined;
    userId!: number;

    constructor(data?: IUnlinkUserInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): UnlinkUserInput {
        data = typeof data === 'object' ? data : {};
        let result = new UnlinkUserInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IUnlinkUserInput {
    tenantId: number | undefined;
    userId: number;
}

export class CreateUserLocationInput implements ICreateUserLocationInput {
    locationIds!: number[] | undefined;
    locationId!: number;
    userId!: number;

    constructor(data?: ICreateUserLocationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["locationIds"])) {
                this.locationIds = [] as any;
                for (let item of data["locationIds"])
                    this.locationIds!.push(item);
            }
            this.locationId = data["locationId"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): CreateUserLocationInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateUserLocationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.locationIds)) {
            data["locationIds"] = [];
            for (let item of this.locationIds)
                data["locationIds"].push(item);
        }
        data["locationId"] = this.locationId;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface ICreateUserLocationInput {
    locationIds: number[] | undefined;
    locationId: number;
    userId: number;
}

export class UserLocationListDto implements IUserLocationListDto {
    id!: number;
    locationId!: number | undefined;
    locationNames!: string[] | undefined;
    locationIds!: number[] | undefined;
    location!: LocationListDto[] | undefined;
    userId!: number | undefined;
    user!: UserListDto | undefined;
    userName!: string | undefined;
    locationName!: string | undefined;

    constructor(data?: IUserLocationListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.locationId = data["locationId"];
            if (Array.isArray(data["locationNames"])) {
                this.locationNames = [] as any;
                for (let item of data["locationNames"])
                    this.locationNames!.push(item);
            }
            if (Array.isArray(data["locationIds"])) {
                this.locationIds = [] as any;
                for (let item of data["locationIds"])
                    this.locationIds!.push(item);
            }
            if (Array.isArray(data["location"])) {
                this.location = [] as any;
                for (let item of data["location"])
                    this.location!.push(LocationListDto.fromJS(item));
            }
            this.userId = data["userId"];
            this.user = data["user"] ? UserListDto.fromJS(data["user"]) : <any>undefined;
            this.userName = data["userName"];
            this.locationName = data["locationName"];
        }
    }

    static fromJS(data: any): UserLocationListDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserLocationListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["locationId"] = this.locationId;
        if (Array.isArray(this.locationNames)) {
            data["locationNames"] = [];
            for (let item of this.locationNames)
                data["locationNames"].push(item);
        }
        if (Array.isArray(this.locationIds)) {
            data["locationIds"] = [];
            for (let item of this.locationIds)
                data["locationIds"].push(item);
        }
        if (Array.isArray(this.location)) {
            data["location"] = [];
            for (let item of this.location)
                data["location"].push(item.toJSON());
        }
        data["userId"] = this.userId;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userName"] = this.userName;
        data["locationName"] = this.locationName;
        return data; 
    }
}

export interface IUserLocationListDto {
    id: number;
    locationId: number | undefined;
    locationNames: string[] | undefined;
    locationIds: number[] | undefined;
    location: LocationListDto[] | undefined;
    userId: number | undefined;
    user: UserListDto | undefined;
    userName: string | undefined;
    locationName: string | undefined;
}

export class PagedResultDtoOfUserLocationListDto implements IPagedResultDtoOfUserLocationListDto {
    totalCount!: number;
    items!: UserLocationListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfUserLocationListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(UserLocationListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfUserLocationListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfUserLocationListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfUserLocationListDto {
    totalCount: number;
    items: UserLocationListDto[] | undefined;
}

export class UpdateUserLocationInput implements IUpdateUserLocationInput {
    id!: number;
    locationId!: number;
    locationIds!: number[] | undefined;
    userId!: number;
    user!: string | undefined;

    constructor(data?: IUpdateUserLocationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.locationId = data["locationId"];
            if (Array.isArray(data["locationIds"])) {
                this.locationIds = [] as any;
                for (let item of data["locationIds"])
                    this.locationIds!.push(item);
            }
            this.userId = data["userId"];
            this.user = data["user"];
        }
    }

    static fromJS(data: any): UpdateUserLocationInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateUserLocationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["locationId"] = this.locationId;
        if (Array.isArray(this.locationIds)) {
            data["locationIds"] = [];
            for (let item of this.locationIds)
                data["locationIds"].push(item);
        }
        data["userId"] = this.userId;
        data["user"] = this.user;
        return data; 
    }
}

export interface IUpdateUserLocationInput {
    id: number;
    locationId: number;
    locationIds: number[] | undefined;
    userId: number;
    user: string | undefined;
}

export class GetUserListInput implements IGetUserListInput {
    tenantId!: number | undefined;
    name!: string | undefined;
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: IGetUserListInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): GetUserListInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserListInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface IGetUserListInput {
    tenantId: number | undefined;
    name: string | undefined;
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class UserLoginAttemptDto implements IUserLoginAttemptDto {
    tenancyName!: string | undefined;
    userNameOrEmail!: string | undefined;
    clientIpAddress!: string | undefined;
    clientName!: string | undefined;
    browserInfo!: string | undefined;
    result!: string | undefined;
    creationTime!: moment.Moment;

    constructor(data?: IUserLoginAttemptDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenancyName = data["tenancyName"];
            this.userNameOrEmail = data["userNameOrEmail"];
            this.clientIpAddress = data["clientIpAddress"];
            this.clientName = data["clientName"];
            this.browserInfo = data["browserInfo"];
            this.result = data["result"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): UserLoginAttemptDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserLoginAttemptDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenancyName"] = this.tenancyName;
        data["userNameOrEmail"] = this.userNameOrEmail;
        data["clientIpAddress"] = this.clientIpAddress;
        data["clientName"] = this.clientName;
        data["browserInfo"] = this.browserInfo;
        data["result"] = this.result;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IUserLoginAttemptDto {
    tenancyName: string | undefined;
    userNameOrEmail: string | undefined;
    clientIpAddress: string | undefined;
    clientName: string | undefined;
    browserInfo: string | undefined;
    result: string | undefined;
    creationTime: moment.Moment;
}

export class ListResultDtoOfUserLoginAttemptDto implements IListResultDtoOfUserLoginAttemptDto {
    items!: UserLoginAttemptDto[] | undefined;

    constructor(data?: IListResultDtoOfUserLoginAttemptDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(UserLoginAttemptDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfUserLoginAttemptDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfUserLoginAttemptDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfUserLoginAttemptDto {
    items: UserLoginAttemptDto[] | undefined;
}

export class UserOrderTypeDto implements IUserOrderTypeDto {
    userId!: number | undefined;
    orderTypeId!: number | undefined;
    id!: number;

    constructor(data?: IUserOrderTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.orderTypeId = data["orderTypeId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserOrderTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserOrderTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["orderTypeId"] = this.orderTypeId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserOrderTypeDto {
    userId: number | undefined;
    orderTypeId: number | undefined;
    id: number;
}

export class GetUserOrderTypeForViewDto implements IGetUserOrderTypeForViewDto {
    userOrderType!: UserOrderTypeDto | undefined;
    userName!: string | undefined;
    orderTypeCode!: string | undefined;
    orderTypeDescription!: string | undefined;

    constructor(data?: IGetUserOrderTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userOrderType = data["userOrderType"] ? UserOrderTypeDto.fromJS(data["userOrderType"]) : <any>undefined;
            this.userName = data["userName"];
            this.orderTypeCode = data["orderTypeCode"];
            this.orderTypeDescription = data["orderTypeDescription"];
        }
    }

    static fromJS(data: any): GetUserOrderTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserOrderTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userOrderType"] = this.userOrderType ? this.userOrderType.toJSON() : <any>undefined;
        data["userName"] = this.userName;
        data["orderTypeCode"] = this.orderTypeCode;
        data["orderTypeDescription"] = this.orderTypeDescription;
        return data; 
    }
}

export interface IGetUserOrderTypeForViewDto {
    userOrderType: UserOrderTypeDto | undefined;
    userName: string | undefined;
    orderTypeCode: string | undefined;
    orderTypeDescription: string | undefined;
}

export class PagedResultDtoOfGetUserOrderTypeForViewDto implements IPagedResultDtoOfGetUserOrderTypeForViewDto {
    totalCount!: number;
    items!: GetUserOrderTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetUserOrderTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetUserOrderTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetUserOrderTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetUserOrderTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetUserOrderTypeForViewDto {
    totalCount: number;
    items: GetUserOrderTypeForViewDto[] | undefined;
}

export class CreateOrEditUserOrderTypeDto implements ICreateOrEditUserOrderTypeDto {
    userId!: number | undefined;
    orderTypeId!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditUserOrderTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.orderTypeId = data["orderTypeId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditUserOrderTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditUserOrderTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["orderTypeId"] = this.orderTypeId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditUserOrderTypeDto {
    userId: number | undefined;
    orderTypeId: number | undefined;
    id: number | undefined;
}

export class GetUserOrderTypeForEditOutput implements IGetUserOrderTypeForEditOutput {
    userOrderType!: CreateOrEditUserOrderTypeDto | undefined;
    userName!: string | undefined;
    orderTypeCode!: string | undefined;

    constructor(data?: IGetUserOrderTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userOrderType = data["userOrderType"] ? CreateOrEditUserOrderTypeDto.fromJS(data["userOrderType"]) : <any>undefined;
            this.userName = data["userName"];
            this.orderTypeCode = data["orderTypeCode"];
        }
    }

    static fromJS(data: any): GetUserOrderTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserOrderTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userOrderType"] = this.userOrderType ? this.userOrderType.toJSON() : <any>undefined;
        data["userName"] = this.userName;
        data["orderTypeCode"] = this.orderTypeCode;
        return data; 
    }
}

export interface IGetUserOrderTypeForEditOutput {
    userOrderType: CreateOrEditUserOrderTypeDto | undefined;
    userName: string | undefined;
    orderTypeCode: string | undefined;
}

export class UserOrderTypeUserLookupTableDto implements IUserOrderTypeUserLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IUserOrderTypeUserLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): UserOrderTypeUserLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserOrderTypeUserLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IUserOrderTypeUserLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class UserOrderTypeOrderTypeLookupTableDto implements IUserOrderTypeOrderTypeLookupTableDto {
    id!: number;
    displayName!: string | undefined;

    constructor(data?: IUserOrderTypeOrderTypeLookupTableDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.displayName = data["displayName"];
        }
    }

    static fromJS(data: any): UserOrderTypeOrderTypeLookupTableDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserOrderTypeOrderTypeLookupTableDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["displayName"] = this.displayName;
        return data; 
    }
}

export interface IUserOrderTypeOrderTypeLookupTableDto {
    id: number;
    displayName: string | undefined;
}

export class UserInPreferenceList implements IUserInPreferenceList {
    id!: number;
    name!: string | undefined;
    surname!: string | undefined;

    constructor(data?: IUserInPreferenceList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.surname = data["surname"];
        }
    }

    static fromJS(data: any): UserInPreferenceList {
        data = typeof data === 'object' ? data : {};
        let result = new UserInPreferenceList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["surname"] = this.surname;
        return data; 
    }
}

export interface IUserInPreferenceList {
    id: number;
    name: string | undefined;
    surname: string | undefined;
}

export class UserPreferenceDto implements IUserPreferenceDto {
    user!: UserInPreferenceList | undefined;
    value!: string | undefined;
    preferences!: PreferenceDtos | undefined;
    id!: number;

    constructor(data?: IUserPreferenceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserInPreferenceList.fromJS(data["user"]) : <any>undefined;
            this.value = data["value"];
            this.preferences = data["preferences"] ? PreferenceDtos.fromJS(data["preferences"]) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): UserPreferenceDto {
        data = typeof data === 'object' ? data : {};
        let result = new UserPreferenceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["value"] = this.value;
        data["preferences"] = this.preferences ? this.preferences.toJSON() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IUserPreferenceDto {
    user: UserInPreferenceList | undefined;
    value: string | undefined;
    preferences: PreferenceDtos | undefined;
    id: number;
}

export class GetUserPreferenceForViewDto implements IGetUserPreferenceForViewDto {
    userPreference!: UserPreferenceDto | undefined;

    constructor(data?: IGetUserPreferenceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userPreference = data["userPreference"] ? UserPreferenceDto.fromJS(data["userPreference"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetUserPreferenceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserPreferenceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userPreference"] = this.userPreference ? this.userPreference.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetUserPreferenceForViewDto {
    userPreference: UserPreferenceDto | undefined;
}

export class PagedResultDtoOfGetUserPreferenceForViewDto implements IPagedResultDtoOfGetUserPreferenceForViewDto {
    totalCount!: number;
    items!: GetUserPreferenceForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetUserPreferenceForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetUserPreferenceForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetUserPreferenceForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetUserPreferenceForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetUserPreferenceForViewDto {
    totalCount: number;
    items: GetUserPreferenceForViewDto[] | undefined;
}

export class CreateOrEditUserPreferenceDto implements ICreateOrEditUserPreferenceDto {
    userId!: number;
    value!: string | undefined;
    preferenceId!: number;
    id!: number | undefined;

    constructor(data?: ICreateOrEditUserPreferenceDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.value = data["value"];
            this.preferenceId = data["preferenceId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditUserPreferenceDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditUserPreferenceDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["value"] = this.value;
        data["preferenceId"] = this.preferenceId;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditUserPreferenceDto {
    userId: number;
    value: string | undefined;
    preferenceId: number;
    id: number | undefined;
}

export class GetUserPreferenceForEditOutput implements IGetUserPreferenceForEditOutput {
    userPreference!: CreateOrEditUserPreferenceDto | undefined;

    constructor(data?: IGetUserPreferenceForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userPreference = data["userPreference"] ? CreateOrEditUserPreferenceDto.fromJS(data["userPreference"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetUserPreferenceForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetUserPreferenceForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userPreference"] = this.userPreference ? this.userPreference.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetUserPreferenceForEditOutput {
    userPreference: CreateOrEditUserPreferenceDto | undefined;
}

export class UserPreferenceInput implements IUserPreferenceInput {
    loadDateValue!: string | undefined;
    locationValue!: string | undefined;
    thresholdValue!: string | undefined;

    constructor(data?: IUserPreferenceInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.loadDateValue = data["loadDateValue"];
            this.locationValue = data["locationValue"];
            this.thresholdValue = data["thresholdValue"];
        }
    }

    static fromJS(data: any): UserPreferenceInput {
        data = typeof data === 'object' ? data : {};
        let result = new UserPreferenceInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["loadDateValue"] = this.loadDateValue;
        data["locationValue"] = this.locationValue;
        data["thresholdValue"] = this.thresholdValue;
        return data; 
    }
}

export interface IUserPreferenceInput {
    loadDateValue: string | undefined;
    locationValue: string | undefined;
    thresholdValue: string | undefined;
}

export class CreateOrUpdateForMobileClientUserInputDto implements ICreateOrUpdateForMobileClientUserInputDto {
    userId!: number;
    preferenceCode!: string | undefined;
    value!: string | undefined;

    constructor(data?: ICreateOrUpdateForMobileClientUserInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.userId = data["userId"];
            this.preferenceCode = data["preferenceCode"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): CreateOrUpdateForMobileClientUserInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrUpdateForMobileClientUserInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["userId"] = this.userId;
        data["preferenceCode"] = this.preferenceCode;
        data["value"] = this.value;
        return data; 
    }
}

export interface ICreateOrUpdateForMobileClientUserInputDto {
    userId: number;
    preferenceCode: string | undefined;
    value: string | undefined;
}

export class GetForMobileClientUserListItemDto implements IGetForMobileClientUserListItemDto {
    code!: string | undefined;
    value!: string | undefined;

    constructor(data?: IGetForMobileClientUserListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.value = data["value"];
        }
    }

    static fromJS(data: any): GetForMobileClientUserListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetForMobileClientUserListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["value"] = this.value;
        return data; 
    }
}

export interface IGetForMobileClientUserListItemDto {
    code: string | undefined;
    value: string | undefined;
}

export class GetForMobileClientUserResultDto implements IGetForMobileClientUserResultDto {
    items!: GetForMobileClientUserListItemDto[] | undefined;

    constructor(data?: IGetForMobileClientUserResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetForMobileClientUserListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetForMobileClientUserResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetForMobileClientUserResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetForMobileClientUserResultDto {
    items: GetForMobileClientUserListItemDto[] | undefined;
}

export class CreateVehicleInput implements ICreateVehicleInput {
    tenantId!: number | undefined;
    name!: string | undefined;
    licenseNumber!: string | undefined;
    userId!: number | undefined;
    color!: string | undefined;
    licenseState!: string | undefined;
    vehicleTypeId!: number | undefined;
    acquisitionDate!: moment.Moment | undefined;
    description!: string | undefined;
    temporaryVehicle!: boolean;
    mileageMultiplier!: number | undefined;

    constructor(data?: ICreateVehicleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.userId = data["userId"];
            this.color = data["color"];
            this.licenseState = data["licenseState"];
            this.vehicleTypeId = data["vehicleTypeId"];
            this.acquisitionDate = data["acquisitionDate"] ? moment(data["acquisitionDate"].toString()) : <any>undefined;
            this.description = data["description"];
            this.temporaryVehicle = data["temporaryVehicle"];
            this.mileageMultiplier = data["mileageMultiplier"];
        }
    }

    static fromJS(data: any): CreateVehicleInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateVehicleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["userId"] = this.userId;
        data["color"] = this.color;
        data["licenseState"] = this.licenseState;
        data["vehicleTypeId"] = this.vehicleTypeId;
        data["acquisitionDate"] = this.acquisitionDate ? this.acquisitionDate.toISOString() : <any>undefined;
        data["description"] = this.description;
        data["temporaryVehicle"] = this.temporaryVehicle;
        data["mileageMultiplier"] = this.mileageMultiplier;
        return data; 
    }
}

export interface ICreateVehicleInput {
    tenantId: number | undefined;
    name: string | undefined;
    licenseNumber: string | undefined;
    userId: number | undefined;
    color: string | undefined;
    licenseState: string | undefined;
    vehicleTypeId: number | undefined;
    acquisitionDate: moment.Moment | undefined;
    description: string | undefined;
    temporaryVehicle: boolean;
    mileageMultiplier: number | undefined;
}

export class VehicleDto implements IVehicleDto {
    name!: string | undefined;
    licenseNumber!: string | undefined;
    color!: string | undefined;
    userId!: number;
    id!: number;

    constructor(data?: IVehicleDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.color = data["color"];
            this.userId = data["userId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VehicleDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["color"] = this.color;
        data["userId"] = this.userId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicleDto {
    name: string | undefined;
    licenseNumber: string | undefined;
    color: string | undefined;
    userId: number;
    id: number;
}

export class VehicleTypeDto implements IVehicleTypeDto {
    description!: string | undefined;
    code!: string | undefined;
    mileageMultiplier!: number | undefined;
    id!: number;

    constructor(data?: IVehicleTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.code = data["code"];
            this.mileageMultiplier = data["mileageMultiplier"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VehicleTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["code"] = this.code;
        data["mileageMultiplier"] = this.mileageMultiplier;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicleTypeDto {
    description: string | undefined;
    code: string | undefined;
    mileageMultiplier: number | undefined;
    id: number;
}

export class VehicleListDto implements IVehicleListDto {
    vehicle!: VehicleDto | undefined;
    tenantId!: number;
    name!: string | undefined;
    licenseNumber!: string | undefined;
    user!: UserInVehicleListDto | undefined;
    userId!: number;
    userName!: string | undefined;
    userSurname!: string | undefined;
    id!: number;
    color!: string | undefined;
    routeId!: number | undefined;
    licenseState!: string | undefined;
    vehicleTypeId!: number | undefined;
    acquisitionDate!: moment.Moment | undefined;
    acquisitionDateString!: string | undefined;
    description!: string | undefined;
    temporaryVehicle!: boolean;
    vehicleType!: VehicleTypeDto | undefined;

    constructor(data?: IVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicle = data["vehicle"] ? VehicleDto.fromJS(data["vehicle"]) : <any>undefined;
            this.tenantId = data["tenantId"];
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.user = data["user"] ? UserInVehicleListDto.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.userName = data["userName"];
            this.userSurname = data["userSurname"];
            this.id = data["id"];
            this.color = data["color"];
            this.routeId = data["routeId"];
            this.licenseState = data["licenseState"];
            this.vehicleTypeId = data["vehicleTypeId"];
            this.acquisitionDate = data["acquisitionDate"] ? moment(data["acquisitionDate"].toString()) : <any>undefined;
            this.acquisitionDateString = data["acquisitionDateString"];
            this.description = data["description"];
            this.temporaryVehicle = data["temporaryVehicle"];
            this.vehicleType = data["vehicleType"] ? VehicleTypeDto.fromJS(data["vehicleType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): VehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["tenantId"] = this.tenantId;
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["userName"] = this.userName;
        data["userSurname"] = this.userSurname;
        data["id"] = this.id;
        data["color"] = this.color;
        data["routeId"] = this.routeId;
        data["licenseState"] = this.licenseState;
        data["vehicleTypeId"] = this.vehicleTypeId;
        data["acquisitionDate"] = this.acquisitionDate ? this.acquisitionDate.toISOString() : <any>undefined;
        data["acquisitionDateString"] = this.acquisitionDateString;
        data["description"] = this.description;
        data["temporaryVehicle"] = this.temporaryVehicle;
        data["vehicleType"] = this.vehicleType ? this.vehicleType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IVehicleListDto {
    vehicle: VehicleDto | undefined;
    tenantId: number;
    name: string | undefined;
    licenseNumber: string | undefined;
    user: UserInVehicleListDto | undefined;
    userId: number;
    userName: string | undefined;
    userSurname: string | undefined;
    id: number;
    color: string | undefined;
    routeId: number | undefined;
    licenseState: string | undefined;
    vehicleTypeId: number | undefined;
    acquisitionDate: moment.Moment | undefined;
    acquisitionDateString: string | undefined;
    description: string | undefined;
    temporaryVehicle: boolean;
    vehicleType: VehicleTypeDto | undefined;
}

export class PagedResultDtoOfVehicleListDto implements IPagedResultDtoOfVehicleListDto {
    totalCount!: number;
    items!: VehicleListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(VehicleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfVehicleListDto {
    totalCount: number;
    items: VehicleListDto[] | undefined;
}

export class GetVehicleForEditOutput implements IGetVehicleForEditOutput {
    vehicle!: VehicleListDto | undefined;

    constructor(data?: IGetVehicleForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicle = data["vehicle"] ? VehicleListDto.fromJS(data["vehicle"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVehicleForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVehicleForEditOutput {
    vehicle: VehicleListDto | undefined;
}

export class UpdateVehicleInput implements IUpdateVehicleInput {
    id!: number;
    name!: string | undefined;
    licenseNumber!: string | undefined;
    userId!: number | undefined;
    color!: string | undefined;
    routeId!: number | undefined;
    licenseState!: string | undefined;
    vehicleTypeId!: number | undefined;
    acquisitionDate!: moment.Moment | undefined;
    description!: string | undefined;
    temporaryVehicle!: boolean;

    constructor(data?: IUpdateVehicleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.userId = data["userId"];
            this.color = data["color"];
            this.routeId = data["routeId"];
            this.licenseState = data["licenseState"];
            this.vehicleTypeId = data["vehicleTypeId"];
            this.acquisitionDate = data["acquisitionDate"] ? moment(data["acquisitionDate"].toString()) : <any>undefined;
            this.description = data["description"];
            this.temporaryVehicle = data["temporaryVehicle"];
        }
    }

    static fromJS(data: any): UpdateVehicleInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateVehicleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["userId"] = this.userId;
        data["color"] = this.color;
        data["routeId"] = this.routeId;
        data["licenseState"] = this.licenseState;
        data["vehicleTypeId"] = this.vehicleTypeId;
        data["acquisitionDate"] = this.acquisitionDate ? this.acquisitionDate.toISOString() : <any>undefined;
        data["description"] = this.description;
        data["temporaryVehicle"] = this.temporaryVehicle;
        return data; 
    }
}

export interface IUpdateVehicleInput {
    id: number;
    name: string | undefined;
    licenseNumber: string | undefined;
    userId: number | undefined;
    color: string | undefined;
    routeId: number | undefined;
    licenseState: string | undefined;
    vehicleTypeId: number | undefined;
    acquisitionDate: moment.Moment | undefined;
    description: string | undefined;
    temporaryVehicle: boolean;
}

export class VehicleCheckOutInput implements IVehicleCheckOutInput {
    vehicleId!: number;
    mileage!: number;

    constructor(data?: IVehicleCheckOutInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleId = data["vehicleId"];
            this.mileage = data["mileage"];
        }
    }

    static fromJS(data: any): VehicleCheckOutInput {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleCheckOutInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleId"] = this.vehicleId;
        data["mileage"] = this.mileage;
        return data; 
    }
}

export interface IVehicleCheckOutInput {
    vehicleId: number;
    mileage: number;
}

export class VehicleCheckInInput implements IVehicleCheckInInput {
    vehicleId!: number;
    mileage!: number;

    constructor(data?: IVehicleCheckInInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleId = data["vehicleId"];
            this.mileage = data["mileage"];
        }
    }

    static fromJS(data: any): VehicleCheckInInput {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleCheckInInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleId"] = this.vehicleId;
        data["mileage"] = this.mileage;
        return data; 
    }
}

export interface IVehicleCheckInInput {
    vehicleId: number;
    mileage: number;
}

export class PagedResultDtoOfAvailableVehicleListDto implements IPagedResultDtoOfAvailableVehicleListDto {
    totalCount!: number;
    items!: AvailableVehicleListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfAvailableVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(AvailableVehicleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfAvailableVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfAvailableVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfAvailableVehicleListDto {
    totalCount: number;
    items: AvailableVehicleListDto[] | undefined;
}

export class UserInGetCheckedOutVehicleList implements IUserInGetCheckedOutVehicleList {
    id!: number;
    name!: string | undefined;
    surname!: string | undefined;

    constructor(data?: IUserInGetCheckedOutVehicleList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.surname = data["surname"];
        }
    }

    static fromJS(data: any): UserInGetCheckedOutVehicleList {
        data = typeof data === 'object' ? data : {};
        let result = new UserInGetCheckedOutVehicleList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["surname"] = this.surname;
        return data; 
    }
}

export interface IUserInGetCheckedOutVehicleList {
    id: number;
    name: string | undefined;
    surname: string | undefined;
}

export class GetCheckedOutVehicleListDto implements IGetCheckedOutVehicleListDto {
    name!: string | undefined;
    licenseNumber!: string | undefined;
    user!: UserInGetCheckedOutVehicleList | undefined;
    userId!: number;
    id!: number;

    constructor(data?: IGetCheckedOutVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.user = data["user"] ? UserInGetCheckedOutVehicleList.fromJS(data["user"]) : <any>undefined;
            this.userId = data["userId"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): GetCheckedOutVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetCheckedOutVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["userId"] = this.userId;
        data["id"] = this.id;
        return data; 
    }
}

export interface IGetCheckedOutVehicleListDto {
    name: string | undefined;
    licenseNumber: string | undefined;
    user: UserInGetCheckedOutVehicleList | undefined;
    userId: number;
    id: number;
}

export class PagedResultDtoOfGetCheckedOutVehicleListDto implements IPagedResultDtoOfGetCheckedOutVehicleListDto {
    totalCount!: number;
    items!: GetCheckedOutVehicleListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetCheckedOutVehicleListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetCheckedOutVehicleListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetCheckedOutVehicleListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetCheckedOutVehicleListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetCheckedOutVehicleListDto {
    totalCount: number;
    items: GetCheckedOutVehicleListDto[] | undefined;
}

export class AddLogInput implements IAddLogInput {
    vehicleId!: number;
    speed!: number;
    time!: moment.Moment;
    geocode!: CreateGeocodeInput | undefined;

    constructor(data?: IAddLogInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleId = data["vehicleId"];
            this.speed = data["speed"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocode = data["geocode"] ? CreateGeocodeInput.fromJS(data["geocode"]) : <any>undefined;
        }
    }

    static fromJS(data: any): AddLogInput {
        data = typeof data === 'object' ? data : {};
        let result = new AddLogInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleId"] = this.vehicleId;
        data["speed"] = this.speed;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IAddLogInput {
    vehicleId: number;
    speed: number;
    time: moment.Moment;
    geocode: CreateGeocodeInput | undefined;
}

export class CheckOrCreateVehicleByDriverInput implements ICheckOrCreateVehicleByDriverInput {
    driverId!: number;

    constructor(data?: ICheckOrCreateVehicleByDriverInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.driverId = data["driverId"];
        }
    }

    static fromJS(data: any): CheckOrCreateVehicleByDriverInput {
        data = typeof data === 'object' ? data : {};
        let result = new CheckOrCreateVehicleByDriverInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["driverId"] = this.driverId;
        return data; 
    }
}

export interface ICheckOrCreateVehicleByDriverInput {
    driverId: number;
}

export class GetChecklistListItemDto implements IGetChecklistListItemDto {
    id!: number;
    code!: string | undefined;
    description!: string | undefined;
    sortOrder!: number;
    isRequired!: number;

    constructor(data?: IGetChecklistListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.code = data["code"];
            this.description = data["description"];
            this.sortOrder = data["sortOrder"];
            this.isRequired = data["isRequired"];
        }
    }

    static fromJS(data: any): GetChecklistListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetChecklistListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["code"] = this.code;
        data["description"] = this.description;
        data["sortOrder"] = this.sortOrder;
        data["isRequired"] = this.isRequired;
        return data; 
    }
}

export interface IGetChecklistListItemDto {
    id: number;
    code: string | undefined;
    description: string | undefined;
    sortOrder: number;
    isRequired: number;
}

export class ListResultDtoOfGetChecklistListItemDto implements IListResultDtoOfGetChecklistListItemDto {
    items!: GetChecklistListItemDto[] | undefined;

    constructor(data?: IListResultDtoOfGetChecklistListItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetChecklistListItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetChecklistListItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetChecklistListItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetChecklistListItemDto {
    items: GetChecklistListItemDto[] | undefined;
}

export class SaveChecklistInputItemDto implements ISaveChecklistInputItemDto {
    vehicleChecklistId!: number;
    routeId!: number | undefined;
    vehicleId!: number;
    isDone!: boolean;

    constructor(data?: ISaveChecklistInputItemDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleChecklistId = data["vehicleChecklistId"];
            this.routeId = data["routeId"];
            this.vehicleId = data["vehicleId"];
            this.isDone = data["isDone"];
        }
    }

    static fromJS(data: any): SaveChecklistInputItemDto {
        data = typeof data === 'object' ? data : {};
        let result = new SaveChecklistInputItemDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleChecklistId"] = this.vehicleChecklistId;
        data["routeId"] = this.routeId;
        data["vehicleId"] = this.vehicleId;
        data["isDone"] = this.isDone;
        return data; 
    }
}

export interface ISaveChecklistInputItemDto {
    vehicleChecklistId: number;
    routeId: number | undefined;
    vehicleId: number;
    isDone: boolean;
}

export class SaveChecklistInputDto implements ISaveChecklistInputDto {
    items!: SaveChecklistInputItemDto[] | undefined;

    constructor(data?: ISaveChecklistInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(SaveChecklistInputItemDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): SaveChecklistInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new SaveChecklistInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ISaveChecklistInputDto {
    items: SaveChecklistInputItemDto[] | undefined;
}

export class VehicleChecklistDto implements IVehicleChecklistDto {
    code!: string | undefined;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    isActive!: boolean;
    isRequired!: boolean;
    id!: number;

    constructor(data?: IVehicleChecklistDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.isActive = data["isActive"];
            this.isRequired = data["isRequired"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VehicleChecklistDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleChecklistDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["isActive"] = this.isActive;
        data["isRequired"] = this.isRequired;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicleChecklistDto {
    code: string | undefined;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    isActive: boolean;
    isRequired: boolean;
    id: number;
}

export class GetVehicleChecklistForViewDto implements IGetVehicleChecklistForViewDto {
    vehicleChecklist!: VehicleChecklistDto | undefined;

    constructor(data?: IGetVehicleChecklistForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleChecklist = data["vehicleChecklist"] ? VehicleChecklistDto.fromJS(data["vehicleChecklist"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVehicleChecklistForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleChecklistForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleChecklist"] = this.vehicleChecklist ? this.vehicleChecklist.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVehicleChecklistForViewDto {
    vehicleChecklist: VehicleChecklistDto | undefined;
}

export class PagedResultDtoOfGetVehicleChecklistForViewDto implements IPagedResultDtoOfGetVehicleChecklistForViewDto {
    totalCount!: number;
    items!: GetVehicleChecklistForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetVehicleChecklistForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetVehicleChecklistForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetVehicleChecklistForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetVehicleChecklistForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetVehicleChecklistForViewDto {
    totalCount: number;
    items: GetVehicleChecklistForViewDto[] | undefined;
}

export class CreateOrEditVehicleChecklistDto implements ICreateOrEditVehicleChecklistDto {
    code!: string;
    description!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    isActive!: boolean;
    isRequired!: boolean;
    id!: number | undefined;

    constructor(data?: ICreateOrEditVehicleChecklistDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.code = data["code"];
            this.description = data["description"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.isActive = data["isActive"];
            this.isRequired = data["isRequired"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditVehicleChecklistDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditVehicleChecklistDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["code"] = this.code;
        data["description"] = this.description;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["isActive"] = this.isActive;
        data["isRequired"] = this.isRequired;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditVehicleChecklistDto {
    code: string;
    description: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    isActive: boolean;
    isRequired: boolean;
    id: number | undefined;
}

export class GetVehicleChecklistForEditOutput implements IGetVehicleChecklistForEditOutput {
    vehicleChecklist!: CreateOrEditVehicleChecklistDto | undefined;

    constructor(data?: IGetVehicleChecklistForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleChecklist = data["vehicleChecklist"] ? CreateOrEditVehicleChecklistDto.fromJS(data["vehicleChecklist"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVehicleChecklistForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleChecklistForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleChecklist"] = this.vehicleChecklist ? this.vehicleChecklist.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVehicleChecklistForEditOutput {
    vehicleChecklist: CreateOrEditVehicleChecklistDto | undefined;
}

export class CreateVehicleLocationInput implements ICreateVehicleLocationInput {
    locationId!: number | undefined;
    vehicleId!: number | undefined;

    constructor(data?: ICreateVehicleLocationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.vehicleId = data["vehicleId"];
        }
    }

    static fromJS(data: any): CreateVehicleLocationInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateVehicleLocationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["vehicleId"] = this.vehicleId;
        return data; 
    }
}

export interface ICreateVehicleLocationInput {
    locationId: number | undefined;
    vehicleId: number | undefined;
}

export class VehicleLocationListDto implements IVehicleLocationListDto {
    id!: number;
    locationId!: number | undefined;
    locationNames!: string[] | undefined;
    locationIds!: number[] | undefined;
    location!: VehicleListDto[] | undefined;
    vehicleId!: number | undefined;
    vehicle!: VehicleListDto | undefined;
    vehicleName!: string | undefined;
    locationName!: string | undefined;

    constructor(data?: IVehicleLocationListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.locationId = data["locationId"];
            if (Array.isArray(data["locationNames"])) {
                this.locationNames = [] as any;
                for (let item of data["locationNames"])
                    this.locationNames!.push(item);
            }
            if (Array.isArray(data["locationIds"])) {
                this.locationIds = [] as any;
                for (let item of data["locationIds"])
                    this.locationIds!.push(item);
            }
            if (Array.isArray(data["location"])) {
                this.location = [] as any;
                for (let item of data["location"])
                    this.location!.push(VehicleListDto.fromJS(item));
            }
            this.vehicleId = data["vehicleId"];
            this.vehicle = data["vehicle"] ? VehicleListDto.fromJS(data["vehicle"]) : <any>undefined;
            this.vehicleName = data["vehicleName"];
            this.locationName = data["locationName"];
        }
    }

    static fromJS(data: any): VehicleLocationListDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleLocationListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["locationId"] = this.locationId;
        if (Array.isArray(this.locationNames)) {
            data["locationNames"] = [];
            for (let item of this.locationNames)
                data["locationNames"].push(item);
        }
        if (Array.isArray(this.locationIds)) {
            data["locationIds"] = [];
            for (let item of this.locationIds)
                data["locationIds"].push(item);
        }
        if (Array.isArray(this.location)) {
            data["location"] = [];
            for (let item of this.location)
                data["location"].push(item.toJSON());
        }
        data["vehicleId"] = this.vehicleId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleName"] = this.vehicleName;
        data["locationName"] = this.locationName;
        return data; 
    }
}

export interface IVehicleLocationListDto {
    id: number;
    locationId: number | undefined;
    locationNames: string[] | undefined;
    locationIds: number[] | undefined;
    location: VehicleListDto[] | undefined;
    vehicleId: number | undefined;
    vehicle: VehicleListDto | undefined;
    vehicleName: string | undefined;
    locationName: string | undefined;
}

export class PagedResultDtoOfVehicleLocationListDto implements IPagedResultDtoOfVehicleLocationListDto {
    totalCount!: number;
    items!: VehicleLocationListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfVehicleLocationListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(VehicleLocationListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfVehicleLocationListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfVehicleLocationListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfVehicleLocationListDto {
    totalCount: number;
    items: VehicleLocationListDto[] | undefined;
}

export class UpdateVehicleLocationInput implements IUpdateVehicleLocationInput {
    id!: number;
    locationId!: number | undefined;
    vehicleId!: number | undefined;

    constructor(data?: IUpdateVehicleLocationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.locationId = data["locationId"];
            this.vehicleId = data["vehicleId"];
        }
    }

    static fromJS(data: any): UpdateVehicleLocationInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateVehicleLocationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["locationId"] = this.locationId;
        data["vehicleId"] = this.vehicleId;
        return data; 
    }
}

export interface IUpdateVehicleLocationInput {
    id: number;
    locationId: number | undefined;
    vehicleId: number | undefined;
}

export class CreateVehicleLogInput implements ICreateVehicleLogInput {
    vehicleId!: number;
    speed!: number;
    time!: moment.Moment;
    geocode!: GeocodeListDto | undefined;
    routeId!: number | undefined;
    distance!: number | undefined;

    constructor(data?: ICreateVehicleLogInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleId = data["vehicleId"];
            this.speed = data["speed"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocode = data["geocode"] ? GeocodeListDto.fromJS(data["geocode"]) : <any>undefined;
            this.routeId = data["routeId"];
            this.distance = data["distance"];
        }
    }

    static fromJS(data: any): CreateVehicleLogInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateVehicleLogInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleId"] = this.vehicleId;
        data["speed"] = this.speed;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        data["routeId"] = this.routeId;
        data["distance"] = this.distance;
        return data; 
    }
}

export interface ICreateVehicleLogInput {
    vehicleId: number;
    speed: number;
    time: moment.Moment;
    geocode: GeocodeListDto | undefined;
    routeId: number | undefined;
    distance: number | undefined;
}

export class BatchCreateVehicleLocationInputDto implements IBatchCreateVehicleLocationInputDto {
    updates!: CreateVehicleLogInput[] | undefined;

    constructor(data?: IBatchCreateVehicleLocationInputDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["updates"])) {
                this.updates = [] as any;
                for (let item of data["updates"])
                    this.updates!.push(CreateVehicleLogInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): BatchCreateVehicleLocationInputDto {
        data = typeof data === 'object' ? data : {};
        let result = new BatchCreateVehicleLocationInputDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.updates)) {
            data["updates"] = [];
            for (let item of this.updates)
                data["updates"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IBatchCreateVehicleLocationInputDto {
    updates: CreateVehicleLogInput[] | undefined;
}

export class GetTotalMileageDto implements IGetTotalMileageDto {
    routeId!: number | undefined;
    totalMileage!: number;

    constructor(data?: IGetTotalMileageDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.totalMileage = data["totalMileage"];
        }
    }

    static fromJS(data: any): GetTotalMileageDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetTotalMileageDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["totalMileage"] = this.totalMileage;
        return data; 
    }
}

export interface IGetTotalMileageDto {
    routeId: number | undefined;
    totalMileage: number;
}

export class CreateVehicleMileageInput implements ICreateVehicleMileageInput {
    vehicle!: CreateVehicleInput | undefined;
    vehicleId!: number;
    mileage!: number | undefined;

    constructor(data?: ICreateVehicleMileageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicle = data["vehicle"] ? CreateVehicleInput.fromJS(data["vehicle"]) : <any>undefined;
            this.vehicleId = data["vehicleId"];
            this.mileage = data["mileage"];
        }
    }

    static fromJS(data: any): CreateVehicleMileageInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateVehicleMileageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["vehicleId"] = this.vehicleId;
        data["mileage"] = this.mileage;
        return data; 
    }
}

export interface ICreateVehicleMileageInput {
    vehicle: CreateVehicleInput | undefined;
    vehicleId: number;
    mileage: number | undefined;
}

export class VehicleInVehicleMileageListDto implements IVehicleInVehicleMileageListDto {
    id!: number;
    name!: string | undefined;
    licenseNumber!: string | undefined;
    userId!: number;

    constructor(data?: IVehicleInVehicleMileageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.licenseNumber = data["licenseNumber"];
            this.userId = data["userId"];
        }
    }

    static fromJS(data: any): VehicleInVehicleMileageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleInVehicleMileageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["licenseNumber"] = this.licenseNumber;
        data["userId"] = this.userId;
        return data; 
    }
}

export interface IVehicleInVehicleMileageListDto {
    id: number;
    name: string | undefined;
    licenseNumber: string | undefined;
    userId: number;
}

export class VehicleMileageListDto implements IVehicleMileageListDto {
    tenantId!: number;
    vehicleId!: number;
    vehicle!: VehicleInVehicleMileageListDto | undefined;
    mileage!: number;
    id!: number;

    constructor(data?: IVehicleMileageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.vehicleId = data["vehicleId"];
            this.vehicle = data["vehicle"] ? VehicleInVehicleMileageListDto.fromJS(data["vehicle"]) : <any>undefined;
            this.mileage = data["mileage"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VehicleMileageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new VehicleMileageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["vehicleId"] = this.vehicleId;
        data["vehicle"] = this.vehicle ? this.vehicle.toJSON() : <any>undefined;
        data["mileage"] = this.mileage;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVehicleMileageListDto {
    tenantId: number;
    vehicleId: number;
    vehicle: VehicleInVehicleMileageListDto | undefined;
    mileage: number;
    id: number;
}

export class PagedResultDtoOfVehicleMileageListDto implements IPagedResultDtoOfVehicleMileageListDto {
    totalCount!: number;
    items!: VehicleMileageListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfVehicleMileageListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(VehicleMileageListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfVehicleMileageListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfVehicleMileageListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfVehicleMileageListDto {
    totalCount: number;
    items: VehicleMileageListDto[] | undefined;
}

export class GetVehicleMileageForEditOutput implements IGetVehicleMileageForEditOutput {
    vehicleMileage!: VehicleMileageListDto | undefined;

    constructor(data?: IGetVehicleMileageForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleMileage = data["vehicleMileage"] ? VehicleMileageListDto.fromJS(data["vehicleMileage"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVehicleMileageForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleMileageForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleMileage"] = this.vehicleMileage ? this.vehicleMileage.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVehicleMileageForEditOutput {
    vehicleMileage: VehicleMileageListDto | undefined;
}

export class UpdateVehicleMileageInput implements IUpdateVehicleMileageInput {
    id!: number;
    vehicleId!: number;
    mileage!: number | undefined;

    constructor(data?: IUpdateVehicleMileageInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.vehicleId = data["vehicleId"];
            this.mileage = data["mileage"];
        }
    }

    static fromJS(data: any): UpdateVehicleMileageInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateVehicleMileageInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["vehicleId"] = this.vehicleId;
        data["mileage"] = this.mileage;
        return data; 
    }
}

export interface IUpdateVehicleMileageInput {
    id: number;
    vehicleId: number;
    mileage: number | undefined;
}

export class GetVehicleTypeForViewDto implements IGetVehicleTypeForViewDto {
    vehicleType!: VehicleTypeDto | undefined;

    constructor(data?: IGetVehicleTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleType = data["vehicleType"] ? VehicleTypeDto.fromJS(data["vehicleType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVehicleTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleType"] = this.vehicleType ? this.vehicleType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVehicleTypeForViewDto {
    vehicleType: VehicleTypeDto | undefined;
}

export class PagedResultDtoOfGetVehicleTypeForViewDto implements IPagedResultDtoOfGetVehicleTypeForViewDto {
    totalCount!: number;
    items!: GetVehicleTypeForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetVehicleTypeForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetVehicleTypeForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetVehicleTypeForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetVehicleTypeForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetVehicleTypeForViewDto {
    totalCount: number;
    items: GetVehicleTypeForViewDto[] | undefined;
}

export class CreateOrEditVehicleTypeDto implements ICreateOrEditVehicleTypeDto {
    description!: string;
    code!: string;
    mileageMultiplier!: number | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditVehicleTypeDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.description = data["description"];
            this.code = data["code"];
            this.mileageMultiplier = data["mileageMultiplier"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditVehicleTypeDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditVehicleTypeDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["description"] = this.description;
        data["code"] = this.code;
        data["mileageMultiplier"] = this.mileageMultiplier;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditVehicleTypeDto {
    description: string;
    code: string;
    mileageMultiplier: number | undefined;
    id: number | undefined;
}

export class GetVehicleTypeForEditOutput implements IGetVehicleTypeForEditOutput {
    vehicleType!: CreateOrEditVehicleTypeDto | undefined;

    constructor(data?: IGetVehicleTypeForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleType = data["vehicleType"] ? CreateOrEditVehicleTypeDto.fromJS(data["vehicleType"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVehicleTypeForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetVehicleTypeForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleType"] = this.vehicleType ? this.vehicleType.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVehicleTypeForEditOutput {
    vehicleType: CreateOrEditVehicleTypeDto | undefined;
}

export class GetVendorListDto implements IGetVendorListDto {
    id!: number;
    name!: string | undefined;
    surname!: string | undefined;
    phoneNumber!: string | undefined;
    emailAddress!: string | undefined;
    isEmailConfirmed!: boolean;
    lockOutEndDateUtc!: moment.Moment | undefined;
    locations!: string[] | undefined;
    fleet!: string | undefined;

    constructor(data?: IGetVendorListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.surname = data["surname"];
            this.phoneNumber = data["phoneNumber"];
            this.emailAddress = data["emailAddress"];
            this.isEmailConfirmed = data["isEmailConfirmed"];
            this.lockOutEndDateUtc = data["lockOutEndDateUtc"] ? moment(data["lockOutEndDateUtc"].toString()) : <any>undefined;
            if (Array.isArray(data["locations"])) {
                this.locations = [] as any;
                for (let item of data["locations"])
                    this.locations!.push(item);
            }
            this.fleet = data["fleet"];
        }
    }

    static fromJS(data: any): GetVendorListDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetVendorListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["surname"] = this.surname;
        data["phoneNumber"] = this.phoneNumber;
        data["emailAddress"] = this.emailAddress;
        data["isEmailConfirmed"] = this.isEmailConfirmed;
        data["lockOutEndDateUtc"] = this.lockOutEndDateUtc ? this.lockOutEndDateUtc.toISOString() : <any>undefined;
        if (Array.isArray(this.locations)) {
            data["locations"] = [];
            for (let item of this.locations)
                data["locations"].push(item);
        }
        data["fleet"] = this.fleet;
        return data; 
    }
}

export interface IGetVendorListDto {
    id: number;
    name: string | undefined;
    surname: string | undefined;
    phoneNumber: string | undefined;
    emailAddress: string | undefined;
    isEmailConfirmed: boolean;
    lockOutEndDateUtc: moment.Moment | undefined;
    locations: string[] | undefined;
    fleet: string | undefined;
}

export class PagedResultDtoOfGetVendorListDto implements IPagedResultDtoOfGetVendorListDto {
    totalCount!: number;
    items!: GetVendorListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetVendorListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetVendorListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetVendorListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetVendorListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetVendorListDto {
    totalCount: number;
    items: GetVendorListDto[] | undefined;
}

export class VendorInfo implements IVendorInfo {
    startDate!: moment.Moment | undefined;
    hourlyRate!: number | undefined;
    dailyRate!: number | undefined;
    idNumber!: string | undefined;
    fleet!: FleetDto | undefined;

    constructor(data?: IVendorInfo) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.hourlyRate = data["hourlyRate"];
            this.dailyRate = data["dailyRate"];
            this.idNumber = data["idNumber"];
            this.fleet = data["fleet"] ? FleetDto.fromJS(data["fleet"]) : <any>undefined;
        }
    }

    static fromJS(data: any): VendorInfo {
        data = typeof data === 'object' ? data : {};
        let result = new VendorInfo();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["hourlyRate"] = this.hourlyRate;
        data["dailyRate"] = this.dailyRate;
        data["idNumber"] = this.idNumber;
        data["fleet"] = this.fleet ? this.fleet.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IVendorInfo {
    startDate: moment.Moment | undefined;
    hourlyRate: number | undefined;
    dailyRate: number | undefined;
    idNumber: string | undefined;
    fleet: FleetDto | undefined;
}

export class GetVendorForEditOutput implements IGetVendorForEditOutput {
    user!: UserEditDto | undefined;
    locationId!: number[] | undefined;
    contact!: ContactListDto | undefined;
    vendor!: VendorInfo | undefined;

    constructor(data?: IGetVendorForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserEditDto.fromJS(data["user"]) : <any>undefined;
            if (Array.isArray(data["locationId"])) {
                this.locationId = [] as any;
                for (let item of data["locationId"])
                    this.locationId!.push(item);
            }
            this.contact = data["contact"] ? ContactListDto.fromJS(data["contact"]) : <any>undefined;
            this.vendor = data["vendor"] ? VendorInfo.fromJS(data["vendor"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVendorForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetVendorForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        if (Array.isArray(this.locationId)) {
            data["locationId"] = [];
            for (let item of this.locationId)
                data["locationId"].push(item);
        }
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["vendor"] = this.vendor ? this.vendor.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVendorForEditOutput {
    user: UserEditDto | undefined;
    locationId: number[] | undefined;
    contact: ContactListDto | undefined;
    vendor: VendorInfo | undefined;
}

export class CreateOrEditVendorInput implements ICreateOrEditVendorInput {
    user!: UserEditDto;
    sendActivationEmail!: boolean;
    setRandomPassword!: boolean;
    location!: number[] | undefined;
    address!: CreateAddressInput | undefined;
    contact!: CreateContactInput | undefined;
    contactId!: number | undefined;
    startDate!: moment.Moment | undefined;
    hourlyRate!: number | undefined;
    dailyRate!: number | undefined;
    idNumber!: string | undefined;
    longitude!: number;
    latitude!: number;
    isImported!: boolean;
    fleetId!: number | undefined;

    constructor(data?: ICreateOrEditVendorInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
        if (!data) {
            this.user = new UserEditDto();
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserEditDto.fromJS(data["user"]) : new UserEditDto();
            this.sendActivationEmail = data["sendActivationEmail"];
            this.setRandomPassword = data["setRandomPassword"];
            if (Array.isArray(data["location"])) {
                this.location = [] as any;
                for (let item of data["location"])
                    this.location!.push(item);
            }
            this.address = data["address"] ? CreateAddressInput.fromJS(data["address"]) : <any>undefined;
            this.contact = data["contact"] ? CreateContactInput.fromJS(data["contact"]) : <any>undefined;
            this.contactId = data["contactId"];
            this.startDate = data["startDate"] ? moment(data["startDate"].toString()) : <any>undefined;
            this.hourlyRate = data["hourlyRate"];
            this.dailyRate = data["dailyRate"];
            this.idNumber = data["idNumber"];
            this.longitude = data["longitude"];
            this.latitude = data["latitude"];
            this.isImported = data["isImported"];
            this.fleetId = data["fleetId"];
        }
    }

    static fromJS(data: any): CreateOrEditVendorInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditVendorInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["sendActivationEmail"] = this.sendActivationEmail;
        data["setRandomPassword"] = this.setRandomPassword;
        if (Array.isArray(this.location)) {
            data["location"] = [];
            for (let item of this.location)
                data["location"].push(item);
        }
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        data["contact"] = this.contact ? this.contact.toJSON() : <any>undefined;
        data["contactId"] = this.contactId;
        data["startDate"] = this.startDate ? this.startDate.toISOString() : <any>undefined;
        data["hourlyRate"] = this.hourlyRate;
        data["dailyRate"] = this.dailyRate;
        data["idNumber"] = this.idNumber;
        data["longitude"] = this.longitude;
        data["latitude"] = this.latitude;
        data["isImported"] = this.isImported;
        data["fleetId"] = this.fleetId;
        return data; 
    }
}

export interface ICreateOrEditVendorInput {
    user: UserEditDto;
    sendActivationEmail: boolean;
    setRandomPassword: boolean;
    location: number[] | undefined;
    address: CreateAddressInput | undefined;
    contact: CreateContactInput | undefined;
    contactId: number | undefined;
    startDate: moment.Moment | undefined;
    hourlyRate: number | undefined;
    dailyRate: number | undefined;
    idNumber: string | undefined;
    longitude: number;
    latitude: number;
    isImported: boolean;
    fleetId: number | undefined;
}

export class GetVendorDetailsDto implements IGetVendorDetailsDto {
    user!: UserInContactListDto | undefined;
    address!: AddressListDto | undefined;
    vendorIncident!: DriverIncidentListDto[] | undefined;
    fleetName!: string | undefined;

    constructor(data?: IGetVendorDetailsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.user = data["user"] ? UserInContactListDto.fromJS(data["user"]) : <any>undefined;
            this.address = data["address"] ? AddressListDto.fromJS(data["address"]) : <any>undefined;
            if (Array.isArray(data["vendorIncident"])) {
                this.vendorIncident = [] as any;
                for (let item of data["vendorIncident"])
                    this.vendorIncident!.push(DriverIncidentListDto.fromJS(item));
            }
            this.fleetName = data["fleetName"];
        }
    }

    static fromJS(data: any): GetVendorDetailsDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetVendorDetailsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["user"] = this.user ? this.user.toJSON() : <any>undefined;
        data["address"] = this.address ? this.address.toJSON() : <any>undefined;
        if (Array.isArray(this.vendorIncident)) {
            data["vendorIncident"] = [];
            for (let item of this.vendorIncident)
                data["vendorIncident"].push(item.toJSON());
        }
        data["fleetName"] = this.fleetName;
        return data; 
    }
}

export interface IGetVendorDetailsDto {
    user: UserInContactListDto | undefined;
    address: AddressListDto | undefined;
    vendorIncident: DriverIncidentListDto[] | undefined;
    fleetName: string | undefined;
}

export class GetVendorList implements IGetVendorList {
    username!: string | undefined;
    email!: string | undefined;
    id!: number;

    constructor(data?: IGetVendorList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.username = data["username"];
            this.email = data["email"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): GetVendorList {
        data = typeof data === 'object' ? data : {};
        let result = new GetVendorList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["username"] = this.username;
        data["email"] = this.email;
        data["id"] = this.id;
        return data; 
    }
}

export interface IGetVendorList {
    username: string | undefined;
    email: string | undefined;
    id: number;
}

export class VersionDto implements IVersionDto {
    versionNumber!: string | undefined;
    releasedDate!: moment.Moment | undefined;
    id!: number;

    constructor(data?: IVersionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.versionNumber = data["versionNumber"];
            this.releasedDate = data["releasedDate"] ? moment(data["releasedDate"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): VersionDto {
        data = typeof data === 'object' ? data : {};
        let result = new VersionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["versionNumber"] = this.versionNumber;
        data["releasedDate"] = this.releasedDate ? this.releasedDate.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface IVersionDto {
    versionNumber: string | undefined;
    releasedDate: moment.Moment | undefined;
    id: number;
}

export class GetVersionForViewDto implements IGetVersionForViewDto {
    version!: VersionDto | undefined;

    constructor(data?: IGetVersionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.version = data["version"] ? VersionDto.fromJS(data["version"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVersionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetVersionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["version"] = this.version ? this.version.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVersionForViewDto {
    version: VersionDto | undefined;
}

export class PagedResultDtoOfGetVersionForViewDto implements IPagedResultDtoOfGetVersionForViewDto {
    totalCount!: number;
    items!: GetVersionForViewDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetVersionForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetVersionForViewDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetVersionForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetVersionForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetVersionForViewDto {
    totalCount: number;
    items: GetVersionForViewDto[] | undefined;
}

export class CreateOrEditVersionDto implements ICreateOrEditVersionDto {
    versionNumber!: string;
    releasedDate!: moment.Moment | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrEditVersionDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.versionNumber = data["versionNumber"];
            this.releasedDate = data["releasedDate"] ? moment(data["releasedDate"].toString()) : <any>undefined;
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrEditVersionDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrEditVersionDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["versionNumber"] = this.versionNumber;
        data["releasedDate"] = this.releasedDate ? this.releasedDate.toISOString() : <any>undefined;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrEditVersionDto {
    versionNumber: string;
    releasedDate: moment.Moment | undefined;
    id: number | undefined;
}

export class GetVersionForEditOutput implements IGetVersionForEditOutput {
    version!: CreateOrEditVersionDto | undefined;

    constructor(data?: IGetVersionForEditOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.version = data["version"] ? CreateOrEditVersionDto.fromJS(data["version"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetVersionForEditOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetVersionForEditOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["version"] = this.version ? this.version.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetVersionForEditOutput {
    version: CreateOrEditVersionDto | undefined;
}

export class GetAllVersionsInput implements IGetAllVersionsInput {
    filter!: string | undefined;
    versionNumberFilter!: string | undefined;
    maxReleasedDateFilter!: moment.Moment | undefined;
    minReleasedDateFilter!: moment.Moment | undefined;
    id!: number | undefined;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetAllVersionsInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.filter = data["filter"];
            this.versionNumberFilter = data["versionNumberFilter"];
            this.maxReleasedDateFilter = data["maxReleasedDateFilter"] ? moment(data["maxReleasedDateFilter"].toString()) : <any>undefined;
            this.minReleasedDateFilter = data["minReleasedDateFilter"] ? moment(data["minReleasedDateFilter"].toString()) : <any>undefined;
            this.id = data["id"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetAllVersionsInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllVersionsInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["filter"] = this.filter;
        data["versionNumberFilter"] = this.versionNumberFilter;
        data["maxReleasedDateFilter"] = this.maxReleasedDateFilter ? this.maxReleasedDateFilter.toISOString() : <any>undefined;
        data["minReleasedDateFilter"] = this.minReleasedDateFilter ? this.minReleasedDateFilter.toISOString() : <any>undefined;
        data["id"] = this.id;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetAllVersionsInput {
    filter: string | undefined;
    versionNumberFilter: string | undefined;
    maxReleasedDateFilter: moment.Moment | undefined;
    minReleasedDateFilter: moment.Moment | undefined;
    id: number | undefined;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class WarehousePickupInput implements IWarehousePickupInput {
    barcode!: string | undefined;
    time!: moment.Moment;
    geocode!: CreateGeocodeInput | undefined;

    constructor(data?: IWarehousePickupInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.barcode = data["barcode"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocode = data["geocode"] ? CreateGeocodeInput.fromJS(data["geocode"]) : <any>undefined;
        }
    }

    static fromJS(data: any): WarehousePickupInput {
        data = typeof data === 'object' ? data : {};
        let result = new WarehousePickupInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["barcode"] = this.barcode;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IWarehousePickupInput {
    barcode: string | undefined;
    time: moment.Moment;
    geocode: CreateGeocodeInput | undefined;
}

export class WarehousePickupResultDto implements IWarehousePickupResultDto {
    vehicleId!: number | undefined;
    routeId!: number | undefined;
    sortOrder!: number | undefined;
    isDeparted!: boolean;
    hasPickupError!: boolean;
    pickupErrorMessage!: string | undefined;

    constructor(data?: IWarehousePickupResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.vehicleId = data["vehicleId"];
            this.routeId = data["routeId"];
            this.sortOrder = data["sortOrder"];
            this.isDeparted = data["isDeparted"];
            this.hasPickupError = data["hasPickupError"];
            this.pickupErrorMessage = data["pickupErrorMessage"];
        }
    }

    static fromJS(data: any): WarehousePickupResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new WarehousePickupResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["vehicleId"] = this.vehicleId;
        data["routeId"] = this.routeId;
        data["sortOrder"] = this.sortOrder;
        data["isDeparted"] = this.isDeparted;
        data["hasPickupError"] = this.hasPickupError;
        data["pickupErrorMessage"] = this.pickupErrorMessage;
        return data; 
    }
}

export interface IWarehousePickupResultDto {
    vehicleId: number | undefined;
    routeId: number | undefined;
    sortOrder: number | undefined;
    isDeparted: boolean;
    hasPickupError: boolean;
    pickupErrorMessage: string | undefined;
}

export class WarehouseCustomPickupInput implements IWarehouseCustomPickupInput {
    orderStatusTypeId!: number;
    barcode!: string | undefined;
    time!: moment.Moment;
    geocode!: CreateGeocodeInput | undefined;

    constructor(data?: IWarehouseCustomPickupInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderStatusTypeId = data["orderStatusTypeId"];
            this.barcode = data["barcode"];
            this.time = data["time"] ? moment(data["time"].toString()) : <any>undefined;
            this.geocode = data["geocode"] ? CreateGeocodeInput.fromJS(data["geocode"]) : <any>undefined;
        }
    }

    static fromJS(data: any): WarehouseCustomPickupInput {
        data = typeof data === 'object' ? data : {};
        let result = new WarehouseCustomPickupInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderStatusTypeId"] = this.orderStatusTypeId;
        data["barcode"] = this.barcode;
        data["time"] = this.time ? this.time.toISOString() : <any>undefined;
        data["geocode"] = this.geocode ? this.geocode.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IWarehouseCustomPickupInput {
    orderStatusTypeId: number;
    barcode: string | undefined;
    time: moment.Moment;
    geocode: CreateGeocodeInput | undefined;
}

export class GetAllSendAttemptsOutput implements IGetAllSendAttemptsOutput {
    id!: string;
    webhookEventId!: string;
    webhookName!: string | undefined;
    data!: string | undefined;
    response!: string | undefined;
    responseStatusCode!: HttpStatusCode | undefined;
    creationTime!: moment.Moment;

    constructor(data?: IGetAllSendAttemptsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.webhookEventId = data["webhookEventId"];
            this.webhookName = data["webhookName"];
            this.data = data["data"];
            this.response = data["response"];
            this.responseStatusCode = data["responseStatusCode"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetAllSendAttemptsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllSendAttemptsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["webhookEventId"] = this.webhookEventId;
        data["webhookName"] = this.webhookName;
        data["data"] = this.data;
        data["response"] = this.response;
        data["responseStatusCode"] = this.responseStatusCode;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetAllSendAttemptsOutput {
    id: string;
    webhookEventId: string;
    webhookName: string | undefined;
    data: string | undefined;
    response: string | undefined;
    responseStatusCode: HttpStatusCode | undefined;
    creationTime: moment.Moment;
}

export class PagedResultDtoOfGetAllSendAttemptsOutput implements IPagedResultDtoOfGetAllSendAttemptsOutput {
    totalCount!: number;
    items!: GetAllSendAttemptsOutput[] | undefined;

    constructor(data?: IPagedResultDtoOfGetAllSendAttemptsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetAllSendAttemptsOutput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetAllSendAttemptsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetAllSendAttemptsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetAllSendAttemptsOutput {
    totalCount: number;
    items: GetAllSendAttemptsOutput[] | undefined;
}

export class GetAllSendAttemptsOfWebhookEventOutput implements IGetAllSendAttemptsOfWebhookEventOutput {
    id!: string;
    webhookSubscriptionId!: string;
    response!: string | undefined;
    responseStatusCode!: HttpStatusCode | undefined;
    creationTime!: moment.Moment;
    lastModificationTime!: moment.Moment | undefined;

    constructor(data?: IGetAllSendAttemptsOfWebhookEventOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.webhookSubscriptionId = data["webhookSubscriptionId"];
            this.response = data["response"];
            this.responseStatusCode = data["responseStatusCode"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.lastModificationTime = data["lastModificationTime"] ? moment(data["lastModificationTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetAllSendAttemptsOfWebhookEventOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllSendAttemptsOfWebhookEventOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["webhookSubscriptionId"] = this.webhookSubscriptionId;
        data["response"] = this.response;
        data["responseStatusCode"] = this.responseStatusCode;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["lastModificationTime"] = this.lastModificationTime ? this.lastModificationTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetAllSendAttemptsOfWebhookEventOutput {
    id: string;
    webhookSubscriptionId: string;
    response: string | undefined;
    responseStatusCode: HttpStatusCode | undefined;
    creationTime: moment.Moment;
    lastModificationTime: moment.Moment | undefined;
}

export class ListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput implements IListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput {
    items!: GetAllSendAttemptsOfWebhookEventOutput[] | undefined;

    constructor(data?: IListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetAllSendAttemptsOfWebhookEventOutput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetAllSendAttemptsOfWebhookEventOutput {
    items: GetAllSendAttemptsOfWebhookEventOutput[] | undefined;
}

export class GetAllSubscriptionsOutput implements IGetAllSubscriptionsOutput {
    webhookUri!: string | undefined;
    isActive!: boolean;
    webhooks!: string[] | undefined;
    id!: string;

    constructor(data?: IGetAllSubscriptionsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.webhookUri = data["webhookUri"];
            this.isActive = data["isActive"];
            if (Array.isArray(data["webhooks"])) {
                this.webhooks = [] as any;
                for (let item of data["webhooks"])
                    this.webhooks!.push(item);
            }
            this.id = data["id"];
        }
    }

    static fromJS(data: any): GetAllSubscriptionsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllSubscriptionsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["webhookUri"] = this.webhookUri;
        data["isActive"] = this.isActive;
        if (Array.isArray(this.webhooks)) {
            data["webhooks"] = [];
            for (let item of this.webhooks)
                data["webhooks"].push(item);
        }
        data["id"] = this.id;
        return data; 
    }
}

export interface IGetAllSubscriptionsOutput {
    webhookUri: string | undefined;
    isActive: boolean;
    webhooks: string[] | undefined;
    id: string;
}

export class ListResultDtoOfGetAllSubscriptionsOutput implements IListResultDtoOfGetAllSubscriptionsOutput {
    items!: GetAllSubscriptionsOutput[] | undefined;

    constructor(data?: IListResultDtoOfGetAllSubscriptionsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetAllSubscriptionsOutput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetAllSubscriptionsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetAllSubscriptionsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetAllSubscriptionsOutput {
    items: GetAllSubscriptionsOutput[] | undefined;
}

export class WebhookSubscription implements IWebhookSubscription {
    tenantId!: number | undefined;
    webhookUri!: string | undefined;
    secret!: string | undefined;
    isActive!: boolean;
    webhooks!: string[] | undefined;
    headers!: { [key: string]: string; } | undefined;
    id!: string;

    constructor(data?: IWebhookSubscription) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.webhookUri = data["webhookUri"];
            this.secret = data["secret"];
            this.isActive = data["isActive"];
            if (Array.isArray(data["webhooks"])) {
                this.webhooks = [] as any;
                for (let item of data["webhooks"])
                    this.webhooks!.push(item);
            }
            if (data["headers"]) {
                this.headers = {} as any;
                for (let key in data["headers"]) {
                    if (data["headers"].hasOwnProperty(key))
                        this.headers![key] = data["headers"][key];
                }
            }
            this.id = data["id"];
        }
    }

    static fromJS(data: any): WebhookSubscription {
        data = typeof data === 'object' ? data : {};
        let result = new WebhookSubscription();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["webhookUri"] = this.webhookUri;
        data["secret"] = this.secret;
        data["isActive"] = this.isActive;
        if (Array.isArray(this.webhooks)) {
            data["webhooks"] = [];
            for (let item of this.webhooks)
                data["webhooks"].push(item);
        }
        if (this.headers) {
            data["headers"] = {};
            for (let key in this.headers) {
                if (this.headers.hasOwnProperty(key))
                    data["headers"][key] = this.headers[key];
            }
        }
        data["id"] = this.id;
        return data; 
    }
}

export interface IWebhookSubscription {
    tenantId: number | undefined;
    webhookUri: string | undefined;
    secret: string | undefined;
    isActive: boolean;
    webhooks: string[] | undefined;
    headers: { [key: string]: string; } | undefined;
    id: string;
}

export class ActivateWebhookSubscriptionInput implements IActivateWebhookSubscriptionInput {
    subscriptionId!: string;
    isActive!: boolean;

    constructor(data?: IActivateWebhookSubscriptionInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.subscriptionId = data["subscriptionId"];
            this.isActive = data["isActive"];
        }
    }

    static fromJS(data: any): ActivateWebhookSubscriptionInput {
        data = typeof data === 'object' ? data : {};
        let result = new ActivateWebhookSubscriptionInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["subscriptionId"] = this.subscriptionId;
        data["isActive"] = this.isActive;
        return data; 
    }
}

export interface IActivateWebhookSubscriptionInput {
    subscriptionId: string;
    isActive: boolean;
}

export class GetAllAvailableWebhooksOutput implements IGetAllAvailableWebhooksOutput {
    name!: string | undefined;
    displayName!: string | undefined;
    description!: string | undefined;

    constructor(data?: IGetAllAvailableWebhooksOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.displayName = data["displayName"];
            this.description = data["description"];
        }
    }

    static fromJS(data: any): GetAllAvailableWebhooksOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllAvailableWebhooksOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["displayName"] = this.displayName;
        data["description"] = this.description;
        return data; 
    }
}

export interface IGetAllAvailableWebhooksOutput {
    name: string | undefined;
    displayName: string | undefined;
    description: string | undefined;
}

export class ListResultDtoOfGetAllAvailableWebhooksOutput implements IListResultDtoOfGetAllAvailableWebhooksOutput {
    items!: GetAllAvailableWebhooksOutput[] | undefined;

    constructor(data?: IListResultDtoOfGetAllAvailableWebhooksOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetAllAvailableWebhooksOutput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfGetAllAvailableWebhooksOutput {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfGetAllAvailableWebhooksOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfGetAllAvailableWebhooksOutput {
    items: GetAllAvailableWebhooksOutput[] | undefined;
}

export class GetLatestWebLogsOutput implements IGetLatestWebLogsOutput {
    latestWebLogLines!: string[] | undefined;

    constructor(data?: IGetLatestWebLogsOutput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["latestWebLogLines"])) {
                this.latestWebLogLines = [] as any;
                for (let item of data["latestWebLogLines"])
                    this.latestWebLogLines!.push(item);
            }
        }
    }

    static fromJS(data: any): GetLatestWebLogsOutput {
        data = typeof data === 'object' ? data : {};
        let result = new GetLatestWebLogsOutput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.latestWebLogLines)) {
            data["latestWebLogLines"] = [];
            for (let item of this.latestWebLogLines)
                data["latestWebLogLines"].push(item);
        }
        return data; 
    }
}

export interface IGetLatestWebLogsOutput {
    latestWebLogLines: string[] | undefined;
}

export class GetClinicResultDto implements IGetClinicResultDto {
    name!: string | undefined;
    accountNumber!: string | undefined;
    id!: number;
    address!: string | undefined;
    email!: string | undefined;
    phone!: string | undefined;
    message!: string | undefined;

    constructor(data?: IGetClinicResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.name = data["name"];
            this.accountNumber = data["accountNumber"];
            this.id = data["id"];
            this.address = data["address"];
            this.email = data["email"];
            this.phone = data["phone"];
            this.message = data["message"];
        }
    }

    static fromJS(data: any): GetClinicResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetClinicResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["name"] = this.name;
        data["accountNumber"] = this.accountNumber;
        data["id"] = this.id;
        data["address"] = this.address;
        data["email"] = this.email;
        data["phone"] = this.phone;
        data["message"] = this.message;
        return data; 
    }
}

export interface IGetClinicResultDto {
    name: string | undefined;
    accountNumber: string | undefined;
    id: number;
    address: string | undefined;
    email: string | undefined;
    phone: string | undefined;
    message: string | undefined;
}

export class GetOrderResultDto implements IGetOrderResultDto {
    orderId!: number;
    name!: string | undefined;
    accountNumber!: string | undefined;
    clinicId!: number;
    address!: string | undefined;
    email!: string | undefined;
    phone!: string | undefined;
    confirmationNumber!: string | undefined;
    routeCode!: string | undefined;
    eta!: moment.Moment;

    constructor(data?: IGetOrderResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.name = data["name"];
            this.accountNumber = data["accountNumber"];
            this.clinicId = data["clinicId"];
            this.address = data["address"];
            this.email = data["email"];
            this.phone = data["phone"];
            this.confirmationNumber = data["confirmationNumber"];
            this.routeCode = data["routeCode"];
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetOrderResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetOrderResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["name"] = this.name;
        data["accountNumber"] = this.accountNumber;
        data["clinicId"] = this.clinicId;
        data["address"] = this.address;
        data["email"] = this.email;
        data["phone"] = this.phone;
        data["confirmationNumber"] = this.confirmationNumber;
        data["routeCode"] = this.routeCode;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetOrderResultDto {
    orderId: number;
    name: string | undefined;
    accountNumber: string | undefined;
    clinicId: number;
    address: string | undefined;
    email: string | undefined;
    phone: string | undefined;
    confirmationNumber: string | undefined;
    routeCode: string | undefined;
    eta: moment.Moment;
}

export class HistoryPackage implements IHistoryPackage {
    packageName!: string | undefined;
    quantity!: number;
    orderId!: number;

    constructor(data?: IHistoryPackage) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.packageName = data["packageName"];
            this.quantity = data["quantity"];
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): HistoryPackage {
        data = typeof data === 'object' ? data : {};
        let result = new HistoryPackage();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["packageName"] = this.packageName;
        data["quantity"] = this.quantity;
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface IHistoryPackage {
    packageName: string | undefined;
    quantity: number;
    orderId: number;
}

export class HistoryOrderListDto implements IHistoryOrderListDto {
    id!: number;
    type!: string | undefined;
    confirmationNumber!: string | undefined;
    status!: string | undefined;
    dateTime!: string | undefined;
    createdBy!: string | undefined;
    color!: string | undefined;
    icon!: string | undefined;
    statusDescriptionId!: number;
    originalDateTime!: moment.Moment;
    orderTypeId!: number;
    routeCode!: string | undefined;
    etaDateTime!: string | undefined;
    originalEtaDateTime!: moment.Moment | undefined;
    lastModified!: string | undefined;
    historyPackageList!: HistoryPackage[] | undefined;
    location!: string | undefined;
    driver!: string | undefined;
    callerName!: string | undefined;
    orderType!: OrderTypeDto | undefined;
    attachmentCount!: number;
    incidentIdList!: number[] | undefined;
    pickUpDateTime!: string | undefined;
    originalPickUpDateTime!: moment.Moment | undefined;

    constructor(data?: IHistoryOrderListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.type = data["type"];
            this.confirmationNumber = data["confirmationNumber"];
            this.status = data["status"];
            this.dateTime = data["dateTime"];
            this.createdBy = data["createdBy"];
            this.color = data["color"];
            this.icon = data["icon"];
            this.statusDescriptionId = data["statusDescriptionId"];
            this.originalDateTime = data["originalDateTime"] ? moment(data["originalDateTime"].toString()) : <any>undefined;
            this.orderTypeId = data["orderTypeId"];
            this.routeCode = data["routeCode"];
            this.etaDateTime = data["etaDateTime"];
            this.originalEtaDateTime = data["originalEtaDateTime"] ? moment(data["originalEtaDateTime"].toString()) : <any>undefined;
            this.lastModified = data["lastModified"];
            if (Array.isArray(data["historyPackageList"])) {
                this.historyPackageList = [] as any;
                for (let item of data["historyPackageList"])
                    this.historyPackageList!.push(HistoryPackage.fromJS(item));
            }
            this.location = data["location"];
            this.driver = data["driver"];
            this.callerName = data["callerName"];
            this.orderType = data["orderType"] ? OrderTypeDto.fromJS(data["orderType"]) : <any>undefined;
            this.attachmentCount = data["attachmentCount"];
            if (Array.isArray(data["incidentIdList"])) {
                this.incidentIdList = [] as any;
                for (let item of data["incidentIdList"])
                    this.incidentIdList!.push(item);
            }
            this.pickUpDateTime = data["pickUpDateTime"];
            this.originalPickUpDateTime = data["originalPickUpDateTime"] ? moment(data["originalPickUpDateTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): HistoryOrderListDto {
        data = typeof data === 'object' ? data : {};
        let result = new HistoryOrderListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["type"] = this.type;
        data["confirmationNumber"] = this.confirmationNumber;
        data["status"] = this.status;
        data["dateTime"] = this.dateTime;
        data["createdBy"] = this.createdBy;
        data["color"] = this.color;
        data["icon"] = this.icon;
        data["statusDescriptionId"] = this.statusDescriptionId;
        data["originalDateTime"] = this.originalDateTime ? this.originalDateTime.toISOString() : <any>undefined;
        data["orderTypeId"] = this.orderTypeId;
        data["routeCode"] = this.routeCode;
        data["etaDateTime"] = this.etaDateTime;
        data["originalEtaDateTime"] = this.originalEtaDateTime ? this.originalEtaDateTime.toISOString() : <any>undefined;
        data["lastModified"] = this.lastModified;
        if (Array.isArray(this.historyPackageList)) {
            data["historyPackageList"] = [];
            for (let item of this.historyPackageList)
                data["historyPackageList"].push(item.toJSON());
        }
        data["location"] = this.location;
        data["driver"] = this.driver;
        data["callerName"] = this.callerName;
        data["orderType"] = this.orderType ? this.orderType.toJSON() : <any>undefined;
        data["attachmentCount"] = this.attachmentCount;
        if (Array.isArray(this.incidentIdList)) {
            data["incidentIdList"] = [];
            for (let item of this.incidentIdList)
                data["incidentIdList"].push(item);
        }
        data["pickUpDateTime"] = this.pickUpDateTime;
        data["originalPickUpDateTime"] = this.originalPickUpDateTime ? this.originalPickUpDateTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IHistoryOrderListDto {
    id: number;
    type: string | undefined;
    confirmationNumber: string | undefined;
    status: string | undefined;
    dateTime: string | undefined;
    createdBy: string | undefined;
    color: string | undefined;
    icon: string | undefined;
    statusDescriptionId: number;
    originalDateTime: moment.Moment;
    orderTypeId: number;
    routeCode: string | undefined;
    etaDateTime: string | undefined;
    originalEtaDateTime: moment.Moment | undefined;
    lastModified: string | undefined;
    historyPackageList: HistoryPackage[] | undefined;
    location: string | undefined;
    driver: string | undefined;
    callerName: string | undefined;
    orderType: OrderTypeDto | undefined;
    attachmentCount: number;
    incidentIdList: number[] | undefined;
    pickUpDateTime: string | undefined;
    originalPickUpDateTime: moment.Moment | undefined;
}

export class PagedResultDtoOfHistoryOrderListDto implements IPagedResultDtoOfHistoryOrderListDto {
    totalCount!: number;
    items!: HistoryOrderListDto[] | undefined;

    constructor(data?: IPagedResultDtoOfHistoryOrderListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(HistoryOrderListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfHistoryOrderListDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfHistoryOrderListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfHistoryOrderListDto {
    totalCount: number;
    items: HistoryOrderListDto[] | undefined;
}

export class GetHistoryResultDto implements IGetHistoryResultDto {
    clinic!: ClinicDto | undefined;
    orders!: PagedResultDtoOfHistoryOrderListDto | undefined;

    constructor(data?: IGetHistoryResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinic = data["clinic"] ? ClinicDto.fromJS(data["clinic"]) : <any>undefined;
            this.orders = data["orders"] ? PagedResultDtoOfHistoryOrderListDto.fromJS(data["orders"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetHistoryResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetHistoryResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinic"] = this.clinic ? this.clinic.toJSON() : <any>undefined;
        data["orders"] = this.orders ? this.orders.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetHistoryResultDto {
    clinic: ClinicDto | undefined;
    orders: PagedResultDtoOfHistoryOrderListDto | undefined;
}

export class GetRouteByClinicResultDto implements IGetRouteByClinicResultDto {
    id!: number;
    name!: string | undefined;

    constructor(data?: IGetRouteByClinicResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
        }
    }

    static fromJS(data: any): GetRouteByClinicResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteByClinicResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        return data; 
    }
}

export interface IGetRouteByClinicResultDto {
    id: number;
    name: string | undefined;
}

export class GetCallBackRouteDto implements IGetCallBackRouteDto {
    routeId!: number;
    routeCode!: string | undefined;
    cutOffValidation!: boolean;
    etaValidation!: boolean;
    driverEta!: string | undefined;
    cutOffTime!: string | undefined;

    constructor(data?: IGetCallBackRouteDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.routeCode = data["routeCode"];
            this.cutOffValidation = data["cutOffValidation"];
            this.etaValidation = data["etaValidation"];
            this.driverEta = data["driverEta"];
            this.cutOffTime = data["cutOffTime"];
        }
    }

    static fromJS(data: any): GetCallBackRouteDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetCallBackRouteDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["routeCode"] = this.routeCode;
        data["cutOffValidation"] = this.cutOffValidation;
        data["etaValidation"] = this.etaValidation;
        data["driverEta"] = this.driverEta;
        data["cutOffTime"] = this.cutOffTime;
        return data; 
    }
}

export interface IGetCallBackRouteDto {
    routeId: number;
    routeCode: string | undefined;
    cutOffValidation: boolean;
    etaValidation: boolean;
    driverEta: string | undefined;
    cutOffTime: string | undefined;
}

export class CreateCallbackInput implements ICreateCallbackInput {
    clinicId!: number;
    routeCode!: string | undefined;
    routeDate!: moment.Moment;
    locationId!: number;

    constructor(data?: ICreateCallbackInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
            this.routeCode = data["routeCode"];
            this.routeDate = data["routeDate"] ? moment(data["routeDate"].toString()) : <any>undefined;
            this.locationId = data["locationId"];
        }
    }

    static fromJS(data: any): CreateCallbackInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateCallbackInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        data["routeCode"] = this.routeCode;
        data["routeDate"] = this.routeDate ? this.routeDate.toISOString() : <any>undefined;
        data["locationId"] = this.locationId;
        return data; 
    }
}

export interface ICreateCallbackInput {
    clinicId: number;
    routeCode: string | undefined;
    routeDate: moment.Moment;
    locationId: number;
}

export class AvailablePickupsDto implements IAvailablePickupsDto {
    eta!: moment.Moment;
    routeScheduleDetailId!: number;
    etaUtc!: moment.Moment;
    etaUtcOffset!: number;
    confirmationNumber!: string | undefined;
    routeType!: string | undefined;

    constructor(data?: IAvailablePickupsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.etaUtc = data["etaUtc"] ? moment(data["etaUtc"].toString()) : <any>undefined;
            this.etaUtcOffset = data["etaUtcOffset"];
            this.confirmationNumber = data["confirmationNumber"];
            this.routeType = data["routeType"];
        }
    }

    static fromJS(data: any): AvailablePickupsDto {
        data = typeof data === 'object' ? data : {};
        let result = new AvailablePickupsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["etaUtc"] = this.etaUtc ? this.etaUtc.toISOString() : <any>undefined;
        data["etaUtcOffset"] = this.etaUtcOffset;
        data["confirmationNumber"] = this.confirmationNumber;
        data["routeType"] = this.routeType;
        return data; 
    }
}

export interface IAvailablePickupsDto {
    eta: moment.Moment;
    routeScheduleDetailId: number;
    etaUtc: moment.Moment;
    etaUtcOffset: number;
    confirmationNumber: string | undefined;
    routeType: string | undefined;
}

export class GetClinicScheduleResultDto implements IGetClinicScheduleResultDto {
    clinicId!: number;
    accountNumber!: string | undefined;
    addressLine1!: string | undefined;
    postalCode!: string | undefined;
    phoneNumber!: string | undefined;
    availablePickups!: AvailablePickupsDto[] | undefined;
    message!: string | undefined;

    constructor(data?: IGetClinicScheduleResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
            this.accountNumber = data["accountNumber"];
            this.addressLine1 = data["addressLine1"];
            this.postalCode = data["postalCode"];
            this.phoneNumber = data["phoneNumber"];
            if (Array.isArray(data["availablePickups"])) {
                this.availablePickups = [] as any;
                for (let item of data["availablePickups"])
                    this.availablePickups!.push(AvailablePickupsDto.fromJS(item));
            }
            this.message = data["message"];
        }
    }

    static fromJS(data: any): GetClinicScheduleResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetClinicScheduleResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        data["accountNumber"] = this.accountNumber;
        data["addressLine1"] = this.addressLine1;
        data["postalCode"] = this.postalCode;
        data["phoneNumber"] = this.phoneNumber;
        if (Array.isArray(this.availablePickups)) {
            data["availablePickups"] = [];
            for (let item of this.availablePickups)
                data["availablePickups"].push(item.toJSON());
        }
        data["message"] = this.message;
        return data; 
    }
}

export interface IGetClinicScheduleResultDto {
    clinicId: number;
    accountNumber: string | undefined;
    addressLine1: string | undefined;
    postalCode: string | undefined;
    phoneNumber: string | undefined;
    availablePickups: AvailablePickupsDto[] | undefined;
    message: string | undefined;
}

export class GetClinicSchedResultDto implements IGetClinicSchedResultDto {
    id!: number;
    routeCode!: string | undefined;
    eta!: moment.Moment;
    etaUtc!: moment.Moment;
    etaConvert!: string | undefined;
    date!: string | undefined;
    location!: string | undefined;
    day!: string | undefined;
    routeTypeCode!: string | undefined;
    routeTypeSortOrder!: number | undefined;
    confirmationNumber!: string | undefined;
    message!: string | undefined;
    pastMidnight!: boolean;
    startTime!: TimeSpan;
    endTime!: TimeSpan;
    routeTypeStartTime!: TimeSpan | undefined;
    startTimeType!: number;
    loadDate!: string | undefined;
    utcOffset!: number;
    locationId!: number;
    routeScheduleCount!: number;
    nextDay!: boolean;
    routeLoadDate!: moment.Moment;
    routeScheduleDetailParam!: RouteScheduleDetailParam | undefined;
    routeTemplate!: CreateRouteTemplateClinicInput | undefined;
    routeList!: GetRoutesResultDto | undefined;

    constructor(data?: IGetClinicSchedResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeCode = data["routeCode"];
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
            this.etaUtc = data["etaUtc"] ? moment(data["etaUtc"].toString()) : <any>undefined;
            this.etaConvert = data["etaConvert"];
            this.date = data["date"];
            this.location = data["location"];
            this.day = data["day"];
            this.routeTypeCode = data["routeTypeCode"];
            this.routeTypeSortOrder = data["routeTypeSortOrder"];
            this.confirmationNumber = data["confirmationNumber"];
            this.message = data["message"];
            this.pastMidnight = data["pastMidnight"];
            this.startTime = data["startTime"] ? TimeSpan.fromJS(data["startTime"]) : <any>undefined;
            this.endTime = data["endTime"] ? TimeSpan.fromJS(data["endTime"]) : <any>undefined;
            this.routeTypeStartTime = data["routeTypeStartTime"] ? TimeSpan.fromJS(data["routeTypeStartTime"]) : <any>undefined;
            this.startTimeType = data["startTimeType"];
            this.loadDate = data["loadDate"];
            this.utcOffset = data["utcOffset"];
            this.locationId = data["locationId"];
            this.routeScheduleCount = data["routeScheduleCount"];
            this.nextDay = data["nextDay"];
            this.routeLoadDate = data["routeLoadDate"] ? moment(data["routeLoadDate"].toString()) : <any>undefined;
            this.routeScheduleDetailParam = data["routeScheduleDetailParam"] ? RouteScheduleDetailParam.fromJS(data["routeScheduleDetailParam"]) : <any>undefined;
            this.routeTemplate = data["routeTemplate"] ? CreateRouteTemplateClinicInput.fromJS(data["routeTemplate"]) : <any>undefined;
            this.routeList = data["routeList"] ? GetRoutesResultDto.fromJS(data["routeList"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetClinicSchedResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetClinicSchedResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeCode"] = this.routeCode;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        data["etaUtc"] = this.etaUtc ? this.etaUtc.toISOString() : <any>undefined;
        data["etaConvert"] = this.etaConvert;
        data["date"] = this.date;
        data["location"] = this.location;
        data["day"] = this.day;
        data["routeTypeCode"] = this.routeTypeCode;
        data["routeTypeSortOrder"] = this.routeTypeSortOrder;
        data["confirmationNumber"] = this.confirmationNumber;
        data["message"] = this.message;
        data["pastMidnight"] = this.pastMidnight;
        data["startTime"] = this.startTime ? this.startTime.toJSON() : <any>undefined;
        data["endTime"] = this.endTime ? this.endTime.toJSON() : <any>undefined;
        data["routeTypeStartTime"] = this.routeTypeStartTime ? this.routeTypeStartTime.toJSON() : <any>undefined;
        data["startTimeType"] = this.startTimeType;
        data["loadDate"] = this.loadDate;
        data["utcOffset"] = this.utcOffset;
        data["locationId"] = this.locationId;
        data["routeScheduleCount"] = this.routeScheduleCount;
        data["nextDay"] = this.nextDay;
        data["routeLoadDate"] = this.routeLoadDate ? this.routeLoadDate.toISOString() : <any>undefined;
        data["routeScheduleDetailParam"] = this.routeScheduleDetailParam ? this.routeScheduleDetailParam.toJSON() : <any>undefined;
        data["routeTemplate"] = this.routeTemplate ? this.routeTemplate.toJSON() : <any>undefined;
        data["routeList"] = this.routeList ? this.routeList.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetClinicSchedResultDto {
    id: number;
    routeCode: string | undefined;
    eta: moment.Moment;
    etaUtc: moment.Moment;
    etaConvert: string | undefined;
    date: string | undefined;
    location: string | undefined;
    day: string | undefined;
    routeTypeCode: string | undefined;
    routeTypeSortOrder: number | undefined;
    confirmationNumber: string | undefined;
    message: string | undefined;
    pastMidnight: boolean;
    startTime: TimeSpan;
    endTime: TimeSpan;
    routeTypeStartTime: TimeSpan | undefined;
    startTimeType: number;
    loadDate: string | undefined;
    utcOffset: number;
    locationId: number;
    routeScheduleCount: number;
    nextDay: boolean;
    routeLoadDate: moment.Moment;
    routeScheduleDetailParam: RouteScheduleDetailParam | undefined;
    routeTemplate: CreateRouteTemplateClinicInput | undefined;
    routeList: GetRoutesResultDto | undefined;
}

export class SaveNotesInput implements ISaveNotesInput {
    clinicId!: number;
    orderId!: number;
    specialInstructions!: string | undefined;
    routeScheduleDetailId!: number;
    date!: moment.Moment;

    constructor(data?: ISaveNotesInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
            this.orderId = data["orderId"];
            this.specialInstructions = data["specialInstructions"];
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.date = data["date"] ? moment(data["date"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): SaveNotesInput {
        data = typeof data === 'object' ? data : {};
        let result = new SaveNotesInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        data["orderId"] = this.orderId;
        data["specialInstructions"] = this.specialInstructions;
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["date"] = this.date ? this.date.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ISaveNotesInput {
    clinicId: number;
    orderId: number;
    specialInstructions: string | undefined;
    routeScheduleDetailId: number;
    date: moment.Moment;
}

export class SaveNoteResultDto implements ISaveNoteResultDto {
    orderId!: number;

    constructor(data?: ISaveNoteResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
        }
    }

    static fromJS(data: any): SaveNoteResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new SaveNoteResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        return data; 
    }
}

export interface ISaveNoteResultDto {
    orderId: number;
}

export class RoutesSchedPerDayDto implements IRoutesSchedPerDayDto {
    cutOff!: string | undefined;
    etaTime!: string | undefined;
    effectivityDate!: moment.Moment;
    isActive!: boolean;
    routeTypeCode!: string | undefined;
    mondayIsAuto!: number | undefined;
    mondayETATime!: string | undefined;
    mondayCutOffTime!: string | undefined;
    mondayLTA!: string | undefined;
    tuesdayIsAuto!: number | undefined;
    tuesdayETATime!: string | undefined;
    tuesdayCutOffTime!: string | undefined;
    tuesdayLTA!: string | undefined;
    wednesdayIsAuto!: number | undefined;
    wednesdayETATime!: string | undefined;
    wednesdayCutOffTime!: string | undefined;
    wednesdayLTA!: string | undefined;
    thursdayIsAuto!: number | undefined;
    thursdayETATime!: string | undefined;
    thursdayCutOffTime!: string | undefined;
    thursdayLTA!: string | undefined;
    fridayIsAuto!: number | undefined;
    fridayETATime!: string | undefined;
    fridayCutOffTime!: string | undefined;
    fridayLTA!: string | undefined;
    saturdayIsAuto!: number | undefined;
    saturdayETATime!: string | undefined;
    saturdayCutOffTime!: string | undefined;
    saturdayLTA!: string | undefined;
    sundayIsAuto!: number | undefined;
    sundayETATime!: string | undefined;
    sundayCutOffTime!: string | undefined;
    sundayLTA!: string | undefined;

    constructor(data?: IRoutesSchedPerDayDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.cutOff = data["cutOff"];
            this.etaTime = data["etaTime"];
            this.effectivityDate = data["effectivityDate"] ? moment(data["effectivityDate"].toString()) : <any>undefined;
            this.isActive = data["isActive"];
            this.routeTypeCode = data["routeTypeCode"];
            this.mondayIsAuto = data["mondayIsAuto"];
            this.mondayETATime = data["mondayETATime"];
            this.mondayCutOffTime = data["mondayCutOffTime"];
            this.mondayLTA = data["mondayLTA"];
            this.tuesdayIsAuto = data["tuesdayIsAuto"];
            this.tuesdayETATime = data["tuesdayETATime"];
            this.tuesdayCutOffTime = data["tuesdayCutOffTime"];
            this.tuesdayLTA = data["tuesdayLTA"];
            this.wednesdayIsAuto = data["wednesdayIsAuto"];
            this.wednesdayETATime = data["wednesdayETATime"];
            this.wednesdayCutOffTime = data["wednesdayCutOffTime"];
            this.wednesdayLTA = data["wednesdayLTA"];
            this.thursdayIsAuto = data["thursdayIsAuto"];
            this.thursdayETATime = data["thursdayETATime"];
            this.thursdayCutOffTime = data["thursdayCutOffTime"];
            this.thursdayLTA = data["thursdayLTA"];
            this.fridayIsAuto = data["fridayIsAuto"];
            this.fridayETATime = data["fridayETATime"];
            this.fridayCutOffTime = data["fridayCutOffTime"];
            this.fridayLTA = data["fridayLTA"];
            this.saturdayIsAuto = data["saturdayIsAuto"];
            this.saturdayETATime = data["saturdayETATime"];
            this.saturdayCutOffTime = data["saturdayCutOffTime"];
            this.saturdayLTA = data["saturdayLTA"];
            this.sundayIsAuto = data["sundayIsAuto"];
            this.sundayETATime = data["sundayETATime"];
            this.sundayCutOffTime = data["sundayCutOffTime"];
            this.sundayLTA = data["sundayLTA"];
        }
    }

    static fromJS(data: any): RoutesSchedPerDayDto {
        data = typeof data === 'object' ? data : {};
        let result = new RoutesSchedPerDayDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["cutOff"] = this.cutOff;
        data["etaTime"] = this.etaTime;
        data["effectivityDate"] = this.effectivityDate ? this.effectivityDate.toISOString() : <any>undefined;
        data["isActive"] = this.isActive;
        data["routeTypeCode"] = this.routeTypeCode;
        data["mondayIsAuto"] = this.mondayIsAuto;
        data["mondayETATime"] = this.mondayETATime;
        data["mondayCutOffTime"] = this.mondayCutOffTime;
        data["mondayLTA"] = this.mondayLTA;
        data["tuesdayIsAuto"] = this.tuesdayIsAuto;
        data["tuesdayETATime"] = this.tuesdayETATime;
        data["tuesdayCutOffTime"] = this.tuesdayCutOffTime;
        data["tuesdayLTA"] = this.tuesdayLTA;
        data["wednesdayIsAuto"] = this.wednesdayIsAuto;
        data["wednesdayETATime"] = this.wednesdayETATime;
        data["wednesdayCutOffTime"] = this.wednesdayCutOffTime;
        data["wednesdayLTA"] = this.wednesdayLTA;
        data["thursdayIsAuto"] = this.thursdayIsAuto;
        data["thursdayETATime"] = this.thursdayETATime;
        data["thursdayCutOffTime"] = this.thursdayCutOffTime;
        data["thursdayLTA"] = this.thursdayLTA;
        data["fridayIsAuto"] = this.fridayIsAuto;
        data["fridayETATime"] = this.fridayETATime;
        data["fridayCutOffTime"] = this.fridayCutOffTime;
        data["fridayLTA"] = this.fridayLTA;
        data["saturdayIsAuto"] = this.saturdayIsAuto;
        data["saturdayETATime"] = this.saturdayETATime;
        data["saturdayCutOffTime"] = this.saturdayCutOffTime;
        data["saturdayLTA"] = this.saturdayLTA;
        data["sundayIsAuto"] = this.sundayIsAuto;
        data["sundayETATime"] = this.sundayETATime;
        data["sundayCutOffTime"] = this.sundayCutOffTime;
        data["sundayLTA"] = this.sundayLTA;
        return data; 
    }
}

export interface IRoutesSchedPerDayDto {
    cutOff: string | undefined;
    etaTime: string | undefined;
    effectivityDate: moment.Moment;
    isActive: boolean;
    routeTypeCode: string | undefined;
    mondayIsAuto: number | undefined;
    mondayETATime: string | undefined;
    mondayCutOffTime: string | undefined;
    mondayLTA: string | undefined;
    tuesdayIsAuto: number | undefined;
    tuesdayETATime: string | undefined;
    tuesdayCutOffTime: string | undefined;
    tuesdayLTA: string | undefined;
    wednesdayIsAuto: number | undefined;
    wednesdayETATime: string | undefined;
    wednesdayCutOffTime: string | undefined;
    wednesdayLTA: string | undefined;
    thursdayIsAuto: number | undefined;
    thursdayETATime: string | undefined;
    thursdayCutOffTime: string | undefined;
    thursdayLTA: string | undefined;
    fridayIsAuto: number | undefined;
    fridayETATime: string | undefined;
    fridayCutOffTime: string | undefined;
    fridayLTA: string | undefined;
    saturdayIsAuto: number | undefined;
    saturdayETATime: string | undefined;
    saturdayCutOffTime: string | undefined;
    saturdayLTA: string | undefined;
    sundayIsAuto: number | undefined;
    sundayETATime: string | undefined;
    sundayCutOffTime: string | undefined;
    sundayLTA: string | undefined;
}

export class RoutesDto implements IRoutesDto {
    routeCode!: string | undefined;
    days!: RoutesSchedPerDayDto[] | undefined;

    constructor(data?: IRoutesDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeCode = data["routeCode"];
            if (Array.isArray(data["days"])) {
                this.days = [] as any;
                for (let item of data["days"])
                    this.days!.push(RoutesSchedPerDayDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): RoutesDto {
        data = typeof data === 'object' ? data : {};
        let result = new RoutesDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeCode"] = this.routeCode;
        if (Array.isArray(this.days)) {
            data["days"] = [];
            for (let item of this.days)
                data["days"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IRoutesDto {
    routeCode: string | undefined;
    days: RoutesSchedPerDayDto[] | undefined;
}

export class ClinicScheduleDetailsInput implements IClinicScheduleDetailsInput {
    timeWindowStart!: number;
    timeWindowEnd!: number;
    routes!: RoutesDto[] | undefined;

    constructor(data?: IClinicScheduleDetailsInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.timeWindowStart = data["timeWindowStart"];
            this.timeWindowEnd = data["timeWindowEnd"];
            if (Array.isArray(data["routes"])) {
                this.routes = [] as any;
                for (let item of data["routes"])
                    this.routes!.push(RoutesDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ClinicScheduleDetailsInput {
        data = typeof data === 'object' ? data : {};
        let result = new ClinicScheduleDetailsInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["timeWindowStart"] = this.timeWindowStart;
        data["timeWindowEnd"] = this.timeWindowEnd;
        if (Array.isArray(this.routes)) {
            data["routes"] = [];
            for (let item of this.routes)
                data["routes"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IClinicScheduleDetailsInput {
    timeWindowStart: number;
    timeWindowEnd: number;
    routes: RoutesDto[] | undefined;
}

export class CreateClinicScheduleInput implements ICreateClinicScheduleInput {
    clinicNotes!: string | undefined;
    clinicNotesVisibleToDriver!: boolean;
    active!: boolean;
    billingNotes!: string | undefined;
    addressLine1!: string;
    addressLine2!: string | undefined;
    city!: string | undefined;
    state!: string | undefined;
    postalCode!: string | undefined;
    country!: string | undefined;
    companyName!: string | undefined;
    accountNumber!: string | undefined;
    clinicPhoneNumber!: string | undefined;
    email!: string | undefined;
    contactSetting!: GetContactSettingsItemDto[] | undefined;
    contactGroup!: ContactGroupSettingsItemDto[] | undefined;
    mondayClinicNotes!: string | undefined;
    tuesdayClinicNotes!: string | undefined;
    wednesdayClinicNotes!: string | undefined;
    thursdayClinicNotes!: string | undefined;
    fridayClinicNotes!: string | undefined;
    saturdayClinicNotes!: string | undefined;
    sundayClinicNotes!: string | undefined;
    clinicScheduleDetails!: ClinicScheduleDetailsInput[] | undefined;

    constructor(data?: ICreateClinicScheduleInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicNotes = data["clinicNotes"];
            this.clinicNotesVisibleToDriver = data["clinicNotesVisibleToDriver"];
            this.active = data["active"];
            this.billingNotes = data["billingNotes"];
            this.addressLine1 = data["addressLine1"];
            this.addressLine2 = data["addressLine2"];
            this.city = data["city"];
            this.state = data["state"];
            this.postalCode = data["postalCode"];
            this.country = data["country"];
            this.companyName = data["companyName"];
            this.accountNumber = data["accountNumber"];
            this.clinicPhoneNumber = data["clinicPhoneNumber"];
            this.email = data["email"];
            if (Array.isArray(data["contactSetting"])) {
                this.contactSetting = [] as any;
                for (let item of data["contactSetting"])
                    this.contactSetting!.push(GetContactSettingsItemDto.fromJS(item));
            }
            if (Array.isArray(data["contactGroup"])) {
                this.contactGroup = [] as any;
                for (let item of data["contactGroup"])
                    this.contactGroup!.push(ContactGroupSettingsItemDto.fromJS(item));
            }
            this.mondayClinicNotes = data["mondayClinicNotes"];
            this.tuesdayClinicNotes = data["tuesdayClinicNotes"];
            this.wednesdayClinicNotes = data["wednesdayClinicNotes"];
            this.thursdayClinicNotes = data["thursdayClinicNotes"];
            this.fridayClinicNotes = data["fridayClinicNotes"];
            this.saturdayClinicNotes = data["saturdayClinicNotes"];
            this.sundayClinicNotes = data["sundayClinicNotes"];
            if (Array.isArray(data["clinicScheduleDetails"])) {
                this.clinicScheduleDetails = [] as any;
                for (let item of data["clinicScheduleDetails"])
                    this.clinicScheduleDetails!.push(ClinicScheduleDetailsInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): CreateClinicScheduleInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateClinicScheduleInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicNotes"] = this.clinicNotes;
        data["clinicNotesVisibleToDriver"] = this.clinicNotesVisibleToDriver;
        data["active"] = this.active;
        data["billingNotes"] = this.billingNotes;
        data["addressLine1"] = this.addressLine1;
        data["addressLine2"] = this.addressLine2;
        data["city"] = this.city;
        data["state"] = this.state;
        data["postalCode"] = this.postalCode;
        data["country"] = this.country;
        data["companyName"] = this.companyName;
        data["accountNumber"] = this.accountNumber;
        data["clinicPhoneNumber"] = this.clinicPhoneNumber;
        data["email"] = this.email;
        if (Array.isArray(this.contactSetting)) {
            data["contactSetting"] = [];
            for (let item of this.contactSetting)
                data["contactSetting"].push(item.toJSON());
        }
        if (Array.isArray(this.contactGroup)) {
            data["contactGroup"] = [];
            for (let item of this.contactGroup)
                data["contactGroup"].push(item.toJSON());
        }
        data["mondayClinicNotes"] = this.mondayClinicNotes;
        data["tuesdayClinicNotes"] = this.tuesdayClinicNotes;
        data["wednesdayClinicNotes"] = this.wednesdayClinicNotes;
        data["thursdayClinicNotes"] = this.thursdayClinicNotes;
        data["fridayClinicNotes"] = this.fridayClinicNotes;
        data["saturdayClinicNotes"] = this.saturdayClinicNotes;
        data["sundayClinicNotes"] = this.sundayClinicNotes;
        if (Array.isArray(this.clinicScheduleDetails)) {
            data["clinicScheduleDetails"] = [];
            for (let item of this.clinicScheduleDetails)
                data["clinicScheduleDetails"].push(item.toJSON());
        }
        return data; 
    }
}

export interface ICreateClinicScheduleInput {
    clinicNotes: string | undefined;
    clinicNotesVisibleToDriver: boolean;
    active: boolean;
    billingNotes: string | undefined;
    addressLine1: string;
    addressLine2: string | undefined;
    city: string | undefined;
    state: string | undefined;
    postalCode: string | undefined;
    country: string | undefined;
    companyName: string | undefined;
    accountNumber: string | undefined;
    clinicPhoneNumber: string | undefined;
    email: string | undefined;
    contactSetting: GetContactSettingsItemDto[] | undefined;
    contactGroup: ContactGroupSettingsItemDto[] | undefined;
    mondayClinicNotes: string | undefined;
    tuesdayClinicNotes: string | undefined;
    wednesdayClinicNotes: string | undefined;
    thursdayClinicNotes: string | undefined;
    fridayClinicNotes: string | undefined;
    saturdayClinicNotes: string | undefined;
    sundayClinicNotes: string | undefined;
    clinicScheduleDetails: ClinicScheduleDetailsInput[] | undefined;
}

export class CreateClinicScheduleResultDto implements ICreateClinicScheduleResultDto {
    clinicId!: number;
    clinicPhoneNumber!: string | undefined;
    message!: string | undefined;

    constructor(data?: ICreateClinicScheduleResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
            this.clinicPhoneNumber = data["clinicPhoneNumber"];
            this.message = data["message"];
        }
    }

    static fromJS(data: any): CreateClinicScheduleResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateClinicScheduleResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        data["clinicPhoneNumber"] = this.clinicPhoneNumber;
        data["message"] = this.message;
        return data; 
    }
}

export interface ICreateClinicScheduleResultDto {
    clinicId: number;
    clinicPhoneNumber: string | undefined;
    message: string | undefined;
}

export class CreateCallinInput implements ICreateCallinInput {
    clinicId!: number;
    routeScheduleDetailId!: number;
    etaUtc!: moment.Moment;
    requestorName!: string | undefined;
    specialInstructions!: string | undefined;
    specialInstructionsVisibleToDriver!: boolean;
    pastMidnight!: boolean;

    constructor(data?: ICreateCallinInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
            this.routeScheduleDetailId = data["routeScheduleDetailId"];
            this.etaUtc = data["etaUtc"] ? moment(data["etaUtc"].toString()) : <any>undefined;
            this.requestorName = data["requestorName"];
            this.specialInstructions = data["specialInstructions"];
            this.specialInstructionsVisibleToDriver = data["specialInstructionsVisibleToDriver"];
            this.pastMidnight = data["pastMidnight"];
        }
    }

    static fromJS(data: any): CreateCallinInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateCallinInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        data["routeScheduleDetailId"] = this.routeScheduleDetailId;
        data["etaUtc"] = this.etaUtc ? this.etaUtc.toISOString() : <any>undefined;
        data["requestorName"] = this.requestorName;
        data["specialInstructions"] = this.specialInstructions;
        data["specialInstructionsVisibleToDriver"] = this.specialInstructionsVisibleToDriver;
        data["pastMidnight"] = this.pastMidnight;
        return data; 
    }
}

export interface ICreateCallinInput {
    clinicId: number;
    routeScheduleDetailId: number;
    etaUtc: moment.Moment;
    requestorName: string | undefined;
    specialInstructions: string | undefined;
    specialInstructionsVisibleToDriver: boolean;
    pastMidnight: boolean;
}

export class CreateCallInResultDto implements ICreateCallInResultDto {
    routeId!: number;
    confirmationCode!: string | undefined;

    constructor(data?: ICreateCallInResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeId = data["routeId"];
            this.confirmationCode = data["confirmationCode"];
        }
    }

    static fromJS(data: any): CreateCallInResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateCallInResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeId"] = this.routeId;
        data["confirmationCode"] = this.confirmationCode;
        return data; 
    }
}

export interface ICreateCallInResultDto {
    routeId: number;
    confirmationCode: string | undefined;
}

export class GetModalMissedPickUpResult implements IGetModalMissedPickUpResult {
    email!: string | undefined;
    managerId!: number;
    originalRouteDate!: moment.Moment;
    routeDate!: string | undefined;
    routeCode!: string | undefined;

    constructor(data?: IGetModalMissedPickUpResult) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.email = data["email"];
            this.managerId = data["managerId"];
            this.originalRouteDate = data["originalRouteDate"] ? moment(data["originalRouteDate"].toString()) : <any>undefined;
            this.routeDate = data["routeDate"];
            this.routeCode = data["routeCode"];
        }
    }

    static fromJS(data: any): GetModalMissedPickUpResult {
        data = typeof data === 'object' ? data : {};
        let result = new GetModalMissedPickUpResult();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["email"] = this.email;
        data["managerId"] = this.managerId;
        data["originalRouteDate"] = this.originalRouteDate ? this.originalRouteDate.toISOString() : <any>undefined;
        data["routeDate"] = this.routeDate;
        data["routeCode"] = this.routeCode;
        return data; 
    }
}

export interface IGetModalMissedPickUpResult {
    email: string | undefined;
    managerId: number;
    originalRouteDate: moment.Moment;
    routeDate: string | undefined;
    routeCode: string | undefined;
}

export class CreateOrderIncidentDto implements ICreateOrderIncidentDto {
    orderId!: number | undefined;
    incidentTypeId!: number;
    geocodeId!: number | undefined;
    content!: string | undefined;
    incidentDate!: moment.Moment;
    managerId!: number | undefined;
    email!: string | undefined;
    id!: number | undefined;

    constructor(data?: ICreateOrderIncidentDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.incidentTypeId = data["incidentTypeId"];
            this.geocodeId = data["geocodeId"];
            this.content = data["content"];
            this.incidentDate = data["incidentDate"] ? moment(data["incidentDate"].toString()) : <any>undefined;
            this.managerId = data["managerId"];
            this.email = data["email"];
            this.id = data["id"];
        }
    }

    static fromJS(data: any): CreateOrderIncidentDto {
        data = typeof data === 'object' ? data : {};
        let result = new CreateOrderIncidentDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["incidentTypeId"] = this.incidentTypeId;
        data["geocodeId"] = this.geocodeId;
        data["content"] = this.content;
        data["incidentDate"] = this.incidentDate ? this.incidentDate.toISOString() : <any>undefined;
        data["managerId"] = this.managerId;
        data["email"] = this.email;
        data["id"] = this.id;
        return data; 
    }
}

export interface ICreateOrderIncidentDto {
    orderId: number | undefined;
    incidentTypeId: number;
    geocodeId: number | undefined;
    content: string | undefined;
    incidentDate: moment.Moment;
    managerId: number | undefined;
    email: string | undefined;
    id: number | undefined;
}

export class EmailConfirmationInput implements IEmailConfirmationInput {
    clinicId!: number;
    confirmationCode!: string | undefined;
    email!: string | undefined;
    requestor!: string | undefined;
    routeCode!: string | undefined;
    eta!: string | undefined;
    cutOff!: string | undefined;
    day!: string | undefined;
    location!: string | undefined;
    isCancel!: boolean;
    loadDate!: string | undefined;

    constructor(data?: IEmailConfirmationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
            this.confirmationCode = data["confirmationCode"];
            this.email = data["email"];
            this.requestor = data["requestor"];
            this.routeCode = data["routeCode"];
            this.eta = data["eta"];
            this.cutOff = data["cutOff"];
            this.day = data["day"];
            this.location = data["location"];
            this.isCancel = data["isCancel"];
            this.loadDate = data["loadDate"];
        }
    }

    static fromJS(data: any): EmailConfirmationInput {
        data = typeof data === 'object' ? data : {};
        let result = new EmailConfirmationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        data["confirmationCode"] = this.confirmationCode;
        data["email"] = this.email;
        data["requestor"] = this.requestor;
        data["routeCode"] = this.routeCode;
        data["eta"] = this.eta;
        data["cutOff"] = this.cutOff;
        data["day"] = this.day;
        data["location"] = this.location;
        data["isCancel"] = this.isCancel;
        data["loadDate"] = this.loadDate;
        return data; 
    }
}

export interface IEmailConfirmationInput {
    clinicId: number;
    confirmationCode: string | undefined;
    email: string | undefined;
    requestor: string | undefined;
    routeCode: string | undefined;
    eta: string | undefined;
    cutOff: string | undefined;
    day: string | undefined;
    location: string | undefined;
    isCancel: boolean;
    loadDate: string | undefined;
}

export class GetEmailConfirmationDto implements IGetEmailConfirmationDto {
    emailConfirmationInput!: EmailConfirmationInput[] | undefined;

    constructor(data?: IGetEmailConfirmationDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["emailConfirmationInput"])) {
                this.emailConfirmationInput = [] as any;
                for (let item of data["emailConfirmationInput"])
                    this.emailConfirmationInput!.push(EmailConfirmationInput.fromJS(item));
            }
        }
    }

    static fromJS(data: any): GetEmailConfirmationDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetEmailConfirmationDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.emailConfirmationInput)) {
            data["emailConfirmationInput"] = [];
            for (let item of this.emailConfirmationInput)
                data["emailConfirmationInput"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IGetEmailConfirmationDto {
    emailConfirmationInput: EmailConfirmationInput[] | undefined;
}

export class GoBackDetails implements IGoBackDetails {
    clinicId!: number;
    clinicName!: string | undefined;
    clinicAddress!: string | undefined;
    originalEta!: moment.Moment;
    eta!: string | undefined;
    routeCode!: string | undefined;

    constructor(data?: IGoBackDetails) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.clinicId = data["clinicId"];
            this.clinicName = data["clinicName"];
            this.clinicAddress = data["clinicAddress"];
            this.originalEta = data["originalEta"] ? moment(data["originalEta"].toString()) : <any>undefined;
            this.eta = data["eta"];
            this.routeCode = data["routeCode"];
        }
    }

    static fromJS(data: any): GoBackDetails {
        data = typeof data === 'object' ? data : {};
        let result = new GoBackDetails();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["clinicId"] = this.clinicId;
        data["clinicName"] = this.clinicName;
        data["clinicAddress"] = this.clinicAddress;
        data["originalEta"] = this.originalEta ? this.originalEta.toISOString() : <any>undefined;
        data["eta"] = this.eta;
        data["routeCode"] = this.routeCode;
        return data; 
    }
}

export interface IGoBackDetails {
    clinicId: number;
    clinicName: string | undefined;
    clinicAddress: string | undefined;
    originalEta: moment.Moment;
    eta: string | undefined;
    routeCode: string | undefined;
}

export class CreateGoBackOrder implements ICreateGoBackOrder {
    orderId!: number;
    eta!: moment.Moment;

    constructor(data?: ICreateGoBackOrder) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.orderId = data["orderId"];
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): CreateGoBackOrder {
        data = typeof data === 'object' ? data : {};
        let result = new CreateGoBackOrder();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["orderId"] = this.orderId;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        return data; 
    }
}

export interface ICreateGoBackOrder {
    orderId: number;
    eta: moment.Moment;
}

export class GetIncidentsDto implements IGetIncidentsDto {
    id!: number;
    accountNumber!: string | undefined;
    url!: string | undefined;
    incidentType!: string | undefined;
    createdBy!: string | undefined;
    idNumber!: string | undefined;
    creationTime!: moment.Moment;
    modifiedBy!: string | undefined;
    modifiedTime!: moment.Moment | undefined;

    constructor(data?: IGetIncidentsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.accountNumber = data["accountNumber"];
            this.url = data["url"];
            this.incidentType = data["incidentType"];
            this.createdBy = data["createdBy"];
            this.idNumber = data["idNumber"];
            this.creationTime = data["creationTime"] ? moment(data["creationTime"].toString()) : <any>undefined;
            this.modifiedBy = data["modifiedBy"];
            this.modifiedTime = data["modifiedTime"] ? moment(data["modifiedTime"].toString()) : <any>undefined;
        }
    }

    static fromJS(data: any): GetIncidentsDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetIncidentsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["accountNumber"] = this.accountNumber;
        data["url"] = this.url;
        data["incidentType"] = this.incidentType;
        data["createdBy"] = this.createdBy;
        data["idNumber"] = this.idNumber;
        data["creationTime"] = this.creationTime ? this.creationTime.toISOString() : <any>undefined;
        data["modifiedBy"] = this.modifiedBy;
        data["modifiedTime"] = this.modifiedTime ? this.modifiedTime.toISOString() : <any>undefined;
        return data; 
    }
}

export interface IGetIncidentsDto {
    id: number;
    accountNumber: string | undefined;
    url: string | undefined;
    incidentType: string | undefined;
    createdBy: string | undefined;
    idNumber: string | undefined;
    creationTime: moment.Moment;
    modifiedBy: string | undefined;
    modifiedTime: moment.Moment | undefined;
}

export class GetIncidentsResultsDto implements IGetIncidentsResultsDto {
    incident!: GetIncidentsDto | undefined;

    constructor(data?: IGetIncidentsResultsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.incident = data["incident"] ? GetIncidentsDto.fromJS(data["incident"]) : <any>undefined;
        }
    }

    static fromJS(data: any): GetIncidentsResultsDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetIncidentsResultsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["incident"] = this.incident ? this.incident.toJSON() : <any>undefined;
        return data; 
    }
}

export interface IGetIncidentsResultsDto {
    incident: GetIncidentsDto | undefined;
}

export class PagedResultDtoOfGetIncidentsResultsDto implements IPagedResultDtoOfGetIncidentsResultsDto {
    totalCount!: number;
    items!: GetIncidentsResultsDto[] | undefined;

    constructor(data?: IPagedResultDtoOfGetIncidentsResultsDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.totalCount = data["totalCount"];
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(GetIncidentsResultsDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): PagedResultDtoOfGetIncidentsResultsDto {
        data = typeof data === 'object' ? data : {};
        let result = new PagedResultDtoOfGetIncidentsResultsDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["totalCount"] = this.totalCount;
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IPagedResultDtoOfGetIncidentsResultsDto {
    totalCount: number;
    items: GetIncidentsResultsDto[] | undefined;
}

export class GetClinicInputForWillCall implements IGetClinicInputForWillCall {
    tenantId!: number | undefined;
    tabSearch!: number | undefined;
    maxResultCount!: number;
    skipCount!: number;
    filter!: string | undefined;

    constructor(data?: IGetClinicInputForWillCall) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.tenantId = data["tenantId"];
            this.tabSearch = data["tabSearch"];
            this.maxResultCount = data["maxResultCount"];
            this.skipCount = data["skipCount"];
            this.filter = data["filter"];
        }
    }

    static fromJS(data: any): GetClinicInputForWillCall {
        data = typeof data === 'object' ? data : {};
        let result = new GetClinicInputForWillCall();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["tenantId"] = this.tenantId;
        data["tabSearch"] = this.tabSearch;
        data["maxResultCount"] = this.maxResultCount;
        data["skipCount"] = this.skipCount;
        data["filter"] = this.filter;
        return data; 
    }
}

export interface IGetClinicInputForWillCall {
    tenantId: number | undefined;
    tabSearch: number | undefined;
    maxResultCount: number;
    skipCount: number;
    filter: string | undefined;
}

export class GetAutomaticSchedulesResultDto implements IGetAutomaticSchedulesResultDto {
    id!: number;
    routeCode!: string | undefined;
    location!: string | undefined;
    routeType!: string | undefined;
    day!: string | undefined;
    eta!: moment.Moment;
    date!: string | undefined;
    etaTime!: string | undefined;
    routeTypeSortOrder!: number | undefined;
    loadDate!: string | undefined;

    constructor(data?: IGetAutomaticSchedulesResultDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.routeCode = data["routeCode"];
            this.location = data["location"];
            this.routeType = data["routeType"];
            this.day = data["day"];
            this.eta = data["eta"] ? moment(data["eta"].toString()) : <any>undefined;
            this.date = data["date"];
            this.etaTime = data["etaTime"];
            this.routeTypeSortOrder = data["routeTypeSortOrder"];
            this.loadDate = data["loadDate"];
        }
    }

    static fromJS(data: any): GetAutomaticSchedulesResultDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetAutomaticSchedulesResultDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["routeCode"] = this.routeCode;
        data["location"] = this.location;
        data["routeType"] = this.routeType;
        data["day"] = this.day;
        data["eta"] = this.eta ? this.eta.toISOString() : <any>undefined;
        data["date"] = this.date;
        data["etaTime"] = this.etaTime;
        data["routeTypeSortOrder"] = this.routeTypeSortOrder;
        data["loadDate"] = this.loadDate;
        return data; 
    }
}

export interface IGetAutomaticSchedulesResultDto {
    id: number;
    routeCode: string | undefined;
    location: string | undefined;
    routeType: string | undefined;
    day: string | undefined;
    eta: moment.Moment;
    date: string | undefined;
    etaTime: string | undefined;
    routeTypeSortOrder: number | undefined;
    loadDate: string | undefined;
}

export class GetRouteTemplateZoneForViewDto implements IGetRouteTemplateZoneForViewDto {
    routeTemplateZoneId!: number;
    zoneId!: number;
    zoneName!: string | undefined;

    constructor(data?: IGetRouteTemplateZoneForViewDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.routeTemplateZoneId = data["routeTemplateZoneId"];
            this.zoneId = data["zoneId"];
            this.zoneName = data["zoneName"];
        }
    }

    static fromJS(data: any): GetRouteTemplateZoneForViewDto {
        data = typeof data === 'object' ? data : {};
        let result = new GetRouteTemplateZoneForViewDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["routeTemplateZoneId"] = this.routeTemplateZoneId;
        data["zoneId"] = this.zoneId;
        data["zoneName"] = this.zoneName;
        return data; 
    }
}

export interface IGetRouteTemplateZoneForViewDto {
    routeTemplateZoneId: number;
    zoneId: number;
    zoneName: string | undefined;
}

export class GetAllZoneInput implements IGetAllZoneInput {
    filter!: string | undefined;
    locationFilterId!: number;
    sorting!: string | undefined;
    skipCount!: number;
    maxResultCount!: number;

    constructor(data?: IGetAllZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.filter = data["filter"];
            this.locationFilterId = data["locationFilterId"];
            this.sorting = data["sorting"];
            this.skipCount = data["skipCount"];
            this.maxResultCount = data["maxResultCount"];
        }
    }

    static fromJS(data: any): GetAllZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new GetAllZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["filter"] = this.filter;
        data["locationFilterId"] = this.locationFilterId;
        data["sorting"] = this.sorting;
        data["skipCount"] = this.skipCount;
        data["maxResultCount"] = this.maxResultCount;
        return data; 
    }
}

export interface IGetAllZoneInput {
    filter: string | undefined;
    locationFilterId: number;
    sorting: string | undefined;
    skipCount: number;
    maxResultCount: number;
}

export class ListResultDtoOfZoneListDto implements IListResultDtoOfZoneListDto {
    items!: ZoneListDto[] | undefined;

    constructor(data?: IListResultDtoOfZoneListDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ZoneListDto.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfZoneListDto {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfZoneListDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfZoneListDto {
    items: ZoneListDto[] | undefined;
}

export class CreateZoneLocationInput implements ICreateZoneLocationInput {
    zoneId!: number;
    zoneName!: string | undefined;
    locationId!: number;
    isPrimary!: boolean;

    constructor(data?: ICreateZoneLocationInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.zoneId = data["zoneId"];
            this.zoneName = data["zoneName"];
            this.locationId = data["locationId"];
            this.isPrimary = data["isPrimary"];
        }
    }

    static fromJS(data: any): CreateZoneLocationInput {
        data = typeof data === 'object' ? data : {};
        let result = new CreateZoneLocationInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["zoneId"] = this.zoneId;
        data["zoneName"] = this.zoneName;
        data["locationId"] = this.locationId;
        data["isPrimary"] = this.isPrimary;
        return data; 
    }
}

export interface ICreateZoneLocationInput {
    zoneId: number;
    zoneName: string | undefined;
    locationId: number;
    isPrimary: boolean;
}

export class UpdateZoneInput implements IUpdateZoneInput {
    id!: number;
    name!: string;
    isPrimary!: boolean;

    constructor(data?: IUpdateZoneInput) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.id = data["id"];
            this.name = data["name"];
            this.isPrimary = data["isPrimary"];
        }
    }

    static fromJS(data: any): UpdateZoneInput {
        data = typeof data === 'object' ? data : {};
        let result = new UpdateZoneInput();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["id"] = this.id;
        data["name"] = this.name;
        data["isPrimary"] = this.isPrimary;
        return data; 
    }
}

export interface IUpdateZoneInput {
    id: number;
    name: string;
    isPrimary: boolean;
}

export class ZoneLocationZoneList implements IZoneLocationZoneList {
    locationId!: number;
    zoneName!: string | undefined;
    zoneId!: number;

    constructor(data?: IZoneLocationZoneList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.locationId = data["locationId"];
            this.zoneName = data["zoneName"];
            this.zoneId = data["zoneId"];
        }
    }

    static fromJS(data: any): ZoneLocationZoneList {
        data = typeof data === 'object' ? data : {};
        let result = new ZoneLocationZoneList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["locationId"] = this.locationId;
        data["zoneName"] = this.zoneName;
        data["zoneId"] = this.zoneId;
        return data; 
    }
}

export interface IZoneLocationZoneList {
    locationId: number;
    zoneName: string | undefined;
    zoneId: number;
}

export class ListResultDtoOfZoneLocationZoneList implements IListResultDtoOfZoneLocationZoneList {
    items!: ZoneLocationZoneList[] | undefined;

    constructor(data?: IListResultDtoOfZoneLocationZoneList) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (Array.isArray(data["items"])) {
                this.items = [] as any;
                for (let item of data["items"])
                    this.items!.push(ZoneLocationZoneList.fromJS(item));
            }
        }
    }

    static fromJS(data: any): ListResultDtoOfZoneLocationZoneList {
        data = typeof data === 'object' ? data : {};
        let result = new ListResultDtoOfZoneLocationZoneList();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (Array.isArray(this.items)) {
            data["items"] = [];
            for (let item of this.items)
                data["items"].push(item.toJSON());
        }
        return data; 
    }
}

export interface IListResultDtoOfZoneLocationZoneList {
    items: ZoneLocationZoneList[] | undefined;
}

export class ZoneLocationImportDto implements IZoneLocationImportDto {
    zoneId!: number;
    zoneName!: string | undefined;
    locationId!: number;
    isPrimary!: boolean;
    postalCode!: string | undefined;
    /** Can be set when reading data from excel or when importing user */
    exception!: string | undefined;

    constructor(data?: IZoneLocationImportDto) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            this.zoneId = data["zoneId"];
            this.zoneName = data["zoneName"];
            this.locationId = data["locationId"];
            this.isPrimary = data["isPrimary"];
            this.postalCode = data["postalCode"];
            this.exception = data["exception"];
        }
    }

    static fromJS(data: any): ZoneLocationImportDto {
        data = typeof data === 'object' ? data : {};
        let result = new ZoneLocationImportDto();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        data["zoneId"] = this.zoneId;
        data["zoneName"] = this.zoneName;
        data["locationId"] = this.locationId;
        data["isPrimary"] = this.isPrimary;
        data["postalCode"] = this.postalCode;
        data["exception"] = this.exception;
        return data; 
    }
}

export interface IZoneLocationImportDto {
    zoneId: number;
    zoneName: string | undefined;
    locationId: number;
    isPrimary: boolean;
    postalCode: string | undefined;
    /** Can be set when reading data from excel or when importing user */
    exception: string | undefined;
}

export class AdditionalData implements IAdditionalData {
    paypal!: { [key: string]: string; };
    stripe!: { [key: string]: string; };

    constructor(data?: IAdditionalData) {
        if (data) {
            for (var property in data) {
                if (data.hasOwnProperty(property))
                    (<any>this)[property] = (<any>data)[property];
            }
        }
    }

    init(data?: any) {
        if (data) {
            if (data["Paypal"]) {
                this.paypal = {} as any;
                for (let key in data["Paypal"]) {
                    if (data["Paypal"].hasOwnProperty(key))
                        this.paypal![key] = data["Paypal"][key];
                }
            }
            if (data["Stripe"]) {
                this.stripe = {} as any;
                for (let key in data["Stripe"]) {
                    if (data["Stripe"].hasOwnProperty(key))
                        this.stripe![key] = data["Stripe"][key];
                }
            }
        }
    }

    static fromJS(data: any): AdditionalData {
        data = typeof data === 'object' ? data : {};
        let result = new AdditionalData();
        result.init(data);
        return result;
    }

    toJSON(data?: any) {
        data = typeof data === 'object' ? data : {};
        if (this.paypal) {
            data["Paypal"] = {};
            for (let key in this.paypal) {
                if (this.paypal.hasOwnProperty(key))
                    data["Paypal"][key] = this.paypal[key];
            }
        }
        if (this.stripe) {
            data["Stripe"] = {};
            for (let key in this.stripe) {
                if (this.stripe.hasOwnProperty(key))
                    data["Stripe"][key] = this.stripe[key];
            }
        }
        return data; 
    }
}

export interface IAdditionalData {
    paypal: { [key: string]: string; };
    stripe: { [key: string]: string; };
}

export class ApiException extends Error {
    message: string;
    status: number; 
    response: string; 
    headers: { [key: string]: any; };
    result: any; 

    constructor(message: string, status: number, response: string, headers: { [key: string]: any; }, result: any) {
        super();

        this.message = message;
        this.status = status;
        this.response = response;
        this.headers = headers;
        this.result = result;
    }

    protected isApiException = true;

    static isApiException(obj: any): obj is ApiException {
        return obj.isApiException === true;
    }
}

function throwException(message: string, status: number, response: string, headers: { [key: string]: any; }, result?: any): Observable<any> {
    if (result !== null && result !== undefined)
        return _observableThrow(result);
    else
        return _observableThrow(new ApiException(message, status, response, headers, null));
}

function blobToText(blob: any): Observable<string> {
    return new Observable<string>((observer: any) => {
        if (!blob) {
            observer.next("");
            observer.complete();
        } else {
            let reader = new FileReader(); 
            reader.onload = event => { 
                observer.next((<any>event.target).result);
                observer.complete();
            };
            reader.readAsText(blob); 
        }
    });
}